# CDFTOOLS
  CDFTOOLS is a diagnostic package written in fortran 90 for the analysis of NEMO model output, initialized in  the frame of the DRAKKAR project (<https://www.drakkar-ocean.eu/>). It is now available on GitHub under the CeCILL license (<http://www.cecill.info/licences/Licence_CeCILL_V2-en.html>).

  CDFTOOLS is an open source package and contributions from other group are welcomed. The Git workflow policy is still to be defined.

## Using CDFTOOLS

#### Cloning the git repository
To retrieve a copy of the CDFTOOLS source code and create a working directory, run the following on the command line: 

```> git clone https://github.com/meom-group/CDFTOOLS ```

#### Compiling CDFTOOLS
All the fortran source are in src/ subdirectory. In src/ there is a Makefile for compiling the sources. The compiler/machines related definitions are supposed to be collected in a `make.macro` file. Some examples of `make.macro` are given in the Macrolib directory and can be used as template for a new compiler or new machine. Then the good practice is to make a link 

```> cd src/```

```> ln -sf ../Macrolib/macro.MACHINE  make.macro```

In the `make.macro` file, the PATH for the netcdf library is specified, as well as compiler name and used flags.  In order to activate netcdf4/HDF5 chunking and deflation ( available in some cdftools), you need to set: 

```NC4=-Dkey_netcdf4 ```

in the make.macro file, otherwise set

```NC4= ```

If you need to use CMIP6 naming convention for input files, you must set the CPP key key_CMIP6 in the `make.macro` file :

```CMIP6 = -Dkey_CMIP6```

Then using `make` (or even `make -j n` if you can compile on n cores), you will have the cdftools programs executable available in the bin/ sub directory. The executable files are ignore by git.


#### Running CDFTOOLS
CDFTOOLS is a collection of programs. Every single program performs one or many computation(s) using a set of input files and output the results as a netcdf file, and eventually also gives some results on the standard output. 

CDFTOOLS coding rules imply that a `usage message` is displayed when just running the tool without any arguments ( or with -h ). At the moment it is the only up to date documentation. 

As CDFTOOLS is a collection of programs, a full diagnostic of model output can be performed writing a script using a sequence of tools. This is done for example in the Drakkar Monitoring Tools (DMONTOOLS, soon available on GitHub!).

## Coding CDFTOOLS
#### Coding rules
##### Syntax
The coding rules are the NEMO coding rules, strictly followed. The idea is that people familiar with NEMO are familiar with CDFTOOLS. In DEV_TOOLS/ some template fortran line are available for program, modules, routine or function headers. Also a template for the `usage message`.
##### Run time behaviour
Any `cdftool`, run without argument or with option -h, should display a short documentation (`usage message`), similar to a unix man page, describing the purpose of the tool, the syntax (arguments,  options, etc...) and giving details on the output files. For some tools, mesh or/and mask files are required to be present in the working directory, with respective name `mesh_hgr.nc`, `mesh_zgr.nc` or `mask.nc` (links are OK). The usage message should indicate the required files.

Example:


```>    cdfcurl```

       usage : cdfcurl -u U-file U-var -v V-file V-var -l levlist [-T] [-8]...
            ... [-surf] [-overf] [-nc4] [-o OUT-file ]
       
      PURPOSE :
        Compute the curl of a vector field, at a specified level.
        If level is specified as 0, assume that the input files are
        forcing files, presumably on A-grid. In this latter case, the
        vector field is interpolated on the C-grid. In any case, the
        curl is computed on the F-point (unless -T option is used).
       
      ARGUMENTS :
        -u U-file U-var : file and variable name for zonal component
        -v V-file V-var : file and variable name for meridional component
        -l levlist    : levels to be processed. If set to 0, assume forcing file
                 in input. Example of recognized syntax :
                   -l "1,10,30"  or -l "1-20" or even -l "1-3,10-20,30-"
                   -l  1 . Note that -l "3-" set a levlist from 3 to the bottom
                   
      OPTIONS :
        -T : compute curl at T point instead of default F-point
        -8 : save in double precision instead of standard simple precision.
        -surf : work with single level C-grid (not forcing)
        -overf : store the ratio curl/f where f is the coriolis parameter
        -nc4 : use netcdf4 output with chunking and deflation 1
        -o OUT-file : specify output file name instead of curl.nc
       
      REQUIRED FILES :
         mesh_hgr.nc
       
      OUTPUT : 
        netcdf file : curl.nc
          variables : socurl or socurlt (if -T option), units : s^-1
             or socurloverf, no units (if -overf option)

##### Improving/modifying existing tool
 It is possible to improve (of course !) or modify any tools, but <u>one important law to respect</u> is that the modified tool should still be able to be used with previous syntax, in order to avoid breaking of existing scripts using CDFTOOLS. If for some reason, this is not possible, then a discussion must be done to reach to a common decision. Eventually, some old options must be documented as osbolete in the usage message, which means that they may be removed from a future release. 

PROGRAM cdfspeed
  !!======================================================================
  !!                     ***  PROGRAM  cdfspeed  ***
  !!=====================================================================
  !!  ** Purpose : combine u and v to obtains the wind speed
  !!
  !!  ** Method  : speed=sqrt(u**2 + v**2)
  !!
  !! History : 2.1  : 11/2007  : P. Mathiot   : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                            :: ji, jj, jk, jt, jlev ! dummy loop index
  INTEGER(KIND=4)                            :: narg, iargc, ijarg   ! command line 
  INTEGER(KIND=4)                            :: ncout, ierr          ! output file stuff
  INTEGER(KIND=4)                            :: npiglo, npjglo       ! size of the domain
  INTEGER(KIND=4)                            :: npk, npt, nlev       ! size of the domain
  INTEGER(KIND=4)                            :: nvpk                 ! vertical levels in working variable
  INTEGER(KIND=4)                            :: ik                   ! level counter
  INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE :: nklevel              ! requested levels
  INTEGER(KIND=4), DIMENSION(1)              :: ipk, id_varout       ! output variable vertical level, varid

  REAL(KIND=4), DIMENSION(:),    ALLOCATABLE :: tim                  ! time counter array
  REAL(KIND=4), DIMENSION(:),    ALLOCATABLE :: gdept, gdeptall      ! deptht values for requested/all levels
  REAL(KIND=4), DIMENSION(:,:),  ALLOCATABLE :: zu, zv, zspeed       ! working arrays, speed

  CHARACTER(LEN=256)                         :: cf_vfil, cf_ufil     ! file for u and v components
  CHARACTER(LEN=256)                         :: cf_tfil='none'       ! file for T point position
  CHARACTER(LEN=256)                         :: cv_u, cv_v           ! name of u and v variable
  CHARACTER(LEN=256)                         :: cf_out='speed.nc'    ! output file name
  CHARACTER(LEN=256)                         :: cldum                ! dummy char variable

  TYPE (variable), DIMENSION(1)              :: stypvar              ! structure for attibutes

  LOGICAL                                    :: lforcing             ! forcing flag
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfspeed  U-file V-file U-var V-var [-t T-file] ...'
     PRINT *,'                  ... [-lev level_list]' 
     PRINT *,'    PURPOSE :'
     PRINT *,'       Computes the speed of ocean currents or wind speed'
     PRINT *,'       '
     PRINT *,'       If the input files are 3D, the input is assumed to be '
     PRINT *,'       a model output on native C-grid. Speed is computed on the A-grid.'
     PRINT *,'       '
     PRINT *,'       If the input file is 2D and then we assume that this is '
     PRINT *,'       a forcing file already on the A-grid.'
     PRINT *,'    '
     PRINT *,'    ARGUMENTS :'
     PRINT *,'       U-file : netcdf file for U component'
     PRINT *,'       V-file : netcdf file for V component'
     PRINT *,'       U-var  : netcdf variable name for U component'
     PRINT *,'       V-var  : netcdf variable name for V component'
     PRINT *,'    '
     PRINT *,'    OPTIONS :'
     PRINT *,'       [-t T-file ] : indicate any file on gridT for correct header'
     PRINT *,'                 of the output file (usefull for 3D files)'
     PRINT *,'       [-lev level_list ] : indicate a list of levels to be processed'
     PRINT *,'                 If not used, all levels are processed.'
     PRINT *,'                 This option should be the last on the command line'
     PRINT *,'    '
     PRINT *,'    OUTPUT :'
     PRINT *,'       Output on ',TRIM(cf_out),'  variable U '
     STOP
  ENDIF

  nlev =0
  ijarg=1
  DO WHILE ( ijarg <= narg ) 
     CALL getarg(ijarg, cldum ) ; ijarg = ijarg + 1
     SELECT CASE ( cldum )
     CASE ( '-lev' ) 
       nlev = narg -ijarg + 1
       ALLOCATE ( nklevel(nlev) )
       DO jlev = 1, nlev 
          CALL getarg(ijarg, cldum ) ; ijarg = ijarg + 1 ; READ( cldum,*) nklevel(jlev)
       END DO
     CASE ( '-t' ) 
       CALL getarg(ijarg, cf_tfil ) ; ijarg = ijarg + 1
       IF ( chkfile (cf_tfil) ) STOP ! missing file
     CASE DEFAULT
       cf_ufil = cldum
       CALL getarg(ijarg, cf_vfil ) ; ijarg = ijarg + 1
       IF ( chkfile(cf_ufil) .OR. chkfile(cf_vfil) ) STOP ! missing file
       CALL getarg(ijarg, cv_u ) ; ijarg = ijarg + 1
       CALL getarg(ijarg, cv_v ) ; ijarg = ijarg + 1
     END SELECT 
  ENDDO

  npiglo = getdim (cf_vfil,cn_x)
  npjglo = getdim (cf_vfil,cn_y)
  npk    = getdim (cf_vfil,cn_z)
  nvpk   = getvdim(cf_vfil,cv_v)
  npt    = getdim (cf_vfil,cn_t)

  IF ( (npk == 0) ) THEN
     lforcing=.TRUE.
     npk=1
     PRINT *, 'W A R N I N G : you used a forcing field'
  ELSE
     lforcing=.FALSE.
     IF ( TRIM(cf_tfil) == 'none' ) THEN
       PRINT *,'  ERROR: you must specify a griT file as fifth argument '
       PRINT *,'     This is for the proper header of output file '
       STOP
     ENDIF
  END IF

  IF ( nlev == 0 ) THEN 
    nlev = npk 
    ALLOCATE ( nklevel(nlev) )
    DO jlev =1, nlev
      nklevel(jlev) = jlev
    ENDDO
  ENDIF

  IF (nvpk == 2 ) nvpk = 1
  IF (nvpk == 3 ) nvpk = nlev

  PRINT *, 'npiglo =', npiglo
  PRINT *, 'npjglo =', npjglo
  PRINT *, 'npk    =', npk
  PRINT *, 'nvpk   =', nvpk
  PRINT *, 'nlev   =', nlev
  PRINT *, 'npt    =', npt

  IF ( nlev >  nvpk ) THEN
     PRINT *, 'W A R N I N G : nlev larger than nvpk, we assume nlev=nvpk'
     nlev = nvpk
  END IF

  ! define new variables for output
  stypvar(1)%cname             = 'U'
  stypvar(1)%cunits            = 'm.s-1'
  stypvar(1)%rmissing_value    = 0.
  stypvar(1)%valid_min         = -1000.
  stypvar(1)%valid_max         = 1000.
  stypvar(1)%clong_name        = 'Current or wind speed'
  stypvar(1)%cshort_name       = 'U'
  stypvar(1)%conline_operation = 'N/A'
  stypvar(1)%caxis             = 'TZYX'

  ! create output fileset
  IF (lforcing ) THEN
     ipk(1) = 1 !  2D  no dep variable
     ncout  = create      (cf_out, cf_vfil, npiglo, npjglo, 0         )
     ierr   = createvar   (ncout,  stypvar, 1,      ipk,    id_varout )
     ierr   = putheadervar(ncout,  cf_vfil, npiglo, npjglo, 0         )
     nlev=1 ; nklevel(nlev) = 1
  ELSE
     ALLOCATE ( gdept(nlev), gdeptall(npk) )
     gdeptall = getvar1d ( cf_tfil, cn_vdeptht, npk )
     DO jlev = 1, nlev
       gdept(jlev) = gdeptall( nklevel(jlev) )
     END DO
     ipk(1) = nlev
     ncout  = create      (cf_out, cf_tfil, npiglo, npjglo, nlev              )
     ierr   = createvar   (ncout,  stypvar, 1,      ipk,    id_varout         )
     ierr   = putheadervar(ncout,  cf_tfil, npiglo, npjglo, nlev,  pdep=gdept )
  END IF

  ! Allocate arrays
  ALLOCATE ( zv(npiglo,npjglo), zu(npiglo,npjglo), zspeed(npiglo,npjglo), tim(npt))

  DO jt=1,npt
     tim(jt)=jt
  END DO

  ierr=putvar1d(ncout, tim, npt, 'T')

  DO jt = 1,npt
     DO jlev = 1, nlev
           ik = nklevel(jlev)
        ! Get velocities v at jk
           zu(:,:) = getvar(cf_ufil, cv_u, ik, npiglo, npjglo, ktime=jt)
           zv(:,:) = getvar(cf_vfil, cv_v, ik, npiglo, npjglo, ktime=jt)
        IF ( lforcing ) THEN
           ! u and v are already on the T grid points
        ELSE
           ! in this case we are on the C-grid and the speed must be computed 
           ! on the A-grid. We use reverse loop in order to use only one array
           DO ji=npiglo,2,-1
             DO jj=1,npjglo
               zu(ji,jj) = 0.5*(zu(ji-1,jj)+zu(ji,jj))
             ENDDO
           ENDDO

           DO ji=1,npiglo 
             DO jj=npjglo,2 -1
               zv(ji,jj) = 0.5*(zv(ji,jj-1)+zv(ji,jj))
             ENDDO
           ENDDO
        END IF
        zspeed    = SQRT(zv*zv+zu*zu)
        ierr = putvar(ncout, id_varout(1), zspeed, jlev ,npiglo, npjglo, ktime=jt)
     END DO
  END DO
  ierr = closeout(ncout)

END PROGRAM cdfspeed

MODULE cdftools
  !!======================================================================
  !!                     ***  MODULE  cdftools  ***
  !! This module holds subroutine that corresponds to cdftools.
  !! For example cdf_findij is the subroutine equivalent to cdffindij 
  !!=====================================================================
  !! History : 2.1  !  05/2010  : J.M. Molines, A. Melet : Original
  !!           3.0  !  12/2010  : J.M. Molines : Doctor + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  !!   routines      : description
  !!   cdf_findij    : the routine version of cdffindij
  !!   NearestPoint : determine the nearest point from a lon lat location
  !!   dist          : compute the distance along othodromic route
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames

  IMPLICIT NONE

  PRIVATE     
  ! list of public subroutines that can be called
  PUBLIC  :: cdf_findij 
  PUBLIC  :: broken_line
  PUBLIC  :: dist

  PRIVATE :: NearestPoint
  PRIVATE :: interm_pt

  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class system
  !!----------------------------------------------------------------------

CONTAINS

  SUBROUTINE cdf_findij ( pxmin, pxmax, pymin, pymax,                        &
       &         kimin, kimax, kjmin, kjmax, cd_coord, cd_point, cd_verbose ,&
       &         plonmin, plonmax, platmin, platmax )
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE cdf_findij  ***
    !!
    !! ** Purpose :  the routine equivalent of cdffindij 
    !!
    !!----------------------------------------------------------------------
    REAL(KIND=4),                  INTENT(in) :: pxmin, pxmax, pymin, pymax !: geographical window in lon-lat
    INTEGER(KIND=4),              INTENT(out) :: kimin, kimax, kjmin, kjmax !: equivalent in model coordinates
    CHARACTER(*), OPTIONAL,        INTENT(in) :: cd_coord                   !: coordinate file name (D: cn_fcoo)
    CHARACTER(*), OPTIONAL,        INTENT(in) :: cd_point                   !: point type           (D: F )
    CHARACTER(*), OPTIONAL,        INTENT(in) :: cd_verbose                 !: verbose flag         (D: N ) Y
    REAL(KIND=4), OPTIONAL,       INTENT(out) :: plonmin, plonmax           !: model lonmn, lonmax
    REAL(KIND=4), OPTIONAL,       INTENT(out) :: platmin, platmax           !: model  latmin, latmax

    INTEGER(KIND=4)                           :: initer
    INTEGER(KIND=4)                           :: imin, imax, jmin, jmax
    INTEGER(KIND=4), SAVE                     :: iloc, jloc
    INTEGER(KIND=4), SAVE                     :: ipiglo, ipjglo
    INTEGER(KIND=4), PARAMETER                :: jp_itermax=15

    REAL(KIND=8)                              :: dl_xmin, dl_xmax, dl_ymin, dl_ymax
    REAL(KIND=8)                              :: dl_dis
    REAL(KIND=8)                              :: dl_glam0, dl_emax
    REAL(KIND=8), SAVE, DIMENSION(:,:), ALLOCATABLE :: dl_glam, dl_gphi, dl_e1, dl_e2

    REAL(KIND=4)                              :: zglamfound, zglamin, zglamax, zgphmin, zgphmax

    CHARACTER(LEN=256)                        :: cl_type='F'
    CHARACTER(LEN=256)                        :: clcoo

    LOGICAL                                   :: ll_again, ll_bnd, ll_verbose=.FALSE.
    !!--------------------------------------------------------------------------
    CALL ReadCdfNames()
    imin = 0 ; jmin = 0

    dl_xmin = pxmin
    dl_xmax = pxmax
    dl_ymin = pymin
    dl_ymax = pymax

    clcoo = cn_fhgr

    IF ( PRESENT( cd_coord)  ) clcoo  = cd_coord
    IF ( PRESENT( cd_point)  ) cl_type= cd_point
    IF ( PRESENT( cd_verbose))   THEN
       IF ( cd_verbose(1:1) == 'Y' .OR. cd_verbose(1:1) == 'y' ) ll_verbose=.TRUE.
    ENDIF

    IF ( .NOT. ALLOCATED (dl_glam) ) THEN 

       IF (chkfile (clcoo) ) STOP 96 ! missing file

       ipiglo= getdim (clcoo, cn_x)
       ipjglo= getdim (clcoo, cn_y)

       ALLOCATE (dl_glam(ipiglo,ipjglo), dl_gphi(ipiglo,ipjglo) )
       ALLOCATE (dl_e1  (ipiglo,ipjglo), dl_e2  (ipiglo,ipjglo) )

       SELECT CASE ( cl_type )
       CASE ('T' , 't' )
          dl_glam(:,:) = getvar(clcoo, cn_glamt, 1, ipiglo, ipjglo)
          dl_gphi(:,:) = getvar(clcoo, cn_gphit, 1, ipiglo, ipjglo)
          dl_e1  (:,:) = getvar(clcoo, cn_ve1t,  1, ipiglo, ipjglo)
          dl_e2  (:,:) = getvar(clcoo, cn_ve2t,  1, ipiglo, ipjglo)
       CASE ('U','u' )
          dl_glam(:,:) = getvar(clcoo, cn_glamu, 1, ipiglo, ipjglo)
          dl_gphi(:,:) = getvar(clcoo, cn_gphiu, 1, ipiglo, ipjglo)
          dl_e1  (:,:) = getvar(clcoo, cn_ve1u,  1, ipiglo, ipjglo)
          dl_e2  (:,:) = getvar(clcoo, cn_ve2u,  1, ipiglo, ipjglo)
       CASE ('V','v' )
          dl_glam(:,:) = getvar(clcoo, cn_glamv, 1, ipiglo, ipjglo)
          dl_gphi(:,:) = getvar(clcoo, cn_gphiv, 1, ipiglo, ipjglo)
          dl_e1  (:,:) = getvar(clcoo, cn_ve1v,  1, ipiglo, ipjglo)
          dl_e2  (:,:) = getvar(clcoo, cn_ve2v,  1, ipiglo, ipjglo)
       CASE ('F','f' )
          dl_glam(:,:) = getvar(clcoo, cn_glamf, 1, ipiglo, ipjglo)
          dl_gphi(:,:) = getvar(clcoo, cn_gphif, 1, ipiglo, ipjglo)
          dl_e1  (:,:) = getvar(clcoo, cn_ve1f,  1, ipiglo, ipjglo)
          dl_e2  (:,:) = getvar(clcoo, cn_ve2f,  1, ipiglo, ipjglo)
       CASE DEFAULT
          PRINT *,' ERROR : type of point not known: ', TRIM(cl_type)
       END SELECT

       ! work with longitude between 0 and 360 to avoid  the date line.
       WHERE( dl_glam < 0 ) dl_glam = dl_glam + 360.d0

       ! For Orca grid, the longitude of ji=1 is about 70 E
       dl_glam0 = dl_glam(1, ipjglo/2)
       WHERE( dl_glam < dl_glam0 ) dl_glam =dl_glam + 360.d0

       IF (dl_xmin < 0.) dl_xmin = dl_xmin + 360.d0
       IF (dl_xmax < 0.) dl_xmax = dl_xmax + 360.d0

       IF (dl_xmin < dl_glam0) dl_xmin = dl_xmin + 360.d0
       IF (dl_xmax < dl_glam0) dl_xmax = dl_xmax + 360.d0
    ENDIF  ! 


    ! deal with xmin, ymin
    ll_again = .TRUE.
    initer = 1
    iloc=ipiglo/2 ; jloc=ipjglo/2

    DO WHILE (ll_again)
       CALL NearestPoint(dl_xmin, dl_ymin, ipiglo, ipjglo, dl_glam, dl_gphi, iloc, jloc, ll_bnd)

       ! distance between the target point and the nearest point
       dl_dis = dist(dl_xmin, dl_glam(iloc,jloc), dl_ymin, dl_gphi(iloc,jloc) ) ! in km

       ! typical grid size (diagonal) in the vicinity of nearest point
       dl_emax= MAX(dl_e1(iloc,jloc), dl_e2(iloc,jloc))/1000.*SQRT(2.) ! in km

       IF (dl_dis  > dl_emax ) THEN
          zglamfound = dl_glam(iloc,jloc) ; IF (zglamfound > 180.)  zglamfound=zglamfound - 360.

          !         PRINT 9000, 'Long= ',zglamfound,' Lat = ',dl_gphi(iloc,jloc) , iloc, jloc 
          !         PRINT *,' Algorithm does''nt converge ', dl_dis

          IF ( initer >= jp_itermax ) THEN
             !            PRINT *, ' no convergence after ', jp_itermax,' iterations'
             iloc     = -1000
             jloc     = -1000
             ll_again = .FALSE.
          ELSE
             ll_again = .TRUE.
             initer   = initer +1
             jloc     = (initer -1)* ipjglo/initer
             iloc     = (initer -1)* ipiglo/jp_itermax
          ENDIF
       ELSE
          IF ( ll_verbose ) THEN
             PRINT '("#  dl_dis= ",f8.3," km")', dl_dis
          ENDIF
          ll_again = .FALSE.
       END IF
    END DO

    IF (ll_bnd ) THEN
       IF (ll_verbose) WRITE (*,*)'Point  Out of domain or on boundary'
    ELSE
       imin=iloc
       jmin=jloc
    ENDIF

    ! deal with xmax, ymax
    IF (  pxmin == pxmax .AND. pymin == pymax ) THEN
       ! job already done with first point
       imax=imin
       jmax=jmin
    ELSE
       ll_again = .TRUE.
       initer = 1
       iloc=ipiglo/2 ; jloc=ipjglo/2

       DO WHILE (ll_again)
          CALL NearestPoint(dl_xmax, dl_ymax, ipiglo, ipjglo, dl_glam, dl_gphi, iloc, jloc, ll_bnd)

          ! distance between the target point and the nearest point
          dl_dis = dist(dl_xmax, dl_glam(iloc,jloc), dl_ymax, dl_gphi(iloc,jloc) ) ! in km

          ! typical grid size (diagonal) in the vicinity of nearest point
          dl_emax = MAX(dl_e1(iloc,jloc),dl_e2(iloc,jloc))/1000.*SQRT(2.) ! in km

          IF (dl_dis >  dl_emax ) THEN
             zglamfound=dl_glam(iloc,jloc) ; IF (zglamfound > 180.)  zglamfound=zglamfound -360.

             !            PRINT 9000, 'Long= ',zglamfound,' Lat = ',dl_gphi(iloc,jloc), iloc, jloc
             !            PRINT *,' Algorithm does''nt converge ', dl_dis

             IF ( initer >= jp_itermax ) THEN
                !               PRINT *, ' no convergence after ', jp_itermax,' iterations'
                iloc     = -1000
                jloc     = -1000
                ll_again = .FALSE.
             ELSE
                ll_again = .TRUE.
                initer   = initer +1
                jloc     = (initer -1)* ipjglo/initer
                iloc     = (initer -1)* ipiglo/jp_itermax
             ENDIF
          ELSE
             IF ( ll_verbose ) THEN
                PRINT '("#  dl_dis= ",f8.3," km")', dl_dis
             ENDIF
             ll_again = .FALSE.
          END IF
       END DO
       IF (ll_bnd ) THEN
          IF (ll_verbose) WRITE (*,*) 'Point  Out of domain or on boundary'
       ELSE
          imax=iloc
          jmax=jloc
       ENDIF
    ENDIF

    IF (ll_verbose) PRINT 9001, imin, imax, jmin, jmax

    kimin   = imin ; kimax = imax ; kjmin   = jmin ; kjmax = jmax
    IF ( ll_bnd .OR. imin < 0 ) THEN
       zglamin= -9999. ; zglamax = -9999
       zgphmin= -9999. ; zgphmax = -9999
    ELSE
       zglamin = dl_glam(imin,jmin)  ; zglamax = dl_glam(imax,jmax)
       zgphmin = dl_gphi(imin,jmin)  ; zgphmax = dl_gphi(imax,jmax)
    ENDIF

    IF ( zglamin > 180 ) zglamin=zglamin-360.
    IF ( zglamax > 180 ) zglamax=zglamax-360.

    IF ( ll_verbose) PRINT 9002, zglamin, zglamax, zgphmin, zgphmax

    IF ( PRESENT (plonmin) ) plonmin=zglamin
    IF ( PRESENT (plonmax) ) plonmax=zglamax
    IF ( PRESENT (platmin) ) platmin=zgphmin
    IF ( PRESENT (platmax) ) platmax=zgphmax

9000 FORMAT(a,f8.2,a,f8.2,2i5)
9001 FORMAT(4i10)
9002 FORMAT(4f10.4)

  END SUBROUTINE cdf_findij

  SUBROUTINE  broken_line( kimin, kimax, kjmin, kjmax, & 
       &                     pxx, pyy, knn , kpi, kpj, knormu, knormv)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE broken_line  ***
    !!
    !! ** Purpose :  determine the broken line between 2 points 
    !!
    !! ** Method  :  Compute the equation of the strait line joining
    !!               the 2 points, on the model I,J domain. Compute
    !!               both y(x) and x(y) and work with the minimum sloping
    !!               line. 
    !!
    !!----------------------------------------------------------------------
    INTEGER(KIND=4),            INTENT(in ) :: kimin, kimax, kjmin, kjmax
    INTEGER(KIND=4),            INTENT(out) :: knn
    INTEGER(KIND=4),            INTENT(in ) :: kpi, kpj
    INTEGER(KIND=4), OPTIONAL,  INTENT(out) :: knormu, knormv
    REAL(KIND=4), DIMENSION(kpi+kpj), INTENT(out) :: pxx, pyy

    INTEGER(KIND=4) :: ji, jj, jk   ! dummy loop index
    INTEGER(KIND=4) :: ii0, ij0, ii1, ij1, iitmp, ijtmp
    INTEGER(KIND=4) :: iist, ijst
    INTEGER(KIND=4) :: ii, ij
    INTEGER(KIND=4) :: idirx, idiry
    INTEGER(KIND=4) :: ipts

    REAL(KIND=4)    :: zxi0, zyj0, zxi1, zyj1
    REAL(KIND=4)    :: zai, zbi
    REAL(KIND=4)    :: zaj, zbj
    REAL(KIND=4)    :: zd

    COMPLEX, DIMENSION(kpi+kpj) :: ylpt           ! array of points coordinates in a section
    COMPLEX                     :: ylpti          ! working point
    !!----------------------------------------------------------------------

    !! Find the broken line between P1 (kimin,kjmin) and P2 (kimax, kjmax)
    ! ... Initialization
    ii0  = kimin ; ij0  = kjmin ; ii1  = kimax ;  ij1 = kjmax
    zxi0 = ii0   ; zyj0 = ij0   ; zxi1 = ii1   ; zyj1 = ij1

    ! compute direction of integrations and signs
    !The transport across the section is the dot product of
    !integral(line){(Mx,My)*dS}
    !Mx=integral(u*dz)  My=integral(v*dz)) and dS=(dy,-dx)}

    !By defining the direction of the integration as
    idirx = SIGN(1,ii1-ii0) !positive to the east or if ii1=ii0
    idiry = SIGN(1,ij1-ij0) !positive to the north or if ij1=ij0

    !Then dS=(e2u*idiry,-e1v*idirx)
    !This will produce the following sign convention:
    !    West-to-est line (dx>0, dy=0)=> -My*dx (-ve for a northward flow)
    !    South-to-north   (dy>0, dx=0)=>  Mx*dy (+ve for an eastward flow)
    IF ( PRESENT (knormu) ) knormu =  idiry
    IF ( PRESENT (knormv) ) knormv = -idirx

    ! .. Compute equation:  ryj = zaj rxi + zbj [valid in the (i,j) plane]
    IF ( (zxi1 -zxi0) /=  0 ) THEN
       zaj = (zyj1 - zyj0 ) / (zxi1 -zxi0)
       zbj = zyj0 - zaj * zxi0
    ELSE
       zaj = 10000.  ! flag value
       zbj = 0.
    END IF
    ! .. Compute equation:  rxi = zai ryj + zbi [valid in the (i,j) plane]
    IF ( (zyj1 -zyj0) /=  0 ) THEN
       zai = (zxi1 - zxi0 ) / ( zyj1 -zyj0 )
       zbi = zxi0 - zai * zyj0
    ELSE
       zai = 10000. ! flag value
       zbi = 0.
    END IF

    ! ..  Compute the integer pathway: a succession of F points
    ipts=0
    ! .. Chose the strait line with the smallest slope
    IF (ABS(zaj) <=  1 ) THEN
       ! ... Here, the best line is y(x)
       ! ... If ii1 < ii0 swap points [ always describe section from left to right ]
       IF (ii1 <  ii0 ) THEN
          iitmp = ii0   ; ijtmp = ij0
          ii0   = ii1   ; ij0   = ij1
          ii1   = iitmp ; ij1   = ijtmp
       END IF

       ! iist,ijst is the grid offset to pass from F point to either U/V point
       IF ( ij1 >= ij0 ) THEN     ! line heading NE
          iist = 1 ; ijst = 1
       ELSE                       ! line heading SE
          iist = 1 ; ijst = 0
       END IF

       ! ... compute the nearest ji point on the line crossing at ji
       DO ji=ii0, ii1
          ipts=ipts+1
          IF (ipts > kpi+kpj) THEN ; PRINT *,' ... ERROR in broken_line : ipts > kpi+kpj !' ; STOP 96
          ENDIF
          ij=NINT(zaj*ji + zbj )
          ylpt(ipts) = CMPLX(ji,ij)
       END DO
    ELSE
       ! ... Here, the best line is x(y)
       ! ... If ij1 < ij0 swap points [ always describe section from bottom to top ]
       IF (ij1 <  ij0 ) THEN
          iitmp = ii0   ; ijtmp = ij0
          ii0   = ii1   ; ij0   = ij1
          ii1   = iitmp ; ij1   = ijtmp
       END IF

       ! iist,ijst is the grid offset to pass from F point to either U/V point
       IF ( ii1 >=  ii0 ) THEN
          iist = 1 ; ijst = 1
       ELSE
          iist = 0 ; ijst = 1
       END IF

       ! ... compute the nearest ji point on the line crossing at jj
       DO jj=ij0,ij1
          ipts=ipts+1
          IF (ipts > kpi+kpj) THEN ; PRINT *,' ... ERROR in broken_line : ipts > kpi+kpj !' ; STOP 96
          ENDIF
          ii=NINT(zai*jj + zbi)
          ylpt(ipts) = CMPLX(ii,jj)
       END DO
    END IF
    !!
    !! Look for intermediate points to be added.
    !  ..  The final positions are saved in pxx,pyy
    pxx(1) = REAL(ylpt(1))
    pyy(1) = IMAG(ylpt(1))
    knn     = 1

    DO jk=2,ipts
       ! .. distance between 2 neighbour points
       zd=ABS(ylpt(jk)-ylpt(jk-1))
       ! .. intermediate points required if zd > 1
       IF ( zd > 1 ) THEN
          CALL interm_pt(ylpt, jk, zai, zbi, zaj, zbj, ylpti)
          knn=knn+1
          IF (knn > kpi+kpj) THEN ; PRINT *,' ... ERROR in broken_line : knn > kpi+kpj !' ; STOP 96
          ENDIF
          pxx(knn) = REAL(ylpti)
          pyy(knn) = IMAG(ylpti)
       END IF
       knn=knn+1
       IF (knn > kpi+kpj) THEN ; PRINT *,' ... ERROR in broken_line : knn > kpi+kpj !' ; STOP 96
       ENDIF
       pxx(knn) = REAL(ylpt(jk))
       pyy(knn) = IMAG(ylpt(jk))
    END DO

  END SUBROUTINE broken_line

  ! Private subroutines and functions
  SUBROUTINE NearestPoint(ddlon, ddlat, kpi, kpj, ddlam, ddphi, kpiloc, kpjloc, ld_bnd)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE NearestPoint  ***
    !!
    !! ** Purpose : Compute the positions of the nearest i,j in the grid
    !!              from the given longitudes and latitudes
    !!
    !! ** Method  : Starts on the middle of the grid, search in a 20x20 box,
    !!              and move the box in the direction where the distance 
    !!              between the box and the point is minimum.
    !!              Iterates ...
    !!              Stops when the point is outside the grid.
    !!
    !! References : P.A. Darbon and A. de Miranda acknowledged for this 
    !!              clever algorithm developped in CLIPPER.
    !!----------------------------------------------------------------------
    REAL(KIND=8),                     INTENT(in) :: ddlon, ddlat      !: lon and lat of target point
    INTEGER(KIND=4),                 INTENT (in) :: kpi, kpj          !: grid size
    REAL(KIND=8), DIMENSION(kpi,kpj), INTENT(in) :: ddlam, ddphi      !: model grid layout
    INTEGER(KIND=4),              INTENT (inout) :: kpiloc, kpjloc    !: nearest point location
    LOGICAL                                      :: ld_bnd            !: reach boundary flag

    INTEGER(KIND=4)                              :: ji, jj
    INTEGER(KIND=4), PARAMETER                   :: jp_blk=10
    INTEGER(KIND=4)                              :: ii0, ij0
    INTEGER(KIND=4)                              :: ii1, ij1
    REAL(KIND=4)                                 :: zdist
    REAL(KIND=4)                                 :: zdistmin, zdistmin0
    LOGICAL, SAVE                                :: ll_bndcell, ll_first=.TRUE.
    !!----------------------------------------------------------------------
    IF ( ll_first ) THEN
       kpiloc = kpi/2 ; kpjloc = kpj/2    ! seek from the middle of domain
       ll_first=.FALSE.
    ENDIF

    zdistmin=1000000. ; zdistmin0=1000000.
    ii0 = kpiloc      ; ij0 = kpjloc
    ll_bndcell=.TRUE. ; ld_bnd=.FALSE.

    ! loop until found or boundary reach
    DO  WHILE ( ll_bndcell .AND. .NOT. ld_bnd )
       ii0 = kpiloc - jp_blk ;  ii1 = kpiloc + jp_blk
       ij0 = kpjloc - jp_blk ;  ij1 = kpjloc + jp_blk

       ! search only the inner domain
       IF (ii0 <= 0 ) ii0 = 2
       IF (ii1 > kpi) ii1 = kpi - 1
       IF (ij0 <= 0 ) ij0 = 2
       IF( ij1 > kpj) ij1 = kpj - 1

       ! within a block jp_blk+1 x jp_blk+1:
       DO jj=ij0,ij1
          DO ji=ii0,ii1
             ! compute true distance (orthodromy) between target point and grid point
             zdist    = dist(ddlon, ddlam(ji,jj), ddlat, ddphi(ji,jj) )
             zdistmin = MIN(zdistmin, zdist)
             ! update kpiloc, kpjloc if distance decreases
             IF (zdistmin /=  zdistmin0 ) THEN
                kpiloc=ji
                kpjloc=jj
             ENDIF
             zdistmin0=zdistmin
          END DO
       END DO

       ll_bndcell=.FALSE.
       ! if kpiloc, kpjloc belong to block boundary proceed to next block, centered on kpiloc, kpjloc
       IF (kpiloc == ii0 .OR. kpiloc == ii1) ll_bndcell=.TRUE.
       IF (kpjloc == ij0 .OR. kpjloc == ij1) ll_bndcell=.TRUE.

       ! boundary reach ---> not found
       IF (kpiloc == 2  .OR. kpiloc ==kpi-1) ld_bnd=.TRUE.
       IF (kpjloc == 2  .OR. kpjloc ==kpj-1) ld_bnd=.TRUE.
    END DO

  END SUBROUTINE  NearestPoint


  REAL(KIND=8) FUNCTION dist(ddlona, ddlonb, ddlata, ddlatb)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION dist  ***
    !!
    !! ** Purpose : Compute the distance (km) between
    !!              point A (lona, lata) and B (lonb, latb)  
    !!
    !! ** Method  : Use of double precision is important. Compute the 
    !!              distance along the orthodromy
    !!
    !!----------------------------------------------------------------------
    REAL(KIND=8), INTENT(in) :: ddlata, ddlona, ddlatb, ddlonb

    REAL(KIND=8), SAVE :: dl_latar, dl_latbr, dl_lonar, dl_lonbr
    REAL(KIND=8)       :: dl_pds
    REAL(KIND=8), SAVE :: dl_ux, dl_uy, dl_uz
    REAL(KIND=8)       :: dl_vx, dl_vy, dl_vz
    REAL(KIND=8), SAVE :: dl_prevlat=-1000.d0
    REAL(KIND=8), SAVE :: dl_prevlon=-1000.d0
    REAL(KIND=8), SAVE :: dl_r, dl_pi, dl_conv

    LOGICAL :: ll_first=.TRUE.
    !!----------------------------------------------------------------------
    ! initialise some values at first call
    IF ( ll_first ) THEN
       ll_first = .FALSE.
       ! constants
       dl_pi   = ACOS(-1.d0)
       dl_conv = dl_pi/180.d0  ! for degree to radian conversion
       ! Earth radius
       dl_r    = (6378.137d0+6356.7523d0)/2.0d0 ! km
    ENDIF

    ! compute these term only if they differ from previous call
    IF ( ddlata /= dl_prevlat .OR. ddlona /= dl_prevlon) THEN
       dl_latar   = ddlata*dl_conv
       dl_lonar   = ddlona*dl_conv
       dl_ux      = COS(dl_lonar)*COS(dl_latar)
       dl_uy      = SIN(dl_lonar)*COS(dl_latar)
       dl_uz      = SIN(dl_latar)
       dl_prevlat = ddlata
       dl_prevlon = ddlona
    ENDIF

    dl_latbr = ddlatb*dl_conv
    dl_lonbr = ddlonb*dl_conv
    dl_vx    = COS(dl_lonbr)*COS(dl_latbr)
    dl_vy    = SIN(dl_lonbr)*COS(dl_latbr)
    dl_vz    = SIN(dl_latbr)

    dl_pds   = dl_ux*dl_vx + dl_uy*dl_vy + dl_uz*dl_vz

    IF (dl_pds >= 1.) THEN
       dist = 0.
    ELSE
       dist = dl_r*ACOS(dl_pds)
    ENDIF

  END FUNCTION dist


  SUBROUTINE interm_pt (ydpt, kk, pai, pbi, paj, pbj, ydpti)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE nterm_pt  ***
    !!
    !! ** Purpose : Find the best intermediate points on a pathway.
    !!
    !! ** Method  : ydpt : complex vector of the positions of the nearest points
    !!               kk  : current working index
    !!          pai, pbi : slope and original ordinate of x(y)
    !!          paj, pbj : slope and original ordinate of y(x)
    !!             ydpti : Complex holding the position of intermediate point 
    !!
    !! ** Reference : 19/07/1999 : J.M. Molines in Clipper
    !!----------------------------------------------------------------------
    COMPLEX, DIMENSION(:), INTENT(in ) :: ydpt
    COMPLEX,               INTENT(out) :: ydpti
    REAL(KIND=4),          INTENT(in ) :: pai, pbi, paj, pbj
    INTEGER(KIND=4),       INTENT(in ) :: kk
    ! ... local
    COMPLEX                            :: ylptmp1, ylptmp2
    REAL(KIND=4)                       :: za0, zb0
    REAL(KIND=4)                       :: za1, zb1
    REAL(KIND=4)                       :: zd1, zd2
    REAL(KIND=4)                       :: zxm, zym
    REAL(KIND=4)                       :: zxp, zyp
    !!----------------------------------------------------------------------
    ! ... Determines whether we use y(x) or x(y):
    IF (ABS(paj) <=  1) THEN
       ! .....  use y(x)
       ! ... possible intermediate points:
       ylptmp1=ydpt(kk-1)+(1.,0.)                 ! M1 
       ylptmp2=ydpt(kk-1)+CMPLX(0.,SIGN(1.,paj))  ! M2
       !
       ! ... M1 is the candidate point:
       zxm=REAL(ylptmp1)
       zym=IMAG(ylptmp1)
       za0=paj
       zb0=pbj
       !
       za1=-1./za0
       zb1=zym - za1*zxm
       ! ... P1 is the projection of M1 on the strait line
       zxp=-(zb1-zb0)/(za1-za0)
       zyp=za0*zxp + zb0
       ! ... zd1 is the distance M1P1
       zd1=(zxm-zxp)*(zxm-zxp) + (zym-zyp)*(zym-zyp)
       !
       ! ... M2 is the candidate point:
       zxm=REAL(ylptmp2)
       zym=IMAG(ylptmp2)
       za1=-1./za0
       zb1=zym - za1*zxm
       ! ... P2 is the projection of M2 on the strait line
       zxp=-(zb1-zb0)/(za1-za0)
       zyp=za0*zxp + zb0
       ! ... zd2 is the distance M2P2
       zd2=(zxm-zxp)*(zxm-zxp) + (zym-zyp)*(zym-zyp)
       ! ... chose the smallest (zd1,zd2)
       IF (zd2 <=  zd1) THEN
          ydpti=ylptmp2   ! use M2
       ELSE
          ydpti=ylptmp1   ! use M1
       END IF
       !
    ELSE   
       ! ...  use x(y)
       ! ... possible intermediate points:
       ylptmp1=ydpt(kk-1)+CMPLX(SIGN(1.,pai),0.)  ! M1
       ylptmp2=ydpt(kk-1)+(0.,1.)                 ! M2
       ! 
       ! ... M1 is the candidate point:
       zxm=REAL(ylptmp1)
       zym=IMAG(ylptmp1)
       za0=pai
       zb0=pbi
       !
       za1=-1./za0
       zb1=zxm - za1*zym
       zyp=-(zb1-zb0)/(za1-za0)
       zxp=za0*zyp + zb0
       zd1=(zxm-zxp)*(zxm-zxp) + (zym-zyp)*(zym-zyp)
       !
       zxm=REAL(ylptmp2)
       zym=IMAG(ylptmp2)
       za1=-1./za0
       zb1=zxm - za1*zym
       zyp=-(zb1-zb0)/(za1-za0)
       zxp=za0*zyp + zb0
       zd2=(zxm-zxp)*(zxm-zxp) + (zym-zyp)*(zym-zyp)
       IF (zd2 <=  zd1) THEN
          ydpti=ylptmp2
       ELSE
          ydpti=ylptmp1
       END IF
    END IF
  END SUBROUTINE interm_pt
END MODULE cdftools

PROGRAM cdfmxlsaltc
  !!======================================================================
  !!                     ***  PROGRAM  cdfmxlsaltc  ***
  !!=====================================================================
  !!  ** Purpose : Compute the salt content in the mixed layer. Work for
  !!               partial steps (default) or full step (-full option)
  !!
  !!  ** Method  : compute the sum ( rho S  * e1 *e2 * e3 *mask )
  !!               for the mixed layer stored into gridT file
  !!
  !! History : 2.1  : 04/2006  : J.M. Molines : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  USE modutils
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class mixed_layer
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                               :: jk, jt              ! dummy loop index
  INTEGER(KIND=4)                               :: it                  ! time index for vvl
  INTEGER(KIND=4)                               :: narg, iargc, ijarg  ! command line 
  INTEGER(KIND=4)                               :: npiglo, npjglo      ! size of the domain
  INTEGER(KIND=4)                               :: npk, npt            ! size of the domain,
  INTEGER(KIND=4)                               :: ncout, ierr         ! ncid and error status
  INTEGER(KIND=4), DIMENSION(1)                 :: ipk, id_varout      ! levels and varid's of output vars

  REAL(KIND=4), PARAMETER                       :: rprho0=1020.        ! rho reference density
  REAL(KIND=4), PARAMETER                       :: rpcp=4000.          ! calorific capacity
  REAL(KIND=4), DIMENSION(1)                    :: rdep                ! dummy depth output
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: gdepw               ! vertical levels
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: e31d                ! vertical metric full
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: e3                  ! metrics
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: zs                  ! temperature in the MXL
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: zmxl                ! depth of the MXL
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: zmask               ! mask

  REAL(KIND=8)                                  :: dvol                ! total volume
  REAL(KIND=8), DIMENSION(:),       ALLOCATABLE :: dtim                ! time counter
  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: dmxlsaltc           ! heat content

  CHARACTER(LEN=256)                            :: cf_tfil             ! input file name
  CHARACTER(LEN=256)                            :: cf_sfil             ! input file name with salinity (option)
  CHARACTER(LEN=256)                            :: cf_mfil             ! input file name with mld (option)
  CHARACTER(LEN=256)                            :: cf_out='mxlsaltc.nc'! output file
  CHARACTER(LEN=256)                            :: cv_out='somxlsaltc' ! input file name
  CHARACTER(LEN=256)                            :: cglobal             ! global attribute
  CHARACTER(LEN=256)                            :: cldum               ! dummy string

  TYPE(variable), DIMENSION(1)                  :: stypvar             ! stucture for attributes (output)

  LOGICAL                                       :: lfull=.FALSE.       ! full step flag
  LOGICAL                                       :: lnc4 =.FALSE.       ! netcdf4  flag
  LOGICAL                                       :: lchk                ! file existence flag (true if missing)
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfmxlsaltc -t T-file [-s S-file] [-mxlf MXL-file] [-full] [-vvl] ...'
     PRINT *,'                 ...   [-o OUT-file] [-nc4] [-vvl]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the salt content in the mixed layer.' 
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -t T-file : netcdf input file with salinity and mld (gridT).' 
     PRINT *,'         If salinity not in T-file use -s option.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-s S-file     ]: specify salinity file if not T-file.'
     PRINT *,'       [-mxlf MXL-file]: netcdf input file with mld if not in T-file.' 
     PRINT *,'       [-full ] : for full step configurations, default is partial step.' 
     PRINT *,'       [-o OUT-file ] : specify output file instead of ',TRIM(cf_out) 
     PRINT *,'       [-nc4 ] : Use netcdf4 output with chunking and deflation level 1.'
     PRINT *,'                 This option is effective only if cdftools are compiled with'
     PRINT *,'                 a netcdf library supporting chunking and deflation.'
     PRINT *,'       [-vvl ] : use time-varying vertical metrics.'
     PRINT *,'      '
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ', TRIM(cn_fzgr),' and ', TRIM(cn_fmsk) 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out),' unless option -o is used.'
     PRINT *,'         variables : ', TRIM(cv_out),' (Kg/m2)'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'       cdfmxl, cdfmxlhcsc, cdfmxlheatc ' 
     PRINT *,'      '
     STOP 
  ENDIF

  cf_mfil='none'
  cf_sfil='none'
  ijarg = 1
  DO WHILE ( ijarg <= narg )
    CALL getarg (ijarg, cldum   ) ; ijarg = ijarg + 1 
    SELECT CASE ( cldum )
    CASE ( '-t','-f'  ) ; CALL getarg (ijarg, cf_tfil  ) ; ijarg = ijarg + 1
    ! options
    CASE ( '-s'       ) ; CALL getarg (ijarg, cf_sfil  ) ; ijarg = ijarg + 1
    CASE ( '-mxlf'    ) ; CALL getarg (ijarg, cf_mfil  ) ; ijarg = ijarg + 1
    CASE ( '-full'    ) ; lfull  = .TRUE.
    CASE ( '-o'       ) ; CALL getarg (ijarg, cf_out ) ; ijarg = ijarg + 1
    CASE ( '-nc4'     ) ; lnc4   = .TRUE.
    CASE ( '-vvl'     ) ; lg_vvl = .TRUE.
    CASE DEFAULT  ; PRINT *, 'ERROR: ', TRIM(cldum),' : unknown option.' ; STOP 99
    END SELECT
  END DO

  IF ( cf_mfil == 'none' ) cf_mfil = cf_tfil 
  IF ( cf_sfil == 'none' ) cf_sfil = cf_tfil 

  lchk = chkfile (cn_fzgr  )
  lchk = chkfile (cn_fmsk  ) .OR. lchk
  lchk = chkfile (cf_tfil  ) .OR. lchk
  lchk = chkfile (cf_sfil  ) .OR. lchk
  lchk = chkfile (cf_mfil  ) .OR. lchk
  IF ( lchk ) STOP 99 ! missing files
  IF ( lg_vvl ) THEN 
     cn_fe3t = cf_tfil
     cn_ve3t = cn_ve3tvvl
  ENDIF

  CALL SetGlobalAtt( cglobal )

  npiglo = getdim (cf_tfil,cn_x)
  npjglo = getdim (cf_tfil,cn_y)
  npk    = getdim (cf_tfil,cn_z)
  npt    = getdim (cf_tfil,cn_t)


  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  ! Allocate arrays
  ALLOCATE ( zmask(npiglo,npjglo), dmxlsaltc(npiglo, npjglo) )
  ALLOCATE ( zs(npiglo,npjglo), zmxl(npiglo,npjglo)          )
  ALLOCATE ( e3(npiglo,npjglo)                               )
  ALLOCATE ( gdepw(npk), dtim(npt)                           )
  
  CALL CreateOutput

  IF ( lfull ) ALLOCATE ( e31d(npk)                          )
               gdepw(:) = getvare3(cn_fzgr, cn_gdepw, npk)
  IF ( lfull ) e31d( :) = getvare3(cn_fzgr, cn_ve3t1d,  npk)

  DO jt=1,npt
     IF ( lg_vvl ) THEN ; it=jt
     ELSE               ; it=1
     ENDIF
     dmxlsaltc(:,:) = 0.d0
     dvol           = 0.d0
     zmxl( :,:) = getvar(cf_mfil, cn_somxl010, 1,  npiglo, npjglo, ktime=jt)

     DO jk = 1, npk
        zs(   :,:) = getvar(cf_sfil, cn_vosaline, jk, npiglo, npjglo, ktime=jt)
        zmask(:,:) = getvar(cn_fmsk, cn_tmask,    jk, npiglo, npjglo          )

        ! get e3 at level jk ( ps...)
        IF ( lfull ) THEN
           e3(:,:) = e31d(jk)
        ELSE
           e3(:,:) = getvar(cn_fe3t, cn_ve3t, jk, npiglo, npjglo, ktime=it, ldiom=.NOT.lg_vvl )
        ENDIF

        !  e3 is used as a flag for the mixed layer; It is 0 outside the mixed layer
        e3(:,:)=MAX ( 0., MIN(e3, zmxl-gdepw(jk) ) )
        WHERE ( e3 == 0 ) zmask = 0.

        dvol      = SUM( DBLE(e3 * zmask) )
        dmxlsaltc = zs * e3 * zmask * 1.d0 + dmxlsaltc

        IF (dvol /= 0 )THEN
           !   go on !
        ELSE
           !   no more layer below !
           EXIT   ! get out of the jk loop
        ENDIF
     END DO

     ! Output to netcdf file : Kg/m2
     dmxlsaltc = rprho0*dmxlsaltc
     ierr = putvar(ncout, id_varout(1), REAL(dmxlsaltc), 1, npiglo, npjglo, ktime=jt)
  END DO

  ierr = closeout(ncout)
CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
  rdep(1)                      = 0.

  ipk(:)                       = 1
  stypvar(1)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
  stypvar(1)%cname             = cv_out
  stypvar(1)%cunits            = 'kg/m2'
  stypvar(1)%rmissing_value    = 0.
  stypvar(1)%valid_min         = 0
  stypvar(1)%valid_max         =  1.e9
  stypvar(1)%clong_name        = 'Mixed_Layer_Salt_Content'
  stypvar(1)%cshort_name       = cv_out
  stypvar(1)%conline_operation = 'N/A'
  stypvar(1)%caxis             = 'TYX'

  ! Initialize output file
  ncout = create      (cf_out, cf_tfil, npiglo, npjglo, 1                          ,ld_nc4=lnc4 )
  ierr  = createvar   (ncout,  stypvar, 1,      ipk,    id_varout, cdglobal=cglobal,ld_nc4=lnc4 )
  ierr  = putheadervar(ncout,  cf_tfil, npiglo, npjglo, 1, pdep=rdep                )

  dtim = getvar1d(cf_tfil, cn_vtimec, npt     )
  ierr = putvar1d(ncout,  dtim,       npt, 'T')

  END SUBROUTINE CreateOutput

END PROGRAM cdfmxlsaltc

PROGRAM cdfbci
  !!======================================================================
  !!                     ***  PROGRAM  cdfbci  ***
  !!=====================================================================
  !!  ** Purpose : Compute the term of energetic transfert BCI
  !!               for the baroclinic instability
  !!
  !!  ** Method  : take  an input file which is the result of a preprocessing
  !!               tool cdfmoyuvwt.
  !!
  !! History : 2.1  : 02/2008  : A. Melet     : Original code
  !!           3.0  : 12/2010  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2010, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: ji, jj, jk
  INTEGER(KIND=4)                           :: ilev
  INTEGER(KIND=4)                           :: npiglo, npjglo, npk, npt
  INTEGER(KIND=4)                           :: narg, iargc
  INTEGER(KIND=4)                           :: ncout, ierr
  INTEGER(KIND=4), DIMENSION(5)             :: ipk, id_varout         ! 

  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: tim
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e2t, e1t 
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: anout, anovt, un, vn, tn
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: utn, vtn
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: tmask, umask, vmask
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: bci
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: rdtdx, rdtdy

  CHARACTER(LEN=256)                        :: cf_in
  CHARACTER(LEN=256)                        :: cf_out='bci.nc'

  TYPE (variable), DIMENSION(5)             :: stypvar         !: structure for attibutes
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()   ! load cdf variable name

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfbci UVWT-file'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute elements for analysing the baroclinic instability' 
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       UVWT-file : input file is produced by cdfmoyuvwt, and the mean'
     PRINT *,'              must be computed on a long-enough period for the ' 
     PRINT *,'              statistics to be meaningful. Points are on T grid.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       Need ', TRIM(cn_fhgr) ,' file'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : 5 output variables'
     PRINT *,'             dTdx : zonal derivative of Tbar on T point (*1000)'
     PRINT *,'             dTdy : meridional derivative of Tbar on T point (*1000)'
     PRINT *,'             uT   : anomaly of u times anomaly of T on T point'
     PRINT *,'             vT   : anomaly of v times anomaly of T on T point'
     PRINT *,'             bci  : transfert of energy for the baroclinic instability (*1000)'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'       cdfmoyuvwt '
     STOP
  ENDIF

  CALL getarg(1, cf_in)
  IF (chkfile(cf_in) .OR. chkfile (cn_fhgr) ) STOP

  npiglo = getdim(cf_in, cn_x)
  npjglo = getdim(cf_in, cn_y)
  npk    = getdim(cf_in, cn_z)
  npt    = getdim(cf_in, cn_t)

  PRINT *, 'npiglo =', npiglo
  PRINT *, 'npjglo =', npjglo
  PRINT *, 'npk    =', npk
  PRINT *, 'npt    =', npt

  ! define new variables for output ( must update att.txt)
  stypvar(1)%cname       = 'dTdx'
  stypvar(1)%clong_name  = 'zonal derivate of Tbar on T point (*1000)'
  stypvar(1)%cshort_name = 'dTdx'

  stypvar(2)%cname       = 'dTdy'
  stypvar(2)%clong_name  = 'meridional derivate of Tbar on T point (*1000)'
  stypvar(2)%cshort_name = 'dTdy'
 
  stypvar(3)%cname       = 'uT'
  stypvar(3)%clong_name  = 'anomaly of u times anomaly of T on T point'
  stypvar(3)%cshort_name = 'uT'
  
  stypvar(4)%cname       = 'vT'
  stypvar(4)%clong_name  = 'anomaly of v times anomaly of T on T point'
  stypvar(4)%cshort_name = 'vT'

  stypvar(5)%cname       = 'bci'
  stypvar(5)%clong_name  = 'transfert of energy for the baroclinic instability (*1000)'
  stypvar(5)%cshort_name = 'bci'

  stypvar%cunits            = '1000 (u"T" dT/dx + v"T" dT/dy)'
  stypvar%rmissing_value    = 0.
  stypvar%valid_min         = -1000.
  stypvar%valid_max         = 1000.
  stypvar%conline_operation = 'N/A'
  stypvar%caxis             = 'TYX'

  ipk(:) = npk  
  
  !test if lev exists
  IF ((npk==0) .AND. (ilev > 0) ) THEN
     PRINT *, 'Problem : npk = 0 and lev > 0 STOP'
     STOP
  END IF

  ! create output fileset
  ncout = create      (cf_out,   cf_in,   npiglo, npjglo, npk       )
  ierr  = createvar   (ncout ,   stypvar, 5,      ipk,    id_varout )
  ierr  = putheadervar(ncout,    cf_in,   npiglo, npjglo, npk       )

  ! Allocate the memory
  ALLOCATE ( e1t(npiglo,npjglo) , e2t(npiglo,npjglo) )
  ALLOCATE ( un(npiglo,npjglo)  , vn(npiglo,npjglo)  )
  ALLOCATE ( tn(npiglo,npjglo) )
  ALLOCATE ( utn(npiglo,npjglo) , vtn(npiglo,npjglo) )
  ALLOCATE ( umask(npiglo,npjglo) , vmask(npiglo,npjglo) )
  ALLOCATE ( tmask(npiglo,npjglo) )
  ALLOCATE ( rdtdx(npiglo,npjglo)  , rdtdy(npiglo,npjglo)  )
  ALLOCATE ( anout(npiglo,npjglo)  , anovt(npiglo,npjglo)  )
  ALLOCATE ( bci(npiglo,npjglo), tim(npt) )

  e1t =  getvar(cn_fhgr, cn_ve1t, 1, npiglo, npjglo)
  e2t =  getvar(cn_fhgr, cn_ve2t, 1, npiglo, npjglo)

  tim  = getvar1d(cf_in, cn_vtimec, npt)
  ierr = putvar1d(ncout, tim, npt, 'T')
     
  DO jk=1, npk
     PRINT *,'            level ',jk
           
     rdtdx(:,:) = 0.0
     rdtdy(:,:) = 0.0
        
     anovt(:,:) = 0.0      
     anout(:,:) = 0.0

     un(:,:)  =  getvar(cf_in, 'ubar',  jk ,npiglo, npjglo, ktime=1)
     vn(:,:)  =  getvar(cf_in, 'vbar',  jk ,npiglo, npjglo, ktime=1)
     tn(:,:)  =  getvar(cf_in, 'tbar',  jk ,npiglo, npjglo, ktime=1)
     utn(:,:) =  getvar(cf_in, 'utbar', jk ,npiglo, npjglo, ktime=1)
     vtn(:,:) =  getvar(cf_in, 'vtbar', jk ,npiglo, npjglo, ktime=1)

     ! compute the mask
     DO jj = 2, npjglo
        DO ji = 2, npiglo
           umask(ji,jj)= un(ji,jj)*un(ji-1,jj) 
           vmask(ji,jj)= vn(ji,jj)*vn(ji,jj-1)
           tmask(ji,jj)= tn(ji,jj)
           IF (umask(ji,jj) /= 0.) umask(ji,jj)=1.
           IF (vmask(ji,jj) /= 0.) vmask(ji,jj)=1.
           IF (tmask(ji,jj) /= 0.) tmask(ji,jj)=1.
        END DO
     END DO

     DO jj = 2, npjglo  
        DO ji = 2, npiglo    ! vector opt.
           ! compute derivatives at T point
           rdtdx(ji,jj) = 1000/2. *( ( tn(ji,jj ) - tn(ji-1,jj) )      &
                &           * tmask(ji,jj)*tmask(ji-1,jj)              &
                &           / ( 0.5* ( e1t(ji,jj) + e1t(ji-1,jj) ))    &
                &           +( tn(ji+1,jj ) - tn(ji,jj) )              &
                &           * tmask(ji+1,jj)*tmask(ji,jj)              &
                &           / ( 0.5* ( e1t(ji+1,jj) + e1t(ji,jj) )))

           rdtdy(ji,jj) = 1000/2. *( ( tn(ji,jj) - tn(ji,jj-1) )       &
                &           * tmask(ji,jj)*tmask(ji,jj-1)              &
                &           / ( 0.5* ( e2t(ji,jj) + e2t(ji,jj-1) ))    &
                &           +( tn(ji,jj+1 ) - tn(ji,jj) )              &
                &           * tmask(ji,jj+1)*tmask(ji,jj)              &
                &           / ( 0.5* ( e2t(ji,jj+1) + e2t(ji,jj) )) )

           anout(ji,jj)    = ( utn(ji,jj)                                            &
                &                 -   1/2 * umask(ji,jj)*( un(ji,jj) + un(ji-1,jj) ) &
                &                   * tmask(ji,jj) * tn(ji,jj) )

           anovt(ji,jj)    = ( vtn(ji,jj)                                            &
                &                 -   1/2 * vmask(ji,jj)*( vn(ji,jj) + vn(ji,jj-1) ) &
                &                   * tmask(ji,jj) * tn(ji,jj) )

           ! compute bci term
           bci(ji,jj) = ( anout(ji,jj) * rdtdx(ji,jj) + anovt(ji,jj) * rdtdy(ji,jj) )

        END DO
     END DO
     ! 
     ierr = putvar(ncout, id_varout(1), rdtdx, jk, npiglo, npjglo, ktime=1)
     ierr = putvar(ncout, id_varout(2), rdtdy, jk, npiglo, npjglo, ktime=1)
     ierr = putvar(ncout, id_varout(3), anout, jk, npiglo, npjglo, ktime=1)
     ierr = putvar(ncout, id_varout(4), anovt, jk, npiglo, npjglo, ktime=1)
     ierr = putvar(ncout, id_varout(5), bci,   jk, npiglo, npjglo, ktime=1)
  END DO
  ierr = closeout(ncout)

END PROGRAM cdfbci

PROGRAM cdf2levitusgrid2d
  !!======================================================================
  !!                     ***  PROGRAM  cdf2levitusgrid2d  ***
  !!=====================================================================
  !!  ** Purpose : remaps (bin) 2D high resolution (finer than 1x1 deg)
  !!               fields on Levitus 2D 1x1 deg grid
  !!
  !!  ** Method  : data surface averaging
  !!               It assumes that Levitus grid SW grid cell center 
  !!               is 0.5W,89.5S 
  !!
  !! History : 3.0  : 06/2012  : N. Ferry  : Original code
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  USE cdftools
  USE modutils
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class data_transformation
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                              :: ji, jj, jk, jvar,jt! dummy loop index
  INTEGER(KIND=4)                              :: jilev,jjlev        ! dummy loop index
  INTEGER(KIND=4)                              :: numvar0            ! dummy loop index
  INTEGER(KIND=4)                              :: ii, ij             ! array index (not loop)
  INTEGER(KIND=4)                              :: iilev, ijlev       ! array index (not loop)
  INTEGER(KIND=4)                              :: npiglo, npjglo     ! size of the domain
  INTEGER(KIND=4)                              :: npk, npt           ! size of the domain
  INTEGER(KIND=4)                              :: npilev, npjlev     ! size of the Levitus domain
  INTEGER(KIND=4)                              :: narg, iargc, ijarg ! browse line
  INTEGER(KIND=4)                              :: ireq              ! ,andatory arguments counter. 
  INTEGER(KIND=4)                              :: ncout              ! ncid of output file
  INTEGER(KIND=4)                              :: ierr               ! error status
  INTEGER(KIND=4)                              :: nvars              ! number of variables in the input file
  INTEGER(KIND=4)                              :: nvarsout           ! number of variables in the output file
  INTEGER(KIND=4)                              :: iter_shap=3        ! number of Shapiro iteration
  INTEGER(KIND=4), DIMENSION(:),   ALLOCATABLE :: ipk, id_var        ! levels and varid's of input vars
  INTEGER(KIND=4), DIMENSION(:),   ALLOCATABLE :: ipkout, id_varout  ! levels and varid's of output vars

  REAL(KIND=4)                                 :: rlon1, rlon2, rlat1, rlat2, rpos
  REAL(KIND=4)                                 :: gphitmin
  REAL(KIND=4), DIMENSION(:),      ALLOCATABLE :: gdept              ! depth axis
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: e1t, e2t           ! horizontal T metrics
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: z_in               ! input field
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: z_fill             ! output 
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: glamt, gphit       ! T longitude latitude
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: rlonlev, rlatlev   ! Levitus grid longitude latitude
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: zbt
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: tmask              ! input mask
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: tmasklev           ! output mask

  REAL(KIND=8), DIMENSION(:),      ALLOCATABLE :: dtim               ! time counter
  REAL(KIND=8), DIMENSION(:,:),    ALLOCATABLE :: d_out, d_n         ! output field and weighting field

  CHARACTER(LEN=256)                           :: cf_in              ! input file name
  CHARACTER(LEN=256)                           :: cf_out             ! output file name ( output)
  CHARACTER(LEN=256)                           :: cf_levitus_mask='levitus_mask.nc'   ! Levitus mask filename
  CHARACTER(LEN=256)                           :: cv_nam             ! variable name
  CHARACTER(LEN=256)                           :: cldum              ! dummy string
  CHARACTER(LEN=256)                           :: ctcalendar         ! time attributes
  CHARACTER(LEN=256)                           :: cttitle            ! time attributes
  CHARACTER(LEN=256)                           :: ctlong_name        ! time attributes
  CHARACTER(LEN=256)                           :: ctaxis             ! time attributes
  CHARACTER(LEN=256)                           :: ctunits            ! time attributes
  CHARACTER(LEN=256)                           :: cttime_origin      ! time attributes

  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE:: cv_names          ! array of var name
  CHARACTER(LEN=6)                             :: ctyp              ! 'fill' or 'smooth' for shapiro

  TYPE(variable), DIMENSION(:),   ALLOCATABLE  :: stypvar            ! input attributes
  TYPE(variable), DIMENSION(:),   ALLOCATABLE  :: stypvarout         ! output attributes

  LOGICAL                                      :: lchk               ! missing files flag
  LOGICAL                                      :: ltest
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdf2levitusgrid2d -f IN-file -o OUT-file -v VAR-name2D'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Remaps (by binning) 2D high resolution (i.e. finer than 1x1 deg) '
     PRINT *,'       fields on Levitus 2D 1x1 deg grid. This program does not work for'
     PRINT *,'       vector fields.'
     PRINT *,'       It assumes that the southwestern-most grid cell of the target grid'
     PRINT *,'       (Levitus 1 deg) is centered at (0.5W,89.5S).' 
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -f IN-file  : netcdf input file ' 
     PRINT *,'       -o OUT-file : netcdf output file ' 
     PRINT *,'       -v VAR-name2D : input variable name for interpolation '
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ',TRIM(cn_fhgr)
     PRINT *,'       ',TRIM(cn_fmsk)
     PRINT *,'       ',TRIM(cf_levitus_mask)
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : name given as second argument'
     PRINT *,'         variables : 2d_var_name'
     STOP 
  ENDIF

  ijarg = 1 ; ireq = 0 
  DO WHILE ( ijarg <= narg )
     CALL getarg(ijarg, cldum)  ; ijarg = ijarg + 1
     SELECT CASE ( cldum )
     CASE ( '-f' ) ; CALL getarg(ijarg, cf_in ) ; ijarg = ijarg + 1 ; ireq=ireq+1
     CASE ( '-o' ) ; CALL getarg(ijarg, cf_out) ; ijarg = ijarg + 1 ; ireq=ireq+1
     CASE ( '-v' ) ; CALL getarg(ijarg, cv_nam) ; ijarg = ijarg + 1 ; ireq=ireq+1
     CASE DEFAULT  ; PRINT *,', ERROR : ', TRIM(cldum), ' :  unknown option.' ; STOP 99
     END SELECT
  ENDDO

  IF ( ireq /= 3 ) THEN ; PRINT *, ' ERROR : missing arguments.'; STOP 99  ; ENDIF

  lchk = chkfile (cn_fhgr)
  lchk = chkfile (cn_fmsk)         .OR. lchk
  lchk = chkfile (cf_levitus_mask) .OR. lchk
  lchk = chkfile (cf_in)           .OR. lchk
  IF ( lchk ) STOP 99 ! missing files

  npiglo = getdim(cf_in,cn_x)
  npjglo = getdim(cf_in,cn_y)
  npk    = getdim(cf_in,cn_z)
  npt    = getdim(cf_in,cn_t)
  npilev = getdim(cf_levitus_mask,cn_x)
  npjlev = getdim(cf_levitus_mask,cn_y)

  nvars = getnvar(cf_in)
  ! Allocate the memory
  ALLOCATE (cv_names(nvars) )
  ALLOCATE (stypvar(nvars)  , stypvarout(1))
  ALLOCATE (id_var(nvars), ipk(nvars), id_varout(1), ipkout(1))
  ALLOCATE ( zbt(npiglo,npjglo) , z_in(npiglo,npjglo) )
  ALLOCATE ( e1t(npiglo,npjglo), e2t(npiglo,npjglo) )
  ALLOCATE ( glamt(npiglo,npjglo), gphit(npiglo,npjglo)  )
  ALLOCATE ( d_out(npilev,npjlev) , d_n(npilev,npjlev) )
  ALLOCATE ( tmask(npiglo,npjglo) , tmasklev(npilev,npjlev))
  ALLOCATE ( rlonlev(npilev,npjlev), rlatlev(npilev,npjlev) )
  ALLOCATE ( gdept(1), dtim(npt) )

  ! Read the metrics from the mesh_hgr file
  e1t = getvar(cn_fhgr, cn_ve1t, 1, npiglo, npjglo)
  e2t = getvar(cn_fhgr, cn_ve2t, 1, npiglo, npjglo)

  ! and the coordinates   from the mesh_hgr file
  glamt = getvar(cn_fhgr, cn_glamt, 1, npiglo, npjglo)
  gphit = getvar(cn_fhgr, cn_gphit, 1, npiglo, npjglo)
  gphitmin = MINVAL(gphit(:,1))
  WHERE ( glamt < 0. ) glamt = glamt + 360. 

  ! get the tmask from the byte_mask file
  tmask(:,:) = getvar(cn_fmsk, cn_tmask, 1, npiglo, npjglo)

  CALL CreateOutput

  ! Get input 2D field ( numvar0 is the varid of the requested var from all the var in cf_in).
  z_in(:,:) = getvar(cf_in, cv_names(numvar0), 1, npiglo, npjglo)

  zbt(:,:) = e1t(:,:) * e2t(:,:)    ! for surface weighting

  DO jt = 1, npt
     PRINT *,'jt = ', jt
     ! Compute spatial mean by bin
     !-----------------------------
     ! Perform bining of the input file on the Levitus grid.
     ! Input area weighted values are summed up into a Levitus 1x1 bin
     d_out(:,:) = 0.d0
     d_n  (:,:) = 0.d0
     DO jj=1,npjglo
        DO ji=1,npiglo
           iilev = MIN( 360, INT( glamt(ji,jj) ) + 1)
           ijlev = MIN (180 , INT( gphit(ji,jj) + 90. ) + 1)
           IF ( z_in(ji,jj) /=  stypvarout(1)%rmissing_value ) THEN
              d_out(iilev,ijlev) = d_out(iilev,ijlev) + (z_in(ji,jj)*tmask(ji,jj))*zbt(ji,jj)*tmasklev(iilev,ijlev)*1.d0
              d_n  (iilev,ijlev) = d_n (iilev,ijlev)  +              tmask(ji,jj) *zbt(ji,jj)*tmasklev(iilev,ijlev)*1.d0
           ENDIF
        ENDDO
     ENDDO

     WHERE ( d_n > 0. ) ; d_out = d_out / d_n 
     ELSEWHERE          ; d_out = stypvarout(1)%rmissing_value 
     END WHERE

     ! Check if there are points with missing values on Levitus grid
     IF ( COUNT( d_out == stypvarout(1)%rmissing_value .AND. tmasklev == 1. ) /=  0. ) THEN
        ALLOCATE ( z_fill(npilev,npjlev) )
        z_fill(:,:) = 0.
        ctyp='fill'
        iter_shap = 3  ! number of shapiro iteration
        CALL shapiro_fill_smooth ( REAL(d_out), npilev, npjlev, iter_shap, ctyp,       &
           &                       stypvarout(1)%rmissing_value, INT(tmasklev), z_fill )

        DO jjlev = 1 , npjlev
           DO jilev = 1 , npilev
             IF (       z_fill(jilev,jjlev)   /=   stypvarout(1)%rmissing_value  &
                & .AND. tmasklev(jilev,jjlev) == 1                               &
                & .AND. d_out(jilev,jjlev)    == stypvarout(1)%rmissing_value )  THEN
                d_out(jilev,jjlev) = z_fill(jilev,jjlev)
             ENDIF
           ENDDO
        ENDDO
        IF ( ALLOCATED(z_fill) ) DEALLOCATE( z_fill )
     ENDIF !  filling points
     ! ----------------------------------------------------------------------------------------
     ! write 
     ierr = putvar(ncout, id_varout(1), REAL(d_out(:,:)), 1, npilev, npjlev, ktime=jt)

  END DO ! loop on time

  ierr = closeout(ncout)

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    ! get list of variable names and collect attributes in stypvar (optional)
    cv_names(:) = getvarname(cf_in, nvars, stypvar)
    id_var(:)   = (/(jvar, jvar=1,nvars)/)

    ! ipk gives the number of level or 0 if not a T[Z]YX  variable
    ipk(:)     = getipk(cf_in, nvars)
    WHERE( ipk == 0 ) cv_names='none'
    stypvar(:)%cname = cv_names

    ! select variable to output: (only one passed as argument)
    ii=1
    DO jvar=1,nvars
       IF ( TRIM(cv_names(jvar)) == TRIM(cv_nam) ) THEN
          ipkout(ii)     = ipk(jvar)
          stypvarout(ii) = stypvar(jvar)
          stypvarout(ii)%rmissing_value=getspval ( cf_in, TRIM(cv_nam) )
          PRINT*, 'rmissing_value = ', stypvarout(ii)%rmissing_value
          nvarsout = ii
          numvar0 = jvar
          EXIT ! found !
       ENDIF
    ENDDO

    ! JMM this Levitus mask file is not standard ? Must be provided some-how ...
    !      variable names hard coded here : OK 
    ! get the longitude,latitude,mask from the input Levitus mask file
    rlonlev(:,:)  = getvar(cf_levitus_mask, 'nav_lon',  1, npilev, npjlev)
    rlatlev(:,:)  = getvar(cf_levitus_mask, 'nav_lat' , 1, npilev, npjlev)
    tmasklev(:,:) = getvar(cf_levitus_mask, 'mask',     1, npilev, npjlev)

    ! create output fileset
    ncout = create      (cf_out, cf_levitus_mask, npilev, npjlev, 0 ,cdlonvar='lon', cdlatvar='lat'  )
    ierr  = createvar   (ncout ,  stypvarout, 1,      ipkout,    id_varout    )
    ierr  = putheadervar(ncout ,  'dummy', npilev, npjlev, 0 , pnavlon=rlonlev, pnavlat=rlatlev )

    dtim = getvar1d(cf_in, cn_vtimec, npt     )
    ierr = putvar1d(ncout, dtim,      npt, 'T')
    ierr = gettimeatt(cf_in, cn_vtimec, ctcalendar, cttitle, ctlong_name, ctaxis, ctunits, cttime_origin )
    ierr = puttimeatt(ncout, cn_vtimec, ctcalendar, cttitle, ctlong_name, ctaxis, ctunits, cttime_origin )
    ierr = putvar1d( ncout, rlonlev(:,1), npilev, 'X')
    ierr = putvar1d( ncout, rlatlev(1,:), npjlev, 'Y')

  END SUBROUTINE CreateOutput

END PROGRAM cdf2levitusgrid2d

PROGRAM cdfnrj_components
  !!======================================================================
  !!                     ***  PROGRAM  cdfnrj_components  ***
  !!=====================================================================
  !!  ** Purpose : Compute the terms for energy components
  !!               (Mean Kinetic Energy, Eddy Kinetic Energy,
  !!                Mean Potential Energy, Eddy Potential Energy )
  !!               compute : tbar, ubar, vbar, anotsqrt, anousqrt, anovsqrt
  !!
  !! History : 2.1  : 02/2008  : A. Melet     : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic. 
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class energy_diagnostics
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                            :: ji, jj, jk ,jt       ! dummy loop index
  INTEGER(KIND=4)                            :: npiglo, npjglo       ! domain size
  INTEGER(KIND=4)                            :: npk, npt             ! domain size
  INTEGER(KIND=4)                            :: narg, iargc, ijarg   ! browse line
  INTEGER(KIND=4)                            :: ierr                 ! error status
  INTEGER(KIND=4)                            :: ncout                ! ncid of output file
  INTEGER(KIND=4), DIMENSION(6)              :: ipk, id_varout       ! level and varid's of output var

  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE  :: un, vn, u2n, v2n
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE  :: tn, t2n, anotsqrt
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE  :: umask, vmask
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE  :: anousqrt, anovsqrt 

  REAL(KIND=8), DIMENSION(1)                 :: dtim                  ! time counter

  CHARACTER(LEN=256)                         :: cf_in                 ! input filename
  CHARACTER(LEN=256)                         :: cf_out='nrjcomp.nc'   ! output file name
  CHARACTER(LEN=256)                         :: cldum                 ! working char variable

  TYPE (variable), DIMENSION(6)              :: stypvar               ! structure for attibutes

  LOGICAL                                    :: lnc4 = .FALSE.        ! Use nc4 with chunking and deflation
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()
  !!
  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfnrj_components -f UVWT-file [-o OUT-file] [-nc4]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute contributing terms of the energy equation at T-points.'
     PRINT *,'       Input file contains mean values processed by cdfuvwt.' 
     PRINT *,'       The means must have been computed on long enough period for the'
     PRINT *,'       statistics to be meaningful.'
     PRINT *,'       Note : this program was formerly named cdfnrjcomp. It needs some'
     PRINT *,'       additional cleaning and revision. Use with care!'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -f UVWT-file: netcdf file produced by cdfuvwt.' 
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-o OUT-file]: specify output file name instead of ',TRIM(cf_out)
     PRINT *,'       [-nc4 ] : Use netcdf4 output with chunking and deflation level 1.'
     PRINT *,'             This option is effective only if cdftools are compiled with'
     PRINT *,'             a netcdf library supporting chunking and deflation.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       none'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         all variables are located at T point.'
     PRINT *,'         variables : tbar : mean temperature '
     PRINT *,'                     ubar : mean zonal velocity'
     PRINT *,'                     vbar : mean meridional velocity'
     PRINT *,'                     anotsqrt : mean squared temperature anomaly'
     PRINT *,'                     anousqrt : mean squared zonal velocity anomaly'
     PRINT *,'                     anovsqrt : mean squared meridional velocity anomaly'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'       cdfuvwt, cdfnrj_bti, cdfnrj_bci, cdfnrj_transfert but also'
     PRINT *,'       cdfeke, cdfmoy, cdfstdevt etc...'
     PRINT *,'      '
     STOP 
  ENDIF

  ijarg = 1 
  DO WHILE ( ijarg <= narg )
     CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-f'   ) ; CALL getarg(ijarg, cf_in ) ; ijarg=ijarg+1
        ! option
     CASE ( '-o'   ) ; CALL getarg(ijarg, cf_out) ; ijarg=ijarg+1
     CASE ( '-nc4' ) ; lnc4 = .TRUE.
     CASE DEFAULT    ; PRINT *, ' ERROR : ', TRIM(cldum),' : unknown option.'; STOP 99
     END SELECT
  ENDDO

  IF ( chkfile(cf_in) ) STOP 99 ! missing file

  npiglo = getdim(cf_in,cn_x)
  npjglo = getdim(cf_in,cn_y)
  npk    = getdim(cf_in,cn_z)
  npt    = getdim(cf_in,cn_t)

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  ! Allocate the memory
  ALLOCATE ( un(npiglo,npjglo), vn(npiglo,npjglo)  )
  ALLOCATE ( umask(npiglo,npjglo), vmask(npiglo,npjglo) )
  ALLOCATE ( u2n(npiglo,npjglo), v2n(npiglo,npjglo)  )
  ALLOCATE ( anousqrt(npiglo,npjglo), anovsqrt(npiglo,npjglo)  )
  ALLOCATE ( tn(npiglo,npjglo), t2n(npiglo,npjglo)  )
  ALLOCATE ( anotsqrt(npiglo,npjglo) )

  CALL CreateOutput

  DO jt =1, npt
     DO jk=1, npk
        PRINT *,'            level ',jk
        umask   (:,:) = 0.0
        vmask   (:,:) = 0.0
        anousqrt(:,:) = 0.0
        anovsqrt(:,:) = 0.0      
        anotsqrt(:,:) = 0.0

        ! JMM COMMENT : this program read data from one file and copy it to
        !               another one. Only the anomalies are computed.
        un(:,:)  = getvar(cf_in, 'ubar',  jk, npiglo, npjglo, ktime=jt)  ! U-point
        vn(:,:)  = getvar(cf_in, 'vbar',  jk, npiglo, npjglo, ktime=jt)  ! V-point
        tn(:,:)  = getvar(cf_in, 'tbar',  jk, npiglo, npjglo, ktime=jt)  ! T-point
        u2n(:,:) = getvar(cf_in, 'u2bar', jk, npiglo, npjglo, ktime=jt)  ! U-point
        v2n(:,:) = getvar(cf_in, 'v2bar', jk, npiglo, npjglo, ktime=jt)  ! V-point
        t2n(:,:) = getvar(cf_in, 't2bar', jk, npiglo, npjglo, ktime=jt)  ! T-point

        ! compute velocity  mask at T-point (??)
        !  JMM COMMENT : this will mask value in the first ocean point from the coast.
        DO jj = 2, npjglo
           DO ji = 2, npiglo
              umask(ji,jj) = un(ji,jj)*un(ji-1,jj) 
              vmask(ji,jj) = vn(ji,jj)*vn(ji,jj-1)
              IF (umask(ji,jj) /= 0.) umask(ji,jj)=1.
              IF (vmask(ji,jj) /= 0.) vmask(ji,jj)=1.
           ENDDO
        ENDDO

        DO jj = 2, npjglo  
           DO ji = 2, npiglo    ! vector opt.
              anotsqrt(ji,jj) = 1000. * ( t2n(ji,jj) - tn(ji,jj) * tn(ji,jj) )
              anousqrt(ji,jj) = 1000./2. * umask(ji,jj)*( ( u2n(ji,jj) - un(ji,jj)*un(ji,jj) ) &
                   &                     + ( u2n(ji-1,jj) - un(ji-1,jj)*un(ji-1,jj) ) )       

              anovsqrt(ji,jj) = 1000./2. * vmask(ji,jj)*( ( v2n(ji,jj) - vn(ji,jj)*vn(ji,jj) ) &
                   &                     + ( v2n(ji,jj-1) - vn(ji,jj)*vn(ji,jj-1) ) ) 
           END DO
        END DO
        ! 
        ierr = putvar(ncout, id_varout(1), tn,       jk, npiglo, npjglo, ktime=jt)
        ierr = putvar(ncout, id_varout(2), un,       jk, npiglo, npjglo, ktime=jt)
        ierr = putvar(ncout, id_varout(3), vn,       jk, npiglo, npjglo, ktime=jt)
        ierr = putvar(ncout, id_varout(4), anotsqrt, jk, npiglo, npjglo, ktime=jt)
        ierr = putvar(ncout, id_varout(5), anousqrt, jk, npiglo, npjglo, ktime=jt) 
        ierr = putvar(ncout, id_varout(6), anovsqrt, jk, npiglo, npjglo, ktime=jt)
     END DO
  ENDDO

  ierr = closeout(ncout)

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    ! define new variables for output 
    ipk(:)                 = npk  
    stypvar(1)%ichunk      = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(1)%cname       = 'tbar'
    stypvar(1)%clong_name  = 'temporal mean of the temperature on T point'
    stypvar(1)%cshort_name = 'tbar'

    stypvar(2)%ichunk      = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(2)%cname       = 'ubar'
    stypvar(2)%clong_name  = 'temporal mean of the zonal velocity on T point'
    stypvar(2)%cshort_name = 'ubar'

    stypvar(3)%ichunk      = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(3)%cname       = 'vbar'
    stypvar(3)%clong_name  = 'temporal mean of the meridional velocity on T point'
    stypvar(3)%cshort_name = 'vbar'

    stypvar(4)%ichunk      = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(4)%cname       = 'anotsqrt'
    stypvar(4)%clong_name  = 'temporal mean of the square of the temperature anomaly on T point (*1000)'
    stypvar(4)%cshort_name = 'anotsqrt'

    stypvar(5)%ichunk      = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(5)%cname       = 'anousqrt'
    stypvar(5)%clong_name  = 'temporal mean of the square of the zonal speed anomaly on T point (*1000)'
    stypvar(5)%cshort_name = 'anousqrt'

    stypvar(6)%ichunk      = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(6)%cname       = 'anovsqrt'
    stypvar(6)%clong_name  = 'temporal mean of the square of the meridional speed anomaly on T point (*1000)'
    stypvar(6)%cshort_name = 'anovsqrt'

    stypvar%cunits            = ' '
    stypvar%rmissing_value    = 0.
    stypvar%valid_min         = -1000.
    stypvar%valid_max         = 1000.
    stypvar%conline_operation = 'N/A'
    stypvar%caxis             = 'TZYX'

    ! create output fileset
    ncout = create      (cf_out, cf_in,   npiglo, npjglo, npk      , ld_nc4=lnc4 )
    ierr  = createvar   (ncout,  stypvar, 6,      ipk,    id_varout, ld_nc4=lnc4 )
    ierr  = putheadervar(ncout,  cf_in,   npiglo, npjglo, npk       )

    dtim = getvar1d(cf_in,cn_vtimec, npt     )
    ierr = putvar1d(ncout, dtim,     npt, 'T')

  END SUBROUTINE CreateOutput

END PROGRAM cdfnrj_components

PROGRAM cdfclip
  !!======================================================================
  !!                     ***  PROGRAM  cdfclip  ***
  !!=====================================================================
  !!  ** Purpose : An alternative to ncks to clip model file. It is 
  !!               usefull when the clipping area cross the E-W
  !!               periodic folding line. Additionally it does not
  !!               mess up the order of the dimensions and variables, 
  !!               which was a problem for coordinates.nc files with
  !!               IOIPSL
  !!
  !! History : 2.1  : 02/2007  : J.M. Molines : Original code
  !!           3.0  : 12/2010  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  !!
  USE cdfio 
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class file_operations
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                               :: jk, jt, jvar, jv        ! dummy loop index
  INTEGER(KIND=4)                               :: ik1, ik2, ik            !
  INTEGER(KIND=4)                               :: ierr                    ! working integer
  INTEGER(KIND=4)                               :: iimin, iimax            !
  INTEGER(KIND=4)                               :: ijmin, ijmax            !
  INTEGER(KIND=4)                               :: ikmin=-9999, ikmax=-9999  !
  INTEGER(KIND=4)                               :: narg, iargc, ijarg      ! 
  INTEGER(KIND=4)                               :: npiglo, npjglo, npk     !
  INTEGER(KIND=4)                               :: npkk, npt               ! size of the domain
  INTEGER(KIND=4)                               :: nvars                   ! Number of variables in a file
  INTEGER(KIND=4)                               :: ncout                   !
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: id_var                  ! arrays of var id's
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: ipk, ipkk               ! arrays of vertical level for each var
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: id_varout , ndim        !

  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: v2d, rlon, rlat         !
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: v2dxz, v2dyz, zxz, zyz  !
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: rdepg, rdep             !

  REAL(KIND=8), DIMENSION(:),       ALLOCATABLE :: dtim                     !

  CHARACTER(LEN=256)                            :: cf_in                   ! input file name
  CHARACTER(LEN=256)                            :: cf_out='cdfclip.nc'     ! output file name
  CHARACTER(LEN=256)                            :: cv_dep, cv_tim          ! depth and time variable names
  CHARACTER(LEN=255)                            :: cglobal                 ! global attribute to write on output file
  CHARACTER(LEN=256)                            :: cldum                   ! dummy character variable
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_names                ! array of var name

  TYPE (variable), DIMENSION(:),   ALLOCATABLE  :: stypvar                 !

  LOGICAL                                       :: lzonal=.FALSE.          !
  LOGICAL                                       :: lmeridian=.FALSE.       !
  LOGICAL                                       :: lnc4     = .FALSE.      ! Use nc4 with chunking and deflation
  !!-------------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfclip -f IN-file  -zoom imin imax jmin jmax ...'
     PRINT *,'            ...[-klim kmin kmax] [-o OUT-file] [-nc4]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Clips the input file according to the indices given in the zoom option.'
     PRINT *,'       If no vertical zoomed area is indicated, the whole water column is '
     PRINT *,'       considered.'
     PRINT *,'      '
     PRINT *,'       This program is able to extract data for a region crossing the E-W '
     PRINT *,'       periodic boundary of a global configuration. It does so if imax < imin.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -f IN-file : specify the input file to be clipped' 
     PRINT *,'       -zoom imin imax jmin jmax : specify the domain to be extracted.'
     PRINT *,'             If imin=imax, or jmin = jmax assume a vertical section either '
     PRINT *,'             meridional or zonal.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-o OUT-file ] : use OUT-file instead of ',TRIM(cf_out),' for output file'
     PRINT *,'       [-nc4 ] : Use netcdf4 output with chunking and deflation level 1.'
     PRINT *,'             This option is effective only if cdftools are compiled with'
     PRINT *,'             a netcdf library supporting chunking and deflation.'
     PRINT *,'       [-klim kmin kmax ] : specify vertical limits for the zoom, in order to '
     PRINT *,'             reduce the extracted area to some levels. Default is to take the' 
     PRINT *,'             while water column.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       none' 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out),' This can be changed using -o option'
     PRINT *,'         variables : same as input variables.'
     STOP 
  ENDIF
  !!
  ijarg=1 
  DO WHILE (ijarg <= narg )
     CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1
     SELECT CASE ( cldum)
     CASE ('-f'   ) ; CALL getarg(ijarg,cf_in ) ; ijarg = ijarg + 1 
     CASE ('-zoom') ; CALL getarg(ijarg,cldum ) ; ijarg = ijarg + 1 ; READ(cldum,*) iimin
        ;             CALL getarg(ijarg,cldum ) ; ijarg = ijarg + 1 ; READ(cldum,*) iimax
        ;             CALL getarg(ijarg,cldum ) ; ijarg = ijarg + 1 ; READ(cldum,*) ijmin
        ;             CALL getarg(ijarg,cldum ) ; ijarg = ijarg + 1 ; READ(cldum,*) ijmax
     CASE ('-klim') ; CALL getarg(ijarg,cldum ) ; ijarg = ijarg + 1 ; READ(cldum,*) ikmin
        ;             CALL getarg(ijarg,cldum ) ; ijarg = ijarg + 1 ; READ(cldum,*) ikmax
     CASE ('-o'   ) ; CALL getarg(ijarg,cf_out) ; ijarg = ijarg + 1 
     CASE ('-nc4' ) ; lnc4 = .TRUE.
     CASE DEFAULT   ; PRINT *,' ERROR : ', TRIM(cldum) ,' : unknwn option.';  STOP 99
     END SELECT
  ENDDO

  IF ( chkfile (cf_in ) ) STOP 99 ! missing file

  ! set global attribute for output file
  IF ( ikmin > 0 ) THEN
     WRITE(cglobal,'(a,a,a,6i5)') 'cdfclip -f ',TRIM(cf_in),' -zoom ',iimin,iimax,ijmin,ijmax, ikmin, ikmax
  ELSE
     WRITE(cglobal,'(a,a,a,4i5)') 'cdfclip -f ',TRIM(cf_in),' -zoom ',iimin,iimax,ijmin,ijmax
  ENDIF

  IF ( iimin == iimax ) THEN ; lmeridian=.TRUE.; PRINT *,' Meridional section ' ;
  ENDIF
  IF ( ijmin == ijmax ) THEN ; lzonal=.TRUE.   ; PRINT *,' Zonal section '      ;
  ENDIF

  IF (iimax < iimin ) THEN ! we assume that this is the case when we cross the periodic line in orca (Indian ocean)
     npiglo= getdim (cf_in,cn_x)
     npiglo=iimax+(npiglo-iimin) -1
  ELSE
     npiglo= iimax-iimin+1
  ENDIF

  npjglo= ijmax-ijmin+1

  ! look for possible name for vertical dim                       :
  npk   = getdim (cf_in,cn_z,cdtrue=cv_dep, kstatus=ierr)     ! depthxxx
  PRINT *,'ist',ierr,TRIM(cn_z)
  IF (ierr /= 0 ) THEN
     npk   = getdim (cf_in,'z',cdtrue=cv_dep,kstatus=ierr)       ! zxxx
     PRINT *,'ist',ierr,'z'
     IF (ierr /= 0 ) THEN
        npk   = getdim (cf_in,'sigma',cdtrue=cv_dep,kstatus=ierr) ! sigmaxxx
        PRINT *,'ist',ierr,'sigma'
        IF (ierr /= 0 ) THEN
           PRINT *,' assume file with no depth'
           IF ( ikmin > 0 ) THEN
              PRINT *,' You cannot specify limits on k level !' ; STOP 99
           ENDIF
           npk=0  ! means no dim level in file (implicitly 1 level)
        ENDIF
     ENDIF
  ENDIF

  ! replace flag value (-9999) by standard value (no ikmin ikmax specified = whole column)
  IF ( ikmin < 0 ) ikmin = 1
  IF ( ikmax < 0 ) ikmax = npk
  npkk = ikmax - ikmin +1   ! number of extracted levels. If no level in file, it is 0: 0 -1 + 1 !
  IF (npk == 0 ) ikmax = 1

  ! look for possible name for time dimension
  npt     = getdim(cf_in,cn_t, cdtrue=cv_tim, kstatus=ierr)
  IF ( ierr /= 0 ) THEN
     npt     = getdim(cf_in,'time', cdtrue=cv_tim, kstatus=ierr)
     IF ( ierr /= 0 ) THEN
        npt     = getdim(cf_in,'t', cdtrue=cv_tim, kstatus=ierr)
        IF ( ierr /= 0 ) THEN
           PRINT *, 'no time dimension found'
           npt=1
        ENDIF
     ENDIF
  ENDIF

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk ,' npkk  =', npkk
  PRINT *, 'npt    = ', npt

  IF (npkk > npk ) THEN
     PRINT *,' It seems that you want levels that are not represented '
     PRINT *,' in any of the variables that are in the file ',TRIM(cf_in)
     STOP 99
  ENDIF

  ALLOCATE( v2d(npiglo,npjglo),rlon(npiglo,npjglo), rlat(npiglo,npjglo), rdepg(npk) , rdep(npkk))
  ALLOCATE( zxz(npiglo,1), zyz(1,npjglo) )
  ALLOCATE( dtim(npt) )

  nvars = getnvar(cf_in)
  PRINT *,' nvars =', nvars

  ALLOCATE (cv_names(nvars), ndim(nvars) )
  ALLOCATE (stypvar(nvars))
  ALLOCATE (id_var(nvars), ipk(nvars), id_varout(nvars), ipkk(nvars))

  rlon =getvar(cf_in, cn_vlon2d, 1, npiglo, npjglo, kimin=iimin, kjmin=ijmin)  ! nav_lon
  rlat =getvar(cf_in, cn_vlat2d, 1, npiglo, npjglo, kimin=iimin, kjmin=ijmin)  ! nav_lat

  IF ( npk /= 0 ) THEN
     rdepg   = getvar1d(cf_in, cv_dep, npk)
     rdep(:) = rdepg(ikmin:ikmax)  
  ENDIF

  CALL CreateOutput

  DO jvar = 1,nvars
     ! skip dimension variables (already done when creating the output file)
     ik1=MAX(1,ikmin) ; ik2=ipk(jvar)
     SELECT CASE (cv_names(jvar) )
        !
     CASE ('none' )
        ! skip
     CASE DEFAULT
        IF ( lzonal ) THEN
           ALLOCATE( v2dxz(npiglo,ipk(jvar)) )
           DO jt=1,npt
              v2dxz=getvarxz(cf_in, cv_names(jvar), ijmin, npiglo, ipk(jvar), kimin=iimin, kkmin=1, ktime=jt)
              DO jk=ik1,ik2
                 ik = jk - ik1 + 1 
                 zxz(:,1) = v2dxz(:,jk)
                 ierr=putvar(ncout, id_varout(jvar), zxz, ik, npiglo, 1, ktime=jt)
              ENDDO
           ENDDO
           DEALLOCATE ( v2dxz )
        ELSEIF (lmeridian) THEN
           ALLOCATE(  v2dyz(npjglo,ipk(jvar)) )
           DO jt=1,npt
              v2dyz=getvaryz(cf_in, cv_names(jvar), iimin, npjglo, ipk(jvar), kjmin=ijmin, kkmin=1, ktime=jt)
              DO jk=ik1, ik2
                 ik = jk - ik1 + 1 
                 zyz(1,:) = v2dyz(:,jk)
                 ierr=putvar(ncout, id_varout(jvar), zyz, ik, 1, npjglo, ktime=jt)
              ENDDO
           ENDDO
           DEALLOCATE ( v2dyz )
        ELSE
           DO jt = 1, npt
              DO jk=ik1,ik2
                 ik = jk - ik1 + 1
                 v2d  = getvar(cf_in, cv_names(jvar),  jk,      npiglo, npjglo, kimin=iimin, kjmin=ijmin, ktime=jt)
                 ierr = putvar(ncout, id_varout(jvar), v2d, ik, npiglo, npjglo,                           ktime=jt)
              ENDDO
           ENDDO
        ENDIF
     END SELECT
  END DO ! loop to next var in file

  ierr = closeout(ncout)

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    ! get list of variable names and collect attributes in stypvar (optional)
    cv_names(:)=getvarname(cf_in, nvars, stypvar)

    ! save variable dimension in ndim
    !  1 = either time or depth : noclip
    !  2 = nav_lon, nav_lat
    !  3 = X,Y,T  or X,Y,Z   <-- need to fix the ambiguity ...
    !  4 = X,Y,Z,T
    DO jvar=1,nvars
       ndim(jvar) = getvdim(cf_in, cv_names(jvar)) + 1   !  we add 1 because vdim is dim - 1 ...
    END DO

    id_var(:)  = (/(jv, jv=1,nvars)/)

    ! ipk gives the number of level or 0 if not a T[Z]YX  variable
    ipk(:) = getipk (cf_in,nvars,cdep=cv_dep)
    ipk(:) = MIN ( ipk , ikmax )            ! reduce max depth to the required maximum
    ipkk(:)= MAX( 0 , ipk(:) - ikmin + 1 )  ! for output variable. For 2D input var, 
    ! ipkk is set to 0 if ikmin > 1 ... OK ? 
    WHERE( ipkk == 0 ) cv_names='none'
    stypvar(:)%cname = cv_names

    DO jv = 1, nvars
       stypvar(jv)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    ENDDO

    ! create output fileset
    ! create output file taking the sizes in cf_in
    ncout = create      (cf_out, cf_in,   npiglo, npjglo, npkk, cdep=cv_dep            , ld_nc4=lnc4)
    ierr  = createvar   (ncout,  stypvar, nvars,  ipkk,   id_varout, cdglobal=cglobal,   ld_nc4=lnc4)
    ierr  = putheadervar(ncout,  cf_in,   npiglo, npjglo, npkk, pnavlon=rlon, pnavlat=rlat, pdep=rdep, cdep=cv_dep)

    dtim = getvar1d(cf_in, cn_vtimec, npt     )
    ierr = putvar1d(ncout, dtim,      npt, 'T')
  END SUBROUTINE CreateOutput

END PROGRAM cdfclip

PROGRAM cdfdifmask
  !!======================================================================
  !!                     ***  PROGRAM  cdfdifmask  ***
  !!=====================================================================
  !!  ** Purpose : Build the difference between 2 mask files
  !!
  !!
  !! History : 2.1  : ??????   : ???          : Original code
  !!           3.0  : 12/2010  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2010, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                            :: jk, jvar               ! dummy loop index
  INTEGER(KIND=4)                            :: ierr                   ! working integer
  INTEGER(KIND=4)                            :: narg, iargc            ! browsing command line
  INTEGER(KIND=4)                            :: npiglo, npjglo, npk    ! size of the domain
  INTEGER(KIND=4)                            :: ncout                  ! ncid of output file
  INTEGER(KIND=4), DIMENSION(4)              :: ipk                    ! outptut variables : levels,
  INTEGER(KIND=4), DIMENSION(4)              :: id_varout              ! ncdf varid's

  REAL(KIND=4), DIMENSION (:,:), ALLOCATABLE :: zmask, zmask2          ! 2D mask at current level
  REAL(KIND=4), DIMENSION(:),    ALLOCATABLE :: tim                    ! dummy time variable

  CHARACTER(LEN=256)                         :: cf_out='mask_diff.nc'  ! Output file name
  CHARACTER(LEN=256)                         :: cf_msk1, cf_msk2       ! name of input files
  CHARACTER(LEN=256)                         :: cv_in                  ! variable name

  TYPE(variable), DIMENSION(4)               :: stypvar                ! data structure

  LOGICAL                                    :: lchk                   ! checking file existence
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfdifmask  mask1 mask2'
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the difference between 2 mask files.' 
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       mask1, mask2 : model files to be compared.' 
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        none'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'       variables : tmask, umask, vmask, fmask'
     STOP
  ENDIF
  CALL getarg (1, cf_msk1)
  CALL getarg (2, cf_msk2)

  lchk =           chkfile ( cf_msk1 )
  lchk = lchk .OR. chkfile ( cf_msk2 )
  IF ( lchk ) STOP ! missing file

  npiglo = getdim (cf_msk1, cn_x)
  npjglo = getdim (cf_msk1, cn_y)
  npk    = getdim (cf_msk1, 'z' )  ! mask file have a z depth dim instead of depth ...

  ipk(:) = npk
  stypvar(:)%cunits            = '1/0'
  stypvar(:)%rmissing_value    = 9999.
  stypvar(:)%valid_min         = 0.
  stypvar(:)%valid_max         = 1.
  stypvar(:)%conline_operation = 'N/A'
  stypvar(:)%caxis             = 'TZYX'
  stypvar(:)%cprecision        = 'by'

  stypvar(1)%cname='tmask' ;  stypvar(1)%clong_name='tmask' ;  stypvar(1)%cshort_name='tmask'
  stypvar(2)%cname='umask' ;  stypvar(2)%clong_name='umask' ;  stypvar(2)%cshort_name='umask'
  stypvar(3)%cname='vmask' ;  stypvar(3)%clong_name='vmask' ;  stypvar(3)%cshort_name='vmask'
  stypvar(4)%cname='fmask' ;  stypvar(4)%clong_name='fmask' ;  stypvar(4)%cshort_name='fmask'

  ncout = create      (cf_out, cf_msk1, npiglo, npjglo, npk,      cdep='z', cdepvar='nav_lev')
  ierr  = createvar   (ncout,  stypvar, 4,      ipk,    id_varout                            )
  ierr  = putheadervar(ncout,  cf_msk1, npiglo, npjglo, npk,      cdep='nav_lev'             )

  ALLOCATE (zmask(npiglo,npjglo), zmask2(npiglo,npjglo))

  DO jvar=1,4
     cv_in = stypvar(jvar)%cname
     PRINT *, ' making difference for ', TRIM(cv_in)
     DO jk=1, npk
        PRINT * ,'jk = ', jk
        zmask(:,:)  = getvar(cf_msk1, cv_in, jk, npiglo, npjglo)
        zmask2(:,:) = getvar(cf_msk2, cv_in, jk, npiglo, npjglo)
        zmask(:,:)  = zmask2(:,:) - zmask(:,:)
        ierr        = putvar(ncout, id_varout(jvar), zmask, jk, npiglo, npjglo)
     END DO  ! loop to next level
  END DO

  tim(:) = 0.
  ierr   = putvar1d(ncout, tim, 1, 'T')
  ierr   = closeout(ncout)

END PROGRAM cdfdifmask

PROGRAM cdfzisot
  !!======================================================================
  !!                     ***  PROGRAM  cdfzisot  ***
  !!=====================================================================
  !!  ** Purpose : Compute isothermal depth
  !!
  !!  ** Method  : - compute surface properties
  !!               - initialize depths and model levels number
  !!
  !! History : 3.0  : 07/2012  : F.Hernandez: Original code
  !!           
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2012, F. Hernandez
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4),PARAMETER                    :: pnvarout = 2   ! number of output variables
  INTEGER(KIND=4)                              :: ji, jj, jk, jt ! dummy loop index
  INTEGER(KIND=4)                              :: jref           ! dummy loop index
  INTEGER(KIND=4)                              :: narg, iargc, ii ! browse line
  INTEGER(KIND=4)                              :: npiglo, npjglo ! domain size
  INTEGER(KIND=4)                              :: npk, npt       ! domain size
  INTEGER(KIND=4)                              :: ncout, ierr    ! ncid of output file, error status
  INTEGER(KIND=4), DIMENSION(pnvarout)         :: ipk, id_varout ! levels and varid's of output vars
  INTEGER(KIND=4), DIMENSION(:,:), ALLOCATABLE :: mbathy         ! mbathy metric

  REAL(KIND=4)                                 :: rtref          ! reference temperature
  REAL(KIND=4)                                 :: rmisval        ! Missing value of temperature
  REAL(KIND=4), DIMENSION(:),      ALLOCATABLE :: gdept          ! depth of T levels
  REAL(KIND=4), DIMENSION(:),      ALLOCATABLE :: gdepw          ! depth of W levels
  REAL(KIND=4), DIMENSION(:),      ALLOCATABLE :: tim            ! time counter
  REAL(KIND=4), DIMENSION(1)                   :: rdep           ! dummy depth for output
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: rtem, rtemxz   ! temperature
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: tmask          ! temperature mask
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: glam,gphi      ! lon/lat
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: rzisot         ! depth of the isotherm
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: rzisotup       ! depth of the isotherm above
                                                                 ! in case of inversion

  CHARACTER(LEN=256)                           :: cf_tfil        ! input T file
  CHARACTER(LEN=256)                           :: cf_out='zisot.nc'! defaults output file name
  CHARACTER(LEN=256)                           :: cdum           ! dummy value

  TYPE(variable), DIMENSION(pnvarout)          :: stypvar        ! structure for output var. attributes
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg < 2 ) THEN
     PRINT *,' usage : cdfzisot T-file RefTemp [Output File]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute depth of an isotherm given as argument'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       T-file  : input netcdf file (gridT)' 
     PRINT *,'       RefTemp : Temperature of the isotherm.'
     PRINT *,'       Output File : netCDF Optional (defaults: zisot.nc)' 
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        ',TRIM(cn_fzgr)
     PRINT *,'         In case of FULL STEP configuration, ',TRIM(cn_fbathylev),' is also required.'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     STOP
  ENDIF

  ! get input gridT filename
  CALL getarg (1, cf_tfil)
  IF ( chkfile(cf_tfil) .OR. chkfile(cn_fzgr) ) STOP ! missing file

  ! get reference temperature
  CALL getarg (2, cdum)
  IF (INDEX(cdum,'.') == 0 ) THEN
     READ(cdum,'(I10)') ii
     rtref = float(ii)
  ELSE
     READ(cdum,'(f12.6)') rtref
     cdum=cdum( 1:INDEX(cdum,'.')-1 )//'_'//cdum( INDEX(cdum,'.')+1:LEN_TRIM(cdum) )
  ENDIF
  IF ( rtref > 50 .OR. rtref < -3. ) THEN
     PRINT*,'Sea Water temperature on Earth, not Pluton ! ',rtref
     STOP
  ENDIF

  ! get (optional) output file name
  IF ( narg == 3 ) CALL getarg (3, cf_out)
  PRINT*,TRIM(cf_out)

  ! read dimensions 
  npiglo = getdim (cf_tfil,cn_x)
  npjglo = getdim (cf_tfil,cn_y)
  npk    = getdim (cf_tfil,cn_z)
  npt    = getdim (cf_tfil,cn_t)
!!$  PRINT *, 'npiglo = ', npiglo
!!$  PRINT *, 'npjglo = ', npjglo
!!$  PRINT *, 'npk    = ', npk
!!$  PRINT *, 'npt    = ', npt


  ! define structure to write the computed isotherm depth
  rdep(1) = 0.
  ipk(:)                    = 1
  stypvar(1)%cname          = 'zisot'//TRIM(cdum)
  stypvar(2)%cname          = 'zisotup'//TRIM(cdum)
  stypvar%cunits            = 'm'
  stypvar%rmissing_value    = 32767.
  stypvar%valid_min         = 0.
  stypvar%valid_max         = 7000.
  stypvar(1)%clong_name     = 'Depth_of_'//TRIM(cdum)//'C_isotherm' 
  stypvar(2)%clong_name     = 'Depth_of_'//TRIM(cdum)//'C_upper_isotherm' 
  stypvar(1)%cshort_name    = 'D'//TRIM(cdum)
  stypvar(2)%cshort_name    = 'D'//TRIM(cdum)//'up'
  stypvar%conline_operation = 'N/A'
  stypvar%caxis             = 'TYX'


  ! dynamical allocations
  ALLOCATE (gdept(npk), gdepw(npk), tim(npt) )
  ALLOCATE (rtem(npiglo,npjglo), rtemxz(npiglo,npk) )
  ALLOCATE (tmask(npiglo,npjglo), glam(npiglo,npjglo), gphi(npiglo,npjglo) )
  ALLOCATE (rzisot(npiglo,npjglo) , rzisotup(npiglo,npjglo) )
  ALLOCATE (mbathy(npiglo,npjglo) )

  ! read metrics gdept and gdepw
  gdept(:)    = getvare3(cn_fzgr, cn_gdept, npk )
  gdepw(:)    = getvare3(cn_fzgr, cn_gdepw, npk)
  ! read "mbathy"
  mbathy(:,:) = getvar(cn_fzgr,      'mbathy',    1, npiglo, npjglo)

  ! get missing value of votemper
  rmisval = getatt(cf_tfil, cn_votemper, cn_missing_value )

  ! get longitude and latitude
  glam(:,:) = getvar(cf_tfil, cn_vlon2d, 1, npiglo, npjglo)
  gphi(:,:) = getvar(cf_tfil, cn_vlat2d, 1, npiglo, npjglo)


  ! initialize tmask: 1=valid / 0= no valid of SST
  tmask(:,:) = 1.
  rtem( :,:) = getvar(cf_tfil, cn_votemper, 1, npiglo, npjglo, ktime=1 )  
  WHERE ( rtem == rmisval ) tmask = 0.
  ! initialise matrix of results
  rzisot = 0. ; WHERE ( rtem == rmisval ) rzisot = rmisval
  rzisotup = 0. ; WHERE ( rtem == rmisval ) rzisotup = rmisval

  ! Create output file, based on existing input gridT file
  ncout = create      (cf_out, cf_tfil, npiglo, npjglo, 1           )
  ierr  = createvar   (ncout,  stypvar, pnvarout,      ipk,    id_varout   )
  ierr  = putheadervar(ncout,  cf_tfil, npiglo, npjglo, 1, pdep=rdep)

  tim  = getvar1d(cf_tfil, cn_vtimec, npt     )
  ierr = putvar1d(ncout,   tim,       npt, 'T')


  ! compute depth for the isotherm, loop first on time
  DO jt=1,npt

     ! then loop on Y axis
     DO jj = 1 , npjglo

        ! read temperature on x-z slab
        rtemxz(:,:) = getvarxz(cf_tfil, cn_votemper, jj, npiglo, npk, kimin=1, kkmin=1, ktime=jt )

        ! loop on X axis
        DO ji = 1, npiglo

           ! proceed to the depth of isotherm computation if mask = OK
           IF ( tmask(ji,jj) == 1 ) THEN
              IF ( COUNT( rtemxz(ji,:)>=rtref .AND. rtemxz(ji,:) .NE.rmisval ) > 0 ) THEN

                 jk = 1 ! count level down

                 ! take into account temperature inversion from the surface
                 IF ( rtemxz(ji,1)<rtref .AND. rtemxz(ji,1) .NE.rmisval ) THEN

                    ! search first level with T >= rtref
                    DO WHILE ( jk < npk .AND. rtemxz(ji,jk) < rtref .AND. rtemxz(ji,jk) .NE. rmisval )
                       jref = jk
                       jk = jk + 1
                    ENDDO

                    ! compute depth of the above isotherm
                    rzisotup(ji,jj) = ( gdept(jk-1)*( rtemxz(ji,jk)-rtref ) + &
                         & gdept(jk)*( rtref-rtemxz(ji,jk-1) ) ) / &
                         & ( rtemxz(ji,jk)-rtemxz(ji,jk-1) )

                    !write(12,*)ji,jj,glam(ji,jj),gphi(ji,jj),rzisotup(ji,jj)

                 ENDIF

                 ! then start from the first level with T >= rtref
                 ! and search first value below rtref
                 jref = 0
                 DO WHILE ( jk < npk .AND. rtemxz(ji,jk) > rtref .AND. rtemxz(ji,jk) .NE. rmisval )
                    jref = jk
                    jk = jk + 1
                 ENDDO

                 ! test if the level is the last "wet level" in model metrics
                 ! OR if next temperature value is missing
                 ! Or at the bottom
                 ! --> give value of the bottom of the layer: gdepw(k+1)
                 IF ( jref == mbathy(ji,jj) .OR. rtemxz(ji,jref+1) == rmisval .OR. jref == npk-1 ) THEN
                    rzisot(ji,jj) = gdepw(jref+1)
                 ELSE
                    rzisot(ji,jj) = ( gdept(jref)*( rtemxz(ji,jref+1)-rtref ) + &
                         & gdept(jref+1)*( rtref-rtemxz(ji,jref) ) ) / &
                         & ( rtemxz(ji,jref+1)-rtemxz(ji,jref) )
                 ENDIF
 
              ENDIF  ! COUNT( rtemxz(ji,:)>=rtref
           ENDIF  ! tmask(ji,jj) == 1

        ENDDO ! ji = 1, npiglo
     ENDDO ! jj = 1 , npjglo

     ! Store the zisot variable in output file
     ierr = putvar(ncout, id_varout(1), rzisot, 1, npiglo, npjglo, ktime=jt)
     ierr = putvar(ncout, id_varout(2), rzisotup, 1, npiglo, npjglo, ktime=jt)

  END DO ! time loop

  ierr = closeout(ncout)

END PROGRAM cdfzisot

PROGRAM cdfstatcoord
  !!======================================================================
  !!                     ***  PROGRAM  cdfstatcoord  ***
  !!=====================================================================
  !!  ** Purpose : Compute statistics about the grid metric versus latitude
  !!
  !!  ** Method  : bins e1 and e2 by latitudes and takes the mean value 
  !!               of each bin
  !!
  !! History : 2.1  : 07/2007  : J.M. Molines : Original code (T. Penduff idea)
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class statistics
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: narg, iargc,ijarg    ! browse lines
  INTEGER(KIND=4)                           :: npiglo, npjglo       ! size of the domain
  INTEGER(KIND=4)                           :: ngood                ! point counter

  REAL(KIND=4), PARAMETER                   :: pp_binsize=2.        ! bin size
  REAL(KIND=4), PARAMETER                   :: pp_latmin=-80.       ! minimum latitude
  REAL(KIND=4), PARAMETER                   :: pp_latmax=90.        ! maximum latitude
  REAL(KIND=4)                              :: rlat, rlat1, rlat2   ! working variables
  REAL(kind=4), DIMENSION(:,:), ALLOCATABLE :: e1, e2, gphi, zmask  ! metrics and mask

  REAL(KIND=8)                              :: de1mean, de2mean     ! mean value of horiz metrics

  CHARACTER(LEN=256)                        :: cf_coo, cf_msk       ! file names
  CHARACTER(LEN=256)                        :: cv_msk               ! mask variable name
  CHARACTER(LEN=256)                        :: cldum                ! mask variable name

  LOGICAL, DIMENSION(:,:), ALLOCATABLE      :: lgood                ! flag for point selection
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()
  cv_msk = cn_tmask

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfstatcoord -c COOR-file -m MSK-file [-v MSK-var ]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute and displays statistics about grid metrics vs latitude.'
     PRINT *,'       Bins e1 and e2 by latitude bins, and compute the mean of each bin.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -c COOR-file : coordinates file with e1 e2 metrics' 
     PRINT *,'       -m MSK-file  : mask file '
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-v MSK-var] : mask variable name. Default is ', TRIM(cv_msk) 
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       none apart those requested on command line.' 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       Standard output'
     STOP 
  ENDIF

  ijarg=1
  DO WHILE (ijarg <= narg )
     CALL getarg(ijarg, cldum) ; ijarg=ijarg+1
     SELECT CASE ( cldum ) 
     CASE ( '-c' ) ; CALL getarg (ijarg, cf_coo) ; ijarg=ijarg+1
     CASE ( '-m' ) ; CALL getarg (ijarg, cf_msk) ; ijarg=ijarg+1
     CASE ( '-v' ) ; CALL getarg (ijarg, cv_msk) ; ijarg=ijarg+1
     CASE DEFAULT  ; PRINT *,' ERROR : ',TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  ENDDO

  IF ( chkfile(cf_coo) .OR. chkfile(cf_msk) ) STOP 99 ! missing files

  npiglo= getdim (cf_coo, cn_x)
  npjglo= getdim (cf_coo, cn_y)

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo

  ALLOCATE ( e1(npiglo,npjglo)  , e2(npiglo,npjglo) )
  ALLOCATE ( gphi(npiglo,npjglo), zmask(npiglo,npjglo), lgood(npiglo,npjglo)  )

  ! read grid metrics and latitude
  e1   = getvar(cf_coo, cn_ve1t,  1, npiglo, npjglo)
  e2   = getvar(cf_coo, cn_ve2t,  1, npiglo, npjglo)
  gphi = getvar(cf_coo, cn_gphit, 1, npiglo, npjglo)
  ! read zmask (1)
  zmask = getvar(cf_msk, cv_msk,  1, npiglo, npjglo)

  rlat = pp_latmin + pp_binsize/2.
     PRINT '(a)', 'Latitude       e1mean         e2mean           e1/e2    npoints'
     PRINT '(a)', '-----------------------------------------------------------------'
  DO WHILE ( rlat <= pp_latmax ) 
     rlat1 = rlat - pp_binsize/2. ; rlat2 = rlat + pp_binsize/2.
     lgood = .FALSE.
     WHERE ( rlat1 <= gphi .AND. gphi < rlat2  .AND. zmask /= 0 )  lgood=.TRUE.
     ngood = COUNT(lgood)
     IF ( ngood /= 0 ) THEN 
        de1mean = SUM( e1, mask=lgood) / ngood  
        de2mean = SUM( e2, mask=lgood) / ngood
     ELSE
        de1mean = -999.
        de2mean = -999.
     ENDIF
     PRINT '(f8.3, 3f15.3,i8)', rlat, de1mean, de2mean ,de1mean/de2mean, ngood
     rlat = rlat + pp_binsize
  ENDDO

END PROGRAM cdfstatcoord

PROGRAM cdftransig_xy3d
  !!======================================================================
  !!                     ***  PROGRAM  cdftransig_xy3d  ***
  !!=====================================================================
  !!  ** Purpose : Calculates u and v transports at each grid cell
  !!               in rho coordinates.  produces a 3D field.
  !!
  !!  ** Method  : allow two 3D arrays for more efficient reading
  !!
  !! History : 2.1  : 02/2006  : A.M. Treguier : Original code
  !!           2.1  : 02/2011  : A.M. Treguier : Allow increased resolution in density
  !!                                             in deeper layers
  !!           3.0  : 06/2011  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE eos
  USE modcdfnames
  USE modutils      ! for SetFileName, SetGlobalAtt
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class transport
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                              :: ji, jj, jk         ! dummy loop index
  INTEGER(KIND=4)                              :: jt, jtag           ! dummy loop index
  INTEGER(KIND=4)                              :: it                 ! time index for vvl
  INTEGER(KIND=4)                              :: ijb   
  INTEGER(KIND=4)                              :: ierr               ! working integer
  INTEGER(KIND=4)                              :: narg, iargc        ! command line 
  INTEGER(KIND=4)                              :: ijarg, icur, istag
  INTEGER(KIND=4)                              :: iset
  INTEGER(KIND=4)                              :: npiglo, npjglo     ! size of the domain
  INTEGER(KIND=4)                              :: npk, npt           ! size of the domain
  INTEGER(KIND=4)                              :: nbins              ! density  bins
  INTEGER(KIND=4)                              :: ncout
  INTEGER(KIND=4)                              :: ntags, nframes
  INTEGER(KIND=4)                              :: nsigmax , ijtrans  ! dimension for itab, intermediate index
  INTEGER(KIND=4), DIMENSION(2)                :: id_varout , ipk    !
  INTEGER(KIND=4), DIMENSION(:),   ALLOCATABLE :: itab               ! look up table for density intervals
  INTEGER(KIND=4), DIMENSION(:,:), ALLOCATABLE :: ibinu, ibinv       ! integer value corresponding to density for binning

  REAL(KIND=4)                                 :: zpref              !  reference for density 
  REAL(KIND=4), DIMENSION(:),      ALLOCATABLE :: gdept              ! array for depth of T points  
  REAL(KIND=4), DIMENSION(:),      ALLOCATABLE :: e31d               ! vertical metric in case of full step
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: zmasku,zmaskv      !  masks x,1,nbins
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: e1v,  gphiv        !  2D x,y metrics, velocity
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: e2u                !  metrics, velocity
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: zt, zs, zv, e3v    !  x,1,z arrays metrics, velocity
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: zu, e3u            !  metrics, velocity
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: zdensu, zdensv     ! density on u and v points 

  REAL(KIND=8)                                 :: dsigtest
  REAL(KIND=8)                                 :: ds1min, ds1scal    !  min sigma and delta_sigma
  REAL(KIND=8)                                 :: ds1zoom = 999., ds1scalmin  !  min sigma for increased resolution
  REAL(KIND=8)                                 :: dtotal_time
  REAL(KIND=8), DIMENSION(1)                   :: dtimean
  REAL(KIND=8), DIMENSION(:),      ALLOCATABLE :: dtim
  REAL(KIND=8), DIMENSION(:),      ALLOCATABLE :: dsigma             ! density coordinate, center of bins
  REAL(KIND=8), DIMENSION(:),      ALLOCATABLE :: dsig_edge          ! density coordinate, edge of bins.
  REAL(KIND=8), DIMENSION(:,:),    ALLOCATABLE :: dens2d 
  REAL(KIND=8), DIMENSION(:,:,:),  ALLOCATABLE :: dusigsig,dvsigsig  ! cumulated transports,   

  CHARACTER(LEN=80 )                           :: cf_out='uvxysig.nc'
  CHARACTER(LEN=80 )                           :: cf_tfil
  CHARACTER(LEN=80 )                           :: cf_sfil
  CHARACTER(LEN=80 )                           :: cf_ufil
  CHARACTER(LEN=80 )                           :: cf_vfil
  CHARACTER(LEN=80 )                           :: cv_outu='vouxysig'
  CHARACTER(LEN=80 )                           :: cv_outv='vovxysig'
  CHARACTER(LEN=80 )                           :: config
  CHARACTER(LEN=80 )                           :: ctag 
  CHARACTER(LEN=80 )                           :: cldum
  CHARACTER(LEN=80 )                           :: cldepcode='1000'
  CHARACTER(LEN=256)                           :: cglobal
  CHARACTER(LEN=7  )                           :: clsigma 
  CHARACTER(LEN=80 ),DIMENSION(:), ALLOCATABLE :: ctag_lst

  TYPE (variable), DIMENSION(2)                :: stypvar     ! structure for attributes

  LOGICAL                                      :: lprint  = .FALSE.
  LOGICAL                                      :: lfull   = .FALSE.
  LOGICAL                                      :: lnotset = .FALSE.
  LOGICAL                                      :: lchk    = .FALSE.  ! flag for missing files
  LOGICAL                                      :: lperio  = .FALSE.  ! flag for periodicity
  LOGICAL                                      :: lnc4    = .FALSE.  ! flag for nc4 output
  LOGICAL                                      :: lsal    = .FALSE.  ! flag for salinity file
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()
  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdftransig_xy3d -c CONFIG-CASE -l LST-tags [-code code ] [-S] ...'
     PRINT *,'                    ... [-depref depref ] [ -nbins nbins ] ... ' 
     PRINT *,'                    ... [-sigmin smin s-scal] [-sigzoom sminr s-scalr ] ...'
     PRINT *,'                    ... [-full ] [-v ] [-vvl ] [-o OUT-file] [-nc4]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the time average volume transport at each grid cell in density'
     PRINT *,'       space, for the list of tags given as arguments. Results must be '
     PRINT *,'       condidered as intermediate for further integration.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -c CONFCASE  : a DRAKKAR CONFIG-CASE name '
     PRINT *,'       -l LST-tags : a blank-separated list of time tags to be processed.'
     PRINT *,'         If temperature and salinity not in same file use option -S '
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-S         ] : indicate that salinity file is to be taken in gridS files.'
     PRINT *,'       [-code code ] : code corresponds to pre-defined parameters settings '
     PRINT *,'              in term of reference depths, density limits for  binning, number'
     PRINT *,'               of bins, deeper layer refinement.'
     PRINT *,'          AVAILABLE code are :'
     PRINT *,'              _______________________________________________________________'
     PRINT *,'              code     |  depth_ref nbins   smin  s-scal  szoommin szoom-scal '
     PRINT *,'              ---------------------------------------------------------------'
     PRINT *,'                0      |    0      101     23.0    0.05                      '
     PRINT *,'              1000     |   1000     93     24.2    0.10   32.3     0.05      ' 
     PRINT *,'              1000-acc |   1000     88     24.5    0.10                      '
     PRINT *,'              2000     |   2000    174     29.0    0.05                      '
     PRINT *,'              none     |  parameters must be set individually                '
     PRINT *,'              ---------------------------------------------------------------'
     PRINT *,'          DEFAULT code is : ',TRIM(cldepcode)
     PRINT *,'              For other setting use the options to specify the settings'
     PRINT *,'              individually.'
     PRINT *,'       [-depref depref ] : give the depth reference for potential density'
     PRINT *,'       [-nbins nbins ] : give the number of density bins.'
     PRINT *,'       [-sigmin smin s-scal ] : give the minimum of density for binning and'
     PRINT *,'              the bin width.  ( take care of the reference depth).'
     PRINT *,'       [-sigzoom sminr s-scalr ] : allow density refinement from sminr, with'
     PRINT *,'              s-scalr bin width.'
     PRINT *,'       [-full ] : indicate a full step configuration.'
     PRINT *,'       [-v ] : verbose mode : extra print are performed during execution.'
     PRINT *,'       [-vvl ] : use time-varying vertical metrics.'
     PRINT *,'       [-o OUT-file ] : specify output file name instead of ',TRIM(cf_out)
     PRINT *,'       [-nc4 ] : Use netcdf4 output with chunking and deflation level 1.'
     PRINT *,'               This option is effective only if cdftools are compiled with'
     PRINT *,'               a netcdf library supporting chunking and deflation.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ',TRIM(cn_fhgr),' and ',TRIM(cn_fzgr) 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) ,' unless -o option is used.'
     PRINT *,'         variables : ',TRIM(cv_outu),' and ', TRIM(cv_outv),' in m3/s.'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'      cdfrhoproj, cdfsigtrp ' 
     PRINT *,'      '
     STOP 
  ENDIF

  ! browse command line according to options
  ijarg = 1 ;  iset = 0
  DO WHILE ( ijarg <= narg ) 
     CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-c'       ) ; CALL getarg(ijarg, config    ) ; ijarg=ijarg+1
     CASE ( '-l'       ) ; CALL GetTagList
     CASE ( '-code'    ) ; CALL getarg(ijarg, cldepcode ) ; ijarg=ijarg+1                            
     CASE ( '-depref'  ) ; CALL getarg(ijarg, cldum     ) ; ijarg=ijarg+1 ; READ(cldum,*) zpref       ; iset = iset+1
        ;                  WRITE(clsigma,'("sigma_",I1)'), NINT(zpref/1000.)
     CASE ( '-nbins'   ) ; CALL getarg(ijarg, cldum     ) ; ijarg=ijarg+1 ; READ(cldum,*) nbins      ; iset = iset+1
     CASE ( '-sigmin'  ) ; CALL getarg(ijarg, cldum     ) ; ijarg=ijarg+1 ; READ(cldum,*) ds1min
     CASE ( '-sigzoom' ) ; CALL getarg(ijarg, cldum     ) ; ijarg=ijarg+1 ; READ(cldum,*) ds1zoom    ; iset = iset+1
        ;                  CALL getarg(ijarg, cldum     ) ; ijarg=ijarg+1 ; READ(cldum,*) ds1scalmin
     CASE ( '-S'       ) ; lsal   = .TRUE.
     CASE ( '-full'    ) ; lfull  = .TRUE.
     CASE ( '-v'       ) ; lprint = .TRUE.
     CASE ( '-vvl'     ) ; lg_vvl = .TRUE. 
     CASE ( '-o'       ) ; CALL getarg(ijarg, cf_out    ) ; ijarg=ijarg+1 
     CASE ( '-nc4'     ) ; lnc4   = .TRUE.
     CASE DEFAULT        ; PRINT *,' ERROR : ', TRIM(cldum),' : unkown option.' ; STOP 99
     END SELECT
  ENDDO

  ! set parameters for pre-defined depcode
  SELECT CASE ( cldepcode )
  CASE ( '0'                    ) 
      zpref = 0.    ; nbins = 101 ; ds1min = 23.0d0 ; ds1scal = 0.03d0 ; ds1zoom = 999.d0 ; ds1scalmin = 999.d0 ; clsigma='sigma_0'
  CASE ( '1000'                 ) 
      zpref = 1000. ; nbins =  93 ; ds1min = 24.2d0 ; ds1scal = 0.10d0 ; ds1zoom = 32.3d0 ; ds1scalmin = 0.05d0 ; clsigma='sigma_1'
  CASE ( '1000-acc', '1000-ACC' ) 
      zpref = 1000. ; nbins =  88 ; ds1min = 24.5d0 ; ds1scal = 0.10d0 ; ds1zoom = 999.d0 ; ds1scalmin = 999.d0 ; clsigma='sigma_1'
  CASE ( '2000'                 ) 
      zpref = 2000. ; nbins = 174 ; ds1min = 29.0d0 ; ds1scal = 0.05d0 ; ds1zoom = 999.d0 ; ds1scalmin = 999.d0 ; clsigma='sigma_2'
  CASE ( 'none'                 ) 
      ! in this case check that all parameters are set individually
      IF ( iset /= 3  ) THEN  ; PRINT *, ' You must set depref, nbins, sigmin  individually'    ; STOP 99 
      ENDIF
  CASE DEFAULT                ; PRINT *, ' This depcode :',TRIM(cldepcode),' is not available.' ; STOP 99 
  END SELECT

  lchk = lchk .OR. chkfile (cn_fzgr)
  lchk = lchk .OR. chkfile (cn_fhgr)
  IF ( lchk ) STOP 99 ! missing files

  ds1scalmin = MIN ( ds1scalmin, ds1scal )
  IF ( lprint ) THEN
     PRINT *,' DEP REF  : ', zpref, ' m'
     PRINT *,' NBINS    : ', nbins
     PRINT *,' SIGMIN   : ', ds1min
     PRINT *,' SIGSTP   : ', ds1scal
     PRINT *,' SIGIN R  : ', ds1zoom
     PRINT *,' SIGSTP R : ', ds1scalmin
  ENDIF
  ! use first tag to look for file dimension
  ctag=ctag_lst(1)
  cf_vfil = SetFileName (config, ctag, 'V' )

  IF ( chkfile(cf_vfil) ) STOP 99 ! missing file

  npiglo = getdim (cf_vfil, cn_x)
  npjglo = getdim (cf_vfil, cn_y)
  npk    = getdim (cf_vfil, cn_z)

  ALLOCATE ( dsigma(nbins), dsig_edge(nbins+1) )
  ! define densities at middle of bins and edges of bins
  ijtrans = 0
  DO ji=1,nbins
     dsigtest  = ds1min +(ji-0.5)*ds1scal
     IF ( dsigtest > ds1zoom ) THEN
        IF ( ijtrans == 0 ) ijtrans = ji
        dsigma(ji) = ds1zoom + (ji-ijtrans+0.5)*ds1scalmin
     ELSE
        dsigma(ji) = dsigtest
     ENDIF
  ENDDO

  IF (lprint) PRINT *, ' min density:',dsigma(1), ' max density:', dsigma(nbins)
  IF (lprint) PRINT *, ' verify sigma:', dsigma

  dsig_edge(1) = ds1min
  DO ji=2,nbins 
     dsig_edge(ji) = 0.5* (dsigma(ji)+dsigma(ji-1))
  END DO
  dsig_edge(nbins+1) = dsig_edge(nbins) + ds1scalmin
  IF (lprint) PRINT *, ' sig_edge : ', dsig_edge
  !
  !  define a lookup table array so that the density can be binned according to 
  !  the smallest interval ds1scalmin
  nsigmax = NINT( (dsig_edge(nbins+1)-dsig_edge(1))/ds1scalmin ) !+1
  ALLOCATE ( itab(nsigmax))
  itab(:) = 0
  DO ji=1,nsigmax
     dsigtest = ds1min+ (ji-0.5) * ds1scalmin
     DO jj=1,nbins
        IF ( dsigtest > dsig_edge(jj) .AND. dsigtest <= dsig_edge(jj+1) ) THEN
           itab(ji) = jj
        ENDIF
     END DO
  ENDDO
  IF (lprint) PRINT *, ' nsigmax=' , nsigmax
  IF (lprint) PRINT *, ' verify itab:', itab

  ! define new variables for output ( must update att.txt)
  ! define output variables
  CALL SetGlobalAtt(cglobal)

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'nbins  = ', nbins

  ! Allocate arrays
  ALLOCATE ( zv (npiglo,npjglo), zu (npiglo,npjglo) )
  ALLOCATE ( zt (npiglo,npjglo), zs (npiglo,npjglo) )
  ALLOCATE ( e3v(npiglo,npjglo), e3u(npiglo,npjglo) )
  ALLOCATE ( ibinu(npiglo, npjglo), ibinv(npiglo, npjglo) )
  ALLOCATE ( e1v(npiglo,npjglo), gphiv(npiglo,npjglo), gdept(npk) )
  ALLOCATE ( e2u(npiglo,npjglo) )
  ALLOCATE ( zdensu(npiglo,npjglo), zdensv(npiglo,npjglo) )
  ALLOCATE ( zmasku(npiglo,npjglo), zmaskv(npiglo,npjglo))
  ALLOCATE ( dusigsig(npiglo,npjglo,nbins), dvsigsig(npiglo,npjglo,nbins))  ! huge as nbins can be > 100
  ALLOCATE ( dens2d(npiglo,npjglo) )

  e1v(:,:)   = getvar  (cn_fhgr, cn_ve1v,  1, npiglo, npjglo) 
  e2u(:,:)   = getvar  (cn_fhgr, cn_ve2u,  1, npiglo, npjglo) 
  gphiv(:,:) = getvar  (cn_fhgr, cn_gphiv, 1, npiglo, npjglo)
  gdept(:)   = getvare3(cn_fzgr, cn_gdept, npk              )

  ! look for  E-W periodicity (using zu for temporary array
  zu(:,:)    = getvar  (cn_fhgr, cn_glamv, 1, npiglo, npjglo)
  IF ( zu(1,1) == zu(npiglo-1,1) ) lperio = .TRUE.

  IF ( lfull ) THEN 
     ALLOCATE ( e31d(npk) )
     e31d(:)  = getvare3(cn_fzgr, cn_ve3t1d, npk              )
  ENDIF

  CALL CreateOutput

  dtotal_time = 0.d0

  ! initialize transport to 0
  dusigsig (:,:,:) = 0.d0 ; dvsigsig (:,:,:) = 0.d0;
  !    loop on time and depth ---------------------------------------------------
  ! 
  DO jk= 1, npk-1
     IF ( lprint ) PRINT *, ' working on depth jk=',jk

     nframes = 0
     DO jtag = 1, ntags
        ctag = ctag_lst(jtag)
        IF (lprint   ) PRINT *, ' working on  ctag=',TRIM(ctag)
        cf_tfil = SetFileName(config, ctag, 'T') 
        IF ( lsal ) THEN 
           cf_sfil = SetFileName(config, ctag, 'S')
        ELSE
           cf_sfil = cf_tfil
        ENDIF
        cf_ufil = SetFileName(config, ctag, 'U')
        cf_vfil = SetFileName(config, ctag, 'V')

        IF ( lg_vvl ) THEN
          cn_fe3u = cf_ufil
          cn_fe3v = cf_vfil
          cn_ve3u = cn_ve3uvvl
          cn_ve3v = cn_ve3vvvl
        ENDIF

        ! check existence of files
        lchk =           chkfile ( cf_tfil) 
        lchk = lchk .OR. chkfile ( cf_sfil) 
        lchk = lchk .OR. chkfile ( cf_ufil) 
        lchk = lchk .OR. chkfile ( cf_vfil) 
        IF ( lg_vvl ) lchk = lchk .OR. chkfile ( cf_vfil) 
        IF ( lchk ) STOP 99 ! missing file
        
        IF (jk== 1 ) THEN
           npt = getdim (cf_tfil, cn_t)  ! assuming all files (U V ) contains same number of time frame
           ALLOCATE ( dtim(npt) )
           dtim        = getvar1d(cf_tfil, cn_vtimec, npt )
           dtotal_time = dtotal_time + SUM(dtim )
           DEALLOCATE ( dtim )
        ENDIF

        DO jt = 1, npt
           IF ( lg_vvl ) THEN ; it=jt
           ELSE               ; it=1
           ENDIF
           IF ( it == jt ) THEN ! read e3 at each time step ( vvl case)
             IF ( lfull ) THEN 
               e3v(:,:) = e31d(jk)
               e3u(:,:) = e31d(jk)
             ELSE
               e3v(:,:) = getvar(cn_fe3v, cn_ve3v, jk, npiglo,npjglo, ktime=it, ldiom=.NOT.lg_vvl )
               e3u(:,:) = getvar(cn_fe3u, cn_ve3u, jk, npiglo,npjglo ,ktime=it, ldiom=.NOT.lg_vvl)
            ENDIF
          ENDIF
           nframes = nframes + 1
           ! Get velocities u, v  and mask   if first time slot only 
           zv(:,:)= getvar ( cf_vfil, cn_vomecrty, jk, npiglo, npjglo, ktime=jt )
           zu(:,:)= getvar ( cf_ufil, cn_vozocrtx, jk, npiglo, npjglo, ktime=jt)
           IF (jtag == 1) THEN 
              zmasku(:,:)= 1; zmaskv(:,:)= 1.0 ;
              WHERE( zu == 0) zmasku(:,:)= 0.0 ;
              WHERE( zv == 0) zmaskv(:,:)= 0.0 ;
              IF (lprint  ) PRINT *, ' min,max u:',MINVAL(zu),MAXVAL(zu)
           ENDIF
           !                     density  
           zt(:,:)= getvar ( cf_tfil, cn_votemper, jk, npiglo, npjglo, ktime=jt )
           zs(:,:)= getvar ( cf_sfil, cn_vosaline, jk, npiglo, npjglo, ktime=jt )

           IF ( zpref == 0. ) THEN
              dens2d = sigma0(zt, zs,       npiglo, npjglo)
           ELSE
              dens2d = sigmai(zt, zs, zpref, npiglo, npjglo)
           ENDIF

           !  density on u points masked by u  , single precision 
           zdensu(1:npiglo-1,:) = 0.5*( dens2d(1:npiglo-1,:) + dens2d(2:npiglo,:))

           ! check for periodic EW condition
           IF ( lperio ) THEN ; zdensu(npiglo,:)     = zdensu(2,:)
           ELSE               ; zdensu(npiglo,:) = 0.
           ENDIF

           zdensu(:,:) = zdensu(:,:) * zmasku(:,:)

           !  density on v points masked by v  , single precision
           zdensv(:,1:npjglo-1) = 0.5*( dens2d(:,1:npjglo-1) + dens2d(:,2:npjglo) )
           zdensv(:,:) = zdensv(:,:) * zmaskv(:,:)

           !  bins density - bins based on dens2d 
           DO jj=1,npjglo
              DO ji=1,npiglo
                 ijb   = INT( (zdensu(ji,jj) - ds1min)/ds1scalmin )+1
                 ijb   = MAX( ijb ,1   )
                 ijb   = MIN( ijb,nsigmax)
                 ibinu(ji,jj) = itab (ijb)
                 ijb   = INT( (zdensv(ji,jj) - ds1min)/ds1scalmin )+1
                 ijb   = MAX( ijb ,1   )
                 ijb   = MIN( ijb,nsigmax)
                 ibinv(ji,jj) =  itab(ijb)
              ENDDO
           ENDDO
           zu(:,:) = zu(:,:)*e3u(:,:)
           zv(:,:) = zv(:,:)*e3v(:,:)
           DO jj=1,npjglo
              DO ji=1,npiglo
                 dusigsig(ji,jj,ibinu(ji,jj)) = dusigsig(ji,jj,ibinu(ji,jj))+ e2u(ji,jj)*zu(ji,jj)*1.d0
                 dvsigsig(ji,jj,ibinv(ji,jj)) = dvsigsig(ji,jj,ibinv(ji,jj))+ e1v(ji,jj)*zv(ji,jj)*1.d0            
              END DO
           END DO
        END DO  ! end of loop on file time frame
        !  -----------------------------------------end of loop on ctags
     END DO
     !           
     ! -----------------  end of loop on jk
  END DO

  dtimean(1) = dtotal_time/nframes
  ierr      = putvar1d(ncout, dtimean, 1, 'T')
  DO jk=1, nbins
     zt   = dusigsig(:,:,jk) / nframes
     ierr = putvar (ncout, id_varout(1), zt, jk, npiglo, npjglo, kwght=nframes)
  ENDDO
  DO jk=1, nbins
     zt   = dvsigsig(:,:,jk) / nframes
     ierr = putvar (ncout, id_varout(2), zt, jk, npiglo, npjglo, kwght=nframes)
  ENDDO
  ierr = closeout(ncout)

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
  ipk(:)                    = nbins   ! output file has  nbins sigma values
  stypvar%cunits            = 'm3/s'  ! transports
  stypvar%rmissing_value    = 0.
  stypvar%valid_min         = -10.    ! seem to be small
  stypvar%valid_max         = 10.
  stypvar%conline_operation = 'N/A'
  stypvar%caxis             = 'TSYX'

  stypvar(1)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
  stypvar(2)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)

  stypvar(1)%cname          = cv_outu                ;    stypvar(2)%cname       = cv_outv
  stypvar(1)%clong_name     = 'Zonal_trsp_sig_coord' ;    stypvar(2)%clong_name  = 'Meridional_trsp_sig_coord'
  stypvar(1)%cshort_name    = cv_outu                ;    stypvar(2)%cshort_name = cv_outv

  ! create output fileset
  IF (lprint) PRINT *, ' ready to create file:',TRIM( cf_out), ' from reference:',TRIM(cf_vfil )

  ncout = create      (cf_out, cf_vfil, npiglo, npjglo, nbins,    cdep=clsigma           , ld_nc4=lnc4  )
  ierr  = createvar   (ncout,  stypvar, 2,      ipk,    id_varout, cdglobal=TRIM(cglobal), ld_nc4=lnc4  )
  ierr  = putheadervar(ncout,  cf_vfil, npiglo, npjglo, nbins,     pdep=REAL(dsigma)      )

  END SUBROUTINE CreateOutput

  SUBROUTINE GetTagList
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE GetTagList  ***
    !!
    !! ** Purpose :  Set up a tag list given on the command line as 
    !!               blank separated list
    !!
    !! ** Method  :  Scan the command line until a '-' is found
    !!----------------------------------------------------------------------
    INTEGER (KIND=4)  :: ji
    INTEGER (KIND=4)  :: icur
    !!----------------------------------------------------------------------
    !!
    ntags=0
    ! need to read a list of file ( number unknow ) 
    ! loop on argument till a '-' is found as first char
    icur=ijarg                          ! save current position of argument number
    DO ji = icur, narg                  ! scan arguments till - found
       CALL getarg ( ji, cldum )
       IF ( cldum(1:1) /= '-' ) THEN ; ntags = ntags+1
       ELSE                          ; EXIT
       ENDIF
    ENDDO
    ALLOCATE (ctag_lst(ntags) )
    DO ji = icur, icur + ntags -1
       CALL getarg(ji, ctag_lst( ji -icur +1 ) ) ; ijarg=ijarg+1
    END DO
  END SUBROUTINE GetTagList

END PROGRAM cdftransig_xy3d

   

PROGRAM cdfmocsig
  !!======================================================================
  !!                     ***  PROGRAM  cdfmocsig  ***
  !!=====================================================================
  !!  ** Purpose : Compute the Meridional Overturning Cell (MOC)
  !!               using density bins. 
  !!
  !!  ** Method  : The MOC is computed from the V velocity field, collected in density bins,
  !!               (reference depth is given as the 3rd argument) and integrated
  !!               throughout the density bins, then zonally averaged with
  !!               eventual masking for oceanic basins.
  !!               In the present version the masking corresponds to the global
  !!               configuration. MOC for Global, Atlantic, Indo-Pacific, Indian,Pacific ocean
  !!               Results are saved on mocsig.nc file with variables name respectively
  !!               zomsfglo, zomsfatl, zomsfinp, zomsfind, zomsfpac.
  !!               If no new_maskglo.nc file found, then the mask.nc file is used and
  !!               only zomsfglo is computed.

  !!
  !! History : 2.1  : 11/2005  : A.M. Treguier : Original code from cdfmoc
  !!                : 03/2010  : C. Dufour     : Choice of depth reference
  !!                                             improvements 
  !!           3.0  : 04/2011  : J.M. Molines  : Doctor norm + Lic.
  !!           3.0  : 06/2013  : J.M. Molines  : add neutral density
  !!           3.0  : 06/2013  : J.M. Molines  : add bin mean depth calculation and OpenMp directives
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE eos
  USE modcdfnames
  USE modutils
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class transport
  !!----------------------------------------------------------------------
  IMPLICIT NONE
  INTEGER(KIND=2), DIMENSION (:,:,:), ALLOCATABLE ::  ibmask              ! nbasins x npiglo x npjglo
  INTEGER(KIND=2), DIMENSION (:,:),   ALLOCATABLE ::  itmask              ! tmask from salinity field

  INTEGER(KIND=4)                                 :: jbasin, jj, jk       ! dummy loop index
  INTEGER(KIND=4)                                 :: ji, jt, jbin         ! dummy loop index
  INTEGER(KIND=4)                                 :: it                   ! time index for vvl
  INTEGER(KIND=4)                                 :: nbins                ! number of  density  bins
  INTEGER(KIND=4)                                 :: npglo, npatl, npinp  ! basins index (mnemonics)
  INTEGER(KIND=4)                                 :: npind, nppac         !  "      "
  INTEGER(KIND=4)                                 :: nbasins              ! number of basins
  INTEGER(KIND=4)                                 :: ierr                 ! working integer
  INTEGER(KIND=4)                                 :: narg, iargc, iarg    ! command line  browsing 
  INTEGER(KIND=4)                                 :: ijarg, ii            !  "             "
  INTEGER(KIND=4)                                 :: ib                   ! current bin number
  INTEGER(KIND=4)                                 :: ij1, ij2             ! current J index
  INTEGER(KIND=4)                                 :: npiglo,npjglo        ! size of the domain
  INTEGER(KIND=4)                                 :: npk, npt             ! size of the domain
  INTEGER(KIND=4)                                 :: ncout                ! ncid of output file
  INTEGER(KIND=4)                                 :: nvaro                ! number of output variables
  INTEGER(KIND=4), DIMENSION(2)                   :: iloc                 ! working array
  INTEGER(KIND=4), DIMENSION(:),      ALLOCATABLE :: ipk, id_varout       ! output variable levels and id
  INTEGER(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: ibin                 ! remaping density in bin number

  REAL(KIND=4), PARAMETER                         :: rp_spval=99999.      !
  REAL(KIND=4)                                    :: pref=0.              ! depth reference for pot. density 
  REAL(KIND=4)                                    :: sigmin               ! minimum density for bining
  REAL(KIND=4)                                    :: sigstp               ! density step for bining
  REAL(KIND=4)                                    :: zsps                 ! Salinity Missing value
  REAL(KIND=4)                                    :: zspt                 ! Temperature Missing value
  REAL(KIND=4)                                    :: zspv                 ! Merid. Vel.  Missing value
  REAL(KIND=4), DIMENSION (:),        ALLOCATABLE :: sigma                ! density coordinate 
  REAL(KIND=4), DIMENSION (:),        ALLOCATABLE :: e31d                 ! vertical level (full step)
  REAL(KIND=4), DIMENSION (:),        ALLOCATABLE :: gdep                 ! depth of T layers ( full step)
  REAL(KIND=4), DIMENSION (:,:),      ALLOCATABLE :: e1v, gphiv           ! horizontal metrics, latitude
  REAL(KIND=4), DIMENSION (:,:),      ALLOCATABLE :: zt, zs               ! temperature, salinity
  REAL(KIND=4), DIMENSION (:,:),      ALLOCATABLE :: zv, zveiv            ! velocity and bolus velocity
  REAL(KIND=4), DIMENSION (:,:),      ALLOCATABLE :: e3v                  ! vertical metrics
  REAL(KIND=4), DIMENSION (:,:),      ALLOCATABLE :: rdumlon              ! dummy longitude = 0.
  REAL(KIND=4), DIMENSION (:,:),      ALLOCATABLE :: rdumlat              ! latitude for i = north pole
  REAL(KIND=4), DIMENSION (:,:),      ALLOCATABLE :: zttmp                ! arrays to call sigmai and mask it
  REAL(KIND=4), DIMENSION (:,:),      ALLOCATABLE :: zarea                ! product e1v * e3v

  REAL(KIND=8), DIMENSION (:),        ALLOCATABLE :: dtim                 ! time counter
  REAL(KIND=8), DIMENSION(:,:),       ALLOCATABLE :: dens                 ! density
  REAL(KIND=8), DIMENSION(:,:),       ALLOCATABLE :: dmoc_tmp             ! temporary transport array
  REAL(KIND=8), DIMENSION(:,:),       ALLOCATABLE :: depi_tmp             ! temporary cumulated depth array
  REAL(KIND=8), DIMENSION(:,:),       ALLOCATABLE :: wdep_tmp             ! temporary count array
  REAL(KIND=8), DIMENSION(:,:,:),     ALLOCATABLE :: dmoc                 ! nbasins x npjglo x npk
  REAL(KIND=8), DIMENSION(:,:,:),     ALLOCATABLE :: depi                 ! Zonal mean of depths of isopycnal
  REAL(KIND=8), DIMENSION(:,:,:),     ALLOCATABLE :: wdep                 ! count array

  CHARACTER(LEN=256)                              :: cf_vfil              ! meridional velocity file
  CHARACTER(LEN=256)                              :: cf_tfil              ! temperature/salinity file
  CHARACTER(LEN=256)                              :: cf_sfil              ! salinity file (option)
  CHARACTER(LEN=256)                              :: cf_moc='mocsig.nc'   ! output file
  CHARACTER(LEN=255)                              :: cglobal              ! Global attribute
  CHARACTER(LEN=256)                              :: cldum                ! dummy char variable

  TYPE(variable), DIMENSION(:), ALLOCATABLE       :: stypvar              ! output var properties

  LOGICAL, DIMENSION(3)                           :: lbin                 ! flag for bin specifications
  LOGICAL                                         :: lntr                 ! flag for neutral density
  LOGICAL                                         :: lbas   = .FALSE.     ! flag for basins file
  LOGICAL                                         :: lisodep= .FALSE.     ! flag for isopycnal zonal mean
  LOGICAL                                         :: lprint = .FALSE.     ! flag for extra print
  LOGICAL                                         :: leiv   = .FALSE.     ! flag for Eddy Induced Velocity (GM)
  LOGICAL                                         :: lfull  = .FALSE.     ! flag for full step
  LOGICAL                                         :: lchk   = .FALSE.     ! flag for missing file
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfmocsig  -v V-file -t T-file -r REF-depth | -ntr [-eiv] [-full] ...'
     PRINT *,'        ... [-sigmin sigmin] [-sigstp sigstp] [-nbins nbins] [-isodep] ...'
     PRINT *,'        ... [-s S-file ] [-o OUT-file] [-vvl] [-verbose]'
     PRINT *,'      '
     PRINT *,'     PURPOSE : '
     PRINT *,'       Compute the MOC in density-latitude coordinates. The global value is '
     PRINT *,'       always computed. Values for oceanic sub-basins are calculated if the '
     PRINT *,'       ', TRIM(cn_fbasins), ' file is provided.'
     PRINT *,'      '
     PRINT *,'       The reference depth for potential density is given with ''-D'' option.'
     PRINT *,'       Density ranges and number of bins to use are pre-defined only for three'
     PRINT *,'       reference depth (0, 1000 and 2000 m). For other reference depth, the '
     PRINT *,'       density binning must be specified using the relevant options for setting'
     PRINT *,'       the minimum density, the density step and the number of bins to use.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'        -v V-file  : Netcdf gridV file.'
     PRINT *,'        -t T-file  : Netcdf gridT file with temperature and salinity.'
     PRINT *,'             If salinity not in T-file use -s option.'
     PRINT *,'        -r ref-depth : reference depth for density. '
     PRINT *,'            For depth values of 0 1000 or 2000 m, pre-defined limits for '
     PRINT *,'            minimum density, number of density bins and width of density '
     PRINT *,'            bins are provided. For other reference depth, you must use the'
     PRINT *,'            options ''-sigmin'', ''-sigstp'' and ''-nbins'' (see below).'
     PRINT *,'        or '
     PRINT *,'        -ntr : uses neutral density (no default bin defined so far), no ''-r'''
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-s S-file   ] : Specify salinity file if not T-file.'
     PRINT *,'       [-eiv ] : takes into account VEIV Meridional eddy induced velocity.'
     PRINT *,'                 -> To be used only if Gent and McWilliams parameterization '
     PRINT *,'                    has been used. '
     PRINT *,'       [-full       ] : Works with full step instead of standard partial steps.'
     PRINT *,'       [-sigmin     ] : Specify minimum of density for bining.'
     PRINT *,'       [-sigstp     ] : Specify density step for bining.'
     PRINT *,'       [-nbins      ] : Specify the number of density bins you want.'
     PRINT *,'       [-isodep     ] : Compute the zonal mean of isopycnal depths used for '
     PRINT *,'                        mocsig.'
     PRINT *,'       [-o OUT-file ] : Specify output file name instead of ', TRIM(cf_moc)
     PRINT *,'       [-vvl        ] : Use time-varying vertical metrics.'
     PRINT *,'       [-verbose    ] : Verbose option for more info during execution.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        Files ', TRIM(cn_fzgr),', ',TRIM(cn_fhgr),', ', TRIM(cn_fmsk)
     PRINT *,'        File ', TRIM(cn_fbasins),' is optional [sub basins masks]'
     PRINT *,'      '
     PRINT *,'     OPENMP SUPPORT : yes '
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_moc) 
     PRINT *,'       variables ',TRIM( cn_zomsfglo),' : Global ocean '
     PRINT *,'       variables ',TRIM( cn_zomsfatl),' : Atlantic Ocean '
     PRINT *,'       variables ',TRIM( cn_zomsfinp),' : Indo Pacific '
     PRINT *,'       variables ',TRIM( cn_zomsfind),' : Indian Ocean alone'
     PRINT *,'       variables ',TRIM( cn_zomsfpac),' : Pacific Ocean alone'
     PRINT *,'       If file ',TRIM(cn_fbasins),' is not present, ',TRIM(cn_fmsk),' file is used and'
     PRINT *,'       only ',TRIM( cn_zomsfglo),' is produced.'
     PRINT *,'       If option -isodep is used, each MOC variable is complemented by a iso'
     PRINT *,'       variable, giving the zonal mean of ispycnal depth (e.g.',TRIM(cn_zoisoglo),').'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'       cdfmoc '
     PRINT *,'      '
     STOP 
  ENDIF

  cglobal = 'Partial step computation'
  lbin=(/.TRUE.,.TRUE.,.TRUE./)
  ijarg = 1 ; ii = 0 ! ii is used to count mandatory arguments
  cf_sfil = 'none'
  DO WHILE ( ijarg <= narg )
     CALL getarg (ijarg, cldum) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-v'     ) ;  CALL getarg (ijarg, cf_vfil) ; ijarg=ijarg+1 ; ii=ii+1
     CASE ( '-t'     ) ;  CALL getarg (ijarg, cf_tfil) ; ijarg=ijarg+1 ; ii=ii+1
     CASE ( '-r'     ) ;  CALL getarg (ijarg, cldum  ) ; ijarg=ijarg+1 ; ii=ii+1 ; READ(cldum,*) pref
     CASE ( '-ntr'   ) ;  lntr = .TRUE. ; ii=ii+1
        ! options
     CASE ( '-s'     ) ;  CALL getarg (ijarg, cf_sfil) ; ijarg=ijarg+1 
     CASE ('-full'   ) ; lfull   = .TRUE. ; cglobal = 'Full step computation'
     CASE ('-eiv'    ) ; leiv    = .TRUE.
     CASE ('-sigmin' ) ; CALL getarg (ijarg, cldum ) ; ijarg=ijarg+1 ; READ(cldum,*) sigmin ; lbin(1) = .FALSE.
     CASE ('-nbins'  ) ; CALL getarg (ijarg, cldum ) ; ijarg=ijarg+1 ; READ(cldum,*) nbins  ; lbin(2) = .FALSE.
     CASE ('-sigstp' ) ; CALL getarg (ijarg, cldum ) ; ijarg=ijarg+1 ; READ(cldum,*) sigstp ; lbin(3) = .FALSE.
     CASE ('-o'      ) ; CALL getarg (ijarg, cf_moc) ; ijarg=ijarg+1 
     CASE ('-vvl'    ) ; lg_vvl  = .TRUE.
     CASE ('-isodep' ) ; lisodep = .TRUE.
     CASE ('-verbose') ; lprint  = .TRUE.
     CASE DEFAULT     ; PRINT *,' ERROR : ',TRIM(cldum), ' : unknown option.'  ; STOP 99
     END SELECT
  END DO

  IF ( ii /= 3  ) THEN ; PRINT *,' ERROR : mandatory arguments missing, see usage please !'  ; STOP 99
  ENDIF

  IF ( cf_sfil == 'none' ) cf_sfil=cf_tfil

  ! check file existence
  lchk = lchk .OR. chkfile ( cn_fhgr )
  lchk = lchk .OR. chkfile ( cn_fzgr )
  lchk = lchk .OR. chkfile ( cn_fmsk )
  lchk = lchk .OR. chkfile ( cf_vfil )
  lchk = lchk .OR. chkfile ( cf_tfil )
  lchk = lchk .OR. chkfile ( cf_sfil )
  IF ( lchk ) STOP 99  ! missing file(s)

  ! Look for salinity spval
  zsps = getspval(cf_sfil, cn_vosaline)
  zspt = getspval(cf_tfil, cn_votemper)
  zspv = getspval(cf_vfil, cn_vomecrty)

  IF ( lg_vvl )  THEN
     cn_fe3v = cf_vfil
     cn_ve3v = cn_ve3vvvl
  ENDIF

  ! re-use lchk for binning control : TRUE if no particular binning specified
  lchk = lbin(1) .OR. lbin(2) .OR. lbin(3) 

  npiglo = getdim (cf_vfil,cn_x)
  npjglo = getdim (cf_vfil,cn_y)
  npk    = getdim (cf_vfil,cn_z)
  npt    = getdim (cf_vfil,cn_t)

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  !setting up the building command in global attribute
  CALL SetGlobalAtt(cglobal, 'A')  ! append command name to global attribute

  !  Detects newmaskglo file
  lbas = .NOT. chkfile (cn_fbasins )

  IF (lbas) THEN ; nbasins = 5
  ELSE           ; nbasins = 1
  ENDIF

  IF ( lisodep ) THEN ; nvaro = 2 * nbasins
  ELSE                ; nvaro =     nbasins
  ENDIF

  ALLOCATE ( stypvar(nvaro), ipk(nvaro), id_varout(nvaro) )

  IF ( lchk )  THEN  ! use default bins definition according to pref 
     ! Define density parameters
     IF ( lntr) THEN   ! to be confirmed ( note that sigmantr returns values > 1000 kg/m3)
        nbins  = 52
        sigmin = 1023.
        sigstp = 0.1
     ELSE
        SELECT CASE ( INT(pref) )
        CASE ( 0 )
           nbins  = 52
           sigmin = 23.
           sigstp = 0.1
        CASE ( 1000 )
           nbins  = 88
           sigmin = 24.
           sigstp = 0.1
        CASE ( 2000)
           nbins  = 158
           sigmin = 30.
           sigstp = 0.05
        CASE DEFAULT
           PRINT *,' This value of depth_ref (',pref,') is not implemented as standard'
           PRINT *,' You must use the -sigmin, -sigstp and -nbins options to precise'
           PRINT *,' the density bining you want to use.'
           STOP 99
        END SELECT
     ENDIF
  ENDIF

  IF (lntr ) THEN  ; PRINT '(a       )',           '  For Neutral density MOC'
  ELSE             ; PRINT '(a,f6.1,a)',           '  For reference depth ', pref, ' m, '
  ENDIF
  PRINT '(a,f5.2,a,f5.2,a,i3)', '  You are using -sigmin ', sigmin,' -sigstp ', sigstp,' -nbins ', nbins

  ALLOCATE ( sigma(nbins) )  

  ! define densities at middle of bins
  DO ji=1,nbins
     sigma(ji)  = sigmin +(ji-0.5)*sigstp
  ENDDO
  IF (lprint) PRINT *, ' min density:',sigma(1), ' max density:', sigma(nbins)

  ! Allocate arrays
  ALLOCATE ( ibmask(nbasins,npiglo,npjglo) )
  ALLOCATE ( zv (npiglo,npjglo), zt(npiglo,npjglo), zs(npiglo,npjglo), zarea(npiglo, npjglo) )
  ALLOCATE ( e3v(npiglo,npjglo) )
  ALLOCATE ( ibin(npiglo, npjglo) )
  ALLOCATE ( e1v(npiglo,npjglo), gphiv(npiglo,npjglo) )
  ALLOCATE ( dmoc(nvaro, nbins, npjglo ) )
  ALLOCATE ( rdumlon(1,npjglo) , rdumlat(1,npjglo))
  ALLOCATE ( dens(npiglo,npjglo))
  ALLOCATE ( itmask(npiglo,npjglo), zttmp(npiglo,npjglo))
  ALLOCATE ( dtim(npt), e31d(npk)  )

  IF ( lisodep) THEN 
     ALLOCATE ( depi(nvaro, nbins, npjglo), gdep(npk))
     ALLOCATE ( wdep(nvaro, nbins, npjglo)           )
  ENDIF
  IF ( leiv   ) ALLOCATE ( zveiv (npiglo,npjglo))

  e1v(:,:)   = getvar(cn_fhgr,   cn_ve1v,  1, npiglo, npjglo) 

  IF ( lfull  ) e31d(:) = getvare3(cn_fzgr, cn_ve3t1d,  npk )
  IF ( lisodep) gdep(:) = -getvare3(cn_fzgr, cn_gdept, npk )  ! take negative value
  ! to be compliant with zonal mean

  IF ( npjglo > 1 ) THEN 
     gphiv(:,:)   = getvar(cn_fhgr, cn_gphiv, 1, npiglo, npjglo)
     iloc         = MAXLOC(gphiv)
     rdumlat(1,:) = gphiv(iloc(1),:)
  ELSE
     rdumlat(1,:) = 0.
  ENDIF
  rdumlon(:,:) = 0.               ! set the dummy longitude to 0

  ! create output fileset
  !global   ; Atlantic  ; Indo-Pacif ; Indian  ; Pacif
  npglo= 1  ; npatl=2   ;  npinp=3   ; npind=4 ; nppac=5

  CALL CreateOutputFile

  ! reading the masks
  ibmask(npglo,:,:) = getvar(cn_fmsk, cn_vmask, 1, npiglo, npjglo)

  IF ( lbas ) THEN
     ibmask(npatl,:,:) = getvar(cn_fbasins, cn_tmaskatl, 1, npiglo, npjglo)
     ibmask(npind,:,:) = getvar(cn_fbasins, cn_tmaskind, 1, npiglo, npjglo)
     ibmask(nppac,:,:) = getvar(cn_fbasins, cn_tmaskpac, 1, npiglo, npjglo)
     ibmask(npinp,:,:) = ibmask(nppac,:,:) + ibmask(npind,:,:)
     ! ensure that there are no overlapping on the masks
     WHERE(ibmask(npinp,:,:) > 0 ) ibmask(npinp,:,:) = 1
     ! change global mask for GLOBAL periodic condition
     ibmask(1,1,     :) = 0.
     ibmask(1,npiglo,:) = 0.
  ENDIF

  DO jt=1, npt
     IF ( lg_vvl ) THEN ; it=jt
     ELSE               ; it=1
     ENDIF
     ! initialize moc to 0
     dmoc(:,:,:) = 0.d0 
     IF ( lisodep ) THEN ; depi(:,:,:) = 0.d0 ; wdep(:,:,:) = 0.d0
     ENDIF

     DO jk=1,npk-1
        !               for testing purposes only loop from 2 to 400
        IF (lprint) PRINT *,' working at depth ',jk
        ! Get velocities v at jj
        zv(:,:) = getvar(cf_vfil, cn_vomecrty, jk, npiglo, npjglo, ktime = jt)
        WHERE( zv == zspv ) zv = 0.
        IF ( leiv ) THEN
           zveiv(:,:) = getvar(cf_vfil, cn_vomeeivv, jk, npiglo,npjglo, ktime = jt)
           zv(:,:)    = zv(:,:) + zveiv(:,:)
        END IF
        ! JMM remark : should be more correct to use t and s a V point ?
        zt(:,:) = getvar(cf_tfil, cn_votemper, jk, npiglo, npjglo, ktime = jt)
        zs(:,:) = getvar(cf_sfil, cn_vosaline, jk, npiglo, npjglo, ktime = jt)
        WHERE( zt == zspt ) zt = 0.
        WHERE( zs == zsps ) zs = 0.

        ! get e3v at latitude jj
        IF ( lfull ) THEN ; e3v(:,:) = e31d(jk)
        ELSE              ; e3v(:,:) = getvar(cn_fe3v, cn_ve3v, jk, npiglo, npjglo, ktime=it, ldiom=.NOT.lg_vvl )
        ENDIF
        zarea(:,:) = e1v(:,:) * e3v(:,:)
        !
        !  finds density 
        itmask =  1
        WHERE ( zs == zsps ) itmask = 0
        IF ( lntr ) THEN ; dens  = sigmantr(zt, zs,       npiglo, npjglo)
        ELSE             ; dens  = sigmai  (zt, zs, pref, npiglo, npjglo)
        ENDIF

        zttmp = dens* itmask ! convert to single precision 
        ! find bin numbers
        ibin(:,:) = INT( (zttmp-sigmin)/sigstp )
        ibin(:,:) = MAX( ibin(:,:), 1    )
        ibin(:,:) = MIN( ibin(:,:), nbins)

        IF ( npjglo > 1 ) THEN ; ij1 = 2 ; ij2 = npjglo-1
        ELSE                   ; ij1 = 1 ; ij2 = 1        ! input file has only one j ( case of extracted broken lines) 
        ENDIF
        !$OMP PARALLEL  PRIVATE(dmoc_tmp,depi_tmp,wdep_tmp, ib)
        ALLOCATE ( dmoc_tmp(nbins,npiglo) )
        IF ( lisodep ) ALLOCATE ( depi_tmp(nbins,npiglo) )
        IF ( lisodep ) ALLOCATE ( wdep_tmp(nbins,npiglo) )
        IF ( lprint ) PRINT *, ' Entering main J loop '
        !$OMP DO SCHEDULE(RUNTIME)
        DO jj= ij1, ij2
           dmoc_tmp = 0.d0 
           !  converts transport in "k" to transport in "sigma"
           !  indirect adresssing - do it once and not for each basin!
           DO ji=2,npiglo-1
              ib = ibin(ji,jj)
              dmoc_tmp(ib,ji) = dmoc_tmp(ib,ji) - zv(ji,jj)*zarea(ji,jj)
           END DO

           IF ( lisodep ) THEN
              depi_tmp = 0.d0 ; wdep_tmp = 0.d0 ! wdep(:,:) = 0
              DO ji=2,npiglo-1
                 ib = ibin(ji,jj)
                 depi_tmp(ib,ji) = depi_tmp(ib,ji) + gdep(jk) * itmask(ji,jj)*zarea(ji,jj)
                 wdep_tmp(ib,ji) = wdep_tmp(ib,ji) +            itmask(ji,jj)*zarea(ji,jj)  ! total weight
              END DO
           ENDIF
           ! integrates 'zonally' (along i-coordinate) 
           ! add to dmoc the contributions from level jk  at all densities jbin

           !          IF ( lprint ) PRINT *, ' Entering main bin loop ', jj,ij2
           DO jbasin= 1, nbasins
              DO jbin =1,nbins  
                 DO ji=2,npiglo-1
                    ! For all basins 
                    dmoc(jbasin,jbin,jj)=dmoc(jbasin,jbin,jj) + dmoc_tmp(jbin,ji) * ibmask(jbasin,ji,jj)
                 ENDDO
              END DO
           END DO

           IF ( lisodep) THEN
              DO jbasin= 1, nbasins
                 DO jbin =1,nbins
                    DO ji=2,npiglo-1
                       depi(jbasin,jbin,jj)=depi(jbasin,jbin,jj) + depi_tmp(jbin,ji) * ibmask(jbasin,ji,jj)
                       wdep(jbasin,jbin,jj)=wdep(jbasin,jbin,jj) + wdep_tmp(jbin,ji) * ibmask(jbasin,ji,jj)
                    ENDDO
                 END DO
              END DO

           ENDIF
        END DO  ! end of loop on latitude for filling dmoc
        !$OMP END DO
        DEALLOCATE (dmoc_tmp)
        IF ( lisodep ) DEALLOCATE (depi_tmp)
        IF ( lisodep ) DEALLOCATE (wdep_tmp)
        !$OMP END PARALLEL
     END DO     ! end of loop on depths for calculating transports     

     IF ( lisodep ) THEN
        WHERE ( wdep(:,:,:) /= 0.d0 ) 
           depi(:,:,:) = depi(:,:,:) / wdep (:,:,:)
        ELSEWHERE
           depi(:,:,:) = rp_spval
        END WHERE
     ENDIF

     ! integrates across bins from highest to lowest density
     dmoc(:,nbins,:) = dmoc(:,nbins,:)/1.e6
     DO jbin=nbins-1, 1, -1
        dmoc(:,jbin,:) = dmoc(:,jbin+1,:) + dmoc(:,jbin,:)/1.e6
     END DO  ! loop to next bin

     ! netcdf output  
     DO jbasin = 1, nbasins
        DO jbin = 1, nbins
           ierr = putvar (ncout, id_varout(jbasin        ), REAL(dmoc(jbasin,jbin,:)), jbin, 1, npjglo, ktime = jt)
           IF (lisodep ) ierr = putvar (ncout, id_varout(jbasin+nbasins), REAL(depi(jbasin,jbin,:)), jbin, 1, npjglo, ktime = jt)
        END DO
     END DO

  ENDDO  ! time loop

  ierr = closeout(ncout)

CONTAINS

  SUBROUTINE CreateOutputFile
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutputFile ***
    !!
    !! ** Purpose :  Initialize and create output files 
    !!
    !! ** Method  :  Check the number of sub_basin, and options 
    !!
    !!----------------------------------------------------------------------

    ! Common to all variables :
    stypvar%cunits            = 'Sverdrup'
    stypvar%rmissing_value    = rp_spval
    stypvar%valid_min         = -1000.
    stypvar%valid_max         =  1000.
    stypvar%scale_factor      = 1.
    stypvar%add_offset        = 0.
    stypvar%savelog10         = 0.
    stypvar%conline_operation = 'N/A'
    stypvar%caxis             = 'TZY'

    ipk(:) = nbins

    ! Global basin
    stypvar(npglo)%cname       = cn_zomsfglo
    stypvar(npglo)%clong_name  = 'Meridional_Overt.Cell_Global'
    stypvar(npglo)%cshort_name = cn_zomsfglo

    IF (lbas) THEN
       stypvar(npatl)%cname       = cn_zomsfatl
       stypvar(npatl)%clong_name  = 'Meridional_Overt.Cell_Atlantic'
       stypvar(npatl)%cshort_name = cn_zomsfatl

       stypvar(npinp)%cname       = cn_zomsfinp
       stypvar(npinp)%clong_name  = 'Meridional_Overt.Cell_IndoPacif'
       stypvar(npinp)%cshort_name = cn_zomsfinp

       stypvar(npind)%cname       = cn_zomsfind
       stypvar(npind)%clong_name  = 'Meridional_Overt.Cell_Indian'
       stypvar(npind)%cshort_name = cn_zomsfind

       stypvar(nppac)%cname       = cn_zomsfpac
       stypvar(nppac)%clong_name  = 'Meridional_Overt.Cell_pacif'
       stypvar(nppac)%cshort_name = cn_zomsfpac
    ENDIF

    IF ( lisodep ) THEN
       ! Global basin
       stypvar(npglo+nbasins)%cunits      = 'm'
       stypvar(npglo+nbasins)%cname       = cn_zoisoglo
       stypvar(npglo+nbasins)%clong_name  = 'Zonal_mean_isopycnal_depth_Global'
       stypvar(npglo+nbasins)%cshort_name = cn_zoisoglo
       stypvar(npglo+nbasins)%valid_min   = 0.
       stypvar(npglo+nbasins)%valid_max   = 8000.
       IF ( lbas ) THEN
          stypvar(npatl+nbasins)%cunits      = 'm'
          stypvar(npatl+nbasins)%cname       = cn_zoisoatl
          stypvar(npatl+nbasins)%clong_name  = 'Zonal_mean_isopycnal_depth_Atlantic'
          stypvar(npatl+nbasins)%cshort_name = cn_zoisoatl
          stypvar(npatl+nbasins)%valid_min   = 0.
          stypvar(npatl+nbasins)%valid_max   = 8000.

          stypvar(npinp+nbasins)%cunits      = 'm'
          stypvar(npinp+nbasins)%cname       = cn_zoisoinp
          stypvar(npinp+nbasins)%clong_name  = 'Zonal_mean_isopycnal_depth_IndoPacif'
          stypvar(npinp+nbasins)%cshort_name = cn_zoisoinp
          stypvar(npinp+nbasins)%valid_min   = 0.
          stypvar(npinp+nbasins)%valid_max   = 8000.

          stypvar(npind+nbasins)%cunits      = 'm'
          stypvar(npind+nbasins)%cname       = cn_zoisoind
          stypvar(npind+nbasins)%clong_name  = 'Zonal_mean_isopycnal_depth_Indian'
          stypvar(npind+nbasins)%cshort_name = cn_zoisoind
          stypvar(npind+nbasins)%valid_min   = 0.
          stypvar(npind+nbasins)%valid_max   = 8000.

          stypvar(nppac+nbasins)%cunits      = 'm'
          stypvar(nppac+nbasins)%cname       = cn_zoisopac
          stypvar(nppac+nbasins)%clong_name  = 'Zonal_mean_isopycnal_depth_pacif'
          stypvar(nppac+nbasins)%cshort_name = cn_zoisopac
          stypvar(nppac+nbasins)%valid_min   = 0.
          stypvar(nppac+nbasins)%valid_max   = 8000.
       ENDIF
    ENDIF

    ncout = create      (cf_moc, 'none', 1,      npjglo, nbins,  cdep='sigma')
    ierr  = createvar   (ncout,  stypvar, nvaro, ipk ,id_varout, cdglobal=cglobal)
    ierr  = putheadervar(ncout,  cf_vfil, 1,     npjglo, nbins,  pnavlon=rdumlon, pnavlat=rdumlat, pdep=sigma)

    dtim = getvar1d(cf_vfil, cn_vtimec, npt     )
    ierr = putvar1d(ncout,  dtim,       npt, 'T')

  END SUBROUTINE CreateOutputFile

END PROGRAM cdfmocsig
   

PROGRAM cdfgeo_uv
  !!======================================================================
  !!                     ***  PROGRAM  cdfgeo_uv  ***
  !!=====================================================================
  !!  ** Purpose : Compute the ug and vg component of the geostrophic 
  !!               velocity from the SSH field
  !!
  !!  ** Method  : ug = -g/f * d(ssh)/dy
  !!               vg =  g/f * d(ssh)/dx
  !!
  !!  **  Note : ug is located on a V grid point
  !!             vg                 U grid point
  !!
  !!
  !! History : 2.1  : 02/2008  : J. Juanno    : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic. and bug fix
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: ji, jj, jt     ! dummy loop index
  INTEGER(KIND=4)                           :: npiglo, npjglo ! size of the domain
  INTEGER(KIND=4)                           :: npk, npt       ! size of the domain
  INTEGER(KIND=4)                           :: narg, iargc    ! browse line
  INTEGER(KIND=4)                           :: ncoutu         ! ncid for ugeo file
  INTEGER(KIND=4)                           :: ncoutv         ! ncid for vgeo file
  INTEGER(KIND=4)                           :: ierr           ! error status
  INTEGER(KIND=4), DIMENSION(1)             :: ipk            ! levels of output vars
  INTEGER(KIND=4), DIMENSION(1)             :: id_varoutu     ! varid for ugeo
  INTEGER(KIND=4), DIMENSION(1)             :: id_varoutv     ! varid for vgeo

  REAL(KIND=4)                              :: grav           ! gravity
  REAL(KIND=4)                              :: ffu, ffv       ! coriolis param f at U and V point
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: tim            ! time counter
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e1u, e2v, ff   ! horiz metrics, coriolis (f-point)
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: glamu, gphiu   ! longitude latitude u-point
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: glamv, gphiv   ! longitude latitude v-point
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: un, vn         ! velocity components
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zsshn          ! ssh
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: umask, vmask   ! mask at u and v points

  CHARACTER(LEN=256)                        :: cf_tfil        ! input file name
  CHARACTER(LEN=256)                        :: cf_uout='ugeo.nc' 
  CHARACTER(LEN=256)                        :: cf_vout='vgeo.nc'

  TYPE(variable), DIMENSION(1)              :: stypvaru       ! attributes for ugeo
  TYPE(variable), DIMENSION(1)              :: stypvarv       ! attributes for vgeo

  LOGICAL                                   :: lchk           ! file existence flag
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  grav = 9.81  ! gravity

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfgeo-uv T-file'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the geostrophic velocity component from the gradient '
     PRINT *,'       of the SSH read in the input file. Note that in the C-grid '
     PRINT *,'       output file, the zonal component is located on V point and the'
     PRINT *,'       meridional component is located on U point.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       T-file : netcdf file with SSH.' 
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        ',TRIM(cn_fhgr),' and ',TRIM(cn_fzgr)
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       - netcdf file : ', TRIM(cf_uout) 
     PRINT *,'           variables : ', TRIM(cn_vozocrtx)
     PRINT *,'             *** CAUTION:  this variable is located on V-point ***'
     PRINT *,'       - netcdf file : ', TRIM(cf_vout) 
     PRINT *,'           variables : ', TRIM(cn_vomecrty)
     PRINT *,'             *** CAUTION:  this variable is located on U-point ***'
     STOP
  ENDIF

  CALL getarg(1, cf_tfil)

  lchk = chkfile(cn_fhgr)
  lchk = chkfile(cn_fzgr) .OR. lchk
  lchk = chkfile(cf_tfil) .OR. lchk
  IF ( lchk ) STOP ! missing file

  npiglo = getdim(cf_tfil, cn_x)
  npjglo = getdim(cf_tfil, cn_y)
  npk    = getdim(cf_tfil, cn_z) 
  npt    = getdim(cf_tfil, cn_t) 

 PRINT *, ' NPIGLO= ', npiglo
 PRINT *, ' NPJGLO= ', npjglo
 PRINT *, ' NPK   = ', npk
 PRINT *, ' NPT   = ', npt

  ipk(1)                        = 1
  stypvaru(1)%cname             = TRIM(cn_vozocrtx)
  stypvaru(1)%cunits            = 'm/s'
  stypvaru(1)%rmissing_value    = 0.
  stypvaru(1)%valid_min         = 0.
  stypvaru(1)%valid_max         = 20.
  stypvaru(1)%clong_name        = 'Zonal_Geostrophic_Velocity'
  stypvaru(1)%cshort_name       = TRIM(cn_vozocrtx)
  stypvaru(1)%conline_operation = 'N/A'
  stypvaru(1)%caxis             = 'TYX'

  stypvarv(1)%cname             = TRIM(cn_vomecrty)
  stypvarv(1)%cunits            = 'm/s'
  stypvarv(1)%rmissing_value    = 0.
  stypvarv(1)%valid_min         = 0.
  stypvarv(1)%valid_max         = 20.
  stypvarv(1)%clong_name        = 'Meridional_Geostrophic_Velocity'
  stypvarv(1)%cshort_name       = TRIM(cn_vomecrty)
  stypvarv(1)%conline_operation = 'N/A'
  stypvarv(1)%caxis             = 'TYX'

  ! Allocate the memory
  ALLOCATE ( e1u(npiglo,npjglo), e2v(npiglo,npjglo) )
  ALLOCATE ( ff(npiglo,npjglo), tim(npt)  )
  ALLOCATE ( glamu(npiglo,npjglo), gphiu(npiglo,npjglo)  )
  ALLOCATE ( glamv(npiglo,npjglo), gphiv(npiglo,npjglo)  )
  ALLOCATE ( un(npiglo,npjglo), vn(npiglo,npjglo)  )
  ALLOCATE ( zsshn(npiglo,npjglo) )
  ALLOCATE ( umask(npiglo,npjglo), vmask(npiglo,npjglo) )

  ! Read the metrics from the mesh_hgr file
  e2v   = getvar(cn_fhgr, cn_ve2v,  1, npiglo, npjglo)
  e1u   = getvar(cn_fhgr, cn_ve1u,  1, npiglo, npjglo)
  ff    = getvar(cn_fhgr, cn_vff,   1, npiglo, npjglo) 

  glamu = getvar(cn_fhgr, cn_glamu, 1, npiglo, npjglo)
  gphiu = getvar(cn_fhgr, cn_gphiu, 1, npiglo, npjglo)
  glamv = getvar(cn_fhgr, cn_glamv, 1, npiglo, npjglo)
  gphiv = getvar(cn_fhgr, cn_gphiv, 1, npiglo, npjglo)

  ! create output filesets
  ! U geo  ! @ V-point !
  ncoutu = create      (cf_uout, cf_tfil,  npiglo, npjglo, 0                              )
  ierr   = createvar   (ncoutu,  stypvaru, 1,      ipk,    id_varoutu                     )
  ierr   = putheadervar(ncoutu,  cf_tfil,  npiglo, npjglo, 0, pnavlon=glamv, pnavlat=gphiv)
  
  tim  = getvar1d(cf_tfil, cn_vtimec, npt     )
  ierr = putvar1d(ncoutu,  tim,       npt, 'T')

  ! V geo  ! @ U-point !
  ncoutv = create      (cf_vout, cf_tfil,  npiglo, npjglo, 0                              )
  ierr   = createvar   (ncoutv,  stypvarv, 1,      ipk,    id_varoutv                     )
  ierr   = putheadervar(ncoutv,  cf_tfil,  npiglo, npjglo, 0, pnavlon=glamu, pnavlat=gphiu)

  tim  = getvar1d(cf_tfil, cn_vtimec, npt     )
  ierr = putvar1d(ncoutv,  tim,       npt, 'T')

  ! Read ssh
  DO jt=1,npt
     zsshn = getvar(cf_tfil, cn_sossheig, 1, npiglo, npjglo, ktime=jt)

     IF ( jt == 1 ) THEN
        ! compute the masks
        umask=0. ; vmask = 0
        DO jj = 1, npjglo 
           DO ji = 1, npiglo - 1
              umask(ji,jj) = zsshn(ji,jj)*zsshn(ji+1,jj)
              IF (umask(ji,jj) /= 0.) umask(ji,jj) = 1.
           END DO
        END DO

        DO jj = 1, npjglo - 1
           DO ji = 1, npiglo
              vmask(ji,jj) = zsshn(ji,jj)*zsshn(ji,jj+1)
              IF (vmask(ji,jj) /= 0.) vmask(ji,jj) = 1.
           END DO
        END DO
        ! e1u and e1v are modified to simplify the computation below
        ! note that geostrophy is not available near the equator ( f=0)
        DO jj=2, npjglo - 1
           DO ji=2, npiglo - 1
              ffu = ff(ji,jj) + ff(ji,  jj-1)
              IF ( ffu /= 0. ) THEN 
                e1u(ji,jj)= 2.* grav * umask(ji,jj) / ( ffu ) / e1u(ji,jj)
              ELSE
                e1u(ji,jj)= 0.  ! spvalue
              ENDIF

              ffv = ff(ji,jj) + ff(ji-1,jj  )
              IF ( ffv /= 0. ) THEN 
                e2v(ji,jj)= 2.* grav * vmask(ji,jj) / ( ffv ) / e2v(ji,jj)
              ELSE
                e2v(ji,jj)= 0.  ! spvalue
              ENDIF
           END DO
        END DO
     END IF

     ! Calculation of geostrophic velocity :
     un(:,:) = 0.
     vn(:,:) = 0.

     DO jj = 2,npjglo - 1
        DO ji = 2,npiglo -1
           vn(ji,jj) = e1u(ji,jj) * ( zsshn(ji+1,jj  ) - zsshn(ji,jj) ) 
           un(ji,jj) = e2v(ji,jj) * ( zsshn(ji  ,jj+1) - zsshn(ji,jj) ) 
        END DO
     END DO

     ! write un and vn  ...
     ierr = putvar(ncoutu, id_varoutu(1), un(:,:), 1, npiglo, npjglo, ktime=jt)
     ierr = putvar(ncoutv, id_varoutv(1), vn(:,:), 1, npiglo, npjglo, ktime=jt)

  END DO  ! time loop

  ierr = closeout(ncoutu)
  ierr = closeout(ncoutv)

END PROGRAM cdfgeo_uv

PROGRAM cdfinfo
  !!======================================================================
  !!                     ***  PROGRAM  cdfinfo  ***
  !!=====================================================================
  !!  ** Purpose : Give very basic informations for Netcdf File
  !!
  !!  ** Method  : to be improved
  !!
  !! History : 2.1  : 09/2010  : J.M. Molines : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio 
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class file_informations
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                               :: jvar, jarg               ! dummy loop index
  INTEGER(KIND=4)                               :: ierr                     ! working integer
  INTEGER(KIND=4)                               :: idep, idep_max           ! possible depth index, maximum
  INTEGER(KIND=4)                               :: narg, iargc, ijarg       ! 
  INTEGER(KIND=4)                               :: npiglo, npjglo, npk ,npt ! size of the domain
  INTEGER(KIND=4)                               :: nvars                    ! Number of variables in a file
  INTEGER(KIND=4)                               :: npoints                  ! Number of points with VALUE
  INTEGER(KIND=4), DIMENSION(1)                 :: ikloc                    ! used for MINLOC

  REAL(KIND=4)                                  :: zdep                     ! depth to look for
  REAL(KIND=4)                                  :: zval                     ! value to lookfor
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: zdept                    ! depth array
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: zv2d                     ! 2D working array

  CHARACTER(LEN=256)                            :: cf_in                    ! file name
  CHARACTER(LEN=256)                            :: cv_dep                   ! depth name
  CHARACTER(LEN=256)                            :: cv_var                   ! depth name
  CHARACTER(LEN=256)                            :: cldum                    ! dummy input variable
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_names                 ! array of var name
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: clv_dep                  ! possible choices for dep dimension

  TYPE(variable), DIMENSION(:),     ALLOCATABLE :: stypvar                  ! variable attributes

  LOGICAL                                       :: ldep  =.FALSE.           ! flag for depth control
  LOGICAL                                       :: lval  =.FALSE.           ! flag for value control
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()

  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfinfo -f MODEL-file [-dep dep] [-val VAR-val] [-in VAR-name]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'        Gives very basic information about the file given in arguments.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'        model output file in netcdf.' 
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'        [-dep depth ] : return the nearest k index corresponding to depth '
     PRINT *,'        [-val VAR-val ] : return the number of points with VAR-val in a '
     PRINT *,'              VAR-name variable.'
     PRINT *,'        [-in VAR-name ] : name of the variable for value check.'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'        On standard ouput, gives the size of the domain, the depth '
     PRINT *,'        dimension name, the number of variables.'
     PRINT *,'      '
     STOP 
  ENDIF

  ijarg=1
  cv_var='none'
  DO WHILE ( ijarg <= narg ) 
     CALL getarg(ijarg, cldum) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-f'   ) ; CALL getarg (ijarg, cf_in) ;  ijarg=ijarg+1
        ! options
     CASE ( '-dep' ) ; CALL getarg (ijarg, cldum) ;  ijarg=ijarg+1 ; READ(cldum,*) zdep ;  ldep =.TRUE.
     CASE ( '-val' ) ; CALL getarg (ijarg, cldum) ;  ijarg=ijarg+1 ; READ(cldum,*) zval ;  lval =.TRUE.
     CASE ( '-in'  ) ; CALL getarg (ijarg, cv_var);  ijarg=ijarg+1 
     CASE DEFAULT   ; PRINT *, 'ERROR : ',TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  ENDDO

  IF ( chkfile(cf_in) ) STOP 99 ! missing file

  npiglo = getdim (cf_in,cn_x)
  npjglo = getdim (cf_in,cn_y)

  ! looking for npk among various possible name
  idep_max=8
  ALLOCATE ( clv_dep(idep_max) )
  clv_dep(:) = (/cn_z,'z','sigma','nav_lev','levels','ncatice','icbcla','icbsect'/)
  idep=1  ; ierr=1000
  DO WHILE ( ierr /= 0 .AND. idep <= idep_max )
     npk  = getdim (cf_in, clv_dep(idep), cdtrue=cv_dep, kstatus=ierr)
     idep = idep + 1
  ENDDO

  IF ( ierr /= 0 ) THEN  ! none of the dim name was found
     PRINT *,' assume file with no depth'
     npk=0
  ENDIF

  npt    = getdim (cf_in,cn_t)

  PRINT *, 'npiglo =', npiglo
  PRINT *, 'npjglo =', npjglo
  PRINT *, 'npk    =', npk
  PRINT *, 'npt    =', npt

  PRINT *,' Depth dimension name is ', TRIM(cv_dep)

  nvars = getnvar(cf_in)
  PRINT *,' nvars =', nvars

  ALLOCATE (cv_names(nvars)  )
  ALLOCATE (stypvar(nvars)  )

  ! get list of variable names 
  cv_names(:)=getvarname(cf_in, nvars, stypvar)

  DO jvar = 1, nvars
     PRINT *, 'variable# ',jvar,' is : ',TRIM(cv_names(jvar))
  END DO

  IF ( ldep ) THEN
     ALLOCATE(zdept(npk) )
     zdept = getdimvar (cf_in,  npk)
     ikloc= MINLOC( ABS(zdept - zdep) )
     PRINT * ,' NEAREST_K ',ikloc(1)
  ENDIF
  
  IF (lval ) THEN
     ALLOCATE( zv2d(npiglo, npjglo ) )
     zv2d=getvar(cf_in, cv_var, 1, npiglo, npjglo)
     WHERE (zv2d /= zval ) 
       zv2d = 0.
     ELSEWHERE
       zv2d = 1.
     END WHERE
     npoints = SUM(zv2d )
     PRINT *,' VAR  ', TRIM(cv_var),'  : value  ', zval,'  : ', npoints
  ENDIF


END PROGRAM cdfinfo

PROGRAM cdfbottom
  !!======================================================================
  !!                     ***  PROGRAM  cdfbottom  ***
  !!=====================================================================
  !!  ** Purpose : Extract the bottom value for the 3D variables
  !!               which are in the input file. Store the results
  !!               on a similar file, with the same variable name.
  !!
  !!  **  Method:  Uses the corresponding mask file to determine the bottom.
  !!               If no mask found it assumes that 0.0000 values corresponds
  !!               to masked values.
  !!
  !! History : 2.1  : 11/2005  : J.M. Molines : Original code
  !!           3.0  : 12/2010  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class bottom
  !!----------------------------------------------------------------------

  IMPLICIT NONE

  INTEGER(KIND=4)                            :: jk , jv, jvar, jt        ! dummy loop index
  INTEGER(KIND=4)                            :: ierr                     ! working integer
  INTEGER(KIND=4)                            :: idep, idep_max           ! possible depth index, maximum
  INTEGER(KIND=4)                            :: narg, iargc, ijarg       ! argument on line
  INTEGER(KIND=4)                            :: npiglo, npjglo, npk, npt ! size of the domain
  INTEGER(KIND=4)                            :: nvars                    ! number of variables in the input file
  INTEGER(KIND=4)                            :: ncout                    ! ncid of output ncdf file
  INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE :: ipk, ipko                ! outptut variables : number of levels,
  INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE :: id_var, id_varout        ! ncdf varid's

  REAL(KIND=4), DIMENSION(:,:),  ALLOCATABLE :: zfield                   ! Array to read a layer of data
  REAL(KIND=4), DIMENSION(:,:),  ALLOCATABLE :: zbot                     ! array to store the bottom value
  REAL(KIND=4), DIMENSION(:,:),  ALLOCATABLE :: zmask                    ! 2D mask at current level

  REAL(KIND=8), DIMENSION(:),    ALLOCATABLE :: dtim                     ! time counter of the file

  CHARACTER(LEN=256)                         :: cf_out='bottom.nc'       ! output file name
  CHARACTER(LEN=256)                         :: cf_in, cldum             ! working strings
  CHARACTER(LEN=256)                         :: cv_dep                   ! true name of dep dimension
  CHARACTER(LEN=5)                           :: cv_msk=' '               ! name of the mask variable
  CHARACTER(LEN=1)                           :: ctype=' '                ! point type (T U V ..)
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_names              ! array of var name
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: clv_dep               ! array of possible depth name (or 3rd dimension)

  TYPE (variable), DIMENSION(:), ALLOCATABLE :: stypvar                  ! structure for variable attribute

  LOGICAL                                    :: lnc4      = .FALSE.     ! Use nc4 with chunking and deflation
  !!--------------------------------------------------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfbottom  -f IN-file [-p C-type] [-o OUT-file] [-nc4] '
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Create a 2D file with bottom most values for all the variables which '
     PRINT *,'       are in the input 3D file.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -f IN-file : input netcdf 3D file.' 
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-p C-type] : specify the type of grid point on the C-grid (T|U|V|F).' 
     PRINT *,'               If not given, assume that land points are values with 0.'
     PRINT *,'       [-o OUT-file ]: specify output filename instead of ',TRIM(cf_out)
     PRINT *,'       [-nc4 ]     : Use netcdf4 output with chunking and deflation level 1.'
     PRINT *,'               This option is effective only if cdftools are compiled with'
     PRINT *,'               a netcdf library supporting chunking and deflation.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ',TRIM(cn_fmsk),' file is required if the grid point is specified or if' 
     PRINT *,'               the land value is not 0.'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) ,' unless -o option is used.'
     PRINT *,'         variables :  same names than input file, long_name attribute is'
     PRINT *,'               prefixed by Bottom '
     PRINT *,'      '
     STOP 
  ENDIF

  ijarg = 1
  DO WHILE ( ijarg <= narg )
     CALL getarg(ijarg, cldum) ; ijarg = ijarg + 1
     SELECT CASE (cldum )
     CASE ( '-f'  ) ;  CALL getarg (ijarg, cf_in) ; ijarg = ijarg + 1
        ! options
     CASE ( '-p'  ) ;  CALL getarg (ijarg, ctype) ; ijarg = ijarg + 1
        IF ( chkfile (cn_fmsk )) STOP 99  ! missing files
        SELECT CASE ( ctype )
        CASE ( 'T', 't', 'S', 's' ) ; cv_msk=cn_tmask
        CASE ( 'U', 'u'           ) ; cv_msk=cn_umask
        CASE ( 'V', 'v'           ) ; cv_msk=cn_vmask
        CASE ( 'F', 'f'           ) ; cv_msk=cn_fmask
           ; PRINT *, 'Be carefull with fmask (think of shlat)... !!!'
        CASE DEFAULT                ; PRINT *, ' ERROR : This type of point ', TRIM(ctype),' is not known !' ; STOP 99
        END SELECT
     CASE ( '-o'  ) ;  CALL getarg (ijarg, cf_out) ; ijarg = ijarg + 1
     CASE ( '-nc4') ;  lnc4 = .TRUE.
     CASE DEFAULT   ; PRINT *, ' ERROR : ',TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  ENDDO

  IF ( chkfile(cf_in) ) STOP 99  ! missing files

  npiglo = getdim (cf_in,cn_x)
  npjglo = getdim (cf_in,cn_y)

  ! looking for npk among various possible name
  idep_max=8
  ALLOCATE ( clv_dep(idep_max) )
  clv_dep(:) = (/cn_z,'z','sigma','nav_lev','levels','ncatice','icbcla','icbsect'/)
  idep=1  ; ierr=1000
  DO WHILE ( ierr /= 0 .AND. idep <= idep_max )
     npk  = getdim (cf_in, clv_dep(idep), cdtrue=cv_dep, kstatus=ierr)
     idep = idep + 1
  ENDDO

  IF ( ierr /= 0 ) THEN  ! none of the dim name was found
     PRINT *,' assume file with no depth'
     npk=0
  ENDIF

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk , 'Dep name :' , TRIM(cv_dep)

  npt   = getdim (cf_in,cn_t)

  ALLOCATE (zfield(npiglo,npjglo), zbot(npiglo,npjglo), zmask(npiglo,npjglo))
  ALLOCATE (dtim(npt) )

  ! look for the number of variables in the input file
  nvars = getnvar(cf_in)
  PRINT *,' nvars =', nvars

  ALLOCATE (cv_names(nvars) ,stypvar(nvars))
  ALLOCATE (id_var(nvars), ipk(nvars), id_varout(nvars), ipko(nvars) )

  cv_names(:)=getvarname(cf_in,nvars,stypvar)
  id_var(:)  = (/(jv, jv=1,nvars)/)

  CALL CreateOutput

  DO jvar = 1,nvars
     zfield = 0.
     zbot   = 0.

     IF (cv_names(jvar) == 'none' ) THEN
        ! skip these variable
     ELSE
        PRINT *, ' WORKING with ', TRIM( cv_names(jvar) ), ipk(jvar)
        DO jt = 1, npt
           DO jk = 1, ipk(jvar)
              zmask = 1.
              zfield(:,:) = getvar(cf_in, cv_names(jvar),  jk, npiglo, npjglo, ktime=jt)
              IF ( cv_msk == ' ' ) THEN
                 WHERE ( zfield /= 0 )
                    zbot = zfield
                 END WHERE
              ELSE
                 zmask(:,:) = getvar(cn_fmsk, cv_msk, jk, npiglo, npjglo)
                 WHERE ( zmask /= 0 )
                    zbot = zfield
                 END WHERE
              ENDIF
           END DO ! level-loop
           ierr = putvar(ncout, id_varout(jvar), zbot, 1, npiglo, npjglo, ktime=jt)
        ENDDO  ! time-loop
     ENDIF
  END DO       ! variable-loop

  ierr    = closeout(ncout)
CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    ! ipk gives the number of level or 0 if not a T[Z]YX  variable
    ipk(:)     = getipk (cf_in,nvars,cdep=cv_dep)
    ipko(:)    = 1  ! all variables output are 2D

    WHERE( ipk <= 1 ) cv_names='none'
    DO jvar=1,nvars
       stypvar(jvar)%ichunk     = (/npiglo,MAX(1,npjglo/30),1,1 /)
       stypvar(jvar)%cname      = cv_names(jvar)
       stypvar(jvar)%caxis      = 'TYX'
       cldum=stypvar(jvar)%clong_name
       stypvar(jvar)%clong_name = 'Bottom '//TRIM(cldum)
    END DO
    ! create output fileset
    ! create output file taking the sizes in cf_in

    ncout = create      (cf_out,   cf_in  , npiglo, npjglo, 1         , ld_nc4=lnc4 ) ! 1 level file
    ierr  = createvar   (ncout   , stypvar, nvars , ipko  , id_varout , ld_nc4=lnc4 )
    ierr  = putheadervar(ncout   , cf_in  , npiglo, npjglo, 1         )
    dtim  = getvar1d(cf_in, cn_vtimec, npt     )
    ierr  = putvar1d(ncout, dtim,      npt, 'T')

  END SUBROUTINE CreateOutput

END PROGRAM cdfbottom

PROGRAM cdfcurl
  !!======================================================================
  !!                     ***  PROGRAM  cdfcurl  ***
  !!=====================================================================
  !!  ** Purpose : Compute the curl on F-points for given gridU gridV 
  !!               files and variables
  !!
  !!  ** Method  : Use the same algorithm than NEMO
  !!
  !! History : 2.1  : 05/2005  : J.M. Molines : Original code
  !!         : 2.1  : 06/2007  : P. Mathiot   : for use with forcing fields
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: ji, jj, jt         ! dummy loop index
  INTEGER(KIND=4)                           :: ilev               ! level to be processed
  INTEGER(KIND=4)                           :: npiglo, npjglo     ! size of the domain
  INTEGER(KIND=4)                           :: npk, npt           ! size of the domain
  INTEGER(KIND=4)                           :: narg, iargc        ! browse command line
  INTEGER(KIND=4)                           :: ncout, ierr        ! browse command line
  INTEGER(KIND=4), DIMENSION(1)             :: ipk, id_varout     ! output variable properties

  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e2v, e1u, e1f, e2f ! horizontql metrics
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: un, vn             ! velocity field
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zun, zvn           ! working arrays
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: rotn, fmask        ! curl and fmask
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: tim                ! time counter

  CHARACTER(LEN=256)                        :: cf_ufil, cf_vfil   ! file names
  CHARACTER(LEN=256)                        :: cf_out = 'curl.nc' ! output file name
  CHARACTER(LEN=256)                        :: cv_u, cv_v         ! variable names
  CHARACTER(LEN=256)                        :: cldum              ! dummy string

  TYPE (variable), DIMENSION(1)             :: stypvar            ! structure for attibutes

  LOGICAL                                   :: lforcing = .FALSE. ! forcing flag
  LOGICAL                                   :: lchk     = .FALSE. ! flag for missing files
  LOGICAL                                   :: lperio   = .FALSE. ! flag for E-W periodicity
  !!----------------------------------------------------------------------
  CALL ReadCdfNames() 

  narg = iargc()
  IF ( narg /= 5 ) THEN
     PRINT *,' usage : cdfcurl U-file V-file U-var V-var lev'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the curl of a vector field, at a specified level.'  
     PRINT *,'       If level is specified as 0, assume that the input files are'
     PRINT *,'       forcing files, presumably on A-grid. In this latter case, the'
     PRINT *,'       vector field is interpolated on the C-grid. In any case, the'
     PRINT *,'       curl is computed on the F-point.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       U-file : zonal component of the vector field.'
     PRINT *,'       V-file : meridional component of the vector field.'
     PRINT *,'       U-var  : zonal component variable name'
     PRINT *,'       V-var  : meridional component variable name.'
     PRINT *,'       lev    : level to be processed. If set to 0, assume forcing file '
     PRINT *,'                in input.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        ', TRIM(cn_fhgr)
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : socurl (s^-1)'
     STOP
  ENDIF

  CALL getarg(1, cf_ufil)
  CALL getarg(2, cf_vfil)
  CALL getarg(3, cv_u   )
  CALL getarg(4, cv_v   )
  CALL getarg(5, cldum  ) ;  READ(cldum,*) ilev

  lchk = chkfile(cn_fhgr ) .OR. lchk
  lchk = chkfile(cf_ufil ) .OR. lchk
  lchk = chkfile(cf_vfil ) .OR. lchk
  IF ( lchk ) STOP ! missing files

  ! define new variables for output
  stypvar(1)%cname             = 'socurl'
  stypvar(1)%cunits            = 's-1'
  stypvar(1)%rmissing_value    = 0.
  stypvar(1)%valid_min         = -1000.
  stypvar(1)%valid_max         =  1000.
  stypvar(1)%clong_name        = 'Relative_Vorticity (curl)'
  stypvar(1)%cshort_name       = 'socurl'
  stypvar(1)%conline_operation = 'N/A'
  stypvar(1)%caxis             = 'TYX'

  ipk(1) = 1  !  2D

  npiglo = getdim(cf_ufil,cn_x)
  npjglo = getdim(cf_ufil,cn_y)
  npk    = getdim(cf_ufil,cn_z)
  npt    = getdim(cf_ufil,cn_t) 

  PRINT *, 'npiglo = ',npiglo
  PRINT *, 'npjglo = ',npjglo
  PRINT *, 'npk    = ',npk
  PRINT *, 'npt    = ',npt
  PRINT *, 'ilev   = ',ilev

  !test if lev exists
  IF ( (npk==0) .AND. (ilev > 0) ) THEN
     PRINT *, 'Problem : npk = 0 and lev > 0 STOP'
     STOP
  END IF

  ! if forcing field 
  IF ( ilev==0 .AND. npk==0 ) THEN
     lforcing=.true.
     npk = 1 ; ilev=1
     PRINT *, 'npk =0, assume 1'
  END IF

  IF ( npt==0 ) THEN
     PRINT *, 'npt=0, assume 1'
     npt=1
  END IF
  ! check files and determines if the curl will be 2D of 3D
  ! ????????????

  ! Allocate the memory
  ALLOCATE ( e1u(npiglo,npjglo) , e1f(npiglo,npjglo) )
  ALLOCATE ( e2v(npiglo,npjglo) , e2f(npiglo,npjglo) )
  ALLOCATE ( un(npiglo,npjglo)  , vn(npiglo,npjglo)  )
  ALLOCATE ( zun(npiglo,npjglo) , zvn(npiglo,npjglo) )
  ALLOCATE ( rotn(npiglo,npjglo) , fmask(npiglo,npjglo) )
  ALLOCATE ( tim(npt) )

  e1u =  getvar(cn_fhgr, cn_ve1u, 1, npiglo, npjglo)
  e1f =  getvar(cn_fhgr, cn_ve1f, 1, npiglo, npjglo)
  e2v =  getvar(cn_fhgr, cn_ve2v, 1, npiglo, npjglo)
  e2f =  getvar(cn_fhgr, cn_ve2f, 1, npiglo, npjglo)

  ! use zun and zvn to store f latitude and longitude for output
  zun = getvar(cn_fhgr, cn_glamf, 1, npiglo, npjglo)
  zvn = getvar(cn_fhgr, cn_gphif, 1, npiglo, npjglo)

  ! look for  E-W periodicity
  IF ( zun(1,1) == zun(npiglo-1,1) ) lperio = .TRUE.

  ! create output fileset
  ncout = create      (cf_out, cf_ufil, npiglo, npjglo, 0                           )
  ierr  = createvar   (ncout , stypvar, 1,      ipk,    id_varout                   )
  ierr  = putheadervar(ncout,  cf_ufil, npiglo, npjglo, 0, pnavlon=zun, pnavlat=zvn )

  tim  = getvar1d(cf_ufil, cn_vtimec, npt      )
  ierr = putvar1d(ncout,   tim,       npt,  'T')
  
  DO jt=1,npt
     IF (MOD(jt,100)==0 ) PRINT *, jt,'/',npt
        ! if files are forcing fields
        zun(:,:) =  getvar(cf_ufil, cv_u, ilev ,npiglo,npjglo, ktime=jt)
        zvn(:,:) =  getvar(cf_vfil, cv_v, ilev ,npiglo,npjglo, ktime=jt)

     IF ( lforcing ) THEN ! for forcing file u and v are on the A grid
        DO ji=1, npiglo-1
           un(ji,:) = 0.5*(zun(ji,:) + zun(ji+1,:))
        END DO
        !
        DO jj=1, npjglo-1
           vn(:,jj) = 0.5*(zvn(:,jj) + zvn(:,jj+1))
        END DO
        ! end compute u and v on U and V point
     ELSE
       un(:,:) = zun(:,:)
       vn(:,:) = zvn(:,:)
     END IF

     ! compute the mask
     IF ( jt==1 ) THEN
        DO jj = 1, npjglo - 1
           DO ji = 1, npiglo - 1
              fmask(ji,jj)=0.
              fmask(ji,jj)= un(ji,jj)*un(ji,jj+1) * vn(ji,jj)*vn(ji+1,jj)
              IF (fmask(ji,jj) /= 0.) fmask(ji,jj)=1.
           ENDDO
        ENDDO
     END IF

     rotn(:,:) = 0.
     DO jj = 1, npjglo -1 
        DO ji = 1, npiglo -1   ! vector opt.
           rotn(ji,jj) = (  e2v(ji+1,jj  ) * vn(ji+1,jj  ) - e2v(ji,jj) * vn(ji,jj)    &
                &         - e1u(ji  ,jj+1) * un(ji  ,jj+1) + e1u(ji,jj) * un(ji,jj)  ) &
                &         * fmask(ji,jj) / ( e1f(ji,jj) * e2f(ji,jj) )
        END DO
     END DO

     IF ( lperio ) rotn(npiglo,:) = rotn(2, :)
     ! write rotn on file at level k and at time jt
     ierr = putvar(ncout, id_varout(1), rotn, 1, npiglo, npjglo, ktime=jt)
  END DO
  ierr = closeout(ncout)

END PROGRAM cdfcurl

PROGRAM cdfcmp
  !!======================================================================
  !!                     ***  PROGRAM  cdfcmp  ***
  !!======================================================================
  !!  ** Purpose : Find the differences between one same variable in two different files
  !!               Indicate where are located these differences
  !!               Indicate the relative difference
  !!
  !!  ** Method  : Compare var1 and var2
  !!               If it differs, print in standard output where are located diff
  !!               Spatial sub-area restriction can be defined
  !!
  !! History : 3.0 !  08/2012    A. Lecointre   : Original code + Full Doctor form + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class file_operations
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                               :: jk,jj,ji, jvar, jjvar ! dummy loop index
  INTEGER(KIND=4)                               :: ierr                  ! working integer
  INTEGER(KIND=4)                               :: narg, iargc, ijarg    ! argument on line 
  INTEGER(KIND=4)                               :: npiglo, npjglo        ! size fo the domain
  INTEGER(KIND=4)                               :: iimin=1, iimax=0      ! i-limit of the domain
  INTEGER(KIND=4)                               :: ijmin=1, ijmax=0      ! j-limit of the domain
  INTEGER(KIND=4)                               :: ikmin=1, ikmax=0      ! k-limit of the domain
  INTEGER(KIND=4)                               :: nvars                 ! Number of variables in a file
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: ipk                   ! arrays of var id's
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: var1, var2            ! variables to compare
  REAL(KIND=4)                                  :: dvar                  ! relative difference
  CHARACTER(LEN=256)                            :: cf1_in,cf2_in         ! input file name
  CHARACTER(LEN=256)                            :: cv_in                 ! variable name
  CHARACTER(LEN=256)                            :: cldum                 ! working string
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_names              ! array of var name
  TYPE (variable), DIMENSION(:),    ALLOCATABLE :: stypvar               ! Type variable is defined in cdfio.

  !!--------------------------------------------------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfcmp -f1 IN-file1 -f2 IN-file2 -v IN-var ...'
     PRINT *,'     ... [-lev kmin kmax ] [-zoom imin imax jmin jmax] ...'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'        Find where IN-var is different between IN-file1 and IN-file2 '
     PRINT *,'        Options allow to restrict the finding to a sub area in space'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -f1 IN-file1 : input file1'
     PRINT *,'       -f2 IN-file2 : input file2'
     PRINT *,'       -v  IN-var   : input variable'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-lev kmin kmax ] : restrict to level between kmin and kmax. '
     PRINT *,'       [-zoom imin imax jmin jmax] : restrict to sub area specified'
     PRINT *,'                                     by the given limits. '
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       none '
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       output is done on standard output.'
     STOP 
  ENDIF
  !!
  ijarg  = 1
  DO  WHILE (ijarg <=  narg)
     CALL getarg(ijarg,cldum) ; ijarg = ijarg + 1
     SELECT CASE ( cldum )
     CASE ( '-f1' ) ; CALL getarg(ijarg, cf1_in) ; ijarg = ijarg + 1
     CASE ( '-f2' ) ; CALL getarg(ijarg, cf2_in) ; ijarg = ijarg + 1
     CASE ( '-v'  ) ; CALL getarg(ijarg, cv_in ) ; ijarg = ijarg + 1
     CASE ( '-lev') ; CALL getarg(ijarg, cldum ) ; ijarg = ijarg + 1 ; READ(cldum,*) ikmin
        ;             CALL getarg(ijarg, cldum ) ; ijarg = ijarg + 1 ; READ(cldum,*) ikmax
     CASE ('-zoom') ; CALL getarg(ijarg, cldum ) ; ijarg = ijarg + 1 ; READ(cldum,*) iimin
        ;             CALL getarg(ijarg, cldum ) ; ijarg = ijarg + 1 ; READ(cldum,*) iimax
        ;             CALL getarg(ijarg, cldum ) ; ijarg = ijarg + 1 ; READ(cldum,*) ijmin
        ;             CALL getarg(ijarg, cldum ) ; ijarg = ijarg + 1 ; READ(cldum,*) ijmax
     CASE DEFAULT   ; PRINT *,' ERROR : ', TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  END DO

  IF ( chkfile(cf1_in) .OR. chkfile(cf2_in) ) STOP 99 ! missing file
  IF ( chkvar(cf1_in, cv_in) .OR. chkvar(cf2_in, cv_in) ) STOP 99  ! missing var

  npiglo = getdim (cf1_in, cn_x)
  npjglo = getdim (cf1_in, cn_y)
  IF ( iimax == 0 ) iimax = npiglo
  IF ( ijmax == 0 ) ijmax = npjglo

  ! get the number of vertical levels of cv_in variable
  nvars = getnvar(cf1_in)
  ALLOCATE (ipk(nvars),cv_names(nvars),stypvar(nvars))
  cv_names(:)=getvarname(cf1_in,nvars,stypvar)
  ipk(:) = getipk (cf1_in,nvars)
  DO jvar=1,nvars
     IF ( cv_names(jvar) == cv_in ) jjvar=jvar
  ENDDO
  IF ( ikmax == 0 ) ikmax = ipk(jjvar)

  ! Allocate memory.
  ALLOCATE(var1(npiglo, npjglo))
  ALLOCATE(var2(npiglo, npjglo))

  PRINT *,' Working with ', TRIM(cv_in),' defined on ', ipk(jjvar),' level(s)'
  DO jk = ikmin, ikmax
     PRINT *,'# -------------------------------------------'
     PRINT '(A19,I3)','# Checking level: ',jk
     PRINT *,'# i     j    k      var1      var2  %reldiff'
     var1(:,:)=9999.0
     var2(:,:)=9999.0
     var1(:,:) = getvar(cf1_in, cv_in,  jk, npiglo, npjglo)
     var2(:,:) = getvar(cf2_in, cv_in,  jk, npiglo, npjglo)
     DO jj=ijmin, ijmax
        DO ji=iimin, iimax
           IF ( var1(ji,jj) /= var2(ji,jj) ) THEN
              dvar = 100.0*(var1(ji,jj)-var2(ji,jj))/var1(ji,jj)
              PRINT '(I4,2X,I4,2X,I3,2X,F8.3,2X,F8.3,2X,F8.3)',ji,jj,jk,var1(ji,jj),var2(ji,jj),dvar
           ENDIF
        ENDDO
     ENDDO
  ENDDO

END PROGRAM cdfcmp

PROGRAM cdfbn2
  !!======================================================================
  !!                     ***  PROGRAM  cdfbn2  ***
  !!=====================================================================
  !!  ** Purpose : Compute the Brunt Vaissala frequency
  !!               using same algoritm than NEMO
  !!
  !!  ** Method  : Try to avoid 3 d arrays : work with 2 levels a a time
  !!              The brunt-vaisala frequency is computed using the
  !!              polynomial expression of McDougall (1987):
  !!              N^2 = grav * beta * ( alpha/beta*dk[ t ] - dk[ s ] )/e3w
  !!              N2 is then insterpolated at T levels
  !!
  !! History : 2.0  : 11/2004  : J.M. Molines : Original code
  !!           2.1  : 04/2005  : J.M. Molines : use cdfio
  !!           3.0  : 12/2010  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames   ! for cdf variable names
  USE eos
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2010, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                              :: jk, jt                   ! dummy loop index
  INTEGER(KIND=4)                              :: ierr                     ! working integer
  INTEGER(KIND=4)                              :: narg, iargc, ijarg       ! 
  INTEGER(KIND=4)                              :: npiglo, npjglo, npk, npt ! size of the domain
  INTEGER(KIND=4)                              :: iup = 1, idown = 2, itmp ! for swapping the levels
  INTEGER(KIND=4)                              :: ncout                    ! ncid of output file
  INTEGER(KIND=4), DIMENSION(2)                :: ipk, id_varout           ! level and id of output variables

  REAL(KIND=4)                                 :: zpi                      ! 3.14...
  REAL(KIND=4), DIMENSION (:,:,:), ALLOCATABLE :: ztemp, zsal, zwk         ! Array to read 2 layer of data
  REAL(KIND=4), DIMENSION (:,:),   ALLOCATABLE :: zn2                      ! Brunt Vaissala Frequency (N2)
  REAL(KIND=4), DIMENSION (:,:),   ALLOCATABLE :: zmask, e3w               ! mask and metric
  REAL(KIND=4), DIMENSION (:),     ALLOCATABLE :: gdep, tim, e3w1d         ! depth and time

  CHARACTER(LEN=256)                           :: cf_tfil, cldum, cv_dep   ! input file name, ...
  CHARACTER(LEN=256)                           :: cf_out = 'bn2.nc'        ! output file name
  CHARACTER(LEN=256)                           :: cglobal                  ! global attribute
  CHARACTER(LEN=80)                            :: cv_e3w  = 'e3w_ps'       ! e3w variable name (partial step)
  CHARACTER(LEN=80)                            :: cv_bn2  = 'vobn2'        ! cdf variable name for N2

  TYPE(variable), DIMENSION(1)                 :: stypvar                  ! variable attribute

  LOGICAL                                      :: l_w=.false.              ! flag for vertical location of bn2
  LOGICAL                                      :: lchk=.true.              ! check missing files
  LOGICAL                                      :: lfull=.false.            ! full step flag
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfbn2  T-file [W] [-full]'
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the Brunt-Vaissala frequency (N2) according to' 
     PRINT *,'       temperature and salinity given in the input file.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       T-file : netcdf input gridT file for temperature and salinity.' 
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [ W ] : keep N2 at W points. Default is to interpolate N2' 
     PRINT *,'             at T point on the vertical.'
     PRINT *,'       [ -full ] : indicate a full step configuration instead of'
     PRINT *,'                the default partial steps.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ',TRIM(cn_fzgr),' is needed for this program.' 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : ', TRIM(cv_bn2)
     STOP
  ENDIF

  cglobal = 'Partial step computation'

  ijarg = 1
  CALL getarg (ijarg, cf_tfil) ; ijarg = ijarg + 1

  DO WHILE ( ijarg <= narg ) 
     CALL getarg(ijarg, cldum) ; ijarg = ijarg + 1
     SELECT CASE (cldum)
     CASE ('W','w') ; l_w   = .true.
     CASE ('-full') ; lfull = .true. ; cglobal = 'full step computation'
     CASE DEFAULT   ; PRINT *,' Option not understood :', TRIM(cldum) ; STOP
     END SELECT
  END DO

  lchk = chkfile (cn_fzgr )
  lchk = lchk .OR. chkfile (cf_tfil  )
  IF ( lchk  ) STOP  ! missing files 

  npiglo = getdim (cf_tfil, cn_x)
  npjglo = getdim (cf_tfil, cn_y)
  npk    = getdim (cf_tfil, cn_z)
  npt    = getdim (cf_tfil, cn_t)

  ipk(1)                       = npk  !  3D
  stypvar(1)%cname             = cv_bn2
  stypvar(1)%cunits            = 's-1'
  stypvar(1)%rmissing_value    = -1000.
  stypvar(1)%valid_min         = 0.
  stypvar(1)%valid_max         = 50000.
  stypvar(1)%clong_name        = 'Brunt_Vaissala_Frequency'
  stypvar(1)%cshort_name       = cv_bn2
  stypvar(1)%conline_operation = 'N/A'
  stypvar(1)%caxis             = 'TZYX'

  PRINT *, 'npiglo =', npiglo
  PRINT *, 'npjglo =', npjglo
  PRINT *, 'npk    =', npk
  PRINT *, 'npt    =', npt

  ALLOCATE (ztemp(npiglo,npjglo,2), zsal(npiglo,npjglo,2) )
  ALLOCATE (zwk(npiglo,npjglo,2), zmask(npiglo,npjglo)    )
  ALLOCATE (zn2(npiglo,npjglo), e3w(npiglo,npjglo)        )
  ALLOCATE (gdep(npk), tim(npt)                           )
  IF ( lfull ) ALLOCATE (e3w1d(npk) )

  cv_dep=cn_gdept
  IF (l_w) cv_dep=cn_gdepw

  gdep(:) = getvare3(cn_fzgr, cv_dep, npk)

  ! create output fileset
  ncout = create      (cf_out,   cf_tfil,  npiglo, npjglo, npk)
  ierr  = createvar   (ncout ,   stypvar,  1,      ipk,    id_varout, cdglobal=TRIM(cglobal))
  ierr  = putheadervar(ncout,    cf_tfil,  npiglo, npjglo, npk, pdep=gdep)

  zpi=ACOS(-1.)

  tim  = getvar1d(cf_tfil, cn_vtimec, npt   )
  ierr = putvar1d(ncout,  tim,       npt,'T')

  IF ( lfull )  e3w1d(:) = getvare3(cn_fzgr, cn_ve3w, npk)

  gdep(:) = getvare3(cn_fzgr, cn_gdepw, npk)
  DO jt=1,npt
     !  2 levels of T and S are required : iup,idown (with respect to W level)
     !  Compute from bottom to top (for vertical integration)
     ztemp(:,:,idown) = getvar(cf_tfil, cn_votemper,  npk-1, npiglo, npjglo, ktime=jt)
     zsal( :,:,idown) = getvar(cf_tfil, cn_vosaline,  npk-1, npiglo, npjglo, ktime=jt)

     DO jk = npk-1, 2, -1 
        PRINT *,'level ',jk
        zmask(:,:)=1.
        ztemp(:,:,iup)= getvar(cf_tfil, cn_votemper, jk-1, npiglo, npjglo, ktime=jt)
        WHERE(ztemp(:,:,idown) == 0 ) zmask = 0
        zsal(:,:,iup) = getvar(cf_tfil, cn_vosaline, jk-1, npiglo, npjglo, ktime=jt)

        IF ( lfull ) THEN
           e3w(:,:) = e3w1d(jk)
        ELSE
           e3w(:,:) = getvar(cn_fzgr, cv_e3w  , jk, npiglo, npjglo, ldiom=.true.)
        ENDIF

        zwk(:,:,iup) = eosbn2(ztemp, zsal, gdep(jk), e3w, npiglo, npjglo ,iup, idown)* zmask(:,:)

        IF ( .NOT. l_w ) THEN
           ! now put zn2 at T level (k )
           WHERE ( zwk(:,:,idown) == 0 ) 
              zn2(:,:) =  zwk(:,:,iup)
           ELSEWHERE
              zn2(:,:) = 0.5 * ( zwk(:,:,iup) + zwk(:,:,idown) ) * zmask(:,:)
           END WHERE
        ELSE
           zn2(:,:) = zwk(:,:,iup)
        ENDIF

        WHERE ( zn2 == 0 ) zn2 = -1000.
        ierr = putvar(ncout, id_varout(1), zn2, jk, npiglo, npjglo, ktime=jt )
        itmp = idown ; idown = iup ; iup = itmp

     END DO  ! loop to next level
  END DO

  ierr = closeout(ncout)

END PROGRAM cdfbn2

PROGRAM cdfcensus
  !!======================================================================
  !!                     ***  PROGRAM  cdfcensus  ***
  !!=====================================================================
  !!  ** Purpose : Build an array giving the volume of water in a TS cell.
  !!
  !!  ** Method  : T-file and S-file are scanned for a given region 
  !!              (eventually limited in depth) and the volume of water in 
  !!              a (T,S) cell such that T < Tmodele < T+dt and 
  !!              S < Smodele < S+ds.
  !!              If Smodel or T model are out of the bound they are 
  !!              cumulated in the nearest (T,S) cell.
  !!                  The output is done on a netcdf file where S is given as
  !!              the x-direction and T the y-direction, the field value 
  !!              being the volume of water. Due to a very large range in 
  !!              the water volume over the TS field the field is indeed 
  !!              the LOG (1 + VOLUME), and even, the scale can be made
  !!              more non-linear by repeating the LOG operation, ie, for 
  !!              example, field=LOG(1 + LOG (1 + VOLUME)). The parameter 
  !!              nlog, passed as command argument can be used to fix the
  !!              number of LOG. If nlog = 0, the true volume is saved.
  !!                 Depending on the user purpose, limiting values tmin,
  !!              tmax, and smin,smax as well as the increments dt, ds can 
  !!              be adjusted.
  !!              output is STILL a dimg file
  !!
  !! History : --   : 02/1997  : J.M. Molines as bimgtools in DYNAMO
  !!           --   : 09/1999  : A. de Miranda for OPA
  !!                : 01/2002  : J.M. Molines : DOctor norm
  !!                : 01/2006  : C. Langlais  : CDF I and partial cell
  !!           2.0  : 03/2006  : J.M. Molines : integration in CDFTOOLS
  !!           2.1  : 12/2006  : J.M. Molines : add sigma-2 and sigma-4 O
  !!           3.0  : 12/2010  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE eos
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class file_informations
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: ji, jj, jk, jt, jlog
  INTEGER(KIND=4)                           :: it_vvl                    ! time index for vvl
  INTEGER(KIND=4)                           :: npiglo, npjglo            ! size of the domain
  INTEGER(KIND=4)                           :: npk, npt                  ! size of the domain
  INTEGER(KIND=4)                           :: nlog=0
  INTEGER(KIND=4)                           :: narg, iargc, ijarg
  INTEGER(KIND=4)                           :: it, is
  INTEGER(KIND=4)                           :: ii1, ii2
  INTEGER(KIND=4)                           :: ij1, ij2
  INTEGER(KIND=4)                           :: ik1, ik2
  INTEGER(KIND=4)                           :: nt, ns
  INTEGER(KIND=4)                           :: ncout, ierr
  INTEGER(KIND=4), DIMENSION(2)             :: ijloc
  INTEGER(KIND=4), DIMENSION(4)             :: ipk, id_varout

  REAL(KIND=4)                              :: ztmin, ztmax, zdt, ztm
  REAL(KIND=4)                              :: zsmin, zsmax, zds, zsm
  REAL(KIND=4)                              :: ztpoint, zspoint, rcmax
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: e31d
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zt, zs, rsigma0, rsigma2, rsigma4
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e1t, e2t
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e3t
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zsx, zty

  REAL(KIND=8)                              :: dvoltotal, dvolpoint
  REAL(KIND=8), DIMENSION(:),   ALLOCATABLE :: dtim
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dcensus, ddump

  CHARACTER(LEN=256)                        :: cf_tfil
  CHARACTER(LEN=256)                        :: cf_sfil
  CHARACTER(LEN=256)                        :: cf_out='census.nc'
  CHARACTER(LEN=256)                        :: cglobal
  CHARACTER(LEN=256)                        :: cline1, cline2, cline3, cline4
  CHARACTER(LEN=256)                        :: cldum

  TYPE(variable), DIMENSION(4)              :: stypvar

  LOGICAL                                   :: lchk
  LOGICAL                                   :: lfull = .FALSE.   ! flag for full step
  LOGICAL                                   :: lnc4  = .FALSE.   ! Use nc4 with chunking and deflation

  ! Initialisations
  DATA ztmin, ztmax, zdt /-2.0, 38.0, 0.05/
  DATA zsmin, zsmax, zds /25.0, 40.0, 0.02/
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()
  ii1=-1 ; ii2=-1
  ij1=-1 ; ij2=-1
  ik1=-1 ; ik2=-1
  cf_sfil='none'

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage :  cdfcensus -t T-file [-log nlog] [-zoom imin imax jmin jmax] ...'
     PRINT *,'              ... [-klim kmin kmax] [-s S-file] [-srange smin smax ds] ... '
     PRINT *,'              ... [-trange tmin tmax dt] [-full] [-vvl] [-o OUT-file] [-nc4]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'        Compute the volumetric water mass census: the ocean is divided in'
     PRINT *,'        T,S bins; the program gives the volume of water for each bin.'
     PRINT *,'        A sub-area can be specified, both horizontaly and vertically.'
     PRINT *,'        Temperature and salinity ranges can be also adapted, as well as the'
     PRINT *,'        width of the bins. Default values are provided. In order to attenuate'
     PRINT *,'        the huge maximum values, a log10 operator can be applied many times,'
     PRINT *,'        the number of filter passes being set on the command line.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -t T-file  : netcdf file name for temperature and salinity' 
     PRINT *,'             If salinity is not in T-file, use -s option.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-s S-file] : Specify salinity file if not T-file.'
     PRINT *,'       [-log nlog] : number of log10 filter to perform. 0 by default.'
     PRINT *,'       [-zoom imin imax jmin jmax] : define a model sub-area, in model '
     PRINT *,'              coordinates' 
     PRINT *,'       [-klim kmin kmax] : set limits on the vertical.'
     PRINT *,'       [-srange smin smax ds ] : define the size of the salinity bin'
     PRINT '(a,2f5.1,x,f6.3)','                         defaut is :', zsmin, zsmax, zds
     PRINT *,'       [-trange tmin tmax dt ] : define the size of the temperatude bin'
     PRINT '(a,2f5.1,x,f6.3)','                         defaut is :', ztmin, ztmax, zdt
     PRINT *,'       [-full ] : use for full step computation'
     PRINT *,'       [-vvl ]  : use time-varying vertical metrics.'
     PRINT *,'       [-o OUT-file] : specify output file name instead of ',TRIM(cf_out)
     PRINT *,'       [-nc4 ] : Use netcdf4 output with chunking and deflation level 1.'
     PRINT *,'            This option is effective only if cdftools are compiled with'
     PRINT *,'            a netcdf library supporting chunking and deflation.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ',TRIM(cn_fhgr),'  and ',TRIM(cn_fzgr) 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       - netcdf file : ', TRIM(cf_out) 
     PRINT *,'           variables : volcensus  (10^15 m3 )'
     PRINT *,'                       sigma0  (kg/m3 -1000 )'
     PRINT *,'                       sigma2  (kg/m3 -1000 )'
     PRINT *,'                       sigma3  (kg/m3 -1000 )'
     STOP 
  ENDIF
  
  ijarg = 1  
  DO WHILE ( ijarg <= narg ) 
     CALL getarg(ijarg,cldum) ; ijarg = ijarg + 1
     SELECT CASE ( cldum)
     CASE ( '-t'     ) ; CALL getarg(ijarg,cf_tfil) ; ijarg = ijarg+1
     CASE ( '-s'     ) ; CALL getarg(ijarg,cf_sfil) ; ijarg = ijarg+1
     CASE ( '-zoom'  ) ; CALL getarg(ijarg,cldum  ) ; ijarg = ijarg+1 ; READ(cldum,*) ii1
        ;                CALL getarg(ijarg,cldum  ) ; ijarg = ijarg+1 ; READ(cldum,*) ii2
        ;                CALL getarg(ijarg,cldum  ) ; ijarg = ijarg+1 ; READ(cldum,*) ij1
        ;                CALL getarg(ijarg,cldum  ) ; ijarg = ijarg+1 ; READ(cldum,*) ij2
     CASE ( '-klim'  ) ; CALL getarg(ijarg,cldum  ) ; ijarg = ijarg+1 ; READ(cldum,*) ik1
        ;                CALL getarg(ijarg,cldum  ) ; ijarg = ijarg+1 ; READ(cldum,*) ik2
     CASE ( '-srange') ; CALL getarg(ijarg,cldum  ) ; ijarg = ijarg+1 ; READ(cldum,*) zsmin
        ;                CALL getarg(ijarg,cldum  ) ; ijarg = ijarg+1 ; READ(cldum,*) zsmax
        ;                CALL getarg(ijarg,cldum  ) ; ijarg = ijarg+1 ; READ(cldum,*) zds   
     CASE ( '-trange') ; CALL getarg(ijarg,cldum  ) ; ijarg = ijarg+1 ; READ(cldum,*) ztmin 
        ;                CALL getarg(ijarg,cldum  ) ; ijarg = ijarg+1 ; READ(cldum,*) ztmax 
        ;                CALL getarg(ijarg,cldum  ) ; ijarg = ijarg+1 ; READ(cldum,*) zdt   
     CASE ( '-o'     ) ; CALL getarg(ijarg,cf_out ) ; ijarg = ijarg+1
     CASE ( '-log'   ) ; CALL getarg(ijarg,cldum  ) ; ijarg = ijarg+1 ; READ(cldum,*) nlog
     CASE ( '-full'  ) ; lfull  = .TRUE.
     CASE ( '-vvl'   ) ; lg_vvl = .TRUE.
     CASE ( '-nc4'   ) ; lnc4   = .TRUE.
     CASE DEFAULT      ; PRINT *,' ERROR : ',TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  END DO
  IF ( cf_sfil == 'none') cf_sfil=cf_tfil
  cglobal = 'Census computed from '//TRIM(cf_tfil)

  lchk =           chkfile ( cn_fzgr )
  lchk = lchk .OR. chkfile ( cn_fhgr )
  lchk = lchk .OR. chkfile ( cf_tfil  )
  lchk = lchk .OR. chkfile ( cf_sfil  )
  IF ( lchk ) STOP 99  ! some compulsory files are missing

  PRINT *,' TS_FILE = ',TRIM(cf_tfil)
  PRINT *,' NLOG    = ', nlog

  ! set domain size from TS file
  npiglo = getdim (cf_tfil,cn_x)
  npjglo = getdim (cf_tfil,cn_y)
  npk    = getdim (cf_tfil,cn_z)
  npt    = getdim (cf_tfil,cn_t)

  PRINT *, 'npiglo =', npiglo
  PRINT *, 'npjglo =', npjglo
  PRINT *, 'npk    =', npk
  PRINT *, 'npt    =', npt

  ! Allocate memory
  ALLOCATE (zt(npiglo,npjglo),zs(npiglo,npjglo))
  ALLOCATE (e1t(npiglo,npjglo),e2t(npiglo,npjglo),e31d(npk),e3t(npiglo,npjglo))

  ! Read metrics
  e1t(:,:) = getvar  (cn_fhgr, cn_ve1t, 1, npiglo, npjglo)
  e2t(:,:) = getvar  (cn_fhgr, cn_ve2t, 1, npiglo, npjglo)
  e31d(:)  = getvare3(cn_fzgr, cn_ve3t1d, npk              )  ! used in full step case

  ! default is full domain, full depth
  IF ( ii1 == -1 ) ii1 = 1 
  IF ( ii2 == -1 ) ii2 = npiglo
  IF ( ij1 == -1 ) ij1 = 1 
  IF ( ij2 == -1 ) ij2 = npjglo
  IF ( ik1 == -1 ) ik1 = 1 
  IF ( ik2 == -1 ) ik2 = npk

  ! Extra checking for over bound
  ii1 = MAX(ii1,1) ; ii2 = MIN(ii2,npiglo)
  ij1 = MAX(ij1,1) ; ij2 = MIN(ij2,npjglo)
  ik1 = MAX(ik1,1) ; ik2 = MIN(ik2,npk   )

  IF ( lg_vvl ) THEN
     cn_fe3t=cf_tfil
     cn_ve3t=cn_ve3tvvl
  ENDIF

  PRINT '(a,6i5)','indices:',ii1, ii2, ij1, ij2, ik1, ik2

  ! Compute the census on the requested domain
  PRINT *,' Water mass census on the file '
  PRINT *, TRIM(cf_tfil)
  PRINT *, ' running .........'
  nt = NINT( (ztmax - ztmin )/zdt + 1 )
  ns = NINT( (zsmax - zsmin )/zds + 1 )

  ! Allocate arrays
  ALLOCATE ( dcensus (ns,nt), ddump(ns,nt) )
  ALLOCATE ( rsigma0(ns,nt), rsigma2(ns,nt), rsigma4(ns,nt) )
  ALLOCATE ( zsx (ns,nt), zty(ns,nt), dtim(npt))

  ! fill up rsigma0 array with theoretical density
  DO ji=1,ns
     DO jj=1,nt
        zsx(ji,jj) = zsmin + (ji-1)*zds
        zty(ji,jj) = ztmin + (jj-1)*zdt
     END DO
  END DO

  rsigma0 = sigma0(zty, zsx,        ns, nt)
  rsigma2 = sigmai(zty, zsx, 2000., ns, nt)
  rsigma4 = sigmai(zty, zsx, 4000., ns, nt)

  CALL CreateOutput

  DO jt = 1, npt
     IF ( lg_vvl ) THEN ; it_vvl=jt
     ELSE ;               it_vvl=1
     ENDIF
     ! reset cumulating variables to 0
     dcensus(:,:) = 0.d0
     dvoltotal    = 0.d0
     ! Enter main loop
     DO jk=ik1,ik2
        zt(:,:) = getvar(cf_tfil, cn_votemper, jk, npiglo, npjglo, ktime = jt)
        zs(:,:) = getvar(cf_sfil, cn_vosaline, jk, npiglo, npjglo, ktime = jt)

        IF ( lfull ) THEN
           e3t(:,:) = e31d(jk)
        ELSE
           e3t(:,:) = getvar(cn_fe3t, cn_ve3t, jk, npiglo, npjglo, ktime=it_vvl, ldiom=.NOT.lg_vvl )
        ENDIF

        DO ji=ii1,ii2
           DO jj=ij1,ij2
              ztpoint   = zt(ji,jj)
              zspoint   = zs(ji,jj)
              dvolpoint = e1t(ji,jj)*e2t(ji,jj)*e3t(ji,jj)*1.d0

              ! salinity = 0 on masked points ( OPA !!! )
              IF (zspoint /= 0) THEN
                 it=NINT( (ztpoint-ztmin)/zdt) + 1
                 is=NINT( (zspoint-zsmin)/zds) + 1
                 ! check for out of bound values
                 it = MIN ( MAX(it,1), nt )
                 is = MIN ( MAX(is,1), ns )

                 dcensus(is,it) = dcensus(is,it) + dvolpoint*1.d-15
                 dvoltotal      = dvoltotal      + dvolpoint*1.d-15
              END IF
           END DO
        END DO

     END DO  ! Main loop

     ! Compute some statistics
     rcmax = MAXVAL ( dcensus )
     ijloc = MAXLOC ( dcensus )
     zsm    = zsmin + (ijloc(1) -1 ) * zds
     ztm    = ztmin + (ijloc(2) -1 ) * zdt

     PRINT *,'  Total Volume of the domain in  10^15 m3:', REAL(dvoltotal)
     PRINT *,'  Volume of the most represented water mass :', rcmax 
     PRINT '(a,f6.2,a)' ,'       this is about ', rcmax/dvoltotal *100,' % of the total'
     PRINT *,'     Salinity   = ', zsm
     PRINT *,'     Temperature= ', ztm

     ! use a distorsion function ( n x log ) to reduce extrema in the output file.
     ddump(:,:) = dcensus(:,:)
     DO jlog = 1, nlog
        ddump(:,:) = LOG10 (1.d0 + ddump(:,:) )
     ENDDO

     ! Output on census.nc file
     ierr = putvar(ncout, id_varout(1), REAL(ddump), 1, ns, nt, ktime=jt)
     ierr = putvar(ncout, id_varout(2), rsigma0,     1, ns, nt, ktime=jt)
     ierr = putvar(ncout, id_varout(3), rsigma2,     1, ns, nt, ktime=jt)
     ierr = putvar(ncout, id_varout(4), rsigma4,     1, ns, nt, ktime=jt)
  ENDDO  ! time loop

  dtim = getvar1d(cf_tfil, cn_vtimec, npt     )
  ierr = putvar1d(ncout,   dtim,      npt, 'T')
  ierr = closeout(ncout)

  PRINT *,' Done.'
CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf files for output
    !!
    !! ** Method  :   Set file structure and use it !
    !!----------------------------------------------------------------------
    REAL(KIND=4), DIMENSION(1) :: zdumdep   ! dummy dep array for output

    zdumdep(:)=0.
    ! create output fileset
    ipk(:)= 1                  
    stypvar%rmissing_value    = -100.
    stypvar%valid_min         = 0.
    stypvar%valid_max         = 1.e20
    stypvar%conline_operation = 'N/A'
    stypvar%caxis             = 'TYX'

    stypvar(1)%ichunk         = (/ns,MAX(1,nt/30),1,1 /)
    stypvar(2)%ichunk         = (/ns,MAX(1,nt/30),1,1 /)
    stypvar(3)%ichunk         = (/ns,MAX(1,nt/30),1,1 /)
    stypvar(4)%ichunk         = (/ns,MAX(1,nt/30),1,1 /)

    stypvar(1)%cname          = 'volcensus'
    stypvar(2)%cname          = 'sigma0'
    stypvar(3)%cname          = 'sigma2'
    stypvar(4)%cname          = 'sigma4'

    stypvar(1)%cunits         = 'm3'
    stypvar(2:4)%cunits       = 'kg/m3'

    stypvar(1)%clong_name     = 'Volume_Census_TS'
    stypvar(2)%clong_name     = 'Sigma0_TS'
    stypvar(3)%clong_name     = 'Sigma2_TS'
    stypvar(4)%clong_name     = 'Sigma4_TS'

    stypvar(1)%cshort_name    = 'volcensus'
    stypvar(2)%cshort_name    = 'sigma0'
    stypvar(3)%cshort_name    = 'sigma2'
    stypvar(4)%cshort_name    = 'sigma4'

    ncout = create      (cf_out, cf_tfil,  ns, nt,  1                              , ld_nc4=lnc4)
    ierr  = createvar   (ncout,  stypvar,  4,  ipk, id_varout, cdglobal=cglobal    , ld_nc4=lnc4)
    ierr  = putheadervar(ncout,  cf_tfil,  ns, nt,  1,   pnavlon=zsx, pnavlat=zty, pdep=zdumdep )

  END SUBROUTINE CreateOutput

END PROGRAM cdfcensus

PROGRAM cdfwhereij
  !!======================================================================
  !!                     ***  PROGRAM  cdfwhereij  ***
  !!=====================================================================
  !!  ** Purpose : Give the values of longitude latitude for a given i, j
  !!
  !!  ** Method  : Read the coordinate/mesh_hgr file and look for the glam,
  !!               gphi variables. The point type ( T U V F ) is specified 
  !!               on the command line.
  !!
  !! History : 2.1  : 05/2005  : J.M. Molines : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class file_informations
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: narg, iargc    ! browse line
  INTEGER(KIND=4)                           :: ijarg          ! browse line
  INTEGER(KIND=4)                           :: iimin, iimax   ! i-zoom limit
  INTEGER(KIND=4)                           :: ijmin, ijmax   ! j-zoom limit
  INTEGER(KIND=4)                           :: npiglo, npjglo ! global size
  INTEGER(KIND=4)                           :: npts, ipts     ! number of pts, loop index
  INTEGER(KIND=4)                           :: numpts, numout ! file id

  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: glam, gphi     ! longitude, latitude

  CHARACTER(LEN=256)                        :: cv_lam         ! longitude name
  CHARACTER(LEN=256)                        :: cv_phi         ! latitude name
  CHARACTER(LEN=256)                        :: ctype='T'      ! type of point on C-grid
  CHARACTER(LEN=256)                        :: cldum          ! dummmy string
  CHARACTER(LEN=256)                        :: cfile, cfout   ! list of point
  CHARACTER(LEN=256)                        :: cname          ! name of the list of points
  CHARACTER(LEN=256)                        :: clcoo          ! dummy character variable

  LOGICAL :: llist = .FALSE. , lw = .FALSE. , lout = .FALSE. ! option flag 
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()
  clcoo = cn_fcoo


  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfwhereij  -w imin imax jmin jmax | -l LST-file]' 
     PRINT *,'                ...  [-c COOR-file] [-p C-type] [-o TXT-file]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Return the geographical coordinates of a model sub-area specified' 
     PRINT *,'       by a rectangular window in (i,j) space.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       One of the two following arguments is mandatory, according to your '
     PRINT *,'       wishes :'
     PRINT *,'       -w          : imin imax jmin jmax : (i,j) space window coordinates.' 
     PRINT *,'          or '
     PRINT *,'       -l LST-file : LST-file contains a list of points whse longitude and'
     PRINT *,'                     latitude will be looked up. It uses the same format than'
     PRINT *,'                     section files in other tools, with a 2-line header:'
     PRINT *,'                         NAME'
     PRINT *,'                         NPTS'
     PRINT *,'                         ii jj'
     PRINT *,'                         .....'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-c COOR_file ] : specify a coordinates file instead of ', TRIM(cn_fcoo)
     PRINT *,'       [-p C-type ]    : specify a point type on the C-grid (T U V F),  '
     PRINT *,'               default is ', TRIM(ctype),'.'
     PRINT *,'       [-o TXT-file ]  : output a text file that can be used directly in  '
     PRINT *,'                        cdf_xtract_broken tool. Only available if -l option '
     PRINT *,'                        activated'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ',TRIM(cn_fcoo),' or COOR-file given in the -c option'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       Standard output'
     PRINT *,'      '
     PRINT *,'     SEE ALSO : '
     PRINT *,'      cdffindij, cdf_xtract_broken'
     PRINT *,'      '
     STOP 
  ENDIF

  ijarg = 1 
  DO WHILE ( ijarg <= narg) 
     CALL getarg( ijarg, cldum ) ; ijarg= ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-w' ) ; lw = .TRUE.
        ;            CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1 ;  READ(cldum,*) iimin
        ;            CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1 ;  READ(cldum,*) iimax
        ;            CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1 ;  READ(cldum,*) ijmin
        ;            CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1 ;  READ(cldum,*) ijmax
     CASE ( '-l' ) ; CALL getarg(ijarg, cfile ) ; ijarg=ijarg+1 ; llist = .TRUE. 
        ! options
     CASE ( '-c' ) ; CALL getarg(ijarg, clcoo ) ; ijarg=ijarg+1
     CASE ( '-p' ) ; CALL getarg(ijarg, ctype ) ; ijarg=ijarg+1
     CASE ( '-o' ) ; CALL getarg(ijarg, cfout ) ; ijarg=ijarg+1 ; lout  = .TRUE.
     CASE DEFAULT  ; PRINT *,' ERROR : ', TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  END DO

  IF ( chkfile(clcoo) ) STOP 99 ! missing file

  npiglo = getdim (clcoo, cn_x)
  npjglo = getdim (clcoo, cn_y)

  ALLOCATE (glam(npiglo,npjglo), gphi(npiglo,npjglo) )

  SELECT CASE ( ctype )
  CASE ('T' , 't' ) ; cv_lam = cn_glamt ; cv_phi = cn_gphit
  CASE ('U' , 'u' ) ; cv_lam = cn_glamu ; cv_phi = cn_gphiu
  CASE ('V' , 'v' ) ; cv_lam = cn_glamv ; cv_phi = cn_gphiv
  CASE ('F' , 'f' ) ; cv_lam = cn_glamf ; cv_phi = cn_gphif
  CASE DEFAULT
     PRINT *,' ERROR : type of point not known: ', TRIM(ctype)
  END SELECT

  glam(:,:) = getvar(clcoo, cv_lam, 1, npiglo, npjglo)
  gphi(:,:) = getvar(clcoo, cv_phi, 1, npiglo, npjglo)

  IF ( lw ) THEN
     ! check index
     IF ( chkindex(iimin, ijmin) ) STOP 99
     IF ( chkindex(iimax, ijmax) ) STOP 99
     ! print output
     PRINT '(2a)'     ,' Type of point   : ', TRIM(ctype)
     PRINT '(a,4i6)'  ,'   I J zoom      : ', iimin, iimax, ijmin, ijmax
     PRINT '(a,4f9.3)','   LON LAT zoom  : ', glam(iimin,ijmin), glam(iimax,ijmax), gphi(iimin,ijmin), gphi(iimax,ijmax)

  ELSE IF (llist) THEN
     ! open section file
     OPEN(numpts,FILE=cfile)
     READ(numpts,*) cname 
     READ(numpts,*) npts 
     ! print std output
     PRINT '(2a)'     ,' Type of point   : ', TRIM(ctype)
     PRINT '(2a)'     ,'   NAME  : ', cname
     PRINT '(a,1i6)'  ,'   NUMBER of points : ', npts
     PRINT '(a)'      ,'---------------------------'
     PRINT *,''
     ! print xtract_broken output
     IF (lout) THEN
        numout = 42
        OPEN(numout,FILE=cfout)
        WRITE(numout,'(a)')   TRIM(cname) 
        WRITE(numout,'(4i6)') npts 
     END IF

     DO ipts = 1,npts
        ! read point
        READ(numpts,*) iimin,ijmin
        IF ( chkindex(iimin, ijmin) ) STOP 99
        ! print std output
        PRINT '(a,1i6)'  ,'   POINT         : ', ipts
        PRINT '(a,2i6)'  ,'   I J zoom      : ', iimin, ijmin
        PRINT '(a,2f9.3)','   LON LAT zoom  : ', glam(iimin,ijmin), gphi(iimin,ijmin)
        PRINT *,''
        ! print xtract_broken output
        IF (lout) THEN
           WRITE(numout,'(2f9.3)') glam(iimin,ijmin), gphi(iimin,ijmin)
        END IF
     END DO
  ELSE
     PRINT  *, ' *** ERROR: you must use either -w or -l arguments.'
     STOP 99
  END IF

CONTAINS

  LOGICAL FUNCTION chkindex(kii,kjj)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION chkindex ***
    !!
    !! ** Purpose :  check if a the point specified by kii, kjj is within
    !!               the model boundaries. 
    !!
    !! ** Method  :  chkindex is set to TRUE if either kii or kjj is greater
    !!               than respectively npiglo or npjglo. In this case an error
    !!               message is printed. 
    !!               If the point is OK, chkindex is false, which allows a 
    !!               simple test like :
    !!               IF ( chkindex (ii,ij) ) STOP ! point outside the domain.
    !!
    !!----------------------------------------------------------------------
     INTEGER(KIND=4), INTENT( in ) :: kii, kjj 

     chkindex = .FALSE.
     IF ( kii > npiglo ) THEN
        PRINT *,' ERROR : imax is greater than the maximum size ', kii, npiglo
        chkindex = .TRUE.
     ENDIF

     IF ( kjj > npjglo ) THEN
        PRINT *,' ERROR : jmax is greater than the maximum size ', kjj, npjglo
        chkindex = .TRUE.
     END IF

  END FUNCTION chkindex

END PROGRAM cdfwhereij

PROGRAM cdfgeostrophy
  !!======================================================================
  !!                     ***  PROGRAM  cdfgeostrophy  ***
  !!=====================================================================
  !!  ** Purpose : Compute the ug and vg component of the geostrophic 
  !!               velocity from ssh and density field
  !!
  !!  ** Method  : * Integrate pressure from surface to current level
  !!                 P(n) = rho_insitu(1) * g * ssh 
  !!                      + sum( rho_insitu(k) * g * h(k) ) k=1,n-1
  !!                      + rho_insitu(n) * g * h(n) / 2
  !!
  !!                 h = level thickness
  !!
  !!               * Interpolation of Pressure on F points
  !!                 values on F-point are given
  !!                 by the demi-sum of X points (on the diagonal)
  !!
  !!                 p1 = 0.5 * ( A + B )
  !!                 p1 = 0.5 * ( B + C )
  !!                 p1 = 0.5 * ( C + D )
  !!
  !!                 F--------F--------F--------F
  !!                 |        |        |        |
  !!                 |        |   B    |        |
  !!                 |        |        |        |
  !!                 F--------p1--V----p2-------F
  !!                 |        |        |        |
  !!                 |   A    |  Pi,j  U   C    |
  !!                 |        |        |        |
  !!                 F--------F--------p3-------F
  !!                 |        |        |        |
  !!                 |        |   D    |        |
  !!                 |        |        |        |
  !!                 F--------F--------F--------F
  !!
  !!               * Compute local coriolis parameter at U and V point
  !!
  !!                 F--------F1--V----F2-------F
  !!                 |        |        |        |
  !!                 |        |   Pij  U        |
  !!                 |        |        |        |
  !!                 F--------F--------F3-------F
  !!
  !!                 Vg computation : Fij_v = 0.5 * ( F1 + F2 )
  !!                 Ug computation : Fij_u = 0.5 * ( F2 + F3 )
  !!
  !!               * Compute geostrophic balance
  !!
  !!                 Vg(i,j) = +1 * ( 1 / rho0 * Fij_v ) * ( p2 - p1 ) / e1v(i,j)
  !!                 Ug(i,j) = -1 * ( 1 / rho0 * Fij_u ) * ( p2 - p3 ) / e2u(i,j)
  !!               
  !!               * Masking :
  !!
  !!                 - if A,B or C are land points -> Vg = 0
  !!                 - if B,C or D are land points -> Ug = 0
  !!                 - multiplied by umask and vmask
  !!                 - if f < 1e-5, we mask
  !!
  !!  **  Note : Ug is located on a U grid point
  !!             Vg                 V grid point
  !!
  !!
  !! History : 3.0  : 01/2011  : R.Dussin : original code
  !!----------------------------------------------------------------------
  USE cdfio
  USE eos
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: ji, jj, jt     ! dummy loop index
  INTEGER(KIND=4)                           :: npiglo, npjglo ! size of the domain
  INTEGER(KIND=4)                           :: npk, npt       ! size of the domain
  INTEGER(KIND=4)                           :: jk             ! vertical index
  INTEGER(KIND=4)                           :: narg, iargc    ! browse line
  INTEGER(KIND=4)                           :: ncoutu         ! ncid for ugeo file
  INTEGER(KIND=4)                           :: ncoutv         ! ncid for vgeo file
  INTEGER(KIND=4)                           :: ierr           ! error status
  INTEGER(KIND=4), DIMENSION(1)             :: ipk            ! levels of output vars
  INTEGER(KIND=4), DIMENSION(1)             :: id_varoutu     ! varid for ugeo
  INTEGER(KIND=4), DIMENSION(1)             :: id_varoutv     ! varid for vgeo

  REAL(KIND=4)                              :: grav           ! gravity
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: tim            ! time counter
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: deptht, depthw
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e1u, e2v, ff   ! horiz metrics, coriolis (f-point)
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e1v, e2u       ! horiz metrics
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e3             ! vertic metrics
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: glamu, gphiu   ! longitude latitude u-point
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: glamv, gphiv   ! longitude latitude v-point
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: umask, vmask   ! mask at u and v points
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: tmask          ! mask at t points
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zsigsurf       ! density at first level (used for zpsurf)
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zsiglevel      ! density at current level (used for zplevel/zphalflevel)
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zt, zsal       ! temporary arrays for temperature and salinity

  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: un, vn         ! velocity components
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: zsshn          ! ssh
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: zpupper        ! total pressure above current level
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: zphalflevel    ! pressure at T-point of current level
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: zplevel        ! pressure at bottom W-point of current level
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: zpsurf         ! pressure due to SSH
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: zptot          ! total pressure at current level

  REAL(KIND=4)                              :: zhlevel        ! thickness of current level
  REAL(KIND=4)                              :: zhhalflevel    ! thickness of half the current level
  REAL(KIND=4)                              :: zrho0          ! reference density in geos balance
  REAL(KIND=4)                              :: zohr0          ! reference density in geos balance
  REAL(KIND=4)                              :: zffu, zffv     ! local coriolis parameter
  REAL(KIND=4)                              :: zp1, zp2       ! dummy for pressure interp
  REAL(KIND=4)                              :: zp3, zp4       ! dummy for pressure interp
  REAL(KIND=4)                              :: zumask, zvmask ! dummy for mask 

  CHARACTER(LEN=256)                        :: cf_tfil        ! input file name
  CHARACTER(LEN=256)                        :: cf_uout='ugeo.nc' 
  CHARACTER(LEN=256)                        :: cf_vout='vgeo.nc'

  TYPE(variable), DIMENSION(1)              :: stypvaru       ! attributes for ugeo
  TYPE(variable), DIMENSION(1)              :: stypvarv       ! attributes for vgeo

  LOGICAL                                   :: lchk           ! file existence flag
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  grav = 9.81  ! gravity
  zrho0 = 1025 ! reference density
  zohr0 = 1. / zrho0

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfgeostrophy T-file'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the geostrophic velocity component from the pressure gradient '
     PRINT *,'       computed from SSH and in-situ density (T,S of input file) '
     PRINT *,'      '
     PRINT *,'     WARNING : USE AT YOUR OWN RISKS'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       T-file : netcdf file with SSH, T and S.' 
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        ',TRIM(cn_fmsk),' ',TRIM(cn_fhgr),' and ',TRIM(cn_fzgr)
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       - netcdf file : ', TRIM(cf_uout) 
     PRINT *,'           variables : ', TRIM(cn_vozocrtx)
     PRINT *,'       - netcdf file : ', TRIM(cf_vout) 
     PRINT *,'           variables : ', TRIM(cn_vomecrty)
     STOP
  ENDIF

  CALL getarg(1, cf_tfil)

  lchk = chkfile(cn_fhgr)
  lchk = chkfile(cn_fzgr) .OR. lchk
  lchk = chkfile(cn_fmsk) .OR. lchk
  lchk = chkfile(cf_tfil) .OR. lchk
  IF ( lchk ) STOP ! missing file

  npiglo = getdim(cf_tfil, cn_x)
  npjglo = getdim(cf_tfil, cn_y)
  npk    = getdim(cf_tfil, cn_z) 
  npt    = getdim(cf_tfil, cn_t) 

  PRINT *, 'npiglo =', npiglo
  PRINT *, 'npjglo =', npjglo
  PRINT *, 'npk =', npk

  ipk(1)                        = npk
  stypvaru(1)%cname             = TRIM(cn_vozocrtx)
  stypvaru(1)%cunits            = 'm/s'
  stypvaru(1)%rmissing_value    = 0.
  stypvaru(1)%valid_min         = -20.
  stypvaru(1)%valid_max         = 20.
  stypvaru(1)%clong_name        = 'Zonal_Geostrophic_Velocity'
  stypvaru(1)%cshort_name       = TRIM(cn_vozocrtx)
  stypvaru(1)%conline_operation = 'N/A'
  stypvaru(1)%caxis             = 'TZYX'

  stypvarv(1)%cname             = TRIM(cn_vomecrty)
  stypvarv(1)%cunits            = 'm/s'
  stypvarv(1)%rmissing_value    = 0.
  stypvarv(1)%valid_min         = -20.
  stypvarv(1)%valid_max         = 20.
  stypvarv(1)%clong_name        = 'Meridional_Geostrophic_Velocity'
  stypvarv(1)%cshort_name       = TRIM(cn_vomecrty)
  stypvarv(1)%conline_operation = 'N/A'
  stypvarv(1)%caxis             = 'TZYX'

  ! Allocate the memory
  ALLOCATE ( e1v(npiglo,npjglo), e2u(npiglo,npjglo) )
  ALLOCATE ( ff(npiglo,npjglo) )
  ALLOCATE ( glamu(npiglo,npjglo), gphiu(npiglo,npjglo)  )
  ALLOCATE ( glamv(npiglo,npjglo), gphiv(npiglo,npjglo)  )
  ALLOCATE ( un(npiglo,npjglo), vn(npiglo,npjglo)  )
  ALLOCATE ( zsshn(npiglo,npjglo) )
  ALLOCATE ( umask(npiglo,npjglo), vmask(npiglo,npjglo) )
  ALLOCATE ( tmask(npiglo,npjglo) )
  ALLOCATE ( zpupper(npiglo,npjglo), zpsurf(npiglo,npjglo) )
  ALLOCATE ( zphalflevel(npiglo,npjglo), zplevel(npiglo,npjglo) )
  ALLOCATE ( zptot(npiglo,npjglo) )
  ALLOCATE ( zt(npiglo,npjglo), zsal(npiglo,npjglo) )
  ALLOCATE ( deptht(npk), depthw(npk) )
  ALLOCATE ( zsigsurf(npiglo,npjglo) , zsiglevel(npiglo,npjglo) )
  ALLOCATE ( e3(npiglo,npjglo) )
  ALLOCATE ( tim(npt) )

  ! Read the metrics from the mesh_hgr file
  e2u   = getvar(cn_fhgr, cn_ve2u,  1, npiglo, npjglo)
  e1v   = getvar(cn_fhgr, cn_ve1v,  1, npiglo, npjglo)
  ff    = getvar(cn_fhgr, cn_vff,   1, npiglo, npjglo) 

  glamu = getvar(cn_fhgr, cn_glamu, 1, npiglo, npjglo)
  gphiu = getvar(cn_fhgr, cn_gphiu, 1, npiglo, npjglo)
  glamv = getvar(cn_fhgr, cn_glamv, 1, npiglo, npjglo)
  gphiv = getvar(cn_fhgr, cn_gphiv, 1, npiglo, npjglo)

  deptht(:) = getvar1d(cf_tfil, cn_vdeptht, npk    )

  ! create output filesets
  ! U geo  
  ncoutu = create      (cf_uout, cf_tfil,  npiglo, npjglo, npk                            )
  ierr   = createvar   (ncoutu,  stypvaru, 1,      ipk,    id_varoutu                     )
  ierr   = putheadervar(ncoutu,  cf_tfil,  npiglo, npjglo, npk, pnavlon=glamu, pnavlat=gphiu)
  tim  = getvar1d(cf_tfil, cn_vtimec, npt     )
  ierr = putvar1d(ncoutu,  tim,       npt, 'T')

  ! V geo 
  ncoutv = create      (cf_vout, cf_tfil,  npiglo, npjglo, npk                            )
  ierr   = createvar   (ncoutv,  stypvarv, 1,      ipk,    id_varoutv                     )
  ierr   = putheadervar(ncoutv,  cf_tfil,  npiglo, npjglo, npk, pnavlon=glamv, pnavlat=gphiv)

  tim  = getvar1d(cf_tfil, cn_vtimec, npt     )
  ierr = putvar1d(ncoutv,  tim,       npt, 'T')

  ! time loop
  DO jt=1,npt

     ! Read ssh
     zsshn = getvar(cf_tfil, cn_sossheig, 1, npiglo, npjglo, ktime=jt)
     ! Read temperature and salinity
     zt   = getvar(cf_tfil, cn_votemper, 1, npiglo, npjglo, ktime=jt)
     zsal = getvar(cf_tfil, cn_vosaline, 1, npiglo, npjglo, ktime=jt)
     ! Compute density at first level
     zsigsurf(:,:) = 1000. + sigmai ( zt,zsal,deptht(1),npiglo,npjglo )
     ! Compute psurf (pressure due to SSH)
     zpsurf(:,:) = zsigsurf * grav * zsshn

     zpupper(:,:) = 0.d0

     DO jk=1,npk

         tmask = getvar(cn_fmsk, 'tmask',  jk, npiglo, npjglo)
         umask = getvar(cn_fmsk, 'umask',  jk, npiglo, npjglo)
         vmask = getvar(cn_fmsk, 'vmask',  jk, npiglo, npjglo)

         PRINT *,'Working on level ', jk
         !! 1. First we compute integrated pressure from the surface to current level

         ! Thickness
         e3  = getvar(cn_fzgr, cn_ve3t, jk, npiglo, npjglo)
         ! MAXVAL is used to avoid partial steps
         zhlevel     = MAXVAL(e3)
         zhhalflevel = 0.5 * MAXVAL(e3)
         ! 
         !PRINT *,' At level ', jk, ' thickness is ', zhlevel
         ! Read temperature and salinity at current level
         zt   = getvar(cf_tfil, cn_votemper, jk, npiglo, npjglo, ktime=jt)
         zsal = getvar(cf_tfil, cn_vosaline, jk, npiglo, npjglo, ktime=jt)
         ! Compute density of this level
         zsiglevel(:,:) = 1000. + sigmai ( zt,zsal,deptht(jk),npiglo,npjglo )
         ! Compute the pressure at T-point 
         zphalflevel(:,:) = zsiglevel * grav * zhhalflevel
         ! Compute the pressure at bottom W-point
         zplevel(:,:) =  zsiglevel * grav * zhlevel
         ! Compute the total pression -> This one is used in the geostrophic balance !
         zptot(:,:) = zpsurf(:,:) + zpupper(:,:) + zphalflevel(:,:)
         ! update zpupper for next level
         zpupper(:,:) = zpupper(:,:) + zplevel(:,:)

         !! 2. We compute the velocities from geostrophic balance

         un(:,:) = 0.d0
         vn(:,:) = 0.d0

         DO jj=2,npjglo-1
            DO ji=2,npiglo-1

               ! local coriolis parameter
               zffu = 0.5 * ( ff(ji,jj) + ff(ji,jj-1) )
               zffv = 0.5 * ( ff(ji,jj) + ff(ji-1,jj) )

               ! interp on F points 
               zp1 = 0.5 * ( zptot(ji-1,jj) + zptot(ji,jj+1) ) 
               zp2 = 0.5 * ( zptot(ji+1,jj) + zptot(ji,jj+1) )
               zp3 = 0.5 * ( zptot(ji,jj-1) + zptot(ji+1,jj) )

               zumask = tmask(ji,jj-1) * tmask(ji+1,jj) * tmask(ji,jj+1)
               zvmask = tmask(ji-1,jj) * tmask(ji,jj+1) * tmask(ji+1,jj)

               ! geostrophic balance
               vn(ji,jj) = +1 * ( zohr0 / zffv ) * ( zp2 - zp1 ) / e1v(ji,jj)
               un(ji,jj) = -1 * ( zohr0 / zffu ) * ( zp2 - zp3 ) / e2u(ji,jj)

               vn(ji,jj) = vn(ji,jj) * zvmask
               un(ji,jj) = un(ji,jj) * zumask

            ENDDO
         ENDDO

     WHERE ( ABS(ff) < 1.e-5 ) un(:,:) = 0.d0
     WHERE ( ABS(ff) < 1.e-5 ) vn(:,:) = 0.d0
 
     un(:,:) = un(:,:) * umask(:,:)
     vn(:,:) = vn(:,:) * vmask(:,:)

     ! write un and vn  ...
     ierr = putvar(ncoutu, id_varoutu(1), un(:,:), jk, npiglo, npjglo, ktime=jt)
     ierr = putvar(ncoutv, id_varoutv(1), vn(:,:), jk, npiglo, npjglo, ktime=jt)


    ENDDO ! vertical loop

  END DO  ! time loop

  ierr = closeout(ncoutu)
  ierr = closeout(ncoutv)

END PROGRAM cdfgeostrophy

PROGRAM cdfvita_geo
  !!======================================================================
  !!                     ***  PROGRAM  cdfvita_geo  ***
  !!=====================================================================
  !!  ** Purpose : Compute velocity on t grid
  !!
  !!  ** Method  : Read velocity component on input gridU and gridV file
  !!               Use gridT file for the proper location of T points
  !!               The velocity module is also output (same function than
  !!               cdfspeed) If a gridW file is given, (fifth argument)
  !!               then w is also computed on the T grid
  !!
  !! History : 2.1  : 11/2006  : J.M. Molines : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio 
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                            :: ji, jj, jk, jt, jlev    ! dummy loop index
  INTEGER(KIND=4)                            :: narg, iargc, ijarg      ! browse line
  INTEGER(KIND=4)                            :: npiglo,npjglo           ! size of the domain
  INTEGER(KIND=4)                            :: npk, npt                ! size of the domain
  INTEGER(KIND=4)                            :: nlev, ik                ! number of selected levels, current lev
  INTEGER(KIND=4)                            :: ncout                   ! ncid of output file
  INTEGER(KIND=4)                            :: ierr                    ! error status for cdfio
  INTEGER(KIND=4)                            :: nvar                    ! number of variable
  INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE :: nklev                   ! selected levels
  INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE :: ipk, id_varout          ! output stuff

  REAL(KIND=4), DIMENSION(:),    ALLOCATABLE :: tim                     ! time counter array
  REAL(KIND=4), DIMENSION(:),    ALLOCATABLE :: gdeptall, gdept         ! depths and selected depths
  REAL(KIND=4), DIMENSION(:,:),  ALLOCATABLE :: uc, vc                  ! velocity component on C grid
  REAL(KIND=4), DIMENSION(:,:),  ALLOCATABLE :: ua, va, vmod            ! velocity component on A grid

  TYPE(variable), DIMENSION(:),  ALLOCATABLE :: stypvar                 ! data attributes

  CHARACTER(LEN=256)                         :: cf_ufil, cf_vfil        ! velocity files on C grid
  CHARACTER(LEN=256)                         :: cf_wfil                 ! optional W file on C grid
  CHARACTER(LEN=256)                         :: cf_tfil                 ! GridT file for T position
  CHARACTER(LEN=256)                         :: cf_out='vita.nc'        ! output file name
  CHARACTER(LEN=256)                         :: cldum                   ! dummy char variable

  LOGICAL                                    :: lvertical = .FALSE.     ! vertical velocity  flag 
  LOGICAL                                    :: lperio    = .FALSE.     ! E_W periodicity flag 
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfvita-geo  Ugeo-file Vgeo_file T-file [-w W-file] [-lev level_list]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Create a file with velocity components and module computed'
     PRINT *,'       at T points from file on C-grid. T-file is used only for' 
     PRINT *,'       getting the header of the output file. Any file on T grid'
     PRINT *,'       can be used.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       Ugeo-file  : netcdf file with zonal component of velocity' 
     PRINT *,'       Vgeo-file  : netcdf file with meridional component of velocity' 
     PRINT *,'       T-file  : netcdf file with T points header OK.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [ -w W-file ] : if used, also compute vertical velocities at' 
     PRINT *,'                       T points.'
     PRINT *,'       [ -lev level_list] : specify a list of level to be used '
     PRINT *,'                   (default option is to use all input levels).'
     PRINT *,'                   This option MUST be the last on the command line !!'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        none'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : sovitua, sovitva, sovitmod, [sovitwa]'
     STOP
  ENDIF

  nlev = 0
  ijarg=1
  DO WHILE ( ijarg <= narg )
     CALL getarg( ijarg, cldum ) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-lev' )
        nlev= narg - ijarg + 1
        ALLOCATE (nklev(nlev) )
        DO jlev = 1, nlev
           CALL getarg( ijarg, cldum ) ; ijarg=ijarg+1 ; READ(cldum,* ) nklev(jlev)
        ENDDO
     CASE ( '-w' )
        CALL getarg( ijarg, cf_wfil ) ; ijarg=ijarg+1
        lvertical=.TRUE.
     CASE DEFAULT
        cf_ufil=cldum
        CALL getarg( ijarg, cf_vfil ) ; ijarg=ijarg+1
        CALL getarg( ijarg, cf_tfil ) ; ijarg=ijarg+1
     END SELECT
  ENDDO

  ! adjust number of variable according to -w option
  nvar=3
  IF ( lvertical )  nvar = 4

  ALLOCATE ( ipk(nvar), id_varout(nvar), stypvar(nvar) )

  IF ( chkfile(cf_ufil) .OR. chkfile(cf_vfil) .OR. chkfile(cf_tfil) ) STOP ! missing file

  IF ( lvertical ) THEN 
     IF ( chkfile(cf_wfil) ) STOP ! missing file
  ENDIF

  npiglo = getdim (cf_ufil,cn_x)
  npjglo = getdim (cf_ufil,cn_y)
  npk    = getdim (cf_ufil,cn_z)
  npt    = getdim (cf_ufil,cn_t)

  IF ( npk == 0 ) THEN ; npk = 1 ; ENDIF

  IF ( nlev == 0 ) THEN ! take all levels
     nlev = npk
     ALLOCATE (nklev(nlev) )
     DO jlev = 1, nlev
        nklev(jlev) = jlev
     ENDDO
  ENDIF

  ALLOCATE ( gdept(nlev) )

  ! Zonal Velocity T point
  ipk(1)                       = nlev
  stypvar(1)%cname             = 'sovitua'
  stypvar(1)%cunits            = 'm/s'
  stypvar(1)%rmissing_value    = 0.
  stypvar(1)%valid_min         = 0.
  stypvar(1)%valid_max         = 10000.
  stypvar(1)%clong_name        = 'Zonal Velocity T point'
  stypvar(1)%cshort_name       = 'sovitua'
  stypvar(1)%conline_operation = 'N/A'
  stypvar(1)%caxis             = 'TZYX'

  ! Meridional Velocity T point
  ipk(2)                       = nlev
  stypvar(2)%cname             = 'sovitva'
  stypvar(2)%cunits            = 'm/s'
  stypvar(2)%rmissing_value    = 0.
  stypvar(2)%valid_min         = 0.
  stypvar(2)%valid_max         = 10000.
  stypvar(2)%clong_name        = 'Meridional Velocity T point'
  stypvar(2)%cshort_name       = 'sovitva'
  stypvar(2)%conline_operation = 'N/A'
  stypvar(2)%caxis             = 'TZYX'

  ! Velocity module T point
  ipk(3)                       = nlev
  stypvar(3)%cname             = 'sovitmod'
  stypvar(3)%cunits            = 'm/s'
  stypvar(3)%rmissing_value    = 0.
  stypvar(3)%valid_min         = 0.
  stypvar(3)%valid_max         = 10000.
  stypvar(3)%clong_name        = 'Velocity module T point'
  stypvar(3)%cshort_name       = 'sovitmod'
  stypvar(3)%conline_operation = 'N/A'
  stypvar(3)%caxis             = 'TZYX'

  IF ( lvertical ) THEN
     ! Vertical Velocity at T point
     ipk(nvar)                       = nlev
     stypvar(nvar)%cname             = 'sovitwa'
     stypvar(nvar)%cunits            = 'mm/s'
     stypvar(nvar)%rmissing_value    = 0.
     stypvar(nvar)%valid_min         = 0.
     stypvar(nvar)%valid_max         = 10000.
     stypvar(nvar)%clong_name        = 'Vertical Velocity at T point'
     stypvar(nvar)%cshort_name       = 'sovitwa'
     stypvar(nvar)%conline_operation = 'N/A'
     stypvar(nvar)%caxis             = 'TZYX'
  ENDIF

  PRINT *, 'npiglo =', npiglo
  PRINT *, 'npjglo =', npjglo
  PRINT *, 'npk    =', npk
  PRINT *, 'npt    =', npt
  PRINT *, 'nlev   =', nlev

  ALLOCATE( uc(npiglo,npjglo), vc(npiglo,npjglo)  )
  ALLOCATE( ua(npiglo,npjglo), va(npiglo,npjglo), vmod(npiglo,npjglo) )
  ALLOCATE( tim(npt), gdeptall(npk) )

  gdeptall(:) = getvar1d(cf_tfil,cn_vdeptht, npk)
  DO jlev = 1, nlev
     ik = nklev(jlev)
     gdept(jlev) = gdeptall(ik)
  ENDDO

  ! check E-W periodicity using uc array as working space
  uc(:,:) = getvar(cf_tfil, cn_vlon2d, 1, npiglo, npjglo )
  IF ( uc(1,1) == uc(npiglo-1,1) )  THEN 
    lperio = .TRUE.
    PRINT *,' E-W periodicity detected.'
  ENDIF

  ncout = create      (cf_out,   cf_tfil,  npiglo, npjglo, nlev                 )
  ierr  = createvar   (ncout ,   stypvar,  nvar,   ipk,    id_varout            )
  ierr  = putheadervar(ncout,    cf_tfil,  npiglo, npjglo, nlev,     pdep=gdept )

  DO jt = 1, npt
     DO jlev = 1, nlev
        ik = nklev(jlev)
        uc(:,:) = getvar(cf_ufil, cn_vozocrtx, ik ,npiglo, npjglo, ktime=jt )
        vc(:,:) = getvar(cf_vfil, cn_vomecrty, ik ,npiglo, npjglo, ktime=jt )

        ua = 0. ; va = 0. ; ua(:,:) = 0. ; va(:,:)=0. ; vmod(:,:)=0.
        DO ji=2, npiglo
           DO jj=2,npjglo
              ua(ji,jj)   = 0.5* (uc(ji,jj  )+ uc(ji,jj-1))
              va(ji,jj)   = 0.5* (vc(ji-1,jj)+ vc(ji,jj  ))
              vmod(ji,jj) = SQRT( ua(ji,jj)*ua(ji,jj) + va(ji,jj)*va(ji,jj) )
           END DO
        END DO
        IF ( lperio) THEN  ! periodic E-W boundary ...
          ua  (1,:) = ua  (npiglo-1,:)
          va  (1,:) = va  (npiglo-1,:)
          vmod(1,:) = vmod(npiglo-1,:)
        ENDIF

        ierr=putvar(ncout, id_varout(1), ua,   jlev ,npiglo, npjglo, ktime=jt )
        ierr=putvar(ncout, id_varout(2), va,   jlev ,npiglo, npjglo, ktime=jt )
        ierr=putvar(ncout, id_varout(3), vmod, jlev ,npiglo, npjglo, ktime=jt )
     END DO
  END DO

  IF ( lvertical ) THEN
     ! reuse uc an vc arrays to store Wk and Wk+1
     DO jt = 1, npt
        DO jlev=1, nlev - 1
           uc(:,:) = getvar(cf_wfil, cn_vovecrtz, nklev(jlev),   npiglo, npjglo, ktime=jt )
           vc(:,:) = getvar(cf_wfil, cn_vovecrtz, nklev(jlev)+1, npiglo, npjglo, ktime=jt )
           ua(:,:) = 0.5*(uc(:,:) + vc(:,:))*1000.  ! mm/sec
           ierr    = putvar(ncout, id_varout(4), ua, jlev,      npiglo, npjglo, ktime=jt )
           uc(:,:) = vc(:,:)
        END DO
        IF ( nlev == npk ) THEN
           ua(:,:) = 0.e0  ! npk
        ELSE
           uc(:,:) = getvar(cf_wfil, cn_vovecrtz, nklev(nlev),   npiglo, npjglo, ktime=jt )
           vc(:,:) = getvar(cf_wfil, cn_vovecrtz, nklev(nlev)+1, npiglo, npjglo, ktime=jt )
           ua(:,:) = 0.5*(uc(:,:) + vc(:,:))*1000.  ! mm/sec
     ENDIF
        ierr = putvar(ncout, id_varout(4), ua, nlev ,npiglo, npjglo, ktime=jt )
     ENDDO
  ENDIF

  tim  = getvar1d(cf_ufil, cn_vtimec, npt     )
  ierr = putvar1d(ncout,  tim,       npt, 'T')
  ierr = closeout(ncout)

END PROGRAM cdfvita_geo

PROGRAM cdfbotpressure
  !!======================================================================
  !!                     ***  PROGRAM  cdfbotpressure  ***
  !!=====================================================================
  !!  ** Purpose : Compute bottom pressure from insitu density
  !!
  !!  ** Method  : Vertical integral of rho g dz
  !!               eventually takes into account the SSH, and full step
  !!
  !! History : 3.0  : 01/2013  : J.M. Molines   : Original code from cdfvint
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE eos
  USE modcdfnames
  USE modutils
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class bottom
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: jk, jt              ! dummy loop index
  INTEGER(KIND=4)                           :: it                  ! time index
  INTEGER(KIND=4)                           :: ierr, iko           ! working integer
  INTEGER(KIND=4)                           :: narg, iargc, ijarg  ! command line 
  INTEGER(KIND=4)                           :: npiglo, npjglo      ! size of the domain
  INTEGER(KIND=4)                           :: npk, npt            ! size of the domain
  INTEGER(KIND=4)                           :: ncout, nvar
  INTEGER(KIND=4)                           :: nbotpres, nssheig, nsshpre,npre3d
  INTEGER(KIND=4),DIMENSION(:), ALLOCATABLE :: ipk, id_varout      ! only one output variable

  REAL(KIND=4), PARAMETER                   :: pp_grav = 9.81      ! Gravity
  REAL(KIND=4), PARAMETER                   :: pp_rau0 = 1035.e0   ! Reference density (as in NEMO)
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: gdepw               ! depth
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: e31d                ! vertical metrics in case of full step
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e3t                 ! vertical metric
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: hdept               ! vertical metric
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zt                  ! Temperature
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zs                  ! Salinity
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: tmask               ! npiglo x npjglo

  REAL(KIND=8), DIMENSION(:),   ALLOCATABLE :: dtim                ! time counter
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dl_psurf            ! Surface pressure
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dl_bpres            ! Bottom pressure
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dl_sigi             ! insitu density

  CHARACTER(LEN=256)                        :: cf_tfil             ! input gridT file
  CHARACTER(LEN=256)                        :: cf_sfil             ! salinity file (option)
  CHARACTER(LEN=256)                        :: cf_sshfil           ! ssh file (option)
  CHARACTER(LEN=256)                        :: cf_out='botpressure.nc'   ! output file
  CHARACTER(LEN=256)                        :: cldum               ! dummy string for command line browsing
  CHARACTER(LEN=256)                        :: cglobal             ! Global attribute

  LOGICAL                                   :: lfull =.FALSE.      ! flag for full step computation
  LOGICAL                                   :: lssh  =.FALSE.      ! Use ssh and cst surf. density in the bot pressure
  LOGICAL                                   :: lssh2 =.FALSE.      ! Use ssh and variable surf.density in the bot pressure
  LOGICAL                                   :: lxtra =.FALSE.      ! Save ssh and ssh pressure
  LOGICAL                                   :: lchk  =.FALSE.      ! flag for missing files
  LOGICAL                                   :: lnc4  =.FALSE.      ! Use nc4 with chunking and deflation
  LOGICAL                                   :: llev  =.FALSE.      ! Save pressure at each level in the output

  TYPE(variable), DIMENSION(:), ALLOCATABLE :: stypvar             ! extension for attributes
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfbotpressure -t T-file [-s S-file] [-full] [-ssh] [-ssh2 ] [-lev] ...'
     PRINT *,'             ... [--ssh-file SSH-file] [-xtra ] [-vvl ] [ -o OUT-file ] [-nc4]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'          Compute the bottom pressure (pa) from in situ density.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'         -t T-file : gridT file holding both temperature and salinity.'
     PRINT *,'               If salinity is not in T-file, use -s option.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'        [-s S-file ]: specify salinity file, if not T-file.'
     PRINT *,'      [--ssh-file SSH-file] : specify the ssh file if not in T-file.'
     PRINT *,'        [-full] : for full step computation ' 
     PRINT *,'        [-lev ] : save the 3D pressure in the output file.'
     PRINT *,'        [-ssh]  : Also take SSH into account in the computation'
     PRINT *,'                In this case, use rau0=',pp_rau0,' kg/m3 for '
     PRINT *,'                surface density (as in NEMO)'
     PRINT *,'                  If you want to use 2d surface density from '
     PRINT *,'                the model, use option -ssh2'
     PRINT *,'        [-ssh2] : as option -ssh but surface density is taken from '
     PRINT *,'                the model instead of a constant'
     PRINT *,'        [-xtra] :  Using this option, the output file also contains the ssh,'
     PRINT *,'                and the pressure contribution of ssh to bottom pressure. '
     PRINT *,'                Require either -ssh or -ssh2 option. Botpressure is still'
     PRINT *,'                the total pressure, including ssh effect.'
     PRINT *,'        [-vvl]  : Use  time-varying vertical metrics e3t'
     PRINT *,'        [-o OUT-file] : specify output file instead of ',TRIM(cf_out)
     PRINT *,'        [-nc4]  : Use netcdf4 output with chunking and deflation level 1.'
     PRINT *,'                 This option is effective only if cdftools are compiled with'
     PRINT *,'                 a netcdf library supporting chunking and deflation.'
     PRINT *,'      '
     PRINT *,'     OPENMP SUPPORT : yes'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ', TRIM(cn_fmsk),' and ', TRIM(cn_fzgr) 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ',TRIM(cf_out),' unless -o option is used.'
     PRINT *,'         variables :  sobotpres, [',TRIM(cn_sossheig),' sosshpre ]'
     PRINT *,'                   :  vopressure [ in case of -lev option ]'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'        cdfvint'
     PRINT *,'      '
     STOP 
  ENDIF
  ! browse command line
  cf_sfil='none'
  cf_sshfil='none'
  ijarg = 1   ; nvar = 1
  DO WHILE ( ijarg <= narg ) 
     CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1
     SELECT CASE ( cldum)
     CASE ('-t','-f'   ) ; CALL getarg (ijarg, cf_tfil) ; ijarg = ijarg + 1
     ! options
     CASE ( '-s'       ) ; CALL getarg (ijarg, cf_sfil) ; ijarg = ijarg + 1
     CASE ('--ssh-file') ; CALL getarg(ijarg, cf_sshfil); ijarg = ijarg + 1
     CASE ( '-ssh'     ) ; lssh  = .TRUE. 
     CASE ( '-ssh2'    ) ; lssh2 = .TRUE. 
     CASE ( '-lev'     ) ; llev  = .TRUE.  ; nvar = nvar+1  ! more outputs
     CASE ( '-xtra'    ) ; lxtra = .TRUE.  ; nvar = nvar+2  ! more outputs
     CASE ( '-full'    ) ; lfull = .TRUE. 
     CASE ( '-vvl'     ) ; lg_vvl= .TRUE. 
     CASE ( '-o'       ) ; CALL getarg( ijarg,cf_out) ; ijarg = ijarg + 1
     CASE ( '-nc4'     ) ; lnc4  = .TRUE.
     CASE DEFAULT      ; PRINT *,' ERROR : ', TRIM(cldum) ,' unknown option.'  ; STOP 99
     END SELECT
  END DO
  IF ( cf_sfil   == 'none' ) cf_sfil   = cf_tfil
  IF ( cf_sshfil == 'none' ) cf_sshfil = cf_tfil

  CALL SetGlobalAtt(cglobal)
  ALLOCATE ( ipk(nvar), id_varout(nvar), stypvar(nvar) )

  ! Security check
  lchk = chkfile ( cf_tfil   )
  lchk = chkfile ( cf_sfil   ) .OR. lchk
  lchk = chkfile ( cf_sshfil ) .OR. lchk
  lchk = chkfile ( cn_fmsk   ) .OR. lchk
  lchk = chkfile ( cn_fzgr   ) .OR. lchk
  IF ( lchk ) STOP 99 ! missing files

  IF ( lg_vvl ) THEN 
     cn_fe3t = cf_tfil
     cn_ve3t = cn_ve3tvvl
  ENDIF

  npiglo = getdim (cf_tfil, cn_x )
  npjglo = getdim (cf_tfil, cn_y )
  npk    = getdim (cf_tfil, cn_z )
  npt    = getdim (cf_tfil, cn_t )

  PRINT *, ' NPIGLO = ', npiglo
  PRINT *, ' NPJGLO = ', npjglo
  PRINT *, ' NPK    = ', npk
  PRINT *, ' NPT    = ', npt

  ! Allocate arrays
  ALLOCATE ( dtim(npt) )
  ALLOCATE ( tmask(npiglo,npjglo) )
  ALLOCATE ( zt(npiglo,npjglo)  )
  ALLOCATE ( zs(npiglo,npjglo)  )
  ALLOCATE ( e3t(npiglo,npjglo) )
  ALLOCATE ( hdept(npiglo,npjglo) )
  ALLOCATE ( e31d(npk)   )
  ALLOCATE ( gdepw(npk)) 

  ALLOCATE ( dl_bpres(npiglo, npjglo))
  ALLOCATE ( dl_psurf(npiglo, npjglo))
  ALLOCATE ( dl_sigi (npiglo, npjglo))

  CALL CreateOutput

  DO jt = 1, npt
     IF ( lg_vvl ) THEN ; it = jt
     ELSE ;               it = 1
     ENDIF

     IF ( lssh ) THEN
        zt(:,:)       = getvar(cf_sshfil, cn_sossheig, 1, npiglo, npjglo, ktime=jt )
        dl_psurf(:,:) = pp_grav * pp_rau0 * zt(:,:)
        IF (lxtra ) THEN
           ierr = putvar(ncout, id_varout(2) ,zt      ,       1, npiglo, npjglo, ktime=jt)
           ierr = putvar(ncout, id_varout(3) ,dl_psurf,       1, npiglo, npjglo, ktime=jt)
        ENDIF
     ELSE IF ( lssh2 ) THEN 
        zt(:,:)    = getvar(cf_tfil,   cn_votemper, 1, npiglo, npjglo, ktime=jt )
        zs(:,:)    = getvar(cf_sfil,   cn_vosaline, 1, npiglo, npjglo, ktime=jt )

        dl_sigi(:,:) = 1000.d0 + sigmai(zt, zs, 0., npiglo, npjglo)

        !  CAUTION : hdept is used for reading SSH in the next line
        hdept(:,:)   = getvar(cf_tfil, cn_sossheig, 1, npiglo, npjglo, ktime=jt )
        dl_psurf(:,:) = pp_grav * dl_sigi * hdept(:,:)
        IF (lxtra ) THEN
           ierr = putvar(ncout, id_varout(2) ,hdept   ,       1, npiglo, npjglo, ktime=jt)
           ierr = putvar(ncout, id_varout(3) ,dl_psurf,       1, npiglo, npjglo, ktime=jt)
        ENDIF
     ELSE
        dl_psurf(:,:)=0.d0
     ENDIF

     dl_bpres(:,:) = dl_psurf(:,:)

     DO jk = 1, npk
        tmask(:,:) = getvar(cn_fmsk, cn_tmask,      jk, npiglo, npjglo          )
        hdept(:,:) = getvar(cn_fzgr, cn_hdept,     jk, npiglo, npjglo           )
        zt(:,:)    = getvar(cf_tfil,   cn_votemper,  jk, npiglo, npjglo, ktime=jt )
        zs(:,:)    = getvar(cf_sfil,   cn_vosaline,  jk, npiglo, npjglo, ktime=jt )

        dl_sigi(:,:) = 1000.d0 + sigmai(zt, zs, hdept, npiglo, npjglo)
        IF ( lfull ) THEN ; e3t(:,:) = e31d(jk)
        ELSE ; e3t(:,:) = getvar(cn_fe3t, cn_ve3t, jk, npiglo, npjglo, ktime=it, ldiom=.NOT.lg_vvl)
        ENDIF
        dl_bpres(:,:) = dl_bpres(:,:) + dl_sigi(:,:) * e3t(:,:) * pp_grav * 1.d0 * tmask(:,:) 
        IF ( llev) THEN
           ierr= putvar(ncout,id_varout(npre3d), REAL(dl_bpres),jk, npiglo, npjglo, ktime=jt)
        ENDIF

     END DO  ! loop to next level
     ierr = putvar(ncout, id_varout(1) ,REAL(dl_bpres), 1, npiglo, npjglo, ktime=jt)
  END DO  ! next time frame

  ierr = closeout(ncout)

CONTAINS
  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose : Create netCDF output file 
    !!
    !! ** Method  : Use Global information to create the file
    !!----------------------------------------------------------------------
    INTEGER(KIND=4) ::  ivar

    ivar=0

    ivar=ivar+1
    nbotpres=ivar
    ipk(nbotpres)                       = 1
    stypvar(nbotpres)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(nbotpres)%cname             = 'sobotpres'
    stypvar(nbotpres)%cunits            = 'Pascal'
    stypvar(nbotpres)%rmissing_value    = 0.
    stypvar(nbotpres)%valid_min         = 0
    stypvar(nbotpres)%valid_max         =  1.e15
    stypvar(nbotpres)%clong_name        = 'Bottom Pressure'
    stypvar(nbotpres)%cshort_name       = 'sobotpres'
    stypvar(nbotpres)%cprecision        = 'r8'
    stypvar(nbotpres)%conline_operation = 'N/A'
    stypvar(nbotpres)%caxis             = 'TYX'

    IF ( lxtra ) THEN
       ivar=ivar+1
       nssheig=ivar
       ipk(nssheig)                       = 1
       stypvar(nssheig)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
       stypvar(nssheig)%cname             = TRIM(cn_sossheig)
       stypvar(nssheig)%cunits            = 'm'
       stypvar(nssheig)%rmissing_value    =  0.
       stypvar(nssheig)%valid_min         = -10.
       stypvar(nssheig)%valid_max         =  10.
       stypvar(nssheig)%clong_name        = 'Sea Surface Height'
       stypvar(nssheig)%cshort_name       = TRIM(cn_sossheig)
       stypvar(nssheig)%conline_operation = 'N/A'
       stypvar(nssheig)%caxis             = 'TYX'

       ivar=ivar+1
       nsshpre=ivar
       ipk(nsshpre)                       = 1
       stypvar(nsshpre)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
       stypvar(nsshpre)%cname             = 'sosshpre'
       stypvar(nsshpre)%cunits            = 'Pascal'
       stypvar(nsshpre)%rmissing_value    =  0.
       stypvar(nsshpre)%valid_min         = -100000.
       stypvar(nsshpre)%valid_max         =  100000.
       stypvar(nsshpre)%clong_name        = 'Pressure due to SSH'
       stypvar(nsshpre)%cshort_name       = 'sosshpre'
       stypvar(nsshpre)%cprecision        = 'r8'
       stypvar(nsshpre)%conline_operation = 'N/A'
       stypvar(nsshpre)%caxis             = 'TYX'
    ENDIF
   
    IF ( llev ) THEN
       ivar=ivar+1
       npre3d=ivar
       ipk(npre3d)                       = npk
       stypvar(npre3d)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
       stypvar(npre3d)%cname             = 'vopressure'
       stypvar(npre3d)%cunits            = 'Pascal'
       stypvar(npre3d)%rmissing_value    =  0.
       stypvar(npre3d)%valid_min         = -100000.
       stypvar(npre3d)%valid_max         =  100000.
       stypvar(npre3d)%clong_name        = '3D Pressure'
       stypvar(npre3d)%cshort_name       = 'vopressure'
       stypvar(npre3d)%cprecision        = 'r8'
       stypvar(npre3d)%conline_operation = 'N/A'
       stypvar(npre3d)%caxis             = 'TYX'
    ENDIF

    ! Initialize output file
    gdepw(:) = getvare3(cn_fzgr, cn_gdepw, npk )
    e31d(:)  = getvare3(cn_fzgr, cn_ve3t1d,  npk )

    IF (llev) THEN
      ncout = create      (cf_out, cf_tfil, npiglo, npjglo, npk, cdep=cn_vdepthw , ld_nc4=lnc4  )
      ierr  = createvar   (ncout, stypvar, nvar, ipk, id_varout, cdglobal=cglobal, ld_nc4=lnc4  )
      ierr  = putheadervar(ncout, cf_tfil,   npiglo, npjglo, npk, pdep=gdepw,  cdep=cn_vdepthw  ) 
    ELSE
      ncout = create      (cf_out, cf_tfil, npiglo, npjglo, 1                    , ld_nc4=lnc4  )
      ierr  = createvar   (ncout, stypvar, nvar, ipk, id_varout, cdglobal=cglobal, ld_nc4=lnc4  )
      ierr  = putheadervar(ncout, cf_tfil,   npiglo, npjglo, 1                                  ) 
    ENDIF

    dtim  = getvar1d    (cf_tfil, cn_vtimec, npt     )
    ierr  = putvar1d    (ncout, dtim,        npt, 'T')

    PRINT *, 'Output files initialised ...'

  END SUBROUTINE CreateOutput

END PROGRAM cdfbotpressure

PROGRAM cdfkempemekeepe
  !!======================================================================
  !!                     ***  PROGRAM  cdfkempemekeepe  ***
  !!=====================================================================
  !!  ** Purpose : Compute the term of energetic transfert from mean kinetic
  !!               energy to mean potential energy (T1) and from eddy 
  !!               potential energy to eddy kinetic energy (T3)
  !!
  !! History : 2.1  : 03/2008  : A. Melet     : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                             :: jj, jk         ! dummy loop index
  INTEGER(KIND=4)                             :: npiglo, npjglo ! size of the domain
  INTEGER(KIND=4)                             :: npk, npt       ! size of the domain
  INTEGER(KIND=4)                             :: narg, iargc    ! browse line
  INTEGER(KIND=4)                             :: ncout, ierr    ! ncid of outputfile, error status
  INTEGER(KIND=4), DIMENSION(2)               :: ipk, id_varout ! levels and varid's of output vars

  REAL(KIND=4), DIMENSION(:,:,:), ALLOCATABLE :: wbartbar
  REAL(KIND=4), DIMENSION(:,:,:), ALLOCATABLE :: anowt 
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: t1mask
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: w1mask
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: txz
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: wxz 
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: wtxz
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: wbartbarxz
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: anowtxz
  REAL(KIND=4), DIMENSION(:),     ALLOCATABLE :: tim            ! time counter (dummy)

  CHARACTER(LEN=256)                          :: cf_uvwtfil          ! input file
  CHARACTER(LEN=256)                          :: cf_out='transfertst1t3.nc'

  TYPE  (variable), DIMENSION(2)              :: stypvar        ! structure for attibutes
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg /= 1 ) THEN
     PRINT *,'usage : cdfkempemekeepe file'
     PRINT *,'     Produce a cdf file transfertst1t3.nc with wT and anowT variables'
     PRINT *,'     file is from cdfmoyuvwt'
     PRINT *,'     the mean must have been computed on a period long enough'
     PRINT *,'     for the statistics to be meaningful'
     PRINT *,'                         '
     STOP
  ENDIF

  CALL getarg(1, cf_uvwtfil)

  IF (chkfile(cf_uvwtfil) ) STOP 99 ! missing file
  npiglo = getdim(cf_uvwtfil, cn_x)
  npjglo = getdim(cf_uvwtfil, cn_y)
  npk    = getdim(cf_uvwtfil, cn_z)
  npt    = getdim(cf_uvwtfil, cn_t)

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  ! define new variables for output ( must update att.txt)
  ipk(:)                    = npk  
  stypvar(1)%cname          = 'wT'
  stypvar(1)%clong_name     = 'temporal mean of w times temporal mean of T on T point (*1000)'
  stypvar(1)%cshort_name    = 'wT'

  stypvar(2)%cname          = 'anowT'
  stypvar(2)%clong_name     = 'temporal mean of anomaly of w times ano of T on T point (*1000)'
  stypvar(2)%cshort_name    = 'anowT'
 
  stypvar%cunits            = '1000 m.K'
  stypvar%rmissing_value    = 0.
  stypvar%valid_min         = -1000.
  stypvar%valid_max         = 1000.
  stypvar%conline_operation = 'N/A'
  stypvar%caxis             = 'TYX'
  
  ! create output fileset
  ncout = create      (cf_out, cf_uvwtfil,   npiglo, npjglo, npk       )
  ierr  = createvar   (ncout,    stypvar, 2,      ipk,    id_varout )
  ierr  = putheadervar(ncout,    cf_uvwtfil,   npiglo, npjglo, npk       )

  ! Allocate the memory
  ALLOCATE ( wbartbar(  npiglo, npjglo, npk) )  ! 3D can be huge !
  ALLOCATE ( anowt(     npiglo, npjglo, npk) )  ! 3D can be huge
  ALLOCATE ( t1mask(    npiglo,npk) )
  ALLOCATE ( w1mask(    npiglo,npk) )
  ALLOCATE ( txz(       npiglo,npk) )
  ALLOCATE ( wxz(       npiglo,npk) )
  ALLOCATE ( wtxz(      npiglo,npk) )
  ALLOCATE ( anowtxz(   npiglo,npk) )
  ALLOCATE ( wbartbarxz(npiglo,npk) )  
  ALLOCATE ( tim(npt)  )  
  
  tim  = getvar1d(cf_uvwtfil, cn_vtimec, npt     )
  ierr = putvar1d(ncout, tim,       npt, 'T')

  DO jj = 1, npjglo
       wbartbarxz(:,:) = 0.0
       anowtxz(:,:)    = 0.0
       wtxz(:,:)       = 0.0
       wxz(:,:)        = 0.0
       txz(:,:)        = 0.0

       txz( :,:) = getvarxz(cf_uvwtfil, 'tbar',  jj, npiglo, npk, kimin=1, kkmin=1, ktime=1)
       wxz( :,:) = getvarxz(cf_uvwtfil, 'wbar',  jj, npiglo, npk, kimin=1, kkmin=1, ktime=1)
       wtxz(:,:) = getvarxz(cf_uvwtfil, 'wtbar', jj, npiglo, npk, kimin=1, kkmin=1, ktime=1)

       DO jk=1, npk-1
          w1mask(:,jk) = wxz(:,jk) * wxz(:,jk+1)
          t1mask(:,jk) = txz(:,jk)
          WHERE ( w1mask(:,jk) /= 0.) w1mask(:,jk)=1.
          WHERE ( t1mask(:,jk) /= 0.) t1mask(:,jk)=1. 
          wbartbarxz(:,jk) = 1000. * t1mask(:,jk) * txz(:,jk) * 0.5 * w1mask(:,jk) * ( wxz(:,jk) + wxz(:,jk+1) )
          anowtxz(   :,jk) = 1000. * ( wtxz(:,jk) - wbartbarxz(:,jk)*0.001 )      
       END DO
       wbartbar(:,jj,:) = wbartbarxz(:,:)
       anowt(   :,jj,:) = anowtxz(   :,:)
  END DO
  DO jk=1,npk
     ierr = putvar(ncout, id_varout(1), wbartbar(:,:,jk), jk, npiglo, npjglo )
     ierr = putvar(ncout, id_varout(2), anowt(   :,:,jk), jk, npiglo, npjglo )
  END DO

  ierr = closeout(ncout)  

END PROGRAM cdfkempemekeepe

PROGRAM cdfmhst
  !!======================================================================
  !!                     ***  PROGRAM  cdfmhst  ***
  !!=====================================================================
  !!  ** Purpose : Compute Meridional Heat Salt  Transport.
  !!
  !!  ** Method  : Starts from the mean VT, VS fields computed by cdfvT.
  !!               Optionally, it can read V, T  and S files in separate files
  !!               Zonal and vertical integration are performed for these
  !!               quantities. If a sub-basin mask is provided, then a
  !!               meridional H/S transoport is computed for each sub basin.
  !!               Meridional H/S transports at different depths
  !!
  !! History : 2.1  : 01/2005  : J.M. Molines  : Original code
  !!                : 04/2005  : A.M. Treguier : adaptation to regional config
  !!                : 04/2007  : J.M. Molines  : add netcdf output
  !!           3.0  : 05/2011  : J.M. Molines  : Doctor norm + Lic.
  !!                  10/2012  : M.A. Balmaseda: opt separate V,T,S infiles
  !!                                             opt z dimension 
  !!                                             add inp0
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class transport
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                              :: ji, jj, jk, jt   ! dummy loop index
  INTEGER(KIND=4)                              :: jbasins, jvar    ! dummy loop index
  INTEGER(KIND=4)                              :: it               ! time index for vvl
  INTEGER(KIND=4)                              :: narg, iargc      ! command line 
  INTEGER(KIND=4)                              :: ik0              ! working integer
  INTEGER(KIND=4)                              :: ijarg            ! argument counter
  INTEGER(KIND=4)                              :: npiglo, npjglo   ! size of the domain
  INTEGER(KIND=4)                              :: npk, npt, npko   ! size of the domain
  INTEGER(KIND=4)                              :: numouth = 10     ! logical unit for heat 
  INTEGER(KIND=4)                              :: numouts = 11     ! logical unit for salt
  INTEGER(KIND=4)                              :: npvar=1          ! number of variables type
  INTEGER(KIND=4)                              :: nbasins          ! number of basins
  INTEGER(KIND=4)                              :: nbasinso         ! basins in output
  INTEGER(KIND=4)                              :: ierr             ! error status
  INTEGER(KIND=4)                              :: ncout            ! ncid of output file
  INTEGER(KIND=4)                              :: ivar             ! variable index
  INTEGER(KIND=4), DIMENSION(2)                :: iloc             ! working array
  INTEGER(KIND=4), DIMENSION(:),  ALLOCATABLE  :: ipk, id_varout   ! for output variables

  REAL(KIND=4), PARAMETER                      :: pprau0 = 1000.   ! reference density
  REAL(KIND=4), PARAMETER                      :: pprcp  = 4000.   ! specific heat
  REAL(KIND=4), PARAMETER                      :: ppspval= 9999.99 ! missing value

  REAL(KIND=4), DIMENSION(:),      ALLOCATABLE :: gdep             ! depth array
  REAL(KIND=4), DIMENSION(:),      ALLOCATABLE :: e31d             ! 1D e3t for full step
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: zmask            ! mask
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: e1v, e3v, gphiv  ! metrics and latitude
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: zvt, zvs         ! transport components
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: zv, zt, zs       ! v,t,s
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: rdumlon          ! dummy longitude = 0.
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: rdumlat          ! latitude for i = north pole

  REAL(KIND=8), DIMENSION(:),      ALLOCATABLE :: dtim             ! time counter
  REAL(KIND=8), DIMENSION(:),      ALLOCATABLE :: dzonal_heat_glo  ! zonal integral
  REAL(KIND=8), DIMENSION(:),      ALLOCATABLE :: dzonal_heat_atl  ! zonal integral 
  REAL(KIND=8), DIMENSION(:),      ALLOCATABLE :: dzonal_heat_pac
  REAL(KIND=8), DIMENSION(:),      ALLOCATABLE :: dzonal_heat_ind
  REAL(KIND=8), DIMENSION(:),      ALLOCATABLE :: dzonal_heat_aus
  REAL(KIND=8), DIMENSION(:),      ALLOCATABLE :: dzonal_heat_med
  REAL(KIND=8), DIMENSION(:),      ALLOCATABLE :: dzonal_salt_glo
  REAL(KIND=8), DIMENSION(:),      ALLOCATABLE :: dzonal_salt_atl
  REAL(KIND=8), DIMENSION(:),      ALLOCATABLE :: dzonal_salt_pac
  REAL(KIND=8), DIMENSION(:),      ALLOCATABLE :: dzonal_salt_ind
  REAL(KIND=8), DIMENSION(:),      ALLOCATABLE :: dzonal_salt_aus
  REAL(KIND=8), DIMENSION(:),      ALLOCATABLE :: dzonal_salt_med
  REAL(KIND=8), DIMENSION(:),      ALLOCATABLE :: dmtrp            ! transport in PW ir kT/s
  REAL(KIND=8), DIMENSION(:,:),    ALLOCATABLE :: dwkh, dtrph      ! working variables
  REAL(KIND=8), DIMENSION(:,:),    ALLOCATABLE :: dtrps, dwks      ! working variables

  TYPE(variable), DIMENSION(:),    ALLOCATABLE :: stypvar          ! structure for attributes

  CHARACTER(LEN=256)                           :: cf_vtfil         ! input VT or V file name
  CHARACTER(LEN=256)                           :: cf_vfil          ! separate V files
  CHARACTER(LEN=256)                           :: cf_tfil          ! separate T,S files
  CHARACTER(LEN=256)                           :: cf_sfil          ! separate T,S files
  CHARACTER(LEN=256)                           :: cf_outh='zonal_heat_trp.dat'
  CHARACTER(LEN=256)                           :: cf_outs='zonal_salt_trp.dat'
  CHARACTER(LEN=256)                           :: cf_outnc='mhst.nc'
  CHARACTER(LEN=256)                           :: cv_zomht='zomht' ! MHT variable name
  CHARACTER(LEN=256)                           :: cv_zomst='zomst' ! MST variable name
  CHARACTER(LEN=256)                           :: cldum            ! dummy character variable
  CHARACTER(LEN=5),  DIMENSION(6)              :: cbasin=(/'_glo ','_atl ','_inp ','_ind ','_pac ','_inp0'/)
  CHARACTER(LEN=80), DIMENSION(:), ALLOCATABLE :: cvarname         ! varname arrays
  CHARACTER(LEN=256)                           :: cldimension      ! varname arrays

  LOGICAL                                      :: llglo = .FALSE.  ! flag for sub basin file
  LOGICAL                                      :: lchk  = .FALSE.  ! flag for missing files
  LOGICAL                                      :: lfull = .FALSE.  ! flag for full step
  LOGICAL                                      :: lsepf = .FALSE.  ! flag for separate files
  LOGICAL                                      :: lzdim = .FALSE.  ! flag for saving cumulated MHT
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  !!  Read command line and output usage message if not compliant.
  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfmhst  -vt VT-file | (-v V-file -t T-file [-s S-file]) ...'
     PRINT *,'         ... [-vtvar VT-var VS-var] ...'
     PRINT *,'         ... [-MST] [-b BASIN-mask] [-full] [-Zdim] [-o OUT-file] [-vvl] '
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the meridional heat/salt transport as a function of latitude.'
     PRINT *,'       If the basin mask-file ',TRIM(cn_fbasins),' is provided, the meridional'
     PRINT *,'       heat/salt transport for each sub-basin is also computed.'
     PRINT *,'      '
     PRINT *,'       This program is designed to read the time-average products V.T into'
     PRINT *,'       the corresponding VT-file (produced by cdfvT). If VT-files are not'
     PRINT *,'       available, or if working with model snapshot, V-file and T-file can'
     PRINT *,'       be specified as an alternative.'
     PRINT *,'      '
     PRINT *,'       In the evaluation of the ''meridional'' component, a ''zonal'' integration'
     PRINT *,'       is performed. Note that in CDFTOOLS, as far as ''zonal'' integrals'
     PRINT *,'       are concerned, they in-fact correspond to ''along-model I'' integrals.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -vt VT-file  : netcdf file containing the mean value of the products' 
     PRINT *,'                  U.S, U.T, V.S and V.T (obtained with cdfvT).'
     PRINT *,'         or   '     
     PRINT *,'       -v V-file  : specify V-file '
     PRINT *,'       -t T-file  : specify T-file '
     PRINT *,'       If not using ''-vt'' option, both V-file and T-file MUST be specified.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-vtvar VT-var VS-var] : name of VT, VS variables in VT-file.'
     PRINT *,'       [-s S-file] : specify S-file (salinity) if the salinity field is not in'
     PRINT *,'              T-file.'
     PRINT *,'       [-MST ]   : Indicates the the meridional Salt transport will also be '
     PRINT *,'              computed.  If not specified, only the MHT is output.' 
     PRINT *,'       [-full ] : to be set for full step case.'
     PRINT *,'       [-Zdim ] : to be set to output vertical structure of Heat/salt transport'
     PRINT *,'       [-b BASIN-mask ] : use BASIN-mask instead of default ', TRIM(cn_fbasins)
     PRINT *,'       [-o OUT-file ] : change name of the output file. Default:', TRIM(cf_outnc)
     PRINT *,'       [-vvl ] : use time-varying vertical metrics.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        ', TRIM(cn_fhgr),', ',TRIM(cn_fzgr),' and ',TRIM(cn_fmsk)
     PRINT *,'        If ',TRIM(cn_fbasins),' is also available, sub-basin meridional transports'
     PRINT *,'        are also computed.'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       ASCII files : ', TRIM(cf_outh),' : Meridional Heat Transport'
     PRINT *,'                     ', TRIM(cf_outs),' : Meridional Salt Transport'
     PRINT *,'       netcdf file : ', TRIM(cf_outnc),' unless -o option is used.'
     PRINT *,'           variables : ( [... ] : -MST option ) '
     PRINT *,'                       ', TRIM(cv_zomht),cbasin(1),' : Meridional Heat Transport (global)'
     PRINT *,'                     [ ', TRIM(cv_zomst),cbasin(1),' : Meridional Salt Transport (global) ] '
     PRINT *,'       If ',TRIM(cn_fbasins),' is available, per basin meridional transport '
     PRINT *,'       are also available:' 
     DO jbasins=2, 6
        PRINT *,'                       ', TRIM(cv_zomht),cbasin(jbasins),' : Meridional Heat Transport'
        PRINT *,'                     [ ', TRIM(cv_zomst),cbasin(jbasins),' : Meridional Salt Transport ]'
     PRINT *,'      '
     END DO
     STOP 
  ENDIF

  cf_vtfil='none'
  cf_vfil='none'
  cf_tfil='none'
  cf_sfil='none'
  lsepf  = .TRUE.
  npvar   = 1    ! default value ( no MST output)
  ijarg   = 1
  ! browse command line and detect the file name as argument different from any option
  ! count the number of files. Assume VT if 1 only, V TS if 2 and V T S if 3
  DO WHILE ( ijarg <= narg ) 
     CALL getarg(ijarg, cldum) ; ijarg = ijarg+1
     SELECT CASE ( cldum)
     CASE ( '-vt'   ) ; CALL getarg(ijarg, cf_vtfil  ) ; ijarg = ijarg+1
     CASE ( '-vtvar') ; CALL getarg(ijarg, cn_vomevt ) ; ijarg = ijarg+1
          ;           ; CALL getarg(ijarg, cn_vomevs ) ; ijarg = ijarg+1
     CASE ( '-v'    ) ; CALL getarg(ijarg, cf_vfil   ) ; ijarg = ijarg+1
     CASE ( '-t'    ) ; CALL getarg(ijarg, cf_tfil   ) ; ijarg = ijarg+1
     CASE ( '-s'    ) ; CALL getarg(ijarg, cf_sfil   ) ; ijarg = ijarg+1
     CASE ( '-MST'  ) ; npvar    = 2
     CASE ( '-full' ) ; lfull    = .TRUE.
     CASE ( '-Zdim' ) ; lzdim    = .TRUE.
     CASE ( '-b'    ) ; CALL getarg(ijarg, cn_fbasins) ; ijarg = ijarg+1
     CASE ( '-o'    ) ; CALL getarg(ijarg, cf_outnc  ) ; ijarg = ijarg+1
     CASE ( '-vvl'  ) ; lg_vvl   = .TRUE.
     CASE DEFAULT     ; PRINT *,' ERROR : ',TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  END DO

  ! security check
  IF ( TRIM(cf_vtfil) /= 'none' ) lsepf = .FALSE.

  IF ( lsepf ) THEN  ! need to have cf_vfil and cf_tfil at least
     lchk = chkfile ( cf_vfil )
     lchk = lchk .OR. chkfile( cf_tfil )
     IF ( lchk ) STOP 99   ! Missing files
     IF ( TRIM(cf_sfil) == 'none' ) cf_sfil = cf_tfil
  ENDIF

  ! check for missing files
  lchk = lchk .OR. chkfile( cn_fhgr )
  lchk = lchk .OR. chkfile( cn_fzgr )
  lchk = lchk .OR. chkfile( cn_fmsk )
  lchk = lchk .OR. chkfile( cf_vtfil)   ! chkfile is returning F when input file name is 'none'
  IF ( lsepf ) THEN
     lchk = lchk .OR. chkfile( cf_tfil)
     lchk = lchk .OR. chkfile( cf_sfil)
  ENDIF

  IF ( lchk ) STOP 99 ! missing files
  IF ( lg_vvl ) THEN
     cn_fe3v = cf_vtfil  ! REM: in case of vvl e3v is either in VT file or in V file 
     cn_ve3v = cn_ve3vvvl
  ENDIF

  ! check for sub basin file and set appropriate variables
  IF ( .NOT. chkfile(cn_fbasins ) ) THEN
     llglo    = .TRUE.
     nbasins  = 5
     nbasinso = 6
  ELSE
     PRINT *,' Only compute for GLOBAL basin'
     llglo    = .FALSE.
     nbasins  = 1
     nbasinso = 1
  ENDIF

  IF ( lsepf ) cf_vtfil=cf_vfil   ! needed only to read the dimension of the domain
  npiglo = getdim (cf_vtfil, cn_x)
  npjglo = getdim (cf_vtfil, cn_y)
  npk    = getdim (cf_vtfil, cn_z)
  npt    = getdim (cf_vtfil, cn_t)

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  IF ( lzdim ) THEN  ! output file hold heat/salt transport by levels
     npko = npk
     cldimension = 'TZY'
  ELSE
     npko = 1
     cldimension = 'TY'
  ENDIF

  ! Allocate arrays
  ALLOCATE ( dtim(npt) )
  ALLOCATE ( dwkh(npiglo,npjglo), zmask(npiglo,npjglo), zvt(npiglo,npjglo) )
  ALLOCATE ( dwks(npiglo,npjglo), zvs(npiglo,npjglo) )
  ALLOCATE ( e1v(npiglo,npjglo), e3v(npiglo,npjglo), gphiv(npiglo,npjglo))
  ALLOCATE ( dtrph(npiglo,npjglo))
  ALLOCATE ( dtrps(npiglo,npjglo))
  ALLOCATE ( dzonal_heat_glo(npjglo), dzonal_heat_atl(npjglo), dzonal_heat_pac(npjglo) )
  ALLOCATE ( dzonal_heat_ind(npjglo), dzonal_heat_aus(npjglo), dzonal_heat_med(npjglo) )
  ALLOCATE ( dzonal_salt_glo(npjglo), dzonal_salt_atl(npjglo), dzonal_salt_pac(npjglo) )
  ALLOCATE ( dzonal_salt_ind(npjglo), dzonal_salt_aus(npjglo), dzonal_salt_med(npjglo) )
  ALLOCATE ( rdumlon(1,npjglo), rdumlat(1,npjglo))
  ALLOCATE ( dmtrp(npjglo) )
  ALLOCATE ( gdep (npko) )

  IF ( lsepf ) THEN
     ALLOCATE ( zv(npiglo,npjglo), zt(npiglo,npjglo), zs(npiglo,npjglo) )
  ENDIF

  IF ( lfull ) ALLOCATE ( e31d(npk) )

  e1v(:,:)   = getvar(cn_fhgr, cn_ve1v,  1, npiglo, npjglo)
  gphiv(:,:) = getvar(cn_fhgr, cn_gphiv, 1, npiglo, npjglo)

  IF ( lzdim ) THEN
     gdep(:)   = getvare3(cn_fzgr, cn_gdept, npk )
  ELSE
     gdep(:)    = 0.  ! dummy depth for netcdf output
  ENDIF

  IF ( lfull ) e31d = getvare3(cn_fzgr, cn_ve3t1d, npk )

  iloc         = MAXLOC( gphiv )
  rdumlat(1,:) = gphiv(iloc(1),:)
  rdumlon(:,:) = 0.   ! set the dummy longitude to 0

  ! prepare output netcdf output file
  ! Allocate output variables
  ALLOCATE(stypvar(nbasinso*npvar),  cvarname(nbasinso*npvar) )
  ALLOCATE(    ipk(nbasinso*npvar), id_varout(nbasinso*npvar) )

  CALL CreateOutput

  OPEN(numouth,FILE=cf_outh,FORM='FORMATTED', RECL=256)  ! to avoid wrapped line with ifort
  OPEN(numouts,FILE=cf_outs,FORM='FORMATTED', RECL=256)  ! to avoid wrapped line with ifort


  DO jt=1, npt
     IF ( lg_vvl ) THEN ; it=jt
     ELSE               ; it=1
     ENDIF
     dtrph(:,:) = 0.d0
     dtrps(:,:) = 0.d0
     DO jk = 1,npk
        PRINT *,'level ',jk
        ! Get temperature and salinity at jk
        IF ( lsepf ) THEN
           zv(:,:)= getvar(cf_vfil, cn_vomecrty, jk, npiglo, npjglo, ktime=jt)
           zt(:,:)= getvar(cf_tfil, cn_votemper, jk, npiglo, npjglo, ktime=jt)
           zs(:,:)= getvar(cf_sfil, cn_vosaline, jk, npiglo, npjglo, ktime=jt)
           zvt(:,:)=0.
           zvs(:,:)=0.
           DO ji=1, npiglo
              DO jj = 1, npjglo -1
                 zvt(ji,jj) = 0.5 * ( zt(ji,jj) + zt(ji,jj+1) )*zv(ji,jj)  ! temper at Vpoint
                 zvs(ji,jj) = 0.5 * ( zs(ji,jj) + zs(ji,jj+1) )*zv(ji,jj)  ! salinity at Vpoint
              END DO
           END DO

        ELSE
           zvt(:,:)= getvar(cf_vtfil, cn_vomevt, jk, npiglo, npjglo, ktime=jt)
           zvs(:,:)= getvar(cf_vtfil, cn_vomevs, jk, npiglo, npjglo, ktime=jt)
        ENDIF
        ! get e3v at level jk
        IF ( lfull ) THEN ; e3v(:,:) = e31d(jk)
        ELSE              ; e3v(:,:) = getvar(cn_fe3v, cn_ve3v, jk, npiglo, npjglo, ktime=it, ldiom=.NOT.lg_vvl )
        ENDIF
        dwkh(:,:) = zvt(:,:)*e1v(:,:)*e3v(:,:)*1.d0
        dwks(:,:) = zvs(:,:)*e1v(:,:)*e3v(:,:)*1.d0

        ! integrates vertically 
        dtrph(:,:) = dtrph(:,:) + dwkh(:,:) * pprau0 * pprcp
        dtrps(:,:) = dtrps(:,:) + dwks(:,:)  

        !global
        zmask(:,:) = getvar(cn_fmsk, cn_vmask, 1, npiglo, npjglo)
        DO jj=1,npjglo
           dzonal_heat_glo(jj) = SUM( dtrph(2:npiglo-1,jj)*zmask(2:npiglo-1,jj) )
           dzonal_salt_glo(jj) = SUM( dtrps(2:npiglo-1,jj)*zmask(2:npiglo-1,jj) )
        END DO

        IF ( llglo ) THEN
           ! Zonal mean with mask
           ! Atlantic 
           zmask(:,:) = getvar(cn_fbasins, cn_tmaskatl, 1, npiglo, npjglo)
           DO jj=1,npjglo
              dzonal_heat_atl(jj) = SUM( dtrph(:,jj)*zmask(:,jj) )
              dzonal_salt_atl(jj) = SUM( dtrps(:,jj)*zmask(:,jj) )
           END DO

           ! Pacific
           zmask(:,:) = getvar(cn_fbasins, cn_tmaskpac, 1, npiglo, npjglo)
           DO jj=1,npjglo
              dzonal_heat_pac(jj) = SUM( dtrph(:,jj)*zmask(:,jj) )
              dzonal_salt_pac(jj) = SUM( dtrps(:,jj)*zmask(:,jj) )
           END DO

           ! Indian
           zmask(:,:) = getvar(cn_fbasins, cn_tmaskind, 1, npiglo, npjglo)
           DO jj=1,npjglo
              dzonal_heat_ind(jj) = SUM( dtrph(:,jj)*zmask(:,jj) )
              dzonal_salt_ind(jj) = SUM( dtrps(:,jj)*zmask(:,jj) )
           END DO

           ! Austral
           dzonal_heat_aus = 0.d0
           dzonal_salt_aus = 0.d0
           !    zmask(:,:)=getvar(cn_fbasins,cn_tmaskant,1,npiglo,npjglo)
           !    DO jj=1,npjglo
           !       dzonal_heat_aus(jj)= SUM( dtrph(:,jj)*zmask(:,jj))
           !       dzonal_salt_aus(jj)= SUM( dtrps(:,jj)*zmask(:,jj))
           !    END DO

           !   ! Med
           dzonal_heat_med = 0.d0
           dzonal_salt_med = 0.d0

           !    zmask(:,:)=getvar(cn_fbasins,cn_tmaskmed,1,npiglo,npjglo)
           !    DO jj=1,npjglo
           !       dzonal_heat_med(jj)= SUM( dtrph(:,jj)*zmask(:,jj))
           !       dzonal_salt_med(jj)= SUM( dtrps(:,jj)*zmask(:,jj))
           !    END DO
        ENDIF

        IF (  lzdim  .OR. ( jk == npk ) ) THEN  !output this level
           IF ( lzdim ) THEN ; ik0 = jk   
           ELSE              ; ik0 = 1 
           ENDIF

           DO jvar=1,npvar   !  MHT [ and MST ]  (1 or 2 )
              IF ( jvar == 1 ) THEN
                 ! MHT
                 ivar=1
                 dmtrp(:) = dzonal_heat_glo(:)/1.d15                            ! GLO
                 WHERE ( dmtrp == 0 ) dmtrp = ppspval
                 ierr = putvar(ncout, id_varout(ivar), REAL(dmtrp), ik0, 1, npjglo, ktime=jt) ; ivar=ivar+1
                 IF ( nbasins == 5 ) THEN
                    dmtrp(:) = dzonal_heat_atl(:)/1.d15                         ! ATL
                    WHERE ( dmtrp == 0 ) dmtrp = ppspval         
                    ierr = putvar(ncout, id_varout(ivar), REAL(dmtrp), ik0, 1, npjglo, ktime=jt); ivar=ivar+1
                    dmtrp(:) = (dzonal_heat_ind(:) + dzonal_heat_pac(:))/1.d15  ! INP
                    WHERE ( dmtrp == 0 ) dmtrp = ppspval
                    ierr = putvar(ncout, id_varout(ivar), REAL(dmtrp), ik0, 1, npjglo, ktime=jt); ivar=ivar+1
                    dmtrp(:) = dzonal_heat_ind(:)/1.d15                         ! IND
                    WHERE ( dmtrp == 0 ) dmtrp = ppspval
                    ierr = putvar(ncout, id_varout(ivar), REAL(dmtrp), ik0, 1, npjglo, ktime=jt); ivar=ivar+1
                    dmtrp(:) = dzonal_heat_pac(:)/1.d15                         ! PAC
                    WHERE ( dmtrp == 0 ) dmtrp = ppspval
                    ierr = putvar(ncout, id_varout(ivar), REAL(dmtrp), ik0, 1, npjglo, ktime=jt); ivar=ivar+1
                    ! now inp0
                    dmtrp(:) = ( dzonal_heat_glo(:) - dzonal_heat_atl(:) )/1.d15 ! INP0
                    WHERE ( dmtrp == 0 ) dmtrp = ppspval
                    ierr = putvar(ncout, id_varout(ivar), REAL(dmtrp), ik0, 1, npjglo, ktime=jt); ivar=ivar+1
                 ENDIF
              ELSE
                 ! MST
                 dmtrp(:) = dzonal_salt_glo(:)/1.d6                              ! GLO
                 WHERE ( dmtrp == 0 ) dmtrp = ppspval
                 ierr = putvar(ncout, id_varout(ivar), REAL(dmtrp), ik0, 1, npjglo, ktime=jt); ivar=ivar+1
                 IF ( nbasins == 5 ) THEN
                    dmtrp(:) = dzonal_salt_atl(:)/1.d6                           ! ATL
                    WHERE ( dmtrp == 0 ) dmtrp = ppspval
                    ierr = putvar(ncout, id_varout(ivar), REAL(dmtrp), ik0, 1, npjglo, ktime=jt); ivar=ivar+1
                    dmtrp(:) = (dzonal_salt_ind(:) + dzonal_salt_pac(:))/1.d6    ! INP
                    WHERE ( dmtrp == 0 ) dmtrp = ppspval
                    ierr = putvar(ncout, id_varout(ivar), REAL(dmtrp), ik0, 1, npjglo, ktime=jt); ivar=ivar+1
                    dmtrp(:) = dzonal_salt_ind(:)/1.d6                           ! IND
                    WHERE ( dmtrp == 0 ) dmtrp = ppspval
                    ierr = putvar(ncout, id_varout(ivar), REAL(dmtrp), ik0, 1, npjglo, ktime=jt); ivar=ivar+1
                    dmtrp(:) = dzonal_salt_pac(:)/1.d6                           ! PAC
                    WHERE ( dmtrp == 0 ) dmtrp = ppspval
                    ierr = putvar(ncout, id_varout(ivar), REAL(dmtrp), ik0, 1, npjglo, ktime=jt); ivar=ivar+1
                    ! now inp0
                    dmtrp(:) = ( dzonal_salt_glo(:) - dzonal_salt_atl(:) )/1.d6  ! INP0  
                    WHERE ( dmtrp == 0 ) dmtrp = ppspval
                    ierr = putvar(ncout, id_varout(ivar), REAL(dmtrp), ik0, 1, npjglo, ktime=jt); ivar=ivar+1
                 ENDIF
              ENDIF
           END DO

        ENDIF   ! end loop on check for ouptut
     END DO  ! loop to next level


     WRITE(numouth,*)'! Zonal heat transport (integrated alon I-model coordinate) (in Pw)'
     IF ( llglo ) THEN
        WRITE(numouth,*)'! J        Global          Atlantic         Pacific          Indian           Mediteranean     Austral  '
        WRITE(numouth,*)' ! time : ', jt
        DO jj=npjglo, 1, -1
           WRITE(numouth,9000) jj, &
                rdumlat(1,jj),  dzonal_heat_glo(jj)/1d15 , &
                dzonal_heat_atl(jj)/1d15, &
                dzonal_heat_pac(jj)/1d15, &
                dzonal_heat_ind(jj)/1d15, &
                dzonal_heat_med(jj)/1d15, &
                dzonal_heat_aus(jj)/1d15
        END DO
     ELSE
        WRITE(numouth,*)'! J        Global        '
        WRITE(numouth,*)' ! time : ', jt
        DO jj=npjglo, 1, -1
           WRITE(numouth,9000) jj, &
                rdumlat(1,jj),  dzonal_heat_glo(jj)/1d15  
        END DO
     ENDIF
     !               
     WRITE(numouts,*)' ! Zonal salt transport (integrated alon I-model coordinate) (in 10^6 kg/s)'
     IF ( llglo ) THEN
        WRITE(numouts,*)' ! J        Global          Atlantic         Pacific          Indian           Mediteranean     Austral  '
        WRITE(numouts,*)' ! time : ', jt
        !               
        DO jj=npjglo, 1, -1
           WRITE(numouts,9001) jj, &
                rdumlat(1,jj),  dzonal_salt_glo(jj)/1d6 , &
                dzonal_salt_atl(jj)/1d6, &
                dzonal_salt_pac(jj)/1d6, &
                dzonal_salt_ind(jj)/1d6, &
                dzonal_salt_med(jj)/1d6, &
                dzonal_salt_aus(jj)/1d6
        END DO
     ELSE
        WRITE(numouts,*)' J        Global  '
        WRITE(numouts,*)' ! time : ', jt
        DO jj=npjglo, 1, -1
           WRITE(numouts,9001) jj, &
                rdumlat(1,jj),  dzonal_salt_glo(jj)/1d6  
        ENDDO
     ENDIF

  ENDDO  ! time loop
  ierr = closeout(ncout)
  CLOSE(numouth)
  CLOSE(numouts)

9000 FORMAT(I4,6(1x,f9.3,1x,f8.4))
9001 FORMAT(I4,6(1x,f9.2,1x,f9.3))

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    ipk(:)=npko               ! all output variables either 1 or npko levels
    DO jbasins = 1,nbasinso
       cvarname(jbasins)                  = TRIM(cv_zomht)//TRIM(cbasin(jbasins))
       stypvar(jbasins)%cname             = cvarname(jbasins)
       stypvar(jbasins)%cunits            = 'PW'
       stypvar(jbasins)%rmissing_value    = ppspval
       stypvar(jbasins)%valid_min         = -10.
       stypvar(jbasins)%valid_max         = 20
       stypvar(jbasins)%clong_name        = 'Meridional Heat Transport '//TRIM(cbasin(jbasins))
       stypvar(jbasins)%cshort_name       = cvarname(jbasins)
       stypvar(jbasins)%conline_operation = 'N/A'
       stypvar(jbasins)%caxis             = cldimension

       IF ( npvar == 2 ) THEN
          ! MST
          ivar = nbasinso+jbasins
          cvarname(ivar)                   = TRIM(cv_zomst)//TRIM(cbasin(jbasins))
          stypvar(ivar )%cname             = cvarname(ivar)
          stypvar(ivar )%cunits            = 'T/sec'
          stypvar(ivar )%rmissing_value    = ppspval
          stypvar(ivar )%valid_min         = -10.e9
          stypvar(ivar )%valid_max         = 20.e9
          stypvar(ivar )%clong_name        = 'Meridional Salt Transport '//TRIM(cbasin(jbasins))
          stypvar(ivar )%cshort_name       = cvarname(ivar)
          stypvar(ivar )%conline_operation = 'N/A'
          stypvar(ivar )%caxis             = cldimension
       ENDIF
    END DO

    ! create output fileset
    ncout = create      (cf_outnc, cf_vtfil, 1,             npjglo, npko, cdep='depthv'                              )
    ierr  = createvar   (ncout,    stypvar,  nbasinso*npvar, ipk,    id_varout                                       )
    ierr  = putheadervar(ncout,    cf_vtfil, 1,             npjglo, npko, pnavlon=rdumlon, pnavlat=rdumlat, pdep=gdep)

    dtim  = getvar1d (cf_vtfil, cn_vtimec, npt     ) 
    ierr  = putvar1d (ncout,    dtim,      npt, 'T')

  END SUBROUTINE CreateOutput

END PROGRAM cdfmhst

PROGRAM cdfzonalout
  !!======================================================================
  !!                     ***  PROGRAM  cdfzonalout  ***
  !!=====================================================================
  !!  ** Purpose : Output zonal mean/integral as ascii files
  !!
  !!  ** Method  : Read zonalmean or zonalsum file, determine 1D variable
  !!               and dump them on the standard output.
  !!
  !! History : 2.1  : 02/2006  : J.M. Molines : Original code
  !!           3.0  : 05/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                               :: jj, jvar, jt  ! dummy loop index
  INTEGER(KIND=4)                               :: ivar          ! variable counter
  INTEGER(KIND=4)                               :: narg, iargc   ! command line 
  INTEGER(KIND=4)                               :: npjglo, npt   ! size of the domain
  INTEGER(KIND=4)                               :: nvarin, nvar  ! variables count
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: ipki          ! input ipk variables
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: id_varin      ! input variables id's

  REAL(KIND=4), DIMENSION (:),      ALLOCATABLE :: tim           ! time counter
  REAL(KIND=4), DIMENSION (:,:),    ALLOCATABLE :: zdumlat       ! latitude for i = north pole
  REAL(KIND=4), DIMENSION (:,:,:),  ALLOCATABLE :: zv            ! data values

  TYPE(variable), DIMENSION(:),     ALLOCATABLE :: stypvar       ! dummy structure

  CHARACTER(LEN=256)                            :: cf_zonal      ! input file name
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_names      ! input variable names
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()

  IF ( narg == 0 ) THEN
     PRINT *,' usage :  cdfzonalout ZONAL-file'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'        This is a formatting program for zonal files, either mean or integral.'
     PRINT *,'        It displays results on the standard output from the input zonal file.'
     PRINT *,'        It only works with 1D zonal variables, skipping 2D variables, that'
     PRINT *,'        cannot be easily displayed !'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'        ZONAL-file : input netcdf zonal file produced by one of the zonal'
     PRINT *,'                     tools.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        none'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'        - Standard output,  structured in columns:'
     PRINT *,'             J  LAT  ( zonal mean, var = 1--> nvar) '
     STOP
  ENDIF

  CALL getarg (1, cf_zonal)
  IF ( chkfile(cf_zonal) ) STOP 99 ! missing file

  nvarin  = getnvar(cf_zonal)
  ALLOCATE ( cv_names(nvarin), ipki(nvarin), id_varin(nvarin), stypvar(nvarin)  )

  cv_names(:) = getvarname(cf_zonal, nvarin, stypvar )
  ipki(:)     = getipk    (cf_zonal, nvarin          )

  ! Open standard output with reclen 2048 for avoid wrapping with ifort
  OPEN(6,FORM='FORMATTED',RECL=2048)
  ! look for 1D var ( f(lat) )
  nvar = 0
  DO jvar = 1,nvarin
     ! skip variables such as nav_lon, nav_lat, time_counter deptht ...
     IF (ipki(jvar) == 0 .OR. ipki(jvar) > 1 ) THEN
        cv_names(jvar)='none'
     ELSE
        nvar = nvar + 1          ! count for elligible  input variables
        id_varin(nvar) = jvar    ! use indirect adressing for those variables
     ENDIF
  END DO

  WRITE(6,*) 'Number of 1D variables :', nvar
  DO jvar=1,nvar
     ivar=id_varin(jvar)
     WRITE(6,*) '     ',TRIM(cv_names(ivar))
  ENDDO

  npjglo = getdim (cf_zonal,cn_y)
  npt    = getdim (cf_zonal,cn_t)

  WRITE(6,*)  'npjglo =', npjglo
  WRITE(6,*)  'npt    =', npt

  ! Allocate arrays
  ALLOCATE ( zv(1,npjglo,nvar), tim(npt)         )
  ALLOCATE ( zdumlat(1,npjglo) )

  zdumlat(:,:) = getvar  (cf_zonal, 'nav_lat', 1, 1, npjglo)
  tim(:)       = getvar1d(cf_zonal, cn_vtimec, npt         )

  DO jt = 1, npt  ! time loop
     ! main elligible variable loop
     DO jvar = 1, nvar
        ivar         = id_varin(jvar)
        zv(:,:,jvar) = getvar(cf_zonal, cv_names(ivar), 1, 1, npjglo, ktime=jt)
     END DO ! next variable

     WRITE(6,*) ' JT = ', jt, ' TIME = ', tim(jt)
     WRITE(6,*) ' J  LAT ', (TRIM(cv_names(id_varin(jvar))),' ',jvar=1,nvar)

     DO jj=npjglo,1,-1
        WRITE(6,*)  jj, zdumlat(1,jj), zv(1,jj,1:nvar)
     ENDDO
  ENDDO


END PROGRAM cdfzonalout

PROGRAM cdfzonalmean
  !!======================================================================
  !!                     ***  PROGRAM  cdfzonalmean  ***
  !!=====================================================================
  !!  ** Purpose : Compute the zonal mean of a file
  !!
  !!  ** Method  : In this program the 'zonal' mean is in fact a mean 
  !!               along the I coordinate. 
  !!
  !! History : 2.1  : 11/2005  : J.M. Molines : Original code
  !!                : 06/2007  : P. Mathiot   : adaptation for 2D files
  !!           3.0  : 05/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  !! * Local variables
  IMPLICIT NONE

  INTEGER(KIND=4)                               :: ji, jj, jk ,jt      ! dummy loop index
  INTEGER(KIND=4)                               :: jbasin, jvar        ! dummy loop index
  INTEGER(KIND=4)                               :: ijvar               ! variable counter
  INTEGER(KIND=4)                               :: npbasins=1          ! number of subbasin
  INTEGER(KIND=4)                               :: ivar = 0            ! output variable counter
  INTEGER(KIND=4)                               :: narg, iargc         ! command line 
  INTEGER(KIND=4)                               :: ijarg, ireq         ! command line 
  INTEGER(KIND=4)                               :: npiglo, npjglo      ! size of the domain
  INTEGER(KIND=4)                               :: npk, npt            ! size of the domain
  INTEGER(KIND=4)                               :: nvarin, nvar        ! number of input variables: all/valid
  INTEGER(KIND=4)                               :: ncout               ! ncid of output file
  INTEGER(KIND=4)                               :: ierr, ik            ! working integers
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: ipki, id_varin      ! jpbasin x nvar
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: ipko, id_varout     ! jpbasin x nvar
  INTEGER(KIND=4), DIMENSION(2)                 :: ijloc               ! working array for maxloc

  REAL(KIND=4)                                  :: zspval=99999.       ! missing value 
  REAL(KIND=4), DIMENSION (:),      ALLOCATABLE :: tim                 ! time counter
  REAL(KIND=4), DIMENSION (:),      ALLOCATABLE :: gdep                ! gdept or gdepw
  REAL(KIND=4), DIMENSION (:,:),    ALLOCATABLE :: e1, e2, gphi, zv    ! metrics, latitude, data value
  REAL(KIND=4), DIMENSION (:,:),    ALLOCATABLE :: zdumlon             ! dummy longitude = 0.
  REAL(KIND=4), DIMENSION (:,:),    ALLOCATABLE :: zdumlat             ! latitude for i = north pole
  REAL(KIND=4), DIMENSION (:,:),    ALLOCATABLE :: zmaskvar            ! variable mask
  REAL(KIND=4), DIMENSION (:,:,:),  ALLOCATABLE :: zmask               ! basin mask jpbasins x npiglo x npjglo

  REAL(KIND=8), DIMENSION (:,:),    ALLOCATABLE :: dzomean , darea     ! jpbasins x npjglo x npk

  CHARACTER(LEN=256)                            :: cf_in               ! input file name
  CHARACTER(LEN=256)                            :: cf_out='zonalmean.nc' ! output file name
  CHARACTER(LEN=256)                            :: cf_basins='none'    ! sub basin file name
  CHARACTER(LEN=10 )                            :: cv_e1, cv_e2        ! horizontal metrics variable names
  CHARACTER(LEN=10 )                            :: cv_phi              ! latitude variable name
  CHARACTER(LEN=10 )                            :: cv_msk              ! mask variable name
  CHARACTER(LEN=10 )                            :: cv_depi, cv_depo    ! depth variable name (input/output)
  CHARACTER(LEN=256)                            :: cldum               ! dummy character variable
  CHARACTER(LEN=256)                            :: ctyp                ! variable type on C-grid
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_namesi           ! input variable names
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_nameso           ! output variable names
  CHARACTER(LEN=4  ), DIMENSION(5)              :: cbasin=(/'_glo','_atl','_inp','_ind','_pac'/) ! sub basin suffixes

  TYPE(variable), DIMENSION(:),     ALLOCATABLE :: stypvari            ! structure for input variables
  TYPE(variable), DIMENSION(:),     ALLOCATABLE :: stypvaro            ! structure for output variables

  LOGICAL                                       :: lpdep    =.FALSE.   ! flag for depth sign (default dep < 0)
  LOGICAL                                       :: lndep_in =.FALSE.   ! flag for depth sign (default dep < 0) in input file
  LOGICAL                                       :: ldebug   =.FALSE.   ! flag for activated debug print 
  LOGICAL                                       :: l2d      =.FALSE.   ! flag for 2D files
  LOGICAL                                       :: lchk     =.FALSE.   ! flag for missing files
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfzonalmean IN-file point_type [ BASIN-file] ...'
     PRINT *,'                  ... [-pdep | --positive_depths]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the zonal mean of all the variables available in the' 
     PRINT *,'       input file. This program assume that all the variables are'
     PRINT *,'       located on the same C-grid point, specified on the command line.'
     PRINT *,'      '
     PRINT *,'       Zonal mean is in fact the mean value computed along the I coordinate.'
     PRINT *,'       The result is a vertical slice, in the meridional direction.'
     PRINT *,'      '
     PRINT *,'       REMARK : partial step are not handled properly (but probably '
     PRINT *,'                minor impact on results).'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       IN-file    : input netcdf file.' 
     PRINT *,'       point_type : indicate the location on C-grid (T|U|V|F|W)'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [BASIN-file] : netcdf file describing sub basins, similar to '
     PRINT *,'                      ', TRIM(cn_fbasins),'. If this name is not given '
     PRINT *,'                      as option, only the global zonal mean is computed.'
     PRINT *,'       [-pdep | --positive_depths ] : use positive depths in the output file.'
     PRINT *,'                      Default behaviour is to have negative depths.'
     PRINT *,'       [-ndep_in ] : negative depths are used in the input file.'
     PRINT *,'                      Default behaviour is to have positive depths.'
     PRINT *,'       [-debug   ] : add some print for debug'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ',TRIM(cn_fhgr),', ', TRIM(cn_fzgr),' and ', TRIM(cn_fmsk)
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : output variable names are built with the following'
     PRINT *,'                     convention: zoxxxx_bas'
     PRINT *,'                      where zo replace vo/so prefix of the input variable'
     PRINT *,'                      where bas is a suffix for each sub-basins (or glo)'
     PRINT *,'                      if a BASIN-file is used.'
     STOP
  ENDIF

  ijarg = 1  ; ireq = 0
  DO WHILE ( ijarg <= narg ) 
    CALL getarg( ijarg, cldum ) ; ijarg=ijarg+1
    SELECT CASE (cldum)
    CASE ( '-pdep' , '--positive_depths' ) ; lpdep    =.TRUE.
    CASE ( '-ndep_in'                    ) ; lndep_in =.TRUE.
    CASE ( '-debug'                      ) ; ldebug   =.TRUE.
    CASE DEFAULT
      ireq=ireq+1
      SELECT CASE (ireq)
      CASE (1) ; cf_in      = cldum                 ! file name is the 1rst argument
      CASE (2) ; ctyp       = cldum                 ! point type is the 2nd
      CASE (3) ; cf_basins  = cldum                 ! sub basin file is the 3rd (optional)
                 npbasins   = 5
                 lchk       = chkfile (cf_basins)
      CASE DEFAULT 
        PRINT *,' Too many arguments ...' ; STOP
      END SELECT
    END SELECT
  END DO

  ! check  files existence
  lchk = lchk .OR. chkfile (cn_fhgr)
  lchk = lchk .OR. chkfile (cn_fzgr)
  lchk = lchk .OR. chkfile (cn_fmsk)
  lchk = lchk .OR. chkfile (cf_in  )
  IF ( lchk ) STOP ! missing files

  ! set the metrics according to C grid point
  SELECT CASE (ctyp)
  CASE ('T', 't', 'S', 's')
     cv_e1   = cn_ve1t    ; cv_e2   = cn_ve2t
     cv_depi = cn_gdept   ; cv_depo = cn_vdeptht
     cv_phi  = cn_gphit   ; cv_msk  = 'tmask'
  CASE ('U', 'u')
     cv_e1   = cn_ve1u    ; cv_e2   = cn_ve2u
     cv_depi = cn_gdept   ; cv_depo = cn_vdepthu
     cv_phi  = cn_gphiu   ; cv_msk  = 'umask'
  CASE ('V', 'v')
     cv_e1   = cn_ve1v    ; cv_e2   = cn_ve2v
     cv_depi = cn_gdept   ; cv_depo = cn_vdepthv
     cv_phi  = cn_gphiv   ; cv_msk  = 'vmask'
  CASE ('F', 'f')
     cv_e1   = cn_ve1f    ; cv_e2   = cn_ve2f
     cv_depi = cn_gdept   ; cv_depo = cn_vdeptht
     cv_phi  = cn_gphif   ; cv_msk  = 'fmask'
  CASE ('W', 'w')
     cv_e1   = cn_ve1t    ; cv_e2   = cn_ve2t
     cv_depi = cn_gdepw   ; cv_depo = cn_vdepthw
     cv_phi  = cn_gphit   ; cv_msk  = 'tmask'
  CASE DEFAULT
     PRINT *, ' C grid:', TRIM(ctyp),' point not known!' ; STOP
  END SELECT

  nvarin  = getnvar(cf_in)   ! number of input variables
  ALLOCATE ( cv_namesi(nvarin),          ipki(nvarin),          id_varin (nvarin)          )
  ALLOCATE ( cv_nameso(npbasins*nvarin), ipko(npbasins*nvarin), id_varout(npbasins*nvarin) )
  ALLOCATE ( stypvari(nvarin)                                                              )
  ALLOCATE ( stypvaro(npbasins*nvarin)                                                     )

  cv_namesi(1:nvarin) = getvarname(cf_in, nvarin, stypvari )
  ipki     (1:nvarin) = getipk    (cf_in, nvarin           )

  ! buildt output filename
  nvar = 0  ! over all number of valid variables for zonal mean ( < nvarin)
  ivar = 0  ! over all variable counter ( nvar x basins)
  DO jvar = 1,nvarin
     ! skip variables such as nav_lon, nav_lat, time_counter deptht ...
     IF (ipki(jvar) == 0 ) THEN
        cv_namesi(jvar)='none'
     ELSE
        nvar           = nvar + 1 ! count for valid input variables
        id_varin(nvar) = jvar     ! use indirect adressing for those variables
        DO jbasin=1,npbasins
           ivar=ivar + 1      ! count for output variables
           cv_nameso(ivar)='zo'//TRIM(cv_namesi(jvar)(3:))//TRIM(cbasin(jbasin) )
           ! intercept case of duplicate zonal name
           IF (cv_namesi(jvar) == 'iowaflup' ) cv_nameso(ivar)='zowaflio'  // TRIM(cbasin(jbasin) )
           IF (cv_namesi(jvar) == 'cfc11'    ) cv_nameso(ivar)='zocfc11'   // TRIM(cbasin(jbasin) )
           IF (cv_namesi(jvar) == 'bombc14'  ) cv_nameso(ivar)='zobc14'    // TRIM(cbasin(jbasin) )
           IF (cv_namesi(jvar) == 'invcfc'   ) cv_nameso(ivar)='zoinvcfc'  // TRIM(cbasin(jbasin) )
           IF (cv_namesi(jvar) == 'invc14'   ) cv_nameso(ivar)='zoinvc14'  // TRIM(cbasin(jbasin) )
           IF (cv_namesi(jvar) == 'qtrcfc'   ) cv_nameso(ivar)='zoqtrcfc'  // TRIM(cbasin(jbasin) )
           IF (cv_namesi(jvar) == 'qtrc14'   ) cv_nameso(ivar)='zoqtrc14'  // TRIM(cbasin(jbasin) )
           IF (cv_namesi(jvar) == 'qintcfc'  ) cv_nameso(ivar)='zoqintcfc' // TRIM(cbasin(jbasin) )
           IF (cv_namesi(jvar) == 'qintc14'  ) cv_nameso(ivar)='zoqintc14' // TRIM(cbasin(jbasin) )

           stypvaro(ivar)%cname             = cv_nameso(ivar)
           stypvaro(ivar)%cunits            = stypvari(jvar)%cunits
           stypvaro(ivar)%rmissing_value    = zspval
           stypvaro(ivar)%valid_min         = stypvari(jvar)%valid_min
           stypvaro(ivar)%valid_max         = stypvari(jvar)%valid_max
           stypvaro(ivar)%clong_name        = 'Zonal_Mean_'//TRIM(stypvari(jvar)%clong_name)//TRIM(cbasin(jbasin) )
           stypvaro(ivar)%cshort_name       = stypvaro(ivar)%cname
           stypvaro(ivar)%conline_operation = '/N/A'

           IF (ipki(jvar) == 1 ) THEN
             stypvaro(ivar)%caxis           ='TY'
           ELSE
             stypvaro(ivar)%caxis           ='TZY'
           ENDIF

           ipko(ivar)=ipki(jvar)
        END DO
     ENDIF
  END DO

  npiglo = getdim (cf_in, cn_x)
  npjglo = getdim (cf_in, cn_y)
  npk    = getdim (cf_in, cn_z)
  npt    = getdim (cf_in, cn_t)

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  ! if 2D fields, npk=0, assume 1
  IF ( npk == 0 ) THEN
     npk = 1 
     l2d = .TRUE.
     PRINT *,' It is a 2D field, assume npk=1 and gdep=0'
  END IF
  ! Allocate arrays
  ALLOCATE ( zmask(npbasins,npiglo,npjglo)              )
  ALLOCATE ( zv(npiglo,npjglo), zmaskvar(npiglo,npjglo) )
  ALLOCATE ( e1(npiglo,npjglo), e2      (npiglo,npjglo) )
  ALLOCATE ( gphi(npiglo,npjglo), gdep(npk), tim(npt)   )
  ALLOCATE ( zdumlon(1,npjglo), zdumlat(1,npjglo)       )
  ALLOCATE ( dzomean(npjglo,npk), darea(npjglo,npk)     )


  ! get the metrics
  e1(:,:)   = getvar(cn_fhgr, cv_e1,  1, npiglo, npjglo) 
  e2(:,:)   = getvar(cn_fhgr, cv_e2,  1, npiglo, npjglo) 
  gphi(:,:) = getvar(cn_fhgr, cv_phi, 1, npiglo, npjglo)

  IF (l2d)  THEN 
     gdep(:) = 0
  ELSE
     gdep(:) = getvare3(cn_fzgr, cv_depi ,npk)
     IF (ldebug) PRINT *, 'getvare3 : ', TRIM(cn_fzgr), TRIM(cv_depi), npk
     IF (ldebug) PRINT *, 'getvare3 : ', gdep
  ENDIF

  IF ( .NOT. lpdep ) gdep(:)   = -1.*  gdep(:)     ! helps for plotting the results

  ! Look for the i-index that go through the North Pole
  ijloc        = MAXLOC(gphi)
  zdumlat(1,:) = gphi(ijloc(1),:)
  zdumlon(:,:) = 0.              ! set the dummy longitude to 0

  ! create output fileset
  ncout = create      (cf_out, cf_in,    1,    npjglo, npk,  cdep=cv_depo                                )
  ierr  = createvar   (ncout,  stypvaro, ivar, ipko,   id_varout                                         )
  ierr  = putheadervar(ncout,  cf_in,    1,    npjglo, npk,  pnavlon=zdumlon, pnavlat=zdumlat, pdep=gdep )

  tim   = getvar1d(cf_in, cn_vtimec, npt     )
  ierr  = putvar1d(ncout, tim,       npt, 'T')

  ! reading the surface masks
  ! 1 : global ; 2 : Atlantic ; 3 : Indo-Pacif ; 4 : Indian ; 5 : Pacif
  ik=1
  IF ( lndep_in ) ik = npk   ! some model are numbered from the bottom
  zmask(1,:,:) = getvar(cn_fmsk, cv_msk, ik, npiglo, npjglo)
  IF ( cf_basins /= 'none' ) THEN
     zmask(2,:,:) = getvar(cf_basins, 'tmaskatl', ik, npiglo, npjglo )
     zmask(4,:,:) = getvar(cf_basins, 'tmaskind', ik, npiglo, npjglo )
     zmask(5,:,:) = getvar(cf_basins, 'tmaskpac', ik, npiglo, npjglo )
     zmask(3,:,:) = zmask(5,:,:) + zmask(4,:,:)
     ! ensure that there are no overlapping on the masks
     WHERE(zmask(3,:,:) > 0 ) zmask(3,:,:) = 1
  ENDIF

  ! main computing loop
  ivar = 0
  DO jvar = 1, nvar
     ijvar = id_varin(jvar)
     DO jt = 1,npt
        IF (MOD(jt,100)==0) PRINT *, jt,'/',npt
        DO jk = 1, ipki(ijvar)
           IF (ldebug) PRINT *,TRIM(cv_namesi(ijvar)), ' level ',jk
           ! Get variables and mask at level jk
           zv(:,:)       = getvar(cf_in,   cv_namesi(ijvar),jk ,npiglo, npjglo, ktime=jt)
           zmaskvar(:,:) = getvar(cn_fmsk, cv_msk ,         jk ,npiglo, npjglo          )
           
           ! For all basins 
           DO jbasin = 1, npbasins
              dzomean(:,:) = 0.d0
              darea(:,:)   = 0.d0
              ! integrates 'zonally' (along i-coordinate)
              DO ji=1,npiglo
                 DO jj=1,npjglo
                    dzomean(jj,jk) = dzomean(jj,jk) + 1.d0*e1(ji,jj)*e2(ji,jj)* zmask(jbasin,ji,jj)*zmaskvar(ji,jj)*zv(ji,jj)
                    darea(jj,jk)   = darea(jj,jk)   + 1.d0*e1(ji,jj)*e2(ji,jj)* zmask(jbasin,ji,jj)*zmaskvar(ji,jj)
                 END DO
              END DO

              ! compute the mean value if the darea is not 0, else assign spval
              WHERE (darea /= 0 ) 
                 dzomean=dzomean/darea
              ELSEWHERE
                 dzomean=zspval
              ENDWHERE
              ivar = (jvar-1)*npbasins + jbasin
              ierr = putvar (ncout, id_varout(ivar), REAL(dzomean(:,jk)), jk, 1, npjglo, ktime=jt)
           END DO  !next basin
        END DO  ! next k 
     END DO ! next time
  END DO ! next variable

  ierr = closeout(ncout)

END PROGRAM cdfzonalmean

PROGRAM cdflap
  !!======================================================================
  !!                     ***  PROGRAM  cdflap  ***
  !!=====================================================================
  !!  ** Purpose : Compute the laplacian of a field given in argument
  !!
  !!  ** Method  : Use a classical centered stencil
  !!               Gradient along the coasline are set to 0
  !!
  !! History :  3.0  : 09/2014  : J.M. Molines 
  !!         :  4.0  : 03/2017  : J.M. Molines  
  !!          
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class derived_fields
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                              :: ji, jj, jk, jt, jv ! dummy loop index
  INTEGER(KIND=4)                              :: npiglo, npjglo     ! size of the domain
  INTEGER(KIND=4)                              :: npk, npt           ! size of the domain
  INTEGER(KIND=4)                              :: npkv               ! vertical size of the variable
  INTEGER(KIND=4)                              :: narg, iargc, ijarg ! browse line
  INTEGER(KIND=4)                              :: ncout              ! ncid of output file
  INTEGER(KIND=4)                              :: nvars              ! nmber of variables in input file
  INTEGER(KIND=4)                              :: ierr               ! error status
  INTEGER(KIND=4)                              :: iioff1, iioff2     ! i-offset for mask
  INTEGER(KIND=4)                              :: ijoff1, ijoff2     ! j-offset for mask
  INTEGER(KIND=4)                              :: ii1, ii2, ij1, ij2 ! working index
  INTEGER(KIND=4), DIMENSION(1)                :: ipk, id_varout     ! levels and varid's of output vars
  INTEGER(KIND=4), DIMENSION(:),   ALLOCATABLE :: ipkin              ! ipk of all variables in input files

  REAL(KIND=4)                                 :: rmissing           ! missing value or_FillValue of input variable
  REAL(KIND=4)                                 :: grav=9.81          ! Gravity acceleration (m2/s)
  REAL(KIND=4)                                 :: omega              ! earth rotation rate
  REAL(KIND=4)                                 :: rpi                ! 3.14159...
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: e1_i1, e1_i2       ! along i horizontal metric
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: e2_j1, e2_j2       ! along j horizontal metric
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: rmski, rmskj       ! relevant mask
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: v2d                ! input variable
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: ff                 ! Coriolis
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: gphi               ! Coriolis

  REAL(KIND=8)                                 :: dspval=99999.d0    ! output laplacian
  REAL(KIND=8), DIMENSION(:),      ALLOCATABLE :: dtim               ! time counter
  REAL(KIND=8), DIMENSION(:,:),    ALLOCATABLE :: dlap               ! output laplacian

  CHARACTER(LEN=256)                           :: cf_in              ! input file name
  CHARACTER(LEN=256)                           :: cv_in              ! input variable name
  CHARACTER(LEN=256)                           :: cv_units           ! units of input variable name
  CHARACTER(LEN=256)                           :: cv_lat             ! name of latitude variable in hgr
  CHARACTER(LEN=3)                             :: ct_in              ! input variable type [ T U V F ] on C-grid
  CHARACTER(LEN=256)                           :: cf_out='lap.nc'    !output file name
  CHARACTER(LEN=256)                           :: cln_in             ! Long name of input variable
  CHARACTER(LEN=256)                           :: csn_in             ! Short name of input variable
  CHARACTER(LEN=256)                           :: cldum              ! dummy string
  CHARACTER(LEN=10)                            :: ce1_i1, ce1_i2     ! name of relevant horizontal i-metric
  CHARACTER(LEN=10)                            :: ce2_j1, ce2_j2     ! name of relevant horizontal i-metric
  CHARACTER(LEN=10)                            :: cmask_i, cmask_j   ! name of relevant mask variable
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_nam             ! array of var name

  TYPE(variable), DIMENSION(1)                 :: stypvar            ! output attributes
  TYPE(variable), DIMENSION(:), ALLOCATABLE    :: sdum               ! input attributes

  LOGICAL                                      :: lchk               ! missing files flag
  LOGICAL                                      :: l_overf2=.FALSE.   ! overf flag
  LOGICAL                                      :: l_metric=.TRUE.    ! use metric flag
  LOGICAL                                      :: lnc4    = .FALSE.  ! Use nc4 with chunking and deflation
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdflap -f IN-file -v IN-var -t IN-type [-overf2] [-nometric] ...'
     PRINT *,'               ...[-o OUT-file] [-nc4]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the Laplacian of the variable IN-var in file IN-file. Assume'
     PRINT *,'       that the data are on a C-grid model (as NEMO).'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -f IN-file : netcdf file in input'
     PRINT *,'       -v IN-var  : name of the variable to process '
     PRINT *,'       -t IN-TYPE : Position of the variable on the C-grid [ T U V F ]'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-overf2] : save laplacien/f/f*g (where f is the local coriolis '
     PRINT *,'            parameter, and g is the accelaration due to gravity --9.81 m/s2-- )'
     PRINT *,'            For the SSH field, this is a proxy for geostrophic vorticity'
     PRINT *,'       [-nometric] : compute laplacian without considering metrics '
     PRINT *,'       [-o OUT-file] : specify output file name instead of ',TRIM(cf_out)
     PRINT *,'            This option must be used after the -overf2 or -nometric option, as'
     PRINT *,'            output file name is redefined when using these options.'
     PRINT *,'       [-nc4 ] : Use netcdf4 output with chunking and deflation level 1..'
     PRINT *,'            This option is effective only if cdftools are compiled with'
     PRINT *,'            a netcdf library supporting chunking and deflation.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ',TRIM(cn_fhgr)," ",TRIM(cn_fzgr) ,' and ', TRIM(cn_fmsk)
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : lap<var> (unit/m2)'
     PRINT *,'       if option -overf2 is used, netcdf file is lapoverf2.nc and '
     PRINT *,'       variable is lap<var>overf2'
     STOP 
  ENDIF

  ijarg = 1
  DO WHILE ( ijarg <= narg )
     CALL getarg(ijarg, cldum ) ; ijarg = ijarg + 1
     SELECT CASE (cldum )
     CASE ( '-f'       ) ; CALL getarg(ijarg,cf_in ) ; ijarg=ijarg+1
     CASE ( '-v'       ) ; CALL getarg(ijarg,cv_in ) ; ijarg=ijarg+1
     CASE ( '-t'       ) ; CALL getarg(ijarg,ct_in ) ; ijarg=ijarg+1
        !options
     CASE ( '-overf2'  ) ; l_overf2 = .TRUE.
        ;                  cf_out   = 'lapoverf2.nc'
     CASE ( '-nometric') ; l_metric = .FALSE.
        ;                  cf_out   = 'lapgrid.nc'
     CASE ( '-o'       ) ; CALL getarg(ijarg,cf_out) ; ijarg=ijarg+1
     CASE ( '-nc4'     ) ; lnc4     = .TRUE.
     CASE DEFAULT        ; PRINT *,' ERROR : ',TRIM(cldum),' : unknown option.'; STOP 99
     END SELECT
  ENDDO
  PRINT *, ' TYP ', ct_in

  ! check if files exists
  lchk=.FALSE.
  IF ( l_metric ) THEN
     lchk = chkfile (cn_fhgr)
     lchk = chkfile (cn_fzgr) .OR. lchk
     lchk = chkfile (cn_fmsk) .OR. lchk
  ENDIF
  lchk = chkfile (cf_in  ) .OR. lchk
  IF ( lchk ) STOP 99 ! missing files

  npiglo = getdim(cf_in,cn_x)
  npjglo = getdim(cf_in,cn_y)
  npk    = getdim(cf_in,cn_z)
  npt    = getdim(cf_in,cn_t)

  !IF ( npk == 0 ) THEN 
  !  PRINT *, 'Input file with no vertical dimension'
  !  PRINT *, 'Set npk to 1 '
  !  npk = 1
  !ENDIF

  PRINT *, 'NPIGLO : ', npiglo
  PRINT *, 'NPJGLO : ', npjglo
  PRINT *, 'NPK    : ', npk
  PRINT *, 'NPT    : ', npT

  nvars = getnvar(cf_in)   ! get the number of variables in files
  ALLOCATE(cv_nam(nvars), ipkin(nvars) ,sdum(nvars) )

  ! get list of variable names and collect attributes in stypvar
  cv_nam(:) = getvarname(cf_in,nvars, sdum)

  ! determine the vertical size of the working variable
  ipkin(:)  = getipk (cf_in,nvars)
  DO jv =1, nvars
     IF ( cv_nam(jv) == cv_in ) THEN
        npkv=ipkin(jv)
        EXIT
     ENDIF
  ENDDO

  ierr = getvaratt (cf_in, cv_in, cv_units, rmissing, cln_in, csn_in)

  ! fix mesh mask variables according to variable type
  ! HOT ! need to write down stencil to fully understand those settings ...
  SELECT CASE (ct_in )
  CASE ( 'T' )
     ! needs umask, vmask, e1u, e1t, e2v, e2t 
     cmask_i = cn_umask  ; cmask_j = cn_vmask
     ce1_i1  = cn_ve1u   ; ce1_i2  = cn_ve1t
     ce2_j1  = cn_ve2v   ; ce2_j2  = cn_ve2t
     iioff1  = 0         ; iioff2  = 1
     ijoff1  = 0         ; ijoff2  = 1
     cv_lat  =cn_gphit
  CASE ( 'U' )
     ! needs tmask, fmask, e1t, e1u, e2f, e2u 
     cmask_i = cn_tmask  ; cmask_j = cn_fmask
     ce1_i1  = cn_ve1t   ; ce1_i2  = cn_ve1u
     ce2_j1  = cn_ve2f   ; ce2_j2  = cn_ve2u
     iioff1  = 1         ; iioff2  = 0
     ijoff1  = 0         ; ijoff2  = 1
     cv_lat  =cn_gphiu
  CASE ( 'V' )
     ! needs fmask, tmask, e1f, e1v, e2t, e2v 
     cmask_i = cn_fmask  ; cmask_j = cn_tmask
     ce1_i1  = cn_ve1f   ; ce1_i2  = cn_ve1v
     ce2_j1  = cn_ve2t   ; ce2_j2  = cn_ve2v
     iioff1  = 0         ; iioff2  = 1
     ijoff1  = 1         ; ijoff2  = 0
     cv_lat  =cn_gphiv
  CASE ( 'F' )
     ! needs vmask, umask, e1v, e1f, e2u, e2f 
     cmask_i = cn_vmask  ; cmask_j = cn_umask
     ce1_i1  = cn_ve1v   ; ce1_i2  = cn_ve1f
     ce2_j1  = cn_ve2u   ; ce2_j2  = cn_ve2f
     iioff1  = 1         ; iioff2  = 0
     ijoff1  = 1         ; ijoff2  = 0
     cv_lat  =cn_gphif
  CASE DEFAULT
     PRINT *, ' TYPE ', TRIM(ct_in),' unknown on C-grid'
     STOP 99
  END SELECT

  ! Allocate the memory
  ALLOCATE ( e1_i1(npiglo,npjglo), e2_j1(npiglo,npjglo) )
  ALLOCATE ( e1_i2(npiglo,npjglo), e2_j2(npiglo,npjglo) )
  ALLOCATE ( rmski(npiglo,npjglo), rmskj(npiglo,npjglo) )
  IF ( l_overf2 ) THEN
     ALLOCATE (  ff(npiglo,npjglo), gphi(npiglo,npjglo) )
  ENDIF

  ALLOCATE ( dlap(npiglo,npjglo), v2d(npiglo, npjglo)  )
  ALLOCATE ( dtim(npt) )

  ! Read the metrics from the mesh_hgr file
  IF ( l_metric ) THEN
     e1_i1 = getvar(cn_fhgr, ce1_i1, 1, npiglo, npjglo)
     e1_i2 = getvar(cn_fhgr, ce1_i2, 1, npiglo, npjglo)
     e2_j1 = getvar(cn_fhgr, ce2_j1, 1, npiglo, npjglo)
     e2_j2 = getvar(cn_fhgr, ce2_j2, 1, npiglo, npjglo)
  ELSE
     e1_i1 = 1.
     e1_i2 = 1.
     e2_j1 = 1.
     e2_j2 = 1.
  ENDIF
  !
  IF ( l_overf2 ) THEN
     ! to prepare computation of g/f*LAP(SSH) 
     gphi    = getvar(cn_fhgr, cv_lat, 1, npiglo, npjglo)
     rpi     = ACOS(-1.)
     omega   = 2 * rpi / 86400.
     ff     = 2.*omega* SIN (gphi*rpi/180.)
     WHERE (ff == 0 ) ff = EPSILON(1.0)
  ENDIF

  ! define new variables for output
  CALL CreateOutput

  ! Main time loop
  DO jt = 1, npt
     ! Main level loop from top to bottom
     DO jk = 1, npkv
        PRINT *,'jt = ', jt,' jk = ', jk

        ! variable at level jk time jt
        v2d(:,:) =  getvar(cf_in, cv_in, jk, npiglo, npjglo, ktime=jt)
        ! relevant mask
        IF ( l_metric ) THEN
           rmski = getvar(cn_fmsk, cmask_i, jk, npiglo, npjglo)
           rmskj = getvar(cn_fmsk, cmask_j, jk, npiglo, npjglo)
        ELSE
           ! something can be done with regard to field's  missing value
           rmski = 1.
           rmskj = 1.
        ENDIF
        ! Compute laplacian
        dlap(:,:) = 0.d0
        DO jj = 2, npjglo -1
           ij1 = jj + ijoff1
           ij2 = jj - ijoff2
           DO ji = 2, npiglo -1
              ii1 = ji + iioff1
              ii2 = ji - iioff2
              dlap(ji,jj) = ((v2d(ji+1,jj  )-v2d(ji  ,jj  ))*1.d0/e1_i1(ii1,jj)*rmski(ii1,jj)                &
                   &       - (v2d(ji  ,jj  )-v2d(ji-1,jj  ))*1.d0/e1_i1(ii2,jj)*rmski(ii2,jj))/e1_i2(ji,jj)  &
                   &       +((v2d(ji  ,jj+1)-v2d(ji  ,jj  ))*1.d0/e2_j1(ji,ij1)*rmskj(ji,ij1)                &
                   &       - (v2d(ji  ,jj  )-v2d(ji  ,jj-1))*1.d0/e2_j1(ji,ij2)*rmskj(ji,ij2))/e2_j2(ji,jj)
           END DO
        END DO

        IF ( l_overf2 ) THEN
           WHERE (dlap == 0.d0 )
              dlap = dspval
           ELSEWHERE
              dlap = grav*dlap /ff/ff
           ENDWHERE
        ENDIF

        ! write level jk 
        ierr = putvar(ncout, id_varout(1), REAL(dlap), jk, npiglo, npjglo, ktime=jt)

     END DO  ! loop to next level
  END DO ! loop on time

  ierr = closeout(ncout)

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    ipk(1) = npkv
    IF ( l_overf2) THEN ; stypvar(1)%cname      = 'lap'//TRIM(cv_in)//'overf2'
       ;                  stypvar(1)%cunits     = TRIM(cv_units)//'/m'
       ;                  stypvar(1)%clong_name = 'Laplacian of '//TRIM(cln_in)
    ELSE                ; stypvar(1)%cname      = 'lap'//TRIM(cv_in)
       ;                  stypvar(1)%cunits     = TRIM(cv_units)//'/m2'
       ;                  stypvar(1)%clong_name = 'g /f/f* Laplacian of '//TRIM(cln_in)
    ENDIF

    stypvar(1)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(1)%rmissing_value    = dspval
    stypvar(1)%valid_min         = -10.
    stypvar(1)%valid_max         = 10.
    stypvar(1)%cshort_name       = stypvar(1)%cname
    stypvar(1)%conline_operation = 'N/A'
    stypvar(1)%caxis             = 'TZYX'

    ! create output fileset
    ncout = create      (cf_out, cf_in, npiglo, npjglo, npk         , ld_nc4=lnc4 ) 
    ierr  = createvar   (ncout,  stypvar, 1,      ipk,    id_varout , ld_nc4=lnc4 )
    ierr  = putheadervar(ncout,  cf_in, npiglo, npjglo, npk         )

    dtim = getvar1d(cf_in , cn_vtimec, npt     )
    ierr = putvar1d(ncout , dtim     , npt, 'T')

  END SUBROUTINE CreateOutput

END PROGRAM cdflap

PROGRAM cdfsmooth
  !!======================================================================
  !!                     ***  PROGRAM  cdfsmooth  ***
  !!=====================================================================
  !!  ** Purpose :  perform a spatial filtering on input file.
  !!               - various filters are available :
  !!               1: Lanczos (default)
  !!               2: hanning
  !!               3: shapiro
  !!
  !!  ** Method  : read file level by level and perform a x direction 
  !!               filter, then y direction filter
  !!
  !! History : --   : 1995     : J.M. Molines : Original code for spem
  !!         : 2.1  : 07/2007  : J.M. Molines : port in cdftools
  !!         : 2.1  : 05/2010  : R. Dussin    : Add shapiro filter
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!           3.0  : 07/2011  : R. Dussin    : Add anisotropic box 
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  !!   routines      : description
  !!  filterinit   : initialise weight
  !!  filter       : main routine for filter computation
  !!  initlanc     : initialise lanczos weights
  !!  inithann     : initialise hanning weights
  !!  initshap     : initialise shapiro routine
  !!  initbox      : initialize weight for box car average
  !!  lislanczos2d : Lanczos filter
  !!  lishan2d     : hanning 2d filter
  !!  lisshapiro1d : shapiro filter
  !!  lisbox       : box car filter
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  USE modutils
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE
  !
  INTEGER(KIND=4), PARAMETER                    :: jp_lanc=1         ! lancszos id
  INTEGER(KIND=4), PARAMETER                    :: jp_hann=2         ! hanning id
  INTEGER(KIND=4), PARAMETER                    :: jp_shap=3         ! shapiro id
  INTEGER(KIND=4), PARAMETER                    :: jp_boxc=4         ! box car id
  INTEGER(KIND=4)                               :: jk, jt, jvar      ! dummy loop index
  INTEGER(KIND=4)                               :: npiglo, npjglo    ! size of the domain
  INTEGER(KIND=4)                               :: npk, npkf, npt    ! size of the domain
  INTEGER(KIND=4)                               :: narg, iargc       ! browse arguments
  INTEGER(KIND=4)                               :: ijarg             ! argument index for browsing line
  INTEGER(KIND=4)                               :: ncut, nband       ! cut period/ length, bandwidth
  INTEGER(KIND=4)                               :: nfilter = jp_lanc ! default value
  INTEGER(KIND=4)                               :: nvars, ierr       ! number of vars
  INTEGER(KIND=4)                               :: ncout             ! ncid of output file
  INTEGER(KIND=4)                               :: ilev              ! level to process if not 0
  INTEGER(KIND=4)                               :: ijk               ! indirect level addressing
  INTEGER(KIND=4), DIMENSION(:,:),  ALLOCATABLE :: iw                ! flag for bad values (or land masked )
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: id_var            ! arrays of var id's
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: ipk               ! arrays of vertical level for each var
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: id_varout         ! id of output variables
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: iklist            ! list of k-level to process

  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: v2d, w2d          ! raw data,  filtered result
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: tim               ! time array
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: gdep, gdeptmp     ! depth array 
  REAL(KIND=4)                                  :: fn, rspval        ! cutoff freq/wavelength, spval
  REAL(KIND=4)                                  :: ranis             ! anistropy

  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: dec2d             ! working array
  REAL(KIND=8), DIMENSION(:),       ALLOCATABLE :: dec, de           ! weight in r8, starting index 0:nband

  TYPE (variable), DIMENSION(:),    ALLOCATABLE :: stypvar           ! struture for attribute

  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_names          ! array of var name
  CHARACTER(LEN=256)                            :: cf_in, cf_out     ! file names
  CHARACTER(LEN=256)                            :: cv_dep, cv_tim    ! variable name for depth and time
  CHARACTER(LEN=256)                            :: ctyp              ! filter type
  CHARACTER(LEN=256)                            :: cldum             ! dummy character variable
  CHARACTER(LEN=256)                            :: clklist           ! ciphered k-list of level
 
  LOGICAL                                       :: lnc4 = .false.    ! flag for netcdf4 output with chinking and deflation

  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg=iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfsmooth -f IN-file -c ncut [-t filter_type] [ -k level_list ] ...'
     PRINT *,'       [-a anisotripoc ratio ] [-nc4 ] '
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Perform a spatial smoothing on the file using a particular'
     PRINT *,'       filter as specified in the option. Available filters' 
     PRINT *,'       are : Lanczos, Hanning, Shapiro, Box car average. Default'
     PRINT *,'       is Lanczos filter.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -f  IN-file  : input data file. All variables will be filtered'
     PRINT *,'       -c  ncut     : number of grid step to be filtered, or number'
     PRINT *,'                    of iteration of the Shapiro filter.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       -t filter_type : Lanczos      , L, l  (default)'
     PRINT *,'                        Hanning      , H, h'
     PRINT *,'                        Shapiro      , S, s'
     PRINT *,'                        Box          , B, b'
     PRINT *,'       -a aniso       : anisotropic ratio for Box car '
     PRINT *,'       -k level_list  : levels to be filtered (default = all levels)'
     PRINT *,'               level_list is a comma-separated list of levels.'
     PRINT *,'                  the syntax 1-3,6,9-12 will select 1 2 3 6 9 10 11 12'
     PRINT *,'       -nc4 : produce netcdf4 output file with chunking and deflation.'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       Output file name is build from input file name with indication'
     PRINT *,'       of the filter type (1 letter) and of ncut.'
     PRINT *,'       netcdf file :   IN-file[LHSB]ncut'
     PRINT *,'         variables : same as input variables.'
     STOP
  ENDIF
  !
  ijarg = 1
  ilev  = 0
  ranis = 1   ! anisotropic ratio for Box car filter
  ctyp  = 'L'
  ncut  = 0   ! hence program exit if none specified on command line
  DO WHILE (ijarg <= narg )
     CALL getarg ( ijarg, cldum ) ; ijarg=ijarg+1
     SELECT CASE (cldum)
     CASE ( '-f' ) ; CALL getarg ( ijarg, cf_in   ) ; ijarg=ijarg+1
     CASE ( '-c' ) ; CALL getarg ( ijarg, cldum   ) ; ijarg=ijarg+1 ; READ(cldum,*) ncut
     CASE ( '-t' ) ; CALL getarg ( ijarg, ctyp    ) ; ijarg=ijarg+1 
     CASE ( '-k' ) ; CALL getarg ( ijarg, clklist ) ; ijarg=ijarg+1 
          CALL GetList (clklist, iklist, ilev )
     CASE ( '-a'  ) ; CALL getarg ( ijarg, cldum   ) ; ijarg=ijarg+1 ; READ(cldum,*) ranis
     CASE ( '-nc4') ;  lnc4=.true.
     END SELECT
  ENDDO

  IF ( ncut == 0 ) THEN
     PRINT *, ' cdfsmooth : ncut = 0 --> nothing to do !'
     STOP 99
  ENDIF

  IF ( chkfile(cf_in) ) STOP 99 ! missing file

  !  remark: for a spatial filter, fn=dx/lambda where dx is spatial step, lamda is cutting wavelength
  fn    = 1./ncut
  nband = 2*ncut    ! Bandwidth of filter is twice the filter span

  ALLOCATE ( dec(0:nband) , de(0:nband) )

  WRITE(cf_out,'(a,a,i3.3)') TRIM(cf_in),'L',ncut   ! default name

     SELECT CASE ( ctyp)
     CASE ( 'Lanczos','L','l') 
        nfilter=jp_lanc
        WRITE(cf_out,'(a,a,i3.3)') TRIM(cf_in),'L',ncut
        PRINT *,' Working with Lanczos filter'
     CASE ( 'Hanning','H','h')
        nfilter=jp_hann
        ALLOCATE ( dec2d(0:2,0:2) )
        WRITE(cf_out,'(a,a,i3.3)') TRIM(cf_in),'H',ncut
        PRINT *,' Working with Hanning filter'
     CASE ( 'Shapiro','S','s')
        nfilter=jp_shap
        WRITE(cf_out,'(a,a,i3.3)') TRIM(cf_in),'S',ncut
        PRINT *,' Working with Shapiro filter'
     CASE ( 'Box','B','b')
        nfilter=jp_boxc
        WRITE(cf_out,'(a,a,i3.3)') TRIM(cf_in),'B',ncut
        IF ( ranis /=1. ) THEN
          PRINT *, 'Anisotropic box car with ratio Lx = ', ranis, 'x Ly'
        ELSE
          PRINT *,' Working with Box filter'
        ENDIF
     CASE DEFAULT
        PRINT *, TRIM(ctyp),' : undefined filter ' ; STOP 99
     END SELECT

  CALL filterinit (nfilter, fn, nband)
  ! Look for input file and create outputfile
  npiglo = getdim (cf_in,cn_x)
  npjglo = getdim (cf_in,cn_y)
  npk    = getdim (cf_in,cn_z, cdtrue=cv_dep, kstatus=ierr)
  npkf   = npk
  IF ( ierr /= 0 ) THEN
     npk   = getdim (cf_in,'z', cdtrue=cv_dep, kstatus=ierr)
     npkf  = npk
     IF ( ierr /= 0 ) THEN
        npk   = getdim (cf_in, 'sigma', cdtrue=cv_dep, kstatus=ierr)
        npkf  = npk
        IF ( ierr /= 0 ) THEN 
           PRINT *,' assume file with no depth'
           npk  = 1  ! Data have 1 level...
           npkf = 0  ! file have no deptht
        ENDIF
     ENDIF
  ENDIF
  npt    = getdim (cf_in,cn_t, cdtrue=cv_tim)

  PRINT *, 'npiglo = ',npiglo
  PRINT *, 'npjglo = ',npjglo
  PRINT *, 'npk    = ',npk
  PRINT *, 'npt    = ',npt

  ALLOCATE ( v2d(npiglo,npjglo),iw(npiglo,npjglo), w2d(npiglo,npjglo), tim(npt) )
  nvars = getnvar(cf_in)
  PRINT *, 'nvars = ', nvars
  ALLOCATE (cv_names(nvars) )
  ALLOCATE (stypvar(nvars) )
  ALLOCATE (id_var(nvars),ipk(nvars),id_varout(nvars) )

    ALLOCATE ( gdeptmp(npk)  )
    IF (npkf /= 0 ) THEN 
       gdeptmp(:) = getvar1d(cf_in, cv_dep, npk )  
    ELSE
       gdeptmp(:)=0.  ! dummy value
    ENDIF

  ! get list of variable names and collect attributes in stypvar (optional)
  cv_names(:) = getvarname(cf_in, nvars, stypvar)

  DO jvar=1,nvars
     ! choose chunk size for output ... not easy not used if lnc4=.false. but anyway ..
     stypvar(jvar)%ichunk=(/npiglo,MAX(1,npjglo/30),1,1 /)
  ENDDO

  ! ipk gives the number of level or 0 if not a T[Z]YX  variable
  ipk(:)     = getipk (cf_in, nvars, cdep=cv_dep)
  WHERE( ipk == 0 ) cv_names='none'
  stypvar(:)%cname=cv_names

  IF ( ilev /= 0 ) THEN   ! selected level on the command line
     WHERE (ipk(:) == npk ) ipk = ilev 
     npk = ilev
  ELSE                    ! all levels
     ilev = npk
     ALLOCATE(iklist(ilev) )
     iklist(:)=(/ (jk,jk=1,npk) /)
  ENDIF

  ALLOCATE ( gdep(ilev ) )
  gdep(:) = (/ (gdeptmp(iklist(jk)), jk=1,ilev) /)

  ! create output file taking the sizes in cf_in
  PRINT *, 'Output file name : ', TRIM(cf_out)
  ncout = create      (cf_out, cf_in,   npiglo, npjglo, npkf, cdep=cv_dep, ld_nc4=lnc4)
  ierr  = createvar   (ncout , stypvar, nvars,  ipk,    id_varout        , ld_nc4=lnc4)
  ierr  = putheadervar(ncout , cf_in,   npiglo, npjglo, npkf, pdep=gdep, cdep=cv_dep)
  tim   = getvar1d(cf_in, cv_tim, npt)
  !
  DO jvar = 1,nvars
     IF ( cv_names(jvar) == cn_vlon2d .OR.                     &
          cv_names(jvar) == cn_vlat2d .OR. cv_names(jvar) == 'none' ) THEN
        ! skip these variables
     ELSE
        rspval=stypvar(jvar)%rmissing_value
        DO jt=1,npt
           DO jk=1,ipk(jvar)
              PRINT *, jt,'/',npt,' and ',jk,'/',ipk(jvar)
              ijk = iklist(jk) 
              v2d(:,:) = getvar(cf_in,cv_names(jvar),ijk,npiglo,npjglo,ktime=jt)
              iw(:,:) = 1
              WHERE ( v2d == rspval ) iw =0
              IF ( ncut /= 0 ) CALL filter( nfilter, v2d, iw, w2d)
              IF ( ncut == 0 ) w2d = v2d
              w2d  = w2d *iw  ! mask filtered data
              ierr = putvar(ncout, id_varout(jvar), w2d, jk, npiglo, npjglo, ktime=jt)
              !
           END DO
        END DO
     ENDIF
  END DO
  ierr = putvar1d(ncout, tim, npt, 'T')
  ierr = closeout(ncout               )

CONTAINS

  SUBROUTINE filterinit(kfilter, pfn, kband)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE filterinit  ***
    !!
    !! ** Purpose :   initialise weight according to filter type
    !!
    !!----------------------------------------------------------------------
    INTEGER(KIND=4), INTENT(in) :: kfilter  ! filter number
    REAL(KIND=4),    INTENT(in) :: pfn      ! filter cutoff frequency/wavelength
    INTEGER(KIND=4), INTENT(in) :: kband    ! filter bandwidth
    !!----------------------------------------------------------------------
    SELECT CASE ( kfilter)
    CASE ( jp_lanc )
       CALL initlanc (pfn, kband)
    CASE ( jp_hann )
       CALL inithann (pfn, kband)
    CASE ( jp_shap )
       CALL initshap (pfn, kband)
    CASE ( jp_boxc )
       CALL initbox  (pfn, kband)
    END SELECT

  END SUBROUTINE filterinit


  SUBROUTINE filter (kfilter, px, kpx, py)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE filter  ***
    !!
    !! ** Purpose :  Call the proper filter routine according to filter type 
    !!
    !!----------------------------------------------------------------------
    INTEGER(KIND=4),                 INTENT(in) :: kfilter ! filter number
    REAL(KIND=4), DIMENSION(:,:),    INTENT(in) :: px      ! input data
    INTEGER(KIND=4), DIMENSION(:,:), INTENT(in) :: kpx     ! validity flag
    REAL(KIND=4), DIMENSION(:,:),   INTENT(out) :: py      ! output data
    !!----------------------------------------------------------------------
    SELECT CASE ( kfilter)
    CASE ( jp_lanc )
       CALL lislanczos2d (px, kpx, py, npiglo, npjglo, fn, nband)
    CASE ( jp_hann )
       CALL lishan2d     (px, kpx, py, ncut, npiglo, npjglo)
    CASE ( jp_shap )
       CALL lisshapiro1d (px, kpx, py, ncut, npiglo, npjglo)
    CASE ( jp_boxc )
       CALL lisbox       (px, kpx, py, npiglo, npjglo, fn, nband, ranis)
    END SELECT

  END SUBROUTINE filter


  SUBROUTINE initlanc(pfn, knj)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE initlanc  ***
    !!
    !! ** Purpose : initialize lanczos weights
    !!
    !!----------------------------------------------------------------------
    REAL(KIND=4),    INTENT(in) :: pfn  ! cutoff freq/wavelength
    INTEGER(KIND=4), INTENT(in) :: knj  ! bandwidth

    INTEGER(KIND=4)             :: ji   ! dummy loop index
    REAL(KIND=8)                :: dl_pi, dl_ey, dl_coef
    !!----------------------------------------------------------------------
    dl_pi   = ACOS(-1.d0)
    dl_coef = 2*dl_pi*pfn

    de(0) = 2.d0*pfn
    DO  ji=1,knj
       de(ji) = SIN(dl_coef*ji)/(dl_pi*ji)
    END DO
    !
    dec(0) = 2.d0*pfn
    DO ji=1,knj
       dl_ey   = dl_pi*ji/knj
       dec(ji) = de(ji)*SIN(dl_ey)/dl_ey
    END DO

  END SUBROUTINE initlanc


  SUBROUTINE inithann(pfn, knj)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE inithann  ***
    !!
    !! ** Purpose : Initialize hanning weight 
    !!
    !!----------------------------------------------------------------------
    REAL(KIND=4),    INTENT(in) :: pfn  ! cutoff freq/wavelength
    INTEGER(KIND=4), INTENT(in) :: knj  ! bandwidth

    REAL(KIND=8)                :: dl_sum
    !!----------------------------------------------------------------------
    dec2d(:,:) = 0.d0 
    ! central point
    dec2d(1,1) = 4.d0
    ! along one direction
    dec2d(1,0) = 1.d0 ;  dec2d(1,2) = 1.d0
    ! and the other 
    dec2d(0,1) = 1.d0 ;  dec2d(2,1) = 1.d0

    ! normalize
    dl_sum     = SUM(dec2d)
    dec2d(:,:) = dec2d(:,:) / dl_sum

  END SUBROUTINE inithann


  SUBROUTINE initshap(pfn, knj)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE initshap  ***
    !!
    !! ** Purpose :  Dummy routine to respect program structure 
    !!
    !!----------------------------------------------------------------------
    REAL(KIND=4),    INTENT(in) :: pfn  ! cutoff freq/wavelength
    INTEGER(KIND=4), INTENT(in) :: knj  ! bandwidth
    !!----------------------------------------------------------------------
    !   nothing to do 

  END SUBROUTINE initshap


  SUBROUTINE initbox(pfn, knj)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE initbox  ***
    !!
    !! ** Purpose :  Init weights for box car 
    !!
    !!----------------------------------------------------------------------
    REAL(KIND=4),    INTENT(in) :: pfn  ! cutoff freq/wavelength
    INTEGER(KIND=4), INTENT(in) :: knj  ! bandwidth
    !!----------------------------------------------------------------------
    dec(:) = 1.d0

  END SUBROUTINE initbox


  SUBROUTINE lislanczos2d(px, kiw, py, kpi, kpj, pfn, knj)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE lislanczos2d  ***
    !!
    !! ** Purpose : Perform lanczos filter
    !!
    !! ** Method  :   px      = input data
    !!                kiw     = validity of input data
    !!                py      = output filter
    !!                kpi,kpj = number of input/output data
    !!                pfn     = cutoff frequency
    !!                knj     = bandwith of the filter
    !!
    !! References : E. Blayo (1992) from CLS source and huge optimization 
    !!----------------------------------------------------------------------
    REAL(KIND=4),    DIMENSION(:,:), INTENT(in ) :: px               ! input array
    INTEGER(KIND=4), DIMENSION(:,:), INTENT(in ) :: kiw              ! flag input array
    REAL(KIND=4),    DIMENSION(:,:), INTENT(out) :: py               ! output array
    INTEGER(KIND=4),                 INTENT(in ) :: kpi, kpj         ! size of input/output
    REAL(KIND=4),                    INTENT(in ) :: pfn              ! cutoff frequency/wavelength
    INTEGER(KIND=4),                 INTENT(in ) :: knj              ! filter bandwidth

    INTEGER(KIND=4)                              :: ji, jj, jmx, jkx !  dummy loop index
    INTEGER(KIND=4)                              :: ik1x, ik2x, ikkx
    INTEGER(KIND=4)                              :: ifrst=0
    INTEGER(KIND=4)                              :: inxmin, inxmaxi
    INTEGER(KIND=4)                              :: inymin, inymaxi
    REAL(KIND=8), DIMENSION(kpi,kpj)             :: dl_tmpx, dl_tmpy
    REAL(KIND=8)                                 :: dl_yy, dl_den
    !!----------------------------------------------------------------------
    inxmin   =  knj
    inxmaxi  =  kpi-knj+1
    inymin   =  knj
    inymaxi  =  kpj-knj+1

    PRINT *,' filtering parameters'
    PRINT *,'    nx    = ', kpi
    PRINT *,'    nband = ', knj
    PRINT *,'    fn    = ', pfn

    DO jj=1,kpj
       DO  jmx=1,kpi
          ik1x = -knj
          ik2x =  knj
          !
          IF (jmx <= inxmin ) ik1x = 1-jmx
          IF (jmx >= inxmaxi) ik2x = kpi-jmx
          !
          dl_yy  = 0.d0
          dl_den = 0.d0
          !
          DO jkx=ik1x,ik2x
             ikkx=ABS(jkx)
             IF (kiw(jkx+jmx,jj)  ==  1) THEN
                dl_den = dl_den + dec(ikkx)
                dl_yy  = dl_yy  + dec(ikkx)*px(jkx+jmx,jj)
             END IF
          END DO
          !
          dl_tmpx(jmx,jj)=dl_yy/dl_den
       END DO
    END DO

    DO ji=1,kpi
       DO  jmx=1,kpj
          ik1x = -knj
          ik2x =  knj
          !
          IF (jmx <= inymin ) ik1x = 1-jmx
          IF (jmx >= inymaxi) ik2x = kpj-jmx
          !
          dl_yy  = 0.d0
          dl_den = 0.d0
          !
          DO jkx=ik1x,ik2x
             ikkx=ABS(jkx)
             IF (kiw(ji,jkx+jmx)  ==  1) THEN
                dl_den = dl_den + dec(ikkx)
                dl_yy  = dl_yy  + dec(ikkx)*dl_tmpx(ji,jkx+jmx)
             END IF
          END DO
          py(ji,jmx)=0.
          IF (dl_den /=  0.) py(ji,jmx) = dl_yy/dl_den
       END DO
    END DO
    !
  END SUBROUTINE lislanczos2d

  SUBROUTINE lishan2d(px, kiw, py, korder, kpi, kpj)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE lishan2d  ***
    !!
    !! ** Purpose : compute hanning filter at order korder
    !!
    !!----------------------------------------------------------------------
    REAL(KIND=4),    DIMENSION(:,:), INTENT(in ) :: px      ! input data
    INTEGER(KIND=4), DIMENSION(:,:), INTENT(in ) :: kiw     ! validity flags
    REAL(KIND=4),    DIMENSION(:,:), INTENT(out) :: py      ! output data
    INTEGER(KIND=4),                 INTENT(in ) :: korder  ! order of the filter
    INTEGER(KIND=4),                 INTENT(in ) :: kpi, kpj ! size of the data

    INTEGER(KIND=4)                              :: jj, ji, jorder  ! loop indexes
    INTEGER(KIND=4)                              :: iiplus1, iiminus1
    INTEGER(KIND=4)                              :: ijplus1, ijminus1
    REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE    :: ztmp
    !!----------------------------------------------------------------------
    ALLOCATE( ztmp(kpi,kpj) )

    py(:,:)   = 0.
    ztmp(:,:) = px(:,:)

    DO jorder = 1, korder
       DO jj   = 2, kpj-1
          DO ji = 2, kpi-1
             !treatment of the domain frontiers
             iiplus1 = MIN(ji+1,kpi) ; iiminus1 = MAX(ji-1,1) 
             ijplus1 = MIN(jj+1,kpj) ; ijminus1 = MAX(jj-1,1) 

             ! we don't compute in land
             IF ( kiw(ji,jj) == 1 ) THEN
                py(ji,jj) = SUM( dec2d(:,:) * ztmp(iiminus1:iiplus1,ijminus1:ijplus1) )
             ENDIF
          ENDDO
       ENDDO
       ! update the ztmp array
       ztmp(:,:) = py(:,:)
    ENDDO

  END SUBROUTINE lishan2d

  SUBROUTINE lisshapiro1d(px, kiw, py, korder, kpi, kpj)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE lisshapiro1d  ***
    !!
    !! ** Purpose :  compute shapiro filter 
    !!
    !! References :  adapted from Mercator code
    !!----------------------------------------------------------------------
    REAL(KIND=4),    DIMENSION(:,:), INTENT(in ) :: px      ! input data
    INTEGER(KIND=4), DIMENSION(:,:), INTENT(in ) :: kiw     ! validity flags
    REAL(KIND=4),    DIMENSION(:,:), INTENT(out) :: py      ! output data
    INTEGER(KIND=4),                 INTENT(in ) :: korder  ! order of the filter
    INTEGER(KIND=4),                 INTENT(in ) :: kpi, kpj ! size of the data

    INTEGER(KIND=4)                              :: jj, ji, jorder  ! loop indexes
    INTEGER(KIND=4)                              :: imin, imax, ihalo=0
    REAL(KIND=4), PARAMETER                      :: rp_aniso_diff_XY = 2.25 !  anisotrope case
    REAL(KIND=4)                                 :: zalphax, zalphay, znum
    REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE    :: ztmp , zpx , zpy, zkiw
    LOGICAL                                      :: ll_cycl = .TRUE.
    !!----------------------------------------------------------------------

    IF(ll_cycl) ihalo=1
    ! we allocate with an ihalo
    ALLOCATE( ztmp(0:kpi+ihalo,kpj) , zkiw(0:kpi+ihalo,kpj) )
    ALLOCATE( zpx (0:kpi+ihalo,kpj) , zpy (0:kpi+ihalo,kpj) )

    IF(ll_cycl) THEN
       zpx(1:kpi,:) = px(:  ,:) ;  zkiw(1:kpi,:) = kiw(:  ,:)
       zpx(0    ,:) = px(kpi,:) ;  zkiw(0    ,:) = kiw(kpi,:)
       zpx(kpi+1,:) = px(1  ,:) ;  zkiw(kpi+1,:) = kiw(1  ,:)
    ELSE
       zpx(:    ,:) = px(:  ,:)
    ENDIF

    zpy (:,:) = zpx(:,:)  ! init?
    ztmp(:,:) = zpx(:,:)  ! init

    zalphax=1./2.
    zalphay=1./2.

    !  Dx/Dy=rp_aniso_diff_XY  , D_ = vitesse de diffusion
    !  140 passes du fitre, Lx/Ly=1.5, le rp_aniso_diff_XY correspondant est:

    IF ( rp_aniso_diff_XY >=  1. ) zalphay=zalphay/rp_aniso_diff_XY
    IF ( rp_aniso_diff_XY <   1. ) zalphax=zalphax*rp_aniso_diff_XY

    DO jorder=1,korder
       imin = 2     - ihalo
       imax = kpi-1 + ihalo
       DO ji = imin,imax
          DO jj = 2,kpj-1
             ! We crop on the coast
             znum =    ztmp(ji,jj)                                                  &
                  &    + 0.25*zalphax*(ztmp(ji-1,jj  )-ztmp(ji,jj))*zkiw(ji-1,jj  ) &
                  &    + 0.25*zalphax*(ztmp(ji+1,jj  )-ztmp(ji,jj))*zkiw(ji+1,jj  ) &
                  &    + 0.25*zalphay*(ztmp(ji  ,jj-1)-ztmp(ji,jj))*zkiw(ji  ,jj-1) &
                  &    + 0.25*zalphay*(ztmp(ji  ,jj+1)-ztmp(ji,jj))*zkiw(ji  ,jj+1)
             zpy(ji,jj) = znum*zkiw(ji,jj)+zpx(ji,jj)*(1.-zkiw(ji,jj))
          ENDDO  ! end loop ji
       ENDDO  ! end loop jj

       IF ( ll_cycl ) THEN
          zpy(0    ,:) = zpy(kpi,:) 
          zpy(kpi+1,:) = zpy(1  ,:) 
       ENDIF

       ! update the tmp array
       ztmp(:,:) = zpy(:,:)

    ENDDO

    ! return this array
    IF( ll_cycl ) THEN
       py(:,:) = zpy(1:kpi,:)
    ELSE
       py(:,:) = zpy(:    ,:)
    ENDIF

  END SUBROUTINE lisshapiro1d


  SUBROUTINE lisbox(px, kiw, py, kpi, kpj, pfn, knj,anis)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE lisbox  ***
    !!
    !! ** Purpose :  Perform box car filtering 
    !!
    !!----------------------------------------------------------------------
    REAL(KIND=4),    DIMENSION(:,:), INTENT(in ) :: px               ! input array
    INTEGER(KIND=4), DIMENSION(:,:), INTENT(in ) :: kiw              ! flag input array
    REAL(KIND=4),    DIMENSION(:,:), INTENT(out) :: py               ! output array
    INTEGER(KIND=4),                 INTENT(in ) :: kpi, kpj         ! size of input/output
    REAL(KIND=4),                    INTENT(in ) :: pfn              ! cutoff frequency/wavelength
    INTEGER(KIND=4),                 INTENT(in ) :: knj              ! filter bandwidth
    REAL(KIND=4),                    INTENT(in ) :: anis             ! anisotrop

    INTEGER(KIND=4)                              :: ji, jj
    INTEGER(KIND=4)                              :: ik1x, ik2x, ik1y, ik2y
    REAL(KIND=8)                                 :: dl_den
    LOGICAL, DIMENSION(kpi,kpj)                  :: ll_mask
    !!----------------------------------------------------------------------
    ll_mask=.TRUE.
    WHERE (kiw == 0 ) ll_mask=.FALSE.
    DO ji=1,kpi
       ik1x = ji-NINT( anis * knj)  ; ik2x = ji+NINT( anis * knj)
       ik1x = MAX(1,ik1x)           ; ik2x = MIN(kpi,ik2x)
       DO jj=1,kpj
          ik1y = jj-knj       ; ik2y = jj+knj
          ik1y = MAX(1,ik1y)  ; ik2y = MIN(kpj,ik2y)
          dl_den = SUM(kiw(ik1x:ik2x,ik1y:ik2y) )
          IF ( dl_den /= 0 ) THEN
             py(ji,jj) = SUM(px(ik1x:ik2x,ik1y:ik2y), mask=ll_mask(ik1x:ik2x,ik1y:ik2y) )/dl_den
          ELSE
             py(ji,jj) = rspval
          ENDIF
       END DO
    END DO

  END SUBROUTINE lisbox

END PROGRAM cdfsmooth

PROGRAM cdfrhoproj
  !!======================================================================
  !!                     ***  PROGRAM  cdfrhoproj  ***
  !!=====================================================================
  !!  ** Purpose : This program is used to project any scalar on the A grid
  !!               onto given isopycnic surfaces.
  !!
  !!  ** Method  : Linear interpolation is used on the vertical to define
  !!               the depth of the given isopycn and linear interpolation
  !!               is also performed on the scalar to determine its value at
  !!               this depth.
  !!
  !! History :      :  1996    : J.M. Molines for SPEM in Dynamo
  !!                :  1999    : J.O. Beismann for OPA
  !!                :  2000    : J.M. Molines for normalization
  !!           2.1  : 11/2005  : J.M. Molines : netcdf 
  !!           3.0  : 05/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                               :: ji,jj,jk,jsig,jfich, jvar
  INTEGER(KIND=4)                               :: npiglo, npjglo
  INTEGER(KIND=4)                               :: npk, npsig, npt
  INTEGER(KIND=4)                               :: nvars, nvout=2
  INTEGER(KIND=4)                               :: narg, iargc
  INTEGER(KIND=4)                               :: ijarg, ireq
  INTEGER(KIND=4)                               :: ik0, ijk
  INTEGER(KIND=4)                               :: istartarg = 1
  INTEGER(KIND=4)                               :: nfilin
  INTEGER(KIND=4)                               :: numlev=10
  INTEGER(KIND=4)                               :: ncout, ierr
  INTEGER(KIND=4), DIMENSION(2)                 :: ipk, id_varout ! for output variables
  !
  REAL(KIND=4), DIMENSION(:,:,:),   ALLOCATABLE :: zsig, alpha
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: v2dint, zint, v2d
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: zi, tim, h1d
  REAL(KIND=4)                                  :: P1, P2
  REAL(KIND=4)                                  :: zalpha
  REAL(KIND=4)                                  :: zspvalo=999999.
  REAL(KIND=4)                                  :: zspvali=0.

  CHARACTER(LEN=256)                            :: cf_rholev='rho_lev'
  CHARACTER(LEN=256)                            :: cf_dta
  CHARACTER(LEN=256)                            :: cf_rhofil
  CHARACTER(LEN=256)                            :: cf_out
  CHARACTER(LEN=256)                            :: cv_in
  CHARACTER(LEN=256)                            :: cv_sig
  CHARACTER(LEN=256)                            :: ctype='T'
  CHARACTER(LEN=256)                            :: cldum
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_names     ! temporary arry for variable name in file
 
  TYPE(variable), DIMENSION(2)                  :: stypvar      ! structure for attributes
  TYPE(variable), DIMENSION(:),     ALLOCATABLE :: stypzvar      ! structure for attributes
  !
  LOGICAL                                       :: lsingle =.FALSE.
  LOGICAL                                       :: lchk    =.FALSE.
  LOGICAL                                       :: lisodep =.FALSE.
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()
  cv_sig = cn_vosigma0

  narg=iargc()
  IF ( narg < 3 ) THEN
     PRINT *,' usage : cdfrhoproj IN-var RHO-file List_of_IN-files [VAR-type] ... '
     PRINT *,'                ... [-s0 sig0 ] [-sig sigma_name] [-isodep ]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Project IN-var on isopycnal surfaces defined either by sig0 given' 
     PRINT *,'       as argument or on all sigma surfaces defined in ',TRIM(cf_rholev),' ascii file.'
     PRINT *,'       IN-var will be interpolated on the T point of the C-grid, previous'
     PRINT *,'       to projection on isopycnal.'
     PRINT *,'       This cdftool is one of the few using 3D arrays. Further development is '
     PRINT *,'       required to work with vertical slabs instead.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       IN-var   : name of the input variable to be projected' 
     PRINT *,'       RHO-file : netcdf file with potential density field. If not a sigma0'
     PRINT *,'                  file, use -sig option to indicate the name of the density'
     PRINT *,'                  variable.'
     PRINT *,'       List_of_IN-file  : netcdf files with IN-var '
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-s0 sigma ] : define a single sigma surface on the command line' 
     PRINT *,'                    instead of reading rho_lev ascii file.'
     PRINT *,'       [VAR-type] : position of IN-var on the C-grid ( either T U V F W )'
     PRINT *,'                    default is ''T''.'
     PRINT *,'       [-sig sigma_name] : name of the density variable in RHO_file.'
     PRINT *,'                    default is ', TRIM(cv_sig)
     PRINT *,'       [-isodep ] : only compute the isopycnal depth. then stop. In this case'
     PRINT *,'                    you must still specify a IN-var variable (in fact a dummy'
     PRINT *,'                     name).'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       no metrics, information is taken from depth variable in input files.'
     PRINT *,'       ', TRIM(cf_rholev),' if not using -s0 option.'
     PRINT *,'       ', TRIM(cf_rholev),' is an ascii file, first line giving the number of isopycnal'
     PRINT *,'                           following lines with isopycnal value, 1 per line.'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       There are as many output files as input files.'
     PRINT *,'       netcdf file : IN-file.interp'
     PRINT *,'         variables : VAR-in (unit is the same as input var)'
     PRINT *,'                     ', TRIM(cn_vodepiso),' (m) : depth of isopycnal.'
     PRINT *,'      '
     PRINT *,'       If option -isodep is used, only isopycnal depth is output :'
     PRINT *,'       netcdf file : isopycdep.nc'
     PRINT *,'         variables : ',TRIM(cn_vodepiso),' (m) '
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'       replace cdfisopycdep when using -isodep option.'
     PRINT *,'       '
     STOP
  ENDIF

  ijarg = 1 ; ireq=0 ; nfilin=0

  DO WHILE ( ijarg <= narg )
    CALL getarg( ijarg, cldum) ; ijarg=ijarg+1
    SELECT CASE ( cldum )
    CASE ('-s0') 
       npsig = 1 ; lsingle=.TRUE. ; ALLOCATE (zi(npsig) )
       CALL getarg( ijarg, cldum) ; ijarg=ijarg+1 ; READ(cldum,*) zi(1)
    CASE ( 'T','t','U','u','V','v','W','w','F','f' )
       ctype=cldum
    CASE ('-sig') 
       CALL getarg( ijarg, cv_sig) ; ijarg=ijarg+1 
    CASE ('-isodep')  ; lisodep = .TRUE. ; nvout=1 ; cf_out='isopycdep.nc'
    CASE DEFAULT 
       ireq=ireq+1
       SELECT CASE (ireq )
       CASE ( 1 ) ; cv_in     = cldum
       CASE ( 2 ) ; cf_rhofil = cldum
       CASE DEFAULT 
         ! count the input files
         nfilin=nfilin+1
         IF ( nfilin == 1 ) istartarg=ijarg-1
       END SELECT
    END SELECT
  END DO

  lchk = chkfile(cf_rhofil)
  IF ( .NOT. lsingle ) lchk = lchk .OR. chkfile(cf_rholev)
  IF ( lchk ) STOP ! missing file

  IF ( .NOT.  lsingle ) THEN
     OPEN(numlev,FILE=cf_rholev)
     READ(numlev,*) npsig
     ALLOCATE ( zi(npsig) )
     DO jsig=1,npsig
        READ(numlev,*) zi(jsig)
        PRINT *,zi(jsig)
     END DO
     CLOSE(numlev)
  ENDIF

  ! Read Rho file
  npiglo = getdim(cf_rhofil,cn_x)
  npjglo = getdim(cf_rhofil,cn_y)
  npk    = getdim(cf_rhofil,cn_z)
  npt    = getdim(cf_rhofil,cn_t)

  CALL getarg(istartarg, cf_dta)
  nvars=getnvar(cf_dta)
  ALLOCATE(cv_names(nvars), stypzvar(nvars))

  cv_names(:)=getvarname(cf_dta, nvars, stypzvar)

  ALLOCATE( zsig(npiglo,npjglo,npk), alpha(npiglo, npjglo, npsig)            )
  ALLOCATE( v2dint(npiglo, npjglo), v2d(npiglo,npjglo), zint(npiglo,npjglo)  )
  ALLOCATE( tim(npt), h1d(npk)                                               )

  tim(:)=getvar1d(cf_rhofil, cn_vtimec,  npt)
  h1d(:)=getvar1d(cf_rhofil, cn_vdeptht, npk)
   
  DO jk=1,npk
     zsig(:,:,jk) = getvar(cf_rhofil, cv_sig, jk, npiglo, npjglo)
  END DO

  !! ** Compute interpolation coefficients as well as the level used
  !!    to interpolate between
  DO ji=1,npiglo
     DO jj = 1, npjglo
        ijk = 1
        DO jsig=1,npsig
        !  Assume that rho (z) is increasing downward (no inversion)
        !     Caution with sigma0 at great depth !
           DO WHILE (zi(jsig) >=  zsig(ji,jj,ijk) .AND. ijk <= npk &
                  &   .AND. zsig(ji,jj,ijk) /=  zspvali )
              ijk=ijk+1
           END DO
           ijk=ijk-1
           ik0=ijk
           IF (ijk == 0) THEN
              ijk=1
              alpha(ji,jj,jsig) = 0.
           ELSE IF (zsig(ji,jj,ijk+1) == zspvali ) THEN
              ik0=0
              alpha(ji,jj,jsig) = 0.
           ELSE 
           ! ... alpha is always in [0,1]. Adding ik0 ( >=1 ) for saving space for ik0
              alpha(ji,jj,jsig)= &
                  &  (zi(jsig)-zsig(ji,jj,ijk))/(zsig(ji,jj,ijk+1)-zsig(ji,jj,ijk)) + ik0
           ENDIF
        END DO
     END DO
  END DO

  IF ( lisodep ) THEN
     ipk(1)                       = npsig
     stypvar(1)%cname             = cn_vodepiso
     stypvar(1)%cunits            = 'm'
     stypvar(1)%rmissing_value    = 999999.
     stypvar(1)%valid_min         = 0.
     stypvar(1)%valid_max         = 7000.
     stypvar(1)%clong_name        = 'Depth_of_Isopycnals'
     stypvar(1)%cshort_name       = cn_vodepiso
     stypvar(1)%conline_operation = 'N/A'
     stypvar(1)%caxis             = 'TRYX'

     ncout = create      (cf_out, cf_rhofil, npiglo, npjglo, npsig          )
     ierr  = createvar   (ncout,  stypvar,   nvout,  ipk,    id_varout      )
     ierr  = putheadervar(ncout , cf_rhofil, npiglo, npjglo, npsig, pdep=zi )

     DO jsig=1,npsig
        DO ji=1,npiglo
           DO jj=1,npjglo
             ! ik0 is retrieved from alpha, taking the integer part.
             ! The remnant is alpha.
             ik0 = INT(alpha(ji,jj,jsig))
             zalpha =  alpha(ji,jj,jsig) - ik0
             IF (ik0 /= 0) THEN
              P1 = zsig(ji,jj,ik0  )
              P2 = zsig(ji,jj,ik0+1)
                IF (P1 /= zspvali .AND. P2 /= zspvali) THEN
                    zint (ji,jj) = zalpha *h1d(ik0+1) &
                     &         +(1-zalpha)*h1d(ik0  )
                ELSE
                   zint  (ji,jj)=zspvalo
               ENDIF
             ELSE
               zint  (ji,jj)=zspvalo
             ENDIF
           END DO
        END DO
        ierr = putvar(ncout, id_varout(1), zint , jsig, npiglo, npjglo)
     END DO
     ierr = closeout(ncout    )
     STOP ' -isodep option in use: only compute depth of isopycnal surfaces.'
  ENDIF

  !! ** Loop on the scalar files to project on choosen isopycnics surfaces
  DO jfich= 1, nfilin
     ijarg = istartarg + jfich - 1

     CALL getarg(ijarg, cf_dta)
     PRINT *,'working with ', TRIM(cf_dta)

     npt    = getdim(cf_dta, cn_t)
     IF (npt /= 1 ) THEN
        PRINT *,' This program has to be modified for multiple'
        PRINT *,' time frames.'
        STOP ' Error : npt # 1'
     ENDIF
     tim(:)=getvar1d(cf_dta, cn_vtimec, 1)
 
     DO jk=1,npk
        v2d(:,:) = getvar(cf_dta,cv_in,jk,npiglo,npjglo)
        SELECT CASE ( ctype )
        CASE ('T', 't' )
           zsig(:,:,jk) = v2d(:,:)
        CASE ('U','u' )
           DO ji=2,npiglo
              DO jj=1, npjglo
                 zsig(ji,jj,jk)=0.5*( v2d(ji,jj) + v2d(ji-1,jj) )  ! put variable on T point
              END DO
           END DO
        CASE ('V','v' )
           DO jj=2,npjglo
              DO ji=1, npiglo
                 zsig(ji,jj,jk)=0.5*( v2d(ji,jj) + v2d(ji,jj-1) )  ! put variable on T point
              END DO
           END DO
         CASE('W','w' )
           zint(:,:) = getvar(cf_dta, cv_in, jk+1, npiglo, npjglo)
           DO jj=1,npjglo
              DO ji=1, npiglo
                 zsig(ji,jj,jk)=0.5*( v2d(ji,jj) + zint(ji,jj) )  ! put variable on T point
              END DO
           END DO
         CASE('F','f' )
           DO jj=2,npjglo
              DO ji=2, npiglo
                 zsig(ji,jj,jk)=0.25*( v2d(ji,jj) + v2d(ji,jj-1) + v2d(ji-1,jj) + v2d(ji-1,jj-1 )) ! put variable on T point
              END DO
           END DO
         END SELECT
     END DO

     ! ... open output file and write header
     ipk(:)=npsig
     DO jvar=1,nvars
       IF ( cv_in == stypzvar(jvar)%cname ) THEN 
          stypvar(2)=stypzvar(jvar)
          EXIT
       ENDIF
     END DO
     stypvar(2)%clong_name        = TRIM(stypvar(2)%clong_name)//' on iso sigma'
     stypvar(2)%rmissing_value    = zspvalo
     stypvar(2)%caxis             = 'TRYX'

     stypvar(1)%cname             = cn_vodepiso
     stypvar(1)%cunits            = 'm'
     stypvar(1)%rmissing_value    = 999999.
     stypvar(1)%valid_min         = 0.
     stypvar(1)%valid_max         = 7000.
     stypvar(1)%clong_name        = 'Depth_of_Isopycnals'
     stypvar(1)%cshort_name       = cn_vodepiso
     stypvar(1)%conline_operation = 'N/A'
     stypvar(1)%caxis             = 'TRYX'

     cf_out=TRIM(cf_dta)//'.interp'
 
     ncout = create      (cf_out, cf_rhofil, npiglo, npjglo, npsig          )
     ierr  = createvar   (ncout,  stypvar,   nvout,  ipk,    id_varout      )
     ierr  = putheadervar(ncout , cf_rhofil, npiglo, npjglo, npsig, pdep=zi )
 
     DO jsig=1,npsig
        DO ji=1,npiglo
           DO jj=1,npjglo
             ! ik0 is retrieved from alpha, taking the integer part.
             ! The remnant is alpha. 
             ik0    = INT(alpha(ji,jj,jsig))
             zalpha =     alpha(ji,jj,jsig) - ik0
             IF (ik0 /= 0) THEN
              P1 = zsig(ji,jj,ik0  )
              P2 = zsig(ji,jj,ik0+1)
                IF (P1 /= zspvali .AND. P2 /= zspvali) THEN
                   v2dint(ji,jj) = zalpha *P2  &
                     &         +(1-zalpha)*P1
                    zint (ji,jj) = zalpha *h1d(ik0+1) &
                     &         +(1-zalpha)*h1d(ik0  )
                ELSE 
                   v2dint(ji,jj)=zspvalo
                   zint  (ji,jj)=zspvalo
               ENDIF
             ELSE 
               v2dint(ji,jj)=zspvalo
               zint  (ji,jj)=zspvalo
             ENDIF
           END DO
        END DO
        ierr = putvar(ncout, id_varout(1), zint  , jsig, npiglo, npjglo)
        ierr = putvar(ncout, id_varout(2), v2dint, jsig, npiglo, npjglo)
     END DO
     ierr = putvar1d(ncout, tim, 1, 'T')
     ierr = closeout(ncout             )
  END DO  ! loop on scalar files
        PRINT *,'Projection on isopycns completed successfully'
END  PROGRAM cdfrhoproj

PROGRAM cdfstrain
  !!======================================================================
  !!                     ***  PROGRAM  cdfstrain  ***
  !!=====================================================================
  !!  ** Purpose :  Compute the 2 component (symetric and antisymetric)
  !!                of the strain using the velocty field
  !!
  !!  ** Method  :  Just apply formula
  !!
  !! History :  4.0  : 04/2020  : F. Le Guillou, J.M. Molines from cdfokbw
  !!----------------------------------------------------------------------
  !! * Modules used
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017
  !! $Id$
  !! Copyright (c) 2012, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class energy_diagnostics
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: ji, jj, jk, jt                   ! dummy loop index
  INTEGER(KIND=4)                           :: ik1, ik2, iko                    ! limits of jk loop, k-index for output
  INTEGER(KIND=4)                           :: ilev=-1                          ! level to be processed
  INTEGER(KIND=4)                           :: npiglo, npjglo                   ! size of the domain
  INTEGER(KIND=4)                           :: npk, npt                         ! size of the domain
  INTEGER(KIND=4)                           :: narg, iargc, ijarg               ! browse command line
  INTEGER(KIND=4)                           :: ncout, ierr                      ! browse command line
  INTEGER(KIND=4), DIMENSION(2)             :: ipk, id_varout                   ! output variable properties

  REAL(KIND=4)                              :: zcoef                            ! working real
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e2v, e1u, e1f, e2f, e1t, e2t     ! horizontal metrics
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: un, vn                           ! velocity field
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: fmask, tmask                     ! mask
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: strsym, strnsy                   ! symetric and non symetric strain
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zstrsym                          ! Symetrical strain for output
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zstrnsy                          ! Anti-Symetrical strain for output
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: gdepu                            ! depth for output

  REAL(KIND=8), DIMENSION(:),   ALLOCATABLE :: dtim                             ! time counter

  CHARACTER(LEN=256)                        :: cf_ufil, cf_vfil                 ! file names
  CHARACTER(LEN=256)                        :: cf_out = 'strain.nc'             ! output file name
  CHARACTER(LEN=256)                        :: cv_u, cv_v                       ! variable names
  CHARACTER(LEN=256)                        :: cldum                            ! dummy string

  TYPE (variable), DIMENSION(2)             :: stypvar                          ! structure for attibutes

  LOGICAL                                   :: lchk     = .FALSE.               ! flag for missing files
  LOGICAL                                   :: lperio   = .FALSE.               ! flag for E-W periodicity
  LOGICAL                                   :: lnc4     = .FALSE.               ! Use nc4 with chunking and deflation
  LOGICAL                                   :: lTpt     = .FALSE.               ! Output on T points
  LOGICAL                                   :: lFpt     = .FALSE.               ! Output on F points
  !!----------------------------------------------------------------------------
  CALL ReadCdfNames() 

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfstrain -u U-file U-var -v V-file V-var [-l lev] ...'
     PRINT *,'                    ... [-T] [-F] [-o OUT-file] [-nc4]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the strain of a vector field at all level or at'  
     PRINT *,'       specified level (-l option).'
     PRINT *,'       The symetric (Ss)  and antisymetric (Sn) component of the strain are '
     PRINT *,'       computed, on the native C-grid (respectively at F point and T points).'
     PRINT *,'       Options are provided for saving the 2 component of the strain at the'
     PRINT *,'       same grid point. Default behaviour is to save on native grid.'
     PRINT *,'       '
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -u U-file U-var: zonal component of the vector field:'
     PRINT *,'                 filename and variable name'
     PRINT *,'       -v V-file V-var: meridional component of the vector field:'
     PRINT *,'                 filename and variable name'
     PRINT *,'     '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-l lev]: level to be processed. Process all level by default.'
     PRINT *,'       [ -T   ]: output both components on T points.'
     PRINT *,'       [ -F   ]: output both components on F points.'
     PRINT *,'       [-o OUT-file] : specify output file instead of ',TRIM(cf_out)
     PRINT *,'       [-nc4 ] : Use netcdf4 output with chunking and deflation level 1.'
     PRINT *,'            This option is effective only if cdftools are compiled with'
     PRINT *,'            a netcdf library supporting chunking and deflation.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        ', TRIM(cn_fhgr),' and ', TRIM(cn_fmsk)
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out),' or the name given in the -o option.'
     PRINT *,'         variables :  strsym_<PT>, strnsy_<PT> (s^-2), where <PT> can be'
     PRINT *,'                      either T or F according to the C-grid position of'
     PRINT *,'                      the variables.'
     STOP 
  ENDIF

  ijarg=1
  DO WHILE ( ijarg <= narg )
     CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-u'   ) ; CALL getarg(ijarg, cf_ufil ) ; ijarg=ijarg+1
        ;              CALL getarg(ijarg, cv_u    ) ; ijarg=ijarg+1
     CASE ( '-v'   ) ; CALL getarg(ijarg, cf_vfil ) ; ijarg=ijarg+1
        ;              CALL getarg(ijarg, cv_v    ) ; ijarg=ijarg+1
        ! option
     CASE ( '-l'   ) ; CALL getarg(ijarg, cldum   ) ; ijarg=ijarg+1 ; READ(cldum,* ) ilev
     CASE ( '-o'   ) ; CALL getarg(ijarg, cf_out  ) ; ijarg=ijarg+1
     CASE ( '-nc4' ) ; lnc4 = .TRUE.
     CASE ( '-T'   ) ; lTpt = .TRUE.
     CASE ( '-F'   ) ; lFpt = .TRUE.
     CASE DEFAULT    ; PRINT *, ' ERROR : ', TRIM(cldum),' : unknown option.'; STOP 99
     END SELECT
  ENDDO

  lchk = chkfile(cn_fhgr ) .OR. lchk
  lchk = chkfile(cn_fmsk ) .OR. lchk
  lchk = chkfile(cf_ufil ) .OR. lchk
  lchk = chkfile(cf_vfil ) .OR. lchk
  IF ( lchk ) STOP 99 ! missing files

  npiglo = getdim(cf_ufil,cn_x)
  npjglo = getdim(cf_ufil,cn_y)
  npk    = getdim(cf_ufil,cn_z)
  npt    = getdim(cf_ufil,cn_t) 

  IF ( npk==0 ) THEN
     PRINT *, 'npk=0, assume 1'
     npk=1
  END IF

  IF ( npt==0 ) THEN
     PRINT *, 'npt=0, assume 1'
     npt=1
  END IF

  PRINT *, 'npiglo = ',npiglo
  PRINT *, 'npjglo = ',npjglo
  PRINT *, 'npk    = ',npk
  PRINT *, 'npt    = ',npt
  PRINT *, 'ilev   = ',ilev

  ! Allocate the memory
  ALLOCATE ( e1u(npiglo,npjglo) , e1f(npiglo,npjglo) )
  ALLOCATE ( e2v(npiglo,npjglo) , e2f(npiglo,npjglo) )
  ALLOCATE ( e1t(npiglo,npjglo) , e2t(npiglo,npjglo) )
  ALLOCATE ( un(npiglo,npjglo)  , vn(npiglo,npjglo)  )
  ALLOCATE ( strsym(npiglo,npjglo) , zstrsym(npiglo,npjglo)  )
  ALLOCATE ( strnsy(npiglo,npjglo) , zstrnsy(npiglo,npjglo)  )
  ALLOCATE ( tmask(npiglo, npjglo) ,fmask(npiglo,npjglo) )
  ALLOCATE ( dtim(npt) , gdepu(npk) )

  e1u =  getvar(cn_fhgr, cn_ve1u, 1, npiglo, npjglo)
  e1f =  getvar(cn_fhgr, cn_ve1f, 1, npiglo, npjglo)
  e1t =  getvar(cn_fhgr, cn_ve1t, 1, npiglo, npjglo)
  e2v =  getvar(cn_fhgr, cn_ve2v, 1, npiglo, npjglo)
  e2f =  getvar(cn_fhgr, cn_ve2f, 1, npiglo, npjglo)
  e2t =  getvar(cn_fhgr, cn_ve2t, 1, npiglo, npjglo)

  ! use un and vn to store f latitude and longitude for CreateOutput
  ! note : when computing on native grid, the 2 component of the strain are not on the same grid
  !  and lon, lat in the file (F point) are just indicative ...
  IF (lTpt ) THEN
     un    = getvar(cn_fhgr, cn_glamt, 1, npiglo, npjglo)
     vn    = getvar(cn_fhgr, cn_gphif, 1, npiglo, npjglo)
     gdepu = getvar1d (cf_ufil, cn_vdepthu, npk )

  ELSE ! lFpt or std output
     un    = getvar(cn_fhgr, cn_glamf, 1, npiglo, npjglo)
     vn    = getvar(cn_fhgr, cn_gphif, 1, npiglo, npjglo)
     gdepu = getvar1d (cf_ufil, cn_vdepthu, npk )
  ENDIF

  ! look for  E-W periodicity
  IF ( un(1,1) == un(npiglo-1,1) ) lperio = .TRUE.

  IF ( ilev < 0 ) THEN  ; ik1 = 1    ; ik2 = npk
  ELSE                  ; ik1 = ilev ; ik2 = ilev ; npk = 1 ; gdepu(1) = gdepu(ilev)
  ENDIF

  iko=0

  CALL CreateOutput

  DO jt=1,npt
     IF (MOD(jt,100)==0 ) PRINT *, jt,'/',npt
     DO jk = ik1,ik2
        iko=iko+1
        un(:,:)    = getvar(cf_ufil, cv_u    , jk, npiglo, npjglo, ktime=jt)
        vn(:,:)    = getvar(cf_vfil, cv_v    , jk, npiglo, npjglo, ktime=jt)
        tmask(:,:) = getvar(cn_fmsk, cn_tmask, jk, npiglo, npjglo          )

        ! compute the mask at level jk
        DO jj = 1, npjglo - 1
           DO ji = 1, npiglo - 1
              fmask(ji,jj)=0.
              fmask(ji,jj)= un(ji,jj)*un(ji,jj+1) * vn(ji,jj)*vn(ji+1,jj)
              IF (fmask(ji,jj) /= 0.) fmask(ji,jj)=1.
           ENDDO
        ENDDO

        strsym(:,:) = 0. ; strnsy(:,:) = 0. ;  zstrsym(:,:) = 0. ; zstrnsy(:,:) = 0.
        DO jj = 1, npjglo -1 
           DO ji = 1, npiglo -1   
              strsym(ji,jj) = (  e2v(ji+1,jj  ) * vn(ji+1,jj  ) - e2v(ji,jj) * vn(ji,jj)    &
                   &           + e1u(ji  ,jj+1) * un(ji  ,jj+1) - e1u(ji,jj) * un(ji,jj)  ) &
                   &           * fmask(ji,jj) / ( e1f(ji,jj) * e2f(ji,jj) )    ! quantity on f grid

              strnsy(ji,jj) = (  e1u(ji+1,jj  ) * un(ji+1,jj  ) - e1u(ji,jj) * un(ji,jj)    &
                   &           - e2v(ji  ,jj+1) * vn(ji  ,jj+1) + e2v(ji,jj) * vn(ji,jj)  ) &
                   &           * tmask(ji,jj) / ( e1t(ji,jj) * e2t(ji,jj) )    ! quantity on T grid
           ENDDO
        ENDDO

        IF ( lTpt) THEN
           ! compute symetrical strain T-point
           DO jj=2, npjglo
              DO ji=2, npiglo
                 zcoef      =  0.25 * tmask(ji,jj)
                 zstrsym(ji,jj)   =  zcoef * ( strsym(ji  ,jj  ) + strsym(ji-1,jj  ) &
                      &                      + strsym(ji-1,jj-1) + strsym(ji  ,jj-1))
                 zstrnsy(ji,jj)  = strnsy(ji,jj)
              ENDDO
           ENDDO

        ELSEIF (lFpt ) THEN
           DO jj = 1, npjglo -1 
              DO ji = 1, npiglo -1   
                 ! compute non-symetrical strain on f-point
                 zcoef      =  0.25 * fmask(ji,jj)
                 zstrnsy(ji,jj)  =  zcoef * ( strnsy(ji  ,jj  ) + strnsy(ji+1,jj   ) &
                      &                     + strnsy(ji+1,jj+1) + strnsy(ji  ,jj+1 ) )
                 zstrsym(ji,jj)  = strsym(ji,jj)
              ENDDO
           ENDDO
        ELSE   ! just do nothing (consider later the use of pointer for perf)
           zstrsym(ji,jj)   = strsym(ji,jj)
           zstrnsy(ji,jj)   = strnsy(ji,jj)
        ENDIF

        IF ( lperio ) THEN
           zstrsym(npiglo,:)  = zstrsym(2, :)
           zstrnsy(npiglo,:)  = zstrnsy(2, :)
        ENDIF
        ! write okubow on file at level k and at time jt
        ierr = putvar(ncout, id_varout(1), zstrsym,  iko,  npiglo, npjglo, ktime=jt)
        ierr = putvar(ncout, id_varout(2), zstrnsy,  iko,  npiglo, npjglo, ktime=jt)
     ENDDO
  END DO
  ierr = closeout(ncout)

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    CHARACTER(LEN=30) :: clv_strsym, cln_strsym
    CHARACTER(LEN=30) :: clv_strnsy, cln_strnsy
    CHARACTER(LEN=30) :: cl_axis

    IF ( lTpt ) THEN
       clv_strsym='strsym_T'
       clv_strnsy='strnsy_T'
       cln_strsym='symetrical strain component on T point'
       cln_strnsy='anti-symetrical strain component on T point'
    ELSE IF ( lFpt ) THEN
       clv_strsym='strsym_F'
       clv_strnsy='strnsy_F'
       cln_strsym='symetrical strain component on F point'
       cln_strnsy='anti-symetrical strain component on F point'
    ELSE
       clv_strsym='strsym_F'
       clv_strnsy='strnsy_T'
       cln_strsym='symetrical strain component on F point'
       cln_strnsy='anti-symetrical strain component on T point'
    ENDIF

    IF (npk > 1 ) THEN
       cl_axis='TZYX'
    ELSE
       cl_axis='TYX'
    ENDIF
    ! define new variables for output
    ipk(1) = npk  !  2D or 3D
    stypvar(1)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(1)%cname             = TRIM(clv_strsym)
    stypvar(1)%cunits            = 's-2'
    stypvar(1)%rmissing_value    = 0.
    stypvar(1)%valid_min         = -1000.
    stypvar(1)%valid_max         =  1000.
    stypvar(1)%clong_name        = TRIM(cln_strsym)
    stypvar(1)%cshort_name       = TRIM(clv_strsym)
    stypvar(1)%conline_operation = 'N/A'
    stypvar(1)%caxis             = TRIM(cl_axis)

    ipk(2) = npk  !  2D or 3D
    stypvar(2)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(2)%cname             = TRIM(clv_strnsy)
    stypvar(2)%cunits            = 's-2'
    stypvar(2)%rmissing_value    = 0.
    stypvar(2)%valid_min         = -1000.
    stypvar(2)%valid_max         =  1000.
    stypvar(2)%clong_name        = TRIM(cln_strnsy)
    stypvar(2)%cshort_name       = TRIM(clv_strnsy)
    stypvar(2)%conline_operation = 'N/A'
    stypvar(2)%caxis             = TRIM(cl_axis)

    ! create output fileset
    ncout = create      (cf_out, cf_ufil, npiglo, npjglo, npk                         , ld_nc4=lnc4)
    ierr  = createvar   (ncout , stypvar, 2,      ipk,    id_varout                   , ld_nc4=lnc4)
    ierr  = putheadervar(ncout,  cf_ufil, npiglo, npjglo, npk, pdep=gdepu,  pnavlon=un, pnavlat=vn )

    dtim = getvar1d(cf_ufil, cn_vtimec, npt      )
    ierr = putvar1d(ncout,   dtim,      npt,  'T')

  END SUBROUTINE CreateOutput

END PROGRAM cdfstrain

PROGRAM cdfpsi
  !!======================================================================
  !!                     ***  PROGRAM  cdfpsi  ***
  !!=====================================================================
  !!  ** Purpose : Compute Barotropic Stream Function
  !!
  !!  ** Method  : Compute the 2D fields dtrpu, dtrpv as the integral on 
  !!               the vertical of u, v on their respective points.
  !!               Then integrate from south to north : ==> dpsiu
  !!               Then integrate from West to East   : ==> dpsiv
  !!                  (should be almost the same (if no error ))
  !!               Default (appropriate for global model): output dpsiu;
  !!               normalizes the values setting psi (jpi,jpj) = 0
  !!               If option "V" is given as last argument, output dpsiv,
  !!               normalizes values setting psi(jpi,1) = 0.
  !!               This is appropriate for North Atlantic
  !!
  !! History : 2.1  : 05/2005  : J.M. Molines : Original code
  !!           3.0  : 05/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  USE modutils
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: ji, jj, jk, jt  ! dummy loop index
  INTEGER(KIND=4)                           :: ierr            ! working integer
  INTEGER(KIND=4)                           :: narg, iargc     ! command line 
  INTEGER(KIND=4)                           :: ijarg, ireq     ! command line
  INTEGER(KIND=4)                           :: npiglo, npjglo  ! size of the domain
  INTEGER(KIND=4)                           :: npk, npt        ! size of the domain
  INTEGER(KIND=4)                           :: ncout           ! ncid of output file
  INTEGER(KIND=4)                           :: iiref, ijref    ! reference i j point
  INTEGER(KIND=4)                           :: nvout=1         ! number of output variables
  INTEGER(KIND=4), DIMENSION(:),ALLOCATABLE :: ipk, id_varout  ! levels and id's of output vars

  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zmask           ! mask
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e1v, e3v        ! v metrics
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e2u, e3u        ! u metrics
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zu, zv          ! velocity components
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: glamf, gphif    ! longitude/latitude
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zsshu, zsshv    ! ssh at u and v point
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zssh            ! temporary array for ssh
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: tim             ! time counter
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: e31d            ! 1d vertical metrics, full step case

  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dtrpu, dtrpv    ! transport working arrays
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dtrpsshu        ! transport working arrays
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dtrpsshv        ! transport working arrays
  REAL(KIND=8), TARGET, DIMENSION(:,:), ALLOCATABLE :: dpsiu   ! BSF ( U computation
  REAL(KIND=8), TARGET, DIMENSION(:,:), ALLOCATABLE :: dpsiv   ! BSF (V computation )
  REAL(KIND=8), TARGET, DIMENSION(:,:), ALLOCATABLE :: dpsisshu ! BSF ( SSHU computation
  REAL(KIND=8), TARGET, DIMENSION(:,:), ALLOCATABLE :: dpsisshv ! BSF ( SSHV computation )
  REAL(KIND=8), POINTER, DIMENSION(:,:)     :: dpsi            ! point to dpsiu or dpsiv
  REAL(KIND=8), POINTER, DIMENSION(:,:)     :: dpsissh         ! point to dpsisshu or dpsisshv

  CHARACTER(LEN=256)                        :: cf_ufil         ! gridU netcdf file name
  CHARACTER(LEN=256)                        :: cf_vfil         ! gridV netcdf file name
  CHARACTER(LEN=256)                        :: cf_tfil         ! gridT netcdf file name (-ssh option)
  CHARACTER(LEN=256)                        :: cf_out='psi.nc' ! output file name
  CHARACTER(LEN=256)                        :: cv_out='sobarstf' ! output variable name
  CHARACTER(LEN=256)                        :: cv_outssh='sobarstfssh'    ! output variable name
  CHARACTER(LEN=256)                        :: cv_outotal='sobarstftotal' ! output variable name
  CHARACTER(LEN=256)                        :: cldum           ! dummy character variable
  CHARACTER(LEN=256)                        :: cglobal         ! global attribute

  TYPE(variable), DIMENSION(:), ALLOCATABLE :: stypvar         ! structure for attributes

  LOGICAL                                   :: lchk  = .FALSE. ! flag for missing files
  LOGICAL                                   :: ll_u  = .TRUE.  ! flag for U integration
  LOGICAL                                   :: ll_v  = .FALSE. ! flag for V integration
  LOGICAL                                   :: lfull = .FALSE. ! flag for full step config
  LOGICAL                                   :: lmask = .FALSE. ! flag for masking output
  LOGICAL                                   :: lmean = .FALSE. ! flag for mean U,V calculation
  LOGICAL                                   :: lopen = .FALSE. ! flag for open calculation
  LOGICAL                                   :: lssh  = .FALSE. ! flag for ssh computation
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfpsi U-file V-file [V] [-full ] [-mask ] [-mean] ...'
     PRINT *,'          ... [-ssh T-file ] [-open ] [-ref iref jref ]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Computes the barotropic stream function (a proxy ) as the integral of '
     PRINT *,'       the transport.' 
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       U-file  : netcdf file of zonal velocity.' 
     PRINT *,'       V-file  : netcdf file of meridional velocity.' 
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [V] : use V field instead of U field for integration.' 
     PRINT *,'       [ -full ] : indicates a full step case. Default is partial steps.'
     PRINT *,'       [ -mask ] : mask output fields. Note that the land value is significant.'
     PRINT *,'                   It correspond to the potential on this continent.'
     PRINT *,'       [ -mean ] : save the average of the computations done with U and V.'
     PRINT *,'       [ -ssh T-file ] : compute the transport in the ''ssh'' layer, using '
     PRINT *,'                  surface velocities. Take the ssh from T-file specified in '
     PRINT *,'                  this option. This is a experimental option, not certified ...'
     PRINT *,'       [ -open ] : for open domain configuration. See also -ref to set '
     PRINT *,'                   reference point.'
     PRINT *,'       [ -ref iref jref ] : Set the reference point in i,j coordinates.'
     PRINT *,'                   BSF at reference point is arbitrarly set to zero.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ', TRIM(cn_fhgr),' and ', TRIM(cn_fzgr),'.'
     PRINT *,'       ', TRIM(cn_fmsk),' is required only if -mask option used.'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : ', TRIM(cv_out),' (m3/s )'
     PRINT *,'       If option -ssh is used, 2 additional variables are added to the file :'
     PRINT *,'                     ', TRIM(cv_outssh),' (m3/s ) : contribution of SSH'
     PRINT *,'                     ', TRIM(cv_outotal),' (m3/s ) : total BSF'
     PRINT *,'      '
     STOP
  ENDIF

  CALL SetGlobalAtt (cglobal)
  iiref = -1 ; ijref= -1

  ijarg = 1 ; ireq = 0
  DO WHILE ( ijarg <= narg )
     CALL getarg( ijarg, cldum ) ; ijarg=ijarg + 1
     SELECT CASE ( cldum )
     CASE ('-full') ; lfull = .TRUE.
     CASE ('-mask') ; lmask = .TRUE.
     CASE ('-mean') ; lmean = .TRUE.  ; ll_v=.TRUE. ; ll_u=.TRUE.
     CASE ('-ssh' ) ; lssh  = .TRUE.  ; nvout=3
        CALL getarg( ijarg, cf_tfil ) ; ijarg=ijarg + 1 
     CASE ('-open') ; lopen = .TRUE.  ; ll_v=.TRUE. ; ll_u=.TRUE.
     CASE ('-ref') 
        CALL getarg( ijarg, cldum )   ; ijarg=ijarg + 1 ; READ(cldum,*) iiref
        CALL getarg( ijarg, cldum )   ; ijarg=ijarg + 1 ; READ(cldum,*) ijref

     CASE DEFAULT
        ireq = ireq + 1
        SELECT CASE ( ireq)
        CASE ( 1 ) ; cf_ufil = cldum
        CASE ( 2 ) ; cf_vfil = cldum
        CASE ( 3 ) ; ll_v = .TRUE. ; ll_u = .FALSE.
        CASE DEFAULT
           PRINT *, ' Too many arguments !' ; STOP
        END SELECT
     END SELECT
  ENDDO

  lchk = lchk .OR. chkfile( cn_fhgr )
  lchk = lchk .OR. chkfile( cn_fzgr )
  IF ( lmask) lchk = lchk .OR. chkfile( cn_fmsk )
  IF ( lssh ) lchk = lchk .OR. chkfile( cf_tfil )
  lchk = lchk .OR. chkfile( cf_ufil )
  lchk = lchk .OR. chkfile( cf_vfil )

  IF ( lchk ) STOP ! missing file

  npiglo = getdim (cf_ufil, cn_x)
  npjglo = getdim (cf_ufil, cn_y)
  npk    = getdim (cf_ufil, cn_z)
  npt    = getdim (cf_ufil, cn_t)

  IF ( iiref == -1 .OR. ijref == -1 ) THEN
     iiref=npiglo
     ijref=npjglo
  ENDIF

  ALLOCATE (stypvar(nvout), ipk(nvout), id_varout(nvout))
  ! define new variables for output ( must update att.txt)
  ipk(:) = 1  !  2D ( X, Y , T )
  stypvar(:)%cunits            = 'm3/s'
  stypvar(:)%valid_min         = -300.e6
  stypvar(:)%valid_max         = 300.e6
  stypvar(:)%conline_operation = 'N/A'
  stypvar(:)%caxis             = 'TYX'

  stypvar(1)%cname             = cv_out
  stypvar(1)%rmissing_value    = 0.
  stypvar(1)%clong_name        = 'Barotropic_Stream_Function'
  stypvar(1)%cshort_name       = cv_out

  IF ( lssh ) THEN
     stypvar(2)%cname             = cv_outssh
     stypvar(2)%rmissing_value    = 0.
     stypvar(2)%clong_name        = 'Barotropic_Stream_Function SSH contribution'
     stypvar(2)%cshort_name       = cv_outssh

     stypvar(3)%cname             = cv_outotal
     stypvar(3)%rmissing_value    = 0.
     stypvar(3)%clong_name        = 'Barotropic_Stream_Function SSH total'
     stypvar(3)%cshort_name       = cv_outotal
  ENDIF

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt
  PRINT *, ' Option is use :'
  PRINT *, '    -full :', lfull
  PRINT *, '    -mask :', lmask
  PRINT *, '    -mean :', lmean
  PRINT *, '    -ssh  :', lssh
  PRINT *, '    -open :', lopen
  PRINT *, '    -ref  :', iiref, ijref
  PRINT *, '  U-comp  :', ll_u
  PRINT *, '  V-comp  :', ll_v

  ! Allocate arrays
  ALLOCATE ( zmask(npiglo,npjglo)                 )
  ALLOCATE ( e1v(npiglo,npjglo),e3v(npiglo,npjglo))
  ALLOCATE ( e2u(npiglo,npjglo),e3u(npiglo,npjglo))
  ALLOCATE ( zu(npiglo,npjglo),dtrpu(npiglo,npjglo), dpsiu(npiglo,npjglo) )
  ALLOCATE ( zv(npiglo,npjglo),dtrpv(npiglo,npjglo), dpsiv(npiglo,npjglo) )
  ALLOCATE ( glamf(npiglo,npjglo), gphif(npiglo,npjglo))
  ALLOCATE ( tim(npt))
  IF ( lfull ) ALLOCATE ( e31d(npk))
  IF ( lssh  ) ALLOCATE ( zssh(npiglo,npjglo), zsshu(npiglo,npjglo), zsshv(npiglo,npjglo))
  IF ( lssh  ) ALLOCATE ( dpsisshu(npiglo,npjglo), dpsisshv(npiglo,npjglo) )
  IF ( lssh  ) ALLOCATE ( dtrpsshu(npiglo,npjglo), dtrpsshv(npiglo,npjglo) )

  glamf(:,:) = getvar(cn_fhgr, cn_glamf, 1, npiglo, npjglo)
  gphif(:,:) = getvar(cn_fhgr, cn_gphif, 1, npiglo, npjglo)

  ! create output fileset
  ncout = create      (cf_out, cf_ufil, npiglo, npjglo, 1              )
  ierr  = createvar   (ncout,  stypvar, nvout,  ipk,    id_varout, cdglobal=TRIM(cglobal)      )
  ierr  = putheadervar(ncout,  cf_ufil, npiglo, npjglo, 1, glamf, gphif)

  tim  = getvar1d(cf_ufil, cn_vtimec, npt     )
  ierr = putvar1d(ncout,   tim,       npt, 'T')

  e1v(:,:)   = getvar(cn_fhgr, cn_ve1v, 1, npiglo, npjglo)
  e2u(:,:)   = getvar(cn_fhgr, cn_ve2u, 1, npiglo, npjglo)
  IF ( lmask) THEN
     zmask(:,:) = getvar(cn_fmsk, 'fmask', 1, npiglo, npjglo)
     WHERE ( zmask >= 2 ) zmask = 1
  ENDIF

  IF ( lfull) e31d(:)    = getvare3(cn_fzgr, cn_ve3t, npk )
  ! get rid of the free-slip/no-slip condition

  DO jt = 1, npt
     dtrpu(:,:)= 0.d0
     dtrpv(:,:)= 0.d0
     dpsiu(:,:)= 0.d0
     dpsiv(:,:)= 0.d0
     IF ( lssh ) THEN
       zsshu(:,:) = 0.0
       zsshv(:,:) = 0.0
       dpsisshu(:,:) = 0.d0
       dpsisshv(:,:) = 0.d0
       dtrpsshu(:,:) = 0.d0
       dtrpsshv(:,:) = 0.d0
       zssh(:,:) = getvar(cf_tfil, cn_sossheig, 1, npiglo, npjglo, ktime=jt)
       zsshu(1:npiglo-1,    :     ) = 0.5*( zssh(2:npiglo,:       ) + zssh(1:npiglo-1,:         ))
       zsshv(   :      ,1:npjglo-1) = 0.5*( zssh(:       ,2:npjglo) + zssh(:         ,1:npjglo-1))
     ENDIF


     DO jk = 1,npk
        IF ( ll_v ) THEN
           zv(:,:) = getvar(cf_vfil, cn_vomecrty, jk, npiglo, npjglo, ktime=jt )
           IF ( lfull ) THEN ; e3v(:,:) = e31d(jk)
           ELSE              ; e3v(:,:) = getvar(cn_fzgr, 'e3v_ps', jk, npiglo, npjglo, ldiom=.TRUE.)
           ENDIF
           dtrpv(:,:) = dtrpv(:,:) + zv(:,:)*e1v(:,:)*e3v(:,:)*1.d0  ! meridional transport of each grid cell
           IF ( lssh .AND. (jk == 1 ) ) THEN
             dtrpsshv(:,:) = dtrpsshv(:,:) + zv(:,:)*e1v(:,:)*zsshv(:,:)*1.d0  ! meridional transport of each grid cell
           ENDIF
        ENDIF

        IF ( ll_u) THEN
           zu(:,:) = getvar(cf_ufil, cn_vozocrtx, jk, npiglo, npjglo, ktime=jt )
           IF ( lfull ) THEN ; e3u(:,:) = e31d(jk)
           ELSE              ; e3u(:,:) = getvar(cn_fzgr, 'e3u_ps', jk, npiglo, npjglo, ldiom=.TRUE.)
           ENDIF
           dtrpu(:,:) = dtrpu(:,:) + zu(:,:)*e2u(:,:)*e3u(:,:)*1.d0  ! zonal transport of each grid cell
           IF ( lssh .AND. (jk == 1 ) ) THEN
             dtrpsshu(:,:) = dtrpsshu(:,:) + zv(:,:)*e2u(:,:)*zsshu(:,:)*1.d0  ! meridional transport of each grid cell
           ENDIF
        ENDIF
     END DO  ! loop to next level

     IF ( lopen ) THEN
        ! This case corresponds to arbitrary configuration: we chose to compute the transport
        ! across a first line ( eg, ji= 2 or jj= npjglo-1 ), assuming that this starting line is
        ! in the true ocean. If it is on true land, it is not a problem. But it cannot be on
        ! arbitrary masked points....
        IF ( lssh ) THEN
          dpsisshu(1,npjglo-2) = dtrpsshv(1, npjglo-2)
          DO ji = 2, npiglo
             dpsisshu(ji,npjglo-2) = dpsisshu(ji-1,npjglo-2) + dtrpsshv(ji,npjglo-2)
          END DO
          ! Then compute the transport with along U starting from this line
          DO jj= npjglo-3,1,-1
             DO ji = 1, npiglo
                dpsisshu(ji,jj) = dpsisshu(ji,jj+1) + dtrpsshu(ji,jj+1)
             END DO
          END DO
        ENDIF

        dpsiu(1,npjglo-2) = dtrpv(1, npjglo-2)
        DO ji = 2, npiglo
           dpsiu(ji,npjglo-2) = dpsiu(ji-1,npjglo-2) + dtrpv(ji,npjglo-2)
        END DO
        ! Then compute the transport with along U starting from this line
        DO jj= npjglo-3,1,-1
           DO ji = 1, npiglo
              dpsiu(ji,jj) = dpsiu(ji,jj+1) + dtrpu(ji,jj+1)
           END DO
        END DO

        IF ( lmean ) THEN  ! we need also the other estimate
           dpsiv(npiglo-2, npjglo) = dtrpu(npiglo-2, npjglo)
           DO jj= npjglo - 1, 1, -1
              dpsiv(npiglo-2,jj) = dpsiv(npiglo-2, jj+1) + dtrpu(npiglo-2, jj+1)
           END DO
           DO jj=npjglo,1,-1
              DO ji = npiglo -3,1,-1
                 dpsiv(ji,jj) = dpsiv(ji+1,jj) - dtrpv(ji+1,jj)
              END DO
           END DO
           dpsiu(:,:) = 0.5*(dpsiu(:,:) + dpsiv(:,:))

           IF ( lssh ) THEN
              dpsisshv(npiglo-2, npjglo) = dtrpsshu(npiglo-2, npjglo)
              DO jj= npjglo - 1, 1, -1
                 dpsisshv(npiglo-2,jj) = dpsisshv(npiglo-2, jj+1) + dtrpsshu(npiglo-2, jj+1)
              END DO
              DO jj=npjglo,1,-1
                 DO ji = npiglo -3,1,-1
                    dpsisshv(ji,jj) = dpsisshv(ji+1,jj) - dtrpsshv(ji+1,jj)
                 END DO
              END DO
              dpsisshu(:,:) = 0.5*(dpsisshu(:,:) + dpsisshv(:,:))
           ENDIF
        ENDIF

        dpsi => dpsiu
        IF ( lssh ) dpsissh => dpsisshu

     ELSE
        ! now perform zonal integration if requested
        IF ( ll_v ) THEN
           ! integrate zonally from east to west 
           ! This comfortable with NATL configurations as the eastern most points are land points.
           dpsiv(npiglo,:)= 0.d0
           DO ji=npiglo-1,1,-1
              dpsiv(ji,:) = dpsiv(ji+1,:) - dtrpv(ji,:)  ! psi at f point
           END DO
           dpsi => dpsiv
           IF ( lssh ) THEN
              dpsisshv(npiglo,:)= 0.d0
              DO ji=npiglo-1,1,-1
                 dpsisshv(ji,:) = dpsisshv(ji+1,:) - dtrpsshv(ji,:)  ! psissh at f point
              END DO
              dpsissh => dpsisshv
           ENDIF
        ENDIF

        ! now perform meridional integration if requested
        IF ( ll_u ) THEN
           ! integrate from the south to the north with zonal transport
           ! This is because on global configuration, line jj=1 is always land (Antarctic)
           dpsiu(:,:) = 0.d0
           DO jj = 2, npjglo
              dpsiu(:,jj) = dpsiu(:,jj-1) - dtrpu(:,jj)   ! psi at f point
           END DO
           dpsi => dpsiu
           IF ( lssh ) THEN
              dpsisshu(:,:) = 0.d0
              DO jj = 2, npjglo
                 dpsisshu(:,jj) = dpsisshu(:,jj-1) - dtrpsshu(:,jj)   ! psissh at f point
              END DO
                 dpsissh => dpsisshu
           ENDIF
        ENDIF

        IF ( lmean) THEN 
           dpsiu(:,:) = 0.5 * ( dpsiu(:,:) + dpsiv(:,:) )
           dpsi => dpsiu
           IF ( lssh ) THEN
              dpsisshu(:,:) = 0.5 * ( dpsisshu(:,:) + dpsisshv(:,:) )
              dpsissh => dpsisshu
           ENDIF
        ENDIF
     ENDIF

     ! output results after normalization
     dpsi = dpsi - dpsi(iiref,ijref)
     IF ( lmask ) THEN
        PRINT *,' Write masked BSF'
        ierr = putvar(ncout, id_varout(1), SNGL(dpsi)*zmask(:,:), 1, npiglo, npjglo, ktime=jt)
        IF ( lssh ) THEN
           ierr = putvar(ncout, id_varout(2), SNGL(dpsissh     )*zmask(:,:), 1, npiglo, npjglo, ktime=jt)
           ierr = putvar(ncout, id_varout(3), SNGL(dpsissh+dpsi)*zmask(:,:), 1, npiglo, npjglo, ktime=jt)
        ENDIF
     ELSE
        PRINT *,' Write BSF'
        ierr = putvar(ncout, id_varout(1), SNGL(dpsi)           , 1, npiglo, npjglo, ktime=jt)
        IF ( lssh ) THEN
           ierr = putvar(ncout, id_varout(2), SNGL(dpsissh     ), 1, npiglo, npjglo, ktime=jt)
           ierr = putvar(ncout, id_varout(3), SNGL(dpsissh+dpsi), 1, npiglo, npjglo, ktime=jt)
        ENDIF
     ENDIF
  ENDDO

  ierr = closeout (ncout)

END PROGRAM cdfpsi

PROGRAM cdfheatc
  !!======================================================================
  !!                     ***  PROGRAM  cdfheatc  ***
  !!=====================================================================
  !!  ** Purpose : Compute the heat content of the ocean : 1 single value
  !!
  !!  ** Method  : compute the sum ( rho cp T  * e1t *e2t * e3t * tmask )
  !!
  !! History : 2.1  : 03/2006  : J.M. Molines : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: jk, jt              ! dummy loop index
  INTEGER(KIND=4)                           :: ik                  ! working integer
  INTEGER(KIND=4)                           :: ierr                ! working integer
  INTEGER(KIND=4)                           :: iimin=0, iimax=0    ! domain limitation for computation
  INTEGER(KIND=4)                           :: ijmin=0, ijmax=0    ! domain limitation for computation
  INTEGER(KIND=4)                           :: ikmin=0, ikmax=0    ! domain limitation for computation
  INTEGER(KIND=4)                           :: narg, iargc, ijarg  ! command line 
  INTEGER(KIND=4)                           :: npiglo, npjglo      ! size of the domain
  INTEGER(KIND=4)                           :: npk, npt            ! size of the domain
  INTEGER(KIND=4)                           :: nvpk                ! vertical levels in working variable

  REAL(KIND=4), PARAMETER                   :: pprho0=1020.        ! water density (kg/m3)
  REAL(KIND=4), PARAMETER                   :: ppcp=4000.          ! calorific capacity (J/kg/m3)

  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e1t, e2t            ! horizontal metrics
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e3t                 ! vertical metric
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: temp                ! temperature
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: tmask               ! tmask
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: gdept               ! depth
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: tim                 ! time counter
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: e31d                ! vertical metrics in case of full step

  REAL(KIND=8)                              :: dvol                ! 3D volume of the ocean
  REAL(KIND=8)                              :: dsum                ! weighted sum 3D
  REAL(KIND=8)                              :: dvol2d              ! volume of a layer
  REAL(KIND=8)                              :: dsum2d              ! weigthed sum per layer
  REAL(KIND=8)                              :: dsurf               ! surface of a layer

  CHARACTER(LEN=256)                        :: cf_tfil             ! input gridT file
  CHARACTER(LEN=256)                        :: cldum               ! dummy character variable

  LOGICAL                                   :: lfull=.FALSE.       ! flag for full step computation
  LOGICAL                                   :: lchk                ! flag for missing files
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage :  cdfheatc  T-file ...'
     PRINT *,'    ... [imin imax jmin jmax kmin kmax] [-full] '
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'        Computes the heat content in the specified area (Joules)'
     PRINT *,'        A sub-domain can be specified in option.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       T-file : a file with temperature and salinity' 
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [imin imax jmin jmax kmin kmax] : limit of a sub domain where'
     PRINT *,'                      the heat content will be calculated.'
     PRINT *,'                   - if imin = 0 then ALL i are taken'
     PRINT *,'                   - if jmin = 0 then ALL j are taken'
     PRINT *,'                   - if kmin = 0 then ALL k are taken'
     PRINT *,'       [-full ] : assume full step model output instead of default'
     PRINT *,'                  partial steps.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       Files ',TRIM(cn_fhgr),', ',TRIM(cn_fzgr),' and ',TRIM(cn_fmsk) 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : to be done ....'
     PRINT *,'       Standard output'
     STOP
  ENDIF

  ijarg = 1 
  CALL getarg (ijarg, cf_tfil) ; ijarg = ijarg + 1

  lchk = chkfile(cn_fhgr)
  lchk = chkfile(cn_fzgr) .OR. lchk
  lchk = chkfile(cn_fmsk) .OR. lchk
  lchk = chkfile(cf_tfil) .OR. lchk
  IF ( lchk ) STOP ! missing files

  DO WHILE ( ijarg <= narg ) 
     CALL getarg ( ijarg, cldum) ; ijarg = ijarg + 1
     SELECT CASE ( cldum )
     CASE ( '-full' ) ; lfull = .true.
     CASE DEFAULT
        PRINT *,' Reading 6 values : imin imax jmin jmax kmin kmax '
                                                          READ(cldum,*) iimin
        CALL getarg ( ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) iimax
        CALL getarg ( ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) ijmin
        CALL getarg ( ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) ijmax
        CALL getarg ( ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) ikmin
        CALL getarg ( ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) ikmax
     END SELECT
  END DO

  npiglo = getdim (cf_tfil,cn_x)
  npjglo = getdim (cf_tfil,cn_y)
  npk    = getdim (cf_tfil,cn_z)
  npt    = getdim (cf_tfil,cn_t)

  IF (iimin /= 0 ) THEN ; npiglo = iimax - iimin + 1;  ELSE ; iimin=1 ; ENDIF
  IF (ijmin /= 0 ) THEN ; npjglo = ijmax - ijmin + 1;  ELSE ; ijmin=1 ; ENDIF
  IF (ikmin /= 0 ) THEN ; npk    = ikmax - ikmin + 1;  ELSE ; ikmin=1 ; ENDIF

  nvpk   = getvdim(cf_tfil,cn_votemper)
  IF (nvpk == 2 ) nvpk = 1
  IF (nvpk == 3 ) nvpk = npk

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt
  PRINT *, 'nvpk   = ', nvpk

  ! Allocate arrays
  ALLOCATE ( tmask(npiglo,npjglo) )
  ALLOCATE ( temp (npiglo,npjglo) )
  ALLOCATE ( e1t  (npiglo,npjglo), e2t(npiglo,npjglo), e3t(npiglo,npjglo) )
  ALLOCATE ( gdept(npk), tim(npt) )
  IF ( lfull ) ALLOCATE ( e31d(npk) )

  e1t(:,:) = getvar(cn_fhgr, cn_ve1t, 1, npiglo, npjglo, kimin=iimin, kjmin=ijmin)
  e2t(:,:) = getvar(cn_fhgr, cn_ve2t, 1, npiglo, npjglo, kimin=iimin, kjmin=ijmin)
  gdept(:) = getvare3(cn_fzgr, cn_gdept,  npk)
  tim  (:) = getvare3(cf_tfil, cn_vtimec, npt)
  IF ( lfull ) e31d(:) = getvare3(cn_fzgr, cn_ve3t, npk)

  DO jt=1,npt
     dvol = 0.d0
     dsum = 0.d0
     PRINT * ,'TIME : ', tim(jt)/86400.,' days'

     DO jk = 1,nvpk
        ik = jk + ikmin -1
        ! Get velocities v at ik
        temp( :,:)   = getvar(cf_tfil, cn_votemper, ik, npiglo, npjglo, kimin=iimin, kjmin=ijmin, ktime=jt)
        tmask(:,:)   = getvar(cn_fmsk, 'tmask',     ik, npiglo, npjglo, kimin=iimin, kjmin=ijmin          )

        ! get e3t at level ik ( ps...)
        IF ( lfull ) THEN
           e3t(:,:) = e31d(jk)
        ELSE
           e3t(:,:) = getvar(cn_fzgr, 'e3t_ps', ik, npiglo, npjglo, kimin=iimin, kjmin=ijmin, ldiom=.TRUE.)
        ENDIF

        dsurf  = SUM(e1t * e2t       * tmask)
        dvol2d = SUM(e1t * e2t * e3t * tmask)
        dvol   = dvol + dvol2d

        dsum2d = SUM(e1t * e2t * e3t * temp * tmask)
        dsum   = dsum + dsum2d

        IF (dvol2d /= 0 )THEN
           PRINT *, ' Heat Content  at level ',ik,'(',gdept(ik),' m) ',pprho0*ppcp*dsum2d, 'surface = ',dsurf/1.e6,' km^2'
        ELSE
           PRINT *, ' No points in the water at level ',ik,'(',gdept(ik),' m) '
        ENDIF

     END DO
     
     PRINT * ,' Total Heat content        : ', pprho0*ppcp*dsum ,' Joules'
     PRINT * ,' Total Heat content/volume : ', pprho0*ppcp*dsum/dvol ,' Joules/m3 '
  END DO

END PROGRAM cdfheatc

PROGRAM cdf_remake_bathy 
  !!======================================================================
  !!                     ***  PROGRAM  cdf_remake_bathy  ***
  !!=====================================================================
  !!  ** Purpose : Recompute bathymetry from e3t vertical intregration
  !!
  !! History : 4.0  : 09/2019  : Q. Jamet, J.-M. Molines
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames   ! for cdf variable names
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class domain_file
  !!----------------------------------------------------------------------
  IMPLICIT NONE


  INTEGER(KIND=4), PARAMETER                   :: wp=4
  INTEGER(KIND=4), PARAMETER                   :: jpvarout = 3             ! number of output variables
  INTEGER(KIND=4)                              :: ncout                    ! ncid of output file
  INTEGER(KIND=4), DIMENSION(jpvarout)         :: id_varout                ! id of output variables
  INTEGER(KIND=4), DIMENSION(jpvarout)         :: ipk                      ! level of output variables
  INTEGER(KIND=4)                              :: ierr                     ! working integer
  INTEGER(KIND=4)                              :: narg, iargc, ijarg       !
  INTEGER(KIND=4)                              :: ji, jj, jk, jt           ! dummy loop indices
  INTEGER(KIND=4)                              :: npi, npj, npk, npt       ! size of the domain

  REAL(wp), DIMENSION(:,:)    , ALLOCATABLE    :: e3t_0, e3u_0, e3v_0      ! vet. metrics at rest (without vvl)
  REAL(wp), DIMENSION(:,:)    , ALLOCATABLE    :: ht_0, hu_0, hv_0         ! Reference ocean depth at T-, U-, V-points
  REAL(wp), DIMENSION(:,:)    , ALLOCATABLE    :: tmask, umask, vmask      ! Mask at T-, U-, V-points

  CHARACTER(LEN=255)                           :: cf_mz                    ! vert. mesh  netcdf file name
  CHARACTER(LEN=255)                           :: cf_mask                  ! mask        netcdf file name
  CHARACTER(LEN=256)                           :: cf_out='bathy_gdepw_0.nc'! output file name 
  CHARACTER(LEN=256)                           :: cldum                    ! dummy character variable
  CHARACTER(LEN=256)                           :: cglobal                  ! global attribute

  TYPE (variable), DIMENSION(jpvarout)         :: stypvar                  ! structure for attibutes

  LOGICAL                                      :: lchk                     ! check missing files
  LOGICAL                                      :: lnc4  =.FALSE.           ! full step flag
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdf_remake_bathy -mz ZGR-file -msk MASK-file [-o OUT-file] [-nc4]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'      Remake bathymetry from vertical integration of e3t, read in mesh_zgr.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -mz ZGR-file   : netcdf file for vertical mesh'
     PRINT *,'       -msk MASK-file : netcdf file for mask'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       -o OUT-file    : netcdf output file'
     PRINT *,'       -nc4           : Use netcdf4/HDF5 with chunking and deflation for output'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : '//TRIM(cf_out)//' unless -o option is used.'
     PRINT *,'       variables   : gdepw_0, hu_0, hv_0 '
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'      cdf_domain2bathy (can probably be merged)'
     PRINT *,'      '
     STOP
  ENDIF

  cglobal = 'Partial step computation'


  ijarg = 1
  DO WHILE ( ijarg <= narg ) 
     CALL getarg(ijarg, cldum) ; ijarg = ijarg + 1
     SELECT CASE (cldum)
     CASE ('-mz'    ) ; CALL getarg( ijarg, cf_mz    ) ; ijarg=ijarg+1
     CASE ('-msk'   ) ; CALL getarg( ijarg, cf_mask  ) ; ijarg=ijarg+1
        ! options
     CASE ( '-o'    ) ; CALL getarg(ijarg, cf_out ) ; ijarg = ijarg + 1
     CASE ( '-nc4'  ) ; lnc4    = .TRUE.
     CASE DEFAULT     ; PRINT *,' ERROR : ', TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  END DO


  !-- get dimensions (assuming all files have the same dimension that U-file) --
  npi = getdim (cf_mz, cn_x)
  npj = getdim (cf_mz, cn_y)
  npk = getdim (cf_mz, 'z')
  npt = 1

  PRINT *, '==============='
  PRINT *, 'npi=      ', npi
  PRINT *, 'npj=      ', npj
  PRINT *, 'npk=      ', npk
  PRINT *, 'npt=      ', npt
  PRINT *, '==============='

  !-- Allocate arrays --
  ALLOCATE( e3t_0(npi, npj), e3u_0(npi, npj), e3v_0(npi, npj) )
  ALLOCATE( ht_0(npi, npj) , hu_0(npi, npj) , hv_0(npi, npj)  )
  ALLOCATE( tmask(npi, npj), umask(npi, npj), vmask(npi, npj) )

  !-- Creat output netcdf files to fill in --
  CALL CreateOutput

  !-- compute (from domain.F90) --
  ht_0(:,:) = 0.0_wp                       ! Reference ocean depth at T-points
  hu_0(:,:) = 0.0_wp                       ! Reference ocean depth at U-points
  hv_0(:,:) = 0.0_wp                       ! Reference ocean depth at V-points
  DO jk = 1, npk
     !- T-points -
     e3t_0(:,:)           = getvar(cf_mz  , cn_ve3t0  , jk, npi, npj )
     tmask(:,:)           = getvar(cf_mask, cn_tmask  , jk, npi, npj ) 
     ht_0(:,:)            = ht_0(:,:) + e3t_0(:,:) * tmask(:,:)
     !- U-points -
     e3u_0(:,:)           = getvar(cf_mz  , cn_ve3u0  , jk, npi, npj )
     umask(:,:)           = getvar(cf_mask, cn_umask  , jk, npi, npj ) 
     hu_0(:,:)            = hu_0(:,:) + e3u_0(:,:) * umask(:,:)
     !- V-points -
     e3v_0(:,:)           = getvar(cf_mz  , cn_ve3v0  , jk, npi, npj )
     vmask(:,:)           = getvar(cf_mask, cn_vmask  , jk, npi, npj ) 
     hv_0(:,:)            = hv_0(:,:) + e3v_0(:,:) * vmask(:,:)
  END DO

  ierr = putvar(ncout, id_varout(1), ht_0, 1, npi, npj , 1 )
  ierr = putvar(ncout, id_varout(2), hu_0, 1, npi, npj , 1 )
  ierr = putvar(ncout, id_varout(3), hv_0, 1, npi, npj , 1 )

  ierr = closeout(ncout)

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    REAL(KIND=8), DIMENSION(npt)        :: dltim                     ! time 
    ! define new variables for output
    ipk(:)                       = 1 
    !stypvar(1)%ichunk            = (/npi,MAX(1,npj/30),1,1 /)
    stypvar(1)%cname             = 'gdepw_0'
    stypvar(1)%cunits            = 'm'
    stypvar(1)%rmissing_value    = 0.
    stypvar(1)%valid_min         = 0.
    stypvar(1)%valid_max         = 9000.
    stypvar(1)%clong_name        = 'Bathymetry as vert. integ.of e3t_0'
    stypvar(1)%cshort_name       = 'Bathymetry'
    stypvar(1)%conline_operation = 'On T-grid'
    stypvar(1)%caxis             = 'nav_lon nav_lat'
    !
    stypvar(2)%ichunk            = (/npi,MAX(1,npj/30),1,1 /)
    stypvar(2)%cname             = 'hu_0'
    stypvar(2)%cunits            = 'm'
    stypvar(2)%rmissing_value    = 0.
    stypvar(2)%valid_min         = 0.
    stypvar(2)%valid_max         = 9000.
    stypvar(2)%clong_name        = 'Bathymetry as vert. integ.of e3u_0'
    stypvar(2)%cshort_name       = 'Bathymetry'
    stypvar(2)%conline_operation = 'On U-grid'
    stypvar(2)%caxis             = 'nav_lon nav_lat'
    !
    stypvar(3)%ichunk            = (/npi,MAX(1,npj/30),1,1 /)
    stypvar(3)%cname             = 'hv_0'
    stypvar(3)%cunits            = 'm'
    stypvar(3)%rmissing_value    = 0.
    stypvar(3)%valid_min         = 0.
    stypvar(3)%valid_max         = 9000.
    stypvar(3)%clong_name        = 'Bathymetry as vert. integ.of e3v_0'
    stypvar(3)%cshort_name       = 'Bathymetry'
    stypvar(3)%conline_operation = 'On V-grid'
    stypvar(3)%caxis             = 'nav_lon nav_lat'

    ! create output fileset
    ncout   = create      (cf_out  , cf_mz ,  npi, npj, 1 , ld_nc4=lnc4   )
    ierr    = createvar   (ncout , stypvar ,  jpvarout, ipk , id_varout   , ld_nc4=lnc4 )
    ierr    = putheadervar(ncout , cf_mz   ,  npi, npj, 1              )

    dltim = getvar1d(cf_mz, cn_vtimec,      npt     )
    ierr  = putvar1d(ncout  , dltim,        npt, 'T')
    ierr  = putvar1d(ncout  , dltim,        npt, 'T')


  END SUBROUTINE CreateOutput

END PROGRAM cdf_remake_bathy

PROGRAM cdfnrjcomp
  !!======================================================================
  !!                     ***  PROGRAM  cdfnrjcomp  ***
  !!=====================================================================
  !!  ** Purpose : Compute the terms for energy components
  !!               (Mean Kinetic Energy, Eddy Kinetic Energy,
  !!                Mean Potential Energy, Eddy Potential Energy )
  !!               compute : tbar, ubar, vbar, anotsqrt, anousqrt, anovsqrt
  !!
  !! History : 2.1  : 02/2008  : A. Melet     : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                            :: ji, jj, jk           ! dummy loop index
  INTEGER(KIND=4)                            :: npiglo, npjglo       ! domain size
  INTEGER(KIND=4)                            :: npk, npt             ! domain size
  INTEGER(KIND=4)                            :: narg, iargc          ! browse line
  INTEGER(KIND=4)                            :: ierr                 ! error status
  INTEGER(KIND=4)                            :: ncout                ! ncid of output file
  INTEGER(KIND=4), DIMENSION(6)              :: ipk, id_varout       ! level and varid's of output var

  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE  :: un, vn, u2n, v2n
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE  :: tn, t2n, anotsqrt
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE  :: umask, vmask
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE  :: anousqrt, anovsqrt 
  REAL(KIND=4), DIMENSION(1)                 :: tim                   ! time counter

  CHARACTER(LEN=256)                         :: cf_in                 ! input filename
  CHARACTER(LEN=256)                         :: cf_out='nrjcomp.nc'   ! output file name
  TYPE (variable), DIMENSION(6)              :: stypvar               ! structure for attibutes
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()
  !!
  narg = iargc()
  IF ( narg /= 1 ) THEN
     PRINT *,' usage : cdfnrjcomp IN-file'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute contributing terms of the energy equation at T-points.'
     PRINT *,'       Input file contains mean values processed by cdfmoyuvwt.' 
     PRINT *,'       The means must have been computed on long enough period'
     PRINT *,'       for the statistics to be meaningful'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       IN-file   : netcdf file produced by cdfmoyuvwt.' 
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       none'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         all variables are located at T point.'
     PRINT *,'         variables : tbar : mean temperature '
     PRINT *,'                     ubar : mean zonal velocity'
     PRINT *,'                     vbar : mean meridional velocity'
     PRINT *,'                     anotsqrt : mean squared temperature anomaly'
     PRINT *,'                     anousqrt : mean squared zonal velocity anomaly'
     PRINT *,'                     anovsqrt : mean squared meridional velocity anomaly'
     STOP
  ENDIF

  CALL getarg(1, cf_in)

  IF ( chkfile(cf_in) ) STOP 99 ! missing file

  npiglo = getdim(cf_in,cn_x)
  npjglo = getdim(cf_in,cn_y)
  npk    = getdim(cf_in,cn_z)
  npt    = getdim(cf_in,cn_t)

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt
 
  ! define new variables for output 
  ipk(:)                 = npk  
  stypvar(1)%cname       = 'tbar'
  stypvar(1)%clong_name  = 'temporal mean of the temperature on T point'
  stypvar(1)%cshort_name = 'tbar'

  stypvar(2)%cname       = 'ubar'
  stypvar(2)%clong_name  = 'temporal mean of the zonal velocity on T point'
  stypvar(2)%cshort_name = 'ubar'
 
  stypvar(3)%cname       = 'vbar'
  stypvar(3)%clong_name  = 'temporal mean of the meridional velocity on T point'
  stypvar(3)%cshort_name = 'vbar'
  
  stypvar(4)%cname       = 'anotsqrt'
  stypvar(4)%clong_name  = 'temporal mean of the square of the temperature anomaly on T point (*1000)'
  stypvar(4)%cshort_name = 'anotsqrt'

  stypvar(5)%cname       = 'anousqrt'
  stypvar(5)%clong_name  = 'temporal mean of the square of the zonal speed anomaly on T point (*1000)'
  stypvar(5)%cshort_name = 'anousqrt'

  stypvar(6)%cname       = 'anovsqrt'
  stypvar(6)%clong_name  = 'temporal mean of the square of the meridional speed anomaly on T point (*1000)'
  stypvar(6)%cshort_name = 'anovsqrt'

  stypvar%cunits            = ' '
  stypvar%rmissing_value    = 0.
  stypvar%valid_min         = -1000.
  stypvar%valid_max         = 1000.
  stypvar%conline_operation = 'N/A'
  stypvar%caxis             = 'TZYX'
  
  ! create output fileset
  ncout = create      (cf_out, cf_in,   npiglo, npjglo, npk       )
  ierr  = createvar   (ncout,  stypvar, 6,      ipk,    id_varout )
  ierr  = putheadervar(ncout,  cf_in,   npiglo, npjglo, npk       )

  ! Allocate the memory
  ALLOCATE ( un(npiglo,npjglo), vn(npiglo,npjglo)  )
  ALLOCATE ( umask(npiglo,npjglo), vmask(npiglo,npjglo) )
  ALLOCATE ( u2n(npiglo,npjglo), v2n(npiglo,npjglo)  )
  ALLOCATE ( anousqrt(npiglo,npjglo), anovsqrt(npiglo,npjglo)  )
  ALLOCATE ( tn(npiglo,npjglo), t2n(npiglo,npjglo)  )
  ALLOCATE ( anotsqrt(npiglo,npjglo) )

  tim  = getvar1d(cf_in,cn_vtimec, npt     )
  ierr = putvar1d(ncout, tim,      npt, 'T')
     
  DO jk=1, npk
     PRINT *,'            level ',jk
     anousqrt(:,:) = 0.0
     anovsqrt(:,:) = 0.0      
     anotsqrt(:,:) = 0.0
     
     un(:,:)  = getvar(cf_in, 'ubar',  jk, npiglo, npjglo, ktime=1)
     vn(:,:)  = getvar(cf_in, 'vbar',  jk, npiglo, npjglo, ktime=1)
     u2n(:,:) = getvar(cf_in, 'u2bar', jk, npiglo, npjglo, ktime=1)
     v2n(:,:) = getvar(cf_in, 'v2bar', jk, npiglo, npjglo, ktime=1)
     tn(:,:)  = getvar(cf_in, 'tbar',  jk, npiglo, npjglo, ktime=1)
     t2n(:,:) = getvar(cf_in, 't2bar', jk, npiglo, npjglo, ktime=1)

     ! compute the mask
     DO jj = 2, npjglo
        DO ji = 2, npiglo
           umask(ji,jj) = 0.
           vmask(ji,jj) = 0.
           umask(ji,jj) = un(ji,jj)*un(ji-1,jj) 
           vmask(ji,jj) = vn(ji,jj)*vn(ji,jj-1)
           IF (umask(ji,jj) /= 0.) umask(ji,jj)=1.
           IF (vmask(ji,jj) /= 0.) vmask(ji,jj)=1.
        ENDDO
     ENDDO

     DO jj = 2, npjglo  
        DO ji = 2, npiglo    ! vector opt.
           anotsqrt(ji,jj) = 1000. * ( t2n(ji,jj) - tn(ji,jj) * tn(ji,jj) )
           anousqrt(ji,jj) = 1000./2. * umask(ji,jj)*( ( u2n(ji,jj) - un(ji,jj)*un(ji,jj) ) &
                &                     + ( u2n(ji-1,jj) - un(ji-1,jj)*un(ji-1,jj) ) )       
                
           anovsqrt(ji,jj) = 1000./2. * vmask(ji,jj)*( ( v2n(ji,jj) - vn(ji,jj)*vn(ji,jj) ) &
                &                     + ( v2n(ji,jj-1) - vn(ji,jj)*vn(ji,jj-1) ) ) 
        END DO
     END DO
     ! 
     ierr = putvar(ncout, id_varout(1), tn,       jk, npiglo, npjglo, ktime=1)
     ierr = putvar(ncout, id_varout(2), un,       jk, npiglo, npjglo, ktime=1)
     ierr = putvar(ncout, id_varout(3), vn,       jk, npiglo, npjglo, ktime=1)
     ierr = putvar(ncout, id_varout(4), anotsqrt, jk, npiglo, npjglo, ktime=1)
     ierr = putvar(ncout, id_varout(5), anousqrt, jk, npiglo, npjglo, ktime=1) 
     ierr = putvar(ncout, id_varout(6), anovsqrt, jk, npiglo, npjglo, ktime=1)
  END DO

  ierr = closeout(ncout)

END PROGRAM cdfnrjcomp

PROGRAM cdf_domain_modif
  !!======================================================================
  !!                     ***  PROGRAM  cdf_domain_modif  ***
  !!=====================================================================
  !!  ** Purpose : adjust scalar variable in (jpiglo, jpjglo, ... jperio)
  !!               in an existing domain_cfg file, for instance obtained
  !!               when extracting a sub area with ncks
  !!
  !!  ** Method  :  READ and Write ... 
  !!
  !! History :  4.0  : 03/2017  : J.M. Molines : 
  !!----------------------------------------------------------------------
  USE netcdf

  IMPLICIT NONE
  INTEGER(KIND=4) :: jperio, jpiglo, jpjglo, jpkglo
  INTEGER(KIND=4) :: jpisfcav, jpsco, jpzps, jpzco
  INTEGER(KIND=4) :: narg, ijarg, ncid, id, ierr

  LOGICAL         :: ll_jperio = .FALSE.
  LOGICAL         :: ll_jpiglo = .FALSE.
  LOGICAL         :: ll_jpjglo = .FALSE.
  LOGICAL         :: ll_jpkglo = .FALSE.
  LOGICAL         :: ll_isfcav = .FALSE.
  LOGICAL         :: ll_sco    = .FALSE.
  LOGICAL         :: ll_zps    = .FALSE.
  LOGICAL         :: ll_zco    = .FALSE.


  CHARACTER(LEN=80) :: cf_domain , cldum

  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2020
  !! $Id$
  !! Copyright (c) 2020, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class domain_file
  !!----------------------------------------------------------------------
  narg = iargc()

  IF ( narg == 0 ) THEN
     PRINT *,' usage :  cdf_domain_modif -d DOMAIN_cfg [-jperio JPERIO] [-jpiglo JPIGLO] ...'
     PRINT *,'                          [-jpjglo JPJGLO] [-jpkglo JPKGLO   ...]'
     PRINT *,'                          [-ln_isfcav LN_ISFCAV] [-ln_sco LN_SCO] ...'
     PRINT *,'                          [-ln_zps LN_ZPS ] [-ln_zco LN_ZCO]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Adjust scalar variable in (jpiglo, jpjglo, jpkglo, jperio) and boolean'
     PRINT *,'       variables (ln_ifscav, ln_sco, ln_zps, ln_zco) in an existing domain_cfg'
     PRINT *,'       file, for instance obtained  when extracting a sub area with ncks.' 

     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -d DOMAIN_cfg : specify the domain_cfg file to work with' 
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       -jperio JPERIO : pass the new value for jperio. If option not used,'
     PRINT *,'                        no changes.' 
     PRINT *,'       -jpiglo JPIGLO : pass the new value for jpiglo. If option not used,'
     PRINT *,'                        no changes.' 
     PRINT *,'       -jpjglo JPJGLO : pass the new value for jpjglo. If option not used,'
     PRINT *,'                        no changes.' 
     PRINT *,'       -jpkglo JPKGLO : pass the new value for jpkglo. If option not used,'
     PRINT *,'                        no changes.' 
     PRINT *,'       -ln_isfcav LN_ISFCAV : pass the new value for ln_isfcav ( 1 or 0 ).'
     PRINT *,'                 If option not used, no changes.'
     PRINT *,'       -ln_sco LN_SCO : pass the new value for ln_sco ( 1 or 0 ).'
     PRINT *,'                 If option not used, no changes.'
     PRINT *,'       -ln_zps LN_ZPS : pass the new value for ln_zps ( 1 or 0 ).'
     PRINT *,'                 If option not used, no changes.'
     PRINT *,'       -ln_zco LN_ZCO : pass the new value for ln_zco ( 1 or 0 ).'
     PRINT *,'                 If option not used, no changes.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       none' 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : Input file is modified on the output.'
     PRINT *,'      '
     STOP
  ENDIF

  ijarg = 1 
  DO WHILE ( ijarg <= narg )
     CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-d'   ) ; CALL getarg(ijarg, cf_domain ) ; ijarg=ijarg+1
        ! option
     CASE ( '-jperio'    ) ; CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1 ; READ(cldum,*) jperio ; ll_jperio=.TRUE.
     CASE ( '-jpiglo'    ) ; CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1 ; READ(cldum,*) jpiglo ; ll_jpiglo=.TRUE.
     CASE ( '-jpjglo'    ) ; CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1 ; READ(cldum,*) jpjglo ; ll_jpjglo=.TRUE.
     CASE ( '-jpkglo'    ) ; CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1 ; READ(cldum,*) jpkglo ; ll_jpkglo=.TRUE.

     CASE ( '-ln_isfcav' ) ; CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1 ; READ(cldum,*) jpisfcav ; ll_isfcav=.TRUE. 
     CASE ( '-ln_sco'    ) ; CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1 ; READ(cldum,*) jpsco    ; ll_sco=.TRUE.
     CASE ( '-ln_zps'    ) ; CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1 ; READ(cldum,*) jpzps    ; ll_zps=.TRUE.
     CASE ( '-ln_zco'    ) ; CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1 ; READ(cldum,*) jpzco    ; ll_zco=.TRUE.
     CASE DEFAULT    ; PRINT *, ' ERROR : ', TRIM(cldum),' : unknown option.'; STOP 1
     END SELECT
  ENDDO

  ierr = NF90_OPEN(cf_domain, NF90_WRITE,ncid)

  IF ( ll_jperio) THEN
     ierr = NF90_INQ_VARID(ncid,'jperio',id )
     ierr = NF90_PUT_VAR(ncid,id,jperio)
  ENDIF
  IF ( ll_jpiglo) THEN
     ierr = NF90_INQ_VARID(ncid,'jpiglo',id )
     ierr = NF90_PUT_VAR(ncid,id,jpiglo)
  ENDIF
  IF ( ll_jpjglo) THEN
     ierr = NF90_INQ_VARID(ncid,'jpjglo',id )
     ierr = NF90_PUT_VAR(ncid,id,jpjglo)
  ENDIF
  IF ( ll_jpkglo) THEN
     ierr = NF90_INQ_VARID(ncid,'jpkglo',id )
     ierr = NF90_PUT_VAR(ncid,id,jpkglo)
  ENDIF
  IF ( ll_isfcav) THEN
     ierr = NF90_INQ_VARID(ncid,'ln_isfcav',id )
     ierr = NF90_PUT_VAR(ncid,id,jpisfcav)
  ENDIF
  IF ( ll_sco) THEN
     ierr = NF90_INQ_VARID(ncid,'ln_sco',id )
     ierr = NF90_PUT_VAR(ncid,id,jpsco)
  ENDIF
  IF ( ll_zps) THEN
     ierr = NF90_INQ_VARID(ncid,'ln_zps',id )
     ierr = NF90_PUT_VAR(ncid,id,jpzps)
  ENDIF
  IF ( ll_zco) THEN
     ierr = NF90_INQ_VARID(ncid,'ln_zco',id )
     ierr = NF90_PUT_VAR(ncid,id,jpzco)
  ENDIF

  ierr = NF90_CLOSE(ncid) 


END PROGRAM cdf_domain_modif

PROGRAM cdfeddyscale_pass1
  !!======================================================================
  !!                     ***  PROGRAM  cdfeddyscale_pass1  ***
  !!=====================================================================
  !!  ** Purpose : Compute: - the curl and the square of curl on F-points, 
  !!                        - the gradient components of the curl and the
  !!                          square of the gradient components on UV-points
  !!                        - the square of velocity components on UV-points 
  !!               for given gridU gridV files and variables.
  !!               These terms will used to compute the Taylor scale or large
  !!               scale eddy (lambda1) and the small scale eddy (lambda2) 
  !!               in the program cdflambda.f90.
  !!
  !!  ** Method  : Use the same algorithm than NEMO
  !!
  !! History : 3.0  : 12/2013  : C.Q. Akuetevi (original)
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence
  !! @class energy_diagnostics
  !! (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE
  ! index of output variables
  INTEGER(KIND=4),                PARAMETER :: jp_nvar=8
  INTEGER(KIND=4),                PARAMETER :: jp_curl=1, jp_curl2=2, jp_dxcurl=3, jp_dycurl=4
  INTEGER(KIND=4),                PARAMETER :: jp_dxcurl2=5, jp_dycurl2=6, jp_u2=7, jp_v2=8

  INTEGER(KIND=4)                           :: ji, jj, jt         ! dummy loop index
  INTEGER(KIND=4)                           :: ilev=1             ! level to be processed
  INTEGER(KIND=4)                           :: npiglo, npjglo     ! size of the domain
  INTEGER(KIND=4)                           :: npk, npt           ! size of the domain
  INTEGER(KIND=4)                           :: narg, iargc, ijarg ! browse command line
  INTEGER(KIND=4)                           :: ncout, ierr        ! browse command line
  INTEGER(KIND=4), DIMENSION(jp_nvar)       :: ipk, id_varout     ! output variable properties

  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e1f, e2f           ! F-grid metrics
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e1u, e2u           ! zonal horizontal metrics
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e1v, e2v           ! meridional horizontal metrics
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: un, vn             ! velocity field
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: fmask              ! fmask

  REAL(KIND=8), DIMENSION(:),   ALLOCATABLE :: dtim               ! time counter
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dl_rotn, dl_rotn2  ! curl and square curl
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dxrotn, dyrotn     ! curl gradient components
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dxrotn2, dyrotn2   ! square curl gradient components
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dl_vozocrtx2       ! square of velocity components
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dl_vomecrty2       ! square of velocity components


  CHARACTER(LEN=256)                        :: cf_ufil, cf_vfil   ! file names
  CHARACTER(LEN=256)                        :: cf_out = 'lambda_int.nc' ! output file name
  CHARACTER(LEN=256)                        :: cv_u, cv_v         ! variable names
  CHARACTER(LEN=256)                        :: cldum              ! dummy string

  TYPE (variable), DIMENSION(jp_nvar)       :: stypvar            ! structure for attibutes

  LOGICAL                                   :: lchk     = .FALSE. ! flag for missing files
  LOGICAL                                   :: lperio   = .FALSE. ! flag for E-W periodicity
  LOGICAL                                   :: lnc4     = .FALSE. ! Use nc4 with chunking and deflation
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfeddyscale_pass1 -u U-file U-var -v -V-file V-var -l lev ...'
     PRINT *,'               ... [-o OUT-file] [-nc4]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'        This program computes some elements whose temporal mean is required'
     PRINT *,'        in the determination of the eddyscales (cf cdfeddyscale). These '
     PRINT *,'        elements are :'
     PRINT *,'              - the curl and the square of curl on F-points,' 
     PRINT *,'              - the gradient components of the curl and the'
     PRINT *,'                square of the gradient components on UV-points,'
     PRINT *,'              - the square of velocity components on UV-points,' 
     PRINT *,'      '
     PRINT *,'        They are computed for the set of U/V files given in arguments. '
     PRINT *,'        Therefore, for a particular experiment, the resulting files obtained'
     PRINT *,'        for a series of time-frames, need to be time-averaged (cdfmoy), before'
     PRINT *,'        using the final cdfeddyscale program, for the computation of the eddy'
     PRINT *,'        scales : Taylor scale (Large scale eddy --lambda1--), and small scale '
     PRINT *,'        eddy (lambda2).'
     PRINT *,'     '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -u U-file U-var: zonal component of the vector field:'
     PRINT *,'                 filename and variable name'
     PRINT *,'       -v V-file V-var: meridional component of the vector field:'
     PRINT *,'                 filename and variable name'
     PRINT *,'       -l lev : level to be processed.'
     PRINT *,'     '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-o OUT-file] : specify output file instead of ',TRIM(cf_out)
     PRINT *,'       [-nc4 ] : Use netcdf4 output with chunking and deflation level 1.'
     PRINT *,'                 This option is effective only if cdftools are compiled with'
     PRINT *,'                 a netcdf library supporting chunking and deflation.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        ', TRIM(cn_fhgr)
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out)
     PRINT *,'         variables : socurl (s^-1), socurl2 (s^-2)'
     PRINT *,'         variables : sodxcurl, sodycurl (s^-1.m^-1)'
     PRINT *,'         variables : sodxcurl2, sodycurl2 (s^-2.m^-2)'
     PRINT *,'         variables : vozocrtx2, vomecrty2 (m^2.s^-2)'
     PRINT *,'         WARNING : variables in the output file are not located at the same'
     PRINT *,'                 C-grid point.'
     PRINT *,'      '
     PRINT *,'     SEE ALSO : '
     PRINT *,'        cdfmoy, cdfeddyscale'
     STOP 
  ENDIF

  ijarg=1
  DO WHILE ( ijarg <= narg )
     CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-u'   ) ; CALL getarg(ijarg, cf_ufil ) ; ijarg=ijarg+1
        ;              CALL getarg(ijarg, cv_u    ) ; ijarg=ijarg+1
     CASE ( '-v'   ) ; CALL getarg(ijarg, cf_vfil ) ; ijarg=ijarg+1
        ;              CALL getarg(ijarg, cv_v    ) ; ijarg=ijarg+1
     CASE ( '-l'   ) ; CALL getarg(ijarg, cldum   ) ; ijarg=ijarg+1 ; READ(cldum,* ) ilev
        ! option
     CASE ( '-o'   ) ; CALL getarg(ijarg, cf_out  ) ; ijarg=ijarg+1
     CASE ( '-nc4' ) ; lnc4 = .TRUE.
     CASE DEFAULT    ; PRINT *, ' ERROR : ', TRIM(cldum),' : unknown option.'; STOP 99
     END SELECT
  ENDDO

  lchk = chkfile(cn_fhgr ) .OR. lchk
  lchk = chkfile(cf_ufil ) .OR. lchk
  lchk = chkfile(cf_vfil ) .OR. lchk
  IF ( lchk ) STOP 99 ! missing files

  ! load the dimension
  npiglo = getdim(cf_ufil,cn_x)
  npjglo = getdim(cf_ufil,cn_y)
  npk    = getdim(cf_ufil,cn_z)
  npt    = getdim(cf_ufil,cn_t)

  IF ( npk==0 ) THEN
     PRINT *, 'npk=0, assume 1'
     npk=1
  END IF

  IF ( npt==0 ) THEN
     PRINT *, 'npt=0, assume 1'
     npt=1
  END IF

  PRINT *, 'npiglo = ',npiglo
  PRINT *, 'npjglo = ',npjglo
  PRINT *, 'npk    = ',npk
  PRINT *, 'npt    = ',npt
  PRINT *, 'ilev   = ',ilev

  ! check files and determines if the curl will be 2D of 3D

  ! Allocate the memory
  ALLOCATE ( e1u(npiglo,npjglo)       , e2u(npiglo,npjglo)       )  
  ALLOCATE ( e1v(npiglo,npjglo)       , e2v(npiglo,npjglo)       )
  ALLOCATE ( e1f(npiglo,npjglo)       , e2f(npiglo,npjglo)       )
  ALLOCATE ( un(npiglo,npjglo)        , vn(npiglo,npjglo)        )
  ALLOCATE ( fmask(npiglo,npjglo)                                )
  ALLOCATE ( dtim(npt)                                           )
  ALLOCATE ( dl_rotn(npiglo,npjglo)   , dl_rotn2(npiglo,npjglo)  )
  ALLOCATE ( dxrotn(npiglo,npjglo)    , dyrotn(npiglo,npjglo)    )
  ALLOCATE ( dxrotn2(npiglo,npjglo)   , dyrotn2(npiglo,npjglo)   )
  ALLOCATE ( dl_vozocrtx2(npiglo,npjglo)                         )
  ALLOCATE ( dl_vomecrty2(npiglo,npjglo)                         )

  ! Read the metrics from the mesh_hgr file
  e1u =  getvar(cn_fhgr, cn_ve1u, 1, npiglo, npjglo)
  e2u =  getvar(cn_fhgr, cn_ve2u, 1, npiglo, npjglo)
  e1v =  getvar(cn_fhgr, cn_ve1v, 1, npiglo, npjglo)
  e2v =  getvar(cn_fhgr, cn_ve2v, 1, npiglo, npjglo)
  e1f =  getvar(cn_fhgr, cn_ve1f, 1, npiglo, npjglo)
  e2f =  getvar(cn_fhgr, cn_ve2f, 1, npiglo, npjglo)

  CALL CreateOutputFile 

  DO jt=1,npt
     IF (MOD(jt,100)==0 ) PRINT *, jt,'/',npt

     un(:,:) =  getvar(cf_ufil, cv_u, ilev ,npiglo,npjglo, ktime=jt)
     vn(:,:) =  getvar(cf_vfil, cv_v, ilev ,npiglo,npjglo, ktime=jt)

     ! compute the mask
     IF ( jt==1 ) THEN
        DO jj = 1, npjglo - 1
           DO ji = 1, npiglo - 1
              fmask(ji,jj)=0.
              fmask(ji,jj)= un(ji,jj)*un(ji,jj+1) * vn(ji,jj)*vn(ji+1,jj)
              IF (fmask(ji,jj) /= 0.) fmask(ji,jj)=1.
           ENDDO
        ENDDO
     END IF
     ! compute the curl
     dl_rotn(:,:) = 0.d0
     DO jj = 1, npjglo -1
        DO ji = 1, npiglo -1   ! vector opt.
           dl_rotn(ji,jj) = (  e2v(ji+1,jj  ) * vn(ji+1,jj  ) - e2v(ji,jj) *vn(ji,jj) &
                &            - e1u(ji  ,jj+1) * un(ji  ,jj+1) + e1u(ji,jj) *un(ji,jj)  ) &
                &         * fmask(ji,jj) / ( e1f(ji,jj) * e2f(ji,jj) )
        END DO
     END DO

     IF ( lperio ) dl_rotn(npiglo,:) = dl_rotn(2, :)

     ! compute the square curl
     dl_rotn2(:,:) = dl_rotn(:,:) * dl_rotn(:,:)

     ! compute the gradient components
     dxrotn(:,:) = 0.d0
     dyrotn(:,:) = 0.d0
     DO jj = 2, npjglo 
        DO ji = 2, npiglo    ! vector opt.
           dxrotn(ji,jj) = (dl_rotn(ji,jj) - dl_rotn(ji-1,jj))/e1v(ji,jj)
           dyrotn(ji,jj) = (dl_rotn(ji,jj) - dl_rotn(ji,jj-1))/e2u(ji,jj)
        END DO
     END DO

     IF ( lperio ) dxrotn(1,:) = dxrotn(npiglo-1, :)
     IF ( lperio ) dyrotn(1,:) = dyrotn(npiglo-1, :)

     ! compute the square module of the gradient
     dxrotn2(:,:) = dxrotn(:,:) * dxrotn(:,:)
     dyrotn2(:,:) = dyrotn(:,:) * dyrotn(:,:)

     ! compute the square of the velocity components
     dl_vozocrtx2(:,:) = un(:,:) * un(:,:) 
     dl_vomecrty2(:,:) = vn(:,:) * vn(:,:)

     ierr = putvar(ncout, id_varout(jp_curl),    REAL(dl_rotn),  1, npiglo, npjglo, ktime=jt)
     ierr = putvar(ncout, id_varout(jp_curl2),   REAL(dl_rotn2), 1, npiglo, npjglo, ktime=jt)
     ierr = putvar(ncout, id_varout(jp_dxcurl),  REAL(dxrotn),   1, npiglo, npjglo, ktime=jt)
     ierr = putvar(ncout, id_varout(jp_dycurl),  REAL(dyrotn),   1, npiglo, npjglo, ktime=jt)
     ierr = putvar(ncout, id_varout(jp_dxcurl2), REAL(dxrotn2),  1, npiglo, npjglo, ktime=jt)
     ierr = putvar(ncout, id_varout(jp_dycurl2), REAL(dyrotn2),  1, npiglo, npjglo, ktime=jt)
     ierr = putvar(ncout, id_varout(jp_u2),  REAL(dl_vozocrtx2), 1, npiglo, npjglo, ktime=jt)
     ierr = putvar(ncout, id_varout(jp_v2),  REAL(dl_vomecrty2), 1, npiglo, npjglo, ktime=jt)

  END DO  ! time loop
  ierr = closeout(ncout)
CONTAINS

  SUBROUTINE CreateOutputFile
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutputFile  ***
    !!
    !! ** Purpose :  Create output file 
    !!
    !! ** Method  :   Use global program variables 
    !!
    !!----------------------------------------------------------------------
    INTEGER :: jv
    !!----------------------------------------------------------------------
    DO jv=1, jp_nvar
       stypvar(jv)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    ENDDO
    ! define new variables for output
    ! Relative Vorticity F point
    ipk(jp_curl)                       = 1   !2D
    stypvar(jp_curl)%cname             = 'socurl'
    stypvar(jp_curl)%cunits            = 's-1'
    stypvar(jp_curl)%rmissing_value    = 0.
    stypvar(jp_curl)%valid_min         = -1000.
    stypvar(jp_curl)%valid_max         =  1000.
    stypvar(jp_curl)%clong_name        = 'Relative_Vorticity (curl)'
    stypvar(jp_curl)%cshort_name       = 'socurl'
    stypvar(jp_curl)%conline_operation = 'N/A'
    stypvar(jp_curl)%caxis             = 'TYX'

    ! Square of Relative Vorticity F point
    ipk(jp_curl2)                       = 1   !2D
    stypvar(jp_curl2)%cname             = 'socurl2'
    stypvar(jp_curl2)%cunits            = 's-2'
    stypvar(jp_curl2)%rmissing_value    = 0.
    stypvar(jp_curl2)%valid_min         = -1000.
    stypvar(jp_curl2)%valid_max         =  1000.
    stypvar(jp_curl2)%clong_name        = 'Square of Relative_Vorticity (curl2)'
    stypvar(jp_curl2)%cshort_name       = 'socurl2'
    stypvar(jp_curl2)%conline_operation = 'N/A'
    stypvar(jp_curl2)%caxis             = 'TYX'


    ! Relative Vorticity zonal gradient V point
    ipk(jp_dxcurl)                       = 1
    stypvar(jp_dxcurl)%cname             = 'sodxcurl'
    stypvar(jp_dxcurl)%cunits            = 'm-1*s-1'
    stypvar(jp_dxcurl)%rmissing_value    = 0.
    stypvar(jp_dxcurl)%valid_min         = -1000.
    stypvar(jp_dxcurl)%valid_max         =  1000.
    stypvar(jp_dxcurl)%clong_name        = 'Relative_Vorticity zonal gradient (dx_curl)'
    stypvar(jp_dxcurl)%cshort_name       = 'sodxcurl'
    stypvar(jp_dxcurl)%conline_operation = 'N/A'
    stypvar(jp_dxcurl)%caxis             = 'TYX'

    ! Relative Vorticity meridional gradient U point
    ipk(jp_dycurl)                       = 1
    stypvar(jp_dycurl)%cname             = 'sodycurl'
    stypvar(jp_dycurl)%cunits            = 'm-1*s-1'
    stypvar(jp_dycurl)%rmissing_value    = 0.
    stypvar(jp_dycurl)%valid_min         = -1000.
    stypvar(jp_dycurl)%valid_max         =  1000.
    stypvar(jp_dycurl)%clong_name        = 'Relative Vorticity meridional gradient (dy_curl)'
    stypvar(jp_dycurl)%cshort_name       = 'sodycurl'
    stypvar(jp_dycurl)%conline_operation = 'N/A'
    stypvar(jp_dycurl)%caxis             = 'TYX'

    ! Square of Relative Vorticity zonal gradient V point
    ipk(jp_dxcurl2)                       = 1
    stypvar(jp_dxcurl2)%cname             = 'sodxcurl2'
    stypvar(jp_dxcurl2)%cunits            = 'm-2*s-2'
    stypvar(jp_dxcurl2)%rmissing_value    = 0.
    stypvar(jp_dxcurl2)%valid_min         = -1000.
    stypvar(jp_dxcurl2)%valid_max         =  1000.
    stypvar(jp_dxcurl2)%clong_name        = 'Square Relative Vorticity zonal gradient (dx_curl2)'
    stypvar(jp_dxcurl2)%cshort_name       = 'sodxcurl2'
    stypvar(jp_dxcurl2)%conline_operation = 'N/A'
    stypvar(jp_dxcurl2)%caxis             = 'TYX'

    ! Square of Relative Vorticity meridional gradient U point
    ipk(jp_dycurl2)                       = 1
    stypvar(jp_dycurl2)%cname             = 'sodycurl2'
    stypvar(jp_dycurl2)%cunits            = 'm-2*s-2'
    stypvar(jp_dycurl2)%rmissing_value    = 0.
    stypvar(jp_dycurl2)%valid_min         = -1000.
    stypvar(jp_dycurl2)%valid_max         =  1000.
    stypvar(jp_dycurl2)%clong_name        = 'Square of Relative Vorticity meridional gradient (dy_curl2)'
    stypvar(jp_dycurl2)%cshort_name       = 'sodycurl2'
    stypvar(jp_dycurl2)%conline_operation = 'N/A'
    stypvar(jp_dycurl2)%caxis             = 'TYX'

    ! Square of Zonal Velocity V point
    ipk(jp_u2)                       = 1
    stypvar(jp_u2)%cname             = 'vozocrtx2'
    stypvar(jp_u2)%cunits            = 'm^2/s^2'
    stypvar(jp_u2)%rmissing_value    = 0.
    stypvar(jp_u2)%valid_min         = -10.
    stypvar(jp_u2)%valid_max         =  10.
    stypvar(jp_u2)%clong_name        = 'Square Zonal Velocity (vozocrtx2)'
    stypvar(jp_u2)%cshort_name       = 'vozocrtx2'
    stypvar(jp_u2)%conline_operation = 'N/A'
    stypvar(jp_u2)%caxis             = 'TYX'

    ! Square of Zonal Velocity V point
    ipk(jp_v2)                       = 1
    stypvar(jp_v2)%cname             = 'vomecrty2'
    stypvar(jp_v2)%cunits            = 'm^2/s^2'
    stypvar(jp_v2)%rmissing_value    = 0.
    stypvar(jp_v2)%valid_min         = -10.
    stypvar(jp_v2)%valid_max         =  10.
    stypvar(jp_v2)%clong_name        = 'Square Meridional Velocity (vomecrty2)'
    stypvar(jp_v2)%cshort_name       = 'vomecrty2'
    stypvar(jp_v2)%conline_operation = 'N/A'
    stypvar(jp_v2)%caxis             = 'TYX'

    ! use un and vn to store f latitude and longitude for output
    un = getvar(cn_fhgr, cn_glamf, 1, npiglo, npjglo)
    vn = getvar(cn_fhgr, cn_gphif, 1, npiglo, npjglo)

    ! look for  E-W periodicity
    IF ( un(1,1) == un(npiglo-1,1) ) lperio = .TRUE.

    ! create output fileset
    ncout = create      (cf_out, cf_ufil, npiglo,  npjglo, 0,         ld_nc4=lnc4 )
    ierr  = createvar   (ncout , stypvar, jp_nvar, ipk,    id_varout, ld_nc4=lnc4 )
    ierr  = putheadervar(ncout,  cf_ufil, npiglo,  npjglo, 0, pnavlon=un, pnavlat=vn )

    dtim = getvar1d(cf_ufil, cn_vtimec, npt      )
    ierr = putvar1d(ncout,   dtim,      npt,  'T')

  END SUBROUTINE CreateOutputFile

END PROGRAM cdfeddyscale_pass1

  PROGRAM cdfokubow
  !!---------------------------------------------------------------------------
  !!         ***  PROGRAM  cdfokubow ***
  !!
  !!  **  Purpose: Compute the okubow weiss parameter on F-points for given gridU gridV files and variables (like cdfcurl routine)
  !!
  !! history :
  !!   Original :  B. Djath (August 2012)
  !!---------------------------------------------------------------------
  !!  $Rev: 256 $
  !!  $Date: 2012-08-31 19:49:27 +0200 (ven. 31 aout 2012) $
  !! 
  !!--------------------------------------------------------------
  !! * Modules used
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! Copyright (c) 2012, B. Djath
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: ji, jj, jt                            ! dummy loop index
  INTEGER(KIND=4)                           :: ilev                                  ! level to be processed
  INTEGER(KIND=4)                           :: npiglo, npjglo                        ! size of the domain
  INTEGER(KIND=4)                           :: npk, npt                              ! size of the domain
  INTEGER(KIND=4)                           :: narg, iargc                           ! browse command line
  INTEGER(KIND=4)                           :: ncout, ierr                           ! browse command line
  INTEGER(KIND=4), DIMENSION(1)             :: ipk, id_varout                        ! output variable properties

  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e2v, e1u, e1f, e2f, e1t, e2t          ! horizontql metrics
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: un, vn                                ! velocity field
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zun, zvn                              ! working arrays
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: okubow, fmask, tmask                  ! curl and fmask
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: rotn, cisah1, cisah2t, cisah2         ! curl and fmask
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: tim                                   ! time counter

  CHARACTER(LEN=256)                        :: cf_ufil, cf_vfil                      ! file names
  CHARACTER(LEN=256)                        :: cf_out = 'okubow.nc'                  ! output file name
  CHARACTER(LEN=256)                        :: cv_u, cv_v                            ! variable names
  CHARACTER(LEN=256)                        :: cldum                                 ! dummy string

  TYPE (variable), DIMENSION(1)             :: stypvar                               ! structure for attibutes

  LOGICAL                                   :: lforcing = .FALSE.                    ! forcing flag
  LOGICAL                                   :: lchk     = .FALSE.                    ! flag for missing files
  LOGICAL                                   :: lperio   = .FALSE.                    ! flag for E-W periodicity
  !!----------------------------------------------------------------------------------
  CALL ReadCdfNames() 

  narg = iargc()
  IF ( narg /= 5 ) THEN
     PRINT *,' usage : cdfokubow U-file V-file U-var V-var lev'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute Okubo-Weiss parameter of a vector field, at a specified level.'  
     PRINT *,'       If level is specified as 0, assume that the input files are'
     PRINT *,'       forcing files, presumably on A-grid. In this latter case, the'
     PRINT *,'       vector field is interpolated on the C-grid. In any case, the'
     PRINT *,'       curl is computed on the F-point.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       U-file : zonal component of the vector field.'
     PRINT *,'       V-file : meridional component of the vector field.'
     PRINT *,'       U-var  : zonal component variable name'
     PRINT *,'       V-var  : meridional component variable name.'
     PRINT *,'       lev    : level to be processed. If set to 0, assume forcing file '
     PRINT *,'                in input.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        ', TRIM(cn_fhgr),' and ', TRIM(cn_fmsk)
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : sokubow (s^-2)'
     STOP
  ENDIF

  CALL getarg(1, cf_ufil)
  CALL getarg(2, cf_vfil)
  CALL getarg(3, cv_u   )
  CALL getarg(4, cv_v   )
  CALL getarg(5, cldum  ) ;  READ(cldum,*) ilev

  lchk = chkfile(cn_fhgr ) .OR. lchk
  lchk = chkfile(cn_fmsk ) .OR. lchk
  lchk = chkfile(cf_ufil ) .OR. lchk
  lchk = chkfile(cf_vfil ) .OR. lchk
  IF ( lchk ) STOP 99 ! missing files

  ! define new variables for output
  stypvar(1)%cname             = 'sokubow'
  stypvar(1)%cunits            = 's-2'
  stypvar(1)%rmissing_value    = 0.
  stypvar(1)%valid_min         = -1000.
  stypvar(1)%valid_max         =  1000.
  stypvar(1)%clong_name        = 'Okubo_Weiss_param (okubow)'
  stypvar(1)%cshort_name       = 'sokubow'
  stypvar(1)%conline_operation = 'N/A'
  stypvar(1)%caxis             = 'TYX'

  ipk(1) = 1  !  2D

  npiglo = getdim(cf_ufil,cn_x)
  npjglo = getdim(cf_ufil,cn_y)
  npk    = getdim(cf_ufil,cn_z)
  npt    = getdim(cf_ufil,cn_t) 

  PRINT *, 'npiglo = ',npiglo
  PRINT *, 'npjglo = ',npjglo
  PRINT *, 'npk    = ',npk
  PRINT *, 'npt    = ',npt
  PRINT *, 'ilev   = ',ilev

  !test if lev exists
  IF ( (npk==0) .AND. (ilev > 0) ) THEN
     PRINT *, 'Problem : npk = 0 and lev > 0 STOP'
     STOP 99
  END IF

  ! if forcing field 
  IF ( ilev==0 .AND. npk==0 ) THEN
     lforcing=.true.
     npk = 1 ; ilev=1
     PRINT *, 'npk =0, assume 1'
  END IF

  IF ( npt==0 ) THEN
     PRINT *, 'npt=0, assume 1'
     npt=1
  END IF
  ! check files and determines if the curl will be 2D of 3D
  ! ????????????

  ! Allocate the memory
  ALLOCATE ( e1u(npiglo,npjglo) , e1f(npiglo,npjglo) )
  ALLOCATE ( e2v(npiglo,npjglo) , e2f(npiglo,npjglo) )
  ALLOCATE ( e1t(npiglo,npjglo) , e2t(npiglo,npjglo) )
  ALLOCATE ( un(npiglo,npjglo)  , vn(npiglo,npjglo)  )
  ALLOCATE ( zun(npiglo,npjglo) , zvn(npiglo,npjglo) )
  ALLOCATE ( cisah1(npiglo,npjglo) , cisah2(npiglo,npjglo) )
  ALLOCATE ( cisah2t(npiglo,npjglo) , tmask(npiglo,npjglo) )
  ALLOCATE ( okubow(npiglo,npjglo) , fmask(npiglo,npjglo) )
  ALLOCATE ( rotn(npiglo,npjglo) , tim(npt) )

  e1u =  getvar(cn_fhgr, cn_ve1u, 1, npiglo, npjglo)
  e1f =  getvar(cn_fhgr, cn_ve1f, 1, npiglo, npjglo)
  e2v =  getvar(cn_fhgr, cn_ve2v, 1, npiglo, npjglo)
  e2f =  getvar(cn_fhgr, cn_ve2f, 1, npiglo, npjglo)
  e1t =  getvar(cn_fhgr, cn_ve1t, 1, npiglo, npjglo)
  e2t =  getvar(cn_fhgr, cn_ve2t, 1, npiglo, npjglo)

  ! use zun and zvn to store f latitude and longitude for output
  zun = getvar(cn_fhgr, cn_glamf, 1, npiglo, npjglo)
  zvn = getvar(cn_fhgr, cn_gphif, 1, npiglo, npjglo)

  ! look for  E-W periodicity
  IF ( zun(1,1) == zun(npiglo-1,1) ) lperio = .TRUE.

  ! create output fileset
  ncout = create      (cf_out, cf_ufil, npiglo, npjglo, 0                           )
  ierr  = createvar   (ncout , stypvar, 1,      ipk,    id_varout                   )
  ierr  = putheadervar(ncout,  cf_ufil, npiglo, npjglo, 0, pnavlon=zun, pnavlat=zvn )

  tim  = getvar1d(cf_ufil, cn_vtimec, npt      )
  ierr = putvar1d(ncout,   tim,       npt,  'T')
  
  DO jt=1,npt
     IF (MOD(jt,100)==0 ) PRINT *, jt,'/',npt
        ! if files are forcing fields
        zun(:,:) =  getvar(cf_ufil, cv_u, ilev ,npiglo,npjglo, ktime=jt)
        zvn(:,:) =  getvar(cf_vfil, cv_v, ilev ,npiglo,npjglo, ktime=jt)
        tmask(:,:) = getvar(cn_fmsk, 'tmask', ilev , npiglo, npjglo)

     IF ( lforcing ) THEN ! for forcing file u and v are on the A grid
        DO ji=1, npiglo-1
           un(ji,:) = 0.5*(zun(ji,:) + zun(ji+1,:))
        END DO
        !
        DO jj=1, npjglo-1
           vn(:,jj) = 0.5*(zvn(:,jj) + zvn(:,jj+1))
        END DO
        ! end compute u and v on U and V point
     ELSE
       un(:,:) = zun(:,:)
       vn(:,:) = zvn(:,:)
     END IF

     ! compute the mask
     IF ( jt==1 ) THEN
        DO jj = 1, npjglo - 1
           DO ji = 1, npiglo - 1
              fmask(ji,jj)=0.
              fmask(ji,jj)= un(ji,jj)*un(ji,jj+1) * vn(ji,jj)*vn(ji+1,jj)
              IF (fmask(ji,jj) /= 0.) fmask(ji,jj)=1.
           ENDDO
        ENDDO
     END IF

      rotn(:,:) = 0. ; cisah1(:,:) = 0. ; cisah2t(:,:) = 0. ; cisah2(:,:) = 0. ;okubow(:,:) = 0.
     DO jj = 1, npjglo -1 
        DO ji = 1, npiglo -1   ! vector opt.
           rotn(ji,jj) = (  e2v(ji+1,jj  ) * vn(ji+1,jj  ) - e2v(ji,jj) * vn(ji,jj)    &
                &         - e1u(ji  ,jj+1) * un(ji  ,jj+1) + e1u(ji,jj) * un(ji,jj)  ) &
                &         * fmask(ji,jj) / ( e1f(ji,jj) * e2f(ji,jj) )       ! quantity on f grid

           cisah1(ji,jj) = (  e2v(ji+1,jj  ) * vn(ji+1,jj  ) - e2v(ji,jj) * vn(ji,jj)    &
                &         + e1u(ji  ,jj+1) * un(ji  ,jj+1) - e1u(ji,jj) * un(ji,jj)  )   &
                &         * fmask(ji,jj) / ( e1f(ji,jj) * e2f(ji,jj) )       ! quantity on f grid

           cisah2t(ji,jj) = (  e1u(ji+1,jj  ) * un(ji+1,jj  ) - e1u(ji,jj) * un(ji,jj)    &
                &         - e2v(ji  ,jj+1) * vn(ji  ,jj+1) + e2v(ji,jj) * vn(ji,jj)  )    &
                &         * tmask(ji,jj) / ( e1t(ji,jj) * e2t(ji,jj) )      ! quantity on T grid
 
           cisah2(ji,jj)  = 0.25 * fmask(ji,jj) * ( cisah2t(ji,jj) * cisah2t(ji,jj)        &
                &         + cisah2t(ji+1,jj) * cisah2t(ji+1,jj) +  cisah2t(ji,jj+1)        &
                &         * cisah2t(ji,jj+1)  + cisah2t(ji+1,jj+1) * cisah2t(ji+1,jj+1) )       ! quantity computed on f grid

               okubow(ji,jj) = cisah1(ji,jj) * cisah1(ji,jj) + cisah2(ji,jj) - rotn(ji,jj)*rotn(ji,jj)

        END DO
     END DO

     IF ( lperio ) okubow(npiglo,:) = okubow(2, :)
     ! write rotn on file at level k and at time jt
     ierr = putvar(ncout, id_varout(1), okubow, 1, npiglo, npjglo, ktime=jt)
  END DO
  ierr = closeout(ncout)

END PROGRAM cdfokubow

PROGRAM cdffindij
  !!======================================================================
  !!                     ***  PROGRAM  cdffindij  ***
  !!=====================================================================
  !!  ** Purpose : Return the window index (imin imax jmin jmax )
  !!               for the geographical windows given on input 
  !!               (longmin longmax latmin matmax)
  !!
  !!  ** Method  : Read the coordinate/mesh_hgr file and look for the glam,
  !!               gphi variables.
  !!               Then use a search algorithm to find the corresponding I J
  !!               The point type ( T U V F ) is specified on the command 
  !!               line as well as the name of the coordinate/mesh hgr file.
  !!
  !! History : 2.1  : 11/2005  : J.M. Molines : Original code
  !!           3.0  : 12/2010  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE cdftools
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2010, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)    :: narg, iargc                ! command line
  INTEGER(KIND=4)    :: ijarg, ireq                ! command line
  INTEGER(KIND=4)    :: iimin, iimax, ijmin, ijmax ! model grid window

  REAL(KIND=4)       :: xmin, xmax, ymin, ymax     ! geographical window

  CHARACTER(LEN=256) :: cltype='F'                 ! point type to search for
  CHARACTER(LEN=256) :: cldum                      ! dummy character variable
  CHARACTER(LEN=256) :: clcoo                      ! dummy character variable
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()
  clcoo = cn_fcoo

  !!  Read command line and output usage message if not compliant.
  narg= iargc()
  IF ( narg < 4 ) THEN
     PRINT *,' usage :   cdffindij  xmin xmax ymin ymax  [-c COOR-file] [-p point_type]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Return the model limit (i,j space) of the geographical window ' 
     PRINT *,'       given on the input line.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       xmin xmax ymin ymax : geographical limits of the window, in lon/lat' 
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-c COOR-file ] : specify a particular coordinate file' 
     PRINT *,'                     default is ',TRIM(cn_fcoo)
     PRINT *,'       [-p point type] : specify the point on the C-grid (T U V F)'
     PRINT *,'                     default is ',TRIM(cltype)
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ', TRIM(cn_fcoo),' or the specified coordinates file.' 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       Output is done on standard output.'
     STOP
  ENDIF

  ijarg = 1 ; ireq = 0
  DO WHILE ( ijarg <= narg ) 
    CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1
    SELECT CASE ( cldum )
    CASE ( '-c' ) ; CALL getarg(ijarg, clcoo  ) ; ijarg=ijarg+1
    CASE ( '-p' ) ; CALL getarg(ijarg, cltype ) ; ijarg=ijarg+1
    CASE DEFAULT
       ireq=ireq+1
       SELECT CASE (ireq)
       CASE ( 1 ) ; READ(cldum,*) xmin
       CASE ( 2 ) ; READ(cldum,*) xmax
       CASE ( 3 ) ; READ(cldum,*) ymin
       CASE ( 4 ) ; READ(cldum,*) ymax
       CASE DEFAULT 
         PRINT *,' Too many arguments !' ; STOP
       END SELECT
    END SELECT
  END DO

  CALL cdf_findij ( xmin, xmax, ymin, ymax, iimin, iimax, ijmin, ijmax, cd_coord=clcoo, cd_point=cltype, cd_verbose='y')

END PROGRAM cdffindij

PROGRAM cdfimprovechk
  !!======================================================================
  !!                     ***  PROGRAM  cdfimprovechk  ***
  !!=====================================================================
  !!  ** Purpose : Estimate the improvement/deterioration of a test run, 
  !!               compared with a reference run relative to some observations
  !!
  !!  ** Method  : Given zobs (observed field), zref (reference run field)
  !!               and ztst (test run field), compute zchk as the ratio:
  !!                 zchk=(zref - ztst) / (zref - zobs )
  !!
  !!               Where  0 < zchk <=1 correction act in the right direction
  !!               Where  1 < zchk     correction is too strong, in the right way
  !!               Where  zchk < 0     correction is in the wrong way (deterioration)
  !!
  !! History : 2.1  : 11/2005  : J.M. Molines : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: jk, jt            ! dummy loop index
  INTEGER(KIND=4)                           :: ierr              ! working integer
  INTEGER(KIND=4)                           :: narg, iargc       ! browse line
  INTEGER(KIND=4)                           :: npiglo, npjglo    ! size of the domain
  INTEGER(KIND=4)                           :: npk, npt          ! size of the domain
  INTEGER(KIND=4)                           :: nvpk              ! dim of the working variable
  INTEGER(KIND=4)                           :: ncout             ! ncid of output file
  INTEGER(KIND=4), DIMENSION(1)             :: ipk, id_varout    ! levels and varid of output vars

  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zobs              ! observation array
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zref              ! reference array
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: ztst              ! test array
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zmask             ! 2D mask at surface
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zchk              ! check index output
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: tim               ! time counter

  CHARACTER(LEN=256)                        :: cf_obs            ! observation-file name
  CHARACTER(LEN=256)                        :: cf_ref            ! reference-file name
  CHARACTER(LEN=256)                        :: cf_tst            ! test-file name
  CHARACTER(LEN=256)                        :: cv_in             ! cdf variable name
  CHARACTER(LEN=256)                        :: cf_out='chk.nc'   ! output filename

  TYPE (variable), DIMENSION(1)             :: stypvar           ! structure for attributes

  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfimprovechk IN-var OBS-file REF-file TST-file'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'        Estimate the improvement/deterioration of a test run,'
     PRINT *,'        compared with a reference run relative to some observations'
     PRINT *,'        This program computes the quantity zchk= ( REF - TEST )/(REF - OBS)'
     PRINT *,'        Where 0 < zchk <= 1, the TST is better than the reference'
     PRINT *,'        Where 1 < zchk, the TST  was corrected in the right sense but too much'
     PRINT *,'        Where  zchk < 0, the TST  was corrected was corrected in the wrong way.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'        IN-var    : netcdf input variable'
     PRINT *,'        OBS-file  : netcdf observation file'
     PRINT *,'        REF-file  : netcdf reference file'
     PRINT *,'        TST-file  : netcdf test file'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       none' 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : same as input variable.'
     STOP
  ENDIF

  CALL getarg (1, cv_in )
  CALL getarg (2, cf_obs)
  CALL getarg (3, cf_ref)
  CALL getarg (4, cf_tst)

  IF ( chkfile(cf_obs) .OR. chkfile(cf_ref) .OR. chkfile(cf_tst) ) STOP ! missing files

  npiglo = getdim(cf_ref, cn_x)
  npjglo = getdim(cf_ref, cn_y)
  npk    = getdim(cf_ref, cn_z)
  npt    = getdim(cf_ref, cn_t)

  nvpk   = getvdim(cf_ref, cv_in)
  IF (nvpk == 2 ) nvpk = 1
  IF (nvpk == 3 ) nvpk = npk

  ipk(:)                       = nvpk  ! all variables 
  stypvar(1)%cname             = TRIM(cv_in)
  stypvar(1)%cunits            = '%'
  stypvar(1)%rmissing_value    = 0.
  stypvar(1)%valid_min         = 0.
  stypvar(1)%valid_max         = 100.
  stypvar(1)%clong_name        = 'Checking ratio for'//TRIM(cv_in)
  stypvar(1)%cshort_name       = cv_in
  stypvar(1)%conline_operation = 'N/A'

  IF (nvpk == npk ) stypvar(1)%caxis='TZYX'
  IF (nvpk == 1   ) stypvar(1)%caxis='TYX'


  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  ALLOCATE (zobs(npiglo,npjglo), zref(npiglo,npjglo), ztst(npiglo,npjglo), zmask(npiglo,npjglo))
  ALLOCATE (zchk(npiglo,npjglo), tim(npt) )

  ! create output fileset

  ncout = create      (cf_out, cf_ref,  npiglo, npjglo, npk       )
  ierr  = createvar   (ncout,  stypvar, 1,      ipk,    id_varout )
  ierr  = putheadervar(ncout,  cf_ref,  npiglo, npjglo, npk       )

  zref  = 0. ;   zobs  = 0. ;  zmask = 1.

  DO jt = 1,npt
     DO jk = 1,npk
        PRINT *,'level ',jk
        zchk = 0.
        zobs(:,:) = getvar(cf_obs, cv_in, jk ,npiglo, npjglo, ktime=jt)
        zref(:,:) = getvar(cf_ref, cv_in, jk ,npiglo, npjglo, ktime=jt)
        ztst(:,:) = getvar(cf_tst, cv_in, jk ,npiglo, npjglo, ktime=jt)

        IF (jk == 1  )  THEN
           WHERE( zref == 0. ) zmask = 0.
        END IF
        WHERE  ( (zref - zobs ) /= 0 ) 
           zchk = (zref - ztst ) / ( zref - zobs) * zmask
        END WHERE
        ierr = putvar(ncout, id_varout(1), zchk, jk, npiglo, npjglo, ktime=jt)

     END DO
  END DO

  tim  = getvar1d(cf_ref, cn_vtimec, npt     )
  ierr = putvar1d(ncout,  tim,       npt, 'T')

  ierr = closeout(ncout)

END PROGRAM cdfimprovechk

PROGRAM cdfmeshmask
  !!======================================================================
  !!                     ***  PROGRAM  cdfmeshmask  ***
  !!=====================================================================
  !!  ** Purpose : build mesh mask file from bathymetry
  !!
  !!  ** Method  : use nemo3.6 simplified zgr_xxx routines for zps
  !!               In this tools, for similarities with NEMO, NF90
  !!               functions are used in this program.
  !!
  !! History : 3.0  : 10/2014  : J.M. Molines 
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  !!   routines      : description
  !!----------------------------------------------------------------------
  USE netcdf
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class mask
  !!----------------------------------------------------------------------
  IMPLICIT NONE
  INTEGER, PARAMETER :: wp=8

  INTEGER :: narg, iargc, ijarg
  INTEGER :: npiglo, npjglo, nkmax
  INTEGER :: nbloc_sz=193  , nbloc=-1
  INTEGER, DIMENSION(:), ALLOCATABLE :: nbloc_szt, njbloct
  INTEGER, DIMENSION(:), ALLOCATABLE :: nblock_szt, nkbloct
  INTEGER :: jbloc, ij, i1, i2, ji     !
  INTEGER :: nperio = 0    ! closed boundary only for the time being
  INTEGER, DIMENSION(:,:), ALLOCATABLE :: mbathy

  INTEGER :: ierr
  INTEGER :: nczgr, nchgr, ncmsk, nccoo  ! ncdif of output files
  INTEGER :: id_dept1d, id_depw1d, id_e3t1d, id_e3w1d, id_dept, id_depw, id_e3t, id_e3w, id_mbat  ! zgr
  INTEGER :: id_e3u, id_e3v, id_hdept, id_hdepw, id_navlat, id_navlon, id_navlev, id_time
  INTEGER :: idx, idy, idz, idt, idvar
  INTEGER :: id_tmsk, id_umsk, id_vmsk, id_fmsk
  INTEGER :: id_tmsku, id_umsku, id_vmsku, id_fmsku

  INTEGER :: id_lamt, id_lamu, id_lamv, id_lamf    ! hgr  copy of coordinates  !!!
  INTEGER :: id_phit, id_phiu, id_phiv, id_phif 

  INTEGER :: id_tmask, id_umask, id_vmask, id_fmask  ! mask file

  REAL(wp) :: rhmin
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: bathy, rlon, rlat

  REAL(wp), DIMENSION(:),   ALLOCATABLE :: gdepw_1d, gdept_1d, e3w_1d, e3t_1d
  REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: gdept_0  ! npiglo, jbloc, jpk
  REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: gdepw_0  ! npiglo, jbloc, jpk
  REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: e3t_0    ! npiglo, jbloc, jpk  then npiglo, npjglo, kbloc
  REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: e3w_0    ! npiglo, jbloc, jpk  then npiglo, npjglo, kbloc
  REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: e3u_0    ! npiglo, jbloc, jpk  then npiglo, npjglo, kbloc
  REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: e3v_0    ! npiglo, jbloc, jpk  then npiglo, npjglo, kbloc
  REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: tmask    ! npiglo, npjglo, kbloc
  REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: umask    ! npiglo, npjglo, kbloc
  REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: vmask    ! npiglo, npjglo, kbloc
  REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: fmask    ! npiglo, npjglo, kbloc

  LOGICAL :: lchk=.FALSE.

  CHARACTER(LEN=80) :: cldum
  CHARACTER(LEN=80) :: cf_nam
  CHARACTER(LEN=80) :: cf_bat
  CHARACTER(LEN=80) :: cf_coo
  CHARACTER(LEN=80) :: cf_zgr = 'cdf_mesh_zgr.nc'
  CHARACTER(LEN=80) :: cf_hgr = 'cdf_mesh_hgr.nc'
  CHARACTER(LEN=80) :: cf_msk = 'cdf_mask.nc'

  INTEGER ::    jpk     , jpkm1
  INTEGER  ::   nn_bathy        !: = 0/1 ,compute/read the bathymetry file
  REAL(wp) ::   rn_bathy        !: depth of flat bottom (active if nn_bathy=0; if =0 depth=jpkm1)
  REAL(wp) ::   rn_hmin         !: minimum ocean depth (>0) or minimum number of ocean levels (<0)
  REAL(wp) ::   rn_e3zps_min    !: miminum thickness for partial steps (meters)
  REAL(wp) ::   rn_e3zps_rat    !: minimum thickness ration for partial steps
  INTEGER  ::   nn_msh          !: = 1 create a mesh-mask file
  INTEGER  ::   nn_acc          !: = 0/1 use of the acceleration of convergence technique
  REAL(wp) ::   rn_atfp         !: asselin time filter parameter
  REAL(wp) ::   rn_rdt          !: time step for the dynamics (and tracer if nacc=0)
  REAL(wp) ::   rn_rdtmin       !: minimum time step on tracers
  REAL(wp) ::   rn_rdtmax       !: maximum time step on tracers
  REAL(wp) ::   rn_rdth         !: depth variation of tracer step
  INTEGER  ::   nn_closea       !: =0 suppress closed sea/lake from the ORCA domain or not (=1)
  INTEGER  ::   nn_euler        !: =0 start with forward time step or not (=1)
  LOGICAL  ::   ln_crs          !: Apply grid coarsening to dynamical model output or online passive tracers

  INTEGER       ::   jphgr_msh        !: type of horizontal mesh
  !                                       !  = 0 curvilinear coordinate on the sphere read in coordinate.nc
  !                                       !  = 1 geographical mesh on the sphere with regular grid-spacing
  !                                       !  = 2 f-plane with regular grid-spacing
  !                                       !  = 3 beta-plane with regular grid-spacing
  !                                       !  = 4 Mercator grid with T/U point at the equator

  REAL(wp)      ::   ppglam0              !: longitude of first raw and column T-point (jphgr_msh = 1)
  REAL(wp)      ::   ppgphi0              !: latitude  of first raw and column T-point (jphgr_msh = 1)
  !                                                        !  used for Coriolis & Beta parameters (jphgr_msh = 2 or 3)
  REAL(wp)      ::   ppe1_deg             !: zonal      grid-spacing (degrees)
  REAL(wp)      ::   ppe2_deg             !: meridional grid-spacing (degrees)
  REAL(wp)      ::   ppe1_m               !: zonal      grid-spacing (degrees)
  REAL(wp)      ::   ppe2_m               !: meridional grid-spacing (degrees)

  REAL(wp)      ::   ppsur                !: ORCA r4, r2 and r05 coefficients
  REAL(wp)      ::   ppa0                 !: (default coefficients)
  REAL(wp)      ::   ppa1                 !:
  REAL(wp)      ::   ppkth                !:
  REAL(wp)      ::   ppacr                !:
  !
  !  If both ppa0 ppa1 and ppsur are specified to 0, then
  !  they are computed from ppdzmin, pphmax , ppkth, ppacr in dom_zgr
  REAL(wp)      ::   ppdzmin              !: Minimum vertical spacing
  REAL(wp)      ::   pphmax               !: Maximum depth
  !
  LOGICAL       ::   ldbletanh            !: Use/do not use double tanf function for vertical coordinates
  REAL(wp)      ::   ppa2                 !: Double tanh function parameters
  REAL(wp)      ::   ppkth2               !:
  REAL(wp)      ::   ppacr2               !:
  !-----------------------------------------------------------------------------
  narg=iargc()

  IF ( narg == 0 ) THEN
     PRINT *,' usage :  cdfmeshmask -n NAMELIST-file -b BATHY-file  -c COORD-file ...'
     PRINT *,'         ... [-njbloc nbloc] '
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Create mesh_mask from bathymetry and namdom information (namelist)' 
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -n NAMELIST-file : name of the namelist file (with NEMO namdom block)' 
     PRINT *,'       -b BATHY-file : name of bathymetry (meters)'
     PRINT *,'       -c COORD-file : name of coordinates file'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-njbloc nbloc]: number of j-bloc of rows to treat together. Increasing'
     PRINT *,'             nbloc decreases memory usage but increases writing time.'
     PRINT *,'            default : nbloc = npjglo (worst condition) '
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        namelist, bathymetry and coordinated passed on the command line' 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf files : ', TRIM(cf_zgr),' ', TRIM(cf_hgr),' and ', TRIM(cf_msk)
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'       '
     PRINT *,'      '
     STOP 
  ENDIF

  ijarg=1
  DO WHILE ( ijarg <= narg )
     CALL getarg(ijarg, cldum) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ('-n '    ) ; CALL getarg(ijarg,cf_nam) ; ijarg=ijarg+1
     CASE ('-b '    ) ; CALL getarg(ijarg,cf_bat) ; ijarg=ijarg+1
     CASE ('-c '    ) ; CALL getarg(ijarg,cf_coo) ; ijarg=ijarg+1
     CASE ('-njbloc') ; CALL getarg(ijarg,cldum ) ; ijarg=ijarg+1 ; READ(cldum,*) nbloc
     CASE DEFAULT     ; PRINT *,' ERROR : ',TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  ENDDO
  lchk = lchk .OR. chkfile(cf_nam) 
  lchk = lchk .OR. chkfile(cf_bat) 
  lchk = lchk .OR. chkfile(cf_coo) 
  IF ( lchk ) STOP 99 ! missing files

  npiglo = getdim(cf_coo, cn_x)
  npjglo = getdim(cf_coo, cn_y)
  IF ( nbloc == -1 ) nbloc = npjglo
  ! build nbloc_szt and njbloct
  ALLOCATE(  nbloc_szt(nbloc), njbloct(nbloc) )
  i1 = npjglo/nbloc
  i2 = MOD(npjglo, nbloc )
  nbloc_szt(1         :nbloc-i2) = i1
  nbloc_szt(nbloc-i2+1:nbloc   ) = i1+1
  njbloct(1) = 1
  DO ji=2, nbloc
     njbloct(ji) = njbloct(ji-1) + nbloc_szt(ji-1)
  ENDDO

  ALLOCATE (bathy(npiglo, npjglo ), rlon(npiglo, npjglo )  , rlat(npiglo, npjglo )  ) 
  ALLOCATE (mbathy(npiglo, npjglo )) 

  CALL zgr_z
  bathy(:,:) = getvar(cf_bat, cn_bathymet, 1, npiglo, npjglo)
  ! set minimum value here :
  IF( rn_hmin < 0._wp ) THEN ; nkmax = - INT( rn_hmin )                                       ! from a nb of level
  ELSE                       ; nkmax = MINLOC( gdepw_1d, mask = gdepw_1d > rn_hmin, dim = 1 ) ! from a depth
  ENDIF

  rhmin = gdepw_1d(nkmax+1)                                        ! minimum depth = ik+1 w-levels
  WHERE( bathy(:,:) <= 0._wp ) ; bathy(:,:) = 0._wp                         ! min=0     over the lands
ELSE WHERE                   ; bathy(:,:) = MAX(  rhmin , bathy(:,:)  )   ! min=rhmin over the oceans
END WHERE

PRINT *,  'Minimum ocean depth: ', rhmin, ' minimum number of ocean levels : ', nkmax

CALL zgr_zps

CONTAINS
SUBROUTINE zgr_z
  !!---------------------------------------------------------------------
  !!                  ***  ROUTINE zgr_z  ***
  !!
  !! ** Purpose :    set the depth of model levels and the resulting 
  !!         vertical scale factors.
  !!
  !! ** Method  :   from NEMO 3.6
  !!
  !! References :  
  !!----------------------------------------------------------------------
 INTEGER  ::   jk                     ! dummy loop indices
 INTEGER  ::   inum = 27              !
 REAL(wp) ::   zt, zw                 ! temporary scalars
 REAL(wp) ::   zsur, za0, za1, zkth   ! Values set from parameters in
 REAL(wp) ::   zacr, zdzmin, zhmax    ! par_CONFIG_Rxx.h90
 REAL(wp) ::   zrefdep                ! depth of the reference level (~10m)
 REAL(wp) ::   za2, zkth2, zacr2      ! Values for optional double tanh function set from parameters 

 NAMELIST/namdom/ jpk, nn_bathy , rn_bathy, rn_e3zps_min, rn_e3zps_rat, nn_msh    , rn_hmin, &
      &             nn_acc   , rn_atfp     , rn_rdt      , rn_rdtmin,           &
      &             rn_rdtmax, rn_rdth     , nn_closea , ln_crs,    &
      &             jphgr_msh, &
      &             ppglam0, ppgphi0, ppe1_deg, ppe2_deg, ppe1_m, ppe2_m, &
      &             ppsur, ppa0, ppa1, ppkth, ppacr, ppdzmin, pphmax, ldbletanh, &
      &             ppa2, ppkth2, ppacr2
 !! -----------------------------------------------------------------------------------------
 OPEN(inum, FILE=cf_nam)
 READ(inum, namdom)
 CLOSE(inum)
 jpkm1=jpk-1

 ! build nbloc_szt and njbloct
 ALLOCATE(  nblock_szt(nbloc), nkbloct(nbloc) )
 i1 = jpk/nbloc
 i2 = MOD(jpk, nbloc )
 nblock_szt(1         :nbloc-i2) = i1
 nblock_szt(nbloc-i2+1:nbloc   ) = i1+1
 nkbloct(1) = 1
 DO ji=2, nbloc
    nkbloct(ji) = nkbloct(ji-1) + nblock_szt(ji-1)
 ENDDO

 ALLOCATE (gdept_1d(jpk), gdepw_1d(jpk), e3t_1d(jpk), e3w_1d(jpk) )

 ! Set variables from parameters
 ! ------------------------------
 zkth = ppkth       ;   zacr = ppacr
 zdzmin = ppdzmin   ;   zhmax = pphmax
 zkth2 = ppkth2     ;   zacr2 = ppacr2   ! optional (ldbletanh=T) double tanh parameters

 IF(   ppa1  == 999    .AND.  &
      &  ppa0  == 999  .AND.  &
      &  ppsur == 999         ) THEN
    !
    za1  = (  ppdzmin - pphmax / FLOAT(jpkm1)  )                                                      &
         & / ( TANH((1-ppkth)/ppacr) - ppacr/FLOAT(jpk-1) * (  LOG( COSH( (jpk - ppkth) / ppacr) )      &
         &                                                   - LOG( COSH( ( 1  - ppkth) / ppacr) )  )  )
    za0  = ppdzmin - za1 *              TANH( (1-ppkth) / ppacr )
    zsur =   - za0 - za1 * ppacr * LOG( COSH( (1-ppkth) / ppacr )  )
 ELSE
    za1 = ppa1 ;       za0 = ppa0 ;          zsur = ppsur
    za2 = ppa2                            ! optional (ldbletanh=T) double tanh parameter
 ENDIF

 IF( .NOT. ldbletanh ) THEN
    DO jk = 1, jpk
       zw = REAL( jk , wp )
       zt = REAL( jk , wp ) + 0.5_wp
       gdepw_1d(jk) = ( zsur + za0 * zw + za1 * zacr * LOG ( COSH( (zw-zkth) / zacr ) )  )
       gdept_1d(jk) = ( zsur + za0 * zt + za1 * zacr * LOG ( COSH( (zt-zkth) / zacr ) )  )
       e3w_1d  (jk) =          za0      + za1        * TANH(       (zw-zkth) / zacr   )
       e3t_1d  (jk) =          za0      + za1        * TANH(       (zt-zkth) / zacr   )
    END DO
 ELSE
    DO jk = 1, jpk
       zw = FLOAT( jk )
       zt = FLOAT( jk ) + 0.5_wp
       ! Double tanh function
       gdepw_1d(jk) = ( zsur + za0 * zw + za1 * zacr * LOG ( COSH( (zw-zkth ) / zacr  ) )    &
            &                             + za2 * zacr2* LOG ( COSH( (zw-zkth2) / zacr2 ) )  )
       gdept_1d(jk) = ( zsur + za0 * zt + za1 * zacr * LOG ( COSH( (zt-zkth ) / zacr  ) )    &
            &                             + za2 * zacr2* LOG ( COSH( (zt-zkth2) / zacr2 ) )  )
       e3w_1d  (jk) =          za0      + za1        * TANH(       (zw-zkth ) / zacr  )      &
            &                             + za2        * TANH(       (zw-zkth2) / zacr2 )
       e3t_1d  (jk) =          za0      + za1        * TANH(       (zt-zkth ) / zacr  )      &
            &                             + za2        * TANH(       (zt-zkth2) / zacr2 )
    END DO
 ENDIF
 gdepw_1d(1) = 0._wp                    ! force first w-level to be exactly at zero
 CALL CreateMeshZgrFile
 CALL CreateMaskFile

END SUBROUTINE zgr_z

SUBROUTINE zgr_zps
  !!----------------------------------------------------------------------
  !!                  ***  ROUTINE zgr_zps  ***
  !!                     
  !! ** Purpose :   the depth and vertical scale factor in partial step
  !!      z-coordinate case
  !!
  !! ** Method  :   Partial steps : computes the 3D vertical scale factors
  !!      of T-, U-, V-, W-, UW-, VW and F-points that are associated with
  !!      a partial step representation of bottom topography.
  !!----------------------------------------------------------------------
 INTEGER  ::   ji, jj, jk       ! dummy loop indices
 INTEGER  ::   ik, it           ! temporary integers
 LOGICAL  ::   ll_print         ! Allow  control print for debugging
 REAL(wp) ::   ze3tp , ze3wp    ! Last ocean level thickness at T- and W-points
 REAL(wp) ::   zdepwp, zdepth   ! Ajusted ocean depth to avoid too small e3t
 REAL(wp) ::   zmax             ! Maximum depth
 REAL(wp) ::   zdiff            ! temporary scalar
 REAL(wp) ::   zrefdep          ! temporary scalar
 REAL(wp), DIMENSION(:,:), ALLOCATABLE :: zdep
 !!----------------------------------------------------------------------


 zmax = gdepw_1d(jpk) + e3t_1d(jpk)        ! maximum depth (i.e. the last ocean level thickness <= 2*e3t_1d(jpkm1) )
 bathy(:,:) = MIN( zmax ,  bathy(:,:) )    ! bounded value of bathy (min already set at the end of zgr_bat)

 WHERE( bathy(:,:) == 0._wp )   
    mbathy(:,:) = 0       ! land  : set mbathy to 0
 ELSE WHERE                     
    mbathy(:,:) = jpkm1   ! ocean : initialize mbathy to the max ocean level
 END WHERE

 ! Compute mbathy for ocean points (i.e. the number of ocean levels)
 ! find the number of ocean levels such that the last level thickness
 ! is larger than the minimum of e3zps_min and e3zps_rat * e3t_1d (where
 ! e3t_1d is the reference level thickness
 DO jk = jpkm1, 1, -1
    zdepth = gdepw_1d(jk) + MIN( rn_e3zps_min, e3t_1d(jk)*rn_e3zps_rat )
    WHERE( 0._wp < bathy(:,:) .AND. bathy(:,:) <= zdepth )   mbathy(:,:) = jk-1
 END DO

 CALL zgr_bat_ctl

 ! compute mask from mbathy : for writing performance and memory management, each mask is computed
 !  and written on file sequentially. Thus repeating  tmask determination (cheap)
 DO jbloc=1, nbloc
    nbloc_sz = nblock_szt(jbloc)
    ALLOCATE ( tmask(npiglo, npjglo,nbloc_sz) )
    tmask(:,:,:) = 0._wp
    DO jk = 1, nbloc_sz
       ik = nkbloct(jbloc) +jk -1
       PRINT *, 'T Masks for jk = ', ik
       DO jj = 1, npjglo
          DO ji = 1, npiglo
             IF( REAL( mbathy(ji,jj) - ik, wp ) + 0.1_wp >= 0._wp )   tmask(ji,jj,jk) = 1._wp
          END DO
       END DO
       IF ( ik == 1 ) THEN
          ierr = NF90_PUT_VAR( ncmsk, id_tmsku, tmask(:,:,1),    start=(/1,1,1/), count=(/npiglo,npjglo,1/) )
          IF ( ierr /= NF90_NOERR ) THEN  ; PRINT *, NF90_STRERROR(ierr) ; STOP 99 ;
          ENDIF
       ENDIF
    ENDDO
    ierr = NF90_PUT_VAR( ncmsk, id_tmsk, tmask,    start=(/1,1,nkbloct(jbloc),1/), count=(/npiglo,npjglo,nbloc_sz,1/) )
    IF ( ierr /= NF90_NOERR ) THEN  ; PRINT *, NF90_STRERROR(ierr) ; STOP 99 ; 
    ENDIF
    DEALLOCATE ( tmask )
 ENDDO ! bloc

 DO jbloc=1, nbloc
    nbloc_sz = nblock_szt(jbloc)
    ALLOCATE ( tmask(npiglo, npjglo,nbloc_sz) )
    ALLOCATE ( umask(npiglo, npjglo,nbloc_sz) )
    tmask(:,:,:) = 0._wp
    umask(:,:,:) = 0._wp
    DO jk = 1, nbloc_sz
       ik = nkbloct(jbloc) +jk -1
       PRINT *, 'U Masks for jk = ', ik
       DO jj = 1, npjglo
          DO ji = 1, npiglo
             IF( REAL( mbathy(ji,jj) - ik, wp ) + 0.1_wp >= 0._wp )   tmask(ji,jj,jk) = 1._wp
          END DO
       END DO
       DO jj = 1, npjglo -1
          DO ji = 1, npiglo -1
             umask(ji,jj,jk) = tmask(ji,jj,jk) * tmask(ji+1,jj,jk  )
          ENDDO
       ENDDO
       IF ( ik == 1 ) THEN
          ierr = NF90_PUT_VAR( ncmsk, id_umsku, umask(:,:,1),    start=(/1,1,1/), count=(/npiglo,npjglo,1/) )
          IF ( ierr /= NF90_NOERR ) THEN  ; PRINT *, NF90_STRERROR(ierr) ; STOP 99 ;
          ENDIF
       ENDIF
    ENDDO
    ierr = NF90_PUT_VAR( ncmsk, id_umsk, umask,    start=(/1,1,nkbloct(jbloc),1/), count=(/npiglo,npjglo,nbloc_sz,1/) )
    IF ( ierr /= NF90_NOERR ) THEN  ; PRINT *, NF90_STRERROR(ierr) ; STOP 99 ;
    ENDIF
    DEALLOCATE ( tmask , umask)
 ENDDO
 DO jbloc=1, nbloc
    nbloc_sz = nblock_szt(jbloc)
    ALLOCATE ( tmask(npiglo, npjglo,nbloc_sz) )
    ALLOCATE ( vmask(npiglo, npjglo,nbloc_sz) )
    tmask(:,:,:) = 0._wp
    vmask(:,:,:) = 0._wp

    DO jk = 1, nbloc_sz
       ik = nkbloct(jbloc) +jk -1
       PRINT *, 'V Masks for jk = ', ik
       DO jj = 1, npjglo
          DO ji = 1, npiglo
             IF( REAL( mbathy(ji,jj) - ik, wp ) + 0.1_wp >= 0._wp )   tmask(ji,jj,jk) = 1._wp
          END DO
       END DO
       DO jj = 1, npjglo -1
          DO ji = 1, npiglo -1
             vmask(ji,jj,jk) = tmask(ji,jj,jk) * tmask(ji  ,jj+1,jk)
          ENDDO
       ENDDO
       IF ( ik == 1 ) THEN
          ierr = NF90_PUT_VAR( ncmsk, id_vmsku, vmask(:,:,1),    start=(/1,1,1/), count=(/npiglo,npjglo,1/) )
          IF ( ierr /= NF90_NOERR ) THEN  ; PRINT *, NF90_STRERROR(ierr) ; STOP 99 ;
          ENDIF
       ENDIF
    ENDDO
    ierr = NF90_PUT_VAR( ncmsk, id_vmsk, vmask,    start=(/1,1,nkbloct(jbloc),1/), count=(/npiglo,npjglo,nbloc_sz,1/) )
    IF ( ierr /= NF90_NOERR ) THEN  ; PRINT *, NF90_STRERROR(ierr) ; STOP 99 ;
    ENDIF
    DEALLOCATE ( tmask , vmask)
 ENDDO

 DO jbloc=1, nbloc
    nbloc_sz = nblock_szt(jbloc)
    ALLOCATE ( tmask(npiglo, npjglo,nbloc_sz) )
    ALLOCATE ( fmask(npiglo, npjglo,nbloc_sz) )
    tmask(:,:,:) = 0._wp
    fmask(:,:,:) = 0._wp

    DO jk = 1, nbloc_sz
       ik = nkbloct(jbloc) +jk -1
       PRINT *, 'F Masks for jk = ', ik
       DO jj = 1, npjglo
          DO ji = 1, npiglo
             IF( REAL( mbathy(ji,jj) - ik, wp ) + 0.1_wp >= 0._wp )   tmask(ji,jj,jk) = 1._wp
          END DO
       END DO
       DO jj = 1, npjglo -1
          DO ji = 1, npiglo -1
             fmask(ji,jj,jk) = tmask(ji,jj,jk  ) * tmask(ji+1,jj,jk  )   &
                  &  * tmask(ji,jj+1,jk) * tmask(ji+1,jj+1,jk)
          ENDDO
       ENDDO
       IF ( ik == 1 ) THEN
          ierr = NF90_PUT_VAR( ncmsk, id_fmsku, fmask(:,:,1),    start=(/1,1,1/), count=(/npiglo,npjglo,1/) )
          IF ( ierr /= NF90_NOERR ) THEN  ; PRINT *, NF90_STRERROR(ierr) ; STOP 99 ;
          ENDIF
       ENDIF
    ENDDO
    ierr = NF90_PUT_VAR( ncmsk, id_fmsk, fmask,    start=(/1,1,nkbloct(jbloc),1/), count=(/npiglo,npjglo,nbloc_sz,1/) )
    IF ( ierr /= NF90_NOERR ) THEN  ; PRINT *, NF90_STRERROR(ierr) ; STOP 99 ;
    ENDIF
    DEALLOCATE ( tmask , fmask)
 ENDDO

 ierr = NF90_CLOSE(ncmsk)

 ! Now work for vertical metrics
 DO jbloc=1,nbloc
    PRINT *, ' WORKING for jbloc-slab ', jbloc
    nbloc_sz = nbloc_szt(jbloc)
    ALLOCATE ( gdept_0(npiglo,nbloc_sz, jpk) )
    ALLOCATE ( gdepw_0(npiglo,nbloc_sz, jpk) )
    ALLOCATE ( zdep(npiglo,nbloc_sz) )
    ALLOCATE ( e3t_0(npiglo,nbloc_sz, jpk) )
    ALLOCATE ( e3w_0(npiglo,nbloc_sz, jpk) )
    DO jk=1, jpk
       gdept_0(:,:,jk) = gdept_1d(jk)
       gdepw_0(:,:,jk) = gdepw_1d(jk)
       e3t_0  (:,:,jk) = e3t_1d  (jk)
       e3w_0  (:,:,jk) = e3w_1d  (jk)
    ENDDO
    DO jj=1, nbloc_sz
       ij=njbloct(jbloc) + jj - 1
       DO ji=1, npiglo
          ik = mbathy(ji,ij)
          IF( ik > 0 ) THEN               ! ocean point only
             ! max ocean level case
             IF( ik == jpkm1 ) THEN
                zdepwp = bathy(ji,ij)
                ze3tp  = bathy(ji,ij) - gdepw_1d(ik)
                ze3wp = 0.5_wp * e3w_1d(ik) * ( 1._wp + ( ze3tp/e3t_1d(ik) ) )
                e3t_0(ji,jj,ik  ) = ze3tp
                e3t_0(ji,jj,ik+1) = ze3tp
                e3w_0(ji,jj,ik  ) = ze3wp
                e3w_0(ji,jj,ik+1) = ze3tp
                gdepw_0(ji,jj,ik+1) = zdepwp
                gdept_0(ji,jj,ik  ) = gdept_1d(ik-1) + ze3wp
                gdept_0(ji,jj,ik+1) = gdept_0(ji,jj,ik) + ze3tp
                !
             ELSE                         ! standard case
                IF( bathy(ji,ij) <= gdepw_1d(ik+1) ) THEN  ;   gdepw_0(ji,jj,ik+1) = bathy(ji,ij)
                ELSE                                       ;   gdepw_0(ji,jj,ik+1) = gdepw_1d(ik+1)
                ENDIF
                !       ... on ik
                gdept_0(ji,jj,ik) = gdepw_1d(ik) + ( gdepw_0   (ji,jj,ik+1) - gdepw_1d(ik) )   &
                     &                          * ((gdept_1d(     ik  ) - gdepw_1d(ik) )   &
                     &                           /( gdepw_1d(     ik+1) - gdepw_1d(ik) ))
                e3t_0(ji,jj,ik) = e3t_1d (ik)    * ( gdepw_0   (ji,jj,ik+1) - gdepw_1d(ik) )   &
                     &                          / ( gdepw_1d(     ik+1) - gdepw_1d(ik) )
                e3w_0(ji,jj,ik) = 0.5_wp * ( gdepw_0(ji,jj,ik+1) + gdepw_1d(ik+1) - 2._wp * gdepw_1d(ik) )   &
                     &                  * ( e3w_1d(ik) / ( gdepw_1d(ik+1) - gdepw_1d(ik) ) )
                !       ... on ik+1
                e3w_0  (ji,jj,ik+1) = e3t_0  (ji,jj,ik)
                e3t_0  (ji,jj,ik+1) = e3t_0  (ji,jj,ik)
                gdept_0(ji,jj,ik+1) = gdept_0(ji,jj,ik) + e3t_0(ji,jj,ik)
             ENDIF
          ENDIF
       END DO
    ENDDO

    ! write mesh_zgr here with gdept_0, gdepw_0, e3t_0, e3w_0 only
    ! do it quick and dirty at this time ...
    ! write vertical slab (maybe slow but save lot of memory
    DO jj=1, nbloc_sz
       !         ij=(jbloc -1 )*nbloc_sz +jj
       ij=njbloct(jbloc) + jj - 1
       DO ji = 1, npiglo
          ik=MAX( mbathy(ji,ij),1)
          zdep(ji,jj)=gdept_0(ji,jj,ik) 
       ENDDO
    ENDDO
    ierr = NF90_PUT_VAR( nczgr, id_hdept, zdep,    start=(/1,(jbloc-1)*nbloc_sz+1  ,1/), count=(/npiglo,nbloc_sz    ,1/) )

    DO jj=1, nbloc_sz
       !         ij=(jbloc -1 )*nbloc_sz +jj
       ij=njbloct(jbloc) + jj - 1
       DO ji = 1, npiglo
          ik=MAX( mbathy(ji,ij),1)
          zdep(ji,jj)=gdepw_0(ji,jj,ik+1) 
       ENDDO
    ENDDO
    ierr = NF90_PUT_VAR( nczgr, id_hdepw, zdep,    start=(/1,(jbloc-1)*nbloc_sz+1  ,1/), count=(/npiglo,nbloc_sz    ,1/) )

    ierr = NF90_PUT_VAR( nczgr, id_e3t, e3t_0,    start=(/1,(jbloc-1)*nbloc_sz+1,1,1/), count=(/npiglo,nbloc_sz,jpk,1/) )
    ierr = NF90_PUT_VAR( nczgr, id_e3w, e3w_0,    start=(/1,(jbloc-1)*nbloc_sz+1,1,1/), count=(/npiglo,nbloc_sz,jpk,1/) )

    DEALLOCATE ( gdept_0,  gdepw_0, zdep, e3t_0,  e3w_0 )
 END DO
 ierr = NF90_CLOSE(nczgr )

 ! re open mesh_zgr in order to read e3t, e3w horizontally and compute e3u, e3v level by level
 !  use rlon, rlat as temporary arrays for e3t, e3w, e3u, e3v ...
 ierr = NF90_OPEN(cf_zgr,NF90_WRITE,nczgr )
 ierr = NF90_INQ_VARID(nczgr,'e3t',id_e3t )
 ierr = NF90_INQ_VARID(nczgr,'e3w',id_e3w ) 
 ierr = NF90_INQ_VARID(nczgr,'e3u',id_e3u )
 ierr = NF90_INQ_VARID(nczgr,'e3v',id_e3v )

 DO jbloc=1, nbloc
    nbloc_sz = nblock_szt(jbloc)
    ALLOCATE ( e3t_0(npiglo, npjglo,nbloc_sz) )
    ALLOCATE ( e3u_0 (npiglo, npjglo,nbloc_sz) )
    ierr= NF90_GET_VAR( nczgr, id_e3t, e3t_0, start=(/1,1,nkbloct(jbloc),1/), count=(/npiglo,npjglo,nbloc_sz,1/) )

    DO jk = 1, nbloc_sz
       ik = nkbloct(jbloc) +jk -1
       PRINT *,' e3u at level ', ik
       e3u_0(:,:,jk) =  e3t_1d(ik)
       DO jj=1,npjglo - 1
          DO ji=1,npiglo -1
             e3u_0(ji,jj,jk) = MIN( e3t_0(ji,jj,jk), e3t_0(ji+1,jj,jk) )
          ENDDO
       ENDDO
       !         ierr = NF90_PUT_VAR(nczgr, id_e3u, e3u_0, start=(/1,1,ik,1/), count=(/npiglo,npjglo,1,1/) )
    ENDDO
    ierr = NF90_PUT_VAR(nczgr, id_e3u, e3u_0, start=(/1,1,nkbloct(jbloc),1/), count=(/npiglo,npjglo,nbloc_sz,1/) )
    DEALLOCATE (e3t_0, e3u_0 )
 ENDDO

 DO jbloc=1, nbloc
    nbloc_sz = nblock_szt(jbloc)
    ALLOCATE ( e3t_0(npiglo, npjglo,nbloc_sz) )
    ALLOCATE ( e3v_0 (npiglo, npjglo,nbloc_sz) )
    ierr= NF90_GET_VAR( nczgr, id_e3t, e3t_0, start=(/1,1,nkbloct(jbloc),1/), count=(/npiglo,npjglo,nbloc_sz,1/) )

    DO jk = 1, nbloc_sz
       ik = nkbloct(jbloc) +jk -1
       PRINT *,' e3v at level ', ik
       e3v_0(:,:,jk) =  e3t_1d(ik)
       DO jj=1,npjglo - 1
          DO ji=1,npiglo -1
             e3v_0(ji,jj,jk) = MIN( e3t_0(ji,jj,jk), e3t_0(ji,jj+1,jk) )
          ENDDO
       ENDDO
       PRINT * , 'e3v_0 (81,2)  e3t_0(81,2), (81,3)', e3v_0(81,2,jk), e3t_0(81,2,jk) ,e3t_0(81,3,jk) 
       !          ierr = NF90_PUT_VAR(nczgr, id_e3v, e3v_0, start=(/1,1,ik,1/), count=(/npiglo,npjglo,1,1/) )
    ENDDO
    ierr = NF90_PUT_VAR(nczgr, id_e3v, e3v_0, start=(/1,1,nkbloct(jbloc),1/), count=(/npiglo,npjglo,nbloc_sz,1/) )
    DEALLOCATE (e3t_0, e3v_0 )
 ENDDO

 ierr = NF90_CLOSE(nczgr )

END SUBROUTINE zgr_zps

SUBROUTINE zgr_bat_ctl
  !!----------------------------------------------------------------------
  !!                    ***  ROUTINE zgr_bat_ctl  ***
  !!
  !! ** Purpose :   check the bathymetry in levels
  !!
  !! ** Method  :   The array mbathy is checked to verified its consistency
  !!      with the model options. in particular:
  !!            mbathy must have at least 1 land grid-points (mbathy<=0)
  !!                  along closed boundary.
  !!            mbathy must be cyclic IF jperio=1.
  !!            mbathy must be lower or equal to jpk-1.
  !!            isolated ocean grid points are suppressed from mbathy
  !!                  since they are only connected to remaining
  !!                  ocean through vertical diffusion.
  !!      C A U T I O N : mbathy will be modified during the initializa-
  !!      tion phase to become the number of non-zero w-levels of a water
  !!      column, with a minimum value of 1.
  !!
  !! ** Action  : - update mbathy: level bathymetry (in level index)
  !!              - update bathy : meter bathymetry (in meters)
  !!----------------------------------------------------------------------
  !!
 INTEGER ::   ji, jj, jl                    ! dummy loop indices
 INTEGER ::   icompt, ibtest, ikmax         ! temporary integers
 !!----------------------------------------------------------------------
 icompt = 0
 DO jl = 1, 2
    IF( nperio == 1 .OR. nperio  ==  4 .OR. nperio  ==  6 ) THEN
       mbathy( 1 ,:) = mbathy(npiglo-1,:)           ! local domain is cyclic east-west
       mbathy(npiglo,:) = mbathy(  2  ,:)
    ENDIF
    DO jj = 2, npjglo-1
       DO ji = 2, npiglo-1
          ibtest = MAX(  mbathy(ji-1,jj), mbathy(ji+1,jj),   &
               &           mbathy(ji,jj-1), mbathy(ji,jj+1)  )
          IF( ibtest < mbathy(ji,jj) ) THEN
             PRINT *, ' the number of ocean level at ',   &
                  &   'grid-point (i,j) =  ',ji,jj,' is changed from ', mbathy(ji,jj),' to ', ibtest
             mbathy(ji,jj) = ibtest
             icompt = icompt + 1
          ENDIF
       END DO
    END DO
 END DO
 PRINT *, icompt,' ocean grid points suppressed'

 !                                          ! East-west cyclic boundary conditions
 IF( nperio == 0 ) THEN
    PRINT *, ' mbathy set to 0 along east and west boundary: nperio = ', nperio
    mbathy( 1 ,:) = 0
    mbathy(npiglo,:) = 0
 ELSEIF( nperio == 1 .OR. nperio == 4 .OR. nperio ==  6 ) THEN
    PRINT *, ' east-west cyclic boundary conditions on mbathy: nperio = ', nperio
    mbathy( 1 ,:) = mbathy(npiglo-1,:)
    mbathy(npiglo,:) = mbathy(  2  ,:)
 ELSEIF( nperio == 2 ) THEN
    PRINT *, '   equatorial boundary conditions on mbathy: nperio = ', nperio
 ELSE
    PRINT *, '    e r r o r'
    PRINT *, '    parameter , nperio = ', nperio
    STOP 99 
 ENDIF

 ! write mbathy to file mesh_zgr
 ierr = NF90_PUT_VAR( nczgr, id_mbat, mbathy, start=(/1,1,1/), count=(/npiglo,npjglo,1/) )

END SUBROUTINE zgr_bat_ctl

SUBROUTINE CreateMeshZgrFile
  !netcdf ORCA12.L75-MAL83_mesh_zgr {
  !dimensions:
  !	x = 4322 ;
  !	y = 3059 ;
  !	z = 75 ;
  !	t = UNLIMITED ; // (1 currently)
  !variables:
  !	float nav_lon(y, x) ;
  !	float nav_lat(y, x) ;
  !	float nav_lev(z) ;
  !	float time_counter(t) ;
  !	float gdept_0(t, z) ;
  !	float gdepw_0(t, z) ;
  !	float e3t_0(t, z) ;
  !	float e3w_0(t, z) ;
  !	float mbathy(t, y, x) ;
  !	float hdept(t, y, x) ;
  !	float hdepw(t, y, x) ;
  !	float e3t(t, z, y, x) ;
  !	float e3u(t, z, y, x) ;
  !	float e3v(t, z, y, x) ;
  !	float e3w(t, z, y, x) ;
  !  ierr= NF90_CREATE(cf_zgr, or(NF90_CLOBBER,NF90_64BIT_OFFSET), nczgr) 

 ierr= NF90_CREATE(cf_zgr, or(NF90_CLOBBER,NF90_NETCDF4), nczgr) 
 ierr= NF90_DEF_DIM(nczgr, 'x', npiglo, idx)
 ierr= NF90_DEF_DIM(nczgr, 'y', npjglo, idy)
 ierr= NF90_DEF_DIM(nczgr, 'z', jpk,    idz)
 ierr= NF90_DEF_DIM(nczgr, 't', NF90_UNLIMITED,  idt)

 ierr=NF90_DEF_VAR(nczgr, 'nav_lon',       NF90_FLOAT, (/idx,idy/), id_navlon )
 ierr=NF90_DEF_VAR(nczgr, 'nav_lat',       NF90_FLOAT, (/idx,idy/), id_navlat )
 ierr=NF90_DEF_VAR(nczgr, 'nav_lev',       NF90_FLOAT, (/idz/)    , id_navlev )
 ierr=NF90_DEF_VAR(nczgr, 'time_counter',  NF90_FLOAT, (/idt/)    , id_time   )

 ierr=NF90_DEF_VAR(nczgr, 'gdept_0',       NF90_FLOAT, (/idz,idt/), id_dept1d )
 ierr=NF90_DEF_VAR(nczgr, 'gdepw_0',       NF90_FLOAT, (/idz,idt/), id_depw1d )
 ierr=NF90_DEF_VAR(nczgr, 'e3t_0',         NF90_FLOAT, (/idz,idt/), id_e3t1d  )
 ierr=NF90_DEF_VAR(nczgr, 'e3w_0',         NF90_FLOAT, (/idz,idt/), id_e3w1d  )

 ierr=NF90_DEF_VAR(nczgr, 'mbathy',        NF90_FLOAT, (/idx,idy,idt/), id_mbat )
 ierr=NF90_DEF_VAR(nczgr, 'hdept',         NF90_FLOAT, (/idx,idy,idt/), id_hdept )
 ierr=NF90_DEF_VAR(nczgr, 'hdepw',         NF90_FLOAT, (/idx,idy,idt/), id_hdepw )

 ierr=NF90_DEF_VAR(nczgr, 'e3t',           NF90_FLOAT, (/idx,idy,idz,idt/), id_e3t )
 ierr=NF90_DEF_VAR(nczgr, 'e3w',           NF90_FLOAT, (/idx,idy,idz,idt/), id_e3w )
 ierr=NF90_DEF_VAR(nczgr, 'e3u',           NF90_FLOAT, (/idx,idy,idz,idt/), id_e3u )
 ierr=NF90_DEF_VAR(nczgr, 'e3v',           NF90_FLOAT, (/idx,idy,idz,idt/), id_e3v )

 ierr = NF90_ENDDEF(nczgr)
 ! put dimension related variables
 ierr = NF90_OPEN(cf_coo, NF90_NOCLOBBER, nccoo )
 ierr = NF90_INQ_VARID(nccoo, cn_glamt, idvar ) ; ierr=NF90_GET_VAR(nccoo, idvar, rlon )
 ierr = NF90_INQ_VARID(nccoo, cn_gphit, idvar ) ; ierr=NF90_GET_VAR(nccoo, idvar, rlat )
 ierr = NF90_CLOSE(nccoo )

 ierr = NF90_PUT_VAR(nczgr, id_navlon, rlon)
 ierr = NF90_PUT_VAR(nczgr, id_navlat, rlat)
 ierr = NF90_PUT_VAR(nczgr, id_navlev, gdept_1d )
 ierr = NF90_PUT_VAR(nczgr, id_time  , (/0./) )

 ! put 1D vertical variables (reference depth)
 ierr = NF90_PUT_VAR(nczgr, id_dept1d, gdept_1d, start=(/1,1/), count=(/jpk,1/) )
 ierr = NF90_PUT_VAR(nczgr, id_depw1d, gdepw_1d, start=(/1,1/), count=(/jpk,1/) )
 ierr = NF90_PUT_VAR(nczgr, id_e3t1d,  e3t_1d,   start=(/1,1/), count=(/jpk,1/) )
 ierr = NF90_PUT_VAR(nczgr, id_e3w1d,  e3w_1d,   start=(/1,1/), count=(/jpk,1/) )

END SUBROUTINE CreateMeshZgrFile

SUBROUTINE CreateMaskFile
  !netcdf ORCA025.L75-MJM101.1_byte_mask {
  !dimensions:
  !	x = 1442 ;
  !	y = 1021 ;
  !	z = 75 ;
  !	t = UNLIMITED ; // (1 currently)
  !variables:
  !	float nav_lon(y, x) ;
  !	float nav_lat(y, x) ;
  !	float nav_lev(z) ;
  !	float time_counter(t) ;
  !	byte tmaskutil(t, y, x) ;
  !	byte umaskutil(t, y, x) ;
  !	byte vmaskutil(t, y, x) ;
  !	byte fmaskutil(t, y, x) ;
  !	byte tmask(t, z, y, x) ;
  !	byte umask(t, z, y, x) ;
  !	byte vmask(t, z, y, x) ;
  !	byte fmask(t, z, y, x) ;

 ierr= NF90_CREATE(cf_msk, or(NF90_CLOBBER,NF90_NETCDF4), ncmsk) 
 IF ( ierr /= NF90_NOERR ) THEN  ; PRINT *, NF90_STRERROR(ierr) ; STOP 99 ;
 ENDIF
 ierr= NF90_DEF_DIM(ncmsk, 'x', npiglo, idx)
 IF ( ierr /= NF90_NOERR ) THEN  ; PRINT *, NF90_STRERROR(ierr) ; STOP 99 ;
 ENDIF
 ierr= NF90_DEF_DIM(ncmsk, 'y', npjglo, idy)
 IF ( ierr /= NF90_NOERR ) THEN  ; PRINT *, NF90_STRERROR(ierr) ; STOP 99 ;
 ENDIF
 ierr= NF90_DEF_DIM(ncmsk, 'z', jpk,    idz)
 IF ( ierr /= NF90_NOERR ) THEN  ; PRINT *, NF90_STRERROR(ierr) ; STOP 99 ;
 ENDIF
 ierr= NF90_DEF_DIM(ncmsk, 't', NF90_UNLIMITED,  idt)
 IF ( ierr /= NF90_NOERR ) THEN  ; PRINT *, NF90_STRERROR(ierr) ; STOP 99 ;
 ENDIF

 ierr=NF90_DEF_VAR(ncmsk, 'nav_lon',       NF90_FLOAT, (/idx,idy/), id_navlon )
 IF ( ierr /= NF90_NOERR ) THEN  ; PRINT *, NF90_STRERROR(ierr) ; STOP 99 ;
 ENDIF
 ierr=NF90_DEF_VAR(ncmsk, 'nav_lat',       NF90_FLOAT, (/idx,idy/), id_navlat )
 IF ( ierr /= NF90_NOERR ) THEN  ; PRINT *, NF90_STRERROR(ierr) ; STOP 99 ;
 ENDIF
 ierr=NF90_DEF_VAR(ncmsk, 'nav_lev',       NF90_FLOAT, (/idz/)    , id_navlev )
 IF ( ierr /= NF90_NOERR ) THEN  ; PRINT *, NF90_STRERROR(ierr) ; STOP 99 ;
 ENDIF
 ierr=NF90_DEF_VAR(ncmsk, 'time_counter',  NF90_FLOAT, (/idt/)    , id_time   )
 IF ( ierr /= NF90_NOERR ) THEN  ; PRINT *, NF90_STRERROR(ierr) ; STOP 99 ;
 ENDIF

 ierr=NF90_DEF_VAR(ncmsk, 'tmaskutil',    NF90_BYTE, (/idx,idy,idt/), id_tmsku )
 IF ( ierr /= NF90_NOERR ) THEN  ; PRINT *, NF90_STRERROR(ierr) ; STOP 99 ;
 ENDIF
 ierr=NF90_DEF_VAR(ncmsk, 'umaskutil',    NF90_BYTE, (/idx,idy,idt/), id_umsku )
 IF ( ierr /= NF90_NOERR ) THEN  ; PRINT *, NF90_STRERROR(ierr) ; STOP 99 ;
 ENDIF
 ierr=NF90_DEF_VAR(ncmsk, 'vmaskutil',    NF90_BYTE, (/idx,idy,idt/), id_vmsku )
 IF ( ierr /= NF90_NOERR ) THEN  ; PRINT *, NF90_STRERROR(ierr) ; STOP 99 ;
 ENDIF
 ierr=NF90_DEF_VAR(ncmsk, 'fmaskutil',    NF90_BYTE, (/idx,idy,idt/), id_fmsku )
 IF ( ierr /= NF90_NOERR ) THEN  ; PRINT *, NF90_STRERROR(ierr) ; STOP 99 ;
 ENDIF

 ierr=NF90_DEF_VAR(ncmsk, 'tmask',         NF90_BYTE, (/idx,idy,idz,idt/), id_tmsk )
 IF ( ierr /= NF90_NOERR ) THEN  ; PRINT *, NF90_STRERROR(ierr) ; STOP 99 ; 
 ENDIF
 ierr=NF90_DEF_VAR(ncmsk, 'umask',         NF90_BYTE, (/idx,idy,idz,idt/), id_umsk )
 IF ( ierr /= NF90_NOERR ) THEN  ; PRINT *, NF90_STRERROR(ierr) ; STOP 99 ;
 ENDIF
 ierr=NF90_DEF_VAR(ncmsk, 'vmask',         NF90_BYTE, (/idx,idy,idz,idt/), id_vmsk )
 IF ( ierr /= NF90_NOERR ) THEN  ; PRINT *, NF90_STRERROR(ierr) ; STOP 99 ;
 ENDIF
 ierr=NF90_DEF_VAR(ncmsk, 'fmask',         NF90_BYTE, (/idx,idy,idz,idt/), id_fmsk )

 ierr = NF90_ENDDEF(ncmsk)
 IF ( ierr /= NF90_NOERR ) THEN  ; PRINT *, NF90_STRERROR(ierr) ; STOP 99 ; 
 ENDIF
 ! put dimension related variables

 ierr = NF90_PUT_VAR(ncmsk, id_navlon, rlon)
 IF ( ierr /= NF90_NOERR ) THEN  ; PRINT *, NF90_STRERROR(ierr) ; STOP 99 ;
 ENDIF
 ierr = NF90_PUT_VAR(ncmsk, id_navlat, rlat)
 IF ( ierr /= NF90_NOERR ) THEN  ; PRINT *, NF90_STRERROR(ierr) ; STOP 99 ;
 ENDIF
 ierr = NF90_PUT_VAR(ncmsk, id_navlev, gdept_1d )
 IF ( ierr /= NF90_NOERR ) THEN  ; PRINT *, NF90_STRERROR(ierr) ; STOP 99 ;
 ENDIF
 ierr = NF90_PUT_VAR(ncmsk, id_time  , (/0./) )
 IF ( ierr /= NF90_NOERR ) THEN  ; PRINT *, NF90_STRERROR(ierr) ; STOP 99 ;
 ENDIF

END SUBROUTINE CreateMaskFile


END PROGRAM

PROGRAM cdfmppini 
  !!======================================================================
  !!                     ***  PROGRAM  cdfmppini  ***
  !!=====================================================================
  !!  ** Purpose : off line domain decomposition using mesh_hgr
  !!
  !!  ** Method  : just an incapsulation of mpp_ini from NEMO
  !!
  !! History : 2.1  : 05/2010  : J.M. Molines : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  !!   routines      : description
  !!   mpp_init2     Nemo routine for mpp initialisation
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE
  ! REM : some of the doctor rules are not followed because we want to use
  !       the mpp_init2 routine almost out of the box, thus we need to define
  !       variables which are parameters in NEMO, with the same name (jp..)

  INTEGER(KIND=4), PARAMETER                   :: wp=8   ! working precision
  INTEGER(KIND=4)                              :: jpni, jpnj, jpnij
  INTEGER(KIND=4)                              :: jpreci=1 , jprecj=1
  INTEGER(KIND=4)                              :: jpi, jpj, jpiglo, jpjglo
  INTEGER(KIND=4)                              :: jperio=6, jv
  INTEGER(KIND=4)                              :: narg, iargc, numout=6
  INTEGER(KIND=4)                              :: ijarg, ireq
  INTEGER(KIND=4), DIMENSION(:,:), ALLOCATABLE :: imask
  INTEGER(KIND=4), DIMENSION(:),   ALLOCATABLE :: nimppt, njmppt, nlcit, nlcjt
  INTEGER(KIND=4), DIMENSION(:),   ALLOCATABLE :: nldit, nldjt, nleit, nlejt
  INTEGER(KIND=4), DIMENSION(:),   ALLOCATABLE :: nbondi, nbondj, icount


  CHARACTER(LEN=80)                            :: cf_msk='m'
  CHARACTER(LEN=80)                            :: cf_out='mppini.txt'
  CHARACTER(LEN=80)                            :: cv_in
  CHARACTER(LEN=80)                            :: cldum

  LOGICAL                                      :: lwp=.true.
  !----------------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg < 2 ) THEN
     PRINT *,' usage : cdfmppini jpni jpnj [m/b/z] [-jperio jperio]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Perform the mpp initialisation with NEMO routine mpp_init2 and' 
     PRINT *,'       give some statistics about the domains. Save the layout on a '
     PRINT *,'       text file.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       jpni : number of domains in the i direction.' 
     PRINT *,'       jpnj : number of domains in the j direction.' 
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [m/b/z] : use one of these letter to choose the land/sea mask.'
     PRINT *,'               m  : take mask from ',TRIM(cn_fmsk),' (tmask) [ default ]'
     PRINT *,'               b  : take mask from ',TRIM(cn_fbathymet),' (Bathymetry)'
     PRINT *,'               z  : take mask from ',TRIM(cn_fzgr),' (mbathy)'
     PRINT *,'                   Default is ',TRIM(cf_msk)
     PRINT *,'       [-jperio jperio ] : specify jperio. '
     PRINT '(a,i2)','                          default value is ', jperio
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       one of ',TRIM(cn_fmsk),', ',TRIM(cn_fbathymet),' or ',TRIM(cn_fzgr),' according to option' 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       - Standard output'
     PRINT *,'       - ASCII file ', TRIM(cf_out)
     STOP
  ENDIF
  
  cf_msk = cn_fmsk ; cv_in='tmask'
  ijarg=1 ; ireq=0
  DO WHILE ( ijarg <= narg )
     CALL getarg( ijarg, cldum ) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE( 'm' ) ; cf_msk=cn_fmsk       ; cv_in='tmask'
     CASE( 'b' ) ; cf_msk=cn_fbathymet  ; cv_in='Bathymetry'
     CASE( 'z' ) ; cf_msk=cn_fzgr       ; cv_in='mbathy'
     CASE( '-jperio' ) 
        CALL getarg( ijarg, cldum ) ; ijarg=ijarg+1 ; READ(cldum,*) jperio
     CASE DEFAULT 
        ireq = ireq+1
        SELECT CASE ( ireq )
        CASE ( 1 ) ; READ(cldum,*) jpni
        CASE ( 2 ) ; READ(cldum,*) jpnj
        CASE DEFAULT ; PRINT *,' Too many arguments.'; STOP
        END SELECT
     END SELECT
  END DO

  IF ( chkfile (cf_msk ))  STOP ! missing file
  
  jpiglo = getdim (cf_msk,cn_x)
  jpjglo = getdim (cf_msk,cn_y)

  jpi = ( jpiglo-2*jpreci + (jpni-1) ) / jpni + 2*jpreci 
  jpj = ( jpjglo-2*jprecj + (jpnj-1) ) / jpnj + 2*jprecj 

  ALLOCATE ( imask(jpiglo,jpjglo) )
  imask(:,:) = getvar(cf_msk, cv_in, 1, jpiglo, jpjglo)
  WHERE (imask <= 0 ) imask = 0
  WHERE (imask > 0  ) imask = 1
  CALL mpp_init2
  PRINT *, 'JPIGLO= ', jpiglo
  PRINT *, 'JPJGLO= ', jpjglo
  PRINT *, 'JPI   = ', jpi
  PRINT *, 'JPJ   = ', jpj
  PRINT *, 'JPNI  = ', jpni
  PRINT *, 'JPNJ  = ', jpnj
  PRINT *, 'JPNIJ = ', jpnij

  PRINT *, 'NBONDI between : ',MINVAL(nbondi),' AND ', MAXVAL(nbondi)
  PRINT *, 'NBONDJ between : ',MINVAL(nbondj),' AND ', MAXVAL(nbondj)
  PRINT *,' Accounting ...'
  ALLOCATE (icount(jpnij))
   DO jv=-1,2
     icount=0
     WHERE(nbondi == jv ) icount=1
     PRINT *,' NBONDI = ', jv,' : ', sum(icount)
   ENDDO

   DO jv=-1,2
     icount=0
     WHERE(nbondj == jv ) icount=1
     PRINT *,' NBONDJ = ', jv,' : ', sum(icount)
   ENDDO
    

CONTAINS

   SUBROUTINE mpp_init2
      !!----------------------------------------------------------------------
      !!                  ***  ROUTINE mpp_init2  ***
      !!
      !! * Purpose :   Lay out the global domain over processors.
      !!     FOR USING THIS VERSION, A PREPROCESSING TRAITMENT IS RECOMMENDED
      !!     FOR DEFINING BETTER CUTTING OUT.
      !!       This routine is used with a the bathymetry file.
      !!       In this version, the land processors are avoided and the adress
      !!     processor (nproc, narea,noea, ...) are calculated again.
      !!     The jpnij parameter can be lesser than jpni x jpnj
      !!     and this jpnij parameter must be calculated before with an
      !!     algoritmic preprocessing program.
      !!
      !! ** Method  :   Global domain is distributed in smaller local domains.
      !!      Periodic condition is a function of the local domain position
      !!      (global boundary or neighbouring domain) and of the global
      !!      periodic
      !!      Type :         jperio global periodic condition
      !!                     nperio local  periodic condition
      !!
      !! ** Action :        nimpp     : longitudinal index 
      !!                    njmpp     : latitudinal  index
      !!                    nperio    : lateral condition type 
      !!                    narea     : number for local area
      !!                    nlci      : first dimension
      !!                    nlcj      : second dimension
      !!                    nproc     : number for local processor
      !!                    noea      : number for local neighboring processor
      !!                    nowe      : number for local neighboring processor
      !!                    noso      : number for local neighboring processor
      !!                    nono      : number for local neighboring processor
      !!
      !! History :
      !!        !  94-11  (M. Guyon)  Original code
      !!        !  95-04  (J. Escobar, M. Imbard)
      !!        !  98-02  (M. Guyon)  FETI method
      !!        !  98-05  (M. Imbard, J. Escobar, L. Colombet )  SHMEM and MPI versions
      !!   9.0  !  04-01  (G. Madec, J.M Molines)  F90 : free form , north fold jpni > 1
      !!----------------------------------------------------------------------
      !! 
      INTEGER(KIND=4) :: ji, jj, jn, jproc, jarea     ! dummy loop indices
      INTEGER(KIND=4) ::  inum = 99                   ! temporary logical unit
      INTEGER(KIND=4) ::   &
         ii, ij, ifreq, il1, il2,          &  ! temporary integers
         icont, ili, ilj,                  &  !    "          "
         isurf, ijm1, imil,                &  !    "          "
         iino, ijno, iiso, ijso,           &  !    "          " 
         iiea, ijea, iiwe, ijwe,           &  !    "          "
         iresti, irestj, iproc                !    "          "
      INTEGER(KIND=4) :: nreci, nrecj,  nperio
      INTEGER(KIND=4), DIMENSION(10000)          ::    iint, ijnt          
      INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE ::    iin, ijn          
      INTEGER(KIND=4), DIMENSION(jpni,jpnj) ::   &
         iimppt, ijmppt, ilci  , ilcj  ,   &  ! temporary workspace
         ipproc, ibondj, ibondi,           &  !    "           "
         ilei  , ilej  , ildi  , ildj  ,   &  !    "           "
         ioea  , iowe  , ioso  , iono         !    "           "
      REAL(wp) ::   zidom , zjdom          ! temporary scalars

      INTEGER(KIND=4) :: nono, noso, noea, nowe
      INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE :: ii_nono, ii_noso, ii_noea, ii_nowe

      ! 0. initialisation
      ! -----------------

      !  1. Dimension arrays for subdomains
      ! -----------------------------------

      !  Computation of local domain sizes ilci() ilcj()
      !  These dimensions depend on global sizes jpni,jpnj and jpiglo,jpjglo
      !  The subdomains are squares leeser than or equal to the global
      !  dimensions divided by the number of processors minus the overlap
      !  array.

      nreci=2*jpreci
      nrecj=2*jprecj
      iresti = 1 + MOD( jpiglo - nreci -1 , jpni )
      irestj = 1 + MOD( jpjglo - nrecj -1 , jpnj )

      ilci(1:iresti      ,:) = jpi
      ilci(iresti+1:jpni ,:) = jpi-1

      ilcj(:,      1:irestj) = jpj
      ilcj(:, irestj+1:jpnj) = jpj-1

      IF(lwp) WRITE(numout,*)
      IF(lwp) WRITE(numout,*) ' mpp_init2: defines mpp subdomains'
      IF(lwp) WRITE(numout,*) ' ~~~~~~  ----------------------'
      IF(lwp) WRITE(numout,*)
      IF(lwp) WRITE(numout,*) 'iresti=',iresti,' irestj=',irestj
      IF(lwp) WRITE(numout,*)
      IF(lwp) WRITE(numout,*) 'jpni=',jpni,' jpnj=',jpnj

      zidom = nreci + sum(ilci(:,1) - nreci ) 
      IF(lwp) WRITE(numout,*)
      IF(lwp) WRITE(numout,*)' sum ilci(i,1)=',zidom,' jpiglo=',jpiglo

      zjdom = nrecj + sum(ilcj(1,:) - nrecj ) 
      IF(lwp) WRITE(numout,*) ' sum ilcj(1,j)=',zjdom,' jpjglo=',jpjglo
      IF(lwp) WRITE(numout,*)


      !  2. Index arrays for subdomains
      ! -------------------------------

      iimppt(:,:) = 1
      ijmppt(:,:) = 1
      ipproc(:,:) = -1

      IF( jpni > 1 )THEN
         DO jj = 1, jpnj
            DO ji = 2, jpni
               iimppt(ji,jj) = iimppt(ji-1,jj) + ilci(ji-1,jj) - nreci
            END DO
         END DO
      ENDIF

      IF( jpnj > 1 )THEN
         DO jj = 2, jpnj
            DO ji = 1, jpni
               ijmppt(ji,jj) = ijmppt(ji,jj-1) + ilcj(ji,jj-1) - nrecj
            END DO
         END DO
      ENDIF


      ! 3. Subdomain description in the Regular Case
      ! --------------------------------------------

      nperio = 0
      icont = -1
      DO jarea = 1, jpni*jpnj
         ii = 1 + MOD(jarea-1,jpni)
         ij = 1 +    (jarea-1)/jpni
         ili = ilci(ii,ij)
         ilj = ilcj(ii,ij)

         ibondj(ii,ij) = -1
         IF( jarea >  jpni          )   ibondj(ii,ij) = 0
         IF( jarea >  (jpnj-1)*jpni )   ibondj(ii,ij) = 1
         IF( jpnj  == 1             )   ibondj(ii,ij) = 2

         ibondi(ii,ij) = 0
         IF( MOD(jarea,jpni) == 1 )   ibondi(ii,ij) = -1
         IF( MOD(jarea,jpni) == 0 )   ibondi(ii,ij) =  1
         IF( jpni            == 1 )   ibondi(ii,ij) =  2

         ! 2.4 Subdomain neighbors

         iproc = jarea - 1
         ioso(ii,ij) = iproc - jpni
         iowe(ii,ij) = iproc - 1
         ioea(ii,ij) = iproc + 1
         iono(ii,ij) = iproc + jpni

         ildi(ii,ij) = 1 + jpreci
         ilei(ii,ij) = ili -jpreci

         IF( ibondi(ii,ij) == -1 .OR. ibondi(ii,ij) == 2 ) ildi(ii,ij) = 1
         IF( ibondi(ii,ij) ==  1 .OR. ibondi(ii,ij) == 2 ) ilei(ii,ij) = ili

         ildj(ii,ij) =  1  + jprecj
         ilej(ii,ij) = ilj - jprecj
         IF( ibondj(ii,ij) == -1 .OR. ibondj(ii,ij) == 2 ) ildj(ii,ij) = 1
         IF( ibondj(ii,ij) ==  1 .OR. ibondj(ii,ij) == 2 ) ilej(ii,ij) = ilj

         ! warning ii*ij (zone) /= nproc (processors)!

         IF( jperio == 1 .OR. jperio == 4 .OR. jperio == 6 ) THEN
            IF( jpni == 1 )THEN
               ibondi(ii,ij) = 2
               nperio = 1
            ELSE
               ibondi(ii,ij) = 0
            ENDIF
            IF( MOD(jarea,jpni) == 0 ) THEN
               ioea(ii,ij) = iproc - (jpni-1)
            ENDIF
            IF( MOD(jarea,jpni) == 1 ) THEN
               iowe(ii,ij) = iproc + jpni - 1
            ENDIF
         ENDIF

         isurf = 0
         DO jj = 1+jprecj, ilj-jprecj
            DO  ji = 1+jpreci, ili-jpreci
               IF( imask(ji+iimppt(ii,ij)-1, jj+ijmppt(ii,ij)-1) == 1) isurf = isurf+1
            END DO
         END DO
         IF(isurf /= 0) THEN
            icont = icont + 1
            ipproc(ii,ij) = icont
            iint(icont+1) = ii
            ijnt(icont+1) = ij
         ENDIF
      END DO
      jpnij=icont+1
      ALLOCATE(iin(jpnij),ijn(jpnij),nimppt(jpnij), njmppt(jpnij), nlcit(jpnij), nlcjt(jpnij)  )
      ALLOCATE(nldit(jpnij), nldjt(jpnij)  )
      ALLOCATE(nleit(jpnij), nlejt(jpnij)  )
      ALLOCATE(nbondi(jpnij), nbondj(jpnij)  )
      ALLOCATE(ii_nono(jpnij), ii_noso(jpnij), ii_noea(jpnij) , ii_nowe(jpnij) )

      iin(:)=iint(1:jpnij)
      ijn(:)=ijnt(1:jpnij)

      ! Control
      ! 4. Subdomain print
      ! ------------------

      IF(lwp) THEN
         ifreq = 4
         il1 = 1
         DO jn = 1,(jpni-1)/ifreq+1
            il2 = MIN(jpni,il1+ifreq-1)
            WRITE(numout,*)
            WRITE(numout,9400) ('***',ji=il1,il2-1)
            DO jj = jpnj, 1, -1
               WRITE(numout,9403) ('   ',ji=il1,il2-1)
               WRITE(numout,9402) jj, (ilci(ji,jj),ilcj(ji,jj),ji=il1,il2)
               WRITE(numout,9404) (ipproc(ji,jj),ji=il1,il2)
               WRITE(numout,9403) ('   ',ji=il1,il2-1)
               WRITE(numout,9400) ('***',ji=il1,il2-1)
            END DO
            WRITE(numout,9401) (ji,ji=il1,il2)
            il1 = il1+ifreq
         END DO
 9400     FORMAT('     ***',20('*************',a3))
 9403     FORMAT('     *     ',20('         *   ',a3))
 9401     FORMAT('        ',20('   ',i3,'          '))
 9402     FORMAT(' ',i3,' *  ',20(i3,'  x',i3,'   *   '))
 9404     FORMAT('     *  ',20('     ',i4,'   *   '))
      ENDIF


      ! 5. neighbour treatment
      ! ----------------------

      DO jarea = 1, jpni*jpnj
         iproc = jarea-1
         ii = 1 + MOD(jarea-1,jpni)
         ij = 1 +    (jarea-1)/jpni
         IF( ipproc(ii,ij) == -1 .AND. iono(ii,ij) >= 0   &
            .AND. iono(ii,ij) <= jpni*jpnj-1 ) THEN
            iino = 1 + MOD(iono(ii,ij),jpni)
            ijno = 1 +    (iono(ii,ij))/jpni
            IF( ibondj(iino,ijno) == 1 ) ibondj(iino,ijno)=2
            IF( ibondj(iino,ijno) == 0 ) ibondj(iino,ijno) = -1
         ENDIF
         IF( ipproc(ii,ij) == -1 .AND. ioso(ii,ij) >= 0   &
            .AND. ioso(ii,ij) <= jpni*jpnj-1 ) THEN
            iiso = 1 + MOD(ioso(ii,ij),jpni)
            ijso = 1 +    (ioso(ii,ij))/jpni
            IF( ibondj(iiso,ijso) == -1 ) ibondj(iiso,ijso) = 2
            IF( ibondj(iiso,ijso) ==  0 ) ibondj(iiso,ijso) = 1
         ENDIF
         IF( ipproc(ii,ij) == -1 .AND. ioea(ii,ij) >= 0   &
            .AND. ioea(ii,ij) <= jpni*jpnj-1) THEN
            iiea = 1 + MOD(ioea(ii,ij),jpni)
            ijea = 1 +    (ioea(ii,ij))/jpni
            IF( ibondi(iiea,ijea) == 1 ) ibondi(iiea,ijea) = 2
            IF( ibondi(iiea,ijea) == 0 ) ibondi(iiea,ijea) = -1
         ENDIF
         IF( ipproc(ii,ij) == -1 .AND. iowe(ii,ij) >= 0   &
            .AND. iowe(ii,ij) <= jpni*jpnj-1) THEN
            iiwe = 1 + MOD(iowe(ii,ij),jpni)
            ijwe = 1 +    (iowe(ii,ij))/jpni
            IF( ibondi(iiwe,ijwe) == -1 ) ibondi(iiwe,ijwe) = 2
            IF( ibondi(iiwe,ijwe) ==  0 ) ibondi(iiwe,ijwe) = 1
         ENDIF
      END DO


      ! just to save nono etc for all proc
      DO jarea = 1, jpnij
        ii = iin(jarea)
        ij = ijn(jarea)
      IF( ioso(ii,ij) >= 0 .AND. ioso(ii,ij) <= (jpni*jpnj-1) ) THEN
         iiso = 1 + MOD(ioso(ii,ij),jpni)
         ijso = 1 +    (ioso(ii,ij))/jpni
         noso = ipproc(iiso,ijso)
         ii_noso(jarea)= noso
      ENDIF
      IF( iowe(ii,ij) >= 0 .AND. iowe(ii,ij) <= (jpni*jpnj-1) ) THEN
         iiwe = 1 + MOD(iowe(ii,ij),jpni)
         ijwe = 1 +    (iowe(ii,ij))/jpni
         nowe = ipproc(iiwe,ijwe)
         ii_nowe(jarea)= nowe
      ENDIF
      IF( ioea(ii,ij) >= 0 .AND. ioea(ii,ij) <= (jpni*jpnj-1) ) THEN
         iiea = 1 + MOD(ioea(ii,ij),jpni)
         ijea = 1 +    (ioea(ii,ij))/jpni
         noea = ipproc(iiea,ijea)
         ii_noea(jarea)= noea
      ENDIF
      IF( iono(ii,ij) >= 0 .AND. iono(ii,ij) <= (jpni*jpnj-1) ) THEN
         iino = 1 + MOD(iono(ii,ij),jpni)
         ijno = 1 +    (iono(ii,ij))/jpni
         nono = ipproc(iino,ijno)
         ii_nono(jarea)= nono
      ENDIF
      END DO
      ! 6. Change processor name
      ! ------------------------

      DO jproc = 1, jpnij
         ii = iin(jproc)
         ij = ijn(jproc)

         nimppt(jproc) = iimppt(ii,ij)  
         njmppt(jproc) = ijmppt(ii,ij)  

         nlcit(jproc) = ilci(ii,ij)
         nlcjt(jproc) = ilcj(ii,ij)

         nldit(jproc) = ildi(ii,ij)
         nldjt(jproc) = ildj(ii,ij)

         nleit(jproc) = ilei(ii,ij)
         nlejt(jproc) = ilej(ii,ij)
      END DO

      ! Save processor layout in ascii file
      IF (lwp) THEN
         OPEN (inum, FILE=cf_out, FORM='FORMATTED', RECL=255)
         WRITE(inum,'(6i8)') jpnij,jpi,jpj,jpiglo,jpjglo
         WRITE(inum,'(a)') 'RANK   nlci nlcj nldi nldj nlei nlej nimpp njmpp nono noso nowe noea nbondi nbondj '

        DO  jproc = 1, jpnij
         ii = iin(jproc)
         ij = ijn(jproc)
         nbondi(jproc) = ibondi(ii,ij)
         nbondj(jproc) = ibondj(ii,ij)
         

         WRITE(inum,'(15i5)') jproc-1, nlcit(jproc), nlcjt(jproc), &
                                       nldit(jproc), nldjt(jproc), &
                                       nleit(jproc), nlejt(jproc), &
                                       nimppt(jproc), njmppt(jproc),& 
                                       ii_nono(jproc), ii_noso(jproc), ii_nowe(jproc), ii_noea(jproc) ,&
                                       nbondi(jproc),  nbondj(jproc) 
        END DO
        CLOSE(inum)   
      END IF


   END SUBROUTINE mpp_init2

END PROGRAM cdfmppini

PROGRAM cdfsigtrp
  !!======================================================================
  !!                     ***  PROGRAM  cdfsigtrp  ***
  !!======================================================================
  !!  ** Purpose : Compute density class Mass transport across a section.
  !!
  !!  ** Method  :- The begining and end point of the section are given in 
  !!                term of f-points index.
  !!              - The program works for zonal or meridional sections.
  !!              - The section definitions are given in an ASCII FILE 
  !!                dens_section.dat:
  !!                 foreach sections, 2 lines :
  !!                       (i) : section name (String, no blank)
  !!                      (ii) : imin imax jmin jmax for the section
  !!              - Only vertical slices corrsponding to the sections are
  !!                read in the files.
  !!              - read metrics, depth, etc
  !!              - read normal velocity (either vozocrtx oy vomecrty )
  !!              - read 2 rows of T and S ( i i+1  or j j+1 )
  !!              - compute the mean value at velocity point
  !!              - compute sigma0 (can be easily modified for sigmai )
  !!              - compute the depths of isopyncal surfaces
  !!              - compute the transport from surface to the isopycn
  !!              - compute the transport in each class of density
  !!              - compute the total transport (for information)
  !!
  !! History : 2.1  : 03/2006  : J.M. Molines : Original code
  !!                : 07/2009  : R. Dussin    : add cdf output
  !!           3.0  : 06/2011  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  !!   routines      : description
  !!  section_init   : initialize section names and positions
  !!  print_out      : routine which performs standard output if required
  !!----------------------------------------------------------------------
  USE cdfio
  USE eos          ! for sigma0, sigmai
  USE modcdfnames  ! for ReadCdfNames
  USE modutils     ! for SetGlobalAtt
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class transport
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                               :: ji, jk, jclass, jsec ! dummy loop index
  INTEGER(KIND=4)                               :: jiso, jbin           ! dummy loop index
  INTEGER(KIND=4)                               :: nbins                ! number of density classes
  INTEGER(KIND=4)                               :: ipos                 ! working variable
  INTEGER(KIND=4)                               :: narg, iargc          ! command line 
  INTEGER(KIND=4)                               :: ijarg, ireq, nreq    ! command line
  INTEGER(KIND=4)                               :: npk, nk              ! vertical size, number of wet layers
  INTEGER(KIND=4)                               :: numout=11            ! ascii output
  INTEGER(KIND=4)                               :: nsection             ! number of sections (overall)
  INTEGER(KIND=4)                               :: npiglo               ! length of broken line section
  INTEGER(KIND=4)                               :: iimin, iimax         ! working section limits
  INTEGER(KIND=4)                               :: ijmin, ijmax         ! working section limits
  INTEGER(KIND=4)                               :: npts                 ! number of points in section
  INTEGER(KIND=4)                               :: ikx=1, iky=1         ! dims of netcdf output file
  INTEGER(KIND=4)                               :: nboutput=2           ! number of values to write in cdf output
  INTEGER(KIND=4)                               :: ncout, ierr          ! for netcdf output
  INTEGER(KIND=4)                               :: iweight              ! weight of input file for further averaging
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: iimina, iimaxa       ! sections limits
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: ijmina, ijmaxa       ! sections limits
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: ipk, id_varout       ! variable levels and id

  REAL(KIND=4)                                  :: refdep =0.e0         ! reference depth (m)
  REAL(KIND=4)                                  :: zsps, zspu, zspv     ! Missing value for salinity, U and V
  REAL(KIND=4), DIMENSION(1)                    :: rdummy1, rdummy2     ! working variable
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: gdept, gdepw         ! depth of T and W points 
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: eu                   ! either e1v or e2u
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: e3t1d, e3w1d         ! vertical metrics in case of full step
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: rlonlat              ! longitudes/latitudes if the section
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: zs, zt, zz           ! salinity and temperature from file 
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: rdumlon, rdumlat     ! dummy longitude and latitude for output
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: zu                   ! velocity
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: zmask                ! mask
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: tmpm, tmpz           ! temporary arrays

  ! double precision for cumulative variables and densities
  REAL(KIND=8)                                  :: dsigma_min           ! minimum density for bining
  REAL(KIND=8)                                  :: dsigma_max, dltsig   ! maximum density for bining, step
  REAL(KIND=8)                                  :: dsigma, dalfa        ! working sigma, interpolation coeff.
  REAL(KIND=8), DIMENSION(1)                    :: dtim                 ! time counter
  REAL(KIND=8), DIMENSION(:),       ALLOCATABLE :: dsigma_lev           ! built array with sigma levels
  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: de3                  ! vertical metrics
  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: ddepu                ! depth of vel points
  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: ddepw                ! depth of W  points
  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: dsig                 ! density
  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: dhiso                ! depth of isopycns
  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: dwtrp, dwtrpbin      ! transport arrays
  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: dtrpbin              ! transport arrays

  TYPE(variable), DIMENSION(:),     ALLOCATABLE :: stypvar              ! structure of output

  CHARACTER(LEN=256)                            :: cf_tfil              ! temperature salinity file
  CHARACTER(LEN=256)                            :: cf_sfil              ! salinity file (option)
  CHARACTER(LEN=256)                            :: cf_ufil              ! zonal velocity file
  CHARACTER(LEN=256)                            :: cf_vfil              ! meridional velocity file
  CHARACTER(LEN=256)                            :: cf_wfil              ! W file for vvl e3w
  CHARACTER(LEN=256)                            :: cf_brk               ! broken-line file
  CHARACTER(LEN=256)                            :: cf_section='dens_section.dat'  ! input section file
  CHARACTER(LEN=256)                            :: cf_out='trpsig.txt'  ! output  ascii file
  CHARACTER(LEN=256)                            :: cf_nc                ! output netcdf file (2d)
  CHARACTER(LEN=256)                            :: cf_outnc             ! output netcdf file (1d, 0d))
  CHARACTER(LEN=256)                            :: cv_dep               ! depth variable
  CHARACTER(LEN=256)                            :: cldum                ! dummy string
  CHARACTER(LEN=256)                            :: cglobal              ! global attribute
  CHARACTER(LEN=80 )                            :: cfmt_9000            ! format string 
  CHARACTER(LEN=80 )                            :: cfmt_9001            ! format string
  CHARACTER(LEN=80 )                            :: cfmt_9002            ! format string
  CHARACTER(LEN=80 )                            :: cfmt_9003            ! format string
  CHARACTER(LEN=256)                            :: cl_vnam, cl_lname    ! working variables
  CHARACTER(LEN=256)                            :: csuffixvarname       !
  CHARACTER(LEN=256)                            :: cprefixlongname      !
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_names             ! names of input variables
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: csection             ! section name
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cvarname             ! output variable name (root)
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: clongname            ! output long name (root)

  LOGICAL                                       :: l_merid              ! flag for meridional section
  LOGICAL                                       :: ltemp  =.FALSE.      ! flag for use of temperature
  LOGICAL                                       :: lprint =.FALSE.      ! flag for extra print
  LOGICAL                                       :: lxtra  =.FALSE.      ! flag for extra netcdf output
  LOGICAL                                       :: lfull  =.FALSE.      ! flag for full step 
  LOGICAL                                       :: lntr   =.FALSE.      ! flag for neutral density
  LOGICAL                                       :: lchk   =.FALSE.      ! flag for missing files
  LOGICAL                                       :: lbrk   =.FALSE.      ! flag for broken lines
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage :  cdfsigtrp -t T-file -u U-file -v V-file [-s S-file] [-brk BRK-file] .'
     PRINT *,'              ... -smin sigma_min -smax sigma_max -nbins nbins [-print] ...'
     PRINT *,'              ... [-xtra] [-full ] [-vvl W-file] [-refdep ref_depth] ...'
     PRINT *,'              ... [-neutral ] [-section file ] [-temp] [-help]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute density class transports, according to the density class' 
     PRINT *,'       definition (minimum, maximum and number of bins) given in arguments.'
     PRINT *,'      '
     PRINT *,'       Sections information are read from the file ',TRIM(cf_section)
     PRINT *,'       which is a text file built  with pairs of lines giving: (1) section name'
     PRINT *,'       and (2) section location.'
     PRINT *,'       First line with section name may also have 2 additional strings holding'
     PRINT *,'       a prefix for variable output, and a long name to be used as attribute in'
     PRINT *,'       the output file. ' 
     PRINT *,'       Second line gives the location of the section with specification of four'
     PRINT *,'       integer values (imin imax jmin jmax), relative to the model grid.'
     PRINT *,'       Only  zonal or meridional sections are allowed.'
     PRINT *,'      '
     PRINT *,'       This program also offer the possibilty to read ''broken-line'' files,'
     PRINT *,'       holding already extracted data along a pseudo zonal section. In this '
     PRINT *,'       particular case, (''-brk'' switch), no additional information about the'
     PRINT *,'       section is required, nor metric files, as it is already available in the'
     PRINT *,'       input file.'
     PRINT *,'      '
     PRINT *,'       This program can also be used to compute transport by temperatures'
     PRINT *,'       classes, provided the temperatures decrease monotonically downward.'
     PRINT *,'       In this case, use -temp option and of course specify sigma_min, '
     PRINT *,'       sigma_max as temperatures.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       Input data file can be specified either using the 3 following switches:'
     PRINT *,'       -t T-file : netcdf file with temperature and salinity' 
     PRINT *,'          If salinity not in T-file use -s option.'
     PRINT *,'       -u U-file : netcdf file with zonal velocity component'
     PRINT *,'       -v V-file : netcdf file with meridional velocity component'
     PRINT *,'       Or, using the ''-brk'' switch.'
     PRINT *,'        -brk BRK-file : specify a ''broken-line'' file produced by the tool'
     PRINT *,'              cdf_xtrac_brokenline, which is considered already as a pseudo'
     PRINT *,'              zonal section, holding all the relevant metrics for the section.'
     PRINT *,'            '
     PRINT *,'       -smin sigma_min : minimum density for binning'
     PRINT *,'       -smax sigma_max : maximum density for binning'
     PRINT *,'       -nbins nbins : number of bins. This will fix the bin ''width'' '
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-s S-file ]: specify salinity file if not T-file.'
     PRINT *,'       [-full] : for full step configuration' 
     PRINT *,'       [-vvl W-file]: use time varying vertical metrics. Need a W-file for e3w.'
     PRINT *,'       [-xtra] : produce extra netcdf output file which shows the details'
     PRINT *,'               of the sections (normal velocity, density, temperature, '
     PRINT *,'               salinity, transports, isopycnal depths. '
     PRINT *,'       [-print]: write the binned transports on standard output, for each'
     PRINT *,'               sections.'
     PRINT *,'       [-refdep ref_depth ]: give a reference depths for the computation of'
     PRINT *,'               potential density. Sigma_min, sigma_max must be adapted '
     PRINT *,'               accordingly.'
     PRINT *,'       [-neutral]: use neutral density instead of potential density '
     PRINT *,'       [-section file] : give the name of section file.'
     PRINT *,'               Default is ', TRIM(cf_section)
     PRINT *,'       [-temp] : use temperature instead of density for binning'
     PRINT *,'       [-help] : give commented example for the section file.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ', TRIM(cn_fhgr),', ', TRIM(cn_fzgr),' and ', TRIM(cf_section)
     PRINT *,'         If option ''-brk'' is used, there is no need for these files, the '
     PRINT *,'         metrics being already embarked into this section file.'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       Netcdf file : There is 1 netcdf file per section. File name is build'
     PRINT *,'         from section name : Section_name_trpsig.nc'
     PRINT *,'         variables : sigma_class (upper limit of the bin)'
     PRINT *,'                     sigtrp : transport (Sv per bin)'
     PRINT *,'      '
     PRINT *,'       ascii file  : ', TRIM(cf_out) 
     PRINT *,'      '
     PRINT *,'      Standard output : the results are written on standard output only if '
     PRINT *,'         the -print option is used.'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'      cdfrhoproj, cdftransport, cdfsigintegr '
     PRINT *,'      '
     STOP 
  ENDIF

  ! browse command line
  ijarg = 1 ; ireq = 0 ; nreq=6
  cf_sfil='none'
  DO WHILE ( ijarg <= narg )
     CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-t'      ) ; CALL getarg(ijarg, cf_tfil ) ; ijarg=ijarg+1 ; ireq=ireq+1
     CASE ( '-u'      ) ; CALL getarg(ijarg, cf_ufil ) ; ijarg=ijarg+1 ; ireq=ireq+1
     CASE ( '-v'      ) ; CALL getarg(ijarg, cf_vfil ) ; ijarg=ijarg+1 ; ireq=ireq+1
     CASE ( '-brk'    ) ; CALL getarg(ijarg, cf_brk  ) ; ijarg=ijarg+1 ; ireq=ireq+1
        ;                 lbrk   = .TRUE. ; nreq= 4
     CASE ( '-smin'   ) ; CALL getarg(ijarg, cldum   ) ; ijarg=ijarg+1 ; READ(cldum,*) dsigma_min ; ireq=ireq+1
     CASE ( '-smax'   ) ; CALL getarg(ijarg, cldum   ) ; ijarg=ijarg+1 ; READ(cldum,*) dsigma_max ; ireq=ireq+1
     CASE ( '-nbins'  ) ; CALL getarg(ijarg, cldum   ) ; ijarg=ijarg+1 ; READ(cldum,*) nbins      ; ireq=ireq+1
        ! options
     CASE ( '-s'      ) ; CALL getarg(ijarg, cf_sfil ) ; ijarg=ijarg+1 ; ireq=ireq+1
     CASE ( '-full'   ) ; lfull  = .TRUE.
     CASE ( '-vvl'    ) ; lg_vvl = .TRUE.
        ;                 CALL getarg(ijarg, cf_wfil ) ; ijarg=ijarg+1 ; ireq=ireq+1
     CASE ( '-xtra'   ) ; lxtra  = .TRUE.
     CASE ( '-print'  ) ; lprint = .TRUE.
     CASE ( '-temp'   ) ; ltemp  = .TRUE. 
     CASE ( '-help'   ) ; CALL file_example ; STOP 99
     CASE ( '-refdep' ) ; CALL getarg(ijarg, cldum      ) ; ijarg=ijarg+1 ; READ(cldum,*) refdep
     CASE ( '-section') ; CALL getarg(ijarg, cf_section ) ; ijarg=ijarg+1 
     CASE ( '-neutral') ; lntr   = .TRUE.
     CASE DEFAULT       ; PRINT *,' ERROR : ',TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  END DO

  IF ( cf_sfil == 'none' ) cf_sfil=cf_tfil

  IF ( ireq /= nreq ) THEN
     PRINT *,' ERROR :  not enough input arguments. See the usage message and correct.' 
     STOP 99
  ENDIF

  IF ( lbrk ) THEN
     cn_fzgr = cf_brk
     cn_fhgr = cf_brk
     cf_tfil = cf_brk
     cf_sfil = cf_brk
     cf_ufil = cf_brk
     cf_vfil = cf_brk 
     cf_section = cf_brk  ! never used in this case, just for check
  ENDIF

  ! check for file existence
  lchk = lchk .OR. chkfile( cn_fzgr    )
  lchk = lchk .OR. chkfile( cn_fhgr    )
  lchk = lchk .OR. chkfile( cf_section )
  lchk = lchk .OR. chkfile( cf_tfil    )
  lchk = lchk .OR. chkfile( cf_sfil    )
  lchk = lchk .OR. chkfile( cf_ufil    )
  lchk = lchk .OR. chkfile( cf_vfil    )
  IF ( lchk ) STOP 99 ! missing file

   ! Look for missing value for salinity, U and V
   zsps = getspval(cf_sfil, cn_vosaline )
   zspu = getspval(cf_ufil, cn_vozocrtx )
   zspv = getspval(cf_vfil, cn_vomecrty )


  IF ( lg_vvl )  THEN
     cn_fe3u = cf_ufil
     cn_fe3v = cf_vfil
     cn_fe3w = cf_wfil
     cn_ve3u = cn_ve3uvvl
     cn_ve3v = cn_ve3vvvl
     cn_ve3w = cn_ve3wvvl
  ENDIF

  IF ( ltemp)  THEN  ! temperature decrease downward. Change sign and swap min/max
     refdep = -10.   ! flag value
     dltsig     = dsigma_max  ! use dltsig as dummy variable for swapping
     dsigma_max = -dsigma_min
     dsigma_min = -dltsig
  ENDIF

  ! define global attribute with command line
  CALL SetGlobalAtt( cglobal)

  ! get the attribute iweight from vomecrty
  iweight = getatt(cf_vfil, cn_vomecrty, 'iweight')
  IF ( iweight == 0 ) iweight = 1  ! if 0 means that it is not defined.

  ALLOCATE ( stypvar(nboutput), ipk(nboutput), id_varout(nboutput) )
  ALLOCATE ( rdumlon(ikx,iky),  rdumlat(ikx,iky)                   )

  rdumlon(:,:)=0.
  rdumlat(:,:)=0.

  ipk(1)=nbins ! sigma for each level
  ipk(2)=nbins ! transport for each level
  ! initialisation of variable names etc... is done according to section name

  ! Initialise sections from file 
  ! first call to get nsection and allocate arrays 
  IF ( lbrk ) THEN 
     npiglo = getdim (cf_brk, cn_x)
     nsection = 1 ; iimina=1 ; iimaxa=npiglo ; ijmina=1 ; ijmaxa=1
  ELSE             
     nsection = 0 
     CALL section_init(cf_section, csection,cvarname,clongname,iimina, iimaxa, ijmina, ijmaxa, nsection)
  ENDIF
  ALLOCATE ( csection(nsection), cvarname(nsection), clongname(nsection) )
  ALLOCATE ( iimina(nsection), iimaxa(nsection), ijmina(nsection),ijmaxa(nsection) )
  IF ( lbrk )  THEN ! initialise section for true section
     npiglo = getdim (cf_brk, cn_x)
     iimina = 1 ; iimaxa = npiglo ; ijmina = 1 ; ijmaxa = 1
     ! file name for BRK file is <prefix>_<section>.nc
     ipos         = INDEX(cf_brk,'_',.TRUE.)
     csection(1)  = cf_brk(ipos+1:)
     ipos         = INDEX(csection(1),'.',.TRUE.)
     csection(1)  = csection(1)(1:ipos-1)
     cvarname(1)  = csection(1)
     clongname(1) = csection(1)
  ELSE
     CALL section_init(cf_section, csection,cvarname,clongname, iimina,iimaxa,ijmina,ijmaxa, nsection)
  ENDIF

  ! Allocate and build sigma levels and section array
  ALLOCATE ( dsigma_lev (nbins+1) , dtrpbin(nsection,nbins)  )

  dsigma_lev(1)=dsigma_min
  dltsig=( dsigma_max - dsigma_min) / nbins
  DO jclass =2, nbins+1
     dsigma_lev(jclass)= dsigma_lev(1) + (jclass-1) * dltsig
  END DO

  ! Look for vertical size of the domain
  npk = getdim (cf_tfil,cn_z)
  ALLOCATE ( gdept(npk), gdepw(npk) )
  IF ( lfull ) ALLOCATE ( e3t1d(npk), e3w1d(npk))

  ! read gdept, gdepw : it is OK even in partial cells, as we never use the bottom gdep
  IF ( .NOT. lbrk ) THEN
     gdept(:) = getvare3(cn_fzgr, cn_gdept, npk)
     gdepw(:) = getvare3(cn_fzgr, cn_gdepw, npk)
  ENDIF

  IF ( lfull )  THEN 
     e3t1d(:) = getvare3(cn_fzgr, cn_ve3t1d, npk)
     e3w1d(:) = getvare3(cn_fzgr, cn_ve3w1d, npk)
  ENDIF

  !! *  Main loop on sections
  DO jsec=1,nsection
     iimin=iimina(jsec) ; iimax=iimaxa(jsec)
     ijmin=ijmina(jsec) ; ijmax=ijmaxa(jsec)

     IF (iimin == iimax ) THEN        ! meridional section
        npts    = ijmax - ijmin       ! number of segments
        l_merid = .TRUE.

     ELSE IF ( ijmin == ijmax ) THEN  ! zonal section
        npts    = iimax - iimin       ! number of segments
        l_merid = .FALSE.

     ELSE
        PRINT *,' Section ',TRIM(csection(jsec)),' is neither zonal nor meridional :('
        PRINT *,' We skip this section .'
        CYCLE
     ENDIF

     ALLOCATE ( zu(npts,npk), zt(npts,npk), zs(npts,npk), zz(npts,npk), dsig(npts,0:npk)  )
     ALLOCATE ( eu(npts), de3(npts,npk), ddepu(npts, 0:npk), ddepw(npts,0:npk),zmask(npts,npk) )
     ALLOCATE ( tmpm(1,npts), tmpz(npts,1)                                   )
     ALLOCATE ( dwtrp(npts, nbins+1), dhiso(npts,nbins+1), dwtrpbin(npts,nbins) )
     ALLOCATE ( rlonlat(npts,1) )

     zt = 0. ; zs = 0. ; zu = 0. ; ddepu= 0.d0 ; zmask = 0.  ; dsig=0.d0

     IF (l_merid ) THEN   ! meridional section at i=iimin=iimax  ! use getvaryz
        tmpm(:,:)    = getvar(cn_fhgr, cn_ve2u,   1, 1, npts, kimin=iimin, kjmin=ijmin+1)
        eu(:)        = tmpm(1,:)  ! metrics varies only horizontally
        tmpm(:,:)    = getvar(cn_fhgr, cn_vlat2d, 1, 1, npts, kimin=iimin, kjmin=ijmin+1)
        rlonlat(:,1) = tmpm(1,:)  ! latitude in this case

        ! use zt and zs as temporaty variable for e3w
        IF ( lfull ) THEN
           DO ji=1, npts
              de3(ji,:) = e3t1d(:)
              zt( ji,:) = e3w1d(:)
              zs( ji,:) = e3w1d(:)
           ENDDO
        ELSE
            SELECT CASE ( cg_zgr_ver )
            CASE ( 'v2.0' ) ; cn_ve3u = 'e3u_ps' ; cn_ve3w='e3w_ps'
            CASE ( 'v3.0' ) ; cn_ve3u = 'e3u'    ; cn_ve3w='e3w'
            CASE ( 'v3.6' ) ; cn_ve3u = 'e3u_0'  ; cn_ve3w='e3w_0'
            END SELECT
           de3(:,:) = getvaryz(cn_fe3u, cn_ve3u, iimin,   npts, npk, kjmin=ijmin+1 )
           zt( :,:) = getvaryz(cn_fe3w, cn_ve3w, iimin,   npts, npk, kjmin=ijmin+1 )
           zs( :,:) = getvaryz(cn_fe3w, cn_ve3w, iimin+1, npts, npk, kjmin=ijmin+1 )
        ENDIF

        DO ji=1, npts
           ddepu(ji,1) = gdept(1) ! assume that first depth is set by gdept(1)
        ENDDO                    ! for vvl case, it might not be exact ...

        DO jk=2, npk
           DO ji=1,npts
              ddepu(ji,jk) = ddepu(ji,jk-1) +MIN (zt(ji,jk), zs(ji,jk) )
           ENDDO
        ENDDO
        ! normal velocity
        zu( :,:) = getvaryz(cf_ufil, cn_vozocrtx, iimin,   npts, npk, kjmin=ijmin+1 )
        WHERE( zu == zspu ) zu = 0.0

        ! salinity and deduce umask for the section
        zs( :,:) = getvaryz(cf_sfil, cn_vosaline, iimin,   npts, npk, kjmin=ijmin+1 )
        zt( :,:) = getvaryz(cf_sfil, cn_vosaline, iimin+1, npts, npk, kjmin=ijmin+1 )
        zmask = 1.
        WHERE ( zs == zsps .OR. zt == zsps ) zmask = 0.
        zs (:,:) = 0.5 * ( zs(:,:) + zt(:,:) )*zmask

        ! limitation to 'wet' points
        DO jk = 1, npk
           IF ( SUM(zs(:,jk)) == 0 ) THEN
              nk=jk
              EXIT
           ENDIF
        ENDDO
        PRINT *, ' NK = ',nk

        ! temperature
        zt(:,:) = getvaryz(cf_tfil, cn_votemper, iimin  , npts, npk, kjmin=ijmin+1 )
        zz(:,:) = getvaryz(cf_tfil, cn_votemper, iimin+1, npts, npk, kjmin=ijmin+1 )
        zt(:,:) = 0.5 * ( zt(:,:) + zz(:,:) ) *zmask

     ELSE                   ! zonal section at j=ijmin=ijmax ( include BRK-line sections)


        IF (lbrk ) THEN
           ! need to fix de3, ddepu, zu, zs, zt, nk , zmask
           IF ( lfull) THEN 
              DO ji=1, npts
                 de3(ji,:) = e3t1d(:)
              ENDDO
           ELSE
              tmpz(:,:)    = getvar(cn_fhgr, cn_ve1v,   1, npts, 1, kimin=iimin, kjmin=ijmin)
              eu(:)        = tmpz(:,1)
              tmpz(:,:)    = getvar(cn_fhgr, cn_vlon2d, 1, npts, 1, kimin=iimin, kjmin=ijmin)
              rlonlat(:,1) = tmpz(:,1)  ! longitude in this case
              de3(  :,:    ) = getvarxz(cf_brk,  cn_ve3v,     ijmin,   npts, npk, kimin=iimin )
              ddepu(:,1:npk) = getvarxz(cf_brk,  cn_depu3d,   ijmin,   npts, npk, kimin=iimin )
              ddepw(:,1:npk) = getvarxz(cf_brk,  cn_depw3d,   ijmin,   npts, npk, kimin=iimin )
           ENDIF
           zu(   :,:) = getvarxz(cf_vfil, cn_vomecrty, ijmin,   npts, npk, kimin=iimin )
           zt(   :,:) = getvarxz(cf_vfil, cn_votemper, ijmin,   npts, npk, kimin=iimin )
           zs(   :,:) = getvarxz(cf_vfil, cn_vosaline, ijmin,   npts, npk, kimin=iimin )
           zmask(:,:) = getvarxz(cf_vfil, cn_vmask,    ijmin,   npts, npk, kimin=iimin )
           ! limitation to 'wet' points
           ! JMM Broken line mask have a 9999 fil value (to be improved)
           WHERE(zmask == 9999.) zmask=0.

           nk = npk
           DO jk = 1, npk
              IF ( SUM(zmask(:,jk)) == 0 ) THEN
                 nk=jk
                 EXIT
              ENDIF
           ENDDO
           
        ELSE
        tmpz(:,:)    = getvar(cn_fhgr, cn_ve1v,   1, npts, 1, kimin=iimin, kjmin=ijmin)
        eu(:)        = tmpz(:,1)
        tmpz(:,:)    = getvar(cn_fhgr, cn_vlon2d, 1, npts, 1, kimin=iimin, kjmin=ijmin)
        rlonlat(:,1) = tmpz(:,1)  ! longitude in this case

           ! use zt and zs as temporary variable for e3w
           IF ( lfull ) THEN
              DO ji=1, npts
                 de3(ji,:) = e3t1d(:)
                 zt( ji,:) = e3w1d(:)
                 zs( ji,:) = e3w1d(:)
              ENDDO
           ELSE
              SELECT CASE ( cg_zgr_ver )
              CASE ( 'v2.0' ) ; cn_ve3v = 'e3v_ps' ; cn_ve3w='e3w_ps'
              CASE ( 'v3.0' ) ; cn_ve3v = 'e3v'    ; cn_ve3w='e3w'
              CASE ( 'v3.6' ) ; cn_ve3v = 'e3v_0'  ; cn_ve3w='e3w_0'
              END SELECT

              de3(:,:) = getvarxz(cn_fe3v, cn_ve3v, ijmin,   npts, npk, kimin=iimin+1 )
              zt( :,:) = getvarxz(cn_fe3w, cn_ve3w, ijmin,   npts, npk, kimin=iimin+1 )
              zs( :,:) = getvarxz(cn_fe3w, cn_ve3w, ijmin+1, npts, npk, kimin=iimin+1 )
           ENDIF

           DO ji=1, npts
              ddepu(ji,1) = gdept(1)
           ENDDO

           DO jk=2, npk
              DO ji=1,npts
                 ddepu(ji,jk) = ddepu(ji,jk-1) +MIN (zt(ji,jk), zs(ji,jk) )
              ENDDO
           ENDDO

           ! normal velocity
           zu( :,:) = getvarxz(cf_vfil, cn_vomecrty, ijmin,   npts, npk, kimin=iimin+1 )
           WHERE( zu == zspv ) zu = 0.0

           ! salinity and deduce umask for the section
           zs( :,:) = getvarxz(cf_sfil, cn_vosaline, ijmin,   npts, npk, kimin=iimin+1 )
           zt( :,:) = getvarxz(cf_sfil, cn_vosaline, ijmin+1, npts, npk, kimin=iimin+1 )

           zmask = 1.
           WHERE ( zs == zsps .OR. zt == zsps ) zmask = 0.
           zs (:,:) = 0.5 * ( zs(:,:) + zt(:,:) )* zmask

           ! limitation to 'wet' points
           DO jk = 1, npk
              IF ( SUM(zs(:,jk)) == 0 ) THEN
                 nk=jk
                 EXIT
              ENDIF
           ENDDO
          PRINT *,'JMM nk  ', nk

           ! temperature
           zt(:,:) = getvarxz(cf_tfil, cn_votemper, ijmin  , npts, npk, kimin=iimin+1 )
           zz(:,:) = getvarxz(cf_tfil, cn_votemper, ijmin+1, npts, npk, kimin=iimin+1 )
           zt(:,:) = 0.5 * ( zt(:,:) + zz(:,:) )
        ENDIF
     ENDIF

     ! compute density only for wet points
     IF ( lntr ) THEN 
        dsig(:,1:nk)=sigmantr( zt, zs,         npts, nk)*zmask(:,:)
     ELSE
        IF     ( refdep == -10.) THEN  ; dsig(:,1:nk)= -zt(:,:)*zmask(:,:)  ! change sign 
        ELSEIF ( refdep ==   0.) THEN  ; dsig(:,1:nk)=sigma0( zt, zs,         npts, nk)*zmask(:,:)
        ELSE                           ; dsig(:,1:nk)=sigmai( zt, zs, refdep, npts, nk)*zmask(:,:)
        ENDIF
     ENDIF

     dsig(:,0)=dsig(:,1)-1.e-4   ! dummy layer for easy interpolation

!! on each vertical column of water set density of land point to be the bottom most wet density
     DO ji = 1, npts
        DO jk = 1, nk
            IF ( zmask (ji,jk) == 0 ) THEN
               dsig(ji,jk)= dsig(ji,jk-1) +1.e-5  ! in order to have an increase
            ENDIF
        ENDDO
     ENDDO

     ! compute depth of isopynals (nbins+1 )
     DO  jiso =1, nbins+1
        dsigma=dsigma_lev(jiso)
!!!  REM : I and K loop can be inverted if necessary
        DO ji=1,npts
           !           dhiso(ji,jiso) = gdept(npk)  ! for broken line it is easier to use ddepu. Impact ?
           dhiso(ji,jiso) = ddepu(ji,npk)
           DO jk=1,nk 
              IF ( dsig(ji,jk) < dsigma ) THEN
              ELSE
                 ! interpolate between jk-1 and jk
                 dalfa=(dsigma - dsig(ji,jk-1)) / ( dsig(ji,jk) -dsig(ji,jk-1) )
                 IF (ABS(dalfa) > 1.1d0 .OR. dalfa < 0.d0 ) THEN   ! case dsig(0) = dsig(1)-1.e-4
                    dhiso(ji,jiso)= 0.d0
                 ELSE
                    dhiso(ji,jiso)= ddepu(ji,jk)*dalfa + (1.d0-dalfa)* ddepu(ji,jk-1)
                 ENDIF
                 EXIT
              ENDIF
           END DO
        END DO
     END DO

     ! compute transport between surface and isopycn 
     DO jiso = 1, nbins + 1
        dsigma=dsigma_lev(jiso)
        DO ji=1,npts
           dwtrp(ji,jiso) = 0.d0
           IF ( lbrk ) gdepw(:) = ddepw(ji,1:npk)   ! in broken line gdepw is not available as 1d array
           DO jk=1, nk-1
              IF ( gdepw(jk+1) < dhiso(ji,jiso) ) THEN
                 dwtrp(ji,jiso)= dwtrp(ji,jiso) + eu(ji)*de3(ji,jk)*zu(ji,jk)*1.d0
              ELSE  ! last box ( fraction)
                 dwtrp(ji,jiso)= dwtrp(ji,jiso) + eu(ji)*(dhiso(ji,jiso)-gdepw(jk))*zu(ji,jk)*1.d0
                 EXIT  ! jk loop
              ENDIF
           END DO
        END DO
     END DO

     ! binned transport : difference between 2 isopycns
     DO jbin=1, nbins
        dsigma=dsigma_lev(jbin)
        DO ji=1, npts
           dwtrpbin(ji,jbin) = dwtrp(ji,jbin+1) -  dwtrp(ji,jbin) 
        END DO
        dtrpbin(jsec,jbin)=SUM(dwtrpbin(:,jbin) )
     END DO

     ! output of the code for 1 section
     IF (lprint) CALL print_out(jsec)
     IF (lxtra ) CALL cdf_writ(jsec)
     PRINT *,' Total transport in all bins :',TRIM(csection(jsec)),' ',SUM(dtrpbin(jsec,:) )/1.d6

     ! free memory for the next section
     DEALLOCATE ( zu, zt, zs, zz, dsig, ddepu, ddepw, dhiso, dwtrp, dwtrpbin )
     DEALLOCATE ( eu, de3, tmpm, tmpz, zmask, rlonlat             )

  END DO   ! next section

  !! Global Output
  OPEN( numout, FILE=cf_out)
  ipos=INDEX(cf_tfil,'_gridT.nc')
  WRITE(numout,9006)  TRIM(cf_tfil(1:ipos-1))
  WRITE(numout,9005) ' sigma  ', (csection(jsec),jsec=1,nsection)
  DO jiso=1,nbins
     WRITE(numout,9004) dsigma_lev(jiso), (dtrpbin(jsec,jiso),jsec=1,nsection)
  ENDDO
  CLOSE(numout)

  cv_dep='levels'
  ! need to call section_init again in order to reset cvarname, clongname if they where modified 
  ! previously in cdf_writ(  case lxtra=true )
  IF (lxtra .AND. .NOT. lbrk) THEN
     CALL section_init(cf_section, csection,cvarname,clongname, iimina,iimaxa,ijmina,ijmaxa, nsection)
  ENDIF

  DO jsec=1,nsection
     ! setup output variables (section dependant for adaptative variable name (if possible)
     ! define new variables for output 

     CALL CreateOutput (jsec) 

     DO jiso=1,nbins
        rdummy1 = dsigma_lev(jiso)
        rdummy2 = dtrpbin(jsec,jiso)/1.d6  ! Sv
        ierr    = putvar(ncout, id_varout(1), rdummy1, jiso, ikx, iky )
        ierr    = putvar(ncout, id_varout(2), rdummy2, jiso, ikx, iky )
     END DO

     ierr = closeout(ncout)

  END DO

9004 FORMAT(f9.4, 20e16.7)
9005 FORMAT('#',a9, 20(2x,a12,2x) )
9006 FORMAT('# ',a)

CONTAINS

  SUBROUTINE section_init(cdfile, cdsection, cdvarname, cdlongname, kimin, kimax, kjmin, kjmax, knumber)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE section_init  ***
    !!
    !! ** Purpose : Read input ASCII file that defines section names and limit of
    !!              sections.
    !!
    !! ** Method  : At fisrt call only return the number of sections for further
    !!              allocation.  
    !!
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*),                       INTENT(in   ) :: cdfile
    CHARACTER(LEN=256), DIMENSION(knumber), INTENT(out  ) :: cdsection
    CHARACTER(LEN=256), DIMENSION(knumber), INTENT(out  ) :: cdvarname
    CHARACTER(LEN=256), DIMENSION(knumber), INTENT(out  ) :: cdlongname
    INTEGER(KIND=4),                        INTENT(inout) :: knumber
    INTEGER(KIND=4), DIMENSION(knumber),    INTENT(out  ) :: kimin, kimax, kjmin, kjmax

    ! Local variables
    INTEGER(KIND=4)                                       :: jsec
    INTEGER(KIND=4)                                       :: ii, inum=10
    INTEGER(KIND=4)                                       :: ipos  
    CHARACTER(LEN=256)                                    :: cline
    CHARACTER(LEN=80), DIMENSION(3)                       :: cldum
    LOGICAL                                               :: llfirst
    !!----------------------------------------------------------------------
    llfirst=.FALSE.
    IF ( knumber == 0 ) llfirst=.TRUE.

    OPEN(inum, FILE=cdfile)
    REWIND(inum)
    ii = 0

    ! read the file just to count the number of sections
    DO
       READ(inum,'(a)') cline
       IF (INDEX(cline,'EOF') == 0 ) THEN
          READ(inum,*)    ! skip one line
          ii = ii + 1
       ELSE
          EXIT
       ENDIF
    END DO

    knumber=ii
    IF ( llfirst ) RETURN

    REWIND(inum)
    DO jsec=1,knumber
       READ(inum,'(a)') cline
       ii = 0
       cldum(:) = 'none'
       ipos = INDEX(cline,' ')
       DO WHILE ( ipos > 1 ) 
          ii = ii + 1
          cldum(ii) = cline(1:ipos - 1 )
          cline = TRIM ( cline(ipos+1:) )
          ipos  = INDEX( cline,' ' ) 
          IF ( ii >= 3 ) EXIT
       END DO
       cdsection(jsec) = TRIM(cldum(1) )
       cdvarname(jsec) = TRIM(cldum(2) )
       cdlongname(jsec) = TRIM(cldum(3) )
       READ(inum,*    ) kimin(jsec), kimax(jsec), kjmin(jsec), kjmax(jsec)
    END DO

    CLOSE(inum)

  END SUBROUTINE section_init

  SUBROUTINE cdf_writ( ksec)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE cdf_writ  ***
    !!
    !! ** Purpose :  Write output cdf files if required 
    !!
    !! ** Method  :  Most of the variables are global 
    !!
    !!----------------------------------------------------------------------
    INTEGER(KIND=4),   INTENT(in) :: ksec  ! number of the section

    INTEGER(KIND=4)               :: ji, jk
    INTEGER(KIND=4)               :: ivar
    INTEGER(KIND=4)               :: icout
    INTEGER(KIND=4), DIMENSION(4) :: ipk, id_varout

    REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zdum
    TYPE(variable),  DIMENSION(4) :: sl_typvar
    CHARACTER(LEN=255)            :: csuffixvarnam
    CHARACTER(LEN=255)            :: cprefixlongnam
    !!----------------------------------------------------------------------
    IF ( cvarname(ksec) /= 'none' ) THEN
       csuffixvarnam = '_'//TRIM(cvarname(ksec))
    ELSE
       csuffixvarnam = ''
    ENDIF
    IF ( clongname(ksec) /= 'none' ) THEN
       cprefixlongnam = TRIM(clongname(ksec))//'_'
    ELSE
       cprefixlongnam = ''
    ENDIF

    ALLOCATE ( zdum(npts,1))
    ! (along section, depth ) 2D variables
    cf_nc=TRIM(csection(ksec))//'_secdep.nc'
    ! define variables
    ipk(:)=nk
    sl_typvar%rmissing_value    = 0.
    sl_typvar%rmissing_value    = 0.
    sl_typvar%scale_factor      = 1.
    sl_typvar%add_offset        = 0.
    sl_typvar%savelog10         = 0.
    sl_typvar%iwght             = iweight
    sl_typvar%conline_operation = 'N/A'
    sl_typvar%caxis             = 'XZT'

    ivar=1
    sl_typvar(ivar)%cname          = 'temperature'//TRIM(csuffixvarnam)
    sl_typvar(ivar)%cunits         = 'Celsius'
    sl_typvar(ivar)%valid_min      = -2.
    sl_typvar(ivar)%valid_max      = 45.
    sl_typvar(ivar)%clong_name     = TRIM(cprefixlongnam)//'Potential_temperature'
    sl_typvar(ivar)%cshort_name    = 'temperature'

    ivar=ivar+1
    sl_typvar(ivar)%cname          = 'salinity'//TRIM(csuffixvarnam)
    sl_typvar(ivar)%cunits         = 'PSU'
    sl_typvar(ivar)%valid_min      = 0.
    sl_typvar(ivar)%valid_max      = 45.
    sl_typvar(ivar)%clong_name     = TRIM(cprefixlongnam)//'Salinity'
    sl_typvar(ivar)%cshort_name    = 'salinity'

    ivar=ivar+1
    sl_typvar(ivar)%cname          = 'density'//TRIM(csuffixvarnam)
    sl_typvar(ivar)%cunits         = 'kg/m3 -1000'
    sl_typvar(ivar)%valid_min      = 0.
    sl_typvar(ivar)%valid_max      = 45.
    sl_typvar(ivar)%clong_name     = TRIM(cprefixlongnam)//'potential_density'
    sl_typvar(ivar)%cshort_name    = 'density'

    ivar=ivar+1
    sl_typvar(ivar)%cname          = 'velocity'//TRIM(csuffixvarnam)
    sl_typvar(ivar)%cunits         = 'm/s'
    sl_typvar(ivar)%valid_min      = -3.
    sl_typvar(ivar)%valid_max      = 3.
    sl_typvar(ivar)%clong_name     = TRIM(cprefixlongnam)//'Normal_velocity'
    sl_typvar(ivar)%cshort_name    = 'velocity'

    icout = create      (cf_nc, 'none',    npts, 1, nk, cdep=cn_vdeptht                     )
    ierr  = createvar   (icout, sl_typvar, ivar, ipk, id_varout, cdglobal=TRIM(cglobal)     )
    ierr  = putheadervar(icout, cf_tfil,   npts, 1, nk, &
         &   pnavlon=rlonlat, pnavlat=rlonlat, cdep=cn_vdeptht                              )

    !    dtim = getvar1d(cf_tfil, cn_vtimec, 1     )
    !    ierr = putvar1d(icout,   dtim,     1 , 'T')

    DO jk = 1, nk
       zdum(:,1)=zt(:,jk)   ; ierr = putvar ( icout, id_varout(1), zdum, jk, npts, 1 )
       zdum(:,1)=zs(:,jk)   ; ierr = putvar ( icout, id_varout(2), zdum, jk, npts, 1 )
       zdum(:,1)=dsig(:,jk) ; ierr = putvar ( icout, id_varout(3), zdum, jk, npts, 1 )
       zdum(:,1)=zu(:,jk)   ; ierr = putvar ( icout, id_varout(4), zdum, jk, npts, 1 )
    END DO

    ierr = closeout(icout)

    ! (along section, sigma ) 2D variables
    cf_nc=TRIM(csection(ksec))//'_secsig.nc'
    ! define variables
    ipk(:)=nbins
    sl_typvar%rmissing_value    = 99999.
    sl_typvar%rmissing_value    = 99999.
    sl_typvar%scale_factor      = 1.
    sl_typvar%add_offset        = 0.
    sl_typvar%savelog10         = 0.
    sl_typvar%iwght             = iweight
    sl_typvar%conline_operation = 'N/A'
    sl_typvar%caxis             = 'XST'

    ivar=1
    ipk(ivar)=nbins-1
    sl_typvar(ivar)%cname          = 'isodep'//TRIM(csuffixvarnam)
    sl_typvar(ivar)%cunits         = 'm'
    sl_typvar(ivar)%valid_min      = 0.
    sl_typvar(ivar)%valid_max      = 6000.
    sl_typvar(ivar)%clong_name     = TRIM(cprefixlongnam)//'isopycnal_depth'
    sl_typvar(ivar)%cshort_name    = 'isodep'

    ivar=ivar+1
    sl_typvar(ivar)%cname          = 'bintrp'//TRIM(csuffixvarnam)
    sl_typvar(ivar)%cunits         = 'SV'
    sl_typvar(ivar)%valid_min      = -5.
    sl_typvar(ivar)%valid_max      = 5.
    sl_typvar(ivar)%clong_name     = TRIM(cprefixlongnam)//'Binned_transport'
    sl_typvar(ivar)%cshort_name    = 'bintrp'

    ivar=ivar+1
    sl_typvar(ivar)%cname          = 'sumtrp'//TRIM(csuffixvarnam)
    sl_typvar(ivar)%cunits         = 'SV'
    sl_typvar(ivar)%valid_min      = -20.
    sl_typvar(ivar)%valid_max      = 20.
    sl_typvar(ivar)%clong_name     = TRIM(cprefixlongnam)//'cumulated_transport'
    sl_typvar(ivar)%cshort_name    = 'sumtrp'

    icout = create      (cf_nc, 'none',    npts, 1, nbins, cdep='levels'                 )
    ierr  = createvar   (icout, sl_typvar, ivar, ipk, id_varout, cdglobal=TRIM(cglobal)  )
    ierr  = putheadervar(icout, cf_tfil,   npts, 1, nbins, &
         &   pnavlon=rlonlat, pnavlat=rlonlat, pdep=REAL(dsigma_lev), cdep='levels'      )

    PRINT *, 'NBINS', nbins, npts
    DO jk = 1, nbins-1
       zdum(:,1)=dhiso   (:,jk)      ; ierr = putvar ( icout, id_varout(1), zdum, jk, npts, 1 )
    END DO
    DO jk = 1, nbins
       zdum(:,1)=dwtrpbin(:,jk)/1.e6 ; ierr = putvar ( icout, id_varout(2), zdum, jk, npts, 1 )
       zdum(:,1)=dwtrp   (:,jk)/1.e6 ; ierr = putvar ( icout, id_varout(3), zdum, jk, npts, 1 )
    END DO
    ierr = closeout(icout)

    DEALLOCATE ( zdum )

  END SUBROUTINE cdf_writ

  SUBROUTINE print_out(ksec)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE print_out  ***
    !!
    !! ** Purpose :  Print results on standard output 
    !!
    !! ** Method  :  Most of the variables are global and already known 
    !!
    !!----------------------------------------------------------------------
    INTEGER(KIND=4), INTENT(in) :: ksec  ! number of the section

    INTEGER(KIND=4)             :: ji, jk, jiso, jbin
    !!----------------------------------------------------------------------
    WRITE(cfmt_9000,'(a,i4,a)') '(i7,  ',npts,'f8.3)'
    WRITE(cfmt_9001,'(a,i4,a)') '(i7,  ',npts,'f8.0)'
    WRITE(cfmt_9002,'(a,i4,a)') '(f7.3,',npts,'f8.0)'
    WRITE(cfmt_9003,'(a,i4,a)') '(f7.3,',npts,'f8.3)'
    PRINT *,' T (deg C)' 
    DO jk=1,nk
       PRINT cfmt_9000, jk,  (zt(ji,jk),ji=1,npts)
    END DO

    PRINT *,' S (PSU)'
    DO jk=1,nk
       PRINT cfmt_9000,  jk,  (zs(ji,jk),ji=1,npts)
    END DO

    PRINT *,' SIG (kg/m3 - 1000 )'
    DO jk=1,nk
       PRINT cfmt_9000, jk,  (dsig(ji,jk),ji=1,npts)
    END DO

    PRINT *,' VELOCITY (cm/s ) '
    DO jk=1,nk
       PRINT cfmt_9000, jk,  (zu(ji,jk)*100,ji=1,npts)
    END DO

    PRINT *,' GDEPU (m) '
    DO jk=1,nk
       PRINT cfmt_9001,jk,  (ddepu(ji,jk)*zmask(ji,jk),ji=1,npts)
    END DO

    PRINT *, 'E3 (m)'
    DO jk=1,nk
       PRINT cfmt_9001,jk,  (de3(ji,jk)*zmask(ji,jk),ji=1,npts)
    END DO

    PRINT *,' DEP ISO ( m )'
    DO  jiso =1, nbins+1
       PRINT cfmt_9002, dsigma_lev(jiso),(dhiso(ji,jiso),ji=1,npts)
    END DO

    PRINT *,' TRP SURF -->  ISO (SV)'
    DO  jiso =1, nbins+1
       PRINT  cfmt_9003, dsigma_lev(jiso),(dwtrp(ji,jiso)/1.d6,ji=1,npts)
    END DO

    PRINT *,' TRP bins (SV)'
    DO  jbin =1, nbins
       PRINT  cfmt_9003, dsigma_lev(jbin),(dwtrpbin(ji,jbin)/1.d6,ji=1,npts), dtrpbin(ksec,jbin)/1.d6
    END DO
  END SUBROUTINE print_out

  SUBROUTINE CreateOutput(ksec)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    INTEGER(KIND=4), INTENT(in) :: ksec  ! section index
    !!----------------------------------------------------------------------

    IF ( cvarname(ksec) /= 'none' ) THEN
       csuffixvarname='_'//TRIM(cvarname(ksec))
    ELSE
       csuffixvarname=''
    ENDIF
    IF ( clongname(ksec) /= 'none' ) THEN
       cprefixlongname=TRIM(clongname(ksec))//'_'
    ELSE
       cprefixlongname=''
    ENDIF

    stypvar%rmissing_value    = 99999.
    stypvar%scale_factor      = 1.
    stypvar%add_offset        = 0.
    stypvar%savelog10         = 0.
    stypvar%iwght             = iweight
    stypvar%conline_operation = 'N/A'
    stypvar%caxis             = 'ZT'

    IF ( ltemp ) THEN
       stypvar(1)%cname          = 'temp_class'
       stypvar(1)%cunits         = '[]'
       stypvar(1)%valid_min      = 0.
       stypvar(1)%valid_max      = 100.
       stypvar(1)%clong_name     = 'class of potential temperature'
       stypvar(1)%cshort_name    = 'temp_class'

       stypvar(2)%cname          = 'temptrp'//TRIM(csuffixvarname)
       stypvar(2)%cunits         = 'Sv'
       stypvar(2)%valid_min      = -1000.
       stypvar(2)%valid_max      = 1000.
       stypvar(2)%clong_name     = TRIM(cprefixlongname)//'transport in temperature class'
       stypvar(2)%cshort_name    = 'temptrp'
    ELSE
       stypvar(1)%cname          = 'sigma_class'
       stypvar(1)%cunits         = '[]'
       stypvar(1)%valid_min      = 0.
       stypvar(1)%valid_max      = 100.
       stypvar(1)%clong_name     = 'class of potential density'
       stypvar(1)%cshort_name    = 'sigma_class'

       stypvar(2)%cname          = 'sigtrp'//TRIM(csuffixvarname)
       stypvar(2)%cunits         = 'Sv'
       stypvar(2)%valid_min      = -1000.
       stypvar(2)%valid_max      = 1000.
       stypvar(2)%clong_name     = TRIM(cprefixlongname)//'transport in sigma class'
       stypvar(2)%cshort_name    = 'sigtrp'
    ENDIF

    ! create output fileset
    IF (ltemp) THEN  ; cf_outnc = TRIM(csection(ksec))//'_trptemp.nc'
    ELSE             ; cf_outnc = TRIM(csection(ksec))//'_trpsig.nc'
    ENDIF

    ncout = create      (cf_outnc, 'none',  ikx,      iky, nbins, cdep=cv_dep               )
    ierr  = createvar   (ncout,    stypvar, nboutput, ipk, id_varout, cdglobal=TRIM(cglobal))
    ierr  = putheadervar(ncout,    cf_tfil, ikx,      iky, nbins, &
         &   pnavlon=rdumlon, pnavlat=rdumlat, pdep=REAL(dsigma_lev), cdep=cv_dep           )

    dtim = getvar1d(cf_tfil, cn_vtimec, 1     )
    ierr = putvar1d(ncout,   dtim,      1, 'T')

  END SUBROUTINE CreateOutput

  SUBROUTINE file_example
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE file_example  ***
    !!
    !! ** Purpose :  give an example for the dens_section.dat 
    !!
    !!----------------------------------------------------------------------
    PRINT *,'  '
    PRINT *,'  '
    PRINT *,'  '
    PRINT *,'   EXAMPLE of dens_section.dat file'
    PRINT *,'   --------------------------------'
    PRINT *,'  Each section is described by 2 lines :'
    PRINT *,'    line#1 : name_of_section [variable_suffix] [ long_name_prefix ]'
    PRINT *,'    line#2 : imin  imax jmin jmax '
    PRINT *,'     IMPORTANT : the points indicated by imin,jmin  imax,jmax are F-point.'
    PRINT *,'  '
    PRINT *,'  example (taken for ORCA12 configuration) :'
    PRINT *,'01_Denmark_strait denma Denmark_Strait_transport_in_sigma_classes'
    PRINT *,'3043 3162 2496 2496'
    PRINT *,'02_Faoes_Bank_Channel faroe Faroes_Bank_Channel_transport_in_sigma_classes'
    PRINT *,'3318 3318 2398 2420'
    PRINT *,'03_Gibraltar gibra Gibraltar_Strait_transport_in_sigma_classes'
    PRINT *,'3378 3378 1956 1961'
    PRINT *,'04_Gibbs_FZ gibbs Gibbs_Fracture_Zone_transport_in_sigma_classes'
    PRINT *,'3075 3075 2215 2235'
    PRINT *,'  '
    PRINT *,'   with this example there will be 4 output files named :'
    PRINT *,'   01_Denmark_strait_trpsig.nc'
    PRINT *,'   02_Faoes_Bank_Channel_trpsig.nc'
    PRINT *,'   03_Gibraltar.nc'
    PRINT *,'   04_Gibbs_FZ'
    PRINT *,' and taking 03_Gibraltar.nc as example, the variable will be (from ncdump):'
    PRINT *,'  '
    PRINT *,'....  '
    PRINT *,' float sigtrp_gibra(time_counter, levels, y, x) ;'
    PRINT *,' 	sigtrp_gibra:units = "Sv" ;'
    PRINT *,' 	sigtrp_gibra:_FillValue = 99999.f ;'
    PRINT *,' 	sigtrp_gibra:valid_min = -1000.f ;'
    PRINT *,' 	sigtrp_gibra:valid_max = 1000.f ;'
    PRINT *,' 	sigtrp_gibra:long_name = "Gibraltar_Strait_transport_in_sigma_classes_transport in sigma class" ;'
    PRINT *,' 	sigtrp_gibra:short_name = "sigtrp" ;'
    PRINT *,' 	sigtrp_gibra:iweight = 73 ;'
    PRINT *,' 	sigtrp_gibra:online_operation = "N/A" ;'
    PRINT *,' 	sigtrp_gibra:axis = "ZT" ;'
    PRINT *,' 	sigtrp_gibra:scale_factor = 1.f ;'
    PRINT *,' 	sigtrp_gibra:add_offset = 0.f ;'
    PRINT *,' 	sigtrp_gibra:savelog10 = 0.f ;'
    PRINT *,'....  '
    PRINT *, ' '
    PRINT *,'  If no variable name suffix nor longname prefix is given, variable names are '
    PRINT *,'  the same for all sections, preventing the concatenation of all the output '
    PRINT *,'  files into a single file.'
    PRINT *,'  Note that in the given example, the long name is not particularly well chosen,'
    PRINT *,'  as ''_transport in sigma class'' is automatically append to the prefix ! :) '
    PRINT *,'  '
    PRINT *,'  If you are using the DRAKKAR monitoring tools (DMONTOOLS), consider the use'
    PRINT *,'  of the create_sections_list.ksh script to build the dens_section.dat file '
    PRINT *,'  from a configuration data base called drakkar_sections_table.txt.'
    PRINT *,'  '
    PRINT *,'  '
    PRINT *,'  '

  END SUBROUTINE file_example

END PROGRAM cdfsigtrp

 PROGRAM cdfmoy_weighted
  !!======================================================================
  !!                     ***  PROGRAM  cdfmoy_weighted  ***
  !!=====================================================================
  !!  ** Purpose : Compute weighted mean values from already processed
  !!               mean files (by cdfmoy)
  !!
  !!               when computing the time average. 
  !!
  !! History : 2.1  : 11/2009  : J.M. Molines : Original code
  !!           3.0  : 04/2011  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  !!      function       : comments
  !!  setweight   : return weight for given variable and file
  !!----------------------------------------------------------------------
  USE cdfio 
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class time_averaging
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                               :: jk, jt, jvar        ! dummy loop index
  INTEGER(KIND=4)                               :: ierr                ! working integer
  INTEGER(KIND=4)                               :: idep, idep_max      ! possible depth inde
  INTEGER(KIND=4)                               :: narg, iargc, ijarg  ! command line
  INTEGER(KIND=4)                               :: npiglo, npjglo, npk ! size of the domain
  INTEGER(KIND=4)                               :: nvars               ! number of variables in a file
  INTEGER(KIND=4)                               :: nvare3              ! number of variables in e3 file
  INTEGER(KIND=4)                               :: nfiles              ! number of tags to process
  INTEGER(KIND=4)                               :: iweight             ! variable weight
  INTEGER(KIND=4)                               :: ncout               ! ncid of output file
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: id_var              ! array of input var id's
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: ipk                 ! array of output var levels
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: id_varout           ! array of output var id's

  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: v1d                 ! array to read column of data
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: v2d                 ! array to read a layer of data
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: e3                  ! array to read vertical metrics

  REAL(KIND=8)                                  :: dtotal_time, dsumw  ! cumulated times and weights
  REAL(KIND=8), DIMENSION(1)                    :: dtimean, dtim       ! time counter
  REAL(KIND=8), DIMENSION(:),       ALLOCATABLE :: dtab1d              ! array for cumulated values
  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: dtab                ! array for cumulated values
  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: de3s                ! arrays for cumulated e3 (vvl)

  CHARACTER(LEN=256)                            :: cf_in               ! current input file name
  CHARACTER(LEN=256)                            :: cf_out='cdfmoy_weighted.nc' ! output file name
  CHARACTER(LEN=256)                            :: cf_e3               ! file name for reading vertical metrics (vvl)
  CHARACTER(LEN=256)                            :: cv_dep              ! name of depth variable
  CHARACTER(LEN=256)                            :: cv_e3               ! name of e3t variable for vvl
  CHARACTER(LEN=256)                            :: cv_skip             ! name of  variable to skip
  CHARACTER(LEN=256)                            :: cldum               ! dummy character variable
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cf_lst              ! file name list of input files
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cf_lste3            ! file name list of e3 file (vvl)
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_names            ! array of var name
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_namese3          ! array of var name in e3 file
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: clv_dep             ! array of possible depth name or 3rd dim.

  TYPE (variable), DIMENSION(:),    ALLOCATABLE :: stypvar             ! structure for output var attributes
  TYPE (variable), DIMENSION(:),    ALLOCATABLE :: stypvare3           ! dummy in this case

  LOGICAL                                       :: lold5d = .FALSE.      ! flag for old5d output
  LOGICAL                                       :: lmonth = .FALSE.      ! flag for true month output
  LOGICAL                                       :: lleap  = .FALSE.      ! flag for leap years
  LOGICAL                                       :: lnc4   = .FALSE.      ! flag for netcdf4 output with chunking and deflation
  LOGICAL                                       :: ll_vvl                ! working flag for vvl AND 3D fields
  LOGICAL                                       :: le3fil = .FALSE.      ! use external e3 file (vvl)
  LOGICAL                                       :: lchk                  ! flag for checking file existence
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfmoy_weighted -l LST-files [-old5d ] [-month] [-leap] ...'
     PRINT *,'       ... [-skip variable] [-vvl] [-e3 LST-e3] [-o OUT-file] [-nc4]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute weighted average of files. The weight for each file is read from'
     PRINT *,'       the iweight variable attribute. In particular, this attribute is set to'
     PRINT *,'       the number of elements used when computing a time average (''cdfmoy'').'
     PRINT *,'       A primary application is thus for computing annual mean from monthly '
     PRINT *,'       means.' 
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -l LST-files : The list of files to be averaged, which are supposed to'
     PRINT *,'             be of the same type and to contain the same variables.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-old5d ] : This option is used to mimic/replace the cdfmoy_annual which'
     PRINT *,'             is no longer available. With this option, 12 monthly files must be'
     PRINT *,'             given, and it is assumed that the monthly means were computed from'
     PRINT *,'             5d output of a simulation using a noleap  calendar (weights are '
     PRINT *,'             fixed, predetermined).'
     PRINT *,'       [-month ] : This option is used to build annual mean from true month'
     PRINT *,'             output (1mo) in XIOS output for instance.'
     PRINT *,'       [-leap ] : This option has only effect together with the -month option.'
     PRINT *,'             When used set 29 days in february.'
     PRINT *,'       [-skip variable ] : name of variable to skip, in the input file. '
     PRINT *,'       [-vvl ] : Use time-varying vertical metrics for weighted averages.'
     PRINT *,'       [-e3  LST-e3] : give a list of file where to find the e3 if not in data'
     PRINT *,'                      file. List must be in the same order as in -l arguments'
     PRINT *,'       [-o OUT-file] : Specify the name for output file instead of'
     PRINT *,'           ', TRIM(cf_out)
     PRINT *,'       [-nc4 ] : Use netcdf4 chunking and deflation in output file.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       none'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'      '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'       variables : same as in the input files'
     PRINT *,'      '
     PRINT *,'     SEE ALSO : '
     PRINT *,'       cdfmoy, cdfmoyt, cdfmoy_freq'
     PRINT *,'      '
     STOP 
  ENDIF

  ! scan command line and check if files exist
  ijarg = 1 
  DO WHILE ( ijarg <= narg ) 
     CALL getarg ( ijarg, cldum ) ; ijarg = ijarg +1
     SELECT CASE ( cldum )
     CASE ( '-l'     ) ; CALL GetFileList(cf_lst)
        ! options
     CASE ( '-old5d' ) ; lold5d = .TRUE.
     CASE ( '-month' ) ; lmonth = .TRUE.
     CASE ( '-leap'  ) ; lleap  = .TRUE.
     CASE ( '-vvl'   ) ; lg_vvl = .TRUE.
     CASE ( '-e3'    ) ; le3fil = .TRUE.  ; CALL GetFileList(cf_lste3)

     CASE ( '-nc4'   ) ; lnc4   = .TRUE.
     CASE ( '-o'     ) ; CALL getarg ( ijarg, cf_out ) ; ijarg = ijarg +1
     CASE ( '-skip'  ) ; CALL getarg ( ijarg, cv_skip) ; ijarg = ijarg +1
     CASE DEFAULT      ; PRINT *,' ERROR : ', TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  ENDDO
  
  lchk = .FALSE.
  DO jt = 1,nfiles
     lchk = lchk .OR. chkfile ( cf_lst(jt) )
  ENDDO
  IF ( lchk ) STOP 99 ! missing files  
 
  IF ( .NOT. le3fil ) THEN
     ALLOCATE ( cf_lste3(nfiles) )
     cf_lste3 = cf_lst
  ENDIF
 
  ! work with 1rst file for dimension lookup
  cf_in=cf_lst(1)
  

  ! additional check in case of old_5d averaged files
  IF ( lold5d .OR. lmonth ) THEN
     IF ( nfiles /= 12 ) THEN 
        PRINT *,' +++ ERROR : exactly 12 monthly files are required for -old5d/-month options.'
        STOP 99
     ENDIF
  ENDIF

  npiglo = getdim (cf_in, cn_x )
  npjglo = getdim (cf_in, cn_y )

  ! looking for npk among various possible name
  idep_max=8
  ALLOCATE ( clv_dep(idep_max) )
  clv_dep(:) = (/cn_z,'z','sigma','nav_lev','levels','ncatice','icbcla','icbsect'/)
  idep=1  ; ierr=1000
  DO WHILE ( ierr /= 0 .AND. idep <= idep_max )
     npk  = getdim (cf_in, clv_dep(idep), cdtrue=cv_dep, kstatus=ierr)
     idep = idep + 1
  ENDDO

  IF ( ierr /= 0 ) THEN  ! none of the dim name was found
      PRINT *,' assume file with no depth'
      npk=0
  ENDIF

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk

  nvars = getnvar(cf_in)
  PRINT *,' nvars =', nvars

  ALLOCATE(               dtab(npiglo,npjglo), v2d(npiglo,npjglo) )
  IF ( lg_vvl ) ALLOCATE( de3s(npiglo,npjglo),  e3(npiglo,npjglo) )
  ALLOCATE (cv_names(nvars) )
  ALLOCATE (stypvar(nvars)  )
  ALLOCATE (id_var(nvars), ipk(nvars), id_varout(nvars) )

  ! Prepare output files
  CALL CreateOutput
  ! for vvl, look for e3x variable in the file
  cv_e3 = 'none'
  IF ( lg_vvl ) THEN
   IF ( le3fil ) THEN
    nvare3=getnvar(cf_lste3(1))
    ALLOCATE(cv_namese3(nvare3))
    ALLOCATE (stypvare3(nvare3)  )
    cv_namese3(:) = getvarname(cf_lste3(1), nvare3, stypvare3)
    DO jvar = 1, nvare3
      IF ( INDEX(cv_namese3(jvar), 'e3' ) /= 0 .OR. INDEX(cv_namese3(jvar), cn_ve3tvvl ) /= 0 ) THEN
         cv_e3=cv_namese3(jvar)
         EXIT
      ENDIF
    ENDDO
   ELSE
    DO jvar = 1, nvars
      ! Caution for CMIP6 if cn_ve3xxx differs from file to files... 
      IF ( INDEX(cv_names(jvar), 'e3' ) /= 0 .OR. INDEX(cv_names(jvar), cn_ve3tvvl ) /= 0 ) THEN
         cv_e3=cv_names(jvar)
         EXIT
      ENDIF
    ENDDO
   ENDIF
  ENDIF

  DO jvar = 1,nvars
     ll_vvl=lg_vvl .AND.  (ipk(jvar) > 1 .AND. cv_names(jvar)/= cv_e3) 
     ! JMM : assume 2D var are not weigthed averaged as well as e3 variable in case of vvl
     IF ( cv_names(jvar) == cn_vlon2d .OR. &
          cv_names(jvar) == cn_vlat2d .OR. &
          cv_names(jvar) == 'none'    .OR. &
          cv_names(jvar) == cv_skip        ) THEN
        ! skip these variable
     ELSE
        PRINT *,' Working with ', TRIM(cv_names(jvar)), ipk(jvar)
        IF ( npiglo == 1 .AND. npjglo == 1 ) THEN 
         !
           ALLOCATE (v1d( ipk(jvar)), dtab1d(ipk(jvar)) )
           dtab1d(:) = 0.d0 ; dtotal_time=0.d0 ; dsumw=0.d0
           DO jt=1, nfiles
              cf_in = cf_lst(jt)
              iweight   = setweight(cf_in, jt, cv_names(jvar)) 
              dsumw     = dsumw + iweight
              dtim = getvar1d(cf_in, cn_vtimec, 1 )
              dtotal_time = dtotal_time + iweight * dtim(1)
              v1d=getvare3(cf_in, cv_names(jvar), ipk(jvar) )
              dtab1d(:)=dtab1d(:) + iweight * v1d(:)
           ENDDO
           dtimean(1)= dtotal_time/dsumw
           ierr      = putvar1d(ncout, dtimean, 1, 'T')
           ierr      = putvar(ncout, id_varout(jvar), SNGL(dtab1d(:)/dsumw), ipk(jvar), 'vert', ktime=1 , kwght=INT(dsumw) )  ! module interface to putvare3
           DEALLOCATE (v1d, dtab1d)
        ELSE
        DO jk = 1, ipk(jvar)
           PRINT *,'Level ',jk, TRIM( cv_names(jvar))
           dtab(:,:) = 0.d0 ; dtotal_time = 0.d0 ; dsumw=0.d0
           IF ( ll_vvl ) THEN  ; de3s(:,:)  = 0.d0    ; ENDIF

           DO jt = 1, nfiles
              cf_in = cf_lst(jt)
              iweight   = setweight(cf_in, jt, cv_names(jvar)) 
              dsumw     = dsumw + iweight
              v2d(:,:)  = getvar(cf_in, cv_names(jvar), jk ,npiglo, npjglo )

              IF ( ll_vvl ) THEN
                 cf_e3     = cf_lste3(jt)
!
! in this program we do not support multiple time frame per file ==> ktime = 1
                 e3(:,:)   = getvar (cf_e3, cv_e3, jk ,npiglo, npjglo, ktime=1 )
                 WHERE (e3 <= 0 ) e3 = 0.1  ! never mind, it is masked
                 de3s(:,:) = de3s(:,:) + iweight * e3(:,:)  ! cumulate e3
                 dtab(:,:) = dtab(:,:) + iweight * e3(:,:) * v2d(:,:)
              ELSE
                 dtab(:,:) = dtab(:,:) + iweight * v2d(:,:)
              ENDIF

              IF (jk == 1 .AND. jvar == nvars )  THEN
                 dtim        = getvar1d(cf_in, cn_vtimec, 1 )
                 dtotal_time = dtotal_time + iweight * dtim(1)
              END IF
           END DO

           ! finish with level jk ; compute mean (assume spval is 0 )
           ! store variable on outputfile
           IF ( ll_vvl ) THEN
             ierr = putvar(ncout, id_varout(jvar), SNGL(dtab(:,:)/de3s ), jk, npiglo, npjglo, kwght=INT(dsumw) )
           ELSE
             ierr = putvar(ncout, id_varout(jvar), SNGL(dtab(:,:)/dsumw), jk, npiglo, npjglo, kwght=INT(dsumw) )
           ENDIF
           IF (jk == 1 .AND. jvar == nvars )  THEN
              dtimean(1) = dtotal_time/dsumw
              ierr       = putvar1d(ncout, dtimean, 1, 'T')
           END IF
        END DO  ! loop to next level
        END IF ! 1D variable
     END IF
  END DO ! loop to next var in file

  ierr = closeout(ncout)

CONTAINS

  INTEGER(KIND=4) FUNCTION setweight( cdfile, kt, cdvar )
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION setweight  ***
    !!
    !! ** Purpose : Return the weight of cdvar in cdfile
    !!
    !! ** Method  : Get attribute iweight from cdfvar in cdfile.
    !!              If lold5d is true, assume weight for 5d build monthly 
    !!              means. If iweight not found 1 is return.
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*),   INTENT(in) :: cdfile
    INTEGER(KIND=4),    INTENT(in) :: kt
    CHARACTER(LEN=*),   INTENT(in) :: cdvar

    INTEGER(KIND=4), DIMENSION(12) :: iweight5d=(/6,5,7,6,6,6,6,6,6,6,6,7/)
    INTEGER(KIND=4), DIMENSION(12) :: iweightmo=(/31,28,31,30,31,30,31,31,30,31,30,31/)
    INTEGER(KIND=4), DIMENSION(12) :: iweightleap=(/31,29,31,30,31,30,31,31,30,31,30,31/)
    !!----------------------------------------------------------------------
    IF ( lold5d ) THEN 
       setweight = iweight5d(kt)
    ELSE IF ( lmonth ) THEN
       IF ( lleap ) THEN
          setweight = iweightleap(kt)
       ELSE
          setweight = iweightmo(kt)
       ENDIF
    ELSE
       setweight = getatt( cdfile, cdvar, 'iweight') 
       IF ( setweight == 0 ) setweight = 1
    ENDIF

  END FUNCTION setweight
  
  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file 
    !!
    !! ** Method  :  Create file, define dims and variables
    !!
    !!----------------------------------------------------------------------
    ! get list of variable names and collect attributes in stypvar (optional)
    cv_names(:) = getvarname(cf_in, nvars, stypvar)

    id_var(:)   = (/(jvar, jvar=1,nvars)/)

    ! ipk gives the number of level or 0 if not a T[Z]YX  variable
    ipk(:)     = getipk(cf_in, nvars, cdep=cv_dep)
    WHERE( ipk == 0 ) cv_names='none'
    stypvar(:)%cname = cv_names

    DO jk = 1, nvars
       stypvar(jk)%ichunk  = (/ npiglo, MAX(1,npjglo/30), 1, 1 /)
    ENDDO

    ! create output file taking the sizes in cf_in
    ncout = create      (cf_out, cf_in,   npiglo, npjglo, npk,      cdep=cv_dep , ld_nc4=lnc4 )
    ierr  = createvar   (ncout , stypvar, nvars,  ipk,    id_varout             , ld_nc4=lnc4 )
    ierr  = putheadervar(ncout , cf_in,   npiglo, npjglo, npk,      cdep=cv_dep               )
  END SUBROUTINE CreateOutput

  SUBROUTINE GetFileList (cd_lst )
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE GetFileList  ***
    !!
    !! ** Purpose :  Set up a file list given on the command line as 
    !!               blank separated list
    !!
    !! ** Method  :  Scan the command line until a '-' is found
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*), DIMENSION(:), ALLOCATABLE, INTENT(inout) :: cd_lst
    INTEGER (KIND=4)  :: ji
    INTEGER (KIND=4)  :: icur
    !!----------------------------------------------------------------------
    !!
    nfiles=0
    ! need to read a list of file ( number unknow ) 
    ! loop on argument till a '-' is found as first char
    icur=ijarg                          ! save current position of argument number
    DO ji = icur, narg                  ! scan arguments till - found
       CALL getarg ( ji, cldum )
       IF ( cldum(1:1) /= '-' ) THEN ; nfiles = nfiles+1
       ELSE                          ; EXIT
       ENDIF
    ENDDO
    ALLOCATE (cd_lst(nfiles) )
    DO ji = icur, icur + nfiles -1
       CALL getarg(ji, cd_lst( ji -icur +1 ) ) ; ijarg=ijarg+1
    END DO
  END SUBROUTINE GetFileList

END PROGRAM cdfmoy_weighted

MODULE modpoly
  !!======================================================================
  !!                     ***  MODULE  modpoly  ***
  !! Determine if a given point is within a polygon or not. This module is
  !! inherited from de finite element mesh generator program (TRIGRID) 
  !!=====================================================================
  !! History :  2.1  : 03/2006  : J.M. Molines : Port from trigrid
  !!            3.0  : 12/2010  : J.M. Molines : Doctor norm + Licence
  !!
  !!          Use algorithms developped in the late 80's for a finite element
  !!          mesh generator (TRIGRID) by R. Walters, C. Werner et Al.
  !!          Some original comments are maintained for references.
  !!----------------------------------------------------------------------

  !!----------------------------------------------------------------------
  !!   routines      : description
  !!   ReadPoly      : Read polygon file 
  !!   PrepPoly      : Compute elements of the sides of polygon
  !!   InPoly        : Check if a point in in or out of a polygon
  !!   PointSlope    : Internal routine which computes slopes and coeff, of the side
  !!----------------------------------------------------------------------

  IMPLICIT NONE

  PRIVATE

  INTEGER(KIND=4), PUBLIC , PARAMETER :: jpvert = 50  !: Number of vertex per polygon
  INTEGER(KIND=4), PUBLIC , PARAMETER :: jpolys = 20  !: Number of polygons.

  ! - Storage for polygon definitions
  INTEGER(KIND=4)                    :: numpolys            ! number of of polygons currently defined
  INTEGER(KIND=4), DIMENSION(jpolys) :: nvertcnt            ! number of vertices of a given polygon

  REAL(KIND=4), DIMENSION(jpolys,jpvert+1) :: vertx, verty  ! 2dim. array of polygons and their X,Y  coordinates
  REAL(KIND=4)                             :: rmaxx, rmaxy  ! max x,y of polygon coordinates
  REAL(KIND=4)                             :: rminx, rminy  ! min x,y of polygon coordinates
  REAL(KIND=8), DIMENSION(jpvert)          :: slope         ! slope of the sides of polygone
  REAL(KIND=8), DIMENSION(jpvert)          :: ra, rb, rc    ! equation of side of polygon

  PUBLIC  :: ReadPoly
  PUBLIC  :: PrepPoly
  PUBLIC  :: InPoly
  PRIVATE :: PointSlope

  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2010, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------

CONTAINS 

  SUBROUTINE ReadPoly(cdfront, kpoly, cdarea)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE ReadPoly  ***
    !!
    !! ** Purpose : read an ASCII file with names of polygon area
    !!        and vertices.  
    !!
    !! References :  late 80's trigrid (Walters et Al.)
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*),                 INTENT(in) :: cdfront ! Name of input file
    INTEGER(KIND=4),                 INTENT(out) :: kpoly   ! number of poylgons
    CHARACTER(LEN=*), DIMENSION (:), INTENT(out) :: cdarea  ! Name of the polygonal area

    INTEGER(KIND=4) :: jj                          ! dummy loop index
    INTEGER(KIND=4),DIMENSION(jpolys) :: ipac      ! flag for Pacific area (across date line )
    INTEGER(KIND=4) :: inum=8                      ! logical unit for input file
    INTEGER(KIND=4) :: ipoly                       ! polygon counter
    INTEGER(KIND=4) :: ivert                       ! number of vertices of a polygon
    !!----------------------------------------------------------------------
    OPEN (inum,FILE=cdfront)
    ipoly=0
    !
    DO WHILE (.TRUE.)
       ipoly=ipoly+1
       READ(inum,'(a)',END=995) cdarea(ipoly)                   ! 1rst line of block : name of polygon
       READ(inum,*)nvertcnt(ipoly), ipac(ipoly)                 ! 2nd : number of vertices, 
       ivert=nvertcnt(ipoly)
       READ(inum,*)(vertx(ipoly,jj),verty(ipoly,jj),jj=1,ivert)  ! 3rd : (x,y) pairs foreach vertex
       ! take care of the date line for pacific zone
       IF (ipac(ipoly) == 1 ) THEN
          DO jj=1,ivert 
             IF (vertx(ipoly,jj) < 0 ) vertx(ipoly,jj) = vertx(ipoly,jj) + 360.
          END DO
       ENDIF

       ! Automatically close the polygon
       vertx(ipoly,ivert+1)=vertx(ipoly,1)               
       verty(ipoly,ivert+1)=verty(ipoly,1)
       ! add dummy 0.001 to integer vertex coordinates... to avoid singular problem 
       DO jj=1, ivert+1
         IF ( (vertx(ipoly, jj) - INT( vertx(ipoly, jj) ) ) == 0 ) vertx(ipoly, jj) = vertx(ipoly, jj)+0.001
         IF ( (verty(ipoly, jj) - INT( verty(ipoly, jj) ) ) == 0 ) verty(ipoly, jj) = verty(ipoly, jj)+0.001
       END DO
    ENDDO

995 kpoly=ipoly-1

    CLOSE(inum)

  END SUBROUTINE ReadPoly


  SUBROUTINE PrepPoly ( kpolyid )
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE PrepPoly  ***
    !!
    !! ** Purpose :  determine  polygon information in preparation for
    !!               a call to InPoly. 
    !!
    !! ** Method  :  returns slope and equation of lines (ra, rc, rb)
    !!               as well as the min/max of polygon coordinates
    !!
    !! References :  Trigrid  
    !!----------------------------------------------------------------------
    INTEGER(KIND=4) ,INTENT(in) :: kpolyid   ! polygon Id

    INTEGER(KIND=4) ji        ! dummy loop index
    INTEGER(KIND=4) inumvert   ! number of vertices for polygon kpolyid
    !!----------------------------------------------------------------------
    !     - get slopes & line equations for each polygon boundary
    inumvert = nvertcnt(kpolyid)
    DO ji = 1, inumvert-1
       CALL PointSlope ( slope(ji), vertx(kpolyid,ji), vertx(kpolyid,ji+1),       &
            &                       verty(kpolyid,ji), verty(kpolyid,ji+1),       &
            &                       ra(ji), rb(ji), rc(ji) )
    END DO
    !       - ( ji = 1, inumvert-1 )
    CALL PointSlope ( slope(inumvert), vertx(kpolyid,inumvert), vertx(kpolyid,1), &
            &                          verty(kpolyid,inumvert), verty(kpolyid,1), &
            &                          ra(inumvert), rb(inumvert), rc(inumvert) )

    !     - calculate the max x,y's of polygon
    rmaxx = vertx(kpolyid,1)
    rmaxy = verty(kpolyid,1)
    DO ji = 1, inumvert
       IF (vertx(kpolyid,ji) >  rmaxx)  rmaxx = vertx(kpolyid,ji)
       IF (verty(kpolyid,ji) >  rmaxy)  rmaxy = verty(kpolyid,ji)
    END DO

    !     - calculate the min x,y's of polygon
    rminx = vertx(kpolyid,1)
    rminy = verty(kpolyid,1)
    DO ji = 1, inumvert
       IF (vertx(kpolyid,ji) <  rminx)  rminx = vertx(kpolyid,ji)
       IF (verty(kpolyid,ji) <  rminy)  rminy = verty(kpolyid,ji)
    END DO

  END SUBROUTINE PrepPoly


  SUBROUTINE InPoly ( kpolyid, pxpoint, pypoint, ld_in )
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE InPoly  ***
    !!
    !! ** Purpose :  To see if a point is inside or outside of the specified
    !!        polygon. 
    !!
    !! ** Method  :  Use the equation of the side of the polygon to determine
    !!               if a point is in (ld_in = true) or out (ld_in = false) 
    !!
    !! References : Trigrid 
    !!----------------------------------------------------------------------
    INTEGER(KIND=4), INTENT(in) ::  kpolyid           ! Polygon ID
    REAL(KIND=4),    INTENT(in) ::  pxpoint, pypoint  ! Position to check
    LOGICAL,        INTENT(out) :: ld_in              ! True if in the polygon

    INTEGER(KIND=4) :: ji
    INTEGER(KIND=4) :: icross, inumvert
    REAL(KIND=8)    :: zxpt, zx, zy, zevenodd
    !!----------------------------------------------------------------------
    inumvert = nvertcnt(kpolyid)
    !     - store coordinates of point to test
    zx = pxpoint
    zy = pypoint
    !     - get the number of cross with the polygon boundary
    icross = 0
    !     - see if point falls in the max and min range of polygon
    IF ( zx <=  rmaxx ) THEN
       IF ( zx >=  rminx ) THEN
          IF ( zy <=  rmaxy ) THEN
             IF ( zy >=  rminy ) THEN
                !               - step through the polygon boundaries
                DO ji = 1, inumvert
                   !                 - see if slope = 9999 and if point is on same y axis
                   IF ( slope(ji) ==  9999 ) THEN
                      IF ( zx >=  vertx(kpolyid,ji) ) THEN
                         IF ( ji ==  inumvert ) THEN
                            IF (        ( (zy <=  verty(kpolyid,inumvert) ) .AND.    &
                                 &        (zy >   verty(kpolyid,1)        ) ) .OR.   &
                                 &      ( (zy >=  verty(kpolyid,inumvert) ) .AND.    &
                                 &        (zy <   verty(kpolyid,1)        ) ) ) THEN
                               !                         - it has crossed the polygon boundary
                               icross = icross + 1
!                              if (zy == 398) print *, zx, zy, icross ,'A', ji
                            ENDIF ! ( zy test )
                         ELSEIF (       ( (zy <=  verty(kpolyid,ji)   ) .AND.        &
                              &           (zy >   verty(kpolyid,ji+1) ) ) .OR.       &
                              &         ( (zy >=  verty(kpolyid,ji)   ) .AND.        &
                              &           (zy <   verty(kpolyid,ji+1) ) ) ) THEN
                            !                       - it has crossed the polygon boundary
                            icross = icross + 1
!                              if (zy == 398) print *, zx, zy, icross,'B', ji
                         ENDIF !    ( ji = inumvert )
                      ENDIF   !    ( zx >= vertx(kpolyid,ji) )
                      !                   - see if normal slope (+ or -), and if point is not
                      !                    - higher or lower than y endpoints of the vertices
                   ELSEIF ( slope(ji) .NE. 0 ) THEN
                      zxpt = ( rc(ji) + zy ) / ra(ji) 
                      IF ( ji ==  inumvert ) THEN
                         IF (            ( (zxpt <=  vertx(kpolyid,inumvert) ) .AND.   &
                              &            (zxpt >   vertx(kpolyid,1)        ) ) .OR.  &
                              &          ( (zxpt >=  vertx(kpolyid,inumvert) ) .AND.   &
                              &            (zxpt <   vertx(kpolyid,1)        ) ) ) THEN
                            IF ( zx >=  zxpt) THEN
                               !                          - it has crossed the polygon boundary
                               icross = icross + 1
!                              if (zy == 398) print *, zx, zy, icross,'C', ji
                            ENDIF ! ( zx >= zxpt )
                         ENDIF !  ( zxpt test )
                      ELSEIF (            ( (zxpt <=  vertx(kpolyid,ji)   ) .AND.     &
                           &                (zxpt >   vertx(kpolyid,ji+1) ) ) .OR.    &
                           &              ( (zxpt >=  vertx(kpolyid,ji)   ) .AND.     &
                           &                (zxpt <   vertx(kpolyid,ji+1) ) ) ) THEN
                         IF ( zx >=   zxpt ) THEN
                            !                       - it has crossed the polygon boundary
                            icross = icross + 1
!                              if (zy == 398) print *, zx, zy, icross,'D', ji, slope(ji), zxpt
                         ENDIF ! ( zx >= zxpt )
                      ENDIF ! ( ji = inumvert )
                   ENDIF !  ( zxpt test )
                END DO !  ( ji = 1, inumvert )
                !          - decide how many times scanline crossed poly bounds
                zevenodd = AMOD ( ( icross * 1.0 ), 2.0 )
                IF ( zevenodd .NE. 0 ) THEN
                   !            - point is in polygon
                   ld_in = .TRUE.
                ELSE
                   ld_in = .FALSE.
                ENDIF
                !            - ( zevenodd ne 0 )
             ELSE
                ld_in = .FALSE.
             ENDIF
             !          - ( zy >= rminy )
          ELSE
             ld_in = .FALSE.
          ENDIF
          !           - ( zy <= rmaxy )
       ELSE
          ld_in = .FALSE.
       ENDIF
       !         - ( zx >= rminx )
    ELSE
       ld_in = .FALSE.
    ENDIF
    !       - ( zx <= rmaxx )

  END SUBROUTINE InPoly

  SUBROUTINE PointSlope ( pslup, pvertxa, pvertxb, pvertya, pvertyb, pax, pby, pcnstnt )
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE PointSlope  ***
    !!
    !! ** Purpose :   To get the slope and general equations of lines. 
    !!
    !! ** Method  :  GIVEN: vertxa, vertxb, vertya, vertyb = endpoints of line section
    !!                            to operate on.
    !!             RETURNS: slup = slope of the line section
    !!              ax, by, cnstnt = general eqation of the line section. 
    !!
    !! References :    trigrid
    !!----------------------------------------------------------------------
    REAL(KIND=8), INTENT(out) :: pslup
    REAL(KIND=4),  INTENT(in) :: pvertxa, pvertxb, pvertya, pvertyb
    REAL(KIND=8), INTENT(out) :: pax, pby, pcnstnt

    REAL(KIND=8) :: zvertxa, zvertxb, zvertya, zvertyb
    REAL(KIND=8) :: zrise, zrun
    !!----------------------------------------------------------------------

    zvertxa = pvertxa  ; zvertxb = pvertxb 
    zvertya = pvertya  ; zvertyb = pvertyb 

    zrise = zvertyb - zvertya
    zrun  = zvertxb - zvertxa

    IF ( zrun ==  0 ) THEN
       pslup = 9999
    ELSE
       pslup = zrise / zrun
    ENDIF

    IF ( ABS(pslup) <=  0.001 ) THEN
       pslup = 0.0
    ENDIF

    IF ( pslup ==  0 ) THEN
       pax = pslup
       pby = 1
       pcnstnt = zvertya
    ELSEIF ( pslup ==  9999 ) THEN
       pax = 1
       pby = 0
       pcnstnt = zvertxa
    ELSE
       pax = pslup
       pby = -1
       pcnstnt = ( pslup * zvertxa - zvertya )
    ENDIF

  END SUBROUTINE PointSlope

END MODULE modpoly

PROGRAM cdfstdevts
  !!======================================================================
  !!                     ***  PROGRAM  cdfstdevts  ***
  !!=====================================================================
  !!  ** Purpose : Compute the RMS of T and S, from the mean squared value.
  !!
  !!  ** Method  : Read gridT and gridT2 and compute rms
  !!
  !! History : 2.1  : 11/2004  : J.M. Molines : Original code
  !!           3.0  : 05/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                            :: jk, jt, jvar      ! dummy loop index
  INTEGER(KIND=4)                            :: narg, iargc       ! command line
  INTEGER(KIND=4)                            :: ijarg, ireq       ! command line
  INTEGER(KIND=4)                            :: npiglo, npjglo    ! size of the domain
  INTEGER(KIND=4)                            :: npk, npt          ! size of the domain
  INTEGER(KIND=4)                            :: ncout             ! ncid of output variable
  INTEGER(KIND=4)                            :: ierr              ! error status
  INTEGER(KIND=4), DIMENSION(2)              :: ipko, id_varout   ! output variable

  REAL(KIND=4), DIMENSION(:,:),  ALLOCATABLE :: zvbar, zvba2      ! mean and mean2 variable
  REAL(KIND=4), DIMENSION(:),    ALLOCATABLE :: tim               ! time counter

  REAL(KIND=8), DIMENSION(:,:),  ALLOCATABLE :: dsdev             ! standard deviation

  CHARACTER(LEN=256)                         :: cf_in             ! input mean file name
  CHARACTER(LEN=256)                         :: cf_in2            ! input mean2 file name
  CHARACTER(LEN=256)                         :: cf_out = 'stdevts.nc'! output file name
  CHARACTER(LEN=256)                         :: cv_in, cv_in2     ! input variable names
  CHARACTER(LEN=256)                         :: cldum             ! dummy character variable
  CHARACTER(LEN=256), DIMENSION(2)           :: cv_namesi         ! input variable names

  TYPE(variable), DIMENSION(2)               :: stypvaro          ! output data structure

  LOGICAL                                    :: lchk = .FALSE.    ! flag for missing files
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  cv_namesi(1) = cn_votemper
  cv_namesi(2) = cn_vosaline

  narg= iargc()
  IF ( narg /= 2 ) THEN
     PRINT *,' usage : cdfstdevts T-file T2-file '
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the standard deviation of the temperature'
     PRINT *,'       and salinity from their mean and  mean square values. '
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       T-file  : netcdf file with mean values for T, S' 
     PRINT *,'       T2-file : netcdf file with mean squared values for T,S' 
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       none' 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : ', TRIM(cn_votemper)//'_stdev, same unit than the input.'
     PRINT *,'                     ', TRIM(cn_vosaline)//'_stdev, same unit than the input.'
     PRINT *,'      '
     PRINT *,'     SEA ALSO :'
     PRINT *,'       cdfstd, cdfrmsssh, cdfstdevw.'
     STOP
  ENDIF

  ijarg = 1  ; ireq = 0
  DO WHILE ( ijarg <= narg) 
     CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE DEFAULT
        ireq = ireq + 1
        SELECT CASE ( ireq ) 
        CASE ( 1 ) ; cf_in  = cldum
        CASE ( 2 ) ; cf_in2 = cldum
        CASE DEFAULT
           PRINT *, ' Too many variables ' ; STOP
        END SELECT
     END SELECT
  ENDDO

  ! check existence of files
  lchk = lchk .OR. chkfile(cf_in )
  lchk = lchk .OR. chkfile(cf_in2)
  IF (lchk ) STOP ! missing file

  npiglo = getdim (cf_in, cn_x)
  npjglo = getdim (cf_in, cn_y)
  npk    = getdim (cf_in, cn_z)
  npt    = getdim (cf_in, cn_t)

  ipko(1) = npk
  stypvaro(1)%cname             = TRIM(cn_votemper)//'_stdev'
  stypvaro(1)%cunits            = 'DegC'
  stypvaro(1)%rmissing_value    = 0.
  stypvaro(1)%valid_min         = 0.
  stypvaro(1)%valid_max         = 20
  stypvaro(1)%clong_name        = 'STDEV_Temperature'
  stypvaro(1)%cshort_name       = TRIM(cn_votemper)//'_stdev'
  stypvaro(1)%conline_operation = 'N/A'
  stypvaro(1)%caxis             = 'TZYX'

  ipko(2) = npk
  stypvaro(2)%cname             = TRIM(cn_vosaline)//'_stdev'
  stypvaro(2)%cunits            = 'PSU'
  stypvaro(2)%rmissing_value    = 0.
  stypvaro(2)%valid_min         = 0.
  stypvaro(2)%valid_max         = 10
  stypvaro(2)%clong_name        = 'STDEV_Salinity'
  stypvaro(2)%cshort_name       = TRIM(cn_vosaline)//'_stdev'
  stypvaro(2)%conline_operation = 'N/A'
  stypvaro(2)%caxis             = 'TZYX'

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  ALLOCATE( zvbar(npiglo,npjglo), zvba2(npiglo,npjglo) )
  ALLOCATE( dsdev(npiglo,npjglo), tim(npt)             )

  ncout = create      (cf_out, cf_in,    npiglo, npjglo, npk       )
  ierr  = createvar   (ncout,  stypvaro, 2,      ipko,   id_varout )
  ierr  = putheadervar(ncout,  cf_in,    npiglo, npjglo, npk       )

  DO jvar = 1, 2
  cv_in  = cv_namesi(jvar)
  cv_in2 = TRIM(cv_in)//'_sqd'
  DO jt = 1, npt
     DO jk = 1, npk
        zvbar(:,:) = getvar(cf_in,  cv_in,  jk, npiglo, npjglo, ktime=jt)
        zvba2(:,:) = getvar(cf_in2, cv_in2, jk, npiglo, npjglo, ktime=jt)

        dsdev(:,:) = SQRT ( DBLE(zvba2(:,:) - zvbar(:,:)*zvbar(:,:)) )

        ierr = putvar(ncout, id_varout(jvar), REAL(dsdev), jk, npiglo, npjglo, ktime=jt)
     END DO
  END DO
  END DO

  tim  = getvar1d(cf_in, cn_vtimec, npt     )
  ierr = putvar1d(ncout, tim,       npt, 'T')

  ierr = closeout(ncout)

END PROGRAM cdfstdevts

PROGRAM cdfcoloc
  !!======================================================================
  !!                     ***  PROGRAM  cdfcoloc  ***
  !!=====================================================================
  !!  ** Purpose : Colocates model values on data points. The 3D or 2D
  !!               position of the points are already in the corresponding
  !!               weight file. (Bilinear interpolation).
  !!
  !!  ** Method  : Use the weight file provided as argument and computed
  !!               with cdfweight
  !!
  !! History : 2.1  : 05/2007  : J.M. Molines : Original code
  !!           3.0  : 03/2011  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  !! subroutine  rotation    : perform vector rotation to get geographical
  !!                           vector components
  !! subroutine getfld       : decipher the field list given on the command line
  !! subroutine help_message : list available fields
  !! function interp         : perform bilinear interpolation
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class data_transformation
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4), PARAMETER                     :: jptyp=16      ! number of available types
  INTEGER(KIND=4)                                :: ntyp          ! number of type to produce ( look to ctype)
  INTEGER(KIND=4)                                :: ji, jj, jk    ! dummy loop index
  INTEGER(KIND=4)                                :: jid, jtyp     ! dummy loop index
  INTEGER(KIND=4)                                :: idum          ! dummy integer
  INTEGER(KIND=4)                                :: narg, iargc, iarg
  INTEGER(KIND=4)                                :: nid = 0       ! mooring counter initialize to 0
  INTEGER(KIND=4)                                :: npiglo, npjglo ! grid size of the model 
  INTEGER(KIND=4)                                :: npk            ! grid size of the model 
  INTEGER(KIND=4)                                :: npkv          ! vertical dimension of the target variable 
  !                                                            !  (either 1 (2D) or npk (3D)
  INTEGER(KIND=4)                                :: numbin  = 20  ! logical unit for I/O files other than NetCdf
  INTEGER(KIND=4)                                :: numout  = 30  ! logical unit for I/O files other than NetCdf
  INTEGER(KIND=4)                                :: numskip = 31  ! logical unit for I/O files other than NetCdf
  ! variables in the weight file, 1 record per mooring
  INTEGER(KIND=4)                                :: id, idep
  INTEGER(KIND=4)                                :: nimin, njmin  ! location of horizontal nearest point
  INTEGER(KIND=4)                                :: nkmin         ! location vertical above target.
  INTEGER(KIND=4)                                :: nquadran      ! grid sector from 1 to 4 (clockwise, 1=NE) 
  !                                                               ! in which target point is located with respect 
  !                                                               ! to nearest point.
  INTEGER(KIND=4)                                :: nSx, nSy      ! index of the Sx and Sy for rotation
  INTEGER(KIND=4)                                :: nU, nV        ! index of the U and V for rotation
  INTEGER(KIND=2), DIMENSION(:,:,:), ALLOCATABLE :: mask          ! 3D working mask

  REAL(KIND=4)                                   :: xmin, ymin, rdep
  REAL(KIND=4)                                   :: vup, vdo, wup, wdo  ! Working variables
  REAL(KIND=4), DIMENSION(:,:,:),    ALLOCATABLE :: v3d           ! 3D  ! working variable (unavoidable)

  REAL(KIND=8)                                   :: dxmin, dymin
  REAL(KIND=8)                                   :: dalpha, dbeta, dgama
  REAL(KIND=8)                                   :: dhN, dscale
  REAL(KIND=8)                                   :: dlmin          
  REAL(KIND=8), DIMENSION(:,:),      ALLOCATABLE :: d2d,  de       ! 2D working variable and horizontal metric
  REAL(KIND=8), DIMENSION(:,:),      ALLOCATABLE :: dinterp        ! result array (nid,jptyp)

  ! file name
  CHARACTER(LEN=256)                             :: cf_out  
  CHARACTER(LEN=256)                             :: cf_skip 
  CHARACTER(LEN=256)                             :: cf_weight 
  CHARACTER(LEN=256)                             :: cf_weight_root
  CHARACTER(LEN=256)                             :: cf_gridt   = 'none'
  CHARACTER(LEN=256)                             :: cf_grids   = 'none'
  CHARACTER(LEN=256)                             :: cf_grid2d  = 'none'
  CHARACTER(LEN=256)                             :: cf_gridtrc = 'none'
  CHARACTER(LEN=256)                             :: cf_diag    = 'none'
  CHARACTER(LEN=256)                             :: cf_gridu   = 'none'
  CHARACTER(LEN=256)                             :: cf_gridv   = 'none'
  CHARACTER(LEN=256)                             :: cf_bathy   = 'none'
  CHARACTER(LEN=256)                             :: cf_in
  CHARACTER(LEN=256)                             :: cf_weight_t
  CHARACTER(LEN=256)                             :: cf_weight_u
  CHARACTER(LEN=256)                             :: cf_weight_v
  CHARACTER(LEN=256)                             :: cctyp, cvar, cvmask    ! current mooring
  CHARACTER(LEN=256)                             :: cldum   ! dummy char variable for line input
  CHARACTER(LEN=256)                             :: ctmplst0 ! current list of type: separated by ,
  CHARACTER(LEN=256)                             :: cformat  ! ASCII format adapted to ntyp
  CHARACTER(LEN=15), DIMENSION(jptyp)            :: ctype  !  all possible type defined there
  CHARACTER(LEN=15), DIMENSION(:),ALLOCATABLE    :: cltype !  actual type used given as argument

  LOGICAL                                        :: llchk
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  ! exhaustive list of supported field     
  ctype    = (/'T       ','S       ','SSH     ','CFCINV  ','CFCCONC ','PENDEP  ',   &
       &        'MXL     ','MXL01   ','MXLT02  ','ISOTHICK','U       ','V       ', &
       &        'Sx      ','Sy      ','H       ','etopo   '/)
  ctmplst0 = 'U,V,Sx,Sy,H'                 ! default list

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfcoloc -w ROOT-weight -t T-file -u U-file -v V-file [-s S-file]...'
     PRINT *,'        ...  [--ssh-file SSH-file] [-h] [-l LST-fields] [-trc TRC-file] ...'
     PRINT *,'        ...  [-d DIAG-file] [-b ETOPO-file]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       This program produces 3D colocalized model values for selected fields.' 
     PRINT *,'       It is the final pass in the colocalization process initialized by '
     PRINT *,'       ''cdfweight'', in which the location of the points to be colocalized'
     PRINT *,'       is set. The 2 steps of the process are separated because weight files'
     PRINT *,'       are to be produced only once for a set of data-point and model config,'
     PRINT *,'       whereas ''cdfcoloc'' is used for several model files corresponding to'
     PRINT *,'       different times.'
     PRINT *,'       This program was initially written to deal with G. Holloway topostrophy'
     PRINT *,'       works.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -w ROOT-weight : specify the root-name of the weight files (binary '
     PRINT *,'                files), to which the suffixes ''_T.bin'', ''_U.bin'' or ''_V.bin'''
     PRINT *,'                are appended if necessary.'
     PRINT *,'       -t T-file : name of gridT model file, used for default fields.'
     PRINT *,'              If salinity not in T-file use -s option.'
     PRINT *,'              If ssh not in T-file use --ssh-file option.'
     PRINT *,'       -u U-file : name of gridU model file, used for default fields.'
     PRINT *,'       -v V-file : name of gridV model file, used for default fields.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-s S-file ] : Give salinity file if not T-file.'
     PRINT *,'       [--ssh-file SSH-file] : specify the ssh file if not in T-file.'
     PRINT *,'       [-h ] : Gives details on the available fields.'
     PRINT *,'       [-l LST-fields ] : Gives a comma-separated list of selected fields to be'
     PRINT *,'              colocalized, from a whole set of fields which are fully described'
     PRINT *,'              with the ''-h'' option. The default list is: ',TRIM(ctmplst0)
     PRINT *,'              According to the selected fields, specific model files are to be'
     PRINT *,'              passed to the program with corresponding option.'
     PRINT *,'       [-trc TRC-file]: name of ptrcT model file, used for when passive tracers'
     PRINT *,'              related fields are selected (CFCINV, CFCCINC or PENDEP).'
     PRINT *,'       [-d DIAG-file ] : name of specific diagnostic file. This file is used '
     PRINT *,'              when ''PENDEP'' or ''ISOTHICK'' are selected. It must have the '
     PRINT *,'              variables ',TRIM(cn_pendep),' or ',TRIM(cn_isothick),', respectively produced by'
     PRINT *,'              ''cdfpendep'' and ''cdfsigintegr''.'
     PRINT *,'       [-b ETOPO-file ] : name of ''etopo-like'' bathymetric file.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ',TRIM(cn_fmsk),'. If bathymetric slopes are needed, then'
     PRINT *,'       ',TRIM(cn_fcoo),' and ',TRIM(cn_fzgr),' files are also required.'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       Output is a multi columns ASCII file with first 2 columns giving'
     PRINT *,'            ''ID'' and ''DEPTH''. Then the line is completed with colocated'
     PRINT *,'            field values. The output file looks pretty much as the input file'
     PRINT *,'            used in ''cdfweight'' for building the weight files.'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'      cdfweight '
     PRINT *,'      '
     STOP 
  ENDIF

  iarg = 1
  DO WHILE ( iarg <= narg ) 
     CALL getarg ( iarg, cldum ) ; iarg = iarg + 1
     SELECT CASE ( cldum )
     CASE ('-w'        ) ; CALL getarg ( iarg, cf_weight_root ) ; iarg = iarg + 1
     CASE ('-t'        ) ; CALL getarg ( iarg, cf_gridt       ) ; iarg = iarg + 1
     CASE ('-u'        ) ; CALL getarg ( iarg, cf_gridu       ) ; iarg = iarg + 1
     CASE ('-v'        ) ; CALL getarg ( iarg, cf_gridv       ) ; iarg = iarg + 1
        ! options
     CASE ('-s'        ) ; CALL getarg ( iarg, cf_grids       ) ; iarg = iarg + 1
     CASE ('--ssh-file') ; CALL getarg ( iarg, cf_grid2d      ) ; iarg = iarg + 1
     CASE ('-l'        ) ; CALL getarg ( iarg, ctmplst0       ) ; iarg = iarg + 1
     CASE ('-trc'      ) ; CALL getarg ( iarg, cf_gridtrc     ) ; iarg = iarg + 1
     CASE ('-d'        ) ; CALL getarg ( iarg, cf_diag        ) ; iarg = iarg + 1
     CASE ('-b'        ) ; CALL getarg ( iarg, cf_bathy       ) ; iarg = iarg + 1
     CASE ('-h'        ) ; CALL help_message 
     CASE DEFAULT   ; PRINT *,TRIM(cldum),' : option not available.' ; STOP 99
     END SELECT
  ENDDO
  IF ( cf_grids  == 'none' ) cf_grids  = cf_gridt
  IF ( cf_grid2d == 'none' ) cf_grid2d = cf_gridt

  ! intepret ctmplst0 to set up cltype list, ntype and build cf_out file name
  CALL getfld( ) 

  idum = INDEX(TRIM(cf_out),'.') - 1
  IF ( idum == -1 ) THEN
     idum = LEN_TRIM(cf_out)
  ENDIF
  cf_skip = cf_out(1:idum)//'_skip.txt'

  WRITE(cf_weight_t,'(a,a,".bin")') TRIM(cf_weight_root), '_T'
  WRITE(cf_weight_u,'(a,a,".bin")') TRIM(cf_weight_root), '_U'
  WRITE(cf_weight_v,'(a,a,".bin")') TRIM(cf_weight_root), '_V'

  ! Check if required files are available
  llchk = .FALSE.

  IF ( cf_bathy /= 'none' ) THEN ! dealing with special case of etopo file
     llchk = llchk .OR. chkfile(cf_bathy    )
     IF (llchk ) STOP 99 ! missing files
     npiglo = getdim (cf_bathy,'lon')
     npjglo = getdim (cf_bathy,'lat')
     npk    = 1
  ELSE
     llchk = llchk .OR. chkfile(cn_fmsk    )
     IF (llchk ) STOP 99 ! missing files
     npiglo = getdim (cn_fmsk,cn_x)
     npjglo = getdim (cn_fmsk,cn_y)
     npk    = getdim (cn_fmsk,cn_z)
  ENDIF

  ALLOCATE (v3d(npiglo, npjglo, npk), mask(npiglo, npjglo, npk) )
  ALLOCATE (d2d(npiglo, npjglo     ), de(npiglo,npjglo) )


  ! loop on all variables to collocate
  DO jtyp=1,ntyp
     cctyp=TRIM(cltype(jtyp))

     ! depending upon the type, set the weigth file, variable name, mask variable, data file
     !  vertical dimension of output variable and a scale factor
     SELECT CASE ( cctyp)
     CASE ('T')          ! temperature, not used for Greg Holloway output
        cf_weight = cf_weight_t
        cf_in     = cf_gridt
        cvar      = cn_votemper 
        cvmask    = cn_tmask
        npkv      = npk
        dscale    = 1.d0
     CASE ('S')          ! salinity, not used for Greg Holloway output
        cf_weight = cf_weight_t
        cf_in     = cf_grids
        cvar      = cn_vosaline 
        cvmask    = cn_tmask
        npkv      = npk
        dscale    = 1.d0
     CASE ('SSH')        !  SSH, not used for Greg Holloway output
        cf_weight = cf_weight_t
        cf_in     = cf_grid2d
        cvar      = cn_sossheig 
        cvmask    = cn_tmask
        npkv      = 1
        dscale    = 100.d0
     CASE ('CFCINV')     !  CFC inventory, not used for Greg Holloway output
        cf_weight = cf_weight_t
        cf_in     = cf_gridtrc
        cvar      = cn_invcfc
        cvmask    = cn_tmask
        npkv      = 1
        dscale    = 1000000.d0
     CASE ('CFCCONC')     !  CFC inventory, not used for Greg Holloway output
        cf_weight = cf_weight_t
        cf_in     = cf_gridtrc
        cvar      = cn_cfc11
        cvmask    = cn_tmask
        npkv      = 1
        dscale    = 1.d0
     CASE ('PENDEP')     !  CFC penetration depth
        cf_weight = cf_weight_t
        cf_in     = cf_diag
        cvar      = cn_pendep
        cvmask    = cn_tmask
        npkv      = 1
        dscale    = 1.d0
     CASE ('MXL','MXL01' )  !  Mixed layer depth
        cf_weight = cf_weight_t
        cf_in     = cf_gridt
        cvar      = cn_somxl010
        cvmask    = cn_tmask
        npkv      = 1
        dscale    = 1.d0
     CASE ('MXLT02' )  !  Mixed layer depth
        cf_weight = cf_weight_t
        cf_in     = cf_gridt
        cvar      = cn_somxlt02
        cvmask    = cn_tmask
        npkv      = 1
        dscale    = 1.d0
     CASE ('ISOTHICK' )  !  Isopycnal thickness
        cf_weight = cf_weight_t
        cf_in     = cf_diag
        cvar      = cn_isothick
        cvmask    = cn_tmask
        npkv      = 1
        dscale    = 1.d0
     CASE ('U')          ! Zonal component of velocity 
        cf_weight = cf_weight_u
        cf_in     = cf_gridu
        cvar      = cn_vozocrtx 
        cvmask    = cn_umask
        npkv      = npk
        dscale    = 100.d0  ! to be cm/s in the output
     CASE ('V')             ! Meridional component of velocity
        cf_weight = cf_weight_v
        cf_in     = cf_gridv
        cvar      = cn_vomecrty 
        cvmask    = cn_vmask
        npkv      = npk
        dscale    = 100.d0  ! to be cm/s in the output
     CASE ('Sx')            ! Zonal component of bottom slope
        cf_weight = cf_weight_u
        cf_in     = 'none' 
        cvar      = 'none'
        cvmask    = cn_umask
        npkv      = 1
        dscale    = 100.d0  ! to be in % in the output
        llchk = llchk .OR. chkfile(cn_fcoo    )
        llchk = llchk .OR. chkfile(cn_fzgr    )
        IF ( llchk ) STOP 99 
        ! Sx is the i-slope of bottom topog: read adequate metric
        !   and compute it on v3d(:,:,1)
        de(:,:)  = getvar(cn_fcoo, cn_ve1u,  1, npiglo, npjglo)     
        d2d(:,:) = getvar(cn_fzgr, cn_hdepw, 1, npiglo, npjglo)     
        DO ji=2, npiglo-1
           v3d(ji,:,1) = (d2d(ji+1,:) - d2d(ji,:)) / de(ji,:)
        END DO
     CASE ('Sy')         ! Meridional component of bottom slope
        cf_weight = cf_weight_v
        cf_in     = 'none' 
        cvar      = 'none'
        cvmask    = cn_vmask
        npkv      = 1
        dscale    = 100.d0  ! to be in % in the output
        llchk = llchk .OR. chkfile(cn_fcoo    )
        llchk = llchk .OR. chkfile(cn_fzgr    )
        IF ( llchk ) STOP 99 
        ! Sy is the j-slope of bottom topog: read adequate metric
        !   and compute it on v3d(:,:,1)
        de(:,:)  = getvar(cn_fcoo, cn_ve2v,  1, npiglo, npjglo)
        d2d(:,:) = getvar(cn_fzgr, cn_hdepw, 1, npiglo, npjglo)
        DO jj=2, npjglo-1
           v3d(:,jj,1) = (d2d(:,jj+1) - d2d(:,jj)) / de(:,jj)
        END DO
     CASE ('H')          ! Bottom topography
        cf_weight = cf_weight_t
        cf_in     = cn_fzgr
        cvar      = cn_hdepw 
        cvmask    = cn_tmask
        npkv      = 1
        dscale    = 1.d0
     CASE ('etopo')       ! Bottom topography from external file
        cf_weight = cf_weight_t
        cf_in     = cf_bathy
        cvar      = 'z' 
        cvmask    = 'none'
        npkv      = 1
        dscale    = 1.d0
     END SELECT

     IF (chkfile (cf_weight) .OR. chkfile( cf_in) )  STOP 99 ! missing file

     ! Now enter the generic processing
     PRINT *,'START coloc for ', TRIM(cctyp)
     IF (jtyp == 1 ) THEN ! count number of station and allocate dinterp
        !  assuming  weight file ( T U V ) have  the same number of stations.
        OPEN(numbin, FILE=cf_weight,FORM='unformatted')
        ! Determine the number of records in the weight file
        DO 
           READ(numbin, END=100)
           nid=nid+1
        END DO
100     CONTINUE
        CLOSE(numbin)

        PRINT *, nid ,' stations to process...'
        ! allocate result array
        ALLOCATE ( dinterp(nid,ntyp) )
     ENDIF

     OPEN(numbin, FILE=cf_weight,FORM='unformatted')

     IF (cf_in /= 'none' ) THEN   ! read data (except for Sx and Sy )
        DO jk=1, npkv
           v3d(:,:,jk)=getvar(cf_in,cvar,jk, npiglo,npjglo)
        END DO
     ENDIF

     ! read corresponding mask
     IF ( cvmask == 'none' ) THEN   ! special case of etopo files ( valid values are < 0 ) 
        mask = 1
        WHERE ( v3d >= 0 ) mask = 0
     ELSE
        DO jk=1, npkv
           mask(:,:,jk)=getvar(cn_fmsk,cvmask,jk, npiglo,npjglo)
        END DO
     ENDIF

     DO jid=1,nid
        !       READ(numbin) id, dymin, dxmin, idep ,nimin, njmin, nkmin, nquadran, dhN, dalpha, dbeta, dgama
        READ(numbin) id, ymin, xmin, rdep ,nimin, njmin, nkmin, nquadran, dhN, dalpha, dbeta, dgama
        dinterp(jid,jtyp)=interp()
        ! do not scale dummy values
        IF ( dinterp (jid,jtyp) > -99990.d0 )  dinterp (jid,jtyp) = dinterp (jid,jtyp) * dscale
     END DO

     CLOSE(numbin)
  END DO   ! Loop on type

  OPEN(numout,  FILE=cf_out )
  OPEN(numskip, FILE=cf_skip)

  ! need to re-read some informations from the weight file (idep, dhN)
  cf_weight = cf_weight_t
  OPEN(numbin, FILE=cf_weight, FORM='unformatted')
  DO jid=1, nid   ! loop on all stations
     READ(numbin) id, ymin, xmin, rdep, nimin, njmin, nkmin, nquadran, dhN
     IF ( xmin > 180.0) xmin = xmin - 360.0
     ! output only stations with no problems ( dinterp > -99990 )
     dlmin=MINVAL(dinterp(jid,:) )
     IF ( dlmin > -99990.d0 ) THEN
        ! apply vector rotation to have results on the geographic reference system (N-S, E-W )
        IF ( nSx > 0 ) THEN   ! (Sx, Sy pair )
           CALL rotation( dinterp(jid,nSx), dinterp(jid,nSy), dhN)  
        ENDIF
        IF ( nU > 0 ) THEN    ! (U, V pair)
           CALL rotation( dinterp(jid,nU), dinterp(jid,nV), dhN)  
        ENDIF
        WRITE(numout, cformat) id, rdep, (dinterp(jid,jtyp),jtyp=1,ntyp)
     ELSE
        ! save discarted stations for control
        WRITE(numskip, cformat) id, rdep, (dinterp(jid,jtyp),jtyp=1,ntyp)
     ENDIF
  END DO
  CLOSE(numbin)
  CLOSE(numout)

  PRINT *,' Done.'

CONTAINS

  FUNCTION interp ()
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION interp  ***
    !!
    !! ** Purpose : Perform spatial interpolation
    !!
    !! ** Method  : Use the informations in weigth file to perform
    !!              bilinear interpolation  
    !!
    !!----------------------------------------------------------------------
    REAL(KIND=8)    :: interp               ! return value

    INTEGER(KIND=4) :: ii1, ij1, ii2, ij2   ! working integers
    INTEGER(KIND=4) :: ii3, ij3, ii4, ij4   ! working integers
    INTEGER(KIND=4) :: ik1, ik2             ! working integers
    !!----------------------------------------------------------------------
    ! skip out of domain stations (flagged with nimin = -1000)
    IF (nimin == -1000 ) THEN
       interp=-99999.d0
       RETURN
    ENDIF

    ! choose the 4 interpolation points, according to sector and nearest point (nimin, njmin)
    SELECT CASE (nquadran)
    CASE (1)
       ii1=nimin    ; ij1 = njmin
       ii2=nimin +1 ; ij2 = njmin
       ii3=nimin +1 ; ij3 = njmin + 1
       ii4=nimin    ; ij4 = njmin + 1
    CASE (2)
       ii1=nimin    ; ij1 = njmin
       ii2=nimin    ; ij2 = njmin - 1
       ii3=nimin +1 ; ij3 = njmin - 1
       ii4=nimin +1 ; ij4 = njmin
    CASE (3)
       ii1=nimin    ; ij1 = njmin
       ii2=nimin -1 ; ij2 = njmin
       ii3=nimin -1 ; ij3 = njmin - 1
       ii4=nimin    ; ij4 = njmin - 1
    CASE (4)
       ii1=nimin    ; ij1 = njmin
       ii2=nimin    ; ij2 = njmin + 1
       ii3=nimin -1 ; ij3 = njmin + 1
       ii4=nimin -1 ; ij4 = njmin
    END SELECT

    ! nkmin is always above target point
    ik1 = nkmin    ; ik2 = nkmin + 1

    IF (npkv == 1 ) THEN   ! 2D var, do not take care of vertical interpolation
       ik1 = 1  ; ik2 = 0 ; wdo = 0.
    ENDIF

    ! compute sum of masked weight above target point
    wup = mask(ii1,ij1,ik1)*(1-dalpha)*(1-dbeta) + mask(ii2,ij2,ik1) * dalpha *(1-dbeta) + &
         &  mask(ii3,ij3,ik1)*   dalpha*dbeta      + mask(ii4,ij4,ik1) * (1-dalpha)*dbeta

    ! interpolate with non-masked  values, above target point
    vup = v3d(ii1,ij1,ik1)*(1-dalpha)*(1-dbeta) + v3d(ii2,ij2,ik1) * dalpha *(1-dbeta) +   &
         &  v3d(ii3,ij3,ik1)*    dalpha*dbeta     + v3d(ii4,ij4,ik1) * (1-dalpha)*dbeta

    IF (ik2 /= 0 ) THEN   ! for 3D variables
       ! compute sum of masked weight below target point
       wdo = mask(ii1,ij1,ik2)*(1-dalpha)*(1-dbeta) + mask(ii2,ij2,ik2) * dalpha *(1-dbeta) + &
            &  mask(ii3,ij3,ik2)*   dalpha*dbeta      + mask(ii4,ij4,ik2) * (1-dalpha)*dbeta

       ! interpolate with non-masked  values, below target point
       vdo = v3d(ii1,ij1,ik2)*(1-dalpha)*(1-dbeta) + v3d(ii2,ij2,ik2) * dalpha *(1-dbeta) + &
            &  v3d(ii3,ij3,ik2)*dalpha*dbeta       + v3d(ii4,ij4,ik2) * (1-dalpha)*dbeta
    ENDIF

    IF ( wup == 0 ) THEN       ! all points are masked
       interp=-99999.d0
    ELSE IF ( wdo == 0 ) THEN  ! all points below are masked, or 2D
       interp= vup/wup
    ELSE                       ! general case
       interp= (1 - dgama) * vup/wup + dgama * vdo/wdo
    ENDIF

  END FUNCTION interp

  SUBROUTINE rotation (ddu, ddv, ddcourse)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE rotation  ***
    !!
    !! ** Purpose : This subroutine returns the input vectors on the 
    !!              geographical reference
    !!
    !! ** Method  : Projection acording to ddcourse (heading)
    !!
    !!----------------------------------------------------------------------
    REAL(KIND=8), INTENT(inout) :: ddu      ! input u component (along I)
    REAL(KIND=8), INTENT(inout) :: ddv      ! input v component (along J)
    REAL(KIND=8), INTENT(in   ) :: ddcourse ! local direction of the I=cst lines 
    !                                                         ! with respect to N (deg).
    REAL(KIND=8)                :: dlu   ! Local working variables
    REAL(KIND=8)                :: dlv   ! Local working variables
    REAL(KIND=8)                :: dlconv   !      " 
    REAL(KIND=8)                :: dlcourse !      "
    REAL(KIND=8)                :: dlpi     !      "
    !!----------------------------------------------------------------------

    dlpi = ACOS(-1.d0) ; dlconv = dlpi/180.d0
    dlcourse = ddcourse*dlconv  ! heading in radians
    dlu = ddu  ; dlv = ddv 

    ddu    =  dlu*COS(dlcourse) +dlv*SIN(dlcourse)
    ddv    = -dlu*SIN(dlcourse) +dlv*COS(dlcourse)
  END SUBROUTINE rotation

  SUBROUTINE getfld ()
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE getfld  ***
    !!
    !! ** Purpose : decipher ctmplst : looking for ',' separating field
    !!              count the number of field in ctmplst0 : ntyp  
    !!              Set up pairing for vector components.
    !!              Initialize format output
    !!
    !! ** Method  :   use global variables 
    !!
    !!----------------------------------------------------------------------
    INTEGER(KIND=4)    :: jt
    CHARACTER(LEN=256) :: cltmplst
    !!----------------------------------------------------------------------

    cltmplst = ctmplst0
    ntyp = 1
    idum = INDEX(cltmplst,',')

    DO WHILE ( idum > 0 )
       cltmplst=cltmplst(idum+1:)
       idum=INDEX(cltmplst,',')
       ntyp = ntyp + 1
    ENDDO

    ALLOCATE (cltype(ntyp) )
    ! populates cltype with individual field
    cltmplst = ctmplst0
    DO jtyp = 1, ntyp
       idum=INDEX(cltmplst,',')
       IF (idum == 0 ) THEN
          cltype(jtyp) = TRIM(cltmplst)
       ELSE
          cltype(jtyp) = cltmplst(1:idum-1)
       ENDIF
       cltmplst=cltmplst(idum+1:)
    ENDDO

    ! check if all fields are supported:
    DO jtyp=1, ntyp
       DO jt =1 , jptyp
          IF ( cltype(jtyp) == TRIM(ctype(jt)) )  EXIT
       ENDDO
       IF ( jt == jptyp + 1 ) THEN
          PRINT *, 'ERROR in field list :', TRIM(cltype(jtyp) ),' not supported'
          STOP 99
       ENDIF
    ENDDO

    ! locate pairing for vector variables
    nSx = -1 ; nSy = -1
    nU  = -1 ; nV  = -1
    DO jtyp = 1, ntyp
       IF (  cltype(jtyp) == 'Sx' ) nSx = jtyp
       IF (  cltype(jtyp) == 'Sy' ) nSy = jtyp
       IF (  cltype(jtyp) == 'U'  ) nU  = jtyp
       IF (  cltype(jtyp) == 'V'  ) nV  = jtyp
    END DO

    IF ( nSx * nSy < 0 ) THEN 
       PRINT *, ' You must specify both Sx and Sy'
       PRINT *, ' in order to perform rotation'
       STOP 99
    ENDIF
    IF ( nU  * nV  < 0 ) THEN 
       PRINT *, ' You must specify both U and V'
       PRINT *, ' in order to perform rotation'
       STOP 99
    ENDIF

    ! build output file name
    cf_out='iz'
    DO jtyp=1, ntyp
       cf_out=TRIM(cf_out)//'_'//TRIM(cltype(jtyp))
    ENDDO
    cf_out=TRIM(cf_out)//'.txt'

    ! Build output format
    WRITE(cformat,'(a,i2,a)') '(I5,  I6,',ntyp,'e14.6)'

  END SUBROUTINE getfld

  SUBROUTINE help_message ()
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE help_message  ***
    !!
    !! ** Purpose : Print the list of available fields, and describes the
    !!              corresponding required input files  
    !!
    !!----------------------------------------------------------------------
    CHARACTER(LEN=25), DIMENSION(jptyp) :: comments
    CHARACTER(LEN=15), DIMENSION(jptyp) :: crequired
    CHARACTER(LEN=15)  :: cf_zgr, cf_coo
    !!----------------------------------------------------------------------
    PRINT *,' List of available field to process:' 
    PRINT 9001,'field name   ','  comments  ','  input files  '
    PRINT 9002
    cf_zgr=cn_fzgr
    cf_coo=cn_fcoo

    ! ctype    = (/'T','S','SSH','CFCINV','CFCCONC','PENDEP','MXL','MXL01',
    !              'MXLT02','ISOTHICK','U ','V ','Sx','Sy','H ','etopo'/)
    comments = (/' Potential temperature  ', &
         &      ' Salinity               ', &
         &      ' Sea Surface height     ', &
         &      ' CFC inventory          ', &
         &      ' CFC concentration      ', &
         &      ' Penetration depth      ', &
         &      ' Mixed layer depth s0.01', &
         &      ' Mixed layer depth s0.01', &
         &      ' Mixed layer depth t0.2 ', &
         &      ' Isopycnal thickness    ', &
         &      ' Zonal velocity         ', &
         &      ' Meridional velocity    ', &
         &      ' Zonal bottom slope     ', &
         &      ' Meridional bottom slope', &
         &      ' Local model bathymetry ', &
         &      ' etopo like bathymetry  ' /)
    crequired = (/' -t T-file     ',   &
         &        ' -t T-file     ',   &
         &        ' -t T-file     ',   &
         &        ' -trc TRC-file ',   &
         &        ' -trc TRC-file ',   &
         &        ' -d  DIAG-file ',   &
         &        ' -t T-file     ',   &
         &        ' -t T-file     ',   &
         &        ' -t T-file     ',   &
         &        ' -d  DIAG-file ',   &
         &        ' -u U-file     ',   &
         &        ' -v V-file     ',   &
         &            cf_zgr,   &
         &            cf_coo,   &
         &            cf_zgr,   &
         &        ' -b ETOPO-file ' /)

    DO jtyp=1, jptyp
       PRINT 9001 , TRIM(ctype(jtyp)), comments(jtyp), crequired(jtyp)
    ENDDO
    PRINT 9002
    PRINT *,''
9001 FORMAT (a15,x,a25,x,a15)
9002 FORMAT (57("-") )
    STOP 99

  END SUBROUTINE help_message

END PROGRAM cdfcoloc

PROGRAM cdfeke
  !!======================================================================
  !!                     ***  PROGRAM cdfeke   ***
  !!=====================================================================
  !!  ** Purpose : Compute Eddy Kinetic Energy 
  !!
  !!  ** Method  : Use gridU gridU2, gridV gridV2 files produced by
  !!               cdfmoy. Velocities are interpolated both on T points
  !!               and the variance is computed. If -mke option is used
  !!               the program also outputs MKE field
  !!
  !! History : pre  : 11/2004  : J.M. Molines : Original code
  !!           2.1  : 04/2005  : J.M. Molines : use modules
  !!           3.0  : 12/2010  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio 
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class derived_fields
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                            :: ji, jj, jk, jt      ! dummy loop index
  INTEGER(KIND=4)                            :: narg, iargc         ! command line browsing
  INTEGER(KIND=4)                            :: ijarg               ! command line browsing
  INTEGER(KIND=4)                            :: npiglo, npjglo      ! size of the domain (horiz)
  INTEGER(KIND=4)                            :: npk, npt            ! size of the domain vert and time
  INTEGER(KIND=4)                            :: ncout               ! ncid of output file
  INTEGER(KIND=4)                            :: ierr                ! Error status
  INTEGER(KIND=4)                            :: ivar                ! variable counter
  INTEGER(KIND=4)                            :: ip_eke, ip_mke, ip_tke  ! variable index
  INTEGER(KIND=4), DIMENSION(3)              :: ipk, id_varout      ! 

  REAL(KIND=4)                               :: ua, va              ! working arrays
  REAL(KIND=4), DIMENSION (:,:), ALLOCATABLE :: uc, vc, u2, v2      ! velocities etc...
  REAL(KIND=4), DIMENSION (:,:), ALLOCATABLE :: eke                 ! velocities etc...
  REAL(KIND=4), DIMENSION (:,:), ALLOCATABLE :: tke                 ! Mean Kinetic energy
  REAL(KIND=4), DIMENSION (:,:), ALLOCATABLE :: rmke                ! Kinetic energy of the mean flow
  REAL(KIND=8), DIMENSION(:),    ALLOCATABLE :: dtim                ! time variable

  CHARACTER(LEN=256)                         :: cf_out='eke.nc'     ! file name
  CHARACTER(LEN=256)                         :: cf_ufil, cf_u2fil   ! file name
  CHARACTER(LEN=256)                         :: cf_vfil, cf_v2fil   !   "
  CHARACTER(LEN=256)                         :: cf_tfil             !   "
  CHARACTER(LEN=256)                         :: cldum               ! dummy character variable
  CHARACTER(LEN=256)                         :: cl_vozocrtx         ! local name of U component
  CHARACTER(LEN=256)                         :: cl_vozocrtx2        ! local name of U2 component
  CHARACTER(LEN=256)                         :: cl_vomecrty         ! local name of V component
  CHARACTER(LEN=256)                         :: cl_vomecrty2        ! local name of V2 component

  TYPE(variable), DIMENSION(3)               :: stypvar             !

  LOGICAL                                    :: lchk                ! checking files existence
  LOGICAL                                    :: lperio = .FALSE.    ! checking E-W periodicity
  LOGICAL                                    :: leke   = .TRUE.     ! compute EKE
  LOGICAL                                    :: lmke   = .FALSE.    ! compute MKE
  LOGICAL                                    :: ltke   = .FALSE.    ! compute TKE
  LOGICAL                                    :: lnc4   = .FALSE.    ! netcdf4 output (chunking and deflation)
  LOGICAL                                    :: lsurf  = .FALSE.    ! flag to set for file w/o vertical dims
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  !!  Read command line
  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfeke -u U-file [-u2 U2-file] -v V-file [-v2 V2-file] -t T-file ...'
     PRINT *,'               [-surf] [-mke] [-tke] ...'
     PRINT *,'               [-o OUT-file] [-nc4][-var VAR-u VAR-v VAR-u2 VAR-v2] '
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'        Compute the Eddy Kinetic Energy from previously computed mean values'
     PRINT *,'        and mean squared values of velocity components.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS : both ''General Use'' or ''Reduced Use'' are acceptable'
     PRINT *,'      * General Use: 5 files are given in argument, and EKE is computed'
     PRINT *,'       -u  U-file  : gridU type file with mean U component.' 
     PRINT *,'       -u2 U2-file : gridU2 type file with mean U2 component.' 
     PRINT *,'       -v  V-file  : gridV type file with mean V component.' 
     PRINT *,'       -v2 V2-file : gridV2 type file with mean V2 component.' 
     PRINT *,'       -t  T-file  : any gridT or gridT2 (smaller) file, used for EKE header.'
     PRINT *,'       '
     PRINT *,'      * Reduced Use: no U2/V2 file, only MKE is computed from U and V file.'
     PRINT *,'       -u U-file  : gridU type file with mean U component.' 
     PRINT *,'       -v V-file  : gridV type file with mean V component.' 
     PRINT *,'       -t T-file  : any gridT or gridT2 (smaller) file, used for MKE header.'
     PRINT *,'             '
     PRINT *,'     OPTION :'
     PRINT *,'       [-surf] : Use this option if the T-file has no vertical dimension.'
     PRINT *,'       [-mke]  : output MKE (KE of mean flow) field together with EKE. '
     PRINT *,'       [-tke]  : output TKE (Mean KE of flow) field together with EKE. '
     PRINT *,'       [-nc4]  : allow netcdf4 output with compression and chunking.'
     PRINT *,'       [-o output file]: specify output file name instead of ', TRIM(cf_out)
     PRINT *,'       [-var VAR-u VAR-v VAR-u2 VAR-v2]: specify the name of the mean and '
     PRINT *,'            mean-squared velocity components if they differ from the standard'
     PRINT *,'            names :',TRIM(cn_vozocrtx),', ',TRIM(cn_vozocrtx)//'_sqd, ' &
       &                          ,TRIM(cn_vomecrty),', ',TRIM(cn_vomecrty)//'_sqd'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        none'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) , ' unless -o option in use.'
     PRINT *,'         variables : voeke (m2/s)'
     PRINT *,'         variables : vomke (m2/s) if required'
     PRINT *,'         variables : votke (m2/s) if required'
     PRINT *,'      '
     STOP
  ENDIF
  !!
  !! Initialisation from 1st file (all file are assume to have the same geometry)
  cf_u2fil='none' ; cf_v2fil='none'
  cl_vozocrtx  = cn_vozocrtx
  cl_vozocrtx2 = TRIM(cn_vozocrtx)//'_sqd'
  cl_vomecrty  = cn_vomecrty
  cl_vomecrty2 = TRIM(cn_vomecrty)//'_sqd'
  ip_eke=0        ; ip_mke=0
  ijarg = 1 
  DO WHILE ( ijarg <= narg )
     CALL getarg(ijarg, cldum ) ; ijarg = ijarg + 1
     SELECT CASE ( cldum )
     CASE ( '-u'   ) ; CALL getarg(ijarg, cf_ufil  ) ; ijarg = ijarg + 1
     CASE ( '-u2'  ) ; CALL getarg(ijarg, cf_u2fil ) ; ijarg = ijarg + 1
     CASE ( '-v'   ) ; CALL getarg(ijarg, cf_vfil  ) ; ijarg = ijarg + 1
     CASE ( '-v2'  ) ; CALL getarg(ijarg, cf_v2fil ) ; ijarg = ijarg + 1
     CASE ( '-t'   ) ; CALL getarg(ijarg, cf_tfil  ) ; ijarg = ijarg + 1
     CASE ( '-mke' ) ; lmke = .TRUE.
     CASE ( '-surf') ; lsurf= .TRUE.
     CASE ( '-tke' ) ; ltke = .TRUE.
     CASE ( '-nc4' ) ; lnc4 = .TRUE.
     CASE ( '-o'   ) ; CALL getarg(ijarg, cf_out   ) ; ijarg = ijarg + 1
     CASE ( '-var' ) ; CALL getarg(ijarg, cl_vozocrtx  ) ; ijarg = ijarg + 1
       ;             ; CALL getarg(ijarg, cl_vomecrty  ) ; ijarg = ijarg + 1
       ;             ; CALL getarg(ijarg, cl_vozocrtx2 ) ; ijarg = ijarg + 1
       ;             ; CALL getarg(ijarg, cl_vomecrty2 ) ; ijarg = ijarg + 1
     CASE DEFAULT    ; PRINT *,' ERROR : ',TRIM(cldum),' : unknown option.'
     END SELECT
  ENDDO

  ! if after parsing the command line cf_u2fil or cf_v2fil are still 'none'
  ! then only mke will be computed. (Reduced Use)
  IF ( cf_u2fil == 'none' .OR.  cf_v2fil == 'none' ) THEN 
     lmke = .TRUE.
     leke = .FALSE.
     ltke = .FALSE.
  ENDIF

  lchk =           chkfile (cf_ufil )
  lchk = lchk .OR. chkfile (cf_vfil )
  lchk = lchk .OR. chkfile (cf_tfil )
  IF (  leke ) THEN
     lchk = lchk .OR. chkfile (cf_u2fil)
     lchk = lchk .OR. chkfile (cf_v2fil)
  ENDIF

  IF ( lchk ) STOP 99 ! missing files

  npiglo = getdim (cf_ufil,cn_x)
  npjglo = getdim (cf_ufil,cn_y)
  npk    = getdim (cf_ufil,cn_z)
  npt    = getdim (cf_ufil,cn_t)

  IF ( npk == 0 ) npk=1 ! assume 1 level at least

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  ALLOCATE( uc(npiglo,npjglo), vc(npiglo,npjglo) )
  IF ( leke ) THEN
     ALLOCATE( eke(npiglo,npjglo)  )
     ALLOCATE( u2(npiglo,npjglo), v2(npiglo,npjglo) )
     eke(:,:) = 0.e0
  ENDIF

  IF (lmke ) THEN
     ALLOCATE( rmke(npiglo,npjglo)  )
     rmke(:,:) = 0.e0
  ENDIF
  IF (ltke ) THEN
     ALLOCATE( tke(npiglo,npjglo)  )
     tke(:,:) = 0.e0
  ENDIF


  ALLOCATE( dtim(npt) )

  CALL CreateOutput
  ! check for E_W periodicity
  uc(:,:) = getvar(cf_tfil, cn_vlon2d, 1, npiglo, npjglo )
  IF ( uc(1,1) ==  uc(npiglo-1,1) ) THEN 
     lperio = .TRUE. 
     PRINT *,' E-W periodicity detected '
  ENDIF

  DO jt = 1, npt  ! input file is likely to contain only one time frame but who knows ...
     DO jk = 1, npk
        uc(:,:) = getvar(cf_ufil,  cl_vozocrtx,               jk, npiglo, npjglo, ktime=jt )
        vc(:,:) = getvar(cf_vfil,  cl_vomecrty,               jk, npiglo, npjglo, ktime=jt )
        IF ( leke ) THEN
           u2(:,:) = getvar(cf_u2fil, cl_vozocrtx2, jk ,npiglo, npjglo, ktime=jt )
           v2(:,:) = getvar(cf_v2fil, cl_vomecrty2, jk ,npiglo, npjglo, ktime=jt )
        ENDIF

        ua = 0. ; va = 0. ; eke(:,:) = 0.
        IF ( leke ) THEN
           DO ji=2, npiglo
              DO jj=2,npjglo
                 ua = 0.5* ((u2(ji,jj)-uc(ji,jj)*uc(ji,jj))+ (u2(ji-1,jj)-uc(ji-1,jj)*uc(ji-1,jj)))
                 va = 0.5* ((v2(ji,jj)-vc(ji,jj)*vc(ji,jj))+ (v2(ji,jj-1)-vc(ji,jj-1)*vc(ji,jj-1)))
                 eke(ji,jj) = 0.5 * ( ua + va )
              END DO
           END DO
        ENDIF

        IF ( ltke ) THEN
           DO ji=2, npiglo
              DO jj=2,npjglo
                 ua = 0.5* (u2(ji,jj)+ u2(ji-1,jj))
                 va = 0.5* (v2(ji,jj)+ v2(ji,jj-1))
                 tke(ji,jj) = 0.5 * ( ua + va )
              END DO
           END DO
        ENDIF

        IF ( lmke ) THEN
           DO ji=2, npiglo
              DO jj=2,npjglo
                 rmke(ji,jj)=  0.5* (0.5*( uc(ji,jj)*uc(ji,jj) + uc(ji-1,jj)*uc(ji-1,jj)) + &
                      &              0.5*( vc(ji,jj)*vc(ji,jj) + vc(ji,jj-1)*vc(ji,jj-1)) )
              END DO
           END DO
        ENDIF

        IF ( lperio ) eke(1,:) = eke(npiglo-1,:)
        IF ( leke ) THEN 
           IF ( lperio ) eke(1,:) = eke(npiglo-1,:)
           ierr=putvar(ncout,id_varout(ip_eke), eke,  jk ,npiglo, npjglo, ktime=jt )
        ENDIF
        IF ( lmke ) THEN 
           IF ( lperio ) rmke(1,:) = rmke(npiglo-1,:)
           ierr=putvar(ncout,id_varout(ip_mke), rmke, jk ,npiglo, npjglo, ktime=jt )
        ENDIF
        IF ( ltke ) THEN 
           IF ( lperio ) tke(1,:) = tke(npiglo-1,:)
           ierr=putvar(ncout,id_varout(ip_tke), tke, jk ,npiglo, npjglo, ktime=jt )
        ENDIF
     END DO
  END DO ! time loop


  ierr = closeout(ncout)

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    ip_eke = -1 ; ip_mke=-1 ;  ip_tke=-1
    stypvar(1)%ichunk = (/ npiglo, MAX(1, npjglo/30), 1, 1 /) 
    stypvar(2)%ichunk = (/ npiglo, MAX(1, npjglo/30), 1, 1 /) 
    stypvar(3)%ichunk = (/ npiglo, MAX(1, npjglo/30), 1, 1 /) 

    ivar = 1
    IF ( leke ) THEN 
       ip_eke=ivar
       ipk(ip_eke)                       = npk
       stypvar(ip_eke)%cname             = 'voeke'
       stypvar(ip_eke)%cunits            = 'm2/s2'
       stypvar(ip_eke)%rmissing_value    = 0.
       stypvar(ip_eke)%valid_min         = 0.
       stypvar(ip_eke)%valid_max         = 10000.
       stypvar(ip_eke)%clong_name        = 'Eddy_Kinetic_Energy'
       stypvar(ip_eke)%cshort_name       = 'voeke'
       stypvar(ip_eke)%conline_operation = 'N/A'
       stypvar(ip_eke)%caxis             = 'TZYX'
       ivar = ivar + 1
    ENDIF

    IF ( lmke ) THEN
       ip_mke=ivar
       ipk(ip_mke)                       = npk
       stypvar(ip_mke)%cname             = 'vomke'
       stypvar(ip_mke)%cunits            = 'm2/s2'
       stypvar(ip_mke)%rmissing_value    = 0.
       stypvar(ip_mke)%valid_min         = 0.
       stypvar(ip_mke)%valid_max         = 10000.
       stypvar(ip_mke)%clong_name        = 'Mean_Kinetic_Energy'
       stypvar(ip_mke)%cshort_name       = 'vomke'
       stypvar(ip_mke)%conline_operation = 'N/A'
       stypvar(ip_mke)%caxis             = 'TZYX'
       ivar = ivar + 1
    ENDIF

    IF ( ltke ) THEN
       ip_tke=ivar
       ipk(ip_tke)                       = npk
       stypvar(ip_tke)%cname             = 'votke'
       stypvar(ip_tke)%cunits            = 'm2/s2'
       stypvar(ip_tke)%rmissing_value    = 0.
       stypvar(ip_tke)%valid_min         = 0.
       stypvar(ip_tke)%valid_max         = 10000.
       stypvar(ip_tke)%clong_name        = 'Total_Kinetic_Energy'
       stypvar(ip_tke)%cshort_name       = 'votke'
       stypvar(ip_tke)%conline_operation = 'N/A'
       stypvar(ip_tke)%caxis             = 'TZYX'
       ivar = ivar + 1
    ENDIF


    ivar = MAX( ip_mke, ip_eke, ip_tke) ! set ivar to the effective number of variables to be output

    IF ( lsurf ) THEN
       ncout = create      (cf_out, cf_tfil, npiglo, npjglo, 0         , ld_nc4=lnc4 )
       ierr  = createvar   (ncout,  stypvar, ivar,   ipk,    id_varout , ld_nc4=lnc4 )
       ierr  = putheadervar(ncout,  cf_tfil, npiglo, npjglo, 0                       )
    ELSE
       ncout = create      (cf_out, cf_tfil, npiglo, npjglo, npk       , ld_nc4=lnc4 )
       ierr  = createvar   (ncout,  stypvar, ivar,   ipk,    id_varout , ld_nc4=lnc4 )
       ierr  = putheadervar(ncout,  cf_tfil, npiglo, npjglo, npk                     )
    ENDIF

    dtim = getvar1d(cf_ufil, cn_vtimec, npt     )
    ierr = putvar1d(ncout,  dtim,       npt, 'T')

  END SUBROUTINE CreateOutput

END PROGRAM cdfeke

PROGRAM cdfvhst
  !!======================================================================
  !!                     ***  PROGRAM  cdfvhst  ***
  !!=====================================================================
  !!  ** Purpose : Compute Verticaly integrated  Heat Salt Transport.
  !!
  !!  ** Method  : Take VT files computed by cdfvT.f90 and integrate
  !!               vertically to produce a 2D file
  !!
  !! History : 2.1  : 01/2005  : J.M. Molines : Original code
  !!           3.0  : 04/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                            :: jk, jt          ! dummy loop index
  INTEGER(KIND=4)                            :: ierr            ! working integer
  INTEGER(KIND=4)                            :: narg, iargc     ! command line 
  INTEGER(KIND=4)                            :: ijarg           ! argument counter
  INTEGER(KIND=4)                            :: npiglo, npjglo  ! size of the domain
  INTEGER(KIND=4)                            :: npk, npt        ! size of the domain
  INTEGER(KIND=4)                            :: ncout           ! ncdf id of output file
  INTEGER(KIND=4), DIMENSION(4)              :: ipk, id_varout  ! output variable levels and id's

  REAL(KIND=4), PARAMETER                    :: pp_rau0=1000.   ! fresh water density ( kg/m3)
  REAL(KIND=4), PARAMETER                    :: pp_rcp=4000.    ! heat capacity of water (J/kg/K)
  REAL(KIND=4), DIMENSION (:,:), ALLOCATABLE :: e1v, e2u        ! horizontal metrics
  REAL(KIND=4), DIMENSION (:,:), ALLOCATABLE :: e3u, e3v        ! vertical metrics
  REAL(KIND=4), DIMENSION (:,:), ALLOCATABLE :: zut, zus        ! heat and salt zonal copmponents
  REAL(KIND=4), DIMENSION (:,:), ALLOCATABLE :: zvt, zvs        ! heat and salt meridional components
  REAL(KIND=4), DIMENSION(:),    ALLOCATABLE :: tim             ! time counter
  REAL(KIND=4), DIMENSION(:),    ALLOCATABLE :: e31d            ! vertical metrics when full step

  REAL(KIND=8), DIMENSION (:,:), ALLOCATABLE :: dtrput, dtrpus  ! zonal transport
  REAL(KIND=8), DIMENSION (:,:), ALLOCATABLE :: dtrpvt, dtrpvs  ! meridional transport

  TYPE (variable), DIMENSION(4)              :: stypvar         ! structure output variables

  CHARACTER(LEN=256)                         :: cf_vtfil        ! input file name (vt)
  CHARACTER(LEN=256)                         :: cf_out='trp.nc' ! output file name
  CHARACTER(LEN=256)                         :: cldum           ! dummy char variable

  LOGICAL                                    :: lfull=.FALSE.   ! flag for full step
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfvhst  VTfile [-full ]'
     PRINT *,'     PURPOSE :'
     PRINT *,'         Computes the vertically integrated heat and salt transports '
     PRINT *,'         at each grid cell.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'         VTfile : file which contains UT, VT, US, VS quantities'
     PRINT *,'              (produced by cdfvT.f90)'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'         [ -full ] : use full step computation (default is partial steps).'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'         Files ',TRIM(cn_fhgr),', ',TRIM(cn_fzgr)
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'         Netcdf file : ',TRIM(cf_out)
     PRINT *,'         Variables : ', TRIM(cn_somevt),', ',TRIM(cn_somevs),', ',TRIM(cn_sozout),' and  ',TRIM(cn_sozous)
     STOP
  ENDIF

  ijarg = 1
  DO WHILE (ijarg <= narg )
     CALL getarg(ijarg, cldum ) ; ijarg = ijarg+1
     SELECT CASE (cldum )
     CASE ( '-full' )
        lfull = .TRUE.
     CASE DEFAULT
        cf_vtfil = cldum
     END SELECT
  END DO

  IF ( chkfile(cf_vtfil) ) STOP 99 ! missing file

  npiglo= getdim (cf_vtfil,cn_x )
  npjglo= getdim (cf_vtfil,cn_y )
  npk   = getdim (cf_vtfil,cn_z )
  npt   = getdim (cf_vtfil,cn_t )

  ! define new variables for output 
  ipk(:)                    = 1
  stypvar%rmissing_value    = 0.
  stypvar%valid_min         = -100.
  stypvar%valid_max         = 100.
  stypvar%conline_operation = 'N/A'
  stypvar%caxis             = 'TYX'

  stypvar(1)%cname       = cn_somevt
  stypvar(2)%cname       = cn_somevs
  stypvar(3)%cname       = cn_sozout
  stypvar(4)%cname       = cn_sozous

  stypvar(1)%cunits      = 'W'
  stypvar(2)%cunits      = 'kg.s-1'
  stypvar(3)%cunits      = 'W'
  stypvar(4)%cunits      = 'kg.s-1'

  stypvar(1)%clong_name  = 'Meridional_heat_transport'
  stypvar(2)%clong_name  = 'Meridional_salt_transport'
  stypvar(3)%clong_name  = 'Zonal_heat_transport'
  stypvar(4)%clong_name  = 'Zonal_salt_transport'

  stypvar(1)%cshort_name = cn_somevt
  stypvar(2)%cshort_name = cn_somevs
  stypvar(3)%cshort_name = cn_sozout
  stypvar(4)%cshort_name = cn_sozous

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  ! Allocate arrays
  ALLOCATE ( zvt(npiglo,npjglo), zvs(npiglo,npjglo) )
  ALLOCATE ( zut(npiglo,npjglo), zus(npiglo,npjglo) )
  ALLOCATE ( e1v(npiglo,npjglo), e3v(npiglo,npjglo) )
  ALLOCATE ( e2u(npiglo,npjglo), e3u(npiglo,npjglo) )
  ALLOCATE ( dtrpvt(npiglo,npjglo), dtrpvs(npiglo,npjglo))
  ALLOCATE ( dtrput(npiglo,npjglo), dtrpus(npiglo,npjglo))
  ALLOCATE ( tim(npt), e31d(npk) )

  ! create output fileset
  ncout = create      (cf_out, cf_vtfil, npiglo, npjglo, 1         )
  ierr  = createvar   (ncout,  stypvar,  4,      ipk,    id_varout )
  ierr  = putheadervar(ncout,  cf_vtfil, npiglo, npjglo, 1         )

  tim   = getvar1d(cf_vtfil, cn_vtimec, npt     )
  ierr  = putvar1d(ncout,    tim,       npt, 'T')

  ! read level independent metrics
  e1v(:,:) = getvar(cn_fhgr,   cn_ve1v, 1, npiglo, npjglo)
  e2u(:,:) = getvar(cn_fhgr,   cn_ve2u, 1, npiglo, npjglo)
  e31d(:)  = getvare3(cn_fzgr, cn_ve3t1d, npk              ) ! used only for full step

  DO jt=1, npt
     ! reset transport to 0
     dtrpvt(:,:) = 0.d0
     dtrpvs(:,:) = 0.d0
     dtrput(:,:) = 0.d0
     dtrpus(:,:) = 0.d0

     DO jk = 1,npk
        PRINT *,'level ',jk, ' time ', jt
        ! Get heat/salt transport component at jk
        zvt(:,:)= getvar(cf_vtfil, cn_vomevt, jk ,npiglo, npjglo, ktime=jt)
        zvs(:,:)= getvar(cf_vtfil, cn_vomevs, jk ,npiglo, npjglo, ktime=jt)
        zut(:,:)= getvar(cf_vtfil, cn_vozout, jk ,npiglo, npjglo, ktime=jt)
        zus(:,:)= getvar(cf_vtfil, cn_vozous, jk ,npiglo, npjglo, ktime=jt)

        ! get e3v at level jk ( and multiply by respective horizontal metric)
        IF ( lfull ) THEN
           e3v(:,:) = e31d(jk) * e1v(:,:)
           e3u(:,:) = e31d(jk) * e2u(:,:)
        ELSE
           e3v(:,:) = getvar(cn_fzgr, 'e3v_ps', jk, npiglo, npjglo, ldiom=.TRUE.) * e1v(:,:)
           e3u(:,:) = getvar(cn_fzgr, 'e3u_ps', jk, npiglo, npjglo, ldiom=.TRUE.) * e2u(:,:)
        ENDIF

        ! integrates vertically 
        dtrpvt(:,:) = dtrpvt(:,:) + zvt(:,:) * e3v(:,:) * pp_rau0*pp_rcp * 1.d0
        dtrpvs(:,:) = dtrpvs(:,:) + zvs(:,:) * e3v(:,:) * 1.d0
        dtrput(:,:) = dtrput(:,:) + zut(:,:) * e3u(:,:) * pp_rau0*pp_rcp * 1.d0
        dtrpus(:,:) = dtrpus(:,:) + zus(:,:) * e3u(:,:) * 1.d0

     END DO  ! loop to next level

     ! output on file
     ierr = putvar(ncout, id_varout(1) ,SNGL(dtrpvt), 1, npiglo, npjglo, ktime=jt)
     ierr = putvar(ncout, id_varout(2) ,SNGL(dtrpvs), 1, npiglo, npjglo, ktime=jt)
     ierr = putvar(ncout, id_varout(3) ,SNGL(dtrput), 1, npiglo, npjglo, ktime=jt)
     ierr = putvar(ncout, id_varout(4) ,SNGL(dtrpus), 1, npiglo, npjglo, ktime=jt)
  END DO  ! loop on time step

  ierr = closeout (ncout)

END PROGRAM cdfvhst

MODULE cdftools
  !!======================================================================
  !!                     ***  MODULE  cdftools  ***
  !! This module holds subroutine that corresponds to cdftools.
  !! For example cdf_findij is the subroutine equivalent to cdffindij 
  !!=====================================================================
  !! History : 2.1  !  05/2010  : J.M. Molines, A. Melet : Original
  !!           3.0  !  12/2010  : J.M. Molines : Doctor + Lic.
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  !!   routines      : description
  !!   cdf_findij    : the routine version of cdffindij
  !!   NearestPoint : determine the nearest point from a lon lat location
  !!   dist          : compute the distance along othodromic route
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames

  IMPLICIT NONE

  PRIVATE     
  ! list of public subroutines that can be called
  PUBLIC  :: cdf_findij 
  PRIVATE :: NearestPoint
  PRIVATE :: dist 

  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2010, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------

CONTAINS

  SUBROUTINE cdf_findij ( pxmin, pxmax, pymin, pymax,           &
       &         kimin, kimax, kjmin, kjmax, cd_coord, cd_point, cd_verbose)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE cdf_findij  ***
    !!
    !! ** Purpose :  the routine equivalent of cdffindij 
    !!
    !!----------------------------------------------------------------------
    REAL(KIND=4),                  INTENT(in) :: pxmin, pxmax, pymin, pymax !: geographical window in lon-lat
    INTEGER(KIND=4),              INTENT(out) :: kimin, kimax, kjmin, kjmax !: equivalent in model coordinates
    CHARACTER(*), OPTIONAL,        INTENT(in) :: cd_coord                   !: coordinate file name (D: cn_fcoo)
    CHARACTER(*), OPTIONAL,        INTENT(in) :: cd_point                   !: point type           (D: F )
    CHARACTER(*), OPTIONAL,        INTENT(in) :: cd_verbose                 !: verbose flag         (D: N ) Y

    INTEGER(KIND=4)                           :: initer
    INTEGER(KIND=4)                           :: imin, imax, jmin, jmax
    INTEGER(KIND=4), SAVE                     :: iloc, jloc
    INTEGER(KIND=4)                           :: ipiglo, ipjglo
    INTEGER(KIND=4), PARAMETER                :: jp_itermax=15
  
    REAL(KIND=8)                              :: dl_xmin, dl_xmax, dl_ymin, dl_ymax
    REAL(KIND=8)                              :: dl_dis
    REAL(KIND=8)                              :: dl_glam0, dl_emax
    REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dl_glam, dl_gphi, dl_e1, dl_e2

    REAL(KIND=4)                              :: zglamfound, zglamin, zglamax

    CHARACTER(LEN=256)                        :: cl_type='F'
    CHARACTER(LEN=256)                        :: clcoo

    LOGICAL                                   :: ll_again, ll_bnd, ll_verbose=.false.
    !!--------------------------------------------------------------------------
    CALL ReadCdfNames()

    dl_xmin = pxmin
    dl_xmax = pxmax
    dl_ymin = pymin
    dl_ymax = pymax

    IF ( PRESENT( cd_coord)  ) clcoo=cd_coord
    IF ( PRESENT( cd_point)  ) cl_type=cd_point
    IF ( PRESENT( cd_verbose))   THEN
      IF ( cd_verbose(1:1) == 'Y' .OR. cd_verbose(1:1) == 'y' ) ll_verbose=.true.
    ENDIF

    IF (chkfile (clcoo) ) STOP ! missing file

    ipiglo= getdim (clcoo, cn_x)
    ipjglo= getdim (clcoo, cn_y)

    ALLOCATE (dl_glam(ipiglo,ipjglo), dl_gphi(ipiglo,ipjglo) )
    ALLOCATE (dl_e1  (ipiglo,ipjglo), dl_e2  (ipiglo,ipjglo) )

    SELECT CASE ( cl_type )
    CASE ('T' , 't' )
       dl_glam(:,:) = getvar(clcoo, cn_glamt, 1, ipiglo, ipjglo)
       dl_gphi(:,:) = getvar(clcoo, cn_gphit, 1, ipiglo, ipjglo)
       dl_e1  (:,:) = getvar(clcoo, cn_ve1t,  1, ipiglo, ipjglo)
       dl_e2  (:,:) = getvar(clcoo, cn_ve2t,  1, ipiglo, ipjglo)
    CASE ('U','u' )
       dl_glam(:,:) = getvar(clcoo, cn_glamu, 1, ipiglo, ipjglo)
       dl_gphi(:,:) = getvar(clcoo, cn_gphiu, 1, ipiglo, ipjglo)
       dl_e1  (:,:) = getvar(clcoo, cn_ve1u,  1, ipiglo, ipjglo)
       dl_e2  (:,:) = getvar(clcoo, cn_ve2u,  1, ipiglo, ipjglo)
    CASE ('V','v' )
       dl_glam(:,:) = getvar(clcoo, cn_glamv, 1, ipiglo, ipjglo)
       dl_gphi(:,:) = getvar(clcoo, cn_gphiv, 1, ipiglo, ipjglo)
       dl_e1  (:,:) = getvar(clcoo, cn_ve1v,  1, ipiglo, ipjglo)
       dl_e2  (:,:) = getvar(clcoo, cn_ve2v,  1, ipiglo, ipjglo)
    CASE ('F','f' )
       dl_glam(:,:) = getvar(clcoo, cn_glamf, 1, ipiglo, ipjglo)
       dl_gphi(:,:) = getvar(clcoo, cn_gphif, 1, ipiglo, ipjglo)
       dl_e1  (:,:) = getvar(clcoo, cn_ve1f,  1, ipiglo, ipjglo)
       dl_e2  (:,:) = getvar(clcoo, cn_ve2f,  1, ipiglo, ipjglo)
    CASE DEFAULT
       PRINT *,' ERROR : type of point not known: ', TRIM(cl_type)
    END SELECT

    ! work with longitude between 0 and 360 to avoid  the date line.
    WHERE( dl_glam < 0 ) dl_glam = dl_glam + 360.d0

    ! For Orca grid, the longitude of ji=1 is about 70 E
    dl_glam0 = dl_glam(1, ipjglo/2)
    WHERE( dl_glam < dl_glam0 ) dl_glam =dl_glam + 360.d0

    IF (dl_xmin < 0.) dl_xmin = dl_xmin + 360.d0
    IF (dl_xmax < 0.) dl_xmax = dl_xmax + 360.d0

    IF (dl_xmin < dl_glam0) dl_xmin = dl_xmin + 360.d0
    IF (dl_xmax < dl_glam0) dl_xmax = dl_xmax + 360.d0


    ! deal with xmin, ymin
    ll_again = .TRUE.
    initer = 1

    DO WHILE (ll_again)
       CALL NearestPoint(dl_xmin, dl_ymin, ipiglo, ipjglo, dl_glam, dl_gphi, iloc, jloc, ll_bnd)

       ! distance between the target point and the nearest point
       dl_dis = dist(dl_xmin, dl_glam(iloc,jloc), dl_ymin, dl_gphi(iloc,jloc) ) ! in km

       ! typical grid size (diagonal) in the vicinity of nearest point
       dl_emax= MAX(dl_e1(iloc,jloc), dl_e2(iloc,jloc))/1000.*SQRT(2.) ! in km

       IF (dl_dis  > dl_emax ) THEN
          zglamfound = dl_glam(iloc,jloc) ; IF (zglamfound > 180.)  zglamfound=zglamfound - 360.

          PRINT 9000, 'Long= ',zglamfound,' Lat = ',dl_gphi(iloc,jloc) , iloc, jloc 
          PRINT *,' Algorithm does''nt converge ', dl_dis

          IF ( initer >= jp_itermax ) THEN
            PRINT *, ' no convergence after ', jp_itermax,' iterations'
            iloc     = -1000
            jloc     = -1000
            ll_again = .FALSE.
          ELSE
            ll_again = .TRUE.
            initer   = initer +1
            jloc     = (initer -1)* ipjglo/initer
            iloc     = (initer -1)* ipiglo/jp_itermax
          ENDIF
       ELSE
          IF ( ll_verbose ) THEN
             PRINT '("#  dl_dis= ",f8.3," km")', dl_dis
          ENDIF
          ll_again = .FALSE.
       END IF
    END DO

    IF (ll_bnd .AND. ll_verbose ) THEN
       WRITE (*,*)'Point  Out of domain or on boundary'
    ELSE
       imin=iloc
       jmin=jloc
    ENDIF

    ! deal with xmax, ymax
    IF (  pxmin == pxmax .AND. pymin == pymax ) THEN
      ! job already done with first point
      imax=imin
      jmax=jmin
    ELSE
    ll_again = .TRUE.
    initer = 1
    iloc=ipiglo/2 ; jloc=ipjglo/2

    DO WHILE (ll_again)
       CALL NearestPoint(dl_xmax, dl_ymax, ipiglo, ipjglo, dl_glam, dl_gphi, iloc, jloc, ll_bnd)

       ! distance between the target point and the nearest point
       dl_dis = dist(dl_xmax, dl_glam(iloc,jloc), dl_ymax, dl_gphi(iloc,jloc) ) ! in km

       ! typical grid size (diagonal) in the vicinity of nearest point
       dl_emax = MAX(dl_e1(iloc,jloc),dl_e2(iloc,jloc))/1000.*SQRT(2.) ! in km

       IF (dl_dis >  dl_emax ) THEN
          zglamfound=dl_glam(iloc,jloc) ; IF (zglamfound > 180.)  zglamfound=zglamfound -360.

          PRINT 9000, 'Long= ',zglamfound,' Lat = ',dl_gphi(iloc,jloc), iloc, jloc
          PRINT *,' Algorithm does''nt converge ', dl_dis

          IF ( initer >= jp_itermax ) THEN
            PRINT *, ' no convergence after ', jp_itermax,' iterations'
            iloc     = -1000
            jloc     = -1000
            ll_again = .FALSE.
          ELSE
            ll_again = .TRUE.
            initer   = initer +1
            jloc     = (initer -1)* ipjglo/initer
            iloc     = (initer -1)* ipiglo/jp_itermax
          ENDIF
       ELSE
          IF ( ll_verbose ) THEN
             PRINT '("#  dl_dis= ",f8.3," km")', dl_dis
          ENDIF
          ll_again = .FALSE.
       END IF
    END DO
    IF (ll_bnd .AND. ll_verbose ) THEN
       WRITE (*,*) 'Point  Out of domain or on boundary'
    ELSE
       imax=iloc
       jmax=jloc
    ENDIF
    ENDIF

    IF (ll_verbose) PRINT 9001, imin, imax, jmin, jmax

    kimin   = imin ; kimax = imax ; kjmin   = jmin ; kjmax = jmax
    zglamin = dl_glam(imin,jmin)  ; zglamax = dl_glam(imax,jmax)

    IF ( zglamin > 180 ) zglamin=zglamin-360.
    IF ( zglamax > 180 ) zglamax=zglamax-360.

    IF ( ll_verbose) PRINT 9002, zglamin, zglamax, dl_gphi(imin,jmin),dl_gphi(imax,jmax)

9000 FORMAT(a,f8.2,a,f8.2,2i5)
9001 FORMAT(4i10)
9002 FORMAT(4f10.4)

  END SUBROUTINE cdf_findij


  SUBROUTINE NearestPoint(ddlon, ddlat, kpi, kpj, ddlam, ddphi, kpiloc, kpjloc, ld_bnd)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE NearestPoint  ***
    !!
    !! ** Purpose : Computes the positions of the nearest i,j in the grid
    !!              from the given longitudes and latitudes
    !!
    !! ** Method  : Starts on the middle of the grid, search in a 20x20 box,
    !!              and move the box in the direction where the distance 
    !!              between the box and the point is minimum.
    !!              Iterates ...
    !!              Stops when the point is outside the grid.
    !!
    !! References : P.A. Darbon and A. de Miranda acknowledged for this 
    !!              clever algorithm developped in CLIPPER.
    !!----------------------------------------------------------------------
    REAL(KIND=8),                     INTENT(in) :: ddlon, ddlat        !: lon and lat of target point
    INTEGER(KIND=4),                 INTENT (in) :: kpi, kpj          !: grid size
    REAL(KIND=8), DIMENSION(kpi,kpj), INTENT(in) :: ddlam, ddphi        !: model grid layout
    INTEGER(KIND=4),              INTENT (inout) :: kpiloc, kpjloc    !: nearest point location
    LOGICAL                                      :: ld_bnd            !: reach boundary flag

    INTEGER(KIND=4)                              :: ji, jj
    INTEGER(KIND=4), PARAMETER                   :: jp_blk=10
    INTEGER(KIND=4)                              :: ii0, ij0
    INTEGER(KIND=4)                              :: ii1, ij1
    REAL(KIND=4)                                 :: zdist
    REAL(KIND=4)                                 :: zdistmin, zdistmin0
    LOGICAL, SAVE                                :: ll_bndcell, ll_first=.TRUE.
    !!----------------------------------------------------------------------
    IF ( ll_first ) THEN
       kpiloc = kpi/2 ; kpjloc = kpj/2    ! seek from the middle of domain
       ll_first=.FALSE.
    ENDIF

    zdistmin=1000000. ; zdistmin0=1000000.
    ii0 = kpiloc      ; ij0 = kpjloc
    ll_bndcell=.TRUE. ; ld_bnd=.FALSE.

    ! loop until found or boundary reach
    DO  WHILE ( ll_bndcell .AND. .NOT. ld_bnd )
       ii0 = kpiloc - jp_blk ;  ii1 = kpiloc + jp_blk
       ij0 = kpjloc - jp_blk ;  ij1 = kpjloc + jp_blk

       ! search only the inner domain
       IF (ii0 <= 0 ) ii0 = 2
       IF (ii1 > kpi) ii1 = kpi - 1
       IF (ij0 <= 0 ) ij0 = 2
       IF( ij1 > kpj) ij1 = kpj - 1

       ! within a block jp_blk+1 x jp_blk+1:
       DO jj=ij0,ij1
          DO ji=ii0,ii1
             ! compute true distance (orthodromy) between target point and grid point
             zdist    = dist(ddlon, ddlam(ji,jj), ddlat, ddphi(ji,jj) )
             zdistmin = MIN(zdistmin, zdist)
             ! update kpiloc, kpjloc if distance decreases
             IF (zdistmin /=  zdistmin0 ) THEN
                kpiloc=ji
                kpjloc=jj
             ENDIF
             zdistmin0=zdistmin
          END DO
       END DO

       ll_bndcell=.FALSE.
       ! if kpiloc, kpjloc belong to block boundary proceed to next block, centered on kpiloc, kpjloc
       IF (kpiloc == ii0 .OR. kpiloc == ii1) ll_bndcell=.TRUE.
       IF (kpjloc == ij0 .OR. kpjloc == ij1) ll_bndcell=.TRUE.

       ! boundary reach ---> not found
       IF (kpiloc == 2  .OR. kpiloc ==kpi-1) ld_bnd=.TRUE.
       IF (kpjloc == 2  .OR. kpjloc ==kpj-1) ld_bnd=.TRUE.
    END DO

  END SUBROUTINE  NEARESTPOINT


  REAL(KIND=8) FUNCTION dist(ddlona, ddlonb, ddlata, ddlatb)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION dist  ***
    !!
    !! ** Purpose : Compute the distance (km) between
    !!              point A (lona, lata) and B (lonb, latb)  
    !!
    !! ** Method  : Use of double precision is important. Compute the 
    !!              distance along the orthodromy
    !!
    !!----------------------------------------------------------------------
    REAL(KIND=8), INTENT(in) :: ddlata, ddlona, ddlatb, ddlonb

    REAL(KIND=8), SAVE :: dl_latar, dl_latbr, dl_lonar, dl_lonbr
    REAL(KIND=8)       :: dl_pds
    REAL(KIND=8), SAVE :: dl_ux, dl_uy, dl_uz
    REAL(KIND=8)       :: dl_vx, dl_vy, dl_vz
    REAL(KIND=8), SAVE :: dl_prevlat=-1000.d0
    REAL(KIND=8), SAVE :: dl_prevlon=-1000.d0
    REAL(KIND=8), SAVE :: dl_r, dl_pi, dl_conv

    LOGICAL :: ll_first=.TRUE.
    !!----------------------------------------------------------------------
    ! initialise some values at first call
    IF ( ll_first ) THEN
       ll_first = .FALSE.
       ! constants
       dl_pi   = ACOS(-1.d0)
       dl_conv = dl_pi/180.d0  ! for degree to radian conversion
       ! Earth radius
       dl_r    = (6378.137d0+6356.7523d0)/2.0d0 ! km
    ENDIF

    ! compute these term only if they differ from previous call
    IF ( ddlata /= dl_prevlat .OR. ddlona /= dl_prevlon) THEN
       dl_latar   = ddlata*dl_conv
       dl_lonar   = ddlona*dl_conv
       dl_ux      = COS(dl_lonar)*COS(dl_latar)
       dl_uy      = SIN(dl_lonar)*COS(dl_latar)
       dl_uz      = SIN(dl_latar)
       dl_prevlat = ddlata
       dl_prevlon = ddlona
    ENDIF

    dl_latbr = ddlatb*dl_conv
    dl_lonbr = ddlonb*dl_conv
    dl_vx    = COS(dl_lonbr)*COS(dl_latbr)
    dl_vy    = SIN(dl_lonbr)*COS(dl_latbr)
    dl_vz    = SIN(dl_latbr)

    dl_pds   = dl_ux*dl_vx + dl_uy*dl_vy + dl_uz*dl_vz

    IF (dl_pds >= 1.) THEN
       dist = 0.
    ELSE
       dist = dl_r*ACOS(dl_pds)
    ENDIF

  END FUNCTION dist

END MODULE cdftools

PROGRAM cdfbathy
  !!======================================================================
  !!                     ***  PROGRAM  cdfbathy  ***
  !!=====================================================================
  !!  ** Purpose : Utility to modify a bathymetric file according to 
  !!               specific option (eg : fill an area, modify points ...)
  !!               Using -var option and -lev, can also edit any file with
  !!               the same tool, except the specific actions dedicated to
  !!               the bathymetry (eg : zstep like ...)
  !!
  !!  ** Method  : All modifications are save in a fortran file ready to be
  !!               used to replay all the modif at once.
  !!
  !! History : 2.1  : 11/2007  : J.M. Molines : Original code
  !!           3.0  : 12/2010  : J.M. Molines : Doctor norm + Lic.
  !!                : 04/1014  : P. Mathiot   : add fill_pool option
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  !!   routines      : description
  !!   zgr_zps 
  !!   zgr_read
  !!   prlog
  !!   fillzone
  !!   raz_zone
  !!   raz_below
  !!   set_below
  !!   dumpzone
  !!   nicedumpzone
  !!   replacezone
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2010, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE
  !
  INTEGER(KIND=4)                              :: narg, iargc, ijarg  ! browse command line
  INTEGER(KIND=4)                              :: iimin, iimax        ! selected area
  INTEGER(KIND=4)                              :: ijmin, ijmax        ! selected area
  INTEGER(KIND=4)                              :: ierr                ! error status
  INTEGER(KIND=4)                              :: icrit               ! maximal size of pool 
  INTEGER(KIND=4)                              :: iklev               ! selected level
  INTEGER(KIND=4)                              :: itime               ! selected time
  INTEGER(KIND=4)                              :: npiglo, npjglo      ! domain size
  INTEGER(KIND=4)                              :: npk, npt            ! domaine size
  INTEGER(KIND=4)                              :: iversion=1          ! version counter for working copy
  INTEGER(KIND=4)                              :: iostat, ipos        ! used for version control
  INTEGER(KIND=4), DIMENSION(:,:), ALLOCATABLE :: mbathy              ! map of wet model level

  REAL(KIND=4)                                 :: e3zps_min=25.       ! minimum thickness of bottom cell
  REAL(KIND=4)                                 :: e3zps_rat=0.2       ! minimum ratio e3bot/e3_0
  REAL(KIND=4)                                 :: rdepmin=600.        ! default value for depmin (full step like)
  REAL(KIND=4)                                 :: rdepfill=0.         ! default filling value
  REAL(KIND=4)                                 :: scale_factor=1.     ! divide by scale factor when reading
  REAL(KIND=4), DIMENSION(:),      ALLOCATABLE :: e3t, e3w            ! vertical metrics
  REAL(KIND=4), DIMENSION(:),      ALLOCATABLE :: gdept, gdepw        ! depth at T and W points
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: e3_bot              ! bottom depth (partial steps)
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: bathyin             ! initial data value
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: bathy               ! modified data value
  !
  CHARACTER(LEN=256)                           :: cf_in               ! original input file name
  CHARACTER(LEN=256)                           :: cf_root             ! root part of the file name
  CHARACTER(LEN=256)                           :: cf_dump             ! dump txt file name (out)
  CHARACTER(LEN=256)                           :: cf_replace          ! replace txt file name (in)
  CHARACTER(LEN=80)                            :: cf_batfile = 'zgrbat.txt' ! txt file giving vertical mesh
  CHARACTER(LEN=80)                            :: cf_log = 'log.f90'  ! default log file
  CHARACTER(LEN=80)                            :: cv_in               ! variable name
  CHARACTER(LEN=256)                           :: cwkc                ! filename of working copy
  CHARACTER(LEN=256)                           :: cldum               ! dummy string

  LOGICAL :: lexist     = .TRUE.,  lfill      = .FALSE.       ! all required flags for options
  LOGICAL :: lfullstep  = .FALSE., lappend    = .FALSE.       ! all required flags for options
  LOGICAL :: lreplace   = .FALSE., ldump      = .FALSE.       ! all required flags for options
  LOGICAL :: lmodif     = .FALSE., loverwrite = .FALSE.       ! all required flags for options
  LOGICAL :: lraz       = .FALSE., ldumpn     = .FALSE.       ! all required flags for options
  LOGICAL :: lrazb      = .FALSE., lsetb      = .FALSE.       ! all required flags for options
  LOGICAL :: lchk       = .FALSE., lfillpool  = .FALSE.       ! all required flags for options
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()

  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfbathy/cdfvar -f IN-file [options]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Allow manual modification of the input file. Very convenient' 
     PRINT *,'       for bathymetric files, can also be used with any model file'
     PRINT *,'       Keep a log.f90 file of the modifications for automatic reprocessing'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       IN-file : original input file. The program works on a copy of the'
     PRINT *,'                original file (default)' 
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT 9999, '   -file (or -f )       : name of input file '
     PRINT 9999, '   -var  (or -v )       : name of cdf variable [default: Bathymetry]'
     PRINT 9999, '   -lev  (or -l )       : level to work with '
     PRINT 9999, '   -time (or -t )       : time to work with '
     PRINT 9999, '   -scale  s            : use s as a scale factor (divide when read the file)'
     PRINT 9999, '   -zoom (or -z )       : sub area of the bathy file to work with (imin imax jmin jmax)'
     PRINT 9999, '   -fillzone (or -fz )  : sub area will be filled with 0 up to the first coast line '
     PRINT 9999, '   -fillpool (or -fp ) [ icrit ] : the whole file is check and fill all the pool smaller than (icrit) cell by 0'
     PRINT 9999, '   -raz_zone (or -raz ) : sub area will be filled with 0 up '
     PRINT 9999, '   -raz_below depmin    : any depth less than depmin in subarea will be replaced by 0 '
     PRINT 9999, '      (or -rb depmin )  '
     PRINT 9999, '   -set_below depmin    : any depth less than depmin in subarea will be replaced by depmin '
     PRINT 9999, '      (or -sb depmin ) '
     PRINT 9999, '   -fullstep depmin     : sub area will be reshaped as full-step, below depmin'
     PRINT 9999, '      (or -fs depmin )    requires the presence of the file zgr_bat.txt (from ocean.output, eg )'
     PRINT 9999, '   -dumpzone (or -d )   : sub area will be output to an ascii file, which can be used by -replace'
     PRINT 9999, '                          after manual editing '
     PRINT 9999, '   -nicedumpzone        : sub area will be output to an ascii file (nice output)'
     PRINT 9999, '            (or -nd )'
     PRINT 9999, '   -replace (or -r )    : sub area defined by the file will replace the original bathy'
     PRINT 9999, '   -append (or -a )     : fortran log file (log.f90) will be append with actual modif'
     PRINT 9999, '                          Standard behaviour is to overwrite/create log file'
     PRINT 9999, '   -overwrite (or -o )  : input bathy file will be used as output.'
     PRINT 9999, '                          Standard behaviour is to use a work copy of the original file'
     PRINT 9999, '                          (indexed from 01 to 99 if necessary ) '
     PRINT 9999, '   -log logfile         : log file for change (default is log.f90) '
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT 9999, '      netcdf file : according to used options, if the original file is to be modified'
     PRINT 9999, '             a sequence number is added at the end of the input file name, to keep'
     PRINT 9999, '             modifications.'
     PRINT *,'            variables : same as input file'
     STOP
  ENDIF
9999 FORMAT(5x,a)

  ijarg = 1
  iimin=-10 ; iimax=-10 ; ijmin=-10 ; ijmax=-10

  cv_in = cn_bathymet  ! default value
  iklev = 1
  itime = 1

  DO  WHILE (ijarg <=  narg)
     CALL getarg(ijarg, cldum) ;  ijarg = ijarg + 1
     SELECT CASE ( cldum )
     !
     CASE ( '-file' , '-f' )     ! name of input file
        CALL getarg(ijarg, cf_in) ; ijarg = ijarg + 1 
        lchk = ( lchk .OR. chkfile (cf_in) )
     !
     CASE ( '-var' , '-v' )      ! name of netcdf variable
        CALL getarg(ijarg, cv_in) ; ijarg = ijarg + 1 
     !
     CASE ( '-lev' , '-k' )      ! level to work with
        CALL getarg(ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) iklev
     !
     CASE ( '-time' , '-t' )     ! time frame to work with
        CALL getarg(ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) itime
     !
     CASE ( '-scale'      )      ! dividing scale factor
        CALL getarg(ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) scale_factor
     !
     CASE ( '-zoom' , '-z' )     ! specify zoomed area
        CALL getarg(ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) iimin
        CALL getarg(ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) iimax
        CALL getarg(ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) ijmin
        CALL getarg(ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) ijmax
    
     CASE ( '-fillzone' , '-fz' )  ! Fill the area specified with zoom 
                                   ! with 0 till a coast is encountered in the East
        lfill=.TRUE. ; lmodif=.TRUE.
     !
     CASE ( '-raz_zone' , '-raz' ) ! Set a zoomed area to 0
        lraz=.TRUE. ; lmodif=.TRUE.
     !
     CASE ( '-raz_below' , '-rb' ) ! Area below this value are set to 0
        CALL getarg(ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) rdepfill
        lrazb=.TRUE. ; lmodif=.TRUE.
     !
     CASE ( '-set_below' , '-sb' ) ! Area below this value are set to values
        CALL getarg(ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) rdepfill
        lsetb=.TRUE. ; lmodif=.TRUE.
     !
     CASE ( '-fullstep' , '-fs' ) ! Create a full-step like bathy in zoomed area
        lfullstep=.TRUE. ; lmodif=.TRUE.
        CALL getarg(ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) rdepmin
     !
     CASE ( '-append' , '-a' )    ! Append modification to the f90 log file
        lappend=.TRUE.
     !
     CASE ( '-overwrite' , '-o' ) ! Overwrite modifications in f90 log file
        loverwrite=.TRUE.
     !
     CASE ( '-fillpool' , '-fp' ) ! Overwrite modifications in f90 log file
        lfillpool=.TRUE. ; lmodif=.TRUE.
        CALL getarg(ijarg, cldum) ; ijarg = ijarg +1 ; READ(cldum,*) icrit
     !
     CASE ( '-replace' , '-r' )   ! Replace zoomed area by values in ascii file
        lreplace=.TRUE. ; lmodif=.TRUE.
        CALL getarg(ijarg, cf_replace) ; ijarg = ijarg +1
        lchk = ( lchk .OR. chkfile (cf_replace) )
     !
     CASE ( '-log'            )  !  log file name
        CALL getarg(ijarg, cf_log) ; ijarg = ijarg +1
     !
     CASE ( '-dumpzone' , '-d' )  ! output the zoomed area in a formatted file
        ldump=.TRUE.
        CALL getarg(ijarg, cf_dump) ; ijarg = ijarg +1
     !
     CASE ( '-nicedumpzone' , '-nd' )  ! idem dumpzone above but with nicer format
        ldumpn=.TRUE.
        CALL getarg(ijarg, cf_dump) ; ijarg = ijarg +1
     !
     CASE DEFAULT
        PRINT *, cldum,' : unknown option '
        STOP
     END SELECT
  END DO
  
  IF ( lchk ) STOP 99 ! missing files

  IF ( lmodif .AND. .NOT. loverwrite) THEN
     ! creating a working copy of the file indexed by iversion
     ipos=INDEX(cf_in,'.',.TRUE.)
     READ(cf_in(ipos+1:),*,IOSTAT=iostat) iversion
     IF (iostat /=0 ) THEN 
        iversion=0
        cf_root=cf_in
     ELSE
        cf_root=cf_in(1:ipos-1)
     ENDIF
     iversion=iversion+1

     DO WHILE ( lexist )
        WRITE(cwkc,'(a,a,i2.2)') TRIM(cf_root),'.',iversion
        INQUIRE(FILE=cwkc,EXIST=lexist)
        iversion=iversion+1
     END DO
     PRINT *, 'Working copy will be : ' ,TRIM(cwkc)
     CALL system(' cp -f '//cf_in//' '//cwkc )
  ELSE
     cwkc=cf_in
  ENDIF

  npiglo = getdim(cwkc,cn_x)
  npjglo = getdim(cwkc,cn_y)
  npk    = getdim(cwkc,cn_z)
  npt    = getdim(cwkc,cn_t)
  IF (npk == 0 ) npk = 1
  IF (npt == 0 ) npt = 1

  IF ( iklev > npk ) THEN
    PRINT *,' ERROR : not enough levels in input file ', TRIM(cwkc)
  ENDIF

  IF ( itime > npt ) THEN
    PRINT *,' ERROR : not enough times in input file ', TRIM(cwkc)
  ENDIF

  IF ( iimin == -10 ) THEN  ! no zoom option passed
     iimin=1 ; iimax=npiglo
     ijmin=1 ; ijmax=npjglo
  END IF

  PRINT *, 'NPIGLO = ', npiglo
  PRINT *, 'NPJGLO = ', npjglo
  PRINT *, 'IMIN IMAX JMIN JMAX :', iimin, iimax,ijmin,ijmax

  ALLOCATE (mbathy(npiglo,npjglo), e3_bot( npiglo,npjglo))
  ALLOCATE (bathy( npiglo,npjglo), bathyin(npiglo,npjglo))

  ! we use bathy as variable name but it can be any field from cf_in
  bathy(:,:) = getvar(cwkc, cv_in, iklev, npiglo, npjglo, ktime=itime)
  bathy(:,:) = bathy(:,:)/scale_factor
  bathyin    = bathy  ! save original 

  IF (lfullstep ) THEN ;CALL zgr_read ; CALL zgr_zps(iimin, iimax, ijmin, ijmax) ; ENDIF
  IF (lfill     )       CALL fillzone  (iimin, iimax, ijmin, ijmax)
  IF (lraz      )       CALL raz_zone  (iimin, iimax, ijmin, ijmax)
  IF (lrazb     )       CALL raz_below (iimin, iimax, ijmin, ijmax, rdepfill)
  IF (lsetb     )       CALL set_below (iimin, iimax, ijmin, ijmax, rdepfill)
  IF (ldump     )       CALL dumpzone     (cf_dump, iimin, iimax, ijmin, ijmax)
  IF (ldumpn    )       CALL nicedumpzone (cf_dump, iimin, iimax, ijmin, ijmax)
  IF (lreplace  )       CALL replacezone  (cf_replace)
  IF (lfillpool )       CALL fillpool  (icrit, iimin, iimax, ijmin, ijmax)

  IF (lmodif ) THEN   ! save log 
     CALL prlog(bathyin, bathy, npiglo, npjglo, lappend)
     ierr = putvar(cwkc, cv_in, iklev, iimax-iimin+1, ijmax-ijmin+1, kimin=iimin, kjmin=ijmin, &
      &            ptab=bathy(iimin:iimax,ijmin:ijmax)*scale_factor, ktime=itime)
  ENDIF

CONTAINS 


  SUBROUTINE zgr_zps ( kimin, kimax ,kjmin, kjmax )
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE zgr_zps  ***
    !!
    !! ** Purpose :   Build the partial steps
    !!
    !! ** Method  :  Use NEMO routine
    !!
    !!----------------------------------------------------------------------
    INTEGER(KIND=4) ,INTENT(in) :: kimin, kimax, kjmin, kjmax
    !! * Local declarations
    INTEGER(KIND=4)  ::   ji, jj, jk        ! dummy loop indices
    INTEGER(KIND=4)  ::   ik, it            ! temporary integers
    INTEGER(KIND=4), PARAMETER :: wp=4      ! working precision is 4 in the CDFTOOLS

    REAL(wp)           :: ze3tp, ze3wp  ! Last ocean level thickness at T- and W-points
    REAL(wp)           :: zdepwp        ! Ajusted ocean depth to avoid too small e3t
    REAL(wp)           :: zdepth        !    "         "
    REAL(wp)           :: zmax, zmin    ! Maximum and minimum depth
    REAL(wp)           :: zdiff         ! temporary scalar
    !!----------------------------------------------------------------------
    ! Initialization of constant
    zmax = gdepw(npk) + e3t(npk)
    zmin = gdepw(4)

    ! initialize mbathy to the maximum ocean level available
    mbathy(kimin:kimax,kjmin:kjmax) = npk-1

    ! storage of land and island's number (zero and negative values) in mbathy
    WHERE (bathy(kimin:kimax,kjmin:kjmax) <= 0. ) mbathy(kimin:kimax,kjmin:kjmax)=INT( bathy(kimin:kimax,kjmin:kjmax) )

    ! bounded value of bathy
    ! minimum depth == 3 levels
    ! maximum depth == gdepw(jpk)+e3t(jpk) 
    ! i.e. the last ocean level thickness cannot exceed e3t(jpkm1)+e3t(jpk)
    WHERE (bathy(kimin:kimax,kjmin:kjmax) <= 0 ) 
       bathy(kimin:kimax,kjmin:kjmax)=0.
    ELSEWHERE (bathy(kimin:kimax,kjmin:kjmax) < zmin ) 
       bathy(kimin:kimax,kjmin:kjmax) = zmin
    ELSEWHERE (bathy(kimin:kimax,kjmin:kjmax) >= zmax )
       bathy(kimin:kimax,kjmin:kjmax) = zmax
    END WHERE

    ! Compute mbathy for ocean points (i.e. the number of ocean levels)
    ! find the number of ocean levels such that the last level thickness
    ! is larger than the minimum of e3zps_min and e3zps_rat * e3t (where
    ! e3t is the reference level thickness
    DO jk = npk-1, 1, -1
!      zdepth = gdepw(jk) + MIN( e3zps_min, e3t(jk)*e3zps_rat )
       zdepth = gdept(jk)
       WHERE ( bathy(kimin:kimax,kjmin:kjmax) > 0. .AND. bathy (kimin:kimax,kjmin:kjmax) <= zdepth )  
          mbathy(kimin:kimax,kjmin:kjmax)=jk-1
          e3_bot(kimin:kimax,kjmin:kjmax)= bathy(kimin:kimax,kjmin:kjmax) - gdepw(jk-1)
       END WHERE
    END DO

    DO ji=kimin,kimax
      DO jj=kjmin,kjmax
        jk=mbathy(ji,jj)
        IF (jk /= 0 ) THEN 
           IF (gdepw(jk+1) > rdepmin ) bathy(ji,jj)=gdepw(jk+1)-0.1
        ENDIF
      ENDDO
    END DO
  END SUBROUTINE zgr_zps


  SUBROUTINE zgr_read()
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE zgr_read  ***
    !!
    !! ** Purpose :  Read zgrbat.txt file (cf_batfile) to set the gdep[tw]_0
    !!               and e3[tw] 
    !!
    !! ** Method  :  Read the ocean output format ( ie, cf_batfile is just 
    !!               a copy of the ocean.output concerning zgrbat 
    !!
    !!----------------------------------------------------------------------
    INTEGER(KIND=4) :: inumzgr = 10, il, iostat, idum, ifoo
    CHARACTER(LEN=256) :: cline, clfile
    !!----------------------------------------------------------------------
    clfile = cf_batfile       ! defined in the main program
    il=0
    OPEN(inumzgr, FILE=clfile,IOSTAT=iostat)

    DO WHILE ( iostat == 0 )
       READ(inumzgr,'(a)',IOSTAT=iostat) cline
       READ(cline,*,IOSTAT=idum )il
       IF ( idum == 0 ) npk=il
    END DO

    ALLOCATE ( gdept(npk), gdepw(npk), e3t(npk), e3w(npk) )
    REWIND(inumzgr)

    il=0 ; iostat=0
    DO WHILE ( iostat == 0 )
       READ(inumzgr,'(a)', IOSTAT=iostat) cline
       READ(cline,*,IOSTAT=idum) il
       IF ( idum == 0  ) READ(cline,*) ifoo, gdept(il), gdepw(il), &
            &             e3t(il), e3w(il)
    END DO
  END SUBROUTINE zgr_read


  SUBROUTINE prlog (ptabold, ptab ,kpi, kpj, ldapp)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE prlog  ***
    !!
    !! ** Purpose :   Print a fortran 90 log file describing the modifications
    !!              done to the bathymetry
    !!
    !! ** Method  :  File is append instead of created if ldapp true
    !!
    !!----------------------------------------------------------------------
    REAL(KIND=4), DIMENSION(:,:), INTENT(in) :: ptabold  ! original array
    REAL(KIND=4), DIMENSION(:,:), INTENT(in) :: ptab     ! modified array
    INTEGER(KIND=4),              INTENT(in) :: kpi, kpj ! size of the array
    LOGICAL,                      INTENT(in) :: ldapp    ! append flag

    INTEGER(KIND=4)        :: ji, jj
    INTEGER(KIND=4)        :: inumlog=10
    CHARACTER(LEN=80)      :: clfile
    !!----------------------------------------------------------------------
    clfile = cf_log

    IF (ldapp ) THEN 
       OPEN (inumlog, FILE=clfile, POSITION='append')
    ELSE
       OPEN (inumlog, FILE=clfile)
    ENDIF

    WRITE(inumlog,'(a,a)') '! modification from original file : ', TRIM(cf_in)
    WRITE(inumlog,'(a,a)') '! written to : ', TRIM(cwkc)
    DO ji=1,kpi
       DO jj=1,kpj
          IF ( ABS( ptabold(ji,jj) - ptab(ji,jj)) > 0.02  ) THEN    ! allow a 2 cm tolerance for rounding purposes
             WRITE(inumlog,'(a,i4,a,i4,a,f8.2,a,f8.2)') ' bathy(',ji,',',jj,')=',ptab(ji,jj)*scale_factor,  &
                    & ' ! instead of ',ptabold(ji,jj)*scale_factor
          END IF
       END DO
    END DO

    CLOSE(inumlog)
  END SUBROUTINE prlog


  SUBROUTINE fillzone(kimin, kimax, kjmin, kjmax)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE fillzone  ***
    !!
    !! ** Purpose :  Fill a subarea with 0 up to encounter a coast on the East
    !!
    !! ** Method  :  Assume that first point is sea point. Mask it and do so with
    !!               all points to the east (j=cst) up to a land point. 
    !!
    !!----------------------------------------------------------------------
    INTEGER(KIND=4), INTENT(in) :: kimin, kimax, kjmin, kjmax ! position of the data windows

    INTEGER(KIND=4) :: jj 
    INTEGER(KIND=4) :: ii
    !!----------------------------------------------------------------------
    DO jj=kjmin,kjmax
       ii=kimin
       IF ( bathy(ii,jj)  /= 0 ) THEN
          DO WHILE ( bathy(ii,jj)  /= 0 .AND. ii <= kimax )
             bathy(ii,jj) = 0.
             ii=ii+1
          END DO
       END IF
    END DO
  END SUBROUTINE fillzone


  SUBROUTINE raz_zone(kimin, kimax, kjmin, kjmax)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE raz_zone  ***
    !!
    !! ** Purpose :  Fill a sub area of a bathy file with 0 
    !!
    !!----------------------------------------------------------------------
    INTEGER(KIND=4), INTENT(in) :: kimin, kimax, kjmin, kjmax ! position of the data windows
    !!----------------------------------------------------------------------
    bathy(kimin:kimax, kjmin:kjmax) = 0.

  END SUBROUTINE raz_zone


  SUBROUTINE raz_below(kimin, kimax, kjmin, kjmax, pdepmin)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE raz_below  ***
    !!
    !! ** Purpose : Fill point (set to 0) that are below pdepmin
    !!
    !!----------------------------------------------------------------------
    INTEGER(KIND=4), INTENT(in) :: kimin, kimax, kjmin, kjmax ! position of the data windows
    REAL(KIND=4),    INTENT(in) :: pdepmin                    ! threshold bathy value
    !!----------------------------------------------------------------------
   WHERE ( bathy(kimin:kimax, kjmin:kjmax) <= pdepmin)  bathy(kimin:kimax, kjmin:kjmax) = 0.

  END SUBROUTINE raz_below


  SUBROUTINE set_below(kimin, kimax, kjmin, kjmax, pdepmin)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE set_below  ***
    !!
    !! ** Purpose : Set bathy points to pdepmin if less than pdepmin in the
    !!              original bathy
    !!
    !!----------------------------------------------------------------------
    INTEGER(KIND=4), INTENT(in) :: kimin, kimax, kjmin, kjmax ! position of the data windows
    REAL(KIND=4),    INTENT(in) :: pdepmin                    ! threshold bathy value
    !!----------------------------------------------------------------------
   WHERE ( bathy(kimin:kimax, kjmin:kjmax) <= pdepmin .AND. bathy(kimin:kimax, kjmin:kjmax) > 0 ) &
        &                 bathy(kimin:kimax, kjmin:kjmax) = pdepmin

  END SUBROUTINE set_below


  SUBROUTINE dumpzone(cdumpf, kimin, kimax, kjmin, kjmax)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE dumpzone  ***
    !!
    !! ** Purpose :  Print subarea to cdumpf ascii file 
    !!
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*), INTENT(in) :: cdumpf                     ! name of the dump file
    INTEGER(KIND=4),  INTENT(in) :: kimin, kimax, kjmin, kjmax ! position of the data windows

    INTEGER(KIND=4)    :: ji, jj
    INTEGER(KIND=4)    :: inumdmp=20 , ini
    CHARACTER(LEN=256) :: cl_fmtr, cl_fmti
    !!----------------------------------------------------------------------
    ini = kimax - kimin + 1
    WRITE(cl_fmtr,99) ini
    WRITE(cl_fmti,98) ini
    OPEN(inumdmp,FILE=cdumpf)
    WRITE(inumdmp,*) kimin, kimax, kjmin, kjmax, TRIM(cl_fmtr)
99  FORMAT('(I5,',i4.4,'f8.2)')
98  FORMAT('(5x,',i4.4,'I8)')
    WRITE(inumdmp,cl_fmti)(ji,ji=kimin,kimax)
    DO jj= kjmax,kjmin,-1
       WRITE(inumdmp,cl_fmtr) jj, bathy(kimin:kimax,jj)
    ENDDO
    CLOSE(inumdmp)

  END SUBROUTINE dumpzone


  SUBROUTINE nicedumpzone(cdumpf, kimin, kimax, kjmin, kjmax)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE nicedumpzone  ***
    !!
    !! ** Purpose : Print subarea to cdumpf ascii file with a nice format  
    !!
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*), INTENT(in) :: cdumpf                     ! name of the dump file
    INTEGER(KIND=4),  INTENT(in) :: kimin, kimax, kjmin, kjmax ! position of the data windows

    INTEGER(KIND=4)    :: ji, jj
    INTEGER(KIND=4)    :: inumdmp=20 , ini
    CHARACTER(LEN=256) :: cl_fmtr, cl_fmti
    !!----------------------------------------------------------------------
    ini=kimax-kimin+1
    WRITE(cl_fmtr,99) ini
    WRITE(cl_fmti,98) ini
    OPEN(inumdmp,FILE=cdumpf)
    WRITE(inumdmp,*) kimin,kimax,kjmin,kjmax, TRIM(cl_fmtr)
99  FORMAT('(I5,',i4.4,'I5)')
98  FORMAT('(5x,',i4.4,'I5)')
    WRITE(inumdmp,cl_fmti)(ji,ji=kimin,kimax)
    DO jj= kjmax,kjmin,-1
       WRITE(inumdmp,cl_fmtr) jj, INT(bathy(kimin:kimax,jj))
       WRITE(inumdmp,*)
       WRITE(inumdmp,*)
    ENDDO
    CLOSE(inumdmp)

  END SUBROUTINE nicedumpzone


  SUBROUTINE replacezone(cdreplace)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE replacezone  ***
    !!
    !! ** Purpose :  Replace a bathy area by data read from an ascii input file
    !!               formely generated by -dump option (and manualy modified) 
    !!
    !! ** Method  :  Read format in the header part of the file 
    !!
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*), INTENT(in) :: cdreplace

    INTEGER(KIND=4) :: jj
    INTEGER(KIND=4) :: iimin, iimax, ijmin, ijmax
    INTEGER(KIND=4) :: inumrep=20, idum
    !!----------------------------------------------------------------------
    OPEN(inumrep,FILE=cdreplace)
    READ(inumrep,*) iimin, iimax, ijmin, ijmax
    READ(inumrep,*)  ! skip 1 line
    DO jj=ijmax,ijmin,-1
       READ(inumrep,*) idum, bathy(iimin:iimax,jj)
    END DO
    CLOSE(inumrep)

  END SUBROUTINE replacezone
  

  SUBROUTINE fillpool(kcrit, kimin, kimax, kjmin, kjmax) 
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE replacezone  ***
    !!
    !! ** Purpose :  Replace all area surrounding by mask value by mask value
    !!
    !! ** Method  :  flood fill algorithm
    !!
    !!----------------------------------------------------------------------
    INTEGER, INTENT(in) :: kcrit        ! maximal allowed pool 
    INTEGER(KIND=4),  INTENT(in) :: kimin, kimax, kjmin, kjmax ! position of the data windows

    INTEGER :: ik                       ! number of point change
    INTEGER :: ip                       ! size of the pile
    INTEGER :: ji, jj                   ! loop index
    INTEGER :: iip1, iim1, ii, ij       ! working integer
    INTEGER, DIMENSION(:,:), ALLOCATABLE :: ipile    ! pile variable
    INTEGER, DIMENSION(:,:), ALLOCATABLE :: ioptm    ! matrix to check already tested value 

    REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zbathy   ! new bathymetry
    !!----------------------------------------------------------------------
    PRINT *, 'WARNING North fold case not coded'
    ! allocate variable
    ALLOCATE(ipile(((kimax-kimin)+1)*((kjmax-kjmin)+1),2))
    ALLOCATE(zbathy(npiglo,npjglo), ioptm(npiglo,npjglo))

    ioptm = bathy
    WHERE (ioptm /=  0)
       ioptm = 1
    END WHERE

    PRINT *, 'Filling area in progress ... (it can take a while)'    

    DO ji=kimin,kimax
       IF (mod(ji,100) == 0) PRINT *, ji,'/',npiglo
       DO jj=kjmin,kjmax
          ! modify something only if seed point is a non 0 cell
          IF (ioptm(ji,jj) == 1) THEN
             ! initialise variables
             zbathy=bathy
             ipile(:,:)=0
             ipile(1,:)=[ji,jj]
             ip=1; ik=0
         
             ! loop until the pile size is 0 or if the pool is larger than the critical size
             DO WHILE ( ip /= 0 .AND. ik < kcrit);
                ik=ik+1 
                ii=ipile(ip,1); ij=ipile(ip,2)
               
                ! update bathy and update pile size
                zbathy(ii,ij)=0.0 
                ipile(ip,:)  =[0,0]; ip=ip-1
                
                ! check neighbour cells and update pile
                iip1=ii+1; IF ( iip1 == npiglo+1 ) iip1=2
                iim1=ii-1; IF ( iim1 == 0        ) iim1=npiglo-1
                IF (zbathy(ii, ij+1) /=  0.0) THEN
                    ip=ip+1; ipile(ip,:)=[ii  ,ij+1] 
                    ioptm (ii, ij+1) = 0
                END IF
                IF (zbathy(ii, ij-1) /= 0.0) THEN
                    ip=ip+1; ipile(ip,:)=[ii  ,ij-1]
                    ioptm(ii, ij-1) = 0
                END IF
                IF (zbathy(iip1, ij) /=  0.0) THEN
                    ip=ip+1; ipile(ip,:)=[iip1,ij  ]
                    ioptm(iip1, ij) = 0
                END IF
                IF (zbathy(iim1, ij) /=  0.0) THEN
                    ip=ip+1; ipile(ip,:)=[iim1,ij  ]
                    ioptm(iim1, ij) = 0
                END IF
             END DO
             IF (ik < kcrit) bathy=zbathy;
          END IF
       END DO
    END DO
 
    DEALLOCATE(ipile); DEALLOCATE(zbathy, ioptm)

  END SUBROUTINE


END PROGRAM cdfbathy

PROGRAM cdfflxconv
  !!-------------------------------------------------------------------
  !!              PROGRAM CDFFLXCONV
  !!              ******************
  !!
  !!  **  Purpose: Convert a set of fluxes dimgfile (Clipper like)
  !!               to a set of CDF files (Drakkar like )
  !!  
  !!  **  Method: takes the current year as input, and config name
  !!              automatically read 
  !!                  ECMWF.Y${year}.M??.FLUX.${config}.dimg (daily, 1 file per month)
  !!                  ECMWF.Y${year}.M??.STRESS.${config}.dimg (daily, 1 file per month)
  !!                  REYNOLDS.Y${year}.SST.${config}.dimg ( weekly, 1 file per year ) ! Danger !
  !!              creates 6 netcdf daily files :
  !!                  ECMWF_emp_1d_${year}.${config}.nc                
  !!                  ECMWF_qnet_1d_${year}.${config}.nc                
  !!                  ECMWF_qsr_1d_${year}.${config}.nc                
  !!                  ECMWF_sst_1d_${year}.${config}.nc                
  !!                  ECMWF_taux_1d_${year}.${config}.nc                
  !!                  ECMWF_tauy_1d_${year}.${config}.nc                
  !!              Requires  coordinates.diags file (to be input consistent)
  !!
  !! history:
  !!    Original:  J.M. Molines (Feb. 2007 )
  !!-------------------------------------------------------------------
  !!  $Rev$
  !!  $Date$
  !!  $Id$
  !!--------------------------------------------------------------
  !!
  !! * Modules used
  USE cdfio 

  !! * Local variables
  IMPLICIT NONE
  INTEGER   :: ji,jj,jk, jvar, jmonth, jdim, jday, jt
  INTEGER   :: narg, iargc, nvar
  INTEGER   :: npiglo,npjglo, npk                           !: size of the domain
  INTEGER   :: iyear, icurrday, jul, jul1, jul2
  INTEGER   :: id1, id2, ii1, ii2, ntime, ntp, ntn, itt
  INTEGER   :: january1, december31
  INTEGER, DIMENSION(:), ALLOCATABLE :: itime

  REAL(KIND=4) , DIMENSION (:,:,:), ALLOCATABLE :: v2d
  REAL(KIND=4) , DIMENSION (:,:), ALLOCATABLE ::  glam, gphi, z2d, v2daily
  REAL(KIND=4) , DIMENSION (:,:), ALLOCATABLE ::  glamu, gphiu
  REAL(KIND=4) , DIMENSION (:,:), ALLOCATABLE ::  glamv, gphiv
  REAL(KIND=4) , DIMENSION (:), ALLOCATABLE :: dep, timetab
  REAL(KIND=8) , DIMENSION (:), ALLOCATABLE ::  timetag, timetagp,timetagn
  REAL(KIND=4) ,DIMENSION(1)                  :: timean 

  CHARACTER(LEN=256) :: ctag, confcase

  ! Dimg stuff
  INTEGER   :: irecl, ii, nt, ndim, irec
  INTEGER   :: numflx=10, numcoo=11, numtau=12, numsst=14, numsstp=15, numsstn=16
  CHARACTER(LEN=256) :: cflux, ctau, csstr,csstrp, csstrn
  CHARACTER(LEN=256) :: coord='coordinates.diags'
  CHARACTER(LEN=256) :: cheader, cdum, config
  CHARACTER(LEN=4) :: cver
  REAL(KIND=4) :: x1,y1, dx,dy, spval
  ! coordinates.diags
  INTEGER :: nrecl8
  REAL(KIND=8) :: zrecl8, zpiglo,zpjglo
  REAL(KIND=8) , DIMENSION (:,:), ALLOCATABLE ::  dzvar
  CHARACTER(LEN=256) :: cltextco
  LOGICAL :: lexist

  ! Netcdf Stuff
  CHARACTER(LEN=256) :: cemp, cqnet, cqsr, ctaux, ctauy, csst
  TYPE(variable), DIMENSION(:), ALLOCATABLE :: typvaremp,typvarqnet,typvarqsr
  TYPE(variable), DIMENSION(:), ALLOCATABLE :: typvartaux,typvartauy,typvarsst
  INTEGER, DIMENSION(:), ALLOCATABLE ::  ipkemp, ipkqnet, ipkqsr, id_varoutemp,id_varoutqnet, id_varoutqsr
  INTEGER, DIMENSION(:), ALLOCATABLE ::  ipktaux, ipktauy, ipksst, id_varouttaux,id_varouttauy, id_varoutsst
  INTEGER    :: ncoutemp, ncoutqnet, ncoutqsr, ncouttaux, ncouttauy, ncoutsst
  INTEGER    :: istatus

  !!  Read command line
  narg= iargc()
  IF ( narg /= 2 ) THEN
     PRINT *,' Usage : cdfflxconv YEAR config '
     PRINT *,'    Output 6 cdf files : for emp, qnet, qsr, sst, taux, tauy with standard var name :'
     PRINT *,'        sowaflup, sohefldo, soshfldo, sst, sozotaux, sometauy '
     PRINT *,'    coordinates.diags ( clipper like) is required in current dir '
     STOP
  ENDIF
  !!
  CALL getarg (1, cdum)
  READ(cdum,*) iyear
  CALL getarg (2, config)


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !!     .....    FLUXES    FLUXES   FLUXES .....                                                     !!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  PRINT *, 'Doing fluxes ... '

  !! read glam gphi in the coordinates file for T point (fluxes)
  nrecl8=200
  OPEN(numcoo,FILE=coord,status='old' ,form='unformatted', access='direct',recl=nrecl8)
  READ(numcoo,rec=1) cltextco,zrecl8,zpiglo,zpjglo
  CLOSE(numcoo)
  nrecl8=zrecl8 ;  npiglo=zpiglo ; npjglo=zpjglo
  ALLOCATE ( glam(npiglo,npjglo), gphi(npiglo,npjglo) ,dzvar(npiglo,npjglo) )
  OPEN(numcoo,FILE=coord,status='old' ,form='unformatted', access='direct',recl=nrecl8)
  READ(numcoo,REC=2)((dzvar(ji,jj),ji=1,npiglo),jj=1,npjglo)  ; glam(:,:) = dzvar(:,:)
  READ(numcoo,REC=6)((dzvar(ji,jj),ji=1,npiglo),jj=1,npjglo)  ; gphi(:,:) = dzvar(:,:)
  DEALLOCATE ( dzvar )
  CLOSE(numcoo)

  !! build nc output files
  WRITE(cemp,'(a,I4.4,a)') 'ECMWF_emp_1d_',iyear,'.'//TRIM(config)//'.nc'
  WRITE(cqnet,'(a,I4.4,a)') 'ECMWF_qnet_1d_',iyear,'.'//TRIM(config)//'.nc'
  WRITE(cqsr,'(a,I4.4,a)') 'ECMWF_qsr_1d_',iyear,'.'//TRIM(config)//'.nc'

  jmonth=1
  !! Build dimg file names
  WRITE(cflux,'(a,I4.4,a,I2.2,a)') 'ECMWF.Y',iyear,'.M',jmonth,'.FLUX.'//TRIM(config)//'.dimg'
  ! WRITE(ctau ,'(a,I4.4,a,I2.2,a)') 'ECMWF.Y',iyear,'.M',imonth,'.STRESS.'//TRIM(config)//'.dimg'
  ! WRITE(csst ,'(a,I4.4,a,I2.2,a)') 'REYNOLDS.Y',iyear,'.SST.'//TRIM(config)//'.dimg'

  ! open (and check ?? if they exists )
  irecl=isdirect(cflux)  ; OPEN( numflx,FILE=cflux, FORM='UNFORMATTED', ACCESS='DIRECT', RECL=irecl )

  READ(numflx,REC=1) cver, cheader, ii, npiglo, npjglo, npk

  ALLOCATE (v2d(npiglo, npjglo,4), dep(npk) )
  ALLOCATE (z2d(npiglo, npjglo) )
  READ(numflx,REC=1) cver, cheader, ii, npiglo, npjglo, npk, nt, ndim, &
       x1,y1,dx,dy,spval,   &
       (dep(jk),jk=1,npk), &
       timean(1)
  CLOSE(numflx)

  ! Build  cdf files output
  nvar = 1 ! 1 var but many files ... (OK  ... 3 actually )
  ALLOCATE ( typvaremp(nvar), ipkemp(nvar), id_varoutemp(nvar) )
  ALLOCATE ( typvarqnet(nvar), ipkqnet(nvar), id_varoutqnet(nvar) )
  ALLOCATE ( typvarqsr(nvar), ipkqsr(nvar), id_varoutqsr(nvar) )
  jvar=1
  ipkemp(jvar)      = 1
  typvaremp(jvar)%cname='sowaflup'    ! E - P = dim 3 - dim 4 dimgfile
  typvaremp(jvar)%cunits='kg/m2/s'
  typvaremp(jvar)%rmissing_value=0.
  typvaremp(jvar)%valid_min= -0.002
  typvaremp(jvar)%valid_max= 0.002
  typvaremp(jvar)%clong_name='E-P Upward water flux'
  typvaremp(jvar)%cshort_name='sowaflup'
  typvaremp(jvar)%conline_operation='N/A'
  typvaremp(jvar)%caxis='TYX'

  ipkqnet(jvar)      = 1
  typvarqnet(jvar)%cname='sohefldo'   !  QNET = dim 1 dimgfile
  typvarqnet(jvar)%cunits='W/m2'
  typvarqnet(jvar)%rmissing_value=0.
  typvarqnet(jvar)%valid_min= -1000.
  typvarqnet(jvar)%valid_max= 1000.
  typvarqnet(jvar)%clong_name='Net_Downward_Heat_Flux'
  typvarqnet(jvar)%cshort_name='sohefldo'
  typvarqnet(jvar)%conline_operation='N/A'
  typvarqnet(jvar)%caxis='TYX'

  ipkqsr(jvar)      = 1
  typvarqsr(jvar)%cname='soshfldo'   ! QSR = dim 2 dimgfile
  typvarqsr(jvar)%cunits='W/m2'
  typvarqsr(jvar)%rmissing_value=0.
  typvarqsr(jvar)%valid_min= -1000.
  typvarqsr(jvar)%valid_max= 1000.
  typvarqsr(jvar)%clong_name='Short_Wave_Radiation'
  typvarqsr(jvar)%cshort_name='soshfldo'
  typvarqsr(jvar)%conline_operation='N/A'
  typvarqsr(jvar)%caxis='TYX'

  ncoutemp =create(cemp, 'none',npiglo,npjglo,npk,cdep='deptht' )
  istatus= createvar(ncoutemp ,typvaremp,nvar, ipkemp,id_varoutemp )
  istatus= putheadervar(ncoutemp, 'none', npiglo, npjglo,npk, pnavlon=glam,pnavlat=gphi,pdep=dep )
  ncoutqnet =create(cqnet, 'none',npiglo,npjglo,npk,cdep='deptht' )
  istatus= createvar(ncoutqnet ,typvarqnet,nvar, ipkqnet,id_varoutqnet )
  istatus= putheadervar(ncoutqnet, 'none', npiglo, npjglo,npk, pnavlon=glam,pnavlat=gphi,pdep=dep )
  ncoutqsr =create(cqsr, 'none',npiglo,npjglo,npk,cdep='deptht' )
  istatus= createvar(ncoutqsr ,typvarqsr,nvar, ipkqsr,id_varoutqsr )
  istatus= putheadervar(ncoutqsr, 'none', npiglo, npjglo,npk, pnavlon=glam,pnavlat=gphi,pdep=dep )

  ! Ready for time loop on month
  icurrday=0
  DO jmonth = 1, 12
     WRITE(cflux,'(a,I4.4,a,I2.2,a)') 'ECMWF.Y',iyear,'.M',jmonth,'.FLUX.'//TRIM(config)//'.dimg'
     irecl=isdirect(cflux)  ; OPEN( numflx,FILE=cflux, FORM='UNFORMATTED', ACCESS='DIRECT', RECL=irecl )
     READ(numflx,REC=1) cver, cheader, ii, npiglo, npjglo, npk, nt, ndim
     ! loop for days in files
     DO jday=1,nt
        icurrday=icurrday +1
        DO jdim=1,ndim
           irec=1+(jday-1)*ndim +jdim
           READ(numflx,REC=irec) (( v2d(ji,jj,jdim),ji=1,npiglo),jj=1,npjglo) 
        END DO
        ! emp
        z2d=(v2d(:,:,3) - v2d(:,:,4) )/ 86400.   ! scaling from mm/d to kg/m2/s
        istatus = putvar(ncoutemp,id_varoutemp(1),z2d,icurrday,npiglo,npjglo)
        ! qnet
        istatus = putvar(ncoutqnet,id_varoutqnet(1),v2d(:,:,1),icurrday,npiglo,npjglo)
        ! qsr
        istatus = putvar(ncoutqsr,id_varoutqsr(1),v2d(:,:,2),icurrday,npiglo,npjglo)
     END DO ! loop on days
     CLOSE(numflx)
  END DO ! loop on month

  ! update time_counter
  ALLOCATE( timetab (icurrday) )
  timetab=(/(jt,jt=1,icurrday)/)
  istatus=putvar1d(ncoutemp,timetab,icurrday,'T')
  istatus=putvar1d(ncoutqnet,timetab,icurrday,'T')
  istatus=putvar1d(ncoutqsr,timetab,icurrday,'T')
  ! close fluxes files
  istatus=closeout(ncoutemp)
  istatus=closeout(ncoutqnet)
  istatus=closeout(ncoutqsr)
  DEALLOCATE (v2d , dep, z2d , timetab )

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !!     .....    STRESSES    STRESSES    STRESSES   ......                                       !!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  PRINT *,' Doing Stresses ...'

  !! read glam gphi in the coordinates file for U point (fluxes)
  nrecl8=200
  OPEN(numcoo,FILE=coord,status='old' ,form='unformatted', access='direct',recl=nrecl8)
  READ(numcoo,rec=1) cltextco,zrecl8,zpiglo,zpjglo
  CLOSE(numcoo)
  nrecl8=zrecl8 ;  npiglo=zpiglo ; npjglo=zpjglo
  ALLOCATE ( glamu(npiglo,npjglo), gphiu(npiglo,npjglo) ,dzvar(npiglo,npjglo) )
  ALLOCATE ( glamv(npiglo,npjglo), gphiv(npiglo,npjglo) )
  OPEN(numcoo,FILE=coord,status='old' ,form='unformatted', access='direct',recl=nrecl8)
  READ(numcoo,REC=3)((dzvar(ji,jj),ji=1,npiglo),jj=1,npjglo)  ; glamu(:,:) = dzvar(:,:)
  READ(numcoo,REC=7)((dzvar(ji,jj),ji=1,npiglo),jj=1,npjglo)  ; gphiu(:,:) = dzvar(:,:)
  READ(numcoo,REC=4)((dzvar(ji,jj),ji=1,npiglo),jj=1,npjglo)  ; glamv(:,:) = dzvar(:,:)
  READ(numcoo,REC=8)((dzvar(ji,jj),ji=1,npiglo),jj=1,npjglo)  ; gphiv(:,:) = dzvar(:,:)
  DEALLOCATE ( dzvar )
  CLOSE(numcoo)

  !! build nc output files
  WRITE(ctaux,'(a,I4.4,a)') 'ECMWF_taux_1d_',iyear,'.'//TRIM(config)//'.nc'
  WRITE(ctauy,'(a,I4.4,a)') 'ECMWF_tauy_1d_',iyear,'.'//TRIM(config)//'.nc'

  jmonth=1
  !! Build dimg file names
  WRITE(ctau ,'(a,I4.4,a,I2.2,a)') 'ECMWF.Y',iyear,'.M',jmonth,'.STRESS.'//TRIM(config)//'.dimg'
  ! WRITE(csst ,'(a,I4.4,a,I2.2,a)') 'REYNOLDS.Y',iyear,'.SST.'//TRIM(config)//'.dimg'

  ! open (and check ?? if they exists )
  irecl=isdirect(ctau)  ; OPEN( numtau,FILE=ctau, FORM='UNFORMATTED', ACCESS='DIRECT', RECL=irecl )

  READ(numtau,REC=1) cver, cheader, ii, npiglo, npjglo, npk

  ALLOCATE (v2d(npiglo, npjglo,2), dep(npk) )
  ALLOCATE (z2d(npiglo, npjglo) )
  READ(numtau,REC=1) cver, cheader, ii, npiglo, npjglo, npk, nt, ndim, &
       x1,y1,dx,dy,spval,   &
       (dep(jk),jk=1,npk), &
       timean(1)
  CLOSE(numtau)

  ! Build  cdf files output
  nvar = 1 ! 1 var but many files ... (OK  ... 3 actually )
  ALLOCATE ( typvartaux(nvar), ipktaux(nvar), id_varouttaux(nvar) )
  ALLOCATE ( typvartauy(nvar), ipktauy(nvar), id_varouttauy(nvar) )
  jvar=1
  ipktaux(jvar)      = 1
  typvartaux(jvar)%cname='sozotaux'    ! taux dim 1 of dimgfile
  typvartaux(jvar)%cunits='N/m2'
  typvartaux(jvar)%rmissing_value=0.
  typvartaux(jvar)%valid_min= -0.1
  typvartaux(jvar)%valid_max= 0.1
  typvartaux(jvar)%clong_name='Zonal Wind Stress'
  typvartaux(jvar)%cshort_name='sozotaux'
  typvartaux(jvar)%conline_operation='N/A'
  typvartaux(jvar)%caxis='TYX'

  ipktauy(jvar)      = 1
  typvartauy(jvar)%cname='sometauy'    ! tauy dim 2 of dimgfile
  typvartauy(jvar)%cunits='N/m2'
  typvartauy(jvar)%rmissing_value=0.
  typvartauy(jvar)%valid_min= -0.1
  typvartauy(jvar)%valid_max= 0.1
  typvartauy(jvar)%clong_name='Meridional Wind Stress'
  typvartauy(jvar)%cshort_name='sometauy'
  typvartauy(jvar)%conline_operation='N/A'
  typvartauy(jvar)%caxis='TYX'

  ncouttaux =create(ctaux, 'none',npiglo,npjglo,npk,cdep='deptht' )
  istatus= createvar(ncouttaux ,typvartaux,nvar, ipktaux,id_varouttaux )
  istatus= putheadervar(ncouttaux, 'none', npiglo, npjglo,npk, pnavlon=glam,pnavlat=gphi,pdep=dep )

  ncouttauy =create(ctauy, 'none',npiglo,npjglo,npk,cdep='deptht' )
  istatus= createvar(ncouttauy ,typvartauy,nvar, ipktauy,id_varouttauy )
  istatus= putheadervar(ncouttauy, 'none', npiglo, npjglo,npk, pnavlon=glam,pnavlat=gphi,pdep=dep )

  ! Ready for time loop on month
  icurrday=0
  DO jmonth = 1, 12
     WRITE(ctau,'(a,I4.4,a,I2.2,a)') 'ECMWF.Y',iyear,'.M',jmonth,'.STRESS.'//TRIM(config)//'.dimg'
     irecl=isdirect(ctau)  ; OPEN( numtau,FILE=ctau, FORM='UNFORMATTED', ACCESS='DIRECT', RECL=irecl )
     READ(numtau,REC=1) cver, cheader, ii, npiglo, npjglo, npk, nt, ndim
     ! loop for days in files
     DO jday=1,nt
        icurrday=icurrday +1
        DO jdim=1,ndim
           irec=1+(jday-1)*ndim +jdim
           READ(numtau,REC=irec) (( v2d(ji,jj,jdim),ji=1,npiglo),jj=1,npjglo) 
        END DO
        ! taux
        istatus = putvar(ncouttaux,id_varouttaux(1),v2d(:,:,1),icurrday,npiglo,npjglo)
        ! tauy
        istatus = putvar(ncouttauy,id_varouttauy(1),v2d(:,:,2),icurrday,npiglo,npjglo)
     END DO ! loop on days
     CLOSE(numtau)
  END DO ! loop on month

  ! update time_counter
  ALLOCATE( timetab (icurrday) )
  timetab=(/(jt,jt=1,icurrday)/)
  istatus=putvar1d(ncouttaux,timetab,icurrday,'T')
  istatus=putvar1d(ncouttauy,timetab,icurrday,'T')
  ! close fluxes files
  istatus=closeout(ncouttaux)
  istatus=closeout(ncouttauy)
  DEALLOCATE (v2d , dep, z2d , timetab)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !!     .....    SST    SST     SST     .....
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  PRINT *,' Doing SST ...'

  !!  glam gphi are already read ( T point)

  !! build nc output files
  WRITE(csst,'(a,I4.4,a)') 'REYNOLDS_sst_1d_',iyear,'.'//TRIM(config)//'.nc'

  !! Build dimg file names
  WRITE(csstr ,'(a,I4.4,a,I2.2,a)') 'REYNOLDS.Y',iyear,'.SST.'//TRIM(config)//'.dimg'

  ! open (and check ?? if they exists )
  irecl=isdirect(csstr)  ; OPEN( numsst,FILE=csstr, FORM='UNFORMATTED', ACCESS='DIRECT', RECL=irecl )

  READ(numsst,REC=1) cver, cheader, ii, npiglo, npjglo, npk, nt

  ALLOCATE (v2d(npiglo, npjglo,nt+2),itime(nt+2), dep(npk) ,timetab(nt), timetag(nt) )
  ALLOCATE (z2d(npiglo, npjglo) ,v2daily(npiglo,npjglo)  )
  READ(numsst,REC=1) cver, cheader, ii, npiglo, npjglo, npk, nt, ndim, &
       x1,y1,dx,dy,spval,   &
       (dep(jk),jk=1,npk), &
       (timetab(jt), jt=1,nt)
       timetag=timetab ! convert to dble precision
       DEALLOCATE(timetab)

  ! Build  cdf files output
  nvar = 1 ! 1 var but many files ... (OK  ... 3 actually )
  ALLOCATE ( typvarsst(nvar), ipksst(nvar), id_varoutsst(nvar) )
  jvar=1
  ipksst(jvar)      = 1
  typvarsst(jvar)%cname='sst'    ! sst dim 1 of dimgfile
  typvarsst(jvar)%cunits='C'
  typvarsst(jvar)%rmissing_value=0.
  typvarsst(jvar)%valid_min= -10.
  typvarsst(jvar)%valid_max= 50.
  typvarsst(jvar)%clong_name='Reynolds SST'
  typvarsst(jvar)%cshort_name='SST'
  typvarsst(jvar)%conline_operation='N/A'
  typvarsst(jvar)%caxis='TYX'

  ncoutsst =create(csst, 'none',npiglo,npjglo,npk,cdep='deptht' )
  istatus= createvar(ncoutsst ,typvarsst,nvar, ipksst,id_varoutsst )
  istatus= putheadervar(ncoutsst, 'none', npiglo, npjglo,npk, pnavlon=glam,pnavlat=gphi,pdep=dep )

  ! We want to interpolate the data for every day. (weekly in the file)
  ! if first day of the file is not 01/01, needs to read previous year
  !  Clipper SST files are not y2k compliant ...
  IF (timetag (1) < 10000 ) THEN 
     timetag(:)=timetag(:)+20000000.
  ELSE
     timetag(:)=timetag(:)+19000000.
  ENDIF
  january1=iyear*10000+01*100+01
  december31=iyear*10000+12*100+31
  jul1=julday(january1)
  jul2=julday(december31)

  itt=0
  IF (jul1 < julday(INT(timetag(1)))  ) THEN
     ! need to read previous year 
     WRITE(csstrp ,'(a,I4.4,a,I2.2,a)') 'REYNOLDS.Y',iyear-1,'.SST.'//TRIM(config)//'.dimg'
     irecl=isdirect(csstrp)  ; OPEN( numsstp,FILE=csstrp, FORM='UNFORMATTED', ACCESS='DIRECT', RECL=irecl )
     READ(numsstp,REC=1) cver, cheader, ii, npiglo, npjglo, npk, ntp
     ALLOCATE (timetagp (ntp) ,timetab(ntp))
     READ(numsstp,REC=1) cver, cheader, ii, npiglo, npjglo, npk, ntp, ndim, &
          x1,y1,dx,dy,spval,   &
          (dep(jk),jk=1,npk), &
          (timetab(jt), jt=1,ntp)
         timetagp=timetab 
         DEALLOCATE(timetab)
     IF (timetagp (1) < 10000 ) THEN 
        timetagp(:)=timetagp(:)+20000000.
     ELSE
        timetagp(:)=timetagp(:)+19000000.
     ENDIF
     IF ( julday(INT(timetagp (ntp)))  <= jul1 ) THEN
        !read ntp sst as 1 data
        itt = itt +1
        READ(numsstp,REC=ntp+1) (( v2d(ji,jj,itt),ji=1,npiglo),jj=1,npjglo)
        itime(itt)=julday( INT(timetagp(ntp)) )
     ELSE IF  ( julday(INT(timetagp (ntp-1))  ) <= jul1 ) THEN
        itt = itt +1
        READ(numsstp,REC=ntp) (( v2d(ji,jj,itt),ji=1,npiglo),jj=1,npjglo)
        itime(itt)=julday(INT(timetagp(ntp-1)) )
     ELSE IF  ( julday(INT(timetagp (ntp-2) )) <= jul1 ) THEN
        itt = itt +1
        READ(numsstp,REC=ntp-1) (( v2d(ji,jj,itt),ji=1,npiglo),jj=1,npjglo)
        itime(itt)=julday(INT(timetagp(ntp-2)) )
     ELSE
        PRINT *,' Something is wrong in previous file SST ' ; STOP
     ENDIF
  ENDIF
  DO jt=1,nt
     itt = itt +1
     READ(numsst,REC=jt+1) (( v2d(ji,jj,itt),ji=1,npiglo),jj=1,npjglo)
     itime(itt)=julday(INT(timetag(jt)) )
  END DO

  IF ( jul2 > julday(INT(timetag(nt))) ) THEN
     ! need to read next year
     IF ( iyear == 2000 ) THEN   ! persistance ...
        itt=itt+1 ;  v2d(:,:,itt)= v2d(:,:,itt-1)  ; itime(itt)=jul2
     ELSE
        WRITE(csstrn ,'(a,I4.4,a,I2.2,a)') 'REYNOLDS.Y',iyear+1,'.SST.'//TRIM(config)//'.dimg'
        irecl=isdirect(csstrn)  ; OPEN( numsstn,FILE=csstrn, FORM='UNFORMATTED', ACCESS='DIRECT', RECL=irecl )
        READ(numsstn,REC=1) cver, cheader, ii, npiglo, npjglo, npk, ntn
        ALLOCATE (timetagn (ntn) ,timetab(ntn))
        READ(numsstn,REC=1) cver, cheader, ii, npiglo, npjglo, npk, ntn, ndim, &
             x1,y1,dx,dy,spval,   &
             (dep(jk),jk=1,npk), &
             (timetab(jt), jt=1,ntn)
        timetagn=timetab
        DEALLOCATE( timetab)
        IF (timetagn (1) < 10000 ) THEN 
           timetagn(:)=INT(timetagn(:))+20000000
        ELSE
           timetagn(:)=INT(timetagn(:))+19000000
        ENDIF

        IF ( julday(INT(timetagn (1) )) >= jul2 ) THEN
           !read 1 sst as 1 data
           itt = itt +1
           READ(numsstn,REC=2) (( v2d(ji,jj,itt),ji=1,npiglo),jj=1,npjglo)
           itime(itt)=julday(INT(timetagn(1)) )
        ELSE IF  ( julday(INT(timetagn (2)) ) >= jul2 ) THEN
           itt = itt +1
           READ(numsstn,REC=3) (( v2d(ji,jj,itt),ji=1,npiglo),jj=1,npjglo)
           itime(itt)=julday(INT( timetagn(2)) )
        ELSE IF  ( julday(INT(timetagn (3))) >= jul2 ) THEN
           itt = itt +1
           READ(numsstn,REC=4) (( v2d(ji,jj,itt),ji=1,npiglo),jj=1,npjglo)
           itime(itt)=julday(INT(timetagn(3)) )
        ELSE
           PRINT *,' Something is wrong in next file SST ' ; STOP
        ENDIF
     ENDIF
  ENDIF
     ntime=itt

     icurrday=0
     ii1=1 ; ii2 = 2 ; id1=itime(ii1) ; id2=itime(ii2) 
     DO jul = jul1, jul2
        icurrday=icurrday + 1
        IF ( jul > id2 ) THEN
           ii1=ii1+1 ; ii2=ii2+1 ;  id1=itime(ii1) ; id2=itime(ii2)
        ENDIF
        v2daily(:,:)=FLOAT((jul - id1 ))/(FLOAT(id2-id1))*(v2d(:,:,ii2) - v2d(:,:,ii1) ) +  v2d(:,:,ii1)
        istatus = putvar(ncoutsst,id_varoutsst(1),v2daily(:,:),icurrday,npiglo,npjglo)
     END DO

     ! update time_counter
     ALLOCATE( timetab (icurrday) )
     timetab=(/(jt,jt=1,icurrday)/)
     istatus=putvar1d(ncoutsst,timetab,icurrday,'T')
     ! close fluxes files
     istatus=closeout(ncoutsst)
     istatus=closeout(ncoutsst)
     DEALLOCATE (v2d , dep, z2d )

   CONTAINS
     INTEGER FUNCTION isdirect(clname)
!!!                     FUNCTION ISDIRECT
!!!                     *****************
!!!
!!!    PURPOSE : This integer function returns the record length if clname
!!!              is a valid dimg file, it returns 0 either.
!!!
!!!    METHOD : Open the file and look for the key characters (@!01) for
!!!             identification.
!!!
!!!    AUTHOR : Jean-Marc Molines (Apr. 1998)
!!! -------------------------------------------------------------------------
       IMPLICIT NONE
       CHARACTER(LEN=*), INTENT(in) ::  clname
       CHARACTER(LEN=4)  ::  cver
       CHARACTER(LEN=256) ::  clheader
       !
       INTEGER :: irecl

       !
       OPEN(100,FILE=clname, FORM   ='UNFORMATTED', ACCESS ='DIRECT', RECL   =88)
       READ(100,REC=1) cver ,clheader,irecl
       CLOSE(100)
       !
       IF (cver ==  '@!01' ) THEN
          isdirect=irecl
       ELSE
          isdirect=0
       END IF
       !
     END FUNCTION isdirect

     FUNCTION julday(kdastp)
       !! ------------------------------------------------------------------
       !!          ***        FUNCTION JULDAY    ***
       !!
       !!   Purpose:   This routine returns the julian day number which begins at noon
       !!         of the calendar date specified by month kmm, day kid, and year kiyyy.
       !!         positive year signifies a.d.; negative, b.c.  (remember that the
       !!         year after 1 b.c. was 1 a.d.)
       !!         routine handles changeover to gregorian calendar on oct. 15, 1582.
       !!
       !!   Method:  This routine comes directly from the Numerical Recipe Book,
       !!           press et al., numerical recipes, cambridge univ. press, 1986.
       !!
       !!   Arguments:
       !!     kdastp  : OPA date yyyymmdd (instead of kmm kid kiyyy)
       !!     kmm     : input, corresponding month
       !!     kid     : input, corresponding day
       !!     kiyyy   : input, corresponding year, positive IF a.d, negative b.c.
       !!      
       !!     
       !!   history
       !!     1998: J.M. Molines for the Doctor form. 
       !!     2007 : J.M. Molines in F90
       !! -----------------------------------------------------------------
       !  *  Declarations
       !
       INTEGER :: julday, kiyyy,kid,kmm
       INTEGER, INTENT(in)  ::kdastp
       !  * Local 
       INTEGER, PARAMETER ::jpgreg=15+31*(10+12*1582)
       INTEGER  :: iy, im, ia
       ! ... Year 0 never existed ...
       kiyyy=kdastp/10000
       kmm=(kdastp - kiyyy*10000)/100
       kid= kdastp - kiyyy*10000 - kmm*100
       IF (kiyyy == 0) STOP 101
       !
       IF (kiyyy < 0) kiyyy = kiyyy + 1
       IF (kmm > 2) THEN
          iy = kiyyy
          im = kmm + 1
       ELSE
          iy = kiyyy - 1
          im = kmm + 13
       END IF
       !
       julday = INT(365.25*iy) + INT(30.6001*im) + kid + 1720995 
       IF (kid+31*(kmm+12*kiyyy).GE.jpgreg) THEN
          ia = INT(0.01*iy)
          julday = julday + 2 - ia + INT(0.25*ia) 
       END IF
     END FUNCTION JULDAY
   END PROGRAM cdfflxconv

PROGRAM cdf_compress
  !!======================================================================
  !!                     ***  PROGRAM  cdf_compress  ***
  !!=====================================================================
  !!  ** Purpose : a low memory consuming tool to be used in place of
  !!               ncks for building netcdf4/Hdf5 deflated files
  !!
  !!  ** Method  :  Read and write deflated
  !!
  !! History :  4.0  : 01/2020  : J.M. Molines :  (Energetics)
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  !!   routines      : description
  !!----------------------------------------------------------------------

  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017
  !! $Id$
  !! Copyright (c) 2012, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class file_operations
  !!----------------------------------------------------------------------
  USE netcdf
  IMPLICIT NONE

  INTEGER(KIND=4)    :: jd, jv, j3,j4
  INTEGER(KIND=4)    :: n1 , n2, n3, n4
  INTEGER(KIND=4)    :: ncin, ncou
  INTEGER(KIND=4)    :: narg, iargc, ijarg
  INTEGER(KIND=4)    :: idef_lev, nvertdim, ilen, ndim, ierr
  INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE :: icnk_dmn

  REAL(KIND=4) , DIMENSION(:,:,:), ALLOCATABLE :: r3d

  REAL(KIND=8) , DIMENSION(:), ALLOCATABLE    ::  d1d
  REAL(KIND=8) , DIMENSION(:,:), ALLOCATABLE  ::  d2d

  CHARACTER(LEN=255) :: cf_in, cf_ou, cdum
  CHARACTER(LEN=80), DIMENSION(:), ALLOCATABLE :: c_vertdim
  
  LOGICAL :: l_3d=.FALSE.

  TYPE :: ncfile
     INTEGER(KIND=4)                              :: ncid   ! file id
     INTEGER(KIND=4)                              :: ndims  ! number of variables
     INTEGER(KIND=4)                              :: nvars   ! number of vars
     INTEGER(KIND=4)                              :: natts   ! number of global attributes
     INTEGER(KIND=4)                              :: iunlim  ! ID of unlimited dimension
     INTEGER(KIND=4), DIMENSION(:),   ALLOCATABLE :: ideflat ! deflate level (nvar)
     INTEGER(KIND=4), DIMENSION(:),   ALLOCATABLE :: nvatt   ! number of att of each variable (var)
     INTEGER(KIND=4), DIMENSION(:),   ALLOCATABLE :: nvid    ! varid of each variable (var)
     INTEGER(KIND=4), DIMENSION(:),   ALLOCATABLE :: nvdim   ! dimension of each variable (var)
     INTEGER(KIND=4), DIMENSION(:),   ALLOCATABLE :: itype   ! type of each variable (var)
     INTEGER(KIND=4), DIMENSION(:),   ALLOCATABLE :: nlen    ! len of each dimension ( ndims)
     INTEGER(KIND=4), DIMENSION(:),   ALLOCATABLE :: idimid  ! dimid of each dimension ( ndims)
     INTEGER(KIND=4), DIMENSION(:,:), ALLOCATABLE :: ichunk  ! size of chunk (nvar, ndims)
     INTEGER(KIND=4), DIMENSION(:,:), ALLOCATABLE :: idimids ! dimids of each variable (nvar, ndims) 
     CHARACTER(LEN=255)                            :: c_fnam ! name of working file
     CHARACTER(LEN=80 ), DIMENSION(:), ALLOCATABLE :: c_vnam ! name of each variable (var)
     CHARACTER(LEN=80 ), DIMENSION(:), ALLOCATABLE :: c_dnam ! name of each dimension (ndims)

  END TYPE ncfile

  TYPE(ncfile) :: scdf_in, scdf_ou
  !!----------------------------------------------------------------------
  ! default values
  idef_lev = 1
  nvertdim = 0
  cf_ou='none'

  narg=iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage :  cdf_compress -f FILE-in [-v LIST-vertical_Dimensions ] [-d DEF-lev ]'
     PRINT *,'                     [-o FILE-out] [-3D]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compress input file using netcdf4/HDF5 with deflation level <DEF_lev>.'
     PRINT *,'       Need to specify vertical dimension names if any. Note that this tool'
     PRINT *,'       is designed to work with any netcdf file, not only NEMO. It is a low'
     PRINT *,'       memory alternative of ncks for huge big files. Sizes of chunks are '
     PRINT *,'       predermined, but always 1 for vertical and time axis.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -f FILE-in : name of netcdfile to be compressed.' 
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       -v LIST-vertical_dimensions : comma separated list of the names of'
     PRINT *,'             the vertical dimensions (in order to set chunk size of 1). '
     PRINT *,'       -d DEF-lev  : Specify deflation level ( default is 1).'
     PRINT *,'       -o FILE-out : Specify output file instead of default <FILE-in>4 '
     PRINT *,'       -3D : use 3D arrays for eventual increased performances (not sure)'
     PRINT *,'            Use more in core memory.' 
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       none' 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : <FILE_in>4 or file specified with -o option.'
     PRINT *,'         variables : same as input ( with same attributes).'
     PRINT *,'      '
     STOP
  ENDIF

  ijarg=1
  DO WHILE ( ijarg <= narg )
     CALL getarg(ijarg,cdum) ; ijarg=ijarg+1
     SELECT CASE ( cdum)
     CASE ( '-f' ) ; CALL getarg(ijarg,cf_in) ; ijarg=ijarg+1
        ! options
     CASE ( '-d'  ) ; CALL getarg(ijarg,cdum ) ; ijarg=ijarg+1 ; READ(cdum,*) idef_lev
     CASE ( '-v'  ) ; CALL getarg(ijarg,cdum ) ; ijarg=ijarg+1 ; CALL getlist(cdum)
     CASE ( '-o'  ) ; CALL getarg(ijarg,cf_ou) ; ijarg=ijarg+1
     CASE ( '-3D' ) ; l_3d = .TRUE.
     CASE DEFAULT  ; PRINT *,'  E R R O R : Unknown option :', TRIM(cdum) ; STOP 99
     END SELECT
  END DO

  IF ( cf_ou == 'none') THEN
     cf_ou=TRIM(cf_in)//'4'
  ENDIF

  scdf_in%c_fnam = cf_in

  ! retrieve file structure 
  CALL getncfile(scdf_in)

  ! copy input structure on output structure
  scdf_ou = scdf_in
  ! weird but nice ... this copy of the structure also allocate the target ???
  ! print *, size( scdf_ou%nvdim )
  ! print *, scdf_in%nvdim(:)
  ! print *, scdf_ou%nvdim(:)

  ! Change the output structure
  ! 1) file name
  scdf_ou%c_fnam = cf_ou
  ! 2) set deflation level  for each variables ( at this stage, all var with same def level ...
  scdf_ou%ideflat(:) = idef_lev
  ! 3) set the chunk size for each dimension according to some criteria
  ALLOCATE( icnk_dmn( scdf_ou%ndims ) )
  icnk_dmn(:) = 0
  DO jd = 1, scdf_ou%ndims
     DO jv = 1, nvertdim
        IF ( scdf_ou%c_dnam(jd) == c_vertdim(jv) ) THEN
           icnk_dmn(jd) = 1
        ENDIF
     ENDDO
     IF ( jd == scdf_ou%iunlim ) THEN
        icnk_dmn(jd) = 1
     ENDIF
     IF ( INDEX( scdf_ou%c_dnam(jd),'x') /= 0 ) THEN
        ilen=scdf_ou%nlen(jd)
        icnk_dmn(jd)=ilen !! 
     ENDIF
     IF ( icnk_dmn(jd) == 0 ) THEN  ! not treated above
        ilen=scdf_ou%nlen(jd)
        icnk_dmn(jd)=MIN(ilen, 200) !!  500 hard coded !! 
     ENDIF
  ENDDO

  ! Create the skeleton of the output file
  CALL makncfile(scdf_ou) 

  !  Read in/ write out ... Loop on variables.
  ncin = scdf_in%ncid
  ncou = scdf_ou%ncid

  DO jv = 1, scdf_in%nvars
     PRINT * , 'compress and copy ', TRIM(scdf_in%c_vnam(jv) )

     ndim=scdf_in%nvdim(jv)
     SELECT CASE ( ndim )
     CASE ( 1 )    ! can be t or z
        ALLOCATE ( d1d (scdf_in%nlen(scdf_in%idimids(jv,1)) ) )
        ierr = NF90_GET_VAR(ncin,jv,d1d )
        ierr = NF90_PUT_VAR(ncou,jv,d1d )
        ierr = NF90_SYNC(ncou)
        DEALLOCATE ( d1d)
     CASE ( 2 )   ! can be t bound or x,y
        n1 = scdf_in%nlen(scdf_in%idimids(jv,1))
        n2 = scdf_in%nlen(scdf_in%idimids(jv,2))
        ALLOCATE ( d2d (n1,n2)  )
        ierr = NF90_GET_VAR(ncin,jv,d2d)
        ierr = NF90_PUT_VAR(ncou,jv,d2d )
        ierr = NF90_SYNC(ncou)
        DEALLOCATE ( d2d)
     CASE ( 3 )   !  can be : x,y,t   x,y,z    loop on 3rd dim
        n1 = scdf_in%nlen(scdf_in%idimids(jv,1))
        n2 = scdf_in%nlen(scdf_in%idimids(jv,2))
        n3 = scdf_in%nlen(scdf_in%idimids(jv,3))
        ALLOCATE ( d2d (n1,n2) )
        DO j3 = 1, n3
           ierr = NF90_GET_VAR(ncin,jv,d2d, start=(/1,1,j3/),count=(/n1,n2,1/) )
           ierr = NF90_PUT_VAR(ncou,jv,d2d, start=(/1,1,j3/),count=(/n1,n2,1/) )
        ENDDO
        ierr = NF90_SYNC(ncou)
        DEALLOCATE ( d2d)
     CASE ( 4 )  !  can be   x,y,z,t or ???  loop on 3 rd and 4th dims
        n1 = scdf_in%nlen(scdf_in%idimids(jv,1))
        n2 = scdf_in%nlen(scdf_in%idimids(jv,2))
        n3 = scdf_in%nlen(scdf_in%idimids(jv,3))
        n4 = scdf_in%nlen(scdf_in%idimids(jv,4))
        IF ( l_3d ) THEN
          ALLOCATE ( r3d (n1,n2,n3) )
          DO j4 =   1, n4
             ierr = NF90_GET_VAR(ncin,jv,r3d, start=(/1,1,1,j4/),count=(/n1,n2,n3,1/) )
             ierr = NF90_PUT_VAR(ncou,jv,r3d, start=(/1,1,1,j4/),count=(/n1,n2,n3,1/) )
          ENDDO
          DEALLOCATE ( r3d)
        ELSE
          ALLOCATE ( d2d (n1,n2) )
          DO j4 =   1, n4
             DO j3 = 1, n3
                ierr = NF90_GET_VAR(ncin,jv,d2d, start=(/1,1,j3,j4/),count=(/n1,n2,1,1/) )
                ierr = NF90_PUT_VAR(ncou,jv,d2d, start=(/1,1,j3,j4/),count=(/n1,n2,1,1/) )
             ENDDO
          ENDDO
          DEALLOCATE ( d2d)
        ENDIF
        ierr = NF90_SYNC(ncou)

     CASE DEFAULT
        PRINT *, 'WARNING : found variable with ', ndim,' dimension : not yet supported : skip it !'
     END SELECT
  ENDDO

  ierr = NF90_CLOSE(ncin)
  ierr = NF90_CLOSE(ncou)

CONTAINS 
  SUBROUTINE getncfile (sd_ncfile)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE getncfile  ***
    !!
    !! ** Purpose :  Fill a ncfile structure with information taken from
    !!               the input file.
    !!
    !! ** Method  :  Use NF90 primitive functions
    !!
    !! References :  netcdf documentation
    !!----------------------------------------------------------------------
    TYPE(ncfile), INTENT(inout) :: sd_ncfile
    ! local vars
    INTEGER(KIND=4) :: jd, jv   ! loop index
    INTEGER(KIND=4) :: ierr, ncid, nvars, ndims  ! short names for some structure elements
    !!----------------------------------------------------------------------

    ierr = NF90_OPEN(sd_ncfile%c_fnam,NF90_NOWRITE,sd_ncfile%ncid)
    ncid =  sd_ncfile%ncid
    ! now fill in ncfile structure ...
    ierr = NF90_INQUIRE(ncid, nDimensions  = sd_ncfile%ndims  &
         &                , nVariables     = sd_ncfile%nvars  &
         &                , nAttributes    = sd_ncfile%natts  &
         &                , unlimitedDimid = sd_ncfile%iunlim  )
    ! look for dimensions 
    ndims = sd_ncfile%ndims
    ALLOCATE ( sd_ncfile%nlen ( ndims) , sd_ncfile%c_dnam ( ndims), sd_ncfile%idimid ( ndims) )
    DO jd = 1 , ndims
       ierr = NF90_INQUIRE_DIMENSION(ncid,jd, name=sd_ncfile%c_dnam(jd) , len=sd_ncfile%nlen (jd) ) 
       PRINT *, " Dimension ",TRIM(sd_ncfile%c_dnam(jd) )," : ", sd_ncfile%nlen (jd)
    ENDDO
    PRINT *, "   Unlimited dimension is ", TRIM(sd_ncfile%c_dnam(sd_ncfile%iunlim))
    ! look for variables
    nvars=sd_ncfile%nvars
    ALLOCATE ( sd_ncfile%ideflat(nvars),  sd_ncfile%nvatt(nvars),  sd_ncfile%nvid(nvars) )
    ALLOCATE ( sd_ncfile%nvdim(nvars),  sd_ncfile%itype(nvars),  sd_ncfile%c_vnam(nvars) )
    ALLOCATE ( sd_ncfile%ichunk(nvars,ndims),  sd_ncfile%idimids(nvars,ndims)            )
    DO  jv = 1, nvars
       sd_ncfile%nvid(jv) = jv
       ierr = NF90_INQUIRE_VARIABLE(ncid, jv, name        = sd_ncfile%c_vnam(jv)    &
            &                             , xtype         = sd_ncfile%itype(jv)     &
            &                             , ndims         = sd_ncfile%nvdim(jv)     &
            &                             , nAtts         = sd_ncfile%nvatt(jv)     &
            &                             , deflate_level = sd_ncfile%ideflat(jv)   &
            &                             , dimids        = sd_ncfile%idimids(jv,:) &
            &                             , chunksizes    = sd_ncfile%ichunk(jv,:)   )
    ENDDO

    ! leave input file open !!! 

  END SUBROUTINE getncfile

  SUBROUTINE makncfile (sd_ncfile )
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE <routine>  ***
    !!
    !! ** Purpose :    Create a new file from the information stored in the
    !!               ncfile structure passed as argument.
    !!
    !! ** Method  :   use NF90 primitives
    !!
    !! References :  netcdf documentation
    !!----------------------------------------------------------------------
    TYPE(ncfile), INTENT(inout) :: sd_ncfile
    !
    INTEGER(KIND=4) :: ja   ! loop index
    INTEGER(KIND=4) :: ierr, ncid, ilen
    INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE :: ichunksz
    CHARACTER(LEN=80) :: cl_anam
    !!----------------------------------------------------------------------
    ! Create output data set
    ierr = NF90_CREATE(sd_ncfile%c_fnam,NF90_NETCDF4,sd_ncfile%ncid)
    ncid = sd_ncfile%ncid

    ! Create dimensions
    DO jd = 1, sd_ncfile%ndims
       IF ( jd == sd_ncfile%iunlim ) THEN
          ilen = NF90_UNLIMITED
       ELSE        
          ilen =sd_ncfile%nlen(jd)
       ENDIF
       ierr = NF90_DEF_DIM(ncid,sd_ncfile%c_dnam(jd),ilen,sd_ncfile%idimid(jd))
    ENDDO

    ! Create variables
    DO jv = 1, sd_ncfile%nvars
       ALLOCATE ( ichunksz(sd_ncfile%nvdim(jv)) )
       DO jd = 1, sd_ncfile%nvdim(jv)
          ichunksz(jd)=icnk_dmn(sd_ncfile%idimids(jv,jd) )
       ENDDO
       ierr=NF90_DEF_VAR(ncid,    sd_ncfile%c_vnam(jv)                         &
            &                   , sd_ncfile%itype(jv)                          &
            &                   , sd_ncfile%idimids(jv,1:sd_ncfile%nvdim(jv))  &
            &                   , sd_ncfile%nvid(jv)                           &
            &                   , chunksizes    = ichunksz(:)                  &
            &                   , deflate_level = sd_ncfile%ideflat(jv)  )
       DEALLOCATE ( ichunksz )
    ENDDO

    ! Create attribute : copy from scdf_in  ( global variable )
    ncin=scdf_in%ncid
    ncou=ncid
    ! Global attributes
    DO ja = 1, scdf_in%natts
       ierr = NF90_INQ_ATTNAME(ncin,NF90_GLOBAL,ja,cl_anam)
       ierr = NF90_COPY_ATT(ncin,NF90_GLOBAL,cl_anam,ncou,NF90_GLOBAL)
    ENDDO
    ! variable attributes
    DO jv = 1, sd_ncfile%nvars
       DO ja=1,  sd_ncfile%nvatt(jv)
          ierr = NF90_INQ_ATTNAME(ncin,jv,ja,cl_anam)
          ierr = NF90_COPY_ATT(ncin,jv,cl_anam,ncou,jv)
       ENDDO
    ENDDO

    ierr = NF90_ENDDEF(ncid)
  END SUBROUTINE makncfile


  SUBROUTINE getlist (cd_list)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE getlist  ***
    !!
    !! ** Purpose :  decode  a comma separated list and put each element
    !!               in the global character array variable  c_vertdim
    !!
    !! ** Method  :  Count the number of ',' in the input list and infer
    !!               the number of elements .. etc 
    !!
    !!----------------------------------------------------------------------

    CHARACTER(LEN=*) , INTENT(in) :: cd_list
    !
    CHARACTER(LEN=80)  ::cl_list
    INTEGER(KIND=4) :: ilen, ipos, ii
    INTEGER(KIND=4) :: jc
    !!----------------------------------------------------------------------
    cl_list=TRIM(cd_list)

    ! count number of ','
    nvertdim=0  ! number of vertical dimensions
    ilen=LEN(TRIM(cd_list))
    DO jc=1,ilen
       IF ( cd_list(jc:jc) == ',' ) THEN
          nvertdim=nvertdim+1
       ENDIF
    ENDDO
    nvertdim=nvertdim + 1  ! number of vertical variables
    PRINT *, ' Vert dim = ', nvertdim
    ALLOCATE (c_vertdim(nvertdim) )
    ipos=0 ; ii=0
    IF ( nvertdim == 1 ) THEN
       c_vertdim(1) = cl_list
    ELSE
       DO jc=1, nvertdim
          ipos = INDEX(cl_list,',' )
          IF ( ipos /= 0 ) THEN
             ii = ii + 1
             c_vertdim(ii) = cl_list(1:ipos-1)
             cl_list=TRIM(cl_list(ipos+1:))
          ELSE
             c_vertdim(nvertdim)= cl_list
          ENDIF
       ENDDO
    ENDIF

    DO jc = 1, nvertdim
       PRINT *, TRIM( c_vertdim(jc) )
    ENDDO

  END SUBROUTINE getlist

END PROGRAM cdf_compress

PROGRAM cdficetrp
  !!======================================================================
  !!                     ***  PROGRAM  cdficetrp  ***
  !!=====================================================================
  !!  ** Purpose : compute ice transport across a section (either zonal
  !!               or meridional.
  !!
  !!  ** Method  : read horizontal metrics, ice velocities, ice thickness
  !!               and ice fraction. Then compute the following transport :
  !!               icertrp = sum( ice_frac * ice_thickness * e1/2 * ice_vel )
  !!
  !! History :  4.0  : 02/2018  : J.M. Molines : Original code
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  !!   routines      : description
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2018
  !! $Id$
  !! Copyright (c) 2018, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE
  INTEGER(KIND=4)                               :: narg, iargc, ijarg
  INTEGER(KIND=4)                               :: nsection             ! number of sections (overall)

  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: iimina, iimaxa       ! sections limits
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: ijmina, ijmaxa       ! sections limits



  CHARACTER(LEN=255) :: cf_ifil  ! input ice model
  CHARACTER(LEN=255) :: cf_sfil='ice_section.dat'  ! input section file (txt)
  CHARACTER(LEN=255) :: cldum    ! dummy character variable
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: csection             ! section name
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cvarname             ! output variable name (root)
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: clongname            ! output long name (root)


  LOGICAL :: lchk = .FALSE.
  LOGICAL :: lim3 = .FALSE.

  !!----------------------------------------------------------------------
  CALL ReadCdfNames()
  narg = iargc()

  IF ( narg == 0 ) THEN
     PRINT *,' usage :  cdficetrp -i ICE-file [-s SECTION-file]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute ice transport through sections described into a section file,'
     PRINT *,'       whose default name is ',TRIM(cf_sfil),'. This file has the '
     PRINT *,'       folowing format:  It is a text file with pairs of lines foreach '
     PRINT *,'       section giving : (1) section name and (2) section location.'
     PRINT *,'     '
     PRINT *,'       First line with section name may also have 2 additional strings holding'
     PRINT *,'       a prefix for variable output, and a long name to be used as attribute in'
     PRINT *,'       the output file. '
     PRINT *,'       Second line gives the location of the section with specification of four'
     PRINT *,'       integer values (imin imax jmin jmax), relative to the model grid.'
     PRINT *,'       Only  zonal or meridional sections are allowed.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'        -i ICE-file : specify ICE-file containing ice velocity, and'
     PRINT *,'            ice concentration.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'        [-s SECTION-file] : give the name of the section file, instead'
     PRINT *,'            of default ',TRIM(cf_sfil)
     PRINT *,'        '
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        mesh_hgr.nc and mask.nc'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       Netcdf file : There is 1 netcdf file per section. File name is build'
     PRINT *,'         from section name : <SECTION>_icetrp.nc'
     PRINT *,'         variables :  icetrp '

!    PRINT *,'       netcdf file : ', TRIM(cf_out) 
!    PRINT *,'         variables : ', TRIM(cv_out),' (Sv)'
     PRINT *,'      '
     PRINT *,'     SEE ALSO : '
     PRINT *,'       cdftransport, cdficediags'
     PRINT *,'      '
     STOP
  ENDIF

  ! Parse  command line
  ijarg = 1 
  DO WHILE ( ijarg <= narg )
     CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-i'   ) ; CALL getarg(ijarg, cf_ifil ) ; ijarg=ijarg+1
! Option
     CASE ( '-s'   ) ; CALL getarg(ijarg, cf_sfil ) ; ijarg=ijarg+1
     CASE DEFAULT    ; PRINT *, ' ERROR : ', TRIM(cldum),' : unknown option.'; STOP 1
     END SELECT
  ENDDO

! Check existence of files :
  lchk = chkfile (cn_fhgr) .OR. lchk
  lchk = chkfile (cn_fmsk) .OR. lchk
  lchk = chkfile (cf_ifil) .OR. lchk
  lchk = chkfile (cf_sfil) .OR. lchk
  IF ( lchk ) STOP 99 ! missing file

  ! check if cf_ifile corresponds to lim3 or lim2
  IF ( chkvar ( cf_ifil, cn_ileadfra ,.FALSE. ) ) THEN
     lim3 = .FALSE.
  ELSE
     lim3 = .TRUE.
     cn_ileadfra = cn_ileadfra3
     cn_iicethic = cn_iicethic3
     cn_iicevelu = cn_iicevelu3
     cn_iicevelv = cn_iicevelv3
  ENDIF

! Initialise section
  nsection=0
  CALL section_init(cf_sfil, csection,cvarname,clongname,iimina, iimaxa, ijmina, ijmaxa, nsection)

CONTAINS
  SUBROUTINE section_init(cdfile, cdsection, cdvarname, cdlongname, kimin, kimax, kjmin, kjmax, knumber)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE section_init  ***
    !!
    !! ** Purpose : Read input ASCII file that defines section names and limit of
    !!              sections.
    !!
    !! ** Method  : At fisrt call only return the number of sections for further
    !!              allocation.  
    !!
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*),                       INTENT(in   ) :: cdfile
    CHARACTER(LEN=256), DIMENSION(knumber), INTENT(out  ) :: cdsection
    CHARACTER(LEN=256), DIMENSION(knumber), INTENT(out  ) :: cdvarname
    CHARACTER(LEN=256), DIMENSION(knumber), INTENT(out  ) :: cdlongname
    INTEGER(KIND=4),                        INTENT(inout) :: knumber
    INTEGER(KIND=4), DIMENSION(knumber),    INTENT(out  ) :: kimin, kimax, kjmin, kjmax

    ! Local variables
    INTEGER(KIND=4)                                       :: jsec
    INTEGER(KIND=4)                                       :: ii, inum=10
    INTEGER(KIND=4)                                       :: ipos
    CHARACTER(LEN=256)                                    :: cline
    CHARACTER(LEN=80), DIMENSION(3)                       :: cldum
    LOGICAL                                               :: llfirst
    !!----------------------------------------------------------------------
    llfirst=.FALSE.
    IF ( knumber == 0 ) llfirst=.TRUE.

    OPEN(inum, FILE=cdfile)
    REWIND(inum)
    ii = 0

    ! read the file just to count the number of sections
    DO
       READ(inum,'(a)') cline
       IF (INDEX(cline,'EOF') == 0 ) THEN
          READ(inum,*)    ! skip one line
          ii = ii + 1
       ELSE
          EXIT
       ENDIF
    END DO

    knumber=ii
    IF ( llfirst ) RETURN

    REWIND(inum)
    DO jsec=1,knumber
       READ(inum,'(a)') cline
       ii = 0
       cldum(:) = 'none'
       ipos = INDEX(cline,' ')
       DO WHILE ( ipos > 1 )
          ii = ii + 1
          cldum(ii) = cline(1:ipos - 1 )
          cline = TRIM ( cline(ipos+1:) )
          ipos  = INDEX( cline,' ' )
          IF ( ii >= 3 ) EXIT
       END DO
       cdsection(jsec) = TRIM(cldum(1) )
       cdvarname(jsec) = TRIM(cldum(2) )
       cdlongname(jsec) = TRIM(cldum(3) )
       READ(inum,*    ) kimin(jsec), kimax(jsec), kjmin(jsec), kjmax(jsec)
    END DO

    CLOSE(inum)

  END SUBROUTINE section_init



END PROGRAM cdficetrp

PROGRAM cdfclip
  !!======================================================================
  !!                     ***  PROGRAM  cdfclip  ***
  !!=====================================================================
  !!  ** Purpose : An alternative to ncks to clip model file. It is 
  !!               usefull when the clipping area cross the E-W
  !!               periodic folding line. Additionally it does not
  !!               mess up the order of the dimensions and variables, 
  !!               which was a problem for coordinates.nc files with
  !!               IOIPSL
  !!
  !! History : 2.1  : 02/2007  : J.M. Molines : Original code
  !!           3.0  : 12/2010  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  !!
  USE cdfio 
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2010, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                               :: jk, jt, jvar, jv        ! dummy loop index
  INTEGER(KIND=4)                               :: ik1, ik2, ik            !
  INTEGER(KIND=4)                               :: ierr                    ! working integer
  INTEGER(KIND=4)                               :: iimin, iimax            !
  INTEGER(KIND=4)                               :: ijmin, ijmax            !
  INTEGER(KIND=4)                               :: ikmin=-9999, ikmax=-9999  !
  INTEGER(KIND=4)                               :: narg, iargc, ijarg      ! 
  INTEGER(KIND=4)                               :: npiglo, npjglo, npk     !
  INTEGER(KIND=4)                               :: npkk, npt               ! size of the domain
  INTEGER(KIND=4)                               :: nvars                   ! Number of variables in a file
  INTEGER(KIND=4)                               :: ncout                   !
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: id_var                  ! arrays of var id's
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: ipk, ipkk               ! arrays of vertical level for each var
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: id_varout , ndim        !

  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: v2d, rlon, rlat         !
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: v2dxz, v2dyz, zxz, zyz  !
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: rdepg, rdep             !
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: tim                     !

  CHARACTER(LEN=256)                            :: cf_in                   ! input file name
  CHARACTER(LEN=256)                            :: cf_out='cdfclip.nc'     ! output file name
  CHARACTER(LEN=256)                            :: cv_dep, cv_tim          ! depth and time variable names
  CHARACTER(LEN=255)                            :: cglobal                 ! global attribute to write on output file
  CHARACTER(LEN=256)                            :: cldum                   ! dummy character variable
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_names                ! array of var name
  
  TYPE (variable), DIMENSION(:),   ALLOCATABLE  :: stypvar                 !

  LOGICAL                                       :: lzonal=.false.          !
  LOGICAL                                       :: lmeridian=.false.       !
  !!-------------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfclip -f IN-file -zoom imin imax jmin jmax [kmin kmax] '
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Clip the input file according to the indices given in the'
     PRINT *,'       zoom statement. If no vertical zoomed area is indicated, ' 
     PRINT *,'       the whole water column is considered.  This program is able'
     PRINT *,'       to extract data for a region crossing the E-W periodic boundary'
     PRINT *,'       of a global configuration. It does so if imax < imin.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -f IN-file : specify the input file to be clipped' 
     PRINT *,'       -zoom imin imax jmin jmax : specify the domain to be extracted.'
     PRINT *,'           If imin=imax, or jmin = jmax assume a vertical section either '
     PRINT *,'           meridional or zonal.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [kmin kmax ] : specify vertical limits for the zoom, in order to reduce'
     PRINT *,'               the extracted area to some levels. Default is to take the whole' 
     PRINT *,'               water column.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       none' 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : same as input variables.'
     STOP
  ENDIF
  !!
  ijarg=1 
  DO WHILE (ijarg <= narg )
    CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1
    SELECT CASE ( cldum)
    CASE ('-f' )
       CALL getarg(ijarg,cldum) ; ijarg = ijarg + 1 ; cf_in=cldum
    CASE ('-zoom')
       CALL getarg(ijarg,cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) iimin
       CALL getarg(ijarg,cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) iimax
       CALL getarg(ijarg,cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) ijmin
       CALL getarg(ijarg,cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) ijmax
       IF ( narg == 9 ) THEN  ! there are kmin kmax optional arguments
         CALL getarg(ijarg,cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) ikmin
         CALL getarg(ijarg,cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) ikmax
       ENDIF
    CASE DEFAULT
       PRINT *,' Unknown option :', TRIM(cldum) ; STOP
    END SELECT
  ENDDO

  IF ( chkfile (cf_in ) ) STOP ! missing file

  ! set global attribute for output file
  IF ( ikmin > 0 ) THEN
   WRITE(cglobal,'(a,a,a,6i5)') 'cdfclip -f ',TRIM(cf_in),' -zoom ',iimin,iimax,ijmin,ijmax, ikmin, ikmax
  ELSE
   WRITE(cglobal,'(a,a,a,4i5)') 'cdfclip -f ',TRIM(cf_in),' -zoom ',iimin,iimax,ijmin,ijmax
  ENDIF

  IF ( iimin == iimax ) THEN ; lmeridian=.true.; print *,' Meridional section ' ; ENDIF
  IF ( ijmin == ijmax ) THEN ; lzonal=.true.   ; print *,' Zonal section '      ; ENDIF

  IF (iimax < iimin ) THEN ! we assume that this is the case when we cross the periodic line in orca (Indian ocean)
    npiglo= getdim (cf_in,cn_x)
    npiglo=iimax+(npiglo-iimin) -1
  ELSE
    npiglo= iimax-iimin+1
  ENDIF

  npjglo= ijmax-ijmin+1

  ! look for possible name for vertical dim                       :
  npk   = getdim (cf_in,cn_z,cdtrue=cv_dep, kstatus=ierr)     ! depthxxx
  print *,'ist',ierr,TRIM(cn_z)
  IF (ierr /= 0 ) THEN
     npk   = getdim (cf_in,'z',cdtrue=cv_dep,kstatus=ierr)       ! zxxx
     print *,'ist',ierr,'z'
     IF (ierr /= 0 ) THEN
       npk   = getdim (cf_in,'sigma',cdtrue=cv_dep,kstatus=ierr) ! sigmaxxx
      print *,'ist',ierr,'sigma'
      IF (ierr /= 0 ) THEN
         PRINT *,' assume file with no depth'
         IF ( ikmin > 0 ) THEN
           PRINT *,' You cannot specify limits on k level !' ; STOP
         ENDIF
         npk=0  ! means no dim level in file (implicitly 1 level)
      ENDIF
     ENDIF
  ENDIF

  ! replace flag value (-9999) by standard value (no ikmin ikmax specified = whole column)
  IF ( ikmin < 0 ) ikmin = 1
  IF ( ikmax < 0 ) ikmax = npk
  npkk = ikmax - ikmin +1   ! number of extracted levels. If no level in file, it is 0: 0 -1 + 1 !
  IF (npk == 0 ) ikmax = 1

  ! look for possible name for time dimension
  npt     = getdim(cf_in,cn_t, cdtrue=cv_tim, kstatus=ierr)
  IF ( ierr /= 0 ) THEN
     npt     = getdim(cf_in,'time', cdtrue=cv_tim, kstatus=ierr)
     IF ( ierr /= 0 ) THEN
        npt     = getdim(cf_in,'t', cdtrue=cv_tim, kstatus=ierr)
        IF ( ierr /= 0 ) THEN
          PRINT *, 'no time dimension found'
          npt=1
        ENDIF
     ENDIF
  ENDIF

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk ,' npkk  =', npkk
  PRINT *, 'npt    = ', npt

  IF (npkk > npk ) THEN
   PRINT *,' It seems that you want levels that are not represented '
   PRINT *,' in any of the variables that are in the file ',TRIM(cf_in)
   STOP
  ENDIF

  ALLOCATE( v2d(npiglo,npjglo),rlon(npiglo,npjglo), rlat(npiglo,npjglo), rdepg(npk) , rdep(npkk))
  ALLOCATE( zxz(npiglo,1), zyz(1,npjglo) )
  ALLOCATE( tim(npt) )

  nvars = getnvar(cf_in)
  PRINT *,' nvars =', nvars

  ALLOCATE (cv_names(nvars), ndim(nvars) )
  ALLOCATE (stypvar(nvars))
  ALLOCATE (id_var(nvars), ipk(nvars), id_varout(nvars), ipkk(nvars))

  rlon =getvar(cf_in, cn_vlon2d, 1, npiglo, npjglo, kimin=iimin, kjmin=ijmin)  ! nav_lon
  rlat =getvar(cf_in, cn_vlat2d, 1, npiglo, npjglo, kimin=iimin, kjmin=ijmin)  ! nav_lat

  IF ( npk /= 0 ) THEN
    rdepg   = getvar1d(cf_in, cv_dep, npk)
    rdep(:) = rdepg(ikmin:ikmax)  
  ENDIF

  ! get list of variable names and collect attributes in stypvar (optional)
  cv_names(:)=getvarname(cf_in, nvars, stypvar)

  ! save variable dimension in ndim
  !  1 = either time or depth : noclip
  !  2 = nav_lon, nav_lat
  !  3 = X,Y,T  or X,Y,Z   <-- need to fix the ambiguity ...
  !  4 = X,Y,Z,T
  DO jvar=1,nvars
      ndim(jvar) = getvdim(cf_in, cv_names(jvar)) + 1   !  we add 1 because vdim is dim - 1 ...
  END DO

  id_var(:)  = (/(jv, jv=1,nvars)/)

  ! ipk gives the number of level or 0 if not a T[Z]YX  variable
  ipk(:) = getipk (cf_in,nvars,cdep=cv_dep)
  ipk(:) = MIN ( ipk , ikmax )            ! reduce max depth to the required maximum
  ipkk(:)= MAX( 0 , ipk(:) - ikmin + 1 )  ! for output variable. For 2D input var, 
                                           ! ipkk is set to 0 if ikmin > 1 ... OK ? 
  WHERE( ipkk == 0 ) cv_names='none'
  stypvar(:)%cname = cv_names

  ! create output fileset
  ! create output file taking the sizes in cf_in
  ncout = create      (cf_out, cf_in,   npiglo, npjglo, npkk, cdep=cv_dep            )
  ierr  = createvar   (ncout,    stypvar, nvars,  ipkk,   id_varout, cdglobal=cglobal)
  ierr  = putheadervar(ncout,    cf_in,   npiglo, npjglo, npkk, pnavlon=rlon, pnavlat=rlat, pdep=rdep, cdep=cv_dep)


  DO jvar = 1,nvars
      ! skip dimension variables (already done when creating the output file)
      ik1=MAX(1,ikmin) ; ik2=ipk(jvar)
     SELECT CASE (cv_names(jvar) )
     !
     CASE ('none' )
          ! skip
     CASE DEFAULT
        IF ( lzonal ) THEN
           ALLOCATE( v2dxz(npiglo,ipk(jvar)) )
           DO jt=1,npt
             v2dxz=getvarxz(cf_in, cv_names(jvar), ijmin, npiglo, ipk(jvar), kimin=iimin, kkmin=1, ktime=jt)
             DO jk=ik1,ik2
               ik = jk - ik1 + 1 
               zxz(:,1) = v2dxz(:,jk)
               ierr=putvar(ncout, id_varout(jvar), zxz, ik, npiglo, 1, ktime=jt)
             ENDDO
           ENDDO
           DEALLOCATE ( v2dxz )
        ELSEIF (lmeridian) THEN
           ALLOCATE(  v2dyz(npjglo,ipk(jvar)) )
           DO jt=1,npt
             v2dyz=getvaryz(cf_in, cv_names(jvar), iimin, npjglo, ipk(jvar), kjmin=ijmin, kkmin=1, ktime=jt)
             DO jk=ik1, ik2
               ik = jk - ik1 + 1 
               zyz(1,:) = v2dyz(:,jk)
               ierr=putvar(ncout, id_varout(jvar), zyz, ik, 1, npjglo, ktime=jt)
             ENDDO
           ENDDO
           DEALLOCATE ( v2dyz )
        ELSE
           DO jt = 1, npt
             DO jk=ik1,ik2
               ik = jk - ik1 + 1
               v2d  = getvar(cf_in, cv_names(jvar),  jk,      npiglo, npjglo, kimin=iimin, kjmin=ijmin, ktime=jt)
               ierr = putvar(ncout, id_varout(jvar), v2d, ik, npiglo, npjglo,                           ktime=jt)
             ENDDO
           ENDDO
        ENDIF
     END SELECT
  END DO ! loop to next var in file
  tim  = getvar1d(cf_in, cn_vtimec, npt     )
  ierr = putvar1d(ncout, tim,       npt, 'T')

  ierr = closeout(ncout)

END PROGRAM cdfclip

PROGRAM cdfscale
  !!======================================================================
  !!                     ***  PROGRAM  cdfscale  ***
  !!=====================================================================
  !!  ** Purpose : Replace a variable in the file by its value x scale
  !!               given in argument
  !!
  !! History : 3.0  : 12/2011  : J.M. Molines : Original code
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio 
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class file_operations
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                               :: jk, jvar, jt           ! dummy loop index
  INTEGER(KIND=4)                               :: ivar                   ! index of working variable
  INTEGER(KIND=4)                               :: ierr, ireq             ! working integer
  INTEGER(KIND=4)                               :: narg, iargc, ijarg     ! browse line
  INTEGER(KIND=4)                               :: ncid                   ! ncid of input file for rewrite
  INTEGER(KIND=4)                               :: npiglo, npjglo         ! size of the domain
  INTEGER(KIND=4)                               :: npk, npt               ! size of the domain
  INTEGER(KIND=4)                               :: nvars                  ! Number of variables in a file
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: ipk                    ! arrays of vertical level for each var
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: id_var                 ! arrays of var id

  REAL(KIND=4)                                  :: vscale                 ! multiplicative scaling factor
  REAL(KIND=4)                                  :: vdivide                ! division factor
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: tab                    ! Arrays for data

  CHARACTER(LEN=256)                            :: cldum                  ! dummy string for getarg
  CHARACTER(LEN=256)                            :: cf_inout               ! file name
  CHARACTER(LEN=256)                            :: cunits, clname, csname ! attributes
  CHARACTER(LEN=256)                            :: cv_inout               ! variable name
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_names               ! array of var name

  TYPE(variable), DIMENSION(:),     ALLOCATABLE :: stypvar                ! type for attributes
  
  LOGICAL                                       :: ll_scale = .true. 

  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfscale -f INOUT-file -v IN-var -s SCAL-factor [-d DIVISION-factor]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Replace IN-var in INOUT-file by its values x SCAL-factor or divided by'
     PRINT *,'       DIVISION-factor if option -d is used instead of -s. '
     PRINT *,'      '
     PRINT *,'     CAUTION :'
     PRINT *,'      #############################'
     PRINT *,'      # INPUT FILE IS OVERWRITTEN #'
     PRINT *,'      #############################'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -f INOUT-file : netcdf input file (!overwritten!).'
     PRINT *,'       -v IN-var : netcdf variable to be scaled.'
     PRINT *,'       -s SCAL-factor : Scale value to be used (multiplication factor).'
     PRINT *,'       -d DIVISION-factor : Scale value to be used (division factor).'
     PRINT *,'        ONLY one of -s or -d option must be used.'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : input file is rewritten ' 
     PRINT *,'         variables : same name as input.' 
     STOP 
  ENDIF

  ijarg=1 ; ireq=0
  DO WHILE ( ijarg <= narg )
      CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1
      SELECT CASE ( cldum )
      CASE ( '-f'   ) ; CALL getarg(ijarg, cf_inout ) ; ijarg=ijarg+1  ; ireq=ireq+1
      CASE ( '-v'   ) ; CALL getarg(ijarg, cv_inout ) ; ijarg=ijarg+1  ; ireq=ireq+1
      CASE ( '-s'   ) ; CALL getarg(ijarg, cldum    ) ; ijarg=ijarg+1  ; ireq=ireq+1 ;  READ(cldum,*) vscale
      CASE ( '-d'   ) ; CALL getarg(ijarg, cldum    ) ; ijarg=ijarg+1  ; ireq=ireq+1 ;  READ(cldum,*) vdivide ; ll_scale=.false.
      CASE DEFAULT    ; PRINT *,' ERROR :', TRIM(cldum),' : unknown option.' ; STOP 99
      END SELECT
  ENDDO
  ! 3 arguments are mandatory : here ijarg must be 4
  IF ( ireq /= 3 ) THEN ; PRINT *,' ERROR : need at least 3 arguments !' ; STOP 99 ; ENDIF

  IF ( chkfile (cf_inout) )  STOP 99 ! missing file

  npiglo = getdim (cf_inout, cn_x              )
  npjglo = getdim (cf_inout, cn_y              )
  npk    = getdim (cf_inout, cn_z, kstatus=ierr)

  IF (ierr /= 0 ) THEN
     npk   = getdim (cf_inout,'z',kstatus=ierr)
     IF (ierr /= 0 ) THEN
        PRINT *, 'ASSUME NO VERTICAL DIMENSIONS !'
        npk=0
     ENDIF
  ENDIF
  ncid   = ncopen ( cf_inout       )
  npt    = getdim ( cf_inout, cn_t )

  PRINT *, 'npiglo=', npiglo
  PRINT *, 'npjglo=', npjglo
  PRINT *, 'npk   =', npk
  PRINT *, 'npt   =', npt

  ALLOCATE( tab(npiglo,npjglo) )

  nvars = getnvar(cf_inout)

  ALLOCATE (cv_names(nvars), id_var(nvars),ipk(nvars), stypvar(nvars))

  cv_names(:) = getvarname(cf_inout,nvars,stypvar)
  ipk(:)      = getipk(cf_inout,nvars)
  id_var(:)   = getvarid(cf_inout,nvars)

  ! look for cv_inout in the list of variables
  DO jvar = 1, nvars
    IF ( cv_inout == cv_names(jvar) ) ivar = jvar
  ENDDO

  PRINT *,' Working with ',TRIM(cv_inout),' variable number ', ivar
  PRINT *,'    IPK   : ', ipk(ivar)
  IF ( ll_scale ) THEN
    PRINT *,'    scale : ', vscale
  ELSE
    PRINT *,'    divide : ', vdivide
  ENDIF

  ! work only for ivar
  DO jt=1,npt
    PRINT *, '  JT = ', jt
    DO jk = 1, ipk(ivar) 
      tab(:,:) = getvar(cf_inout, cv_names(ivar), jk, npiglo, npjglo, ktime=jt )
      IF ( ll_scale ) THEN
        tab(:,:) = tab(:,:) * vscale
      ELSE
        tab(:,:) = tab(:,:) / vdivide
      ENDIF
      ierr = putvar(ncid, id_var(ivar), tab, jk, npiglo, npjglo, ktime=jt)
    ENDDO
  END DO

  ierr = closeout(ncid)

END PROGRAM cdfscale

PROGRAM cdfmoy
  !!======================================================================
  !!                     ***  PROGRAM  cdfmoy  ***
  !!=====================================================================
  !!  ** Purpose : Compute mean values for all the variables in a bunch
  !!               of cdf files given as argument
  !!               Store the results on a 'similar' cdf file.
  !!
  !!  ** Method  : Also store the mean squared values for the nn_sqdvar
  !!               variables belonging to cn_sqdvar(:), than can be changed 
  !!               in the nam_cdf_names namelist if wished.
  !!               Optionally order 3 moments for some variables can be
  !!               computed.
  !!
  !! History : 2.0  : 11/2004  : J.M. Molines : Original code
  !!         : 2.1  : 06/2007  : P. Mathiot   : Modif for forcing fields
  !!           3.0  : 12/2010  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  !!   routines      : description
  !!   varchk2       : check if variable is candidate for square mean
  !!   varchk3       : check if variable is candidate for cubic mean
  !!   zeromean      : substract mean value from input field
  !!----------------------------------------------------------------------
  USE cdfio 
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2010, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!-----------------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                               :: jk, jfil           ! dummy loop index
  INTEGER(KIND=4)                               :: jvar, jv, jt       ! dummy loop index
  INTEGER(KIND=4)                               :: ierr               ! working integer
  INTEGER(KIND=4)                               :: narg, iargc, ijarg ! browsing command line
  INTEGER(KIND=4)                               :: nfil               ! number of files to average
  INTEGER(KIND=4)                               :: npiglo, npjglo     ! size of the domain
  INTEGER(KIND=4)                               :: npk, npt           ! size of the domain
  INTEGER(KIND=4)                               :: nvars              ! number of variables in a file
  INTEGER(KIND=4)                               :: ntframe            ! cumul of time frame
  INTEGER(KIND=4)                               :: ncout              ! ncid of output files
  INTEGER(KIND=4)                               :: ncout2             ! ncid of output files
  INTEGER(KIND=4)                               :: ncout3             ! ncid of output files
  INTEGER(KIND=4)                               :: nperio=4           ! ncid of output files
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: id_var             ! arrays of var id's
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: ipk                ! arrays of vertical level for each var
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: id_varout          ! varid's of average vars
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: id_varout2         ! varid's of sqd average vars
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: id_varout3         ! varid's of cub average vars

  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: v2d                ! array to read a layer of data
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: rmean              ! average
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: rmean2             ! squared average
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: rmean3             ! cubic average
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: tim                ! time counter
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: zspval_in          ! time counter
  REAL(KIND=4), DIMENSION(1)                    :: timean             ! mean time

  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: dtab, dtab2        ! arrays for cumulated values
  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: dtab3              ! arrays for cumulated values
  REAL(KIND=8)                                  :: dtotal_time        ! to compute mean time

  CHARACTER(LEN=256)                            :: cf_in              ! input file names
  CHARACTER(LEN=256)                            :: cf_out  = 'cdfmoy.nc'  ! output file for average
  CHARACTER(LEN=256)                            :: cf_out2 = 'cdfmoy2.nc' ! output file for squared average
  CHARACTER(LEN=256)                            :: cf_out3 = 'cdfmoy3.nc' ! output file for squared average
  CHARACTER(LEN=256)                            :: cv_dep             ! depth dimension name
  CHARACTER(LEN=256)                            :: cldum              ! dummy string argument
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cf_list            ! list of input files
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_nam             ! array of var name
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_nam2            ! array of var2 name for output
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_nam3            ! array of var3 name for output
  
  TYPE (variable), DIMENSION(:),    ALLOCATABLE :: stypvar            ! attributes for average values
  TYPE (variable), DIMENSION(:),    ALLOCATABLE :: stypvar2           ! attributes for square averaged values
  TYPE (variable), DIMENSION(:),    ALLOCATABLE :: stypvar3           ! attributes for cubic averaged values

  LOGICAL                                       :: lcaltmean          ! mean time computation flag
  LOGICAL                                       :: lspval0 = .false.  ! cdfmoy_chsp flag
  LOGICAL                                       :: lcubic  = .false.  ! 3rd momment computation
  LOGICAL                                       :: lzermean = .false. ! flag for zero-mean process
  LOGICAL                                       :: lchk    = .false.  ! flag for missing files
  !!----------------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfmoy list_of_model_files [-spval0] [-cub ] [-zeromean]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the time average of a list of files given as arguments.' 
     PRINT *,'       The program assume that all files in the list are of same'
     PRINT *,'       type (shape, variables etc...). '
     PRINT *,'       For some variables, the program also compute the time average '
     PRINT *,'       of the squared variables, which is used in other cdftools '
     PRINT *,'       (cdfeke, cdfrmsssh, cdfstdevw, cdfstddevts ... The actual variables'
     PRINT *,'       selected for squared average are :'
     PRINT '(10x,"- ",a)' , (TRIM(cn_sqdvar(jv)), jv=1, nn_sqdvar)
     PRINT *,'       This selection can be adapted with the nam_cdf_namelist process.'
     PRINT *,'       (See cdfnamelist -i for details).'
     PRINT *,'       If you want to compute the average of already averaged files,'
     PRINT *,'       consider using cdfmoy_weighted instead, in order to take into'
     PRINT *,'       account a particular weight for each file in the list.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       A list of similar model output files. '
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [ -spval0 ] :  set missing_value attribute to 0 for all output'
     PRINT *,'               variables and take care of the input missing_value.'
     PRINT *,'               This option is usefull if missing_values differ from files '
     PRINT *,'               to files; it was formely done by cdfmoy_chsp).'
     PRINT *,'       [ -cub ] :  use this option if you want to compute third order moment'
     PRINT *,'               for the eligible variables, which are at present :'
     PRINT '(15x,"- ",a)' , (TRIM(cn_cubvar(jv)), jv=1, nn_cubvar)
     PRINT *,'              This selection can be adapted with the nam_cdf_namelist process.'
     PRINT *,'              (See cdfnamelist -i for details).'
     PRINT *,'       [ -zeromean ] : with this option, the spatial mean value for each '
     PRINT *,'              time frame is substracted from the original field previous '
     PRINT *,'              averaging, square averaging and eventually cubic averaging'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       If -zeromean option is used, need ', TRIM(cn_fhgr),' and ',TRIM(cn_fmsk)
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out),' and ',TRIM(cf_out2)
     PRINT *,'       variables : are the same than in the input files. For squared averages' 
     PRINT *,'       _sqd is append to the original variable name.'
     PRINT *,'       IF -cub option is used, the file ', TRIM(cf_out3),' is also created'
     PRINT *,'       with _cub append to the original variable name.'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'       cdfmoy_weighted, cdfstdev'
     PRINT *,'      '
     STOP
  ENDIF


  ALLOCATE ( cf_list(narg) )
  ! look for -spval0 option and set up cf_list, nfil 
  ijarg = 1 
  nfil = 0
  DO WHILE ( ijarg <= narg )
     CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1
     SELECT CASE ( cldum )
     CASE ( '-spval0' )   ! option to reset spval to 0 in the output files
        lspval0 = .true.
     CASE ( '-cub' )   ! option to reset spval to 0 in the output files
        lcubic = .true.
     CASE ( '-zeromean' )   ! option to reset spval to 0 in the output files
        lzermean = .true.
     CASE DEFAULT         ! then the argument is a file
        nfil          = nfil + 1
        cf_list(nfil) = TRIM(cldum)
     END SELECT
  END DO

  IF ( lzermean ) THEN
    lchk = lchk .OR. chkfile ( cn_fhgr )
    lchk = lchk .OR. chkfile ( cn_fmsk )
    IF ( lchk ) STOP ! missing files
  ENDIF

  ! Initialisation from  1rst file (all file are assume to have the same geometry)
  ! time counter can be different for each file in the list. It is read in the
  ! loop for files

  cf_in = cf_list(1)
  IF ( chkfile (cf_in) ) STOP ! missing file

  npiglo = getdim (cf_in, cn_x)
  npjglo = getdim (cf_in, cn_y)
  npk    = getdim (cf_in, cn_z, cdtrue=cv_dep, kstatus=ierr)

  IF (ierr /= 0 ) THEN
     npk   = getdim (cf_in, 'z',cdtrue=cv_dep,kstatus=ierr)
     IF (ierr /= 0 ) THEN
       npk   = getdim (cf_in,'sigma',cdtrue=cv_dep,kstatus=ierr)
        IF ( ierr /= 0 ) THEN 
          npk = getdim (cf_in,'nav_lev',cdtrue=cv_dep,kstatus=ierr)
            IF ( ierr /= 0 ) THEN 
              npk = getdim (cf_in,'levels',cdtrue=cv_dep,kstatus=ierr)
              IF ( ierr /= 0 ) THEN 
                PRINT *,' assume file with no depth'
                npk=0
              ENDIF
            ENDIF
        ENDIF
     ENDIF
  ENDIF

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk

  ALLOCATE( dtab(npiglo,npjglo), dtab2(npiglo,npjglo), v2d(npiglo,npjglo) )
  ALLOCATE( rmean(npiglo,npjglo), rmean2(npiglo,npjglo) )
  IF ( lcubic ) THEN
     ALLOCATE( dtab3(npiglo,npjglo), rmean3(npiglo,npjglo) )
  ENDIF

  nvars = getnvar(cf_in)
  PRINT *,' nvars = ', nvars

  ALLOCATE (cv_nam(nvars), cv_nam2(nvars) )
  ALLOCATE (stypvar(nvars), stypvar2(nvars) )
  ALLOCATE (id_var(nvars),ipk(nvars),id_varout(nvars), id_varout2(nvars)  )
  IF ( lcubic ) THEN
     ALLOCATE (cv_nam3(nvars), stypvar3(nvars), id_varout3(nvars)  )
  ENDIF

  ! get list of variable names and collect attributes in stypvar (optional)
  cv_nam(:) = getvarname(cf_in,nvars,stypvar)

  IF ( lspval0 ) THEN 
     ALLOCATE ( zspval_in(nvars) )
     zspval_in(:) = stypvar(:)%rmissing_value
     stypvar(:)%rmissing_value = 0.
  ENDIF
  IF ( lcubic) THEN
     ! force votemper to be squared saved
     nn_sqdvar = nn_sqdvar + 1
     cn_sqdvar(nn_sqdvar) = TRIM(cn_votemper)  
  ENDIF

  DO jvar = 1, nvars
     ! variables that will not be computed or stored are named 'none'
     IF ( varchk2 ( cv_nam(jvar) ) ) THEN 
        cv_nam2(jvar)                    = TRIM(cv_nam(jvar))//'_sqd'
        stypvar2(jvar)%cname             = TRIM(stypvar(jvar)%cname)//'_sqd'         ! name
        stypvar2(jvar)%cunits            = '('//TRIM(stypvar(jvar)%cunits)//')^2'    ! unit
        stypvar2(jvar)%rmissing_value    = stypvar(jvar)%rmissing_value              ! missing_value
        stypvar2(jvar)%valid_min         = 0.                                        ! valid_min = zero
        stypvar2(jvar)%valid_max         = stypvar(jvar)%valid_max**2                ! valid_max *valid_max
        stypvar2(jvar)%scale_factor      = 1.
        stypvar2(jvar)%add_offset        = 0.
        stypvar2(jvar)%savelog10         = 0.
        stypvar2(jvar)%clong_name        = TRIM(stypvar(jvar)%clong_name)//'_Squared'   ! 
        stypvar2(jvar)%cshort_name       = TRIM(stypvar(jvar)%cshort_name)//'_sqd'     !
        stypvar2(jvar)%conline_operation = TRIM(stypvar(jvar)%conline_operation) 
        stypvar2(jvar)%caxis             = TRIM(stypvar(jvar)%caxis) 
     ELSE
         cv_nam2(jvar) = 'none'
     END IF
     ! check for cubic average
     IF ( lcubic ) THEN
       IF ( varchk3 ( cv_nam(jvar) ) ) THEN 
          cv_nam3(jvar)                    = TRIM(cv_nam(jvar))//'_cub'
          stypvar3(jvar)%cname             = TRIM(stypvar(jvar)%cname)//'_cub'         ! name
          stypvar3(jvar)%cunits            = '('//TRIM(stypvar(jvar)%cunits)//')^3'    ! unit
          stypvar3(jvar)%rmissing_value    = stypvar(jvar)%rmissing_value              ! missing_value
          stypvar3(jvar)%valid_min         = 0.                                        ! valid_min = zero
          stypvar3(jvar)%valid_max         = stypvar(jvar)%valid_max**3                ! valid_max *valid_max
          stypvar3(jvar)%scale_factor      = 1.
          stypvar3(jvar)%add_offset        = 0.
          stypvar3(jvar)%savelog10         = 0.
          stypvar3(jvar)%clong_name        = TRIM(stypvar(jvar)%clong_name)//'_Cubed'   ! 
          stypvar3(jvar)%cshort_name       = TRIM(stypvar(jvar)%cshort_name)//'_cub'     !
          stypvar3(jvar)%conline_operation = TRIM(stypvar(jvar)%conline_operation) 
          stypvar3(jvar)%caxis             = TRIM(stypvar(jvar)%caxis) 
       ELSE
          cv_nam3(jvar) = 'none'
       END IF
     ENDIF


  END DO

  id_var(:)  = (/(jv, jv=1,nvars)/)
  ! ipk gives the number of level or 0 if not a T[Z]YX  variable
  ipk(:)     = getipk (cf_in,nvars,cdep=cv_dep)
  WHERE( ipk == 0 ) cv_nam='none'
                stypvar (:)%cname = cv_nam
                stypvar2(:)%cname = cv_nam2
  IF ( lcubic ) stypvar3(:)%cname = cv_nam3

  ! create output file taking the sizes in cf_in
  ncout  = create      (cf_out,  cf_in,    npiglo, npjglo, npk, cdep=cv_dep)
  ierr   = createvar   (ncout ,  stypvar,  nvars,  ipk,    id_varout       )
  ierr   = putheadervar(ncout,   cf_in,    npiglo, npjglo, npk, cdep=cv_dep)

  ncout2 = create      (cf_out2, cf_in,    npiglo, npjglo, npk, cdep=cv_dep)
  ierr   = createvar   (ncout2,  stypvar2, nvars,  ipk,    id_varout2      )
  ierr   = putheadervar(ncout2,  cf_in,    npiglo, npjglo, npk, cdep=cv_dep)

  IF ( lcubic) THEN
     ncout3 = create      (cf_out3, cf_in,    npiglo, npjglo, npk, cdep=cv_dep)
     ierr   = createvar   (ncout3,  stypvar3, nvars,  ipk,    id_varout3      )
     ierr   = putheadervar(ncout3,  cf_in,    npiglo, npjglo, npk, cdep=cv_dep)
  ENDIF

  lcaltmean=.TRUE.
  DO jvar = 1,nvars
     IF ( cv_nam(jvar) == cn_vlon2d .OR. &     ! nav_lon
          cv_nam(jvar) == cn_vlat2d ) THEN     ! nav_lat
        ! skip these variable
     ELSE
        PRINT *,' Working with ', TRIM(cv_nam(jvar)), ipk(jvar)
        DO jk = 1, ipk(jvar)
           PRINT *,'level ',jk
           dtab(:,:) = 0.d0 ; dtab2(:,:) = 0.d0 ; dtotal_time = 0.
           IF ( lcubic ) THEN  ; dtab3(:,:) = 0.d0 ; ENDIF
           ntframe = 0
           DO jfil = 1, nfil
              cf_in = cf_list(jfil)
              IF ( jk == 1 ) THEN
                  IF ( chkfile (cf_in) ) STOP ! missing file
              ENDIF

              npt = getdim (cf_in, cn_t)
              IF ( lcaltmean )  THEN
                 ALLOCATE ( tim(npt) )
                 tim         = getvar1d(cf_in, cn_vtimec, npt)
                 dtotal_time = dtotal_time + SUM(DBLE(tim(:)))
                 DEALLOCATE (tim )
              END IF
              DO jt=1,npt
                ntframe = ntframe + 1
                v2d(:,:)  = getvar(cf_in, cv_nam(jvar), jk ,npiglo, npjglo,ktime=jt )
                IF ( lspval0  )  WHERE (v2d == zspval_in(jvar))  v2d = 0.  ! change missing values to 0
                IF ( lzermean ) CALL zeromean (jk, v2d )
                dtab(:,:) = dtab(:,:) + v2d(:,:)*1.d0
                IF (cv_nam2(jvar) /= 'none' ) dtab2(:,:) = dtab2(:,:) + v2d(:,:)*v2d(:,:)*1.d0
                IF ( lcubic ) THEN
                   IF (cv_nam3(jvar) /= 'none' ) dtab3(:,:) = dtab3(:,:) + v2d(:,:)*v2d(:,:)*v2d(:,:) *1.d0
                ENDIF
              ENDDO
           END DO
           ! finish with level jk ; compute mean (assume spval is 0 )
           rmean(:,:) = dtab(:,:)/ntframe
           IF (cv_nam2(jvar) /= 'none' ) rmean2(:,:) = dtab2(:,:)/ntframe
           IF ( lcubic ) THEN
              IF (cv_nam3(jvar) /= 'none' ) rmean3(:,:) = dtab3(:,:)/ntframe
           ENDIF

           ! store variable on outputfile
           ierr = putvar(ncout, id_varout(jvar), rmean, jk, npiglo, npjglo, kwght=ntframe)
           IF (cv_nam2(jvar) /= 'none' ) THEN 
               ierr = putvar(ncout2, id_varout2(jvar), rmean2, jk, npiglo, npjglo, kwght=ntframe)
           ENDIF

           IF ( lcubic) THEN
              IF (cv_nam3(jvar) /= 'none' ) THEN 
                 ierr = putvar(ncout3, id_varout3(jvar), rmean3, jk, npiglo, npjglo, kwght=ntframe)
              ENDIF
           ENDIF

           IF (lcaltmean )  THEN
              timean(1) = dtotal_time/ntframe
                          ierr = putvar1d(ncout,  timean, 1, 'T')
                          ierr = putvar1d(ncout2, timean, 1, 'T')
              IF (lcubic) ierr = putvar1d(ncout3, timean, 1, 'T')
           END IF

           lcaltmean=.FALSE. ! tmean already computed
        END DO  ! loop to next level
     END IF
  END DO ! loop to next var in file

                ierr = closeout(ncout)
                ierr = closeout(ncout2)
  IF ( lcubic ) ierr = closeout(ncout3 ) 

CONTAINS 

  LOGICAL FUNCTION varchk2 ( cd_var ) 
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION varchk2  ***
    !!
    !! ** Purpose : Return true if cd_var is candidate for mean squared value  
    !!
    !! ** Method  : List of candidate is established in modcdfnames, and
    !!              can be changed via the nam_cdf_names namelist   
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*), INTENT(in) :: cd_var

    INTEGER(KIND=4)              :: jv
    !!----------------------------------------------------------------------
    varchk2 = .FALSE.
    DO jv = 1, nn_sqdvar 
      IF ( cd_var == cn_sqdvar(jv) ) THEN
       varchk2 = .TRUE.
       exit
      ENDIF
    ENDDO 
    
  END FUNCTION varchk2

  LOGICAL FUNCTION varchk3 ( cd_var )
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION varchk3  ***
    !!
    !! ** Purpose : Return true if cd_var is candidate for cubic mean average
    !!
    !! ** Method  : List of candidate is established in modcdfnames, and
    !!              can be changed via the nam_cdf_names namelist
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*), INTENT(in) :: cd_var

    INTEGER(KIND=4)              :: jv
    !!----------------------------------------------------------------------
    varchk3 = .FALSE.
    DO jv = 1, nn_cubvar
      IF ( cd_var == cn_cubvar(jv) ) THEN
       varchk3 = .TRUE.
       exit
      ENDIF
    ENDDO

  END FUNCTION varchk3

  SUBROUTINE zeromean(kk, ptab)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE zeromean  ***
    !!
    !! ** Purpose :  Computes the spatial average of argument and
    !!               and substract it from the field 
    !!
    !! ** Method  :  requires the horizontal metrics 
    !!
    !!----------------------------------------------------------------------
    INTEGER(KIND=4),              INTENT(   in) :: kk
    REAL(KIND=4), DIMENSION(:,:), INTENT(inout) :: ptab

    REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE, SAVE :: ze2, ze1, tmask, tmask0

    REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE, SAVE :: dareas
    REAL(KIND=8),                              SAVE :: darea
    REAL(KIND=8)                                    :: dmean

    LOGICAL, SAVE                                   :: lfirst=.true.
    !!----------------------------------------------------------------------

   IF (lfirst) THEN
     lfirst=.false.
     ! read e1 e2 and tmask ( assuming this prog only deal with T-points)
     ALLOCATE ( ze1(npiglo, npjglo), ze2(npiglo,npjglo)       )
     ALLOCATE ( tmask(npiglo,npjglo), tmask0(npiglo,npjglo)   )
     ALLOCATE ( dareas(npiglo,npjglo)                         )

     ze1(:,:)     = getvar(cn_fhgr, cn_ve1t, 1, npiglo, npjglo)
     ze2(:,:)     = getvar(cn_fhgr, cn_ve2t, 1, npiglo, npjglo)
     dareas(:,:)  = ze1(:,:) * ze2(:,:) *1.d0
   ENDIF
     tmask0(:,:)  = getvar(cn_fmsk, 'tmask', kk, npiglo, npjglo)
     tmask = tmask0
     tmask(1,:)=0 ; tmask(npiglo,:)=0 ; tmask(:,1) = 0.; tmask(:,npjglo) = 0 

     IF ( nperio == 3 .OR. nperio == 4 ) THEN
       tmask(npiglo/2+1:npiglo,npjglo-1) = 0.
     ENDIF


     darea = SUM( dareas * tmask )

     IF ( darea /= 0.d0 ) THEN
        dmean = SUM( ptab * dareas ) / darea
     ELSE
        dmean = 0.d0
     ENDIF

     WHERE ( ptab /= 0 )  ptab = ( ptab - dmean ) * tmask0
     
  END SUBROUTINE zeromean


END PROGRAM cdfmoy

PROGRAM cdfnan
  !!======================================================================
  !!                     ***  PROGRAM  cdfnan  ***
  !!=====================================================================
  !!  ** Purpose : Replace the nan values by spval or another value 
  !!               given in argument
  !!
  !! History : 2.1  : 05/2010  : J.M. Molines : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio 
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class file_operations
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                               :: jk, jvar, jfil, jt     ! dummy loop index
  INTEGER(KIND=4)                               :: ierr                   ! working integer
  INTEGER(KIND=4)                               :: idep, idep_max         ! possible depth index, maximum
  INTEGER(KIND=4)                               :: narg, iargc, ijarg     ! browse line
  INTEGER(KIND=4)                               :: nfiles                 ! number of files to process
  INTEGER(KIND=4)                               :: ncid                   ! ncid of input file for rewrite
  INTEGER(KIND=4)                               :: npiglo, npjglo         ! size of the domain
  INTEGER(KIND=4)                               :: npk, npt               ! size of the domain
  INTEGER(KIND=4)                               :: nvars                  ! Number of variables in a file
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: ipk                    ! arrays of vertical level for each var
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: id_var                 ! arrays of var id

  REAL(KIND=4)                                  :: zspval, replace        ! spval, replace value
  REAL(KIND=4)                                  :: rabsmax                ! spval, replace value
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: tab                    ! Arrays for data

  CHARACTER(LEN=256)                            :: cldum                  ! dummy string for getarg
  CHARACTER(LEN=256)                            :: cf_inout               ! file name
  CHARACTER(LEN=256)                            :: cunits, clname, csname ! attributes
  CHARACTER(LEN=256)                            :: cv_dep                 ! name of dep dimension
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_names               ! array of var name
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cf_lst                 ! list of file to process
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: clv_dep                ! array of possible depth name (or 3rd dimension)

  TYPE(variable), DIMENSION(:),     ALLOCATABLE :: stypvar                ! type for attributes

  LOGICAL                                       :: l_replace = .FALSE.    ! flag for replace value
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfnan -l LST-files [-r value] [-absmax max] '
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Detect NaN values in the input files, and change them to either spval'
     PRINT *,'       (missing_value) or the value given with -r option.'
     PRINT *,'      '
     PRINT *,'       When absolute value is larger than huge or that the value given with'
     PRINT *,'       the -absmax option, it is also replaced as NaN are replaced.'
     PRINT *,'      '
     PRINT *,'     CAUTION :'
     PRINT *,'      ################################'
     PRINT *,'      # INPUT FILES ARE OVER-WRITTEN #'
     PRINT *,'      ################################'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -l LST-files : A blank-separated list of the name of the files to '
     PRINT *,'              process. All files in the list must have the same geometry and'
     PRINT *,'              must contain the same variables.'
     PRINT *,'              CAUTION : input files are over-written!'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-r value] : use value instead of missing_value for replacing NaN.'
     PRINT *,'       [-absmax rabsmax ] : replace values whose absolute value is greater'
     PRINT *,'                    than max.'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : input file is rewritten without NaN.' 
     PRINT *,'         variables : same name as input.' 
     PRINT *,'      '
     STOP 
  ENDIF

  rabsmax=HUGE(0.0)

  ijarg=1 ; nfiles=0
  DO WHILE ( ijarg <= narg )
     CALL getarg(ijarg, cldum) ;   ijarg = ijarg + 1
     SELECT CASE (cldum)
     CASE ('-l'      ) ; CALL GetFileList
        ! options
     CASE ('-r'      ) ; CALL getarg( ijarg, cldum) ; ijarg = ijarg+1 ; READ(cldum,*) replace ; l_replace=.TRUE.
     CASE ('-absmax' ) ; CALL getarg( ijarg, cldum) ; ijarg = ijarg+1 ; READ(cldum,*) rabsmax 
     CASE DEFAULT      ; PRINT *,' ERROR : ',TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  END DO

  cf_inout = cf_lst(1)
  IF ( chkfile (cf_inout) )  STOP 99 ! missing file

  npiglo = getdim (cf_inout, cn_x              )
  npjglo = getdim (cf_inout, cn_y              )

  ! looking for npk among various possible name
  idep_max=8
  ALLOCATE ( clv_dep(idep_max) )
  clv_dep(:) = (/cn_z,'z','sigma','nav_lev','levels','ncatice','icbcla','icbsect'/)
  idep=1  ; ierr=1000
  DO WHILE ( ierr /= 0 .AND. idep <= idep_max )
     npk  = getdim (cf_inout, clv_dep(idep), cdtrue=cv_dep, kstatus=ierr)
     idep = idep + 1
  ENDDO

  IF ( ierr /= 0 ) THEN  ! none of the dim name was found
     PRINT *,' assume file with no depth'
     npk=0
  ENDIF

  PRINT *, 'npiglo=', npiglo
  PRINT *, 'npjglo=', npjglo
  PRINT *, 'npk   =', npk

  ALLOCATE( tab(npiglo,npjglo) )

  nvars = getnvar(cf_inout)

  ALLOCATE (cv_names(nvars), id_var(nvars),ipk(nvars), stypvar(nvars))

  cv_names(:) = getvarname(cf_inout,nvars,stypvar)
  ipk(:)      = getipk(cf_inout,nvars)
  id_var(:)   = getvarid(cf_inout,nvars)

  DO jfil = 1, nfiles
     cf_inout = cf_lst(jfil)
     PRINT *, 'Change NaN on file ', cf_inout
     ncid = ncopen(cf_inout)
     npt  = getdim (cf_inout,cn_t)

     DO jvar = 1,nvars
        IF (    cv_names(jvar) == cn_vlon2d   .OR. &
             &  cv_names(jvar) == cn_vlat2d   .OR. &
             &  cv_names(jvar) == cn_vtimec   .OR. &
             &  cv_names(jvar) == cn_vdeptht  .OR. &
             &  cv_names(jvar) == cn_vdepthu  .OR. &
             &  cv_names(jvar) == cn_vdepthv         )  THEN
           ! skip these variable
        ELSE
           IF ( l_replace ) THEN
              zspval=replace
           ELSE
              ierr = getvaratt (cf_inout, cv_names(jvar), cunits, zspval, clname, csname)
           ENDIF

           DO jt=1,npt
              DO jk = 1, ipk(jvar) 
                 tab(:,:) = getvar(cf_inout, cv_names(jvar), jk, npiglo, npjglo, ktime=jt )
                 !                   WHERE( isnan(tab(:,:)) ) tab(:,:) = zspval
                 ! isnan function is not available on xlf90 compiler
                 ! we replace it by the following test that gives the same results
                 ! reference : http://www.unixguide.net/ibm/faq/faq3.03.shtml
                 WHERE( tab(:,:) /=  tab(:,:) ) tab(:,:) = zspval
                 WHERE( tab(:,:) < -rabsmax )   tab(:,:) = zspval
                 WHERE( tab(:,:) >  rabsmax )   tab(:,:) = zspval
                 ierr = putvar(ncid, id_var(jvar), tab, jk, npiglo, npjglo, ktime=jt)
              ENDDO
           END DO
        ENDIF
     ENDDO
  ENDDO

  ierr = closeout(ncid)

CONTAINS

  SUBROUTINE GetFileList
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE GetFileList  ***
    !!
    !! ** Purpose :  Set up a file list given on the command line as 
    !!               blank separated list
    !!
    !! ** Method  :  Scan the command line until a '-' is found
    !!----------------------------------------------------------------------
    INTEGER (KIND=4)  :: ji
    INTEGER (KIND=4)  :: icur
    !!----------------------------------------------------------------------
    !!
    nfiles=0
    ! need to read a list of file ( number unknow ) 
    ! loop on argument till a '-' is found as first char
    icur=ijarg                          ! save current position of argument number
    DO ji = icur, narg                  ! scan arguments till - found
       CALL getarg ( ji, cldum )
       IF ( cldum(1:1) /= '-' ) THEN ; nfiles = nfiles+1
       ELSE                          ; EXIT
       ENDIF
    ENDDO
    ALLOCATE (cf_lst(nfiles) )
    DO ji = icur, icur + nfiles -1
       CALL getarg(ji, cf_lst( ji -icur +1 ) ) ; ijarg=ijarg+1
    END DO
  END SUBROUTINE GetFileList


END PROGRAM cdfnan

PROGRAM cdfzonalsum
  !!======================================================================
  !!                     ***  PROGRAM  cdfzonalsum  ***
  !!=====================================================================
  !!  ** Purpose : Compute the zonal sum of a file
  !!
  !!  ** Method  : In this program the 'zonal' sum is in fact a sum 
  !!               along the I coordinate. 
  !!
  !! History : 2.1  : 11/2005  : J.M. Molines : Original code
  !!                : 06/2007  : P. Mathiot   : adaptation for 2D files
  !!           3.0  : 05/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  !! * Local variables
  IMPLICIT NONE

  INTEGER(KIND=4)                               :: ji, jj, jk ,jt      ! dummy loop index
  INTEGER(KIND=4)                               :: jbasin, jvar        ! dummy loop index
  INTEGER(KIND=4)                               :: ijvar               ! variable counter
  INTEGER(KIND=4)                               :: npbasins=1          ! number of subbasin
  INTEGER(KIND=4)                               :: ivar = 0            ! output variable counter
  INTEGER(KIND=4)                               :: narg, iargc         ! command line 
  INTEGER(KIND=4)                               :: ijarg, ireq         ! command line 
  INTEGER(KIND=4)                               :: npiglo, npjglo      ! size of the domain
  INTEGER(KIND=4)                               :: npk, npt            ! size of the domain
  INTEGER(KIND=4)                               :: nvarin, nvar        ! number of input variables: all/valid
  INTEGER(KIND=4)                               :: nvarmx              ! number of output variables: all/valid
  INTEGER(KIND=4)                               :: nvaro=1             ! number of output variables: all/valid
  INTEGER(KIND=4)                               :: ncout               ! ncid of output file
  INTEGER(KIND=4)                               :: ierr                ! working integer
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: ipki, id_varin      ! jpbasin x nvar
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: ipko, id_varout     ! jpbasin x nvar
  INTEGER(KIND=4), DIMENSION(2)                 :: ijloc               ! working array for maxloc

  REAL(KIND=4)                                  :: ra = 6371229.       ! earth radius (m)
  REAL(KIND=4)                                  :: z2pi                ! 2 x 3.14...
  REAL(KIND=4), DIMENSION (:),      ALLOCATABLE :: tim                 ! time counter
  REAL(KIND=4), DIMENSION (:),      ALLOCATABLE :: gdep                ! gdept or gdepw
  REAL(KIND=4), DIMENSION (:),      ALLOCATABLE :: alpha               ! 
  REAL(KIND=4), DIMENSION (:,:),    ALLOCATABLE :: e1, e2, gphi, zv    ! metrics, latitude, data value
  REAL(KIND=4), DIMENSION (:,:),    ALLOCATABLE :: zdumlon             ! dummy longitude = 0.
  REAL(KIND=4), DIMENSION (:,:),    ALLOCATABLE :: zdumlat             ! latitude for i = north pole
  REAL(KIND=4), DIMENSION (:,:),    ALLOCATABLE :: zmaskvar            ! variable mask
  REAL(KIND=4), DIMENSION (:,:,:),  ALLOCATABLE :: zmask               ! basin mask jpbasins x npiglo x npjglo

  REAL(KIND=8), DIMENSION (:,:),    ALLOCATABLE :: dzosum              ! jpbasins x npjglo x npk

  CHARACTER(LEN=256)                            :: cf_in               ! input file name
  CHARACTER(LEN=256)                            :: cf_out='zonalsum.nc' ! output file name
  CHARACTER(LEN=256)                            :: cf_pdeg='zonalintdeg.nc' ! output file name
  CHARACTER(LEN=256)                            :: cf_basins='none'    ! sub basin file name
  CHARACTER(LEN=10 )                            :: cv_e1, cv_e2        ! horizontal metrics variable names
  CHARACTER(LEN=10 )                            :: cv_phi              ! latitude variable name
  CHARACTER(LEN=10 )                            :: cv_msk              ! mask variable name
  CHARACTER(LEN=10 )                            :: cv_depi, cv_depo    ! depth variable name (input/output)
  CHARACTER(LEN=256)                            :: cldum               ! dummy character variable
  CHARACTER(LEN=256)                            :: ctyp                ! variable type on C-grid
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_namesi           ! input variable names
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_nameso           ! output variable names
  CHARACTER(LEN=80 ), DIMENSION(:), ALLOCATABLE :: cv_fix              ! name of the specified variable to process (-var option)
  CHARACTER(LEN=4  ), DIMENSION(5)              :: cbasin=(/'_glo','_atl','_inp','_ind','_pac'/) ! sub basin suffixes

  TYPE(variable), DIMENSION(:),     ALLOCATABLE :: stypvari            ! structure for input variables
  TYPE(variable), DIMENSION(:),     ALLOCATABLE :: stypvaro            ! structure for output variables

  LOGICAL                                       :: lpdep =.FALSE.      ! flag for depth sign (default dep < 0)
  LOGICAL                                       :: lpdeg =.FALSE.      ! flag for per degree normalization
  LOGICAL                                       :: lvar  =.FALSE.      ! flag for specified variables processing
  LOGICAL                                       :: ldebug   =.FALSE.   ! flag for activated debug print 
  LOGICAL                                       :: l2d   =.FALSE.      ! flag for 2D files
  LOGICAL                                       :: lchk  =.FALSE.      ! flag for missing files
  LOGICAL, DIMENSION(:),            ALLOCATABLE :: lbad                ! flag array for variable selection
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfzonalsum IN-file point_type [ BASIN-file] ...'
     PRINT *,'                  ... [-var var1,var2,..] [-pdep | --positive_depths]'
     PRINT *,'                  ... [-pdeg | --per_degree] [-debug]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the zonal sum of all the variables available in the' 
     PRINT *,'       input file. This program assume that all the variables are'
     PRINT *,'       located on the same C-grid point, specified on the command line.'
     PRINT *,'         Using -var option limits the variables to be processed.'
     PRINT *,'      '
     PRINT *,'       Zonal sum is in fact the integral value computed along the I coordinate.'
     PRINT *,'       The result is a vertical slice, in the meridional direction.'
     PRINT *,'      '
     PRINT *,'       REMARK : partial step are not handled properly (but probably '
     PRINT *,'                minor impact on results).'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       IN-file    : input netcdf file.' 
     PRINT *,'       point_type : indicate the location on C-grid (T|U|V|F|W)'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [BASIN-file] : netcdf file describing sub basins, similar to '
     PRINT *,'                      ', TRIM(cn_fbasins),'. If this name is not given '
     PRINT *,'                      as option, only the global zonal integral is computed.'
     PRINT *,'       [-var var1,var2,.. ] : Comma separated list of selected variables'
     PRINT *,'       [-pdep | --positive_depths ] : use positive depths in the output file.'
     PRINT *,'                      Default behaviour is to have negative depths.'
     PRINT *,'       [-pdeg | --per_degree ] : When using this option, the zonal integral'
     PRINT *,'                      is normalized per degree of latitude. This was formally'
     PRINT *,'                      done with cdfzonalintdeg program, which is now merged'
     PRINT *,'                      in this one.'
     PRINT *,'                      Default behaviour is not to normalize.'
     PRINT *,'       [-debug ] : add some print for debug'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ',TRIM(cn_fhgr),', ', TRIM(cn_fzgr),' and ', TRIM(cn_fmsk)
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out),' or ', TRIM(cf_pdeg),' (-pdeg option)' 
     PRINT *,'         variables : output variable names are built with the following'
     PRINT *,'                     convention: zoixxxx_bas'
     PRINT *,'                      where zoi replace vo/so prefix of the input variable'
     PRINT *,'                      where bas is a suffix for each sub-basins (or glo)'
     PRINT *,'                      if a BASIN-file is used.'
     PRINT *,'            Units are modified by adding ''.m2'' at the end. Can be improved !'
     PRINT *,'            In addition, ''.degree-1'' is append to unit with -pdeg option.'
     STOP
  ENDIF

  ijarg = 1  ; ireq = 0
  DO WHILE ( ijarg <= narg ) 
    CALL getarg( ijarg, cldum ) ; ijarg=ijarg+1
    SELECT CASE (cldum)
    CASE ( '-pdep' , '--positive_depths' ) ; lpdep  =.TRUE.
    CASE ( '-pdeg' , '--per_degree'      ) ; lpdeg  =.TRUE.
    CASE ( '-debug'                      ) ; ldebug =.TRUE.
    CASE ( '-var'                        ) ; lvar   =.TRUE.
                                             CALL getarg( ijarg, cldum) ; ijarg=ijarg+1
                                             CALL ParseVars(cldum)
    CASE DEFAULT
      ireq=ireq+1
      SELECT CASE (ireq)
      CASE (1) ; cf_in      = cldum                 ! file name is the 1rst argument
      CASE (2) ; ctyp       = cldum                 ! point type is the 2nd
      CASE (3) ; cf_basins  = cldum                 ! sub basin file is the 3rd (optional)
                 npbasins   = 5
                 lchk       = chkfile (cf_basins)
      CASE DEFAULT 
        PRINT *,' Too many arguments ...' ; STOP 99
      END SELECT
    END SELECT
  END DO

  IF ( ldebug ) THEN  ! additional print for debuging
     PRINT *,' Option -pdep     ', lpdep
     PRINT *,' Option -pdeg     ', lpdeg
     PRINT *,' Option -debug    ', ldebug
     PRINT *,' Option -var      ', lvar
     PRINT *,' NPBASINS       = ', npbasins
  ENDIF

  ! check  files existence
  lchk = lchk .OR. chkfile (cn_fhgr)
  lchk = lchk .OR. chkfile (cn_fzgr)
  lchk = lchk .OR. chkfile (cn_fmsk)
  lchk = lchk .OR. chkfile (cf_in  )
  IF ( lchk ) STOP 99 ! missing files

  ! set the metrics according to C grid point
  SELECT CASE (ctyp)
  CASE ('T', 't', 'S', 's')
     cv_e1   = cn_ve1t    ; cv_e2   = cn_ve2t
     cv_depi = cn_gdept   ; cv_depo = cn_vdeptht
     cv_phi  = cn_gphit   ; cv_msk  = 'tmask'
  CASE ('U', 'u')
     cv_e1   = cn_ve1u    ; cv_e2   = cn_ve2u
     cv_depi = cn_gdept   ; cv_depo = cn_vdepthu
     cv_phi  = cn_gphiu   ; cv_msk  = 'umask'
  CASE ('V', 'v')
     cv_e1   = cn_ve1v    ; cv_e2   = cn_ve2v
     cv_depi = cn_gdept   ; cv_depo = cn_vdepthv
     cv_phi  = cn_gphiv   ; cv_msk  = 'vmask'
  CASE ('F', 'f')
     cv_e1   = cn_ve1f    ; cv_e2   = cn_ve2f
     cv_depi = cn_gdept   ; cv_depo = cn_vdeptht
     cv_phi  = cn_gphif   ; cv_msk  = 'fmask'
  CASE ('W', 'w')
     cv_e1   = cn_ve1t    ; cv_e2   = cn_ve2t
     cv_depi = cn_gdepw   ; cv_depo = cn_vdepthw
     cv_phi  = cn_gphit   ; cv_msk  = 'tmask'
  CASE DEFAULT
     PRINT *, ' C grid:', TRIM(ctyp),' point not known!' ; STOP 99
  END SELECT

  nvarin  = getnvar(cf_in)   ! number of input variables
  IF ( .NOT. lvar ) THEN
    nvaro = nvarin
  ENDIF

  nvarmx = npbasins * nvaro
  IF ( ldebug ) PRINT *,' NVARMX (output) :', nvarmx

  ALLOCATE ( cv_namesi(nvarin), ipki(nvarin), id_varin (nvarin) )
  ALLOCATE ( cv_nameso(nvarmx), ipko(nvarmx), id_varout(nvarmx) )
  ALLOCATE ( stypvari(nvarin)                                   )
  ALLOCATE ( stypvaro(nvarmx)                                   )

  cv_namesi(1:nvarin) = getvarname(cf_in, nvarin, stypvari )
  ipki     (1:nvarin) = getipk    (cf_in, nvarin           )

  IF ( lvar )  THEN
     ALLOCATE ( lbad(nvarin) )
     lbad(:) = .true.  ! 
     ! tricks : in case of specified variables, set ipki to 0 all variables
     !          not choosen.
     DO ji = 1, nvaro
       DO jvar = 1, nvarin
         IF ( cv_namesi(jvar) == cv_fix(ji) ) lbad(jvar) = .false.
       END DO
     END DO
     WHERE ( lbad ) ipki=0
     DEALLOCATE (lbad )
  ENDIF

  ! buildt output filename
  nvar = 0  ! over all number of valid variables for zonal sum ( < nvarin)
  ivar = 0  ! over all variable counter ( nvar x basins)
  DO jvar = 1,nvarin
     ! skip variables such as nav_lon, nav_lat, time_counter deptht ...
     IF (ipki(jvar) == 0 ) THEN
        cv_namesi(jvar)='none'
     ELSE
        nvar           = nvar + 1 ! count for valid input variables
        id_varin(nvar) = jvar     ! use indirect adressing for those variables
        DO jbasin=1,npbasins
           ivar=ivar + 1      ! count for output variables
           cv_nameso(ivar)='zoi'//TRIM(cv_namesi(jvar)(3:))//TRIM(cbasin(jbasin) )
           ! intercept case of duplicate zonal name
           IF (cv_namesi(jvar) == 'iowaflup' ) cv_nameso(ivar)='zoiwaflio'  // TRIM(cbasin(jbasin) )
           IF (cv_namesi(jvar) == 'cfc11'    ) cv_nameso(ivar)='zoicfc11'   // TRIM(cbasin(jbasin) )
           IF (cv_namesi(jvar) == 'bombc14'  ) cv_nameso(ivar)='zoibc14'    // TRIM(cbasin(jbasin) )
           IF (cv_namesi(jvar) == 'invcfc'   ) cv_nameso(ivar)='zoiinvcfc'  // TRIM(cbasin(jbasin) )
           IF (cv_namesi(jvar) == 'invc14'   ) cv_nameso(ivar)='zoiinvc14'  // TRIM(cbasin(jbasin) )
           IF (cv_namesi(jvar) == 'qtrcfc'   ) cv_nameso(ivar)='zoiqtrcfc'  // TRIM(cbasin(jbasin) )
           IF (cv_namesi(jvar) == 'qtrc14'   ) cv_nameso(ivar)='zoiqtrc14'  // TRIM(cbasin(jbasin) )
           IF (cv_namesi(jvar) == 'qintcfc'  ) cv_nameso(ivar)='zoiqintcfc' // TRIM(cbasin(jbasin) )
           IF (cv_namesi(jvar) == 'qintc14'  ) cv_nameso(ivar)='zoiqintc14' // TRIM(cbasin(jbasin) )

           stypvaro(ivar)%cname             = cv_nameso(ivar)
           ! units can be build automatically: add .m2 at the end (not very nice ...)
           !  a special function to parse the unit and build the proper one is to be done
           !  this is tricky as many details are to be taken into account :
           !  eg :  mol/m2, kg.m-2, W/m2
           IF ( lpdeg ) THEN
             cf_out = cf_pdeg
             stypvaro(ivar)%cunits            = stypvari(jvar)%cunits//'.m2.degree-1'
             stypvaro(ivar)%clong_name        = 'Zonal_Integral_per_pegree_'//TRIM(stypvari(jvar)%clong_name)//TRIM(cbasin(jbasin) )
           ELSE
             stypvaro(ivar)%cunits            = stypvari(jvar)%cunits//'.m2'
             stypvaro(ivar)%clong_name        = 'Zonal_Integral_'//TRIM(stypvari(jvar)%clong_name)//TRIM(cbasin(jbasin) )
           ENDIF
           stypvaro(ivar)%rmissing_value    = stypvari(ivar)%rmissing_value
           stypvaro(ivar)%valid_min         = stypvari(jvar)%valid_min
           stypvaro(ivar)%valid_max         = stypvari(jvar)%valid_max
           stypvaro(ivar)%cshort_name       = stypvaro(ivar)%cname
           stypvaro(ivar)%conline_operation = '/N/A'

           IF (ipki(jvar) == 1 ) THEN
             stypvaro(ivar)%caxis           ='TY'
           ELSE
             stypvaro(ivar)%caxis           ='TZY'
           ENDIF

           ipko(ivar)=ipki(jvar)
        END DO
     ENDIF
  END DO
 
  npiglo = getdim (cf_in, cn_x)
  npjglo = getdim (cf_in, cn_y)
  npk    = getdim (cf_in, cn_z)
  npt    = getdim (cf_in, cn_t)

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  ! if 2D fields, npk=0, assume 1
  IF ( npk == 0 ) THEN
     npk = 1 
     l2d = .TRUE.
     PRINT *,' It is a 2D field, assume npk=1 and gdep=0'
  END IF
  ! Allocate arrays
  ALLOCATE ( zmask(npbasins,npiglo,npjglo)              )
  ALLOCATE ( zv(npiglo,npjglo), zmaskvar(npiglo,npjglo) )
  ALLOCATE ( e1(npiglo,npjglo), e2      (npiglo,npjglo) )
  ALLOCATE ( gphi(npiglo,npjglo), gdep(npk), tim(npt)   )
  ALLOCATE ( zdumlon(1,npjglo), zdumlat(1,npjglo)       )
  ALLOCATE ( dzosum(npjglo,npk), alpha(npjglo)          )
 

  ! get the metrics
  e1(:,:)   = getvar(cn_fhgr, cv_e1,  1, npiglo, npjglo) 
  e2(:,:)   = getvar(cn_fhgr, cv_e2,  1, npiglo, npjglo) 
  gphi(:,:) = getvar(cn_fhgr, cv_phi, 1, npiglo, npjglo)

  ! compute the size of the meridional mesh size in degree
  IF ( lpdeg ) THEN
     z2pi = 2.0 * ACOS( -1.)
     alpha(:) = e2(1,:) *360. / z2pi / ra
  ELSE
     alpha(:) = 1.e0
  ENDIF

  IF (l2d)  THEN 
     gdep(:) = 0
  ELSE
     gdep(:) = getvare3(cn_fzgr, cv_depi ,npk)
  ENDIF

  IF ( .NOT. lpdep ) gdep(:)   = -1.*  gdep(:)     ! helps for plotting the results

  ! Look for the i-index that go through the North Pole
  ijloc        = MAXLOC(gphi)
  zdumlat(1,:) = gphi(ijloc(1),:)
  zdumlon(:,:) = 0.              ! set the dummy longitude to 0

  ! create output fileset
  ncout = create      (cf_out, cf_in,    1,    npjglo, npk,  cdep=cv_depo                                )
  ierr  = createvar   (ncout,  stypvaro, ivar, ipko,   id_varout                                         )
  ierr  = putheadervar(ncout,  cf_in,    1,    npjglo, npk,  pnavlon=zdumlon, pnavlat=zdumlat, pdep=gdep )

  tim   = getvar1d(cf_in, cn_vtimec, npt     )
  ierr  = putvar1d(ncout, tim,       npt, 'T')

  ! reading the surface masks
  ! 1 : global ; 2 : Atlantic ; 3 : Indo-Pacif ; 4 : Indian ; 5 : Pacif
  zmask(1,:,:) = getvar(cn_fmsk, cv_msk, 1, npiglo, npjglo)
  IF ( cf_basins /= 'none' ) THEN
     zmask(2,:,:) = getvar(cf_basins, cn_tmaskatl, 1, npiglo, npjglo )
     zmask(4,:,:) = getvar(cf_basins, cn_tmaskind, 1, npiglo, npjglo )
     zmask(5,:,:) = getvar(cf_basins, cn_tmaskind, 1, npiglo, npjglo )
     zmask(3,:,:) = zmask(5,:,:) + zmask(4,:,:)
     ! ensure that there are no overlapping on the masks
     WHERE(zmask(3,:,:) > 0 ) zmask(3,:,:) = 1
  ENDIF

  ! main computing loop
  ivar = 0
  DO jvar = 1, nvar
     ijvar = id_varin(jvar)
     DO jt = 1,npt
        IF (MOD(jt,100)==0) PRINT *, jt,'/',npt
        DO jk = 1, ipki(ijvar)
           PRINT *,TRIM(cv_namesi(ijvar)), ' level ',jk
           ! Get variables and mask at level jk
           zv(:,:)       = getvar(cf_in,   cv_namesi(ijvar), jk ,npiglo, npjglo, ktime=jt)
           zmaskvar(:,:) = getvar(cn_fmsk, cv_msk,           jk ,npiglo, npjglo          )
           
           ! For all basins 
           DO jbasin = 1, npbasins
              dzosum(:,:) = 0.d0
              ! integrates 'zonally' (along i-coordinate)
              DO ji=1,npiglo
                 DO jj=1,npjglo
                    dzosum(jj,jk) = dzosum(jj,jk) + e1(ji,jj)*e2(ji,jj)* zmask(jbasin,ji,jj)*zmaskvar(ji,jj)*zv(ji,jj)*1.d0
                 END DO
              END DO
              dzosum(:,jk) = dzosum(:,jk) / alpha(:)  ! eventual normalization per degree
              ivar = (jvar-1)*npbasins + jbasin
              ierr = putvar (ncout, id_varout(ivar), REAL(dzosum(:,jk)), jk, 1, npjglo, ktime=jt)
           END DO  !next basin
        END DO  ! next k 
     END DO ! next time
  END DO ! next variable

  ierr = closeout(ncout)
CONTAINS
   SUBROUTINE ParseVars (cdum)
      !!---------------------------------------------------------------------
      !!                  ***  ROUTINE ParseVars  ***
      !!
      !! ** Purpose :  Decode -var option from command line
      !!
      !! ** Method  :  look for , in the argument string and set the number of
      !!         variable (nvaro), allocate cv_fix array and fill it with the
      !!         decoded  names.
      !!
      !!----------------------------------------------------------------------
      CHARACTER(LEN=*), INTENT(in) :: cdum

      CHARACTER(LEN=80), DIMENSION(100) :: cl_dum  ! 100 is arbitrary
      INTEGER  :: ji
      INTEGER  :: inchar,  i1=1
      !!----------------------------------------------------------------------

      inchar= LEN(TRIM(cdum))
      ! scan the input string and look for ',' as separator
      DO ji=1,inchar
         IF ( cdum(ji:ji) == ',' ) THEN
            cl_dum(nvaro) = cdum(i1:ji-1)
            i1=ji+1
            nvaro=nvaro+1
         ENDIF
      ENDDO

      ! last name of the list does not have a ','
      cl_dum(nvaro) = cdum(i1:inchar)

      ALLOCATE ( cv_fix(nvaro) )
      IF ( ldebug) PRINT *,' SELECTED VARIABLES :'
      DO ji=1, nvaro
         cv_fix(ji) = cl_dum(ji)
         IF ( ldebug) PRINT *, "    ",TRIM(cv_fix(ji))
      ENDDO
   END SUBROUTINE ParseVars

END PROGRAM cdfzonalsum

PROGRAM cdfisf_rnf
  !!======================================================================
  !!                     ***  PROGRAM  cdfisf_rnf  ***
  !!=====================================================================
  !!  ** Purpose : Prepare netcdf file with Ice Shelf melting parametrized
  !!               as runoff (spread on the vertical)
  !!
  !!  ** Method  : 
  !!
  !! History : 3.0  : 04/2014  : P.Mathiot 
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  USE cdfio 
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id: cdfisf_rnf.f90 668 2013-05-30 12:54:00Z molines $
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class ice_shelf_processing
  !!-----------------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                               :: jisf, ji, jj, jw   ! dummy loop index
  INTEGER(KIND=4)                               :: ierr               ! working integer
  INTEGER(KIND=4)                               :: narg, iargc, ijarg ! browsing command line
  INTEGER(KIND=4)                               :: npiglo, npjglo, npk! size of the domain
  INTEGER(KIND=4)                               :: nisf, nwidth       ! number of ice shelves
  INTEGER(KIND=4)                               :: iunit=10           ! id file
  INTEGER(KIND=4)                               :: ncout              ! ncid of output files
  INTEGER(KIND=4)                               :: ifill
  INTEGER(KIND=4)                               :: iiseed, ijseed     ! position of a point within ice shelf
  INTEGER(KIND=4)                               :: ijmin, ijmax       ! j-limits of a particular ice shelf
  INTEGER(KIND=4)                               :: iwscale=75         ! horizontal scale of the fading function (points)
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: ipk                ! arrays of vertical level for each var
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: id_varout          ! varid's of average vars
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: isum               ! zonal sum of isf index for optim
  INTEGER(KIND=2), DIMENSION(:,:),  ALLOCATABLE :: isfindex, isfmask  ! 
  INTEGER(KIND=2), DIMENSION(:,:),  ALLOCATABLE :: isfindex_wk        !

  REAL(KIND=4)                                  :: rdraftmax, rdraftmin ! dummy information in input file
  REAL(KIND=4)                                  :: rlon, rlat         ! dummy information in input file
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: bathy, zdrft       ! bathymetry and ice shelf draft
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: zmax2d, zmin2d     ! output arrays

  REAL(KIND=8)                                  :: dfwf
  REAL(KIND=8)                                  :: dl_fwf, dsumcoef
  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: de12t
  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: dl_fwfisf2d
  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: dfwfisf2d

  !                                                FILES
  CHARACTER(LEN=256)                            :: cf_fill            ! input file names
  CHARACTER(LEN=256)                            :: cf_isflist         ! input file names
  CHARACTER(LEN=256)                            :: cf_bathy='bathy.nc'! bathymetry file name
  CHARACTER(LEN=256)                            :: cf_isfdr='isf_draft.nc'! ice_draft file name
  CHARACTER(LEN=256)                            :: cf_out='rnfisf.nc' ! output file for average
  !                                                VARIABLES
  CHARACTER(LEN=256)                            :: cv_fill            ! fill var name
  CHARACTER(LEN=256)                            :: cv_bathy='Bathymetry' ! bathymetry name
  CHARACTER(LEN=256)                            :: cv_isfdr='isf_draft'  ! ice shelf draft name
  CHARACTER(LEN=256)                            :: cldum              ! dummy string argument

  TYPE (variable), DIMENSION(:),    ALLOCATABLE :: stypvar            ! attributes for average values

  LOGICAL                                       :: lchk    = .FALSE.  ! flag for missing files
  LOGICAL                                       :: lnc4    = .FALSE.  ! flag for netcdf4 chunking and deflation
  !!----------------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()

  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfisf_rnf -f ISF-fill-file -v ISF-fill_var -l ISF-listfile -w width '
     PRINT *,'     [-b BATHY-file] [-vb BATHY-var] [-i ISFDRAFT-file] [-vi ISFDRAFT-variable]'
     PRINT *,'     [-nc4] [-o OUT-file ]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'        Build a netcdf file runoff file using the basal melting of the '
     PRINT *,'        ice-shelves. This netcdf file is intented to be used with NEMO when'
     PRINT *,'        nn_isf namelist parameter is set to 3.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'          -f ISF-fill_file : file built by cdffill (all the ice shelves are'
     PRINT *,'                             tagged with an id)'
     PRINT *,'          -v ISF-fill_var  : name of fill variable to use in ISF-fill_file'
     PRINT *,'          -l ISF-list : Text file with the melting rate (GT/y) given for'
     PRINT *,'               each ice shelf.' 
     PRINT *,'          -w width : specify the width (in grid points) on which the run-off'
     PRINT *,'               will be applied.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'          -b BATHY-file : give name of bathy file.'
     PRINT *,'                      [ default : ',TRIM(cf_bathy),' ]'
     PRINT *,'          -vp BATHY-var : give name of bathy variable.'
     PRINT *,'                      [ default : ',TRIM(cv_bathy),' ]'
     PRINT *,'          -i ISFDRAFT-file : give name of isf_draft file.'
     PRINT *,'                      [ default : ',TRIM(cf_isfdr),' ]'
     PRINT *,'          -vi ISFDRAFT-var : give name of isf_draft variable.'
     PRINT *,'                      [ default : ',TRIM(cv_isfdr),' ]'
     PRINT *,'          -nc4 : Use this option to have netcdf4 output file, with chunking'
     PRINT *,'               and deflation.'
     PRINT *,'          -o OUT-file : Specify the name of the output file instead of '
     PRINT *,'               the default name ',TRIM(cf_out)
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       mesh_hgr.nc and all files specified on the command line' 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) ,' unless -o option used'
     PRINT *,'         variables : sozisfmax (m), sozisfmin(m), sofwfisf (kg/m2/s)'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'       cdfisf_fill, cdfisf_forcing, cdfisf_poolchk'
     PRINT *,'      '
     STOP 
  ENDIF

  ijarg=1
  DO WHILE ( ijarg <= narg )
     CALL getarg(ijarg,cldum) ; ijarg=ijarg+1
     SELECT CASE (cldum)
     CASE ('-f' ) ; CALL getarg(ijarg,cf_fill   ) ; ijarg=ijarg+1
     CASE ('-v' ) ; CALL getarg(ijarg,cv_fill   ) ; ijarg=ijarg+1
     CASE ('-l' ) ; CALL getarg(ijarg,cf_isflist) ; ijarg=ijarg+1
     CASE ('-w' ) ; CALL getarg(ijarg,cldum     ) ; ijarg=ijarg+1 ; READ(cldum,*) nwidth
     CASE ('-b' ) ; CALL getarg(ijarg,cf_bathy  ) ; ijarg=ijarg+1
     CASE ('-vb') ; CALL getarg(ijarg,cv_bathy  ) ; ijarg=ijarg+1
     CASE ('-i' ) ; CALL getarg(ijarg,cf_isfdr  ) ; ijarg=ijarg+1
     CASE ('-vi') ; CALL getarg(ijarg,cv_isfdr  ) ; ijarg=ijarg+1
     CASE ('-nc4'); lnc4 = .TRUE.
     CASE ('-o' ) ; CALL getarg(ijarg,cf_out    ) ; ijarg=ijarg+1
     CASE DEFAULT ; PRINT *,' ERROR : ',TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  ENDDO

  lchk = lchk .OR. chkfile (cf_fill   )
  lchk = lchk .OR. chkfile (cf_isflist)
  lchk = lchk .OR. chkfile (cf_bathy  )
  lchk = lchk .OR. chkfile (cf_isfdr  )
  lchk = lchk .OR. chkfile (cn_fhgr   )

  IF ( lchk ) STOP 99 ! missing file

  npiglo = getdim (cf_fill, cn_x)
  npjglo = getdim (cf_fill, cn_y)
  npk    = 0                  ! bathy file has no dep dimension

  PRINT *, 'NPIGLO = ', npiglo
  PRINT *, 'NPJGLO = ', npjglo
  PRINT *, 'NPK    = ', npk

  ALLOCATE(isfindex (npiglo, npjglo), isfmask    (npiglo, npjglo))
  ALLOCATE(isfindex_wk(npiglo, npjglo), isum(npjglo))

  ALLOCATE(bathy    (npiglo, npjglo), zdrft      (npiglo, npjglo))
  ALLOCATE(zmax2d   (npiglo, npjglo), zmin2d     (npiglo, npjglo))

  ALLOCATE(de12t    (npiglo, npjglo) )
  ALLOCATE(dfwfisf2d(npiglo, npjglo), dl_fwfisf2d(npiglo, npjglo))

  ALLOCATE (stypvar(3))
  ALLOCATE (ipk(3),id_varout(3))

  CALL CreateOutput

  ! define variable
  ! read ice shelf draft data
  isfindex(:,:) = getvar(cf_fill,  cv_fill,  1 ,npiglo, npjglo )  ! fill index
  bathy(:,:)    = getvar(cf_bathy, cv_bathy, 1, npiglo, npjglo )  ! ocean bathy
  zdrft(:,:)    = getvar(cf_isfdr, cv_isfdr, 1, npiglo, npjglo )  ! ice shelf draft
  de12t(:,:)    = getvar(cn_fhgr,  cn_ve1t,  1, npiglo, npjglo ) * getvar(cn_fhgr, cn_ve2t, 1, npiglo, npjglo )

  ! open isf file
  OPEN(unit=iunit, file=cf_isflist, form='formatted', status='old')
  ! get number of isf
  nisf = 0
  cldum='XXX'
  DO WHILE ( TRIM(cldum) /= 'EOF')
     READ(iunit,*) cldum
     nisf=nisf+1
  END DO
  REWIND(iunit)
  nisf = nisf - 1

  PRINT *, '   Number of ISF found in file list : ', nisf
  zmax2d(:,:)      = 0.
  zmin2d(:,:)      = 0.

  DO jisf=1,nisf
     ! reset working isf index to its initial value
     isfindex_wk(:,:) = isfindex(:,:)

     ! read ice shelf data for jsf
     READ(iunit,*) ifill,cldum,rlon, rlat, iiseed, ijseed ,rdraftmin, rdraftmax, dfwf
     IF (ifill == 99 ) EXIT  ! exit on last line 

     dl_fwf = dfwf * 1.d9 * 1.d3 / 86400.d0 / 365.d0  ! convert GT/yr to kg/m2/s
     isfmask    (:,:) = 0
     dl_fwfisf2d(:,:) = 0.0d0
     dsumcoef         = 0.0d0

     ! only deal with current ice shelf
     WHERE (isfindex_wk /=  -ifill ) isfindex_wk = 0

     ! find the j-limits for the current ice shelf 
     PRINT *,' Ice shelf ', jisf,TRIM(cldum), ifill, rdraftmin,rdraftmax
     isum(:)=SUM(isfindex_wk,dim=1)
     ijmin = npjglo ; ijmax=2
     DO jj=ijseed, 2, -1
        IF ( isum(jj) /= 0 ) THEN
           ijmin=jj
        ENDIF
     ENDDO
     DO jj=ijseed, npjglo-1
        IF ( isum(jj) /= 0 ) THEN
           ijmax=jj
        ENDIF
     ENDDO

     DO jw = 1,nwidth
        DO ji=2,npiglo-1
           DO jj = ijmin, ijmax
              IF ( zdrft(ji,jj) == 0 .AND.  &    ! not under ice_shelf
                   &    bathy(ji,jj) /= 0 .AND.  &    ! but in the ocean
                   &    MINVAL(isfindex_wk(ji-1:ji+1 , jj-1:jj+1)) == -ifill  .AND. &  ! 
                   &    isfindex_wk(ji,jj) == 0 ) THEN
                 ! save depth for this point
                 zmax2d(ji,jj)   = rdraftmax
                 zmin2d(ji,jj)   = rdraftmin
                 ! compute dfwf in mm/s  ???
                 isfmask(ji,jj)  = isfmask(ji,jj) + jw 
                 ! use an empirical ocean ward fading function, in order to distribute the
                 ! runoff on nwidth points along the coast. iwscale can be adapted for
                 ! sharper (decrease) or flatter (increase) fading function. Default = 75
                 dl_fwfisf2d(ji,jj) = EXP(-((isfmask(ji,jj)-1.)/iwscale)**2)  
              END IF
           END DO
        END DO
        WHERE (isfmask >= 1) isfindex_wk = -ifill ! capture already treated points under the shelf
     END DO

     dsumcoef=SUM(dl_fwfisf2d)
     IF ( dsumcoef /= 0 ) THEN
       PRINT *, SUM(dl_fwfisf2d), dsumcoef, SUM(dl_fwfisf2d / dsumcoef), dl_fwf, dfwf
     ELSE 
       PRINT *,' ISF number ',jisf, ' missing in config ?'
     ENDIF
     WHERE (isfmask >= 1)
        dl_fwfisf2d = dl_fwfisf2d / dsumcoef * dl_fwf / de12t
     END WHERE
     dfwfisf2d = dfwfisf2d + dl_fwfisf2d
  END DO
  ierr = putvar(ncout, id_varout(1), zmax2d   , 1, npiglo, npjglo)
  ierr = putvar(ncout, id_varout(2), zmin2d   , 1, npiglo, npjglo)
  ierr = putvar(ncout, id_varout(3), dfwfisf2d, 1, npiglo, npjglo)

  ierr = closeout(ncout)

  ! Diagnose total amount of fwf
  dl_fwf = 0.0d0
  DO ji=2,npiglo-1
     DO jj=2,npjglo-1
        dl_fwf = dl_fwf + dfwfisf2d(ji,jj) * de12t(ji,jj) * 86400.d0 * 365.d0
     END DO
  END DO
  PRINT *, 'total sum of isf = ', dl_fwf

CONTAINS

  SUBROUTINE CreateOutput 
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create output netcdf output file using cdfio 
    !!              We use a routine just to increase readability
    !! ** Method  :  Use global variables to know about the file to be created
    !!           
    !!----------------------------------------------------------------------
    REAL(KIND=8), DIMENSION(1) :: dl_tim
    !!----------------------------------------------------------------------
    ! define new variables for output
    stypvar(1)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(1)%cname             = 'sozisfmax'
    stypvar(1)%rmissing_value    =  -99.
    stypvar(1)%valid_min         =  0.
    stypvar(1)%valid_max         =  2000.
    stypvar(1)%clong_name        = 'max depth of isf'
    stypvar(1)%cshort_name       = 'sozisfmax'
    stypvar(1)%conline_operation = 'N/A'
    stypvar(1)%caxis             = 'TYX'
    ipk(1) = 1  !  2D
    ! define new variables for output
    stypvar(2)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(2)%cname             = 'sozisfmin'
    stypvar(2)%rmissing_value    =  -99.
    stypvar(2)%valid_min         =  0.
    stypvar(2)%valid_max         =  2000.
    stypvar(2)%clong_name        = 'min depth of isf'
    stypvar(2)%cshort_name       = 'sozisfmin'
    stypvar(2)%conline_operation = 'N/A'
    stypvar(2)%caxis             = 'TYX'
    ipk(2) = 1  !  2D
    ! define new variables for output
    stypvar(3)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(3)%cname             = 'sofwfisf'
    stypvar(3)%rmissing_value    =  -99.d0
    stypvar(3)%valid_min         =  0.
    stypvar(3)%valid_max         =  2000.
    stypvar(3)%clong_name        = 'fwfisf'
    stypvar(3)%cshort_name       = 'sofwfisf'
    stypvar(3)%conline_operation = 'N/A'
    stypvar(3)%caxis             = 'TYX'
    stypvar(3)%cprecision        = 'r8'
    ipk(3) = 1  !  2D

    ! create output file taking the sizes in cf_fill
    ncout  = create      (cf_out, cf_fill,   npiglo, npjglo, npk,  ld_nc4=lnc4)
    ierr   = createvar   (ncout,  stypvar, 3,   ipk, id_varout  ,  ld_nc4=lnc4)
    ierr   = putheadervar(ncout,  cf_fill,   npiglo, npjglo, npk              )

    dl_tim(1) = 0.d0
    ierr = putvar1d(ncout, dl_tim, 1, 'T') 

  END SUBROUTINE CreateOutput

END PROGRAM cdfisf_rnf

PROGRAM cdfsiginsitu
  !!======================================================================
  !!                     ***  PROGRAM  cdfsiginsitu  ***
  !!=====================================================================
  !!  ** Purpose : Compute sigma insitu 3D field from gridT file
  !!                Store the results on a 'similar' cdf file.
  !!
  !!  **  Method: read temp and salinity, compute sigma insitu
  !!              using depth taken from input T file

  !! History : 2.0  : 11/2004  : J.M. Molines : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE eos
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE
  INTEGER(KIND=4)                           :: jk, jt             ! dummy loop index
  INTEGER(KIND=4)                           :: ierr               ! error status
  INTEGER(KIND=4)                           :: narg, iargc        ! browse command line
  INTEGER(KIND=4)                           :: npiglo, npjglo     ! size of the domain
  INTEGER(KIND=4)                           :: npk, npt           ! size of the domain
  INTEGER(KIND=4)                           :: ncout              ! ncid of output file
  INTEGER(KIND=4), DIMENSION(1)             :: ipk, id_varout     ! level and  varid's

  REAL(KIND=4)                              :: zspval             ! missing value
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: ztemp              ! temperature
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zsal               ! salinity
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zsigi              ! sigma-insitu
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zmask              ! 2D mask at current level
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: tim                ! time counter
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: gdept              ! depth of T points

  CHARACTER(LEN=256)                        :: cf_tfil             ! input filename
  CHARACTER(LEN=256)                        :: cf_out='siginsitu.nc' ! output file name

  TYPE (variable), DIMENSION(1)             :: stypvar            ! structure for attributes
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfsiginsitu T-file'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute in situ density from temperature and salinity.' 
     PRINT *,'       Depths are taken from input file.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       T-file : netcdf file with temperature and salinity.' 
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        none'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : vosigmainsitu (kg/m3 -1000 )'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'      cdfsig0, cdfsigi '
     PRINT *,'      '
     STOP
  ENDIF

  CALL getarg (1, cf_tfil)

  IF ( chkfile(cf_tfil) ) STOP ! missing file

  npiglo = getdim (cf_tfil,cn_x)
  npjglo = getdim (cf_tfil,cn_y)
  npk    = getdim (cf_tfil,cn_z)
  npt    = getdim (cf_tfil,cn_t)

  ipk(:)= npk  ! all variables (input and output are 3D)
  stypvar(1)%cname             = 'vosigmainsitu'
  stypvar(1)%cunits            = 'kg/m3'
  stypvar(1)%rmissing_value    = 0.
  stypvar(1)%valid_min         = 0.001
  stypvar(1)%valid_max         = 45.
  stypvar(1)%clong_name        = 'in situ density'
  stypvar(1)%cshort_name       = 'vosigmainsitu'
  stypvar(1)%conline_operation = 'N/A'
  stypvar(1)%caxis             = 'TZYX'

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  ALLOCATE (ztemp(npiglo,npjglo), zsal (npiglo,npjglo) )
  ALLOCATE (zsigi(npiglo,npjglo), zmask(npiglo,npjglo) )
  ALLOCATE (gdept(npk), tim(npt)                       )

  ! create output fileset
  ncout = create      (cf_out, cf_tfil,  npiglo, npjglo, npk       )
  ierr  = createvar   (ncout,  stypvar,  1,      ipk,    id_varout )
  ierr  = putheadervar(ncout,  cf_tfil,  npiglo, npjglo, npk       )

  zspval = getatt(cf_tfil, cn_vosaline, 'missing_value')

  gdept = getvar1d(cf_tfil, cn_vdeptht, npk    )
  tim   = getvar1d(cf_tfil, cn_vtimec, npt     )
  ierr  = putvar1d(ncout,  tim,        npt, 'T')

  DO jt = 1, npt
     PRINT *,'time: ',jt
     DO jk = 1, npk
        zmask(:,:) = 1.

        ztemp(:,:) = getvar(cf_tfil, cn_votemper, jk, npiglo, npjglo, ktime=jt)
        zsal( :,:) = getvar(cf_tfil, cn_vosaline, jk, npiglo, npjglo, ktime=jt)

        WHERE( zsal == zspval ) zmask = 0

        zsigi(:,:) = sigmai(ztemp, zsal, gdept(jk), npiglo, npjglo )* zmask(:,:)

        ierr = putvar(ncout, id_varout(1), zsigi, jk, npiglo, npjglo, ktime=jt)

     END DO  ! loop to next level
  END DO  ! loop on time

  ierr = closeout(ncout)

END PROGRAM cdfsiginsitu

PROGRAM cdfmxl
  !!======================================================================
  !!                     ***  PROGRAM  cdfmxl  ***
  !!=====================================================================
  !!  ** Purpose : Compute mixed layer depth
  !!
  !!  ** Method  : - compute surface properties
  !!               - initialize depths and model levels number
  !!               - from bottom to top compute rho and
  !!                 check if rho > rho_surf +rho_c
  !!                 where rho_c is a density criteria given as argument
  !!
  !! History : 2.1  : 10/2005  : J.M. Molines : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!           3.0  : 07/2012  : F. Hernandez: Optional S-FILE input
  !!           3.0  : 07/2012  : F. Hernandez: Add new MLD computation for GSOP/GODAE
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE eos
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class mixed_layer
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4), PARAMETER                   :: jp_varout = 7  ! number of output variables 
  INTEGER(KIND=4)                              :: ji, jj, jk, jt ! dummy loop index
  INTEGER(KIND=4)                              :: ik1, ik2, ikt  ! k vertical index of mixed layers 
  INTEGER(KIND=4), DIMENSION(1)                :: nkref10        ! vertical index for 10m depth T layer  
  INTEGER(KIND=4)                              :: narg, iargc    ! browse line
  INTEGER(KIND=4)                              :: ijarg, ixtra   ! browse line
  INTEGER(KIND=4)                              :: npiglo, npjglo ! domain size
  INTEGER(KIND=4)                              :: npk, npt       ! domain size
  INTEGER(KIND=4)                              :: ncout, ierr    ! ncid of output file, error status
  INTEGER(KIND=4), DIMENSION(:,:), ALLOCATABLE :: mbathy         ! number of w levels in water <= npk
  INTEGER(KIND=4), DIMENSION(:,:), ALLOCATABLE :: nmln1          ! last level where rho > rho + rho_c1
  INTEGER(KIND=4), DIMENSION(:,:), ALLOCATABLE :: nmln2          ! last level where rho > rho + rho_c2
  INTEGER(KIND=4), DIMENSION(:,:), ALLOCATABLE :: nmln3          ! last level where rho > rho10 + rho_c2 
  INTEGER(KIND=4), DIMENSION(:,:), ALLOCATABLE :: nmln4          ! last level where rho > rho10 + rho_c3 
  INTEGER(KIND=4), DIMENSION(:,:), ALLOCATABLE :: nmlnt          ! last level where T - SST > temp_c
  INTEGER(KIND=4), DIMENSION(:,:), ALLOCATABLE :: nmlnt2         ! last level where T-T10 > temp_c  
  INTEGER(KIND=4), DIMENSION(:,:), ALLOCATABLE :: nmlnt3         ! last level where T-T10 > temp_c2 
  INTEGER(KIND=4), DIMENSION(jp_varout)        :: ipk, id_varout ! levels and varid's of output vars

  REAL(KIND=4)                                 :: rmisval=32767. ! Missing value of Mercator fields 
  REAL(KIND=4)                                 :: rr1,rr2        ! Coef for T(z=10m) interp. 
  REAL(KIND=4)                                 :: rho_c1=0.01    ! 1rst density criterion
  REAL(KIND=4)                                 :: rho_c2=0.03    ! 2nd density criterion
  REAL(KIND=4)                                 :: rho_c3=0.125   ! 3rd density criterion 
  REAL(KIND=4)                                 :: temp_c=-0.2    ! temperature criterion
  REAL(KIND=4)                                 :: temp_c2=-0.5   ! 2nd temperature criterion 
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: rtem           ! temperature
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: rtem10         ! 10m depth temperature 
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: rsal           ! salinity
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: rsal10         ! 10m depth salinity 
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: rho            ! density
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: rho10          ! 10m depth density 
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: rho_surf       ! surface density
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: tem_surf       ! surface temperature
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: tmask_surf     ! surface tmask
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: tmask_10       ! 10m-depth tmask 
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: tmask          ! level tmask
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: hmlp1          ! mxl depth based on density criterion 1
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: hmlp2          ! mxl depth based on density criterion 2
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: hmlp3          ! mxl depth based on density criterion 2 and 10m
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: hmlp4          ! mxl depth based on density criterion 3 and 10m
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: hmlt           ! mxl depth based on temperature criterion
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: hmlt2          ! mxl depth based on temperature criterion and 10m
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: hmlt3          ! mxl depth based on temperature criterion 2 and 10m
  REAL(KIND=4), DIMENSION(:),      ALLOCATABLE :: gdepw          ! depth of w levels
  REAL(KIND=4), DIMENSION(:),      ALLOCATABLE :: gdept          ! depth of T levels 
  REAL(KIND=4), DIMENSION(1)                   :: rdep           ! dummy depth for output

  REAL(KIND=8), DIMENSION(:),      ALLOCATABLE :: dtim           ! time counter

  CHARACTER(LEN=256)                           :: cf_tfil        ! input T file
  CHARACTER(LEN=256)                           :: cf_sfil        ! input S file (F.Hernandez)
  CHARACTER(LEN=256)                           :: cf_out='mxl.nc'! output file name
  CHARACTER(LEN=256)                           :: cldum          ! dummy character variable

  TYPE(variable), DIMENSION(jp_varout)         :: stypvar        ! structure for attributes 

  LOGICAL                                      :: lexist         ! flag for existence of bathy_level file
  LOGICAL                                      :: lnc4=.FALSE.   ! flag for netcdf4 output with chunking and deflation
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfmxl -t T-file [-s S-file] [-o OUT-file] [-nc4]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute 7 estimates of the mixed layer depth from temperature and '
     PRINT *,'       salinity given in the input file, based on 7 different criteria:'
     PRINT *,'       1- Density criterion (0.01 kg/m3 difference between surface and MLD)' 
     PRINT *,'       2- Density criterion (0.03 kg/m3 difference between surface and MLD)' 
     PRINT *,'       3- Temperature criterion (0.2 C absolute difference between surface '
     PRINT *,'          and MLD)'
     PRINT *,'       4- Temperature criterion (0.2 C absolute difference between T at 10m '
     PRINT *,'          and MLD)'
     PRINT *,'       5- Temperature criterion (0.5 C absolute difference between T at 10m '
     PRINT *,'          and MLD)'
     PRINT *,'       6- Density criterion (0.03 kg/m3 difference between rho at 10m and MLD) '
     PRINT *,'       7- Density criterion (0.125 kg/m3 difference between rho at 10m and MLD) '
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -t T-file   : input netcdf file (gridT)' 
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-s S-file] : input netcdf file (gridS), if vosaline not in T-file' 
     PRINT *,'       [-o OUT-file] : specify the name of output file instead of ', TRIM(cf_out)
     PRINT *,'       [-nc4] : use netcdf4 chunking and deflation on output '
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        ',TRIM(cn_fzgr)
     PRINT *,'         In case of FULL STEP configuration, ',TRIM(cn_fbathylev),' is also required.'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : somxl010    = mld on density criterion 0.01 ref. surf.'
     PRINT *,'                     somxl030    = mld on density criterion 0.03 ref. surf.'
     PRINT *,'                     somxlt02    = mld on temperature criterion -0.2 ref. surf.'
     PRINT *,'                     somxlt02z10 = mld on temperature criterion -0.2 ref. 10m'
     PRINT *,'                     somxlt05z10 = mld on temperature criterion -0.5 ref. 10m'
     PRINT *,'                     somxl030z10 = mld on density criterion 0.03 ref. 10m'
     PRINT *,'                     somxl125z10 = mld on density criterion 0.125 ref. 10m'
     PRINT *,'      '
     STOP 
  ENDIF

  ijarg = 1  ; cf_sfil='none'

  DO WHILE ( ijarg <= narg )
     CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1
     SELECT CASE (cldum )
     CASE ( '-t'   ) ; CALL getarg (ijarg,cf_tfil ) ; ijarg = ijarg + 1
     CASE ( '-s'   ) ; CALL getarg (ijarg,cf_sfil ) ; ijarg = ijarg + 1
        ! options
     CASE ( '-nc4' ) ; lnc4 = .TRUE.
     CASE ( '-o'   ) ; CALL getarg (ijarg,cf_out  ) ; ijarg = ijarg + 1
     CASE DEFAULT    ; PRINT *,' ERROR : ',TRIM(cldum) ,' :  unknown option.' ; STOP 99
     END SELECT
  ENDDO

  IF ( cf_sfil == 'none' ) cf_sfil=cf_tfil

  IF ( chkfile(cf_tfil) .OR. chkfile(cn_fzgr) .OR. chkfile(cf_sfil)  ) STOP 99 ! missing file

  ! read dimensions 
  npiglo = getdim (cf_tfil,cn_x)
  npjglo = getdim (cf_tfil,cn_y)
  npk    = getdim (cf_tfil,cn_z)
  npt    = getdim (cf_tfil,cn_t)

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  ALLOCATE (rtem  (npiglo,npjglo), rsal  (npiglo,npjglo), rho  (npiglo,npjglo)    )
  ALLOCATE (rtem10(npiglo,npjglo), rsal10(npiglo,npjglo), rho10(npiglo,npjglo)    )

  ALLOCATE (hmlp1(npiglo,npjglo), hmlp2(npiglo,npjglo), hmlt(npiglo,npjglo)       )
  ALLOCATE (hmlp3(npiglo,npjglo), hmlp4(npiglo,npjglo)                            ) 
  ALLOCATE (hmlt2(npiglo,npjglo), hmlt3(npiglo,npjglo)                            )

  ALLOCATE (nmln1 (npiglo,npjglo), nmln2 (npiglo,npjglo), nmlnt(npiglo,npjglo)    )
  ALLOCATE (nmln3 (npiglo,npjglo), nmln4 (npiglo,npjglo)                          )
  ALLOCATE (nmlnt2(npiglo,npjglo), nmlnt3(npiglo,npjglo)                          )  

  ALLOCATE (tmask(npiglo,npjglo), tmask_surf(npiglo,npjglo), tmask_10(npiglo,npjglo))
  ALLOCATE (rho_surf(npiglo,npjglo), tem_surf(npiglo,npjglo)                )
  ALLOCATE (mbathy(npiglo,npjglo)                                           )
  ALLOCATE (gdepw(0:npk), gdept(npk), dtim(npt)                              )

  ! read mbathy and gdepw use real rtem(:,:) as template (getvar is used for real only)
  IF ( chkfile( cn_fbathylev,ld_verbose=.FALSE.)  ) THEN
     PRINT *, 'Read mbathy in ', TRIM(cn_fzgr),' ...'
     rtem(:,:) = getvar(cn_fzgr,      'mbathy',    1, npiglo, npjglo)
  ELSE
     PRINT *, 'Read mbathy in ', TRIM(cn_bathylev),' ...'
     rtem(:,:) = getvar(cn_fbathylev, cn_bathylev, 1, npiglo, npjglo)
  ENDIF

  mbathy(:,:)  = rtem(:,:)
  gdepw(0)     = 99999. ! dummy value, always masked -but eventually accessed on land-
  gdepw(1:npk) = getvare3(cn_fzgr, cn_gdepw, npk)
  gdept(:)     = getvare3(cn_fzgr, cn_gdept, npk)

  ! find the T-reference level for 10m (F.Hernandez)
  nkref10 = MINLOC(gdept,gdept>=10.) - 1 ;  IF ( nkref10(1) < 1 ) nkref10(1)=1

  ! coef for linear interpolation of T at 10m between nkref10 and nkref10+1
  rr1 = (10. - gdept(nkref10(1)+1) ) / (gdept(nkref10(1))-gdept(nkref10(1)+1))
  rr2 = (gdept(nkref10(1)) - 10.   ) / (gdept(nkref10(1))-gdept(nkref10(1)+1))

  ! find W levels for later computation
  nkref10 = MINLOC(gdepw(1:npk),gdepw(1:npk)>=10)-1 ;  IF ( nkref10(1) < 1 ) nkref10(1)=1

  CALL CreateOutput

  DO jt=1,npt

     ! read T/S levels around 10m and interpolate 
     rtem  (:,:) = getvar(cf_tfil, cn_votemper, nkref10(1),   npiglo, npjglo, ktime=jt )
     rtem10(:,:) = getvar(cf_tfil, cn_votemper, nkref10(1)+1, npiglo, npjglo, ktime=jt )
     WHERE ( rtem == rmisval ) rtem10 = rmisval
     WHERE ( .NOT. (rtem10 == rmisval) ) rtem10 = rtem*rr1 + rtem10*rr2

     rsal  (:,:) = getvar(cf_sfil, cn_vosaline, nkref10(1),   npiglo, npjglo, ktime=jt )
     rsal10(:,:) = getvar(cf_sfil, cn_vosaline, nkref10(1)+1, npiglo, npjglo, ktime=jt )
     WHERE ( rsal == rmisval ) rsal10 = rmisval
     WHERE ( .NOT. (rsal10 == rmisval) ) rsal10 = rsal*rr1 + rsal10*rr2

     ! read surface T/S
     rtem(:,:) = getvar(cf_tfil, cn_votemper, 1, npiglo, npjglo, ktime=jt )
     rsal(:,:) = getvar(cf_sfil, cn_vosaline, 1, npiglo, npjglo, ktime=jt )

     ! .. and deduce land-mask from salinity 
     ! ... modified to take into account fill_value = 32767 F.Hernandez 
     IF (jt == 1 ) THEN
        ! For surface criteria
        tmask(:,:) = 1.
        WHERE ( rsal == 0. .OR. rsal == rmisval .OR. rtem == rmisval ) tmask = 0.
        tmask_surf(:,:) = tmask(:,:)

        ! For 10m depth criteria (F. Hernandez)
        tmask(:,:) = 1.
        WHERE ( rsal10 == 0. .OR. rsal10 == rmisval .OR. rtem10 == rmisval) tmask = 0.
        tmask_10(:,:) = tmask(:,:)
     ENDIF

     ! compute rho_surf
     rho_surf(:,:) = sigma0 (rtem, rsal, npiglo, npjglo )* tmask_surf(:,:)
     tem_surf(:,:) = rtem(:,:)

     ! compute rho at 10m-depth
     rho10(:,:) = sigma0 (rtem10, rsal10, npiglo, npjglo )* tmask_10(:,:)

     ! Initialization to the number of w ocean point mbathy
     nmln1(:,:) = mbathy(:,:)
     nmln2(:,:) = mbathy(:,:)
     nmln3(:,:) = mbathy(:,:)  
     nmln4(:,:) = mbathy(:,:)  
     nmlnt(:,:) = mbathy(:,:)
     nmlnt2(:,:) = mbathy(:,:) 
     nmlnt3(:,:) = mbathy(:,:) 

     ! compute mixed layer depth
     ! Last w-level at which rhop>=rho surf+rho_c (starting from jpk-1)
     ! (rhop defined at t-point, thus jk-1 for w-level just above)
     DO jk = npk-1, 2, -1
        rtem (:,:) = getvar(cf_tfil, cn_votemper, jk ,npiglo, npjglo, ktime=jt)
        rsal (:,:) = getvar(cf_sfil, cn_vosaline, jk ,npiglo, npjglo, ktime=jt)
        tmask(:,:) = 1. ! take into account missing values 32767 
        WHERE ( rsal == 0. .OR. rsal >= rmisval .OR. rtem == rmisval ) tmask = 0.
        rho  (:,:) = sigma0 (rtem, rsal, npiglo, npjglo )* tmask(:,:)

        DO jj = 1, npjglo
           DO ji = 1, npiglo
              IF( rho(ji,jj)  > rho_surf(ji,jj) + rho_c1 )   nmln1(ji,jj) = jk
              IF( rho(ji,jj)  > rho_surf(ji,jj) + rho_c2 )   nmln2(ji,jj) = jk
              IF( ABS(rtem(ji,jj) - tem_surf(ji,jj)) > ABS( temp_c)  )   nmlnt(ji,jj) = jk
           END DO
        END DO

        ! Compute with the 10m depth reference: stop if level < nkref10+1 (F.Hernandez)
        IF ( jk > nkref10(1) ) THEN
           DO jj = 1, npjglo
              DO ji = 1, npiglo
                 IF( rho(ji,jj)  > rho10(ji,jj) + rho_c2 )   nmln3(ji,jj) = jk
                 IF( rho(ji,jj)  > rho10(ji,jj) + rho_c3 )   nmln4(ji,jj) = jk
                 IF( ABS(rtem(ji,jj) - rtem10(ji,jj)) > ABS( temp_c)  )   nmlnt2(ji,jj) = jk
                 IF( ABS(rtem(ji,jj) - rtem10(ji,jj)) > ABS( temp_c2)  )   nmlnt3(ji,jj) = jk
              END DO
           END DO
        ENDIF

     END DO

     ! Mixed layer depth
     DO jj = 1, npjglo
        DO ji = 1, npiglo
           ik1 = nmln1(ji,jj) ; ik2 = nmln2(ji,jj) ; ikt = nmlnt(ji,jj)
           hmlp1 (ji,jj) = gdepw(ik1) * tmask_surf(ji,jj)
           hmlp2 (ji,jj) = gdepw(ik2) * tmask_surf(ji,jj)
           hmlp3 (ji,jj) = gdepw(nmln3(ji,jj)) * tmask_10(ji,jj)  
           hmlp4 (ji,jj) = gdepw(nmln4(ji,jj)) * tmask_10(ji,jj)            
           hmlt (ji,jj)  = gdepw(ikt) * tmask_surf(ji,jj)
           hmlt2 (ji,jj) = gdepw(nmlnt2(ji,jj)) * tmask_10(ji,jj) 
           hmlt3 (ji,jj) = gdepw(nmlnt3(ji,jj)) * tmask_10(ji,jj) 
        END DO
     END DO

     ! Correct for missing values = 32767 
     WHERE ( tmask_surf == 0. )
        hmlp1 = rmisval ; hmlp2 = rmisval ; hmlt = rmisval
     END WHERE
     WHERE ( tmask_10 == 0. )
        hmlp3 = rmisval ; hmlp4 = rmisval ; hmlt2 = rmisval ; hmlt3 = rmisval
     END WHERE

     ierr = putvar(ncout, id_varout(1), hmlp1, 1, npiglo, npjglo, ktime=jt)
     ierr = putvar(ncout, id_varout(2), hmlp2, 1, npiglo, npjglo, ktime=jt)
     ierr = putvar(ncout, id_varout(3), hmlt , 1, npiglo, npjglo, ktime=jt)
     ierr = putvar(ncout, id_varout(4), hmlt2, 1, npiglo, npjglo, ktime=jt) 
     ierr = putvar(ncout, id_varout(5), hmlt3, 1, npiglo, npjglo, ktime=jt) 
     ierr = putvar(ncout, id_varout(6), hmlp3, 1, npiglo, npjglo, ktime=jt) 
     ierr = putvar(ncout, id_varout(7), hmlp4, 1, npiglo, npjglo, ktime=jt) 

  END DO ! time loop

  ierr = closeout(ncout)

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    rdep(1) = 0.

    DO ji = 1, jp_varout
       stypvar(ji)%ichunk = (/npiglo, MAX(1,npjglo/30), 1, 1 /)
    ENDDO

    ipk(:)                    = 1
    stypvar(1)%cname          = 'somxl010'
    stypvar(2)%cname          = 'somxl030'
    stypvar(3)%cname          = 'somxlt02'
    stypvar(4)%cname          = 'somxlt02z10' 
    stypvar(5)%cname          = 'somxlt05z10'
    stypvar(6)%cname          = 'somxl030z10'
    stypvar(7)%cname          = 'somxl125z10'
    stypvar%cunits            = 'm'
    stypvar%rmissing_value    = rmisval  ! to be compliant with Mercator standards
    stypvar%valid_min         = 0.
    stypvar%valid_max         = 7000.
    stypvar(1)%clong_name     = 'Mixed_Layer_Depth_on_0.01_rho_crit'
    stypvar(2)%clong_name     = 'Mixed_Layer_Depth_on_0.03_rho_crit'
    stypvar(3)%clong_name     = 'Mixed_Layer_Depth_on_-0.2_temp_crit'
    stypvar(4)%clong_name     = 'Mixed_Layer_Depth_on_-0.2_temp_crit ref. 10m'
    stypvar(5)%clong_name     = 'Mixed_Layer_Depth_on_-0.5_temp_crit ref. 10m'
    stypvar(6)%clong_name     = 'Mixed_Layer_Depth_on_0.03_rho_crit ref. 10m'
    stypvar(7)%clong_name     = 'Mixed_Layer_Depth_on_0.125_rho_crit ref. 10m'
    stypvar(1)%cshort_name    = 'somxl010'
    stypvar(2)%cshort_name    = 'somxl030'
    stypvar(3)%cshort_name    = 'somxlt02'
    stypvar(4)%cshort_name    = 'ILD02z10'
    stypvar(5)%cshort_name    = 'ILD05z10'
    stypvar(6)%cshort_name    = 'MLD030z10'
    stypvar(7)%cshort_name    = 'MLD125z10'
    stypvar%conline_operation = 'N/A'
    stypvar%caxis             = 'TYX'

    ncout = create      (cf_out, cf_tfil, npiglo, npjglo, 1             , ld_nc4=lnc4 )
    ierr  = createvar   (ncout,  stypvar, jp_varout,      ipk, id_varout, ld_nc4=lnc4 )
    ierr  = putheadervar(ncout,  cf_tfil, npiglo, npjglo, 1, pdep=rdep)

    dtim = getvar1d(cf_tfil, cn_vtimec, npt     )
    ierr = putvar1d(ncout,  dtim,       npt, 'T')

  END SUBROUTINE CreateOutput

END PROGRAM cdfmxl

PROGRAM cdfvT
  !!======================================================================
  !!                     ***  PROGRAM  cdfvT  ***
  !!=====================================================================
  !!  ** Purpose : Compute the average values for the products 
  !!               V.T, V.S, U.T and U.S, used afterward for heat and
  !!               salt transport.
  !!
  !!  ** Method  : pass the CONFIG name and a series of tags as arguments.
  !!
  !! History : 2.1  : 11/2004  : J.M. Molines : Original code
  !!           2.1  : 02/2010  : J.M. Molines : handle multiframes input files.
  !!           3.0  : 04/2011  : J.M. Molines : Doctor norm + Lic.
  !!                : 10/2012  : M. Balmaseda : Split T and S file eventually
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  USE modutils       ! SetFileName function
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: ji, jj, jk, jt, jtt  ! dummy loop index
  INTEGER(KIND=4)                           :: ierr                 ! working integer
  INTEGER(KIND=4)                           :: narg, iargc          ! command line
  INTEGER(KIND=4)                           :: npiglo,npjglo        ! size of the domain
  INTEGER(KIND=4)                           :: npk, npt             ! size of the domain
  INTEGER(KIND=4)                           :: ntframe              ! Cumul of time frame
  INTEGER(KIND=4)                           :: ncout                ! ncid of output file
  INTEGER(KIND=4), DIMENSION(4)             :: ipk, id_varout       ! level and varid's of output vars

  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: ztemp, zsal          ! Array to read a layer of data
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zu, zv               ! Velocity component
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zworku, zworkv       ! working arrays
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zmean                ! temporary mean value for netcdf write
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: tim                  ! time counter of individual files
  REAL(KIND=4), DIMENSION(1)                :: timean               ! mean time

  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dcumulut, dcumulus   ! Arrays for cumulated values
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dcumulvt, dcumulvs   ! Arrays for cumulated values
  REAL(KIND=8)                              :: dtotal_time          ! cumulated time

  CHARACTER(LEN=256)                        :: cf_tfil              ! T file name
  CHARACTER(LEN=256)                        :: cf_sfil              ! S file name [default: idem T file]
  CHARACTER(LEN=256)                        :: cf_ufil              ! zonal velocity file
  CHARACTER(LEN=256)                        :: cf_vfil              ! meridional velocity file
  CHARACTER(LEN=256)                        :: cf_out='vt.nc'       ! output file
  CHARACTER(LEN=256)                        :: config               ! configuration name
  CHARACTER(LEN=256)                        :: ctag                 ! current tag to work with               

  TYPE (variable), DIMENSION(4)             :: stypvar              ! structure for attributes

  LOGICAL                                   :: lcaltmean            ! flag for mean time computation
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  !!  Read command line
  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfvT CONFIG-CASE ''list_of_tags'' '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the time average values for second order products ' 
     PRINT *,'       V.T, V.S, U.T and U.S used in heat and salt transport computation.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       CONFIG-CASE is the config name of a given experiment (eg ORCA025-G70)'
     PRINT *,'            The program will look for gridT, gridU and gridV files for' 
     PRINT *,'            this config ( grid_T, grid_U and grid_V are also accepted).'
     PRINT *,'            Additionaly, if gridS or grid_S file is found, it will be taken'
     PRINT *,'            in place of gridT for the salinity variable.'
     PRINT *,'       list_of_tags : a list of time tags that will be used for time'
     PRINT *,'            averaging. e.g. y2000m01d05 y2000m01d10 ...'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        none'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'       variables : ',TRIM(cn_vozout),', ',TRIM(cn_vozous),', ',TRIM(cn_vomevt),' and ',TRIM(cn_vomevs)
     STOP
  ENDIF

  !! Initialisation from 1st file (all file are assume to have the same geometry)
  CALL getarg (1, config)
  CALL getarg (2, ctag  )

  cf_tfil = SetFileName( config, ctag, 'T')

  npiglo = getdim (cf_tfil,cn_x)
  npjglo = getdim (cf_tfil,cn_y)
  npk    = getdim (cf_tfil,cn_z)

  ipk(:)= npk  ! all variables (input and output are 3D)
  ! define output variables
  stypvar%rmissing_value    = 0.
  stypvar%valid_min         = -100.
  stypvar%valid_max         = 100.
  stypvar%conline_operation = 'N/A'
  stypvar%caxis             = 'TZYX'

  stypvar(1)%cname          = cn_vomevt       ; stypvar(1)%cunits        = 'm.DegC.s-1'
  stypvar(2)%cname          = cn_vomevs       ; stypvar(2)%cunits        = 'm.PSU.s-1'
  stypvar(3)%cname          = cn_vozout       ; stypvar(3)%cunits        = 'm.DegC.s-1'
  stypvar(4)%cname          = cn_vozous       ; stypvar(4)%cunits        = 'm.PSU.s-1'

  stypvar(1)%clong_name     = 'Meridional_VT' ; stypvar(1)%cshort_name   = cn_vomevt
  stypvar(2)%clong_name     = 'Meridional_VS' ; stypvar(2)%cshort_name   = cn_vomevs
  stypvar(3)%clong_name     = 'Zonal_UT'      ; stypvar(3)%cshort_name   = cn_vozout
  stypvar(4)%clong_name     = 'Zonal_US'      ; stypvar(4)%cshort_name   = cn_vozous

  PRINT *, 'npiglo =', npiglo
  PRINT *, 'npjglo =', npjglo
  PRINT *, 'npk    =', npk

  ALLOCATE( dcumulut(npiglo,npjglo), dcumulus(npiglo,npjglo) )
  ALLOCATE( dcumulvt(npiglo,npjglo), dcumulvs(npiglo,npjglo) )
  ALLOCATE( zu(npiglo,npjglo),    zv(npiglo,npjglo) )
  ALLOCATE( zworku(npiglo,npjglo),   zworkv(npiglo,npjglo) )
  ALLOCATE( ztemp(npiglo,npjglo),    zsal(npiglo,npjglo) )
  ALLOCATE( zmean(npiglo,npjglo))

  ! create output fileset
  ncout = create      (cf_out, cf_tfil, npiglo, npjglo, npk, ld_xycoo=.TRUE. )
  ierr  = createvar   (ncout , stypvar, 4,      ipk,    id_varout            )
  ierr  = putheadervar(ncout,  cf_tfil, npiglo, npjglo, npk, ld_xycoo=.TRUE. )
  
  lcaltmean=.TRUE.
  DO jk = 1, npk
     PRINT *,'level ',jk
     dcumulut(:,:) = 0.d0 ;  dcumulvt(:,:) = 0.d0 ; dtotal_time = 0.d0
     dcumulus(:,:) = 0.d0 ;  dcumulvs(:,:) = 0.d0 ; ntframe = 0

     DO jt = 2, narg           ! loop on tags
        CALL getarg (jt, ctag)

        cf_tfil = SetFileName( config, ctag, 'T', ld_stop=.TRUE. )
        cf_sfil = SetFileName( config, ctag, 'S', ld_stop=.FALSE.)      ! do not stop if gridS/grid_S not found !
        IF ( chkfile (cf_sfil, ld_verbose=.FALSE.) ) cf_sfil = cf_tfil  ! do not complain if not found

        npt = getdim (cf_tfil, cn_t)
        IF ( lcaltmean ) THEN
           ALLOCATE ( tim(npt) )
           tim = getvar1d(cf_tfil, cn_vtimec, npt)
           dtotal_time = dtotal_time + SUM(tim(1:npt) )
           DEALLOCATE( tim )
        END IF

        ! assume U and V file have same time span ...
        cf_ufil = SetFileName( config, ctag, 'U' )
        cf_vfil = SetFileName( config, ctag, 'V' )

        DO jtt = 1, npt  ! loop on time frame in a single file
           ntframe = ntframe+1
           zu(:,:)    = getvar(cf_ufil, cn_vozocrtx, jk, npiglo, npjglo, ktime=jtt )
           zv(:,:)    = getvar(cf_vfil, cn_vomecrty, jk, npiglo, npjglo, ktime=jtt )
           ztemp(:,:) = getvar(cf_tfil, cn_votemper, jk, npiglo, npjglo, ktime=jtt )
           zsal(:,:)  = getvar(cf_sfil, cn_vosaline, jk, npiglo, npjglo, ktime=jtt )

           ! temperature at u point, v points
           zworku(:,:) = 0. ; zworkv(:,:) = 0.
           DO ji=1, npiglo-1
              DO jj = 1, npjglo -1
                 zworku(ji,jj) = 0.5 * ( ztemp(ji,jj) + ztemp(ji+1,jj) )  ! temper at Upoint
                 zworkv(ji,jj) = 0.5 * ( ztemp(ji,jj) + ztemp(ji,jj+1) )  ! temper at Vpoint
              END DO
           END DO

           dcumulut(:,:) = dcumulut(:,:) + zworku(:,:) * zu(:,:)*1.d0
           dcumulvt(:,:) = dcumulvt(:,:) + zworkv(:,:) * zv(:,:)*1.d0

           ! salinity at u points, v points
           zworku(:,:) = 0. ; zworkv(:,:) = 0.
           DO ji=1, npiglo-1
              DO jj = 1, npjglo -1
                 zworku(ji,jj) = 0.5 * ( zsal(ji,jj) + zsal(ji+1,jj) )  ! salinity  at Upoint
                 zworkv(ji,jj) = 0.5 * ( zsal(ji,jj) + zsal(ji,jj+1) )  ! salinity  at Vpoint
              END DO
           END DO

           dcumulus(:,:) = dcumulus(:,:) + zworku(:,:) * zu(:,:)*1.d0
           dcumulvs(:,:) = dcumulvs(:,:) + zworkv(:,:) * zv(:,:)*1.d0

        END DO  !jtt
     END DO  ! jt
     ! finish with level jk ; compute mean (assume spval is 0 )
     zmean(:,:) = dcumulvt(:,:)/ntframe
     ierr = putvar(ncout, id_varout(1), zmean, jk,npiglo, npjglo, kwght=ntframe )

     zmean(:,:) = dcumulvs(:,:)/ntframe
     ierr = putvar(ncout, id_varout(2), zmean, jk,npiglo, npjglo, kwght=ntframe )

     zmean(:,:) = dcumulut(:,:)/ntframe
     ierr = putvar(ncout, id_varout(3), zmean, jk,npiglo, npjglo, kwght=ntframe )

     zmean(:,:) = dcumulus(:,:)/ntframe
     ierr = putvar(ncout, id_varout(4), zmean, jk,npiglo, npjglo, kwght=ntframe )

     IF (lcaltmean )  THEN
        timean(1) = dtotal_time/ntframe
        ierr      = putvar1d(ncout, timean, 1, 'T')
     END IF
     lcaltmean=.FALSE. ! tmean already computed

  END DO  ! loop to next level

  ierr = closeout(ncout)

END PROGRAM cdfvT

PROGRAM cdfmaxmoc
  !!======================================================================
  !!                     ***  PROGRAM  cdfmaxmoc  ***
  !!=====================================================================
  !!  ** Purpose : Compute the maximum of the overturning fonction from 
  !!               a file calculated by cdfmoc
  !!
  !!  ** Method  : A spatial window, limited by latmin latmax depmin depmax
  !!               given on the command line, is used to determnine the 
  !!               maximum and minimum of the MOC as well as their 
  !!               respective depth and latitude. 
  !!
  !! History : 2.1  : 07/2005  : J.M. Molines : Original code
  !!                : 11/2009  : R. Dussin    : Netcdf output
  !!           3.0  : 03/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE
  !
  INTEGER(KIND=4)                             :: jj, jk            ! dummy loop index
  INTEGER(KIND=4)                             :: npjglo, npk       ! size of the overturning
  INTEGER(KIND=4)                             :: narg, iargc       ! line command stuff
  INTEGER(KIND=4)                             :: iarg              ! line command stuff
  INTEGER(KIND=4)                             :: ijmin, ijmax      ! latitude window where to look at extrema
  INTEGER(KIND=4)                             :: ikmin, ikmax      ! depth window where to look at extrema
  INTEGER(KIND=4)                             :: ilatmin, ilatmax  ! index of found extrema (latitude)
  INTEGER(KIND=4)                             :: idepmin, idepmax  ! index of found extrema (depth )
  INTEGER(KIND=4)                             :: nx=1, ny=1, nz=1  ! dims of netcdf output file
  INTEGER(KIND=4)                             :: nvarout=6         ! number of values to write in cdf output
  INTEGER(KIND=4)                             :: ncout, ierr       ! for netcdf output
  INTEGER(KIND=4), DIMENSION(3)               :: iminloc, imaxloc  ! work arrays for minloc and maxloc
  INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE  :: ipk, id_varout    ! netcdf output
  !
  REAL(KIND=4)                                :: ovtmax, ovtmin    ! max/ min of MOC ( Sv)
  REAL(KIND=4)                                :: rlatmin, rlatmax  ! latitude limits for searching
  REAL(KIND=4)                                :: rdepmin, rdepmax  ! depth limits for searching
  REAL(KIND=4), DIMENSION(1)                  :: tim               ! time counter
  REAL(KIND=4), DIMENSION(:),     ALLOCATABLE :: gdepw             ! depth read in the header
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: rdumlon, rdumlat  ! dummy array for output
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: rlat              ! latitude (1, npjglo)
  REAL(KIND=4), DIMENSION(:,:,:), ALLOCATABLE :: rmoc              ! MOC (1, npjglo, jpk)
  !
  TYPE(variable), DIMENSION(:),   ALLOCATABLE :: stypvar           ! structure of output
  !
  CHARACTER(LEN=256)                          :: cf_moc            ! input file 
  CHARACTER(LEN=256)                          :: cf_ncout='maxmoc.nc' ! output file
  CHARACTER(LEN=256)                          :: cldum             ! dummy string for I/O
  CHARACTER(LEN=256)                          :: cbasin, cv_in     ! basin name and cdf variable name
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()
  narg=iargc()
  
  IF ( narg /= 6 ) THEN
     PRINT *,' usage : cdfmaxmoc OVT-file basin_name latmin latmax depmin depmax'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'        Compute the maximum and minimum of the overturning, from file OVT-file,' 
     PRINT *,'        for oceanic basin specified by cbasin, and in the geographical frame '
     PRINT *,'        defined by latmin latmax, depmin, depmax.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       OVT-file   : overturning file from cdfmoc, with or w/o sub basins.' 
     PRINT *,'       basin_name : name of oceanic subbasin as defined in ',TRIM(cn_fbasins)
     PRINT *,'                usually it can be one of atl, glo, inp, ind or pac'
     PRINT *,'                glo means no subbasins.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        none'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_ncout) 
     PRINT *,'         6 variables : '
     PRINT *,'            maxmoc, minmoc ( sv )      : max and min of overturning'
     PRINT *,'            latmaxmoc latminmoc ( deg) : latitudes of max and min.'
     PRINT *,'            depmaxmoc depminmoc ( m)   : depth of max amd min .'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'       cdfmoc '
     PRINT *,'      '
     STOP
  ENDIF

  CALL getarg(1, cf_moc)                          ! input moc file
  CALL getarg(2, cbasin)                          ! basin name
  CALL getarg(3, cldum ) ; READ(cldum,*) rlatmin  ! searching window : latmin
  CALL getarg(4, cldum ) ; READ(cldum,*) rlatmax  ! searching window : latmax
  CALL getarg(5, cldum ) ; READ(cldum,*) rdepmin  ! searching window : depth min
  CALL getarg(6, cldum ) ; READ(cldum,*) rdepmax  ! searching window : depth max
  
  IF ( chkfile(cf_moc) ) STOP 99 ! missing file

  npjglo = getdim(cf_moc, cn_y)
  npk    = getdim(cf_moc, cn_z)

  ALLOCATE ( rmoc(1,npjglo,npk), gdepw(npk), rlat(1,npjglo))
  gdepw(:)  = -getvar1d(cf_moc, cn_vdepthw,  npk         )
  rlat(:,:) =  getvar  (cf_moc, cn_vlat2d,   1, 1, npjglo)

  SELECT CASE (cbasin)
  CASE ('atl') ; cv_in=cn_zomsfatl
  CASE ('glo') ; cv_in=cn_zomsfglo
  CASE ('pac') ; cv_in=cn_zomsfpac
  CASE ('inp') ; cv_in=cn_zomsfinp
  CASE ('ind') ; cv_in=cn_zomsfind
  CASE DEFAULT ; PRINT *, 'basin not found' ; STOP 99
  END SELECT

  ALLOCATE ( stypvar(nvarout), ipk(nvarout), id_varout(nvarout) )
  ALLOCATE ( rdumlon(1,1) , rdumlat(1,1) )

  rdumlon(:,:)=0.
  rdumlat(:,:)=0.

  DO jj=1,nvarout
     ipk(jj)=1
  ENDDO

  ! define new variables for output 
  ! all variables :
  stypvar%rmissing_value    = 99999.
  stypvar%scale_factor      = 1.
  stypvar%add_offset        = 0.
  stypvar%savelog10         = 0.
  stypvar%conline_operation = 'N/A'
  stypvar%caxis             = 'T'

  ! each pair of variables
  stypvar(1)%cname          = 'maxmoc'                         ; stypvar(2)%cname          = 'minmoc'
  stypvar(1)%clong_name     = 'Maximum_Overturing'             ; stypvar(2)%clong_name     = 'Minimum_Overtuning'
  stypvar(1)%cshort_name    = 'maxmoc'                         ; stypvar(2)%cshort_name    = 'minmoc'
  stypvar(1:2)%cunits       = 'Sverdrup'
  stypvar(1:2)%valid_min    = -1000. 
  stypvar(1:2)%valid_max    =  1000.

  stypvar(3)%cname          = 'latmaxmoc'                      ; stypvar(4)%cname          = 'latminmoc'
  stypvar(3)%clong_name     = 'Latitude_of_Maximum_Overturing' ; stypvar(4)%clong_name     = 'Latitude_of_Minimum_Overtuning'
  stypvar(3)%cshort_name    = 'latmaxmoc'                      ; stypvar(4)%cshort_name    = 'latminmoc'
  stypvar(3:4)%cunits       = 'Degrees'
  stypvar(3:4)%valid_min    = -90.
  stypvar(3:4)%valid_max    = 90.

  stypvar(5)%cname          = 'depthmaxmoc'                    ; stypvar(6)%cname          = 'depthminmoc'
  stypvar(5)%clong_name     = 'Depth_of_Maximum_Overturing'    ; stypvar(6)%clong_name     = 'Depth_of_Minimum_Overtuning'
  stypvar(5)%cshort_name    = 'depthmaxmoc'                    ; stypvar(6)%cshort_name    = 'depthminmoc'
  stypvar(5:6)%cunits       = 'Meters'
  stypvar(5:6)%valid_min    = -10000.
  stypvar(5:6)%valid_max    = 0.

  DO jk=1,npk
     rmoc(:,:,jk) = getvar(cf_moc, cv_in, jk, 1, npjglo)
  END DO

  ! define window in index limit
  ! look for ijmin-ijmax :
  DO jj=1, npjglo
     IF ( rlat(1,jj) <= rlatmin )  ijmin = jj
     IF ( rlat(1,jj) <= rlatmax )  ijmax = jj
  END DO

  ! look for ikmin ikmax
  DO jk=1,npk
     IF ( gdepw(jk) <= rdepmin ) ikmin = jk
     IF ( gdepw(jk) <= rdepmax ) ikmax = jk
  END DO

  ! look for max/min overturning
  ovtmax = MAXVAL(rmoc(1,ijmin:ijmax,ikmin:ikmax))
  ovtmin = MINVAL(rmoc(1,ijmin:ijmax,ikmin:ikmax))

  ! find location of min/max
  iminloc =MINLOC(rmoc(:,ijmin:ijmax,ikmin:ikmax))
  imaxloc =MAXLOC(rmoc(:,ijmin:ijmax,ikmin:ikmax))

  ! results from minloc/maxloc is relative to the sub -array given as arguments
  ilatmin = iminloc(2) + ijmin -1 ; ilatmax = imaxloc(2) + ijmin -1
  idepmin = iminloc(3) + ikmin -1 ; idepmax = imaxloc(3) + ikmin -1

  PRINT *,' Maximum ', ovtmax ,' Sv latitude ', rlat(1,ilatmax),' depth = ', gdepw(idepmax)
  PRINT *,' Minimum ', ovtmin ,' Sv latitude ', rlat(1,ilatmin),' depth = ', gdepw(idepmin)

  ! create output fileset
  ncout = create      (cf_ncout, 'none',  nx,      ny,  nz,      cdep=cn_vdepthw )
  ierr  = createvar   (ncout,    stypvar, nvarout, ipk, id_varout                )

  ierr  = putheadervar(ncout,    cf_moc,  nx,      ny,  nz,      &
                        pnavlon=rdumlon, pnavlat=rdumlat,   pdep=gdepw           )
               
  tim  = getvar1d(cf_moc,cn_vtimec, 1     )
  ierr = putvar1d(ncout, tim,       1, 'T')

  ! netcdf output 
  ierr = putvar0d(ncout,id_varout(1), REAL(ovtmax) )
  ierr = putvar0d(ncout,id_varout(2), REAL(ovtmin) )
  ierr = putvar0d(ncout,id_varout(3), REAL(rlat(1,ilatmax)) )
  ierr = putvar0d(ncout,id_varout(4), REAL(rlat(1,ilatmin)) )
  ierr = putvar0d(ncout,id_varout(5), REAL(gdepw(idepmax)) )
  ierr = putvar0d(ncout,id_varout(6), REAL(gdepw(idepmin)) )

  ierr = closeout(ncout)

END PROGRAM cdfmaxmoc

PROGRAM cdfbotpressure
   !!======================================================================
   !!                     ***  PROGRAM  cdfbotpressure  ***
   !!=====================================================================
   !!  ** Purpose : Compute bottom pressure from insitu density
   !!
   !!  ** Method  : Vertical integral of rho g dz
   !!               eventually takes into account the SSH, and full step
   !!
   !! History : 3.0  : 01/2013  : J.M. Molines   : Original code from cdfvint
   !!----------------------------------------------------------------------
   USE cdfio
   USE eos
   USE modcdfnames
   USE modutils
   !!----------------------------------------------------------------------
   !! CDFTOOLS_3.0 , MEOM 2012
   !! $Id$
   !! Copyright (c) 2012, J.-M. Molines
   !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
   !!----------------------------------------------------------------------
   IMPLICIT NONE

   INTEGER(KIND=4)                           :: jk, jt              ! dummy loop index
   INTEGER(KIND=4)                           :: ierr, ij, iko       ! working integer
   INTEGER(KIND=4)                           :: narg, iargc, ijarg  ! command line 
   INTEGER(KIND=4)                           :: npiglo, npjglo      ! size of the domain
   INTEGER(KIND=4)                           :: npk, npt            ! size of the domain
   INTEGER(KIND=4),             DIMENSION(1) :: ipk, id_varout      ! only one output variable
   INTEGER(KIND=4)                           :: ncout 

   REAL(KIND=4), PARAMETER                   :: pp_grav = 9.81      ! Gravity
   REAL(KIND=4), PARAMETER                   :: pp_rau0 = 1035.e0   ! Reference density (as in NEMO)
   REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e3t                 ! vertical metric
   REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: hdept               ! vertical metric
   REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zt                  ! Temperature
   REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zs                  ! Salinity
   REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: tmask               ! npiglo x npjglo
   REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: gdepw               ! depth
   REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: tim                 ! time counter
   REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: e31d                ! vertical metrics in case of full step

   REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dl_psurf            ! Surface pressure
   REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dl_bpres            ! Bottom pressure
   REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dl_sigi             ! insitu density

   CHARACTER(LEN=256)                        :: cf_in, cf_out       ! input/output file
   CHARACTER(LEN=256)                        :: cldum               ! dummy string for command line browsing
   CHARACTER(LEN=256)                        :: cglobal            ! Global attribute

   LOGICAL                                   :: lfull =.FALSE.      ! flag for full step computation
   LOGICAL                                   :: lssh  =.FALSE.      ! Use ssh and cst surf. density in the bot pressure
   LOGICAL                                   :: lssh2 =.FALSE.      ! Use ssh and variable surf.density in the bot pressure
   LOGICAL                                   :: lchk  =.FALSE.      ! flag for missing files

   TYPE(variable), DIMENSION(1)              :: stypvar             ! extension for attributes
   !!----------------------------------------------------------------------
   CALL ReadCdfNames()

   narg= iargc()
   IF ( narg == 0 ) THEN
      PRINT *,' usage : cdfbotpressure T-file [-full] [-ssh] [-ssh2 ] '
      PRINT *,'      '
      PRINT *,'     PURPOSE :'
      PRINT *,'          Compute the vertical bottom pressure (pa) from in situ density'
      PRINT *,'      '
      PRINT *,'     ARGUMENTS :'
      PRINT *,'         T-file : gridT file holding either Temperature and  salinity '
      PRINT *,'      '
      PRINT *,'     OPTIONS :'
      PRINT *,'        -full : for full step computation ' 
      PRINT *,'        -ssh  : Also take SSH into account in the computation'
      PRINT *,'                In this case, use rau0=',pp_rau0,' kg/m3 for '
      PRINT *,'                surface density (as in NEMO)'
      PRINT *,'                If you want to use 2d surface density from '
      PRINT *,'                the model, use option -ssh2'
      PRINT *,'        -ssh2 : as option -ssh but surface density is taken from '
      PRINT *,'                the model instead of a constant'
      PRINT *,'      '
      PRINT *,'     REQUIRED FILES :'
      PRINT *,'       ', TRIM(cn_fmsk),' and ', TRIM(cn_fzgr) 
      PRINT *,'      '
      PRINT *,'     OUTPUT : '
      PRINT *,'       netcdf file :  botpressure.nc'
      PRINT *,'         variables :  sobotpres'
      PRINT *,'      '
      PRINT *,'     SEE ALSO :'
      PRINT *,'        cdfvint'
      PRINT *,'      '
      STOP
   ENDIF

   ! browse command line
   ijarg = 1   ; ij = 0
   DO WHILE ( ijarg <= narg ) 
      CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1
      SELECT CASE ( cldum)
      CASE ( '-ssh'  ) ; lssh  = .TRUE. 
      CASE ( '-ssh2' ) ; lssh2 = .TRUE. 
      CASE ( '-full' ) ; lfull = .TRUE. 
      CASE DEFAULT     
         ij = ij + 1
         SELECT CASE ( ij)
         CASE ( 1 ) ; cf_in = cldum
         CASE DEFAULT ; PRINT *, ' ERROR: Too many arguments ! ' ; STOP
         END SELECT
      END SELECT
   END DO
   CALL SetGlobalAtt(cglobal)

   ! Security check
   lchk = chkfile ( cf_in   )
   lchk = chkfile ( cn_fmsk ) .OR. lchk
   lchk = chkfile ( cn_fzgr ) .OR. lchk
   IF ( lchk ) STOP ! missing files

   ! log information so far
   cf_out = 'botpressure.nc'

   npiglo = getdim (cf_in, cn_x )
   npjglo = getdim (cf_in, cn_y )
   npk    = getdim (cf_in, cn_z )
   npt    = getdim (cf_in, cn_t )

   PRINT *, ' NPIGLO = ', npiglo
   PRINT *, ' NPJGLO = ', npjglo
   PRINT *, ' NPK    = ', npk
   PRINT *, ' NPT    = ', npt

   ! Allocate arrays
   ALLOCATE ( tim(npt) )
   ALLOCATE ( tmask(npiglo,npjglo) )
   ALLOCATE ( zt(npiglo,npjglo)  )
   ALLOCATE ( zs(npiglo,npjglo)  )
   ALLOCATE ( e3t(npiglo,npjglo) )
   ALLOCATE ( hdept(npiglo,npjglo) )
   ALLOCATE ( e31d(npk)   )
   ALLOCATE ( gdepw(npk)) 

   ALLOCATE ( dl_bpres(npiglo, npjglo))
   ALLOCATE ( dl_psurf(npiglo, npjglo))
   ALLOCATE ( dl_sigi(npiglo, npjglo))

   ! prepare output variable
   ipk(:)                       = 1
   stypvar(1)%cname             = 'sobotpres'
   stypvar(1)%cunits            = 'Pascal'
   stypvar(1)%rmissing_value    = 0.
   stypvar(1)%valid_min         = 0
   stypvar(1)%valid_max         =  1.e15
   stypvar(1)%clong_name        = 'Bottom Pressure'
   stypvar(1)%cshort_name       = 'sobotpres'
   stypvar(1)%conline_operation = 'N/A'
   stypvar(1)%caxis             = 'TYX'

   ! Initialize output file
   gdepw(:) = getvare3(cn_fzgr, cn_gdepw, npk )
   e31d(:)  = getvare3(cn_fzgr, cn_ve3t,  npk )

   ncout = create      (cf_out, cf_in, npiglo, npjglo, 1                    )
   ierr  = createvar   (ncout, stypvar, 1, ipk, id_varout, cdglobal=cglobal )
   ierr  = putheadervar(ncout, cf_in,   npiglo, npjglo, 1                   )

   tim   = getvar1d    (cf_in, cn_vtimec, npt     )
   ierr  = putvar1d    (ncout, tim,       npt, 'T')

   PRINT *, 'Output files initialised ...'

   DO jt = 1, npt
      IF ( lssh ) THEN
        zt(:,:)       = getvar(cf_in, cn_sossheig, 1, npiglo, npjglo, ktime=jt )
        dl_psurf(:,:) = pp_grav * pp_rau0 * zt(:,:)
      ELSE IF ( lssh2 ) THEN 
         zt(:,:)    = getvar(cf_in,   cn_votemper, 1, npiglo, npjglo, ktime=jt )
         zs(:,:)    = getvar(cf_in,   cn_vosaline, 1, npiglo, npjglo, ktime=jt )
     
         dl_sigi(:,:) = 1000. + sigmai(zt, zs, 0., npiglo, npjglo)

         !  CAUTION : hdept is used for reading SSH in the next line
         hdept(:,:)   = getvar(cf_in, cn_sossheig, 1, npiglo, npjglo, ktime=jt )
        dl_psurf(:,:) = pp_grav * dl_sigi * hdept(:,:)
      ELSE
        dl_psurf(:,:)=0.d0
      ENDIF

      dl_bpres(:,:) = dl_psurf(:,:)

      DO jk = 1, npk
         tmask(:,:) = getvar(cn_fmsk, 'tmask',      jk, npiglo, npjglo           )
         hdept(:,:) = getvar(cn_fzgr, cn_hdept,     jk, npiglo, npjglo           )
         zt(:,:)    = getvar(cf_in,   cn_votemper,  jk, npiglo, npjglo, ktime=jt )
         zs(:,:)    = getvar(cf_in,   cn_vosaline,  jk, npiglo, npjglo, ktime=jt )
     
         dl_sigi(:,:) = 1000. + sigmai(zt, zs, hdept, npiglo, npjglo)
         IF ( lfull ) THEN ; e3t(:,:) = e31d(jk)
                      ELSE ; e3t(:,:) = getvar(cn_fzgr, 'e3t_ps', jk, npiglo, npjglo, ldiom=.TRUE.)
         ENDIF
         dl_bpres(:,:) = dl_bpres(:,:) + dl_sigi(:,:) * e3t(:,:) * pp_grav * 1.d0 * tmask(:,:) 

      END DO  ! loop to next level
         ierr = putvar(ncout, id_varout(1) ,REAL(dl_bpres), 1, npiglo, npjglo, ktime=jt)
   END DO  ! next time frame

   ierr = closeout(ncout)

END PROGRAM cdfbotpressure

PROGRAM cdfnrj_transfert
  !!======================================================================
  !!                     ***  PROGRAM  cdfnrj_transfert  ***
  !!=====================================================================
  !!  ** Purpose : Compute the term of energetic transfert from mean kinetic
  !!               energy to mean potential energy (T1) and from eddy 
  !!               potential energy to eddy kinetic energy (T3)
  !!
  !! History : 2.1  : 03/2008  : A. Melet     : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class energy_diagnostics
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                             :: jj, jk             ! dummy loop index
  INTEGER(KIND=4)                             :: npiglo, npjglo     ! size of the domain
  INTEGER(KIND=4)                             :: npk, npt           ! size of the domain
  INTEGER(KIND=4)                             :: narg, iargc, ijarg ! browse line
  INTEGER(KIND=4)                             :: ncout, ierr        ! ncid of outputfile, error status
  INTEGER(KIND=4), DIMENSION(2)               :: ipk, id_varout     ! levels and varid's of output vars

  REAL(KIND=4), DIMENSION(:,:,:), ALLOCATABLE :: wbartbar
  REAL(KIND=4), DIMENSION(:,:,:), ALLOCATABLE :: anowt 
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: t1mask
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: w1mask
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: txz
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: wxz 
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: wtxz
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: wbartbarxz
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: anowtxz

  REAL(KIND=8), DIMENSION(:),     ALLOCATABLE :: dtim               ! time counter (dummy)

  CHARACTER(LEN=256)                          :: cf_uvwtfil         ! input file
  CHARACTER(LEN=256)                          :: cf_out='trf_t1t3.nc' ! output file
  CHARACTER(LEN=256)                          :: cldum              ! working char variable

  TYPE  (variable), DIMENSION(2)              :: stypvar            ! structure for attibutes

  LOGICAL                                     :: lnc4 = .FALSE.     ! Use nc4 with chunking and deflation
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage :  cdfnrj_transfert -f UVWT-file [-o OUT-file] [-nc4]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       This program computes the energy transfert term from previously'
     PRINT *,'       computed high order moments (cdfuvwt). High order moments must'
     PRINT *,'       have been evaluated on a long enough period, in order to get '
     PRINT *,'       meaningfull statistics.'
     PRINT *,'       Note : this program was formerly named cdfkempemekeepe. (no idea of the'
     PRINT *,'       pronunciation :) ).'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -f UVWT-file : Input file is the output of cdfuvwt, holding the required'
     PRINT *,'             high order moments.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-o OUT-file] : Specify the output file name instead of ',TRIM(cf_out)
     PRINT *,'       [-nc4 ] : Use netcdf4 output with chunking and deflation level 1.'
     PRINT *,'             This option is effective only if cdftools are compiled with'
     PRINT *,'             a netcdf library supporting chunking and deflation.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       none' 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) ,' unless option -o is used.'
     PRINT *,'         variables : WT    : temporal mean of Wbar x Tbar at T point.'
     PRINT *,'                     anoWT : temporal mean of W''xT'' at T points.'
     PRINT *,'             units : 1000 x Celsius x m/s'
     PRINT *,'     SEE ALSO :'
     PRINT *,'      cdfuvwt, cdfnrj_bci, cdfnrj_bti, cdfnrj_components' 
     PRINT *,'      '
     STOP 
  ENDIF

  ijarg = 1 
  DO WHILE ( ijarg <= narg )
     CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-f'   ) ; CALL getarg(ijarg, cf_uvwtfil ) ; ijarg=ijarg+1
        ! option
     CASE ( '-o'   ) ; CALL getarg(ijarg, cf_out     ) ; ijarg=ijarg+1
     CASE ( '-nc4' ) ; lnc4 = .TRUE.
     CASE DEFAULT    ; PRINT *, ' ERROR : ', TRIM(cldum),' : unknown option.'; STOP 99
     END SELECT
  ENDDO

  IF (chkfile(cf_uvwtfil) ) STOP 99 ! missing file
  npiglo = getdim(cf_uvwtfil, cn_x)
  npjglo = getdim(cf_uvwtfil, cn_y)
  npk    = getdim(cf_uvwtfil, cn_z)
  npt    = getdim(cf_uvwtfil, cn_t)

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  ! Allocate the memory
  ALLOCATE ( wbartbar(  npiglo, npjglo, npk) )  ! 3D can be huge !
  ALLOCATE ( anowt(     npiglo, npjglo, npk) )  ! 3D can be huge
  ALLOCATE ( t1mask(    npiglo,npk) )
  ALLOCATE ( w1mask(    npiglo,npk) )
  ALLOCATE ( txz(       npiglo,npk) )
  ALLOCATE ( wxz(       npiglo,npk) )
  ALLOCATE ( wtxz(      npiglo,npk) )
  ALLOCATE ( anowtxz(   npiglo,npk) )
  ALLOCATE ( wbartbarxz(npiglo,npk) )  
  ALLOCATE ( dtim(npt)  )  

  CALL CreateOutput

  DO jj = 1, npjglo
     wbartbarxz(:,:) = 0.0
     anowtxz(:,:)    = 0.0
     wtxz(:,:)       = 0.0
     wxz(:,:)        = 0.0
     txz(:,:)        = 0.0

     txz( :,:) = getvarxz(cf_uvwtfil, 'tbar',  jj, npiglo, npk, kimin=1, kkmin=1, ktime=1)
     wxz( :,:) = getvarxz(cf_uvwtfil, 'wbar',  jj, npiglo, npk, kimin=1, kkmin=1, ktime=1)
     wtxz(:,:) = getvarxz(cf_uvwtfil, 'wtbar', jj, npiglo, npk, kimin=1, kkmin=1, ktime=1)

     DO jk=1, npk-1
        w1mask(:,jk) = wxz(:,jk) * wxz(:,jk+1)
        t1mask(:,jk) = txz(:,jk)
        WHERE ( w1mask(:,jk) /= 0.) w1mask(:,jk)=1.
        WHERE ( t1mask(:,jk) /= 0.) t1mask(:,jk)=1. 
        wbartbarxz(:,jk) = 1000. * t1mask(:,jk) * txz(:,jk) * 0.5 * w1mask(:,jk) * ( wxz(:,jk) + wxz(:,jk+1) )
        anowtxz(   :,jk) = 1000. * ( wtxz(:,jk) - wbartbarxz(:,jk)*0.001 )      
     END DO
     wbartbar(:,jj,:) = wbartbarxz(:,:)
     anowt(   :,jj,:) = anowtxz(   :,:)
  END DO

  DO jk=1,npk
     ierr = putvar(ncout, id_varout(1), wbartbar(:,:,jk), jk, npiglo, npjglo )
     ierr = putvar(ncout, id_varout(2), anowt(   :,:,jk), jk, npiglo, npjglo )
  END DO

  ierr = closeout(ncout)  

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------

    ipk(:)                    = npk  
    stypvar(1)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(1)%cname          = 'wT'
    stypvar(1)%clong_name     = 'temporal mean of w times temporal mean of T on T point (*1000)'
    stypvar(1)%cshort_name    = 'wT'

    stypvar(2)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(2)%cname          = 'anowT'
    stypvar(2)%clong_name     = 'temporal mean of anomaly of w times ano of T on T point (*1000)'
    stypvar(2)%cshort_name    = 'anowT'

    stypvar%cunits            = '1000 m/s.K'
    stypvar%rmissing_value    = 0.
    stypvar%valid_min         = -1000.
    stypvar%valid_max         = 1000.
    stypvar%conline_operation = 'N/A'
    stypvar%caxis             = 'TYX'

    ! create output fileset
    ncout = create      (cf_out, cf_uvwtfil,   npiglo, npjglo, npk   , ld_nc4=lnc4 )
    ierr  = createvar   (ncout,    stypvar, 2,      ipk,    id_varout, ld_nc4=lnc4 )
    ierr  = putheadervar(ncout,    cf_uvwtfil,   npiglo, npjglo, npk       )

    dtim = getvar1d(cf_uvwtfil, cn_vtimec, npt )
    ierr = putvar1d(ncout, dtim,      npt, 'T' )

  END SUBROUTINE CreateOutput

END PROGRAM cdfnrj_transfert

PROGRAM cdfmoy_freq
  !!======================================================================
  !!                     ***  PROGRAM  cdfmoy_freq  ***
  !!=====================================================================
  !!  ** Purpose : Mainly in case of forcing file (gathered as yearly file)
  !!               compute annual mean, monthl mean or diurnal means.
  !!
  !!  ** Method  : Detect the frequency of the input file according to the
  !!               number of fields in the file.
  !!
  !! History : 2.1  : 06/2007  : P. Mathiot   : Original code from cdfmoy
  !!           3.0  : 06/2011  : J.M. Molines : Doctor norm + Lic.
  !!           3.0  : 10/2011  : P. Mathiot   : Add seasonal option and 
  !!                                            allow file with 73 time steps
  !!                : 05/2015  : J.M. Molines : Rewrite to be compliant with XIOS
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio 
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class time_averaging
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                               :: jk, jvar    ! dummy loop index
  INTEGER(KIND=4)                               :: jv, jtt     ! dummy loop index
  INTEGER(KIND=4)                               :: jframe      ! dummy loop index
  INTEGER(KIND=4)                               :: it1, it2    ! box limits
  INTEGER(KIND=4)                               :: ierr        ! working integer
  INTEGER(KIND=4)                               :: narg, iargc     ! 
  INTEGER(KIND=4)                               :: ijarg, ijm
  INTEGER(KIND=4)                               :: npiglo, npjglo  ! size of the domain
  INTEGER(KIND=4)                               :: npk ,npt        ! size of the domain
  INTEGER(KIND=4)                               :: ip, nf          ! working integer
  INTEGER(KIND=4)                               :: nvars           ! Number of variables in a file
  INTEGER(KIND=4)                               :: nframes         ! Number of frames in the output file
  INTEGER(KIND=4)                               :: ndyr, nhyr      ! Days and hours per year
  INTEGER(KIND=4)                               :: nhfri           ! input freq in hours
  INTEGER(KIND=4)                               :: ncout, ncout2
  INTEGER(KIND=4), DIMENSION( 12)               :: njm             ! month vector
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: id_var, ipk, id_varout, ibox

  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: v2d, rmean
  REAL(KIND=4), DIMENSION(:,:,:),   ALLOCATABLE :: v3d
  REAL(KIND=4), DIMENSION(:,:,:,:), ALLOCATABLE :: v4d

  REAL(KIND=8)                                  :: dtotal_time
  REAL(KIND=8), DIMENSION(:),       ALLOCATABLE :: dtim, dtimean
  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: dtab         ! Arrays for cumulated values

  CHARACTER(LEN=256)                            :: cf_in               !
  CHARACTER(LEN=256)                            :: cf_out='cdfmoy_'    ! file name
  CHARACTER(LEN=256)                            :: cv_dep
  CHARACTER(LEN=256)                            :: cfreq_o             ! output frequency
  CHARACTER(LEN=256)                            :: cldum               ! dummy character arguments
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_names            ! array of var nam
  CHARACTER(LEN=2  ), DIMENSION(4)              :: cfreq_a=(/'h ','d ','mo','y '/) ! authorized keys for frequency specif
  CHARACTER(LEN=2  )                            :: cfr_id              ! current output freq id

  TYPE (variable), DIMENSION(:),    ALLOCATABLE :: stypvar

  LOGICAL                                       :: lcaltmean=.TRUE.
  LOGICAL                                       :: lleap
  LOGICAL                                       :: lerr
  LOGICAL                                       :: lnc4 = .FALSE.
  LOGICAL                                       :: lv3d = .FALSE.
  LOGICAL                                       :: lv4d = .FALSE.
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfmoy_freq -f IN-file -avg AVG-length [-v3d] [-v4d] [-o OUT-rootname]'
     PRINT *,'            ... [-nc4]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       This program takes a file covering 1 year of data (evenly spaced) and'
     PRINT *,'       sub-samples the data by performing box averages, which span is given as'
     PRINT *,'       argument. The original data sampling can be hours, days, monthes or'
     PRINT *,'       even seasons.'
     PRINT *,'       The program recognizes leap years, and when feb. 29 is found, it is '
     PRINT *,'       included in the current ''box'' (averaging length is thus increased by'
     PRINT *,'       1 day.)'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -f IN-file : gives the name of the yearly file containing either 365 '
     PRINT *,'              or 366 days'
     PRINT *,'       -avg AVG-length : Set the time size of the averaging box. Averaging '
     PRINT *,'              length is specified using XIOS convention (e.g. 1d,5d, 1mo, 1y ;'
     PRINT *,'              4mo stands for seasonal means )'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-v3d] : use 3d variable (x,y,t) : save execution time, increase memory'
     PRINT *,'       [-v4d] : use 4d variable (x,y,z,t): save execution time, increase memory'
     PRINT *,'       [-o OUT-rootname] : specify the root of the output file name instead '
     PRINT *,'                   of ',TRIM(cf_out),'. Final name will have <freq> appened'
     PRINT *,'                   to the root.'
     PRINT *,'       [-nc4] : use netcdf4 with chunking and deflation for the output file'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        none.'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file :  cdfmoy_output<freq>.nc'
     PRINT *,'         variables :  same as variables in input file.'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'      cdfmoy, cdfmoy_weighted'
     PRINT *,'      '
     STOP 
  ENDIF

  ! parse command line
  ijarg = 1
  DO WHILE ( ijarg <= narg )
     CALL getarg(ijarg, cldum) ; ijarg = ijarg +1
     SELECT CASE ( cldum ) 
     CASE ( '-f'   ) ; CALL getarg(ijarg, cf_in   ) ; ijarg = ijarg + 1
     CASE ( '-avg' ) ; CALL getarg(ijarg, cfreq_o ) ; ijarg = ijarg + 1
        ! options
     CASE ( '-v3d' ) ; lv3d=.TRUE.
     CASE ( '-v4d' ) ; lv4d=.TRUE.
     CASE ( '-o'   ) ; CALL getarg(ijarg, cf_out  ) ; ijarg = ijarg + 1
     CASE ( '-nc4' ) ; lnc4=.TRUE.
     CASE DEFAULT    ; PRINT *,' ERROR : ', TRIM(cldum) ,' : unknown option.' ; STOP 99
     END SELECT
  END DO

  IF ( chkfile ( cf_in ) ) STOP 99 ! missing file

  ! parse the cfreqo to determine the output frequency. 
  ! Allowed syntax is nf<cfr_id> where nf is an integer >0, <cfr_id> is h, d, mo or y
  cfr_id='--'
  DO jk =1, 4
     ip=INDEX(cfreq_o, cfreq_a(jk) )
     IF ( ip /= 0 ) THEN
        cfr_id=cfreq_o(ip:)
        READ(cfreq_o(1:ip-1), *) nf
        EXIT
     ENDIF
  ENDDO

  SELECT CASE ( cfr_id )
  CASE ( '--' ) 
     PRINT *, ' +++ ERROR : Cannot determine the output frequency'
     PRINT *, '            You should use a character string such as 6h, 5d, 1mo, 1y '
  CASE ( 'd' ) 
     IF ( nf /= 1 .AND. nf/=5 ) THEN
        PRINT *, ' +++ ERROR : only 1d or 5d are acceptable !'
        STOP 99
     ENDIF
  CASE ( 'y' )
     IF ( nf > 1 ) THEN
        PRINT *, ' +++ ERROR : Cannot have output freq > 1 y !'
        STOP 99
     ENDIF
  END SELECT

  ! get domain size from the input file
  npiglo= getdim (cf_in, cn_x                             )
  npjglo= getdim (cf_in, cn_y                             )
  npk   = getdim (cf_in, cn_z, cdtrue=cv_dep, kstatus=ierr)

  IF (ierr /= 0 ) THEN
     npk   = getdim (cf_in,'z',cdtrue=cv_dep,kstatus=ierr)
     IF (ierr /= 0 ) THEN
        npk   = getdim (cf_in,'sigma',cdtrue=cv_dep,kstatus=ierr)
        IF ( ierr /= 0 ) THEN 
           PRINT *,' assume file with no depth'
           npk=0
        ENDIF
     ENDIF
  ENDIF

  npt   = getdim (cf_in, cn_t)

  ! Now look at input file and try to look for input frequency
  ! Note that we know that the file contains either 365d or 366 days of data
  ! We suppose that input file freq is a multiple of 1 hour.
  lleap = .FALSE.
  ndyr  = 365     ! number of days per year
  nhyr  = ndyr*24 ! number of hours per year

  IF ( MOD( nhyr, npt ) /= 0 ) THEN
     ndyr = 366     ! try leap year
     nhyr = ndyr*24 ! number of hours per leap year
     IF ( MOD( nhyr, npt ) /= 0 ) THEN
        PRINT *," +++ ERROR : npt do not fit in 365 nor 366 days "
        STOP 99
     ELSE
        lleap=.TRUE.
     ENDIF
  ENDIF
  nhfri = 24*ndyr/npt  ! input frequency in hours

  PRINT *, 'INPUT FILE : ', TRIM(cf_in)
  PRINT *, 'NPIGLO = ', npiglo
  PRINT *, 'NPJGLO = ', npjglo
  PRINT *, 'NPK    = ', npk
  PRINT *, 'NPT    = ', npt
  PRINT *, ' '
  PRINT *, ' LEAP YEAR  : ', lleap
  PRINT *, ' INPUT FREQ : ', nhfri,' hours '

  ! Now determines the number of frames in the output file and detect impossible case
  !  Also determines the number of input frames in boxes. (can be variable)
  ! number of day by month
  njm(:)= (/ 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 /)

  IF ( lleap ) THEN 
     njm(:) = (/ 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 /)
  ENDIF

  lerr = .TRUE.
  SELECT CASE ( cfr_id )
  CASE ( 'h' ) 
     IF ( MOD( nf, nhfri ) == 0 ) THEN
        nframes = ndyr*24/nf 
        ALLOCATE (ibox( nframes) )
        ibox(:)=nf/nhfri ; lerr=.FALSE.
     ENDIF
  CASE ( 'd' ) ! note : 365 = 73 *5  ( 366 = 73 *5 + 1 ) 
     IF ( MOD ( nf*24, nhfri ) == 0 ) THEN
        IF ( nf == 1 ) nframes = ndyr
        IF ( nf == 5 ) nframes = 73  ! in case of leap year frame#12 will have 6day average
        ALLOCATE (ibox( nframes) )
        lerr=.FALSE.
        ibox(:)=nf*24/nhfri 
        IF ( lleap .AND. nf == 5 ) ibox(12)=6*24/nhfri
     ENDIF
  CASE ( 'mo' )
     !##################################
     !JM : do not work if nhfri > 24 !!! 
     !##################################
     IF ( MOD( 12, nf ) == 0 ) THEN
        nframes=12/nf ; lerr=.FALSE.
        ALLOCATE (ibox( nframes) )  ! 12 6 4 3 2 
        SELECT CASE ( nframes )
        CASE ( 12 )
           ibox(:) = njm(:)*24/nhfri 
        CASE ( 6 )
           DO jframe= 1, nframes
              ijm=jframe*2-1
              ibox(jframe) = (njm(ijm)+njm(ijm+1)) *24/nhfri 
           ENDDO
        CASE ( 4 )
           DO jframe= 1, nframes
              ijm=jframe*3-2
              ibox(jframe) = (njm(ijm)+njm(ijm+1)+njm(ijm+2)) *24/nhfri 
           ENDDO
        CASE ( 3 )
           DO jframe= 1, nframes
              ijm=jframe*4-3
              ibox(jframe) = (njm(ijm)+njm(ijm+1)+njm(ijm+2)+njm(ijm+3)) *24/nhfri 
           ENDDO
        CASE ( 2 )
           DO jframe= 1, nframes
              ijm=jframe*6-5
              ibox(jframe) = (njm(ijm)+njm(ijm+1)+njm(ijm+2)+njm(ijm+3)+njm(ijm+4)+njm(ijm+5)) *24/nhfri 
           ENDDO
        END SELECT
     ENDIF
  CASE ( 'y' )  ! 1y average  all is to be taken !
     nframes = 1
     ALLOCATE (ibox( nframes) )
     ibox(:) = npt
     lerr = .FALSE.
  END SELECT

  IF ( lerr ) THEN
     PRINT *, ' +++ ERROR : Input and output frequency incompatible.'
     PRINT *, '         Input  : ',  nhfri,' hours '
     PRINT *, '         Output : ',  nf,' hours '
     STOP 99
  ENDIF

  ALLOCATE( dtab(npiglo,npjglo), v2d(npiglo,npjglo) )
  ALLOCATE( rmean(npiglo,npjglo)                    )
  IF (lv3d)   ALLOCATE( v3d(npiglo,npjglo,npt)      )

  nvars = getnvar(cf_in)
  PRINT *,' nvars =', nvars

  ALLOCATE (cv_names(nvars)                            )
  ALLOCATE (stypvar(nvars)                             )
  ALLOCATE (id_var(nvars), ipk(nvars), id_varout(nvars))
  ALLOCATE( dtim( npt), dtimean(nframes)             )

  ! get list of variable names and collect attributes in stypvar (optional)
  cv_names(:)=getvarname(cf_in, nvars, stypvar)

  CALL CreateOutput

  dtim(:)=getvar1d(cf_in, cn_vtimec, npt)
  DO jvar = 1,nvars
     IF ( cv_names(jvar) == cn_vlon2d .OR.                            &
          cv_names(jvar) == cn_vlat2d .OR. cv_names(jvar) == 'none') THEN
        ! skip these variable
     ELSE
        PRINT *,' Working with ', TRIM(cv_names(jvar))
        IF (lv4d)   ALLOCATE( v4d(npiglo, npjglo,ipk(jvar),npt)  )

        IF (lv4d)  v4d(:,:,:,:) = getvar4d(cf_in, cv_names(jvar),npiglo, npjglo,ipk(jvar),npt)
        DO jk=1,ipk(jvar)

           ! initialisation
           dtab(:,:) = 0.d0 ; dtotal_time = 0.d0

           ! time loop
           it1=1
           IF ( lv3d )  v3d(:,:,:)=getvar3dt(cf_in, cv_names(jvar),jk,npiglo, npjglo, npt)
           DO jframe = 1, nframes
              it2=it1+ibox(jframe)-1
              DO jtt=it1, it2
                 ! load data
                  IF ( lv4d) THEN 
                       v2d(:,:) = v4d(:,:,jk,jtt)
                  ELSE
                    IF ( lv3d ) THEN ; v2d(:,:)  = v3d(:,:,jtt)
                    ELSE             ; v2d(:,:)  = getvar(cf_in, cv_names(jvar), jk, npiglo, npjglo, ktime=jtt )
                    ENDIF
                  ENDIF
                 dtab(:,:) = dtab(:,:) + v2d(:,:)*1.d0
                 IF ( lcaltmean ) THEN
                    dtotal_time = dtotal_time + dtim(jtt) 
                 ENDIF
              ENDDO
              rmean(:,:) = dtab(:,:)/ibox(jframe)
              ierr = putvar(ncout, id_varout(jvar) ,rmean, jk, npiglo, npjglo, ktime=jframe)
              IF ( lcaltmean ) THEN
                 dtimean(jframe) = dtotal_time/ibox(jframe)
              ENDIF
              dtab(:,:) = 0.d0 ; dtotal_time = 0.d0
              it1 = it2 + 1
              !
           ENDDO ! loop to next time
           lcaltmean=.FALSE.

        ENDDO ! loop to next level
        IF (lv4d)   DEALLOCATE( v4d )
     END IF
  END DO ! loop to next var in file

  ierr = putvar1d(ncout,   dtimean,  nframes  , 'T')
  ierr = closeout(ncout)

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
  id_var(:)  = (/(jv, jv=1,nvars)/)
  ! ipk gives the number of level or 0 if not a T[Z]YX  variable
  ipk(:)     = getipk (cf_in, nvars, cdep=cv_dep)
  !
  WHERE( ipk == 0 ) cv_names='none'
  stypvar(:)%cname = cv_names
  DO jv=1, nvars
    stypvar(jv)%ichunk=(/npiglo,MAX(1,npjglo/30), 1, 1 /)
  ENDDO

  ! create output file taking the sizes in cf_in
  cf_out = TRIM(cf_out)//'_'//TRIM(cfreq_o)//'.nc'
  ncout = create      (cf_out, cf_in,   npiglo, npjglo, npk, cdep=cv_dep , ld_nc4=lnc4 )
  ierr  = createvar   (ncout,  stypvar, nvars,  ipk,    id_varout        , ld_nc4=lnc4 )
  ierr  = putheadervar(ncout,  cf_in,   npiglo, npjglo, npk, cdep=cv_dep               )


  END SUBROUTINE CreateOutput

END PROGRAM cdfmoy_freq

PROGRAM cdfstdevw
  !!======================================================================
  !!                     ***  PROGRAM  cdfstdevw  ***
  !!=====================================================================
  !!  ** Purpose : Compute the RMS of W, from the mean squared value.
  !!
  !!  ** Method  : Read gridW and gridW2 and compute rms
  !!
  !! History : 2.1  : 11/2004  : J.M. Molines : Original code
  !!           3.0  : 05/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                            :: jk, jt            ! dummy loop index
  INTEGER(KIND=4)                            :: narg, iargc       ! command line
  INTEGER(KIND=4)                            :: ijarg, ireq       ! command line
  INTEGER(KIND=4)                            :: npiglo, npjglo    ! size of the domain
  INTEGER(KIND=4)                            :: npk, npt          ! size of the domain
  INTEGER(KIND=4)                            :: ncout             ! ncid of output variable
  INTEGER(KIND=4)                            :: ierr              ! error status
  INTEGER(KIND=4), DIMENSION(1)              :: ipko, id_varout   ! output variable

  REAL(KIND=4), DIMENSION(:,:),  ALLOCATABLE :: zvbar, zvba2      ! mean and mean2 variable
  REAL(KIND=4), DIMENSION(:),    ALLOCATABLE :: tim               ! time counter
  REAL(KIND=4)                               :: rmiss             ! missing value attribute

  REAL(KIND=8), DIMENSION(:,:),  ALLOCATABLE :: dsdev             ! standard deviation

  CHARACTER(LEN=256)                         :: cf_in             ! input mean file name
  CHARACTER(LEN=256)                         :: cf_in2            ! input mean2 file name
  CHARACTER(LEN=256)                         :: cf_out = 'rmsw.nc'! output file name
  CHARACTER(LEN=256)                         :: cv_in, cv_in2     ! input variable names
  CHARACTER(LEN=256)                         :: cldum             ! dummy character variable
  CHARACTER(LEN=256)                         :: cl_units, cl_longname, cl_shortname

  TYPE(variable), DIMENSION(1)               :: stypvaro          ! output data structure

  LOGICAL                                    :: lchk = .FALSE.    ! flag for missing files
  LOGICAL                                    :: lnc4 = .FALSE.    ! flag for netcdf4 with chunking and deflation
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  cv_in  = cn_vovecrtz
  cv_in2 = cn_vovecrtz2

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfstdevw W-file W2-file [varname] [-o output_file] [-nc4 ]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Computes the standard deviation of the vertical velocity'
     PRINT *,'       from its mean value and its mean square value. If a variable name '
     PRINT *,'       is given, then computes rms of this variable instead of the vertical '
     PRINT *,'       velocity.'
     PRINT *,'      '
     PRINT *,'       Note that what is computed in this program is stictly the'
     PRINT *,'       standard deviation. It is very often called RMS, which is'
     PRINT *,'       an abuse. It is the same only in the case of zero mean value.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       W-file  : netcdf file with mean values for w ( or given variable)' 
     PRINT *,'       W2-file : netcdf file with mean squared values for w (or given variable)' 
     PRINT *,'      '
     PRINT *,'     OPTIONS: '
     PRINT *,'        varname : give name of variable if not ', TRIM(cn_vovecrtz)
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       none' 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) ,' (if varname specified, output file is rms_var.nc)'
     PRINT *,'         variables : ', TRIM(cv_in)//'_rms, (or varname_rms)  same unit than the input.'
     PRINT *,'      '
     PRINT *,'     SEA ALSO :'
     PRINT *,'       cdfstd, cdfrmsssh, cdfstdevts.'
     STOP
  ENDIF

  ijarg = 1  ; ireq = 0
  DO WHILE ( ijarg <= narg) 
     CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-o'   ) ; CALL getarg(ijarg, cf_out ) ; ijarg=ijarg+1
     CASE ( '-nc4' ) ; lnc4 = .true.
     CASE DEFAULT
        ireq = ireq + 1
        SELECT CASE ( ireq ) 
        CASE ( 1 ) ; cf_in  = cldum
        CASE ( 2 ) ; cf_in2 = cldum
        CASE ( 3 ) ; cv_in  = cldum ; cf_out='rms_var.nc'
        CASE DEFAULT
           PRINT *, ' Too many variables ' ; STOP 99
        END SELECT
     END SELECT
  ENDDO

  ! check existence of files
  lchk = lchk .OR. chkfile(cf_in )
  lchk = lchk .OR. chkfile(cf_in2)
  IF (lchk ) STOP 99 ! missing file

  npiglo = getdim (cf_in, cn_x)
  npjglo = getdim (cf_in, cn_y)
  npk    = getdim (cf_in, cn_z)
  npt    = getdim (cf_in, cn_t)

  ierr = getvaratt(cf_in, cv_in, cl_units, rmiss, cl_longname, cl_shortname )

  stypvaro(1)%ichunk = (/ npiglo, MAX(1,npjglo/30), 1,1 /)

  ipko(1) = npk
  stypvaro(1)%cname             = TRIM(cv_in)//'_rms'
  stypvaro(1)%cunits            = TRIM(cl_units)
  stypvaro(1)%rmissing_value    = 0.
  stypvaro(1)%valid_min         = 0.
  stypvaro(1)%valid_max         = 10.
  stypvaro(1)%clong_name        = 'RMS_'//TRIM(cl_longname)
  stypvaro(1)%cshort_name       = TRIM(cv_in)//'_rms'
  stypvaro(1)%conline_operation = 'N/A'
  stypvaro(1)%caxis             = 'TZYX'

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  ALLOCATE( zvbar(npiglo,npjglo), zvba2(npiglo,npjglo) )
  ALLOCATE( dsdev(npiglo,npjglo), tim(npt)             )

  ncout = create      (cf_out, cf_in,    npiglo, npjglo, npk       , ld_nc4=lnc4 )
  ierr  = createvar   (ncout,  stypvaro, 1,      ipko,   id_varout , ld_nc4=lnc4 )
  ierr  = putheadervar(ncout,  cf_in,    npiglo, npjglo, npk       )

  DO jt = 1, npt
     DO jk = 1, npk
        zvbar(:,:) = getvar(cf_in,  cv_in,  jk, npiglo, npjglo, ktime=jt)
        zvba2(:,:) = getvar(cf_in2, cv_in2, jk, npiglo, npjglo, ktime=jt)

        dsdev(:,:) = SQRT ( DBLE(zvba2(:,:) - zvbar(:,:)*zvbar(:,:)) )

        ierr = putvar(ncout, id_varout(1), REAL(dsdev), jk, npiglo, npjglo, ktime=jt)
     END DO
  END DO

  tim  = getvar1d(cf_in, cn_vtimec, npt     )
  ierr = putvar1d(ncout, tim,       npt, 'T')

  ierr = closeout(ncout)

END PROGRAM cdfstdevw

PROGRAM cdfwhereij
  !!======================================================================
  !!                     ***  PROGRAM  cdfwhereij  ***
  !!=====================================================================
  !!  ** Purpose : Give the values of longitude latitude for a given i, j
  !!
  !!  ** Method  : Read the coordinate/mesh_hgr file and look for the glam,
  !!               gphi variables. The point type ( T U V F ) is specified 
  !!               on the command line.
  !!
  !! History : 2.1  : 05/2005  : J.M. Molines : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: narg, iargc    ! browse line
  INTEGER(KIND=4)                           :: ijarg, ireq    ! browse line
  INTEGER(KIND=4)                           :: iimin, iimax   ! i-zoom limit
  INTEGER(KIND=4)                           :: ijmin, ijmax   ! j-zoom limit
  INTEGER(KIND=4)                           :: npiglo, npjglo ! global size

  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: glam, gphi     ! longitude, latitude

  CHARACTER(LEN=256)                        :: cv_lam         ! longitude name
  CHARACTER(LEN=256)                        :: cv_phi         ! latitude name
  CHARACTER(LEN=256)                        :: ctype='T'      ! type of point on C-grid
  CHARACTER(LEN=256)                        :: cldum          ! dummmy string
  CHARACTER(LEN=256)                        :: clcoo          ! dummy character variable
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()
  clcoo = cn_fcoo


  narg= iargc()
  IF ( narg < 4 ) THEN
     PRINT *,' usage : cdfwhereij  imin imax jmin jmax [-c COOR-file ] [ -p point_type]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Return the geographical coordinates of a model sub-area specified' 
     PRINT *,'       in i,j space on the command line.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       imin imax jmin jmax : (i,j) space window coordinates' 
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-c COOR_file  ] : specify a coordinates file.' 
     PRINT *,'                      default is ', TRIM(cn_fcoo)
     PRINT *,'       [-p point type ] : specify a point type on the C-grid (T U V F) '
     PRINT *,'                      default is ', TRIM(ctype)
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ',TRIM(cn_fcoo),' or COOR-file given in the -c option'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       Standard output'
     STOP
  ENDIF

  ijarg = 1 ; ireq = 0
  DO WHILE ( ijarg <= narg) 
     CALL getarg( ijarg, cldum ) ; ijarg= ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-c' ) ; CALL getarg(ijarg, clcoo ) ; ijarg=ijarg+1
     CASE ( '-p' ) ; CALL getarg(ijarg, ctype ) ; ijarg=ijarg+1
     CASE DEFAULT
        ireq=ireq+1
        SELECT CASE (ireq)
        CASE ( 1 ) ; READ(cldum,*) iimin
        CASE ( 2 ) ; READ(cldum,*) iimax
        CASE ( 3 ) ; READ(cldum,*) ijmin
        CASE ( 4 ) ; READ(cldum,*) ijmax
        CASE DEFAULT
           PRINT *,' Too many arguments !' ; STOP
        END SELECT
     END SELECT
  END DO

  IF ( chkfile(clcoo) ) STOP ! missing file

  npiglo = getdim (clcoo, cn_x)
  npjglo = getdim (clcoo, cn_y)

  IF ( iimax > npiglo ) THEN
     PRINT *,' ERROR : imax is greater than the maximum size ', iimax, npiglo
     STOP
  ENDIF

  IF ( ijmax > npjglo ) THEN
     PRINT *,' ERROR : jmax is greater than the maximum size ', ijmax, npjglo
     STOP
  END IF

  ALLOCATE (glam(npiglo,npjglo), gphi(npiglo,npjglo) )

  SELECT CASE ( ctype )
  CASE ('T' , 't' ) ; cv_lam = cn_glamt ; cv_phi = cn_gphit
  CASE ('U' , 'u' ) ; cv_lam = cn_glamu ; cv_phi = cn_gphiu
  CASE ('V' , 'v' ) ; cv_lam = cn_glamv ; cv_phi = cn_gphiv
  CASE ('F' , 'f' ) ; cv_lam = cn_glamf ; cv_phi = cn_gphif
  CASE DEFAULT
     PRINT *,' ERROR : type of point not known: ', TRIM(ctype)
  END SELECT

  glam(:,:) = getvar(clcoo, cv_lam, 1, npiglo, npjglo)
  gphi(:,:) = getvar(clcoo, cv_phi, 1, npiglo, npjglo)

  PRINT '(2a)'     ,' Type of point   : ', TRIM(ctype)
  PRINT '(a,4i6)'  ,'   I J zoom      : ', iimin, iimax, ijmin, ijmax
  PRINT '(a,4f9.3)','   LON LAT zoom  : ', glam(iimin,ijmin), glam(iimax,ijmax), gphi(iimin,ijmin), gphi(iimax,ijmax)

END PROGRAM cdfwhereij

PROGRAM cdfprobe
  !!======================================================================
  !!                     ***  PROGRAM  cdfprobe  ***
  !!=====================================================================
  !!  ** Purpose : Display time series of a variable at a given point
  !!
  !!
  !! History : 2.1  : 12/2006  : J.M. Molines : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class file_informations
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)    :: narg, iargc, ijarg     ! browse line
  INTEGER(KIND=4)    :: iilook, ijlook, iklook ! point to look at
  CHARACTER(LEN=256) :: cf_in, cldum , cv_in   ! file name  variable name
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg=iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage :  cdfprobe -f IN-file -v IN-var -i ilook -j jlook [-k klook]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'      Displays a series of pair of values (time, value) corresponding to the'
     PRINT *,'      IN-var variable in IN-file, at location (ilook, jlook,[klook]). The'
     PRINT *,'      standard output can be piped to a graphical tool such as ''graph'' to'
     PRINT *,'      easily plot the time evolution of IN-var.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -f IN-file : input file to look for' 
     PRINT *,'       -i ilook   : i position of the probe.'
     PRINT *,'       -j jlook   : j position of the probe.'
     PRINT *,'       -v IN-var  : name of the cdf variabled to be displayed'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-k klook] : Use the probe at level klook, instead of the first level.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       none'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       2 columns ( time , value ) ASCII output on display'
     PRINT *,'       time are given in days since the begining of the run.'
     STOP 
  ENDIF

  ! Browse command line
  iklook=1
  ijarg=1
  DO WHILE ( ijarg <= narg)
     CALL getarg(ijarg,cldum) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-f' ) ; CALL getarg(ijarg,cf_in) ; ijarg=ijarg+1
     CASE ( '-v' ) ; CALL getarg(ijarg,cv_in) ; ijarg=ijarg+1
     CASE ( '-i' ) ; CALL getarg(ijarg,cldum) ; ijarg=ijarg+1 ; READ(cldum,*) iilook
     CASE ( '-j' ) ; CALL getarg(ijarg,cldum) ; ijarg=ijarg+1 ; READ(cldum,*) ijlook
     CASE ( '-k' ) ; CALL getarg(ijarg,cldum) ; ijarg=ijarg+1 ; READ(cldum,*) iklook
     CASE DEFAULT  ; PRINT *,' ERROR : ',TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  ENDDO

  IF ( chkfile(cf_in) ) STOP 99 ! missing file

     CALL gettimeseries(cf_in, cv_in, iilook, ijlook, klev=iklook)

END PROGRAM cdfprobe

program cdfsections   
         
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!          *** PROGRAM cdfsections ***
!
! ** Purpose : extract oceanic fields along a track made of several sections.
!
! ** Method : computes N sections by taking the nearest point north of 60°N 
!             and near undefined values (bottom or coasts), and interpolates 
!             between the four nearest points elsewhere.
!             
! ** Outputs : temperature, salinity, density, current (normal/tangeantial)
!              - normal current is positive northward (westward if meridional section)
!              - tangeantial current is on the right of the normal current.
!
! NB : it is recommended to put a lot of points on each section if the aim is 
!      to compute X-integrations.
!
! WARNING : 
!  - require large memory : reduce domain size with ncks if insufficient memory error.
!  - does not work if the section crosses the Greenwich line (easy to modify if needed).
!  - not yet tested north of 60°N (but should work) ...
!
! history :
! N. JOURDAIN (LEGI-MEOM), April 2009
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !!  $Rev$
  !!  $Date$
  !!  $Id$
  !!--------------------------------------------------------------

                                             
USE netcdf                                            
USE eos
                                                      
IMPLICIT NONE                                         

!--- Local variables
INTEGER   :: narg, iargc 
                                                    
!--- grid_T
INTEGER :: fidT, status, dimID_time_counter, dimID_deptht, dimID_y, dimID_x, &
& mtime_counter, mdeptht, my, mx, vosaline_ID, votemper_ID, time_counter_ID, &
& deptht_ID, nav_lat_ID, nav_lon_ID, fidM, dimID_s, X_ID, sig0_ID, sig1_ID,  &
& sig2_ID, sig4_ID 
      
!--- grid_U 
INTEGER :: fidU, dimID_depthu, mdepthu, mxu, vozocrtx_ID

!--- grid_V
INTEGER :: fidV, dimID_depthv, mdepthv, myu, vomecrty_ID
                                                      
CHARACTER(LEN=256) :: file_in_T, file_out, file_in_U, file_in_V, cdum             
           
REAL*4 :: RT, dtmp_T, dtmp_U, dtmp_V, miniT, miniU, miniV, rr, ang, pi,&
&  latinf, latsup, loninf, lonsup, a, b, c, e, missing, lonref, latref

REAL*8 :: offset

INTEGER :: N1, N2, i, j, k, s, p, iiT, jjT, Nsec, Ntot,Unorm_ID, Utang_ID, cont,&
& l, iiU, jjU, iiV, jjV, iinf, isup, jinf, jsup

INTEGER,ALLOCATABLE,DIMENSION(:) :: N

REAL*4,ALLOCATABLE,DIMENSION(:) :: lat, lon 

LOGICAL,ALLOCATABLE,DIMENSION(:) :: undefined

!---- grid_T                                           
REAL*4,ALLOCATABLE,DIMENSION(:,:,:,:) :: vosaline, votemper, sig0, sig1, sig2, sig4
REAL*4,ALLOCATABLE,DIMENSION(:,:,:) :: somxl010, somxlt02, vosaline_sec, votemper_sec
REAL*4,ALLOCATABLE,DIMENSION(:,:) :: nav_lat_T, nav_lon_T, somxl010_sec, somxlt02_sec
REAL*4,ALLOCATABLE,DIMENSION(:) :: time_counter, deptht
                                                     
!---- grid_U
REAL*4,ALLOCATABLE,DIMENSION(:,:,:,:) :: vozocrtx
REAL*4,ALLOCATABLE,DIMENSION(:,:,:) :: vozocrtx_sec
REAL*4,ALLOCATABLE,DIMENSION(:,:) :: nav_lat_U, nav_lon_U

!---- grid_V
REAL*4,ALLOCATABLE,DIMENSION(:,:,:,:) :: vomecrty
REAL*4,ALLOCATABLE,DIMENSION(:,:,:) :: vomecrty_sec
REAL*4,ALLOCATABLE,DIMENSION(:,:) :: nav_lat_V, nav_lon_V

!---- grid section 
REAL*4,ALLOCATABLE,DIMENSION(:,:,:) :: Unorm, Utang, sigsec0, sigsec1, sigsec2, sigsec4
REAL*4,ALLOCATABLE,DIMENSION(:) :: lonsec, latsec
REAL*8,ALLOCATABLE,DIMENSION(:) :: d, X1

!-------------------------------------------------------------------------
! GETTING ARGUMENTS :

!-  Read command line and output usage message if not compliant.
  narg= iargc()
  IF ( narg.lt.10 ) THEN
     PRINT *,'Usage : '
     PRINT *,' cdfsections  Ufile Vfile Tfile larf lorf Nsec lat1 lon1 lat2 lon2 n1'
     PRINT *,'              [ lat3 lon3 n2 ] [ lat4 lon4 n3 ] ....'
     PRINT *,'   ' 
     PRINT *,' Computes temperature, salinity, sig0, sig1, sig2, sig4, Uorth, Utang '
     PRINT *,' along a section made of Nsec linear segments (see output attributes).'
     PRINT *,' Output is section.nc, var. as a function of X(km), depth(m) and time.'
     PRINT *,'   '
     PRINT *,'Arguments : '
     PRINT *,' # larf and lorf -> location of X=0 for the X-absice (may be out of section)'
     PRINT *,' # Nsec -> number of segments used to compute the whole section.'
     PRINT *,' # lat1,lat2,lat3,... -> extrema latitudes of the segments (from -90 to 90)'
     PRINT *,' # lon1,lon2,lon3,... -> extrema latitudes of the segments (from 0 to 360)'
     PRINT *,' # n1, n2, ...        -> number of output points on each segment.'
     PRINT *,'   (you have to give Nsec+1 values of lati/loni and Nsec values of ni)'
     PRINT *,' '
     PRINT *,' It is recommended to put a lot of points on each section if the aim'
     PRINT *,' is to compute X-integrations along the section (10 x the model resolution).'
     PRINT *,'NB : sections cannot cross the Greenwich line !!'
     PRINT *,'NB : Not yet tested north of 60°N.'
     PRINT *,'NB : require a large amount of memory !' 
     PRINT *,'     -> reduce domain size with  ncks -d  if insufficient memory error.'
     PRINT *,' '
     PRINT *,'Example for one linear section : '
     PRINT *,' cdfsections U.nc V.nc T.nc 48.0 305.0 1 49.0 307.0 50.5 337.5 20'
     PRINT *,'Example for a section made of 2 linear segments : '
     PRINT *,' cdfsections U.nc V.nc T.nc 48.0 305.0 2 49.0 307.0 50.5 337.5 20 40.3 305.1 50'
     STOP
  ENDIF

  CALL getarg (1, file_in_U )
  CALL getarg (2, file_in_V )
  CALL getarg (3, file_in_T )

  CALL getarg (4, cdum ); READ(cdum,*) latref
  CALL getarg (5, cdum ); READ(cdum,*) lonref
  CALL getarg (6, cdum ); READ(cdum,*) Nsec

  if ( narg.ne.8+Nsec*3) then
    PRINT *, '**!/# ERROR : wrong number of arguments in cdfsections'
    PRINT *, 'Usage : '
    PRINT *, ' cdfsections  Ufile Vfile Tfile larf lorf Nsec lat1 lon1 lat2 lon2 n1 ....'
    PRINT *, '-> please execute cdfsections without any arguments for more details.'
    STOP
  endif

  ALLOCATE( lat(Nsec+1), lon(Nsec+1) )
  ALLOCATE( N(Nsec), d(Nsec) )

   CALL getarg (7, cdum ); READ(cdum,*) lat(1)
   CALL getarg (8, cdum ); READ(cdum,*) lon(1)

  do i=1,(narg-8),3
    CALL getarg (i+8, cdum ); READ(cdum,*) lat(i/3+2)
    CALL getarg (i+9, cdum ); READ(cdum,*) lon(i/3+2)
    CALL getarg (i+10, cdum ); READ(cdum,*) N(i/3+1)
  enddo

  do i=1,Nsec+1
    if ( (lon(i).lt.0.0).or.(lonref.lt.0.0) ) then
      PRINT *, '**!/# ERROR : longitudes must be between 0 and 360'
      STOP
    endif
  enddo
   
  file_out = 'section.nc'                               

 !---- Rayon terrestre en km :
   RT = 6378

   pi = 3.1415927
   rr = pi / 180.0         
         
!---------------------------------------                   
! Read netcdf input file for grid T :                                 
         
         write(*,*) TRIM(file_in_T)
                                                  
         status = NF90_OPEN(TRIM(file_in_T),0,fidT)          
         call erreur(status,.TRUE.,"read") 
                                                           
       !Lecture des ID des dimensions qui nous interessent
         status = NF90_INQ_DIMID(fidT,"time_counter",dimID_time_counter)
         call erreur(status,.TRUE.,"inq_dimID_time_counter")
         status = NF90_INQ_DIMID(fidT,"deptht",dimID_deptht)
         call erreur(status,.TRUE.,"inq_dimID_deptht")
         status = NF90_INQ_DIMID(fidT,"y",dimID_y)
         call erreur(status,.TRUE.,"inq_dimID_y")
         status = NF90_INQ_DIMID(fidT,"x",dimID_x)
         call erreur(status,.TRUE.,"inq_dimID_x")
                                                               
       !Lecture des valeurs des dimensions qui nous interessent
         status = NF90_INQUIRE_DIMENSION(fidT,dimID_time_counter,len=mtime_counter)
         call erreur(status,.TRUE.,"inq_dim_time_counter")
         status = NF90_INQUIRE_DIMENSION(fidT,dimID_deptht,len=mdeptht)
         call erreur(status,.TRUE.,"inq_dim_deptht")
         status = NF90_INQUIRE_DIMENSION(fidT,dimID_y,len=my)
         call erreur(status,.TRUE.,"inq_dim_y")
         status = NF90_INQUIRE_DIMENSION(fidT,dimID_x,len=mx)
         call erreur(status,.TRUE.,"inq_dim_x")
         
         write(*,101) mx, my, mdeptht, mtime_counter         
101 FORMAT('   -> dimensions of arrays : (',3(i4,','),i4,')')         
             
       !Allocation of arrays : 
         ALLOCATE(  vosaline(mx,my,mdeptht,mtime_counter)  ) 
         ALLOCATE(  votemper(mx,my,mdeptht,mtime_counter)  ) 
         ALLOCATE(  time_counter(mtime_counter)  ) 
         ALLOCATE(  deptht(mdeptht)  ) 
         ALLOCATE(  nav_lat_T(mx,my)  ) 
         ALLOCATE(  nav_lon_T(mx,my)  ) 
         ALLOCATE(  undefined(mdeptht) )         
                        
       !Lecture des ID des variables qui nous interessent
         status = NF90_INQ_VARID(fidT,"vosaline",vosaline_ID)
         call erreur(status,.TRUE.,"inq_vosaline_ID")
         status = NF90_INQ_VARID(fidT,"votemper",votemper_ID)
         call erreur(status,.TRUE.,"inq_votemper_ID")
         status = NF90_INQ_VARID(fidT,"time_counter",time_counter_ID)
         call erreur(status,.TRUE.,"inq_time_counter_ID")
         status = NF90_INQ_VARID(fidT,"deptht",deptht_ID)
         call erreur(status,.TRUE.,"inq_deptht_ID")
         status = NF90_INQ_VARID(fidT,"nav_lat",nav_lat_ID)
         call erreur(status,.TRUE.,"inq_nav_lat_ID")
         status = NF90_INQ_VARID(fidT,"nav_lon",nav_lon_ID)
         call erreur(status,.TRUE.,"inq_nav_lon_ID")
                                                              
       !Lecture des valeurs des variables qui nous interessent
         status = NF90_GET_VAR(fidT,vosaline_ID,vosaline)
         call erreur(status,.TRUE.,"getvar_vosaline")
         status = NF90_GET_VAR(fidT,votemper_ID,votemper)
         call erreur(status,.TRUE.,"getvar_votemper")
         status = NF90_GET_VAR(fidT,time_counter_ID,time_counter)
         call erreur(status,.TRUE.,"getvar_time_counter")
         status = NF90_GET_VAR(fidT,deptht_ID,deptht)
         call erreur(status,.TRUE.,"getvar_deptht")
         status = NF90_GET_VAR(fidT,nav_lat_ID,nav_lat_T)
         call erreur(status,.TRUE.,"getvar_nav_lat")
         status = NF90_GET_VAR(fidT,nav_lon_ID,nav_lon_T)
         call erreur(status,.TRUE.,"getvar_nav_lon")
         
        !extract missing value for vosaline :
         status = NF90_GET_ATT(fidT,vosaline_ID,"missing_value",missing)
         call erreur(status,.TRUE.,"get_att_vosaline")
                                             
     !Fermeture du fichier lu                         
       status = NF90_CLOSE(fidT)                      
       call erreur(status,.TRUE.,"fin_lecture")     
        
!---------------------------------------
! Read netcdf input file for grid U :

         write(*,*) TRIM(file_in_U)

         status = NF90_OPEN(TRIM(file_in_U),0,fidU)          
         call erreur(status,.TRUE.,"read") 
                                                           
       !Lecture des ID des dimensions qui nous interessent
         status = NF90_INQ_DIMID(fidU,"time_counter",dimID_time_counter)
         call erreur(status,.TRUE.,"inq_dimID_time_counter")
         status = NF90_INQ_DIMID(fidU,"depthu",dimID_depthu)
         call erreur(status,.TRUE.,"inq_dimID_depthu")
         status = NF90_INQ_DIMID(fidU,"y",dimID_y)
         call erreur(status,.TRUE.,"inq_dimID_y")
         status = NF90_INQ_DIMID(fidU,"x",dimID_x)
         call erreur(status,.TRUE.,"inq_dimID_x")
                                                               
       !Lecture des valeurs des dimensions qui nous interessent
         status = NF90_INQUIRE_DIMENSION(fidU,dimID_depthu,len=mdepthu)
         call erreur(status,.TRUE.,"inq_dim_depthu")
         status = NF90_INQUIRE_DIMENSION(fidU,dimID_x,len=mxu)
         call erreur(status,.TRUE.,"inq_dim_x")

         write(*,101) mxu, my, mdepthu, mtime_counter         
                      
       !Allocation of arrays : 
         ALLOCATE(  vozocrtx(mxu,my,mdepthu,mtime_counter)  ) 
         ALLOCATE(  nav_lat_U(mxu,my)  ) 
         ALLOCATE(  nav_lon_U(mxu,my)  ) 
                                 
       !Lecture des ID des variables qui nous interessent
         status = NF90_INQ_VARID(fidU,"vozocrtx",vozocrtx_ID)
         call erreur(status,.TRUE.,"inq_vozocrtx_ID")
         status = NF90_INQ_VARID(fidU,"nav_lat",nav_lat_ID)
         call erreur(status,.TRUE.,"inq_nav_lat_ID")
         status = NF90_INQ_VARID(fidU,"nav_lon",nav_lon_ID)
         call erreur(status,.TRUE.,"inq_nav_lon_ID")
                                                              
       !Lecture des valeurs des variables qui nous interessent
         status = NF90_GET_VAR(fidU,vozocrtx_ID,vozocrtx)
         call erreur(status,.TRUE.,"getvar_vozocrtx")
         status = NF90_GET_VAR(fidU,nav_lat_ID,nav_lat_U)
         call erreur(status,.TRUE.,"getvar_nav_lat")
         status = NF90_GET_VAR(fidU,nav_lon_ID,nav_lon_U)
         call erreur(status,.TRUE.,"getvar_nav_lon")
                                                      
     !Fermeture du fichier lu                         
       status = NF90_CLOSE(fidU)                      
       call erreur(status,.TRUE.,"fin_lecture")     


!---------------------------------------
! Read netcdf input file for grid V :

         write(*,*) TRIM(file_in_V)

         status = NF90_OPEN(TRIM(file_in_V),0,fidV)          
         call erreur(status,.TRUE.,"read") 
                                                           
       !Lecture des ID des dimensions qui nous interessent
         status = NF90_INQ_DIMID(fidV,"depthv",dimID_depthv)
         call erreur(status,.TRUE.,"inq_dimID_depthv")
         status = NF90_INQ_DIMID(fidV,"y",dimID_y)
         call erreur(status,.TRUE.,"inq_dimID_y")
                                                               
       !Lecture des valeurs des dimensions qui nous interessent
         status = NF90_INQUIRE_DIMENSION(fidV,dimID_depthv,len=mdepthv)
         call erreur(status,.TRUE.,"inq_dim_depthv")
         status = NF90_INQUIRE_DIMENSION(fidV,dimID_y,len=myu)
         call erreur(status,.TRUE.,"inq_dim_y")
         write(*,101) mx, myu, mdepthv, mtime_counter
                               
       !Allocation of arrays : 
         ALLOCATE(  vomecrty(mx,myu,mdepthv,mtime_counter)  ) 
         ALLOCATE(  nav_lat_V(mx,myu)  ) 
         ALLOCATE(  nav_lon_V(mx,myu)  ) 
                                 
       !Lecture des ID des variables qui nous interessent
         status = NF90_INQ_VARID(fidV,"vomecrty",vomecrty_ID)
         call erreur(status,.TRUE.,"inq_vomecrty_ID")
         status = NF90_INQ_VARID(fidV,"nav_lat",nav_lat_ID)
         call erreur(status,.TRUE.,"inq_nav_lat_ID")
         status = NF90_INQ_VARID(fidV,"nav_lon",nav_lon_ID)
         call erreur(status,.TRUE.,"inq_nav_lon_ID")
                                                              
       !Lecture des valeurs des variables qui nous interessent
         status = NF90_GET_VAR(fidV,vomecrty_ID,vomecrty)
         call erreur(status,.TRUE.,"getvar_vomecrty")
         status = NF90_GET_VAR(fidV,nav_lat_ID,nav_lat_V)
         call erreur(status,.TRUE.,"getvar_nav_lat")
         status = NF90_GET_VAR(fidV,nav_lon_ID,nav_lon_V)
         call erreur(status,.TRUE.,"getvar_nav_lon")
                                                      
     !Fermeture du fichier lu                         
       status = NF90_CLOSE(fidV)                      
       call erreur(status,.TRUE.,"fin_lecture")     


!------------------------------------------------------------------------------- 
!-------------------------------------------------------------------------------                                                     

!-------------------------------------------------------------------------------
! Remise des longitudes de 0 à 360 (utile pour l'interpolation):

do i=1,mx
do j=1,my
  if (nav_lon_T(i,j).lt.0.0) then
    nav_lon_T(i,j) = 360.0 + nav_lon_T(i,j)
  endif
enddo
do j=1,myu
  if (nav_lon_V(i,j).lt.0.0) then
    nav_lon_V(i,j) = 360.0 + nav_lon_V(i,j)
  endif
enddo  
enddo

do i=1,mxu
do j=1,my
  if (nav_lon_U(i,j).lt.0.0) then
    nav_lon_U(i,j) = 360.0 + nav_lon_U(i,j)
  endif
enddo
enddo


!-------------------------------------------------------------------------------
! Calcul des densite avel le module eos des CDFTOOLS-2.1

 ALLOCATE( sig0(mx,my,mdeptht,mtime_counter) )
 ALLOCATE( sig1(mx,my,mdeptht,mtime_counter) )
 ALLOCATE( sig2(mx,my,mdeptht,mtime_counter) )
 ALLOCATE( sig4(mx,my,mdeptht,mtime_counter) )

 do k=1,mdeptht
 do l=1,mtime_counter
      sig0(:,:,k,l)=sigma0(votemper(:,:,k,l),vosaline(:,:,k,l),mx,my)
      sig1(:,:,k,l)=sigmai(votemper(:,:,k,l),vosaline(:,:,k,l),1000.,mx,my)
      sig2(:,:,k,l)=sigmai(votemper(:,:,k,l),vosaline(:,:,k,l),2000.,mx,my)
      sig4(:,:,k,l)=sigmai(votemper(:,:,k,l),vosaline(:,:,k,l),4000.,mx,my)
 enddo
 enddo

!-------------------------------------------------------------------------------
! Calcul de la longueur des sections et des points modeles associes                 
        
  Ntot=SUM(N(:))
  write(*,*) '********** total number of points  :', Ntot
 
  ALLOCATE( latsec(Ntot) , lonsec(Ntot) , X1(Ntot) )
  ALLOCATE( votemper_sec(Ntot,mdeptht,mtime_counter) ) 
  ALLOCATE( vosaline_sec(Ntot,mdeptht,mtime_counter) )
  ALLOCATE( vozocrtx_sec(Ntot,mdepthu,mtime_counter) )
  ALLOCATE( vomecrty_sec(Ntot,mdepthv,mtime_counter) ) 
  ALLOCATE( Unorm(Ntot,mdeptht,mtime_counter) )
  ALLOCATE( Utang(Ntot,mdeptht,mtime_counter) )
  ALLOCATE( sigsec0(Ntot,mdeptht,mtime_counter) )
  ALLOCATE( sigsec1(Ntot,mdeptht,mtime_counter) )
  ALLOCATE( sigsec2(Ntot,mdeptht,mtime_counter) )
  ALLOCATE( sigsec4(Ntot,mdeptht,mtime_counter) )

! BOUCLE SUR LE NOMBRE DE SECTIONS Nsec A ACOLLER :
N2=0
! Point de référence pour la distance de la section (exple : dans OVIDE 60N 43.25W)
offset=RT * acos(cos(latref*rr)*cos(lat(1)*rr)*cos((lonref)*rr-lon(1)*rr)+sin(latref*rr)*sin(lat(1)*rr))
cont=0
DO p=1,Nsec
 N1=N2+1
 N2=N1+N(p)-1
 !longueur de la section p en km :
  d(p) = RT * acos(cos(lat(p)*rr)*cos(lat(p+1)*rr)*cos(lon(p+1)*rr-lon(p)*rr)+sin(lat(p)*rr)*sin(lat(p+1)*rr))
  write(*,102) p,d(p)
102 FORMAT('*** Section ',i4,' = ',f8.2, 'km')
  write(*,103) lat(p), lon(p), lat(p+1), lon(p+1)
103 FORMAT('     - from (lat,lon) = (',f6.2,',',f6.2,') to (',f6.2,',',f6.2,')')
 ! "pente" de la section 1 en radians / equateur (angle algebrique)
  if (lon(p).ne.lon(p+1)) then
    ang = atan((lat(p+1)-lat(p))/(lon(p+1)-lon(p)))
  else
    ang=pi/2.
  endif
  write(*,*) '    - angle / equateur (deg) =', ang/rr
 !coordonnées de tous les points de la section p en (lon,lat) et en km :
  DO s=N1,N2
    undefined(:)=.FALSE.
    latsec(s)=(lat(p+1)-lat(p))*FLOAT(s-N1+cont)/FLOAT(N2-N1+cont) + lat(p)
    lonsec(s)=(lon(p+1)-lon(p))*FLOAT(s-N1+cont)/FLOAT(N2-N1+cont) + lon(p)
    X1(s)=d(p)*FLOAT(s-N1+cont)/FLOAT(N2-N1+cont)+offset
    miniT=1000 !km
    miniU=miniT
    miniV=miniT
   ! recherche du point le plus proche (on fait comme ça parceque la grille est bizarre vers les poles)
    do i=1,mx
    do j=1,my
      dtmp_T= RT * acos(cos(nav_lat_T(i,j)*rr)*cos(latsec(s)*rr)*cos(nav_lon_T(i,j)*rr- &
     &        lonsec(s)*rr)+sin(nav_lat_T(i,j)*rr)*sin(latsec(s)*rr))
      dtmp_U= RT * acos(cos(nav_lat_U(i,j)*rr)*cos(latsec(s)*rr)*cos(nav_lon_U(i,j)*rr- &
     &        lonsec(s)*rr)+sin(nav_lat_U(i,j)*rr)*sin(latsec(s)*rr))
      dtmp_V= RT * acos(cos(nav_lat_V(i,j)*rr)*cos(latsec(s)*rr)*cos(nav_lon_V(i,j)*rr- &
     &        lonsec(s)*rr)+sin(nav_lat_V(i,j)*rr)*sin(latsec(s)*rr))
      if (dtmp_T.lt.miniT) then
          miniT=dtmp_T
          iiT=i
          jjT=j
      endif
      if (dtmp_U.lt.miniU) then
          miniU=dtmp_U
          iiU=i
          jjU=j
      endif
      if (dtmp_V.lt.miniV) then
          miniV=dtmp_V
          iiV=i
          jjV=j
      endif
    enddo
    enddo
   !interpolation des champs T:
    if (latsec(s).gt.60.0) then  
     !champs le plus proche de la section (U et V interpoles au point T)
      votemper_sec(s,:,:) = votemper(iiT,jjT,:,:)
      vosaline_sec(s,:,:) = vosaline(iiT,jjT,:,:)
      vozocrtx_sec(s,:,:) = vozocrtx(iiU,jjU,:,:)
      vomecrty_sec(s,:,:) = vomecrty(iiV,jjV,:,:)
     ! vitesse normale et tangeantielle a la section (section orientee vers le nord, tangeante à droite)
      Unorm(s,:,:) = vomecrty_sec(s,:,:)*cos(ang) - vozocrtx_sec(s,:,:)*sin(ang) 
      Utang(s,:,:) = vomecrty_sec(s,:,:)*sin(ang) + vozocrtx_sec(s,:,:)*cos(ang)
     ! densites :
      sigsec0(s,:,:) = MAX(sig0(iiT,jjT,:,:),10.0)
      sigsec1(s,:,:) = MAX(sig1(iiT,jjT,:,:),10.0)
      sigsec2(s,:,:) = MAX(sig2(iiT,jjT,:,:),10.0)
      sigsec4(s,:,:) = MAX(sig4(iiT,jjT,:,:),20.0)
    else
     ! Champs T interpoles
      if (lonsec(s).ge.nav_lon_T(iiT,jjT)) then
        iinf=iiT
        if ( iiT+1.le.mx ) then
          isup=iiT+1
        else
          isup=1
        endif
      else
        if ( iiT-1.ge.1 ) then
          iinf=iiT-1
        else
          iinf=mx
        endif
        isup=iiT
      endif
      if (latsec(s).ge.nav_lat_T(iiT,jjT)) then
        jinf=jjT
        jsup=jjT+1
      else
        jinf=jjT-1
        jsup=jjT
      endif
      loninf=nav_lon_T(iinf,jjT)
      lonsup=nav_lon_T(isup,jjT)
      latinf=nav_lat_T(iiT,jinf)
      latsup=nav_lat_T(iiT,jsup)
      a=(lonsec(s)-loninf)/(lonsup-loninf)
      b=(lonsup-lonsec(s))/(lonsup-loninf)
      c=(latsec(s)-latinf)/(latsup-latinf)
      e=(latsup-latsec(s))/(latsup-latinf)
      votemper_sec(s,:,:) =  c*(a*votemper(isup,jsup,:,:)+b*votemper(iinf,jsup,:,:)) &
&                           +e*(a*votemper(isup,jinf,:,:)+b*votemper(iinf,jinf,:,:))
      vosaline_sec(s,:,:) =  c*(a*vosaline(isup,jsup,:,:)+b*vosaline(iinf,jsup,:,:)) &
&                           +e*(a*vosaline(isup,jinf,:,:)+b*vosaline(iinf,jinf,:,:))
      sigsec0(s,:,:) =  c*(a*sig0(isup,jsup,:,:)+b*sig0(iinf,jsup,:,:)) &
&                      +e*(a*sig0(isup,jinf,:,:)+b*sig0(iinf,jinf,:,:))
      sigsec0(s,:,:) = MAX(sigsec0(s,:,:),10.0)
      sigsec1(s,:,:) =  c*(a*sig1(isup,jsup,:,:)+b*sig1(iinf,jsup,:,:)) &
&                      +e*(a*sig1(isup,jinf,:,:)+b*sig1(iinf,jinf,:,:))
      sigsec1(s,:,:) = MAX(sigsec1(s,:,:),10.0)
      sigsec2(s,:,:) =  c*(a*sig2(isup,jsup,:,:)+b*sig2(iinf,jsup,:,:)) &
&                      +e*(a*sig2(isup,jinf,:,:)+b*sig2(iinf,jinf,:,:))
      sigsec2(s,:,:) = MAX(sigsec2(s,:,:),10.0)
      sigsec4(s,:,:) =  c*(a*sig4(isup,jsup,:,:)+b*sig4(iinf,jsup,:,:)) &
&                      +e*(a*sig4(isup,jinf,:,:)+b*sig4(iinf,jinf,:,:))
      sigsec4(s,:,:) = MAX(sigsec4(s,:,:),20.0)
     ! test si valeurs indefinies sur un des 4 points :
      do k=1,mdeptht
        if ((vosaline(iinf,jinf,k,1).eq.missing).or.(vosaline(iinf,jsup,k,1).eq.missing).or.&
&           (vosaline(isup,jinf,k,1).eq.missing).or.(vosaline(isup,jsup,k,1).eq.missing)   ) then
          votemper_sec(s,:,:) = votemper(iiT,jjT,:,:)
          vosaline_sec(s,:,:) = vosaline(iiT,jjT,:,:)
          vozocrtx_sec(s,:,:) = vozocrtx(iiU,jjU,:,:)
          vomecrty_sec(s,:,:) = vomecrty(iiV,jjV,:,:)
          sigsec0(s,:,:) = MAX(sig0(iiT,jjT,:,:),10.0)
          sigsec1(s,:,:) = MAX(sig1(iiT,jjT,:,:),10.0)
          sigsec2(s,:,:) = MAX(sig2(iiT,jjT,:,:),10.0)
          sigsec4(s,:,:) = MAX(sig4(iiT,jjT,:,:),20.0) 
          undefined(k)=.TRUE.
        endif
      enddo
     ! Champs U interpoles
      if (lonsec(s).ge.nav_lon_U(iiU,jjU)) then
        iinf=iiU
        if ( iiU+1.le.mx ) then
          isup=iiU+1
        else
          isup=1
        endif
      else
        if ( iiU-1.ge.1 ) then
          iinf=iiU-1
        else
          iinf=mx
        endif
        isup=iiU
      endif
      if (latsec(s).ge.nav_lat_U(iiU,jjU)) then
       jinf=jjU
       jsup=jjU+1
      else
       jinf=jjU-1
       jsup=jjU
      endif
      loninf=nav_lon_U(iinf,jjU)
      lonsup=nav_lon_U(isup,jjU)
      latinf=nav_lat_U(iiU,jinf)
      latsup=nav_lat_U(iiU,jsup)
      a=(lonsec(s)-loninf)/(lonsup-loninf)
      b=(lonsup-lonsec(s))/(lonsup-loninf)
      c=(latsec(s)-latinf)/(latsup-latinf)
      e=(latsup-latsec(s))/(latsup-latinf)
      vozocrtx_sec(s,:,:) =  c*(a*vozocrtx(isup,jsup,:,:)+b*vozocrtx(iinf,jsup,:,:)) &
&                           +e*(a*vozocrtx(isup,jinf,:,:)+b*vozocrtx(iinf,jinf,:,:))
     ! Champs V interpoles
      if (lonsec(s).ge.nav_lon_U(iiU,jjU)) then
        iinf=iiU
        if ( iiU+1.le.mx ) then
          isup=iiU+1
        else
          isup=1
        endif
      else
        if ( iiU-1.ge.1 ) then
          iinf=iiU-1
        else
          iinf=mx
        endif
        isup=iiU
      endif
      if (latsec(s).ge.nav_lat_V(iiV,jjV)) then
       jinf=jjV
       jsup=jjV+1
      else
       jinf=jjV-1
       jsup=jjV
      endif
      loninf=nav_lon_V(iinf,jjV)
      lonsup=nav_lon_V(isup,jjV)
      latinf=nav_lat_V(iiV,jinf)
      latsup=nav_lat_V(iiV,jsup)
      a=(lonsec(s)-loninf)/(lonsup-loninf)
      b=(lonsup-lonsec(s))/(lonsup-loninf)
      c=(latsec(s)-latinf)/(latsup-latinf)
      e=(latsup-latsec(s))/(latsup-latinf)
      vomecrty_sec(s,:,:) =  c*(a*vomecrty(isup,jsup,:,:)+b*vomecrty(iinf,jsup,:,:)) &
&                           +e*(a*vomecrty(isup,jinf,:,:)+b*vomecrty(iinf,jinf,:,:))
     ! si l'un des 4 points de l'interpolation etait indefini :
      do k=1,mdeptht
        if (undefined(k)) then
          vozocrtx_sec(s,k,:) = vozocrtx(iiU,jjU,k,:)
          vomecrty_sec(s,k,:) = vomecrty(iiV,jjV,k,:)
        endif
      enddo
     ! vitesse normale et tangeantielle a la section (section orientee vers le nord, tangeante à droite)
      Unorm(s,:,:) = vomecrty_sec(s,:,:)*cos(ang) - vozocrtx_sec(s,:,:)*sin(ang)
      Utang(s,:,:) = vomecrty_sec(s,:,:)*sin(ang) + vozocrtx_sec(s,:,:)*cos(ang)
    endif
  ENDDO !- s nb de points sur section p
  cont=1
  offset=X1(N2)
ENDDO !- p nb de sections 
      
!----------------------------------------------------------                                                      
!----------------------------------------------------------    
! Writing new netcdf file :                                   
                                                              
        status = NF90_CREATE(TRIM(file_out),NF90_NOCLOBBER,fidM)
        call erreur(status,.TRUE.,'create')                     
                                                                
        !Definition des dimensions du fichiers                  
         status = NF90_DEF_DIM(fidM,"time_counter",NF90_UNLIMITED,dimID_time_counter)
         call erreur(status,.TRUE.,"def_dimID_time_counter")
         status = NF90_DEF_DIM(fidM,"deptht",mdeptht,dimID_deptht)
         call erreur(status,.TRUE.,"def_dimID_deptht")
         status = NF90_DEF_DIM(fidM,"X",Ntot,dimID_s)
         call erreur(status,.TRUE.,"def_dimID_s")
                                                              
        !Definition des variables                             
         status = NF90_DEF_VAR(fidM,"vosaline",NF90_FLOAT,(/dimID_s,dimID_deptht,dimID_time_counter/),vosaline_ID)
         call erreur(status,.TRUE.,"def_var_vosaline_ID")
         status = NF90_DEF_VAR(fidM,"votemper",NF90_FLOAT,(/dimID_s,dimID_deptht,dimID_time_counter/),votemper_ID)
         call erreur(status,.TRUE.,"def_var_votemper_ID")
         status = NF90_DEF_VAR(fidM,"time_counter",NF90_FLOAT,(/dimID_time_counter/),time_counter_ID)
         call erreur(status,.TRUE.,"def_var_time_counter_ID")
         status = NF90_DEF_VAR(fidM,"deptht",NF90_FLOAT,(/dimID_deptht/),deptht_ID)
         call erreur(status,.TRUE.,"def_var_deptht_ID")
         status = NF90_DEF_VAR(fidM,"nav_lat",NF90_FLOAT,(/dimID_s/),nav_lat_ID)
         call erreur(status,.TRUE.,"def_var_nav_lat_ID")
         status = NF90_DEF_VAR(fidM,"nav_lon",NF90_FLOAT,(/dimID_s/),nav_lon_ID)
         call erreur(status,.TRUE.,"def_var_nav_lon_ID")
         status = NF90_DEF_VAR(fidM,"X",NF90_DOUBLE,(/dimID_s/),X_ID)
         call erreur(status,.TRUE.,"def_var_X_ID")     
         status = NF90_DEF_VAR(fidM,"Uorth",NF90_FLOAT,(/dimID_s,dimID_deptht,dimID_time_counter/),Unorm_ID)
         call erreur(status,.TRUE.,"def_var_Unorm_ID")    
         status = NF90_DEF_VAR(fidM,"Utang",NF90_FLOAT,(/dimID_s,dimID_deptht,dimID_time_counter/),Utang_ID)
         call erreur(status,.TRUE.,"def_var_Utang_ID")
         status = NF90_DEF_VAR(fidM,"sig0",NF90_FLOAT,(/dimID_s,dimID_deptht,dimID_time_counter/),sig0_ID)
         call erreur(status,.TRUE.,"def_var_sig0_ID")
         status = NF90_DEF_VAR(fidM,"sig1",NF90_FLOAT,(/dimID_s,dimID_deptht,dimID_time_counter/),sig1_ID)
         call erreur(status,.TRUE.,"def_var_sig1_ID")
         status = NF90_DEF_VAR(fidM,"sig2",NF90_FLOAT,(/dimID_s,dimID_deptht,dimID_time_counter/),sig2_ID)
         call erreur(status,.TRUE.,"def_var_sig2_ID")
         status = NF90_DEF_VAR(fidM,"sig4",NF90_FLOAT,(/dimID_s,dimID_deptht,dimID_time_counter/),sig4_ID)
         call erreur(status,.TRUE.,"def_var_sig4_ID")

                          
        ! Attributs des variables :
         status = NF90_PUT_ATT(fidM,vosaline_ID,"online_operation","N/A")
         call erreur(status,.TRUE.,"put_att_vosaline_ID")
         status = NF90_PUT_ATT(fidM,vosaline_ID,"short_name","vosaline")
         call erreur(status,.TRUE.,"put_att_vosaline_ID")
         status = NF90_PUT_ATT(fidM,vosaline_ID,"long_name","sea_water_salinity")
         call erreur(status,.TRUE.,"put_att_vosaline_ID")
         status = NF90_PUT_ATT(fidM,vosaline_ID,"valid_max",45.)
         call erreur(status,.TRUE.,"put_att_vosaline_ID")
         status = NF90_PUT_ATT(fidM,vosaline_ID,"valid_min",0.)
         call erreur(status,.TRUE.,"put_att_vosaline_ID")
         status = NF90_PUT_ATT(fidM,vosaline_ID,"missing_value",0.)
         call erreur(status,.TRUE.,"put_att_vosaline_ID")
         status = NF90_PUT_ATT(fidM,vosaline_ID,"units","PSU")
         call erreur(status,.TRUE.,"put_att_vosaline_ID")

         status = NF90_PUT_ATT(fidM,votemper_ID,"online_operation","N/A")
         call erreur(status,.TRUE.,"put_att_votemper_ID")
         status = NF90_PUT_ATT(fidM,votemper_ID,"short_name","votemper")
         call erreur(status,.TRUE.,"put_att_votemper_ID")
         status = NF90_PUT_ATT(fidM,votemper_ID,"long_name","sea_water_potential_temperature")
         call erreur(status,.TRUE.,"put_att_votemper_ID")
         status = NF90_PUT_ATT(fidM,votemper_ID,"valid_max",45.)
         call erreur(status,.TRUE.,"put_att_votemper_ID")
         status = NF90_PUT_ATT(fidM,votemper_ID,"valid_min",-2.)
         call erreur(status,.TRUE.,"put_att_votemper_ID")
         status = NF90_PUT_ATT(fidM,votemper_ID,"missing_value",0.)
         call erreur(status,.TRUE.,"put_att_votemper_ID")
         status = NF90_PUT_ATT(fidM,votemper_ID,"units","C")
         call erreur(status,.TRUE.,"put_att_votemper_ID")

         status = NF90_PUT_ATT(fidM,time_counter_ID,"time_origin","2001-OCT-03 00:00:00")
         call erreur(status,.TRUE.,"put_att_time_counter_ID")
         status = NF90_PUT_ATT(fidM,time_counter_ID,"units","seconds since 2001-10-03 00:00:00")
         call erreur(status,.TRUE.,"put_att_time_counter_ID")
         status = NF90_PUT_ATT(fidM,time_counter_ID,"long_name","Time axis")
         call erreur(status,.TRUE.,"put_att_time_counter_ID")
         status = NF90_PUT_ATT(fidM,time_counter_ID,"title","Time")
         call erreur(status,.TRUE.,"put_att_time_counter_ID")
         status = NF90_PUT_ATT(fidM,time_counter_ID,"calendar","gregorian")
         call erreur(status,.TRUE.,"put_att_time_counter_ID")

         status = NF90_PUT_ATT(fidM,deptht_ID,"long_name","Vertical T levels")
         call erreur(status,.TRUE.,"put_att_deptht_ID")
         status = NF90_PUT_ATT(fidM,deptht_ID,"title","deptht")
         call erreur(status,.TRUE.,"put_att_deptht_ID")
         status = NF90_PUT_ATT(fidM,deptht_ID,"valid_max",50.)
         call erreur(status,.TRUE.,"put_att_deptht_ID")
         status = NF90_PUT_ATT(fidM,deptht_ID,"valid_min",0.)
         call erreur(status,.TRUE.,"put_att_deptht_ID")
         status = NF90_PUT_ATT(fidM,deptht_ID,"positive","unknown")
         call erreur(status,.TRUE.,"put_att_deptht_ID")
         status = NF90_PUT_ATT(fidM,deptht_ID,"units","m")
         call erreur(status,.TRUE.,"put_att_deptht_ID")

         status = NF90_PUT_ATT(fidM,nav_lat_ID,"long_name","Latitude")
         call erreur(status,.TRUE.,"put_att_nav_lat_ID")
         status = NF90_PUT_ATT(fidM,nav_lat_ID,"scale_factor",1.)
         call erreur(status,.TRUE.,"put_att_nav_lat_ID")
         status = NF90_PUT_ATT(fidM,nav_lat_ID,"add_offset",0.)
         call erreur(status,.TRUE.,"put_att_nav_lat_ID")
         status = NF90_PUT_ATT(fidM,nav_lat_ID,"valid_max",89.947868347168)
         call erreur(status,.TRUE.,"put_att_nav_lat_ID")
         status = NF90_PUT_ATT(fidM,nav_lat_ID,"valid_min",-77.0104751586914)
         call erreur(status,.TRUE.,"put_att_nav_lat_ID")
         status = NF90_PUT_ATT(fidM,nav_lat_ID,"units","degrees_north")
         call erreur(status,.TRUE.,"put_att_nav_lat_ID")

         status = NF90_PUT_ATT(fidM,nav_lon_ID,"long_name","Longitude")
         call erreur(status,.TRUE.,"put_att_nav_lon_ID")
         status = NF90_PUT_ATT(fidM,nav_lon_ID,"scale_factor",1.)
         call erreur(status,.TRUE.,"put_att_nav_lon_ID")
         status = NF90_PUT_ATT(fidM,nav_lon_ID,"add_offset",0.)
         call erreur(status,.TRUE.,"put_att_nav_lon_ID")
         status = NF90_PUT_ATT(fidM,nav_lon_ID,"valid_max",180.)
         call erreur(status,.TRUE.,"put_att_nav_lon_ID")
         status = NF90_PUT_ATT(fidM,nav_lon_ID,"valid_min",-180.)
         call erreur(status,.TRUE.,"put_att_nav_lon_ID")
         status = NF90_PUT_ATT(fidM,nav_lon_ID,"units","degrees_east")
         call erreur(status,.TRUE.,"put_att_nav_lon_ID")

         status = NF90_PUT_ATT(fidM,X_ID,"nav_model","Default grid")
         call erreur(status,.TRUE.,"put_att_X_ID")
         status = NF90_PUT_ATT(fidM,X_ID,"long_name","X")
         call erreur(status,.TRUE.,"put_att_X_ID")
         status = NF90_PUT_ATT(fidM,X_ID,"scale_factor",1.)
         call erreur(status,.TRUE.,"put_att_X_ID")
         status = NF90_PUT_ATT(fidM,X_ID,"add_offset",0.)
         call erreur(status,.TRUE.,"put_att_X_ID")
         status = NF90_PUT_ATT(fidM,X_ID,"units","km")
         call erreur(status,.TRUE.,"put_att_X_ID")

         status = NF90_PUT_ATT(fidM,Unorm_ID,"online_operation","N/A")
         call erreur(status,.TRUE.,"put_att_Unorm_ID")
         status = NF90_PUT_ATT(fidM,Unorm_ID,"short_name","Uorth")
         call erreur(status,.TRUE.,"put_att_Unorm_ID")
         status = NF90_PUT_ATT(fidM,Unorm_ID,"long_name","ocean speed orthogonal to the section oriented south-north")
         call erreur(status,.TRUE.,"put_att_Unorm_ID")
         status = NF90_PUT_ATT(fidM,Unorm_ID,"valid_max",10.)
         call erreur(status,.TRUE.,"put_att_Unorm_ID")
         status = NF90_PUT_ATT(fidM,Unorm_ID,"valid_min",-10.)
         call erreur(status,.TRUE.,"put_att_Unorm_ID")
         status = NF90_PUT_ATT(fidM,Unorm_ID,"missing_value",0.)
         call erreur(status,.TRUE.,"put_att_Unorm_ID")
         status = NF90_PUT_ATT(fidM,Unorm_ID,"units","m/s")
         call erreur(status,.TRUE.,"put_att_Unorm_ID")

         status = NF90_PUT_ATT(fidM,Utang_ID,"online_operation","N/A")
         call erreur(status,.TRUE.,"put_att_Utang_ID")
         status = NF90_PUT_ATT(fidM,Utang_ID,"short_name","Utang")
         call erreur(status,.TRUE.,"put_att_Utang_ID")
         status = NF90_PUT_ATT(fidM,Utang_ID,"long_name","ocean speed tangential to the section oriented south-north")
         call erreur(status,.TRUE.,"put_att_Utang_ID")
         status = NF90_PUT_ATT(fidM,Utang_ID,"valid_max",10.)
         call erreur(status,.TRUE.,"put_att_Utang_ID")
         status = NF90_PUT_ATT(fidM,Utang_ID,"valid_min",-10.)
         call erreur(status,.TRUE.,"put_att_Utang_ID")
         status = NF90_PUT_ATT(fidM,Utang_ID,"missing_value",0.)
         call erreur(status,.TRUE.,"put_att_Utang_ID")
         status = NF90_PUT_ATT(fidM,Utang_ID,"units","m/s")
         call erreur(status,.TRUE.,"put_att_Utang_ID")
                         
         status = NF90_PUT_ATT(fidM,sig0_ID,"short_name","sig0")
         call erreur(status,.TRUE.,"put_att_sig0_ID")
         status = NF90_PUT_ATT(fidM,sig0_ID,"long_name","Potential Density Sigma 0")
         call erreur(status,.TRUE.,"put_att_sig0_ID")
         status = NF90_PUT_ATT(fidM,sig0_ID,"valid_max",100.)
         call erreur(status,.TRUE.,"put_att_sig0_ID")
         status = NF90_PUT_ATT(fidM,sig0_ID,"valid_min",10.0)
         call erreur(status,.TRUE.,"put_att_sig0_ID")
         status = NF90_PUT_ATT(fidM,sig0_ID,"missing_value",10.0)
         call erreur(status,.TRUE.,"put_att_sig0_ID")
         status = NF90_PUT_ATT(fidM,sig0_ID,"units","kg/m3")
         call erreur(status,.TRUE.,"put_att_sig0_ID")

         status = NF90_PUT_ATT(fidM,sig1_ID,"short_name","sig1")
         call erreur(status,.TRUE.,"put_att_sig1_ID")
         status = NF90_PUT_ATT(fidM,sig1_ID,"long_name","Potential Density Sigma 0")
         call erreur(status,.TRUE.,"put_att_sig1_ID")
         status = NF90_PUT_ATT(fidM,sig1_ID,"valid_max",100.)
         call erreur(status,.TRUE.,"put_att_sig1_ID")
         status = NF90_PUT_ATT(fidM,sig1_ID,"valid_min",10.0)
         call erreur(status,.TRUE.,"put_att_sig1_ID")
         status = NF90_PUT_ATT(fidM,sig1_ID,"missing_value",10.0)
         call erreur(status,.TRUE.,"put_att_sig1_ID")
         status = NF90_PUT_ATT(fidM,sig1_ID,"units","kg/m3")
         call erreur(status,.TRUE.,"put_att_sig1_ID")

         status = NF90_PUT_ATT(fidM,sig2_ID,"short_name","sig2")
         call erreur(status,.TRUE.,"put_att_sig2_ID")
         status = NF90_PUT_ATT(fidM,sig2_ID,"long_name","Potential Density Sigma 0")
         call erreur(status,.TRUE.,"put_att_sig2_ID")
         status = NF90_PUT_ATT(fidM,sig2_ID,"valid_max",100.)
         call erreur(status,.TRUE.,"put_att_sig2_ID")
         status = NF90_PUT_ATT(fidM,sig2_ID,"valid_min",10.0)
         call erreur(status,.TRUE.,"put_att_sig2_ID")
         status = NF90_PUT_ATT(fidM,sig2_ID,"missing_value",10.0)
         call erreur(status,.TRUE.,"put_att_sig2_ID")
         status = NF90_PUT_ATT(fidM,sig2_ID,"units","kg/m3")
         call erreur(status,.TRUE.,"put_att_sig2_ID")

         status = NF90_PUT_ATT(fidM,sig4_ID,"short_name","sig4")
         call erreur(status,.TRUE.,"put_att_sig4_ID")
         status = NF90_PUT_ATT(fidM,sig4_ID,"long_name","Potential Density Sigma 0")
         call erreur(status,.TRUE.,"put_att_sig4_ID")
         status = NF90_PUT_ATT(fidM,sig4_ID,"valid_max",100.)
         call erreur(status,.TRUE.,"put_att_sig4_ID")
         status = NF90_PUT_ATT(fidM,sig4_ID,"valid_min",20.0)
         call erreur(status,.TRUE.,"put_att_sig4_ID")
         status = NF90_PUT_ATT(fidM,sig4_ID,"missing_value",20.0)
         call erreur(status,.TRUE.,"put_att_sig4_ID")
         status = NF90_PUT_ATT(fidM,sig4_ID,"units","kg/m3")
         call erreur(status,.TRUE.,"put_att_sig4_ID")

        ! Attributs globaux       :
         status = NF90_PUT_ATT(fidM,NF90_GLOBAL,"history","Created by cdfsections (see CDFTOOLS)")
         call erreur(status,.TRUE.,"put_att_global_ID")
                                                      
        !Fin des definitions                          
         status = NF90_ENDDEF(fidM)                   
         call erreur(status,.TRUE.,"fin_definition") 
                                                      
        !Valeurs prises par les variables :           
         status = NF90_PUT_VAR(fidM,vosaline_ID,vosaline_sec)
         call erreur(status,.TRUE.,"var_vosaline_ID")
         status = NF90_PUT_VAR(fidM,votemper_ID,votemper_sec)
         call erreur(status,.TRUE.,"var_votemper_ID")
         status = NF90_PUT_VAR(fidM,time_counter_ID,time_counter)
         call erreur(status,.TRUE.,"var_time_counter_ID")
         status = NF90_PUT_VAR(fidM,deptht_ID,deptht)
         call erreur(status,.TRUE.,"var_deptht_ID")
         status = NF90_PUT_VAR(fidM,nav_lat_ID,latsec)
         call erreur(status,.TRUE.,"var_nav_lat_ID")
         status = NF90_PUT_VAR(fidM,nav_lon_ID,lonsec)
         call erreur(status,.TRUE.,"var_nav_lon_ID")
         status = NF90_PUT_VAR(fidM,X_ID,X1)
         call erreur(status,.TRUE.,"var_X_ID")
         status = NF90_PUT_VAR(fidM,Unorm_ID,Unorm)
         call erreur(status,.TRUE.,"var_Unorm_ID")
         status = NF90_PUT_VAR(fidM,Utang_ID,Utang)
         call erreur(status,.TRUE.,"var_Utang_ID") 
         status = NF90_PUT_VAR(fidM,sig0_ID,sigsec0)
         call erreur(status,.TRUE.,"var_sig0_ID")
         status = NF90_PUT_VAR(fidM,sig1_ID,sigsec1)
         call erreur(status,.TRUE.,"var_sig1_ID")
         status = NF90_PUT_VAR(fidM,sig2_ID,sigsec2)
         call erreur(status,.TRUE.,"var_sigsec2_ID") 
         status = NF90_PUT_VAR(fidM,sig4_ID,sigsec4)
         call erreur(status,.TRUE.,"var_sigsec4_ID")         
                                    
        !Fin de l'ecriture                            
         status = NF90_CLOSE(fidM)                    
         call erreur(status,.TRUE.,"final")         

end program cdfsections



SUBROUTINE erreur(iret, lstop, chaine)
  ! pour les messages d'erreur
  USE netcdf
  INTEGER, INTENT(in)                     :: iret
  LOGICAL, INTENT(in)                     :: lstop
  CHARACTER(LEN=*), INTENT(in)            :: chaine
  !
  CHARACTER(LEN=256)                       :: message
  !
  IF ( iret .NE. 0 ) THEN
    WRITE(*,*) 'ROUTINE: ', TRIM(chaine)
    WRITE(*,*) 'ERREUR: ', iret
    message=NF90_STRERROR(iret)
    WRITE(*,*) 'THIS MEANS :',TRIM(message)
    IF ( lstop ) STOP
  ENDIF
  !
END SUBROUTINE erreur

PROGRAM cdfocape
  !!======================================================================
  !!                     ***  PROGRAM cdfocape   ***
  !!=====================================================================
  !!  ** Purpose : Compute ocean convective potential energy
  !!
  !!  ** Method  : Paul Myers
  !!
  !! History :  4.0  : 06/2019  : P. Verezemskaya : J.M. Molines :  
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  !!   routines      : description
  !!----------------------------------------------------------------------
  USE cdfio
  USE eos
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017
  !! $Id$
  !! Copyright (c) 2012, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE
  
  INTEGER(KIND=4)                           :: jk, jti, it, jt    ! dummy loop index
  INTEGER(KIND=4)                           :: iimin=0, iimax=0   ! domain limitation for computation
  INTEGER(KIND=4)                           :: ijmin=0, ijmax=0   ! domain limitation for computation
  INTEGER(KIND=4)                           :: ierr               ! error status
  INTEGER(KIND=4)                           :: narg, iargc, ijarg ! browse command line
  INTEGER(KIND=4)                           :: npiglo, npjglo     ! size of the domain
  INTEGER(KIND=4)                           :: npiglo_fi, npjglo_fi ! size of the zoomed domain
  INTEGER(KIND=4)                           :: npk, npt           ! size of the domain
  INTEGER(KIND=4)                           :: ncout, ncout1d     ! ncid of output file
  INTEGER(KIND=4), DIMENSION(2)             :: ipk, ipk1d         ! level 
  INTEGER(KIND=4), DIMENSION(2)             :: id_varout          ! varid's
  INTEGER(KIND=4), DIMENSION(2)             :: id_varout1d        ! varid's

  REAL(KIND=4)                              :: grvt=9.8           ! gravity constant (m/s2)
  REAL(KIND=4), DIMENSION(1)                :: zarea              ! area of a domain points
  REAL(KIND=4), DIMENSION(1)                :: zcape_int          ! area of a domain points
  REAL(KIND=4)                              :: zspval             ! missing value
  REAL(KIND=4)                              :: ref_dep            ! reference depth
  REAL(KIND=4), DIMENSION(:), ALLOCATABLE   :: gdep               ! depth array
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e1t                ! e1t - dz for integration
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e2t                ! e2t - dz for integration
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e3t                ! e3t - dz for integration
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: hdept              ! real depth
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zmask              ! mask 
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: ztemp              ! temperature
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zsal               ! salinity

  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: zsigh              ! sigma at h level
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: zsigz              ! sigma at z level
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: zsigvi             ! vertically integrated sigma
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: zcape              ! convective energy
  REAL(KIND=8), DIMENSION(:),   ALLOCATABLE :: dtim               ! time counter

  CHARACTER(LEN=256)                        :: cf_tfil            ! input filename
  CHARACTER(LEN=256)                        :: cf_sfil            ! salinity file (option)
  CHARACTER(LEN=256)                        :: cf_root            ! readable name
  CHARACTER(LEN=256)                        :: cf_out='ocape.nc'  ! output file name
  CHARACTER(LEN=256)                        :: cf_out_int='intocape.nc' ! integral output file name
  CHARACTER(LEN=256)                        :: cv_out='vocape'         ! 2d ocape name
  CHARACTER(LEN=256)                        :: cv_out_name='vocape'         ! 2d ocape name
  CHARACTER(LEN=256)                        :: cv_out_int='iocape'     ! integral ocape name
  CHARACTER(LEN=256)                        :: cv_out_name_int='iocape'     ! integral ocape name
  CHARACTER(LEN=256)                        :: cldum              ! dummy string
  CHARACTER(LEN=256)                        :: cv_msk='tmask'     ! mask

  TYPE (variable), DIMENSION(2)             :: stypvar            ! structure for attributes
  TYPE (variable), DIMENSION(2)             :: stypvar1d          ! structure for attributes int

  LOGICAL                                   :: lchk  = .FALSE.    ! flag for missing files
  LOGICAL                                   :: lnc4  = .FALSE.    ! flag for missing files
  !!--------------------------------------------------------------------------------------
  CALL ReadCdfNames()
  !!  Read command line and output usage message if not compliant.
  
  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfocape -dep REF-dep -t T-file [-s S-file] [-w imin imax jmin jmax]'
     PRINT *,'                   [-nc4] [-o OUT-file] '  
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'        Compute OCAPE (Ocean Convective Available Potential Energy) from TS '
     PRINT *,'        and vertical integration. '
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'        -dep REF-dep : reference depth to which you want to ventilate the ocean '
     PRINT *,'        -t T-file : name of the file holding temperature and salinity '
     PRINT *,'      '
     PRINT *,'     OPTIONS :'  
     PRINT *,'        -s S-file : Specify salinity file if not T-file. ' 
     PRINT *,'        -w imin imax jmin jmax : spatial window where mean value'
     PRINT *,'           is computed:'
     PRINT *,'                  if imin = 0 then ALL i are taken'
     PRINT *,'                  if jmin = 0 then ALL j are taken'
     PRINT *,'        -o : Specify output file name instead of ocape.nc ' 
     PRINT *,'        -nc4 : Use netcdf4 output with chunking and deflation level 1 ' 
     PRINT *,'         This option is effective only if cdftools are compiled with' 
     PRINT *,'         a netcdf library supporting chunking and deflation.' 
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'     mesh_hgr.nc, mesh_zgr.nc, mask.nc '
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ocape.nc '           , TRIM(cf_out) 
     PRINT *,'         variables : 2d ocape '           , TRIM(cv_out),' ( Joules/m3 )'
     PRINT *,'       netcdf file : intocape.nc '        , TRIM(cf_out_int) 
     PRINT *,'         variables : weighted mean ocape ', TRIM(cv_out_int),' ( Joules/m3 )'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'       cdfsigi, cdfmxl '
     PRINT *,'      '
     STOP
  ENDIF

  cf_tfil='none'
  cf_sfil='none'

  ijarg = 1
  cf_sfil='none' 
  DO WHILE ( ijarg <= narg )
     CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-t'   ) ; CALL getarg(ijarg, cf_tfil ) ; ijarg=ijarg+1
     CASE ( '-dep' ) ; CALL getarg(ijarg, cldum )   ; ijarg=ijarg+1 ; READ(cldum,*) ref_dep
        ! option
     CASE ( '-s'   ) ; CALL getarg (ijarg, cf_sfil) ; ijarg=ijarg+1
     CASE ( '-w'   ) ; CALL getarg(ijarg, cldum   ) ; ijarg=ijarg+1 ; READ(cldum,*) iimin
                     ; CALL getarg(ijarg, cldum   ) ; ijarg=ijarg+1 ; READ(cldum,*) iimax
                     ; CALL getarg(ijarg, cldum   ) ; ijarg=ijarg+1 ; READ(cldum,*) ijmin
                     ; CALL getarg(ijarg, cldum   ) ; ijarg=ijarg+1 ; READ(cldum,*) ijmax
     CASE ( '-o'   ) ; CALL getarg(ijarg, cf_root ) ; ijarg=ijarg+1
     CASE ( '-nc4' ) ; lnc4 = .TRUE.
     CASE DEFAULT    ; PRINT *, ' ERROR : ', TRIM(cldum),' : unknown option.'; STOP 1
     END SELECT
  ENDDO

 WRITE(cldum, '(I4.4)') INT(ref_dep)

 ! Define file names according to the one specified without .nc
 cf_out=TRIM(cf_root )//'ocape'//TRIM(cldum)//'.nc'
 cf_out_int=TRIM(cf_root)//'iocape'//TRIM(cldum)//'.nc'

 PRINT *, ref_dep

  IF ( cf_sfil == 'none' ) cf_sfil=cf_tfil
  ! check for missing files - obligatory
  ! Check file existence mask, hgr, zgr:
  lchk = lchk .OR. chkfile( cn_fhgr )
  lchk = lchk .OR. chkfile( cn_fzgr )
  lchk = lchk .OR. chkfile( cn_fmsk )
  lchk = lchk .OR. chkfile( cf_tfil )   ! chkfile is returning F when input file name is 'none'
  lchk = lchk .OR. chkfile( cf_sfil )   ! chkfile is returning F when input file name is 'none'
  IF ( lchk ) STOP 99 ! missing files

  ! Read the domain dimensions - obgigatory
  npiglo = getdim (cf_tfil, cn_x)
  npjglo = getdim (cf_tfil, cn_y)
  npk    = getdim (cf_tfil, cn_z)
  npt    = getdim (cf_tfil, cn_t)

  ! save original npiglo, npiglo - for zoom
  npiglo_fi = npiglo
  npjglo_fi = npjglo
  ! Set new npiglo, npjglo according to zoom
  IF (iimin /= 0 ) THEN ; npiglo = iimax -iimin + 1;  ELSE ; iimin=1 ;
  ENDIF
  IF (ijmin /= 0 ) THEN ; npjglo = ijmax -ijmin + 1;  ELSE ; ijmin=1 ;
  ENDIF

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt
  
  ! Allocate aarays for read, compute and write + time
  ALLOCATE (ztemp(npiglo,npjglo), zsal (npiglo,npjglo))
  ALLOCATE (zsigh(npiglo,npjglo), zsigz (npiglo,npjglo))
  ALLOCATE (zsigvi(npiglo,npjglo), e3t(npiglo,npjglo))
  ALLOCATE ( e1t(npiglo,npjglo), e2t(npiglo,npjglo)) 
  ALLOCATE (zcape(npiglo,npjglo), zmask (npiglo,npjglo))
  ALLOCATE (hdept(npiglo,npjglo))
  ALLOCATE (dtim(npt) , gdep(npk))

  ! Prepare output netcdf files 

  ! The strange thing is that the main part starts here!
  CALL CreateOutput
  
  ! first read missing vaue for salinity
  zspval= getatt(cf_sfil, cn_vosaline, cn_missing_value)
  gdep(:) = getvare3(cn_fzgr, cn_gdept, npk)
  hdept(:,:) = getvar(cn_fzgr, cn_hdept, 1, npiglo, npjglo)
  e1t(:,:) =  getvar(cn_fhgr, cn_ve1t, 1, npiglo, npjglo)
  e2t(:,:) =  getvar(cn_fhgr, cn_ve2t, 1, npiglo, npjglo)
  ! loop over time
  it = 1.
  DO jt=1, npt
     ! loop over depth
     jk = 1
     DO WHILE (gdep(jk) <= ref_dep)
        zmask(:,:) = getvar(cn_fmsk, cv_msk, jk, npiglo, npjglo, kimin=iimin, kjmin=ijmin, ktime=jt)

        ztemp(:,:) = getvar( cf_tfil, cn_votemper,  jk, npiglo, npjglo, kimin=iimin, kjmin=ijmin, ktime=jt )
        zsal( :,:) = getvar( cf_sfil, cn_vosaline,  jk, npiglo, npjglo, kimin=iimin, kjmin=ijmin, ktime=jt )

        e3t(:,:) = getvar(cn_fzgr, cn_ve3t, jk, npiglo, npjglo, kimin=iimin, kjmin=ijmin, ktime=it, ldiom=.NOT.lg_vvl )

        ! we compute sigma using sigmai from eos and multiply it by 0-1 mask
        zsigz(:,:) = sigmai(ztemp, zsal, gdep(jk) , npiglo, npjglo )* zmask(:,:)
        
        ! vertical integration
        zsigvi(:,:) = zsigvi(:,:) + zsigz(:,:)*e3t(:,:)
        jk = jk+1
     END DO
     ! And after this we can read zsigh
     zsigh(:,:) = sigmai(ztemp, zsal, ref_dep, npiglo, npjglo )* zmask(:,:)
     ! and compute 2d convective energy
     zcape(:,:) = (ref_dep*zsigh(:,:) - zsigvi(:,:)) * zmask(:,:)
     ! integrate by area:
     zarea = SUM (e1t(:,:)*e2t(:,:))
     zcape_int = SUM( zcape(:,:)*e1t(:,:)*e2t(:,:) ) * grvt/zarea
     
     zcape = zcape * grvt
 
     ierr = putvar(ncout, id_varout(1), zcape, 1, npiglo, npjglo, ktime=jt)
     ierr = putvar(ncout1d, id_varout1d(1), zcape_int, 1, 1, 1, ktime=jt)
  END DO

  ierr = closeout(ncout)
  ierr = closeout(ncout1d)
CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    ipk(:)= npk  ! all variables (input and output are 3D)
    stypvar(1)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(1)%cname             = cv_out_name ! Where do I get this? 
    stypvar(1)%cunits            = 'J/m3'
    stypvar(1)%rmissing_value    = 0.
    stypvar(1)%valid_min         = 0.001
    stypvar(1)%valid_max         = 5000.
    stypvar(1)%clong_name        = 'Convective energy:refered to '//TRIM(cldum)//' m'
    stypvar(1)%cshort_name       = cv_out 
    stypvar(1)%conline_operation = 'N/A'
    stypvar(1)%caxis             = 'TYX'

    ! create output fileset
    ncout = create      (cf_out, cf_tfil, npiglo, npjglo, 1  , ld_nc4=lnc4 )
    ierr  = createvar   (ncout,  stypvar, 1,   ipk,    id_varout , ld_nc4=lnc4 )
    ierr  = putheadervar(ncout,  cf_tfil, npiglo, npjglo, 1)

    dtim  = getvar1d(cf_tfil, cn_vtimec, npt     )
    ierr  = putvar1d(ncout,   dtim,      npt, 'T')
    
   ! Create 1d output file additionally
   ipk1d(:)=1
   stypvar1d(1)%cname             = cv_out_name_int
   stypvar1d(1)%cunits            = 'J/m3'
   stypvar1d(1)%rmissing_value    = 0.
   stypvar1d(1)%valid_min         = 0.001
   stypvar1d(1)%valid_max         = 5000.
   stypvar1d(1)%clong_name        = 'Weighed mean OCAPE :refered to '//TRIM(cldum)//' m'
   stypvar1d(1)%cshort_name       = cv_out_int
   stypvar1d(1)%conline_operation = 'N/A'
   stypvar1d(1)%caxis             = 'T'

   ! Creating output fileset for int
   ncout1d = create      (cf_out_int, cf_tfil, 1, 1, 1  , ld_nc4=lnc4 )
   ierr    = createvar   (ncout1d,  stypvar1d, 1,   ipk1d,  id_varout1d , ld_nc4=lnc4 )
   ierr    = putheadervar(ncout1d,  cf_tfil, 1, 1, 1)

   dtim    = getvar1d(cf_tfil, cn_vtimec, npt     )
   ierr    = putvar1d(ncout1d,   dtim,      npt, 'T')
  END SUBROUTINE CreateOutput
  
END PROGRAM cdfocape

PROGRAM cdfshift05
  !!======================================================================
  !!                     ***  PROGRAM  cdfshift05  ***
  !!=====================================================================
  !!  ** Purpose : Shift the periodic folding line for ORCA05
  !!               (It may work, after verification for other ORCA grid,
  !!               but I checked in detail the case jperio=6 in this program)
  !!
  !!  ** Method  :  Work on a copy of the input file
  !!                Scan the variables and apply shift on 'map' variable
  !!                Shift and take care of the periodicity afterward
  !!  ** Remarks : As the files to be shifted are not (in general) NEMO
  !!               output, I decided to use netcdf function within this
  !!               program instead of the wrappers in cdfio. Therefore
  !!               this tool is not fully following CDFTOOLS spirit :) !
  !!
  !! History :  4.0  : 03/2021  : J.M. Molines : 
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  !!   routines      : description
  !!----------------------------------------------------------------------
  !!   shift05       : perform the shift of 180 degre
  !!----------------------------------------------------------------------
  USE netcdf
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2021
  !! $Id$
  !! Copyright (c) 2012, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class file_operations
  !!----------------------------------------------------------------------
  IMPLICIT NONE
  INTEGER(KIND=4) :: npiglo, npjglo, npk, nt
  INTEGER(KIND=4) :: ji,jj,jk, jt, jvar, jdim
  INTEGER(KIND=4) :: ipivot, ii
  INTEGER(KIND=4) :: narg, ijarg
  INTEGER(KIND=4) :: nvar=5, nvartotal,ndims
  INTEGER(KIND=4) :: ierr, ncid, id, idunlim
  INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE :: idims
  INTEGER(KIND=4), DIMENSION(:,:), ALLOCATABLE :: idimids

  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: v2di
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: v2do

  CHARACTER(LEN=255) :: cf_in
  CHARACTER(LEN=255) :: cf_out
  CHARACTER(LEN=255) :: cvar
  CHARACTER(LEN=255) :: cldum
  CHARACTER(LEN=5) :: cdimx='x', cdimy='y'
  CHARACTER(LEN=255), DIMENSION(:), ALLOCATABLE :: cvart
  CHARACTER(LEN=255), DIMENSION(:), ALLOCATABLE :: cdimt
  !!----------------------------------------------------------------------
  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfshift05 -f IN-file [ -x X-dmn] [-y Y-dmn]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Shift ORCA05 files in order to put the periodic line in the pacific' 
     PRINT *,'       The names of the ''x'' and ''y'' dimension need to be known.'
     PRINT *,'        Time dimension (if any) is supposed to be unlimited. '
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -f IN-file : pass the name of the file to shift' 
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-x X-dmn] : pass the name of the x dimension if not ''x'' ' 
     PRINT *,'       [-y Y-dmn] : pass the name of the y dimension if not ''y'' ' 
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       None ' 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file :  IN-file.shifted'
     PRINT *,'         variables :  same as input file'
     PRINT *,'      '
     PRINT *,'      '
     STOP
  ENDIF

  ijarg = 1 
  DO WHILE ( ijarg <= narg )
     CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-f'   ) ; CALL getarg(ijarg, cf_in ) ; ijarg=ijarg+1
        ! option
     CASE ( '-x'   ) ; CALL getarg(ijarg, cdimx ) ; ijarg=ijarg+1
     CASE ( '-y'   ) ; CALL getarg(ijarg, cdimy ) ; ijarg=ijarg+1
     CASE DEFAULT    ; PRINT *, ' ERROR : ', TRIM(cldum),' : unknown option.'; STOP 1
     END SELECT
  ENDDO
  cf_out=TRIM(cf_in)//'.shifted'

  !  
  CALL SYSTEM ("cp "//TRIM(cf_in)//" "//TRIM(cf_out) )
  ierr = NF90_OPEN(cf_out,NF90_WRITE,ncid)
  ierr = NF90_INQUIRE( ncid, nVariables=nvartotal, nDimensions=ndims,unlimitedDimId=idunlim)
  PRINT *, 'NDIMS     ', ndims
  PRINT *, 'NVARTOTAL ', nvartotal
  ALLOCATE(cvart(nvartotal), idims(nvartotal), idimids(ndims,nvartotal) )
  ALLOCATE(cdimt(ndims))
  DO jdim = 1 , ndims
    ierr = NF90_INQUIRE_DIMENSION(ncid, jdim, name=cdimt(jdim) )
!   print *, jdim, TRIM(cdimt(jdim))
  ENDDO

  DO jvar = 1, nvartotal
     ierr = NF90_INQUIRE_VARIABLE(ncid, jvar, name=cvart(jvar), ndims=idims(jvar),dimids=idimids(:,jvar))
!    print *, TRIM(cvart(jvar) )
!    DO jdim = 1, idims(jvar)
!      print *, '   dim ',jdim," ",TRIM(cdimt( idimids(jdim,jvar) ))
!   ENDDO
  ENDDO
  ierr = NF90_INQ_DIMID( ncid, cdimx,id) ; ierr=NF90_INQUIRE_DIMENSION(ncid,id, len=npiglo)
  ierr = NF90_INQ_DIMID( ncid, cdimy,id) ; ierr=NF90_INQUIRE_DIMENSION(ncid,id, len=npjglo)
  PRINT *, 'npiglo, npjglo', npiglo, npjglo
  ALLOCATE(v2di(npiglo,npjglo), v2do(npiglo,npjglo))

  DO jvar=1,nvartotal
     cvar=cvart(jvar)
     SELECT CASE (idims(jvar))
     CASE ( 2 )
        IF (cdimt(idimids(1,jvar)) == cdimx .AND. cdimt(idimids(2,jvar)) == cdimy) THEN  ! 2D x,y
           PRINT *,' SHIFTING 2D x y ', TRIM(cvar)
           ierr=NF90_INQ_VARID(ncid,cvar,id)
           ierr=NF90_GET_VAR(ncid,id,v2di,start=(/1,1/), count=(/npiglo,npjglo/) )
           CALL shift05
           ierr=NF90_PUT_VAR(ncid,id,v2do,start=(/1,1/), count=(/npiglo,npjglo/) )
        ENDIF
     CASE ( 3 )
        IF (cdimt(idimids(1,jvar)) == cdimx .AND. cdimt(idimids(2,jvar)) == cdimy) THEN  ! 2D x,y ,?
           IF (idimids(3,jvar) == idunlim ) THEN          ! x,y,t 
             ierr=NF90_INQUIRE_DIMENSION(ncid,idunlim, len=nt)
             PRINT *,' SHIFTING 3D x y t', TRIM(cvar)
             DO jt = 1, nt
               ierr=NF90_INQ_VARID(ncid,cvar,id)
               ierr=NF90_GET_VAR(ncid,id,v2di,start=(/1,1,jt/), count=(/npiglo,npjglo,1/) )
               CALL shift05
               ierr=NF90_PUT_VAR(ncid,id,v2do,start=(/1,1,jt/), count=(/npiglo,npjglo,1/) )
             ENDDO
           ELSE                                           ! x,y,z
             ierr=NF90_INQUIRE_DIMENSION(ncid,idimids(3,jvar), len=npk )
             PRINT *,' SHIFTING 3D x y z', TRIM(cvar)
             DO jk = 1, npk
               ierr=NF90_INQ_VARID(ncid,cvar,id)
               ierr=NF90_GET_VAR(ncid,id,v2di,start=(/1,1,jk/), count=(/npiglo,npjglo,1/) )
               CALL shift05
               ierr=NF90_PUT_VAR(ncid,id,v2do,start=(/1,1,jk/), count=(/npiglo,npjglo,1/) )
             ENDDO
           ENDIF
        ENDIF
     CASE ( 4 )
        ierr=NF90_INQUIRE_DIMENSION(ncid,idunlim, len=nt)
        ierr=NF90_INQUIRE_DIMENSION(ncid,idimids(3,jvar), len=npk )
        PRINT *,' SHIFTING 4D x y z t', TRIM(cvar)
        DO jt = 1, nt
          DO jk=1,npk
           ierr=NF90_INQ_VARID(ncid,cvar,id)
           ierr=NF90_GET_VAR(ncid,id,v2di,start=(/1,1,jk,jt/), count=(/npiglo,npjglo,1,1/) )
           CALL shift05
           ierr=NF90_PUT_VAR(ncid,id,v2do,start=(/1,1,jk,jt/), count=(/npiglo,npjglo,1,1/) )
          ENDDO
        ENDDO
     END SELECT
  ENDDO

  ierr = NF90_CLOSE(ncid)

CONTAINS

  SUBROUTINE shift05 
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE shift05  ***
    !!
    !! ** Purpose :  perform the shifting of v2di into v2do 
    !!
    !! ** Method  :  use all variables in the global space 
    !!               checked for the case jperio = 6 (F-Pivot)
    !!               Although it may work for other cases.
    !!----------------------------------------------------------------------

    ipivot=npiglo/2+1
    DO jj=1,npjglo
       DO ji=2,ipivot-1
          ii=ipivot+ji-2
          v2do(ji,jj) = v2di(ii,jj)
       ENDDO
       DO ji=ipivot,npiglo-1
          ii=ji-ipivot+2
          v2do(ji,jj) = v2di(ii,jj)
       ENDDO
       ! Periodic condition
       v2do(1,jj)=v2do(npiglo-1,jj)
       v2do(npiglo,jj) = v2do(2,jj)

    ENDDO
  END SUBROUTINE shift05

END PROGRAM cdfshift05

PROGRAM cdfovide
  !!======================================================================
  !!                     ***  PROGRAM  cdfovide  ***
  !!=====================================================================
  !!  ** Purpose : Easy tool to perform Temperature, Salinity and velocity
  !!               plots along OVIDE section
  !!               PARTIAL STEPS version
  !!
  !!  ** Method  : Works as a standalone file once compiled
  !!               Inspired by cdffindij, cdftransportiz
  !!
  !! History : 2.1  : 12/2009  : R. Dussin    : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  !!   routines      : description
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4) :: narg, iargc         ! command line
  INTEGER(KIND=4) :: npiglo, npjglo, npk ! size of the domain
  INTEGER(KIND=4) :: niter
  INTEGER(KIND=4) :: imin, imax, jmin, jmax, k, ik, jk, jclass
  INTEGER(KIND=4) :: iloc, jloc
  INTEGER(KIND=4) :: iloop, jloop

  INTEGER(KIND=4) :: nsec=0 ! nb total de points le long de la section
  INTEGER(KIND=4), DIMENSION (:), ALLOCATABLE :: isec, jsec ! indices des points a recuperer
  
  INTEGER(KIND=4), PARAMETER :: nsta=4
  INTEGER(KIND=4), DIMENSION(nsta) :: ista, jsta
  INTEGER(KIND=4), DIMENSION(nsta-1) :: ikeepn

  ! broken line stuff
  INTEGER(KIND=4), PARAMETER :: jpseg=10000
  INTEGER(KIND=4) :: i0,j0,i1,j1, i, j
  INTEGER(KIND=4) :: n,nn, jseg, kk
  INTEGER(KIND=4) :: norm_u, norm_v, ist, jst
  INTEGER(KIND=4)    ::  nxtarg
  INTEGER(KIND=4), DIMENSION(nsta-1,jpseg) :: legs1=0, legs2=0

  REAL(KIND=8), DIMENSION(nsta)             :: rlonsta, rlatsta
  REAL(KIND=8)                              :: xmin, xmax, ymin, ymax, rdis
  REAL(KIND=4)                              :: glamfound, glamin, glamax
  REAL(KIND=8)                              :: glam0, emax
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: glam, gphi, e1, e2
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: e1t, e2t, e1u, e2v, e3t
  
  REAL(KIND=4) :: rxi0, ryj0, rxi1, ryj1
  REAL(KIND=4) :: ai, bi, aj,bj,d
  REAL(KIND=4) :: rxx(jpseg), ryy(jpseg)
  REAL(KIND=4), DIMENSION(jpseg) :: gla !, gphi

  REAL(KIND=8), DIMENSION(jpseg) :: voltrp, heatrp, saltrp
  REAL(KIND=8)                   :: voltrpsum, heatrpsum, saltrpsum
  COMPLEX yypt(jpseg), yypti

  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: e1v, e3v ,gphiv, zv, zvt, zvs !: mask, metrics
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: e2u, e3u ,gphiu, zu, zut, zus !: mask, metrics
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: temper, saline, zonalu, meridv, navlon, navlat
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: ovidetemper, ovidesaline, ovidezonalu, ovidemeridv
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: lonsec, latsec, dumisec, dumjsec
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: e1tsec, e1usec, e1vsec, e2tsec, e2usec, e2vsec
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: e3tsec, e3usec, e3vsec
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: glamu, glamv
  REAL(KIND=4), DIMENSION(:),     ALLOCATABLE :: gdepw


! constants
  REAL(KIND=4)   ::  rau0=1000.,  rcp=4000.

  CHARACTER(LEN=80) :: ctype='F'
  CHARACTER(LEN=80) :: cfilet , cfileu, cfilev, csection 
  LOGICAL  :: lagain, lbord
  LOGICAL  :: ltest=.FALSE.
  LOGICAL  :: lchk
  
! cdf output stuff
  CHARACTER(LEN=80) :: cfileoutnc='ovide.nc'
  TYPE (variable), DIMENSION(:), ALLOCATABLE   :: stypvar
  INTEGER(KIND=4)    :: ierr, ncout
  REAL(KIND=4), DIMENSION(1)                    ::  tim
  INTEGER(KIND=4)    :: nfield=10
  INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE :: ipk, id_varout
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg < 3  ) THEN
     PRINT *,'usage : cdfovide gridTfile gridUfile gridVfile '
     PRINT *,'     Files ',TRIM(cn_fhgr),' and ',TRIM(cn_fzgr),' must be in te current directory '
     PRINT *,'     Output on netcdf file ',TRIM(cfileoutnc)
     STOP
  ENDIF

  CALL getarg (1, cfilet)
  CALL getarg (2, cfileu)
  CALL getarg (3, cfilev)

  lchk = chkfile(cn_fhgr)
  lchk = chkfile(cn_fzgr) .OR. lchk
  lchk = chkfile(cfilet ) .OR. lchk
  lchk = chkfile(cfileu ) .OR. lchk
  lchk = chkfile(cfilev ) .OR. lchk
  IF ( lchk ) STOP ! missing files

  ! Location of leg points that define the 3 legs of OVIDE section
  rlonsta(1) = -43.00 ; rlatsta(1) = 60.60    ! Greenland
  rlonsta(2) = -31.30 ; rlatsta(2) = 58.90    ! Reykjanes Ridge
  rlonsta(3) = -12.65 ; rlatsta(3) = 40.33    ! Off Portugal
  rlonsta(4) =  -8.70 ; rlatsta(4) = 40.33    ! Lisboa

  PRINT *, '###########################################################'
  PRINT *, '#                                                          '
  PRINT *, '#   CDF ovide                                              '
  PRINT *, '#                                                          '
  PRINT *, '#                                      \___________________'
  PRINT *, '#                                       \                  '
  PRINT *, '#                                        \                 '
  PRINT *, '#                                         \________________'
  PRINT *, '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~'

  !!---------------------------------------------------------------------
  !!  Find the indexes of the 3 legs (from cdffindij) 
  !!---------------------------------------------------------------------

  npiglo = getdim (cn_fhgr,cn_x)
  npjglo = getdim (cn_fhgr,cn_y)
  
  ALLOCATE (glam(npiglo,npjglo), gphi(npiglo,npjglo) )
  ALLOCATE (e1(npiglo,npjglo), e2(npiglo,npjglo) )

  SELECT CASE ( ctype )
  CASE ('T' , 't' )
     glam(:,:) = getvar(cn_fhgr, 'glamt',1,npiglo,npjglo)
     gphi(:,:) = getvar(cn_fhgr, 'gphit',1,npiglo,npjglo)
     e1  (:,:) = getvar(cn_fhgr, 'e1t'  ,1,npiglo,npjglo)
     e2  (:,:) = getvar(cn_fhgr, 'e2t'  ,1,npiglo,npjglo)
  CASE ('U','u' )
     glam(:,:) = getvar(cn_fhgr, 'glamu',1,npiglo,npjglo)
     gphi(:,:) = getvar(cn_fhgr, 'gphiu',1,npiglo,npjglo)
     e1  (:,:) = getvar(cn_fhgr, 'e1u'  ,1,npiglo,npjglo)
     e2  (:,:) = getvar(cn_fhgr, 'e2u'  ,1,npiglo,npjglo)
  CASE ('V','v' )
     glam(:,:) = getvar(cn_fhgr, 'glamv',1,npiglo,npjglo)
     gphi(:,:) = getvar(cn_fhgr, 'gphiv',1,npiglo,npjglo)
     e1  (:,:) = getvar(cn_fhgr, 'e1v'  ,1,npiglo,npjglo)
     e2  (:,:) = getvar(cn_fhgr, 'e2v'  ,1,npiglo,npjglo)
  CASE ('F','f' )
     glam(:,:) = getvar(cn_fhgr, 'glamf',1,npiglo,npjglo)
     gphi(:,:) = getvar(cn_fhgr, 'gphif',1,npiglo,npjglo)
     e1  (:,:) = getvar(cn_fhgr, 'e1f'  ,1,npiglo,npjglo)
     e2  (:,:) = getvar(cn_fhgr, 'e2f'  ,1,npiglo,npjglo)
  CASE DEFAULT
     PRINT *,' ERROR : type of point not known: ', TRIM(ctype)
  END SELECT

  ! work with longitude between 0 and 360 to avoid  the date line.
    WHERE( glam < 0 ) glam=glam+360.
  ! For Orca grid, the longitude of ji=1 is about 70 E
  glam0=glam(1, npjglo/2)
  WHERE( glam < glam0 ) glam=glam+360.

  !! loop on the 3 legs
  DO k = 1,nsta-1

   xmin=rlonsta(k)
   ymin=rlatsta(k)
   xmax=rlonsta(k+1)
   ymax=rlatsta(k+1)

   IF (xmin < 0.) xmin = xmin +360.
   IF (xmax < 0.) xmax = xmax +360.
    
   IF (xmin < glam0) xmin = xmin +360.
   IF (xmax < glam0) xmax = xmax +360.

   lagain = .TRUE.
   niter = 0

  !! --- while loop -----------------------------------------------------------
  DO WHILE (lagain)
     CALL Nearestpoint(xmin,ymin,npiglo,npjglo,glam,gphi,iloc,jloc,lbord)
     ! distance between the target point and the nearest point
     rdis=dist(xmin,glam(iloc,jloc),ymin,gphi(iloc,jloc) ) ! in km
     ! typical grid size (diagonal) in the vicinity of nearest point
     emax= MAX(e1(iloc,jloc),e2(iloc,jloc))/1000.*SQRT(2.) ! in km

!!    rdis = (xmin - glam(iloc,jloc))**2 + (ymin - gphi(iloc,jloc))**2
!!    rdis = SQRT(rdis)
     IF (rdis  > emax ) THEN
         glamfound=glam(iloc,jloc) ; IF (glamfound > 180.)  glamfound=glamfound -360.
        PRINT 9000, 'Long= ',glamfound,' Lat = ',gphi(iloc,jloc)&
             &               , iloc, jloc 
        PRINT *,' Algorithme ne converge pas ', rdis 
        IF ( niter >=  1 ) STOP ' pas de convergence apres iteration'
        lagain = .TRUE.
        jloc = npjglo
        niter = niter +1
     ELSE
        !PRINT '("#  rdis= ",f8.3," km")', rdis
        lagain = .FALSE.
     END IF
  END DO
  !!--------------------------------------------------------------------------

  IF (lbord) THEN
     WRITE (*,*)'Point  Out of domain or on boundary'
  ELSE
     imin=iloc
     jmin=jloc
     !      PRINT 9000, 'Long= ',glam(iloc,jloc),' lat = ',gphi(iloc,jloc), iloc, jloc 
  ENDIF
  


  lagain = .TRUE.
  niter = 0
  !! --- while loop ----------------------------------------------------------------
  DO WHILE (lagain)
     CALL Nearestpoint(xmax,ymax,npiglo,npjglo,glam,gphi,iloc,jloc,lbord)
     ! distance between the target point and the nearest point
     rdis=dist(xmax,glam(iloc,jloc),ymax,gphi(iloc,jloc) ) ! in km
     ! typical grid size (diagonal) in the vicinity of nearest point
     emax= MAX(e1(iloc,jloc),e2(iloc,jloc))/1000.*SQRT(2.) ! in km
!!    rdis = (xmax - glam(iloc,jloc))**2 + (ymax - gphi(iloc,jloc))**2
!!    rdis = SQRT(rdis)
     IF (rdis >  emax ) THEN
         glamfound=glam(iloc,jloc) ; IF (glamfound > 180.)  glamfound=glamfound -360.
        PRINT 9000, 'Long= ',glamfound,' Lat = ',gphi(iloc,jloc) &
             &               , iloc, jloc
        PRINT *,' Algorithme ne converge pas ', rdis
        IF ( niter >= 1 ) STOP ' pas de convergence avres iteration'
        lagain = .TRUE.
        jloc  = npjglo
        niter = niter +1
     ELSE
        !PRINT '("#  rdis= ",f8.3," km")', rdis
        lagain = .FALSE.
     END IF
  END DO !! ---------------------------------------------------------------------

  IF (lbord) THEN
     WRITE (*,*) 'Point  Out of domain or on boundary'
  ELSE
     imax=iloc
     jmax=jloc
     !      PRINT 9000, 'Long= ',glam(iloc,jloc),' lat = ',gphi(iloc,jloc), iloc, jloc
  ENDIF
  
  ista(k)=imin
  jsta(k)=jmin
  ista(k+1)=imax
  jsta(k+1)=jmax

!  PRINT 9001, imin,imax, jmin, jmax
!  glamin=glam(imin,jmin) ;glamax=glam(imax,jmax)
!  IF ( glamin > 180 ) glamin=glamin-360.
!  IF ( glamax > 180 ) glamax=glamax-360.
!  PRINT 9002, glamin, glamax, gphi(imin,jmin),gphi(imax,jmax)
9000 FORMAT(a,f8.2,a,f8.2,2i5)
9001 FORMAT(4i10)
9002 FORMAT(4f10.4)


     !! Find the broken line between P1 (imin,jmin) and P2 (imax, jmax)
     !! ---------------------------------------------------------------
     ! ... Initialization
     i0=imin; j0=jmin; i1=imax;  j1=jmax
     rxi1=i1;  ryj1=j1; rxi0=i0; ryj0=j0

     ! .. Compute equation:  ryj = aj rxi + bj
     IF ( (rxi1 -rxi0) /=  0 ) THEN
        aj = (ryj1 - ryj0 ) / (rxi1 -rxi0)
        bj = ryj0 - aj * rxi0
     ELSE
        aj=10000.
        bj=0.
     END IF


     ! .. Compute equation:  rxi = ai ryj + bi
     IF ( (ryj1 -ryj0) /=  0 ) THEN
        ai = (rxi1 - rxi0 ) / ( ryj1 -ryj0 )
        bi = rxi0 - ai * ryj0
     ELSE
        ai=10000.
        bi=0.
     END IF


     ! ..  Compute the integer pathway:
     n=0
     ! .. Chose the strait line with the smallest slope
     IF (ABS(aj) <=  1 ) THEN
        ! ... Here, the best line is y(x)
        ! ... If i1 < i0 swap points and remember it has been swapped
        IF (i1 <  i0 ) THEN
           i  = i0 ; j  = j0
           i0 = i1 ; j0 = j1
           i1 = i  ; j1 = j
        END IF

        IF ( j1 >= j0 ) THEN
           ist = 1     ; jst = 1
           norm_u =  1 ;  norm_v = -1
        ELSE
           ist = 1     ; jst = 0
           norm_u = -1 ; norm_v = -1
        END IF

        ! ... compute the nearest j point on the line crossing at i
        DO i=i0,i1
           n=n+1
           IF (n > jpseg) STOP 'n > jpseg !'
           j=NINT(aj*i + bj )
           yypt(n) = CMPLX(i,j)
        END DO
     ELSE
        ! ... Here, the best line is x(y)
        ! ... If j1 < j0 swap points and remember it has been swapped
        IF (j1 <  j0 ) THEN
           i  = i0 ; j  = j0
           i0 = i1 ; j0 = j1
           i1 = i  ; j1 = j
        END IF
        IF ( i1 >=  i0 ) THEN
           ist = 1    ;  jst = 1
           norm_u = 1 ;  norm_v = -1
        ELSE
           ist = 0
           jst = 1
           norm_u = 1
           norm_v = 1
        END IF

        ! ... compute the nearest i point on the line crossing at j
        DO j=j0,j1
           n=n+1
           IF (n > jpseg) STOP 'n>jpseg !'
           i=NINT(ai*j + bi)
           yypt(n) = CMPLX(i,j)
        END DO
     END IF

     !!
     !! Look for intermediate points to be added.
     !  ..  The final positions are saved in rxx,ryy
     rxx(1)=REAL(yypt(1))
     ryy(1)=IMAG(yypt(1))
     nn=1

     DO kk=2,n
        ! .. distance between 2 neighbour points
        d=ABS(yypt(kk)-yypt(kk-1))
        ! .. intermediate points required if d > 1
        IF ( d > 1 ) THEN
           CALL interm_pt(yypt,kk,ai,bi,aj,bj,yypti)
           nn=nn+1
           IF (nn > jpseg) STOP 'nn>jpseg !'
           rxx(nn)=REAL(yypti)
           ryy(nn)=IMAG(yypti)
        END IF
        nn=nn+1
        IF (nn > jpseg) STOP 'nn>jpseg !'
        rxx(nn)=REAL(yypt(kk))
        ryy(nn)=IMAG(yypt(kk))
     END DO

  IF (rxx(1) < rxx(nn) ) THEN ;
     legs1(k,:)=rxx
     legs2(k,:)=ryy
  ELSE

    DO iloop=1,nn
      legs1(k,iloop)=rxx(nn-iloop+1)
      legs2(k,iloop)=ryy(nn-iloop+1)
   END DO
  END IF

  ! compute the number of total points
  ikeepn(k)=nn
  nsec = nsec + nn
  END DO !! loop on the 3 legs

! fancy control print
WRITE(*,*) '------------------------------------------------------------'
WRITE(*,9100) 'leg 1 start at ', rlonsta(1) ,'°N ', rlatsta(1), '°W and ends at ', rlonsta(2) ,'°N ', rlatsta(2), '°W'
WRITE(*,9101) 'corresponding to F-gridpoints(', ista(1),',',jsta(1),') and (', ista(2),',',jsta(2),')' 
WRITE(*,*) '------------------------------------------------------------'
WRITE(*,*) '------------------------------------------------------------'
WRITE(*,9100) 'leg 2 start at ', rlonsta(2) ,'°N ', rlatsta(2), '°W and ends at ', rlonsta(3) ,'°N ', rlatsta(3), '°W'
WRITE(*,9101) 'corresponding to F-gridpoints(', ista(2),',',jsta(2),') and (', ista(3),',',jsta(3),')' 
WRITE(*,*) '------------------------------------------------------------'
WRITE(*,*) '------------------------------------------------------------'
WRITE(*,9100) 'leg 3 start at ', rlonsta(3) ,'°N ', rlatsta(3), '°W and ends at ', rlonsta(4) ,'°N ', rlatsta(4), '°W'
WRITE(*,9101) 'corresponding to F-gridpoints(', ista(3),',',jsta(3),') and (', ista(4),',',jsta(4),')' 
WRITE(*,*) '------------------------------------------------------------'

9100 FORMAT(a,f6.2,a,f6.2,a,f6.2,a,f6.2,a)
9101 FORMAT(a,i4,a,i4,a,i4,a,i4,a)

  ALLOCATE (isec(nsec), jsec(nsec)) 

  DO k=1, nsta-1
    DO iloop=1, ikeepn(k) 
     jloop=iloop + SUM(ikeepn(1:k)) -ikeepn(k)
     isec(jloop)=legs1(k,iloop)
     jsec(jloop)=legs2(k,iloop)
    END DO
  END DO

  npk = getdim (cfilet,'deptht')

  ! input fields
  ALLOCATE(navlon(npiglo,npjglo), navlat(npiglo,npjglo))
  ALLOCATE(temper(npiglo,npjglo), saline(npiglo,npjglo))
  ALLOCATE(zonalu(npiglo,npjglo), meridv(npiglo,npjglo))
  ALLOCATE(e1v(npiglo,npjglo))
  ALLOCATE(e2u(npiglo,npjglo))
  ALLOCATE(e3u(npiglo,npjglo), e3v(npiglo,npjglo))

  ! output fields
  ALLOCATE(lonsec(1,nsec), latsec(1,nsec) )
  ALLOCATE(dumisec(1,nsec), dumjsec(1,nsec) )
  ALLOCATE(e2usec(1,nsec-1), e3usec(nsec-1,npk) )
  ALLOCATE(e1vsec(1,nsec-1), e3vsec(nsec-1,npk) )
  ALLOCATE(ovidetemper(nsec-1,npk), ovidesaline(nsec-1,npk) )
  ALLOCATE(ovidezonalu(nsec-1,npk), ovidemeridv(nsec-1,npk) )
  
  dumisec(:,:)=0
  dumjsec(:,:)=0

  navlon(:,:) = getvar(cfilet, 'nav_lon' ,1,npiglo,npjglo)
  navlat(:,:) = getvar(cfilet, 'nav_lat' ,1,npiglo,npjglo)
  e1v(:,:)    = getvar(cn_fhgr, 'e1v',1,npiglo,npjglo)
  e2u(:,:)    = getvar(cn_fhgr, 'e2u',1,npiglo,npjglo)

  ! il faut faire un test sur la continuité des segements
  ! on va prendre T et S comme etant la moyenne du point
  ! en dessous et au-dessus du segment pour pouvoir calculer
  ! les fluxs de maniere optimales...

  ! loop on 2d arrays
  DO iloop=1,nsec

    lonsec(1,iloop) = navlon(isec(iloop),jsec(iloop))
    latsec(1,iloop) = navlat(isec(iloop),jsec(iloop))
    dumisec(1,iloop)= isec(iloop)
    dumjsec(1,iloop)= jsec(iloop)

  END DO

  DO iloop=1,nsec-1

  IF ( jsec(iloop+1) == jsec(iloop) ) THEN ! horizontal segment
    IF ( isec(iloop+1) > isec(iloop) ) THEN ! eastward

       e2usec(iloop,jk) = 0.
       e1vsec(iloop,jk) = e1v(isec(iloop)+1,jsec(iloop))

    ELSE

       e2usec(iloop,jk) = 0.
       e1vsec(iloop,jk) = e1v(isec(iloop),jsec(iloop))

    ENDIF
  ELSEIF ( isec(iloop+1) == isec(iloop) ) THEN ! vertical segment
    IF ( jsec(iloop+1) < jsec(iloop) ) THEN ! southward

       e2usec(iloop,jk) = e2u(isec(iloop),jsec(iloop))
       e1vsec(iloop,jk) = 0.

    ELSE

       e2usec(iloop,jk) = e2u(isec(iloop),jsec(iloop)+1)
       e1vsec(iloop,jk) = 0.
    ENDIF
  ELSE
       PRINT *, 'problem'
       exit 
  ENDIF
  END DO

  ! loop on 3d arrays
  DO jk=1,npk
  temper(:,:) = getvar(cfilet, 'votemper',jk,npiglo,npjglo)
  saline(:,:) = getvar(cfilet, 'vosaline',jk,npiglo,npjglo)
  zonalu(:,:) = getvar(cfileu, 'vozocrtx',jk,npiglo,npjglo)
  meridv(:,:) = getvar(cfilev, 'vomecrty',jk,npiglo,npjglo)
  e3u(:,:) = getvar(cn_fzgr, 'e3u_ps',jk,npiglo,npjglo, ldiom=.true.)
  e3v(:,:) = getvar(cn_fzgr, 'e3v_ps',jk,npiglo,npjglo, ldiom=.true.)

  DO iloop=1,nsec-1
    IF ( jsec(iloop+1) == jsec(iloop) ) THEN ! horizontal segment
       IF ( isec(iloop+1) > isec(iloop) ) THEN ! eastward

       IF ( min( temper(isec(iloop)+1,jsec(iloop)) , temper(isec(iloop)+1,jsec(iloop)+1) ) == 0. ) THEN
       ovidetemper(iloop,jk) = 0. ; ovidesaline(iloop,jk) = 0.
       ELSE
       ovidetemper(iloop,jk) = 0.5 * ( temper(isec(iloop)+1,jsec(iloop)) + temper(isec(iloop)+1,jsec(iloop)+1) )
       ovidesaline(iloop,jk) = 0.5 * ( saline(isec(iloop)+1,jsec(iloop)) + saline(isec(iloop)+1,jsec(iloop)+1) )
       ENDIF
       ovidezonalu(iloop,jk) = 0.
       ovidemeridv(iloop,jk) = meridv(isec(iloop)+1,jsec(iloop))
       e3usec(iloop,jk) = 0.
       e3vsec(iloop,jk) = e3v(isec(iloop)+1,jsec(iloop))

       ELSE ! westward

       IF ( min( temper(isec(iloop),jsec(iloop)) , temper(isec(iloop),jsec(iloop)+1) ) == 0. ) THEN
       ovidetemper(iloop,jk) = 0. ; ovidesaline(iloop,jk) = 0.
       ELSE
       ovidetemper(iloop,jk) = 0.5 * ( temper(isec(iloop),jsec(iloop)) + temper(isec(iloop),jsec(iloop)+1) )
       ovidesaline(iloop,jk) = 0.5 * ( saline(isec(iloop),jsec(iloop)) + saline(isec(iloop),jsec(iloop)+1) )
       ENDIF
       ovidezonalu(iloop,jk) = 0.
       ovidemeridv(iloop,jk) = meridv(isec(iloop),jsec(iloop))
       e3usec(iloop,jk) = 0.
       e3vsec(iloop,jk) = e3v(isec(iloop),jsec(iloop))

       ENDIF
    ELSEIF ( isec(iloop+1) == isec(iloop) ) THEN ! vertical segment
       IF ( jsec(iloop+1) < jsec(iloop) ) THEN ! southward

       IF ( min( temper(isec(iloop),jsec(iloop)) , temper(isec(iloop)+1,jsec(iloop)) ) == 0. ) THEN
       ovidetemper(iloop,jk) = 0. ; ovidesaline(iloop,jk) = 0.
       ELSE
       ovidetemper(iloop,jk) = 0.5 * ( temper(isec(iloop),jsec(iloop)) + temper(isec(iloop)+1,jsec(iloop)) )
       ovidesaline(iloop,jk) = 0.5 * ( saline(isec(iloop),jsec(iloop)) + saline(isec(iloop)+1,jsec(iloop)) )
       ENDIF
       ovidezonalu(iloop,jk) = zonalu(isec(iloop),jsec(iloop))
       ovidemeridv(iloop,jk) = 0.
       e3usec(iloop,jk) = e3u(isec(iloop),jsec(iloop))
       e3vsec(iloop,jk) = 0.

       ELSE ! northward

       IF ( min( temper(isec(iloop),jsec(iloop)+1) , temper(isec(iloop)+1,jsec(iloop)+1) ) == 0. ) THEN
       ovidetemper(iloop,jk) = 0. ; ovidesaline(iloop,jk) = 0.
       ELSE
       ovidetemper(iloop,jk) = 0.5 * ( temper(isec(iloop),jsec(iloop)+1) + temper(isec(iloop)+1,jsec(iloop)+1) )
       ovidesaline(iloop,jk) = 0.5 * ( saline(isec(iloop),jsec(iloop)+1) + saline(isec(iloop)+1,jsec(iloop)+1) )
       ENDIF
       ovidezonalu(iloop,jk) = zonalu(isec(iloop),jsec(iloop)+1)
       ovidemeridv(iloop,jk) = 0.
       e3usec(iloop,jk) = e3u(isec(iloop),jsec(iloop)+1)
       e3vsec(iloop,jk) = 0.

       ENDIF

    ELSE
       PRINT *, 'problem'
       exit 
    ENDIF

  END DO
  END DO

  ALLOCATE ( stypvar(nfield), ipk(nfield), id_varout(nfield) )

  DO iloop=1,nfield
     ipk(iloop) = npk
  END DO

 ! define new variables for output 
  stypvar(1)%cname= 'votemper'
  stypvar(1)%cunits='deg C'
  stypvar%rmissing_value=0.
  stypvar(1)%valid_min= -2.
  stypvar(1)%valid_max= 40.
  stypvar%scale_factor= 1.
  stypvar%add_offset= 0.
  stypvar%savelog10= 0.
  stypvar(1)%clong_name='Temperature along OVIDE section'
  stypvar(1)%cshort_name='votemper'
  stypvar%conline_operation='N/A'
  stypvar%caxis='TYZ'

  stypvar(2)%cname= 'vosaline'
  stypvar(2)%cunits='PSU'
  stypvar(2)%valid_min= 0.
  stypvar(2)%valid_max= 50.
  stypvar(2)%clong_name='Salinity along OVIDE section'
  stypvar(2)%cshort_name='vosaline'

  stypvar(3)%cname= 'vozocrtx'
  stypvar(3)%cunits='m.s-1'
  stypvar(3)%valid_min= -20.
  stypvar(3)%valid_max= 20.
  stypvar(3)%clong_name='Zonal velocity along OVIDE section'
  stypvar(3)%cshort_name='vozocrtx'

  stypvar(4)%cname= 'vomecrty'
  stypvar(4)%cunits='m.s-1'
  stypvar(4)%valid_min= -20.
  stypvar(4)%valid_max= 20.
  stypvar(4)%clong_name='Meridionnal velocity along OVIDE section'
  stypvar(4)%cshort_name='vomecrty'

  stypvar(5)%cname= 'isec'
  stypvar(5)%valid_min= 0.
  stypvar(5)%valid_max= npiglo 
  stypvar(6)%cname= 'jsec'
  stypvar(6)%valid_min= 0.
  stypvar(6)%valid_max= npjglo 
  stypvar(7)%cname= 'e2u'
  stypvar(7)%valid_min= MINVAL(e2usec(1,:))
  stypvar(7)%valid_max= MAXVAL(e2usec(1,:)) 
  stypvar(8)%cname= 'e1v'
  stypvar(8)%valid_min= MINVAL(e1vsec(1,:))
  stypvar(8)%valid_max= MAXVAL(e1vsec(1,:))
  stypvar(9)%cname= 'e3u'
  stypvar(9)%valid_min= MINVAL(e3usec(:,:))
  stypvar(9)%valid_max= MAXVAL(e3usec(:,:)) 
  stypvar(10)%cname= 'e3v'
  stypvar(10)%valid_min= MINVAL(e3vsec(:,:))
  stypvar(10)%valid_max= MAXVAL(e3vsec(:,:)) 

  ! create output fileset
   ncout =create(cfileoutnc, 'none', 1,nsec,npk,cdep='depthw')
   ierr= createvar(ncout ,stypvar,nfield, ipk,id_varout )
   ierr= putheadervar(ncout, cfilet,1, nsec,npk,pnavlon=lonsec,pnavlat=latsec,pdep=gdepw)
   tim=getvar1d(cfilet,'time_counter',1)
   ierr=putvar1d(ncout,tim,1,'T')

  ! netcdf output 
    DO jk =1, npk
    ierr = putvar (ncout, id_varout(1), REAL(ovidetemper(:,jk)), jk,1,nsec-1)
    ierr = putvar (ncout, id_varout(2), REAL(ovidesaline(:,jk)), jk,1,nsec-1)
    ierr = putvar (ncout, id_varout(3), REAL(ovidezonalu(:,jk)), jk,1,nsec-1)
    ierr = putvar (ncout, id_varout(4), REAL(ovidemeridv(:,jk)), jk,1,nsec-1)
    ierr = putvar (ncout, id_varout(5), REAL(dumisec(1,:)), jk,1,nsec)
    ierr = putvar (ncout, id_varout(6), REAL(dumjsec(1,:)), jk,1,nsec)
    ierr = putvar (ncout, id_varout(7),REAL(e2usec(1,:)), jk,1,nsec-1)
    ierr = putvar (ncout, id_varout(8),REAL(e1vsec(1,:)), jk,1,nsec-1)
    ierr = putvar (ncout, id_varout(9),REAL(e3usec(:,jk)), jk,1,nsec-1)
    ierr = putvar (ncout, id_varout(10),REAL(e3vsec(:,jk)), jk,1,nsec-1)
    END DO

  ierr = closeout(ncout)

    !!--------------------------------------------------------------------
    !!
    !!   SUBROUTINES USED
    !!
    !!--------------------------------------------------------------------
CONTAINS

  SUBROUTINE Nearestpoint(pplon,pplat,kpi,kpj,plam,pphi,kpiloc,kpjloc,ldbord)
    !!----------------------------------------------------------------------------
    !!            ***  SUBROUTINE NEARESTPOINT  ***
    !!
    !!   ** Purpose:  Computes the positions of the nearest i,j in the grid
    !!                from the given longitudes and latitudes
    !!
    !!   ** Method :  Starts on the middle of the grid, search in a 20x20 box, and move
    !!     the box in the direction where the distance between the box and the
    !!     point is minimum
    !!     Iterates ...
    !!     Stops when the point is outside the grid.
    !!     This algorithm does not work on the Mediteranean grid !
    !!
    !!   * history:
    !!        Anne de Miranda et Pierre-Antoine Darbon Jul. 2000 (CLIPPER)
    !!        Jean-Marc Molines : In NEMO form
    !!----------------------------------------------------------------------------
    IMPLICIT NONE
    !* arguments
    REAL(KIND=8),INTENT(in)   ::  pplon,pplat   !: lon and lat of target point
    INTEGER(KIND=4),INTENT (in)       ::  kpi,kpj       !: grid size
    INTEGER(KIND=4),INTENT (inout)    :: kpiloc,kpjloc  !: nearest point location
    REAL(KIND=8),DIMENSION(kpi,kpj),INTENT(in) ::  pphi,plam  !: model grid layout
    LOGICAL                   :: ldbord         !: reach boundary flag

    ! * local variables
    INTEGER(KIND=4) :: ji,jj,i0,j0,i1,j1
    INTEGER(KIND=4) :: itbl
    REAL(KIND=4) ::  zdist,zdistmin,zdistmin0
    LOGICAL, SAVE ::  lbordcell, lfirst=.TRUE.
    !!
    ! Initial values
    kpiloc = kpi/2 ; kpjloc = kpj/2    ! seek from the middle of domain
    itbl = 10                          ! block size for search
    zdistmin=1000000. ; zdistmin0=1000000.
    i0=kpiloc ;  j0=kpjloc
    lbordcell=.TRUE.;   ldbord=.FALSE.

    ! loop until found or boundary reach
    DO  WHILE ( lbordcell .AND. .NOT. ldbord)
       i0=kpiloc-itbl ;  i1=kpiloc+itbl
       j0=kpjloc-itbl ;  j1=kpjloc+itbl

       ! search only the inner domain
       IF (i0 <= 0) i0=2
       IF (i1 > kpi) i1=kpi-1
       IF (j0 <= 0) j0=2
       IF( j1 > kpj) j1=kpj-1

       ! within a block itbl+1 x itbl+1:
       DO jj=j0,j1
          DO ji=i0,i1
             ! compute true distance (orthodromy) between target point and grid point
             zdist=dist(pplon,plam(ji,jj),pplat,pphi(ji,jj) )
             zdistmin=MIN(zdistmin,zdist)
             ! update kpiloc, kpjloc if distance decreases
             IF (zdistmin .NE. zdistmin0 ) THEN
                kpiloc=ji
                kpjloc=jj
             ENDIF
             zdistmin0=zdistmin
          END DO
       END DO
       lbordcell=.FALSE.
       ! if kpiloc, kpjloc belong to block boundary proceed to next block, centered on kpiloc, kpjloc
       IF (kpiloc == i0 .OR. kpiloc == i1) lbordcell=.TRUE.
       IF (kpjloc == j0 .OR. kpjloc == j1) lbordcell=.TRUE.
       ! boundary reach ---> not found
       IF (kpiloc == 2  .OR. kpiloc ==kpi-1) ldbord=.TRUE.
       IF (kpjloc == 2  .OR. kpjloc ==kpj-1) ldbord=.TRUE.
    END DO
  END SUBROUTINE  NEARESTPOINT

SUBROUTINE interm_pt (ydpt,k,pai,pbi,paj,pbj,ydpti)
    !! -----------------------------------------------------
    !!           SUBROUTINE INTERM_PT
    !!           ********************
    !!
    !!   PURPOSE:
    !!   --------
    !!     Find the best intermediate points on a pathway.
    !!
    !!    ARGUMENTS:
    !!    ----------
    !!      ydpt : complex vector of the positions of the nearest points
    !!         k : current working index
    !!       pai ,pbi : slope and original ordinate of x(y)
    !!       paj ,pbj : slope and original ordinate of y(x)
    !!      ydpti : Complex holding the position of intermediate point
    !!
    !!    AUTHOR:
    !!    -------
    !!      19/07/1999 : Jean-Marc MOLINES
    !!      14/01/2005 : J M M in F90
    !!
    !!--------------------------------------------------------------
    !!
    !! 0. Declarations:
    !! ----------------
    IMPLICIT NONE
    COMPLEX, INTENT(in) :: ydpt(*)
    COMPLEX, INTENT(out) :: ydpti
    REAL(KIND=4), INTENT(IN) ::  pai,pbi,paj,pbj
    INTEGER(KIND=4) ,INTENT(in) :: k
    ! ... local
    COMPLEX :: ylptmp1, ylptmp2
    REAL(KIND=4) ::  za0,zb0,za1,zb1,zd1,zd2
    REAL(KIND=4) ::  zxm,zym
    REAL(KIND=4) ::  zxp,zyp
    !!
    !! 1. Compute intermediate points
    !! ------------------------------
    !
    ! ... Determines whether we use y(x) or x(y):
    IF (ABS(paj) <=  1) THEN
       ! ..... y(x)
       ! ... possible intermediate points:
       ylptmp1=ydpt(k-1)+(1.,0.)
       ylptmp2=ydpt(k-1)+CMPLX(0.,SIGN(1.,paj))
       !
       ! ... M is the candidate point:
       zxm=REAL(ylptmp1)
       zym=IMAG(ylptmp1)
       za0=paj
       zb0=pbj
       !
       za1=-1./za0
       zb1=zym - za1*zxm
       ! ... P is the projection of M on the strait line
       zxp=-(zb1-zb0)/(za1-za0)
       zyp=za0*zxp + zb0
       ! ... zd1 is the distance MP
       zd1=(zxm-zxp)*(zxm-zxp) + (zym-zyp)*(zym-zyp)
       !
       ! ... M is the candidate point:
       zxm=REAL(ylptmp2)
       zym=IMAG(ylptmp2)
       za1=-1./za0
       zb1=zym - za1*zxm
       ! ... P is the projection of M on the strait line
       zxp=-(zb1-zb0)/(za1-za0)
       zyp=za0*zxp + zb0
       ! ... zd2 is the distance MP
       zd2=(zxm-zxp)*(zxm-zxp) + (zym-zyp)*(zym-zyp)
       ! ... chose the smallest (zd1,zd2)
       IF (zd2 <=  zd1) THEN
          ydpti=ylptmp2
       ELSE
          ydpti=ylptmp1
       END IF
       !
    ELSE
       !
       ! ... x(y)
       ylptmp1=ydpt(k-1)+CMPLX(SIGN(1.,pai),0.)
       ylptmp2=ydpt(k-1)+(0.,1.)
       zxm=REAL(ylptmp1)
       zym=IMAG(ylptmp1)
       za0=pai
       zb0=pbi
       !
       za1=-1./za0
       zb1=zxm - za1*zym
       zyp=-(zb1-zb0)/(za1-za0)
       zxp=za0*zyp + zb0
       zd1=(zxm-zxp)*(zxm-zxp) + (zym-zyp)*(zym-zyp)
       !
       zxm=REAL(ylptmp2)
       zym=IMAG(ylptmp2)
       za1=-1./za0
       zb1=zxm - za1*zym
       zyp=-(zb1-zb0)/(za1-za0)
       zxp=za0*zyp + zb0
       zd2=(zxm-zxp)*(zxm-zxp) + (zym-zyp)*(zym-zyp)
       IF (zd2 <=  zd1) THEN
          ydpti=ylptmp2
       ELSE
          ydpti=ylptmp1
       END IF
    END IF
  END SUBROUTINE interm_pt

  FUNCTION dist(plona,plonb,plata,platb)
    !!----------------------------------------------------------
    !!           ***  FUNCTION  DIST  ***
    !!
    !!  ** Purpose : Compute the distance (km) between
    !!          point A (lona, lata) and B(lonb,latb)
    !!
    !!  ** Method : Compute the distance along the orthodromy
    !!
    !! * history : J.M. Molines in CHART, f90, may 2007
    !!----------------------------------------------------------
    IMPLICIT NONE
    ! Argument
    REAL(KIND=8), INTENT(in) :: plata, plona, platb, plonb
    REAL(KIND=8) :: dist
    ! Local variables
    REAL(KIND=8),SAVE ::  zlatar, zlatbr, zlonar, zlonbr
    REAL(KIND=8) ::  zpds
    REAL(KIND=8),SAVE :: zux, zuy, zuz
    REAL(KIND=8) :: zvx, zvy, zvz

    REAL(KIND=8), SAVE :: prevlat=-1000., prevlon=-1000, zr, zpi, zconv
    LOGICAL :: lfirst=.TRUE.

    ! initialise some values at first call
    IF ( lfirst ) THEN
       lfirst=.FALSE.
       ! constants
       zpi=ACOS(-1.)
       zconv=zpi/180.  ! for degree to radian conversion
       ! Earth radius
       zr=(6378.137+6356.7523)/2.0 ! km
    ENDIF

    ! compute these term only if they differ from previous call
    IF ( plata /= prevlat .OR. plona /= prevlon) THEN
       zlatar=plata*zconv
       zlonar=plona*zconv
       zux=COS(zlonar)*COS(zlatar)
       zuy=SIN(zlonar)*COS(zlatar)
       zuz=SIN(zlatar)
       prevlat=plata
       prevlon=plona
    ENDIF

    zlatbr=platb*zconv
    zlonbr=plonb*zconv
    zvx=COS(zlonbr)*COS(zlatbr)
    zvy=SIN(zlonbr)*COS(zlatbr)
    zvz=SIN(zlatbr)

    zpds=zux*zvx+zuy*zvy+zuz*zvz

    IF (zpds >= 1.) THEN
       dist=0.
    ELSE
       dist=zr*ACOS(zpds)
    ENDIF
  END FUNCTION dist

END PROGRAM cdfovide

PROGRAM cdfprobe
  !!======================================================================
  !!                     ***  PROGRAM  cdfprobe  ***
  !!=====================================================================
  !!  ** Purpose : Display time series of a variable at a given point
  !!
  !!
  !! History : 2.1  : 12/2006  : J.M. Molines : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)    :: narg, iargc            ! browse line
  INTEGER(KIND=4)    :: iilook, ijlook, ilevel ! point to look at
  CHARACTER(LEN=256) :: cf_in, cldum , cv_in   ! file name  variable name
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg=iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage :  cdfprobe IN-file ilook jlook cdfvar [level]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'      Display a 2 columns output time (in days), value.'  
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       IN-file : input file to look for' 
     PRINT *,'       ilook jlook : i,j position of the probe.'
     PRINT *,'       cdfvar : name of the cdf variabled to be displayed'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [level] : This optional last argument is used' 
     PRINT *,'               to specify a model level, instead of first.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       none'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       2 columns ( time , value ) ASCII output on display'
     PRINT *,'       time are given in days since the begining of the run.'
     STOP
  ENDIF

  ! Browse command line
  CALL getarg(1, cf_in )
  CALL getarg(2, cldum ) ; READ(cldum,*) iilook
  CALL getarg(3, cldum ) ; READ(cldum,*) ijlook
  CALL getarg(4, cv_in ) 

  IF ( chkfile(cf_in) ) STOP ! missing file

  IF ( narg == 5 ) THEN
     CALL getarg(5, cldum) ;  READ(cldum,*) ilevel
     CALL gettimeseries(cf_in, cv_in, iilook, ijlook, klev=ilevel)
  ELSE
     CALL gettimeseries(cf_in, cv_in, iilook, ijlook             )
  ENDIF

END PROGRAM cdfprobe

PROGRAM cdfhdy
  !!======================================================================
  !!                     ***  PROGRAM  cdfhdy  ***
  !!=====================================================================
  !!  ** Purpose : Compute dynamical height anomaly field from gridT file
  !!               Store the results on a 2D cdf file.
  !!
  !!  ** Method  : the integral of (1/g) *10e4 * sum [ delta * dz ]
  !!               with delta = (1/rho - 1/rho0)
  !!               10e4 factor is conversion decibar/pascal
  !!
  !! History : 2.1  : 05/2010  : R. Dussin    : Original code
  !!           3.0  : 12/2010  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE eos, ONLY : sigmai
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2010, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: jk, jt           ! dummy loop index
  INTEGER(KIND=4)                           :: ierr             ! working integer
  INTEGER(KIND=4)                           :: narg, iargc      ! browse arguments
  INTEGER(KIND=4)                           :: npiglo, npjglo   ! size of the domain
  INTEGER(KIND=4)                           :: npk, npt         !  "           "
  INTEGER(KIND=4)                           :: nlev1, nlev2     ! limit of vertical integration
  INTEGER(KIND=4)                           :: ncout            ! ncid of output fileset
  INTEGER(KIND=4), DIMENSION(1)             :: ipk              ! outptut variables : number of levels,
  INTEGER(KIND=4), DIMENSION(1)             :: id_varout        ! ncdf varid's

  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: temp, sal        ! Temperature and salinity at current level
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: temp0, sal0      ! reference temperature and salinity
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: tmask            ! 2D mask at current level
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: rdep, rdepth     ! depth at current level including SSH
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: ssh              ! Sea Surface Heigh
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: tim, e3t_1d      ! time counter, vertical level spacing

  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dhdy, dterm      ! dynamic height, working array
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dsig0, dsig      ! In situ density (reference, local)
  REAL(KIND=8)                              :: drau0 = 1000.d0  ! density of fresh water
  REAL(KIND=8)                              :: dgrav = 9.81d0   ! gravity

  CHARACTER(LEN=256)                        :: cf_tfil          ! input file name
  CHARACTER(LEN=256)                        :: cf_out='cdfhdy.nc' ! output file name
  CHARACTER(LEN=256)                        :: cldum            ! dummy string

  TYPE(variable) , DIMENSION(1)             :: stypvar          ! structure for attributes
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg <= 3 ) THEN
     PRINT *,' usage : cdfhdy T-file level1 level2'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'        Compute dynamical height anomaly field from gridT file.'
     PRINT *,'        It is computed as the integral of (1/g) *10e4 * sum [ delta * dz ]'
     PRINT *,'            where delta = (1/rho - 1/rho0)'
     PRINT *,'            10e4 factor is for the conversion decibar to pascal.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'        T-file  : netcdf file with temperature and salinity'
     PRINT *,'        level1  : upper limit for vertical integration (usually 1 = surface)'
     PRINT *,'        level2  : lower limit for vertical integration.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ',TRIM(cn_fmsk),' and ', TRIM(cn_fzgr)
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : sohdy (m)'
     STOP
  ENDIF

  CALL getarg (1, cf_tfil )
  CALL getarg (2, cldum   ) ;        READ(cldum,*) nlev1
  CALL getarg (3, cldum   ) ;        READ(cldum,*) nlev2

  IF ( chkfile (cf_tfil) .OR. chkfile(cn_fmsk) .OR. chkfile(cn_fzgr)  ) STOP 99 ! missing file

  npiglo = getdim (cf_tfil,cn_x)
  npjglo = getdim (cf_tfil,cn_y)
  npk    = getdim (cf_tfil,cn_z)
  npt    = getdim (cf_tfil,cn_t)

  ipk(:) = 1 
  stypvar(1)%cname= 'sohdy'
  stypvar(1)%cunits='m'
  stypvar(1)%rmissing_value=0.
  stypvar(1)%valid_min= -100.
  stypvar(1)%valid_max= 100.
  stypvar(1)%clong_name='Dynamical height anomaly'
  stypvar(1)%cshort_name='sohdy'
  stypvar(1)%conline_operation='N/A'
  stypvar(1)%caxis='TYX'


  PRINT *, 'npiglo=', npiglo
  PRINT *, 'npjglo=', npjglo
  PRINT *, 'npk   =', npk
  PRINT *, 'npt   =', npt

  ALLOCATE (temp0(npiglo,npjglo), sal0(npiglo,npjglo), dsig0(npiglo,npjglo) ,tmask(npiglo,npjglo))
  ALLOCATE (temp(npiglo,npjglo), sal(npiglo,npjglo), dsig(npiglo,npjglo) , dhdy(npiglo,npjglo), dterm(npiglo,npjglo))
  ALLOCATE (rdep(npiglo,npjglo), rdepth(npiglo,npjglo), ssh(npiglo,npjglo), e3t_1d(npk))
  ALLOCATE (tim(npt))

  ! create output fileset
  ncout = create      (cf_out, cf_tfil,  npiglo, npjglo, npk       )
  ierr  = createvar   (ncout,  stypvar,  1,      ipk,    id_varout )
  ierr  = putheadervar(ncout,  cf_tfil,  npiglo, npjglo, npk       )

  tim   = getvar1d(cf_tfil, cn_vtimec, npt     )
  ierr  = putvar1d(ncout,   tim,       npt, 'T')

  ! Temperature and salinity for reference profile
  temp0(:,:) =  0.
  sal0(:,:)  = 35.

  tmask(:,:) = getvar(cn_fmsk, 'tmask', nlev2, npiglo, npjglo)
  ssh(:,:)   = getvar(cf_tfil,  cn_sossheig, 1,  npiglo, npjglo)
  e3t_1d(:)  = getvare3(cn_fzgr, cn_ve3t1d, npk)

  DO jt=1,npt
     PRINT *,' TIME = ', jt, tim(jt)/86400.,' days'
     dhdy(:,:)    = 0.
     rdepth(:,:) = 0.

     DO jk = nlev1, nlev2

        !rdep(:,:)   = getvar(cn_fzgr, 'e3t_ps', jk,npiglo,npjglo,ldiom=.true.)
        ! we degrade the computation to smooth the results
        rdep(:,:) = e3t_1d(jk)

        IF ( jk == 1 ) THEN
           rdep(:,:) = rdep(:,:) + ssh(:,:)
        ENDIF

        ! depth at current level, including ssh (used for computation of rho in situ)
        rdepth(:,:) = rdepth(:,:) + rdep(:,:)

        temp(:,:)= getvar(cf_tfil, cn_votemper,  jk ,npiglo, npjglo, ktime=jt)
        sal(:,:) = getvar(cf_tfil, cn_vosaline,  jk ,npiglo, npjglo, ktime=jt)

        dsig0 = sigmai(temp0, sal0, rdepth, npiglo, npjglo) 
        dsig  = sigmai(temp , sal , rdepth, npiglo, npjglo) 

        ! we compute the term of the integral : (1/g) *10e4 * sum [ delta * dz ]
        ! with delta = (1/rho - 1/rho0)
        ! 10e4 factor is conversion decibar/pascal
        !
        dterm = ( ( 1.d0 / ( drau0 + dsig(:,:) ) ) - ( 1.d0 / ( drau0 + dsig0(:,:) ) ) ) * 10000.d0 * rdep / dgrav
        ! in land, it seems appropriate to stop the computation
        WHERE(sal == 0 ) dterm = 0

        dhdy(:,:) = dhdy(:,:) + dterm(:,:)

     END DO  ! loop to next level

     ! we mask with the last level of the integral
     dhdy(:,:) = dhdy(:,:) * tmask(:,:)

     ierr = putvar(ncout, id_varout(1) ,REAL(dhdy), 1, npiglo, npjglo, ktime=jt)

  END DO  ! next time frame

  ierr = closeout(ncout)

END PROGRAM cdfhdy

PROGRAM cdfeddyscale
  !!======================================================================
  !!                     ***  PROGRAM  cdfeddyscale  ***
  !!=====================================================================
  !!  ** Purpose : Compute: -the Taylor scale or large scale eddy (lambda1)
  !!                        -the small scale eddy (lambda2) 
  !!                        -and the inertial range (scar) on F-points
  !!               lambda1 = sqrt(mean Kinetic Energie / Enstrophy)
  !!               lambda2 = sqrt(Enstrophy / Palinstrophy)
  !!               scar    = lambda1 / lambda2
  !!
  !!               Enstrophy = 1/2 * ( mean((RV)^2) )
  !!               Palinstrophy = 1/2 * ( mean((dx(RV))^2 + (dy(RV))^2) ) 
  !!
  !!  ** Method  : Use the mean of the variables (vozocrtx2 + vomecrty2), socurl2, 
  !!               (sodxcurl2 + sodycurl2) of the cdfeddyscale_pass1.f90  
  !!               
  !!  ** Warning : - the square of curl socurl2 is on F-points, 
  !!               - vozocrtx2, vomecrty2, sodxcurl2 and sodycurl2 are on UV-points
  !!              
  !! History : 3.0  : 12/2013  : C.Q. Akuetevi (original)
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence  (Licence/CDFTOOLSCeCILL.txt)
  !! @class energy_diagnostics
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: ji, jj, jt         ! dummy loop index
  INTEGER(KIND=4)                           :: npiglo, npjglo     ! size of the domain
  INTEGER(KIND=4)                           :: npk, npt           ! size of the domain
  INTEGER(KIND=4)                           :: narg, iargc, ijarg ! browse command line
  INTEGER(KIND=4)                           :: ncout, ierr        ! browse command line
  INTEGER(KIND=4), DIMENSION(3)             :: ipk, id_varout     ! output variable properties

  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zun, zvn           ! working arrays
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: rotn2              ! square curl
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zdxrotn2, zdyrotn2 ! square curl gradient components
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: vozocrtx2          ! square of velocity components
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: vomecrty2          ! square of velocity components
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zmke               ! mean kinetic energy
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: ens                ! enstrophy
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zpal               ! palinstrophy
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zlambda1           ! Taylor or large scale eddy
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zlambda2           ! small scale eddy
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: scar               ! inertial range

  REAL(KIND=8), DIMENSION(1)                :: dtim               ! time counter in output file

  CHARACTER(LEN=256)                        :: cf_meanfil   ! file names
  CHARACTER(LEN=256)                        :: cf_out = 'lambda.nc' ! output file name
  CHARACTER(LEN=256)                        :: cldum              ! dummy string

  TYPE (variable), DIMENSION(3)             :: stypvar            ! structure for attibutes

  LOGICAL                                   :: lchk     = .FALSE. ! flag for missing files
  LOGICAL                                   :: lperio   = .FALSE. ! flag for E-W periodicity
  LOGICAL                                   :: lnc4     = .FALSE. ! Use nc4 with chunking and deflation
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfeddyscale -f PASS1-meanfile [-o OUT-file] [-nc4]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'        This program computes 3 quantities relative to the eddy scales,'
     PRINT *,'        from a file preprocessed by cdfeddyscale_pass1 :'
     PRINT *,'              -the Taylor scale or large scale eddy (lambda1)'
     PRINT *,'              -the small scale eddy (lambda2)'
     PRINT *,'              -and the inertial range (scar) on F-points'
     PRINT *,'      '
     PRINT *,'           lambda1 = sqrt(mean Kinetic Energie / Enstrophy)'
     PRINT *,'           lambda2 = sqrt(Enstrophy / Palinstrophy)'
     PRINT *,'           Inertial Range    = lambda1 / lambda2'
     PRINT *,'      ' 
     PRINT *,'           Enstrophy = 1/2 * ( mean((RV)^2) )'
     PRINT *,'           Palenstrophy = 1/2 * ( mean((dx(RV))^2 + (dy(RV))^2) )'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -f  PASS1-meanfile : time average of cdfeddyscale_pass1 preprocessed'
     PRINT *,'           files.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-o OUT-file ]: specify the output file name instead of ',TRIM(cf_out)
     PRINT *,'       [-nc4 ]  : Use netcdf4 output with chunking and deflation level 1.'
     PRINT *,'              This option is effective only if cdftools are compiled with'
     PRINT *,'              a netcdf library supporting chunking and deflation.'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out),' unless -o option is used.'
     PRINT *,'         variables : solambda1 (m), solambda2 (m), soscar'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'       cdfeddyscale_pass1 '
     STOP 
  ENDIF

  ijarg=1
  DO WHILE ( ijarg <= narg )
     CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-f'   ) ; CALL getarg(ijarg, cf_meanfil ) ; ijarg=ijarg+1
        ! option
     CASE ( '-o'   ) ; CALL getarg(ijarg, cf_out     ) ; ijarg=ijarg+1
     CASE ( '-nc4' ) ; lnc4 = .TRUE.
     CASE DEFAULT    ; PRINT *, ' ERROR : ', TRIM(cldum),' : unknown option.'; STOP 99
     END SELECT
  ENDDO

  lchk = chkfile(cf_meanfil ) .OR. lchk
  IF ( lchk ) STOP 99 ! missing files

  npiglo = getdim(cf_meanfil,cn_x)
  npjglo = getdim(cf_meanfil,cn_y)

  PRINT *, 'npiglo = ',npiglo
  PRINT *, 'npjglo = ',npjglo

  ! Allocate the memory
  ALLOCATE ( rotn2(npiglo,npjglo)                                )
  ALLOCATE ( zdxrotn2(npiglo,npjglo)  , zdyrotn2(npiglo,npjglo)  )
  ALLOCATE ( vozocrtx2(npiglo,npjglo) , vomecrty2(npiglo,npjglo) )
  ALLOCATE ( zmke(npiglo,npjglo)                                 )
  ALLOCATE ( ens(npiglo,npjglo)                                  )
  ALLOCATE ( zpal(npiglo,npjglo)                                 )
  ALLOCATE ( zlambda1(npiglo,npjglo)   , zlambda2(npiglo,npjglo) )
  ALLOCATE ( scar(npiglo,npjglo)                                 )

  CALL CreateOutputFile

  !load the mean variables
  rotn2(:,:)     =  getvar(cf_meanfil, 'socurl2'  , 1,npiglo,npjglo )
  zdxrotn2(:,:)  =  getvar(cf_meanfil, 'sodxcurl2', 1,npiglo,npjglo )
  zdyrotn2(:,:)  =  getvar(cf_meanfil, 'sodycurl2', 1,npiglo,npjglo )
  vozocrtx2(:,:) =  getvar(cf_meanfil, 'vozocrtx2', 1,npiglo,npjglo )
  vomecrty2(:,:) =  getvar(cf_meanfil, 'vomecrty2', 1,npiglo,npjglo )

  ! Enstrophy
  ens(:,:) = 0.5 * rotn2(:,:)

  ! compute the Kinetic Energy on F-points
  zmke = -9999.
  DO jj = 1, npjglo-1
     DO ji = 1, npiglo-1   ! vector opt.
        zmke(ji,jj) =  0.25 *( (vozocrtx2(ji,jj+1) + vozocrtx2(ji,jj))   &
             &                +(vomecrty2(ji+1,jj) + vomecrty2(ji,jj))   )
     END DO
  END DO

  ! compute the Palinstrophy on  F-points
  zpal = -9999.
  DO jj = 1, npjglo-1 
     DO ji = 1, npiglo-1   ! vector opt.
        zpal(ji,jj) =  0.25 * (zdxrotn2(ji+1,jj) + zdxrotn2(ji,jj))  &
             & + 0.25 * (zdyrotn2(ji,jj+1) + zdyrotn2(ji,jj))   
     END DO
  END DO

  ! compute the Taylor and small scale eddy
  zlambda1(:,:) = 0.
  zlambda2(:,:) = 0.
  WHERE( ens > 0.  ) zlambda1(:,:) = SQRT ( zmke(:,:)/ens(:,:))
  WHERE( zpal > 0. ) zlambda2(:,:) = SQRT ( ens(:,:)/zpal(:,:))

  ! compute the Inertial Range
  scar(:,:) = 0. 
  WHERE( zlambda2 > 0. ) scar(:,:) = zlambda1(:,:)/zlambda2(:,:) 

  ! write zlambda1 on file 
  ierr = putvar(ncout, id_varout(1), zlambda1, 1, npiglo, npjglo )

  ! write zlamdba2 on file
  ierr = putvar(ncout, id_varout(2), zlambda2, 1, npiglo, npjglo )

  ! write scar on file
  ierr = putvar(ncout, id_varout(3), scar,     1, npiglo, npjglo ) 

  ierr = closeout(ncout)

CONTAINS

  SUBROUTINE CreateOutputFile
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutputFile  ***
    !!
    !! ** Purpose :  Create Output file 
    !!
    !! ** Method  :  Use global variable 
    !!
    !!----------------------------------------------------------------------

    ! define new variables for output
    ! Taylor or large scale eddy F point
    ipk(1)                       = 1   !2D
    stypvar(1)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(1)%cname             = 'solambda1'
    stypvar(1)%cunits            = 'm'
    stypvar(1)%rmissing_value    = 0.
    stypvar(1)%valid_min         = 0.
    stypvar(1)%valid_max         =  100000.
    stypvar(1)%clong_name        = 'Taylor_large_eddy_scale (lambda1)'
    stypvar(1)%cshort_name       = 'solambda1'
    stypvar(1)%conline_operation = 'N/A'
    stypvar(1)%caxis             = 'TYX'

    ! Small scale eddy F point
    ipk(2)                       = 1   !2D
    stypvar(2)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(2)%cname             = 'solambda2'
    stypvar(2)%cunits            = 'm'
    stypvar(2)%rmissing_value    = 0.
    stypvar(2)%valid_min         = 0.
    stypvar(2)%valid_max         =  100000.
    stypvar(2)%clong_name        = 'Small scale eddy (lambda2)'
    stypvar(2)%cshort_name       = 'solambda2'
    stypvar(2)%conline_operation = 'N/A'
    stypvar(2)%caxis             = 'TYX'

    ! Inertial Range F point
    ipk(3)                       = 1   !2D
    stypvar(3)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(3)%cname             = 'soscar'
    stypvar(3)%cunits            = ''
    stypvar(3)%rmissing_value    = 0.
    stypvar(3)%valid_min         = 0.
    stypvar(3)%valid_max         =  20.
    stypvar(3)%clong_name        = 'Inertial range (scar)'
    stypvar(3)%cshort_name       = 'soscar'
    stypvar(3)%conline_operation = 'N/A'
    stypvar(3)%caxis             = 'TYX'

    ! create output fileset
    ncout = create      (cf_out, cf_meanfil, npiglo, npjglo, 0     , ld_nc4=lnc4 )
    ierr  = createvar   (ncout , stypvar, 3,      ipk,    id_varout, ld_nc4=lnc4 )
    ierr  = putheadervar(ncout,  cf_meanfil, npiglo, npjglo, 0 )

    dtim = getvar1d(cf_meanfil, cn_vtimec, 1      )
    ierr = putvar1d(ncout,      dtim,      1,  'T')

  END SUBROUTINE CreateOutputFile

END PROGRAM cdfeddyscale

PROGRAM cdf_dynadv_ubs 
  !!======================================================================
  !!                     ***  PROGRAM  cdf_dynadv_ubs  ***
  !!=====================================================================
  !!  ** Purpose : Compute momentum and KE advection trends following UBS advection scheme,
  !!               as well as the eddy/mean contributions (optional).
  !!
  !!  ** Method  : Adapt NEMO dynadv_ubs.F90 to CDFTOOLS (cf below for further details)
  !!               following the parameter used in the configuration eNATL60.
  !!
  !! History : 4.0  : 09/2019  : Q. Jamet & J.M. Molines : Original code
  !!                : 05/2021  : Q. Jamet & J.M. Molines : Turn the computation layer per layer
  !!                                                       to avoid memory issues.
  !!                : 06/2021  : Q. Jamet & J.M. Molines : Add eddy/mean decomposition
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames   ! for cdf variable names
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class derived_fields
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4), PARAMETER                   :: wp=4
  INTEGER(KIND=4), PARAMETER                   :: jpnvarout1 = 2           ! number of output variables (uv)
  INTEGER(KIND=4)                              :: jpnvarout2               ! number of output variables (ke)
  INTEGER(KIND=4)                              :: ji, jj, jk, jt           ! dummy loop indices
  INTEGER(KIND=4)                              :: it                       ! time index for vvl
  INTEGER(KIND=4)                              :: ierr                     ! working integer
  INTEGER(KIND=4)                              :: narg, iargc, ijarg       ! 
  INTEGER(KIND=4)                              :: npiglo, npjglo, npk, npt ! size of the domain
  INTEGER(KIND=4)                              :: npim1, npjm1, npkm1      ! index for computation of grad/div
  INTEGER(KIND=4)                              :: nkkm1=1, nkk=2, nkkp1=3  ! for swapping the levels
  INTEGER(KIND=4)                              :: npkk=3                   ! number of level to load (nkkm1, nkk, nkkp1)
  INTEGER(KIND=4)                              :: ncout_u, ncout_v         ! ncid of output file
  INTEGER(KIND=4)                              :: ncout_ke                 ! ncid of output file
  INTEGER(KIND=4), DIMENSION(jpnvarout1)       :: ipk1                     ! level of output variables
  INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE   :: ipk2                     ! level of output variables
  INTEGER(KIND=4), DIMENSION(jpnvarout1)       :: id_varout_u              ! id of output variables (u-comp)
  INTEGER(KIND=4), DIMENSION(jpnvarout1)       :: id_varout_v              ! id of output variables (v-comp)
  INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE   :: id_varout_ke             ! id of output variables (ke-comp)

  REAL(wp)                                     :: pp_gamma1 = 1._wp/3._wp  ! =0 no dissipation ; =1/4 quick   ; =1/3  3rd order UBS
  REAL(wp), PARAMETER                          :: pp_gamma2 = 1._wp/32._wp ! =0   2nd order  ; =1/32 4th order centred
  REAL(wp), DIMENSION(:)    , ALLOCATABLE      :: deptht, depthu, depthv   ! z-grid (t, u,v)
  REAL(wp), DIMENSION(:,:)  , ALLOCATABLE      :: rlon_t, rlat_t           ! t-grid hor.
  REAL(wp), DIMENSION(:,:)  , ALLOCATABLE      :: rlon_u, rlat_u           ! u-grid hor.
  REAL(wp), DIMENSION(:,:)  , ALLOCATABLE      :: rlon_v, rlat_v           ! v-grid hor.
  REAL(wp), DIMENSION(:,:)  , ALLOCATABLE      :: ht_0                     ! Reference ocean depth at T-points
  REAL(wp), DIMENSION(:,:)  , ALLOCATABLE      :: sshn                     ! now sea surface height
  REAL(wp), DIMENSION(:,:)  , ALLOCATABLE      :: sshnm                    ! now sea surface height - mean
  REAL(wp), DIMENSION(:,:)  , ALLOCATABLE      :: e1t, e2t                 ! horizontal metric, t-pts
  REAL(wp), DIMENSION(:,:)  , ALLOCATABLE      :: e1u, e2u                 ! horizontal metric, u-pts
  REAL(wp), DIMENSION(:,:)  , ALLOCATABLE      :: e1v, e2v                 ! horizontal metric, v-pts
  REAL(wp), DIMENSION(:,:)  , ALLOCATABLE      :: e12t, r1_e12u, r1_e12v   ! face area at t-pts and inverse at u- v- pts
  REAL(wp), DIMENSION(:,:)  , ALLOCATABLE      :: e3t_0, e3u_0, e3v_0      ! vet. metrics at rest (without vvl)
  REAL(wp), DIMENSION(:,:)  , ALLOCATABLE      :: e3u, e3v, e3t            ! vet. metrics, u- v- t- pts
  REAL(wp), DIMENSION(:,:)  , ALLOCATABLE      :: tmask, fmask             ! mesh masks
  REAL(wp), DIMENSION(:,:)  , ALLOCATABLE      :: umask, vmask             ! mesh masks
  REAL(wp), DIMENSION(:,:,:), ALLOCATABLE      :: wn                       ! 3D vert. velocity (now)
  REAL(wp), DIMENSION(:,:,:), ALLOCATABLE      :: wnm                      ! 3D vert. velocity (now) - mean
  REAL(wp), DIMENSION(:,:,:), ALLOCATABLE      :: un, vn                   ! 3D hz. velocity (now)
  REAL(wp), DIMENSION(:,:,:), ALLOCATABLE      :: unm, vnm                 ! 3D hz. velocity (now) - mean
  REAL(wp), DIMENSION(:,:)  , ALLOCATABLE      :: adv_h_u, adv_z_u         ! hor. and vert. advection of u-mom. (outputs)
  REAL(wp), DIMENSION(:,:)  , ALLOCATABLE      :: adv_h_v, adv_z_v         ! hor. and vert. advection of v-mom. (outputs)
  REAL(wp), DIMENSION(:,:)  , ALLOCATABLE      :: adv_h_ke, adv_z_ke       ! hor. and vert. advection of KE     (outputs)

  CHARACTER(LEN=256)                           :: cf_tt                    ! temperature netcdf file name (for mesh only)
  CHARACTER(LEN=256)                           :: cf_uu                    ! zonal vel  netcdf file name
  CHARACTER(LEN=256)                           :: cf_um                    ! MEAN zonal vel  netcdf file name
  CHARACTER(LEN=256)                           :: cf_vv                    ! merd vel  netcdf file name
  CHARACTER(LEN=256)                           :: cf_vm                    ! MEAN merd vel  netcdf file name
  CHARACTER(LEN=256)                           :: cf_ww                    ! vert. vel  netcdf file name
  CHARACTER(LEN=256)                           :: cf_wm                    ! MEAN vert. vel  netcdf file name
  CHARACTER(LEN=256)                           :: cf_ssh                   ! Sea surface height
  CHARACTER(LEN=255)                           :: cf_mh                    ! mesh       netcdf file name
  CHARACTER(LEN=255)                           :: cf_mz                    ! mesh       netcdf file name
  CHARACTER(LEN=255)                           :: cf_mask                  ! mask       netcdf file name
  CHARACTER(LEN=255)                           :: cf_bathy                 ! bathymetry netcdf file name
  CHARACTER(LEN=256)                           :: cf_out_u ='adv_u.nc'     ! output file name (u-comp)
  CHARACTER(LEN=256)                           :: cf_out_v ='adv_v.nc'     ! output file name (v-comp)
  CHARACTER(LEN=256)                           :: cf_out_ke='adv_ke.nc'    ! output file name (ke-comp)
  CHARACTER(LEN=256)                           :: cldum                    ! dummy character variable
  CHARACTER(LEN=256)                           :: cglobal                  ! global attribute
  CHARACTER(LEN=256)                           :: eddymean='full'          ! select what to compute

  TYPE (variable), DIMENSION(jpnvarout1)       :: stypvar1                 ! structure for attibutes (u-comp)
  TYPE (variable), DIMENSION(jpnvarout1)       :: stypvar2                 ! structure for attibutes (v-comp)
  TYPE (variable), DIMENSION(:), ALLOCATABLE   :: stypvar3                 ! structure for attibutes (ke-comp)

  LOGICAL                                      :: l_w   =.FALSE.           ! flag for vertical location of bn2
  LOGICAL                                      :: lchk                     ! check missing files
  LOGICAL                                      :: lfull =.FALSE.           ! full step flag
  LOGICAL                                      :: lnc4  =.FALSE.           ! full step flag
  LOGICAL                                      :: nodiss  =.FALSE.         ! to remove dissipation term in UBS scheme
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdf_dynadv_ubs -t T-file -u U-file -v V-file -w W-file SSH-file ...'
     PRINT *,'          [-um Um-file -vm Vm-file -vm Vm-file] ...'
     PRINT *,'          -mh MESH-file -mz MESZ-file -mask MASK-file -bathy BATHY-file ...'
     PRINT *,'          [-o_u OUT-file-u -o_v OUT-file-v -o_ke OUT-file-ke ...'
     PRINT *,'          -em eddy-mean_option -nodiss]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'      Compute the momentum/KE advection trend following UBS advection scheme '
     PRINT *,'      of Shchepetkin & McWilliams (2005).'
     PRINT *,'      Options are provided for computing the eddy/mean decompositions (-em),'
     PRINT *,'      and remove the diffusive term included in this advective scheme (-nodiss).'
     PRINT *,'      The latter is done by turning pp_gamma1 = 0.0.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -t T-file          : netcdf file for      temperature (for mesh only)'
     PRINT *,'       -u U-file          : netcdf file for      zonal velocity'
     PRINT *,'       -v V-file          : netcdf file for      meridional velocity'
     PRINT *,'       -w W-file          : netcdf file for      vertical velocity'
     PRINT *,'       -ssh SSH-file      : netcdf file for      SSH (for vvl recomputation of vert. grid)'
     PRINT *,'       -mh MESH-file      : netcdf file for horizontal mesh'
     PRINT *,'       -mz MESZ-file      : netcdf file for vertical mesh'
     PRINT *,'       -mask MASK-file    : netcdf file for mask'
     PRINT *,'       -bathy BATHY-file  : netcdf file for model bathymetry'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       -em                : Eddy-mean option '
     PRINT *,'                            (full, mean-mean, eddy-mean, mean-eddy, eddy-eddy)'
     PRINT *,'                            (default: '//TRIM(eddymean)//')'
     PRINT *,'             --- For eddy-mean decomposition, no need if the option em=full'
     PRINT *,'       -um Um-file        : netcdf file for MEAN zonal velocity'
     PRINT *,'       -vm Vm-file        : netcdf file for MEAN meridional velocity'
     PRINT *,'       -wm Wm-file        : netcdf file for MEAN vertical velocity'
     PRINT *,'             ---  ' 
     PRINT *,'       -nodiss            : To remove dissipation term in the UBS advection scheme;'
     PRINT *,'                          :   =.TRUE. in case eddy/mean decomposition activated'
     PRINT *,'                          :   to insure balance between full and eddy/mean terms.'
     PRINT *,'       -nc4               : use netcdf4/HDF5 with chunking and deflation on output'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : '
     PRINT *,'       -o_u OUT-file      : netcdf file for advection term for u-momentum '
     PRINT *,'                                          (defaulf: '//TRIM(cf_out_u)//' )'
     PRINT *,'       -o_v OUT-file      : netcdf file for advection term for v-momentum '
     PRINT *,'                                          (defaulf: '//TRIM(cf_out_v)//' )'
     PRINT *,'       -o_ke OUT-file     : netcdf file for advection term for KE         '
     PRINT *,'                           (ubar*putrd + vbar*pvtrd) ; (upr*putrd + vpr*pvtrd)'
     PRINT *,'                                          (defaulf: '//TRIM(cf_out_ke)//')'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'      '
     STOP
  ENDIF

  cglobal = 'Partial step computation'

  ijarg = 1
  DO WHILE ( ijarg <= narg ) 
     CALL getarg(ijarg, cldum) ; ijarg = ijarg + 1
     SELECT CASE (cldum)
     CASE ('-t'        ) ; CALL getarg( ijarg, cf_tt )    ; ijarg=ijarg+1
     CASE ('-u'        ) ; CALL getarg( ijarg, cf_uu )    ; ijarg=ijarg+1
     CASE ('-v'        ) ; CALL getarg( ijarg, cf_vv )    ; ijarg=ijarg+1
     CASE ('-w'        ) ; CALL getarg( ijarg, cf_ww )    ; ijarg=ijarg+1
     CASE ('-ssh'      ) ; CALL getarg( ijarg, cf_ssh)    ; ijarg=ijarg+1
     CASE ('-um'       ) ; CALL getarg( ijarg, cf_um )    ; ijarg=ijarg+1
     CASE ('-vm'       ) ; CALL getarg( ijarg, cf_vm )    ; ijarg=ijarg+1
     CASE ('-wm'       ) ; CALL getarg( ijarg, cf_wm )    ; ijarg=ijarg+1
        !
     CASE ('-mh'       ) ; CALL getarg( ijarg, cf_mh   )  ; ijarg=ijarg+1
     CASE ('-mz'       ) ; CALL getarg( ijarg, cf_mz   )  ; ijarg=ijarg+1
     CASE ('-mask'     ) ; CALL getarg( ijarg, cf_mask )  ; ijarg=ijarg+1
     CASE ('-bathy'    ) ; CALL getarg( ijarg, cf_bathy ) ; ijarg=ijarg+1
        ! options
     CASE ( '-full' ) ; lfull   = .TRUE. ; cglobal = 'full step computation'
     CASE ( '-o_u'    ) ; CALL getarg(ijarg, cf_out_u )   ; ijarg = ijarg + 1
     CASE ( '-o_v'    ) ; CALL getarg(ijarg, cf_out_v )   ; ijarg = ijarg + 1
     CASE ( '-o_ke'   ) ; CALL getarg(ijarg, cf_out_ke)   ; ijarg = ijarg + 1
     CASE ( '-em'     ) ; CALL getarg(ijarg, eddymean  )  ; ijarg = ijarg + 1
     CASE ( '-nodiss' ) ; nodiss  = .TRUE.                ; ijarg = ijarg + 1
     CASE ( '-nc4'    ) ; lnc4    = .TRUE.
     CASE DEFAULT     ; PRINT *,' ERROR : ', TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  END DO
  IF ( eddymean .NE. 'full' ) THEN
     jpnvarout2=4
     nodiss  = .TRUE.           ! imposes no dissipation in eddy/mean decomposition
  ELSE
     jpnvarout2=2
  END IF
  !
  IF ( nodiss ) THEN
     pp_gamma1 = 0._wp
  END IF

  !-- get dimensions (all files must have the same dimension that U-file) --
  npiglo = getdim (cf_uu, cn_x)
  npjglo = getdim (cf_uu, cn_y)
  npk    = getdim (cf_uu, cn_z)
  npt    = getdim (cf_uu, cn_t)
  npim1  = npiglo-1
  npjm1  = npjglo-1
  npkm1  = npk-1
  
  !-- summary --
  PRINT *, 'npiglo =', npiglo
  PRINT *, 'npjglo =', npjglo
  PRINT *, 'npk    =', npk
  PRINT *, 'npt    =', npt
  !
  IF ( nodiss ) THEN
          PRINT*, '-- DO NOT compute dissipation --'
          PRINT*, '           -->>  pp_gamma1=  ', pp_gamma1
  ELSE
          PRINT*, '-- Compute dissipation --'
          PRINT*, '           -->>  pp_gamma1=  ', pp_gamma1
  END IF
  !
  SELECT CASE (eddymean)
  CASE ('full' ) ;
          PRINT *, 'Copmute FULL advection'
  CASE ('mean-mean') ;
          PRINT *, 'Compute MEAN-MEAN advection components'
  CASE ('mean-eddy') ;
          PRINT *, 'Compute MEAN-EDDY advection components'
  CASE ('eddy-mean') ;
          PRINT *, 'Compute EDDY-MEAN advection components'
  CASE ('eddy-eddy') ;
          PRINT *, 'Compute EDDY-EDDY advection components'
  CASE DEFAULT ; 
          PRINT *,' ERROR : ', TRIM(eddymean),' : unknown option.' ; STOP 99
  END SELECT

  !-- Allocate --
  ALLOCATE( ipk2(jpnvarout2)                                               )
  ALLOCATE( id_varout_ke(jpnvarout2)                                       )
  ALLOCATE( stypvar3(jpnvarout2)                                           )
  ! mesh
  ALLOCATE( deptht(npk)                   , depthu(npk)                    , depthv(npk)                    )
  ALLOCATE( rlon_t(npiglo, npjglo)        , rlat_t(npiglo, npjglo)         )
  ALLOCATE( rlon_u(npiglo, npjglo)        , rlat_u(npiglo, npjglo)         )
  ALLOCATE( rlon_v(npiglo, npjglo)        , rlat_v(npiglo, npjglo)         )
  ALLOCATE( ht_0(npiglo, npjglo)                                           )
  ALLOCATE( e1t(npiglo, npjglo)           , e2t(npiglo, npjglo)            )
  ALLOCATE( e1u(npiglo, npjglo)           , e2u(npiglo, npjglo)            )
  ALLOCATE( e1v(npiglo, npjglo)           , e2v(npiglo, npjglo)            )
  ALLOCATE( e12t(npiglo, npjglo)                                           )
  ALLOCATE( r1_e12u(npiglo, npjglo)       , r1_e12v(npiglo, npjglo)        )
  ALLOCATE( e3t_0(npiglo, npjglo)         , e3t(npiglo, npjglo)            )
  ALLOCATE( e3u_0( npiglo, npjglo)        , e3v_0(npiglo, npjglo)          )
  ALLOCATE( e3u(npiglo, npjglo)           , e3v(npiglo, npjglo)            )
  ALLOCATE( tmask(npiglo, npjglo)         , fmask(npiglo, npjglo)          )
  ALLOCATE( umask(npiglo, npjglo)         , vmask(npiglo, npjglo)          )
  !! variables
  ALLOCATE( sshn(npiglo, npjglo)                                           )
  ALLOCATE( un(npiglo, npjglo, npkk)      , vn(npiglo, npjglo, npkk)       )
  ALLOCATE( wn(npiglo, npjglo, npkk)                                       )
  IF ( eddymean .NE. 'full' ) THEN
     ALLOCATE( sshnm(npiglo, npjglo)                                       )
     ALLOCATE( unm(npiglo, npjglo, npkk)  , vnm(npiglo, npjglo, npkk)      )
     ALLOCATE( wnm(npiglo, npjglo, npkk)                                   )
  END IF 
  !
  ALLOCATE( adv_h_u(npiglo, npjglo)       , adv_z_u(npiglo, npjglo)        )
  ALLOCATE( adv_h_v(npiglo, npjglo)       , adv_z_v(npiglo, npjglo)        )
  ALLOCATE( adv_h_ke(npiglo, npjglo)      , adv_z_ke(npiglo, npjglo)       )


  !!-- loading -- 
  PRINT *, '-- LOAD VARIABLES --'
  rlon_t       = getvar(cf_tt   , cn_vlon2d, 1, npiglo, npjglo )
  rlat_t       = getvar(cf_tt   , cn_vlat2d, 1, npiglo, npjglo )
  deptht       = getvar1d(cf_tt , cn_vdeptht  , npk            )
  rlon_u       = getvar(cf_uu   , cn_vlon2d, 1, npiglo, npjglo )
  rlat_u       = getvar(cf_uu   , cn_vlat2d, 1, npiglo, npjglo )
  depthu       = getvar1d(cf_uu , cn_vdepthu  , npk            )
  rlon_v       = getvar(cf_vv   , cn_vlon2d, 1, npiglo, npjglo )
  rlat_v       = getvar(cf_vv   , cn_vlat2d, 1, npiglo, npjglo )
  depthv       = getvar1d(cf_vv , cn_vdepthv  , npk            )
  ht_0(:,:)    = getvar(cf_bathy, 'gdepw_0', 1, npiglo, npjglo )
  !- hz. mesh -
  e1t(:,:)     = getvar(cf_mh   , cn_ve1t  , 1, npiglo, npjglo )
  e2t(:,:)     = getvar(cf_mh   , cn_ve2t  , 1, npiglo, npjglo )
  e1u(:,:)     = getvar(cf_mh   , cn_ve1u  , 1, npiglo, npjglo )
  e2u(:,:)     = getvar(cf_mh   , cn_ve2u  , 1, npiglo, npjglo )
  e1v(:,:)     = getvar(cf_mh   , cn_ve1v  , 1, npiglo, npjglo )
  e2v(:,:)     = getvar(cf_mh   , cn_ve2v  , 1, npiglo, npjglo )
  e12t(:,:)    = e1t(:,:) * e2t(:,:)
  r1_e12u(:,:) = 1._wp / (e1u(:,:) * e2u(:,:))
  r1_e12v(:,:) = 1._wp / (e1v(:,:) * e2v(:,:))


  !-- Creat output netcdf files to fill in --
  PRINT *, '-- Creat output --'
  CALL CreateOutput

  DO jk = 1, 1
   PRINT *, '-- klayer: ', jk

   !-- load vert. mesh (at rest) and masks (dommsk.f90) --
   e3t_0(:,:) = getvar(cf_mz  , cn_ve3t0 , jk, npiglo, npjglo )
   e3u_0(:,:) = e3t_0(:,:)
   e3v_0(:,:) = e3t_0(:,:)
   DO jj = 1, npjm1
      DO ji = 1, npim1   ! vector opt.
         e3u_0 (ji,jj) = MIN( e3t_0(ji,jj), e3t_0(ji+1,jj) )
         e3v_0 (ji,jj) = MIN( e3t_0(ji,jj), e3t_0(ji,jj+1) )
      END DO
   END DO
   tmask(:,:) = getvar(cf_mask, cn_tmask , jk, npiglo, npjglo )
   umask(:,:) = getvar(cf_mask, cn_umask , jk, npiglo, npjglo )
   vmask(:,:) = getvar(cf_mask, cn_vmask , jk, npiglo, npjglo )
   !! fmask = 2 on lateral boundaries for no-slip bdy conditions on vorticity !!
   fmask(:,:) = getvar(cf_mask, cn_fmask , jk, npiglo, npjglo )

   DO jt = 1, npt
     sshn(:,:)   = 0._wp
     un(:,:,:)   = 0._wp
     vn(:,:,:)   = 0._wp
     wn(:,:,:)   = 0._wp
     IF ( eddymean .NE. 'full' ) THEN
        unm(:,:,:)   = 0._wp
        vnm(:,:,:)   = 0._wp
        wnm(:,:,:)   = 0._wp
     END IF
     ! 
     sshn(:,:)     = getvar(cf_ssh  , cn_sossheig, 1, npiglo, npjglo, ktime=jt )
     e3t(:,:) = e3t_0(:,:) * (1 + sshn/ht_0)
     !- at u- and v- pts (domvvl.F90) -
     e3u(:,:) = e3u_0(:,:)
     e3v(:,:) = e3v_0(:,:)
     DO jj = 1, npjm1
        DO ji = 1, npim1   ! vector opt.
           e3u(ji,jj) = e3u_0(ji,jj) + 0.5_wp * umask(ji,jj) * r1_e12u(ji,jj)                 &
              &                       * (   e12t(ji  ,jj) * ( e3t(ji  ,jj) - e3t_0(ji  ,jj) )    &
              &                           + e12t(ji+1,jj) * ( e3t(ji+1,jj) - e3t_0(ji+1,jj) ) )
           e3v(ji,jj) = e3v_0(ji,jj) + 0.5_wp * vmask(ji,jj) * r1_e12v(ji,jj)                 &
              &                       * (   e12t(ji,jj  ) * ( e3t(ji,jj  ) - e3t_0(ji,jj  ) )    &
              &                           + e12t(ji,jj+1) * ( e3t(ji,jj+1) - e3t_0(ji,jj+1) ) )
        END DO
     END DO

     !-- Load variables --
     IF ( jk == 1 ) THEN
        !- variable -
        un(:,:,nkk  ) = getvar(cf_uu, cn_vozocrtx, jk  , npiglo, npjglo, ktime=jt )
        vn(:,:,nkk  ) = getvar(cf_vv, cn_vomecrty, jk  , npiglo, npjglo, ktime=jt )
        un(:,:,nkk  ) = getvar(cf_uu, cn_vozocrtx, jk  , npiglo, npjglo, ktime=jt )
        vn(:,:,nkk  ) = getvar(cf_vv, cn_vomecrty, jk  , npiglo, npjglo, ktime=jt )
        wn(:,:,nkk  ) = getvar(cf_ww, cn_vovecrtz, jk  , npiglo, npjglo, ktime=jt )
        un(:,:,nkkp1) = getvar(cf_uu, cn_vozocrtx, jk+1, npiglo, npjglo, ktime=jt )
        vn(:,:,nkkp1) = getvar(cf_vv, cn_vomecrty, jk+1, npiglo, npjglo, ktime=jt )
        wn(:,:,nkkp1) = getvar(cf_ww, cn_vovecrtz, jk+1, npiglo, npjglo, ktime=jt )
        !- ensemble mean -
        IF ( eddymean .NE. 'full' ) THEN
           unm(:,:,nkk  ) = getvar(cf_um, cn_vozocrtx, jk  , npiglo, npjglo, ktime=jt )
           vnm(:,:,nkk  ) = getvar(cf_vm, cn_vomecrty, jk  , npiglo, npjglo, ktime=jt )
           wnm(:,:,nkk  ) = getvar(cf_wm, cn_vovecrtz, jk  , npiglo, npjglo, ktime=jt )
           unm(:,:,nkkp1) = getvar(cf_um, cn_vozocrtx, jk+1, npiglo, npjglo, ktime=jt )
           vnm(:,:,nkkp1) = getvar(cf_vm, cn_vomecrty, jk+1, npiglo, npjglo, ktime=jt )
           wnm(:,:,nkkp1) = getvar(cf_wm, cn_vovecrtz, jk+1, npiglo, npjglo, ktime=jt )
        END IF
     ELSE
        !- variable -
        un(:,:,nkkm1) = getvar(cf_uu, cn_vozocrtx, jk-1, npiglo, npjglo, ktime=jt )
        vn(:,:,nkkm1) = getvar(cf_vv, cn_vomecrty, jk-1, npiglo, npjglo, ktime=jt )
        wn(:,:,nkkm1) = getvar(cf_ww, cn_vovecrtz, jk-1, npiglo, npjglo, ktime=jt )
        un(:,:,nkk  ) = getvar(cf_uu, cn_vozocrtx, jk  , npiglo, npjglo, ktime=jt )
        vn(:,:,nkk  ) = getvar(cf_vv, cn_vomecrty, jk  , npiglo, npjglo, ktime=jt )
        wn(:,:,nkk  ) = getvar(cf_ww, cn_vovecrtz, jk  , npiglo, npjglo, ktime=jt )
        un(:,:,nkkp1) = getvar(cf_uu, cn_vozocrtx, jk+1, npiglo, npjglo, ktime=jt )
        vn(:,:,nkkp1) = getvar(cf_vv, cn_vomecrty, jk+1, npiglo, npjglo, ktime=jt )
        wn(:,:,nkkp1) = getvar(cf_ww, cn_vovecrtz, jk+1, npiglo, npjglo, ktime=jt )
        !- ensemble mean -
        IF ( eddymean .NE. 'full' ) THEN
           unm(:,:,nkkm1) = getvar(cf_um, cn_vozocrtx, jk-1, npiglo, npjglo, ktime=jt )
           vnm(:,:,nkkm1) = getvar(cf_vm, cn_vomecrty, jk-1, npiglo, npjglo, ktime=jt )
           wnm(:,:,nkkm1) = getvar(cf_wm, cn_vovecrtz, jk-1, npiglo, npjglo, ktime=jt )
           unm(:,:,nkk  ) = getvar(cf_um, cn_vozocrtx, jk  , npiglo, npjglo, ktime=jt )
           vnm(:,:,nkk  ) = getvar(cf_vm, cn_vomecrty, jk  , npiglo, npjglo, ktime=jt )
           wnm(:,:,nkk  ) = getvar(cf_wm, cn_vovecrtz, jk  , npiglo, npjglo, ktime=jt )
           unm(:,:,nkkp1) = getvar(cf_um, cn_vozocrtx, jk+1, npiglo, npjglo, ktime=jt )
           vnm(:,:,nkkp1) = getvar(cf_vm, cn_vomecrty, jk+1, npiglo, npjglo, ktime=jt )
           wnm(:,:,nkkp1) = getvar(cf_wm, cn_vovecrtz, jk+1, npiglo, npjglo, ktime=jt )
        END IF
     ENDIF

     !-- Advection and KE trends --
     SELECT CASE (eddymean)
     CASE ('full' ) ;
        CALL dyn_adv_ubs( jt, jk, un, vn, wn, un, vn )
        ierr = putvar(ncout_u , id_varout_u(1) , adv_h_u(:,:) , jk, npiglo, npjglo, ktime=jt )
        ierr = putvar(ncout_u , id_varout_u(2) , adv_z_u(:,:) , jk, npiglo, npjglo, ktime=jt )
        ierr = putvar(ncout_v , id_varout_v(1) , adv_h_v(:,:) , jk, npiglo, npjglo, ktime=jt )
        ierr = putvar(ncout_v , id_varout_v(2) , adv_z_v(:,:) , jk, npiglo, npjglo, ktime=jt )
        ! KE
        CALL trd_ken( adv_h_u, adv_h_v, adv_h_ke, un, vn )
        CALL trd_ken( adv_z_u, adv_z_v, adv_z_ke, un, vn )
        ierr = putvar(ncout_ke, id_varout_ke(1), adv_h_ke(:,:), jk, npiglo, npjglo, ktime=jt )
        ierr = putvar(ncout_ke, id_varout_ke(2), adv_z_ke(:,:), jk, npiglo, npjglo, ktime=jt )
     CASE ('mean-mean') ;
        CALL dyn_adv_ubs( jt, jk, unm, vnm, wnm, unm, vnm )
        ierr = putvar(ncout_u , id_varout_u(1) , adv_h_u(:,:) , jk, npiglo, npjglo, ktime=jt )
        ierr = putvar(ncout_u , id_varout_u(2) , adv_z_u(:,:) , jk, npiglo, npjglo, ktime=jt )
        ierr = putvar(ncout_v , id_varout_v(1) , adv_h_v(:,:) , jk, npiglo, npjglo, ktime=jt )
        ierr = putvar(ncout_v , id_varout_v(2) , adv_z_v(:,:) , jk, npiglo, npjglo, ktime=jt )
        ! KE  --  ubar*
        CALL trd_ken( adv_h_u, adv_h_v, adv_h_ke, unm, vnm )
        CALL trd_ken( adv_z_u, adv_z_v, adv_z_ke, unm, vnm )
        ierr = putvar(ncout_ke, id_varout_ke(1), adv_h_ke(:,:), jk, npiglo, npjglo, ktime=jt )
        ierr = putvar(ncout_ke, id_varout_ke(2), adv_z_ke(:,:), jk, npiglo, npjglo, ktime=jt )
        ! KE  --  uprime*
        CALL trd_ken( adv_h_u, adv_h_v, adv_h_ke, un(:,:,:)-unm(:,:,:), vn(:,:,:)-vnm(:,:,:) )
        CALL trd_ken( adv_z_u, adv_z_v, adv_z_ke, un(:,:,:)-unm(:,:,:), vn(:,:,:)-vnm(:,:,:) )
        ierr = putvar(ncout_ke, id_varout_ke(3), adv_h_ke(:,:), jk, npiglo, npjglo, ktime=jt )
        ierr = putvar(ncout_ke, id_varout_ke(4), adv_z_ke(:,:), jk, npiglo, npjglo, ktime=jt )
     CASE ('mean-eddy') ;
        CALL dyn_adv_ubs( jt, jk, unm, vnm, wnm, un(:,:,:)-unm(:,:,:), vn(:,:,:)-vnm(:,:,:) )
        ierr = putvar(ncout_u , id_varout_u(1) , adv_h_u(:,:) , jk, npiglo, npjglo, ktime=jt )
        ierr = putvar(ncout_u , id_varout_u(2) , adv_z_u(:,:) , jk, npiglo, npjglo, ktime=jt )
        ierr = putvar(ncout_v , id_varout_v(1) , adv_h_v(:,:) , jk, npiglo, npjglo, ktime=jt )
        ierr = putvar(ncout_v , id_varout_v(2) , adv_z_v(:,:) , jk, npiglo, npjglo, ktime=jt )
        ! KE  --  ubar*
        CALL trd_ken( adv_h_u, adv_h_v, adv_h_ke, unm, vnm )
        CALL trd_ken( adv_z_u, adv_z_v, adv_z_ke, unm, vnm )
        ierr = putvar(ncout_ke, id_varout_ke(1), adv_h_ke(:,:), jk, npiglo, npjglo, ktime=jt )
        ierr = putvar(ncout_ke, id_varout_ke(2), adv_z_ke(:,:), jk, npiglo, npjglo, ktime=jt )
        ! KE  --  uprime*
        CALL trd_ken( adv_h_u, adv_h_v, adv_h_ke, un(:,:,:)-unm(:,:,:), vn(:,:,:)-vnm(:,:,:) )
        CALL trd_ken( adv_z_u, adv_z_v, adv_z_ke, un(:,:,:)-unm(:,:,:), vn(:,:,:)-vnm(:,:,:) )
        ierr = putvar(ncout_ke, id_varout_ke(3), adv_h_ke(:,:), jk, npiglo, npjglo, ktime=jt )
        ierr = putvar(ncout_ke, id_varout_ke(4), adv_z_ke(:,:), jk, npiglo, npjglo, ktime=jt )
     CASE ('eddy-mean') ;
        CALL dyn_adv_ubs( jt, jk, un(:,:,:)-unm(:,:,:), vn(:,:,:)-vnm(:,:,:), &
                   & wn(:,:,:)-wnm(:,:,:), unm, vnm )
        ierr = putvar(ncout_u , id_varout_u(1) , adv_h_u(:,:) , jk, npiglo, npjglo, ktime=jt )
        ierr = putvar(ncout_u , id_varout_u(2) , adv_z_u(:,:) , jk, npiglo, npjglo, ktime=jt )
        ierr = putvar(ncout_v , id_varout_v(1) , adv_h_v(:,:) , jk, npiglo, npjglo, ktime=jt )
        ierr = putvar(ncout_v , id_varout_v(2) , adv_z_v(:,:) , jk, npiglo, npjglo, ktime=jt )
        ! KE  --  ubar*
        CALL trd_ken( adv_h_u, adv_h_v, adv_h_ke, unm, vnm )
        CALL trd_ken( adv_z_u, adv_z_v, adv_z_ke, unm, vnm )
        ierr = putvar(ncout_ke, id_varout_ke(1), adv_h_ke(:,:), jk, npiglo, npjglo, ktime=jt )
        ierr = putvar(ncout_ke, id_varout_ke(2), adv_z_ke(:,:), jk, npiglo, npjglo, ktime=jt )
        ! KE  --  uprime*
        CALL trd_ken( adv_h_u, adv_h_v, adv_h_ke, un(:,:,:)-unm(:,:,:), vn(:,:,:)-vnm(:,:,:) )
        CALL trd_ken( adv_z_u, adv_z_v, adv_z_ke, un(:,:,:)-unm(:,:,:), vn(:,:,:)-vnm(:,:,:) )
        ierr = putvar(ncout_ke, id_varout_ke(3), adv_h_ke(:,:), jk, npiglo, npjglo, ktime=jt )
        ierr = putvar(ncout_ke, id_varout_ke(4), adv_z_ke(:,:), jk, npiglo, npjglo, ktime=jt )
     CASE ('eddy-eddy') ;
        CALL dyn_adv_ubs( jt, jk, un(:,:,:)-unm(:,:,:), vn(:,:,:)-vnm(:,:,:), wn(:,:,:)-wnm(:,:,:), &
                   & un(:,:,:)-unm(:,:,:), vn(:,:,:)-vnm(:,:,:) )
        ierr = putvar(ncout_u , id_varout_u(1) , adv_h_u(:,:) , jk, npiglo, npjglo, ktime=jt )
        ierr = putvar(ncout_u , id_varout_u(2) , adv_z_u(:,:) , jk, npiglo, npjglo, ktime=jt )
        ierr = putvar(ncout_v , id_varout_v(1) , adv_h_v(:,:) , jk, npiglo, npjglo, ktime=jt )
        ierr = putvar(ncout_v , id_varout_v(2) , adv_z_v(:,:) , jk, npiglo, npjglo, ktime=jt )
        ! KE  --  ubar*
        CALL trd_ken( adv_h_u, adv_h_v, adv_h_ke, unm, vnm )
        CALL trd_ken( adv_z_u, adv_z_v, adv_z_ke, unm, vnm )
        ierr = putvar(ncout_ke, id_varout_ke(1), adv_h_ke(:,:), jk, npiglo, npjglo, ktime=jt )
        ierr = putvar(ncout_ke, id_varout_ke(2), adv_z_ke(:,:), jk, npiglo, npjglo, ktime=jt )
        ! KE  --  uprime*
        CALL trd_ken( adv_h_u, adv_h_v, adv_h_ke, un(:,:,:)-unm(:,:,:), vn(:,:,:)-vnm(:,:,:) )
        CALL trd_ken( adv_z_u, adv_z_v, adv_z_ke, un(:,:,:)-unm(:,:,:), vn(:,:,:)-vnm(:,:,:) )
        ierr = putvar(ncout_ke, id_varout_ke(3), adv_h_ke(:,:), jk, npiglo, npjglo, ktime=jt )
        ierr = putvar(ncout_ke, id_varout_ke(4), adv_z_ke(:,:), jk, npiglo, npjglo, ktime=jt )
     END SELECT

   ENDDO       !jt-loop
  ENDDO        !jk-loop
 
  ierr = closeout(ncout_u)
  ierr = closeout(ncout_v)
  ierr = closeout(ncout_ke)

CONTAINS

   SUBROUTINE dyn_adv_ubs( kt, kk, u1, v1, w1, u2, v2 )
!!----------------------------------------------------------------------
!!                  ***  ROUTINE dyn_adv_ubs  ***
!!
!! ** Purpose :   Compute the now momentum advection trend in flux form
!!              and the general trend of the momentum equation.
!!
!! ** Method  :   The scheme is the one implemeted in ROMS. It depends
!!      on two parameter gamma1 and gamma2. The former control the
!!      upstream baised part of the scheme and the later the centred
!!      part:     gamma1 = 0    pure centered  (no diffusive part)
!!                       = 1/4  Quick scheme
!!                       = 1/3  3rd order Upstream biased scheme
!!                gamma2 = 0    2nd order finite differencing
!!                       = 1/32 4th order finite differencing
!!      For stability reasons, the first term of the fluxes which cor-
!!      responds to a second order centered scheme is evaluated using
!!      the now velocity (centered in time) while the second term which
!!      is the diffusive part of the scheme, is evaluated using the
!!      before velocity (forward in time).
!!      Default value (hard coded in the begining of the module) are
!!      gamma1=1/3 and gamma2=1/32.
!!
!! ** Action : - (ua,va) updated with the 3D advective momentum trends
!!
!! Reference : Shchepetkin & McWilliams, 2005, Ocean Modelling.
!!----------------------------------------------------------------------
      INTEGER, INTENT(in) ::   kt     ! ocean time-step index
      INTEGER, INTENT(in) ::   kk     ! ocean vertical level
      REAL(wp), DIMENSION(:,:,:), INTENT(in   ) ::   u1, v1, w1   ! U, V and W ocean advecting velocities
      REAL(wp), DIMENSION(:,:,:), INTENT(in   ) ::   u2, v2       ! U and V    ocean advected  velocities
!
      INTEGER  ::   ji, jj              ! dummy loop indices
      REAL(wp) ::   zbu, zbv    ! temporary scalars
      REAL(wp) ::   zui, zvj, zfuj, zfvi, zl_u, zl_v   ! temporary scalars
      REAL(wp), POINTER, DIMENSION(:,:    ) ::  zfu, zfv
      REAL(wp), POINTER, DIMENSION(:,:,:  ) ::  zfw
      REAL(wp), POINTER, DIMENSION(:,:    ) ::  zfu_t, zfv_t, zfu_f, zfv_f
      REAL(wp), POINTER, DIMENSION(:,:,:  ) ::  zfu_uw, zfv_vw
      REAL(wp), POINTER, DIMENSION(:,:,:  ) ::  zlu_uu, zlv_vv, zlu_uv, zlv_vu
!!----------------------------------------------------------------------
!
      ALLOCATE( zfu(npiglo, npjglo)          , zfv(npiglo, npjglo)          )
      ALLOCATE( zfw(npiglo, npjglo, npkk)                                   )
      ALLOCATE( zfu_t(npiglo, npjglo)        , zfv_t(npiglo, npjglo)        )
      ALLOCATE( zfu_f(npiglo, npjglo)        , zfv_f(npiglo, npjglo)        )
      ALLOCATE( zfu_uw(npiglo, npjglo, npkk) , zfv_vw(npiglo, npjglo, npkk) )
      !
      ALLOCATE( zlu_uu(npiglo, npjglo, 2)    , zlv_vv(npiglo, npjglo, 2)    )
      ALLOCATE( zlu_uv(npiglo, npjglo, 2)    , zlv_vu(npiglo, npjglo, 2)    )

!
      zfu_t(:,:)    = 0._wp
      zfv_t(:,:)    = 0._wp
      zfu_f(:,:)    = 0._wp
      zfv_f(:,:)    = 0._wp
      zfu_uw(:,:,:) = 0._wp
      zfv_vw(:,:,:) = 0._wp
!
      zlu_uu(:,:,:) = 0._wp
      zlv_vv(:,:,:) = 0._wp
      zlu_uv(:,:,:) = 0._wp
      zlv_vu(:,:,:) = 0._wp

!                                      ! =========================== !
                                       !  Laplacian of the velocity  !
!                                      ! =========================== !
!                                         ! horizontal volume fluxes
         zfu(:,:) = e2u(:,:) * e3u(:,:) * u1(:,:,nkk)
         zfv(:,:) = e1v(:,:) * e3v(:,:) * v1(:,:,nkk)
!
         DO jj = 2, npjm1                          ! laplacian
            DO ji = 2, npim1   ! vector opt.
!
               zlu_uu(ji,jj,1) = ( u2 (ji+1,jj  ,nkk) - 2.*u2 (ji,jj,nkk) + u2 (ji-1,jj  ,nkk) ) * umask(ji,jj)
               zlv_vv(ji,jj,1) = ( v2 (ji  ,jj+1,nkk) - 2.*v2 (ji,jj,nkk) + v2 (ji  ,jj-1,nkk) ) * vmask(ji,jj)
               zlu_uv(ji,jj,1) = ( u2 (ji  ,jj+1,nkk) - u2 (ji  ,jj  ,nkk) ) * fmask(ji  ,jj  )   &
                  &               - ( u2 (ji  ,jj  ,nkk) - u2 (ji  ,jj-1,nkk) ) * fmask(ji  ,jj-1)
               zlv_vu(ji,jj,1) = ( v2 (ji+1,jj  ,nkk) - v2 (ji  ,jj  ,nkk) ) * fmask(ji  ,jj  )   &
                  &               - ( v2 (ji  ,jj  ,nkk) - v2 (ji-1,jj  ,nkk) ) * fmask(ji-1,jj  )
!
               zlu_uu(ji,jj,2) = ( zfu(ji+1,jj  ) - 2.*zfu(ji,jj) + zfu(ji-1,jj  ) ) * umask(ji,jj)
               zlv_vv(ji,jj,2) = ( zfv(ji  ,jj+1) - 2.*zfv(ji,jj) + zfv(ji  ,jj-1) ) * vmask(ji,jj)
               zlu_uv(ji,jj,2) = ( zfu(ji  ,jj+1) - zfu(ji  ,jj  ) ) * fmask(ji  ,jj  )   &
                  &               - ( zfu(ji  ,jj  ) - zfu(ji  ,jj-1) ) * fmask(ji  ,jj-1)
               zlv_vu(ji,jj,2) = ( zfv(ji+1,jj  ) - zfv(ji  ,jj  ) ) * fmask(ji  ,jj  )   &
                  &               - ( zfv(ji  ,jj  ) - zfv(ji-1,jj  ) ) * fmask(ji-1,jj  )
            END DO
         END DO

!                                      ! ====================== !
!                                      !  Horizontal advection  !
                                       ! ====================== !
!                                         ! horizontal volume fluxes
         zfu(:,:) = 0.25 * e2u(:,:) * e3u(:,:) * u1(:,:,nkk)
         zfv(:,:) = 0.25 * e1v(:,:) * e3v(:,:) * v1(:,:,nkk)
!
         DO jj = 1, npjm1                          ! horizontal momentum fluxes at T- and F-point
            DO ji = 1, npim1   ! vector opt.
               zui = ( u2(ji,jj,nkk) + u2(ji+1,jj  ,nkk) )
               zvj = ( v2(ji,jj,nkk) + v2(ji  ,jj+1,nkk) )
               IF (zui > 0) THEN   ;   zl_u = zlu_uu(ji  ,jj,1)
               ELSE                ;   zl_u = zlu_uu(ji+1,jj,1)
               ENDIF
               IF (zvj > 0) THEN   ;   zl_v = zlv_vv(ji,jj  ,1)
               ELSE                ;   zl_v = zlv_vv(ji,jj+1,1)
               ENDIF
!
               zfu_t(ji+1,jj  ) = ( zfu(ji,jj) + zfu(ji+1,jj  )                               &
                  &                    - pp_gamma2 * ( zlu_uu(ji,jj,2) + zlu_uu(ji+1,jj  ,2) )  )   &
                  &                * ( zui - pp_gamma1 * zl_u)
               zfv_t(ji  ,jj+1) = ( zfv(ji,jj) + zfv(ji  ,jj+1)                               &
                  &                    - pp_gamma2 * ( zlv_vv(ji,jj,2) + zlv_vv(ji  ,jj+1,2) )  )   &
                  &                * ( zvj - pp_gamma1 * zl_v)
!
               zfuj = ( zfu(ji,jj) + zfu(ji  ,jj+1) )
               zfvi = ( zfv(ji,jj) + zfv(ji+1,jj  ) )
               IF (zfuj > 0) THEN   ;    zl_v = zlv_vu( ji  ,jj  ,1)
               ELSE                 ;    zl_v = zlv_vu( ji+1,jj,1)
               ENDIF
               IF (zfvi > 0) THEN   ;    zl_u = zlu_uv( ji,jj  ,1)
               ELSE                 ;    zl_u = zlu_uv( ji,jj+1,1)
               ENDIF
!
               zfv_f(ji  ,jj  ) = ( zfvi - pp_gamma2 * ( zlv_vu(ji,jj,2) + zlv_vu(ji+1,jj  ,2) )  )   &
                  &                * ( u2(ji,jj,nkk) + u2(ji  ,jj+1,nkk) - pp_gamma1 * zl_u )
               zfu_f(ji  ,jj  ) = ( zfuj - pp_gamma2 * ( zlu_uv(ji,jj,2) + zlu_uv(ji  ,jj+1,2) )  )   &
                  &                * ( v2(ji,jj,nkk) + v2(ji+1,jj  ,nkk) - pp_gamma1 * zl_v )
            END DO
         END DO
         DO jj = 2, npjm1                          ! divergence of horizontal momentum fluxes
            DO ji = 2, npim1   ! vector opt.
               zbu = e1u(ji,jj) * e2u(ji,jj) * e3u(ji,jj)
               zbv = e1v(ji,jj) * e2v(ji,jj) * e3v(ji,jj)
!
               adv_h_u(ji,jj)  = - (  zfu_t(ji+1,jj  ) - zfu_t(ji  ,jj  )    &
                  &                   + zfv_f(ji  ,jj  ) - zfv_f(ji  ,jj-1)  ) / zbu
               adv_h_v(ji,jj) = - (  zfu_f(ji  ,jj  ) - zfu_f(ji-1,jj  )    &
                  &                  + zfv_t(ji  ,jj+1) - zfv_t(ji  ,jj  )  ) / zbv
!
               adv_h_u(ji,jj) = adv_h_u(ji,jj) * umask(ji,jj)
               adv_h_v(ji,jj) = adv_h_v(ji,jj) * vmask(ji,jj)
            END DO
         END DO

!                                      ! ==================== !
!                                      !  Vertical advection  !
                                       ! ==================== !
!                                         ! Vertical volume fluxes
         zfw(:,:,nkk)   = 0.25 * e1t(:,:) * e2t(:,:) * w1(:,:,nkk  )
         zfw(:,:,nkkp1) = 0.25 * e1t(:,:) * e2t(:,:) * w1(:,:,nkkp1)
!
   !      IF( kk == 1 ) THEN                        ! surface/bottom advective fluxes
   !       ... moved after interior fluxes ...
   !      ELSE                                      ! interior fluxes
            DO jj = 2, npjm1
               DO ji = 2, npim1   ! vector opt.
                  zfu_uw(ji,jj,nkk)   = ( zfw(ji,jj,nkk)  + zfw(ji+1,jj  ,nkk) )   * ( u2(ji,jj,nkk)   + u2(ji,jj,nkkm1) )
                  zfv_vw(ji,jj,nkk)   = ( zfw(ji,jj,nkk)  + zfw(ji  ,jj+1,nkk) )   * ( v2(ji,jj,nkk)   + v2(ji,jj,nkkm1) )
                  zfu_uw(ji,jj,nkkp1) = ( zfw(ji,jj,nkkp1)+ zfw(ji+1,jj  ,nkkp1) ) * ( u2(ji,jj,nkkp1) + u2(ji,jj,nkk)   )
                  zfv_vw(ji,jj,nkkp1) = ( zfw(ji,jj,nkkp1)+ zfw(ji  ,jj+1,nkkp1) ) * ( v2(ji,jj,nkkp1) + v2(ji,jj,nkk)   )
               END DO
            END DO
    !     ENDIF
         IF( kk == npkm1 ) THEN
            zfu_uw(:,:,nkkp1) = 0.e0                      ! Bottom  value : flux set to zero
            zfv_vw(:,:,nkkp1) = 0.e0
         ENDIF
         IF ( kk == 1 ) THEN                        ! Surface value :
!            IF( lk_vvl ) THEN                                ! variable volume : flux set to zero
               zfu_uw(:,:, nkk ) = 0.e0
               zfv_vw(:,:, nkk ) = 0.e0
!            ELSE                                             ! constant volume : advection through the surface
!               ...
!            ENDIF
         ENDIF

         DO jj = 2, npjm1
            DO ji = 2, npim1   ! vector opt.
               adv_z_u(ji,jj) =  - ( zfu_uw(ji,jj,nkk) - zfu_uw(ji,jj,nkkp1) )    &
                  &  / ( e1u(ji,jj) * e2u(ji,jj) * e3u(ji,jj) )
               adv_z_v(ji,jj) =  - ( zfv_vw(ji,jj,nkk) - zfv_vw(ji,jj,nkkp1) )    &
                  &  / ( e1v(ji,jj) * e2v(ji,jj) * e3v(ji,jj) )
!
               adv_z_u(ji,jj) = adv_z_u(ji,jj) * umask(ji,jj)
               adv_z_v(ji,jj) = adv_z_v(ji,jj) * vmask(ji,jj)
            END DO
         END DO
!
      DEALLOCATE( zfu_t , zfv_t  )
      DEALLOCATE( zfu_f , zfv_f  )
      DEALLOCATE( zfu   , zfv    )
      DEALLOCATE( zfw            )
      DEALLOCATE( zlu_uu, zlv_vv )
      DEALLOCATE( zlu_uv, zlv_vu )

   END SUBROUTINE dyn_adv_ubs


   SUBROUTINE trd_ken( putrd, pvtrd, ktrd, u0, v0 )
!!---------------------------------------------------------------------
!!                  ***  ROUTINE trd_ken  ***
!!
!! ** Purpose :   output 3D Kinetic Energy trends using IOM
!!
!! ** Method  : - apply lbc to the input masked velocity trends
!!              - compute the associated KE trend:
!!          zke = 0.5 * (  mi-1[ un * putrd * bu ] + mj-1[ vn * pvtrd * bv]  ) / bt
!!      where bu, bv, bt are the volume of u-, v- and t-boxes.
!!              - vertical diffusion case (jpdyn_zdf):
!!          diagnose separately the KE trend associated with wind stress
!!              - bottom friction case (jpdyn_bfr):
!!          explicit case (ln_bfrimp=F): bottom trend put in the 1st level
!!                                       of putrd, pvtrd
!!----------------------------------------------------------------------
      REAL(wp), DIMENSION(:,:), INTENT(in   ) ::   putrd, pvtrd   ! U and V masked trends
      REAL(wp), DIMENSION(:,:,:), INTENT(in   ) ::   u0, v0       ! U and V 
      REAL(wp), DIMENSION(:,:), INTENT(inout) ::   ktrd           ! KE trend
!
      INTEGER ::   ji, jj       ! dummy loop indices
!
      REAL(wp)                                :: rau0 = 1026._wp    ! volumic mass of reference     [kg/m3] (from phycst.F90)
      REAL(wp), ALLOCATABLE, DIMENSION(:,:) ::   bu, bv   ! volume of u- and v-boxes
      REAL(wp), ALLOCATABLE, DIMENSION(:,:) ::   r1_bt    ! inverse of t-box volume
!!----------------------------------------------------------------------
!
!
      ALLOCATE( bu(npiglo,npjglo) , bv(npiglo,npjglo) , r1_bt(npiglo,npjglo) )
!
      bu   (:,:) =  e1u(:,:) * e2u(:,:) * e3u(:,:)
      bv   (:,:) =  e1v(:,:) * e2v(:,:) * e3v(:,:)
      r1_bt(:,:) = 1._wp / ( e12t(:,:) * e3t(:,:) ) * tmask(:,:)
!
      ktrd(:,:) = 0._wp
      ktrd(:,:) = 0._wp
      DO jj = 2, npjglo
         DO ji = 2, npiglo
            ktrd(ji,jj) = 0.5_wp * rau0 *( u0(ji  ,jj,nkk) * putrd(ji  ,jj) * bu(ji  ,jj)  &
               &                            + u0(ji-1,jj,nkk) * putrd(ji-1,jj) * bu(ji-1,jj)  &
               &                            + v0(ji,jj  ,nkk) * pvtrd(ji,jj  ) * bv(ji,jj  )  &
               &                            + v0(ji,jj-1,nkk) * pvtrd(ji,jj-1) * bv(ji,jj-1)  ) * r1_bt(ji,jj)
         END DO
      END DO

   END SUBROUTINE trd_ken



  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s)
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    REAL(KIND=8), DIMENSION(npt) :: dltim
    ! define new variables for output
    ipk1(:)                        = npk
    stypvar1(1)%ichunk             = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar1(1)%cname              = 'advh_uu'
    stypvar1(1)%cunits             = 'm/s^2'
    stypvar1(1)%rmissing_value     = 99999.
    stypvar1(1)%valid_min          = -1.
    stypvar1(1)%valid_max          = 1.
    stypvar1(1)%clong_name         = 'Horizontal advection of zonal momentum ('//TRIM(eddymean)//')'
    stypvar1(1)%cshort_name        = 'advh_uu'
    stypvar1(1)%conline_operation  = 'On u-grid'
    stypvar1(1)%caxis              = 'time depthu nav_lon_u nav_lat_u'
    !
    stypvar1(2)%ichunk             = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar1(2)%cname              = 'advz_uu'
    stypvar1(2)%cunits             = 'm/s^2'
    stypvar1(2)%rmissing_value     = 99999.
    stypvar1(2)%valid_min          = -1.
    stypvar1(2)%valid_max          = 1.
    stypvar1(2)%clong_name         = 'Vertical advection of zonal momentum ('//TRIM(eddymean)//')'
    stypvar1(2)%cshort_name        = 'advz_uu'
    stypvar1(2)%conline_operation  = 'On u-grid'
    stypvar1(2)%caxis              = 'time depthu nav_lon_u nav_lat_u'

    stypvar2(1)%ichunk             = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar2(1)%cname              = 'advh_vv'
    stypvar2(1)%cunits             = 'm/s^2'
    stypvar2(1)%rmissing_value     = 99999.
    stypvar2(1)%valid_min          = -1.
    stypvar2(1)%valid_max          = 1.
    stypvar2(1)%clong_name         = 'Horizontal advection of meridional momentum ('//TRIM(eddymean)//')'
    stypvar2(1)%cshort_name        = 'advh_vv'
    stypvar2(1)%conline_operation  = 'On v-grid'
    stypvar2(1)%caxis              = 'time depthv nav_lon_v nav_lat_v'
    !
    stypvar2(2)%ichunk             = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar2(2)%cname              = 'advz_vv'
    stypvar2(2)%cunits             = 'm/s^2'
    stypvar2(2)%rmissing_value     = 99999.
    stypvar2(2)%valid_min          = -1.
    stypvar2(2)%valid_max          = 1.
    stypvar2(2)%clong_name         = 'Vertical advection of meridional momentum ('//TRIM(eddymean)//')'
    stypvar2(2)%cshort_name        = 'advz_vv'
    stypvar2(2)%conline_operation  = 'On v-grid'
    stypvar2(2)%caxis              = 'time depthv nav_lon_v nav_lat_v'

    ipk2(:)                        = npk
    IF ( eddymean .EQ. 'full ') THEN
    stypvar3(1)%ichunk             = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar3(1)%cname              = 'advh_ke'
    stypvar3(1)%cunits             = 'm^2/s^3'
    stypvar3(1)%rmissing_value     = 99999.
    stypvar3(1)%valid_min          = -1.
    stypvar3(1)%valid_max          = 1.
    stypvar3(1)%clong_name         = 'Horizontal advection of Kinetic Energy ('//TRIM(eddymean)//')'
    stypvar3(1)%cshort_name        = 'advh_ke'
    stypvar3(1)%conline_operation  = 'On t-grid'
    stypvar3(1)%caxis              = 'time deptht nav_lon_t nav_lat_t'
    !
    stypvar3(2)%ichunk             = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar3(2)%cname              = 'advz_ke'
    stypvar3(2)%cunits             = 'm^2/s^3'
    stypvar3(2)%rmissing_value     = 99999.
    stypvar3(2)%valid_min          = -1.
    stypvar3(2)%valid_max          = 1.
    stypvar3(2)%clong_name         = 'Vertical advection of Kinetic Energy ('//TRIM(eddymean)//')'
    stypvar3(2)%cshort_name        = 'advz_ke'
    stypvar3(2)%conline_operation  = 'On t-grid'
    stypvar3(2)%caxis              = 'time deptht nav_lon_t nav_lat_t'
    ELSE
    stypvar3(1)%ichunk             = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar3(1)%cname              = 'advh_ke_m'
    stypvar3(1)%cunits             = 'm^2/s^3'
    stypvar3(1)%rmissing_value     = 99999.
    stypvar3(1)%valid_min          = -1.
    stypvar3(1)%valid_max          = 1.
    stypvar3(1)%clong_name         = 'um * advh_uu + vm * advh_vv ('//TRIM(eddymean)//')'
    stypvar3(1)%cshort_name        = 'advh_ke_m'
    stypvar3(1)%conline_operation  = 'On t-grid'
    stypvar3(1)%caxis              = 'time deptht nav_lon_t nav_lat_t'
    !
    stypvar3(2)%ichunk             = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar3(2)%cname              = 'advz_ke_m'
    stypvar3(2)%cunits             = 'm^2/s^3'
    stypvar3(2)%rmissing_value     = 99999.
    stypvar3(2)%valid_min          = -1.
    stypvar3(2)%valid_max          = 1.
    stypvar3(2)%clong_name         = 'um * advz_uu + vm * advz_vv ('//TRIM(eddymean)//')'
    stypvar3(2)%cshort_name        = 'advz_ke_m'
    stypvar3(2)%conline_operation  = 'On t-grid'
    stypvar3(2)%caxis              = 'time deptht nav_lon_t nav_lat_t'
    !
    stypvar3(3)%ichunk             = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar3(3)%cname              = 'advh_ke_pr'
    stypvar3(3)%cunits             = 'm^2/s^3'
    stypvar3(3)%rmissing_value     = 99999.
    stypvar3(3)%valid_min          = -1.
    stypvar3(3)%valid_max          = 1.
    stypvar3(3)%clong_name         = 'upr * advh_uu + vpr * advh_vv ('//TRIM(eddymean)//')'
    stypvar3(3)%cshort_name        = 'advh_ke_pr'
    stypvar3(3)%conline_operation  = 'On t-grid'
    stypvar3(3)%caxis              = 'time deptht nav_lon_t nav_lat_t'
    !
    stypvar3(4)%ichunk             = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar3(4)%cname              = 'advz_ke_pr'
    stypvar3(4)%cunits             = 'm^2/s^3'
    stypvar3(4)%rmissing_value     = 99999.
    stypvar3(4)%valid_min          = -1.
    stypvar3(4)%valid_max          = 1.
    stypvar3(4)%clong_name         = 'upr * advz_uu + vpr * advz_vv ('//TRIM(eddymean)//')'
    stypvar3(4)%cshort_name        = 'advz_ke_pr'
    stypvar3(4)%conline_operation  = 'On t-grid'
    stypvar3(4)%caxis              = 'time deptht nav_lon_t nav_lat_t'
    END IF

    ! create output fileset
    ncout_u = create      (cf_out_u, cf_uu   , npiglo, npjglo, npk  , cdep=cn_vdepthu        , ld_nc4=lnc4 )
    ierr    = createvar   (ncout_u , stypvar1, jpnvarout1    , ipk1 , id_varout_u            , ld_nc4=lnc4 )
    ierr    = putheadervar(ncout_u , cf_uu   , npiglo, npjglo, npk, rlon_u, rlat_u, depthu   )

    ncout_v = create      (cf_out_v, cf_vv   , npiglo, npjglo, npk  , cdep=cn_vdepthv        , ld_nc4=lnc4 )
    ierr    = createvar   (ncout_v , stypvar2, jpnvarout1    , ipk1 , id_varout_v            , ld_nc4=lnc4 )
    ierr    = putheadervar(ncout_v , cf_vv   , npiglo, npjglo, npk, rlon_v, rlat_v, depthv   )

    ncout_ke= create     (cf_out_ke, cf_tt   , npiglo, npjglo, npk  , cdep=cn_vdeptht        , ld_nc4=lnc4 )
    ierr    = createvar   (ncout_ke, stypvar3, jpnvarout2    , ipk2 , id_varout_ke           , ld_nc4=lnc4 )
    ierr    = putheadervar(ncout_ke, cf_tt   , npiglo, npjglo, npk, rlon_t, rlat_t, deptht   )

    dltim = getvar1d(cf_uu  , cn_vtimec,   npt     )
    ierr = putvar1d(ncout_u , dltim,       npt, 'T')
    ierr = putvar1d(ncout_v , dltim,       npt, 'T')
    ierr = putvar1d(ncout_ke, dltim,       npt, 'T')

  END SUBROUTINE CreateOutput


END PROGRAM

PROGRAM cdfbottom
  !!======================================================================
  !!                     ***  PROGRAM  cdfbottom  ***
  !!=====================================================================
  !!  ** Purpose : Extract the bottom value for the 3D variables
  !!               which are in the input file. Store the results
  !!               on a similar file, with the same variable name.
  !!
  !!  **  Method:  Uses the corresponding mask file to determine the bottom.
  !!               If no mask found it assumes that 0.0000 values corresponds
  !!               to masked values.
  !!
  !! History : 2.1  : 11/2005  : J.M. Molines : Original code
  !!           3.0  : 12/2010  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2010, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------

  IMPLICIT NONE

  INTEGER(KIND=4)                            :: jk , jv, jvar, jt        ! dummy loop index
  INTEGER(KIND=4)                            :: ierr                     ! working integer
  INTEGER(KIND=4)                            :: narg, iargc, ijarg       ! argument on line
  INTEGER(KIND=4)                            :: npiglo, npjglo, npk, npt ! size of the domain
  INTEGER(KIND=4)                            :: nvars                    ! number of variables in the input file
  INTEGER(KIND=4)                            :: ncout                    ! ncid of output ncdf file
  INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE :: ipk, ipko                ! outptut variables : number of levels,
  INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE :: id_var, id_varout        ! ncdf varid's

  REAL(KIND=4), DIMENSION(:,:),  ALLOCATABLE :: zfield                   ! Array to read a layer of data
  REAL(KIND=4), DIMENSION(:,:),  ALLOCATABLE :: zbot                     ! array to store the bottom value
  REAL(KIND=4), DIMENSION(:,:),  ALLOCATABLE :: zmask                    ! 2D mask at current level
  REAL(KIND=4), DIMENSION(:),    ALLOCATABLE :: tim                      ! time counter of the file

  CHARACTER(LEN=256)                         :: cf_out='bottom.nc'       ! output file name
  CHARACTER(LEN=256)                         :: cf_in, cldum             ! working strings
  CHARACTER(LEN=256)                         :: cv_dep                   ! true name of dep dimension
  CHARACTER(LEN=5)                           :: cv_msk=' '               ! name of the mask variable
  CHARACTER(LEN=1)                           :: ctype=' '                ! point type (T U V ..)
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_names              ! array of var name

  TYPE (variable), DIMENSION(:), ALLOCATABLE :: stypvar                  ! structure for variable attribute
  !!--------------------------------------------------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfbottom  IN-file [ T | U | V | F]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Create a 2D file with bottom most values for all the variables'
     PRINT *,'       which are in the input 3D file.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       IN-file : input netcdf 3D file.' 
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [ T | U | V | F] : specify the type of grid point on the C-grid' 
     PRINT *,'            if not given, assume that land points are values with 0.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ',TRIM(cn_fmsk),' file is required if the grid point is specified' 
     PRINT *,'                  or if the land value is not 0.'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables :  same names than input file, long_name attribute is'
     PRINT *,'               prefixed by Bottom '
     STOP
  ENDIF

  ijarg = 1
  CALL getarg (ijarg, cf_in) ; ijarg = ijarg + 1

  IF ( chkfile(cf_in) ) STOP  ! missing files

  npiglo = getdim (cf_in,cn_x)
  npjglo = getdim (cf_in,cn_y)
  npk    = getdim (cf_in,cn_z, cdtrue=cv_dep, kstatus=ierr)  ! defautl cn_z is depth

  IF (ierr /= 0 ) THEN
     npk   = getdim (cf_in,'z', cdtrue=cv_dep, kstatus=ierr)
     IF (ierr /= 0 ) THEN
       npk   = getdim (cf_in,'sigma', cdtrue=cv_dep, kstatus=ierr)
        IF ( ierr /= 0 ) THEN
          npk = getdim (cf_in,'nav_lev', cdtrue=cv_dep, kstatus=ierr)
            IF ( ierr /= 0 ) THEN
              PRINT *,' assume file with no depth'
              npk=0
            ENDIF
        ENDIF
     ENDIF
  ENDIF
  npt   = getdim (cf_in,cn_t)


  ALLOCATE (zfield(npiglo,npjglo), zbot(npiglo,npjglo), zmask(npiglo,npjglo))
  ALLOCATE (tim(npt) )

  DO WHILE ( ijarg <= narg )
     CALL getarg (ijarg, ctype ) ; ijarg = ijarg + 1
     IF ( chkfile (cn_fmsk ) ) STOP  ! missing mask file

     SELECT CASE ( ctype )
     CASE ( 'T', 't', 'S', 's' )
        cv_msk='tmask'
     CASE ( 'U', 'u' )
        cv_msk='umask'
     CASE ( 'V', 'v' )
        cv_msk='vmask'
     CASE ( 'F', 'f' )
        cv_msk='fmask'
        PRINT *, 'Be carefull with fmask ... !!!'
     CASE DEFAULT
        PRINT *, ' ERROR : This type of point ', ctype,' is not known !'
        STOP
     END SELECT

  END DO

  ! look for the number of variables in the input file
  nvars = getnvar(cf_in)
  PRINT *,' nvars =', nvars

  ALLOCATE (cv_names(nvars) ,stypvar(nvars))
  ALLOCATE (id_var(nvars), ipk(nvars), id_varout(nvars), ipko(nvars) )

  cv_names(:)=getvarname(cf_in,nvars,stypvar)

  id_var(:)  = (/(jv, jv=1,nvars)/)
  ! ipk gives the number of level or 0 if not a T[Z]YX  variable
  ipk(:)     = getipk (cf_in,nvars,cdep=cv_dep)
  ipko(:)    = 1  ! all variables output are 2D

  WHERE( ipk <= 1 ) cv_names='none'
  DO jvar=1,nvars
    stypvar(jvar)%cname      = cv_names(jvar)
    stypvar(jvar)%caxis      = 'TYX'
    cldum=stypvar(jvar)%clong_name
    stypvar(jvar)%clong_name = 'Bottom '//TRIM(cldum)
  END DO
  ! create output fileset
  ! create output file taking the sizes in cf_in

  ncout = create      (cf_out,   cf_in  , npiglo, npjglo, 1         ) ! 1 level file
  ierr  = createvar   (ncout   , stypvar, nvars , ipko  , id_varout )
  ierr  = putheadervar(ncout   , cf_in  , npiglo, npjglo, 1         )

  DO jvar = 1,nvars
     zfield = 0.
     zbot   = 0.

     IF (cv_names(jvar) == 'none' ) THEN
        ! skip these variable
     ELSE
        PRINT *, ' WORKING with ', TRIM( cv_names(jvar) ), ipk(jvar)
        DO jt = 1, npt
          DO jk = 1, ipk(jvar)
             zmask = 1.
             zfield(:,:) = getvar(cf_in, cv_names(jvar),  jk, npiglo, npjglo, ktime=jt)
             IF ( cv_msk == ' ' ) THEN
                WHERE ( zfield /= 0 )
                   zbot = zfield
                END WHERE
             ELSE
                zmask(:,:) = getvar(cn_fmsk, cv_msk, jk, npiglo, npjglo)
                WHERE ( zmask /= 0 )
                   zbot = zfield
                END WHERE
             ENDIF
          END DO
          ierr = putvar(ncout, id_varout(jvar), zbot, 1, npiglo, npjglo, ktime=jt)
        ENDDO
     ENDIF
  END DO

  tim     = getvar1d(cf_in, cn_vtimec, npt     )
  ierr    = putvar1d(ncout, tim,       npt, 'T')
  ierr    = closeout(ncout)

END PROGRAM cdfbottom

PROGRAM cdf_xtract_brokenline
  !!======================================================================
  !!                     ***  PROGRAM  cdf_xtract_brokenline  ***
  !!=====================================================================
  !!  ** Purpose : Extract temperature, Salinity and velocity components
  !!               along a broken line formed by various legs
  !!
  !!  ** Method  : A broken line is defined by various segments or leg.
  !!               Each leg is defined by its starting and endig point
  !!               given as geographical coordinates on standard input.
  !!
  !!
  !! History : 2.1  : 12/2009  : R. Dussin    : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!           3.0  : 05/2013  : T. Penduff & R. Dussin  : Saving new variables
  !!           3.0  : 05/2013  : J.M. Molines : Code review, generalization 
  !!           3.0  : 06/2013  : J.M. Molines : allows multiple section files (optimization).
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  !!   routines      : description
  !!----------------------------------------------------------------------
  USE cdfio
  USE cdftools
  USE modcdfnames
  USE modutils    ! for heading
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class transport
  !!----------------------------------------------------------------------
  IMPLICIT NONE
  INTEGER(KIND=4), PARAMETER :: jp_xtra = 20          ! max number of extra fields
  INTEGER(KIND=4) :: jsec, jleg, jt, jk,  jipt, jvar ! dummy loop index
  INTEGER(KIND=4) :: jf                              !   "    "     "
  INTEGER(KIND=4) :: it                              ! time index for vvl
  INTEGER(KIND=4) :: narg, iargc, ijarg              ! command line
  INTEGER(KIND=4) :: numin=10                        ! logical unit for input section file
  INTEGER(KIND=4) :: numout=11                       ! logical unit for output section.dat (used in cdftransport)
  INTEGER(KIND=4) :: npiglo, npjglo, npk, npt        ! size of the domain
  INTEGER(KIND=4) :: iimin, iimax, ijmin, ijmax      ! ending points of a leg in model I J
  INTEGER(KIND=4) :: ii, ij, ii1, ij1, ipoint        ! working integer
  INTEGER(KIND=4) :: idum                            ! working integer
  INTEGER(KIND=4) :: ierr                            ! Netcdf error and ncid
  INTEGER(KIND=4) :: nxtra = 0                       ! number of xtra variables to extract
  INTEGER(KIND=4) :: nvar = 18                       ! number of output variables (modified after if options)
  INTEGER(KIND=4) :: np_tem, np_sal, np_una, np_vna  ! index for output variable
  INTEGER(KIND=4) :: np_isec, np_jsec, np_e2vn       !  "
  INTEGER(KIND=4) :: np_depu, np_depw                !  "
  INTEGER(KIND=4) :: np_e1vn, np_e3un, np_e3vn       !  "
  INTEGER(KIND=4) :: np_vmod, np_e1v,  np_e3v        !  "
  INTEGER(KIND=4) :: np_vmsk, np_baro, np_bat        !  "
  INTEGER(KIND=4) :: np_ssh,  np_mld,  np_vt, np_vs  !  "
  INTEGER(KIND=4) :: np_icethick, np_icefra          !  "
  INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE :: ncout                     ! Netcdf error and ncid
  INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE :: ipk, id_varout  ! netcdf output stuff
  INTEGER(KIND=4), DIMENSION(jp_xtra)        :: np_xtra, npkt

  ! broken line definition
  INTEGER(KIND=4) :: nfiles = 1                     ! number of sections
  INTEGER(KIND=4) :: nn                             ! working integer (number of points in a leg)
  INTEGER(KIND=4) :: nstamax                        ! maximum number of points per defined broken line
  INTEGER(KIND=4) :: npsecmax                       ! maximum number of points per defined model broken line
  INTEGER(KIND=4) :: ista                           ! working integer
  INTEGER(KIND=4), DIMENSION(:),     ALLOCATABLE :: npsec            ! number of points defining the model broken line
  INTEGER(KIND=4), DIMENSION(:),     ALLOCATABLE :: nsta             ! number of points defining the broken line
  INTEGER(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: normu_sec, normv_sec ! velocity normalization per section
  INTEGER(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: iisec, ijsec     ! F-index of points on the broken line
  INTEGER(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: norm_u, norm_v   ! velocity normalization per leg
  INTEGER(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: iista, ijsta     ! I,J position of the point on the broken line
  INTEGER(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: ikeepn           ! Number of points per leg
  INTEGER(KIND=4), DIMENSION(:,:,:), ALLOCATABLE :: iilegs, ijlegs   ! F-index of points on the broken line per leg

  REAL(KIND=4)                              :: ztmp
  REAL(KIND=4)                              :: zspvalt, zspvals, zspvalu, zspvalv
  REAL(KIND=4)                              :: xmin, xmax, ymin, ymax !
  REAL(KIND=4), DIMENSION(jp_xtra)          :: zspvalxtra
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: gdept               ! Model deptht levels
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: rxx, ryy            ! leg i j index of F points
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: rlonsta, rlatsta    ! Geographic position defining legs

  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e1v, e3v            ! V point relevant metric
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e2u, e3u            ! U point relevant metric
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e3w,e3uup, e3vup    ! W point relevant metric
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: hdepw               ! model bathymetry
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: rmbat               ! model bathymetry (levels)

  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: rlonu, rlatu        ! model long and lat of U points
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: rlonv, rlatv        ! model long and lat of U points
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: rlonf, rlatf        ! model long and lat of F points
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: temper, saline      ! model extra field
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: uzonal, vmerid      ! model zonal and meridional velocity
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: ssh, rmld           ! model SSH and MLD
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: ricethick, ricefra  ! ice thickness and fraction
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zvmod               ! ice thickness and fraction
  REAL(KIND=4), DIMENSION(:,:,:), ALLOCATABLE :: vextra              ! model Temperature and salinity
  ! along section array (dimension x,z or x,1 )
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: tempersec, salinesec, uzonalsec, vmeridsec
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: sshsec, rmldsec
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: ricethicksec, ricefrasec
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: rlonsec, rlatsec, risec, rjsec
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: e3usec, e3vsec
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: rdepusec, rdepwsec
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: batsec
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: vmasksec
  REAL(KIND=4), DIMENSION(:,:,:), ALLOCATABLE :: e1vsec, e2usec  ! 3rd dimension for sections
  REAL(KIND=4), DIMENSION(:,:,:), ALLOCATABLE :: vextrasec       ! model Temperature and salinity

  REAL(KIND=8)                              :: dtmp    ! temporary cumulating variable
  REAL(KIND=8)                              :: dl_xmin, dl_xmax, dl_ymin, dl_ymax !
  REAL(KIND=8), DIMENSION(:), ALLOCATABLE   :: dtim                ! Model time array
  REAL(KIND=8), DIMENSION(:), ALLOCATABLE   :: dbarot  ! for barotropic transport computation

  CHARACTER(LEN=255) :: cf_tfil , cf_ufil, cf_vfil   ! input T U V files
  CHARACTER(LEN=255) :: cf_sfil                      ! input S-file if necessary
  CHARACTER(LEN=255) :: cf_sshfil                    ! input SSH file (option)
  CHARACTER(LEN=255) :: cf_wfil                      ! input W file (vvl case)
  CHARACTER(LEN=255) :: cf_bath                      ! bathy file 
  CHARACTER(LEN=255) :: cf_ifil                      ! input ice file
  CHARACTER(LEN=255) :: cf_mfil                      ! input MLD file
  CHARACTER(LEN=255) :: cf_root=''                   ! root name used as prefix
  CHARACTER(LEN=255) :: cf_out                       ! output file
  CHARACTER(LEN=255) :: cf_secdat                    ! output section file (suitable for cdftransport or cdfsigtrp)
  CHARACTER(LEN=255) :: cv_bath                      ! bathy variable name
  CHARACTER(LEN=255) :: cv_ileadfra                  ! name of ice concentration variable
  CHARACTER(LEN=255) :: cv_iicethic                  ! name of ice thickness variable
  CHARACTER(LEN=255) :: cverb='n'                    ! verbose key for findij
  CHARACTER(LEN=5  ) :: cstar, cend                  ! dummy character variable
  CHARACTER(LEN=255) :: cldum                        ! can handle a long list of section files ...
  CHARACTER(LEN=255), DIMENSION(:), ALLOCATABLE :: cf_lst    ! input section file dim: nfiles
  CHARACTER(LEN=255), DIMENSION(:), ALLOCATABLE :: csection  ! section name
  CHARACTER(LEN=255), DIMENSION(jp_xtra)        :: cf_xtra, cv_xtra, cl_point, cu_xtra, cln_xtra, csn_xtra

  LOGICAL  :: lchk                                  ! flag for missing files
  LOGICAL  :: lverbose = .FALSE.                    ! flag for verbosity
  LOGICAL  :: lsecfile = .FALSE.                    ! flag for input section file
  LOGICAL  :: lssh     = .FALSE.                    ! flag for saving ssh
  LOGICAL  :: lmld     = .FALSE.                    ! flag for saving mld
  LOGICAL  :: lice     = .FALSE.                    ! flag for saving ice*
  LOGICAL  :: lvt      = .FALSE.                    ! flag for saving products vt, vs
  LOGICAL  :: ll_ssh, ll_mld, ll_ice                ! working flag for jk =1
  LOGICAL  :: lvecrot  = .FALSE.                    ! flag for saving mld
  REAL(KIND=4)                                    :: angled, angle, alfa, pi
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE       :: uzonala, vmerida, urot, vrot
  INTEGER(KIND=4)                                 :: ji, jj 
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: urotsec, vrotsec
  INTEGER(KIND=4) :: np_urot,np_vrot

  TYPE (variable), DIMENSION(:), ALLOCATABLE :: stypvar  ! variable definition and attributes
  !!----------------------------------------------------------------------
  ! 1. : Initialization
  ! --------------------
  CALL ReadCdfNames()


  ! check argument number and show usage if necessary
  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage :  cdf_xtrac_brokenline -t T-file -u U-file -v V-file [-i ICE-file] ...'
     PRINT *,'        ... [-b BAT-file] [-mxl MXL-file] [-f section_filei,sec_file2,..] ...'
     PRINT *,'        ... [-l LST-sections] [-ssh] [-mld] [-vt] [-vecrot] [-vvl W-file] ...'
     PRINT *,'        ... [--ssh-file SSH-file] [-s S-file ] [-o ROOT_name] [-ice] ...'
     PRINT *,'        ... [-xtra VAR-file VAR-name ] [-verbose]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'      This tool extracts model variables from model files for a geographical' 
     PRINT *,'      broken line, similar to an oceanographic campaign where an oceanic '
     PRINT *,'      section is formed by one or more legs.' 
     PRINT *,'      '
     PRINT *,'      The broken line is specified by the position of ending points of each'
     PRINT *,'      leg, given in an ASCII file. OVIDE section is taken as default, when no'
     PRINT *,'      section file is provided.'
     PRINT *,'      '
     PRINT *,'      This tool provides a netcdf file similar to a model file, but with a '
     PRINT *,'      degenerated ''y'' dimension (1). In order to be able to use standard '
     PRINT *,'      CDFTOOLS, relevant metric variables are saved into the output file, such'
     PRINT *,'      as pseudo e1v and e3v and vmask. Therefore the output file can be '
     PRINT *,'      considered as a mesh_hgr, mesh_zgr and mask file for any ''meridional'' '
     PRINT *,'      computation. In the relevant CDFTOOLS, the option ''-self'' tells the '
     PRINT *,'      program that input data file can be considered as mesh_mask file as well.'
     PRINT *,'      '
     PRINT *,'      This tools works with temperatures, salinities and normal velocities.'
     PRINT *,'      The broken line is approximated in the model, by a succession of segments'
     PRINT *,'      joining F-points. The velocity is taken as either U or V depending on the'
     PRINT *,'      orientation of the segment, temperatures and salinities are interpolated'
     PRINT *,'      on the velocity points. When progressing along the broken line, normal '
     PRINT *,'      velocity is positive when heading to the right of the progression.' 
     PRINT *,'      '
     PRINT *,'      The barotropic transport across the broken line is computed, using the'
     PRINT *,'      same sign convention. On a closed broken line, the barotropic transport'
     PRINT *,'      should be very small.'
     PRINT *,'      ' 
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -t T-file :  model gridT file. If salinity is not in T-file, '
     PRINT *,'                    use -s option'
     PRINT *,'       -u U-file :  model gridU file '
     PRINT *,'       -v V-file :  model gridV file '
     PRINT *,'      ' 
     PRINT *,'     OPTIONS :'
     PRINT *,'      [-l LST-sections ] : provides a blank-separated list of files for section'
     PRINT *,'              definitions. Section_file is an ascii file as follows :'
     PRINT *,'               * line #1 : name of the section (e.g. ovide). '
     PRINT *,'                    Will be used for naming the output file.'
     PRINT *,'               * line #2 : number of points defining the broken line.'
     PRINT *,'               * line #3-end : a pair of Longitude latitude values defining'
     PRINT *,'                    the points. If not supplied, use hard-coded information'
     PRINT *,'                    for OVIDE section. A comment can be added at the end of'
     PRINT *,'                    of the lines, using a # as separator'
     PRINT *,'      [-f section_file1,section_file2,...] : provide a comma-separated list of'
     PRINT *,'              files for section definition. This option will be deprecated in'
     PRINT *,'              favor of ''-l'' option, which passes the same file names, but'
     PRINT *,'              easier to parse when using a big number of files.'
     PRINT *,'      [-s S-file] : Specify a salinity file if salinity not in T-file.'
     PRINT *,'      [-b BAT-file] : Specify a bathymetric file in case the ocean bathymetry'
     PRINT *,'              is not in ',TRIM(cn_fzgr),' (variable ',TRIM(cn_hdepw),').'
     PRINT *,'      [-mxl MXL-file] : Give the name of the file containing the MLD if it is'
     PRINT *,'              not in T-file.'
     PRINT *,'      [--ssh-file SSH-file] : specify the ssh file if not in T-file.' 
     PRINT *,'      [-verbose] : increase verbosity  ' 
     PRINT *,'      [-ssh]     : also save ssh along the broken line.'
     PRINT *,'      [-mld]     : also save mld along the broken line.'
     PRINT *,'      [-i ICE-file] : also save ice properties (concentration, thickness)'
     PRINT *,'             extracted from ICE-file along the broken line.'
     PRINT *,'      [-vt]      : also save products vt and vs along the broken line.'
     PRINT *,'      [-vvl W-file]  : use time-varying vertical metrics. Specify a W-file in '
     PRINT *,'             order to read  time-varying e3w needed in the computation of '
     PRINT *,'             ',TRIM(cn_depu3d),'.'
     PRINT *,'      [-o ROOT-name]: specified the prefix to be used for the output file name.'
     PRINT *,'             Note that it may be a good idea to include a separator character'
     PRINT *,'             such as ''_'' at the end of the ROOT_name.'
     PRINT *,'      [-vecrot] : also save normal and tangent velocities along the broken line'
     PRINT *,'             (for plots purpose only).'
     PRINT *,'      [-xtra VAR-file VAR-name ] : This option specify information for'
     PRINT *,'             extraction of extra data: (i) The name of the VAR-file, (ii) the'
     PRINT *,'             name of the variable VAR-name in VAR-file.  Variable is assumed'
     PRINT *,'             to be on Cgrid T-point. (Release of this condition will be coded'
     PRINT *,'             in a latter version.'
     PRINT *,'             This option can be repeated many time for different files.'
     PRINT *,'     '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ', TRIM(cn_fhgr),' and ',TRIM(cn_fzgr),' in the current directory ' 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : <section_name>.nc (default). If -o option is used, the'
     PRINT *,'             name will be <ROOT-name><section_name>.nc'
     PRINT *,'         variables : temperature, salinity, normal velocity, pseudo V metrics,'
     PRINT *,'             mask, barotropic transport, bathymetry of velocity points.'
     PRINT *,'             Additional variables can be set when using options.'
     PRINT *,'       ASCII file : <section_name>_section.dat usefull for cdftransport, gives'
     PRINT *,'             the position in I,J of the geographical input points.'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'        cdftransport, cdfmoc, cdfmocsig. This tool replaces cdfovide.' 
     PRINT *,'      '
     STOP 
  ENDIF

  ! Parse command line
  cf_bath='none'
  cf_mfil='none'
  cf_sfil='none'
  cf_sshfil='none'
  ijarg = 1 
  DO WHILE ( ijarg <= narg ) 
     CALL getarg(ijarg, cldum) ; ijarg = ijarg + 1
     SELECT CASE  ( cldum   )
     CASE ( '-t'       ) ; CALL getarg(ijarg, cf_tfil ) ; ijarg=ijarg+1
     CASE ( '-u'       ) ; CALL getarg(ijarg, cf_ufil ) ; ijarg=ijarg+1
     CASE ( '-v'       ) ; CALL getarg(ijarg, cf_vfil ) ; ijarg=ijarg+1
        ! options
     CASE ( '-s'       ) ; CALL getarg(ijarg, cf_sfil ) ; ijarg=ijarg+1
     CASE ('--ssh-file') ; CALL getarg(ijarg, cf_sshfil); ijarg=ijarg+1
     CASE ( '-i'       ) ; CALL getarg(ijarg, cf_ifil ) ; ijarg=ijarg+1 ; lice = .TRUE. ;  nvar=nvar+2
     CASE ( '-o '      ) ; CALL getarg(ijarg, cf_root ) ; ijarg=ijarg+1
     CASE ( '-b '      ) ; CALL getarg(ijarg, cf_bath ) ; ijarg=ijarg+1
     CASE ( '-mxl'     ) ; CALL getarg(ijarg, cf_mfil ) ; ijarg=ijarg+1
     CASE ( '-l'       ) ; CALL GetFileList ;  lsecfile=.TRUE.
     CASE ( '-verbose' ) ; lverbose=.TRUE.  ; cverb='y'
     CASE ( '-ssh'     ) ; lssh    =.TRUE.  ; nvar=nvar+1  ! 
     CASE ( '-mld'     ) ; lmld    =.TRUE.  ; nvar=nvar+1  !
     CASE ( '-vt '     ) ; lvt     =.TRUE.  ; nvar=nvar+2  !
     CASE ( '-vvl '    ) ; lg_vvl  =.TRUE.                     !
     CASE ( '-vecrot'  ) ; lvecrot =.TRUE.  ; nvar = nvar + 2  !
     CASE ( '-f'       ) ; CALL getarg(ijarg, cldum  ) ; ijarg = ijarg + 1 ; lsecfile=.TRUE.
        ;                  CALL ParseFiles(cldum)  ! many section files can be given separated with comma
     CASE ( '-xtra'    ) ; nxtra = nxtra + 1  
        ;                  CALL getarg(ijarg, cf_xtra(nxtra) ) ; ijarg=ijarg+1
        ;                  CALL getarg(ijarg, cv_xtra(nxtra) ) ; ijarg=ijarg+1
!       ;                  CALL getarg(ijarg, cl_point(nxtra)) ; ijarg=ijarg+1

     CASE DEFAULT        ; PRINT *,' ERROR : ',TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  ENDDO

  IF ( cf_bath == 'none') THEN ; cf_bath = cn_fzgr ; cv_bath = cn_hdepw 
  ELSE                         ;                   ; cv_bath = cn_bathymet
  ENDIF
  IF ( cf_mfil == 'none') THEN ; cf_mfil = cf_tfil
  ENDIF
  IF ( cf_sfil == 'none') THEN ; cf_sfil = cf_tfil
  ENDIF
  IF ( cf_sshfil == 'none') THEN ; cf_sshfil = cf_tfil
  ENDIF
  ! check file existence
  lchk = chkfile(cn_fhgr   )
  lchk = chkfile(cf_bath   ) .OR. lchk 
  lchk = chkfile(cn_fzgr   ) .OR. lchk
  lchk = chkfile(cf_tfil   ) .OR. lchk
  lchk = chkfile(cf_sfil   ) .OR. lchk
  lchk = chkfile(cf_sshfil ) .OR. lchk
  lchk = chkfile(cf_ufil   ) .OR. lchk
  lchk = chkfile(cf_vfil   ) .OR. lchk
  IF ( lsecfile ) THEN 
     DO jsec = 1, nfiles
        lchk = chkfile(cf_lst(jsec) ) .OR. lchk
     ENDDO
  ENDIF
  DO jf=1,nxtra
    lchk = chkfile(cf_xtra(jf)  ) .OR. lchk
  ENDDO

  IF ( lchk     ) STOP 99 ! missing files
  IF ( lg_vvl   ) THEN
     cn_fe3u = cf_ufil
     cn_fe3v = cf_vfil
     cn_fe3w = cf_wfil
     cn_ve3u = cn_ve3uvvl
     cn_ve3v = cn_ve3vvvl
     cn_ve3w = cn_ve3wvvl
  ENDIF

  IF ( lice ) THEN 
     ! try to findout the name of ice-concentration and ice thickness (LIM2/LIM3)
     cv_ileadfra = cn_ileadfra
     lchk = .FALSE. 
     lchk = lchk .OR. chkvar(cf_ifil, cv_ileadfra)
     IF ( lchk ) THEN
        cv_ileadfra = cn_ileadfra3
        IF (  chkvar(cf_ifil, cv_ileadfra) ) THEN
           PRINT *,' No ice concentration found, disable ''-i'' option.'
           lice = .FALSE. ; nvar = nvar - 2
        ENDIF
     ENDIF
  ENDIF

  ! if not found concentration, lice is already false here ...
  ! do not merge the two if (lice) : nvar will be incorrect
  IF ( lice ) THEN 
     cv_iicethic = cn_iicethic
     lchk = .FALSE.
     lchk = lchk .OR. chkvar(cf_ifil, cv_iicethic)
     IF ( lchk ) THEN
        cv_iicethic = cn_iicethic3
        IF (  chkvar(cf_ifil, cv_iicethic) ) THEN
           PRINT *,' No ice thickness found, disable ''-i'' option.'
           lice = .FALSE. ; nvar = nvar - 2
        ENDIF
     ENDIF
  ENDIF

  ! count extra variables
  nvar = nvar + nxtra

  ! nvar and nfiles are  now fixed
  ALLOCATE( stypvar(nvar), ipk(nvar), id_varout(nvar) )
  ALLOCATE( csection (nfiles),nsta(nfiles), ncout(nfiles), dbarot(nfiles)  )

  ! read section file if required
  IF ( lsecfile ) THEN
     nstamax = 0
     DO jsec =1, nfiles
        OPEN(numin, file=cf_lst(jsec) )
        READ(numin,'(a)') csection(jsec)
        READ(numin,*    ) nsta(jsec)
        nstamax  = MAX( nstamax, nsta(jsec))
        CLOSE (numin)
     END DO
     IF ( lverbose ) PRINT *, 'NSTAMAX = ', nstamax
     ALLOCATE ( iista(nstamax,nfiles), ijsta(nstamax,nfiles), ikeepn(nstamax -1,nfiles )  )
     ALLOCATE ( npsec(nfiles) )
     ALLOCATE ( rlonsta(nstamax,nfiles), rlatsta(nstamax,nfiles) )

     DO jsec =1, nfiles
        OPEN(numin, file=cf_lst(jsec) )
        READ(numin,'(a)') csection(jsec)
        READ(numin,*    ) ista
        DO jipt = 1, ista
           READ(numin, * ) rlonsta(jipt,jsec), rlatsta(jipt,jsec)
        ENDDO
        CLOSE (numin)
     ENDDO
  ELSE    ! default to OVIDE section
     nfiles = 1
     nstamax = 5
     nsta(1) = 5
     csection(1) = 'ovide'
     ALLOCATE ( iista(nstamax,nfiles), ijsta(nstamax,nfiles), ikeepn(nstamax -1,nfiles )  )
     ALLOCATE ( npsec(nfiles) )
     ALLOCATE ( rlonsta(nstamax,nfiles), rlatsta(nstamax,nfiles) )

     ! D. Desbruyeres : Location of leg points that define the 4 legs of the OVIDE section
     rlonsta(1,1) = -43.70 ; rlatsta(1,1) = 59.90    ! 
     rlonsta(2,1) = -30.30 ; rlatsta(2,1) = 58.90    ! 
     rlonsta(3,1) = -19.40 ; rlatsta(3,1) = 44.90    ! 
     rlonsta(4,1) = -12.65 ; rlatsta(4,1) = 40.33    ! 
     rlonsta(5,1) = -08.70 ; rlatsta(5,1) = 40.33    ! 
  ENDIF

  ! 2. Find the model F-points along the legs of the section
  ! --------------------------------------------------------
  npiglo = getdim (cf_tfil, cn_x)
  npjglo = getdim (cf_tfil, cn_y)
  npk    = getdim (cf_tfil, cn_z)
  npt    = getdim (cf_tfil, cn_t)

  IF ( lverbose ) THEN
     PRINT *, 'NPIGLO = ', npiglo
     PRINT *, 'NPJGLO = ', npjglo
     PRINT *, 'NPK    = ', npk
     PRINT *, 'NPT    = ', npt
  ENDIF

  ! input  2D fields
  ALLOCATE(rlonu(npiglo,npjglo), rlatu(npiglo,npjglo))
  ALLOCATE(rlonv(npiglo,npjglo), rlatv(npiglo,npjglo))
  ALLOCATE(rlonf(npiglo,npjglo), rlatf(npiglo,npjglo))
  ALLOCATE(temper(npiglo,npjglo), saline(npiglo,npjglo))
  IF ( nxtra /= 0 ) ALLOCATE( vextra(npiglo,npjglo,nxtra))
  ALLOCATE(uzonal(npiglo,npjglo), vmerid(npiglo,npjglo))
  ALLOCATE(e1v(npiglo,npjglo))
  ALLOCATE(e2u(npiglo,npjglo))
  ALLOCATE(e3u(npiglo,npjglo), e3v(npiglo,npjglo), e3w(npiglo,npjglo) )
  ALLOCATE(e3uup(npiglo,npjglo), e3vup(npiglo,npjglo) )
  ALLOCATE(hdepw(npiglo,npjglo), rmbat(npiglo, npjglo))
  IF ( lssh ) ALLOCATE (ssh (npiglo, npjglo))
  IF ( lmld ) ALLOCATE (rmld(npiglo, npjglo))
  IF ( lice ) ALLOCATE(ricethick(npiglo,npjglo),ricefra(npiglo,npjglo))
  IF ( lvecrot ) ALLOCATE ( uzonala(npiglo,npjglo),vmerida(npiglo,npjglo), urot(npiglo,npjglo),vrot(npiglo,npjglo) )

  ! allocate section working arrays
  ALLOCATE ( iilegs(nstamax-1, npiglo+npjglo, nfiles), ijlegs(nstamax-1, npiglo+npjglo, nfiles) )
  ALLOCATE ( norm_u(nstamax-1, nfiles) , norm_v(nstamax-1, nfiles) )
  ALLOCATE ( rxx(npiglo+npjglo, nfiles), ryy(npiglo+npjglo, nfiles) )
  ALLOCATE ( dtim (npt), gdept(npk) )

  gdept(:) = getvar1d(cf_tfil, cn_vdeptht, npk )

  iilegs = 0  ; ijlegs = 0 ; npsec(:) = 0

  ! Loop on the sections 
  npsecmax = 0
  DO jsec  = 1, nfiles
     ! loop on the legs
     DO jleg = 1, nsta(jsec)-1

        dl_xmin = rlonsta(jleg,  jsec) *1.d0
        dl_ymin = rlatsta(jleg,  jsec) *1.d0
        dl_xmax = rlonsta(jleg+1,jsec) *1.d0
        dl_ymax = rlatsta(jleg+1,jsec) *1.d0
        ! also need xmin xmax ymin ymax in single precision for cdf_findij
        xmin = rlonsta(jleg,  jsec)
        ymin = rlatsta(jleg,  jsec)
        xmax = rlonsta(jleg+1,jsec)
        ymax = rlatsta(jleg+1,jsec)


        ! return ending points of a leg in I J model coordinates
        CALL cdf_findij ( xmin, xmax, ymin, ymax, iimin, iimax, ijmin, ijmax, &
             &            cd_coord=cn_fhgr, cd_point='F', cd_verbose=cverb)

        ! save leg information
        iista(jleg  , jsec) = iimin
        ijsta(jleg  , jsec) = ijmin
        iista(jleg+1, jsec) = iimax
        ijsta(jleg+1, jsec) = ijmax

        ! find the broken line between P1 (iimin,ijmin) and P2 (iimax, ijmax)
        CALL broken_line( iimin, iimax, ijmin, ijmax, rxx(:,jsec), ryy(:,jsec), nn, npiglo, npjglo,  &
             &            norm_u(jleg,jsec), norm_v(jleg,jsec) )
        ikeepn(jleg,jsec) = nn  ! number of points (F) on leg jleg
        npsec(jsec)       = npsec(jsec) + nn   ! total number of points (F) on the broken line

        IF ( lverbose) PRINT *, 'Leg ', jleg,' : npoints : ', nn

        IF ( jleg == 1 ) THEN
           ! we want to ensure that the broken line start in the direction that we specify
           IF ( INT(rxx(1,jsec)) /= iimin .OR.  INT(ryy(1,jsec)) /= ijmin ) THEN 
              IF ( lverbose ) PRINT *,' First leg is to be reverse'
              iilegs(jleg,1:nn,jsec)=rxx(nn:1:-1,jsec)
              ijlegs(jleg,1:nn,jsec)=ryy(nn:1:-1,jsec)
           ELSE
              iilegs(jleg,1:nn,jsec)=rxx(1:nn,jsec)
              ijlegs(jleg,1:nn,jsec)=ryy(1:nn,jsec)
           ENDIF
        ELSE  ! check the continuity between legs
           IF ( iilegs(jleg-1, ikeepn(jleg-1,jsec),jsec) == rxx(1,jsec) .AND. &
                &   ijlegs(jleg-1, ikeepn(jleg-1,jsec),jsec) == ryy(1,jsec) ) THEN  ! continuity
              IF ( lverbose ) PRINT *,' Leg ',jleg ,' is continuous ...'
              iilegs(jleg,1:nn,jsec)=rxx(1:nn,jsec)
              ijlegs(jleg,1:nn,jsec)=ryy(1:nn,jsec)
           ELSE                          ! reverse sense
              IF ( lverbose ) PRINT *,' Leg ',jleg ,' requires inversion ...'
              iilegs(jleg,1:nn,jsec)=rxx(nn:1:-1,jsec)
              ijlegs(jleg,1:nn,jsec)=ryy(nn:1:-1,jsec)
           END IF
        ENDIF

        IF ( lverbose) THEN
           PRINT *, '          Leg      iileg        ijleg rxx          ryy '
           DO jipt = 1, ikeepn(jleg,jsec)  ! ( nn ! ) 
              PRINT *, jleg, iilegs(jleg,jipt,jsec), ijlegs(jleg,jipt,jsec) ,rxx(jipt,jsec), ryy(jipt,jsec)
           END DO
        ENDIF
     END DO !! loop on the legs
     ! Check that legs are at least 2 points long 
     
     lchk=.FALSE.
     DO jleg = 1, nsta(jsec) -1
       IF ( ikeepn(jleg,jsec) < 2 ) THEN 
          lchk=.TRUE.
          PRINT *, 'Section ', TRIM(csection(jsec)),': Stations ',jleg,' and ',jleg+1,' are the same in the model !'
       ENDIF
     ENDDO
     npsecmax = MAX(npsecmax, npsec(jsec))  ! maximum number of point in any section
  END DO !! loop on the sections
  IF ( lchk ) THEN
       PRINT *,' Please edit your section file, and erase duplicate stations (model sense) '
       STOP 101
  ENDIF
     
  IF ( lverbose)  PRINT *,' NPSECMAX = ', npsecmax

  ! Now can allocate the section arrays 
  ALLOCATE( rlonsec(npsecmax,  1), rlatsec(npsecmax,1) )
  ALLOCATE( risec  (npsecmax,  1), rjsec  (npsecmax,1) )
  ALLOCATE( batsec   (npsecmax-1,1  ), vmasksec (npsecmax-1,npk) )
  ALLOCATE( tempersec(npsecmax-1,npk), salinesec(npsecmax-1,npk) )
  IF (nxtra /= 0 )  ALLOCATE( vextrasec(npsecmax-1,npk,nxtra))
  ALLOCATE( uzonalsec(npsecmax-1,npk), vmeridsec(npsecmax-1,npk) )
  ALLOCATE( zvmod (npsecmax-1,1) )  ! working array
  IF ( lssh ) ALLOCATE ( sshsec (npsecmax-1,1) )
  IF ( lmld ) ALLOCATE ( rmldsec(npsecmax-1,1) )
  IF ( lice ) ALLOCATE(ricethicksec(npsecmax-1,1),ricefrasec(npsecmax-1,1))
  IF ( lvecrot ) ALLOCATE ( urotsec(npsecmax-1,npk), vrotsec(npsecmax-1,npk) )

  ! Next arrays are initialized outside the vertical loop and thus require a section index
  ALLOCATE ( iisec    (npsecmax,nfiles),     ijsec(  npsecmax,nfiles) ) 
  ALLOCATE ( normu_sec(npsecmax,nfiles), normv_sec(  npsecmax,nfiles) ) 
  ALLOCATE ( e2usec   (npsecmax-1,1,nfiles), e3usec(  npsecmax-1,npk) )
  ALLOCATE ( e1vsec   (npsecmax-1,1,nfiles), e3vsec(  npsecmax-1,npk) )
  ALLOCATE ( rdepusec (npsecmax-1,npk), rdepwsec(npsecmax-1,npk) )

  ! 3. : Extraction along the legs
  ! ------------------------------

  e1vsec = -9999.
  e2usec = -9999.

  risec(:,:) = 0.
  rjsec(:,:) = 0.

  rlonu(:,:) = getvar(cn_fhgr, cn_glamu, 1, npiglo, npjglo)
  rlatu(:,:) = getvar(cn_fhgr, cn_gphiu, 1, npiglo, npjglo)
  rlonv(:,:) = getvar(cn_fhgr, cn_glamv, 1, npiglo, npjglo)
  rlatv(:,:) = getvar(cn_fhgr, cn_gphiv, 1, npiglo, npjglo)
  rlonf(:,:) = getvar(cn_fhgr, cn_glamf, 1, npiglo, npjglo)
  rlatf(:,:) = getvar(cn_fhgr, cn_gphif, 1, npiglo, npjglo)
  e1v(:,:)   = getvar(cn_fhgr, cn_ve1v,  1, npiglo, npjglo)
  e2u(:,:)   = getvar(cn_fhgr, cn_ve2u,  1, npiglo, npjglo)
  rmbat(:,:) = getvar(cn_fzgr, cn_mbathy,1, npiglo, npjglo)
  hdepw(:,:) = getvar(cf_bath, cv_bath,  1, npiglo, npjglo)

  !  Loop on sections for metrics and non z-depending variables
  DO jsec = 1, nfiles   ! loop on sections
     cf_out    = TRIM(cf_root)//TRIM(csection(jsec))//'.nc'
     cf_secdat = TRIM(cf_root)//TRIM(csection(jsec))//'_section.dat'

     ipoint = 1
     DO jleg=1, nsta(jsec) -1      ! loop on legs 
        ipoint = ipoint -1  ! trick to avoid repetition of points in between legs
        DO jipt=1, ikeepn(jleg,jsec) 
           ipoint = ipoint + 1
           iisec    (ipoint,jsec) = iilegs(jleg,jipt,jsec)  ! i-index
           ijsec    (ipoint,jsec) = ijlegs(jleg,jipt,jsec)  ! j-index
           normu_sec(ipoint,jsec) = norm_u(jleg,jsec)
           normv_sec(ipoint,jsec) = norm_v(jleg,jsec)
        END DO
     END DO
     ! adjust npsec to its real value ( 2nd part of the trick)
     npsec(jsec) = ipoint

     ! now that we know the model grid and bathy do fancy print of the legs.
     CALL FancyPrint(jsec)

     ! loop on 2d arrays
     DO jipt = 1,npsec(jsec)
        ii = iisec(jipt,jsec)
        ij = ijsec(jipt,jsec)

        risec  (jipt,1) = ii
        rjsec  (jipt,1) = ij
     END DO

     DO jipt=1,npsec(jsec)-1
        ii  = iisec(jipt  ,jsec) ; ij  = ijsec(jipt  ,jsec)
        ii1 = iisec(jipt+1,jsec) ; ij1 = ijsec(jipt+1,jsec)
        IF ( ij1 == ij ) THEN ! horizontal segment
           e2usec(jipt,1,jsec) = 0.
           IF ( ii1 > ii ) THEN ! eastward
              e1vsec (jipt,1,jsec) = e1v  (ii+1,ij)
              rlonsec(jipt,1) = rlonv(ii+1,ij)
              rlatsec(jipt,1) = rlatv(ii+1,ij)
              batsec (jipt,1) = MIN( hdepw(ii+1,ij),  hdepw(ii+1,ij+1) )
           ELSE
              e1vsec (jipt,1,jsec) = e1v  (ii,ij)
              rlonsec(jipt,1) = rlonv(ii,ij)
              rlatsec(jipt,1) = rlatv(ii,ij)
              batsec (jipt,1) = MIN( hdepw(ii,ij),  hdepw(ii,ij+1) )
           ENDIF

        ELSEIF ( ii1 == ii ) THEN ! vertical segment
           e1vsec(jipt,1,jsec) = 0.
           IF ( ij1 < ij ) THEN ! southward
              e2usec (jipt,1,jsec) = e2u  (ii,ij)
              rlonsec(jipt,1) = rlonu(ii,ij)
              rlatsec(jipt,1) = rlatu(ii,ij)
              batsec (jipt,1) = MIN( hdepw(ii,ij),  hdepw(ii+1,ij) )
           ELSE
              e2usec (jipt,1,jsec) = e2u  (ii,ij+1)
              rlonsec(jipt,1) = rlonu(ii,ij+1)
              rlatsec(jipt,1) = rlatu(ii,ij+1)
              batsec (jipt,1) = MIN( hdepw(ii,ij+1),  hdepw(ii+1,ij+1) )
           ENDIF

        ELSE
           PRINT *, 'problem 1 for JIPT = ', jipt
           PRINT *, '             I(P2)=',ii1, 'J(P1)=', ii
           PRINT *, '             J(P2)=',ij1, 'J(P1)=', ij
           EXIT 
        ENDIF
     END DO

     ! Prepare output file ( here because rlonsec and rlatsec required )
     DO jf = 1, nxtra
        idum=getvdim(cf_xtra(jf), cv_xtra(jf))
        IF (idum == 3 ) THEN 
         npkt(jf) = npk
        ELSE
         npkt(jf) = 1
        ENDIF
     ENDDO
     CALL CreateOutputFile (jsec )

     ierr = putvar (ncout(jsec), id_varout(np_isec), risec(:,1),                            1,  npsec(jsec)  , 1 )
     ierr = putvar (ncout(jsec), id_varout(np_jsec), rjsec(:,1),                            1,  npsec(jsec)  , 1 )
     ierr = putvar (ncout(jsec), id_varout(np_e2vn), e2usec(:,1,jsec),                      1,  npsec(jsec)-1, 1 )
     ierr = putvar (ncout(jsec), id_varout(np_e1vn), e1vsec(:,1,jsec),                      1,  npsec(jsec)-1, 1 )
     ierr = putvar (ncout(jsec), id_varout(np_e1v ), e2usec(:,1,jsec) + e1vsec(:,1,jsec),   1,  npsec(jsec)-1, 1 )
     ierr = putvar (ncout(jsec), id_varout(np_bat ), batsec(:,1),                           1,  npsec(jsec)-1, 1 )

  END DO  ! section for non depth dependent

  ! Temperature and salinity are interpolated on the respective U or V  point for better flux computation
  zspvalt = getatt(cf_tfil, cn_votemper, cn_missing_value)
  zspvals = getatt(cf_sfil, cn_vosaline, cn_missing_value)
  zspvalu = getatt(cf_ufil, cn_vozocrtx, cn_missing_value)
  zspvalv = getatt(cf_vfil, cn_vomecrty, cn_missing_value)
  DO jf = 1, nxtra
    zspvalxtra(jf) = getatt(cf_xtra(jf), cv_xtra(jf), cn_missing_value)
  ENDDO
  DO jt=1, npt  ! time loop
     IF ( lg_vvl ) THEN ;  it=jt
     ELSE ;                it=1
     ENDIF
     dbarot(:) = 0.d0    ! reset barotropic transport  for all sections
     IF ( lssh ) ssh (:,:)      = getvar(cf_sshfil,cn_sossheig,1, npiglo, npjglo, ktime = jt)
     IF ( lmld ) rmld(:,:)      = getvar(cf_mfil, cn_somxl010, 1, npiglo, npjglo, ktime = jt)
     IF ( lice ) ricethick(:,:) = getvar(cf_ifil, cv_iicethic, 1, npiglo, npjglo, ktime = jt)
     IF ( lice ) ricefra(:,:)   = getvar(cf_ifil, cv_ileadfra, 1, npiglo, npjglo, ktime = jt)

     DO jk=1,npk   ! level loop , read only once the horizontal slab
        temper(:,:) = getvar(cf_tfil, cn_votemper, jk, npiglo, npjglo, ktime = jt)
        WHERE(temper == zspvalt ) temper=0.
        saline(:,:) = getvar(cf_sfil, cn_vosaline, jk, npiglo, npjglo, ktime = jt)
        WHERE(saline == zspvals ) saline=0.
        uzonal(:,:) = getvar(cf_ufil, cn_vozocrtx, jk, npiglo, npjglo, ktime = jt)
        WHERE(uzonal == zspvalu ) uzonal=0.
        vmerid(:,:) = getvar(cf_vfil, cn_vomecrty, jk, npiglo, npjglo, ktime = jt)
        WHERE(vmerid == zspvalv ) vmerid=0.
        DO jf = 1, nxtra 
           vextra(:,:,jf) = getvar(cf_xtra(jf), cv_xtra(jf), jk, npiglo, npjglo, ktime = jt)
           WHERE(vextra(:,:,jf) == zspvalxtra(jf) )  vextra(:,:,jf)=0.
        ENDDO

        IF ( lvecrot ) THEN
           !We put the velocities in point a
           DO jj=1,npjglo
              uzonala(1,jj)=0.
              DO ji=2,npiglo
                 uzonala(ji,jj)=0.5*(uzonal(ji-1,jj) + uzonal(ji,jj))
              END DO
           END DO

           DO ji=1,npiglo
              vmerida(ji,1)=0.
              DO jj=2,npjglo
                 vmerida(ji,jj)=0.5*(vmerid(ji,jj-1) + vmerid(ji,jj))
              END DO
           END DO

           !Get alfa for the current section
           angled= heading (dl_xmin,  dl_xmax,  dl_ymin, dl_ymax )
           pi      = ACOS(-1.)
           angle = angled*pi/180.
           alfa  = angle - pi/2.
           !We rotate the velocities according to the angle in the section

           urot = uzonala * COS(alfa) - vmerida * SIN(alfa)
           vrot = uzonala * SIN(alfa) + vmerida * COS(alfa)
        ENDIF

        ! save upper layer thicness, used to compute depht of w points
        IF ( jk == 1 ) THEN
          e3uup(:,:) = 0. ; e3vup(:,:) = 0.
        ELSE
          e3uup(:,:) = e3u(:,:)
          e3vup(:,:) = e3v(:,:)
        ENDIF

        e3u(:,:)    = getvar(cn_fe3u, cn_ve3u,     jk, npiglo, npjglo, ktime = it, ldiom=.NOT.lg_vvl )
        e3v(:,:)    = getvar(cn_fe3v, cn_ve3v,     jk, npiglo, npjglo, ktime = it, ldiom=.NOT.lg_vvl )
        e3w(:,:)    = getvar(cn_fe3w, cn_ve3w,     jk, npiglo, npjglo, ktime = it, ldiom=.NOT.lg_vvl )

        ll_ssh = ( lssh .AND. jk == 1 )
        ll_mld = ( lmld .AND. jk == 1 )
        ll_ice = ( lice .AND. jk == 1 )
        tempersec(:,:) = 0.
        salinesec(:,:) = 0.
        uzonalsec(:,:) = 0.
        vmeridsec(:,:) = 0.
        IF ( lvecrot ) THEN
           urotsec  (:,:) = 0.
           vrotsec  (:,:) = 0.
        ENDIF

        DO jsec = 1, nfiles  ! section loop at level jk
           DO jipt=1,npsec(jsec)-1
              ii  = iisec(jipt  ,jsec) ; ij  = ijsec(jipt  ,jsec)  ! F point  position
              ii1 = iisec(jipt+1,jsec) ; ij1 = ijsec(jipt+1,jsec)  ! Next F point position
              IF ( ij1  == ij ) THEN ! horizontal segment
                 uzonalsec(jipt,jk) = 0.
                 e3usec   (jipt,jk) = 0.
                 IF ( ii1 > ii ) THEN ! eastward

                    IF ( MIN( saline(ii+1,ij) , saline(ii+1,ij+1))  == 0. ) THEN
                       tempersec(jipt,jk) = 0. ; salinesec(jipt,jk) = 0. 
                       DO jf=1, nxtra 
                          vextrasec(jipt,jk,jf) = 0.
                       ENDDO
                       IF ( ll_ssh ) sshsec(jipt,jk) = 0.
                       IF ( ll_mld ) rmldsec(jipt,jk) = 0.
                       IF ( ll_ice ) ricethicksec(jipt,jk) = 0.
                       IF ( ll_ice ) ricefrasec(jipt,jk) = 0.

                       IF ( lvecrot ) THEN
                          urotsec(jipt,jk) = 0.
                          vrotsec(jipt,jk) = 0.
                       ENDIF
                    ELSE
                       tempersec(jipt,jk) = 0.5 * ( temper(ii+1,ij) + temper(ii+1,ij+1) )
                       salinesec(jipt,jk) = 0.5 * ( saline(ii+1,ij) + saline(ii+1,ij+1) )
                       DO jf=1,nxtra
                         vextrasec(jipt,jk,jf) = 0.5 * ( vextra(ii+1,ij,jf) + vextra(ii+1,ij+1,jf) )
                       ENDDO
                       IF ( ll_ssh ) sshsec (jipt,jk) = 0.5 * ( ssh (ii+1,ij) + ssh (ii+1,ij+1) )
                       IF ( ll_mld ) rmldsec(jipt,jk) = 0.5 * ( rmld(ii+1,ij) + rmld(ii+1,ij+1) )
                       IF ( ll_ice ) ricethicksec(jipt,jk) = 0.5 * ( ricethick(ii+1,ij) + ricethick(ii+1,ij+1) )
                       IF ( ll_ice ) ricefrasec(jipt,jk)   = 0.5 * ( ricefra(ii+1,ij) + ricefra(ii+1,ij+1) )

                       IF ( lvecrot ) THEN
                          urotsec(jipt,jk) = 0.5 * ( urot(ii+1,ij) + urot(ii+1,ij+1) )
                          vrotsec(jipt,jk) = 0.5 * ( vrot(ii+1,ij) + vrot(ii+1,ij+1) )
                       ENDIF
                    ENDIF
                    vmeridsec(jipt,jk) = vmerid(ii+1,ij) * normv_sec(jipt,jsec)
                    e3vsec   (jipt,jk) = e3v   (ii+1,ij)
                    IF ( jk == 1 ) THEN ; rdepusec(jipt,jk) = gdept(jk)
                       ;                ; rdepwsec(jipt,jk) = 0.
                    ELSE                ; rdepusec(jipt,jk) = rdepusec(jipt,jk-1) + MIN ( e3w(ii+1,ij)  ,e3w(ii+1,ij+1)   )
                       ;                ; rdepwsec(jipt,jk) = rdepwsec(jipt,jk-1) + MIN ( e3vup(ii+1,ij),e3vup(ii+1,ij+1) )
                    ENDIF

                 ELSE ! westward

                    IF ( MIN( saline(ii,ij) , saline(ii,ij+1) ) == 0. ) THEN
                       tempersec(jipt,jk) = 0. ; salinesec(jipt,jk) = 0. 
                       DO jf=1, nxtra 
                          vextrasec(jipt,jk,jf) = 0.
                       ENDDO
                       IF ( ll_ssh ) sshsec (jipt,jk) = 0.
                       IF ( ll_mld ) rmldsec(jipt,jk) = 0.
                       IF ( ll_ice ) ricethicksec(jipt,jk) = 0.
                       IF ( ll_ice ) ricefrasec(jipt,jk) = 0.

                       IF ( lvecrot ) THEN
                          urotsec(jipt,jk) = 0.
                          vrotsec(jipt,jk) = 0.
                       ENDIF
                    ELSE
                       tempersec(jipt,jk) = 0.5 * ( temper(ii,ij) + temper(ii,ij+1) )
                       salinesec(jipt,jk) = 0.5 * ( saline(ii,ij) + saline(ii,ij+1) )
                       DO jf=1,nxtra
                         vextrasec(jipt,jk,jf) = 0.5 * ( vextra(ii,ij,jf) + vextra(ii,ij+1,jf) )
                       ENDDO
                       IF ( ll_ssh ) sshsec (jipt,jk) = 0.5 * ( ssh (ii,ij) + ssh (ii,ij+1) )
                       IF ( ll_mld ) rmldsec(jipt,jk) = 0.5 * ( rmld(ii,ij) + rmld(ii,ij+1) )
                       IF ( ll_ice ) ricethicksec(jipt,jk) = 0.5 * ( ricethick(ii,ij) + ricethick(ii,ij+1) )
                       IF ( ll_ice ) ricefrasec(jipt,jk) = 0.5 * ( ricefra(ii,ij) + ricefra(ii,ij+1) )

                       IF ( lvecrot ) THEN
                          urotsec(jipt,jk) = 0.5 * ( urot(ii,ij) + urot(ii,ij+1) )
                          vrotsec(jipt,jk) = 0.5 * ( vrot(ii,ij) + vrot(ii,ij+1) )
                       ENDIF
                    ENDIF
                    vmeridsec(jipt,jk) = vmerid(ii,ij) * normv_sec(jipt,jsec)
                    e3vsec   (jipt,jk) = e3v   (ii,ij)
                    IF ( jk == 1 ) THEN ; rdepusec(jipt,jk) = gdept(jk)
                       ;                ; rdepwsec(jipt,jk) = 0.
                    ELSE                ; rdepusec(jipt,jk) = rdepusec(jipt,jk-1) + MIN ( e3w(  ii,ij)  ,e3w(ii,ij+1) )
                       ;                ; rdepwsec(jipt,jk) = rdepwsec(jipt,jk-1) + MIN ( e3vup(ii,ij),e3vup(ii,ij+1) )
                    ENDIF
                 ENDIF
              ELSEIF ( ii1 == ii ) THEN ! vertical segment
                 vmeridsec(jipt,jk) = 0.
                 e3vsec   (jipt,jk) = 0.
                 IF ( ij1 < ij ) THEN ! southward

                    IF ( MIN( saline(ii,ij) , saline(ii+1,ij) ) == 0. ) THEN
                       tempersec(jipt,jk) = 0. ; salinesec(jipt,jk) = 0.
                       DO jf=1, nxtra 
                          vextrasec(jipt,jk,jf) = 0.
                       ENDDO
                       IF ( ll_ssh ) sshsec (jipt,jk) = 0.
                       IF ( ll_mld ) rmldsec(jipt,jk) = 0.
                       IF ( ll_ice ) ricethicksec(jipt,jk) = 0.
                       IF ( ll_ice ) ricefrasec(jipt,jk) = 0.

                       IF ( lvecrot ) THEN
                          urotsec(jipt,jk) = 0.
                          vrotsec(jipt,jk) = 0.
                       ENDIF
                    ELSE
                       tempersec(jipt,jk) = 0.5 * ( temper(ii,ij) + temper(ii+1,ij) )
                       salinesec(jipt,jk) = 0.5 * ( saline(ii,ij) + saline(ii+1,ij) )
                       DO jf=1,nxtra
                         vextrasec(jipt,jk,jf) = 0.5 * ( vextra(ii,ij,jf) + vextra(ii+1,ij,jf) )
                       ENDDO
                       IF ( ll_ssh ) sshsec (jipt,jk) = 0.5 * ( ssh (ii,ij) + ssh (ii+1,ij) )
                       IF ( ll_mld ) rmldsec(jipt,jk) = 0.5 * ( rmld(ii,ij) + rmld(ii+1,ij) )
                       IF ( ll_ice ) ricethicksec(jipt,jk) = 0.5 * ( ricethick(ii,ij) + ricethick(ii+1,ij) )
                       IF ( ll_ice ) ricefrasec(jipt,jk) = 0.5 * ( ricefra(ii,ij) + ricefra(ii+1,ij) )

                       IF ( lvecrot ) THEN
                          urotsec(jipt,jk) = 0.5 * ( urot(ii,ij) + urot(ii+1,ij) )
                          vrotsec(jipt,jk) = 0.5 * ( vrot(ii,ij) + vrot(ii+1,ij) )
                       ENDIF
                    ENDIF
                    uzonalsec(jipt,jk) = uzonal(ii,ij) * normu_sec(jipt,jsec)
                    e3usec   (jipt,jk) = e3u   (ii,ij)
                    IF ( jk == 1 ) THEN ; rdepusec(jipt,jk) = gdept(jk)
                       ;                ; rdepwsec(jipt,jk) = 0.
                    ELSE                ; rdepusec(jipt,jk) = rdepusec(jipt,jk-1) + MIN ( e3w(  ii,ij)  ,e3w(ii+1,ij) )
                       ;                ; rdepwsec(jipt,jk) = rdepwsec(jipt,jk-1) + MIN ( e3uup(ii,ij),e3uup(ii+1,ij) )
                    ENDIF

                 ELSE ! northward

                    IF ( MIN( saline(ii,ij+1) , saline(ii+1,ij+1) ) == 0. ) THEN
                       tempersec(jipt,jk) = 0. ; salinesec(jipt,jk) = 0.
                       DO jf=1, nxtra 
                          vextrasec(jipt,jk,jf) = 0.
                       ENDDO
                       IF ( ll_ssh ) sshsec (jipt,jk) = 0.
                       IF ( ll_mld ) rmldsec(jipt,jk) = 0.
                       IF ( ll_ice ) ricethicksec(jipt,jk) = 0.
                       IF ( ll_ice ) ricefrasec(jipt,jk) = 0.

                       IF ( lvecrot ) THEN
                          urotsec(jipt,jk) = 0.
                          vrotsec(jipt,jk) = 0.
                       ENDIF
                    ELSE
                       tempersec(jipt,jk) = 0.5 * ( temper(ii,ij+1) + temper(ii+1,ij+1) )
                       salinesec(jipt,jk) = 0.5 * ( saline(ii,ij+1) + saline(ii+1,ij+1) )
                       DO jf=1,nxtra
                         vextrasec(jipt,jk,jf) = 0.5 * ( vextra(ii,ij+1,jf) + vextra(ii+1,ij+1,jf) )
                       ENDDO
                       IF ( ll_ssh ) sshsec (jipt,jk) = 0.5 * ( ssh (ii,ij+1) + ssh (ii+1,ij+1) )
                       IF ( ll_mld ) rmldsec(jipt,jk) = 0.5 * ( rmld(ii,ij+1) + rmld(ii+1,ij+1) )
                       IF ( ll_ice ) ricethicksec(jipt,jk) = 0.5 * ( ricethick(ii,ij+1) + ricethick(ii+1,ij+1) )
                       IF ( ll_ice ) ricefrasec(jipt,jk) = 0.5 * ( ricefra(ii,ij+1) + ricefra(ii+1,ij+1) )

                       IF ( lvecrot ) THEN
                          urotsec(jipt,jk) = 0.5 * ( urot(ii,ij+1) + urot(ii+1,ij+1) )
                          vrotsec(jipt,jk) = 0.5 * ( vrot(ii,ij+1) + vrot(ii+1,ij+1) ) 
                       ENDIF
                    ENDIF
                    uzonalsec(jipt,jk) = uzonal(ii,ij+1) * normu_sec(jipt,jsec)
                    e3usec   (jipt,jk) = e3u   (ii,ij+1)
                    IF ( jk == 1 ) THEN ; rdepusec(jipt,jk) = gdept(jk)
                       ;                ; rdepwsec(jipt,jk) = 0.
                    ELSE                ; rdepusec(jipt,jk) = rdepusec(jipt,jk-1) + MIN ( e3w(  ii,ij+1)  ,e3w(ii+1,ij+1) )
                       ;                ; rdepwsec(jipt,jk) = rdepwsec(jipt,jk-1) + MIN ( e3uup(ii,ij+1),e3uup(ii+1,ij+1) )
                    ENDIF
                 ENDIF

              ELSE
                 PRINT *, 'problem 2 for JIPT = ', jipt, 'JK=', jk
                 PRINT *, '             I(P2)=',ii1, 'J(P1)=', ii
                 PRINT *, '             J(P2)=',ij1, 'J(P1)=', ij
                 EXIT 
              ENDIF

              ! cumulate transport for barotropic calculation
              dtmp=1.d0* (uzonalsec(jipt,jk) + vmeridsec(jipt,jk))*    &
                   &   (e2usec(jipt,1,jsec )+ e1vsec(jipt,1,jsec ))*    &
                   &   (e3usec(jipt,jk)+ e3vsec(jipt,jk))
              dbarot(jsec)=dbarot(jsec)+dtmp
           END DO

           ! output section variable at level jk, in separated output section files
           ierr = putvar (ncout(jsec), id_varout(np_tem), tempersec(:,jk), jk, npsec(jsec)-1, 1, ktime=jt )
           ierr = putvar (ncout(jsec), id_varout(np_sal), salinesec(:,jk), jk, npsec(jsec)-1, 1, ktime=jt )
           ierr = putvar (ncout(jsec), id_varout(np_una), uzonalsec(:,jk), jk, npsec(jsec)-1, 1, ktime=jt )
           ierr = putvar (ncout(jsec), id_varout(np_vna), vmeridsec(:,jk), jk, npsec(jsec)-1, 1, ktime=jt )

           ! along-track normal velocity, horiz. and vert. resolution, and mask
           zvmod(:,1)= uzonalsec(:,jk) + vmeridsec(:,jk)
           ierr = putvar (ncout(jsec), id_varout(np_vmod    ), zvmod(:,1),                jk, npsec(jsec)-1, 1, ktime=jt ) 
           IF (ll_ssh) ierr = putvar (ncout(jsec), id_varout(np_ssh     ), sshsec (:,jk),              1, npsec(jsec)-1, 1, ktime=jt )
           IF (ll_mld) ierr = putvar (ncout(jsec), id_varout(np_mld     ), rmldsec(:,jk),              1, npsec(jsec)-1, 1, ktime=jt )
           IF (ll_ice) ierr = putvar (ncout(jsec), id_varout(np_icethick), ricethicksec(:,jk),         1, npsec(jsec)-1, 1, ktime=jt )
           IF (ll_ice) ierr = putvar (ncout(jsec), id_varout(np_icefra  ), ricefrasec(:,jk),           1, npsec(jsec)-1, 1, ktime=jt )
           IF (lvt   ) ierr = putvar (ncout(jsec), id_varout(np_vt      ), zvmod(:,1)*tempersec(:,jk),jk, npsec(jsec)-1, 1, ktime=jt )
           IF (lvt   ) ierr = putvar (ncout(jsec), id_varout(np_vs      ), zvmod(:,1)*salinesec(:,jk),jk, npsec(jsec)-1, 1, ktime=jt )

           IF ( lvecrot ) THEN
              ierr = putvar (ncout(jsec), id_varout(np_urot), urotsec(:,jk), jk, npsec(jsec)-1, 1, ktime=jt )
              ierr = putvar (ncout(jsec), id_varout(np_vrot), vrotsec(:,jk), jk, npsec(jsec)-1, 1, ktime=jt )
           ENDIF
           DO jf = 1, nxtra
              ierr = putvar (ncout(jsec), id_varout(np_xtra(jf)), vextrasec(:,jk,jf), jk, npsec(jsec)-1, 1, ktime=jt )
           ENDDO
           ierr = putvar (ncout(jsec), id_varout(np_depu), rdepusec (:,jk),             jk, npsec(jsec)-1, 1 , ktime=it )  ! use it for vvl
           ierr = putvar (ncout(jsec), id_varout(np_depw), rdepwsec (:,jk),             jk, npsec(jsec)-1, 1 , ktime=it )  ! use it for vvl

           IF ( jt == 1 ) THEN   ! output of time independent variables at first time step only
              ! save a mask of the section
              vmasksec(:,:) = 1.
              WHERE( salinesec(:,:) == 0. ) vmasksec(:,:) = 0.

              ierr = putvar (ncout(jsec), id_varout(np_e3un), e3usec(:,jk),                jk, npsec(jsec)-1, 1 )
              ierr = putvar (ncout(jsec), id_varout(np_e3vn), e3vsec(:,jk),                jk, npsec(jsec)-1, 1 )
              ierr = putvar (ncout(jsec), id_varout(np_e3v ), e3usec(:,jk)+e3vsec(:,jk),   jk, npsec(jsec)-1, 1 )
              ierr = putvar (ncout(jsec), id_varout(np_vmsk), vmasksec(:,jk),              jk, npsec(jsec)-1, 1 )
           ENDIF
        END DO  ! section
     END DO  ! levels

     ! print and output barotropic transport once all levels have been processed
     DO jsec = 1, nfiles
        PRINT 9010, TRIM(csection(jsec)),' BAROTROPIC TRANSPORT at time ',jt,' = ', dbarot(jsec)/1.d6, ' Sv.'
        ierr  = putvar0d ( ncout(jsec), id_varout(np_baro), REAL(dbarot(jsec)/1.d6), ktime = jt    )
     ENDDO

  END DO  ! time 

  ! close all output files
  DO jsec = 1, nfiles
     ierr = closeout(ncout(jsec))
  ENDDO
9010 FORMAT ( "Section :",a15,a,i3,a3,f8.3,a4)

CONTAINS 
  SUBROUTINE CreateOutputFile(ksec)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutputFile  ***
    !!
    !! ** Purpose :  Perform output file creation with all the variables 
    !!
    !! ** Method  :  Move this part of the code in a subroutine for clarity
    !!               All variables are global.  
    !!
    !!----------------------------------------------------------------------
    INTEGER(KIND=4), INTENT(in) :: ksec  ! section index
    INTEGER(KIND=4)             :: ivar  ! variable index
    !!----------------------------------------------------------------------
    ivar = 1

    stypvar%scale_factor= 1.
    stypvar%add_offset= 0.
    stypvar%savelog10= 0.
    stypvar%rmissing_value=0.
    stypvar%conline_operation='N/A'

    ! define new variables for output 
    np_tem = ivar
    stypvar(ivar)%cname       = cn_votemper
    stypvar(ivar)%cunits      = 'deg C'
    stypvar(ivar)%valid_min   = -2.
    stypvar(ivar)%valid_max   = 40.
    stypvar(ivar)%clong_name  = 'Temperature along '//TRIM(csection(ksec))//' section'
    stypvar(ivar)%cshort_name = cn_votemper
    stypvar(ivar)%caxis       = 'TZX'
    ipk(ivar)                 = npk
    ivar = ivar + 1

    np_sal = ivar
    stypvar(ivar)%cname       = cn_vosaline
    stypvar(ivar)%cunits      = 'PSU'
    stypvar(ivar)%valid_min   = 0.
    stypvar(ivar)%valid_max   = 50.
    stypvar(ivar)%clong_name  = 'Salinity along '//TRIM(csection(ksec))//' section'
    stypvar(ivar)%cshort_name = cn_vosaline
    stypvar(ivar)%caxis       = 'TZX'
    ipk(ivar)                 = npk
    ivar = ivar + 1

    np_una = ivar
    stypvar(ivar)%cname       = TRIM(cn_vozocrtx)//'_native'
    stypvar(ivar)%cunits      = 'm.s-1'
    stypvar(ivar)%valid_min   = -20.
    stypvar(ivar)%valid_max   = 20.
    stypvar(ivar)%clong_name  = 'Zonal velocity along '//TRIM(csection(ksec))//' section'
    stypvar(ivar)%cshort_name = TRIM(cn_vozocrtx)//'_native'
    stypvar(ivar)%caxis       = 'TZX'
    ipk(ivar)                 = npk
    ivar = ivar + 1

    np_vna = ivar
    stypvar(ivar)%cname       = TRIM(cn_vomecrty)//'_native'
    stypvar(ivar)%cunits      = 'm.s-1'
    stypvar(ivar)%valid_min   = -20.
    stypvar(ivar)%valid_max   = 20.
    stypvar(ivar)%clong_name  = 'Meridionnal velocity along '//TRIM(csection(ksec))//' section'
    stypvar(ivar)%cshort_name = TRIM(cn_vomecrty)//'_native'
    stypvar(ivar)%caxis       = 'TZX'
    ipk(ivar)                 = npk
    ivar = ivar + 1

    np_isec = ivar
    stypvar(ivar)%cname       = 'isec'
    stypvar(ivar)%valid_min   = 1.
    stypvar(ivar)%valid_max   = npiglo 
    stypvar(ivar)%caxis       = 'TX'
    ipk(ivar)                 = 1
    ivar = ivar + 1

    np_jsec = ivar
    stypvar(ivar)%cname       = 'jsec'
    stypvar(ivar)%valid_min   = 1.
    stypvar(ivar)%valid_max   = npjglo 
    stypvar(ivar)%caxis       = 'TX'
    ipk(ivar)                 = 1
    ivar = ivar + 1

    np_e2vn = ivar
    stypvar(ivar)%cname       = TRIM(cn_ve2u)//'_native'
    stypvar(ivar)%valid_min   = 1.
    stypvar(ivar)%valid_max   = 200000.
    stypvar(ivar)%caxis       = 'TX'
    ipk(ivar)                 = 1
    ivar = ivar + 1

    np_e1vn = ivar
    stypvar(ivar)%cname       = TRIM(cn_ve1v)//'_native'
    stypvar(ivar)%valid_min   = 1.
    stypvar(ivar)%valid_max   = 200000.
    stypvar(ivar)%caxis       = 'TX'
    ipk(ivar)                 = 1
    ivar = ivar + 1

    np_e3un = ivar
    stypvar(ivar)%cname       = 'e3u_native'
    stypvar(ivar)%valid_min   = 1.
    stypvar(ivar)%valid_max   = 200000.
    stypvar(ivar)%caxis       = 'TZX'
    ipk(ivar)                 =  npk
    ivar = ivar + 1

    np_e3vn = ivar
    stypvar(ivar)%cname      = 'e3v_native'
    stypvar(ivar)%valid_min   = 1.
    stypvar(ivar)%valid_max   = 200000.
    stypvar(ivar)%caxis      = 'TZX'
    ipk(ivar)                =  npk
    ivar = ivar + 1

    np_vmod = ivar
    stypvar(ivar)%cname       = cn_vomecrty
    stypvar(ivar)%cunits      = 'm.s-1'
    stypvar(ivar)%valid_min   = -20.
    stypvar(ivar)%valid_max   = 20.
    stypvar(ivar)%clong_name  = 'Normal velocity along '//TRIM(csection(ksec))//' section'
    stypvar(ivar)%cshort_name = cn_vomecrty
    stypvar(ivar)%caxis       = 'TZX'
    ipk(ivar)                 =  npk
    ivar = ivar + 1

    np_depu = ivar
    stypvar(ivar)%cname       = cn_depu3d
    stypvar(ivar)%cunits      = 'm'
    stypvar(ivar)%valid_min   = 0.
    stypvar(ivar)%valid_max   = 1000000.
    stypvar(ivar)%clong_name  = 'Local depth U along '//TRIM(csection(ksec))//' section'
    stypvar(ivar)%cshort_name = cn_depu3d
    stypvar(ivar)%caxis       = 'TZX'
    ipk(ivar)                 = npk
    ivar = ivar + 1

    np_depw = ivar
    stypvar(ivar)%cname       = cn_depw3d
    stypvar(ivar)%cunits      = 'm'
    stypvar(ivar)%valid_min   = 0.
    stypvar(ivar)%valid_max   = 1000000.
    stypvar(ivar)%clong_name  = 'Local depth W along '//TRIM(csection(ksec))//' section'
    stypvar(ivar)%cshort_name = cn_depw3d
    stypvar(ivar)%caxis       = 'TZX'
    ipk(ivar)                 = npk
    ivar = ivar + 1

    np_e1v = ivar
    stypvar(ivar)%cname       = cn_ve1v
    stypvar(ivar)%cunits      = 'm'
    stypvar(ivar)%valid_min   = 0.
    stypvar(ivar)%valid_max   = 1000000.
    stypvar(ivar)%clong_name  = 'Local horiz. resolution along '//TRIM(csection(ksec))//' section'
    stypvar(ivar)%cshort_name = cn_ve1v
    stypvar(ivar)%caxis       = 'TX'
    ipk(ivar)                 = 1
    ivar = ivar + 1

    np_e3v = ivar
    stypvar(ivar)%cname       = cn_ve3v
    stypvar(ivar)%cunits      = 'm'
    stypvar(ivar)%valid_min   = 0.
    stypvar(ivar)%valid_max   = 100000000.
    stypvar(ivar)%clong_name  = 'Local vert. resolution along '//TRIM(csection(ksec))//' section'
    stypvar(ivar)%cshort_name = cn_ve3v
    stypvar(ivar)%caxis       = 'TZX'
    ipk(ivar)                 =  npk
    ivar = ivar + 1

    np_vmsk = ivar
    stypvar(ivar)%cname       = 'vmask'
    stypvar(ivar)%cunits      ='1/0'
    stypvar(ivar)%valid_min   = 0.
    stypvar(ivar)%valid_max   = 1.
    stypvar(ivar)%rmissing_value = 9999.
    stypvar(ivar)%clong_name  ='Mask along '//TRIM(csection(ksec))//' section'
    stypvar(ivar)%cshort_name = 'vmask'
    stypvar(ivar)%caxis       = 'TZX'
    ipk(ivar)                 =  npk
    ivar = ivar + 1

    np_baro = ivar
    stypvar(ivar)%cname       = 'barotrop_'//TRIM(csection(ksec))
    stypvar(ivar)%cunits      ='Sv'
    stypvar(ivar)%valid_min   = -500.
    stypvar(ivar)%valid_max   = 500.
    stypvar(ivar)%rmissing_value = -99999.
    stypvar(ivar)%clong_name  = 'Barotropic_transport for '//TRIM(csection(ksec))//' section'
    stypvar(ivar)%cshort_name = 'barotrop_'//TRIM(csection(ksec))
    stypvar(ivar)%caxis       = 'T'
    ipk(ivar)                 =  -1
    ivar = ivar + 1

    np_bat = ivar
    stypvar(ivar)%cname       = 'Bathymetry'
    stypvar(ivar)%cunits      = 'm'
    stypvar(ivar)%valid_min   = 0.
    stypvar(ivar)%valid_max   = 1000000.
    stypvar(ivar)%clong_name  = 'Bathymetry along '//TRIM(csection(ksec))//' section'
    stypvar(ivar)%cshort_name = 'Bathymetry'
    stypvar(ivar)%caxis       = 'TX'
    ipk(ivar)                 = 1
    ivar = ivar + 1

    IF ( lssh ) THEN
       np_ssh = ivar
       stypvar(ivar)%cname       = cn_sossheig
       stypvar(ivar)%cunits      = 'm'
       stypvar(ivar)%valid_min   = 0.
       stypvar(ivar)%valid_max   = 1000000.
       stypvar(ivar)%clong_name  = 'SSH  along '//TRIM(csection(ksec))//' section'
       stypvar(ivar)%cshort_name = cn_sossheig
       stypvar(ivar)%caxis       = 'TX'
       ipk(ivar)                 = 1
       ivar = ivar + 1
    ENDIF

    IF ( lmld ) THEN
       np_mld = ivar
       stypvar(ivar)%cname       = cn_somxl010
       stypvar(ivar)%cunits      = 'm'
       stypvar(ivar)%valid_min   = 0.
       stypvar(ivar)%valid_max   = 100000.
       stypvar(ivar)%clong_name  = 'Mixed Layer Depth 0.01  along '//TRIM(csection(ksec))//' section'
       stypvar(ivar)%cshort_name = cn_somxl010
       stypvar(ivar)%caxis       = 'TX'
       ipk(ivar)                 = 1
       ivar = ivar + 1
    ENDIF

    IF ( lice ) THEN
       np_icethick = ivar
       stypvar(ivar)%cname       = cn_iicethic
       stypvar(ivar)%cunits      = 'm'
       stypvar(ivar)%valid_min   = -10000.
       stypvar(ivar)%valid_max   = 1000000.
       stypvar(ivar)%clong_name  = 'icethick along '//TRIM(csection(ksec))//' section'
       stypvar(ivar)%cshort_name = cn_iicethic
       stypvar(ivar)%caxis       = 'TX'
       ipk(ivar)                 = 1
       ivar = ivar + 1

       np_icefra = ivar
       stypvar(ivar)%cname       = cv_ileadfra
       stypvar(ivar)%cunits      = 'm'
       stypvar(ivar)%valid_min   = -10000.
       stypvar(ivar)%valid_max   = 1000000.
       stypvar(ivar)%clong_name  = 'icefra along '//TRIM(csection(ksec))//' section'
       stypvar(ivar)%cshort_name = cv_ileadfra
       stypvar(ivar)%caxis       = 'TX'
       ipk(ivar)                 = 1
       ivar = ivar + 1
    ENDIF

    IF ( lvt ) THEN
       np_vt = ivar
       stypvar(ivar)%cname       = cn_vomevt
       stypvar(ivar)%cunits      = 'C.m/s'
       stypvar(ivar)%valid_min   = -1000000.
       stypvar(ivar)%valid_max   = 1000000.
       stypvar(ivar)%clong_name  = 'VT product along '//TRIM(csection(ksec))//' section'
       stypvar(ivar)%cshort_name = cn_vomevt
       stypvar(ivar)%caxis       = 'TZX'
       ipk(ivar)                 = npk
       ivar = ivar + 1

       np_vs = ivar
       stypvar(ivar)%cname       = cn_vomevs
       stypvar(ivar)%cunits      = 'PSU.m/s'
       stypvar(ivar)%valid_min   = -1000000.
       stypvar(ivar)%valid_max   = 1000000.
       stypvar(ivar)%clong_name  = 'VS product along '//TRIM(csection(ksec))//' section'
       stypvar(ivar)%cshort_name = cn_vomevs
       stypvar(ivar)%caxis       = 'TZX'
       ipk(ivar)                 = npk
       ivar = ivar + 1
    ENDIF

    IF ( lvecrot ) THEN
       ! define new variables for output 
       np_urot = ivar
       stypvar(ivar)%cname       = 'vtang'
       stypvar(ivar)%cunits      = 'm/s'
       stypvar(ivar)%valid_min   = -10.
       stypvar(ivar)%valid_max   = 10.
       stypvar(ivar)%clong_name  = 'Tangential velocity along '//TRIM(csection(ksec))//' section'
       stypvar(ivar)%cshort_name = 'vtang'
       stypvar(ivar)%caxis       = 'TZX'
       ipk(ivar)                 = npk
       ivar = ivar + 1

       np_vrot = ivar
       stypvar(ivar)%cname       = 'vnorm'
       stypvar(ivar)%cunits      = 'm/s'
       stypvar(ivar)%valid_min   = -10.
       stypvar(ivar)%valid_max   = 10.
       stypvar(ivar)%clong_name  = 'Normal velocity along '//TRIM(csection(ksec))//' section'
       stypvar(ivar)%cshort_name = 'vnorm'
       stypvar(ivar)%caxis       = 'TZX'
       ipk(ivar)                 = npk
       ivar = ivar + 1
    ENDIF
    ! extra fields
    DO jf=1,nxtra
       cu_xtra(jf)  = getatt(cf_xtra(jf), cv_xtra(jf),'units','yes')
       cln_xtra(jf) = getatt(cf_xtra(jf), cv_xtra(jf),'long_name','yes')
       csn_xtra(jf) = getatt(cf_xtra(jf), cv_xtra(jf),'short_name','yes')
       np_xtra(jf) = ivar 
       stypvar(ivar)%cname       = cv_xtra(jf)
       stypvar(ivar)%cunits      = cu_xtra(jf)
       stypvar(ivar)%valid_min   = -100000.    ! dummy value so far
       stypvar(ivar)%valid_max   = 100000.     !  "      "    "   "
       stypvar(ivar)%clong_name  = TRIM(cln_xtra(jf))//' along '//TRIM(csection(ksec))//' section'
       stypvar(ivar)%cshort_name = TRIM(csn_xtra(jf))
       stypvar(ivar)%caxis       = 'TZX'
       ipk(ivar)                 = npkt(jf)
       ivar = ivar + 1
    ENDDO

    ! create output fileset
    ncout(ksec) = create      (cf_out, cf_tfil, npsec(ksec),  1, npk, cdep=cn_vdeptht                    )
    ierr  = createvar   (ncout(ksec),  stypvar, nvar,  ipk, id_varout                                    )
    ierr  = putheadervar(ncout(ksec),  cf_tfil, npsec(ksec)-1,  1, npk, pnavlon=rlonsec, pnavlat=rlatsec )
    dtim  = getvar1d    (cf_tfil, cn_vtimec, npt                                                         )
    ierr  = putvar1d    (ncout(ksec), dtim, npt, 'T'                                                     )

  END SUBROUTINE CreateOutputFile

  SUBROUTINE GetFileList
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE GetFileList  ***
    !!
    !! ** Purpose :  Set up a file list given on the command line as 
    !!               blank separated list
    !!
    !! ** Method  :  Scan the command line until a '-' is found
    !!----------------------------------------------------------------------
    INTEGER (KIND=4)  :: ji
    INTEGER (KIND=4)  :: icur
    !!----------------------------------------------------------------------
    !!
    nfiles=0
    ! need to read a list of file ( number unknow ) 
    ! loop on argument till a '-' is found as first char
    icur=ijarg                          ! save current position of argument number
    DO ji = icur, narg                  ! scan arguments till - found
       CALL getarg ( ji, cldum )
       IF ( cldum(1:1) /= '-' ) THEN ; nfiles = nfiles+1
       ELSE                          ; EXIT
       ENDIF
    ENDDO
    ALLOCATE (cf_lst(nfiles) )
    DO ji = icur, icur + nfiles -1
       CALL getarg(ji, cf_lst( ji -icur +1 ) ) ; ijarg=ijarg+1
    END DO
  END SUBROUTINE GetFileList

  SUBROUTINE ParseFiles (cdum)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE ParseFiles  ***
    !!
    !! ** Purpose :  Decode -f option from command line 
    !!
    !! ** Method  :  look for , in the argument string and set the number of 
    !!         sections (nfiles), allocate cf_lst array and fill it with the 
    !!         decoded  names.
    !!
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*), INTENT(in) :: cdum

    CHARACTER(LEN=80), DIMENSION(100) :: cl_dum  ! 100 is arbitrary
    INTEGER  :: ji
    INTEGER  :: inchar,  i1=1
    !!----------------------------------------------------------------------

    inchar= LEN(TRIM(cdum))
    ! scan the input string and look for ',' as separator
    DO ji=1,inchar
       IF ( cdum(ji:ji) == ',' ) THEN
          cl_dum(nfiles) = cdum(i1:ji-1)
          i1=ji+1
          nfiles=nfiles+1
       ENDIF
    ENDDO

    ! last name of the list does not have a ','
    cl_dum(nfiles) = cdum(i1:inchar)

    ALLOCATE ( cf_lst(nfiles) )

    DO ji=1, nfiles
       cf_lst(ji) = cl_dum(ji)
    ENDDO
  END SUBROUTINE ParseFiles

  SUBROUTINE FancyPrint(ksec)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE FancyPrint  ***
    !!
    !! ** Purpose :   perform Fancy Print for sections definitions 
    !!
    !!----------------------------------------------------------------------
    INTEGER(KIND=4), INTENT(in) :: ksec
    !!----------------------------------------------------------------------

    PRINT 9005
    PRINT 9006, TRIM(csection(ksec))
    PRINT 9005
    PRINT 9000
    PRINT 9005

    OPEN(numout, file=cf_secdat )   ! open section.dat file for output

    DO jleg = 1, nsta(ksec) -1
       ! start point 
       ii = iista(jleg,ksec)  ; ij = ijsta(jleg,ksec)
       ztmp = MIN (rmbat(ii,ij), rmbat(ii+1,ij), rmbat(ii+1,ij+1), rmbat(ii,ij+1) ) 
       IF ( ztmp == 0. ) THEN 
          cstar = 'LAND'
       ELSE
          cstar = ' SEA'
       ENDIF

       ! end  point 
       ii1 = iista(jleg+1,ksec)  ; ij1 = ijsta(jleg+1,ksec)
       ztmp = MIN (rmbat(ii1,ij1), rmbat(ii1+1,ij1), rmbat(ii1+1,ij1+1), rmbat(ii1,ij1+1) )
       IF ( ztmp == 0. ) THEN
          cend = 'LAND'
       ELSE
          cend = ' SEA'
       ENDIF
       PRINT 9001, jleg, rlatsta(jleg,ksec), rlonsta(jleg,ksec),    rlatsta(jleg+1,ksec), rlonsta(jleg+1,ksec)
       PRINT 9002,          ii,ij,                        ii1,ij1
       PRINT 9003, rlatf(ii,ij), rlonf(ii,ij),            rlatf(ii1,ij1), rlonf(ii1,ij1)
       PRINT 9004, TRIM(cstar),                           TRIM(cend)
       PRINT 9005
       WRITE(numout,'(i2.2,"_",a)') jleg, TRIM(csection(ksec))
       WRITE(numout,*) ii, ii1, ij, ij1
    ENDDO

    WRITE(numout,'("EOF")')
    CLOSE(numout)

9000 FORMAT ("  |  Leg #  |    Start point     |      End point     | ")
9001 FORMAT ("  |   ",i3,"   | ", f6.2," N ", f7.2, " E | ", f6.2," N ", f7.2, " E |" )
9002 FORMAT ("  |        F| I =", i5,", J =",i5 " | I =", i5,", J =",i5 " |" )
9003 FORMAT ("  |      mod| ", f6.2," N ", f7.2, " E | ", f6.2," N ", f7.2, " E |" )
9004 FORMAT ("  |         |      ",a4,"          |     ",a4,"           | ")
9005 FORMAT ("  |---------|--------------------|--------------------| ")
9006 FORMAT ("  |    Section : ",a33,"    |" )

  END SUBROUTINE FancyPrint

END PROGRAM cdf_xtract_brokenline

PROGRAM cdfweight
  !!======================================================================
  !!                     ***  PROGRAM  cdfweight  ***
  !!=====================================================================
  !!  ** Purpose : Compute a wheight file for further bi-linear colocalisation
  !!               done with cdfcoloc.
  !!
  !!  ** Method  : Use Greg Holloway iyxz.txt file type as input, to specify
  !!               the points to search in the model grid.
  !!               Read the coordinate/mesh_hgr file and look
  !!               for the glam, gphi variables
  !!               Then use a search algorithm to find the corresponding I J
  !!               The point type ( T U V F ) is specified on the command line
  !!               as well as the name of the coordinate/mesh hgr file.
  !!               If -2d option is used, only horizontal weight are produced.
  !!
  !! History : 2.0  : 11/2005  : J.M. Molines : Original code
  !!                : 05/2007  : J.M. Molines : for weight
  !!           3.0  : 03/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  !!   routines      : description
  !! SUBROUTINE localcoord( palpha, pbeta, plam, pphi)
  !! FUNCTION det(p1,p2,p3,p4)
  !! FUNCTION heading(plona, plonb, plata, platb)
  !!----------------------------------------------------------------------
  USE cdfio
  USE cdftools       ! cdf_find_ij
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: jk                      ! dummy loop counter
  INTEGER(KIND=4)                           :: idum                    ! dummy working integer
  INTEGER(KIND=4)                           :: narg, iargc, iarg       ! Argument management
  INTEGER(KIND=4)                           :: iimin,  ijmin           ! i j position of target point
  INTEGER(KIND=4)                           :: ikloc                   ! k position of target point
  INTEGER(KIND=4)                           :: npiglo, npjglo, npk     ! domain size
  INTEGER(KIND=4)                           :: iquadran                ! quadran
  INTEGER(KIND=4)                           :: numgreg=10              ! logical unit of ASCII input file
  INTEGER(KIND=4)                           :: numbin=20               ! logical unit of BINARY weight file
  INTEGER(KIND=4)                           :: ios                     ! iostat variable
                                                                       ! Greg Holloway input data  ( 5 variables)
  INTEGER(KIND=4)                           :: id                      ! station ID
  REAL(KIND=4)                              :: xmin, ymin, rdep        ! longitude, latitude, depth

  REAL(KIND=8)                              :: dl_xmin, dl_ymin
  REAL(KIND=8)                              :: dl_hPp                  ! local maximum metrics
  REAL(KIND=8)                              :: dl_lam0                 ! longitude of grid point ji=1
  REAL(KIND=8)                              :: dl_lamin, dl_phimin     ! coordinates of the nearest point  (NP)
  REAL(KIND=8)                              :: dl_lamN, dl_phiN, dl_hN ! grid point North of NP, true heading from NP
  REAL(KIND=8)                              :: dl_lamE, dl_phiE, dl_hE ! grid point East of NP, true heading from NP
  REAL(KIND=8)                              :: dl_lamS, dl_phiS, dl_hS ! grid point South of NP, true heading from NP
  REAL(KIND=8)                              :: dl_lamW, dl_phiW, dl_hW ! grid point West of NP, true heading from NP
  REAL(KIND=8), DIMENSION(0:4)              :: dl_lami, dl_phii        ! the 4 grid points around target (1-4)
                                                                       !  + the target (0)
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dl_lam, dl_phi          ! grid layout and metrics
  REAL(KIND=8), DIMENSION(:),   ALLOCATABLE :: dl_dept                 ! vertical depth
  REAL(KIND=8)                              :: dl_hP                   ! true heading of target point from NP
  REAL(KIND=8)                              :: dl_alpha, dl_beta       ! reduced coordinates (0-1) in the NP gridcell
  REAL(KIND=8)                              :: dl_gam                  ! vertical weight

  CHARACTER(LEN=256)                        :: cf_coord, cf_in         ! file names (in)
  CHARACTER(LEN=256)                        :: cf_weight               ! weight file name (out)
  CHARACTER(LEN=256)                        :: ctype, cldum            ! C-grid type point, dummy character

  LOGICAL                                   :: lldebug = .FALSE.       ! verbose/debug flag
  LOGICAL                                   :: ll2d    = .FALSE.       ! 2D field flag
  LOGICAL                                   :: llchk   = .FALSE.       ! for checking missing files
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  ! default values
  cf_coord = cn_fcoo
  ctype    = 'F'

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfweight  [-f] IN-file [-c COORD-file] ... '
     PRINT *,'              ...  [-t point_type] [-2d] [-v] '
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Produce a weight file for further bilinear collocalisation ' 
     PRINT *,'       with cdfcoloc program. It takes the position of the points'
     PRINT *,'       to be collocated into a simple ascii file. '
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       [-f ] IN-file   : input file is a iyxz ASCII file, 1 line per point.'  
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-c COORD-file] : coordinate file [',TRIM(cf_coord),']'
     PRINT *,'       [-t point_type] : point type on C-grid (either T U V or F ) [',TRIM(ctype),']'
     PRINT *,'       [-2d ]          : tell cdfweight that only 2D weights are to be computed.'
     PRINT *,'       [-v ]           : Verbose mode for extra information (debug mode).'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        ',TRIM(cf_coord),' file if not passed as argument.'
     PRINT *,'        If working with 3D files, ',TRIM(cn_fzgr),' is required.'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       binary weight file : weight_point_type.bin'
     PRINT *,'       standard output : almost the same info that is saved in the binary file'
     PRINT *,'                   When using -v option, even more informations !'
     STOP
  ENDIF

  iarg=1
  DO WHILE (iarg <= narg ) 
     CALL getarg(iarg, cldum) ; iarg=iarg+1
     SELECT CASE ( cldum )
     CASE ('-f' ) ; CALL getarg(iarg, cf_in   ) ; iarg=iarg+1 
     CASE ('-c' ) ; CALL getarg(iarg, cf_coord) ; iarg=iarg+1 
     CASE ('-t' ) ; CALL getarg(iarg, ctype   ) ; iarg=iarg+1 
     CASE ('-2d') ; ll2d    = .TRUE.
     CASE ('-v' ) ; lldebug = .TRUE.
     CASE DEFAULT ; CALL getarg(iarg, cf_in   ) ; iarg=iarg+1  ! if no switch assume file name
     END SELECT
  END DO

  llchk = llchk .OR. chkfile(cf_in)
  llchk = llchk .OR. chkfile(cf_coord)
  IF ( .NOT. ll2d ) llchk = llchk .OR. chkfile(cn_fzgr)
  IF ( llchk ) STOP 99 ! missing files

  npiglo = getdim (cf_coord,cn_x)
  npjglo = getdim (cf_coord,cn_y)

  IF ( .NOT. ll2d ) THEN 
     npk = getdim (cn_fzgr,cn_z )
     ALLOCATE (dl_dept(npk) )
     ! read depth of model T points (hence U and V)
     dl_dept(:)=getvare3(cn_fzgr, cn_gdept, npk)
  ENDIF

  ALLOCATE (dl_lam(npiglo,npjglo), dl_phi(npiglo,npjglo) )

  ! set name and open  output weight file
  WRITE(cf_weight,'("weight_",a,".bin")') TRIM(ctype)
  OPEN(numbin, FILE=cf_weight,FORM='unformatted')

  SELECT CASE ( ctype )
  CASE ('T' , 't' )
     dl_lam(:,:) = getvar(cf_coord, cn_glamt, 1, npiglo, npjglo)
     dl_phi(:,:) = getvar(cf_coord, cn_gphit, 1, npiglo, npjglo)
  CASE ('U','u' )
     dl_lam(:,:) = getvar(cf_coord, cn_glamu, 1, npiglo, npjglo)
     dl_phi(:,:) = getvar(cf_coord, cn_gphiu, 1, npiglo, npjglo)
  CASE ('V','v' )
     dl_lam(:,:) = getvar(cf_coord, cn_glamv, 1, npiglo, npjglo)
     dl_phi(:,:) = getvar(cf_coord, cn_gphiv, 1, npiglo, npjglo)
  CASE ('F','f' )
     dl_lam(:,:) = getvar(cf_coord, cn_glamf, 1, npiglo, npjglo)
     dl_phi(:,:) = getvar(cf_coord, cn_gphif, 1, npiglo, npjglo)
  CASE DEFAULT
     PRINT *,' ERROR : type of point not known: ', TRIM(ctype)
  END SELECT
  ! work with longitude between 0 and 360 to avoid  the date line.
  WHERE( dl_lam < 0 ) dl_lam(:,:)=dl_lam(:,:)+360.d0

  ! For Orca grid, the longitude of ji=1 is about 70 E
  dl_lam0 = dl_lam(1, npjglo/2)  
  WHERE( dl_lam < dl_lam0 ) dl_lam=dl_lam+360.d0

  OPEN(numgreg,FILE=cf_in)
  ! Greg (Holloway) files are iyxz.txt file
  ios=0
  ! loop for each line of Greg File
  DO WHILE (ios == 0 )
     READ(numgreg,*,iostat=ios) id,ymin,xmin,rdep
     dl_xmin=xmin ; dl_ymin=ymin
     IF( ios == 0 ) THEN  ! EOF not reached
        IF ( .NOT. ll2d ) THEN
           ! Look for vertical position 
           !    ikloc = k index of point above rdep
           ikloc=1
           DO WHILE ( dl_dept(ikloc) <= rdep .AND. ikloc < npk )
              ikloc = ikloc+1
           ENDDO
           ikloc = ikloc -1 ! up one level

           ! compute dl_gam such that Vint= (1-dl_gam) x V(ikloc) + dl_gam x V(ikloc +1)
           dl_gam=(rdep - dl_dept(ikloc))/(dl_dept(ikloc+1)-dl_dept(ikloc) )

           IF (ikloc == npk -1 ) dl_gam = 0.d0

           IF ( dl_gam < 0 ) THEN
              ikloc=1
              dl_gam = 0.d0
           ENDIF
           IF ( dl_gam > 1 ) THEN
              ikloc=npk -1
              dl_gam = 0.d0
           ENDIF
        ELSE
           dl_gam = 0.d0
        ENDIF

        IF ( lldebug) PRINT '("DEP", f8.1,i8,f8.0,f8.4)', dl_dept(ikloc), rdep, dl_dept(ikloc+1), dl_gam

        ! Now deal with horizontal interpolation
        CALL cdf_findij ( xmin, xmin, ymin, ymin, iimin, idum, ijmin, idum, cd_coord=cf_coord, cd_point=ctype)

        IF ( iimin /= -1000 .AND. ijmin /= -1000 ) THEN
           ! Latitude and longitude of the neighbours on the grid
           ! define longitudes between 0 and 360 deg
           dl_lamin = MOD(dl_lam(iimin  ,ijmin  ),360.d0) ; dl_phimin = dl_phi(iimin  ,ijmin  )  ! nearest point
           dl_lamN  = MOD(dl_lam(iimin  ,ijmin+1),360.d0) ; dl_phiN   = dl_phi(iimin  ,ijmin+1)  ! N (grid)
           dl_lamE  = MOD(dl_lam(iimin+1,ijmin  ),360.d0) ; dl_phiE   = dl_phi(iimin+1,ijmin  )  ! E (grid)
           dl_lamS  = MOD(dl_lam(iimin  ,ijmin-1),360.d0) ; dl_phiS   = dl_phi(iimin  ,ijmin-1)  ! S (grid)
           dl_lamW  = MOD(dl_lam(iimin-1,ijmin  ),360.d0) ; dl_phiW   = dl_phi(iimin-1,ijmin  )  ! W (grid)

           ! Compute heading of target point and neighbours from the nearest point
           dl_hP = heading(dl_lamin, dl_xmin, dl_phimin, dl_ymin)  ! target point
           dl_hN = heading(dl_lamin, dl_lamN, dl_phimin, dl_phiN)  ! 'north' on the grid
           dl_hE = heading(dl_lamin, dl_lamE, dl_phimin, dl_phiE)  ! 'east' on the grid
           dl_hS = heading(dl_lamin, dl_lamS, dl_phimin, dl_phiS)  ! 'south' on the grid
           dl_hW = heading(dl_lamin, dl_lamW, dl_phimin, dl_phiW)  ! 'west' on the grid

           ! determine the sector in wich the target point is located: 
           !  ( from 1, to 4 resp. NE, SE, SW, NW  of the grid)
           iquadran = 4
           ! to avoid problem with the GW meridian, pass to -180, 180 when working around GW
           IF ( dl_hP > 180.d0 ) THEN 
              dl_hPp = dl_hP - 360.d0 
              dl_hPp = dl_hP
           ENDIF

           IF ( dl_hN  > dl_hE                       ) dl_hN = dl_hN - 360.d0
           IF ( dl_hPp > dl_hN .AND. dl_hPp <= dl_hE ) iquadran = 1
           IF ( dl_hP  > dl_hE .AND. dl_hP  <= dl_hS ) iquadran = 2
           IF ( dl_hP  > dl_hS .AND. dl_hP  <= dl_hW ) iquadran = 3
           IF ( dl_hP  > dl_hW .AND. dl_hPp <= dl_hN ) iquadran = 4

           dl_lami(0) = xmin     ; dl_phii(0) = ymin          ! fill dl_lami, dl_phii for 0 = target point
           dl_lami(1) = dl_lamin ; dl_phii(1) = dl_phimin     !                           1 = nearest point
           SELECT CASE ( iquadran )         ! point 2 3 4 are counter clockwise in the respective sector
           CASE ( 1 ) 
              dl_lami(2) = dl_lamE ; dl_phii(2) = dl_phiE
              dl_lami(3) = MOD(dl_lam(iimin+1,ijmin+1), 360.d0) ; dl_phii(3) = dl_phi(iimin+1,ijmin+1)
              dl_lami(4) = dl_lamN ; dl_phii(4) = dl_phiN
           CASE ( 2 )
              dl_lami(2) = dl_lamS ; dl_phii(2) = dl_phiS
              dl_lami(3) = MOD(dl_lam(iimin+1,ijmin-1), 360.d0) ; dl_phii(3) = dl_phi(iimin+1,ijmin-1)
              dl_lami(4) = dl_lamE ; dl_phii(4) = dl_phiE
           CASE ( 3 )
              dl_lami(2) = dl_lamW ; dl_phii(2) = dl_phiW
              dl_lami(3) = MOD(dl_lam(iimin-1,ijmin-1), 360.d0) ; dl_phii(3) = dl_phi(iimin-1,ijmin-1)
              dl_lami(4) = dl_lamS ; dl_phii(4) = dl_phiS
           CASE ( 4 )
              dl_lami(2) = dl_lamN ; dl_phii(2) = dl_phiN
              dl_lami(3) = MOD(dl_lam(iimin-1,ijmin+1), 360.d0) ; dl_phii(3) = dl_phi(iimin-1,ijmin+1)
              dl_lami(4) = dl_lamW ; dl_phii(4) = dl_phiW
           END SELECT

           ! resolve a non linear system of equation for dl_alpha and dl_beta 
           !( the non dimensional coordinates of target point)
           CALL localcoord( dl_alpha, dl_beta, dl_lami, dl_phii)
        ELSE   ! point is outside the domaine, put dummy values
           dl_alpha=-1000.d0 ; dl_beta=-1000.d0
        ENDIF

        IF (lldebug) THEN 
           PRINT 9001, id, ymin, xmin, rdep ,iimin, ijmin,  dl_hP, dl_hPp, dl_hN, &
                &         dl_hE, dl_hS, dl_hW, iquadran, dl_alpha, dl_beta
        ENDIF
        ! output both on std output and binary weight file (same info).
        PRINT 9002, id, ymin, xmin, rdep ,iimin, ijmin, ikloc, iquadran, dl_alpha, dl_beta, dl_gam
        WRITE(numbin) id, ymin, xmin, rdep ,iimin, ijmin, ikloc, iquadran, dl_hN, dl_alpha, dl_beta, dl_gam
     ENDIF
  ENDDO
9001 FORMAT(i10, 3f10.4,2i6,6f10.4,I4,2f8.4)
9002 FORMAT(i10, 3f10.4,3i6,I4,3f11.4)
  CLOSE(numbin)

CONTAINS

  SUBROUTINE localcoord( dpalpha, dpbeta, dplam, dpphi)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE localcoord  ***
    !!
    !! ** Purpose :  compute the local coordinate in a grid cell
    !!
    !! ** Method  :  See reference 
    !!
    !! References : from N. Daget Web page :
    !!      http://aton.cerfacs.fr/~daget/TECHREPORT/TR_CMGC_06_18_html/node8.html 
    !!----------------------------------------------------------------------
    REAL(KIND=8), DIMENSION(0:4), INTENT(in)  :: dplam, dpphi
    REAL(KIND=8)                , INTENT(out) :: dpalpha, dpbeta

    INTEGER(KIND=4)              :: itermax=200    ! maximum of iteration 
    INTEGER(KIND=4)              :: iter=0         ! iteration counter
    REAL(KIND=8)                 :: dlalpha=0.d0   ! working variable, initialized to 1rst guess
    REAL(KIND=8)                 :: dlbeta=0.d0    !  ""                  ""
    REAL(KIND=8)                 :: dlresmax=0.001 ! Convergence criteria
    REAL(KIND=8)                 :: dlres          ! residual 
    REAL(KIND=8)                 :: dldeta
    REAL(KIND=8)                 :: dldalp
    REAL(KIND=8)                 :: dldbet
    REAL(KIND=8)                 :: dldlam
    REAL(KIND=8)                 :: dldphi
    REAL(KIND=8)                 :: dl1, dl2, dl3, dl4
    REAL(KIND=8), DIMENSION(2,2) :: dla
    REAL(KIND=8), DIMENSION(0:4) :: dlplam
    !!----------------------------------------------------------------------
    dlplam=dplam       !: save input longitude in working array
    IF ( lldebug ) THEN
       PRINT *,dplam(0), dpphi(0)
       PRINT *,9999,9999
       PRINT *,dplam(1), dpphi(1)
       PRINT *,dplam(2), dpphi(2)
       PRINT *,dplam(3), dpphi(3)
       PRINT *,dplam(4), dpphi(4)
       PRINT *,dplam(1), dpphi(1)
       PRINT *,9999,9999
    ENDIF
    IF ( ABS( dlplam(1) -dlplam(4) ) >= 180.d0 .OR. ABS( dlplam(1) -dlplam(2) ) >=180.d0) THEN
       ! then we are near the 0 deg line and we must work in the frame -180 180 
       WHERE ( dlplam >= 180.d0 ) dlplam=dlplam -360.d0
    ENDIF

    dlres=1000.; dldlam=0.5; dldphi=0.5 ;  dlalpha=0.d0 ; dlbeta=0.d0; iter=0

    DO WHILE (dlres > dlresmax .AND. iter < itermax)
       dl1=(dlplam(2)- dlplam(1) )
       dl2=(dlplam(1) -dlplam(4) )
       dl3=(dlplam(3) -dlplam(2) )

       dla(1,1) =  dl1 + (dl2 + dl3 )* dlbeta 
       dla(1,2) = -dl2 + (dl2 + dl3 )* dlalpha

       dla(2,1) = dpphi(2)-dpphi(1) +  (dpphi(1) -dpphi(4) +dpphi(3) -dpphi(2))* dlbeta 
       dla(2,2) = dpphi(4)-dpphi(1) +  (dpphi(1) -dpphi(4) +dpphi(3) -dpphi(2))* dlalpha

       ! determinant 
       dldeta=det(dla(1,1), dla(1,2), dla(2,1), dla(2,2) )

       ! solution of 
       ! | zdlam |        | zdalp |
       ! |       | =  za .|       |
       ! | zdphi |        | zdbet |
       dldalp=det(dldlam,   dla(1,2), dldphi,   dla(2,2))/dldeta
       dldbet=det(dla(1,1), dldlam,   dla(2,1), dldphi  )/dldeta

       ! compute residual ( loop criteria)
       dlres=SQRT(dldalp*dldalp + dldbet*dldbet )

       ! Compute alpha and beta from 1rst guess :
       dlalpha = dlalpha + dldalp
       dlbeta  = dlbeta  + dldbet

       ! compute corresponding lon/lat for this alpha, beta
       dldlam = dlplam(0) - ((1.-dlalpha)*(1-dlbeta)*dlplam(1) + dlalpha*(1-dlbeta)*dlplam(2) + & 
            &                      dlalpha*dlbeta*dlplam(3) + (1-dlalpha)*dlbeta*dlplam(4))
       dldphi = dpphi(0)  - ((1.-dlalpha)*(1-dlbeta)*dpphi(1)  + dlalpha*(1-dlbeta)*dpphi(2)  + &
            &                      dlalpha*dlbeta*dpphi(3)  + (1-dlalpha)*dlbeta*dpphi(4))

       iter=iter + 1  ! increment iteration counter
    END DO   ! loop until dlres small enough (or itermax reach )

    dpalpha = dlalpha
    dpbeta  = dlbeta
  END SUBROUTINE localcoord

  FUNCTION det(dp1,dp2,dp3,dp4)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION det  ***
    !!
    !! ** Purpose : compute determinant
    !!
    !! ** Method  : just multiply and add  !
    !!
    !!----------------------------------------------------------------------
    REAL(KIND=8), INTENT(in) :: dp1, dp2, dp3, dp4 ! matrix elements
    REAL(KIND=8)             :: det                ! return value
    !!----------------------------------------------------------------------
    det = dp1*dp4 - dp2*dp3
  END FUNCTION det

  FUNCTION heading(dplona, dplonb, dplata, dplatb)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION heading  ***
    !!
    !! ** Purpose : Compute true heading between point a and b
    !!
    !! ** Method  : Suppose that the 2 points are not too far away 
    !!              from each other so that heading can be computed 
    !!              with loxodromy.
    !!
    !!----------------------------------------------------------------------
    REAL(KIND=8), INTENT(in) :: dplata, dplona ! lat lon of point a
    REAL(KIND=8), INTENT(in) :: dplatb, dplonb ! lat lon of point b
    REAL(KIND=8)             :: heading        ! return value in degree

    REAL(KIND=8)             :: dlpi, dlconv   ! pi and conversion factor
    REAL(KIND=8)             :: dlxa,dlya      ! working variable
    REAL(KIND=8)             :: dlxb,dlyb      ! working variable
    REAL(KIND=8)             :: dlxb_xa        !  ""        ""
    !!----------------------------------------------------------------------

    dlpi   = ACOS(-1.d0)
    dlconv = dlpi/180.d0  ! for degree to radian conversion

    ! there is a problem if the Greenwich meridian pass between a and b
    IF ( lldebug) PRINT *,' Plonb  Plona ' , dplonb, dplona
    dlxa = dplona*dlconv
    dlxb = dplonb*dlconv

    dlya = -LOG(TAN(dlpi/4.-dlconv*dplata/2.d0))
    dlyb = -LOG(TAN(dlpi/4.-dlconv*dplatb/2.d0))

    IF (lldebug) PRINT *,' dlxa_xb , modulo 2pi', dlxb-dlxa, MOD((dlxb-dlxa),2*dlpi)
    dlxb_xa = MOD((dlxb-dlxa),2*dlpi)

    IF ( dlxb_xa >=  dlpi ) dlxb_xa = dlxb_xa -2*dlpi
    IF ( dlxb_xa <= -dlpi ) dlxb_xa = dlxb_xa +2*dlpi
    IF (lldebug)  PRINT *, 'dlyb -dlya, dlxb_xa ',dlyb -dlya , dlxb_xa

    heading=ATAN2(dlxb_xa,(dlyb-dlya))*180.d0/dlpi

    IF (heading < 0) heading=heading+360.d0
  END FUNCTION heading

END PROGRAM cdfweight

PROGRAM cdftempvol_full
  !!---------------------------------------------------------------------
  !!               ***  PROGRAM cdftempvol_full  ***
  !!
  !!  **  Purpose: Compute water volume in a given domain between isotherms 
  !!                FULL STEPS version
  !! 
  !!  **  Method   :  compute the sum ( e1 * e2 * e3 * mask )
  !!        -The box boundary are given by imin, imax, jmin, jmax
  !!            read metrics, depth, etc
  !!            read T and SSH
  !!            compute the depths of isothermal surfaces
  !!            compute the volume from surface to the isotherm
  !!            compute the volume in each class of temperature
  !!            compute the total volume
  !!
  !! history :
  !!   Original :  F. Castruccio (Fall 2006)
  !!---------------------------------------------------------------------
  !!  $Rev$
  !!  $Date$
  !!  $Id$
  !!--------------------------------------------------------------
  !! * Modules used
  USE cdfio

  !! * Local variables
  IMPLICIT NONE
  INTEGER   :: nbins                                  !: number of density classes
  INTEGER   :: ji, jj, jk, jclass, jiso, jbin, jarg   !: dummy loop index
  INTEGER   :: ipos                                   !: working variable
  INTEGER   :: narg, iargc                            !: command line 
  INTEGER   :: npiglo,npjglo                          !: size of the domain
  INTEGER   :: npk, nk                                !: vertical size, number of wet layers in the section
  INTEGER   :: numbimg=10                             !: optional bimg logical unit
  INTEGER   :: numout=11                              !: ascii output

  INTEGER                            :: imin, imax, jmin, jmax      !: working box limits

  REAL(KIND=4), DIMENSION (:),     ALLOCATABLE :: gdept, gdepw !: depth of T and W points 
  REAL(KIND=4), DIMENSION (:),     ALLOCATABLE :: e3t          !: depth of T and W points 
  REAL(KIND=4), DIMENSION (:,:),   ALLOCATABLE :: e1t, e2t     !: lon, lat of T from file 
  REAL(KIND=4), DIMENSION (:,:),   ALLOCATABLE :: zt           !: temperature from file
  REAL(KIND=4), DIMENSION (:,:),   ALLOCATABLE :: zssh         !: SSH from file 
  REAL(KIND=4), DIMENSION (:,:),   ALLOCATABLE :: tmp          !: temporary array

  ! double precision for cumulative variables
  REAL(KIND=8), DIMENSION (:,:),   ALLOCATABLE ::  e1, e2             !: either e1t or e2t
  REAL(KIND=8), DIMENSION (:,:),   ALLOCATABLE ::  e3 , zmask         !: e3 and zmask
  REAL(KIND=8), DIMENSION (:,:),   ALLOCATABLE ::  ztemp, gdep        !: temp., depth of temp. points
  REAL(KIND=8)                                 :: temp_min, temp_max, dtemp    !: Min and Max for temp. bining
  REAL(KIND=8)                                 :: temp,zalfa                   !: current working temp.
  REAL(KIND=8), DIMENSION (:),   ALLOCATABLE   :: temp_lev                     !: built array with temp. levels
  REAL(KIND=8), DIMENSION (:,:), ALLOCATABLE   :: hiso                         !: depth of isotherms

  REAL(KIND=8), DIMENSION (:,:), ALLOCATABLE   :: zwvol, zwvolbin, volbin2      !: volume arrays
  REAL(KIND=8), DIMENSION (:), ALLOCATABLE     :: volbin                        !: volume arrays

  CHARACTER(LEN=256) :: cfilet                                                   !: files name
  CHARACTER(LEN=256) :: coordhgr='mesh_hgr.nc',  coordzgr='mesh_zgr.nc'          !: coordinates files
  CHARACTER(LEN=256) :: cfilout='voltemp.txt'                                    !: output file
  CHARACTER(LEN=256) :: cdum                                                     !: dummy string

  LOGICAL    :: l_print=.FALSE.             !: flag  for printing additional results
  LOGICAL    :: l_print2=.FALSE.             !: flag  for printing additional results
  LOGICAL    :: l_bimg=.FALSE.              !: flag  for bimg output

  !!  * Initialisations

  !  Read command line and output usage message if not compliant.
  narg= iargc()
  IF ( narg < 6  ) THEN
     PRINT '(255a)',' Usage : cdftempvol-full  gridTfile  imin, imax, jmin, jmax temp_max temp_min nbins [options]'
     PRINT '(255a)','            imin, imax, jmin, jmax : horizontal limit of the box'
     PRINT '(255a)','            temp_max, temp_min : limit for temperature bining '
     PRINT '(255a)','                           nbins : number of bins to use '
     PRINT '(255a)','     Possible options :'
     PRINT '(255a)','         -print :additional output is send to std output'
     PRINT '(255a)','         -bimg : 2D (x=lat/lon, y=temp) output on bimg file for hiso, cumul trp, trp'
     PRINT '(255a)',' Files mesh_hgr.nc, mesh_zgr.nc must be in the current directory'
     PRINT '(255a)',' Output on voltemp.txt'
     STOP
  ENDIF

  !! Read arguments
  CALL getarg (1, cfilet)
  CALL getarg (2,cdum)           ;        READ(cdum,*) imin
  CALL getarg (3,cdum)           ;        READ(cdum,*) imax
  CALL getarg (4,cdum)           ;        READ(cdum,*) jmin
  CALL getarg (5,cdum)           ;        READ(cdum,*) jmax
  CALL getarg (6,cdum)           ;        READ(cdum,*) temp_max
  CALL getarg (7,cdum)           ;        READ(cdum,*) temp_min
  CALL getarg (8,cdum)           ;        READ(cdum,*) nbins

  DO jarg=9, narg
     CALL getarg(jarg,cdum)
     SELECT CASE (cdum)
     CASE ('-print' )
        l_print = .TRUE.
     CASE ('-bimg')
        l_bimg = .TRUE.
     CASE DEFAULT
        PRINT *,' Unknown option ', TRIM(cdum),' ... ignored'
     END SELECT
  END DO

  ! Allocate and build temp. levels and section array
  ALLOCATE ( temp_lev (nbins+1) )

  temp_lev(1)=temp_max
  dtemp=( temp_max - temp_min) / nbins
  DO jclass =2, nbins+1
     temp_lev(jclass)= temp_lev(1) - (jclass-1) * dtemp
  END DO

  ! Look for size of the domain
  npiglo= getdim (cfilet,'x')
  npjglo= getdim (cfilet,'y')
  npk = getdim (cfilet,'depth')
  IF (imin /= 0 ) THEN ; npiglo=imax -imin + 1;  ELSE ; imin=1 ; ENDIF
  IF (jmin /= 0 ) THEN ; npjglo=jmax -jmin + 1;  ELSE ; jmin=1 ; ENDIF
  ALLOCATE ( gdept(npk), gdepw(npk), e1t(npiglo,npjglo), e2t(npiglo,npjglo), e3t(npk) )
  ALLOCATE ( volbin(nbins), volbin2(npjglo,nbins) )
  volbin=0.d0 ; volbin2=0.d0 

  ! read dimensions 
  gdept(:) = getvare3(coordzgr, 'gdept',npk)
  gdepw(:) = getvare3(coordzgr, 'gdepw',npk)
  e1t(:,:) = getvar(coordhgr, 'e1t', 1,npiglo,npjglo,kimin=imin,kjmin=jmin)
  e2t(:,:) = getvar(coordhgr, 'e2t', 1,npiglo,npjglo,kimin=imin,kjmin=jmin)
  e3t(:)   = getvare3(coordzgr, 'e3t',npk)


  !! *  Main loop
  
  DO jj=jmin,jmax

     ALLOCATE ( zt(npiglo,npk), tmp(npiglo,1), ztemp(npiglo,0:npk), zssh(npiglo,1) ) 
     ALLOCATE ( e1(npiglo,npk), e2(npiglo,npk), e3(npiglo,npk), gdep(npiglo, npk), zmask(npiglo,npk) )
     ALLOCATE ( zwvol(npiglo, nbins+1) , hiso(npiglo,nbins+1), zwvolbin(npiglo,nbins) )

     zssh= 0. ; gdep= 0. ; zmask = 0. ; ztemp=0.d0 ; e1=0.d0 ; e2=0.d0 ; e3=0.d0
     zwvol=0.d0 ; zwvolbin=0.d0
 
     zssh(:,:)=getvar(cfilet,'sossheig',1, npiglo, 1 , kimin=imin+1 , kjmin=jj)

     DO jk=1,npk
        ! initiliaze gdep to gdept()
        gdep(:,jk) = gdept(jk)

        ! metrics (Full step case)
        e1(:,jk)=e1t(:,jj-jmin+1)
        e2(:,jk)=e2t(:,jj-jmin+1)
        e3(:,jk)=e3t(jk)
     

        ! temperature
        tmp(:,:)=getvar(cfilet,'votemper',jk, npiglo, 1, kimin=imin+1, kjmin=jj)
        zmask(:,jk)=tmp(:,1)
        WHERE ( zmask(:,jk) /= 0 ) zmask(:,jk)=1

        zt(:,jk) = tmp(:,1)

        ! limitation to 'wet' points
        IF ( SUM(zt(:,jk))  == 0 ) THEN
           nk=jk ! first vertical point of the section full on land
           EXIT  ! as soon as all the points are on land
        ENDIF

     END DO

     ! temp. only for wet points
     ztemp(:,1:nk)=zt(:,:)
     ztemp(:,0)=ztemp(:,1)-1.e-4   ! dummy layer for easy interpolation


     ! Some control print 
     IF ( l_print2 ) THEN
        PRINT *,' T (deg C)' 
        DO jk=1,nk
           PRINT 9000, jk,  (ztemp(ji,jk),ji=1,npiglo)
        END DO

        PRINT *,' SSH (m)'  
        PRINT 9000, 1, (zssh(ji,1),ji=1,npiglo) 

        PRINT *,' GDEP (m) '
        DO jk=1,nk
           PRINT 9001,jk,  (gdep(ji,jk)*zmask(ji,jk),ji=1,npiglo)
        END DO

        PRINT *, 'E1 (m)'
        DO jk=1,nk
           PRINT 9001,jk,  (e1(ji,jk)*zmask(ji,jk),ji=1,npiglo)
        END DO

        PRINT *, 'E2 (m)'
        DO jk=1,nk
           PRINT 9001,jk,  (e2(ji,jk)*zmask(ji,jk),ji=1,npiglo)
        END DO

        PRINT *, 'E3 (m)'
        DO jk=1,nk
           PRINT 9001,jk,  (e3(ji,jk)*zmask(ji,jk),ji=1,npiglo)
        END DO
     END IF

     ! compute depth of isotherms (nbins+1 )
     IF (l_print )  PRINT *,' DEP ISO ( m )'
     DO  jiso =1, nbins+1
        temp=temp_lev(jiso)
!!!  REM : I and K loop can be inverted if necessary
        DO ji=1,npiglo
           hiso(ji,jiso) = gdept(npk)
           DO jk=1,nk 
              IF ( ztemp(ji,jk) > temp ) THEN
              ELSE
                 ! interpolate between jk-1 and jk
                 zalfa=(temp - ztemp(ji,jk-1)) / ( ztemp(ji,jk) -ztemp(ji,jk-1) )
                 IF (ABS(zalfa) > 1.1 ) THEN   ! case ztemp(0) = ztemp(1)-1.e-4
                    hiso(ji,jiso)= 0.
                 ELSE
                    hiso(ji,jiso)= gdep(ji,jk)*zalfa + (1.-zalfa)* gdep(ji,jk-1)
                 ENDIF
                 EXIT
              ENDIF
           END DO
        END DO
        IF (l_print) PRINT 9002, temp,(hiso(ji,jiso),ji=1,npiglo)
     END DO

     ! compute volume between surface and isotherm 
     IF (l_print) PRINT *,' VOL SURF -->  ISO (1.e12 M3)'
     DO jiso = 1, nbins + 1
        temp=temp_lev(jiso)
        DO ji=1,npiglo
           !zwvol(ji,jiso) = e1(ji,1)*e2(ji,1)*zssh(ji,1)
           DO jk=1, nk
              IF ( gdepw(jk+1) < hiso(ji,jiso) ) THEN
                 zwvol(ji,jiso)= zwvol(ji,jiso) + e1(ji,jk)*e2(ji,jk)*e3(ji,jk)
              ELSE  ! last box ( fraction)
                 zwvol(ji,jiso)= zwvol(ji,jiso) + e1(ji,jk)*e2(ji,jk)*(hiso(ji,jiso)-gdepw(jk))
                 EXIT  ! jk loop
              ENDIF
           END DO
        END DO
        IF (l_print) PRINT  9003, temp,(zwvol(ji,jiso)/1.e12,ji=1,npiglo)
     END DO

     ! binned volume : difference between 2 isotherms
     IF (l_print) PRINT *,' VOL bins (SV)'
     DO jbin=1, nbins
        temp=temp_lev(jbin)
        DO ji=1, npiglo
           zwvolbin(ji,jbin) = zwvol(ji,jbin+1) -  zwvol(ji,jbin) 
        END DO
        volbin2(jj-jmin+1,jbin)=SUM(zwvolbin(:,jbin) )
        IF (l_print) PRINT  9003, temp,(zwvolbin(ji,jbin)/1.e12,ji=1,npiglo), volbin2(jj-jmin+1,jbin)/1.e12
        volbin(jbin)=volbin(jbin)+volbin2(jj-jmin+1,jbin)
     END DO
     PRINT *,' Total volume in all bins (1e.15 M3):',SUM(volbin2(jj-jmin+1,:) )/1.e15
     

!    ! output of the code for 1 section
!    IF (l_bimg) THEN
!      ! (along section, depth ) 2D variables
!       cdum='Tdep.bimg'
!       OPEN(numbimg,FILE=cdum,FORM='UNFORMATTED')
!       cdum=' 3 dimensions in this file '
!       WRITE(numbimg) cdum
!       cdum=' 1: T  '
!       WRITE(numbimg) cdum
!       WRITE(cdum,'(a,4i5.4)') 'in box ', imin,imax,jmin,jmax
!       WRITE(numbimg) cdum
!       cdum=' file '//TRIM(cfilet)
!       WRITE(numbimg) cdum
!       WRITE(numbimg) npiglo,nk,1,1,2,0
!       WRITE(numbimg) 1.,-float(nk),1.,1., 0.
!       WRITE(numbimg) 0.
!       WRITE(numbimg) 0.
!       ! temperature
!       WRITE(numbimg) (( REAL(ztemp(ji,jk)), ji=1,npiglo) , jk=nk,1,-1 )
!       CLOSE(numbimg)

!       ! (along section, temp ) 2D variables
!       cdum='Volume_water_Tdep.bimg'
!       OPEN(numbimg,FILE=cdum,FORM='UNFORMATTED')
!       cdum=' 3 dimensions in this file '
!       WRITE(numbimg) cdum
!       cdum=' 1: hiso ;  2: bin vol '
!       WRITE(numbimg) cdum
!       WRITE(cdum,'(a,4i5.4)') ' in box ', imin,imax,jmin,jmax
!       WRITE(numbimg) cdum
!       cdum=' file '//TRIM(cfilet)
!       WRITE(numbimg) cdum
!       WRITE(numbimg) npiglo,nbins,1,1,2,0
!       WRITE(numbimg) 1.,-REAL(temp_lev(nbins)),1.,REAL(dtemp), 0.
!       WRITE(numbimg) 0.
!       WRITE(numbimg) 0.
!       ! hiso
!       WRITE(numbimg) (( REAL(hiso(ji,jiso)), ji=1,npiglo) , jiso=nbins,1,-1)
!       ! binned transport
!       WRITE(numbimg) (( REAL(zwvolbin(ji,jiso))/1.e15, ji=1,npiglo) , jiso=nbins,1,-1)
!       CLOSE(numbimg)
!    ENDIF

     ! free memory for the next section
     DEALLOCATE ( zt, tmp, ztemp, zssh )
     DEALLOCATE ( e1, e2, e3, gdep, zmask )
     DEALLOCATE ( zwvol, hiso, zwvolbin )

     PRINT *,' Total volume in all bins (1e.15 M3):',SUM(volbin(:)/1.e15 )

  END DO   ! next section

  !! Global Output
     OPEN( numout, FILE=cfilout)
       ipos=INDEX(cfilet,'_gridT.nc')
       WRITE(numout,9006)  TRIM(cfilet(1:ipos-1))
       WRITE(numout,*) ' temp.  '
     DO jiso=1,nbins
       WRITE(numout,9004) temp_lev(jiso), volbin(jiso)
     ENDDO
     CLOSE(numout)

9000 FORMAT(i7,60f8.3)
9001 FORMAT(i7,60f8.0)
9002 FORMAT(f7.3,60f8.0)
9003 FORMAT(f7.3,60f8.3)
9004 FORMAT(f9.4, 60e16.7)
9005 FORMAT('#',a9, 60(2x,a12,2x) )
9006 FORMAT('# ',a)


END PROGRAM cdftempvol_full

PROGRAM cdfnan
  !!======================================================================
  !!                     ***  PROGRAM  cdfnan  ***
  !!=====================================================================
  !!  ** Purpose : Replace the nan values by spval or another value 
  !!               given in argument
  !!
  !! History : 2.1  : 05/2010  : J.M. Molines : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio 
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                               :: jk, jvar, jt           ! dummy loop index
  INTEGER(KIND=4)                               :: ierr                   ! working integer
  INTEGER(KIND=4)                               :: narg, iargc, ijarg     ! browse line
  INTEGER(KIND=4)                               :: ncid                   ! ncid of input file for rewrite
  INTEGER(KIND=4)                               :: npiglo, npjglo         ! size of the domain
  INTEGER(KIND=4)                               :: npk, npt               ! size of the domain
  INTEGER(KIND=4)                               :: nvars                  ! Number of variables in a file
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: ipk                    ! arrays of vertical level for each var
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: id_var                 ! arrays of var id

  REAL(KIND=4)                                  :: zspval, replace        ! spval, replace value
  REAL(KIND=4)                                  :: rabsmax                ! spval, replace value
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: tab                    ! Arrays for data

  CHARACTER(LEN=256)                            :: cldum                  ! dummy string for getarg
  CHARACTER(LEN=256)                            :: cf_inout               ! file name
  CHARACTER(LEN=256)                            :: cunits, clname, csname ! attributes
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_names               ! array of var name

  TYPE(variable), DIMENSION(:),     ALLOCATABLE :: stypvar                ! type for attributes

  LOGICAL                                       :: l_replace = .false.    ! flag for replace value
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfnan list_of_model_output_files [-value replace] [-absmax rabsmax ] '
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Detect NaN values in the input files, and change them to '
     PRINT *,'       either spval (missing_value) or the value given as option.'
     PRINT *,'       Does the same for absolute values > huge(0.0)'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       list of model output files. They must be of same type and have'
     PRINT *,'       similar sizes. CAUTION : input files are rewritten !'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-value replace ] : use replace instead of missing_value for'
     PRINT *,'                           changing NaN.'
     PRINT *,'       [-absmax rabsmax ] : replace values whose absolute value is greater '
     PRINT *,'                           than rabsmax.'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : input file is rewritten without NaN.' 
     PRINT *,'         variables : same name as input.' 
     STOP
  ENDIF

  rabsmax=huge(0.0)
  ijarg=1
  DO WHILE ( ijarg <= narg )
     CALL getarg(ijarg, cldum) ;   ijarg = ijarg + 1
     SELECT CASE (cldum)
     CASE ('-value' )
        CALL getarg( ijarg, cldum) ; ijarg = ijarg+1 ; 
        READ(cldum,*) replace ; l_replace=.true.
     CASE ('-absmax' )
        CALL getarg( ijarg, cldum) ; ijarg = ijarg+1 ; 
        READ(cldum,*) rabsmax 
     CASE DEFAULT
        cf_inout=TRIM(cldum)
     END SELECT
  END DO
  IF ( chkfile (cf_inout) )  STOP ! missing file

  npiglo = getdim (cf_inout, cn_x              )
  npjglo = getdim (cf_inout, cn_y              )
  npk    = getdim (cf_inout, cn_z, kstatus=ierr)

  IF (ierr /= 0 ) THEN
     npk   = getdim (cf_inout,'z',kstatus=ierr)
     IF (ierr /= 0 ) THEN
        PRINT *, 'ASSUME NO VERTICAL DIMENSIONS !'
        npk=0
     ENDIF
  ENDIF

  PRINT *, 'npiglo=', npiglo
  PRINT *, 'npjglo=', npjglo
  PRINT *, 'npk   =', npk

  ALLOCATE( tab(npiglo,npjglo) )

  nvars = getnvar(cf_inout)

  ALLOCATE (cv_names(nvars), id_var(nvars),ipk(nvars), stypvar(nvars))

  cv_names(:) = getvarname(cf_inout,nvars,stypvar)
  ipk(:)      = getipk(cf_inout,nvars)
  id_var(:)   = getvarid(cf_inout,nvars)

  !re scan argument list 
  ijarg = 1
  DO WHILE (ijarg <=  narg ) 
     CALL getarg (ijarg, cf_inout) ; ijarg = ijarg + 1 

     SELECT CASE ( cf_inout)
     CASE ('-value' )
        ! replace already read, just skip
        ijarg = ijarg + 1
     CASE ('-absmax' )
        !  already read, just skip
        ijarg = ijarg + 1
     CASE DEFAULT  ! reading files
        PRINT *, 'Change NaN on file ', cf_inout
        ncid = ncopen(cf_inout)
        npt  = getdim (cf_inout,cn_t)

        DO jvar = 1,nvars
           IF (    cv_names(jvar) == cn_vlon2d   .OR. &
                &  cv_names(jvar) == cn_vlat2d   .OR. &
                &  cv_names(jvar) == cn_vtimec   .OR. &
                &  cv_names(jvar) == cn_vdeptht  .OR. &
                &  cv_names(jvar) == cn_vdepthu  .OR. &
                &  cv_names(jvar) == cn_vdepthv         )  THEN
              ! skip these variable
           ELSE
              IF ( l_replace ) THEN
                 zspval=replace
              ELSE
                 ierr = getvaratt (cf_inout, cv_names(jvar), cunits, zspval, clname, csname)
              ENDIF

              DO jt=1,npt
                 DO jk = 1, ipk(jvar) 
                    tab(:,:) = getvar(cf_inout, cv_names(jvar), jk, npiglo, npjglo, ktime=jt )
!                   WHERE( isnan(tab(:,:)) ) tab(:,:) = zspval
                    ! isnan function is not available on xlf90 compiler
                    ! we replace it by the following test that gives the same results
                    ! reference : http://www.unixguide.net/ibm/faq/faq3.03.shtml
                    WHERE( tab(:,:) /=  tab(:,:) ) tab(:,:) = zspval
                    WHERE( tab(:,:) < -rabsmax ) tab(:,:) = zspval
                    WHERE( tab(:,:) >  rabsmax ) tab(:,:) = zspval
                    ierr = putvar(ncid, id_var(jvar), tab, jk, npiglo, npjglo, ktime=jt)
                 ENDDO
              END DO
           ENDIF
        ENDDO
     END SELECT
  ENDDO

  ierr = closeout(ncid)

END PROGRAM cdfnan

PROGRAM cdfnrj_bci
  !!======================================================================
  !!                     ***  PROGRAM  cdfnrj_bci  ***
  !!=====================================================================
  !!  ** Purpose : Compute the term of energetic transfert BCI
  !!               for the baroclinic instability
  !!
  !!  ** Method  : take  an input file which is the result of a preprocessing
  !!               tool cdfuvwt.
  !!
  !! History : 2.1  : 02/2008  : A. Melet     : Original code
  !!           3.0  : 12/2010  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class energy_diagnostics
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: ji, jj, jk, jt, jv       ! dummy loop index
  INTEGER(KIND=4)                           :: npiglo, npjglo, npk, npt ! domain size
  INTEGER(KIND=4)                           :: narg, iargc, ijarg       ! line parser
  INTEGER(KIND=4)                           :: ncout, ierr              ! netcdf i/o
  INTEGER(KIND=4), DIMENSION(5)             :: ipk, id_varout           ! idem

  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e2t, e1t                 ! horizontal metric
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: anout, anovt, un, vn, tn ! working variables
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: utn, vtn                 !  idem
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: tmask, umask, vmask      ! mask variable
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: bci                      ! baroclinic energy transfert
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: rdtdx, rdtdy             ! horizontal gradients

  REAL(KIND=8), DIMENSION(:),   ALLOCATABLE :: dtim                     ! time variable

  CHARACTER(LEN=256)                        :: cf_in                    ! input filename
  CHARACTER(LEN=256)                        :: cf_out='bci.nc'          ! output file name
  CHARACTER(LEN=256)                        :: cldum                    ! working char variable

  TYPE (variable), DIMENSION(5)             :: stypvar                  ! structure for attibutes

  LOGICAL                                   :: lnc4 = .FALSE.           ! Use nc4 with chunking and deflation
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()   ! load cdf variable name

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfnrj_bci -f UVWT-file [-o OUT-file] [-nc4]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute elements (see variable list below) for analysing the baroclinic'
     PRINT *,'       instability.' 
     PRINT *,'       Note : this program was formerly named cdfbci.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -f UVWT-file : input file is produced by cdfuvwt, and the mean'
     PRINT *,'              must be computed on a long-enough period for the statistics' 
     PRINT *,'              to be meaningful. Points are on T grid.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-o OUT-file] : specify output file name instead of ',TRIM(cf_out)
     PRINT *,'       [-nc4 ]   : Use netcdf4 output with chunking and deflation level 1.'
     PRINT *,'              This option is effective only if cdftools are compiled with'
     PRINT *,'              a netcdf library supporting chunking and deflation.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       Need ', TRIM(cn_fhgr) ,' file'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : 5 output variables'
     PRINT *,'             dTdx : zonal derivative of Tbar on T point (*1000)'
     PRINT *,'             dTdy : meridional derivative of Tbar on T point (*1000)'
     PRINT *,'             uT   : anomaly of u times anomaly of T on T point'
     PRINT *,'             vT   : anomaly of v times anomaly of T on T point'
     PRINT *,'             bci  : transfert of energy for the baroclinic instability (*1000)'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'       cdfuvwt, cdfnrj_bti, cdfnrj_components, cdfnrj_transfert '
     STOP 
  ENDIF

  ijarg = 1
  DO WHILE ( ijarg <= narg )
     CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-f'   ) ; CALL getarg(ijarg, cf_in ) ; ijarg=ijarg+1
        ! option
     CASE ( '-o'   ) ; CALL getarg(ijarg, cf_out) ; ijarg=ijarg+1
     CASE ( '-nc4' ) ; lnc4 = .TRUE.
     CASE DEFAULT    ; PRINT *, ' ERROR : ', TRIM(cldum),' : unknown option.'; STOP 99
     END SELECT
  ENDDO

  IF (chkfile(cf_in) .OR. chkfile (cn_fhgr) ) STOP 99

  npiglo = getdim(cf_in, cn_x)
  npjglo = getdim(cf_in, cn_y)
  npk    = getdim(cf_in, cn_z)
  npt    = getdim(cf_in, cn_t)

  PRINT *, 'npiglo =', npiglo
  PRINT *, 'npjglo =', npjglo
  PRINT *, 'npk    =', npk
  PRINT *, 'npt    =', npt

  ! Allocate the memory
  ALLOCATE ( e1t(npiglo,npjglo) , e2t(npiglo,npjglo) )
  ALLOCATE ( un(npiglo,npjglo)  , vn(npiglo,npjglo)  )
  ALLOCATE ( tn(npiglo,npjglo) )
  ALLOCATE ( utn(npiglo,npjglo) , vtn(npiglo,npjglo) )
  ALLOCATE ( umask(npiglo,npjglo) , vmask(npiglo,npjglo) )
  ALLOCATE ( tmask(npiglo,npjglo) )
  ALLOCATE ( rdtdx(npiglo,npjglo)  , rdtdy(npiglo,npjglo)  )
  ALLOCATE ( anout(npiglo,npjglo)  , anovt(npiglo,npjglo)  )
  ALLOCATE ( bci(npiglo,npjglo), dtim(npt) )

  CALL CreateOutput

  e1t =  getvar(cn_fhgr, cn_ve1t, 1, npiglo, npjglo)
  e2t =  getvar(cn_fhgr, cn_ve2t, 1, npiglo, npjglo)

  DO jt=1,npt
     DO jk=1, npk
        PRINT *,'            level ',jk

        rdtdx(:,:) = 0.0
        rdtdy(:,:) = 0.0

        anovt(:,:) = 0.0      
        anout(:,:) = 0.0

        un(:,:)  =  getvar(cf_in, 'ubar',  jk ,npiglo, npjglo, ktime=jt)
        vn(:,:)  =  getvar(cf_in, 'vbar',  jk ,npiglo, npjglo, ktime=jt)
        tn(:,:)  =  getvar(cf_in, 'tbar',  jk ,npiglo, npjglo, ktime=jt)
        utn(:,:) =  getvar(cf_in, 'utbar', jk ,npiglo, npjglo, ktime=jt)
        vtn(:,:) =  getvar(cf_in, 'vtbar', jk ,npiglo, npjglo, ktime=jt)

        ! compute the mask
        DO jj = 2, npjglo
           DO ji = 2, npiglo
              umask(ji,jj)= un(ji,jj)*un(ji-1,jj) 
              vmask(ji,jj)= vn(ji,jj)*vn(ji,jj-1)
              tmask(ji,jj)= tn(ji,jj)
              IF (umask(ji,jj) /= 0.) umask(ji,jj)=1.
              IF (vmask(ji,jj) /= 0.) vmask(ji,jj)=1.
              IF (tmask(ji,jj) /= 0.) tmask(ji,jj)=1.
           END DO
        END DO

        DO jj = 2, npjglo  
           DO ji = 2, npiglo    ! vector opt.
              ! compute derivatives at T point
              rdtdx(ji,jj) = 1000/2. *( ( tn(ji,jj ) - tn(ji-1,jj) )      &
                   &           * tmask(ji,jj)*tmask(ji-1,jj)              &
                   &           / ( 0.5* ( e1t(ji,jj) + e1t(ji-1,jj) ))    &
                   &           +( tn(ji+1,jj ) - tn(ji,jj) )              &
                   &           * tmask(ji+1,jj)*tmask(ji,jj)              &
                   &           / ( 0.5* ( e1t(ji+1,jj) + e1t(ji,jj) )))

              rdtdy(ji,jj) = 1000/2. *( ( tn(ji,jj) - tn(ji,jj-1) )       &
                   &           * tmask(ji,jj)*tmask(ji,jj-1)              &
                   &           / ( 0.5* ( e2t(ji,jj) + e2t(ji,jj-1) ))    &
                   &           +( tn(ji,jj+1 ) - tn(ji,jj) )              &
                   &           * tmask(ji,jj+1)*tmask(ji,jj)              &
                   &           / ( 0.5* ( e2t(ji,jj+1) + e2t(ji,jj) )) )

              anout(ji,jj)    = ( utn(ji,jj)                                            &
                   &                 -   0.5 * umask(ji,jj)*( un(ji,jj) + un(ji-1,jj) ) &
                   &                   * tmask(ji,jj) * tn(ji,jj) )

              anovt(ji,jj)    = ( vtn(ji,jj)                                            &
                   &                 -   0.5 * vmask(ji,jj)*( vn(ji,jj) + vn(ji,jj-1) ) &
                   &                   * tmask(ji,jj) * tn(ji,jj) )

              ! compute bci term
              bci(ji,jj) = ( anout(ji,jj) * rdtdx(ji,jj) + anovt(ji,jj) * rdtdy(ji,jj) )

           END DO
        END DO
        ! 
        ierr = putvar(ncout, id_varout(1), rdtdx, jk, npiglo, npjglo, ktime=jt)
        ierr = putvar(ncout, id_varout(2), rdtdy, jk, npiglo, npjglo, ktime=jt)
        ierr = putvar(ncout, id_varout(3), anout, jk, npiglo, npjglo, ktime=jt)
        ierr = putvar(ncout, id_varout(4), anovt, jk, npiglo, npjglo, ktime=jt)
        ierr = putvar(ncout, id_varout(5), bci,   jk, npiglo, npjglo, ktime=jt)
     END DO !level-loop
  ENDDO ! time-loop
  ierr = closeout(ncout)

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    DO jv = 1,5
       stypvar(jv)%ichunk  = (/npiglo,MAX(1,npjglo/30),1,1 /)
    ENDDO

    ipk(:) = npk  

    stypvar(1)%cname       = 'dTdx'
    stypvar(1)%clong_name  = 'zonal derivate of Tbar on T point (*1000)'
    stypvar(1)%cshort_name = 'dTdx'

    stypvar(2)%cname       = 'dTdy'
    stypvar(2)%clong_name  = 'meridional derivate of Tbar on T point (*1000)'
    stypvar(2)%cshort_name = 'dTdy'

    stypvar(3)%cname       = 'uT'
    stypvar(3)%clong_name  = 'anomaly of u times anomaly of T on T point'
    stypvar(3)%cshort_name = 'uT'

    stypvar(4)%cname       = 'vT'
    stypvar(4)%clong_name  = 'anomaly of v times anomaly of T on T point'
    stypvar(4)%cshort_name = 'vT'

    stypvar(5)%cname       = 'bci'
    stypvar(5)%clong_name  = 'transfert of energy for the baroclinic instability (*1000)'
    stypvar(5)%cshort_name = 'bci'

    stypvar%cunits            = '1000 (u"T" dT/dx + v"T" dT/dy)'
    stypvar%rmissing_value    = 0.
    stypvar%valid_min         = -1000.
    stypvar%valid_max         = 1000.
    stypvar%conline_operation = 'N/A'
    stypvar%caxis             = 'TYX'


    ! create output fileset
    ncout = create      (cf_out,   cf_in,   npiglo, npjglo, npk       , ld_nc4=lnc4 )
    ierr  = createvar   (ncout ,   stypvar, 5,      ipk,    id_varout , ld_nc4=lnc4 )
    ierr  = putheadervar(ncout,    cf_in,   npiglo, npjglo, npk       )

    dtim = getvar1d(cf_in, cn_vtimec, npt)
    ierr = putvar1d(ncout, dtim, npt, 'T')

  END SUBROUTINE CreateOutput

END PROGRAM cdfnrj_bci

PROGRAM cdfmht_gsop
  !!======================================================================
  !!                     ***  PROGRAM  cdfmht_gsop  ***
  !!=====================================================================
  !!  **  Purpose  :  Compute the Meridional Heat Transport (MHT) components
  !!                  GSOP intercomparison project.
  !!  
  !!  **  Method   :  The MHT is computed from the V velocity field and T temperature field,
  !!                  integrated from the bottom to the surface. The velocity field is 
  !!                  decomposed into 3 components : Barotropic (BT), Shear geostrophic(SH)
  !!                  and Ageostrophic (AG). The program computes the corresponding MHT, thus
  !!                  saving 4 variables : Total, BT, SH, and AG MHT component.
  !!
  !!
  !! History : 2.0  : 07/2005 : J.M. Molines    : original MHT code
  !!                : 09/2007 : G.C. Smith      : Added MOC decomposition following :
  !!                : 12/2008 : A. Lecointre    : Replaced by a MHT decomposition
  !!         : 4.0  : 03/2017 : J.M. Molines    : rewriting at cdftools 4 standards
  !!
  !! References :  Lee & Marotzke (1998), Baehr, Hirschi, Beismann, &  Marotzke (2004),
  !!               Cabanes, Lee, & Fu (2007),  Koehl & Stammer (2007).
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  !!   routines      : description
  !!   varchk2       : check if variable is candidate for square mean
  !!   varchk3       : check if variable is candidate for cubic mean
  !!   zeromean      : substract mean value from input field
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  USE eos
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class transport
  !!-----------------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4), PARAMETER                  :: jpgsop=4                   ! number of output variable
  INTEGER(KIND=4)                             :: nbasins                    ! number of basins to deal with
  INTEGER(KIND=4)                             :: jgsop, jbasin, jj, jk ,ji  ! dummy loop index
  INTEGER(KIND=4)                             :: ierr                       ! working integer
  INTEGER(KIND=4)                             :: narg, iargc, ijarg         ! command line 
  INTEGER(KIND=4)                             :: npiglo,npjglo, npk, npt    ! size of the domain
  INTEGER(KIND=4)                             :: ncout, np
  INTEGER(KIND=4)                             :: numout=10                  ! logical unit
  INTEGER(KIND=4), DIMENSION(jpgsop)          :: ipk_gsop, id_varout_gsop   ! netcdf output
  INTEGER(KIND=4), DIMENSION(2)               :: iloc

  REAL(KIND=4)                                :: rho0=1000.,   rcp=4000.    ! rau0 en kg x m-3 et rcp en m2 x s-2 x degC-1
  REAL(KIND=4)                                :: rau0, grav, f0, fcor       ! physical parameters
  REAL(KIND=4)                                :: zmsv, zphv, rpi            !
  REAL(KIND=4), DIMENSION(:),     ALLOCATABLE :: gdept, gdepw               ! deptht, deptw
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: e1u, e1v, e3v, gphiv, zv   !  metrics, velocity
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: hdep, vbt
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: btht
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: zt,zt_v,zsal
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: tmask,umask,vmask
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: vgeoz
  REAL(KIND=8), DIMENSION(:,:),   ALLOCATABLE :: zsig0
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: rlon                      ! dummy longitude = 0.
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: rlat                      ! latitude for i = north pole
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: zzmask                    ! npiglo x npjglo
  REAL(KIND=4), DIMENSION(:,:,:), ALLOCATABLE :: zmask                     ! nbasins x npiglo x npjglo
  REAL(KIND=4), DIMENSION(:,:,:), ALLOCATABLE :: vgeo,vgeosh,vageosh       ! npiglo x npjglo x npk
  REAL(KIND=4), DIMENSION(:,:,:), ALLOCATABLE :: vfull,tfull               ! npiglo x npjglo x npk
  REAL(KIND=4), DIMENSION(:,:,:), ALLOCATABLE :: vmaskz,tmaskz             ! npiglo x npjglo x npk
  REAL(KIND=4), DIMENSION(:,:,:), ALLOCATABLE :: e3vz                      ! npiglo x npjglo x npk

  REAL(KIND=8), DIMENSION(:),     ALLOCATABLE :: dtim
  REAL(KIND=8), DIMENSION(:,:),   ALLOCATABLE :: dzomht                    ! nbasins x npjglo
  REAL(KIND=8), DIMENSION(:,:),   ALLOCATABLE :: dzomht_gsop               ! jpgsop x npjglo
  REAL(KIND=8), DIMENSION(:,:),   ALLOCATABLE :: dzomht_geos_full          ! npjglo x npk
  REAL(KIND=8), DIMENSION(:,:),   ALLOCATABLE :: dzomht_ageos_full         ! npjglo x npk
  REAL(KIND=8), DIMENSION(:,:,:), ALLOCATABLE :: dzomhtfull                ! nbasins x npjglo x npk

  CHARACTER(LEN=256)                          :: cf_tfil
  CHARACTER(LEN=256)                          :: cf_sfil
  CHARACTER(LEN=256)                          :: cf_vfil 
  CHARACTER(LEN=256)                          :: cf_out='gsopmht.nc'
  CHARACTER(LEN=256)                          :: cldum

  TYPE(variable), DIMENSION(jpgsop)           :: stypvar       

  LOGICAL                                     :: llglo = .FALSE.            ! indicator for presence of new_maskglo.nc file
  LOGICAL                                     :: lchk  = .FALSE.            ! missing files flag
  !!-----------------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()

  IF ( narg == 0 ) THEN
     PRINT *,' usage :  cdfmht_gsop -v V-file -t T-file [-s S-file] [-o OUT-file]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the meridional heat transport(MHT) for the Atlantic basin.'
     PRINT *,'       Compute 3 components of the MHT :'
     PRINT *,'          - Barotropic component'
     PRINT *,'          - Vertical shear geostrophic component '
     PRINT *,'          - Vertical shear ageostrophic component (Ekman + residual)'
     PRINT *,'      '
     PRINT *,'     REMARKS :'
     PRINT *,'       This program has been ported to CDFTOOLS4, without major changes.'
     PRINT *,'       It should work as before but is not optimized for memory (lot of'
     PRINT *,'       3D arrays declared). '
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -v V-file : name of the meridional velocity file.' 
     PRINT *,'       -t T-file : name of the temperature file.'
     PRINT *,'          If salinity not in T-file use -s option.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-s S-file]   : specify salinity file if not T-file.'
     PRINT *,'       [-o OUT-file] : output file name instead of ',TRIM(cf_out)
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ',TRIM(cn_fhgr),', ',TRIM(cn_fzgr),' and ',TRIM(cn_fbasins) 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables :  zomhtatl  : MHT Atlantic Ocean '
     PRINT *,'                      zobtmhta  : Barotropic component '
     PRINT *,'                      zoshmhta  : Vertical shear geostrophic component '
     PRINT *,'                      zoagmhta  : vertical shear ageostrophic component'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'       cdfmhst (compute MHT without decomposition), cdfmoc' 
     PRINT *,'      '
     STOP 
  ENDIF

  ijarg   = 1 
  cf_sfil = 'none'
  DO WHILE ( ijarg <= narg )
     CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-v'   ) ; CALL getarg(ijarg, cf_vfil ) ; ijarg=ijarg+1
     CASE ( '-t'   ) ; CALL getarg(ijarg, cf_tfil ) ; ijarg=ijarg+1
        ! option
     CASE ( '-s'   ) ; CALL getarg(ijarg, cf_sfil ) ; ijarg=ijarg+1
     CASE ( '-o'   ) ; CALL getarg(ijarg, cf_out     ) ; ijarg=ijarg+1
     CASE DEFAULT    ; PRINT *, ' ERROR : ', TRIM(cldum),' : unknown option.'; STOP 99 
     END SELECT
  ENDDO
  IF ( cf_sfil == 'none' ) cf_sfil = cf_tfil

  lchk = lchk .OR. chkfile(cn_fzgr)
  lchk = lchk .OR. chkfile(cn_fhgr)
  lchk = lchk .OR. chkfile(cn_fmsk)
  lchk = lchk .OR. chkfile(cn_fbasins)
  lchk = lchk .OR. chkfile(cf_vfil )
  lchk = lchk .OR. chkfile(cf_tfil )
  lchk = lchk .OR. chkfile(cf_sfil )
  IF ( lchk ) STOP 99 

  npiglo= getdim (cf_vfil,cn_x)
  npjglo= getdim (cf_vfil,cn_y)
  npk   = getdim (cf_vfil,cn_z)
  npt   = getdim (cf_vfil,cn_t)

  ! sanity check on npt
  IF (npt > 1) THEN
     PRINT *, 'E R R O R npt > 1 not yet coded, STOP'
     STOP 99
  END IF

  ! Detects newmaskglo file modif Alb 29/11/08 pour MERA
  INQUIRE( FILE=cn_fbasins, EXIST=llglo )
  IF (llglo) THEN ; nbasins = 5
  ELSE            ; nbasins = 1
  ENDIF

  ! Allocate arrays
  ALLOCATE ( zmask(nbasins,npiglo,npjglo) )
  ALLOCATE ( tmask(npiglo,npjglo) )
  ALLOCATE ( tmaskz(npiglo,npjglo,npk) )
  ALLOCATE ( umask(npiglo,npjglo) )
  ALLOCATE ( vmask(npiglo,npjglo) )
  ALLOCATE ( vmaskz(npiglo,npjglo,npk) )
  ALLOCATE ( zv(npiglo,npjglo) )
  ALLOCATE ( vfull(npiglo,npjglo,npk) )
  ALLOCATE ( zt(npiglo,npjglo), zt_v(npiglo,npjglo) ) ! temperature au point T et au point V
  ALLOCATE ( tfull(npiglo,npjglo,npk) )  ! temperature au point V
  ALLOCATE ( e1u(npiglo,npjglo),e1v(npiglo,npjglo),e3v(npiglo,npjglo), gphiv(npiglo,npjglo) ,gdepw(npk) )
  ALLOCATE ( hdep(npiglo,npjglo), vbt(npiglo,npjglo) )
  ALLOCATE ( e3vz(npiglo,npjglo,npk) )
  ALLOCATE ( dzomhtfull(nbasins,npjglo,npk) )
  ALLOCATE ( dzomht(nbasins, npjglo) )
  ALLOCATE ( dzomht_gsop(jpgsop, npjglo) )
  ALLOCATE ( btht(npjglo,npk) )
  ALLOCATE ( zsal(npiglo,npjglo), zsig0(npiglo,npjglo) )
  ALLOCATE ( gdept(npk) ,dtim(npt))
  ALLOCATE ( rlon(1,npjglo) , rlat(1,npjglo))
  ALLOCATE ( zzmask(npiglo,npjglo) )
  ALLOCATE ( vgeo(npiglo,npjglo,npk) )
  ALLOCATE ( vgeoz(npiglo,npjglo) )
  ALLOCATE ( vgeosh(npiglo,npjglo,npk) )
  ALLOCATE ( dzomht_geos_full(npjglo,npk) )
  ALLOCATE ( vageosh(npiglo,npjglo,npk) )
  ALLOCATE ( dzomht_ageos_full(npjglo,npk) )

  e1v(:,:) = getvar(cn_fhgr, cn_ve1v, 1,npiglo,npjglo) 
  e1u(:,:) = getvar(cn_fhgr, cn_ve1u, 1,npiglo,npjglo) 
  gphiv(:,:) = getvar(cn_fhgr, cn_gphiv, 1,npiglo,npjglo)
  gdept(:) = getvare3(cn_fzgr, cn_gdept,npk)
  gdepw(:) = getvare3(cn_fzgr, cn_gdepw,npk)
  gdepw(:) = -1.*  gdepw(:)

  iloc=MAXLOC(gphiv)
  rlat(1,:) = gphiv(iloc(1),:)
  rlon(:,:) = 0.   ! set the dummy longitude to 0

  CALL CreateOutput

  ! reading the masks
  ! 1 : global ; 2 : Atlantic ; 3 : Indo-Pacif ; 4 : Indian ; 5 : Pacif

  zmask=0
  zmask(1,:,:)=getvar(cn_fmsk,cn_vmask,1,npiglo,npjglo)

  IF (llglo) THEN
     zmask(2,:,:)=getvar(cn_fbasins,cn_tmaskatl,1,npiglo,npjglo)
     zmask(4,:,:)=getvar(cn_fbasins,cn_tmaskind,1,npiglo,npjglo)
     zmask(5,:,:)=getvar(cn_fbasins,cn_tmaskpac,1,npiglo,npjglo)
     zmask(3,:,:)=zmask(5,:,:)+zmask(4,:,:)
     ! ensure that there are no overlapping on the masks
     WHERE(zmask(3,:,:) > 0 ) zmask(3,:,:) = 1
  ELSE
     zmask(2,:,:)=getvar(cn_fmsk, cn_tmask,1,npiglo,npjglo)
  ENDIF

  ! initialize mht to 0
  dzomht(:,:) = 0.
  dzomhtfull(:,:,:) = 0.
  dzomht_gsop(:,:) = 0.
  vbt(:,:) = 0.0
  hdep(:,:) = 0.0
  btht(:,:) = 0.0
  vgeo(:,:,:)=0.0
  vfull(:,:,:)=0.0
  tfull(:,:,:)=0.0

  ! Constants for geostrophic calc
  rau0 = 1025.0
  grav = 9.81
  rpi = ACOS(-1.)
  f0 = 2.0*(2.0*rpi)/(24.0*3600.0)

  ! Get velocities v and temperature T and e3v_ps and masks at all levels
  DO jk = 1,npk
     vmask(:,:)=getvar(cn_fmsk, cn_vmask,    jk,npiglo,npjglo) ; vmaskz(:,:,jk) = vmask(:,:)
     tmask(:,:)=getvar(cn_fmsk, cn_tmask,    jk,npiglo,npjglo) ; tmaskz(:,:,jk) = tmask(:,:)
     zv(:,:)  = getvar(cf_vfil, cn_vomecrty, jk,npiglo,npjglo) ; vfull(:,:,jk) = zv(:,:)
     zt(:,:)  = getvar(cf_tfil, cn_votemper, jk,npiglo,npjglo)  ! au point T
     DO ji = 1,npiglo   ! mettre la temperature au point V
        DO jj = 1,npjglo-1
           zt_v(ji,jj)= ((zt(ji,jj) + zt(ji,jj+1)) * tmask(ji,jj) * tmask(ji,jj+1))/2
        END DO
     END DO
     tfull(:,:,jk)= zt_v(:,:)                                ! au point V
     e3v(:,:) = getvar(cn_fzgr, cn_ve3v, jk,npiglo,npjglo) ; e3vz(:,:,jk) = e3v(:,:)
  ENDDO

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! CALCUL OF THE TOTAL MHT
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  DO jk = 1,npk-1
     ! MHT totale au point V
     ! integrates 'zonally' (along i-coordinate)
     DO ji=1,npiglo
        ! For all basins 
        DO jbasin = 1, nbasins
           DO jj=1,npjglo
              dzomhtfull(jbasin,jj,jk) = dzomhtfull(jbasin,jj,jk) + vmaskz(ji,jj,jk)*e1v(ji,jj)*e3vz(ji,jj,jk)*zmask(jbasin,ji,jj)*vfull(ji,jj,jk)*tfull(ji,jj,jk)*rho0*rcp/1.d15
           ENDDO ! loop to next latitude
        END DO  ! loop to next basin
     END DO    ! loop to next longitude
  ENDDO        ! loop to next level

  ! integrates vertically from bottom to surface the total MHT
  DO jk=npk , 1 , -1 
     dzomht(:,:) = dzomht(:,:) + dzomhtfull(:,:,jk)
  END DO  ! loop to next level
  ! Save variable in dzomht_gsop
  dzomht_gsop(4,:) = dzomht(2,:)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! CALCUL OF THE BAROTROPIC MHT
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  ! Calculate ATLANTIC Barotropic velocity au point V
  DO jk = 1,npk-1
     DO ji=1,npiglo
        DO jj=1,npjglo
           vbt(ji,jj) = vbt(ji,jj) + e3vz(ji,jj,jk)*zmask(2,ji,jj)*vfull(ji,jj,jk)*vmaskz(ji,jj,jk)  ! hardwire to jbasin=2
           hdep(ji,jj) = hdep(ji,jj) + e3vz(ji,jj,jk)*zmask(2,ji,jj)*vmaskz(ji,jj,jk)
        ENDDO ! loop to next latitude
     ENDDO   ! loop to next longitude
  ENDDO      ! loop to next level

  ! Normalize Barotropic velocity
  DO ji=1,npiglo
     DO jj=1,npjglo
        IF ( hdep(ji,jj) > 0.0 ) THEN
           vbt(ji,jj) = vbt(ji,jj)/hdep(ji,jj)
        ELSE
           IF ( vbt(ji,jj) /= 0.0 ) THEN
              PRINT *, 'Is something wrong?, ji,jj=',ji,jj
           ENDIF
           vbt(ji,jj) = 0.0
        ENDIF
     ENDDO  ! loop to next latitude
  ENDDO    ! loop to next longitude

  ! Integrate zonally the barotropic velocity
  DO jk=1, npk 
     DO jj=1,npjglo
        DO ji=1,npiglo
           btht(jj,jk) = btht(jj,jk) + vmaskz(ji,jj,jk)*e1v(ji,jj)*e3vz(ji,jj,jk)*zmask(2,ji,jj)*vbt(ji,jj)*tfull(ji,jj,jk)*rho0*rcp/1.d15
        ENDDO
     ENDDO
  ENDDO

  ! Now Integrate vertically to get Barotropic Meridional Heat Transport
  DO jk=npk , 1 , -1 
     dzomht_gsop(1,:)=dzomht_gsop(1,:) + btht(:,jk)
  END DO  ! loop to next level

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! CALCUL OF THE GEOSTROPHIC MHT
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  ! reinitialiser la temperature au point T a 0
  zt(:,:)=0.0
  DO jk = 1,npk-1 
     ! Calculate density !! attention, density est au point U, il faut la mettre au point V
     zsal(:,:) = getvar(cf_sfil, cn_vosaline,  jk ,npiglo, npjglo)
     zt(:,:)= getvar(cf_tfil, cn_votemper, jk,npiglo,npjglo)    ! au point T

     zzmask=1
     WHERE(zsal(:,:)* zmask(2,:,:) == 0 ) zzmask = 0
     ! geostrophic calculation must use in situ density gradient
     ! la il faut prendre la temperature au point T
     zsig0(:,:) = sigmai ( zt,zsal,gdept(jk),npiglo,npjglo )* zzmask(:,:)

     ! Calculate Geostrophic velocity
     ! value at v points is average of values at u points
     DO ji = 2, npiglo-1
        DO jj = 2, npjglo-1
           IF ( gphiv(ji,jj) == 0.0 ) THEN 
              vgeo(ji,jj,jk) = 0.0
           ELSE
              zmsv = 1. / MAX(  tmaskz(ji  ,jj+1,jk)*tmaskz(ji-1,jj+1,jk) + tmaskz(ji+1,jj+1,jk)*tmaskz(ji  ,jj+1,jk)   &
                   + tmaskz(ji,  jj  ,jk)*tmaskz(ji-1,jj  ,jk) + tmaskz(ji+1,jj  ,jk)*tmaskz(ji  ,jj  ,jk) , 1.  )
              zphv = ( zsig0(ji  ,jj+1) - zsig0(ji-1,jj+1) ) * tmaskz(ji  ,jj+1,jk)*tmaskz(ji-1,jj+1,jk) / e1u(ji-1,jj+1)   &
                   + ( zsig0(ji+1,jj+1) - zsig0(ji  ,jj+1) ) * tmaskz(ji+1,jj+1,jk)*tmaskz(ji  ,jj+1,jk) / e1u(ji  ,jj+1)   &
                   + ( zsig0(ji  ,jj  ) - zsig0(ji-1,jj  ) ) * tmaskz(ji  ,jj  ,jk)*tmaskz(ji-1,jj  ,jk) / e1u(ji-1,jj  )   &
                   + ( zsig0(ji+1,jj  ) - zsig0(ji  ,jj  ) ) * tmaskz(ji+1,jj ,jk )*tmaskz(ji  ,jj  ,jk) / e1u(ji  ,jj  )
              zphv = (1. / rau0) * zphv * zmsv * vmaskz(ji,jj,jk)
              fcor = f0*SIN(rpi*gphiv(ji,jj)/180.0)
              vgeo(ji,jj,jk) = -grav*zphv/fcor*e3vz(ji,jj,jk)*zmask(2,ji,jj)
           ENDIF
        ENDDO  ! loop to next latitude
     ENDDO    ! loop to next longitude
  ENDDO       ! loop to next level

  ! Vertical shear-velocity: Remove vertical average
  vgeoz(:,:) = 0.0
  vgeosh(:,:,:)=0.0
  DO ji=1, npiglo
     DO jj = 1, npjglo
        ! Integrate vertically to get geostrophic velocity referenced  to bottom
        DO jk = npk-1,1,-1
           vgeo(ji,jj,jk) = vgeo(ji,jj,jk+1) + vgeo(ji,jj,jk)
        ENDDO
        ! Calculate vertical sum
        DO jk = 1, npk
           vgeoz(ji,jj) = vgeoz(ji,jj) + vgeo(ji,jj,jk)*zmask(2,ji,jj)*e3vz(ji,jj,jk)*vmaskz(ji,jj,jk)
        ENDDO
        ! Remove total depth to get vertical mean
        IF ( hdep(ji,jj) > 0.0 ) THEN
           vgeoz(ji,jj) = vgeoz(ji,jj)/hdep(ji,jj)
        ELSE
           vgeoz(ji,jj) = 0.0
        ENDIF
        ! Remove vertical mean from geostrophic velocity to get geostrophic vertical shear velocity.
        DO jk = 1, npk
           vgeosh(ji,jj,jk) = zmask(2,ji,jj)*vgeo(ji,jj,jk) - vgeoz(ji,jj)
        ENDDO
     ENDDO  ! loop to next latitude
  ENDDO    ! loop to next longitude
  ! Calculate vertical shear MHT - integrate over x
  dzomht_geos_full(:,:) = 0.0
  DO jk=1, npk 
     DO jj=1,npjglo
        DO ji=1,npiglo
           dzomht_geos_full(jj,jk) = dzomht_geos_full(jj,jk) + &
                & vmaskz(ji,jj,jk)*e1v(ji,jj)*e3vz(ji,jj,jk)*zmask(2,ji,jj)*vgeosh(ji,jj,jk)*tfull(ji,jj,jk)*rho0*rcp/1.e15
        END DO
     ENDDO
  ENDDO
  ! Integrate vertically the geostrophic MHT
  DO jk=npk , 1 , -1 
     dzomht_gsop(2,:) = dzomht_gsop(2,:) + dzomht_geos_full(:,jk)
  END DO  ! loop to next level

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! CALCUL OF THE AGEOSTROPHIC MHT
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  vageosh(:,:,:)=0.0
  ! Calculate Vageostrophique au point V
  DO jk=1,npk
     vageosh(:,:,jk)=vfull(:,:,jk)-vgeosh(:,:,jk)-vbt(:,:)
  END DO

  ! Calculate vertical shear ageostrophique streamfunction - integrate over x
  dzomht_ageos_full(:,:) = 0.0
  DO jk=1, npk 
     DO jj=1,npjglo
        DO ji=1,npiglo
           dzomht_ageos_full(jj,jk) = dzomht_ageos_full(jj,jk) + vmaskz(ji,jj,jk)*e1v(ji,jj)*e3vz(ji,jj,jk)*zmask(2,ji,jj)*vageosh(ji,jj,jk)*tfull(ji,jj,jk)*rho0*rcp/1.e15
        END DO
     ENDDO
  ENDDO

  ! Now Integrate vertically to get streamfunction AGEOSTROPHIE
  DO jk=npk , 1 , -1 
     dzomht_gsop(3,:) = dzomht_gsop(3,:) + dzomht_ageos_full(:,jk)
  END DO  ! loop to next level

  jj = 190
  FIND26: DO jj=1,npjglo
     IF ( rlat(1,jj) > 26.0 ) EXIT FIND26
  ENDDO FIND26
  PRINT *, 'MHT:dzomht_gsop(4,jj) = ', dzomht_gsop(4,jj)
  PRINT *, 'BT:dzomht_gsop(1,jj) = ', dzomht_gsop(1,jj)
  PRINT *, 'SH:dzomht_gsop(2,jj) = ', dzomht_gsop(2,jj)
  PRINT *, 'AG:dzomht_gsop(3,jj) = ', dzomht_gsop(3,jj)

  !---------------------------------
  ! netcdf output 
  !---------------------------------

  !print *, 'Writing netcdf...'
  DO jgsop = 1, jpgsop
     ierr = putvar (ncout, id_varout_gsop(jgsop),REAL(dzomht_gsop(jgsop,:)), 1,1,npjglo)
  ENDDO

  ierr = closeout(ncout)

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    ipk_gsop(:) = npk

    stypvar(1)%cname= 'zobtmhta'
    stypvar(1)%cunits='PetaWatt'
    stypvar(1)%rmissing_value=99999.
    stypvar(1)%valid_min= -1000.
    stypvar(1)%valid_max= 1000.
    stypvar(1)%scale_factor= 1.
    stypvar(1)%add_offset= 0.
    stypvar(1)%savelog10= 0.
    stypvar(1)%clong_name='Barotropic_Merid_HeatTransport'
    stypvar(1)%cshort_name='zobtmhta'
    stypvar(1)%conline_operation='N/A'
    stypvar(1)%caxis='TY'

    stypvar(2)%cname= 'zoshmhta'
    stypvar(2)%cunits='PetaWatt'
    stypvar(2)%rmissing_value=99999.
    stypvar(2)%valid_min= -1000.
    stypvar(2)%valid_max= 1000.
    stypvar(2)%scale_factor= 1.
    stypvar(2)%add_offset= 0.
    stypvar(2)%savelog10= 0.
    stypvar(2)%clong_name='GeoShear_Merid_HeatTransport'
    stypvar(2)%cshort_name='zoshmhta'
    stypvar(2)%conline_operation='N/A'
    stypvar(2)%caxis='TY'

    stypvar(3)%cname= 'zoagmhta'
    stypvar(3)%cunits='PetaWatt'
    stypvar(3)%rmissing_value=99999.
    stypvar(3)%valid_min= -1000.
    stypvar(3)%valid_max= 1000.
    stypvar(3)%scale_factor= 1.
    stypvar(3)%add_offset= 0.
    stypvar(3)%savelog10= 0.
    stypvar(3)%clong_name='Ageo_Merid_HeatTransport'
    stypvar(3)%cshort_name='zoagmhta'
    stypvar(3)%conline_operation='N/A'
    stypvar(3)%caxis='TY'

    stypvar(4)%cname= 'zomhtatl'
    stypvar(4)%cunits='PetaWatt'
    stypvar(4)%rmissing_value=99999.
    stypvar(4)%valid_min= -1000.
    stypvar(4)%valid_max= 1000.
    stypvar(4)%scale_factor= 1.
    stypvar(4)%add_offset= 0.
    stypvar(4)%savelog10= 0.
    stypvar(4)%clong_name='Meridional_HeatTransport_Atlantic'
    stypvar(4)%cshort_name='zomhtatl'
    stypvar(4)%conline_operation='N/A'
    stypvar(4)%caxis='TY'

    ! create output fileset
    ncout = create(cf_out, cf_vfil,1,npjglo,1,cdep=cn_vdepthw)
    ierr  = createvar(ncout ,stypvar,jpgsop, ipk_gsop,id_varout_gsop )
    ierr  = putheadervar(ncout, cf_vfil,1, npjglo,1,pnavlon=rlon,pnavlat=rlat,pdep=gdepw)
    dtim  = getvar1d(cf_vfil,cn_vtimec,npt)
    ierr  = putvar1d(ncout,dtim,npt,'T')

  END SUBROUTINE CreateOutput

END PROGRAM cdfmht_gsop

PROGRAM cdfcofpoint
  !!-------------------------------------------------------------------
  !!               ***  PROGRAM cdfmean  ***
  !!
  !!  **  Purpose  :  Compute distance of first coast in grid point
  !!                  Determine the edge of a mask (for further use
  !!                  with iceshelf parametrization)
  !!  
  !!  **  Method   :  long iterative method (check furtehr time all mask point)
  !!
  !!
  !! history ;
  !!  Original :  P. Mathiot (June, 2009)
  !!-------------------------------------------------------------------
  !! * Modules used
  USE cdfio
  !! * Local variables
  IMPLICIT NONE
  INTEGER   :: npiglo, npjglo, npk, nt, npi, npj      !: size of the domain
  INTEGER   :: ji, jj, jk, jt, i
  INTEGER   :: imin=0, imax=0, jmin=0, jmax=0      !: domain limitation for computation
  INTEGER   :: kmin=0, kmax=0                      !: domain limitation for computation
  INTEGER   :: narg, iargc                         !: command line 


  REAL(KIND=4), DIMENSION (:,:),   ALLOCATABLE ::  zmask, mask, mask_out  !: npiglo x npjglo

  CHARACTER(LEN=256) :: cfile, cldum
  CHARACTER(LEN=256) :: cmask='mask.nc'

  ! output stuff
  INTEGER, DIMENSION(1) :: ipk, id_varout
  TYPE(variable), DIMENSION(1) :: stypvar
  REAL(KIND=4) ,DIMENSION(1)                  :: timean
  CHARACTER(LEN=256) :: cfileout='pointcoast.nc'
  INTEGER :: ncout, ierr

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' Usage : cdfmean  filemask [imin imax jmin jmax kmin kmax] '
     PRINT *,' imin imax jmin jmax kmin kmax can be given in option '
     PRINT *,'    if imin = 0 then ALL i are taken'
     PRINT *,'    if jmin = 0 then ALL j are taken'
     PRINT *,'    if kmin = 0 then ALL k are taken'
     PRINT *,'    output file is pointcoast.nc    '
     STOP
  ENDIF

  CALL getarg (1, cfile)

  npi= getdim (cfile,'x')
  npj= getdim (cfile,'y')
  npk   = getdim (cfile,'depth')
  nt    = getdim (cfile,'time')
  
  imin=1; jmin=1; jmax=npj; imax=npi

  IF (narg > 3 ) THEN
    IF ( narg /= 5 ) THEN
       PRINT *, ' ERROR : You must give 6 optional values (imin imax jmin jmax kmin kmax)'
       STOP 99
    ELSE
    ! input optional imin imax jmin jmax
      CALL getarg ( 2,cldum) ; READ(cldum,*) imin
      CALL getarg ( 3,cldum) ; READ(cldum,*) imax
      CALL getarg ( 4,cldum) ; READ(cldum,*) jmin
      CALL getarg ( 5,cldum) ; READ(cldum,*) jmax
    ENDIF
  ENDIF

  IF (npk == 0  ) THEN ; npk = 1              ; ENDIF  ! no depth dimension ==> 1 level
  IF (imin /= 0 ) THEN ; npiglo=imax -imin + 1;  ELSE ; imin=1 ; ENDIF
  IF (jmin /= 0 ) THEN ; npjglo=jmax -jmin + 1;  ELSE ; jmin=1 ; ENDIF
  IF (kmin /= 0 ) THEN ; npk   =kmax -kmin + 1;  ELSE ; kmin=1 ; ENDIF

  WRITE(6, *) 'npiglo=', npiglo
  WRITE(6, *) 'npjglo=', npjglo
  WRITE(6, *) 'npi   =', npi
  WRITE(6, *) 'npj   =', npj
  WRITE (6,*) 'npk   =', npk
  WRITE (6,*) 'nt    =', nt
  
  ! Allocate arrays
  ALLOCATE ( zmask(npi,npj), mask_out(npi,npj), mask(npi,npj) )
  mask_out(:,:)=0
  mask(:,:)= getvar(cfile, 'tmask',  1 ,npi,npj)
  i=0
  DO WHILE ( SUM(mask(imin+1:imax-1,jmin+1:jmax-1)) .NE. 0 )
     i=i+1
     zmask=0
     IF (MOD(i,10)==0) PRINT *, 'i = ',i, ' SUM(mask) = ',SUM(mask(imin+1:imax-1,jmin+1:jmax-1)) 
     DO ji=imin+1,imax-1
        DO jj=jmin+1,jmax-1
           IF ((mask(ji,jj)==0) .AND. (mask_out(ji,jj)==i-1)) THEN
              IF (mask(ji+1,jj  )==1) zmask(ji+1,jj  )=1
              IF (mask(ji  ,jj-1)==1) zmask(ji  ,jj-1)=1
              IF (mask(ji-1,jj  )==1) zmask(ji-1,jj  )=1
              IF (mask(ji  ,jj+1)==1) zmask(ji  ,jj+1)=1
           END IF
        END DO
     END DO
     WHERE (zmask==1) mask=0
     WHERE (zmask==1) mask_out=i
  END DO
        
  ! prepare file output
  ipk(1) = 1
  stypvar(1)%cname='pointcoast'
  stypvar(1)%cunits='px'
  stypvar(1)%rmissing_value=0
  stypvar(1)%valid_min= 1.
  stypvar(1)%valid_max= i
  stypvar(1)%clong_name='pointcoast'
  stypvar(1)%cshort_name='pointcoast'
  stypvar(1)%conline_operation='N/A'
  stypvar(1)%caxis='TZYX'
  stypvar(1)%cprecision='r4'
  PRINT *,' CREATE ...'
  ncout=create(cfileout, cfile,npi,npj,1)

  PRINT *,' CREATEVAR ...'
  ierr= createvar(ncout ,stypvar,1, ipk,id_varout )
  PRINT *,' PUTHEADERVAR ...'
  ierr= putheadervar(ncout, cfile, npi,npj,npk)
  ierr=putvar(ncout,id_varout(1),mask_out,1,npi,npj)
  timean(:)=0.
  ierr=putvar1d(ncout,timean,1,'T')
  ierr = closeout(ncout)

END PROGRAM cdfcofpoint

PROGRAM cdffindij
  !!======================================================================
  !!                     ***  PROGRAM  cdffindij  ***
  !!=====================================================================
  !!  ** Purpose : Return the window index (imin imax jmin jmax )
  !!               for the geographical windows given on input 
  !!               (longmin longmax latmin matmax)
  !!
  !!  ** Method  : Read the coordinate/mesh_hgr file and look for the glam,
  !!               gphi variables.
  !!               Then use a search algorithm to find the corresponding I J
  !!               The point type ( T U V F ) is specified on the command 
  !!               line as well as the name of the coordinate/mesh hgr file.
  !!
  !! History : 2.1  : 11/2005  : J.M. Molines : Original code
  !!           3.0  : 12/2010  : J.M. Molines : Doctor norm + Lic.
  !!           3.0  : 02/2016  : J.M. Molines : add -f, -d, -o options
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE cdftools
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class file_informations
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)    :: ji                         ! dummy loop index
  INTEGER(KIND=4)    :: narg, iargc                ! command line
  INTEGER(KIND=4)    :: ijarg                      ! command line
  INTEGER(KIND=4)    :: iimin, iimax, ijmin, ijmax ! model grid window
  INTEGER(KIND=4)    :: inum=10, iout=6            ! logical unit of assci files
  INTEGER(KIND=4)    :: nfields                    ! number of fields in file_list
  INTEGER(KIND=4)    :: ipx, ipy                   ! field number for X and Y in file_list

  REAL(KIND=4)       :: xmin, xmax, ymin, ymax     ! geographical window
  REAL(KIND=4)       :: zlon, zlat                 ! position of model point

  CHARACTER(LEN=256) :: cltype='F'                 ! point type to search for
  CHARACTER(LEN=256) :: cldum                      ! dummy character variable
  CHARACTER(LEN=256) :: clcoo                      ! dummy character variable
  CHARACTER(LEN=256) :: cf_list                    ! list_file name
  CHARACTER(LEN=256) :: cf_out                     ! output file name
  CHARACTER(LEN=256) :: cldes='XY'                 ! descriptor for input file
  CHARACTER(LEN=50), DIMENSION(:), ALLOCATABLE :: cfields ! string array to receive
                                                   ! fields of the list_file

  LOGICAL            :: l_file_in=.false.          ! flag for input file
  LOGICAL            :: l_file_ou=.false.          ! flag for output file
  LOGICAL            :: l_append =.false.          ! flag for appending x,y to existing data on line
  LOGICAL            :: l_lonlat =.false.          ! flag for adding lon lat to the output
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()
  clcoo = cn_fcoo

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage :   cdffindij  -w xmin xmax ymin ymax  [-c COOR-file] [-p C-type]...'
     PRINT *,'                 ... [-f LST-file] [-d descriptor] [-o OUT-file] [-A] [-l]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Return the model limit (i,j space) of the geographical window given on' 
     PRINT *,'       the input line. If using -f list_file option, then the output is just'
     PRINT *,'       a single point, not a window, and there are no need to define the '
     PRINT *,'       window with -w.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -w xmin xmax ymin ymax : geographical limits of the window, in lon/lat' 
     PRINT *,'       (relevant only if -f option not used.)'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-c COOR-file ] : specify a particular coordinate file' 
     PRINT *,'                     default is ',TRIM(cn_fcoo)
     PRINT *,'       [-p C-type] : specify the point on the C-grid (T U V F). Default is ',TRIM(cltype),'.'
     PRINT *,'       [-f LST-file ] : LST-file is an ascii file describing the location'
     PRINT *,'                (one per line) of geographical points to be translated to '
     PRINT *,'                model (i,j) point. Unless specified with -d option, this list'
     PRINT *,'                file contains Longitude (X) Latitudes (Y) information.'
     PRINT *,'       [-d descriptor] : descriptor is a string indicating the position of'
     PRINT *,'                X and Y coordinates for the lines of list_file. Default value'
     PRINT *,'                of the descriptor is ''XY''. Any other field on the line is '
     PRINT *,'                indicated with any characterm except X or Y. Example of valid'
     PRINT *,'                descriptor : ''oXYooo'' or ''ooYabcdfXooo'' '
     PRINT *,'       [-A  ] : With this option, output is similar to input with I,J appended'
     PRINT *,'                to the corresponding line.'
     PRINT *,'       [-l  ] : With this option, also output the exact model longitude and '
     PRINT *,'                latitude of the I,J point.'
     PRINT *,'       [-o OUT-file]: write output in text OUT-file instead of standard output.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ', TRIM(cn_fcoo),' or the specified coordinates file.' 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       Output is done on standard output.'
     PRINT *,'      '
     PRINT *,'     SEE ALSO : '
     PRINT *,'       cdfwhereij'
     PRINT *,'      '
     STOP 
  ENDIF

  ijarg = 1 
  DO WHILE ( ijarg <= narg ) 
     CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-w' ) ; CALL getarg(ijarg, cldum  ) ; ijarg=ijarg+1 ; READ(cldum,*) xmin
        ;            CALL getarg(ijarg, cldum  ) ; ijarg=ijarg+1 ; READ(cldum,*) xmax
        ;            CALL getarg(ijarg, cldum  ) ; ijarg=ijarg+1 ; READ(cldum,*) ymin
        ;            CALL getarg(ijarg, cldum  ) ; ijarg=ijarg+1 ; READ(cldum,*) ymax
     CASE ( '-c' ) ; CALL getarg(ijarg, clcoo  ) ; ijarg=ijarg+1
     CASE ( '-p' ) ; CALL getarg(ijarg, cltype ) ; ijarg=ijarg+1
     CASE ( '-f' ) ; CALL getarg(ijarg, cf_list) ; ijarg=ijarg+1 ;  l_file_in=.true.
     CASE ( '-d' ) ; CALL getarg(ijarg, cldes  ) ; ijarg=ijarg+1
     CASE ( '-o' ) ; CALL getarg(ijarg, cf_out ) ; ijarg=ijarg+1 ;  l_file_ou=.true.
     CASE ( '-A' ) ;                                                l_append =.true.
     CASE ( '-l' ) ;                                                l_lonlat =.true.
     CASE DEFAULT  ; PRINT *,' ERROR : ',TRIM(cldum),' unknown option.' ; STOP 99
     END SELECT
  END DO

  IF ( l_file_in) THEN
     ! interpret descriptor
     nfields = LEN(TRIM(cldes) )
     ipx     = INDEX(TRIM(cldes),'X')
     ipy     = INDEX(TRIM(cldes),'Y')
     ALLOCATE( cfields(nfields))

     ! open list_file and loop over lines
     OPEN(inum, FILE=cf_list)
     IF ( l_file_ou ) OPEN(iout, FILE=cf_out)
     DO 
        READ(inum,*,END=999) cfields
        READ(cfields(ipx),*) xmin
        READ(cfields(ipy),*) ymin
        CALL cdf_findij ( xmin, xmin, ymin, ymin, iimin, iimax, ijmin, ijmax, cd_coord=clcoo, & 
             &cd_point=cltype, cd_verbose='n', plonmin=zlon, platmin=zlat)
        IF ( l_append ) THEN
           DO ji = 1, nfields
              WRITE(iout,'(a,x)',advance="no") TRIM(cfields(ji))
           ENDDO
        ENDIF
        IF ( l_lonlat ) THEN
           WRITE(iout,'(g20.9,x)',advance="no")  zlon
           WRITE(iout,'(g20.9,x)',advance="no")  zlat
        ENDIF
        WRITE(iout,'(i10,x)',advance="no") iimin
        WRITE(iout,'(i10,x)'             ) ijmin
     ENDDO
999  CONTINUE

  ELSE
     CALL cdf_findij ( xmin, xmax, ymin, ymax, iimin, iimax, ijmin, ijmax, cd_coord=clcoo, cd_point=cltype, cd_verbose='y')
  ENDIF

END PROGRAM cdffindij

PROGRAM cdfmoy
  !!======================================================================
  !!                     ***  PROGRAM  cdfmoy  ***
  !!=====================================================================
  !!  ** Purpose : Compute mean values for all the variables in a bunch
  !!               of cdf files given as argument
  !!               Store the results on a 'similar' cdf file.
  !!
  !!  ** Method  : Also store the mean squared values for the nn_sqdvar
  !!               variables belonging to cn_sqdvar(:), than can be changed 
  !!               in the nam_cdf_names namelist if wished.
  !!               Optionally order 3 moments for some variables can be
  !!               computed.
  !!
  !! History : 2.0  : 11/2004  : J.M. Molines : Original code
  !!         : 2.1  : 06/2007  : P. Mathiot   : Modif for forcing fields
  !!           3.0  : 12/2010  : J.M. Molines : Doctor norm + Lic.
  !!                  04/2015  : S. Leroux    : add nomissincl option
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  !!   routines      : description
  !!   varchk2       : check if variable is candidate for square mean
  !!   varchk3       : check if variable is candidate for cubic mean
  !!   zeromean      : substract mean value from input field
  !!----------------------------------------------------------------------
  USE cdfio 
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class time_averaging
  !!-----------------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                               :: jk, jfil,jdep      ! dummy loop index
  INTEGER(KIND=4)                               :: jvar, jv, jt       ! dummy loop index
  INTEGER(KIND=4)                               :: ierr               ! working integer
  INTEGER(KIND=4)                               :: idep, idep_max     ! possible depth index, maximum
  INTEGER(KIND=4)                               :: narg, iargc, ijarg ! browsing command line
  INTEGER(KIND=4)                               :: nfiles             ! number of files to average
  INTEGER(KIND=4)                               :: npiglo, npjglo     ! size of the domain
  INTEGER(KIND=4)                               :: npk, npt           ! size of the domain
  INTEGER(KIND=4)                               :: nvars              ! number of variables in a file
  INTEGER(KIND=4)                               :: ntframe            ! cumul of time frame
  INTEGER(KIND=4)                               :: ncout              ! ncid of output files
  INTEGER(KIND=4)                               :: ncout2             ! ncid of output files
  INTEGER(KIND=4)                               :: ncout3             ! ncid of output files
  INTEGER(KIND=4)                               :: ncout4             ! ncid of output files
  INTEGER(KIND=4)                               :: nperio=4           ! periodic flag
  INTEGER(KIND=4)                               :: iwght              ! weight of variable
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: id_var             ! arrays of var id's
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: ipk                ! arrays of vertical level for each var
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: ipk4               ! arrays of vertical level for min/max
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: id_varout          ! varid's of average vars
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: id_varout2         ! varid's of sqd average vars
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: id_varout3         ! varid's of cub average vars
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: id_varout4         ! varid's of cub average vars

  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: rmask2d            ![from SL]
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: v2d                ! array to read a layer of data
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: e3                 ! array to read vertical metrics
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: rmax               ! array for maximum value
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: rmin               ! array for minimum value
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: rmean              ! average
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: rmean2             ! squared average
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: rmean3             ! cubic average
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: zspval_in          ! time counter

  REAL(KIND=8), DIMENSION(1)                    :: dtimean            ! mean time
  REAL(KIND=8), DIMENSION(:),       ALLOCATABLE :: dtim               ! time counter
  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: dtab, dtab2        ! arrays for cumulated values
  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: dtab3              ! arrays for cumulated values
  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: de3s               ! arrays for cumulated e3 (vvl)
  REAL(KIND=8)                                  :: dtotal_time        ! to compute mean time

  CHARACTER(LEN=256)                            :: cf_in              ! input file names
  CHARACTER(LEN=256)                            :: cf_root = 'cdfmoy'     ! optional root of output files 
  CHARACTER(LEN=256)                            :: cf_out  = 'cdfmoy.nc'  ! output file for average
  CHARACTER(LEN=256)                            :: cf_out2 = 'cdfmoy2.nc' ! output file for squared average
  CHARACTER(LEN=256)                            :: cf_out3 = 'cdfmoy3.nc' ! output file for squared average
  CHARACTER(LEN=256)                            :: cf_out4 = 'cdfmoy_minmax.nc'  ! output file for min/max
  CHARACTER(LEN=256)                            :: cf_e3              ! file name for reading vertical metrics (vvl)
  CHARACTER(LEN=256)                            :: cv_single          ! name of the single variable to process ( -var option)
  CHARACTER(LEN=256)                            :: cv_dep             ! depth dimension name
  CHARACTER(LEN=256)                            :: cv_e3              ! name of e3t variable for vvl
  CHARACTER(LEN=256)                            :: cldum              ! dummy string argument
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cf_lst             ! list of input files
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_nam             ! array of var name
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_nam2            ! array of var2 name for output
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_nam3            ! array of var3 name for output
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_nam4            ! array of var3 name for output
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: clv_dep            ! array of possible depth name (or 3rd dimension)

  TYPE (variable), DIMENSION(:),    ALLOCATABLE :: stypvar            ! attributes for average values
  TYPE (variable), DIMENSION(:),    ALLOCATABLE :: stypvar2           ! attributes for square averaged values
  TYPE (variable), DIMENSION(:),    ALLOCATABLE :: stypvar3           ! attributes for cubic averaged values
  TYPE (variable), DIMENSION(:),    ALLOCATABLE :: stypvar4           ! attributes for min/max

  LOGICAL                                       :: lcaltmean          ! mean time computation flag
  LOGICAL                                       :: lspval0 = .FALSE.  ! cdfmoy_chsp flag
  LOGICAL                                       :: lcubic  = .FALSE.  ! 3rd momment computation
  LOGICAL                                       :: lzermean= .FALSE.  ! flag for zero-mean process
  LOGICAL                                       :: lmax    = .FALSE.  ! flag for min/max computation
  LOGICAL                                       :: lvar    = .FALSE.  ! fkag for single variable processing
  LOGICAL                                       :: lchk    = .FALSE.  ! flag for missing files
  LOGICAL                                       :: lnc4    = .FALSE.  ! flag for netcdf4 output
  LOGICAL                                       :: ll_vvl             ! working flag: vvl AND ipk(jvar) > 1
  LOGICAL                                       :: lmskmiss= .FALSE.  ! from SL] flag for excluding gridpoints where some values are missing
  !!----------------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfmoy -l LST-files [-spval0] [-cub] [-zeromean] [-max] [-mskmiss] ...'
     PRINT *,'            ... [-var VAR-name] [-vvl] [-o OUT-rootname] [-nc4]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the ''time average'' of a list of files given as arguments.' 
     PRINT *,'       The program assumes that all files in the list are of same type (shape,'
     PRINT *,'       variables,  etc...). Any file in the list may have many time frames,'
     PRINT *,'       they will be taken into account in the average.'
     PRINT *,'      '
     PRINT *,'       For some variables, the program also computes the time average of the'
     PRINT *,'       squared variables, which is used in other cdftools (cdfeke, cdfrmsssh,'
     PRINT *,'       cdfstdevw, cdfstddevts...). The actual variables selected for squared'
     PRINT *,'       average are :'
     PRINT '(10x,"- ",a)' , (TRIM(cn_sqdvar(jv)), jv=1, nn_sqdvar)
     PRINT *,'       This selection can be adapted with the nam_cdf_namelist process.'
     PRINT *,'       (See cdfnamelist -i for details).'
     PRINT *,'      '
     PRINT *,'       If you want to compute the average of already averaged files, consider'
     PRINT *,'       using cdfmoy_weighted instead, in order to take into account a '
     PRINT *,'       particular weight for each file in the list.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -l LST-files : A list of similar model output files, whose time average'
     PRINT *,'                      will be computed.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-spval0 ] : set missing_value attribute to 0 for all variables and'
     PRINT *,'               take care of the input missing_value. This option is usefull'
     PRINT *,'               if missing_values differ from files to files.'
     PRINT *,'       [-cub ] : use this option if you want to compute third order moments'
     PRINT *,'               for the eligible variables, which are at present :'
     PRINT '(17x,"- ",a)' , (TRIM(cn_cubvar(jv)), jv=1, nn_cubvar)
     PRINT *,'              This selection can be adapted with the nam_cdf_namelist process.'
     PRINT *,'              (See cdfnamelist -i for details).'
     PRINT *,'       [-zeromean ] : with this option, the spatial mean value for each time'
     PRINT *,'              frame is substracted from the original field before averaging,'
     PRINT *,'              square averaging and eventually cubic averaging.'
     PRINT *,'       [-max ] : with this option, a file with the minimum and maximum values'
     PRINT *,'              of the variables (through the list of files) is created.'
     PRINT *,'       [-mskmiss ] : with this option, the output average is set to missing' 
     PRINT *,'              value at any gridpoint where the variable contains a  missing'
     PRINT *,'              value for at least one timestep. You should combine with option'
     PRINT *,'              -spval0 if missing values are not 0 in all the input files.'
     PRINT *,'       [-var VAR-name] : Only process VAR-name, instead of all variables.'
     PRINT *,'       [-vvl ] : take into account the time varying vertical scale factor.'
     PRINT *,'       [-o OUT-rootname] : Define output root-name instead of ', TRIM(cf_root) 
     PRINT *,'       [-nc4 ]: Use netcdf4 output with chunking and deflation level 1..'
     PRINT *,'              This option is effective only if cdftools are compiled with'
     PRINT *,'              a netcdf library supporting chunking and deflation.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       If -zeromean option is used, need ', TRIM(cn_fhgr),' and ',TRIM(cn_fmsk)
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out),' and ',TRIM(cf_out2)
     PRINT *,'       Variables name are the same than in the input files. '
     PRINT *,'       For squared averages ''_sqd'' is appended to the original variable name.'
     PRINT *,'       If -cub option is used, the file ', TRIM(cf_out3),' is also created with'
     PRINT *,'       ''_cub'' appended to the original variable name.'
     PRINT *,'       If -max option is used, the file ',TRIM(cf_out4),' is also created with '
     PRINT *,'       ''_max'' and ''_min'' appended to the original variable name.'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'       cdfmoy_weighted, cdfstdev'
     PRINT *,'      '
     STOP 
  ENDIF

  ijarg = 1 
  DO WHILE ( ijarg <= narg )
     CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1
     SELECT CASE ( cldum )
     CASE ( '-l'        ) ; CALL GetFileList
        ! options
     CASE ( '-spval0'   ) ; lspval0  = .TRUE.
     CASE ( '-cub'      ) ; lcubic   = .TRUE.
     CASE ( '-zeromean' ) ; lzermean = .TRUE.
     CASE ( '-max'      ) ; lmax     = .TRUE.
     CASE ( '-mskmiss'  ) ; lmskmiss = .TRUE.  
     CASE ( '-var'      ) ; lvar     = .TRUE.  
        ;                   CALL getarg (ijarg, cv_single) ; ijarg = ijarg + 1
     CASE ( '-vvl'      ) ; lg_vvl   = .TRUE.
     CASE ( '-o'        ) ; CALL getarg (ijarg, cf_root  ) ; ijarg = ijarg + 1
     CASE ( '-nc4'      ) ; lnc4     = .TRUE.
     CASE DEFAULT         ; PRINT *,' ERROR : ',TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  END DO

  cf_out=TRIM(cf_root )//'.nc'
  cf_out2=TRIM(cf_root)//'2.nc'
  cf_out3=TRIM(cf_root)//'3.nc'
  cf_out4=TRIM(cf_root)//'_minmax.nc'

  IF ( lzermean ) THEN
     lchk = lchk .OR. chkfile ( cn_fhgr )
     lchk = lchk .OR. chkfile ( cn_fmsk )
     IF ( lchk ) STOP 99 ! missing files
  ENDIF

  ! Initialisation from  1rst file (all file are assume to have the same geometry)
  ! time counter can be different for each file in the list. It is read in the
  ! loop for files

  cf_in = cf_lst(1)
  IF ( chkfile (cf_in) ) STOP 99 ! missing file
  !
  npiglo = getdim (cf_in, cn_x)
  npjglo = getdim (cf_in, cn_y)

  ! looking for npk among various possible name
  idep_max=8
  ALLOCATE ( clv_dep(idep_max) )
  clv_dep(:) = (/cn_z,'z','sigma','nav_lev','levels','ncatice','icbcla','icbsect'/)
  idep=1  ; ierr=1000
  DO WHILE ( ierr /= 0 .AND. idep <= idep_max )
     npk  = getdim (cf_in, clv_dep(idep), cdtrue=cv_dep, kstatus=ierr)
     idep = idep + 1
  ENDDO

  IF ( ierr /= 0 ) THEN  ! none of the dim name was found
     PRINT *,' assume file with no depth'
     npk=0
  ENDIF

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk , 'Dep name :' , TRIM(cv_dep)

  nvars = getnvar(cf_in)
  PRINT *,' nvars = ', nvars

  ALLOCATE(  dtab(npiglo,npjglo),   dtab2(npiglo,npjglo) )
  ALLOCATE(   v2d(npiglo,npjglo), rmask2d(npiglo,npjglo) )
  ALLOCATE( rmean(npiglo,npjglo),  rmean2(npiglo,npjglo) )
  IF ( lcubic ) ALLOCATE( dtab3(npiglo,npjglo), rmean3(npiglo,npjglo) )
  IF ( lg_vvl ) ALLOCATE(  de3s(npiglo,npjglo),     e3(npiglo,npjglo) )
  IF ( lmax   ) ALLOCATE (rmin(npiglo, npjglo),   rmax(npiglo,npjglo) )
  ALLOCATE (    cv_nam(nvars),    cv_nam2(nvars) )
  ALLOCATE (   stypvar(nvars),   stypvar2(nvars) )
  ALLOCATE (    id_var(nvars),        ipk(nvars) )
  ALLOCATE ( id_varout(nvars), id_varout2(nvars) )
  IF ( lcubic ) ALLOCATE (                cv_nam3(  nvars), stypvar3(  nvars), id_varout3(  nvars)  )
  IF ( lmax   ) ALLOCATE ( ipk4(2*nvars), cv_nam4(2*nvars), stypvar4(2*nvars), id_varout4(2*nvars)  )

  ! Prepare output files
  CALL CreateOutput

  ! for vvl, look for e3x variable in the file
  cv_e3 = 'none'
  IF ( lg_vvl ) THEN
     DO jvar = 1, nvars
        ! in case of CMIP6 names, cn_ve3tvvl is identical for U v W grid ... so far ! CAUTION if changed !
        IF ( INDEX(cv_nam(jvar), 'e3') /= 0  .OR. INDEX(cv_nam(jvar), cn_ve3tvvl) /= 0 ) THEN
           cv_e3=cv_nam(jvar)
           EXIT
        ENDIF
     ENDDO
     PRINT *, " -vvl option. Found e3 variable :",TRIM(cv_e3)
  ENDIF

  lcaltmean=.TRUE.
  DO jvar = 1,nvars
     ! JMM vvl note : we suppose that 2D fields are not weighted averaged ( Questionable ? )
     ll_vvl = lg_vvl .AND.  (ipk(jvar) > 1)  .AND.  (cv_nam(jvar) ) /= cv_e3 
     iwght=0
     IF ( cv_nam(jvar) == cn_vlon2d .OR. &     ! nav_lon
          cv_nam(jvar) == cn_vlat2d .OR. &     ! nav_lon
          cv_nam(jvar) == 'none'    ) THEN     ! nav_lat
        ! skip these variable
     ELSE
        PRINT *,' Working with ', TRIM(cv_nam(jvar)), ipk(jvar), 'vvl: ',ll_vvl
          DO jk = 1, ipk(jvar)
           PRINT *,'level ',jk
           dtab(:,:) = 0.d0 ; dtab2(:,:) = 0.d0 ; dtotal_time = 0.
           rmask2d(:,:) = 1.
           IF ( lcubic ) THEN  ; dtab3(:,:) = 0.d0                       ;
           ENDIF
           IF ( lmax   ) THEN  ; rmin (:,:) = 1.e20 ; rmax(:,:) = -1.e20 ;
           ENDIF
           IF ( ll_vvl ) THEN  ; de3s(:,:)  = 0.d0                       ;
           ENDIF
           ntframe = 0
           DO jfil = 1, nfiles
              cf_in = cf_lst(jfil)
              IF ( ll_vvl ) THEN ! work with weighted average in case of vvl
                 cf_e3=cf_in
              ENDIF
              IF ( jk == 1 ) THEN
                 IF ( chkfile (cf_in) ) STOP 99 ! missing file
                 iwght=iwght+MAX(1,INT(getatt( cf_in, cv_nam(jvar), 'iweight')))
              ENDIF

              npt = getdim (cf_in, cn_t)
              IF ( lcaltmean )  THEN
                 ALLOCATE ( dtim(npt) )
                 dtim        = getvar1d(cf_in, cn_vtimec, npt)
                 dtotal_time = dtotal_time + SUM(dtim(:))
                 DEALLOCATE (dtim )
              END IF
              DO jt=1,npt
                 ntframe = ntframe + 1
                 IF ( ll_vvl ) THEN
                    e3(:,:)   = getvar (cf_e3, cv_e3, jk ,npiglo, npjglo,ktime=jt )
                    de3s(:,:) = de3s(:,:) + e3(:,:)  ! cumulate e3
                 ENDIF
                 v2d(:,:)  = getvar(cf_in, cv_nam(jvar), jk ,npiglo, npjglo,ktime=jt )
                 IF ( lspval0  )  WHERE (v2d == zspval_in(jvar))  v2d = 0.  ! change missing values to 0

                 WHERE (v2d == 0.) rmask2d = 0.                              ! [from SL]
                 IF ( lzermean ) CALL zeromean (jk, v2d )

                 IF ( ll_vvl ) THEN ; dtab(:,:) = dtab(:,:) + e3(:,:) * v2d(:,:)*1.d0
                 ELSE               ; dtab(:,:) = dtab(:,:) + v2d(:,:)          *1.d0
                 ENDIF

                 IF (cv_nam2(jvar) /= 'none'    ) dtab2(:,:) = dtab2(:,:) + v2d(:,:)*v2d(:,: )         *1.d0
                 IF ( lcubic ) THEN
                    IF (cv_nam3(jvar) /= 'none' ) dtab3(:,:) = dtab3(:,:) + v2d(:,:)*v2d(:,:)*v2d(:,:) *1.d0
                 ENDIF
                 IF ( lmax ) THEN
                    rmax(:,:) = MAX(v2d(:,:),rmax(:,:))
                    rmin(:,:) = MIN(v2d(:,:),rmin(:,:))
                 ENDIF
              ENDDO
           END DO
           ! finish with level jk ; compute mean (assume spval is 0 )
           IF ( ll_vvl ) THEN 
              rmean(:,:)=0.
              WHERE ( de3s (:,:) /= 0.d0 ) rmean(:,:) = dtab(:,:)/de3s(:,:)
           ELSE                          ; rmean(:,:) = dtab(:,:)/ntframe
           ENDIF

           IF ( lmskmiss ) rmean(:,:) = rmean(:,:)*(rmask2d(:,:)*1.d0)

           IF (cv_nam2(jvar) /= 'none' ) THEN
              rmean2(:,:) = dtab2(:,:)/ntframe
              IF ( lmskmiss ) rmean2(:,:) = rmean2(:,:)*(rmask2d(:,:)*1.d0)
           ENDIF

           IF ( lcubic ) THEN
              IF (cv_nam3(jvar) /= 'none' ) THEN 
                 rmean3(:,:) = dtab3(:,:)/ntframe
                 IF ( lmskmiss ) rmean3(:,:) = rmean3(:,:)*(rmask2d(:,:)*1.d0)
              ENDIF
           ENDIF

           ! store variable on outputfile
           ierr = putvar(ncout, id_varout(jvar), rmean, jk, npiglo, npjglo, kwght=iwght)
           IF (cv_nam2(jvar) /= 'none' ) THEN 
              ierr = putvar(ncout2, id_varout2(jvar), rmean2, jk, npiglo, npjglo, kwght=iwght)
           ENDIF

           IF ( lcubic) THEN
              IF (cv_nam3(jvar) /= 'none' ) THEN 
                 ierr = putvar(ncout3, id_varout3(jvar), rmean3, jk, npiglo, npjglo, kwght=iwght)
              ENDIF
           ENDIF

           IF ( lmax  ) THEN
              ierr = putvar(ncout4, id_varout4(      jvar), rmax, jk, npiglo, npjglo, kwght=iwght)
              ierr = putvar(ncout4, id_varout4(nvars+jvar), rmin, jk, npiglo, npjglo, kwght=iwght)
           ENDIF

           IF (lcaltmean )  THEN
              dtimean(1) = dtotal_time/ntframe
              ierr = putvar1d(ncout,  dtimean, 1, 'T')
              ierr = putvar1d(ncout2, dtimean, 1, 'T')
              IF (lcubic) ierr = putvar1d(ncout3, dtimean, 1, 'T')
              IF (lmax  ) ierr = putvar1d(ncout4, dtimean, 1, 'T')
           END IF

           lcaltmean=.FALSE. ! tmean already computed
        END DO  ! loop to next level
     END IF
  END DO ! loop to next var in file

  ierr = closeout(ncout )
  ierr = closeout(ncout2)
  IF ( lcubic ) ierr = closeout(ncout3) 
  IF ( lmax   ) ierr = closeout(ncout4) 

CONTAINS 

  LOGICAL FUNCTION varchk2 ( cd_var ) 
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION varchk2  ***
    !!
    !! ** Purpose : Return true if cd_var is candidate for mean squared value  
    !!
    !! ** Method  : List of candidate is established in modcdfnames, and
    !!              can be changed via the nam_cdf_names namelist   
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*), INTENT(in) :: cd_var

    INTEGER(KIND=4)              :: jv
    !!----------------------------------------------------------------------
    varchk2 = .FALSE.
    DO jv = 1, nn_sqdvar 
       IF ( cd_var == cn_sqdvar(jv) ) THEN
          varchk2 = .TRUE.
          EXIT
       ENDIF
    ENDDO

  END FUNCTION varchk2

  LOGICAL FUNCTION varchk3 ( cd_var )
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION varchk3  ***
    !!
    !! ** Purpose : Return true if cd_var is candidate for cubic mean average
    !!
    !! ** Method  : List of candidate is established in modcdfnames, and
    !!              can be changed via the nam_cdf_names namelist
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*), INTENT(in) :: cd_var

    INTEGER(KIND=4)              :: jv
    !!----------------------------------------------------------------------
    varchk3 = .FALSE.
    DO jv = 1, nn_cubvar
       IF ( cd_var == cn_cubvar(jv) ) THEN
          varchk3 = .TRUE.
          EXIT
       ENDIF
    ENDDO

  END FUNCTION varchk3

  SUBROUTINE zeromean(kk, ptab)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE zeromean  ***
    !!
    !! ** Purpose :  Compute the spatial average of argument and
    !!               and substract it from the field 
    !!
    !! ** Method  :  requires the horizontal metrics 
    !!
    !!----------------------------------------------------------------------
    INTEGER(KIND=4),              INTENT(   in) :: kk
    REAL(KIND=4), DIMENSION(:,:), INTENT(inout) :: ptab

    REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE, SAVE :: ze2, ze1, tmask, tmask0

    REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE, SAVE :: dareas
    REAL(KIND=8),                              SAVE :: darea
    REAL(KIND=8)                                    :: dmean

    LOGICAL, SAVE                                   :: lfirst = .TRUE.
    !!----------------------------------------------------------------------

    IF (lfirst) THEN
       lfirst=.FALSE.
       ! read e1 e2 and tmask ( assuming this prog only deal with T-points)
       ALLOCATE ( ze1(npiglo, npjglo), ze2(npiglo,npjglo)       )
       ALLOCATE ( tmask(npiglo,npjglo), tmask0(npiglo,npjglo)   )
       ALLOCATE ( dareas(npiglo,npjglo)                         )

       ze1(:,:)     = getvar(cn_fhgr, cn_ve1t, 1, npiglo, npjglo)
       ze2(:,:)     = getvar(cn_fhgr, cn_ve2t, 1, npiglo, npjglo)
       dareas(:,:)  = ze1(:,:) * ze2(:,:) *1.d0
    ENDIF
    tmask0(:,:)  = getvar(cn_fmsk, cn_tmask, kk, npiglo, npjglo)
    tmask = tmask0
    tmask(1,:)=0 ; tmask(npiglo,:)=0 ; tmask(:,1) = 0.; tmask(:,npjglo) = 0 

    IF ( nperio == 3 .OR. nperio == 4 ) tmask(npiglo/2+1:npiglo,npjglo-1) = 0.

    darea = SUM( dareas * tmask )

    IF ( darea /= 0.d0 ) THEN ; dmean = SUM( ptab * dareas ) / darea
    ELSE                      ; dmean = 0.d0
    ENDIF

    WHERE ( ptab /= 0 )  ptab = ( ptab - dmean ) * tmask0

  END SUBROUTINE zeromean

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create Netcdf output files
    !!
    !! ** Method  :  Create files and define variables etc...
    !!
    !!----------------------------------------------------------------------

    ! get list of variable names and collect attributes in stypvar (optional)
    cv_nam(:) = getvarname(cf_in,nvars,stypvar)
    IF ( lvar ) THEN
       DO jv=1,nvars
          IF ( cv_nam(jv) /= cv_single ) cv_nam(jv)='none'
       ENDDO
    ENDIF


    ! choose chunk size for output ... not easy not used if lnc4=.false. but anyway ..
    DO jv = 1, nvars
       stypvar(jv)%ichunk=(/npiglo,MAX(1,npjglo/30),1,1 /)
       stypvar2(jv)%ichunk=(/npiglo,MAX(1,npjglo/30),1,1 /)
    ENDDO

    IF ( lspval0 ) THEN 
       ALLOCATE ( zspval_in(nvars) )
       zspval_in(:) = stypvar(:)%rmissing_value
       stypvar(:)%rmissing_value = 0.
    ENDIF

    IF ( lcubic) THEN
       ! force votemper to be squared saved
       nn_sqdvar = nn_sqdvar + 1
       cn_sqdvar(nn_sqdvar) = TRIM(cn_votemper)  
    ENDIF

    DO jvar = 1, nvars
       ! variables that will not be computed or stored are named 'none'
       IF (cv_nam(jvar) /= 'none' ) THEN
          IF ( varchk2 ( cv_nam(jvar) ) ) THEN 
             cv_nam2(jvar)                    = TRIM(cv_nam(jvar))//'_sqd'
             stypvar2(jvar)%cname             = TRIM(stypvar(jvar)%cname)//'_sqd'         ! name
             stypvar2(jvar)%cunits            = '('//TRIM(stypvar(jvar)%cunits)//')^2'    ! unit
             stypvar2(jvar)%rmissing_value    = stypvar(jvar)%rmissing_value              ! missing_value
             stypvar2(jvar)%valid_min         = 0.                                        ! valid_min = zero
             stypvar2(jvar)%valid_max         = stypvar(jvar)%valid_max**2                ! valid_max *valid_max
             stypvar2(jvar)%scale_factor      = 1.
             stypvar2(jvar)%add_offset        = 0.
             stypvar2(jvar)%savelog10         = 0.
             stypvar2(jvar)%clong_name        = TRIM(stypvar(jvar)%clong_name)//'_Squared'  ! 
             stypvar2(jvar)%cshort_name       = TRIM(stypvar(jvar)%cshort_name)//'_sqd'     !
             stypvar2(jvar)%conline_operation = TRIM(stypvar(jvar)%conline_operation) 
             stypvar2(jvar)%caxis             = TRIM(stypvar(jvar)%caxis) 
          ELSE
             cv_nam2(jvar) = 'none'
          END IF

          ! check for cubic average
          IF ( lcubic ) THEN
             IF ( varchk3 ( cv_nam(jvar) ) ) THEN 
                cv_nam3(jvar)                    = TRIM(cv_nam(jvar))//'_cub'
                stypvar3(jvar)%cname             = TRIM(stypvar(jvar)%cname)//'_cub'         ! name
                stypvar3(jvar)%cunits            = '('//TRIM(stypvar(jvar)%cunits)//')^3'    ! unit
                stypvar3(jvar)%rmissing_value    = stypvar(jvar)%rmissing_value              ! missing_value
                stypvar3(jvar)%valid_min         = 0.                                        ! valid_min = zero
                stypvar3(jvar)%valid_max         = stypvar(jvar)%valid_max**3                ! valid_max *valid_max
                stypvar3(jvar)%scale_factor      = 1.
                stypvar3(jvar)%add_offset        = 0.
                stypvar3(jvar)%savelog10         = 0.
                stypvar3(jvar)%clong_name        = TRIM(stypvar(jvar)%clong_name)//'_Cubed'   ! 
                stypvar3(jvar)%cshort_name       = TRIM(stypvar(jvar)%cshort_name)//'_cub'    !
                stypvar3(jvar)%conline_operation = TRIM(stypvar(jvar)%conline_operation) 
                stypvar3(jvar)%caxis             = TRIM(stypvar(jvar)%caxis) 

                stypvar3(jvar)%ichunk=(/npiglo,MAX(1,npjglo/30),1,1 /)
             ELSE
                cv_nam3(jvar) = 'none'
             END IF
          ENDIF

          IF ( lmax ) THEN
             cv_nam4(jvar)                    = TRIM(cv_nam(jvar))//'_max'
             stypvar4(jvar)%cname             = TRIM(stypvar(jvar)%cname)//'_max'         ! name
             stypvar4(jvar)%cunits            = '('//TRIM(stypvar(jvar)%cunits)//')'      ! unit
             stypvar4(jvar)%rmissing_value    = stypvar(jvar)%rmissing_value              ! missing_value
             stypvar4(jvar)%valid_min         = 0.                                        ! valid_min = zero
             stypvar4(jvar)%valid_max         = stypvar(jvar)%valid_max                   ! valid_max *valid_max
             stypvar4(jvar)%scale_factor      = 1.
             stypvar4(jvar)%add_offset        = 0.
             stypvar4(jvar)%savelog10         = 0.
             stypvar4(jvar)%clong_name        = TRIM(stypvar(jvar)%clong_name)//'_max'   ! 
             stypvar4(jvar)%cshort_name       = TRIM(stypvar(jvar)%cshort_name)//'_max'  !
             stypvar4(jvar)%conline_operation = TRIM(stypvar(jvar)%conline_operation)
             stypvar4(jvar)%caxis             = TRIM(stypvar(jvar)%caxis)

             stypvar4(jvar)%ichunk=(/npiglo,MAX(1,npjglo/30),1,1 /)

             cv_nam4(nvars+jvar)                    = TRIM(cv_nam(jvar))//'_min'
             stypvar4(nvars+jvar)%cname             = TRIM(stypvar(jvar)%cname)//'_min'         ! name
             stypvar4(nvars+jvar)%cunits            = '('//TRIM(stypvar(jvar)%cunits)//')'      ! unit
             stypvar4(nvars+jvar)%rmissing_value    = stypvar(jvar)%rmissing_value              ! missing_value
             stypvar4(nvars+jvar)%valid_min         = 0.                                        ! valid_min = zero
             stypvar4(nvars+jvar)%valid_max         = stypvar(jvar)%valid_max                   ! valid_max *valid_max
             stypvar4(nvars+jvar)%scale_factor      = 1.
             stypvar4(nvars+jvar)%add_offset        = 0.
             stypvar4(nvars+jvar)%savelog10         = 0.
             stypvar4(nvars+jvar)%clong_name        = TRIM(stypvar(jvar)%clong_name)//'_min'   ! 
             stypvar4(nvars+jvar)%cshort_name       = TRIM(stypvar(jvar)%cshort_name)//'_min'  !
             stypvar4(nvars+jvar)%conline_operation = TRIM(stypvar(jvar)%conline_operation)
             stypvar4(nvars+jvar)%caxis             = TRIM(stypvar(jvar)%caxis)

             stypvar4(nvars+jvar)%ichunk=(/npiglo,MAX(1,npjglo/30),1,1 /)
          ENDIF

       ELSE
          cv_nam2(jvar)='none'
          IF (lcubic) cv_nam3(       jvar)='none'
          IF (lmax  ) cv_nam4(       jvar)='none'
          IF (lmax  ) cv_nam4(nvars+ jvar)='none'
       ENDIF
    END DO

    id_var(:)  = (/(jv, jv=1,nvars)/)
    ! ipk gives the number of level or 0 if not a T[Z]YX  variable
    ipk(:)     = getipk (cf_in,nvars,cdep=cv_dep)
    WHERE( ipk == 0 ) cv_nam='none'
    IF ( lmax ) THEN 
       ipk4(1      :nvars  ) = ipk(1:nvars)
       ipk4(nvars+1:2*nvars) = ipk(1:nvars)
       WHERE( ipk4 == 0 ) cv_nam4='none'
    ENDIF
    stypvar (:)%cname = cv_nam
    stypvar2(:)%cname = cv_nam2
    IF ( lcubic ) stypvar3(:)%cname = cv_nam3
    IF ( lmax   ) stypvar4(:)%cname = cv_nam4

    ! create output file taking the sizes in cf_in
    ncout  = create      (cf_out,  cf_in,    npiglo, npjglo, npk, cdep=cv_dep, ld_nc4=lnc4)
    ierr   = createvar   (ncout ,  stypvar,  nvars,  ipk,    id_varout       , ld_nc4=lnc4)
    ierr   = putheadervar(ncout,   cf_in,    npiglo, npjglo, npk, cdep=cv_dep      )

    ncout2 = create      (cf_out2, cf_in,    npiglo, npjglo, npk, cdep=cv_dep, ld_nc4=lnc4)
    ierr   = createvar   (ncout2,  stypvar2, nvars,  ipk,    id_varout2      , ld_nc4=lnc4)
    ierr   = putheadervar(ncout2,  cf_in,    npiglo, npjglo, npk, cdep=cv_dep      )

    IF ( lcubic) THEN
       ncout3 = create      (cf_out3, cf_in,    npiglo, npjglo, npk, cdep=cv_dep, ld_nc4=lnc4)
       ierr   = createvar   (ncout3,  stypvar3, nvars,  ipk,    id_varout3      , ld_nc4=lnc4)
       ierr   = putheadervar(ncout3,  cf_in,    npiglo, npjglo, npk, cdep=cv_dep      )
    ENDIF

    IF ( lmax ) THEN
       ncout4 = create      (cf_out4, cf_in,    npiglo, npjglo, npk, cdep=cv_dep, ld_nc4=lnc4)
       ierr   = createvar   (ncout4,  stypvar4, 2*nvars,  ipk4,    id_varout4   , ld_nc4=lnc4)
       ierr   = putheadervar(ncout4,  cf_in,    npiglo, npjglo, npk, cdep=cv_dep      )
    ENDIF

  END SUBROUTINE CreateOutput

  SUBROUTINE GetFileList
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE GetFileList  ***
    !!
    !! ** Purpose :  Set up a file list given on the command line as 
    !!               blank separated list
    !!
    !! ** Method  :  Scan the command line until a '-' is found
    !!----------------------------------------------------------------------
    INTEGER (KIND=4)  :: ji
    INTEGER (KIND=4)  :: icur
    !!----------------------------------------------------------------------
    !!
    nfiles=0
    ! need to read a list of file ( number unknow ) 
    ! loop on argument till a '-' is found as first char
    icur=ijarg                          ! save current position of argument number
    DO ji = icur, narg                  ! scan arguments till - found
       CALL getarg ( ji, cldum )
       IF ( cldum(1:1) /= '-' ) THEN ; nfiles = nfiles+1
       ELSE                          ; EXIT
       ENDIF
    ENDDO
    ALLOCATE (cf_lst(nfiles) )
    DO ji = icur, icur + nfiles -1
       CALL getarg(ji, cf_lst( ji -icur +1 ) ) ; ijarg=ijarg+1
    END DO
  END SUBROUTINE GetFileList

END PROGRAM cdfmoy

PROGRAM cdfhdy
  !!======================================================================
  !!                     ***  PROGRAM  cdfhdy  ***
  !!=====================================================================
  !!  ** Purpose : Compute dynamical height anomaly field from gridT file
  !!               Store the results on a 2D cdf file.
  !!
  !!  ** Method  : the integral of (1/g) *10e4 * sum [ delta * dz ]
  !!               with delta = (1/rho - 1/rho0)
  !!               10e4 factor is conversion decibar/pascal
  !!
  !! History : 2.1  : 05/2010  : R. Dussin    : Original code
  !!           3.0  : 12/2010  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE eos, ONLY : sigmai
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2010, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: jk, jt           ! dummy loop index
  INTEGER(KIND=4)                           :: ierr             ! working integer
  INTEGER(KIND=4)                           :: narg, iargc      ! browse arguments
  INTEGER(KIND=4)                           :: npiglo, npjglo   ! size of the domain
  INTEGER(KIND=4)                           :: npk, npt         !  "           "
  INTEGER(KIND=4)                           :: nlev1, nlev2     ! limit of vertical integration
  INTEGER(KIND=4)                           :: ncout            ! ncid of output fileset
  INTEGER(KIND=4), DIMENSION(1)             :: ipk              ! outptut variables : number of levels,
  INTEGER(KIND=4), DIMENSION(1)             :: id_varout        ! ncdf varid's

  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: temp, sal        ! Temperature and salinity at current level
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: temp0, sal0      ! reference temperature and salinity
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: tmask            ! 2D mask at current level
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: rdep, rdepth     ! depth at current level including SSH
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: ssh              ! Sea Surface Heigh
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: tim, e3t_1d      ! time counter, vertical level spacing

  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dhdy, dterm      ! dynamic height, working array
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dsig0, dsig      ! In situ density (reference, local)
  REAL(KIND=8)                              :: drau0 = 1000.d0  ! density of fresh water
  REAL(KIND=8)                              :: dgrav = 9.81d0   ! gravity

  CHARACTER(LEN=256)                        :: cf_tfil          ! input file name
  CHARACTER(LEN=256)                        :: cf_out='cdfhdy.nc' ! output file name
  CHARACTER(LEN=256)                        :: cldum            ! dummy string

  TYPE(variable) , DIMENSION(1)             :: stypvar          ! structure for attributes
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg <= 3 ) THEN
     PRINT *,' usage : cdfhdy T-file level1 level2'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'        Compute dynamical height anomaly field from gridT file.'
     PRINT *,'        It is computed as the integral of (1/g) *10e4 * sum [ delta * dz ]'
     PRINT *,'            where delta = (1/rho - 1/rho0)'
     PRINT *,'            10e4 factor is for the conversion decibar to pascal.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'        T-file  : netcdf file with temperature and salinity'
     PRINT *,'        level1  : upper limit for vertical integration (usually 1 = surface)'
     PRINT *,'        level2  : lower limit for vertical integration.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ',TRIM(cn_fmsk),' and ', TRIM(cn_fzgr)
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : sohdy (m)'
     STOP
  ENDIF

  CALL getarg (1, cf_tfil )
  CALL getarg (2, cldum   ) ;        READ(cldum,*) nlev1
  CALL getarg (3, cldum   ) ;        READ(cldum,*) nlev2

  IF ( chkfile (cf_tfil) .OR. chkfile(cn_fmsk) .OR. chkfile(cn_fzgr)  ) STOP ! missing file

  npiglo = getdim (cf_tfil,cn_x)
  npjglo = getdim (cf_tfil,cn_y)
  npk    = getdim (cf_tfil,cn_z)
  npt    = getdim (cf_tfil,cn_t)

  ipk(:) = 1 
  stypvar(1)%cname= 'sohdy'
  stypvar(1)%cunits='m'
  stypvar(1)%rmissing_value=0.
  stypvar(1)%valid_min= -100.
  stypvar(1)%valid_max= 100.
  stypvar(1)%clong_name='Dynamical height anomaly'
  stypvar(1)%cshort_name='sohdy'
  stypvar(1)%conline_operation='N/A'
  stypvar(1)%caxis='TYX'


  PRINT *, 'npiglo=', npiglo
  PRINT *, 'npjglo=', npjglo
  PRINT *, 'npk   =', npk
  PRINT *, 'npt   =', npt

  ALLOCATE (temp0(npiglo,npjglo), sal0(npiglo,npjglo), dsig0(npiglo,npjglo) ,tmask(npiglo,npjglo))
  ALLOCATE (temp(npiglo,npjglo), sal(npiglo,npjglo), dsig(npiglo,npjglo) , dhdy(npiglo,npjglo), dterm(npiglo,npjglo))
  ALLOCATE (rdep(npiglo,npjglo), rdepth(npiglo,npjglo), ssh(npiglo,npjglo), e3t_1d(npk))
  ALLOCATE (tim(npt))

  ! create output fileset
  ncout = create      (cf_out, cf_tfil,  npiglo, npjglo, npk       )
  ierr  = createvar   (ncout,  stypvar,  1,      ipk,    id_varout )
  ierr  = putheadervar(ncout,  cf_tfil,  npiglo, npjglo, npk       )

  tim   = getvar1d(cf_tfil, cn_vtimec, npt     )
  ierr  = putvar1d(ncout,   tim,       npt, 'T')

  ! Temperature and salinity for reference profile
  temp0(:,:) =  0.
  sal0(:,:)  = 35.

  tmask(:,:) = getvar(cn_fmsk, 'tmask', nlev2, npiglo, npjglo)
  ssh(:,:)   = getvar(cf_tfil,  cn_sossheig, 1,  npiglo, npjglo)
  e3t_1d(:)  = getvare3(cn_fzgr, cn_ve3t, npk)

  DO jt=1,npt
     PRINT *,' TIME = ', jt, tim(jt)/86400.,' days'
     dhdy(:,:)    = 0.
     rdepth(:,:) = 0.

     DO jk = nlev1, nlev2

        !rdep(:,:)   = getvar(cn_fzgr, 'e3t_ps', jk,npiglo,npjglo,ldiom=.true.)
        ! we degrade the computation to smooth the results
        rdep(:,:) = e3t_1d(jk)

        IF ( jk == 1 ) THEN
           rdep(:,:) = rdep(:,:) + ssh(:,:)
        ENDIF

        ! depth at current level, including ssh (used for computation of rho in situ)
        rdepth(:,:) = rdepth(:,:) + rdep(:,:)

        temp(:,:)= getvar(cf_tfil, cn_votemper,  jk ,npiglo, npjglo, ktime=jt)
        sal(:,:) = getvar(cf_tfil, cn_vosaline,  jk ,npiglo, npjglo, ktime=jt)

        dsig0 = sigmai(temp0, sal0, rdepth, npiglo, npjglo) 
        dsig  = sigmai(temp , sal , rdepth, npiglo, npjglo) 

        ! we compute the term of the integral : (1/g) *10e4 * sum [ delta * dz ]
        ! with delta = (1/rho - 1/rho0)
        ! 10e4 factor is conversion decibar/pascal
        !
        dterm = ( ( 1.d0 / ( drau0 + dsig(:,:) ) ) - ( 1.d0 / ( drau0 + dsig0(:,:) ) ) ) * 10000.d0 * rdep / dgrav
        ! in land, it seems appropriate to stop the computation
        WHERE(sal == 0 ) dterm = 0

        dhdy(:,:) = dhdy(:,:) + dterm(:,:)

     END DO  ! loop to next level

     ! we mask with the last level of the integral
     dhdy(:,:) = dhdy(:,:) * tmask(:,:)

     ierr = putvar(ncout, id_varout(1) ,REAL(dhdy), 1, npiglo, npjglo, ktime=jt)

  END DO  ! next time frame

  ierr = closeout(ncout)

END PROGRAM cdfhdy

PROGRAM cdfmltmask
  !!======================================================================
  !!                     ***  PROGRAM  cdfmltmask  ***
  !!=====================================================================
  !!  ** Purpose : multiplication of file by a mask (0,1)
  !!
  !! History : 2.1  : 06/2007  : M. Juza      : Original code
  !!         : 2.1  : 06/2007  : P. Mathiot   : add forcing capabilities
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                             :: jk, jt          ! dummy loop index
  INTEGER(KIND=4)                             :: ierr            ! error status
  INTEGER(KIND=4)                             :: narg, iargc     ! command line 
  INTEGER(KIND=4)                             :: npiglo, npjglo  ! size of the domain
  INTEGER(KIND=4)                             :: npk, npt        ! size of the domain
  INTEGER(KIND=4)                             :: nvpk            ! vertical levels in working variable
  INTEGER(KIND=4)                             :: npkmask         ! vertical levels in mask file

  REAL(KIND=4)                                :: zspval          ! missing value attribute
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: zv              ! cv_in at jk level 
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: zmask           ! mask at jk level 
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: zvmask          ! masked cv_in at jk level

  CHARACTER(LEN=256)                          :: cunits          ! units attribute
  CHARACTER(LEN=256)                          :: clname          ! long_name attribute
  CHARACTER(LEN=256)                          :: csname          ! short_name attribute
  CHARACTER(LEN=256)                          :: cf_in           ! input file name
  CHARACTER(LEN=256)                          :: cf_msk          ! input mask file name
  CHARACTER(LEN=256)                          :: cv_in           ! cdf variable name
  CHARACTER(LEN=256)                          :: cvartype        ! variable position on Cgrid
  CHARACTER(LEN=256)                          :: cv_dep          ! depth dim name
  CHARACTER(LEN=256)                          :: ctmp            ! dummy string
  CHARACTER(LEN=20)                           :: cv_msk          ! mask variable name
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfmltmask IN-file MSK-file IN-var T| U | V | F | W | P'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Multiply IN-var of IN-file by the mask corresponding to the' 
     PRINT *,'       C-grid point position given as last argument.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       IN-file  : input netcdf file.' 
     PRINT *,'       MSK-file : input netcdf mask file.' 
     PRINT *,'       IN-var   : input variable name.'
     PRINT *,'       T| U | V | F | W | P : C-grid position of IN-var'
     PRINT *,'                P indicate a polygon mask created by cdfpoly.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        none, all are given as arguments.'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       The output file is a copy of the input file with only'
     PRINT *,'       the requested variable masked.'
     PRINT *,'       netcdf file : IN-file_masked'
     PRINT *,'         variables : IN-var (same as input).'
     STOP
  ENDIF

  CALL getarg (1, cf_in    )
  CALL getarg (2, cf_msk   )
  CALL getarg (3, cv_in    )
  CALL getarg (4, cvartype )

  IF ( chkfile (cf_in) .OR. chkfile(cf_msk) ) STOP ! missing files

  ! append _masked to input file name and copy initial file to new file, which will be modified
  !  using dd more efficient than cp for big files
  ctmp   = TRIM(cf_in)//'_masked'
  CALL system(' dd bs=10000000 if='//TRIM(cf_in)//' of='//TRIM(ctmp) )
  cf_in = ctmp

  PRINT *,' Working on copy : ', TRIM(cf_in)

  npiglo = getdim (cf_in,cn_x)
  npjglo = getdim (cf_in,cn_y)
  npk    = getdim (cf_in,cn_z, cdtrue=cv_dep, kstatus=ierr)

  IF (ierr /= 0 ) THEN
     npk   = getdim (cf_in, 'z', cdtrue=cv_dep, kstatus=ierr)
     IF (ierr /= 0 ) THEN
       npk   = getdim (cf_in, 'sigma', cdtrue=cv_dep, kstatus=ierr)
        IF ( ierr /= 0 ) THEN
          npk = getdim (cf_in, 'nav_lev', cdtrue=cv_dep, kstatus=ierr)
            IF ( ierr /= 0 ) THEN
              PRINT *,' assume file with no depth'
              npk=0
            ENDIF
        ENDIF
     ENDIF
  ENDIF

  npkmask = getdim (cf_msk, cn_z, cdtrue=cv_dep, kstatus=ierr)
  IF (ierr /= 0 ) THEN
     npkmask  = getdim (cf_msk, 'z', cdtrue=cv_dep, kstatus=ierr)
       IF ( ierr /= 0 ) THEN
            npkmask = getdim (cf_msk, 'nav_lev', cdtrue=cv_dep, kstatus=ierr)
            IF ( ierr /= 0 ) THEN
              PRINT *,' assume file with no depth'
              npkmask=0
            ENDIF
       ENDIF
  ENDIF

  npt   = getdim (cf_in, cn_t )
  nvpk  = getvdim(cf_in, cv_in)

  IF (nvpk == 2 ) nvpk = 1
  IF (nvpk == 3 ) nvpk = npk

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt
  PRINT *, 'nvpk   = ', nvpk

  IF (npk==0) npk=1

  ! Allocate arrays
  ALLOCATE( zmask(npiglo,npjglo) )
  ALLOCATE( zv   (npiglo,npjglo) )
  ALLOCATE(zvmask(npiglo,npjglo) )

  SELECT CASE (TRIM(cvartype))
  CASE ( 'T' )
     cv_msk='tmask'
  CASE ( 'U' )
     cv_msk='umask'
  CASE ( 'V' )
     cv_msk='vmask'
  CASE ( 'F' )
     cv_msk='fmask'
  CASE ( 'W' )
     cv_msk='tmask'
  CASE ( 'P' )   ! for polymask 
     cv_msk='polymask'
  CASE DEFAULT
     PRINT *, 'this type of variable is not known :', TRIM(cvartype)
     STOP
  END SELECT

  IF ( npkmask <= 1 ) THEN 
        zmask(:,:) = getvar(cf_msk, cv_msk, 1, npiglo, npjglo)
  ENDIF

  DO jt = 1, npt
     IF (MOD(jt,100)==0) PRINT *, jt,'/', npt
     DO jk = 1,nvpk
        ! Read cv_in
        zv(:,:) = getvar(cf_in, cv_in, jk, npiglo, npjglo, ktime=jt)
        IF ( npkmask > 1 ) THEN
        ! Read mask
          zmask(:,:) = getvar(cf_msk, cv_msk, jk, npiglo, npjglo)
        ENDIF
        ! Multiplication of cv_in by mask at level jk
        zvmask = zv * zmask
        ! Writing  on the copy of original file                 
        ierr = putvar(cf_in, cv_in, jk, npiglo, npjglo, 1, 1, ktime=jt, ptab=zvmask)
     END DO
  END DO
  ! set missing value attribute for cv_in as 0.
  ierr = getvaratt (cf_in, cv_in, cunits, zspval, clname, csname)
  ierr = cvaratt   (cf_in, cv_in, cunits, 0.,     clname, csname)

END PROGRAM cdfmltmask 

PROGRAM cdfvita
  !!======================================================================
  !!                     ***  PROGRAM  cdfvita  ***
  !!=====================================================================
  !!  ** Purpose : Compute velocity on t grid
  !!
  !!  ** Method  : Read velocity component on input gridU and gridV file
  !!               Use gridT file for the proper location of T points
  !!               The velocity module is also output (same function than
  !!               cdfspeed) If a gridW file is given, (fifth argument)
  !!               then w is also computed on the T grid
  !!
  !! History : 2.1  : 11/2006  : J.M. Molines : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!                : 03/2013  : J.M. Molines : add -geo option
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio 
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class derived_fields
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                            :: ji, jj, jk, jt, jlev    ! dummy loop index
  INTEGER(KIND=4)                            :: narg, iargc, ijarg      ! browse line
  INTEGER(KIND=4)                            :: npiglo,npjglo           ! size of the domain
  INTEGER(KIND=4)                            :: npk, npt                ! size of the domain
  INTEGER(KIND=4)                            :: nlev, ik                ! number of selected levels, current lev
  INTEGER(KIND=4)                            :: ncout                   ! ncid of output file
  INTEGER(KIND=4)                            :: ierr                    ! error status for cdfio
  INTEGER(KIND=4)                            :: ivar                    ! variable index
  INTEGER(KIND=4)                            :: ivar_vert               ! variable index of vertical velocity
  INTEGER(KIND=4)                            :: ivar_cub                ! variable index of cube of velocity module
  INTEGER(KIND=4)                            :: nvar                    ! number of variable
  INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE :: nklevel                 ! selected levels
  INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE :: ipk, id_varout          ! output stuff

  REAL(KIND=4)                               :: pi                      ! pi
  REAL(KIND=4), DIMENSION(:),    ALLOCATABLE :: gdeptall, gdept         ! depths and selected depths
  REAL(KIND=4), DIMENSION(:,:),  ALLOCATABLE :: uc, vc                  ! velocity component on C grid
  REAL(KIND=4), DIMENSION(:,:),  ALLOCATABLE :: ua, va, vmod, vdir      ! velocity component on A grid

  REAL(KIND=8), DIMENSION(:),    ALLOCATABLE :: dtim                    ! time counter array

  TYPE(variable), DIMENSION(:),  ALLOCATABLE :: stypvar                 ! data attributes

  CHARACTER(LEN=256)                         :: cf_ufil, cf_vfil        ! velocity files on C grid
  CHARACTER(LEN=256)                         :: cf_wfil                 ! optional W file on C grid
  CHARACTER(LEN=256)                         :: cf_tfil                 ! GridT file for T position
  CHARACTER(LEN=256)                         :: cf_out='vita.nc'        ! output file name
  CHARACTER(LEN=256)                         :: cldum                   ! dummy char variable
  

  LOGICAL                                    :: lvertical = .FALSE.     ! vertical velocity  flag 
  LOGICAL                                    :: lperio    = .FALSE.     ! E_W periodicity flag 
  LOGICAL                                    :: lgeo      = .FALSE.     ! input U V files are geostrophic files
  LOGICAL                                    :: lcub      = .FALSE.     ! save U*U*U on  A grid
  LOGICAL                                    :: lnc4      = .FALSE.     ! Use nc4 with chunking and deflation
  LOGICAL                                    :: lmod      = .FALSE.     ! flag for saving velocoty module only
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfvita -u U-file -v V-file -t T-file [-w W-file] [-geo] [-cubic]'
     PRINT *,'             ... [-uvar U-var] [-vvar V-var] [-o OUT-file] [-nc4] ...'
     PRINT *,'             ... [-lev LST-level] [-vitmod]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Creates a file with velocity components, module  and direction'
     PRINT *,'       at T points from file on C-grid. T-file is used only for' 
     PRINT *,'       getting the header of the output file. Any file on T grid'
     PRINT *,'       can be used.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -u U-file  : netcdf file with zonal component of velocity' 
     PRINT *,'       -v V-file  : netcdf file with meridional component of velocity' 
     PRINT *,'       -t T-file  : netcdf file with T points header OK.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-w W-file ]: if used, also compute vertical velocities at T points.' 
     PRINT *,'       [-geo ]     : indicate that input velocity files are produced by '
     PRINT *,'              cdfgeo-uv, hence ugeo on V-point, vgeo on U-points. '
     PRINT *,'       [-cubic ]   : Save the cube of the velocity module.'
     PRINT *,'       [-nc4 ]     : Use netcdf4 output with chunking and deflation level 1.'
     PRINT *,'              This option is effective only if cdftools are compiled with'
     PRINT *,'              a netcdf library supporting chunking and deflation.'
     PRINT *,'       [-o OUT-file ] : Specify name of output file instead of ',TRIM(cf_out)
     PRINT *,'       [-lev LST-level] : specify a blank-separated list of levels to be used.'
     PRINT *,'              (default option is to use all input levels).'
     PRINT *,'       [-uvar U-var] : specify name of u-field. Default: ',TRIM(cn_vozocrtx)
     PRINT *,'       [-vvar V-var] : specify name of v-field. Default: ',TRIM(cn_vomecrty)
     PRINT *,'       [-vitmod] : only save sovitmod variable (smaller files)'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        none'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) ,' unless -o option is used'
     PRINT *,'         variables : sovitua, sovitva, sovitmod, sovitdir, [sovitmod3] and'
     PRINT *,'                     [sovitwa]. Note that the direction is relative to the'
     PRINT *,'                     model grid.'
     PRINT *,'      '
     PRINT *,'     SEE ALSO : '
     PRINT *,'        cdfspeed only computes the speed (velocity module).'
     PRINT *,'      '
     STOP 
  ENDIF

  nlev = 0
  ijarg=1
  pi=ACOS(-1.)
  DO WHILE ( ijarg <= narg )
     CALL getarg( ijarg, cldum ) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-u'   ) ; CALL getarg(ijarg, cf_ufil )     ; ijarg=ijarg+1
     CASE ( '-v'   ) ; CALL getarg(ijarg, cf_vfil )     ; ijarg=ijarg+1
        ! options
     CASE ( '-lev' ) ; CALL GetLevList
     CASE ( '-t'   ) ; CALL getarg(ijarg, cf_tfil )     ; ijarg=ijarg+1
     CASE ( '-w'   ) ; CALL getarg(ijarg, cf_wfil )     ; ijarg=ijarg+1
        ;              lvertical=.TRUE.
     CASE ( '-uvar') ; CALL getarg(ijarg, cn_vozocrtx ) ; ijarg=ijarg+1
     CASE ( '-vvar') ; CALL getarg(ijarg, cn_vomecrty ) ; ijarg=ijarg+1
     CASE ( '-geo' ) ; lgeo = .TRUE.
     CASE ('-cubic') ; lcub = .TRUE.
     CASE ('-vitmod'); lmod = .TRUE.
     CASE ( '-nc4' ) ; lnc4 = .TRUE.
     CASE ( '-o'   ) ; CALL getarg(ijarg, cf_out  )     ; ijarg=ijarg+1
     CASE DEFAULT    ; PRINT *,' ERROR : ', TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  ENDDO

  IF ( chkfile(cf_ufil) .OR. chkfile(cf_vfil) .OR. chkfile(cf_tfil) ) STOP 99 ! missing file
  IF ( lvertical ) THEN 
     IF ( chkfile(cf_wfil) ) STOP 99 ! missing file
  ENDIF

  npiglo = getdim (cf_ufil,cn_x)
  npjglo = getdim (cf_ufil,cn_y)
  npk    = getdim (cf_ufil,cn_z)
  npt    = getdim (cf_ufil,cn_t)

  IF (npk == 0 ) THEN
     npk  = 1
  ENDIF

  IF ( nlev == 0 ) THEN ! take all levels
     nlev = npk
     ALLOCATE (nklevel(nlev) )
     DO jlev = 1, nlev
        nklevel(jlev) = jlev
     ENDDO
  ENDIF

  ! adjust number of variable according to  option
  IF ( lmod) THEN
    nvar=1
  ELSE
    nvar=4
    IF ( lvertical )  nvar = nvar + 1
    IF ( lcub      )  nvar = nvar + 1
  ENDIF

  ALLOCATE ( ipk(nvar), id_varout(nvar), stypvar(nvar) )
  ALLOCATE ( gdept(nlev) )

  PRINT *, 'npiglo =', npiglo
  PRINT *, 'npjglo =', npjglo
  PRINT *, 'npk    =', npk
  PRINT *, 'npt    =', npt
  PRINT *, 'nlev   =', nlev

  ALLOCATE( uc(npiglo,npjglo), vc(npiglo,npjglo)  )
  ALLOCATE( ua(npiglo,npjglo), va(npiglo,npjglo)  )
  ALLOCATE( vmod(npiglo,npjglo), vdir(npiglo, npjglo)  )
  ALLOCATE( dtim(npt), gdeptall(npk) )

  gdeptall(:) = getvar1d(cf_tfil,cn_vdeptht, npk)
  DO jlev = 1, nlev
     ik = nklevel(jlev)
     gdept(jlev) = gdeptall(ik)
  ENDDO

  ! check E-W periodicity using uc array as working space
  uc(:,:) = getvar(cf_tfil, cn_vlon2d, 1, npiglo, npjglo )
  IF ( uc(1,1) == uc(npiglo-1,1) )  THEN 
     lperio = .TRUE.
     PRINT *,' E-W periodicity detected.'
  ENDIF

  IF ( lmod ) THEN
    CALL CreateOutput_mod
  ELSE
    CALL CreateOutput_full
  ENDIF

  DO jt = 1, npt
     DO jlev = 1, nlev
        ik = nklevel(jlev)
        uc(:,:) = getvar(cf_ufil, cn_vozocrtx, ik ,npiglo, npjglo, ktime=jt )
        vc(:,:) = getvar(cf_vfil, cn_vomecrty, ik ,npiglo, npjglo, ktime=jt )
        WHERE( uc > 1000 ) uc=0.
        WHERE( vc > 1000 ) vc=0.

        ua = 0. ; va = 0. ; ua(:,:) = 0. ; va(:,:)=0. ; vmod(:,:)=0.
        IF ( lgeo ) THEN  ! geostrophic velocities
           DO ji=2, npiglo
              DO jj=2,npjglo
                 ua(ji,jj)   = 0.5* (uc(ji,jj)+ uc(ji  ,jj-1))
                 va(ji,jj)   = 0.5* (vc(ji,jj)+ vc(ji-1,jj  ))
                 vmod(ji,jj) = SQRT( ua(ji,jj)*ua(ji,jj) + va(ji,jj)*va(ji,jj) )
                 ! the direction is relative to the model mesh, not the true North
                 vdir(ji,jj) = 90. - ATAN2(va(ji,jj),ua(ji,jj))*180./pi
                 IF ( vdir(ji,jj) < 0. ) vdir(ji,jj) = 360.+vdir(ji,jj)
              END DO
           END DO
        ELSE
           DO ji=2, npiglo
              DO jj=2,npjglo
                 ua(ji,jj)   = 0.5* (uc(ji,jj)+ uc(ji-1,jj))
                 va(ji,jj)   = 0.5* (vc(ji,jj)+ vc(ji,jj-1))
                 vmod(ji,jj) = SQRT( ua(ji,jj)*ua(ji,jj) + va(ji,jj)*va(ji,jj) )
                 ! the direction is relative to the model mesh, not the true North
                 vdir(ji,jj) = 90. - ATAN2(va(ji,jj),ua(ji,jj))*180./pi
                 IF ( vdir(ji,jj) < 0. ) vdir(ji,jj) = 360.+vdir(ji,jj)
              END DO
           END DO
        ENDIF
        IF ( lperio) THEN  ! periodic E-W boundary ...
           ua  (1,:) = ua  (npiglo-1,:)
           va  (1,:) = va  (npiglo-1,:)
           vmod(1,:) = vmod(npiglo-1,:)
           vdir(1,:) = vdir(npiglo-1,:)
        ENDIF
        ivar = 1
        IF ( lmod ) THEN
           ierr=putvar(ncout, id_varout(ivar), vmod, jlev ,npiglo, npjglo, ktime=jt ) ; ivar = ivar +1
        ELSE
           ierr=putvar(ncout, id_varout(ivar), ua,   jlev ,npiglo, npjglo, ktime=jt ) ; ivar = ivar +1
           ierr=putvar(ncout, id_varout(ivar), va,   jlev ,npiglo, npjglo, ktime=jt ) ; ivar = ivar +1
           ierr=putvar(ncout, id_varout(ivar), vmod, jlev ,npiglo, npjglo, ktime=jt ) ; ivar = ivar +1
           ierr=putvar(ncout, id_varout(ivar), vdir, jlev ,npiglo, npjglo, ktime=jt ) 
           IF ( lcub ) THEN
              ierr=putvar(ncout, id_varout(ivar_cub), vmod*vmod*vmod, jlev ,npiglo, npjglo, ktime=jt ) 
           ENDIF
        ENDIF
     END DO
  END DO

  IF ( lvertical ) THEN
     ! reuse uc an vc arrays to store Wk and Wk+1
     DO jt = 1, npt
        DO jlev=1, nlev - 1
           uc(:,:) = getvar(cf_wfil, cn_vovecrtz, nklevel(jlev),   npiglo, npjglo, ktime=jt )
           vc(:,:) = getvar(cf_wfil, cn_vovecrtz, nklevel(jlev)+1, npiglo, npjglo, ktime=jt )
           WHERE( uc > 1000 ) uc=0.
           WHERE( vc > 1000 ) vc=0.
           ua(:,:) = 0.5*(uc(:,:) + vc(:,:))*1000.  ! mm/sec
           ierr    = putvar(ncout, id_varout(ivar_vert), ua, jlev,      npiglo, npjglo, ktime=jt )
           uc(:,:) = vc(:,:)
        END DO
        IF ( nlev == npk ) THEN
           ua(:,:) = 0.e0  ! npk
        ELSE
           uc(:,:) = getvar(cf_wfil, cn_vovecrtz, nklevel(nlev),   npiglo, npjglo, ktime=jt )
           vc(:,:) = getvar(cf_wfil, cn_vovecrtz, nklevel(nlev)+1, npiglo, npjglo, ktime=jt )
           ua(:,:) = 0.5*(uc(:,:) + vc(:,:))*1000.  ! mm/sec
        ENDIF
        ierr = putvar(ncout, id_varout(ivar_vert), ua, nlev ,npiglo, npjglo, ktime=jt )
     ENDDO
  ENDIF

  ierr = closeout(ncout)

CONTAINS

  SUBROUTINE CreateOutput_full
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    ivar=0
    ! Zonal Velocity T point
    ivar                            = ivar+1
    ipk(ivar)                       = nlev
    stypvar(ivar)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(ivar)%cname             = 'sovitua'
    stypvar(ivar)%cunits            = 'm/s'
    stypvar(ivar)%rmissing_value    = 0.
    stypvar(ivar)%valid_min         = 0.
    stypvar(ivar)%valid_max         = 10000.
    stypvar(ivar)%clong_name        = 'Zonal Velocity T point'
    stypvar(ivar)%cshort_name       = 'sovitua'
    stypvar(ivar)%conline_operation = 'N/A'
    stypvar(ivar)%caxis             = 'TZYX'

    ! Meridional Velocity T point
    ivar                            = ivar+1
    ipk(ivar)                       = nlev
    stypvar(ivar)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(ivar)%cname             = 'sovitva'
    stypvar(ivar)%cunits            = 'm/s'
    stypvar(ivar)%rmissing_value    = 0.
    stypvar(ivar)%valid_min         = 0.
    stypvar(ivar)%valid_max         = 10000.
    stypvar(ivar)%clong_name        = 'Meridional Velocity T point'
    stypvar(ivar)%cshort_name       = 'sovitva'
    stypvar(ivar)%conline_operation = 'N/A'
    stypvar(ivar)%caxis             = 'TZYX'

    ! Velocity module T point
    ivar                            = ivar+1
    ipk(ivar)                       = nlev
    stypvar(ivar)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(ivar)%cname             = 'sovitmod'
    stypvar(ivar)%cunits            = 'm/s'
    stypvar(ivar)%rmissing_value    = 0.
    stypvar(ivar)%valid_min         = 0.
    stypvar(ivar)%valid_max         = 10000.
    stypvar(ivar)%clong_name        = 'Velocity module T point'
    stypvar(ivar)%cshort_name       = 'sovitmod'
    stypvar(ivar)%conline_operation = 'N/A'
    stypvar(ivar)%caxis             = 'TZYX'

    ! Velocity direction  T point
    ivar                            = ivar+1
    ipk(ivar)                       = nlev
    stypvar(ivar)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(ivar)%cname             = 'sovitdir'
    stypvar(ivar)%cunits            = 'deg N'
    stypvar(ivar)%rmissing_value    = 0.
    stypvar(ivar)%valid_min         = 0.
    stypvar(ivar)%valid_max         = 360.
    stypvar(ivar)%clong_name        = 'Velocity direction T point'
    stypvar(ivar)%cshort_name       = 'sovitdir'
    stypvar(ivar)%conline_operation = 'N/A'
    stypvar(ivar)%caxis             = 'TZYX'

    IF ( lvertical ) THEN
       ! Vertical Velocity at T point
       ivar                            = ivar+1
       ivar_vert                       = ivar
       ipk(ivar)                       = nlev
       stypvar(ivar)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
       stypvar(ivar)%cname             = 'sovitwa'
       stypvar(ivar)%cunits            = 'mm/s'
       stypvar(ivar)%rmissing_value    = 0.
       stypvar(ivar)%valid_min         = 0.
       stypvar(ivar)%valid_max         = 10000.
       stypvar(ivar)%clong_name        = 'Vertical Velocity at T point'
       stypvar(ivar)%cshort_name       = 'sovitwa'
       stypvar(ivar)%conline_operation = 'N/A'
       stypvar(ivar)%caxis             = 'TZYX'
    ENDIF

    IF ( lcub ) THEN
       ! Cube of velocity module
       ivar                            = ivar+1
       ivar_cub                        = ivar
       ipk(ivar)                       = nlev
       stypvar(ivar)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
       stypvar(ivar)%cname             = 'sovitmod3'
       stypvar(ivar)%cunits            = 'm3/s3'
       stypvar(ivar)%rmissing_value    = 0.
       stypvar(ivar)%valid_min         = 0.
       stypvar(ivar)%valid_max         = 10000.
       stypvar(ivar)%clong_name        = 'cube of velocity module'
       stypvar(ivar)%cshort_name       = 'sovitmod3'
       stypvar(ivar)%conline_operation = 'N/A'
       stypvar(ivar)%caxis             = 'TZYX'
    ENDIF

    ncout = create      (cf_out,   cf_tfil,  npiglo, npjglo, nlev     , ld_nc4=lnc4 )
    ierr  = createvar   (ncout ,   stypvar,  nvar,   ipk,    id_varout, ld_nc4=lnc4 )
    ierr  = putheadervar(ncout,    cf_tfil,  npiglo, npjglo, nlev,     pdep=gdept )

    dtim = getvar1d(cf_ufil, cn_vtimec, npt     )
    ierr = putvar1d(ncout,  dtim,       npt, 'T')

  END SUBROUTINE CreateOutput_full

  SUBROUTINE CreateOutput_mod
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    ivar=0
    ! Velocity module T point
    ivar                            = ivar+1
    ipk(ivar)                       = nlev
    stypvar(ivar)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(ivar)%cname             = 'sovitmod'
    stypvar(ivar)%cunits            = 'm/s'
    stypvar(ivar)%rmissing_value    = 0.
    stypvar(ivar)%valid_min         = 0.
    stypvar(ivar)%valid_max         = 10000.
    stypvar(ivar)%clong_name        = 'Velocity module T point'
    stypvar(ivar)%cshort_name       = 'sovitmod'
    stypvar(ivar)%conline_operation = 'N/A'
    stypvar(ivar)%caxis             = 'TZYX'

    ncout = create      (cf_out,   cf_tfil,  npiglo, npjglo, nlev     , ld_nc4=lnc4 )
    ierr  = createvar   (ncout ,   stypvar,  nvar,   ipk,    id_varout, ld_nc4=lnc4 )
    ierr  = putheadervar(ncout,    cf_tfil,  npiglo, npjglo, nlev,     pdep=gdept )

    dtim = getvar1d(cf_ufil, cn_vtimec, npt     )
    ierr = putvar1d(ncout,  dtim,       npt, 'T')

  END SUBROUTINE CreateOutput_mod

  SUBROUTINE GetLevList
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE GetLevList  ***
    !!
    !! ** Purpose :  Set up a level list given on the command line as 
    !!               blank separated list
    !!
    !! ** Method  :  Scan the command line until a '-' is found
    !!----------------------------------------------------------------------
    INTEGER (KIND=4)  :: ji
    INTEGER (KIND=4)  :: icur
    !!----------------------------------------------------------------------
    !!
    nlev=0
    ! need to read a list of level ( number unknow ) 
    ! loop on argument till a '-' is found as first char
    icur=ijarg                          ! save current position of argument number
    DO ji = icur, narg                  ! scan arguments till - found
       CALL getarg ( ji, cldum )
       IF ( cldum(1:1) /= '-' ) THEN ; nlev = nlev+1
       ELSE                          ; EXIT
       ENDIF
    ENDDO
    ALLOCATE (nklevel(nlev) )
    DO ji = icur, icur + nlev -1
       CALL getarg(ji, cldum ) ; ijarg=ijarg+1 ; READ(cldum, * ) nklevel( ji -icur +1 )
    END DO
  END SUBROUTINE GetLevList

END PROGRAM cdfvita

PROGRAM cdfvita
   !!======================================================================
   !!                     ***  PROGRAM  cdfvita  ***
   !!=====================================================================
   !!  ** Purpose : Compute velocity on t grid
   !!
   !!  ** Method  : Read velocity component on input gridU and gridV file
   !!               Use gridT file for the proper location of T points
   !!               The velocity module is also output (same function than
   !!               cdfspeed) If a gridW file is given, (fifth argument)
   !!               then w is also computed on the T grid
   !!
   !! History : 2.1  : 11/2006  : J.M. Molines : Original code
   !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
   !!                : 03/2013  : J.M. Molines : add -geo option
   !!----------------------------------------------------------------------
   USE cdfio 
   USE modcdfnames
   !!----------------------------------------------------------------------
   !! CDFTOOLS_3.0 , MEOM 2011
   !! $Id$
   !! Copyright (c) 2011, J.-M. Molines
   !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
   !!----------------------------------------------------------------------
   IMPLICIT NONE

   INTEGER(KIND=4)                            :: ji, jj, jk, jt, jlev    ! dummy loop index
   INTEGER(KIND=4)                            :: narg, iargc, ijarg      ! browse line
   INTEGER(KIND=4)                            :: npiglo,npjglo           ! size of the domain
   INTEGER(KIND=4)                            :: npk, npt                ! size of the domain
   INTEGER(KIND=4)                            :: nlev, ik                ! number of selected levels, current lev
   INTEGER(KIND=4)                            :: ncout                   ! ncid of output file
   INTEGER(KIND=4)                            :: ierr                    ! error status for cdfio
   INTEGER(KIND=4)                            :: nvar                    ! number of variable
   INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE :: nklev                   ! selected levels
   INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE :: ipk, id_varout          ! output stuff

   REAL(KIND=4)                               :: pi                      ! pi
   REAL(KIND=4), DIMENSION(:),    ALLOCATABLE :: tim                     ! time counter array
   REAL(KIND=4), DIMENSION(:),    ALLOCATABLE :: gdeptall, gdept         ! depths and selected depths
   REAL(KIND=4), DIMENSION(:,:),  ALLOCATABLE :: uc, vc                  ! velocity component on C grid
   REAL(KIND=4), DIMENSION(:,:),  ALLOCATABLE :: ua, va, vmod, vdir      ! velocity component on A grid

   TYPE(variable), DIMENSION(:),  ALLOCATABLE :: stypvar                 ! data attributes

   CHARACTER(LEN=256)                         :: cf_ufil, cf_vfil        ! velocity files on C grid
   CHARACTER(LEN=256)                         :: cf_wfil                 ! optional W file on C grid
   CHARACTER(LEN=256)                         :: cf_tfil                 ! GridT file for T position
   CHARACTER(LEN=256)                         :: cf_out='vita.nc'        ! output file name
   CHARACTER(LEN=256)                         :: cldum                   ! dummy char variable

   LOGICAL                                    :: lvertical = .FALSE.     ! vertical velocity  flag 
   LOGICAL                                    :: lperio    = .FALSE.     ! E_W periodicity flag 
   LOGICAL                                    :: lgeo      = .FALSE.     ! input U V files are geostrophic files
   !!----------------------------------------------------------------------
   CALL ReadCdfNames()

   narg= iargc()
   IF ( narg == 0 ) THEN
      PRINT *,' usage : cdfvita U-file V_file T-file [-w W-file] [-geo ] [-lev level_list]'
      PRINT *,'      '
      PRINT *,'     PURPOSE :'
      PRINT *,'       Create a file with velocity components, module  and direction'
      PRINT *,'       at T points from file on C-grid. T-file is used only for' 
      PRINT *,'       getting the header of the output file. Any file on T grid'
      PRINT *,'       can be used.'
      PRINT *,'      '
      PRINT *,'     ARGUMENTS :'
      PRINT *,'       U-file  : netcdf file with zonal component of velocity' 
      PRINT *,'       V-file  : netcdf file with meridional component of velocity' 
      PRINT *,'       T-file  : netcdf file with T points header OK.'
      PRINT *,'      '
      PRINT *,'     OPTIONS :'
      PRINT *,'       [ -w W-file ] : if used, also compute vertical velocities at' 
      PRINT *,'                       T points.'
      PRINT *,'       [ -geo ]     : indicate that input velocity files are produced '
      PRINT *,'                      by cdfgeo-uv, hence ugeo on V-point, vgeo on U-points'
      PRINT *,'                      ( U-file and V_file are the same !)'
      PRINT *,'       [ -lev level_list] : specify a list of level to be used '
      PRINT *,'                   (default option is to use all input levels).'
      PRINT *,'                   This option MUST be the last on the command line !!'
      PRINT *,'      '
      PRINT *,'     REQUIRED FILES :'
      PRINT *,'        none'
      PRINT *,'      '
      PRINT *,'     OUTPUT : '
      PRINT *,'       netcdf file : ', TRIM(cf_out) 
      PRINT *,'         variables : sovitua, sovitva, sovitmod, sovitdir, [sovitwa]'
      STOP
   ENDIF

   nlev = 0
   ijarg=1
   pi=ACOS(-1.)
   DO WHILE ( ijarg <= narg )
      CALL getarg( ijarg, cldum ) ; ijarg=ijarg+1
      SELECT CASE ( cldum )
      CASE ( '-lev' )
         nlev= narg - ijarg + 1
         ALLOCATE (nklev(nlev) )
         DO jlev = 1, nlev
            CALL getarg( ijarg, cldum ) ; ijarg=ijarg+1 ; READ(cldum,* ) nklev(jlev)
         ENDDO
      CASE ( '-w' )
         CALL getarg( ijarg, cf_wfil ) ; ijarg=ijarg+1
         lvertical=.TRUE.
      CASE ( '-geo' )
         lgeo = .TRUE.
      CASE DEFAULT
         cf_ufil=cldum
         CALL getarg( ijarg, cf_vfil ) ; ijarg=ijarg+1
         CALL getarg( ijarg, cf_tfil ) ; ijarg=ijarg+1
      END SELECT
   ENDDO

   ! adjust number of variable according to -w option
   nvar=4
   IF ( lvertical )  nvar = 5

   ALLOCATE ( ipk(nvar), id_varout(nvar), stypvar(nvar) )

   IF ( chkfile(cf_ufil) .OR. chkfile(cf_vfil) .OR. chkfile(cf_tfil) ) STOP ! missing file

   IF ( lvertical ) THEN 
      IF ( chkfile(cf_wfil) ) STOP ! missing file
   ENDIF

   npiglo = getdim (cf_ufil,cn_x)
   npjglo = getdim (cf_ufil,cn_y)
   npk    = getdim (cf_ufil,cn_z)
   npt    = getdim (cf_ufil,cn_t)

   IF (npk == 0 ) THEN
     npk  = 1
   ENDIF

   IF ( nlev == 0 ) THEN ! take all levels
      nlev = npk
      ALLOCATE (nklev(nlev) )
      DO jlev = 1, nlev
         nklev(jlev) = jlev
      ENDDO
   ENDIF

   ALLOCATE ( gdept(nlev) )

   ! Zonal Velocity T point
   ipk(1)                       = nlev
   stypvar(1)%cname             = 'sovitua'
   stypvar(1)%cunits            = 'm/s'
   stypvar(1)%rmissing_value    = 0.
   stypvar(1)%valid_min         = 0.
   stypvar(1)%valid_max         = 10000.
   stypvar(1)%clong_name        = 'Zonal Velocity T point'
   stypvar(1)%cshort_name       = 'sovitua'
   stypvar(1)%conline_operation = 'N/A'
   stypvar(1)%caxis             = 'TZYX'

   ! Meridional Velocity T point
   ipk(2)                       = nlev
   stypvar(2)%cname             = 'sovitva'
   stypvar(2)%cunits            = 'm/s'
   stypvar(2)%rmissing_value    = 0.
   stypvar(2)%valid_min         = 0.
   stypvar(2)%valid_max         = 10000.
   stypvar(2)%clong_name        = 'Meridional Velocity T point'
   stypvar(2)%cshort_name       = 'sovitva'
   stypvar(2)%conline_operation = 'N/A'
   stypvar(2)%caxis             = 'TZYX'

   ! Velocity module T point
   ipk(3)                       = nlev
   stypvar(3)%cname             = 'sovitmod'
   stypvar(3)%cunits            = 'm/s'
   stypvar(3)%rmissing_value    = 0.
   stypvar(3)%valid_min         = 0.
   stypvar(3)%valid_max         = 10000.
   stypvar(3)%clong_name        = 'Velocity module T point'
   stypvar(3)%cshort_name       = 'sovitmod'
   stypvar(3)%conline_operation = 'N/A'
   stypvar(3)%caxis             = 'TZYX'

   ! Velocity module T point
   ipk(4)                       = nlev
   stypvar(4)%cname             = 'sovitdir'
   stypvar(4)%cunits            = 'deg N'
   stypvar(4)%rmissing_value    = 0.
   stypvar(4)%valid_min         = 0.
   stypvar(4)%valid_max         = 360.
   stypvar(4)%clong_name        = 'Velocity direction T point'
   stypvar(4)%cshort_name       = 'sovitdir'
   stypvar(4)%conline_operation = 'N/A'
   stypvar(4)%caxis             = 'TZYX'



   IF ( lvertical ) THEN
      ! Vertical Velocity at T point
      ipk(nvar)                       = nlev
      stypvar(nvar)%cname             = 'sovitwa'
      stypvar(nvar)%cunits            = 'mm/s'
      stypvar(nvar)%rmissing_value    = 0.
      stypvar(nvar)%valid_min         = 0.
      stypvar(nvar)%valid_max         = 10000.
      stypvar(nvar)%clong_name        = 'Vertical Velocity at T point'
      stypvar(nvar)%cshort_name       = 'sovitwa'
      stypvar(nvar)%conline_operation = 'N/A'
      stypvar(nvar)%caxis             = 'TZYX'
   ENDIF

   PRINT *, 'npiglo =', npiglo
   PRINT *, 'npjglo =', npjglo
   PRINT *, 'npk    =', npk
   PRINT *, 'npt    =', npt
   PRINT *, 'nlev   =', nlev

   ALLOCATE( uc(npiglo,npjglo), vc(npiglo,npjglo)  )
   ALLOCATE( ua(npiglo,npjglo), va(npiglo,npjglo)  )
   ALLOCATE( vmod(npiglo,npjglo), vdir(npiglo, npjglo)  )
   ALLOCATE( tim(npt), gdeptall(npk) )

   gdeptall(:) = getvar1d(cf_tfil,cn_vdeptht, npk)
   DO jlev = 1, nlev
      ik = nklev(jlev)
      gdept(jlev) = gdeptall(ik)
   ENDDO

   ! check E-W periodicity using uc array as working space
   uc(:,:) = getvar(cf_tfil, cn_vlon2d, 1, npiglo, npjglo )
   IF ( uc(1,1) == uc(npiglo-1,1) )  THEN 
      lperio = .TRUE.
      PRINT *,' E-W periodicity detected.'
   ENDIF

   ncout = create      (cf_out,   cf_tfil,  npiglo, npjglo, nlev                 )
   ierr  = createvar   (ncout ,   stypvar,  nvar,   ipk,    id_varout            )
   ierr  = putheadervar(ncout,    cf_tfil,  npiglo, npjglo, nlev,     pdep=gdept )

   DO jt = 1, npt
      DO jlev = 1, nlev
         ik = nklev(jlev)
         uc(:,:) = getvar(cf_ufil, cn_vozocrtx, ik ,npiglo, npjglo, ktime=jt )
         vc(:,:) = getvar(cf_vfil, cn_vomecrty, ik ,npiglo, npjglo, ktime=jt )

         ua = 0. ; va = 0. ; ua(:,:) = 0. ; va(:,:)=0. ; vmod(:,:)=0.
         IF ( lgeo ) THEN  ! geostrophic velocities
            DO ji=2, npiglo
               DO jj=2,npjglo
                  ua(ji,jj)   = 0.5* (uc(ji,jj)+ uc(ji  ,jj-1))
                  va(ji,jj)   = 0.5* (vc(ji,jj)+ vc(ji-1,jj  ))
                  vmod(ji,jj) = SQRT( ua(ji,jj)*ua(ji,jj) + va(ji,jj)*va(ji,jj) )
                  vdir(ji,jj) = 90. - atan2(va(ji,jj),ua(ji,jj))*180./pi
                  IF ( vdir(ji,jj) < 0. ) vdir(ji,jj) = 360.+vdir(ji,jj)
               END DO
            END DO
         ELSE
            DO ji=2, npiglo
               DO jj=2,npjglo
                  ua(ji,jj)   = 0.5* (uc(ji,jj)+ uc(ji-1,jj))
                  va(ji,jj)   = 0.5* (vc(ji,jj)+ vc(ji,jj-1))
                  vmod(ji,jj) = SQRT( ua(ji,jj)*ua(ji,jj) + va(ji,jj)*va(ji,jj) )
                  vdir(ji,jj) = 90. - atan2(va(ji,jj),ua(ji,jj))*180./pi
                  IF ( vdir(ji,jj) < 0. ) vdir(ji,jj) = 360.+vdir(ji,jj)
               END DO
            END DO
         ENDIF
         IF ( lperio) THEN  ! periodic E-W boundary ...
            ua  (1,:) = ua  (npiglo-1,:)
            va  (1,:) = va  (npiglo-1,:)
            vmod(1,:) = vmod(npiglo-1,:)
            vdir(1,:) = vdir(npiglo-1,:)
         ENDIF

         ierr=putvar(ncout, id_varout(1), ua,   jlev ,npiglo, npjglo, ktime=jt )
         ierr=putvar(ncout, id_varout(2), va,   jlev ,npiglo, npjglo, ktime=jt )
         ierr=putvar(ncout, id_varout(3), vmod, jlev ,npiglo, npjglo, ktime=jt )
         ierr=putvar(ncout, id_varout(4), vdir, jlev ,npiglo, npjglo, ktime=jt )
      END DO
   END DO

   IF ( lvertical ) THEN
      ! reuse uc an vc arrays to store Wk and Wk+1
      DO jt = 1, npt
         DO jlev=1, nlev - 1
            uc(:,:) = getvar(cf_wfil, cn_vovecrtz, nklev(jlev),   npiglo, npjglo, ktime=jt )
            vc(:,:) = getvar(cf_wfil, cn_vovecrtz, nklev(jlev)+1, npiglo, npjglo, ktime=jt )
            ua(:,:) = 0.5*(uc(:,:) + vc(:,:))*1000.  ! mm/sec
            ierr    = putvar(ncout, id_varout(4), ua, jlev,      npiglo, npjglo, ktime=jt )
            uc(:,:) = vc(:,:)
         END DO
         IF ( nlev == npk ) THEN
            ua(:,:) = 0.e0  ! npk
         ELSE
            uc(:,:) = getvar(cf_wfil, cn_vovecrtz, nklev(nlev),   npiglo, npjglo, ktime=jt )
            vc(:,:) = getvar(cf_wfil, cn_vovecrtz, nklev(nlev)+1, npiglo, npjglo, ktime=jt )
            ua(:,:) = 0.5*(uc(:,:) + vc(:,:))*1000.  ! mm/sec
         ENDIF
         ierr = putvar(ncout, id_varout(4), ua, nlev ,npiglo, npjglo, ktime=jt )
      ENDDO
   ENDIF

   tim  = getvar1d(cf_ufil, cn_vtimec, npt     )
   ierr = putvar1d(ncout,  tim,       npt, 'T')
   ierr = closeout(ncout)

END PROGRAM cdfvita

PROGRAM cdfisopsi
  !!======================================================================
  !!                     ***  PROGRAM  cdfisopsi  ***
  !!=====================================================================
  !!  ** Purpose : Compute a geostrophic streamfunction projected
  !!               on an isopycn (Ref: McDougall and ?, need reference)
  !!
  !!  ** Method  : read temp and salinity, compute sigmainsitu and sigma
  !!              at a reference level, projection of p,T,S on a given
  !!              isopycnal, compute specific volume anomaly and
  !!              integrates it.
  !!
  !! History : 2.1  : 12/2010  : R. Dussin 
  !!           3.0  : 03/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE eos
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE
  INTEGER(KIND=4), PARAMETER  :: jp_vars=7

  INTEGER(KIND=4)                             :: jj, ji, jk, jt            ! dummy loop index
  INTEGER(KIND=4)                             :: ierr                      ! working integer
  INTEGER(KIND=4)                             :: narg, iargc               ! command line arguments
  INTEGER(KIND=4)                             :: npiglo, npjglo  ! size of the domain
  INTEGER(KIND=4)                             :: npk, npt  ! size of the domain
  INTEGER(KIND=4)                             :: ik, ik0                        ! 
  INTEGER(KIND=4)                             :: ncout
  INTEGER(KIND=4), DIMENSION(jp_vars)         :: ipk              ! outptut variables : number of levels,
  INTEGER(KIND=4), DIMENSION(jp_vars)         :: id_varout        ! ncdf varid's

  REAL(KIND=4), DIMENSION(:,:,:), ALLOCATABLE :: v3d, ztemp3         ! 3d array
  REAL(KIND=4), DIMENSION(:,:,:), ALLOCATABLE :: zsal3, zsva3        ! 3d array
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: ztemp, zsal , zssh  ! Array to read a layer of data
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: ztemp0, zsal0       ! Arrays for reference profile
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: zsiginsitu          ! in-situ density
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: zsig0, zsigsurf     ! potential density of ref profile and surface
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: zmask, zdep           ! 2D mask at current level, level depths
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: v2d             !  2d working arrays
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: ztempint ! 2d working arrays
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: zsalint ! 2d working arrays
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: zint ! 2d working arrays
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: pint    ! 2d working arrays
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: alpha ! 2d working arrays
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: e1t, e2t
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: rdeltapsi1
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: rdeltapsi2
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: psi0
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: psi
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: zsva2
  REAL(KIND=4), DIMENSION(:),     ALLOCATABLE :: prof, tim              ! prof (m) and time (sec)
  REAL(KIND=4)                                :: P1, P2
  REAL(KIND=4)                                :: zspval            ! missing value
  REAL(KIND=4)                                :: refdepth
  REAL(KIND=4)                                :: zsigmaref      !
  REAL(KIND=4)                                :: ztmean, zsmean  ! mean temperature and salinity on isopycnal
  REAL(KIND=4)                                :: hmean, pmean  ! mean isopycnal depth and mean pressure

  CHARACTER(LEN=256) :: cf_tfil                              ! input gridT file
  CHARACTER(LEN=256) :: cf_out='isopsi.nc'                   ! output file name
  CHARACTER(LEN=256) :: cldum                                ! dummy character variable for reading

  TYPE(variable) , DIMENSION(jp_vars) :: stypvar         ! structure for attributes
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfisopsi ref_level sigma_ref gridT '
     PRINT *,'      Compute  a geostrophic streamfunction'
     PRINT *,'      projected  on an isopycn.'
     PRINT *,'         ref_level = reference level for pot. density'
     PRINT *,'         sigma_ref = density level to project on'
     PRINT *,'         gridT     = input file for temperature and salinity'
     PRINT *,'  '
     PRINT *,'         Output on ',TRIM(cf_out),' variable soisopsi'
     PRINT *,'         Depths are taken from input file '
     PRINT *,'         requires ',TRIM(cn_fhgr),' and ',TRIM(cn_fzgr) 
     STOP
  ENDIF

  CALL getarg (1, cldum) ; READ (cldum,*) refdepth
  CALL getarg (2, cldum) ; READ (cldum,*) zsigmaref
  CALL getarg (3, cf_tfil)

  IF ( chkfile(cf_tfil) .OR. chkfile(cn_fzgr) .OR. chkfile(cn_fhgr) ) STOP  ! missing file

  PRINT *, 'Potential density referenced at ', refdepth , ' meters'
  PRINT *, 'Isopycn for projection is ', zsigmaref

  npiglo = getdim (cf_tfil,cn_x)
  npjglo = getdim (cf_tfil,cn_y)
  npk    = getdim (cf_tfil,cn_z)
  npt    = getdim (cf_tfil,cn_t)

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  ALLOCATE ( prof(npk)         , tim(npt)           )
  ALLOCATE ( e1t(npiglo,npjglo), e2t(npiglo,npjglo) )

  e1t(:,:) = getvar(cn_fhgr, cn_ve1t, 1, npiglo, npjglo)
  e2t(:,:) = getvar(cn_fhgr, cn_ve2t, 1, npiglo, npjglo)

  !--------------------------------------------------------------------
  !!  Output file
  ipk(:)= 1  ! all variables are 2d
  stypvar(1)%cname             = 'votemper_interp'
  stypvar(1)%cunits            = 'DegC'
  stypvar(1)%rmissing_value    = 0.
  stypvar(1)%valid_min         = -2.
  stypvar(1)%valid_max         = 45.
  stypvar(1)%clong_name        = 'Temperature interpolated on isopycnal layer'
  stypvar(1)%cshort_name       = 'votemper_interp'
  stypvar(1)%conline_operation = 'N/A'
  stypvar(1)%caxis             = 'TZYX'

  stypvar(2)%cname             = 'vosaline_interp'
  stypvar(2)%cunits            = 'PSU'
  stypvar(2)%rmissing_value    = 0.
  stypvar(2)%valid_min         = 0.
  stypvar(2)%valid_max         = 50.
  stypvar(2)%clong_name        = 'Salinity interpolated on isopycnal layer'
  stypvar(2)%cshort_name       = 'vosaline_interp'
  stypvar(2)%conline_operation = 'N/A'
  stypvar(2)%caxis             = 'TZYX'

  stypvar(3)%cname             = 'depth_interp'
  stypvar(3)%cunits            = 'meters'
  stypvar(3)%rmissing_value    = 0.
  stypvar(3)%valid_min         = 0.0
  stypvar(3)%valid_max         = 8000.
  stypvar(3)%clong_name        = 'Depth of the isopycnal layer'
  stypvar(3)%cshort_name       = 'depth_interp'
  stypvar(3)%conline_operation = 'N/A'
  stypvar(3)%caxis             = 'TZYX'

  stypvar(4)%cname             = 'soisopsi'
  stypvar(4)%cunits            = 'm2s-2 (to be verified)'
  stypvar(4)%rmissing_value    = 0.
  stypvar(4)%valid_min         = -500.
  stypvar(4)%valid_max         =  500.
  stypvar(4)%clong_name        = 'Total streamfunction on the isopycnal layer'
  stypvar(4)%cshort_name       = 'soisopsi'
  stypvar(4)%conline_operation = 'N/A'
  stypvar(4)%caxis             = 'TZYX'

  stypvar(5)%cname             = 'soisopsi0'
  stypvar(5)%cunits            = 'm2s-2 (to be verified)'
  stypvar(5)%rmissing_value    = 0.
  stypvar(5)%valid_min         = -500.
  stypvar(5)%valid_max         =  500.
  stypvar(5)%clong_name        = 'Contribution of the SSH'
  stypvar(5)%cshort_name       = 'soisopsi'
  stypvar(5)%conline_operation = 'N/A'
  stypvar(5)%caxis             = 'TZYX'

  stypvar(6)%cname             = 'soisopsi1'
  stypvar(6)%cunits            = 'm2s-2 (to be verified)'
  stypvar(6)%rmissing_value    = 0.
  stypvar(6)%valid_min         = -500.
  stypvar(6)%valid_max         =  500.
  stypvar(6)%clong_name        = 'Contribution of specific volume anomaly vertical integration'
  stypvar(6)%cshort_name       = 'soisopsi'
  stypvar(6)%conline_operation = 'N/A'
  stypvar(6)%caxis             = 'TZYX'

  stypvar(7)%cname             = 'soisopsi2'
  stypvar(7)%cunits            = 'm2s-2 (to be verified)'
  stypvar(7)%rmissing_value    = 0.
  stypvar(7)%valid_min         = -500.
  stypvar(7)%valid_max         =  500.
  stypvar(7)%clong_name        = 'Contribution of pressure term on the isopycnal layer'
  stypvar(7)%cshort_name       = 'soisopsi'
  stypvar(7)%conline_operation = 'N/A'
  stypvar(7)%caxis             = 'TZYX'

  ! create output fileset
  ncout = create      (cf_out, cf_tfil, npiglo,  npjglo, npk       )
  ierr  = createvar   (ncout,  stypvar, jp_vars, ipk,    id_varout ) 
  ierr  = putheadervar(ncout,  cf_tfil, npiglo,  npjglo, npk       )

  prof(:) = getvar1d(cf_tfil, cn_vdeptht, npk     )
  tim     = getvar1d(cf_tfil, cn_vtimec,  npt     )
  ierr    = putvar1d(ncout,   tim,        npt, 'T')

  zspval   = getatt(cf_tfil, cn_vosaline, cn_missing_value )

  !---------------------------------------------------------------------------
  DO jt=1,npt
     PRINT *,'time ',jt, tim(jt)/86400.,' days'

     !------------------------------------------------------------------------------
     ! 1. First we compute the potential density and store it into a 3d array
     ALLOCATE (ztemp(npiglo,npjglo), zsal(npiglo,npjglo), zmask(npiglo,npjglo))
     ALLOCATE (v3d(npiglo,npjglo,npk)                                         )

     DO jk = 1, npk
        zmask(:,:) = 1.

        ztemp(:,:) = getvar(cf_tfil, cn_votemper, jk, npiglo, npjglo, ktime=jt)
        zsal(:,:)  = getvar(cf_tfil, cn_vosaline, jk, npiglo, npjglo, ktime=jt)

        WHERE(zsal == zspval ) zmask = 0

        v3d(:,:,jk) = sigmai(ztemp, zsal, refdepth, npiglo, npjglo ) * zmask(:,:)
     END DO  ! loop to next level

     DEALLOCATE ( ztemp, zsal, zmask )
     !------------------------------------------------------------------------------
     ! 2. Projection of T,S and p on the chosen isopycnal layer (from cdfrhoproj)
     ALLOCATE ( alpha(npiglo,npjglo) )

     !! Compute coefficients
     DO ji=1,npiglo
        DO jj = 1, npjglo
           ik = 1
           !  Assume that rho (z) is increasing downward (no inversion)
           !     Caution with sigma0 at great depth !
           DO WHILE (zsigmaref >=  v3d(ji,jj,ik) .AND. ik <= npk &
                &                .AND. v3d(ji,jj,ik) /=  zspval )
              ik=ik+1
           END DO
           ik=ik-1
           ik0=ik
           IF (ik == 0) THEN
              ik=1
              alpha(ji,jj) = 0.
           ELSE IF (v3d(ji,jj,ik+1) == zspval ) THEN
              ik0=0
              alpha(ji,jj) = 0.
           ELSE
              ! ... alpha is always in [0,1]. Adding ik0 ( >=1 ) for saving space for ik0
              alpha(ji,jj)= (zsigmaref-v3d(ji,jj,ik))/(v3d(ji,jj,ik+1)-v3d(ji,jj,ik)) + ik0
           ENDIF
        END DO
     END DO
     DEALLOCATE (v3d)

     ! Working on temperature first
     ALLOCATE( ztempint(npiglo, npjglo), zint(npiglo, npjglo), pint(npiglo, npjglo) )
     ALLOCATE( ztemp3(npiglo, npjglo,npk) )

     DO jk=1,npk
        ztemp3(:,:,jk) = getvar(cf_tfil, cn_votemper, jk ,npiglo, npjglo, ktime=jt)
     ENDDO

     DO ji=1,npiglo
        DO jj=1,npjglo
           ! ik0 is retrieved from alpha, taking the integer part.
           ! The remnant is alpha. 
           ik0=INT(alpha(ji,jj))
           alpha(ji,jj) =  alpha(ji,jj) - ik0
           IF (ik0 /= 0) THEN
              P1=ztemp3(ji,jj,ik0)
              P2=ztemp3(ji,jj,ik0+1)
              IF (P1 /= zspval .AND. P2 /= zspval) THEN
                 ztempint(ji,jj) = alpha(ji,jj) * P2          + (1-alpha(ji,jj)) * P1
                 zint(ji,jj)     = alpha(ji,jj) * prof(ik0+1) + (1-alpha(ji,jj)) * prof(ik0)
              ELSE
                 ztempint(ji,jj) = zspval
                 zint(ji,jj)     = zspval
              ENDIF
           ELSE
              ztempint(ji,jj) = zspval
              zint(ji,jj)     = zspval
           ENDIF
           ! re-add ik0 to alpha for the next computation
           alpha(ji,jj) =  alpha(ji,jj) + ik0
        END DO
     END DO

     pint = zint / 10. ! pressure on the isopycnal layer = depth / 10.

     ierr = putvar(ncout, id_varout(1), ztempint, 1, npiglo, npjglo, ktime=jt)
     ierr = putvar(ncout, id_varout(3), zint,     1, npiglo, npjglo, ktime=jt)
     DEALLOCATE( ztemp3 )  

     ! Working on salinity
     ALLOCATE( zsalint(npiglo, npjglo) )
     ALLOCATE( zsal3(npiglo, npjglo,npk) )

     DO jk=1,npk
        zsal3(:,:,jk) = getvar(cf_tfil, cn_vosaline, jk, npiglo, npjglo, ktime=jt)
     ENDDO

     DO ji=1,npiglo
        DO jj=1,npjglo
           ! ik0 is retrieved from alpha, taking the integer part.
           ! The remnant is alpha. 
           ik0=INT(alpha(ji,jj))
           alpha(ji,jj) =  alpha(ji,jj) - ik0
           IF (ik0 /= 0) THEN
              P1=zsal3(ji,jj,ik0)
              P2=zsal3(ji,jj,ik0+1)
              IF (P1 /= zspval .AND. P2 /= zspval) THEN
                 zsalint(ji,jj) = alpha(ji,jj) * P2 + (1-alpha(ji,jj)) * P1
              ELSE
                 zsalint(ji,jj) = zspval
              ENDIF
           ELSE
              zsalint(ji,jj) = zspval
           ENDIF
           ! re-add ik0 to alpha for the next computation
           alpha(ji,jj) =  alpha(ji,jj) + ik0
        END DO
     END DO

     ierr = putvar(ncout, id_varout(2), zsalint, 1, npiglo, npjglo, ktime=jt)
     DEALLOCATE( zsal3 )

     ! 3. Compute means for T,S and depth on the isopycnal layer
     ALLOCATE( zmask(npiglo, npjglo) )
     zmask=1. ! define a new mask which correspond to the isopycnal layer
     WHERE( zint == 0. ) zmask = 0.

     ztmean = SUM( ztempint * e1t * e2t * zmask ) / SUM( e1t * e2t * zmask )
     zsmean = SUM( zsalint  * e1t * e2t * zmask ) / SUM( e1t * e2t * zmask )
     ! JMM rem : hmean never used ...
     ! hmean = SUM( zint     * e1t * e2t * zmask ) / SUM( e1t * e2t * zmask )
     pmean = SUM( pint     * e1t * e2t * zmask ) / SUM( e1t * e2t * zmask )

     DEALLOCATE ( ztempint, zsalint )

     ! 4. Compute specific volume anomaly
     ALLOCATE( zsva3(npiglo,npjglo,npk) )
     ALLOCATE( zsiginsitu(npiglo,npjglo), zsig0(npiglo,npjglo) )
     ALLOCATE( ztemp(npiglo,npjglo),  zsal(npiglo,npjglo) )
     ALLOCATE( ztemp0(npiglo,npjglo), zsal0(npiglo,npjglo) )

     DO jk=1,npk
        ztemp(:,:) = getvar(cf_tfil, cn_votemper, jk, npiglo, npjglo, ktime=jt)
        zsal (:,:) = getvar(cf_tfil, cn_vosaline, jk, npiglo, npjglo, ktime=jt)

        ztemp0(:,:) = ztmean
        zsal0 (:,:) = zsmean

        ! again land/sea mask
        zmask (:,:) = 1.
        WHERE( zsal == zspval ) zmask = 0.

        zsiginsitu(:,:) = sigmai ( ztemp,  zsal,  prof(jk), npiglo, npjglo ) * zmask(:,:) ! in-situ density
        zsig0(:,:)      = sigmai ( ztemp0, zsal0, prof(jk), npiglo, npjglo ) * zmask(:,:) ! density of reference profile

        zsva3(:,:,jk)    = ( 1. / zsiginsitu(:,:) ) - ( 1. / zsig0(:,:) )
     ENDDO

     DEALLOCATE( zsiginsitu, zsig0, ztemp0, zsal0 )

     ! 5. Integrates from surface to depth of isopycnal layer
     ALLOCATE( zdep(npiglo, npjglo), rdeltapsi1(npiglo, npjglo) )

     rdeltapsi1(:,:) = 0.
     DO jk=1, npk
        zdep(:,:) = getvar(cn_fzgr, 'e3t_ps', jk,npiglo,npjglo,ldiom=.TRUE.)

        ! For each point we integrate from surface to zint(ji,jj) which is the depth
        ! of the isopycnal layer

        ! If isopycnal layer depth is below the current level
        WHERE( zint >= prof(jk) ) rdeltapsi1 = rdeltapsi1 - zsva3(:,:,jk) * zdep / 10.
        ! If isopycnal layer is between current level and previous level
        WHERE( zint < prof(jk) .AND. zint > prof(jk-1) ) rdeltapsi1 = rdeltapsi1 &
             & - zsva3(:,:,jk) * ( zint - prof(jk-1) ) / 10.
     ENDDO
     ierr = putvar(ncout, id_varout(6), rdeltapsi1, 1, npiglo, npjglo, ktime=jt)
     DEALLOCATE( zdep )

     ! 6. Projection of the specific volume anomaly on the isopycnal layer
     ALLOCATE( zsva2(npiglo,npjglo), rdeltapsi2(npiglo,npjglo) )

     DO ji=1,npiglo
        DO jj=1,npjglo
           ! ik0 is retrieved from alpha, taking the integer part.
           ! The remnant is alpha. 
           ik0=INT(alpha(ji,jj))
           alpha(ji,jj) =  alpha(ji,jj) - ik0
           IF (ik0 /= 0) THEN
              P1=zsva3(ji,jj,ik0)
              P2=zsva3(ji,jj,ik0+1)
              IF (P1 /= zspval .AND. P2 /= zspval) THEN
                 zsva2(ji,jj) = alpha(ji,jj) * P2 + ( 1-alpha(ji,jj) ) * P1
              ELSE
                 zsva2(ji,jj) = zspval
              ENDIF
           ELSE
              zsva2(ji,jj) = zspval
           ENDIF
           ! re-add ik0 to alpha for the next computation
           alpha(ji,jj) =  alpha(ji,jj) + ik0
        END DO
     END DO

     rdeltapsi2 = ( pint - pmean ) * zsva2
     ierr       = putvar(ncout, id_varout(7), rdeltapsi2, 1, npiglo, npjglo, ktime=jt)
     DEALLOCATE ( zsva3, zsva2, alpha, zint, pint )

     ! 6. Finally we compute the surface streamfunction
     ALLOCATE(zssh(npiglo,npjglo) , zsigsurf(npiglo,npjglo), psi0(npiglo,npjglo) )

     ztemp   (:,:) = getvar(cf_tfil, cn_votemper, 1, npiglo, npjglo, ktime=jt)
     zsal    (:,:) = getvar(cf_tfil, cn_vosaline, 1, npiglo, npjglo, ktime=jt)
     zssh    (:,:) = getvar(cf_tfil, cn_sossheig, 1, npiglo, npjglo, ktime=jt)

     ! land/sea mask at surface
     zmask (:,:) = 1.
     WHERE( zsal == zspval ) zmask = 0.

     zsigsurf(:,:) = sigmai ( ztemp, zsal, prof(1), npiglo, npjglo ) * zmask(:,:)

     psi0 = zsigsurf * zssh * (9.81 / 1020. )
     ierr = putvar(ncout, id_varout(5), psi0, 1, npiglo, npjglo, ktime=jt)
     DEALLOCATE(zssh, zsigsurf, ztemp, zsal )

     ! 7. At least we are done with the computations
     ALLOCATE( psi(npiglo,npjglo) )
     ! final mask for output : mask the contribution of SSH where isopycn outcrops
     zmask=1.
     WHERE(rdeltapsi1 == zspval ) zmask = 0.
     psi = ( psi0 * zmask ) + rdeltapsi1 + rdeltapsi2

     ierr = putvar(ncout, id_varout(4), psi, 1, npiglo, npjglo, ktime=jt)
     DEALLOCATE( psi, psi0, rdeltapsi1, rdeltapsi2, zmask )
  END DO  ! loop to next time

  ierr = closeout(ncout)

END PROGRAM cdfisopsi

PROGRAM cdf2regular
  !!======================================================================
  !!                     ***  PROGRAM  cdf2regular  ***
  !!=====================================================================
  !!  ** Purpose : remaps (bin) 3D high resolution (finer than 1x1 deg)
  !!               fields on Levitus-like (ie lon/lat regular) grid.
  !!
  !!  ** Method  : data surface averaging
  !!               It assumes that Levitus grid SW grid cell center 
  !!               is 0.5W,89.5S 
  !!
  !! History : 3.0  : 06/2012  : N. Ferry  : Original code
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  USE cdftools
  USE modutils
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class data_transformation
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                              :: ji, jj, jk, jt     ! dummy loop index
  INTEGER(KIND=4)                              :: jilev,jjlev        ! dummy loop index
  INTEGER(KIND=4)                              :: jvar               ! dummy loop index
  INTEGER(KIND=4)                              :: ii, ij             ! array index (not loop)
  INTEGER(KIND=4)                              :: iilev, ijlev       ! array index (not loop)
  INTEGER(KIND=4)                              :: icount             ! array index (not loop)
  INTEGER(KIND=4)                              :: npiglo, npjglo     ! size of the domain
  INTEGER(KIND=4)                              :: npk, npt           ! size of the domain
  INTEGER(KIND=4)                              :: npilev, npjlev     ! size of the Levitus domain
  INTEGER(KIND=4)                              :: narg, iargc, ijarg ! browse line
  INTEGER(KIND=4)                              :: ncout              ! ncid of output file
  INTEGER(KIND=4)                              :: ierr               ! error status
  INTEGER(KIND=4)                              :: ires               ! resolution in fraction
  INTEGER(KIND=4)                              :: nvars              ! number of variables in the input file
  INTEGER(KIND=4)                              :: iimin, iimax       ! IJ coordinates of the closest points
  INTEGER(KIND=4)                              :: ijmin, ijmax       ! "      "            "
  INTEGER(KIND=4)                              :: imethod=1          ! interpolation method
  INTEGER(KIND=4)                              :: iter_shap=3        ! number of Shapiro iteration
  INTEGER(KIND=4), DIMENSION(:),   ALLOCATABLE :: ipk, id_var        ! levels and varid's of input vars
  INTEGER(KIND=4), DIMENSION(:),   ALLOCATABLE :: ipkout, id_varout  ! levels and varid's of output vars

  REAL(KIND=4)                                 :: zradius=120.       ! Distance (km) for the search bubble (FHZ)
  REAL(KIND=4)                                 :: rlon1, rlon2, rlat1, rlat2, rpos
  REAL(KIND=4)                                 :: gphitmin
  REAL(KIND=4)                                 :: rlev_resol=0.33333333     ! degree
  REAL(KIND=4)                                 :: rlon0=-180         ! degree
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: e1t, e2t           ! horizontal T metrics
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: z_in               ! input field
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: z_fill             ! output 
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: glamt, gphit       ! T longitude latitude
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: rlonlev, rlatlev   ! Levitus grid longitude latitude
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: zbt
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: tmask              ! input mask
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: tmasklev           ! output mask
  REAL(KIND=4), DIMENSION(:),      ALLOCATABLE :: gdept              ! depth axis

  REAL(KIND=8), DIMENSION(:),      ALLOCATABLE :: dtim               ! time counter
  REAL(KIND=8), DIMENSION(:,:),    ALLOCATABLE :: d_out, d_n         ! output field and weighting field

  CHARACTER(LEN=256)                           :: cldum              ! dummy char variable
  CHARACTER(LEN=256)                           :: cf_in              ! input file name
  CHARACTER(LEN=256)                           :: cf_out='regular.nc'! output file name ( output)
  CHARACTER(LEN=256)                           :: cv_nam             ! variable name
  CHARACTER(LEN=256)                           :: ctcalendar         ! time attributes
  CHARACTER(LEN=256)                           :: cttitle            ! time attributes
  CHARACTER(LEN=256)                           :: ctlong_name        ! time attributes
  CHARACTER(LEN=256)                           :: ctaxis             ! time attributes
  CHARACTER(LEN=256)                           :: ctunits            ! time attributes
  CHARACTER(LEN=256)                           :: cttime_origin      ! time attributes

  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_names          ! array of var name
  CHARACTER(LEN=6)                              :: ctyp              ! 'fill' or 'smooth' for shapiro

  TYPE(variable), DIMENSION(:),   ALLOCATABLE  :: stypvar            ! input attributes
  TYPE(variable), DIMENSION(:),   ALLOCATABLE  :: stypvarout         ! output attributes

  LOGICAL                                      :: lchk               ! missing files flag
  LOGICAL                                      :: ltest
  LOGICAL                                      :: l360 = .FALSE.     ! flag for 0-360 layout
  LOGICAL                                      :: lnc4 = .FALSE.     ! Use nc4 with chunking and deflation
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  WRITE(cldum,'("1/",i2)') NINT(1./rlev_resol)

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdf2regular -f IN-file -v VAR-name [-o OUT-file] [-360] ...'
     PRINT *,'        ... [-r TGT-resolution] [-nc4] '
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Remap (by binnig) high resolution fields on a coarser regular grid,'
     PRINT *,'       keeping the same vertical grid as in the input file.'
     PRINT *,'       This program is not suitable for vector fields, as far as transport'
     PRINT *,'       conservation is concerned.'
     PRINT *,'       Default output grid resolution is ',TRIM(cldum),' deg. It can be changed using'
     PRINT *,'       the -r option.'
     PRINT *,'       Note that output file is not masked.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -f IN-file  : netcdf input file ' 
     PRINT *,'       -v VAR-name : input variable name to be remapped.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-o OUT-file]: netcdf output file, instead of ',TRIM(cf_out)
     PRINT *,'       [-nc4 ]: Use netcdf4 output with chunking and deflation level 1.'
     PRINT *,'                This option is effective only if cdftools are compiled with'
     PRINT *,'                a netcdf library supporting chunking and deflation.'
     PRINT *,'       [-360 ]: Output file longitudes span [0 -> 360 deg.], instead of'
     PRINT *,'                the default [-180 -> 180 deg.].'
     PRINT *,'       [-r TGT-resolution ]:  Target resolution (in degrees).'
     PRINT *,'     '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ',TRIM(cn_fhgr)
     PRINT *,'       ',TRIM(cn_fmsk)
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : name given as second argument'
     PRINT *,'         variables : 3d_var_name'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'       cdf2levitus2d (a particular case)'
     PRINT *,'      '
     STOP 
  ENDIF

  ijarg = 1
  DO WHILE ( ijarg <= narg ) 
     CALL getarg( ijarg, cldum)  ; ijarg = ijarg + 1
     SELECT CASE (cldum)
     CASE ( '-f'  ) ; CALL getarg(ijarg, cf_in)  ; ijarg = ijarg + 1
     CASE ( '-v'  ) ; CALL getarg(ijarg, cv_nam) ; ijarg = ijarg + 1
     CASE ( '-o'  ) ; CALL getarg(ijarg, cf_out) ; ijarg = ijarg + 1
     CASE ( '-r'  ) ; CALL getarg( ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) rlev_resol
     CASE ( '-360') ; l360 = .TRUE. ; rlon0 = 0.
     CASE ( '-nc4') ; lnc4 = .TRUE.
     CASE DEFAULT   ; PRINT *,' ERROR : ', TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  ENDDO

  lchk = chkfile (cn_fhgr)
  lchk = chkfile (cn_fmsk) .OR. lchk
  lchk = chkfile (cf_in  ) .OR. lchk
  IF ( lchk ) STOP 99 ! missing files

  npiglo = getdim(cf_in,cn_x)
  npjglo = getdim(cf_in,cn_y)
  npk    = getdim(cf_in,cn_z)
  npt    = getdim(cf_in,cn_t)

  npilev = NINT(360./rlev_resol)
  npjlev = NINT(180./rlev_resol)

  nvars = getnvar(cf_in)
  ! Allocate the memory
  ALLOCATE (cv_names(nvars) )
  ALLOCATE (stypvar(nvars)  , stypvarout(1))
  ALLOCATE (id_var(nvars), ipk(nvars), id_varout(1), ipkout(1))
  ALLOCATE (zbt(npiglo,npjglo) , z_in(npiglo,npjglo) )

  ALLOCATE ( e1t(npiglo,npjglo), e2t(npiglo,npjglo) )
  ALLOCATE ( glamt(npiglo,npjglo), gphit(npiglo,npjglo)  )

  ALLOCATE ( d_out(npilev,npjlev) , d_n(npilev,npjlev) )
  ALLOCATE ( tmask(npiglo,npjglo) , tmasklev(npilev,npjlev))
  ALLOCATE ( rlonlev(npilev,npjlev), rlatlev(npilev,npjlev) )
  ALLOCATE ( gdept(1), dtim(npt) )

  ! Read the metrics from the mesh_hgr file
  e1t = getvar(cn_fhgr, cn_ve1t, 1, npiglo, npjglo)
  e2t = getvar(cn_fhgr, cn_ve2t, 1, npiglo, npjglo)

  ! and the coordinates   from the mesh_hgr file
  glamt = getvar(cn_fhgr, cn_glamt, 1, npiglo, npjglo)
  gphit = getvar(cn_fhgr, cn_gphit, 1, npiglo, npjglo)
  gphitmin = MINVAL(gphit(:,1))
  IF ( l360 ) THEN
     WHERE ( glamt < 0. ) glamt = glamt + 360. 
  ENDIF

  ! get the longitude,latitude,mask from the input Levitus mask file
  rlonlev(:,1) = (/ (rlon0+rlev_resol*ji , ji=1,npilev ) /)
  DO jj=2, npjlev
     rlonlev(:,jj) = rlonlev(:,1)
  ENDDO
  rlatlev(1,:) = (/ (rlev_resol*jj - 90.  , jj=1,npjlev ) /)
  DO ji=2, npilev
     rlatlev(ji,:) = rlatlev(1,:)
  ENDDO
  tmasklev(:,:) = 1.

  CALL CreateOutput

  zbt(:,:) = e1t(:,:) * e2t(:,:)    ! for surface weighting

  DO jt = 1, npt
     DO jk = 1, npk
        PRINT *,'jt = ', jt,' jk = ', jk
        ! get the tmask from the byte_mask file
        tmask(:,:) = getvar(cn_fmsk, cn_tmask, jk, npiglo, npjglo)
        z_in (:,:) = getvar(cf_in,   cv_nam,   jk, npiglo, npjglo, ktime=jt)
        ! Compute spatial mean by bin
        !-----------------------------
        ! Perform bining of the input file on the Levitus grid.
        ! Input area weighted values are summed up into a Levitus 1x1 bin
        d_out(:,:) = 0.d0
        d_n  (:,:) = 0.d0
        DO jj=1,npjglo
           DO ji=1,npiglo
              iilev = MIN( npilev,  INT( (glamt(ji,jj)-rlon0)/rlev_resol ) + 1)
              ijlev = MIN (npjlev , INT( (gphit(ji,jj)+ 90.)/rlev_resol ) + 1)
              IF ( z_in(ji,jj) /=  stypvarout(1)%rmissing_value ) THEN
                 d_out(iilev,ijlev) = d_out(iilev,ijlev) + (z_in(ji,jj)*tmask(ji,jj))*zbt(ji,jj)*tmasklev(iilev,ijlev)*1.d0
                 d_n  (iilev,ijlev) = d_n (iilev,ijlev)  +              tmask(ji,jj) *zbt(ji,jj)*tmasklev(iilev,ijlev)*1.d0
              ENDIF
           ENDDO
        ENDDO

        WHERE ( d_n > 0. )
           d_out = d_out / d_n 
        ELSEWHERE
           d_out = stypvarout(1)%rmissing_value 
        END WHERE

        ! Check if there are points with missing values on Levitus grid
        icount= COUNT( d_out == stypvarout(1)%rmissing_value .AND. tmasklev == 1. )
        IF ( icount /=  0. ) THEN
           ALLOCATE ( z_fill(npilev,npjlev) )
           z_fill(:,:) = 0.
           !
           imethod = 0  ! hard coded here JMM : check if all method works and pass method as argument
           SELECT CASE (imethod)
           CASE ( 0 ) 
              PRINT *, 'no filling, even if required for ',icount
           CASE ( 1 ) ! Method 1: fill missing data with shapiro
              ctyp='fill'
              iter_shap = 3  ! number of shapiro iteration
              CALL shapiro_fill_smooth ( REAL(d_out), npilev, npjlev, iter_shap, ctyp,         &
                   stypvarout(1)%rmissing_value, INT(tmasklev), z_fill )

              DO jjlev = 1 , npjlev
                 DO jilev = 1 , npilev
                    IF ( z_fill(jilev,jjlev) .NE. stypvarout(1)%rmissing_value  &
                         &                  .AND. tmasklev(jilev,jjlev) == 1    &
                         &                  .AND. d_out(jilev,jjlev) == stypvarout(1)%rmissing_value ) &
                         &  d_out(jilev,jjlev) = z_fill(jilev,jjlev)
                 ENDDO
              ENDDO

           CASE ( 2 ) ! Method 2: compute with influence bubble 
              ! For each point of Levitus grid, a data screening is performed 
              ! in a influence bubble of radius zradius, centered on Levitus point
              ! and the weighted average of the data in the bubble is computed
              z_fill(:,:) = 0.
              DO jjlev = 1 , npjlev-1
                 DO jilev = 1 , npilev
                    ierr = 0
                    IF (  tmasklev(jilev,jjlev) == 1 .AND. d_out(jilev,jjlev) == stypvarout(1)%rmissing_value ) THEN 
                       ! for the South pole, no treatment performed if data too far from southern most orca points
                       CALL btoe(rlonlev(jilev,jjlev),rlatlev(jilev,jjlev),rlon1,rlat1,-1.2*zradius,-1.2*zradius)
                       IF ( rlat1 > gphitmin ) THEN
                          ! Search the closest point of ORCA grid for this Levitus point
                          CALL cdf_findij (rlonlev(jilev,jjlev), rlonlev(jilev,jjlev), rlatlev(jilev,jjlev), rlatlev(jilev,jjlev), &
                               &         iimin, iimax, ijmin, ijmax,cd_coord=cn_fhgr,cd_point='T',  cd_verbose='N')

                          ! Next valid grid point going northward on ORCA grid
                          ltest = .TRUE. ; ij = ijmin ; ii =  iimin
                          DO WHILE ( ij <= npjglo .AND. ltest .AND. &
                               & etobd(rlonlev(jilev,jjlev),rlatlev(jilev,jjlev),glamt(ii,ij), gphit(ii,ij)) <= zradius )
                             IF ( tmask(ii,ij) == 1 ) THEN
                                ltest = .FALSE.
                                z_fill(jilev,jjlev) = z_fill(jilev,jjlev) + &
                                     &(z_in(ii,ij)*tmask(ii,ij))*zbt(ii,ij)*tmasklev(jilev,jjlev)
                                d_n  (jilev,jjlev) = d_n (jilev,jjlev)  + &
                                     & tmask(ii,ij) *zbt(ii,ij)*tmasklev(jilev,jjlev)
                                ierr = ierr + 1
                             ENDIF
                             ij = ij + 1
                          END DO
                          ! Next valid grid point going southward on ORCA grid
                          ltest = .TRUE. ; ij = ijmin-1 ; ii =  iimin
                          DO WHILE ( ij >= 1 .AND. ltest .AND. &
                               & etobd(rlonlev(jilev,jjlev),rlatlev(jilev,jjlev),glamt(ii,ij), gphit(ii,ij)) <= zradius ) 
                             IF ( tmask(ii,ij) == 1 ) THEN
                                ltest = .FALSE.
                                z_fill(jilev,jjlev) = z_fill(jilev,jjlev) + &
                                     & (z_in(ii,ij)*tmask(ii,ij))*zbt(ii,ij)*tmasklev(jilev,jjlev)
                                d_n  (jilev,jjlev) = d_n (jilev,jjlev)  +  &
                                     & tmask(ii,ij) *zbt(ii,ij)*tmasklev(jilev,jjlev)
                                ierr = ierr + 1
                             ENDIF
                             ij = ij - 1
                          END DO
                          ! Next valid grid point going westward on ORCA grid
                          ltest = .TRUE. ; ij = ijmin ; ii =  iimin+1 ; IF ( ii > npiglo ) ii = ii - npiglo
                          DO WHILE ( ltest .AND. &
                               & etobd(rlonlev(jilev,jjlev),rlatlev(jilev,jjlev),glamt(ii,ij), gphit(ii,ij)) <= zradius ) 
                             IF ( tmask(ii,ij) == 1 ) THEN
                                ltest = .FALSE.
                                z_fill(jilev,jjlev) = z_fill(jilev,jjlev) + &
                                     & (z_in(ii,ij)*tmask(ii,ij))*zbt(ii,ij)*tmasklev(jilev,jjlev) 
                                d_n  (jilev,jjlev) = d_n (jilev,jjlev)  + &
                                     & tmask(ii,ij) *zbt(ii,ij)*tmasklev(jilev,jjlev)
                                ierr = ierr + 1
                             ENDIF
                             ii = ii + 1
                             IF ( ii > npiglo ) ii = ii - npiglo
                          END DO
                          ! Next valid grid point going eastward on ORCA grid
                          ltest = .TRUE. ; ij = ijmin ; ii =  iimin-1 ; IF ( ii < 1) ii = ii + npiglo
                          DO WHILE ( ltest .AND. &
                               & etobd(rlonlev(jilev,jjlev),rlatlev(jilev,jjlev),glamt(ii,ij), gphit(ii,ij)) <= zradius ) 
                             IF ( tmask(ii,ij) == 1 ) THEN
                                ltest = .FALSE.
                                z_fill(jilev,jjlev) = z_fill(jilev,jjlev) + &
                                     & (z_in(ii,ij)*tmask(ii,ij))*zbt(ii,ij)*tmasklev(jilev,jjlev) 
                                d_n  (jilev,jjlev) = d_n (jilev,jjlev)  + &
                                     & tmask(ii,ij) *zbt(ii,ij)*tmasklev(jilev,jjlev)
                                ierr = ierr + 1
                             ENDIF
                             ii = ii - 1
                             IF ( ii < 1 ) ii = ii + npiglo
                          END DO

                          ! computing d_out value
                          IF ( z_fill(jilev,jjlev) .NE. stypvarout(1)%rmissing_value &
                               & .AND. d_n(jilev,jjlev) > 0 &
                               & .AND. d_out(jilev,jjlev) == stypvarout(1)%rmissing_value ) &
                               &  d_out(jilev,jjlev) = z_fill(jilev,jjlev) / d_n(jilev,jjlev)

                       ENDIF ! rlat1 > gphitmin

                    ENDIF ! tmasklev(jilev,jjlev) == 1 .AND. d_out(jilev,jjlev) == stypvarout(1)%rmissing_value

                 ENDDO
              ENDDO

              ! Case of the North Pole
              ijlev = npjlev
              DO jilev = 1 , npilev
                 ierr = 0

                 IF (  tmasklev(jilev,ijlev) == 1 .AND. d_out(jilev,ijlev) == stypvarout(1)%rmissing_value ) THEN

                    ! Search the closest point of ORCA grid for this Levitus point
                    CALL cdf_findij (rlonlev(jilev,ijlev), rlonlev(jilev,ijlev), rlatlev(jilev,ijlev), rlatlev(jilev,ijlev), &
                         & iimin, iimax, ijmin, ijmax,cd_coord=cn_fhgr,cd_point='T', cd_verbose='N')

                    ! Next valid grid point going southward on ORCA grid
                    ltest = .TRUE. ; ij = ijmin ; ii =  iimin
                    DO WHILE ( ij >= 1 .AND. ltest .AND. &
                         & etobd(rlonlev(jilev,ijlev),rlatlev(jilev,ijlev),glamt(ii,ij), gphit(ii,ij)) <= zradius ) 
                       IF ( tmask(ii,ij) == 1 ) THEN
                          ltest = .FALSE.
                          z_fill(jilev,ijlev) = z_fill(jilev,ijlev) + &
                               & (z_in(ii,ij)*tmask(ii,ij))*zbt(ii,ij)*tmasklev(jilev,ijlev) 
                          d_n  (jilev,ijlev) = d_n (jilev,ijlev)  +  &
                               & tmask(ii,ij) *zbt(ii,ij)*tmasklev(jilev,ijlev)
                          ierr = ierr + 1
                       ENDIF
                       ij = ij - 1
                    END DO
                    ! Next valid grid point going westward on ORCA grid
                    ltest = .TRUE. ; ij = ijmin ; ii =  iimin+1 ; IF ( ii > npiglo) ii = ii - npiglo
                    DO WHILE ( ltest .AND. &
                         & etobd(rlonlev(jilev,ijlev),rlatlev(jilev,ijlev),glamt(ii,ij), gphit(ii,ij)) <= zradius ) 
                       IF ( tmask(ii,ij) == 1 ) THEN
                          ltest = .FALSE.
                          z_fill(jilev,ijlev) = z_fill(jilev,ijlev) + &
                               & (z_in(ii,ij)*tmask(ii,ij))*zbt(ii,ij)*tmasklev(jilev,ijlev) 
                          d_n  (jilev,ijlev) = d_n (jilev,ijlev)  + &
                               & tmask(ii,ij) *zbt(ii,ij)*tmasklev(jilev,ijlev)
                          ierr = ierr + 1
                       ENDIF
                       ii = ii + 1
                       IF ( ii > npiglo ) ii = ii - npiglo
                    END DO
                    ! Next valid grid point going eastward on ORCA grid
                    ltest = .TRUE. ; ij = ijmin ; ii =  iimin-1 ; IF ( ii < 1 ) ii = ii + npiglo
                    DO WHILE ( ltest .AND. &
                         & etobd(rlonlev(jilev,ijlev),rlatlev(jilev,ijlev),glamt(ii,ij), gphit(ii,ij)) <= zradius ) 
                       IF ( tmask(ii,ij) == 1 ) THEN
                          ltest = .FALSE.
                          z_fill(jilev,ijlev) = z_fill(jilev,ijlev) + &
                               & (z_in(ii,ij)*tmask(ji,ij))*zbt(ii,ij)*tmasklev(jilev,ijlev) 
                          d_n  (jilev,ijlev) = d_n (jilev,ijlev)  + &
                               & tmask(ii,ij) *zbt(ii,ij)*tmasklev(jilev,ijlev)
                          ierr = ierr + 1
                       ENDIF
                       ii = ii - 1 ;  IF ( ii < 1 ) ii = ii + npiglo
                    END DO
                    ! Going "northward" and crossing the pole
                    ltest = .TRUE.
                    rpos = 1.
                    ij = ijmin + 1 * rpos ; ii =  iimin
                    IF ( ij > npjglo ) THEN
                       ii = ii + npiglo/2 ; IF ( ii > npiglo ) ii = ii - npiglo
                       rpos = -1.
                       ij = ij + 1 * rpos
                    ENDIF
                    DO WHILE ( ij >= 1 .AND. ltest .AND. &
                         & etobd(rlonlev(jilev,ijlev),rlatlev(jilev,ijlev),glamt(ii,ij), gphit(ii,ij)) <= zradius )
                       IF ( tmask(ii,ij) == 1 ) THEN
                          ltest = .FALSE.
                          z_fill(jilev,ijlev) = z_fill(jilev,ijlev) + &
                               &(z_in(ii,ij)*tmask(ii,ij))*zbt(ii,ij)*tmasklev(jilev,ijlev) 
                          d_n  (jilev,ijlev) = d_n (jilev,ijlev)  + &
                               & tmask(ii,ij) *zbt(ii,ij)*tmasklev(jilev,ijlev)
                          ierr = ierr + 1
                       ENDIF
                       ij = ij + 1 * rpos
                       IF ( ij > npjglo ) THEN
                          ii = ii + npiglo/2 ; IF ( ii > npiglo ) ii = ii - npiglo
                          rpos = -1.
                          ij = ij + 1 * rpos
                       ENDIF
                    END DO

                    ! computing d_out value
                    IF ( z_fill(jilev,ijlev) .NE. stypvarout(1)%rmissing_value  &
                         & .AND. d_n(jilev,ijlev) > 0  ) &
                         &  d_out(jilev,ijlev) = z_fill(jilev,ijlev) / d_n(jilev,ijlev)

                 ENDIF

              ENDDO
           CASE DEFAULT 
              PRINT *, ' METHOD ', imethod ,'is not recognized in this program'
              STOP 99

           END SELECT  ! imethod
           IF ( ALLOCATED(z_fill) ) DEALLOCATE( z_fill )

        ENDIF !  filling points
        ! ----------------------------------------------------------------------------------------
        ! write 
        ierr = putvar(ncout, id_varout(1), REAL(d_out(:,:)), jk, npilev, npjlev, ktime=jt)
     ENDDO ! jk

  END DO ! loop on time

  ierr = closeout(ncout)

CONTAINS

  REAL(KIND=4) FUNCTION etobd(plonr, platr, plon, plat)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION etobd  ***
    !!
    !! ** Purpose :
    !!           Compute the beta plane distance between two lon/lat values 
    !!
    !! ** Method  : 
    !!           Return the distance (km) between 2 points given in the
    !!           arguments with their latitudes and longitudes
    !!----------------------------------------------------------------------
    REAL(KIND=4), INTENT(in) :: plonr, platr, plon, plat  ! lon/lat of the 2 input points

    REAL(KIND=8), PARAMETER  :: dp_p1 = 1.745329D-02  ! radians per degree
    REAL(KIND=8), PARAMETER  :: dp_p2 = 111.1940D0    ! dp_p1 * earth radius in km (6370.949)

    REAL(KIND=8)             :: dl_rx, dl_ry          ! working double prec variables
    REAL(KIND=8)             :: dl_r0
    REAL(KIND=8)             :: dl_r1, dl_r2
    !!----------------------------------------------------------------------
    dl_r0 = DBLE(plonr) ; IF ( dl_r0 < 0.d0 ) dl_r0 = dl_r0 + 360.d0
    dl_r1 = DBLE(plon ) ; IF ( dl_r1 < 0.d0 ) dl_r1 = dl_r1 + 360.d0

    dl_rx = dl_r1 - dl_r0
    IF ( dl_rx > 180. ) THEN
       dl_rx = dl_rx - 360.d0
    ELSE IF ( dl_rx < -180.d0 ) THEN
       dl_rx = dl_rx + 360.d0
    ELSE IF ( ABS(dl_rx) == 180.d0 ) THEN
       dl_rx = 180.d0
    ENDIF
    dl_r2 = DBLE(plat) - DBLE(platr)

    dl_rx = dp_p2 * dl_rx * COS(dp_p1*platr)
    dl_ry = dp_p2 * dl_r2

    etobd = REAL(SQRT(dl_rx*dl_rx + dl_ry*dl_ry))

  END FUNCTION etobd


  SUBROUTINE btoe(plonr, platr, plon, plat, plx, ply)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE btoe  ***
    !!
    !! ** Purpose :  Return position (lon/lat) of a point located at
    !!               a given distance from the original point
    !!
    !! ** Method  :  Trigo ... 
    !!
    !!----------------------------------------------------------------------
    REAL(KIND=4), INTENT(in)  :: plonr, platr, plx, ply
    REAL(KIND=4), INTENT(out) :: plon, plat

    REAL(KIND=8), PARAMETER   :: dp_p1= 1.745329D-02  ! radians per degree
    REAL(KIND=8), PARAMETER   :: dp_p2= 111.1940D0    ! dp_p1 * earth radius in km (6370.949)
    REAL(KIND=8)              :: dl_rx, dl_ry
    REAL(KIND=8)              :: dl_r0
    REAL(KIND=8)              :: dl_r1, dl_r2, dl_r3
    !!----------------------------------------------------------------------
    dl_r0 = DBLE(plonr) ; IF ( dl_r0 < 0.d0 ) dl_r0 = dl_r0 + 360.d0
    dl_rx = DBLE(plx  )
    dl_r2 = DBLE(platr)
    dl_r1 = dl_r0 + dl_rx / ( dp_p2 * COS(dp_p1*dl_r2) )
    dl_r3 = dl_r2 + ply   / dp_p2
    plon  = REAL(dl_r1)
    IF ( plon <    0. ) plon = plon + 360.
    IF ( plon >= 360. ) plon = plon - 360.
    plat = REAL(dl_r3)
    IF ( plat >  90. ) plat =  90.
    IF ( plat < -90. ) plat = -90.

  END SUBROUTINE btoe

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
  ! get list of variable names and collect attributes in stypvar (optional)
  cv_names(:) = getvarname(cf_in, nvars, stypvar)

  id_var(:)   = (/(jvar, jvar=1,nvars)/)
  ! ipk gives the number of level or 0 if not a T[Z]YX  variable
  ipk(:)     = getipk(cf_in, nvars)
  WHERE( ipk == 0 ) cv_names='none'
  stypvar(:)%cname = cv_names

  ! select variables to output:
  ii=1
  DO jk=1,nvars
     IF ( TRIM(cv_names(jk)) == TRIM(cv_nam) ) THEN
        ipkout(ii) = ipk(jk)
        stypvarout(ii) = stypvar(jk)
        stypvar(ii)%ichunk  = (/npilev,MAX(1,npjlev/30),1,1 /)
     ENDIF
  ENDDO

  ! create output fileset
  ncout = create      (cf_out,  cf_in, npilev, npjlev, npk ,cdlonvar='lon', cdlatvar='lat', ld_nc4=lnc4 )
  ierr  = createvar   (ncout ,  stypvarout, 1,      ipkout,    id_varout                  , ld_nc4=lnc4 )
  ierr  = putheadervar(ncout ,  cf_in, npilev, npjlev, npk , pnavlon=rlonlev, pnavlat=rlatlev )

  dtim = getvar1d(cf_in, cn_vtimec, npt     )
  ierr = putvar1d(ncout, dtim,      npt, 'T')

  ierr = gettimeatt(cf_in, cn_vtimec, ctcalendar, cttitle, ctlong_name, ctaxis, ctunits, cttime_origin )
  ierr = puttimeatt(ncout, cn_vtimec, ctcalendar, cttitle, ctlong_name, ctaxis, ctunits, cttime_origin )
  ierr = putvar1d( ncout, rlonlev(:,1), npilev, 'X')
  ierr = putvar1d( ncout, rlatlev(1,:), npjlev, 'Y')

  END SUBROUTINE CreateOutput

END PROGRAM cdf2regular

PROGRAM cdfdegradw
  !!======================================================================
  !!                   ***  PROGRAM  cdfdegradw  ***
  !!=====================================================================
  !!  ** Purpose : Degrade horizontal resolution of NEMO gridW output
  !!
  !!  ** Method  : Degradation procedure ensuring the conservation
  !!               of water fluxes.
  !!
  !! History : 1.0 : 11/2011  : X. Meunier : Original code
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: nflsdc           ! array for fluid sub-domain counter
  INTEGER(KIND=4), DIMENSION(:),     ALLOCATABLE :: ipk, id_varout, id_varout2
  INTEGER(KIND=4)                           :: ji, jj, jk, jt, jri, jrj   ! dummy loop index
  INTEGER(KIND=4)                           :: ik, ii, ij         !
  INTEGER(KIND=4)                           :: ix, iy             !
  INTEGER(KIND=4)                           :: ierr               ! error status
  INTEGER(KIND=4)                           :: nri=1, nrj=1       ! scale degrading factor along i and j  
  INTEGER(KIND=4)                           :: iimin=2            ! indice from where the filtering begins
  INTEGER(KIND=4)                           :: ijmin=2            ! indice from where the filtering begins
  INTEGER(KIND=4)                           :: narg, iargc, ijarg ! browse command line
  INTEGER(KIND=4)                           :: npiglo, npjglo     ! size of the domain
  INTEGER(KIND=4)                           :: npk, npt           ! size of the domain
  INTEGER(KIND=4)                           :: ncout, ncout2      ! ncid of output file
  INTEGER(KIND=4)                           :: msks               ! mask sum on each coarse cells
  INTEGER(KIND=4)                           :: nvpk               ! vertical levels in working variable
  INTEGER(KIND=4)                           :: ikx=1, iky=1       ! dims of netcdf output file

  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: glamf, gphif       ! lon, lat
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e1, e2, zv         ! metrics, variable
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: rdumlon, rdumlat   ! dummy lon/lat for output file
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: rdummymean         ! array for mean value on output file
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zmask              ! 2D mask at current level
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: tim                ! time counter
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: gdep               ! depth 
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: zdep               ! depth of the whole vertical levels
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: e31d               ! 1d vertical spacing
  REAL(KIND=4)                              :: zspval             ! missing value

  REAL(KIND=8)                              :: dvol, dsum, dsurf  ! cumulated values
  REAL(KIND=8)                              :: dvol2d, dsum2d     !

  CHARACTER(LEN=256)                        :: cf_wfil            ! input filename
  CHARACTER(LEN=256)                        :: cf_ncout,cf_ncout2 ! output file name
  !
  CHARACTER(LEN=256)                        :: cv_nam             ! current variable name
  CHARACTER(LEN=256)                        :: cv_dep             ! deptht name
  CHARACTER(LEN=20)                         :: cv_e1, cv_e2       ! horizontal metrics names
  CHARACTER(LEN=20)                         :: cv_e3, cv_e31d     ! vertical metrics names
  CHARACTER(LEN=20)                         :: cv_msk             ! mask variable name
  !
  CHARACTER(LEN=256)                        :: clunits            ! attribute of output file : units
  CHARACTER(LEN=256)                        :: cllong_name        !     "      long name
  CHARACTER(LEN=256)                        :: cglobal            !     "      global 
  CHARACTER(LEN=256)                        :: clshort_name       !     "      short name
  CHARACTER(LEN=256)                        :: cldum              ! dummy char variable

  TYPE(variable), DIMENSION(:), ALLOCATABLE :: stypvar            ! structure of output
  TYPE(variable), DIMENSION(:), ALLOCATABLE :: stypvar2           ! structure of sub-domain counter output

  LOGICAL                                   :: lfull     = .false.! full step  flag
  LOGICAL                                   :: lchk               ! flag for missing files
 
 !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfdegradw IN-Wfile IN-var ri rj [i0 j0]'
     PRINT *,'       ... [-full]'
     PRINT *,'       '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Degrad the horizontal resolution of NEMO W-grid ouput,       ' 
     PRINT *,'       for each z-level and time step, with a ratio of ri along     '
     PRINT *,'       x direction and rj along y direction. If specified, the input'
     PRINT *,'       grid is considered starting from the indices i0 and j0.      ' 
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       IN-Wfile  : netcdf W-file.' 
     PRINT *,'       IN-var    : name of netcdf variable to work with' 
     PRINT *,'       ri        : degradation ratio for x-direction   ' 
     PRINT *,'       rj        : degradation ratio for y-direction   ' 
     PRINT *,'      '
     PRINT *,'     OPTIONS : '
     PRINT *,'       [i0 j0] : spatial indices from where starting the procedure   '
     PRINT *,'                 of degradation.                                    ' 
     PRINT *,'       [-full] : flag for full steps grid, instead of default partial'
     PRINT *,'                 steps.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       Files ', TRIM(cn_fhgr),', ', TRIM(cn_fzgr),', ', TRIM(cn_fmsk)
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : degraded_cdfvar.nc '
     PRINT *,'       netcdf file : flsdc.nc'
     PRINT *,'      '
    STOP
  ENDIF

  cglobal = 'Partial step computation'
  ijarg = 1 ; ii = 0
  DO WHILE ( ijarg <= narg )
     CALL getarg(ijarg, cldum ) ; ijarg = ijarg + 1 
     SELECT CASE (cldum) 
     CASE ('-full' )
        lfull = .true. 
        cglobal = 'full step computation'
     CASE DEFAULT 
         ii=ii+1
        SELECT CASE (ii) 
        CASE ( 1 ) ; cf_wfil  = cldum 
        CASE ( 2 ) ; cv_nam = cldum 
        CASE ( 3 ) ; READ(cldum,*) nri  
        CASE ( 4 ) ; READ(cldum,*) nrj  
        CASE ( 5 ) ; READ(cldum,*) iimin
        CASE ( 6 ) ; READ(cldum,*) ijmin
        CASE DEFAULT
          PRINT *, ' ERROR : Too many arguments ...'
          STOP 99
        END SELECT
     END SELECT
  END DO

  lchk = chkfile(cn_fhgr)
  lchk = chkfile(cn_fzgr) .OR. lchk
  lchk = chkfile(cn_fmsk) .OR. lchk
  lchk = chkfile(cf_wfil) .OR. lchk
  IF ( lchk ) STOP 99 ! missing file

  cv_dep = 'none'
  npiglo = getdim (cf_wfil, cn_x)
  npjglo = getdim (cf_wfil, cn_y)
  npk    = getdim (cf_wfil, cn_z, cdtrue=cv_dep, kstatus=ierr)

  IF (ierr /= 0 ) THEN
     npk   = getdim (cf_wfil, 'z', cdtrue=cv_dep, kstatus=ierr)
     IF (ierr /= 0 ) THEN
        npk   = getdim (cf_wfil, 'sigma', cdtrue=cv_dep, kstatus=ierr)
        IF ( ierr /= 0 ) THEN
           npk = getdim (cf_wfil, 'nav_lev', cdtrue=cv_dep, kstatus=ierr)
           IF ( ierr /= 0 ) THEN
              PRINT *,' assume file with no depth'
              npk=0
           ENDIF
        ENDIF
     ENDIF
  ENDIF

  npt    = getdim (cf_wfil, cn_t)
  nvpk   = getvdim(cf_wfil, cv_nam)

  IF (npk   == 0 ) THEN ; npk = 1;  ENDIF ! no depth dimension ==> 1 level
  IF (iimin < 2 )  THEN
     PRINT *,'iimin value is too low'
     STOP 99
  END IF
  IF (ijmin  < 2 ) THEN
     PRINT *,'ijmin value is too low'
     STOP 99
  END IF
  npiglo = ( (npiglo - iimin ) / nri )*nri
  npjglo = ( (npjglo - ijmin ) / nrj )*nrj
  ikx = npiglo / nri
  iky = npjglo / nrj

  PRINT *,'ikx    : ',ikx
  PRINT *,'iky    : ',iky

  IF (nvpk == 2 ) npk = 1
  ! IF (nvpk == 3 ) nvpk = npk

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt
  PRINT *, 'nvpk   = ', nvpk
  PRINT *, 'depth dim name is ',TRIM(cv_dep)

  ! Allocate arrays
  ALLOCATE (zmask(npiglo,npjglo) )
  ALLOCATE (zv(npiglo,npjglo) )
  ALLOCATE (e1(npiglo,npjglo), e2(npiglo,npjglo) )
  ALLOCATE (gdep (npk), e31d(npk), tim(npt) )
  ALLOCATE (zdep(npk) )

  cv_e1    = cn_ve1t
  cv_e2    = cn_ve2t
  cv_e3    = 'e3w_ps'
  cv_e31d  = cn_ve3w1d
  cv_msk = 'tmask'
  cv_dep   = cn_gdepw
 
  e1(:,:) = getvar  (cn_fhgr, cv_e1,  1,  npiglo, npjglo, kimin=iimin, kjmin=ijmin)
  e2(:,:) = getvar  (cn_fhgr, cv_e2,  1,  npiglo, npjglo, kimin=iimin, kjmin=ijmin)
  IF ( lfull )  e31d(:) = getvare3(cn_fzgr, cv_e31d, npk)
  zdep(:) = getvare3(cn_fzgr, cv_dep, npk)
  gdep(:) = zdep(  1  :npk)

  ALLOCATE ( stypvar( 1 ), ipk( 1 ), id_varout( 1 ) )
  ALLOCATE ( stypvar2( 1 ), id_varout2( 1 ) )
  ALLOCATE ( rdumlon(ikx,iky), rdumlat(ikx,iky), rdummymean(ikx,iky) ) 
  ALLOCATE ( nflsdc(ikx,iky) )
  ALLOCATE ( glamf(npiglo+1,npjglo+1), gphif(npiglo+1,npjglo+1))

  glamf = getvar(cn_fhgr, cn_glamf, 1, npiglo+1 , npjglo+1 , kimin=iimin-1 , kjmin=ijmin-1 )
  gphif = getvar(cn_fhgr, cn_gphif, 1, npiglo+1 , npjglo+1 , kimin=iimin-1 , kjmin=ijmin-1 )
  DO jj=1,iky
     DO ji=1,ikx
        rdumlat(ji,jj) = 0.5 * ( gphif((ji-1)*nri+1,(jj-1)*nrj+1) + gphif( ji   *nri+1,jj*nrj+1) )
        rdumlon(ji,jj) = 0.5 * ( glamf( ji   *nri+1,(jj-1)*nrj+1) + glamf((ji-1)*nri+1,jj*nrj+1) )
     END DO
  END DO

  ipk(:) = npk ! mean for each level

  ierr=getvaratt (cf_wfil, cv_nam, clunits, zspval, cllong_name, clshort_name)

  ! define new variables for output 
  stypvar%rmissing_value    = 99999.
  stypvar%scale_factor      = 1.
  stypvar%add_offset        = 0.
  stypvar%savelog10         = 0.
  stypvar%conline_operation = 'N/A'

  stypvar%cunits         = TRIM(clunits)
  stypvar%valid_min      = -100000.
  stypvar%valid_max      = 100000.
  stypvar%cname          = 'degraded_'//TRIM(cv_nam)
  stypvar%clong_name     = 'degraded '//TRIM(cllong_name)
  stypvar%cshort_name    = 'degraded_'//TRIM(clshort_name)

  stypvar2%rmissing_value    = 99999.
  stypvar2%scale_factor      = 1.
  stypvar2%add_offset        = 0.
  stypvar2%savelog10         = 0.
  stypvar2%conline_operation = 'N/A'

  stypvar2%valid_min      = 0.
  stypvar2%valid_max      = 100000.
  stypvar2%cname          = 'flsdc'
  stypvar2%clong_name     = 'fluid sub-domain counter'
  stypvar2%cshort_name    = 'fdsdc'

  IF ( nvpk == 2 ) THEN
     stypvar%caxis       = 'TYX'
     stypvar2%caxis      = 'YX'
  ELSE
     stypvar%caxis       = 'TZYX'
     stypvar2%caxis      = 'ZYX'
  END IF

  ! create output fileset
  cf_ncout  = 'degraded_'//TRIM(cv_nam)//'.nc'
  cf_ncout2 = 'flsdc.nc'
  ncout  = create      (cf_ncout ,   'none',  ikx,   iky,   npk, cdep=cv_dep)
  ncout2 = create      (cf_ncout2,   'none',  ikx,   iky,   npk, cdep=cv_dep)
  ierr  = createvar   (ncout ,      stypvar , 1 , ipk,   id_varout  , cdglobal=TRIM(cglobal) ) 
  ierr  = createvar   (ncout2,      stypvar2, 1 , ipk,   id_varout2 , cdglobal=TRIM(cglobal) ) 
  ierr  = putheadervar(ncout ,      cf_wfil,  ikx, iky, npk, pnavlon=rdumlon, pnavlat=rdumlat, pdep=gdep, cdep=cv_dep)
  ierr  = putheadervar(ncout2,      cn_fmsk,  ikx, iky, npk, pnavlon=rdumlon, pnavlat=rdumlat, pdep=gdep, cdep=cv_dep)
  tim   = getvar1d(cf_wfil, cn_vtimec, npt)
  ierr  = putvar1d(ncout,  tim,       npt, 'T')

  DO jk = 1, npk
     ik = jk
     ! Get variable v at ik
     zmask(:,:) = getvar(cn_fmsk, cv_msk, ik, npiglo, npjglo, kimin=iimin, kjmin=ijmin          )
     DO jt=1,npt
        ! 
        zv   (:,:) = getvar(cf_wfil,  cv_nam,   ik, npiglo, npjglo, kimin=iimin, kjmin=ijmin, ktime=jt)
        DO jj=1,iky
           DO ji=1,ikx
              dvol = 0.d0
              dsum = 0.d0
              msks = 0
              DO jrj=1,nrj
                 DO jri=1,nri
                    ix = (ji-1)*nri+jri
                    iy = (jj-1)*nrj+jrj
                    dvol2d = e1(ix,iy) * e2(ix,iy) * zmask(ix,iy)
                    msks = msks + zmask(ix,iy)
                    dvol = dvol + dvol2d
                    dsum = dsum + zv(ix,iy) * dvol2d
                 END DO
              END DO
              IF ( dvol > 0.d0 ) THEN
                 rdummymean(ji,jj) = dsum/dvol
              ELSE
                 rdummymean(ji,jj) = 99999.
              END IF
              nflsdc(ji,jj) = msks
           END DO
        END DO
        ierr = putvar(ncout , id_varout(1), rdummymean , jk, ikx, iky, ktime=jt )
     END DO ! time loop
     ierr = putvar(ncout2, id_varout2(1), DBLE(nflsdc), jk, ikx, iky )
  END DO  

  ierr = closeout(ncout )
  ierr = closeout(ncout2)

9004 FORMAT(f9.2,' ',i2,' ',f9.2)

END PROGRAM cdfdegradw

PROGRAM cdfimprovechk
  !!======================================================================
  !!                     ***  PROGRAM  cdfimprovechk  ***
  !!=====================================================================
  !!  ** Purpose : Estimate the improvement/deterioration of a test run, 
  !!               compared with a reference run relative to some observations
  !!
  !!  ** Method  : Given zobs (observed field), zref (reference run field)
  !!               and ztst (test run field), compute zchk as the ratio:
  !!                 zchk=(zref - ztst) / (zref - zobs )
  !!
  !!               Where  0 < zchk <=1 correction act in the right direction
  !!               Where  1 < zchk     correction is too strong, in the right way
  !!               Where  zchk < 0     correction is in the wrong way (deterioration)
  !!
  !! History : 2.1  : 11/2005  : J.M. Molines : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class miscellaneous
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: jk, jt            ! dummy loop index
  INTEGER(KIND=4)                           :: ierr              ! working integer
  INTEGER(KIND=4)                           :: narg, iargc, ijarg! browse line
  INTEGER(KIND=4)                           :: npiglo, npjglo    ! size of the domain
  INTEGER(KIND=4)                           :: npk, npt          ! size of the domain
  INTEGER(KIND=4)                           :: nvpk              ! dim of the working variable
  INTEGER(KIND=4)                           :: ncout             ! ncid of output file
  INTEGER(KIND=4), DIMENSION(1)             :: ipk, id_varout    ! levels and varid of output vars

  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zobs              ! observation array
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zref              ! reference array
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: ztst              ! test array
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zmask             ! 2D mask at surface
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zchk              ! check index output

  REAL(KIND=8), DIMENSION(:),   ALLOCATABLE :: dtim              ! time counter

  CHARACTER(LEN=256)                        :: cf_obs            ! observation-file name
  CHARACTER(LEN=256)                        :: cf_ref            ! reference-file name
  CHARACTER(LEN=256)                        :: cf_tst            ! test-file name
  CHARACTER(LEN=256)                        :: cv_in             ! cdf variable name
  CHARACTER(LEN=256)                        :: cf_out='chk.nc'   ! output filename
  CHARACTER(LEN=256)                        :: cldum             ! working char variable

  TYPE (variable), DIMENSION(1)             :: stypvar           ! structure for attributes

  LOGICAL                                   :: lnc4 = .FALSE.    ! Use nc4 with chunking and deflation
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfimprovechk -v IN-var -obs OBS-file -r REF-file -t TST-file ...'
     PRINT *,'                ... [-o OUT-file] [-nc4]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'        Estimates the improvement/deterioration of a test run, compared with a'
     PRINT *,'        reference run relative to some observations.'
     PRINT *,'        This program computes the field zchk= ( REF - TST )/(REF - OBS).'
     PRINT *,'        Where 0 < zchk <= 1, the TST is better than the reference'
     PRINT *,'        Where 1 < zchk, the TST  was corrected in the right sense but too much'
     PRINT *,'        Where  zchk < 0, the TST  was corrected was corrected in the wrong way.'
     PRINT *,'        Although not very much used, this program is maintained as one of the'
     PRINT *,'        first CDFTOOLS.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'        -v IN-var    : netcdf input variable'
     PRINT *,'        -obs OBS-file: netcdf observation file'
     PRINT *,'        -r REF-file  : netcdf reference file'
     PRINT *,'        -t TST-file  : netcdf test file'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'        [-o OUT-file] : specifiy the output file name instead of ',TRIM(cf_out)
     PRINT *,'        [-nc4]    : Use netcdf4 output with chunking and deflation level 1.'
     PRINT *,'               This option is effective only if cdftools are compiled with'
     PRINT *,'               a netcdf library supporting chunking and deflation.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       none' 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : same as input variable.'
     PRINT *,'      '
     STOP 
  ENDIF

  ijarg=1
  DO WHILE (ijarg <= narg )
     CALL getarg(ijarg,cldum) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-v'  ) ; CALL getarg(ijarg,cv_in ) ; ijarg=ijarg+1
     CASE ( '-obs') ; CALL getarg(ijarg,cf_obs) ; ijarg=ijarg+1
     CASE ( '-r'  ) ; CALL getarg(ijarg,cf_ref) ; ijarg=ijarg+1
     CASE ( '-t'  ) ; CALL getarg(ijarg,cf_tst) ; ijarg=ijarg+1
        ! options
     CASE ( '-o'  ) ; CALL getarg(ijarg,cf_out) ; ijarg=ijarg+1
     CASE ( '-nc4') ; lnc4 = .TRUE.
     CASE DEFAULT   ; PRINT *,' ERROR : ',TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  ENDDO

  IF ( chkfile(cf_obs) .OR. chkfile(cf_ref) .OR. chkfile(cf_tst) ) STOP 99 ! missing files

  npiglo = getdim(cf_ref, cn_x)
  npjglo = getdim(cf_ref, cn_y)
  npk    = getdim(cf_ref, cn_z)
  npt    = getdim(cf_ref, cn_t)

  nvpk   = getvdim(cf_ref, cv_in)
  IF (nvpk == 2 ) nvpk = 1
  IF (nvpk == 3 ) nvpk = npk

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  ALLOCATE (zobs(npiglo,npjglo), zref(npiglo,npjglo), ztst(npiglo,npjglo), zmask(npiglo,npjglo))
  ALLOCATE (zchk(npiglo,npjglo), dtim(npt) )

  CALL CreateOutput
  zref  = 0. ;   zobs  = 0. ;  zmask = 1.

  DO jt = 1,npt
     DO jk = 1,npk
        PRINT *,'level ',jk
        zchk = 0.
        zobs(:,:) = getvar(cf_obs, cv_in, jk ,npiglo, npjglo, ktime=jt)
        zref(:,:) = getvar(cf_ref, cv_in, jk ,npiglo, npjglo, ktime=jt)
        ztst(:,:) = getvar(cf_tst, cv_in, jk ,npiglo, npjglo, ktime=jt)

        IF (jk == 1  )  THEN
           WHERE( zref == 0. ) zmask = 0.
        END IF
        WHERE  ( (zref - zobs ) /= 0 ) 
           zchk = (zref - ztst ) / ( zref - zobs) * zmask
        END WHERE
        ierr = putvar(ncout, id_varout(1), zchk, jk, npiglo, npjglo, ktime=jt)
     END DO
  END DO

  ierr = closeout(ncout)

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    ipk(:)                       = nvpk  ! all variables 
    stypvar(1)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(1)%cname             = TRIM(cv_in)
    stypvar(1)%cunits            = '%'
    stypvar(1)%rmissing_value    = 0.
    stypvar(1)%valid_min         = 0.
    stypvar(1)%valid_max         = 100.
    stypvar(1)%clong_name        = 'Checking ratio for'//TRIM(cv_in)
    stypvar(1)%cshort_name       = cv_in
    stypvar(1)%conline_operation = 'N/A'

    IF (nvpk == npk ) stypvar(1)%caxis='TZYX'
    IF (nvpk == 1   ) stypvar(1)%caxis='TYX'

    ! create output fileset

    ncout = create      (cf_out, cf_ref,  npiglo, npjglo, npk       , ld_nc4=lnc4 )
    ierr  = createvar   (ncout,  stypvar, 1,      ipk,    id_varout , ld_nc4=lnc4 )
    ierr  = putheadervar(ncout,  cf_ref,  npiglo, npjglo, npk       )

    dtim = getvar1d(cf_ref, cn_vtimec, npt     )
    ierr = putvar1d(ncout,  dtim,      npt, 'T')

  END SUBROUTINE CreateOutput

END PROGRAM cdfimprovechk

PROGRAM cdfbci
  !!======================================================================
  !!                     ***  PROGRAM  cdfbci  ***
  !!=====================================================================
  !!  ** Purpose : Compute the term of energetic transfert BCI
  !!               for the baroclinic instability
  !!
  !!  ** Method  : take  an input file which is the result of a preprocessing
  !!               tool cdfmoyuvwt.
  !!
  !! History : 2.1  : 02/2008  : A. Melet     : Original code
  !!           3.0  : 12/2010  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2010, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: ji, jj, jk
  INTEGER(KIND=4)                           :: ilev
  INTEGER(KIND=4)                           :: npiglo, npjglo, npk, npt
  INTEGER(KIND=4)                           :: narg, iargc
  INTEGER(KIND=4)                           :: ncout, ierr
  INTEGER(KIND=4), DIMENSION(5)             :: ipk, id_varout         ! 

  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: tim
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e2t, e1t 
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: anout, anovt, un, vn, tn
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: utn, vtn
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: tmask, umask, vmask
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: bci
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: rdtdx, rdtdy

  CHARACTER(LEN=256)                        :: cf_in
  CHARACTER(LEN=256)                        :: cf_out='bci.nc'

  TYPE (variable), DIMENSION(5)             :: stypvar         !: structure for attibutes
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()   ! load cdf variable name

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfbci UVWT-file'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute elements for analysing the baroclinic instability' 
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       UVWT-file : input file is produced by cdfmoyuvwt, and the mean'
     PRINT *,'              must be computed on a long-enough period for the ' 
     PRINT *,'              statistics to be meaningful. Points are on T grid.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       Need ', TRIM(cn_fhgr) ,' file'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : 5 output variables'
     PRINT *,'             dTdx : zonal derivative of Tbar on T point (*1000)'
     PRINT *,'             dTdy : meridional derivative of Tbar on T point (*1000)'
     PRINT *,'             uT   : anomaly of u times anomaly of T on T point'
     PRINT *,'             vT   : anomaly of v times anomaly of T on T point'
     PRINT *,'             bci  : transfert of energy for the baroclinic instability (*1000)'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'       cdfmoyuvwt '
     STOP
  ENDIF

  CALL getarg(1, cf_in)
  IF (chkfile(cf_in) .OR. chkfile (cn_fhgr) ) STOP 99

  npiglo = getdim(cf_in, cn_x)
  npjglo = getdim(cf_in, cn_y)
  npk    = getdim(cf_in, cn_z)
  npt    = getdim(cf_in, cn_t)

  PRINT *, 'npiglo =', npiglo
  PRINT *, 'npjglo =', npjglo
  PRINT *, 'npk    =', npk
  PRINT *, 'npt    =', npt

  ! define new variables for output ( must update att.txt)
  stypvar(1)%cname       = 'dTdx'
  stypvar(1)%clong_name  = 'zonal derivate of Tbar on T point (*1000)'
  stypvar(1)%cshort_name = 'dTdx'

  stypvar(2)%cname       = 'dTdy'
  stypvar(2)%clong_name  = 'meridional derivate of Tbar on T point (*1000)'
  stypvar(2)%cshort_name = 'dTdy'
 
  stypvar(3)%cname       = 'uT'
  stypvar(3)%clong_name  = 'anomaly of u times anomaly of T on T point'
  stypvar(3)%cshort_name = 'uT'
  
  stypvar(4)%cname       = 'vT'
  stypvar(4)%clong_name  = 'anomaly of v times anomaly of T on T point'
  stypvar(4)%cshort_name = 'vT'

  stypvar(5)%cname       = 'bci'
  stypvar(5)%clong_name  = 'transfert of energy for the baroclinic instability (*1000)'
  stypvar(5)%cshort_name = 'bci'

  stypvar%cunits            = '1000 (u"T" dT/dx + v"T" dT/dy)'
  stypvar%rmissing_value    = 0.
  stypvar%valid_min         = -1000.
  stypvar%valid_max         = 1000.
  stypvar%conline_operation = 'N/A'
  stypvar%caxis             = 'TYX'

  ipk(:) = npk  
  
  !test if lev exists
  IF ((npk==0) .AND. (ilev > 0) ) THEN
     PRINT *, 'Problem : npk = 0 and lev > 0 STOP'
     STOP 99
  END IF

  ! create output fileset
  ncout = create      (cf_out,   cf_in,   npiglo, npjglo, npk       )
  ierr  = createvar   (ncout ,   stypvar, 5,      ipk,    id_varout )
  ierr  = putheadervar(ncout,    cf_in,   npiglo, npjglo, npk       )

  ! Allocate the memory
  ALLOCATE ( e1t(npiglo,npjglo) , e2t(npiglo,npjglo) )
  ALLOCATE ( un(npiglo,npjglo)  , vn(npiglo,npjglo)  )
  ALLOCATE ( tn(npiglo,npjglo) )
  ALLOCATE ( utn(npiglo,npjglo) , vtn(npiglo,npjglo) )
  ALLOCATE ( umask(npiglo,npjglo) , vmask(npiglo,npjglo) )
  ALLOCATE ( tmask(npiglo,npjglo) )
  ALLOCATE ( rdtdx(npiglo,npjglo)  , rdtdy(npiglo,npjglo)  )
  ALLOCATE ( anout(npiglo,npjglo)  , anovt(npiglo,npjglo)  )
  ALLOCATE ( bci(npiglo,npjglo), tim(npt) )

  e1t =  getvar(cn_fhgr, cn_ve1t, 1, npiglo, npjglo)
  e2t =  getvar(cn_fhgr, cn_ve2t, 1, npiglo, npjglo)

  tim  = getvar1d(cf_in, cn_vtimec, npt)
  ierr = putvar1d(ncout, tim, npt, 'T')
     
  DO jk=1, npk
     PRINT *,'            level ',jk
           
     rdtdx(:,:) = 0.0
     rdtdy(:,:) = 0.0
        
     anovt(:,:) = 0.0      
     anout(:,:) = 0.0

     un(:,:)  =  getvar(cf_in, 'ubar',  jk ,npiglo, npjglo, ktime=1)
     vn(:,:)  =  getvar(cf_in, 'vbar',  jk ,npiglo, npjglo, ktime=1)
     tn(:,:)  =  getvar(cf_in, 'tbar',  jk ,npiglo, npjglo, ktime=1)
     utn(:,:) =  getvar(cf_in, 'utbar', jk ,npiglo, npjglo, ktime=1)
     vtn(:,:) =  getvar(cf_in, 'vtbar', jk ,npiglo, npjglo, ktime=1)

     ! compute the mask
     DO jj = 2, npjglo
        DO ji = 2, npiglo
           umask(ji,jj)= un(ji,jj)*un(ji-1,jj) 
           vmask(ji,jj)= vn(ji,jj)*vn(ji,jj-1)
           tmask(ji,jj)= tn(ji,jj)
           IF (umask(ji,jj) /= 0.) umask(ji,jj)=1.
           IF (vmask(ji,jj) /= 0.) vmask(ji,jj)=1.
           IF (tmask(ji,jj) /= 0.) tmask(ji,jj)=1.
        END DO
     END DO

     DO jj = 2, npjglo  
        DO ji = 2, npiglo    ! vector opt.
           ! compute derivatives at T point
           rdtdx(ji,jj) = 1000/2. *( ( tn(ji,jj ) - tn(ji-1,jj) )      &
                &           * tmask(ji,jj)*tmask(ji-1,jj)              &
                &           / ( 0.5* ( e1t(ji,jj) + e1t(ji-1,jj) ))    &
                &           +( tn(ji+1,jj ) - tn(ji,jj) )              &
                &           * tmask(ji+1,jj)*tmask(ji,jj)              &
                &           / ( 0.5* ( e1t(ji+1,jj) + e1t(ji,jj) )))

           rdtdy(ji,jj) = 1000/2. *( ( tn(ji,jj) - tn(ji,jj-1) )       &
                &           * tmask(ji,jj)*tmask(ji,jj-1)              &
                &           / ( 0.5* ( e2t(ji,jj) + e2t(ji,jj-1) ))    &
                &           +( tn(ji,jj+1 ) - tn(ji,jj) )              &
                &           * tmask(ji,jj+1)*tmask(ji,jj)              &
                &           / ( 0.5* ( e2t(ji,jj+1) + e2t(ji,jj) )) )

           anout(ji,jj)    = ( utn(ji,jj)                                            &
                &                 -   1/2 * umask(ji,jj)*( un(ji,jj) + un(ji-1,jj) ) &
                &                   * tmask(ji,jj) * tn(ji,jj) )

           anovt(ji,jj)    = ( vtn(ji,jj)                                            &
                &                 -   1/2 * vmask(ji,jj)*( vn(ji,jj) + vn(ji,jj-1) ) &
                &                   * tmask(ji,jj) * tn(ji,jj) )

           ! compute bci term
           bci(ji,jj) = ( anout(ji,jj) * rdtdx(ji,jj) + anovt(ji,jj) * rdtdy(ji,jj) )

        END DO
     END DO
     ! 
     ierr = putvar(ncout, id_varout(1), rdtdx, jk, npiglo, npjglo, ktime=1)
     ierr = putvar(ncout, id_varout(2), rdtdy, jk, npiglo, npjglo, ktime=1)
     ierr = putvar(ncout, id_varout(3), anout, jk, npiglo, npjglo, ktime=1)
     ierr = putvar(ncout, id_varout(4), anovt, jk, npiglo, npjglo, ktime=1)
     ierr = putvar(ncout, id_varout(5), bci,   jk, npiglo, npjglo, ktime=1)
  END DO
  ierr = closeout(ncout)

END PROGRAM cdfbci

PROGRAM cdfgradT
  !!======================================================================
  !!                     ***  PROGRAM  cdfgradT ***
  !!=====================================================================
  !!  ** Purpose :
  !!
  !!  ** Method  :
  !!
  !! History : 3.0  : 05/2013  : N. Ducousso
  !!           3.0  : 06/2013  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  !!   routines      : description
  !!   CreateOutput  : perform all the stuff linked with output file 
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class derived_fields
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4), PARAMETER                  :: jp_varout = 6     ! number of output variables
  INTEGER(KIND=4)                             :: jk, jt            ! dummy loop index
  INTEGER(KIND=4)                             :: it                ! time index for vvl
  INTEGER(KIND=4)                             :: narg, iargc, ijarg! command line
  INTEGER(KIND=4)                             :: npiglo, npjglo    ! size of the domain
  INTEGER(KIND=4)                             :: npk, npt          ! size of the domain
  INTEGER(KIND=4)                             :: ncout             ! ncid of output variable
  INTEGER(KIND=4)                             :: ierr              ! error status
  INTEGER(KIND=4)                             :: iup = 1, icur = 2 ! 2 working level
  INTEGER(KIND=4)                             :: itmp              ! working integer for swapping arrays
  INTEGER(KIND=4), DIMENSION(jp_varout)       :: ipk, id_varout    ! output variable

  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: umask, vmask, wmask ! relevant mask
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: e1u, e2v, e3w     ! metrics
  REAL(KIND=4), DIMENSION(:,:,:), ALLOCATABLE :: zt, zs            ! Temperature Salinity on 2 levels

  REAL(KIND=8), DIMENSION(:),     ALLOCATABLE :: dtim              ! time variable
  REAL(KIND=8), DIMENSION(:,:),   ALLOCATABLE :: dgradt_x, dgradt_y, dgradt_z  ! Temperature gradient component
  REAL(KIND=8), DIMENSION(:,:),   ALLOCATABLE :: dgrads_x, dgrads_y, dgrads_z  ! Salinity gradient component

  CHARACTER(LEN=256)                         :: cldum               ! dummy character variable
  CHARACTER(LEN=256)                         :: cf_tfil             ! input file name for T and S
  CHARACTER(LEN=256)                         :: cf_sfil=''          ! input file name for S (optional)
  CHARACTER(LEN=256)                         :: cf_out = 'gradT.nc' ! output file name
  CHARACTER(LEN=256)                         :: cf_e3w              ! file with e3w metrics in case of vvl

  TYPE(variable), DIMENSION(jp_varout)       :: stypvar             ! output data structure

  LOGICAL                                    :: lchk = .FALSE.      ! flag for missing files
  LOGICAL                                    :: lnc4 = .FALSE.      ! flag for netcdf4 output
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfgradT -t T-file [-s S-file] [-o OUT-file] [-nc4] [-vvl W-file]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'      Compute horizontal and vertical gradient of temperature and salinity.'
     PRINT *,'      Results are saved at U point for zonal gradient, V point for meridional'
     PRINT *,'      gradient and W for vertical gradient.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -t T-file : File with ',TRIM(cn_votemper),' and ',TRIM(cn_vosaline),' variables' 
     PRINT *,'           If ',TRIM(cn_vosaline),' not in T-file consider the use of -s option.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-s S-file  ] : File with ',TRIM(cn_vosaline),' variable if not in T file'
     PRINT *,'       [-o OUT-file] : specify output file name, instead of ',TRIM(cf_out)
     PRINT *,'       [-nc4 ]       : Use netcdf4 output with chunking and deflation level 1.'
     PRINT *,'                 This option is effective only if cdftools are compiled with'
     PRINT *,'                 a netcdf library supporting chunking and deflation.'
     PRINT *,'       [-vvl W-file ] : use time-varying vertical metrics. W-file is a file '
     PRINT *,'                 where the time-varying vertical e3w metrics can be found.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ', TRIM(cn_fhgr),' ',TRIM(cn_fmsk),' and ',TRIM(cn_fzgr)
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         ',jp_varout,' variables : '
     PRINT *,'              vozogradt, vomegradt, vovegradt : 3 component of the temperature'
     PRINT *,'                          located respectively at U, V and W points'
     PRINT *,'              vozograds, vomegrads, vovegrads : 3 component of the salinity'
     PRINT *,'                          located respectively at U, V and W points'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'      cdfhgradb'
     PRINT *,'      '
     STOP 
  ENDIF

  ijarg=1
  DO WHILE ( ijarg <= narg )
     CALL getarg (ijarg, cldum) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-t'   ) ; CALL getarg (ijarg, cf_tfil ) ; ijarg=ijarg+1
        ! options
     CASE ( '-s'   ) ; CALL getarg (ijarg, cf_sfil ) ; ijarg=ijarg+1
     CASE ( '-o'   ) ; CALL getarg (ijarg, cf_out  ) ; ijarg=ijarg+1
     CASE ( '-nc4' ) ; lnc4   = .TRUE.
     CASE ( '-vvl' ) ; lg_vvl = .TRUE.
        ;              CALL getarg (ijarg, cf_e3w  ) ; ijarg=ijarg+1
     CASE DEFAULT    ; PRINT *,'ERROR : ', TRIM(cldum),' : Option not known.'
     END SELECT
  ENDDO

  IF ( cf_sfil == '' ) cf_sfil = cf_tfil
  IF ( lg_vvl        ) THEN
     cn_fe3w = cf_e3w
     cn_ve3w = cn_ve3wvvl
  ENDIF

  lchk = ( lchk .OR. chkfile(cf_tfil) )
  lchk = ( lchk .OR. chkfile(cf_sfil) )
  lchk = ( lchk .OR. chkfile(cn_fhgr) )
  lchk = ( lchk .OR. chkfile(cn_fzgr) )
  lchk = ( lchk .OR. chkfile(cn_fmsk) )
  IF (lg_vvl ) lchk = ( lchk .OR. chkfile(cf_e3w) )
  IF (lchk ) STOP 99 ! missing file

  npiglo = getdim (cf_tfil, cn_x)
  npjglo = getdim (cf_tfil, cn_y)
  npk    = getdim (cf_tfil, cn_z)
  npt    = getdim (cf_tfil, cn_t)

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  !!  Allocate arrays
  ALLOCATE (dtim(npt) )
  ALLOCATE (e1u  (npiglo,npjglo), e2v  (npiglo,npjglo), e3w  (npiglo,npjglo))
  ALLOCATE (umask(npiglo,npjglo), vmask(npiglo,npjglo), wmask(npiglo,npjglo))
  ALLOCATE (zt   (npiglo,npjglo,2), zs (npiglo,npjglo,2))
  ALLOCATE (dgradt_x(npiglo,npjglo), dgradt_y(npiglo,npjglo), dgradt_z(npiglo,npjglo))
  ALLOCATE (dgrads_x(npiglo,npjglo), dgrads_y(npiglo,npjglo), dgrads_z(npiglo,npjglo))

  CALL CreateOutput

  e1u =  getvar(cn_fhgr, cn_ve1u, 1, npiglo, npjglo)
  e2v =  getvar(cn_fhgr, cn_ve2v, 1, npiglo, npjglo)

  DO jt = 1,npt
     IF ( lg_vvl ) THEN ; it=jt
     ELSE               ; it=1
     ENDIF

     DO jk = npk, 1, -1  !! Main loop : (2 levels of T are required : iup, icur)

        PRINT *,'level ',jk
        ! read files
        IF ( jk == npk   ) THEN  ! first time need to read 2 levels
           zt(:,:,iup ) = getvar(cf_tfil, cn_votemper, jk-1, npiglo, npjglo, ktime=jt)
           zt(:,:,icur) = getvar(cf_tfil, cn_votemper, jk,   npiglo, npjglo, ktime=jt)
           zs(:,:,iup ) = getvar(cf_sfil, cn_vosaline, jk-1, npiglo, npjglo, ktime=jt)
           zs(:,:,icur) = getvar(cf_sfil, cn_vosaline, jk,   npiglo, npjglo, ktime=jt)
        ELSEIF ( jk == 1 ) THEN ! surface : vertical gradient is N/A
           iup = icur        
        ELSE                  ! only read iup, icur has been swapped
           zt(:,:,iup ) = getvar(cf_tfil, cn_votemper, jk-1, npiglo, npjglo, ktime=jt)
           zs(:,:,iup ) = getvar(cf_sfil, cn_vosaline, jk-1, npiglo, npjglo, ktime=jt)
        ENDIF

        e3w(:,:)   = getvar(cn_fe3w, cn_ve3w, jk, npiglo, npjglo, ktime=it, ldiom=.NOT.lg_vvl )

        umask(:,:) = getvar(cn_fmsk, cn_umask , jk, npiglo, npjglo )
        vmask(:,:) = getvar(cn_fmsk, cn_vmask , jk, npiglo, npjglo )
        wmask(:,:) = getvar(cn_fmsk, cn_tmask , jk, npiglo, npjglo )

        ! zonal grad located at U point at current level
        dgradt_x(:,:) = 0.d0
        dgradt_x(1:npiglo-1,:) = 1.d0 / e1u(1:npiglo-1,:) * &
             &                 ( zt(2:npiglo,:,icur) - zt(1:npiglo-1,:,icur) ) * umask(1:npiglo-1,:)
        dgrads_x(:,:) = 0.d0
        dgrads_x(1:npiglo-1,:) = 1.d0 / e1u(1:npiglo-1,:) * &
             &                 ( zs(2:npiglo,:,icur) - zs(1:npiglo-1,:,icur) ) * umask(1:npiglo-1,:)

        ! meridional grad located at V point at current level
        dgradt_y(:,:) = 0.d0
        dgradt_y(:,1:npjglo-1) = 1.d0 / e2v(:,1:npjglo-1) * &
             &                 ( zt(:,2:npjglo,icur) - zt(:,1:npjglo-1,icur) ) * vmask(:,1:npjglo-1)
        dgrads_y(:,:) = 0.d0
        dgrads_y(:,1:npjglo-1) = 1.d0 / e2v(:,1:npjglo-1) * &
             &                 ( zs(:,2:npjglo,icur) - zs(:,1:npjglo-1,icur) ) * vmask(:,1:npjglo-1)

        ! vertical grad located at W point 
        dgradt_z(:,:) = 0.d0
        dgradt_z(:,:) = 1.d0 / e3w(:,:) * ( zt(:,:,iup) - zt(:,:,icur) ) * wmask(:,:)
        dgrads_z(:,:) = 0.d0
        dgrads_z(:,:) = 1.d0 / e3w(:,:) * ( zs(:,:,iup) - zs(:,:,icur) ) * wmask(:,:)

        ! write
        ierr = putvar(ncout, id_varout(1), REAL(dgradt_x), jk, npiglo, npjglo, ktime=jt)
        ierr = putvar(ncout, id_varout(2), REAL(dgradt_y), jk, npiglo, npjglo, ktime=jt)
        ierr = putvar(ncout, id_varout(3), REAL(dgradt_z), jk, npiglo, npjglo, ktime=jt)
        ierr = putvar(ncout, id_varout(4), REAL(dgrads_x), jk, npiglo, npjglo, ktime=jt)
        ierr = putvar(ncout, id_varout(5), REAL(dgrads_y), jk, npiglo, npjglo, ktime=jt)
        ierr = putvar(ncout, id_varout(6), REAL(dgrads_z), jk, npiglo, npjglo, ktime=jt)

        ! swap levels and read only up
        itmp = iup ; iup  = icur ; icur = itmp

     END DO
  END DO

  ierr = closeout(ncout)

CONTAINS
  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Set up all things required for the output file, create
    !!               the file and write the header part. 
    !!
    !! ** Method  :  Use global module variables 
    !!
    !!----------------------------------------------------------------------
    ipk(:) = npk  !  3D

    stypvar(1)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(1)%cname             = 'vozogradt'
    stypvar(1)%cunits            = ''
    stypvar(1)%rmissing_value    = -1000.
    stypvar(1)%valid_min         = -1.
    stypvar(1)%valid_max         = 1.
    stypvar(1)%clong_name        = 'zonal temper gradient'
    stypvar(1)%cshort_name       = 'vozogradt'
    stypvar(1)%conline_operation = 'N/A'
    stypvar(1)%caxis             = 'TZYX'

    stypvar(2)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(2)%cname             = 'vomegradt'
    stypvar(2)%cunits            = ''
    stypvar(2)%rmissing_value    = -1000.
    stypvar(2)%valid_min         = -1.
    stypvar(2)%valid_max         = 1.
    stypvar(2)%clong_name        = 'meridional temper gradient'
    stypvar(2)%cshort_name       = 'vomegradt'
    stypvar(2)%conline_operation = 'N/A'
    stypvar(2)%caxis             = 'TZYX'

    stypvar(3)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(3)%cname             = 'vovegradt'
    stypvar(3)%cunits            = ''
    stypvar(3)%rmissing_value    = -1000.
    stypvar(3)%valid_min         = -1.
    stypvar(3)%valid_max         = 1.
    stypvar(3)%clong_name        = 'vertical temper gradient'
    stypvar(3)%cshort_name       = 'vovegradt'
    stypvar(3)%conline_operation = 'N/A'
    stypvar(3)%caxis             = 'TZYX'

    stypvar(4)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(4)%cname             = 'vozograds'
    stypvar(4)%cunits            = ''
    stypvar(4)%rmissing_value    = -1000.
    stypvar(4)%valid_min         = -1.
    stypvar(4)%valid_max         = 1.
    stypvar(4)%clong_name        = 'zonal saline gradient'
    stypvar(4)%cshort_name       = 'vozograds'
    stypvar(4)%conline_operation = 'N/A'
    stypvar(4)%caxis             = 'TZYX'

    stypvar(5)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(5)%cname             = 'vomegrads'
    stypvar(5)%cunits            = ''
    stypvar(5)%rmissing_value    = -1000.
    stypvar(5)%valid_min         = -1.
    stypvar(5)%valid_max         = 1.
    stypvar(5)%clong_name        = 'meridional saline gradient'
    stypvar(5)%cshort_name       = 'vomegrads'
    stypvar(5)%conline_operation = 'N/A'
    stypvar(5)%caxis             = 'TZYX'

    stypvar(6)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(6)%cname             = 'vovegrads'
    stypvar(6)%cunits            = ''
    stypvar(6)%rmissing_value    = -1000.
    stypvar(6)%valid_min         = -1.
    stypvar(6)%valid_max         = 1.
    stypvar(6)%clong_name        = 'vertical saline gradient'
    stypvar(6)%cshort_name       = 'vovegrads'
    stypvar(6)%conline_operation = 'N/A'

    ! create output fileset
    ncout = create      (cf_out, cf_tfil, npiglo, npjglo, npk       , ld_nc4=lnc4 )
    ierr  = createvar   (ncout,  stypvar, jp_varout, ipk, id_varout , ld_nc4=lnc4 )
    ierr  = putheadervar(ncout,  cf_tfil, npiglo, npjglo, npk       )

    dtim = getvar1d(cf_tfil, cn_vtimec, npt     )
    ierr = putvar1d(ncout,  dtim,       npt, 'T')

  END SUBROUTINE CreateOutput

END PROGRAM cdfgradT

PROGRAM cdfrhoproj
  !!======================================================================
  !!                     ***  PROGRAM  cdfrhoproj  ***
  !!=====================================================================
  !!  ** Purpose : This program is used to project any scalar on the A grid
  !!               onto given isopycnic surfaces.
  !!
  !!  ** Method  : Linear interpolation is used on the vertical to define
  !!               the depth of the given isopycn and linear interpolation
  !!               is also performed on the scalar to determine its value at
  !!               this depth.
  !!
  !! History :      :  1996    : J.M. Molines for SPEM in Dynamo
  !!                :  1999    : J.O. Beismann for OPA
  !!                :  2000    : J.M. Molines for normalization
  !!           2.1  : 11/2005  : J.M. Molines : netcdf 
  !!           3.0  : 05/2011  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class derived_fields
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                               :: ji, jj, jk, jsig, jt ! dummy loop index
  INTEGER(KIND=4)                               :: jfich, jvar          ! dummy loop index
  INTEGER(KIND=4)                               :: npiglo, npjglo       ! domain size
  INTEGER(KIND=4)                               :: npk, npsig=1, npt    ! domain size
  INTEGER(KIND=4)                               :: nvars, nvout=2       ! number of variables in/out
  INTEGER(KIND=4)                               :: narg, iargc          ! command line parser
  INTEGER(KIND=4)                               :: ijarg                ! command line parser
  INTEGER(KIND=4)                               :: ik0, ijk             ! working integer
  INTEGER(KIND=4)                               :: nfiles               ! file counter
  INTEGER(KIND=4)                               :: numlev=10            ! logical unit for rholev file
  INTEGER(KIND=4)                               :: ncout, ierr          ! netcdf working variables
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: ipk, id_varout       ! for output variables
  !
  REAL(KIND=4)                                  :: P1, P2               ! values used in the vertical interpolation
  REAL(KIND=4)                                  :: zalpha               ! working real
  REAL(KIND=4)                                  :: zspvalo=999999.      ! output special value
  REAL(KIND=4)                                  :: zspvali=0.           ! input special values
  REAL(KIND=4)                                  :: sigmin, sigstp       ! definition of sigma layers
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: zi, h1d              ! working 1D arrays
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: v2dint, zint, v2d    ! working 2D arrays
  REAL(KIND=4), DIMENSION(:,:,:),   ALLOCATABLE :: zsig, alpha          ! data and interp coef 3D

  REAL(KIND=8), DIMENSION(:),       ALLOCATABLE :: dtim                 ! time_counter

  CHARACTER(LEN=256)                            :: cf_rholev='rho_lev'  ! default name of rho_lev file
  CHARACTER(LEN=256)                            :: cf_dta               ! working input file
  CHARACTER(LEN=256)                            :: cf_rhofil            ! density reference file
  CHARACTER(LEN=256)                            :: cf_out               ! output file name
  CHARACTER(LEN=256)                            :: cf_iso = 'isopycdep.nc' ! default isodep file name
  CHARACTER(LEN=256)                            :: cv_in                ! input variable
  CHARACTER(LEN=256)                            :: cv_sig               ! default density variable name
  CHARACTER(LEN=256)                            :: ctype='T'            ! default C-grid type
  CHARACTER(LEN=256)                            :: cldum                ! working char variable
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_names             ! temporary array for variable name in file
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cf_lst               ! list of input files

  TYPE(variable), DIMENSION(:),     ALLOCATABLE :: stypvar              ! structure for attributes (out)
  TYPE(variable), DIMENSION(:),     ALLOCATABLE :: stypzvar             ! structure for attributes (in)
  !
  LOGICAL                                       :: lsingle = .FALSE.    ! flag for use of -s0 option
  LOGICAL                                       :: lchk    = .FALSE.    ! flag for file existence
  LOGICAL                                       :: lisodep = .FALSE.    ! flag for isodep only computation
  LOGICAL                                       :: liso    = .TRUE.     ! flag for isodep computation
  LOGICAL                                       :: ldebug  = .FALSE.    ! flag for extra debugging print
  LOGICAL                                       :: lnc4    = .FALSE.    ! Use nc4 with chunking and deflation
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()
  cv_sig = cn_vosigma0

  narg=iargc()
  IF ( narg == 0  ) THEN
     PRINT *,' usage : cdfrhoproj-v IN-var -s RHO-file -l LST-files [-p C-type] [-debug]...'
     PRINT *,'       ... [-isodep] [-s0 sig0 | -s0 sigmin,sigstp,nsig] [-sig sigma_name]..'
     PRINT *,'       ... [-noiso] [-rholev TXT-file] [-o OUT-isodep] [-nc4] '
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       This program aims at projecting the model variable IN-var, from a list'
     PRINT *,'       of model files (LST-files) on some isopycnic surfaces, inferred from'
     PRINT *,'       a 3D density file, passed as one the arguments of the program. '
     PRINT *,'      '
     PRINT *,'       The density values corresponding to the isopycnic surfaces can be'
     PRINT *,'       specified in three ways :'
     PRINT *,'          1. Using a predefined text file ',TRIM(cf_rholev),' with density'
     PRINT *,'             values. The format is straightforward: one value per line, first'
     PRINT *,'             line giving the number of isopycnic to consider. (The default'
     PRINT *,'             name of this text file can be changed using -rholev option).'
     PRINT *,'          2. Using the -s0 option, with 3 parameters, defining equally spaced'
     PRINT *,'             isopycnic surfaces.'
     PRINT *,'          3. Using the -s0 option with only one parameter, defining then a'
     PRINT *,'             single surface.'
     PRINT *,'       '
     PRINT *,'     WARNING: This cdftool is one of the few using 3D arrays. Additional'
     PRINT *,'         development is required to work with vertical slabs instead.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -v IN-var   : name of the input variable to be projected' 
     PRINT *,'       -s RHO-file : netcdf file with potential density field. If not a sigma0'
     PRINT *,'             file, use -sig option to indicate the name of the density '
     PRINT *,'             variable.'
     PRINT *,'       -l LST-files: List of netcdf file with variable IN-var to process.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-s0 sigma  | -s0 sigmin,sigstp,nsig] : In the first form define a '
     PRINT *,'            single sigma surface, while in the 2nd form, it defines a set of'
     PRINT *,'            ''nsig'' density values, starting from ''sigmin'' and spaced every'
     PRINT *,'            ''sigstp''. This option prevails the use of ',TRIM(cf_rholev),' file.'
     PRINT *,'       [-rholev TXT-file] : Specify the name of the ''rholev'' text file, '
     PRINT *,'            instead of ',TRIM(cf_rholev),'.'
     PRINT *,'       [-p C-type] : position of IN-var on the C-grid ( either T U V F W S ),'
     PRINT *,'            default is ''T''. ''S'' special point is used in case of section'
     PRINT *,'            files created by cdf_xtract_brokenline.'
     PRINT *,'       [-sig sigma_name] : name of the density variable in RHO_file. Default is'
     PRINT *,'           ',TRIM(cv_sig),'.'
     PRINT *,'       [-isodep ] : Only computes the isopycnic depth, then stops. '
     PRINT *,'       [-noiso]   : Does not save isopycnic depth (suitable for big files).'
     PRINT *,'       [-debug]   : Produces extra prints.'
     PRINT *,'       [-o OUT-isodep]: specify the name of isodep file (-isodep option),'
     PRINT *,'           instead of ',TRIM(cf_iso),'.'
     PRINT *,'       [ -nc4 ]   : Use netcdf4 output with chunking and deflation level 1..'
     PRINT *,'            This option is effective only if cdftools are compiled with'
     PRINT *,'            a netcdf library supporting chunking and deflation.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       If not using -s0 option ',TRIM(cf_rholev), 'is required, unless '
     PRINT *,'       the default name is changed by -rholev option.'
     PRINT *,'     ' 
     PRINT *,'     OPENMP SUPPORT : yes'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       There are as many output files than input files, with ''.interp'' '
     PRINT *,'       suffix added to the original name.'
     PRINT *,'       netcdf files : <IN-file>.interp'
     PRINT *,'         variables : VAR-in (unit is the same as input var)'
     PRINT *,'                     ', TRIM(cn_vodepiso),' (m) : depth of isopycnic.'
     PRINT *,'      '
     PRINT *,'       If option -isodep is used, only isopycnic depth is output on '
     PRINT *,'       netcdf file : ',TRIM(cf_iso),' (unless -o option is used).'
     PRINT *,'         variables : ',TRIM(cn_vodepiso),' (m) '
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'       cdfmocsig'
     PRINT *,'       '
     STOP 
  ENDIF

  ijarg = 1 

  DO WHILE ( ijarg <= narg )
     CALL getarg( ijarg, cldum) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-v'    ) ; CALL getarg( ijarg, cv_in    ) ; ijarg=ijarg+1
     CASE ( '-s'    ) ; CALL getarg( ijarg, cf_rhofil) ; ijarg=ijarg+1
     CASE ( '-l'    ) ; CALL GetFileList
        ! options
     CASE ( '-s0'   ) ; CALL ParseS0Val
     CASE ( '-p'    ) ; CALL getarg( ijarg, ctype    ) ; ijarg=ijarg+1
     CASE ('-sig'   ) ; CALL getarg( ijarg, cv_sig   ) ; ijarg=ijarg+1 
     CASE ('-isodep') ; lisodep = .TRUE.  ; nvout=1 
     CASE ('-noiso' ) ; liso    = .FALSE. ; nvout=1
     CASE ('-debug' ) ; ldebug  = .TRUE.
     CASE ('-rholev') ; CALL getarg( ijarg, cf_rholev) ; ijarg=ijarg+1
     CASE ( '-o'    ) ; CALL getarg( ijarg, cf_iso   ) ; ijarg=ijarg+1
     CASE ( '-nc4'  ) ; lnc4    = .TRUE.
     CASE DEFAULT     ; PRINT *,' ERROR : ', TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  END DO

  lchk = chkfile(cf_rhofil)
  IF ( .NOT. lsingle ) lchk = lchk .OR. chkfile(cf_rholev)
  IF ( lchk ) STOP 99 ! missing file

  IF ( .NOT.  lsingle ) THEN
     OPEN(numlev,FILE=cf_rholev)
     READ(numlev,*) npsig
     IF (ldebug) PRINT *, TRIM(cf_rholev),' contains :'
     IF (ldebug) PRINT *, npsig
     ALLOCATE ( zi(npsig) )
     DO jsig=1,npsig
        READ(numlev,*)      zi(jsig)
        IF (ldebug) PRINT *,zi(jsig)
     END DO
     CLOSE(numlev)
  ENDIF

  ! Read reference density  file
  npiglo = getdim(cf_rhofil,cn_x)
  npjglo = getdim(cf_rhofil,cn_y)
  npk    = getdim(cf_rhofil,cn_z)
  npt    = getdim(cf_rhofil,cn_t)

  IF ( npt > 1 ) THEN
     PRINT *,'  WARNING : more than 1 time step in ',TRIM(cf_rhofil)
     PRINT *,'            Only the first one will be used.'
  ENDIF

  cf_dta = cf_lst(1)   ! work with the first file of the list for dimension determination
  nvars=getnvar(cf_dta)

  ALLOCATE(cv_names(nvars), stypzvar(nvars))
  ALLOCATE(ipk(nvout), id_varout(nvout), stypvar(nvout) )

  cv_names(:)=getvarname(cf_dta, nvars, stypzvar)

  ALLOCATE( zsig(npiglo,npjglo,npk), alpha(npiglo, npjglo, npsig)            )  ! 3D arrays !!
  ALLOCATE( v2dint(npiglo, npjglo), v2d(npiglo,npjglo), zint(npiglo,npjglo)  )
  ALLOCATE( dtim(npt), h1d(npk)                                              )
  alpha=0.d0

  dtim(:) = getvar1d(cf_rhofil, cn_vtimec,  npt)
  h1d(:)  = getvar1d(cf_rhofil, cn_vdeptht, npk)

  DO jk=1,npk
     zsig(:,:,jk) = getvar(cf_rhofil, cv_sig, jk, npiglo, npjglo)
  END DO

  !! Compute interpolation coefficients as well as the level used
  !! to interpolate between
  !!  This work is done once, on the RHO file.
  !$OMP PARALLEL DO SCHEDULE(RUNTIME)
  DO ji=1,npiglo
     DO jj = 1, npjglo
        ijk = 1
        DO jsig=1,npsig
           !  Assume that rho (z) is increasing downward (no inversion)
           !     Caution with sigma0 at great depth !
           DO WHILE (zi(jsig) >=  zsig(ji,jj,ijk) .AND. ijk < npk &
                &   .AND. zsig(ji,jj,ijk) /=  zspvali )
              ijk=ijk+1
           END DO
           ijk=ijk-1
           ik0=ijk
           IF (ijk == 0) THEN
              ijk=1
              alpha(ji,jj,jsig) = 0.
           ELSE IF (zsig(ji,jj,ijk+1) == zspvali ) THEN
              ik0=0
              alpha(ji,jj,jsig) = 0.
           ELSE 
              ! ... alpha is always in [0,1]. Adding ik0 ( >=1 ) for saving space for ik0
              alpha(ji,jj,jsig)= &
                   &  (zi(jsig)-zsig(ji,jj,ijk))/(zsig(ji,jj,ijk+1)-zsig(ji,jj,ijk)) + ik0
           ENDIF
        END DO
     END DO
  END DO
  !$OMP END PARALLEL DO

  IF ( lisodep ) THEN
     CALL CreateOutputIsodep
     DO jsig=1,npsig
        !$OMP PARALLEL DO SCHEDULE(RUNTIME)
        DO ji=1,npiglo
           DO jj=1,npjglo
              ! ik0 is retrieved from alpha, taking the integer part.
              ! The remnant is alpha.
              ik0 = INT(alpha(ji,jj,jsig))
              zalpha =  alpha(ji,jj,jsig) - ik0
              IF (ik0 /= 0) THEN
                 P1 = zsig(ji,jj,ik0  )
                 P2 = zsig(ji,jj,ik0+1)
                 IF (P1 /= zspvali .AND. P2 /= zspvali) THEN
                    zint (ji,jj) = zalpha *h1d(ik0+1) &
                         &         +(1-zalpha)*h1d(ik0  )
                 ELSE
                    zint  (ji,jj)=zspvalo
                 ENDIF
              ELSE
                 zint  (ji,jj)=zspvalo
              ENDIF
           END DO
        END DO
        !$OMP END PARALLEL DO
        ierr = putvar(ncout, id_varout(1), zint , jsig, npiglo, npjglo)
     END DO
     ierr = closeout(ncout    )
     PRINT *,' -isodep option in use: only compute depth of isopycnic surfaces.'
     STOP 99 
  ENDIF
  DEALLOCATE ( dtim) 

  !! ** Loop on the scalar files to project on choosen isopycnic surfaces
  DO jfich= 1, nfiles
     cf_dta = cf_lst(jfich)
     PRINT *,'working with ', TRIM(cf_dta)
     npt    = getdim(cf_dta, cn_t)
     CALL CreateOutput
     DO jt =1, npt

        ! fill in zsig with 3D input data interpolated at T-point
        DO jk=1,npk
           v2d(:,:) = getvar(cf_dta, cv_in, jk, npiglo, npjglo, ktime=jt)
           SELECT CASE ( ctype )
           CASE ('T', 't', 'S', 's' )
              zsig(:,:,jk) = v2d(:,:)
           CASE ('U','u' )
              DO ji=2,npiglo
                 DO jj=1, npjglo
                    zsig(ji,jj,jk)=0.5*( v2d(ji,jj) + v2d(ji-1,jj) )  ! put variable on T point
                 END DO
              END DO
           CASE ('V','v' )
              DO jj=2,npjglo
                 DO ji=1, npiglo
                    zsig(ji,jj,jk)=0.5*( v2d(ji,jj) + v2d(ji,jj-1) )  ! put variable on T point
                 END DO
              END DO
           CASE('W','w' )
              zint(:,:) = getvar(cf_dta, cv_in, jk+1, npiglo, npjglo)
              DO jj=1,npjglo
                 DO ji=1, npiglo
                    zsig(ji,jj,jk)=0.5*( v2d(ji,jj) + zint(ji,jj) )  ! put variable on T point
                 END DO
              END DO
           CASE('F','f' )
              DO jj=2,npjglo
                 DO ji=2, npiglo
                    zsig(ji,jj,jk)=0.25*( v2d(ji,jj) + v2d(ji,jj-1) + v2d(ji-1,jj) + v2d(ji-1,jj-1 )) ! put variable on T point
                 END DO
              END DO
           END SELECT
        END DO

        DO jsig=1,npsig
           !$OMP PARALLEL DO SCHEDULE(RUNTIME)
           DO ji=1,npiglo
              DO jj=1,npjglo
                 ! ik0 is retrieved from alpha, taking the integer part.
                 ! The remnant is alpha. 
                 ik0    = INT(alpha(ji,jj,jsig))
                 zalpha =     alpha(ji,jj,jsig) - ik0
                 IF (ik0 > 0 .AND. ik0 < npk ) THEN
                    P1 = zsig(ji,jj,ik0  )
                    P2 = zsig(ji,jj,ik0+1)
                    IF (P1 /= zspvali .AND. P2 /= zspvali) THEN
                       v2dint(ji,jj) = zalpha *P2  &
                            &         +(1-zalpha)*P1
                       IF( liso) zint (ji,jj) = zalpha *h1d(ik0+1) &
                            &         +(1-zalpha)*h1d(ik0  )
                    ELSE 
                       v2dint(ji,jj)=zspvalo
                       IF( liso )zint  (ji,jj)=zspvalo
                    ENDIF
                 ELSE 
                    v2dint(ji,jj)=zspvalo
                    IF ( liso ) zint  (ji,jj)=zspvalo
                 ENDIF
              END DO
           END DO
           !$OMP END PARALLEL DO
           ierr = putvar(ncout, id_varout(1), v2dint, jsig, npiglo, npjglo, ktime=jt)
           IF (liso) ierr = putvar(ncout, id_varout(2), zint  , jsig, npiglo, npjglo, ktime=jt)
        END DO
     ENDDO   ! loop on time
     ierr = closeout(ncout             )
  END DO  ! loop on scalar files
  PRINT *,'Projection on isopycns completed successfully'

CONTAINS

  SUBROUTINE ParseS0Val
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE ParseS0Val  ***
    !!
    !! ** Purpose :  Parse -s0 option if used to set up the equally spaced
    !!               isopycnic surfaces to use for projection 
    !!
    !! ** Method  :  Assume cldum is a comma separated list, use global module
    !!               variables.
    !!----------------------------------------------------------------------
    CHARACTER(LEN=80), DIMENSION(100) :: cl_dum  ! 100 is arbitrary
    INTEGER  :: ji
    INTEGER  :: inchar,  i1=1, ival
    !!----------------------------------------------------------------------
    CALL getarg(ijarg, cldum); ijarg=ijarg+1
    inchar = LEN(TRIM(cldum))
    ival  = 1
    lsingle = .TRUE.  ! this flag tells the program that no rholev file is
    ! required.
    ! scan the input string and look for ',' as separator
    DO ji=1,inchar
       IF ( cldum(ji:ji) == ',' ) THEN
          cl_dum(ival) = cldum(i1:ji-1)
          i1=ji+1
          ival = ival + 1
       ENDIF
    ENDDO
    ! last name of the list does not have a ','
    cl_dum(ival) = cldum(i1:inchar)

    IF ( ival == 3 ) THEN  ! sigmin,sigstp,npsig
       READ(cl_dum(1),*) sigmin
       READ(cl_dum(2),*) sigstp
       READ(cl_dum(3),*) npsig
    ELSE IF (ival == 1 ) THEN ! single value
       READ(cl_dum(1),*) sigmin
       npsig  = 1
       sigstp = 0.
    ELSE
       PRINT *,' Error in -s0 option : either -s0 val  or -s0 sigmin,sigstp,nsig'
       STOP 99
    ENDIF

    ALLOCATE ( zi(npsig) )
    zi(1) = sigmin
    DO ji=2, npsig
       zi(ji) = zi(ji-1) + sigstp
    ENDDO
    IF ( ldebug ) THEN
       PRINT *, TRIM(cf_rholev),' like output '
       PRINT *, '---------------------'
       PRINT *, npsig
       DO ji = 1, npsig
          PRINT *, zi(ji)
       END DO
    ENDIF

  END SUBROUTINE ParseS0Val
  
  SUBROUTINE GetFileList
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE GetFileList  ***
    !!
    !! ** Purpose :  Set up a file list given on the command line as 
    !!               blank separated list
    !!
    !! ** Method  :  Scan the command line until a '-' is found
    !!----------------------------------------------------------------------
    INTEGER (KIND=4)  :: ji
    INTEGER (KIND=4)  :: icur
    !!----------------------------------------------------------------------
    !!
    nfiles=0
    ! need to read a list of file ( number unknow ) 
    ! loop on argument till a '-' is found as first char
    icur=ijarg                          ! save current position of argument number
    DO ji = icur, narg                  ! scan arguments till - found
       CALL getarg ( ji, cldum )
       IF ( cldum(1:1) /= '-' ) THEN ; nfiles = nfiles+1
       ELSE                          ; EXIT
       ENDIF
    ENDDO
    ALLOCATE (cf_lst(nfiles) )
    DO ji = icur, icur + nfiles -1
       CALL getarg(ji, cf_lst( ji -icur +1 ) ) ; ijarg=ijarg+1
    END DO
  END SUBROUTINE GetFileList

  SUBROUTINE CreateOutputIsodep
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutputIsodep  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    ipk(1)                       = npsig

    stypvar(1)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(1)%cname             = cn_vodepiso
    stypvar(1)%cunits            = 'm'
    stypvar(1)%rmissing_value    = 999999.
    stypvar(1)%valid_min         = 0.
    stypvar(1)%valid_max         = 7000.
    stypvar(1)%clong_name        = 'Depth_of_Isopycnals'
    stypvar(1)%cshort_name       = cn_vodepiso
    stypvar(1)%conline_operation = 'N/A'
    stypvar(1)%caxis             = 'TRYX'

    ncout = create      (cf_out, cf_rhofil, npiglo, npjglo, npsig         , ld_nc4=lnc4 )
    ierr  = createvar   (ncout,  stypvar,   nvout,  ipk,    id_varout     , ld_nc4=lnc4 )
    ierr  = putheadervar(ncout , cf_rhofil, npiglo, npjglo, npsig, pdep=zi )

    ierr  = putvar1d(ncout, dtim, 1, 'T')

  END SUBROUTINE CreateOutputIsodep

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    ! ... open output file and write header
    cf_out=TRIM(cf_dta)//'.interp'

    ipk(:)=npsig
    DO jvar=1,nvars
       IF ( cv_in == stypzvar(jvar)%cname ) THEN 
          stypvar(1)=stypzvar(jvar)
          EXIT
       ENDIF
    END DO
    stypvar(1)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(1)%clong_name        = TRIM(stypvar(2)%clong_name)//' on iso sigma'
    stypvar(1)%rmissing_value    = zspvalo
    stypvar(1)%caxis             = 'TRYX'

    IF ( liso ) THEN
       stypvar(2)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
       stypvar(2)%cname             = cn_vodepiso
       stypvar(2)%cunits            = 'm'
       stypvar(2)%rmissing_value    = 999999.
       stypvar(2)%valid_min         = 0.
       stypvar(2)%valid_max         = 7000.
       stypvar(2)%clong_name        = 'Depth_of_Isopycnes'
       stypvar(2)%cshort_name       = cn_vodepiso
       stypvar(2)%conline_operation = 'N/A'
       stypvar(2)%caxis             = 'TRYX'
    ENDIF

    ncout = create      (cf_out, cf_rhofil, npiglo, npjglo, npsig         , ld_nc4=lnc4 )
    ierr  = createvar   (ncout,  stypvar,   nvout,  ipk,    id_varout     , ld_nc4=lnc4 )
    ierr  = putheadervar(ncout , cf_rhofil, npiglo, npjglo, npsig, pdep=zi              )

    ALLOCATE ( dtim(npt) )
    dtim = getvar1d(cf_dta, cn_vtimec, npt)
    ierr = putvar1d(ncout, dtim,  npt, 'T')
    DEALLOCATE ( dtim )

  END SUBROUTINE CreateOutput

END  PROGRAM cdfrhoproj

MODULE modutils
  !!======================================================================
  !!                     ***  MODULE  modutils  ***
  !! Hold functions and subroutine dedicated to common utility task
  !!=====================================================================
  !! History : 3.0  : 04/2011  : J.M. Molines : Original code
  !!                : 10/2012  : N. Ferry, E. Durand, F. Hernandez : add shapiro
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  !!   routines      : description
  !!   SetGlobalAtt  : Set Global Attribute to the command line
  !!   SetFilename   : Build standard name from confname
  !!   shapiro_fill_smooth : shapiro smoother or filler
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2010, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  USE cdfio

  IMPLICIT NONE

  PRIVATE
  PUBLIC SetGlobalAtt
  PUBLIC SetFileName
  PUBLIC GetList
  PUBLIC shapiro_fill_smooth
  PUBLIC FillPool2D
  PUBLIC FillPool3D

CONTAINS
  SUBROUTINE SetGlobalAtt(cdglobal, cd_append)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE SetGlobalAtt  ***
    !!
    !! ** Purpose : Append command line to the string given as argument.
    !!              This is basically used for setting a global attribute 
    !!              in the output files 
    !!
    !! ** Method  : Decrypt line command with getarg  
    !!
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*),           INTENT(inout) :: cdglobal
    CHARACTER(LEN=1), OPTIONAL, INTENT(in   ) :: cd_append

    INTEGER(KIND=4)    :: iargc, inarg
    INTEGER(KIND=4)    :: jarg
    CHARACTER(LEN=100) :: cl_arg
    CHARACTER(LEN=1  ) :: cl_app
    !!----------------------------------------------------------------------
    cl_app = 'N'
    IF ( PRESENT( cd_append ) ) THEN 
       cl_app = 'A'
    ENDIF

    CALL getarg(0, cl_arg)
    SELECT CASE ( cl_app)
    CASE ('A') 
       cdglobal = TRIM(cdglobal)//' ; '//TRIM(cl_arg) 
    CASE ('N') 
       cdglobal = TRIM(cl_arg) 
    END SELECT

    inarg = iargc()
    DO jarg=1, inarg
       CALL getarg(jarg,cl_arg) 
       cdglobal = TRIM(cdglobal)//' '//TRIM(cl_arg) 
    END DO

  END SUBROUTINE SetGlobalAtt

  CHARACTER(LEN=256) FUNCTION SetFileName(cdconf, cdtag, cdgrid ,ld_stop )
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION SetFileName  ***
    !!
    !! ** Purpose :  Build filename from cdconf, tag and grid
    !!
    !! ** Method  :  Check 2 forms of file names and return
    !!               error is file is missing
    !!
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*),  INTENT(in) :: cdconf, cdtag, cdgrid
    LOGICAL, OPTIONAL, INTENT(in) :: ld_stop

    LOGICAL :: ll_stop
    !!----------------------------------------------------------------------
    IF ( PRESENT(ld_stop) ) THEN
       ll_stop = ld_stop
    ELSE
       ll_stop = .TRUE.
    ENDIF

    WRITE( SetFileName,'(a,"_",a,"_grid",a,".nc")') TRIM(cdconf), TRIM(cdtag), TRIM(cdgrid)
    IF ( chkfile(SetFileName ,ld_verbose=.FALSE.) ) THEN ! look for another name
       WRITE(SetFileName,'(a,"_",a,"_grid_",a,".nc")') TRIM(cdconf), TRIM(cdtag), TRIM(cdgrid)
       IF ( chkfile( SetFileName, ld_verbose=.FALSE.) .AND. ll_stop  ) THEN
          PRINT *,' ERROR : missing grid',TRIM(cdgrid),'or even grid_',TRIM(cdgrid),' file '
          STOP 97
       ENDIF
    ENDIF
  END FUNCTION SetFileName

  SUBROUTINE GetList ( cd_list, klist, ksiz )
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE getlist  ***
    !!
    !! ** Purpose :   Expand list described with input string like
    !!                k1,k2,k3  or k1-k2,k3 or any valid combination
    !!
    !! ** Method  :   Look for ',' and '-' in cd_list and interprets
    !!
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*),                           INTENT(in ) :: cd_list ! list to decipher
    INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE, INTENT(out) :: klist   ! deciphered integer list
    INTEGER(KIND=4),                            INTENT(out) :: ksiz    ! size of the list

    INTEGER(KIND=4),             PARAMETER :: jp_maxlist=500
    INTEGER(KIND=4)                        :: ji, jk
    INTEGER(KIND=4)                        :: inlev, ipos, iposm,  ik1, ik2
    INTEGER(KIND=4), DIMENSION(jp_maxlist) :: itmp
    CHARACTER(LEN=80)                      :: cldum
    CHARACTER(LEN=80)                      :: cldum2
    !----------------------------------------------------------------------------
    cldum=cd_list
    ipos=1
    ksiz=0
    DO WHILE (ipos /= 0 )
       ipos=INDEX(cldum,',')
       IF (ipos == 0 ) THEN
          cldum2=cldum
       ELSE
          cldum2=cldum(1:ipos-1)
       ENDIF

       iposm=INDEX(cldum2,'-')
       IF ( iposm == 0 ) THEN
          ksiz=ksiz+1 ; 
          IF (ksiz > jp_maxlist) THEN 
             PRINT *, 'jp_maxlist too small in getlist '
             STOP 97
          ENDIF
          READ(cldum2,* ) itmp(ksiz)
       ELSE
          READ(cldum2(1:iposm-1),*) ik1
          READ(cldum2(iposm+1:),* ) ik2
          DO jk = ik1,ik2
             ksiz=ksiz+1 ; 
             IF (ksiz > jp_maxlist) THEN
                PRINT *, 'jp_maxlist too small in getlist '
                STOP 97
             ENDIF
             itmp(ksiz)=jk
          ENDDO
       ENDIF
       cldum=cldum(ipos+1:)
    ENDDO
    ALLOCATE (klist(ksiz) )
    klist(:)=itmp(1:ksiz)

  END SUBROUTINE GetList

  SUBROUTINE shapiro_fill_smooth ( psig, kpi, kpj, kpass, cdfs, pbad, klmasktrue, psigf )
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE shapiro_fill_smooth  ***
    !!
    !! ** Purpose : Shapiro smoother or filler
    !!
    !! ** Method  : Shapiro algorithm 
    !!           psig    : variable to be filtered 2D
    !!           kpi,kpj : dimension of psig
    !!           kpass   : number of passes of the filter
    !!           cdfs    : 'smooth' or 'fill' according to choice
    !!           pbad    : psig Fill_Value
    !!           klmasktrue : mask flag for continent.
    !!                If land extrapolation is desired, set klmasktrue=1 everywhere
    !!
    !!           psigf   : filtered/filled variable (output)
    !!
    !!  code history:
    !!      original  : 05-11 (N. Ferry)
    !!      additions : 05-12 (E. Durand)
    !!      correction: 07-12 (F. Hernandez)
    !!      cdftools norm : 11-12 (J.M. Molines)
    !!----------------------------------------------------------------------
    INTEGER(KIND=4),                     INTENT(in ) :: kpi, kpj, kpass
    INTEGER(KIND=4), DIMENSION(kpi,kpj), INTENT(in ) :: klmasktrue

    REAL(KIND=4),                        INTENT(in ) :: pbad
    REAL(KIND=4), DIMENSION(kpi,kpj),    INTENT(in ) :: psig
    REAL(KIND=4), DIMENSION(kpi,kpj),    INTENT(out) :: psigf

    CHARACTER(LEN=6),                    INTENT(in ) :: cdfs

    INTEGER(KIND=4)                               :: ji, jj, jp    ! dummy loop index
    INTEGER(KIND=4), DIMENSION(0:kpi+1,kpj)       :: ilmask_e     ! extra i-point for E-W periodicity
    INTEGER(KIND=4), DIMENSION(0:kpi+1,kpj)       :: ilmask0_e    ! extra i-point for E-W periodicity
    INTEGER(KIND=4), DIMENSION(0:kpi+1,kpj)       :: ilmasktrue_e ! extra i-point for E-W periodicity

    REAL(KIND=4), DIMENSION(0:kpi+1,kpj)          :: zsigf_e      ! extra i-point for E-W periodicity
    REAL(KIND=4), DIMENSION(0:kpi+1,kpj)          :: zsig_e       ! extra i-point for E-W periodicity
    REAL(KIND=4)                                  :: znum, zden, zsum

    !!----------------------------------------------------------------------
    ! ... Initialization : 
    zsig_e      (1:kpi,:) = psig      (:,:)
    ilmasktrue_e(1:kpi,:) = klmasktrue(:,:)
    !  E-W periodic
    zsig_e      (0,:)     = zsig_e      (kpi,:)      
    ilmasktrue_e(0,:)     = ilmasktrue_e(kpi,:)      
    zsig_e      (kpi+1,:) = zsig_e      (1,:)      
    ilmasktrue_e(kpi+1,:) = ilmasktrue_e(1,:)      

    ! check cdfs compliance
    IF ( cdfs(1:4)  .NE. 'fill' .AND. cdfs(1:6) .NE. 'smooth' ) THEN
       PRINT*, 'cdfs = ',cdfs ,' <> fill or smooth'
       STOP 97
    ENDIF
    !
    ! ... Shapiro filter : 
    !
    DO jp = 1, kpass          ! number of passes for the filter
       !
       ! in both cases 'smooth' and ' fill' we check points w/o values
       ilmask_e(:,:) = 0 ; ilmask0_e(:,:) = 0
       WHERE ( zsig_e(:,:) /= pbad )
          !   set ilmask_e = 1 when field is already filled
          ilmask_e (:,:) = 1 
          ilmask0_e(:,:) = 1 
       ENDWHERE

       ! case 'fill'
       IF ( cdfs(1:4) == 'fill' ) THEN
          ilmask0_e(:,:) = 0
          DO ji=1,kpi
             DO jj=2,kpj-1
                zsum = ilmask_e(ji+1,jj) + ilmask_e(ji-1,jj) + ilmask_e(ji,jj+1) + ilmask_e(ji,jj-1)
                ! set ilmask0_e = 1 if it is possible to do a 4-point interpolation (N-S-E-W)
                ! not on  land
                IF ( ( zsum                >= 1 ) .AND. &
                     ( ilmask_e    (ji,jj) == 0 ) .AND. &
                     ( ilmasktrue_e(ji,jj) == 1 ) )  THEN
                          ilmask0_e(ji,jj) = 1
                ENDIF
             ENDDO
             ! for the northernmost line
             zsum = ilmask_e(ji+1,kpj) + ilmask_e(ji-1,kpj) + ilmask_e(ji,kpj-1)
             IF ( ( zsum                 >= 1 ) .AND. &
                  ( ilmask_e    (ji,kpj) == 0 ) .AND. &
                  ( ilmasktrue_e(ji,kpj) == 1 ) )  THEN 
                       ilmask0_e(ji,kpj) = 1
             ENDIF
          ENDDO
       ENDIF
       !
       ! loop on data points for both cases
       DO ji = 1, kpi
          DO jj = 2, kpj-1
             IF ( ilmask0_e(ji,jj) == 1. )  THEN
                znum =  zsig_e(ji-1,jj  )*ilmask_e(ji-1,jj  ) &
                      + zsig_e(ji+1,jj  )*ilmask_e(ji+1,jj  ) &
                      + zsig_e(ji  ,jj-1)*ilmask_e(ji  ,jj-1) &
                      + zsig_e(ji  ,jj+1)*ilmask_e(ji  ,jj+1)  
                zden =  ilmask_e(ji-1,jj  ) &
                      + ilmask_e(ji+1,jj  ) &
                      + ilmask_e(ji  ,jj-1) &
                      + ilmask_e(ji  ,jj+1) 
                zsigf_e(ji,jj) = znum/zden
             ELSE
                zsigf_e(ji,jj) = zsig_e(ji,jj)
             ENDIF
          ENDDO
          ! for the northernmost line, we do not take kpj+1 into account
          IF ( ilmask0_e(ji,kpj) == 1. )  THEN
             znum =  zsig_e(ji-1,kpj  )*ilmask_e(ji-1,kpj  ) &
                   + zsig_e(ji+1,kpj  )*ilmask_e(ji+1,kpj  ) &
                   + zsig_e(ji  ,kpj-1)*ilmask_e(ji  ,kpj-1) 
             zden =  ilmask_e(ji-1,kpj  ) &
                   + ilmask_e(ji+1,kpj  ) &
                   + ilmask_e(ji  ,kpj-1) 
             zsigf_e(ji,kpj) = znum/zden
          ELSE
             zsigf_e(ji,kpj) = zsig_e(ji,kpj)
          ENDIF
       ENDDO
       !
       !    fill or smooth ?
       !
       IF ( cdfs(1:6) == 'smooth' ) THEN
          WHERE ( ilmasktrue_e(:,:) == 1 )
             zsig_e(:,:) = zsigf_e(:,:)
          END WHERE
       ENDIF
       !
       IF ( cdfs(1:4) == 'fill' ) THEN
          WHERE ( ilmask0_e(:,:) == 1 )
             zsig_e(:,:) = zsigf_e(:,:)
          END WHERE
       ENDIF
       ! Boundary condition  : E-W  (simplifie)
       zsig_e(0,:) = zsig_e(kpi,:)
       zsig_e(kpi+1,:) = zsig_e(1,:)

       !
    ENDDO                     ! jp

    psigf(:,:) = zsig_e(1:kpi,:)

  END SUBROUTINE shapiro_fill_smooth

  SUBROUTINE FillPool2D(kiseed, kjseed, kdta, kifill)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE FillPool2D  ***
    !!  
    !! ** Purpose :  Replace all area surrounding by mask value by mask value
    !!  
    !! ** Method  :  flood fill algorithm
    !!  
    !!----------------------------------------------------------------------
    INTEGER(KIND=4),                 INTENT(in)    :: kiseed, kjseed
    INTEGER(KIND=4),                 INTENT(in)    :: kifill         ! pool value
    INTEGER(KIND=2), DIMENSION(:,:), INTENT(inout) :: kdta           ! mask

    INTEGER :: ik                       ! number of point change
    INTEGER :: ip                       ! size of the pile
    INTEGER :: ji, jj                   ! loop index
    INTEGER :: iip1, iim1, ii, ij       ! working integer
    INTEGER :: ipiglo, ipjglo           ! size of the domain, infered from kdta size

    INTEGER(KIND=2), DIMENSION(:,:), ALLOCATABLE :: ipile    ! pile variable
    INTEGER(KIND=2), DIMENSION(:,:), ALLOCATABLE :: idata   ! new bathymetry
    !!----------------------------------------------------------------------
    ! infer domain size from input array
    ipiglo = SIZE(kdta,1)
    ipjglo = SIZE(kdta,2)

    ! allocate variable
    ALLOCATE(ipile(2*ipiglo*ipjglo,2))
    ALLOCATE(idata(ipiglo,ipjglo))

    ! initialise variables
    idata=kdta
    ipile(:,:)=0
    ipile(1,:)=[kiseed,kjseed]
    ip=1; ik=0

    ! loop until the pile size is 0 or if the pool is larger than the critical size
    DO WHILE ( ip /= 0 ) ! .AND. ik < 600000);
       ik=ik+1
       ii=ipile(ip,1); ij=ipile(ip,2)
       IF ( MOD(ik, 10000) == 0 ) PRINT *, 'IP =', ip, ik, ii,ij

       ! update bathy and update pile size
       idata(ii,ij) =kifill
       ipile(ip,:)  =[0,0]; ip=ip-1

       ! check neighbour cells and update pile ( assume E-W periodicity )
       iip1=ii+1; IF ( iip1 == ipiglo+1 ) iip1=2
       iim1=ii-1; IF ( iim1 == 0        ) iim1=ipiglo-1

       IF (idata(ii, ij+1) > 0 ) THEN
          ip=ip+1; ipile(ip,:)=[ii  ,ij+1]
       END IF
       IF (idata(ii, ij-1) > 0 ) THEN
          ip=ip+1; ipile(ip,:)=[ii  ,ij-1]
       END IF
       IF (idata(iip1, ij) > 0 ) THEN
          ip=ip+1; ipile(ip,:)=[iip1,ij  ]
       END IF
       IF (idata(iim1, ij) > 0 ) THEN
          ip=ip+1; ipile(ip,:)=[iim1,ij  ]
       END IF

    END DO
    kdta=idata;

    DEALLOCATE(ipile); DEALLOCATE(idata)

  END SUBROUTINE FillPool2D


  SUBROUTINE FillPool3D(kiseed, kjseed, kkseed, kdta, kifill)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE FillPool3D  ***
    !!
    !! ** Purpose :  Replace all area surrounding by mask value by mask value
    !!
    !! ** Method  :  flood fill algorithm
    !!
    !!----------------------------------------------------------------------
    INTEGER(KIND=4),                   INTENT(in)    :: kiseed, kjseed, kkseed
    INTEGER(KIND=4),                   INTENT(in)    :: kifill   ! new bathymetry
    INTEGER(KIND=2), DIMENSION(:,:,:), INTENT(inout) :: kdta     ! new bathymetry

    INTEGER :: ik,iik                   ! number of point change
    INTEGER :: ip                       ! size of the pile
    INTEGER :: ji, jj                   ! loop index
    INTEGER :: ipiglo, ipjglo, ipk      ! size of the domain inferred from kdta
    INTEGER :: iip1, iim1, ii, ij       ! working integer
    INTEGER :: ijp1, ijm1, ikp1, ikm1
    INTEGER(KIND=2), DIMENSION(:,:),   ALLOCATABLE :: ipile    ! pile variable
    INTEGER(KIND=2), DIMENSION(:,:,:), ALLOCATABLE :: idata   ! new bathymetry
    !!----------------------------------------------------------------------
    ! infer domain size from input array
    ipiglo = SIZE(kdta,1)
    ipjglo = SIZE(kdta,2)
    ipk    = SIZE(kdta,3)

    ! allocate variable
    ALLOCATE(ipile(2*ipiglo*ipjglo*ipk,3))
    ALLOCATE(idata(ipiglo,ipjglo,ipk))

    ! initialise variables
    idata=kdta
    ipile(:,:)=0
    ipile(1,:)=[kiseed,kjseed,kkseed]
    ip=1; iik=0

    ! loop until the pile size is 0 or if the pool is larger than the critical size
    DO WHILE ( ip /= 0 ) !.AND. iik < 600000);
       iik=iik+1
       ii=ipile(ip,1); ij=ipile(ip,2) ; ik=ipile(ip,3)
       IF ( MOD( ip, 1000000) == 0 ) PRINT *, 'IP =', ip, iik, ii,ij, ik

       ! update bathy and update pile size
       idata(ii,ij,ik) = kifill
       ipile(ip,:)  =[0,0,0]; ip=ip-1

       ! check neighbour cells and update pile ( assume E-W periodicity )
       iip1=ii+1; IF ( iip1 == ipiglo+1 ) iip1=2
       iim1=ii-1; IF ( iim1 == 0        ) iim1=ipiglo-1
       ijp1=ij+1 ; ijm1 =ij-1
       ikp1=ik+1 ; IF (ikp1 == ipk+1 ) ikp1=ik
       ikm1=ik-1 ; IF (ikm1 == 0     ) ikm1=ik


       IF (idata(ii, ijp1,ik) > 0 ) THEN
          ip=ip+1; ipile(ip,:)=[ii  ,ijp1,ik]
       END IF
       IF (idata(ii, ijm1,ik) > 0 ) THEN
          ip=ip+1; ipile(ip,:)=[ii  ,ijm1,ik]
       END IF

       IF (idata(iip1, ij,ik) > 0 ) THEN
          ip=ip+1; ipile(ip,:)=[iip1,ij  ,ik]
       END IF
       IF (idata(iim1, ij,ik) > 0 ) THEN
          ip=ip+1; ipile(ip,:)=[iim1,ij  ,ik]
       END IF
       IF (idata(ii, ij,ikp1) > 0 ) THEN
          ip=ip+1; ipile(ip,:)=[ii  ,ij,ikp1]
       END IF

       IF (idata(ii, ij,ikm1) > 0 ) THEN
          ip=ip+1; ipile(ip,:)=[ii  ,ij,ikm1]
       END IF

    END DO

    kdta=idata;

    DEALLOCATE(ipile); DEALLOCATE(idata)

  END SUBROUTINE FillPool3D

END MODULE modutils

PROGRAM cdfinfo
  !!======================================================================
  !!                     ***  PROGRAM  cdfinfo  ***
  !!=====================================================================
  !!  ** Purpose : Give very basic informations for Netcdf File
  !!
  !!  ** Method  : to be improved
  !!
  !! History : 2.1  : 09/2010  : J.M. Molines : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio 
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                               :: jvar                     ! dummy loop index
  INTEGER(KIND=4)                               :: ierr                     ! working integer
  INTEGER(KIND=4)                               :: narg, iargc              ! 
  INTEGER(KIND=4)                               :: npiglo, npjglo, npk ,npt ! size of the domain
  INTEGER(KIND=4)                               :: nvars                    ! Number of variables in a file

  CHARACTER(LEN=256)                            :: cf_in                    ! file name
  CHARACTER(LEN=256)                            :: cv_dep                   ! depth name
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_names                 ! array of var name
  
  TYPE(variable), DIMENSION(:),     ALLOCATABLE :: stypvar                  ! variable attributes
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()

  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfinfo ''model cdf file'' '
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'        Gives very basic information about the file given in arguments.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'        model output file in netcdf.' 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'        On standard ouput, gives the size of the domain, the depth '
     PRINT *,'        dimension name, the number of variables.'
     PRINT *,'      '
     STOP
  ENDIF

  CALL getarg (1, cf_in)
  IF ( chkfile(cf_in) ) STOP ! missing file

  npiglo = getdim (cf_in,cn_x)
  npjglo = getdim (cf_in,cn_y)
  npk    = getdim (cf_in,cn_z, cdtrue=cv_dep, kstatus=ierr)

  IF (ierr /= 0 ) THEN
     npk   = getdim (cf_in,'z',cdtrue=cv_dep,kstatus=ierr)
     IF (ierr /= 0 ) THEN
       npk   = getdim (cf_in,'sigma',cdtrue=cv_dep,kstatus=ierr)
        IF ( ierr /= 0 ) THEN 
          npk = getdim (cf_in,'nav_lev',cdtrue=cv_dep,kstatus=ierr)
            IF ( ierr /= 0 ) THEN 
              npk = getdim (cf_in,'levels',cdtrue=cv_dep,kstatus=ierr)
              IF ( ierr /= 0 ) THEN 
                PRINT *,' assume file with no depth'
                npk=0
              ENDIF
            ENDIF
        ENDIF
     ENDIF
  ENDIF

  npt    = getdim (cf_in,cn_t)

  PRINT *, 'npiglo =', npiglo
  PRINT *, 'npjglo =', npjglo
  PRINT *, 'npk    =', npk
  PRINT *, 'npt    =', npt

  PRINT *,' Depth dimension name is ', TRIM(cv_dep)

  nvars = getnvar(cf_in)
  PRINT *,' nvars =', nvars

  ALLOCATE (cv_names(nvars)  )
  ALLOCATE (stypvar(nvars)  )

  ! get list of variable names 
  cv_names(:)=getvarname(cf_in, nvars, stypvar)

  DO jvar = 1, nvars
   PRINT *, 'variable# ',jvar,' is : ',TRIM(cv_names(jvar))
  END DO

END PROGRAM cdfinfo

PROGRAM cdfisopsi
  !!======================================================================
  !!                     ***  PROGRAM  cdfisopsi  ***
  !!=====================================================================
  !!  ** Purpose : Compute a geostrophic streamfunction projected
  !!               on an isopycn (Ref: McDougall and ?, need reference)
  !!
  !!  ** Method  : read temp and salinity, compute sigmainsitu and sigma
  !!              at a reference level, projection of p,T,S on a given
  !!              isopycnal, compute specific volume anomaly and
  !!              integrates it.
  !!
  !! History : 2.1  : 12/2010  : R. Dussin (during L. Talley visit at MEOM)
  !!           3.0  : 03/2011  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE eos
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class transport
  !!----------------------------------------------------------------------
  IMPLICIT NONE
  INTEGER(KIND=4), PARAMETER  :: jp_vars=7

  INTEGER(KIND=4)                             :: jj, ji, jk, jt ,jv        ! dummy loop index
  INTEGER(KIND=4)                             :: it                        ! time index for vvl
  INTEGER(KIND=4)                             :: ierr                      ! working integer
  INTEGER(KIND=4)                             :: narg, iargc, ijarg        ! command line arguments
  INTEGER(KIND=4)                             :: npiglo, npjglo  ! size of the domain
  INTEGER(KIND=4)                             :: npk, npt  ! size of the domain
  INTEGER(KIND=4)                             :: ik, ik0                        ! 
  INTEGER(KIND=4)                             :: ncout
  INTEGER(KIND=4), DIMENSION(jp_vars)         :: ipk              ! outptut variables : number of levels,
  INTEGER(KIND=4), DIMENSION(jp_vars)         :: id_varout        ! ncdf varid's

  REAL(KIND=4)                                :: P1, P2
  REAL(KIND=4)                                :: zspval            ! missing value
  REAL(KIND=4)                                :: refdepth
  REAL(KIND=4)                                :: zsigmaref      !
  REAL(KIND=4)                                :: ztmean, zsmean  ! mean temperature and salinity on isopycnal
  REAL(KIND=4)                                :: hmean, zpmean  ! mean isopycnal depth and mean pressure
  REAL(KIND=4), DIMENSION(:),     ALLOCATABLE :: prof              ! prof (m)
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: ztemp, zsal , zssh  ! Array to read a layer of data
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: ztemp0, zsal0       ! Arrays for reference profile
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: zsiginsitu          ! in-situ density
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: zsig0, zsigsurf     ! potential density of ref profile and surface
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: zmask, zdep           ! 2D mask at current level, level depths
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: v2d             !  2d working arrays
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: ztempint ! 2d working arrays
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: zsalint ! 2d working arrays
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: zint ! 2d working arrays
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: zpint    ! 2d working arrays
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: alpha ! 2d working arrays
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: e1t, e2t
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: rdeltapsi1
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: rdeltapsi2
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: psi0
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: psi
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: zsva2
  REAL(KIND=4), DIMENSION(:,:,:), ALLOCATABLE :: v3d, ztemp3         ! 3d array
  REAL(KIND=4), DIMENSION(:,:,:), ALLOCATABLE :: zsal3, zsva3        ! 3d array

  REAL(KIND=8), DIMENSION(:),     ALLOCATABLE :: dtim                ! time (sec)

  CHARACTER(LEN=256) :: cf_tfil                              ! input gridT file
  CHARACTER(LEN=256) :: cf_sfil                              ! input salinity file (option)
  CHARACTER(LEN=255) :: cf_sshfil                            ! input SSH file (option)
  CHARACTER(LEN=256) :: cf_out='isopsi.nc'                   ! output file name
  CHARACTER(LEN=256) :: cv_out='soisopsi'                    ! output variable name
  CHARACTER(LEN=256) :: cldum                                ! dummy character variable for reading

  LOGICAL            :: lnc4 = .FALSE.                       ! flag for netcdf4 output
  LOGICAL            :: lchk = .FALSE.                       ! flag for existence of files

  TYPE(variable) , DIMENSION(jp_vars) :: stypvar         ! structure for attributes
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()

  IF ( narg == 0 ) THEN
     PRINT *,' usage :  cdfisopsi -ref REF-level -sig TGT-sigma -t T-file [-o OUT-file]...'
     PRINT *,'          ... [-s S-file]  [--ssh-file SSH-file] [-nc4] [-vvl] '
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute a ''geostrophic streamfunction'', projected on an isopycn.'
     PRINT *,'       In this program, temperature and salinities on the selected isopync'
     PRINT *,'       are saved, as well as the depth of the isopycnal surface.'
     PRINT *,'       Then the specific volume anomaly at each model level  (1/rho0 -1/rho)'
     PRINT *,'       is integrated from top to isopycnal surface. The resulting 3D field'
     PRINT *,'       is finally projected (and normalized) on the isopycnal surface.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'        -ref REF-level: reference level for pot. density.'
     PRINT *,'        -sig TGT-sigma: target density level to project on.'
     PRINT *,'        -t T-file : input file for temperature and salinity.'
     PRINT *,'          If salinity not in T-file, use -s option.'
     PRINT *,'          If ssh not in T-file use --ssh-file option.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'        [-s S-file ]: specify the name of salinity file if not T-file.'
     PRINT *,'        [--ssh-file SSH-file] : specify the ssh file if not in T-file.'
     PRINT *,'        [-o OUT-file ]: specify output filename instead of ',TRIM(cf_out)
     PRINT *,'        [-nc4 ]     : Use netcdf4 output with chunking and deflation level 1.'
     PRINT *,'                 This option is effective only if cdftools are compiled with'
     PRINT *,'                 a netcdf library supporting chunking and deflation.'
     PRINT *,'        [-vvl ] : use time varying vertical metrics.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ',TRIM(cn_fhgr),' and ', TRIM(cn_fzgr) 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out),' unless -o option is used.'
     PRINT *,'         7 variables : '
     PRINT *,'            votemper_interp : Temperature interpolated on isopycnal layer'
     PRINT *,'            vosaline_interp : Salinity interpolated on isopycnal layer'
     PRINT *,'            depth_interp    : Depth of the isopycnal layer'
     PRINT *,'            soisopsi        : Total streamfunction on the isopycnal layer'
     PRINT *,'            soisopsi1       : Contribution of the SSH'
     PRINT *,'            soisopsi2       : Contribution of specific volume anomaly vertical'
     PRINT *,'                              integration'
     PRINT *,'            soisopsi3       : Contribution of pressure term on the isopycnal'
     PRINT *,'                              layer'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'       cdfhdy '
     PRINT *,'      '
     STOP 
  ENDIF

  ijarg  = 1
  cf_sfil   = 'none'
  cf_sshfil = 'none'

  DO WHILE ( ijarg <= narg ) 
     CALL getarg(ijarg, cldum) ; ijarg = ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-ref'     ) ; CALL getarg(ijarg, cldum  ) ; ijarg = ijarg+1 ; READ(cldum,*) refdepth
     CASE ( '-sig'     ) ; CALL getarg(ijarg, cldum  ) ; ijarg = ijarg+1 ; READ(cldum,*) zsigmaref
     CASE ('-t','-f'   ) ; CALL getarg(ijarg, cf_tfil) ; ijarg = ijarg+1 
     ! options
     CASE ( '-s'       ) ; CALL getarg(ijarg, cf_sfil) ; ijarg = ijarg+1 
     CASE ('--ssh-file') ; CALL getarg(ijarg, cf_sshfil); ijarg= ijarg+1
     CASE ( '-o'       ) ; CALL getarg(ijarg, cf_out ) ; ijarg = ijarg+1 
     CASE ( '-nc4'     ) ; lnc4   = .TRUE.
     CASE ( '-vvl'     ) ; lg_vvl = .TRUE.
     END SELECT
  ENDDO

  IF ( cf_sfil   == 'none' ) cf_sfil   = cf_tfil
  IF ( cf_sshfil == 'none' ) cf_sshfil = cf_tfil
 
  lchk =  chkfile(cf_tfil  )
  lchk =  chkfile(cf_sfil  ) .OR. lchk
  lchk =  chkfile(cf_sshfil) .OR. lchk
  lchk =  chkfile(cn_fhgr  ) .OR. lchk
  lchk =  chkfile(cn_fzgr  ) .OR. lchk

  IF ( lchk ) STOP 99  ! missing file

  IF ( lg_vvl ) THEN
     cn_fe3t = cf_tfil
     cn_ve3t = cn_ve3t
  ENDIF

  PRINT *, 'Potential density referenced at ', refdepth , ' meters'
  PRINT *, 'Isopycn for projection is ', zsigmaref

  npiglo = getdim (cf_tfil,cn_x)
  npjglo = getdim (cf_tfil,cn_y)
  npk    = getdim (cf_tfil,cn_z)
  npt    = getdim (cf_tfil,cn_t)

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  ALLOCATE ( prof(0:npk)         , dtim(npt)           )
  ALLOCATE ( e1t(npiglo,npjglo), e2t(npiglo,npjglo) )

  e1t(:,:) = getvar(cn_fhgr, cn_ve1t, 1, npiglo, npjglo)
  e2t(:,:) = getvar(cn_fhgr, cn_ve2t, 1, npiglo, npjglo)

  !--------------------------------------------------------------------
  CALL CreateOutput
  zspval   = getatt(cf_sfil, cn_vosaline, cn_missing_value )
  !---------------------------------------------------------------------------
  DO jt=1,npt
     PRINT *,'time ',jt, dtim(jt)/86400.,' days'
     IF (lg_vvl ) THEN ; it = jt
     ELSE              ; it = 1
     ENDIF

     !------------------------------------------------------------------------------
     ! 1. First we compute the potential density and store it into a 3d array
     ALLOCATE (ztemp(npiglo,npjglo), zsal(npiglo,npjglo), zmask(npiglo,npjglo))
     ALLOCATE (v3d(npiglo,npjglo,npk)                                         )

     DO jk = 1, npk
        zmask(:,:) = 1.

        ztemp(:,:) = getvar(cf_tfil, cn_votemper, jk, npiglo, npjglo, ktime=jt)
        zsal(:,:)  = getvar(cf_sfil, cn_vosaline, jk, npiglo, npjglo, ktime=jt)

        WHERE(zsal == zspval ) zmask = 0.

        v3d(:,:,jk) = sigmai(ztemp, zsal, refdepth, npiglo, npjglo ) * zmask(:,:)
     END DO  ! loop to next level

     DEALLOCATE ( ztemp, zsal, zmask )
     !------------------------------------------------------------------------------
     ! 2. Projection of T,S and p on the chosen isopycnal layer (from cdfrhoproj)
     ALLOCATE ( alpha(npiglo,npjglo) )

     !! Compute  the interpolation coefficients
     DO ji=1,npiglo
        DO jj = 1, npjglo
           ik = 1
           !  Assume that rho (z) is increasing downward (no inversion)
           !     Caution with sigma0 at great depth !
           DO WHILE (zsigmaref >=  v3d(ji,jj,ik) .AND. ik <= npk &
                &                .AND. v3d(ji,jj,ik) /=  zspval )
              ik=ik+1
           END DO
           ik=ik-1
           ik0=ik
           IF (ik == 0) THEN
              ik=1
              alpha(ji,jj) = 0.
           ELSE IF (v3d(ji,jj,ik+1) == zspval ) THEN
              ik0=0
              alpha(ji,jj) = 0.
           ELSE
              ! ... alpha is always in [0,1]. Adding ik0 ( >=1 ) for saving space for ik0
              alpha(ji,jj)= (zsigmaref-v3d(ji,jj,ik))/(v3d(ji,jj,ik+1)-v3d(ji,jj,ik)) + ik0
           ENDIF
        END DO
     END DO
     DEALLOCATE (v3d)

     ! Working on temperature first
     ALLOCATE( ztempint(npiglo, npjglo), zint(npiglo, npjglo), zpint(npiglo, npjglo) )
     ALLOCATE( ztemp3(npiglo, npjglo,npk) )

     DO jk=1,npk
        ztemp3(:,:,jk) = getvar(cf_tfil, cn_votemper, jk ,npiglo, npjglo, ktime=jt)
     ENDDO

     CALL ProjectOverIso ( ztemp3, ztempint, prof(1:npk), zint )

     zpint = zint / 10. ! pressure on the isopycnal layer = depth / 10.

     ierr = putvar(ncout, id_varout(1), ztempint, 1, npiglo, npjglo, ktime=jt)
     ierr = putvar(ncout, id_varout(3), zint,     1, npiglo, npjglo, ktime=jt)
     DEALLOCATE( ztemp3 )  

     ! Working on salinity
     ALLOCATE( zsalint(npiglo, npjglo) )
     ALLOCATE( zsal3(npiglo, npjglo,npk) )

     DO jk=1,npk
        zsal3(:,:,jk) = getvar(cf_sfil, cn_vosaline, jk, npiglo, npjglo, ktime=jt)
     ENDDO
     
     CALL ProjectOverIso (zsal3, zsalint)

     ierr = putvar(ncout, id_varout(2), zsalint, 1, npiglo, npjglo, ktime=jt)
     DEALLOCATE( zsal3 )

     ! 3. Compute means for T,S and depth on the isopycnal layer
     ALLOCATE( zmask(npiglo, npjglo) )
     zmask=1. ! define a new mask which correspond to the isopycnal layer
     WHERE( zint == 0. ) zmask = 0.

     ztmean = SUM( ztempint * e1t * e2t * zmask ) / SUM( e1t * e2t * zmask )
     zsmean = SUM( zsalint  * e1t * e2t * zmask ) / SUM( e1t * e2t * zmask )
     ! JMM rem : hmean never used ...
     ! hmean = SUM( zint     * e1t * e2t * zmask ) / SUM( e1t * e2t * zmask )
     zpmean = SUM( zpint     * e1t * e2t * zmask ) / SUM( e1t * e2t * zmask )

     DEALLOCATE ( ztempint, zsalint )

     ! 4. Compute specific volume anomaly
     ALLOCATE( zsva3(npiglo,npjglo,npk) )
     ALLOCATE( zsiginsitu(npiglo,npjglo), zsig0(npiglo,npjglo) )
     ALLOCATE( ztemp(npiglo,npjglo),  zsal(npiglo,npjglo) )
     ALLOCATE( ztemp0(npiglo,npjglo), zsal0(npiglo,npjglo) )

     DO jk=1,npk
        ztemp(:,:) = getvar(cf_tfil, cn_votemper, jk, npiglo, npjglo, ktime=jt)
        zsal (:,:) = getvar(cf_sfil, cn_vosaline, jk, npiglo, npjglo, ktime=jt)

        ztemp0(:,:) = ztmean
        zsal0 (:,:) = zsmean

        ! again land/sea mask
        zmask (:,:) = 1.
        WHERE( zsal == zspval ) zmask = 0.

        zsiginsitu(:,:) = sigmai ( ztemp,  zsal,  prof(jk), npiglo, npjglo )  ! in-situ density
        zsig0(:,:)      = sigmai ( ztemp0, zsal0, prof(jk), npiglo, npjglo )  ! density of reference profile
!        zsiginsitu(:,:) = sigmai ( ztemp,  zsal,  prof(jk), npiglo, npjglo ) * zmask(:,:) ! in-situ density
!        zsig0(:,:)      = sigmai ( ztemp0, zsal0, prof(jk), npiglo, npjglo ) * zmask(:,:) ! density of reference profile

        zsva3(:,:,jk)    = ( 1. / zsiginsitu(:,:) ) - ( 1. / zsig0(:,:) ) *zmask(:,:)
     ENDDO

     DEALLOCATE( zsiginsitu, zsig0, ztemp0, zsal0 )

     ! 5. Integrates from surface to depth of isopycnal layer
     ALLOCATE( zdep(npiglo, npjglo), rdeltapsi1(npiglo, npjglo) )

     rdeltapsi1(:,:) = 0.
     DO jk=1, npk
        zdep(:,:) = getvar(cn_fe3t, cn_ve3t, jk, npiglo, npjglo, ktime=it, ldiom=.NOT.lg_vvl )

        ! For each point we integrate from surface to zint(ji,jj) which is the depth
        ! of the isopycnal layer

        ! If isopycnal layer depth is below the current level
        WHERE( zint >= prof(jk) ) rdeltapsi1 = rdeltapsi1 - zsva3(:,:,jk) * zdep / 10.
        ! If isopycnal layer is between current level and previous level
        WHERE( zint < prof(jk) .AND. zint > prof(jk-1) ) rdeltapsi1 = rdeltapsi1 &
             & - zsva3(:,:,jk) * ( zint - prof(jk-1) ) / 10.
     ENDDO
     ierr = putvar(ncout, id_varout(6), rdeltapsi1, 1, npiglo, npjglo, ktime=jt)
     DEALLOCATE( zdep )

     ! 6. Projection of the specific volume anomaly on the isopycnal layer
     ALLOCATE( zsva2(npiglo,npjglo), rdeltapsi2(npiglo,npjglo) )

     CALL ProjectOverIso ( zsva3, zsva2 )

     rdeltapsi2 = ( zpint - zpmean ) * zsva2
     ierr       = putvar(ncout, id_varout(7), rdeltapsi2, 1, npiglo, npjglo, ktime=jt)
     DEALLOCATE ( zsva3, zsva2, alpha, zint, zpint )

     ! 7. Finally we compute the surface streamfunction
     ALLOCATE(zssh(npiglo,npjglo) , zsigsurf(npiglo,npjglo), psi0(npiglo,npjglo) )

     ztemp   (:,:) = getvar(cf_tfil,   cn_votemper, 1, npiglo, npjglo, ktime=jt)
     zsal    (:,:) = getvar(cf_sfil,   cn_vosaline, 1, npiglo, npjglo, ktime=jt)
     zssh    (:,:) = getvar(cf_sshfil, cn_sossheig, 1, npiglo, npjglo, ktime=jt)

     ! land/sea mask at surface
     zmask (:,:) = 1.
     WHERE( zsal == zspval ) zmask = 0.

     zsigsurf(:,:) = sigmai ( ztemp, zsal, prof(1), npiglo, npjglo ) * zmask(:,:)

     psi0 = zsigsurf * zssh * (9.81 / 1020. )
     ierr = putvar(ncout, id_varout(5), psi0, 1, npiglo, npjglo, ktime=jt)
     DEALLOCATE(zssh, zsigsurf, ztemp, zsal )

     ! 8. At least we are done with the computations
     ALLOCATE( psi(npiglo,npjglo) )
     ! final mask for output : mask the contribution of SSH where isopycn outcrops
     zmask=1.
     WHERE(rdeltapsi1 == zspval ) zmask = 0.
     psi = ( psi0 * zmask ) + rdeltapsi1 + rdeltapsi2

     ierr = putvar(ncout, id_varout(4), psi, 1, npiglo, npjglo, ktime=jt)
     DEALLOCATE( psi, psi0, rdeltapsi1, rdeltapsi2, zmask )
  END DO  ! loop to next time

  ierr = closeout(ncout)

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    DO jv = 1, jp_vars
      stypvar(jv)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    ENDDO

    ipk(:)= 1  ! all variables are 2d
    stypvar(1)%cname             = 'votemper_interp'
    stypvar(1)%cunits            = 'DegC'
    stypvar(1)%rmissing_value    = 0.
    stypvar(1)%valid_min         = -2.
    stypvar(1)%valid_max         = 45.
    stypvar(1)%clong_name        = 'Temperature interpolated on isopycnal layer'
    stypvar(1)%cshort_name       = 'votemper_interp'
    stypvar(1)%conline_operation = 'N/A'
    stypvar(1)%caxis             = 'TZYX'
  
    stypvar(2)%cname             = 'vosaline_interp'
    stypvar(2)%cunits            = 'PSU'
    stypvar(2)%rmissing_value    = 0.
    stypvar(2)%valid_min         = 0.
    stypvar(2)%valid_max         = 50.
    stypvar(2)%clong_name        = 'Salinity interpolated on isopycnal layer'
    stypvar(2)%cshort_name       = 'vosaline_interp'
    stypvar(2)%conline_operation = 'N/A'
    stypvar(2)%caxis             = 'TZYX'

    stypvar(3)%cname             = 'depth_interp'
    stypvar(3)%cunits            = 'meters'
    stypvar(3)%rmissing_value    = 0.
    stypvar(3)%valid_min         = 0.0
    stypvar(3)%valid_max         = 8000.
    stypvar(3)%clong_name        = 'Depth of the isopycnal layer'
    stypvar(3)%cshort_name       = 'depth_interp'
    stypvar(3)%conline_operation = 'N/A'
    stypvar(3)%caxis             = 'TZYX'

    stypvar(4)%cname             = 'soisopsi'
    stypvar(4)%cunits            = 'm2s-2 (to be verified)'
    stypvar(4)%rmissing_value    = 0.
    stypvar(4)%valid_min         = -500.
    stypvar(4)%valid_max         =  500.
    stypvar(4)%clong_name        = 'Total streamfunction on the isopycnal layer'
    stypvar(4)%cshort_name       = 'soisopsi'
    stypvar(4)%conline_operation = 'N/A'
    stypvar(4)%caxis             = 'TZYX'

    stypvar(5)%cname             = 'soisopsi0'
    stypvar(5)%cunits            = 'm2s-2 (to be verified)'
    stypvar(5)%rmissing_value    = 0.
    stypvar(5)%valid_min         = -500.
    stypvar(5)%valid_max         =  500.
    stypvar(5)%clong_name        = 'Contribution of the SSH'
    stypvar(5)%cshort_name       = 'soisopsi'
    stypvar(5)%conline_operation = 'N/A'
    stypvar(5)%caxis             = 'TZYX'

    stypvar(6)%cname             = 'soisopsi1'
    stypvar(6)%cunits            = 'm2s-2 (to be verified)'
    stypvar(6)%rmissing_value    = 0.
    stypvar(6)%valid_min         = -500.
    stypvar(6)%valid_max         =  500.
    stypvar(6)%clong_name        = 'Contribution of specific volume anomaly vertical integration'
    stypvar(6)%cshort_name       = 'soisopsi'
    stypvar(6)%conline_operation = 'N/A'
    stypvar(6)%caxis             = 'TZYX'

    stypvar(7)%cname             = 'soisopsi2'
    stypvar(7)%cunits            = 'm2s-2 (to be verified)'
    stypvar(7)%rmissing_value    = 0.
    stypvar(7)%valid_min         = -500.
    stypvar(7)%valid_max         =  500.
    stypvar(7)%clong_name        = 'Contribution of pressure term on the isopycnal layer'
    stypvar(7)%cshort_name       = 'soisopsi'
    stypvar(7)%conline_operation = 'N/A'
    stypvar(7)%caxis             = 'TZYX'

    ! create output fileset
    ncout = create      (cf_out, cf_tfil, npiglo,  npjglo, npk       , ld_nc4=lnc4 )
    ierr  = createvar   (ncout,  stypvar, jp_vars, ipk,    id_varout , ld_nc4=lnc4 ) 
    ierr  = putheadervar(ncout,  cf_tfil, npiglo,  npjglo, npk                     )

    prof(:) = getvar1d(cf_tfil, cn_vdeptht, npk     )
    prof(0) = 0.  ! used  for vertical integration later on
    dtim    = getvar1d(cf_tfil, cn_vtimec,  npt     )
    ierr    = putvar1d(ncout,  dtim,        npt, 'T')
  END SUBROUTINE CreateOutput

  SUBROUTINE ProjectOverIso ( ptab3, ptabint, ptab1d, ptabint2 )
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE ProjectOverIso  ***
    !!
    !! ** Purpose :  Project the value of ptab3 (3d) on a isopycnic surface
    !!
    !! ** Method  :  We use pre-computed interpolation coefficients 
    !!
    !!----------------------------------------------------------------------
    REAL(KIND=4), DIMENSION (:,:,:),         INTENT (in  ) :: ptab3
    REAL(KIND=4), DIMENSION (:,:),           INTENT ( out) :: ptabint
    REAL(KIND=4), DIMENSION (:),   OPTIONAL, INTENT (in  ) :: ptab1d
    REAL(KIND=4), DIMENSION (:,:), OPTIONAL, INTENT ( out) :: ptabint2
    !
    LOGICAL :: ll_1d = .FALSE.
    LOGICAL :: ll_good
    !!----------------------------------------------------------------------
    IF ( PRESENT (ptab1d) ) THEN ; ll_1d=.TRUE.
    ELSE                         ; ll_1d=.FALSE.
    ENDIF
     DO ji=1,npiglo
        DO jj=1,npjglo
           ! ik0 is retrieved from alpha, taking the integer part.
           ! The remnant is alpha. 
           ik0=INT(alpha(ji,jj))
           alpha(ji,jj) =  alpha(ji,jj) - ik0
           IF (ik0 /= 0) THEN
              P1=ptab3(ji,jj,ik0)
              P2=ptab3(ji,jj,ik0+1)
              ll_good = (P1 /= zspval .AND. P2 /= zspval)
              IF ( ll_good ) THEN
                 ptabint(ji,jj)  = alpha(ji,jj) * P2          + (1-alpha(ji,jj)) * P1
              ELSE
                 ptabint(ji,jj) = zspval
              ENDIF
           ELSE
              ptabint(ji,jj) = zspval
              zint(ji,jj)    = zspval
           ENDIF
           IF ( ll_1d ) THEN
             IF (ik0 /= 0) THEN
                P1=ptab1d(ik0)
                P2=ptab1d(ik0+1)
                IF ( ll_good ) THEN
                   ptabint2(ji,jj)  = alpha(ji,jj) * P2       + (1-alpha(ji,jj)) * P1
                ELSE
                   ptabint2(ji,jj)  = zspval
                ENDIF
             ELSE
                ptabint2(ji,jj) = zspval
             ENDIF
           ENDIF
           ! re-add ik0 to alpha for the next computation
           alpha(ji,jj) =  alpha(ji,jj) + ik0
        END DO
     END DO
  END SUBROUTINE ProjectOverIso


END PROGRAM cdfisopsi

PROGRAM cdfeke
  !!======================================================================
  !!                     ***  PROGRAM cdfeke   ***
  !!=====================================================================
  !!  ** Purpose : Compute Eddy Kinetic Energy 
  !!
  !!  ** Method  : Use gridU gridU2, gridV gridV2 files produced by
  !!               cdfmoy. Velocities are interpolated both on T points
  !!               and the variance is computed
  !!
  !! History : pre  : 11/2004  : J.M. Molines : Original code
  !!           2.1  : 04/2005  : J.M. Molines : use modules
  !!           3.0  : 12/2010  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio 
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2010, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                            :: ji, jj, jk, jt     ! dummy loop index
  INTEGER(KIND=4)                            :: narg, iargc        ! command line browsing
  INTEGER(KIND=4)                            :: npiglo, npjglo     ! size of the domain (horiz)
  INTEGER(KIND=4)                            :: npk, npt           ! size of the domain vert and time
  INTEGER(KIND=4)                            :: ncout              ! ncid of output file
  INTEGER(KIND=4)                            :: ierr               ! Error status
  INTEGER(KIND=4), DIMENSION(1)              :: ipk, id_varout     ! 

  REAL(KIND=4)                               :: ua, va             ! working arrays
  REAL(KIND=4), DIMENSION(:),    ALLOCATABLE :: tim                ! time variable
  REAL(KIND=4), DIMENSION (:,:), ALLOCATABLE :: uc, vc, u2, v2     ! velocities etc...
  REAL(KIND=4), DIMENSION (:,:), ALLOCATABLE :: eke                ! velocities etc...

  CHARACTER(LEN=256)                         :: cf_out='eke.nc'    ! file name
  CHARACTER(LEN=256)                         :: cf_ufil, cf_u2fil  ! file name
  CHARACTER(LEN=256)                         :: cf_vfil, cf_v2fil  !
  CHARACTER(LEN=256)                         :: cf_tfil            !

  TYPE(variable), DIMENSION(1)               :: stypvar            !

  LOGICAL                                    :: lchk               ! checking files existence
  LOGICAL                                    :: lperio=.FALSE.     ! checking E-W periodicity
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  !!  Read command line
  narg= iargc()
  IF ( narg /= 5 ) THEN
     PRINT *,' usage : cdfeke U-file U2-file V-file V2-file T2-file'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'        Compute the Eddy Kinetic Energy from previously computed'
     PRINT *,'        mean values and mean squared values of velocity components.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       U-file  : gridU type file with mean U component.' 
     PRINT *,'       U2-file : gridU2 type file with mean U2 component.' 
     PRINT *,'       V-file  : gridV type file with mean V component.' 
     PRINT *,'       V2-file : gridV2 type file with mean V2 component.' 
     PRINT *,'       T2-file : any gridT or gridT2 (smaller) file, used for EKE header.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        none'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : voeke (m2/s)'
     STOP
  ENDIF
  !!
  !! Initialisation from 1st file (all file are assume to have the same geometry)
  CALL getarg (1, cf_ufil )
  CALL getarg (2, cf_u2fil)
  CALL getarg (3, cf_vfil )
  CALL getarg (4, cf_v2fil)
  CALL getarg (5, cf_tfil )

  lchk =           chkfile (cf_ufil )
  lchk = lchk .OR. chkfile (cf_u2fil)
  lchk = lchk .OR. chkfile (cf_vfil )
  lchk = lchk .OR. chkfile (cf_v2fil)
  lchk = lchk .OR. chkfile (cf_tfil )
  IF ( lchk ) STOP ! missing files

  npiglo = getdim (cf_ufil,cn_x)
  npjglo = getdim (cf_ufil,cn_y)
  npk    = getdim (cf_ufil,cn_z)
  npt    = getdim (cf_ufil,cn_t)

  ipk(1)                       = npk
  stypvar(1)%cname             = 'voeke'
  stypvar(1)%cunits            = 'm2/s2'
  stypvar(1)%rmissing_value    = 0.
  stypvar(1)%valid_min         = 0.
  stypvar(1)%valid_max         = 10000.
  stypvar(1)%clong_name        = 'Eddy_Kinetic_Energy'
  stypvar(1)%cshort_name       = 'voeke'
  stypvar(1)%conline_operation = 'N/A'
  stypvar(1)%caxis             = 'TZYX'

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  ALLOCATE( uc(npiglo,npjglo), u2(npiglo,npjglo), vc(npiglo,npjglo), v2(npiglo,npjglo) )
  ALLOCATE( eke(npiglo,npjglo) , tim(npt) )

  ncout = create      (cf_out, cf_tfil, npiglo, npjglo, npk       )
  ierr  = createvar   (ncout,  stypvar, 1,      ipk,    id_varout )
  ierr  = putheadervar(ncout,  cf_tfil, npiglo, npjglo, npk       )

  ! check for E_W periodicity
  uc(:,:) = getvar(cf_tfil, cn_vlon2d, 1, npiglo, npjglo )
  IF ( uc(1,1) ==  uc(npiglo-1,1) ) THEN 
     lperio = .TRUE. 
     PRINT *,' E-W periodicity detected '
  ENDIF

  DO jt = 1, npt  ! input file is likely to contain only one time frame but who knows ...
    DO jk = 1, npk
      uc(:,:) = getvar(cf_ufil,  cn_vozocrtx,               jk, npiglo, npjglo, ktime=jt )
      vc(:,:) = getvar(cf_vfil,  cn_vomecrty,               jk, npiglo, npjglo, ktime=jt )
      u2(:,:) = getvar(cf_u2fil, TRIM(cn_vozocrtx)//'_sqd', jk ,npiglo, npjglo, ktime=jt )
      v2(:,:) = getvar(cf_v2fil, TRIM(cn_vomecrty)//'_sqd', jk ,npiglo, npjglo, ktime=jt )

      ua = 0. ; va = 0. ; eke(:,:) = 0.
      DO ji=2, npiglo
        DO jj=2,npjglo
          ua = 0.5* ((u2(ji,jj)-uc(ji,jj)*uc(ji,jj))+ (u2(ji-1,jj)-uc(ji-1,jj)*uc(ji-1,jj)))
          va = 0.5* ((v2(ji,jj)-vc(ji,jj)*vc(ji,jj))+ (v2(ji,jj-1)-vc(ji,jj-1)*vc(ji,jj-1)))
          eke(ji,jj) = 0.5 * ( ua + va )
        END DO
      END DO
      IF ( lperio ) eke(1,:) = eke(npiglo-1,:)
      ierr=putvar(ncout,id_varout(1), eke, jk ,npiglo, npjglo, ktime=jt )
    END DO
  END DO ! time loop

  tim  = getvar1d(cf_ufil, cn_vtimec, npt     )
  ierr = putvar1d(ncout,   tim,       npt, 'T')

  ierr = closeout(ncout)

END PROGRAM cdfeke

PROGRAM cdfhgradb
  !!======================================================================
  !!                     ***  PROGRAM  cdfhgradb ***
  !!=====================================================================
  !!  ** Purpose : Compute the norm of the lateral buoyancy gradient.
  !!
  !!  ** Method  :
  !!
  !! History : 3.0  : 08/2015  : J. Le Sommer (from cdfgradT)
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  !!   routines      : description
  !!   CreateOutput  :  perform all the stuff linked with output file 
  !!----------------------------------------------------------------------
  USE cdfio
  USE eos
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class derived_fields
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4), PARAMETER                  :: jp_varout = 1     ! number of output variables
  INTEGER(KIND=4)                             :: jk, jt            ! dummy loop index
  INTEGER(KIND=4)                             :: ji, jj, jlev      ! dummy loop index
  INTEGER(KIND=4)                             :: narg, ijarg, iargc! command line
  INTEGER(KIND=4)                             :: npiglo, npjglo    ! size of the domain
  INTEGER(KIND=4)                             :: npk, npkk,  npt   ! size of the domain
  INTEGER(KIND=4)                             :: ncout             ! ncid of output variable
  INTEGER(KIND=4)                             :: ierr              ! error status
  INTEGER(KIND=4), DIMENSION(jp_varout)       :: ipk, id_varout    ! output variable

  REAL(KIND=4)                                :: zdep              ! temporary scalar
  REAL(KIND=4), DIMENSION(:),     ALLOCATABLE :: gdept             ! depth of Tlevels
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: umask, vmask, tmask ! relevant mask
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: e1u, e2v          ! metrics
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: zt, zs            ! Temperature Salinity on 2 levels
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: zalbet, zbeta         ! for alpha and beta

  REAL(KIND=8)                                :: dgrav=9.81d0
  REAL(KIND=8), DIMENSION(:),     ALLOCATABLE :: dtim              ! time variable
  REAL(KIND=8), DIMENSION(:,:),   ALLOCATABLE :: dgradt_xu, dgradt_yv! Temperature gradient, native grid
  REAL(KIND=8), DIMENSION(:,:),   ALLOCATABLE :: dgrads_xu, dgrads_yv! Salinity gradient, native grid

  REAL(KIND=8), DIMENSION(:,:),   ALLOCATABLE :: dgradt_xt, dgradt_yt! Temperature gradient, t-point
  REAL(KIND=8), DIMENSION(:,:),   ALLOCATABLE :: dgrads_xt, dgrads_yt! Salinity gradient, t-point

  REAL(KIND=8), DIMENSION(:,:),   ALLOCATABLE :: dgradb_xt, dgradb_yt ! Buyoyancy gradient, t-point
  REAL(KIND=8), DIMENSION(:,:),   ALLOCATABLE :: dgradb              ! norm of the buyoyancy gradient, t-point


  CHARACTER(LEN=256)                         :: cf_tfil             ! input file name for T and S
  CHARACTER(LEN=256)                         :: cf_sfil             ! input file name for S (optional)
  CHARACTER(LEN=256)                         :: cf_out = 'hgradb_gridT.nc' ! output file name
  CHARACTER(LEN=256)                         :: cldum               ! dummy character variable
  CHARACTER(LEN=256)                         :: cv_sal              ! salinity name in netcdf
  CHARACTER(LEN=256)                         :: cv_tem              ! temperature name in netcdf

  TYPE(variable), DIMENSION(jp_varout)       :: stypvar             ! output data structure

  LOGICAL                                    :: lchk = .FALSE.      ! flag for missing files
  LOGICAL                                    :: lnc4 = .FALSE.      ! flag for netcdf4 output with chunking and deflation

  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfhgradb -t T-file [-s S-file] [-o OUT-file] [-nc4] ...'
     PRINT *,'                   ...  [-sal SAL-name]  [-tem TEMP-name] '
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the norm of the horizontal buoyancy gradient. Results are '
     PRINT *,'       saved at T points.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -t T-file : File with ',TRIM(cn_votemper),' and ',TRIM(cn_vosaline),' variables' 
     PRINT *,'           If ',TRIM(cn_vosaline),' not in T-file use -s option.'
     PRINT *,'          Note that salinity and/or temperature variables name can be changed'
     PRINT *,'          with -sal and/or -tem options, respectively.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'        [-s S-file ]   : File with ',TRIM(cn_vosaline),' variable if not in T file.'
     PRINT *,'        [-o OUT-file]  : specify the name of output file instead of '
     PRINT *,'                   ',TRIM(cf_out)
     PRINT *,'        [-nc4]         : use netcdf4 chunking and deflation on output.'
     PRINT *,'        [-sal SAL-name]: specify the name of salinity variable.'
     PRINT *,'        [-tem TEM-name]: specify the name of temperature variable.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ', TRIM(cn_fhgr),' ',TRIM(cn_fmsk),' and ',TRIM(cn_fzgr)
     PRINT *,'      '
     PRINT *,'     OPENMP SUPPORTED : yes '
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out),' ( unless specified with -o option)' 
     PRINT *,'         ',jp_varout,' variables : '
     PRINT *,'              vohgradb: norm of the horizontal buoyancy gradient at t-point'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'        cdfbuoyflx  '
     PRINT *,'      '
     STOP 
  ENDIF

  ijarg =1 
  cv_sal=cn_vosaline
  cv_tem=cn_votemper
  DO WHILE ( ijarg <= narg )
     CALL getarg (ijarg, cldum ) ; ijarg = ijarg + 1 
     SELECT CASE ( cldum) 
     CASE ( '-t '  ) ; CALL getarg (ijarg, cf_tfil ) ; ijarg = ijarg+1
        cf_sfil=cf_tfil
     CASE ( '-s '  ) ; CALL getarg (ijarg, cf_sfil ) ; ijarg = ijarg+1
     CASE ( '-nc4 ') ; lnc4 = .TRUE.
     CASE ( '-o'   ) ; CALL getarg (ijarg, cf_out ) ; ijarg = ijarg+1
     CASE ( '-sal' ) ; CALL getarg (ijarg, cv_sal ) ; ijarg = ijarg+1
     CASE ( '-tem' ) ; CALL getarg (ijarg, cv_tem ) ; ijarg = ijarg+1
     CASE DEFAULT    ; PRINT *,' ERROR : ',TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  ENDDO

  lchk = ( lchk .OR. chkfile(cf_tfil) )
  lchk = ( lchk .OR. chkfile(cf_sfil) )
  lchk = ( lchk .OR. chkfile(cn_fhgr) )
  lchk = ( lchk .OR. chkfile(cn_fzgr) )
  lchk = ( lchk .OR. chkfile(cn_fmsk) )
  IF (lchk ) STOP 99 ! missing file

  npiglo = getdim (cf_tfil, cn_x)
  npjglo = getdim (cf_tfil, cn_y)
  npk    = getdim (cf_tfil, cn_z)
  npt    = getdim (cf_tfil, cn_t)

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  npkk=npk
  IF ( npk == 0 ) npkk = 1

  !!  Allocate arrays
  ALLOCATE (dtim(npt) )
  ALLOCATE (gdept(npkk) )
  ALLOCATE (e1u  (npiglo,npjglo), e2v  (npiglo,npjglo) )
  ALLOCATE (umask(npiglo,npjglo), vmask(npiglo,npjglo), tmask(npiglo,npjglo))
  ALLOCATE (zt   (npiglo,npjglo), zs (npiglo,npjglo))
  ALLOCATE ( zalbet(npiglo,npjglo), zbeta(npiglo, npjglo) )
  ALLOCATE (dgradt_xu(npiglo,npjglo), dgradt_yv(npiglo,npjglo))
  ALLOCATE (dgrads_xu(npiglo,npjglo), dgrads_yv(npiglo,npjglo))
  ALLOCATE (dgradt_xt(npiglo,npjglo), dgradt_yt(npiglo,npjglo))
  ALLOCATE (dgrads_xt(npiglo,npjglo), dgrads_yt(npiglo,npjglo))
  ALLOCATE (dgradb_xt(npiglo,npjglo), dgradb_yt(npiglo,npjglo))
  ALLOCATE (dgradb(npiglo,npjglo))

  CALL CreateOutput

  e1u =  getvar(cn_fhgr, cn_ve1u, 1, npiglo, npjglo)
  e2v =  getvar(cn_fhgr, cn_ve2v, 1, npiglo, npjglo)
  gdept(:)    = getvare3(cn_fzgr, cn_gdept, npkk )

  DO jt = 1,npt
     DO jk = 1, npkk

        PRINT *,'level ',jk
        zdep = gdept(jk)

        ! read files
        zt(:,:) = getvar(cf_tfil, cv_tem, jk,   npiglo, npjglo, ktime=jt)
        zs(:,:) = getvar(cf_sfil, cv_sal, jk,   npiglo, npjglo, ktime=jt)

        umask(:,:) = getvar(cn_fmsk, cn_umask , jk, npiglo, npjglo )
        vmask(:,:) = getvar(cn_fmsk, cn_vmask , jk, npiglo, npjglo )
        tmask(:,:) = getvar(cn_fmsk, cn_tmask , jk, npiglo, npjglo )

        ! zonal grad located at U point at current level
        dgradt_xu(:,:) = 0.d0
        dgradt_xu(1:npiglo-1,:) = 1.d0 / e1u(1:npiglo-1,:) * &
             &                 ( zt(2:npiglo,:) - zt(1:npiglo-1,:) ) * umask(1:npiglo-1,:)
        dgrads_xu(:,:) = 0.d0
        dgrads_xu(1:npiglo-1,:) = 1.d0 / e1u(1:npiglo-1,:) * &
             &                 ( zs(2:npiglo,:) - zs(1:npiglo-1,:) ) * umask(1:npiglo-1,:)

        ! meridional grad located at V point at current level
        dgradt_yv(:,:) = 0.d0
        dgradt_yv(:,1:npjglo-1) = 1.d0 / e2v(:,1:npjglo-1) * &
             &                 ( zt(:,2:npjglo) - zt(:,1:npjglo-1) ) * vmask(:,1:npjglo-1)
        dgrads_yv(:,:) = 0.d0
        dgrads_yv(:,1:npjglo-1) = 1.d0 / e2v(:,1:npjglo-1) * &
             &                 ( zs(:,2:npjglo) - zs(:,1:npjglo-1) ) * vmask(:,1:npjglo-1)

        ! get temperature and salinity gradients at t-point 
        dgradt_xt(:,:) = 0.d0
        dgradt_yt(:,:) = 0.d0
        dgrads_xt(:,:) = 0.d0
        dgrads_yt(:,:) = 0.d0

        DO ji=2,npiglo
           DO jj=2,npjglo
              dgradt_xt(ji,jj) = 0.5*(dgradt_xu(ji-1,jj)+dgradt_xu(ji,jj))
              dgrads_xt(ji,jj) = 0.5*(dgrads_xu(ji-1,jj)+dgrads_xu(ji,jj))
              dgradt_yt(ji,jj) = 0.5*(dgradt_yv(ji,jj-1)+dgradt_yv(ji,jj))
              dgrads_yt(ji,jj) = 0.5*(dgrads_yv(ji,jj-1)+dgrads_yv(ji,jj))
           ENDDO
        ENDDO

        ! compute alpha and beta at t-point
        zalbet(:,:) = albet ( zt, zs, zdep, npiglo, npjglo) ! not exact for partial-step level
        zbeta (:,:) = beta  ( zt, zs, zdep, npiglo, npjglo) ! 

        ! compute the buoyancy gradients at t-point
        dgradb_xt(:,:) = zbeta(:,:) * ( zalbet(:,:) * dgradt_xt(:,:) - dgrads_xt(:,:) ) * tmask(:,:)
        dgradb_yt(:,:) = zbeta(:,:) * ( zalbet(:,:) * dgradt_yt(:,:) - dgrads_yt(:,:) ) * tmask(:,:)

        ! get the norm of the buoyancy gradients at t-point
        dgradb(:,:) = dgrav * SQRT( dgradb_xt(:,:) * dgradb_xt(:,:) + dgradb_yt(:,:) * dgradb_yt(:,:) )

        ! write
        ierr = putvar(ncout, id_varout(1), REAL(dgradb), jk, npiglo, npjglo, ktime=jt)
     END DO
  END DO

  ierr = closeout(ncout)

CONTAINS
  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Set up all things required for the output file, create
    !!               the file and write the header part. 
    !!
    !! ** Method  :  Use global module variables 
    !!
    !!----------------------------------------------------------------------
    ipk(:) = npkk  !  3D

    stypvar(1)%cname             = 'vohgradb'
    stypvar(1)%cunits            = 's^{-2}'
    stypvar(1)%rmissing_value    = -1000.
    stypvar(1)%valid_min         = -1.
    stypvar(1)%valid_max         = 1.
    stypvar(1)%clong_name        = 'Horizontal gradient of buoyancy.'
    stypvar(1)%cshort_name       = 'vohgradb'
    stypvar(1)%conline_operation = 'N/A'
    stypvar(1)%ichunk            = (/npiglo, MAX(1,npjglo/30), 1, 1 /)

    ! create output fileset
    ncout = create      (cf_out, cf_tfil, npiglo, npjglo, npk,       ld_nc4=lnc4    )
    ierr  = createvar   (ncout,  stypvar, jp_varout, ipk, id_varout, ld_nc4=lnc4    )
    ierr  = putheadervar(ncout,  cf_tfil, npiglo, npjglo, npk       )

    dtim = getvar1d(cf_tfil, cn_vtimec, npt     )
    ierr = putvar1d(ncout,  dtim,       npt, 'T')

  END SUBROUTINE CreateOutput

END PROGRAM cdfhgradb

PROGRAM cdfflxconv
  !!-------------------------------------------------------------------
  !!              PROGRAM CDFFLXCONV
  !!              ******************
  !!
  !!  **  Purpose: Convert a set of fluxes dimgfile (Clipper like)
  !!               to a set of CDF files (Drakkar like )
  !!  
  !!  **  Method: takes the current year as input, and config name
  !!              automatically read 
  !!                  ECMWF.Y${year}.M??.FLUX.${config}.dimg (daily, 1 file per month)
  !!                  ECMWF.Y${year}.M??.STRESS.${config}.dimg (daily, 1 file per month)
  !!                  REYNOLDS.Y${year}.SST.${config}.dimg ( weekly, 1 file per year ) ! Danger !
  !!              creates 6 netcdf daily files :
  !!                  ECMWF_emp_1d_${year}.${config}.nc                
  !!                  ECMWF_qnet_1d_${year}.${config}.nc                
  !!                  ECMWF_qsr_1d_${year}.${config}.nc                
  !!                  ECMWF_sst_1d_${year}.${config}.nc                
  !!                  ECMWF_taux_1d_${year}.${config}.nc                
  !!                  ECMWF_tauy_1d_${year}.${config}.nc                
  !!              Requires  coordinates.diags file (to be input consistent)
  !!
  !! history:
  !!    Original:  J.M. Molines (Feb. 2007 )
  !!-------------------------------------------------------------------
  !!  $Rev$
  !!  $Date$
  !!  $Id$
  !!--------------------------------------------------------------
  !!
  !! * Modules used
  USE cdfio 

  !! * Local variables
  IMPLICIT NONE
  INTEGER   :: ji,jj,jk, jvar, jmonth, jdim, jday, jt
  INTEGER   :: narg, iargc, nvar
  INTEGER   :: npiglo,npjglo, npk                           !: size of the domain
  INTEGER   :: iyear, icurrday, jul, jul1, jul2
  INTEGER   :: id1, id2, ii1, ii2, ntime, ntp, ntn, itt
  INTEGER   :: january1, december31
  INTEGER, DIMENSION(:), ALLOCATABLE :: itime

  REAL(KIND=4) , DIMENSION (:,:,:), ALLOCATABLE :: v2d
  REAL(KIND=4) , DIMENSION (:,:), ALLOCATABLE ::  glam, gphi, z2d, v2daily
  REAL(KIND=4) , DIMENSION (:,:), ALLOCATABLE ::  glamu, gphiu
  REAL(KIND=4) , DIMENSION (:,:), ALLOCATABLE ::  glamv, gphiv
  REAL(KIND=4) , DIMENSION (:), ALLOCATABLE :: dep, timetab
  REAL(KIND=8) , DIMENSION (:), ALLOCATABLE ::  timetag, timetagp,timetagn
  REAL(KIND=4) ,DIMENSION(1)                  :: timean 

  CHARACTER(LEN=256) :: ctag, confcase

  ! Dimg stuff
  INTEGER   :: irecl, ii, nt, ndim, irec
  INTEGER   :: numflx=10, numcoo=11, numtau=12, numsst=14, numsstp=15, numsstn=16
  CHARACTER(LEN=256) :: cflux, ctau, csstr,csstrp, csstrn
  CHARACTER(LEN=256) :: coord='coordinates.diags'
  CHARACTER(LEN=256) :: cheader, cdum, config
  CHARACTER(LEN=4) :: cver
  REAL(KIND=4) :: x1,y1, dx,dy, spval
  ! coordinates.diags
  INTEGER :: nrecl8
  REAL(KIND=8) :: zrecl8, zpiglo,zpjglo
  REAL(KIND=8) , DIMENSION (:,:), ALLOCATABLE ::  dzvar
  CHARACTER(LEN=256) :: cltextco
  LOGICAL :: lexist

  ! Netcdf Stuff
  CHARACTER(LEN=256) :: cemp, cqnet, cqsr, ctaux, ctauy, csst
  TYPE(variable), DIMENSION(:), ALLOCATABLE :: typvaremp,typvarqnet,typvarqsr
  TYPE(variable), DIMENSION(:), ALLOCATABLE :: typvartaux,typvartauy,typvarsst
  INTEGER, DIMENSION(:), ALLOCATABLE ::  ipkemp, ipkqnet, ipkqsr, id_varoutemp,id_varoutqnet, id_varoutqsr
  INTEGER, DIMENSION(:), ALLOCATABLE ::  ipktaux, ipktauy, ipksst, id_varouttaux,id_varouttauy, id_varoutsst
  INTEGER    :: ncoutemp, ncoutqnet, ncoutqsr, ncouttaux, ncouttauy, ncoutsst
  INTEGER    :: istatus

  !!  Read command line
  narg= iargc()
  IF ( narg /= 2 ) THEN
     PRINT *,' Usage : cdfflxconv YEAR config '
     PRINT *,'    Output 6 cdf files : for emp, qnet, qsr, sst, taux, tauy with standard var name :'
     PRINT *,'        sowaflup, sohefldo, soshfldo, sst, sozotaux, sometauy '
     PRINT *,'    coordinates.diags ( clipper like) is required in current dir '
     STOP
  ENDIF
  !!
  CALL getarg (1, cdum)
  READ(cdum,*) iyear
  CALL getarg (2, config)


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !!     .....    FLUXES    FLUXES   FLUXES .....                                                     !!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  PRINT *, 'Doing fluxes ... '

  !! read glam gphi in the coordinates file for T point (fluxes)
  nrecl8=200
  OPEN(numcoo,FILE=coord,status='old' ,form='unformatted', access='direct',recl=nrecl8)
  READ(numcoo,rec=1) cltextco,zrecl8,zpiglo,zpjglo
  CLOSE(numcoo)
  nrecl8=zrecl8 ;  npiglo=zpiglo ; npjglo=zpjglo
  ALLOCATE ( glam(npiglo,npjglo), gphi(npiglo,npjglo) ,dzvar(npiglo,npjglo) )
  OPEN(numcoo,FILE=coord,status='old' ,form='unformatted', access='direct',recl=nrecl8)
  READ(numcoo,REC=2)((dzvar(ji,jj),ji=1,npiglo),jj=1,npjglo)  ; glam(:,:) = dzvar(:,:)
  READ(numcoo,REC=6)((dzvar(ji,jj),ji=1,npiglo),jj=1,npjglo)  ; gphi(:,:) = dzvar(:,:)
  DEALLOCATE ( dzvar )
  CLOSE(numcoo)

  !! build nc output files
  WRITE(cemp,'(a,I4.4,a)') 'ECMWF_emp_1d_',iyear,'.'//TRIM(config)//'.nc'
  WRITE(cqnet,'(a,I4.4,a)') 'ECMWF_qnet_1d_',iyear,'.'//TRIM(config)//'.nc'
  WRITE(cqsr,'(a,I4.4,a)') 'ECMWF_qsr_1d_',iyear,'.'//TRIM(config)//'.nc'

  jmonth=1
  !! Build dimg file names
  WRITE(cflux,'(a,I4.4,a,I2.2,a)') 'ECMWF.Y',iyear,'.M',jmonth,'.FLUX.'//TRIM(config)//'.dimg'
  ! WRITE(ctau ,'(a,I4.4,a,I2.2,a)') 'ECMWF.Y',iyear,'.M',imonth,'.STRESS.'//TRIM(config)//'.dimg'
  ! WRITE(csst ,'(a,I4.4,a,I2.2,a)') 'REYNOLDS.Y',iyear,'.SST.'//TRIM(config)//'.dimg'

  ! open (and check ?? if they exists )
  irecl=isdirect(cflux)  ; OPEN( numflx,FILE=cflux, FORM='UNFORMATTED', ACCESS='DIRECT', RECL=irecl )

  READ(numflx,REC=1) cver, cheader, ii, npiglo, npjglo, npk

  ALLOCATE (v2d(npiglo, npjglo,4), dep(npk) )
  ALLOCATE (z2d(npiglo, npjglo) )
  READ(numflx,REC=1) cver, cheader, ii, npiglo, npjglo, npk, nt, ndim, &
       x1,y1,dx,dy,spval,   &
       (dep(jk),jk=1,npk), &
       timean(1)
  CLOSE(numflx)

  ! Build  cdf files output
  nvar = 1 ! 1 var but many files ... (OK  ... 3 actually )
  ALLOCATE ( typvaremp(nvar), ipkemp(nvar), id_varoutemp(nvar) )
  ALLOCATE ( typvarqnet(nvar), ipkqnet(nvar), id_varoutqnet(nvar) )
  ALLOCATE ( typvarqsr(nvar), ipkqsr(nvar), id_varoutqsr(nvar) )
  jvar=1
  ipkemp(jvar)      = 1
  typvaremp(jvar)%cname='sowaflup'    ! E - P = dim 3 - dim 4 dimgfile
  typvaremp(jvar)%cunits='kg/m2/s'
  typvaremp(jvar)%rmissing_value=0.
  typvaremp(jvar)%valid_min= -0.002
  typvaremp(jvar)%valid_max= 0.002
  typvaremp(jvar)%clong_name='E-P Upward water flux'
  typvaremp(jvar)%cshort_name='sowaflup'
  typvaremp(jvar)%conline_operation='N/A'
  typvaremp(jvar)%caxis='TYX'

  ipkqnet(jvar)      = 1
  typvarqnet(jvar)%cname='sohefldo'   !  QNET = dim 1 dimgfile
  typvarqnet(jvar)%cunits='W/m2'
  typvarqnet(jvar)%rmissing_value=0.
  typvarqnet(jvar)%valid_min= -1000.
  typvarqnet(jvar)%valid_max= 1000.
  typvarqnet(jvar)%clong_name='Net_Downward_Heat_Flux'
  typvarqnet(jvar)%cshort_name='sohefldo'
  typvarqnet(jvar)%conline_operation='N/A'
  typvarqnet(jvar)%caxis='TYX'

  ipkqsr(jvar)      = 1
  typvarqsr(jvar)%cname='soshfldo'   ! QSR = dim 2 dimgfile
  typvarqsr(jvar)%cunits='W/m2'
  typvarqsr(jvar)%rmissing_value=0.
  typvarqsr(jvar)%valid_min= -1000.
  typvarqsr(jvar)%valid_max= 1000.
  typvarqsr(jvar)%clong_name='Short_Wave_Radiation'
  typvarqsr(jvar)%cshort_name='soshfldo'
  typvarqsr(jvar)%conline_operation='N/A'
  typvarqsr(jvar)%caxis='TYX'

  ncoutemp =create(cemp, 'none',npiglo,npjglo,npk,cdep='deptht' )
  istatus= createvar(ncoutemp ,typvaremp,nvar, ipkemp,id_varoutemp )
  istatus= putheadervar(ncoutemp, 'none', npiglo, npjglo,npk, pnavlon=glam,pnavlat=gphi,pdep=dep )
  ncoutqnet =create(cqnet, 'none',npiglo,npjglo,npk,cdep='deptht' )
  istatus= createvar(ncoutqnet ,typvarqnet,nvar, ipkqnet,id_varoutqnet )
  istatus= putheadervar(ncoutqnet, 'none', npiglo, npjglo,npk, pnavlon=glam,pnavlat=gphi,pdep=dep )
  ncoutqsr =create(cqsr, 'none',npiglo,npjglo,npk,cdep='deptht' )
  istatus= createvar(ncoutqsr ,typvarqsr,nvar, ipkqsr,id_varoutqsr )
  istatus= putheadervar(ncoutqsr, 'none', npiglo, npjglo,npk, pnavlon=glam,pnavlat=gphi,pdep=dep )

  ! Ready for time loop on month
  icurrday=0
  DO jmonth = 1, 12
     WRITE(cflux,'(a,I4.4,a,I2.2,a)') 'ECMWF.Y',iyear,'.M',jmonth,'.FLUX.'//TRIM(config)//'.dimg'
     irecl=isdirect(cflux)  ; OPEN( numflx,FILE=cflux, FORM='UNFORMATTED', ACCESS='DIRECT', RECL=irecl )
     READ(numflx,REC=1) cver, cheader, ii, npiglo, npjglo, npk, nt, ndim
     ! loop for days in files
     DO jday=1,nt
        icurrday=icurrday +1
        DO jdim=1,ndim
           irec=1+(jday-1)*ndim +jdim
           READ(numflx,REC=irec) (( v2d(ji,jj,jdim),ji=1,npiglo),jj=1,npjglo) 
        END DO
        ! emp
        z2d=(v2d(:,:,3) - v2d(:,:,4) )/ 86400.   ! scaling from mm/d to kg/m2/s
        istatus = putvar(ncoutemp,id_varoutemp(1),z2d,icurrday,npiglo,npjglo)
        ! qnet
        istatus = putvar(ncoutqnet,id_varoutqnet(1),v2d(:,:,1),icurrday,npiglo,npjglo)
        ! qsr
        istatus = putvar(ncoutqsr,id_varoutqsr(1),v2d(:,:,2),icurrday,npiglo,npjglo)
     END DO ! loop on days
     CLOSE(numflx)
  END DO ! loop on month

  ! update time_counter
  ALLOCATE( timetab (icurrday) )
  timetab=(/(jt,jt=1,icurrday)/)
  istatus=putvar1d(ncoutemp,timetab,icurrday,'T')
  istatus=putvar1d(ncoutqnet,timetab,icurrday,'T')
  istatus=putvar1d(ncoutqsr,timetab,icurrday,'T')
  ! close fluxes files
  istatus=closeout(ncoutemp)
  istatus=closeout(ncoutqnet)
  istatus=closeout(ncoutqsr)
  DEALLOCATE (v2d , dep, z2d , timetab )

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !!     .....    STRESSES    STRESSES    STRESSES   ......                                       !!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  PRINT *,' Doing Stresses ...'

  !! read glam gphi in the coordinates file for U point (fluxes)
  nrecl8=200
  OPEN(numcoo,FILE=coord,status='old' ,form='unformatted', access='direct',recl=nrecl8)
  READ(numcoo,rec=1) cltextco,zrecl8,zpiglo,zpjglo
  CLOSE(numcoo)
  nrecl8=zrecl8 ;  npiglo=zpiglo ; npjglo=zpjglo
  ALLOCATE ( glamu(npiglo,npjglo), gphiu(npiglo,npjglo) ,dzvar(npiglo,npjglo) )
  ALLOCATE ( glamv(npiglo,npjglo), gphiv(npiglo,npjglo) )
  OPEN(numcoo,FILE=coord,status='old' ,form='unformatted', access='direct',recl=nrecl8)
  READ(numcoo,REC=3)((dzvar(ji,jj),ji=1,npiglo),jj=1,npjglo)  ; glamu(:,:) = dzvar(:,:)
  READ(numcoo,REC=7)((dzvar(ji,jj),ji=1,npiglo),jj=1,npjglo)  ; gphiu(:,:) = dzvar(:,:)
  READ(numcoo,REC=4)((dzvar(ji,jj),ji=1,npiglo),jj=1,npjglo)  ; glamv(:,:) = dzvar(:,:)
  READ(numcoo,REC=8)((dzvar(ji,jj),ji=1,npiglo),jj=1,npjglo)  ; gphiv(:,:) = dzvar(:,:)
  DEALLOCATE ( dzvar )
  CLOSE(numcoo)

  !! build nc output files
  WRITE(ctaux,'(a,I4.4,a)') 'ECMWF_taux_1d_',iyear,'.'//TRIM(config)//'.nc'
  WRITE(ctauy,'(a,I4.4,a)') 'ECMWF_tauy_1d_',iyear,'.'//TRIM(config)//'.nc'

  jmonth=1
  !! Build dimg file names
  WRITE(ctau ,'(a,I4.4,a,I2.2,a)') 'ECMWF.Y',iyear,'.M',jmonth,'.STRESS.'//TRIM(config)//'.dimg'
  ! WRITE(csst ,'(a,I4.4,a,I2.2,a)') 'REYNOLDS.Y',iyear,'.SST.'//TRIM(config)//'.dimg'

  ! open (and check ?? if they exists )
  irecl=isdirect(ctau)  ; OPEN( numtau,FILE=ctau, FORM='UNFORMATTED', ACCESS='DIRECT', RECL=irecl )

  READ(numtau,REC=1) cver, cheader, ii, npiglo, npjglo, npk

  ALLOCATE (v2d(npiglo, npjglo,2), dep(npk) )
  ALLOCATE (z2d(npiglo, npjglo) )
  READ(numtau,REC=1) cver, cheader, ii, npiglo, npjglo, npk, nt, ndim, &
       x1,y1,dx,dy,spval,   &
       (dep(jk),jk=1,npk), &
       timean(1)
  CLOSE(numtau)

  ! Build  cdf files output
  nvar = 1 ! 1 var but many files ... (OK  ... 3 actually )
  ALLOCATE ( typvartaux(nvar), ipktaux(nvar), id_varouttaux(nvar) )
  ALLOCATE ( typvartauy(nvar), ipktauy(nvar), id_varouttauy(nvar) )
  jvar=1
  ipktaux(jvar)      = 1
  typvartaux(jvar)%cname='sozotaux'    ! taux dim 1 of dimgfile
  typvartaux(jvar)%cunits='N/m2'
  typvartaux(jvar)%rmissing_value=0.
  typvartaux(jvar)%valid_min= -0.1
  typvartaux(jvar)%valid_max= 0.1
  typvartaux(jvar)%clong_name='Zonal Wind Stress'
  typvartaux(jvar)%cshort_name='sozotaux'
  typvartaux(jvar)%conline_operation='N/A'
  typvartaux(jvar)%caxis='TYX'

  ipktauy(jvar)      = 1
  typvartauy(jvar)%cname='sometauy'    ! tauy dim 2 of dimgfile
  typvartauy(jvar)%cunits='N/m2'
  typvartauy(jvar)%rmissing_value=0.
  typvartauy(jvar)%valid_min= -0.1
  typvartauy(jvar)%valid_max= 0.1
  typvartauy(jvar)%clong_name='Meridional Wind Stress'
  typvartauy(jvar)%cshort_name='sometauy'
  typvartauy(jvar)%conline_operation='N/A'
  typvartauy(jvar)%caxis='TYX'

  ncouttaux =create(ctaux, 'none',npiglo,npjglo,npk,cdep='deptht' )
  istatus= createvar(ncouttaux ,typvartaux,nvar, ipktaux,id_varouttaux )
  istatus= putheadervar(ncouttaux, 'none', npiglo, npjglo,npk, pnavlon=glam,pnavlat=gphi,pdep=dep )

  ncouttauy =create(ctauy, 'none',npiglo,npjglo,npk,cdep='deptht' )
  istatus= createvar(ncouttauy ,typvartauy,nvar, ipktauy,id_varouttauy )
  istatus= putheadervar(ncouttauy, 'none', npiglo, npjglo,npk, pnavlon=glam,pnavlat=gphi,pdep=dep )

  ! Ready for time loop on month
  icurrday=0
  DO jmonth = 1, 12
     WRITE(ctau,'(a,I4.4,a,I2.2,a)') 'ECMWF.Y',iyear,'.M',jmonth,'.STRESS.'//TRIM(config)//'.dimg'
     irecl=isdirect(ctau)  ; OPEN( numtau,FILE=ctau, FORM='UNFORMATTED', ACCESS='DIRECT', RECL=irecl )
     READ(numtau,REC=1) cver, cheader, ii, npiglo, npjglo, npk, nt, ndim
     ! loop for days in files
     DO jday=1,nt
        icurrday=icurrday +1
        DO jdim=1,ndim
           irec=1+(jday-1)*ndim +jdim
           READ(numtau,REC=irec) (( v2d(ji,jj,jdim),ji=1,npiglo),jj=1,npjglo) 
        END DO
        ! taux
        istatus = putvar(ncouttaux,id_varouttaux(1),v2d(:,:,1),icurrday,npiglo,npjglo)
        ! tauy
        istatus = putvar(ncouttauy,id_varouttauy(1),v2d(:,:,2),icurrday,npiglo,npjglo)
     END DO ! loop on days
     CLOSE(numtau)
  END DO ! loop on month

  ! update time_counter
  ALLOCATE( timetab (icurrday) )
  timetab=(/(jt,jt=1,icurrday)/)
  istatus=putvar1d(ncouttaux,timetab,icurrday,'T')
  istatus=putvar1d(ncouttauy,timetab,icurrday,'T')
  ! close fluxes files
  istatus=closeout(ncouttaux)
  istatus=closeout(ncouttauy)
  DEALLOCATE (v2d , dep, z2d , timetab)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !!     .....    SST    SST     SST     .....
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  PRINT *,' Doing SST ...'

  !!  glam gphi are already read ( T point)

  !! build nc output files
  WRITE(csst,'(a,I4.4,a)') 'REYNOLDS_sst_1d_',iyear,'.'//TRIM(config)//'.nc'

  !! Build dimg file names
  WRITE(csstr ,'(a,I4.4,a,I2.2,a)') 'REYNOLDS.Y',iyear,'.SST.'//TRIM(config)//'.dimg'

  ! open (and check ?? if they exists )
  irecl=isdirect(csstr)  ; OPEN( numsst,FILE=csstr, FORM='UNFORMATTED', ACCESS='DIRECT', RECL=irecl )

  READ(numsst,REC=1) cver, cheader, ii, npiglo, npjglo, npk, nt

  ALLOCATE (v2d(npiglo, npjglo,nt+2),itime(nt+2), dep(npk) ,timetab(nt), timetag(nt) )
  ALLOCATE (z2d(npiglo, npjglo) ,v2daily(npiglo,npjglo)  )
  READ(numsst,REC=1) cver, cheader, ii, npiglo, npjglo, npk, nt, ndim, &
       x1,y1,dx,dy,spval,   &
       (dep(jk),jk=1,npk), &
       (timetab(jt), jt=1,nt)
       timetag=timetab ! convert to dble precision
       DEALLOCATE(timetab)

  ! Build  cdf files output
  nvar = 1 ! 1 var but many files ... (OK  ... 3 actually )
  ALLOCATE ( typvarsst(nvar), ipksst(nvar), id_varoutsst(nvar) )
  jvar=1
  ipksst(jvar)      = 1
  typvarsst(jvar)%cname='sst'    ! sst dim 1 of dimgfile
  typvarsst(jvar)%cunits='C'
  typvarsst(jvar)%rmissing_value=0.
  typvarsst(jvar)%valid_min= -10.
  typvarsst(jvar)%valid_max= 50.
  typvarsst(jvar)%clong_name='Reynolds SST'
  typvarsst(jvar)%cshort_name='SST'
  typvarsst(jvar)%conline_operation='N/A'
  typvarsst(jvar)%caxis='TYX'

  ncoutsst =create(csst, 'none',npiglo,npjglo,npk,cdep='deptht' )
  istatus= createvar(ncoutsst ,typvarsst,nvar, ipksst,id_varoutsst )
  istatus= putheadervar(ncoutsst, 'none', npiglo, npjglo,npk, pnavlon=glam,pnavlat=gphi,pdep=dep )

  ! We want to interpolate the data for every day. (weekly in the file)
  ! if first day of the file is not 01/01, needs to read previous year
  !  Clipper SST files are not y2k compliant ...
  IF (timetag (1) < 10000 ) THEN 
     timetag(:)=timetag(:)+20000000.
  ELSE
     timetag(:)=timetag(:)+19000000.
  ENDIF
  january1=iyear*10000+01*100+01
  december31=iyear*10000+12*100+31
  jul1=julday(january1)
  jul2=julday(december31)

  itt=0
  IF (jul1 < julday(INT(timetag(1)))  ) THEN
     ! need to read previous year 
     WRITE(csstrp ,'(a,I4.4,a,I2.2,a)') 'REYNOLDS.Y',iyear-1,'.SST.'//TRIM(config)//'.dimg'
     irecl=isdirect(csstrp)  ; OPEN( numsstp,FILE=csstrp, FORM='UNFORMATTED', ACCESS='DIRECT', RECL=irecl )
     READ(numsstp,REC=1) cver, cheader, ii, npiglo, npjglo, npk, ntp
     ALLOCATE (timetagp (ntp) ,timetab(ntp))
     READ(numsstp,REC=1) cver, cheader, ii, npiglo, npjglo, npk, ntp, ndim, &
          x1,y1,dx,dy,spval,   &
          (dep(jk),jk=1,npk), &
          (timetab(jt), jt=1,ntp)
         timetagp=timetab 
         DEALLOCATE(timetab)
     IF (timetagp (1) < 10000 ) THEN 
        timetagp(:)=timetagp(:)+20000000.
     ELSE
        timetagp(:)=timetagp(:)+19000000.
     ENDIF
     IF ( julday(INT(timetagp (ntp)))  <= jul1 ) THEN
        !read ntp sst as 1 data
        itt = itt +1
        READ(numsstp,REC=ntp+1) (( v2d(ji,jj,itt),ji=1,npiglo),jj=1,npjglo)
        itime(itt)=julday( INT(timetagp(ntp)) )
     ELSE IF  ( julday(INT(timetagp (ntp-1))  ) <= jul1 ) THEN
        itt = itt +1
        READ(numsstp,REC=ntp) (( v2d(ji,jj,itt),ji=1,npiglo),jj=1,npjglo)
        itime(itt)=julday(INT(timetagp(ntp-1)) )
     ELSE IF  ( julday(INT(timetagp (ntp-2) )) <= jul1 ) THEN
        itt = itt +1
        READ(numsstp,REC=ntp-1) (( v2d(ji,jj,itt),ji=1,npiglo),jj=1,npjglo)
        itime(itt)=julday(INT(timetagp(ntp-2)) )
     ELSE
        PRINT *,' Something is wrong in previous file SST ' ; STOP 99
     ENDIF
  ENDIF
  DO jt=1,nt
     itt = itt +1
     READ(numsst,REC=jt+1) (( v2d(ji,jj,itt),ji=1,npiglo),jj=1,npjglo)
     itime(itt)=julday(INT(timetag(jt)) )
  END DO

  IF ( jul2 > julday(INT(timetag(nt))) ) THEN
     ! need to read next year
     IF ( iyear == 2000 ) THEN   ! persistance ...
        itt=itt+1 ;  v2d(:,:,itt)= v2d(:,:,itt-1)  ; itime(itt)=jul2
     ELSE
        WRITE(csstrn ,'(a,I4.4,a,I2.2,a)') 'REYNOLDS.Y',iyear+1,'.SST.'//TRIM(config)//'.dimg'
        irecl=isdirect(csstrn)  ; OPEN( numsstn,FILE=csstrn, FORM='UNFORMATTED', ACCESS='DIRECT', RECL=irecl )
        READ(numsstn,REC=1) cver, cheader, ii, npiglo, npjglo, npk, ntn
        ALLOCATE (timetagn (ntn) ,timetab(ntn))
        READ(numsstn,REC=1) cver, cheader, ii, npiglo, npjglo, npk, ntn, ndim, &
             x1,y1,dx,dy,spval,   &
             (dep(jk),jk=1,npk), &
             (timetab(jt), jt=1,ntn)
        timetagn=timetab
        DEALLOCATE( timetab)
        IF (timetagn (1) < 10000 ) THEN 
           timetagn(:)=INT(timetagn(:))+20000000
        ELSE
           timetagn(:)=INT(timetagn(:))+19000000
        ENDIF

        IF ( julday(INT(timetagn (1) )) >= jul2 ) THEN
           !read 1 sst as 1 data
           itt = itt +1
           READ(numsstn,REC=2) (( v2d(ji,jj,itt),ji=1,npiglo),jj=1,npjglo)
           itime(itt)=julday(INT(timetagn(1)) )
        ELSE IF  ( julday(INT(timetagn (2)) ) >= jul2 ) THEN
           itt = itt +1
           READ(numsstn,REC=3) (( v2d(ji,jj,itt),ji=1,npiglo),jj=1,npjglo)
           itime(itt)=julday(INT( timetagn(2)) )
        ELSE IF  ( julday(INT(timetagn (3))) >= jul2 ) THEN
           itt = itt +1
           READ(numsstn,REC=4) (( v2d(ji,jj,itt),ji=1,npiglo),jj=1,npjglo)
           itime(itt)=julday(INT(timetagn(3)) )
        ELSE
           PRINT *,' Something is wrong in next file SST ' ; STOP 99
        ENDIF
     ENDIF
  ENDIF
     ntime=itt

     icurrday=0
     ii1=1 ; ii2 = 2 ; id1=itime(ii1) ; id2=itime(ii2) 
     DO jul = jul1, jul2
        icurrday=icurrday + 1
        IF ( jul > id2 ) THEN
           ii1=ii1+1 ; ii2=ii2+1 ;  id1=itime(ii1) ; id2=itime(ii2)
        ENDIF
        v2daily(:,:)=FLOAT((jul - id1 ))/(FLOAT(id2-id1))*(v2d(:,:,ii2) - v2d(:,:,ii1) ) +  v2d(:,:,ii1)
        istatus = putvar(ncoutsst,id_varoutsst(1),v2daily(:,:),icurrday,npiglo,npjglo)
     END DO

     ! update time_counter
     ALLOCATE( timetab (icurrday) )
     timetab=(/(jt,jt=1,icurrday)/)
     istatus=putvar1d(ncoutsst,timetab,icurrday,'T')
     ! close fluxes files
     istatus=closeout(ncoutsst)
     istatus=closeout(ncoutsst)
     DEALLOCATE (v2d , dep, z2d )

   CONTAINS
     INTEGER FUNCTION isdirect(clname)
!!!                     FUNCTION ISDIRECT
!!!                     *****************
!!!
!!!    PURPOSE : This integer function returns the record length if clname
!!!              is a valid dimg file, it returns 0 either.
!!!
!!!    METHOD : Open the file and look for the key characters (@!01) for
!!!             identification.
!!!
!!!    AUTHOR : Jean-Marc Molines (Apr. 1998)
!!! -------------------------------------------------------------------------
       IMPLICIT NONE
       CHARACTER(LEN=*), INTENT(in) ::  clname
       CHARACTER(LEN=4)  ::  cver
       CHARACTER(LEN=256) ::  clheader
       !
       INTEGER :: irecl

       !
       OPEN(100,FILE=clname, FORM   ='UNFORMATTED', ACCESS ='DIRECT', RECL   =88)
       READ(100,REC=1) cver ,clheader,irecl
       CLOSE(100)
       !
       IF (cver ==  '@!01' ) THEN
          isdirect=irecl
       ELSE
          isdirect=0
       END IF
       !
     END FUNCTION isdirect

     FUNCTION julday(kdastp)
       !! ------------------------------------------------------------------
       !!          ***        FUNCTION JULDAY    ***
       !!
       !!   Purpose:   This routine returns the julian day number which begins at noon
       !!         of the calendar date specified by month kmm, day kid, and year kiyyy.
       !!         positive year signifies a.d.; negative, b.c.  (remember that the
       !!         year after 1 b.c. was 1 a.d.)
       !!         routine handles changeover to gregorian calendar on oct. 15, 1582.
       !!
       !!   Method:  This routine comes directly from the Numerical Recipe Book,
       !!           press et al., numerical recipes, cambridge univ. press, 1986.
       !!
       !!   Arguments:
       !!     kdastp  : OPA date yyyymmdd (instead of kmm kid kiyyy)
       !!     kmm     : input, corresponding month
       !!     kid     : input, corresponding day
       !!     kiyyy   : input, corresponding year, positive IF a.d, negative b.c.
       !!      
       !!     
       !!   history
       !!     1998: J.M. Molines for the Doctor form. 
       !!     2007 : J.M. Molines in F90
       !! -----------------------------------------------------------------
       !  *  Declarations
       !
       INTEGER :: julday, kiyyy,kid,kmm
       INTEGER, INTENT(in)  ::kdastp
       !  * Local 
       INTEGER, PARAMETER ::jpgreg=15+31*(10+12*1582)
       INTEGER  :: iy, im, ia
       ! ... Year 0 never existed ...
       kiyyy=kdastp/10000
       kmm=(kdastp - kiyyy*10000)/100
       kid= kdastp - kiyyy*10000 - kmm*100
       IF (kiyyy == 0) STOP 101
       !
       IF (kiyyy < 0) kiyyy = kiyyy + 1
       IF (kmm > 2) THEN
          iy = kiyyy
          im = kmm + 1
       ELSE
          iy = kiyyy - 1
          im = kmm + 13
       END IF
       !
       julday = INT(365.25*iy) + INT(30.6001*im) + kid + 1720995 
       IF (kid+31*(kmm+12*kiyyy).GE.jpgreg) THEN
          ia = INT(0.01*iy)
          julday = julday + 2 - ia + INT(0.25*ia) 
       END IF
     END FUNCTION JULDAY
   END PROGRAM cdfflxconv

PROGRAM cdfhgradv
  !!======================================================================
  !!                     ***  PROGRAM  cdfhgradv ***
  !!=====================================================================
  !!  ** Purpose : Compute the norm of horizontal gradient for a variable
  !!
  !!  ** Method  :
  !!
  !! History :   : 4.0  : 06/2018  : J.M. Molines  (from cdfhgradb)
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  !!   routines      : description
  !!   CreateOutput  :  perform all the stuff linked with output file 
  !!----------------------------------------------------------------------
  USE cdfio
  USE eos
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class derived_fields
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4), PARAMETER                  :: jp_varout = 1     ! number of output variables
  INTEGER(KIND=4)                             :: jk, jt            ! dummy loop index
  INTEGER(KIND=4)                             :: ji, jj, jlev      ! dummy loop index
  INTEGER(KIND=4)                             :: narg, ijarg, iargc! command line
  INTEGER(KIND=4)                             :: npiglo, npjglo    ! size of the domain
  INTEGER(KIND=4)                             :: npk, npkk,  npt   ! size of the domain
  INTEGER(KIND=4)                             :: ncout             ! ncid of output variable
  INTEGER(KIND=4)                             :: ierr              ! error status
  INTEGER(KIND=4), DIMENSION(jp_varout)       :: ipk, id_varout    ! output variable

  REAL(KIND=4)                                :: zdep              ! temporary scalar
  REAL(KIND=4), DIMENSION(:),     ALLOCATABLE :: gdept             ! depth of Tlevels
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: umask, vmask, tmask ! relevant mask
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: e1u, e2v          ! metrics
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: zv                ! Variables

  REAL(KIND=8)                                :: dgrav=9.81d0
  REAL(KIND=8), DIMENSION(:),     ALLOCATABLE :: dtim              ! time variable
  REAL(KIND=8), DIMENSION(:,:),   ALLOCATABLE :: dgradv_xu, dgradv_yv! Temperature gradient, native grid
  REAL(KIND=8), DIMENSION(:,:),   ALLOCATABLE :: dgradv_xt, dgradv_yt! Temperature gradient, t-point

  REAL(KIND=8), DIMENSION(:,:),   ALLOCATABLE :: dgradv              ! norm of the buyoyancy gradient, t-point


  CHARACTER(LEN=256)                         :: cf_in               ! input file name for T and S
  CHARACTER(LEN=256)                         :: cf_out = 'grad.nc'  ! output file name
  CHARACTER(LEN=256)                         :: cldum               ! dummy character variable
  CHARACTER(LEN=256)                         :: cv_in               ! input variable

  TYPE(variable), DIMENSION(jp_varout)       :: stypvar             ! output data structure

  LOGICAL                                    :: lchk = .FALSE.      ! flag for missing files
  LOGICAL                                    :: lnc4 = .FALSE.      ! flag for netcdf4 output with chunking and deflation

  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfhgradv -f IN-file  -v VAR-name [-o OUT-file] [-nc4] ...'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the norm of the horizontal gradient of a variable.'
     PRINT *,'       Results are saved at T points.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -f IN-file  : input file'
     PRINT *,'       -v VAR-name : input variable'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'        [-o OUT-file]  : specify the name of output file instead of '
     PRINT *,'                   ',TRIM(cf_out)
     PRINT *,'        [-nc4]         : use netcdf4 chunking and deflation on output.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ', TRIM(cn_fhgr),' ',TRIM(cn_fmsk),' and ',TRIM(cn_fzgr)
     PRINT *,'      '
     PRINT *,'     OPENMP SUPPORTED : yes '
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out),' ( unless specified with -o option)' 
     PRINT *,'         ',jp_varout,' variables : '
     PRINT *,'              vohgradb: norm of the horizontal buoyancy gradient at t-point'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'        cdfbuoyflx  '
     PRINT *,'      '
     STOP 
  ENDIF

  ijarg =1 
  DO WHILE ( ijarg <= narg )
     CALL getarg (ijarg, cldum ) ; ijarg = ijarg + 1 
     SELECT CASE ( cldum) 
     CASE ( '-f '  ) ; CALL getarg (ijarg, cf_in  ) ; ijarg = ijarg+1
     CASE ( '-v '  ) ; CALL getarg (ijarg, cv_in  ) ; ijarg = ijarg+1
     CASE ( '-nc4 ') ; lnc4 = .TRUE.
     CASE ( '-o'   ) ; CALL getarg (ijarg, cf_out ) ; ijarg = ijarg+1
     CASE DEFAULT    ; PRINT *,' ERROR : ',TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  ENDDO

  lchk = ( lchk .OR. chkfile(cf_in) )
  lchk = ( lchk .OR. chkfile(cn_fhgr) )
  lchk = ( lchk .OR. chkfile(cn_fzgr) )
  lchk = ( lchk .OR. chkfile(cn_fmsk) )
  IF (lchk ) STOP 99 ! missing file

  npiglo = getdim (cf_in, cn_x)
  npjglo = getdim (cf_in, cn_y)
  npk    = getdim (cf_in, cn_z)
  npt    = getdim (cf_in, cn_t)

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  npkk=npk
  IF ( npk == 0 ) npkk = 1

  !!  Allocate arrays
  ALLOCATE (dtim(npt) )
  ALLOCATE (gdept(npkk) )
  ALLOCATE (e1u  (npiglo,npjglo), e2v  (npiglo,npjglo) )
  ALLOCATE (umask(npiglo,npjglo), vmask(npiglo,npjglo), tmask(npiglo,npjglo))
  ALLOCATE (zv   (npiglo,npjglo))
  ALLOCATE (dgradv_xu(npiglo,npjglo), dgradv_yv(npiglo,npjglo))
  ALLOCATE (dgradv_xt(npiglo,npjglo), dgradv_yt(npiglo,npjglo))
  ALLOCATE (dgradv(npiglo,npjglo))

  CALL CreateOutput

  e1u =  getvar(cn_fhgr, cn_ve1u, 1, npiglo, npjglo)
  e2v =  getvar(cn_fhgr, cn_ve2v, 1, npiglo, npjglo)
  gdept(:)    = getvare3(cn_fzgr, cn_gdept, npkk )

  DO jt = 1,npt
     DO jk = 1, npkk

        PRINT *,'level ',jk
        zdep = gdept(jk)

        ! read files
        zv(:,:) = getvar(cf_in, cv_in, jk,   npiglo, npjglo, ktime=jt)

        umask(:,:) = getvar(cn_fmsk, cn_umask , jk, npiglo, npjglo )
        vmask(:,:) = getvar(cn_fmsk, cn_vmask , jk, npiglo, npjglo )
        tmask(:,:) = getvar(cn_fmsk, cn_tmask , jk, npiglo, npjglo )

        ! zonal grad located at U point at current level
        dgradv_xu(:,:) = 0.d0
        dgradv_xu(1:npiglo-1,:) = 1.d0 / e1u(1:npiglo-1,:) * &
             &                 ( zv(2:npiglo,:) - zv(1:npiglo-1,:) ) * umask(1:npiglo-1,:)

        ! meridional grad located at V point at current level
        dgradv_yv(:,:) = 0.d0
        dgradv_yv(:,1:npjglo-1) = 1.d0 / e2v(:,1:npjglo-1) * &
             &                 ( zv(:,2:npjglo) - zv(:,1:npjglo-1) ) * vmask(:,1:npjglo-1)

        ! get temperature and salinity gradients at t-point 
        dgradv_xt(:,:) = 0.d0
        dgradv_yt(:,:) = 0.d0

        DO ji=2,npiglo
           DO jj=2,npjglo
              dgradv_xt(ji,jj) = 0.5*(dgradv_xu(ji-1,jj)+dgradv_xu(ji,jj))
              dgradv_yt(ji,jj) = 0.5*(dgradv_yv(ji,jj-1)+dgradv_yv(ji,jj))
           ENDDO
        ENDDO


        ! get the norm of the buoyancy gradients at t-point
        dgradv(:,:) =  SQRT( dgradv_xt(:,:) * dgradv_xt(:,:) + dgradv_yt(:,:) * dgradv_yt(:,:) )

        ! write
        ierr = putvar(ncout, id_varout(1), REAL(dgradv), jk, npiglo, npjglo, ktime=jt)
     END DO
  END DO

  ierr = closeout(ncout)

CONTAINS
  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Set up all things required for the output file, create
    !!               the file and write the header part. 
    !!
    !! ** Method  :  Use global module variables 
    !!
    !!----------------------------------------------------------------------
    ipk(:) = npkk  !  3D

    stypvar(1)%cname             = 'vohgradb'
    stypvar(1)%cunits            = 's^{-2}'
    stypvar(1)%rmissing_value    = -1000.
    stypvar(1)%valid_min         = -1.
    stypvar(1)%valid_max         = 1.
    stypvar(1)%clong_name        = 'Horizontal gradient of buoyancy.'
    stypvar(1)%cshort_name       = 'vohgradb'
    stypvar(1)%conline_operation = 'N/A'
    stypvar(1)%ichunk            = (/npiglo, MAX(1,npjglo/30), 1, 1 /)

    ! create output fileset
    ncout = create      (cf_out, cf_in, npiglo, npjglo, npk,         ld_nc4=lnc4    )
    ierr  = createvar   (ncout,  stypvar, jp_varout, ipk, id_varout, ld_nc4=lnc4    )
    ierr  = putheadervar(ncout,  cf_in, npiglo, npjglo, npk       )

    dtim = getvar1d(cf_in,  cn_vtimec,  npt     )
    ierr = putvar1d(ncout,  dtim,       npt, 'T')

  END SUBROUTINE CreateOutput

END PROGRAM cdfhgradv

PROGRAM cdfisf_forcing
  !!======================================================================
  !!                     ***  PROGRAM  cdfisf_forcing  ***
  !!=====================================================================
  !!  ** Purpose : spread a specified total ice shelf melting over a specific
  !!               ice shelf melting pattern
  !!
  !!  ** Method  : read an ice shelf mask file produce by cdffill, read the
  !!               integrate melting for each ice shelf and the wanted pattern,
  !!               then compute the final melting for each ice shelf.
  !!
  !! History : 3.0  : 04/2014  : Pierre Mathiot 
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  USE cdfio 
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2010, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!-----------------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                               :: jisf               ! dummy loop counter
  INTEGER(KIND=4)                               :: ierr               ! working integer
  INTEGER(KIND=4)                               :: narg, iargc, ijarg ! browsing command line
  INTEGER(KIND=4)                               :: npiglo, npjglo     ! size of the domain
  INTEGER(KIND=4)                               :: npk, npt, nisf     ! size of the domain
  INTEGER(KIND=4)                               :: iunit=10           ! id file
  INTEGER(KIND=4)                               :: ncout              ! ncid of output files
  INTEGER(KIND=4)                               :: iiseed, ijseed
  INTEGER(KIND=4)                               :: ifill
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: ipk                ! arrays of vertical level for each var
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: id_varout          ! varid's of average vars

  INTEGER(KIND=2), DIMENSION(:,:),  ALLOCATABLE :: ipoolmsk           ! mask for closed pool
  INTEGER(KIND=2), DIMENSION(:,:),  ALLOCATABLE :: isfindex           ! index of each ISF ( negative integer)
  INTEGER(KIND=2), DIMENSION(:,:),  ALLOCATABLE :: isfindex_wk        ! index of each ISF 'working variable)

  REAL(KIND=4)                                  :: rdraftmax, rdraftmin ! dummy information in input file
  REAL(KIND=4)                                  :: rlon, rlat         ! dummy information in input file

  REAL(KIND=8)                                  :: dl_fwf, dsumcoef
  REAL(KIND=8)                                  :: dfwf
  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: dfwfisf2d
  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: de12t
  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: dl_fwfisf2d, dl_fwfispat

  CHARACTER(LEN=256)                            :: cf_fill            ! input file names
  CHARACTER(LEN=256)                            :: cf_isflist         ! input file names
  CHARACTER(LEN=256)                            :: cf_out='isfforcing.nc' ! output file for average
  CHARACTER(LEN=256)                            :: cf_pat='isfpattern.nc' ! pattern file
  CHARACTER(LEN=256)                            :: cf_pool='isfpool.nc'   ! pools mask file
  CHARACTER(LEN=256)                            :: cv_dep             ! depth dimension name
  CHARACTER(LEN=256)                            :: cv_pat='sowflisf'  ! pattern variable name
  CHARACTER(LEN=256)                            :: cv_pool='isfpoolmask'! pattern variable name
  CHARACTER(LEN=256)                            :: cv_fill            ! isf index variable in cf_fill
  CHARACTER(LEN=256)                            :: cdum               ! dummy string argument

  TYPE (variable), DIMENSION(:),    ALLOCATABLE :: stypvar            ! attributes for average values

  LOGICAL                                       :: lnc4 = .FALSE.     ! flag for netcdf4 chunking and deflation
  LOGICAL                                       :: lchk = .FALSE.     ! flag for missing values

  !!----------------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfisf_forcing -f ISF-fill_file  -v ISF-fill_var -l ISF-listfile '
     PRINT *,'             -m ISF-poolmask [-vm ISF-poolmask_variable] [-p PATTERN-file] '
     PRINT *,'            [-vp PATTERN-variable] [-nc4] [-o OUT-file ]'
     PRINT *,'      '
     PRINT *,'     PURPOSE : '
     PRINT *,'         Build basal melting rate file used in NEMO ISF when nn_isf=4 '
     PRINT *,'      '
     PRINT *,'     ARGUMENTS : '
     PRINT *,'          -f ISF-fill_file : file built by cdfisf_fill (all the ice shelves '
     PRINT *,'                             are tagged with an id)'
     PRINT *,'          -v ISF-fill_var  : name of fill variable to use in ISF-fill_file'
     PRINT *,'          -l ISF-listfile : text file used to build the ISF-fill_file. '
     PRINT *,'                            Only the last variable on each line is used (GT/y)'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'          -p PATTERN-file : specify the file use for patterns. '
     PRINT *,'                            [ default : ',TRIM(cf_pat),' ]'
     PRINT *,'          -vp PATTERN-variable : specify the name of the pattern variable. '
     PRINT *,'                            [ default : ',TRIM(cv_pat),' ]'
     PRINT *,'          -vm ISF-poolmask_variable : specify the name of the variable used '
     PRINT *,'                 for masking the pools. [ default : ',TRIM(cv_pool),' ]'
     PRINT *,'          -nc4 : use netcdf4 chunking and deflation'
     PRINT *,'          -o OUT-file : specify output filename. [ default : ',TRIM(cf_out),' ]'
     PRINT *,'              '
     PRINT *,'     REQUIRED FILES : '
     PRINT *,'           mesh_zgr.nc mesh_hgr.nc,'
     PRINT *,'           isfpattern.nc (ie reference file used to define the isf melting '
     PRINT *,'                 pattern), unless -p option is used to give different name.'
     PRINT *,'      '
     PRINT *,'     OUTPUT :'
     PRINT *,'         netcdf file : ', TRIM(cf_out),' unless specified with -o option'
     PRINT *,'         variable : sofwfisf '
     PRINT *,'      '
     PRINT *,'     SEE ALSO : cdfisf_fill, cdfisf_rnf, cdfisf_poolchk'
     PRINT *,'      '
     STOP
  ENDIF

  ijarg = 1
  DO WHILE ( ijarg <= narg )
     CALL getarg(ijarg, cdum ) ; ijarg = ijarg + 1
     SELECT CASE ( cdum)
     CASE ( '-f' ) ; CALL getarg(ijarg, cf_fill    ) ; ijarg = ijarg + 1
     CASE ( '-v' ) ; CALL getarg(ijarg, cv_fill    ) ; ijarg = ijarg + 1
     CASE ( '-l' ) ; CALL getarg(ijarg, cf_isflist ) ; ijarg = ijarg + 1
     CASE ( '-o' ) ; CALL getarg(ijarg, cf_out     ) ; ijarg = ijarg + 1
     CASE ( '-p' ) ; CALL getarg(ijarg, cf_pat     ) ; ijarg = ijarg + 1
     CASE ( '-vp') ; CALL getarg(ijarg, cv_pat     ) ; ijarg = ijarg + 1
     CASE ( '-m' ) ; CALL getarg(ijarg, cf_pool    ) ; ijarg = ijarg + 1
     CASE ( '-vm') ; CALL getarg(ijarg, cv_pool    ) ; ijarg = ijarg + 1
     CASE ('-nc4') ; lnc4=.TRUE.
     CASE DEFAULT
        PRINT *, ' Option ', TRIM(cdum),' not understood'
        STOP
     END SELECT
  ENDDO

  lchk = lchk .OR. chkfile (cf_fill   )
  lchk = lchk .OR. chkfile (cf_isflist)
  lchk = lchk .OR. chkfile (cf_pat    )
  lchk = lchk .OR. chkfile (cf_pool   )
  lchk = lchk .OR. chkfile (cn_fzgr   )
  lchk = lchk .OR. chkfile (cn_fhgr   )
  IF ( lchk  ) STOP ! missing file

  npiglo = getdim (cf_fill, cn_x)
  npjglo = getdim (cf_fill, cn_y)
  npk    = 0  ! working with 2D files only

  PRINT *, 'NPIGLO = ', npiglo
  PRINT *, 'NPJGLO = ', npjglo
  PRINT *, 'NPK    = ', npk

  ALLOCATE(de12t(npiglo,npjglo))
  ALLOCATE(ipoolmsk(npiglo, npjglo), dfwfisf2d(npiglo, npjglo)    )
  ALLOCATE(dl_fwfisf2d(npiglo,npjglo), dl_fwfispat(npiglo,npjglo))
  ALLOCATE(isfindex(npiglo, npjglo), isfindex_wk(npiglo, npjglo) )

  ALLOCATE (stypvar(1))
  ALLOCATE (ipk(1),id_varout(1))
  ! initialisation of final fwf
  dfwfisf2d(:,:) = 0.0d0

  CALL CreateOutput

  ! define variable
  ! read ice shelf draft data
  de12t(:,:)    = getvar(cn_fhgr, cn_ve1t,  1, npiglo, npjglo ) *  getvar(cn_fhgr, cn_ve2t,  1, npiglo, npjglo )

  ! open isf file
  OPEN(unit=iunit, file=cf_isflist, form='formatted', status='old')
  ! get number of isf
  nisf = 0
  cdum='XXX'
  DO WHILE ( TRIM(cdum) /= 'EOF')
     READ(iunit,*) cdum
     nisf=nisf+1
  END DO
  REWIND(iunit)
  nisf = nisf - 1

  PRINT *, '   Number of ISF found in file list : ', nisf

  ! Read the Basal melting pattern, once for all
  dl_fwfispat(:,:) = getvar(cf_pat , cv_pat, 1 ,npiglo, npjglo )
  isfindex(:,:)    = getvar(cf_fill, cv_fill,1 ,npiglo, npjglo )  
  ipoolmsk(:,:)    = getvar(cf_pool, cv_pool,1 ,npiglo, npjglo )

  ! loop over all the ice shelf
  DO jisf=1,nisf
     ! initialize working pattern with the fixed one
     dl_fwfisf2d = dl_fwfispat

     ! reset working isf index to its initial value
     isfindex_wk(:,:) = isfindex(:,:)

     ! eliminate closed pools from isfindex, using ISF-pool file
     isfindex_wk = isfindex_wk * ipoolmsk

     ! read ice shelf data
     READ(iunit,*) ifill,cdum,rlon, rlat, iiseed, ijseed ,rdraftmin, rdraftmax, dfwf

     ! convertion of total ice shelf melting from Gt/y -> kg/s
     dl_fwf = dfwf * 1.d9 * 1.d3 / 86400.d0 / 365.d0

     ! initialisation of cumulative variable
     dsumcoef = 0.0d0

     ! isolate the ice shelf data we want
     WHERE (isfindex_wk /= -ifill)
        isfindex_wk(:,:) = 0      ! eliminate all ISF not current (-ifill)
        dl_fwfisf2d(:,:) = 0.0d0
     END WHERE

     ! set the halo to 0 (to avoid double counting)  ( E-W periodicity !)
     dl_fwfisf2d(1,:)=0.0d0 ; dl_fwfisf2d(npiglo,:)=0.0d0 ;

     dsumcoef = SUM(dl_fwfisf2d * de12t)
     dl_fwfisf2d(:,:) = dl_fwfisf2d(:,:) / dsumcoef * dl_fwf

     ! Value read from the text file has the wrong sign for melting.
     ! As the shelves are disjoint, cumulate is OK !
     dfwfisf2d(:,:) = dfwfisf2d(:,:) - dl_fwfisf2d(:,:)
  END DO

  ! print isf forcing file
  ierr = putvar(ncout, id_varout(1), dfwfisf2d, 1, npiglo, npjglo)

  ! close file
  ierr = closeout(ncout)

CONTAINS
  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create the output file. This is done outside the main
    !!               in order to increase readability of the code. 
    !!
    !! ** Method  :  Use global variables, defined in mail 
    !!----------------------------------------------------------------------
    ! define new variables for output
    stypvar(1)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(1)%cname             = 'sofwfisf'
    stypvar(1)%cunits            = 'kg/s'
    stypvar(1)%rmissing_value    =  -99.d0
    stypvar(1)%valid_min         =  0.d0
    stypvar(1)%valid_max         =  2000.d0
    stypvar(1)%clong_name        = 'Ice Shelf Fresh Water Flux '
    stypvar(1)%cshort_name       = 'sofwfisf'
    stypvar(1)%conline_operation = 'N/A'
    stypvar(1)%caxis             = 'TYX'
    stypvar(1)%cprecision        = 'r8'
    ipk(1) = 1  !  2D

    ! create output file taking the sizes in cf_fill
    ncout  = create      (cf_out, cf_fill, npiglo, npjglo, npk,   ld_nc4=lnc4 )
    ierr   = createvar   (ncout , stypvar, 1,  ipk,  id_varout,   ld_nc4=lnc4 )
    ierr   = putheadervar(ncout,  cn_fzgr, npiglo, npjglo, npk                )

  END SUBROUTINE CreateOutput

END PROGRAM cdfisf_forcing

PROGRAM cdfdegrad
  !!======================================================================
  !!                   ***  PROGRAM  cdfdegrad  ***
  !!=====================================================================
  !!  ** Purpose : Degrade horizontal resolution of NEMO output
  !!
  !!  ** Method  : Degradation procedure ensuring the conservation
  !!               of tracers fluxes, preserving the tracer budget (T)
  !!               preserve the mass fluxes ( U,V,W)
  !!
  !! History : 1.0 : 11/2011  : X. Meunier : Original code
  !!           3.0 : 02/2017  : J.-M. Molines : merge of all cdfdegradx tools
  !!                            debuging but still not completed
  !!         : 4.0 : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class file_operations
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: nflsdc        ! array for fluid sub-domain counter
  INTEGER(KIND=4), DIMENSION(:),     ALLOCATABLE :: ipk, id_varout ! netcdf output
  INTEGER(KIND=4)                           :: ji, jj, jk, jt     ! dummy loop index
  INTEGER(KIND=4)                           :: jri, jrj           ! dummy loop index
  INTEGER(KIND=4)                           :: ik, ii, ij         !
  INTEGER(KIND=4)                           :: it                 ! time index for vvl
  INTEGER(KIND=4)                           :: ix, iy             !
  INTEGER(KIND=4)                           :: idep, idep_max     ! index for finding vertical dimension
  INTEGER(KIND=4)                           :: ierr               ! error status
  INTEGER(KIND=4)                           :: nri=1, nrj=1       ! scale degrading factor along i and j  
  INTEGER(KIND=4)                           :: iimin=2            ! indice from where the filtering begins
  INTEGER(KIND=4)                           :: ijmin=2            ! indice from where the filtering begins
  INTEGER(KIND=4)                           :: narg, iargc, ijarg ! browse command line
  INTEGER(KIND=4)                           :: npiglo, npjglo     ! size of the domain
  INTEGER(KIND=4)                           :: npk, npt           ! size of the domain
  INTEGER(KIND=4)                           :: ncout              ! ncid of output file
  INTEGER(KIND=4)                           :: msks               ! mask sum on each coarse cells
  INTEGER(KIND=4)                           :: nvpk               ! vertical levels in working variable
  INTEGER(KIND=4)                           :: ikx, iky           ! dims of netcdf output file

  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zmask              ! 2D mask at current level
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: glamf, gphif       ! lon, lat
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e1, e2, e3, zv     ! metrics, variable
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: rdumlon, rdumlat   ! dummy lon/lat for output file
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: rdummymean         ! array for mean value on output file
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: gdep               ! depth 
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: zdep               ! depth of the whole vertical levels
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: e31d               ! 1d vertical spacing
  REAL(KIND=4)                              :: zspval             ! missing value

  REAL(KIND=8)                              :: dvol, dsum, dsurf  ! cumulated values
  REAL(KIND=8)                              :: dvol2d, dsum2d     !
  REAL(KIND=8), DIMENSION(:),   ALLOCATABLE :: dtim               ! time counter

  CHARACTER(LEN=256)                        :: cf_in              ! input filename
  CHARACTER(LEN=256)                        :: cf_e3              ! vertical metrics filename
  CHARACTER(LEN=256)                        :: cf_out=''          ! output file name
  !
  CHARACTER(LEN=256)                        :: cv_nam             ! current variable name
  CHARACTER(LEN=20)                         :: cv_e1, cv_e2       ! horizontal metrics names
  CHARACTER(LEN=20)                         :: cv_e3, cv_e31d     ! vertical metrics names
  CHARACTER(LEN=20)                         :: cv_msk             ! mask variable name
  CHARACTER(LEN=256)                        :: cv_dep             ! deptht name
  CHARACTER(LEN=256), DIMENSION(:),ALLOCATABLE :: clv_dep         ! deptht name
  !
  CHARACTER(LEN=256)                        :: clunits            ! attribute of output file : units
  CHARACTER(LEN=256)                        :: cldum              ! dummy char variable
  CHARACTER(LEN=256)                        :: cllong_name        !     "      long name
  CHARACTER(LEN=256)                        :: cglobal            !     "      global 
  CHARACTER(LEN=256)                        :: clshort_name       !     "      short name
  CHARACTER(LEN=256)                        :: ctyp=''            ! Point on C grid

  TYPE(variable), DIMENSION(:), ALLOCATABLE :: stypvar            ! structure of output

  LOGICAL                                   :: lfull  = .FALSE.   ! full step  flag
  LOGICAL                                   :: lstart = .FALSE.   ! change staring point flag
  LOGICAL                                   :: lchk               ! flag for missing files
  LOGICAL                                   :: ll_pt  = .FALSE.   ! flag for T point
  LOGICAL                                   :: ll_pu  = .FALSE.   ! flag for U point
  LOGICAL                                   :: ll_pv  = .FALSE.   ! flag for V point
  LOGICAL                                   :: ll_pw  = .FALSE.   ! flag for W point

  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfdegrad -f IN-file -v IN-var -r ri rj -p C-type  [-start i0 j0]'
     PRINT *,'       ... [-full] [-vvl] [-o OUT-file]'
     PRINT *,'       '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Degrad the horizontal resolution of a NEMO ouput file,       ' 
     PRINT *,'       for each z-level and time step, with a ratio of ri along     '
     PRINT *,'       x direction and rj along y direction. If specified, the input'
     PRINT *,'       grid is considered starting from the indices i0 and j0.      ' 
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -f IN-file : netcdf input file on grid point corresponding to -p option.' 
     PRINT *,'       -v IN-var  : name of netcdf variable to work with' 
     PRINT *,'       -r ri rj   : degradation ratio for x-direction and y-direction.' 
     PRINT *,'       -p C-type : position of variable on C-grid, one of T|U|V|W.'
     PRINT *,'      '
     PRINT *,'     OPTIONS : '
     PRINT *,'       [-start i0 j0] : spatial indices from where the procedure of   '
     PRINT *,'                        degradation starts. ' 
     PRINT *,'       [-o OUT-file ]:  output filename instead of ''degraded_<IN-var>.nc'' '
     PRINT *,'       [-vvl ] : use time-varying vertical metrics.'
     PRINT *,'       [-full] : flag for full steps grid, instead of default partial'
     PRINT *,'                 steps.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       Files ', TRIM(cn_fhgr),', ', TRIM(cn_fzgr),', ', TRIM(cn_fmsk)
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : degraded_<IN-var>.nc unless -o option is used'
     PRINT *,'          variables : degraded_<IN-VAR> '
     PRINT *,'                      flsdc : fluid subdomain counter '
     PRINT *,'      '
     STOP 
  ENDIF

  cglobal = 'Partial step computation'
  ijarg = 1 
  DO WHILE ( ijarg <= narg )
     CALL getarg(ijarg, cldum ) ; ijarg = ijarg + 1 
     SELECT CASE (cldum) 
     CASE ('-f'    ) ; CALL getarg(ijarg, cf_in   ) ; ijarg = ijarg + 1
     CASE ('-v'    ) ; CALL getarg(ijarg, cv_nam  ) ; ijarg = ijarg + 1
     CASE ('-r'    ) ; CALL getarg(ijarg, cldum   ) ; ijarg = ijarg + 1 ; READ(cldum,*) nri
        ;              CALL getarg(ijarg, cldum   ) ; ijarg = ijarg + 1 ; READ(cldum,*) nrj
     CASE ('-p'    ) ; CALL getarg(ijarg, ctyp    ) ; ijarg = ijarg + 1
        ! options
     CASE ('-o'    ) ; CALL getarg(ijarg, cf_out  ) ; ijarg = ijarg + 1
     CASE ('-full' ) ; lfull  = .TRUE. ; cglobal = 'full step computation'
     CASE ('-vvl'  ) ; lg_vvl = .TRUE. 
     CASE ('-start') ; lstart = .TRUE.
        ;              CALL getarg(ijarg, cldum   ) ; ijarg = ijarg + 1 ; READ(cldum,*) iimin
        ;              CALL getarg(ijarg, cldum   ) ; ijarg = ijarg + 1 ; READ(cldum,*) ijmin
     CASE DEFAULT    ; PRINT *,' ERROR : ',TRIM(cldum),' : unknown option !' ; STOP 99
     END SELECT
  END DO

  lchk = chkfile(cn_fhgr)
  lchk = chkfile(cn_fzgr) .OR. lchk
  lchk = chkfile(cn_fmsk) .OR. lchk
  lchk = chkfile(cf_in  ) .OR. lchk
  IF ( lchk   ) STOP 99 ! missing file

  SELECT CASE ( ctyp )
  CASE ( 'T' )
     ll_pt = .TRUE.
     IF ( .NOT. lstart ) THEN ; iimin=2 ; ijmin=2 ; ENDIF
     cf_e3    = cn_fe3t
     cv_e1    = cn_ve1t
     cv_e2    = cn_ve2t
     cv_e3    = cn_ve3t
     cv_e31d  = cn_ve3t1d
     cv_msk   = cn_tmask
     IF (lg_vvl ) cv_e3 = cn_ve3tvvl
  CASE ( 'U' )
     ll_pu = .TRUE.
     IF ( .NOT. lstart ) THEN ; iimin=1 ; ijmin=2 ; ENDIF
     cf_e3    = cn_fe3u
     cv_e1    = cn_ve1u
     cv_e2    = cn_ve2u
     cv_e3    = cn_ve3u
     cv_e31d  = cn_ve3t1d
     cv_msk   = cn_umask
     IF (lg_vvl ) cv_e3 = cn_ve3uvvl
  CASE ( 'V' )
     ll_pv = .TRUE.
     IF ( .NOT. lstart ) THEN ; iimin=2 ; ijmin=1 ; ENDIF
     cf_e3    = cn_fe3v
     cv_e1    = cn_ve1v
     cv_e2    = cn_ve2v
     cv_e3    = cn_ve3v
     cv_e31d  = cn_ve3t1d
     cv_msk   = cn_vmask
     IF (lg_vvl ) cv_e3 = cn_ve3vvvl
  CASE ( 'W' )
     ll_pw = .TRUE.
     IF ( .NOT. lstart ) THEN ; iimin=2 ; ijmin=2 ; ENDIF
     cf_e3    = cn_fe3w
     cv_e1    = cn_ve1t
     cv_e2    = cn_ve2t
     cv_e3    = cn_ve3w
     cv_e31d  = cn_ve3w1d
     cv_msk   = cn_tmask
     IF (lg_vvl ) cv_e3 = cn_ve3wvvl
  CASE DEFAULT ; PRINT *,' ERROR : C-grid point ', TRIM(ctyp),' not recognized' ; STOP 99
  END SELECT

  IF ( lg_vvl ) cf_e3 = cf_in  

  cv_dep = 'none'
  npiglo = getdim (cf_in  , cn_x)
  npjglo = getdim (cf_in  , cn_y)

  ! looking for npk among various possible name
  idep_max=8
  ALLOCATE ( clv_dep(idep_max) )
  clv_dep(:) = (/cn_z,'z','sigma','nav_lev','levels','ncatice','icbcla','icbsect'/)
  idep=1  ; ierr=1000

  DO WHILE ( ierr /= 0 .AND. idep <= idep_max )
     npk  = getdim (cf_in  , clv_dep(idep), cdtrue=cv_dep, kstatus=ierr)
     idep = idep + 1
  ENDDO

  IF ( ierr /= 0 ) THEN  ! none of the dim name was found
     PRINT *,' assume file with no depth'
     npk=0
  ENDIF

  npt    = getdim (cf_in  , cn_t   )
  nvpk   = getvdim(cf_in  , cv_nam )

  IF (npk   == 0 ) THEN ; npk = 1; ENDIF ! no depth dimension ==> 1 level
  ! retail horizontal fine resolution sizes to be multiple of the coarsening ratio

  SELECT CASE ( ctyp )
  CASE ( 'T' , 'W' ) 
     IF (iimin < 2  ) THEN ; PRINT *,'iimin value is too low' ; STOP 99 ; ENDIF
     IF (ijmin < 2  ) THEN ; PRINT *,'ijmin value is too low' ; STOP 99 ; ENDIF
     npiglo = ( (npiglo - iimin ) / nri )*nri
     npjglo = ( (npjglo - ijmin ) / nrj )*nrj
     ikx = npiglo / nri
     iky = npjglo / nrj
     ALLOCATE (e1(npiglo,npjglo), e2(npiglo,npjglo), e3(npiglo,npjglo) )
  CASE ( 'U' ) 
     IF (iimin < 1  ) THEN ; PRINT *,'iimin value is too low' ; STOP 99 ; ENDIF
     IF (ijmin < 2  ) THEN ; PRINT *,'ijmin value is too low' ; STOP 99 ; ENDIF
     npiglo = ( (npiglo - iimin - 1 ) / nri )*nri + 1
     npjglo = ( (npjglo - ijmin ) / nrj )*nrj
     ikx = ( npiglo - 1 ) / nri + 1
     iky = ( npjglo     ) / nrj
     ALLOCATE (e2(npiglo,npjglo), e3(npiglo,npjglo) )
  CASE ( 'V' ) 
     IF (iimin < 2  ) THEN ; PRINT *,'iimin value is too low' ; STOP 99 ; ENDIF
     IF (ijmin < 1  ) THEN ; PRINT *,'ijmin value is too low' ; STOP 99 ; ENDIF
     npiglo = ( (npiglo - iimin ) / nri )*nri
     npjglo = ( (npjglo - ijmin - 1 ) / nrj )*nrj + 1
     ikx = ( npiglo     ) / nri
     iky = ( npjglo - 1 ) / nrj + 1
     ALLOCATE (e1(npiglo,npjglo), e3(npiglo,npjglo) )
  END SELECT

  PRINT *,'ikx    : ',ikx
  PRINT *,'iky    : ',iky

  IF (nvpk == 2 ) npk = 1

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt
  PRINT *, 'nvpk   = ', nvpk
  PRINT *, 'depth dim name is ',TRIM(cv_dep)

  ! Allocate arrays
  ALLOCATE (zmask(npiglo,npjglo) )
  ALLOCATE (zv(npiglo,npjglo) )
  ALLOCATE (gdep (npk), e31d(npk), dtim(npt) )
  ALLOCATE (zdep(npk) )

  IF ( ll_pt .OR. ll_pw .OR. ll_pv )  e1(:,:) = getvar  (cn_fhgr, cv_e1,  1,  npiglo, npjglo, kimin=iimin, kjmin=ijmin)
  IF ( ll_pt .OR. ll_pw .OR. ll_pu )  e2(:,:) = getvar  (cn_fhgr, cv_e2,  1,  npiglo, npjglo, kimin=iimin, kjmin=ijmin)

  IF ( lfull )  e31d(:) = getvare3(cn_fzgr, cv_e31d, npk)
  zdep(:) = getvare3(cf_in, cv_dep, npk)
  gdep(:) = zdep(  1  :npk)

  ALLOCATE ( stypvar( 2 ), ipk( 2 ), id_varout( 2 ) )
  ALLOCATE ( rdumlon(ikx,iky), rdumlat(ikx,iky), rdummymean(ikx,iky) ) 
  ALLOCATE ( nflsdc(ikx,iky) )

  ! JMM: follow original X. Meunier code for u/v/t
  !      Can be done simpler
  SELECT CASE ( ctyp )
  CASE ( 'T' , 'W' )
     ALLOCATE ( glamf(npiglo+1,npjglo+1), gphif(npiglo+1,npjglo+1))
     glamf = getvar(cn_fhgr, cn_glamf, 1, npiglo+1 , npjglo+1 , kimin=iimin-1 , kjmin=ijmin-1 )
     gphif = getvar(cn_fhgr, cn_gphif, 1, npiglo+1 , npjglo+1 , kimin=iimin-1 , kjmin=ijmin-1 )

     DO jj=1,iky
        DO ji=1,ikx
           rdumlat(ji,jj) = 0.5 * ( gphif((ji-1)*nri+1,(jj-1)*nrj+1) + gphif( ji   *nri+1,jj*nrj+1) )
           rdumlon(ji,jj) = 0.5 * ( glamf( ji   *nri+1,(jj-1)*nrj+1) + glamf((ji-1)*nri+1,jj*nrj+1) )
        END DO
     END DO
  CASE ( 'U' )
     ALLOCATE ( glamf(npiglo,npjglo+1), gphif(npiglo,npjglo+1))
     glamf = getvar(cn_fhgr, cn_glamf, 1, npiglo , npjglo+1 , kimin=iimin , kjmin=ijmin-1 )
     gphif = getvar(cn_fhgr, cn_gphif, 1, npiglo , npjglo+1 , kimin=iimin , kjmin=ijmin-1 )

     DO ji=1,ikx
        DO jj=1,iky
           rdumlat(ji,jj) = 0.5 * ( gphif((ji-1)*nri+1,(jj-1)*nrj+1) + gphif((ji-1)*nri+1,jj*nrj+1) )
           rdumlon(ji,jj) = 0.5 * ( glamf((ji-1)*nri+1,(jj-1)*nrj+1) + glamf((ji-1)*nri+1,jj*nrj+1) )
        END DO
     END DO
  CASE ( 'V' )
     ALLOCATE ( glamf(npiglo+1,npjglo), gphif(npiglo+1,npjglo))
     glamf = getvar(cn_fhgr, cn_glamf, 1, npiglo+1 , npjglo , kimin=iimin-1 , kjmin=ijmin )
     gphif = getvar(cn_fhgr, cn_gphif, 1, npiglo+1 , npjglo , kimin=iimin-1 , kjmin=ijmin )
     DO jj=1,iky
        DO ji=1,ikx
           rdumlat(ji,jj) = 0.5 * ( gphif((ji-1)*nri+1,(jj-1)*nrj+1) + gphif(ji*nri+1,(jj-1)*nrj+1) )
           rdumlon(ji,jj) = 0.5 * ( glamf((ji-1)*nri+1,(jj-1)*nrj+1) + glamf(ji*nri+1,(jj-1)*nrj+1) )
        END DO
     END DO
  END SELECT
  DEALLOCATE ( glamf, gphif )

  CALL CreateOutput

  DO jt=1,npt
     IF ( lg_vvl ) THEN ; it=jt
     ELSE               ; it=1
     ENDIF
     DO jk = 1, npk
        ik = jk
        ! Get variable v at ik
        zmask(:,:) = getvar(cn_fmsk, cv_msk, ik, npiglo, npjglo, kimin=iimin, kjmin=ijmin          )

        IF (ll_pw ) THEN
           ! do nothing
        ELSE  ! read vertical metrics
           IF ( lfull ) THEN ; e3(:,:) = e31d(jk)
           ELSE              ; e3(:,:) = getvar(cf_e3, cv_e3,  ik, npiglo, npjglo, kimin=iimin, kjmin=ijmin, ktime=it, ldiom=.NOT.lg_vvl )
           END IF
        ENDIF
        ! 
        zv   (:,:) = getvar(cf_in  ,  cv_nam,   ik, npiglo, npjglo, kimin=iimin, kjmin=ijmin, ktime=jt)
        SELECT CASE ( ctyp )
        CASE ( 'T' )  ! weighted volume averaging
           DO jj=1,iky
              DO ji=1,ikx
                 dvol = 0.d0
                 dsum = 0.d0
                 msks = 0
                 ! volume averaging
                 DO jrj=1,nrj
                    DO jri=1,nri
                       ix = (ji-1)*nri+jri
                       iy = (jj-1)*nrj+jrj
                       dvol2d = e1(ix,iy) * e2(ix,iy) * e3(ix,iy) * zmask(ix,iy)
                       msks = msks + zmask(ix,iy)
                       dvol = dvol + dvol2d
                       dsum = dsum + zv(ix,iy) * dvol2d
                    END DO
                 END DO
                 IF ( dvol > 0.d0 ) THEN ; rdummymean(ji,jj) = dsum/dvol
                 ELSE                    ; rdummymean(ji,jj) = 99999.
                 END IF
                 nflsdc(ji,jj) = msks
              END DO
           END DO
        CASE ( 'U' )  ! lateral volume flux averaging
           DO ji=1,ikx
              ix = (ji-1)*nri+1
              DO jj=1,iky
                 dvol = 0.d0
                 dsum = 0.d0
                 msks = 0
                 DO jrj=1,nrj
                    iy = (jj-1)*nrj+jrj
                    ! JMM :note that X. Meunier code uses e1 instead of e2 ( bug ?)
                    ! JMM : for conservation of fluxes I think that dvol2d must not be masked. (bug ?)
                    dvol2d = e2(ix,iy) * e3(ix,iy) * zmask(ix,iy)
                    msks = msks + zmask(ix,iy)
                    dvol = dvol + dvol2d
                    dsum = dsum + zv(ix,iy) * dvol2d
                 END DO
                 IF ( dvol > 0.d0 ) THEN
                    rdummymean(ji,jj) = dsum/dvol
                 ELSE
                    rdummymean(ji,jj) = 99999.
                 END IF
                 nflsdc(ji,jj) = msks
              END DO
           END DO
        CASE ( 'V' ) ! lateral volume flux averaging
           DO jj=1,iky
              iy = (jj-1)*nrj+1
              DO ji=1,ikx
                 dvol = 0.d0
                 dsum = 0.d0
                 msks = 0
                 DO jri=1,nri
                    ix = (ji-1)*nri+jri
                    ! JMM :note that X. Meunier code uses e2 instead of e1 ( bug ?)
                    ! JMM : for conservation of fluxes I think that dvol2d must not be masked. (bug ?)
                    dvol2d = e1(ix,iy) * e3(ix,iy) * zmask(ix,iy)
                    msks = msks + zmask(ix,iy)
                    dvol = dvol + dvol2d
                    dsum = dsum + zv(ix,iy) * dvol2d
                 END DO
                 IF ( dvol > 0.d0 ) THEN
                    rdummymean(ji,jj) = dsum/dvol
                 ELSE
                    rdummymean(ji,jj) = 99999.
                 END IF
                 nflsdc(ji,jj) = msks
              END DO
           END DO
        CASE ( 'W' )  ! surface cell averaging 
           DO jj=1,iky
              DO ji=1,ikx
                 dvol = 0.d0
                 dsum = 0.d0
                 msks = 0
                 DO jrj=1,nrj
                    DO jri=1,nri
                       ix = (ji-1)*nri+jri
                       iy = (jj-1)*nrj+jrj
                       ! JMM : for conservation of fluxes I think that dvol2d must not be masked. (bug ?)
                       dvol2d = e1(ix,iy) * e2(ix,iy) * zmask(ix,iy)
                       msks = msks + zmask(ix,iy)
                       dvol = dvol + dvol2d
                       dsum = dsum + zv(ix,iy) * dvol2d
                    END DO
                 END DO
                 IF ( dvol > 0.d0 ) THEN
                    rdummymean(ji,jj) = dsum/dvol
                 ELSE
                    rdummymean(ji,jj) = 99999.
                 END IF
                 nflsdc(ji,jj) = msks
              END DO
           END DO
        END SELECT
        ierr = putvar(ncout , id_varout(1), rdummymean ,  jk, ikx, iky, ktime=jt )
        ierr = putvar(ncout , id_varout(2), DBLE(nflsdc), jk, ikx, iky, ktime=jt )  
     END DO ! k-loop
  END DO    ! time-loop

  ierr = closeout(ncout )

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    ipk(:) = npk ! mean for each level

    ierr=getvaratt (cf_in  , cv_nam, clunits, zspval, cllong_name, clshort_name)

    ! define new variables for output 
    stypvar(1)%rmissing_value    = 99999.
    stypvar(1)%scale_factor      = 1.
    stypvar(1)%add_offset        = 0.
    stypvar(1)%savelog10         = 0.
    stypvar(1)%conline_operation = 'N/A'

    stypvar(1)%cunits         = TRIM(clunits)
    stypvar(1)%valid_min      = -100000.
    stypvar(1)%valid_max      =  100000.
    stypvar(1)%cname          = 'degraded_'//TRIM(cv_nam)
    stypvar(1)%clong_name     = 'degraded '//TRIM(cllong_name)
    stypvar(1)%cshort_name    = 'degraded_'//TRIM(clshort_name)

    stypvar(2)%rmissing_value    = 99999.
    stypvar(2)%scale_factor      = 1.
    stypvar(2)%add_offset        = 0.
    stypvar(2)%savelog10         = 0.
    stypvar(2)%conline_operation = 'N/A'

    stypvar(2)%cunits         = '[1]'
    stypvar(2)%valid_min      = 0.
    stypvar(2)%valid_max      = 100000.
    stypvar(2)%cname          = 'flsdc'
    stypvar(2)%clong_name     = 'fluid sub-domain counter'
    stypvar(2)%cshort_name    = 'fdsdc'

    IF ( nvpk == 2 ) THEN
       stypvar(:)%caxis       = 'TYX'
    ELSE
       stypvar(:)%caxis       = 'TZYX'
    END IF

    ! create output fileset
    IF ( cf_out == '' ) cf_out= 'degraded_'//TRIM(cv_nam)//'.nc'  ! set default name if not specified on command line
    ncout = create      (cf_out ,     'none',  ikx,   iky,   npk, cdep=cv_dep)
    ierr  = createvar   (ncout ,      stypvar , 2 , ipk,   id_varout  , cdglobal=TRIM(cglobal) ) 
    ierr  = putheadervar(ncout ,      cf_in  ,  ikx, iky, npk, pnavlon=rdumlon, pnavlat=rdumlat, pdep=gdep, cdep=cv_dep)
    dtim  = getvar1d(cf_in, cn_vtimec, npt )
    ierr  = putvar1d(ncout,  dtim, npt, 'T')

  END SUBROUTINE CreateOutput

END PROGRAM cdfdegrad

program cdfsections   
         
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!          *** PROGRAM cdfsections ***
!
! ** Purpose : extract oceanic fields along a track made of several sections.
!
! ** Method : computes N sections by taking the nearest point north of 60N 
!             and near undefined values (bottom or coasts), and interpolates 
!             between the four nearest points elsewhere.
!             
! ** Outputs : temperature, salinity, density, current (normal/tangeantial)
!              - normal current is positive northward (westward if meridional section)
!              - tangeantial current is on the right of the normal current.
!
! NB : it is recommended to put a lot of points on each section if the aim is 
!      to compute X-integrations.
!
! WARNING : 
!  - require large memory : reduce domain size with ncks if insufficient memory error.
!  - does not work if the section crosses the Greenwich line (easy to modify if needed).
!  - not yet tested north of 60N (but should work) ...
!
! history :
! N. JOURDAIN (LEGI-MEOM), April 2009
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !!  $Rev$
  !!  $Date$
  !!  $Id$
  !!--------------------------------------------------------------

                                             
USE netcdf                                            
USE eos
                                                      
IMPLICIT NONE                                         

!--- Local variables
INTEGER   :: narg, iargc 
                                                    
!--- grid_T
INTEGER :: fidT, status, dimID_time_counter, dimID_deptht, dimID_y, dimID_x, &
& mtime_counter, mdeptht, my, mx, vosaline_ID, votemper_ID, time_counter_ID, &
& deptht_ID, nav_lat_ID, nav_lon_ID, fidM, dimID_s, X_ID, sig0_ID, sig1_ID,  &
& sig2_ID, sig4_ID 
      
!--- grid_U 
INTEGER :: fidU, dimID_depthu, mdepthu, mxu, vozocrtx_ID

!--- grid_V
INTEGER :: fidV, dimID_depthv, mdepthv, myu, vomecrty_ID
                                                      
CHARACTER(LEN=256) :: file_in_T, file_out, file_in_U, file_in_V, cdum             
           
REAL*4 :: RT, dtmp_T, dtmp_U, dtmp_V, miniT, miniU, miniV, rr, ang, pi,&
&  latinf, latsup, loninf, lonsup, a, b, c, e, missing, lonref, latref

REAL*8 :: offset

INTEGER :: N1, N2, i, j, k, s, p, iiT, jjT, Nsec, Ntot,Unorm_ID, Utang_ID, cont,&
& l, iiU, jjU, iiV, jjV, iinf, isup, jinf, jsup

INTEGER,ALLOCATABLE,DIMENSION(:) :: N

REAL*4,ALLOCATABLE,DIMENSION(:) :: lat, lon 

LOGICAL,ALLOCATABLE,DIMENSION(:) :: undefined

!---- grid_T                                           
REAL*4,ALLOCATABLE,DIMENSION(:,:,:,:) :: vosaline, votemper, sig0, sig1, sig2, sig4
REAL*4,ALLOCATABLE,DIMENSION(:,:,:) :: somxl010, somxlt02, vosaline_sec, votemper_sec
REAL*4,ALLOCATABLE,DIMENSION(:,:) :: nav_lat_T, nav_lon_T, somxl010_sec, somxlt02_sec
REAL*4,ALLOCATABLE,DIMENSION(:) :: time_counter, deptht
                                                     
!---- grid_U
REAL*4,ALLOCATABLE,DIMENSION(:,:,:,:) :: vozocrtx
REAL*4,ALLOCATABLE,DIMENSION(:,:,:) :: vozocrtx_sec
REAL*4,ALLOCATABLE,DIMENSION(:,:) :: nav_lat_U, nav_lon_U

!---- grid_V
REAL*4,ALLOCATABLE,DIMENSION(:,:,:,:) :: vomecrty
REAL*4,ALLOCATABLE,DIMENSION(:,:,:) :: vomecrty_sec
REAL*4,ALLOCATABLE,DIMENSION(:,:) :: nav_lat_V, nav_lon_V

!---- grid section 
REAL*4,ALLOCATABLE,DIMENSION(:,:,:) :: Unorm, Utang, sigsec0, sigsec1, sigsec2, sigsec4
REAL*4,ALLOCATABLE,DIMENSION(:) :: lonsec, latsec
REAL*8,ALLOCATABLE,DIMENSION(:) :: d, X1

!-------------------------------------------------------------------------
! GETTING ARGUMENTS :

!-  Read command line and output usage message if not compliant.
  narg= iargc()
  IF ( narg.lt.10 ) THEN
     PRINT *,'Usage : '
     PRINT *,' cdfsections  Ufile Vfile Tfile larf lorf Nsec lat1 lon1 lat2 lon2 n1'
     PRINT *,'              [ lat3 lon3 n2 ] [ lat4 lon4 n3 ] ....'
     PRINT *,'   ' 
     PRINT *,' Computes temperature, salinity, sig0, sig1, sig2, sig4, Uorth, Utang '
     PRINT *,' along a section made of Nsec linear segments (see output attributes).'
     PRINT *,' Output is section.nc, var. as a function of X(km), depth(m) and time.'
     PRINT *,'   '
     PRINT *,'Arguments : '
     PRINT *,' # larf and lorf -> location of X=0 for the X-absice (may be out of section)'
     PRINT *,' # Nsec -> number of segments used to compute the whole section.'
     PRINT *,' # lat1,lat2,lat3,... -> extrema latitudes of the segments (from -90 to 90)'
     PRINT *,' # lon1,lon2,lon3,... -> extrema latitudes of the segments (from 0 to 360)'
     PRINT *,' # n1, n2, ...        -> number of output points on each segment.'
     PRINT *,'   (you have to give Nsec+1 values of lati/loni and Nsec values of ni)'
     PRINT *,' '
     PRINT *,' It is recommended to put a lot of points on each section if the aim'
     PRINT *,' is to compute X-integrations along the section (10 x the model resolution).'
     PRINT *,'NB : sections cannot cross the Greenwich line !!'
     PRINT *,'NB : Not yet tested north of 60N.'
     PRINT *,'NB : require a large amount of memory !' 
     PRINT *,'     -> reduce domain size with  ncks -d  if insufficient memory error.'
     PRINT *,' '
     PRINT *,'Example for one linear section : '
     PRINT *,' cdfsections U.nc V.nc T.nc 48.0 305.0 1 49.0 307.0 50.5 337.5 20'
     PRINT *,'Example for a section made of 2 linear segments : '
     PRINT *,' cdfsections U.nc V.nc T.nc 48.0 305.0 2 49.0 307.0 50.5 337.5 20 40.3 305.1 50'
     STOP
  ENDIF

  CALL getarg (1, file_in_U )
  CALL getarg (2, file_in_V )
  CALL getarg (3, file_in_T )

  CALL getarg (4, cdum ); READ(cdum,*) latref
  CALL getarg (5, cdum ); READ(cdum,*) lonref
  CALL getarg (6, cdum ); READ(cdum,*) Nsec

  if ( narg.ne.8+Nsec*3) then
    PRINT *, '**!/# ERROR : wrong number of arguments in cdfsections'
    PRINT *, 'Usage : '
    PRINT *, ' cdfsections  Ufile Vfile Tfile larf lorf Nsec lat1 lon1 lat2 lon2 n1 ....'
    PRINT *, '-> please execute cdfsections without any arguments for more details.'
    STOP
  endif

  ALLOCATE( lat(Nsec+1), lon(Nsec+1) )
  ALLOCATE( N(Nsec), d(Nsec) )

   CALL getarg (7, cdum ); READ(cdum,*) lat(1)
   CALL getarg (8, cdum ); READ(cdum,*) lon(1)

  do i=1,(narg-8),3
    CALL getarg (i+8, cdum ); READ(cdum,*) lat(i/3+2)
    CALL getarg (i+9, cdum ); READ(cdum,*) lon(i/3+2)
    CALL getarg (i+10, cdum ); READ(cdum,*) N(i/3+1)
  enddo

  do i=1,Nsec+1
    if ( (lon(i).lt.0.0).or.(lonref.lt.0.0) ) then
      PRINT *, '**!/# ERROR : longitudes must be between 0 and 360'
      STOP 99
    endif
  enddo
   
  file_out = 'section.nc'                               

 !---- Rayon terrestre en km :
   RT = 6378

   pi = 3.1415927
   rr = pi / 180.0         
         
!---------------------------------------                   
! Read netcdf input file for grid T :                                 
         
         write(*,*) TRIM(file_in_T)
                                                  
         status = NF90_OPEN(TRIM(file_in_T),0,fidT)          
         call erreur(status,.TRUE.,"read") 
                                                           
       !Lecture des ID des dimensions qui nous interessent
         status = NF90_INQ_DIMID(fidT,"time_counter",dimID_time_counter)
         call erreur(status,.TRUE.,"inq_dimID_time_counter")
         status = NF90_INQ_DIMID(fidT,"deptht",dimID_deptht)
         call erreur(status,.TRUE.,"inq_dimID_deptht")
         status = NF90_INQ_DIMID(fidT,"y",dimID_y)
         call erreur(status,.TRUE.,"inq_dimID_y")
         status = NF90_INQ_DIMID(fidT,"x",dimID_x)
         call erreur(status,.TRUE.,"inq_dimID_x")
                                                               
       !Lecture des valeurs des dimensions qui nous interessent
         status = NF90_INQUIRE_DIMENSION(fidT,dimID_time_counter,len=mtime_counter)
         call erreur(status,.TRUE.,"inq_dim_time_counter")
         status = NF90_INQUIRE_DIMENSION(fidT,dimID_deptht,len=mdeptht)
         call erreur(status,.TRUE.,"inq_dim_deptht")
         status = NF90_INQUIRE_DIMENSION(fidT,dimID_y,len=my)
         call erreur(status,.TRUE.,"inq_dim_y")
         status = NF90_INQUIRE_DIMENSION(fidT,dimID_x,len=mx)
         call erreur(status,.TRUE.,"inq_dim_x")
         
         write(*,101) mx, my, mdeptht, mtime_counter         
101 FORMAT('   -> dimensions of arrays : (',3(i4,','),i4,')')         
             
       !Allocation of arrays : 
         ALLOCATE(  vosaline(mx,my,mdeptht,mtime_counter)  ) 
         ALLOCATE(  votemper(mx,my,mdeptht,mtime_counter)  ) 
         ALLOCATE(  time_counter(mtime_counter)  ) 
         ALLOCATE(  deptht(mdeptht)  ) 
         ALLOCATE(  nav_lat_T(mx,my)  ) 
         ALLOCATE(  nav_lon_T(mx,my)  ) 
         ALLOCATE(  undefined(mdeptht) )         
                        
       !Lecture des ID des variables qui nous interessent
         status = NF90_INQ_VARID(fidT,"vosaline",vosaline_ID)
         call erreur(status,.TRUE.,"inq_vosaline_ID")
         status = NF90_INQ_VARID(fidT,"votemper",votemper_ID)
         call erreur(status,.TRUE.,"inq_votemper_ID")
         status = NF90_INQ_VARID(fidT,"time_counter",time_counter_ID)
         call erreur(status,.TRUE.,"inq_time_counter_ID")
         status = NF90_INQ_VARID(fidT,"deptht",deptht_ID)
         call erreur(status,.TRUE.,"inq_deptht_ID")
         status = NF90_INQ_VARID(fidT,"nav_lat",nav_lat_ID)
         call erreur(status,.TRUE.,"inq_nav_lat_ID")
         status = NF90_INQ_VARID(fidT,"nav_lon",nav_lon_ID)
         call erreur(status,.TRUE.,"inq_nav_lon_ID")
                                                              
       !Lecture des valeurs des variables qui nous interessent
         status = NF90_GET_VAR(fidT,vosaline_ID,vosaline)
         call erreur(status,.TRUE.,"getvar_vosaline")
         status = NF90_GET_VAR(fidT,votemper_ID,votemper)
         call erreur(status,.TRUE.,"getvar_votemper")
         status = NF90_GET_VAR(fidT,time_counter_ID,time_counter)
         call erreur(status,.TRUE.,"getvar_time_counter")
         status = NF90_GET_VAR(fidT,deptht_ID,deptht)
         call erreur(status,.TRUE.,"getvar_deptht")
         status = NF90_GET_VAR(fidT,nav_lat_ID,nav_lat_T)
         call erreur(status,.TRUE.,"getvar_nav_lat")
         status = NF90_GET_VAR(fidT,nav_lon_ID,nav_lon_T)
         call erreur(status,.TRUE.,"getvar_nav_lon")
         
        !extract missing value for vosaline :
         status = NF90_GET_ATT(fidT,vosaline_ID,"missing_value",missing)
         call erreur(status,.TRUE.,"get_att_vosaline")
                                             
     !Fermeture du fichier lu                         
       status = NF90_CLOSE(fidT)                      
       call erreur(status,.TRUE.,"fin_lecture")     
        
!---------------------------------------
! Read netcdf input file for grid U :

         write(*,*) TRIM(file_in_U)

         status = NF90_OPEN(TRIM(file_in_U),0,fidU)          
         call erreur(status,.TRUE.,"read") 
                                                           
       !Lecture des ID des dimensions qui nous interessent
         status = NF90_INQ_DIMID(fidU,"time_counter",dimID_time_counter)
         call erreur(status,.TRUE.,"inq_dimID_time_counter")
         status = NF90_INQ_DIMID(fidU,"depthu",dimID_depthu)
         call erreur(status,.TRUE.,"inq_dimID_depthu")
         status = NF90_INQ_DIMID(fidU,"y",dimID_y)
         call erreur(status,.TRUE.,"inq_dimID_y")
         status = NF90_INQ_DIMID(fidU,"x",dimID_x)
         call erreur(status,.TRUE.,"inq_dimID_x")
                                                               
       !Lecture des valeurs des dimensions qui nous interessent
         status = NF90_INQUIRE_DIMENSION(fidU,dimID_depthu,len=mdepthu)
         call erreur(status,.TRUE.,"inq_dim_depthu")
         status = NF90_INQUIRE_DIMENSION(fidU,dimID_x,len=mxu)
         call erreur(status,.TRUE.,"inq_dim_x")

         write(*,101) mxu, my, mdepthu, mtime_counter         
                      
       !Allocation of arrays : 
         ALLOCATE(  vozocrtx(mxu,my,mdepthu,mtime_counter)  ) 
         ALLOCATE(  nav_lat_U(mxu,my)  ) 
         ALLOCATE(  nav_lon_U(mxu,my)  ) 
                                 
       !Lecture des ID des variables qui nous interessent
         status = NF90_INQ_VARID(fidU,"vozocrtx",vozocrtx_ID)
         call erreur(status,.TRUE.,"inq_vozocrtx_ID")
         status = NF90_INQ_VARID(fidU,"nav_lat",nav_lat_ID)
         call erreur(status,.TRUE.,"inq_nav_lat_ID")
         status = NF90_INQ_VARID(fidU,"nav_lon",nav_lon_ID)
         call erreur(status,.TRUE.,"inq_nav_lon_ID")
                                                              
       !Lecture des valeurs des variables qui nous interessent
         status = NF90_GET_VAR(fidU,vozocrtx_ID,vozocrtx)
         call erreur(status,.TRUE.,"getvar_vozocrtx")
         status = NF90_GET_VAR(fidU,nav_lat_ID,nav_lat_U)
         call erreur(status,.TRUE.,"getvar_nav_lat")
         status = NF90_GET_VAR(fidU,nav_lon_ID,nav_lon_U)
         call erreur(status,.TRUE.,"getvar_nav_lon")
                                                      
     !Fermeture du fichier lu                         
       status = NF90_CLOSE(fidU)                      
       call erreur(status,.TRUE.,"fin_lecture")     


!---------------------------------------
! Read netcdf input file for grid V :

         write(*,*) TRIM(file_in_V)

         status = NF90_OPEN(TRIM(file_in_V),0,fidV)          
         call erreur(status,.TRUE.,"read") 
                                                           
       !Lecture des ID des dimensions qui nous interessent
         status = NF90_INQ_DIMID(fidV,"depthv",dimID_depthv)
         call erreur(status,.TRUE.,"inq_dimID_depthv")
         status = NF90_INQ_DIMID(fidV,"y",dimID_y)
         call erreur(status,.TRUE.,"inq_dimID_y")
                                                               
       !Lecture des valeurs des dimensions qui nous interessent
         status = NF90_INQUIRE_DIMENSION(fidV,dimID_depthv,len=mdepthv)
         call erreur(status,.TRUE.,"inq_dim_depthv")
         status = NF90_INQUIRE_DIMENSION(fidV,dimID_y,len=myu)
         call erreur(status,.TRUE.,"inq_dim_y")
         write(*,101) mx, myu, mdepthv, mtime_counter
                               
       !Allocation of arrays : 
         ALLOCATE(  vomecrty(mx,myu,mdepthv,mtime_counter)  ) 
         ALLOCATE(  nav_lat_V(mx,myu)  ) 
         ALLOCATE(  nav_lon_V(mx,myu)  ) 
                                 
       !Lecture des ID des variables qui nous interessent
         status = NF90_INQ_VARID(fidV,"vomecrty",vomecrty_ID)
         call erreur(status,.TRUE.,"inq_vomecrty_ID")
         status = NF90_INQ_VARID(fidV,"nav_lat",nav_lat_ID)
         call erreur(status,.TRUE.,"inq_nav_lat_ID")
         status = NF90_INQ_VARID(fidV,"nav_lon",nav_lon_ID)
         call erreur(status,.TRUE.,"inq_nav_lon_ID")
                                                              
       !Lecture des valeurs des variables qui nous interessent
         status = NF90_GET_VAR(fidV,vomecrty_ID,vomecrty)
         call erreur(status,.TRUE.,"getvar_vomecrty")
         status = NF90_GET_VAR(fidV,nav_lat_ID,nav_lat_V)
         call erreur(status,.TRUE.,"getvar_nav_lat")
         status = NF90_GET_VAR(fidV,nav_lon_ID,nav_lon_V)
         call erreur(status,.TRUE.,"getvar_nav_lon")
                                                      
     !Fermeture du fichier lu                         
       status = NF90_CLOSE(fidV)                      
       call erreur(status,.TRUE.,"fin_lecture")     


!------------------------------------------------------------------------------- 
!-------------------------------------------------------------------------------                                                     

!-------------------------------------------------------------------------------
! Remise des longitudes de 0 à 360 (utile pour l'interpolation):

do i=1,mx
do j=1,my
  if (nav_lon_T(i,j).lt.0.0) then
    nav_lon_T(i,j) = 360.0 + nav_lon_T(i,j)
  endif
enddo
do j=1,myu
  if (nav_lon_V(i,j).lt.0.0) then
    nav_lon_V(i,j) = 360.0 + nav_lon_V(i,j)
  endif
enddo  
enddo

do i=1,mxu
do j=1,my
  if (nav_lon_U(i,j).lt.0.0) then
    nav_lon_U(i,j) = 360.0 + nav_lon_U(i,j)
  endif
enddo
enddo


!-------------------------------------------------------------------------------
! Calcul des densite avel le module eos des CDFTOOLS-2.1

 ALLOCATE( sig0(mx,my,mdeptht,mtime_counter) )
 ALLOCATE( sig1(mx,my,mdeptht,mtime_counter) )
 ALLOCATE( sig2(mx,my,mdeptht,mtime_counter) )
 ALLOCATE( sig4(mx,my,mdeptht,mtime_counter) )

 do k=1,mdeptht
 do l=1,mtime_counter
      sig0(:,:,k,l)=sigma0(votemper(:,:,k,l),vosaline(:,:,k,l),mx,my)
      sig1(:,:,k,l)=sigmai(votemper(:,:,k,l),vosaline(:,:,k,l),1000.,mx,my)
      sig2(:,:,k,l)=sigmai(votemper(:,:,k,l),vosaline(:,:,k,l),2000.,mx,my)
      sig4(:,:,k,l)=sigmai(votemper(:,:,k,l),vosaline(:,:,k,l),4000.,mx,my)
 enddo
 enddo

!-------------------------------------------------------------------------------
! Calcul de la longueur des sections et des points modeles associes                 
        
  Ntot=SUM(N(:))
  write(*,*) '********** total number of points  :', Ntot
 
  ALLOCATE( latsec(Ntot) , lonsec(Ntot) , X1(Ntot) )
  ALLOCATE( votemper_sec(Ntot,mdeptht,mtime_counter) ) 
  ALLOCATE( vosaline_sec(Ntot,mdeptht,mtime_counter) )
  ALLOCATE( vozocrtx_sec(Ntot,mdepthu,mtime_counter) )
  ALLOCATE( vomecrty_sec(Ntot,mdepthv,mtime_counter) ) 
  ALLOCATE( Unorm(Ntot,mdeptht,mtime_counter) )
  ALLOCATE( Utang(Ntot,mdeptht,mtime_counter) )
  ALLOCATE( sigsec0(Ntot,mdeptht,mtime_counter) )
  ALLOCATE( sigsec1(Ntot,mdeptht,mtime_counter) )
  ALLOCATE( sigsec2(Ntot,mdeptht,mtime_counter) )
  ALLOCATE( sigsec4(Ntot,mdeptht,mtime_counter) )

! BOUCLE SUR LE NOMBRE DE SECTIONS Nsec A ACOLLER :
N2=0
! Point de référence pour la distance de la section (exple : dans OVIDE 60N 43.25W)
offset=RT * acos(cos(latref*rr)*cos(lat(1)*rr)*cos((lonref)*rr-lon(1)*rr)+sin(latref*rr)*sin(lat(1)*rr))
cont=0
DO p=1,Nsec
 N1=N2+1
 N2=N1+N(p)-1
 !longueur de la section p en km :
  d(p) = RT * acos(cos(lat(p)*rr)*cos(lat(p+1)*rr)*cos(lon(p+1)*rr-lon(p)*rr)+sin(lat(p)*rr)*sin(lat(p+1)*rr))
  write(*,102) p,d(p)
102 FORMAT('*** Section ',i4,' = ',f8.2, 'km')
  write(*,103) lat(p), lon(p), lat(p+1), lon(p+1)
103 FORMAT('     - from (lat,lon) = (',f6.2,',',f6.2,') to (',f6.2,',',f6.2,')')
 ! "pente" de la section 1 en radians / equateur (angle algebrique)
  if (lon(p).ne.lon(p+1)) then
    ang = atan((lat(p+1)-lat(p))/(lon(p+1)-lon(p)))
  else
    ang=pi/2.
  endif
  write(*,*) '    - angle / equateur (deg) =', ang/rr
 !coordonnées de tous les points de la section p en (lon,lat) et en km :
  DO s=N1,N2
    undefined(:)=.FALSE.
    latsec(s)=(lat(p+1)-lat(p))*FLOAT(s-N1+cont)/FLOAT(N2-N1+cont) + lat(p)
    lonsec(s)=(lon(p+1)-lon(p))*FLOAT(s-N1+cont)/FLOAT(N2-N1+cont) + lon(p)
    X1(s)=d(p)*FLOAT(s-N1+cont)/FLOAT(N2-N1+cont)+offset
    miniT=1000 !km
    miniU=miniT
    miniV=miniT
   ! recherche du point le plus proche (on fait comme ça parceque la grille est bizarre vers les poles)
    do i=1,mx
    do j=1,my
      dtmp_T= RT * acos(cos(nav_lat_T(i,j)*rr)*cos(latsec(s)*rr)*cos(nav_lon_T(i,j)*rr- &
     &        lonsec(s)*rr)+sin(nav_lat_T(i,j)*rr)*sin(latsec(s)*rr))
      dtmp_U= RT * acos(cos(nav_lat_U(i,j)*rr)*cos(latsec(s)*rr)*cos(nav_lon_U(i,j)*rr- &
     &        lonsec(s)*rr)+sin(nav_lat_U(i,j)*rr)*sin(latsec(s)*rr))
      dtmp_V= RT * acos(cos(nav_lat_V(i,j)*rr)*cos(latsec(s)*rr)*cos(nav_lon_V(i,j)*rr- &
     &        lonsec(s)*rr)+sin(nav_lat_V(i,j)*rr)*sin(latsec(s)*rr))
      if (dtmp_T.lt.miniT) then
          miniT=dtmp_T
          iiT=i
          jjT=j
      endif
      if (dtmp_U.lt.miniU) then
          miniU=dtmp_U
          iiU=i
          jjU=j
      endif
      if (dtmp_V.lt.miniV) then
          miniV=dtmp_V
          iiV=i
          jjV=j
      endif
    enddo
    enddo
   !interpolation des champs T:
    if (latsec(s).gt.60.0) then  
     !champs le plus proche de la section (U et V interpoles au point T)
      votemper_sec(s,:,:) = votemper(iiT,jjT,:,:)
      vosaline_sec(s,:,:) = vosaline(iiT,jjT,:,:)
      vozocrtx_sec(s,:,:) = vozocrtx(iiU,jjU,:,:)
      vomecrty_sec(s,:,:) = vomecrty(iiV,jjV,:,:)
     ! vitesse normale et tangeantielle a la section (section orientee vers le nord, tangeante à droite)
      Unorm(s,:,:) = vomecrty_sec(s,:,:)*cos(ang) - vozocrtx_sec(s,:,:)*sin(ang) 
      Utang(s,:,:) = vomecrty_sec(s,:,:)*sin(ang) + vozocrtx_sec(s,:,:)*cos(ang)
     ! densites :
      sigsec0(s,:,:) = MAX(sig0(iiT,jjT,:,:),10.0)
      sigsec1(s,:,:) = MAX(sig1(iiT,jjT,:,:),10.0)
      sigsec2(s,:,:) = MAX(sig2(iiT,jjT,:,:),10.0)
      sigsec4(s,:,:) = MAX(sig4(iiT,jjT,:,:),20.0)
    else
     ! Champs T interpoles
      if (lonsec(s).ge.nav_lon_T(iiT,jjT)) then
        iinf=iiT
        if ( iiT+1.le.mx ) then
          isup=iiT+1
        else
          isup=1
        endif
      else
        if ( iiT-1.ge.1 ) then
          iinf=iiT-1
        else
          iinf=mx
        endif
        isup=iiT
      endif
      if (latsec(s).ge.nav_lat_T(iiT,jjT)) then
        jinf=jjT
        jsup=jjT+1
      else
        jinf=jjT-1
        jsup=jjT
      endif
      loninf=nav_lon_T(iinf,jjT)
      lonsup=nav_lon_T(isup,jjT)
      latinf=nav_lat_T(iiT,jinf)
      latsup=nav_lat_T(iiT,jsup)
      a=(lonsec(s)-loninf)/(lonsup-loninf)
      b=(lonsup-lonsec(s))/(lonsup-loninf)
      c=(latsec(s)-latinf)/(latsup-latinf)
      e=(latsup-latsec(s))/(latsup-latinf)
      votemper_sec(s,:,:) =  c*(a*votemper(isup,jsup,:,:)+b*votemper(iinf,jsup,:,:)) &
&                           +e*(a*votemper(isup,jinf,:,:)+b*votemper(iinf,jinf,:,:))
      vosaline_sec(s,:,:) =  c*(a*vosaline(isup,jsup,:,:)+b*vosaline(iinf,jsup,:,:)) &
&                           +e*(a*vosaline(isup,jinf,:,:)+b*vosaline(iinf,jinf,:,:))
      sigsec0(s,:,:) =  c*(a*sig0(isup,jsup,:,:)+b*sig0(iinf,jsup,:,:)) &
&                      +e*(a*sig0(isup,jinf,:,:)+b*sig0(iinf,jinf,:,:))
      sigsec0(s,:,:) = MAX(sigsec0(s,:,:),10.0)
      sigsec1(s,:,:) =  c*(a*sig1(isup,jsup,:,:)+b*sig1(iinf,jsup,:,:)) &
&                      +e*(a*sig1(isup,jinf,:,:)+b*sig1(iinf,jinf,:,:))
      sigsec1(s,:,:) = MAX(sigsec1(s,:,:),10.0)
      sigsec2(s,:,:) =  c*(a*sig2(isup,jsup,:,:)+b*sig2(iinf,jsup,:,:)) &
&                      +e*(a*sig2(isup,jinf,:,:)+b*sig2(iinf,jinf,:,:))
      sigsec2(s,:,:) = MAX(sigsec2(s,:,:),10.0)
      sigsec4(s,:,:) =  c*(a*sig4(isup,jsup,:,:)+b*sig4(iinf,jsup,:,:)) &
&                      +e*(a*sig4(isup,jinf,:,:)+b*sig4(iinf,jinf,:,:))
      sigsec4(s,:,:) = MAX(sigsec4(s,:,:),20.0)
     ! test si valeurs indefinies sur un des 4 points :
      do k=1,mdeptht
        if ((vosaline(iinf,jinf,k,1).eq.missing).or.(vosaline(iinf,jsup,k,1).eq.missing).or.&
&           (vosaline(isup,jinf,k,1).eq.missing).or.(vosaline(isup,jsup,k,1).eq.missing)   ) then
          votemper_sec(s,:,:) = votemper(iiT,jjT,:,:)
          vosaline_sec(s,:,:) = vosaline(iiT,jjT,:,:)
          vozocrtx_sec(s,:,:) = vozocrtx(iiU,jjU,:,:)
          vomecrty_sec(s,:,:) = vomecrty(iiV,jjV,:,:)
          sigsec0(s,:,:) = MAX(sig0(iiT,jjT,:,:),10.0)
          sigsec1(s,:,:) = MAX(sig1(iiT,jjT,:,:),10.0)
          sigsec2(s,:,:) = MAX(sig2(iiT,jjT,:,:),10.0)
          sigsec4(s,:,:) = MAX(sig4(iiT,jjT,:,:),20.0) 
          undefined(k)=.TRUE.
        endif
      enddo
     ! Champs U interpoles
      if (lonsec(s).ge.nav_lon_U(iiU,jjU)) then
        iinf=iiU
        if ( iiU+1.le.mx ) then
          isup=iiU+1
        else
          isup=1
        endif
      else
        if ( iiU-1.ge.1 ) then
          iinf=iiU-1
        else
          iinf=mx
        endif
        isup=iiU
      endif
      if (latsec(s).ge.nav_lat_U(iiU,jjU)) then
       jinf=jjU
       jsup=jjU+1
      else
       jinf=jjU-1
       jsup=jjU
      endif
      loninf=nav_lon_U(iinf,jjU)
      lonsup=nav_lon_U(isup,jjU)
      latinf=nav_lat_U(iiU,jinf)
      latsup=nav_lat_U(iiU,jsup)
      a=(lonsec(s)-loninf)/(lonsup-loninf)
      b=(lonsup-lonsec(s))/(lonsup-loninf)
      c=(latsec(s)-latinf)/(latsup-latinf)
      e=(latsup-latsec(s))/(latsup-latinf)
      vozocrtx_sec(s,:,:) =  c*(a*vozocrtx(isup,jsup,:,:)+b*vozocrtx(iinf,jsup,:,:)) &
&                           +e*(a*vozocrtx(isup,jinf,:,:)+b*vozocrtx(iinf,jinf,:,:))
     ! Champs V interpoles
      if (lonsec(s).ge.nav_lon_U(iiU,jjU)) then
        iinf=iiU
        if ( iiU+1.le.mx ) then
          isup=iiU+1
        else
          isup=1
        endif
      else
        if ( iiU-1.ge.1 ) then
          iinf=iiU-1
        else
          iinf=mx
        endif
        isup=iiU
      endif
      if (latsec(s).ge.nav_lat_V(iiV,jjV)) then
       jinf=jjV
       jsup=jjV+1
      else
       jinf=jjV-1
       jsup=jjV
      endif
      loninf=nav_lon_V(iinf,jjV)
      lonsup=nav_lon_V(isup,jjV)
      latinf=nav_lat_V(iiV,jinf)
      latsup=nav_lat_V(iiV,jsup)
      a=(lonsec(s)-loninf)/(lonsup-loninf)
      b=(lonsup-lonsec(s))/(lonsup-loninf)
      c=(latsec(s)-latinf)/(latsup-latinf)
      e=(latsup-latsec(s))/(latsup-latinf)
      vomecrty_sec(s,:,:) =  c*(a*vomecrty(isup,jsup,:,:)+b*vomecrty(iinf,jsup,:,:)) &
&                           +e*(a*vomecrty(isup,jinf,:,:)+b*vomecrty(iinf,jinf,:,:))
     ! si l'un des 4 points de l'interpolation etait indefini :
      do k=1,mdeptht
        if (undefined(k)) then
          vozocrtx_sec(s,k,:) = vozocrtx(iiU,jjU,k,:)
          vomecrty_sec(s,k,:) = vomecrty(iiV,jjV,k,:)
        endif
      enddo
     ! vitesse normale et tangeantielle a la section (section orientee vers le nord, tangeante à droite)
      Unorm(s,:,:) = vomecrty_sec(s,:,:)*cos(ang) - vozocrtx_sec(s,:,:)*sin(ang)
      Utang(s,:,:) = vomecrty_sec(s,:,:)*sin(ang) + vozocrtx_sec(s,:,:)*cos(ang)
    endif
  ENDDO !- s nb de points sur section p
  cont=1
  offset=X1(N2)
ENDDO !- p nb de sections 
      
!----------------------------------------------------------                                                      
!----------------------------------------------------------    
! Writing new netcdf file :                                   
                                                              
        status = NF90_CREATE(TRIM(file_out),NF90_NOCLOBBER,fidM)
        call erreur(status,.TRUE.,'create')                     
                                                                
        !Definition des dimensions du fichiers                  
         status = NF90_DEF_DIM(fidM,"time_counter",NF90_UNLIMITED,dimID_time_counter)
         call erreur(status,.TRUE.,"def_dimID_time_counter")
         status = NF90_DEF_DIM(fidM,"deptht",mdeptht,dimID_deptht)
         call erreur(status,.TRUE.,"def_dimID_deptht")
         status = NF90_DEF_DIM(fidM,"X",Ntot,dimID_s)
         call erreur(status,.TRUE.,"def_dimID_s")
                                                              
        !Definition des variables                             
         status = NF90_DEF_VAR(fidM,"vosaline",NF90_FLOAT,(/dimID_s,dimID_deptht,dimID_time_counter/),vosaline_ID)
         call erreur(status,.TRUE.,"def_var_vosaline_ID")
         status = NF90_DEF_VAR(fidM,"votemper",NF90_FLOAT,(/dimID_s,dimID_deptht,dimID_time_counter/),votemper_ID)
         call erreur(status,.TRUE.,"def_var_votemper_ID")
         status = NF90_DEF_VAR(fidM,"time_counter",NF90_FLOAT,(/dimID_time_counter/),time_counter_ID)
         call erreur(status,.TRUE.,"def_var_time_counter_ID")
         status = NF90_DEF_VAR(fidM,"deptht",NF90_FLOAT,(/dimID_deptht/),deptht_ID)
         call erreur(status,.TRUE.,"def_var_deptht_ID")
         status = NF90_DEF_VAR(fidM,"nav_lat",NF90_FLOAT,(/dimID_s/),nav_lat_ID)
         call erreur(status,.TRUE.,"def_var_nav_lat_ID")
         status = NF90_DEF_VAR(fidM,"nav_lon",NF90_FLOAT,(/dimID_s/),nav_lon_ID)
         call erreur(status,.TRUE.,"def_var_nav_lon_ID")
         status = NF90_DEF_VAR(fidM,"X",NF90_DOUBLE,(/dimID_s/),X_ID)
         call erreur(status,.TRUE.,"def_var_X_ID")     
         status = NF90_DEF_VAR(fidM,"Uorth",NF90_FLOAT,(/dimID_s,dimID_deptht,dimID_time_counter/),Unorm_ID)
         call erreur(status,.TRUE.,"def_var_Unorm_ID")    
         status = NF90_DEF_VAR(fidM,"Utang",NF90_FLOAT,(/dimID_s,dimID_deptht,dimID_time_counter/),Utang_ID)
         call erreur(status,.TRUE.,"def_var_Utang_ID")
         status = NF90_DEF_VAR(fidM,"sig0",NF90_FLOAT,(/dimID_s,dimID_deptht,dimID_time_counter/),sig0_ID)
         call erreur(status,.TRUE.,"def_var_sig0_ID")
         status = NF90_DEF_VAR(fidM,"sig1",NF90_FLOAT,(/dimID_s,dimID_deptht,dimID_time_counter/),sig1_ID)
         call erreur(status,.TRUE.,"def_var_sig1_ID")
         status = NF90_DEF_VAR(fidM,"sig2",NF90_FLOAT,(/dimID_s,dimID_deptht,dimID_time_counter/),sig2_ID)
         call erreur(status,.TRUE.,"def_var_sig2_ID")
         status = NF90_DEF_VAR(fidM,"sig4",NF90_FLOAT,(/dimID_s,dimID_deptht,dimID_time_counter/),sig4_ID)
         call erreur(status,.TRUE.,"def_var_sig4_ID")

                          
        ! Attributs des variables :
         status = NF90_PUT_ATT(fidM,vosaline_ID,"online_operation","N/A")
         call erreur(status,.TRUE.,"put_att_vosaline_ID")
         status = NF90_PUT_ATT(fidM,vosaline_ID,"short_name","vosaline")
         call erreur(status,.TRUE.,"put_att_vosaline_ID")
         status = NF90_PUT_ATT(fidM,vosaline_ID,"long_name","sea_water_salinity")
         call erreur(status,.TRUE.,"put_att_vosaline_ID")
         status = NF90_PUT_ATT(fidM,vosaline_ID,"valid_max",45.)
         call erreur(status,.TRUE.,"put_att_vosaline_ID")
         status = NF90_PUT_ATT(fidM,vosaline_ID,"valid_min",0.)
         call erreur(status,.TRUE.,"put_att_vosaline_ID")
         status = NF90_PUT_ATT(fidM,vosaline_ID,"missing_value",0.)
         call erreur(status,.TRUE.,"put_att_vosaline_ID")
         status = NF90_PUT_ATT(fidM,vosaline_ID,"units","PSU")
         call erreur(status,.TRUE.,"put_att_vosaline_ID")

         status = NF90_PUT_ATT(fidM,votemper_ID,"online_operation","N/A")
         call erreur(status,.TRUE.,"put_att_votemper_ID")
         status = NF90_PUT_ATT(fidM,votemper_ID,"short_name","votemper")
         call erreur(status,.TRUE.,"put_att_votemper_ID")
         status = NF90_PUT_ATT(fidM,votemper_ID,"long_name","sea_water_potential_temperature")
         call erreur(status,.TRUE.,"put_att_votemper_ID")
         status = NF90_PUT_ATT(fidM,votemper_ID,"valid_max",45.)
         call erreur(status,.TRUE.,"put_att_votemper_ID")
         status = NF90_PUT_ATT(fidM,votemper_ID,"valid_min",-2.)
         call erreur(status,.TRUE.,"put_att_votemper_ID")
         status = NF90_PUT_ATT(fidM,votemper_ID,"missing_value",0.)
         call erreur(status,.TRUE.,"put_att_votemper_ID")
         status = NF90_PUT_ATT(fidM,votemper_ID,"units","C")
         call erreur(status,.TRUE.,"put_att_votemper_ID")

         status = NF90_PUT_ATT(fidM,time_counter_ID,"time_origin","2001-OCT-03 00:00:00")
         call erreur(status,.TRUE.,"put_att_time_counter_ID")
         status = NF90_PUT_ATT(fidM,time_counter_ID,"units","seconds since 2001-10-03 00:00:00")
         call erreur(status,.TRUE.,"put_att_time_counter_ID")
         status = NF90_PUT_ATT(fidM,time_counter_ID,"long_name","Time axis")
         call erreur(status,.TRUE.,"put_att_time_counter_ID")
         status = NF90_PUT_ATT(fidM,time_counter_ID,"title","Time")
         call erreur(status,.TRUE.,"put_att_time_counter_ID")
         status = NF90_PUT_ATT(fidM,time_counter_ID,"calendar","gregorian")
         call erreur(status,.TRUE.,"put_att_time_counter_ID")

         status = NF90_PUT_ATT(fidM,deptht_ID,"long_name","Vertical T levels")
         call erreur(status,.TRUE.,"put_att_deptht_ID")
         status = NF90_PUT_ATT(fidM,deptht_ID,"title","deptht")
         call erreur(status,.TRUE.,"put_att_deptht_ID")
         status = NF90_PUT_ATT(fidM,deptht_ID,"valid_max",50.)
         call erreur(status,.TRUE.,"put_att_deptht_ID")
         status = NF90_PUT_ATT(fidM,deptht_ID,"valid_min",0.)
         call erreur(status,.TRUE.,"put_att_deptht_ID")
         status = NF90_PUT_ATT(fidM,deptht_ID,"positive","unknown")
         call erreur(status,.TRUE.,"put_att_deptht_ID")
         status = NF90_PUT_ATT(fidM,deptht_ID,"units","m")
         call erreur(status,.TRUE.,"put_att_deptht_ID")

         status = NF90_PUT_ATT(fidM,nav_lat_ID,"long_name","Latitude")
         call erreur(status,.TRUE.,"put_att_nav_lat_ID")
         status = NF90_PUT_ATT(fidM,nav_lat_ID,"scale_factor",1.)
         call erreur(status,.TRUE.,"put_att_nav_lat_ID")
         status = NF90_PUT_ATT(fidM,nav_lat_ID,"add_offset",0.)
         call erreur(status,.TRUE.,"put_att_nav_lat_ID")
         status = NF90_PUT_ATT(fidM,nav_lat_ID,"valid_max",89.947868347168)
         call erreur(status,.TRUE.,"put_att_nav_lat_ID")
         status = NF90_PUT_ATT(fidM,nav_lat_ID,"valid_min",-77.0104751586914)
         call erreur(status,.TRUE.,"put_att_nav_lat_ID")
         status = NF90_PUT_ATT(fidM,nav_lat_ID,"units","degrees_north")
         call erreur(status,.TRUE.,"put_att_nav_lat_ID")

         status = NF90_PUT_ATT(fidM,nav_lon_ID,"long_name","Longitude")
         call erreur(status,.TRUE.,"put_att_nav_lon_ID")
         status = NF90_PUT_ATT(fidM,nav_lon_ID,"scale_factor",1.)
         call erreur(status,.TRUE.,"put_att_nav_lon_ID")
         status = NF90_PUT_ATT(fidM,nav_lon_ID,"add_offset",0.)
         call erreur(status,.TRUE.,"put_att_nav_lon_ID")
         status = NF90_PUT_ATT(fidM,nav_lon_ID,"valid_max",180.)
         call erreur(status,.TRUE.,"put_att_nav_lon_ID")
         status = NF90_PUT_ATT(fidM,nav_lon_ID,"valid_min",-180.)
         call erreur(status,.TRUE.,"put_att_nav_lon_ID")
         status = NF90_PUT_ATT(fidM,nav_lon_ID,"units","degrees_east")
         call erreur(status,.TRUE.,"put_att_nav_lon_ID")

         status = NF90_PUT_ATT(fidM,X_ID,"nav_model","Default grid")
         call erreur(status,.TRUE.,"put_att_X_ID")
         status = NF90_PUT_ATT(fidM,X_ID,"long_name","X")
         call erreur(status,.TRUE.,"put_att_X_ID")
         status = NF90_PUT_ATT(fidM,X_ID,"scale_factor",1.)
         call erreur(status,.TRUE.,"put_att_X_ID")
         status = NF90_PUT_ATT(fidM,X_ID,"add_offset",0.)
         call erreur(status,.TRUE.,"put_att_X_ID")
         status = NF90_PUT_ATT(fidM,X_ID,"units","km")
         call erreur(status,.TRUE.,"put_att_X_ID")

         status = NF90_PUT_ATT(fidM,Unorm_ID,"online_operation","N/A")
         call erreur(status,.TRUE.,"put_att_Unorm_ID")
         status = NF90_PUT_ATT(fidM,Unorm_ID,"short_name","Uorth")
         call erreur(status,.TRUE.,"put_att_Unorm_ID")
         status = NF90_PUT_ATT(fidM,Unorm_ID,"long_name","ocean speed orthogonal to the section oriented south-north")
         call erreur(status,.TRUE.,"put_att_Unorm_ID")
         status = NF90_PUT_ATT(fidM,Unorm_ID,"valid_max",10.)
         call erreur(status,.TRUE.,"put_att_Unorm_ID")
         status = NF90_PUT_ATT(fidM,Unorm_ID,"valid_min",-10.)
         call erreur(status,.TRUE.,"put_att_Unorm_ID")
         status = NF90_PUT_ATT(fidM,Unorm_ID,"missing_value",0.)
         call erreur(status,.TRUE.,"put_att_Unorm_ID")
         status = NF90_PUT_ATT(fidM,Unorm_ID,"units","m/s")
         call erreur(status,.TRUE.,"put_att_Unorm_ID")

         status = NF90_PUT_ATT(fidM,Utang_ID,"online_operation","N/A")
         call erreur(status,.TRUE.,"put_att_Utang_ID")
         status = NF90_PUT_ATT(fidM,Utang_ID,"short_name","Utang")
         call erreur(status,.TRUE.,"put_att_Utang_ID")
         status = NF90_PUT_ATT(fidM,Utang_ID,"long_name","ocean speed tangential to the section oriented south-north")
         call erreur(status,.TRUE.,"put_att_Utang_ID")
         status = NF90_PUT_ATT(fidM,Utang_ID,"valid_max",10.)
         call erreur(status,.TRUE.,"put_att_Utang_ID")
         status = NF90_PUT_ATT(fidM,Utang_ID,"valid_min",-10.)
         call erreur(status,.TRUE.,"put_att_Utang_ID")
         status = NF90_PUT_ATT(fidM,Utang_ID,"missing_value",0.)
         call erreur(status,.TRUE.,"put_att_Utang_ID")
         status = NF90_PUT_ATT(fidM,Utang_ID,"units","m/s")
         call erreur(status,.TRUE.,"put_att_Utang_ID")
                         
         status = NF90_PUT_ATT(fidM,sig0_ID,"short_name","sig0")
         call erreur(status,.TRUE.,"put_att_sig0_ID")
         status = NF90_PUT_ATT(fidM,sig0_ID,"long_name","Potential Density Sigma 0")
         call erreur(status,.TRUE.,"put_att_sig0_ID")
         status = NF90_PUT_ATT(fidM,sig0_ID,"valid_max",100.)
         call erreur(status,.TRUE.,"put_att_sig0_ID")
         status = NF90_PUT_ATT(fidM,sig0_ID,"valid_min",10.0)
         call erreur(status,.TRUE.,"put_att_sig0_ID")
         status = NF90_PUT_ATT(fidM,sig0_ID,"missing_value",10.0)
         call erreur(status,.TRUE.,"put_att_sig0_ID")
         status = NF90_PUT_ATT(fidM,sig0_ID,"units","kg/m3")
         call erreur(status,.TRUE.,"put_att_sig0_ID")

         status = NF90_PUT_ATT(fidM,sig1_ID,"short_name","sig1")
         call erreur(status,.TRUE.,"put_att_sig1_ID")
         status = NF90_PUT_ATT(fidM,sig1_ID,"long_name","Potential Density Sigma 0")
         call erreur(status,.TRUE.,"put_att_sig1_ID")
         status = NF90_PUT_ATT(fidM,sig1_ID,"valid_max",100.)
         call erreur(status,.TRUE.,"put_att_sig1_ID")
         status = NF90_PUT_ATT(fidM,sig1_ID,"valid_min",10.0)
         call erreur(status,.TRUE.,"put_att_sig1_ID")
         status = NF90_PUT_ATT(fidM,sig1_ID,"missing_value",10.0)
         call erreur(status,.TRUE.,"put_att_sig1_ID")
         status = NF90_PUT_ATT(fidM,sig1_ID,"units","kg/m3")
         call erreur(status,.TRUE.,"put_att_sig1_ID")

         status = NF90_PUT_ATT(fidM,sig2_ID,"short_name","sig2")
         call erreur(status,.TRUE.,"put_att_sig2_ID")
         status = NF90_PUT_ATT(fidM,sig2_ID,"long_name","Potential Density Sigma 0")
         call erreur(status,.TRUE.,"put_att_sig2_ID")
         status = NF90_PUT_ATT(fidM,sig2_ID,"valid_max",100.)
         call erreur(status,.TRUE.,"put_att_sig2_ID")
         status = NF90_PUT_ATT(fidM,sig2_ID,"valid_min",10.0)
         call erreur(status,.TRUE.,"put_att_sig2_ID")
         status = NF90_PUT_ATT(fidM,sig2_ID,"missing_value",10.0)
         call erreur(status,.TRUE.,"put_att_sig2_ID")
         status = NF90_PUT_ATT(fidM,sig2_ID,"units","kg/m3")
         call erreur(status,.TRUE.,"put_att_sig2_ID")

         status = NF90_PUT_ATT(fidM,sig4_ID,"short_name","sig4")
         call erreur(status,.TRUE.,"put_att_sig4_ID")
         status = NF90_PUT_ATT(fidM,sig4_ID,"long_name","Potential Density Sigma 0")
         call erreur(status,.TRUE.,"put_att_sig4_ID")
         status = NF90_PUT_ATT(fidM,sig4_ID,"valid_max",100.)
         call erreur(status,.TRUE.,"put_att_sig4_ID")
         status = NF90_PUT_ATT(fidM,sig4_ID,"valid_min",20.0)
         call erreur(status,.TRUE.,"put_att_sig4_ID")
         status = NF90_PUT_ATT(fidM,sig4_ID,"missing_value",20.0)
         call erreur(status,.TRUE.,"put_att_sig4_ID")
         status = NF90_PUT_ATT(fidM,sig4_ID,"units","kg/m3")
         call erreur(status,.TRUE.,"put_att_sig4_ID")

        ! Attributs globaux       :
         status = NF90_PUT_ATT(fidM,NF90_GLOBAL,"history","Created by cdfsections (see CDFTOOLS)")
         call erreur(status,.TRUE.,"put_att_global_ID")
                                                      
        !Fin des definitions                          
         status = NF90_ENDDEF(fidM)                   
         call erreur(status,.TRUE.,"fin_definition") 
                                                      
        !Valeurs prises par les variables :           
         status = NF90_PUT_VAR(fidM,vosaline_ID,vosaline_sec)
         call erreur(status,.TRUE.,"var_vosaline_ID")
         status = NF90_PUT_VAR(fidM,votemper_ID,votemper_sec)
         call erreur(status,.TRUE.,"var_votemper_ID")
         status = NF90_PUT_VAR(fidM,time_counter_ID,time_counter)
         call erreur(status,.TRUE.,"var_time_counter_ID")
         status = NF90_PUT_VAR(fidM,deptht_ID,deptht)
         call erreur(status,.TRUE.,"var_deptht_ID")
         status = NF90_PUT_VAR(fidM,nav_lat_ID,latsec)
         call erreur(status,.TRUE.,"var_nav_lat_ID")
         status = NF90_PUT_VAR(fidM,nav_lon_ID,lonsec)
         call erreur(status,.TRUE.,"var_nav_lon_ID")
         status = NF90_PUT_VAR(fidM,X_ID,X1)
         call erreur(status,.TRUE.,"var_X_ID")
         status = NF90_PUT_VAR(fidM,Unorm_ID,Unorm)
         call erreur(status,.TRUE.,"var_Unorm_ID")
         status = NF90_PUT_VAR(fidM,Utang_ID,Utang)
         call erreur(status,.TRUE.,"var_Utang_ID") 
         status = NF90_PUT_VAR(fidM,sig0_ID,sigsec0)
         call erreur(status,.TRUE.,"var_sig0_ID")
         status = NF90_PUT_VAR(fidM,sig1_ID,sigsec1)
         call erreur(status,.TRUE.,"var_sig1_ID")
         status = NF90_PUT_VAR(fidM,sig2_ID,sigsec2)
         call erreur(status,.TRUE.,"var_sigsec2_ID") 
         status = NF90_PUT_VAR(fidM,sig4_ID,sigsec4)
         call erreur(status,.TRUE.,"var_sigsec4_ID")         
                                    
        !Fin de l'ecriture                            
         status = NF90_CLOSE(fidM)                    
         call erreur(status,.TRUE.,"final")         

end program cdfsections



SUBROUTINE erreur(iret, lstop, chaine)
  ! pour les messages d'erreur
  USE netcdf
  INTEGER, INTENT(in)                     :: iret
  LOGICAL, INTENT(in)                     :: lstop
  CHARACTER(LEN=*), INTENT(in)            :: chaine
  !
  CHARACTER(LEN=256)                       :: message
  !
  IF ( iret .NE. 0 ) THEN
    WRITE(*,*) 'ROUTINE: ', TRIM(chaine)
    WRITE(*,*) 'ERREUR: ', iret
    message=NF90_STRERROR(iret)
    WRITE(*,*) 'THIS MEANS :',TRIM(message)
    IF ( lstop ) STOP 99
  ENDIF
  !
END SUBROUTINE erreur

PROGRAM cdfmht_gsop
  !!-------------------------------------------------------------------
  !!               ***  PROGRAM cdfmht_gsop  ***
  !!
  !!  **  Purpose  :  Compute the Meridional Heat Transport (MHT)
  !!                  Components for GSOP intercomparison
  !!                  PARTIAL STEPS
  !!  
  !!  **  Method   :  The MHT is computed from the V velocity field and T temperature field, integrated
  !!                  from the bottom to the surface.
  !!                  The MHT is decomposed into 3 components : BT, SH, AG.
  !!                  Results are saved on gsopmht.nc file with variables name respectively
  !!                  zomhtatl, zobtmhta, zoshmhta, zoagmhta
  !!
  !!
  !! history ;
  !!  Original :  J.M. Molines (jul. 2005) 
  !!              G.C. Smith ( Sep 2007) Added MOC decomposition following :
  !!                 Lee & Marotzke (1998), Baehr, Hirschi, Beismann, &  Marotzke (2004), Cabanes, Lee, & Fu (2007),  !!                  Koehl & Stammer (2007).
  !!                 See also the powerpoint presentation by Tony Lee at the third CLIVAR-GSOP intercomparison
  !!    available at : http://www.clivar.org/organization/gsop/synthesis/mit/talks/lee_MOC_comparison.ppt
  !!
  !!              A. Lecointre (Dec 2008) Replaced by a MHT decomposition
  !!
  !!-------------------------------------------------------------------
  !!  $Rev$
  !!  $Date$
  !!  $Id$
  !!--------------------------------------------------------------

  !! * Modules used
  USE cdfio
  USE eos

  !! * Local variables
  IMPLICIT NONE
  INTEGER   :: jpbasins  ! =5 modif Alb 29/11/08 pour fonctionner avec MERA
  INTEGER, PARAMETER :: jpgsop=4
  INTEGER   :: jgsop, jbasin, jj, jk ,ji                  !: dummy loop index
  INTEGER   :: ierr                                !: working integer
  INTEGER   :: narg, iargc                         !: command line 
  INTEGER   :: npiglo,npjglo, npk                  !: size of the domain
  INTEGER   :: ncout, np
  INTEGER   :: numout=10
  INTEGER, DIMENSION(:), ALLOCATABLE ::  ipk, id_varout         ! 
  INTEGER, DIMENSION(jpgsop) ::  ipk_gsop, id_varout_gsop         !
  INTEGER, DIMENSION(2)          ::  iloc

  REAL(KIND=4), DIMENSION (:,:),     ALLOCATABLE ::  e1u, e1v, e3v, gphiv, zv !:  metrics, velocity
  REAL(KIND=4), DIMENSION (:,:),     ALLOCATABLE ::  Hdep, vbt
  REAL(KIND=4), DIMENSION (:,:),     ALLOCATABLE ::  btht
  REAL(KIND=4), DIMENSION (:,:),     ALLOCATABLE ::  zt,zt_v,zsal,tmask,umask,vmask, vgeoz
  REAL(KIND=8), DIMENSION (:,:),     ALLOCATABLE ::  zsig0
  REAL(KIND=4), DIMENSION (:,:,:),   ALLOCATABLE ::  vgeo,vgeosh,vageosh,vfull,tfull,vmaskz,tmaskz
  REAL(KIND=4)   ::  rau0, grav, f0, fcor, zmsv, zphv, rpi
!  REAL(KIND=4)   ::  grav, f0, fcor, zmsv, zphv, rpi
  REAL(KIND=4), DIMENSION (:,:,:),   ALLOCATABLE ::  e3vz
  REAL(KIND=4), DIMENSION (:,:),     ALLOCATABLE ::  dumlon              !: dummy longitude = 0.
  REAL(KIND=4), DIMENSION (:,:),     ALLOCATABLE ::  dumlat              !: latitude for i = north pole
  REAL(KIND=4), DIMENSION (:),       ALLOCATABLE ::  deptht, gdepw       !: deptw
  REAL(KIND=4), DIMENSION (:,:,:),   ALLOCATABLE ::  zmask               !:  jpbasins x npiglo x npjglo
  REAL(KIND=4), DIMENSION (:,:),     ALLOCATABLE ::  zzmask              !:  npiglo x npjglo
  REAL(KIND=4), DIMENSION (1)                    ::  tim

  REAL(KIND=8) ,DIMENSION(:,:) , ALLOCATABLE ::  zomht                 !: jpbasins x npjglo
  REAL(KIND=8) ,DIMENSION(:,:) , ALLOCATABLE ::  zomht_gsop            !: jpgsop x npjglo
  REAL(KIND=8) ,DIMENSION(:,:) , ALLOCATABLE ::  zomht_geos_full       !: npjglo x npk
  REAL(KIND=8) ,DIMENSION(:,:) , ALLOCATABLE ::  zomht_ageos_full      !: npjglo x npk
  REAL(KIND=8) ,DIMENSION(:,:,:) , ALLOCATABLE ::  zomhtfull           !: jpbasin x npjglo x npk


  CHARACTER(LEN=256) :: cfilet, cfilev , cfileoutnc='gsopmht.nc'
  CHARACTER(LEN=256) :: coordhgr='mesh_hgr.nc',  coordzgr='mesh_zgr.nc',cbasinmask='new_maskglo.nc'
  CHARACTER(LEN=256) ,DIMENSION(jpgsop)     :: cvarname_gsop              !: array of var name for output
  TYPE(variable), DIMENSION(jpgsop) :: stypvar       !: modif Alb 26/11/08 structure for attributes
  LOGICAL    :: llglo = .false.                            !: indicator for presence of new_maskglo.nc file
  INTEGER    :: istatus

  ! constants
  REAL(KIND=4),PARAMETER   ::  rho0=1000.,   rcp=4000.   ! rau0 en kg x m-3 et rcp en m2 x s-2 x degC-1

  !!  Read command line and output usage message if not compliant.
  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' Usage : cdfmht_gsop  V file Tfile'
     PRINT *,' Computes the MHT for atlantic basin'
     PRINT *,' PARTIAL CELLS VERSION'
     PRINT *,' Files mesh_hgr.nc, mesh_zgr.nc ,new_maskglo.nc ,mask.nc '
     PRINT *,'  must be in the current directory'
     PRINT *,' Output on gsopmht.nc: '
     PRINT *,'      variables zomhtatl  : MHT Atlantic Ocean '
     PRINT *,'      variables zobtmhta  : Barotropic component '
     PRINT *,'      variables zoshmhta  : Vertical shear geostrophic component '
     PRINT *,'      variables zoagmhta  : vertical shear ageostrophic component (Ekman + residu)'
     STOP
  ENDIF

  CALL getarg (1, cfilev)
  npiglo= getdim (cfilev,'x')
  npjglo= getdim (cfilev,'y')
  npk   = getdim (cfilev,'depth')
  CALL getarg (2, cfilet)

 ! Detects newmaskglo file modif Alb 29/11/08 pour MERA
  INQUIRE( FILE='new_maskglo.nc', EXIST=llglo )
  IF (llglo) THEN
     jpbasins = 5
  ELSE
     jpbasins = 1
  ENDIF 

 ! define new variables for output

  stypvar(1)%cname= 'zobtmhta'
  stypvar(1)%cunits='PetaWatt'
  stypvar(1)%rmissing_value=99999.
  stypvar(1)%valid_min= -1000.
  stypvar(1)%valid_max= 1000.
  stypvar(1)%scale_factor= 1.
  stypvar(1)%add_offset= 0.
  stypvar(1)%savelog10= 0.
  stypvar(1)%clong_name='Barotropic_Merid_HeatTransport'
  stypvar(1)%cshort_name='zobtmhta'
  stypvar(1)%conline_operation='N/A'
  stypvar(1)%caxis='TY'

  stypvar(2)%cname= 'zoshmhta'
  stypvar(2)%cunits='PetaWatt'
  stypvar(2)%rmissing_value=99999.
  stypvar(2)%valid_min= -1000.
  stypvar(2)%valid_max= 1000.
  stypvar(2)%scale_factor= 1.
  stypvar(2)%add_offset= 0.
  stypvar(2)%savelog10= 0.
  stypvar(2)%clong_name='GeoShear_Merid_HeatTransport'
  stypvar(2)%cshort_name='zoshmhta'
  stypvar(2)%conline_operation='N/A'
  stypvar(2)%caxis='TY'

  stypvar(3)%cname= 'zoagmhta'
  stypvar(3)%cunits='PetaWatt'
  stypvar(3)%rmissing_value=99999.
  stypvar(3)%valid_min= -1000.
  stypvar(3)%valid_max= 1000.
  stypvar(3)%scale_factor= 1.
  stypvar(3)%add_offset= 0.
  stypvar(3)%savelog10= 0.
  stypvar(3)%clong_name='Ageo_Merid_HeatTransport'
  stypvar(3)%cshort_name='zoagmhta'
  stypvar(3)%conline_operation='N/A'
  stypvar(3)%caxis='TY'

  stypvar(4)%cname= 'zomhtatl'
  stypvar(4)%cunits='PetaWatt'
  stypvar(4)%rmissing_value=99999.
  stypvar(4)%valid_min= -1000.
  stypvar(4)%valid_max= 1000.
  stypvar(4)%scale_factor= 1.
  stypvar(4)%add_offset= 0.
  stypvar(4)%savelog10= 0.
  stypvar(4)%clong_name='Meridional_HeatTransport_Atlantic'
  stypvar(4)%cshort_name='zomhtatl'
  stypvar(4)%conline_operation='N/A'
  stypvar(4)%caxis='TY'

  ipk_gsop(1) = npk
  ipk_gsop(2) = npk
  ipk_gsop(3) = npk
  ipk_gsop(4) = npk

  ! Allocate arrays
  ALLOCATE ( zmask(jpbasins,npiglo,npjglo) )
  ALLOCATE ( tmask(npiglo,npjglo) )
  ALLOCATE ( tmaskz(npiglo,npjglo,npk) )
  ALLOCATE ( umask(npiglo,npjglo) )
  ALLOCATE ( vmask(npiglo,npjglo) )
  ALLOCATE ( vmaskz(npiglo,npjglo,npk) )
  ALLOCATE ( zv(npiglo,npjglo) )
  ALLOCATE ( vfull(npiglo,npjglo,npk) )
  ALLOCATE ( zt(npiglo,npjglo), zt_v(npiglo,npjglo) ) ! temperature au point T et au point V
  ALLOCATE ( tfull(npiglo,npjglo,npk) )  ! temperature au point V
  ALLOCATE ( e1u(npiglo,npjglo),e1v(npiglo,npjglo),e3v(npiglo,npjglo), gphiv(npiglo,npjglo) ,gdepw(npk) )
  ALLOCATE ( Hdep(npiglo,npjglo), vbt(npiglo,npjglo) )
  ALLOCATE ( e3vz(npiglo,npjglo,npk) )
  ALLOCATE ( zomhtfull(jpbasins,npjglo,npk) )
  ALLOCATE ( zomht(jpbasins, npjglo) )
  ALLOCATE ( zomht_gsop(jpgsop, npjglo) )
  ALLOCATE ( btht(npjglo,npk) )
  ALLOCATE ( zsal(npiglo,npjglo), zsig0(npiglo,npjglo) )
  ALLOCATE ( deptht(npk) )
  ALLOCATE ( dumlon(1,npjglo) , dumlat(1,npjglo))
  ALLOCATE ( zzmask(npiglo,npjglo) )
  ALLOCATE ( vgeo(npiglo,npjglo,npk) )
  ALLOCATE ( vgeoz(npiglo,npjglo) )
  ALLOCATE ( vgeosh(npiglo,npjglo,npk) )
  ALLOCATE ( zomht_geos_full(npjglo,npk) )
  ALLOCATE ( vageosh(npiglo,npjglo,npk) )
  ALLOCATE ( zomht_ageos_full(npjglo,npk) )

  e1v(:,:) = getvar(coordhgr, 'e1v', 1,npiglo,npjglo) 
  e1u(:,:) = getvar(coordhgr, 'e1u', 1,npiglo,npjglo) 
  gphiv(:,:) = getvar(coordhgr, 'gphiv', 1,npiglo,npjglo)
  deptht(:) = getvare3(coordzgr, 'gdept',npk)
  gdepw(:) = getvare3(coordzgr, 'gdepw',npk)
  gdepw(:) = -1.*  gdepw(:)

  iloc=maxloc(gphiv)
  dumlat(1,:) = gphiv(iloc(1),:)
  dumlon(:,:) = 0.   ! set the dummy longitude to 0

  ! create output fileset
  ncout =create(cfileoutnc, cfilev,1,npjglo,1,cdep='depthw')
  ierr= createvar(ncout ,stypvar,jpgsop, ipk_gsop,id_varout_gsop )
  ierr= putheadervar(ncout, cfilev,1, npjglo,1,pnavlon=dumlon,pnavlat=dumlat,pdep=gdepw)
  tim=getvar1d(cfilev,'time_counter',1)
  ierr=putvar1d(ncout,tim,1,'T')

  ! reading the masks
  ! 1 : global ; 2 : Atlantic ; 3 : Indo-Pacif ; 4 : Indian ; 5 : Pacif

zmask=0
zmask(1,:,:)=getvar('mask.nc','vmask',1,npiglo,npjglo)

IF (llglo) THEN

  zmask(2,:,:)=getvar(cbasinmask,'tmaskatl',1,npiglo,npjglo)
  zmask(4,:,:)=getvar(cbasinmask,'tmaskind',1,npiglo,npjglo)
  zmask(5,:,:)=getvar(cbasinmask,'tmaskpac',1,npiglo,npjglo)
  zmask(3,:,:)=zmask(5,:,:)+zmask(4,:,:)
  ! ensure that there are no overlapping on the masks
  WHERE(zmask(3,:,:) > 0 ) zmask(3,:,:) = 1

ELSE

zmask(2,:,:)=getvar('mask.nc','tmask',1,npiglo,npjglo)

ENDIF

  ! initialize mht to 0
  zomht(:,:) = 0.
  zomhtfull(:,:,:) = 0.
  zomht_gsop(:,:) = 0.
  vbt(:,:) = 0.0
  Hdep(:,:) = 0.0
  btht(:,:) = 0.0
  vgeo(:,:,:)=0.0
  vfull(:,:,:)=0.0
  tfull(:,:,:)=0.0

  ! Constants for geostrophic calc
  rau0 = 1025.0
  grav = 9.81
  rpi = 3.14159
  f0 = 2.0*(2.0*rpi)/(24.0*3600.0)

  ! Get velocities v and temperature T and e3v_ps and masks at all levels
  DO jk = 1,npk
  vmask(:,:)=getvar('mask.nc','vmask',jk,npiglo,npjglo)
  vmaskz(:,:,jk) = vmask(:,:)
  tmask(:,:)=getvar('mask.nc','tmask',jk,npiglo,npjglo)
  tmaskz(:,:,jk) = tmask(:,:)
  zv(:,:)= getvar(cfilev, 'vomecrty',  jk ,npiglo,npjglo)  ! au point V
  vfull(:,:,jk) = zv(:,:)                                  ! au point V
  zt(:,:)= getvar(cfilet, 'votemper', jk,npiglo,npjglo)    ! au point T
    DO ji = 1,npiglo                                       ! mettre la temperature au point V
      DO jj = 1,npjglo-1
        zt_v(ji,jj)= ((zt(ji,jj) + zt(ji,jj+1)) * tmask(ji,jj) * tmask(ji,jj+1))/2
      END DO
    END DO
  tfull(:,:,jk)= zt_v(:,:)                                ! au point V
  e3v(:,:) = getvar(coordzgr, 'e3v_ps', jk,npiglo,npjglo)
  e3vz(:,:,jk) = e3v(:,:)
  ENDDO

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! CALCUL OF THE TOTAL MHT
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  DO jk = 1,npk-1
     ! MHT totale au point V
     ! integrates 'zonally' (along i-coordinate)
     DO ji=1,npiglo
       ! For all basins 
       DO jbasin = 1, jpbasins
         DO jj=1,npjglo
           zomhtfull(jbasin,jj,jk) = zomhtfull(jbasin,jj,jk) + vmaskz(ji,jj,jk)*e1v(ji,jj)*e3vz(ji,jj,jk)*zmask(jbasin,ji,jj)*vfull(ji,jj,jk)*tfull(ji,jj,jk)*rho0*rcp/1.e15
         ENDDO ! loop to next latitude
       END DO  ! loop to next basin
     END DO    ! loop to next longitude
  ENDDO        ! loop to next level

 ! integrates vertically from bottom to surface the total MHT
  DO jk=npk , 1 , -1 
     zomht(:,:) = zomht(:,:) + zomhtfull(:,:,jk)
  END DO  ! loop to next level
  ! Save variable in zomht_gsop
  zomht_gsop(4,:) = zomht(2,:)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! CALCUL OF THE BAROTROPIC MHT
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

     ! Calculate ATLANTIC Barotropic velocity au point V
  DO jk = 1,npk-1
     DO ji=1,npiglo
       DO jj=1,npjglo
         vbt(ji,jj) = vbt(ji,jj) + e3vz(ji,jj,jk)*zmask(2,ji,jj)*vfull(ji,jj,jk)*vmaskz(ji,jj,jk)  ! hardwire to jbasin=2
         Hdep(ji,jj) = Hdep(ji,jj) + e3vz(ji,jj,jk)*zmask(2,ji,jj)*vmaskz(ji,jj,jk)
       ENDDO ! loop to next latitude
     ENDDO   ! loop to next longitude
  ENDDO      ! loop to next level

  ! Normalize Barotropic velocity
  DO ji=1,npiglo
    DO jj=1,npjglo
      IF ( Hdep(ji,jj) > 0.0 ) THEN
        vbt(ji,jj) = vbt(ji,jj)/Hdep(ji,jj)
      ELSE
        IF ( vbt(ji,jj) /= 0.0 ) THEN
         print *, 'Is something wrong?, ji,jj=',ji,jj
        ENDIF
        vbt(ji,jj) = 0.0
      ENDIF
    ENDDO  ! loop to next latitude
  ENDDO    ! loop to next longitude

  ! Integrate zonally the barotropic velocity
  DO jk=1, npk 
    DO jj=1,npjglo
      DO ji=1,npiglo
        btht(jj,jk) = btht(jj,jk) + vmaskz(ji,jj,jk)*e1v(ji,jj)*e3vz(ji,jj,jk)*zmask(2,ji,jj)*vbt(ji,jj)*tfull(ji,jj,jk)*rho0*rcp/1.e15
      ENDDO 
    ENDDO
  ENDDO 

  ! Now Integrate vertically to get Barotropic Meridional Heat Transport
  DO jk=npk , 1 , -1 
     zomht_gsop(1,:)=zomht_gsop(1,:) + btht(:,jk)
  END DO  ! loop to next level

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! CALCUL OF THE GEOSTROPHIC MHT
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! reinitialiser la temperature au point T a 0
zt(:,:)=0.0
  DO jk = 1,npk-1 
     ! Calculate density !! attention, density est au point U, il faut la mettre au point V
     zsal(:,:) = getvar(cfilet, 'vosaline',  jk ,npiglo, npjglo)
     zt(:,:)= getvar(cfilet, 'votemper', jk,npiglo,npjglo)    ! au point T

     zzmask=1
     WHERE(zsal(:,:)* zmask(2,:,:) == 0 ) zzmask = 0
     ! geostrophic calculation must use in situ density gradient
     ! la il faut prendre la temperature au point T
     zsig0(:,:) = sigmai ( zt,zsal,deptht(jk),npiglo,npjglo )* zzmask(:,:)

     ! Calculate Geostrophic velocity
     ! value at v points is average of values at u points
     DO ji = 2, npiglo-1
       DO jj = 2, npjglo-1
         IF ( gphiv(ji,jj) == 0.0 ) THEN 
           vgeo(ji,jj,jk) = 0.0
         ELSE
           zmsv = 1. / MAX(  tmaskz(ji  ,jj+1,jk)*tmaskz(ji-1,jj+1,jk) + tmaskz(ji+1,jj+1,jk)*tmaskz(ji  ,jj+1,jk)   &
                         + tmaskz(ji,  jj  ,jk)*tmaskz(ji-1,jj  ,jk) + tmaskz(ji+1,jj  ,jk)*tmaskz(ji  ,jj  ,jk) , 1.  )
           zphv = ( zsig0(ji  ,jj+1) - zsig0(ji-1,jj+1) ) * tmaskz(ji  ,jj+1,jk)*tmaskz(ji-1,jj+1,jk) / e1u(ji-1,jj+1)   &
                + ( zsig0(ji+1,jj+1) - zsig0(ji  ,jj+1) ) * tmaskz(ji+1,jj+1,jk)*tmaskz(ji  ,jj+1,jk) / e1u(ji  ,jj+1)   &
                + ( zsig0(ji  ,jj  ) - zsig0(ji-1,jj  ) ) * tmaskz(ji  ,jj  ,jk)*tmaskz(ji-1,jj  ,jk) / e1u(ji-1,jj  )   &
                + ( zsig0(ji+1,jj  ) - zsig0(ji  ,jj  ) ) * tmaskz(ji+1,jj ,jk )*tmaskz(ji  ,jj  ,jk) / e1u(ji  ,jj  )
           zphv = (1. / rau0) * zphv * zmsv * vmaskz(ji,jj,jk)
           fcor = f0*SIN(rpi*gphiv(ji,jj)/180.0)
           vgeo(ji,jj,jk) = -grav*zphv/fcor*e3vz(ji,jj,jk)*zmask(2,ji,jj)
         ENDIF
       ENDDO  ! loop to next latitude
     ENDDO    ! loop to next longitude
  ENDDO       ! loop to next level

  ! Vertical shear-velocity: Remove vertical average
  vgeoz(:,:) = 0.0
  vgeosh(:,:,:)=0.0
  DO ji=1, npiglo
    DO jj = 1, npjglo
      ! Integrate vertically to get geostrophic velocity referenced  to bottom
      DO jk = npk-1,1,-1
        vgeo(ji,jj,jk) = vgeo(ji,jj,jk+1) + vgeo(ji,jj,jk)
      ENDDO
      ! Calculate vertical sum
      DO jk = 1, npk
       vgeoz(ji,jj) = vgeoz(ji,jj) + vgeo(ji,jj,jk)*zmask(2,ji,jj)*e3vz(ji,jj,jk)*vmaskz(ji,jj,jk)
      ENDDO
      ! Remove total depth to get vertical mean
      IF ( Hdep(ji,jj) > 0.0 ) THEN
        vgeoz(ji,jj) = vgeoz(ji,jj)/Hdep(ji,jj)
      ELSE
        vgeoz(ji,jj) = 0.0
      ENDIF
      ! Remove vertical mean from geostrophic velocity to get geostrophic vertical shear velocity.
      DO jk = 1, npk
        vgeosh(ji,jj,jk) = zmask(2,ji,jj)*vgeo(ji,jj,jk) - vgeoz(ji,jj)
      ENDDO
    ENDDO  ! loop to next latitude
  ENDDO    ! loop to next longitude
  ! Calculate vertical shear MHT - integrate over x
  zomht_geos_full(:,:) = 0.0
  DO jk=1, npk 
    DO jj=1,npjglo
      DO ji=1,npiglo
        zomht_geos_full(jj,jk) = zomht_geos_full(jj,jk) + &
            & vmaskz(ji,jj,jk)*e1v(ji,jj)*e3vz(ji,jj,jk)*zmask(2,ji,jj)*vgeosh(ji,jj,jk)*tfull(ji,jj,jk)*rho0*rcp/1.e15
      END DO 
    ENDDO
  ENDDO 
  ! Integrate vertically the geostrophic MHT
  DO jk=npk , 1 , -1 
     zomht_gsop(2,:) = zomht_gsop(2,:) + zomht_geos_full(:,jk)
  END DO  ! loop to next level

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! CALCUL OF THE AGEOSTROPHIC MHT
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  vageosh(:,:,:)=0.0
  ! Calculate Vageostrophique au point V
  DO jk=1,npk
  vageosh(:,:,jk)=vfull(:,:,jk)-vgeosh(:,:,jk)-vbt(:,:)
  END DO

  ! Calculate vertical shear ageostrophique streamfunction - integrate over x
  zomht_ageos_full(:,:) = 0.0
  DO jk=1, npk 
    DO jj=1,npjglo
      DO ji=1,npiglo
        zomht_ageos_full(jj,jk) = zomht_ageos_full(jj,jk) + vmaskz(ji,jj,jk)*e1v(ji,jj)*e3vz(ji,jj,jk)*zmask(2,ji,jj)*vageosh(ji,jj,jk)*tfull(ji,jj,jk)*rho0*rcp/1.e15
      END DO 
    ENDDO
  ENDDO 

  ! Now Integrate vertically to get streamfunction AGEOSTROPHIE
  DO jk=npk , 1 , -1 
     zomht_gsop(3,:) = zomht_gsop(3,:) + zomht_ageos_full(:,jk)
  END DO  ! loop to next level
  



! ! integrates vertically from bottom to surface the total MHT
!  DO jk=npk-1 , 1 , -1 
!     zomht(:,:,jk) = zomht(:,:,jk+1) + zomht(:,:,jk)
!  END DO  ! loop to next level

!  ! Normalize Barotropic velocity
!  DO ji=1,npiglo
!    DO jj=1,npjglo
!      IF ( Hdep(ji,jj) > 0.0 ) THEN
!        vbt(ji,jj) = vbt(ji,jj)/Hdep(ji,jj)
!      ELSE
!        IF ( vbt(ji,jj) /= 0.0 ) THEN
!         print *, 'Is something wrong?, ji,jj=',ji,jj
!        ENDIF
!        vbt(ji,jj) = 0.0
!      ENDIF
!    END DO 
!  ENDDO

!  ! Calculate Barotropic Meridional Heat Transport - integrate over x
!  DO jk=1, npk 
!    DO jj=1,npjglo
!      DO ji=1,npiglo
!        btht(jj,jk) = btht(jj,jk) - vmaskz(ji,jj,jk)*e1v(ji,jj)*e3vz(ji,jj,jk)*zmask(2,ji,jj)*vbt(ji,jj)*ztfull(ji,jj,jk)/1.e15
!      END DO 
!    ENDDO
!  ENDDO 

  ! Now Integrate vertically to get Barotropic Meridional Heat Transport
!  DO jk=npk-1 , 1 , -1 
!     btht(:,jk) = btht(:,jk+1) + btht(:,jk)
!  END DO  ! loop to next level

!  ! Calculate Vageostrophique au point V
!  DO jk=1,npk
!  vageosh(:,:,jk)=vfull(:,:,jk)-vgeosh(:,:,jk)-vbt(:,:)
!  END DO

!  ! Calculate vertical shear ageostrophique streamfunction - integrate over x
!  DO jk=1, npk 
!    DO jj=1,npjglo
!      DO ji=1,npiglo
!        zomht_gsop(3,jj,jk) = zomht_gsop(3,jj,jk) - vmaskz(ji,jj,jk)*e1v(ji,jj)*e3vz(ji,jj,jk)*zmask(2,ji,jj)*vageosh(ji,jj,jk)*ztfull(ji,jj,jk)/1.e15
!      END DO 
!    ENDDO
!  ENDDO 

!  ! Now Integrate vertically to get streamfunction AGEOSTROPHIE
!  DO jk=npk-1 , 1 , -1 
!     zomht_gsop(3,:,jk) = zomht_gsop(3,:,jk+1) + zomht_gsop(3,:,jk)
!  END DO  ! loop to next level
  
!  ! Save variables in zomht_gsop
!  zomht_gsop(1,:,:) = btht(:,:)
!  zomht_gsop(4,:,:) = zomht(2,:,:)

  jj = 190
  FIND26: DO jj=1,npjglo
    IF ( dumlat(1,jj) > 26.0 ) EXIT FIND26
  ENDDO FIND26
  print *, 'MHT:zomht_gsop(4,jj) = ', zomht_gsop(4,jj)
  print *, 'BT:zomht_gsop(1,jj) = ', zomht_gsop(1,jj)
  print *, 'SH:zomht_gsop(2,jj) = ', zomht_gsop(2,jj)
  print *, 'AG:zomht_gsop(3,jj) = ', zomht_gsop(3,jj)

  !---------------------------------
  ! netcdf output 
  !---------------------------------

  !print *, 'Writing netcdf...'
  DO jgsop = 1, jpgsop
      ierr = putvar (ncout, id_varout_gsop(jgsop),REAL(zomht_gsop(jgsop,:)), 1,1,npjglo)
  ENDDO

  ierr = closeout(ncout)
 
END PROGRAM cdfmht_gsop

PROGRAM cdfstats
  !!======================================================================
  !!                     ***  PROGRAM  cdfstats  ***
  !!=====================================================================
  !!  ** Purpose : Compute RMS/CORREL between 2 files. 
  !!               Seasonal cycle removed
  !!
  !!  ** Method  :
  !!
  !! History : 2.1  : 2009     : M.A. Balmaseda : original code  from cdfrmsssh.f90
  !!         :  4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  USE modutils,  ONLY : SetGlobalAtt
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class statistics
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: jt, jm                 ! dummy loop index
  INTEGER(KIND=4)                           :: narg, iargc, ijarg, ij ! browse command line
  INTEGER(KIND=4)                           :: npiglo, npjglo         ! size of the domain
  INTEGER(KIND=4)                           :: npk, nt                ! size of the domain
  INTEGER(KIND=4), PARAMETER                :: jpvar=4                ! number of output variables
  INTEGER(KIND=4), DIMENSION(jpvar)         :: ipk, id_varout

  TYPE(variable), DIMENSION(jpvar)          :: stypvar                ! structure for attribute

  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: u, v                   ! input variables from file 1 and 2
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: tmask, e1t, e2t        ! mask and metrics

  REAL(KIND=8), DIMENSION(1)                :: dtim                   ! time for output (dummy)
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dl_er, dl_uv           ! rms, correlation
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dl_sn, dl_sg           ! signal/noise signal ratios
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dl_du, dl_dv           !  variable anomaly
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dl_u2, dl_v2           ! quadratic sum
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dl_um, dl_vm           ! linear sum
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dl_area                ! cell areas
  REAL(KIND=8)                              :: dl_spma                ! total area of the ocean ( info only)
  REAL(KIND=8)                              :: dl_spmu, dl_spmv       ! global mean (info only)
  REAL(KIND=8)                              :: dl_fct, dl_fcts        ! scaling coefficients

  CHARACTER(LEN=256)                        :: cf_in, cf_ref          ! input and reference file names
  CHARACTER(LEN=256)                        :: cf_msk, cf_hgr         ! current mask and hgr file
  CHARACTER(LEN=256)                        :: cf_out = 'stats.nc'    ! output file
  CHARACTER(LEN=256)                        :: cglobal                ! Global attribute
  CHARACTER(LEN=256)                        :: cldum                  ! dummy string for arguments
  CHARACTER(LEN=20)                         :: cv_name1, cv_name2     ! variable name
  CHARACTER(LEN=2)                          :: cy                     ! (1 or 12 ) 

  INTEGER(KIND=4)                           :: ncy                    ! 1/12 for annual/seasonal statistics
  INTEGER(KIND=4)                           :: ncout                  ! ID of netcdf output file
  INTEGER(KIND=4)                           :: ierr                   ! error status for ncdf

  LOGICAL                                   :: lchk                   ! flag for checking missing files
  LOGICAL                                   :: lnc4 = .FALSE.         ! Use nc4 with chunking and deflation
  !!--------------------------------------------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfstats -f IN-file -r REF-file -ncy ncy [-v1 VAR-name1] ...'
     PRINT *,'             ... [-v2 VAR-name2] [-m MSH-MSK-file ] [-o OUT-file] [-nc4]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'         This tool computes some statistics (rms, correlation, signal/noise'
     PRINT *,'         ratio and signal ratio [ratio of std deviation]) between two files.'
     PRINT *,'         In this tool, the files are supposed to hold monthly averages values,'
     PRINT *,'         for many years. Specifying ncy=12, allows to remove the seasonal'
     PRINT *,'         cycle of the data.'
     PRINT *,'      '
     PRINT *,'         This program was initially written for SSH statistics between model'
     PRINT *,'         output and AVISO files (default variable names are ',TRIM(cn_sossheig)
     PRINT *,'         for this reason ). It can now be used with any variables.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'        -f IN-file  : Model data file.'
     PRINT *,'        -r REF-file : Reference data file (usually observation file) '
     PRINT *,'        -ncy ncy    : ncy can only be 1 or 12. If set to 12, annual cycle is '
     PRINT *,'                 removed  from the data.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'        [-v1 VAR-name1] : Variable name in the model file. Default is ',TRIM(cn_sossheig),'.'
     PRINT *,'        [-v2 VAR-name2] : Variable name in the reference file. If not specified'
     PRINT *,'              assumes that it is the same than in the model file.'
     PRINT *,'        [-m MSH-MSK-file] : specify a mesh_mask file holding the tmaskutil'
     PRINT *,'              and the horizontal metrics. If this option is not used,'
     PRINT *,'              mask are taken in ',TRIM(cn_fmsk), ' and horizontal metric'
     PRINT *,'              is taken in ',TRIM(cn_fhgr)
     PRINT *,'        [-o OUT-file] : specify the output file name instead of ',TRIM(cf_out)
     PRINT *,'        [-nc4 ]  : Use netcdf4 output with chunking and deflation level 1.'
     PRINT *,'              This option is effective only if cdftools are compiled with'
     PRINT *,'              a netcdf library supporting chunking and deflation.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ' , TRIM(cn_fmsk),' and ', TRIM(cn_fhgr)
     PRINT *,'           or mesh_mask file specified in -m option'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'        netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables are : ' 
     PRINT *,'               rms    : RMS between the input files'
     PRINT *,'               correl : CORREL between the input files'
     PRINT *,'               rrat   : Signal to noise ratio '
     PRINT *,'               srat   : Signal ratio (stdev ratio) '
     PRINT *,'      '
     STOP 
  ENDIF

  ! default values
  cf_msk   = cn_fmsk
  cf_hgr   = cn_fhgr
  cv_name1 = cn_sossheig  
  cv_name2 = cn_sossheig  
  CALL SetGlobalAtt( cglobal )  ! global attribute for history : command line

  ! Browse command line
  ijarg = 1 
  DO WHILE (ijarg <= narg )
     CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1
     SELECT CASE ( cldum )
     CASE ( '-f ' ) ; CALL getarg (ijarg, cf_in   ) ; ijarg=ijarg+1
     CASE ( '-r ' ) ; CALL getarg (ijarg, cf_ref  ) ; ijarg=ijarg+1
     CASE ( '-ncy') ; CALL getarg (ijarg, cldum   ) ; ijarg=ijarg+1 ; READ(cldum,*) ncy
        ! option
     CASE ( '-m ' ) ; CALL getarg (ijarg, cf_msk  ) ; ijarg=ijarg+1
        ;             cf_hgr = cf_msk
     CASE ( '-v1' ) ; CALL getarg (ijarg, cv_name1) ; ijarg=ijarg+1 ; cv_name2=cv_name1
     CASE ( '-v2' ) ; CALL getarg (ijarg, cv_name2) ; ijarg=ijarg+1 
     CASE ( '-o ' ) ; CALL getarg (ijarg, cf_out  ) ; ijarg=ijarg+1
     CASE ( '-nc4') ; lnc4 = .TRUE.
     CASE DEFAULT   ; PRINT *,' ERROR : ',TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  END DO

  ! Security check for files
  lchk = chkfile ( cf_in  )
  lchk = chkfile ( cf_ref ) .OR. lchk
  lchk = chkfile ( cf_msk ) .OR. lchk
  lchk = chkfile ( cf_hgr ) .OR. lchk
  IF (lchk ) STOP 99 ! missing files

  ! log arguments do far
  PRINT *,'IN-file   : ', TRIM(cf_in )
  PRINT *,'REF-file  : ', TRIM(cf_ref)
  PRINT *,'NCY       : ', ncy
  PRINT *,'VAR-name1 : ', TRIM(cv_name1)
  PRINT *,'VAR_name2 : ', TRIM(cv_name2)
  PRINT *,'MASK file : ', TRIM(cf_msk  )
  PRINT *,'HGR file  : ', TRIM(cf_hgr  )

  ! define domain size from IN-file
  npiglo = getdim (cf_in, cn_x )
  npjglo = getdim (cf_in, cn_y )
  nt     = getdim (cf_in, cn_t )  ! read time dimension
  npk    = 1

  PRINT *, 'NPIGLO =', npiglo
  PRINT *, 'NPJGLO =', npjglo
  PRINT *, 'NPK    =', npk

  ! Allocate arrays from domain size
  ALLOCATE(     u(npiglo,npjglo),   v(npiglo,npjglo)                     )
  ALLOCATE( tmask(npiglo,npjglo), e1t(npiglo,npjglo), e2t(npiglo,npjglo) )

  ALLOCATE( dl_er(npiglo,npjglo), dl_uv(npiglo,npjglo) )
  ALLOCATE( dl_sn(npiglo,npjglo), dl_sg(npiglo,npjglo) )
  ALLOCATE( dl_u2(npiglo,npjglo), dl_v2(npiglo,npjglo) )
  ALLOCATE( dl_du(npiglo,npjglo), dl_dv(npiglo,npjglo) )
  ALLOCATE( dl_um(npiglo,npjglo), dl_vm(npiglo,npjglo) )
  ALLOCATE( dl_area(npiglo,npjglo)                     )

  CALL CreateOutput

  ! Read mask and metrics  
  tmask= getvar(cf_msk, cn_tmaskutil, 1, npiglo, npjglo)
  e1t  = getvar(cf_hgr, cn_ve1t,     1, npiglo, npjglo)
  e2t  = getvar(cf_hgr, cn_ve2t,     1, npiglo, npjglo)

  dl_area(:,:) = tmask(:,:)*e1t(:,:)*e2t(:,:)*1.d0   ! masked cell area
  dl_spma      = SUM(dl_area)                        ! model ocean area
  dl_fct       = 1.d0/float(nt)
  dl_fcts      = 1.d0*float(ncy)*dl_fct

  PRINT *, 'dl_spma = ',dl_spma, SUM(tmask)


  PRINT *,' output file created'
  dl_er(:,:) = 0.d0   ! rms
  dl_uv(:,:) = 0.d0   ! correlation
  dl_u2(:,:) = 0.d0   ! variance var1
  dl_v2(:,:) = 0.d0   ! variance var2
  dl_sn(:,:) = 0.d0   ! signal to noise ratio (rms/sdv)
  dl_sg(:,:) = 0.d0   ! signal ratio  (sdv(1)/sdv(2))

  DO jm = 1, ncy      ! loop on month (ncy=12)  or no loop if annual file (ncy=1)
     dl_um(:,:) = 0.d0
     dl_vm(:,:) = 0.d0
     PRINT *,' computing mean for month ',jm
     DO jt = jm, nt, ncy
        u(:,:) = getvar(cf_in , cv_name1, 1, npiglo, npjglo, ktime=jt)
        v(:,:) = getvar(cf_ref, cv_name2, 1, npiglo, npjglo, ktime=jt)

        dl_um(:,:) = dl_um(:,:) + u(:,:)*tmask(:,:)*1.d0
        dl_vm(:,:) = dl_vm(:,:) + v(:,:)*tmask(:,:)*1.d0
     ENDDO

     dl_um(:,:) = dl_um(:,:)*dl_fcts
     dl_vm(:,:) = dl_vm(:,:)*dl_fcts

     PRINT *,'MIN MAX UM ',MINVAL(dl_um), MAXVAL(dl_um)
     PRINT *,'MIN MAX VM ',MINVAL(dl_vm), MAXVAL(dl_vm)
     PRINT *,'computing 2nd order statistics'
     DO jt = jm, nt, ncy
        u(:,:) = getvar(cf_in , cv_name1, 1, npiglo, npjglo, ktime = jt)
        v(:,:) = getvar(cf_ref, cv_name2, 1, npiglo, npjglo, ktime = jt)

        ! anomaly
        dl_du(:,:) = (u(:,:) - dl_um(:,:))*tmask(:,:)
        dl_dv(:,:) = (v(:,:) - dl_vm(:,:))*tmask(:,:)

        ! REM no used if print below commented out (jmm ?)
        !         dl_spmu = SUM(u(:,:)*dl_area(:,:))/dl_spma
        !         dl_spmv = SUM(v(:,:)*dl_area(:,:))/dl_spma
        !         PRINT *,' jt, dl_spmu, dl_spmv ', jt, dl_spmu,dl_spmv

        dl_u2(:,:)=dl_u2(:,:) +  dl_du(:,:)             *  dl_du(:,:)
        dl_v2(:,:)=dl_v2(:,:) +  dl_dv(:,:)             *  dl_dv(:,:)
        dl_er(:,:)=dl_er(:,:) + (dl_du(:,:)-dl_dv(:,:)) * (dl_du(:,:)-dl_dv(:,:))
        dl_uv(:,:)=dl_uv(:,:) +  dl_du(:,:)             *  dl_dv(:,:)
     ENDDO
  ENDDO    ! loop on month

  dl_u2(:,:) = dl_u2(:,:)*dl_fct
  dl_v2(:,:) = dl_v2(:,:)*dl_fct 
  dl_uv(:,:) = dl_uv(:,:)*dl_fct
  dl_er(:,:) = SQRT(dl_er(:,:)*dl_fct)

  WHERE (tmask(:,:) > 0 )  dl_uv(:,:) = dl_uv(:,:)/SQRT(dl_u2(:,:)*dl_v2(:,:))
  WHERE (tmask(:,:) > 0 )  dl_sn(:,:) = dl_er(:,:)/SQRT(dl_v2(:,:))
  WHERE (tmask(:,:) > 0 )  dl_sg(:,:) = SQRT(dl_u2(:,:)/dl_v2(:,:))

  ! some print on standard output
  PRINT *,'MIN MAX RMS          ', MINVAL(dl_er), MAXVAL(dl_er)
  PRINT *,'MIN MAX CORREL       ', MINVAL(dl_uv), MAXVAL(dl_uv)
  PRINT *,'MIN MAX SIGNAL/NOISE ', MINVAL(dl_sn), MAXVAL(dl_sn)
  PRINT *,'MIN MAX SIGNAL RATIO ', MINVAL(dl_sg), MAXVAL(dl_sg)

  ! output on NC file
  ierr = putvar(ncout, id_varout(1), REAL(dl_er), 1, npiglo, npjglo)
  ierr = putvar(ncout, id_varout(2), REAL(dl_uv), 1, npiglo, npjglo)
  ierr = putvar(ncout, id_varout(3), REAL(dl_sn), 1, npiglo, npjglo)
  ierr = putvar(ncout, id_varout(4), REAL(dl_sg), 1, npiglo, npjglo)

  ierr      = closeout(ncout             )

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    ! prepare output file 
    !   common features to all variables
    ipk    (:)                   = 1
    stypvar(:)%conline_operation = 'N/A'
    stypvar(:)%caxis             = 'TYX'

    !   specific features
    stypvar(1)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(1)%cname             = 'rms'
    stypvar(1)%cunits            = 'm'
    stypvar(1)%rmissing_value    = 0.
    stypvar(1)%valid_min         = 0.
    stypvar(1)%valid_max         = 100.
    stypvar(1)%clong_name        = 'RMS_'//TRIM(cv_name1)//'_'//TRIM(cv_name2)//'_'//cy
    stypvar(1)%cshort_name       = 'rms'

    stypvar(2)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(2)%cname             = 'correl'
    stypvar(2)%cunits            = 'ndim'
    stypvar(2)%rmissing_value    = 0.
    stypvar(2)%valid_min         = -1.
    stypvar(2)%valid_max         = 1.
    stypvar(2)%clong_name        = 'CORREL_'//TRIM(cv_name1)//'_'//TRIM(cv_name2)//'_'//cy
    stypvar(2)%cshort_name       = 'correl'

    stypvar(3)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(3)%cname             = 'rrat'
    stypvar(3)%cunits            = 'N/A'
    stypvar(3)%rmissing_value    = 0.
    stypvar(3)%valid_min         = 0.
    stypvar(3)%valid_max         = 100.
    stypvar(3)%clong_name        = 'RMS/signal_'//TRIM(cv_name1)//'_'//TRIM(cv_name2)//'_'//cy
    stypvar(3)%cshort_name       = 'rrat'

    stypvar(4)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(4)%cname             = 'srat'
    stypvar(4)%cunits            = 'N/A'
    stypvar(4)%rmissing_value    = 0.
    stypvar(4)%valid_min         = 0.
    stypvar(4)%valid_max         = 100.
    stypvar(4)%clong_name        = 'sdvm/sdvo_'//TRIM(cv_name1)//'_'//TRIM(cv_name2)//'_'//cy
    stypvar(4)%cshort_name       = 'srat'

    PRINT *,' creating output file'
    ncout = create   (cf_out, cf_in,   npiglo, npjglo, npk                              , ld_nc4=lnc4)
    ierr  = createvar(ncout,  stypvar, jpvar,  ipk,    id_varout, cdglobal=TRIM(cglobal), ld_nc4=lnc4)
    ierr  = putheadervar(ncout,  cf_in, npiglo, npjglo, npk, ld_xycoo=.TRUE. )

    dtim = 1.d0
    ierr = putvar1d(ncout,dtim,1,'T')

  END SUBROUTINE CreateOutput

END PROGRAM cdfstats

PROGRAM cdfnrjcomp
  !!======================================================================
  !!                     ***  PROGRAM  cdfnrjcomp  ***
  !!=====================================================================
  !!  ** Purpose : Compute the terms for energy components
  !!               (Mean Kinetic Energy, Eddy Kinetic Energy,
  !!                Mean Potential Energy, Eddy Potential Energy )
  !!               compute : tbar, ubar, vbar, anotsqrt, anousqrt, anovsqrt
  !!
  !! History : 2.1  : 02/2008  : A. Melet     : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                            :: ji, jj, jk           ! dummy loop index
  INTEGER(KIND=4)                            :: npiglo, npjglo       ! domain size
  INTEGER(KIND=4)                            :: npk, npt             ! domain size
  INTEGER(KIND=4)                            :: narg, iargc          ! browse line
  INTEGER(KIND=4)                            :: ierr                 ! error status
  INTEGER(KIND=4)                            :: ncout                ! ncid of output file
  INTEGER(KIND=4), DIMENSION(6)              :: ipk, id_varout       ! level and varid's of output var

  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE  :: un, vn, u2n, v2n
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE  :: tn, t2n, anotsqrt
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE  :: umask, vmask
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE  :: anousqrt, anovsqrt 
  REAL(KIND=4), DIMENSION(1)                 :: tim                   ! time counter

  CHARACTER(LEN=256)                         :: cf_in                 ! input filename
  CHARACTER(LEN=256)                         :: cf_out='nrjcomp.nc'   ! output file name
  TYPE (variable), DIMENSION(6)              :: stypvar               ! structure for attibutes
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()
  !!
  narg = iargc()
  IF ( narg /= 1 ) THEN
     PRINT *,' usage : cdfnrjcomp IN-file'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute contributing terms of the energy equation at T-points.'
     PRINT *,'       Input file contains mean values processed by cdfmoyuvwt.' 
     PRINT *,'       The means must have been computed on long enough period'
     PRINT *,'       for the statistics to be meaningful'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       IN-file   : netcdf file produced by cdfmoyuvwt.' 
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       none'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         all variables are located at T point.'
     PRINT *,'         variables : tbar : mean temperature '
     PRINT *,'                     ubar : mean zonal velocity'
     PRINT *,'                     vbar : mean meridional velocity'
     PRINT *,'                     anotsqrt : mean squared temperature anomaly'
     PRINT *,'                     anousqrt : mean squared zonal velocity anomaly'
     PRINT *,'                     anovsqrt : mean squared meridional velocity anomaly'
     STOP
  ENDIF

  CALL getarg(1, cf_in)

  IF ( chkfile(cf_in) ) STOP ! missing file

  npiglo = getdim(cf_in,cn_x)
  npjglo = getdim(cf_in,cn_y)
  npk    = getdim(cf_in,cn_z)
  npt    = getdim(cf_in,cn_t)

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt
 
  ! define new variables for output 
  ipk(:)                 = npk  
  stypvar(1)%cname       = 'tbar'
  stypvar(1)%clong_name  = 'temporal mean of the temperature on T point'
  stypvar(1)%cshort_name = 'tbar'

  stypvar(2)%cname       = 'ubar'
  stypvar(2)%clong_name  = 'temporal mean of the zonal velocity on T point'
  stypvar(2)%cshort_name = 'ubar'
 
  stypvar(3)%cname       = 'vbar'
  stypvar(3)%clong_name  = 'temporal mean of the meridional velocity on T point'
  stypvar(3)%cshort_name = 'vbar'
  
  stypvar(4)%cname       = 'anotsqrt'
  stypvar(4)%clong_name  = 'temporal mean of the square of the temperature anomaly on T point (*1000)'
  stypvar(4)%cshort_name = 'anotsqrt'

  stypvar(5)%cname       = 'anousqrt'
  stypvar(5)%clong_name  = 'temporal mean of the square of the zonal speed anomaly on T point (*1000)'
  stypvar(5)%cshort_name = 'anousqrt'

  stypvar(6)%cname       = 'anovsqrt'
  stypvar(6)%clong_name  = 'temporal mean of the square of the meridional speed anomaly on T point (*1000)'
  stypvar(6)%cshort_name = 'anovsqrt'

  stypvar%cunits            = ' '
  stypvar%rmissing_value    = 0.
  stypvar%valid_min         = -1000.
  stypvar%valid_max         = 1000.
  stypvar%conline_operation = 'N/A'
  stypvar%caxis             = 'TZYX'
  
  ! create output fileset
  ncout = create      (cf_out, cf_in,   npiglo, npjglo, npk       )
  ierr  = createvar   (ncout,  stypvar, 6,      ipk,    id_varout )
  ierr  = putheadervar(ncout,  cf_in,   npiglo, npjglo, npk       )

  ! Allocate the memory
  ALLOCATE ( un(npiglo,npjglo), vn(npiglo,npjglo)  )
  ALLOCATE ( umask(npiglo,npjglo), vmask(npiglo,npjglo) )
  ALLOCATE ( u2n(npiglo,npjglo), v2n(npiglo,npjglo)  )
  ALLOCATE ( anousqrt(npiglo,npjglo), anovsqrt(npiglo,npjglo)  )
  ALLOCATE ( tn(npiglo,npjglo), t2n(npiglo,npjglo)  )
  ALLOCATE ( anotsqrt(npiglo,npjglo) )

  tim  = getvar1d(cf_in,cn_vtimec, npt     )
  ierr = putvar1d(ncout, tim,      npt, 'T')
     
  DO jk=1, npk
     PRINT *,'            level ',jk
     anousqrt(:,:) = 0.0
     anovsqrt(:,:) = 0.0      
     anotsqrt(:,:) = 0.0
     
     un(:,:)  = getvar(cf_in, 'ubar',  jk, npiglo, npjglo, ktime=1)
     vn(:,:)  = getvar(cf_in, 'vbar',  jk, npiglo, npjglo, ktime=1)
     u2n(:,:) = getvar(cf_in, 'u2bar', jk, npiglo, npjglo, ktime=1)
     v2n(:,:) = getvar(cf_in, 'v2bar', jk, npiglo, npjglo, ktime=1)
     tn(:,:)  = getvar(cf_in, 'tbar',  jk, npiglo, npjglo, ktime=1)
     t2n(:,:) = getvar(cf_in, 't2bar', jk, npiglo, npjglo, ktime=1)

     ! compute the mask
     DO jj = 2, npjglo
        DO ji = 2, npiglo
           umask(ji,jj) = 0.
           vmask(ji,jj) = 0.
           umask(ji,jj) = un(ji,jj)*un(ji-1,jj) 
           vmask(ji,jj) = vn(ji,jj)*vn(ji,jj-1)
           IF (umask(ji,jj) /= 0.) umask(ji,jj)=1.
           IF (vmask(ji,jj) /= 0.) vmask(ji,jj)=1.
        ENDDO
     ENDDO

     DO jj = 2, npjglo  
        DO ji = 2, npiglo    ! vector opt.
           anotsqrt(ji,jj) = 1000. * ( t2n(ji,jj) - tn(ji,jj) * tn(ji,jj) )
           anousqrt(ji,jj) = 1000./2. * umask(ji,jj)*( ( u2n(ji,jj) - un(ji,jj)*un(ji,jj) ) &
                &                     + ( u2n(ji-1,jj) - un(ji-1,jj)*un(ji-1,jj) ) )       
                
           anovsqrt(ji,jj) = 1000./2. * vmask(ji,jj)*( ( v2n(ji,jj) - vn(ji,jj)*vn(ji,jj) ) &
                &                     + ( v2n(ji,jj-1) - vn(ji,jj)*vn(ji,jj-1) ) ) 
        END DO
     END DO
     ! 
     ierr = putvar(ncout, id_varout(1), tn,       jk, npiglo, npjglo, ktime=1)
     ierr = putvar(ncout, id_varout(2), un,       jk, npiglo, npjglo, ktime=1)
     ierr = putvar(ncout, id_varout(3), vn,       jk, npiglo, npjglo, ktime=1)
     ierr = putvar(ncout, id_varout(4), anotsqrt, jk, npiglo, npjglo, ktime=1)
     ierr = putvar(ncout, id_varout(5), anousqrt, jk, npiglo, npjglo, ktime=1) 
     ierr = putvar(ncout, id_varout(6), anovsqrt, jk, npiglo, npjglo, ktime=1)
  END DO

  ierr = closeout(ncout)

END PROGRAM cdfnrjcomp

PROGRAM cdfenstat
  !!======================================================================
  !!                     ***  PROGRAM  cdfenstat  ***
  !!=====================================================================
  !!  ** Purpose : Compute mean values standard dev for all the variables 
  !!               in a bunch of cdf files given as arguments (ensemble)
  !!               Store the results on a 'similar' cdf file (same number
  !!               of time frame) with same variables + stdev_variable
  !!
  !!  ** Method  : Use optimize algorithm for better accuracy
  !!               variables belonging to cn_sqdvar(:), than can be changed 
  !!               in the nam_cdf_names namelist if wished.
  !!
  !!  ** Reference : Accuracy of floating point arithmetic.
  !!
  !! History  3.0  : 07/2015  : J.M. Molines : from cdfmoyt
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  !!   routines      : description
  !!----------------------------------------------------------------------
  USE cdfio 
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id: cdfenstat.f90 550 2011-09-19 16:07:45Z molines $
  !! Copyright (c) 2010, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!-----------------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                               :: jk, jfil, jrec, jv! dummy loop index
  INTEGER(KIND=4)                               :: ierr               ! working integer
  INTEGER(KIND=4)                               :: inpt               ! working integer
  INTEGER(KIND=4)                               :: narg, iargc, ijarg ! browsing command line
  INTEGER(KIND=4)                               :: nfil               ! number of files to average
  INTEGER(KIND=4)                               :: npiglo, npjglo     ! size of the domain
  INTEGER(KIND=4)                               :: npk, npt           ! size of the domain
  INTEGER(KIND=4)                               :: nvars              ! number of variables in a file
  INTEGER(KIND=4)                               :: ncout              ! ncid of output files
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: id_var             ! arrays of var id's
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: ipk                ! arrays of vertical level for each var
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: id_varout          ! varid's of average vars

  REAL(KIND=4), DIMENSION(:,:,:),   ALLOCATABLE :: v3d                ! array to read a layer of data for all files
  REAL(KIND=4), DIMENSION(:,:,:,:), ALLOCATABLE :: v4d                ! array to read a layer of data for all files
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: tim                ! time counter
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: zspval_in          ! input missing value

  REAL(KIND=8), DIMENSION(:,:,:),     ALLOCATABLE :: dtabn, dtab2n      ! arrays for cumulated values
  REAL(KIND=8), DIMENSION(:,:,:),     ALLOCATABLE :: dtabb, dtab2b      ! arrays for cumulated values
  REAL(KIND=8), DIMENSION(:,:,:),     ALLOCATABLE :: dtmp               ! temporary array
  REAL(KIND=8), DIMENSION(:,:,:,:),   ALLOCATABLE :: d4tabn, d4tab2n    ! arrays for cumulated values
  REAL(KIND=8), DIMENSION(:,:,:,:),   ALLOCATABLE :: d4tabb, d4tab2b    ! arrays for cumulated values
  REAL(KIND=8), DIMENSION(:,:,:,:),   ALLOCATABLE :: d4tmp               ! temporary array
  REAL(KIND=8), DIMENSION(:),       ALLOCATABLE :: dtotal_time        ! to compute mean time

  CHARACTER(LEN=256)                            :: cf_in              ! input file names
  CHARACTER(LEN=256)                            :: cf_out  = 'cdfmoy.nc'  ! output file for average
  CHARACTER(LEN=256)                            :: cv_dep             ! depth dimension name
  CHARACTER(LEN=256)                            :: cldum              ! dummy string argument
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cf_list            ! list of input files
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_nam             ! array of var name

  TYPE (variable), DIMENSION(:),    ALLOCATABLE :: stypvar            ! attributes for average values

  LOGICAL                                       :: lspval0 = .FALSE.  ! cdfmoy_chsp flag
  LOGICAL                                       :: lnc4    = .FALSE.  ! flag for netcdf4 chinking and deflation
  LOGICAL                                       :: lv4d    = .FALSE.  ! flag for netcdf4 chinking and deflation
  !!----------------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfenstat list_of_model_files [-spval0] [-nc4] [-v4d] -o OUT-file]'
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the time average of a list of files given as arguments.' 
     PRINT *,'       This program handle multi time-frame files is such a way that'
     PRINT *,'       the output files are also multi time-frame, each frame being'
     PRINT *,'       the average across the files given in the list.'
     PRINT *,'       '
     PRINT *,'       The program assume that all files in the list are of same'
     PRINT *,'       type (shape, variables , and number of time frames ). '
     PRINT *,'       For some variables, the program also compute the time average '
     PRINT *,'       of the squared variables, which is used in other cdftools '
     PRINT *,'       (cdfeke, cdfrmsssh, cdfstdevw, cdfstddevts ... The actual variables'
     PRINT *,'       selected for squared average are :'
     PRINT '(10x,"- ",a)' , (TRIM(cn_sqdvar(jv)), jv=1, nn_sqdvar)
     PRINT *,'       This selection can be adapted with the nam_cdf_namelist process.'
     PRINT *,'       (See cdfnamelist -i for details).'
     PRINT *,'       If you want to compute the average of already averaged files,'
     PRINT *,'       consider using cdfmoy_weighted instead, in order to take into'
     PRINT *,'       account a particular weight for each file in the list.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       A list of similar model output files. '
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [ -spval0 ] :  set missing_value attribute to 0 for all output'
     PRINT *,'               variables and take care of the input missing_value.'
     PRINT *,'               This option is usefull if missing_values differ from files '
     PRINT *,'               to files; it was formely done by cdfmoy_chsp).'
     PRINT *,'       [ -nc4 ] : output file will be in netcdf4, with chunking and deflation'
     PRINT *,'       [ -v4d ] : uses 4D arrays for improved performance (use more memory !)'
     PRINT *,'       [ -o OUT-file ] : specify a name for output file instead of '//TRIM(cf_out)
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       none '
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out), 'unless -o option in use'
     PRINT *,'       variables : are the same than in the input files. Standard Dev are '
     PRINT *,'        named  stdev_<variable>'
     STOP
  ENDIF

  ALLOCATE ( cf_list(narg) )
  ! look for -spval0 option and set up cf_list, nfil 
  ijarg = 1 
  nfil = 0
  DO WHILE ( ijarg <= narg )
     CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1
     SELECT CASE ( cldum )
     CASE ( '-spval0' )   ! option to reset spval to 0 in the output files
        lspval0 = .TRUE.
     CASE ( '-nc4   ' )   ! option to reset spval to 0 in the output files
        lnc4 = .TRUE.
     CASE ( '-v4d  '  )   ! option to reset spval to 0 in the output files
        lv4d = .TRUE.
     CASE ( '-o   ' )   ! option to reset spval to 0 in the output files
        CALL getarg (ijarg, cf_out) ; ijarg = ijarg + 1
     CASE DEFAULT         ! then the argument is a file
        nfil          = nfil + 1
        cf_list(nfil) = TRIM(cldum)
     END SELECT
  END DO
  ! Initialisation from  1rst file (all file are assume to have the same geometry)
  ! time counter can be different for each file in the list. It is read in the
  ! loop for files
  IF ( chkfile (cf_list(1)) ) STOP 99 ! missing file

  cf_in  = cf_list(1)
  npiglo = getdim (cf_in,cn_x)
  npjglo = getdim (cf_in,cn_y)
  npk    = getdim (cf_in,cn_z, cdtrue=cv_dep, kstatus=ierr)
  npt    = getdim (cf_in,cn_t)

  IF (ierr /= 0 ) THEN
     npk   = getdim (cf_in,'z',cdtrue=cv_dep,kstatus=ierr)
     IF (ierr /= 0 ) THEN
        npk   = getdim (cf_in,'sigma',cdtrue=cv_dep,kstatus=ierr)
        IF ( ierr /= 0 ) THEN 
           npk = getdim (cf_in,'nav_lev',cdtrue=cv_dep,kstatus=ierr)
           IF ( ierr /= 0 ) THEN 
              npk = getdim (cf_in,'levels',cdtrue=cv_dep,kstatus=ierr)
              IF ( ierr /= 0 ) THEN 
                 PRINT *,' assume file with no depth'
                 npk=0
              ENDIF
           ENDIF
        ENDIF
     ENDIF
  ENDIF

  ! check that all files have the same number of time frames
  ierr = 0
  DO jfil = 1, nfil
     IF (  chkfile (cf_list(jfil)      ) ) STOP 99 ! missing file
     inpt = getdim (cf_list(jfil), cn_t)
     IF ( inpt /= npt ) THEN
        PRINT *, 'File ',TRIM(cf_list(jfil) ),' has ',inpt,' time frames instead of ', npt
        ierr = ierr + 1
     ENDIF
  ENDDO
  IF ( ierr /= 0 ) STOP 99 ! frame numbers mismatch

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  IF ( .NOT. lv4d ) THEN 
  ALLOCATE( v3d(npiglo,npjglo,npt) )
  ALLOCATE( dtabn(npiglo,npjglo,npt), dtab2n(npiglo,npjglo,npt)) 
  ALLOCATE( dtabb(npiglo,npjglo,npt), dtab2b(npiglo,npjglo,npt), dtmp(npiglo,npjglo,npt))
  ENDIF

  ALLOCATE( dtotal_time(npt), tim(npt) )

  nvars = getnvar(cf_in)
  PRINT *,' nvars = ', nvars

  ALLOCATE (cv_nam(2*nvars) )
  ALLOCATE (stypvar(2*nvars))
  ALLOCATE (id_var(2*nvars), ipk(2*nvars), id_varout(2*nvars)  )

  ! get list of variable names and collect attributes in stypvar (optional)
  cv_nam(1:nvars) = getvarname(cf_in,nvars, stypvar)
  DO jv =1, nvars
    cv_nam(jv+nvars) ='stdev_'//TRIM(cv_nam(jv))
  ENDDO
  ! choose chunk size for output ... not easy not used if lnc4=.false. but anyway ..
  DO jv = 1, 2*nvars
     stypvar(jv)%ichunk=(/npiglo,MAX(1,npjglo/30),1,1 /)
  ENDDO


  IF ( lspval0 ) THEN 
     ALLOCATE ( zspval_in(nvars) )
     zspval_in(:) = stypvar(1:nvars)%rmissing_value
     stypvar(:)%rmissing_value = 0.
  ENDIF

  DO jv = 1, nvars
     ! variables that will not be computed or stored are named 'none'
        stypvar(jv+nvars)%cname             = cv_nam(jv+nvars)
        stypvar(jv+nvars)%cunits            = TRIM(stypvar(jv)%cunits)             ! unit
        stypvar(jv+nvars)%rmissing_value    = stypvar(jv)%rmissing_value           ! missing_value
        stypvar(jv+nvars)%valid_min         = 0.                                   ! valid_min = zero
        stypvar(jv+nvars)%valid_max         = stypvar(jv)%valid_max                ! valid_max *valid_max
        stypvar(jv+nvars)%scale_factor      = 1.
        stypvar(jv+nvars)%add_offset        = 0.
        stypvar(jv+nvars)%savelog10         = 0.
        stypvar(jv+nvars)%clong_name        = TRIM(stypvar(jv)%clong_name)//'_Std_Dev'   ! 
        stypvar(jv+nvars)%cshort_name       = cv_nam(jv+nvars)
        stypvar(jv+nvars)%conline_operation = TRIM(stypvar(jv)%conline_operation) 
        stypvar(jv+nvars)%caxis             = TRIM(stypvar(jv)%caxis) 
  END DO

  id_var(:)  = (/(jv, jv=1,2*nvars)/)
  ! ipk gives the number of level or 0 if not a T[Z]YX  variable
  ipk(1:nvars)  = getipk (cf_in,nvars,cdep=cv_dep)
  ipk(nvars+1:2*nvars) = ipk(1:nvars)
  WHERE( ipk == 0 ) cv_nam='none'
  stypvar( :)%cname = cv_nam

  ! create output file taking the sizes in cf_in
  ncout  = create      (cf_out,  cf_in,     npiglo, npjglo, npk, cdep=cv_dep, ld_nc4=lnc4)
  ierr   = createvar   (ncout ,  stypvar,  2*nvars,  ipk,   id_varout       , ld_nc4=lnc4)
  ierr   = putheadervar(ncout,   cf_in,    npiglo, npjglo, npk, cdep=cv_dep)

  ! Compute the mean time for each mean frame
  dtotal_time(:) = 0.d0
  DO jfil = 1, nfil 
     cf_in          = cf_list(jfil)
     tim(:)         = getvar1d(cf_in, cn_vtimec, npt)
     dtotal_time(:) = dtotal_time(:) + tim (:)
  END DO
  tim(:) = dtotal_time(:)/ nfil
  ierr   = putvar1d(ncout,  tim, npt, 'T')


     DO jv = 1,nvars
        IF ( cv_nam(jv) == cn_vlon2d .OR. &     ! nav_lon
           & cv_nam(jv) == cn_vlat2d .OR. &
           & cv_nam(jv) == 'none'    ) THEN     ! nav_lat
           ! skip these variable
        ELSE
           PRINT *,' Working with ', TRIM(cv_nam(jv)), ipk(jv)
           IF ( lv4d) THEN
             ALLOCATE( v4d(npiglo,npjglo,ipk(jv),npt) )
             ALLOCATE( d4tabn(npiglo,npjglo,ipk(jv),npt), d4tab2n(npiglo,npjglo,ipk(jv),npt) ) 
             ALLOCATE( d4tabb(npiglo,npjglo,ipk(jv),npt), d4tab2b(npiglo,npjglo,ipk(jv),npt), d4tmp(npiglo,npjglo,ipk(jv),npt))

              DO jfil = 1, nfil
                 cf_in     = cf_list(jfil)
                 v4d(:,:,:,:)  = getvar4d(cf_in, cv_nam(jv), npiglo, npjglo, ipk(jv), npt )
                 IF ( jfil == 1 ) THEN
                    d4tabb(:,:,:,:)=v4d(:,:,:,:) ; d4tab2b(:,:,:,:)=0.d0
                    CYCLE
                 ENDIF
                 IF ( lspval0 )  WHERE ( v4d == zspval_in(jv) )  v4d = 0.  ! change missing values to 0
                 d4tmp(:,:,:,:)   = v4d(:,:,:,:) - d4tabb(:,:,:,:)
                 d4tabn(:,:,:,:)  = d4tabb(:,:,:,:)  + d4tmp(:,:,:,:) / jfil
                 d4tab2n(:,:,:,:) = d4tab2b(:,:,:,:) + d4tmp(:,:,:,:) * ( v4d(:,:,:,:) - d4tabn(:,:,:,:) )
                 ! swap tabs
                 d4tabb(:,:,:,:)  = d4tabn(:,:,:,:)
                 d4tab2b(:,:,:,:) = d4tab2n(:,:,:,:)
              END DO

              ! store variable on outputfile
              DO jrec = 1, npt
                DO jk=1, ipk(jv)
                ierr = putvar(ncout, id_varout(jv),       SNGL(d4tabn(:,:,jk,jrec)),                 jk, npiglo, npjglo, kwght=nfil, ktime = jrec )
                ierr = putvar(ncout, id_varout(jv+nvars), SQRT(SNGL(d4tab2n(:,:,jk,jrec))/(nfil-1)), jk, npiglo, npjglo, kwght=nfil, ktime = jrec )
                ENDDO
              ENDDO

             ! Deqllocate array for this variable
             DEALLOCATE( v4d, d4tabn, d4tab2n, d4tabb, d4tab2b, d4tmp )
           ELSE
           DO jk = 1, ipk(jv)
              PRINT *,'level ',jk
              DO jfil = 1, nfil
                 cf_in     = cf_list(jfil)
                 v3d(:,:,:)  = getvar3dt(cf_in, cv_nam(jv), jk, npiglo, npjglo, npt )
                 IF ( jfil == 1 ) THEN
                    dtabb(:,:,:)=v3d(:,:,:) ; dtab2b(:,:,:)=0.d0
                    CYCLE
                 ENDIF
                 IF ( lspval0 )  WHERE ( v3d == zspval_in(jv) )  v3d = 0.  ! change missing values to 0
                 dtmp(:,:,:)   = v3d(:,:,:) - dtabb(:,:,:)
                 dtabn(:,:,:)  = dtabb(:,:,:)  + dtmp(:,:,:) / jfil
                 dtab2n(:,:,:) = dtab2b(:,:,:) + dtmp(:,:,:) * ( v3d(:,:,:) - dtabn(:,:,:) )
                 ! swap tabs
                 dtabb(:,:,:)  = dtabn(:,:,:)
                 dtab2b(:,:,:) = dtab2n(:,:,:)
              END DO

              ! store variable on outputfile
              DO jrec = 1, npt
                ierr = putvar(ncout, id_varout(jv),       SNGL(dtabn(:,:,jrec)),                 jk, npiglo, npjglo, kwght=nfil, ktime = jrec )
                ierr = putvar(ncout, id_varout(jv+nvars), SQRT(SNGL(dtab2n(:,:,jrec))/(nfil-1)), jk, npiglo, npjglo, kwght=nfil, ktime = jrec )
              ENDDO
           END DO  ! loop to next level
           ENDIF 

        END IF
     END DO ! loop to next var in file

  ierr = closeout(ncout)

END PROGRAM cdfenstat

PROGRAM cdfspice
  !!======================================================================
  !!                     ***  PROGRAM  cdfspice  ***
  !!=====================================================================
  !!  ** Purpose : Compute spiciness 3D field from gridT file
  !!               Store the results on a 'similar' cdf file.
  !!
  !!  ** Method  :  spiciness = sum(i=0,5)[sum(j=0,4)[b(i,j)*theta^i*(s-35)^j]]
  !!                   with:  b     -> coefficients
  !!                          theta -> potential temperature
  !!                          s     -> salinity
  !!
  !!  **  Example:
  !!       spice(15,33)=   0.5445863      0.544586321373410  calcul en double
  !!       spice(15,33)=   0.5445864      (calcul en simple precision)
  !!
  !!  ** References : Flament (2002) "A state variable for characterizing 
  !!              water masses and their diffusive stability: spiciness."
  !!              Progress in Oceanography Volume 54, 2002, Pages 493-501.
  !!
  !! History : 2.1  : 03/2010  : C.O. Dufour  : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!           3.0  : 06/2013  : J.M. Molines : Transfert spice in eos
  !!                                            Add OMP directive
  !!----------------------------------------------------------------------
  USE cdfio
  USE eos
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: ji, jj, jk, jt     ! dummy loop index
  INTEGER(KIND=4)                           :: ierr               ! error status
  INTEGER(KIND=4)                           :: narg, ijarg, iargc ! browse command line
  INTEGER(KIND=4)                           :: npiglo, npjglo     ! size of the domain
  INTEGER(KIND=4)                           :: npk, npkk, npt     ! size of the domain
  INTEGER(KIND=4)                           :: ncout              ! ncid of output file
  INTEGER(KIND=4), DIMENSION(1)             :: ipk, id_varout     ! level and  varid's

  REAL(KIND=4)                              :: zspval             ! missing value
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: tim                ! time counter
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: ztemp              ! temperature
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zsal               ! salinity
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zmask              ! 2D mask at current level

  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dtempt             ! temperature
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dsalt              ! salinity
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dsalref            ! reference salinity
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dspi               ! spiceness

  CHARACTER(LEN=256)                        :: cf_tfil            ! input filename
  CHARACTER(LEN=256)                        :: cf_out='spice.nc'  ! output file name
  CHARACTER(LEN=256)                        :: cldum              ! dummy characte variable variable
  CHARACTER(LEN=256)                        :: cv_sal             ! salinity name in netcdf
  CHARACTER(LEN=256)                        :: cv_tem             ! temperature name in netcdf

  TYPE (variable), DIMENSION(1)             :: stypvar            ! structure for attributes
  LOGICAL                                   :: lnc4 = .FALSE.     ! flag for missing files

  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfspice -t T-file [-sal SAL-name] [-tem TEM-name] ...'
     PRINT *,'        ... [-nc4] [-o OUT-file]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the spiceness corresponding to temperatures and salinities'
     PRINT *,'       given in the input file.' 
     PRINT *,'      '
     PRINT *,'       spiciness = sum(i=0,5)[sum(j=0,4)[b(i,j)*theta^i*(s-35)^j]]'
     PRINT *,'                 with:  b     -> coefficients'
     PRINT *,'                        theta -> potential temperature'
     PRINT *,'                        s     -> salinity'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -t T-file : netcdf file with temperature and salinity (gridT)' 
     PRINT *,'           Single argument T-file can also be used, for backward compatibility'
     PRINT *,'     '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-sal SAL-name]  : name of salinity variable'
     PRINT *,'       [-tem TEM-name]  : name of temperature variable'
     PRINT *,'       [-nc4]  : enable chunking and compression'
     PRINT *,'       [-o OUT-file]    : specify output filename instead of ',TRIM(cf_out)
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       none'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : vospice'
     PRINT *,'      '
     PRINT *,'     REFERENCE :'
     PRINT *,'       Flament (2002) "A state variable for characterizing '
     PRINT *,'             water masses and their diffusive stability: spiciness."'
     PRINT *,'             Progress in Oceanography Volume 54, 2002, Pages 493-501.'
     STOP
  ENDIF

  ijarg=1
  cv_sal=cn_vosaline
  cv_tem=cn_votemper
  DO WHILE ( ijarg <= narg )
     CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-t'   ) ; CALL getarg(ijarg, cf_tfil) ; ijarg=ijarg+1
     CASE ( '-o'   ) ; CALL getarg(ijarg, cf_out ) ; ijarg=ijarg+1
     CASE ( '-sal' ) ; CALL getarg(ijarg, cv_sal ) ; ijarg=ijarg+1
     CASE ( '-tem' ) ; CALL getarg(ijarg, cv_tem ) ; ijarg=ijarg+1
     CASE ( '-nc4' ) ; lnc4 = .TRUE.
     CASE DEFAULT
      IF ( narg == 1 ) THEN
         cf_tfil = cldum
      ELSE
         PRINT *,' option ',TRIM(cldum),' not understood'
         STOP 99
      ENDIF
     END SELECT
  ENDDO

  IF ( chkfile(cf_tfil) ) STOP 99 ! missing files

  npiglo = getdim (cf_tfil,cn_x)
  npjglo = getdim (cf_tfil,cn_y)
  npk    = getdim (cf_tfil,cn_z)
  npt    = getdim (cf_tfil,cn_t)

  npkk=npk
  IF ( npk == 0 ) npkk=1

  ipk(:)                       = npkk
  stypvar(1)%cname             = 'vospice'
  stypvar(1)%cunits            = 'kg/m3'
  stypvar(1)%rmissing_value    = 0.
  stypvar(1)%valid_min         = -300.
  stypvar(1)%valid_max         = 300.
  stypvar(1)%clong_name        = 'spiciness'
  stypvar(1)%cshort_name       = 'vospice'
  stypvar(1)%conline_operation = 'N/A'
  stypvar(1)%caxis             = 'TZYX'
  stypvar(1)%ichunk            = (/npiglo, MAX(1,npjglo/30), 1, 1 /)

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  ALLOCATE (ztemp(npiglo,npjglo), zsal (npiglo,npjglo) )
  ALLOCATE (dspi( npiglo,npjglo), zmask(npiglo,npjglo) )
  ALLOCATE (dtempt(npiglo,npjglo), dsalt(npiglo,npjglo))
  ALLOCATE (dsalref(npiglo,npjglo))
  ALLOCATE (tim(npt))

  ! create output fileset
  ncout = create      (cf_out, cf_tfil, npiglo, npjglo, npk,       ld_nc4=lnc4     )
  ierr  = createvar   (ncout,  stypvar, 1,      ipk,    id_varout, ld_nc4=lnc4     )
  ierr  = putheadervar(ncout,  cf_tfil, npiglo, npjglo, npk       )

  tim  = getvar1d(cf_tfil, cn_vtimec, npt     )
  ierr = putvar1d(ncout,   tim,       npt, 'T')

  zspval = getspval( cf_tfil, cn_vosaline )

  ! Compute spiciness
  DO jt=1,npt
     PRINT *,' TIME = ', jt, tim(jt)/86400.,' days'
     DO jk = 1, npkk
        PRINT *, 'Level ', jk
        zmask(:,:) = 1.e0

        ztemp(:,:) = getvar(cf_tfil, cv_tem, jk, npiglo, npjglo, ktime=jt)
        zsal( :,:) = getvar(cf_tfil, cv_sal, jk, npiglo, npjglo, ktime=jt)

        WHERE(zsal == zspval ) zmask = 0.e0
     
        dspi(:,:) = spice ( ztemp, zsal, npiglo, npjglo )
        ierr      = putvar( ncout, id_varout(1), REAL(dspi*zmask), jk, npiglo, npjglo, ktime=jt)

     END DO  ! loop to next level
  END DO  ! next time frame

  ierr = closeout(ncout)

END PROGRAM cdfspice

PROGRAM cdfzoom
  !!======================================================================
  !!                     ***  PROGRAM  cdfzoom  ***
  !!=====================================================================
  !!  ** Purpose : Extract a sub area of a cdf output file and print it 
  !!               on the screen with an easy to read format.
  !!
  !!  ** Method  : specify the variable name and file on the command line
  !!
  !! History : ---  : 1999     : A. de Miranda : Original code in bimgtools
  !! History : 2.1  : 11/2004  : J.M. Molines  : port to CDFTOOLS
  !!           3.0  : 12/2010  : J.M. Molines  : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2010, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE
  !
  INTEGER(KIND=4)                           :: ji, jj, jt             ! dummy loop index
  INTEGER(KIND=4)                           :: narg, iargc, ijarg     ! browse line
  INTEGER(KIND=4)                           :: ni, nj, nk, nt, ndim   ! domain dimension
  INTEGER(KIND=4)                           :: niz, njz, nkz          ! size of zoom
  INTEGER(KIND=4)                           :: iimin, iimax           ! i-limits
  INTEGER(KIND=4)                           :: ijmin, ijmax           ! j-limits
  INTEGER(KIND=4)                           :: ikmin, ikmax           ! k-limits
  INTEGER(KIND=4)                           :: itmin, itmax           ! t-limit
  INTEGER(KIND=4)                           :: ikext, ierr            ! 
  INTEGER(KIND=4)                           :: iipmin, iipmax         ! 
  INTEGER(KIND=4)                           :: ijpmin, ijpmax         !
  !
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: v2d                    ! data array
  REAL(KIND=4)                              :: fact                   ! scaling factor
  !
  CHARACTER(LEN=256)                        :: cldum                  ! summy character variable
  CHARACTER(LEN=256)                        :: cf_in                  ! input file name
  CHARACTER(LEN=256)                        :: cv_in='none'           ! variable name
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfzoom -f file -zoom imin imax jmin jmax  ...'
     PRINT *,'               ... -var cdfvar [-lev kmin kmax ] ...'
     PRINT *,'               ... [ -time tmin tmax ] [ -fact factor] '
     PRINT *,'     PURPOSE :'
     PRINT *,'      Display the numerical values of a zoomed area. By'
     PRINT *,'      default, all times and levels are shown. If the zoomed'
     PRINT *,'      area is degenerated to a single line, then the vertical'
     PRINT *,'      slab is displayed.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -f file : name of input file' 
     PRINT *,'       -zoom imin imax jmin jmax : spatial window definition'
     PRINT *,'       -var cdfvar : cdf variable name to work with.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-lev kmin kmax ]  : vertical limits for display.' 
     PRINT *,'       [-time tmin tmax ] : time limits for display.' 
     PRINT *,'       [-fact factor ]    : use a scaling factor for display.'
     PRINT *,'                            Values are DIVIDED by factor'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        none'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       display on standard output'
     STOP
  ENDIF
  !
  ikext = 1 ; ikmin = 1 ; ikmax = 1 ; itmin = 1 ; itmax = 1
  fact  = 1

  ijarg  = 1
  ! Read command line
  DO  WHILE (ijarg <=  narg)
     CALL getarg(ijarg,cldum) ; ijarg = ijarg + 1
     SELECT CASE ( cldum )
     CASE ( '-f' )
        CALL getarg(ijarg, cf_in) ; ijarg = ijarg + 1
     CASE ( '-lev' )
        CALL getarg(ijarg,cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) ikmin
        CALL getarg(ijarg,cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) ikmax
     CASE ( '-time' )
        CALL getarg(ijarg,cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) itmin
        CALL getarg(ijarg,cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) itmax
     CASE ( '-fact' )
        CALL getarg(ijarg,cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) fact
     CASE ( '-zoom' )
        CALL getarg(ijarg,cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) iimin
        CALL getarg(ijarg,cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) iimax
        CALL getarg(ijarg,cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) ijmin
        CALL getarg(ijarg,cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) ijmax
     CASE ( '-var' )
        CALL getarg(ijarg,cv_in) ; ijarg = ijarg + 1
     CASE DEFAULT
        PRINT *, TRIM(cldum),' : unknown option '
        STOP 99
     END SELECT
  END DO

  IF ( chkfile (cf_in) ) STOP 99 ! missing file
  !
  ni=0 ; nj=0 ; nk=0 ; nt=0 
  niz  = iimax - iimin + 1
  njz  = ijmax - ijmin + 1
  nkz  = ikmax - ikmin + 1
  ikext= ikmin

  IF ( nkz > 1 ) THEN
     !working with vertical slab, either niz or njz must be 1
     IF ( niz == 1  ) THEN ! y/z slab
     ELSE IF ( njz == 1 ) THEN ! x/z slab
     ELSE
        PRINT *, 'Either niz or njz must me  one'
        STOP 99
     ENDIF
  ENDIF

  ni = getdim(cf_in, cn_x, cldum, ierr)
  IF ( ierr == 1 ) THEN 
     ni = getdim(cf_in, 'lon', cldum, ierr)
     IF ( ierr == 1 ) THEN
        PRINT *,' No X or lon dim found ' ; STOP 99
     ENDIF
  ENDIF

  nj = getdim(cf_in, cn_y, cldum, ierr)
  IF ( ierr == 1 ) THEN 
     nj = getdim(cf_in, 'lat', cldum, ierr)
     IF ( ierr == 1 ) THEN
        PRINT *,' No y or lat dim found ' ; STOP 99
     ENDIF
  ENDIF

  nk = getdim(cf_in, cn_z, cldum, ierr)
  IF ( ierr == 1 ) THEN 
     nk = getdim(cf_in, 'z', cldum, ierr)
     IF ( ierr == 1 ) THEN 
        nk = getdim(cf_in, 'lev', cldum, ierr)
        IF ( ierr == 1 ) THEN
           PRINT *,' No dep or z or lev  dim found ' 
        ENDIF
     ENDIF
  ENDIF

  nt = getdim(cf_in, cn_t, cldum, ierr)
  IF ( ierr == 1 ) THEN 
     nt = getdim(cf_in, 'step', cldum, ierr)
     IF ( ierr == 1 ) THEN
        nt = getdim(cf_in, 'time', cldum, ierr)
        IF ( ierr == 1 ) THEN
           nt = getdim(cf_in, 't', cldum, ierr)
           IF ( ierr == 1 ) THEN
             PRINT *,' No time or step dim found ' 
           ENDIF
        ENDIF
     ENDIF
  ENDIF

  IF ( itmax > nt ) THEN 
     PRINT *,' Not enough time steps in this file' 
     STOP 99
  ENDIF

  IF (nk == 0 ) THEN ; nk = 1 ; ikext = 1 ; ENDIF  ! assume a 2D variable
  IF (nt == 0 ) THEN ; nt = 1             ; ENDIF  ! assume a 1 time frame file

  IF ( nkz == 1 ) THEN 
     ALLOCATE ( v2d(niz,njz) )
  ELSE  
     IF ( niz == 1 ) THEN
        ALLOCATE( v2d(njz,nkz))
     ELSE
        ALLOCATE( v2d(niz,nkz))
     ENDIF
  ENDIF

  DO jt = itmin, itmax
     DO   ! for exit statement
        ndim = getvdim(cf_in, cv_in)+1   ! getvdim gives ndim-1 !
        PRINT *,TRIM(cv_in), ndim, ikext
        SELECT CASE (nkz)
        CASE (1)
           iipmin=iimin ; iipmax=iimax; ijpmin=ijmin; ijpmax=ijmax
           SELECT CASE (ndim)
           CASE( 2 )  ! assume x,y variable
              v2d(:,:) = getvar(cf_in, cv_in, 1,     niz, njz, iimin, ijmin, ktime=jt)
              EXIT
           CASE( 3 )  ! assume x,y,t variable
              v2d(:,:) = getvar(cf_in, cv_in, 1,     niz, njz, iimin, ijmin, ktime=jt)
              EXIT
           CASE( 4 )  ! assume x,y,z,t variable
              v2d(:,:) = getvar(cf_in, cv_in, ikext, niz, njz, iimin, ijmin, ktime=jt)
              EXIT
           CASE DEFAULT
              PRINT *,' Non mapable variables x-y :('
              cv_in='none'
           END SELECT

        CASE DEFAULT
           SELECT CASE (ndim)
           CASE( 4 )  ! assume x,y,z,t variable
              IF ( njz == 1 ) THEN
                 iipmin=iimin ; iipmax=iimax; ijpmin=ikmin; ijpmax=ikmax
                 v2d(:,:) = getvarxz(cf_in, cv_in, ijmin, niz, nkz, iimin, ikmin, ktime=jt)
              ELSE
                 iipmin=ijmin ; iipmax=ijmax; ijpmin=ikmin; ijpmax=ikmax
                 v2d(:,:) = getvaryz(cf_in, cv_in, iimin, njz, nkz, ijmin, ikmin, ktime=jt)
              ENDIF
              EXIT
           CASE DEFAULT
              PRINT *,' Non mapable variables x-z or y-z :('
              cv_in='none'
           END SELECT

        END SELECT ! nkz
     ENDDO

     PRINT *,'IMIN IMAX JMIN JMAX KMIN KMAX TIME', iimin,iimax,ijmin,ijmax,ikmin,ikmax, jt
     PRINT 9001,'      ',(ji,ji=iipmin,iipmax)
     IF (nkz == 1 ) THEN
        DO jj=ijpmax,ijpmin,-1
           PRINT 9000,jj,'  ',(v2d(ji-iipmin+1,jj-ijpmin+1)/fact,ji=iipmin,iipmax)
        END DO
     ELSE
        DO jj=ijpmin,ijpmax
           PRINT 9000,jj,'  ',(v2d(ji-iipmin+1,jj-ijpmin+1)/fact,ji=iipmin,iipmax)
        END DO
     ENDIF
  ENDDO
9000 FORMAT(i4,a,20f12.4)
9001 FORMAT(a,20i12)

END PROGRAM cdfzoom

PROGRAM cdfthic
  !!======================================================================
  !!                      ***  PROGRAM  cdfthic   ***
  !!======================================================================
  !!  ** Purpose : Compute water column thickness on either T, U, or V grid.
  !!               Handle time-varying thickness either using the -vvl option
  !!               (i.e. using time-varying e3[tuv]), or using the -ssh option
  !!               (i.e. using constant e3[tuv] and varying ssh).
  !!               Handle full step configuration using the -full option.
  !!
  !!  ** Method  : Compute the vertical sum of e3[tuv]*[tuv]mask 
  !!                 (+ssh if used with the -ssh option)
  !!
  !!               Based on cdfvertmean routine
  !!
  !! History : 0.1  : 09/2017  : N. Jourdain
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  USE modutils
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class integration
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                            :: jk, jvar, jvarin, jt ! dummy loop index
  INTEGER(KIND=4)                            :: it                   ! time index for vvl
  INTEGER(KIND=4)                            :: ierr, iko            ! working integer
  INTEGER(KIND=4)                            :: narg, iargc, ijarg   ! command line 
  INTEGER(KIND=4)                            :: npiglo, npjglo       ! size of the domain
  INTEGER(KIND=4)                            :: npk, npt             ! size of the domain
  INTEGER(KIND=4)                            :: ncout                ! ID for netcdf file
  INTEGER(KIND=4)                            :: nvout=1              ! number of output variables
  INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE :: ipk, id_varout       ! levels and varid's of output vars

  REAL(KIND=4), PARAMETER                    :: ppspval= 9999.99     ! missing value
  REAL(KIND=4), PARAMETER                    :: pp_eps=1.e-9         ! epsilon
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE  :: e3_1d                ! vertical metrics in case of full step
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE  :: e3, ssh              ! vertical metric
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE  :: area1, area2, ztmp   ! used to interpolate ssh
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE  :: tmask                ! npiglo x npjglo

  REAL(KIND=8), DIMENSION(:),   ALLOCATABLE  :: dtim                 ! time counter
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE  :: dl_vint1             ! verticall int quantity         

  CHARACTER(LEN=1)                           :: cgrid='x'            ! grid used for thickness computation
  CHARACTER(LEN=256)                         :: cf_in, cn_fe3, cn_ve3! input file and variable
  CHARACTER(LEN=256)                         :: cf_out='thic.nc'     ! output file 
  CHARACTER(LEN=256)                         :: cldum                ! dummy string for command line browsing

  LOGICAL                                    :: lfull  =.FALSE.      ! flag for full step computation
  LOGICAL                                    :: lchk   =.FALSE.      ! flag for missing files
  LOGICAL                                    :: lssh   =.FALSE.      ! flag for using ssh for top layer thickness

  TYPE(variable), DIMENSION(:), ALLOCATABLE  :: stypvar              ! extension for attributes
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfthic [-vvl <file>] [-ssh <file>] [-full]'
     PRINT *,'                 [-T] [-U] [-V] [-o <OUT-file>]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the water column thickness at T, U, or V points.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'        (default)    : partial step computation (constant grid metrics)'
     PRINT *,'        -full        : full step computation (constant grid metrics)' 
     PRINT *,'        -vvl <file>  : directly use time-varying vertical metrics in <file>'
     PRINT *,'        -ssh <file>  : use time-varying ssh and initial grid properties' 
     PRINT *,'        -T -U -V     : grid computation (specify one of them)'
     PRINT *,'        -o OUT-file  : use specified output file instead of ', TRIM(cf_out)
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'      ', TRIM(cn_fzgr),', and ',TRIM(cn_fhgr),', and ',TRIM(cn_fmsk)
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file :  thic.nc (or specified with -o option)'
     PRINT *,'         variables :  thic_T, thic_U, or thic_V (according to grid)'
     PRINT *,'                      ssh_U or ssh_V (if -ssh option with U or V grids)'
     PRINT *,'      '
     STOP 
  ENDIF

  ! browse command line
  ijarg = 1   
  DO WHILE ( ijarg <= narg ) 
     CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1
     SELECT CASE ( cldum)
     CASE ( '-vvl'  ) ; CALL getarg (ijarg, cf_in    ) ; lg_vvl = .TRUE. ; ijarg = ijarg + 1
     CASE ( '-ssh'  ) ; CALL getarg (ijarg, cf_in    ) ; lssh   = .TRUE. ; ijarg = ijarg + 1
     CASE ( '-full' ) ; lfull  = .TRUE. 
     CASE ( '-T'    ) ; cgrid  = 'T'
     CASE ( '-U'    ) ; cgrid  = 'U'
     CASE ( '-V'    ) ; cgrid  = 'V'
     CASE ( '-o'    ) ; CALL getarg (ijarg, cf_out   ) ; ijarg = ijarg + 1
     CASE DEFAULT     ; PRINT *,' ERROR : ',TRIM(cldum),' : unknown options.' ; STOP 90
     END SELECT
  END DO

  ijarg = 0
  IF ( lg_vvl ) ijarg = ijarg + 1
  IF ( lssh   ) ijarg = ijarg + 1
  IF ( lfull  ) ijarg = ijarg + 1
  IF ( ijarg .GT. 1 ) THEN
   PRINT *,' ERROR : choose no more than one option among -vvl -ssh -full'
   STOP 91
  ENDIF

  IF ( lg_vvl ) THEN
    cn_fe3 = cf_in
    SELECT CASE (cgrid)
      CASE ('T')   ; cn_ve3 = cn_ve3tvvl
      CASE ('U')   ; cn_ve3 = cn_ve3uvvl
      CASE ('V')   ; cn_ve3 = cn_ve3vvvl
      CASE DEFAULT ; PRINT *,' ERROR : You need to choose one option among -T, -U and -V' ; STOP 92
    END SELECT
  ELSE
    SELECT CASE (cgrid)
      CASE ('T')   ; cn_fe3 = cn_fe3t ; cn_ve3 = cn_ve3t
      CASE ('U')   ; cn_fe3 = cn_fe3u ; cn_ve3 = cn_ve3u
      CASE ('V')   ; cn_fe3 = cn_fe3v ; cn_ve3 = cn_ve3v
      CASE DEFAULT ; PRINT *,' ERROR : You need to choose one option among -T, -U and -V' ; STOP 93
    END SELECT
  ENDIF

  ! Security check
  lchk = chkfile ( cn_fe3  )
  lchk = chkfile ( cn_fzgr ) .OR. lchk
  lchk = chkfile ( cn_fhgr ) .OR. lchk
  lchk = chkfile ( cn_fmsk ) .OR. lchk
  IF ( lchk ) STOP 94 ! missing files

  IF ( lssh .AND. cgrid .NE. 'T' ) nvout=2
  ALLOCATE (stypvar(nvout), ipk(nvout), id_varout(nvout))

  ! log information so far
  PRINT *,' OUTPUT FILE     : ' , TRIM(cf_out)

  npiglo = getdim (cf_in, cn_x )
  npjglo = getdim (cf_in, cn_y )
  npk    = getdim (cf_in, cn_z )
  npt    = getdim (cf_in, cn_t )

  PRINT *, ' NPIGLO = ', npiglo
  PRINT *, ' NPJGLO = ', npjglo
  PRINT *, ' NPK    = ', npk
  PRINT *, ' NPT    = ', npt

  ! Allocate arrays
  ALLOCATE (     dtim( npt                  ) )
  ALLOCATE (    tmask(        npiglo,npjglo ) )
  ALLOCATE (       e3(        npiglo,npjglo ) )
  ALLOCATE ( dl_vint1(        npiglo,npjglo ) )
  IF ( lssh .AND. cgrid .NE. 'T' ) THEN
    ALLOCATE (  area1(        npiglo,npjglo ) )
    ALLOCATE (  area2(        npiglo,npjglo ) )
    ALLOCATE (   ztmp(        npiglo,npjglo ) )
  ENDIF
  IF ( lssh  ) ALLOCATE ( ssh(npiglo,npjglo ) )
  IF ( lfull ) ALLOCATE ( e3_1d( npk ) )

  ! Read vertical axis in full-step-case
  IF ( lfull ) e3_1d(:) = getvare3(cn_fzgr, cn_ve3t1d, npk)

  ! Read area fields to interpolate ssh onto U and V grids
  IF ( lssh .AND. cgrid .NE. 'T' ) THEN
    area1(:,:) = getvar(cn_fhgr, cn_ve1t, 1, npiglo, npjglo)  ! Save memory: e1t is first read into area
    ztmp( :,:) = getvar(cn_fhgr, cn_ve2t, 1, npiglo, npjglo)  ! ..and ztmp is used to read e2t
    area1(:,:) = area1(:,:) * ztmp(:,:)                       ! ..
    SELECT CASE (cgrid)
    CASE ('U')
      area2(:,:) = getvar(cn_fhgr, cn_ve1u, 1, npiglo, npjglo)  ! Save memory: e1u is first read into area
      ztmp( :,:) = getvar(cn_fhgr, cn_ve2u, 1, npiglo, npjglo)  ! ..and ztmp is used to read e2u
      area2(:,:) = area2(:,:) * ztmp(:,:)                       ! ..
    CASE ('V')
      area2(:,:) = getvar(cn_fhgr, cn_ve1v, 1, npiglo, npjglo)  ! Save memory: e1v is first read into area
      ztmp( :,:) = getvar(cn_fhgr, cn_ve2v, 1, npiglo, npjglo)  ! ..and ztmp is used to read e2v
      area2(:,:) = area2(:,:) * ztmp(:,:)                       ! ..
    END SELECT    
  ENDIF

  CALL CreateOutput
  PRINT *, 'Output file initialised ...'

  DO jt=1,npt

     IF ( lg_vvl ) THEN ; it=jt
     ELSE               ; it=1
     ENDIF

     dl_vint1(:,:) = 0.d0

     DO jk = 1, npk
        ! Get values at jk
        tmask(:,:) = getvar(cn_fmsk, cn_tmask, jk, npiglo, npjglo )
        ! Get e3 at level jk ( ps...)
        IF ( lfull ) THEN ; e3(:,:) = e3_1d(jk)
        ELSE              ; e3(:,:) = getvar(cn_fe3, cn_ve3, jk, npiglo, npjglo, ktime=it,  ldiom=.NOT.lg_vvl)
        ENDIF
        ! Vertical integration
        dl_vint1(:,:) = dl_vint1(:,:) + e3(:,:) * tmask(:,:) * 1.d0
     END DO

     IF ( lssh ) THEN
       e3(:,:) = 0.e0
       e3(:,:) = getvar(cf_in, cn_sossheig, 1, npiglo, npjglo, ktime=jt) ! e3 <= ssh (to save memory)
       SELECT CASE (cgrid)
         CASE ('T')
           ssh(:,:) = e3(:,:)
         CASE ('U') ! ssh at U points
           ssh(npiglo,:) = e3(npiglo,:) ! to improve if periodic domain
           ssh(1:npiglo-1,:) = 0.5 * (  e3(1:npiglo-1,:) * area1(1:npiglo-1,:) &
           &                          + e3(2:npiglo  ,:) * area1(2:npiglo  ,:) ) / ( pp_eps + area2(1:npiglo-1,:) )
         CASE ('V') ! ssh at V points
           ssh(:,npjglo) = e3(:,npjglo)
           ssh(:,1:npjglo-1) = 0.5 * (  e3(:,1:npjglo-1) * area1(:,1:npjglo-1) &
           &                          + e3(:,2:npjglo  ) * area1(:,2:npjglo  ) ) / ( pp_eps + area2(:,1:npjglo-1) )
       END SELECT
       dl_vint1(:,:) = dl_vint1(:,:) + ssh(:,:) * 1.d0
     ENDIF

     ! Output to netcdf file 
     ierr = putvar(ncout, id_varout(1), REAL(dl_vint1), 1, npiglo, npjglo, ktime=jt)
     IF ( lssh .AND. cgrid .NE. 'T' ) THEN
       ierr = putvar(ncout, id_varout(2), REAL(ssh), 1, npiglo, npjglo, ktime=jt)
     ENDIF

  END DO  ! loop on time

  ierr = closeout(ncout)

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------

    ! prepare output variable(s)
    ipk(:)                       = 1

    stypvar(1)%cname             = 'thic_'//TRIM(cgrid)
    stypvar(1)%cunits            = 'm'
    stypvar(1)%rmissing_value    = ppspval
    stypvar(1)%valid_min         = 0.0
    stypvar(1)%valid_max         = 10000.0
    stypvar(1)%clong_name        = 'Water column thickness'
    stypvar(1)%cshort_name       = 'thickness'
    stypvar(1)%conline_operation = 'N/A'
    stypvar(1)%caxis             = 'TYX'

    IF ( lssh .AND. cgrid .NE. 'T' ) THEN
      stypvar(2)%cname             = 'ssh_'//TRIM(cgrid)
      stypvar(2)%cunits            = 'm'
      stypvar(2)%rmissing_value    = ppspval
      stypvar(2)%valid_min         = 0.0
      stypvar(2)%valid_max         = 100.0
      stypvar(2)%clong_name        = 'Sea Surface Height'
      stypvar(2)%cshort_name       = 'ssh'
      stypvar(2)%conline_operation = 'N/A'
      stypvar(2)%caxis             = 'TYX'
    ENDIF

    ! Initialize output file
    ncout = create    (cf_out, 'none', npiglo, npjglo, 1  )
    ierr  = createvar (ncout, stypvar, nvout, ipk, id_varout  )
    !SELECT CASE (cgrid)
    !  CASE( 'T' ) ; ierr = putheadervar(ncout, 'none', npiglo, npjglo, 1, glamt, gphit)
    !  CASE( 'U' ) ; ierr = putheadervar(ncout, 'none', npiglo, npjglo, 1, glamu, gphiu)
    !  CASE( 'V' ) ; ierr = putheadervar(ncout, 'none', npiglo, npjglo, 1, glamv, gphiv)
    !END SELECT

    dtim  = getvar1d (cf_in, cn_vtimec, npt     )
    ierr  = putvar1d (ncout, dtim,      npt, 'T')

  END SUBROUTINE CreateOutput

END PROGRAM cdfthic

PROGRAM cdfets
  !!======================================================================
  !!                     ***  PROGRAM  cdfets  ***
  !!=====================================================================
  !!  ** Purpose : Compute Eddy Time Scale 3D field from gridT file
  !!               and the Rosby Radius of deformation.
  !!               Store the results on a 'similar' cdf file.
  !!
  !!  ** Method  : (1) Compute the BruntVaissala frequency (N2) using eosbn2
  !!               (2) Compute the Rossby Radius as the vertical integral of N,
  !!                   scaled by |f|*pi
  !!               (3) Compute the buoyancy =-g x rho/rho0 and is horizontal 
  !!                   derivative db/dx and db/dy
  !!               (4) Compute M2 = SQRT ( (db/dx)^2 + (db/dy)^2 )
  !!               (5) Compute eddy length scale = ets = N/M2
  !!               (6) Output on netcdf file ets.nc :  
  !!                   ets = voets ;  rosby_radius = sorosrad
  !!
  !!  ** Reference : Chelton et Al.  (1998)  J. Phys.Oceanogr. 28, 433-460
  !!
  !!  ** Remarks : A special care has been taken with respect to land value 
  !!               which have been set to spval (-1000.) and not 0 as usual.
  !!               This is because a value of 0.00 has a physical meaning for N.
  !!               On the other hand, ets is N/M2. If M2 is 0, (which is likely 
  !!               not very usual), ets is set to the arbitrary value of -10.,
  !!               to flag these points.
  !!
  !! History : 2.0  : 12/2004  : J.M. Molines, J. Le Sommer  : Original code
  !!           3.0  : 12/2010  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE eos
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class energy_diagnostics
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                             :: ji, jj, jk, jt            ! dummy loop index
  INTEGER(KIND=4)                             :: it                        ! time index for vvl
  INTEGER(KIND=4)                             :: ierr                      ! working integer
  INTEGER(KIND=4)                             :: narg, iargc, ijarg        ! command line 
  INTEGER(KIND=4)                             :: npiglo, npjglo            ! size of the domain
  INTEGER(KIND=4)                             :: npk, npt                  ! size of the domain
  INTEGER(KIND=4)                             :: iup = 1, idown = 2, itmp  !
  INTEGER(KIND=4)                             :: ncout                     ! ncid of output file
  INTEGER(KIND=4), DIMENSION(2)               :: ipk, id_varout            ! 

  REAL(KIND=4)                                :: rau0  = 1000.             ! density of water
  REAL(KIND=4)                                :: grav  = 9.81              ! Gravity
  REAL(KIND=4)                                :: spval = -1000.            ! special value
  REAL(KIND=4)                                :: zpi
  REAL(KIND=4)                                :: zsps                      ! missing value for salinity
  REAL(KIND=4), DIMENSION(:,:,:), ALLOCATABLE :: ztemp, zsal, zwk          ! Array to read 2 layer of data
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: zn2                       ! Brunt Vaissala Frequency (N2)
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: zmask, ff                 ! mask coriolis.
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: e1u, e2v, e3w             ! metrics
  REAL(KIND=4), DIMENSION(:),     ALLOCATABLE :: gdepw                     ! depth of w level

  REAL(KIND=4), DIMENSION(:),     ALLOCATABLE :: dtim                      ! time counter
  REAL(KIND=8), DIMENSION(:,:),   ALLOCATABLE :: dbuoy, dbu, dbv           ! Double precision
  REAL(KIND=8), DIMENSION(:,:),   ALLOCATABLE :: dlda, dM2, dets           ! Double precision

  CHARACTER(LEN=256)                          :: cf_tfil                   ! temperture file
  CHARACTER(LEN=256)                          :: cf_sfil                   ! salinity file (option)
  CHARACTER(LEN=256)                          :: cf_out = 'ets.nc'         ! output filename
  CHARACTER(LEN=256)                          :: cldum                     ! working variable

  TYPE (variable), DIMENSION(2)               :: stypvar                   ! structure for attribute

  LOGICAL                                     :: lchk                      ! flag for missing files
  LOGICAL                                     :: lnc4 = .FALSE.            ! flag for missing files
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfets -t T-file [-s S-file ][-o OUT-file] [-nc4] [-vvl W-file]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the eddy time scale, and a proxy for rossby radius. The Rossby' 
     PRINT *,'       radius is computed as the vertical integral of N2 (Brunt Vaissala '
     PRINT *,'       frequency), scaled by |f|*pi.'
     PRINT *,'       The Eddy Time Scale is the ratio N/|grad B| where N is the square root'
     PRINT *,'       of N2 and |grad B| is the module of the horizontal buoyancy gradient.'
     PRINT *,'       B is the buoyancy computed as B=-g rho/rho0.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -t T-file : netcdf input file for temperature and salinity (gridT).'
     PRINT *,'           If salinity not in T-file,  use -s option.' 
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-s S-file ] : specify salinity file if not T-file.' 
     PRINT *,'       [-o OUT-file] : specifiy the name of output file instead of ',TRIM(cf_out)
     PRINT *,'       [-nc4 ] : Use netcdf4 output with chunking and deflation level 1.'
     PRINT *,'                 This option is effective only if cdftools are compiled with'
     PRINT *,'                 a netcdf library supporting chunking and deflation.'
     PRINT *,'       [-vvl W-file] : use time varying vertical metrics. W-file holds the '
     PRINT *,'                 time-varying e3w vertical metrics.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        ',TRIM(cn_fhgr),', ',TRIM(cn_fzgr)
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out),' unless -o option is used.' 
     PRINT *,'         variables : voets (days)  and sorosrad (m)'
     STOP 
  ENDIF

  cf_sfil = 'none'
  ijarg = 1
  DO WHILE ( ijarg <= narg )
     CALL getarg (ijarg, cldum) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ('-t','-f') ; CALL getarg (ijarg, cf_tfil) ; ijarg=ijarg+1
        ! options
     CASE ( '-s'   ) ; CALL getarg (ijarg, cf_sfil) ; ijarg=ijarg+1
     CASE ( '-o'   ) ; CALL getarg (ijarg, cf_out ) ; ijarg=ijarg+1
     CASE ( '-nc4' ) ; lnc4   = .TRUE.
     CASE ( '-vvl' ) ; lg_vvl = .TRUE.
        ;              CALL getarg (ijarg, cn_fe3w) ; ijarg=ijarg+1 ! change default cn_fe3w in this case
        ;              cn_ve3w = cn_ve3wvvl                         ! change default cn_ve3w
     CASE DEFAULT    ; PRINT *,' ERROR : ',TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  ENDDO
  IF ( cf_sfil == 'none' ) cf_sfil=cf_tfil 

  lchk = chkfile (cf_tfil) 
  lchk = chkfile (cf_sfil) .OR. lchk 
  lchk = chkfile (cn_fhgr) .OR. lchk 
  lchk = chkfile (cn_fzgr) .OR. lchk 

  IF ( lchk )  STOP 99 ! missing file

  ! Look for missing value for salinity
  zsps = getspval(cf_sfil, cn_vosaline)

  npiglo = getdim (cf_tfil,cn_x)
  npjglo = getdim (cf_tfil,cn_y)
  npk    = getdim (cf_tfil,cn_z)
  npt    = getdim (cf_tfil,cn_t)

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  ! Allocate arrays
  ALLOCATE (ztemp(npiglo,npjglo,2), zsal(npiglo,npjglo,2), zwk(npiglo,npjglo,2) ,zmask(npiglo,npjglo))
  ALLOCATE (zn2(npiglo,npjglo), e1u(npiglo,npjglo), e2v(npiglo,npjglo) ,e3w(npiglo,npjglo))
  ALLOCATE (dbu(npiglo,npjglo), dbv(npiglo,npjglo),dlda(npiglo,npjglo) )
  ALLOCATE (dbuoy(npiglo,npjglo), dM2(npiglo,npjglo),dets(npiglo,npjglo) ,ff(npiglo,npjglo) )
  ALLOCATE (gdepw(npk), dtim(npt) )

  CALL CreateOutput

  zpi=ACOS(-1.)

  e1u(:,:) = getvar  (cn_fhgr, cn_ve1u,  1,  npiglo, npjglo)
  e2v(:,:) = getvar  (cn_fhgr, cn_ve2v,  1,  npiglo, npjglo)
  ff(:,:)  = getvar  (cn_fhgr, cn_vff,   1,  npiglo, npjglo)
  gdepw(:) = getvare3(cn_fzgr, cn_gdepw, npk               )

  ! eliminates zeros (which corresponds to land points where no procs were used)
  WHERE ( e1u == 0 ) 
     ff  = 1.e-6
     e1u = 1
     e2v = 1
  END WHERE

  ff(:,:) = ABS(ff(:,:))* zpi
  ! need ff at T points, zwp(:,:,iup) is used as work array here.
  DO ji = 2, npiglo
     DO jj =2, npjglo
        zwk(ji,jj,iup) = 0.25 *  ( ff(ji,jj) + ff(ji,jj-1) + ff(ji-1,jj) + ff(ji-1,jj-1) )
     END DO
  END DO
  ff(:,:) = zwk(:,:,iup)
  ff(:,1) = ff(:,2)
  ff(1,:) = ff(2,:)

  DO jt = 1, npt
     IF ( lg_vvl ) THEN ; it=jt
     ELSE               ; it=1
     ENDIF
     ! at level 1. and npk, dets is not defined
     dets(:,:) = spval
     ierr = putvar(ncout, id_varout(1) ,SNGL(dets), npk, npiglo, npjglo, ktime = jt)
     !  2 levels of T and S are required : iup,idown (with respect to W level)
     !  Compute from bottom to top (for vertical integration)
     ztemp(:,:,idown) = getvar(cf_tfil, cn_votemper,  npk-1 ,npiglo,npjglo, ktime=jt )
     zsal (:,:,idown) = getvar(cf_sfil, cn_vosaline,  npk-1 ,npiglo,npjglo, ktime=jt )
     zwk  (:,:,idown) = spval

     ! Set to 0 dlda
     dlda(:,:) = 0.d0
     DO jk = npk-1, 2, -1   ! from bottom to top 
        PRINT *,'level ',jk
        ! Get temperature and salinity at jk -1 (up )
        ztemp(:,:,iup) = getvar(cf_tfil, cn_votemper,  jk-1 ,npiglo,npjglo, ktime = jt)
        zsal (:,:,iup) = getvar(cf_sfil, cn_vosaline,  jk-1 ,npiglo,npjglo, ktime = jt)

        ! build tmask at level jk
        zmask(:,:)=1.
        WHERE(ztemp(:,:,idown) == zsps ) zmask = 0

        ! get depthw and e3w at level jk
        e3w(:,:)   = getvar(cn_fe3w, cn_ve3w, jk,npiglo,npjglo, ktime=it, ldiom=.NOT.lg_vvl )
        WHERE(e3w == 0. ) e3w = 0.1     ! avoid 0's in e3w (land points anyway)

        ! zwk will hold N2 at W level
        zwk(:,:,iup) = eosbn2 ( ztemp,zsal,gdepw(jk),e3w,npiglo,npjglo, iup, idown )   ! not masked 
        WHERE( zwk(:,:,iup) < 0 ) zwk(:,:,iup) = 0.                         ! when < 0 set N2 = 0
        WHERE( zmask == 0 ) zwk(:,:,iup) = spval                            ! set to spval on land

        ! now put zn2 at T level (k )
        WHERE ( zwk(:,:,idown) == spval )  
           zn2(:,:) =  zwk(:,:,iup)
        ELSEWHERE                         
           zn2(:,:) = 0.5 * ( zwk(:,:,iup) + zwk(:,:,idown) ) 
        END WHERE

        ! Only the square root is used in this program (work for ocean points only)
        WHERE (zmask == 1 )  
           zn2=SQRT(zn2)
        ELSEWHERE            
           zn2=spval
        END WHERE

        ! integrates vertically (ff is already ABS(ff) * pi
        dlda(:,:) = dlda(:,:) + e3w(:,:)/ff(:,:) * zn2(:,:)* zmask(:,:)

        ! Compute buoyancy at level Tk ( idown)
        dbuoy(:,:) = - grav * (sigma0 ( ztemp(:,:,idown),  zsal(:,:,idown),npiglo, npjglo) )  * zmask(:,:) / rau0

        ! Compute dB/dx (U point) and dB/dy (V point)
        DO jj =1 , npjglo -1
           DO ji= 1, npiglo -1
              dbu(ji,jj) = 1./e1u(ji,jj) *( dbuoy(ji+1,jj) - dbuoy(ji,jj) )
              dbv(ji,jj) = 1./e2v(ji,jj) *( dbuoy(ji,jj+1) - dbuoy(ji,jj) )
           END DO
        END DO

        ! dM2 at T point ( (dB/dx)^2 + (dB/dy)^2 ) ^1/2
        DO jj=2,npjglo -1
           DO ji=2,npiglo -1
              dM2(ji,jj) =  0.25*(dbu(ji,jj) + dbu(ji-1,jj)) * (dbu(ji,jj) + dbu(ji-1,jj))  &
                   + 0.25*(dbv(ji,jj) + dbv(ji,jj-1))  * (dbv(ji,jj) + dbv(ji,jj-1))
           END DO
        END DO
        dM2(:,:) = SQRT( dM2(:,:) )

        ! Eddy Time Scale = N / dM2
        dets(:,:) = spval
        WHERE (dM2 /= 0 )  
           dets =  zn2/dM2/86400.   ! in seconds
        ELSEWHERE
           dets = -10.d0            ! flag ocean points with dM2 = 0 (very few ?)
        END WHERE
        WHERE (zmask == 0 ) dets = spval

        ! write dets at level jk on the output file
        ierr = putvar(ncout, id_varout(1) ,SNGL(dets), jk, npiglo, npjglo, ktime=jt)

        ! swap up and down, next will be read in up
        itmp = idown ; idown = iup ; iup = itmp

     END DO  ! loop to next level

     ! repeat dets at the surface and level 2 (the last computed)
     ierr = putvar(ncout, id_varout(1) ,SNGL(dets), 1,npiglo, npjglo, ktime=jt)

     ! apply land mask (level 2) on dlda (level 1. and 2 have same mask, as there are  always at least 3 levels)
     WHERE (zmask == 0 ) dlda=spval
     ierr = putvar(ncout, id_varout(2) ,SNGL(dlda), 1,npiglo, npjglo, ktime=jt)

  END DO  ! time loop

  ierr = closeout(ncout)

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    ! define new variables for output 
    ipk(1) = npk  ! 3D
    stypvar(1)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(1)%cname             = 'voets'
    stypvar(1)%cunits            = 'days'
    stypvar(1)%rmissing_value    = -1000.
    stypvar(1)%valid_min         = 0
    stypvar(1)%valid_max         = 50000.
    stypvar(1)%clong_name        = 'Eddy_Time_Scale'
    stypvar(1)%cshort_name       = 'voets'
    stypvar(1)%conline_operation = 'N/A'
    stypvar(1)%caxis             = 'TZYX'

    ipk(2) = 1    ! 2D
    stypvar(2)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(2)%cname             = 'sorosrad'
    stypvar(2)%cunits            = 'm'
    stypvar(2)%rmissing_value    = -1000.
    stypvar(2)%valid_min         = 0.
    stypvar(2)%valid_max         = 50000.
    stypvar(2)%clong_name        = 'Rossby_Radius'
    stypvar(2)%cshort_name       = 'sorosrad'
    stypvar(2)%conline_operation = 'N/A'
    stypvar(2)%caxis             = 'TYX'

    ! create output fileset
    ncout = create      (cf_out, cf_tfil,  npiglo, npjglo, npk       , ld_nc4=lnc4 )
    ierr  = createvar   (ncout,  stypvar , 2,      ipk,    id_varout , ld_nc4=lnc4 )
    ierr  = putheadervar(ncout,  cf_tfil,  npiglo, npjglo, npk       )

    dtim = getvar1d(cf_tfil, cn_vtimec, npt     )
    ierr = putvar1d(ncout, dtim,       npt, 'T')

  END SUBROUTINE CreateOutput


END PROGRAM cdfets

PROGRAM cdfmoyt
  !!======================================================================
  !!                     ***  PROGRAM  cdfmoyt  ***
  !!=====================================================================
  !!  ** Purpose : Compute mean values for all the variables in a bunch
  !!               of cdf files given as arguments.
  !!               Store the results on a 'similar' cdf file. This version
  !!               differ from cdfmoy, because if the input files have many
  !!               time frames in it, the output file will have the same 
  !!               number of time frames, each being the average accross the
  !!               input files.
  !!
  !!  ** Method  : Also store the mean squared values for the nn_sqdvar
  !!               variables belonging to cn_sqdvar(:), than can be changed 
  !!               in the nam_cdf_names namelist if wished.
  !!
  !! History : 2.0  : 11/2004  : J.M. Molines : Original code
  !!         : 2.1  : 06/2007  : P. Mathiot   : Modif for forcing fields
  !!           3.0  : 12/2010  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  !!   routines      : description
  !!   varchk2       : check if variable is candidate for square mean
  !!----------------------------------------------------------------------
  USE cdfio 
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2010, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!-----------------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                               :: jk, jfil, jrec     ! dummy loop index
  INTEGER(KIND=4)                               :: jvar, jv, jt       ! dummy loop index
  INTEGER(KIND=4)                               :: ierr               ! working integer
  INTEGER(KIND=4)                               :: inpt               ! working integer
  INTEGER(KIND=4)                               :: narg, iargc, ijarg ! browsing command line
  INTEGER(KIND=4)                               :: nfil               ! number of files to average
  INTEGER(KIND=4)                               :: npiglo, npjglo     ! size of the domain
  INTEGER(KIND=4)                               :: npk, npt           ! size of the domain
  INTEGER(KIND=4)                               :: nvars              ! number of variables in a file
  INTEGER(KIND=4)                               :: ntframe            ! cumul of time frame
  INTEGER(KIND=4)                               :: ncout, ncout2      ! ncid of output files
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: id_var             ! arrays of var id's
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: ipk                ! arrays of vertical level for each var
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: id_varout          ! varid's of average vars
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: id_varout2         ! varid's of sqd average vars

  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: v2d                ! array to read a layer of data
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: tim                ! time counter
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: zspval_in          ! input missing value

  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: dtab, dtab2        ! arrays for cumulated values
  REAL(KIND=8), DIMENSION(:),       ALLOCATABLE :: dtotal_time        ! to compute mean time

  CHARACTER(LEN=256)                            :: cf_in              ! input file names
  CHARACTER(LEN=256)                            :: cf_out  = 'cdfmoy.nc'  ! output file for average
  CHARACTER(LEN=256)                            :: cf_out2 = 'cdfmoy2.nc' ! output file for squared average
  CHARACTER(LEN=256)                            :: cv_dep             ! depth dimension name
  CHARACTER(LEN=256)                            :: cldum              ! dummy string argument
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cf_list            ! list of input files
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_nam             ! array of var name
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_nam2            ! array of var2 name for output

  TYPE (variable), DIMENSION(:),    ALLOCATABLE :: stypvar            ! attributes for average values
  TYPE (variable), DIMENSION(:),    ALLOCATABLE :: stypvar2           ! attributes for square averaged values

  LOGICAL                                       :: lspval0 = .FALSE.  ! cdfmoy_chsp flag
  !!----------------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfmoyt list_of_model_files [-spval0]  '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the time average of a list of files given as arguments.' 
     PRINT *,'       This program handle multi time-frame files is such a way that'
     PRINT *,'       the output files are also multi time-frame, each frame being'
     PRINT *,'       the average across the files given in the list.'
     PRINT *,'       '
     PRINT *,'       The program assume that all files in the list are of same'
     PRINT *,'       type (shape, variables , and number of time frames ). '
     PRINT *,'       For some variables, the program also compute the time average '
     PRINT *,'       of the squared variables, which is used in other cdftools '
     PRINT *,'       (cdfeke, cdfrmsssh, cdfstdevw, cdfstddevts ... The actual variables'
     PRINT *,'       selected for squared average are :'
     PRINT '(10x,"- ",a)' , (TRIM(cn_sqdvar(jv)), jv=1, nn_sqdvar)
     PRINT *,'       This selection can be adapted with the nam_cdf_namelist process.'
     PRINT *,'       (See cdfnamelist -i for details).'
     PRINT *,'       If you want to compute the average of already averaged files,'
     PRINT *,'       consider using cdfmoy_weighted instead, in order to take into'
     PRINT *,'       account a particular weight for each file in the list.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       A list of similar model output files. '
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [ -spval0 ] :  set missing_value attribute to 0 for all output'
     PRINT *,'               variables and take care of the input missing_value.'
     PRINT *,'               This option is usefull if missing_values differ from files '
     PRINT *,'               to files; it was formely done by cdfmoy_chsp).'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       none '
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out),' and ',TRIM(cf_out2)
     PRINT *,'       variables : are the same than in the input files. For squared averages' 
     PRINT *,'       _sqd is append to the original variable name.'
     STOP
  ENDIF

  ALLOCATE ( cf_list(narg) )
  ! look for -spval0 option and set up cf_list, nfil 
  ijarg = 1 
  nfil = 0
  DO WHILE ( ijarg <= narg )
     CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1
     SELECT CASE ( cldum )
     CASE ( '-spval0' )   ! option to reset spval to 0 in the output files
        lspval0 = .TRUE.
     CASE DEFAULT         ! then the argument is a file
        nfil          = nfil + 1
        cf_list(nfil) = TRIM(cldum)
     END SELECT
  END DO
  ! Initialisation from  1rst file (all file are assume to have the same geometry)
  ! time counter can be different for each file in the list. It is read in the
  ! loop for files

  IF ( chkfile (cf_list(1)) ) STOP ! missing file

  cf_in  = cf_list(1)
  npiglo = getdim (cf_in,cn_x)
  npjglo = getdim (cf_in,cn_y)
  npk    = getdim (cf_in,cn_z, cdtrue=cv_dep, kstatus=ierr)
  npt    = getdim (cf_in,cn_t)

  IF (ierr /= 0 ) THEN
     npk   = getdim (cf_in,'z',cdtrue=cv_dep,kstatus=ierr)
     IF (ierr /= 0 ) THEN
        npk   = getdim (cf_in,'sigma',cdtrue=cv_dep,kstatus=ierr)
        IF ( ierr /= 0 ) THEN 
           npk = getdim (cf_in,'nav_lev',cdtrue=cv_dep,kstatus=ierr)
           IF ( ierr /= 0 ) THEN 
              npk = getdim (cf_in,'levels',cdtrue=cv_dep,kstatus=ierr)
              IF ( ierr /= 0 ) THEN 
                 PRINT *,' assume file with no depth'
                 npk=0
              ENDIF
           ENDIF
        ENDIF
     ENDIF
  ENDIF

  ! check that all files have the same number of time frames
  ierr = 0
  DO jfil = 1, nfil
     IF (  chkfile (cf_list(jfil)      ) ) STOP ! missing file
     inpt = getdim (cf_list(jfil), cn_t)
     IF ( inpt /= npt ) THEN
        PRINT *, 'File ',TRIM(cf_list(jfil) ),' has ',inpt,' time frames instead of ', npt
        ierr = ierr + 1
     ENDIF
  ENDDO
  IF ( ierr /= 0 ) STOP ! frame numbers mismatch

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  ALLOCATE( dtab(npiglo,npjglo), dtab2(npiglo,npjglo), v2d(npiglo,npjglo) )
  ALLOCATE( dtotal_time(npt), tim(npt) )

  nvars = getnvar(cf_in)
  PRINT *,' nvars = ', nvars

  ALLOCATE (cv_nam(nvars), cv_nam2(nvars) )
  ALLOCATE (stypvar(nvars), stypvar2(nvars) )
  ALLOCATE (id_var(nvars), ipk(nvars), id_varout(nvars), id_varout2(nvars)  )

  ! get list of variable names and collect attributes in stypvar (optional)
  cv_nam(:) = getvarname(cf_in,nvars, stypvar)

  IF ( lspval0 ) THEN 
     ALLOCATE ( zspval_in(nvars) )
     zspval_in(:) = stypvar(:)%rmissing_value
     stypvar(:)%rmissing_value = 0.
  ENDIF

  DO jvar = 1, nvars
     ! variables that will not be computed or stored are named 'none'
     IF ( varchk2 ( cv_nam(jvar) ) ) THEN 
        cv_nam2(jvar)                    = TRIM(cv_nam(jvar))//'_sqd'
        stypvar2(jvar)%cname             = TRIM(stypvar(jvar)%cname)//'_sqd'         ! name
        stypvar2(jvar)%cunits            = '('//TRIM(stypvar(jvar)%cunits)//')^2'    ! unit
        stypvar2(jvar)%rmissing_value    = stypvar(jvar)%rmissing_value              ! missing_value
        stypvar2(jvar)%valid_min         = 0.                                        ! valid_min = zero
        stypvar2(jvar)%valid_max         = stypvar(jvar)%valid_max**2                ! valid_max *valid_max
        stypvar2(jvar)%scale_factor      = 1.
        stypvar2(jvar)%add_offset        = 0.
        stypvar2(jvar)%savelog10         = 0.
        stypvar2(jvar)%clong_name        = TRIM(stypvar(jvar)%clong_name)//'_Squared'   ! 
        stypvar2(jvar)%cshort_name       = TRIM(stypvar(jvar)%cshort_name)//'_sqd'     !
        stypvar2(jvar)%conline_operation = TRIM(stypvar(jvar)%conline_operation) 
        stypvar2(jvar)%caxis             = TRIM(stypvar(jvar)%caxis) 
     ELSE
        cv_nam2(jvar) = 'none'
     END IF
  END DO

  id_var(:)  = (/(jv, jv=1,nvars)/)
  ! ipk gives the number of level or 0 if not a T[Z]YX  variable
  ipk(:)     = getipk (cf_in,nvars,cdep=cv_dep)
  WHERE( ipk == 0 ) cv_nam='none'
  stypvar( :)%cname = cv_nam
  stypvar2(:)%cname = cv_nam2

  ! create output file taking the sizes in cf_in
  ncout  = create      (cf_out,  cf_in,    npiglo, npjglo, npk, cdep=cv_dep)
  ierr   = createvar   (ncout ,  stypvar,  nvars,  ipk,    id_varout       )
  ierr   = putheadervar(ncout,   cf_in,    npiglo, npjglo, npk, cdep=cv_dep)

  ncout2 = create      (cf_out2, cf_in,    npiglo, npjglo, npk, cdep=cv_dep)
  ierr   = createvar   (ncout2,  stypvar2, nvars,  ipk,    id_varout2      )
  ierr   = putheadervar(ncout2,  cf_in,    npiglo, npjglo, npk, cdep=cv_dep)

  ! Compute the mean time for each mean frame
  dtotal_time(:) = 0.d0
  DO jfil = 1, nfil 
     cf_in          = cf_list(jfil)
     tim(:)         = getvar1d(cf_in, cn_vtimec, npt)
     dtotal_time(:) = dtotal_time(:) + tim (:)
  END DO
  tim(:) = dtotal_time(:)/ nfil
  ierr   = putvar1d(ncout,  tim, npt, 'T')
  ierr   = putvar1d(ncout2, tim, npt, 'T')

  DO jrec = 1, npt

     DO jvar = 1,nvars
        IF ( cv_nam(jvar) == cn_vlon2d .OR. &     ! nav_lon
             cv_nam(jvar) == cn_vlat2d ) THEN     ! nav_lat
           ! skip these variable
        ELSE
           PRINT *,' Working with ', TRIM(cv_nam(jvar)), ipk(jvar)
           DO jk = 1, ipk(jvar)
              PRINT *,'level ',jk
              dtab(:,:) = 0.d0 ; dtab2(:,:) = 0.d0 
              ntframe = 0
              DO jfil = 1, nfil
                 cf_in     = cf_list(jfil)
                 v2d(:,:)  = getvar(cf_in, cv_nam(jvar), jk, npiglo, npjglo, ktime=jrec )
                 IF ( lspval0 )  WHERE (v2d == zspval_in(jvar))  v2d = 0.  ! change missing values to 0
                 dtab(:,:) = dtab(:,:) + v2d(:,:)
                 IF (cv_nam2(jvar) /= 'none' ) dtab2(:,:) = dtab2(:,:) + v2d(:,:)*v2d(:,:)
              END DO

              ! store variable on outputfile
              ierr = putvar(ncout, id_varout(jvar), SNGL(dtab(:,:)/nfil), jk, npiglo, npjglo, kwght=nfil, ktime = jrec )
              IF (cv_nam2(jvar) /= 'none' )  THEN 
                 ierr = putvar(ncout2, id_varout2(jvar), SNGL(dtab2(:,:)/nfil), jk, npiglo, npjglo, kwght=nfil, ktime=jrec)
              ENDIF

           END DO  ! loop to next level
        END IF
     END DO ! loop to next var in file
  END DO ! loop to next record in input file

  ierr = closeout(ncout)
  ierr = closeout(ncout2)

CONTAINS 

  LOGICAL FUNCTION varchk2 ( cd_var ) 
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION varchk2  ***
    !!
    !! ** Purpose : Return true if cd_var is candidate for mean squared value  
    !!
    !! ** Method  : List of candidate is established in modcdfnames, and
    !!              can be changed via the nam_cdf_names namelist   
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*), INTENT(in) :: cd_var

    INTEGER(KIND=4)              :: jv
    !!----------------------------------------------------------------------
    varchk2 = .FALSE.
    DO jv = 1, nn_sqdvar 
       IF ( cd_var == cn_sqdvar(jv) ) THEN
          varchk2 = .TRUE.
          EXIT
       ENDIF
    ENDDO

  END FUNCTION varchk2

END PROGRAM cdfmoyt

PROGRAM cdfmocsig
  !!======================================================================
  !!                     ***  PROGRAM  cdfmocsig  ***
  !!=====================================================================
  !!  ** Purpose : Compute the Meridional Overturning Cell (MOC)
  !!               using density bins. 
  !!
  !!  ** Method  : The MOC is computed from the V velocity field, collected in density bins,
  !!               (reference depth is given as the 3rd argument) and integrated
  !!               throughout the density bins, then zonally averaged with
  !!               eventual masking for oceanic basins.
  !!               In the present version the masking corresponds to the global
  !!               configuration. MOC for Global, Atlantic, Indo-Pacific, Indian,Pacific ocean
  !!               Results are saved on mocsig.nc file with variables name respectively
  !!               zomsfglo, zomsfatl, zomsfinp, zomsfind, zomsfpac.
  !!               If no new_maskglo.nc file found, then the mask.nc file is used and
  !!               only zomsfglo is computed.

  !!
  !! History : 2.1  : 11/2005  : A.M. Treguier : Original code from cdfmoc
  !!                : 03/2010  : C. Dufour     : Choice of depth reference
  !!                                             improvements 
  !!           3.0  : 04/2011  : J.M. Molines  : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE eos
  USE modcdfnames
  USE modutils
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE
  INTEGER(KIND=2), DIMENSION (:,:,:), ALLOCATABLE ::  ibmask              ! nbasins x npiglo x npjglo
  INTEGER(KIND=2), DIMENSION (:,:),   ALLOCATABLE ::  itmask              ! tmask from salinity field

  INTEGER(KIND=4)                                 :: jbasin, jj, jk       ! dummy loop index
  INTEGER(KIND=4)                                 :: ji, jt, jbin         ! dummy loop index
  INTEGER(KIND=4)                                 :: nbins                ! number of  density  bins
  INTEGER(KIND=4)                                 :: npglo, npatl, npinp  ! basins index (mnemonics)
  INTEGER(KIND=4)                                 :: npind, nppac         !  "      "
  INTEGER(KIND=4)                                 :: nbasins              ! number of basins
  INTEGER(KIND=4)                                 :: ierr                 ! working integer
  INTEGER(KIND=4)                                 :: narg, iargc, iarg    ! command line  browsing 
  INTEGER(KIND=4)                                 :: ijarg, ii            !  "             "
  INTEGER(KIND=4)                                 :: npiglo,npjglo        ! size of the domain
  INTEGER(KIND=4)                                 :: npk, npt             ! size of the domain
  INTEGER(KIND=4)                                 :: ncout                ! ncid of output file
  INTEGER(KIND=4), DIMENSION(2)                   :: iloc                 ! working array
  INTEGER(KIND=4), DIMENSION(:),      ALLOCATABLE :: ipk, id_varout       ! output variable levels and id
  INTEGER(KIND=4), DIMENSION (:,:),   ALLOCATABLE :: ibin                 ! remaping density in bin number

  REAL(KIND=4), DIMENSION (:,:),      ALLOCATABLE :: e1v, gphiv           ! horizontal metrics, latitude
  REAL(KIND=4), DIMENSION (:,:),      ALLOCATABLE :: zt, zs               ! temperature, salinity
  REAL(KIND=4), DIMENSION (:,:),      ALLOCATABLE :: zv, zveiv            ! velocity and bolus velocity
  REAL(KIND=4), DIMENSION (:,:),      ALLOCATABLE :: e3v                  ! vertical metrics
  REAL(KIND=4), DIMENSION (:,:),      ALLOCATABLE :: rdumlon              ! dummy longitude = 0.
  REAL(KIND=4), DIMENSION (:,:),      ALLOCATABLE :: rdumlat              ! latitude for i = north pole
  REAL(KIND=4), DIMENSION (:,:),      ALLOCATABLE :: zttmp                ! arrays to call sigmai and mask it
  REAL(KIND=4), DIMENSION (:),        ALLOCATABLE :: sigma                ! density coordinate 
  REAL(KIND=4), DIMENSION (:),        ALLOCATABLE :: e31d                 ! vertical level (full step)
  REAL(KIND=4), DIMENSION (:),        ALLOCATABLE :: tim                  ! time counter
  REAL(KIND=4)                                    :: pref=0.              ! depth reference for pot. density 
  REAL(KIND=4)                                    :: sigmin               ! minimum density for bining
  REAL(KIND=4)                                    :: sigstp               ! density step for bining

  REAL(KIND=8), DIMENSION(:,:,:),     ALLOCATABLE :: dmoc                 ! nbasins x npjglo x npk
  REAL(KIND=8), DIMENSION(:,:),       ALLOCATABLE :: dens                 ! density
  REAL(KIND=8), DIMENSION(:,:),       ALLOCATABLE :: dmoc_tmp             ! temporary transport array

  CHARACTER(LEN=256)                              :: cf_vfil              ! meridional velocity file
  CHARACTER(LEN=256)                              :: cf_tfil              ! temperature/salinity file
  CHARACTER(LEN=256)                              :: cf_moc='mocsig.nc'   ! output file
  CHARACTER(LEN=255)                              :: cglobal              ! Global attribute
  CHARACTER(LEN=256)                              :: cldum                ! dummy char variable

  TYPE(variable), DIMENSION(:), ALLOCATABLE       :: stypvar              ! output var properties

  LOGICAL, DIMENSION(3)                           :: lbin                 ! flag for bin specifications
  LOGICAL                                         :: lbas   = .FALSE.     ! flag for basins file
  LOGICAL                                         :: lprint = .FALSE.     ! flag for extra print
  LOGICAL                                         :: leiv   = .FALSE.     ! flag for Eddy Induced Velocity (GM)
  LOGICAL                                         :: lfull  = .FALSE.     ! flag for full step
  LOGICAL                                         :: lchk   = .FALSE.     ! flag for missing file
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfmocsig  V_file T_file depth_ref [-eiv] [-full]  ... '
     PRINT *,'         ...  [-sigmin sigmin] [-sigstp sigstp] [-nbins nbins] [-v] '
     PRINT *,'     PURPOSE : '
     PRINT *,'       Computes the MOC in density-latitude coordinates. The global value'
     PRINT *,'       is always computed. Values for oceanic sub-basins are calculated'
     PRINT *,'       if the file ', TRIM(cn_fbasins), ' is provided.'
     PRINT *,'       Last arguments is the reference depth for potential density, in m.'
     PRINT *,'       Actually only 0 1000 or 2000 are available with standard values for'
     PRINT *,'       density bins. If you specify another reference depth, you must also'
     PRINT *,'       specify the minimum density, the bin size and the number of bins,'
     PRINT *,'       with the options -sigmin, -sigstp, -nbins'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'        V_file  : Netcdf gridV file'
     PRINT *,'        T_file  : Netcdf gridT file'
     PRINT *,'        depth_ref : reference depth for density '
     PRINT *,'               for depth values of 0 1000 or 2000, pre-defined limits for'
     PRINT *,'               minimum density, number of density bins and width of density'
     PRINT *,'               bins are provided. For other reference depth, you must use'
     PRINT *,'               -sigmin, -sigstp and -nbins options (see below).'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-eiv ] : takes into account VEIV Meridional eddy induced velocity'
     PRINT *,'                 -> To be used only if Gent and McWilliams parameterization '
     PRINT *,'                    has been used '
     PRINT *,'       [ -full ] : Works with full step instead of standard partial steps'
     PRINT *,'       [ -sigmin ] : Specify minimum of density for bining'
     PRINT *,'       [ -sigstp ] : Specify density step for bining'
     PRINT *,'       [ -nbins ]  : Specify the number of density bins you want'
     PRINT *,'       [ -v  ]     : Verbose option for more info during execution'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        Files ', TRIM(cn_fzgr),', ',TRIM(cn_fhgr),', ', TRIM(cn_fmsk)
     PRINT *,'        File ', TRIM(cn_fbasins),' is optional [sub basins masks]'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_moc) 
     PRINT *,'       variables ',TRIM( cn_zomsfglo),' : Global ocean '
     PRINT *,'       variables ',TRIM( cn_zomsfatl),' : Atlantic Ocean '
     PRINT *,'       variables ',TRIM( cn_zomsfinp),' : Indo Pacific '
     PRINT *,'       variables ',TRIM( cn_zomsfind),' : Indian Ocean alone'
     PRINT *,'       variables ',TRIM( cn_zomsfpac),' : Pacific Ocean alone'
     PRINT *,'       If file ',TRIM(cn_fbasins),' is not present, ',TRIM(cn_fmsk),' file'
     PRINT *,'       is used and only ',TRIM( cn_zomsfglo),' is produced.'
     STOP
  ENDIF

  cglobal = 'Partial step computation'
  lbin=(/.TRUE.,.TRUE.,.TRUE./)
  ijarg = 1 ; ii = 0
  DO WHILE ( ijarg <= narg )
     CALL getarg (ijarg, cldum) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ('-full')
        lfull   = .TRUE.
        cglobal = 'Full step computation'
     CASE ('-eiv')
        leiv    = .TRUE.
     CASE ('-sigmin')
        CALL getarg (ijarg, cldum) ; ijarg=ijarg+1 ; READ(cldum,*) sigmin
        lbin(1) = .FALSE.
     CASE ('-nbins')
        CALL getarg (ijarg, cldum) ; ijarg=ijarg+1 ; READ(cldum,*) nbins
        lbin(2) = .FALSE.
     CASE ('-sigstp')
        CALL getarg (ijarg, cldum) ; ijarg=ijarg+1 ; READ(cldum,*) sigstp
        lbin(3) = .FALSE.
     CASE ('-v')
        lprint = .TRUE.
     CASE DEFAULT
        ii=ii+1
        SELECT CASE (ii)
        CASE ( 1 ) ; cf_vfil = cldum
        CASE ( 2 ) ; cf_tfil = cldum
        CASE ( 3 ) ; READ(cldum,*) pref
        CASE DEFAULT
           STOP 'ERROR : Too many arguments ...'
        END SELECT
     END SELECT
  END DO

  ! check file existence
  lchk = lchk .OR. chkfile ( cn_fhgr )
  lchk = lchk .OR. chkfile ( cn_fzgr )
  lchk = lchk .OR. chkfile ( cn_fmsk )
  lchk = lchk .OR. chkfile ( cf_vfil )
  lchk = lchk .OR. chkfile ( cf_tfil )
  IF ( lchk ) STOP  ! missing file(s)

  ! re-use lchk for binning control : TRUE if no particular binning specified
  lchk = lbin(1) .OR. lbin(2) .OR. lbin(3) 

  npiglo = getdim (cf_vfil,cn_x)
  npjglo = getdim (cf_vfil,cn_y)
  npk    = getdim (cf_vfil,cn_z)
  npt    = getdim (cf_vfil,cn_t)

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  !setting up the building command in global attribute
  CALL SetGlobalAtt(cglobal, 'A')  ! append command name to global attribute

  !  Detects newmaskglo file
  lbas = .NOT. chkfile (cn_fbasins )

  IF (lbas) THEN
     nbasins = 5
  ELSE
     nbasins = 1
  ENDIF

  ALLOCATE ( stypvar(nbasins), ipk(nbasins), id_varout(nbasins) )

  IF ( lchk )  THEN  ! use default bins definition according to pref 
     ! Define density parameters
     SELECT CASE ( INT(pref) )
     CASE ( 0 )
        nbins  = 52
        sigmin  = 23.
        sigstp = 0.1
     CASE ( 1000 )
        nbins  = 88
        sigmin  = 24.
        sigstp = 0.1
     CASE ( 2000)
        nbins  = 158
        sigmin  = 30.
        sigstp = 0.05
     CASE DEFAULT
        PRINT *,' This value of depth_ref (',pref,') is not implemented as standard'
        PRINT *,' You must use the -sigmin, -sigstp and -nbins options to precise'
        PRINT *,' the density bining you want to use.'
        STOP
     END SELECT
  ENDIF
  PRINT '(a,f6.1,a)',           '  For reference depth ', pref, ' m, '
  PRINT '(a,f5.2,a,f5.2,a,i3)', '  You are using -sigmin ', sigmin,' -sigstp ', sigstp,' -nbins ', nbins

  ALLOCATE ( sigma(nbins) )  

  ! define densities at middle of bins
  DO ji=1,nbins
     sigma(ji)  = sigmin +(ji-0.5)*sigstp
  ENDDO
  IF (lprint) PRINT *, ' min density:',sigma(1), ' max density:', sigma(nbins)

  !global   ; Atlantic  ; Indo-Pacif ; Indian  ; Pacif
  npglo= 1  ; npatl=2   ;  npinp=3   ; npind=4 ; nppac=5

  ! Common to all variables :
  stypvar%cunits            = 'Sverdrup'
  stypvar%rmissing_value    = 99999.
  stypvar%valid_min         = -1000.
  stypvar%valid_max         =  1000.
  stypvar%scale_factor      = 1.
  stypvar%add_offset        = 0.
  stypvar%savelog10         = 0.
  stypvar%conline_operation = 'N/A'
  stypvar%caxis             = 'TZY'

  ipk(:) = npk  

  ! Global basin
  stypvar(npglo)%cname       = cn_zomsfglo
  stypvar(npglo)%clong_name  = 'Meridional_Overt.Cell_Global'
  stypvar(npglo)%cshort_name = cn_zomsfglo

  IF (lbas) THEN
     stypvar(npatl)%cname       = cn_zomsfatl
     stypvar(npatl)%clong_name  = 'Meridional_Overt.Cell_Atlantic'
     stypvar(npatl)%cshort_name = cn_zomsfatl

     stypvar(npinp)%cname       = cn_zomsfinp
     stypvar(npinp)%clong_name  = 'Meridional_Overt.Cell_IndoPacif'
     stypvar(npinp)%cshort_name = cn_zomsfinp

     stypvar(npind)%cname       = cn_zomsfind
     stypvar(npind)%clong_name  = 'Meridional_Overt.Cell_Indian'
     stypvar(npind)%cshort_name = cn_zomsfind

     stypvar(nppac)%cname       = cn_zomsfpac
     stypvar(nppac)%clong_name  = 'Meridional_Overt.Cell_pacif'
     stypvar(nppac)%cshort_name = cn_zomsfpac
  ENDIF

  ! Allocate arrays
  ALLOCATE ( ibmask(nbasins,npiglo,npjglo) )
  ALLOCATE ( zv (npiglo,npjglo), zt(npiglo,npjglo), zs(npiglo,npjglo))
  ALLOCATE ( e3v(npiglo,npjglo) )
  ALLOCATE ( ibin(npiglo, npjglo) )
  ALLOCATE ( e1v(npiglo,npjglo), gphiv(npiglo,npjglo) )
  ALLOCATE ( dmoc(nbasins, npjglo, nbins) )
  ALLOCATE ( dmoc_tmp(nbins,npiglo) )
  ALLOCATE ( rdumlon(1,npjglo) , rdumlat(1,npjglo))
  ALLOCATE ( dens(npiglo,npjglo))
  ALLOCATE ( itmask(npiglo,npjglo), zttmp(npiglo,npjglo))
  ALLOCATE ( tim(npt), e31d(npk)  )

  IF ( leiv ) THEN
     ALLOCATE ( zveiv (npiglo,npjglo))
  END IF

  e1v(:,:)   = getvar(cn_fhgr,   cn_ve1v,  1, npiglo, npjglo) 
  gphiv(:,:) = getvar(cn_fhgr,   cn_gphiv, 1, npiglo, npjglo)

  IF ( lfull ) e31d(:)  = getvare3(cn_fzgr, cn_ve3t, npk)

  iloc         = MAXLOC(gphiv)
  rdumlat(1,:) = gphiv(iloc(1),:)
  rdumlon(:,:) = 0.               ! set the dummy longitude to 0

  ! create output fileset
! ncout = create      (cf_moc, cf_vfil, 1,       npjglo, nbins,  cdep='sigma')
  ncout = create      (cf_moc, 'none', 1,       npjglo, nbins,  cdep='sigma')
  ierr  = createvar   (ncout,  stypvar, nbasins, ipk ,id_varout, cdglobal=cglobal)
  ierr  = putheadervar(ncout,  cf_vfil, 1,       npjglo, nbins,  pnavlon=rdumlon, pnavlat=rdumlat, pdep=sigma)

  tim  = getvar1d(cf_vfil, cn_vtimec, npt     )
  ierr = putvar1d(ncout,   tim,       npt, 'T')

  ! reading the masks
  ibmask(npglo,:,:) = getvar(cn_fmsk, 'vmask', 1, npiglo, npjglo)

  IF ( lbas ) THEN
     ibmask(npatl,:,:) = getvar(cn_fbasins, 'tmaskatl', 1, npiglo, npjglo)
     ibmask(npind,:,:) = getvar(cn_fbasins, 'tmaskind', 1, npiglo, npjglo)
     ibmask(nppac,:,:) = getvar(cn_fbasins, 'tmaskpac', 1, npiglo, npjglo)
     ibmask(npinp,:,:) = ibmask(nppac,:,:) + ibmask(npind,:,:)
     ! ensure that there are no overlapping on the masks
     WHERE(ibmask(npinp,:,:) > 0 ) ibmask(npinp,:,:) = 1
     ! change global mask for GLOBAL periodic condition
     ibmask(1,1,     :) = 0.
     ibmask(1,npiglo,:) = 0.
  ENDIF

  DO jt=1, npt
     ! initialize moc to 0
     dmoc(:,:,:) = 0.d0

     DO jk=1,npk-1
        !               for testing purposes only loop from 2 to 400
        IF (lprint) PRINT *,' working at depth ',jk
        ! Get velocities v at jj
        zv(:,:) = getvar(cf_vfil, cn_vomecrty, jk, npiglo, npjglo)
        IF ( leiv ) THEN
           zveiv(:,:) = getvar(cf_vfil, cn_vomeeivv, jk, npiglo,npjglo)
           zv(:,:)    = zv(:,:) + zveiv(:,:)
        END IF
        zt(:,:) = getvar(cf_tfil, cn_votemper, jk, npiglo, npjglo)
        zs(:,:) = getvar(cf_tfil, cn_vosaline, jk, npiglo, npjglo)

        ! get e3v at latitude jj
        IF ( lfull ) THEN
          e3v(:,:) = e31d(jk)
        ELSE
          e3v(:,:) = getvar(cn_fzgr, 'e3v_ps', jk, npiglo, npjglo, ldiom=.TRUE.)
        ENDIF
        !
        !  finds density 
        itmask =  1
        WHERE ( zs == 0 ) itmask = 0
        dens  = sigmai(zt, zs, pref, npiglo, npjglo)
        zttmp = dens* itmask ! convert to single precision 
        ! find bin numbers
        ibin(:,:) = INT( (zttmp-sigmin)/sigstp )
        ibin(:,:) = MAX( ibin(:,:), 1    )
        ibin(:,:) = MIN( ibin(:,:), nbins)

        DO jj=2,npjglo-1
           dmoc_tmp = 0
           !  converts transport in "k" to transport in "sigma"
           !  indirect adresssing - do it once and not for each basin!
           DO ji=2,npiglo-1
              dmoc_tmp(ibin(ji,jj),ji)=dmoc_tmp(ibin(ji,jj),ji) - e1v(ji,jj)*e3v(ji,jj)*zv(ji,jj)
           END DO
           ! integrates 'zonally' (along i-coordinate) 
           ! add to dmoc the contributions from level jk  at all densities jbin
           DO jbin =1,nbins  
              DO ji=2,npiglo-1
                 DO jbasin= 1, nbasins
                    ! For all basins 
                    dmoc(jbasin,jj,jbin)=dmoc(jbasin,jj,jbin ) + dmoc_tmp(jbin,ji) * ibmask(jbasin,ji,jj)
                 ENDDO
              END DO
           END DO
           !               end of loop on latitude for filling dmoc
        END DO
        !  end of loop on depths for calculating transports     
     END DO

     ! integrates across bins from highest to lowest density
     dmoc(:,:,nbins) = dmoc(:,:,nbins)/1.e6
     DO jk=nbins-1, 1, -1
        dmoc(:,:,jk) = dmoc(:,:,jk+1) + dmoc(:,:,jk)/1.e6
     END DO  ! loop to next bin

     ! netcdf output  
     DO jbasin = 1, nbasins
        DO jk = 1, nbins
           ierr = putvar (ncout, id_varout(jbasin), REAL(dmoc(jbasin,:,jk)), jk, 1, npjglo)
        END DO
     END DO

  ENDDO  ! time loop

  ierr = closeout(ncout)

END PROGRAM cdfmocsig
   

PROGRAM cdfuvwt
  !!======================================================================
  !!                     ***  PROGRAM  cdfuvwt  ***
  !!=====================================================================
  !!  ** Purpose : Compute mean values of some quantities, required for
  !!               other cdftools ( cdfbci, cdfbti and cdfnrjcomp).
  !!               At U point : ubar, u2bar
  !!               At V point : vbar, v2bar
  !!               At W point : wbar
  !!               AT T point : tbar, t2bar, uvbar, utbar, vtbar, wtbar
  !!
  !!  ** Method  : take care of double precision on product
  !!
  !! History : 2.1  : 02/2008  : A. Melet     : Original code
  !!           3.0  : 06/2011  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  USE modutils    ! SetFileName function
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class second_order_moments
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4), PARAMETER                    :: jp_var = 11
  INTEGER(KIND=4)                               :: ji, jj, jk, jt, jtt
  INTEGER(KIND=4)                               :: ntframe
  INTEGER(KIND=4)                               :: npiglo, npjglo
  INTEGER(KIND=4)                               :: npk, npt, ntags
  INTEGER(KIND=4)                               :: iimin, iimax, ijmin, ijmax
  INTEGER(KIND=4)                               :: iup=1, idwn=2
  INTEGER(KIND=4)                               :: narg, iargc, ijarg
  INTEGER(KIND=4)                               :: ncout
  INTEGER(KIND=4)                               :: ierr
  INTEGER(KIND=4), DIMENSION(jp_var)            :: ipk, id_varout         ! 

  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: u2d, v2d, t2d
  REAL(KIND=4), DIMENSION(:,:,:),   ALLOCATABLE :: w2d

  REAL(KIND=8)                                  :: dcoef
  REAL(KIND=8)                                  :: dtotal_time
  REAL(KIND=8), DIMENSION(:),       ALLOCATABLE :: dtim
  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: dtabu, dtabv, dtabu2, dtabv2, dtabuv
  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: dtabw, dtabt, dtabut, dtabvt, dtabt2
  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: dtabwt

  CHARACTER(LEN=256)                            :: cf_ufil, cf_vfil
  CHARACTER(LEN=256)                            :: cf_wfil, cf_tfil
  CHARACTER(LEN=256)                            :: cf_out='moyuvwt.nc'
  CHARACTER(LEN=256)                            :: cldum
  CHARACTER(LEN=256)                            :: config , ctag
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: ctag_lst

  TYPE (variable), DIMENSION(jp_var)            :: stypvar         ! structure for attibutes

  LOGICAL                                       :: lnc4 = .FALSE.  ! Use nc4 with chunking and deflation
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()
  !!
  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfuvwt -c CONFCASE -l LST-tags [-w imin imax jmin jmax] ...'
     PRINT *,'               ... [-o OUT-file] [-nc4]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the time-mean fields for velocity components (u,v,w) and' 
     PRINT *,'       temperature (t), as well as second order moments ( u2, v2, t2, uv, ut,'
     PRINT *,'       vt, wt).'
     PRINT *,'       These fields are required in other cdftools which computes either '
     PRINT *,'       barotropic (cdfnrj_bti) or baroclinic (cdfnrj_bci) instabilities, and a'
     PRINT *,'       global energy balance (cdfnrj_components)'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -c CONFCASE : the root name for the data files. Grid files are assumed '
     PRINT *,'                to be gridT, gridU, gridV, gridW. (grid_T, grid_U, grid_V and'
     PRINT *,'                grid_W are also supported).'
     PRINT *,'       -l LST-tags : set the list of time tags corresponding to the time serie'
     PRINT *,'                whose mean is being computed.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-w imin imax jmin jmax ] : model window limiting the area where the'
     PRINT *,'                time-means will be computed.'
     PRINT *,'       [-o OUT-file] : specify output file name instead of ',TRIM(cf_out)
     PRINT *,'       [-nc4]   : Use netcdf4 output with chunking and deflation level 1.'
     PRINT *,'             This option is effective only if cdftools are compiled with'
     PRINT *,'             a netcdf library supporting chunking and deflation.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       none' 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables :  There are 11 variables produced by this program.'
     PRINT *,'                 tbar, t2bar : mean t (Kelvin) and mean t^2 (K^2)   [T-point]'
     PRINT *,'                 ubar, u2bar : mean u (m/s) and mean u^2 (m2/s2)    [U-point]'
     PRINT *,'                 vbar, v2bar : mean v (m/s) and mean v^2 (m2/s2)    [V-point]'
     PRINT *,'                 wbar        : mean w (m/s)                         [W-point]'
     PRINT *,'                 uvbar       : mean product u . v (m2/s2)           [T-point]'       
     PRINT *,'                 utbar, vtbar, wtbar : mean product [uvw].t (m/s.K) [T-point]'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'      cdfnrj_bti, cdfnrj_bci, cdfnrj_components and cdfnrj_transfert.' 
     PRINT *,'      '
     STOP 
  ENDIF

  iimin=0 ; ijmin=0
  iimax=0 ; ijmax=0

  ijarg = 1 
  DO WHILE ( ijarg <= narg )
     CALL getarg(ijarg, cldum) ; ijarg = ijarg +1
     SELECT CASE (cldum)
     CASE ( '-c'  ) ; CALL getarg(ijarg, config) ; ijarg=ijarg+1
     CASE ( '-l'  ) ; CALL GetTagList
        ! options
     CASE ( '-w'  ) ; CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1 ; READ(cldum,*) iimin
        ;             CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1 ; READ(cldum,*) iimax
        ;             CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1 ; READ(cldum,*) ijmin
        ;             CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1 ; READ(cldum,*) ijmax
     CASE ( '-o'  ) ; CALL getarg(ijarg, cf_out) ; ijarg=ijarg+1
     CASE ( '-nc4') ; lnc4 = .TRUE.
     CASE DEFAULT   ; PRINT *,' ERROR : ',TRIM(cldum), ' : unknown option.' ; STOP 99
     END SELECT
  END DO

  cf_ufil = SetFileName( config, ctag_lst(1), 'U')

  ! assume all input files have same spatial size
  npiglo = getdim (cf_ufil, cn_x )
  npjglo = getdim (cf_ufil, cn_y )
  npk    = getdim (cf_ufil, cn_z )

  ! modify sizes with respect to working window  area
  IF (iimin /= 0 ) THEN ; npiglo=iimax -iimin + 1 ; ELSE ; iimin=1 ; iimax=npiglo ; ENDIF
  IF (ijmin /= 0 ) THEN ; npjglo=ijmax -ijmin + 1 ; ELSE ; ijmin=1 ; ijmax=npjglo ; ENDIF

  PRINT *, ' npiglo = ', npiglo
  PRINT *, ' npjglo = ', npjglo
  PRINT *, ' npk    = ', npk

  ! Allocate the memory
  ALLOCATE ( u2d(npiglo,npjglo), v2d(npiglo,npjglo)   )
  ALLOCATE ( t2d(npiglo,npjglo), w2d(npiglo,npjglo,2) )

  ALLOCATE ( dtabu(npiglo,npjglo), dtabu2(npiglo,npjglo), dtabut(npiglo,npjglo) )
  ALLOCATE ( dtabv(npiglo,npjglo), dtabv2(npiglo,npjglo), dtabvt(npiglo,npjglo) )
  ALLOCATE ( dtabt(npiglo,npjglo), dtabt2(npiglo,npjglo)                        )
  ALLOCATE ( dtabw(npiglo,npjglo),                        dtabwt(npiglo,npjglo) )
  ALLOCATE (                                              dtabuv(npiglo,npjglo) )

  CALL CreateOutput

  DO jk=1, npk-1   ! level npk is masked for T U V and is 0 for W ( bottom ) !
     PRINT *,'            level ',jk
     dtotal_time  = 0.d0 ;  ntframe=0 
     dtabu(:,:)   = 0.d0 ; dtabv(:,:)  = 0.d0 ; dtabuv(:,:) = 0.d0 
     dtabu2(:,:)  = 0.d0 ; dtabv2(:,:) = 0.d0 ; dtabt(:,:)  = 0.d0 
     dtabw(:,:)   = 0.d0 ; dtabut(:,:) = 0.d0 ; dtabvt(:,:) = 0.d0 
     dtabt2(:,:)  = 0.d0 ; dtabwt(:,:) = 0.d0

     DO jt= 1, ntags
        ctag    = ctag_lst(jt)
        cf_ufil = SetFileName( config, ctag_lst(jt), 'U')
        cf_vfil = SetFileName( config, ctag_lst(jt), 'V')
        cf_wfil = SetFileName( config, ctag_lst(jt), 'W')
        cf_tfil = SetFileName( config, ctag_lst(jt), 'T')
        
        IF ( jk == 1 ) THEN
           npt = getdim(cf_ufil, cn_t)
           ALLOCATE ( dtim(npt) )
           dtim=getvar1d(cf_ufil, cn_vtimec, npt)
           dtotal_time = dtotal_time + SUM(dtim)
           DEALLOCATE ( dtim )
        ENDIF

        DO jtt = 1, npt
           ntframe  = ntframe+1
           u2d(:,:)      = getvar(cf_ufil, cn_vozocrtx, jk,   npiglo, npjglo, kimin=iimin, kjmin=ijmin, ktime=jtt )
           v2d(:,:)      = getvar(cf_vfil, cn_vomecrty, jk,   npiglo, npjglo, kimin=iimin, kjmin=ijmin, ktime=jtt )
           w2d(:,:,iup)  = getvar(cf_wfil, cn_vovecrtz, jk,   npiglo, npjglo, kimin=iimin, kjmin=ijmin, ktime=jtt )
           w2d(:,:,idwn) = getvar(cf_wfil, cn_vovecrtz, jk+1, npiglo, npjglo, kimin=iimin, kjmin=ijmin, ktime=jtt )
           t2d(:,:)      = getvar(cf_tfil, cn_votemper, jk,   npiglo, npjglo, kimin=iimin, kjmin=ijmin, ktime=jtt )
           WHERE ( t2d /= 0. ) t2d = t2d + 273.15   ! from C to K

           dtabu(:,:)  = dtabu(:,:)  + u2d(:,:)
           dtabu2(:,:) = dtabu2(:,:) + u2d(:,:) * u2d(:,:) * 1.d0
           dtabv(:,:)  = dtabv(:,:)  + v2d(:,:)
           dtabv2(:,:) = dtabv2(:,:) + v2d(:,:) * v2d(:,:) * 1.d0
           dtabw(:,:)  = dtabw(:,:)  + w2d(:,:,iup)
           dtabt(:,:)  = dtabt(:,:)  + t2d(:,:)
           dtabt2(:,:) = dtabt2(:,:) + t2d(:,:) * t2d(:,:) * 1.d0

           DO jj = npjglo, 2 , -1
              DO ji = npiglo, 2 , -1
                 ! put u, v on T point ( note the loops starting from the end for using u2d and v2d as tmp array)
                 u2d(ji,jj) = 0.5 * ( u2d(ji,jj) + u2d(ji-1,jj  ) )
                 v2d(ji,jj) = 0.5 * ( v2d(ji,jj) + v2d(ji,  jj-1) )
              END DO
           END DO
           u2d(1,:) = 0. ; u2d(:,1) = 0.
           v2d(1,:) = 0. ; v2d(:,1) = 0.
           w2d(:,:,iup) = 0.5 * ( w2d(:,:,iup) + w2d(:,:,idwn) )  ! W at  T point

           dtabuv(:,:) = dtabuv(:,:) + u2d(:,:)     * v2d(:,:) * 1.d0
           dtabut(:,:) = dtabut(:,:) + u2d(:,:)     * t2d(:,:) * 1.d0
           dtabvt(:,:) = dtabvt(:,:) + v2d(:,:)     * t2d(:,:) * 1.d0
           dtabwt(:,:) = dtabwt(:,:) + w2d(:,:,iup) * t2d(:,:) * 1.d0

        END DO  ! jtt
     END DO     ! tags

     dcoef = 1.d0 / ntframe

     ! save on file
     ierr = putvar(ncout, id_varout( 1), REAL(dtabu * dcoef), jk, npiglo, npjglo )
     ierr = putvar(ncout, id_varout( 2), REAL(dtabv * dcoef), jk, npiglo, npjglo )
     ierr = putvar(ncout, id_varout( 3), REAL(dtabu2* dcoef), jk, npiglo, npjglo )
     ierr = putvar(ncout, id_varout( 4), REAL(dtabv2* dcoef), jk, npiglo, npjglo )
     ierr = putvar(ncout, id_varout( 5), REAL(dtabuv* dcoef), jk, npiglo, npjglo )
     ierr = putvar(ncout, id_varout( 6), REAL(dtabw * dcoef), jk, npiglo, npjglo )
     ierr = putvar(ncout, id_varout( 7), REAL(dtabt * dcoef), jk, npiglo, npjglo )
     ierr = putvar(ncout, id_varout( 8), REAL(dtabut* dcoef), jk, npiglo, npjglo )
     ierr = putvar(ncout, id_varout( 9), REAL(dtabvt* dcoef), jk, npiglo, npjglo )
     ierr = putvar(ncout, id_varout(10), REAL(dtabt2* dcoef), jk, npiglo, npjglo )
     ierr = putvar(ncout, id_varout(11), REAL(dtabwt* dcoef), jk, npiglo, npjglo )

  END DO   ! loop on level

  ! fill up empty last level
  dtabu = 0.d0  ! reset this dummy array to 0 for npk output
  DO jk= 1, jp_var
     ierr  = putvar(ncout, id_varout(jk), REAL(dtabu), npk, npiglo, npjglo )
  END DO

  ierr = putvar1d(ncout, (/dtotal_time*dcoef/), 1, 'T')
  ierr = closeout(ncout)

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    INTEGER(KIND=4) :: jv
    !!----------------------------------------------------------------------
  DO jv=1,jp_var
     stypvar(jv)%ichunk   = (/npiglo,MAX(1,npjglo/30),1,1 /)
  ENDDO
  ipk(:) = npk  

  stypvar( 1)%cname       = 'ubar'
  stypvar( 1)%clong_name  = 'temporal mean of u on U point'
  stypvar( 1)%cshort_name = 'ubar'
  stypvar( 1)%cunits      = 'm/s'

  stypvar( 2)%cname       = 'vbar'
  stypvar( 2)%clong_name  = 'temporal mean of v on V point'
  stypvar( 2)%cshort_name = 'vbar'
  stypvar( 2)%cunits      = 'm/s'

  stypvar( 3)%cname       = 'u2bar'
  stypvar( 3)%clong_name  = 'temporal mean of u * u on U point'
  stypvar( 3)%cshort_name = 'u2bar'
  stypvar( 3)%cunits      = 'm2/s2'

  stypvar( 4)%cname       = 'v2bar'
  stypvar( 4)%clong_name  = 'temporal mean of v * v on V point'
  stypvar( 4)%cshort_name = 'v2bar'
  stypvar( 4)%cunits      = 'm2/s2'

  stypvar( 5)%cname       = 'uvbar'
  stypvar( 5)%clong_name  = 'temporal mean of u * v on T point'
  stypvar( 5)%cshort_name = 'uvbar'
  stypvar( 5)%cunits      = 'm2/s2'

  stypvar( 6)%cname       = 'wbar'
  stypvar( 6)%clong_name  = 'temporal mean of w on W point'
  stypvar( 6)%cshort_name = 'wbar'
  stypvar( 6)%cunits      = 'm/s'

  stypvar( 7)%cname       = 'tbar'
  stypvar( 7)%clong_name  = 'temporal mean of T on T point in K'
  stypvar( 7)%cshort_name = 'tbar'
  stypvar( 7)%cunits      = 'K'

  stypvar( 8)%cname       = 'utbar'
  stypvar( 8)%clong_name  = 'temporal mean of u * T (in K) on T point'
  stypvar( 8)%cshort_name = 'utbar'
  stypvar( 8)%cunits      = 'm/s.K'

  stypvar( 9)%cname       = 'vtbar'
  stypvar( 9)%clong_name  = 'temporal mean of v * T (in K) on T point'
  stypvar( 9)%cshort_name = 'vtbar'
  stypvar( 9)%cunits      = 'm/s.K'

  stypvar(10)%cname       = 't2bar'
  stypvar(10)%clong_name  = 'temporal mean of T * T on T point in K^2'
  stypvar(10)%cshort_name = 't2bar'
  stypvar(10)%cunits      = 'K2'

  stypvar(11)%cname       = 'wtbar'
  stypvar(11)%clong_name  = 'temporal mean of w * T (in K) on T point'
  stypvar(11)%cshort_name = 'wtbar'
  stypvar(11)%cunits      = 'm/s.K'

  stypvar%rmissing_value    = 0.
  stypvar%valid_min         = -1000.
  stypvar%valid_max         = 1000.
  stypvar%conline_operation = 'N/A'
  stypvar%caxis             = 'TYX'

  ! create output fileset
  ncout = create      (cf_out, cf_ufil, npiglo, npjglo, npk       , ld_nc4=lnc4 )
  ierr  = createvar   (ncout,  stypvar, jp_var, ipk,    id_varout , ld_nc4=lnc4 )
  ierr  = putheadervar(ncout,  cf_ufil, npiglo, npjglo, npk       )

  END SUBROUTINE CreateOutput

  SUBROUTINE GetTagList
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE GetTagList  ***
    !!
    !! ** Purpose :  Set up a tag list given on the command line as 
    !!               blank separated list
    !!
    !! ** Method  :  Scan the command line until a '-' is found
    !!----------------------------------------------------------------------
    INTEGER (KIND=4)  :: ji
    INTEGER (KIND=4)  :: icur
    !!----------------------------------------------------------------------
    !!
    ntags=0
    ! need to read a list of file ( number unknow ) 
    ! loop on argument till a '-' is found as first char
    icur=ijarg                          ! save current position of argument number
    DO ji = icur, narg                  ! scan arguments till - found
       CALL getarg ( ji, cldum )
       IF ( cldum(1:1) /= '-' ) THEN ; ntags = ntags+1
       ELSE                          ; EXIT
       ENDIF
    ENDDO
    ALLOCATE (ctag_lst(ntags) )
    DO ji = icur, icur + ntags -1
       CALL getarg(ji, ctag_lst( ji -icur +1 ) ) ; ijarg=ijarg+1
    END DO
  END SUBROUTINE GetTagList

END PROGRAM cdfuvwt

PROGRAM cdfnorth_unfold
  !!======================================================================
  !!                     ***  PROGRAM  cdfnorth_unfold  ***
  !!=====================================================================
  !!  ** Purpose : Unfold the arctic ocean in an ORCA like configuration
  !!               for all the variables of the file given in the arguments
  !!
  !!  ** Method  : read the filename, the limit of the extracted zone, and
  !!              the type of pivot to use and the C-grid point of variables
  !!
  !! History : 2.1  : 04/2010  : J.M. Molines : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  !!
  !!   unfold     unfold the north pole of orca grid
  !!   chkisig    function to determine if the variable changes sign
  !!              when folded
  !!----------------------------------------------------------------------
  USE cdfio 
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                               :: jk, jt, jvar, jv         ! dummy loop index
  INTEGER(KIND=4)                               :: ierr                     ! working integer
  INTEGER(KIND=4)                               :: narg, iargc              ! browse line
  INTEGER(KIND=4)                               :: npiglo, npjglo, npk, npt ! size of the domain
  INTEGER(KIND=4)                               :: nvars                    ! Number of variables in a file
  INTEGER(KIND=4)                               :: ijatl, ijpacif           ! j starting position in atl and pacif
  INTEGER(KIND=4)                               :: npiarctic, npjarctic     ! size of the output arrays file
  INTEGER(KIND=4)                               :: isig                     ! change sign indicator
  INTEGER(KIND=4)                               :: nipivot                  ! i position of pivot
  INTEGER(KIND=4)                               :: ncout                    ! ncid of output file
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: id_var                   ! arrays of var id's (input)
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: ipk, id_varout           ! level and varid of output var

  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: tab                      ! output array
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: tablon, tablat           ! output longitude and latitude
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: v2d                      ! Array to read a layer of data
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: tim                      ! time counter

  CHARACTER(LEN=256)                            :: cf_in                    ! input file name
  CHARACTER(LEN=256)                            :: cf_out='unfold.nc'       ! output file names 
  CHARACTER(LEN=256)                            :: cv_dep                   ! depth name
  CHARACTER(LEN=256)                            :: cpivot                   ! pivot position
  CHARACTER(LEN=256)                            :: ctype                    ! variable position
  CHARACTER(LEN=256)                            :: cglobal                  ! variable position
  CHARACTER(LEN=256)                            :: cldum                    ! dummy string
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_names                 ! array of var name

  TYPE (variable), DIMENSION(:),    ALLOCATABLE :: stypvar                  ! output var attribute

  LOGICAL                                       :: lchk=.false.             ! flag for consistency check
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg /=5 ) THEN
     PRINT *,' usage : cdfnorth_unfold IN-file jatl jpacif pivot Cgrid_point'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Unfold the Artic Ocean in an ORCA configuration. Produce a netcdf' 
     PRINT *,'       file with the Artic ocean as a whole. The area can be adjusted on'
     PRINT *,'       both Atlantic and Pacific sides.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       IN-file     : netcdf file to be unfolded.' 
     PRINT *,'       jatl        : J index to start the unfold process in the Atlantic.'
     PRINT *,'       jpacif      : J index to start the unfold process in the Pacific.'
     PRINT *,'       pivot       : type of pivot for the north fold condition ( T or F )'
     PRINT *,'       Cgrid_point : grid point where the variables in the input file are'
     PRINT *,'                     located. If all variables in a single file are not on'
     PRINT *,'                     the same C-grid location, there might be a problem ...'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        none'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : same name and units than in the input file.'
     STOP
  ENDIF

  CALL getarg (1, cf_in )
  CALL getarg (2, cldum ) ; READ(cldum,*) ijatl
  CALL getarg (3, cldum ) ; READ(cldum,*) ijpacif
  CALL getarg (4, cpivot) 
  CALL getarg (5, ctype )
  
  IF ( chkfile(cf_in) ) STOP 99 ! missing file

  WRITE(cglobal,9000) 'cdfnorth_unfold ',TRIM(cf_in), ijatl, ijpacif, TRIM(cpivot), TRIM(ctype)
9000 FORMAT(a,a,2i5,a,1x,a)

  npiglo = getdim (cf_in, cn_x                             )
  npjglo = getdim (cf_in, cn_y                             )
  npt    = getdim (cf_in, cn_t                             )
  npk    = getdim (cf_in, cn_z, cdtrue=cv_dep, kstatus=ierr)

  IF (ierr /= 0 ) THEN
     npk   = getdim (cf_in,'z',cdtrue=cv_dep,kstatus=ierr)
     IF (ierr /= 0 ) THEN
        npk   = getdim (cf_in,'sigma',cdtrue=cv_dep,kstatus=ierr)
        IF ( ierr /= 0 ) THEN
           npk = getdim (cf_in,'nav_lev',cdtrue=cv_dep,kstatus=ierr)
           IF ( ierr /= 0 ) THEN
              PRINT *,' assume file with no depth'
              npk=0
           ENDIF
        ENDIF
     ENDIF
  ENDIF

  ! to be improved
  npiarctic = npiglo/2
  nipivot   = npiglo/2

  SELECT CASE ( cpivot )
  CASE ( 'T','t') ; npjarctic=(npjglo-ijatl+1)  + (npjglo -ijpacif +1) -3
  CASE ( 'F','f') ; npjarctic=(npjglo-ijatl+1)  + (npjglo -ijpacif +1) -2
  END SELECT

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  ALLOCATE( tab(npiarctic, npjarctic),  v2d(npiglo,npjglo), tim(npt)   )
  ALLOCATE( tablon(npiarctic, npjarctic), tablat(npiarctic, npjarctic) )

  nvars = getnvar(cf_in)
  PRINT *,' nvars = ', nvars

  ALLOCATE (cv_names(nvars) )
  ALLOCATE (stypvar(nvars) )
  ALLOCATE (id_var(nvars), ipk(nvars), id_varout(nvars) )

  ! get list of variable names and collect attributes in stypvar (optional)
  cv_names(:) = getvarname(cf_in, nvars, stypvar)

  id_var(:)  = (/(jv, jv=1,nvars)/)
  ! ipk gives the number of level or 0 if not a T[Z]YX  variable
  ipk(:)     = getipk (cf_in, nvars, cdep=cv_dep)

  WHERE( ipk == 0 ) cv_names = 'none'
  stypvar(:)%cname = cv_names

  v2d=getvar(cf_in, cn_vlon2d, 1, npiglo, npjglo)
  CALL unfold(v2d ,tablon, ijatl, ijpacif, cpivot, ctype, 1)

  v2d=getvar(cf_in, cn_vlat2d, 1, npiglo, npjglo)
  CALL unfold(v2d ,tablat, ijatl, ijpacif, cpivot, ctype, 1)

  ! create output file taking the sizes in cf_in
  ncout = create      (cf_out, cf_in,   npiarctic, npjarctic, npk,                                 cdep=cv_dep)
  ierr  = createvar   (ncout,  stypvar, nvars,     ipk,       id_varout, cdglobal=TRIM(cglobal)               )
  ierr  = putheadervar(ncout,  cf_in,   npiarctic, npjarctic, npk, pnavlon=tablon, pnavlat=tablat, cdep=cv_dep)

  tim  = getvar1d(cf_in, cn_vtimec, npt     )
  ierr = putvar1d(ncout, tim,       npt, 'T')

  ! default value
  isig =  1

  DO jvar = 1,nvars
     PRINT *,' Working with ', TRIM(cv_names(jvar)), ipk(jvar)
     DO jk = 1, ipk(jvar)
        PRINT *,'level ',jk
        tab(:,:) = 0.
        DO jt=1,npt
           v2d(:,:) = getvar(cf_in, cv_names(jvar), jk, npiglo, npjglo, ktime=jt )

           IF ( jk == 1 .AND. jt == 1) THEN ! look for correct isig
              isig=chkisig( cpivot, ctype, v2d, lchk)
              PRINT *,'ISIG=', isig
           ENDIF

           CALL unfold(v2d, tab, ijatl, ijpacif, cpivot, ctype, isig)
           ierr = putvar(ncout, id_varout(jvar), tab, jk, npiarctic, npjarctic)
        ENDDO
     END DO  ! loop to next level
  END DO ! loop to next var in file

  ierr = closeout(ncout)

CONTAINS

 
  INTEGER(KIND=4) FUNCTION chkisig (cdpivot, cdtype, ptab, ldchk)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION chkisig  ***
    !!
    !! ** Purpose : from the input data determine if the field is to be 
    !!              multiplied by -1 in the unfolding process  or not.
    !!              if ldchk is true, proceed to an extended check of the 
    !!              overlaping area (not written yet)
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*),             INTENT(in) :: cdpivot, cdtype
    REAL(KIND=4), DIMENSION(:,:), INTENT(in) :: ptab
    LOGICAL,                      INTENT(in) :: ldchk
    ! 
    INTEGER(KIND=4)                          :: ii, ij
    REAL(KIND=4)                             :: zrat
    !!----------------------------------------------------------------------

    IF ( ldchk ) THEN
      PRINT *,' Full check not written yet ' ; STOP 99
    ELSE
    SELECT CASE ( cdpivot)
    CASE ( 'T','t')
       SELECT CASE (cdtype )
       CASE ( 'T','t') 
          ii = 1
          DO WHILE ( ptab(ii,npjglo-1)  == 0 .AND. ii < npiglo ) 
             ii = ii+1
          ENDDO
          IF ( ii /=  npiglo )  THEN
             ij = 2*nipivot - ii +2
             zrat = ptab(ij,npjglo-1) / ptab(ii,npjglo-1)
             IF ( ABS(zrat) /= 1. ) THEN
                PRINT *, 'INCOHERENT value in T point ', TRIM(cv_names(jvar)), zrat
                ierr = closeout(ncout)
                STOP 99
             ELSE
                chkisig = zrat
             ENDIF
          ENDIF
       CASE ( 'U','u') 
          ii = 1
          DO WHILE ( ptab(ii,npjglo-1) == 0  .AND. ii < npiglo )
             ii = ii+1
          ENDDO
          ij = 2*nipivot - ii + 1
          zrat = ptab(ij,npjglo-1) / ptab(ii,npjglo-1)
          IF ( ABS(zrat) /= 1. ) THEN
             PRINT *, 'INCOHERENT value in U point ', TRIM(cv_names(jvar)), zrat
             ierr = closeout(ncout)
             STOP 99
          ELSE
             chkisig=zrat
          ENDIF
       CASE ( 'V','v') 
          ii = 1
          DO WHILE ( ptab(ii,npjglo-1) == 0 .AND. ii < npiglo )
             ii = ii+1
          ENDDO
          ij = 2*nipivot - ii + 2
          zrat = ptab(ij,npjglo-2) / ptab(ii,npjglo-1)
          IF ( ABS(zrat) /= 1. ) THEN
             PRINT *, 'INCOHERENT value in V point ', TRIM(cv_names(jvar)), zrat
             ierr = closeout(ncout)
             STOP 99
          ELSE
             chkisig=zrat
          ENDIF
       END SELECT
    CASE ( 'F','f')
       PRINT *, 'F pivot not done yet ' ; STOP 99
    END SELECT
    ENDIF

  END FUNCTION chkisig


  SUBROUTINE unfold( ptabin, ptabout, kjatl, kjpacif, cdpivot, cdtype, ksig)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE unfold  ***
    !!
    !! ** Purpose : unfold the north pole
    !!
    !! -----------------------------------------------------------------------
    REAL(KIND=4), DIMENSION(npiglo,npjglo),       INTENT(in ) :: ptabin
    REAL(KIND=4), DIMENSION(npiarctic,npjarctic), INTENT(out) :: ptabout
    INTEGER(KIND=4),                              INTENT(in ) :: kjatl
    INTEGER(KIND=4),                              INTENT(in ) :: kjpacif
    CHARACTER(LEN=*),                             INTENT(in ) :: cdpivot
    CHARACTER(LEN=*),                             INTENT(in ) :: cdtype
    INTEGER(KIND=4),                              INTENT(in ) :: ksig

    INTEGER(KIND=4)                                           :: ji, jj
    INTEGER(KIND=4)                                           :: ipivot
    INTEGER(KIND=4)                                           :: ijn, ii, ij
    !! -----------------------------------------------------------------------
    !
    ipivot=npiglo/2
    DO jj=kjatl, npjglo
       ij = jj-kjatl+1
       ptabout(:,ij) = ptabin(ipivot:npiglo,jj)
    ENDDO

    ijn=ij

    SELECT CASE ( cdpivot )
    CASE ('T','t')   ! pivot
       SELECT CASE ( cdtype )
       CASE ('T','t')
          DO jj=npjglo-3,kjpacif, -1
             ij=  ijn + ( npjglo - 3  - jj ) +1 !  2 *npjglo - kjatl -1 -jj
             DO ji = 2, npiarctic
                ii = ipivot - ji + 3 
                ptabout(ji,ij) = ksig * ptabin(ii, jj)
             ENDDO
          ENDDO
       CASE ('V','v')
          DO jj=npjglo-4,kjpacif-1, -1
             ij=  ijn + ( npjglo - 4  - jj ) +1 !  2 *npjglo - kjatl -1 -jj
             DO ji = 2, npiarctic
                ii = ipivot - ji + 3
                ptabout(ji,ij) = ksig * ptabin(ii, jj)
             ENDDO
          ENDDO
       CASE ('U','u')
          DO jj=npjglo-3,kjpacif, -1
             ij=  ijn + ( npjglo - 3  - jj ) +1 !  2 *npjglo - kjatl -1 -jj
             DO ji = 1, npiarctic
                ii = ipivot -ji + 2
                ptabout(ji,ij) = ksig * ptabin(ii, jj)
             ENDDO
          ENDDO
       END SELECT
    CASE ('F','f')   ! pivot
       PRINT * , ' Not yet done for F pivot ' ; STOP 99
    END SELECT

  END SUBROUTINE unfold

END PROGRAM cdfnorth_unfold

PROGRAM cdf2matlab
  !!======================================================================
  !!                     ***  PROGRAM  cdf2matlab  ***
  !!=====================================================================
  !!  ** Purpose : Reshapes ORCA grids to be matlab-friendly
  !!
  !!  ** Method  : transform input file with monotonically increasing
  !!               longitudes.
  !!
  !! History : 2.1  : 01/2011  : R. Dussin    : Original code
  !!           3.0  : 03/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: ji, jj              ! dummy loop index
  INTEGER(KIND=4)                           :: narg, iargc         ! 
  INTEGER(KIND=4)                           :: npiglo, npjglo, npk ! size of the domain
  INTEGER(KIND=4)                           :: npiglox2            ! new model size in x
  INTEGER(KIND=4)                           :: ilev, iindex, itmp
  INTEGER(KIND=4)                           :: ncout
  INTEGER(KIND=4)                           :: ierr
  INTEGER(KIND=4), DIMENSION(3)             :: ipk, id_varout

  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zlon, zlat, zvar    ! input arrays
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zlonout, zlatout    ! output arrays
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zlonwork, zlatwork  ! working arrays arrays
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zvarout, zvarwork   ! working arrays arrays
  REAL(KIND=4), DIMENSION(1)                :: tim

  CHARACTER(LEN=256)                        :: cf_in               ! input file name
  CHARACTER(LEN=256)                        :: cf_out='output.nc'  ! output file name
  CHARACTER(LEN=256)                        :: cv_in               ! input variable  name
  CHARACTER(LEN=256)                        :: cldum               !  dummy character variable

  TYPE(variable), DIMENSION(3)              :: stypvar             ! structure for attribute
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg /= 3 ) THEN
     PRINT *,' usage : cdf2matlab IN-file IN-var level '
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Convert global nemo input file (ORCA configurations) into' 
     PRINT *,'       a file with monotonically increasing longitudes.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       IN-file : input model file.' 
     PRINT *,'       IN-var  : netcdf variable name to process.'
     PRINT *,'       level   : level to process.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        none'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : same name than in input file.'
     STOP
  ENDIF
  !!
  !! Initialisation from 1st file (all file are assume to have the same geometry)
  CALL getarg (1, cf_in)
  CALL getarg (2, cv_in)
  CALL getarg (3, cldum) ; READ(cldum,*) ilev

  IF ( chkfile (cf_in) ) STOP  ! missing file

  npiglo = getdim (cf_in,cn_x)
  npjglo = getdim (cf_in,cn_y)
  npk    = getdim (cf_in,cn_z)

  ipk(:)                       = 1
  stypvar(1)%cname             = 'lon'
  stypvar(1)%cunits            = 'degrees'
  stypvar(1)%valid_min         = -180.
  stypvar(1)%valid_max         = 540.
  stypvar(1)%clong_name        = 'longitude'
  stypvar(1)%cshort_name       = 'lon'
  stypvar(1)%conline_operation = 'N/A'
  stypvar(1)%caxis             = 'YX'

  stypvar(2)%cname             = 'lat'
  stypvar(2)%cunits            = 'degrees'
  stypvar(2)%rmissing_value    = 0.
  stypvar(2)%valid_min         = -90.
  stypvar(2)%valid_max         = 90.
  stypvar(2)%clong_name        = 'latitude'
  stypvar(2)%cshort_name       = 'lat'
  stypvar(2)%conline_operation = 'N/A'
  stypvar(2)%caxis             = 'YX'

  stypvar(3)%cname             = cv_in
  stypvar(3)%cunits            = ''
  stypvar(3)%rmissing_value    = 0.
  stypvar(3)%clong_name        = ''
  stypvar(3)%cshort_name       = cv_in
  stypvar(3)%conline_operation = 'N/A'
  stypvar(3)%caxis             = 'TYX'

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk

  npiglox2 = 2 * npiglo

  ALLOCATE( zvar(npiglo,npjglo), zlon(npiglo,npjglo), zlat(npiglo,npjglo) )
  ALLOCATE( zvarout(npiglox2,npjglo), zlonout(npiglox2,npjglo), zlatout(npiglox2,npjglo) )

  ncout = create    (cf_out,   cf_in,   npiglox2, npjglo, 1         )
  ierr  = createvar (ncout,    stypvar, 3,        ipk,    id_varout )

  zlon(:,:) = getvar(cf_in, cn_vlon2d, 1,    npiglo, npjglo)
  zlat(:,:) = getvar(cf_in, cn_vlat2d, 1,    npiglo, npjglo)
  zvar(:,:) = getvar(cf_in, cv_in,     ilev, npiglo, npjglo)

  DO jj=1,npjglo
     iindex = MINLOC( ABS(zlon(:,jj) + 180 ),1 ) ! find the discontinuity in lon array
     itmp   = npiglo - iindex + 1

     zlonout(1:itmp,jj) = zlon(iindex:npiglo,jj) ; zlonout(itmp+1:npiglo,jj) = zlon(1:iindex-1,jj)
     zlonout(npiglo+1:npiglo+itmp  ,jj) = zlon(iindex:npiglo,jj) + 360. 
     zlonout(npiglo+itmp+1:npiglox2,jj) = zlon(1:iindex-1,   jj) + 360.

     zlatout(1:itmp,jj) = zlat(iindex:npiglo,jj) ; zlatout(itmp+1:npiglo,jj) = zlat(1:iindex-1,jj)
     zlatout(npiglo+1:npiglo+itmp,  jj) = zlat(iindex:npiglo,jj)  
     zlatout(npiglo+itmp+1:npiglox2,jj) = zlat(1:iindex-1,   jj) 

     zvarout(1:itmp,jj) = zvar(iindex:npiglo,jj) ; zvarout(itmp+1:npiglo,jj) = zvar(1:iindex-1,jj)
     zvarout(npiglo+1:npiglo+itmp,  jj) = zvar(iindex:npiglo,jj)  
     zvarout(npiglo+itmp+1:npiglox2,jj) = zvar(1:iindex-1,   jj) 
  END DO

  ! Special treatement for ORCA2

  IF ( ( npiglo == 182 ) .AND. ( npjglo == 149 ) ) THEN
     PRINT *, 'Assuming that this config is ORCA2 !'

     ALLOCATE( zvarwork(npiglox2,npjglo), zlonwork(npiglox2,npjglo), zlatwork(npiglox2,npjglo) )

     !! init the arryas
     zlonwork(:,:) = zlonout(:,:)
     zlatwork(:,:) = zlatout(:,:)
     zvarwork(:,:) = zvarout(:,:)

     !! swap values to keep lon increasing 
     zlonwork(131,:) = zlonout(130,:) ; zlonwork(npiglo+131,:) = zlonout(npiglo+130,:)
     zlatwork(131,:) = zlatout(130,:) ; zlatwork(npiglo+131,:) = zlatout(npiglo+130,:)
     zvarwork(131,:) = zvarout(130,:) ; zvarwork(npiglo+131,:) = zvarout(npiglo+130,:)

     zlonwork(130,:) = zlonout(131,:) ; zlonwork(npiglo+130,:) = zlonout(npiglo+131,:)
     zlatwork(130,:) = zlatout(131,:) ; zlatwork(npiglo+130,:) = zlatout(npiglo+131,:)
     zvarwork(130,:) = zvarout(131,:) ; zvarwork(npiglo+130,:) = zvarout(npiglo+131,:)

     !! swapping the arrays
     zlonout(:,:) = zlonwork(:,:)
     zlatout(:,:) = zlatwork(:,:)
     zvarout(:,:) = zvarwork(:,:)

  ENDIF
 
  ierr = putvar(ncout,id_varout(1), zlonout, 1, npiglox2, npjglo)
  ierr = putvar(ncout,id_varout(2), zlatout, 1, npiglox2, npjglo)
  ierr = putvar(ncout,id_varout(3), zvarout, 1, npiglox2, npjglo)

  tim  = getvar1d(cf_in, cn_vtimec, 1     )
  ierr = putvar1d(ncout, tim,       1, 'T')
  ierr = closeout(ncout)

  PRINT *, 'Tip : in matlab, do not plot the last line (e.g. maximum northern latitude) '

END PROGRAM cdf2matlab

PROGRAM cdfsiginsitu
  !!======================================================================
  !!                     ***  PROGRAM  cdfsiginsitu  ***
  !!=====================================================================
  !!  ** Purpose : Compute sigma insitu 3D field from gridT file
  !!                Store the results on a 'similar' cdf file.
  !!
  !!  **  Method: read temp and salinity, compute sigma insitu
  !!              using depth taken from input T file

  !! History : 2.0  : 11/2004  : J.M. Molines : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE eos
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE
  INTEGER(KIND=4)                           :: jk, jt             ! dummy loop index
  INTEGER(KIND=4)                           :: ierr               ! error status
  INTEGER(KIND=4)                           :: narg, iargc, ijarg ! browse command line
  INTEGER(KIND=4)                           :: npiglo, npjglo     ! size of the domain
  INTEGER(KIND=4)                           :: npk, npkk, npt     ! size of the domain
  INTEGER(KIND=4)                           :: ncout              ! ncid of output file
  INTEGER(KIND=4), DIMENSION(1)             :: ipk, id_varout     ! level and  varid's

  REAL(KIND=4)                              :: zspval             ! missing value
  REAL(KIND=4)                              :: dep=0.0            ! depth to be used
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: ztemp              ! temperature
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zsal               ! salinity
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zsigi              ! sigma-insitu
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zmask              ! 2D mask at current level
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: tim                ! time counter
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: gdept              ! depth of T points

  CHARACTER(LEN=256)                        :: cf_tfil             ! input filename
  CHARACTER(LEN=256)                        :: cf_out='siginsitu.nc' ! output file name
  CHARACTER(LEN=256)                        :: cldum              ! dummy characte variable variable
  CHARACTER(LEN=256)                        :: cv_sal             ! salinity name in netcdf
  CHARACTER(LEN=256)                        :: cv_tem             ! temperature name in netcdf

  TYPE (variable), DIMENSION(1)             :: stypvar            ! structure for attributes
  LOGICAL                                   :: lnc4 = .FALSE.     ! flag for missing files
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfsiginsitu -t T-file [-sal SAL-name] [-tem TEM-name ] ...'
     PRINT *,'                [-dep depth] [-o OUT-file ] [-nc4 ] '
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute in situ density from temperature and salinity.' 
     PRINT *,'       Depths are taken from input file.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -t T-file : netcdf file with temperature and salinity.' 
     PRINT *,'         (for backward compatibility, -t can be ommited when T-file is the only'
     PRINT *,'         argument.)'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-sal SAL-name] : name of salinity variable'
     PRINT *,'       [-tem TEM-name] : name of temperature variable'
     PRINT *,'       [-dep depth ]   : depth to be used in case of 2D input file (only)'
     PRINT *,'       [-nc4]          : enable chunking and compression'
     PRINT *,'       [-o OUT-file]   : specify output filename instead of ',TRIM(cf_out)
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        none'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) ,'or the file name specified '
     PRINT *,'                   with -o option'
     PRINT *,'         variables : vosigmainsitu (kg/m3 -1000 )'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'      cdfsig0, cdfsigi '
     PRINT *,'      '
     STOP
  ENDIF

  ijarg=1
  cv_sal=cn_vosaline
  cv_tem=cn_votemper
  DO WHILE ( ijarg <= narg )
     CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-t'   ) ; CALL getarg(ijarg, cf_tfil) ; ijarg=ijarg+1
     CASE ( '-o'   ) ; CALL getarg(ijarg, cf_out ) ; ijarg=ijarg+1
     CASE ( '-sal' ) ; CALL getarg(ijarg, cv_sal ) ; ijarg=ijarg+1
     CASE ( '-tem' ) ; CALL getarg(ijarg, cv_tem ) ; ijarg=ijarg+1
     CASE ( '-dep' ) ; CALL getarg(ijarg, cldum  ) ; ijarg=ijarg+1 ; READ(cldum,*) dep 
     CASE ( '-nc4' ) ; lnc4 = .TRUE.
     CASE DEFAULT
      IF ( narg == 1 ) THEN
         cf_tfil = cldum
      ELSE
         PRINT *,' option ',TRIM(cldum),' not understood'
         STOP 99
      ENDIF
     END SELECT
  ENDDO

  IF ( chkfile(cf_tfil) ) STOP 99 ! missing file

  npiglo = getdim (cf_tfil,cn_x)
  npjglo = getdim (cf_tfil,cn_y)
  npk    = getdim (cf_tfil,cn_z)
  npt    = getdim (cf_tfil,cn_t)
  

  IF ( npk == 0 ) THEN
   npkk = 1
  ELSE
   npkk = npk  ! all variables (input and output are 3D)
  ENDIF
  ipk(:) = npkk
  stypvar(1)%cname             = 'vosigmainsitu'
  stypvar(1)%cunits            = 'kg/m3'
  stypvar(1)%rmissing_value    = 0.
  stypvar(1)%valid_min         = 0.001
  stypvar(1)%valid_max         = 45.
  stypvar(1)%clong_name        = 'in situ density'
  stypvar(1)%cshort_name       = 'vosigmainsitu'
  stypvar(1)%conline_operation = 'N/A'
  stypvar(1)%caxis             = 'TZYX'
  stypvar(1)%ichunk            = (/npiglo, MAX(1,npjglo/30), 1, 1 /)

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  ALLOCATE (ztemp(npiglo,npjglo), zsal (npiglo,npjglo) )
  ALLOCATE (zsigi(npiglo,npjglo), zmask(npiglo,npjglo) )
  ALLOCATE (gdept(npkk), tim(npt)                       )

  ! create output fileset
  ncout = create      (cf_out, cf_tfil,  npiglo, npjglo, npk,       ld_nc4=lnc4 )
  ierr  = createvar   (ncout,  stypvar,  1,      ipk,    id_varout, ld_nc4=lnc4 )
  ierr  = putheadervar(ncout,  cf_tfil,  npiglo, npjglo, npk       )

  zspval = getatt(cf_tfil, cv_sal, 'missing_value')

  IF ( npk == 0 ) THEN
    gdept(:)= dep
  ELSE
    gdept = getvar1d(cf_tfil, cn_vdeptht, npk    )
  ENDIF
  tim   = getvar1d(cf_tfil, cn_vtimec, npt     )
  ierr  = putvar1d(ncout,  tim,        npt, 'T')

  DO jt = 1, npt
     PRINT *,'time: ',jt
     DO jk = 1, npkk
        zmask(:,:) = 1.

        ztemp(:,:) = getvar(cf_tfil, cv_tem, jk, npiglo, npjglo, ktime=jt)
        zsal( :,:) = getvar(cf_tfil, cv_sal, jk, npiglo, npjglo, ktime=jt)

        WHERE( zsal == zspval ) zmask = 0

        zsigi(:,:) = sigmai(ztemp, zsal, gdept(jk), npiglo, npjglo )* zmask(:,:)

        ierr = putvar(ncout, id_varout(1), zsigi, jk, npiglo, npjglo, ktime=jt)

     END DO  ! loop to next level
  END DO  ! loop on time

  ierr = closeout(ncout)

END PROGRAM cdfsiginsitu

PROGRAM cdfchgrid
  !!======================================================================
  !!                     ***  PROGRAM  cdfchgrid  ***
  !!======================================================================
  !!  ** Purpose : Transform an 1442x1021 ORCA025 grid variable into an 
  !!               4322x3059 ORCA12 grid variable.
  !!               No interpolation, only copying one grid cell into 9 grid cells.
  !!
  !!  ** Method  : Store the result on a 'cdfchgrid.nc' file similar to the input file
  !!               (except x and y dimension)
  !!
  !!  ** Restriction  : Caution for mask coherence !
  !!                    This tool is only adapted for drowned field
  !!
  !! History : 3.0 !  08/2012    A. Lecointre   : Original code with Full Doctor form + Lic.
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  !!   routines      : description
  !!   chgrid        : Convert 1442x1021 ORCA025 2D var into 4322x3059 ORCA12 var
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id: cdfchgrid.f90 XXX YYYY-MM-DD MM:MM:SSZ molines $
  !! Copyright (c) 2010, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                               :: jk, jt                 ! dummy loop index
  INTEGER(KIND=4)                               :: jvar,jjvar             ! dummy loop index
  INTEGER(KIND=4)                               :: ierr                   ! working integer
  INTEGER(KIND=4)                               :: narg, iargc, ijarg     ! argument on line
  INTEGER(KIND=4)                               :: npiglo, npjglo         ! size of the input domain
  INTEGER(KIND=4), PARAMETER                    :: npigloout=4322, npjgloout=3059 ! size of the output domain
  INTEGER(KIND=4)                               :: npk, npt               ! size of the domain
  INTEGER(KIND=4)                               :: nvars                  ! number of variables in the input file
  INTEGER(KIND=4)                               :: ncout                  ! ncid of output ncdf file
  INTEGER(KIND=4), DIMENSION(1)                 :: ipk                    ! output variable : number of levels
  INTEGER(KIND=4), DIMENSION(1)                 :: id_varout              ! ncdf varid's

  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: v2d                    ! array to read a layer of data 
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: u2d                    ! array onto ORCA12-grid
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: tim                    ! time counter of the file
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: dep                    ! depth of the file

  CHARACTER(LEN=256)                            :: cf_out='cdfchgrid.nc'  ! output file name
  CHARACTER(LEN=256)                            :: cf_in                  ! input file name
  CHARACTER(LEN=256)                            :: cv_in                  ! variable name
  CHARACTER(LEN=256)                            :: cldum                  ! working string
  CHARACTER(LEN=256)                            :: cv_dep                 ! true name of dep dimension
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_names               ! array of var name

  TYPE (variable), DIMENSION(:),    ALLOCATABLE :: stypvar                ! structure for variable attribute
  !!--------------------------------------------------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfchgrid -f IN-file -var IN-var'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Convert ORCA025-grid variable into ORCA12-grid variable'
     PRINT *,'       No interpolation, only copying one grid cell into nine grid cells'
     PRINT *,'      '
     PRINT *,'     RESTRICTION :'
     PRINT *,'       Caution for mask coherence !'
     PRINT *,'       This tool is only adapted for drowned field'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -f IN-var : input ORCA025-grid file'
     PRINT *,'       -var IN-var : input ORCA025-grid variable to be converted'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       none '
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out)
     PRINT *,'         variable : same name as in input file'
     STOP
  ENDIF
  !!
  ijarg = 1
  ! Read command line
  DO  WHILE (ijarg <=  narg)
     CALL getarg(ijarg,cldum) ; ijarg = ijarg + 1
     SELECT CASE ( cldum )
     CASE ( '-f' )
        CALL getarg(ijarg, cf_in) ; ijarg = ijarg + 1
     CASE ( '-var' )
        CALL getarg(ijarg,cv_in) ; ijarg = ijarg + 1
     CASE DEFAULT
        PRINT *, TRIM(cldum),' : unknown option '
        STOP
     END SELECT
  END DO

  IF ( chkfile(cf_in) ) STOP  ! missing files

  ! get domain dimension from input file
  npiglo = getdim (cf_in, cn_x)
  npjglo = getdim (cf_in, cn_y)
  npk    = getdim (cf_in, cn_z, cdtrue=cv_dep, kstatus=ierr)  ! defautl cn_z is depth
  npt    = getdim (cf_in, cn_t)

  IF ( npk == 0 )  npk = 1  ! assume a 2D variable
  IF ( npt == 0 )  npt = 1  ! assume a 1 time frame file

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  ALLOCATE ( v2d(npiglo,npjglo) )
  ALLOCATE ( u2d(npigloout,npjgloout) )
  ALLOCATE ( tim(npt) )
  ALLOCATE ( dep(npk) )

  ! look for the number of variables in the input file
  nvars = getnvar(cf_in)
  ALLOCATE (cv_names(nvars) ,stypvar(nvars))
  cv_names(:)=getvarname(cf_in,nvars,stypvar)

  ! find the number of variable we are interested in
  jvar=0
  DO  WHILE (jvar <=  nvars)
     jvar=jvar+1
     IF ( cv_names(jvar) == cv_in ) jjvar=jvar
  END DO
  ipk(1)=npk
  ncout = create      (cf_out,   cf_in  , npigloout, npjgloout, npk         )
  ierr  = createvar   (ncout   , stypvar(jjvar), 1 , ipk  , id_varout )

  ! get time and write time and get deptht and write deptht
  tim=getvar1d(cf_in,cn_t,npt) ; ierr=putvar1d(ncout,tim,npt,'T')
  dep=getvar1d(cf_in,cv_dep,npk) ; ierr=putvar1d(ncout,dep,npk,'D')

  PRINT *,' Working with ', TRIM(cv_in), npk
  DO jt = 1, npt
     DO jk = 1, npk
        v2d(:,:) = getvar(cf_in, cv_in,  jk, npiglo, npjglo, ktime=jt)
        PRINT *,'level ',jk, 'time ',jt
        CALL chgrid(v2d,u2d,'025to12')
        ierr = putvar ( ncout , id_varout(1), REAL(u2d), jk, npigloout, npjgloout, ktime=jt)
     ENDDO
  ENDDO 

  ierr    = closeout(ncout)

CONTAINS

  SUBROUTINE chgrid (invar,outvar,cc)

  REAL(KIND=4), DIMENSION(npiglo,npjglo), INTENT(in)        :: invar
  REAL(KIND=4), DIMENSION(npigloout,npjgloout), INTENT(out) :: outvar
  CHARACTER(LEN=*), INTENT(in)                              :: cc
  INTEGER(KIND=4)                                           :: iin,jin,iout,jout ! dummy loop index

  SELECT CASE (cc)
  CASE ('025to12')
     DO iin = 2, 1441
        iout=3*iin-4
        jin=1   ! Fill only NORTH and EAST and WEST
        jout=3*jin-2
        outvar(iout  ,jout  ) = invar(iin,jin)
        outvar(iout  ,jout+1) = invar(iin,jin)
        outvar(iout-1,jout  ) = invar(iin,jin)
        outvar(iout+1,jout  ) = invar(iin,jin)
        outvar(iout+1,jout+1) = invar(iin,jin)
        outvar(iout-1,jout+1) = invar(iin,jin)
        DO jin = 2, 1020 ! Fill all: NORTH and SOUTH and EAST and WEST
           jout=3*jin-2
           outvar(iout  ,jout  ) = invar(iin,jin)
           outvar(iout+1,jout  ) = invar(iin,jin)
           outvar(iout-1,jout  ) = invar(iin,jin)
           outvar(iout  ,jout-1) = invar(iin,jin)
           outvar(iout  ,jout+1) = invar(iin,jin)
           outvar(iout+1,jout+1) = invar(iin,jin)
           outvar(iout+1,jout-1) = invar(iin,jin)
           outvar(iout-1,jout+1) = invar(iin,jin)
           outvar(iout-1,jout-1) = invar(iin,jin)
        ENDDO
     ENDDO
     iin=1442
     iout=3*iin-4
     jin=1 ! Fill only NORTH and WEST
     jout=3*jin-2
     outvar(iout  ,jout  ) = invar(iin,jin)
     outvar(iout  ,jout+1) = invar(iin,jin)
     outvar(iout-1,jout  ) = invar(iin,jin)
     outvar(iout-1,jout+1) = invar(iin,jin)
     DO jin = 2, 1020 ! Fill only NORTH and SOUTH and WEST
        jout=3*jin-2
        outvar(iout  ,jout  ) = invar(iin,jin)
        outvar(iout  ,jout-1) = invar(iin,jin)
        outvar(iout  ,jout+1) = invar(iin,jin)
        outvar(iout-1,jout  ) = invar(iin,jin)
        outvar(iout-1,jout-1) = invar(iin,jin)
        outvar(iout-1,jout+1) = invar(iin,jin)
     ENDDO
  CASE ('05to025')
    ! to do ...
  CASE ('05to12')
    ! to do ...
  CASE DEFAULT
     PRINT *, TRIM(cc),'  is not recognized !'
     PRINT *, 'No conversion will be performed'
  END SELECT

  END SUBROUTINE chgrid

END PROGRAM cdfchgrid

PROGRAM cdfpdf
  !!======================================================================
  !!                     ***  PROGRAM  cdfpdf  ***
  !!=====================================================================
  !!  ** Purpose : Build the pdf for a given variable on a given area.
  !!
  !!  ** Method  : Establish a data binning and count the number of element
  !!               in each bin.  Binning is defined from given  minimum 
  !!               value, maximum value, and number of bins
  !!
  !! History : 3.0  : 10/2015  : J.M. Molines : Original code
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  USE modutils
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2015
  !! $Id$
  !! Copyright (c) 2015, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: ji, jj, jk, jt
  INTEGER(KIND=4)                           :: npiglo, npjglo            ! size of the domain
  INTEGER(KIND=4)                           :: npk, npt                  ! size of the domain
  INTEGER(KIND=4)                           :: npi, npj, ilev            !
  INTEGER(KIND=4)                           :: narg, iargc, ijarg
  INTEGER(KIND=4)                           :: numout=10
  INTEGER(KIND=4)                           :: imin, imax 
  INTEGER(KIND=4)                           :: jmin, jmax
  INTEGER(KIND=4)                           :: nbin, nlim, ibin
  INTEGER(KIND=4)                           :: ncout             ! ncid of output variable
  INTEGER(KIND=4)                           :: ierr              ! error status
  INTEGER(KIND=4), DIMENSION(1)             :: ipk , id_varout   ! output variable

  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zvar, zcount, ztimed, zlon
  REAL(KIND=4), DIMENSION(:)  , ALLOCATABLE :: vlim, ztimes
  REAL(KIND=4)                              :: vmin, vmax, bin_siz
  REAL(KIND=4)                              :: below, above, spval

  CHARACTER(LEN=256)                        :: cf_ifil
  CHARACTER(LEN=256)                        :: cf_asc='pdf.txt'
  CHARACTER(LEN=256)                        :: cf_out='pdf.nc'
  CHARACTER(LEN=256)                        :: cv_nam
  CHARACTER(LEN=256)                        :: cldum
  CHARACTER(LEN=256)                        :: cglobal

  TYPE(variable), DIMENSION(1)              :: stypvar           ! output data structure

  LOGICAL                                   :: lchk
  LOGICAL                                   :: l_nozoom=.true.
  LOGICAL                                   :: l_norange=.true.
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage :  cdfpdf -f IN-file -v IN-var [-zoom imin imax jmin jmax] ..'
     PRINT *,'       [-lev level ] [-range vmin vmax nbin ] [-o OUT-ncfile] [-a OUT-ascfile]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Build the pdf of a given variable, on a given area, according'
     PRINT *,'       to bin specifications passed as argument of the program. If no' 
     PRINT *,'       particular specification is passed to the program, build 100 '
     PRINT *,'       bins between minimum and maximum value of the variable.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -f IN-file : input file '
     PRINT *,'       -v IN-var  : variable name '
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-zoom imin imax jmin jmax] : define a sub-area, in model '
     PRINT *,'                                     coordinates' 
     PRINT *,'       [ -lev level ] : choose a level for pdf computation '
     PRINT *,'              If not specified, takes level 1 '
     PRINT *,'       [-range vmin vmax nbin  ] : define the limit for binning '
     PRINT *,'                               and number of bins.'
     PRINT *,'       [-o OUT-file] : specify name for netcdf output file'
     PRINT *,'       [-a ASC-file] : specify name for ascii output file'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'          (1) ascii file with bin number, value and mean field in bin'
     PRINT *,'          (2) netcdf file for 2d array where x dimension corresponds to bins'
     PRINT *,'              y dimension corresponds to time, thus the field value being '
     PRINT *,'              an array count(bin,time). The output file follows the nemo '
     PRINT *,'              standards, even, if nav_lon, nav_lat are no more longitude or'
     PRINT *,'              latitude.'
     PRINT *,'              netdf variable is <IN-var>_pdf'
     PRINT *,'      '
     PRINT *,'     SEE ALSO : '
     STOP
  ENDIF

  ijarg = 1
  ilev  = 1
  l_nozoom = .true.
  DO WHILE ( ijarg <= narg )
     CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-f'   ) ; CALL getarg(ijarg, cf_ifil) ; ijarg=ijarg+1
     CASE ( '-o'   ) ; CALL getarg(ijarg, cf_out ) ; ijarg=ijarg+1
     CASE ( '-a'   ) ; CALL getarg(ijarg, cf_asc ) ; ijarg=ijarg+1
     CASE ( '-v'   ) ; CALL getarg(ijarg, cv_nam ) ; ijarg=ijarg+1
     CASE ( '-zoom') ; l_nozoom = .false.
             CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1 ; READ(cldum,*) imin
             CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1 ; READ(cldum,*) imax
             CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1 ; READ(cldum,*) jmin
             CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1 ; READ(cldum,*) jmax
     CASE ( '-lev') 
             CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1 ; READ(cldum,*) ilev
     CASE ( '-range') ; l_norange = .false.
             CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1 ; READ(cldum,*) vmin
             CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1 ; READ(cldum,*) vmax
             CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1 ; READ(cldum,*) nbin
     CASE DEFAULT
             PRINT *,' option ',TRIM(cldum),' not understood'
     END SELECT
  ENDDO

  IF (  chkfile ( cf_ifil) ) STOP 99 ! some compulsory files are missing

  ! set domain size from input ile
  npiglo = getdim (cf_ifil,cn_x)
  npjglo = getdim (cf_ifil,cn_y)
  npk    = getdim (cf_ifil,cn_z)
  npt    = getdim (cf_ifil,cn_t)

  PRINT *, 'npiglo =', npiglo
  PRINT *, 'npjglo =', npjglo
  PRINT *, 'npk    =', npk
  PRINT *, 'npt    =', npt
  
  ! if no zoom specified, take the full domain
  IF ( l_nozoom ) THEN
    imin=1 ; imax=npiglo
    jmin=1 ; jmax=npjglo
  ENDIF

  npi=imax - imin + 1
  npj=jmax - jmin + 1
  ALLOCATE ( zvar(npi,npj) )

  ! takle the case when no range specified for binning
  IF ( l_norange ) THEN
    nbin =100
    spval = getspval( cf_ifil, cv_nam) 
    ! scan the file for min and max
     vmin=1.e10
     vmax=-1.e10
    DO jt=1,npt
      zvar(:,:) = getvar( cf_ifil, cv_nam, ilev, npi, npj, ktime=jt, kimin=imin, kjmin=jmin )
      zvar(:,:) = getvar( cf_ifil, cv_nam, ilev, npi, npj,  ktime=jt, kimin=imin, kjmin=jmin )
      vmin=MIN(vmin, MINVAL(zvar, (zvar /= spval) ) )
      vmax=MAX(vmax, MAXVAL(zvar, (zvar /= spval) ) )
    ENDDO
  ENDIF

  bin_siz=(vmax - vmin ) / nbin
  nlim = nbin+1

  PRINT *, ' NPI  = ', npi
  PRINT *, ' NPJ  = ', npj
  PRINT *, ' IMIN = ', imin
  PRINT *, ' IMAX = ', imax
  PRINT *, ' JMIN = ', jmin
  PRINT *, ' JMAX = ', jmax
  PRINT *, ' ILEV = ', ilev
  PRINT *, ' VMIN = ', vmin
  PRINT *, ' VMAX = ', vmax
  PRINT *, ' NBIN = ', nbin
  PRINT *, ' NLIM = ', nlim
  PRINT *, ' BINS = ', bin_siz


  ! Allocate memory
  ALLOCATE ( zcount(nbin,npt), vlim(nlim) )
  ALLOCATE ( ztimes(npt), ztimed(nbin,npt) , zlon(nbin,npt))

  DO ji=1, nlim 
     vlim(ji)= vmin + (ji-1)*bin_siz
  ENDDO

  OPEN (numout, FILE=cf_asc)   ! this file can be plotted easily with graph
  ! time in seconds read from file 
  ztimes  = getvar1d(cf_ifil, cn_vtimec, npt )

  ! convert in time in days since the begining of the file
  ! this will be the dummy 'latitude' for the output file
 
  DO jt=1, npt
    ztimed(:,jt) = (ztimes(jt) - ztimes(1) ) / 86400.
  ENDDO

 ! dummy longitude for the output file in the mean value of the bin
  DO ji = 1, nbin
    zlon(ji,:) =  (vlim(ji) + vlim(ji+1)) /2.
  ENDDO

  CALL CreateOutput 

  DO jt = 1, npt
      zcount(:,jt) = 0. ; below=0. ; above=0.
      zvar(:,:) = getvar( cf_ifil, cv_nam, ilev, npi, npj,  ktime=jt, kimin=imin, kjmin=jmin )
      DO jj=1,npj
        DO ji=1,npi
           ibin=INT((zvar(ji,jj)-vmin)/bin_siz) +1
           IF ( ibin < 1 ) THEN 
              below=below+1
           ELSE IF ( ibin > nbin ) THEN
              above=above+1
           ELSE
              zcount(ibin,jt) = zcount(ibin,jt) + 1
           ENDIF
        ENDDO
      ENDDO

      WRITE(numout,*) 
      WRITE(numout,*) vlim(1),  below
      DO ji=1, nbin
         WRITE(numout,*)  (vlim(ji) + vlim(ji+1)) /2.,  zcount (ji,jt )
      ENDDO
      WRITE(numout,*)  vlim(nlim),  above
  ENDDO
   ierr = putvar( ncout, id_varout(1), zcount, 1, nbin, npt)
   ierr = closeout(ncout)
  CLOSE(numout)

CONTAINS
  SUBROUTINE CreateOutput
      !!---------------------------------------------------------------------
      !!                  ***  ROUTINE CreateOutput  ***
      !!
      !! ** Purpose :  Set up all things required for the output file, create
      !!               the file and write the header part. 
      !!
      !! ** Method  :  Use global module variables 
      !!
      !!----------------------------------------------------------------------
      ipk(:) = 1

      stypvar(1)%cname             = 'pdf_'//TRIM(cv_nam)
      stypvar(1)%cunits            = 'N/A'
      stypvar(1)%rmissing_value    = -1000.
      stypvar(1)%valid_min         = 0.
      stypvar(1)%valid_max         = npi*npj
      stypvar(1)%clong_name        = 'PDF of '//TRIM(cv_nam)
      stypvar(1)%cshort_name       = 'pdf_'//TRIM(cv_nam)
      stypvar(1)%conline_operation = 'N/A'

      CALL SetGlobalAtt (cglobal)

      ! create output fileset
      ncout = create      (cf_out, 'none', nbin, npt, 0      )
      ierr  = createvar   (ncout,  stypvar, 1, ipk, id_varout , cdglobal=cglobal        )
      ierr  = putheadervar(ncout,  cf_ifil, nbin, npt, 0 , pnavlon=zlon, pnavlat=ztimed )
      

  END SUBROUTINE CreateOutput
END PROGRAM cdfpdf

PROGRAM cdfvita_geo
  !!======================================================================
  !!                     ***  PROGRAM  cdfvita_geo  ***
  !!=====================================================================
  !!  ** Purpose : Compute velocity on t grid
  !!
  !!  ** Method  : Read velocity component on input gridU and gridV file
  !!               Use gridT file for the proper location of T points
  !!               The velocity module is also output (same function than
  !!               cdfspeed) If a gridW file is given, (fifth argument)
  !!               then w is also computed on the T grid
  !!
  !! History : 2.1  : 11/2006  : J.M. Molines : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio 
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                            :: ji, jj, jk, jt, jlev    ! dummy loop index
  INTEGER(KIND=4)                            :: narg, iargc, ijarg      ! browse line
  INTEGER(KIND=4)                            :: npiglo,npjglo           ! size of the domain
  INTEGER(KIND=4)                            :: npk, npt                ! size of the domain
  INTEGER(KIND=4)                            :: nlev, ik                ! number of selected levels, current lev
  INTEGER(KIND=4)                            :: ncout                   ! ncid of output file
  INTEGER(KIND=4)                            :: ierr                    ! error status for cdfio
  INTEGER(KIND=4)                            :: nvar                    ! number of variable
  INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE :: nklev                   ! selected levels
  INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE :: ipk, id_varout          ! output stuff

  REAL(KIND=4), DIMENSION(:),    ALLOCATABLE :: tim                     ! time counter array
  REAL(KIND=4), DIMENSION(:),    ALLOCATABLE :: gdeptall, gdept         ! depths and selected depths
  REAL(KIND=4), DIMENSION(:,:),  ALLOCATABLE :: uc, vc                  ! velocity component on C grid
  REAL(KIND=4), DIMENSION(:,:),  ALLOCATABLE :: ua, va, vmod            ! velocity component on A grid

  TYPE(variable), DIMENSION(:),  ALLOCATABLE :: stypvar                 ! data attributes

  CHARACTER(LEN=256)                         :: cf_ufil, cf_vfil        ! velocity files on C grid
  CHARACTER(LEN=256)                         :: cf_wfil                 ! optional W file on C grid
  CHARACTER(LEN=256)                         :: cf_tfil                 ! GridT file for T position
  CHARACTER(LEN=256)                         :: cf_out='vita.nc'        ! output file name
  CHARACTER(LEN=256)                         :: cldum                   ! dummy char variable

  LOGICAL                                    :: lvertical = .FALSE.     ! vertical velocity  flag 
  LOGICAL                                    :: lperio    = .FALSE.     ! E_W periodicity flag 
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfvita-geo  Ugeo-file Vgeo_file T-file [-w W-file] [-lev level_list]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Create a file with velocity components and module computed'
     PRINT *,'       at T points from file on C-grid. T-file is used only for' 
     PRINT *,'       getting the header of the output file. Any file on T grid'
     PRINT *,'       can be used.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       Ugeo-file  : netcdf file with zonal component of velocity' 
     PRINT *,'       Vgeo-file  : netcdf file with meridional component of velocity' 
     PRINT *,'       T-file  : netcdf file with T points header OK.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [ -w W-file ] : if used, also compute vertical velocities at' 
     PRINT *,'                       T points.'
     PRINT *,'       [ -lev level_list] : specify a list of level to be used '
     PRINT *,'                   (default option is to use all input levels).'
     PRINT *,'                   This option MUST be the last on the command line !!'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        none'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : sovitua, sovitva, sovitmod, [sovitwa]'
     STOP
  ENDIF

  nlev = 0
  ijarg=1
  DO WHILE ( ijarg <= narg )
     CALL getarg( ijarg, cldum ) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-lev' )
        nlev= narg - ijarg + 1
        ALLOCATE (nklev(nlev) )
        DO jlev = 1, nlev
           CALL getarg( ijarg, cldum ) ; ijarg=ijarg+1 ; READ(cldum,* ) nklev(jlev)
        ENDDO
     CASE ( '-w' )
        CALL getarg( ijarg, cf_wfil ) ; ijarg=ijarg+1
        lvertical=.TRUE.
     CASE DEFAULT
        cf_ufil=cldum
        CALL getarg( ijarg, cf_vfil ) ; ijarg=ijarg+1
        CALL getarg( ijarg, cf_tfil ) ; ijarg=ijarg+1
     END SELECT
  ENDDO

  ! adjust number of variable according to -w option
  nvar=3
  IF ( lvertical )  nvar = 4

  ALLOCATE ( ipk(nvar), id_varout(nvar), stypvar(nvar) )

  IF ( chkfile(cf_ufil) .OR. chkfile(cf_vfil) .OR. chkfile(cf_tfil) ) STOP 99 ! missing file

  IF ( lvertical ) THEN 
     IF ( chkfile(cf_wfil) ) STOP 99 ! missing file
  ENDIF

  npiglo = getdim (cf_ufil,cn_x)
  npjglo = getdim (cf_ufil,cn_y)
  npk    = getdim (cf_ufil,cn_z)
  npt    = getdim (cf_ufil,cn_t)

  IF ( npk == 0 ) THEN ; npk = 1 ; ENDIF

  IF ( nlev == 0 ) THEN ! take all levels
     nlev = npk
     ALLOCATE (nklev(nlev) )
     DO jlev = 1, nlev
        nklev(jlev) = jlev
     ENDDO
  ENDIF

  ALLOCATE ( gdept(nlev) )

  ! Zonal Velocity T point
  ipk(1)                       = nlev
  stypvar(1)%cname             = 'sovitua'
  stypvar(1)%cunits            = 'm/s'
  stypvar(1)%rmissing_value    = 0.
  stypvar(1)%valid_min         = 0.
  stypvar(1)%valid_max         = 10000.
  stypvar(1)%clong_name        = 'Zonal Velocity T point'
  stypvar(1)%cshort_name       = 'sovitua'
  stypvar(1)%conline_operation = 'N/A'
  stypvar(1)%caxis             = 'TZYX'

  ! Meridional Velocity T point
  ipk(2)                       = nlev
  stypvar(2)%cname             = 'sovitva'
  stypvar(2)%cunits            = 'm/s'
  stypvar(2)%rmissing_value    = 0.
  stypvar(2)%valid_min         = 0.
  stypvar(2)%valid_max         = 10000.
  stypvar(2)%clong_name        = 'Meridional Velocity T point'
  stypvar(2)%cshort_name       = 'sovitva'
  stypvar(2)%conline_operation = 'N/A'
  stypvar(2)%caxis             = 'TZYX'

  ! Velocity module T point
  ipk(3)                       = nlev
  stypvar(3)%cname             = 'sovitmod'
  stypvar(3)%cunits            = 'm/s'
  stypvar(3)%rmissing_value    = 0.
  stypvar(3)%valid_min         = 0.
  stypvar(3)%valid_max         = 10000.
  stypvar(3)%clong_name        = 'Velocity module T point'
  stypvar(3)%cshort_name       = 'sovitmod'
  stypvar(3)%conline_operation = 'N/A'
  stypvar(3)%caxis             = 'TZYX'

  IF ( lvertical ) THEN
     ! Vertical Velocity at T point
     ipk(nvar)                       = nlev
     stypvar(nvar)%cname             = 'sovitwa'
     stypvar(nvar)%cunits            = 'mm/s'
     stypvar(nvar)%rmissing_value    = 0.
     stypvar(nvar)%valid_min         = 0.
     stypvar(nvar)%valid_max         = 10000.
     stypvar(nvar)%clong_name        = 'Vertical Velocity at T point'
     stypvar(nvar)%cshort_name       = 'sovitwa'
     stypvar(nvar)%conline_operation = 'N/A'
     stypvar(nvar)%caxis             = 'TZYX'
  ENDIF

  PRINT *, 'npiglo =', npiglo
  PRINT *, 'npjglo =', npjglo
  PRINT *, 'npk    =', npk
  PRINT *, 'npt    =', npt
  PRINT *, 'nlev   =', nlev

  ALLOCATE( uc(npiglo,npjglo), vc(npiglo,npjglo)  )
  ALLOCATE( ua(npiglo,npjglo), va(npiglo,npjglo), vmod(npiglo,npjglo) )
  ALLOCATE( tim(npt), gdeptall(npk) )

  gdeptall(:) = getvar1d(cf_tfil,cn_vdeptht, npk)
  DO jlev = 1, nlev
     ik = nklev(jlev)
     gdept(jlev) = gdeptall(ik)
  ENDDO

  ! check E-W periodicity using uc array as working space
  uc(:,:) = getvar(cf_tfil, cn_vlon2d, 1, npiglo, npjglo )
  IF ( uc(1,1) == uc(npiglo-1,1) )  THEN 
    lperio = .TRUE.
    PRINT *,' E-W periodicity detected.'
  ENDIF

  ncout = create      (cf_out,   cf_tfil,  npiglo, npjglo, nlev                 )
  ierr  = createvar   (ncout ,   stypvar,  nvar,   ipk,    id_varout            )
  ierr  = putheadervar(ncout,    cf_tfil,  npiglo, npjglo, nlev,     pdep=gdept )

  DO jt = 1, npt
     DO jlev = 1, nlev
        ik = nklev(jlev)
        uc(:,:) = getvar(cf_ufil, cn_vozocrtx, ik ,npiglo, npjglo, ktime=jt )
        vc(:,:) = getvar(cf_vfil, cn_vomecrty, ik ,npiglo, npjglo, ktime=jt )

        ua = 0. ; va = 0. ; ua(:,:) = 0. ; va(:,:)=0. ; vmod(:,:)=0.
        DO ji=2, npiglo
           DO jj=2,npjglo
              ua(ji,jj)   = 0.5* (uc(ji,jj  )+ uc(ji,jj-1))
              va(ji,jj)   = 0.5* (vc(ji-1,jj)+ vc(ji,jj  ))
              vmod(ji,jj) = SQRT( ua(ji,jj)*ua(ji,jj) + va(ji,jj)*va(ji,jj) )
           END DO
        END DO
        IF ( lperio) THEN  ! periodic E-W boundary ...
          ua  (1,:) = ua  (npiglo-1,:)
          va  (1,:) = va  (npiglo-1,:)
          vmod(1,:) = vmod(npiglo-1,:)
        ENDIF

        ierr=putvar(ncout, id_varout(1), ua,   jlev ,npiglo, npjglo, ktime=jt )
        ierr=putvar(ncout, id_varout(2), va,   jlev ,npiglo, npjglo, ktime=jt )
        ierr=putvar(ncout, id_varout(3), vmod, jlev ,npiglo, npjglo, ktime=jt )
     END DO
  END DO

  IF ( lvertical ) THEN
     ! reuse uc an vc arrays to store Wk and Wk+1
     DO jt = 1, npt
        DO jlev=1, nlev - 1
           uc(:,:) = getvar(cf_wfil, cn_vovecrtz, nklev(jlev),   npiglo, npjglo, ktime=jt )
           vc(:,:) = getvar(cf_wfil, cn_vovecrtz, nklev(jlev)+1, npiglo, npjglo, ktime=jt )
           ua(:,:) = 0.5*(uc(:,:) + vc(:,:))*1000.  ! mm/sec
           ierr    = putvar(ncout, id_varout(4), ua, jlev,      npiglo, npjglo, ktime=jt )
           uc(:,:) = vc(:,:)
        END DO
        IF ( nlev == npk ) THEN
           ua(:,:) = 0.e0  ! npk
        ELSE
           uc(:,:) = getvar(cf_wfil, cn_vovecrtz, nklev(nlev),   npiglo, npjglo, ktime=jt )
           vc(:,:) = getvar(cf_wfil, cn_vovecrtz, nklev(nlev)+1, npiglo, npjglo, ktime=jt )
           ua(:,:) = 0.5*(uc(:,:) + vc(:,:))*1000.  ! mm/sec
     ENDIF
        ierr = putvar(ncout, id_varout(4), ua, nlev ,npiglo, npjglo, ktime=jt )
     ENDDO
  ENDIF

  tim  = getvar1d(cf_ufil, cn_vtimec, npt     )
  ierr = putvar1d(ncout,  tim,       npt, 'T')
  ierr = closeout(ncout)

END PROGRAM cdfvita_geo

MODULE eos
  !!======================================================================
  !!                     ***  MODULE  eos  ***
  !! All routines dealing with the Equation Of State of sea water
  !!=====================================================================
  !! History : 2.1  !  2004   : J.M. Molines : Original code ported
  !!                                           from NEMO
  !!           3.0    12/2010 : J.M. Molines : Doctor norm + Lic.
  !!           4.0  : 03/2017 : J.M. Molines  
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  !!   routines      : description
  !!   sigma0     : compute sigma-0 
  !!   eosbn2     : compute Brunt Vaissala Frequency
  !!   sigmai     : compute sigma-i ( refered to a depth given in argument
  !!   albet      : Compute the ratio alpha/beta ( Thermal/haline exapnsion)
  !!   beta       : compute beta (haline expension)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  PRIVATE
  PUBLIC :: sigma0
  PUBLIC :: sigmai
  PUBLIC :: spice
  PUBLIC :: sigmantr
  PUBLIC :: eosbn2
  PUBLIC :: albet
  PUBLIC :: beta

  INTERFACE sigmai
     MODULE PROCEDURE sigmai_dep, sigmai_dep2d
  END INTERFACE

  INTERFACE albet
     MODULE PROCEDURE  albet_2d, albet_z
  END INTERFACE

  INTERFACE beta
     MODULE PROCEDURE  beta_2d, beta_z
  END INTERFACE



  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class system
  !!----------------------------------------------------------------------

CONTAINS


  FUNCTION sigma0 ( ptem, psal, kpi, kpj)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION sigma0  ***
    !!
    !! ** Purpose : Compute the in situ density (ratio rho/rau0) and the
    !!              potential volumic mass (Kg/m3) from potential temperature 
    !!              and salinity fields using an equation of state defined 
    !!              through the namelist parameter neos.
    !!
    !! ** Method  : Jackett and McDougall (1994) equation of state.
    !!              The in situ density is computed directly as a function of
    !!              potential temperature relative to the surface (the opa t
    !!              variable), salt and pressure (assuming no pressure variation
    !!              along geopotential surfaces, i.e. the pressure p in decibars
    !!              is approximated by the depth in meters.
    !!              prd(t,s,p) = ( rho(t,s,p) - rau0 ) / rau0
    !!              rhop(t,s)  = rho(t,s,0)
    !!              with pressure                      p        decibars
    !!                   potential temperature         t        deg celsius
    !!                   salinity                      s        psu
    !!                   reference volumic mass        rau0     kg/m**3
    !!                   in situ volumic mass          rho      kg/m**3
    !!                   in situ density anomalie      prd      no units
    !!
    !!----------------------------------------------------------------------
    REAL(KIND=4), DIMENSION(kpi,kpj), INTENT(in) :: ptem, psal  ! temperature and salinity
    INTEGER(KIND=4),                  INTENT(in) :: kpi, kpj    ! dimension of 2D arrays
    REAL(KIND=8), DIMENSION(kpi,kpj)             :: sigma0      ! returned value

    INTEGER(KIND=4)                   :: ji, jj 
    REAL(KIND=8), DIMENSION (kpi,kpj) :: zws
    REAL(KIND=8)                      :: zt, zs, zsr, zrau0=1000.
    REAL(KIND=8)                      :: zr1, zr2, zr3, zr4
    !!----------------------------------------------------------------------
    zws = 0.d0
    sigma0 = 0.d0
    DO jj = 1, kpj
       DO ji = 1, kpi
          zws(ji,jj) = SQRT( ABS( psal(ji,jj) ) )
       END DO
    END DO

    !$OMP PARALLEL DO SCHEDULE(RUNTIME)
    DO jj = 1, kpj
       DO ji = 1, kpi

          zt  = ptem (ji,jj)          ! interpolated T
          zs  = psal (ji,jj)          ! interpolated S
          zsr = zws  (ji,jj)          ! square root of interpolated S

          ! compute volumic mass pure water at atm pressure
          zr1 = ( ( ( ( 6.536332e-9*zt-1.120083e-6 )*zt+1.001685e-4)*zt   &
               -9.095290e-3 )*zt+6.793952e-2 )*zt+999.842594
          ! seawater volumic mass atm pressure
          zr2= ( ( ( 5.3875e-9*zt-8.2467e-7 )*zt+7.6438e-5 ) *zt   &
               -4.0899e-3 ) *zt+0.824493
          zr3= ( -1.6546e-6*zt+1.0227e-4 ) *zt-5.72466e-3
          zr4= 4.8314e-4

          ! potential volumic mass (reference to the surface)
          sigma0(ji,jj) = ( zr4*zs + zr3*zsr + zr2 ) *zs + zr1 - zrau0
       END DO
    END DO
    !$OMP END PARALLEL DO

  END FUNCTION sigma0

  FUNCTION sigmantr( ptem, psal, kpi,kpj) 
    !! --------------------------------------------------------------------
    !! ** Purpose :   Compute the  neutral volumic mass (kg/m3) from known
    !!      potential temperature and salinity fields using an equation of
    !!      state. 
    !!
    !! ** Method  :
    !!       McDougall and Jackett (2005) equation of state.
    !!              potential temperature         t        deg celsius
    !!              salinity                      s        psu
    !!              neutral density               rho      kg/m**3
    !!       result is not masked at this stage.
    !!       Check value: rho(20,35) = 1024.59416751197 kg/m**3  -1000.
    !!       t = 20 deg celcius, s=35 psu
    !!
    !! ** References : McDougall and Jackett, The material derivative of neutral density
    !!        Journal of Marine Research, 63, 159-185, 2005
    !! --------------------------------------------------------------------
    REAL(KIND=4), DIMENSION(kpi,kpj), INTENT(in) :: ptem, psal ! temperature salinity
    INTEGER(KIND=4),                  INTENT(in) :: kpi,kpj    ! dimension of 2D arrays
    REAL(KIND=8), DIMENSION(kpi,kpj) :: sigmantr          ! return value

    INTEGER(KIND=4)                   :: ji, jj
    REAL(KIND=8), DIMENSION (kpi,kpj) :: dl_ws
    REAL(KIND=8)                      :: dl_t, dl_s, dl_sr
    REAL(KIND=8)                      :: dl_r1, dl_r2, dl_r3, dl_r4, dl_r5
    !! --------------------------------------------------------------------
    !$OMP PARALLEL DO SCHEDULE(RUNTIME)
    DO jj = 1, kpj
       DO ji = 1, kpi
          dl_t = ptem(ji,jj)
          dl_s = psal(ji,jj)
          dl_sr= SQRT( ABS(dl_s) )
       ! Numerator
          ! T-Polynome
          dl_r1= ( ( -4.3159255086706703d-4*dl_t+8.1157118782170051d-2 )*dl_t+2.2280832068441331d-1 )*dl_t+1002.3063688892480d0
          ! S-T Polynome
          dl_r2= ( -1.7052298331414675d-7*dl_s-3.1710675488863952d-3*dl_t-1.0304537539692924d-4 )*dl_s
       ! Denominator
          ! T-Polynome
          dl_r3= ( ( (-2.3850178558212048d-9*dl_t -1.6212552470310961d-7 )*dl_t+7.8717799560577725d-5 )*dl_t+4.3907692647825900d-5 )*dl_t+     1.0d0
          ! S-T Polynome
          dl_r4= ( ( -2.2744455733317707d-9*dl_t*dl_t+6.0399864718597388d-6)*dl_t-5.1268124398160734d-4 )*dl_s
          ! S-T Polynome
          dl_r5= ( -1.3409379420216683d-9*dl_t*dl_t-3.6138532339703262d-5)*dl_s*dl_sr

          ! Neutral density
          sigmantr(ji,jj) = ( dl_r1 + dl_r2 ) / ( dl_r3 + dl_r4 + dl_r5 ) -1000.d0
       ENDDO
    ENDDO
    !$OMP END PARALLEL DO


  END FUNCTION sigmantr

  FUNCTION spice ( ptem, psal, kpi, kpj )
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION spice  ***
    !!
    !! ** Purpose :  Compute spiciness from T S fields. 
    !!
    !! ** Method  :  spiciness = sum(i=0,5)[sum(j=0,4)[b(i,j)*theta^i*(s-35)^j]]
    !!                   with:  b     -> coefficients
    !!                          theta -> potential temperature
    !!                          s     -> salinity
    !!
    !!  **  Example:
    !!       spice(15,33)=   0.5445863      0.544586321373410  calcul en double
    !!       spice(15,33)=   0.5445864      (calcul en simple precision) 
    !!
    !!  ** References : Flament (2002) "A state variable for characterizing
    !!              water masses and their diffusive stability: spiciness."
    !!              Progress in Oceanography Volume 54, 2002, Pages 493-501.
    !!
    !!----------------------------------------------------------------------
    REAL(KIND=4), DIMENSION(kpi,kpj), INTENT(in) :: ptem, psal ! temperature salinity
    INTEGER(KIND=4),                  INTENT(in) :: kpi,kpj    ! dimension of 2D arrays
    REAL(KIND=8), DIMENSION(kpi,kpj)             :: spice      ! return value

    INTEGER(KIND=4)                        :: ji,jj     ! dummy loop index
    INTEGER(KIND=4)                        :: jig,jjg     ! dummy loop index
    REAL(KIND=8), SAVE, DIMENSION(6,5)     :: dl_bet    ! coefficients of spiciness formula
    REAL(KIND=8),       DIMENSION(kpi,kpj) :: dl_spi    ! spiciness
    REAL(KIND=8),       DIMENSION(kpi,kpj) :: dl_salref ! reference salinity
    REAL(KIND=8),       DIMENSION(kpi,kpj) :: dl_tempt  ! working array
    REAL(KIND=8),       DIMENSION(kpi,kpj) :: dl_salt   ! working array

    LOGICAL, SAVE                        :: lfrst=.TRUE.!
    !!----------------------------------------------------------------------
    IF ( lfrst ) THEN
       lfrst = .false.
       ! Define coefficients to compute spiciness (R*8)
       dl_bet(1,:) = (/       0.d0,   7.7442d-01,    -5.85d-03,    -9.84d-04,    -2.06d-04/)
       dl_bet(2,:) = (/ 5.1655d-02,    2.034d-03,   -2.742d-04,     -8.5d-06,     1.36d-05/)
       dl_bet(3,:) = (/6.64783d-03,  -2.4681d-04,   -1.428d-05,    3.337d-05,    7.894d-06/)
       dl_bet(4,:) = (/-5.4023d-05,    7.326d-06,   7.0036d-06,  -3.0412d-06,  -1.0853d-06/)
       dl_bet(5,:) = (/  3.949d-07,   -3.029d-08,  -3.8209d-07,   1.0012d-07,   4.7133d-08/)
       dl_bet(6,:) = (/  -6.36d-10,   -1.309d-09,    6.048d-09,  -1.1409d-09,   -6.676d-10/)
    ENDIF
    ! spiciness 
    dl_spi(:,:)    = 0.d0
    dl_salref(:,:) = psal(:,:) - 35.d0
    dl_tempt(:,:)  = 1.d0
!$OMP PARALLEL DO SCHEDULE(RUNTIME)
    DO jjg=1, kpj
    DO ji=1,6
       dl_salt(:,jjg) = 1.d0
       DO jj=1,5
           dl_spi( :,jjg) = dl_spi (:,jjg) +   dl_bet (ji,jj) * dl_tempt(:,jjg) * dl_salt(:,jjg)
           dl_salt(:,jjg) = dl_salt(:,jjg) * dl_salref( :,jjg )
       END DO
       dl_tempt(:,jjg) = dl_tempt(:,jjg) * ptem(:,jjg)
    END DO
    END DO
!$OMP END PARALLEL DO

    spice(:,:) = dl_spi( :,:)

  END FUNCTION spice

  FUNCTION sigmai_dep ( ptem, psal, pref, kpi,kpj)
    !! --------------------------------------------------------------------
    !! ** Purpose :   Compute the  density referenced to pref (ratio rho/rau0) 
    !!       from potential temperature and
    !!      salinity fields using an equation of state defined through the
    !!     namelist parameter neos.
    !!
    !! ** Method  :
    !!       Jackett and McDougall (1994) equation of state.
    !!         the in situ density is computed directly as a function of
    !!         potential temperature relative to the surface (the opa t
    !!         variable), salt and pressure (assuming no pressure variation
    !!         along geopotential surfaces, i.e. the pressure p in decibars
    !!         is approximated by the depth in meters.
    !!              prd(t,s,p) = ( rho(t,s,p) - rau0 ) / rau0
    !!              rhop(t,s)  = rho(t,s,0)
    !!         with pressure                      p        decibars
    !!              potential temperature         t        deg celsius
    !!              salinity                      s        psu
    !!              reference volumic mass        rau0     kg/m**3
    !!              in situ volumic mass          rho      kg/m**3
    !!              in situ density anomalie      prd      no units
    !! --------------------------------------------------------------------
    REAL(KIND=4), DIMENSION(kpi,kpj), INTENT(in) :: ptem, psal ! temperature salinity
    INTEGER(KIND=4),                  INTENT(in) :: kpi,kpj    ! dimension of 2D arrays
    REAL(KIND=4),                     INTENT(in) :: pref       ! reference pressure (meters or db)
    REAL(KIND=8), DIMENSION(kpi,kpj) :: sigmai_dep             ! return value

    REAL(kind=8), PARAMETER :: dpr4=4.8314d-4, dpd=-2.042967d-2 , dprau0 = 1000.d0

    INTEGER(KIND=4) :: ji, jj 
    REAL(KIND=8), DIMENSION (kpi,kpj) ::  dlrs
    REAL(KIND=8) :: dlt, dls      
    REAL(KIND=8) :: dla, dla1, dlaw, dlb, dlb1, dlbw, dlc, dle, dlk0, dlkw 
    REAL(kind=8) :: dlrhop, dlr1, dlr2, dlr3, dlref
    !! --------------------------------------------------------------------
    dlref      = pref
    sigmai_dep = 0.d0
    DO jj = 1, kpj
       DO ji = 1, kpi
          dlrs(ji,jj) = SQRT( ABS( psal(ji,jj) ) )
       END DO
    END DO

    !$OMP PARALLEL DO SCHEDULE(RUNTIME)
    DO jj=1,kpj
       DO ji=1,kpi

          ! Convert T and S to double precision.
          dlt = DBLE(ptem(ji,jj))
          dls = DBLE(psal(ji,jj))

          ! Compute the volumic mass of pure water at atmospheric pressure.
          dlr1=((((6.536332d-9*dlt-1.120083d-6)&
               *dlt+1.001685d-4)&
               *dlt-9.095290d-3)&
               *dlt+6.793952d-2)&
               *dlt+999.842594d0

          ! Compute the seawater volumic mass at atmospheric pressure.
          dlr2=(((5.3875d-9*dlt-8.2467d-7)&
               *dlt+7.6438d-5)&
               *dlt-4.0899d-3)&
               *dlt+0.824493d0

          dlr3=(-1.6546d-6*dlt+1.0227d-4)&
               *dlt-5.72466d-3

          ! Compute the potential volumic mass (referenced to the surface).
          dlrhop=(dpr4*dls+dlr3*dlrs(ji,jj)+dlr2)*dls+dlr1

          ! Compute the compression terms.
          dle=(-3.508914d-8*dlt-1.248266d-8)&
               *dlt-2.595994d-6

          dlbw=(1.296821d-6*dlt-5.782165d-9)&
               *dlt+1.045941d-4

          dlb=dlbw+dle*dls

          dlc=(-7.267926d-5*dlt+2.598241d-3 )&
               *dlt+0.1571896d0

          dlaw=((5.939910d-6*dlt+2.512549d-3)&
               *dlt-0.1028859d0)&
               *dlt-4.721788d0

          dla=(dpd*dlrs(ji,jj)+dlc)*dls+dlaw

          dlb1=(-0.1909078d0*dlt+7.390729d0)&
               *dlt-55.87545d0

          dla1=((2.326469d-3*dlt+1.553190d0)&
               *dlt-65.00517d0)&
               *dlt+1044.077d0

          dlkw=(((-1.361629d-4*dlt-1.852732d-2)&
               *dlt-30.41638d0)&
               *dlt+2098.925d0)&
               *dlt+190925.6d0

          dlk0=(dlb1*dlrs(ji,jj)+dla1)*dls+dlkw

          ! Compute the potential density anomaly.
          sigmai_dep(ji,jj)=dlrhop/(1.0d0-dlref/(dlk0-dlref*(dla-dlref*dlb)))&
               -dprau0

       ENDDO
    ENDDO
    !$OMP END PARALLEL DO

  END FUNCTION sigmai_dep

  FUNCTION sigmai_dep2d ( ptem, psal, pref, kpi,kpj)
    !! --------------------------------------------------------------------
    !! ** Purpose :   Compute the  density referenced to pref (ratio rho/rau0) 
    !!       from potential temperature and
    !!      salinity fields using an equation of state defined through the
    !!     namelist parameter neos.
    !!
    !! ** Method  :
    !!       Jackett and McDougall (1994) equation of state.
    !!         the in situ density is computed directly as a function of
    !!         potential temperature relative to the surface (the opa t
    !!         variable), salt and pressure (assuming no pressure variation
    !!         along geopotential surfaces, i.e. the pressure p in decibars
    !!         is approximated by the depth in meters.
    !!              prd(t,s,p) = ( rho(t,s,p) - rau0 ) / rau0
    !!              rhop(t,s)  = rho(t,s,0)
    !!         with pressure                      p        decibars
    !!              potential temperature         t        deg celsius
    !!              salinity                      s        psu
    !!              reference volumic mass        rau0     kg/m**3
    !!              in situ volumic mass          rho      kg/m**3
    !!              in situ density anomalie      prd      no units
    !! --------------------------------------------------------------------
    REAL(KIND=4), DIMENSION(kpi,kpj), INTENT(in) :: ptem, psal ! temperature salinity
    INTEGER(KIND=4),                  INTENT(in) :: kpi,kpj    ! dimension of 2D arrays
    REAL(KIND=4), DIMENSION(kpi,kpj), INTENT(in) :: pref       ! reference pressure (meters or db) (2d Array)
    REAL(KIND=8), DIMENSION(kpi,kpj) :: sigmai_dep2d           ! return value

    REAL(kind=8), PARAMETER :: dpr4=4.8314d-4, dpd=-2.042967d-2 , dprau0 = 1000.d0

    INTEGER(KIND=4) :: ji, jj 
    REAL(KIND=8), DIMENSION (kpi,kpj) ::  dlrs
    REAL(KIND=8) :: dlt, dls      
    REAL(KIND=8) :: dla, dla1, dlaw, dlb, dlb1, dlbw, dlc, dle, dlk0, dlkw 
    REAL(kind=8) :: dlrhop, dlr1, dlr2, dlr3, dlref

    sigmai_dep2d = 0.d0
    DO jj = 1, kpj
       DO ji = 1, kpi
          dlrs(ji,jj) = SQRT( ABS( psal(ji,jj) ) )
       END DO
    END DO

    !$OMP PARALLEL DO SCHEDULE(RUNTIME)
    DO jj=1,kpj
       DO ji=1,kpi

          ! Convert T and S to double precision.
          dlt   = DBLE(ptem(ji,jj))
          dls   = DBLE(psal(ji,jj))
          dlref = DBLE(pref(ji,jj))

          ! Compute the volumic mass of pure water at atmospheric pressure.
          dlr1=((((6.536332d-9*dlt-1.120083d-6)&
               *dlt+1.001685d-4)&
               *dlt-9.095290d-3)&
               *dlt+6.793952d-2)&
               *dlt+999.842594d0

          ! Compute the seawater volumic mass at atmospheric pressure.
          dlr2=(((5.3875d-9*dlt-8.2467d-7)&
               *dlt+7.6438d-5)&
               *dlt-4.0899d-3)&
               *dlt+0.824493d0

          dlr3=(-1.6546d-6*dlt+1.0227d-4)&
               *dlt-5.72466d-3

          ! Compute the potential volumic mass (referenced to the surface).
          dlrhop=(dpr4*dls+dlr3*dlrs(ji,jj)+dlr2)*dls+dlr1

          ! Compute the compression terms.
          dle=(-3.508914d-8*dlt-1.248266d-8)&
               *dlt-2.595994d-6

          dlbw=(1.296821d-6*dlt-5.782165d-9)&
               *dlt+1.045941d-4

          dlb=dlbw+dle*dls

          dlc=(-7.267926d-5*dlt+2.598241d-3 )&
               *dlt+0.1571896d0

          dlaw=((5.939910d-6*dlt+2.512549d-3)&
               *dlt-0.1028859d0)&
               *dlt-4.721788d0

          dla=(dpd*dlrs(ji,jj)+dlc)*dls+dlaw

          dlb1=(-0.1909078d0*dlt+7.390729d0)&
               *dlt-55.87545d0

          dla1=((2.326469d-3*dlt+1.553190d0)&
               *dlt-65.00517d0)&
               *dlt+1044.077d0

          dlkw=(((-1.361629d-4*dlt-1.852732d-2)&
               *dlt-30.41638d0)&
               *dlt+2098.925d0)&
               *dlt+190925.6d0

          dlk0=(dlb1*dlrs(ji,jj)+dla1)*dls+dlkw

          ! Compute the potential density anomaly.
          sigmai_dep2d(ji,jj)=dlrhop/(1.0d0-dlref/(dlk0-dlref*(dla-dlref*dlb)))&
               -dprau0

       ENDDO
    ENDDO
    !$OMP END PARALLEL DO

  END FUNCTION sigmai_dep2d


  FUNCTION eosbn2 ( ptem, psal, pdep, pe3w, kpi, kpj, kup, kdown)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION eosbn2  ***
    !!
    !! ** Purpose :  Compute the local Brunt-Vaisala frequency at the time-
    !!               step of the input arguments
    !!
    !! ** Method :  UNESCO sea water properties
    !!             The brunt-vaisala frequency is computed using the
    !!              polynomial expression of McDougall (1987):
    !!              N^2 = grav * beta * ( alpha/beta*dk[ t ] - dk[ s ] )/e3w
    !!----------------------------------------------------------------------
    REAL(KIND=4), DIMENSION(kpi,kpj,2), INTENT(in) :: ptem, psal ! temperaature salinity
    REAL(KIND=4)                                   :: pdep       ! reference depth
    REAL(KIND=4), DIMENSION(kpi,kpj),   INTENT(in) :: pe3w       ! e3w of the current layer
    INTEGER(KIND=4),                    INTENT(in) :: kpi, kpj   ! size of the array
    INTEGER(KIND=4),                    INTENT(in) :: kup, kdown ! index of levels up and down
    REAL(KIND=4), DIMENSION(kpi,kpj)               :: eosbn2     ! returned values

    INTEGER(KIND=4) :: ji, jj         ! dummy loop indices
    REAL(KIND=8)    :: zgde3w, zt, zs, zh
    REAL(KIND=8)    :: zalbet, zbeta
    REAL(KIND=8)    :: zgrav=9.81
    !!----------------------------------------------------------------------

    zh = pdep
    !$OMP PARALLEL DO SCHEDULE(RUNTIME)
    DO jj = 1, kpj
       DO ji = 1, kpi
          zgde3w = zgrav / pe3w(ji,jj)
          zt = 0.5 * ( ptem(ji,jj,kup) + ptem(ji,jj,kdown) )          ! potential temperature at w-point
          zs = 0.5 * ( psal(ji,jj,kup) + psal(ji,jj,kdown) ) - 35.0   ! salinity anomaly (s-35) at w-point

          zalbet = ( ( ( - 0.255019e-07 * zt + 0.298357e-05 ) * zt     &   ! ratio alpha/beta
               &                               - 0.203814e-03 ) * zt   &
               &                               + 0.170907e-01 ) * zt   &
               &   + 0.665157e-01                                      &
               &   +     ( - 0.678662e-05 * zs                         &
               &           - 0.846960e-04 * zt + 0.378110e-02 ) * zs   &
               &   +   ( ( - 0.302285e-13 * zh                         &
               &           - 0.251520e-11 * zs                         &
               &           + 0.512857e-12 * zt * zt           ) * zh   &
               &           - 0.164759e-06 * zs                         &
               &        +(   0.791325e-08 * zt - 0.933746e-06 ) * zt   &
               &                               + 0.380374e-04 ) * zh

          zbeta  = ( ( -0.415613e-09 * zt + 0.555579e-07 ) * zt        &   ! beta
               &                            - 0.301985e-05 ) * zt      &
               &   + 0.785567e-03                                      &
               &   + (     0.515032e-08 * zs                           &
               &         + 0.788212e-08 * zt - 0.356603e-06 ) * zs     &
               &   +(  (   0.121551e-17 * zh                           &
               &         - 0.602281e-15 * zs                           &
               &         - 0.175379e-14 * zt + 0.176621e-12 ) * zh     &
               &                             + 0.408195e-10   * zs     &
               &     + ( - 0.213127e-11 * zt + 0.192867e-09 ) * zt     &
               &                             - 0.121555e-07 ) * zh

          eosbn2(ji,jj) = zgde3w * zbeta                                         &   ! N^2
               &          * ( zalbet * ( ptem(ji,jj,kup) - ptem(ji,jj,kdown) )   &
               &                     - ( psal(ji,jj,kup) - psal(ji,jj,kdown) ) )
       END DO
    END DO
    !$OMP END PARALLEL DO

  END FUNCTION eosbn2


  FUNCTION albet_2d(  ptem, psal, pdep, kpi, kpj)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION  albet  ***
    !!
    !! ** Purpose :  Compute the ratio alpha/beta 
    !!
    !! ** Method  :  Follow Mc Dougal et al as in other functions
    !!
    !!----------------------------------------------------------------------
    REAL(KIND=4), DIMENSION(kpi,kpj), INTENT(in) :: ptem, psal ! temperature salinity
    REAL(KIND=4),                     INTENT(in) :: pdep       ! refererence depth
    INTEGER(KIND=4),                  INTENT(in) :: kpi, kpj   ! size of the arrays

    REAL(KIND=8), DIMENSION(kpi,kpj)             :: albet_2d   ! returned value

    INTEGER(KIND=4) :: ji, jj      ! dummy loop index
    REAL(KIND=8)    :: zt, zs, zh  ! working local variables
    !!----------------------------------------------------------------------
    zh = pdep
    !$OMP PARALLEL DO SCHEDULE(RUNTIME)
     DO jj=1,kpj
       DO ji=1,kpi
          zt =  ptem(ji,jj)         ! potential temperature
          zs =  psal(ji,jj)- 35.0   ! salinity anomaly (s-35)

          albet_2d(ji,jj) = ( ( ( - 0.255019e-07 * zt + 0.298357e-05 ) * zt   &   ! ratio alpha/beta
               &                               - 0.203814e-03 ) * zt   &
               &                               + 0.170907e-01 ) * zt   &
               &   + 0.665157e-01                                      &
               &   +     ( - 0.678662e-05 * zs                         &
               &           - 0.846960e-04 * zt + 0.378110e-02 ) * zs   &
               &   +   ( ( - 0.302285e-13 * zh                         &
               &           - 0.251520e-11 * zs                         &
               &           + 0.512857e-12 * zt * zt           ) * zh   &
               &           - 0.164759e-06 * zs                         &
               &        +(   0.791325e-08 * zt - 0.933746e-06 ) * zt   &
               &                               + 0.380374e-04 ) * zh
       END DO
    END DO
    !$OMP END PARALLEL DO

  END FUNCTION albet_2d


  FUNCTION albet_z(  ptem, psal, pdep, kpk)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION  albet  ***
    !!
    !! ** Purpose :  Compute the ratio alpha/beta 
    !!
    !! ** Method  :  Follow Mc Dougal et al as in other functions
    !!
    !!----------------------------------------------------------------------
    REAL(KIND=4), DIMENSION(kpk), INTENT(in) :: ptem, psal ! temperature salinity
    REAL(KIND=4), DIMENSION(kpk), INTENT(in) :: pdep       ! refererence depth
    INTEGER(KIND=4),              INTENT(in) :: kpk        ! size of the arrays

    REAL(KIND=8), DIMENSION(kpk)             :: albet_z    ! returned value

    INTEGER(KIND=4) :: jk          ! dummy loop index
    REAL(KIND=8)    :: zt, zs, zh  ! working local variables
    !!----------------------------------------------------------------------
    !$OMP PARALLEL DO SCHEDULE(RUNTIME)
     DO jk=1,kpk
          zh = pdep(jk)
          zt = ptem(jk)         ! potential temperature
          zs = psal(jk)- 35.0   ! salinity anomaly (s-35)

          albet_z(jk) = (  ( ( - 0.255019e-07 * zt + 0.298357e-05 ) * zt   &   ! ratio alpha/beta
                   &                               - 0.203814e-03 ) * zt   &
                   &                               + 0.170907e-01 ) * zt   &
                   &   + 0.665157e-01                                      &
                   &   +     ( - 0.678662e-05 * zs                         &
                   &           - 0.846960e-04 * zt + 0.378110e-02 ) * zs   &
                   &   +   ( ( - 0.302285e-13 * zh                         &
                   &           - 0.251520e-11 * zs                         &
                   &           + 0.512857e-12 * zt * zt           ) * zh   &
                   &           - 0.164759e-06 * zs                         &
                   &        +(   0.791325e-08 * zt - 0.933746e-06 ) * zt   &
                   &                               + 0.380374e-04 ) * zh
    END DO
    !$OMP END PARALLEL DO

  END FUNCTION albet_z


  FUNCTION beta_2d (  ptem, psal, pdep, kpi, kpj)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION beta  ***
    !!
    !! ** Purpose :  Compute the beta 
    !!
    !! ** Method  :  Follow Mc Dougal et al as in other functions 
    !!
    !!----------------------------------------------------------------------
    REAL(KIND=4), DIMENSION(kpi,kpj),INTENT(in) :: ptem, psal ! temperature salinity
    REAL(KIND=4),                    INTENT(in) :: pdep       ! reference depth
    INTEGER(KIND=4),                 INTENT(in) :: kpi, kpj   ! size of the array
    REAL(KIND=8), DIMENSION(kpi,kpj)            :: beta_2d    ! returned values

    INTEGER(KIND=4) :: ji, jj      ! dummy loop index
    REAL(KIND=8)    :: zt, zs, zh  ! working variables
    !!----------------------------------------------------------------------
    zh = pdep
    !$OMP PARALLEL DO SCHEDULE(RUNTIME)
    DO jj=1,kpj
       DO ji=1,kpi
          zt =  ptem(ji,jj)         ! potential temperature
          zs =  psal(ji,jj)- 35.0   ! salinity anomaly (s-35)

          beta_2d(ji,jj) = ( ( -0.415613e-09 * zt + 0.555579e-07 ) * zt      &   ! beta
               &                            - 0.301985e-05 ) * zt      &
               &   + 0.785567e-03                                      &
               &   + (     0.515032e-08 * zs                           &
               &         + 0.788212e-08 * zt - 0.356603e-06 ) * zs     &
               &   +(  (   0.121551e-17 * zh                           &
               &         - 0.602281e-15 * zs                           &
               &         - 0.175379e-14 * zt + 0.176621e-12 ) * zh     &
               &                             + 0.408195e-10   * zs     &
               &     + ( - 0.213127e-11 * zt + 0.192867e-09 ) * zt     &
               &                             - 0.121555e-07 ) * zh
       END DO
    END DO
    !$OMP END PARALLEL DO

  END FUNCTION beta_2d

  FUNCTION beta_z (  ptem, psal, pdep, kpk)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION beta  ***
    !!
    !! ** Purpose :  Compute the beta 
    !!
    !! ** Method  :  Follow Mc Dougal et al as in other functions 
    !!
    !!----------------------------------------------------------------------
    REAL(KIND=4), DIMENSION(kpk),INTENT(in) :: ptem, psal ! temperature salinity
    REAL(KIND=4), DIMENSION(kpk),INTENT(in) :: pdep       ! reference depth
    INTEGER(KIND=4),             INTENT(in) :: kpk        ! size of the array
    REAL(KIND=8), DIMENSION(kpk)            :: beta_z     ! returned values

    INTEGER(KIND=4) :: jk          ! dummy loop index
    REAL(KIND=8)    :: zt, zs, zh  ! working variables
    !!----------------------------------------------------------------------
    !$OMP PARALLEL DO SCHEDULE(RUNTIME)
    DO jk=1,kpk
          zh = pdep(jk)
          zt =  ptem(jk)         ! potential temperature
          zs =  psal(jk)- 35.0   ! salinity anomaly (s-35)

          beta_z(jk) = ( ( -0.415613e-09 * zt + 0.555579e-07 ) * zt        &   ! beta
                   &                            - 0.301985e-05 ) * zt      &
                   &   + 0.785567e-03                                      &
                   &   + (     0.515032e-08 * zs                           &
                   &         + 0.788212e-08 * zt - 0.356603e-06 ) * zs     &
                   &   +(  (   0.121551e-17 * zh                           &
                   &         - 0.602281e-15 * zs                           &
                   &         - 0.175379e-14 * zt + 0.176621e-12 ) * zh     &
                   &                             + 0.408195e-10   * zs     &
                   &     + ( - 0.213127e-11 * zt + 0.192867e-09 ) * zt     &
                   &                             - 0.121555e-07 ) * zh
    END DO
    !$OMP END PARALLEL DO

  END FUNCTION beta_z

END MODULE eos

PROGRAM cdfstd
  !!======================================================================
  !!                     ***  PROGRAM  cdfstd  ***
  !!=====================================================================
  !!  ** Purpose : Compute Standard deviation values for all the 
  !!               variables in a bunch of cdf files given as argument
  !!               Store the results on a 'similar' cdf file.
  !!
  !!  ** Method  : Compute mean, mean squared, then the variance and
  !!               the standard deviation
  !!
  !! History : 2.1  : 04/2006  : F. Castruccio : Original code (from cdfmoy)
  !!           3.0  : 01/2011  : J.M. Molines  : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio 
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                               :: jk, jfil, jt        ! dummy loop index
  INTEGER(KIND=4)                               :: jvar, jv            ! dummy loop index
  INTEGER(KIND=4)                               :: narg, iargc, ijarg  ! browse line
  INTEGER(KIND=4)                               :: npiglo, npjglo      ! size of the domain
  INTEGER(KIND=4)                               :: npk, npt            ! size of the domain
  INTEGER(KIND=4)                               :: nvars               ! number of variables in a file
  INTEGER(KIND=4)                               :: ntframe             ! cumul of time frame
  INTEGER(KIND=4)                               :: ncout               ! ncid of stdev file output
  INTEGER(KIND=4)                               :: ncou2               ! ncid of mean file output (optional)
  INTEGER(KIND=4)                               :: ierr                ! error status
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: id_var              ! varid's of input variables
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: ipk, id_varout      ! levels and varid's of output vars
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: id_varoutm          ! varid's of mean var output (optional)

  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: v2d                 ! 2d data array
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: tim                 ! tim counter
  REAL(KIND=4), DIMENSION(1)                    :: timean              ! mean time

  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: dtab, dtab2         ! cumulated values and squared values
  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: dstd                ! standard deviation
  REAL(KIND=8)                                  :: dtotal_time         ! cumulated time

  CHARACTER(LEN=256)                            :: cf_in               ! input file
  CHARACTER(LEN=256)                            :: cf_out='cdfstd.nc'  ! std dev output file
  CHARACTER(LEN=256)                            :: cf_moy='cdfmoy.nc'  ! mean output file (optional)
  CHARACTER(LEN=256)                            :: cv_dep              ! depth variable name
  CHARACTER(LEN=256)                            :: cldum               ! dummy string
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_namesi           ! array of var name
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_nameso           ! array of var name for output

  TYPE (variable), DIMENSION(:),    ALLOCATABLE :: stypvari            ! attributes of input variables
  TYPE (variable), DIMENSION(:),    ALLOCATABLE :: stypvaro            ! attributes of output variables

  LOGICAL                                       :: lcaltmean           ! time mean computation flag
  LOGICAL                                       :: lsave=.false.       ! mean value save flag
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfstd list_of files [-save]' 
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the standard deviation of the variables belonging to a set of' 
     PRINT *,'       files given as arguments.  This computation is direct and does not '
     PRINT *,'       required a pre-processing with any of the cdfmoy tools.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       List on netcdf files of the same type, forming a time-series' 
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [ -save ] : Save the mean value of the field, in addition to the '
     PRINT *,'                   std deviation' 
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       none' 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       - netcdf file : ', TRIM(cf_out) 
     PRINT *,'           variables :  IN-var_std, same units than input variables.'
     PRINT *,'       - netcdf file : ', TRIM(cf_moy),' in case of -save option.' 
     PRINT *,'           variables :  IN-var, same units than input variables.'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'        cdfmoy, cdfrmsssh, cdfstdevw'
     STOP
  ENDIF

  ! look for -save option and one of the file name 
  ijarg = 1
  DO WHILE ( ijarg <= narg ) 
    CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1
    SELECT CASE ( cldum )
    CASE ( '-save' ) 
      lsave = .true.
    CASE DEFAULT 
       cf_in = cldum
!      CALL getarg (ijarg, cf_in) ; ijarg = ijarg + 1
       EXIT  ! got the first file
    END SELECT
  END DO

  IF ( chkfile(cf_in) ) STOP ! missing file

  npiglo = getdim (cf_in, cn_x)
  npjglo = getdim (cf_in, cn_y)
  npk    = getdim (cf_in, cn_z, cdtrue=cv_dep, kstatus=ierr)

  IF (ierr /= 0 ) THEN
     npk   = getdim (cf_in,'z',kstatus=ierr)
     IF (ierr /= 0 ) THEN
        npk   = getdim (cf_in,'sigma',cdtrue=cv_dep,kstatus=ierr)
       IF (ierr /= 0 ) THEN
         PRINT *,' assume file with no depth'
         npk=0
       ENDIF
     ENDIF
  ENDIF

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk

  ALLOCATE( dtab(npiglo,npjglo), dtab2(npiglo,npjglo), v2d(npiglo,npjglo) )
  ALLOCATE( dstd(npiglo,npjglo)                                           )

  nvars = getnvar(cf_in)
  PRINT *,' nvars =', nvars

  ALLOCATE (cv_namesi(nvars), cv_nameso(nvars)          )
  ALLOCATE (stypvari(nvars), stypvaro(nvars)            )
  ALLOCATE (id_var(nvars), ipk(nvars), id_varout(nvars) )
  IF ( lsave ) ALLOCATE (id_varoutm(nvars)              )

  cv_namesi(:) = getvarname(cf_in, nvars, stypvari)

  id_var(:)  = (/(jv, jv=1,nvars)/)
  ipk(:)     = getipk(cf_in, nvars, cdep=cv_dep)
  DO jvar = 1, nvars 
     cv_nameso(jvar) = TRIM(cv_namesi(jvar))//'_std' 
  ENDDO

  WHERE( ipk == 0 ) cv_nameso='none'

  DO jvar = 1, nvars
     stypvaro(jvar)             = stypvari(jvar)
     stypvaro(jvar)%cname       = cv_nameso(jvar)
     stypvaro(jvar)%clong_name  = 'Std Deviation of '//TRIM(cv_namesi(jvar))
     stypvaro(jvar)%cshort_name = cv_nameso(jvar)
  END DO

  ! create output fileset
  ncout = create      (cf_out, cf_in,    npiglo, npjglo, npk, cdep=cv_dep )
  ierr  = createvar   (ncout,  stypvaro, nvars,  ipk,    id_varout        )
  ierr  = putheadervar(ncout,  cf_in,    npiglo, npjglo, npk, cdep=cv_dep )

  IF ( lsave )  THEN
    ! create output fileset for mean values
    ncou2 = create      (cf_moy, cf_in,    npiglo, npjglo, npk, cdep=cv_dep )
    ierr  = createvar   (ncou2,  stypvari, nvars,  ipk,    id_varoutm       )
    ierr  = putheadervar(ncou2,  cf_in,    npiglo, npjglo, npk, cdep=cv_dep )
  ENDIF

  lcaltmean=.TRUE.
  DO jvar = 1,nvars
     IF ( cv_namesi(jvar) == cn_vlon2d .OR. &
          cv_namesi(jvar) == cn_vlat2d .OR. &
          cv_nameso(jvar) == 'none'  ) THEN
        ! skip these variable
     ELSE
        PRINT *,' Working with ', TRIM(cv_namesi(jvar)), ipk(jvar)

        DO jk = 1, ipk(jvar)
           PRINT *,'level ',jk

           dtab(:,:) = 0.d0; dtab2(:,:) = 0.d0; dtotal_time = 0.d0 
           ntframe = 0
           DO jfil = 1, narg
              CALL getarg (jfil, cf_in)
              IF ( chkfile(cf_in) ) STOP ! missing file

              IF ( lcaltmean )  THEN
                 npt = getdim (cf_in, cn_t)
                 ALLOCATE (tim(npt) )
                 tim(:)      = getvar1d(cf_in, cn_vtimec, npt)
                 dtotal_time = dtotal_time + SUM(DBLE(tim))
                 DEALLOCATE ( tim ) 
              END IF

              DO jt=1,npt
                 ntframe = ntframe + 1
                 v2d(  :,:) = getvar(cf_in, cv_namesi(jvar), jk, npiglo, npjglo, ktime=jt)
                 dtab( :,:) = dtab( :,:) + v2d(:,:)*1.d0
                 dtab2(:,:) = dtab2(:,:) + v2d(:,:)*v2d(:,:)*1.d0
              END DO
           END DO

           ! finish with level jk ; compute mean (assume spval is 0 )
           dtab( :,:) = dtab( :,:) / ntframe
           dtab2(:,:) = dtab2(:,:) / ntframe

           WHERE ( dtab2 - dtab*dtab >= 0 ) 
             dstd = SQRT(dtab2 - dtab*dtab)
           ELSEWHERE
             dstd = 0.d0
           END WHERE

           ! store variable on output file
                        ierr = putvar(ncout, id_varout(jvar),  REAL(dstd), jk, npiglo, npjglo, kwght=ntframe)
           IF ( lsave ) ierr = putvar(ncou2, id_varoutm(jvar), REAL(dtab), jk, npiglo, npjglo, kwght=ntframe)

           IF ( lcaltmean )  THEN
              timean(1) = dtotal_time / ntframe
                           ierr = putvar1d(ncout, timean, 1, 'T')
              IF ( lsave ) ierr = putvar1d(ncou2, timean, 1, 'T')
              lcaltmean = .FALSE. ! tmean already computed 
           END IF
        END DO  ! loop to next level
     END IF

  END DO ! loop to next var in file

  ierr = closeout(ncout)
  ierr = closeout(ncou2)

END PROGRAM cdfstd

PROGRAM cdfmoy_weighted
  !!======================================================================
  !!                     ***  PROGRAM  cdfmoy_weighted  ***
  !!=====================================================================
  !!  ** Purpose : Compute weighted mean values from already processed
  !!               mean files (by cdfmoy)
  !!
  !!  ** Method  : The weight of each file is the number of elements used
  !!               when computing the time average. 
  !!
  !! History : 2.1  : 11/2009  : J.M. Molines : Original code
  !!           3.0  : 04/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  !!      function       : comments
  !!  setweight   : return weight for given variable and file
  !!----------------------------------------------------------------------
  USE cdfio 
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                               :: jk, jt, jvar        ! dummy loop index
  INTEGER(KIND=4)                               :: ierr                ! working integer
  INTEGER(KIND=4)                               :: narg, iargc, ijarg  ! command line
  INTEGER(KIND=4)                               :: npiglo, npjglo, npk ! size of the domain
  INTEGER(KIND=4)                               :: nvars               ! number of variables in a file
  INTEGER(KIND=4)                               :: ntags               ! number of tags to process
  INTEGER(KIND=4)                               :: iweight             ! variable weight
  INTEGER(KIND=4)                               :: ncout               ! ncid of output file
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: id_var              ! array of input var id's
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: ipk                 ! array of output var levels
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: id_varout           ! array of output var id's

  REAL(KIND=4), DIMENSION (:,:),    ALLOCATABLE :: v2d                 ! array to read a layer of data
  REAL(KIND=4), DIMENSION(1)                    :: timean, tim         ! time counter

  REAL(KIND=8), DIMENSION (:,:),    ALLOCATABLE :: dtab                ! array for cumulated values
  REAL(KIND=8)                                  :: dtotal_time, dsumw  ! cumulated times and weights

  CHARACTER(LEN=256)                            :: cf_in               ! current input file name
  CHARACTER(LEN=256)                            :: cf_out='cdfmoy_weighted.nc' ! output file name
  CHARACTER(LEN=256)                            :: cv_dep              ! name of depth variable
  CHARACTER(LEN=256)                            :: cldum               ! dummy character variable
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_names            ! array of var name
  
  TYPE (variable), DIMENSION(:),    ALLOCATABLE :: stypvar             ! structure for output var attributes

  LOGICAL                                       :: lold5d              ! flag for old5d output
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfmoy_weighted list of files [-old5d ]'
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute weight average of files. The weight for each file is'
     PRINT *,'       read from the iweight attribute. In particular, this attribute'
     PRINT *,'       is set to the number of elements used when computing a time'
     PRINT *,'       average (cdfmoy program). A primary application is thus for'
     PRINT *,'       computing annual mean from monthly means.' 
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       The list of files to be averaged, which are supposed to be of' 
     PRINT *,'       the same type and to contain the same variables. This list MUST'
     PRINT *,'       be given before any options'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-old5d ] : This option is used to mimic/replace the cdfmoy_annual'
     PRINT *,'                   which is no longer available. With this option, 12 monthly'
     PRINT *,'                   files must be given, and it is assumed that the monthly'
     PRINT *,'                   means were computed from 5d output of a simulation using'
     PRINT *,'                   a noleap calendar ( weights are fixed, predetermined)'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       none'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'       variables : same as in the input files'
     STOP
  ENDIF

  ! default values
  lold5d = .FALSE.
  ! scan command line and check if files exist
  ijarg = 1
  ntags = narg
  DO WHILE ( ijarg <= narg ) 
    CALL getarg ( ijarg, cldum ) ; ijarg = ijarg +1
    SELECT CASE ( cldum )
    CASE ( '-old5d' )
        lold5d = .TRUE.
        ntags = ntags - 1
    CASE DEFAULT
        cf_in = cldum
        IF ( chkfile (cldum ) ) STOP ! missing file
    END SELECT
  ENDDO

  ! additional check in case of old_5d averaged files
  IF ( lold5d ) THEN
    IF ( ntags /= 12 ) THEN 
       PRINT *,' ERROR : exactly 12 monthly files are required for -old5d option'
       STOP
    ENDIF
  ENDIF

  npiglo = getdim (cf_in, cn_x                              )
  npjglo = getdim (cf_in, cn_y                              )
  npk    = getdim (cf_in, cn_z, cdtrue=cv_dep, kstatus=ierr )

  IF (ierr /= 0 ) THEN
     npk   = getdim (cf_in,'z',cdtrue=cv_dep, kstatus=ierr   )
     IF (ierr /= 0 ) THEN
       npk   = getdim (cf_in,'sigma',cdtrue=cv_dep,kstatus=ierr)
        IF ( ierr /= 0 ) THEN
          npk = getdim (cf_in,'nav_lev',cdtrue=cv_dep,kstatus=ierr)
            IF ( ierr /= 0 ) THEN
              npk = getdim (cf_in,'levels',cdtrue=cv_dep,kstatus=ierr)
              IF ( ierr /= 0 ) THEN
                PRINT *,' assume file with no depth'
                npk=0
              ENDIF
            ENDIF
        ENDIF
     ENDIF
  ENDIF

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk

  ALLOCATE( dtab(npiglo,npjglo), v2d(npiglo,npjglo) )

  nvars = getnvar(cf_in)
  PRINT *,' nvars =', nvars

  ALLOCATE (cv_names(nvars) )
  ALLOCATE (stypvar(nvars)  )
  ALLOCATE (id_var(nvars), ipk(nvars), id_varout(nvars) )

  ! get list of variable names and collect attributes in stypvar (optional)
  cv_names(:) = getvarname(cf_in, nvars, stypvar)

  id_var(:)   = (/(jvar, jvar=1,nvars)/)

  ! ipk gives the number of level or 0 if not a T[Z]YX  variable
  ipk(:)     = getipk(cf_in, nvars, cdep=cv_dep)
  WHERE( ipk == 0 ) cv_names='none'
  stypvar(:)%cname = cv_names

  ! create output file taking the sizes in cf_in
  ncout = create      (cf_out, cf_in,   npiglo, npjglo, npk,      cdep=cv_dep )
  ierr  = createvar   (ncout , stypvar, nvars,  ipk,    id_varout             )
  ierr  = putheadervar(ncout , cf_in,   npiglo, npjglo, npk,      cdep=cv_dep )

  DO jvar = 1,nvars
     IF ( cv_names(jvar) == cn_vlon2d .OR. &
          cv_names(jvar) == cn_vlat2d        ) THEN
        ! skip these variable
     ELSE
        PRINT *,' Working with ', TRIM(cv_names(jvar)), ipk(jvar)
        DO jk = 1, ipk(jvar)
           PRINT *,'Level ',jk
           dtab(:,:) = 0.d0 ; dtotal_time = 0.d0 ; dsumw=0.d0

           DO jt = 1, ntags
              CALL getarg   (jt, cf_in)

              iweight   = setweight(cf_in, jt, cv_names(jvar)) 
              dsumw     = dsumw + iweight
              v2d(:,:)  = getvar(cf_in, cv_names(jvar), jk ,npiglo, npjglo )
              dtab(:,:) = dtab(:,:) + iweight * v2d(:,:)

              IF (jk == 1 .AND. jvar == nvars )  THEN
                 tim         = getvar1d(cf_in, cn_vtimec, 1 )
                 dtotal_time = dtotal_time + tim(1)
              END IF
           END DO

           ! finish with level jk ; compute mean (assume spval is 0 )
           ! store variable on outputfile
           ierr = putvar(ncout, id_varout(jvar), SNGL(dtab(:,:)/dsumw), jk, npiglo, npjglo, kwght=INT(dsumw) )
           IF (jk == 1 .AND. jvar == nvars )  THEN
              timean(1) = dtotal_time/ntags
              ierr      = putvar1d(ncout, timean, 1, 'T')
           END IF
        END DO  ! loop to next level
     END IF
  END DO ! loop to next var in file

  ierr = closeout(ncout)

  CONTAINS

  INTEGER(KIND=4) FUNCTION setweight( cdfile, kt, cdvar )
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION setweight  ***
    !!
    !! ** Purpose : Return the weight of cdvar in cdfile
    !!
    !! ** Method  : Get attribute iweight from cdfvar in cdfile.
    !!              If lold5d is true, assume weight for 5d build monthly 
    !!              means. If iweight not found 1 is return.
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*),   INTENT(in) :: cdfile
    INTEGER(KIND=4),    INTENT(in) :: kt
    CHARACTER(LEN=*),   INTENT(in) :: cdvar

    INTEGER(KIND=4), DIMENSION(12) :: iweight5d=(/6,5,7,6,6,6,6,6,6,6,6,7/)
    !!----------------------------------------------------------------------
    IF ( lold5d ) THEN 
      setweight = iweight5d(kt)
    ELSE
      setweight = getatt( cdfile, cdvar, 'iweight') 
      IF ( setweight == 0 ) setweight = 1
    ENDIF

    END FUNCTION setweight

END PROGRAM cdfmoy_weighted

PROGRAM cdfpendep
  !!======================================================================
  !!                     ***  PROGRAM  cdfpendep  ***
  !!=====================================================================
  !!  ** Purpose : Computes penetration depth for passive tracer output. 
  !!               This is the ratio between inventory and surface 
  !!               concentration.
  !!
  !!  ** Method  : takes TRC files as input
  !!
  !! History : 2.1  : 02/2008  : J.M. Molines : Original code
  !!         : 2.1  : 09/2010  : C. Dufour    : Adapation to TOP evolution
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio 
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: jt                   ! dummy loop index
  INTEGER(KIND=4)                           :: narg, iargc, ijarg   ! browse command line
  INTEGER(KIND=4)                           :: npiglo, npjglo       ! size of the domain
  INTEGER(KIND=4)                           :: npk, npt             ! size of the domain
  INTEGER(KIND=4)                           :: ncout                ! ncid of output file
  INTEGER(KIND=4)                           :: ierr                 ! error status
  INTEGER(KIND=4), DIMENSION(1)             :: ipk, id_varout       ! levels and varid's of output vats

  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: trcinv, trcsurf      ! inventory, surface concentration
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: rpendep              ! penetration depth
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: tim                  ! time counter

  CHARACTER(LEN=256)                        :: cf_trcfil            ! tracer file name
  CHARACTER(LEN=256)                        :: cf_inv               ! inventory file name
  CHARACTER(LEN=256)                        :: cf_out='pendep.nc'   ! output file
  CHARACTER(LEN=256)                        :: cv_inv               ! inventory variable name
  CHARACTER(LEN=256)                        :: cv_trc               ! tracer variable name
  CHARACTER(LEN=256)                        :: cglobal              ! global attribute
  CHARACTER(LEN=256)                        :: cldum                ! dummy string

  TYPE(variable), DIMENSION(1)              :: typvar               ! structure for attributes
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  cv_inv = cn_invcfc
  cv_trc = cn_cfc11
  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage :  cdfpendep TRC-file INV-file  ... '
     PRINT *,'                    ... [-inv inventory_name -trc trc_name ]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'        Compute the penetration depth for passive tracers. It is the'
     PRINT *,'        ratio between the inventory and the surface concentration of'
     PRINT *,'        the tracer.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       TRC-file : netcdf file with tracer concentration.' 
     PRINT *,'       INV-file : netcdf file with inventory of the tracer.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-inv inventory_name ] : specify netcdf variable name for inventory.' 
     PRINT *,'                                Default is ', TRIM(cv_inv)
     PRINT *,'       [-trc tracer_name ]    : specify netcdf variable name for tracer.' 
     PRINT *,'                                Default is ', TRIM(cv_trc)
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        none'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : pendep (m)'
     STOP
  ENDIF

  ijarg = 1
  CALL getarg (ijarg, cf_trcfil) ; ijarg = ijarg + 1 
  CALL getarg (ijarg, cf_inv   ) ; ijarg = ijarg + 1

  IF ( chkfile(cf_trcfil) .OR. chkfile(cf_inv) ) STOP ! missing file

  DO WHILE ( ijarg <= narg)
     CALL getarg(ijarg, cldum ) ; ijarg = ijarg + 1 
     SELECT CASE ( cldum )
     CASE ('-inv') ;  CALL getarg(ijarg, cv_inv) ; ijarg=ijarg+1
     CASE ('-trc') ;  CALL getarg(ijarg, cv_trc) ; ijarg=ijarg+1
     CASE DEFAULT  ; PRINT *, 'option ', TRIM(cldum),' not understood' ; STOP
     END SELECT
  END DO

  npiglo = getdim (cf_trcfil,cn_x)
  npjglo = getdim (cf_trcfil,cn_y)
  npk    = getdim (cf_trcfil,cn_z)
  npt    = getdim (cf_trcfil,cn_t)

  ipk(1)                      = 1
  typvar(1)%cname             = cn_pendep
  typvar(1)%cunits            = 'm'
  typvar(1)%rmissing_value    = 0.
  typvar(1)%valid_min         = 0.
  typvar(1)%valid_max         = 10000.
  typvar(1)%clong_name        = 'Penetration depth'
  typvar(1)%cshort_name       = cn_pendep
  typvar(1)%conline_operation = 'N/A'
  typvar(1)%caxis             = 'TYX'


  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  ALLOCATE( trcinv(npiglo,npjglo), trcsurf(npiglo,npjglo), rpendep(npiglo,npjglo) )
  ALLOCATE( tim(npt) )

  WRITE(cglobal,9000) TRIM(cf_trcfil), TRIM(cf_inv), TRIM(cv_inv), TRIM(cv_trc)
9000 FORMAT('cdfpendep ',a,' ',a,' -inv ',a,' -trc ',a )

  ncout = create      (cf_out, cf_trcfil, npiglo, npjglo, 1)
  ierr  = createvar   (ncout,  typvar,    1,      ipk,    id_varout, cdglobal=cglobal )
  ierr  = putheadervar(ncout,  cf_trcfil, npiglo, npjglo, 1)

  DO jt = 1,npt
     rpendep(:,:) = 0.
     trcinv( :,:) = getvar(cf_inv,    cv_inv, 1, npiglo, npjglo, ktime=jt)
     trcsurf(:,:) = getvar(cf_trcfil, cv_trc, 1, npiglo, npjglo, ktime=jt)

     WHERE( trcsurf /= 0 ) rpendep = trcinv/trcsurf
     ierr=putvar(ncout, id_varout(1), rpendep, 1, npiglo, npjglo, ktime=jt)
  END DO

  tim  = getvar1d(cf_trcfil, cn_vtimec, npt     )
  ierr = putvar1d(ncout,     tim,       npt, 'T')
  ierr = closeout(ncout)

END PROGRAM cdfpendep

PROGRAM cdfcsp
  !!======================================================================
  !!                     ***  PROGRAM  cdfcsp  ***
  !!=====================================================================
  !!  ** Purpose : Replace the masked part of the arrays (marked with
  !!               special values) with spval zero. Replace consistently
  !!               the definition of the spval in the variable attribut.
  !!
  !! History : 2.1  : 10/2006  : F. Castruccio : Original code
  !!           3.0  : 12/2010  : J.M. Molines  : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio 
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class file_operations
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                               :: jf, jk, jvar, jt ! dummy loop index
  INTEGER(KIND=4)                               :: narg, iargc      ! 
  INTEGER(KIND=4)                               :: ijarg            !
  INTEGER(KIND=4)                               :: nfiles           ! number of files in the list
  INTEGER(KIND=4)                               :: npiglo, npjglo   ! size of the domain
  INTEGER(KIND=4)                               :: npk , npt        ! size of the domain
  INTEGER(KIND=4)                               :: ncid, ierr       ! ncdf related integer
  INTEGER(KIND=4)                               :: nvars            ! Number of variables in a file
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: ipk              ! arrays of vertical level for each var
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: id_var           ! arrays of var id

  REAL(KIND=4), DIMENSION (:,:),    ALLOCATABLE :: tab              ! working array
  REAL(KIND=4)                                  :: zspval           ! special value read in file
  REAL(KIND=4)                                  :: spval=0.         ! special value written in file

  CHARACTER(LEN=256)                            :: cf_in            ! input file name
  CHARACTER(LEN=256)                            :: cunits           ! units attribute
  CHARACTER(LEN=256)                            :: clname           ! long name attribute
  CHARACTER(LEN=256)                            :: csname           ! short name attribute
  CHARACTER(LEN=256)                            :: cldum            ! working char variable
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_names         ! array of var name
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cf_lst           ! list of input files

  TYPE(variable), DIMENSION(:),     ALLOCATABLE :: stypvar          ! type for attributes
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()

  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfcsp -l LST-files [-v value]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Replace missing_values by 0 and update attribute.' 
     PRINT *,'       This program is not working properly with NETCDF4/HDF5 files!'
     PRINT *,'       Even more : problem when **compiled**  with NETCDF4.'
     PRINT *,'      '
     PRINT *,'     CAUTION :'
     PRINT *,'      ################################'
     PRINT *,'      # INPUT FILES ARE OVER-WRITTEN #'
     PRINT *,'      ################################'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -l LST-files : The list of cdf file to process, all variables will '
     PRINT *,'              be processed.' 
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-v value] : use value instead of 0 as the new missing_value'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        none'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : same as input file (modified)'
     PRINT *,'         variables : same as input file'
     PRINT *,'      '
     STOP 
  ENDIF

  !! Initialisation from 1st file (all file are assume to have the same geometry)
  ijarg=1
  DO WHILE ( ijarg <= narg )
     CALL getarg( ijarg,cldum ) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-l' ) ; CALL GetFileList
        ! options
     CASE ( '-v' ) ; CALL getarg (ijarg, cldum ) ; ijarg=ijarg+1  ; READ(cldum,*) spval
     CASE DEFAULT  ; PRINT *,' ERROR : ', TRIM(cldum) , ' : unknown option.' ; STOP 99
     END SELECT
  ENDDO
  cf_in = cf_lst(1)

  IF ( chkfile (cf_in) ) STOP 99 ! missing file

  npiglo = getdim (cf_in, cn_x)
  npjglo = getdim (cf_in, cn_y)
  npk    = getdim (cf_in, cn_z, kstatus=ierr)
  npt    = getdim (cf_in, cn_t)

  IF (ierr /= 0 ) THEN
     npk   = getdim (cf_in,'z',kstatus=ierr)
     IF (ierr /= 0 ) THEN
        PRINT *, "ASSUME NO VERTICAL DIMENSIONS !"
        npk=0
     ENDIF
  ENDIF

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  ALLOCATE( tab(npiglo,npjglo) )

  nvars = getnvar(cf_in)

  ALLOCATE (cv_names(nvars), id_var(nvars),ipk(nvars), stypvar(nvars))

  cv_names(:) = getvarname(cf_in, nvars, stypvar)
  ipk(:)      = getipk    (cf_in, nvars         )
  id_var(:)   = getvarid  (cf_in, nvars         )

  DO jf = 1, nfiles
     cf_in = cf_lst(jf) 
     IF ( chkfile (cf_in) ) STOP 99 ! missing file
     PRINT *, 'Change spval on file ', cf_in
     ncid = ncopen(cf_in)
     npt  = getdim (cf_in, cn_t)
     DO jvar = 1,nvars
        IF ( cv_names(jvar) == cn_vlon2d  .OR. &
             & cv_names(jvar) == cn_vlat2d  .OR. &
             & cv_names(jvar) == cn_vtimec  .OR. &
             & cv_names(jvar) == cn_vdeptht .OR. &
             & cv_names(jvar) == cn_vdepthu .OR. &
             & cv_names(jvar) == cn_vdepthv      )  THEN
           ! skip these variable
        ELSE
           ierr = getvaratt (cf_in, cv_names(jvar), cunits, zspval, clname, csname)
           ierr = cvaratt   (cf_in, cv_names(jvar), cunits,  spval, clname, csname)
           DO jt=1,npt
              DO jk = 1, ipk(jvar) 
                 tab(:,:) = getvar(cf_in, cv_names(jvar),   jk, npiglo, npjglo, ktime=jt )
                 WHERE( tab(:,:) == zspval ) tab(:,:) = spval
                 ierr     = putvar(ncid, id_var(jvar), tab, jk, npiglo, npjglo, ktime=jt )
              ENDDO
           END DO
        ENDIF
     ENDDO
  ENDDO

  ierr = closeout(ncid)

CONTAINS

  SUBROUTINE GetFileList
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE GetFileList  ***
    !!
    !! ** Purpose :  Set up a file list given on the command line as 
    !!               blank separated list
    !!
    !! ** Method  :  Scan the command line until a '-' is found
    !!----------------------------------------------------------------------
    INTEGER (KIND=4)  :: ji
    INTEGER (KIND=4)  :: icur
    !!----------------------------------------------------------------------
    !!
    nfiles=0
    ! need to read a list of file ( number unknow ) 
    ! loop on argument till a '-' is found as first char
    icur=ijarg                          ! save current position of argument number
    DO ji = icur, narg                  ! scan arguments till - found
       CALL getarg ( ji, cldum )
       IF ( cldum(1:1) /= '-' ) THEN ; nfiles = nfiles+1
       ELSE                          ; EXIT
       ENDIF
    ENDDO
    ALLOCATE (cf_lst(nfiles) )
    DO ji = icur, icur + nfiles -1
       CALL getarg(ji, cf_lst( ji -icur +1 ) ) ; ijarg=ijarg+1
    END DO
  END SUBROUTINE GetFileList

END PROGRAM cdfcsp

PROGRAM cdfcofdis
  !!======================================================================
  !!                     ***  PROGRAM  cdfcofdis  ***
  !!=====================================================================
  !!  ** Purpose : A wrapper for NEMO routine cofdis: create a file 
  !!               with the distance to coast variable
  !!
  !!  ** Method  : Mimic some NEMO global variables to be able to use
  !!               NEMO cofdis with minimum changes. Use cdfio instead
  !!               of IOIPSL for the output file. Due to this constaint
  !!               DOCTOR norm is not fully respected (eg jpi not PARAMETER) 
  !!               pdct is not a routine argument ...
  !!
  !! History : 2.1  : 11/2009  : J.M. Molines : Original code
  !!           3.0  : 12/2010  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  !!   cofdis       : compute distance to coast (NEMO routine )
  !!----------------------------------------------------------------------

  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2010, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: jpi, jpj, jpk
  INTEGER(KIND=4)                           :: jpim1, jpjm1, nperio=4
  INTEGER(KIND=4)                           :: narg, iargc, iarg
  INTEGER(KIND=4)                           :: ncout, ierr
  INTEGER(KIND=4), DIMENSION(1)             :: ipk, id_varout

  ! from phycst
  REAL(KIND=4)            :: rpi = 3.141592653589793          !: pi
  REAL(KIND=4)            :: rad = 3.141592653589793 / 180.   !: conv. from degre into radian
  REAL(KIND=4)            :: ra  = 6371229.                   !: earth radius (meter)

  REAL(KIND=4) ,DIMENSION(1)                :: timean
  ! to be read in mesh_hgr
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: glamt, glamu,glamv, glamf
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: gphit, gphiu,gphiv, gphif
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: tmask, umask, vmask, fmask
  ! 
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: pdct                       ! 2D only in this version
                                                                          ! It is a 3D arg in original cofdis
  CHARACTER(LEN=256)                        :: cf_out='dist.coast'
  CHARACTER(LEN=256)                        :: cf_tfil
  CHARACTER(LEN=256)                        :: cv_out='Tcoast'
  CHARACTER(LEN=256)                        :: cldum

  TYPE(variable), DIMENSION(1)              :: stypvar

  LOGICAL                                   :: lchk
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()
  !
  narg=iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage :  cdfcofdis mesh_hgr.nc mask.nc gridT.nc [-jperio jperio ]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'        Compute the distance to the coast and create a file with '
     PRINT *,'        the ',TRIM(cv_out),' variable, indicating the distance to the coast.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       HGR-file : name of the mesh_hgr file '
     PRINT *,'       MSK-file : name of the mask file '
     PRINT *,'       T-file   : netcdf file at T point.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [ -jperio jperio ] : define the NEMO jperio variable for north fold condition' 
     PRINT *,'                Default is  4.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       none' 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : ', TRIM(cv_out),' (m)'
     PRINT *,'      '
     PRINT *,'      '
     STOP
  ENDIF
 
  CALL getarg(1,cn_fhgr)  ! overwrite standard name eventually
  CALL getarg(2,cn_fmsk)  !   ""                "" 
  CALL getarg(3,cf_tfil )

  lchk =           chkfile ( cn_fhgr )
  lchk = lchk .OR. chkfile ( cn_fmsk )
  lchk = lchk .OR. chkfile ( cf_tfil )
  IF ( lchk ) STOP ! missing files

  iarg = 4 
  DO WHILE ( iarg <= narg )
    CALL getarg(iarg, cldum ) ; iarg = iarg + 1
    SELECT CASE ( cldum )
    CASE ( '-jperio' ) 
       CALL getarg (iarg,cldum) ; READ(cldum, * ) nperio  ; iarg = iarg + 1
    CASE DEFAULT
       PRINT *,' unknown option : ', TRIM(cldum)
       STOP
    END SELECT
  END DO

  ! read domain dimensions in the mask file
  jpi = getdim(cf_tfil,cn_x)
  jpj = getdim(cf_tfil,cn_y)
  jpk = getdim(cf_tfil,cn_z)

  IF (jpk == 0 ) THEN
    jpk = getdim(cf_tfil,'z')
    IF ( jpk == 0 ) THEN
      PRINT *,' ERROR in determining jpk form gridT file ....'
      STOP
    ENDIF
  ENDIF

  PRINT *, ' JPI = ', jpi
  PRINT *, ' JPJ = ', jpj
  PRINT *, ' JPK = ', jpk

  jpim1=jpi-1 ; jpjm1=jpj-1

  ! ALLOCATION of the arrays
  ALLOCATE ( glamt(jpi,jpj), glamu(jpi,jpj), glamv(jpi,jpj), glamf(jpi,jpj) )
  ALLOCATE ( gphit(jpi,jpj), gphiu(jpi,jpj), gphiv(jpi,jpj), gphif(jpi,jpj) )
  ALLOCATE ( tmask(jpi,jpj), umask(jpi,jpj), vmask(jpi,jpj), fmask(jpi,jpj) )
  ALLOCATE ( pdct(jpi,jpj) )
  
  PRINT *, 'ALLOCATION DONE.'

  ! read latitude an longitude
  glamt(:,:) = getvar(cn_fhgr,cn_glamt,1,jpi,jpj)
  glamu(:,:) = getvar(cn_fhgr,cn_glamu,1,jpi,jpj)
  glamv(:,:) = getvar(cn_fhgr,cn_glamv,1,jpi,jpj)
  glamf(:,:) = getvar(cn_fhgr,cn_glamf,1,jpi,jpj)

  gphit(:,:) = getvar(cn_fhgr,cn_gphit,1,jpi,jpj)
  gphiu(:,:) = getvar(cn_fhgr,cn_gphiu,1,jpi,jpj)
  gphiv(:,:) = getvar(cn_fhgr,cn_gphiv,1,jpi,jpj)
  gphif(:,:) = getvar(cn_fhgr,cn_gphif,1,jpi,jpj)

  ! prepare file output
  ipk(1)                       = jpk
  stypvar(1)%cname             = cv_out
  stypvar(1)%cunits            = 'm'
  stypvar(1)%rmissing_value    = 0
  stypvar(1)%valid_min         = 0.
  stypvar(1)%valid_max         = 1.
  stypvar(1)%clong_name        = cv_out
  stypvar(1)%cshort_name       = cv_out
  stypvar(1)%conline_operation = 'N/A'
  stypvar(1)%caxis             = 'TZYX'
  stypvar(1)%cprecision        = 'r4'

  ncout = create      (cf_out, cf_tfil, jpi, jpj, jpk       )
  ierr  = createvar   (ncout,  stypvar, 1,   ipk, id_varout )
  ierr  = putheadervar(ncout,  cf_tfil, jpi, jpj, jpk       )

  CALL cofdis
  
  CONTAINS

  SUBROUTINE cofdis()
    !!----------------------------------------------------------------------
    !!                 ***  ROUTINE cofdis  ***
    !!
    !! ** Purpose :   Compute the distance between ocean T-points and the
    !!      ocean model coastlines. Save the distance in a NetCDF file.
    !!
    !! ** Method  :   For each model level, the distance-to-coast is 
    !!      computed as follows : 
    !!       - The coastline is defined as the serie of U-,V-,F-points
    !!      that are at the ocean-land bound.
    !!       - For each ocean T-point, the distance-to-coast is then 
    !!      computed as the smallest distance (on the sphere) between the 
    !!      T-point and all the coastline points.
    !!       - For land T-points, the distance-to-coast is set to zero.
    !!      C A U T I O N : Computation not yet implemented in mpp case.
    !!
    !! ** Action  : - pdct, distance to the coastline (argument)
    !!              - NetCDF file 'dist.coast' 
    !!----------------------------------------------------------------------
    INTEGER(KIND=4) ::   ji, jj, jk, jl      ! dummy loop indices
    INTEGER(KIND=4) ::   iju, ijt            ! temporary integers
    INTEGER(KIND=4) ::   icoast, itime
    INTEGER(KIND=4) ::   icot         ! logical unit for file distance to the coast
    LOGICAL, DIMENSION(jpi,jpj) ::   llcotu, llcotv, llcotf   ! ???
    CHARACTER (len=32) ::   clname
    REAL(KIND=4) ::   zdate0
    REAL(KIND=4), DIMENSION(jpi,jpj)   ::   zxt, zyt, zzt, zmask   ! cartesian coordinates for T-points
    REAL(KIND=4), DIMENSION(3*jpi*jpj) ::   zxc, zyc, zzc, zdis    ! temporary workspace
    !!----------------------------------------------------------------------

    ! 0. Initialization
    ! -----------------
    PRINT *, 'COFDIS init'
    zxt(:,:) = COS( rad * gphit(:,:) ) * COS( rad * glamt(:,:) )
    zyt(:,:) = COS( rad * gphit(:,:) ) * SIN( rad * glamt(:,:) )
    zzt(:,:) = SIN( rad * gphit(:,:) )


    ! 1. Loop on vertical levels
    ! --------------------------
    !                                             ! ===============
    DO jk = 1, jpk                                ! Horizontal slab
       !                                          ! ===============
       PRINT *,'WORKING for level ', jk, nperio
       pdct(:,:) = 0.e0
       ! read the masks
       !    temp(:,:) = getvar(cbathy,'Bathy_level',1, npiglo, npjglo)

       tmask(:,:)=getvar(cn_fmsk,'tmask',jk,jpi,jpj)
       umask(:,:)=getvar(cn_fmsk,'umask',jk,jpi,jpj)
       vmask(:,:)=getvar(cn_fmsk,'vmask',jk,jpi,jpj)
       fmask(:,:)=getvar(cn_fmsk,'fmask',jk,jpi,jpj)
       PRINT *, '    READ masks done.'
       ! Define the coastline points (U, V and F)
       DO jj = 2, jpjm1
          DO ji = 2, jpim1
             zmask(ji,jj) =  ( tmask(ji,jj+1) + tmask(ji+1,jj+1) &
                  &           + tmask(ji,jj  ) + tmask(ji+1,jj  ) )
             llcotu(ji,jj) = ( tmask(ji,jj  ) + tmask(ji+1,jj  ) == 1. ) 
             llcotv(ji,jj) = ( tmask(ji,jj  ) + tmask(ji  ,jj+1) == 1. ) 
             llcotf(ji,jj) = ( zmask(ji,jj) > 0. ) .AND. ( zmask(ji,jj) < 4. )
          END DO
       END DO
       PRINT *,'  llcot? set now.'

       ! Lateral boundaries conditions
       llcotu(:, 1 ) = umask(:,  2  ) == 1
       llcotu(:,jpj) = umask(:,jpjm1) == 1
       llcotv(:, 1 ) = vmask(:,  2  ) == 1
       llcotv(:,jpj) = vmask(:,jpjm1) == 1
       llcotf(:, 1 ) = fmask(:,  2  ) == 1
       llcotf(:,jpj) = fmask(:,jpjm1) == 1

       IF( nperio == 1 .OR. nperio == 4 .OR. nperio == 6 ) THEN
          llcotu( 1 ,:) = llcotu(jpim1,:)
          llcotu(jpi,:) = llcotu(  2  ,:)
          llcotv( 1 ,:) = llcotv(jpim1,:)
          llcotv(jpi,:) = llcotv(  2  ,:)
          llcotf( 1 ,:) = llcotf(jpim1,:)
          llcotf(jpi,:) = llcotf(  2  ,:)
       ELSE
          llcotu( 1 ,:) = umask(  2  ,:) == 1
          llcotu(jpi,:) = umask(jpim1,:) == 1
          llcotv( 1 ,:) = vmask(  2  ,:) == 1
          llcotv(jpi,:) = vmask(jpim1,:) == 1
          llcotf( 1 ,:) = fmask(  2  ,:) == 1
          llcotf(jpi,:) = fmask(jpim1,:) == 1
       ENDIF
       IF( nperio == 3 .OR. nperio == 4 ) THEN
          DO ji = 1, jpim1
             iju = jpi - ji + 1
             llcotu(ji,jpj  ) = llcotu(iju,jpj-2)
             llcotf(ji,jpjm1) = llcotf(iju,jpj-2)
             llcotf(ji,jpj  ) = llcotf(iju,jpj-3)
          END DO
          DO ji = jpi/2, jpim1
             iju = jpi - ji + 1
             llcotu(ji,jpjm1) = llcotu(iju,jpjm1)
          END DO
          DO ji = 2, jpi
             ijt = jpi - ji + 2
             llcotv(ji,jpjm1) = llcotv(ijt,jpj-2)
             llcotv(ji,jpj  ) = llcotv(ijt,jpj-3)
          END DO
       ENDIF
       IF( nperio == 5 .OR. nperio == 6 ) THEN
          DO ji = 1, jpim1
             iju = jpi - ji
             llcotu(ji,jpj  ) = llcotu(iju,jpjm1)
             llcotf(ji,jpj  ) = llcotf(iju,jpj-2)
          END DO
          DO ji = jpi/2, jpim1
             iju = jpi - ji
             llcotf(ji,jpjm1) = llcotf(iju,jpjm1)
          END DO
          DO ji = 1, jpi
             ijt = jpi - ji + 1
             llcotv(ji,jpj  ) = llcotv(ijt,jpjm1)
          END DO
          DO ji = jpi/2+1, jpi
             ijt = jpi - ji + 1
             llcotv(ji,jpjm1) = llcotv(ijt,jpjm1)
          END DO
       ENDIF

       ! Compute cartesian coordinates of coastline points
       ! and the number of coastline points

       icoast = 0
       PRINT *,' START computing cartesian coord of coastlines '
       DO jj = 1, jpj
          DO ji = 1, jpi
             IF( llcotf(ji,jj) ) THEN
                icoast = icoast + 1
                zxc(icoast) = COS( rad*gphif(ji,jj) ) * COS( rad*glamf(ji,jj) )
                zyc(icoast) = COS( rad*gphif(ji,jj) ) * SIN( rad*glamf(ji,jj) )
                zzc(icoast) = SIN( rad*gphif(ji,jj) )
             ENDIF
             IF( llcotu(ji,jj) ) THEN
                icoast = icoast+1
                zxc(icoast) = COS( rad*gphiu(ji,jj) ) * COS( rad*glamu(ji,jj) )
                zyc(icoast) = COS( rad*gphiu(ji,jj) ) * SIN( rad*glamu(ji,jj) )
                zzc(icoast) = SIN( rad*gphiu(ji,jj) )
             ENDIF
             IF( llcotv(ji,jj) ) THEN
                icoast = icoast+1
                zxc(icoast) = COS( rad*gphiv(ji,jj) ) * COS( rad*glamv(ji,jj) )
                zyc(icoast) = COS( rad*gphiv(ji,jj) ) * SIN( rad*glamv(ji,jj) )
                zzc(icoast) = SIN( rad*gphiv(ji,jj) )
             ENDIF
          END DO
       END DO
       PRINT *,' END computing cartesian coord of coastlines '

       ! Distance for the T-points

       PRINT *,' START computing distance for T points', icoast
       DO jj = 1, jpj
             print *, jj
          DO ji = 1, jpi
             IF( tmask(ji,jj) == 0. ) THEN
                pdct(ji,jj) = 0.
             ELSE
                DO jl = 1, icoast
                   zdis(jl) = ( zxt(ji,jj) - zxc(jl) )**2   &
                        &     + ( zyt(ji,jj) - zyc(jl) )**2 &
                        &     + ( zzt(ji,jj) - zzc(jl) )**2
                END DO
                pdct(ji,jj) = ra * SQRT( MINVAL( zdis(1:icoast) ) )
             ENDIF
          END DO
       END DO
       PRINT *,' END computing distance for T points'
       
       ierr=putvar(ncout,id_varout(1),pdct,jk,jpi,jpj)
       !                                                ! ===============
    END DO                                              !   End of slab
    !                                                   ! ===============
    timean(:)=0.
    ierr=putvar1d(ncout,timean,1,'T')
    ierr = closeout(ncout)

  END SUBROUTINE cofdis

  END PROGRAM cdfcofdis

PROGRAM cdfmoyt
  !!======================================================================
  !!                     ***  PROGRAM  cdfmoyt  ***
  !!=====================================================================
  !!  ** Purpose : Compute mean values for all the variables in a bunch
  !!               of cdf files given as arguments.
  !!               Store the results on a 'similar' cdf file. This version
  !!               differ from cdfmoy, because if the input files have many
  !!               time frames in it, the output file will have the same 
  !!               number of time frames, each being the average accross the
  !!               input files.
  !!
  !!  ** Method  : Also store the mean squared values for the nn_sqdvar
  !!               variables belonging to cn_sqdvar(:), than can be changed 
  !!               in the nam_cdf_names namelist if wished.
  !!
  !! History : 2.0  : 11/2004  : J.M. Molines : Original code
  !!         : 2.1  : 06/2007  : P. Mathiot   : Modif for forcing fields
  !!           3.0  : 12/2010  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  !!   routines      : description
  !!   varchk2       : check if variable is candidate for square mean
  !!----------------------------------------------------------------------
  USE cdfio 
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class time_averaging
  !!-----------------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                               :: jk, jfil, jrec     ! dummy loop index
  INTEGER(KIND=4)                               :: jvar, jv, jt       ! dummy loop index
  INTEGER(KIND=4)                               :: ierr               ! working integer
  INTEGER(KIND=4)                               :: idep, idep_max     ! possible depth index, maximum
  INTEGER(KIND=4)                               :: inpt               ! working integer
  INTEGER(KIND=4)                               :: narg, iargc, ijarg ! browsing command line
  INTEGER(KIND=4)                               :: nfiles             ! number of files to average
  INTEGER(KIND=4)                               :: npiglo, npjglo     ! size of the domain
  INTEGER(KIND=4)                               :: npk, npt           ! size of the domain
  INTEGER(KIND=4)                               :: nvars              ! number of variables in a file
  INTEGER(KIND=4)                               :: ntframe            ! cumul of time frame
  INTEGER(KIND=4)                               :: ncout, ncout2      ! ncid of output files
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: id_var             ! arrays of var id's
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: ipk                ! arrays of vertical level for each var
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: id_varout          ! varid's of average vars
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: id_varout2         ! varid's of sqd average vars

  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: zspval_in          ! input missing value
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: v2d                ! array to read a layer of data

  REAL(KIND=8), DIMENSION(:),       ALLOCATABLE :: dtim               ! time counter
  REAL(KIND=8), DIMENSION(:),       ALLOCATABLE :: dtotal_time        ! to compute mean time
  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: dtab, dtab2        ! arrays for cumulated values

  CHARACTER(LEN=256)                            :: cf_in              ! input file names
  CHARACTER(LEN=256)                            :: cf_root = 'cdfmoyt'! root of the output file name
  CHARACTER(LEN=256)                            :: cf_out             ! output file for average
  CHARACTER(LEN=256)                            :: cf_out2            ! output file for squared average
  CHARACTER(LEN=256)                            :: cv_dep             ! depth dimension name
  CHARACTER(LEN=256)                            :: cldum              ! dummy string argument
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cf_lst             ! list of input files
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_nam             ! array of var name
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_nam2            ! array of var2 name for output
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: clv_dep            ! array of possible depth name (or 3rd dimension)

  TYPE (variable), DIMENSION(:),    ALLOCATABLE :: stypvar            ! attributes for average values
  TYPE (variable), DIMENSION(:),    ALLOCATABLE :: stypvar2           ! attributes for square averaged values

  LOGICAL                                       :: lspval0 = .FALSE.  ! cdfmoy_chsp flag
  LOGICAL                                       :: lnc4    = .FALSE.  ! Use nc4 with chunking and deflation
  LOGICAL                                       :: lchk               ! flag for checking presence of files
  !!----------------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfmoyt -l LST-files [-spval0] [-vvl] [-o OUT-rootname] [-nc4]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the ''file average'' of the files listed on the command line.'
     PRINT *,'       The ''file average'' will have the same number of time frame than any'
     PRINT *,'       individual file in the list, the average being done frame by frame.'
     PRINT *,'       '
     PRINT *,'       The main use of this program is the calculation of a climatological'
     PRINT *,'       average, for instance. It can also be used for the calculation of an'
     PRINT *,'       ensemble mean, although cdfenstat is more appropriate. '
     PRINT *,'       '
     PRINT *,'       The program assumes that all files in the list are of same type (shape,'
     PRINT *,'       variables, and number of time frames).'
     PRINT *,'       '
     PRINT *,'       For some variables, the program also computes the ''file average'' of the'
     PRINT *,'       squared variables, which is used in other cdftools (cdfeke, cdfrmsssh,'
     PRINT *,'       cdfstdevw, cdfstddevts...). The actual variables selected for squared'
     PRINT *,'       average are :'
     PRINT '(10x,"- ",a)' , (TRIM(cn_sqdvar(jv)), jv=1, nn_sqdvar)
     PRINT *,'       This selection can be adapted with the nam_cdf_namelist process.'
     PRINT *,'       (See cdfnamelist -i for details).'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -l LST-files: List of files whose average will be computed.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-spval0 ] : set missing_value attribute to 0 for all variables and'
     PRINT *,'              take care of the input missing_value. This option is usefull'
     PRINT *,'              if missing_values differ from files to files.'
     PRINT *,'       [-vvl] : Use time-varying vertical metrics.'
     PRINT *,'       [-o OUT-rootname] : Define output root-name instead of ', TRIM(cf_root)
     PRINT *,'       [-nc4 ]: Use netcdf4 output with chunking and deflation level 1..'
     PRINT *,'              This option is effective only if cdftools are compiled with'
     PRINT *,'              a netcdf library supporting chunking and deflation.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       none '
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_root),'.nc and ',TRIM(cf_root),'2.nc'
     PRINT *,'       Variables name are the same than in the input files. '
     PRINT *,'       For squared averages ''_sqd'' is appended to the original variable name.'
     STOP 
  ENDIF

  ijarg = 1 
  DO WHILE ( ijarg <= narg )
     CALL getarg (ijarg, cldum) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-l'      ) ; CALL GetFileList
        ! options
     CASE ( '-spval0' ) ; lspval0 = .TRUE.
     CASE ( '-o'      ) ; CALL getarg(ijarg, cf_root) ; ijarg=ijarg+1
     CASE ( '-nc4'    ) ; lnc4    = .TRUE.
     CASE ( '-vvl'    ) ; lg_vvl  = .TRUE. ; PRINT *, ' vvl not yet supported' ; STOP 99
     CASE DEFAULT       ; PRINT *,' ERROR : ', TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  END DO

  cf_out  = TRIM(cf_root)//'.nc'
  cf_out2 = TRIM(cf_root)//'2.nc'

  lchk = .FALSE.
  DO jfil=1,nfiles
     lchk = lchk .OR. chkfile (cf_lst(jfil) )
  ENDDO
  IF ( lchk ) STOP 99 ! missing file

  ! Initialisation from  1rst file (all file are assumed to have the same geometry)
  cf_in  = cf_lst(1)
  npiglo = getdim (cf_in,cn_x)
  npjglo = getdim (cf_in,cn_y)
  npt    = getdim (cf_in,cn_t)

  ! looking for npk among various possible name
  idep_max=8
  ALLOCATE ( clv_dep(idep_max) )
  clv_dep(:) = (/cn_z,'z','sigma','nav_lev','levels','ncatice','icbcla','icbsect'/)
  idep=1  ; ierr=1000
  DO WHILE ( ierr /= 0 .AND. idep <= idep_max )
     npk  = getdim (cf_in, clv_dep(idep), cdtrue=cv_dep, kstatus=ierr)
     idep = idep + 1
  ENDDO

  IF ( ierr /= 0 ) THEN  ! none of the dim name was found
     PRINT *,' assume file with no depth'
     npk=0
  ENDIF

  ! check that all files have the same number of time frames
  ierr = 0
  DO jfil = 1, nfiles
     IF (  chkfile (cf_lst(jfil)      ) ) STOP 99 ! missing file
     inpt = getdim (cf_lst(jfil), cn_t)
     IF ( inpt /= npt ) THEN
        PRINT *, 'File ',TRIM(cf_lst(jfil) ),' has ',inpt,' time frames instead of ', npt
        ierr = ierr + 1
     ENDIF
  ENDDO
  IF ( ierr /= 0 ) STOP 99 ! frame numbers mismatch

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  nvars = getnvar(cf_in)
  PRINT *,' nvars = ', nvars

  ALLOCATE( dtab(npiglo,npjglo), dtab2(npiglo,npjglo), v2d(npiglo,npjglo) )
  ALLOCATE( dtotal_time(npt), dtim(npt) )
  ALLOCATE (cv_nam(nvars), cv_nam2(nvars) )
  ALLOCATE (stypvar(nvars), stypvar2(nvars) )
  ALLOCATE (id_var(nvars), ipk(nvars), id_varout(nvars), id_varout2(nvars)  )

  CALL CreateOutput

  ! Compute the mean time for each mean frame
  dtotal_time(:) = 0.d0
  DO jfil = 1, nfiles 
     cf_in          = cf_lst(jfil)
     dtim(:)        = getvar1d(cf_in, cn_vtimec, npt)
     dtotal_time(:) = dtotal_time(:) + dtim (:)
  END DO
  dtim(:)= dtotal_time(:)/ nfiles
  ierr   = putvar1d(ncout,  dtim, npt, 'T')
  ierr   = putvar1d(ncout2, dtim, npt, 'T')

  DO jrec = 1, npt
     DO jvar = 1,nvars
        IF ( cv_nam(jvar) == cn_vlon2d .OR. &     ! nav_lon
             cv_nam(jvar) == cn_vlat2d ) THEN     ! nav_lat
           ! skip these variable
        ELSE
           PRINT *,' Working with ', TRIM(cv_nam(jvar)), ipk(jvar)
           DO jk = 1, ipk(jvar)
              PRINT *,'level ',jk
              dtab(:,:) = 0.d0 ; dtab2(:,:) = 0.d0 
              ntframe = 0
              DO jfil = 1, nfiles
                 cf_in     = cf_lst(jfil)
                 v2d(:,:)  = getvar(cf_in, cv_nam(jvar), jk, npiglo, npjglo, ktime=jrec )
                 IF ( lspval0 )  WHERE (v2d == zspval_in(jvar))  v2d = 0.  ! change missing values to 0
                 dtab(:,:) = dtab(:,:) + v2d(:,:)
                 IF (cv_nam2(jvar) /= 'none' ) dtab2(:,:) = dtab2(:,:) + v2d(:,:)*v2d(:,:)
              END DO

              ! store variable on outputfile
              ierr = putvar(ncout, id_varout(jvar), SNGL(dtab(:,:)/nfiles), jk, npiglo, npjglo, kwght=nfiles, ktime = jrec )
              IF (cv_nam2(jvar) /= 'none' )  THEN 
                 ierr = putvar(ncout2, id_varout2(jvar), SNGL(dtab2(:,:)/nfiles), jk, npiglo, npjglo, kwght=nfiles, ktime=jrec)
              ENDIF

           END DO  ! loop to next level
        END IF
     END DO ! loop to next var in file
  END DO ! loop to next record in input file

  ierr = closeout(ncout )
  ierr = closeout(ncout2)

CONTAINS 

  LOGICAL FUNCTION varchk2 ( cd_var ) 
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION varchk2  ***
    !!
    !! ** Purpose : Return true if cd_var is candidate for mean squared value  
    !!
    !! ** Method  : List of candidate is established in modcdfnames, and
    !!              can be changed via the nam_cdf_names namelist   
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*), INTENT(in) :: cd_var

    INTEGER(KIND=4)              :: jv
    !!----------------------------------------------------------------------
    varchk2 = .FALSE.
    DO jv = 1, nn_sqdvar 
       IF ( cd_var == cn_sqdvar(jv) ) THEN
          varchk2 = .TRUE.
          EXIT
       ENDIF
    ENDDO

  END FUNCTION varchk2

  SUBROUTINE GetFileList
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE GetFileList  ***
    !!
    !! ** Purpose :  Set up a file list given on the command line as 
    !!               blank separated list
    !!
    !! ** Method  :  Scan the command line until a '-' is found
    !!----------------------------------------------------------------------
    INTEGER (KIND=4)  :: ji
    INTEGER (KIND=4)  :: icur
    !!----------------------------------------------------------------------
    !!
    nfiles=0
    ! need to read a list of file ( number unknow ) 
    ! loop on argument till a '-' is found as first char
    icur=ijarg                          ! save current position of argument number
    DO ji = icur, narg                  ! scan arguments till - found
       CALL getarg ( ji, cldum )
       IF ( cldum(1:1) /= '-' ) THEN ; nfiles = nfiles+1
       ELSE                          ; EXIT
       ENDIF
    ENDDO
    ALLOCATE (cf_lst(nfiles) )
    DO ji = icur, icur + nfiles -1
       CALL getarg(ji, cf_lst( ji -icur +1 ) ) ; ijarg=ijarg+1
    END DO
  END SUBROUTINE GetFileList

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    ! get list of variable names and collect attributes in stypvar (optional)
    cv_nam(:) = getvarname(cf_in,nvars, stypvar)
    DO jvar = 1,nvars
       stypvar(jvar)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    ENDDO

    IF ( lspval0 ) THEN 
       ALLOCATE ( zspval_in(nvars) )
       zspval_in(:) = stypvar(:)%rmissing_value
       stypvar(:)%rmissing_value = 0.
    ENDIF

    DO jvar = 1, nvars
       ! variables that will not be computed or stored are named 'none'
       IF ( varchk2 ( cv_nam(jvar) ) ) THEN 
          cv_nam2(jvar)                    = TRIM(cv_nam(jvar))//'_sqd'
          stypvar2(jvar)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
          stypvar2(jvar)%cname             = TRIM(stypvar(jvar)%cname)//'_sqd'         ! name
          stypvar2(jvar)%cunits            = '('//TRIM(stypvar(jvar)%cunits)//')^2'    ! unit
          stypvar2(jvar)%rmissing_value    = stypvar(jvar)%rmissing_value              ! missing_value
          stypvar2(jvar)%valid_min         = 0.                                        ! valid_min = zero
          stypvar2(jvar)%valid_max         = stypvar(jvar)%valid_max**2                ! valid_max *valid_max
          stypvar2(jvar)%scale_factor      = 1.
          stypvar2(jvar)%add_offset        = 0.
          stypvar2(jvar)%savelog10         = 0.
          stypvar2(jvar)%clong_name        = TRIM(stypvar(jvar)%clong_name)//'_Squared'   ! 
          stypvar2(jvar)%cshort_name       = TRIM(stypvar(jvar)%cshort_name)//'_sqd'     !
          stypvar2(jvar)%conline_operation = TRIM(stypvar(jvar)%conline_operation) 
          stypvar2(jvar)%caxis             = TRIM(stypvar(jvar)%caxis) 
       ELSE
          cv_nam2(jvar) = 'none'
       END IF
    END DO

    id_var(:)  = (/(jv, jv=1,nvars)/)
    ! ipk gives the number of level or 0 if not a T[Z]YX  variable
    ipk(:)     = getipk (cf_in,nvars,cdep=cv_dep)
    WHERE( ipk == 0 ) cv_nam='none'
    stypvar( :)%cname = cv_nam
    stypvar2(:)%cname = cv_nam2

    ! create output file taking the sizes in cf_in
    ncout  = create      (cf_out,  cf_in,    npiglo, npjglo, npk, cdep=cv_dep, ld_nc4=lnc4 )
    ierr   = createvar   (ncout ,  stypvar,  nvars,  ipk,    id_varout       , ld_nc4=lnc4 )
    ierr   = putheadervar(ncout,   cf_in,    npiglo, npjglo, npk, cdep=cv_dep)

    ncout2 = create      (cf_out2, cf_in,    npiglo, npjglo, npk, cdep=cv_dep, ld_nc4=lnc4 )
    ierr   = createvar   (ncout2,  stypvar2, nvars,  ipk,    id_varout2      , ld_nc4=lnc4 )
    ierr   = putheadervar(ncout2,  cf_in,    npiglo, npjglo, npk, cdep=cv_dep)

  END SUBROUTINE CreateOutput

END PROGRAM cdfmoyt

MODULE modutils
  !!======================================================================
  !!                     ***  MODULE  modutils  ***
  !! Hold functions and subroutine dedicated to common utility task
  !!=====================================================================
  !! History : 3.0  : 04/2011  : J.M. Molines : Original code
  !!                : 10/2012  : N. Ferry, E. Durand, F. Hernandez : add shapiro
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  !!   routines      : description
  !!   SetGlobalAtt  : Set Global Attribute to the command line
  !!   SetFilename   : Build standard name from confname
  !!   shapiro_fill_smooth : shapiro smoother or filler
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2010, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  USE cdfio

  IMPLICIT NONE

  PRIVATE
  PUBLIC SetGlobalAtt
  PUBLIC SetFileName
  PUBLIC shapiro_fill_smooth

CONTAINS
  SUBROUTINE SetGlobalAtt(cdglobal, cd_append)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE SetGlobalAtt  ***
    !!
    !! ** Purpose : Append command line to the string given as argument.
    !!              This is basically used for setting a global attribute 
    !!              in the output files 
    !!
    !! ** Method  : Decrypt line command with getarg  
    !!
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*),           INTENT(inout) :: cdglobal
    CHARACTER(LEN=1), OPTIONAL, INTENT(in   ) :: cd_append

    INTEGER(KIND=4)    :: iargc, inarg
    INTEGER(KIND=4)    :: jarg
    CHARACTER(LEN=100) :: cl_arg
    CHARACTER(LEN=1  ) :: cl_app
    !!----------------------------------------------------------------------
    cl_app = 'N'
    IF ( PRESENT( cd_append ) ) THEN 
       cl_app = 'A'
    ENDIF

    CALL getarg(0, cl_arg)
    SELECT CASE ( cl_app)
    CASE ('A') 
       cdglobal = TRIM(cdglobal)//' ; '//TRIM(cl_arg) 
    CASE ('N') 
       cdglobal = TRIM(cl_arg) 
    END SELECT

    inarg = iargc()
    DO jarg=1, inarg
       CALL getarg(jarg,cl_arg) 
       cdglobal = TRIM(cdglobal)//' '//TRIM(cl_arg) 
    END DO

  END SUBROUTINE SetGlobalAtt

  CHARACTER(LEN=256) FUNCTION SetFileName(cdconf, cdtag, cdgrid ,ld_stop )
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION SetFileName  ***
    !!
    !! ** Purpose :  Build filename from cdconf, tag and grid
    !!
    !! ** Method  :  Check 2 forms of file names and return
    !!               error is file is missing
    !!
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*),  INTENT(in) :: cdconf, cdtag, cdgrid
    LOGICAL, OPTIONAL, INTENT(in) :: ld_stop

    LOGICAL :: ll_stop
    !!----------------------------------------------------------------------
    IF ( PRESENT(ld_stop) ) THEN
       ll_stop = ld_stop
    ELSE
       ll_stop = .TRUE.
    ENDIF

    WRITE( SetFileName,'(a,"_",a,"_grid",a,".nc")') TRIM(cdconf), TRIM(cdtag), TRIM(cdgrid)
    IF ( chkfile(SetFileName ,ld_verbose=.FALSE.) ) THEN ! look for another name
       WRITE(SetFileName,'(a,"_",a,"_grid_",a,".nc")') TRIM(cdconf), TRIM(cdtag), TRIM(cdgrid)
       IF ( chkfile( SetFileName, ld_verbose=.FALSE.) .AND. ll_stop  ) THEN
          PRINT *,' ERROR : missing grid',TRIM(cdgrid),'or even grid_',TRIM(cdgrid),' file '
          STOP
       ENDIF
    ENDIF
  END FUNCTION SetFileName

  SUBROUTINE shapiro_fill_smooth ( psig, kpi, kpj, kpass, cdfs, pbad, klmasktrue, psigf )
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE shapiro_fill_smooth  ***
    !!
    !! ** Purpose : Shapiro smoother or filler
    !!
    !! ** Method  : Shapiro algorithm 
    !!           psig    : variable to be filtered 2D
    !!           kpi,kpj : dimension of psig
    !!           kpass   : number of passes of the filter
    !!           cdfs    : 'smooth' or 'fill' according to choice
    !!           pbad    : psig Fill_Value
    !!           klmasktrue : mask flag for continent.
    !!                If land extrapolation is desired, set klmasktrue=1 everywhere
    !!
    !!           psigf   : filtered/filled variable (output)
    !!
    !!  code history:
    !!      original  : 05-11 (N. Ferry)
    !!      additions : 05-12 (E. Durand)
    !!      correction: 07-12 (F. Hernandez)
    !!      cdftools norm : 11-12 (J.M. Molines)
    !!----------------------------------------------------------------------
    INTEGER(KIND=4),                     INTENT(in ) :: kpi, kpj, kpass
    INTEGER(KIND=4), DIMENSION(kpi,kpj), INTENT(in ) :: klmasktrue

    REAL(KIND=4),                        INTENT(in ) :: pbad
    REAL(KIND=4), DIMENSION(kpi,kpj),    INTENT(in ) :: psig
    REAL(KIND=4), DIMENSION(kpi,kpj),    INTENT(out) :: psigf

    CHARACTER(LEN=6),                    INTENT(in ) :: cdfs

    INTEGER(KIND=4)                               :: ji, jj, jp    ! dummy loop index
    INTEGER(KIND=4), DIMENSION(0:kpi+1,kpj)       :: ilmask_e     ! extra i-point for E-W periodicity
    INTEGER(KIND=4), DIMENSION(0:kpi+1,kpj)       :: ilmask0_e    ! extra i-point for E-W periodicity
    INTEGER(KIND=4), DIMENSION(0:kpi+1,kpj)       :: ilmasktrue_e ! extra i-point for E-W periodicity

    REAL(KIND=4), DIMENSION(0:kpi+1,kpj)          :: zsigf_e      ! extra i-point for E-W periodicity
    REAL(KIND=4), DIMENSION(0:kpi+1,kpj)          :: zsig_e       ! extra i-point for E-W periodicity
    REAL(KIND=4)                                  :: znum, zden, zsum

    !!----------------------------------------------------------------------
    ! ... Initialization : 
    zsig_e      (1:kpi,:) = psig      (:,:)
    ilmasktrue_e(1:kpi,:) = klmasktrue(:,:)
    !  E-W periodic
    zsig_e      (0,:)     = zsig_e      (kpi,:)      
    ilmasktrue_e(0,:)     = ilmasktrue_e(kpi,:)      
    zsig_e      (kpi+1,:) = zsig_e      (1,:)      
    ilmasktrue_e(kpi+1,:) = ilmasktrue_e(1,:)      

    ! check cdfs compliance
    IF ( cdfs(1:4)  .NE. 'fill' .AND. cdfs(1:6) .NE. 'smooth' ) THEN
       PRINT*, 'cdfs = ',cdfs ,' <> fill or smooth'
       STOP
    ENDIF
    !
    ! ... Shapiro filter : 
    !
    DO jp = 1, kpass          ! number of passes for the filter
       !
       ! in both cases 'smooth' and ' fill' we check points w/o values
       ilmask_e(:,:) = 0 ; ilmask0_e(:,:) = 0
       WHERE ( zsig_e(:,:) /= pbad )
          !   set ilmask_e = 1 when field is already filled
          ilmask_e (:,:) = 1 
          ilmask0_e(:,:) = 1 
       ENDWHERE

       ! case 'fill'
       IF ( cdfs(1:4) == 'fill' ) THEN
          ilmask0_e(:,:) = 0
          DO ji=1,kpi
             DO jj=2,kpj-1
                zsum = ilmask_e(ji+1,jj) + ilmask_e(ji-1,jj) + ilmask_e(ji,jj+1) + ilmask_e(ji,jj-1)
                ! set ilmask0_e = 1 if it is possible to do a 4-point interpolation (N-S-E-W)
                ! not on  land
                IF ( ( zsum                >= 1 ) .AND. &
                     ( ilmask_e    (ji,jj) == 0 ) .AND. &
                     ( ilmasktrue_e(ji,jj) == 1 ) )  THEN
                          ilmask0_e(ji,jj) = 1
                ENDIF
             ENDDO
             ! for the northernmost line
             zsum = ilmask_e(ji+1,kpj) + ilmask_e(ji-1,kpj) + ilmask_e(ji,kpj-1)
             IF ( ( zsum                 >= 1 ) .AND. &
                  ( ilmask_e    (ji,kpj) == 0 ) .AND. &
                  ( ilmasktrue_e(ji,kpj) == 1 ) )  THEN 
                       ilmask0_e(ji,kpj) = 1
             ENDIF
          ENDDO
       ENDIF
       !
       ! loop on data points for both cases
       DO ji = 1, kpi
          DO jj = 2, kpj-1
             IF ( ilmask0_e(ji,jj) == 1. )  THEN
                znum =  zsig_e(ji-1,jj  )*ilmask_e(ji-1,jj  ) &
                      + zsig_e(ji+1,jj  )*ilmask_e(ji+1,jj  ) &
                      + zsig_e(ji  ,jj-1)*ilmask_e(ji  ,jj-1) &
                      + zsig_e(ji  ,jj+1)*ilmask_e(ji  ,jj+1)  
                zden =  ilmask_e(ji-1,jj  ) &
                      + ilmask_e(ji+1,jj  ) &
                      + ilmask_e(ji  ,jj-1) &
                      + ilmask_e(ji  ,jj+1) 
                zsigf_e(ji,jj) = znum/zden
             ELSE
                zsigf_e(ji,jj) = zsig_e(ji,jj)
             ENDIF
          ENDDO
          ! for the northernmost line, we do not take kpj+1 into account
          IF ( ilmask0_e(ji,kpj) == 1. )  THEN
             znum =  zsig_e(ji-1,kpj  )*ilmask_e(ji-1,kpj  ) &
                   + zsig_e(ji+1,kpj  )*ilmask_e(ji+1,kpj  ) &
                   + zsig_e(ji  ,kpj-1)*ilmask_e(ji  ,kpj-1) 
             zden =  ilmask_e(ji-1,kpj  ) &
                   + ilmask_e(ji+1,kpj  ) &
                   + ilmask_e(ji  ,kpj-1) 
             zsigf_e(ji,kpj) = znum/zden
          ELSE
             zsigf_e(ji,kpj) = zsig_e(ji,kpj)
          ENDIF
       ENDDO
       !
       !    fill or smooth ?
       !
       IF ( cdfs(1:6) == 'smooth' ) THEN
          WHERE ( ilmasktrue_e(:,:) == 1 )
             zsig_e(:,:) = zsigf_e(:,:)
          END WHERE
       ENDIF
       !
       IF ( cdfs(1:4) == 'fill' ) THEN
          WHERE ( ilmask0_e(:,:) == 1 )
             zsig_e(:,:) = zsigf_e(:,:)
          END WHERE
       ENDIF
       ! Boundary condition  : E-W  (simplifie)
       zsig_e(0,:) = zsig_e(kpi,:)
       zsig_e(kpi+1,:) = zsig_e(1,:)

       !
    ENDDO                     ! jp

    psigf(:,:) = zsig_e(1:kpi,:)

  END SUBROUTINE shapiro_fill_smooth

END MODULE modutils

PROGRAM cdfuv
  !!======================================================================
  !!                     ***  PROGRAM  cdfuv  ***
  !!=====================================================================
  !!  ** Purpose : Compute the average values for the products 
  !!               u.v at T-point
  !!
  !!  ** Method  : pass the CONFIG name and a series of tags as arguments.
  !!
  !! History : 2.1  : 11/2004  : J.M. Molines : Original code
  !!           2.1  : 02/2010  : J.M. Molines : handle multiframes input files.
  !!           3.0  : 04/2011  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!
  !! * Reference for mean and variance computing:
  !! Higham N. (2002) :"Accuracy and Stability of Numerical Algorithms." 
  !!         Second edition, Siam editor, 710pp. (see chapter 1.9 )
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  USE modutils       ! SetFileName function
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class second_order_moments
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: ji, jj, jk, jt, jtt  ! dummy loop index
  INTEGER(KIND=4)                           :: ierr                 ! working integer
  INTEGER(KIND=4)                           :: narg, iargc, ijarg   ! command line
  INTEGER(KIND=4)                           :: npiglo,npjglo        ! size of the domain
  INTEGER(KIND=4)                           :: npk, npt, npkf       ! size of the domain
  INTEGER(KIND=4)                           :: ntframe              ! Cumul of time frame
  INTEGER(KIND=4)                           :: ntags                ! number of tags to process
  INTEGER(KIND=4)                           :: ncout                ! ncid of output file
  INTEGER(KIND=4), DIMENSION(4)             :: ipk, id_varout       ! level and varid's of output vars

  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zu, zv               ! Velocity component
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zworku, zworkv       ! working arrays
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zmean                ! temporary mean value for netcdf write
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zlon                 ! longitude of T points to check periodicity

  REAL(KIND=8), DIMENSION(1)                :: dtimean              ! mean time
  REAL(KIND=8), DIMENSION(:),   ALLOCATABLE :: dtim                 ! time counter of individual files
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dcumuluv             ! Arrays for cumulated values
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dcumulu              ! Arrays for cumulated values
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dcumulv              ! Arrays for cumulated values
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dupvp                ! Arrays for U'.V'
  REAL(KIND=8)                              :: dtotal_time          ! cumulated time

  CHARACTER(LEN=256)                        :: cf_tfil              ! Temperature file for reference only
  CHARACTER(LEN=256)                        :: cf_ufil              ! zonal velocity file
  CHARACTER(LEN=256)                        :: cf_vfil              ! meridional velocity file
  CHARACTER(LEN=256)                        :: cf_out='uv.nc'       ! output file
  CHARACTER(LEN=256)                        :: config               ! configuration name
  CHARACTER(LEN=256)                        :: ctag                 ! current tag to work with               
  CHARACTER(LEN=256)                        :: cl_name              ! temporary variable name
  CHARACTER(LEN=256)                        :: cldum                ! working char variable
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: ctag_lst         ! tag list

  TYPE (variable), DIMENSION(4)             :: stypvar              ! structure for attributes

  LOGICAL                                   :: lcaltmean            ! flag for mean time computation
  LOGICAL                                   :: lperio = .FALSE.     ! flag for E-W periodicity
  LOGICAL                                   :: lnc4   = .FALSE.     ! Use nc4 with chunking and deflation
  LOGICAL                                   :: lopt   = .FALSE.     ! optimized algorithm flag
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  !!  Read command line
  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfuv -c CONFIG-CASE -l LST-tags [-opt] [-o OUT-file] [-nc4]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the time average values for U.V product, at T point.' 
     PRINT *,'       Mean U, mean V  and mean U''.V''  at T point are also computed.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -c CONFIG-CASE is the config name of a given experiment (eg ORCA025-G70)'
     PRINT *,'            The program will look for gridU and gridV files for this config'
     PRINT *,'            grid_U and grid_V are also accepted).'
     PRINT *,'       -l LST-tags : a list of time tags that will be used for time averaging.'
     PRINT *,'            e.g. :  y2000m01d05 y2000m01d10 ...'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-opt :] use optimized algorithm, minimizing truncation errors in the'
     PRINT *,'             evaluation of mean U, meanV and mean (U''.V'').'
     PRINT *,'       [-o OUT-file] : specify output filename instead of ',TRIM(cf_out)
     PRINT *,'       [-nc4 ] :  Use netcdf4 output with chunking and deflation level 1.'
     PRINT *,'             This option is effective only if cdftools are compiled with'
     PRINT *,'             a netcdf library supporting chunking and deflation.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        none'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'       variables : ',TRIM(cn_vouv), '  : Mean U.V at T point'
     PRINT *,'                   ',TRIM(cn_vozocrtx)//'_t : Mean U at T point'
     PRINT *,'                   ',TRIM(cn_vomecrty)//'_t : Mean V at T point'
     PRINT *,'                   ',TRIM(cn_vouv)//'_prime : Mean U''.V'' at T point'
     PRINT *,'      '
     STOP 
  ENDIF

  ijarg=1
  DO WHILE (ijarg <= narg) 
     CALL getarg(ijarg, cldum) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-c'  ) ; CALL getarg(ijarg, config) ; ijarg=ijarg+1
     CASE ( '-l'  ) ; CALL GetTagList
        ! options
     CASE ( '-opt') ; lopt = .TRUE.
     CASE ( '-o'  ) ; CALL getarg(ijarg, cf_out) ; ijarg=ijarg+1
     CASE ( '-nc4') ; lnc4 = .TRUE.
     CASE DEFAULT   ; PRINT *,' ERROR : ', TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  ENDDO

  cf_tfil = SetFileName( config, ctag_lst(1), 'T')
  cf_ufil = SetFileName( config, ctag_lst(1), 'U')

  npiglo = getdim (cf_ufil,cn_x)
  npjglo = getdim (cf_ufil,cn_y)
  npkf   = getdim (cf_ufil,cn_z)

  IF ( npkf == 0 ) THEN ; npk = 1
  ELSE                  ; npk=npkf
  ENDIF

  PRINT *, 'npiglo =', npiglo
  PRINT *, 'npjglo =', npjglo
  PRINT *, 'npk    =', npk

  ALLOCATE( dcumuluv(npiglo,npjglo) )
  ALLOCATE( dcumulu(npiglo,npjglo) )
  ALLOCATE( dcumulv(npiglo,npjglo) )
  ALLOCATE( dupvp(npiglo,npjglo) )
  ALLOCATE( zu(npiglo,npjglo),     zv(npiglo,npjglo) )
  ALLOCATE( zworku(npiglo,npjglo), zworkv(npiglo,npjglo) )
  ALLOCATE( zmean(npiglo,npjglo))
  ALLOCATE( zlon(npiglo,npjglo))

  ! check for E_W periodicity
  zlon(:,:) = getvar(cf_tfil, cn_vlon2d, 1, npiglo, npjglo )
  IF ( zlon(1,1) ==  zlon(npiglo-1,1) ) THEN
     lperio = .TRUE.
     PRINT *,' E-W periodicity detected '
  ENDIF

  CALL CreateOutput

  lcaltmean=.TRUE.
  DO jk = 1, npk
     PRINT *,'level ',jk
     dcumuluv(:,:) = 0.d0 ;  dtotal_time  = 0.d0 ; ntframe = 0
     dcumulu(:,:)  = 0.d0 ;  dcumulv(:,:) = 0.d0

     DO jt = 1, ntags           ! loop on tags
        ctag=ctag_lst(jt)

        cf_ufil = SetFileName( config, ctag, 'U', ld_stop=.TRUE. )
        npt = getdim (cf_ufil, cn_t)
        IF ( lcaltmean ) THEN
           ALLOCATE ( dtim(npt) )
           dtim        = getvar1d(cf_ufil, cn_vtimec, npt)
           dtotal_time = dtotal_time + SUM(dtim(1:npt) )
           DEALLOCATE( dtim )
        END IF

        ! assume U and V file have same time span ...
        cf_ufil = SetFileName( config, ctag, 'U' )
        cf_vfil = SetFileName( config, ctag, 'V' )

        DO jtt = 1, npt  ! loop on time frame in a single file
           ntframe = ntframe+1
           zu(:,:)    = getvar(cf_ufil, cn_vozocrtx, jk, npiglo, npjglo, ktime=jtt )
           zv(:,:)    = getvar(cf_vfil, cn_vomecrty, jk, npiglo, npjglo, ktime=jtt )

           ! U and V velocities at T point
           zworku(:,:) = 0. ; zworkv(:,:) = 0.
           DO ji=2, npiglo
              DO jj = 1, npjglo
                 zworku(ji,jj) = 0.5 * ( zu(ji,jj) + zu(ji-1,jj) )  ! U at T point
              END DO
           END DO

           DO ji=1, npiglo
              DO jj = 2, npjglo 
                 zworkv(ji,jj) = 0.5 * ( zv(ji,jj) + zv(ji,jj-1) )  ! V at T point
              END DO
           END DO
           IF ( lopt ) THEN
              IF ( ntframe == 1 ) THEN  ! initialize recurence formula
                dcumulu(:,:) = zworku(:,:)
                dcumulv(:,:) = zworkv(:,:)
                dupvp(:,:)   = 0.d0
                dcumuluv(:,:) =zworku(:,:) * zworkv(:,:)*1.d0
              ELSE
                dupvp(:,:)= dupvp(:,:) + (1.*(ntframe -1))/ntframe*(zworku(:,:) - dcumulu(:,:))*(zworkv(:,:) - dcumulv(:,:))
                dcumulu(:,:) = dcumulu(:,:)  +  1./ntframe*(zworku(:,:)            *1.d0 - dcumulu(:,:))
                dcumulv(:,:) = dcumulv(:,:)  +  1./ntframe*(zworkv(:,:)            *1.d0 - dcumulv(:,:))
                dcumuluv(:,:) = dcumuluv(:,:)+  1./ntframe*(zworku(:,:)*zworkv(:,:)*1.d0 - dcumuluv(:,:))
              ENDIF
           ELSE
             dcumuluv(:,:) = dcumuluv(:,:) + zworku(:,:) * zworkv(:,:)*1.d0
             dcumulu(:,:)  = dcumulu(:,:)  + zworku(:,:)*1.d0
             dcumulv(:,:)  = dcumulv(:,:)  + zworkv(:,:)*1.d0
           ENDIF

        END DO  !jtt
     END DO  ! jt
     ! finish with level jk ; compute mean (assume spval is 0 ) 
     !  < > is temporal mean here
     ! < U.V> 
     IF ( lopt) THEN ; zmean(:,:) = dcumuluv(:,:)
     ELSE            ; zmean(:,:) = dcumuluv(:,:)/ntframe
     ENDIF
     IF ( lperio ) zmean(1, :) = zmean(npiglo-1,:)
     ierr = putvar(ncout, id_varout(1), zmean, jk,npiglo, npjglo, kwght=ntframe )

     ! < U >
     IF ( lopt ) THEN ; zmean(:,:) = dcumulu(:,:)
     ELSE             ; zmean(:,:) = dcumulu(:,:)/ntframe
     ENDIF
     IF ( lperio ) zmean(1, :) = zmean(npiglo-1,:)
     ierr = putvar(ncout, id_varout(2), zmean, jk,npiglo, npjglo, kwght=ntframe )

     ! < V >
     IF ( lopt ) THEN ; zmean(:,:) = dcumulv(:,:)
     ELSE             ; zmean(:,:) = dcumulv(:,:)/ntframe
     ENDIF
     IF ( lperio ) zmean(1, :) = zmean(npiglo-1,:)
     ierr = putvar(ncout, id_varout(3), zmean, jk,npiglo, npjglo, kwght=ntframe )

     ! < U'.V' >
     IF ( lopt ) THEN ; dupvp(:,:)= 1./(ntframe -1 ) * dupvp(:,:) ! use unbiased estimate 
     ELSE             ; dupvp(:,:) = dcumuluv(:,:)/ntframe - dcumulu(:,:)*dcumulv(:,:)/ntframe/ntframe
     ENDIF
     zmean(:,:) = dupvp(:,:)
     IF ( lperio ) zmean(1, :) = zmean(npiglo-1,:)
     ierr = putvar(ncout, id_varout(4), zmean, jk,npiglo, npjglo, kwght=ntframe )

     IF (lcaltmean )  THEN
        dtimean(1) = dtotal_time/ntframe
        ierr       = putvar1d(ncout, dtimean, 1, 'T')
     END IF
     lcaltmean=.FALSE. ! tmean already computed

  END DO  ! loop to next level

  ierr = closeout(ncout)

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    ipk(:)= npk  ! all variables (input and output are 3D)
    ! define output variables
    stypvar%rmissing_value    = 0.
    stypvar%valid_min         = -100.
    stypvar%valid_max         = 100.
    stypvar%conline_operation = 'N/A'
    stypvar%caxis             = 'TZYX'

    stypvar(1)%ichunk         = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(1)%cname          = cn_vouv                  ; stypvar(1)%cunits        = 'm2/s2'
    stypvar(1)%clong_name     = 'U.V product at T point' ; stypvar(1)%cshort_name   = cn_vouv

    cl_name = TRIM(cn_vozocrtx)//'_t'
    stypvar(2)%ichunk         = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(2)%cname          = cl_name                  ; stypvar(2)%cunits        = 'm/s'
    stypvar(2)%clong_name     = 'Mean U at T point '     ; stypvar(2)%cshort_name   = cl_name

    cl_name = TRIM(cn_vomecrty)//'_t'
    stypvar(3)%ichunk         = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(3)%cname          = cl_name                  ; stypvar(3)%cunits        = 'm/s'
    stypvar(3)%clong_name     = 'Mean V at T point '     ; stypvar(3)%cshort_name   = cl_name

    cl_name = TRIM(cn_vouv)//'_prime'
    stypvar(4)%ichunk         = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(4)%cname          = cl_name                     ; stypvar(3)%cunits        = 'm2/s2'
    stypvar(4)%clong_name     = 'Uprime .Vprime at T point' ; stypvar(3)%cshort_name   = cl_name

    ! create output fileset
    ncout = create      (cf_out, cf_tfil, npiglo, npjglo, npkf, ld_xycoo=.TRUE., ld_nc4=lnc4 )
    ierr  = createvar   (ncout , stypvar, 4,      ipk,    id_varout           , ld_nc4=lnc4 )
    ierr  = putheadervar(ncout,  cf_tfil, npiglo, npjglo, npkf, ld_xycoo=.TRUE. )

  END SUBROUTINE CreateOutput

  SUBROUTINE GetTagList
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE GetTagList  ***
    !!
    !! ** Purpose :  Set up a tag list given on the command line as 
    !!               blank separated list
    !!
    !! ** Method  :  Scan the command line until a '-' is found
    !!----------------------------------------------------------------------
    INTEGER (KIND=4)  :: ji
    INTEGER (KIND=4)  :: icur
    !!----------------------------------------------------------------------
    !!
    ntags=0
    ! need to read a list of file ( number unknow ) 
    ! loop on argument till a '-' is found as first char
    icur=ijarg                          ! save current position of argument number
    DO ji = icur, narg                  ! scan arguments till - found
       CALL getarg ( ji, cldum )
       IF ( cldum(1:1) /= '-' ) THEN ; ntags = ntags+1
       ELSE                          ; EXIT
       ENDIF
    ENDDO
    PRINT *,' NTAGS', ntags
    ALLOCATE (ctag_lst(ntags) )
    DO ji = icur, icur + ntags -1
       CALL getarg(ji, ctag_lst( ji -icur +1 ) ) ; ijarg=ijarg+1
    END DO
  END SUBROUTINE GetTagList

END PROGRAM cdfuv

PROGRAM cdfconvert
  !!======================================================================
  !!                     ***  PROGRAM  cdfconvert  ***
  !!=====================================================================
  !!  ** Purpose : Convert a set of dimgfile (Clipper like)
  !!               to a set of CDF files (Drakkar like )
  !!
  !!  ** Method  : Read tag then open the respective T S 2D U V files to create
  !!              gridT, gridU and gridV files.
  !!              Requires  mesh_hgr.nc and mesh_zgr.nc  files
  !!
  !! History : 2.1  : 01/2007  : J.M. Molines : Original code
  !!           3.0  : 05/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  !!   routines      : description
  !!  isdirect       : integer function which return the record length
  !!                   of the file in argument if a dimgfile, 0 else.
  !!                  
  !!----------------------------------------------------------------------
  USE cdfio 
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                            :: ji, jj, jk      ! dummy loop index
  INTEGER(KIND=4)                            :: jt, jvar        ! dummy loop index
  INTEGER(KIND=4)                            :: narg, iargc     ! command line
  INTEGER(KIND=4)                            :: nvar            ! number of output variables
  INTEGER(KIND=4)                            :: npiglo, npjglo  ! size of the domain
  INTEGER(KIND=4)                            :: npk, npt        ! size of the domain
  INTEGER(KIND=4)                            :: irecl, ii, ndim ! dimg stuff variables
  INTEGER(KIND=4)                            :: numu=10         ! logical id for input dimg file
  INTEGER(KIND=4)                            :: numv=11         !      "             "
  INTEGER(KIND=4)                            :: numt=12         !      "             "
  INTEGER(KIND=4)                            :: nums=14         !      "             "
  INTEGER(KIND=4)                            :: num2d=15        !      "             "
  INTEGER(KIND=4)                            :: numssh=16       !      "             "
  INTEGER(KIND=4)                            :: numuu=17        !      "             "
  INTEGER(KIND=4)                            :: numvv=18        !      "             "
  INTEGER(KIND=4)                            :: ncout           ! ncid of output netcdf file
  INTEGER(KIND=4)                            :: ierr            ! error status
  INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE :: ipk, id_varout  ! outpur variables levels and id's

  REAL(KIND=4)                               :: x1, y1          ! dimg header ( SW corner)
  REAL(KIND=4)                               :: dx, dy          ! dimg header ( x,y step)
  REAL(KIND=4)                               :: zspval          ! dimg header ( special value)
  REAL(KIND=4), DIMENSION(:,:),  ALLOCATABLE :: v2d, glam, gphi ! working arrays
  REAL(KIND=4), DIMENSION(:),    ALLOCATABLE :: zdep            ! depth
  REAL(KIND=4), DIMENSION(:),    ALLOCATABLE :: tim             ! time counter

  CHARACTER(LEN=256)                         :: cf_ufil         ! output gridU file
  CHARACTER(LEN=256)                         :: cf_vfil         ! output gridV file
  CHARACTER(LEN=256)                         :: cf_tfil         ! output gridT file
  CHARACTER(LEN=256)                         :: cf_bsfil        ! output BSF file
  CHARACTER(LEN=256)                         :: cf_dimgu        ! input dimg U file
  CHARACTER(LEN=256)                         :: cf_dimgv        ! input dimg V file
  CHARACTER(LEN=256)                         :: cf_dimgt        ! input dimg T file
  CHARACTER(LEN=256)                         :: cf_dimgs        ! input dimg S file
  CHARACTER(LEN=256)                         :: cf_dimg2d       ! input dimg 2D file
  CHARACTER(LEN=256)                         :: cf_dimguu       ! input dimg U2 file
  CHARACTER(LEN=256)                         :: cf_dimgvv       ! input dimg V2 file
  CHARACTER(LEN=256)                         :: cf_dimgssh      ! input dimg SSH file
  CHARACTER(LEN=256)                         :: ctag            ! time tag
  CHARACTER(LEN=256)                         :: confcase        ! config-case
  CHARACTER(LEN=80 )                         :: cheader         ! comment in header of dimg file
  CHARACTER(LEN=4  )                         :: cver            ! dimg version

  TYPE(variable), DIMENSION(:),  ALLOCATABLE :: stypvar         ! output data structure

  LOGICAL                                    :: lexist          ! flag for existing file
  LOGICAL                                    :: lchk = .FALSE.  ! flag for missing files
  !!----------------------------------------------------------------------

  !!  Read command line
  narg= iargc()
  IF ( narg /= 2 ) THEN
     PRINT *,' usage : cdfconvert CLIPPER_tag CLIPPER_Confcase'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Convert dimg files (CLIPPER like) to netcdf (DRAKKAR like).'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       CLIPPER_tag      : a string such as y2000m01d15 for time identification.' 
     PRINT *,'       CLIPPER_confcase : CONFIG-CASE of the files to be converted (eg ATL6-V6)'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        ',TRIM(cn_fhgr),' and ', TRIM(cn_fzgr)
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : gridT, gridU, gridV files'
     PRINT *,'         variables : same as in standard NEMO output'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'       cdfflxconv, cdfsstconv, cdfstrconv'
     PRINT *,'      '
     STOP
  ENDIF
  !!
  CALL getarg (1, ctag)
  CALL getarg (2, confcase)

  lchk = lchk .OR. chkfile( cn_fhgr )
  lchk = lchk .OR. chkfile (cn_fzgr )

  !! Build dimg file names
  cf_dimgu   = TRIM(confcase)//'_U_'  //TRIM(ctag)//'.dimg' ; lchk = lchk .OR. chkfile(cf_dimgu )
  cf_dimgv   = TRIM(confcase)//'_V_'  //TRIM(ctag)//'.dimg' ; lchk = lchk .OR. chkfile(cf_dimgv )
  cf_dimgt   = TRIM(confcase)//'_T_'  //TRIM(ctag)//'.dimg' ; lchk = lchk .OR. chkfile(cf_dimgt )
  cf_dimgs   = TRIM(confcase)//'_S_'  //TRIM(ctag)//'.dimg' ; lchk = lchk .OR. chkfile(cf_dimgs )
  cf_dimg2d  = TRIM(confcase)//'_2D_' //TRIM(ctag)//'.dimg' ; lchk = lchk .OR. chkfile(cf_dimg2d)
  IF ( lchk ) STOP 99 ! missing file

  cf_dimgssh = TRIM(confcase)//'_SSH_'//TRIM(ctag)//'.dimg'
  cf_dimguu  = TRIM(confcase)//'_UU_' //TRIM(ctag)//'.dimg'
  cf_dimgvv  = TRIM(confcase)//'_VV_' //TRIM(ctag)//'.dimg'

  cf_ufil    = TRIM(confcase)//'_'    //TRIM(ctag)//'_gridU.nc'
  cf_vfil    = TRIM(confcase)//'_'    //TRIM(ctag)//'_gridV.nc'
  cf_tfil    = TRIM(confcase)//'_'    //TRIM(ctag)//'_gridT.nc'
  cf_bsfil   = TRIM(confcase)//'_'    //TRIM(ctag)//'_PSI.nc'

  ! open (and check ?? if they exists )
  irecl=isdirect(cf_dimgu ) ; OPEN( numu,  FILE=cf_dimgu,  FORM='UNFORMATTED', ACCESS='DIRECT', RECL=irecl )
  irecl=isdirect(cf_dimgv ) ; OPEN( numv,  FILE=cf_dimgv,  FORM='UNFORMATTED', ACCESS='DIRECT', RECL=irecl )
  irecl=isdirect(cf_dimgt ) ; OPEN( numt,  FILE=cf_dimgt,  FORM='UNFORMATTED', ACCESS='DIRECT', RECL=irecl )
  irecl=isdirect(cf_dimgs ) ; OPEN( nums,  FILE=cf_dimgs,  FORM='UNFORMATTED', ACCESS='DIRECT', RECL=irecl )
  irecl=isdirect(cf_dimg2d) ; OPEN( num2d, FILE=cf_dimg2d, FORM='UNFORMATTED', ACCESS='DIRECT', RECL=irecl )
  
  READ(numt,REC=1) cver, cheader, ii, npiglo, npjglo, npk, npt

  ALLOCATE (v2d(npiglo, npjglo), glam(npiglo,npjglo), gphi(npiglo,npjglo), zdep(npk), tim(npt) )

  READ(numt,REC=1) cver, cheader, ii, npiglo, npjglo, npk, npt, ndim, &
                   &      x1,y1,dx,dy,zspval, &
                   &    ( zdep(jk),jk=1,npk), &
                        ( tim(jt), jt=1,npt)

  ! transform Clipper days to drakkar seconds ...
  tim(:)=tim(:)*86400.

  !###############
  !# GRID T FILE #
  !###############
  ! Build gridT file with votemper, vosaline, sossheig, ... fluxes ...
  INQUIRE(FILE=cf_dimgssh, EXIST=lexist)
  IF ( lexist ) THEN
    irecl = isdirect(cf_dimgssh) 
    OPEN( numssh,FILE=cf_dimgssh, FORM='UNFORMATTED', ACCESS='DIRECT', RECL=irecl )
    nvar = 10 
  ELSE
    nvar = 9
  ENDIF

  ALLOCATE ( stypvar(nvar), ipk(nvar), id_varout(nvar) )
  jvar=1 
  ipk(jvar)                       = npk       
  stypvar(jvar)%cname             = cn_votemper
  stypvar(jvar)%cunits            = 'C'      
  stypvar(jvar)%rmissing_value    = 0.      
  stypvar(jvar)%valid_min         = -2.    
  stypvar(jvar)%valid_max         = 40.   
  stypvar(jvar)%clong_name        = 'Potential Temperature'
  stypvar(jvar)%cshort_name       = cn_votemper
  stypvar(jvar)%conline_operation = 'N/A'                
  stypvar(jvar)%caxis             = 'TZYX'              
  jvar=jvar+1

  ipk(jvar)                       = npk
  stypvar(jvar)%cname             = cn_vosaline
  stypvar(jvar)%cunits            = 'PSU'
  stypvar(jvar)%rmissing_value    = 0.
  stypvar(jvar)%valid_min         = 0.
  stypvar(jvar)%valid_max         = 45.
  stypvar(jvar)%clong_name        = 'Salinity'
  stypvar(jvar)%cshort_name       = cn_vosaline
  stypvar(jvar)%conline_operation = 'N/A'
  stypvar(jvar)%caxis             = 'TZYX'
  jvar=jvar+1

  IF ( lexist ) THEN
  ipk(jvar)                       = 1
  stypvar(jvar)%cname             = cn_sossheig
  stypvar(jvar)%cunits            = 'm'
  stypvar(jvar)%rmissing_value    = 0.
  stypvar(jvar)%valid_min         = -10.
  stypvar(jvar)%valid_max         = 10.
  stypvar(jvar)%clong_name        = 'Sea_Surface_height'
  stypvar(jvar)%cshort_name       = cn_sossheig
  stypvar(jvar)%conline_operation = 'N/A'
  stypvar(jvar)%caxis             = 'TYX'
  jvar=jvar+1
  ENDIF

  ipk(jvar)                       = 1
  stypvar(jvar)%cname             = cn_somxl010         ! rec 12 of dimg file 2D
  stypvar(jvar)%cunits            = 'm'
  stypvar(jvar)%rmissing_value    = 0.
  stypvar(jvar)%valid_min         = 0.
  stypvar(jvar)%valid_max         = 7000.
  stypvar(jvar)%clong_name        = 'Mixed_Layer_Depth_on_0.01_rho_crit'
  stypvar(jvar)%cshort_name       = cn_somxl010
  stypvar(jvar)%conline_operation = 'N/A'
  stypvar(jvar)%caxis             = 'TYX'
  jvar=jvar+1

  ipk(jvar)                       = 1
  stypvar(jvar)%cname             = 'sohefldo'         ! rec 4 of dimg file 2D
  stypvar(jvar)%cunits            = 'W/m2'
  stypvar(jvar)%rmissing_value    = 0.
  stypvar(jvar)%valid_min         = -1000.
  stypvar(jvar)%valid_max         = 1000.
  stypvar(jvar)%clong_name        = 'Net_Downward_Heat_Flux'
  stypvar(jvar)%cshort_name       = 'sohefldo'
  stypvar(jvar)%conline_operation = 'N/A'
  stypvar(jvar)%caxis             = 'TYX'
  jvar=jvar+1

  ipk(jvar)                       = 1
  stypvar(jvar)%cname             = cn_soshfldo         ! rec 8 of dimg file 2D (qsr)
  stypvar(jvar)%cunits            = 'W/m2'
  stypvar(jvar)%rmissing_value    = 0.
  stypvar(jvar)%valid_min         = -1000.
  stypvar(jvar)%valid_max         = 1000.
  stypvar(jvar)%clong_name        = 'Short_Wave_Radiation'
  stypvar(jvar)%cshort_name       = cn_soshfldo
  stypvar(jvar)%conline_operation = 'N/A'
  stypvar(jvar)%caxis             = 'TYX'
  jvar=jvar+1

  ipk(jvar)                       = 1
  stypvar(jvar)%cname             = cn_sowaflup       ! rec 5 of dimg file 2D (emp)
  stypvar(jvar)%cunits            = 'kg/m2/s'         ! conversion required from CLIPPER /86400.
  stypvar(jvar)%rmissing_value    = 0.
  stypvar(jvar)%valid_min         = -1000.
  stypvar(jvar)%valid_max         = 1000.
  stypvar(jvar)%clong_name        = 'Net_Upward_Water_Flux'
  stypvar(jvar)%cshort_name       = cn_sowaflup
  stypvar(jvar)%conline_operation = 'N/A'
  stypvar(jvar)%caxis             = 'TYX'
  jvar=jvar+1

  ipk(jvar)                       = 1
  stypvar(jvar)%cname             = 'sowafldp'       ! rec 10 of dimg file 2D (erp)
  stypvar(jvar)%cunits            = 'kg/m2/s'         ! conversion required from CLIPPER /jvar.
  stypvar(jvar)%rmissing_value    = 0.
  stypvar(jvar)%valid_min         = -1000.
  stypvar(jvar)%valid_max         = 1000.
  stypvar(jvar)%clong_name        = 'Surface_Water_Flux:Damping'
  stypvar(jvar)%cshort_name       = 'sowafldp'
  stypvar(jvar)%conline_operation = 'N/A'
  stypvar(jvar)%caxis             = 'TYX'
  jvar=jvar+1

  ipk(jvar)                       = 1
  stypvar(jvar)%cname             = cn_soicecov         ! rec 13 of dimg file 2D (erp)
  stypvar(jvar)%cunits            = '%'         
  stypvar(jvar)%rmissing_value    = 0.
  stypvar(jvar)%valid_min         = 0.
  stypvar(jvar)%valid_max         = 1.
  stypvar(jvar)%clong_name        = 'Ice Cover'
  stypvar(jvar)%cshort_name       = cn_soicecov
  stypvar(jvar)%conline_operation = 'N/A'
  stypvar(jvar)%caxis             = 'TYX'
  jvar=jvar+1

  ipk(jvar)                       = 1
  stypvar(jvar)%cname             = 'sohefldp'         ! rec 9 of dimg file 2D (erp)
  stypvar(jvar)%cunits            = 'W/m2'         
  stypvar(jvar)%rmissing_value    = 0.
  stypvar(jvar)%valid_min         = -10.
  stypvar(jvar)%valid_max         = 10.
  stypvar(jvar)%clong_name        = 'Surface Heat Flux: Damping'
  stypvar(jvar)%cshort_name       = 'sohefldp'
  stypvar(jvar)%conline_operation = 'N/A'
  stypvar(jvar)%caxis             = 'TYX'

  glam = getvar  (cn_fhgr, cn_glamt, 1, npiglo, npjglo)
  gphi = getvar  (cn_fhgr, cn_gphit, 1, npiglo, npjglo)
  zdep = getvare3(cn_fzgr, cn_gdept, npk              )

  ncout = create      (cf_tfil, 'none',  npiglo, npjglo, npk, cdep=cn_vdeptht                       )
  ierr  = createvar   (ncout,   stypvar, nvar,   ipk,    id_varout                                  )
  ierr  = putheadervar(ncout,   'none',  npiglo, npjglo, npk, pnavlon=glam, pnavlat=gphi, pdep=zdep )

  jvar=1
  ! T
  DO jk=1, npk
   READ(numt,REC=jk+1) (( v2d(ji,jj), ji=1, npiglo), jj=1,npjglo)
   ierr = putvar(ncout, id_varout(jvar), v2d, jk, npiglo, npjglo)
  END DO
  jvar  = jvar+1
  PRINT *, 'Done for T'

  ! S
  DO jk=1, npk
   READ(nums,REC=jk+1) (( v2d(ji,jj), ji=1, npiglo), jj=1,npjglo)
   ierr = putvar(ncout, id_varout(jvar), v2d, jk, npiglo, npjglo)
  END DO
  jvar  = jvar+1
  PRINT *, 'Done for S'

  IF ( lexist ) THEN
  ! SSH
  READ(numssh,REC=2) (( v2d(ji,jj), ji=1, npiglo), jj=1,npjglo)
  ierr = putvar(ncout, id_varout(jvar), v2d, 1, npiglo, npjglo)
  jvar = jvar+1
  PRINT *, 'Done for SSH'
  ENDIF

  ! MXL
  READ(num2d,REC=12) (( v2d(ji,jj), ji=1, npiglo), jj=1,npjglo)
  ierr = putvar(ncout, id_varout(jvar), v2d, 1, npiglo, npjglo)
  jvar = jvar+1
  PRINT *, 'Done for MXL'

  ! QNET
  READ(num2d,REC=4 ) (( v2d(ji,jj), ji=1, npiglo), jj=1,npjglo)
  ierr = putvar(ncout, id_varout(jvar), v2d, 1, npiglo, npjglo)
  jvar = jvar+1
  PRINT *, 'Done for QNET'

  ! QSR
  READ(num2d,REC=8)  (( v2d(ji,jj), ji=1, npiglo), jj=1,npjglo)
  ierr = putvar(ncout, id_varout(jvar), v2d, 1, npiglo, npjglo)
  jvar = jvar+1
  PRINT *, 'Done for QSR'

  ! EMP
  READ(num2d,REC=5)  (( v2d(ji,jj), ji=1, npiglo), jj=1,npjglo)
  v2d  = v2d/86400. ! to change units
  ierr = putvar(ncout, id_varout(jvar), v2d, 1, npiglo, npjglo)
  jvar = jvar+1
  PRINT *, 'Done for EMP'

  ! ERP
  READ(num2d,REC=10) (( v2d(ji,jj), ji=1, npiglo), jj=1,npjglo)
  v2d  = v2d/86400. ! to change units
  ierr = putvar(ncout, id_varout(jvar), v2d, 1, npiglo, npjglo)
  jvar = jvar+1
  PRINT *, 'Done for ERP'

  ! FREEZE
  READ(num2d,REC=13) (( v2d(ji,jj), ji=1, npiglo), jj=1,npjglo)
  ierr = putvar(ncout, id_varout(jvar), v2d, 1, npiglo, npjglo)
  jvar = jvar+1
  PRINT *, 'Done for FREEZE'

  ! QRP
  READ(num2d,REC=9)  (( v2d(ji,jj), ji=1, npiglo), jj=1,npjglo)
  ierr = putvar(ncout, id_varout(jvar), v2d, 1, npiglo, npjglo)
  jvar = jvar+1
  PRINT *, 'Done for QRP'

  ierr = putvar1d(ncout, tim, npt, 'T')
  ierr = closeout(ncout)
  DEALLOCATE ( stypvar, ipk, id_varout )


  !###############
  !# GRID U FILE #
  !###############
  ! Build gridU file with vozocrtx, sozotaux
  INQUIRE(FILE=cf_dimguu, EXIST=lexist)
  IF ( lexist ) THEN
    irecl = isdirect(cf_dimguu)
    OPEN( numuu, FILE=cf_dimguu, FORM='UNFORMATTED', ACCESS='DIRECT', RECL=irecl )
    nvar=3 
  ELSE
    nvar=2
  ENDIF

  ALLOCATE ( stypvar(nvar), ipk(nvar), id_varout(nvar) )
  
  jvar = 1
  ipk(jvar)                       = npk
  stypvar(jvar)%cname             = cn_vozocrtx
  stypvar(jvar)%cunits            = 'm/s'
  stypvar(jvar)%rmissing_value    = 0.
  stypvar(jvar)%valid_min         = 0.
  stypvar(jvar)%valid_max         = 20.
  stypvar(jvar)%clong_name        = 'Zonal Velocity '
  stypvar(jvar)%cshort_name       = cn_vozocrtx
  stypvar(jvar)%conline_operation = 'N/A'
  stypvar(jvar)%caxis             = 'TZYX'
  jvar = jvar+1

  ipk(jvar)                       =  1
  stypvar(jvar)%cname             = 'sozotaux'
  stypvar(jvar)%cunits            = 'N/m2'
  stypvar(jvar)%rmissing_value    = 0.
  stypvar(jvar)%valid_min         = 0.
  stypvar(jvar)%valid_max         = 20.
  stypvar(jvar)%clong_name        = 'Zonal Wind Stress'
  stypvar(jvar)%cshort_name       = 'sozotaux'
  stypvar(jvar)%conline_operation = 'N/A'
  stypvar(jvar)%caxis             = 'TYX'
  jvar = jvar+1

  IF ( lexist ) THEN
  ipk(jvar)      = npk
  stypvar(jvar)%cname             = TRIM(cn_vozocrtx2)
  stypvar(jvar)%cunits            = 'm2/s2'
  stypvar(jvar)%rmissing_value    = 0.
  stypvar(jvar)%valid_min         = 0.
  stypvar(jvar)%valid_max         = 100.
  stypvar(jvar)%clong_name        = 'MS_Zonal_Velocity'
  stypvar(jvar)%cshort_name       = TRIM(cn_vozocrtx2)
  stypvar(jvar)%conline_operation = 'N/A'
  stypvar(jvar)%caxis             = 'TZYX'
  ENDIF

  glam = getvar  (cn_fhgr, cn_glamu, 1, npiglo, npjglo)
  gphi = getvar  (cn_fhgr, cn_gphiu, 1, npiglo, npjglo)
  zdep = getvare3(cn_fzgr, cn_gdept, npk              )

  ncout = create      (cf_ufil, 'none',  npiglo, npjglo, npk, cdep=cn_vdepthu                       )
  ierr  = createvar   (ncout,   stypvar, nvar,   ipk,    id_varout                                  )
  ierr  = putheadervar(ncout,   'none',  npiglo, npjglo, npk, pnavlon=glam, pnavlat=gphi, pdep=zdep )

  jvar=1
  DO jk=1, npk
   READ(numu,REC=jk+1) (( v2d(ji,jj), ji=1, npiglo), jj=1,npjglo)
   ierr = putvar(ncout, id_varout(jvar), v2d, jk, npiglo, npjglo)
  END DO
  jvar  = jvar+1
  PRINT *, 'Done for U'

  READ(num2d, REC=2 ) (( v2d(ji,jj), ji=1, npiglo), jj=1,npjglo)
  ierr = putvar(ncout, id_varout(jvar), v2d, 1,  npiglo, npjglo)
  jvar = jvar+1
  PRINT *, 'Done for TAUX'

  IF ( lexist ) THEN
  DO jk=1, npk
   READ(numuu,REC=jk+1) (( v2d(ji,jj), ji=1, npiglo), jj=1,npjglo)
   ierr = putvar(ncout, id_varout(jvar), v2d, jk,  npiglo, npjglo)
  END DO
  PRINT *, 'Done for UU'
  ENDIF

  ierr = putvar1d(ncout, tim, npt, 'T')
  ierr = closeout(ncout               )

  DEALLOCATE ( stypvar, ipk, id_varout )

  !###############
  !# GRID V FILE #
  !###############
  ! Build gridV file with vomecrty, sometauy
  INQUIRE(FILE=cf_dimgvv, EXIST=lexist)
  IF ( lexist ) THEN
    irecl = isdirect(cf_dimgvv)
    OPEN( numvv, FILE=cf_dimgvv, FORM='UNFORMATTED', ACCESS='DIRECT', RECL=irecl )
    nvar=3 
  ELSE
    nvar=2
  ENDIF
  ALLOCATE ( stypvar(nvar), ipk(nvar), id_varout(nvar) )

  jvar=1
  ipk(jvar)                       = npk
  stypvar(jvar)%cname             = cn_vomecrty
  stypvar(jvar)%cunits            = 'm/s'
  stypvar(jvar)%rmissing_value    = 0.
  stypvar(jvar)%valid_min         = 0.
  stypvar(jvar)%valid_max         = 20.
  stypvar(jvar)%clong_name        = 'Meridinal  Velocity '
  stypvar(jvar)%cshort_name       = cn_vomecrty
  stypvar(jvar)%conline_operation = 'N/A'
  stypvar(jvar)%caxis             = 'TZYX'
  jvar = jvar+1

  ipk(jvar)                       = 1
  stypvar(jvar)%cname             = 'sometauy'
  stypvar(jvar)%cunits            = 'N/m2'
  stypvar(jvar)%rmissing_value    = 0.
  stypvar(jvar)%valid_min         = 0.
  stypvar(jvar)%valid_max         = 20.
  stypvar(jvar)%clong_name        = 'Meridional Wind Stress'
  stypvar(jvar)%cshort_name       = 'sometauy'
  stypvar(jvar)%conline_operation = 'N/A'
  stypvar(jvar)%caxis             = 'TYX'
  jvar=jvar+1

  IF ( lexist ) THEN
  ipk(jvar)                       = npk
  stypvar(jvar)%cname             = TRIM(cn_vomecrty2)
  stypvar(jvar)%cunits            = 'm2/s2'
  stypvar(jvar)%rmissing_value    = 0.
  stypvar(jvar)%valid_min         = 0.
  stypvar(jvar)%valid_max         = 100.
  stypvar(jvar)%clong_name        = 'MS_Meridional_Velocity'
  stypvar(jvar)%cshort_name       = TRIM(cn_vomecrty2)
  stypvar(jvar)%conline_operation = 'N/A'
  stypvar(jvar)%caxis             = 'TZYX'
  ENDIF


  glam = getvar  (cn_fhgr, cn_glamv, 1,  npiglo, npjglo)
  gphi = getvar  (cn_fhgr, cn_gphiv, 1,  npiglo, npjglo)
  zdep = getvare3(cn_fzgr, cn_gdept, npk               )
  
  ncout = create      (cf_vfil, 'none',  npiglo, npjglo, npk, cdep=cn_vdepthv                       )
  ierr  = createvar   (ncout,   stypvar, nvar,   ipk,    id_varout                                  )
  ierr  = putheadervar(ncout,   'none',  npiglo, npjglo, npk, pnavlon=glam, pnavlat=gphi, pdep=zdep )

  jvar = 1
  DO jk=1, npk
   READ(numv,REC=jk+1)  (( v2d(ji,jj), ji=1, npiglo), jj=1,npjglo)
   ierr = putvar (ncout, id_varout(jvar), v2d, jk, npiglo, npjglo)
  END DO
  jvar  = jvar+1
  PRINT *, 'Done for V'

  READ(num2d, REC=3) (( v2d(ji,jj), ji=1, npiglo), jj=1,npjglo)
  ierr = putvar(ncout, id_varout(jvar), v2d, 1, npiglo, npjglo)
  jvar = jvar+1
  PRINT *, 'Done for TAUY'

  IF ( lexist ) THEN
  DO jk=1, npk
   READ(numvv,REC=jk+1) (( v2d(ji,jj), ji=1, npiglo), jj=1,npjglo)
   ierr = putvar(ncout, id_varout(jvar), v2d, jk,  npiglo, npjglo)
  END DO
  PRINT *, 'Done for VV'
  ENDIF

  ierr = putvar1d(ncout, tim, npt, 'T')
  ierr = closeout(ncout               )

  DEALLOCATE ( stypvar, ipk, id_varout )

  !###############
  !# PSI FILE #
  !###############
  ! Build PSI file with sobarstf
  nvar=1  
  ALLOCATE ( stypvar(nvar), ipk(nvar), id_varout(nvar) )
  ipk(1)                       = 1
  stypvar(1)%cname             = 'sobarstf'
  stypvar(1)%cunits            = 'm3/s'
  stypvar(1)%rmissing_value    = 0.
  stypvar(1)%valid_min         = -3.e8
  stypvar(1)%valid_max         = 3.e8
  stypvar(1)%clong_name        = 'Barotropic_Stream_Function'
  stypvar(1)%cshort_name       = 'sobarstf'
  stypvar(1)%conline_operation = 'N/A'
  stypvar(1)%caxis             = 'TYX'

  glam = getvar  (cn_fhgr, cn_glamf, 1, npiglo, npjglo)
  gphi = getvar  (cn_fhgr, cn_gphif, 1, npiglo, npjglo)
  zdep = getvare3(cn_fzgr, cn_gdept, 1                )
  
  ncout = create      (cf_bsfil, 'none',  npiglo, npjglo, 1, cdep=cn_vdepthu                       )
  ierr  = createvar   (ncout,    stypvar, nvar,   ipk,    id_varout                                )
  ierr  = putheadervar(ncout,    'none',  npiglo, npjglo, 1, pnavlon=glam, pnavlat=gphi, pdep=zdep )

  jvar = 1
  READ(num2d,REC=7) (( v2d(ji,jj), ji=1, npiglo), jj=1,npjglo)
  ierr = putvar(ncout, id_varout(jvar),v2d, 1, npiglo, npjglo)
  PRINT *, 'Done for PSI'

  ierr = putvar1d(ncout, tim, npt, 'T')
  ierr = closeout(ncout               )

  DEALLOCATE ( stypvar, ipk, id_varout )

CONTAINS

    INTEGER(KIND=4) FUNCTION isdirect(cdname)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION isdirect  ***
    !!
    !! ** Purpose :  This integer function returns the record length if cdname 
    !!               is a valid dimg file, it returns 0 either.
    !!
    !! ** Method  :  Open the file and look for the key characters (@!01) for
    !!               identification.
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*), INTENT(in) :: cdname

    ! --
    INTEGER(KIND=4)              :: irecl
    INTEGER(KIND=4)              :: inum = 100

    CHARACTER(LEN=4)             :: clver
    CHARACTER(LEN=80)            :: clheader
    !!----------------------------------------------------------------------

!
      OPEN(inum,FILE=cdname, FORM = 'UNFORMATTED', ACCESS = 'DIRECT', RECL = 88)
      READ(inum,REC=1) clver ,clheader, irecl
      CLOSE(inum)
!
      IF (clver ==  '@!01' ) THEN
         isdirect = irecl
      ELSE
         isdirect = 0
      END IF
!
      END FUNCTION isdirect
END PROGRAM cdfconvert

PROGRAM cdficb_diags
  !!======================================================================
  !!                     ***  PROGRAM  cdficb_diags  ***
  !!=====================================================================
  !!  ** Purpose : Compute the spatialy integrated icb mass and melt.
  !!
  !!  ** Method  : Horizontal integration, like in cdfmean but make 
  !!               differences for Northern and Southern Hemisphere.
  !!
  !! History : 3.0  : 01/2016  : N. Merino : Original code
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id: cdficb_diags.f90 759 2014-07-21 22:01:28Z molines $
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class iceberg_processing
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                            :: jk, jj, jt           ! dummy loop index
  INTEGER(KIND=4)                            :: ierr                 ! working integer
  INTEGER(KIND=4)                            :: narg, iargc, ijarg   ! command line 
  INTEGER(KIND=4)                            :: npiglo, npjglo, npt  ! size of the domain
  INTEGER(KIND=4)                            :: nvpk                 ! vertical levels in working variable
  INTEGER(KIND=4)                            :: nperio = 4           ! boundary condition ( periodic, north fold)
  INTEGER(KIND=4)                            :: ikx=1, iky=1, ikz=0  ! dims of netcdf output file
  INTEGER(KIND=4)                            :: nboutput=4           ! number of values to write in cdf output
  INTEGER(KIND=4)                            :: ncout                ! for netcdf output
  INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE :: ipk, id_varout

  REAL(KIND=4), DIMENSION(:,:),  ALLOCATABLE :: e1, e2               ! metrics
  REAL(KIND=4), DIMENSION(:,:),  ALLOCATABLE :: tmask, ff            ! npiglo x npjglo
  REAL(KIND=4), DIMENSION(:,:),  ALLOCATABLE :: ricbmass, ricbmelt ! thickness, leadfrac (concentration)
  REAL(KIND=4), DIMENSION(:,:),  ALLOCATABLE :: rdumlon, rdumlat     ! dummy lon lat for output

  REAL(KIND=8)                               :: dmasss, dmelts       ! volume, area extend South hemisphere
  REAL(KIND=8)                               :: dmassn, dmeltn       ! volume, area extend North hemisphere
  REAL(KIND=8), DIMENSION(:),    ALLOCATABLE :: dtim                 ! time counter

  TYPE(variable), DIMENSION(:),  ALLOCATABLE :: stypvar              ! structure of output
  !
  CHARACTER(LEN=256)                         :: cf_ifil              ! input ice file
  CHARACTER(LEN=256)                         :: cf_out='icbdiags.nc' ! output file
  CHARACTER(LEN=256)                         :: cldum                ! dummy string
  !
  LOGICAL                                    :: lchk  = .false.      ! missing file flag
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdficb_diags -f ICB-file [-jperio jperio] [-o OUT-file] '
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'        Compute the spatially integrated icb mass and melt flux for'
     PRINT *,'        both hemispheres.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -f ICB-file : a single netcdf icb file' 
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-jperio jperio] : specify the NEMO jperio parameter for the north pole'
     PRINT *,'               folding condition. Default is ',nperio
     PRINT *,'                - ORCA2 ORCA025, ORCA12 uses 4'
     PRINT *,'                - ORCA1 ORCA05  uses 6'
     PRINT *,'       [-o OUT-file] : specifiy output file name instead of ',TRIM(cf_out)
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        ',TRIM(cn_fhgr),' and ',TRIM(cn_fmsk)
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) , 'with single values.'
     PRINT *,'         variables : [NS]Mass  (Kg )'
     PRINT *,'                     [NS]Melt    (Kg/s )'
     PRINT *,'               N = northern hemisphere'
     PRINT *,'               S = southern hemisphere'
     PRINT *,'       standard output'
     PRINT *,'      '
     STOP 
  ENDIF

  ijarg=1
  DO WHILE (ijarg <= narg )
     CALL getarg(ijarg,cldum) ; ijarg=ijarg+1
     SELECT CASE (cldum)
     CASE ( '-f'    ) ; CALL getarg(ijarg, cf_ifil) ; ijarg=ijarg+1
        ! options
     CASE ( '-o'    ) ; CALL getarg(ijarg, cf_out ) ; ijarg=ijarg+1
     CASE ('-jperio') ; CALL getarg(ijarg, cldum  ) ; ijarg=ijarg+1 ; READ(cldum,*) nperio
     CASE DEFAULT     ; PRINT *,' ERROR : ',TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  ENDDO

  lchk = lchk .OR. chkfile(cn_fhgr) 
  lchk = lchk .OR. chkfile(cn_fmsk) 
  lchk = lchk .OR. chkfile(cf_ifil)

  IF ( lchk ) STOP 99 ! missing file

  npiglo = getdim (cf_ifil,cn_x)
  npjglo = getdim (cf_ifil,cn_y)
  npt    = getdim (cf_ifil,cn_t)

  ALLOCATE ( tmask(npiglo,npjglo) ,ff(npiglo,npjglo) )
  ALLOCATE ( ricbmass(npiglo,npjglo) )
  ALLOCATE ( ricbmelt(npiglo,npjglo) )
  ALLOCATE ( e1(npiglo,npjglo),e2(npiglo,npjglo) )
  ALLOCATE ( dtim(npt) )
  ALLOCATE ( stypvar(nboutput), ipk(nboutput), id_varout(nboutput) )
  ALLOCATE ( rdumlon(1,1), rdumlat(1,1) )

  CALL CreateOutput

  e1(:,:) = getvar(cn_fhgr, cn_ve1t,  1, npiglo, npjglo)
  e2(:,:) = getvar(cn_fhgr, cn_ve2t,  1, npiglo, npjglo)
  ff(:,:) = getvar(cn_fhgr, cn_gphit, 1, npiglo, npjglo) ! only the sign of ff is important

  ! modify the mask for periodic and north fold condition (T pivot, F Pivot ...)
  ! in fact should be nice to use jperio as in the code ...
  tmask(:,:)=getvar(cn_fmsk, cn_tmask,1,npiglo,npjglo)

  ! consider the use of tmaskutil ???
  SELECT CASE (nperio)
  CASE (0) ! closed boundaries
     ! nothing to do
  CASE (4) ! ORCA025 , ORCA12 type boundary
     tmask(1:2,:)=0.
     tmask(:,npjglo)=0.
     tmask(npiglo/2+1:npiglo,npjglo-1)= 0.
  CASE (6) ! ORCA05
     tmask(1:2,:)=0.
     tmask(:,npjglo)=0.
  CASE DEFAULT
     PRINT *,' Nperio=', nperio,' not yet coded'
     STOP 99
  END SELECT

  IF (chkvar(cf_ifil, cn_iicbmass)) STOP 99

  IF (chkvar(cf_ifil, cn_iicbmelt)) STOP 99
  !
  DO jt = 1, npt
     IF (TRIM(cn_iicbmass) /= 'missing') THEN ; ricbmass(:,:) = getvar(cf_ifil, cn_iicbmass, 1, npiglo, npjglo, ktime=jt)
     ELSE                                     ; ricbmass(:,:) = 0.
     ENDIF
     ricbmelt(:,:) = getvar(cf_ifil, cn_iicbmelt, 1, npiglo, npjglo, ktime=jt)

     ! North : ff > 0 
     dmassn    = SUM( ricbmass (:,:)* e1(:,:) * e2(:,:) * tmask (:,:), (ff > 0 ) )
     dmeltn    = SUM( ricbmelt (:,:)* e1(:,:) * e2(:,:) * tmask (:,:), (ff > 0 ) )

     ! South : ff < 0
     dmasss    = SUM( ricbmass (:,:)* e1(:,:) * e2(:,:) * tmask (:,:), (ff < 0) )
     dmelts    = SUM( ricbmelt (:,:)* e1(:,:) * e2(:,:) * tmask (:,:), (ff < 0 )) 

     PRINT *,' TIME = ', jt,' ( ',dtim(jt),' )'
     PRINT *,' Northern Hemisphere ' 
     PRINT *,'          NMass (Kg)      ', dmassn
     PRINT *,'          NMelt (Kg/s)    ', dmeltn
     PRINT *
     PRINT *,' Southern Hemisphere ' 
     PRINT *,'          Mass (Kg)      ', dmasss
     PRINT *,'          Melt (Kg/s)    ', dmelts

     ! netcdf output 
     ierr = putvar0d(ncout,id_varout(1), REAL(dmassn), ktime=jt)
     ierr = putvar0d(ncout,id_varout(2), REAL(dmeltn), ktime=jt)
     ierr = putvar0d(ncout,id_varout(3), REAL(dmasss), ktime=jt)
     ierr = putvar0d(ncout,id_varout(4), REAL(dmelts), ktime=jt)

  END DO ! time loop
  ierr = closeout(ncout)

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    rdumlon(:,:) = 0.
    rdumlat(:,:) = 0.

    ipk(:) = 1
    ! define new variables for output 
    stypvar%scale_factor      = 1.
    stypvar%add_offset        = 0.
    stypvar%savelog10         = 0.
    stypvar%conline_operation = 'N/A'
    stypvar%caxis             = 'T'

    stypvar(1)%cname          = 'NMass'
    stypvar(1)%cunits         = 'Kg'
    stypvar(1)%clong_name     = 'Icb_Mass_in_Northern_Hemisphere'
    stypvar(1)%cshort_name    = 'NMass'

    stypvar(2)%cname          = 'NMelt'
    stypvar(2)%cunits         = 'Kg/s'
    stypvar(2)%clong_name     = 'Icb_melt_in_Northern_Hemisphere'
    stypvar(2)%cshort_name    = 'NMelt'

    stypvar(3)%cname          = 'SVMass'
    stypvar(3)%cunits         = 'Kg'
    stypvar(3)%clong_name     = 'Icb_Mass_in_Southern_Hemisphere'
    stypvar(3)%cshort_name    = 'SMass'

    stypvar(4)%cname          = 'SMelt'
    stypvar(4)%cunits         = 'Kg/s'
    stypvar(4)%clong_name     = 'Icb_Melt_in_Southern_Hemisphere'
    stypvar(4)%cshort_name    = 'SMelt'

    ! create output fileset
    ncout = create      (cf_out, 'none',  ikx,      iky, ikz,     cdep='depthw'                   )
    ierr  = createvar   (ncout,  stypvar, nboutput, ipk, id_varout                                )
    ierr  = putheadervar(ncout,  cf_ifil, ikx,      iky, ikz,     pnavlon=rdumlon, pnavlat=rdumlat)

    dtim  = getvar1d(cf_ifil, cn_vtimec, npt     )
    ierr  = putvar1d(ncout,   dtim,      npt, 'T')

  END SUBROUTINE CreateOutput

END PROGRAM cdficb_diags

PROGRAM cdfzonalmean
  !!======================================================================
  !!                     ***  PROGRAM  cdfzonalmean  ***
  !!=====================================================================
  !!  ** Purpose : Compute the zonal mean of a file
  !!
  !!  ** Method  : In this program the 'zonal' mean is in fact a mean 
  !!               along the I coordinate. 
  !!
  !! History : 2.1  : 11/2005  : J.M. Molines : Original code
  !!                : 06/2007  : P. Mathiot   : adaptation for 2D files
  !!           3.0  : 05/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  !! * Local variables
  IMPLICIT NONE

  INTEGER(KIND=4)                               :: ji, jj, jk ,jt      ! dummy loop index
  INTEGER(KIND=4)                               :: jbasin, jvar        ! dummy loop index
  INTEGER(KIND=4)                               :: ijvar               ! variable counter
  INTEGER(KIND=4)                               :: npbasins=1          ! number of subbasin
  INTEGER(KIND=4)                               :: ivar = 0            ! output variable counter
  INTEGER(KIND=4)                               :: narg, iargc         ! command line 
  INTEGER(KIND=4)                               :: ijarg, ireq         ! command line 
  INTEGER(KIND=4)                               :: npiglo, npjglo      ! size of the domain
  INTEGER(KIND=4)                               :: npk, npt            ! size of the domain
  INTEGER(KIND=4)                               :: nvarin, nvar        ! number of input variables: all/valid
  INTEGER(KIND=4)                               :: nvarmx              ! number of output variables: all/valid
  INTEGER(KIND=4)                               :: nvaro=1             ! number of output variables: all/valid
  INTEGER(KIND=4)                               :: ncoef=1             ! 1 or 2 (regarding lmax option) 
  INTEGER(KIND=4)                               :: ncout               ! ncid of output file
  INTEGER(KIND=4)                               :: ierr, ik            ! working integers
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: ipki, id_varin      ! jpbasin x nvar
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: ipko, id_varout     ! jpbasin x nvar
  INTEGER(KIND=4), DIMENSION(2)                 :: ijloc               ! working array for maxloc

  REAL(KIND=4)                                  :: zspval=0.           ! missing value 
  REAL(KIND=4), DIMENSION (:),      ALLOCATABLE :: tim                 ! time counter
  REAL(KIND=4), DIMENSION (:),      ALLOCATABLE :: gdep                ! gdept or gdepw
  REAL(KIND=4), DIMENSION (:,:),    ALLOCATABLE :: e1, e2, gphi, zv    ! metrics, latitude, data value
  REAL(KIND=4), DIMENSION (:,:),    ALLOCATABLE :: zdumlon             ! dummy longitude = 0.
  REAL(KIND=4), DIMENSION (:,:),    ALLOCATABLE :: zdumlat             ! latitude for i = north pole
  REAL(KIND=4), DIMENSION (:,:),    ALLOCATABLE :: zmaskvar            ! variable mask
  REAL(KIND=4), DIMENSION (:,:,:),  ALLOCATABLE :: zmask               ! basin mask jpbasins x npiglo x npjglo
  REAL(KIND=4), DIMENSION (:,:),    ALLOCATABLE :: rzomax              ! zonal maximum
  REAL(KIND=4), DIMENSION (:,:),    ALLOCATABLE :: rzomin              ! zonal minimum

  REAL(KIND=8)                                  :: dtmp                ! temporary variable
  REAL(KIND=8), DIMENSION (:,:),    ALLOCATABLE :: dzomean , darea     !  npjglo x npk
  REAL(KIND=8), DIMENSION (:,:),    ALLOCATABLE :: dl_surf             ! surface of cells

  CHARACTER(LEN=256)                            :: cf_in               ! input file name
  CHARACTER(LEN=256)                            :: cf_out='zonalmean.nc' ! output file name
  CHARACTER(LEN=256)                            :: cf_basins='none'    ! sub basin file name
  CHARACTER(LEN=10 )                            :: cv_e1, cv_e2        ! horizontal metrics variable names
  CHARACTER(LEN=10 )                            :: cv_phi              ! latitude variable name
  CHARACTER(LEN=10 )                            :: cv_msk              ! mask variable name
  CHARACTER(LEN=10 )                            :: cv_depi, cv_depo    ! depth variable name (input/output)
  CHARACTER(LEN=256)                            :: cldum               ! dummy character variable
  CHARACTER(LEN=256)                            :: ctyp                ! variable type on C-grid
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_namesi           ! input variable names
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_nameso           ! output variable names
  CHARACTER(LEN=80 ), DIMENSION(:), ALLOCATABLE :: cv_fix              ! name of the specified variable to process (-var option)
  CHARACTER(LEN=4  ), DIMENSION(5)              :: cbasin=(/'_glo','_atl','_inp','_ind','_pac'/) ! sub basin suffixes

  TYPE(variable), DIMENSION(:),     ALLOCATABLE :: stypvari            ! structure for input variables
  TYPE(variable), DIMENSION(:),     ALLOCATABLE :: stypvaro            ! structure for output variables

  LOGICAL                                       :: lpdep    =.FALSE.   ! flag for depth sign (default dep < 0)
  LOGICAL                                       :: lndep_in =.FALSE.   ! flag for depth sign (default dep < 0) in input file
  LOGICAL                                       :: lmax     =.FALSE.   ! flag for zonal maximum determination
  LOGICAL                                       :: lvar     =.FALSE.   ! flag for single variable processing
  LOGICAL                                       :: ldebug   =.FALSE.   ! flag for activated debug print 
  LOGICAL                                       :: l2d      =.FALSE.   ! flag for 2D files
  LOGICAL                                       :: lchk     =.FALSE.   ! flag for missing files
  LOGICAL, DIMENSION(:),            ALLOCATABLE :: lbad                ! flag array for variable selection
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfzonalmean IN-file point_type [ BASIN-file] [-debug]...'
     PRINT *,'       ...[-var var1,var2,..] [-max ] [-pdep | --positive_depths]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the zonal mean of all the variables available in the' 
     PRINT *,'       input file. This program assume that all the variables are'
     PRINT *,'       located on the same C-grid point, specified on the command line.'
     PRINT *,'         Using -var option limits the variables to be processed.'
     PRINT *,'      '
     PRINT *,'       Zonal mean is in fact the mean value computed along the I coordinate.'
     PRINT *,'       The result is a vertical slice, in the meridional direction.'
     PRINT *,'      '
     PRINT *,'       REMARK : partial step are not handled properly (but probably '
     PRINT *,'                minor impact on results).'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       IN-file    : input netcdf file.' 
     PRINT *,'       point_type : indicate the location on C-grid (T|U|V|F|W)'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [BASIN-file] : netcdf file describing sub basins, similar to '
     PRINT *,'                      ', TRIM(cn_fbasins),'. If this name is not given '
     PRINT *,'                      as option, only the global zonal mean is computed.'
     PRINT *,'       [-max     ] : output the zonal maximum and minimum of the variable '
     PRINT *,'       [-var var1,var2,.. ] : Comma separated list of selected variables'
     PRINT *,'       [-pdep | --positive_depths ] : use positive depths in the output file.'
     PRINT *,'                      Default behaviour is to have negative depths.'
     PRINT *,'       [-ndep_in ] : negative depths are used in the input file.'
     PRINT *,'                      Default behaviour is to have positive depths.'
     PRINT *,'       [-debug   ] : add some print for debug'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ',TRIM(cn_fhgr),', ', TRIM(cn_fzgr),' and ', TRIM(cn_fmsk)
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : output variable names are built with the following'
     PRINT *,'                     convention: zoxxxx_bas'
     PRINT *,'                      where zo replace vo/so prefix of the input variable'
     PRINT *,'                      where bas is a suffix for each sub-basins (or glo)'
     PRINT *,'                      if a BASIN-file is used.'
     PRINT *,'                 If option -max is used, each standard output variable'
     PRINT *,'                     is associated with a var_max variable.'
     STOP
  ENDIF

  ijarg = 1  ; ireq = 0
  DO WHILE ( ijarg <= narg ) 
    CALL getarg( ijarg, cldum ) ; ijarg=ijarg+1
    SELECT CASE (cldum)
    CASE ( '-pdep' , '--positive_depths' ) ; lpdep    =.TRUE.
    CASE ( '-ndep_in'                    ) ; lndep_in =.TRUE.
    CASE ( '-debug'                      ) ; ldebug   =.TRUE.
    CASE ( '-max'                        ) ; lmax     =.TRUE. ; ncoef=3
    CASE ( '-var'                        ) ; lvar     =.TRUE.
                                             CALL getarg( ijarg, cldum) ; ijarg=ijarg+1
                                             CALL ParseVars(cldum) 
    CASE DEFAULT
      ireq=ireq+1
      SELECT CASE (ireq)
      CASE (1) ; cf_in      = cldum                 ! file name is the 1rst argument
      CASE (2) ; ctyp       = cldum                 ! point type is the 2nd
      CASE (3) ; cf_basins  = cldum                 ! sub basin file is the 3rd (optional)
                 npbasins   = 5
                 lchk       = chkfile (cf_basins)
      CASE DEFAULT 
        PRINT *,' Too many arguments ...' ; STOP 99
      END SELECT
    END SELECT
  END DO

  IF ( ldebug ) THEN  ! additional print for debuging
     PRINT *,' Option -pdep     ', lpdep
     PRINT *,' Option -npdep_in ', lndep_in
     PRINT *,' Option -debug    ', ldebug
     PRINT *,' Option -max      ', lmax
     PRINT *,' Option -var      ', lvar
     PRINT *,' NPBASINS       = ', npbasins
  ENDIF

  ! check  files existence
  lchk = lchk .OR. chkfile (cn_fhgr)
  lchk = lchk .OR. chkfile (cn_fzgr)
  lchk = lchk .OR. chkfile (cn_fmsk)
  lchk = lchk .OR. chkfile (cf_in  )
  IF ( lchk ) STOP 99 ! missing files

  ! set the metrics according to C grid point
  SELECT CASE (ctyp)
  CASE ('T', 't', 'S', 's')
     cv_e1   = cn_ve1t    ; cv_e2   = cn_ve2t
     cv_depi = cn_gdept   ; cv_depo = cn_vdeptht
     cv_phi  = cn_gphit   ; cv_msk  = 'tmask'
  CASE ('U', 'u')
     cv_e1   = cn_ve1u    ; cv_e2   = cn_ve2u
     cv_depi = cn_gdept   ; cv_depo = cn_vdepthu
     cv_phi  = cn_gphiu   ; cv_msk  = 'umask'
  CASE ('V', 'v')
     cv_e1   = cn_ve1v    ; cv_e2   = cn_ve2v
     cv_depi = cn_gdept   ; cv_depo = cn_vdepthv
     cv_phi  = cn_gphiv   ; cv_msk  = 'vmask'
  CASE ('F', 'f')
     cv_e1   = cn_ve1f    ; cv_e2   = cn_ve2f
     cv_depi = cn_gdept   ; cv_depo = cn_vdeptht
     cv_phi  = cn_gphif   ; cv_msk  = 'fmask'
  CASE ('W', 'w')
     cv_e1   = cn_ve1t    ; cv_e2   = cn_ve2t
     cv_depi = cn_gdepw   ; cv_depo = cn_vdepthw
     cv_phi  = cn_gphit   ; cv_msk  = 'tmask'
  CASE DEFAULT
     PRINT *, ' C grid:', TRIM(ctyp),' point not known!' ; STOP 99
  END SELECT

  nvarin  = getnvar(cf_in)   ! number of input variables in file
  IF ( .NOT. lvar ) THEN
    nvaro = nvarin
  ENDIF

  nvarmx = ncoef * npbasins * nvaro

  IF ( ldebug ) PRINT *,' NVARMX (output) :', nvarmx

  ALLOCATE ( cv_namesi(nvarin), ipki(nvarin), id_varin (nvarin) )
  ALLOCATE ( cv_nameso(nvarmx), ipko(nvarmx), id_varout(nvarmx) )
  ALLOCATE ( stypvari(nvarin)                                   )
  ALLOCATE ( stypvaro(nvarmx)                                   )

  cv_namesi(1:nvarin) = getvarname(cf_in, nvarin, stypvari )
  ipki     (1:nvarin) = getipk    (cf_in, nvarin           )
 
  IF ( lvar )  THEN 
     ALLOCATE ( lbad(nvarin) ) 
     lbad(:) = .true.  ! 
     ! tricks : in case of specified variables, set ipki to 0 all variables
     !          not choosen.
     DO ji = 1, nvaro
       DO jvar = 1, nvarin
         IF ( cv_namesi(jvar) == cv_fix(ji) ) lbad(jvar) = .false.
       END DO
     END DO
     WHERE ( lbad ) ipki=0
     DEALLOCATE (lbad )
  ENDIF

  ! buildt output filename
  nvar = 0  ! over all number of valid variables for zonal mean ( < nvarin)
  ivar = 0  ! over all variable counter ( nvar x basins)
  DO jvar = 1,nvarin
     ! skip variables such as nav_lon, nav_lat, time_counter deptht ...
     IF (ipki(jvar) == 0 ) THEN
        cv_namesi(jvar)='none'
     ELSE
        nvar           = nvar + 1 ! count for valid input variables
        id_varin(nvar) = jvar     ! use indirect adressing for those variables
        DO jbasin=1,npbasins
           ivar=ivar + 1      ! count for output variables
           cv_nameso(ivar)='zo'//TRIM(cv_namesi(jvar)(3:))//TRIM(cbasin(jbasin) )
           ! intercept case of duplicate zonal name
           IF (cv_namesi(jvar) == 'iowaflup' ) cv_nameso(ivar)='zowaflio'  // TRIM(cbasin(jbasin) )
           IF (cv_namesi(jvar) == 'cfc11'    ) cv_nameso(ivar)='zocfc11'   // TRIM(cbasin(jbasin) )
           IF (cv_namesi(jvar) == 'bombc14'  ) cv_nameso(ivar)='zobc14'    // TRIM(cbasin(jbasin) )
           IF (cv_namesi(jvar) == 'invcfc'   ) cv_nameso(ivar)='zoinvcfc'  // TRIM(cbasin(jbasin) )
           IF (cv_namesi(jvar) == 'invc14'   ) cv_nameso(ivar)='zoinvc14'  // TRIM(cbasin(jbasin) )
           IF (cv_namesi(jvar) == 'qtrcfc'   ) cv_nameso(ivar)='zoqtrcfc'  // TRIM(cbasin(jbasin) )
           IF (cv_namesi(jvar) == 'qtrc14'   ) cv_nameso(ivar)='zoqtrc14'  // TRIM(cbasin(jbasin) )
           IF (cv_namesi(jvar) == 'qintcfc'  ) cv_nameso(ivar)='zoqintcfc' // TRIM(cbasin(jbasin) )
           IF (cv_namesi(jvar) == 'qintc14'  ) cv_nameso(ivar)='zoqintc14' // TRIM(cbasin(jbasin) )

           stypvaro(ivar)%cname             = cv_nameso(ivar)
           stypvaro(ivar)%cunits            = stypvari(jvar)%cunits
           stypvaro(ivar)%rmissing_value    = zspval
           stypvaro(ivar)%valid_min         = stypvari(jvar)%valid_min
           stypvaro(ivar)%valid_max         = stypvari(jvar)%valid_max
           stypvaro(ivar)%clong_name        = 'Zonal_Mean_'//TRIM(stypvari(jvar)%clong_name)//TRIM(cbasin(jbasin) )
           stypvaro(ivar)%cshort_name       = stypvaro(ivar)%cname
           stypvaro(ivar)%conline_operation = '/N/A'

           IF (ipki(jvar) == 1 ) THEN
             stypvaro(ivar)%caxis           ='TY'
           ELSE
             stypvaro(ivar)%caxis           ='TZY'
           ENDIF

           ipko(ivar)=ipki(jvar)
        END DO
     ENDIF
  END DO

  nvaro = ivar  ! total number of output variables
  IF ( lmax ) THEN  ! create variable and entry for zonal max
     DO jvar = 1,nvaro
       stypvaro(jvar+nvaro) = stypvaro(jvar)  ! copy all var attributes 
       ipko    (jvar+nvaro) = ipko    (jvar)
       stypvaro(jvar+nvaro)%cname      = TRIM(stypvaro (jvar)%cname)//'_max'
       stypvaro(jvar+nvaro)%clong_name = 'Zonal_Max_'//TRIM(stypvaro (jvar)%clong_name(12:))

       stypvaro(jvar+2*nvaro) = stypvaro(jvar)  ! copy all var attributes 
       ipko    (jvar+2*nvaro) = ipko    (jvar)
       stypvaro(jvar+2*nvaro)%cname      = TRIM(stypvaro (jvar)%cname)//'_min'
       stypvaro(jvar+2*nvaro)%clong_name = 'Zonal_Min_'//TRIM(stypvaro (jvar)%clong_name(12:))
     ENDDO
  ENDIF

  npiglo = getdim (cf_in, cn_x)
  npjglo = getdim (cf_in, cn_y)
  npk    = getdim (cf_in, cn_z)
  npt    = getdim (cf_in, cn_t)

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  ! if 2D fields, npk=0, assume 1
  IF ( npk == 0 ) THEN
     npk = 1 
     l2d = .TRUE.
     PRINT *,' It is a 2D field, assume npk=1 and gdep=0'
  END IF
  ! Allocate arrays
  ALLOCATE ( zmask(npbasins,npiglo,npjglo)              )
  ALLOCATE ( zv(npiglo,npjglo), zmaskvar(npiglo,npjglo) )
  ALLOCATE ( e1(npiglo,npjglo), e2      (npiglo,npjglo) )
  ALLOCATE ( gphi(npiglo,npjglo), gdep(npk), tim(npt)   )
  ALLOCATE ( zdumlon(1,npjglo), zdumlat(1,npjglo)       )
  IF ( lmax ) ALLOCATE ( rzomax(npjglo,npk)             )
  IF ( lmax ) ALLOCATE ( rzomin(npjglo,npk)             )
  ALLOCATE ( dzomean(npjglo,npk), darea(npjglo,npk)     )
  ALLOCATE ( dl_surf(npiglo,npjglo)                     )

  ! get the metrics
  e1(:,:)   = getvar(cn_fhgr, cv_e1,  1, npiglo, npjglo) 
  e2(:,:)   = getvar(cn_fhgr, cv_e2,  1, npiglo, npjglo) 
  gphi(:,:) = getvar(cn_fhgr, cv_phi, 1, npiglo, npjglo)
  
  dl_surf(:,:) = 1.d0 * e1(:,:) * e2(:,:)

  IF (l2d)  THEN 
     gdep(:) = 0
  ELSE
     gdep(:) = getvare3(cn_fzgr, cv_depi ,npk)
     IF (ldebug) PRINT *, 'getvare3 : ', TRIM(cn_fzgr), TRIM(cv_depi), npk
     IF (ldebug) PRINT *, 'getvare3 : ', gdep
  ENDIF

  IF ( .NOT. lpdep ) gdep(:)   = -1.*  gdep(:)     ! helps for plotting the results

  ! Look for the i-index that go through the North Pole
  ijloc        = MAXLOC(gphi)
  zdumlat(1,:) = gphi(ijloc(1),:)
  zdumlon(:,:) = 0.              ! set the dummy longitude to 0

  ! create output fileset
  ncout = create      (cf_out, cf_in,    1,           npjglo, npk,  cdep=cv_depo                                )
  ierr  = createvar   (ncout,  stypvaro, ncoef*nvaro, ipko,   id_varout                                         )
  ierr  = putheadervar(ncout,  cf_in,    1,           npjglo, npk,  pnavlon=zdumlon, pnavlat=zdumlat, pdep=gdep )

  tim   = getvar1d(cf_in, cn_vtimec, npt     )
  ierr  = putvar1d(ncout, tim,       npt, 'T')

  ! reading the surface masks
  ! 1 : global ; 2 : Atlantic ; 3 : Indo-Pacif ; 4 : Indian ; 5 : Pacif
  ik=1
  IF ( lndep_in ) ik = npk   ! some model are numbered from the bottom
  zmask(1,:,:) = getvar(cn_fmsk, cv_msk, ik, npiglo, npjglo)
  IF ( cf_basins /= 'none' ) THEN
     zmask(2,:,:) = getvar(cf_basins, cn_tmaskatl, ik, npiglo, npjglo )
     zmask(4,:,:) = getvar(cf_basins, cn_tmaskind, ik, npiglo, npjglo )
     zmask(5,:,:) = getvar(cf_basins, cn_tmaskpac, ik, npiglo, npjglo )
     zmask(3,:,:) = zmask(5,:,:) + zmask(4,:,:)
     ! ensure that there are no overlapping on the masks
     WHERE(zmask(3,:,:) > 0 ) zmask(3,:,:) = 1
  ENDIF

  ! main computing loop
  ivar = 0
  DO jvar = 1, nvar
     ijvar = id_varin(jvar)
     DO jt = 1,npt
        IF (MOD(jt,100)==0) PRINT *, jt,'/',npt
        DO jk = 1, ipki(ijvar)
           IF (ldebug) PRINT *,TRIM(cv_namesi(ijvar)), ' level ',jk
           ! Get variables and mask at level jk
           zv(:,:)       = getvar(cf_in,   cv_namesi(ijvar),jk ,npiglo, npjglo, ktime=jt)
           zmaskvar(:,:) = getvar(cn_fmsk, cv_msk ,         jk ,npiglo, npjglo          )
           
           ! For all basins 
           DO jbasin = 1, npbasins
              dzomean(:,:) = 0.d0
              darea(:,:)   = 0.d0
              ! integrates 'zonally' (along i-coordinate)
              IF ( lmax) rzomax(:,jk) = -1.e20
              IF ( lmax) rzomin(:,jk) =  1.e20

              !$OMP PARALLEL DO SCHEDULE(RUNTIME) PRIVATE(dtmp)
              DO jj=1,npjglo
                  DO ji=1,npiglo
                    dtmp = 1.d0 * zmask(jbasin,ji,jj)*zmaskvar(ji,jj)*zv(ji,jj)
                    dzomean(jj,jk) = dzomean(jj,jk) + dl_surf(ji,jj)* dtmp
                    darea  (jj,jk) = darea  (jj,jk) + dl_surf(ji,jj)* zmask(jbasin,ji,jj)*zmaskvar(ji,jj)
           IF( lmax )                 rzomax (jj,jk) = MAX(rzomax (jj,jk), dtmp )
           IF( lmax .AND. dtmp /= 0.) rzomin (jj,jk) = MIN(rzomin (jj,jk), dtmp )
                 END DO
              END DO
              !$OMP  END  PARALLEL DO

              ! compute the mean value if the darea is not 0, else assign spval
              WHERE (darea /= 0 ) 
                 dzomean=dzomean/darea
              ELSEWHERE
                 dzomean=zspval
              ENDWHERE
              IF (lmax)  THEN
                 WHERE (darea == 0 ) 
                   rzomax=zspval ; rzomin=zspval 
                 ENDWHERE
              ENDIF

              ivar = (jvar-1)*npbasins + jbasin
              ierr = putvar (ncout, id_varout(ivar),   REAL(dzomean(:,jk)), jk, 1, npjglo, ktime=jt)
   IF ( lmax) ierr = putvar (ncout, id_varout(ivar+nvaro),   rzomax(:,jk),  jk, 1, npjglo, ktime=jt)
   IF ( lmax) ierr = putvar (ncout, id_varout(ivar+2*nvaro), rzomin(:,jk),  jk, 1, npjglo, ktime=jt)
           END DO  !next basin
        END DO  ! next k 
     END DO ! next time
  END DO ! next variable

  ierr = closeout(ncout)
CONTAINS 
   SUBROUTINE ParseVars (cdum)
      !!---------------------------------------------------------------------
      !!                  ***  ROUTINE ParseVars  ***
      !!
      !! ** Purpose :  Decode -var option from command line
      !!
      !! ** Method  :  look for , in the argument string and set the number of
      !!         variable (nvaro), allocate cv_fix array and fill it with the
      !!         decoded  names.
      !!
      !!----------------------------------------------------------------------
      CHARACTER(LEN=*), INTENT(in) :: cdum

      CHARACTER(LEN=80), DIMENSION(100) :: cl_dum  ! 100 is arbitrary
      INTEGER  :: ji
      INTEGER  :: inchar,  i1=1
      !!----------------------------------------------------------------------

      inchar= LEN(TRIM(cdum))
      ! scan the input string and look for ',' as separator
      DO ji=1,inchar
         IF ( cdum(ji:ji) == ',' ) THEN
            cl_dum(nvaro) = cdum(i1:ji-1)
            i1=ji+1
            nvaro=nvaro+1
         ENDIF
      ENDDO

      ! last name of the list does not have a ','
      cl_dum(nvaro) = cdum(i1:inchar)

      ALLOCATE ( cv_fix(nvaro) )
      IF ( ldebug) PRINT *,' SELECTED VARIABLES :'
      DO ji=1, nvaro
         cv_fix(ji) = cl_dum(ji)
         IF ( ldebug) PRINT *, "    ",TRIM(cv_fix(ji))
      ENDDO
   END SUBROUTINE ParseVars

END PROGRAM cdfzonalmean

PROGRAM cdfheatc
  !!======================================================================
  !!                     ***  PROGRAM  cdfheatc  ***
  !!=====================================================================
  !!  ** Purpose : Compute the heat content of the ocean : 1 single value
  !!
  !!  ** Method  : compute the sum ( rho cp T  * e1t *e2t * e3t * tmask )
  !!
  !! History : 2.1  : 03/2006  : J.M. Molines : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4), PARAMETER                :: jp_hc3d=1, jp_hc2d=2 , jp_hcvol=3
  INTEGER(KIND=4)                           :: jk, jt              ! dummy loop index
  INTEGER(KIND=4)                           :: ik                  ! working integer
  INTEGER(KIND=4)                           :: ierr                ! working integer
  INTEGER(KIND=4)                           :: iimin=0, iimax=0    ! domain limitation for computation
  INTEGER(KIND=4)                           :: ijmin=0, ijmax=0    ! domain limitation for computation
  INTEGER(KIND=4)                           :: ikmin=0, ikmax=0    ! domain limitation for computation
  INTEGER(KIND=4)                           :: mxloption=0         ! mixed layer option    
  INTEGER(KIND=4)                           :: narg, iargc, ijarg  ! command line 
  INTEGER(KIND=4)                           :: npiglo, npjglo      ! size of the domain
  INTEGER(KIND=4)                           :: npk, npkk,npt       ! size of the domain
  INTEGER(KIND=4)                           :: nvpk                ! vertical levels in working variable
  INTEGER(KIND=4)                           :: ncout
  INTEGER(KIND=4), DIMENSION(:),  ALLOCATABLE  :: ipk, id_varout   ! for output variables

  REAL(KIND=4), PARAMETER                   :: pprho0=1020.        ! water density (kg/m3)
  REAL(KIND=4), PARAMETER                   :: ppcp=4000.          ! calorific capacity (J/kg/m3)

  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e1t, e2t            ! horizontal metrics
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e3t                 ! vertical metric
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: temp                ! temperature
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: tmask               ! tmask
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: rmxldep             ! mixed layer depth
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: gdepw               ! depth
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: tim                 ! time counter
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: e31d                ! vertical metrics in case of full step

  REAL(KIND=8)                              :: dvol                ! 3D volume of the ocean
  REAL(KIND=8)                              :: dsum                ! weighted sum 3D
  REAL(KIND=8)                              :: dvol2d              ! volume of a layer
  REAL(KIND=8)                              :: dsum2d              ! weigthed sum per layer
  REAL(KIND=8)                              :: dsurf               ! surface of a layer
  REAL(KIND=8), DIMENSION(1,1)              :: dl_dum              ! working pseudo array for nc output

  TYPE(variable), DIMENSION(:),    ALLOCATABLE :: stypvar          ! structure for attributes

  CHARACTER(LEN=256)                        :: cf_tfil             ! input gridT file
  CHARACTER(LEN=256)                        :: cf_out='heatc.nc'   ! netcdf output file
  CHARACTER(LEN=256)                        :: cldum               ! dummy character variable
  CHARACTER(LEN=256)                        :: cv_msk='tmask'      ! variable for masking

  LOGICAL                                   :: lfull=.FALSE.       ! flag for full step computation
  LOGICAL                                   :: lchk                ! flag for missing files

  ! NETCDF OUTPUT
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage :  cdfheatc  -f T-file [-mxloption option] ...'
     PRINT *,'     [-zoom imin imax jmin jmax kmin kmax] [-full] [-o OUT-file]'
     PRINT *,'     [-M MSK-file VAR-mask ]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'        Computes the heat content in the specified 3D area (Joules)'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -f T-file : name of the input file with temperature (and MLD if needed).'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-zoom imin imax jmin jmax kmin kmax] : limit of a sub domain where'
     PRINT *,'                      the heat content will be calculated.'
     PRINT *,'                   - if imin = 0 then ALL i are taken'
     PRINT *,'                   - if jmin = 0 then ALL j are taken'
     PRINT *,'                   - if kmin = 0 then ALL k are taken'
     PRINT *,'       [-full ] : assume full step model output instead of default'
     PRINT *,'                  partial steps.'
     PRINT *,'       [-mxloption option]: option= 1 : compute only in the mixed layer,'
     PRINT *,'                            option=-1 : exclude mixed layer in the computation'
     PRINT *,'                            option= 0 : [Default], do not take care of mxl.'
     PRINT *,'       [-o OUT-file ] : specify netcdf output filename instead of ',TRIM(cf_out)
     PRINT *,'       [-M MSK-file VAR-mask] : Allow the use of a non standard mask file '
     PRINT *,'              with VAR-mask, instead of ',TRIM(cn_fmsk),' and ',TRIM(cv_msk) 
     PRINT *,'              This option is a usefull alternative to -zoom option, when the '
     PRINT *,'              area of interest is not ''box-like'' '
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       Files ',TRIM(cn_fhgr),', ',TRIM(cn_fzgr),' and ',TRIM(cn_fmsk) 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : heatc.nc unless -o option is used.'
     PRINT *,'              variables: heatc3d (Joules)'
     PRINT *,'                       : heatc(dep) (Joules) '
     PRINT *,'                       : heatc3dpervol (Joules/m3) '
     PRINT *,'       Standard output'
     PRINT *,'       '
     PRINT *,'      SEE ALSO: '
     PRINT *,'          cdfpolymask '
     STOP
  ENDIF

  ijarg = 1 
  DO WHILE ( ijarg <= narg ) 
     CALL getarg ( ijarg, cldum) ; ijarg = ijarg + 1
     SELECT CASE ( cldum )
     CASE ( '-f'    ) ; CALL getarg ( ijarg, cf_tfil) ; ijarg = ijarg + 1
     CASE ( '-full' ) ; lfull = .true.
     CASE ( '-mxloption' ) ; CALL getarg ( ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) mxloption
     CASE ( '-o   ' ) ; CALL getarg ( ijarg, cf_out)    ; ijarg = ijarg + 1 
     CASE ( '-zoom' )   
        CALL getarg ( ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) iimin
        CALL getarg ( ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) iimax
        CALL getarg ( ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) ijmin
        CALL getarg ( ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) ijmax
        CALL getarg ( ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) ikmin
        CALL getarg ( ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) ikmax
     CASE ( '-M' )   
        CALL getarg ( ijarg, cn_fmsk) ; ijarg = ijarg + 1 
        CALL getarg ( ijarg, cv_msk ) ; ijarg = ijarg + 1
     CASE DEFAULT
        PRINT *,' A single argument is considered as a T-file'
        CALL getarg ( ijarg, cf_tfil) ; ijarg = ijarg + 1 
     END SELECT
  END DO

  lchk = chkfile(cn_fhgr)
  lchk = chkfile(cn_fzgr) .OR. lchk
  lchk = chkfile(cn_fmsk) .OR. lchk
  lchk = chkfile(cf_tfil) .OR. lchk
  IF ( lchk ) STOP 99 ! missing files

  npiglo = getdim (cf_tfil,cn_x)
  npjglo = getdim (cf_tfil,cn_y)
  npk    = getdim (cf_tfil,cn_z)
  npt    = getdim (cf_tfil,cn_t)

  npkk=npk

  IF (iimin /= 0 ) THEN ; npiglo = iimax - iimin + 1;  ELSE ; iimin=1 ; ENDIF
  IF (ijmin /= 0 ) THEN ; npjglo = ijmax - ijmin + 1;  ELSE ; ijmin=1 ; ENDIF
  IF (ikmin /= 0 ) THEN ; npkk   = ikmax - ikmin + 1;  ELSE ; ikmin=1 ; ikmax=npk ; ENDIF

  nvpk   = getvdim(cf_tfil,cn_votemper)
  IF (nvpk == 2 ) nvpk = 1
  IF (nvpk == 3 ) nvpk = npkk

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt
  PRINT *, 'nvpk   = ', nvpk

  ! Allocate arrays
  PRINT *, 'Allocate TMASK'
  ALLOCATE ( tmask(npiglo,npjglo))
  PRINT *, 'Allocate temp'
  ALLOCATE ( temp (npiglo,npjglo))
  PRINT *, 'Allocate e1t'
  ALLOCATE ( e1t  (npiglo,npjglo), e2t(npiglo,npjglo), e3t(npiglo,npjglo))

  IF (mxloption /= 0) THEN
      PRINT *, 'Allocate rmxldep'
      ALLOCATE ( rmxldep(npiglo,npjglo))
  ENDIF

  PRINT *, 'Allocate gdepw'
  ALLOCATE ( gdepw(npk), tim(npt))
  IF ( lfull ) ALLOCATE ( e31d(npk))

  e1t(:,:) = getvar(cn_fhgr, cn_ve1t, 1, npiglo, npjglo, kimin=iimin, kjmin=ijmin)
  e2t(:,:) = getvar(cn_fhgr, cn_ve2t, 1, npiglo, npjglo, kimin=iimin, kjmin=ijmin)
  gdepw(:) = getvare3(cn_fzgr, cn_gdepw,  npk)
  tim  (:) = getvare3(cf_tfil, cn_vtimec, npt)
  
  IF ( lfull ) e31d(:) = getvare3(cn_fzgr, cn_ve3t1d, npk)

  CALL CreateOutput

  DO jt=1,npt
     dvol = 0.d0
     dsum = 0.d0
     PRINT * ,'TIME : ', tim(jt)
     IF (mxloption /= 0) rmxldep(:,:) = getvar(cf_tfil, cn_somxldep, 1, npiglo, npjglo, ktime=jt)

     DO jk = 1,nvpk
        ik = jk + ikmin -1
        ! Get temperatures temp at ik
        temp( :,:)   = getvar(cf_tfil, cn_votemper, ik, npiglo, npjglo, kimin=iimin, kjmin=ijmin, ktime=jt)
        tmask(:,:)   = getvar(cn_fmsk, cv_msk,      ik, npiglo, npjglo, kimin=iimin, kjmin=ijmin          )           

        ! get e3t at level ik ( ps...)
        IF ( lfull ) THEN
           e3t(:,:) = e31d(ik)
        ELSE
           e3t(:,:) = getvar(cn_fzgr, 'e3t_ps', ik, npiglo, npjglo, kimin=iimin, kjmin=ijmin, ldiom=.TRUE.)
        ENDIF
        
        SELECT CASE ( mxloption ) 
         CASE ( 1 ) 
            e3t(:,:) = MAX ( 0., MIN( e3t,rmxldep-gdepw(ik) ) )
         CASE ( -1 )
            e3t(:,:) = MIN ( e3t, MAX( 0.,gdepw(ik)+e3t(:,:)-rmxldep ) )
         END SELECT

        dsurf  = sum(e1t * e2t       * tmask)
        dvol2d = sum(e1t * e2t * e3t * tmask)
        dvol   = dvol + dvol2d

        dsum2d = sum(e1t * e2t * e3t * temp * tmask)
        dsum   = dsum + dsum2d

        IF (dvol2d /= 0 )THEN
           PRINT *, ' Heat Content  at level ',ik,'(',gdepw(ik),' m) ',pprho0*ppcp*dsum2d, 'surface = ',dsurf/1.e6,' km^2'
        ELSE
           PRINT *, ' No points in the water at level ',ik,'(',gdepw(ik),' m) '
        ENDIF
        dl_dum(1,1) = pprho0*ppcp*dsum2d
        ierr = putvar(ncout, id_varout(jp_hc2d), dl_dum(:,:),jk, 1, 1, ktime=jt )

     END DO
     
     PRINT * ,' Total Heat content        : ', pprho0*ppcp*dsum ,' Joules'
     PRINT * ,' Total Heat content/volume : ', pprho0*ppcp*dsum/dvol ,' Joules/m3 '
     dl_dum(1,1)=pprho0*ppcp*dsum
     ierr = putvar(ncout, id_varout(jp_hc3d), dl_dum(:,:),1, 1, 1, ktime=jt )
     dl_dum(1,1)=dl_dum(1,1)/dvol
     ierr = putvar(ncout, id_varout(jp_hcvol), dl_dum(:,:),1, 1, 1, ktime=jt )
  END DO
  ierr = closeout(ncout )
CONTAINS
  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create the netcdf outputfile 
    !!
    !!----------------------------------------------------------------------
    ! so far in cdfheatc, only 4 variables willbe output.
    ! indeed 4 scalar but that will be considered as (x,y,t) ie (1,1,t)
    INTEGER(KIND=4) :: ivar=3, ierr
    REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zdumlon, zdumlat
    !!----------------------------------------------------------------------
    ALLOCATE(stypvar(ivar) )
    ALLOCATE(    ipk(ivar), id_varout(ivar) )
    ALLOCATE( zdumlon(1,1), zdumlat(1,1) )
    zdumlon(:,:) = 0.
    zdumlat(:,:) = 0.
    ipk(:)= 1 
    ! define new variables for output 

    stypvar%scale_factor      = 1.
    stypvar%add_offset        = 0.
    stypvar%savelog10         = 0.
    stypvar%conline_operation = 'N/A'
    stypvar%caxis             = 'T'
    stypvar%cprecision        = 'r8'

    stypvar(jp_hc3d)%cname          = 'heatc3d'
    stypvar(jp_hc3d)%cunits         = 'Joules'
    stypvar(jp_hc3d)%clong_name     = 'Total Heat Content'
    stypvar(jp_hc3d)%cshort_name    = 'heatc3d'

    stypvar(jp_hcvol)%cname          = 'heatc3dpervol'
    stypvar(jp_hcvol)%cunits         = 'Joules/m3'
    stypvar(jp_hcvol)%clong_name     = 'Total Heat Content per unit volume'
    stypvar(jp_hcvol)%cshort_name    = 'heatc3dpervol'

    ipk(jp_hc2d) = npkk
    stypvar(jp_hc2d)%cname          = 'heatc2d'
    stypvar(jp_hc2d)%cunits         = 'Joules'
    stypvar(jp_hc2d)%clong_name     = 'Heat Content at each selected level'
    stypvar(jp_hc2d)%cshort_name    = 'heatc2d'

    ncout =  create     (cf_out, 'none',  1,      1, npkk,   cdep='depthw' )
    ierr  = createvar   (ncout,  stypvar, ivar, ipk, id_varout             )
    ierr  = putheadervar(ncout,  cf_tfil, 1,      1, npkk,                 &
                  &         pnavlon=zdumlon, pnavlat=zdumlat,              &
                  &         pdep=gdepw(ikmin:ikmax),                       &
                  &         cdep='depthw'                                  )
    tim(:)= putvar1d(ncout,  tim,       npt, 'T')

    DEALLOCATE( zdumlon, zdumlat)
    
  END SUBROUTINE CreateOutput

END PROGRAM cdfheatc

PROGRAM cdfgeostrophy
  !!======================================================================
  !!                     ***  PROGRAM  cdfgeostrophy  ***
  !!=====================================================================
  !!  ** Purpose : Compute the ug and vg component of the geostrophic 
  !!               velocity from ssh and density field
  !!
  !!  ** Method  : * Integrate pressure from surface to current level
  !!                 P(n) = rho_insitu(1) * g * ssh 
  !!                      + sum( rho_insitu(k) * g * h(k) ) k=1,n-1
  !!                      + rho_insitu(n) * g * h(n) / 2
  !!
  !!                 h = level thickness
  !!
  !!               * Interpolation of Pressure on F points
  !!                 values on F-point are given
  !!                 by the demi-sum of X points (on the diagonal)
  !!
  !!                 p1 = 0.5 * ( A + B )
  !!                 p1 = 0.5 * ( B + C )
  !!                 p1 = 0.5 * ( C + D )
  !!
  !!                 F--------F--------F--------F
  !!                 |        |        |        |
  !!                 |        |   B    |        |
  !!                 |        |        |        |
  !!                 F--------p1--V----p2-------F
  !!                 |        |        |        |
  !!                 |   A    |  Pi,j  U   C    |
  !!                 |        |        |        |
  !!                 F--------F--------p3-------F
  !!                 |        |        |        |
  !!                 |        |   D    |        |
  !!                 |        |        |        |
  !!                 F--------F--------F--------F
  !!
  !!               * Compute local coriolis parameter at U and V point
  !!
  !!                 F--------F1--V----F2-------F
  !!                 |        |        |        |
  !!                 |        |   Pij  U        |
  !!                 |        |        |        |
  !!                 F--------F--------F3-------F
  !!
  !!                 Vg computation : Fij_v = 0.5 * ( F1 + F2 )
  !!                 Ug computation : Fij_u = 0.5 * ( F2 + F3 )
  !!
  !!               * Compute geostrophic balance
  !!
  !!                 Vg(i,j) = +1 * ( 1 / rho0 * Fij_v ) * ( p2 - p1 ) / e1v(i,j)
  !!                 Ug(i,j) = -1 * ( 1 / rho0 * Fij_u ) * ( p2 - p3 ) / e2u(i,j)
  !!               
  !!               * Masking :
  !!
  !!                 - if A,B or C are land points -> Vg = 0
  !!                 - if B,C or D are land points -> Ug = 0
  !!                 - multiplied by umask and vmask
  !!                 - if f < 1e-5, we mask
  !!
  !!  **  Note : Ug is located on a U grid point
  !!             Vg                 V grid point
  !!
  !!
  !! History : 3.0  : 01/2011  : R.Dussin : original code
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE eos
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class derived_fields
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: ji, jj, jt     ! dummy loop index
  INTEGER(KIND=4)                           :: it             ! time index for vvl
  INTEGER(KIND=4)                           :: npiglo, npjglo ! size of the domain
  INTEGER(KIND=4)                           :: npk, npt       ! size of the domain
  INTEGER(KIND=4)                           :: jk             ! vertical index
  INTEGER(KIND=4)                           :: narg, iargc    ! browse line
  INTEGER(KIND=4)                           :: ijarg          ! browse line
  INTEGER(KIND=4)                           :: ncoutu         ! ncid for ugeo file
  INTEGER(KIND=4)                           :: ncoutv         ! ncid for vgeo file
  INTEGER(KIND=4)                           :: ierr           ! error status
  INTEGER(KIND=4), DIMENSION(1)             :: ipk            ! levels of output vars
  INTEGER(KIND=4), DIMENSION(1)             :: id_varoutu     ! varid for ugeo
  INTEGER(KIND=4), DIMENSION(1)             :: id_varoutv     ! varid for vgeo

  REAL(KIND=4)                              :: grav           ! gravity
  REAL(KIND=4)                              :: zhlevel        ! thickness of current level
  REAL(KIND=4)                              :: zhhalflevel    ! thickness of half the current level
  REAL(KIND=4)                              :: zrho0          ! reference density in geos balance
  REAL(KIND=4)                              :: zohr0          ! reference density in geos balance
  REAL(KIND=4)                              :: zffu, zffv     ! local coriolis parameter
  REAL(KIND=4)                              :: zumask, zvmask ! dummy for mask 
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: deptht, depthw
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e1u, e2v, ff   ! horiz metrics, coriolis (f-point)
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e1v, e2u       ! horiz metrics
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e3             ! vertic metrics
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: glamu, gphiu   ! longitude latitude u-point
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: glamv, gphiv   ! longitude latitude v-point
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: umask, vmask   ! mask at u and v points
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: tmask          ! mask at t points
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zt, zsal       ! temporary arrays for temperature and salinity

  REAL(KIND=8)                              :: dp1, dp2, dp3  ! dummy for pressure interp
  REAL(KIND=8), DIMENSION(:),   ALLOCATABLE :: dtim           ! time counter
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: dsigsurf       ! density at first level (used for dpsurf)
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: dsiglevel      ! density at current level (used for dplevel/dphalflevel)
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dun, dvn       ! velocity components
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dsshn          ! ssh
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dpupper        ! total pressure above current level
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dphalflevel    ! pressure at T-point of current level
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dplevel        ! pressure at bottom W-point of current level
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dpsurf         ! pressure due to SSH
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dptot          ! total pressure at current level

  CHARACTER(LEN=256)                        :: cf_tfil        ! input file name
  CHARACTER(LEN=256)                        :: cf_sfil        ! input salinity file (option)
  CHARACTER(LEN=255)                        :: cf_sshfil      ! input SSH file (option)

  CHARACTER(LEN=256)                        :: cf_uout='ugeo.nc' 
  CHARACTER(LEN=256)                        :: cf_vout='vgeo.nc'
  CHARACTER(LEN=256)                        :: cldum          ! working char variable

  TYPE(variable), DIMENSION(1)              :: stypvaru       ! attributes for ugeo
  TYPE(variable), DIMENSION(1)              :: stypvarv       ! attributes for vgeo

  LOGICAL                                   :: lchk           ! file existence flag
  LOGICAL                                   :: lnc4 = .FALSE. ! Use nc4 with chunking and deflation
  LOGICAL                                   :: lssh = .TRUE.  ! Use ssh data . If false, assume ssh=0 everywhere
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  grav  = 9.81  ! m/s2   gravity
  zrho0 = 1025  ! kg/m3  reference density
  zohr0 = 1. / zrho0

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfgeostrophy -t T-file [-s S-file] [--ssh-file SSH-file] ...'
     PRINT *,'                   ...  [-o OUT-ufile OUT-vfile] [-nc4] [-vvl]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the geostrophic velocity components from the pressure gradient'
     PRINT *,'       induced by SSH and in-situ density (T,S of input file), using the '
     PRINT *,'       thermal wind equation.'
     PRINT *,'      '
     PRINT *,'     WARNING : USE AT YOUR OWN RISKS. '
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -t T-file : netcdf file with SSH, Temperature and Salinity.' 
     PRINT *,'         If salinity not in T-file use -s option.'
     PRINT *,'         If ssh not in T-file use --ssh-file option. (If ssh file is ''NA'''
     PRINT *,'         SSH is set to 0).'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-s S-file ] : Specify the salinity file if not T-file.'
     PRINT *,'       [--ssh-file SSH-file] : specify the ssh file if not in T-file. If'
     PRINT *,'                    SSH-file=''NA'' (not available), ssh is set to 0.'
     PRINT *,'       [-o OUT-ufile OUT-vfile] : Specify output files name''s  instead of '
     PRINT *,'            ',TRIM(cf_uout),' and ', TRIM(cf_vout)
     PRINT *,'       [-nc4 ]:  Use netcdf4 output with chunking and deflation level 1.'
     PRINT *,'                 This option is effective only if cdftools are compiled with'
     PRINT *,'                 a netcdf library supporting chunking and deflation.'
     PRINT *,'       [-vvl] : use time varying vertical metrics.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        ',TRIM(cn_fmsk),' ',TRIM(cn_fhgr),' and ',TRIM(cn_fzgr)
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       - netcdf file : ', TRIM(cf_uout) 
     PRINT *,'           variables : ', TRIM(cn_vozocrtx)
     PRINT *,'       - netcdf file : ', TRIM(cf_vout) 
     PRINT *,'           variables : ', TRIM(cn_vomecrty)
     PRINT *,'      '
     STOP 
  ENDIF

  ijarg=1
  cf_sfil   = 'none'
  cf_sshfil = 'none'
  DO WHILE (ijarg <= narg ) 
     CALL getarg(ijarg, cldum) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ('-t','-f'   ); CALL getarg(ijarg, cf_tfil) ; ijarg=ijarg+1
        ! option
     CASE ( '-s '      ) ; CALL getarg(ijarg, cf_sfil) ; ijarg=ijarg+1
     CASE ('--ssh-file') ; CALL getarg(ijarg, cf_sshfil);ijarg=ijarg+1
        ;   IF ( cf_sshfil == 'NA' ) lssh=.false.
     CASE ( '-o '      ) ; CALL getarg(ijarg, cf_uout) ; ijarg=ijarg+1
        ;                  CALL getarg(ijarg, cf_vout) ; ijarg=ijarg+1
     CASE ( '-nc4'     ) ; lnc4   = .TRUE.
     CASE ( '-vvl'     ) ; lg_vvl = .TRUE.
     CASE DEFAULT        ; PRINT *,' ERROR : ', TRIM(cldum), ' : unknown option.' ; STOP 99
     END SELECT
  ENDDO

  IF ( cf_sfil   == 'none' ) cf_sfil   = cf_tfil
  IF ( cf_sshfil == 'none' ) cf_sshfil = cf_tfil

  lchk = chkfile(cn_fhgr  )
  lchk = chkfile(cn_fzgr  ) .OR. lchk
  lchk = chkfile(cn_fmsk  ) .OR. lchk
  lchk = chkfile(cf_tfil  ) .OR. lchk
  lchk = chkfile(cf_sfil  ) .OR. lchk
  IF ( lssh )   lchk = chkfile(cf_sshfil) .OR. lchk
  IF ( lchk ) STOP 99 ! missing file

  IF ( lg_vvl ) THEN
     cn_fe3t = cf_tfil
     cn_ve3t = cn_ve3tvvl
  ENDIF

  npiglo = getdim(cf_tfil, cn_x)
  npjglo = getdim(cf_tfil, cn_y)
  npk    = getdim(cf_tfil, cn_z) 
  npt    = getdim(cf_tfil, cn_t) 

  PRINT *, 'npiglo =', npiglo
  PRINT *, 'npjglo =', npjglo
  PRINT *, 'npk =', npk

  ! Allocate the memory
  ALLOCATE ( e1v(npiglo,npjglo), e2u(npiglo,npjglo) )
  ALLOCATE ( ff(npiglo,npjglo) )
  ALLOCATE ( glamu(npiglo,npjglo), gphiu(npiglo,npjglo)  )
  ALLOCATE ( glamv(npiglo,npjglo), gphiv(npiglo,npjglo)  )
  ALLOCATE ( dun(npiglo,npjglo),     dvn(npiglo,npjglo)  )
  ALLOCATE ( dsshn(npiglo,npjglo) )
  ALLOCATE ( umask(npiglo,npjglo),  vmask(npiglo,npjglo) )
  ALLOCATE ( tmask(npiglo,npjglo) )
  ALLOCATE ( dpupper(npiglo,npjglo),      dpsurf(npiglo,npjglo) )
  ALLOCATE ( dphalflevel(npiglo,npjglo), dplevel(npiglo,npjglo) )
  ALLOCATE ( dptot(npiglo,npjglo) )
  ALLOCATE ( zt(npiglo,npjglo), zsal(npiglo,npjglo) )
  ALLOCATE ( deptht(npk), depthw(npk) )
  ALLOCATE ( dsigsurf(npiglo,npjglo) , dsiglevel(npiglo,npjglo) )
  ALLOCATE ( e3(npiglo,npjglo) )
  ALLOCATE ( dtim(npt) )

  ! Read the metrics from the mesh_hgr file
  e2u   = getvar(cn_fhgr, cn_ve2u,  1, npiglo, npjglo)
  e1v   = getvar(cn_fhgr, cn_ve1v,  1, npiglo, npjglo)
  ff    = getvar(cn_fhgr, cn_vff,   1, npiglo, npjglo) 

  glamu = getvar(cn_fhgr, cn_glamu, 1, npiglo, npjglo)
  gphiu = getvar(cn_fhgr, cn_gphiu, 1, npiglo, npjglo)
  glamv = getvar(cn_fhgr, cn_glamv, 1, npiglo, npjglo)
  gphiv = getvar(cn_fhgr, cn_gphiv, 1, npiglo, npjglo)

  deptht(:) = getvar1d(cf_tfil, cn_vdeptht, npk    )

  CALL CreateOutputUV

  ! time loop
  DO jt=1,npt
     IF ( lg_vvl ) THEN  ; it=jt
     ELSE                ; it=1
     ENDIF

     ! Read ssh
     IF ( lssh) THEN
        dsshn = getvar(cf_sshfil, cn_sossheig, 1, npiglo, npjglo, ktime=jt)*1.d0
     ELSE
        dsshn = 0.d0
     ENDIF
     ! Read temperature and salinity
     zt    = getvar(cf_tfil, cn_votemper,   1, npiglo, npjglo, ktime=jt)
     zsal  = getvar(cf_sfil, cn_vosaline,   1, npiglo, npjglo, ktime=jt)
     ! Compute density at first level
     dsigsurf(:,:) = 1000.d0 + sigmai ( zt,zsal,deptht(1),npiglo,npjglo )
     ! Compute psurf (pressure due to SSH)
     dpsurf(:,:)  = dsigsurf * grav * dsshn
     dpupper(:,:) = 0.d0

     DO jk=1,npk
        tmask = getvar(cn_fmsk, cn_tmask,  jk, npiglo, npjglo)
        umask = getvar(cn_fmsk, cn_umask,  jk, npiglo, npjglo)
        vmask = getvar(cn_fmsk, cn_vmask,  jk, npiglo, npjglo)

        PRINT *,'Working on level ', jk
        !! 1. First we compute integrated pressure from the surface to current level

        ! Thickness
        e3(:,:)  = getvar(cn_fe3t, cn_ve3t, jk, npiglo, npjglo, ktime=it, ldiom=.NOT.lg_vvl )
        ! MAXVAL is used to avoid partial steps 
        ! JMM : this is probably not valid for vvl ...
        zhlevel     = MAXVAL(e3)
        zhhalflevel = 0.5 * MAXVAL(e3)
        ! 
        ! Read temperature and salinity at current level
        zt   = getvar(cf_tfil, cn_votemper, jk, npiglo, npjglo, ktime=jt)
        zsal = getvar(cf_sfil, cn_vosaline, jk, npiglo, npjglo, ktime=jt)
        ! Compute density of this level
        dsiglevel(:,:) = 1000.d0 + sigmai ( zt,zsal,deptht(jk),npiglo,npjglo )
        ! Compute the pressure at T-point 
        dphalflevel(:,:) = dsiglevel * grav * zhhalflevel
        ! Compute the pressure at bottom W-point
        dplevel(:,:) =  dsiglevel * grav * zhlevel
        ! Compute the total pression -> This one is used in the geostrophic balance !
        dptot(:,:) = dpsurf(:,:) + dpupper(:,:) + dphalflevel(:,:)
        ! update dpupper for next level
        dpupper(:,:) = dpupper(:,:) + dplevel(:,:)

        !! 2. We compute the velocities from geostrophic balance
        dun(:,:) = 0.d0
        dvn(:,:) = 0.d0

        DO jj=2,npjglo-1
           DO ji=2,npiglo-1

              ! local coriolis parameter
              zffu = 0.5 * ( ff(ji,jj) + ff(ji,jj-1) )
              zffv = 0.5 * ( ff(ji,jj) + ff(ji-1,jj) )

              ! interp on F points 
              dp1 = 0.5 * ( dptot(ji-1,jj) + dptot(ji,jj+1) ) 
              dp2 = 0.5 * ( dptot(ji+1,jj) + dptot(ji,jj+1) )
              dp3 = 0.5 * ( dptot(ji,jj-1) + dptot(ji+1,jj) )

              zumask = tmask(ji,jj-1) * tmask(ji+1,jj) * tmask(ji,jj+1)
              zvmask = tmask(ji-1,jj) * tmask(ji,jj+1) * tmask(ji+1,jj)

              ! geostrophic balance
              dvn(ji,jj) = +1 * ( zohr0 / zffv ) * ( dp2 - dp1 ) / e1v(ji,jj)
              dun(ji,jj) = -1 * ( zohr0 / zffu ) * ( dp2 - dp3 ) / e2u(ji,jj)

              dvn(ji,jj) = dvn(ji,jj) * zvmask
              dun(ji,jj) = dun(ji,jj) * zumask

           ENDDO
        ENDDO

        WHERE ( ABS(ff) < 1.e-5 ) dun(:,:) = 0.d0
        WHERE ( ABS(ff) < 1.e-5 ) dvn(:,:) = 0.d0

        dun(:,:) = dun(:,:) * umask(:,:)
        dvn(:,:) = dvn(:,:) * vmask(:,:)

        ! write dun and dvn  ...
        ierr = putvar(ncoutu, id_varoutu(1), dun(:,:), jk, npiglo, npjglo, ktime=jt)
        ierr = putvar(ncoutv, id_varoutv(1), dvn(:,:), jk, npiglo, npjglo, ktime=jt)
     ENDDO ! vertical loop
  END DO  ! time loop

  ierr = closeout(ncoutu)
  ierr = closeout(ncoutv)

CONTAINS

  SUBROUTINE CreateOutputUV
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutputUV  ***
    !!
    !! ** Purpose :  Create netcdf output file(s)  ugeo and vgeo
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    ipk(1)                        = npk
    stypvaru(1)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvaru(1)%cname             = TRIM(cn_vozocrtx)
    stypvaru(1)%cunits            = 'm/s'
    stypvaru(1)%rmissing_value    = 0.
    stypvaru(1)%valid_min         = -20.
    stypvaru(1)%valid_max         = 20.
    stypvaru(1)%clong_name        = 'Zonal_Geostrophic_Velocity'
    stypvaru(1)%cshort_name       = TRIM(cn_vozocrtx)
    stypvaru(1)%conline_operation = 'N/A'
    stypvaru(1)%caxis             = 'TZYX'

    stypvarv(1)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvarv(1)%cname             = TRIM(cn_vomecrty)
    stypvarv(1)%cunits            = 'm/s'
    stypvarv(1)%rmissing_value    = 0.
    stypvarv(1)%valid_min         = -20.
    stypvarv(1)%valid_max         = 20.
    stypvarv(1)%clong_name        = 'Meridional_Geostrophic_Velocity'
    stypvarv(1)%cshort_name       = TRIM(cn_vomecrty)
    stypvarv(1)%conline_operation = 'N/A'
    stypvarv(1)%caxis             = 'TZYX'

    ! create output filesets
    ! U geo  
    ncoutu = create      (cf_uout, cf_tfil,  npiglo, npjglo, npk        , ld_nc4=lnc4         )
    ierr   = createvar   (ncoutu,  stypvaru, 1,      ipk,    id_varoutu , ld_nc4=lnc4         )
    ierr   = putheadervar(ncoutu,  cf_tfil,  npiglo, npjglo, npk, pnavlon=glamu, pnavlat=gphiu)

    dtim = getvar1d(cf_tfil, cn_vtimec, npt     )
    ierr = putvar1d(ncoutu,  dtim,      npt, 'T')

    ! V geo 
    ncoutv = create      (cf_vout, cf_tfil,  npiglo, npjglo, npk        , ld_nc4=lnc4         )
    ierr   = createvar   (ncoutv,  stypvarv, 1,      ipk,    id_varoutv , ld_nc4=lnc4         )
    ierr   = putheadervar(ncoutv,  cf_tfil,  npiglo, npjglo, npk, pnavlon=glamv, pnavlat=gphiv)

    dtim = getvar1d(cf_tfil, cn_vtimec, npt     )
    ierr = putvar1d(ncoutv, dtim,       npt, 'T')

  END SUBROUTINE CreateOutputUV

END PROGRAM cdfgeostrophy

PROGRAM cdfcofpoint
  !!-------------------------------------------------------------------
  !!               ***  PROGRAM cdfmean  ***
  !!
  !!  **  Purpose  :  Compute distance of first coast in grid point
  !!                  Determine the edge of a mask (for further use
  !!                  with iceshelf parametrization)
  !!  
  !!  **  Method   :  long iterative method (check furtehr time all mask point)
  !!
  !!
  !! history ;
  !!  Original :  P. Mathiot (June, 2009)
  !!-------------------------------------------------------------------
  !! * Modules used
  USE cdfio
  !! * Local variables
  IMPLICIT NONE
  INTEGER   :: npiglo, npjglo, npk, nt, npi, npj      !: size of the domain
  INTEGER   :: ji, jj, jk, jt, i
  INTEGER   :: imin=0, imax=0, jmin=0, jmax=0      !: domain limitation for computation
  INTEGER   :: kmin=0, kmax=0                      !: domain limitation for computation
  INTEGER   :: narg, iargc                         !: command line 


  REAL(KIND=4), DIMENSION (:,:),   ALLOCATABLE ::  zmask, mask, mask_out  !: npiglo x npjglo

  CHARACTER(LEN=256) :: cfile, cldum
  CHARACTER(LEN=256) :: cmask='mask.nc'

  ! output stuff
  INTEGER, DIMENSION(1) :: ipk, id_varout
  TYPE(variable), DIMENSION(1) :: stypvar
  REAL(KIND=4) ,DIMENSION(1)                  :: timean
  CHARACTER(LEN=256) :: cfileout='pointcoast.nc'
  INTEGER :: ncout, ierr

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' Usage : cdfmean  filemask [imin imax jmin jmax kmin kmax] '
     PRINT *,' imin imax jmin jmax kmin kmax can be given in option '
     PRINT *,'    if imin = 0 then ALL i are taken'
     PRINT *,'    if jmin = 0 then ALL j are taken'
     PRINT *,'    if kmin = 0 then ALL k are taken'
     PRINT *,'    output file is pointcoast.nc    '
     STOP
  ENDIF

  CALL getarg (1, cfile)

  npi= getdim (cfile,'x')
  npj= getdim (cfile,'y')
  npk   = getdim (cfile,'depth')
  nt    = getdim (cfile,'time')
  
  imin=1; jmin=1; jmax=npj; imax=npi

  IF (narg > 3 ) THEN
    IF ( narg /= 5 ) THEN
       PRINT *, ' ERROR : You must give 6 optional values (imin imax jmin jmax kmin kmax)'
       STOP
    ELSE
    ! input optional imin imax jmin jmax
      CALL getarg ( 2,cldum) ; READ(cldum,*) imin
      CALL getarg ( 3,cldum) ; READ(cldum,*) imax
      CALL getarg ( 4,cldum) ; READ(cldum,*) jmin
      CALL getarg ( 5,cldum) ; READ(cldum,*) jmax
    ENDIF
  ENDIF

  IF (npk == 0  ) THEN ; npk = 1              ; ENDIF  ! no depth dimension ==> 1 level
  IF (imin /= 0 ) THEN ; npiglo=imax -imin + 1;  ELSE ; imin=1 ; ENDIF
  IF (jmin /= 0 ) THEN ; npjglo=jmax -jmin + 1;  ELSE ; jmin=1 ; ENDIF
  IF (kmin /= 0 ) THEN ; npk   =kmax -kmin + 1;  ELSE ; kmin=1 ; ENDIF

  WRITE(6, *) 'npiglo=', npiglo
  WRITE(6, *) 'npjglo=', npjglo
  WRITE(6, *) 'npi   =', npi
  WRITE(6, *) 'npj   =', npj
  WRITE (6,*) 'npk   =', npk
  WRITE (6,*) 'nt    =', nt
  
  ! Allocate arrays
  ALLOCATE ( zmask(npi,npj), mask_out(npi,npj), mask(npi,npj) )
  mask_out(:,:)=0
  mask(:,:)= getvar(cfile, 'tmask',  1 ,npi,npj)
  i=0
  DO WHILE ( SUM(mask(imin+1:imax-1,jmin+1:jmax-1)) .NE. 0 )
     i=i+1
     zmask=0
     IF (MOD(i,10)==0) PRINT *, 'i = ',i, ' SUM(mask) = ',SUM(mask(imin+1:imax-1,jmin+1:jmax-1)) 
     DO ji=imin+1,imax-1
        DO jj=jmin+1,jmax-1
           IF ((mask(ji,jj)==0) .AND. (mask_out(ji,jj)==i-1)) THEN
              IF (mask(ji+1,jj  )==1) zmask(ji+1,jj  )=1
              IF (mask(ji  ,jj-1)==1) zmask(ji  ,jj-1)=1
              IF (mask(ji-1,jj  )==1) zmask(ji-1,jj  )=1
              IF (mask(ji  ,jj+1)==1) zmask(ji  ,jj+1)=1
           END IF
        END DO
     END DO
     WHERE (zmask==1) mask=0
     WHERE (zmask==1) mask_out=i
  END DO
        
  ! prepare file output
  ipk(1) = 1
  stypvar(1)%cname='pointcoast'
  stypvar(1)%cunits='px'
  stypvar(1)%rmissing_value=0
  stypvar(1)%valid_min= 1.
  stypvar(1)%valid_max= i
  stypvar(1)%clong_name='pointcoast'
  stypvar(1)%cshort_name='pointcoast'
  stypvar(1)%conline_operation='N/A'
  stypvar(1)%caxis='TZYX'
  stypvar(1)%cprecision='r4'
  PRINT *,' CREATE ...'
  ncout=create(cfileout, cfile,npi,npj,1)

  PRINT *,' CREATEVAR ...'
  ierr= createvar(ncout ,stypvar,1, ipk,id_varout )
  PRINT *,' PUTHEADERVAR ...'
  ierr= putheadervar(ncout, cfile, npi,npj,npk)
  ierr=putvar(ncout,id_varout(1),mask_out,1,npi,npj)
  timean(:)=0.
  ierr=putvar1d(ncout,timean,1,'T')
  ierr = closeout(ncout)

END PROGRAM cdfcofpoint

PROGRAM cdfpvor
  !!======================================================================
  !!                     ***  PROGRAM  cdfpvor  ***
  !!=====================================================================
  !!  ** Purpose : Compute the Ertel Potential vorticity
  !!
  !!  ** Method  : Formula :
  !!      Qpot = drho/dz * ( f + xsi ) = Qstr + Qrel
  !!      * f is the Coriolis factor, computed from the latitudes of the T-grid :
  !!        f(i,j) = 2 * omega * sin ( phit(i,j) * pi / 180 )
  !!
  !!      * xsi is the relative vorticity (vertical component of the velocity curl),
  !!        computed from the relative vorticity of the F-points interpolated at
  !!        the T-points :
  !!        xsif(i,j) = ( ue(i,j) - ue(i,j+1) - ve(i,j) + ve(i+1,j) ) / areaf(i,j)
  !!         with : ue(i,j) = U(i,j) * e1u(i,j)
  !!                ve(i,j) = V(i,j) * e2v(i,j)
  !!             areaf(i,j) = e1f(i,j) * e2f(i,j)
  !!        xsi(i,j) = ( xsif(i-1,j-1) + xsif(i-1,j) + xsif(i,j-1) + xsif(i,j) ) / 4
  !!                 = (  ue(i-1,j-1) + ue(i,j-1) - ue(i-1,j+1) - ue(i,j+1)
  !!                    - ve(i-1,j-1) - ve(i-1,j) + ve(i+1,j-1) + ve(i+1,j) )
  !!                    / 4 / areat(i,j)
  !!        with : areat(i,j) = e1t(i,j) * e2t(i,j)
  !!        units : U, V in m.s-1
  !!           e1u, e2v, e1f, e2f in m
  !!           f, xsi in s-1
  !!           Qpot, Qrel, Qstr in kg.m-4.s-1
  !!
  !! History : 2.1  : 12/2005  : A.M. Treguier : Original code
  !!           3.0  : 05/2011  : J.M. Molines  : Doctor norm + Lic., merge with cdfpv
  !!-------------------------------------------------------------------
  USE cdfio
  USE eos
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                             :: jk, jj, ji, jt       ! dummy loop index
  INTEGER(KIND=4)                             :: ierr                 ! working integer
  INTEGER(KIND=4)                             :: narg, iargc          ! command line
  INTEGER(KIND=4)                             :: ijarg, ireq          ! command line
  INTEGER(KIND=4)                             :: npiglo, npjglo       ! size of the domain
  INTEGER(KIND=4)                             :: npk, npt             ! size of the domain
  INTEGER(KIND=4)                             :: iup=1, idown=2, itmp ! working interger
  INTEGER(KIND=4)                             :: ncout                ! ncid for output file
  INTEGER(KIND=4)                             :: nvar=3               ! number of output variable
  INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE  :: ipk, id_varout       ! output variable id's

  REAL(KIND=4), DIMENSION(:,:,:), ALLOCATABLE :: ztemp, zsal, zwk     ! array to ead 2 layer of data
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: zn2                  ! Brunt Vaissala frequency
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: tmask                ! tmask from salinity
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: e3w                  ! vertical metric
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: e1u, e2v             ! horizontal metric
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: e1t, e2t             ! horizontal metric at T point
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: gphit                ! latitude of t point
  REAL(KIND=4), DIMENSION(:),     ALLOCATABLE :: gdepw                ! deptht
  REAL(KIND=4), DIMENSION(:),     ALLOCATABLE :: tim                  ! time counter
  REAL(KIND=4), DIMENSION(:),     ALLOCATABLE :: e31d                 ! metric for full step
  REAL(KIND=4)                                :: zpi, zomega, rau0sg  ! physical constant

  REAL(KIND=8), DIMENSION(:,:),   ALLOCATABLE :: dun, dvn             ! velocity component and flx
  REAL(KIND=8), DIMENSION(:,:),   ALLOCATABLE :: drotn                ! curl of the velocity
  REAL(KIND=8), DIMENSION(:,:),   ALLOCATABLE :: d2fcor               ! coriolis term at T point
  REAL(KIND=8), DIMENSION(:,:),   ALLOCATABLE :: dstretch             ! stretching vorticity
  REAL(KIND=8), DIMENSION(:,:),   ALLOCATABLE :: dareat               ! area of T cells

  CHARACTER(LEN=256)                          :: cf_tfil              ! input T file
  CHARACTER(LEN=256)                          :: cf_ufil              ! input U file
  CHARACTER(LEN=256)                          :: cf_vfil              ! input V file
  CHARACTER(LEN=256)                          :: cf_out='pvor.nc'     ! output file
  CHARACTER(LEN=256)                          :: cldum                ! dummy character variable

  TYPE(variable), DIMENSION(:), ALLOCATABLE   :: stypvar              ! structure for attribute

  LOGICAL                                     :: lfull  = .FALSE.     ! flag for full step
  LOGICAL                                     :: lertel = .TRUE.      ! flag for large scale pv
  LOGICAL                                     :: lchk   = .FALSE.     ! flag for missing files
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg < 2 ) THEN
     PRINT *,' usage : cdfpvor T-file  U-file V-file [-full] [-lspv ]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the Ertel potential vorticity and save the relative  ' 
     PRINT *,'       vorticity, the stretching and the total potential vorticity. '
     PRINT *,'       Qtot = ( f + xsi ) . D(rho)/D(z)  = Qstrech + Qrel           '
     PRINT *,'       With -lspv option, compute only Qstretch or Large Scale P V '
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       T-file : netcdf file for temperature and salinity.           ' 
     PRINT *,'       U-file : netcdf file for zonal component of the velocity.    '
     PRINT *,'       V-file : netcdf file for meridional component of the velocity.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-full ] : indicate a full step configuration.                ' 
     PRINT *,'       [-lspv ] : calculate only the large scale potential vorticity.'
     PRINT *,'                  ( replace the old cdflspv tool).'
     PRINT *,'                  If used only T-file is required, no need for velocities.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ', TRIM(cn_fhgr),' and ',TRIM(cn_fzgr)
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : vorelvor (kg.m-4.s-1 ) relative vorticity'
     PRINT *,'                     vostrvor (kg.m-4.s-1 ) stretching vorticity'
     PRINT *,'                     vototvor (kg.m-4.s-1 ) total potential vorticity'
     PRINT *,'                  Ertel PV are located at T points.'
     PRINT *,'           '
     PRINT *,'       With option -lspv :'
     PRINT *,'       netcdf file : lspv.nc'
     PRINT *,'         variables :  volspv  (kg.m-4.s-1 ) large scale potential vorticity'
     PRINT *,'                  LSPV is  located at W points.'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'       cdfcurl ( compute only the curl on 1 level)'
     PRINT *,'      '
     STOP
  ENDIF

  ijarg = 1  ; ireq = 0
  DO WHILE ( ijarg <= narg )
     CALL getarg( ijarg, cldum ) ; ijarg = ijarg + 1

     SELECT CASE ( cldum )
     CASE ( '-full' ) ; lfull  = .TRUE.
     CASE ( '-lspv' ) ; lertel = .FALSE. ; nvar = 1 ; cf_out = 'lspv.nc'
     CASE DEFAULT
        ireq=ireq+1
        SELECT CASE ( ireq )
        CASE ( 1 ) ; cf_tfil = cldum
        CASE ( 2 ) ; cf_ufil = cldum
        CASE ( 3 ) ; cf_vfil = cldum
        CASE DEFAULT
           PRINT *,' Too many arguments '; STOP
        END SELECT
     END SELECT
  END DO

  lchk = lchk .OR. chkfile( cn_fzgr)
  lchk = lchk .OR. chkfile( cn_fhgr)
  lchk = lchk .OR. chkfile( cf_tfil)
  IF ( lertel ) THEN
     lchk = lchk .OR. chkfile( cf_ufil)
     lchk = lchk .OR. chkfile( cf_vfil)
  ENDIF
  IF ( lchk ) STOP ! missing file

  npiglo = getdim (cf_tfil, cn_x)
  npjglo = getdim (cf_tfil, cn_y)
  npk    = getdim (cf_tfil, cn_z)
  npt    = getdim (cf_tfil, cn_t)

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  ALLOCATE ( e1u(npiglo,npjglo),   e1t(npiglo,npjglo)     )
  ALLOCATE ( e2v(npiglo,npjglo),   e2t(npiglo,npjglo)     )
  ALLOCATE ( gphit(npiglo,npjglo), d2fcor(npiglo,npjglo)  )
  ALLOCATE ( tmask(npiglo,npjglo)                         )
  ALLOCATE ( gdepw(npk), tim(npt)                         )

  ALLOCATE ( dstretch(npiglo,npjglo)                      )
  IF ( lertel ) THEN
     ALLOCATE ( dareat(npiglo,npjglo)                     )
     ALLOCATE ( dun(npiglo,npjglo),    dvn(npiglo,npjglo) )
     ALLOCATE ( drotn(npiglo,npjglo)                      )
  ENDIF
  IF ( lfull ) ALLOCATE ( e31d(npk)                       )

  e1u   = getvar(cn_fhgr, cn_ve1u,  1, npiglo, npjglo)
  e1t   = getvar(cn_fhgr, cn_ve1t,  1, npiglo, npjglo)
  e2v   = getvar(cn_fhgr, cn_ve2v,  1, npiglo, npjglo)
  e2t   = getvar(cn_fhgr, cn_ve2t,  1, npiglo, npjglo)
  gphit = getvar(cn_fhgr, cn_gphit, 1, npiglo, npjglo)

  rau0sg      = 1020./9.81
  zpi         = ACOS(-1.)
  zomega      = 2.0  * zpi /(3600*24)
  d2fcor(:,:) = 2.d0 * zomega * SIN(gphit(:,:)*zpi/180.0)
  dareat(:,:) = 4.d0 * e1t(:,:) * e2t(:,:)  ! factor of 4 to normalize relative vorticity

  gdepw(:) = getvare3(cn_fzgr, cn_gdepw, npk)

  ALLOCATE (ztemp(npiglo,npjglo,2), zsal(npiglo,npjglo,2)) 
  ALLOCATE (zwk(npiglo,npjglo,2)                         )
  ALLOCATE (zn2(npiglo,npjglo) ,    e3w(npiglo,npjglo)   )
  ALLOCATE ( stypvar(nvar), ipk(nvar), id_varout(nvar)   )

  ! create output fileset

  ipk(:)= npk                   ! Those three variables are  3D
  stypvar%cunits            = 'kg.m-4.s-1'
  stypvar%rmissing_value    = 0.
  stypvar%valid_min         = -1000.
  stypvar%valid_max         = 1000.
  stypvar%conline_operation = 'N/A'
  stypvar%caxis             = 'TZYX'

  IF (lertel ) THEN
     ! define variable name and attribute
     stypvar(1)%cname = 'vorelvor' ; stypvar(1)%clong_name = 'Relative_component_of_Ertel_PV'
     stypvar(2)%cname = 'vostrvor' ; stypvar(2)%clong_name = 'Stretching_component_of_Ertel_PV'
     stypvar(3)%cname = 'vototvor' ; stypvar(3)%clong_name = 'Ertel_potential_vorticity'

     stypvar(1)%cshort_name = 'vorelvor'
     stypvar(2)%cshort_name = 'vostrvor'
     stypvar(3)%cshort_name = 'vototvor'

     ncout = create      (cf_out, cf_tfil, npiglo, npjglo, npk       )
     ierr  = createvar   (ncout,  stypvar, nvar,   ipk,    id_varout )
     ierr  = putheadervar(ncout,  cf_tfil, npiglo, npjglo, npk       )
  ELSE
     stypvar(1)%cname = 'volspv' ; stypvar(1)%clong_name = 'Large Scale Potential_vorticity'
     stypvar(1)%cshort_name = 'volspv'
     ncout = create      (cf_out, cf_tfil, npiglo, npjglo, npk, cdep=TRIM(cn_vdepthw) )
     ierr  = createvar   (ncout,  stypvar, nvar,   ipk,    id_varout                  )
     ierr  = putheadervar(ncout,  cf_tfil, npiglo, npjglo, npk, pdep=gdepw            )
  ENDIF

  IF ( lfull ) e31d = getvare3( cn_fzgr, cn_ve3w, npk )

  tim  = getvar1d(cf_ufil, cn_vtimec, npt      )
  ierr = putvar1d(ncout,   tim,       npt, 'T' )

  DO jt=1,npt
     !  2 levels of T and S are required : iup,idown (with respect to W level)
     !  Compute from bottom to top (for vertical integration)
     PRINT *,'time=',jt,'(days:',tim(jt)/86400.,')'
     ztemp(:,:,idown) = getvar(cf_tfil, cn_votemper, npk-1, npiglo, npjglo, ktime=jt)
     zsal( :,:,idown) = getvar(cf_tfil, cn_vosaline, npk-1, npiglo, npjglo, ktime=jt)

     ! -------------------------------- LOOP OVER LEVELS
     DO jk = npk-1, 1, -1 
        PRINT *,'            level ',jk
        IF ( lertel ) THEN 
           ! ------------------------------------RELATIVE VORTICITY FIRST
           dun(:,:) = getvar(cf_ufil, cn_vozocrtx, jk ,npiglo, npjglo, ktime=jt)
           dvn(:,:) = getvar(cf_vfil, cn_vomecrty, jk ,npiglo, npjglo, ktime=jt)
           dun(:,:) = dun(:,:)*e1u(:,:)
           dvn(:,:) = dvn(:,:)*e2v(:,:)
           !     relative vorticity at T point
           drotn(:,:) = 0.d0
           DO jj = 2, npjglo -1 
              DO ji = 2, npiglo -1    
                 drotn(ji,jj) = ( dun(ji-1,jj-1)  + dun(ji,jj-1)  &
                      &        -dun(ji-1,jj+1)  - dun(ji,jj+1)  &
                      &        -dvn(ji-1,jj-1)  - dvn(ji-1,jj)  &
                      &        +dvn(ji+1,jj-1)  + dvn(ji+1,jj)) &
                      / dareat(ji,jj) 
              END DO
           END DO
        ENDIF

        !  now  tmask and Vaisala Frequency bn2
        IF ( jk > 1) THEN 
           tmask(:,:)=1.
           ztemp(:,:,iup) = getvar(cf_tfil, cn_votemper, jk-1 ,npiglo, npjglo, ktime=jt)
           zsal(:,:,iup)  = getvar(cf_tfil, cn_vosaline, jk-1 ,npiglo, npjglo, ktime=jt)
           WHERE(zsal(:,:,idown) == 0 ) tmask = 0
           IF ( lfull ) THEN
              e3w(:,:) = e31d(jk)
           ELSE
              e3w(:,:) = getvar(cn_fzgr, 'e3w_ps', jk, npiglo, npjglo ,ldiom=.TRUE.)
           ENDIF

           WHERE (e3w == 0 ) e3w = 1.

           zwk(:,:,iup) = eosbn2 ( ztemp, zsal, gdepw(jk), e3w, npiglo, npjglo ,iup, idown)* tmask(:,:)
           !
           IF ( lertel ) THEN ! put zn2 at T level (k )
              WHERE ( zwk(:,:,idown) == 0 ) 
                 zn2(:,:) =  zwk(:,:,iup)
              ELSEWHERE
                 zn2(:,:) = 0.5 * ( zwk(:,:,iup) + zwk(:,:,idown) ) * tmask(:,:)
              END WHERE
           ELSE               ! keep bn2 at w points
              zn2(:,:) = zwk(:,:,iup) * tmask(:,:)
           ENDIF
        ENDIF
        !
        !   now rotn will be converted to relative vorticity and zn2 to stretching
        dstretch(:,:) = d2fcor(:,:)* rau0sg * zn2(:,:)

        IF ( lertel ) THEN
           drotn(:,:)    = drotn(:,:) * rau0sg * zn2(:,:)
           ! write the three variables on file at level k
           ierr = putvar(ncout, id_varout(1), REAL( drotn          )*1.e7, jk, npiglo, npjglo, ktime=jt)
           ierr = putvar(ncout, id_varout(2), REAL( dstretch       )*1.e7, jk, npiglo, npjglo, ktime=jt)
           ierr = putvar(ncout, id_varout(3), REAL((drotn+dstretch))*1.e7, jk, npiglo, npjglo, ktime=jt)
        ELSE
           ! save absolute value of dstretch, as in olf cdflspv
           ierr = putvar(ncout, id_varout(1), REAL( ABS(dstretch)  )*1.e7, jk, npiglo, npjglo, ktime=jt)
        ENDIF

        itmp = idown ; idown = iup ; iup = itmp

     END DO  ! loop to next level

     !  set zero at bottom and surface
     zwk(:,:,1) = 0.e0
     ierr = putvar(ncout, id_varout(1), zwk(:,:,1), 1,   npiglo, npjglo, ktime=jt)
     ierr = putvar(ncout, id_varout(1), zwk(:,:,1), npk, npiglo, npjglo, ktime=jt)

     IF (lertel ) THEN
        ierr = putvar(ncout, id_varout(2), zwk(:,:,1), 1,   npiglo, npjglo, ktime=jt)
        ierr = putvar(ncout, id_varout(3), zwk(:,:,1), 1,   npiglo, npjglo, ktime=jt)

        ierr = putvar(ncout, id_varout(2), zwk(:,:,1), npk, npiglo, npjglo, ktime=jt)
        ierr = putvar(ncout, id_varout(3), zwk(:,:,1), npk, npiglo, npjglo, ktime=jt)
     ENDIF
  END DO   ! loop on time

  ierr = closeout(ncout)

END PROGRAM cdfpvor

PROGRAM cdfsum
  !!======================================================================
  !!                     ***  PROGRAM  cdfsum  ***
  !!=====================================================================
  !!  ** Purpose : Compute the sum of a variable over the ocean, or
  !!               part of the ocean
  !!
  !!  ** Method  : this code is for partial steps configuration
  !!              sum = sum ( V * e1 *e2 * e3 *mask )
  !!              CAUTION : this version is still tricky, as it does not
  !!              compute the same thing in case of forcing field or
  !!              model field. Need clarification ( JMM)
  !!
  !! History : 2.1  : 11/2008  : P. Mathiot   : Original code (from cdfmean)
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: jk, jt              ! dummy loop index
  INTEGER(KIND=4)                           :: ik                  ! dummy loop index
  INTEGER(KIND=4)                           :: iimin=0, iimax=0    ! domain limitation for computation
  INTEGER(KIND=4)                           :: ijmin=0, ijmax=0    ! domain limitation for computation
  INTEGER(KIND=4)                           :: ikmin=0, ikmax=0    ! domain limitation for computation
  INTEGER(KIND=4)                           :: ierr                ! working integer
  INTEGER(KIND=4)                           :: narg, iargc         ! command line 
  INTEGER(KIND=4)                           :: npiglo, npjglo      ! size of the domain
  INTEGER(KIND=4)                           :: npk, npt            ! size of the domain
  INTEGER(KIND=4)                           :: nvpk                ! vertical levels in working variable
  INTEGER(KIND=4)                           :: numout=10           ! logical unit

  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e1, e2, e3,  zv     ! metrics, velocity
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zmask               ! npiglo x npjglo
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: gdep                ! depth 

  REAL(KIND=8)                              :: dvol, dvol2d        ! volume of the ocean/ layer
  REAL(KIND=8)                              :: dsurf               ! surface of the ocean
  REAL(KIND=8)                              :: dsum, dsum2d        ! global sum /layer sum
  REAL(KIND=8)                              :: dsumt               ! global sum over time

  CHARACTER(LEN=256)                        :: cldum               ! dummy string
  CHARACTER(LEN=256)                        :: cf_in               ! file name 
  CHARACTER(LEN=256)                        :: cv_dep              ! depth name
  CHARACTER(LEN=256)                        :: cv_in               ! variable name
  CHARACTER(LEN=20)                         :: cv_e1, cv_e2, cv_e3 ! name of the horiz/vert metrics
  CHARACTER(LEN=20)                         :: cv_msk              ! name of mask variable
  CHARACTER(LEN=20)                         :: cvartype            ! variable type

  LOGICAL                                   :: lforcing            ! forcing flag
  LOGICAL                                   :: lchk                ! flag for missing files
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfsum IN-file IN-var T| U | V | F | W  ... '
     PRINT *,'             ... [imin imax jmin jmax kmin kmax] [-full ] '
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Computes the sum value of the field (3D, weighted)' 
     PRINT *,'       This sum can be optionally limited to a sub-area.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       IN-file : netcdf input file.' 
     PRINT *,'       IN-var  : netcdf variable to work with.'
     PRINT *,'       T| U | V | F | W : C-grid point where IN-var is located.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [imin imax jmin jmax kmin kmax] : limit of the sub area to work with.' 
     PRINT *,'              if imin=0 all i are taken'
     PRINT *,'              if jmin=0 all j are taken'
     PRINT *,'              if kmin=0 all k are taken'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'      ', TRIM(cn_fhgr),', ',TRIM(cn_fzgr),' and ',TRIM(cn_fmsk) 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       Standard output.'
     STOP
  ENDIF

  CALL getarg (1, cf_in)
  CALL getarg (2, cv_in)
  CALL getarg (3, cvartype)

  lchk = chkfile(cn_fhgr)
  lchk = chkfile(cn_fzgr) .OR. lchk
  lchk = chkfile(cn_fmsk) .OR. lchk
  lchk = chkfile(cf_in  ) .OR. lchk
  IF ( lchk ) STOP ! missing file

  IF (narg > 3 ) THEN
     IF ( narg /= 9 ) THEN
        PRINT *, ' ERROR : You must give 6 optional values (imin imax jmin jmax kmin kmax)'
        STOP
     ELSE
        ! input optional iimin iimax ijmin ijmax
        CALL getarg ( 4,cldum) ; READ(cldum,*) iimin
        CALL getarg ( 5,cldum) ; READ(cldum,*) iimax
        CALL getarg ( 6,cldum) ; READ(cldum,*) ijmin
        CALL getarg ( 7,cldum) ; READ(cldum,*) ijmax
        CALL getarg ( 8,cldum) ; READ(cldum,*) ikmin
        CALL getarg ( 9,cldum) ; READ(cldum,*) ikmax
     ENDIF
  ENDIF

  npiglo = getdim (cf_in,cn_x)
  npjglo = getdim (cf_in,cn_y)
  npk    = getdim (cf_in,cn_z)
  nvpk   = getvdim(cf_in,cv_in)
  npt    = getdim (cf_in,cn_t)

  IF (iimin /= 0 ) THEN ; npiglo = iimax - iimin + 1;  ELSE ; iimin = 1 ;  ENDIF
  IF (ijmin /= 0 ) THEN ; npjglo = ijmax - ijmin + 1;  ELSE ; ijmin = 1 ;  ENDIF
  IF (ikmin /= 0 ) THEN ; npk    = ikmax - ikmin + 1;  ELSE ; ikmin = 1 ;  ENDIF

  IF (nvpk == 2 ) nvpk = 1
  IF (nvpk == 3 ) nvpk = npk

  PRINT *, 'Size of the extracted area :'
  PRINT *, '  npiglo = ', npiglo
  PRINT *, '  npjglo = ', npjglo
  PRINT *, '  npk    = ', npk
  PRINT *, '  nvpk   = ', nvpk
  PRINT *, '  npt    = ', npt

  lforcing=.FALSE.
  IF ( (npk == 0) ) THEN
     lforcing = .TRUE.
     npk      = 1
     PRINT *, 'W A R N I N G : you used a forcing field'
  END IF

  IF (lforcing)  OPEN(unit=numout, file='cdfsum.txt' , form='formatted', status='new', iostat=ierr)

  ! Allocate arrays
  ALLOCATE ( zmask(npiglo,npjglo) )
  ALLOCATE ( zv   (npiglo,npjglo) )
  ALLOCATE ( e1   (npiglo,npjglo), e2(npiglo,npjglo), e3(npiglo,npjglo) )
  ALLOCATE ( gdep (npk) )

  SELECT CASE (TRIM(cvartype))
  CASE ( 'T' )
     cv_e1  = cn_ve1t
     cv_e2  = cn_ve2t
     cv_e3  = 'e3t_ps'
     cv_msk = 'tmask'
     cv_dep = cn_gdept
  CASE ( 'U' )
     cv_e1  = cn_ve1u
     cv_e2  = cn_ve2u
     cv_e3  = 'e3t_ps'
     cv_msk = 'umask'
     cv_dep = cn_gdept
  CASE ( 'V' )
     cv_e1  = cn_ve1v
     cv_e2  = cn_ve2v
     cv_e3  = 'e3t_ps'
     cv_msk = 'vmask'
     cv_dep = cn_gdept
  CASE ( 'F' )
     cv_e1  = cn_ve1f
     cv_e2  = cn_ve2f
     cv_e3  = 'e3t_ps'
     cv_msk = 'fmask'
     cv_dep = cn_gdept
  CASE ( 'W' )
     cv_e1  = cn_ve1t
     cv_e2  = cn_ve2t
     cv_e3  = 'e3w_ps'
     cv_msk = 'tmask'
     cv_dep = cn_gdepw
  CASE DEFAULT
     PRINT *, 'this type of variable is not known :', TRIM(cvartype)
     STOP
  END SELECT

  e1(:,:) = getvar  (cn_fhgr, cv_e1, 1, npiglo, npjglo, kimin=iimin, kjmin=ijmin)
  e2(:,:) = getvar  (cn_fhgr, cv_e2, 1, npiglo, npjglo, kimin=iimin, kjmin=ijmin)
  gdep(:) = getvare3(cn_fzgr, cv_dep,   npk                                   )

  dsumt = 0.d0
  DO jt = 1,npt
     dvol = 0.d0
     dsum = 0.d0
     zv   = 0.
     DO jk = 1,nvpk
        ik = jk + ikmin -1
        ! Get velocities v at ik
        zv   (:,:) = getvar(cf_in,   cv_in,  ik, npiglo, npjglo, ktime=jt,   kimin=iimin, kjmin=ijmin)
        zmask(:,:) = getvar(cn_fmsk, cv_msk, ik, npiglo, npjglo,             kimin=iimin, kjmin=ijmin)
        !    zmask(:,npjglo)=0.

        ! get e3 at level ik ( ps...)
        e3(:,:) = getvar(cn_fzgr, cv_e3, ik, npiglo, npjglo, kimin=iimin, kjmin=ijmin, ldiom=.TRUE.)      
        ! 
        IF (.NOT. lforcing) THEN
           dsurf  = SUM(DBLE(e1 * e2      * zmask))
           dvol2d = SUM(DBLE(e1 * e2 * e3 * zmask))
           dvol   = dvol + dvol2d
           dsum2d = SUM(DBLE(zv))
           dsum   = dsum + dsum2d
           IF (dvol2d /= 0 )THEN
              PRINT *, ' Sum value at level ', ik, '(',gdep(ik),' m) ', dsum2d
           ELSE
              PRINT *, ' No points in the water at level ', ik, '(',gdep(ik),' m) '
           ENDIF
        ELSE
           dsurf  = SUM(DBLE(     e1 * e2 * zmask))
           dsum2d = SUM(DBLE(zv * e1 * e2 * zmask))
           dsum   = dsum + dsum2d
           PRINT *, ' Sum value at time ',jt,' = ', dsum2d
           PRINT *, '          Surface  = ', dsurf/1.d6,' km^2'
           PRINT *, '       mean value  = ', dsum2d/dsurf
           WRITE (numout,'(i4," ",1e12.6)') jt, dsum2d
        END IF
     END DO
     dsumt = dsumt + dsum
     IF (.NOT. lforcing) PRINT * ,' Sum value over the ocean: ', dsum
  END DO  ! time loop
  
  PRINT *, ' mean Sum over time ', dsumt/npt

  CLOSE(numout)

END PROGRAM cdfsum

PROGRAM cdfbottomsig
  !!======================================================================
  !!                     ***  PROGRAM  cdfbottomsig  ***
  !!=====================================================================
  !!  ** Purpose : Compute the bottom sigma from gridT file.
  !!               Store the results on a 'similar' cdf file.
  !!
  !!  **  Method:  Uses vosaline do determine the bottom points. A depth
  !!               reference can be specify to compute density refered to
  !!               this depth.
  !!
  !! History : 2.1  : 11/2005  : J.M. Molines : Original code
  !!           3.0  : 12/2010  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE eos
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2010, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                            :: jk, jt         ! dummy loop index
  INTEGER(KIND=4)                            :: ierr           ! working integer
  INTEGER(KIND=4)                            :: narg, iargc    ! 
  INTEGER(KIND=4)                            :: npiglo, npjglo ! size of the domain
  INTEGER(KIND=4)                            :: npk, npt       ! size of the domain
  INTEGER(KIND=4)                            :: ncout          ! ncid of output file
  INTEGER(KIND=4), DIMENSION(1)              :: ipk            ! outptut variables : number of levels,
  INTEGER(KIND=4), DIMENSION(1)              :: id_varout      ! ncdf varid's
  INTEGER(KIND=4), DIMENSION(2)              :: ismin, ismax   ! location of min and max sigmabot

  REAL(KIND=4)                               :: zsigmn, zsigmx ! value of min and max of sigmabot
  REAL(KIND=4)                               :: zref           ! value of min and max of sigmabot
  REAL(KIND=4), DIMENSION(:,:),  ALLOCATABLE :: ztemp, zsal    ! Array to read a layer of data
  REAL(KIND=4), DIMENSION(:,:),  ALLOCATABLE :: ztemp0, zsal0  ! temporary array to read temp, sal
  REAL(KIND=4), DIMENSION(:,:),  ALLOCATABLE :: zsig           ! potential density 
  REAL(KIND=4), DIMENSION(:,:),  ALLOCATABLE :: zmask          ! 2D mask at surface
  REAL(KIND=4), DIMENSION(:),    ALLOCATABLE :: tim            ! time counter

  CHARACTER(LEN=256)                         :: cf_out='botsig.nc' ! Output file name
  CHARACTER(LEN=256)                         :: cf_tfil        ! input filename
  CHARACTER(LEN=256)                         :: cv_sig         ! output variable name
  CHARACTER(LEN=256)                         :: cref           ! message for depth reference
  CHARACTER(LEN=256)                         :: cldum          ! dummy char variable

  TYPE (variable), DIMENSION(1)              :: stypvar        ! structure for attributes

  LOGICAL                                    :: lsigi=.FALSE.  ! flag for sigma-i computation
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  !!  Read command line
  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfbottomsig  T-file [zref]' 
     PRINT *,'      '
     PRINT *,'     PURPOSE :' 
     PRINT *,'       Create a 2D file with bottom density. In case a depth reference' 
     PRINT *,'       is given, the density is refered to this depth. By default sigma-0'
     PRINT *,'       is used. Bottom most point is determined from the last non zero '
     PRINT *,'       salinity point in the water column.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       T-file : input file with temperature and salinity '
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [zref] : depth reference for potential density'
     PRINT *,'             If not given assume sigma-0'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       none'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : sobotsig0 or sobotsigi ( kg/m3 - 1000 )' 
     STOP
  ENDIF

  cv_sig = 'sobotsig0'
  cref=''
  CALL getarg (1, cf_tfil)
  IF ( chkfile(cf_tfil) ) STOP ! missing file

  IF ( narg == 2 ) THEN
     lsigi = .TRUE.
     CALL getarg (2, cldum) ; READ(cldum,*) zref
     cv_sig = 'sobotsigi'
     WRITE(cref,'("_refered_to_",i4.4,"_m")') NINT(zref)
  ENDIF

  npiglo = getdim (cf_tfil,cn_x)
  npjglo = getdim (cf_tfil,cn_y)
  npk    = getdim (cf_tfil,cn_z)
  npt    = getdim (cf_tfil,cn_t)

  ipk(:)= 1  ! all variables (input and output are 3D)

  stypvar(1)%cname             = cv_sig
  stypvar(1)%cunits            = 'kg/m3'
  stypvar(1)%rmissing_value    = 0.
  stypvar(1)%valid_min         = 0.001
  stypvar(1)%valid_max         = 40.
  stypvar(1)%clong_name        = 'Bottom_Potential_density'//TRIM(cref)
  stypvar(1)%cshort_name       = cv_sig
  stypvar(1)%conline_operation = 'N/A'
  stypvar(1)%caxis             = 'TYX'

  PRINT *, 'npiglo =', npiglo
  PRINT *, 'npjglo =', npjglo
  PRINT *, 'npk    =', npk
  PRINT *, 'npt    =', npt

  ALLOCATE (ztemp( npiglo,npjglo), zsal( npiglo,npjglo), zsig(npiglo,npjglo) ,zmask(npiglo,npjglo))
  ALLOCATE (ztemp0(npiglo,npjglo), zsal0(npiglo,npjglo) )
  ALLOCATE ( tim (npt) )

  ! create output fileset

  ncout = create      (cf_out, cf_tfil, npiglo, npjglo, npk       )
  ierr  = createvar   (ncout,  stypvar, 1     , ipk   , id_varout )
  ierr  = putheadervar(ncout,  cf_tfil, npiglo, npjglo, npk       )

  zsal  = 0.
  ztemp = 0.
  zmask = 1.

  DO jt = 1, npt
     DO jk = 1, npk
        PRINT *,'level ',jk
        zsal0(:,:) = getvar(cf_tfil, cn_vosaline, jk, npiglo, npjglo, ktime=jt)
        ztemp0(:,:)= getvar(cf_tfil, cn_votemper, jk, npiglo, npjglo, ktime=jt)
        IF (jk == 1  )  THEN
           WHERE( zsal0 == 0. ) zmask=0.
        END IF
        WHERE ( zsal0 /= 0 )
          zsal=zsal0 ; ztemp=ztemp0
        END WHERE
     ENDDO
     
     IF (lsigi ) THEN
        zsig(:,:) = sigmai ( ztemp, zsal, zref, npiglo, npjglo ) * zmask(:,:)
     ELSE
        zsig(:,:) = sigma0 ( ztemp, zsal,       npiglo, npjglo ) * zmask(:,:)
     ENDIF


     zsigmn=minval(zsig(2:npiglo-1,2:npjglo-1), zmask(2:npiglo-1,2:npjglo-1)==1)
     zsigmx=maxval(zsig(2:npiglo-1,2:npjglo-1), zmask(2:npiglo-1,2:npjglo-1)==1)
     ismin= minloc(zsig(2:npiglo-1,2:npjglo-1), zmask(2:npiglo-1,2:npjglo-1)==1)
     ismax= maxloc(zsig(2:npiglo-1,2:npjglo-1), zmask(2:npiglo-1,2:npjglo-1)==1)

     PRINT *,'Bottom density : min = ', zsigmn,' at ', ismin(1), ismin(2)
     PRINT *,'               : max = ', zsigmx,' at ', ismax(1), ismax(2)

     ierr = putvar(ncout, id_varout(1), zsig, 1, npiglo, npjglo, ktime=jt)
  ENDDO

  tim  = getvar1d(cf_tfil, cn_vtimec, npt     )
  ierr = putvar1d(ncout,   tim      , npt, 'T')
  ierr = closeout(ncout)

END PROGRAM cdfbottomsig

PROGRAM cdf2matlab
  !!======================================================================
  !!                     ***  PROGRAM  cdf2matlab  ***
  !!=====================================================================
  !!  ** Purpose : Reshapes ORCA grids to be matlab-friendly
  !!
  !!  ** Method  : transform input file with monotonically increasing
  !!               longitudes.
  !!
  !! History : 2.1  : 01/2011  : R. Dussin    : Original code
  !!           3.0  : 03/2011  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  

  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class data_transformation
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: ji, jj, jt          ! dummy loop index
  INTEGER(KIND=4)                           :: narg, iargc,ijarg   ! 
  INTEGER(KIND=4)                           :: npiglo, npjglo, npk ! size of the domain
  INTEGER(KIND=4)                           :: npt                 ! number of time frame
  INTEGER(KIND=4)                           :: npiglox2            ! new model size in x
  INTEGER(KIND=4)                           :: ilev, iindex, itmp
  INTEGER(KIND=4)                           :: ncout
  INTEGER(KIND=4)                           :: ierr
  INTEGER(KIND=4), DIMENSION(3)             :: ipk, id_varout

  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zlon, zlat, zvar    ! input arrays
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zlonout, zlatout    ! output arrays
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zlonwork, zlatwork  ! working arrays arrays
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zvarout, zvarwork   ! working arrays arrays

  REAL(KIND=8), DIMENSION(:),   ALLOCATABLE :: dtim

  CHARACTER(LEN=256)                        :: cf_in               ! input file name
  CHARACTER(LEN=256)                        :: cf_out='output.nc'  ! output file name
  CHARACTER(LEN=256)                        :: cv_in               ! input variable  name
  CHARACTER(LEN=256)                        :: cldum               !  dummy character variable

  TYPE(variable), DIMENSION(3)              :: stypvar             ! structure for attribute

  LOGICAL                                   :: lnc4 = .FALSE.      ! Use nc4 with chunking and deflation
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdf2matlab -f IN-file -v IN-var -k level [-o OUT-file] [-nc4]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Convert global nemo input file (ORCA configurations) into' 
     PRINT *,'       a file with monotonically increasing longitudes.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -f IN-file : input model file.' 
     PRINT *,'       -v IN-var  : netcdf variable name to process.'
     PRINT *,'       -k level   : level to process.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'        [-o OUT-file] : specify output file name instead of ',TRIM(cf_out)
     PRINT *,'        [-nc4 ]: Use netcdf4 output with chunking and deflation level 1.'
     PRINT *,'                 This option is effective only if cdftools are compiled with'
     PRINT *,'                 a netcdf library supporting chunking and deflation.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        none'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : same name than in input file.'
     STOP 
  ENDIF
  !!
  ijarg=1
  DO WHILE (ijarg <= narg )
     CALL getarg (ijarg, cldum ) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-f'  ) ; CALL getarg (ijarg, cf_in ) ; ijarg=ijarg+1
     CASE ( '-v'  ) ; CALL getarg (ijarg, cv_in ) ; ijarg=ijarg+1
     CASE ( '-k'  ) ; CALL getarg (ijarg, cldum ) ; ijarg=ijarg+1 ; READ(cldum,*) ilev
        ! options
     CASE ( '-o'  ) ; CALL getarg (ijarg, cf_out) ; ijarg=ijarg+1
     CASE ( '-nc4') ; lnc4 = .TRUE.
     CASE DEFAULT   ; PRINT *,' ERROR : ',TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  ENDDO
  IF ( chkfile (cf_in) ) STOP 99  ! missing file

  npiglo = getdim (cf_in,cn_x)
  npjglo = getdim (cf_in,cn_y)
  npk    = getdim (cf_in,cn_z)
  npt    = getdim (cf_in,cn_t)

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt
  npiglox2 = 2 * npiglo

  ALLOCATE( zvar(npiglo,npjglo), zlon(npiglo,npjglo), zlat(npiglo,npjglo), dtim(npt)  )
  ALLOCATE( zvarout(npiglox2,npjglo), zlonout(npiglox2,npjglo), zlatout(npiglox2,npjglo) )

  CALL CreateOutput
  zlon(:,:) = getvar(cf_in, cn_vlon2d, 1,    npiglo, npjglo)
  zlat(:,:) = getvar(cf_in, cn_vlat2d, 1,    npiglo, npjglo)
  DO jt=1, npt

  zvar(:,:) = getvar(cf_in, cv_in,     ilev, npiglo, npjglo, ktime=jt )

  DO jj=1,npjglo
     iindex = MINLOC( ABS(zlon(:,jj) + 180 ),1 ) ! find the discontinuity in lon array
     itmp   = npiglo - iindex + 1

     zlonout(1:itmp,jj) = zlon(iindex:npiglo,jj) ; zlonout(itmp+1:npiglo,jj) = zlon(1:iindex-1,jj)
     zlonout(npiglo+1:npiglo+itmp  ,jj) = zlon(iindex:npiglo,jj) + 360. 
     zlonout(npiglo+itmp+1:npiglox2,jj) = zlon(1:iindex-1,   jj) + 360.

     zlatout(1:itmp,jj) = zlat(iindex:npiglo,jj) ; zlatout(itmp+1:npiglo,jj) = zlat(1:iindex-1,jj)
     zlatout(npiglo+1:npiglo+itmp,  jj) = zlat(iindex:npiglo,jj)  
     zlatout(npiglo+itmp+1:npiglox2,jj) = zlat(1:iindex-1,   jj) 

     zvarout(1:itmp,jj) = zvar(iindex:npiglo,jj) ; zvarout(itmp+1:npiglo,jj) = zvar(1:iindex-1,jj)
     zvarout(npiglo+1:npiglo+itmp,  jj) = zvar(iindex:npiglo,jj)  
     zvarout(npiglo+itmp+1:npiglox2,jj) = zvar(1:iindex-1,   jj) 
  END DO

  ! Special treatement for ORCA2

  IF ( ( npiglo == 182 ) .AND. ( npjglo == 149 ) ) THEN
     PRINT *, 'Assuming that this config is ORCA2 !'

     ALLOCATE( zvarwork(npiglox2,npjglo), zlonwork(npiglox2,npjglo), zlatwork(npiglox2,npjglo) )

     !! init the arryas
     zlonwork(:,:) = zlonout(:,:)
     zlatwork(:,:) = zlatout(:,:)
     zvarwork(:,:) = zvarout(:,:)

     !! swap values to keep lon increasing 
     zlonwork(131,:) = zlonout(130,:) ; zlonwork(npiglo+131,:) = zlonout(npiglo+130,:)
     zlatwork(131,:) = zlatout(130,:) ; zlatwork(npiglo+131,:) = zlatout(npiglo+130,:)
     zvarwork(131,:) = zvarout(130,:) ; zvarwork(npiglo+131,:) = zvarout(npiglo+130,:)

     zlonwork(130,:) = zlonout(131,:) ; zlonwork(npiglo+130,:) = zlonout(npiglo+131,:)
     zlatwork(130,:) = zlatout(131,:) ; zlatwork(npiglo+130,:) = zlatout(npiglo+131,:)
     zvarwork(130,:) = zvarout(131,:) ; zvarwork(npiglo+130,:) = zvarout(npiglo+131,:)

     !! swapping the arrays
     zlonout(:,:) = zlonwork(:,:)
     zlatout(:,:) = zlatwork(:,:)
     zvarout(:,:) = zvarwork(:,:)

  ENDIF

  ierr = putvar(ncout,id_varout(1), zlonout, 1, npiglox2, npjglo, ktime=jt)
  ierr = putvar(ncout,id_varout(2), zlatout, 1, npiglox2, npjglo, ktime=jt)
  ierr = putvar(ncout,id_varout(3), zvarout, 1, npiglox2, npjglo, ktime=jt)
  ENDDO

  ierr = closeout(ncout)

  PRINT *, 'Tip : in matlab, do not plot the last line (e.g. maximum northern latitude) '

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    ipk(:)                       = 1
    stypvar(1)%ichunk            = (/npiglox2,MAX(1,npjglo/30),1,1 /)
    stypvar(1)%cname             = 'lon'
    stypvar(1)%cunits            = 'degrees'
    stypvar(1)%valid_min         = -180.
    stypvar(1)%valid_max         = 540.
    stypvar(1)%clong_name        = 'longitude'
    stypvar(1)%cshort_name       = 'lon'
    stypvar(1)%conline_operation = 'N/A'
    stypvar(1)%caxis             = 'YX'

    stypvar(2)%ichunk            = (/npiglox2,MAX(1,npjglo/30),1,1 /)
    stypvar(2)%cname             = 'lat'
    stypvar(2)%cunits            = 'degrees'
    stypvar(2)%rmissing_value    = 0.
    stypvar(2)%valid_min         = -90.
    stypvar(2)%valid_max         = 90.
    stypvar(2)%clong_name        = 'latitude'
    stypvar(2)%cshort_name       = 'lat'
    stypvar(2)%conline_operation = 'N/A'
    stypvar(2)%caxis             = 'YX'

    stypvar(3)%ichunk            = (/npiglox2,MAX(1,npjglo/30),1,1 /)
    stypvar(3)%cname             = cv_in
    stypvar(3)%cunits            = ''
    stypvar(3)%rmissing_value    = 0.
    stypvar(3)%clong_name        = ''
    stypvar(3)%cshort_name       = cv_in
    stypvar(3)%conline_operation = 'N/A'
    stypvar(3)%caxis             = 'TYX'

    ncout = create    (cf_out,   cf_in,   npiglox2, npjglo, 1         , ld_nc4=lnc4 )
    ierr  = createvar (ncout,    stypvar, 3,        ipk,    id_varout , ld_nc4=lnc4 )

    dtim = getvar1d(cf_in, cn_vtimec, npt     )
    ierr = putvar1d(ncout, dtim,      npt, 'T')

  END SUBROUTINE CreateOutput

END PROGRAM cdf2matlab

PROGRAM cdfsigtrp_broken
  !!======================================================================
  !!                     ***  PROGRAM  cdfsigtrp_broken  ***
  !!======================================================================
  !!  ** Purpose : Compute density class Mass transport across a section.
  !!               previously extracted with cdf_xtrac_broken_line
  !!           
  !!  ** Method  : 
  !!              - The program works for sections extracted with cdf_xtrac_brokenline
  !!              - Hence it is considered as a pseudo zonal section with 
  !!                normal velocity seen as V
  !!              - read metrics, depth, etc
  !!              - read normal velocity 
  !!              - read T and S already interpolated at V point
  !!              - compute sigma0 (can be easily modified for sigmai )
  !!              - compute the depths of isopyncal surfaces
  !!              - compute the transport from surface to the isopycn
  !!              - compute the transport in each class of density
  !!              - compute the total transport (for information)
  !!
  !! History : 3.0  : 12/2014  : P. Colombo   : from cdfsigtrp 
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  !!   routines      : description
  !!  section_init   : initialize section names and positions
  !!  print_out      : routine which performs standard output if required
  !!----------------------------------------------------------------------
  USE cdfio
  USE eos          ! for sigma0, sigmai
  USE modcdfnames  ! for ReadCdfNames
  USE modutils     ! for SetGlobalAtt
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id: cdfsigtrp.f90 699 2013-06-24 14:17:21Z molines $
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class transport
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                               :: ji, jk, jclass, jsec ! dummy loop index
  INTEGER(KIND=4)                               :: jiso, jbin, jarg     ! dummy loop index
  INTEGER(KIND=4)                               :: nbins                ! number of density classes
  INTEGER(KIND=4)                               :: ipos                 ! working variable
  INTEGER(KIND=4)                               :: narg, iargc          ! command line 
  INTEGER(KIND=4)                               :: ijarg                ! command line
  INTEGER(KIND=4)                               :: npk, nk              ! vertical size, number of wet layers
  INTEGER(KIND=4)                               :: numout=11            ! ascii output
  INTEGER(KIND=4)                               :: nsection             ! number of sections (overall)
  INTEGER(KIND=4)                               :: iimin, iimax         ! working section limits
  INTEGER(KIND=4)                               :: ijmin, ijmax         ! working section limits
  INTEGER(KIND=4)                               :: npts                 ! number of points in section
  INTEGER(KIND=4)                               :: ikx=1, iky=1         ! dims of netcdf output file
  INTEGER(KIND=4)                               :: nboutput=2           ! number of values to write in cdf output
  INTEGER(KIND=4)                               :: ncout, ierr          ! for netcdf output
  INTEGER(KIND=4)                               :: iweight              ! weight of input file for further averaging
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: iimina, iimaxa       ! sections limits
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: ijmina, ijmaxa       ! sections limits
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: ipk, id_varout       ! variable levels and id

  REAL(KIND=4)                                  :: refdep =0.e0         ! reference depth (m)
  REAL(KIND=4), DIMENSION(1)                    :: rdummy1, rdummy2     ! working variable
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: gdept, gdepw         ! depth of T and W points 
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: eu                   ! either e1v or e2u
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: e3t1d, e3w1d         ! vertical metrics in case of full step
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: rlonlat              ! longitudes/latitudes if the section
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: zs, zt               ! salinity and temperature from file 
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: rdumlon, rdumlat     ! dummy longitude and latitude for output
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: zu                   ! velocity
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: zmask                ! mask
  REAL(KIND=4), DIMENSION(:,:,:),   ALLOCATABLE :: tmpm, tmpz           ! temporary arrays
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: tmpz1d               ! temporary arrays
  ! double precision for cumulative variables and densities
  REAL(KIND=8)                                  :: dsigma_min           ! minimum density for bining
  REAL(KIND=8)                                  :: dsigma_max, dltsig   ! maximum density for bining, step
  REAL(KIND=8)                                  :: dsigma, dalfa        ! working sigma, interpolation coeff.
  REAL(KIND=8), DIMENSION(1)                    :: dtim                 ! time counter
  REAL(KIND=8), DIMENSION(:),       ALLOCATABLE :: dsigma_lev           ! built array with sigma levels
  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: de3                  ! vertical metrics
  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: ddepu                ! depth of vel points
  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: dsig                 ! density
  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: dhiso                ! depth of isopycns
  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: dwtrp, dwtrpbin      ! transport arrays
  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: dtrpbin              ! transport arrays

  TYPE(variable), DIMENSION(:),     ALLOCATABLE :: stypvar              ! structure of output

  CHARACTER(LEN=256)                            :: cf_brfi              ! temperature salinity velocity file 
                                                                        !(from cdf_xtrac_brokenline)
  CHARACTER(LEN=256)                            :: cf_section='dens_section.dat'  ! input section file
  CHARACTER(LEN=256)                            :: cf_out='trpsig.txt'  ! output  ascii file
  CHARACTER(LEN=256)                            :: cf_nc                ! output netcdf file (2d)
  CHARACTER(LEN=256)                            :: cf_outnc             ! output netcdf file (1d, 0d))
  CHARACTER(LEN=256)                            :: cv_dep               ! depth variable
  CHARACTER(LEN=256)                            :: cldum                ! dummy string
  CHARACTER(LEN=256)                            :: cglobal              ! global attribute
  CHARACTER(LEN=80 )                            :: cfmt_9000            ! format string 
  CHARACTER(LEN=80 )                            :: cfmt_9001            ! format string
  CHARACTER(LEN=80 )                            :: cfmt_9002            ! format string
  CHARACTER(LEN=80 )                            :: cfmt_9003            ! format string
  CHARACTER(LEN=256)                            :: cl_vnam, cl_lname    ! working variables
  CHARACTER(LEN=256)                            :: csuffixvarname       !
  CHARACTER(LEN=256)                            :: cprefixlongname      !
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_names             ! names of input variables
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: csection             ! section name
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cvarname             ! output variable name (root)
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: clongname            ! output long name (root)

  LOGICAL                                       :: ltemp  =.FALSE.      ! flag for use of temperature
  LOGICAL                                       :: lprint =.FALSE.      ! flag for extra print
  LOGICAL                                       :: lncdf  =.FALSE.      ! flag for extra netcdf output
  LOGICAL                                       :: lfull  =.FALSE.      ! flag for full step 
  LOGICAL                                       :: lneutral  =.FALSE.   ! flag for neutral density
  LOGICAL                                       :: lchk   =.FALSE.      ! flag for missing files
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage :  cdfsigtrp_broken -f BRK-file -bin sigma_min sigma_max nbins ...'
     PRINT *,'              ... [-print ] [-full ] [ -refdep ref_depth] ...'
     PRINT *,'              ... [-neutral ] [-section file ] [-temp ]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute density class transports, according to the density class' 
     PRINT *,'       definition ( minimum, maximum and number of bins) given in arguments.'
     PRINT *,'       Section position are given in ',TRIM(cf_section),', an ASCII file '
     PRINT *,'       with pairs of lines giving section name and section location as'
     PRINT *,'       imin imax jmin jmax. Only zonal or meridional section are allowed.'
     PRINT *,'       The name of this file can be specified with the -section option, if'
     PRINT *,'       it differs from the standard name. Optionaly, a netcdf root variable '
     PRINT *,'       name and a netcdf root long-name can be provided on the line giving '
     PRINT *,'       the section name.'
     PRINT *,'       In this particular tool, the section used is the result of '
     PRINT *,'       cdf_xtrac_brokenline. In this way, it is possible to calculate the'
     PRINT *,'       transport of density class in oblicous sections (non dependance on '
     PRINT *,'       zonal or meridional).'
     PRINT *,'      '
     PRINT *,'       This program can also be used to compute transport by class of '
     PRINT *,'       temperatures, provided the temperatures decrease monotonically '
     PRINT *,'       downward. In this case, use -temp option and of course specify'
     PRINT *,'       sigma_min, sigma_max as temperatures.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -f BRK-file : netcdf_broken_line file with temperature, salinity' 
     PRINT *,'                   and the normal velocity through the section + some '
     PRINT *,'                   usefull metrics.'
     PRINT *,'       -bin  sigma_min sigma_max nbins : 3 values follow -bin switch :'
     PRINT *,'               sigma_min : minimum density for binning'
     PRINT *,'               sigma_max : maximum density for binning'
     PRINT *,'               nbins : number of bins. This will fix the bin ''width'' '
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-full ] : for full step configuration' 
     PRINT *,'       [-ncdf ] : produce extra netcdf output file which shows the details'
     PRINT *,'               of the sections (normal velocity, density, temperature, '
     PRINT *,'               salinity, transports, isopycnal depths. '
     PRINT *,'       [-print ]: write the binned transports on standard output, for each'
     PRINT *,'               sections.'
     PRINT *,'       [-refdep ref_depth ]: give a reference depths for the computation of'
     PRINT *,'               potential density. Sigma_min, sigma_max must be adapted '
     PRINT *,'               accordingly.'
     PRINT *,'       [-neutral ]: use neutral density instead of potential density '
     PRINT *,'       [-section file] : give the name of section file.'
     PRINT *,'               Default is ', TRIM(cf_section)
     PRINT *,'       [-temp ] : use temperature instead of density for binning'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ', TRIM(cn_fzgr),' and ', TRIM(cf_section)
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       Netcdf file : There is 1 netcdf file per section. File name is build'
     PRINT *,'         from section name : Section_name_trpsig.nc'
     PRINT *,'         variables : sigma_class (upper limit of the bin)'
     PRINT *,'                     sigtrp : transport (Sv per bin)'
     PRINT *,'      '
     PRINT *,'       ascii file  : ', TRIM(cf_out) 
     PRINT *,'      '
     PRINT *,'      Standard output : the results are written on standard output only if '
     PRINT *,'         the -print option is used.'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'      cdfrhoproj, cdftransport, cdfsigintegr, cdfsigtrp, cdf_xtrac_brokenline '
     PRINT *,'      '
     STOP 
  ENDIF

  ! browse command line
  ijarg = 1 
  DO WHILE ( ijarg <= narg )
     CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-f'      ) ; CALL getarg(ijarg, cf_brfi    ) ; ijarg=ijarg+1 
     CASE ( '-bin'    ) ; CALL getarg(ijarg, cldum      ) ; ijarg=ijarg+1 ; READ(cldum,*) dsigma_min 
                        ; CALL getarg(ijarg, cldum      ) ; ijarg=ijarg+1 ; READ(cldum,*) dsigma_max
                        ; CALL getarg(ijarg, cldum      ) ; ijarg=ijarg+1 ; READ(cldum,*) nbins
     ! options
     CASE ( '-full'   ) ; lfull  = .TRUE.
     CASE ( '-ncdf'   ) ; lncdf  = .TRUE.
     CASE ( '-print'  ) ; lprint = .TRUE.
     CASE ( '-temp'   ) ; ltemp  = .TRUE. 
     CASE ( '-refdep' ) ; CALL getarg(ijarg, cldum      ) ; ijarg=ijarg+1 ; READ(cldum,*) refdep
     CASE ( '-section') ; CALL getarg(ijarg, cf_section ) ; ijarg=ijarg+1 
     CASE ( '-neutral') ; lneutral = .TRUE.
     CASE DEFAULT       ; PRINT *,' ERROR : ', TRIM(cldum), ' : unknown option.' ; STOP 99
     END SELECT
  END DO

  ! check for file existence
  lchk = lchk .OR. chkfile( cn_fzgr    )
  lchk = lchk .OR. chkfile( cf_section )
  lchk = lchk .OR. chkfile( cf_brfi    )
  IF ( lchk ) STOP 99 ! missing file

  IF ( ltemp)  THEN  ! temperature decrease downward. Change sign and swap min/max
     refdep = -10. ! flag value
     dltsig     = dsigma_max  ! use dltsig as dummy variable for swapping
     dsigma_max = -dsigma_min
     dsigma_min = -dltsig
  ENDIF

  ! define global attribute with command line
  CALL SetGlobalAtt( cglobal)

  !! Commented Pedro   
  ! get the attribute iweight from vozocrtx
  ! JM iweight can be taken from cf_brfi as well
  !iweight = getatt(cf_ufil, cn_vozocrtx, 'iweight')
  iweight = 1
  IF ( iweight == 0 ) iweight = 1  ! if 0 means that it is not defined.

  ALLOCATE ( stypvar(nboutput), ipk(nboutput), id_varout(nboutput) )
  ALLOCATE ( rdumlon(ikx,iky),  rdumlat(ikx,iky)                   )

  rdumlon(:,:)=0.
  rdumlat(:,:)=0.

  ipk(1)=nbins ! sigma for each level
  ipk(2)=nbins ! transport for each level
  ! initialisation of variable names etc... is done according to section name

  ! Initialise sections from file 
  ! first call to get nsection and allocate arrays 
  nsection = 0 ; CALL section_init(cf_section, csection,cvarname,clongname,iimina, iimaxa, ijmina, ijmaxa, nsection)
  ALLOCATE ( csection(nsection), cvarname(nsection), clongname(nsection) )
  ALLOCATE ( iimina(nsection), iimaxa(nsection), ijmina(nsection),ijmaxa(nsection) )
  CALL section_init(cf_section, csection,cvarname,clongname, iimina,iimaxa,ijmina,ijmaxa, nsection)

  ! Allocate and build sigma levels and section array
  ALLOCATE ( dsigma_lev (nbins+1) , dtrpbin(nsection,nbins)  )

  dsigma_lev(1)=dsigma_min
  dltsig=( dsigma_max - dsigma_min) / nbins
  DO jclass =2, nbins+1
     dsigma_lev(jclass)= dsigma_lev(1) + (jclass-1) * dltsig
  END DO

  ! Look for vertical size of the domain
  npk = getdim (cf_brfi,cn_z)
  ALLOCATE ( gdept(npk), gdepw(npk) )
  IF ( lfull ) ALLOCATE ( e3t1d(npk), e3w1d(npk))

  ! read gdept, gdepw : it is OK even in partial cells, as we never use the bottom gdep
  gdept(:) = getvare3(cn_fzgr, cn_gdept, npk)
  gdepw(:) = getvare3(cn_fzgr, cn_gdepw, npk)

  IF ( lfull )  THEN 
     e3t1d(:) = getvare3(cn_fzgr, cn_ve3t1d, npk)
     e3w1d(:) = getvare3(cn_fzgr, cn_ve3w1d, npk)
  ENDIF

  !! *  Main loop on sections
  DO jsec=1,nsection
     iimin=iimina(jsec) ; iimax=iimaxa(jsec)
     ijmin=ijmina(jsec) ; ijmax=ijmaxa(jsec)

     IF (iimin == iimax ) THEN        ! meridional section
        npts    = ijmax - ijmin       ! number of segments

     ELSE IF ( ijmin == ijmax ) THEN  ! zonal section
        npts    = iimax - iimin       ! number of segments

     ELSE
        PRINT *,' Section ',TRIM(csection(jsec)),' is neither zonal nor meridional :('
        PRINT *,' We skip this section .'
        CYCLE
     ENDIF

     ALLOCATE ( zu(npts,npk), zt(npts,npk), zs(npts,npk), dsig(npts,0:npk)  )
     ALLOCATE ( eu(npts), de3(npts,npk), ddepu(npts, 0:npk), zmask(npts,npk) )
     ALLOCATE ( tmpm(1,npts,2), tmpz(npts,1,2)                              )
     ALLOCATE ( dwtrp(npts, nbins+1), dhiso(npts,nbins+1), dwtrpbin(npts,nbins) )
     ALLOCATE ( rlonlat(npts,1) )

     ! zonal section at j=ijmin=ijmax
     tmpz(:,:,1)  = getvar(cf_brfi, cn_ve1v,   1, npts, 1, kimin=iimin, kjmin=ijmin)
     eu(:)        = tmpz(:,1,1)
     tmpz(:,:,1)  = getvar(cf_brfi, cn_vlon2d, 1, npts, 1, kimin=iimin, kjmin=ijmin)
     rlonlat(:,1) = tmpz(:,1,1)  ! longitude in this case
     DO jk=1,npk
        ! initiliaze ddepu to gdept()
        ddepu(:,jk) = gdept(jk)

        IF ( lfull ) THEN
           de3(:,jk)   = e3t1d(jk)
           tmpm(:,1,1) = e3w1d(jk)
           tmpm(:,1,2) = e3w1d(jk)
        ELSE
           ! vertical metrics (PS case)
           tmpz(:,:,1)=getvar(cf_brfi,'e3v_ps',jk, npts, 1, kimin=iimin+1, kjmin=ijmin, ldiom=.TRUE.)
           de3(:,jk) = tmpz(:,1,1)
        ENDIF

        IF (jk >= 2 ) THEN
           DO ji=1,npts
              ddepu(ji,jk)= ddepu(ji,jk-1) + tmpz(ji,1,1)!MIN(tmpz(ji,1,1), tmpz(ji,1,2))
           END DO
        ENDIF

        ! Normal velocity
        tmpz(:,:,1)=getvar(cf_brfi,cn_vomecrty,jk,npts,1, kimin=iimin+1, kjmin=ijmin)
        zu(:,jk)=tmpz(:,1,1)
        ! salinity and mask
        tmpz(:,:,1)=getvar(cf_brfi,cn_vosaline,jk,npts,1, kimin=iimin+1, kjmin=ijmin)
        zmask(:,jk)=tmpz(:,1,1)
        WHERE ( zmask(:,jk) /= 0 ) zmask(:,jk)=1
        ! do not take special care for land value, as the corresponding velocity point is masked
        zs(:,jk) = tmpz(:,1,1)
        ! limitation to 'wet' points
        IF ( SUM(zs(:,jk))  == 0 ) THEN
           nk=jk ! first vertical point of the section full on land
           EXIT  ! as soon as all the points are on land
        ENDIF

        ! temperature
        tmpz(:,:,1)=getvar(cf_brfi,cn_votemper,jk, npts, 1, kimin=iimin+1, kjmin=ijmin)
        zt(:,jk) = tmpz(:,1,1)
     END DO
     ! compute density only for wet points
     IF ( lneutral ) THEN 
        dsig(:,1:nk)=sigmantr( zt, zs,         npts, npk)*zmask(:,:)
     ELSE
        IF ( refdep == -10. ) THEN
           dsig(:,1:nk)= -zt(:,:)  ! change sign 
        ELSEIF ( refdep == 0. ) THEN
           dsig(:,1:nk)=sigma0( zt, zs,         npts, npk)*zmask(:,:)
        ELSE
           dsig(:,1:nk)=sigmai( zt, zs, refdep, npts, npk)*zmask(:,:)
        ENDIF
     ENDIF

     dsig(:,0)=dsig(:,1)-1.e-4   ! dummy layer for easy interpolation

     ! compute depth of isopynals (nbins+1 )
     DO  jiso =1, nbins+1
        dsigma=dsigma_lev(jiso)
!!!  REM : I and K loop can be inverted if necessary
        DO ji=1,npts
           dhiso(ji,jiso) = gdept(npk)
           DO jk=1,nk 
              IF ( dsig(ji,jk) < dsigma ) THEN
              ELSE
                 ! interpolate between jk-1 and jk
                 dalfa=(dsigma - dsig(ji,jk-1)) / ( dsig(ji,jk) -dsig(ji,jk-1) )
                 IF (ABS(dalfa) > 1.1 .OR. dalfa < 0 ) THEN   ! case dsig(0) = dsig(1)-1.e-4
                    dhiso(ji,jiso)= 0.d0
                 ELSE
                    dhiso(ji,jiso)= ddepu(ji,jk)*dalfa + (1.d0-dalfa)* ddepu(ji,jk-1)
                 ENDIF
                 EXIT
              ENDIF
           END DO
        END DO
     END DO

     ! compute transport between surface and isopycn 
     DO jiso = 1, nbins + 1
        dsigma=dsigma_lev(jiso)
        DO ji=1,npts
           dwtrp(ji,jiso) = 0.d0
           DO jk=1, nk-1
              IF ( gdepw(jk+1) < dhiso(ji,jiso) ) THEN
                 dwtrp(ji,jiso)= dwtrp(ji,jiso) + eu(ji)*de3(ji,jk)*zu(ji,jk)*1.d0
              ELSE  ! last box ( fraction)
                 dwtrp(ji,jiso)= dwtrp(ji,jiso) + eu(ji)*(dhiso(ji,jiso)-gdepw(jk))*zu(ji,jk)*1.d0
                 EXIT  ! jk loop
              ENDIF
           END DO
        END DO
     END DO

     ! binned transport : difference between 2 isopycns
     DO jbin=1, nbins
        dsigma=dsigma_lev(jbin)
        DO ji=1, npts
           dwtrpbin(ji,jbin) = dwtrp(ji,jbin+1) -  dwtrp(ji,jbin) 
        END DO
        dtrpbin(jsec,jbin)=SUM(dwtrpbin(:,jbin) )
     END DO

     ! output of the code for 1 section
     IF (lprint) CALL print_out(jsec)
     IF (lncdf ) CALL cdf_writ(jsec)
     PRINT *,' Total transport in all bins :',TRIM(csection(jsec)),' ',SUM(dtrpbin(jsec,:) )/1.d6

     ! free memory for the next section
     DEALLOCATE ( zu, zt, zs, dsig, ddepu, dhiso, dwtrp, dwtrpbin )
     DEALLOCATE ( eu, de3, tmpm, tmpz, zmask, rlonlat             )

  END DO   ! next section

  !! Global Output
  OPEN( numout, FILE=cf_out)
  ipos=INDEX(cf_brfi,'_gridT.nc')
  WRITE(numout,9006)  TRIM(cf_brfi(1:ipos-1))
  WRITE(numout,9005) ' sigma  ', (csection(jsec),jsec=1,nsection)
  DO jiso=1,nbins
     WRITE(numout,9004) dsigma_lev(jiso), (dtrpbin(jsec,jiso),jsec=1,nsection)
  ENDDO
  CLOSE(numout)

  cv_dep='levels'
  ! need to call section_init again in order to reset cvarname, clongname if they where modified 
  ! previously in cdf_writ(  case lncdf=true )
  IF (lncdf) THEN
     CALL section_init(cf_section, csection,cvarname,clongname, iimina,iimaxa,ijmina,ijmaxa, nsection)
  ENDIF

  DO jsec=1,nsection
     ! setup output variables (section dependant for adaptative variable name (if possible)
     ! define new variables for output 
     IF ( cvarname(jsec) /= 'none' ) THEN
        csuffixvarname='_'//TRIM(cvarname(jsec))
     ELSE
        csuffixvarname=''
     ENDIF
     IF ( clongname(jsec) /= 'none' ) THEN
        cprefixlongname=TRIM(clongname(jsec))//'_'
     ELSE
        cprefixlongname=''
     ENDIF

     stypvar%rmissing_value    = 99999.
     stypvar%scale_factor      = 1.
     stypvar%add_offset        = 0.
     stypvar%savelog10         = 0.
     stypvar%iwght             = iweight
     stypvar%conline_operation = 'N/A'
     stypvar%caxis             = 'ZT'

     IF ( ltemp ) THEN
        stypvar(1)%cname          = 'temp_class'
        stypvar(1)%cunits         = '[]'
        stypvar(1)%valid_min      = 0.
        stypvar(1)%valid_max      = 100.
        stypvar(1)%clong_name     = 'class of potential temperature'
        stypvar(1)%cshort_name    = 'temp_class'

        stypvar(2)%cname          = 'temptrp'//TRIM(csuffixvarname)
        stypvar(2)%cunits         = 'Sv'
        stypvar(2)%valid_min      = -1000.
        stypvar(2)%valid_max      = 1000.
        stypvar(2)%clong_name     = TRIM(cprefixlongname)//'transport in temperature class'
        stypvar(2)%cshort_name    = 'temptrp'
     ELSE
        stypvar(1)%cname          = 'sigma_class'
        stypvar(1)%cunits         = '[]'
        stypvar(1)%valid_min      = 0.
        stypvar(1)%valid_max      = 100.
        stypvar(1)%clong_name     = 'class of potential density'
        stypvar(1)%cshort_name    = 'sigma_class'

        stypvar(2)%cname          = 'sigtrp'//TRIM(csuffixvarname)
        stypvar(2)%cunits         = 'Sv'
        stypvar(2)%valid_min      = -1000.
        stypvar(2)%valid_max      = 1000.
        stypvar(2)%clong_name     = TRIM(cprefixlongname)//'transport in sigma class'
        stypvar(2)%cshort_name    = 'sigtrp'
     ENDIF


     ! create output fileset
     IF (ltemp) THEN
        cf_outnc = TRIM(csection(jsec))//'_trptemp.nc'
     ELSE
        cf_outnc = TRIM(csection(jsec))//'_trpsig.nc'
     ENDIF

     ncout = create      (cf_outnc, 'none',  ikx,      iky, nbins, cdep=cv_dep               )
     ierr  = createvar   (ncout,    stypvar, nboutput, ipk, id_varout, cdglobal=TRIM(cglobal))
     ierr  = putheadervar(ncout,    cf_brfi, ikx,      iky, nbins, &
          &   pnavlon=rdumlon, pnavlat=rdumlat, pdep=REAL(dsigma_lev), cdep=cv_dep           )

     dtim = getvar1d(cf_brfi, cn_vtimec, 1     )
     ierr = putvar1d(ncout,   dtim,      1, 'T')

     DO jiso=1,nbins
        rdummy1 = dsigma_lev(jiso)
        rdummy2 = dtrpbin(jsec,jiso)/1.d6  ! Sv
        ierr    = putvar(ncout, id_varout(1), rdummy1, jiso, ikx, iky )
        ierr    = putvar(ncout, id_varout(2), rdummy2, jiso, ikx, iky )
     END DO

     ierr = closeout(ncout)

  END DO

9004 FORMAT(f9.4, 20e16.7)
9005 FORMAT('#',a9, 20(2x,a12,2x) )
9006 FORMAT('# ',a)

CONTAINS
  SUBROUTINE section_init(cdfile, cdsection, cdvarname, cdlongname, kimin, kimax, kjmin, kjmax, knumber)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE section_init  ***
    !!
    !! ** Purpose : Read input ASCII file that defines section names and limit of
    !!              sections.
    !!
    !! ** Method  : At fisrt call only return the number of sections for further
    !!              allocation.  
    !!
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*),                       INTENT(in   ) :: cdfile
    CHARACTER(LEN=256), DIMENSION(knumber), INTENT(out  ) :: cdsection
    CHARACTER(LEN=256), DIMENSION(knumber), INTENT(out  ) :: cdvarname
    CHARACTER(LEN=256), DIMENSION(knumber), INTENT(out  ) :: cdlongname
    INTEGER(KIND=4),                        INTENT(inout) :: knumber
    INTEGER(KIND=4), DIMENSION(knumber),    INTENT(out  ) :: kimin, kimax, kjmin, kjmax

    ! Local variables
    INTEGER(KIND=4)                                       :: jsec
    INTEGER(KIND=4)                                       :: ii, inum=10
    INTEGER(KIND=4)                                       :: ipos  
    CHARACTER(LEN=256)                                    :: cline
    CHARACTER(LEN=80), DIMENSION(3)                       :: cldum
    LOGICAL                                               :: llfirst
    !!----------------------------------------------------------------------
    llfirst=.FALSE.
    IF ( knumber == 0 ) llfirst=.TRUE.

    OPEN(inum, FILE=cdfile)
    REWIND(inum)
    ii = 0

    ! read the file just to count the number of sections
    DO
       READ(inum,'(a)') cline
       IF (INDEX(cline,'EOF') == 0 ) THEN
          READ(inum,*)    ! skip one line
          ii = ii + 1
       ELSE
          EXIT
       ENDIF
    END DO

    knumber=ii
    IF ( llfirst ) RETURN

    REWIND(inum)
    DO jsec=1,knumber
       READ(inum,'(a)') cline
       ii = 0
       cldum(:) = 'none'
       ipos = INDEX(cline,' ')
       DO WHILE ( ipos > 1 ) 
          ii = ii + 1
          cldum(ii) = cline(1:ipos - 1 )
          cline = TRIM ( cline(ipos+1:) )
          ipos  = INDEX( cline,' ' ) 
          IF ( ii >= 3 ) EXIT
       END DO
       cdsection(jsec) = TRIM(cldum(1) )
       cdvarname(jsec) = TRIM(cldum(2) )
       cdlongname(jsec) = TRIM(cldum(3) )
       READ(inum,*    ) kimin(jsec), kimax(jsec), kjmin(jsec), kjmax(jsec)
    END DO

    CLOSE(inum)

  END SUBROUTINE section_init

  SUBROUTINE cdf_writ( ksec)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE cdf_writ  ***
    !!
    !! ** Purpose :  Write output cdf files if required 
    !!
    !! ** Method  :  Most of the variables are global 
    !!
    !!----------------------------------------------------------------------
    INTEGER(KIND=4),   INTENT(in) :: ksec  ! number of the section

    INTEGER(KIND=4)               :: ji, jk
    INTEGER(KIND=4)               :: ivar
    INTEGER(KIND=4)               :: icout
    INTEGER(KIND=4), DIMENSION(4) :: ipk, id_varout

    REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zdum
    TYPE(variable),  DIMENSION(4) :: sl_typvar
    CHARACTER(LEN=255)            :: csuffixvarnam
    CHARACTER(LEN=255)            :: cprefixlongnam
    !!----------------------------------------------------------------------
    IF ( cvarname(ksec) /= 'none' ) THEN
       csuffixvarnam = '_'//TRIM(cvarname(ksec))
    ELSE
       csuffixvarnam = ''
    ENDIF
    IF ( clongname(ksec) /= 'none' ) THEN
       cprefixlongnam = TRIM(clongname(ksec))//'_'
    ELSE
       cprefixlongnam = ''
    ENDIF

    ALLOCATE ( zdum(npts,1))
    ! (along section, depth ) 2D variables
    cf_nc=TRIM(csection(ksec))//'_secdep.nc'
    ! define variables
    ipk(:)=nk
    sl_typvar%rmissing_value    = 0.
    sl_typvar%rmissing_value    = 0.
    sl_typvar%scale_factor      = 1.
    sl_typvar%add_offset        = 0.
    sl_typvar%savelog10         = 0.
    sl_typvar%iwght             = iweight
    sl_typvar%conline_operation = 'N/A'
    sl_typvar%caxis             = 'XZT'

    ivar=1
    sl_typvar(ivar)%cname          = 'temperature'//TRIM(csuffixvarnam)
    sl_typvar(ivar)%cunits         = 'Celsius'
    sl_typvar(ivar)%valid_min      = -2.
    sl_typvar(ivar)%valid_max      = 45.
    sl_typvar(ivar)%clong_name     = TRIM(cprefixlongnam)//'Potential_temperature'
    sl_typvar(ivar)%cshort_name    = 'temperature'

    ivar=ivar+1
    sl_typvar(ivar)%cname          = 'salinity'//TRIM(csuffixvarnam)
    sl_typvar(ivar)%cunits         = 'PSU'
    sl_typvar(ivar)%valid_min      = 0.
    sl_typvar(ivar)%valid_max      = 45.
    sl_typvar(ivar)%clong_name     = TRIM(cprefixlongnam)//'Salinity'
    sl_typvar(ivar)%cshort_name    = 'salinity'

    ivar=ivar+1
    sl_typvar(ivar)%cname          = 'density'//TRIM(csuffixvarnam)
    sl_typvar(ivar)%cunits         = 'kg/m3 -1000'
    sl_typvar(ivar)%valid_min      = 0.
    sl_typvar(ivar)%valid_max      = 45.
    sl_typvar(ivar)%clong_name     = TRIM(cprefixlongnam)//'potential_density'
    sl_typvar(ivar)%cshort_name    = 'density'

    ivar=ivar+1
    sl_typvar(ivar)%cname          = 'velocity'//TRIM(csuffixvarnam)
    sl_typvar(ivar)%cunits         = 'm/s'
    sl_typvar(ivar)%valid_min      = -3.
    sl_typvar(ivar)%valid_max      = 3.
    sl_typvar(ivar)%clong_name     = TRIM(cprefixlongnam)//'Normal_velocity'
    sl_typvar(ivar)%cshort_name    = 'velocity'

    icout = create      (cf_nc, 'none',    npts, 1, nk, cdep=cn_vdeptht                     )
    ierr  = createvar   (icout, sl_typvar, ivar, ipk, id_varout, cdglobal=TRIM(cglobal)     )
    ierr  = putheadervar(icout, cf_brfi,   npts, 1, nk, &
         &   pnavlon=rlonlat, pnavlat=rlonlat, cdep=cn_vdeptht                              )

    !    dtim = getvar1d(cf_brfi, cn_vtimec, 1     )
    !    ierr = putvar1d(icout,   dtim,      1, 'T')

    DO jk = 1, nk
       zdum(:,1)=zt(:,jk)   ; ierr = putvar ( icout, id_varout(1), zdum, jk, npts, 1 )
       zdum(:,1)=zs(:,jk)   ; ierr = putvar ( icout, id_varout(2), zdum, jk, npts, 1 )
       zdum(:,1)=dsig(:,jk) ; ierr = putvar ( icout, id_varout(3), zdum, jk, npts, 1 )
       zdum(:,1)=zu(:,jk)   ; ierr = putvar ( icout, id_varout(4), zdum, jk, npts, 1 )
    END DO

    ierr = closeout(icout)

    ! (along section, sigma ) 2D variables
    cf_nc=TRIM(csection(ksec))//'_secsig.nc'
    ! define variables
    ipk(:)=nbins
    sl_typvar%rmissing_value    = 99999.
    sl_typvar%rmissing_value    = 99999.
    sl_typvar%scale_factor      = 1.
    sl_typvar%add_offset        = 0.
    sl_typvar%savelog10         = 0.
    sl_typvar%iwght             = iweight
    sl_typvar%conline_operation = 'N/A'
    sl_typvar%caxis             = 'XST'

    ivar=1
    ipk(ivar)=nbins-1
    sl_typvar(ivar)%cname          = 'isodep'//TRIM(csuffixvarnam)
    sl_typvar(ivar)%cunits         = 'm'
    sl_typvar(ivar)%valid_min      = 0.
    sl_typvar(ivar)%valid_max      = 6000.
    sl_typvar(ivar)%clong_name     = TRIM(cprefixlongnam)//'isopycnal_depth'
    sl_typvar(ivar)%cshort_name    = 'isodep'

    ivar=ivar+1
    sl_typvar(ivar)%cname          = 'bintrp'//TRIM(csuffixvarnam)
    sl_typvar(ivar)%cunits         = 'SV'
    sl_typvar(ivar)%valid_min      = -5.
    sl_typvar(ivar)%valid_max      = 5.
    sl_typvar(ivar)%clong_name     = TRIM(cprefixlongnam)//'Binned_transport'
    sl_typvar(ivar)%cshort_name    = 'bintrp'

    ivar=ivar+1
    sl_typvar(ivar)%cname          = 'sumtrp'//TRIM(csuffixvarnam)
    sl_typvar(ivar)%cunits         = 'SV'
    sl_typvar(ivar)%valid_min      = -20.
    sl_typvar(ivar)%valid_max      = 20.
    sl_typvar(ivar)%clong_name     = TRIM(cprefixlongnam)//'cumulated_transport'
    sl_typvar(ivar)%cshort_name    = 'sumtrp'

    icout = create      (cf_nc, 'none',    npts, 1, nbins, cdep='levels'                 )
    ierr  = createvar   (icout, sl_typvar, ivar, ipk, id_varout, cdglobal=TRIM(cglobal)  )
    ierr  = putheadervar(icout, cf_brfi,   npts, 1, nbins, &
         &   pnavlon=rlonlat, pnavlat=rlonlat, pdep=REAL(dsigma_lev), cdep='levels'      )

    PRINT *, 'NBINS', nbins, npts
    DO jk = 1, nbins-1
       zdum(:,1)=dhiso   (:,jk)      ; ierr = putvar ( icout, id_varout(1), zdum, jk, npts, 1 )
    END DO
    DO jk = 1, nbins
       zdum(:,1)=dwtrpbin(:,jk)/1.e6 ; ierr = putvar ( icout, id_varout(2), zdum, jk, npts, 1 )
       zdum(:,1)=dwtrp   (:,jk)/1.e6 ; ierr = putvar ( icout, id_varout(3), zdum, jk, npts, 1 )
    END DO
    ierr = closeout(icout)

    DEALLOCATE ( zdum )

  END SUBROUTINE cdf_writ

  SUBROUTINE print_out(ksec)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE print_out  ***
    !!
    !! ** Purpose :  Print results on standard output 
    !!
    !! ** Method  :  Most of the variables are global and already known 
    !!
    !!----------------------------------------------------------------------
    INTEGER(KIND=4), INTENT(in) :: ksec  ! number of the section

    INTEGER(KIND=4)             :: ji, jk, jiso, jbin
    !!----------------------------------------------------------------------
    WRITE(cfmt_9000,'(a,i4,a)') '(i7,  ',npts,'f8.3)'
    WRITE(cfmt_9001,'(a,i4,a)') '(i7,  ',npts,'f8.0)'
    WRITE(cfmt_9002,'(a,i4,a)') '(f7.3,',npts,'f8.0)'
    WRITE(cfmt_9003,'(a,i4,a)') '(f7.3,',npts,'f8.3)'
    PRINT *,' T (deg C)' 
    DO jk=1,nk
       PRINT cfmt_9000, jk,  (zt(ji,jk),ji=1,npts)
    END DO

    PRINT *,' S (PSU)'
    DO jk=1,nk
       PRINT cfmt_9000,  jk,  (zs(ji,jk),ji=1,npts)
    END DO

    PRINT *,' SIG (kg/m3 - 1000 )'
    DO jk=1,nk
       PRINT cfmt_9000, jk,  (dsig(ji,jk),ji=1,npts)
    END DO

    PRINT *,' VELOCITY (cm/s ) '
    DO jk=1,nk
       PRINT cfmt_9000, jk,  (zu(ji,jk)*100,ji=1,npts)
    END DO

    PRINT *,' GDEPU (m) '
    DO jk=1,nk
       PRINT cfmt_9001,jk,  (ddepu(ji,jk)*zmask(ji,jk),ji=1,npts)
    END DO

    PRINT *, 'E3 (m)'
    DO jk=1,nk
       PRINT cfmt_9001,jk,  (de3(ji,jk)*zmask(ji,jk),ji=1,npts)
    END DO

    PRINT *,' DEP ISO ( m )'
    DO  jiso =1, nbins+1
       PRINT cfmt_9002, dsigma_lev(jiso),(dhiso(ji,jiso),ji=1,npts)
    END DO

    PRINT *,' TRP SURF -->  ISO (SV)'
    DO  jiso =1, nbins+1
       PRINT  cfmt_9003, dsigma_lev(jiso),(dwtrp(ji,jiso)/1.d6,ji=1,npts)
    END DO

    PRINT *,' TRP bins (SV)'
    DO  jbin =1, nbins
       PRINT  cfmt_9003, dsigma_lev(jbin),(dwtrpbin(ji,jbin)/1.d6,ji=1,npts), dtrpbin(ksec,jbin)/1.d6
    END DO

  END SUBROUTINE print_out

END PROGRAM cdfsigtrp_broken

PROGRAM cdfmkmask
   !!======================================================================
   !!                     ***  PROGRAM  cdfmkmask  ***
   !!=====================================================================
   !!  ** Purpose : Build mask file from a salinity output
   !!
   !!  ** Method  : Read vosaline and set tmask to 1 where sal is not 0
   !!               then umask, vmask and fmask are deduced from tmask
   !!               REM: the result may be locally different for fmask than
   !!                   fmask produced online as there are computed on line
   !!               merged with cdfmkmask-zone by adding a zoom option. When
   !!               used with -zoom option, the mask is 0 outside the zoom
   !!               area.
   !!
   !! History : 2.1  : 11/2005  : J.M. Molines : Original code
   !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
   !! Modified : 3.0 : 08/2011  : P.   Mathiot : Add zoomij, zoombat, zoomvar and time option
   !!----------------------------------------------------------------------
   USE cdfio
   USE modcdfnames
   !!----------------------------------------------------------------------
   !! CDFTOOLS_3.0 , MEOM 2011
   !! $Id$
   !! Copyright (c) 2011, J.-M. Molines
   !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
   !!----------------------------------------------------------------------
   IMPLICIT NONE

   INTEGER(KIND=4)                           :: ji, jj, jk, jt           ! dummy loop index
   INTEGER(KIND=4)                           :: ierr                     ! working integer
   INTEGER(KIND=4)                           :: narg, iargc, ijarg       ! 
   INTEGER(KIND=4)                           :: npiglo, npjglo, npk, nt  ! size of the domain
   INTEGER(KIND=4)                           :: iimin, iimax             ! limit in i
   INTEGER(KIND=4)                           :: ijmin, ijmax             ! limit in j
   INTEGER(KIND=4)                           :: ncout                    ! ncid of output file
   INTEGER(KIND=4), DIMENSION(4)             :: ipk, id_varout           ! outptut variables : number of levels,
   INTEGER(KIND=4), DIMENSION(:,:), ALLOCATABLE :: mbathy                ! bathymetry  in levels

   REAL(KIND=4)                              :: rlonmin, rlonmax         ! limit in longitude
   REAL(KIND=4)                              :: rlatmin, rlatmax         ! limit in latitude
   REAL(KIND=4)                              :: rbatmin, rbatmax         ! limit in latitude
   REAL(KIND=4)                              :: rvarmin, rvarmax         ! limit in variable
   REAL(KIND=4), DIMENSION(:)  , ALLOCATABLE :: tim                      ! time counter
   REAL(KIND=4), DIMENSION(:)  , ALLOCATABLE :: rdep                     ! depth 
   REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: tmask, zmask             ! 2D mask at current level
   REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: rlon, rlat               ! latitude and longitude
   REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: rbat                     ! bathymetry 

   CHARACTER(LEN=256)                        :: cf_tfil                  ! file name
   CHARACTER(LEN=256)                        :: cf_out = 'mask_sal.nc'   ! output file
   CHARACTER(LEN=256)                        :: cv_mask                  ! variable name
   CHARACTER(LEN=256)                        :: cv_dep                   ! variable name
   CHARACTER(LEN=256)                        :: cldum                    ! dummy string

   TYPE (variable), DIMENSION(4)             :: stypvar                  ! output attribute

   LOGICAL                                   :: lzoom    = .false.       ! zoom flag lat/lon
   LOGICAL                                   :: lzoomij  = .false.       ! zoom flag i/j
   LOGICAL                                   :: lzoombat = .false.       ! zoom flag bat
   LOGICAL                                   :: lzoomvar = .false.       ! zoom flag var
   LOGICAL                                   :: ltime    = .false.       ! time flag    
   LOGICAL                                   :: lmbathy  = .false.       ! mbathy flag    
   !!----------------------------------------------------------------------
   CALL ReadCdfNames()

   narg = iargc()
   IF ( narg == 0 ) THEN
      PRINT *,' usage : cdfmkmask T-file [-zoom lonmin lonmax latmin latmax] ...'
      PRINT *,'                   ... [-zoomij iimin iimax ijmin ijmax] ...'
      PRINT *,'                   ... [-zoombat bathymin bathymax]  ...'
      PRINT *,'                   ... [-o OUT-file ]'
      PRINT *,'      '
      PRINT *,'     PURPOSE :'
      PRINT *,'       Build a mask file from vosaline array read from the input file.' 
      PRINT *,'       It assumes that land salinity values are set to 0.'
      PRINT *,'      '
      PRINT *,'     ARGUMENTS :'
      PRINT *,'       T-file : netcdf file with salinity.' 
      PRINT *,'                if T-file = -maskfile, we assume a reference file named ',TRIM(cn_fmsk)
      PRINT *,'                with tmask variable.' 
      PRINT *,'                if T-file = -mbathy, we assume a reference file named '
      PRINT *,'                bathylevel.nc with mbathy variable, giving the number of '
      PRINT *,'                levels in the ocean.' 
      PRINT *,'      '
      PRINT *,'     OPTIONS :'
      PRINT *,'       [-zoom lonmin lonmax latmin latmax] : geographical windows used to'
      PRINT *,'                        limit the area where the mask is builded. Outside'
      PRINT *,'                        this area, the mask is set to 0.'
      PRINT *,'       [-zoomij iimin iimax ijmin ijmax] : model grid windows used to'
      PRINT *,'                        limit the area where the mask is builded. Outside'
      PRINT *,'                        this area, the mask is set to 0.'
      PRINT *,'       [-zoombat bathymin bathymax] : depth windows used to'
      PRINT *,'                        limit the area where the mask is builded. Outside'
      PRINT *,'                        this area, the mask is set to 0.' 
      PRINT *,'                        Need mesh_zgr.nc'
      PRINT *,'       [-zoomvar varname varmin varmax] : range of varname used to'
      PRINT *,'                        limit the area where the mask is builded. Outside'
      PRINT *,'                        this area, the mask is set to 0.'
      PRINT *,'       [-time ] : If further time step is available'
      PRINT *,'                        a mask for each time step is done'
      PRINT *,'       [-o OUT-file ] : output file name to be used in place of standard'
      PRINT *,'                        name [ ',TRIM(cf_out),' ]'
      PRINT *,'      '
      PRINT *,'     REQUIRED FILES :'
      PRINT *,'       If option -zoombat is used, file ', TRIM(cn_fzgr),' is required.'
      PRINT *,'       If option T-file is -maskfile then ', TRIM(cn_fmsk), ' is required.'
      PRINT *,'       If option T-file is -mbathy then bathylevel.nc and ', TRIM(cn_fzgr) 
      PRINT *,'        are required.'
      PRINT *,'      '
      PRINT *,'     OUTPUT : '
      PRINT *,'       netcdf file : ', TRIM(cf_out), ' or OUT-file.'
      PRINT *,'         variables : tmask, umask, vmask, fmask'
      PRINT *,'                fmask can differ from standard fmask because it does not'
      PRINT *,'                reflect the slip/noslip lateral condition.'
      STOP
   ENDIF

   ijarg = 1
   CALL getarg (ijarg, cf_tfil) ; ijarg = ijarg + 1

   DO WHILE ( ijarg <= narg ) 
      CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1
      SELECT CASE ( cldum )
         !
      CASE ( '-zoom' )  ! read a zoom lat/lon area
         lzoom = .true.
         CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) rlonmin
         CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) rlonmax
         CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) rlatmin
         CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) rlatmax
         !
      CASE ( '-zoomij' )  ! read a zoom i/j area
         lzoomij = .true.
         CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) iimin
         CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) iimax
         CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) ijmin
         CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) ijmax
         !
      CASE ( '-zoombat' )  ! read a zoom bathy area 
         lzoombat = .true.
         CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) rbatmin
         CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) rbatmax
         !
      CASE ( '-zoomvar' ) ! read a zoom variable area
         lzoomvar = .true.
         CALL getarg (ijarg, cv_mask) ; ijarg = ijarg + 1 ;
         CALL getarg (ijarg, cldum)   ; ijarg = ijarg + 1 ; READ(cldum,*) rvarmin 
         CALL getarg (ijarg, cldum)   ; ijarg = ijarg + 1 ; READ(cldum,*) rvarmax 
      CASE ( '-time' )  ! create a mask for each time step of the file
         ltime=.true.
      CASE ( '-o'    )  ! change output file name
         CALL getarg (ijarg, cf_out) ; ijarg = ijarg + 1
         !
      CASE DEFAULT
         PRINT *, 'ERROR : unknown option :', TRIM(cldum)
         STOP
      END SELECT
   ENDDO

   IF ( lzoom .AND. lzoomij ) PRINT *, 'WARNING 2 spatial condition for mask'

   IF (.NOT. lzoomvar) cv_mask = cn_vosaline
   IF (TRIM(cf_tfil)=='-maskfile') THEN
      cv_mask = 'tmask'
      cf_tfil = cn_fmsk
      cn_z    = 'z'
   END IF

   IF (TRIM(cf_tfil)=='-mbathy') THEN
      cv_mask = 'mbathy'
      cv_dep  = 'nav_lev'
      cf_tfil = 'bathylevel.nc'
      cn_z    = 'z'
      lmbathy = .TRUE.
      IF ( chkfile(cn_fzgr) ) STOP ! missing file
   END IF

   IF ( chkfile(cf_tfil) ) STOP ! missing file

   npiglo = getdim (cf_tfil,cn_x)
   npjglo = getdim (cf_tfil,cn_y)
   IF ( lmbathy ) THEN
      npk  = getdim (cn_fzgr,cn_z)
      ALLOCATE ( rdep(npk) )
   ELSE
      npk  = getdim (cf_tfil,cn_z)
   ENDIF
   nt     = getdim (cf_tfil,cn_t)

   PRINT *,' npiglo = ', npiglo
   PRINT *,' npjglo = ', npjglo
   PRINT *,' npk    = ', npk
   PRINT *,' nt     = ', nt 

   IF ( nt == 0 ) THEN
      PRINT *,' nt is forced to 1'
      nt = 1
   ENDIF

   IF ((nt > 1) .AND. (.NOT. ltime)) THEN 
      PRINT *, "WARNING nt > 1"
      PRINT *, "we used only the first time step"
      nt=1
   END IF


   ipk(1:4)                       = npk
   stypvar(1)%cname               = 'tmask'
   stypvar(2)%cname               = 'umask'
   stypvar(3)%cname               = 'vmask'
   stypvar(4)%cname               = 'fmask'

   stypvar(1:4)%cunits            = '1/0'
   stypvar(1:4)%rmissing_value    = 9999.
   stypvar(1:4)%valid_min         = 0.
   stypvar(1:4)%valid_max         = 1.

   stypvar(1)%clong_name          = 'tmask'
   stypvar(2)%clong_name          = 'umask'
   stypvar(3)%clong_name          = 'vmask'
   stypvar(4)%clong_name          = 'fmask'

   stypvar(1)%cshort_name         = 'tmask'
   stypvar(2)%cshort_name         = 'umask'
   stypvar(3)%cshort_name         = 'vmask'
   stypvar(4)%cshort_name         = 'fmask'

   stypvar(1:4)%conline_operation = 'N/A'
   stypvar(1:4)%caxis             = 'TZYX'
   stypvar(1:4)%cprecision        = 'i2'

   ncout = create      (cf_out, cf_tfil,  npiglo, npjglo, npk)
   ierr  = createvar   (ncout,    stypvar, 4,      ipk,    id_varout )

   IF ( lmbathy ) THEN
     rdep(:) = getvare3(cn_fzgr, cv_dep ,npk)
     ierr  = putheadervar(ncout,    cf_tfil,  npiglo, npjglo, npk, pdep=rdep, cdep='nav_lev')
   ELSE
     ierr  = putheadervar(ncout,    cf_tfil,  npiglo, npjglo, npk)
   ENDIF

   !! Allocate only usefull variable and read only usefull variable
   ALLOCATE (tmask(npiglo,npjglo), zmask(npiglo,npjglo), tim(nt))

   IF ( lmbathy ) THEN
      ALLOCATE (mbathy(npiglo,npjglo))
   ENDIF

   IF ( lzoom ) THEN
      ALLOCATE (rlon(npiglo,npjglo), rlat(npiglo,npjglo))
      rlon(:,:) = getvar(cf_tfil, cn_vlon2d, 1, npiglo, npjglo)
      rlat(:,:) = getvar(cf_tfil, cn_vlat2d, 1, npiglo, npjglo)
   ENDIF

   IF ( lzoombat ) THEN
      IF ( chkfile(cn_fzgr) ) STOP ! missing file
      ALLOCATE ( rbat  (npiglo,npjglo) )
      rbat(:,:)= getvar(cn_fzgr, cn_hdepw,  1 ,npiglo, npjglo)
   END IF

   IF ( lmbathy ) THEN
      mbathy(:,:) = getvar(cf_tfil, cv_mask, 1, npiglo, npjglo)
   ENDIF

   !! Now compute the mask 
   DO jt=1, nt
      IF (MOD(jt,10)==0) PRINT *,jt,'/',nt,' ...'
      DO jk=1, npk
         ! tmask
         IF ( lmbathy ) THEN
            tmask(:,:) = 1.
            WHERE (mbathy < jk ) tmask = 0.
         ELSE
            tmask(:,:) = getvar(cf_tfil, cv_mask,  jk, npiglo, npjglo, ktime=jt)
         ENDIF

         IF ( lzoomvar ) THEN
            zmask=tmask
            WHERE ((tmask .GE. rvarmin) .AND. (tmask .LE. rvarmax)) zmask = 1
            WHERE ((tmask .LT. rvarmin) .OR.  (tmask .GT. rvarmax)) zmask = 0
            tmask=zmask
         ELSE
            WHERE (tmask > 0 ) tmask = 1
            WHERE (tmask <=0 ) tmask = 0
         ENDIF

         IF ( lzoom ) THEN
            IF (rlonmax > rlonmin) THEN
               WHERE (rlon > rlonmax ) tmask = 0
               WHERE (rlon < rlonmin ) tmask = 0
            ELSE
               WHERE (rlon < rlonmin .AND. rlon > rlonmax ) tmask = 0
            END IF

            WHERE (rlat > rlatmax ) tmask = 0
            WHERE (rlat < rlatmin ) tmask = 0
         ENDIF

         IF ( lzoomij ) THEN
            tmask(1:iimin-1,:     ) = 0   ! West
            tmask(iimax+1:npiglo,:) = 0   ! East
            tmask(:,ijmax+1:npjglo) = 0   ! North
            tmask(:,1:ijmin-1     ) = 0   ! South
         ENDIF

         IF ( lzoombat ) THEN
            WHERE (rbat < rbatmin .OR. rbat > rbatmax) tmask = 0
         ENDIF

         ierr       = putvar(ncout, id_varout(1), tmask, jk ,npiglo, npjglo, ktime=jt)
         ! umask
         zmask = 0.
         DO ji=1,npiglo-1
            DO jj=1,npjglo
               zmask(ji,jj) = tmask(ji,jj)*tmask(ji+1,jj)
            END DO
         END DO
         ierr       = putvar(ncout, id_varout(2), zmask, jk ,npiglo, npjglo, ktime=jt)
         ! vmask
         zmask=0.
         DO ji=1,npiglo
            DO jj=1,npjglo-1
               zmask(ji,jj) = tmask(ji,jj)*tmask(ji,jj+1)
            END DO
         END DO
         ierr       = putvar(ncout, id_varout(3), zmask, jk, npiglo, npjglo, ktime=jt)
         !fmask
         zmask=0.
         DO ji=1,npiglo-1
            DO jj=1,npjglo-1
               zmask(ji,jj) = tmask(ji,jj)*tmask(ji,jj+1)*tmask(ji+1,jj)*tmask(ji+1,jj+1)
            END DO
         END DO
         ierr       = putvar(ncout, id_varout(4), zmask, jk, npiglo, npjglo, ktime=jt)
      END DO  ! loop to next level
   END DO

   tim(:) = 0.
   ierr   = putvar1d(ncout, tim, nt,'T')
   ierr   = closeout(ncout              )

   PRINT *,''
   PRINT *,'Mask file ',TRIM(cf_out),' has been created' 

END PROGRAM cdfmkmask

PROGRAM cdfgeo_uv
  !!======================================================================
  !!                     ***  PROGRAM  cdfgeo_uv  ***
  !!=====================================================================
  !!  ** Purpose : Compute the ug and vg component of the geostrophic 
  !!               velocity from the SSH field
  !!
  !!  ** Method  : ug = -g/f * d(ssh)/dy
  !!               vg =  g/f * d(ssh)/dx
  !!
  !!  **  Note : ug is located on a V grid point
  !!             vg                 U grid point
  !!
  !!
  !! History : 2.1  : 02/2008  : J. Juanno    : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic. and bug fix
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class derived_fields
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: ji, jj, jt     ! dummy loop index
  INTEGER(KIND=4)                           :: npiglo, npjglo ! size of the domain
  INTEGER(KIND=4)                           :: npk, npt       ! size of the domain
  INTEGER(KIND=4)                           :: narg, iargc    ! browse line
  INTEGER(KIND=4)                           :: ijarg          ! browse line
  INTEGER(KIND=4)                           :: ncoutu         ! ncid for ugeo file
  INTEGER(KIND=4)                           :: ncoutv         ! ncid for vgeo file
  INTEGER(KIND=4)                           :: ierr           ! error status
  INTEGER(KIND=4)                           :: ioption=0      ! Option for C-grid interpolation
  INTEGER(KIND=4), DIMENSION(1)             :: ipk            ! levels of output vars
  INTEGER(KIND=4), DIMENSION(1)             :: id_varoutu     ! varid for ugeo
  INTEGER(KIND=4), DIMENSION(1)             :: id_varoutv     ! varid for vgeo

  REAL(KIND=4)                              :: grav           ! gravity
  REAL(KIND=4)                              :: ffu, ffv       ! coriolis param f at U and V point
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e1u, e2v, ff   ! horiz metrics, coriolis (f-point)
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e2u, e1v       ! horiz metrics
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: glamu, gphiu   ! longitude latitude u-point
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: glamv, gphiv   ! longitude latitude v-point
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: un, vn         ! velocity components
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zun, zvn       ! velocity components
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zsshn          ! ssh
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zwrk           ! working array for interpolation
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: umask, vmask   ! mask at u and v points

  REAL(KIND=8), DIMENSION(:),   ALLOCATABLE :: dtim           ! time counter

  CHARACTER(LEN=256)                        :: cf_tfil        ! input file name
  CHARACTER(LEN=256)                        :: cf_uout='ugeo.nc' 
  CHARACTER(LEN=256)                        :: cf_vout='vgeo.nc'
  CHARACTER(LEN=256)                        :: cldum          ! dummy character variable
  CHARACTER(LEN=256)                        :: cl_global      ! global attribute

  TYPE(variable), DIMENSION(1)              :: stypvaru       ! attributes for ugeo
  TYPE(variable), DIMENSION(1)              :: stypvarv       ! attributes for vgeo

  LOGICAL                                   :: lchk           ! file existence flag
  LOGICAL                                   :: lnc4 = .FALSE. ! Use nc4 with chunking and deflation
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  grav = 9.81  ! gravity

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfgeo-uv -f T-file [-o UOUT-file VOUT-file ] [-ssh SSH-var] ...'
     PRINT *,'              ...[-nc4] [-C option]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'         Compute the geostrophic velocity components from the gradient of the'
     PRINT *,'         SSH read in the input file. '
     PRINT *,'      '
     PRINT *,'         Without any -C option, the zonal component is located on a C-grid '
     PRINT *,'         V point, the meridional one is located on a C-grid U point. See the'
     PRINT *,'         use of the -C option in order to have (Ugeo, Vgeo) at (U,V) points on'
     PRINT *,'         the C-grid.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'      -f T-file : netcdf file with SSH (input).' 
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'      [-o UOUT-file VOUT-file]: specify the names of the output files.'
     PRINT *,'              Default are: ',TRIM(cf_uout),' ',TRIM(cf_vout),'.'
     PRINT *,'      [-nc4]: Use netcdf4 output with chunking and deflation level 1.'
     PRINT *,'              This option is effective only if cdftools are compiled with'
     PRINT *,'              a netcdf library supporting chunking and deflation.'
     PRINT *,'      [-C option]: Using this option, the output velocity component are at the'
     PRINT *,'              correct (U,V) points on the C-grid. Two options are available :'
     PRINT *,'           option = 1 : SSH is interpolated on the F point prior derivation.'
     PRINT *,'           option = 2 : Ugeo and Vgeo are interpolated on the C-grid after'
     PRINT *,'              derivation.'
     PRINT *,'              Both options should give very similar results...'
     PRINT *,'      [-ssh SSH-var ]: give the name of the SSH variable if not ',TRIM(cn_sossheig)
     PRINT *,'  '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        ',TRIM(cn_fhgr),' and ',TRIM(cn_fzgr)
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       - netcdf file : ', TRIM(cf_uout) ,' (default)'
     PRINT *,'           variables : ', TRIM(cn_vozocrtx)
     PRINT *,'           Unless -C option is used : '
     PRINT *,'             *** CAUTION:  this variable is located on V-point ***'
     PRINT *,'       - netcdf file : ', TRIM(cf_vout) ,' (default)'
     PRINT *,'           variables : ', TRIM(cn_vomecrty)
     PRINT *,'           Unless -C option is used : '
     PRINT *,'             *** CAUTION:  this variable is located on U-point ***'
     PRINT *,'      '
     STOP 
  ENDIF

  ijarg = 1
  DO WHILE ( ijarg <= narg )
     CALL getarg(ijarg, cldum ) ; ijarg = ijarg + 1
     SELECT CASE ( cldum )
     CASE ('-f'   ) ; CALL getarg(ijarg, cf_tfil     ) ; ijarg = ijarg + 1 
        ! options
     CASE ('-o'   ) ; CALL getarg(ijarg, cf_uout     ) ; ijarg = ijarg + 1
        ;             CALL getarg(ijarg, cf_vout     ) ; ijarg = ijarg + 1
     CASE ('-nc4' ) ; lnc4 = .TRUE.
     CASE ('-C'   ) ; CALL getarg(ijarg, cldum       ) ; ijarg = ijarg + 1
        ;             READ(cldum, * ) ioption
     CASE ('-ssh' ) ; CALL getarg(ijarg, cn_sossheig ) ; ijarg = ijarg + 1 
     CASE DEFAULT   ; PRINT *, ' ERROR : ',TRIM(cldum),' :  unknown option.' ; STOP 99
     END SELECT
  ENDDO

  SELECT CASE ( ioption )
  CASE ( 0 )   ; PRINT *,' *** UGEO on V-point, VGEO on U-point ***' ; cl_global=' (Ugeo, Vgeo) are on (V,U) points of the C-grid'
  CASE ( 1 )   ; PRINT *,' *** Use SSH interpolation ***'            ; cl_global=' (Ugeo, Vgeo) are on (U,V) points of the C-grid (SSH interp)'
  CASE ( 2 )   ; PRINT *,' *** Use Ugeo Vgeo interpolation ***'      ; cl_global=' (Ugeo, Vgeo) are on (U,V) points of the C-grid (velocity interp)'
  CASE DEFAULT ;  PRINT *, ' +++ ERROR: -C can use only option 1 or 2 +++' ; STOP 99
  END SELECT
  
  lchk = chkfile(cn_fhgr)
  lchk = chkfile(cn_fzgr) .OR. lchk
  lchk = chkfile(cf_tfil) .OR. lchk
  IF ( lchk ) STOP 99 ! missing file

  npiglo = getdim(cf_tfil, cn_x)
  npjglo = getdim(cf_tfil, cn_y)
  npk    = getdim(cf_tfil, cn_z) 
  npt    = getdim(cf_tfil, cn_t) 

  PRINT *, ' NPIGLO= ', npiglo
  PRINT *, ' NPJGLO= ', npjglo
  PRINT *, ' NPK   = ', npk
  PRINT *, ' NPT   = ', npt

  ! Allocate the memory
  ALLOCATE ( e1u(npiglo,npjglo), e2v(npiglo,npjglo) )
  IF( ioption == 1 ) ALLOCATE ( e1v(npiglo,npjglo), e2u(npiglo,npjglo) )
  ALLOCATE ( ff(npiglo,npjglo), dtim(npt)  )
  ALLOCATE ( glamu(npiglo,npjglo), gphiu(npiglo,npjglo)  )
  ALLOCATE ( glamv(npiglo,npjglo), gphiv(npiglo,npjglo)  )
  ALLOCATE ( un(npiglo,npjglo), vn(npiglo,npjglo)  )
  IF ( ioption == 2 ) ALLOCATE ( zun(npiglo,npjglo), zvn(npiglo,npjglo)  )
  ALLOCATE ( zsshn(npiglo,npjglo) )
  ALLOCATE ( umask(npiglo,npjglo), vmask(npiglo,npjglo) )
  ALLOCATE ( zwrk (npiglo,npjglo) )

  ! Read the metrics from the mesh_hgr file
  e1u   = getvar(cn_fhgr, cn_ve1u,  1, npiglo, npjglo)
  e1v   = getvar(cn_fhgr, cn_ve1v,  1, npiglo, npjglo)
  e2u   = getvar(cn_fhgr, cn_ve2u,  1, npiglo, npjglo)
  e2v   = getvar(cn_fhgr, cn_ve2v,  1, npiglo, npjglo)
  ff    = getvar(cn_fhgr, cn_vff,   1, npiglo, npjglo) 

  glamu = getvar(cn_fhgr, cn_glamu, 1, npiglo, npjglo)
  gphiu = getvar(cn_fhgr, cn_gphiu, 1, npiglo, npjglo)
  glamv = getvar(cn_fhgr, cn_glamv, 1, npiglo, npjglo)
  gphiv = getvar(cn_fhgr, cn_gphiv, 1, npiglo, npjglo)

  CALL CreateOutputUV

  ! Read ssh
  DO jt=1,npt
     zwrk(:,:) = getvar(cf_tfil, cn_sossheig, 1, npiglo, npjglo, ktime=jt)
     IF ( ioption == 1 ) THEN
        PRINT *, ' *** interpolation of SSH ...'
        DO jj=1, npjglo -1
           DO ji=1, npiglo -1
              zsshn(ji,jj) = 0.25*( zwrk (ji,jj  ) +  zwrk (ji+1,jj  ) + &
                   &                zwrk (ji,jj+1) +  zwrk (ji+1,jj+1) )
           ENDDO
        ENDDO
     ELSE
        zsshn(:,:) = zwrk(:,:) 
     ENDIF

     IF ( jt == 1 ) THEN
        ! compute the masks (do not depend on time
        umask=0. ; vmask = 0
        DO jj = 1, npjglo 
           DO ji = 1, npiglo - 1
              umask(ji,jj) = zwrk(ji,jj)*zwrk(ji+1,jj)
              IF (umask(ji,jj) /= 0.) umask(ji,jj) = 1.
           END DO
        END DO

        DO jj = 1, npjglo - 1
           DO ji = 1, npiglo
              vmask(ji,jj) = zwrk(ji,jj)*zwrk(ji,jj+1)
              IF (vmask(ji,jj) /= 0.) vmask(ji,jj) = 1.
           END DO
        END DO
        ! e1u and e1v are modified to simplify the computation below
        ! note that geostrophy is not available near the equator ( f=0)
        IF ( ioption == 0 .OR. ioption == 2 ) THEN  ! SSH at T point
           DO jj=2, npjglo - 1
              DO ji=2, npiglo - 1
                 ffu = ff(ji,jj) + ff(ji,  jj-1)
                 IF ( ffu /= 0. ) THEN  ; e1u(ji,jj)= 2.* grav * umask(ji,jj) / ( ffu ) / e1u(ji,jj)
                 ELSE                   ; e1u(ji,jj)= 0.  ! spvalue
                 ENDIF

                 ffv = ff(ji,jj) + ff(ji-1,jj  )
                 IF ( ffv /= 0. ) THEN  ; e2v(ji,jj)= 2.* grav * vmask(ji,jj) / ( ffv ) / e2v(ji,jj)
                 ELSE                   ; e2v(ji,jj)= 0.  ! spvalue
                 ENDIF
              END DO
           END DO
        ELSE    ! SSH at F point
           DO jj=2, npjglo - 1
              DO ji=2, npiglo - 1
                 ffu = ff(ji,jj) + ff(ji,  jj-1)
                 IF ( ffu /= 0. ) THEN ; e2u(ji,jj)= 2.* grav * umask(ji,jj) / ( ffu ) / e2u(ji,jj)
                 ELSE                  ; e2u(ji,jj)= 0.  ! spvalue
                 ENDIF

                 ffv = ff(ji,jj) + ff(ji-1,jj  )
                 IF ( ffv /= 0. ) THEN ; e1v(ji,jj)= 2.* grav * vmask(ji,jj) / ( ffv ) / e1v(ji,jj)
                 ELSE                  ; e1v(ji,jj)= 0.  ! spvalue
                 ENDIF
              END DO
           ENDDO
        ENDIF
     END IF

     ! Calculation of geostrophic velocity :
     un(:,:) = 0.
     vn(:,:) = 0.

     IF ( ioption == 0 .OR. ioption == 2 ) THEN
        DO jj = 1,npjglo - 1
           DO ji = 1,npiglo -1
              vn(ji,jj) =   e1u(ji,jj) * ( zsshn(ji+1,jj  ) - zsshn(ji,jj) ) 
              un(ji,jj) = - e2v(ji,jj) * ( zsshn(ji  ,jj+1) - zsshn(ji,jj) ) 
           END DO
        END DO
     ELSE    ! SSH at F point
        DO jj = 2,npjglo 
           DO ji = 2,npiglo 
              vn(ji,jj) =   e1v(ji,jj) * ( zsshn(ji,jj) - zsshn(ji-1,jj) ) 
              un(ji,jj) = - e2u(ji,jj) * ( zsshn(ji,jj) - zsshn(ji,jj-1) ) 
           END DO
        END DO
     ENDIF

     IF ( ioption == 2 ) THEN ! interpolate ugeo, vgeo on (U,V) point
        PRINT *, ' *** interpolation of velocities ...'
        DO jj=2,npjglo -1
           DO ji=2, npiglo -1
              zun(ji,jj) = 0.25*( un(ji,jj) + un(ji, jj-1) + un(ji+1,jj) + un (ji+1, jj-1) )
              zvn(ji,jj) = 0.25*( vn(ji,jj) + vn(ji-1, jj) + vn(ji,jj+1) + vn (ji-1, jj+1) )
           ENDDO
        ENDDO
        un(:,:) = zun(:,:)
        vn(:,:) = zvn(:,:)
     ENDIF

     ! write un and vn  ...
     ! mask a 1 grid point wide rim where geostrophic velocities cannot be computed
     un(1,:) = 0. ; un(npiglo,:) = 0.
     vn(1,:) = 0. ; vn(npiglo,:) = 0.
     un(:,1) = 0. ; un(:,npjglo) = 0.
     vn(:,1) = 0. ; vn(:,npjglo) = 0.
     ierr = putvar(ncoutu, id_varoutu(1), un(:,:), 1, npiglo, npjglo, ktime=jt)
     ierr = putvar(ncoutv, id_varoutv(1), vn(:,:), 1, npiglo, npjglo, ktime=jt)

  END DO  ! time loop

  ierr = closeout(ncoutu)
  ierr = closeout(ncoutv)

CONTAINS

  SUBROUTINE CreateOutputUV
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutputUV  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    ipk(1)                        = 1
    stypvaru(1)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvaru(1)%cname             = TRIM(cn_vozocrtx)
    stypvaru(1)%cunits            = 'm/s'
    stypvaru(1)%rmissing_value    = 0.
    stypvaru(1)%valid_min         = -10.
    stypvaru(1)%valid_max         = 10.
    stypvaru(1)%clong_name        = 'Zonal_Geostrophic_Velocity'
    stypvaru(1)%cshort_name       = TRIM(cn_vozocrtx)
    stypvaru(1)%conline_operation = 'N/A'
    stypvaru(1)%caxis             = 'TYX'

    stypvarv(1)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvarv(1)%cname             = TRIM(cn_vomecrty)
    stypvarv(1)%cunits            = 'm/s'
    stypvarv(1)%rmissing_value    = 0.
    stypvarv(1)%valid_min         = -10.
    stypvarv(1)%valid_max         = 10.
    stypvarv(1)%clong_name        = 'Meridional_Geostrophic_Velocity'
    stypvarv(1)%cshort_name       = TRIM(cn_vomecrty)
    stypvarv(1)%conline_operation = 'N/A'
    stypvarv(1)%caxis             = 'TYX'

    ! create output filesets
    ncoutu = create      (cf_uout, cf_tfil,  npiglo, npjglo, 0         , ld_nc4=lnc4                     )
    ierr   = createvar   (ncoutu,  stypvaru, 1,      ipk,    id_varoutu, ld_nc4=lnc4, cdglobal=cl_global )
    IF ( ioption == 0 ) THEN
       ! U geo  ! @ V-point !
       ierr   = putheadervar(ncoutu,  cf_tfil,  npiglo, npjglo, 0, pnavlon=glamv, pnavlat=gphiv)
    ELSE
       ierr   = putheadervar(ncoutu,  cf_tfil,  npiglo, npjglo, 0, pnavlon=glamu, pnavlat=gphiu)
    ENDIF

    dtim = getvar1d(cf_tfil, cn_vtimec, npt     )
    ierr = putvar1d(ncoutu,  dtim,      npt, 'T')

    ! V geo  ! @ U-point !
    ncoutv = create      (cf_vout, cf_tfil,  npiglo, npjglo, 0         , ld_nc4=lnc4                     )
    ierr   = createvar   (ncoutv,  stypvarv, 1,      ipk,    id_varoutv, ld_nc4=lnc4, cdglobal=cl_global )
    IF ( ioption == 0 ) THEN
       ! V geo  ! @ U-point !
       ierr   = putheadervar(ncoutv,  cf_tfil,  npiglo, npjglo, 0, pnavlon=glamu, pnavlat=gphiu)
    ELSE
       ierr   = putheadervar(ncoutv,  cf_tfil,  npiglo, npjglo, 0, pnavlon=glamv, pnavlat=gphiv)
    ENDIF

    dtim = getvar1d(cf_tfil, cn_vtimec, npt     )
    ierr = putvar1d(ncoutv,  dtim,      npt, 'T')

  END SUBROUTINE CreateOutputUV

END PROGRAM cdfgeo_uv

PROGRAM cdfstd
  !!======================================================================
  !!                     ***  PROGRAM  cdfstd  ***
  !!=====================================================================
  !!  ** Purpose : Compute Standard deviation values for all the 
  !!               variables in a bunch of cdf files given as argument
  !!               Store the results on a 'similar' cdf file.
  !!
  !!  ** Method  : Compute mean, mean squared, then the variance and
  !!               the standard deviation
  !!
  !! History : 2.1  : 04/2006  : F. Castruccio : Original code (from cdfmoy)
  !!           3.0  : 01/2011  : J.M. Molines  : Doctor norm + Lic.
  !!                : 04/2015  : S. Leroux  : add  optstd spval0 options
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio 
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class statistics
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                               :: jk, jfil, jt        ! dummy loop index
  INTEGER(KIND=4)                               :: jvar, jv            ! dummy loop index
  INTEGER(KIND=4)                               :: narg, iargc, ijarg  ! browse line
  INTEGER(KIND=4)                               :: npiglo, npjglo      ! size of the domain
  INTEGER(KIND=4)                               :: npk, npt            ! size of the domain
  INTEGER(KIND=4)                               :: nvars               ! number of variables in a file
  INTEGER(KIND=4)                               :: nfiles              ! number of files to process
  INTEGER(KIND=4)                               :: ntframe             ! cumul of time frame
  INTEGER(KIND=4)                               :: ncout               ! ncid of stdev file output
  INTEGER(KIND=4)                               :: ncou2               ! ncid of mean file output (optional)
  INTEGER(KIND=4)                               :: ierr                ! error status
  INTEGER(KIND=4)                               :: idep, idep_max      ! possible names for 3rd dimension
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: id_var              ! varid's of input variables
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: ipk, id_varout      ! levels and varid's of output vars
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: id_varoutm          ! varid's of mean var output (optional)

  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: zspval_in           ! [from SL]   
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: v2d                 ! 2d data array
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: rmask2d             ![from SL]  

  REAL(KIND=8), DIMENSION(1)                    :: dtimean             ! mean time
  REAL(KIND=8), DIMENSION(:),       ALLOCATABLE :: dtim                ! time counter
  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: dtab, dtab2         ! cumulated values and squared values
  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: dtabprev, dtab2prev ! [from SL] keep value from the i-1 timestep
  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: dstd                ! standard deviation
  REAL(KIND=8)                                  :: dtotal_time         ! cumulated time

  CHARACTER(LEN=256)                            :: cf_in               ! input file
  CHARACTER(LEN=256)                            :: cf_out='cdfstd.nc'  ! std dev output file
  CHARACTER(LEN=256)                            :: cf_moy='cdfmoy.nc'  ! mean output file (optional)
  CHARACTER(LEN=256)                            :: cv_dep              ! depth variable name
  CHARACTER(LEN=256)                            :: cldum               ! dummy string
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_namesi           ! array of var name
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_nameso           ! array of var name for output
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cf_lst              ! list of file to process
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: clv_dep             ! list of possible depth name (dimension)

  TYPE (variable), DIMENSION(:),    ALLOCATABLE :: stypvari            ! attributes of input variables
  TYPE (variable), DIMENSION(:),    ALLOCATABLE :: stypvaro            ! attributes of output variables

  LOGICAL                                       :: lcaltmean           ! time mean computation flag
  LOGICAL                                       :: lsave   = .FALSE.   ! mean value save flag
  LOGICAL                                       :: lspval0 = .FALSE.   ! [from SL] flag  if missing values other than zero 
  LOGICAL                                       :: lmskmiss= .FALSE.   ! flag for excluding gridpoints where some values are missing    
  LOGICAL                                       :: lstdopt = .FALSE.   ! flag for using a more optimal algorithm to compute std (and std is unbiased) 
  LOGICAL                                       :: lnc4    = .FALSE.   ! Use nc4 with chunking and deflation
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfstd -l LST-files [-save] [-spval0] [-mskmiss] [-opt] ...' 
     PRINT *,'                ... [-o STD-fileout] [-m MEAN-fileout] [-nc4]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the standard deviation of the variables belonging to a set of' 
     PRINT *,'       files given as arguments.  This computation is direct and does not '
     PRINT *,'       required a pre-processing with any of the cdfmoy tools.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -l LST-files : A blank-separated List on netcdf files of the same type,'
     PRINT *,'               forming a time-series' 
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-save ] : Save the mean value of the field, in addition to the '
     PRINT *,'           std deviation. '
     PRINT *,'       [-spval0 ] :  set missing_value attribute to 0 for all output'
     PRINT *,'           variables and take care of the input missing_value.'
     PRINT *,'           This option is usefull if missing_values differ from files '
     PRINT *,'           to files.'
     PRINT *,'       [-mskmiss ] : with this option, the output std and mean are set to'
     PRINT *,'           missing value at any gridpoint where the variable contains a '
     PRINT *,'           missing value for at least one timestep. You should combine '
     PRINT *,'           with -spval0 if missing values are not 0 in all the input files.' 
     PRINT *,'       [-opt ]:  use an optimal algorithm to compute std deviation and use an'
     PRINT *,'           unbiased standard deviation estimates.'
     PRINT *,'       [-o STD-fileout]: specify std dev output file name instead of ',TRIM(cf_out)
     PRINT *,'       [-m MEAN-fileout]: specify mean output file name instead of ',TRIM(cf_moy)
     PRINT *,'       [-nc4 ]     : Use netcdf4 output with chunking and deflation level 1.'
     PRINT *,'           This option is effective only if cdftools are compiled with'
     PRINT *,'           a netcdf library supporting chunking and deflation.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       none' 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       - netcdf file : ', TRIM(cf_out) 
     PRINT *,'           variables :  IN-var_std, same units than input variables.'
     PRINT *,'       - netcdf file : ', TRIM(cf_moy),' in case of -save option.' 
     PRINT *,'           variables :  IN-var, same units than input variables.'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'        cdfmoy, cdfrmsssh, cdfstdevw'
     STOP 
  ENDIF

  ijarg = 1
  DO WHILE ( ijarg <= narg ) 
     CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1
     SELECT CASE ( cldum )
     CASE ( '-l'     ) ; CALL GetFileList
        ! options
     CASE ( '-save'  ) ; lsave    = .TRUE.
     CASE ('-spval0' ) ; lspval0  = .TRUE. 
     CASE ('-mskmiss') ; lmskmiss = .TRUE. 
     CASE ('-opt'    ) ; lstdopt  = .TRUE. 
     CASE ('-o'      ) ; CALL getarg (ijarg, cf_out ) ; ijarg=ijarg+1
     CASE ('-m'      ) ; CALL getarg (ijarg, cf_moy ) ; ijarg=ijarg+1
     CASE ('-nc4'    ) ; lnc4     = .TRUE.
     CASE DEFAULT      ; PRINT *,' ERROR : ', TRIM(cldum), ' : unknown option.' ; STOP 99
     END SELECT
  END DO

  cf_in = cf_lst(1)

  IF ( chkfile(cf_in) ) STOP 99 ! missing file

  npiglo = getdim (cf_in, cn_x)
  npjglo = getdim (cf_in, cn_y)

  ! looking for npk among various possible name
  idep_max=8
  ALLOCATE ( clv_dep(idep_max) )
  clv_dep(:) = (/cn_z,'z','sigma','nav_lev','levels','ncatice','icbcla','icbsect'/)
  idep=1  ; ierr=1000
  DO WHILE ( ierr /= 0 .AND. idep <= idep_max )
     npk  = getdim (cf_in, clv_dep(idep), cdtrue=cv_dep, kstatus=ierr)
     idep = idep + 1
  ENDDO

  IF ( ierr /= 0 ) THEN  ! none of the dim name was found
     PRINT *,' assume file with no depth'
     npk=0
  ENDIF

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk

  ALLOCATE( dtab(npiglo,npjglo), dtab2(npiglo,npjglo), v2d(npiglo,npjglo) )
  ALLOCATE( rmask2d(npiglo,npjglo)                                        )
  ALLOCATE( dstd(npiglo,npjglo)                                           )
  ALLOCATE( dtabprev(npiglo,npjglo), dtab2prev(npiglo,npjglo)             )

  nvars = getnvar(cf_in)
  PRINT *,' nvars =', nvars

  ALLOCATE (cv_namesi(nvars), cv_nameso(nvars)          )
  ALLOCATE (stypvari(nvars), stypvaro(nvars)            )
  ALLOCATE (id_var(nvars), ipk(nvars), id_varout(nvars) )
  IF ( lsave ) ALLOCATE (id_varoutm(nvars)              )

  CALL CreateOutput

  lcaltmean=.TRUE.
  DO jvar = 1,nvars
     IF ( cv_namesi(jvar) == cn_vlon2d .OR. &
          cv_namesi(jvar) == cn_vlat2d .OR. &
          cv_nameso(jvar) == 'none'  ) THEN
        ! skip these variable
     ELSE
        PRINT *,' Working with ', TRIM(cv_namesi(jvar)), ipk(jvar)

        DO jk = 1, ipk(jvar)
           PRINT *,'level ',jk

           dtab(:,:) = 0.d0; dtab2(:,:) = 0.d0; dtotal_time = 0.d0 
           dtabprev(:,:) = 0.d0; dtab2prev(:,:) = 0.d0              ! [from SL]
           rmask2d(:,:) = 1.0                                        ! [from SL]

           ntframe = 0
           DO jfil = 1, nfiles
              cf_in=cf_lst(jfil)

              IF ( chkfile(cf_in) ) STOP 99 ! missing file

              IF ( lcaltmean )  THEN
                 npt = getdim (cf_in, cn_t)
                 ALLOCATE (dtim(npt) )
                 dtim(:)     = getvar1d(cf_in, cn_vtimec, npt)
                 dtotal_time = dtotal_time + SUM(dtim)
                 DEALLOCATE ( dtim ) 
              END IF

              DO jt=1,npt
                 ntframe = ntframe + 1
                 v2d(:,:) = getvar(cf_in, cv_namesi(jvar), jk, npiglo, npjglo, ktime=jt)
                 IF ( lspval0  )  WHERE (v2d == zspval_in(jvar))  v2d = 0.     ! [from SL] change missing values to 0
                 WHERE (v2d == 0.) rmask2d = 0.                                ! [from SL] keep memory of missing values at gridpoints


                 IF (lstdopt) THEN    ! [from SL] New algorithm
                    IF (ntframe == 1) THEN                                        ! [from SL]
                       dtab(:,:)  = v2d(:,:)*1.d0                                 ! [from SL]
                       dtab2(:,:) = 0.d0                                          ! [from SL]
                       dtabprev(:,:)  = dtab(:,:)                                 ! [from SL]
                       dtab2prev(:,:) = dtab2(:,:)                                ! [from SL]
                    ELSE                                      
                       dtab(:,:)  = dtabprev(:,:)  + (v2d(:,:) -dtabprev(:,:))/ntframe               ! [from SL]           
                       dtab2(:,:) = dtab2prev(:,:) + ((v2d(:,:)-dtabprev(:,:))*(v2d(:,:)-dtab(:,:))) ! [from SL]   
                       dtabprev(:,:)  = dtab(:,:)                                 ! [from SL]        
                       dtab2prev(:,:) = dtab2(:,:)                                ! [from SL]        
                    ENDIF
                 ELSE                 ! original algo
                    dtab( :,:) = dtab( :,:) + v2d(:,:)*1.d0
                    dtab2(:,:) = dtab2(:,:) + v2d(:,:)*v2d(:,:)*1.d0
                 ENDIF

              END DO
           END DO

           ! finish with level jk ; compute mean (assume spval is 0 )

           IF (lstdopt) THEN                                                          ! [from SL]  if opt "std optimal and unbiased"
              ! dtab is already normalized with this algo
              dstd(:,:) = SQRT(dtab2(:,:) / (ntframe-1))                           ! [from SL] unbiased estimate

           ELSE                                                                      ! [from SL]
              dtab(:,:)  = dtab(:,:) / ntframe                                   
              dtab2(:,:) = dtab2(:,:) / (ntframe)                       
              WHERE ( dtab2 - dtab*dtab >= 0 ) 
                 dstd = SQRT(dtab2 - dtab*dtab)
              ELSEWHERE
                 dstd = 0.d0
              END WHERE
           ENDIF                                                                     ! [from SL]

           IF ( lmskmiss ) dtab(:,:) = dtab(:,:)*(rmask2d(:,:)*1.d0)           ! [from SL] apply mask 
           IF ( lmskmiss ) dstd(:,:) = dstd(:,:)*(rmask2d(:,:)*1.d0)           ! [from SL] apply mask 

           ! store variable on output file
           ierr = putvar(ncout, id_varout(jvar),  REAL(dstd), jk, npiglo, npjglo, kwght=ntframe)
           IF ( lsave ) ierr = putvar(ncou2, id_varoutm(jvar), REAL(dtab), jk, npiglo, npjglo, kwght=ntframe)

           IF ( lcaltmean )  THEN
              dtimean(1) = dtotal_time / ntframe
              ierr = putvar1d(ncout, dtimean, 1, 'T')
              IF ( lsave ) ierr = putvar1d(ncou2, dtimean, 1, 'T')
              lcaltmean = .FALSE. ! tmean already computed 
           END IF
        END DO  ! loop to next level
     END IF

  END DO ! loop to next var in file

  ierr = closeout(ncout)
  IF ( lsave ) ierr = closeout(ncou2)

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    cv_namesi(:) = getvarname(cf_in, nvars, stypvari)

    IF ( lspval0 ) THEN                              ! [from SL]
       ALLOCATE ( zspval_in(nvars) )                 ! [from SL]
       zspval_in(:) = stypvari(:)%rmissing_value     ! [from SL]
       stypvari(:)%rmissing_value = 0.               ! [from SL]
    ENDIF                                            ! [from SL]

    id_var(:)  = (/(jv, jv=1,nvars)/)
    ipk(:)     = getipk(cf_in, nvars, cdep=cv_dep)
    DO jvar = 1, nvars 
       cv_nameso(jvar) = TRIM(cv_namesi(jvar))//'_std' 
    ENDDO

    WHERE( ipk == 0 ) cv_nameso='none'

    DO jvar = 1, nvars
       stypvaro(jvar)%ichunk      = (/npiglo,MAX(1,npjglo/30),1,1 /)
       stypvaro(jvar)             = stypvari(jvar)
       stypvaro(jvar)%cname       = cv_nameso(jvar)
       stypvaro(jvar)%clong_name  = 'Std Deviation of '//TRIM(cv_namesi(jvar))
       stypvaro(jvar)%cshort_name = cv_nameso(jvar)
    END DO


    ! create output fileset
    ncout = create      (cf_out, cf_in,    npiglo, npjglo, npk, cdep=cv_dep , ld_nc4=lnc4)
    ierr  = createvar   (ncout,  stypvaro, nvars,  ipk,    id_varout        , ld_nc4=lnc4)
    ierr  = putheadervar(ncout,  cf_in,    npiglo, npjglo, npk, cdep=cv_dep              )

    IF ( lsave )  THEN
       WHERE(ipk == 0 ) stypvari(:)%cname='none'
       DO jvar = 1, nvars
          stypvari(jvar)%ichunk      = (/npiglo,MAX(1,npjglo/30),1,1 /)
       ENDDO
       ! create output fileset for mean values
       ncou2 = create      (cf_moy, cf_in,    npiglo, npjglo, npk, cdep=cv_dep , ld_nc4=lnc4)
       ierr  = createvar   (ncou2,  stypvari, nvars,  ipk,    id_varoutm       , ld_nc4=lnc4)
       ierr  = putheadervar(ncou2,  cf_in,    npiglo, npjglo, npk, cdep=cv_dep              )
    ENDIF

  END SUBROUTINE CreateOutput

  SUBROUTINE GetFileList
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE GetFileList  ***
    !!
    !! ** Purpose :  Set up a file list given on the command line as 
    !!               blank separated list
    !!
    !! ** Method  :  Scan the command line until a '-' is found
    !!----------------------------------------------------------------------
    INTEGER (KIND=4)  :: ji
    INTEGER (KIND=4)  :: icur
    !!----------------------------------------------------------------------
    !!
    nfiles=0
    ! need to read a list of file ( number unknow ) 
    ! loop on argument till a '-' is found as first char
    icur=ijarg                          ! save current position of argument number
    DO ji = icur, narg                  ! scan arguments till - found
       CALL getarg ( ji, cldum )
       IF ( cldum(1:1) /= '-' ) THEN ; nfiles = nfiles+1
       ELSE                          ; EXIT
       ENDIF
    ENDDO
    ALLOCATE (cf_lst(nfiles) )
    DO ji = icur, icur + nfiles -1
       CALL getarg(ji, cf_lst( ji -icur +1 ) ) ; ijarg=ijarg+1
    END DO
  END SUBROUTINE GetFileList

END PROGRAM cdfstd

PROGRAM cdfpsi_level
  !!-------------------------------------------------------------------
  !!               ***  PROGRAM cdfpsi_level  ***
  !!
  !!  **  Purpose  :  Compute Stream Function for each level
  !!                  PARTIAL STEPS
  !!  
  !!  **  Method   :  Compute the 3D fields ztrpu, ztrpv 
  !!                  as the integral on the vertical of u, v on their
  !!                  respective points. 
  !!                  Then integrate from south to north : ==> psiu
  !!                  Then integrate from West to East   : ==> psiv
  !!                  (should be almost the same (if no error ))
  !!   Default (appropriate for global model): output psiu;
  !!                    normalizes the values setting psi (jpi,jpj) = 0
  !!   If option "V" is given as last argument, output psiv, 
  !!                    normalizes values setting psi(jpi,1) = 0.
  !!                    This is appropriate for North Atlantic 
  !!
  !! history ;
  !!  Original :  J.M. Molines (May 2005 )
  !!-------------------------------------------------------------------
  !!  $Rev: 256 $
  !!  $Date: 2009-07-21 17:49:27 +0200 (mar. 21 juil. 2009) $
  !!  $Id$
  !!--------------------------------------------------------------
  !! * Modules used
  USE cdfio

  !! * Local variables
  IMPLICIT NONE
  INTEGER   :: ji,jj,jk                            !: dummy loop index
  INTEGER   :: ierr                                !: working integer
  INTEGER   :: narg, iargc                         !: command line 
  INTEGER   :: npiglo,npjglo, npk                  !: size of the domain
  INTEGER   :: ncout
  INTEGER, DIMENSION(1) ::  ipk, id_varout         !

  REAL(KIND=4), DIMENSION (:,:),   ALLOCATABLE ::  zmask, e1v, e3v , zv !: mask, metrics
  REAL(KIND=4), DIMENSION (:,:),   ALLOCATABLE ::         e2u, e3u , zu !: mask, metrics
  REAL(KIND=4), DIMENSION (:,:),   ALLOCATABLE ::         glamf, gphif
  REAL(KIND=4) ,DIMENSION(1)                    ::  tim

  REAL(KIND=8),   DIMENSION (:,:), ALLOCATABLE :: ztrpu, ztrpv, psiu, psiv

  CHARACTER(LEN=256) :: cfileu ,cfilev, cfileoutnc='psi_level.nc'
  CHARACTER(LEN=256) :: coordhgr='mesh_hgr.nc',  coordzgr='mesh_zgr.nc', cmask='mask.nc'
  CHARACTER(LEN=1)  :: coption
  CHARACTER(LEN=256) :: cdep

  TYPE(variable), DIMENSION(1) :: typvar         !: structure for attributes

  INTEGER    :: istatus

  ! constants

  !!  Read command line and output usage message if not compliant.
  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' Usage : cdfpsi_level  Ufile Vfile <V> (optional argument)'
     PRINT *,' Computes the barotropic stream function as the integral of the transport'
     PRINT *,' PARTIAL CELLS VERSION'
     PRINT *,' Files mesh_hgr.nc, mesh_zgr.nc ,mask.nc must be in te current directory'
     PRINT *,' Output on psi_level.nc, variables sobarstf on f-points'
     PRINT *,' Default works well for a global ORCA grid. use V 3rdargument for North Atlantic'
     STOP
  ENDIF

  CALL getarg (1, cfileu  )
  CALL getarg (2, cfilev  )
  CALL getarg (3, coption )

  npiglo= getdim (cfileu,'x')
  npjglo= getdim (cfileu,'y')
  npk   = getdim (cfileu,'depth')

 ! define new variables for output ( must update att.txt)
  typvar(1)%cname= 'sobarstf'
  typvar(1)%cunits='m3/s'
  typvar(1)%rmissing_value=0.
  typvar(1)%valid_min= -300.e6
  typvar(1)%valid_max= 300.e6
  typvar(1)%clong_name='Barotropic_Stream_Function'
  typvar(1)%cshort_name='sobarstf'
  typvar(1)%conline_operation='N/A'
  typvar(1)%caxis='TZYX'
  ipk(1) = npk  !  3D ( X, Y , Z, T )

  PRINT *, 'npiglo=', npiglo
  PRINT *, 'npjglo=', npjglo
  PRINT *, 'npk   =', npk
  IF ( coption == 'V') PRINT *, ' Use psiv (ex. North Atlantic case)'

  ! Allocate arrays
  ALLOCATE ( zmask(npiglo,npjglo) )
  ALLOCATE ( e1v(npiglo,npjglo),e3v(npiglo,npjglo))
  ALLOCATE ( e2u(npiglo,npjglo),e3u(npiglo,npjglo))
  ALLOCATE ( zu(npiglo,npjglo),ztrpu(npiglo,npjglo), psiu(npiglo,npjglo) )
  ALLOCATE ( zv(npiglo,npjglo),ztrpv(npiglo,npjglo), psiv(npiglo,npjglo))
  ALLOCATE ( glamf(npiglo,npjglo), gphif(npiglo,npjglo))

  glamf(:,:) = getvar(coordhgr, 'glamf',1,npiglo,npjglo)
  gphif(:,:) = getvar(coordhgr, 'gphif',1,npiglo,npjglo)

  ! create output fileset
  ncout =create(cfileoutnc, cfileu, npiglo,npjglo,npk)
  ierr= createvar(ncout ,typvar,1, ipk,id_varout )
  ierr= putheadervar(ncout , cfileu, npiglo, npjglo, npk)
!  ierr= putheadervar(ncout , cfileu, npiglo, npjglo, npk,cdep=cdep)
!  ierr= putheadervar(ncout, cfileu,npiglo, npjglo,1,glamf, gphif)
  tim=getvar1d(cfileu,'time_counter',1)
  ierr=putvar1d(ncout,tim,1,'T')

  e1v(:,:) = getvar(coordhgr, 'e1v', 1,npiglo,npjglo)
  e2u(:,:) = getvar(coordhgr, 'e2u', 1,npiglo,npjglo)

     ztrpu(:,:)= 0.d0
     ztrpv(:,:)= 0.d0

  DO jk = 1,npk
  
     zmask(:,:) = getvar(cmask, 'fmask', jk,npiglo,npjglo)
     ! get rid of the free-slip/no-slip condition
     WHERE ( zmask >= 2 ) zmask = 1

     PRINT *,'level ',jk
     IF ( coption == 'V' ) THEN
        zv(:,:)= getvar(cfilev, 'vomecrty',  jk ,npiglo,npjglo)
        e3v(:,:) = getvar(coordzgr, 'e3v_ps', jk,npiglo,npjglo, ldiom=.true.)
        ztrpv(:,:) = zv(:,:)*e1v(:,:)*e3v(:,:)*1.d0  ! meridional transport of each grid cell
     ELSE
     ! Get zonal velocity  at jk
        zu(:,:)= getvar(cfileu, 'vozocrtx',  jk ,npiglo,npjglo)
     ! get e3v at level jk
        e3u(:,:) = getvar(coordzgr, 'e3u_ps', jk,npiglo,npjglo, ldiom=.true.)
     ! integrates vertically 
        ztrpu(:,:) = zu(:,:)*e2u(:,:)*e3u(:,:)*1.d0  ! zonal transport of each grid cell
     ENDIF

  IF (coption == 'V' ) THEN
  ! integrate zonally from east to west 
     psiv(npiglo,:)= 0.0
     DO ji=npiglo-1,1,-1
        psiv(ji,:) = psiv(ji+1,:) - ztrpv(ji,:)  ! psi at f point
     END DO
     psiv(:,:) = psiv(:,:) *zmask(:,:)
     ierr = putvar(ncout, id_varout(1) ,REAL(psiv),   jk, npiglo, npjglo)
     !ierr = putvar(ncout, id_varout(1) ,REAL(ztrpv),   jk, npiglo, npjglo)

  ELSE
  ! integrate from the south to the north with zonal transport
     psiu(:,:) = 0.d0

     DO jj = 2, npjglo
       psiu(:,jj) = psiu(:,jj-1) - ztrpu(:,jj)   ! psi at f point
     END DO
     psiu(:,:) = (psiu(:,:) -psiu(npiglo,npjglo) ) * zmask(:,:)
     ierr = putvar(ncout, id_varout(1) ,REAL(psiu),   jk, npiglo, npjglo)
     !ierr = putvar(ncout, id_varout(1) ,REAL(ztrpu),   jk, npiglo, npjglo)
   ENDIF

  END DO  ! loop to next level

   istatus = closeout (ncout)

   END PROGRAM cdfpsi_level

PROGRAM cdf16bit
  !!======================================================================
  !!                     ***  PROGRAM  cdf16bit  ***
  !!======================================================================
  !!  ** Purpose : Transform the 32bit precision input file into a 16bit prec.
  !!               Uses constant scale_factor and add_offset.
  !!
  !!  ** Method  : Store the results on a 'cdf16bit.nc' file similar to the input file.
  !!               Scale factor and offset are pre-defined for authorized cdf varname
  !!
  !! History : 2.1 !  11/2006    J.M. Molines   : Original code
  !!           3.0 !  12/2010    J.M. Molines   : Full Doctor form + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  !!   routines      : description
  !!   sf_ao         : Scale Factor Add Offset
  !!   check_scaling : verify that the sf_ao do not produce saturation
  !!----------------------------------------------------------------------
  USE cdfio 
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class data_transformation
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                               :: jk, jt, jvar, jv   ! dummy loop index
  INTEGER(KIND=4)                               :: ierr               ! working integer
  INTEGER(KIND=4)                               :: narg, iargc, ijarg ! 
  INTEGER(KIND=4)                               :: npiglo, npjglo     ! size of the domain
  INTEGER(KIND=4)                               :: npk, npt           ! size of the domain
  INTEGER(KIND=4)                               :: nvars              ! Number of variables in a file
  INTEGER(KIND=4)                               :: ncout              ! ncid of output file
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: id_var             ! arrays of var id's
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: ipk                ! arrays of var id's
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: id_varout          ! arrays of var id's
  INTEGER(KIND=2), DIMENSION(:,:),  ALLOCATABLE :: i2d                ! 16 bit 2D array fro conversion

  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: v2d                ! Array to read a layer of data
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: zmax, zmin         ! min and max of the field at level(jk)
  REAL(KIND=4)                                  :: sf, ao             ! scale_factor, add_offset
  REAL(KIND=4)                                  :: zchkmax, zchkmin   ! scale_factor, add_offset checking values
  REAL(KIND=4)                                  :: zzmax, zzmin       ! min and max of the full 3D field
  REAL(KIND=4)                                  :: spval              ! missing value, fill_value, spval ...

  REAL(KIND=8), DIMENSION(:),       ALLOCATABLE :: dtim               ! time of file

  CHARACTER(LEN=256)                            :: cf_in              ! input file
  CHARACTER(LEN=256)                            :: cf_out='cdf16bit.nc' ! outputfile
  CHARACTER(LEN=256)                            :: cldum              ! dummy string
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_names           ! array of var name

  TYPE (variable), DIMENSION(:),    ALLOCATABLE :: stypvar            ! Type variable is defined in cdfio.

  LOGICAL                                       :: l_chk    = .FALSE. ! logical flags to save line options
  LOGICAL                                       :: l_verbose= .FALSE. ! logical flags to save line options
  LOGICAL                                       :: lnc4     = .FALSE. ! Use nc4 with chunking and deflation
  LOGICAL, DIMENSION(:,:),          ALLOCATABLE :: lmask              ! 2D logical land/sea mask (true on ocean)
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdf16bit -f 32BIT-file [-check] [-verbose] [-o OUT-file] [-nc4]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Convert input 32 bit precision file into 16 bit precision file using' 
     PRINT *,'       add_offset and scale_factor. '
     PRINT *,'       Note that predifined values for these two parameters are defined '
     PRINT *,'       according to the variable name. If variable name is not supported,'
     PRINT *,'       no conversion is performed.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -f 32BIT-file : input 32 bit file to be converted' 
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-check ]   : control than the scale factors are adequate.'
     PRINT *,'       [-verbose ] : give information level by level.' 
     PRINT *,'       [-o OUT-file] : Specify output file name instead of ', TRIM(cf_out)
     PRINT *,'       [-nc4 ] : Use netcdf4 output with chunking and deflation level 1.'
     PRINT *,'                 This option is effective only if cdftools are compiled with'
     PRINT *,'                 a netcdf library supporting chunking and deflation.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       none '
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : same names than in input file'
     STOP 
  ENDIF
  !!
  ijarg = 1
  DO WHILE ( ijarg <= narg)  
     CALL getarg(ijarg, cldum) ; ijarg = ijarg + 1
     SELECT CASE (  cldum  )  
     CASE ( '-f'      ) ; CALL getarg (ijarg, cf_in ) ; ijarg = ijarg + 1
        ! options
     CASE ( '-check'  ) ; l_chk     =.TRUE.
     CASE ( '-verbose') ; l_chk     =.TRUE. 
        ;                 l_verbose =.TRUE.
     CASE ( '-o'      ) ; CALL getarg (ijarg, cf_out) ; ijarg = ijarg + 1
     CASE ( '-nc4'    ) ; lnc4      =.TRUE.
     CASE DEFAULT       ; PRINT *,' ERROR : ',TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  END DO

  IF ( chkfile(cf_in)  ) STOP 99 ! missing file

  ! get domain dimension from input file
  npiglo = getdim (cf_in, cn_x)
  npjglo = getdim (cf_in, cn_y)
  npk    = getdim (cf_in, cn_z, kstatus=ierr)

  IF (ierr /= 0 ) THEN
     npk   = getdim (cf_in,'z',kstatus=ierr)
     IF (ierr /= 0 ) THEN ;  PRINT *,' ERROR : depth dimension name not suported' ; STOP 99
     ENDIF
  ENDIF
  npt    = getdim (cf_in, cn_t)

  ! Allocate memory 
  ALLOCATE( v2d(npiglo,npjglo), i2d(npiglo,npjglo), lmask(npiglo, npjglo) )
  ALLOCATE( zmin(npk) , zmax(npk) , dtim(npt))

  ! Get the number of variables held in the file, allocate arrays
  nvars = getnvar(cf_in)
  PRINT *,' nvars =', nvars

  ALLOCATE (cv_names(nvars) )
  ALLOCATE (stypvar(nvars) )
  ALLOCATE (id_var(nvars),ipk(nvars),id_varout(nvars) )

  ! get list of variable names and collect attributes in stypvar (optional)
  cv_names(:)=getvarname(cf_in,nvars,stypvar) 

  CALL CreateOutput

  ! Loop on all variables of the file
  DO jvar = 1,nvars
     IF (cv_names(jvar) == 'none' ) THEN
        ! skip these variable  they are copied in ncout by putheader above
     ELSE
        sf=stypvar(jvar)%scale_factor
        ao=stypvar(jvar)%add_offset
        PRINT *,' Working with ', TRIM(cv_names(jvar)), ipk(jvar), sf, ao
        spval=stypvar(jvar)%rmissing_value 
        DO jt = 1, npt
           DO jk = 1, ipk(jvar)
              v2d(:,:)= getvar(cf_in, cv_names(jvar), jk ,npiglo, npjglo, ktime=jt )
              IF ( sf == 1. .AND. ao == 0 ) THEN
                 ! write FLOATS
                 IF ( stypvar(jvar)%savelog10 == 1 ) THEN
                    WHERE ( v2d /= spval )
                       v2d(:,:)= LOG10(v2d)
                    ELSEWHERE
                       v2d = 0.
                    END WHERE
                 ENDIF
                 ierr = putvar(ncout, id_varout(jvar) ,v2d, jk, npiglo, npjglo, ktime=jt)
                 ! skip remaining of the do-loop, treat next level
                 CYCLE
              ENDIF
              IF ( stypvar(jvar)%savelog10 == 0 ) THEN
                 ! take care of not converting 'special values'
                 WHERE( v2d /= spval ) 
                    i2d(:,:)=NINT((v2d(:,:)-ao)/sf)
                 ELSEWHERE
                    i2d(:,:)=0
                 END WHERE
              ELSE  ! store log10  ao and sf refer to the log10 of the variable
                 WHERE( v2d /= spval ) 
                    i2d(:,:)=NINT((LOG10(v2d(:,:))-ao)/sf)
                 ELSEWHERE
                    i2d(:,:)=0
                 END WHERE
              ENDIF
              CALL checkscaling
              ! write SHORT to the file
              ierr = putvar(ncout, id_varout(jvar) ,i2d, jk, npiglo, npjglo, ktime=jt)
           END DO  ! loop to next level
        END DO  ! next time loop
     END IF
  END DO ! loop to next var in file

  ierr = closeout(ncout)

CONTAINS

  SUBROUTINE sf_ao (kvar)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE sf_ao  ***
    !!
    !! ** Purpose :  Set the scale_factor and add_offset for the variable kvar
    !!               Also set the flag savelog10 when the log10 of the variable
    !!               is stored, instead of the proper variable. 
    !!
    !! ** Method  : Recognize the variable name and set pre-defined values.
    !!              Give the min and max value for a given variable, and remap
    !!              it on -32000 +32000 (Integer*2. The max I2 is 32767 (2^15 -1)
    !!              Taking 32000 leaves  allows a slight overshoot ( 1%) 
    !!
    !! ** Comments : With select case (which gives a much more readable code,
    !!               the CASE statement requires a constant matching pattern,
    !!               thus avoiding the use of dynamically adjusted names as
    !!               defined in modcdfnames ...
    !!----------------------------------------------------------------------
    INTEGER(KIND=4), INTENT(in) :: kvar  ! variable number

    CHARACTER(LEN=256) :: clvarname
    REAL(KIND=4)       :: zvmin, zvmax
    !!----------------------------------------------------------------------

    clvarname=cv_names(kvar)
    SELECT CASE (clvarname)
       ! gridT
    CASE ('votemper')             ! Potential temperature (Deg C)
       zvmin= -3.   ;  zvmax = 42.
       stypvar(kvar)%add_offset=(zvmin + zvmax) /2.
       stypvar(kvar)%scale_factor= (zvmax-stypvar(kvar)%add_offset)/32000.
       stypvar(kvar)%savelog10=0.

    CASE ('vosaline')             ! Salinity (PSU)
       zvmin= 0.   ;  zvmax = 42.
       stypvar(kvar)%add_offset=(zvmin + zvmax) /2.
       stypvar(kvar)%scale_factor= (zvmax-stypvar(kvar)%add_offset)/32000.
       stypvar(kvar)%savelog10=0.

    CASE ('sossheig')             ! Sea Surface Heigh (m)
       zvmin= -2.5   ;  zvmax = 2.5
       stypvar(kvar)%add_offset=(zvmin + zvmax) /2.
       stypvar(kvar)%scale_factor= (zvmax-stypvar(kvar)%add_offset)/32000.
       stypvar(kvar)%savelog10=0.

    CASE ('somxl010')             ! Mixed layer depth (m)
       zvmin= 0.   ;  zvmax = 5000.
       stypvar(kvar)%add_offset=(zvmin + zvmax) /2.
       stypvar(kvar)%scale_factor= (zvmax-stypvar(kvar)%add_offset)/32000.
       stypvar(kvar)%savelog10=0.

    CASE ('sohefldo')             ! Total Heat flux Down (W/m2)
       zvmin= -1500.   ;  zvmax = 500.
       stypvar(kvar)%add_offset=(zvmin + zvmax) /2.
       stypvar(kvar)%scale_factor= (zvmax-stypvar(kvar)%add_offset)/32000.
       stypvar(kvar)%savelog10=0.

    CASE ('soshfldo')             ! Solar Heat flux Down (W/m2)
       zvmin= -0.1   ;  zvmax = 500.
       stypvar(kvar)%add_offset=(zvmin + zvmax) /2.
       stypvar(kvar)%scale_factor= (zvmax-stypvar(kvar)%add_offset)/32000.
       stypvar(kvar)%savelog10=0.

    CASE ('sowaflup')             ! Evaporation - Precipitation Up ( kg/m2/s)
       zvmin= -0.1   ;  zvmax = 0.1
       stypvar(kvar)%add_offset=(zvmin + zvmax) /2.
       stypvar(kvar)%scale_factor= (zvmax-stypvar(kvar)%add_offset)/32000.
       stypvar(kvar)%savelog10=0.

    CASE ('sowafldp')             ! SSS damping term Up (kg/m2/s )
       zvmin= -10.  ;  zvmax = 15.
       stypvar(kvar)%add_offset=(zvmin + zvmax) /2.
       stypvar(kvar)%scale_factor= (zvmax-stypvar(kvar)%add_offset)/32000.
       stypvar(kvar)%savelog10=0.

    CASE ('iowaflup')             ! ???
       zvmin= -1.  ;  zvmax = 0.1
       stypvar(kvar)%add_offset=(zvmin + zvmax) /2.
       stypvar(kvar)%scale_factor= (zvmax-stypvar(kvar)%add_offset)/32000.
       stypvar(kvar)%savelog10=0.

    CASE ('sowaflcd')             ! Concentration Dilution water flux (kg/m2/s)
       zvmin=-1.   ;  zvmax = 15.
       stypvar(kvar)%add_offset=(zvmin + zvmax) /2.
       stypvar(kvar)%scale_factor= (zvmax-stypvar(kvar)%add_offset)/32000.
       stypvar(kvar)%savelog10=0.

    CASE ('solhflup')             ! Latent Heat Flux Up (W/m2)
       zvmin=-800.   ;  zvmax = 150.
       stypvar(kvar)%add_offset=(zvmin + zvmax) /2.
       stypvar(kvar)%scale_factor= (zvmax-stypvar(kvar)%add_offset)/32000.
       stypvar(kvar)%savelog10=0.

    CASE ('solwfldo')             ! Long Wave radiation Heat flux Down (W/m2)
       zvmin=-200.   ;  zvmax = 50.
       stypvar(kvar)%add_offset=(zvmin + zvmax) /2.
       stypvar(kvar)%scale_factor= (zvmax-stypvar(kvar)%add_offset)/32000.
       stypvar(kvar)%savelog10=0.

    CASE ('sosbhfup')             ! Sensible Heat Flux Up (W/m2)
       zvmin=-800.   ;  zvmax = 100.
       stypvar(kvar)%add_offset=(zvmin + zvmax) /2.
       stypvar(kvar)%scale_factor= (zvmax-stypvar(kvar)%add_offset)/32000.
       stypvar(kvar)%savelog10=0.

       ! gridU
    CASE ('vozocrtx')             ! Zonal Velocity U (m/s)
       zvmin= -3.0   ;  zvmax = 3.0
       stypvar(kvar)%add_offset=(zvmin + zvmax) /2.
       stypvar(kvar)%scale_factor= (zvmax-stypvar(kvar)%add_offset)/32000.
       stypvar(kvar)%savelog10=0.

    CASE ('sozotaux')             !  Zonal Wind Stress (N/m2)
       zvmin= -1.5   ;  zvmax = 1.5
       stypvar(kvar)%add_offset=(zvmin + zvmax) /2.
       stypvar(kvar)%scale_factor= (zvmax-stypvar(kvar)%add_offset)/32000.
       stypvar(kvar)%savelog10=0.

       ! gridV
    CASE ('vomecrty')             ! Meridional Velocity V (m/s)
       zvmin= -3.0   ;  zvmax = 3.0
       stypvar(kvar)%add_offset=(zvmin + zvmax) /2.
       stypvar(kvar)%scale_factor= (zvmax-stypvar(kvar)%add_offset)/32000.
       stypvar(kvar)%savelog10=0.

    CASE ('sometauy')             !  Meridional  Wind Stress (N/m2)
       zvmin= -1.5   ;  zvmax = 1.5
       stypvar(kvar)%add_offset=(zvmin + zvmax) /2.
       stypvar(kvar)%scale_factor= (zvmax-stypvar(kvar)%add_offset)/32000.
       stypvar(kvar)%savelog10=0.

       ! gridW
    CASE ('vovecrtz')             ! Vertical Velocity W (m/s)
       zvmin= -1.e-2   ;  zvmax = 1.e-2
       stypvar(kvar)%add_offset=(zvmin + zvmax) /2.
       stypvar(kvar)%scale_factor= (zvmax-stypvar(kvar)%add_offset)/32000.
       stypvar(kvar)%savelog10=0.

    CASE ('votkeavt')             ! Vertical mixing coef log(avt) log(m2/s)
       zvmin= -8.   ;  zvmax = 2.0
       stypvar(kvar)%add_offset=(zvmin + zvmax) /2.
       stypvar(kvar)%scale_factor= (zvmax-stypvar(kvar)%add_offset)/32000.
       stypvar(kvar)%savelog10=1.

       !icemod 
    CASE ('isnowthi')             ! Snow Thickness (m)
       zvmin=0.   ;  zvmax = 5.
       stypvar(kvar)%add_offset=(zvmin + zvmax) /2.
       stypvar(kvar)%scale_factor= (zvmax-stypvar(kvar)%add_offset)/32000.
       stypvar(kvar)%savelog10=0.

    CASE ('iicethic')             ! Ice Thickness (m)
       zvmin=0.   ;  zvmax = 15.
       stypvar(kvar)%add_offset=(zvmin + zvmax) /2.
       stypvar(kvar)%scale_factor= (zvmax-stypvar(kvar)%add_offset)/32000.
       stypvar(kvar)%savelog10=0.

    CASE ('iiceprod')             ! Ice Production (m/kt) (step ice)
       zvmin=-0.05   ;  zvmax = 0.05
       stypvar(kvar)%add_offset=(zvmin + zvmax) /2.
       stypvar(kvar)%scale_factor= (zvmax-stypvar(kvar)%add_offset)/32000.
       stypvar(kvar)%savelog10=0.

    CASE ('ileadfra')             ! Ice Lead Fraction (%) (In fact, ice concentration)
       zvmin= 0  ;  zvmax = 1.
       stypvar(kvar)%add_offset=(zvmin + zvmax) /2.
       stypvar(kvar)%scale_factor= (zvmax-stypvar(kvar)%add_offset)/32000.
       stypvar(kvar)%savelog10=0.

    CASE ('iicetemp')             ! Ice Temperature (Deg C )
       zvmin= -50.  ;  zvmax = 0.1
       stypvar(kvar)%add_offset=(zvmin + zvmax) /2.
       stypvar(kvar)%scale_factor= (zvmax-stypvar(kvar)%add_offset)/32000.
       stypvar(kvar)%savelog10=0.

    CASE ('ioceflxb')             !Ocean Ice flux  (W/m2) 
       zvmin= -100.  ;  zvmax = 2500.0
       stypvar(kvar)%add_offset=(zvmin + zvmax) /2.
       stypvar(kvar)%scale_factor= (zvmax-stypvar(kvar)%add_offset)/32000.
       stypvar(kvar)%savelog10=0.

    CASE ('iicevelu')             ! Zonal Ice Velocity (m/s) (at U point)
       zvmin= -2.  ;  zvmax = 2.0
       stypvar(kvar)%add_offset=(zvmin + zvmax) /2.
       stypvar(kvar)%scale_factor= (zvmax-stypvar(kvar)%add_offset)/32000.
       stypvar(kvar)%savelog10=0.

    CASE ('iicevelv')             ! Meridional Ice Velocity (m/s) (at V point)
       zvmin= -2.  ;  zvmax = 2.0
       stypvar(kvar)%add_offset=(zvmin + zvmax) /2.
       stypvar(kvar)%scale_factor= (zvmax-stypvar(kvar)%add_offset)/32000.
       stypvar(kvar)%savelog10=0.

    CASE ('isstempe')             ! Sea Surface Temperature (Deg C)
       zvmin= -3.  ;  zvmax = 42.0
       stypvar(kvar)%add_offset=(zvmin + zvmax) /2.
       stypvar(kvar)%scale_factor= (zvmax-stypvar(kvar)%add_offset)/32000.
       stypvar(kvar)%savelog10=0.

    CASE ('isssalin')             ! Sea Surface Salinity (PSU)
       zvmin= 0.  ;  zvmax = 42.0
       stypvar(kvar)%add_offset=(zvmin + zvmax) /2.
       stypvar(kvar)%scale_factor= (zvmax-stypvar(kvar)%add_offset)/32000.
       stypvar(kvar)%savelog10=0.

    CASE ('iocetflx')             ! Total Flux at Ocean Surface (W/m2)
       zvmin= -1500.  ;  zvmax = 500.
       stypvar(kvar)%add_offset=(zvmin + zvmax) /2.
       stypvar(kvar)%scale_factor= (zvmax-stypvar(kvar)%add_offset)/32000.
       stypvar(kvar)%savelog10=0.

    CASE ('iocesflx')             ! Solar Flux at Ocean Surface (W/m2)
       zvmin= 0.  ;  zvmax = 500.
       stypvar(kvar)%add_offset=(zvmin + zvmax) /2.
       stypvar(kvar)%scale_factor= (zvmax-stypvar(kvar)%add_offset)/32000.
       stypvar(kvar)%savelog10=0.

    CASE ('iocwnsfl')             ! Non Solar Flux at Ocean surface (W/m2)
       zvmin= -1500.  ;  zvmax = 200.
       stypvar(kvar)%add_offset=(zvmin + zvmax) /2.
       stypvar(kvar)%scale_factor= (zvmax-stypvar(kvar)%add_offset)/32000.
       stypvar(kvar)%savelog10=0.

    CASE ('iocesafl')             ! Salt Flux at Ocean Surface (kg/m2/kt)
       zvmin= -300.  ;  zvmax = 300.
       stypvar(kvar)%add_offset=(zvmin + zvmax) /2.
       stypvar(kvar)%scale_factor= (zvmax-stypvar(kvar)%add_offset)/32000.
       stypvar(kvar)%savelog10=0.

    CASE ('iocestru')             ! Zonal Ice Ocean Stress (N/m2)
       zvmin= -1.5  ;  zvmax = 1.5
       stypvar(kvar)%add_offset=(zvmin + zvmax) /2.
       stypvar(kvar)%scale_factor= (zvmax-stypvar(kvar)%add_offset)/32000.
       stypvar(kvar)%savelog10=0.

    CASE ('iocestrv')             ! Meridional Ice Ocean Stress (N/m2)
       zvmin= -1.5  ;  zvmax = 1.5
       stypvar(kvar)%add_offset=(zvmin + zvmax) /2.
       stypvar(kvar)%scale_factor= (zvmax-stypvar(kvar)%add_offset)/32000.
       stypvar(kvar)%savelog10=0.

    CASE ('iicesflx')             ! Solar FLux at ice/ocean Surface (W/m2)
       zvmin= -1.0  ;  zvmax = 500.
       stypvar(kvar)%add_offset=(zvmin + zvmax) /2.
       stypvar(kvar)%scale_factor= (zvmax-stypvar(kvar)%add_offset)/32000.
       stypvar(kvar)%savelog10=0.

    CASE ('iicenflx')             ! Non Solar FLux at ice/ocean Surface (W/m2)
       zvmin= -1500.  ;  zvmax = 300.
       stypvar(kvar)%add_offset=(zvmin + zvmax) /2.
       stypvar(kvar)%scale_factor= (zvmax-stypvar(kvar)%add_offset)/32000.
       stypvar(kvar)%savelog10=0.

    CASE ('isnowpre')             ! Snow Precipitation (kg/day)
       zvmin= 0.  ;  zvmax = 0.0001
       stypvar(kvar)%add_offset=(zvmin + zvmax) /2.
       stypvar(kvar)%scale_factor= (zvmax-stypvar(kvar)%add_offset)/32000.
       stypvar(kvar)%savelog10=0.

       ! TRC
    CASE ('cfc11')               ! Concentration tracer 1
       zvmin= 0.  ;  zvmax = 0.0001
       stypvar(kvar)%add_offset=0.
       stypvar(kvar)%scale_factor= 1.
       stypvar(kvar)%savelog10=1.

    CASE ('bombc14')               ! Concentration tracer 1
       zvmin= 0.  ;  zvmax = 0.0001
       stypvar(kvar)%add_offset=0.
       stypvar(kvar)%scale_factor= 1.
       stypvar(kvar)%savelog10=1.

    CASE DEFAULT
       PRINT *, TRIM(clvarname),'  is not recognized !'
       PRINT *, 'No conversion will be performed'
       stypvar(kvar)%scale_factor=1.0
       stypvar(kvar)%add_offset=0.
       stypvar(kvar)%savelog10=0.
    END SELECT

  END SUBROUTINE sf_ao

  SUBROUTINE checkscaling()
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE checkscaling  ***
    !!
    !! ** Purpose :  Check if the scale_factor and add_offset are ok for 
    !!               the current v2d field
    !!
    !! ** Method  :  - Needs -check and/or -verbose line option to be activated.
    !!               - Find the min and max of 3D field (called every level, and determine min/max)
    !!               - if -verbose option set, give details at every levels
    !!               - When last level is done, give the diagnostics in case of conflict  
    !!
    !!----------------------------------------------------------------------
    IF ( l_chk ) THEN  ! with this option, check if the max value of the field  can be
       !mapped on I2 with actual values of Scale_factor and Add_offset
       lmask=.TRUE. ; WHERE (v2d == spval ) lmask=.FALSE.
       ! Works with log10 of v2d in case of savelog10=1
       IF (stypvar(jvar)%savelog10 == 1 ) THEN
          WHERE( v2d /= 0. ) v2d=LOG10(v2d)
       ENDIF
       zmax(jk)=MAXVAL(v2d,lmask) ; zmin(jk)=MINVAL(v2d,lmask)

       ! Additional output if verbose mode
       IF ( l_verbose ) THEN
          zchkmax=(zmax(jk) - ao )/sf ; zchkmin = (zmin(jk) -ao ) /sf
          IF ( zchkmax >= 2**15 ) THEN
             PRINT *,TRIM(cv_names(jvar)), ' LEVEL ', jk ,' MIN = ',zmin(jk),' MAX = ', zmax(jk)
             PRINT *,' W A R N I N G ! : maximum too high for (sf,ao) pair.', TRIM(cf_in)
             PRINT *,' Optimal value for this level AO = ', (zmin(jk) + zmax(jk) )/2.,' [ ', &
                  &  stypvar(jvar)%add_offset,']'
             PRINT *,' Optimal value for this level SF = ', (zmax(jk) - (zmin(jk) + zmax(jk) )/2. )/32000., &
                  & ' [ ',stypvar(jvar)%scale_factor,' ] '
          END IF

          IF ( zchkmin < -2**15 ) THEN
             PRINT *,TRIM(cv_names(jvar)), ' LEVEL ', jk ,' MIN = ',zmin(jk),' MAX = ', zmax(jk)
             PRINT *,' W A R N I N G ! : minimum too low for (sf,ao) pair.', TRIM(cf_in)
             PRINT *,' Optimal value for this level AO = ', (zmin(jk) + zmax(jk) )/2.,' [ ', &
                  &   stypvar(jvar)%add_offset,']'
             PRINT *,' Optimal value for this level SF = ', (zmax(jk) - (zmin(jk) + zmax(jk) )/2. )/32000., &
                  & ' [ ',stypvar(jvar)%scale_factor,' ] '
          END IF
       END IF   ! verbose mode

       ! Print a warning if necessary after the last level of var has been processed
       IF ( jk == ipk(jvar) ) THEN
          zzmax=MAXVAL(zmax(1:ipk(jvar))) ; zzmin=MINVAL(zmin(1:ipk(jvar)))
          zchkmax=(zzmax - ao )/sf ; zchkmin = (zzmin -ao ) /sf
          IF ( zchkmax >= 2**15 ) THEN
             PRINT *,' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! '
             PRINT *,TRIM(cv_names(jvar)), ' MIN = ',zzmin,' MAX = ',zzmax,TRIM(cf_in)
             PRINT *,' WARNING ! : maximum too high for (sf,ao) pair.'
             PRINT *,' Optimal value for this level AO = ', (zzmin + zzmax )/2.,' [ ', &
                  &   stypvar(jvar)%add_offset,']'
             PRINT *,' Optimal value for this level SF = ', (zzmax - (zzmin + zzmax )/2. )/32000., &
                  & ' [ ',stypvar(jvar)%scale_factor,' ] '
             PRINT *,' ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^'
          END IF

          IF ( zchkmin < -2**15 ) THEN
             PRINT *,' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! '
             PRINT *,TRIM(cv_names(jvar)), ' MIN = ',zzmin,' MAX = ', zzmax,TRIM(cf_in)
             PRINT *,' WARNING ! : minimum too low for (sf,ao) pair.'
             PRINT *,' Optimal value for  AO = ', (zzmin + zzmax )/2.,' [ ', & 
                  &   stypvar(jvar)%add_offset,']'
             PRINT *,' Optimal value for  SF = ', (zzmax - (zzmin + zzmax )/2. )/32000., &
                  & ' [ ',stypvar(jvar)%scale_factor,' ] '
             PRINT *,' ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^'
          ENDIF
       END IF   ! last level
    END IF   ! check mode
  END SUBROUTINE checkscaling

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    id_var(:)  = (/(jv, jv=1,nvars)/)
    ! ipk gives the number of level or 0 if not a T[Z]YX  variable
    ipk(:)     = getipk (cf_in,nvars)

    ! flags variable not to be treated by changing their name to none
    WHERE( ipk == 0 ) cv_names='none'
    stypvar(:)%cname=cv_names

    ! create output fileset
    ! fills the scale_factor and add_offset attribute according to variable name
    ! if the variable is not documented, then, sf=1, ao=0. and no conversion
    ! is performed for this variable (It stays in REAL*4 )
    DO jvar=1,nvars
       IF (cv_names(jvar) /= 'none' ) CALL sf_ao(jvar)
       stypvar(jvar)%ichunk = (/npiglo,MAX(1,npjglo/30),1,1 /)
    END DO

    ! create output file taking the sizes in cf_in
    ncout =create(cf_out, cf_in,npiglo,npjglo,npk           , ld_nc4=lnc4 )
    ! The variables are created as FLOAT or SHORT depending on the scale_factor AND add_offset attribute
    ierr= createvar(ncout , stypvar,  nvars, ipk, id_varout , ld_nc4=lnc4 )
    ierr= putheadervar(ncout , cf_in, npiglo, npjglo, npk)

    ! Get time and write time
    dtim=getvar1d(cf_in,cn_vtimec,npt) 
    ierr=putvar1d(ncout,dtim,npt,'T')

  END SUBROUTINE CreateOutput

END PROGRAM cdf16bit

PROGRAM cdfprofile
  !!======================================================================
  !!                     ***  PROGRAM  cdfprofile  ***
  !!=====================================================================
  !!  ** Purpose : extract a vertical profile from a CDFfile
  !!
  !!  ** Method  : read (i,j) position of point to extract
  !!               read varname
  !!               print profile
  !!
  !! History : 2.1  : 06/2005  : J.M. Molines : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class file_informations
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                               :: jk, jt, jvar      ! dummy loop index
  INTEGER(KIND=4)                               :: narg, iargc       ! argument numbers
  INTEGER(KIND=4)                               :: ijarg             ! argument counter
  INTEGER(KIND=4)                               :: iilook, ijlook      ! look position
  INTEGER(KIND=4)                               :: npiglo, npjglo    ! size of the domain
  INTEGER(KIND=4)                               :: npk, npt, nvars   ! vetical, time size, number of variables
  INTEGER(KIND=4)                               :: ikx=1, iky=1, ikz ! dims of netcdf output file
  INTEGER(KIND=4)                               :: nboutput=1        ! number of variables to write in cdf output
  INTEGER(KIND=4)                               :: ncout, ierr       ! ncid and error flag for cdfio
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: ipk, id_varout    ! vertical size and id of output variables

  REAL(KIND=4)                                  :: rdep              ! vertical interpolation stuff
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: gdept, rprofile   ! depth and profile values
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: gdepout           ! output depth array
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: v2d, rlon, rlat   ! 2d data array, longitude, latitude
  REAL(KIND=4), DIMENSION(1,1)                  :: rdumlon, rdumlat  ! dummy array for output
  REAL(KIND=4), DIMENSION(1,1)                  :: rdummy            ! dummy array

  REAL(KIND=8), DIMENSION(:),       ALLOCATABLE :: dtim              ! time counter

  CHARACTER(LEN=256)                            :: cldum             ! dummy character variable
  CHARACTER(LEN=256)                            :: cf_in             ! input file 
  CHARACTER(LEN=256)                            :: cf_out='profile.nc'
  CHARACTER(LEN=256)                            :: cv_in, cv_dep     ! variable name and depth name
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_names          ! array of var name

  TYPE(variable), DIMENSION(:),     ALLOCATABLE :: stypvar_input     ! structure of input data
  TYPE(variable), DIMENSION(:),     ALLOCATABLE :: stypvar           ! structure of output data

  LOGICAL                                       :: l_vert_interp=.FALSE. ! flag for -dep option
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfprofile  -f IN-file -v IN-var -IJ I J [-dep depth ] [-o OUT-file]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Extracts a vertical profile at location I J, for the IN-var variable of'
     PRINT *,'       the IN-file. A depth can optionally be specified.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'      -f  IN-file : input file to work with.'
     PRINT *,'      -v  IN-var  : variable name whose profile is requested.'
     PRINT *,'      -IJ I J     : I, J position of the point to extract from file.' 
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-dep depth] : specify a depth where vertical value will be'
     PRINT *,'                     interpolated.'
     PRINT *,'       [-o OUT-file]: specify output file name instead of ',TRIM(cf_out)
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        none '
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out),' unless -o option is used.'
     PRINT *,'          variable : name given as argument.'
     PRINT *,'       Profile is also written on standard output.'
     STOP 
  ENDIF

  ijarg = 1

  DO WHILE ( ijarg < narg )
     CALL getarg (ijarg, cldum ) ; ijarg = ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-f'   ) ; CALL getarg (ijarg, cf_in ) ; ijarg = ijarg+1  
     CASE ( '-v'   ) ; CALL getarg (ijarg, cv_in ) ; ijarg = ijarg+1  
     CASE ( '-IJ'  ) ; CALL getarg (ijarg, cldum ) ; ijarg = ijarg+1  ; READ(cldum,*) iilook
        ;              CALL getarg (ijarg, cldum ) ; ijarg = ijarg+1  ; READ(cldum,*) ijlook
        ! options
     CASE ( '-dep' ) ; CALL getarg (ijarg, cldum ) ; ijarg = ijarg+1  ; READ(cldum,*) rdep ; l_vert_interp = .TRUE.
     CASE ( '-o'   ) ; CALL getarg (ijarg, cf_out) ; ijarg = ijarg+1
     CASE  DEFAULT   ; PRINT *,' ERROR :',TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  ENDDO

  IF ( chkfile(cf_in) ) STOP 99 ! missing file

  npiglo = getdim (cf_in, cn_x)
  npjglo = getdim (cf_in, cn_y)
  npk    = getdim (cf_in, cn_z, cv_dep)
  nvars  = getnvar(cf_in)
  npt    = getdim (cf_in, cn_t)

  ! Allocate arrays
  ALLOCATE ( v2d (npiglo,npjglo), gdept(npk), rprofile(npk), dtim(npt) )
  ALLOCATE ( stypvar_input(nvars) ,cv_names(nvars) )
  ALLOCATE ( stypvar(nboutput), ipk(nboutput), id_varout(nboutput) )
  ALLOCATE ( rlon(npiglo,npjglo), rlat(npiglo,npjglo))

  rlon(:,:)= getvar(cf_in, cn_vlon2d, 1, npiglo, npjglo)
  rlat(:,:)= getvar(cf_in, cn_vlat2d, 1, npiglo, npjglo)

  rdumlon(:,:) = rlon(iilook,ijlook)
  rdumlat(:,:) = rlat(iilook,ijlook)

  gdept(:) = getvar1d(cf_in, cv_dep, npk, ierr)
  cv_names(:) = getvarname(cf_in, nvars, stypvar_input)

  CALL CreateOutput

  DO jt=1,npt
     DO jk=1,npk
        v2d(:,:)     = getvar(cf_in, cv_in, jk, npiglo, npjglo, ktime=jt)
        rprofile(jk) = v2d(iilook,ijlook)
        ! netcdf output 
        IF ( .NOT. l_vert_interp ) THEN
           rdummy(1,1)  = rprofile(jk)
           ierr         = putvar(ncout, id_varout(1), rdummy, jk, ikx, iky, ktime=jt)
        ENDIF
     END DO
     PRINT *, 'FILE : ', TRIM(cf_in), ' TIME = ', jt
     PRINT *, '    ', TRIM(cv_dep),'         ', TRIM(cv_in),'(',iilook,',',ijlook,')'

     IF ( l_vert_interp ) THEN
        rdummy(1,1) = vinterp (rprofile, gdept , rdep, npk )
        ierr        = putvar(ncout, id_varout(1), rdummy, 1, ikx, iky, ktime=jt)
        PRINT *, ' Interpolated value is : ', rdummy(1,1)
     ENDIF

     ! Ascii output
     DO jk=1, npk
        PRINT *, gdept(jk), rprofile(jk)
     END DO

  END DO

  ierr = closeout(ncout)

CONTAINS

  REAL(KIND=4) FUNCTION vinterp ( profile, pdept, pdep, kpk)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION vinterp  ***
    !!
    !! ** Purpose :  return the interpolated value at specified depth from
    !!               an  input profile.
    !!
    !! ** Method  :  Linear interpolation
    !!
    !!----------------------------------------------------------------------
    REAL(KIND=4), DIMENSION(kpk), INTENT(in) :: profile  ! vertical profile
    REAL(KIND=4), DIMENSION(kpk), INTENT(in) :: pdept    ! depth array
    REAL(KIND=4),                 INTENT(in) :: pdep     ! required depth
    INTEGER(KIND=4),              INTENT(in) :: kpk      ! number of level in the profile
    !
    INTEGER(KIND=4)                          :: jk       ! loop index
    INTEGER(KIND=4)                          :: ik0, ik1 ! limit index
    REAL(KIND=8)                             :: dalfa    ! weight
    !!----------------------------------------------------------------------
    ! find interpolation limits for required depth
    DO jk = 1, kpk
       IF ( pdept(jk) > pdep ) THEN
          ik0 = jk - 1
          ik1 = ik0 + 1
          EXIT
       ENDIF
    ENDDO
    dalfa   = ( pdep  - pdept(ik0) ) / ( pdept(ik1) - pdept(ik0) ) 
    vinterp =  dalfa * profile (ik1) + ( 1.d0 - dalfa ) * profile (ik0 )

  END FUNCTION vinterp

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    IF ( l_vert_interp ) THEN
       ipk(:) = 1
       ikz    = 1
       ALLOCATE ( gdepout(ikz) )
       gdepout(1) = rdep
    ELSE
       ipk(:) = npk
       ikz    = npk
       ALLOCATE ( gdepout(ikz) )
       gdepout(:) = gdept(:)
    ENDIF


    DO jvar = 1, nvars
       IF ( cv_names(jvar) == cv_in ) THEN
          stypvar=stypvar_input(jvar)
          EXIT  ! found cv_in
       ENDIF
    ENDDO

    ! create output fileset
    ncout = create      (cf_out, 'none',  ikx,      iky, ikz,     cdep='depth')
    ierr  = createvar   (ncout,  stypvar, nboutput, ipk, id_varout            )
    ierr  = putheadervar(ncout,  cf_in,   ikx,      iky, ikz,     pnavlon=rdumlon, pnavlat=rdumlat, pdep=gdepout)

    dtim = getvar1d(cf_in, cn_vtimec, npt     )
    ierr = putvar1d(ncout, dtim,      npt, 'T')

  END SUBROUTINE CreateOutput

END PROGRAM cdfprofile

PROGRAM cdfvFWov
  !!-------------------------------------------------------------------
  !!======================================================================
  !!                     ***  PROGRAM  cdfvFWov  ***
  !!=====================================================================
  !!  ** Purpose : from a section calculate net freshwater transport and its
  !!               overturning component
  !!               section is assumed to be 2 j lines (j and j+1)
  !!
  !!  ** Method  : compute salinity at v point
  !!               compute zonal mean of salinity-vpt and v velocity
  !!               compute total freshwater transport and overturning component
  !!
  !! History : 2.1  : 12/2011  : J. Deshayes  : Original code
  !!           3.0  : 12/2011  : J.M. Molines : Port to 3.0
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                            :: narg, iargc         ! arguments on command line
  INTEGER(KIND=4)                            :: npiglo, npjglo      ! size of the domain
  INTEGER(KIND=4)                            :: npk, npt            ! size of the domain
  INTEGER(KIND=4)                            :: ji, jk, jt          ! dummy loop index
  INTEGER(KIND=4)                            :: ierr                ! error status of I/O
  INTEGER(KIND=4)                            :: ncout               ! ncid of output file
  INTEGER(KIND=4)                            :: ikx=1, iky=1, ikz=1 ! dims of netcdf output file
  INTEGER(KIND=4)                            :: nboutput = 3        ! number of output variables
  INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE :: ipk, id_varout      ! output variables properties

  REAL(KIND=4), DIMENSION (:,:), ALLOCATABLE :: rmaskn, rmasks      ! S-mask North and South of V-point
  REAL(KIND=4), DIMENSION (:,:), ALLOCATABLE :: rmaskv              ! mask at V point
  REAL(KIND=4), DIMENSION (:,:), ALLOCATABLE :: zsaln, zsals        ! salinity North and South of v point
  REAL(KIND=4), DIMENSION (:,:), ALLOCATABLE :: zsalv, zvitv        ! salinity at V point, velocity
  REAL(KIND=4), DIMENSION (:,:), ALLOCATABLE :: zFWv                ! work array
  REAL(KIND=4), DIMENSION (:,:), ALLOCATABLE :: rdumlon, rdumlat    ! dummy arrays for I/O

  REAL(KIND=8), DIMENSION (:,:), ALLOCATABLE :: de3v                ! vertical metrics
  REAL(KIND=8), DIMENSION (:,:), ALLOCATABLE :: de1v                ! horizontal metrics
  REAL(KIND=8), DIMENSION (:),   ALLOCATABLE :: dnetvFW, dtotvFW    ! transport array
  REAL(KIND=8), DIMENSION (:),   ALLOCATABLE :: dovFW, dtime        ! overturning array, time
  REAL(KIND=8), DIMENSION (1)                :: dnetv, dnetFW       ! total transport accross section (mass and FW)
  REAL(KIND=8), DIMENSION (1)                :: darea, dareak       ! work space
  REAL(KIND=8), DIMENSION (1)                :: dzonalv, dzonalFW
  REAL(KIND=8)                               :: dztrp, dcellarea
  REAL(KIND=8), PARAMETER                    :: dp_rsal=35.d0       ! reference salinity for freshwater calculation

  CHARACTER(LEN=256)                         :: cf_vfil             ! input V file
  CHARACTER(LEN=256)                         :: cf_sfil             ! input S file
  CHARACTER(LEN=256)                         :: cf_zgr              ! zgr file
  CHARACTER(LEN=256)                         :: cf_hgr              ! hgr file
  CHARACTER(LEN=256)                         :: cf_mask             ! mask file
  CHARACTER(LEN=256)                         :: cf_out    = 'vFWov.nc'  ! output file
  CHARACTER(LEN=256)                         :: cv_netvFW = 'netvFW'    ! output variable 1
  CHARACTER(LEN=256)                         :: cv_totvFW = 'totvFW'    ! output variable 2
  CHARACTER(LEN=256)                         :: cv_ovFW   = 'ovFW'      ! output variable 3
  CHARACTER(LEN=256)                         :: cglobal             ! Global attribute for output file

  TYPE (variable), DIMENSION(:), ALLOCATABLE :: stypvar             ! I/O data structure

  LOGICAL                                    :: lchk = .FALSE.      ! flag for missing files
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  !!  Read command line 
  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfvFWov V-secfile S-secfile ZGR-secfile HGR-secfile MSK-secfile'
     PRINT *,'     PURPOSE :'
     PRINT *,'        Compute the fresh water transport and its overturning component through'
     PRINT *,'        a section specified by the input files (data and metrics).'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'        All arguments are ''section files'', which are assumed to be files with'
     PRINT *,'        2 zonal lines of data ( j and j+1 ): '
     PRINT *,'         - V_secfile : meridional velocity section file.'
     PRINT *,'         - S_secfile : salinity section file.'
     PRINT *,'         - ZGR_secfile : mesh_zgr section file '
     PRINT *,'         - HGR_secfile : mesh_hgr section file '
     PRINT *,'         - MSK_secfile : mask section file '
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        none'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out)
     PRINT *,'       variables : ',TRIM(cv_netvFW),', ',TRIM(cv_totvFW),', ',TRIM(cv_ovFW)
     PRINT *,'       Output file only has time relevant dimension. Other dims are set to 1.'
     PRINT *,'       Degenerated dimensions can be removed with :'
     PRINT *,'           ncwga -a x,y,depthw ',TRIM(cf_out), ' -o out.nc'
     STOP
  ENDIF

  !! get arguments
  CALL getarg (1, cf_vfil)
  CALL getarg (2, cf_sfil)
  CALL getarg (3, cf_zgr )
  CALL getarg (4, cf_hgr )
  CALL getarg (5, cf_mask)

  lchk = lchk .OR. chkfile ( cf_vfil )
  lchk = lchk .OR. chkfile ( cf_sfil )
  lchk = lchk .OR. chkfile ( cf_zgr  )
  lchk = lchk .OR. chkfile ( cf_hgr  )
  lchk = lchk .OR. chkfile ( cf_mask )

  IF ( lchk ) STOP 99 ! missing files

  !! get dimensions of input file containing data
  npiglo = getdim(cf_vfil, cn_x)
  npjglo = getdim(cf_vfil, cn_y)
  npk    = getdim(cf_vfil, cn_z)
  npt    = getdim(cf_vfil, cn_t)  

  PRINT *, 'npiglo =', npiglo
  PRINT *, 'npjglo =', npjglo
  PRINT *, 'npk    =', npk
  PRINT *, 'npt    =', npt

  IF ( npjglo /= 2 ) THEN
     PRINT *,' ERROR : This program works with section files.'
     PRINT *,'       all data should have j dimension equal to 2 '
     STOP 99
  ENDIF

  ALLOCATE ( dnetvFW(npt), dtotvFW(npt), dovFW(npt), dtime(npt) )
  ALLOCATE ( de1v(npiglo,npjglo), de3v(npiglo,npk))
  ALLOCATE ( zFWv(npiglo,npk), zvitv(npiglo,npk) )
  ALLOCATE ( zsals(npiglo,npk), zsaln(npiglo,npk), zsalv(npiglo,npk) )
  ALLOCATE ( rmasks(npiglo,npk), rmaskn(npiglo,npk), rmaskv(npiglo,npk))
  ALLOCATE ( stypvar(nboutput), ipk(nboutput), id_varout(nboutput) )
  ALLOCATE ( rdumlon(1,1), rdumlat(1,1) )

  rdumlon(:,:) = 0.e0  ! dummy longitude
  rdumlat(:,:) = 0.e0  ! dummy latitude

  !! load data
  dtime = getvar1d(cf_vfil, cn_vtimec, npt)

  !! define output variables
  ipk(:) = 1
  stypvar%rmissing_value    = 0.
  stypvar%valid_min         = -1000.
  stypvar%valid_max         = 1000.
  stypvar%conline_operation = 'N/A'
  stypvar%caxis             = 'T'
  stypvar%scale_factor      = 1.
  stypvar%add_offset        = 0.
  stypvar%savelog10         = 0.

  stypvar(1)%cname          = TRIM(cv_netvFW )
  stypvar(2)%cname          = TRIM(cv_totvFW )
  stypvar(3)%cname          = TRIM(cv_ovFW   )

  stypvar(1)%cunits         ='Sv'
  stypvar(2)%cunits         ='Sv'
  stypvar(3)%cunits         ='Sv'

  stypvar(1)%clong_name     = 'Net transport of freshwater across section'
  stypvar(2)%clong_name     = 'Transport of freshwater across section when net mass transport equals 0'
  stypvar(3)%clong_name     = 'Overturning component of freshwater transport across section'

  stypvar(1)%cshort_name    = TRIM(cv_netvFW )
  stypvar(2)%cshort_name    = TRIM(cv_totvFW )
  stypvar(3)%cshort_name    = TRIM(cv_ovFW   )

  WRITE(cglobal,'(a,f5.1,a)' ) 'comment : Reference salinity ', dp_rsal,' transport is positive northward'
  
  !! prepare output file
  ncout = create      (cf_out, 'none',  ikx,      iky, ikz,       cdep='depthw'                    )
  ierr  = createvar   (ncout,  stypvar, nboutput, ipk, id_varout, cdglobal=TRIM(cglobal)           )
  ierr  = putheadervar(ncout,  cf_vfil, ikx,      iky, ikz,       pnavlon=rdumlon, pnavlat=rdumlat )

  ierr  = putvar1d(ncout,   REAL(dtime),      npt, 'T')

  !! load scale factors 
  rmasks(:,:) = getvarxz(cf_mask, 'tmask', kj=1,   kpi=npiglo, kpz=npk,    kimin=1, kkmin=1)
  rmaskn(:,:) = getvarxz(cf_mask, 'tmask', kj=2,   kpi=npiglo, kpz=npk,    kimin=1, kkmin=1)
  rmaskv(:,:) = getvarxz(cf_mask, 'vmask', kj=1,   kpi=npiglo, kpz=npk,    kimin=1, kkmin=1)
  de1v(:,:)   = getvar  (cf_hgr, cn_ve1v,  klev=1, kpi=npiglo, kpj=npjglo, kimin=1, kjmin=1)
  de3v(:,:)   = getvarxz(cf_zgr, 'e3v',    kj=1,   kpi=npiglo, kpz=npk,    kimin=1, kkmin=1)

  WHERE ( rmasks /= 0. ) rmasks = 1.
  WHERE ( rmaskn /= 0. ) rmaskn = 1.
  WHERE ( rmaskv /= 0. ) rmaskv = 1.

  !! do calculation for each time step
  DO jt=1,npt
     PRINT *,'jt =',jt
     ! reset cumulative arrays to 0
     zFWv(:,:)   = 0.e0
     dnetv       = 0.d0  ;  dnetFW = 0.d0 
     darea       = 0.d0
     dnetvFW(jt) = 0.d0  ;  dtotvFW(jt) = 0.d0  ; dovFW(jt) = 0.d0

     zvitv(:,:)= getvarxz(cf_vfil, cn_vomecrty, kj=1, kpi=npiglo, kpz=npk, kimin=1, kkmin=1, ktime=jt) 
     zsals(:,:)= getvarxz(cf_sfil, cn_vosaline, kj=1, kpi=npiglo, kpz=npk, kimin=1, kkmin=1, ktime=jt)
     zsaln(:,:)= getvarxz(cf_sfil, cn_vosaline, kj=2, kpi=npiglo, kpz=npk, kimin=1, kkmin=1, ktime=jt)

     DO jk = 1, npk
        DO ji = 1, npiglo
           IF ( rmasks(ji,jk) + rmaskn(ji,jk) /=  0 )  THEN
              zFWv(ji,jk) = ( dp_rsal - ( zsals(ji,jk) * rmasks(ji,jk) + zsaln(ji,jk) * rmaskn(ji,jk) ) &
                   &           / ( rmasks(ji,jk) + rmaskn(ji,jk) ) ) / dp_rsal ! freshwater at Vpoint
           ENDIF
           dcellarea   = de1v(ji,1) * de3v(ji,jk) * rmaskv(ji,jk)
           dztrp       = zvitv(ji,jk) * dcellarea
           dnetvFW(jt) = dnetvFW(jt) + zFWv(ji,jk) * dztrp /1.d6         ! net freshwater transport in Sv
           dnetv       = dnetv       +               dztrp
           dnetFW      = dnetFW      + zFWv(ji,jk) * dcellarea
           darea       = darea       + dcellarea
        END DO !ji
     END DO !jk

     PRINT *,'total mass transport across section =', dnetv / 1.d6,' Sv'

     dnetv  = dnetv  / darea   ! mean velocity across section
     dnetFW = dnetFW / darea   ! mean freshwater along section
     PRINT *,'mean salinity along section =', dp_rsal - dnetFW * dp_rsal,' psu'

     DO jk = 1, npk
        dzonalv  = 0.d0
        dzonalFW = 0.d0
        dareak   = 0.d0 
        DO ji = 1, npiglo
           dcellarea = de1v(ji,1) * de3v(ji,jk) * rmaskv(ji,jk)
           dzonalv   = dzonalv  + ( zvitv(ji,jk) - dnetv  ) * dcellarea
           dzonalFW  = dzonalFW + ( zFWv(ji,jk)  - dnetFW ) * dcellarea
           dareak    = dareak   +                             dcellarea

           dtotvFW(jt) = dtotvFW(jt) + ( zvitv(ji,jk) - dnetv(1) ) * zFWv(ji,jk) * dcellarea /1.d6 
        END DO !ji

        IF ( dareak(1) > 0 ) THEN
           ! overturning freshwater transport in Sv
           dovFW(jt) = dovFW(jt) + dzonalv(1) * dzonalFW(1) / dareak(1) /1.d6  
        ENDIF
     END DO !jk

     PRINT *,'netvFW = ', dnetvFW(jt), ' Sv'
     PRINT *,'totvFW = ', dtotvFW(jt), ' Sv'
     PRINT *,'ovFW   = ', dovFW(jt),   ' Sv'
     
     ierr = putvar0d( ncout, id_varout(1), REAL(dnetvFW(jt)), ktime = jt )
     ierr = putvar0d( ncout, id_varout(2), REAL(dtotvFW(jt)), ktime = jt )
     ierr = putvar0d( ncout, id_varout(3), REAL(dovFW(jt))  , ktime = jt )

  END DO  !jt
  
  ierr = closeout(ncout)

END PROGRAM cdfvFWov

PROGRAM cdfvsig
  !!======================================================================
  !!                     ***  PROGRAM  cdfvsig  ***
  !!=====================================================================
  !!  ** Purpose : Compute the average values for the products 
  !!               U.sig, V.sig, W.sig where sig is the potential density.
  !!
  !!  ** Method  : pass the CONFIG name and a series of tags as arguments.
  !!               Tracers are interpolated on velocity points. The product
  !!               is evaluated at velocity points.
  !!
  !! History : 2.1  : 11/2004  : J.M. Molines : Original code
  !!           2.1  : 02/2010  : J.M. Molines : handle multiframes input files.
  !!           3.0  : 04/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE eos
  USE modcdfnames
  USE modutils
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: ji, jj, jk, jt, jtt  ! dummy loop index
  INTEGER(KIND=4)                           :: ierr                 ! working integer
  INTEGER(KIND=4)                           :: narg, iargc          ! command line
  INTEGER(KIND=4)                           :: npiglo,npjglo        ! size of the domain
  INTEGER(KIND=4)                           :: npk, npt             ! size of the domain
  INTEGER(KIND=4)                           :: ntframe              ! Cumul of time frame
  INTEGER(KIND=4)                           :: ncoutu               ! ncid of output file
  INTEGER(KIND=4)                           :: ncoutv               ! ncid of output file
  INTEGER(KIND=4)                           :: ncoutw               ! ncid of output file
  INTEGER(KIND=4), DIMENSION(3)             :: ipku, id_varoutu     ! level and varid's of output vars
  INTEGER(KIND=4), DIMENSION(3)             :: ipkv, id_varoutv     ! level and varid's of output vars
  INTEGER(KIND=4), DIMENSION(3)             :: ipkw, id_varoutw     ! level and varid's of output vars

  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: ztemp,  zsal         ! Array to read a layer of data
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zu, zv, zw           ! Velocity component
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: ztempu, zsalu        ! Array to read a layer of data
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: ztempv, zsalv        ! Array to read a layer of data
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: ztempw, zsalw        ! Array to read a layer of data
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: umask,  vmask, wmask ! masks
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: tim                  ! time counter of individual files
  REAL(KIND=4), DIMENSION(1)                :: timean               ! mean time

  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dcumulus             ! Arrays for cumulated values
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dcumulvs             ! Arrays for cumulated values
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dcumulws             ! Arrays for cumulated values
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dcumulsu             ! Arrays for cumulated values
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dcumulsv             ! Arrays for cumulated values
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dcumulsw             ! Arrays for cumulated values
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dcumulu              ! Arrays for cumulated values
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dcumulv              ! Arrays for cumulated values
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dcumulw              ! Arrays for cumulated values
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dsigu                ! Array for sigma0 at u point
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dsigv                ! Array for sigma0 at v point
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dsigw                ! Array for sigma0 at w point
  REAL(KIND=8)                              :: dtotal_time          ! cumulated time

  CHARACTER(LEN=256)                        :: cf_tfil              ! TS file name
  CHARACTER(LEN=256)                        :: cf_ufil              ! zonal velocity file
  CHARACTER(LEN=256)                        :: cf_vfil              ! meridional velocity file
  CHARACTER(LEN=256)                        :: cf_wfil              ! vertical velocity file
  CHARACTER(LEN=256)                        :: cf_outu='usig.nc'    ! output file
  CHARACTER(LEN=256)                        :: cf_outv='vsig.nc'    ! output file
  CHARACTER(LEN=256)                        :: cf_outw='wsig.nc'    ! output file
  CHARACTER(LEN=256)                        :: config               ! configuration name
  CHARACTER(LEN=256)                        :: ctag                 ! current tag to work with               

  TYPE (variable), DIMENSION(3)             :: stypvaru             ! structure for attributes
  TYPE (variable), DIMENSION(3)             :: stypvarv             ! structure for attributes
  TYPE (variable), DIMENSION(3)             :: stypvarw             ! structure for attributes

  LOGICAL                                   :: lcaltmean            ! flag for mean time computation
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  !!  Read command line
  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfvsig CONFIG ''list_of_tags'' '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the time average values for second order products ' 
     PRINT *,'       U.sig,  V.sig and W.sig.  Also save mean sigma-0 interpolated at'
     PRINT *,'       velocity points, as well as mean velocity component, for further use.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       CONFIG is the config name of a given experiment (eg ORCA025-G70)'
     PRINT *,'            The program will look for gridT, gridU, gridV  and gridW files for' 
     PRINT *,'            this config ( grid_T, grid_U, grid_V and grid_W are also accepted).'
     PRINT *,'       list_of_tags : a list of time tags that will be used for time'
     PRINT *,'            averaging. e.g. y2000m01d05 y2000m01d10 ...'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        ',TRIM(cn_fmsk)
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_outu),', ',TRIM(cf_outv),' and ', TRIM(cf_outw)
     PRINT *,'       variables : vousig, vovsig, vowsig : mean product v x sigma-0 '
     PRINT *,'                                            at velocity point.'
     PRINT *,'                   vosigu, vosigv, vosigw : mean sigma-0 at velocity point.'
     PRINT *,'                   ',TRIM(cn_vozocrtx),', ',TRIM(cn_vomecrty),', ',TRIM(cn_vovecrtz),' : mean velocity components.'
     STOP
  ENDIF

  !! Initialisation from 1st file (all file are assume to have the same geometry)
  CALL getarg (1, config)
  CALL getarg (2, ctag  )

  cf_tfil = SetFileName ( config, ctag, 'T')
  cf_ufil = SetFileName ( config, ctag, 'U')
  cf_vfil = SetFileName ( config, ctag, 'V')
  cf_wfil = SetFileName ( config, ctag, 'W')

  npiglo = getdim (cf_tfil,cn_x)
  npjglo = getdim (cf_tfil,cn_y)
  npk    = getdim (cf_tfil,cn_z)

  ipku(:)= npk  ! all variables (input and output are 3D)
  ipkv(:)= npk  !   "                     "
  ipkw(:)= npk  !   "                     "

  ! define output variables  U points
  stypvaru%rmissing_value    = 0.
  stypvaru%valid_min         = -100.
  stypvaru%valid_max         = 100.
  stypvaru%conline_operation = 'N/A'
  stypvaru%caxis             = 'TZYX'

  stypvaru(1)%cname          = 'vousig'           ; stypvaru(1)%cunits        = 'kg.m-2.s-1'
  stypvaru(2)%cname          = 'vosigu'           ; stypvaru(2)%cunits        = 'kg.m-3'
  stypvaru(3)%cname          =  cn_vozocrtx       ; stypvaru(3)%cunits        = 'm/s'

  stypvaru(1)%clong_name     = 'Mean U x sigma0'  ; stypvaru(1)%cshort_name   = 'vousig'
  stypvaru(2)%clong_name     = 'Mean sigma0 at U' ; stypvaru(2)%cshort_name   = 'vosigu'
  stypvaru(3)%clong_name     = 'Mean zonal vel'   ; stypvaru(3)%cshort_name   = cn_vozocrtx

  ! define output variables  V points
  stypvarv%rmissing_value    = 0.
  stypvarv%valid_min         = -100.
  stypvarv%valid_max         = 100.
  stypvarv%conline_operation = 'N/A'
  stypvarv%caxis             = 'TZYX'

  stypvarv(1)%cname          = 'vovsig'           ; stypvarv(1)%cunits        = 'kg.m-2.s-1'
  stypvarv(2)%cname          = 'vosigv'           ; stypvarv(2)%cunits        = 'kg.m-3'
  stypvarv(3)%cname          =  cn_vomecrty       ; stypvarv(3)%cunits        = 'm/s'

  stypvarv(1)%clong_name     = 'Mean V x sigma0'  ; stypvarv(1)%cshort_name   = 'vovsig'
  stypvarv(2)%clong_name     = 'Mean sigma0 at V' ; stypvarv(2)%cshort_name   = 'vosigv'
  stypvarv(3)%clong_name     = 'Mean merid vel'   ; stypvarv(3)%cshort_name   = cn_vomecrty

  ! define output variables  W points
  stypvarw%rmissing_value    = 0.
  stypvarw%valid_min         = -100.
  stypvarw%valid_max         = 100.
  stypvarw%conline_operation = 'N/A'
  stypvarw%caxis             = 'TZYX'

  stypvarw(1)%cname          = 'vowsig'           ; stypvarw(1)%cunits        = 'kg.m-2.s-1'
  stypvarw(2)%cname          = 'vosigw'           ; stypvarw(2)%cunits        = 'kg.m-3'
  stypvarw(3)%cname          =  cn_vovecrtz       ; stypvarw(3)%cunits        = 'm/s'

  stypvarw(1)%clong_name     = 'Mean W x sigma0'  ; stypvarw(1)%cshort_name   = 'vowsig'
  stypvarw(2)%clong_name     = 'Mean sigma0 at W' ; stypvarw(2)%cshort_name   = 'vosigw'
  stypvarw(3)%clong_name     = 'Mean vert. vel'   ; stypvarw(3)%cshort_name   = cn_vovecrtz

  PRINT *, 'npiglo =', npiglo
  PRINT *, 'npjglo =', npjglo
  PRINT *, 'npk    =', npk

  ALLOCATE( dcumulus(npiglo,npjglo), dcumulvs(npiglo,npjglo), dcumulws(npiglo,npjglo) )
  ALLOCATE( dcumulsu(npiglo,npjglo), dcumulsv(npiglo,npjglo), dcumulsw(npiglo,npjglo) )
  ALLOCATE( dcumulu(npiglo,npjglo),  dcumulv(npiglo,npjglo),  dcumulw(npiglo,npjglo)  )
  ALLOCATE( ztemp(npiglo,npjglo),    zsal(npiglo,npjglo)                              )
  ALLOCATE( zu(npiglo,npjglo),       zv(npiglo,npjglo),       zw(npiglo,npjglo)       )
  ALLOCATE( dsigu(npiglo,npjglo),    dsigv(npiglo,npjglo),    dsigw(npiglo,npjglo)    )
  ALLOCATE( umask(npiglo,npjglo),    vmask(npiglo,npjglo),    wmask(npiglo,npjglo)    )

  ! create output fileset
  ncoutu = create      (cf_outu, cf_ufil,  npiglo, npjglo, npk        )
  ierr   = createvar   (ncoutu,  stypvaru, 3,      ipku,   id_varoutu )
  ierr   = putheadervar(ncoutu,  cf_ufil,  npiglo, npjglo, npk        )

  ncoutv = create      (cf_outv, cf_vfil,  npiglo, npjglo, npk        )
  ierr   = createvar   (ncoutv,  stypvarv, 3,      ipkv,   id_varoutv )
  ierr   = putheadervar(ncoutv,  cf_vfil,  npiglo, npjglo, npk        )

  ncoutw = create      (cf_outw, cf_wfil,  npiglo, npjglo, npk        )
  ierr   = createvar   (ncoutw,  stypvarw, 3,      ipku,   id_varoutw )
  ierr   = putheadervar(ncoutw,  cf_wfil,  npiglo, npjglo, npk        )

  lcaltmean=.TRUE.
  DO jk = 1, npk
     PRINT *,'level ',jk
     dcumulus(:,:) = 0.d0 ;  dcumulvs(:,:) = 0.d0 ; dcumulws(:,:) = 0.d0
     dcumulsu(:,:) = 0.d0 ;  dcumulsv(:,:) = 0.d0 ; dcumulsw(:,:) = 0.d0
     dcumulu(:,:)  = 0.d0 ;  dcumulv(:,:)  = 0.d0 ; dcumulw(:,:)  = 0.d0
     dtotal_time   = 0.d0 ;  ntframe       = 0
     
     umask(:,:) = getvar(cn_fmsk, 'umask' , jk, npiglo, npjglo )
     vmask(:,:) = getvar(cn_fmsk, 'vmask' , jk, npiglo, npjglo )
     wmask(:,:) = getvar(cn_fmsk, 'tmask' , jk, npiglo, npjglo )

     DO jt = 2, narg           ! loop on tags
        CALL getarg (jt, ctag)
        cf_tfil = SetFileName ( config, ctag, 'T' )
        cf_ufil = SetFileName ( config, ctag, 'U' )
        cf_vfil = SetFileName ( config, ctag, 'V' )
        cf_wfil = SetFileName ( config, ctag, 'W' )

        npt = getdim (cf_tfil, cn_t)
        IF ( lcaltmean ) THEN
           ALLOCATE ( tim(npt) )
           tim = getvar1d(cf_tfil, cn_vtimec, npt)
           dtotal_time = dtotal_time + SUM(tim(1:npt) )
           DEALLOCATE( tim )
        END IF

        DO jtt = 1, npt  ! loop on time frame in a single file
           ntframe    = ntframe+1
           zu(:,:)    = getvar(cf_ufil, cn_vozocrtx, jk, npiglo, npjglo, ktime=jtt )
           zv(:,:)    = getvar(cf_vfil, cn_vomecrty, jk, npiglo, npjglo, ktime=jtt )
           zw(:,:)    = getvar(cf_wfil, cn_vovecrtz, jk, npiglo, npjglo, ktime=jtt )
           ztemp(:,:) = getvar(cf_tfil, cn_votemper, jk, npiglo, npjglo, ktime=jtt )
           zsal(:,:)  = getvar(cf_tfil, cn_vosaline, jk, npiglo, npjglo, ktime=jtt )

           ! temperature at u point, v points
           dsigu(:,:) = 0.d0  ; dsigv(:,:) = 0.d0
           DO ji=1, npiglo-1
              DO jj = 1, npjglo -1
                 ztempu(ji,jj) = 0.5 * ( ztemp(ji,jj) + ztemp(ji+1,jj) )  ! temper at Upoint
                 ztempv(ji,jj) = 0.5 * ( ztemp(ji,jj) + ztemp(ji,jj+1) )  ! temper at Vpoint
                 zsalu(ji,jj)  = 0.5 * ( zsal(ji,jj)  +  zsal(ji+1,jj) )  ! sal at U point
                 zsalv(ji,jj)  = 0.5 * ( zsal(ji,jj)  +  zsal(ji,jj+1) )  ! sal at v point
              END DO
           END DO
           
           dsigu(:,:) = sigma0(ztempu, zsalu, npiglo, npjglo) * umask(:,:)
           dsigv(:,:) = sigma0(ztempv, zsalv, npiglo, npjglo) * vmask(:,:)

           dcumulus(:,:) = dcumulus(:,:) + dsigu(:,:) * zu(:,:) * 1.d0
           dcumulvs(:,:) = dcumulvs(:,:) + dsigv(:,:) * zv(:,:) * 1.d0
           dcumulsu(:,:) = dcumulsu(:,:) + dsigu(:,:) * 1.d0
           dcumulsv(:,:) = dcumulsv(:,:) + dsigv(:,:) * 1.d0
           dcumulu(:,:)  = dcumulu(:,:)  + zu(:,:)    * 1.d0
           dcumulv(:,:)  = dcumulv(:,:)  + zv(:,:)    * 1.d0
          
           IF ( jk > 1 ) THEN ! now wsig
               ztempw(:,:)   = 0.5 * ( ztemp(:,:) + getvar(cf_tfil, cn_votemper, jk-1, npiglo, npjglo, ktime=jtt ))
               zsalw(:,:)    = 0.5 * ( zsal(:,:)  + getvar(cf_tfil, cn_vosaline, jk-1, npiglo, npjglo, ktime=jtt ))
               dsigw(:,:)    = sigma0(ztempw, zsalw, npiglo, npjglo) * wmask(:,:)
               dcumulws(:,:) = dcumulws(:,:) + dsigw(:,:) * zw(:,:) * 1.d0
               dcumulsw(:,:) = dcumulsw(:,:) + dsigw(:,:) * 1.d0
               dcumulw(:,:)  = dcumulw(:,:)  + zw(:,:)    * 1.d0
           ENDIF

        END DO  !jtt
     END DO  ! jt
     ! finish with level jk ; compute mean (assume spval is 0 )
     ierr = putvar(ncoutu, id_varoutu(1), SNGL(dcumulus(:,:)/ntframe), jk, npiglo, npjglo, kwght=ntframe )
     ierr = putvar(ncoutu, id_varoutu(2), SNGL(dcumulsu(:,:)/ntframe), jk, npiglo, npjglo, kwght=ntframe )
     ierr = putvar(ncoutu, id_varoutu(3), SNGL(dcumulu(:,:) /ntframe), jk, npiglo, npjglo, kwght=ntframe )

     ierr = putvar(ncoutv, id_varoutv(1), SNGL(dcumulvs(:,:)/ntframe), jk, npiglo, npjglo, kwght=ntframe )
     ierr = putvar(ncoutv, id_varoutv(2), SNGL(dcumulsv(:,:)/ntframe), jk, npiglo, npjglo, kwght=ntframe )
     ierr = putvar(ncoutv, id_varoutv(3), SNGL(dcumulv(:,:) /ntframe), jk, npiglo, npjglo, kwght=ntframe )

     ierr = putvar(ncoutw, id_varoutw(1), SNGL(dcumulws(:,:)/ntframe), jk, npiglo, npjglo, kwght=ntframe )
     ierr = putvar(ncoutw, id_varoutw(2), SNGL(dcumulsw(:,:)/ntframe), jk, npiglo, npjglo, kwght=ntframe )
     ierr = putvar(ncoutw, id_varoutw(3), SNGL(dcumulw(:,:) /ntframe), jk, npiglo, npjglo, kwght=ntframe )

     IF ( lcaltmean )  THEN
        timean(1) = dtotal_time/ntframe
        ierr      = putvar1d(ncoutu, timean, 1, 'T')
        ierr      = putvar1d(ncoutv, timean, 1, 'T')
        ierr      = putvar1d(ncoutw, timean, 1, 'T')
     END IF

     lcaltmean = .FALSE. ! tmean already computed

  END DO  ! loop to next level

  ierr = closeout(ncoutu)
  ierr = closeout(ncoutv)
  ierr = closeout(ncoutw)

END PROGRAM cdfvsig

PROGRAM cdfnamelist
  !!======================================================================
  !!                     ***  PROGRAM  cdfnamelist  ***
  !!=====================================================================
  !!  ** Purpose : Give informations on the namelist mechanism implemented
  !!               in CDFTOOLS_3. 
  !!               Write a template namelist for CDFTOOLS_3.0, usefull
  !!               to change default file names, variable  or dimension
  !!               names.
  !!
  !!  ** Method  : 
  !!
  !! History :  3.0  : 01/2011  : J.M. Molines : Original code
  !!----------------------------------------------------------------------
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)   :: narg, iargc, ijarg

  CHARACTER(LEN=80) :: cldum
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()

  IF ( narg == 0 ) THEN
     PRINT *,' usage :  cdfnamelist [-i] [-p]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Give information [-i option] on the namelist mechanism implemented' 
     PRINT *,'       in CDFTOOLS v3. Write a namelist template [-p option ] to initialize'
     PRINT *,'       the mechanism.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       none' 
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [ -i ] : print informations ' 
     PRINT *,'       [ -p ] : write a template namelist.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       none' 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       with option -p, print a template namelist : PrintCdfNames.namlist'
     PRINT *,'      '
     STOP
  ENDIF

  ijarg = 1
  DO WHILE ( ijarg <= narg ) 
     CALL getarg( ijarg, cldum ) ; ijarg = ijarg + 1
     SELECT CASE ( cldum )
     CASE ( '-i' ) 
        CALL InfoUseNamelist()
     CASE ( '-p' )
        CALL PrintCdfNames()
     CASE DEFAULT
        PRINT *, TRIM(cldum),' : unknown option in cdfnamelist '
     END SELECT
  END DO

CONTAINS

  SUBROUTINE InfoUseNamelist()
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE InfoUseNamelist  ***
    !!
    !! ** Purpose :  Print detailed info on the use of namelist in
    !!               CDFTOOLS_3.0 
    !!
    !!----------------------------------------------------------------------
    PRINT *,'   In CDFTOOLS_3 the variable names, dimension names, mesh_mask'
    PRINT *,' file names can be customized via a system of namelist.'
    PRINT *,'   A call to ReadCdfNames at the begining of the program allows'
    PRINT *,' the update of the names used in the program.'
    PRINT *,'   If there is no need for changing names, then it is not necessary'
    PRINT *,' to give a namelist, the default values are OK.'
    PRINT *,'   '
    PRINT *,'   If you need to change any of the default values, then you can'
    PRINT *,' use the namelist system to make this change effective. Doing do'
    PRINT *,' some rules are to be followed for proper use.'
    PRINT *,'   '
    PRINT *,'NAMELIST EDITING'
    PRINT *,'   To have a template of a CDFTOOLS_3 namelist, use the statement'
    PRINT *,'     cdfnamelist -p '
    PRINT *,' This will give you a template namelist (PrintCdfNames.namlist)'
    PRINT *,' that you have to customized for your application.'
    PRINT *,'   Some comments are made within this namelist for particular blocks.'
    PRINT *,' '
    PRINT *,'NAME AND LOCATION OF THE NAMELIST'
    PRINT *,'   The default name of the namelist read by ReadCdfNames is '
    PRINT *,'     nam_cdf_names'
    PRINT *,'   ReadCdfNames look for the namelist in the current directory (./)'
    PRINT *,' and, if not found there, in the $HOME/CDFTOOLS_cfg/ directory'
    PRINT *,'   The name of the namelist can be changed setting the environment'
    PRINT *,' variable NAM_CDF_NAMES to the desired value.' 
    PRINT *,'    '

  END SUBROUTINE InfoUseNamelist

END PROGRAM cdfnamelist

PROGRAM cdfvT
  !!======================================================================
  !!                     ***  PROGRAM  cdfvT  ***
  !!=====================================================================
  !!  ** Purpose : Compute the average values for the products 
  !!               V.T, V.S, U.T and U.S, used afterward for heat and
  !!               salt transport.
  !!
  !!  ** Method  : pass the CONFIG name and a series of tags as arguments.
  !!
  !! History : 2.1  : 11/2004  : J.M. Molines : Original code
  !!           2.1  : 02/2010  : J.M. Molines : handle multiframes input files.
  !!           3.0  : 04/2011  : J.M. Molines : Doctor norm + Lic.
  !!                : 10/2012  : M. Balmaseda : Split T and S file eventually
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  USE modutils       ! SetFileName function
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class second_order_moments
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: ji, jj, jk, jv, jtt, jt  ! dummy loop index
  INTEGER(KIND=4)                           :: ierr                 ! working integer
  INTEGER(KIND=4)                           :: narg, iargc          ! command line
  INTEGER(KIND=4)                           :: ijarg                ! command line
  INTEGER(KIND=4)                           :: npiglo,npjglo        ! size of the domain
  INTEGER(KIND=4)                           :: npk, npt             ! size of the domain
  INTEGER(KIND=4)                           :: ntframe              ! Cumul of time frame
  INTEGER(KIND=4)                           :: ntags                ! number of tags in the list
  INTEGER(KIND=4)                           :: ncout                ! ncid of output file
  INTEGER(KIND=4)                           :: nvaro                ! Number of output variables
  INTEGER(KIND=4), DIMENSION(:),ALLOCATABLE :: ipk, id_varout       ! level and varid's of output vars

  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: ztemp, zsal          ! Array to read a layer of data
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zu, zv               ! Velocity component
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zworku, zworkv       ! working arrays
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e3u, e3v             ! vertical metrics for vvl case

  REAL(KIND=8), DIMENSION(1)                :: dtimean              ! mean time
  REAL(KIND=8), DIMENSION(:),   ALLOCATABLE :: dtim                 ! time counter of individual files
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dcumulut, dcumulus   ! Arrays for cumulated values
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dcumulvt, dcumulvs   ! Arrays for cumulated values
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dcumule3u, dcumule3v ! Arrays for cumulated vertical metrics (vvl case)
  REAL(KIND=8)                              :: dtotal_time          ! cumulated time

  CHARACTER(LEN=256)                        :: cf_tfil              ! T file name
  CHARACTER(LEN=256)                        :: cf_sfil              ! S file name [default: idem T file]
  CHARACTER(LEN=256)                        :: cf_ufil              ! zonal velocity file
  CHARACTER(LEN=256)                        :: cf_vfil              ! meridional velocity file
  CHARACTER(LEN=256)                        :: cf_out='vt.nc'       ! output file
  CHARACTER(LEN=256)                        :: config               ! configuration name
  CHARACTER(LEN=256)                        :: ctag                 ! current tag to work with               
  CHARACTER(LEN=256)                        :: cldum                ! dummy character argument
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: ctag_lst         ! dummy character argument

  TYPE (variable), DIMENSION(:), ALLOCATABLE:: stypvar          ! structure for attributes

  LOGICAL                                   :: lcaltmean            ! flag for mean time computation
  LOGICAL                                   :: lnc4=.FALSE.         ! flag for netcdf4 output with chunking and deflation
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  !!  Read command line
  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfvT -c CONFIG-CASE -l LST-tags [-o OUT-file ] [-nc4 ] [-vvl]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the time average values for second order moments V.T, V.S, U.T' 
     PRINT *,'       and U.S used in heat and salt transport computation.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -c CONFIG-CASE is the config name of a given experiment (eg ORCA025-G70)'
     PRINT *,'            The program will look for gridT, gridU and gridV files for this ' 
     PRINT *,'            config ( grid_T, grid_U and grid_V are also accepted).'
     PRINT *,'            Additionaly, if gridS or grid_S file is found, it will be taken'
     PRINT *,'            in place of gridT for the salinity variable.'
     PRINT *,'       -l LST-tags : a blank-separated list of time tags that will be used for'
     PRINT *,'            time averaging, e.g.:  y2000m01d05 y2000m01d10 ...'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-o OUT-file] : specify output file name instead of ', TRIM(cf_out)
     PRINT *,'       [-nc4 ] use netcdf4 output with chunking and deflation 1'
     PRINT *,'       [-vvl ] use time varying vertical metrics.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        none'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) ,' unless -o option used.'
     PRINT *,'       variables : ',TRIM(cn_vozout),' time-mean ( U.T ) at U point.'
     PRINT *,'                   ',TRIM(cn_vozous),' time-mean ( U.S ) at U point.'
     PRINT *,'                   ',TRIM(cn_vomevt),' time-mean ( V.T ) at V point.'
     PRINT *,'                   ',TRIM(cn_vomevs),' time-mean ( V.S ) at V point.'
     PRINT *,'      '
     STOP 
  ENDIF

  !! Initialisation from 1st file (all file are assume to have the same geometry)
  ijarg = 1 
  DO WHILE ( ijarg <= narg ) 
     CALL getarg (ijarg, cldum ) ; ijarg=ijarg+1
     SELECT CASE ( cldum ) 
     CASE ( '-c'   ) ; CALL getarg (ijarg, config) ; ijarg=ijarg+1
     CASE ( '-l'   ) ; CALL GetTagList
        ! options
     CASE ( '-o'   ) ; CALL getarg (ijarg, cf_out) ; ijarg=ijarg+1
     CASE ( '-nc4' ) ; lnc4   = .TRUE.
     CASE ( '-vvl' ) ; lg_vvl = .TRUE.
     CASE DEFAULT    ; PRINT *,' ERROR : ',TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  ENDDO

  cf_tfil = SetFileName( config, ctag_lst(1), 'T')

  npiglo = getdim (cf_tfil,cn_x)
  npjglo = getdim (cf_tfil,cn_y)
  npk    = getdim (cf_tfil,cn_z)

  PRINT *, 'npiglo =', npiglo
  PRINT *, 'npjglo =', npjglo
  PRINT *, 'npk    =', npk

  IF ( lg_vvl ) THEN
     nvaro = 6  ! UT US VT VS e3u, e3v
     cn_ve3u = cn_ve3uvvl
     cn_ve3v = cn_ve3vvvl
  ELSE
     nvaro = 4  ! UT US VT VS
  ENDIF

  ALLOCATE( dcumulut(npiglo,npjglo), dcumulus(npiglo,npjglo) )
  ALLOCATE( dcumulvt(npiglo,npjglo), dcumulvs(npiglo,npjglo) )
  ALLOCATE( zu(npiglo,npjglo),    zv(npiglo,npjglo) )
  ALLOCATE( zworku(npiglo,npjglo),   zworkv(npiglo,npjglo) )
  ALLOCATE( ztemp(npiglo,npjglo),    zsal(npiglo,npjglo) )
  ALLOCATE( id_varout(nvaro), ipk(nvaro), stypvar(nvaro) )
  IF (lg_vvl ) THEN
     ALLOCATE(       e3u(npiglo,npjglo),       e3v(npiglo,npjglo))
     ALLOCATE( dcumule3u(npiglo,npjglo), dcumule3v(npiglo,npjglo) )
  ENDIF

  CALL CreateOutput

  lcaltmean=.TRUE.
  DO jk = 1, npk
     PRINT *,'level ',jk
     dcumulut(:,:) = 0.d0 ;  dcumulvt(:,:) = 0.d0 ; dtotal_time = 0.d0
     dcumulus(:,:) = 0.d0 ;  dcumulvs(:,:) = 0.d0 ; ntframe = 0
     IF ( lg_vvl ) THEN
        dcumule3u(:,:) = 0.d0 ;  dcumule3v(:,:) = 0.d0
     ENDIF

     DO jt = 1, ntags
        ctag=ctag_lst(jt) 
        cf_tfil = SetFileName( config, ctag, 'T', ld_stop=.TRUE. )
        cf_sfil = SetFileName( config, ctag, 'S', ld_stop=.FALSE.)      ! do not stop if gridS/grid_S not found !
        IF ( chkfile (cf_sfil, ld_verbose=.FALSE.) ) cf_sfil = cf_tfil  ! do not complain if not found

        npt = getdim (cf_tfil, cn_t)
        IF ( lcaltmean ) THEN
           ALLOCATE ( dtim(npt) )
           dtim        = getvar1d(cf_tfil, cn_vtimec, npt)
           dtotal_time = dtotal_time + SUM(dtim(1:npt) )
           DEALLOCATE( dtim )
        END IF

        ! assume U and V file have same time span ...
        cf_ufil = SetFileName( config, ctag, 'U' )
        cf_vfil = SetFileName( config, ctag, 'V' )

        DO jtt = 1, npt  ! loop on time frame in a single file
           ntframe = ntframe+1
           zu(:,:)    = getvar(cf_ufil, cn_vozocrtx, jk, npiglo, npjglo, ktime=jtt )
           zv(:,:)    = getvar(cf_vfil, cn_vomecrty, jk, npiglo, npjglo, ktime=jtt )
           ztemp(:,:) = getvar(cf_tfil, cn_votemper, jk, npiglo, npjglo, ktime=jtt )
           zsal(:,:)  = getvar(cf_sfil, cn_vosaline, jk, npiglo, npjglo, ktime=jtt )

           IF ( lg_vvl ) THEN
              e3u(:,:) = getvar(cf_ufil, cn_ve3u, jk, npiglo, npjglo, ktime=jtt )
              e3v(:,:) = getvar(cf_vfil, cn_ve3v, jk, npiglo, npjglo, ktime=jtt )
           ENDIF

           ! temperature at u point, v points ( As in NEMO, with or without  vvl Temp a U/V points is 
           ! computed as follow ( second order) 
           zworku(:,:) = 0. ; zworkv(:,:) = 0.
           DO ji=1, npiglo-1
              DO jj = 1, npjglo -1
                 zworku(ji,jj) = 0.5 * ( ztemp(ji,jj) + ztemp(ji+1,jj) )  ! temper at Upoint
                 zworkv(ji,jj) = 0.5 * ( ztemp(ji,jj) + ztemp(ji,jj+1) )  ! temper at Vpoint
              END DO
           END DO

           IF (lg_vvl ) THEN
              dcumulut(:,:) = dcumulut(:,:) + zworku(:,:) * e3u(:,:) * zu(:,:)*1.d0
              dcumulvt(:,:) = dcumulvt(:,:) + zworkv(:,:) * e3v(:,:) * zv(:,:)*1.d0
              dcumule3u(:,:) = dcumule3u(:,:) +  e3u(:,:) *1.d0
              dcumule3v(:,:) = dcumule3v(:,:) +  e3v(:,:) *1.d0
           ELSE
              dcumulut(:,:) = dcumulut(:,:) + zworku(:,:) * zu(:,:)*1.d0
              dcumulvt(:,:) = dcumulvt(:,:) + zworkv(:,:) * zv(:,:)*1.d0
           ENDIF

           ! salinity at u points, v points
           zworku(:,:) = 0. ; zworkv(:,:) = 0.
           DO ji=1, npiglo-1
              DO jj = 1, npjglo -1
                 zworku(ji,jj) = 0.5 * ( zsal(ji,jj) + zsal(ji+1,jj) )  ! salinity  at Upoint
                 zworkv(ji,jj) = 0.5 * ( zsal(ji,jj) + zsal(ji,jj+1) )  ! salinity  at Vpoint
              END DO
           END DO

           IF (lg_vvl ) THEN
              dcumulus(:,:) = dcumulus(:,:) + zworku(:,:) * e3u(:,:) * zu(:,:)*1.d0
              dcumulvs(:,:) = dcumulvs(:,:) + zworkv(:,:) * e3v(:,:) * zv(:,:)*1.d0
           ELSE
              dcumulus(:,:) = dcumulus(:,:) + zworku(:,:) * zu(:,:)*1.d0
              dcumulvs(:,:) = dcumulvs(:,:) + zworkv(:,:) * zv(:,:)*1.d0
           ENDIF

        END DO  !jtt
     END DO  ! arg list
     ! finish with level jk ; compute mean (assume spval is 0 )
     ! JMM In the following line multiplication by 1.e0 is a trick to write real*4 values.
     IF ( lg_vvl) THEN
        ierr = putvar(ncout, id_varout(1), dcumulvt(:,:)/dcumule3v(:,:)*1.e0, jk,npiglo, npjglo, kwght=ntframe )
        ierr = putvar(ncout, id_varout(2), dcumulvs(:,:)/dcumule3v(:,:)*1.e0, jk,npiglo, npjglo, kwght=ntframe )
        ierr = putvar(ncout, id_varout(3), dcumulut(:,:)/dcumule3u(:,:)*1.e0, jk,npiglo, npjglo, kwght=ntframe )
        ierr = putvar(ncout, id_varout(4), dcumulus(:,:)/dcumule3u(:,:)*1.e0, jk,npiglo, npjglo, kwght=ntframe )
        ierr = putvar(ncout, id_varout(5), dcumule3u(:,:)/ntframe      *1.e0, jk,npiglo, npjglo, kwght=ntframe )
        ierr = putvar(ncout, id_varout(6), dcumule3v(:,:)/ntframe      *1.e0, jk,npiglo, npjglo, kwght=ntframe )
     ELSE
        ierr = putvar(ncout, id_varout(1), dcumulvt(:,:)/ntframe*1.d0, jk,npiglo, npjglo, kwght=ntframe )
        ierr = putvar(ncout, id_varout(2), dcumulvs(:,:)/ntframe*1.d0, jk,npiglo, npjglo, kwght=ntframe )
        ierr = putvar(ncout, id_varout(3), dcumulut(:,:)/ntframe*1.d0, jk,npiglo, npjglo, kwght=ntframe )
        ierr = putvar(ncout, id_varout(4), dcumulus(:,:)/ntframe*1.d0, jk,npiglo, npjglo, kwght=ntframe )
     ENDIF

     IF (lcaltmean )  THEN
        dtimean(1) = dtotal_time/ntframe
        ierr       = putvar1d(ncout, dtimean, 1, 'T')
     END IF
     lcaltmean=.FALSE. ! tmean already computed

  END DO  ! loop to next level

  ierr = closeout(ncout)

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------

    ipk(:)= npk  ! all variables (input and output are 3D)
    ! define output variables
    stypvar%rmissing_value    = 0.
    stypvar%valid_min         = -100.
    stypvar%valid_max         = 100.
    stypvar%conline_operation = 'N/A'
    stypvar%caxis             = 'TZYX'

    DO jv = 1, nvaro
       stypvar(jv)%ichunk = (/npiglo,MAX(1,npjglo/30), 1, 1 /)
    ENDDO

    stypvar(1)%cname          = cn_vomevt       ; stypvar(1)%cunits        = 'm.DegC.s-1'
    stypvar(2)%cname          = cn_vomevs       ; stypvar(2)%cunits        = 'm.PSU.s-1'
    stypvar(3)%cname          = cn_vozout       ; stypvar(3)%cunits        = 'm.DegC.s-1'
    stypvar(4)%cname          = cn_vozous       ; stypvar(4)%cunits        = 'm.PSU.s-1'

    stypvar(1)%clong_name     = 'Meridional_VT' ; stypvar(1)%cshort_name   = cn_vomevt
    stypvar(2)%clong_name     = 'Meridional_VS' ; stypvar(2)%cshort_name   = cn_vomevs
    stypvar(3)%clong_name     = 'Zonal_UT'      ; stypvar(3)%cshort_name   = cn_vozout
    stypvar(4)%clong_name     = 'Zonal_US'      ; stypvar(4)%cshort_name   = cn_vozous

    IF ( lg_vvl ) THEN
       stypvar(5)%cname       = cn_ve3u         ; stypvar(5)%cunits        = 'm'
       stypvar(6)%cname       = cn_ve3v         ; stypvar(6)%cunits        = 'm'

       stypvar(5)%clong_name  = 'Mean_e3u'      ; stypvar(5)%cshort_name   = cn_ve3u
       stypvar(6)%clong_name  = 'Mean_e3v'      ; stypvar(6)%cshort_name   = cn_ve3v
    ENDIF

    ! create output fileset
    ncout = create      (cf_out, cf_tfil, npiglo, npjglo, npk, ld_xycoo=.TRUE. , ld_nc4=lnc4 )
    ierr  = createvar   (ncout , stypvar, nvaro,      ipk,    id_varout        , ld_nc4=lnc4 )
    ierr  = putheadervar(ncout,  cf_tfil, npiglo, npjglo, npk, ld_xycoo=.TRUE. )

  END SUBROUTINE CreateOutput

  SUBROUTINE GetTagList
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE GetTagList  ***
    !!
    !! ** Purpose :  Set up a tag list given on the command line as 
    !!               blank separated list
    !!
    !! ** Method  :  Scan the command line until a '-' is found
    !!----------------------------------------------------------------------
    INTEGER (KIND=4)  :: ji
    INTEGER (KIND=4)  :: icur
    !!----------------------------------------------------------------------
    !!
    ntags=0
    ! need to read a list of file ( number unknow ) 
    ! loop on argument till a '-' is found as first char
    icur=ijarg                          ! save current position of argument number
    DO ji = icur, narg                  ! scan arguments till - found
       CALL getarg ( ji, cldum )
       IF ( cldum(1:1) /= '-' ) THEN ; ntags = ntags+1
       ELSE                          ; EXIT
       ENDIF
    ENDDO
    ALLOCATE (ctag_lst(ntags) )
    DO ji = icur, icur + ntags -1
       CALL getarg(ji, ctag_lst( ji -icur +1 ) ) ; ijarg=ijarg+1
    END DO
  END SUBROUTINE GetTagList

END PROGRAM cdfvT

PROGRAM cdfchgrid
  !!======================================================================
  !!                     ***  PROGRAM  cdfchgrid  ***
  !!======================================================================
  !!  ** Purpose : Transform an 1442x1021 ORCA025 grid variable into an 
  !!               4322x3059 ORCA12 grid variable.
  !!               No interpolation, only copying one grid cell into 9 grid cells.
  !!
  !!  ** Method  : Store the result on a 'cdfchgrid.nc' file similar to the input file
  !!               (except x and y dimension)
  !!
  !!  ** Restriction  : Caution for mask coherence !
  !!                    This tool is only adapted for drowned field
  !!
  !! History : 3.0 !  08/2012    A. Lecointre   : Original code with Full Doctor form + Lic.
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  !!   routines      : description
  !!   chgrid        : Convert coarser grid into refined grid
  !!----------------------------------------------------------------------
  USE cdfio
  USE modutils
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id: cdfchgrid.f90 XXX YYYY-MM-DD MM:MM:SSZ molines $
  !! Copyright (c) 2010, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                               :: jk, jt                 ! dummy loop index
  INTEGER(KIND=4)                               :: ivar,iivar             ! dummy loop index
  INTEGER(KIND=4)                               :: ierr                   ! working integer
  INTEGER(KIND=4)                               :: narg, iargc, ijarg     ! argument on line
  INTEGER(KIND=4)                               :: npiglo, npjglo         ! size of the input domain
  INTEGER(KIND=4)                               :: npigloout              ! I-size of the output domain
  INTEGER(KIND=4)                               :: npjgloout              ! J-size of the output domain
  INTEGER(KIND=4)                               :: npk, npkk, npt          ! size of the domain
  INTEGER(KIND=4)                               :: nvars                  ! number of variables in the input file
  INTEGER(KIND=4)                               :: ncout                  ! ncid of output ncdf file
  INTEGER(KIND=4), DIMENSION(1)                 :: ipk                    ! output variable : number of levels
  INTEGER(KIND=4), DIMENSION(1)                 :: id_varout              ! ncdf varid's

  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: v2d                    ! array to read a layer of data 
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: u2d                    ! array onto ORCA12-grid
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: tim                    ! time counter of the file
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: rdep                   ! depth of the file

  CHARACTER(LEN=256)                            :: cf_out='cdfchgrid.nc'  ! output file name
  CHARACTER(LEN=256)                            :: cf_in                  ! input file name
  CHARACTER(LEN=256)                            :: cf_ref                 ! reference file for output file
  CHARACTER(LEN=256)                            :: cv_in                  ! variable name
  CHARACTER(LEN=256)                            :: cldum                  ! working string
  CHARACTER(LEN=256)                            :: cv_dep                 ! true name of dep dimension
  CHARACTER(LEN=256)                            :: cl_trf                 ! conversion key
  CHARACTER(LEN=256)                            :: cglobal                ! Global attribute with command line
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_names               ! array of var name

  TYPE (variable), DIMENSION(:),    ALLOCATABLE :: stypvar                ! structure for variable attribute
  LOGICAL                                       :: lnc4=.FALSE.           ! flag for nc4 output with chinking and deflation
  LOGICAL                                       :: ldbg=.FALSE.           ! flag for nc4 output with chinking and deflation
  !!--------------------------------------------------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfchgrid -f IN-file -r REF-file -var IN-var [-nc4] [-o OUT-file] [-d]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Build a new file on a refined grid, from a coarser grid, assuming that'
     PRINT *,'       the two grids are embedded, with common points (hence an odd scaling '
     PRINT *,'       factor). Grid characteristics are hard wired in the code. Support for'
     PRINT *,'       ORCA025 --> ORCA12, eORCA025 --> eORCA12 is actually provided. Hooks '
     PRINT *,'       are ready in the code for adding new conversion.'
     PRINT *,'       No interpolation, only copying value of a coarse grid cell, onto '
     PRINT *,'       scale x scale cells of the output grid (scale is the refinement factor)'
     PRINT *,'      '
     PRINT *,'     RESTRICTION :'
     PRINT *,'       Caution for mask coherence !'
     PRINT *,'       This tool is only adapted for drowned field'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -f IN-file  : input Coarser-grid file'
     PRINT *,'       -r REF-file : Reference file used for identification of the output grid'
     PRINT *,'               should be of same geometry than the output file.'
     PRINT *,'       -var IN-var : input coarser-grid variable to be converted'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       -nc4        : use netcdf4 chunking and deflation for the output file'
     PRINT *,'       -o OUT-file : specify output file name instead of ',TRIM(cf_out)
     PRINT *,'       -d          : Display some debugging information '
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       none '
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out)
     PRINT *,'         variable : same name as in input file'
     STOP
  ENDIF
  !!
  ijarg = 1
  ! Read command line
  DO  WHILE (ijarg <=  narg)
     CALL getarg(ijarg,cldum) ; ijarg = ijarg + 1
     SELECT CASE ( cldum )
     CASE ( '-f' )
        CALL getarg(ijarg, cf_in) ; ijarg = ijarg + 1
     CASE ( '-r' )
        CALL getarg(ijarg, cf_ref) ; ijarg = ijarg + 1
     CASE ( '-var' )
        CALL getarg(ijarg,cv_in ) ; ijarg = ijarg + 1
     CASE ( '-o' )
        CALL getarg(ijarg,cf_out) ; ijarg = ijarg + 1
     CASE ( '-nc4' )
        lnc4 = .TRUE.
     CASE ( '-d' )
        ldbg = .TRUE.
     CASE DEFAULT
        PRINT *, TRIM(cldum),' : unknown option '
        STOP 99
     END SELECT
  END DO

  IF ( chkfile(cf_in) .OR. chkfile(cf_ref) ) STOP 99 ! missing files

  ! get domain dimension from input file
  npiglo = getdim (cf_in, cn_x)
  npjglo = getdim (cf_in, cn_y)
  npk    = getdim (cf_in, cn_z, cdtrue=cv_dep, kstatus=ierr)  ! defautl cn_z is depth
  npt    = getdim (cf_in, cn_t)

  IF ( npt == 0 ) THEN
     PRINT *, 'npt is forced to 1'
     npt = 1
  ENDIF

  IF ( npk == 0 ) THEN
    npkk = 1
  ELSE
    npkk = npk
  ENDIF


  ! get output domain dimension from reference file
  npigloout = getdim (cf_ref, cn_x)
  npjgloout = getdim (cf_ref, cn_y)
  ! infer convertion key from input/output sizes 
  cl_trf = 'none'

  ! check input size
  IF ( npiglo ==  722 .AND. npjglo ==  511 ) cl_trf='05to'   ! ORCA05
  IF ( npiglo == 1442 .AND. npjglo == 1021 ) cl_trf='025to'  ! ORCA025
  IF ( npiglo == 1442 .AND. npjglo == 1207 ) cl_trf='e025to' ! eORCA025
  IF ( npiglo == 4322 .AND. npjglo == 3059 ) cl_trf='12to'   ! ORCA12
  IF ( npiglo == 4322 .AND. npjglo == 3606 ) cl_trf='e12to'  ! eORCA12
  ! check output size
  IF ( npigloout ==  722 .AND. npjgloout ==  511 ) cl_trf=TRIM(cl_trf)//'05'
  IF ( npigloout == 1442 .AND. npjgloout == 1021 ) cl_trf=TRIM(cl_trf)//'025'
  IF ( npigloout == 1442 .AND. npjgloout == 1207 ) cl_trf=TRIM(cl_trf)//'e025'
  IF ( npigloout == 4322 .AND. npjgloout == 3059 ) cl_trf=TRIM(cl_trf)//'12'
  IF ( npigloout == 4322 .AND. npjgloout == 3606 ) cl_trf=TRIM(cl_trf)//'e12'


  PRINT *,' INPUT GRID '
  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt
  PRINT *
  PRINT *,' OUTPUT GRID '
  PRINT *, 'npigloout = ', npigloout
  PRINT *, 'npjgloout = ', npjgloout

  ALLOCATE ( v2d(npiglo+1,npjglo+1) )
  ALLOCATE ( u2d(npigloout,npjgloout) )
  ALLOCATE ( tim(npt) )
  ALLOCATE ( rdep(npkk) )

  ! look for the number of variables in the input file
  nvars = getnvar(cf_in)
  ALLOCATE (cv_names(nvars) ,stypvar(nvars))
  cv_names(:)=getvarname(cf_in,nvars,stypvar)

  ! find the number of variable we are interested in
  ivar=0
  DO  WHILE (ivar <   nvars)
     ivar=ivar+1
     IF ( cv_names(ivar) == cv_in ) iivar=ivar
  END DO
  cglobal="File produced with cdfchgrid "
  CALL SetGlobalAtt( cglobal, "A" )
  rdep=getvar1d(cf_in,cv_dep,npkk) 

  ipk(1)=npkk
  stypvar(iivar)%ichunk = (/npigloout,MAX(1,npjgloout/30),1,1 /)

  ncout = create      (cf_out,   cf_in  , npigloout, npjgloout, npk,   ld_nc4=lnc4  )
  ierr  = createvar   (ncout   , stypvar(iivar), 1 , ipk  , id_varout, ld_nc4=lnc4, cdglobal=cglobal  )
  ierr  = putheadervar(ncout,    cf_ref,  npigloout, npjgloout, npk , cdep='deptht', pdep=rdep     )

  ! get time and write time and get deptht and write deptht
  tim=getvar1d(cf_in,cn_t,npt)    ; ierr=putvar1d(ncout,tim,npt,'T')
                                    ierr=putvar1d(ncout,rdep,npk,'D')

  PRINT *,' Working with ', TRIM(cv_in), npk
  DO jt = 1, npt
     DO jk = 1, npkk
        v2d(1:npiglo,1:npjglo) = getvar(cf_in, cv_in,  jk, npiglo, npjglo, ktime=jt)
        ! duplicate last  row and column 
        v2d(npiglo+1, :) = v2d(npiglo,:)
        v2d(:,npjglo+1 ) = v2d(:,npjglo)
        PRINT *,'level ',jk, 'time ',jt
        CALL chgrid(v2d, u2d, cl_trf)
        ierr = putvar ( ncout , id_varout(1), REAL(u2d), jk, npigloout, npjgloout, ktime=jt)
     ENDDO
  ENDDO

  ierr    = closeout(ncout)

CONTAINS

  SUBROUTINE chgrid (pinvar,poutvar,cd_trf)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE chgrid  ***
    !!
    !! ** Purpose :  This routine just copy input coarser grid
    !!              onto a finer inbedded grid.
    !!
    !! ** Method  :  Each case ( defined by the key cd_trf) is treated
    !!              separatly 
    !!----------------------------------------------------------------------

    REAL(KIND=4), DIMENSION(npiglo+1,npjglo+1),   INTENT(in ) :: pinvar
    REAL(KIND=4), DIMENSION(npigloout,npjgloout), INTENT(out) :: poutvar
    CHARACTER(LEN=*),                             INTENT(in ) :: cd_trf

    INTEGER(KIND=4)                                           :: jiin,jjin ! dummy loop index
    INTEGER(KIND=4)                                           :: iiin,ijin ! 
    INTEGER(KIND=4)                                           :: iiout,ijout !
    INTEGER(KIND=4)                                           :: ii_offset, ij_offset, iscal
    INTEGER(KIND=4)                                           :: iicomc,ijcomc,  iicomf,ijcomf

    SELECT CASE (cd_trf)
    CASE ('025to12')
       iscal  = 3
       iicomc = 2
       ijcomc = 499
       iicomf = 2
       ijcomf = 1495
       CALL filltab( pinvar, poutvar, iscal, iicomc, ijcomc, iicomf,ijcomf)
       ! force E-W periodicity
       poutvar(npigloout-1,:)= poutvar(1,:)
       poutvar(npigloout,  :)= poutvar(2,:)

    CASE ('05to025')
       ! to do ...
       PRINT * ,' Conversion ', TRIM(cd_trf), ' not supported yet!'
    CASE ('05to12')
       ! to do ...
       PRINT * ,' Conversion ', TRIM(cd_trf), ' not supported yet!'
    CASE ('e025toe12')
       iscal  = 3
       iicomc = 2
       ijcomc = 685
       iicomf = 2
       ijcomf = 2042
       CALL filltab( pinvar, poutvar, iscal, iicomc, ijcomc, iicomf,ijcomf)
       ! force E-W periodicity
       poutvar(npigloout-1,:)= poutvar(1,:)
       poutvar(npigloout,  :)= poutvar(2,:)
       ! 
    CASE DEFAULT
       PRINT *, TRIM(cd_trf),'  is not recognized !'
       PRINT *, 'No conversion will be performed'
    END SELECT

  END SUBROUTINE chgrid

  SUBROUTINE filltab(  pinvar, poutvar,  kscal, &
       &         kicomc, kjcomc, kicomf, kjcomf )
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE filltab  ***
    !!
    !! ** Purpose :  fill higher resolution poutvar with values from pinvar
    !!               repeating the values over the iscal x iscale square  
    !!
    !!----------------------------------------------------------------------
    REAL(KIND=4), DIMENSION(npiglo+1,npjglo+1)  , INTENT(in )  :: pinvar
    REAL(KIND=4), DIMENSION(npigloout,npjgloout), INTENT(out)  :: poutvar
    INTEGER(KIND=4),                              INTENT(in )  :: kscal
    INTEGER(KIND=4),                           INTENT(inout )  :: kicomc, kjcomc
    INTEGER(KIND=4),                           INTENT(inout )  :: kicomf, kjcomf
    !
    INTEGER(KIND=4)                           :: jic, jjc, jif, jjf, ji,jj
    INTEGER(KIND=4)                           :: iiglof, ijglof, ipi,ipj
    INTEGER(KIND=4)                           :: iiofset, ijofset , iifc, ijfc, iiff, ijff
    INTEGER(KIND=4)                           :: ii,ij, ii0,ij0,  ii1,ij1

    REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zwvar  ! working array to be cropped out after

    !------------------------------------------------------------------------
    iiglof=(npiglo+1) * kscal
    ijglof=(npjglo+1) * kscal
    ALLOCATE(zwvar(iiglof,ijglof))
    IF (ldbg) THEN
       PRINT *,' Size of working array: ', iiglof,ijglof
       PRINT *,'   last NE corner point ', kscal*(npiglo+1) -kscal/2 ,  kscal*(npjglo+1) -kscal/2
    ENDIF

    ! fill working fine array with all possible values from coarse array
    DO jjc = 1, npjglo+1
       ijfc=kscal * jjc - kscal/2  ! take care : integer division of an odd number
       DO jic = 1, npiglo+1
          iifc=kscal * jic - kscal/2  ! take care : integer division of an odd number
          DO jjf = ijfc - kscal/2, ijfc + kscal/2
             DO jif = iifc - kscal/2, iifc + kscal/2
                zwvar(jif,jjf) = pinvar(jic,jjc)
             ENDDO
          ENDDO
       ENDDO
    ENDDO

    ! crop working array to fit final fine array
    ! use common point information 
    ! Compute off set of grid from the inverce of formula : Pf = kscal * Pc + offset 
    iiofset = kicomf - kscal*kicomc
    ijofset = kjcomf - kscal*kjcomc
    ! find the most SW common point for the 2 grids ( brute force!)
    DO ji=1, npiglo+1
       ii= ji * kscal + iiofset
       IF ( ii >= 1) THEN
          kicomc=ji ; kicomf=ii
          EXIT
       ENDIF
    ENDDO

    DO jj=1, npjglo+1
       ij= jj * kscal + ijofset
       IF ( ij >= 1) THEN
          kjcomc=jj ; kjcomf=ij
          EXIT
       ENDIF
    ENDDO
    IF ( ldbg ) THEN
      PRINT *,'   Matching points : '
      PRINT *,'      coarse : ', kicomc, kjcomc
      PRINT *,'      fine   : ', kicomf, kjcomf
   ENDIF
    ! now do crop zwvar to fit poutvar  iiff,ijff are the index of SW most common point in zwvar
    iiff = kscal * kicomc - kscal/2 
    ijff = kscal * kjcomc - kscal/2 

!   ii0=iiff-kicomf +1 ; ii1=MIN(npigloout , ii0+npigloout-1) ; ipi=ii1-ii0+1
!   ij0=ijff-kjcomf +1 ; ij1=MIN(npjgloout , ij0+npjgloout-1) ; ipj=ij1-ij0+1
    ii0=iiff-kicomf +1 ; ii1=MIN(iiglof , ii0+npigloout-1) ; ipi=ii1-ii0+1
    ij0=ijff-kjcomf +1 ; ij1=MIN(ijglof , ij0+npjgloout-1) ; ipj=ij1-ij0+1
    IF ( ldbg) THEN
      PRINT *,'  Index limit to crop the array'
      PRINT *,'     ', ii0,ii1,ij0,ij1
      PRINT *,'   crop size : ', ipi,ipj
    ENDIF

    poutvar(:,:) = 999.
    poutvar(1:ipi,1:ipj) = zwvar(ii0:ii1,ij0:ij1)

    DEALLOCATE (zwvar )

  END SUBROUTINE filltab

END PROGRAM cdfchgrid

PROGRAM cdfwflx
  !!======================================================================
  !!                     ***  PROGRAM  cdfwflx  ***
  !!=====================================================================
  !!  ** Purpose : Produce a file with the water flux separated into 
  !!               4 components: E (soevap), P (soprecip), R (sorunoff),
  !!               dmp (sowafldp).
  !!               The total water flux is E -P -R + dmp. Units in this 
  !!               program are mm/days.
  !!
  !!  ** Method  : Evap is computed from the latent heat flux : evap=-qla/Lv
  !!               Runoff is read from the climatological input file
  !!               dmp is read from the file (sowafldp)
  !!               Precip is then computed as the difference between the
  !!               total water flux (sowaflup) and the E-R+dmp. In the high 
  !!               latitudes this precip includes the effect of snow 
  !!               (storage/melting). Therefore it may differ slightly from
  !!               the input precip file.
  !!
  !! History : 2.1  : 01/2008  : J.M. Molines : Original code
  !!           3.0  : 04/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4), PARAMETER                 :: jpvarout = 5     ! number of output variables
  INTEGER(KIND=4)                            :: jj, jk, ji       ! dummy loop index
  INTEGER(KIND=4)                            :: npiglo, npjglo   ! size of the domain
  INTEGER(KIND=4)                            :: narg, iargc      ! command line 
  INTEGER(KIND=4)                            :: ncout, ierr      ! netcdf i/o
  INTEGER(KIND=4), DIMENSION(jpvarout)       :: ipk, id_varout   ! levels and varid of output vars

  REAL(KIND=4), DIMENSION (:,:), ALLOCATABLE :: zmask, zwk       !  work array
  REAL(KIND=4), DIMENSION (:,:), ALLOCATABLE :: evap, precip     ! water flux components
  REAL(KIND=4), DIMENSION (:,:), ALLOCATABLE :: runoff, wdmp     ! water flux components
  REAL(KIND=4), DIMENSION(1)                 :: tim, dep         ! time_counter and dummy depth
  REAL(KIND=4)                               :: Lv=2.5e6         ! latent HF <--> evap conversion

  CHARACTER(LEN=256)                         :: cf_tfil          ! input gridT file name
  CHARACTER(LEN=256)                         :: cf_rnf           ! input runoff file name
  CHARACTER(LEN=256)                         :: cf_out='wflx.nc' ! output file

  TYPE(variable), DIMENSION(jpvarout)        :: stypvar          ! structure for attributes
  
  LOGICAL                                    :: lchk             ! flag for missing files
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfwflx T-file Runoff'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Computes the water fluxes components. Suitable for '
     PRINT *,'       annual means files. All output variables are in mm/days.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       T-file  : model output file with water fluxes (gridT) '
     PRINT *,'       Runoff : file with the climatological runoff on the'
     PRINT *,'                model grid.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        none'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'       variables : soevap, soprecip, sorunoff, sowadmp, sowaflux'
     STOP
  ENDIF

  CALL getarg (1, cf_tfil)
  CALL getarg (2, cf_rnf )

  lchk = lchk .OR. chkfile ( cf_tfil)
  lchk = lchk .OR. chkfile ( cf_rnf )
  IF ( lchk ) STOP ! missing file

  npiglo= getdim (cf_tfil, cn_x)
  npjglo= getdim (cf_tfil, cn_y)

  ! prepare output variables
  dep(1) = 0.
  ipk(:) = 1  ! all variables ( output are 2D)

  stypvar%rmissing_value    = 0.
  stypvar%valid_min         = -100.
  stypvar%valid_max         =  100.
  stypvar%cunits            = 'mm/day'
  stypvar%conline_operation = 'N/A'
  stypvar%caxis             = 'TYX'

  stypvar(1)%cname = 'soevap'   ; stypvar(1)%clong_name = 'Evaporation'      ; stypvar(1)%cshort_name = 'soevap'
  stypvar(2)%cname = 'soprecip' ; stypvar(2)%clong_name = 'Precipitation'    ; stypvar(2)%cshort_name = 'soprecip'
  stypvar(3)%cname = 'sorunoff' ; stypvar(3)%clong_name = 'Runoff'           ; stypvar(3)%cshort_name = 'sorunoff'
  stypvar(4)%cname = 'sowadmp'  ; stypvar(4)%clong_name = 'SSS damping'      ; stypvar(4)%cshort_name = 'sowadmp'
  stypvar(5)%cname = 'sowaflux' ; stypvar(5)%clong_name = 'Total water flux' ; stypvar(5)%cshort_name = 'sowaflux'

  PRINT *, 'npiglo=', npiglo
  PRINT *, 'npjglo=', npjglo

  ALLOCATE ( zmask(npiglo,npjglo), zwk(npiglo,npjglo))
  ALLOCATE ( evap(npiglo,npjglo), precip(npiglo,npjglo), runoff(npiglo,npjglo), wdmp(npiglo,npjglo) )

 ! read vosaline for masking purpose
     zwk(:,:) =  getvar(cf_tfil, cn_vosaline,  1 ,npiglo,npjglo)
     zmask    = 1. ; WHERE ( zwk == 0 ) zmask = 0.
 ! Evap : 
     evap(:,:) = -1.* getvar(cf_tfil, cn_solhflup, 1 ,npiglo, npjglo)/Lv*86400. *zmask(:,:)  ! mm/days
      print *,'Evap done'
 ! Wdmp
     wdmp(:,:)   = getvar(cf_tfil, cn_sowafldp, 1 ,npiglo, npjglo) * 86400. * zmask(:,:)     ! mm/days
      print *,'Damping done'
 ! Runoff
     runoff(:,:) = getvar(cf_rnf,  'sorunoff',  1 ,npiglo, npjglo) * 86400. * zmask(:,:)     ! mm/days
      print *,'Runoff done'
 ! total water flux
     zwk(:,:)    = getvar(cf_tfil, cn_sowaflup, 1 ,npiglo, npjglo) * 86400. *zmask(:,:)      ! mm/days
      print *,'Total water flux done'
 ! Precip:
     precip(:,:)= evap(:,:) - runoff(:,:) + wdmp(:,:) - zwk(:,:)                            ! mm/day
      print *,'Precip done'

 ! Write output file
 ncout = create      (cf_out, cf_tfil, npiglo,   npjglo, 1          )
 ierr  = createvar   (ncout,  stypvar, jpvarout, ipk,    id_varout  )
 ierr  = putheadervar(ncout,  cf_tfil, npiglo,   npjglo, 1, pdep=dep)

 ierr = putvar(ncout, id_varout(1), evap,   1, npiglo, npjglo)
 ierr = putvar(ncout, id_varout(2), precip, 1, npiglo, npjglo)
 ierr = putvar(ncout, id_varout(3), runoff, 1, npiglo, npjglo)
 ierr = putvar(ncout, id_varout(4), wdmp,   1, npiglo, npjglo)
 ierr = putvar(ncout, id_varout(5), zwk,    1, npiglo, npjglo)

 tim   = getvar1d(cf_tfil, cn_vtimec, 1     )
 ierr  = putvar1d(ncout,   tim,       1, 'T')

 ierr=closeout(ncout)

END PROGRAM cdfwflx

PROGRAM cdfbottomsig
  !!======================================================================
  !!                     ***  PROGRAM  cdfbottomsig  ***
  !!=====================================================================
  !!  ** Purpose : Compute the bottom sigma from gridT file.
  !!               Store the results on a 'similar' cdf file.
  !!
  !!  **  Method:  Uses vosaline do determine the bottom points. A depth
  !!               reference can be specify to compute density refered to
  !!               this depth.
  !!
  !! History : 2.1  : 11/2005  : J.M. Molines : Original code
  !!           3.0  : 12/2010  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE eos
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class bottom
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                            :: jk, jt         ! dummy loop index
  INTEGER(KIND=4)                            :: ierr           ! working integer
  INTEGER(KIND=4)                            :: narg, iargc    ! 
  INTEGER(KIND=4)                            :: ijarg          ! argument counter
  INTEGER(KIND=4)                            :: npiglo, npjglo ! size of the domain
  INTEGER(KIND=4)                            :: npk, npt       ! size of the domain
  INTEGER(KIND=4)                            :: ncout          ! ncid of output file
  INTEGER(KIND=4), DIMENSION(1)              :: ipk            ! outptut variables : number of levels,
  INTEGER(KIND=4), DIMENSION(1)              :: id_varout      ! ncdf varid's
  INTEGER(KIND=4), DIMENSION(2)              :: ismin, ismax   ! location of min and max sigmabot

  REAL(KIND=4)                               :: zsigmn, zsigmx ! value of min and max of sigmabot
  REAL(KIND=4)                               :: zref           ! value of min and max of sigmabot
  REAL(KIND=4)                               :: zsps           ! Missing value for salinity
  REAL(KIND=4), DIMENSION(:,:),  ALLOCATABLE :: ztemp, zsal    ! Array to read a layer of data
  REAL(KIND=4), DIMENSION(:,:),  ALLOCATABLE :: ztemp0, zsal0  ! temporary array to read temp, sal
  REAL(KIND=4), DIMENSION(:,:),  ALLOCATABLE :: zsig           ! potential density 
  REAL(KIND=4), DIMENSION(:,:),  ALLOCATABLE :: zmask          ! 2D mask at surface

  REAL(KIND=8), DIMENSION(:),    ALLOCATABLE :: dtim           ! time counter

  CHARACTER(LEN=256)                         :: cf_out='botsig.nc' ! Output file name
  CHARACTER(LEN=256)                         :: cf_tfil        ! input filename
  CHARACTER(LEN=256)                         :: cf_sfil        ! input filename
  CHARACTER(LEN=256)                         :: cv_sig         ! output variable name
  CHARACTER(LEN=256)                         :: cref           ! message for depth reference
  CHARACTER(LEN=256)                         :: cldum          ! dummy char variable

  TYPE (variable), DIMENSION(1)              :: stypvar        ! structure for attributes

  LOGICAL                                    :: lsigi  =.FALSE.! flag for sigma-i computation
  LOGICAL                                    :: lsigntr=.FALSE.! flag for sigma-Neutral computation
  LOGICAL                                    :: lnc4   =.FALSE.! Use nc4 with chunking and deflation
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  !!  Read command line
  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfbottomsig  -t T-file [-s S-file] [-r REF-depth ] [-ntr] ...'
     PRINT *,'               ... [-o OUT-file] [-nc4]' 
     PRINT *,'      '
     PRINT *,'     PURPOSE :' 
     PRINT *,'       Create a 2D file with bottom density. In case a depth reference is ' 
     PRINT *,'       given, the density is referred to this depth. By default sigma-0 is'
     PRINT *,'       used. Bottom most point is determined from the last non zero salinity'
     PRINT *,'       point in the water column.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -t T-file : input file with temperature and salinity.'
     PRINT *,'               If salinity is not in T-file use -s option.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-s S-file ] : specify salinity file if not T-file.' 
     PRINT *,'       [-r REF-depth] : depth reference for potential density.'
     PRINT *,'             Without -r nor -ntr options sigma-0 is assumed.'
     PRINT *,'       [-ntr ]: Will use neutral density.'
     PRINT *,'             Without -r nor -ntr options sigma-0 is assumed.'
     PRINT *,'       [-o OUT-file] : Specify output file name instead of ',TRIM(cf_out)
     PRINT *,'       [-nc4]:  Use netcdf4 output with chunking and deflation level 1.'
     PRINT *,'             This option is effective only if cdftools are compiled with'
     PRINT *,'             a netcdf library supporting chunking and deflation.'
     PRINT *,'      '
     PRINT *,'     OPENMP SUPPORT : yes'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       none'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out),' unless -o option is used.'
     PRINT *,'         variables : sobotsig0 or sobotsigi ( kg/m3 - 1000 )' 
     PRINT *,'                     or sobotsigntr (kg/m3)'
     PRINT *,'      '
     STOP 
  ENDIF

  cv_sig = 'sobotsig0'
  cf_sfil='none'
  cref=''
  ijarg=1
  DO WHILE ( ijarg <= narg )
     CALL getarg (ijarg, cldum ) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-t'  ) ; CALL getarg(ijarg, cf_tfil) ;  ijarg=ijarg+1
        ! options
     CASE ( '-s'  ) ; CALL getarg(ijarg, cf_sfil) ;  ijarg=ijarg+1
     CASE ( '-r'  ) ; CALL getarg (ijarg, cldum ) ; ijarg=ijarg+1 ; READ(cldum,*) zref
        ;             lsigi  = .TRUE. 
        ;             cv_sig = 'sobotsigi'
        ;             WRITE(cref,'("_refered_to_",i4.4,"_m")') NINT(zref)
     CASE ( '-ntr') ; lsigntr = .TRUE.
        ;             cv_sig  = 'sobotsigntr'
        ;             WRITE(cref,'("_Neutral")')
     CASE ( '-o'  ) ; CALL getarg(ijarg, cf_out ) ;  ijarg=ijarg+1
     CASE ( '-nc4') ; lnc4     = .TRUE.
     CASE DEFAULT   ; PRINT *,' ERROR : ',TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  END DO
  IF ( cf_sfil == 'none' ) cf_sfil = cf_tfil

  IF ( chkfile(cf_tfil) .OR.  chkfile(cf_sfil) ) STOP 99 ! missing file
  ! look for MissingValue for salinity
  zsps = getspval(cf_sfil, cn_vosaline)


  npiglo = getdim (cf_tfil,cn_x)
  npjglo = getdim (cf_tfil,cn_y)
  npk    = getdim (cf_tfil,cn_z)
  npt    = getdim (cf_tfil,cn_t)

  PRINT *, 'npiglo =', npiglo
  PRINT *, 'npjglo =', npjglo
  PRINT *, 'npk    =', npk
  PRINT *, 'npt    =', npt

  ALLOCATE (ztemp( npiglo,npjglo), zsal( npiglo,npjglo), zsig(npiglo,npjglo) ,zmask(npiglo,npjglo))
  ALLOCATE (ztemp0(npiglo,npjglo), zsal0(npiglo,npjglo) )
  ALLOCATE ( dtim (npt) )

  CALL CreateOutput

  zsal  = 0.
  ztemp = 0.
  zmask = 1.

  DO jt = 1, npt
     DO jk = 1, npk
        PRINT *,'level ',jk
        zsal0(:,:) = getvar(cf_sfil, cn_vosaline, jk, npiglo, npjglo, ktime=jt)
        ztemp0(:,:)= getvar(cf_tfil, cn_votemper, jk, npiglo, npjglo, ktime=jt)
        IF (jk == 1  )  THEN
           WHERE( zsal0 == zsps ) zmask=0.
        END IF
        WHERE ( zsal0 /= zsps )
           zsal=zsal0 ; ztemp=ztemp0
        END WHERE
     ENDDO

     IF (lsigi ) THEN
        zsig(:,:) = sigmai ( ztemp, zsal, zref, npiglo, npjglo ) * zmask(:,:)
     ELSE IF (lsigntr ) THEN
        zsig(:,:) = sigmantr (ztemp, zsal,      npiglo, npjglo )* zmask(:,:)
     ELSE
        zsig(:,:) = sigma0 ( ztemp, zsal,       npiglo, npjglo ) * zmask(:,:)
     ENDIF

     zsigmn=MINVAL(zsig(2:npiglo-1,2:npjglo-1), zmask(2:npiglo-1,2:npjglo-1)==1)
     zsigmx=MAXVAL(zsig(2:npiglo-1,2:npjglo-1), zmask(2:npiglo-1,2:npjglo-1)==1)
     ismin= MINLOC(zsig(2:npiglo-1,2:npjglo-1), zmask(2:npiglo-1,2:npjglo-1)==1)
     ismax= MAXLOC(zsig(2:npiglo-1,2:npjglo-1), zmask(2:npiglo-1,2:npjglo-1)==1)

     PRINT *,'Bottom density : min = ', zsigmn,' at ', ismin(1), ismin(2)
     PRINT *,'               : max = ', zsigmx,' at ', ismax(1), ismax(2)

     ierr = putvar(ncout, id_varout(1), zsig, 1, npiglo, npjglo, ktime=jt)
  ENDDO

  ierr = closeout(ncout)

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    ipk(:)= 1  ! all variables (input and output are 3D)

    stypvar(1)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(1)%cname             = cv_sig
    stypvar(1)%cunits            = 'kg/m3'
    stypvar(1)%rmissing_value    = 0.
    stypvar(1)%valid_min         = 0.001
    stypvar(1)%valid_max         = 40.
    stypvar(1)%clong_name        = 'Bottom_Potential_density'//TRIM(cref)
    stypvar(1)%cshort_name       = cv_sig
    stypvar(1)%conline_operation = 'N/A'
    stypvar(1)%caxis             = 'TYX'

    ! create output fileset
    ncout = create      (cf_out, cf_tfil, npiglo, npjglo, npk      , ld_nc4=lnc4 )
    ierr  = createvar   (ncout,  stypvar, 1     , ipk   , id_varout, ld_nc4=lnc4 )
    ierr  = putheadervar(ncout,  cf_tfil, npiglo, npjglo, npk       )

    dtim = getvar1d(cf_tfil, cn_vtimec, npt     )
    ierr = putvar1d(ncout,   dtim     , npt, 'T')

  END SUBROUTINE CreateOutput

END PROGRAM cdfbottomsig

PROGRAM cdflinreg
  !!======================================================================
  !!                     ***  PROGRAM  cdflinreg  ***
  !!=====================================================================
  !!  ** Purpose : Compute linear regression coef from a bunch of input 
  !!               cdf files given as argument.
  !!               Store the results on a 'similar' cdf file.
  !!
  !!  ** Method  : compute a and b such as yr = a . t + b
  !!              yr is the estimation of the field value, t is the time (in days ).
  !!              a= cov(y,t) / var(t)
  !!              b= moy(y) - a . moy(t)
  !!              R2 pearson value [0,1], giving the quality of the adjustment is also given
  !!              R2= a*a*var(t)/var(y)
  !!              cov(y,t)= moy(y*t) - moy(y)*moy(t)
  !!              var(t)  = moy(t*t) - moy(t)*moy(t)
  !!              var(y)  = moy(y*y) - moy(y)*moy(y)
  !!
  !! History : 2.1  : 01/2008  : J.M. Molines : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!--------------------------------------------------------------
  USE cdfio 
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4), PARAMETER                    :: jptmax=1000               ! maximum number of time frame
  INTEGER(KIND=4)                               :: jk, jfil, jvar, jv, jt    ! dummy loop index
  INTEGER(KIND=4)                               :: ierr, ijvar               ! working integer
  INTEGER(KIND=4)                               :: narg, iargc               ! 
  INTEGER(KIND=4)                               :: npiglo, npjglo, npk, npt  ! size of the domain
  INTEGER(KIND=4)                               :: nvars                     ! Number of variables in a file
  INTEGER(KIND=4)                               :: ntframe                   ! Cumul of time frame
  INTEGER(KIND=4)                               :: ncout                     ! ncid of output file
  INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE    :: ipki                      ! arrays of vertical level for each var
  INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE    :: ipko                      ! arrays of vertical level for each var
  INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE    :: id_varout                 ! id of output variable

  REAL(KIND=4)                                  :: zspval = -99999.          ! special value/ missing value
  REAL(KIND=4), DIMENSION(2)                    :: timean                    ! trick : timean(1) hold moy(t) (days)
  !                                                                          !         timean(2) hold moy(t2) (days)**2
  REAL(KIND=4), DIMENSION(:), ALLOCATABLE       :: tim                       ! time counter

  REAL(KIND=8)                                  :: dt, dt2                   ! variables for cumulated time values
  REAL(KIND=8)                                  :: dtotal_time               ! cumulated time
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE     :: dy, dyy, dyt              ! Arrays for cumulated values
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE     :: dv2d                      ! Array to read a layer of data
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE     :: dmean, dmean2, dmean3     ! 
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE     :: dareg, dbreg, dpear       ! slope, origin ordinate, pearson coef

  CHARACTER(LEN=256)                            :: cf_in                     ! file names
  CHARACTER(LEN=256)                            :: cf_out='linreg.nc'        ! file names
  CHARACTER(LEN=256)                            :: cv_dep                    ! depth variable name
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_namesi                 ! array of var name
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_nameso                 ! array of var22 name for output

  TYPE (variable), DIMENSION(:), ALLOCATABLE    :: stypvari, stypvaro        ! data structure

  LOGICAL                                       :: lcaltmean                 ! flag for timemean computation
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdflinreg ''list of model files'' '
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'        Compute the linear regression coefficients for a bunch of'
     PRINT *,'        input files. '
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       A list of netcdf model file of same kind' 
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       none' 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : for each input variables, there are 3 computed field'
     PRINT *,'                - slope coefficient'
     PRINT *,'                - barycenter '
     PRINT *,'                - Pearson Coefficient'
     STOP
  ENDIF

  !! Initialisation from 1st file (all file are assume to have the same geometry)
  CALL getarg (1, cf_in )
  IF ( chkfile(cf_in) ) STOP 99 ! missing file

  npiglo = getdim (cf_in,cn_x                             )
  npjglo = getdim (cf_in,cn_y                             )
  npk    = getdim (cf_in,cn_z, cdtrue=cv_dep, kstatus=ierr)

  IF (ierr /= 0 ) THEN
     npk   = getdim (cf_in,'z',cdtrue=cv_dep,kstatus=ierr)
     IF (ierr /= 0 ) THEN
        npk   = getdim (cf_in,'sigma',cdtrue=cv_dep,kstatus=ierr)
        IF ( ierr /= 0 ) THEN 
           PRINT *,' assume file with no depth'
           npk=0
        ENDIF
     ENDIF
  ENDIF


  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk

  ALLOCATE( dy   (npiglo,npjglo), dyt   (npiglo,npjglo), dyy   (npiglo,npjglo), dv2d(npiglo,npjglo) )
  ALLOCATE( dmean(npiglo,npjglo), dmean2(npiglo,npjglo), dmean3(npiglo,npjglo)                      )
  ALLOCATE( dareg(npiglo,npjglo), dbreg (npiglo,npjglo) ,dpear (npiglo,npjglo)                      )
  ALLOCATE( tim  (jptmax) )

  nvars = getnvar(cf_in)
  PRINT *,' nvars =', nvars

  ALLOCATE (cv_namesi(nvars), cv_nameso(3*nvars) )
  ALLOCATE (stypvari (nvars), stypvaro (3*nvars) )
  ALLOCATE (ipki     (nvars), ipko     (3*nvars) )
  ALLOCATE (                  id_varout(3*nvars) )

  ! get list of variable names and collect attributes in stypvari (optional)
  cv_namesi(:) = getvarname(cf_in, nvars, stypvari)

  DO jvar = 1, nvars
     ijvar=(jvar -1)*3 +1
     ! AREG
     cv_nameso(ijvar)                    = TRIM(cv_namesi(jvar))//'_areg'
     stypvaro(ijvar)%cname               = TRIM(stypvari(jvar)%cname)//'_areg'   ! name
     stypvaro(ijvar)%cunits              = TRIM(stypvari(jvar)%cunits)//'/year'  ! unit
     stypvaro(ijvar)%rmissing_value      = zspval                                ! missing_value
     stypvaro(ijvar)%valid_min           = -100.                                 ! valid_min = zero
     stypvaro(ijvar)%valid_max           =  100.                                 ! valid_max *valid_max
     stypvaro(ijvar)%scale_factor        = 1.
     stypvaro(ijvar)%add_offset          = 0.
     stypvaro(ijvar)%savelog10           = 0.
     stypvaro(ijvar)%clong_name          = TRIM(stypvari(jvar)%clong_name)//'_linear_slope'
     stypvaro(ijvar)%cshort_name         = TRIM(stypvari(jvar)%cshort_name)//'_areg'     
     stypvaro(ijvar)%conline_operation   = TRIM(stypvari(jvar)%conline_operation) 
     stypvaro(ijvar)%caxis               = TRIM(stypvari(jvar)%caxis) 
     ! BREG
     cv_nameso(ijvar+1)                  = TRIM(cv_namesi(jvar))//'_breg'
     stypvaro(ijvar+1)%cname             = TRIM(stypvari(jvar)%cname)//'_breg'   ! name
     stypvaro(ijvar+1)%cunits            = TRIM(stypvari(jvar)%cunits)           ! unit
     stypvaro(ijvar+1)%rmissing_value    = zspval                                ! missing_value
     stypvaro(ijvar+1)%valid_min         = -100.                                 ! valid_min = zero
     stypvaro(ijvar+1)%valid_max         =  100.                                 ! valid_max *valid_max
     stypvaro(ijvar+1)%scale_factor      = 1.
     stypvaro(ijvar+1)%add_offset        = 0.
     stypvaro(ijvar+1)%savelog10         = 0.
     stypvaro(ijvar+1)%clong_name        = TRIM(stypvari(jvar)%clong_name)//'_b' 
     stypvaro(ijvar+1)%cshort_name       = TRIM(stypvari(jvar)%cshort_name)//'_breg' 
     stypvaro(ijvar+1)%conline_operation = TRIM(stypvari(jvar)%conline_operation)
     stypvaro(ijvar+1)%caxis             = TRIM(stypvari(jvar)%caxis)
     ! R2 pearson
     cv_nameso(ijvar+2)                  = TRIM(cv_namesi(jvar))//'_r2'
     stypvaro(ijvar+2)%cname             = TRIM(stypvari(jvar)%cname)//'_r2'    ! name
     stypvaro(ijvar+2)%cunits            = 'no unit'                            ! unit
     stypvaro(ijvar+2)%rmissing_value    = zspval                               ! missing_value
     stypvaro(ijvar+2)%valid_min         = 0.                                   ! valid_min = zero
     stypvaro(ijvar+2)%valid_max         = 1.                                   ! valid_max *valid_max
     stypvaro(ijvar+2)%scale_factor      = 1.
     stypvaro(ijvar+2)%add_offset        = 0.
     stypvaro(ijvar+2)%savelog10         = 0.
     stypvaro(ijvar+2)%clong_name        = TRIM(stypvari(jvar)%clong_name)//'_r2_Pearson'
     stypvaro(ijvar+2)%cshort_name       = TRIM(stypvari(jvar)%cshort_name)//'_r2'
     stypvaro(ijvar+2)%conline_operation = TRIM(stypvari(jvar)%conline_operation)
     stypvaro(ijvar+2)%caxis             = TRIM(stypvari(jvar)%caxis)
  END DO

  ! ipki gives the number of level or 0 if not a T[Z]YX  variable
  ipki(:) = getipk (cf_in, nvars, cdep=cv_dep)

  DO jvar=1,nvars
     ipko( (jvar-1)*3 +1 ) = ipki(jvar)
     ipko( (jvar-1)*3 +2 ) = ipki(jvar)
     ipko( (jvar-1)*3 +3 ) = ipki(jvar)
  ENDDO

  WHERE( ipki == 0 ) cv_namesi = 'none'
  WHERE( ipko == 0 ) cv_nameso = 'none'
  stypvari(:)%cname = cv_namesi
  stypvaro(:)%cname = cv_nameso

  ! create output fileset
  cf_out='linreg.nc'
  ! create output file taking the sizes in cf_in

  ncout  = create      (cf_out, cf_in,    npiglo,  npjglo, npk, cdep=cv_dep )
  ierr   = createvar   (ncout,  stypvaro, 3*nvars, ipko,   id_varout        )
  ierr   = putheadervar(ncout,  cf_in,    npiglo,  npjglo, npk, cdep=cv_dep )

  lcaltmean=.TRUE. ; dt=0.d0 ; dt2=0.d0
  DO jvar = 1,nvars
     ijvar=(jvar-1)*3 + 1
     IF (cv_namesi(jvar) == cn_vlon2d .OR. &
         cv_namesi(jvar) == cn_vlat2d ) THEN
        ! skip these variable
     ELSE
        PRINT *,' Working with ', TRIM(cv_namesi(jvar)), ipki(jvar), jvar
        DO jk = 1, ipki(jvar)
           dy(:,:) = 0.d0 ; dyt(:,:) = 0.d0 ; dyy(:,:) =0.d0 ; dtotal_time = 0.;  ntframe=0
           DO jfil = 1, narg
              CALL getarg (jfil, cf_in)
              IF ( jvar == 1 ) THEN
                  IF ( chkfile(cf_in) ) STOP 99 ! missing file
              ENDIF
              npt = getdim (cf_in,cn_t)
              ntframe=ntframe+npt
              IF ( lcaltmean )  THEN
                 ! read time and convert seconds to years
                 tim(ntframe-npt+1:ntframe)=getvar1d(cf_in,cn_vtimec,npt)/86400.d0/365.
              END IF

              DO jt=1,npt
                 ! If forcing fields is without depth dimension
                 dv2d(:,:) = getvar(cf_in, cv_namesi(jvar), jk ,npiglo, npjglo, ktime=jt )
                 dy(:,:)   = dy(:,:)  + dv2d(:,:)
                 dyy(:,:)  = dyy(:,:) + dv2d(:,:)*dv2d(:,:)
                 dyt(:,:)  = dyt(:,:) + dv2d(:,:)*tim(ntframe-npt+jt)
              ENDDO
           END DO
           ! finish with level jk ; compute mean (assume zspval is 0 )
           dt          = SUM(tim(1:ntframe)                )
           dt2         = SUM(tim(1:ntframe)*tim(1:ntframe) )
           dmean(:,:)  = dy (:,:) / ntframe
           dmean2(:,:) = dyt(:,:) / ntframe
           dmean3(:,:) = dyy(:,:) / ntframe

           IF (lcaltmean )  THEN
              timean(1)= dt/ntframe
              timean(2)= dt2/ntframe
              ierr=putvar1d(ncout,timean,1,'T')
           END IF

           !compute dareg, dbreg, dpear
           WHERE (dmean /= 0 ) 
              dareg(:,:) = ( dmean2(:,:) - dmean(:,:) *timean(1) ) / ( timean(2) -timean(1)*timean(1) )
              dbreg(:,:) = dmean(:,:) - dareg(:,:)*timean(1) 
              dpear(:,:) = dareg(:,:)*dareg(:,:)*( timean(2) -timean(1)*timean(1))/( dmean3(:,:) -dmean(:,:)*dmean(:,:) )
              WHERE (dpear < 0 ) dpear=0 ; WHERE (dpear > 1 ) dpear=1
           ELSEWHERE
              dareg=zspval ; dbreg=zspval ; dpear=zspval
           ENDWHERE

           ierr = putvar(ncout, id_varout(ijvar  ), REAL(dareg), jk, npiglo, npjglo)
           ierr = putvar(ncout, id_varout(ijvar+1), REAL(dbreg), jk, npiglo, npjglo)
           ierr = putvar(ncout, id_varout(ijvar+2), REAL(dpear), jk, npiglo, npjglo)
           lcaltmean = .FALSE. ! tmean already computed
        END DO  ! loop to next level
     END IF
  END DO ! loop to next var in file

  ierr = closeout(ncout)

END PROGRAM cdflinreg

PROGRAM cdfdynh_anom
  !!======================================================================
  !!                     ***  PROGRAM  cdfdynh_anom  ***
  !!=====================================================================
  !!  ** Purpose : Compute dynamical height anomaly field from gridT file
  !!               at each levels.
  !!               Store the results on a 3D cdf file.
  !!
  !!  ** Method  : the integral of (1/g) *10e4 * sum [ delta * dz ]
  !!               with delta = (1/rho - 1/rho0)
  !!               10e4 factor is conversion decibar/pascal
  !!
  !! History : 2.1  : 05/2010  : R. Dussin    : Original code
  !!           3.0  : 12/2010  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE eos, ONLY : sigmai
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class derived_fields
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: jk, jt           ! dummy loop index
  INTEGER(KIND=4)                           :: it               ! time index for vvl
  INTEGER(KIND=4)                           :: ierr             ! working integer
  INTEGER(KIND=4)                           :: narg, iargc      ! browse arguments
  INTEGER(KIND=4)                           :: ijarg            ! argument counter
  INTEGER(KIND=4)                           :: npiglo, npjglo   ! size of the domain
  INTEGER(KIND=4)                           :: npk, npt         !  "           "
  INTEGER(KIND=4)                           :: nlev1, nlev2     ! limit of vertical integration
  INTEGER(KIND=4)                           :: ncout            ! ncid of output fileset
  INTEGER(KIND=4), DIMENSION(1)             :: ipk              ! outptut variables : number of levels,
  INTEGER(KIND=4), DIMENSION(1)             :: id_varout        ! ncdf varid's

  REAL(KIND=4)                              :: zsps             ! Missing value for salinity
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: e3t_1d           ! time counter, vertical level spacing
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: temp, zsal       ! Temperature and salinity at current level
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: temp0, zsal0     ! reference temperature and salinity
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: tmask            ! 2D mask at current level
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: rdep, rdepth     ! depth at current level including SSH
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zssh             ! Sea Surface Heigh

  REAL(KIND=8)                              :: drau0 = 1000.d0  ! density of fresh water
  REAL(KIND=8)                              :: dgrav = 9.81d0   ! gravity
  REAL(KIND=8), DIMENSION(:),   ALLOCATABLE :: dtim             ! time counter
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dhdy, dterm      ! dynamic height, working array
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dsig0, dsig      ! In situ density (reference, local)

  CHARACTER(LEN=256)                        :: cf_tfil           ! input file name
  CHARACTER(LEN=256)                        :: cf_sfil           ! input salinity file (option)
  CHARACTER(LEN=255)                        :: cf_sshfil         ! input SSH file (option)
  CHARACTER(LEN=256)                        :: cf_out='cdfhdy3d.nc' ! output file name
  CHARACTER(LEN=256)                        :: cv_out='vohdy'   ! output file name
  CHARACTER(LEN=256)                        :: cf_out2d='cdfhdy2d.nc' ! output file name
  CHARACTER(LEN=256)                        :: cv_out2d='sohdy'   ! output file name
  CHARACTER(LEN=256)                        :: cldum            ! working char variable

  TYPE(variable) , DIMENSION(1)             :: stypvar          ! structure for attributes

  LOGICAL                                   :: lout  = .FALSE.   ! flag to use non standard output name
  LOGICAL                                   :: lnc4  = .FALSE.   ! Use nc4 with chunking and deflation
  LOGICAL                                   :: limit = .FALSE.   ! flag set if limit are used (2D case)
  LOGICAL                                   :: lchk  = .FALSE.   ! flag for file existence checking
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfdynh_anom -t T-file [-s S-file] [-limit lev1 lev2] [-vvl] ...'
     PRINT *,'             ... [--ssh-file SSH-file] [-o OUT-file] [-nc4]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'        Compute dynamic height anomaly from T-file given as argument.'
     PRINT *,'        In this tool, the cumulated values (from top to bottom) are saved at'
     PRINT *,'        each model level. '
     PRINT *,'        If the -limit option is used, only the 2D integral of the dynamic '
     PRINT *,'        height anomaly between lev1 and lev2 is saved. '
     PRINT *,'        This program replace cdfhdy ( case using -limit option) and cdfhdy3d '
     PRINT *,'        in the standard case.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -t T-file : netcdf file with temperature and salinity.' 
     PRINT *,'             If salinity is not in T-file, use -s option.'
     PRINT *,'             If ssh not in T-file use --ssh-file option.'
     PRINT *,'     '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-s S-file ] : Specify salinity file if not T-file.' 
     PRINT *,'       [--ssh-file SSH-file] : specify the ssh file if not in T-file.'
     PRINT *,'       [-limit lev1 lev2] : if specified, the program will only output the'
     PRINT *,'              dynamic height anomaly at lev1 with reference at lev2.'
     PRINT *,'       [-vvl] : use time-varying vertical metrics.'
     PRINT *,'       [-o OUT-file] : Specify output file name instead of ',TRIM(cf_out)
     PRINT *,'       [-nc4] : Use netcdf4 output with chunking and deflation level 1.'
     PRINT *,'                This option is effective only if cdftools are compiled with'
     PRINT *,'                a netcdf library supporting chunking and deflation.'
     PRINT *,'      '
     PRINT *,'     OPENMP SUPPORT : yes'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        ',TRIM(cn_fmsk),' and ', TRIM(cn_fzgr)
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) ,' unless -o option is used.'
     PRINT *,'         variables : ', TRIM(cv_out),' ( m )'
     PRINT *,'       If -limit option is used :'
     PRINT *,'       netcdf file : ', TRIM(cf_out2d) ,' unless -o option is used.'
     PRINT *,'         variables : ', TRIM(cv_out2d),' ( m )'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'       replace old tools cdfhdy and cdfhdy3d.'
     PRINT *,'      '
     STOP 
  ENDIF

  cf_sfil   = 'none'
  cf_sshfil = 'none'
  ijarg = 1
  DO WHILE ( ijarg <= narg )
     CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-t','-f'  ) ; CALL getarg (ijarg, cf_tfil) ; ijarg=ijarg+1
        ! options
     CASE ( '-s'       ) ; CALL getarg (ijarg, cf_sfil) ; ijarg=ijarg+1
     CASE ('--ssh-file') ; CALL getarg(ijarg, cf_sshfil); ijarg=ijarg+1
     CASE ( '-o'       ) ; CALL getarg (ijarg, cf_out ) ; ijarg=ijarg+1 
        ;                  lout  = .TRUE.
     CASE ( '-nc4'     ) ; lnc4  = .TRUE.
     CASE ( '-vvl'     ) ; lg_vvl= .TRUE.
     CASE ( '-limit'   ) ; limit = .TRUE.
        ;                  CALL getarg (ijarg, cldum ) ; ijarg=ijarg+1 ; READ(cldum,*) nlev1
        ;                  CALL getarg (ijarg, cldum ) ; ijarg=ijarg+1 ; READ(cldum,*) nlev2
     CASE DEFAULT        ; PRINT *,' ERROR : ',TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  ENDDO

  IF ( cf_sfil   == 'none' ) cf_sfil   = cf_tfil
  IF ( cf_sshfil == 'none' ) cf_sshfil = cf_tfil
  IF ( lout ) cf_out2d = cf_out  !  name of 2D file if -limit is used

  lchk = chkfile(cf_tfil)
  lchk = lchk .OR. chkfile(cf_sfil  )
  lchk = lchk .OR. chkfile(cf_sshfil)
  lchk = lchk .OR. chkfile(cn_fmsk  )
  lchk = lchk .OR. chkfile(cn_fzgr  )

  IF ( lchk ) STOP 99 ! missing files

  IF ( lg_vvl ) THEN 
    cn_fe3t = cf_tfil
    cn_ve3t = cn_ve3tvvl
  ENDIF

  ! Look for Missing value for salinity
  zsps = getspval(cf_sfil, cn_vosaline)

  npiglo = getdim (cf_tfil,cn_x)
  npjglo = getdim (cf_tfil,cn_y)
  npk    = getdim (cf_tfil,cn_z)
  npt    = getdim (cf_tfil,cn_t)

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  IF ( .NOT. limit ) THEN
     nlev1 = 1
     nlev2 = npk
  ENDIF

  ALLOCATE (temp0(npiglo,npjglo), zsal0(npiglo,npjglo), dsig0(npiglo,npjglo) ,tmask(npiglo,npjglo))
  ALLOCATE (temp(npiglo,npjglo), zsal(npiglo,npjglo), dsig(npiglo,npjglo) , dhdy(npiglo,npjglo), dterm(npiglo,npjglo))
  ALLOCATE (rdep(npiglo,npjglo), rdepth(npiglo,npjglo), zssh(npiglo,npjglo), e3t_1d(npk))
  ALLOCATE (dtim(npt))

  CALL CreateOutput

  ! Temperature and salinity for reference profile
  temp0(:,:) =  0.
  zsal0(:,:)  = 35.

  zssh(:,:)  = getvar(cf_sshfil,  cn_sossheig, 1,  npiglo, npjglo)
  e3t_1d(:)  = getvare3(cn_fzgr, cn_ve3t1d, npk)

  DO jt = 1, npt
     IF ( lg_vvl ) THEN ; it=jt
     ELSE               ; it=1
     ENDIF

     PRINT *,' TIME = ', jt, dtim(jt)/86400.,' days'
     dhdy(:,:)   = 0.
     rdepth(:,:) = 0.

     DO jk = nlev1, nlev2

        IF ( lg_vvl ) THEN ; rdep(:,:) =  getvar(cn_fe3t, cn_ve3t, jk,npiglo,npjglo, ktime=it)
        ELSE               ; rdep(:,:)  = e3t_1d(jk)
        ENDIF

        tmask(:,:) = getvar(cn_fmsk, cn_tmask, jk, npiglo, npjglo)

        IF ( jk == 1 .AND. .NOT. lg_vvl ) THEN
           rdep(:,:) = rdep(:,:) + zssh(:,:)
        ENDIF

        ! depth at current level, including ssh (used for computation of rho in situ)
        rdepth(:,:) = rdepth(:,:) + rdep(:,:)

        temp(:,:) = getvar(cf_tfil, cn_votemper,  jk ,npiglo, npjglo, ktime=jt)
        zsal(:,:) = getvar(cf_sfil, cn_vosaline,  jk ,npiglo, npjglo, ktime=jt)

        dsig0 = sigmai(temp0, zsal0, rdepth, npiglo, npjglo) 
        dsig  = sigmai(temp , zsal , rdepth, npiglo, npjglo) 

        ! we compute the term of the integral : (1/g) *10e4 * sum [ delta * dz ]
        ! with delta = (1/rho - 1/rho0)
        ! 10e4 factor is conversion decibar/pascal
        !
        dterm = ( ( 1.d0 / ( drau0 + dsig(:,:) ) ) - ( 1.d0 / ( drau0 + dsig0(:,:) ) ) ) * 10000.d0 * rdep / dgrav
        ! in land, it seems appropriate to stop the computation
        WHERE(zsal == zsps ) dterm = 0

        dhdy(:,:) = dhdy(:,:) + dterm(:,:)
        ! masked
        dhdy(:,:) = dhdy(:,:) * tmask(:,:)

        IF ( .NOT. limit ) ierr = putvar(ncout, id_varout(1) ,REAL(dhdy), jk, npiglo, npjglo, ktime=jt)

     END DO  ! loop to next level
     IF ( limit ) ierr = putvar(ncout, id_varout(1) ,REAL(dhdy), 1 , npiglo, npjglo, ktime=jt)
  END DO  ! next time frame

  ierr = closeout(ncout)

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    IF ( limit ) THEN
       ipk(:)                       = 1
       stypvar(1)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
       stypvar(1)%cname             = cv_out2d
       stypvar(1)%cunits            = 'm'
       stypvar(1)%rmissing_value    = 0.
       stypvar(1)%valid_min         = -100.
       stypvar(1)%valid_max         = 100.
       stypvar(1)%clong_name        = 'Dynamical height anomaly'
       stypvar(1)%cshort_name       = cv_out2d
       stypvar(1)%conline_operation = 'N/A'
       stypvar(1)%caxis             = 'TYX'

       ! create output fileset (2D case )
       ncout = create      (cf_out2d, cf_tfil,  npiglo, npjglo, 1       , ld_nc4=lnc4 )
       ierr  = createvar   (ncout,    stypvar, 1,      ipk,    id_varout, ld_nc4=lnc4 )
       ierr  = putheadervar(ncout,    cf_tfil,  npiglo, npjglo, 1                     )
    ELSE
       ipk(:)                       = npk
       stypvar(1)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
       stypvar(1)%cname             = cv_out
       stypvar(1)%cunits            = 'm'
       stypvar(1)%rmissing_value    = 0.
       stypvar(1)%valid_min         = -100.
       stypvar(1)%valid_max         = 100.
       stypvar(1)%clong_name        = 'Dynamical height anomaly'
       stypvar(1)%cshort_name       = cv_out
       stypvar(1)%conline_operation = 'N/A'
       stypvar(1)%caxis             = 'TZYX'

       ! create output fileset (3D case )
       ncout = create      (cf_out, cf_tfil,  npiglo, npjglo, npk     , ld_nc4=lnc4 )
       ierr  = createvar   (ncout,  stypvar, 1,      ipk,    id_varout, ld_nc4=lnc4 )
       ierr  = putheadervar(ncout,  cf_tfil,  npiglo, npjglo, npk       )
    ENDIF

    dtim  = getvar1d(cf_tfil, cn_vtimec, npt)
    ierr  = putvar1d(ncout, dtim,   npt, 'T')

  END SUBROUTINE CreateOutput

END PROGRAM cdfdynh_anom

PROGRAM cdffixtime
  !!======================================================================
  !!                     ***  PROGRAM  cdffixtime  ***
  !!=====================================================================
  !!  ** Purpose : Correct time inconsistency in model output file or
  !!               mean fields.
  !!
  !!  ** Method  : Adjust the values of time_counters in order to be 
  !!               coherent with the time_origin and units attribute.
  !!               According to drakkar the time in seconds represents
  !!               the time of the model at the moment of output, ie at
  !!               the end of the averaging period. The time origin is
  !!               shifted back half the averaging period in order to
  !!               indicate the center of the averaging period.
  !!                  This program is intended to manage both leap year
  !!               and noleap year calendars.
  !!
  !! History :  3.0  : 04/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  !!   routines      : description
  !!   jcnes         : return the jcnes Julian day from time tag
  !!   julday        : return the true Julian day 
  !!   caldatjm      : Return the calendar date from the input jcnes day
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)            :: narg            ! number of arguments
  INTEGER(KIND=4)            :: iargc           ! f90 function
  INTEGER(KIND=4)            :: ijarg           ! argument counter
  INTEGER(KIND=4)            :: is, ie          ! starting and ending position of the tag in file name
  INTEGER(KIND=4)            :: iyr_init        ! initial date (year)
  INTEGER(KIND=4)            :: imm_init        ! initial date (month)
  INTEGER(KIND=4)            :: idd_init        ! initial date (day)
  INTEGER(KIND=4)            :: ihr_init        ! ititial time (hour)
  INTEGER(KIND=4)            :: imn_init        ! ititial time (minutes)
  INTEGER(KIND=4)            :: isec_init       ! ititial time (seconds)
  INTEGER(KIND=4)            :: ierr            ! error status for i/o

  REAL(KIND=4)               :: rpp_one_year = 365 ! 365.2425
  REAL(KIND=4)               :: rdt_obs = 5.    ! time interval between file fields (days)
  REAL(KIND=4)               :: rday0           ! CNES julian day corresponding to tag of initial date
  REAL(KIND=4)               :: rday_origin     ! CNES julian day corresponding to origin date
  REAL(KIND=4), DIMENSION(1) :: rdaycnes        ! CNES julian day corresponding to current tag
  REAL(KIND=4), DIMENSION(1) :: rseconds        ! seconds since rday0

  CHARACTER(LEN=80)          :: cf_in           ! input file 
  CHARACTER(LEN=80)          :: cldum           ! dummy character variable
  CHARACTER(LEN=80)          :: ctag='none'     ! tag default. Interpreted from file name if possible
  CHARACTER(LEN=80)          :: cldate, ctim    ! date and time as string
  CHARACTER(LEN=80)          :: ctag0           ! time tag from input initial date/time
  CHARACTER(LEN=80)          :: ctim_unit       ! attribute value for time_counter unit
  CHARACTER(LEN=80)          :: ctim_origin     ! attribute value for time_counter time_origin
  CHARACTER(LEN=3)           :: cmm             ! month in character

  LOGICAL                    :: lnoleap=.true.  ! flag for noleap years
  LOGICAL                    :: lagrif=.false.  ! flag for agrif files
  LOGICAL                    :: lkeep=.false.  ! flag for agrif files
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg=iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdffixtime  -f IN-file -i initial date [-t tag] [-dt freq] ... '
     PRINT *,'               ...  [-keep ] [-leap] [ -noleap]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'        Change time_counter in file to set it according to drakkar rule,' 
     PRINT *,'        time_counter attibutes ''units'' and ''time_origin'' are ajusted.'
     PRINT *,'         * units are ''seconds since yyyy-mm-dd hh:mm:ss'' '
     PRINT *,'         * time_origin is set to ''yyyy-MMM-dd hh:mm:ss'', MMM represents a'
     PRINT *,'        litteral abbreviation for the month (eg: JAN FEB MAR ...)'
     PRINT *,'        Once fixed, the time_counter indicates the middle of the output '
     PRINT *,'        interval (in case of averaged output, of course).'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -f IN-file     : specify the file whose time_counter need adjustment' 
     PRINT *,'       -i inital date : indicate the time origin in a fixed 2 words format'
     PRINT *,'                   yyyy-mm-dd hh:mm:ss ( eg: 1956-05-16 04:30:00 )'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [ -t tag ]  : supply a time tag corresponding to the file. If not'
     PRINT *,'                     supplied, tag is taken from the name of the input file'
     PRINT *,'                     assuming DRAKKAR convention ( CONFIG-CASE_tag_xxxx.nc )'
     PRINT *,'       [ -dt freq] : number of days between model output [ 5d ]'
     PRINT *,'       [-leap ]    : assume a calendar with leap years'
     PRINT *,'       [-noleap ]  : assume a calendar without leap years (default)'
     PRINT *,'       [-keep ]    : keep the actual value of time_counter, adjust time_counter'
     PRINT *,'                    attributes only;'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       none ' 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : Input file is modified (only attributes)'
     PRINT *,'      '
     STOP
  ENDIF

  ! browse line option
  ijarg=1
  DO WHILE ( ijarg <= narg )
     CALL getarg(ijarg, cldum) ; ijarg=ijarg + 1 
     SELECT CASE (cldum)
     CASE ( '-f' )
        CALL getarg(ijarg,cf_in) ;ijarg=ijarg +1
     CASE ( '-t' )
        CALL getarg(ijarg,ctag) ; ijarg=ijarg +1
     CASE ( '-dt' )
        CALL getarg(ijarg,cldum) ; ijarg=ijarg +1
        READ(cldum,*) rdt_obs
     CASE ( '-i' )
        CALL getarg(ijarg,cldate) ; ijarg=ijarg +1
        CALL getarg(ijarg,ctim)  ; ijarg=ijarg +1
     CASE ( '-leap' )
        rpp_one_year=365.2425
        lnoleap=.false.
     CASE ( '-noleap' )
        rpp_one_year=365
        lnoleap=.true.
     CASE ( '-keep' )
        lkeep=.true.
     CASE DEFAULT 
         PRINT *,' Option ',TRIM(cldum),' unknown'
         STOP 99
     END SELECT
  END DO
  
  IF ( chkfile(cf_in) ) STOP 99 ! missing file
  PRINT *,' Changing time on file :', TRIM(cf_in)

  ! if ctag = none, try to find it from the file name.
  IF ( TRIM(ctag) == 'none' ) THEN  ! no tag given as arguments
    is = INDEX(cf_in,'_')
    IF ( is == 2 ) THEN 
      PRINT *,' ASSUME AGRIF file for ', TRIM(cf_in)
      lagrif = .TRUE.
    ENDIF

    IF (lagrif) THEN
     is=INDEX(cf_in(3:),'_' )+2
     ie=INDEX(cf_in(is+1:),'_' )
     ctag=cf_in(is+1:is+ie-1) 
    ELSE
     is=INDEX(cf_in,'_')
     ie=INDEX(cf_in(is+1:),'_' )
     ctag=cf_in(is+1:is+ie-1) 
    ENDIF

    is=INDEX(ctag,'d')
    IF ( is == 0 ) THEN ! not a model output but a mean value
      is=INDEX(ctag,'m') 
      IF ( is == 0 ) THEN ! annual mean set pseudo date to 01/07
        ctag=ctag(1:5)//"m07d01"
      ELSE  ! monthly mean set pseudo date to the 15 of month
        ctag=ctag(1:8)//"d15"
      ENDIF
    ENDIF
  ENDIF

  PRINT *,'            Using tag = ', TRIM(ctag)
 
  ! interpret ctim and cldate
  READ(cldate,'(i4,1x,i2,1x,i2)'            ) iyr_init, imm_init, idd_init
  READ(ctim,  '(i2,1x,i2,1x,i2)'            ) ihr_init, imn_init, isec_init
  WRITE(ctag0,'("y",i4.4,"m",i2.2,"d",i2.2)') iyr_init, imm_init, idd_init

  ! jcnes of initial date including time as fraction of days
  rday0 = jcnes(ctag0) + ihr_init/24.0 + imn_init/60./24. + isec_init/3600./24.

  ! compute the pseudo time_origin and set up variable attributes
  rday_origin = rday0 - rdt_obs/2.   ! offset of -1/2 of time interval
  CALL caldatjm(rday_origin, iyr_init, imm_init, idd_init, ihr_init, imn_init, isec_init)

  WRITE(cldate,'(i4.4,"-",i2.2,"-",i2.2)') iyr_init, imm_init, idd_init
  WRITE(ctim,  '(i2.2,":",i2.2,":",i2.2)') ihr_init, imn_init, isec_init

  ! Compute initial julian day
  SELECT CASE ( imm_init )
  CASE (  1 ) ; cmm='JAN' 
  CASE (  2 ) ; cmm='FEB'
  CASE (  3 ) ; cmm='MAR'
  CASE (  4 ) ; cmm='APR'
  CASE (  5 ) ; cmm='MAY'
  CASE (  6 ) ; cmm='JUN'
  CASE (  7 ) ; cmm='JUL'
  CASE (  8 ) ; cmm='AUG'
  CASE (  9 ) ; cmm='SEP'
  CASE ( 10 ) ; cmm='OCT'
  CASE ( 11 ) ; cmm='NOV'
  CASE ( 12 ) ; cmm='DEC'
  END SELECT

  WRITE(ctim_unit,  '("seconds since ",a,i3.2,":",i2.2,":",i2.2   )') TRIM(cldate), ihr_init, imn_init, isec_init
  WRITE(ctim_origin,'(i5,"-",a,"-",i2.2," ",i2.2,":",i2.2,":",i2.2)') iyr_init,cmm, idd_init, ihr_init, imn_init, isec_init

  PRINT *, "          ",TRIM(cn_vtimec)," units set to : ", TRIM(ctim_unit)
  PRINT *, "          ",TRIM(cn_vtimec)," time origin set to : ", TRIM(ctim_origin)

  ! Compute corresponding jcnes
  rdaycnes=jcnes(ctag)
  rseconds=(rdaycnes - rday0 +1 ) * 86400. 

  ! Modify cdfile !! CAUTION : Original file will be modified  !!
  IF ( .NOT. lkeep )  THEN
    ierr = putvar1d( cf_in, cn_vtimec, rseconds, 1 )
  ENDIF
  ierr = atted   ( cf_in, cn_vtimec, 'units',       ctim_unit  )
  ierr = atted   ( cf_in, cn_vtimec, 'time_origin', ctim_origin)

CONTAINS

  REAL(KIND=4) FUNCTION jcnes(cdtag)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION jcnes  ***
    !!
    !! ** Purpose : return the JCNES corresponding to time tag. JCNES is a julian
    !!              day refered from 1950-01-01
    !!
    !! ** Method  : Interface with function julday 
    !!
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*),INTENT(in) :: cdtag

    INTEGER(KIND=4)             :: iyear, imon, iday
    REAL(KIND=4)                :: zsec = 0.
    REAL(KIND=4)                :: zjuldeb, zjulfin, zjulday

    READ(cdtag,'(1x,i4.4,1x,i2.2,1x,i2.2)') iyear, imon, iday
    zsec=0.
    !---------------------------------------------------------------------
    zjulfin = julday(iyear, imon, iday, zsec)
    zjuldeb = julday(1950, 01, 01, 0.)
    jcnes   = zjulfin - zjuldeb
  END FUNCTION jcnes

  REAL(KIND=4) FUNCTION julday(kyear, kmonth, kday, psec)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION julday  ***
    !!
    !! ** Purpose : Converts year, month, day and seconds into a julian day
    !!
    !! ** Method  : In 1968 in a letter to the editor of Communications of 
    !!              the ACM (CACM, volume 11, number 10, October 1968, p.657)
    !!              Henry F. Fliegel and Thomas C. Van Flandern presented 
    !!              such an algorithm.
    !!                  In the case of the Gregorian calendar we have chosen 
    !!              to use the Lilian day numbers. This is the day counter 
    !!              which starts on the 15th October 1582.
    !!              This is the day at which Pope Gregory XIII introduced the
    !!              Gregorian calendar.
    !!              Compared to the true Julian calendar, which starts some
    !!              7980 years ago, the Lilian days are smaller and are dealt 
    !!              with easily on 32 bit machines. With the true Julian days
    !!              you can only the fraction of the day in the real part to 
    !!              a precision of a 1/4 of a day with 32 bits.
    !!----------------------------------------------------------------------
    INTEGER(KIND=4), INTENT(in) :: kyear, kmonth, kday  ! input date
    REAL(KIND=4),    INTENT(in) :: psec                 ! input seconds

    REAL(KIND=4),     PARAMETER :: pp_one_day = 86400.0
    INTEGER(KIND=4),  PARAMETER :: jp_mon_len(12)=(/31,28,31,30,31,30,31,31,30,31,30,31/)

    INTEGER(KIND=4)             :: in_m, in_y, in_d
    INTEGER(KIND=4)             :: ijd, iml
    !---------------------------------------------------------------------

    in_m = kmonth
    in_y = kyear
    in_d = kday
    !- We deduce the calendar from the length of the year as it
    !- is faster than an INDEX on the calendar variable.
    !-
    !- Gregorian
    IF ( (rpp_one_year > 365.0) .AND. (rpp_one_year < 366.0) ) THEN
       ijd = (1461*(in_y+4800+INT(( in_m-14 )/12)))/4 &
            &      +(367*(in_m-2-12*(INT(( in_m-14 )/12))))/12 &
            &      -(3*((in_y+4900+INT((in_m-14)/12))/100))/4 &
            &      +in_d-32075
       ijd = ijd-2299160
       !- No leap or All leap
    ELSE IF (ABS(rpp_one_year-365.0) <= EPSILON(rpp_one_year) .OR. &
         &   ABS(rpp_one_year-366.0) <= EPSILON(rpp_one_year)) THEN
       iml = SUM(jp_mon_len(1:in_m-1))
       ijd = in_y*INT(rpp_one_year)+iml+(in_d-1)
       !- Calendar with regular month
       !  ELSE
       !    iml = INT(one_year)/12
       !    ijd = y*INT(one_year)+(m-1)*iml+(d-1)
    ENDIF
    !-
    julday = ijd + psec / pp_one_day
  END FUNCTION julday


  SUBROUTINE caldatjm( pjcnes, ky, km, kd, kh, kmn, ksec )
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE caldatjm  ***
    !!
    !! ** Purpose : Compute the calendar date from the julian CNES day
    !!              given as input  
    !!
    !! ** Method  : Take care of the leap/noleap calendar. That's why we
    !!              cannot use the standard caldat from numerical recipe
    !!----------------------------------------------------------------------
    REAL(KIND=4),       INTENT(in) :: pjcnes
    INTEGER(KIND=4),   INTENT(out) :: ky, km, kd, kh, kmn, ksec
  
    INTEGER(KIND=4)                :: jd, jm      ! dummy loop index
    INTEGER(KIND=4)                :: isec, idays
    INTEGER(KIND=4), DIMENSION(12) :: indays=(/31,28,31,30,31,30,31,31,30,31,30,31/)
    INTEGER(KIND=4), DIMENSION(12) :: icumul
    !!--------------------------------------------------------------------------------
    ! initialize the cumulated time
    icumul(1)    = indays(1)
    DO jm=2,12
      icumul(jm) = icumul(jm-1) + indays(jm)
    ENDDO
    
    ! look for time part of pjcnes
    isec = (pjcnes-INT(pjcnes) ) * 86400.
    kh   = isec/3600
    kmn  = (isec - kh * 3600 )/60
    ksec =  isec - kh * 3600 - kmn * 60
  
    ! number of years since 1950
    IF ( lnoleap ) THEN ! no leap years
      ky=1950 + INT(pjcnes)/365
      idays= ( INT(pjcnes)/ 365. - INT(pjcnes)/365 )* 365 
      km=1 ; kd=0
      DO jd=1, idays
       IF ( jd > icumul(km) ) THEN
         km=km+1
         kd=1
       ELSE
         kd=kd+1
       ENDIF
      ENDDO
    ELSE
      ! use caldat from Numerical Recipe
      CALL caldat_nr ( pjcnes, ky, km, kd, kh, kmn, ksec )
    ENDIF
    END SUBROUTINE caldatjm

  SUBROUTINE caldat_nr( pjcnes, kiyyy, kmm, kid, kh, kmn, ksec ) 
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE caldat_nr  ***
    !!
    !! ** Purpose : This routine convert a julian day in calendar date.
    !!
    !! ** Method  :  This routine comes directly from the Numerical Recipe Book,
    !!
    !!   Arguments
    !!     kjulian : input julian day number
    !!     kmm     : output, corresponding month
    !!     kid     : output, corresponding day
    !!     kiyyy   : output, corresponding year, positive IF a.d, negative b.c.
    !!
    !! References  : Numerical Recipe Book,  Press et al., numerical recipes,
    !!               cambridge univ. press, 1986.
    !!----------------------------------------------------------------------
    IMPLICIT NONE

    REAL(KIND=4),    INTENT(in)  :: pjcnes
    INTEGER(KIND=4), INTENT(out) :: kiyyy, kmm, kid, kh, kmn, ksec
    ! * Local
    INTEGER(KIND=4), PARAMETER  :: jpgreg = 2299161
    INTEGER(KIND=4)             :: ijulian
    INTEGER(KIND=4)             :: ia, ialpha, ib, ic, id, ie, isec
    REAL(KIND=4)                :: zjul1950
    !!----------------------------------------------------------------------
    ! look for time part of pjcnes
    isec = (pjcnes-INT(pjcnes) ) * 86400.
    kh   = isec/3600
    kmn  = (isec - kh * 3600 )/60
    ksec =  isec - kh * 3600 - kmn * 60
    zjul1950 = julday_nr( 01, 01, 1950)
    ijulian  = INT(pjcnes + zjul1950)
   !
    IF ( ijulian >= jpgreg) THEN
       ialpha = INT ((( ijulian - 1867216) - 0.25)/36524.25 )
       ia     = ijulian +1 + ialpha -INT (0.25*ialpha)
    ELSE
       ia = ijulian
    END IF
    !
    ib = ia + 1524
    ic = INT (6680. + (( ib -2439870) - 122.1)/365.25 )
    id = 365* ic + INT (0.25*ic)
    ie = INT (( ib - id )/30.6001)
    !
    kid = ib - id - INT (30.6001*ie)
    kmm = ie -1
    IF ( kmm > 12 ) kmm = kmm - 12
    kiyyy = ic - 4715
    IF ( kmm   >  2 ) kiyyy = kiyyy - 1
    IF ( kiyyy <= 0 ) kiyyy = kiyyy - 1
  END SUBROUTINE caldat_nr

  INTEGER(KIND=4) FUNCTION julday_nr(kmm,kid,kiyyy)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION julday_nr  ***
    !!
    !! ** Purpose : his routine returns the julian day number which begins at noon
    !!         of the calendar date specified by month kmm, day kid, and year kiyyy.
    !!         positive year signifies a.d.; negative, b.c.  (remember that the
    !!         year after 1 b.c. was 1 a.d.)
    !!         routine handles changeover to gregorian calendar on oct. 15, 1582.
    !!
    !! ** Method:  This routine comes directly from the Numerical Recipe Book,
    !!
    !!----------------------------------------------------------------------
   INTEGER, INTENT(in) :: kiyyy
   INTEGER, INTENT(in) :: kmm, kid
   !  * Local
   INTEGER, PARAMETER ::jpgreg=15+31*(10+12*1582)
   INTEGER  ::ky, iy, im, ia
    !!----------------------------------------------------------------------
    ky = kiyyy
    ! ... Year 0 never existed ...
    IF (ky == 0) STOP 101
    !
    IF (ky < 0) ky = ky + 1
    IF (kmm > 2) THEN
       iy = ky
       im = kmm + 1
    ELSE
       iy = ky - 1
       im = kmm + 13
    END IF
    !
    julday_nr = INT(365.25*iy) + INT(30.6001*im) + kid + 1720995
    IF (kid+31*(kmm+12*ky).GE.jpgreg) THEN
       ia = INT(0.01*iy)
       julday_nr = julday_nr + 2 - ia + INT(0.25*ia)
    END IF
  END FUNCTION julday_nr

  
END PROGRAM cdffixtime

PROGRAM cdfnrj_bti
  !!======================================================================
  !!                     ***  PROGRAM  cdfnrj_bti  ***
  !!=====================================================================
  !!  ** Purpose : Compute the term of energetic transfert BTI
  !!               for the barotropic instability for given gridU 
  !!               gridV gridU2 gridV2 files and variables
  !!
  !!  ** Method  : Take an input file which is preprocessed by
  !!               cdfuvwt. See also cdfbci
  !!
  !! History : 2.1  : 02/2008  : A. Melet     : Original code
  !!           3.0  : 12/2010  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class energy_diagnostics
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4), PARAMETER                :: jp_varout  = 8
  INTEGER(KIND=4), PARAMETER                :: jp_dudx    = 1, jp_dvdx    = 2
  INTEGER(KIND=4), PARAMETER                :: jp_dudy    = 3, jp_dvdy    = 4
  INTEGER(KIND=4), PARAMETER                :: jp_anousqrt= 5, jp_anovsqrt= 6
  INTEGER(KIND=4), PARAMETER                :: jp_anouv   = 7, jp_bti     = 8
  INTEGER(KIND=4)                           :: ji, jj, jk, jt,jv      ! dummy loop index
  INTEGER(KIND=4)                           :: npiglo, npjglo         ! domain size
  INTEGER(KIND=4)                           :: npk, npt               ! vertical and time
  INTEGER(KIND=4)                           :: narg, iargc, ijarg     ! command line parser
  INTEGER(KIND=4)                           :: ncout, ierr            ! ncid of output file, error status
  INTEGER(KIND=4), DIMENSION(jp_varout)     :: ipk, id_varout         ! 

  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e2t, e1t, e1f, e2f     !
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: un, vn, u2n, v2n, uvn  !
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: fmask, umask, vmask    !
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: anousqrt, anovsqrt     !
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: anouv, bti             !
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: dudx, dudy, dvdx, dvdy !

  REAL(KIND=8), DIMENSION(:),   ALLOCATABLE :: dtim

  CHARACTER(LEN=256)                        :: cf_out='bti.nc'        ! output file name
  CHARACTER(LEN=256)                        :: cf_uvwtfil             ! input file name
  CHARACTER(LEN=256)                        :: cldum                  ! working char variable

  TYPE (variable), DIMENSION(jp_varout)     :: stypvar                ! structure for attibutes

  LOGICAL                                   :: lchk                   ! flag for missing files
  LOGICAL                                   :: lnc4 = .FALSE.         ! Use nc4 with chunking and deflation
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()
  !!
  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfnrj_bti -f UVWT-file [-o OUT-file] [-nc4]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute  the terms in the barotropic energy tranfert equation.'
     PRINT *,'       The transfert of energy for the barotropic instability is '
     PRINT *,'       bti= -[(u''bar)^2*dubar/dx ...'
     PRINT *,'             +(v''bar)^2*dvbar/dy ...'
     PRINT *,'             +(u''v''*(dubar/dy +dvbar/dx))]'
     PRINT *,'       Note : This program was formerly named cdfbti.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -f UVWT-file : netcdf file produced by cdfuvwt'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-o OUT-file] : specify the output file name instead of ',TRIM(cf_out)
     PRINT *,'       [-nc4 ]  : Use netcdf4 output with chunking and deflation level 1.'
     PRINT *,'             This option is effective only if cdftools are compiled with'
     PRINT *,'             a netcdf library supporting chunking and deflation.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ', TRIM(cn_fhgr) 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : '
     PRINT *,'              dudx : zonal derivate of ubar on T point'
     PRINT *,'              dvdx : zonal derivate of vbar on T point'
     PRINT *,'              dudy : meridional derivate of ubar on T point'
     PRINT *,'              dvdy : meridional derivate of vbar on T point'
     PRINT *,'              anousqrt : mean of (u-ubar)^2 on T point'
     PRINT *,'              anovsqrt : mean of (v-vbar)^2 on T point'
     PRINT *,'              anouv : mean of (u-ubar)*(v-vbar) on T point'
     PRINT *,'              bti  : transfert of energy for the barotropic instability.'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'      cdfuvwt, cdfnrj_bci, cdfnrj_components, cdfnrj_transfert'
     PRINT *,'      '
     STOP 
  ENDIF

  ijarg = 1
  DO WHILE ( ijarg <= narg )
     CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-f'   ) ; CALL getarg(ijarg, cf_uvwtfil ) ; ijarg=ijarg+1
        ! option
     CASE ( '-o'   ) ; CALL getarg(ijarg, cf_out     ) ; ijarg=ijarg+1
     CASE ( '-nc4' ) ; lnc4 = .TRUE.
     CASE DEFAULT    ; PRINT *, ' ERROR : ', TRIM(cldum),' : unknown option.'; STOP 99
     END SELECT
  ENDDO

  lchk = chkfile (cn_fhgr )
  lchk = lchk .OR. chkfile (cf_uvwtfil )
  IF ( lchk ) STOP 99 ! missing file

  npiglo  = getdim(cf_uvwtfil,cn_x)
  npjglo  = getdim(cf_uvwtfil,cn_y)
  npk     = getdim(cf_uvwtfil,cn_z)
  npt     = getdim(cf_uvwtfil,cn_t)

  PRINT *, 'npiglo =', npiglo
  PRINT *, 'npjglo =', npjglo
  PRINT *, 'npk    =', npk
  PRINT *, 'npt    =', npt

  ! Allocate the memory
  ALLOCATE ( e1t(npiglo,npjglo) , e1f(npiglo,npjglo) )
  ALLOCATE ( e2t(npiglo,npjglo) , e2f(npiglo,npjglo) )
  ALLOCATE ( un(npiglo,npjglo)  , vn(npiglo,npjglo)  )
  ALLOCATE ( fmask(npiglo,npjglo) )
  ALLOCATE ( umask(npiglo,npjglo) , vmask(npiglo,npjglo) )
  ALLOCATE ( dudx(npiglo,npjglo)  , dudy(npiglo,npjglo)  )
  ALLOCATE ( dvdx(npiglo,npjglo)  , dvdy(npiglo,npjglo)  )
  ALLOCATE ( u2n(npiglo,npjglo)  , v2n(npiglo,npjglo)  )
  ALLOCATE ( uvn(npiglo,npjglo) )
  ALLOCATE ( anousqrt(npiglo,npjglo) , anovsqrt(npiglo,npjglo)  )
  ALLOCATE ( anouv(npiglo,npjglo), bti(npiglo,npjglo) )
  ALLOCATE ( dtim(npt) )

  CALL CreateOutput

  e1t = getvar(cn_fhgr, cn_ve1t, 1, npiglo, npjglo)
  e1f = getvar(cn_fhgr, cn_ve1f, 1, npiglo, npjglo)
  e2t = getvar(cn_fhgr, cn_ve2t, 1, npiglo, npjglo)
  e2f = getvar(cn_fhgr, cn_ve2f, 1, npiglo, npjglo)


  DO jt = 1, npt
     DO jk=1, npk
        PRINT *,'            level ',jk
        dudx(:,:) = 0.d0
        dvdx(:,:) = 0.d0
        dudy(:,:) = 0.d0
        dvdy(:,:) = 0.d0

        anousqrt(:,:) = 0.d0
        anovsqrt(:,:) = 0.d0      
        anouv(:,:)    = 0.d0

        un(:,:)  =  getvar(cf_uvwtfil, 'ubar',  jk ,npiglo,npjglo, ktime=jt)
        vn(:,:)  =  getvar(cf_uvwtfil, 'vbar',  jk ,npiglo,npjglo, ktime=jt)
        u2n(:,:) =  getvar(cf_uvwtfil, 'u2bar', jk ,npiglo,npjglo, ktime=jt)
        v2n(:,:) =  getvar(cf_uvwtfil, 'v2bar', jk ,npiglo,npjglo, ktime=jt)
        uvn(:,:) =  getvar(cf_uvwtfil, 'uvbar', jk ,npiglo,npjglo, ktime=jt)

        ! compute the masks
        umask(:,:) = 0. ; vmask(:,:) = 0. ; fmask(:,:) = 0.
        DO jj = 2, npjglo
           DO ji = 2, npiglo
              umask(ji,jj)= un(ji,jj)*un(ji-1,jj  ) 
              vmask(ji,jj)= vn(ji,jj)*vn(ji  ,jj-1)
           ENDDO
        ENDDO

        WHERE ( umask /= 0. ) umask = 1.
        WHERE ( vmask /= 0. ) vmask = 1.

        DO jj = 1, npjglo-1
           DO ji = 1, npiglo-1
              fmask(ji,jj)= un(ji,jj)*un(ji,jj+1) * vn(ji,jj)*vn(ji+1,jj)
           ENDDO
        ENDDO

        WHERE ( fmask /= 0. ) fmask = 1.

        DO jj = 2, npjglo  
           DO ji = 2, npiglo    ! vector opt.
              ! compute derivates at T points
              dudx(ji,jj) = 100000. * ( un(ji,jj ) - un(ji-1,jj) )   &
                   &               * umask(ji,jj) / e1t(ji,jj) 

              dvdy(ji,jj) = 100000. * ( vn(ji,jj ) - vn(ji,jj-1) )   &
                   &               * vmask(ji,jj) / e2t(ji,jj)             

              dudy(ji,jj) = 100000./4. *( ( un(ji,jj+1 ) - un(ji,jj) )   &
                   &           * fmask(ji,jj) / e2f(ji,jj)               &
                   &       + (un(ji,jj ) - un(ji,jj-1) )                 &
                   &           * fmask(ji,jj-1) / e2f(ji,jj-1)           &
                   &       + (un(ji-1,jj+1 ) - un(ji-1,jj) )             &
                   &           * fmask(ji-1,jj) / e2f(ji-1,jj)           &         
                   &       + (un(ji-1,jj ) - un(ji-1,jj-1) )             &    
                   &           * fmask(ji-1,jj-1) / e2f(ji-1,jj-1) )            

              dvdx(ji,jj) = 100000./4. *( ( vn(ji,jj ) - vn(ji-1,jj) )   &
                   &           * fmask(ji-1,jj) / e1f(ji-1,jj)           &
                   &       + (vn(ji+1,jj ) - vn(ji,jj) )                 &
                   &           * fmask(ji,jj) / e1f(ji,jj)               &
                   &       + (vn(ji-1,jj-1 ) - vn(ji,jj-1) )             &
                   &           * fmask(ji-1,jj-1) / e1f(ji-1,jj-1)       &
                   &       + (vn(ji+1,jj-1 ) - vn(ji,jj-1) )             &
                   &           * fmask(ji,jj-1) / e1f(ji,jj-1) )         

              ! Compute Reynolds terms
              anousqrt(ji,jj) = 1000./2. * umask(ji,jj)*( ( u2n(ji,jj) - un(ji,jj)*un(ji,jj) ) &
                   &                     + ( u2n(ji-1,jj) - un(ji-1,jj)*un(ji-1,jj) ) )       

              anovsqrt(ji,jj) = 1000./2. * vmask(ji,jj)*( ( v2n(ji,jj) - vn(ji,jj)*vn(ji,jj) ) &
                   &                     + ( v2n(ji,jj-1) - vn(ji,jj)*vn(ji,jj-1) ) ) 

              anouv(ji,jj)    = 1000. * ( uvn(ji,jj) &
                   &                 -   0.5 * umask(ji,jj)*( un(ji,jj) + un(ji-1,jj) ) &
                   &                   * 0.5 * vmask(ji,jj)*( vn(ji,jj) + vn(ji,jj-1) ) )

              ! Compute bti
              bti(ji,jj) = -1. * ( anousqrt(ji,jj) * dudx(ji,jj)                &
                   &           + anovsqrt(ji,jj) * dvdy(ji,jj)                  &
                   &           + anouv(ji,jj) * ( dvdx(ji,jj) + dudy(ji,jj) ))

           END DO
        END DO
        ! 
        ierr = putvar(ncout, id_varout(jp_dudx),     dudx,     jk, npiglo, npjglo, ktime=jt)
        ierr = putvar(ncout, id_varout(jp_dvdx),     dvdx,     jk, npiglo, npjglo, ktime=jt)
        ierr = putvar(ncout, id_varout(jp_dudy),     dudy,     jk, npiglo, npjglo, ktime=jt)
        ierr = putvar(ncout, id_varout(jp_dvdy),     dvdy,     jk, npiglo, npjglo, ktime=jt)
        ierr = putvar(ncout, id_varout(jp_anousqrt), anousqrt, jk, npiglo, npjglo, ktime=jt)
        ierr = putvar(ncout, id_varout(jp_anovsqrt), anovsqrt, jk, npiglo, npjglo, ktime=jt) 
        ierr = putvar(ncout, id_varout(jp_anouv),    anouv,    jk, npiglo, npjglo, ktime=jt)
        ierr = putvar(ncout, id_varout(jp_bti),      bti,      jk, npiglo, npjglo, ktime=jt)
     END DO
  END DO  ! time loop

  ierr = closeout(ncout)

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    ! define new variables for output ( must update att.txt)
    DO jv = 1, jp_varout
       stypvar(jv)%ichunk        = (/npiglo,MAX(1,npjglo/30),1,1 /)
    ENDDO
    ipk(:) = npk  

    stypvar(jp_dudx)%cname       = 'dudx'
    stypvar(jp_dudx)%clong_name  = 'zonal derivate of u on T point'
    stypvar(jp_dudx)%cshort_name = 'dudx'

    stypvar(jp_dvdx)%cname       = 'dvdx'
    stypvar(jp_dvdx)%clong_name  = 'zonal derivate of v on T point'
    stypvar(jp_dvdx)%cshort_name = 'dvdx'

    stypvar(jp_dudy)%cname       = 'dudy'
    stypvar(jp_dudy)%clong_name  = 'meridional derivate of u on T point'
    stypvar(jp_dudy)%cshort_name = 'dudy'

    stypvar(jp_dvdy)%cname       = 'dvdy'
    stypvar(jp_dvdy)%clong_name  = 'meridional derivate of v on T point'
    stypvar(jp_dvdy)%cshort_name = 'dvdy'

    stypvar(jp_anousqrt)%cname       = 'anousqrt'
    stypvar(jp_anousqrt)%clong_name  = 'temporal mean of the square of the zonal speed anomaly'
    stypvar(jp_anousqrt)%cshort_name = 'anousqrt'

    stypvar(jp_anovsqrt)%cname       = 'anovsqrt'
    stypvar(jp_anovsqrt)%clong_name  = 'temporal mean of the square of the meridional speed anomaly'
    stypvar(jp_anovsqrt)%cshort_name = 'anovsqrt'

    stypvar(jp_anouv)%cname       = 'anouv'
    stypvar(jp_anouv)%clong_name  = 'temporal mean of the Reynolds term'
    stypvar(jp_anouv)%cshort_name = 'anouanov'

    stypvar(jp_bti)%cname         = 'bti'
    stypvar(jp_bti)%clong_name    = 'transfert of energy for the barotropic instability'
    stypvar(jp_bti)%cshort_name   = 'bti'

    stypvar%cunits            = '100000 s-1'
    stypvar%rmissing_value    = 0.
    stypvar%valid_min         = -1000.
    stypvar%valid_max         = 1000.
    stypvar%conline_operation = 'N/A'
    stypvar%caxis             = 'TYX'

    ! create output fileset
    ncout = create      (cf_out, cf_uvwtfil, npiglo,    npjglo, npk      , ld_nc4=lnc4 )
    ierr  = createvar   (ncout,  stypvar,    jp_varout, ipk,    id_varout, ld_nc4=lnc4 )
    ierr  = putheadervar(ncout,  cf_uvwtfil, npiglo,    npjglo, npk       )

    dtim = getvar1d(cf_uvwtfil, cn_vtimec, npt      )
    ierr = putvar1d(ncout, dtim,           npt, 'T' )

  END SUBROUTINE CreateOutput

END PROGRAM cdfnrj_bti

PROGRAM cdftransport
   !!======================================================================
   !!                     ***  PROGRAM  cdftransport  ***
   !!=====================================================================
   !!  ** Purpose : Compute Transports across a section. 
   !!               By default, mass (Sv) and  heat(PW)/salt(kT/s) transports
   !!               are computed unless -noheat option is used (mass 
   !!               transport only).
   !!
   !!  ** Method  : The begining and end point of the section are given in 
   !!               term of F-points index. A broken line joining successive
   !!               F-points is defined between the begining and end point
   !!               of the section. Therefore each segment between F-points
   !!               is either a zonal or meridional segment corresponding to
   !!               V or U velocity component. Doing so, the volume conservation
   !!               is ensured as velocities are not interpolated, and stay 
   !!               on the native model grid. 
   !!                 The section name and the begin/end point of a section are
   !!               read from standard input, till 'EOF' is given as section
   !!               name. This make possible to give a bunch of sections in 
   !!               an ASCII files and use the < redirection.
   !!            SIGN CONVENTION : The transport is positive when the flow cross
   !!               the section to the right, negative otherwise. This depends
   !!               on the sense the section is described.  With this convention
   !!               The algebric sum of transports accross sections forming a 
   !!               closed area is 0. 
   !!            OPTIONS :
   !!               -full   : full step case
   !!               -noheat : only mass transport is computed.
   !!               -time   : specify the time frame to be used
   !!               -zlimit : transports can be computed in different depth layers
   !!                         defined by their depth limit
   !!            REQUIREMENT :
   !!               mesh-mask file are required in the current directory.
   !!            
   !!
   !! History : 2.1  : 01/2005  : J.M. Molines : Original code
   !!           2.1  : 07/2009  : R. Dussin : add cdf output
   !!           2.1  : 01/2010  : M.A. Balmaseda : Change integration signs 
   !!                             so that the transport across a segment is 
   !!                             independent of the chosen trajectory.
   !!           3.0  : 04/2011  : J.M. Molines : Doctor norm + Lic.
   !!----------------------------------------------------------------------
   !!----------------------------------------------------------------------
   !!   routines      : description
   !!  interm_pt  : choose intermediate points on a broken line.
   !!----------------------------------------------------------------------
   USE cdfio
   USE modcdfnames
   USE modutils       ! for global attribute
   !!----------------------------------------------------------------------
   !! CDFTOOLS_3.0 , MEOM 2011
   !! $Id$
   !! Copyright (c) 2011, J.-M. Molines
   !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
   !!----------------------------------------------------------------------
   IMPLICIT NONE

   INTEGER(KIND=4)                             :: jclass, jseg   ! dummy loop index
   INTEGER(KIND=4)                             :: ji, jj, jk     ! dummy loop index
   INTEGER(KIND=4), DIMENSION(:),  ALLOCATABLE :: imeter         ! limit beetween depth level, in m (nclass -1)
   INTEGER(KIND=4), DIMENSION(:),  ALLOCATABLE :: ilev0, ilev1   ! limit in levels  (nclass)
   INTEGER(KIND=4), DIMENSION(:),  ALLOCATABLE :: ipk, id_varout ! Netcdf output
   INTEGER(KIND=4)                             :: ipos           ! working integer (position of ' ' in strings)
   INTEGER(KIND=4)                             :: ncout, ierr    ! for netcdf output
   INTEGER(KIND=4)                             :: nvarout=12     ! number of values to write in cdf output
   INTEGER(KIND=4)                             :: ivtrp          ! var index of volume transport (barotrope)
   INTEGER(KIND=4)                             :: iptrp          ! var index of volume transport (barotrope)
   INTEGER(KIND=4)                             :: imtrp          ! var index of volume transport (barotrope)
   INTEGER(KIND=4)                             :: ihtrp          ! var index of heat transport (barotrope)
   INTEGER(KIND=4)                             :: istrp          ! var index of sal transport (barotrope)
   INTEGER(KIND=4)                             :: ivtrpcl        ! var index of volume transport (p. class)
   INTEGER(KIND=4)                             :: iptrpcl        ! var index of volume transport (p. class)
   INTEGER(KIND=4)                             :: imtrpcl        ! var index of volume transport (p. class)
   INTEGER(KIND=4)                             :: ihtrpcl        ! var index of heat transport (p. class)
   INTEGER(KIND=4)                             :: istrpcl        ! var index of sal transport (p. class)
   INTEGER(KIND=4)                             :: ilonmin        ! var index of starting section longitude
   INTEGER(KIND=4)                             :: ilonmax        ! var index of ending section longitude
   INTEGER(KIND=4)                             :: ilatmin        ! var index of starting section latitude
   INTEGER(KIND=4)                             :: ilatmax        ! var index of ending section latitude
   INTEGER(KIND=4)                             :: itop           ! var index of top depth class
   INTEGER(KIND=4)                             :: ibot           ! var index of bottom depth class
   INTEGER(KIND=4)                             :: ikx=1, iky=1   ! dims of netcdf output file
   INTEGER(KIND=4)                             :: numout  = 10   ! logical unit for output file (overall)
   INTEGER(KIND=4)                             :: numvtrp = 11   ! logical unit for volume transport file
   INTEGER(KIND=4)                             :: numhtrp = 12   ! logical unit for heat transport file
   INTEGER(KIND=4)                             :: numstrp = 14   ! logical unit for salt trp file 
   INTEGER(KIND=4)                             :: nclass         ! number of depth class
   INTEGER(KIND=4)                             :: narg, iargc    ! command line 
   INTEGER(KIND=4)                             :: ijarg, nxtarg  !  "       "
   INTEGER(KIND=4)                             :: npiglo, npjglo ! size of the domain
   INTEGER(KIND=4)                             :: npk, npt       ! size of the domain
   INTEGER(KIND=4)                             :: iimin, iimax   ! i-limit of the section
   INTEGER(KIND=4)                             :: ijmin, ijmax   ! j-limit of the section
   INTEGER(KIND=4)                             :: ivar, itime    ! working integer
   INTEGER(KIND=4)                             :: ii, ij, ik     ! working integer
   INTEGER(KIND=4), PARAMETER                  :: jpseg=10000    ! used for broken line algorithm
   INTEGER(KIND=4)                             :: ii0, ij0       !  "        "             "
   INTEGER(KIND=4)                             :: ii1, ij1       !  "        "             "
   INTEGER(KIND=4)                             :: iitmp, ijtmp   !  "        "             "
   INTEGER(KIND=4)                             :: np, nn         ! segment counters, 
   INTEGER(KIND=4)                             :: iist, ijst     ! local point offset for velocity
   INTEGER(KIND=4)                             :: norm_u, norm_v ! normalization factor (sign of normal transport)
   INTEGER(KIND=4)                             :: idirx, idiry   ! sense of description of the section

   REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: e1v, e2u       ! horizontal metric
   REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: e3u, e3v       ! vertical metric
   REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: glamf          ! longitudes of F points
   REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: gphif          ! latitudes of F points
   REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: zu, zut, zus   ! Zonal velocities and uT uS
   REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: zv, zvt, zvs   ! Meridional velocities and uT uS
   REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: rdum           ! dummy (1x1) array for ncdf output
   REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: zuobc, zvobc   ! arrays for OBC files (vertical slice)
   REAL(KIND=4), DIMENSION(:),     ALLOCATABLE :: tim            ! time counter
   REAL(KIND=4), DIMENSION(:),     ALLOCATABLE :: gdepw          ! depth at layer interface
   REAL(KIND=4), DIMENSION(:),     ALLOCATABLE :: e31d           ! vertical metric in case of full step
   REAL(KIND=4), DIMENSION(:),     ALLOCATABLE :: rclass         ! vertical metric in case of full step
   REAL(KIND=4), DIMENSION(2)                  :: gla, gphi      ! lon/lat of the begining/end of section (f point)
   REAL(KIND=4), DIMENSION(jpseg)              :: rxx, ryy       ! working variables
   REAL(KIND=4)                                :: rxi0, ryj0     ! working variables
   REAL(KIND=4)                                :: rxi1, ryj1     ! working variables
   REAL(KIND=4)                                :: ai, bi         ! equation of line (y=ai.x +bi)
   REAL(KIND=4)                                :: aj, bj         ! equation of line (x=aj.y +bj
   REAL(KIND=4)                                :: rd, rd1, rd2   ! distance between point, between vertical layers
   REAL(KIND=4)                                :: udum, vdum     ! dummy velocity components for tests
   REAL(KIND=4)                                :: rau0=1000      ! density of pure water (kg/m3)
   REAL(KIND=4)                                :: rcp=4000.      ! heat capacity (J/kg/K)

   ! at every model point
   REAL(KIND=8), DIMENSION(:,:),   ALLOCATABLE :: dwku,  dwkv    ! volume transport at each cell boundary
   REAL(KIND=8), DIMENSION(:,:),   ALLOCATABLE :: dwkut, dwkvt   ! heat   transport at each cell boundary
   REAL(KIND=8), DIMENSION(:,:),   ALLOCATABLE :: dwkus, dwkvs   ! salt   transport at each cell boundary
   REAL(KIND=8), DIMENSION(:,:),   ALLOCATABLE :: dwkup, dwkvp   ! volume transport in the positive direction
   REAL(KIND=8), DIMENSION(:,:),   ALLOCATABLE :: dwkum, dwkvm   !  volume transport in the negatibe direction
   REAL(KIND=8), DIMENSION(:,:,:), ALLOCATABLE :: dtrpu,  dtrpv  ! volume transport integrated in depth class
   REAL(KIND=8), DIMENSION(:,:,:), ALLOCATABLE :: dtrput, dtrpvt ! heat transport integrated in depth class
   REAL(KIND=8), DIMENSION(:,:,:), ALLOCATABLE :: dtrpus, dtrpvs ! salt transport integrated in depth class
   REAL(KIND=8), DIMENSION(:,:,:), ALLOCATABLE :: dtrpup, dtrpvp ! volume transport integrated in depth class (positive)
   REAL(KIND=8), DIMENSION(:,:,:), ALLOCATABLE :: dtrpum, dtrpvm ! volume transport integrated in depth class (negative)
   ! for a given section
   REAL(KIND=8), DIMENSION(:),     ALLOCATABLE :: dvoltrpsum     ! volume transport by depth class across section
   REAL(KIND=8), DIMENSION(:),     ALLOCATABLE :: dvoltrpsump    ! volume transport by depth class across section
   REAL(KIND=8), DIMENSION(:),     ALLOCATABLE :: dvoltrpsumm    ! volume transport by depth class across section
   REAL(KIND=8), DIMENSION(:),     ALLOCATABLE :: dheatrpsum     ! heat transport by depth class across section
   REAL(KIND=8), DIMENSION(:),     ALLOCATABLE :: dsaltrpsum     ! salt transport by depth class across section
   REAL(KIND=8), DIMENSION(:),     ALLOCATABLE :: dvolallegcl    ! over all leg volume transport by depth class
   REAL(KIND=8), DIMENSION(:),     ALLOCATABLE :: dvolallegclp   ! over all leg volume transport by depth class +
   REAL(KIND=8), DIMENSION(:),     ALLOCATABLE :: dvolallegclm   ! over all leg volume transport by depth class -
   REAL(KIND=8), DIMENSION(:),     ALLOCATABLE :: dheatallegcl   ! over all leg heat transport by depth class 
   REAL(KIND=8), DIMENSION(:),     ALLOCATABLE :: dsaltallegcl   ! over all leg salt transport by depth class 
   REAL(KIND=8), DIMENSION(jpseg)              :: dvoltrp        ! volume transport across each segment of a section
   REAL(KIND=8), DIMENSION(jpseg)              :: dvoltrpp       ! volume transport across each segment of a section
   REAL(KIND=8), DIMENSION(jpseg)              :: dvoltrpm       ! volume transport across each segment of a section
   REAL(KIND=8), DIMENSION(jpseg)              :: dheatrp        ! heat transport across each segment of a section
   REAL(KIND=8), DIMENSION(jpseg)              :: dsaltrp        ! salt transport across each segment of a section
   REAL(KIND=8)                                :: dvoltrpbrtp    ! volume transport integrated over the whole depth
   REAL(KIND=8)                                :: dvoltrpbrtpp   ! volume transport integrated over the whole depth
   REAL(KIND=8)                                :: dvoltrpbrtpm   ! volume transport integrated over the whole depth
   REAL(KIND=8)                                :: dheatrpbrtp    ! heat transport integrated over the whole depth
   REAL(KIND=8)                                :: dsaltrpbrtp    ! salt transport integrated over the whole depth
   REAL(KIND=8)                                :: dvolalleg      ! over all leg sum of volume transport
   REAL(KIND=8)                                :: dvolallegp     ! over all leg sum of volume transport +
   REAL(KIND=8)                                :: dvolallegm     ! over all leg sum of volume transport -
   REAL(KIND=8)                                :: dheatalleg     ! over all leg sum of heat transport 
   REAL(KIND=8)                                :: dsaltalleg     ! over all leg sum of salt transport 

   COMPLEX, DIMENSION(jpseg)                   :: yypt           ! array of points coordinates in a section
   COMPLEX                                     :: yypti          ! working point

   TYPE(variable), DIMENSION(:),   ALLOCATABLE :: stypvar        ! structure of output

   CHARACTER(LEN=256)                          :: cf_tfil        ! VT file  (in)
   CHARACTER(LEN=256)                          :: cf_ufil        ! U file   (in)
   CHARACTER(LEN=256)                          :: cf_vfil        ! V file   (in)
   CHARACTER(LEN=256)                          :: cf_out='section_trp.dat'  ! output file name (ASCII)
   CHARACTER(LEN=256)                          :: cf_outnc            ! output netcdf file
   CHARACTER(LEN=256)                          :: cf_vtrp='vtrp.txt'  ! output volume transport file
   CHARACTER(LEN=256)                          :: cf_htrp='htrp.txt'  ! output heat transport file
   CHARACTER(LEN=256)                          :: cf_strp='strp.txt'  ! output salt transport file
   CHARACTER(LEN=256)                          :: csection            ! section names
   CHARACTER(LEN=256)                          :: cvarname            ! variable names (root)
   CHARACTER(LEN=256)                          :: clongname           ! variable longname (root)
   CHARACTER(LEN=512)                          :: cglobal             ! global attribute
   CHARACTER(LEN=256)                          :: cldum               ! dummy char variable
   CHARACTER(LEN=256)                          :: cline               ! dummy char variable
   CHARACTER(LEN=256), DIMENSION(3)            :: cldumt              ! dummy char variable

   LOGICAL                                     :: ltest   = .FALSE.   ! flag for test case
   LOGICAL                                     :: lfull   = .FALSE.   ! flag for full step case
   LOGICAL                                     :: lheat   = .TRUE.    ! flag for skipping heat/salt transport computation
   LOGICAL                                     :: lchk    = .FALSE.   ! flag for missing files
   LOGICAL                                     :: lpm     = .FALSE.   ! flag for plus/minus transport
   LOGICAL                                     :: lobc    = .FALSE.   ! flag for obc input files
   LOGICAL                                     :: l_merid = .FALSE.   ! flag for meridional obc
   LOGICAL                                     :: l_zonal = .FALSE.   ! flag for zonal obc
   !!----------------------------------------------------------------------
   CALL ReadCdfNames()

   narg= iargc()
   ! Print usage if no argument
   IF ( narg == 0 ) THEN
      PRINT *,' usage : cdftransport [-test  u v ] [-noheat ] [-plus_minus ] [-obc]...'
      PRINT *,'                  ... [VT-file] U-file V-file [-full] |-time jt] ...'
      PRINT *,'                  ... [-time jt ] [-zlimit limits of level]'
      PRINT *,'      '
      PRINT *,'    PURPOSE :'
      PRINT *,'      Compute the transports accross a section.'
      PRINT *,'      The name of the section and the imin, imax, jmin, jmax for the section '
      PRINT *,'      is read from the standard input. To finish the program use the key name'
      PRINT *,'      ''EOF'' for the section name.'
      PRINT *,'      OBC U,V files can be used if -obc option is specified.'
      PRINT *,'      '
      PRINT *,'     ARGUMENTS :'
      PRINT *,'      [VT-file ] : netcdf file with mean values of vt, vs, ut, us for heat and'
      PRINT *,'                   salt transport. If options -noheat or -plus_minus are used'
      PRINT *,'                   this file name must be omitted.'   
      PRINT *,'      [U-file ] : netcdf file with the zonal velocity component.'
      PRINT *,'      [V-file ] : netcdf file with the meridional velocity component.'
      PRINT *,'      '
      PRINT *,'     OPTIONS :'
      PRINT *,'      [-test u v ]: use constant the u and v velocity components for sign '
      PRINT *,'                    test purpose.'
      PRINT *,'      [-noheat ]  : use when heat and salt transport are not requested.'
      PRINT *,'                    This option must come before the file names, and if used'
      PRINT *,'                    VT file must not be given.'
      PRINT *,'      [ -plus_minus or -pm ] : separate positive and negative contribution to'
      PRINT *,'                    the volume transport. This option implicitly set -noheat,'
      PRINT *,'                    and must be used before the file names.'
      PRINT *,'      [-obc ]    : indicates that input files are obc files (vertical slices)'
      PRINT *,'                    Take care that for this case, mesh files must be adapted.'
      PRINT *,'                    This option implicitly set -noheat, and must be used before'
      PRINT *,'                    the file names.'
      PRINT *,'      [-full ]   :  use for full step configurations.'
      PRINT *,'      [-time jt ]:  compute transports for time index jt. Default is 1.'
      PRINT *,'      [-zlimit list of depth] : Specify depths limits defining layers where the'
      PRINT *,'                    transports will be computed. If not used, the transports '
      PRINT *,'                    are computed for the whole water column. If used, this '
      PRINT *,'                    option must be the last on the command line.'  
      PRINT *,'      '
      PRINT *,'     REQUIRED FILES :'
      PRINT *,'      Files ',TRIM(cn_fhgr),', ',TRIM(cn_fzgr),' must be in the current directory.'
      PRINT *,'      '
      PRINT *,'     OUTPUT : '
      PRINT *,'      - Standard output '
      PRINT *,'      - ASCII file reflecting the standard output: section_trp.dat'
      PRINT *,'      - ASCII files for volume, heat and salt transport: vtrp.txt, htrp.txt '
      PRINT *,'          and strp.txt.'
      PRINT *,'      - Netcdf files for each section. name of the file is buildt'
      PRINT *,'          from section name.'
      PRINT *,'      '
      PRINT *,'     SEE ALSO :'
      PRINT *,'       cdfsigtrp'
      PRINT *,'      '
      STOP
   ENDIF

   itime  = 1
   nclass = 1
   ijarg  = 1
   CALL SetGlobalAtt(cglobal)

   ! Browse command line for arguments and/or options
   DO WHILE (ijarg <= narg )
      CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1
      SELECT CASE ( cldum )
      CASE ('-test ')
         CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) udum
         CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) vdum
         ltest = .TRUE. 

      CASE ('-full' )
         lfull = .TRUE.

      CASE ('-noheat' )  ! it must be called before the list of files
         lheat = .FALSE.

      CASE ('-time' )
         CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) itime

      CASE ('-plus_minus', '-pm' )
         lpm   = .TRUE.
         lheat = .FALSE.

      CASE ('-obc' )
         lobc   = .TRUE.
         lheat = .FALSE.

      CASE ('-zlimit' )  ! this should be the last option on the line
         nxtarg = ijarg - 1
         nclass = narg - nxtarg + 1
         ALLOCATE ( imeter(nclass -1) ) ! if no zlimit option, this array is never used
         DO jclass =1, nclass -1
            CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) imeter(jclass)
         END DO

      CASE DEFAULT
         ijarg = ijarg -1 ! re-read argument in this case
         IF ( lheat) THEN 
            CALL getarg (ijarg, cf_tfil) ; ijarg = ijarg + 1 
         ENDIF
         CALL getarg (ijarg, cf_ufil) ; ijarg = ijarg + 1 
         CALL getarg (ijarg, cf_vfil) ; ijarg = ijarg + 1 
      END SELECT
   END DO

   ! checking if all required files are available
   lchk = lchk .OR. chkfile(cn_fzgr)
   lchk = lchk .OR. chkfile(cn_fhgr)
   IF ( ltest ) THEN
      ! OK
   ELSE
      lchk = lchk .OR. chkfile(cf_ufil)
      lchk = lchk .OR. chkfile(cf_vfil)
      IF (lheat) THEN
         lchk = lchk .OR. chkfile(cf_tfil)
      ENDIF
   ENDIF
   IF ( lchk ) STOP ! missing files

   ! adjust the number of output variables according to options
   IF ( nclass > 1 ) THEN
      IF ( lheat ) THEN
         nvarout = 12
      ELSE 
         nvarout = 8
      ENDIF
      IF ( lpm ) nvarout=nvarout+4
   ELSE
      IF ( lheat ) THEN
         nvarout = 9
      ELSE 
         nvarout = 7
      ENDIF
      IF ( lpm ) nvarout=nvarout+2
   ENDIF

   ALLOCATE ( ilev0(nclass), ilev1(nclass), rclass(nclass) )
   rclass=(/(jclass, jclass=1,nclass)/)

   npiglo = getdim (cf_ufil,cn_x)
   npjglo = getdim (cf_ufil,cn_y)
   npk    = getdim (cf_ufil,cn_z)
   npt    = getdim (cf_ufil,cn_t)

   PRINT *, 'npiglo =', npiglo
   PRINT *, 'npjglo =', npjglo
   PRINT *, 'npk    =', npk
   PRINT *, 'npt    =', npt

   IF ( lobc ) THEN  ! if lobc false, l_merid and l_zonal are false (default)
      IF ( npiglo == 1 ) THEN
         l_merid=.TRUE.
         ALLOCATE (zuobc(npjglo,npk), zvobc(npjglo,npk) )
         PRINT *,' Meridional OBC'
      ENDIF

      IF ( npjglo == 1 ) THEN
         l_zonal=.TRUE.
         ALLOCATE (zuobc(npiglo,npk), zvobc(npiglo,npk) )
         PRINT *,' Zonal OBC'
      ENDIF
   ENDIF

   ALLOCATE ( e31d(npk) )

   ! define new variables for output 
   ALLOCATE ( stypvar(nvarout), ipk(nvarout), id_varout(nvarout) )
   ALLOCATE ( rdum(1,1) )

   rdum(:,:)=0.e0

   ! Allocate arrays
   ALLOCATE (   zu(npiglo,npjglo),   zv(npiglo,npjglo) )
   ALLOCATE ( dwku(npiglo,npjglo), dwkv(npiglo,npjglo) )
   ALLOCATE ( dtrpu(npiglo,npjglo,nclass), dtrpv(npiglo,npjglo,nclass))
   ALLOCATE ( dvoltrpsum(nclass), dvolallegcl(nclass) )

   IF ( lpm ) THEN 
      ALLOCATE ( dwkup(npiglo,npjglo), dwkvp(npiglo,npjglo) )
      ALLOCATE ( dwkum(npiglo,npjglo), dwkvm(npiglo,npjglo) )
      ALLOCATE ( dtrpup(npiglo,npjglo,nclass), dtrpvp(npiglo,npjglo,nclass))
      ALLOCATE ( dtrpum(npiglo,npjglo,nclass), dtrpvm(npiglo,npjglo,nclass))
      ALLOCATE ( dvoltrpsump(nclass),  dvoltrpsumm(nclass)  )
      ALLOCATE ( dvolallegclp(nclass), dvolallegclm(nclass) )
   ENDIF

   IF ( lheat ) THEN
      ALLOCATE (   zut(npiglo,npjglo),   zus(npiglo,npjglo) )
      ALLOCATE (   zvt(npiglo,npjglo),   zvs(npiglo,npjglo) )
      ALLOCATE ( dwkut(npiglo,npjglo), dwkus(npiglo,npjglo) )
      ALLOCATE ( dwkvt(npiglo,npjglo), dwkvs(npiglo,npjglo) )
      ALLOCATE ( dtrput(npiglo,npjglo,nclass), dtrpvt(npiglo,npjglo,nclass))
      ALLOCATE ( dtrpus(npiglo,npjglo,nclass), dtrpvs(npiglo,npjglo,nclass))
      ALLOCATE ( dheatrpsum(nclass), dsaltrpsum(nclass)     )
      ALLOCATE ( dheatallegcl(nclass), dsaltallegcl(nclass) )
   ENDIF
   !
   ALLOCATE ( e1v(npiglo,npjglo),e3v(npiglo,npjglo)       )
   ALLOCATE ( e2u(npiglo,npjglo),e3u(npiglo,npjglo)       )
   !
   ALLOCATE ( gphif(npiglo,npjglo) )
   ALLOCATE ( glamf(npiglo,npjglo) )
   ALLOCATE ( gdepw(npk) , tim(npt)                       )
   !
   ! read metrics and grid position
   e1v(:,:)   = getvar(cn_fhgr, cn_ve1v, 1, npiglo, npjglo)
   e2u(:,:)   = getvar(cn_fhgr, cn_ve2u, 1, npiglo, npjglo)

   glamf(:,:) = getvar(cn_fhgr, cn_glamf, 1,npiglo, npjglo)
   gphif(:,:) = getvar(cn_fhgr, cn_gphif, 1,npiglo, npjglo)

   gdepw(:) = getvare3(cn_fzgr, cn_gdepw, npk)
   e31d(:)  = getvare3(cn_fzgr, cn_ve3t,  npk) ! used only for full step

   ! look for nearest level to imeter and setup ilev0 and ilev1 (t-index of class limit)
   ik = 1
   ilev0(1) = 1 ; ilev1(nclass) = npk-1  ! default value if nclass=1

   IF ( lobc ) THEN
      ! read u, v on OBC
      IF ( l_zonal ) THEN   ! (jpiglo,jpk)
         zuobc(:,:)= getvarxz(cf_ufil, cn_vozocrtx, 1, npiglo, npk)
         zvobc(:,:)= getvarxz(cf_vfil, cn_vomecrty, 1, npiglo, npk)
      ENDIF
      IF ( l_merid ) THEN   ! (jpjglo,jpk)
         zuobc(:,:)= getvaryz(cf_ufil, cn_vozocrtx, 1, npjglo, npk)
         zvobc(:,:)= getvaryz(cf_vfil, cn_vomecrty, 1, npjglo, npk)
      ENDIF
   ENDIF

   DO jclass = 1, nclass -1
      DO WHILE ( gdepw(ik)  < imeter(jclass) )
         ik = ik +1
      END DO

      rd1 = ABS(gdepw(ik-1) - imeter(jclass) )
      rd2 = ABS(gdepw(ik  ) - imeter(jclass) )
      IF ( rd2 < rd1 ) THEN
         ilev1(jclass  ) = ik - 1  ! t-levels index
         ilev0(jclass+1) = ik
      ELSE 
         ilev1(jclass  ) = ik - 2  ! t-levels index
         ilev0(jclass+1) = ik - 1
      END IF
   END DO

   PRINT *, 'Limits :  '
   DO jclass = 1, nclass
      PRINT *, ilev0(jclass),ilev1(jclass), gdepw(ilev0(jclass)), gdepw(ilev1(jclass)+1)
   END DO

   ! compute the transports at each grid cell
   dtrpu (:,:,:)= 0.d0 ; dtrpv (:,:,:)= 0.d0    ! initialization to 0

   IF ( lpm   ) THEN
      dtrpup(:,:,:)= 0.d0 ; dtrpvp(:,:,:)= 0.d0  
      dtrpum(:,:,:)= 0.d0 ; dtrpvm(:,:,:)= 0.d0
   ENDIF
   IF ( lheat ) THEN
      dtrput(:,:,:)= 0.d0 ; dtrpvt(:,:,:)= 0.d0  
      dtrpus(:,:,:)= 0.d0 ; dtrpvs(:,:,:)= 0.d0
   ENDIF

   DO jclass = 1, nclass
      DO jk = ilev0(jclass),ilev1(jclass)
         PRINT *,'level ',jk
         ! Get velocities, temperature and salinity fluxes at jk
         IF ( ltest ) THEN
            zu (:,:) = udum ; zv (:,:) = vdum
            IF (lheat) THEN
               zut(:,:) = udum ; zvt(:,:) = vdum
               zus(:,:) = udum ; zvs(:,:) = vdum
            ENDIF
         ELSEIF ( lobc ) THEN
            IF      ( l_zonal ) THEN ; zu(:,1)=zuobc(:,jk) ; zv(:,1)=zvobc(:,jk) 
            ELSE IF ( l_merid ) THEN ; zu(1,:)=zuobc(:,jk) ; zv(1,:)=zvobc(:,jk) ; ENDIF
            ELSE
               zu (:,:) = getvar(cf_ufil, cn_vozocrtx, jk, npiglo, npjglo, ktime=itime)
               zv (:,:) = getvar(cf_vfil, cn_vomecrty, jk, npiglo, npjglo, ktime=itime)
               IF (lheat) THEN
                  zut(:,:) = getvar(cf_tfil, cn_vozout,   jk, npiglo, npjglo, ktime=itime)
                  zvt(:,:) = getvar(cf_tfil, cn_vomevt,   jk, npiglo, npjglo, ktime=itime)
                  zus(:,:) = getvar(cf_tfil, cn_vozous,   jk, npiglo, npjglo, ktime=itime)
                  zvs(:,:) = getvar(cf_tfil, cn_vomevs,   jk, npiglo, npjglo, ktime=itime)
               ENDIF
            ENDIF

            ! get e3u, e3v  at level jk
            IF ( lfull ) THEN 
               e3v(:,:) = e31d(jk)
               e3u(:,:) = e31d(jk)
            ELSE
               e3v(:,:) = getvar(cn_fzgr, 'e3v_ps', jk, npiglo, npjglo, ldiom=.TRUE.)
               e3u(:,:) = getvar(cn_fzgr, 'e3u_ps', jk, npiglo, npjglo, ldiom=.TRUE.)
            ENDIF

            dwku (:,:) = zu (:,:)*e2u(:,:)*e3u(:,:)*1.d0
            dwkv (:,:) = zv (:,:)*e1v(:,:)*e3v(:,:)*1.d0

            IF ( lpm ) THEN 
               dwkup = 0.d0 ; dwkum = 0.d0
               WHERE ( zu >= 0. ) 
                  dwkup(:,:) = zu (:,:)*e2u(:,:)*e3u(:,:)*1.d0
               ELSEWHERE 
                  dwkum(:,:) = zu (:,:)*e2u(:,:)*e3u(:,:)*1.d0
               END WHERE

               dwkvp = 0.d0 ; dwkvm = 0.d0
               WHERE ( zv >= 0. )
                  dwkvp(:,:) = zv (:,:)*e1v(:,:)*e3v(:,:)*1.d0
               ELSEWHERE
                  dwkvm(:,:) = zv (:,:)*e1v(:,:)*e3v(:,:)*1.d0
               END WHERE
            ENDIF

            IF ( lheat ) THEN
               dwkut(:,:) = zut(:,:)*e2u(:,:)*e3u(:,:)*1.d0
               dwkvt(:,:) = zvt(:,:)*e1v(:,:)*e3v(:,:)*1.d0
               dwkus(:,:) = zus(:,:)*e2u(:,:)*e3u(:,:)*1.d0
               dwkvs(:,:) = zvs(:,:)*e1v(:,:)*e3v(:,:)*1.d0
            ENDIF

            ! integrates vertically 
            dtrpu (:,:,jclass) = dtrpu (:,:,jclass) + dwku (:,:)
            dtrpv (:,:,jclass) = dtrpv (:,:,jclass) + dwkv (:,:)

            IF ( lpm   ) THEN
               dtrpup(:,:,jclass) = dtrpup(:,:,jclass) + dwkup(:,:)
               dtrpvp(:,:,jclass) = dtrpvp(:,:,jclass) + dwkvp(:,:)
               dtrpum(:,:,jclass) = dtrpum(:,:,jclass) + dwkum(:,:)
               dtrpvm(:,:,jclass) = dtrpvm(:,:,jclass) + dwkvm(:,:)
            ENDIF

            IF ( lheat ) THEN
               dtrput(:,:,jclass) = dtrput(:,:,jclass) + dwkut(:,:) * rau0*rcp
               dtrpvt(:,:,jclass) = dtrpvt(:,:,jclass) + dwkvt(:,:) * rau0*rcp
               dtrpus(:,:,jclass) = dtrpus(:,:,jclass) + dwkus(:,:)  
               dtrpvs(:,:,jclass) = dtrpvs(:,:,jclass) + dwkvs(:,:)  
            ENDIF

         END DO  ! loop to next level
      END DO    ! next class

      OPEN(numout,FILE=cf_out)
      ! also dump the results on txt files without any comments, some users  like it !
      OPEN(numvtrp,FILE=cf_vtrp)
      IF ( lheat ) THEN
         OPEN(numhtrp,FILE=cf_htrp) ; OPEN(numstrp,FILE=cf_strp)
      ENDIF

      !################################################################################
      ! enter interactive part 
      !################################################################################
      ! initialize all legs arrays and variable to 0 
      dvolalleg = 0.d0 ; dvolallegcl(:) = 0.d0
      IF ( lpm   ) THEN
         dvolallegp = 0.d0 ; dvolallegclp(:) = 0.d0
         dvolallegm = 0.d0 ; dvolallegclm(:) = 0.d0
      ENDIF
      IF ( lheat ) THEN
         dheatalleg = 0.d0 ; dheatallegcl(:) = 0.d0
         dsaltalleg = 0.d0 ; dsaltallegcl(:) = 0.d0
      ENDIF
      DO 
         PRINT *, ' Give name of section (EOF to finish)'
         READ(*,'(a)') cline
         ii = 0
         cldumt(:) = 'none'
         ipos = index(cline,' ')
         DO WHILE ( ipos > 1 )
            ii = ii + 1
            cldumt(ii) = cline(1:ipos - 1 )
            cline = TRIM ( cline(ipos+1:) )
            ipos  = index( cline,' ' )
            IF ( ii >= 3 ) EXIT
         END DO
         csection = TRIM(cldumt(1) )
         cvarname = TRIM(cldumt(2) )
         clongname = TRIM(cldumt(3) )

         IF (TRIM(csection) == 'EOF' ) THEN 
            CLOSE(numout) ; CLOSE(numvtrp) 
            IF ( lheat ) THEN 
               CLOSE(numhtrp) ; CLOSE(numstrp) 
            ENDIF
            EXIT  ! infinite DO loop
         ENDIF

         ! create output fileset
         CALL set_typvar( stypvar, csection, cvarname, clongname )
         cf_outnc   = TRIM(csection)//'_transports.nc'
         ncout      = create      (cf_outnc, 'none',    ikx,      iky, nclass, cdep='depth_class')
         ierr       = createvar   (ncout,    stypvar,   nvarout,  ipk, id_varout, cdglobal=TRIM(cglobal) )
         ierr       = putheadervar(ncout,    cf_ufil,   ikx, iky, nclass, pnavlon=rdum, pnavlat=rdum, pdep=rclass )
         tim        = getvar1d    (cf_ufil,  cn_vtimec, npt     )
         ierr       = putvar1d    (ncout,    tim,       npt, 'T')

         PRINT *, ' Give iimin, iimax, ijmin, ijmax '
         READ(*,*) iimin, iimax, ijmin, ijmax
         !! Find the broken line between P1 (iimin,ijmin) and P2 (iimax, ijmax)
         ! ... Initialization
         ii0  = iimin ; ij0  = ijmin ; ii1  = iimax ;  ij1 = ijmax
         rxi0 = ii0   ; ryj0 = ij0   ; rxi1 = ii1   ; ryj1 = ij1

         ! compute direction of integrations and signs
         !The transport across the section is the dot product of
         !integral(line){(Mx,My)*dS} 
         !Mx=integral(u*dz)  My=integral(v*dz)) and dS=(dy,-dx)}

         !By defining the direction of the integration as 
         idirx = SIGN(1,ii1-ii0) !positive to the east or if ii1=ii0
         idiry = SIGN(1,ij1-ij0) !positive to the north or if ij1=ij0

         !Then dS=(e2u*idiry,-e1v*idirx)
         !This will produce the following sign convention:
         !    West-to-est line (dx>0, dy=0)=> -My*dx (-ve for a northward flow)
         !    South-to-north   (dy>0, dx=0)=>  Mx*dy (+ve for an eastward flow)
         norm_u =  idiry
         norm_v = -idirx

         ! .. Compute equation:  ryj = aj rxi + bj [valid in the (i,j) plane]
         IF ( (rxi1 -rxi0) /=  0 ) THEN
            aj = (ryj1 - ryj0 ) / (rxi1 -rxi0)
            bj = ryj0 - aj * rxi0
         ELSE
            aj = 10000.  ! flag value
            bj = 0.
         END IF

         ! .. Compute equation:  rxi = ai ryj + bi [valid in the (i,j) plane]
         IF ( (ryj1 -ryj0) /=  0 ) THEN
            ai = (rxi1 - rxi0 ) / ( ryj1 -ryj0 )
            bi = rxi0 - ai * ryj0
         ELSE
            ai = 10000. ! flag value
            bi = 0.
         END IF

         ! ..  Compute the integer pathway: a succession of F points
         np=0
         ! .. Chose the strait line with the smallest slope
         IF (ABS(aj) <=  1 ) THEN
            ! ... Here, the best line is y(x)
            ! ... If ii1 < ii0 swap points [ always describe section from left to right ]
            IF (ii1 <  ii0 ) THEN
               iitmp = ii0   ; ijtmp = ij0
               ii0   = ii1   ; ij0   = ij1
               ii1   = iitmp ; ij1   = ijtmp
            END IF

            ! iist,ijst is the grid offset to pass from F point to either U/V point
            IF ( ij1 >= ij0 ) THEN     ! line heading NE
               iist = 1 ; ijst = 1
            ELSE                       ! line heading SE
               iist = 1 ; ijst = 0
            END IF

            ! ... compute the nearest ji point on the line crossing at ji
            DO ji=ii0, ii1
               np=np+1
               IF (np > jpseg) STOP 'np > jpseg !'
               ij=NINT(aj*ji + bj )
               yypt(np) = CMPLX(ji,ij)
            END DO
         ELSE
            ! ... Here, the best line is x(y)
            ! ... If ij1 < ij0 swap points [ always describe section from bottom to top ]
            IF (ij1 <  ij0 ) THEN
               iitmp = ii0   ; ijtmp = ij0
               ii0   = ii1   ; ij0   = ij1
               ii1   = iitmp ; ij1   = ijtmp
            END IF

            ! iist,ijst is the grid offset to pass from F point to either U/V point
            IF ( ii1 >=  ii0 ) THEN
               iist = 1 ; ijst = 1
            ELSE
               iist = 0 ; ijst = 1
            END IF

            ! ... compute the nearest ji point on the line crossing at jj
            DO jj=ij0,ij1
               np=np+1
               IF (np > jpseg) STOP 'np > jpseg !'
               ii=NINT(ai*jj + bi)
               yypt(np) = CMPLX(ii,jj)
            END DO
         END IF

         !!
         !! Look for intermediate points to be added.
         !  ..  The final positions are saved in rxx,ryy
         rxx(1) = REAL(yypt(1))
         ryy(1) = IMAG(yypt(1))
         nn     = 1

         DO jk=2,np
            ! .. distance between 2 neighbour points
            rd=ABS(yypt(jk)-yypt(jk-1))
            ! .. intermediate points required if rd > 1
            IF ( rd > 1 ) THEN
               CALL interm_pt(yypt, jk, ai, bi, aj, bj, yypti)
               nn=nn+1
               IF (nn > jpseg) STOP 'nn>jpseg !'
               rxx(nn) = REAL(yypti)
               ryy(nn) = IMAG(yypti)
            END IF
            nn=nn+1
            IF (nn > jpseg) STOP 'nn>jpseg !'
            rxx(nn) = REAL(yypt(jk))
            ryy(nn) = IMAG(yypt(jk))
         END DO
         ! record longitude and latitude of initial en endind point of the section
         gla (1) = glamf( INT(rxx(1)),  INT(ryy(1))  ) 
         gphi(1) = gphif( INT(rxx(1)),  INT(ryy(1))  ) 
         gla (2) = glamf( INT(rxx(nn)), INT(ryy(nn)) ) 
         gphi(2) = gphif( INT(rxx(nn)), INT(ryy(nn)) ) 

         ! Now extract the transport through a section 
         ! ... Check whether we need a u velocity or a v velocity
         !   Think that the points are f-points and delimit either a U segment
         !   or a V segment (iist and ijst are set in order to look for the correct
         !   velocity point on the C-grid
         PRINT *, TRIM(csection)
         PRINT *, 'IMIN IMAX JMIN JMAX', iimin, iimax, ijmin, ijmax
         WRITE(numout,*) '% Transport along a section by levels' ,TRIM(csection)
         WRITE(numout,*) '% ---- IMIN IMAX JMIN JMAX'

         dvoltrpbrtp  = 0.d0
         dvoltrpbrtpp = 0.d0
         dvoltrpbrtpm = 0.d0
         dheatrpbrtp  = 0.d0
         dsaltrpbrtp  = 0.d0
         DO jclass=1,nclass
            dvoltrpsum(jclass) = 0.d0
            IF ( lpm   ) THEN
               dvoltrpsump(jclass) = 0.d0
               dvoltrpsumm(jclass) = 0.d0
            ENDIF
            IF ( lheat ) THEN
               dheatrpsum(jclass) = 0.d0
               dsaltrpsum(jclass) = 0.d0
            ENDIF

            ! segment jseg is a line between (rxx(jseg),ryy(jseg))  and (rxx(jseg+1),ryy(jseg+1))
            DO jseg = 1, nn-1
               ii0=rxx(jseg)
               ij0=ryy(jseg)
               IF ( rxx(jseg) ==  rxx(jseg+1) ) THEN    ! meridional segment, use U velocity
                  dvoltrp(jseg)= dtrpu (ii0,ij0+ijst,jclass)*norm_u

                  IF ( lpm   ) THEN 
                     dvoltrpp(jseg)= dtrpup(ii0,ij0+ijst,jclass)*norm_u
                     dvoltrpm(jseg)= dtrpum(ii0,ij0+ijst,jclass)*norm_u
                  ENDIF

                  IF ( lheat ) THEN
                     dheatrp(jseg)= dtrput(ii0,ij0+ijst,jclass)*norm_u
                     dsaltrp(jseg)= dtrpus(ii0,ij0+ijst,jclass)*norm_u
                  ENDIF
               ELSE IF ( ryy(jseg) == ryy(jseg+1) ) THEN ! zonal segment, use V velocity
                  dvoltrp(jseg)=dtrpv (ii0+iist,ij0,jclass)*norm_v

                  IF ( lpm   ) THEN 
                     dvoltrpp(jseg)=dtrpvp(ii0+iist,ij0,jclass)*norm_v
                     dvoltrpm(jseg)=dtrpvm(ii0+iist,ij0,jclass)*norm_v
                  ENDIF

                  IF ( lheat ) THEN
                     dheatrp(jseg)=dtrpvt(ii0+iist,ij0,jclass)*norm_v
                     dsaltrp(jseg)=dtrpvs(ii0+iist,ij0,jclass)*norm_v
                  ENDIF
               ELSE
                  PRINT *,' ERROR :',  rxx(jseg),ryy(jseg),rxx(jseg+1),ryy(jseg+1) ! likely to never happen !
               END IF
               dvoltrpsum(jclass) = dvoltrpsum(jclass) + dvoltrp(jseg)
               IF ( lpm   ) THEN 
                  dvoltrpsump(jclass) = dvoltrpsump(jclass) + dvoltrpp(jseg)
                  dvoltrpsumm(jclass) = dvoltrpsumm(jclass) + dvoltrpm(jseg)
               ENDIF
               IF ( lheat ) THEN
                  dheatrpsum(jclass) = dheatrpsum(jclass) + dheatrp(jseg)
                  dsaltrpsum(jclass) = dsaltrpsum(jclass) + dsaltrp(jseg)
               ENDIF
            END DO   ! next segment

            ! Ascii outputs :      
            IF (jclass == 1 ) THEN   ! print header when it is the first class
               PRINT '(a,2f8.2,a,2f8.2)', 'FROM (LON LAT): ', gla(1),gphi(1),' TO (LON LAT) ', gla(2), gphi(2)
               WRITE(numout,*)  '% ---- LONmin LATmin LONmax LATmax'
               WRITE(numout,*)  '% Top(m)  Bottom(m)  MassTrans(Sv) HeatTrans(PW) SaltTrans(kt/s)'
               WRITE(numout,*) 0 ,iimin, iimax, ijmin, ijmax
               WRITE(numout,9003) 0. ,gla(1),gphi(1), gla(2), gphi(2)
            ENDIF

            PRINT *, gdepw(ilev0(jclass)), gdepw(ilev1(jclass)+1)
            PRINT *, ' Mass transport : ', dvoltrpsum(jclass)/1.e6,' SV'
            WRITE(numvtrp,'(e12.6)') dvoltrpsum(jclass) 
            IF ( lpm   ) THEN
               PRINT *, ' Positive Mass transport : ', dvoltrpsump(jclass)/1.e6,' SV'
               PRINT *, ' Negative Mass transport : ', dvoltrpsumm(jclass)/1.e6,' SV'
               WRITE(numout,9002) gdepw(ilev0(jclass)), gdepw(ilev1(jclass)+1), &
                    &   dvoltrpsum(jclass)/1.e6, dvoltrpsump(jclass)/1.e6, dvoltrpsumm(jclass)/1.e6
               WRITE(numvtrp,'(e12.6)') dvoltrpsump(jclass) 
               WRITE(numvtrp,'(e12.6)') dvoltrpsumm(jclass) 
            ENDIF

            IF ( lheat ) THEN
               PRINT *, ' Heat transport : ', dheatrpsum(jclass)/1.e15,' PW'
               PRINT *, ' Salt transport : ', dsaltrpsum(jclass)/1.e6,' kT/s'
               WRITE(numout,9002) gdepw(ilev0(jclass)), gdepw(ilev1(jclass)+1), &
                    &   dvoltrpsum(jclass)/1.e6, dheatrpsum(jclass)/1.e15, dsaltrpsum(jclass)/1.e6
               WRITE(numhtrp,'(e12.6)') dheatrpsum(jclass)
               WRITE(numstrp,'(e12.6)') dsaltrpsum(jclass)
            ELSE
               IF ( .NOT. lpm ) WRITE(numout,9002) gdepw(ilev0(jclass)), gdepw(ilev1(jclass)+1), dvoltrpsum(jclass)/1.e6
            ENDIF

            ! netcdf output 
            IF ( nclass > 1 ) THEN
               rdum(1,1) = REAL(dvoltrpsum(jclass)/1.e6)
               ierr = putvar(ncout,id_varout(ivtrpcl), rdum, jclass, 1, 1, ktime=itime ) 
               IF ( lpm   ) THEN
                  rdum(1,1) =  REAL(dvoltrpsump(jclass)/1.e6)
                  ierr = putvar(ncout,id_varout(iptrpcl), rdum, jclass, 1, 1, ktime=itime ) 
                  rdum(1,1) =  REAL(dvoltrpsumm(jclass)/1.e6)
                  ierr = putvar(ncout,id_varout(imtrpcl), rdum, jclass, 1, 1, ktime=itime ) 
               ENDIF
               IF ( lheat ) THEN
                  rdum(1,1) =  REAL(dheatrpsum(jclass)/1.e15)
                  ierr = putvar(ncout,id_varout(ihtrpcl), rdum, jclass, 1, 1, ktime=itime ) 
                  rdum(1,1) =  REAL(dsaltrpsum(jclass)/1.e6)
                  ierr = putvar(ncout,id_varout(istrpcl), rdum, jclass, 1, 1, ktime=itime )
               ENDIF
            ENDIF
            rdum(1,1) = REAL(gdepw(ilev0(jclass)))
            ierr = putvar(ncout,id_varout(itop), rdum, jclass, 1, 1, ktime=itime )
            rdum(1,1) = REAL(gdepw(ilev1(jclass)+1))
            ierr = putvar(ncout,id_varout(ibot), rdum, jclass, 1, 1, ktime=itime )

            dvoltrpbrtp = dvoltrpbrtp +  dvoltrpsum(jclass)
            IF ( lpm  ) THEN
               dvoltrpbrtpp = dvoltrpbrtpp + dvoltrpsump(jclass)
               dvoltrpbrtpm = dvoltrpbrtpm + dvoltrpsumm(jclass)
            ENDIF
            IF ( lheat) THEN
               dheatrpbrtp = dheatrpbrtp +  dheatrpsum(jclass)
               dsaltrpbrtp = dsaltrpbrtp +  dsaltrpsum(jclass)
            ENDIF
            ! save sum over legs
            dvolallegcl(jclass) = dvolallegcl(jclass) + dvoltrpsum(jclass)
            IF ( lpm   ) THEN
               dvolallegclp(jclass) = dvolallegclp(jclass) + dvoltrpsump(jclass)
               dvolallegclm(jclass) = dvolallegclm(jclass) + dvoltrpsumm(jclass)
            ENDIF
            IF ( lheat ) THEN
               dheatallegcl(jclass) = dheatallegcl(jclass) + dheatrpsum(jclass)
               dsaltallegcl(jclass) = dsaltallegcl(jclass) + dsaltrpsum(jclass)
            ENDIF
         END DO ! next class
         ! save sum over legs 
         dvolalleg = dvolalleg + dvoltrpbrtp
         IF ( lpm   ) THEN
            dvolallegp = dvolallegp + dvoltrpbrtpp
            dvolallegm = dvolallegm + dvoltrpbrtpm
         ENDIF
         IF ( lheat ) THEN
            dheatalleg = dheatalleg + dheatrpbrtp
            dsaltalleg = dsaltalleg + dsaltrpbrtp
         ENDIF

         IF ( nclass > 1 ) THEN 
            PRINT *, ' ====================================================='
            PRINT *, ' total Mass transport : ', dvoltrpbrtp/1.e6,' SV'
            IF ( lpm   ) THEN
               PRINT *, ' total positive transport : ', dvoltrpbrtpp/1.e6,' SV'
               PRINT *, ' total negative transport : ', dvoltrpbrtpm/1.e6,' SV'
            ENDIF
            IF ( lheat ) THEN
               PRINT *, ' total Heat transport : ', dheatrpbrtp/1.e15,' PW'
               PRINT *, ' total Salt transport : ', dsaltrpbrtp/1.e6,' kT/s'
            ENDIF
         ENDIF
         ierr = putvar0d(ncout,id_varout(ivtrp), REAL(dvoltrpbrtp/1.e6)        )
         IF ( lpm   ) THEN
            ierr = putvar0d(ncout,id_varout(iptrp), REAL(dvoltrpbrtpp/1.e6)    )
            ierr = putvar0d(ncout,id_varout(imtrp), REAL(dvoltrpbrtpm/1.e6)    )
         ENDIF
         IF ( lheat ) THEN
            ierr = putvar0d(ncout,id_varout(ihtrp), REAL(dheatrpbrtp/1.e15)    )
            ierr = putvar0d(ncout,id_varout(istrp), REAL(dsaltrpbrtp/1.e6 )    )
         ENDIF
         ierr = putvar0d(ncout,id_varout(ilonmin), REAL(gla(1))  )
         ierr = putvar0d(ncout,id_varout(ilonmax), REAL(gla(2))  )
         ierr = putvar0d(ncout,id_varout(ilatmin), REAL(gphi(1)) )
         ierr = putvar0d(ncout,id_varout(ilatmax), REAL(gphi(2)) )
         ierr = closeout(ncout)
      END DO ! infinite loop : gets out when input is EOF 


      PRINT *,'   '
      PRINT *,' Overall transports (sum of all legs done so far)'
      DO jclass = 1, nclass
         PRINT *, gdepw(ilev0(jclass)), gdepw(ilev1(jclass)+1)
         PRINT *, ' Mass transport : ', dvolallegcl(jclass)/1.e6,' SV'
         IF ( lpm   ) THEN
            PRINT *, ' Positive Mass transport : ', dvolallegclp(jclass)/1.e6,' SV'
            PRINT *, ' Negative Mass transport : ', dvolallegclm(jclass)/1.e6,' SV'
         ENDIF

         IF ( lheat ) THEN
            PRINT *, ' Heat transport : ', dheatallegcl(jclass)/1.e15,' PW'
            PRINT *, ' Salt transport : ', dsaltallegcl(jclass)/1.e6,' kT/s'
         ENDIF
      ENDDO

      IF ( nclass > 1 ) THEN
         PRINT *, ' ====================================================='
         PRINT *, '    Mass transport      : ', dvolalleg/1.e6,' SV'
         IF ( lpm ) THEN
            PRINT *, '     positive transport : ', dvolallegp/1.e6,' SV'
            PRINT *, '     negative transport : ', dvolallegm/1.e6,' SV'
         ENDIF
         IF ( lheat ) THEN
            PRINT *, '     heat transport     : ', dheatalleg/1.e15,' PW'
            PRINT *, '     salt transport     : ', dsaltalleg/1.e6,' kT/s'
         ENDIF
      ENDIF


9000  FORMAT(I4,6(f9.3,f8.4))
9001  FORMAT(I4,6(f9.2,f9.3))
9002  FORMAT(f9.0,f9.0,f9.2,f9.2,f9.2)
9003  FORMAT(f9.2,f9.2,f9.2,f9.2,f9.2)

   CONTAINS
      SUBROUTINE set_typvar ( sd_typvar, cdsection, cdvarname, cdlongname ) 
         !!---------------------------------------------------------------------
         !!                  ***  ROUTINE set_typvar  ***
         !!
         !! ** Purpose : Initialize typvar structure for netcdfoutput at a given section
         !!
         !! ** Method  : use varname longname to suffix variable name and attributes
         !!              If varname and/or logname are not given (ie 'none') take
         !!              standard default names
         !!              Netcdf id for variables are passed as global variables
         !!----------------------------------------------------------------------
         TYPE(variable), DIMENSION(:), INTENT(out) :: sd_typvar        ! structure of output
         CHARACTER(LEN=*),             INTENT(in ) :: cdsection
         CHARACTER(LEN=*),             INTENT(in ) :: cdvarname
         CHARACTER(LEN=*),             INTENT(in ) :: cdlongname
         !!
         INTEGER(KIND=4)                           :: ivar
         CHARACTER(LEN=255)                        :: csuffixvarnam
         CHARACTER(LEN=255)                        :: cprefixlongnam
         !!----------------------------------------------------------------------
         ! set suffixes according to variable/longname 
         IF ( cdvarname /= 'none' ) THEN
            csuffixvarnam = '_'//TRIM(cdvarname)
         ELSE
            csuffixvarnam = ''
         ENDIF

         IF ( cdlongname /= 'none' ) THEN
            cprefixlongnam = TRIM(cdlongname)//'_'
         ELSE
            cprefixlongnam = ''
         ENDIF

         ! set common values
         sd_typvar%rmissing_value=99999.
         sd_typvar%scale_factor= 1.
         sd_typvar%add_offset= 0.
         sd_typvar%savelog10= 0.
         sd_typvar%conline_operation='N/A'
         sd_typvar%caxis='T'

         ! set particular values for individual variables
         ivar = 1  ; ivtrp = ivar
         ipk(ivar) = 1
         sd_typvar(ivar)%cname       = 'vtrp'//TRIM(csuffixvarnam)
         sd_typvar(ivar)%cunits      = 'Sverdrup'
         sd_typvar(ivar)%valid_min   = -500.
         sd_typvar(ivar)%valid_max   =  500.
         sd_typvar(ivar)%clong_name  = TRIM(cprefixlongnam)//'Volume_Transport'
         sd_typvar(ivar)%cshort_name = 'vtrp'

         IF ( lpm ) THEN 
            ivar = ivar + 1 ; iptrp = ivar                                                  ;  imtrp = ivar+1
            ipk(ivar) = 1                                                                   ;  ipk(ivar+1) = 1
            sd_typvar(ivar)%cname       = 'ptrp'//TRIM(csuffixvarnam)                       ;  sd_typvar(ivar+1)%cname       = 'mtrp'//TRIM(csuffixvarnam)
            sd_typvar(ivar)%cunits      = 'Sverdrup'                                        ;  sd_typvar(ivar+1)%cunits      = 'Sverdrup'
            sd_typvar(ivar)%valid_min   = -500.                                             ;  sd_typvar(ivar+1)%valid_min   = -500.
            sd_typvar(ivar)%valid_max   =  500.                                             ;  sd_typvar(ivar+1)%valid_max   =  500.
            sd_typvar(ivar)%clong_name  = TRIM(cprefixlongnam)//'Positive_volume_transport' ;  sd_typvar(ivar+1)%clong_name  = TRIM(cprefixlongnam)//'Negative_volume_transport'
            sd_typvar(ivar)%cshort_name = 'ptrp'                                            ;  sd_typvar(ivar+1)%cshort_name = 'mtrp'
            ivar = ivar + 1
         ENDIF

         IF ( lheat ) THEN
            ivar = ivar + 1 ; ihtrp = ivar                                                  ;  istrp = ivar+1
            ipk(ivar) = 1                                                                   ;  ipk(ivar+1) = 1
            sd_typvar(ivar)%cname       = 'htrp'//TRIM(csuffixvarnam)                       ;  sd_typvar(ivar+1)%cname       = 'strp'//TRIM(csuffixvarnam)
            sd_typvar(ivar)%cunits      = 'PW'                                              ;  sd_typvar(ivar+1)%cunits      = 'kt/s'
            sd_typvar(ivar)%valid_min   = -1000.                                            ;  sd_typvar(ivar+1)%valid_min   = -1000.
            sd_typvar(ivar)%valid_max   =  1000.                                            ;  sd_typvar(ivar+1)%valid_max   =  1000.
            sd_typvar(ivar)%clong_name  = TRIM(cprefixlongnam)//'Heat_Transport'            ;  sd_typvar(ivar+1)%clong_name  = TRIM(cprefixlongnam)//'Salt_Transport'
            sd_typvar(ivar)%cshort_name = 'htrp'                                            ;  sd_typvar(ivar+1)%cshort_name = 'strp'
            ivar = ivar + 1
         ENDIF

         ivar = ivar + 1 ; ilonmin = ivar                                                   ;  ilonmax = ivar+1
         ipk(ivar) = 1                                                                      ;  ipk(ivar+1) = 1
         sd_typvar(ivar)%cname       = 'lonmin'//TRIM(csuffixvarnam)                        ;  sd_typvar(ivar+1)%cname       = 'lonmax'//TRIM(csuffixvarnam)
         sd_typvar(ivar)%cunits      = 'deg'                                                ;  sd_typvar(ivar+1)%cunits      = 'deg'
         sd_typvar(ivar)%valid_min   = -180.                                                ;  sd_typvar(ivar+1)%valid_min   = -180.
         sd_typvar(ivar)%valid_max   =  180.                                                ;  sd_typvar(ivar+1)%valid_max   =  180.
         sd_typvar(ivar)%clong_name  = TRIM(cprefixlongnam)//'begin_longitude'              ;  sd_typvar(ivar+1)%clong_name  = TRIM(cprefixlongnam)//'end_longitude'
         sd_typvar(ivar)%cshort_name = 'lonmin'                                             ;  sd_typvar(ivar+1)%cshort_name = 'lonmax'
         ivar = ivar + 1

         ivar = ivar + 1  ; ilatmin = ivar                                                  ;  ilatmax = ivar+1
         ipk(ivar) = 1                                                                      ;  ipk(ivar+1) = 1
         sd_typvar(ivar)%cname       = 'latmin'//TRIM(csuffixvarnam)                        ;  sd_typvar(ivar+1)%cname       = 'latmax'//TRIM(csuffixvarnam)
         sd_typvar(ivar)%cunits      = 'deg'                                                ;  sd_typvar(ivar+1)%cunits      = 'deg'
         sd_typvar(ivar)%valid_min   = -90.                                                 ;  sd_typvar(ivar+1)%valid_min   = -90.
         sd_typvar(ivar)%valid_max   =  90.                                                 ;  sd_typvar(ivar+1)%valid_max   =  90.
         sd_typvar(ivar)%clong_name  = TRIM(cprefixlongnam)//'begin_latitude'               ;  sd_typvar(ivar+1)%clong_name  = TRIM(cprefixlongnam)//'end_latitude'
         sd_typvar(ivar)%cshort_name = 'latmin'                                             ;  sd_typvar(ivar+1)%cshort_name = 'latmax'
         ivar = ivar + 1

         ivar = ivar + 1  ; itop = ivar                                                     ;  ibot = ivar+1
         ipk(ivar) = nclass                                                                 ;  ipk(ivar+1) = nclass
         sd_typvar(ivar)%cname       = 'top'                                                ;  sd_typvar(ivar+1)%cname       = 'bottom'
         sd_typvar(ivar)%cunits      = 'meters'                                             ;  sd_typvar(ivar+1)%cunits      = 'meters'
         sd_typvar(ivar)%valid_min   = 0.                                                   ;  sd_typvar(ivar+1)%valid_min   = 0.
         sd_typvar(ivar)%valid_max   = 10000.                                               ;  sd_typvar(ivar+1)%valid_max   = 10000.
         sd_typvar(ivar)%clong_name  = 'class_min_depth'                                    ;  sd_typvar(ivar+1)%clong_name  = 'class_max_depth'
         sd_typvar(ivar)%cshort_name = 'top'                                                ;  sd_typvar(ivar+1)%cshort_name = 'bottom'
         ivar = ivar + 1

         ivtrpcl = -1  ; ihtrpcl = -1 ; istrpcl = -1
         IF ( nclass > 1 ) THEN  ! define additional variable for vertical profile of transport (per class)
            ivar = ivar + 1  ; ivtrpcl = ivar
            ipk(ivar) = nclass                      
            sd_typvar(ivar)%cname       = 'vtrp_dep'//TRIM(csuffixvarnam) 
            sd_typvar(ivar)%cunits      = 'SV'  
            sd_typvar(ivar)%valid_min   = 0.       
            sd_typvar(ivar)%valid_max   = 10000.  
            sd_typvar(ivar)%clong_name  = TRIM(cprefixlongnam)//'Volume_Transport_per_class' 
            sd_typvar(ivar)%cshort_name = 'vtrp_dep'            

            IF ( lpm )  THEN
               ivar = ivar + 1  ; iptrpcl = ivar                                             ;  imtrpcl = ivar+1
               ipk(ivar) = nclass                                                            ;  ipk(ivar+1) = nclass
               sd_typvar(ivar)%cname       = 'ptrp_dep'//TRIM(csuffixvarnam)                 ;  sd_typvar(ivar+1)%cname       = 'mtrp_dep'//TRIM(csuffixvarnam)
               sd_typvar(ivar)%cunits      = 'SV'                                            ;  sd_typvar(ivar+1)%cunits      = 'SV'
               sd_typvar(ivar)%valid_min   = -500.                                           ;  sd_typvar(ivar+1)%valid_min   = -500.
               sd_typvar(ivar)%valid_max   =  500.                                           ;  sd_typvar(ivar+1)%valid_max   =  500.
               sd_typvar(ivar)%clong_name  = TRIM(cprefixlongnam)//'Positive_trp_per_class'  ;  sd_typvar(ivar+1)%clong_name  = TRIM(cprefixlongnam)//'Negative_trp_per_class'
               sd_typvar(ivar)%cshort_name = 'ptrp_dep'                                      ;  sd_typvar(ivar+1)%cshort_name = 'mtrp_dep'
               ivar = ivar + 1
            ENDIF

            IF ( lheat ) THEN
               ivar = ivar + 1  ; ihtrpcl = ivar                                              ;  istrpcl = ivar+1
               ipk(ivar) = nclass                                                             ;  ipk(ivar+1) = nclass
               sd_typvar(ivar)%cname       = 'htrp_dep'//TRIM(csuffixvarnam)                  ;  sd_typvar(ivar+1)%cname       = 'strp_dep'//TRIM(csuffixvarnam)
               sd_typvar(ivar)%cunits      = 'PW'                                             ;  sd_typvar(ivar+1)%cunits      = 'kt/s'
               sd_typvar(ivar)%valid_min   = -1000.                                           ;  sd_typvar(ivar+1)%valid_min   = -1000.
               sd_typvar(ivar)%valid_max   =  1000.                                           ;  sd_typvar(ivar+1)%valid_max   =  1000.
               sd_typvar(ivar)%clong_name  = TRIM(cprefixlongnam)//'Heat_Transport_per_class' ;  sd_typvar(ivar+1)%clong_name  = TRIM(cprefixlongnam)//'Salt_Transport_per_class'
               sd_typvar(ivar)%cshort_name = 'htrp_dep'                                       ;  sd_typvar(ivar+1)%cshort_name = 'strp_dep'
               ivar = ivar + 1
            ENDIF
         ENDIF

      END SUBROUTINE set_typvar
      SUBROUTINE interm_pt (ydpt, kk, pai, pbi, paj, pbj, ydpti)
         !!---------------------------------------------------------------------
         !!                  ***  ROUTINE nterm_pt  ***
         !!
         !! ** Purpose : Find the best intermediate points on a pathway.
         !!
         !! ** Method  : ydpt : complex vector of the positions of the nearest points
         !!               kk  : current working index
         !!          pai, pbi : slope and original ordinate of x(y)
         !!          paj, pbj : slope and original ordinate of y(x)
         !!             ydpti : Complex holding the position of intermediate point 
         !!
         !! ** Reference : 19/07/1999 : J.M. Molines in Clipper
         !!----------------------------------------------------------------------
         COMPLEX, DIMENSION(:), INTENT(in ) :: ydpt
         COMPLEX,               INTENT(out) :: ydpti
         REAL(KIND=4),          INTENT(in ) :: pai, pbi, paj, pbj
         INTEGER(KIND=4),       INTENT(in ) :: kk
         ! ... local
         COMPLEX                            :: ylptmp1, ylptmp2
         REAL(KIND=4)                       :: za0, zb0
         REAL(KIND=4)                       :: za1, zb1
         REAL(KIND=4)                       :: zd1, zd2
         REAL(KIND=4)                       :: zxm, zym
         REAL(KIND=4)                       :: zxp, zyp
         !!----------------------------------------------------------------------
         ! ... Determines whether we use y(x) or x(y):
         IF (ABS(paj) <=  1) THEN
            ! .....  use y(x)
            ! ... possible intermediate points:
            ylptmp1=ydpt(kk-1)+(1.,0.)                 ! M1 
            ylptmp2=ydpt(kk-1)+CMPLX(0.,SIGN(1.,paj))  ! M2
            !
            ! ... M1 is the candidate point:
            zxm=REAL(ylptmp1)
            zym=IMAG(ylptmp1)
            za0=paj
            zb0=pbj
            !
            za1=-1./za0
            zb1=zym - za1*zxm
            ! ... P1 is the projection of M1 on the strait line
            zxp=-(zb1-zb0)/(za1-za0)
            zyp=za0*zxp + zb0
            ! ... zd1 is the distance M1P1
            zd1=(zxm-zxp)*(zxm-zxp) + (zym-zyp)*(zym-zyp)
            !
            ! ... M2 is the candidate point:
            zxm=REAL(ylptmp2)
            zym=IMAG(ylptmp2)
            za1=-1./za0
            zb1=zym - za1*zxm
            ! ... P2 is the projection of M2 on the strait line
            zxp=-(zb1-zb0)/(za1-za0)
            zyp=za0*zxp + zb0
            ! ... zd2 is the distance M2P2
            zd2=(zxm-zxp)*(zxm-zxp) + (zym-zyp)*(zym-zyp)
            ! ... chose the smallest (zd1,zd2)
            IF (zd2 <=  zd1) THEN
               ydpti=ylptmp2   ! use M2
            ELSE
               ydpti=ylptmp1   ! use M1
            END IF
            !
         ELSE   
            ! ...  use x(y)
            ! ... possible intermediate points:
            ylptmp1=ydpt(kk-1)+CMPLX(SIGN(1.,pai),0.)  ! M1
            ylptmp2=ydpt(kk-1)+(0.,1.)                 ! M2
            ! 
            ! ... M1 is the candidate point:
            zxm=REAL(ylptmp1)
            zym=IMAG(ylptmp1)
            za0=pai
            zb0=pbi
            !
            za1=-1./za0
            zb1=zxm - za1*zym
            zyp=-(zb1-zb0)/(za1-za0)
            zxp=za0*zyp + zb0
            zd1=(zxm-zxp)*(zxm-zxp) + (zym-zyp)*(zym-zyp)
            !
            zxm=REAL(ylptmp2)
            zym=IMAG(ylptmp2)
            za1=-1./za0
            zb1=zxm - za1*zym
            zyp=-(zb1-zb0)/(za1-za0)
            zxp=za0*zyp + zb0
            zd2=(zxm-zxp)*(zxm-zxp) + (zym-zyp)*(zym-zyp)
            IF (zd2 <=  zd1) THEN
               ydpti=ylptmp2
            ELSE
               ydpti=ylptmp1
            END IF
         END IF
      END SUBROUTINE interm_pt

   END PROGRAM cdftransport

PROGRAM cdf2levitusgrid2d
   !!======================================================================
   !!                     ***  PROGRAM  cdf2levitusgrid2d  ***
   !!=====================================================================
   !!  ** Purpose : remaps (bin) 2D high resolution (finer than 1x1 deg)
   !!               fields on Levitus 2D 1x1 deg grid
   !!
   !!  ** Method  : data surface averaging
   !!               It assumes that Levitus grid SW grid cell center 
   !!               is 0.5W,89.5S 
   !!
   !! History : 3.0  : 06/2012  : N. Ferry  : Original code
   !!----------------------------------------------------------------------
   USE cdfio
   USE modcdfnames
   USE cdftools
   USE modutils
   !!----------------------------------------------------------------------
   !! CDFTOOLS_3.0 , MEOM 2012
   !! $Id$
   !! Copyright (c) 2012, J.-M. Molines
   !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
   !!----------------------------------------------------------------------
   IMPLICIT NONE

   INTEGER(KIND=4)                              :: ji, jj, jk, jt     ! dummy loop index
   INTEGER(KIND=4)                              :: jilev,jjlev        ! dummy loop index
   INTEGER(KIND=4)                              :: jvar, numvar0      ! dummy loop index
   INTEGER(KIND=4)                              :: ii, ij             ! array index (not loop)
   INTEGER(KIND=4)                              :: iilev, ijlev       ! array index (not loop)
   INTEGER(KIND=4)                              :: npiglo, npjglo     ! size of the domain
   INTEGER(KIND=4)                              :: npk, npt           ! size of the domain
   INTEGER(KIND=4)                              :: npilev, npjlev     ! size of the Levitus domain
   INTEGER(KIND=4)                              :: narg, iargc, ijarg ! browse line
   INTEGER(KIND=4)                              :: ncout              ! ncid of output file
   INTEGER(KIND=4)                              :: ierr               ! error status
   INTEGER(KIND=4)                              :: nvars              ! number of variables in the input file
   INTEGER(KIND=4)                              :: nvarsout           ! number of variables in the output file
   INTEGER(KIND=4)                              :: iimin, iimax       ! IJ coordinates of the closest points
   INTEGER(KIND=4)                              :: ijmin, ijmax       ! "      "            "
   INTEGER(KIND=4)                              :: imethod=1          ! interpolation method
   INTEGER(KIND=4)                              :: iter_shap=3        ! number of Shapiro iteration
   INTEGER(KIND=4), DIMENSION(:),   ALLOCATABLE :: ipk, id_var        ! levels and varid's of input vars
   INTEGER(KIND=4), DIMENSION(:),   ALLOCATABLE :: ipkout, id_varout  ! levels and varid's of output vars

   REAL(KIND=4)                                 :: zradius=120.       ! Distance (km) for the search bubble (FHZ)
   REAL(KIND=4)                                 :: rlon1, rlon2, rlat1, rlat2, rpos
   REAL(KIND=4)                                 :: gphitmin
   REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: e1t, e2t           ! horizontal T metrics
   REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: z_in               ! input field
   REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: z_fill             ! output 
   REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: glamt, gphit       ! T longitude latitude
   REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: rlonlev, rlatlev   ! Levitus grid longitude latitude
   REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: zbt
   REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: tmask              ! input mask
   REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: tmasklev           ! output mask
   REAL(KIND=4), DIMENSION(:),      ALLOCATABLE :: tim                ! time counter
   REAL(KIND=4), DIMENSION(:),      ALLOCATABLE :: gdept              ! depth axis

   REAL(KIND=8), DIMENSION(:,:),    ALLOCATABLE :: d_out, d_n         ! output field and weighting field

   CHARACTER(LEN=256)                           :: cf_in              ! input file name
   CHARACTER(LEN=256)                           :: cf_out             ! output file name ( output)
   CHARACTER(LEN=256)                           :: cf_levitus_mask='levitus_mask.nc'   ! Levitus mask filename
   CHARACTER(LEN=256)                           :: cv_nam             ! variable name
   CHARACTER(LEN=256)                           :: cldum              ! dummy string
   CHARACTER(LEN=256)                           :: ctcalendar         ! time attributes
   CHARACTER(LEN=256)                           :: cttitle            ! time attributes
   CHARACTER(LEN=256)                           :: ctlong_name        ! time attributes
   CHARACTER(LEN=256)                           :: ctaxis             ! time attributes
   CHARACTER(LEN=256)                           :: ctunits            ! time attributes
   CHARACTER(LEN=256)                           :: cttime_origin      ! time attributes

   CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_names          ! array of var name
   CHARACTER(LEN=6)                              :: ctyp              ! 'fill' or 'smooth' for shapiro

   TYPE(variable), DIMENSION(:),   ALLOCATABLE  :: stypvar            ! input attributes
   TYPE(variable), DIMENSION(:),   ALLOCATABLE  :: stypvarout         ! output attributes

   LOGICAL                                      :: lchk               ! missing files flag
   LOGICAL                                      :: ltest
   !!----------------------------------------------------------------------
   CALL ReadCdfNames()

   narg = iargc()
   IF ( narg < 3 ) THEN
      PRINT *,' usage : cdf2levitusgrid2d IN-file OUT-file  VAR-name2D'
      PRINT *,'      '
      PRINT *,'     PURPOSE :'
      PRINT *,'       remaps (bin) 2D high resolution (finer than 1x1 deg) '
      PRINT *,'       fields on Levitus 2D 1x1 deg grid                    '
      PRINT *,'       (does not work for vector fields)  '
      PRINT *,'       It assumes that Levitus grid SW grid cell center '
      PRINT *,'       is (0.5W,89.5S) '
      PRINT *,'      '
      PRINT *,'     ARGUMENTS :'
      PRINT *,'       IN-file  : netcdf input file ' 
      PRINT *,'       OUT-file : netcdf output file ' 
      PRINT *,'       VAR-name2D : input variable name for interpolation '
      PRINT *,'      '
      PRINT *,'     OPTIONS :'
      PRINT *,'      '
      PRINT *,'     REQUIRED FILES :'
      PRINT *,'       ',TRIM(cn_fhgr)
      PRINT *,'       ',TRIM(cn_fmsk)
      PRINT *,'       ',TRIM(cf_levitus_mask)
      PRINT *,'      '
      PRINT *,'     OUTPUT : '
      PRINT *,'       netcdf file : name given as second argument'
      PRINT *,'         variables : 2d_var_name'
      STOP
   ENDIF

   ijarg = 1
   CALL getarg(ijarg, cf_in)  ; ijarg = ijarg + 1
   CALL getarg(ijarg, cf_out) ; ijarg = ijarg + 1
   CALL getarg(ijarg, cv_nam) ; ijarg = ijarg + 1

   lchk = chkfile (cn_fhgr)
   lchk = chkfile (cn_fmsk)         .OR. lchk
   lchk = chkfile (cf_levitus_mask) .OR. lchk
   lchk = chkfile (cf_in)           .OR. lchk
   IF ( lchk ) STOP ! missing files

   npiglo = getdim(cf_in,cn_x)
   npjglo = getdim(cf_in,cn_y)
   npk    = getdim(cf_in,cn_z)
   npt    = getdim(cf_in,cn_t)
   npilev = getdim(cf_levitus_mask,cn_x)
   npjlev = getdim(cf_levitus_mask,cn_y)

   nvars = getnvar(cf_in)
   ALLOCATE (cv_names(nvars) )
   ALLOCATE (stypvar(nvars)  , stypvarout(1))
   ALLOCATE (id_var(nvars), ipk(nvars), id_varout(1), ipkout(1))
   ALLOCATE ( zbt(npiglo,npjglo) , z_in(npiglo,npjglo) )

   ! get list of variable names and collect attributes in stypvar (optional)
   cv_names(:) = getvarname(cf_in, nvars, stypvar)

   id_var(:)   = (/(jvar, jvar=1,nvars)/)

   ! ipk gives the number of level or 0 if not a T[Z]YX  variable
   ipk(:)     = getipk(cf_in, nvars)
   WHERE( ipk == 0 ) cv_names='none'
   stypvar(:)%cname = cv_names

   ! select variables to output:
   ii=1
   DO jk=1,nvars
      IF ( TRIM(cv_names(jk)) == TRIM(cv_nam) ) THEN
         ipkout(ii) = ipk(jk)
         stypvarout(ii) = stypvar(jk)
         stypvarout(ii)%rmissing_value=getspval ( cf_in, TRIM(cv_nam) )
         PRINT*, 'rmissing_value = ', stypvarout(ii)%rmissing_value
         nvarsout = ii
         numvar0 = jk
      ENDIF
   ENDDO
   z_in(:,:) = getvar(cf_in, cv_names(numvar0), 1, npiglo, npjglo)

   ! Allocate the memory
   ALLOCATE ( e1t(npiglo,npjglo), e2t(npiglo,npjglo) )
   ALLOCATE ( glamt(npiglo,npjglo), gphit(npiglo,npjglo)  )
   ALLOCATE ( d_out(npilev,npjlev) , d_n(npilev,npjlev) )
   ALLOCATE ( tmask(npiglo,npjglo) , tmasklev(npilev,npjlev))
   ALLOCATE ( rlonlev(npilev,npjlev), rlatlev(npilev,npjlev) )
   ALLOCATE ( gdept(1), tim(npt) )

   ! Read the metrics from the mesh_hgr file
   e1t = getvar(cn_fhgr, cn_ve1t, 1, npiglo, npjglo)
   e2t = getvar(cn_fhgr, cn_ve2t, 1, npiglo, npjglo)

   ! and the coordinates   from the mesh_hgr file
   glamt = getvar(cn_fhgr, cn_glamt, 1, npiglo, npjglo)
   gphit = getvar(cn_fhgr, cn_gphit, 1, npiglo, npjglo)
   gphitmin = MINVAL(gphit(:,1))
   WHERE ( glamt < 0. )
      glamt = glamt + 360. 
   END WHERE

   ! get the tmask from the byte_mask file
   tmask(:,:) = getvar(cn_fmsk, 'tmask', 1, npiglo, npjglo)

   ! get the longitude,latitude,mask from the input Levitus mask file
   rlonlev(:,:)  = getvar(cf_levitus_mask, 'nav_lon',  1, npilev, npjlev)
   rlatlev(:,:)  = getvar(cf_levitus_mask, 'nav_lat' , 1, npilev, npjlev)
   tmasklev(:,:) = getvar(cf_levitus_mask, 'mask',     1, npilev, npjlev)

   ! create output fileset
   ncout = create      (cf_out, cf_levitus_mask, npilev, npjlev, 0 ,cdlonvar='lon', cdlatvar='lat'  )
   ierr  = createvar   (ncout ,  stypvarout, 1,      ipkout,    id_varout    )
   ierr  = putheadervar(ncout ,  'dummy', npilev, npjlev, 0 , pnavlon=rlonlev, pnavlat=rlatlev )

   tim  = getvar1d(cf_in, cn_vtimec, npt     )
   ierr = putvar1d(ncout, tim,       npt, 'T')
   ierr = gettimeatt(cf_in, cn_vtimec, ctcalendar, cttitle, ctlong_name, ctaxis, ctunits, cttime_origin )
   ierr = puttimeatt(ncout, cn_vtimec, ctcalendar, cttitle, ctlong_name, ctaxis, ctunits, cttime_origin )
   ierr = putvar1d( ncout, rlonlev(:,1), npilev, 'X')
   ierr = putvar1d( ncout, rlatlev(1,:), npjlev, 'Y')

   zbt(:,:) = e1t(:,:) * e2t(:,:)    ! for surface weighting

   DO jt = 1, npt
      PRINT *,'jt = ', jt
      ! Compute spatial mean by bin
      !-----------------------------
      ! Perform bining of the input file on the Levitus grid.
      ! Input area weighted values are summed up into a Levitus 1x1 bin
      d_out(:,:) = 0.d0
      d_n  (:,:) = 0.d0
      DO jj=1,npjglo
         DO ji=1,npiglo
            iilev = MIN( 360, INT( glamt(ji,jj) ) + 1)
            ijlev = MIN (180 , INT( gphit(ji,jj) + 90. ) + 1)
            !IF ( iilev < 1 .OR. iilev .GT. 360 ) print*, 'iilev, glamt = ',iilev,glamt(ji,jj)
            !IF ( ijlev < 1 .OR. ijlev .GT. 180 ) print*, 'ijlev, gphit = ',ijlev,gphit(ji,jj)
            IF ( z_in(ji,jj) /=  stypvarout(1)%rmissing_value ) THEN
               d_out(iilev,ijlev) = d_out(iilev,ijlev) + (z_in(ji,jj)*tmask(ji,jj))*zbt(ji,jj)*tmasklev(iilev,ijlev)*1.d0
               d_n  (iilev,ijlev) = d_n (iilev,ijlev)  +              tmask(ji,jj) *zbt(ji,jj)*tmasklev(iilev,ijlev)*1.d0
            ENDIF
         ENDDO
      ENDDO

      WHERE ( d_n > 0. )
         d_out = d_out / d_n 
      ELSEWHERE
         d_out = stypvarout(1)%rmissing_value 
      END WHERE

      ! Check if there are points with missing values on Levitus grid
      IF ( COUNT( d_out == stypvarout(1)%rmissing_value .AND. tmasklev == 1. ) /=  0. ) THEN
         ALLOCATE ( z_fill(npilev,npjlev) )
         z_fill(:,:) = 0.
         !
         imethod = 1
         SELECT CASE (imethod)
         CASE ( 1 ) ! Method 1: fill missing data with shapiro
            ctyp='fill'
            iter_shap = 3  ! number of shapiro iteration
            CALL shapiro_fill_smooth ( REAL(d_out), npilev, npjlev, iter_shap, ctyp,         &
                                       stypvarout(1)%rmissing_value, INT(tmasklev), z_fill )

            DO jjlev = 1 , npjlev
               DO jilev = 1 , npilev
                  IF ( z_fill(jilev,jjlev) .NE. stypvarout(1)%rmissing_value  &
                       &                  .AND. tmasklev(jilev,jjlev) == 1    &
                       &                  .AND. d_out(jilev,jjlev) == stypvarout(1)%rmissing_value ) &
                       &  d_out(jilev,jjlev) = z_fill(jilev,jjlev)
               ENDDO
            ENDDO

         CASE ( 2 ) ! Method 2: compute with influence bubble
            ! For each point of Levitus grid, a data screening is performed 
            ! in a influence bubble of radius zradius, centered on Levitus point
            ! and the weighted average of the data in the bubble is computed
            z_fill(:,:) = 0.
            DO jjlev = 1 , npjlev-1
               DO jilev = 1 , npilev
                  ierr = 0
                  IF (  tmasklev(jilev,jjlev) == 1 .AND. d_out(jilev,jjlev) == stypvarout(1)%rmissing_value ) THEN 
                     ! for the South pole, no treatment performed if data too far from southern most orca points
                     CALL btoe(rlonlev(jilev,jjlev),rlatlev(jilev,jjlev),rlon1,rlat1,-1.2*zradius,-1.2*zradius)
                     IF ( rlat1 > gphitmin ) THEN
                        ! Search the closest point of ORCA grid for this Levitus point
                        CALL cdf_findij (rlonlev(jilev,jjlev), rlonlev(jilev,jjlev), rlatlev(jilev,jjlev), rlatlev(jilev,jjlev), &
                             &         iimin, iimax, ijmin, ijmax,cd_coord=cn_fhgr,cd_point='T',  cd_verbose='N')

                        ! Next valid grid point going northward on ORCA grid
                        ltest = .TRUE. ; ij = ijmin ; ii =  iimin
                        DO WHILE ( ij <= npjglo .AND. ltest .AND. &
                             & etobd(rlonlev(jilev,jjlev),rlatlev(jilev,jjlev),glamt(ii,ij), gphit(ii,ij)) <= zradius )
                           IF ( tmask(ii,ij) == 1 ) THEN
                              ltest = .FALSE.
                              z_fill(jilev,jjlev) = z_fill(jilev,jjlev) + &
                                   &(z_in(ii,ij)*tmask(ii,ij))*zbt(ii,ij)*tmasklev(jilev,jjlev)
                              d_n  (jilev,jjlev) = d_n (jilev,jjlev)  + &
                                   & tmask(ii,ij) *zbt(ii,ij)*tmasklev(jilev,jjlev)
                              ierr = ierr + 1
                           ENDIF
                           ij = ij + 1
                        END DO
                        ! Next valid grid point going southward on ORCA grid
                        ltest = .TRUE. ; ij = ijmin-1 ; ii =  iimin
                        DO WHILE ( ij >= 1 .AND. ltest .AND. &
                             & etobd(rlonlev(jilev,jjlev),rlatlev(jilev,jjlev),glamt(ii,ij), gphit(ii,ij)) <= zradius ) 
                           IF ( tmask(ii,ij) == 1 ) THEN
                              ltest = .FALSE.
                              z_fill(jilev,jjlev) = z_fill(jilev,jjlev) + &
                                   & (z_in(ii,ij)*tmask(ii,ij))*zbt(ii,ij)*tmasklev(jilev,jjlev)
                              d_n  (jilev,jjlev) = d_n (jilev,jjlev)  +  &
                                   & tmask(ii,ij) *zbt(ii,ij)*tmasklev(jilev,jjlev)
                              ierr = ierr + 1
                           ENDIF
                           ij = ij - 1
                        END DO
                        ! Next valid grid point going westward on ORCA grid
                        ltest = .TRUE. ; ij = ijmin ; ii =  iimin+1 ; IF ( ii > npiglo ) ii = ii - npiglo
                        DO WHILE ( ltest .AND. &
                             & etobd(rlonlev(jilev,jjlev),rlatlev(jilev,jjlev),glamt(ii,ij), gphit(ii,ij)) <= zradius ) 
                           IF ( tmask(ii,ij) == 1 ) THEN
                              ltest = .FALSE.
                              z_fill(jilev,jjlev) = z_fill(jilev,jjlev) + &
                                   & (z_in(ii,ij)*tmask(ii,ij))*zbt(ii,ij)*tmasklev(jilev,jjlev) 
                              d_n  (jilev,jjlev) = d_n (jilev,jjlev)  + &
                                   & tmask(ii,ij) *zbt(ii,ij)*tmasklev(jilev,jjlev)
                              ierr = ierr + 1
                           ENDIF
                           ii = ii + 1
                           IF ( ii > npiglo ) ii = ii - npiglo
                        END DO
                        ! Next valid grid point going eastward on ORCA grid
                        ltest = .TRUE. ; ij = ijmin ; ii =  iimin-1 ; IF ( ii < 1) ii = ii + npiglo
                        DO WHILE ( ltest .AND. &
                             & etobd(rlonlev(jilev,jjlev),rlatlev(jilev,jjlev),glamt(ii,ij), gphit(ii,ij)) <= zradius ) 
                           IF ( tmask(ii,ij) == 1 ) THEN
                              ltest = .FALSE.
                              z_fill(jilev,jjlev) = z_fill(jilev,jjlev) + &
                                   & (z_in(ii,ij)*tmask(ii,ij))*zbt(ii,ij)*tmasklev(jilev,jjlev) 
                              d_n  (jilev,jjlev) = d_n (jilev,jjlev)  + &
                                   & tmask(ii,ij) *zbt(ii,ij)*tmasklev(jilev,jjlev)
                              ierr = ierr + 1
                           ENDIF
                           ii = ii - 1
                           IF ( ii < 1 ) ii = ii + npiglo
                        END DO

                        ! computing d_out value
                        IF ( z_fill(jilev,jjlev) .NE. stypvarout(1)%rmissing_value &
                             & .AND. d_n(jilev,jjlev) > 0 &
                             & .AND. d_out(jilev,jjlev) == stypvarout(1)%rmissing_value ) &
                             &  d_out(jilev,jjlev) = z_fill(jilev,jjlev) / d_n(jilev,jjlev)

                     ENDIF ! rlat1 > gphitmin

                  ENDIF ! tmasklev(jilev,jjlev) == 1 .AND. d_out(jilev,jjlev) == stypvarout(1)%rmissing_value

               ENDDO
            ENDDO

            ! Case of the North Pole
            ijlev = npjlev
            DO jilev = 1 , npilev
               ierr = 0

               IF (  tmasklev(jilev,ijlev) == 1 .AND. d_out(jilev,ijlev) == stypvarout(1)%rmissing_value ) THEN

                  ! Search the closest point of ORCA grid for this Levitus point
                  CALL cdf_findij (rlonlev(jilev,ijlev), rlonlev(jilev,ijlev), rlatlev(jilev,ijlev), rlatlev(jilev,ijlev), &
                       & iimin, iimax, ijmin, ijmax,cd_coord=cn_fhgr,cd_point='T', cd_verbose='N')

                  ! Next valid grid point going southward on ORCA grid
                  ltest = .TRUE. ; ij = ijmin ; ii =  iimin
                  DO WHILE ( ij >= 1 .AND. ltest .AND. &
                       & etobd(rlonlev(jilev,ijlev),rlatlev(jilev,ijlev),glamt(ii,ij), gphit(ii,ij)) <= zradius ) 
                     IF ( tmask(ii,ij) == 1 ) THEN
                        ltest = .FALSE.
                        z_fill(jilev,ijlev) = z_fill(jilev,ijlev) + &
                             & (z_in(ii,ij)*tmask(ii,ij))*zbt(ii,ij)*tmasklev(jilev,ijlev) 
                        d_n  (jilev,ijlev) = d_n (jilev,ijlev)  +  &
                             & tmask(ii,ij) *zbt(ii,ij)*tmasklev(jilev,ijlev)
                        ierr = ierr + 1
                     ENDIF
                     ij = ij - 1
                  END DO
                  ! Next valid grid point going westward on ORCA grid
                  ltest = .TRUE. ; ij = ijmin ; ii =  iimin+1 ; IF ( ii > npiglo) ii = ii - npiglo
                  DO WHILE ( ltest .AND. &
                       & etobd(rlonlev(jilev,ijlev),rlatlev(jilev,ijlev),glamt(ii,ij), gphit(ii,ij)) <= zradius ) 
                     IF ( tmask(ii,ij) == 1 ) THEN
                        ltest = .FALSE.
                        z_fill(jilev,ijlev) = z_fill(jilev,ijlev) + &
                             & (z_in(ii,ij)*tmask(ii,ij))*zbt(ii,ij)*tmasklev(jilev,ijlev) 
                        d_n  (jilev,ijlev) = d_n (jilev,ijlev)  + &
                             & tmask(ii,ij) *zbt(ii,ij)*tmasklev(jilev,ijlev)
                        ierr = ierr + 1
                     ENDIF
                     ii = ii + 1
                     IF ( ii > npiglo ) ii = ii - npiglo
                  END DO
                  ! Next valid grid point going eastward on ORCA grid
                  ltest = .TRUE. ; ij = ijmin ; ii =  iimin-1 ; IF ( ii < 1 ) ii = ii + npiglo
                  DO WHILE ( ltest .AND. &
                       & etobd(rlonlev(jilev,ijlev),rlatlev(jilev,ijlev),glamt(ii,ij), gphit(ii,ij)) <= zradius ) 
                     IF ( tmask(ii,ij) == 1 ) THEN
                        ltest = .FALSE.
                        z_fill(jilev,ijlev) = z_fill(jilev,ijlev) + &
                             & (z_in(ii,ij)*tmask(ji,ij))*zbt(ii,ij)*tmasklev(jilev,ijlev) 
                        d_n  (jilev,ijlev) = d_n (jilev,ijlev)  + &
                             & tmask(ii,ij) *zbt(ii,ij)*tmasklev(jilev,ijlev)
                        ierr = ierr + 1
                     ENDIF
                     ii = ii - 1 ;  IF ( ii < 1 ) ii = ii + npiglo
                  END DO
                  ! Going "northward" and crossing the pole
                  ltest = .TRUE.
                  rpos = 1.
                  ij = ijmin + 1 * rpos ; ii =  iimin
                  IF ( ij > npjglo ) THEN
                     ii = ii + npiglo/2 ; IF ( ii > npiglo ) ii = ii - npiglo
                     rpos = -1.
                     ij = ij + 1 * rpos
                  ENDIF
                  DO WHILE ( ij >= 1 .AND. ltest .AND. &
                       & etobd(rlonlev(jilev,ijlev),rlatlev(jilev,ijlev),glamt(ii,ij), gphit(ii,ij)) <= zradius )
                     IF ( tmask(ii,ij) == 1 ) THEN
                        ltest = .FALSE.
                        z_fill(jilev,ijlev) = z_fill(jilev,ijlev) + &
                             &(z_in(ii,ij)*tmask(ii,ij))*zbt(ii,ij)*tmasklev(jilev,ijlev) 
                        d_n  (jilev,ijlev) = d_n (jilev,ijlev)  + &
                             & tmask(ii,ij) *zbt(ii,ij)*tmasklev(jilev,ijlev)
                        ierr = ierr + 1
                     ENDIF
                     ij = ij + 1 * rpos
                     IF ( ij > npjglo ) THEN
                        ii = ii + npiglo/2 ; IF ( ii > npiglo ) ii = ii - npiglo
                        rpos = -1.
                        ij = ij + 1 * rpos
                     ENDIF
                  END DO

                  ! computing d_out value
                  IF ( z_fill(jilev,ijlev) .NE. stypvarout(1)%rmissing_value  &
                       & .AND. d_n(jilev,ijlev) > 0  ) &
                       &  d_out(jilev,ijlev) = z_fill(jilev,ijlev) / d_n(jilev,ijlev)

               ENDIF

            ENDDO


         CASE DEFAULT 
            PRINT *, ' METHOD ', imethod ,'is not recognized in this program'
            STOP

         END SELECT  ! imethod
         IF ( ALLOCATED(z_fill) ) DEALLOCATE( z_fill )

      ENDIF !  filling points
      ! ----------------------------------------------------------------------------------------
      ! write 
      ierr = putvar(ncout, id_varout(1), REAL(d_out(:,:)), 1, npilev, npjlev, ktime=jt)

   END DO ! loop on time

   ierr = closeout(ncout)

CONTAINS

   REAL(KIND=4) FUNCTION etobd(plonr, platr, plon, plat)
      !!---------------------------------------------------------------------
      !!                  ***  FUNCTION etobd  ***
      !!
      !! ** Purpose :
      !!           Compute the beta plane distance between two lon/lat values 
      !!
      !! ** Method  : 
      !!           Return the distance (km) between 2 points given in the
      !!           arguments with their latitudes and longitudes
      !!----------------------------------------------------------------------
      REAL(KIND=4), INTENT(in) :: plonr, platr, plon, plat  ! lon/lat of the 2 input points

      REAL(KIND=8), PARAMETER  :: dp_p1 = 1.745329D-02  ! radians per degree
      REAL(KIND=8), PARAMETER  :: dp_p2 = 111.1940D0    ! dp_p1 * earth radius in km (6370.949)

      REAL(KIND=8)             :: dl_rx, dl_ry          ! working double prec variables
      REAL(KIND=8)             :: dl_r0
      REAL(KIND=8)             :: dl_r1, dl_r2
      !!----------------------------------------------------------------------
      dl_r0 = DBLE(plonr) ; IF ( dl_r0 < 0.d0 ) dl_r0 = dl_r0 + 360.d0
      dl_r1 = DBLE(plon ) ; IF ( dl_r1 < 0.d0 ) dl_r1 = dl_r1 + 360.d0

      dl_rx = dl_r1 - dl_r0
      IF ( dl_rx > 180. ) THEN
         dl_rx = dl_rx - 360.d0
      ELSE IF ( dl_rx < -180.d0 ) THEN
         dl_rx = dl_rx + 360.d0
      ELSE IF ( ABS(dl_rx) == 180.d0 ) THEN
         dl_rx = 180.d0
      ENDIF
      dl_r2 = DBLE(plat) - DBLE(platr)

      dl_rx = dp_p2 * dl_rx * COS(dp_p1*platr)
      dl_ry = dp_p2 * dl_r2

      etobd = REAL(SQRT(dl_rx*dl_rx + dl_ry*dl_ry))

   END FUNCTION etobd


   SUBROUTINE btoe(plonr, platr, plon, plat, plx, ply)
     !!---------------------------------------------------------------------
     !!                  ***  ROUTINE btoe  ***
     !!
     !! ** Purpose :  Return position (lon/lat) of a point located at
     !!               a given distance from the original point
     !!
     !! ** Method  :  Trigo ... 
     !!
     !!----------------------------------------------------------------------
     REAL(KIND=4), INTENT(in)  :: plonr, platr, plx, ply
     REAL(KIND=4), INTENT(out) :: plon, plat

     REAL(KIND=8), PARAMETER   :: dp_p1= 1.745329D-02  ! radians per degree
     REAL(KIND=8), PARAMETER   :: dp_p2= 111.1940D0    ! dp_p1 * earth radius in km (6370.949)
     REAL(KIND=8)              :: dl_rx, dl_ry
     REAL(KIND=8)              :: dl_r0
     REAL(KIND=8)              :: dl_r1, dl_r2, dl_r3
     !!----------------------------------------------------------------------
      dl_r0 = DBLE(plonr) ; IF ( dl_r0 < 0.d0 ) dl_r0 = dl_r0 + 360.d0
      dl_rx = DBLE(plx  )
      dl_r2 = DBLE(platr)
      dl_r1 = dl_r0 + dl_rx / ( dp_p2 * COS(dp_p1*dl_r2) )
      dl_r3 = dl_r2 + ply   / dp_p2
      plon  = REAL(dl_r1)
      IF ( plon <    0. ) plon = plon + 360.
      IF ( plon >= 360. ) plon = plon - 360.
      plat = REAL(dl_r3)
      IF ( plat >  90. ) plat =  90.
      IF ( plat < -90. ) plat = -90.

   END SUBROUTINE btoe

END PROGRAM cdf2levitusgrid2d

PROGRAM cdfrichardson
  !!======================================================================
  !!                     ***  PROGRAM  cdfrichardson  ***
  !!=====================================================================
  !!  ** Purpose : Compute the Richardson NUmber
  !!               using same algoritm than NEMO
  !!
  !!  ** Method  : Try to avoid 3 d arrays : work with 2 levels at a time
  !!              The Richardson number is computed as 
  !!              Ri = N^2/ dz(U)**2 
  !!              and dz(U)** [ squared vertical velocity derivative] is :
  !!              dz(ub)*dz(ub) + dz(vb)*dz(vb)
  !!
  !! History : 2.0  : 11/2004  : J.M. Molines : Original code
  !!           2.1  : 04/2005  : J.M. Molines : use cdfio
  !!           3.0  : 12/2010  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames   ! for cdf variable names
  USE eos
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class derived_fields
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                              :: ji, jj, jk, jt           ! dummy loop index
  INTEGER(KIND=4)                              :: it                       ! time index for vvl
  INTEGER(KIND=4)                              :: ierr                     ! working integer
  INTEGER(KIND=4)                              :: narg, iargc, ijarg       ! 
  INTEGER(KIND=4)                              :: npiglo, npjglo, npk, npt ! size of the domain
  INTEGER(KIND=4)                              :: iup = 1, idown = 2, itmp ! for swapping the levels
  INTEGER(KIND=4)                              :: ncout                    ! ncid of output file
  INTEGER(KIND=4), DIMENSION(2)                :: ipk, id_varout           ! level and id of output variables

  REAL(KIND=4)                                 :: rspval=0.                ! missing_value
  REAL(KIND=4)                                 :: zsps                     ! missing_value for salinity
  REAL(KIND=4)                                 :: zcoef, zdku, zdkv, zzri  ! working real
  REAL(KIND=4), DIMENSION (:),     ALLOCATABLE :: gdep, e3w1d              ! depth and metrics
  REAL(KIND=4), DIMENSION (:,:),   ALLOCATABLE :: zri                      ! Richardson number
  REAL(KIND=4), DIMENSION (:,:),   ALLOCATABLE :: zmask, e3w               ! mask and metric
  REAL(KIND=4), DIMENSION (:,:,:), ALLOCATABLE :: ztemp, zsal, zwk         ! Array to read 2 layer of data
  REAL(KIND=4), DIMENSION (:,:,:), ALLOCATABLE :: zu, zv                   ! Array to read 2 layer of velocities

  REAL(KIND=8), DIMENSION (:),     ALLOCATABLE :: dtim                     ! time

  CHARACTER(LEN=256)                           :: cldum                    ! dummy char variable
  CHARACTER(LEN=256)                           :: cf_tfil                  ! input T file name
  CHARACTER(LEN=256)                           :: cf_sfil                  ! input S file name (option)
  CHARACTER(LEN=256)                           :: cf_ufil                  ! input U file name
  CHARACTER(LEN=256)                           :: cf_vfil                  ! input V file name
  CHARACTER(LEN=256)                           :: cf_out = 'richardson.nc' ! output file name
  CHARACTER(LEN=256)                           :: cglobal                  ! global attribute
  CHARACTER(LEN=80)                            :: cf_e3w                   ! file name for e3w in case of vvl
  CHARACTER(LEN=80)                            :: cv_ric  = 'voric'        ! cdf variable name for N2
  CHARACTER(LEN=80)                            :: cv_dep                   ! cdf variable name for depth

  TYPE(variable), DIMENSION(1)                 :: stypvar                  ! variable attribute

  LOGICAL                                      :: l_w    = .FALSE.         ! flag for vertical location of ric
  LOGICAL                                      :: lchk                     ! check missing files
  LOGICAL                                      :: lfull  = .FALSE.         ! full step flag
  LOGICAL                                      :: lnc4   = .FALSE.         ! Use nc4 with chunking and deflation
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfrichardson  -t T-file -u U-file -v V-file [-s S-file]...'
     PRINT *,'          ...  [-W] [-full] [-o OUT-file] [-nc4] [-vvl W-file] '
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the Richardson Number (Ri) according to temperature,' 
     PRINT *,'       salinity and velocity components, given in the input files.'
     PRINT *,'      '
     PRINT *,'       Richardson''s number is the ratio N2/(Vertical Shear)^2, N being'
     PRINT *,'       the Brunt-Vaissala frequency.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -t T-file : input gridT file for temperature and salinity' 
     PRINT *,'           If salinity not in T-file use -s option.'
     PRINT *,'       -u U-file : input gridU file for zonal velocity component'
     PRINT *,'       -v V-file : input gridV file for meridional velocity component'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-s S-file ]: specify salinity file if not T-file.'
     PRINT *,'       [-W ] : keep N2 at W points. Default is to interpolate N2 at T points' 
     PRINT *,'             on the vertical'
     PRINT *,'       [-full ] : indicate a full step configuration instead of the default'
     PRINT *,'             partial steps.'
     PRINT *,'       [-o OUT-file ]: specify output file instead of ',TRIM(cf_out)
     PRINT *,'       [-nc4 ]  : Use netcdf4 output with chunking and deflation level 1.'
     PRINT *,'             This option is effective only if cdftools are compiled with'
     PRINT *,'             a netcdf library supporting chunking and deflation.'
     PRINT *,'       [-vvl W-file ]: use time-varying vertical metrics. W-file holds the'
     PRINT *,'             time-varying e3w vertical metrics.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ',TRIM(cn_fzgr),' is needed for this program.' 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) ,' unless option -o is used.'
     PRINT *,'       variables : ', TRIM(cv_ric)
     PRINT *,'      '
     STOP 
  ENDIF

  cglobal = 'Partial step computation'

  ijarg = 1
  cf_sfil='none'
  DO WHILE ( ijarg <= narg ) 
     CALL getarg(ijarg, cldum) ; ijarg = ijarg + 1
     SELECT CASE (cldum)
     CASE ( '-t'   ) ; CALL getarg (ijarg, cf_tfil) ; ijarg = ijarg + 1
     CASE ( '-u'   ) ; CALL getarg (ijarg, cf_ufil) ; ijarg = ijarg + 1
     CASE ( '-v'   ) ; CALL getarg (ijarg, cf_vfil) ; ijarg = ijarg + 1
        ! options
     CASE ( '-s'   ) ; CALL getarg (ijarg, cf_sfil) ; ijarg = ijarg + 1
     CASE ('-W'    ) ; l_w   = .TRUE.
     CASE ('-full' ) ; lfull = .TRUE. ; cglobal = 'full step computation'
     CASE ( '-nc4' ) ; lnc4  = .TRUE.
     CASE ( '-o'   ) ; CALL getarg (ijarg, cf_out) ; ijarg = ijarg + 1
     CASE ( '-vvl' ) ; lg_vvl= .TRUE.
        ;              CALL getarg (ijarg, cf_e3w) ; ijarg = ijarg + 1
     CASE DEFAULT    ; PRINT *,' ERROR : ',TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  END DO

  IF ( cf_sfil == 'none' ) cf_sfil=cf_tfil

  lchk = chkfile (cn_fzgr )
  lchk = lchk .OR. chkfile (cf_tfil  )
  lchk = lchk .OR. chkfile (cf_sfil  )
  lchk = lchk .OR. chkfile (cf_ufil  )
  lchk = lchk .OR. chkfile (cf_vfil  )
  IF ( lg_vvl ) THEN
     lchk = lchk .OR. chkfile (cf_e3w  )
  ENDIF
  IF ( lchk   ) STOP 99  ! missing files  

  ! Look for Missing value for salinity
  zsps = getspval(cf_sfil, cn_vosaline)


  IF ( lg_vvl ) THEN
     cn_fe3w = cf_e3w
     cn_ve3w = cn_ve3wvvl
  ENDIF

  npiglo = getdim (cf_tfil, cn_x)
  npjglo = getdim (cf_tfil, cn_y)
  npk    = getdim (cf_tfil, cn_z)
  npt    = getdim (cf_tfil, cn_t)

  PRINT *, 'npiglo =', npiglo
  PRINT *, 'npjglo =', npjglo
  PRINT *, 'npk    =', npk
  PRINT *, 'npt    =', npt

  ALLOCATE (ztemp(npiglo,npjglo,2), zsal(npiglo,npjglo,2) )
  ALLOCATE (zu(npiglo,npjglo,2),      zv(npiglo,npjglo,2) )
  ALLOCATE (zwk(npiglo,npjglo,2), zmask(npiglo,npjglo)    )
  ALLOCATE (zri(npiglo,npjglo), e3w(npiglo,npjglo)        )
  ALLOCATE (gdep(npk), dtim(npt)               )
  IF ( lfull ) ALLOCATE (e3w1d(npk) )

  zwk(:,:,:) = rspval
  zri(:,:)   = rspval

  IF (l_w) THEN ; cv_dep = cn_gdepw
  ELSE          ; cv_dep = cn_gdept
  ENDIF

  gdep(:) = getvare3(cn_fzgr, cv_dep, npk) 

  CALL CreateOutput

  IF ( lfull )  e3w1d(:) = getvare3(cn_fzgr, cn_ve3w1d, npk)

  gdep(:) = getvare3(cn_fzgr, cn_gdepw, npk)

  DO jt=1,npt
     IF ( lg_vvl ) THEN ; it=jt
     ELSE               ; it=1
     ENDIF
     !  2 levels of T and S are required : iup,idown (with respect to W level)
     !  Compute from bottom to top (for vertical integration)
     ztemp(:,:,idown) = getvar(cf_tfil, cn_votemper,  npk-1, npiglo, npjglo, ktime=jt)
     zsal( :,:,idown) = getvar(cf_sfil, cn_vosaline,  npk-1, npiglo, npjglo, ktime=jt)
     zu( :,:,idown)   = getvar(cf_ufil, cn_vozocrtx,  npk-1, npiglo, npjglo, ktime=jt)
     zv( :,:,idown)   = getvar(cf_vfil, cn_vomecrty,  npk-1, npiglo, npjglo, ktime=jt)

     DO jk = npk-1, 2, -1 
        PRINT *,'level ',jk
        zmask(:,:)=1.0
        WHERE(zsal(:,:,idown) == zsps ) zmask = 0.0
        ztemp(:,:,iup)= getvar(cf_tfil, cn_votemper, jk-1, npiglo, npjglo, ktime=jt)
        zsal(:,:,iup) = getvar(cf_sfil, cn_vosaline, jk-1, npiglo, npjglo, ktime=jt)
        zu( :,:,iup)  = getvar(cf_ufil, cn_vozocrtx, jk-1, npiglo, npjglo, ktime=jt)
        zv( :,:,iup)  = getvar(cf_vfil, cn_vomecrty, jk-1, npiglo, npjglo, ktime=jt)

        IF ( lfull ) THEN ; e3w(:,:) = e3w1d(jk)
        ELSE              ; e3w(:,:) = getvar(cn_fe3w, cn_ve3w  , jk, npiglo, npjglo,ktime=it, ldiom=.NOT.lg_vvl )
        ENDIF

        zwk(:,:,iup) = eosbn2(ztemp, zsal, gdep(jk), e3w, npiglo, npjglo ,iup, idown)* zmask(:,:)

        DO jj = 2, npjglo - 1
           DO ji = 2, npiglo - 1
              zcoef = 0.5 / e3w(ji,jj)
              !                                            ! shear of horizontal velocity
              zdku = zcoef * (  zu(ji-1,jj,iup  ) + zu(ji,jj,iup    )   &
                   &           -zu(ji-1,jj,idown) - zu(ji,jj,idown  )  )
              zdkv = zcoef * (  zv(ji,jj-1,iup  ) + zv(ji,jj,iup    )   &
                   &           -zv(ji,jj-1,idown) - zv(ji,jj,idown  )  )
              !                                            ! richardson number (minimum value set to zero)
              zzri = zwk(ji,jj,iup) / ( zdku*zdku + zdkv*zdkv + 1.e-20 )
              zwk(ji,jj,iup) = MAX( zzri, 0.e0 )
           ENDDO
        ENDDO

        IF ( .NOT. l_w ) THEN
           ! now put zri at T level (k )
           WHERE ( zwk(:,:,idown) == 0 )  ; zri(:,:) =  zwk(:,:,iup)
        ELSEWHERE                      ; zri(:,:) = 0.5 * ( zwk(:,:,iup) + zwk(:,:,idown) ) * zmask(:,:)
        END WHERE
     ELSE
        zri(:,:) = zwk(:,:,iup)
     ENDIF

     WHERE ( zri < 0  .AND. zri /= rspval )  zri = rspval
     ierr = putvar(ncout, id_varout(1), zri, jk, npiglo, npjglo, ktime=jt )
     itmp = idown ; idown = iup ; iup = itmp

  END DO  ! loop to next level
END DO

ierr = closeout(ncout)
CONTAINS

SUBROUTINE CreateOutput
  !!---------------------------------------------------------------------
  !!                  ***  ROUTINE CreateOutput  ***
  !!
  !! ** Purpose :  Create netcdf output file(s) 
  !!
  !! ** Method  :  Use stypvar global description of variables
  !!
  !!----------------------------------------------------------------------
 ipk(1)                       = npk  !  3D
 stypvar(1)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
 stypvar(1)%cname             = cv_ric
 stypvar(1)%cunits            = 'no'
 stypvar(1)%rmissing_value    = rspval
 stypvar(1)%valid_min         = 0.
 stypvar(1)%valid_max         = 50000.
 stypvar(1)%clong_name        = 'Richardson Number'
 stypvar(1)%cshort_name       = cv_ric
 stypvar(1)%conline_operation = 'N/A'
 stypvar(1)%caxis             = 'TZYX'

 ! create output fileset
 ncout = create      (cf_out,   cf_tfil,  npiglo, npjglo, npk                             , ld_nc4=lnc4 )
 ierr  = createvar   (ncout ,   stypvar, 1,      ipk,    id_varout, cdglobal=TRIM(cglobal), ld_nc4=lnc4 )
 ierr  = putheadervar(ncout,    cf_tfil,  npiglo, npjglo, npk, pdep=gdep)

 dtim = getvar1d(cf_tfil, cn_vtimec, npt   )
 ierr = putvar1d(ncout,  dtim,      npt,'T')

END SUBROUTINE CreateOutput


END PROGRAM

PROGRAM cdfdiv
  !!======================================================================
  !!                     ***  PROGRAM  cdfdiv  ***
  !!=====================================================================
  !!  ** Purpose : Compute the divergence for given gridU gridV files 
  !!               and variables
  !!
  !!  ** Method  : Use the equation on continuity: Integrate the 
  !!               horizontal divergence from bottom to the top.
  !!               ( Use the same routines than in the NEMO code )
  !!
  !! History :  3.0  : 10/2011  : P. Mathiot : first version, based on cdfw.f90
  !!          
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                              :: ji, jj, jk, jt     ! dummy loop index
  INTEGER(KIND=4)                              :: npiglo, npjglo     ! size of the domain
  INTEGER(KIND=4)                              :: npk, npt           ! size of the domain
  INTEGER(KIND=4)                              :: narg, iargc, ijarg ! browse line
  INTEGER(KIND=4)                              :: ncout              ! ncid of output file
  INTEGER(KIND=4)                              :: ierr               ! error status
  INTEGER(KIND=4)                              :: itmp               ! working integer for level swap
  INTEGER(KIND=4), DIMENSION(1)                :: ipk, id_varout     ! levels and varid's of output vars

  REAL(KIND=4), DIMENSION(:,:,:), ALLOCATABLE  :: wn                 ! vertical velocity on the top
  !                                                                  ! and bottom of a cell.
  !                                                                  ! wn(top) is computed
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: e1t, e2t           ! horizontal T metrics
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: e1v, e2u           ! horizontal V and U metrics
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: e3v, e3u, e3t      ! vertical metrics
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: glamt, gphit       ! T longitude latitude
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: un, vn             ! horizontal velocity component
  REAL(KIND=8), DIMENSION(:,:),    ALLOCATABLE :: hdivn              ! horizontal divergence
  REAL(KIND=4), DIMENSION(:),      ALLOCATABLE :: gdepw              ! depth of W points
  REAL(KIND=4), DIMENSION(:),      ALLOCATABLE :: tim                ! time counter
  REAL(KIND=4), DIMENSION(:),      ALLOCATABLE :: e31d               ! vertical metrics (full step)

  CHARACTER(LEN=256)                           :: cf_ufil            ! U file name
  CHARACTER(LEN=256)                           :: cf_vfil            ! V file name
  CHARACTER(LEN=256)                           :: cf_out='div.nc'      ! W file name ( output)
  CHARACTER(LEN=256)                           :: cldum              ! dummy string

  TYPE(variable), DIMENSION(1)                 :: stypvar            ! output attributes

  LOGICAL                                      :: lchk               ! missing files flag
  LOGICAL                                      :: lfull=.FALSE.      ! full step flag
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg < 2 ) THEN
     PRINT *,' usage : cdfdiv U-file V-file [ U-var V-var ] [ -full ]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the vertical velocity from the vertical integration of'
     PRINT *,'       of the horizontal divergence of the velocity. '
     PRINT *,'       Limitation: coded only for C grid (be carefful with forcing field)' 
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       U-file : netcdf file with the zonal velocity component.' 
     PRINT *,'       V-file : netcdf file with the meridional velocity component.' 
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [ U-var V-var ] : names of the zonal and meridional velocity '
     PRINT *,'                         components. Default are ', TRIM(cn_vozocrtx),' and ', TRIM(cn_vomecrty)
     PRINT *,'       [ -full ] : in case of full step configuration. Default is partial step.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ',TRIM(cn_fhgr),' and ',TRIM(cn_fzgr) 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : div (s-1)'
     STOP
  ENDIF

  ijarg = 1
  CALL getarg(ijarg, cf_ufil) ; ijarg = ijarg + 1
  CALL getarg(ijarg, cf_vfil) ; ijarg = ijarg + 1

  DO WHILE (ijarg <= narg )
     CALL getarg(ijarg, cldum) ;
     SELECT CASE ( cldum )
     CASE ( '-full' ) 
        lfull = .TRUE.
        ijarg = ijarg + 1
     CASE DEFAULT
        CALL getarg(ijarg, cn_vozocrtx) ; ijarg = ijarg + 1
        CALL getarg(ijarg, cn_vomecrty) ; ijarg = ijarg + 1
     END SELECT
  END DO

  PRINT *, cn_vozocrtx, cn_vomecrty

  lchk = chkfile (cn_fhgr)
  lchk = chkfile (cn_fzgr) .OR. lchk
  lchk = chkfile (cf_ufil) .OR. lchk
  lchk = chkfile (cf_vfil) .OR. lchk
  IF ( lchk ) STOP ! missing files

  npiglo = getdim(cf_ufil,cn_x)
  npjglo = getdim(cf_ufil,cn_y)
  npk    = getdim(cf_ufil,cn_z)
  npt    = getdim(cf_ufil,cn_t)

  ! define new variables for output
  ipk(1)                       = npk 
  stypvar(1)%cname             = 'div'
  stypvar(1)%cunits            = 's-1'
  stypvar(1)%rmissing_value    = 0.
  stypvar(1)%valid_min         = -10.
  stypvar(1)%valid_max         = 10.
  stypvar(1)%clong_name        = 'Divergence field'
  stypvar(1)%cshort_name       = 'div' 
  stypvar(1)%conline_operation = 'N/A'
  stypvar(1)%caxis             = 'TZYX'

  ! Allocate the memory
  ALLOCATE ( e1v(npiglo,npjglo), e2u(npiglo,npjglo) )
  ALLOCATE ( e1t(npiglo,npjglo), e2t(npiglo,npjglo) )
  ALLOCATE ( e3u(npiglo,npjglo), e3v(npiglo,npjglo), e3t(npiglo,npjglo) )
  ALLOCATE ( glamt(npiglo,npjglo), gphit(npiglo,npjglo)  )
  ALLOCATE ( un(npiglo,npjglo), vn(npiglo,npjglo), hdivn(npiglo,npjglo) )
  ALLOCATE ( wn(npiglo,npjglo,2) )
  ALLOCATE ( gdepw(npk), tim(npt) )
  IF ( lfull ) ALLOCATE ( e31d (npk) )

  ! Read the metrics from the mesh_hgr file
  e2u = getvar(cn_fhgr, cn_ve2u, 1, npiglo, npjglo)
  e1v = getvar(cn_fhgr, cn_ve1v, 1, npiglo, npjglo)
  e1t = getvar(cn_fhgr, cn_ve1t, 1, npiglo, npjglo)
  e2t = getvar(cn_fhgr, cn_ve2t, 1, npiglo, npjglo)

  ! and the coordinates   from the mesh_hgr file
  glamt = getvar(cn_fhgr, cn_glamt, 1, npiglo, npjglo)
  gphit = getvar(cn_fhgr, cn_gphit, 1, npiglo, npjglo)

  ! Read the depth of the w points (in the file, it is not a vector but a 1x1xnpk array)
  gdepw(:) = getvare3(cn_fzgr, cn_gdepw, npk)
  IF ( lfull ) e31d(:) = getvare3(cn_fzgr, cn_ve3t, npk)

  ! create output fileset
  ncout = create      (cf_out, cf_ufil, npiglo, npjglo, npk, cdep=cn_vdepthw     )
  ierr  = createvar   (ncout,  stypvar, 1,      ipk,    id_varout                )
  ierr  = putheadervar(ncout,  'dummy', npiglo, npjglo, npk, glamt, gphit, gdepw )

  tim  = getvar1d(cf_ufil, cn_vtimec, npt     )
  ierr = putvar1d(ncout  , tim      , npt, 'T')

  ! Main time loop
  DO jt = 1, npt
     ! Main level loop from top to bottom
     DO jk = 1, npk
        PRINT *,'jt = ', jt,' jk = ', jk

        ! velocities at level jk
        un(:,:) =  getvar(cf_ufil, cn_vozocrtx, jk, npiglo, npjglo, ktime=jt)
        vn(:,:) =  getvar(cf_vfil, cn_vomecrty, jk, npiglo, npjglo, ktime=jt)

        IF ( lfull ) THEN
           e3u(:,:) = e31d(jk)
           e3v(:,:) = e31d(jk)
           e3t(:,:) = e31d(jk)
        ELSE
           ! e3 metrics at level jk ( Partial steps)
           e3u(:,:) = getvar(cn_fzgr, 'e3u_ps', jk, npiglo, npjglo, ldiom=.TRUE.) 
           e3v(:,:) = getvar(cn_fzgr, 'e3v_ps', jk, npiglo, npjglo, ldiom=.TRUE.) 
           e3t(:,:) = getvar(cn_fzgr, 'e3t_ps', jk, npiglo, npjglo, ldiom=.TRUE.) 
        ENDIF

        ! Compute divergence :
        DO jj = 2, npjglo -1
           DO ji = 2, npiglo -1
              hdivn(ji,jj) =   &
                &  (  e2u(ji,jj)*e3u(ji,jj) * un(ji,jj) - e2u(ji-1,jj  )*e3u(ji-1,jj  )  * un(ji-1,jj )     &       
                &   + e1v(ji,jj)*e3v(ji,jj) * vn(ji,jj) - e1v(ji  ,jj-1)*e3v(ji  ,jj-1)  * vn(ji  ,jj-1)  ) &
                & / ( e1t(ji,jj)*e2t(ji,jj) * e3t(ji,jj) )
           END DO
        END DO

        ! write level jk 
        ierr = putvar(ncout, id_varout(1), hdivn, jk, npiglo, npjglo, ktime=jt)

     END DO  ! loop to next level
  END DO ! loop on time

  ierr = closeout(ncout)

END PROGRAM cdfdiv

PROGRAM cdfrmsssh
  !!======================================================================
  !!                     ***  PROGRAM  cdfrmsssh  ***
  !!=====================================================================
  !!  ** Purpose : Compute the RMS of SSH, from the mean squared value.
  !!
  !!  ** Method  : Read gridT and gridT2 and compute rms
  !!
  !! History : 2.1  : 11/2004  : J.M. Molines : Original code
  !!           3.0  : 05/2011  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class statistics
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                            :: jk, jt            ! dummy loop index
  INTEGER(KIND=4)                            :: narg, iargc       ! command line
  INTEGER(KIND=4)                            :: ijarg, ixtra      ! command line
  INTEGER(KIND=4)                            :: npiglo, npjglo    ! size of the domain
  INTEGER(KIND=4)                            :: npk, npt          ! size of the domain
  INTEGER(KIND=4)                            :: ncout             ! ncid of output variable
  INTEGER(KIND=4)                            :: ierr              ! error status
  INTEGER(KIND=4), DIMENSION(1)              :: ipko, id_varout   ! output variable

  REAL(KIND=4), DIMENSION(:,:),  ALLOCATABLE :: zvbar, zvba2      ! mean and mean2 variable

  REAL(KIND=8), DIMENSION(:),    ALLOCATABLE :: dtim              ! time counter
  REAL(KIND=8), DIMENSION(:,:),  ALLOCATABLE :: dsdev             ! standard deviation

  CHARACTER(LEN=256)                         :: cf_in             ! input mean file name
  CHARACTER(LEN=256)                         :: cf_in2            ! input mean2 file name
  CHARACTER(LEN=256)                         :: cf_out = 'rms.nc' ! output file name
  CHARACTER(LEN=256)                         :: cv_in, cv_in2     ! input variable names
  CHARACTER(LEN=256)                         :: cldum             ! dummy character variable
  CHARACTER(LEN=256)                         :: cl_sossheig       ! local name for ssh
  CHARACTER(LEN=256)                         :: cl_sossheig2      ! local name for ssh2

  TYPE(variable), DIMENSION(1)               :: stypvaro          ! output data structure

  LOGICAL                                    :: lchk = .FALSE.    ! flag for missing files
  LOGICAL                                    :: lnc4 = .FALSE.    ! flag for missing files
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfrmsssh -t T-file -t2 T2-file [-o OUT-file] [-nc4] ... '
     PRINT *,'            ...  [-var VAR-ssh VAR-ssh2]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the standard deviation of the SSH from its mean value'
     PRINT *,'       its mean square value. '
     PRINT *,'      '
     PRINT *,'       Note that what is computed in this program is stictly the'
     PRINT *,'       standard deviation. It is very often called RMS, which is'
     PRINT *,'       an abuse. It is the same only in the case of zero mean value.'
     PRINT *,'       However, for historical reason, the name of this tool, remains'
     PRINT *,'       unchanged: cdfrmsssh'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -t T-file   : netcdf file with mean values for SSH' 
     PRINT *,'       -t2 T2-file : netcdf file with mean squared values for SSH' 
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-o OUT-file] : specify the name of the output file instead'
     PRINT *,'            of default name ', TRIM(cf_out)
     PRINT *,'       [-nc4] : use netcdf4 with chunking and deflation '
     PRINT *,'       [-var VAR-ssh VAR-ssh2] : specify the variable name for mean and '
     PRINT *,'             mean-squared ssh, if they differ from the standard names.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       none' 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) ,' unless option -o is used.'
     PRINT *,'         variables : ', TRIM(cn_sossheig)//'_rms, same unit than the input.'
     PRINT *,'      '
     PRINT *,'     SEA ALSO :'
     PRINT *,'       cdfstd, cdfstdevw, cdfstdevts.'
     STOP 
  ENDIF

  cl_sossheig  = cn_sossheig
  cl_sossheig2 = TRIM(cn_sossheig)//'_sqd'

  ijarg = 1  
  DO WHILE ( ijarg <= narg) 
     CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-t'   ) ; CALL getarg(ijarg, cf_in        ) ; ijarg=ijarg+1
     CASE ( '-t2'  ) ; CALL getarg(ijarg, cf_in2       ) ; ijarg=ijarg+1
        ! options
     CASE ( '-nc4' ) ; lnc4 = .TRUE.
     CASE ( '-o'   ) ; CALL getarg(ijarg, cf_out       ) ; ijarg=ijarg+1
     CASE ( '-var' ) ; CALL getarg(ijarg, cl_sossheig  ) ; ijarg=ijarg+1
       ;             ; CALL getarg(ijarg, cl_sossheig2 ) ; ijarg=ijarg+1
     CASE DEFAULT    ; PRINT *,' ERROR : ', TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  ENDDO

  cv_in  = cl_sossheig
  cv_in2 = cl_sossheig2

  ! check existence of files
  lchk = lchk .OR. chkfile(cf_in  )
  lchk = lchk .OR. chkfile(cf_in2 )
  IF (lchk ) STOP 99 ! missing file

  npiglo = getdim (cf_in, cn_x)
  npjglo = getdim (cf_in, cn_y)
  npk    = getdim (cf_in, cn_z)
  npt    = getdim (cf_in, cn_t)

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  ALLOCATE( zvbar(npiglo,npjglo), zvba2(npiglo,npjglo) )
  ALLOCATE( dsdev(npiglo,npjglo), dtim(npt)            )

  CALL CreateOutput

  DO jt = 1, npt
     zvbar(:,:) = getvar(cf_in,  cv_in,  1, npiglo, npjglo, ktime=jt)
     zvba2(:,:) = getvar(cf_in2, cv_in2, 1, npiglo, npjglo, ktime=jt)

     dsdev(:,:) = SQRT ( DBLE(zvba2(:,:) - zvbar(:,:)*zvbar(:,:)) )

     ierr = putvar(ncout, id_varout(1), REAL(dsdev), 1, npiglo, npjglo, ktime=jt)
  END DO


  ierr = closeout(ncout)

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    ipko(1) = 1
    stypvaro(1)%ichunk            = (/npiglo, MAX(1,npjglo/30), 1, 1 /)
    stypvaro(1)%cname             = TRIM(cv_in)//'_rms'
    stypvaro(1)%cunits            = 'm'
    stypvaro(1)%rmissing_value    = 0.
    stypvaro(1)%valid_min         = 0.
    stypvaro(1)%valid_max         = 100.
    stypvaro(1)%clong_name        = 'RMS_Sea_Surface_height'
    stypvaro(1)%cshort_name       = TRIM(cv_in)//'_rms'
    stypvaro(1)%conline_operation = 'N/A'
    stypvaro(1)%caxis             = 'TYX'

    ncout = create      (cf_out, cf_in,    npiglo, npjglo, npk       , ld_nc4=lnc4 )
    ierr  = createvar   (ncout,  stypvaro, 1,      ipko,   id_varout , ld_nc4=lnc4 )
    ierr  = putheadervar(ncout,  cf_in,    npiglo, npjglo, npk                     )

    dtim = getvar1d(cf_in, cn_vtimec, npt     )
    ierr = putvar1d(ncout, dtim,      npt, 'T')

  END SUBROUTINE CreateOutput

END PROGRAM cdfrmsssh

PROGRAM cdfw
  !!======================================================================
  !!                     ***  PROGRAM  cdfw  ***
  !!=====================================================================
  !!  ** Purpose : Compute the 3D w for given gridU gridV files 
  !!               and variables
  !!
  !!  ** Method  : Use the equation on continuity: Integrate the 
  !!               horizontal divergence from bottom to the top.
  !!               ( Use the same routines than in the NEMO code )
  !!
  !! History : 2.1  : 06/2005  : J.M. Molines : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                              :: ji, jj, jk, jt     ! dummy loop index
  INTEGER(KIND=4)                              :: npiglo, npjglo     ! size of the domain
  INTEGER(KIND=4)                              :: npk, npt           ! size of the domain
  INTEGER(KIND=4)                              :: narg, iargc, ijarg ! browse line
  INTEGER(KIND=4)                              :: ncout              ! ncid of output file
  INTEGER(KIND=4)                              :: ierr               ! error status
  INTEGER(KIND=4)                              :: itop = 1           ! top array index
  INTEGER(KIND=4)                              :: ibot = 2           ! bottom array index
  INTEGER(KIND=4)                              :: itmp               ! working integer for level swap
  INTEGER(KIND=4), DIMENSION(1)                :: ipk, id_varout     ! levels and varid's of output vars

  REAL(KIND=4), DIMENSION(:,:,:), ALLOCATABLE  :: wn                 ! vertical velocity on the top
  !                                                                  ! and bottom of a cell.
  !                                                                  ! wn(top) is computed
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: e1t, e2t           ! horizontal T metrics
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: e1v, e2u           ! horizontal V and U metrics
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: e3u, e3v, e3t      ! vertical metrics (partial steps)
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: glamt, gphit       ! T longitude latitude
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: un, vn             ! horizontal velocity component
  REAL(KIND=8), DIMENSION(:,:),    ALLOCATABLE :: hdivn              ! horizontal divergence
  REAL(KIND=4), DIMENSION(:),      ALLOCATABLE :: gdepw              ! depth of W points
  REAL(KIND=4), DIMENSION(:),      ALLOCATABLE :: tim                ! time counter
  REAL(KIND=4), DIMENSION(:),      ALLOCATABLE :: e31d               ! vertical metrics ( full step)

  CHARACTER(LEN=256)                           :: cf_ufil            ! U file name
  CHARACTER(LEN=256)                           :: cf_vfil            ! V file name
  CHARACTER(LEN=256)                           :: cf_out='w.nc'      ! W file name ( output)
  CHARACTER(LEN=256)                           :: cldum              ! dummy string

  TYPE(variable), DIMENSION(1)                 :: stypvar            ! output attributes

  LOGICAL                                      :: lchk               ! missing files flag
  LOGICAL                                      :: lfull=.FALSE.      ! full step flag
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg < 2 ) THEN
     PRINT *,' usage : cdfw U-file V-file [ U-var V-var ] [ -full]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the vertical velocity from the vertical integration of'
     PRINT *,'       of the horizontal divergence of the velocity.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       U-file : netcdf file with the zonal velocity component.' 
     PRINT *,'       V-file : netcdf file with the meridional velocity component.' 
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [ U-var V-var ] : names of the zonal and meridional velocity '
     PRINT *,'                         components. Default are ', TRIM(cn_vozocrtx),' and ', TRIM(cn_vomecrty)
     PRINT *,'       [ -full ] : in case of full step configuration. Default is partial step.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ',TRIM(cn_fhgr),' and ',TRIM(cn_fzgr) 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : ', TRIM(cn_vovecrtz),' (m/s)'
     STOP
  ENDIF

  ijarg = 1
  CALL getarg(ijarg, cf_ufil) ; ijarg = ijarg + 1
  CALL getarg(ijarg, cf_vfil) ; ijarg = ijarg + 1

  DO WHILE (ijarg <= narg )
     CALL getarg(ijarg, cldum) 
     SELECT CASE ( cldum )
     CASE ( '-full' ) 
        lfull = .TRUE.
        ijarg = ijarg + 1
     CASE DEFAULT
        CALL getarg(ijarg, cn_vozocrtx) ; ijarg = ijarg + 1
        CALL getarg(ijarg, cn_vomecrty) ; ijarg = ijarg + 1
     END SELECT
  END DO

  lchk = chkfile (cn_fhgr)
  lchk = chkfile (cn_fzgr) .OR. lchk
  lchk = chkfile (cf_ufil) .OR. lchk
  lchk = chkfile (cf_vfil) .OR. lchk
  IF ( lchk ) STOP 99 ! missing files

  npiglo = getdim(cf_ufil,cn_x)
  npjglo = getdim(cf_ufil,cn_y)
  npk    = getdim(cf_ufil,cn_z)
  npt    = getdim(cf_ufil,cn_t)

  ! define new variables for output
  ipk(1)                       = npk 
  stypvar(1)%cname             = TRIM(cn_vovecrtz)
  stypvar(1)%cunits            = 'm/s'
  stypvar(1)%rmissing_value    = 0.
  stypvar(1)%valid_min         = -1.
  stypvar(1)%valid_max         = 1.
  stypvar(1)%clong_name        = 'Vertical_Velocity'
  stypvar(1)%cshort_name       = TRIM(cn_vovecrtz)
  stypvar(1)%conline_operation = 'N/A'
  stypvar(1)%caxis             = 'TZYX'

  ! Allocate the memory
  ALLOCATE ( e1v(npiglo,npjglo), e2u(npiglo,npjglo) )
  ALLOCATE ( e1t(npiglo,npjglo), e2t(npiglo,npjglo) )
  ALLOCATE ( e3u(npiglo,npjglo), e3v(npiglo,npjglo), e3t(npiglo,npjglo) )
  ALLOCATE ( glamt(npiglo,npjglo), gphit(npiglo,npjglo)  )
  ALLOCATE ( un(npiglo,npjglo), vn(npiglo,npjglo), hdivn(npiglo,npjglo) )
  ALLOCATE ( wn(npiglo,npjglo,2) )
  ALLOCATE ( gdepw(npk), tim(npt) )
  IF ( lfull ) ALLOCATE ( e31d (npk) )

  ! Read the metrics from the mesh_hgr file
  e2u = getvar(cn_fhgr, cn_ve2u, 1, npiglo, npjglo)
  e1v = getvar(cn_fhgr, cn_ve1v, 1, npiglo, npjglo)
  e1t = getvar(cn_fhgr, cn_ve1t, 1, npiglo, npjglo)
  e2t = getvar(cn_fhgr, cn_ve2t, 1, npiglo, npjglo)

  ! and the coordinates   from the mesh_hgr file
  glamt = getvar(cn_fhgr, cn_glamt, 1, npiglo, npjglo)
  gphit = getvar(cn_fhgr, cn_gphit, 1, npiglo, npjglo)

  ! Read the depth of the w points (in the file, it is not a vector but a 1x1xnpk array)
  gdepw(:) = getvare3(cn_fzgr, cn_gdepw, npk)
  IF ( lfull ) e31d(:) = getvare3(cn_fzgr, cn_ve3t1d, npk)

  ! create output fileset
  ncout = create      (cf_out, cf_ufil, npiglo, npjglo, npk, cdep=cn_vdepthw     )
  ierr  = createvar   (ncout,  stypvar, 1,      ipk,    id_varout                )
  ierr  = putheadervar(ncout,  'dummy', npiglo, npjglo, npk, glamt, gphit, gdepw )

  tim  = getvar1d(cf_ufil, cn_vtimec, npt     )
  ierr = putvar1d(ncout, tim,       npt, 'T')

  DO jt = 1, npt
     wn(:,:,:) = 0.
     ! Main level loop from bottom to top
     DO jk = npk-1, 1, -1
        PRINT *,'jt = ', jt,' jk = ', jk

        ! velocities at level jk
        un(:,:) =  getvar(cf_ufil, cn_vozocrtx, jk, npiglo, npjglo, ktime=jt)
        vn(:,:) =  getvar(cf_vfil, cn_vomecrty, jk, npiglo, npjglo, ktime=jt)

        IF ( lfull ) THEN
           e3u(:,:) = e31d(jk)
           e3v(:,:) = e31d(jk)
           e3t(:,:) = e31d(jk)
        ELSE
           ! e3 metrics at level jk ( Partial steps)
           e3u(:,:) = getvar(cn_fzgr, 'e3u_ps', jk, npiglo, npjglo, ldiom=.TRUE.) 
           e3v(:,:) = getvar(cn_fzgr, 'e3v_ps', jk, npiglo, npjglo, ldiom=.TRUE.) 
           e3t(:,:) = getvar(cn_fzgr, 'e3t_ps', jk, npiglo, npjglo, ldiom=.TRUE.) 
        ENDIF

        ! Compute divergence :
        DO jj = 2, npjglo -1
           DO ji = 2, npiglo -1
              hdivn(ji,jj) =   &
                &  (  e2u(ji,jj)*e3u(ji,jj) * un(ji,jj) - e2u(ji-1,jj  )*e3u(ji-1,jj  )  * un(ji-1,jj )     &       
                &   + e1v(ji,jj)*e3v(ji,jj) * vn(ji,jj) - e1v(ji  ,jj-1)*e3v(ji  ,jj-1)  * vn(ji  ,jj-1)  ) &
                & / ( e1t(ji,jj)*e2t(ji,jj) * e3t(ji,jj) )
           END DO
        END DO

        ! Computation from the bottom
        wn(:,:,itop) = wn(:,:,ibot) - e3t(:,:) * hdivn(:,:)

        ! write wn  on file at level jk (This coculd be epensive at it writes from the bottom ...
        ierr = putvar(ncout, id_varout(1), wn(:,:,itop), jk, npiglo, npjglo, ktime=jt)

        ! swap top and bottom index
        itmp=itop ; itop=ibot ; ibot=itmp 

     END DO  ! loop to next level
  END DO ! loop on time

  ierr = closeout(ncout)


END PROGRAM cdfw

PROGRAM cdfmxlheatc
  !!======================================================================
  !!                     ***  PROGRAM  cdfmxlheatc  ***
  !!=====================================================================
  !!  ** Purpose : Compute the heat content in the mixed layer. Work for
  !!               partial steps (default) or full step (-full option)
  !!
  !!  ** Method  : compute the sum ( rho cp T  * e1 *e2 * e3 *mask )
  !!               for the mixed layer stored into gridT file
  !!
  !! History : 2.1  : 04/2006  : J.M. Molines : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  USE modutils
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                               :: jk, jt              ! dummy loop index
  INTEGER(KIND=4)                               :: narg, iargc, ijarg  ! command line 
  INTEGER(KIND=4)                               :: npiglo, npjglo      ! size of the domain
  INTEGER(KIND=4)                               :: npk, npt            ! size of the domain,
  INTEGER(KIND=4)                               :: ncout, ierr         ! ncid and error status
  INTEGER(KIND=4), DIMENSION(1)                 :: ipk, id_varout      ! levels and varid's of output vars

  REAL(KIND=4), PARAMETER                       :: rprho0=1020.        ! rho reference density
  REAL(KIND=4), PARAMETER                       :: rpcp=4000.          ! calorific capacity
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: e3                  ! metrics
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: zt                  ! temperature in the MXL
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: zmxl                ! depth of the MXL
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: zmask               ! mask
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: gdepw               ! vertical levels
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: e31d                ! vertical metric full
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: tim                 ! time counter
  REAL(KIND=4), DIMENSION(1)                    :: rdep                ! dummy depth output

  REAL(KIND=8)                                  :: dvol                ! total volume
  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: dmxlheatc           ! heat content

  CHARACTER(LEN=256)                            :: cf_tfil             ! input file name
  CHARACTER(LEN=256)                            :: cf_out='mxlheatc.nc'! output file
  CHARACTER(LEN=256)                            :: cv_out='somxlheatc' ! output file
  CHARACTER(LEN=256)                            :: cglobal             ! global attribute
  CHARACTER(LEN=256)                            :: cldum               ! dummy string

  TYPE(variable), DIMENSION(1)                  :: stypvar             ! stucture for attributes (output)

  LOGICAL                                       :: lfull=.FALSE.       ! full step flag
  LOGICAL                                       :: lchk                ! file existence flag (true if missing)
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfmxlheatc T-file [-full]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Computed the heat content in the mixed layer (Joules/m2).' 
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       T-file : netcdf input file with temperature and mld (gridT).' 
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [ -full ] : for full step configurations, default is partial step.' 
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ',TRIM(cn_fzgr),' and ',TRIM(cn_fmsk) 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : ', TRIM(cv_out),' (Joules/m2)'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'       cdfmxl, cdfmxlhcsc and  cdfmxlsaltc.'
     PRINT *,'      '
     STOP
  ENDIF

  ijarg = 1
  CALL getarg (ijarg, cf_tfil  ) ; ijarg = ijarg + 1

  DO WHILE ( ijarg <= narg )
    CALL getarg (ijarg, cldum   ) ; ijarg = ijarg + 1 
    SELECT CASE ( cldum )
    CASE ( '-full'    ) ; lfull = .true.
    CASE DEFAULT  ; PRINT *, TRIM(cldum),' : unknown option' ; STOP
    END SELECT
  END DO

  lchk = chkfile (cn_fzgr)
  lchk = chkfile (cn_fmsk) .OR. lchk
  lchk = chkfile (cf_tfil) .OR. lchk
  IF ( lchk ) STOP ! missing files

  CALL SetGlobalAtt( cglobal) 

  npiglo = getdim (cf_tfil,cn_x)
  npjglo = getdim (cf_tfil,cn_y)
  npk    = getdim (cf_tfil,cn_z)
  npt    = getdim (cf_tfil,cn_t)

  rdep(1)                      = 0.
  ipk(:)                       = 1
  stypvar(1)%cname             = cv_out
  stypvar(1)%cunits            = 'J/m2'
  stypvar(1)%rmissing_value    = 0.
  stypvar(1)%valid_min         = -1.e15
  stypvar(1)%valid_max         =  1.e15
  stypvar(1)%clong_name        = 'Mixed_Layer_Heat_Content'
  stypvar(1)%cshort_name       = cv_out
  stypvar(1)%conline_operation = 'N/A'
  stypvar(1)%caxis             = 'TYX'

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  ! Allocate arrays
  ALLOCATE ( zmask(npiglo,npjglo), dmxlheatc(npiglo, npjglo) )
  ALLOCATE ( zt(npiglo,npjglo), zmxl(npiglo,npjglo)  )
  ALLOCATE ( e3(npiglo,npjglo) )
  ALLOCATE ( gdepw(0:npk), tim(npt) )

  IF ( lfull ) ALLOCATE ( e31d(npk) )

  ! Initialize output file
  ncout = create      (cf_out, cf_tfil, npiglo, npjglo, 1)
  ierr  = createvar   (ncout,  stypvar, 1,      ipk,    id_varout, cdglobal=cglobal  )
  ierr  = putheadervar(ncout,  cf_tfil, npiglo, npjglo, 1, pdep=rdep)

  tim  = getvar1d(cf_tfil, cn_vtimec, npt     )
  ierr = putvar1d(ncout,   tim,       npt, 'T')

           gdepw(0)     = 99999. ! dummy value always masked
           gdepw(1:npk) = getvare3(cn_fzgr, cn_gdepw, npk)
  IF ( lfull ) e31d( :) = getvare3(cn_fzgr, cn_ve3t,  npk)


  dvol           = 0.d0
  dmxlheatc(:,:) = 0.d0

  DO jt=1,npt
     zmxl( :,:) = getvar(cf_tfil, cn_somxl010, 1, npiglo, npjglo, ktime=jt)
     DO jk = 1, npk
        ! Get temperatures at jk
        zt(   :,:) = getvar(cf_tfil, cn_votemper, jk, npiglo, npjglo, ktime=jt)
        zmask(:,:) = getvar(cn_fmsk, 'tmask',     jk, npiglo, npjglo)

        ! get e3 at level jk ( ps...)
        IF ( lfull ) THEN ; e3(:,:) = e31d(jk)
        ELSE              ; e3(:,:) = getvar(cn_fzgr, 'e3t_ps', jk, npiglo, npjglo, ldiom=.TRUE.)
        ENDIF

        !  e3 is used as a flag for the mixed layer; It is 0 outside the mixed layer
        e3(:,:)= MAX ( 0., MIN(e3, zmxl-gdepw(jk) ) )
        WHERE ( e3 == 0 ) zmask = 0.

        dvol      = SUM( DBLE(e3 * zmask) )
        dmxlheatc = zt * e3 * zmask * 1.d0 + dmxlheatc

        IF (dvol == 0 ) EXIT ! no more layer below get out of the jk loop
     END DO

     ! Output to netcdf file : J/m2
      dmxlheatc = rprho0*rpcp*dmxlheatc
     ierr = putvar(ncout, id_varout(1), REAL(dmxlheatc), 1, npiglo, npjglo, ktime=jt)
  END DO

  ierr = closeout(ncout)

END PROGRAM cdfmxlheatc

PROGRAM cdfsig0
  !!======================================================================
  !!                     ***  PROGRAM  cdfsig0  ***
  !!=====================================================================
  !!  ** Purpose : Compute sigma0 3D field from gridT file
  !!               Store the results on a 'similar' cdf file.
  !!
  !!  ** Method  : Use NEMO equation of state
  !!
  !! History : 2.1  : 11/2006  : J.M. Molines : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE eos
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class Equation_of_state
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: jk, jt             ! dummy loop index
  INTEGER(KIND=4)                           :: ierr               ! error status
  INTEGER(KIND=4)                           :: narg, ijarg,iargc        ! browse command line
  INTEGER(KIND=4)                           :: npiglo, npjglo     ! size of the domain
  INTEGER(KIND=4)                           :: npk, npkk, npt     ! size of the domain
  INTEGER(KIND=4)                           :: ncout              ! ncid of output file
  INTEGER(KIND=4), DIMENSION(1)             :: ipk, id_varout     ! level and  varid's

  REAL(KIND=4)                              :: zsps               ! missing value for salinity
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: ztemp              ! temperature
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zsal               ! salinity
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zsig0              ! sigma-0
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zmask              ! 2D mask at current level

  REAL(KIND=8), DIMENSION(:),   ALLOCATABLE :: dtim               ! time counter

  CHARACTER(LEN=256)                        :: cf_tfil            ! input filename
  CHARACTER(LEN=256)                        :: cf_sfil            ! salinity file (option)
  CHARACTER(LEN=256)                        :: cf_out='sig0.nc'   ! output file name
  CHARACTER(LEN=256)                        :: cldum              ! dummy characte variable variable
  CHARACTER(LEN=256)                        :: cv_sal             ! salinity name in netcdf
  CHARACTER(LEN=256)                        :: cv_tem             ! temperature name in netcdf

  TYPE (variable), DIMENSION(1)             :: stypvar            ! structure for attributes
  LOGICAL                                   :: lnc4 = .FALSE.     ! flag for missing files
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfsig0 -t T-file [-s S-file] [-sal SAL-name] [-tem TEM-name] ...'
     PRINT *,'            ... [-nc4] [-o OUT-file]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute potential density (sigma-0) refered to the surface.' 
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -t T-file  : netcdf file with temperature and salinity.' 
     PRINT *,'           If salinity not in T-file, use -s option.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-s S-file]    : specify salinity file if not T-file.'
     PRINT *,'       [-sal SAL-name]  : name of salinity variable'
     PRINT *,'       [-tem TEM-name]  : name of temperature variable'
     PRINT *,'       [-nc4]  : enable chunking and compression'
     PRINT *,'       [-o OUT-file]    : specify output filename instead of ',TRIM(cf_out)
     PRINT *,'      '
     PRINT *,'     OPENMP SUPPORT : yes'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        none'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : ', TRIM(cn_vosigma0), ' ( kg/m3 - 1000 )'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'       cdfsigi, cdfsigintu, signtr'
     STOP 
  ENDIF

  cv_sal=cn_vosaline
  cv_tem=cn_votemper
  cf_sfil='none'
  ijarg=1
  DO WHILE ( ijarg <= narg )
     CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-t'   ) ; CALL getarg(ijarg, cf_tfil) ; ijarg=ijarg+1
!    options
     CASE ( '-s'   ) ; CALL getarg(ijarg, cf_sfil) ; ijarg=ijarg+1
     CASE ( '-o'   ) ; CALL getarg(ijarg, cf_out ) ; ijarg=ijarg+1
     CASE ( '-sal' ) ; CALL getarg(ijarg, cv_sal ) ; ijarg=ijarg+1
     CASE ( '-tem' ) ; CALL getarg(ijarg, cv_tem ) ; ijarg=ijarg+1
     CASE ( '-nc4' ) ; lnc4 = .TRUE.
     CASE DEFAULT    ; PRINT *,' ERROR : ', TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  ENDDO
  IF ( cf_sfil == 'none' ) cf_sfil=cf_tfil

  IF (chkfile(cf_tfil) .OR. chkfile(cf_sfil) ) STOP 99 ! missing file

  ! Look for missing value for salinity
  zsps = getspval(cf_sfil, cv_sal)

  npiglo = getdim (cf_tfil, cn_x)
  npjglo = getdim (cf_tfil, cn_y)
  npk    = getdim (cf_tfil, cn_z)
  npt    = getdim (cf_tfil, cn_t)

  npkk=npk
  IF ( npk == 0 ) npkk=1

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  ALLOCATE (ztemp(npiglo,npjglo), zsal (npiglo,npjglo) )
  ALLOCATE (zsig0(npiglo,npjglo), zmask(npiglo,npjglo) )
  ALLOCATE (dtim(npt) )

  CALL CreateOutput
  zsps = getspval( cf_sfil, cv_sal )

  DO jt=1,npt
     PRINT *,' TIME = ', jt, dtim(jt)/86400.,' days'
     DO jk = 1, npkk
        zmask(:,:)=1.

        ztemp(:,:)= getvar(cf_tfil, cv_tem, jk, npiglo, npjglo, ktime=jt)
        zsal(:,:) = getvar(cf_sfil, cv_sal, jk, npiglo, npjglo, ktime=jt)

        ! assuming spval is 0
        WHERE( zsal == zsps ) zmask = 0

        zsig0(:,:) = sigma0 (ztemp, zsal, npiglo, npjglo )* zmask(:,:)

        ierr = putvar(ncout, id_varout(1), zsig0, jk, npiglo, npjglo, ktime=jt)

     END DO  ! loop to next level
  END DO  ! next time frame

  ierr = closeout(ncout)
CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------

    ipk(:)                       = npkk  ! all variables (input and output are 3D)
    stypvar(1)%cname             = cn_vosigma0
    stypvar(1)%cunits            = 'kg/m3'
    stypvar(1)%rmissing_value    = 0.
    stypvar(1)%valid_min         = 0.001
    stypvar(1)%valid_max         = 40.
    stypvar(1)%clong_name        = 'Potential_density:sigma-0'
    stypvar(1)%cshort_name       = cn_vosigma0
    stypvar(1)%conline_operation = 'N/A'
    stypvar(1)%caxis             = 'TZYX'
    stypvar(1)%ichunk            = (/npiglo, MAX(1,npjglo/30), 1, 1 /)

    ! create output fileset
    ncout = create      (cf_out, cf_tfil, npiglo, npjglo, npk,       ld_nc4=lnc4  )
    ierr  = createvar   (ncout,  stypvar, 1,      ipk,    id_varout, ld_nc4=lnc4  )
    ierr  = putheadervar(ncout,  cf_tfil, npiglo, npjglo, npk       )

    dtim=getvar1d(cf_tfil, cn_vtimec, npt     )
    ierr=putvar1d(ncout,  dtim,       npt, 'T')

  END SUBROUTINE CreateOutput


END PROGRAM cdfsig0

PROGRAM cdfovide
  !!======================================================================
  !!                     ***  PROGRAM  cdfovide  ***
  !!=====================================================================
  !!  ** Purpose : Easy tool to perform Temperature, Salinity and velocity
  !!               plots along OVIDE section
  !!               PARTIAL STEPS version
  !!
  !!  ** Method  : Works as a standalone file once compiled
  !!               Inspired by cdffindij, cdftransportiz
  !!
  !! History : 2.1  : 12/2009  : R. Dussin    : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!           3.1  : 05/2013  : T. Penduff & R. Dussin  : Saving new variables
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  !!   routines      : description
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4) :: narg, iargc         ! command line
  INTEGER(KIND=4) :: npiglo, npjglo, npk ! size of the domain
  INTEGER(KIND=4) :: niter
  INTEGER(KIND=4) :: imin, imax, jmin, jmax, k, ik, jk, jclass
  INTEGER(KIND=4) :: iloc, jloc
  INTEGER(KIND=4) :: iloop, jloop

  INTEGER(KIND=4) :: nsec=0 ! nb total de points le long de la section
  INTEGER(KIND=4), DIMENSION (:), ALLOCATABLE :: isec, jsec ! indices des points a recuperer
  
!	R. Dussin's initial choice 
!  INTEGER(KIND=4), PARAMETER :: nsta=4
!	IFREMER (D. Desbruyeres') choice
  INTEGER(KIND=4), PARAMETER :: nsta=5

  INTEGER(KIND=4), DIMENSION(nsta) :: ista, jsta
  INTEGER(KIND=4), DIMENSION(nsta-1) :: ikeepn

  ! broken line stuff
  INTEGER(KIND=4), PARAMETER :: jpseg=10000
  INTEGER(KIND=4) :: i0,j0,i1,j1, i, j
  INTEGER(KIND=4) :: n,nn, jseg, kk
  INTEGER(KIND=4) :: norm_u, norm_v, ist, jst
  INTEGER(KIND=4)    ::  nxtarg
  INTEGER(KIND=4), DIMENSION(nsta-1,jpseg) :: legs1=0, legs2=0

  REAL(KIND=8), DIMENSION(nsta)             :: rlonsta, rlatsta
  REAL(KIND=8)                              :: xmin, xmax, ymin, ymax, rdis
  REAL(KIND=4)                              :: glamfound, glamin, glamax
  REAL(KIND=8)                              :: glam0, emax
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: glam, gphi, e1, e2
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: e1t, e2t, e1u, e2v, e3t
  
  REAL(KIND=4) :: rxi0, ryj0, rxi1, ryj1
  REAL(KIND=4) :: ai, bi, aj,bj,d
  REAL(KIND=4) :: rxx(jpseg), ryy(jpseg)
  REAL(KIND=4), DIMENSION(jpseg) :: gla !, gphi

  REAL(KIND=8), DIMENSION(jpseg) :: voltrp, heatrp, saltrp
  REAL(KIND=8)                   :: voltrpsum, heatrpsum, saltrpsum
  COMPLEX yypt(jpseg), yypti

  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: e1v, e3v ,gphiv, zv, zvt, zvs !: mask, metrics
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: e2u, e3u ,gphiu, zu, zut, zus !: mask, metrics
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: temper, saline, zonalu, meridv, navlon, navlat
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: ovidetemper, ovidesaline, ovidezonalu, ovidemeridv
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: lonsec, latsec, dumisec, dumjsec
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: e1tsec, e1usec, e1vsec, e2tsec, e2usec, e2vsec
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: e3tsec, e3usec, e3vsec
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: e2join, e3join, dummyvmask
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: glamu, glamv
  REAL(KIND=4), DIMENSION(:),     ALLOCATABLE :: gdepw

  REAL(KIND=8)                              :: tmp,barot

! constants
  REAL(KIND=4)   ::  rau0=1000.,  rcp=4000.

  CHARACTER(LEN=80) :: ctype='F'
  CHARACTER(LEN=80) :: cfilet , cfileu, cfilev, csection 
  LOGICAL  :: lagain, lbord
  LOGICAL  :: ltest=.FALSE.
  LOGICAL  :: lchk
  
! cdf output stuff
  CHARACTER(LEN=80) :: cfileoutnc='ovide.nc'
  TYPE (variable), DIMENSION(:), ALLOCATABLE   :: stypvar
  INTEGER(KIND=4)    :: ierr, ncout
  REAL(KIND=4), DIMENSION(1)                    ::  tim
  INTEGER(KIND=4)    :: nfield=14
  INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE :: ipk, id_varout
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg < 3  ) THEN
     PRINT *,'usage : cdfovide gridTfile gridUfile gridVfile '
     PRINT *,'     Files ',TRIM(cn_fhgr),' and ',TRIM(cn_fzgr),' must be in te current directory '
     PRINT *,'     Output on netcdf file ',TRIM(cfileoutnc)
     STOP
  ENDIF

  CALL getarg (1, cfilet)
  CALL getarg (2, cfileu)
  CALL getarg (3, cfilev)

  lchk = chkfile(cn_fhgr)
  lchk = chkfile(cn_fzgr) .OR. lchk
  lchk = chkfile(cfilet ) .OR. lchk
  lchk = chkfile(cfileu ) .OR. lchk
  lchk = chkfile(cfilev ) .OR. lchk
  IF ( lchk ) STOP 99 ! missing files

  ! R. Dussin : Location of leg points that define the 3 legs of OVIDE section
  !rlonsta(1) = -43.00 ; rlatsta(1) = 60.60    ! Greenland
  !rlonsta(2) = -31.30 ; rlatsta(2) = 58.90    ! Reykjanes Ridge
  !rlonsta(3) = -12.65 ; rlatsta(3) = 40.33    ! Off Portugal
  !rlonsta(4) =  -8.70 ; rlatsta(4) = 40.33    ! Lisboa

  ! D. Desbruyeres : Location of leg points that define the 4 legs of the OVIDE section
  rlonsta(1) = -43.70 ; rlatsta(1) = 59.90    ! 
  rlonsta(2) = -30.30 ; rlatsta(2) = 58.90    ! 
  rlonsta(3) = -19.40 ; rlatsta(3) = 44.90    ! 
  rlonsta(4) = -12.65 ; rlatsta(4) = 40.33    ! 
  rlonsta(5) = -08.70 ; rlatsta(5) = 40.33    ! 



  PRINT *, '###########################################################'
  PRINT *, '#                                                          '
  PRINT *, '#   CDF ovide                                              '
  PRINT *, '#                                                          '
  PRINT *, '#                                      \___________________'
  PRINT *, '#                                       \                  '
  PRINT *, '#                                        \                 '
  PRINT *, '#                                         \________________'
  PRINT *, '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~'

  !!---------------------------------------------------------------------
  !!  Find the indexes of the legs (from cdffindij) 
  !!---------------------------------------------------------------------

  npiglo = getdim (cn_fhgr,cn_x)
  npjglo = getdim (cn_fhgr,cn_y)
  
  ALLOCATE (glam(npiglo,npjglo), gphi(npiglo,npjglo) )
  ALLOCATE (e1(npiglo,npjglo), e2(npiglo,npjglo) )

  SELECT CASE ( ctype )
  CASE ('T' , 't' )
     glam(:,:) = getvar(cn_fhgr, 'glamt',1,npiglo,npjglo)
     gphi(:,:) = getvar(cn_fhgr, 'gphit',1,npiglo,npjglo)
     e1  (:,:) = getvar(cn_fhgr, 'e1t'  ,1,npiglo,npjglo)
     e2  (:,:) = getvar(cn_fhgr, 'e2t'  ,1,npiglo,npjglo)
  CASE ('U','u' )
     glam(:,:) = getvar(cn_fhgr, 'glamu',1,npiglo,npjglo)
     gphi(:,:) = getvar(cn_fhgr, 'gphiu',1,npiglo,npjglo)
     e1  (:,:) = getvar(cn_fhgr, 'e1u'  ,1,npiglo,npjglo)
     e2  (:,:) = getvar(cn_fhgr, 'e2u'  ,1,npiglo,npjglo)
  CASE ('V','v' )
     glam(:,:) = getvar(cn_fhgr, 'glamv',1,npiglo,npjglo)
     gphi(:,:) = getvar(cn_fhgr, 'gphiv',1,npiglo,npjglo)
     e1  (:,:) = getvar(cn_fhgr, 'e1v'  ,1,npiglo,npjglo)
     e2  (:,:) = getvar(cn_fhgr, 'e2v'  ,1,npiglo,npjglo)
  CASE ('F','f' )
     glam(:,:) = getvar(cn_fhgr, 'glamf',1,npiglo,npjglo)
     gphi(:,:) = getvar(cn_fhgr, 'gphif',1,npiglo,npjglo)
     e1  (:,:) = getvar(cn_fhgr, 'e1f'  ,1,npiglo,npjglo)
     e2  (:,:) = getvar(cn_fhgr, 'e2f'  ,1,npiglo,npjglo)
  CASE DEFAULT
     PRINT *,' ERROR : type of point not known: ', TRIM(ctype)
  END SELECT

  ! work with longitude between 0 and 360 to avoid  the date line.
    WHERE( glam < 0 ) glam=glam+360.
  ! For Orca grid, the longitude of ji=1 is about 70 E
  glam0=glam(1, npjglo/2)
  WHERE( glam < glam0 ) glam=glam+360.

  !! loop on the legs
  DO k = 1,nsta-1

   xmin=rlonsta(k)
   ymin=rlatsta(k)
   xmax=rlonsta(k+1)
   ymax=rlatsta(k+1)

   IF (xmin < 0.) xmin = xmin +360.
   IF (xmax < 0.) xmax = xmax +360.
    
   IF (xmin < glam0) xmin = xmin +360.
   IF (xmax < glam0) xmax = xmax +360.

   lagain = .TRUE.
   niter = 0

  !! --- while loop -----------------------------------------------------------
  DO WHILE (lagain)
     CALL Nearestpoint(xmin,ymin,npiglo,npjglo,glam,gphi,iloc,jloc,lbord)
     ! distance between the target point and the nearest point
     rdis=dist(xmin,glam(iloc,jloc),ymin,gphi(iloc,jloc) ) ! in km
     ! typical grid size (diagonal) in the vicinity of nearest point
     emax= MAX(e1(iloc,jloc),e2(iloc,jloc))/1000.*SQRT(2.) ! in km

!!    rdis = (xmin - glam(iloc,jloc))**2 + (ymin - gphi(iloc,jloc))**2
!!    rdis = SQRT(rdis)
     IF (rdis  > emax ) THEN
         glamfound=glam(iloc,jloc) ; IF (glamfound > 180.)  glamfound=glamfound -360.
        PRINT 9000, 'Long= ',glamfound,' Lat = ',gphi(iloc,jloc)&
             &               , iloc, jloc 
        PRINT *,' Algorithme ne converge pas ', rdis 
        IF ( niter >=  1 ) THEN
           PRINT *, ' pas de convergence apres iteration'
           STOP 99
        ENDIF
        lagain = .TRUE.
        jloc = npjglo
        niter = niter +1
     ELSE
        !PRINT '("#  rdis= ",f8.3," km")', rdis
        lagain = .FALSE.
     END IF
  END DO
  !!--------------------------------------------------------------------------

  IF (lbord) THEN
     WRITE (*,*)'Point  Out of domain or on boundary'
  ELSE
     imin=iloc
     jmin=jloc
     !      PRINT 9000, 'Long= ',glam(iloc,jloc),' lat = ',gphi(iloc,jloc), iloc, jloc 
  ENDIF
  
  lagain = .TRUE.
  niter = 0
  !! --- while loop ----------------------------------------------------------------
  DO WHILE (lagain)
     CALL Nearestpoint(xmax,ymax,npiglo,npjglo,glam,gphi,iloc,jloc,lbord)
     ! distance between the target point and the nearest point
     rdis=dist(xmax,glam(iloc,jloc),ymax,gphi(iloc,jloc) ) ! in km
     ! typical grid size (diagonal) in the vicinity of nearest point
     emax= MAX(e1(iloc,jloc),e2(iloc,jloc))/1000.*SQRT(2.) ! in km
!!    rdis = (xmax - glam(iloc,jloc))**2 + (ymax - gphi(iloc,jloc))**2
!!    rdis = SQRT(rdis)
     IF (rdis >  emax ) THEN
         glamfound=glam(iloc,jloc) ; IF (glamfound > 180.)  glamfound=glamfound -360.
        PRINT 9000, 'Long= ',glamfound,' Lat = ',gphi(iloc,jloc) &
             &               , iloc, jloc
        PRINT *,' Algorithme ne converge pas ', rdis
        IF ( niter >= 1 ) THEN
           PRINT *, ' pas de convergence avres iteration'
           STOP 99
        ENDIF
        lagain = .TRUE.
        jloc  = npjglo
        niter = niter +1
     ELSE
        !PRINT '("#  rdis= ",f8.3," km")', rdis
        lagain = .FALSE.
     END IF
  END DO !! ---------------------------------------------------------------------

  IF (lbord) THEN
     WRITE (*,*) 'Point  Out of domain or on boundary'
  ELSE
     imax=iloc
     jmax=jloc
     !      PRINT 9000, 'Long= ',glam(iloc,jloc),' lat = ',gphi(iloc,jloc), iloc, jloc
  ENDIF
  
  ista(k)=imin
  jsta(k)=jmin
  ista(k+1)=imax
  jsta(k+1)=jmax

!  PRINT 9001, imin,imax, jmin, jmax
!  glamin=glam(imin,jmin) ;glamax=glam(imax,jmax)
!  IF ( glamin > 180 ) glamin=glamin-360.
!  IF ( glamax > 180 ) glamax=glamax-360.
!  PRINT 9002, glamin, glamax, gphi(imin,jmin),gphi(imax,jmax)
9000 FORMAT(a,f8.2,a,f8.2,2i5)
9001 FORMAT(4i10)
9002 FORMAT(4f10.4)


     !! Find the broken line between P1 (imin,jmin) and P2 (imax, jmax)
     !! ---------------------------------------------------------------
     ! ... Initialization
     i0=imin; j0=jmin; i1=imax;  j1=jmax
     rxi1=i1;  ryj1=j1; rxi0=i0; ryj0=j0

     ! .. Compute equation:  ryj = aj rxi + bj
     IF ( (rxi1 -rxi0) /=  0 ) THEN
        aj = (ryj1 - ryj0 ) / (rxi1 -rxi0)
        bj = ryj0 - aj * rxi0
     ELSE
        aj=10000.
        bj=0.
     END IF


     ! .. Compute equation:  rxi = ai ryj + bi
     IF ( (ryj1 -ryj0) /=  0 ) THEN
        ai = (rxi1 - rxi0 ) / ( ryj1 -ryj0 )
        bi = rxi0 - ai * ryj0
     ELSE
        ai=10000.
        bi=0.
     END IF


     ! ..  Compute the integer pathway:
     n=0
     ! .. Chose the strait line with the smallest slope
     IF (ABS(aj) <=  1 ) THEN
        ! ... Here, the best line is y(x)
        ! ... If i1 < i0 swap points and remember it has been swapped
        IF (i1 <  i0 ) THEN
           i  = i0 ; j  = j0
           i0 = i1 ; j0 = j1
           i1 = i  ; j1 = j
        END IF

        IF ( j1 >= j0 ) THEN
           ist = 1     ; jst = 1
           norm_u =  1 ;  norm_v = -1
        ELSE
           ist = 1     ; jst = 0
           norm_u = -1 ; norm_v = -1
        END IF

        ! ... compute the nearest j point on the line crossing at i
        DO i=i0,i1
           n=n+1
           IF (n > jpseg) THEN
              PRINT *, 'n > jpseg !'
              STOP 99
           ENDIF
           j=NINT(aj*i + bj )
           yypt(n) = CMPLX(i,j)
        END DO
     ELSE
        ! ... Here, the best line is x(y)
        ! ... If j1 < j0 swap points and remember it has been swapped
        IF (j1 <  j0 ) THEN
           i  = i0 ; j  = j0
           i0 = i1 ; j0 = j1
           i1 = i  ; j1 = j
        END IF
        IF ( i1 >=  i0 ) THEN
           ist = 1    ;  jst = 1
           norm_u = 1 ;  norm_v = -1
        ELSE
           ist = 0
           jst = 1
           norm_u = 1
           norm_v = 1
        END IF

        ! ... compute the nearest i point on the line crossing at j
        DO j=j0,j1
           n=n+1
           IF (n > jpseg) THEN
              PRINT *, 'n>jpseg !'
              STOP 99
           ENDIF
           i=NINT(ai*j + bi)
           yypt(n) = CMPLX(i,j)
        END DO
     END IF

     !!
     !! Look for intermediate points to be added.
     !  ..  The final positions are saved in rxx,ryy
     rxx(1)=REAL(yypt(1))
     ryy(1)=IMAG(yypt(1))
     nn=1

     DO kk=2,n
        ! .. distance between 2 neighbour points
        d=ABS(yypt(kk)-yypt(kk-1))
        ! .. intermediate points required if d > 1
        IF ( d > 1 ) THEN
           CALL interm_pt(yypt,kk,ai,bi,aj,bj,yypti)
           nn=nn+1
           IF (nn > jpseg) THEN
              PRINT *, 'nn>jpseg !'
              STOP 99
           ENDIF
           rxx(nn)=REAL(yypti)
           ryy(nn)=IMAG(yypti)
        END IF
        nn=nn+1
        IF (nn > jpseg) THEN
           PRINT *, 'nn>jpseg !'
           STOP 99
        ENDIF
        rxx(nn)=REAL(yypt(kk))
        ryy(nn)=IMAG(yypt(kk))
     END DO

  IF (rxx(1) < rxx(nn) ) THEN ;
     legs1(k,:)=rxx
     legs2(k,:)=ryy
  ELSE

    DO iloop=1,nn
      legs1(k,iloop)=rxx(nn-iloop+1)
      legs2(k,iloop)=ryy(nn-iloop+1)
   END DO
  END IF

  ! compute the number of total points
  ikeepn(k)=nn
  nsec = nsec + nn
  END DO !! loop on the legs

! fancy control print
WRITE(*,*) '------------------------------------------------------------'
WRITE(*,9100) 'leg 1 start at ', rlonsta(1) ,'°N ', rlatsta(1), '°W and ends at ', rlonsta(2) ,'°N ', rlatsta(2), '°W'
WRITE(*,9101) 'corresponding to F-gridpoints(', ista(1),',',jsta(1),') and (', ista(2),',',jsta(2),')' 
WRITE(*,*) '------------------------------------------------------------'
WRITE(*,*) '------------------------------------------------------------'
WRITE(*,9100) 'leg 2 start at ', rlonsta(2) ,'°N ', rlatsta(2), '°W and ends at ', rlonsta(3) ,'°N ', rlatsta(3), '°W'
WRITE(*,9101) 'corresponding to F-gridpoints(', ista(2),',',jsta(2),') and (', ista(3),',',jsta(3),')' 
WRITE(*,*) '------------------------------------------------------------'
WRITE(*,*) '------------------------------------------------------------'
WRITE(*,9100) 'leg 3 start at ', rlonsta(3) ,'°N ', rlatsta(3), '°W and ends at ', rlonsta(4) ,'°N ', rlatsta(4), '°W'
WRITE(*,9101) 'corresponding to F-gridpoints(', ista(3),',',jsta(3),') and (', ista(4),',',jsta(4),')' 
WRITE(*,*) '------------------------------------------------------------'
WRITE(*,*) '------------------------------------------------------------'
WRITE(*,9100) 'leg 4 start at ', rlonsta(4) ,'°N ', rlatsta(4), '°W and ends at ', rlonsta(5) ,'°N ', rlatsta(5), '°W'
WRITE(*,9101) 'corresponding to F-gridpoints(', ista(4),',',jsta(4),') and (', ista(5),',',jsta(5),')' 
WRITE(*,*) '------------------------------------------------------------'

9100 FORMAT(a,f6.2,a,f6.2,a,f6.2,a,f6.2,a)
9101 FORMAT(a,i4,a,i4,a,i4,a,i4,a)

  ALLOCATE (isec(nsec), jsec(nsec)) 

  DO k=1, nsta-1
    DO iloop=1, ikeepn(k) 
     jloop=iloop + SUM(ikeepn(1:k)) -ikeepn(k)
     isec(jloop)=legs1(k,iloop)
     jsec(jloop)=legs2(k,iloop)
    END DO
  END DO

  npk = getdim (cfilet,'deptht')

  ! input fields
  ALLOCATE(navlon(npiglo,npjglo), navlat(npiglo,npjglo))
  ALLOCATE(temper(npiglo,npjglo), saline(npiglo,npjglo))
  ALLOCATE(zonalu(npiglo,npjglo), meridv(npiglo,npjglo))
  ALLOCATE(e1v(npiglo,npjglo))
  ALLOCATE(e2u(npiglo,npjglo))
  ALLOCATE(e3u(npiglo,npjglo), e3v(npiglo,npjglo))

  ! output fields
  ALLOCATE(lonsec(1,nsec), latsec(1,nsec) )
  ALLOCATE(dumisec(1,nsec), dumjsec(1,nsec) )
  ALLOCATE(e2usec(1,nsec-1), e3usec(nsec-1,npk) )
  ALLOCATE(e1vsec(1,nsec-1), e3vsec(nsec-1,npk) )
  ALLOCATE(ovidetemper(nsec-1,npk), ovidesaline(nsec-1,npk) )
  ALLOCATE(ovidezonalu(nsec-1,npk), ovidemeridv(nsec-1,npk) )
  ALLOCATE(dummyvmask(nsec-1,npk))
    
  
  e1vsec=-9999.
  e2usec=-9999.
  
  
  dumisec(:,:)=0
  dumjsec(:,:)=0
  

  navlon(:,:) = getvar(cfilet, 'nav_lon' ,1,npiglo,npjglo)
  navlat(:,:) = getvar(cfilet, 'nav_lat' ,1,npiglo,npjglo)
  e1v(:,:)    = getvar(cn_fhgr, 'e1v',1,npiglo,npjglo)
  e2u(:,:)    = getvar(cn_fhgr, 'e2u',1,npiglo,npjglo)

  ! il faut faire un test sur la continuité des segements
  ! on va prendre T et S comme etant la moyenne du point
  ! en dessous et au-dessus du segment pour pouvoir calculer
  ! les fluxs de maniere optimales...

  ! loop on 2d arrays
  DO iloop=1,nsec

    lonsec(1,iloop) = navlon(isec(iloop),jsec(iloop))
    latsec(1,iloop) = navlat(isec(iloop),jsec(iloop))
    dumisec(1,iloop)= isec(iloop)
    dumjsec(1,iloop)= jsec(iloop)

  END DO

	jk=1

  DO iloop=1,nsec-1
	 !PRINT*, 'iloop=', iloop
	
  IF ( jsec(iloop+1) == jsec(iloop) ) THEN ! horizontal segment
    IF ( isec(iloop+1) > isec(iloop) ) THEN ! eastward

       e2usec(jk,iloop) = 0.
       e1vsec(jk,iloop) = e1v(isec(iloop)+1,jsec(iloop))

    ELSE

       e2usec(jk,iloop) = 0.
       e1vsec(jk,iloop) = e1v(isec(iloop),jsec(iloop))

    ENDIF
  ELSEIF ( isec(iloop+1) == isec(iloop) ) THEN ! vertical segment
    IF ( jsec(iloop+1) < jsec(iloop) ) THEN ! southward

       e2usec(jk,iloop) = e2u(isec(iloop),jsec(iloop))
       e1vsec(jk,iloop) = 0.

    ELSE

       e2usec(jk,iloop) = e2u(isec(iloop),jsec(iloop)+1)
       e1vsec(jk,iloop) = 0.

    ENDIF
  ELSE
       PRINT *, 'problem'
       exit 
  ENDIF
  END DO

!	PRINT*,nsec
!	PRINT*, MINVAL(e1v),MAXVAL(e1v),MINVAL(e2u),MAXVAL(e2u)  
!	PRINT*, MINVAL(e1vsec),MAXVAL(e1vsec),MINVAL(e2usec),MAXVAL(e2usec)  
!	PAUSE		
	
  ! loop on 3d arrays
  DO jk=1,npk
  temper(:,:) = getvar(cfilet, 'votemper',jk,npiglo,npjglo)
  saline(:,:) = getvar(cfilet, 'vosaline',jk,npiglo,npjglo)
  zonalu(:,:) = getvar(cfileu, 'vozocrtx',jk,npiglo,npjglo)
  meridv(:,:) = getvar(cfilev, 'vomecrty',jk,npiglo,npjglo)
  e3u(:,:) = getvar(cn_fzgr, 'e3u_ps',jk,npiglo,npjglo, ldiom=.true.)
  e3v(:,:) = getvar(cn_fzgr, 'e3v_ps',jk,npiglo,npjglo, ldiom=.true.)

  DO iloop=1,nsec-1
    IF ( jsec(iloop+1) == jsec(iloop) ) THEN ! horizontal segment
       IF ( isec(iloop+1) > isec(iloop) ) THEN ! eastward

       IF ( min( temper(isec(iloop)+1,jsec(iloop)) , temper(isec(iloop)+1,jsec(iloop)+1) ) == 0. ) THEN
       ovidetemper(iloop,jk) = 0. ; ovidesaline(iloop,jk) = 0.
       ELSE
       ovidetemper(iloop,jk) = 0.5 * ( temper(isec(iloop)+1,jsec(iloop)) + temper(isec(iloop)+1,jsec(iloop)+1) )
       ovidesaline(iloop,jk) = 0.5 * ( saline(isec(iloop)+1,jsec(iloop)) + saline(isec(iloop)+1,jsec(iloop)+1) )
       ENDIF
       ovidezonalu(iloop,jk) = 0.
       ovidemeridv(iloop,jk) = meridv(isec(iloop)+1,jsec(iloop))
       e3usec(iloop,jk) = 0.
       e3vsec(iloop,jk) = e3v(isec(iloop)+1,jsec(iloop))

       ELSE ! westward

       IF ( min( temper(isec(iloop),jsec(iloop)) , temper(isec(iloop),jsec(iloop)+1) ) == 0. ) THEN
       ovidetemper(iloop,jk) = 0. ; ovidesaline(iloop,jk) = 0.
       ELSE
       ovidetemper(iloop,jk) = 0.5 * ( temper(isec(iloop),jsec(iloop)) + temper(isec(iloop),jsec(iloop)+1) )
       ovidesaline(iloop,jk) = 0.5 * ( saline(isec(iloop),jsec(iloop)) + saline(isec(iloop),jsec(iloop)+1) )
       ENDIF
       ovidezonalu(iloop,jk) = 0.
       ovidemeridv(iloop,jk) = meridv(isec(iloop),jsec(iloop))
       e3usec(iloop,jk) = 0.
       e3vsec(iloop,jk) = e3v(isec(iloop),jsec(iloop))

       ENDIF
    ELSEIF ( isec(iloop+1) == isec(iloop) ) THEN ! vertical segment
       IF ( jsec(iloop+1) < jsec(iloop) ) THEN ! southward

       IF ( min( temper(isec(iloop),jsec(iloop)) , temper(isec(iloop)+1,jsec(iloop)) ) == 0. ) THEN
       ovidetemper(iloop,jk) = 0. ; ovidesaline(iloop,jk) = 0.
       ELSE
       ovidetemper(iloop,jk) = 0.5 * ( temper(isec(iloop),jsec(iloop)) + temper(isec(iloop)+1,jsec(iloop)) )
       ovidesaline(iloop,jk) = 0.5 * ( saline(isec(iloop),jsec(iloop)) + saline(isec(iloop)+1,jsec(iloop)) )
       ENDIF
       ovidezonalu(iloop,jk) = zonalu(isec(iloop),jsec(iloop))
       ovidemeridv(iloop,jk) = 0.
       e3usec(iloop,jk) = e3u(isec(iloop),jsec(iloop))
       e3vsec(iloop,jk) = 0.

       ELSE ! northward

       IF ( min( temper(isec(iloop),jsec(iloop)+1) , temper(isec(iloop)+1,jsec(iloop)+1) ) == 0. ) THEN
       ovidetemper(iloop,jk) = 0. ; ovidesaline(iloop,jk) = 0.
       ELSE
       ovidetemper(iloop,jk) = 0.5 * ( temper(isec(iloop),jsec(iloop)+1) + temper(isec(iloop)+1,jsec(iloop)+1) )
       ovidesaline(iloop,jk) = 0.5 * ( saline(isec(iloop),jsec(iloop)+1) + saline(isec(iloop)+1,jsec(iloop)+1) )
       ENDIF
       ovidezonalu(iloop,jk) = zonalu(isec(iloop),jsec(iloop)+1)
       ovidemeridv(iloop,jk) = 0.
       e3usec(iloop,jk) = e3u(isec(iloop),jsec(iloop)+1)
       e3vsec(iloop,jk) = 0.

       ENDIF

    ELSE
       PRINT *, 'problem'
       exit 
    ENDIF

  END DO
  END DO


  ALLOCATE ( stypvar(nfield), ipk(nfield), id_varout(nfield) )

  DO iloop=1,nfield
     ipk(iloop) = npk
  END DO

 ! define new variables for output 
  stypvar(1)%cname= 'votemper'
  stypvar(1)%cunits='deg C'
  stypvar%rmissing_value=0.
  stypvar(1)%valid_min= -2.
  stypvar(1)%valid_max= 40.
  stypvar%scale_factor= 1.
  stypvar%add_offset= 0.
  stypvar%savelog10= 0.
  stypvar(1)%clong_name='Temperature along OVIDE section'
  stypvar(1)%cshort_name='votemper'
  stypvar%conline_operation='N/A'
  stypvar%caxis='TXZ'

  stypvar(2)%cname= 'vosaline'
  stypvar(2)%cunits='PSU'
  stypvar(2)%valid_min= 0.
  stypvar(2)%valid_max= 50.
  stypvar(2)%clong_name='Salinity along OVIDE section'
  stypvar(2)%cshort_name='vosaline'

  stypvar(3)%cname= 'vozocrtx_native'
  stypvar(3)%cunits='m.s-1'
  stypvar(3)%valid_min= -20.
  stypvar(3)%valid_max= 20.
  stypvar(3)%clong_name='Zonal velocity along OVIDE section'
  stypvar(3)%cshort_name='vozocrtx'

  stypvar(4)%cname= 'vomecrty_native'
  stypvar(4)%cunits='m.s-1'
  stypvar(4)%valid_min= -20.
  stypvar(4)%valid_max= 20.
  stypvar(4)%clong_name='Meridionnal velocity along OVIDE section'
  stypvar(4)%cshort_name='vomecrty'

  stypvar(5)%cname= 'isec'
  stypvar(5)%valid_min= 0.
  stypvar(5)%valid_max= npiglo 
  stypvar(6)%cname= 'jsec'
  stypvar(6)%valid_min= 0.
  stypvar(6)%valid_max= npjglo 
  stypvar(7)%cname= 'e2u_native'
  stypvar(7)%valid_min= MINVAL(e2usec(1,:))
  stypvar(7)%valid_max= MAXVAL(e2usec(1,:)) 
  stypvar(8)%cname= 'e1v_native'
  stypvar(8)%valid_min= MINVAL(e1vsec(1,:))
  stypvar(8)%valid_max= MAXVAL(e1vsec(1,:))
  stypvar(9)%cname= 'e3u_native'
  stypvar(9)%valid_min= MINVAL(e3usec(:,:))
  stypvar(9)%valid_max= MAXVAL(e3usec(:,:)) 
  stypvar(10)%cname= 'e3v_native'
  stypvar(10)%valid_min= MINVAL(e3vsec(:,:))
  stypvar(10)%valid_max= MAXVAL(e3vsec(:,:)) 

  stypvar(11)%cname= 'vomecrty'
  stypvar(11)%cunits='m.s-1'
  stypvar(11)%valid_min= -20.
  stypvar(11)%valid_max= 20.
  stypvar(11)%clong_name='Normal velocity along OVIDE section'
  stypvar(11)%cshort_name='vomecrty'

  stypvar(12)%cname= 'e1v'
  stypvar(12)%cunits='m'
  stypvar(12)%valid_min= 0.
  stypvar(12)%valid_max= 1000000.
  stypvar(12)%clong_name='Local horiz. resolution along OVIDE section'
  stypvar(12)%cshort_name='e1v'

  stypvar(13)%cname= 'e3v_ps'
  stypvar(13)%cunits='m'
  stypvar(13)%valid_min= 0.
  stypvar(13)%valid_max= 100000000.
  stypvar(13)%clong_name='Local vert. resolution along OVIDE section'
  stypvar(13)%cshort_name='e3v_ps'

  stypvar(14)%cname= 'vmask'
  stypvar(12)%cunits=''
  stypvar(12)%valid_min= 0.
  stypvar(12)%valid_max= 1.
  stypvar(12)%clong_name='Mask along OVIDE section'
  stypvar(12)%cshort_name='vmask'

  ! create output fileset
   ncout =create(cfileoutnc, 'none', nsec,1, npk,cdep='depthw')
   ierr= createvar(ncout ,stypvar,nfield, ipk,id_varout )
   ierr= putheadervar(ncout, cfilet,nsec,1, npk,pnavlon=lonsec,pnavlat=latsec,pdep=gdepw)
   tim=getvar1d(cfilet,'time_counter',1)
   ierr=putvar1d(ncout,tim,1,'T')


  dummyvmask(:,:) = 1.
  WHERE( ovidesaline(:,:) == 0. ) dummyvmask(:,:) = 0.


	!PRINT*, MINVAL(e1v),MAXVAL(e1v),MINVAL(e2u),MAXVAL(e2u)  
	!PRINT*, MINVAL(e1vsec),MAXVAL(e1vsec),MINVAL(e2usec),MAXVAL(e2usec)  
	!PAUSE

!------------------- BAROTROPIC TRANSPORT
    barot = 0.
    
  DO iloop=1,nsec-1
  DO jk=1,npk
	tmp=(ovidezonalu(iloop,jk)+ovidemeridv(iloop,jk))*&
	    (e2usec(1,iloop)+e1vsec(1,iloop))*&
	    (e3usec(iloop,jk)+e3vsec(iloop,jk))*&
	    dummyvmask(iloop,jk)
    barot=barot+tmp
  ENDDO
	    !jk=1
		!PRINT*,iloop,(ovidezonalu(iloop,jk)+ovidemeridv(iloop,jk)),(e2usec(1,iloop)+e1vsec(1,iloop)),&
		!(e3usec(iloop,jk)+e3vsec(iloop,jk)),dummyvmask(iloop,jk),barot
  ENDDO
	PRINT*, 'BAROTROPIC TRANSPORT = ', barot/1.e6, ' Sv.'
!--------------------------------------------


  ! netcdf output 
    DO jk =1, npk
    ierr = putvar (ncout, id_varout(1), REAL(ovidetemper(:,jk)), jk,nsec-1,1)
    ierr = putvar (ncout, id_varout(2), REAL(ovidesaline(:,jk)), jk,nsec-1,1)
    ierr = putvar (ncout, id_varout(3), REAL(ovidezonalu(:,jk)), jk,nsec-1,1)
    ierr = putvar (ncout, id_varout(4), REAL(ovidemeridv(:,jk)), jk,nsec-1,1)
    ierr = putvar (ncout, id_varout(5), REAL(dumisec(1,:)), jk,1,nsec)
    ierr = putvar (ncout, id_varout(6), REAL(dumjsec(1,:)), jk,1,nsec)
    ierr = putvar (ncout, id_varout(7), REAL(e2usec(1,:)), jk,nsec-1,1)
    ierr = putvar (ncout, id_varout(8), REAL(e1vsec(1,:)), jk,nsec-1,1)
    ierr = putvar (ncout, id_varout(9), REAL(e3usec(:,jk)), jk,nsec-1,1)
    ierr = putvar (ncout, id_varout(10),REAL(e3vsec(:,jk)), jk,nsec-1,1)
  ! along-track normal velocity, horiz. and vert. resolution, and mask
    ierr = putvar (ncout, id_varout(11),REAL(ovidezonalu(:,jk) + ovidemeridv(:,jk)), jk,nsec-1,1)
    ierr = putvar (ncout, id_varout(12),REAL(e2usec(1,:) + e1vsec(1,:)), jk,nsec-1,1)
    ierr = putvar (ncout, id_varout(13),REAL(e3usec(:,jk) + e3vsec(:,jk)), jk,nsec-1,1)
    ierr = putvar (ncout, id_varout(14),REAL(dummyvmask(:,jk)), jk,nsec-1,1)
    END DO

  ierr = closeout(ncout)

    !!--------------------------------------------------------------------
    !!
    !!   SUBROUTINES USED
    !!
    !!--------------------------------------------------------------------
CONTAINS

  SUBROUTINE Nearestpoint(pplon,pplat,kpi,kpj,plam,pphi,kpiloc,kpjloc,ldbord)
    !!----------------------------------------------------------------------------
    !!            ***  SUBROUTINE NEARESTPOINT  ***
    !!
    !!   ** Purpose:  Computes the positions of the nearest i,j in the grid
    !!                from the given longitudes and latitudes
    !!
    !!   ** Method :  Starts on the middle of the grid, search in a 20x20 box, and move
    !!     the box in the direction where the distance between the box and the
    !!     point is minimum
    !!     Iterates ...
    !!     Stops when the point is outside the grid.
    !!     This algorithm does not work on the Mediteranean grid !
    !!
    !!   * history:
    !!        Anne de Miranda et Pierre-Antoine Darbon Jul. 2000 (CLIPPER)
    !!        Jean-Marc Molines : In NEMO form
    !!----------------------------------------------------------------------------
    IMPLICIT NONE
    !* arguments
    REAL(KIND=8),INTENT(in)   ::  pplon,pplat   !: lon and lat of target point
    INTEGER(KIND=4),INTENT (in)       ::  kpi,kpj       !: grid size
    INTEGER(KIND=4),INTENT (inout)    :: kpiloc,kpjloc  !: nearest point location
    REAL(KIND=8),DIMENSION(kpi,kpj),INTENT(in) ::  pphi,plam  !: model grid layout
    LOGICAL                   :: ldbord         !: reach boundary flag

    ! * local variables
    INTEGER(KIND=4) :: ji,jj,i0,j0,i1,j1
    INTEGER(KIND=4) :: itbl
    REAL(KIND=4) ::  zdist,zdistmin,zdistmin0
    LOGICAL, SAVE ::  lbordcell, lfirst=.TRUE.
    !!
    ! Initial values
    kpiloc = kpi/2 ; kpjloc = kpj/2    ! seek from the middle of domain
    itbl = 10                          ! block size for search
    zdistmin=1000000. ; zdistmin0=1000000.
    i0=kpiloc ;  j0=kpjloc
    lbordcell=.TRUE.;   ldbord=.FALSE.

    ! loop until found or boundary reach
    DO  WHILE ( lbordcell .AND. .NOT. ldbord)
       i0=kpiloc-itbl ;  i1=kpiloc+itbl
       j0=kpjloc-itbl ;  j1=kpjloc+itbl

       ! search only the inner domain
       IF (i0 <= 0) i0=2
       IF (i1 > kpi) i1=kpi-1
       IF (j0 <= 0) j0=2
       IF( j1 > kpj) j1=kpj-1

       ! within a block itbl+1 x itbl+1:
       DO jj=j0,j1
          DO ji=i0,i1
             ! compute true distance (orthodromy) between target point and grid point
             zdist=dist(pplon,plam(ji,jj),pplat,pphi(ji,jj) )
             zdistmin=MIN(zdistmin,zdist)
             ! update kpiloc, kpjloc if distance decreases
             IF (zdistmin .NE. zdistmin0 ) THEN
                kpiloc=ji
                kpjloc=jj
             ENDIF
             zdistmin0=zdistmin
          END DO
       END DO
       lbordcell=.FALSE.
       ! if kpiloc, kpjloc belong to block boundary proceed to next block, centered on kpiloc, kpjloc
       IF (kpiloc == i0 .OR. kpiloc == i1) lbordcell=.TRUE.
       IF (kpjloc == j0 .OR. kpjloc == j1) lbordcell=.TRUE.
       ! boundary reach ---> not found
       IF (kpiloc == 2  .OR. kpiloc ==kpi-1) ldbord=.TRUE.
       IF (kpjloc == 2  .OR. kpjloc ==kpj-1) ldbord=.TRUE.
    END DO
  END SUBROUTINE  NEARESTPOINT

SUBROUTINE interm_pt (ydpt,k,pai,pbi,paj,pbj,ydpti)
    !! -----------------------------------------------------
    !!           SUBROUTINE INTERM_PT
    !!           ********************
    !!
    !!   PURPOSE:
    !!   --------
    !!     Find the best intermediate points on a pathway.
    !!
    !!    ARGUMENTS:
    !!    ----------
    !!      ydpt : complex vector of the positions of the nearest points
    !!         k : current working index
    !!       pai ,pbi : slope and original ordinate of x(y)
    !!       paj ,pbj : slope and original ordinate of y(x)
    !!      ydpti : Complex holding the position of intermediate point
    !!
    !!    AUTHOR:
    !!    -------
    !!      19/07/1999 : Jean-Marc MOLINES
    !!      14/01/2005 : J M M in F90
    !!
    !!--------------------------------------------------------------
    !!
    !! 0. Declarations:
    !! ----------------
    IMPLICIT NONE
    COMPLEX, INTENT(in) :: ydpt(*)
    COMPLEX, INTENT(out) :: ydpti
    REAL(KIND=4), INTENT(IN) ::  pai,pbi,paj,pbj
    INTEGER(KIND=4) ,INTENT(in) :: k
    ! ... local
    COMPLEX :: ylptmp1, ylptmp2
    REAL(KIND=4) ::  za0,zb0,za1,zb1,zd1,zd2
    REAL(KIND=4) ::  zxm,zym
    REAL(KIND=4) ::  zxp,zyp
    !!
    !! 1. Compute intermediate points
    !! ------------------------------
    !
    ! ... Determines whether we use y(x) or x(y):
    IF (ABS(paj) <=  1) THEN
       ! ..... y(x)
       ! ... possible intermediate points:
       ylptmp1=ydpt(k-1)+(1.,0.)
       ylptmp2=ydpt(k-1)+CMPLX(0.,SIGN(1.,paj))
       !
       ! ... M is the candidate point:
       zxm=REAL(ylptmp1)
       zym=IMAG(ylptmp1)
       za0=paj
       zb0=pbj
       !
       za1=-1./za0
       zb1=zym - za1*zxm
       ! ... P is the projection of M on the strait line
       zxp=-(zb1-zb0)/(za1-za0)
       zyp=za0*zxp + zb0
       ! ... zd1 is the distance MP
       zd1=(zxm-zxp)*(zxm-zxp) + (zym-zyp)*(zym-zyp)
       !
       ! ... M is the candidate point:
       zxm=REAL(ylptmp2)
       zym=IMAG(ylptmp2)
       za1=-1./za0
       zb1=zym - za1*zxm
       ! ... P is the projection of M on the strait line
       zxp=-(zb1-zb0)/(za1-za0)
       zyp=za0*zxp + zb0
       ! ... zd2 is the distance MP
       zd2=(zxm-zxp)*(zxm-zxp) + (zym-zyp)*(zym-zyp)
       ! ... chose the smallest (zd1,zd2)
       IF (zd2 <=  zd1) THEN
          ydpti=ylptmp2
       ELSE
          ydpti=ylptmp1
       END IF
       !
    ELSE
       !
       ! ... x(y)
       ylptmp1=ydpt(k-1)+CMPLX(SIGN(1.,pai),0.)
       ylptmp2=ydpt(k-1)+(0.,1.)
       zxm=REAL(ylptmp1)
       zym=IMAG(ylptmp1)
       za0=pai
       zb0=pbi
       !
       za1=-1./za0
       zb1=zxm - za1*zym
       zyp=-(zb1-zb0)/(za1-za0)
       zxp=za0*zyp + zb0
       zd1=(zxm-zxp)*(zxm-zxp) + (zym-zyp)*(zym-zyp)
       !
       zxm=REAL(ylptmp2)
       zym=IMAG(ylptmp2)
       za1=-1./za0
       zb1=zxm - za1*zym
       zyp=-(zb1-zb0)/(za1-za0)
       zxp=za0*zyp + zb0
       zd2=(zxm-zxp)*(zxm-zxp) + (zym-zyp)*(zym-zyp)
       IF (zd2 <=  zd1) THEN
          ydpti=ylptmp2
       ELSE
          ydpti=ylptmp1
       END IF
    END IF
  END SUBROUTINE interm_pt

  FUNCTION dist(plona,plonb,plata,platb)
    !!----------------------------------------------------------
    !!           ***  FUNCTION  DIST  ***
    !!
    !!  ** Purpose : Compute the distance (km) between
    !!          point A (lona, lata) and B(lonb,latb)
    !!
    !!  ** Method : Compute the distance along the orthodromy
    !!
    !! * history : J.M. Molines in CHART, f90, may 2007
    !!----------------------------------------------------------
    IMPLICIT NONE
    ! Argument
    REAL(KIND=8), INTENT(in) :: plata, plona, platb, plonb
    REAL(KIND=8) :: dist
    ! Local variables
    REAL(KIND=8),SAVE ::  zlatar, zlatbr, zlonar, zlonbr
    REAL(KIND=8) ::  zpds
    REAL(KIND=8),SAVE :: zux, zuy, zuz
    REAL(KIND=8) :: zvx, zvy, zvz

    REAL(KIND=8), SAVE :: prevlat=-1000., prevlon=-1000, zr, zpi, zconv
    LOGICAL :: lfirst=.TRUE.

    ! initialise some values at first call
    IF ( lfirst ) THEN
       lfirst=.FALSE.
       ! constants
       zpi=ACOS(-1.)
       zconv=zpi/180.  ! for degree to radian conversion
       ! Earth radius
       zr=(6378.137+6356.7523)/2.0 ! km
    ENDIF

    ! compute these term only if they differ from previous call
    IF ( plata /= prevlat .OR. plona /= prevlon) THEN
       zlatar=plata*zconv
       zlonar=plona*zconv
       zux=COS(zlonar)*COS(zlatar)
       zuy=SIN(zlonar)*COS(zlatar)
       zuz=SIN(zlatar)
       prevlat=plata
       prevlon=plona
    ENDIF

    zlatbr=platb*zconv
    zlonbr=plonb*zconv
    zvx=COS(zlonbr)*COS(zlatbr)
    zvy=SIN(zlonbr)*COS(zlatbr)
    zvz=SIN(zlatbr)

    zpds=zux*zvx+zuy*zvy+zuz*zvz

    IF (zpds >= 1.) THEN
       dist=0.
    ELSE
       dist=zr*ACOS(zpds)
    ENDIF
  END FUNCTION dist

END PROGRAM cdfovide

PROGRAM cdfgradT
  !!======================================================================
  !!                     ***  PROGRAM  cdfgradT  ***
  !!=====================================================================
  !!  ** Purpose :
  !!
  !!  ** Method  :
  !!
  !! History : 3.0  : 05/2013  : N. Ducousso
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                            :: jk, jt, jvar      ! dummy loop index
  INTEGER(KIND=4)                            :: narg, iargc       ! command line
  INTEGER(KIND=4)                            :: ijarg, ireq       ! command line
  INTEGER(KIND=4)                            :: npiglo, npjglo    ! size of the domain
  INTEGER(KIND=4)                            :: npk, npt          ! size of the domain
  INTEGER(KIND=4)                            :: ncout             ! ncid of output variable
  INTEGER(KIND=4)                            :: ierr              ! error status
  INTEGER(KIND=4)                            :: iup= 1, icurr= 2  ! 
  INTEGER(KIND=4), DIMENSION(6)              :: ipk, id_varout    ! output variable

  REAL(KIND=4), DIMENSION (:),      ALLOCATABLE :: tim              
  REAL(KIND=4), DIMENSION (:,:,:),  ALLOCATABLE :: zt, zs
  REAL(KIND=4), DIMENSION (:,:),    ALLOCATABLE :: umask, vmask, wmask
  REAL(KIND=4), DIMENSION (:,:),    ALLOCATABLE :: e1u, e2v, e3w 

  REAL(KIND=8), DIMENSION (:,:),    ALLOCATABLE :: gradt_x, gradt_y, gradt_z
  REAL(KIND=8), DIMENSION (:,:),    ALLOCATABLE :: grads_x, grads_y, grads_z
 
  CHARACTER(LEN=256)                         :: cf_tfil             ! input file name
  CHARACTER(LEN=256)                         :: cf_out = 'gradT.nc' ! output file name
  CHARACTER(LEN=256), DIMENSION(2)           :: cv_namesi           ! input variable names

  TYPE(variable), DIMENSION(6)               :: stypvar             ! output data structure

  LOGICAL                                    :: lchk = .FALSE.      ! flag for missing files
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  cv_namesi(1) = cn_votemper
  cv_namesi(2) = cn_vosaline

  narg= iargc()
  IF ( narg /= 1 ) THEN
     PRINT *,' usage : cdfgradT T-file'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'      '
     STOP
  ENDIF

  CALL getarg (1, cf_tfil)
  IF (chkfile(cf_tfil) ) STOP ! missing file

  npiglo = getdim (cf_tfil, cn_x)
  npjglo = getdim (cf_tfil, cn_y)
  npk    = getdim (cf_tfil, cn_z)
  npt    = getdim (cf_tfil, cn_t)

  !!  Create output variables
  ipk(:) = npk  !  3D

  stypvar(1)%cname             = 'vozogradt'
  stypvar(1)%cunits            = ''
  stypvar(1)%rmissing_value    = -1000.
  stypvar(1)%valid_min         = -1.
  stypvar(1)%valid_max         = 1.
  stypvar(1)%clong_name        = 'zonal temper gradient'
  stypvar(1)%cshort_name       = 'vozogradt'
  stypvar(1)%conline_operation = 'N/A'
  stypvar(1)%caxis             = 'TZYX'

  stypvar(2)%cname             = 'vomegradt'
  stypvar(2)%cunits            = ''
  stypvar(2)%rmissing_value    = -1000.
  stypvar(2)%valid_min         = -1.
  stypvar(2)%valid_max         = 1.
  stypvar(2)%clong_name        = 'meridional temper gradient'
  stypvar(2)%cshort_name       = 'vomegradt'
  stypvar(2)%conline_operation = 'N/A'
  stypvar(2)%caxis             = 'TZYX'

  stypvar(3)%cname             = 'vovegradt'
  stypvar(3)%cunits            = ''
  stypvar(3)%rmissing_value    = -1000.
  stypvar(3)%valid_min         = -1.
  stypvar(3)%valid_max         = 1.
  stypvar(3)%clong_name        = 'vertical temper gradient'
  stypvar(3)%cshort_name       = 'vovegradt'
  stypvar(3)%conline_operation = 'N/A'
  stypvar(3)%caxis             = 'TZYX'

  stypvar(4)%cname             = 'vozograds'
  stypvar(4)%cunits            = ''
  stypvar(4)%rmissing_value    = -1000.
  stypvar(4)%valid_min         = -1.
  stypvar(4)%valid_max         = 1.
  stypvar(4)%clong_name        = 'zonal saline gradient'
  stypvar(4)%cshort_name       = 'vozograds'
  stypvar(4)%conline_operation = 'N/A'
  stypvar(4)%caxis             = 'TZYX'

  stypvar(5)%cname             = 'vomegrads'
  stypvar(5)%cunits            = ''
  stypvar(5)%rmissing_value    = -1000.
  stypvar(5)%valid_min         = -1.
  stypvar(5)%valid_max         = 1.
  stypvar(5)%clong_name        = 'meridional saline gradient'
  stypvar(5)%cshort_name       = 'vomegrads'
  stypvar(5)%conline_operation = 'N/A'
  stypvar(5)%caxis             = 'TZYX'

  stypvar(6)%cname             = 'vovegrads'
  stypvar(6)%cunits            = ''
  stypvar(6)%rmissing_value    = -1000.
  stypvar(6)%valid_min         = -1.
  stypvar(6)%valid_max         = 1.
  stypvar(6)%clong_name        = 'vertical saline gradient'
  stypvar(6)%cshort_name       = 'vovegrads'
  stypvar(6)%conline_operation = 'N/A'

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  !!  Allocate arrays
  ALLOCATE (tim(npt) )
  ALLOCATE (e1u(npiglo,npjglo), e2v(npiglo,npjglo), e3w(npiglo,npjglo))
  ALLOCATE (umask(npiglo,npjglo), vmask(npiglo,npjglo), wmask(npiglo,npjglo))
  ALLOCATE (zt(npiglo,npjglo,2), zs(npiglo,npjglo,2))
  ALLOCATE (gradt_x(npiglo,npjglo), gradt_y(npiglo,npjglo), gradt_z(npiglo,npjglo))
  ALLOCATE (grads_x(npiglo,npjglo), grads_y(npiglo,npjglo), grads_z(npiglo,npjglo))

  ! create output fileset
  ncout = create      (cf_out, cf_tfil, npiglo, npjglo, npk       )
  ierr  = createvar   (ncout,  stypvar, 6,      ipk,    id_varout )
  ierr  = putheadervar(ncout,  cf_tfil, npiglo, npjglo, npk       )

  tim  = getvar1d(cf_tfil, cn_vtimec, npt     )
  ierr = putvar1d(ncout,  tim,       npt, 'T')

  e1u =  getvar(cn_fhgr, cn_ve1u, 1, npiglo, npjglo)
  e2v =  getvar(cn_fhgr, cn_ve2v, 1, npiglo, npjglo)

  DO jt = 1,npt
  DO jk = npk, 1, -1  !! Main loop : (2 levels of T are required : iup, icurr)
     
     PRINT *,'level ',jk
     
     ! read files
     IF (jk == 1) THEN
        zt(:,:,iup)   = getvar(cf_tfil, cn_votemper, jk, npiglo, npjglo, ktime=jt)
        zt(:,:,icurr) = getvar(cf_tfil, cn_votemper, jk, npiglo, npjglo, ktime=jt)
        zs(:,:,iup)   = getvar(cf_tfil, cn_vosaline, jk, npiglo, npjglo, ktime=jt)
        zs(:,:,icurr) = getvar(cf_tfil, cn_vosaline, jk, npiglo, npjglo, ktime=jt)
     ELSE        
        zt(:,:,iup)   = getvar(cf_tfil, cn_votemper, jk-1, npiglo, npjglo, ktime=jt)
        zt(:,:,icurr) = getvar(cf_tfil, cn_votemper, jk, npiglo, npjglo, ktime=jt)
        zs(:,:,iup)   = getvar(cf_tfil, cn_vosaline, jk-1, npiglo, npjglo, ktime=jt)
        zs(:,:,icurr) = getvar(cf_tfil, cn_vosaline, jk, npiglo, npjglo, ktime=jt)
     END IF

     e3w(:,:) = getvar(cn_fzgr, 'e3w_ps', jk, npiglo, npjglo, ldiom=.true.)
     
     umask(:,:) = getvar(cn_fmsk, 'umask' , jk, npiglo, npjglo )
     vmask(:,:) = getvar(cn_fmsk, 'vmask' , jk, npiglo, npjglo )
     wmask(:,:) = getvar(cn_fmsk, 'tmask' , jk, npiglo, npjglo )

     ! zonal grad located at U point
     gradt_x(:,:) = 0.
     gradt_x(1:npiglo-1,:) = 1. / e1u(1:npiglo-1,:) * &
          &                 ( zt(2:npiglo,:,icurr) - zt(1:npiglo-1,:,icurr) ) * umask(1:npiglo-1,:)
     grads_x(:,:) = 0.
     grads_x(1:npiglo-1,:) = 1. / e1u(1:npiglo-1,:) * &
          &                 ( zs(2:npiglo,:,icurr) - zs(1:npiglo-1,:,icurr) ) * umask(1:npiglo-1,:)

     ! meridional grad located at V point
     gradt_y(:,:) = 0.
     gradt_y(:,1:npjglo-1) = 1. / e2v(:,1:npjglo-1) * &
          &                 ( zt(:,2:npjglo,icurr) - zt(:,1:npjglo-1,icurr) ) * vmask(:,1:npjglo-1)
     grads_y(:,:) = 0.
     grads_y(:,1:npjglo-1) = 1. / e2v(:,1:npjglo-1) * &
          &                 ( zs(:,2:npjglo,icurr) - zs(:,1:npjglo-1,icurr) ) * vmask(:,1:npjglo-1)

     ! vertical grad located at W point
     gradt_z(:,:) = 0.
     gradt_z(:,:) = 1. / e3w(:,:) * ( zt(:,:,iup) - zt(:,:,icurr) ) * wmask(:,:)
     grads_z(:,:) = 0.
     grads_z(:,:) = 1. / e3w(:,:) * ( zs(:,:,iup) - zs(:,:,icurr) ) * wmask(:,:)

     ! write
     ierr = putvar(ncout, id_varout(1), REAL(gradt_x), jk, npiglo, npjglo, ktime=jt)
     ierr = putvar(ncout, id_varout(2), REAL(gradt_y), jk, npiglo, npjglo, ktime=jt)
     ierr = putvar(ncout, id_varout(3), REAL(gradt_z), jk, npiglo, npjglo, ktime=jt)
     ierr = putvar(ncout, id_varout(4), REAL(grads_x), jk, npiglo, npjglo, ktime=jt)
     ierr = putvar(ncout, id_varout(5), REAL(grads_y), jk, npiglo, npjglo, ktime=jt)
     ierr = putvar(ncout, id_varout(6), REAL(grads_z), jk, npiglo, npjglo, ktime=jt)

  END DO
  END DO

  ierr = closeout(ncout)

END PROGRAM cdfgradT

PROGRAM cdfmaskdmp
  !!======================================================================
  !!                     ***  PROGRAM  cdfmaskdmp  ***
  !!=====================================================================
  !!  ** Purpose : Compute 3D mask for AABW relaxation from T and S 
  !!               climatology.
  !!               Store the results on a cdf file.
  !!
  !!  **  Method: read temp and salinity, compute sigma-2
  !!              compute coefs, create mask
  !!
  !! History : 2.1  : 09/2010  : R. Dussin    : Original code from JLS Py version
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE eos
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: ji, jj, jk, jt     ! dummy loop index
  INTEGER(KIND=4)                           :: ierr               ! error status
  INTEGER(KIND=4)                           :: narg, iargc        ! browse command line
  INTEGER(KIND=4)                           :: npiglo, npjglo     ! size of the domain
  INTEGER(KIND=4)                           :: npk, npt           ! size of the domain
  INTEGER(KIND=4)                           :: ncout              ! ncid of output file
  INTEGER(KIND=4), DIMENSION(1)             :: ipk, id_varout     ! level and varid's

  REAL(KIND=4)                              :: ref_dep=2000.      ! reference depth in meters
  REAL(KIND=4)                              :: zsnmin=37.16       ! minimum density
  REAL(KIND=4)                              :: zswidth=0.025      ! tapering width
  REAL(KIND=4)                              :: hmin=1000.         ! depth limit
  REAL(KIND=4)                              :: hwidth=100.        ! depth tapering height
  REAL(KIND=4)                              :: rlatmax=-20        ! max latitude
  REAL(KIND=4)                              :: rlatwidth=2        ! latitude tapering width
  REAL(KIND=4)                              :: wdep, wsig, wlat   ! tapering function dep, sigma and lat
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: ztemp              ! temperature
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zsal               ! salinity
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zsigi              ! sigma-i
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zmask              ! 2D mask at current level
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zwdmp              ! 2D build mask at current level
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zlat               ! latitudes
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: tim                ! time counter
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: zdep               ! deptht

  CHARACTER(LEN=256)                        :: cf_tfil            ! input filename for temperature
  CHARACTER(LEN=256)                        :: cf_sfil            ! input filename for salinity
  CHARACTER(LEN=256)                        :: cf_out='mask_dmp.nc' ! output file name
  CHARACTER(LEN=256)                        :: cldum              ! dummy string
  CHARACTER(LEN=256)                        :: cglobal            ! Global attribute with command name

  TYPE (variable), DIMENSION(1)             :: stypvar            ! structure for attributes
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfmaskdmp T-file S-file  ... '
     PRINT *,'               ... [ref_dep snmin swidth hmin hwidth latmax latwidth]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute a damping mask with smooth transition according to density,'
     PRINT *,'       depth and latitude criteria.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       T-file : temperature file' 
     PRINT *,'       S-file : salinity file' 
     PRINT *,'        They can be the same file, but as many climatologied are provided'
     PRINT *,'        in separate files, we decided to put both in the command line.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'        ** If used, they must all be provided in the correct order (!) **'
     PRINT *,'       ref_dep  : reference depth for potential density.'
     PRINT *,'       snmin    : density minimum for the mask.'
     PRINT *,'       swidth   : density width for tapering'
     PRINT *,'       hmin     : minimum depth'
     PRINT *,'       hwidth   : depth width  for tapering'
     PRINT *,'       latmax   : maximum latitude'
     PRINT *,'       latwidth : latitude width  for tapering'
     PRINT *,'      '
     PRINT *,'       Actual default values are :'
     PRINT *,'        ref_dep  = ', ref_dep
     PRINT *,'        snmin    = ', zsnmin
     PRINT *,'        swidth   = ', zswidth
     PRINT *,'        hmin     = ', hmin
     PRINT *,'        hwidth   = ', hwidth
     PRINT *,'        latmax   = ', rlatmax
     PRINT *,'        latwidth = ', rlatwidth
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ', TRIM(cn_fmsk) 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : wdmp'
     STOP
  ENDIF

  IF ( narg > 2 .AND. narg < 9 ) THEN
     PRINT *,'wrong number of arguments'
     STOP
  ENDIF

  CALL getarg (1, cf_tfil)
  CALL getarg (2, cf_sfil)

  IF ( chkfile(cf_tfil) .OR. chkfile(cf_sfil) ) STOP ! missing files

  IF ( narg == 9 ) THEN
     CALL getarg (3, cldum) ; READ(cldum,*) ref_dep
     CALL getarg (4, cldum) ; READ(cldum,*) zsnmin
     CALL getarg (5, cldum) ; READ(cldum,*) zswidth
     CALL getarg (6, cldum) ; READ(cldum,*) hmin
     CALL getarg (7, cldum) ; READ(cldum,*) hwidth
     CALL getarg (8, cldum) ; READ(cldum,*) rlatmax
     CALL getarg (9, cldum) ; READ(cldum,*) rlatwidth
  ENDIF
  WRITE(cglobal,'(a,a,1x,a,7f9.3)') 'cdfmaskdmp ', TRIM(cf_tfil), TRIM(cf_sfil), ref_dep, zsnmin, &
           &                      zswidth, hmin, hwidth, rlatmax, rlatwidth

  npiglo = getdim (cf_tfil,cn_x)
  npjglo = getdim (cf_tfil,cn_y)
  npk    = getdim (cf_tfil,cn_z)
  npt    = getdim (cf_tfil,cn_t)

  ipk(:)                    = npk  
  stypvar(1)%cname          = 'wdmp'
  stypvar(1)%cunits         = '[0-1]'
  stypvar(1)%rmissing_value = 1.e+20
  stypvar(1)%caxis          = 'TZYX'
  stypvar(1)%valid_min      = 0.
  stypvar(1)%valid_max      = 1.
  stypvar(1)%clong_name     = 'Damping mask build on density criteria'
  stypvar(1)%cshort_name    = 'wdmp'

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  ALLOCATE (ztemp(npiglo,npjglo), zsal( npiglo,npjglo)                      )
  ALLOCATE (zsigi(npiglo,npjglo), zmask(npiglo,npjglo), zlat(npiglo,npjglo) )
  ALLOCATE (zwdmp(npiglo,npjglo) )
  ALLOCATE (tim(npt) , zdep(npk) )

  ! create output fileset
  ncout = create      (cf_out, cf_tfil,  npiglo, npjglo, npk                        )
  ierr  = createvar   (ncout,  stypvar,  1,     ipk,     id_varout, cdglobal=cglobal)
  ierr  = putheadervar(ncout,  cf_tfil,  npiglo, npjglo, npk                        )

  tim(:)    = getvar1d(cf_tfil, cn_vtimec,  npt              )
  zdep(:)   = getvar1d(cf_tfil, cn_vdeptht, npk              )
  zlat(:,:) = getvar  (cf_tfil, cn_vlat2d,  1, npiglo, npjglo)

  ierr=putvar1d(ncout, tim, npt, 'T')

  DO jt = 1, npt
     PRINT *,'time: ',jt
     DO jk = 1, npk
        PRINT *, 'jk = ', jk
        ztemp(:,:) = getvar(cf_tfil, cn_votemper, jk, npiglo, npjglo, ktime=jt)
        zsal( :,:) = getvar(cf_sfil, cn_vosaline, jk, npiglo, npjglo, ktime=jt)
        zmask(:,:) = getvar(cn_fmsk, 'tmask',     jk, npiglo, npjglo          )

        zsigi(:,:) = sigmai( ztemp, zsal, ref_dep, npiglo, npjglo)* zmask(:,:)

        DO jj=1,npjglo
           DO ji=1,npiglo

              wdep = TANH( (zdep(jk    ) - hmin   ) / hwidth   ) / 2. + 0.5
              wsig = TANH( (zsigi(ji,jj) - zsnmin ) / zswidth  ) / 2. + 0.5
              wlat = TANH(-(zlat( ji,jj) - rlatmax) / rlatwidth) / 2. + 0.5

              zwdmp(ji,jj) = wdep * wsig * wlat

           ENDDO
        ENDDO

        zwdmp(:,:) = zwdmp(:,:) * zmask(:,:)

        ierr = putvar(ncout, id_varout(1), zwdmp, jk,npiglo, npjglo, ktime=jt)

     END DO  ! loop to next level
  END DO  ! loop on time

  ierr = closeout(ncout)

END PROGRAM cdfmaskdmp

PROGRAM cdfisf_fill
  !!======================================================================
  !!                     ***  PROGRAM  cdfisf_fill  ***
  !!=====================================================================
  !!  ** Purpose : Build a file containing one value for each closed pools
  !!               seeded by a list of points.
  !!
  !!  ** Method  : flood filling algorithm
  !!               
  !! History : 3.0  : 04/2014  : Pierre Mathiot 
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  USE cdfio 
  USE modcdfnames
  USE modutils
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2014
  !! $Id$
  !! Copyright (c) 2010, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!-----------------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                               :: jisf               ! dummy loop integer 
  INTEGER(KIND=4)                               :: ierr, ipos         ! working integer
  INTEGER(KIND=4)                               :: narg, iargc, ijarg ! browsing command line
  INTEGER(KIND=4)                               :: npiglo, npjglo     ! size of the domain
  INTEGER(KIND=4)                               :: npk, npt, nisf     ! size of the domain
  INTEGER(KIND=4)                               :: iunit=10           ! file unit for txt input file
  INTEGER(KIND=4)                               :: iunitu=11          ! file unit for txt output file
  INTEGER(KIND=4)                               :: ncout              ! ncid of output files
  INTEGER(KIND=4)                               :: iiseed, ijseed
  INTEGER(KIND=4)                               :: ifill
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: ipk                ! arrays of vertical level for each var
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: id_varout          ! varid's of average vars
  INTEGER(KIND=2), DIMENSION(:,:),  ALLOCATABLE :: itab

  REAL(KIND=4)                                  :: rlon, rlat         ! longitude and latitude of one point in ISF
  REAL(KIND=4)                                  :: rdraftmin, rdraftmax
  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: dtab

  CHARACTER(LEN=256)                            :: cf_in              ! input file name
  CHARACTER(LEN=256)                            :: cf_isflist         ! input file name (txt)
  CHARACTER(LEN=256)                            :: cf_isflistup       ! output file name (update of input, with draftmin/max
  CHARACTER(LEN=256)                            :: cf_out='fill.nc'   ! output file for average
  CHARACTER(LEN=256)                            :: cv_dep             ! depth dimension name
  CHARACTER(LEN=256)                            :: cv_in              ! depth dimension name
  CHARACTER(LEN=256)                            :: cdum               ! dummy string argument

  TYPE (variable), DIMENSION(:),    ALLOCATABLE :: stypvar            ! attributes for average values
  LOGICAL                                       :: lnc4 = .FALSE.     ! flag for netcdf4 chunk and deflation

  !!----------------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfisf_fill  -f ISF-file -v ISF-var -l ISF-list [-nc4 ] [-o OUT-file]'
     PRINT *,'      '
     PRINT *,'     PURPOSE : Build a nc file with a single value for each pool around a list'
     PRINT *,'               of given point. A warning is given when neighbouring ice-shelves'
     PRINT *,'               cannot be discriminated (no gap in between). In this case, hand'
     PRINT *,'               edit on the ISF-file is required.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS : '
     PRINT *,'         -f ISF-file : netcdf file  which contains the ice shelf draft variable'
     PRINT *,'                     (mesh_zgr is OK). It is used as a mask, only.'
     PRINT *,'         -v ISF-var  : variable name corresponding to the ice shelf draft or '
     PRINT *,'                      ice shelf level'
     PRINT *,'         -l ISF-list : text file containing at least the following information: '
     PRINT *,'                 1  NAME    LON  LAT I  J '
     PRINT *,'                 ...             '
     PRINT *,'                 i  NAMEi   LON  LAT I  J '
     PRINT *,'                 ...             '
     PRINT *,'                 EOF             '
     PRINT *,'                 No NAME  X    Y   I  J '
     PRINT *,'      '
     PRINT *,'     OPTIONS : '
     PRINT *,'          -nc4 : use NetCDF4 chunking and deflation for the output'
     PRINT *,'          -o OUT-file : specify the name of the output file instead of ',TRIM(cf_out)
     PRINT *,'                 This file will be one of the input file for cdfmkforcingisf '
     PRINT *,'                 as the ISF-fill_file '
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'              netcdf file : fill.nc '
     PRINT *,'              variable : sofillvar contains for all points in ice shelf NAME '
     PRINT *,'                         the value -i (negative value)'
     PRINT *,'              text file : <ISF-list>_zmin_zmax.txt '
     PRINT *,'                        this output file is similar to <ISF-list> but updated'
     PRINT *,'                        with the minimum and maximul value of ice-draft for '
     PRINT *,'                        each shelf.'
     PRINT *,'      '
     PRINT *,'     SEE ALSO : '
     PRINT *,'           cdfisf_forcing,  cdfisf_rnf '
     PRINT *,'      '
     STOP
  ENDIF

  ijarg = 1
  DO WHILE ( ijarg <= narg )
     CALL getarg(ijarg, cdum ) ; ijarg = ijarg + 1 
     SELECT CASE ( cdum)
     CASE ( '-f' ) ; CALL getarg(ijarg, cf_in      ) ; ijarg = ijarg + 1
     CASE ( '-v' ) ; CALL getarg(ijarg, cv_in      ) ; ijarg = ijarg + 1
     CASE ( '-l' ) ; CALL getarg(ijarg, cf_isflist ) ; ijarg = ijarg + 1
     CASE ( '-o' ) ; CALL getarg(ijarg, cf_out     ) ; ijarg = ijarg + 1
     CASE ('-nc4') ; lnc4=.TRUE.
     CASE DEFAULT
        PRINT *, ' Option ', TRIM(cdum),' not understood'
        STOP
     END SELECT
  ENDDO

  IF ( chkfile (cf_in) .OR. chkfile (cf_isflist)  ) STOP ! missing file

  ipos = INDEX(cf_isflist,'.')
  cdum=cf_isflist(ipos+1:)
  cf_isflistup=cf_isflist(1:ipos-1)//'_zmin_zmax.'//TRIM(cdum)

  npiglo = getdim (cf_in, cn_x)
  npjglo = getdim (cf_in, cn_y)
  npk    = getdim (cf_in, cn_z, cdtrue=cv_dep, kstatus=ierr)

  IF (ierr /= 0 ) THEN
     npk   = getdim (cf_in, 'z',cdtrue=cv_dep,kstatus=ierr)
     IF (ierr /= 0 ) THEN
        npk   = getdim (cf_in,'sigma',cdtrue=cv_dep,kstatus=ierr)
        IF ( ierr /= 0 ) THEN 
           npk = getdim (cf_in,'nav_lev',cdtrue=cv_dep,kstatus=ierr)
           IF ( ierr /= 0 ) THEN 
              npk = getdim (cf_in,'levels',cdtrue=cv_dep,kstatus=ierr)
              IF ( ierr /= 0 ) THEN 
                 PRINT *,' assume file with no depth'
                 npk=0
              ENDIF
           ENDIF
        ENDIF
     ENDIF
  ENDIF

  PRINT *, 'NPIGLO = ', npiglo
  PRINT *, 'NPJGLO = ', npjglo
  PRINT *, 'NPK    = ', npk

  ALLOCATE(dtab(npiglo, npjglo))
  ALLOCATE(itab(npiglo, npjglo))

  ALLOCATE (stypvar(1))
  ALLOCATE (ipk(1),id_varout(1))

  CALL CreateOutput 

  ! initialize variable
  dtab(:,:) = 0.d0 
  ! read ice shelf draft data
  dtab = getvar(cf_in, cv_in, 1 ,npiglo, npjglo )
  itab=1
  WHERE ( dtab <=0 ) itab=0
  PRINT *, 'Maximum of ISF-draft : ', MAXVAL(dtab),' m'

  ! open isf-list file
  OPEN(unit=iunit,  file=cf_isflist  , form='formatted', status='old')
  OPEN(unit=iunitu, file=cf_isflistup, form='formatted'              )
  ! get total number of isf
  nisf = 0
  cdum='XXX'
  DO WHILE ( TRIM(cdum) /= 'EOF')
     READ(iunit,*) cdum
     nisf=nisf+1
  END DO
  REWIND(iunit)

  nisf = nisf - 1
  PRINT *, '   Number of ISF found in file list : ', nisf

  ! loop over each ice shelf
  DO jisf=1,nisf
     ! get iiseed, ijseed, ice shelf number ifill
     READ(iunit,*) ifill, cdum, rlon, rlat, iiseed, ijseed
     IF (dtab(iiseed, ijseed) < 0 ) THEN
        PRINT *,'  ==> WARNING: Likely a problem with ',TRIM(cdum)
        PRINT *,'               check separation with neighbours'
     ENDIF
     CALL FillPool2D(iiseed, ijseed,itab, -ifill)

     rdraftmax=MAXVAL(dtab, (itab == -ifill) )
     rdraftmin=MINVAL(dtab, (itab == -ifill) )

     PRINT *,'Iceshelf : ', TRIM(cdum)
     PRINT *,'  index  : ', ifill
     PRINT *,'  code   : ', INT(dtab(iiseed, ijseed ) )
     PRINT *,'  depmin : ', rdraftmin
     PRINT *,'  depmax : ', rdraftmax
     PRINT *,'   '
     WRITE(iunitu,'(i4,1x,a20,2f9.4,2i5,2f8.1)') jisf,ADJUSTL(cdum),rlon, rlat, iiseed, ijseed,rdraftmin,rdraftmax
  END DO
  WRITE(iunitu,'(a)') 'EOF  '
  WRITE(iunitu,'(a5,a20,2a9,2a5,2a8,a)' ) 'No ','NAME                           ',' X',' Y',' I ',' J ',' Zmin',' Zmax',' FWF'

  CLOSE(iunitu)
  CLOSE(iunit)

  ! set to 0 all unwanted point (why not .GE. 0.0, I don't know)
  WHERE (dtab >= 1.d0)
     dtab = 0.0d0
  END WHERE

  ierr = putvar(ncout, id_varout(1), itab, 1, npiglo, npjglo)

  ! close file
  ierr = closeout(ncout)

CONTAINS
  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create the output file. This is done outside the main
    !!               in order to increase readability of the code. 
    !!
    !! ** Method  :  Use global variables, defined in mail 
    !!----------------------------------------------------------------------
  ! define new variables for output
  stypvar(1)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
  stypvar(1)%cname             = 'sofillvar'
  stypvar(1)%cunits            = 'N/A'
  stypvar(1)%rmissing_value    = 0.
  stypvar(1)%valid_min         = -1000.
  stypvar(1)%valid_max         =  1000.
  stypvar(1)%clong_name        = 'Fill var'
  stypvar(1)%cshort_name       = 'sofillvar'
  stypvar(1)%conline_operation = 'N/A'
  stypvar(1)%caxis             = 'TYX'
  stypvar(1)%cprecision        = 'i2'
  ipk(1) = 1  !  2D

  ! create output file taking the sizes in cf_in
  ncout  = create      (cf_out,  cf_in,    npiglo, npjglo, npk, cdep=cv_dep, ld_nc4=lnc4)
  ierr   = createvar   (ncout ,  stypvar,  1,  ipk,    id_varout           , ld_nc4=lnc4)
  ierr   = putheadervar(ncout,   cf_in,    npiglo, npjglo, npk, cdep=cv_dep             )

  END SUBROUTINE CreateOutput

END PROGRAM cdfisf_fill

PROGRAM cdfdifmask
  !!======================================================================
  !!                     ***  PROGRAM  cdfdifmask  ***
  !!=====================================================================
  !!  ** Purpose : Build the difference between 2 mask files
  !!
  !!
  !! History : 2.1  : ??????   : ???          : Original code
  !!           3.0  : 12/2010  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class file_operations
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                            :: jk, jvar               ! dummy loop index
  INTEGER(KIND=4)                            :: ierr                   ! working integer
  INTEGER(KIND=4)                            :: narg, iargc, ijarg     ! browsing command line
  INTEGER(KIND=4)                            :: npiglo, npjglo, npk    ! size of the domain
  INTEGER(KIND=4)                            :: ncout                  ! ncid of output file
  INTEGER(KIND=4), DIMENSION(4)              :: ipk                    ! outptut variables : levels,
  INTEGER(KIND=4), DIMENSION(4)              :: id_varout              ! ncdf varid's

  REAL(KIND=4), DIMENSION (:,:), ALLOCATABLE :: zmask, zmask2          ! 2D mask at current level

  REAL(KIND=8), DIMENSION(:),    ALLOCATABLE :: dtim                   ! dummy time variable

  CHARACTER(LEN=256)                         :: cf_out='mask_diff.nc'  ! Output file name
  CHARACTER(LEN=256)                         :: cf_msk1, cf_msk2       ! name of input files
  CHARACTER(LEN=256)                         :: cv_in                  ! variable name
  CHARACTER(LEN=256)                         :: cldum                  ! working char variable

  TYPE(variable), DIMENSION(4)               :: stypvar                ! data structure

  LOGICAL                                    :: lchk                   ! checking file existence
  LOGICAL                                    :: lnc4 = .FALSE.         ! Use nc4 with chunking and deflation
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfdifmask -m  mask1 mask2 [-o OUT-file] [-nc4]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the difference between 2 NEMO mask files.' 
     PRINT *,'       This difference is not easy to perform with nco.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -m mask1 mask2 : model mask files to be compared.' 
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-o OUT-file ]: specify output file name instead of ',TRIM(cf_out)
     PRINT *,'       [-nc4 ]     : Use netcdf4 output with chunking and deflation level 1.'
     PRINT *,'                 This option is effective only if cdftools are compiled with'
     PRINT *,'                 a netcdf library supporting chunking and deflation.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        none'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) ,' unless -o option is used.'
     PRINT *,'       variables : ',TRIM(cn_tmask),' ', TRIM(cn_umask),' ',TRIM(cn_vmask),' ',TRIM(cn_fmask)
     STOP 
  ENDIF

  ijarg=1
  DO WHILE ( ijarg <= narg )
     CALL getarg(ijarg, cldum) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-m'   ) ; CALL getarg(ijarg, cf_msk1) ; ijarg=ijarg+1
        ;              CALL getarg(ijarg, cf_msk2) ; ijarg=ijarg+1
        ! options
     CASE ( '-o'   ) ; CALL getarg(ijarg, cf_out ) ; ijarg=ijarg+1
     CASE ( '-nc4' ) ; lnc4 = .TRUE.
     CASE DEFAULT    ; PRINT *,' ERROR : ', TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  END DO

  lchk =           chkfile ( cf_msk1 )
  lchk = lchk .OR. chkfile ( cf_msk2 )
  IF ( lchk ) STOP 99 ! missing file

  npiglo = getdim (cf_msk1, cn_x)
  npjglo = getdim (cf_msk1, cn_y)
  npk    = getdim (cf_msk1, 'z' , kstatus=ierr )  ! mask file have a z depth dim instead of depth ...
  IF (ierr /= 0 ) THEN
    npk    = getdim (cf_msk1, 'nav_lev' , kstatus=ierr )  ! mask file have a z depth dim instead of depth ...
    IF (ierr /= 0 ) THEN
      npk    = getdim (cf_msk1, 'deptht' , kstatus=ierr )  ! mask file have a z depth dim instead of depth ...
    ENDIF
  ENDIF
  IF (ierr /= 0 ) THEN
     PRINT *,' E R R O R : Vertical dimension name unknown' ; STOP 99
  ENDIF

  ALLOCATE (zmask(npiglo,npjglo), zmask2(npiglo,npjglo))
  ALLOCATE ( dtim(1) )

  CALL CreateOutput

  DO jvar=1,4
     cv_in = stypvar(jvar)%cname
     PRINT *, ' making difference for ', TRIM(cv_in)
     DO jk=1, npk
        PRINT * ,'jk = ', jk
        zmask(:,:)  = getvar(cf_msk1, cv_in, jk, npiglo, npjglo)
        zmask2(:,:) = getvar(cf_msk2, cv_in, jk, npiglo, npjglo)
        zmask(:,:)  = zmask2(:,:) - zmask(:,:)
        ierr        = putvar(ncout, id_varout(jvar), zmask, jk, npiglo, npjglo)
     END DO  ! loop to next level
  END DO

  ierr   = closeout(ncout)

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    DO jvar = 1, 4
       stypvar(jvar)%ichunk       = (/npiglo,MAX(1,npjglo/30),1,1 /)
    ENDDO
    ipk(:) = npk
    stypvar(:)%cunits            = '1/0'
    stypvar(:)%rmissing_value    = 9999.
    stypvar(:)%valid_min         = 0.
    stypvar(:)%valid_max         = 1.
    stypvar(:)%conline_operation = 'N/A'
    stypvar(:)%caxis             = 'TZYX'
    stypvar(:)%cprecision        = 'by'

    stypvar(1)%cname=cn_tmask ;  stypvar(1)%clong_name=cn_tmask ;  stypvar(1)%cshort_name=cn_tmask
    stypvar(2)%cname=cn_umask ;  stypvar(2)%clong_name=cn_umask ;  stypvar(2)%cshort_name=cn_umask
    stypvar(3)%cname=cn_vmask ;  stypvar(3)%clong_name=cn_vmask ;  stypvar(3)%cshort_name=cn_vmask
    stypvar(4)%cname=cn_fmask ;  stypvar(4)%clong_name=cn_fmask ;  stypvar(4)%cshort_name=cn_fmask

    ncout = create      (cf_out, cf_msk1, npiglo, npjglo, npk,      cdep='z', cdepvar='nav_lev', ld_nc4=lnc4 )
    ierr  = createvar   (ncout,  stypvar, 4,      ipk,    id_varout                            , ld_nc4=lnc4 )
    ierr  = putheadervar(ncout,  cf_msk1, npiglo, npjglo, npk,      cdep='nav_lev'                           )

    dtim(:) = 0.d0
    ierr   = putvar1d(ncout, dtim, 1, 'T')

  END SUBROUTINE CreateOutput

END PROGRAM cdfdifmask

PROGRAM cdfcensus
  !!======================================================================
  !!                     ***  PROGRAM  cdfcensus  ***
  !!=====================================================================
  !!  ** Purpose : Build an array giving the volume of water in a TS cell.
  !!
  !!  ** Method  : T-file and S-file are scanned for a given region 
  !!              (eventually limited in depth) and the volume of water in 
  !!              a (T,S) cell such that T < Tmodele < T+dt and 
  !!              S < Smodele < S+ds.
  !!              If Smodel or T model are out of the bound they are 
  !!              cumulated in the nearest (T,S) cell.
  !!                  The output is done on a bimg file where S is given as
  !!              the x-direction and T the y-direction, the field value 
  !!              being the volume of water. Due to a very large range in 
  !!              the water volume over the TS field the field is indeed 
  !!              the LOG (1 + VOLUME), and even, the scale can be made
  !!              more non-linear by repeating the LOG operation, ie, for 
  !!              example, field=LOG(1 + LOG (1 + VOLUME)). The parameter 
  !!              nlog, passed as command argument can be used to fix the
  !!              number of LOG. If nlog = 0, the true volume is saved.
  !!                 Depending on the user purpose, limiting values tmin,
  !!              tmax, and smin,smax as well as the increments dt, ds can 
  !!              be adjusted.
  !!              output is STILL a dimg file
  !!
  !! History : --   : 02/1997  : J.M. Molines as bimgtools in DYNAMO
  !!           --   : 09/1999  : A. de Miranda for OPA
  !!                : 01/2002  : J.M. Molines : DOctor norm
  !!                : 01/2006  : C. Langlais  : CDF I and partial cell
  !!           2.0  : 03/2006  : J.M. Molines : integration in CDFTOOLS
  !!           2.1  : 12/2006  : J.M. Molines : add sigma-2 and sigma-4 O
  !!           3.0  : 12/2010  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE eos
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2010, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: ji, jj, jk, jt, jlog
  INTEGER(KIND=4)                           :: npiglo, npjglo            ! size of the domain
  INTEGER(KIND=4)                           :: npk, npt                  ! size of the domain
  INTEGER(KIND=4)                           :: nlog
  INTEGER(KIND=4)                           :: narg, iargc, ijarg
  INTEGER(KIND=4)                           :: it, is
  INTEGER(KIND=4)                           :: ii1, ii2
  INTEGER(KIND=4)                           :: ij1, ij2
  INTEGER(KIND=4)                           :: ik1, ik2
  INTEGER(KIND=4)                           :: nt, ns
  INTEGER(KIND=4)                           :: ncout, ierr
  INTEGER(KIND=4), DIMENSION(2)             :: ijloc
  INTEGER(KIND=4), DIMENSION(4)             :: ipk, id_varout

  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zt, zs, rsigma0, rsigma2, rsigma4
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e1t, e2t
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e3t
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zsx, zty
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: rdumdep, tim
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: e31d
  REAL(KIND=4)                              :: ztmin, ztmax, zdt, ztm
  REAL(KIND=4)                              :: zsmin, zsmax, zds, zsm
  REAL(KIND=4)                              :: ztpoint, zspoint, rcmax

  REAL(KIND=8)                              :: dvoltotal, dvolpoint
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dcensus, ddump

  CHARACTER(LEN=256)                        :: cf_tfil
  CHARACTER(LEN=256)                        :: cf_bimg='censusopa.bimg'
  CHARACTER(LEN=256)                        :: cf_out='census.nc'
  CHARACTER(LEN=256)                        :: cglobal
  CHARACTER(LEN=256)                        :: cline1, cline2, cline3, cline4
  CHARACTER(LEN=256)                        :: cldum

  TYPE(variable), DIMENSION(4)              :: stypvar

  LOGICAL                                   :: lcdf=.TRUE. , lbimg=.FALSE.
  LOGICAL                                   :: lchk
  LOGICAL                                   :: lfull = .FALSE.   ! flag for full step

  ! Initialisations
  DATA ztmin, ztmax, zdt /-2.0, 38.0, 0.05/
  DATA zsmin, zsmax, zds /25.0, 40.0, 0.02/
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()


  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage :  cdfcensus T-file nlog [-zoom imin imax jmin jmax] ...'
     PRINT *,'                ... [-klim kmin kmax]  [-full] [-bimg] ... '
     PRINT *,'                ... [-srange smin smax ds ] ...'
     PRINT *,'                ... [-trange tmin tmax dt ] '
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'        Compute the volumetric water mass census: the ocean is divided in'
     PRINT *,'        T,S bins; the program gives the volume of water for each bin.'
     PRINT *,'        A sub-area can be specified, both horizontaly and vertically.'
     PRINT *,'        Temperature and salinity ranges can be also adapted, as well as the'
     PRINT *,'        width of the bins. Default values are provided. In order to attenuate'
     PRINT *,'        the huge maximum values, a log10 operator can be applied many times,'
     PRINT *,'        the number of filter passes being set on the command line.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       T-file  : netcdf file name for temperature and salinity' 
     PRINT *,'       nlog    : number of log10 filter to perform. Can be 0.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-zoom imin imax jmin jmax] : define a model sub-area, in model '
     PRINT *,'                                     coordinates' 
     PRINT *,'       [-klim ik1 ik2            ] : set limits on the vertical.'
     PRINT *,'       [-srange smin smax ds     ] : define the size of the salinity bin'
     PRINT '(a,2f5.1,x,f6.3)','                         defaut is :', zsmin, zsmax, zds
     PRINT *,'       [-trange tmin tmax dt     ] : define the size of the temperatude bin'
     PRINT '(a,2f5.1,x,f6.3)','                         defaut is :', ztmin, ztmax, zdt
     PRINT *,'       [-full                    ] : use for full step computation'
     PRINT *,'       [-bimg                    ] : output on bimg files (to be deprecated).'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ',TRIM(cn_fhgr),'  and ',TRIM(cn_fzgr) 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       - netcdf file : ', TRIM(cf_out) 
     PRINT *,'           variables : volcensus  (10^15 m3 )'
     PRINT *,'                       sigma0  (kg/m3 -1000 )'
     PRINT *,'                       sigma2  (kg/m3 -1000 )'
     PRINT *,'                       sigma3  (kg/m3 -1000 )'
     PRINT *,'       - bimg file   : According to options.'
     STOP
  ENDIF

  ijarg = 1
  CALL getarg(ijarg, cf_tfil) ; ijarg = ijarg + 1
  CALL getarg(ijarg, cldum  ) ; ijarg = ijarg + 1  ; READ(cldum,*) nlog
  cglobal = 'Census computed from '//TRIM(cf_tfil)

  lchk =           chkfile ( cn_fzgr )
  lchk = lchk .OR. chkfile ( cn_fhgr )
  lchk = lchk .OR. chkfile ( cf_tfil  )
  IF ( lchk ) STOP  ! some compulsory files are missing

  PRINT *,' TS_FILE = ',TRIM(cf_tfil)
  PRINT *,' NLOG    = ', nlog

  ! set domain size from TS file
  npiglo = getdim (cf_tfil,cn_x)
  npjglo = getdim (cf_tfil,cn_y)
  npk    = getdim (cf_tfil,cn_z)
  npt    = getdim (cf_tfil,cn_t)

  PRINT *, 'npiglo =', npiglo
  PRINT *, 'npjglo =', npjglo
  PRINT *, 'npk    =', npk
  PRINT *, 'npt    =', npt

  ! Allocate memory
  ALLOCATE (zt(npiglo,npjglo),zs(npiglo,npjglo))
  ALLOCATE (e1t(npiglo,npjglo),e2t(npiglo,npjglo),e31d(npk),e3t(npiglo,npjglo))

  ! Read metrics
  e1t(:,:) = getvar  (cn_fhgr, cn_ve1t, 1, npiglo, npjglo)
  e2t(:,:) = getvar  (cn_fhgr, cn_ve2t, 1, npiglo, npjglo)
  e31d(:)  = getvare3(cn_fzgr, cn_ve3t, npk              )  ! used in full step case

  ! default is full domain, full depth
  ii1 = 1 ; ii2 = npiglo
  ij1 = 1 ; ij2 = npjglo
  ik1 = 1 ; ik2 = npk

  ! Read additional optional argument (zoom)
  DO WHILE ( ijarg <= narg ) 
     CALL getarg(ijarg,cldum) ; ijarg = ijarg + 1
     SELECT CASE ( cldum)
     CASE ( '-zoom' )
        CALL getarg(ijarg,cldum) ; READ(cldum,*) ii1  ; ijarg = ijarg+1
        CALL getarg(ijarg,cldum) ; READ(cldum,*) ii2  ; ijarg = ijarg+1
        CALL getarg(ijarg,cldum) ; READ(cldum,*) ij1  ; ijarg = ijarg+1
        CALL getarg(ijarg,cldum) ; READ(cldum,*) ij2  ; ijarg = ijarg+1
     CASE ( '-klim' )
        CALL getarg(ijarg,cldum) ; READ(cldum,*) ik1  ; ijarg = ijarg+1
        CALL getarg(ijarg,cldum) ; READ(cldum,*) ik2  ; ijarg = ijarg+1
     CASE ( '-bimg' )
        lbimg = .TRUE.
        lcdf  = .FALSE.
     CASE ( '-srange' )
        CALL getarg(ijarg,cldum) ; READ(cldum,*) zsmin ; ijarg = ijarg+1
        CALL getarg(ijarg,cldum) ; READ(cldum,*) zsmax ; ijarg = ijarg+1
        CALL getarg(ijarg,cldum) ; READ(cldum,*) zds   ; ijarg = ijarg+1
     CASE ( '-trange' )
        CALL getarg(ijarg,cldum) ; READ(cldum,*) ztmin ; ijarg = ijarg+1
        CALL getarg(ijarg,cldum) ; READ(cldum,*) ztmax ; ijarg = ijarg+1
        CALL getarg(ijarg,cldum) ; READ(cldum,*) zdt   ; ijarg = ijarg+1
     CASE ( '-full' )
        lfull = .TRUE.
     CASE DEFAULT
        PRINT *,' Unknown option :',TRIM(cldum)
        STOP
     END SELECT
  END DO

  ! Extra checking for over bound
  ii1 = MAX(ii1,1) ; ii2 = MIN(ii2,npiglo)
  ij1 = MAX(ij1,1) ; ij2 = MIN(ij2,npjglo)
  ik1 = MAX(ik1,1) ; ik2 = MIN(ik2,npk   )

  PRINT '(a,6i5)','indices:',ii1, ii2, ij1, ij2, ik1, ik2

  ! Compute the census on the requested domain
  PRINT *,' Water mass census on the file '
  PRINT *, TRIM(cf_tfil)
  PRINT *, ' running .........'
  nt = NINT( (ztmax - ztmin )/zdt + 1 )
  ns = NINT( (zsmax - zsmin )/zds + 1 )

  ! Allocate arrays
  ALLOCATE ( dcensus (ns,nt), ddump(ns,nt) )
  ALLOCATE ( rsigma0(ns,nt), rsigma2(ns,nt), rsigma4(ns,nt) )
  ALLOCATE ( zsx (ns,nt), zty(ns,nt), rdumdep(1), tim(npt))

  ! fill up rsigma0 array with theoretical density
  DO ji=1,ns
     DO jj=1,nt
        zsx(ji,jj) = zsmin + (ji-1)*zds
        zty(ji,jj) = ztmin + (jj-1)*zdt
     END DO
  END DO
  
  rsigma0 = sigma0(zty, zsx,        ns, nt)
  rsigma2 = sigmai(zty, zsx, 2000., ns, nt)
  rsigma4 = sigmai(zty, zsx, 4000., ns, nt)
  rdumdep(1) = 0.

  IF ( lcdf ) THEN
     ! create output fileset
     ipk(:)= 1                  
     stypvar%rmissing_value    = -100.
     stypvar%valid_min         = 0.
     stypvar%valid_max         = 1.e20
     stypvar%conline_operation = 'N/A'
     stypvar%caxis             = 'TYX'

     stypvar(1)%cname          = 'volcensus'
     stypvar(2)%cname          = 'sigma0'
     stypvar(3)%cname          = 'sigma2'
     stypvar(4)%cname          = 'sigma4'

     stypvar(1)%cunits         = 'm3'
     stypvar(2:4)%cunits       = 'kg/m3'

     stypvar(1)%clong_name     = 'Volume_Census_TS'
     stypvar(2)%clong_name     = 'Sigma0_TS'
     stypvar(3)%clong_name     = 'Sigma2_TS'
     stypvar(4)%clong_name     = 'Sigma4_TS'

     stypvar(1)%cshort_name    = 'volcensus'
     stypvar(2)%cshort_name    = 'sigma0'
     stypvar(3)%cshort_name    = 'sigma2'
     stypvar(4)%cshort_name    = 'sigma4'

     ncout = create      (cf_out, cf_tfil,  ns, nt,  1                                           )
     ierr  = createvar   (ncout,  stypvar,  4,  ipk, id_varout, cdglobal=cglobal                 )
     ierr  = putheadervar(ncout,  cf_tfil,  ns, nt,  1,   pnavlon=zsx, pnavlat=zty, pdep=rdumdep )
  ENDIF

  DO jt = 1, npt
     ! reset cumulating variables to 0
     dcensus(:,:) = 0.d0
     dvoltotal    = 0.d0
     ! Enter main loop
     DO jk=ik1,ik2
        zt(:,:) = getvar(cf_tfil, cn_votemper, jk, npiglo, npjglo, ktime = jt)
        zs(:,:) = getvar(cf_tfil, cn_vosaline, jk, npiglo, npjglo, ktime = jt)

        IF ( lfull ) THEN
           e3t(:,:) = e31d(jk)
        ELSE
           e3t(:,:) = getvar(cn_fzgr, 'e3t_ps', jk, npiglo, npjglo, ldiom=.TRUE.)
        ENDIF

        DO ji=ii1,ii2
           DO jj=ij1,ij2
              ztpoint   = zt(ji,jj)
              zspoint   = zs(ji,jj)
              dvolpoint = e1t(ji,jj)*e2t(ji,jj)*e3t(ji,jj)*1.d0

              ! salinity = 0 on masked points ( OPA !!! )
              IF (zspoint /= 0) THEN
                 it=NINT( (ztpoint-ztmin)/zdt) + 1
                 is=NINT( (zspoint-zsmin)/zds) + 1
                 ! check for out of bound values
                 it = MIN ( MAX(it,1), nt )
                 is = MIN ( MAX(is,1), ns )

                 dcensus(is,it) = dcensus(is,it) + dvolpoint*1.d-15
                 dvoltotal      = dvoltotal      + dvolpoint*1.d-15
              END IF
           END DO
        END DO

     END DO  ! Main loop

     ! Computes some statistics
     rcmax = MAXVAL ( dcensus )
     ijloc = MAXLOC ( dcensus )
     zsm    = zsmin + (ijloc(1) -1 ) * zds
     ztm    = ztmin + (ijloc(2) -1 ) * zdt

     PRINT *,'  Total Volume of the domain in  10^15 m3:', REAL(dvoltotal)
     PRINT *,'  Volume of the most represented water mass :', rcmax 
     PRINT '(a,f6.2,a)' ,'       this is about ', rcmax/dvoltotal *100,' % of the total'
     PRINT *,'     Salinity   = ', zsm
     PRINT *,'     Temperature= ', ztm

     ! use a distorsion function ( n x log ) to reduce extrema in the output file.
     ddump(:,:) = dcensus(:,:)
     DO jlog = 1, nlog
        ddump(:,:) = LOG10 (1.d0 + ddump(:,:) )
     ENDDO

     IF ( lcdf ) THEN
        ! Output on census.nc file
        ierr = putvar(ncout, id_varout(1), REAL(ddump), 1, ns, nt, ktime=jt)
        ierr = putvar(ncout, id_varout(2), rsigma0,     1, ns, nt, ktime=jt)
        ierr = putvar(ncout, id_varout(3), rsigma2,     1, ns, nt, ktime=jt)
        ierr = putvar(ncout, id_varout(4), rsigma4,     1, ns, nt, ktime=jt)
     ENDIF
  ENDDO  ! time loop

  IF ( lcdf ) THEN
     tim  = getvar1d(cf_tfil, cn_vtimec, npt     )
     ierr = putvar1d(ncout,   tim,       npt, 'T')
     ierr = closeout(ncout)
  ENDIF

  IF (lbimg ) THEN
     ! Output on bimg file
     OPEN (10,file=cf_bimg,form='UNFORMATTED')

     WRITE(cline1,942)' Water Masses Census [10-15 m3] on',ii1,ii2,ij1,ij2
942  FORMAT(a,4i5)
     cline2 = '   computed from the following T-S files:'
     cline3 = cf_tfil
     cline4 = ''
     !
     WRITE(10) cline1
     WRITE(10) cline2
     WRITE(10) cline3
     WRITE(10) cline4
     WRITE(10) ns, nt, 1, 1, 4, nlog
     WRITE(10) zsmin, ztmin, zds, zdt, 0.
     WRITE(10) 0.
     WRITE(10) 0.
     WRITE(10) ((REAL(ddump(ji,jj)),ji=1,ns),jj=1,nt)
     WRITE(10) ((rsigma0(ji,jj),    ji=1,ns),jj=1,nt)
     WRITE(10) ((rsigma2(ji,jj),    ji=1,ns),jj=1,nt)
     WRITE(10) ((rsigma4(ji,jj),    ji=1,ns),jj=1,nt)
     CLOSE(10)
  ENDIF

  PRINT *,' Done.'
END PROGRAM cdfcensus

PROGRAM cdftransport
  !!======================================================================
  !!                     ***  PROGRAM  cdftransport  ***
  !!=====================================================================
  !!  ** Purpose : Compute Transports across a section. 
  !!               By default, mass (Sv) and  heat(PW)/salt(kT/s) transports
  !!               are computed unless -noheat option is used (mass 
  !!               transport only).
  !!
  !!  ** Method  : The begining and end point of the section are given in 
  !!               term of F-points index. A broken line joining successive
  !!               F-points is defined between the begining and end point
  !!               of the section. Therefore each segment between F-points
  !!               is either a zonal or meridional segment corresponding to
  !!               V or U velocity component. Doing so, the volume conservation
  !!               is ensured as velocities are not interpolated, and stay 
  !!               on the native model grid. 
  !!                 The section name and the begin/end point of a section are
  !!               read from standard input, till 'EOF' is given as section
  !!               name. This make possible to give a bunch of sections in 
  !!               an ASCII files and use the < redirection.
  !!            SIGN CONVENTION : The transport is positive when the flow cross
  !!               the section to the right, negative otherwise. This depends
  !!               on the sense the section is described.  With this convention
  !!               The algebric sum of transports accross sections forming a 
  !!               closed area is 0. 
  !!            OPTIONS :
  !!               -full   : full step case
  !!               -noheat : only mass transport is computed.
  !!               -time   : specify the time frame to be used
  !!               -zlimit : transports can be computed in different depth layers
  !!                         defined by their depth limit
  !!            REQUIREMENT :
  !!               mesh-mask file are required in the current directory.
  !!            
  !!
  !! History : 2.1  : 01/2005  : J.M. Molines : Original code
  !!           2.1  : 07/2009  : R. Dussin : add cdf output
  !!           2.1  : 01/2010  : M.A. Balmaseda : Change integration signs 
  !!                             so that the transport across a segment is 
  !!                             independent of the chosen trajectory.
  !!           3.0  : 04/2011  : J.M. Molines : Doctor norm + Lic.
  !!         :  4.0  : 03/2017  : J.M. Molines
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  !!   routines      : description
  !!  interm_pt  : choose intermediate points on a broken line.
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  USE modutils       ! for global attribute
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)  
  !! @class transport
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4), PARAMETER                  :: jpseg=10000    ! used for broken line algorithm
  INTEGER(KIND=4)                             :: jclass, jseg   ! dummy loop index
  INTEGER(KIND=4)                             :: ji, jj, jk     ! dummy loop index
  INTEGER(KIND=4)                             :: it             ! time index
  INTEGER(KIND=4)                             :: ipos           ! working integer (position of ' ' in strings)
  INTEGER(KIND=4)                             :: ncout, ierr    ! for netcdf output
  INTEGER(KIND=4)                             :: ncoutc         ! for netcdf output
  INTEGER(KIND=4)                             :: nvarout=12     ! number of values to write in cdf output
  INTEGER(KIND=4)                             :: nvaroutc=6     ! number of values to write in cumulative output
  INTEGER(KIND=4)                             :: ivtrp          ! var index of volume transport (barotrope)
  INTEGER(KIND=4)                             :: iptrp          ! var index of volume transport (barotrope)
  INTEGER(KIND=4)                             :: imtrp          ! var index of volume transport (barotrope)
  INTEGER(KIND=4)                             :: ihtrp          ! var index of heat transport (barotrope)
  INTEGER(KIND=4)                             :: istrp          ! var index of sal transport (barotrope)
  INTEGER(KIND=4)                             :: ivtrpcl        ! var index of volume transport (p. class)
  INTEGER(KIND=4)                             :: iptrpcl        ! var index of volume transport (p. class)
  INTEGER(KIND=4)                             :: imtrpcl        ! var index of volume transport (p. class)
  INTEGER(KIND=4)                             :: ihtrpcl        ! var index of heat transport (p. class)
  INTEGER(KIND=4)                             :: istrpcl        ! var index of sal transport (p. class)
  INTEGER(KIND=4)                             :: ivtrpc         ! var index of volume cumulated transport (p. class)
  INTEGER(KIND=4)                             :: ihtrpc         ! var index of heat cumulated transport (p. class)
  INTEGER(KIND=4)                             :: istrpc         ! var index of sal cumulated transport (p. class)
  INTEGER(KIND=4)                             :: ivtrpclc       ! var index of volume cumulated transport (p. class)
  INTEGER(KIND=4)                             :: ihtrpclc       ! var index of heat cumulated transport (p. class)
  INTEGER(KIND=4)                             :: istrpclc       ! var index of sal cumulated transport (p. class)
  INTEGER(KIND=4)                             :: ilonmin        ! var index of starting section longitude
  INTEGER(KIND=4)                             :: ilonmax        ! var index of ending section longitude
  INTEGER(KIND=4)                             :: ilatmin        ! var index of starting section latitude
  INTEGER(KIND=4)                             :: ilatmax        ! var index of ending section latitude
  INTEGER(KIND=4)                             :: itop           ! var index of top depth class
  INTEGER(KIND=4)                             :: ibot           ! var index of bottom depth class
  INTEGER(KIND=4)                             :: ikx=1, iky=1   ! dims of netcdf output file
  INTEGER(KIND=4)                             :: numout  = 10   ! logical unit for output file (overall)
  INTEGER(KIND=4)                             :: numvtrp = 11   ! logical unit for volume transport file
  INTEGER(KIND=4)                             :: numhtrp = 12   ! logical unit for heat transport file
  INTEGER(KIND=4)                             :: numstrp = 14   ! logical unit for salt trp file 
  INTEGER(KIND=4)                             :: nclass,ndep    ! number of depth class
  INTEGER(KIND=4)                             :: narg, iargc    ! command line 
  INTEGER(KIND=4)                             :: ijarg, nxtarg  !  "       "
  INTEGER(KIND=4)                             :: npiglo, npjglo ! size of the domain
  INTEGER(KIND=4)                             :: npk, npt       ! size of the domain
  INTEGER(KIND=4)                             :: iimin, iimax   ! i-limit of the section
  INTEGER(KIND=4)                             :: ijmin, ijmax   ! j-limit of the section
  INTEGER(KIND=4)                             :: ivar, itime    ! working integer
  INTEGER(KIND=4)                             :: ii, ij, ik     ! working integer
  INTEGER(KIND=4)                             :: ii0, ij0       !  "        "             "
  INTEGER(KIND=4)                             :: ii1, ij1       !  "        "             "
  INTEGER(KIND=4)                             :: iitmp, ijtmp   !  "        "             "
  INTEGER(KIND=4)                             :: np, nn         ! segment counters, 
  INTEGER(KIND=4)                             :: iist, ijst     ! local point offset for velocity
  INTEGER(KIND=4)                             :: norm_u, norm_v ! normalization factor (sign of normal transport)
  INTEGER(KIND=4)                             :: idirx, idiry   ! sense of description of the section
  INTEGER(KIND=4), DIMENSION(:),  ALLOCATABLE :: ilev0, ilev1   ! limit in levels  (nclass)
  INTEGER(KIND=4), DIMENSION(:),  ALLOCATABLE :: ipk, id_varout ! Netcdf output
  INTEGER(KIND=4), DIMENSION(:),  ALLOCATABLE :: ipkc, id_varoutc ! Netcdf output

  REAL(KIND=4)                                :: rxi0, ryj0     ! working variables
  REAL(KIND=4)                                :: rxi1, ryj1     ! working variables
  REAL(KIND=4)                                :: ai, bi         ! equation of line (y=ai.x +bi)
  REAL(KIND=4)                                :: aj, bj         ! equation of line (x=aj.y +bj
  REAL(KIND=4)                                :: rd, rd1, rd2   ! distance between point, between vertical layers
  REAL(KIND=4)                                :: udum, vdum     ! dummy velocity components for tests
  REAL(KIND=4)                                :: rau0=1000      ! density of pure water (kg/m3)
  REAL(KIND=4)                                :: rcp=4000.      ! heat capacity (J/kg/K)
  REAL(KIND=4)                                :: zspu, zspv     ! missing values for u and v
  REAL(KIND=4), DIMENSION(2)                  :: gla, gphi      ! lon/lat of the begining/end of section (f point)
  REAL(KIND=4), DIMENSION(jpseg)              :: rxx, ryy       ! working variables
  REAL(KIND=4), DIMENSION(jpseg,1)            :: rdumseg        ! working variables
  REAL(KIND=4), DIMENSION(:),     ALLOCATABLE :: gdepw          ! depth at layer interface
  REAL(KIND=4), DIMENSION(:),     ALLOCATABLE :: e31d           ! vertical metric in case of full step
  REAL(KIND=4), DIMENSION(:),     ALLOCATABLE :: rclass         ! vertical metric in case of full step
  REAL(KIND=4), DIMENSION(:),     ALLOCATABLE :: rz_lst         ! limit beetween depth level, in m (nclass -1)
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: e1v, e2u       ! horizontal metric
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: e3u, e3v       ! vertical metric
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: glamf          ! longitudes of F points
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: glamu          ! longitudes of U points
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: glamv          ! longitudes of V points
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: gphif          ! latitudes of F points
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: gphiu          ! latitudes of U points
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: gphiv          ! latitudes of V points
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: rlonsec        ! longitudes in case of section read
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: rlatsec        ! latitudes in case of section read
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: rdum           ! dummy (1x1) array for ncdf output
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: zuobc, zvobc   ! arrays for OBC files (vertical slice)


  ! at every model point
  REAL(KIND=8), DIMENSION(:),     ALLOCATABLE :: dtim           ! time counter
  REAL(KIND=8), DIMENSION(:,:),   ALLOCATABLE :: dwku,  dwkv    ! volume transport at each cell boundary
  REAL(KIND=8), DIMENSION(:,:),   ALLOCATABLE :: dwkut, dwkvt   ! heat   transport at each cell boundary
  REAL(KIND=8), DIMENSION(:,:),   ALLOCATABLE :: dwkus, dwkvs   ! salt   transport at each cell boundary
  REAL(KIND=8), DIMENSION(:,:),   ALLOCATABLE :: dwkup, dwkvp   ! volume transport in the positive direction
  REAL(KIND=8), DIMENSION(:,:),   ALLOCATABLE :: dwkum, dwkvm   !  volume transport in the negatibe direction
  REAL(KIND=8), DIMENSION(:,:),   ALLOCATABLE :: dlu, dlut, dlus   ! Zonal velocities and uT uS
  REAL(KIND=8), DIMENSION(:,:),   ALLOCATABLE :: dlv, dlvt, dlvs   ! Meridional velocities and uT uS
  REAL(KIND=8), DIMENSION(:,:),   ALLOCATABLE :: dlt, dls         ! temperature and salinity
  REAL(KIND=8), DIMENSION(:,:,:), ALLOCATABLE :: dtrpu,  dtrpv  ! volume transport integrated in depth class
  REAL(KIND=8), DIMENSION(:,:,:), ALLOCATABLE :: dtrput, dtrpvt ! heat transport integrated in depth class
  REAL(KIND=8), DIMENSION(:,:,:), ALLOCATABLE :: dtrpus, dtrpvs ! salt transport integrated in depth class
  REAL(KIND=8), DIMENSION(:,:,:), ALLOCATABLE :: dtrpup, dtrpvp ! volume transport integrated in depth class (positive)
  REAL(KIND=8), DIMENSION(:,:,:), ALLOCATABLE :: dtrpum, dtrpvm ! volume transport integrated in depth class (negative)
  ! for a given section
  REAL(KIND=8), DIMENSION(:),     ALLOCATABLE :: dvoltrpsum     ! volume transport by depth class across section
  REAL(KIND=8), DIMENSION(:),     ALLOCATABLE :: dvoltrpsump    ! volume transport by depth class across section
  REAL(KIND=8), DIMENSION(:),     ALLOCATABLE :: dvoltrpsumm    ! volume transport by depth class across section
  REAL(KIND=8), DIMENSION(:),     ALLOCATABLE :: dheatrpsum     ! heat transport by depth class across section
  REAL(KIND=8), DIMENSION(:),     ALLOCATABLE :: dsaltrpsum     ! salt transport by depth class across section
  REAL(KIND=8), DIMENSION(:),     ALLOCATABLE :: dvolallegcl    ! over all leg volume transport by depth class
  REAL(KIND=8), DIMENSION(:),     ALLOCATABLE :: dvolallegclp   ! over all leg volume transport by depth class +
  REAL(KIND=8), DIMENSION(:),     ALLOCATABLE :: dvolallegclm   ! over all leg volume transport by depth class -
  REAL(KIND=8), DIMENSION(:),     ALLOCATABLE :: dheatallegcl   ! over all leg heat transport by depth class 
  REAL(KIND=8), DIMENSION(:),     ALLOCATABLE :: dsaltallegcl   ! over all leg salt transport by depth class 
  REAL(KIND=8), DIMENSION(jpseg)              :: dvoltrp        ! volume transport across each segment of a section
  REAL(KIND=8), DIMENSION(jpseg)              :: dvoltrpp       ! volume transport across each segment of a section
  REAL(KIND=8), DIMENSION(jpseg)              :: dvoltrpm       ! volume transport across each segment of a section
  REAL(KIND=8), DIMENSION(jpseg)              :: dheatrp        ! heat transport across each segment of a section
  REAL(KIND=8), DIMENSION(jpseg)              :: dsaltrp        ! salt transport across each segment of a section
  REAL(KIND=8), DIMENSION(jpseg)              :: dvoltrpcbtp    ! cumulative volume transportin  section integrated over the classes
  REAL(KIND=8), DIMENSION(jpseg)              :: dheatrpcbtp    ! cumulative heat transportin  section integrated over the classes
  REAL(KIND=8), DIMENSION(jpseg)              :: dsaltrpcbtp    ! cumulative salt transportin  section integrated over the classes
  REAL(KIND=8)                                :: dvoltrpbrtp    ! volume transport integrated over the whole depth
  REAL(KIND=8)                                :: dvoltrpbrtpp   ! volume transport integrated over the whole depth
  REAL(KIND=8)                                :: dvoltrpbrtpm   ! volume transport integrated over the whole depth
  REAL(KIND=8)                                :: dheatrpbrtp    ! heat transport integrated over the whole depth
  REAL(KIND=8)                                :: dsaltrpbrtp    ! salt transport integrated over the whole depth
  REAL(KIND=8)                                :: dvolalleg      ! over all leg sum of volume transport
  REAL(KIND=8)                                :: dvolallegp     ! over all leg sum of volume transport +
  REAL(KIND=8)                                :: dvolallegm     ! over all leg sum of volume transport -
  REAL(KIND=8)                                :: dheatalleg     ! over all leg sum of heat transport 
  REAL(KIND=8)                                :: dsaltalleg     ! over all leg sum of salt transport 

  COMPLEX, DIMENSION(jpseg)                   :: yypt           ! array of points coordinates in a section
  COMPLEX                                     :: yypti          ! working point

  TYPE(variable), DIMENSION(:),   ALLOCATABLE :: stypvar        ! structure of output
  TYPE(variable), DIMENSION(:),   ALLOCATABLE :: stypvarc       ! structure of output

  CHARACTER(LEN=256)                          :: cf_utfil       ! UT file  (in)
  CHARACTER(LEN=256)                          :: cf_vtfil       ! VT file  (in)
  CHARACTER(LEN=256)                          :: cf_tfil        ! T file  (in)
  CHARACTER(LEN=256)                          :: cf_sfil        ! S file  (in) optional
  CHARACTER(LEN=256)                          :: cf_ufil        ! U file   (in)
  CHARACTER(LEN=256)                          :: cf_vfil        ! V file   (in)
  CHARACTER(LEN=256)                          :: cf_cumul       ! cumulated transpot file   (out)
  CHARACTER(LEN=256)                          :: cf_out='section_trp.dat'  ! output file name (ASCII)
  CHARACTER(LEN=256)                          :: cf_outnc            ! output netcdf file
  CHARACTER(LEN=256)                          :: cf_vtrp='vtrp.txt'  ! output volume transport file
  CHARACTER(LEN=256)                          :: cf_htrp='htrp.txt'  ! output heat transport file
  CHARACTER(LEN=256)                          :: cf_strp='strp.txt'  ! output salt transport file
  CHARACTER(LEN=256)                          :: csection            ! section names
  CHARACTER(LEN=256)                          :: cvarname            ! variable names (root)
  CHARACTER(LEN=256)                          :: clongname           ! variable longname (root)
  CHARACTER(LEN=512)                          :: cglobal             ! global attribute
  CHARACTER(LEN=256)                          :: cldum               ! dummy char variable
  CHARACTER(LEN=256)                          :: cline               ! dummy char variable
  CHARACTER(LEN=256)                          :: csfx='transports'   ! suffix for the netcdf outputfile
  CHARACTER(LEN=256), DIMENSION(3)            :: cldumt              ! dummy char variable

  LOGICAL                                     :: ltest   = .FALSE.   ! flag for test case
  LOGICAL                                     :: lfull   = .FALSE.   ! flag for full step case
  LOGICAL                                     :: lheat   = .TRUE.    ! flag for skipping heat/salt transport computation
  LOGICAL                                     :: lchk    = .FALSE.   ! flag for missing files
  LOGICAL                                     :: lpm     = .FALSE.   ! flag for plus/minus transport
  LOGICAL                                     :: lobc    = .FALSE.   ! flag for obc input files
  LOGICAL                                     :: lspu    = .FALSE.   ! flag for spvalu /= 0 
  LOGICAL                                     :: lspv    = .FALSE.   ! flag for spvalv /= 0 
  LOGICAL                                     :: l_merid = .FALSE.   ! flag for meridional obc
  LOGICAL                                     :: l_zonal = .FALSE.   ! flag for zonal obc
  LOGICAL                                     :: l_tsfil = .FALSE.   ! flag for using T file instead of VT file
  LOGICAL                                     :: l_self  = .FALSE.   ! flag for self mesh/mask files in the input
  LOGICAL                                     :: l_cumul = .FALSE.   ! flag for cumulated transport output
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  ! Print usage if no argument
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdftransport -u U-file -v V-file [-t T-file] [-s S-file] '
     PRINT *,'                  ... [-vt VT-file] [-vtvar VT-var VS-var ]'
     PRINT *,'                  ... [-ut UT-file] [-utvar UT-var US-var ]'
     PRINT *,'                  ... [-test  u v ] [-noheat ] [-pm ] [-obc] [-TS] ... '
     PRINT *,'                  ... [-full] [-time jt] [-vvl] [-self] ...'
     PRINT *,'                  ... [-zlimit dep_list] [-sfx suffix][-cumul]'
     PRINT *,'      '
     PRINT *,'    PURPOSE :'
     PRINT *,'      Compute the transports (volume, heat and salt) accross a section.'
     PRINT *,'      The name of the section and the imin, imax, jmin, jmax for the section '
     PRINT *,'      is read from the standard input. To finish the program use the key name'
     PRINT *,'      ''EOF'' for the section name. It may be usefull to use the syntax :'
     PRINT *,'      ''cdftransport [..options.. ] < section_file.txt''. Section corresponds'
     PRINT *,'      to a line between 2 F-points A(imin, jmin) and B(imax,jmax). The order'
     PRINT *,'      of the points does matter: when travelling from A to B, transports to '
     PRINT *,'      the right are positive, transports to the left are negative.   '
     PRINT *,'      OBC U,V files can be used if -obc option is specified.'
     PRINT *,'      Extracted broken lines files can also be used with option -self.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'      -u U-file  : netcdf file with the zonal velocity component.'
     PRINT *,'      -v V-file  : netcdf file with the meridional velocity component.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'      [-vt VT-file]: netcdf file with mean values of vt, vs, ut, us for heat'
     PRINT *,'                    and salt transport. This option is mandatory unless '
     PRINT *,'                    -noheat option is used. If VT-file only hold V-fields,'
     PRINT *,'                    use also -ut option for U-fields.'
     PRINT *,'      [-ut UT-file]: netcdf file with mean values of  ut, us for heat'
     PRINT *,'                    and salt transport. This option is used when all variables'
     PRINT *,'                    are not in VT-file.'
     PRINT *,'      [ -utvar UT-var US-var ] : specify the name of the ut us variables in'
     PRINT *,'                    UT-file.'
     PRINT *,'      [ -vtvar VT-var VS-var ] : specify the name of the vt vs variables in'
     PRINT *,'                    VT-file.'
     PRINT *,'      [-t T-file]: Temperature and Salinity file used with -TS option.'
     PRINT *,'      [-s S-file]: Salinity file (-TS option), if salinity not in T-file.'
     PRINT *,'      [-test u v]: use constant the u and v velocity components for sign '
     PRINT *,'                    test purpose.'
     PRINT *,'      [-noheat ] : use when heat and salt transport are not requested.'
     PRINT *,'      [-pm ]     : separate positive and negative contribution to'
     PRINT *,'                    the volume transport. This option implicitly set -noheat,'
     PRINT *,'                    and must be used before the file names.'
     PRINT *,'      [-obc ]    : indicates that input files are obc files (vertical slices)'
     PRINT *,'                   Take care that for this case, mesh files must be adapted.'
     PRINT *,'                   This option implicitly set -noheat, and must be used before'
     PRINT *,'                   the file names.'
     PRINT *,'      [-TS ]     : Indicate that UT VT US VS will be recomputed from T U V'
     PRINT *,'                   files. In this case use -t T-file option.'
     PRINT *,'      [-full ]   : use for full step configurations.'
     PRINT *,'      [-time jt ]: compute transports for time index jt. Default is 1.'
     PRINT *,'      [-vvl  ]   : use time varying  vertical metrics e3 read in the data file'
     PRINT *,'      [-zlimit dep_list] : Specify a list of depth (meters) defining the '
     PRINT *,'                   limits of classes for which transports will be computed.'
     PRINT *,'                   If not used, the transports are computed for the whole water'
     PRINT *,'                   column. Example : -zlimit 500 1000 creates 3 classes :'
     PRINT *,'                           0-500 '
     PRINT *,'                         500-1000 '
     PRINT *,'                        1000-bottom '
     PRINT *,'      [-self ] : This option indicates that input files corresponds to a '
     PRINT *,'                  broken line, hence  data files hold the metrics. In this '
     PRINT *,'                  case, the input file is considered as a V-file, and must'
     PRINT *,'                  specified with -v option.'
     PRINT *,'      [-sfx suffix] : use suffix instead of ',TRIM(csfx), ' in the netcdf'
     PRINT *,'                  output file. '
     PRINT *,'      [-cumul]   : Save cumulative transports along the section in a separate'
     PRINT *,'                   file. '
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'      Files ',TRIM(cn_fhgr),', ',TRIM(cn_fzgr),' must be in the current directory.'
     PRINT *,'            unless -self option is used.'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'      - Standard output '
     PRINT *,'      - ASCII file reflecting the standard output: section_<SUFFIX>.dat'
     PRINT *,'      - ASCII files for volume, heat and salt transport: v<SUFFIX>.txt,'
     PRINT *,'          h<SUFFIX>.txt and s<SUFFIX>.txt.'
     PRINT *,'      - Netcdf files for each section. <SECTION>_<SUFFIX>.nc. '
     PRINT *,'        Default <SUFFIX> is ',TRIM(csfx),' and can be changed with -sfx option.'
     PRINT *,'      - In case of -cumul option extra .nc file will be named <SECTION>_<SUFFIX>_cumul.nc.'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'       cdfsigtrp cdf_xtrac_brokenline'
     PRINT *,'      '
     STOP 
  ENDIF

  itime  = 1
  nclass = 1
  ijarg  = 1
  CALL SetGlobalAtt(cglobal)
  cf_sfil='none'
  cf_utfil='none'

  ! Browse command line for arguments and/or options
  DO WHILE (ijarg <= narg )
     CALL getarg (ijarg, cldum) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ('-vt'    ) ; CALL getarg (ijarg, cf_vtfil) ; ijarg=ijarg+1 
     CASE ('-ut'    ) ; CALL getarg (ijarg, cf_utfil) ; ijarg=ijarg+1 
     CASE ('-utvar' ) ; CALL getarg (ijarg, cn_vozout); ijarg=ijarg+1 
         ;            ; CALL getarg (ijarg, cn_vozous); ijarg=ijarg+1 
     CASE ('-vtvar' ) ; CALL getarg (ijarg, cn_vomevt); ijarg=ijarg+1 
         ;            ; CALL getarg (ijarg, cn_vomevs); ijarg=ijarg+1 
     CASE ('-u'     ) ; CALL getarg (ijarg, cf_ufil ) ; ijarg=ijarg+1 
     CASE ('-v'     ) ; CALL getarg (ijarg, cf_vfil ) ; ijarg=ijarg+1 
     CASE ('-t'     ) ; CALL getarg (ijarg, cf_tfil ) ; ijarg=ijarg+1 
     CASE ('-s'     ) ; CALL getarg (ijarg, cf_sfil ) ; ijarg=ijarg+1 
     CASE ('-test ' ) ; CALL getarg (ijarg, cldum   ) ; ijarg=ijarg+1 ; READ(cldum,*) udum
        ;               CALL getarg (ijarg, cldum   ) ; ijarg=ijarg+1 ; READ(cldum,*) vdum
        ;               ltest = .TRUE. 
     CASE ('-full'  ) ; lfull = .TRUE.
     CASE ('-noheat') ; lheat = .FALSE.
     CASE ('-time'  ) ; CALL getarg (ijarg, cldum   ) ; ijarg = ijarg + 1 ; READ(cldum,*) itime
     CASE ('-pm'    ) ; lpm   = .TRUE.
        ;               lheat = .FALSE.
     CASE ('-obc'   ) ; lobc  = .TRUE.
        ;               lheat = .FALSE.
     CASE ( '-TS'   ) ; l_tsfil = .TRUE.
     CASE ( '-vvl'  ) ; lg_vvl = .TRUE.
     CASE ( '-self' ) ; l_self = .TRUE.
     CASE ('-zlimit') ; CALL GetZlimit  ! Parse arguments of -zlimit to build rz_lst array
     CASE ('-sfx'   ) ; CALL getarg (ijarg, csfx   ) ; ijarg = ijarg + 1
     CASE ('-cumul' ) ; l_cumul = .TRUE.
     CASE DEFAULT     ; PRINT *,' ERROR : ',TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  END DO


  it = 1
  IF ( lg_vvl ) THEN
     ! when vvl vertical metrics is stored in the data file with name cn_ve3u 
     cn_fe3u = cf_ufil
     cn_fe3v = cf_vfil
     cn_ve3u = cn_ve3uvvl
     cn_ve3v = cn_ve3vvvl
     it      = itime
  ENDIF

  IF ( l_self ) THEN
     cn_fzgr  = cf_vfil
     cn_fhgr  = cf_vfil
     cn_fe3u  = cf_vfil
     cn_fe3v  = cf_vfil
     cf_vtfil = cf_vfil
     cf_tfil  = cf_vfil
     cf_ufil  = cf_vfil
  ENDIF

  ! checking if all required files are available
  lchk = lchk .OR. chkfile(cn_fzgr)
  lchk = lchk .OR. chkfile(cn_fhgr)
  IF ( ltest ) THEN
     ! OK
  ELSE
     lchk = lchk .OR. chkfile(cf_ufil)
     lchk = lchk .OR. chkfile(cf_vfil)
     IF (l_tsfil)  THEN 
        IF ( cf_sfil == 'none' ) cf_sfil=cf_tfil
        lchk = lchk .OR. chkfile(cf_tfil )
        lchk = lchk .OR. chkfile(cf_sfil )
     ELSE IF (lheat  ) THEN 
        IF ( cf_utfil == 'none' ) cf_utfil=cf_vtfil 
        lchk = lchk .OR. chkfile(cf_utfil)
        lchk = lchk .OR. chkfile(cf_vtfil)
     ENDIF
  ENDIF
  IF ( lchk ) STOP 99 ! missing files

  ! Look for missingValue for u and v
  zspu = getspval(cf_ufil,cn_vozocrtx)
  zspv = getspval(cf_vfil,cn_vomecrty)
  ! set flags to true if spval /= 0
  IF ( zspu /= 0. ) lspu=.TRUE.
  IF ( zspv /= 0. ) lspv=.TRUE.


  ! adjust the number of output variables according to options
  IF ( nclass > 1 ) THEN
     IF ( lheat ) THEN ; nvarout = 12
     ELSE              ; nvarout =  8
     ENDIF
     IF ( lpm   ) nvarout=nvarout+4
  ELSE
     IF ( lheat ) THEN ; nvarout =  9
     ELSE              ; nvarout =  7
     ENDIF
     IF ( lpm   ) nvarout=nvarout+2
  ENDIF
  IF ( l_cumul ) THEN
     IF ( nclass > 1 ) THEN
        IF ( lheat ) THEN ; nvaroutc = 6
        ELSE              ; nvaroutc = 2
        ENDIF
     ELSE
        IF ( lheat ) THEN ; nvaroutc = 3
        ELSE              ; nvaroutc = 1 
        ENDIF
     ENDIF
  ENDIF
  ALLOCATE ( ilev0(nclass), ilev1(nclass), rclass(nclass) )
  rclass=(/(jclass, jclass=1,nclass)/)

  npiglo = getdim (cf_vfil,cn_x)
  npjglo = getdim (cf_vfil,cn_y)
  npk    = getdim (cf_vfil,cn_z)
  npt    = getdim (cf_vfil,cn_t)

  PRINT *, 'npiglo =', npiglo
  PRINT *, 'npjglo =', npjglo
  PRINT *, 'npk    =', npk
  PRINT *, 'npt    =', npt

  IF ( lobc ) THEN  ! if lobc false, l_merid and l_zonal are false (default)
     IF ( npiglo == 1 ) THEN
        l_merid=.TRUE.
        ALLOCATE (zuobc(npjglo,npk), zvobc(npjglo,npk) )
        PRINT *,' Meridional OBC'
     ENDIF

     IF ( npjglo == 1 ) THEN
        l_zonal=.TRUE.
        ALLOCATE (zuobc(npiglo,npk), zvobc(npiglo,npk) )
        PRINT *,' Zonal OBC'
     ENDIF
  ENDIF

  ALLOCATE ( e31d(npk) )

  ! define new variables for output 
  ALLOCATE ( stypvar(nvarout), ipk(nvarout), id_varout(nvarout) )
  IF ( l_cumul ) THEN
     ALLOCATE ( stypvarc(nvaroutc), ipkc(nvaroutc), id_varoutc(nvaroutc) )
  ENDIF
  ALLOCATE ( rdum(1,1) )

  rdum(:,:)=0.e0

  ! Allocate arrays
  ALLOCATE ( dlu(npiglo,npjglo),   dlv(npiglo,npjglo) )
  ALLOCATE ( dwku(npiglo,npjglo), dwkv(npiglo,npjglo) )
  ALLOCATE ( dtrpu(npiglo,npjglo,nclass), dtrpv(npiglo,npjglo,nclass))
  ALLOCATE ( dvoltrpsum(nclass), dvolallegcl(nclass) )

  IF ( lpm ) THEN 
     ALLOCATE ( dwkup(npiglo,npjglo), dwkvp(npiglo,npjglo) )
     ALLOCATE ( dwkum(npiglo,npjglo), dwkvm(npiglo,npjglo) )
     ALLOCATE ( dtrpup(npiglo,npjglo,nclass), dtrpvp(npiglo,npjglo,nclass))
     ALLOCATE ( dtrpum(npiglo,npjglo,nclass), dtrpvm(npiglo,npjglo,nclass))
     ALLOCATE ( dvoltrpsump(nclass),  dvoltrpsumm(nclass)  )
     ALLOCATE ( dvolallegclp(nclass), dvolallegclm(nclass) )
  ENDIF

  IF ( lheat ) THEN
     ALLOCATE (   dlut(npiglo,npjglo),   dlus(npiglo,npjglo) )
     ALLOCATE (   dlvt(npiglo,npjglo),   dlvs(npiglo,npjglo) )
     ALLOCATE ( dwkut(npiglo,npjglo), dwkus(npiglo,npjglo) )
     ALLOCATE ( dwkvt(npiglo,npjglo), dwkvs(npiglo,npjglo) )
     ALLOCATE ( dtrput(npiglo,npjglo,nclass), dtrpvt(npiglo,npjglo,nclass))
     ALLOCATE ( dtrpus(npiglo,npjglo,nclass), dtrpvs(npiglo,npjglo,nclass))
     ALLOCATE ( dheatrpsum(nclass), dsaltrpsum(nclass)     )
     ALLOCATE ( dheatallegcl(nclass), dsaltallegcl(nclass) )
     IF ( l_tsfil ) THEN
        ALLOCATE (dlt(npiglo+1,npjglo+1), dls(npiglo+1, npjglo+1) )
     ENDIF
  ENDIF
  !
  ALLOCATE ( e1v(npiglo,npjglo),e3v(npiglo,npjglo)       )
  ALLOCATE ( e2u(npiglo,npjglo),e3u(npiglo,npjglo)       )
  !
  ALLOCATE ( gphif(npiglo,npjglo) )
  ALLOCATE ( glamf(npiglo,npjglo) )
  IF ( l_cumul ) THEN
     ALLOCATE  ( gphiu(npiglo,npjglo) )
     ALLOCATE  ( gphiv(npiglo,npjglo) )
     ALLOCATE  ( glamu(npiglo,npjglo) )
     ALLOCATE  ( glamv(npiglo,npjglo) )
  ENDIF
  ALLOCATE ( gdepw(npk) , dtim(npt)                      )
  !
  ! read metrics and grid position
  e1v(:,:)   = getvar(cn_fhgr, cn_ve1v, 1, npiglo, npjglo)
  IF ( l_self ) THEN
     e2u(:,:)   = 1.  ! dummy value, not used
     glamf(:,:) = 1.
     gphif(:,:) = 1.
     IF ( l_cumul ) THEN
        glamu(:,:) = 1.
        gphiu(:,:) = 1.
        glamv(:,:) = getvar(cf_vtfil, cn_vlon2d, 1, npiglo, npjglo)
        gphiv(:,:) = getvar(cf_vtfil, cn_vlat2d, 1, npiglo, npjglo)
     ENDIF

     ! use e31d for temporary calculation
     e31d(:)    =  getvar1d(cf_vtfil, cn_vdeptht, npk)
     gdepw(1)   = 0.
     gdepw(2:npk) = 0.5 * (e31d(1:npk-1) + e31d(2:npk)) ! This is just a proxy for gdepw
     ! max error ~ 1m for 46 lev
     e31d(:)    = 1.  ! set dummy value for e31d 
  ELSE
     e2u(:,:)   = getvar(cn_fhgr, cn_ve2u, 1, npiglo, npjglo)

     glamf(:,:) = getvar(cn_fhgr, cn_glamf, 1,npiglo, npjglo)
     gphif(:,:) = getvar(cn_fhgr, cn_gphif, 1,npiglo, npjglo)
     IF ( l_cumul ) THEN
        glamu(:,:) = getvar(cn_fhgr, cn_glamu, 1,npiglo, npjglo)
        glamv(:,:) = getvar(cn_fhgr, cn_glamv, 1,npiglo, npjglo)
        gphiu(:,:) = getvar(cn_fhgr, cn_gphiu, 1,npiglo, npjglo)
        gphiv(:,:) = getvar(cn_fhgr, cn_gphiv, 1,npiglo, npjglo)
     ENDIF
     gdepw(:) = getvare3(cn_fzgr, cn_gdepw, npk)
     e31d(:)  = getvare3(cn_fzgr, cn_ve3t1d,  npk) ! used only for full step
  ENDIF


  IF ( lobc ) THEN
     ! read u, v on OBC
     IF ( l_zonal ) THEN   ! (jpiglo,jpk)
        zuobc(:,:)= getvarxz(cf_ufil, cn_vozocrtx, 1, npiglo, npk)
        zvobc(:,:)= getvarxz(cf_vfil, cn_vomecrty, 1, npiglo, npk)
     ENDIF
     IF ( l_merid ) THEN   ! (jpjglo,jpk)
        zuobc(:,:)= getvaryz(cf_ufil, cn_vozocrtx, 1, npjglo, npk)
        zvobc(:,:)= getvaryz(cf_vfil, cn_vomecrty, 1, npjglo, npk)
     ENDIF
  ENDIF

  ! look for nearest level to rz_lst and setup ilev0 and ilev1 (t-index of class limit)
  ik = 1
  ilev0(1) = 1 ; ilev1(nclass) = npk-1  ! default value if nclass=1
  DO jclass = 1, nclass -1
     DO WHILE ( gdepw(ik)  < rz_lst(jclass) )
        ik = ik +1
     END DO

     rd1 = ABS(gdepw(ik-1) - rz_lst(jclass) )
     rd2 = ABS(gdepw(ik  ) - rz_lst(jclass) )
     IF ( rd2 < rd1 ) THEN
        ilev1(jclass  ) = ik - 1  ! t-levels index
        ilev0(jclass+1) = ik
     ELSE 
        ilev1(jclass  ) = ik - 2  ! t-levels index
        ilev0(jclass+1) = ik - 1
     END IF
  END DO

  PRINT *, 'Limits :  '
  DO jclass = 1, nclass
     PRINT *, ilev0(jclass),ilev1(jclass), gdepw(ilev0(jclass)), gdepw(ilev1(jclass)+1)
  END DO

  ! compute the transports at each grid cell
  dtrpu (:,:,:)= 0.d0 ; dtrpv (:,:,:)= 0.d0    ! initialization to 0

  IF ( lpm   ) THEN
     dtrpup(:,:,:)= 0.d0 ; dtrpvp(:,:,:)= 0.d0  
     dtrpum(:,:,:)= 0.d0 ; dtrpvm(:,:,:)= 0.d0
  ENDIF
  IF ( lheat ) THEN
     dtrput(:,:,:)= 0.d0 ; dtrpvt(:,:,:)= 0.d0  
     dtrpus(:,:,:)= 0.d0 ; dtrpvs(:,:,:)= 0.d0
  ENDIF

  DO jclass = 1, nclass
     DO jk = ilev0(jclass),ilev1(jclass)
        PRINT *,'level ',jk
        ! Get velocities, temperature and salinity fluxes at jk
        IF ( ltest ) THEN
           dlu (:,:) = udum ; dlv (:,:) = vdum
           IF (lheat) THEN
              dlut(:,:) = udum ; dlvt(:,:) = vdum
              dlus(:,:) = udum ; dlvs(:,:) = vdum
           ENDIF
        ELSEIF ( lobc ) THEN
           IF      ( l_zonal ) THEN ; dlu(:,1)=zuobc(:,jk) ; dlv(:,1)=zvobc(:,jk) 
           ELSE IF ( l_merid ) THEN ; dlu(1,:)=zuobc(:,jk) ; dlv(1,:)=zvobc(:,jk) 
           ENDIF
           IF ( lspu ) WHERE ( dlu == zspu ) dlu = 0.d0
           IF ( lspv ) WHERE ( dlv == zspv ) dlv = 0.d0
        ELSE
           IF ( l_self ) THEN
              dlu(:,:) = 0.d0
           ELSE
              dlu (:,:) = getvar(cf_ufil, cn_vozocrtx, jk, npiglo, npjglo, ktime=itime)
           ENDIF
           dlv (:,:) = getvar(cf_vfil, cn_vomecrty, jk, npiglo, npjglo, ktime=itime)
           IF ( lspu ) WHERE ( dlu == zspu ) dlu = 0.d0
           IF ( lspv ) WHERE ( dlv == zspv ) dlv = 0.d0
           IF (lheat) THEN
              IF ( l_tsfil ) THEN
                 dlt(:,:) = 0.d0 ; dls(:,:) = 0.d0
                 dlt(1:npiglo,1:npjglo) =  getvar(cf_tfil, cn_votemper, jk, npiglo, npjglo, ktime=itime)
                 dls(1:npiglo,1:npjglo) =  getvar(cf_sfil, cn_vosaline, jk, npiglo, npjglo, ktime=itime)
                 IF  (l_self ) THEN
                    dlut(:,:) = 0.d0
                    dlus(:,:) = 0.d0
                    dlvt(1:npiglo,1:npjglo) = dlv(1:npiglo,1:npjglo) *  dlt(1:npiglo,1:npjglo)
                    dlvs(1:npiglo,1:npjglo) = dlv(1:npiglo,1:npjglo) *  dls(1:npiglo,1:npjglo)
                 ELSE
                    dlut(1:npiglo,1:npjglo) = dlu(1:npiglo,1:npjglo) * 0.5d0* ( dlt(1:npiglo,1:npjglo) + dlt(2:npiglo+1,1:npjglo  ))
                    dlus(1:npiglo,1:npjglo) = dlu(1:npiglo,1:npjglo) * 0.5d0* ( dls(1:npiglo,1:npjglo) + dls(2:npiglo+1,1:npjglo  ))
                    dlvt(1:npiglo,1:npjglo) = dlv(1:npiglo,1:npjglo) * 0.5d0* ( dlt(1:npiglo,1:npjglo) + dlt(1:npiglo,  2:npjglo+1))
                    dlvs(1:npiglo,1:npjglo) = dlv(1:npiglo,1:npjglo) * 0.5d0* ( dls(1:npiglo,1:npjglo) + dls(1:npiglo,  2:npjglo+1))
                 ENDIF
              ELSE
                 IF ( l_self ) THEN
                    dlut(:,:) = 0.d0
                    dlus(:,:) = 0.d0
                 ELSE
                    dlut(:,:) = getvar(cf_utfil, cn_vozout,   jk, npiglo, npjglo, ktime=itime)
                    dlus(:,:) = getvar(cf_utfil, cn_vozous,   jk, npiglo, npjglo, ktime=itime)
                 ENDIF
                 dlvt(:,:) = getvar(cf_vtfil, cn_vomevt,   jk, npiglo, npjglo, ktime=itime)
                 dlvs(:,:) = getvar(cf_vtfil, cn_vomevs,   jk, npiglo, npjglo, ktime=itime)
              ENDIF
           ENDIF
        ENDIF

        ! get e3u, e3v  at level jk
        IF ( lfull ) THEN 
           e3v(:,:) = e31d(jk)
           e3u(:,:) = e31d(jk)
        ELSE
           IF ( l_self) THEN
              e3u(:,:) = 1. !dummy value
              e3v(:,:) = getvar(cn_fe3v, cn_ve3v, jk, npiglo, npjglo, ktime=it, ldiom=.FALSE.)  ! In broken line name is cn_ve3v
           ELSE
              e3u(:,:) = getvar(cn_fe3u, cn_ve3u, jk, npiglo, npjglo, ktime=it, ldiom=.NOT.lg_vvl)
              e3v(:,:) = getvar(cn_fe3v, cn_ve3v, jk, npiglo, npjglo, ktime=it, ldiom=.NOT.lg_vvl)
           ENDIF
        ENDIF

        dwku (:,:) = dlu (:,:)*e2u(:,:)*e3u(:,:)*1.d0
        dwkv (:,:) = dlv (:,:)*e1v(:,:)*e3v(:,:)*1.d0

        IF ( lpm ) THEN 
           dwkup = 0.d0 ; dwkum = 0.d0
           WHERE ( dlu >= 0.d0 ) 
              dwkup(:,:) = dlu (:,:)*e2u(:,:)*e3u(:,:)*1.d0
           ELSEWHERE         
              dwkum(:,:) = dlu (:,:)*e2u(:,:)*e3u(:,:)*1.d0
           END WHERE

           dwkvp = 0.d0 ; dwkvm = 0.d0
           WHERE ( dlv >= 0.d0 ) 
              dwkvp(:,:) = dlv (:,:)*e1v(:,:)*e3v(:,:)*1.d0
           ELSEWHERE         ;
              dwkvm(:,:) = dlv (:,:)*e1v(:,:)*e3v(:,:)*1.d0
           END WHERE
        ENDIF

        IF ( lheat ) THEN
           dwkut(:,:) = dlut(:,:)*e2u(:,:)*e3u(:,:)*1.d0
           dwkvt(:,:) = dlvt(:,:)*e1v(:,:)*e3v(:,:)*1.d0
           dwkus(:,:) = dlus(:,:)*e2u(:,:)*e3u(:,:)*1.d0
           dwkvs(:,:) = dlvs(:,:)*e1v(:,:)*e3v(:,:)*1.d0
        ENDIF

        ! integrates vertically 
        dtrpu (:,:,jclass) = dtrpu (:,:,jclass) + dwku (:,:)
        dtrpv (:,:,jclass) = dtrpv (:,:,jclass) + dwkv (:,:)

        IF ( lpm   ) THEN
           dtrpup(:,:,jclass) = dtrpup(:,:,jclass) + dwkup(:,:)
           dtrpvp(:,:,jclass) = dtrpvp(:,:,jclass) + dwkvp(:,:)
           dtrpum(:,:,jclass) = dtrpum(:,:,jclass) + dwkum(:,:)
           dtrpvm(:,:,jclass) = dtrpvm(:,:,jclass) + dwkvm(:,:)
        ENDIF

        IF ( lheat ) THEN
           dtrput(:,:,jclass) = dtrput(:,:,jclass) + dwkut(:,:) * rau0*rcp
           dtrpvt(:,:,jclass) = dtrpvt(:,:,jclass) + dwkvt(:,:) * rau0*rcp
           dtrpus(:,:,jclass) = dtrpus(:,:,jclass) + dwkus(:,:)  
           dtrpvs(:,:,jclass) = dtrpvs(:,:,jclass) + dwkvs(:,:)  
        ENDIF

     END DO  ! loop to next level
  END DO    ! next class

  cf_out ='section_'//TRIM(csfx)//'.dat'
  cf_vtrp='v'//TRIM(csfx)//'.txt'
  cf_htrp='h'//TRIM(csfx)//'.txt'
  cf_strp='s'//TRIM(csfx)//'.txt'
  OPEN(numout,FILE=cf_out)
  ! also dump the results on txt files without any comments, some users  like it !
  OPEN(numvtrp,FILE=cf_vtrp)
  IF ( lheat ) THEN
     OPEN(numhtrp,FILE=cf_htrp) ; OPEN(numstrp,FILE=cf_strp)
  ENDIF

  !################################################################################
  ! enter interactive part 
  !################################################################################
  ! initialize all legs arrays and variable to 0 
  dvolalleg = 0.d0 ; dvolallegcl(:) = 0.d0
  IF ( lpm   ) THEN
     dvolallegp = 0.d0 ; dvolallegclp(:) = 0.d0
     dvolallegm = 0.d0 ; dvolallegclm(:) = 0.d0
  ENDIF
  IF ( lheat ) THEN
     dheatalleg = 0.d0 ; dheatallegcl(:) = 0.d0
     dsaltalleg = 0.d0 ; dsaltallegcl(:) = 0.d0
  ENDIF
  DO 
     PRINT *, ' Give name of section (EOF to finish)'
     READ(*,'(a)') cline
     ii = 0
     cldumt(:) = 'none'
     ipos = INDEX(cline,' ')
     DO WHILE ( ipos > 1 )
        ii = ii + 1
        cldumt(ii) = cline(1:ipos - 1 )
        cline = TRIM ( cline(ipos+1:) )
        ipos  = INDEX( cline,' ' )
        IF ( ii >= 3 ) EXIT
     END DO
     csection = TRIM(cldumt(1) )
     cvarname = TRIM(cldumt(2) )
     clongname = TRIM(cldumt(3) )

     IF (TRIM(csection) == 'EOF' ) THEN 
        CLOSE(numout) ; CLOSE(numvtrp) 
        IF ( lheat ) THEN 
           CLOSE(numhtrp) ; CLOSE(numstrp) 
        ENDIF
        EXIT  ! infinite DO loop
     ENDIF

     ! create output fileset
     CALL set_typvar( stypvar, csection, cvarname, clongname )
     cf_outnc = TRIM(csection)//'_'//TRIM(csfx)//'.nc'
     ncout    = create      (cf_outnc, 'none',    ikx,      iky, nclass, cdep='depth_class')
     ierr     = createvar   (ncout,    stypvar,   nvarout,  ipk, id_varout, cdglobal=TRIM(cglobal) )
     ierr     = putheadervar(ncout,    cf_ufil,   ikx, iky, nclass, pnavlon=rdum, pnavlat=rdum, pdep=rclass )
     dtim     = getvar1d    (cf_ufil,  cn_vtimec, npt                )
     ierr     = putvar1d    (ncout,    dtim(itime:itime),      1, 'T')


     PRINT *, ' Give iimin, iimax, ijmin, ijmax '
     READ(*,*) iimin, iimax, ijmin, ijmax
     !! Find the broken line between P1 (iimin,ijmin) and P2 (iimax, ijmax)
     ! ... Initialization
     ii0  = iimin ; ij0  = ijmin ; ii1  = iimax ;  ij1 = ijmax
     rxi0 = ii0   ; ryj0 = ij0   ; rxi1 = ii1   ; ryj1 = ij1

     ! compute direction of integrations and signs
     !The transport across the section is the dot product of
     !integral(line){(Mx,My)*dS} 
     !Mx=integral(u*dz)  My=integral(v*dz)) and dS=(dy,-dx)}

     !By defining the direction of the integration as 
     idirx = SIGN(1,ii1-ii0) !positive to the east or if ii1=ii0
     idiry = SIGN(1,ij1-ij0) !positive to the north or if ij1=ij0

     !Then dS=(e2u*idiry,-e1v*idirx)
     !This will produce the following sign convention:
     !    West-to-est line (dx>0, dy=0)=> -My*dx (-ve for a northward flow)
     !    South-to-north   (dy>0, dx=0)=>  Mx*dy (+ve for an eastward flow)
     norm_u =  idiry
     norm_v = -idirx

     ! .. Compute equation:  ryj = aj rxi + bj [valid in the (i,j) plane]
     IF ( (rxi1 -rxi0) /=  0 ) THEN
        aj = (ryj1 - ryj0 ) / (rxi1 -rxi0)
        bj = ryj0 - aj * rxi0
     ELSE
        aj = 10000.  ! flag value
        bj = 0.
     END IF

     ! .. Compute equation:  rxi = ai ryj + bi [valid in the (i,j) plane]
     IF ( (ryj1 -ryj0) /=  0 ) THEN
        ai = (rxi1 - rxi0 ) / ( ryj1 -ryj0 )
        bi = rxi0 - ai * ryj0
     ELSE
        ai = 10000. ! flag value
        bi = 0.
     END IF

     ! ..  Compute the integer pathway: a succession of F points
     np=0
     ! .. Chose the strait line with the smallest slope
     IF (ABS(aj) <=  1 ) THEN
        ! ... Here, the best line is y(x)
        ! ... If ii1 < ii0 swap points [ always describe section from left to right ]
        IF (ii1 <  ii0 ) THEN
           iitmp = ii0   ; ijtmp = ij0
           ii0   = ii1   ; ij0   = ij1
           ii1   = iitmp ; ij1   = ijtmp
        END IF

        ! iist,ijst is the grid offset to pass from F point to either U/V point
        IF ( ij1 >= ij0 ) THEN     ! line heading NE
           iist = 1 ; ijst = 1
        ELSE                       ! line heading SE
           iist = 1 ; ijst = 0
        END IF

        ! ... compute the nearest ji point on the line crossing at ji
        DO ji=ii0, ii1
           np=np+1
           IF (np > jpseg) THEN ; PRINT *, 'np > jpseg !' ; STOP 99 
           ENDIF
           ij=NINT(aj*ji + bj )
           yypt(np) = CMPLX(ji,ij)
        END DO
     ELSE
        ! ... Here, the best line is x(y)
        ! ... If ij1 < ij0 swap points [ always describe section from bottom to top ]
        IF (ij1 <  ij0 ) THEN
           iitmp = ii0   ; ijtmp = ij0
           ii0   = ii1   ; ij0   = ij1
           ii1   = iitmp ; ij1   = ijtmp
        END IF

        ! iist,ijst is the grid offset to pass from F point to either U/V point
        IF ( ii1 >=  ii0 ) THEN
           iist = 1 ; ijst = 1
        ELSE
           iist = 0 ; ijst = 1
        END IF

        ! ... compute the nearest ji point on the line crossing at jj
        DO jj=ij0,ij1
           np=np+1
           IF (np > jpseg) THEN ; PRINT *, 'np > jpseg !' ; STOP 99 
           ENDIF
           ii=NINT(ai*jj + bi)
           yypt(np) = CMPLX(ii,jj)
        END DO
     END IF

     !!
     !! Look for intermediate points to be added.
     !  ..  The final positions are saved in rxx,ryy
     rxx(1) = REAL(yypt(1))
     ryy(1) = IMAG(yypt(1))
     nn     = 1

     DO jk=2,np
        ! .. distance between 2 neighbour points
        rd=ABS(yypt(jk)-yypt(jk-1))
        ! .. intermediate points required if rd > 1
        IF ( rd > 1 ) THEN
           CALL interm_pt(yypt, jk, ai, bi, aj, bj, yypti)
           nn=nn+1
           IF (nn > jpseg) THEN ; PRINT *, 'nn > jpseg !' ; STOP 99 
           ENDIF
           rxx(nn) = REAL(yypti)
           ryy(nn) = IMAG(yypti)
        END IF
        nn=nn+1
        IF (nn > jpseg) THEN ; PRINT *, 'nn > jpseg !' ; STOP 99 
        ENDIF
        rxx(nn) = REAL(yypt(jk))
        ryy(nn) = IMAG(yypt(jk))
     END DO
     ! record longitude and latitude of initial en endind point of the section
     gla (1) = glamf( INT(rxx(1)),  INT(ryy(1))  ) 
     gphi(1) = gphif( INT(rxx(1)),  INT(ryy(1))  ) 
     gla (2) = glamf( INT(rxx(nn)), INT(ryy(nn)) ) 
     gphi(2) = gphif( INT(rxx(nn)), INT(ryy(nn)) ) 

     IF (l_cumul) THEN
        ALLOCATE ( rlonsec(nn-1,1), rlatsec(nn-1,1) )
        DO jseg = 1, nn-1
           ii0=rxx(jseg)
           ij0=ryy(jseg)
           IF ( rxx(jseg) ==  rxx(jseg+1) ) THEN    ! meridional segment, use U velocity
              rlonsec(jseg,1) = glamu(ii0,ij0+ijst)
              rlatsec(jseg,1) = gphiu(ii0,ij0+ijst)
           ELSE IF ( ryy(jseg) == ryy(jseg+1) ) THEN
              rlonsec(jseg,1) = glamv(ii0+iist,ij0)
              rlatsec(jseg,1) = gphiv(ii0+iist,ij0)
           ELSE
              PRINT *, 'ERROR : neither meridional, nor zonal! Where we are? '
           ENDIF
        END DO

        CALL set_typvarc( stypvarc, csection, cvarname, clongname )
        cf_cumul = TRIM(csection)//'_'//TRIM(csfx)//'_cumul.nc'
        ncoutc   = create      (cf_cumul, 'none',    nn-1,     1, nclass, cdep='depth_class')
        ierr     = createvar   (ncoutc,    stypvarc,   nvaroutc,  ipkc, id_varoutc, cdglobal=TRIM(cglobal) )
        ierr     = putheadervar(ncoutc,    cf_ufil,   nn-1, 1, nclass, pnavlon=rlonsec, pnavlat=rlatsec, pdep=rclass )
        dtim     = getvar1d    (cf_ufil,  cn_vtimec, npt                )
        ierr     = putvar1d    (ncoutc,    dtim(itime:itime),      1, 'T')
     END IF

     ! Now extract the transport through a section 
     ! ... Check whether we need a u velocity or a v velocity
     !   Think that the points are f-points and delimit either a U segment
     !   or a V segment (iist and ijst are set in order to look for the correct
     !   velocity point on the C-grid
     PRINT *, TRIM(csection)
     PRINT *, 'IMIN IMAX JMIN JMAX', iimin, iimax, ijmin, ijmax
     WRITE(numout,*) '% Transport along a section by levels' ,TRIM(csection)
     WRITE(numout,*) '% ---- IMIN IMAX JMIN JMAX'

     dvoltrpbrtp  = 0.d0
     dvoltrpbrtpp = 0.d0
     dvoltrpbrtpm = 0.d0
     dheatrpbrtp  = 0.d0
     dsaltrpbrtp  = 0.d0
     ! cumulative barotropuic transport
     dvoltrpcbtp(:) = 0.d0
     dheatrpcbtp(:) = 0.d0
     dsaltrpcbtp(:) = 0.d0

     DO jclass=1,nclass
        dvoltrpsum(jclass) = 0.d0
        IF ( lpm   ) THEN
           dvoltrpsump(jclass) = 0.d0
           dvoltrpsumm(jclass) = 0.d0
        ENDIF
        IF ( lheat ) THEN
           dheatrpsum(jclass) = 0.d0
           dsaltrpsum(jclass) = 0.d0
        ENDIF

        ! segment jseg is a line between (rxx(jseg),ryy(jseg))  and (rxx(jseg+1),ryy(jseg+1))
        DO jseg = 1, nn-1
           ii0=rxx(jseg)
           ij0=ryy(jseg)
           IF ( rxx(jseg) ==  rxx(jseg+1) ) THEN    ! meridional segment, use U velocity
              dvoltrp(jseg)= dtrpu (ii0,ij0+ijst,jclass)*norm_u

              IF ( lpm   ) THEN 
                 IF (norm_u > 0 ) THEN
                    dvoltrpp(jseg)= dtrpup(ii0,ij0+ijst,jclass)*norm_u
                    dvoltrpm(jseg)= dtrpum(ii0,ij0+ijst,jclass)*norm_u
                 ELSE
                    dvoltrpp(jseg)= dtrpum(ii0,ij0+ijst,jclass)*norm_u
                    dvoltrpm(jseg)= dtrpup(ii0,ij0+ijst,jclass)*norm_u
                 ENDIF
              ENDIF

              IF ( lheat ) THEN
                 dheatrp(jseg)= dtrput(ii0,ij0+ijst,jclass)*norm_u
                 dsaltrp(jseg)= dtrpus(ii0,ij0+ijst,jclass)*norm_u
              ENDIF
           ELSE IF ( ryy(jseg) == ryy(jseg+1) ) THEN ! zonal segment, use V velocity
              dvoltrp(jseg)=dtrpv (ii0+iist,ij0,jclass)*norm_v

              IF ( lpm   ) THEN 
                 IF (norm_v > 0 ) THEN
                    dvoltrpp(jseg)=dtrpvp(ii0+iist,ij0,jclass)*norm_v
                    dvoltrpm(jseg)=dtrpvm(ii0+iist,ij0,jclass)*norm_v
                 ELSE
                    dvoltrpp(jseg)=dtrpvm(ii0+iist,ij0,jclass)*norm_v
                    dvoltrpm(jseg)=dtrpvp(ii0+iist,ij0,jclass)*norm_v
                 ENDIF
              ENDIF

              IF ( lheat ) THEN
                 dheatrp(jseg)=dtrpvt(ii0+iist,ij0,jclass)*norm_v
                 dsaltrp(jseg)=dtrpvs(ii0+iist,ij0,jclass)*norm_v
              ENDIF
           ELSE
              PRINT *,' ERROR :',  rxx(jseg),ryy(jseg),rxx(jseg+1),ryy(jseg+1) ! likely to never happen !
           END IF
           dvoltrpsum(jclass) = dvoltrpsum(jclass) + dvoltrp(jseg)
           dvoltrpcbtp(jseg) = dvoltrpcbtp(jseg) + dvoltrp(jseg)
           IF ( lpm   ) THEN 
              dvoltrpsump(jclass) = dvoltrpsump(jclass) + dvoltrpp(jseg)
              dvoltrpsumm(jclass) = dvoltrpsumm(jclass) + dvoltrpm(jseg)
           ENDIF
           IF ( lheat ) THEN
              dheatrpsum(jclass) = dheatrpsum(jclass) + dheatrp(jseg)
              dsaltrpsum(jclass) = dsaltrpsum(jclass) + dsaltrp(jseg)
              dheatrpcbtp(jseg)  = dheatrpcbtp(jseg) + dheatrp(jseg)
              dsaltrpcbtp(jseg)  = dsaltrpcbtp(jseg) + dsaltrp(jseg)
           ENDIF
        END DO   ! next segment

        ! Ascii outputs :      
        IF (jclass == 1 ) THEN   ! print header when it is the first class
           PRINT '(a,2f8.2,a,2f8.2)', 'FROM (LON LAT): ', gla(1),gphi(1),' TO (LON LAT) ', gla(2), gphi(2)
           WRITE(numout,*)  '% ---- LONmin LATmin LONmax LATmax'
           WRITE(numout,*)  '% Top(m)  Bottom(m)  MassTrans(Sv) HeatTrans(PW) SaltTrans(kt/s)'
           WRITE(numout,*) 0 ,iimin, iimax, ijmin, ijmax
           WRITE(numout,9003) 0. ,gla(1),gphi(1), gla(2), gphi(2)
        ENDIF

        PRINT *, gdepw(ilev0(jclass)), gdepw(ilev1(jclass)+1)
        PRINT *, ' Mass transport : ', dvoltrpsum(jclass)/1.e6,' SV'
        WRITE(numvtrp,'(e14.6)') dvoltrpsum(jclass) 
        IF ( lpm   ) THEN
           PRINT *, ' Positive Mass transport : ', dvoltrpsump(jclass)/1.e6,' SV'
           PRINT *, ' Negative Mass transport : ', dvoltrpsumm(jclass)/1.e6,' SV'
           WRITE(numout,9002) gdepw(ilev0(jclass)), gdepw(ilev1(jclass)+1), &
                &   dvoltrpsum(jclass)/1.e6, dvoltrpsump(jclass)/1.e6, dvoltrpsumm(jclass)/1.e6
           WRITE(numvtrp,'(e14.6)') dvoltrpsump(jclass) 
           WRITE(numvtrp,'(e14.6)') dvoltrpsumm(jclass) 
        ENDIF

        IF ( lheat ) THEN
           PRINT *, ' Heat transport : ', dheatrpsum(jclass)/1.e15,' PW'
           PRINT *, ' Salt transport : ', dsaltrpsum(jclass)/1.e6,' kT/s'
           WRITE(numout,9002) gdepw(ilev0(jclass)), gdepw(ilev1(jclass)+1), &
                &   dvoltrpsum(jclass)/1.e6, dheatrpsum(jclass)/1.e15, dsaltrpsum(jclass)/1.e6
           WRITE(numhtrp,'(e14.6)') dheatrpsum(jclass)
           WRITE(numstrp,'(e14.6)') dsaltrpsum(jclass)
        ELSE
           IF ( .NOT. lpm ) WRITE(numout,9002) gdepw(ilev0(jclass)), gdepw(ilev1(jclass)+1), dvoltrpsum(jclass)/1.e6
        ENDIF

        ! netcdf output 
        IF ( nclass > 1 ) THEN
           rdum(1,1) = REAL(dvoltrpsum(jclass)/1.e6)
           ierr = putvar(ncout,id_varout(ivtrpcl), rdum, jclass, 1, 1, 1 ) 
           IF ( lpm   ) THEN
              rdum(1,1) =  REAL(dvoltrpsump(jclass)/1.e6)
              ierr = putvar(ncout,id_varout(iptrpcl), rdum, jclass, 1, 1, 1 ) 
              rdum(1,1) =  REAL(dvoltrpsumm(jclass)/1.e6)
              ierr = putvar(ncout,id_varout(imtrpcl), rdum, jclass, 1, 1, 1 ) 
           ENDIF
           IF ( lheat ) THEN
              rdum(1,1) =  REAL(dheatrpsum(jclass)/1.e15)
              ierr = putvar(ncout,id_varout(ihtrpcl), rdum, jclass, 1, 1, 1 ) 
              rdum(1,1) =  REAL(dsaltrpsum(jclass)/1.e6)
              ierr = putvar(ncout,id_varout(istrpcl), rdum, jclass, 1, 1, 1 )
           ENDIF
           IF ( l_cumul ) THEN
              rdumseg(1:nn-1,1) = REAL(dvoltrp(1:nn-1)/1.e6)
              ierr = putvar(ncoutc,id_varoutc(ivtrpclc), rdumseg(1:nn-1,:), jclass, nn-1, 1, 1 )
              IF ( lheat ) THEN
                 rdumseg(1:nn-1,1) = REAL(dheatrp(1:nn-1)/1.e15)
                 ierr = putvar(ncoutc,id_varoutc(ihtrpclc), rdumseg(1:nn-1,:), jclass, nn-1, 1, 1 )
                 rdumseg(1:nn-1,1) = REAL(dsaltrp(1:nn-1)/1.e6)
                 ierr = putvar(ncoutc,id_varoutc(istrpclc), rdumseg(1:nn-1,:), jclass, nn-1, 1, 1 )
              ENDIF
           ENDIF

        ENDIF
        rdum(1,1) = REAL(gdepw(ilev0(jclass)))
        ierr = putvar(ncout,id_varout(itop), rdum, jclass, 1, 1, 1 )
        rdum(1,1) = REAL(gdepw(ilev1(jclass)+1))
        ierr = putvar(ncout,id_varout(ibot), rdum, jclass, 1, 1, 1 )

        dvoltrpbrtp = dvoltrpbrtp +  dvoltrpsum(jclass)
        IF ( lpm  ) THEN
           dvoltrpbrtpp = dvoltrpbrtpp + dvoltrpsump(jclass)
           dvoltrpbrtpm = dvoltrpbrtpm + dvoltrpsumm(jclass)
        ENDIF
        IF ( lheat) THEN
           dheatrpbrtp = dheatrpbrtp +  dheatrpsum(jclass)
           dsaltrpbrtp = dsaltrpbrtp +  dsaltrpsum(jclass)
        ENDIF
        ! save sum over legs
        dvolallegcl(jclass) = dvolallegcl(jclass) + dvoltrpsum(jclass)
        IF ( lpm   ) THEN
           dvolallegclp(jclass) = dvolallegclp(jclass) + dvoltrpsump(jclass)
           dvolallegclm(jclass) = dvolallegclm(jclass) + dvoltrpsumm(jclass)
        ENDIF
        IF ( lheat ) THEN
           dheatallegcl(jclass) = dheatallegcl(jclass) + dheatrpsum(jclass)
           dsaltallegcl(jclass) = dsaltallegcl(jclass) + dsaltrpsum(jclass)
        ENDIF
     END DO ! next class
     ! save sum over legs 
     dvolalleg = dvolalleg + dvoltrpbrtp
     IF ( lpm   ) THEN
        dvolallegp = dvolallegp + dvoltrpbrtpp
        dvolallegm = dvolallegm + dvoltrpbrtpm
     ENDIF
     IF ( lheat ) THEN
        dheatalleg = dheatalleg + dheatrpbrtp
        dsaltalleg = dsaltalleg + dsaltrpbrtp
     ENDIF

     IF ( nclass > 1 ) THEN 
        PRINT *, ' ====================================================='
        PRINT *, ' total Mass transport : ', dvoltrpbrtp/1.e6,' SV'
        IF ( lpm   ) THEN
           PRINT *, ' total positive transport : ', dvoltrpbrtpp/1.e6,' SV'
           PRINT *, ' total negative transport : ', dvoltrpbrtpm/1.e6,' SV'
        ENDIF
        IF ( lheat ) THEN
           PRINT *, ' total Heat transport : ', dheatrpbrtp/1.e15,' PW'
           PRINT *, ' total Salt transport : ', dsaltrpbrtp/1.e6,' kT/s'
        ENDIF
     ENDIF
     ierr = putvar0d(ncout,id_varout(ivtrp), REAL(dvoltrpbrtp/1.e6)        )
     IF ( lpm   ) THEN
        ierr = putvar0d(ncout,id_varout(iptrp), REAL(dvoltrpbrtpp/1.e6)    )
        ierr = putvar0d(ncout,id_varout(imtrp), REAL(dvoltrpbrtpm/1.e6)    )
     ENDIF
     IF ( lheat ) THEN
        ierr = putvar0d(ncout,id_varout(ihtrp), REAL(dheatrpbrtp/1.e15)    )
        ierr = putvar0d(ncout,id_varout(istrp), REAL(dsaltrpbrtp/1.e6 )    )
     ENDIF
     ierr = putvar0d(ncout,id_varout(ilonmin), REAL(gla(1))  )
     ierr = putvar0d(ncout,id_varout(ilonmax), REAL(gla(2))  )
     ierr = putvar0d(ncout,id_varout(ilatmin), REAL(gphi(1)) )
     ierr = putvar0d(ncout,id_varout(ilatmax), REAL(gphi(2)) )
     ierr = closeout(ncout)

     IF ( l_cumul ) THEN
        rdumseg(1:nn-1,1) = REAL(dvoltrpcbtp(1:nn-1)/1.e6)
        ierr = putvar(ncoutc,id_varoutc(ivtrpc), rdumseg(1:nn-1,:), 1, nn-1, 1, 1 )
        IF ( lheat ) THEN
           rdumseg(1:nn-1,1) = REAL(dheatrpcbtp(1:nn-1)/1.e15)
           ierr = putvar(ncoutc,id_varoutc(ihtrpc), rdumseg(1:nn-1,:), 1, nn-1, 1, 1 )
           rdumseg(1:nn-1,1) = REAL(dsaltrpcbtp(1:nn-1)/1.e6)
           ierr = putvar(ncoutc,id_varoutc(istrpc), rdumseg(1:nn-1,:), 1, nn-1, 1, 1 )
        ENDIF
        ierr = closeout(ncoutc)
        DEALLOCATE (rlonsec, rlatsec)
     ENDIF

  END DO ! infinite loop : gets out when input is EOF 


  PRINT *,'   '
  PRINT *,' Overall transports (sum of all legs done so far)'
  DO jclass = 1, nclass
     PRINT *, gdepw(ilev0(jclass)), gdepw(ilev1(jclass)+1)
     PRINT *, ' Mass transport : ', dvolallegcl(jclass)/1.e6,' SV'
     IF ( lpm   ) THEN
        PRINT *, ' Positive Mass transport : ', dvolallegclp(jclass)/1.e6,' SV'
        PRINT *, ' Negative Mass transport : ', dvolallegclm(jclass)/1.e6,' SV'
     ENDIF

     IF ( lheat ) THEN
        PRINT *, ' Heat transport : ', dheatallegcl(jclass)/1.e15,' PW'
        PRINT *, ' Salt transport : ', dsaltallegcl(jclass)/1.e6,' kT/s'
     ENDIF
  ENDDO

  IF ( nclass > 1 ) THEN
     PRINT *, ' ====================================================='
     PRINT *, '    Mass transport      : ', dvolalleg/1.e6,' SV'
     IF ( lpm ) THEN
        PRINT *, '     positive transport : ', dvolallegp/1.e6,' SV'
        PRINT *, '     negative transport : ', dvolallegm/1.e6,' SV'
     ENDIF
     IF ( lheat ) THEN
        PRINT *, '     heat transport     : ', dheatalleg/1.e15,' PW'
        PRINT *, '     salt transport     : ', dsaltalleg/1.e6,' kT/s'
     ENDIF
  ENDIF

9000 FORMAT(I4,6(f9.3,f8.4))
9001 FORMAT(I4,6(f9.2,f9.3))
9002 FORMAT(f9.0,f9.0,f9.2,f9.2,f9.2)
9003 FORMAT(f9.2,f9.2,f9.2,f9.2,f9.2)

CONTAINS

  SUBROUTINE set_typvar ( sd_typvar, cdsection, cdvarname, cdlongname ) 
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE set_typvar  ***
    !!
    !! ** Purpose : Initialize typvar structure for netcdfoutput at a given section
    !!
    !! ** Method  : use varname longname to suffix variable name and attributes
    !!              If varname and/or logname are not given (ie 'none') take
    !!              standard default names
    !!              Netcdf id for variables are passed as global variables
    !!----------------------------------------------------------------------
    TYPE(variable), DIMENSION(:), INTENT(out) :: sd_typvar        ! structure of output
    CHARACTER(LEN=*),             INTENT(in ) :: cdsection
    CHARACTER(LEN=*),             INTENT(in ) :: cdvarname
    CHARACTER(LEN=*),             INTENT(in ) :: cdlongname
    !!
    INTEGER(KIND=4)                           :: ivar
    CHARACTER(LEN=255)                        :: csuffixvarnam
    CHARACTER(LEN=255)                        :: cprefixlongnam
    !!----------------------------------------------------------------------
    ! set suffixes according to variable/longname 
    IF ( cdvarname /= 'none' ) THEN
       csuffixvarnam = '_'//TRIM(cdvarname)
    ELSE
       csuffixvarnam = ''
    ENDIF

    IF ( cdlongname /= 'none' ) THEN
       cprefixlongnam = TRIM(cdlongname)//'_'
    ELSE
       cprefixlongnam = ''
    ENDIF

    ! set common values
    sd_typvar%rmissing_value=99999.
    sd_typvar%scale_factor= 1.
    sd_typvar%add_offset= 0.
    sd_typvar%savelog10= 0.
    sd_typvar%conline_operation='N/A'
    sd_typvar%caxis='T'

    ! set particular values for individual variables
    ivar = 1  ; ivtrp = ivar
    ipk(ivar) = 1
    sd_typvar(ivar)%cname       = 'vtrp'//TRIM(csuffixvarnam)
    sd_typvar(ivar)%cunits      = 'Sverdrup'
    sd_typvar(ivar)%valid_min   = -500.
    sd_typvar(ivar)%valid_max   =  500.
    sd_typvar(ivar)%clong_name  = TRIM(cprefixlongnam)//'Volume_Transport'
    sd_typvar(ivar)%cshort_name = 'vtrp'

    IF ( lpm ) THEN 
       ivar = ivar + 1 ; iptrp = ivar                                                  ;  imtrp = ivar+1
       ipk(ivar) = 1                                                                   ;  ipk(ivar+1) = 1
       sd_typvar(ivar)%cname       = 'ptrp'//TRIM(csuffixvarnam)                       ;  sd_typvar(ivar+1)%cname       = 'mtrp'//TRIM(csuffixvarnam)
       sd_typvar(ivar)%cunits      = 'Sverdrup'                                        ;  sd_typvar(ivar+1)%cunits      = 'Sverdrup'
       sd_typvar(ivar)%valid_min   = -500.                                             ;  sd_typvar(ivar+1)%valid_min   = -500.
       sd_typvar(ivar)%valid_max   =  500.                                             ;  sd_typvar(ivar+1)%valid_max   =  500.
       sd_typvar(ivar)%clong_name  = TRIM(cprefixlongnam)//'Positive_volume_transport' ;  sd_typvar(ivar+1)%clong_name  = TRIM(cprefixlongnam)//'Negative_volume_transport'
       sd_typvar(ivar)%cshort_name = 'ptrp'                                            ;  sd_typvar(ivar+1)%cshort_name = 'mtrp'
       ivar = ivar + 1
    ENDIF

    IF ( lheat ) THEN
       ivar = ivar + 1 ; ihtrp = ivar                                                  ;  istrp = ivar+1
       ipk(ivar) = 1                                                                   ;  ipk(ivar+1) = 1
       sd_typvar(ivar)%cname       = 'htrp'//TRIM(csuffixvarnam)                       ;  sd_typvar(ivar+1)%cname       = 'strp'//TRIM(csuffixvarnam)
       sd_typvar(ivar)%cunits      = 'PW'                                              ;  sd_typvar(ivar+1)%cunits      = 'kt/s'
       sd_typvar(ivar)%valid_min   = -1000.                                            ;  sd_typvar(ivar+1)%valid_min   = -1000.
       sd_typvar(ivar)%valid_max   =  1000.                                            ;  sd_typvar(ivar+1)%valid_max   =  1000.
       sd_typvar(ivar)%clong_name  = TRIM(cprefixlongnam)//'Heat_Transport'            ;  sd_typvar(ivar+1)%clong_name  = TRIM(cprefixlongnam)//'Salt_Transport'
       sd_typvar(ivar)%cshort_name = 'htrp'                                            ;  sd_typvar(ivar+1)%cshort_name = 'strp'
       ivar = ivar + 1
    ENDIF

    ivar = ivar + 1 ; ilonmin = ivar                                                   ;  ilonmax = ivar+1
    ipk(ivar) = 1                                                                      ;  ipk(ivar+1) = 1
    sd_typvar(ivar)%cname       = 'lonmin'//TRIM(csuffixvarnam)                        ;  sd_typvar(ivar+1)%cname       = 'lonmax'//TRIM(csuffixvarnam)
    sd_typvar(ivar)%cunits      = 'deg'                                                ;  sd_typvar(ivar+1)%cunits      = 'deg'
    sd_typvar(ivar)%valid_min   = -180.                                                ;  sd_typvar(ivar+1)%valid_min   = -180.
    sd_typvar(ivar)%valid_max   =  180.                                                ;  sd_typvar(ivar+1)%valid_max   =  180.
    sd_typvar(ivar)%clong_name  = TRIM(cprefixlongnam)//'begin_longitude'              ;  sd_typvar(ivar+1)%clong_name  = TRIM(cprefixlongnam)//'end_longitude'
    sd_typvar(ivar)%cshort_name = 'lonmin'                                             ;  sd_typvar(ivar+1)%cshort_name = 'lonmax'
    ivar = ivar + 1

    ivar = ivar + 1  ; ilatmin = ivar                                                  ;  ilatmax = ivar+1
    ipk(ivar) = 1                                                                      ;  ipk(ivar+1) = 1
    sd_typvar(ivar)%cname       = 'latmin'//TRIM(csuffixvarnam)                        ;  sd_typvar(ivar+1)%cname       = 'latmax'//TRIM(csuffixvarnam)
    sd_typvar(ivar)%cunits      = 'deg'                                                ;  sd_typvar(ivar+1)%cunits      = 'deg'
    sd_typvar(ivar)%valid_min   = -90.                                                 ;  sd_typvar(ivar+1)%valid_min   = -90.
    sd_typvar(ivar)%valid_max   =  90.                                                 ;  sd_typvar(ivar+1)%valid_max   =  90.
    sd_typvar(ivar)%clong_name  = TRIM(cprefixlongnam)//'begin_latitude'               ;  sd_typvar(ivar+1)%clong_name  = TRIM(cprefixlongnam)//'end_latitude'
    sd_typvar(ivar)%cshort_name = 'latmin'                                             ;  sd_typvar(ivar+1)%cshort_name = 'latmax'
    ivar = ivar + 1

    ivar = ivar + 1  ; itop = ivar                                                     ;  ibot = ivar+1
    ipk(ivar) = nclass                                                                 ;  ipk(ivar+1) = nclass
    sd_typvar(ivar)%cname       = 'top'                                                ;  sd_typvar(ivar+1)%cname       = 'bottom'
    sd_typvar(ivar)%cunits      = 'meters'                                             ;  sd_typvar(ivar+1)%cunits      = 'meters'
    sd_typvar(ivar)%valid_min   = 0.                                                   ;  sd_typvar(ivar+1)%valid_min   = 0.
    sd_typvar(ivar)%valid_max   = 10000.                                               ;  sd_typvar(ivar+1)%valid_max   = 10000.
    sd_typvar(ivar)%clong_name  = 'class_min_depth'                                    ;  sd_typvar(ivar+1)%clong_name  = 'class_max_depth'
    sd_typvar(ivar)%cshort_name = 'top'                                                ;  sd_typvar(ivar+1)%cshort_name = 'bottom'
    ivar = ivar + 1

    ivtrpcl = -1  ; ihtrpcl = -1 ; istrpcl = -1
    IF ( nclass > 1 ) THEN  ! define additional variable for vertical profile of transport (per class)
       ivar = ivar + 1  ; ivtrpcl = ivar
       ipk(ivar) = nclass                      
       sd_typvar(ivar)%cname       = 'vtrp_dep'//TRIM(csuffixvarnam) 
       sd_typvar(ivar)%cunits      = 'SV'  
       sd_typvar(ivar)%valid_min   = 0.       
       sd_typvar(ivar)%valid_max   = 10000.  
       sd_typvar(ivar)%clong_name  = TRIM(cprefixlongnam)//'Volume_Transport_per_class' 
       sd_typvar(ivar)%cshort_name = 'vtrp_dep'            

       IF ( lpm )  THEN
          ivar = ivar + 1  ; iptrpcl = ivar                                             ;  imtrpcl = ivar+1
          ipk(ivar) = nclass                                                            ;  ipk(ivar+1) = nclass
          sd_typvar(ivar)%cname       = 'ptrp_dep'//TRIM(csuffixvarnam)                 ;  sd_typvar(ivar+1)%cname       = 'mtrp_dep'//TRIM(csuffixvarnam)
          sd_typvar(ivar)%cunits      = 'SV'                                            ;  sd_typvar(ivar+1)%cunits      = 'SV'
          sd_typvar(ivar)%valid_min   = -500.                                           ;  sd_typvar(ivar+1)%valid_min   = -500.
          sd_typvar(ivar)%valid_max   =  500.                                           ;  sd_typvar(ivar+1)%valid_max   =  500.
          sd_typvar(ivar)%clong_name  = TRIM(cprefixlongnam)//'Positive_trp_per_class'  ;  sd_typvar(ivar+1)%clong_name  = TRIM(cprefixlongnam)//'Negative_trp_per_class'
          sd_typvar(ivar)%cshort_name = 'ptrp_dep'                                      ;  sd_typvar(ivar+1)%cshort_name = 'mtrp_dep'
          ivar = ivar + 1
       ENDIF

       IF ( lheat ) THEN
          ivar = ivar + 1  ; ihtrpcl = ivar                                              ;  istrpcl = ivar+1
          ipk(ivar) = nclass                                                             ;  ipk(ivar+1) = nclass
          sd_typvar(ivar)%cname       = 'htrp_dep'//TRIM(csuffixvarnam)                  ;  sd_typvar(ivar+1)%cname       = 'strp_dep'//TRIM(csuffixvarnam)
          sd_typvar(ivar)%cunits      = 'PW'                                             ;  sd_typvar(ivar+1)%cunits      = 'kt/s'
          sd_typvar(ivar)%valid_min   = -1000.                                           ;  sd_typvar(ivar+1)%valid_min   = -1000.
          sd_typvar(ivar)%valid_max   =  1000.                                           ;  sd_typvar(ivar+1)%valid_max   =  1000.
          sd_typvar(ivar)%clong_name  = TRIM(cprefixlongnam)//'Heat_Transport_per_class' ;  sd_typvar(ivar+1)%clong_name  = TRIM(cprefixlongnam)//'Salt_Transport_per_class'
          sd_typvar(ivar)%cshort_name = 'htrp_dep'                                       ;  sd_typvar(ivar+1)%cshort_name = 'strp_dep'
          ivar = ivar + 1
       ENDIF
    ENDIF

  END SUBROUTINE set_typvar

  SUBROUTINE set_typvarc ( sd_typvar, cdsection, cdvarname, cdlongname ) 
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE set_typvarc  ***
    !!
    !! ** Purpose : Initialize typvar structure for netcdfoutput at a given section
    !!
    !! ** Method  : use varname longname to suffix variable name and attributes
    !!              If varname and/or logname are not given (ie 'none') take
    !!              standard default names
    !!              Netcdf id for variables are passed as global variables
    !!----------------------------------------------------------------------
    TYPE(variable), DIMENSION(:), INTENT(out) :: sd_typvar        ! structure of output
    CHARACTER(LEN=*),             INTENT(in ) :: cdsection
    CHARACTER(LEN=*),             INTENT(in ) :: cdvarname
    CHARACTER(LEN=*),             INTENT(in ) :: cdlongname
    !!
    INTEGER(KIND=4)                           :: ivar
    CHARACTER(LEN=255)                        :: csuffixvarnam
    CHARACTER(LEN=255)                        :: cprefixlongnam
    !!----------------------------------------------------------------------
    ! set suffixes according to variable/longname 
    IF ( cdvarname /= 'none' ) THEN
       csuffixvarnam = '_'//TRIM(cdvarname)
    ELSE
       csuffixvarnam = ''
    ENDIF

    IF ( cdlongname /= 'none' ) THEN
       cprefixlongnam = TRIM(cdlongname)//'_'
    ELSE
       cprefixlongnam = ''
    ENDIF

    ! set common values
    sd_typvar%rmissing_value=99999.
    sd_typvar%scale_factor= 1.
    sd_typvar%add_offset= 0.
    sd_typvar%savelog10= 0.
    sd_typvar%conline_operation='N/A'
    sd_typvar%caxis='T'

    ! set particular values for individual variables
    ivar = 1  ; ivtrpc = ivar
    ipkc(ivar) = 1
    sd_typvar(ivar)%cname       = 'vtrpcumul'//TRIM(csuffixvarnam)
    sd_typvar(ivar)%cunits      = 'Sverdrup'
    sd_typvar(ivar)%valid_min   = -500.
    sd_typvar(ivar)%valid_max   =  500.
    sd_typvar(ivar)%clong_name  = TRIM(cprefixlongnam)//'Volume_Transport'
    sd_typvar(ivar)%cshort_name = 'vtrp'

    IF ( lheat ) THEN
       ivar = ivar + 1 ; ihtrpc = ivar                                                 ;  istrpc = ivar+1
       ipkc(ivar) = 1                                                                  ;  ipkc(ivar+1) = 1
       sd_typvar(ivar)%cname       = 'htrpcumul'//TRIM(csuffixvarnam)                  ;  sd_typvar(ivar+1)%cname       = 'strpcumul'//TRIM(csuffixvarnam)
       sd_typvar(ivar)%cunits      = 'PW'                                              ;  sd_typvar(ivar+1)%cunits      = 'kt/s'
       sd_typvar(ivar)%valid_min   = -1000.                                            ;  sd_typvar(ivar+1)%valid_min   = -1000.
       sd_typvar(ivar)%valid_max   =  1000.                                            ;  sd_typvar(ivar+1)%valid_max   =  1000.
       sd_typvar(ivar)%clong_name  = TRIM(cprefixlongnam)//'Heat_Transport'            ;  sd_typvar(ivar+1)%clong_name  = TRIM(cprefixlongnam)//'Salt_Transport'
       sd_typvar(ivar)%cshort_name = 'htrp'                                            ;  sd_typvar(ivar+1)%cshort_name = 'strp'
       ivar = ivar + 1
    ENDIF


    ivtrpclc = -1  ; ihtrpclc = -1 ; istrpclc = -1
    IF ( nclass > 1 ) THEN  ! define additional variable for vertical profile of transport (per class)
       ivar = ivar + 1  ; ivtrpclc = ivar
       ipkc(ivar) = nclass                      
       sd_typvar(ivar)%cname       = 'vtrp_dep_cumul'//TRIM(csuffixvarnam) 
       sd_typvar(ivar)%cunits      = 'SV'  
       sd_typvar(ivar)%valid_min   = 0.       
       sd_typvar(ivar)%valid_max   = 10000.  
       sd_typvar(ivar)%clong_name  = TRIM(cprefixlongnam)//'Volume_Transport_per_class' 
       sd_typvar(ivar)%cshort_name = 'vtrp_dep'            

       IF ( lheat ) THEN
          ivar = ivar + 1  ; ihtrpclc = ivar                                             ;  istrpclc = ivar+1
          ipkc(ivar) = nclass                                                            ;  ipkc(ivar+1) = nclass
          sd_typvar(ivar)%cname       = 'htrp_dep_cumul'//TRIM(csuffixvarnam)            ;  sd_typvar(ivar+1)%cname       = 'strp_dep_cumul'//TRIM(csuffixvarnam)
          sd_typvar(ivar)%cunits      = 'PW'                                             ;  sd_typvar(ivar+1)%cunits      = 'kt/s'
          sd_typvar(ivar)%valid_min   = -1000.                                           ;  sd_typvar(ivar+1)%valid_min   = -1000.
          sd_typvar(ivar)%valid_max   =  1000.                                           ;  sd_typvar(ivar+1)%valid_max   =  1000.
          sd_typvar(ivar)%clong_name  = TRIM(cprefixlongnam)//'Heat_Transport_per_class' ;  sd_typvar(ivar+1)%clong_name  = TRIM(cprefixlongnam)//'Salt_Transport_per_class'
          sd_typvar(ivar)%cshort_name = 'htrp_dep'                                       ;  sd_typvar(ivar+1)%cshort_name = 'strp_dep'
          ivar = ivar + 1
       ENDIF
    ENDIF

  END SUBROUTINE set_typvarc

  SUBROUTINE interm_pt (ydpt, kk, pai, pbi, paj, pbj, ydpti)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE nterm_pt  ***
    !!
    !! ** Purpose : Find the best intermediate points on a pathway.
    !!
    !! ** Method  : ydpt : complex vector of the positions of the nearest points
    !!               kk  : current working index
    !!          pai, pbi : slope and original ordinate of x(y)
    !!          paj, pbj : slope and original ordinate of y(x)
    !!             ydpti : Complex holding the position of intermediate point 
    !!
    !! ** Reference : 19/07/1999 : J.M. Molines in Clipper
    !!----------------------------------------------------------------------
    COMPLEX, DIMENSION(:), INTENT(in ) :: ydpt
    COMPLEX,               INTENT(out) :: ydpti
    REAL(KIND=4),          INTENT(in ) :: pai, pbi, paj, pbj
    INTEGER(KIND=4),       INTENT(in ) :: kk
    ! ... local
    COMPLEX                            :: ylptmp1, ylptmp2
    REAL(KIND=4)                       :: za0, zb0
    REAL(KIND=4)                       :: za1, zb1
    REAL(KIND=4)                       :: zd1, zd2
    REAL(KIND=4)                       :: zxm, zym
    REAL(KIND=4)                       :: zxp, zyp
    !!----------------------------------------------------------------------
    ! ... Determines whether we use y(x) or x(y):
    IF (ABS(paj) <=  1) THEN
       ! .....  use y(x)
       ! ... possible intermediate points:
       ylptmp1=ydpt(kk-1)+(1.,0.)                 ! M1 
       ylptmp2=ydpt(kk-1)+CMPLX(0.,SIGN(1.,paj))  ! M2
       !
       ! ... M1 is the candidate point:
       zxm=REAL(ylptmp1)
       zym=IMAG(ylptmp1)
       za0=paj
       zb0=pbj
       !
       za1=-1./za0
       zb1=zym - za1*zxm
       ! ... P1 is the projection of M1 on the strait line
       zxp=-(zb1-zb0)/(za1-za0)
       zyp=za0*zxp + zb0
       ! ... zd1 is the distance M1P1
       zd1=(zxm-zxp)*(zxm-zxp) + (zym-zyp)*(zym-zyp)
       !
       ! ... M2 is the candidate point:
       zxm=REAL(ylptmp2)
       zym=IMAG(ylptmp2)
       za1=-1./za0
       zb1=zym - za1*zxm
       ! ... P2 is the projection of M2 on the strait line
       zxp=-(zb1-zb0)/(za1-za0)
       zyp=za0*zxp + zb0
       ! ... zd2 is the distance M2P2
       zd2=(zxm-zxp)*(zxm-zxp) + (zym-zyp)*(zym-zyp)
       ! ... chose the smallest (zd1,zd2)
       IF (zd2 <=  zd1) THEN
          ydpti=ylptmp2   ! use M2
       ELSE
          ydpti=ylptmp1   ! use M1
       END IF
       !
    ELSE   
       ! ...  use x(y)
       ! ... possible intermediate points:
       ylptmp1=ydpt(kk-1)+CMPLX(SIGN(1.,pai),0.)  ! M1
       ylptmp2=ydpt(kk-1)+(0.,1.)                 ! M2
       ! 
       ! ... M1 is the candidate point:
       zxm=REAL(ylptmp1)
       zym=IMAG(ylptmp1)
       za0=pai
       zb0=pbi
       !
       za1=-1./za0
       zb1=zxm - za1*zym
       zyp=-(zb1-zb0)/(za1-za0)
       zxp=za0*zyp + zb0
       zd1=(zxm-zxp)*(zxm-zxp) + (zym-zyp)*(zym-zyp)
       !
       zxm=REAL(ylptmp2)
       zym=IMAG(ylptmp2)
       za1=-1./za0
       zb1=zxm - za1*zym
       zyp=-(zb1-zb0)/(za1-za0)
       zxp=za0*zyp + zb0
       zd2=(zxm-zxp)*(zxm-zxp) + (zym-zyp)*(zym-zyp)
       IF (zd2 <=  zd1) THEN
          ydpti=ylptmp2
       ELSE
          ydpti=ylptmp1
       END IF
    END IF
  END SUBROUTINE interm_pt

  SUBROUTINE GetZlimit
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE GetZlimit  ***
    !!
    !! ** Purpose :  Set up a limit list given on the command line as 
    !!               blank separated list
    !!
    !! ** Method  :  Scan the command line until a '-' is found
    !!----------------------------------------------------------------------
    INTEGER (KIND=4)  :: icur
    !!----------------------------------------------------------------------
    !!
    ndep=0
    ! need to read a list of dep ( number unknow ) 
    ! loop on argument till a '-' is found as first char
    icur=ijarg                          ! save current position of argument number
    DO ji = icur, narg                  ! scan arguments till - found
       CALL getarg ( ji, cldum )
       IF ( cldum(1:1) /= '-' ) THEN ; ndep = ndep+1
       ELSE                          ; EXIT
       ENDIF
    ENDDO
    nclass = ndep+1
    ALLOCATE (rz_lst(ndep) )
    DO ji = icur, icur + ndep -1
       CALL getarg(ji, cldum ) ; ijarg=ijarg+1 ; READ(cldum,*) rz_lst( ji -icur +1 )
    END DO
  END SUBROUTINE GetZlimit

END PROGRAM cdftransport

PROGRAM cdfvtrp
  !!======================================================================
  !!                     ***  PROGRAM  cdfvtrp  ***
  !!=====================================================================
  !!  ** Purpose : Compute verticaly integrated transport.
  !!
  !!  ** Method  : Read the velocity components, and computed the verticaly
  !!               averaged transport at each grid cell ( velocity location).
  !!
  !! History : 2.1  : 01/2005  : J.M. Molines : Original code
  !!                : 01/2008  : P. Mathiot for -lbathy option
  !!           3.0  : 05/2011  : J.M. Molines : Doctor norm + Lic., merge
  !!                             with cdftrp_bathy
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                            :: ji, jj, jk, jt       ! dummy loop index
  INTEGER(KIND=4)                            :: ierr, ireq           ! working integer
  INTEGER(KIND=4)                            :: narg, iargc, ijarg   ! command line 
  INTEGER(KIND=4)                            :: npiglo, npjglo       ! size of the domain
  INTEGER(KIND=4)                            :: npk, npt             ! size of the domain
  INTEGER(KIND=4)                            :: ncout                ! ncid of output file
  INTEGER(KIND=4)                            :: nvarout = 2          ! number of output variables
  INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE :: ipk, id_varout       ! for variable output

  REAL(KIND=4), DIMENSION (:,:), ALLOCATABLE :: e1u, e1v             ! horizontal metrics
  REAL(KIND=4), DIMENSION (:,:), ALLOCATABLE :: e2u, e2v             !  "            "
  REAL(KIND=4), DIMENSION (:,:), ALLOCATABLE :: e3u, e3v             ! vertical metrics
  REAL(KIND=4), DIMENSION (:,:), ALLOCATABLE :: tmask, hdepw         ! tmask and bathymetry
  REAL(KIND=4), DIMENSION (:,:), ALLOCATABLE :: zdhdx, zdhdy         ! bottom slope
  REAL(KIND=4), DIMENSION (:,:), ALLOCATABLE :: zalpha               ! angle of rotation
  REAL(KIND=4), DIMENSION (:,:), ALLOCATABLE :: zu, zv               ! velocity components
  REAL(KIND=4), DIMENSION(:),    ALLOCATABLE :: tim                  ! time counter
  REAL(KIND=4), DIMENSION(:),    ALLOCATABLE :: e31d                 ! e3t metrics (full step)

  REAL(KIND=8), DIMENSION (:,:), ALLOCATABLE :: dwku , dwkv          ! working arrays
  REAL(KIND=8), DIMENSION (:,:), ALLOCATABLE :: dtrpu, dtrpv         ! barotropic transport 

  TYPE (variable), DIMENSION(:), ALLOCATABLE :: stypvar              ! structure for attribute

  CHARACTER(LEN=256)                         :: cf_ufil              ! input U- file
  CHARACTER(LEN=256)                         :: cf_vfil              ! input V- file
  CHARACTER(LEN=256)                         :: cf_out='trp.nc'      ! output file
  CHARACTER(LEN=256)                         :: cv_soastrp='soastrp' ! Along Slope TRansPort
  CHARACTER(LEN=256)                         :: cv_socstrp='socstrp' ! Cross Slope TRansPort
  CHARACTER(LEN=256)                         :: cldum                ! dummy character variable

  LOGICAL                                    :: lfull  = .FALSE.     ! flag for full step
  LOGICAL                                    :: lbathy = .FALSE.     ! flag for slope current
  LOGICAL                                    :: lchk   = .FALSE.     ! flag for missing files
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfvtrp  U-file V-file [ -full ] [ -bathy ]'
     PRINT *,'     PURPOSE :'
     PRINT *,'       Computes the vertically integrated transports at each grid cell.' 
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       U-file : netcdf gridU file' 
     PRINT *,'       V-file : netcdf gridV file' 
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        ',TRIM(cn_fhgr),' and ',TRIM(cn_fzgr)
     PRINT *,'        ',TRIM(cn_fmsk),' is required only with -bathy option.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-full ]  : To be used in case of full step configuration.'
     PRINT *,'                   Default is partial steps.'
     PRINT *,'       [-bathy ] : When used, cdfvtrp also compute the along slope'
     PRINT *,'                   and cross slope transport components.'
     PRINT *,'                   Bathymetry is read from ',TRIM(cn_fzgr),' file.'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'       variables : ' 
     PRINT *,'           ', TRIM(cn_sozoutrp),' : zonal transport.'
     PRINT *,'           ', TRIM(cn_somevtrp),' : meridional transport.'
     PRINT *,'          If option -bathy is used :'
     PRINT *,'           ', TRIM(cv_soastrp),' : along slope transport'
     PRINT *,'           ', TRIM(cv_socstrp),' : cross slope transport'
     STOP
  ENDIF

  ! scan command line and set flags
  ijarg = 1 ; ireq=0
  DO WHILE ( ijarg <= narg ) 
     CALL getarg(ijarg, cldum) ; ijarg=ijarg+1
     SELECT CASE ( cldum ) 
     CASE ('-full'  ) ; lfull  = .TRUE.
     CASE ('-bathy' ) ; lbathy = .TRUE. ; nvarout = 4
     CASE DEFAULT 
        ireq=ireq+1  ! required arguments
        SELECT CASE ( ireq )
        CASE ( 1 ) ; cf_ufil = cldum   
        CASE ( 2 ) ; cf_vfil = cldum      
        END SELECT
     END SELECT
  ENDDO
  
  ! file existence check
  lchk = lchk .OR. chkfile ( cn_fzgr )
  lchk = lchk .OR. chkfile ( cn_fhgr )
  lchk = lchk .OR. chkfile ( cf_ufil )
  lchk = lchk .OR. chkfile ( cf_vfil )
  IF ( lbathy ) lchk = lchk .OR. chkfile ( cn_fmsk )
  IF ( lchk ) STOP 99 ! missing files

  ALLOCATE ( ipk(nvarout), id_varout(nvarout), stypvar(nvarout) )

  npiglo = getdim (cf_ufil, cn_x)
  npjglo = getdim (cf_ufil, cn_y)
  npk    = getdim (cf_ufil, cn_z)
  npt    = getdim (cf_ufil, cn_t)

  ! define  variables for output 
  ipk(:) = 1   ! all 2D variables
  stypvar%rmissing_value    = 0.
  stypvar%valid_min         = -100.
  stypvar%valid_max         = 100.
  stypvar%cunits            = 'm3/s'
  stypvar%conline_operation = 'N/A'
  stypvar%caxis             = 'TYX'

  stypvar(1)%cname       = cn_sozoutrp                         ; stypvar(2)%cname       = cn_somevtrp
  stypvar(1)%clong_name  = 'Zonal_barotropic_transport'        ; stypvar(2)%clong_name  = 'Meridional_barotropic_transport'
  stypvar(1)%cshort_name = cn_sozoutrp                         ; stypvar(2)%cshort_name = cn_somevtrp

  IF ( lbathy ) THEN
     stypvar(3)%cname       = cv_soastrp                       ; stypvar(4)%cname       = cv_socstrp
     stypvar(3)%clong_name  = 'Along_Slope_Barotropic_Transp'  ; stypvar(4)%clong_name  = 'Cross_Slope_Barotropic_Transp'
     stypvar(3)%cshort_name = cv_soastrp                       ; stypvar(4)%cshort_name = cv_socstrp
  ENDIF

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  ! Allocate arrays
  ALLOCATE ( e1v(npiglo,npjglo), e3v(npiglo,npjglo)    )
  ALLOCATE ( e2u(npiglo,npjglo), e3u(npiglo,npjglo)    )
  ALLOCATE ( zu(npiglo,npjglo), zv(npiglo,npjglo)      )
  ALLOCATE ( dwku(npiglo,npjglo), dwkv(npiglo,npjglo)  )
  ALLOCATE ( dtrpu(npiglo,npjglo), dtrpv(npiglo,npjglo))
  ALLOCATE ( e31d(npk), tim(npt)                       )

  IF ( lbathy ) THEN ! allocate extra arrays
     ALLOCATE ( e1u(npiglo, npjglo), e2v(npiglo, npjglo))
     ALLOCATE ( tmask(npiglo,npjglo), hdepw(npiglo, npjglo) )
     ALLOCATE ( zdhdx(npiglo,npjglo), zdhdy(npiglo, npjglo) )
     ALLOCATE ( zalpha(npiglo,npjglo) )
  ENDIF

  ! create output fileset
  ncout = create      (cf_out, cf_ufil, npiglo,  npjglo, 1         )
  ierr  = createvar   (ncout,  stypvar, nvarout, ipk,    id_varout )
  ierr  = putheadervar(ncout,  cf_ufil, npiglo,  npjglo, 1         )

  tim   = getvar1d(cf_ufil, cn_vtimec, npt     )
  ierr  = putvar1d(ncout,   tim,       npt, 'T')

  e1v(:,:) = getvar(cn_fhgr, cn_ve1v, 1, npiglo, npjglo)
  e2u(:,:) = getvar(cn_fhgr, cn_ve2u, 1, npiglo, npjglo)
  IF ( lfull )  e31d(:)  = getvare3(cn_fzgr, cn_ve3t1d, npk )

  IF ( lbathy ) THEN  ! read extra metrics
    e1u(:,:)   = getvar(cn_fhgr, cn_ve1u,  1, npiglo, npjglo)
    e2v(:,:)   = getvar(cn_fhgr, cn_ve2v,  1, npiglo, npjglo)
    tmask(:,:) = getvar(cn_fmsk, 'tmask',  1, npiglo, npjglo)
    hdepw(:,:) = getvar(cn_fzgr, cn_hdepw, 1, npiglo, npjglo)
  ENDIF

  DO jt = 1, npt
     dtrpu(:,:)= 0.d0
     dtrpv(:,:)= 0.d0
     DO jk = 1,npk
        PRINT *,'level ',jk
        ! Get velocities at jk
        zu(:,:)= getvar(cf_ufil, cn_vozocrtx, jk ,npiglo, npjglo, ktime=jt)
        zv(:,:)= getvar(cf_vfil, cn_vomecrty, jk ,npiglo, npjglo, ktime=jt)

        ! get e3v at level jk
        IF ( lfull ) THEN
           e3v(:,:) = e31d(jk)
           e3u(:,:) = e31d(jk)
        ELSE
           e3v(:,:) = getvar(cn_fzgr, 'e3v_ps', jk, npiglo, npjglo, ldiom=.TRUE.)
           e3u(:,:) = getvar(cn_fzgr, 'e3u_ps', jk, npiglo, npjglo, ldiom=.TRUE.)
        ENDIF
        dwku(:,:) = zu(:,:)*e2u(:,:)*e3u(:,:)*1.d0
        dwkv(:,:) = zv(:,:)*e1v(:,:)*e3v(:,:)*1.d0
        ! integrates vertically 
        dtrpu(:,:) = dtrpu(:,:) + dwku(:,:)
        dtrpv(:,:) = dtrpv(:,:) + dwkv(:,:)

     END DO  ! loop to next level

     ierr = putvar(ncout, id_varout(1) ,REAL(dtrpu(:,:)), 1, npiglo, npjglo, ktime=jt)
     ierr = putvar(ncout, id_varout(2) ,REAL(dtrpv(:,:)), 1, npiglo, npjglo, ktime=jt)

     IF ( lbathy ) THEN
       ! compute transport component at T point 
       dwku(:,:) = 0.d0        ! U direction
       DO jj=1, npjglo
          DO ji= 2,npiglo
            dwku(ji,jj) = 0.5 * ( dtrpu(ji,jj) + dtrpu(ji-1,jj) )
          ENDDO
          ! E-W periodicity :
          dwku(1,jj) = dwku(npiglo-1, jj)
       ENDDO
       dwkv(:,:) = 0.d0        ! V direction
       DO jj=2, npjglo
          DO ji= 1,npiglo
            dwkv(ji,jj) = 0.5 * ( dtrpv(ji,jj) + dtrpv(ji,jj-1) )
          ENDDO
       ENDDO

       ! compute bathymetric slope at T point (centered scheme)
       zdhdx = 0.e0            ! U direction
       DO jj=1,npjglo          
          DO ji=2, npiglo-1
            zdhdx(ji,jj) = ( hdepw(ji+1,jj) - hdepw(ji-1,jj)) / ( e1u(ji,jj) + e1u(ji-1,jj) ) * tmask(ji,jj)
          END DO
       END DO

       zdhdy = 0.e0            ! V direction
       DO jj=2,npjglo-1        
          DO ji=1, npiglo
            zdhdy(ji,jj) = ( hdepw(ji,jj+1) - hdepw(ji,jj-1)) / ( e2v(ji,jj) + e2v(ji,jj-1) ) * tmask(ji,jj)
          END DO
       END DO
      
       ! compute the angle between the bathymetric slope and model coordinates
       zalpha(:,:) = ATAN2( zdhdx, zdhdy ) * tmask(:,:)
 
       ! apply the rotation on the transport
       dtrpu(:,:) = (  dwku(:,:) * COS(zalpha) + dwkv(:,:)* SIN(zalpha) ) * tmask(:,:)
       dtrpv(:,:) = ( -dwku(:,:) * SIN(zalpha) + dwkv(:,:)* COS(zalpha) ) * tmask(:,:)
      
       ierr = putvar(ncout, id_varout(3) ,REAL(dtrpu(:,:)), 1, npiglo, npjglo, ktime=jt)
       ierr = putvar(ncout, id_varout(4) ,REAL(dtrpv(:,:)), 1, npiglo, npjglo, ktime=jt)
     ENDIF
  END DO

  ierr = closeout (ncout)

END PROGRAM cdfvtrp

PROGRAM cdfsigintegr
  !!======================================================================
  !!                     ***  PROGRAM  cdfsigintegr  ***
  !!=====================================================================
  !!  ** Purpose : This program is used to integrate quantities between 
  !!               isopycnals
  !!
  !!  ** Method  : Linear interpolation is used on the vertical to define
  !!               the depth of the given isopycn.
  !!               Then, the integral is performed from the top of the ocean
  !!               down to the given isopycnal. Finaly, by making the 
  !!               difference between 2 isopycnals we obtain the required 
  !!               quantity.
  !!
  !! History : 2.1  : 12/2007  : J.M. Molines : Original code
  !!           3.0  : 06/2011  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  USE modutils
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class integration
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                               :: ji, jj, jk, jt   ! dummy loop index
  INTEGER(KIND=4)                               :: jiso, jfich      ! dummy loop index
  INTEGER(KIND=4)                               :: jvar             ! dummy loop index
  INTEGER(KIND=4)                               :: it               ! time index for vvl
  INTEGER(KIND=4)                               :: npiglo, npjglo   ! domain size
  INTEGER(KIND=4)                               :: npk, npt         ! domain size
  INTEGER(KIND=4)                               :: npiso, nvars     ! number of isopycnals, variables
  INTEGER(KIND=4)                               :: narg, iargc      ! command line
  INTEGER(KIND=4)                               :: ijarg, ireq      ! command line
  INTEGER(KIND=4)                               :: nfiles           ! number of input files
  INTEGER(KIND=4)                               :: nsfiles          ! number of density input files
  INTEGER(KIND=4)                               :: istrt_arg        ! argument number of first input file
  INTEGER(KIND=4)                               :: ijk              ! layer index
  INTEGER(KIND=4)                               :: ik               ! working integer
  INTEGER(KIND=4)                               :: ik0              ! working integer
  INTEGER(KIND=4)                               :: numin=10         ! logical unit for ascii input file
  INTEGER(KIND=4)                               :: ncout, ierr      ! ncid and status variable
  INTEGER(KIND=4), DIMENSION(4)                 :: ipk, id_varout   ! levels and id's of output variables
  !
  REAL(KIND=4)                                  :: zspval=999999.   ! output missing value
  REAL(KIND=4)                                  :: spvalz          ! missing value from rho file      
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: rho_lev          ! value of isopycnals
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: h1d              ! depth of rho points
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: e31d             ! vertical metrics in full step
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: v2d              ! 2D working array
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: e3               ! vertical metrics
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: tmask            ! mask of t points from rho
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: zdum             ! dummy array for I/O
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: gdepw2d          ! depth of W points
  REAL(KIND=4), DIMENSION(:,:,:),   ALLOCATABLE :: v3d              ! 3D working array (npk)
  REAL(KIND=4), DIMENSION(:,:,:),   ALLOCATABLE :: zint             ! pseudo 3D working array (2)

  REAL(KIND=8)                                  :: dl_wght
  REAL(KIND=8), DIMENSION(:),       ALLOCATABLE :: dtim             ! time counter
  REAL(KIND=8), DIMENSION(:,:,:),   ALLOCATABLE :: dv2dint          ! interpolated value 
  REAL(KIND=8), DIMENSION(:,:,:),   ALLOCATABLE :: dalpha           ! 3D coefficient (npiso)

  CHARACTER(LEN=256)                            :: cf_rholev = 'rho_lev' ! input file for rho surfaces
  CHARACTER(LEN=256)                            :: cf_in            ! input file for data
  CHARACTER(LEN=256)                            :: cf_tsig          ! text file with density filename
  CHARACTER(LEN=256)                            :: cf_tdta          ! text file with data filename
  CHARACTER(LEN=256)                            :: cf_wk            ! working character variable
  CHARACTER(LEN=256)                            :: cf_rho           ! input file for density
  CHARACTER(LEN=256)                            :: cf_out           ! output file
  CHARACTER(LEN=256)                            :: cf_e3            ! e3 filename ( for vvl )
  CHARACTER(LEN=256)                            :: cv_in            ! name of input variable
  CHARACTER(LEN=256)                            :: cldum            ! dummy string variable
  CHARACTER(LEN=256)                            :: cluni            ! dummy string variable for variable units
  CHARACTER(LEN=256)                            :: cglobal          ! global attribute
  CHARACTER(LEN=256)                            :: ctype='T'        ! position of variable on C grid
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_names         ! temporary arry for variable name in file
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cf_lst           ! list of input files
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cf_slst          ! list of input density files (option -sl)

  TYPE(variable), DIMENSION(4)                  :: stypvar          ! structure for attributes
  TYPE(variable), DIMENSION(:),     ALLOCATABLE :: stypzvar         ! structure for attributes

  LOGICAL                                       :: lscli = .FALSE.  ! flag for climatological  density
  LOGICAL                                       :: lfull = .FALSE.  ! flag for full step
  LOGICAL                                       :: lchk  = .FALSE.  ! flag for missing files
  LOGICAL                                       :: lnc4  = .FALSE.  ! flag for netcdf4 output
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg=iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfsigintegr -s RHO-file | -sl LST-RHO-files | -st LST-RHO-txt ...'
     PRINT *,'              ... -l LST-files | -lt LST-DATA-txt  -v IN-var [-p C-type ] ...'
     PRINT *,'              ... [-sig sigma_name] [-full] [-nc4] [-vvl]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :' 
     PRINT *,'       Take a list of input files with specific IN-var variable, associated'
     PRINT *,'       with a reference density file. A set of isopycnal surfaces is defined'
     PRINT *,'       in an ASCII file (rho_lev by default), using same depth reference than'
     PRINT *,'       the input reference density file. This program computes the integral of'
     PRINT *,'       IN-var between the isopycnals defined in rho_lev. It also gives the '
     PRINT *,'       isopycnal depth and thickness of density layers.'
     PRINT *,'      '
     PRINT *,'       Rho_lev file first line indicates the number of following isopycnals.'
     PRINT *,'       Then a list of the densities is given, one per line.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -v IN-var : input variable to be integrated' 
     PRINT *,'       -s RHO-file : netcdf file with already computed density' 
     PRINT *,'          or'
     PRINT *,'       -sl LST-RHO-file : a blank separated list of density files '
     PRINT *,'           It is mandatory that, when using this option, the number of time '
     PRINT *,'           frames is fully coherent with the data files.'
     PRINT *,'          or'
     PRINT *,'       -sl LST-RHO-txt : Pass a text file with the name of density files (1 per line).'
     PRINT *,'       -l LST-files : a blank separated list of model netcdf files '
     PRINT *,'              containing IN-var.'
     PRINT *,'          or'
     PRINT *,'       -lt LST-DATA-txt : Pass a text file with the name of data files (1 per line).'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-p  C-type ] : one of T U V F W which defined the position of' 
     PRINT *,'               IN-var in the model C-grid. Default is ', TRIM(ctype)
     PRINT *,'       [-sig sigma_name ] : give the name of sigma variable in RHO-file.'
     PRINT *,'               Default is ',TRIM(cn_vosigma0)
     PRINT *,'       [-full ] : indicate a full step configuration.'
     PRINT *,'       [-rholev  file] : indicates name of file defining the limits for '
     PRINT *,'               integration. Default is ', TRIM(cf_rholev)
     PRINT *,'       [-vvl ] : use time-varying vertical metrics.'
     PRINT *,'       [-nc4 ] : Use netcdf4 output with chunking and deflation level 1.'
     PRINT *,'            This option is effective only if cdftools are compiled with'
     PRINT *,'            a netcdf library supporting chunking and deflation.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ', TRIM(cn_fzgr),' and ',TRIM(cf_rholev)
     PRINT *,'      '
     PRINT *,'     OPENMP SUPPORT : yes'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : IN-file.integr'
     PRINT *,'         variables : inv_<IN-var>  : inventory of IN-var from input file.'
     PRINT *,'            ', TRIM(cn_vodepiso),' (m) : depth of isopycnal.'
     PRINT *,'            ', TRIM(cn_isothick),' (m) : thickness of isopycnal layer.'
     PRINT *,'            mean_<IN-var> (same unit as IN-var) : mean IN-var in the isopycnal'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'      cdfrhoproj, cdfsigtrp, cdfisopycdep'
     PRINT *,'      '
     STOP 
  ENDIF

  ijarg = 1 ; ireq = 0 ; nfiles = 0 ; nsfiles = 0
  cf_tsig='none' ; cf_tdta='none'
  DO WHILE ( ijarg <= narg ) 
     CALL getarg( ijarg, cldum ) ; ijarg = ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-v'      ) ; CALL getarg( ijarg, cv_in      ) ; ijarg = ijarg+1 ; ireq=ireq+1
     CASE ( '-s'      ) ; CALL getarg( ijarg, cf_rho     ) ; ijarg = ijarg+1 ; ireq=ireq+1
      ! or 
     CASE ( '-sl'     ) ; CALL GetFileList(cf_slst,nsfiles)                  ; ireq=ireq+1
      ! or 
     CASE ( '-st'     ) ; CALL getarg( ijarg, cf_tsig    );  ijarg = ijarg+1 ; ireq=ireq+1
     CASE ( '-l'      ) ; CALL GetFileList(cf_lst,nfiles)                    ; ireq=ireq+1
      ! or 
     CASE ( '-lt'     ) ; CALL getarg( ijarg, cf_tdta    );  ijarg = ijarg+1 ; ireq=ireq+1
        ! options
     CASE ( '-p'      ) ; CALL getarg( ijarg, ctype      ) ; ijarg = ijarg+1 
     CASE ( '-sig'    ) ; CALL getarg( ijarg, cn_vosigma0) ; ijarg = ijarg+1 
     CASE ( '-rholev ') ; CALL getarg( ijarg, cf_rholev  ) ; ijarg = ijarg+1
     CASE ( '-full '  ) ; lfull  = .TRUE.
     CASE ( '-vvl'    ) ; lg_vvl = .TRUE.
     CASE ( '-nc4'    ) ; lnc4   = .TRUE.
     CASE DEFAULT       ; PRINT *, ' ERROR : ', TRIM(cldum), 'unknown option.' ; STOP 99
     END SELECT
  ENDDO

  IF ( ireq /= 3 ) THEN 
      PRINT *,' Exactly 3 options are mandatory. Look to usage message !' 
      PRINT *,'   In particular you cannot have both -s AND -sl  or -st options !' ; STOP 99;
  ENDIF

  IF ( cf_tdta /= 'none' ) THEN
     PRINT *,' Setting data file list from ',TRIM(cf_tdta)
     CALL GetTxtFileList(cf_tdta,cf_lst,nfiles)
  ENDIF

  IF ( cf_tsig /= 'none' ) THEN
     PRINT *,' Setting density file list from ',TRIM(cf_tsig)
     CALL GetTxtFileList(cf_tsig,cf_slst,nsfiles)
  ENDIF

  IF ( nsfiles == 0 ) THEN  ! means there is a climatological density file
     lscli = .true.
     PRINT *, " Use a single climatological  density files."
     ALLOCATE(cf_slst(1) )
     cf_slst = cf_rho
  ELSE
     PRINT *, " Use ",nsfiles,"  density files."
     PRINT *, " Use ",nfiles,"  data files."
     ! nsfiles should be equal to nfiles in case of multiple files
     lscli = .false.
     IF ( nsfiles /= nfiles) STOP ' ERROR: Number of density files differs form number of data file'
     cf_rho=cf_slst(1)
  ENDIF

  CALL SetGlobalAtt( cglobal )

  ! check for files
  lchk = lchk .OR. chkfile (cn_fzgr   )
  lchk = lchk .OR. chkfile (cf_rholev )
  IF ( lscli) lchk = lchk .OR. chkfile (cf_rho    )
  IF ( lchk ) STOP 99 ! missing file

  ! Read rho level between which the integral is being performed
  OPEN(numin,file=cf_rholev)
  READ(numin,*) npiso
  ALLOCATE (rho_lev(npiso) )
  PRINT *,' Density limits read in ',TRIM(cf_rholev)
  DO jiso=1,npiso
     READ(numin,*) rho_lev(jiso)
     PRINT *,rho_lev(jiso)
  END DO
  CLOSE(numin)

  ! assume here that all files have the same geometry (as well as density files) use the 1rst of the list
  cf_wk = cf_slst(1)
  IF ( chkfile (cf_wk) ) STOP 'missing density file 1' 
  npiglo = getdim(cf_wk, cn_x)
  npjglo = getdim(cf_wk, cn_y)
  npk    = getdim(cf_wk, cn_z)

  spvalz=getspval(cf_wk, cn_vosigma0)

  cf_in =  cf_lst(1)
  IF ( chkfile ( cf_in) ) STOP 'missing data file 1'  ! missing file

  nvars=getnvar(cf_in )
  ALLOCATE(cv_names(nvars), stypzvar(nvars))

  cv_names(:)=getvarname(cf_in,nvars,stypzvar)

  ALLOCATE( v3d(npiglo,npjglo,npk), dalpha(npiglo,npjglo,npiso), e3(npiglo,npjglo) )
  ALLOCATE( dv2dint(npiglo,npjglo,2), v2d(npiglo,npjglo), zint(npiglo,npjglo,2)  )
  ALLOCATE( gdepw2d(npiglo,npjglo) )
  ALLOCATE( h1d(npk) ,tmask(npiglo,npjglo), zdum(npiglo,npjglo) )
  IF ( lfull ) ALLOCATE ( e31d(npk) )


  IF (lfull ) e31d(:) = getvare3(cn_fzgr, cn_ve3t1d, npk)

  h1d(:) = getvar1d(cf_rho, cn_vdeptht, npk)


  ! Note, if working with vertical slabs, one may avoid 3D array, but may be slow ...
  IF ( lscli ) THEN
    CALL Weight( 1 )
  ENDIF

  ! Create output variables
  CALL CreateOutputVar

  !! ** Loop on the scalar files to project on choosen isopycnics surfaces
  DO jfich=1, nfiles
     cf_in = cf_lst( jfich)
     IF ( .not. lscli ) THEN  ! need to process every density files
        cf_rho=cf_slst(jfich) 
        IF ( chkfile (cf_rho) ) STOP 99 ! missing file
     ENDIF

     IF ( chkfile (cf_in) ) STOP 99 ! missing file
     PRINT *,'working with ', TRIM(cf_in)
     PRINT *,'    and with ', TRIM(cf_rho)
     ! JMM : not obvious to find file wirh correct e3t
     IF (lg_vvl )  THEN
        cn_fe3t = cf_rho
        cn_ve3t = cn_ve3tvvl
     ENDIF

     ! create output file
     cf_out=TRIM(cf_in)//'.integr'

     ! creation of output file is done within the file loop, but do not interfere with 
     ! possible parallelization as output files name are different.
     ncout = create      (cf_out, cf_rho,  npiglo, npjglo, npiso                      , ld_nc4=lnc4 )
     ierr  = createvar   (ncout,  stypvar, 4,      ipk,    id_varout, cdglobal=cglobal, ld_nc4=lnc4 )
     ierr  = putheadervar(ncout,  cf_rho,  npiglo, npjglo, npiso, pdep=rho_lev                      )

     ! copy time arrays in output file
     npt = getdim ( cf_in, cn_t)
     ALLOCATE ( dtim(npt) )
     dtim = getvar1d(cf_in, cn_vtimec, npt     )
     ierr = putvar1d(ncout, dtim,      npt, 'T')
     DEALLOCATE ( dtim )

     DO jt =1, npt
        IF ( lg_vvl) THEN ; it=jt
        ELSE              ; it=1
        ENDIF
        IF ( .not. lscli ) THEN  ! need to process every density files
           CALL Weight( jt )
        ENDIF
        DO jk=1,npk
           v2d(:,:) = getvar(cf_in, cv_in, jk, npiglo, npjglo, ktime = jt )
           SELECT CASE ( ctype )
           CASE ('T', 't' ) ; v3d(:,:,jk) = v2d(:,:)
           CASE ('U','u'  ) ; 
              DO jj=1,npjglo
                 DO ji=2, npiglo
                    v3d(ji,jj,jk)=0.5*( v2d(ji,jj) + v2d(ji-1,jj) )  ! put variable on T point
                 END DO
              END DO
           CASE ('V','v' )
              DO jj=2,npjglo
                 DO ji=1, npiglo
                    v3d(ji,jj,jk)=0.5*( v2d(ji,jj) + v2d(ji,jj-1) )  ! put variable on T point
                 END DO
              END DO
           CASE('W','w' )
              v3d(:,:,jk) = v2d(:,:)
              v2d(:,:) = getvar(cf_in, cv_in, jk+1, npiglo, npjglo, ktime = jt )
              v3d(:,:,jk) = 0.5 * ( v3d(:,:,jk) + v2d(:,:) )
           CASE('F','f' )
              DO jj = 2, npjglo
                 DO ji = 2, npiglo
                    v3d(:,:,jk) = 0.25*( v2d(ji,jj) + v2d( ji, jj-1) + v2d (ji-1,jj-1) + v2d(ji-1, jj) )
                 END DO
              END DO
           END SELECT
        END DO

        ! Compute integral from surface to isopycnal
        DO jiso=1,npiso
           ! determine isopycnal surface
           DO ji=1,npiglo
              DO jj=1,npjglo
                 ! 
                 ik      = INT(dalpha(ji,jj,jiso))
                 dl_wght = dalpha(ji,jj,jiso) - ik
                 IF (ik /= 0) THEN
                    zint (ji,jj,1)=dl_wght*h1d(ik+1) + (1.d0-dl_wght)*h1d(ik)
                 ELSE 
                    zint  (ji,jj,1)=0.  !zspval  
                 ENDIF
              END DO
           END DO
           ! integrate from jk=1 to zint
           dv2dint(:,:,1) = 0.d0
           ! gdepw is recomputef from e3t as it is not coherent in some mesh_zgr files
           gdepw2d(:,:)=0.
           DO jk=1,npk-1
              ! get metrixs at level jk
              IF ( lfull ) THEN  ; e3(:,:) = e31d(jk)
              ELSE               ; e3(:,:) = getvar(cn_fe3t, cn_ve3t, jk,npiglo,npjglo, ktime=it, ldiom=.NOT.lg_vvl )
              ENDIF
              DO ji=1,npiglo
                 DO jj=1,npjglo
                    IF ( gdepw2d(ji,jj)+e3(ji,jj) < zint(ji,jj,1) ) THEN  ! full cell
                       dv2dint(ji,jj,1)=dv2dint(ji,jj,1) + e3(ji,jj)* v3d(ji,jj,jk)
                    ELSE IF (( zint(ji,jj,1) <= gdepw2d(ji,jj)+e3(ji,jj) ) .AND. (zint(ji,jj,1) > gdepw2d(ji,jj)) ) THEN
                       dv2dint(ji,jj,1)=dv2dint(ji,jj,1)+ (zint(ji,jj,1) - gdepw2d(ji,jj) )* v3d(ji,jj,jk)
                    ELSE   ! below the isopycnal 
                       ! do nothing for this i j point
                    ENDIF
                 END DO
              END DO
              gdepw2d(:,:)=gdepw2d(:,:)+e3(:,:)
           END DO   ! end on vertical integral for isopynal jiso

           zdum(:,:)=zint(:,:,1)

           WHERE (tmask == 0. ) zdum=zspval
           ierr = putvar(ncout,id_varout(3), zdum, jiso, npiglo, npjglo, ktime=jt )

           IF (jiso > 1  ) THEN  ! compute the difference ie the inventory in the layer between 2 isopycnals
              zdum=dv2dint(:,:,1) - dv2dint(:,:,2) ; WHERE ((tmask == 0.)  .OR. (zdum < 0 ) ) zdum = zspval
              ierr = putvar(ncout, id_varout(1), zdum, jiso-1, npiglo, npjglo, ktime=jt)

              zdum=zint  (:,:,1) - zint  (:,:,2) ; WHERE ((tmask == 0.)  .OR. (zdum < 0 ) ) zdum = zspval
              ierr = putvar(ncout, id_varout(2), zdum, jiso-1, npiglo, npjglo, ktime=jt)

              WHERE ( zdum /= zspval .AND. zdum /= 0.)  ; zdum=(dv2dint(:,:,1) - dv2dint(:,:,2))/ zdum
              ELSEWHERE                                 ; zdum=zspval
              ENDWHERE

              ierr = putvar(ncout, id_varout(4), zdum, jiso-1, npiglo, npjglo, ktime=jt)
           ENDIF
           dv2dint(:,:,2) = dv2dint(:,:,1)
           zint   (:,:,2) = zint   (:,:,1)

        END DO
     END DO
     ierr = closeout(ncout)
  END DO  ! loop on scalar files
  PRINT *,' integral between isopycnals completed successfully'

CONTAINS
  SUBROUTINE Weight ( kt) 
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE Weight  ***
    !!
    !! ** Purpose :  Compute weights for vertical interpoaltion
    !!
    !! ** Method  :  linear interpolation
    !!
    !!----------------------------------------------------------------------
    INTEGER(KIND=4), INTENT(in) :: kt
    ! local variables
    INTEGER(KIND=4 )  :: ji,jj,jk, jiso
    INTEGER(KIND=4)   :: ijk
    REAL(KIND=4), DIMENSION(:,:,:), ALLOCATABLE :: z3d
    !!----------------------------------------------------------------------
    ALLOCATE (z3d(npiglo,npjglo,npk) )
    ! in this case, this is to be done once only !
    DO jk=1,npk
       z3d(:,:,jk) = getvar(cf_rho, cn_vosigma0, jk, npiglo, npjglo,ktime=kt)
       IF ( jk == 1 .AND. kt == 1 ) THEN
          tmask=1.
          WHERE (z3d(:,:,jk) == spvalz ) tmask=0.
       ENDIF
    END DO
    !$OMP PARALLEL DO SCHEDULE(RUNTIME)
    DO ji=1,npiglo
       DO jj = 1, npjglo
          ijk = 1
          DO jiso=1,npiso
             !  Assume that rho (z) is increasing downward (no inversion)
             !     Caution with sigma0 at great depth !
             DO WHILE (rho_lev(jiso) >=  z3d(ji,jj,ijk) .AND. ijk <= npk &
                  &                .AND. z3d(ji,jj,ijk) /=  spvalz )
                ijk = ijk+1
             END DO
             ijk = ijk-1
             ik0 = ijk
             IF (ijk == 0) THEN
                ijk = 1
                dalpha(ji,jj,jiso) = 0.d0
             ELSE IF (z3d(ji,jj,ijk+1) == spvalz ) THEN
                ik0 = 0
                dalpha(ji,jj,jiso) = 0.d0
             ELSE 
                ! ... dalpha is always in [0,1] we add ik0
                dalpha(ji,jj,jiso)= (rho_lev(jiso)-z3d(ji,jj,ijk))/(z3d(ji,jj,ijk+1)-z3d(ji,jj,ijk)) +ik0
             ENDIF
          END DO
       END DO
    END DO
    !$OMP END PARALLEL DO
    DEALLOCATE (z3d )

  END SUBROUTINE Weight

  SUBROUTINE CreateOutputVar
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutputVar  ***
    !!
    !! ** Purpose :  Create netcdf output  variables
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    ! define header of all files
    ipk(1)=npiso-1 ; ipk(2)=npiso-1 ; ipk(3)=npiso ; ipk(4)=npiso-1

    DO jvar=1,nvars
       IF ( cv_in == stypzvar(jvar)%cname ) THEN 
          stypvar(1)=stypzvar(jvar)
          EXIT
       ENDIF
    END DO
    ! save original long name for further process
    cldum = TRIM(stypvar(1)%clong_name)
    cluni = TRIM(stypvar(1)%cunits)

    stypvar(1)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(1)%cname             = 'inv'//TRIM(cv_in)
    stypvar(1)%clong_name        = TRIM(cldum)//' integrated on sigma bin'
    stypvar(1)%cshort_name       = stypvar(1)%cname
    stypvar(1)%cunits            = TRIM(cluni)//'.m'
    stypvar(1)%rmissing_value    = zspval
    stypvar(1)%caxis             = 'TRYX'

    stypvar(2)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(2)%cname             = TRIM(cn_isothick)
    stypvar(2)%cunits            = 'm'
    stypvar(2)%rmissing_value    = zspval
    stypvar(2)%valid_min         = 0.
    stypvar(2)%valid_max         = 7000.
    stypvar(2)%clong_name        = 'Thickness_of_Isopycnals'
    stypvar(2)%cshort_name       = TRIM(cn_isothick)
    stypvar(2)%conline_operation = 'N/A'
    stypvar(2)%caxis             = 'TRYX'

    stypvar(3)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(3)%cname             = TRIM(cn_vodepiso)
    stypvar(3)%cunits            = 'm'
    stypvar(3)%rmissing_value    = zspval
    stypvar(3)%valid_min         = 0.
    stypvar(3)%valid_max         = 7000.
    stypvar(3)%clong_name        = 'Depth_of_Isopycnals'
    stypvar(3)%cshort_name       = TRIM(cn_vodepiso)
    stypvar(3)%conline_operation = 'N/A'
    stypvar(3)%caxis             = 'TRYX'

    stypvar(4)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(4)%cname             = 'mean'//TRIM(cv_in)
    stypvar(4)%cunits            = TRIM(cluni)
    stypvar(4)%rmissing_value    = zspval
    stypvar(4)%valid_min         = stypvar(1)%valid_min
    stypvar(4)%valid_max         = stypvar(1)%valid_max
    stypvar(4)%clong_name        = TRIM(cldum)//' mean value in sigma layer'
    stypvar(4)%cshort_name       = stypvar(4)%cname
    stypvar(4)%conline_operation = 'N/A'
    stypvar(4)%caxis             = 'TRYX'

  END SUBROUTINE CreateOutputVar

  SUBROUTINE GetFileList(cd_lst, kfiles)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE GetFileList  ***
    !!
    !! ** Purpose :  Set up a file list given on the command line as 
    !!               blank separated list
    !!
    !! ** Method  :  Scan the command line until a '-' is found
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*), DIMENSION(:), ALLOCATABLE, INTENT(inout) :: cd_lst
    INTEGER(KIND=4),                             INTENT(out)   :: kfiles
    INTEGER (KIND=4)  :: icur 
    !!----------------------------------------------------------------------
    !!
    kfiles=0
    ! need to read a list of file ( number unknow ) 
    ! loop on argument till a '-' is found as first char
    icur=ijarg                          ! save current position of argument number
    DO ji = icur, narg                  ! scan arguments till - found
       CALL getarg ( ji, cldum )
       IF ( cldum(1:1) /= '-' ) THEN ; kfiles = kfiles+1
       ELSE                          ; EXIT
       ENDIF
    ENDDO
    ALLOCATE (cd_lst(kfiles) )
    DO ji = icur, icur + kfiles -1
       CALL getarg(ji, cd_lst( ji -icur +1 ) ) ; ijarg=ijarg+1
    END DO
  END SUBROUTINE GetFileList
  
  SUBROUTINE GetTxtFileList(cd_txt, cd_lst, kfiles)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE GetTxtFileList  ***
    !!
    !! ** Purpose :  Set up a file list read in the input text file
    !!
    !! ** Method  :  read an count the lines of input file
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*),                            INTENT(in   ) :: cd_txt
    CHARACTER(LEN=*), DIMENSION(:), ALLOCATABLE, INTENT(inout) :: cd_lst
    INTEGER(KIND=4),                             INTENT(  out) :: kfiles

    INTEGER(KIND=4)                                            :: jl
    INTEGER(KIND=4)                                            :: inum = 11
    !!----------------------------------------------------------------------
    kfiles=0
    OPEN(inum,file=cd_txt)
    DO 
      READ(inum,*,END=999)
      kfiles=kfiles+1
    ENDDO
999 CONTINUE
    ALLOCATE( cd_lst(kfiles) )
    REWIND(inum)
    DO jl = 1, kfiles
      READ(inum,'(a)') cd_lst(jl)
    ENDDO
    CLOSE(inum)
    
  END SUBROUTINE GetTxtFileList

END  PROGRAM cdfsigintegr

PROGRAM cdfmoy_freq
  !!======================================================================
  !!                     ***  PROGRAM  cdfmoy_freq  ***
  !!=====================================================================
  !!  ** Purpose : Mainly in case of forcing file (gathered as yearly file)
  !!               compute annual mean, monthl mean or diurnal means.
  !!
  !!  ** Method  : Detect the frequency of the input file according to the
  !!               number of fields in the file.
  !!
  !! History : 2.1  : 06/2007  : P. Mathiot   : Original code from cdfmoy
  !!           3.0  : 06/2011  : J.M. Molines : Doctor norm + Lic.
  !!           3.0  : 10/2011  : P. Mathiot   : Add seasonal option and 
  !!                                            allow file with 73 time steps
  !!----------------------------------------------------------------------
  USE cdfio 
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                               :: nt_in, nt_out
  INTEGER(KIND=4)                               :: jk, jvar    ! dummy loop index
  INTEGER(KIND=4)                               :: jv, jtt     ! dummy loop index
  INTEGER(KIND=4)                               :: ierr            ! working integer
  INTEGER(KIND=4)                               :: itime    ! dummy loop index
  INTEGER(KIND=4)                               :: narg, iargc     ! 
  INTEGER(KIND=4)                               :: npiglo, npjglo  ! size of the domain
  INTEGER(KIND=4)                               :: npk ,npt        ! size of the domain
  INTEGER(KIND=4)                               :: nvars           ! Number of variables in a file
  INTEGER(KIND=4)                               :: ntframe         ! Cumul of time frame
  INTEGER(KIND=4)                               :: ncout, ncout2
  INTEGER(KIND=4), DIMENSION(365)               :: njd  ! day vector
  INTEGER(KIND=4), DIMENSION( 12)               :: njm  ! month vector
  INTEGER(KIND=4), DIMENSION(  4)               :: njs  !season vector
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: id_var, ipk, id_varout

  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: v2d, rmean
  REAL(KIND=4), DIMENSION(1)                    :: time
  REAL(KIND=4), DIMENSION(365)                  :: tim

  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: dtab         ! Arrays for cumulated values
  REAL(KIND=8)                                  :: dtotal_time

  CHARACTER(LEN=256)                            :: cf_in               !
  CHARACTER(LEN=256)                            :: cf_out              ! file name
  CHARACTER(LEN=256)                            :: cv_dep
  CHARACTER(LEN=256)                            :: cfreq_out, cfreq_in
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_names            ! array of var nam

  TYPE (variable), DIMENSION(:),    ALLOCATABLE :: stypvar

  LOGICAL                                       :: lcaltmean, lprint
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfmoy_freq IN-file output_frequency'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute annual mean or monthly mean or daily mean from a yearly'
     PRINT *,'       input forcing file given on input.' 
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       IN-file : netcdf input file corresponding to 1 year of forcing variable (1460, 365, 73 or 12 time step) '
     PRINT *,'       output_frequency : either one of monthly, daily, seasonal or annual.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        none.'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file :  cdfmoy_outputFreaquency.nc'
     PRINT *,'         variables :  same as variables in input file.'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'      cdfmoy, cdfmoy_weighted'
     PRINT *,'      '
     STOP
  ENDIF

  !! Initialisation from 1st file (all file are assume to have the same geometry)
  CALL getarg (1, cf_in    )
  CALL getarg (2, cfreq_out)

  IF ( chkfile ( cf_in ) ) STOP ! missing file

  SELECT CASE ( cfreq_out )
  CASE ('daily'   ) ; nt_out = 365
  CASE ('monthly' ) ; nt_out =  12
  CASE ('seasonal') ; nt_out =   4
  CASE ('annual'  ) ; nt_out =   1
  CASE DEFAULT 
     PRINT *, 'Pb : this output_frequency is not allowed, please use daily, monthly, seasonal or annual'
     STOP
  END SELECT

  npiglo= getdim (cf_in, cn_x                             )
  npjglo= getdim (cf_in, cn_y                             )
  npk   = getdim (cf_in, cn_z, cdtrue=cv_dep, kstatus=ierr)

  IF (ierr /= 0 ) THEN
     npk   = getdim (cf_in,'z',cdtrue=cv_dep,kstatus=ierr)
     IF (ierr /= 0 ) THEN
        npk   = getdim (cf_in,'sigma',cdtrue=cv_dep,kstatus=ierr)
        IF ( ierr /= 0 ) THEN 
           PRINT *,' assume file with no depth'
           npk=0
        ENDIF
     ENDIF
  ENDIF

  npt   = getdim (cf_in, cn_t)

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  ALLOCATE( dtab(npiglo,npjglo), v2d(npiglo,npjglo) )
  ALLOCATE( rmean(npiglo,npjglo)                    )

  nvars = getnvar(cf_in)
  PRINT *,' nvars =', nvars

  ALLOCATE (cv_names(nvars)                            )
  ALLOCATE (stypvar(nvars)                             )
  ALLOCATE (id_var(nvars), ipk(nvars), id_varout(nvars))

  ! get list of variable names and collect attributes in stypvar (optional)
  cv_names(:)=getvarname(cf_in, nvars, stypvar)

  id_var(:)  = (/(jv, jv=1,nvars)/)
  ! ipk gives the number of level or 0 if not a T[Z]YX  variable
  ipk(:)     = getipk (cf_in, nvars, cdep=cv_dep)
  !
  WHERE( ipk == 0 ) cv_names='none'
  stypvar(:)%cname = cv_names

  !
  ! create output file taking the sizes in cf_in

  cf_out = 'cdfmoy_'//TRIM(cfreq_out)//'.nc'
  ncout = create      (cf_out, cf_in,   npiglo, npjglo, npk, cdep=cv_dep )
  ierr  = createvar   (ncout,  stypvar, nvars,  ipk,    id_varout )
  ierr  = putheadervar(ncout,  cf_in,   npiglo, npjglo, npk, cdep=cv_dep )

  time=getvar1d(cf_in, cn_vtimec, 1)
  ierr=putvar1d(ncout, time, 1, 'T')

  npt   = getdim (cf_in, cn_t)
  nt_in = npt

  SELECT CASE ( npt )
  CASE ( 1460 ) ; PRINT *, 'Frequency of this file : 6h '
  CASE (  365 ) ; PRINT *, 'Frequency of this file : daily '
  CASE (   73 ) ; PRINT *, 'Frequency of this file : 5 day '
  CASE (   12 ) ; PRINT *, 'Frequency of this file : monthly '
  END SELECT

  IF (npt <= nt_out) THEN
     PRINT *, 'You don''t need to use it, or it is impossible (npt_in <= npt_out)'
     STOP
  END IF

  ! number of day by month, season and day
  njd(:)= 1
  njm= (/ 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 /)
  njs= (/ 90, 91, 92, 92 /)

  DO jvar = 1,nvars
     IF ( cv_names(jvar) == cn_vlon2d .OR.                            &
          cv_names(jvar) == cn_vlat2d .OR. cv_names(jvar) == 'none') THEN
        ! skip these variable
     ELSE
        PRINT *,' Working with ', TRIM(cv_names(jvar))
	DO jk=1,ipk(jvar)

    ! initialisation
           dtab(:,:) = 0.d0 ; dtotal_time = 0.d0;  ntframe=0; itime=1; 

	   ! time loop
           DO jtt=1, nt_in
	      lprint=.FALSE.
              ntframe=ntframe+1
              ! load data
              v2d(:,:)  = getvar(cf_in, cv_names(jvar), jk, npiglo, npjglo, ktime=jtt )
              dtab(:,:) = dtab(:,:) + v2d(:,:)*1.d0

              ! detection of time when you have to print the average
              IF (nt_out==365) THEN
	         IF (MOD(jtt,FLOOR(SUM(njd(1:itime)) * nt_in/365.))==0) lprint=.TRUE.
              ELSE IF (nt_out==12) THEN
	         IF (MOD(jtt,FLOOR(SUM(njm(1:itime)) * nt_in/365.))==0) lprint=.TRUE.
              ELSE IF (nt_out==4) THEN   
	         IF (MOD(jtt,FLOOR(SUM(njs(1:itime)) * nt_in/365.))==0) lprint=.TRUE.
              ELSE IF (nt_out==1) THEN
	         IF (MOD(jtt,                          nt_in      )==0) lprint=.TRUE.
              END IF
              !
              ! Compute and print the average at the right time              
              IF ( lprint ) THEN
                 IF (jk==1) PRINT *, itime, jtt,'/',npt 
                 ! compute mean
                 rmean(:,:) = dtab(:,:)/ntframe
                 ! store variable on outputfile
                 ierr = putvar(ncout, id_varout(jvar) ,rmean, jk, npiglo, npjglo, ktime=itime)
                 dtab(:,:) = 0.d0 ; dtotal_time = 0.;  ntframe=0; itime=itime+1
              END IF
	      !
           ENDDO ! loop to next time

	ENDDO ! loop to next level

     END IF
  END DO ! loop to next var in file

  ierr = closeout(ncout)


END PROGRAM cdfmoy_freq

PROGRAM cdfmxlhcsc
  !!======================================================================
  !!                     ***  PROGRAM  cdfmxlhcsc  ***
  !!=====================================================================
  !!  ** Purpose : Compute mixed layer depth and the heat and salt contents
  !!               in the mixed layer. There is an option to limit this 
  !!               computation between hmin and ml depth. For that, hmin is
  !!               given as last argument (>0) with no arguments, hmin is 
  !!               supposed to be 0.
  !!
  !!  ** Method  : This program is a merge of  cdfmxl, cdfmxlheatc and
  !!               cdfmxlsaltc.
  !!               MXL computation:
  !!                - compute surface properties
  !!                - initialize depths and model levels number
  !!                - from bottom to top compute rho and
  !!                check if rho > rho_surf +rho_c, where rho_c is a 
  !!                density criteria given as argument
  !!               Heat Content and Salt Content:
  !!                 HC = sum ( rho cp T * e1 * e2 * e3 * tmask )
  !!                 SC = sum ( rho    S * e1 * e2 * e3 * tmask )
  !!                 where the sum is limited to the MXL, between hmin and
  !!                 MLD
  !!
  !! History : 2.1  : 04/2007  : M. Juza      : Merging of the programs
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE eos
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                              :: ji, jj, jk, jt  ! dummy loop index
  INTEGER(KIND=4)                              :: ik              ! level indirect index
  INTEGER(KIND=4)                              :: narg, iargc     ! browse line
  INTEGER(KIND=4)                              :: npiglo, npjglo  ! domain size
  INTEGER(KIND=4)                              :: npk, npt        ! domaine size
  INTEGER(KIND=4)                              :: ncout, ierr     ! ncid of output file an error status
  INTEGER(KIND=4), DIMENSION(3)                :: ipk, id_varout  ! levels and varid's of output vars
  INTEGER(KIND=4), DIMENSION(:,:), ALLOCATABLE :: mbathy          ! number of w levels in water <= npk
  INTEGER(KIND=4), DIMENSION(:,:), ALLOCATABLE :: nmln            ! last level where rho > rho + val_crit
                                                                  !              or rtem > rtem + val_crit
  REAL(KIND=4), PARAMETER                      :: rprho0=1020.    ! reference density
  REAL(KIND=4), PARAMETER                      :: rpcp=4000.      ! specific heat of water
  REAL(KIND=4)                                 :: val             ! criteria value
  REAL(KIND=4)                                 :: hmin = 0.       ! minimum depth for vertical integration
  REAL(KIND=4), DIMENSION(1)                   :: rdep            ! dummy depth output
  REAL(KIND=4), DIMENSION(:),      ALLOCATABLE :: tim             ! time counter
  REAL(KIND=4), DIMENSION(:),      ALLOCATABLE :: gdepw           ! depth of w points
  REAL(KIND=4), DIMENSION(:),      ALLOCATABLE :: e31d            ! vertical metrics (full step)
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: rtem            ! temperature
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: rsal            ! salinity
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: rho             ! density (sigma-0)
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: rho_surf        ! surface density
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: tem_surf        ! surface temperature
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: hmld            ! mixed layer depth
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: tmask_surf      ! surface tmask
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: tmask           ! land sea mask of temperature
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: e3              ! vertical metrics

  REAL(KIND=8), DIMENSION(:,:),    ALLOCATABLE :: dmxlheatc       ! mxl heat content
  REAL(KIND=8), DIMENSION(:,:),    ALLOCATABLE :: dmxlsaltc       ! mxl salt content

  TYPE(variable), DIMENSION(3)                 :: stypvar         ! output attributes

  CHARACTER(LEN=256)                           :: cf_tfil         ! input file
  CHARACTER(LEN=256)                           :: cf_out='mxlhcsc.nc' ! output file
  CHARACTER(LEN=256)                           :: criteria        ! type of criteria used for mld
  CHARACTER(LEN=256)                           :: cldum           ! dummy string

  LOGICAL                                      :: lchk          ! flag for missing files
  LOGICAL                                      :: lfull=.FALSE. ! flag for full step
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfmxlhcsc T-file criteria value [hmin]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the mixed layer depth, the heat content and salt content.' 
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       T-file : netcdf input file for temperature and salinity (gridT).' 
     PRINT *,'       criteria : one of temperature, t,  T for temperature criteria.'
     PRINT *,'                  or density, d,  D  for density criteria.'
     PRINT *,'       value  : value of the criteria (eg: 0.2 for temp, 0.01 or 0.03 for dens)'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [ hmin ] : limit the vertical integral from hmin to mld. By default, ' 
     PRINT *,'                  hmin is set to 0 so that the integral is performed on the'
     PRINT *,'                  whole mixed layer.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ',TRIM(cn_fhgr),' ',TRIM(cn_fzgr),' and ',TRIM(cn_fmsk) 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : -  somxl010 (mld based on density criterium 0.01)'
     PRINT *,'          (2D)          or somxl030 (mld on density criterium 0.03)'
     PRINT *,'                        or somxlt02 (mld on temperature criterium -0.2)'
     PRINT *,'                        -  somxlheatc (heat content computed in the MLD)'
     PRINT *,'                        -  somxlsaltc (salt content computed in the MLD)'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'       cdfmxl, cdfmxlheatc and  cdfmxlsaltc.'
     PRINT *,'      '
     STOP
  ENDIF

  CALL getarg (1, cf_tfil  )
  CALL getarg (2, criteria )
  CALL getarg (3, cldum    ) ;  READ(cldum,*) val
  IF ( narg == 4 ) THEN ; CALL getarg (4, cldum) ;  READ(cldum,*) hmin ; ENDIF

  lchk = chkfile (cn_fhgr)
  lchk = chkfile (cn_fzgr) .OR. lchk
  lchk = chkfile (cn_fmsk) .OR. lchk
  lchk = chkfile (cf_tfil) .OR. lchk
  IF ( lchk ) STOP ! missing files

  ! read dimensions 
  npiglo = getdim (cf_tfil, cn_x)
  npjglo = getdim (cf_tfil, cn_y)
  npk    = getdim (cf_tfil, cn_z)
  npt    = getdim (cf_tfil, cn_t)

  rdep(1) = 0.
  ipk(:)  = 1 

  ! Variable Mixed Layer Depth
  SELECT CASE ( criteria)
     !
  CASE ( 'Temperature', 'temperature', 't', 'T' )
     WRITE(cldum,'(a,i2.2)' ) 'somxlt', INT(ABS(val)*10)
     !
  CASE ( 'Density',     'density',     'd', 'D' )
     WRITE(cldum,'(a,i3.3)' ) 'somxl', INT((val)*1000)
     !
  CASE DEFAULT
     PRINT *,TRIM(criteria),' : criteria not understood'
     STOP
  END SELECT

  stypvar(1)%cname       = TRIM(cldum)
  stypvar(1)%cshort_name = TRIM(cldum)
  stypvar(1)%cunits      = 'm'
  stypvar(1)%clong_name  = 'Mixed Layer Depth'

  ! Variable Heat Content
  stypvar(2)%cname       = 'somxlheatc'
  stypvar(2)%cunits      = '10^9 J/m2'
  stypvar(2)%clong_name  = 'Mixed_Layer_Heat_Content'
  stypvar(2)%cshort_name = 'somxlheatc'

  ! Variable Salt Content
  stypvar(3)%cname       = 'somxlsaltc'
  stypvar(3)%cunits      = '10^6 kg/m2'
  stypvar(3)%clong_name  = 'Mixed_Layer_Salt_Content'
  stypvar(3)%cshort_name = 'somxlsaltc'

  ! Allocate arrays
  ALLOCATE (rtem(npiglo,npjglo),rsal(npiglo,npjglo)          )
  ALLOCATE (tmask(npiglo,npjglo),tmask_surf(npiglo,npjglo)   )
  ALLOCATE (mbathy(npiglo,npjglo)                            )
  ALLOCATE (nmln(npiglo,npjglo),hmld(npiglo,npjglo)          )
  ALLOCATE (dmxlheatc(npiglo,npjglo),dmxlsaltc(npiglo,npjglo))
  ALLOCATE (e3(npiglo,npjglo)                                )
  ALLOCATE (gdepw(0:npk), tim(npt)                             )

  ! read mbathy and gdepw use real rtem(:,:) as template (getvar is used for real only)
  INQUIRE (FILE=cn_fbathylev, EXIST=lfull)
  IF ( lfull ) THEN
     rtem(:,:) = getvar(cn_fbathylev, cn_bathylev, 1, npiglo, npjglo)
     ALLOCATE ( e31d(npk) )
  ELSE
     rtem(:,:) = getvar(cn_fzgr,      'mbathy',    1, npiglo, npjglo)
  ENDIF

  mbathy(:,:)  = rtem(:,:)
  gdepw(0)     = 999999.  ! dummy values normaly always masked
  gdepw(1:npk) = getvare3(cn_fzgr, cn_gdepw, npk) 
  IF ( lfull ) e31d = getvare3(cn_fzgr, cn_ve3t, npk )

  ncout = create      (cf_out, cf_tfil, npiglo, npjglo, 1           )
  ierr  = createvar   (ncout,  stypvar, 3,      ipk,    id_varout   )
  ierr  = putheadervar(ncout,  cf_tfil, npiglo, npjglo, 1, pdep=rdep)
  tim   = getvar1d(cf_tfil, cn_vtimec, npt     )
  ierr  = putvar1d(ncout,  tim,       npt, 'T')

  DO jt = 1, npt   ! major time loop
     ! MXL computation
     !---------------
     ! Initialization to the number of w ocean point mbathy
     nmln(:,:) = mbathy(:,:)

     ! read surface tmask
     tmask_surf(:,:) = getvar(cn_fmsk, 'tmask', 1, npiglo, npjglo)

     SELECT CASE ( criteria )
        !
     CASE ( 'temperature', 'Temperature', 'T', 't' ) ! Temperature criteria
        ! temp_surf
        IF (.NOT. ALLOCATED ( tem_surf) ) ALLOCATE (tem_surf(npiglo,npjglo))
        tem_surf(:,:) = getvar(cf_tfil, cn_votemper, 1, npiglo, npjglo, ktime=jt )

        ! Last w-level at which ABS(rtem-tem_surf)>=ABS(val) (starting from jpk-1)
        ! (rtem defined at t-point, thus jk-1 for w-level just above)
        DO jk = npk-1, 2, -1
           rtem(:,:) = getvar(cf_tfil, cn_votemper, jk, npiglo, npjglo, ktime=jt)
           WHERE ( ABS(rtem - tem_surf) > ABS(val) ) nmln = jk
        ENDDO
        !
     CASE ( 'density', 'Density', 'D', 'd' ) ! Density criteria
        ! compute rho_surf
        IF ( .NOT. ALLOCATED( rho_surf ) ) ALLOCATE (rho_surf(npiglo,npjglo) )
        IF ( .NOT. ALLOCATED( rho      ) ) ALLOCATE (rho     (npiglo,npjglo) )
        rtem(:,:) = getvar(cf_tfil, cn_votemper, 1, npiglo, npjglo, ktime=jt)
        rsal(:,:) = getvar(cf_tfil, cn_vosaline, 1, npiglo, npjglo, ktime=jt)
        rho_surf(:,:) = sigma0 (rtem, rsal, npiglo, npjglo )* tmask_surf(:,:)

        ! Last w-level at which rhop>=rho surf+rho_c (starting from jpk-1)
        ! (rhop defined at t-point, thus jk-1 for w-level just above)
        DO jk = npk-1, 2, -1
           rtem( :,:) = getvar(cf_tfil, cn_votemper,  jk ,npiglo, npjglo, ktime=jt)
           rsal( :,:) = getvar(cf_tfil, cn_vosaline,  jk ,npiglo, npjglo, ktime=jt)
           tmask(:,:) = getvar(cn_fmsk, 'tmask',     jk, npiglo, npjglo          )
           rho(  :,:) = sigma0 (rtem, rsal, npiglo, npjglo ) * tmask(:,:)
           WHERE ( rho > rho_surf + val ) nmln = jk
        ENDDO
        !
     CASE DEFAULT
        PRINT *,' ERROR: Criterium on ', TRIM(criteria),' not suported' ; STOP
        !
     END SELECT

     !! Determine mixed layer depth
     DO jj = 1, npjglo
        DO ji = 1, npiglo
           ik = nmln(ji,jj)
           hmld (ji,jj) = gdepw(ik) * tmask_surf(ji,jj)
        ENDDO
     ENDDO

     !!Compute heat and salt contents in the mixed layer depth
     !!-------------------------------------------------------
     !!
     dmxlheatc(:,:) = 0.d0
     dmxlsaltc(:,:) = 0.d0

     DO jk = 1,npk
        ! Get temperature and salinity at jk
        rtem(:,:)  = getvar(cf_tfil,  cn_votemper, jk, npiglo, npjglo, ktime=jt)
        rsal(:,:)  = getvar(cf_tfil,  cn_vosaline, jk, npiglo, npjglo, ktime=jt)
        tmask(:,:) = getvar(cn_fmsk, 'tmask',     jk, npiglo, npjglo          )

        IF ( lfull ) THEN
           e3(:,:) = e31d(jk)
        ELSE
           ! Get e3 at level jk (ps...)
           e3(:,:) = getvar(cn_fzgr, 'e3t_ps', jk ,npiglo, npjglo, ldiom=.TRUE.)
        ENDIF

        ! e3 is used as a flag for the mixed layer; it is 0 outside the mixed layer
        e3(:,:) = MAX(0., MIN(e3, hmld-gdepw(jk) ) + MIN(e3, gdepw(jk)+ e3-hmin) - e3)

        ! Heat and salt contents
        dmxlheatc(:,:) = dmxlheatc(:,:) + rtem * e3 * tmask *1.d0
        dmxlsaltc(:,:) = dmxlsaltc(:,:) + rsal * e3 * tmask *1.d0

     END DO

     !! Heat and salt contents (10^9.J/m2 and 10^6.kg/m2)
     dmxlheatc = dmxlheatc *rprho0 *rpcp * 1.d-9
     dmxlsaltc = dmxlsaltc *rprho0       * 1.d-6

     ierr = putvar(ncout, id_varout(1), hmld,            1, npiglo, npjglo, ktime=jt)
     ierr = putvar(ncout, id_varout(2), REAL(dmxlheatc), 1, npiglo, npjglo, ktime=jt)
     ierr = putvar(ncout, id_varout(3), REAL(dmxlsaltc), 1, npiglo, npjglo, ktime=jt)

  END DO ! time loop

  ierr = closeout(ncout)


END PROGRAM cdfmxlhcsc

MODULE modCdfNames
  !!======================================================================
  !!                     ***  MODULE  modCdfNames  ***
  !! Declare all dimension name, variable name, attribute name as variable
  !! This will ease the generalization of CDFTOOLS
  !!=====================================================================
  !! History : 3.0  !  12/2010 ! J.M. Molines : Original code
  !! Modified: 3.0  !  08/2010 ! P.   Mathiot : Add LIM3 variables
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  PUBLIC
#if defined key_CMIP6
  INCLUDE 'modcdfnames_CMIP6.h90'
#else
  CHARACTER(LEN=256) :: cn_output = 'default'

  ! Dimension name : cn_. [ 1 letter only ]
  CHARACTER(LEN=256) :: cn_x='x'               !: longitude, I dimension
  CHARACTER(LEN=256) :: cn_y='y'               !: latitude,  J dimension
  CHARACTER(LEN=256) :: cn_z='depth'           !: depth, z dimension
  CHARACTER(LEN=256) :: cn_t='time_counter'    !: time dimension

  ! Dimension variable
  CHARACTER(LEN=256) :: cn_vlon2d  = 'nav_lon'      !: longitude
  CHARACTER(LEN=256) :: cn_vlat2d  = 'nav_lat'      !: latitude
  CHARACTER(LEN=256) :: cn_vdeptht = 'deptht'       !: depth
  CHARACTER(LEN=256) :: cn_vdepthu = 'depthu'       !: depth
  CHARACTER(LEN=256) :: cn_vdepthv = 'depthv'       !: depth
  CHARACTER(LEN=256) :: cn_vdepthw = 'depthw'       !: depth
  CHARACTER(LEN=256) :: cn_vtimec  = 'time_counter' !: time 
  CHARACTER(LEN=256) :: cn_vlon1d  = 'lon'          !: longitude 1d
  CHARACTER(LEN=256) :: cn_vlat1d  = 'lat'          !: latitude  1d

  ! Attribute of a variable
  CHARACTER(LEN=256) :: cn_missing_value = '_FillValue' !: missing value (to be replaced bby _Fill_Value)

  ! Metrics
  CHARACTER(LEN=256) :: cn_ve1t='e1t', cn_ve2t='e2t'   !: e.t
  CHARACTER(LEN=256) :: cn_ve1u='e1u', cn_ve2u='e2u'   !: e.u
  CHARACTER(LEN=256) :: cn_ve1v='e1v', cn_ve2v='e2v'   !: e.v
  CHARACTER(LEN=256) :: cn_ve1f='e1f', cn_ve2f='e2f'   !: e.v
  CHARACTER(LEN=256) :: cn_ve3t1d='e3t'                !: e3 1d
  CHARACTER(LEN=255) :: cn_ve3w1d='e3w'                !: e3. (1D). 
  CHARACTER(LEN=256) :: cn_ve3t='e3t', cn_ve3w='e3w'   !: e3. (3D). 
  CHARACTER(LEN=256) :: cn_ve3u='e3u', cn_ve3v='e3v'   !: e3.
  ! VVL case
  CHARACTER(LEN=256) :: cn_ve3tvvl='e3t', cn_ve3wvvl='e3w'   !: e3. (3D). 
  CHARACTER(LEN=256) :: cn_ve3uvvl='e3u', cn_ve3vvvl='e3v'   !: e3.
  CHARACTER(LEN=256) :: cn_ve3t0='e3t_0', cn_ve3w0='e3w_0'   !: e3. (3D). (at rest)
  CHARACTER(LEN=256) :: cn_ve3u0='e3u_0', cn_ve3v0='e3v_0'   !: e3.

  CHARACTER(LEN=256) :: cn_vff='ff'

  CHARACTER(LEN=256) :: cn_gdept='gdept', cn_gdepw='gdepw'   !: 1d dep variable
  CHARACTER(LEN=256) :: cn_hdept='hdept', cn_hdepw='hdepw'   !: 2d dep variable

  CHARACTER(LEN=256) :: cn_dept3d='gdept_0'                  !: initial dept 3D
  CHARACTER(LEN=256) :: cn_depu3d='depu3d', cn_depw3d='depw3d' !: Local depth U and W in broken line extraction

  CHARACTER(LEN=256) :: cn_glamt='glamt', cn_gphit='gphit'   !:  glam gphi
  CHARACTER(LEN=256) :: cn_glamu='glamu', cn_gphiu='gphiu'   !:  glam gphi
  CHARACTER(LEN=256) :: cn_glamv='glamv', cn_gphiv='gphiv'   !:  glam gphi
  CHARACTER(LEN=256) :: cn_glamf='glamf', cn_gphif='gphif'   !:  glam gphi

  ! Mask variables
  CHARACTER(LEN=256) :: cn_tmask='tmask', cn_umask='umask'   !:  tmask, umask
  CHARACTER(LEN=256) :: cn_vmask='vmask', cn_fmask='fmask'   !:  vmask, fmask
  CHARACTER(LEN=256) :: cn_tmaskutil='tmaskutil'             !:  tmaskutil
  CHARACTER(LEN=256) :: cn_polymask='polymask'               !:  polymask
  CHARACTER(LEN=256) :: cn_tmaskatl='tmaskatl'               !:  atlantic mask in cn_fbasins
  CHARACTER(LEN=256) :: cn_tmaskpac='tmaskpac'               !:  pacific mask in cn_fbasins
  CHARACTER(LEN=256) :: cn_tmaskind='tmaskind'               !:  indian mask in cn_fbasins
  CHARACTER(LEN=256) :: cn_tmaskant='tmaskant'               !:  austral mask in cn_fbasins
  CHARACTER(LEN=256) :: cn_tmaskmed='tmaskmed'               !:  mediterranean mask in cn_fbasins
 

  ! Generic mesh-mask file names  cn_f...
  CHARACTER(LEN=256) :: cn_fzgr='mesh_zgr.nc'
  CHARACTER(LEN=256) :: cn_fe3t='mesh_zgr.nc'
  CHARACTER(LEN=256) :: cn_fe3u='mesh_zgr.nc'
  CHARACTER(LEN=256) :: cn_fe3v='mesh_zgr.nc'
  CHARACTER(LEN=256) :: cn_fe3w='mesh_zgr.nc'
  CHARACTER(LEN=256) :: cn_fhgr='mesh_hgr.nc'
  CHARACTER(LEN=256) :: cn_fmsk='mask.nc'
  CHARACTER(LEN=256) :: cn_fcoo='coordinates.nc'
  CHARACTER(LEN=256) :: cn_fbasins='new_maskglo.nc'

  ! Variable name  : cn_v... [ starts with cn_v ]
  CHARACTER(LEN=256) :: cn_votemper='votemper' !: temperature
  CHARACTER(LEN=256) :: cn_vosaline='vosaline' !: salinity
  CHARACTER(LEN=256) :: cn_vozocrtx='vozocrtx' !: zonal velocity
  CHARACTER(LEN=256) :: cn_vomecrty='vomecrty' !: meridional velocity
  CHARACTER(LEN=256) :: cn_vomeeivv='vomeeivv' !: meridional Eddy Induced Velocity
  CHARACTER(LEN=256) :: cn_vovecrtz='vovecrtz' !: vertical velocity
  CHARACTER(LEN=256) :: cn_sossheig='sossheig' !: Sea Surface Height
  CHARACTER(LEN=256) :: cn_somxl010='somxl010' !: Mixed layer depth (density criterion)
  CHARACTER(LEN=256) :: cn_somxlt02='somxlt02' !: Mixed layer depth (temperature criterion)
  CHARACTER(LEN=256) :: cn_sozotaux='sozotaux' !: Zonal wind stress

  CHARACTER(LEN=256) :: cn_sohefldo='sohefldo' !: Total Heat FLux
  CHARACTER(LEN=256) :: cn_solhflup='solhflup' !: Latent Heat FLux 
  CHARACTER(LEN=256) :: cn_sosbhfup='sosbhfup' !: Sensible heat Flux
  CHARACTER(LEN=256) :: cn_solwfldo='solwfldo' !: Long Wave downward Heat Flux
  CHARACTER(LEN=256) :: cn_soshfldo='soshfldo' !: Solar Heat FLux

  CHARACTER(LEN=256) :: cn_sowaflup='sowaflup' !: Fresh Water Flux
  CHARACTER(LEN=256) :: cn_sowaflcd='sowaflcd' !: Concentration Dilution water flux
  CHARACTER(LEN=256) :: cn_sowafldp='sowafldp' !: SSS damping water Flux
  CHARACTER(LEN=256) :: cn_sorunoff='sorunoff' !: River Run-off
  CHARACTER(LEN=256) :: cn_iowaflup='iowaflup' !: Ice Ocean Water flux ( + = freezing, - = melting)
  CHARACTER(LEN=256) :: cn_soicecov='soicecov' !: Ice cover

  CHARACTER(LEN=256) :: cn_iicbmass='berg_mass'!: Mass of Icebergs (kg/m2)
  CHARACTER(LEN=256) :: cn_iicbmelt='berg_melt'!: Melting rate of icebergs (kg/m2/s)

  ! MOC variables
  CHARACTER(LEN=256) :: cn_zomsfatl='zomsfatl' !: moc in the Atlantic
  CHARACTER(LEN=256) :: cn_zomsfglo='zomsfglo' !: moc in the Global ocean
  CHARACTER(LEN=256) :: cn_zomsfpac='zomsfpac' !: moc in the Pacific
  CHARACTER(LEN=256) :: cn_zomsfinp='zomsfinp' !: moc in the Indo-Pacific
  CHARACTER(LEN=256) :: cn_zomsfind='zomsfind' !: moc in the Indian ocean
  CHARACTER(LEN=256) :: cn_zomsfinp0='zomsfinp0' !: moc in the Indo-Pacific Net
  !
  CHARACTER(LEN=256) :: cn_zoisoatl='zoisoatl' !: moc in the Atlantic
  CHARACTER(LEN=256) :: cn_zoisoglo='zoisoglo' !: moc in the Global ocean
  CHARACTER(LEN=256) :: cn_zoisopac='zoisopac' !: moc in the Pacific
  CHARACTER(LEN=256) :: cn_zoisoinp='zoisoinp' !: moc in the Indo-Pacific
  CHARACTER(LEN=256) :: cn_zoisoind='zoisoind' !: moc in the Indian ocean
  CHARACTER(LEN=256) :: cn_zoisoinp0='zoisoinp0' !: moc in the Indo-Pacific Net
  
  ! transport variables
  CHARACTER(LEN=256) :: cn_vozout='vozout'     !: product U x T at U point
  CHARACTER(LEN=256) :: cn_vomevt='vomevt'     !: product V x T at V point
  CHARACTER(LEN=256) :: cn_vozous='vozous'     !: product U x S at U point
  CHARACTER(LEN=256) :: cn_vomevs='vomevs'     !: product V x S at V point
  CHARACTER(LEN=256) :: cn_sozout='sozout'     !: product U x T at U point
  CHARACTER(LEN=256) :: cn_somevt='somevt'     !: product V x T at V point
  CHARACTER(LEN=256) :: cn_sozous='sozous'     !: product U x S at U point
  CHARACTER(LEN=256) :: cn_somevs='somevs'     !: product V x S at V point
  CHARACTER(LEN=256) :: cn_sozoutrp='sozoutrp' !: vertically integrated trp at U point
  CHARACTER(LEN=256) :: cn_somevtrp='somevtrp' !: vertically integrated trp at V point
  CHARACTER(LEN=256) :: cn_vouv='vouv'         !: product U x V at T point

  ! density, isopycnal diagnostics
  CHARACTER(LEN=256) :: cn_vosigma0='vosigma0' !: potential density refered to surface
  CHARACTER(LEN=256) :: cn_vosigmai='vosigmai' !: potential density refered to a partiular depth
  CHARACTER(LEN=256) :: cn_vosigntr='vosigntr' !: neutral density
  CHARACTER(LEN=256) :: cn_vodepiso='vodepiso' !: depth of isopycnal
  CHARACTER(LEN=256) :: cn_isothick='isothick' !: isopycnal tickness (from cdfsigintegr)

  ! Passive tracer variable
  CHARACTER(LEN=256) :: cn_invcfc='INVCFC'     !: CFC inventory
  CHARACTER(LEN=256) :: cn_cfc11='CFC11'       !: CFC concentration
  CHARACTER(LEN=256) :: cn_pendep='pendep'     !: CFC penetration depth (from cdfpendep)
  
  ! ice variable names
  CHARACTER(LEN=256) :: cn_iicethic='iicethic' !: ice thickness
  CHARACTER(LEN=256) :: cn_ileadfra='ileadfra' !: ice concentration
  CHARACTER(LEN=256) :: cn_iicevelu='iicevelu' !: ice velocity U
  CHARACTER(LEN=256) :: cn_iicevelv='iicevelv' !: ice velocity V
  CHARACTER(LEN=256) :: cn_iicethic3='sivolu'  !: ice thickness (LIM3)
  CHARACTER(LEN=256) :: cn_ileadfra3='siconc'  !: ice concentration (LIM3)
  CHARACTER(LEN=256) :: cn_iicevelu3='sivelu' !: ice velocity U (LIM3)
  CHARACTER(LEN=256) :: cn_iicevelv3='sivelv' !: ice velocity V (LIM3)
  
  ! Bathymetry
  CHARACTER(LEN=256) :: cn_fbathymet='bathy_meter.nc' !: file Bathymetry in meters
  CHARACTER(LEN=256) :: cn_fbathylev='bathy_level.nc' !: file Bathymetry in levels

  CHARACTER(LEN=256) :: cn_bathymet='Bathymetry' !: variable Bathymetry in meters
  CHARACTER(LEN=256) :: cn_bathylev='bathy_level'!: variable Bathymetry in levels
  CHARACTER(LEN=256) :: cn_mbathy  ='mbathy'     !: variable mbathy in levels

  ! variables to be squared when performing cdfmoy
  INTEGER(KIND=4), PARAMETER :: jp_sqdvarmax=10
  INTEGER(KIND=4) :: nn_sqdvar = 4
  INTEGER(KIND=4), PRIVATE :: ji
  CHARACTER(LEN=15), DIMENSION(jp_sqdvarmax) :: cn_sqdvar = &
      & (/'vozocrtx','vomecrty','vovecrtz','sossheig',('        ', ji=jp_sqdvarmax-5,jp_sqdvarmax) /)

  ! variables eligible for 3rd moment computation when performing cdfmoy
  INTEGER(KIND=4), PARAMETER :: jp_cubvarmax=10
  INTEGER(KIND=4) :: nn_cubvar = 2
  CHARACTER(LEN=15), DIMENSION(jp_cubvarmax) :: cn_cubvar = &
      & (/'sossheig','votemper',('        ', ji=3,jp_cubvarmax) /)

#endif

! INTERFACE  
!    SUBROUTINE fdate( cldate)
!    CHARACTER(LEN=24) :: cldate
!    END SUBROUTINE fdate
! END INTERFACE

  PUBLIC :: ReadCdfNames
  PUBLIC :: PrintCdfNames

  !! NAMELIST STATEMENTS
    ! dimensions
    NAMELIST/namdim/ cn_x, cn_y, cn_z, cn_t                        ! dimensions

    ! dimension variables
    NAMELIST/namdimvar/ cn_vlon2d, cn_vlat2d
    NAMELIST/namdimvar/ cn_vdeptht, cn_vdepthu, cn_vdepthv, cn_vdepthw
    NAMELIST/namdimvar/ cn_vtimec
   
    ! attributes
    NAMELIST/namdimvar/ cn_missing_value

    ! metrics in coordinates, mesh_hgr
    NAMELIST/nammetrics/ cn_ve1t, cn_ve1u, cn_ve1v, cn_ve1f
    NAMELIST/nammetrics/ cn_ve2t, cn_ve2u, cn_ve2v, cn_ve2f
    NAMELIST/nammetrics/ cn_ve3t1d, cn_ve3w1d
    NAMELIST/nammetrics/ cn_ve3t, cn_ve3w, cn_ve3u, cn_ve3v
    NAMELIST/nammetrics/ cn_ve3tvvl, cn_ve3wvvl, cn_ve3uvvl, cn_ve3vvvl
    NAMELIST/nammetrics/ cn_vff
    NAMELIST/nammetrics/ cn_glamt, cn_glamu, cn_glamv, cn_glamf
    NAMELIST/nammetrics/ cn_gphit, cn_gphiu, cn_gphiv, cn_gphif
    !        mesh_zgr
    NAMELIST/nammetrics/ cn_gdept, cn_gdepw
    NAMELIST/nammetrics/ cn_hdept, cn_hdepw
    !
    NAMELIST/nambroken/ cn_dept3d, cn_depu3d, cn_depw3d

    ! variables 
    NAMELIST/namvars/ cn_votemper, cn_vosaline
    NAMELIST/namvars/ cn_vozocrtx, cn_vomecrty, cn_vomeeivv, cn_vovecrtz
    NAMELIST/namvars/ cn_sossheig, cn_somxl010, cn_somxlt02
    NAMELIST/namvars/ cn_sohefldo, cn_solhflup, cn_sosbhfup
    NAMELIST/namvars/ cn_solwfldo, cn_soshfldo
    NAMELIST/namvars/ cn_sowaflup, cn_sowaflcd, cn_sowafldp, cn_iowaflup
    NAMELIST/namvars/ cn_zomsfatl, cn_zomsfglo, cn_zomsfpac, cn_zomsfinp, cn_zomsfind
    NAMELIST/namvars/ cn_zoisoatl, cn_zoisoglo, cn_zoisopac, cn_zoisoinp, cn_zoisoind
    NAMELIST/namvars/ cn_vozout, cn_vomevt, cn_vozous, cn_vomevs
    NAMELIST/namvars/ cn_sozout, cn_somevt, cn_sozous, cn_somevs
    NAMELIST/namvars/ cn_sozoutrp, cn_somevtrp
    NAMELIST/namvars/ cn_soicecov
    NAMELIST/namvars/ cn_vosigma0, cn_vosigmai, cn_vosigntr, cn_vodepiso, cn_isothick
    NAMELIST/namvars/ cn_iicethic, cn_ileadfra, cn_iicevelu, cn_iicevelv
    NAMELIST/namvars/ cn_invcfc,   cn_cfc11,    cn_pendep

    ! list of variable to be squared by cdfmoy
    NAMELIST/namsqdvar/ nn_sqdvar, cn_sqdvar

    ! list of variable to be cubed by cdfmoy ( option )
    NAMELIST/namcubvar/ nn_cubvar, cn_cubvar

    ! name of mesh_mask files
    NAMELIST/nammeshmask/ cn_fzgr, cn_fe3t, cn_fe3u, cn_fe3v, cn_fe3w, cn_fhgr, cn_fmsk, cn_fcoo, cn_fbasins
    ! mask variables
    NAMELIST/nammask/ cn_tmask, cn_umask, cn_vmask, cn_fmask, cn_polymask, cn_tmaskutil
    NAMELIST/nammask/ cn_tmaskatl, cn_tmaskpac, cn_tmaskind, cn_tmaskant, cn_tmaskmed

    ! Bathymetry
    NAMELIST/nambathy/ cn_fbathymet, cn_fbathylev, cn_bathymet, cn_bathylev, cn_mbathy
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class system
  !!----------------------------------------------------------------------

CONTAINS

  SUBROUTINE ReadCdfNames ()
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE ReadCdfNames  ***
    !!
    !! ** Purpose :  update the standard NetCdfName using a dedicated
    !!               namelist ( nam_cdf_names ) 
    !!
    !! ** Method  :  Look for this namelist in the following order :
    !!               1. current dir
    !!               2. HOME/CDTOOLS_cfg directory
    !!
    !!                 nam_cdf_nam can be adjusted with environment
    !!               variable NAM_CDF_NAMES
    !!
    !!----------------------------------------------------------------------
    CHARACTER(LEN=90)  :: cl_namlist= 'nam_cdf_names'
    CHARACTER(LEN=256) :: cl_env    = 'NAM_CDF_NAMES'
    CHARACTER(LEN=90)  :: cldum, cl_home
    LOGICAL            :: ll_exist
    INTEGER(KIND=4)    :: inam = 10
    !!----------------------------------------------------------------------
    CALL getenv ('HOME', cl_home) 

    ! Look for cdf namelist name
    CALL getenv (cl_env, cldum )

    IF ( cldum /= ' ' ) cl_namlist = cldum 

    ! Now look for existence of the namelist
    INQUIRE( FILE=cl_namlist, EXIST=ll_exist )

    IF ( .NOT. ll_exist ) THEN
       cldum=TRIM(cl_home)//'/CDFTOOLS_cfg/'//TRIM(cl_namlist)
       cl_namlist=cldum
       INQUIRE( FILE=cl_namlist, EXIST= ll_exist )
       IF ( .NOT. ll_exist ) THEN
          CALL chkenv
          RETURN    ! assuming that there is no need to read 
                    ! a namelist for cdf names
       ENDIF
    ENDIF

    PRINT *, ' CAUTION : dim names and variable names are now set according to '
    PRINT *, ' =======   the following namelist : ', TRIM(cl_namlist) 

    OPEN(inam, FILE=cl_namlist, RECL=200)
    REWIND(inam)

    READ(inam, namdim     )
    READ(inam, namdimvar  )
    READ(inam, nammetrics )
    READ(inam, namvars    )
    READ(inam, nambathy   )
    READ(inam, namsqdvar  )
    READ(inam, nammeshmask  )
    CLOSE ( inam ) 
    CALL chkenv

  END SUBROUTINE ReadCdfNames

  SUBROUTINE PrintCdfNames()
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE PrintCdfNames  ***
    !!
    !! ** Purpose :  Print a namelist like file from the actual netcdf names 
    !!
    !! ** Method  :  Use namelist facilities 
    !!
    !!----------------------------------------------------------------------
    CHARACTER(LEN=80) :: cl_filout='PrintCdfNames.namlist'
    CHARACTER(LEN=24) :: cl_date
    INTEGER(KIND=4)   :: iout=3
    !!----------------------------------------------------------------------
    CALL fdate(cl_date)
!   cl_date=fdate()
    OPEN(iout, FILE=cl_filout, RECL=200)
    WRITE(iout, '(a,a)' ) ' ! ', cl_date
    WRITE(iout, '(a)' ) ' ! Namelist automatically generated by PrintCdfNames '
    WRITE(iout, '(a)' ) ' ! Do not edit without changing its name ... '
    WRITE(iout, '(a)' ) ' ! ------------------------------------------'
    WRITE(iout, namdim     )
    WRITE(iout, namdimvar  )
    WRITE(iout, nammetrics )
    WRITE(iout, namvars    )
    WRITE(iout, nambathy   )
    WRITE(iout,'(a)' ) ' ! Namelist entry namsqdvar needs manual formating before'
    WRITE(iout,'(a)' ) ' ! it can be used as input : put variables names in between '' '
    WRITE(iout,'(a)' ) ' ! and separate variables by , '
    WRITE(iout, namsqdvar  )
    WRITE(iout, nammeshmask  )
    CLOSE (iout)

  END SUBROUTINE PrintCdfNames

  SUBROUTINE chkenv
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE chkenv  ***
    !!
    !! ** Purpose :  Check CDFT_xxx environment variables for the name of
    !!               mesh, mask files 
    !!
    !! ** Method  :  Use getenv function 
    !!
    !!----------------------------------------------------------------------
    CHARACTER(LEN=255) :: cldum
    !!----------------------------------------------------------------------

    ! provide facilities for environment mariables fixing basic filename
    CALL getenv('CDFT_MESH_HGR',cldum ) ; IF ( cldum /= '' ) cn_fhgr    = cldum
    CALL getenv('CDFT_MESH_ZGR',cldum ) ; IF ( cldum /= '' ) cn_fzgr    = cldum
    CALL getenv('CDFT_MASK'    ,cldum ) ; IF ( cldum /= '' ) cn_fmsk    = cldum
    CALL getenv('CDFT_BASINS'  ,cldum ) ; IF ( cldum /= '' ) cn_fbasins = cldum
    CALL getenv('CDFT_COORD'   ,cldum ) ; IF ( cldum /= '' ) cn_fcoo    = cldum
    ! propagates cn_fzgr to e3 metrics (default)
    cn_fe3t = cn_fzgr
    cn_fe3u = cn_fzgr
    cn_fe3v = cn_fzgr
    cn_fe3w = cn_fzgr

    ! .. can be extended
  END SUBROUTINE chkenv



END MODULE modCdfNames

PROGRAM cdfmean
  !!======================================================================
  !!                     ***  PROGRAM  cdfmean  ***
  !!=====================================================================
  !!  ** Purpose : Compute the Mean Value over the ocean or part of the
  !!               ocean (spatial mean).
  !!
  !!  ** Method  : mean= sum( V * e1 *e2 * e3 *mask )/ sum( e1 * e2 * e3 *mask ))
  !!               Partial cell version
  !!
  !! History : 2.1  : 10/2005  : J.M. Molines : Original code
  !!         : 2.1  : 07/2009  : R. Dussin    : Netcdf output
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                            :: jk, jt, jvar       ! dummy loop index
  INTEGER(KIND=4)                            :: ik, ii, ivar       !
  INTEGER(KIND=4)                            :: iimin=0, iimax=0   ! domain limitation for computation
  INTEGER(KIND=4)                            :: ijmin=0, ijmax=0   ! domain limitation for computation
  INTEGER(KIND=4)                            :: ikmin=0, ikmax=0   ! domain limitation for computation
  INTEGER(KIND=4)                            :: narg, iargc, ijarg ! command line 
  INTEGER(KIND=4)                            :: npiglo, npjglo     ! size of the domain
  INTEGER(KIND=4)                            :: npiglo_fi          ! size of the domain from input file
  INTEGER(KIND=4)                            :: npjglo_fi          ! size of the domain from input file
  INTEGER(KIND=4)                            :: npk_fi             ! size of the domain from input file
  INTEGER(KIND=4)                            :: npk, npt           ! size of the domain
  INTEGER(KIND=4)                            :: nvpk               ! vertical levels in working variable
  INTEGER(KIND=4)                            :: numout=10          ! logical unit for mean output file
  INTEGER(KIND=4)                            :: numvar=11          ! logical unit for variance output file
  INTEGER(KIND=4)                            :: ikx=1, iky=1       ! dims of netcdf output file
  INTEGER(KIND=4)                            :: nvars              ! number of values to write in cdf output
  INTEGER(KIND=4)                            :: ncout, ierr        ! for netcdf output
  INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE :: ipk, id_varout

  REAL(KIND=4)                               :: zspval             ! missing value
  REAL(KIND=4), DIMENSION(1,1)               :: rdummy             ! dummy variable
  REAL(KIND=4), DIMENSION(:,:),  ALLOCATABLE :: e1, e2, e3, zv     ! metrics, velocity
  REAL(KIND=4), DIMENSION(:,:),  ALLOCATABLE :: zmask              ! npiglo x npjglo
  REAL(KIND=4), DIMENSION(:,:),  ALLOCATABLE :: rdumlon, rdumlat   ! dummy lon/lat for output file
  REAL(KIND=4), DIMENSION(:,:),  ALLOCATABLE :: rdummymean         ! array for mean value on output file
  REAL(KIND=4), DIMENSION(:),    ALLOCATABLE :: gdep               ! depth 
  REAL(KIND=4), DIMENSION(:),    ALLOCATABLE :: zdep               ! depth of the whole vertical levels
  REAL(KIND=4), DIMENSION(:),    ALLOCATABLE :: e31d               ! 1d vertical spacing
  REAL(KIND=4), DIMENSION(:),    ALLOCATABLE :: tim                ! time counter

  REAL(KIND=8)                               :: dvol, dsum, dsurf  ! cumulated values
  REAL(KIND=8)                               :: dvol2d, dsum2d     !
  REAL(KIND=8)                               :: dvar2d, dvar       ! for variance computing
  REAL(KIND=8), DIMENSION(:),    ALLOCATABLE :: dvmeanout          ! spatial mean
  REAL(KIND=8), DIMENSION(:),    ALLOCATABLE :: dvariance           ! spatial variance
  REAL(KIND=8), DIMENSION(:),    ALLOCATABLE :: dvmeanout3d         ! global 3D mean value
  REAL(KIND=8), DIMENSION(:),    ALLOCATABLE :: dvariance3d         ! global 3D mean variance

  CHARACTER(LEN=256)                         :: cv_nam             ! current variable name
  CHARACTER(LEN=256)                         :: cv_dep             ! deptht name
  CHARACTER(LEN=20)                          :: cv_e1, cv_e2       ! horizontal metrics names
  CHARACTER(LEN=20)                          :: cv_e3, cv_e31d     ! vertical metrics names
  CHARACTER(LEN=20)                          :: cv_msk             ! mask variable name
  CHARACTER(LEN=256)                         :: cf_in              ! input file name
  CHARACTER(LEN=256)                         :: cf_out   = 'cdfmean.txt' ! ASCII output file for mean
  CHARACTER(LEN=256)                         :: cf_var   = 'cdfvar.txt'  ! ASCII output file for variance
  CHARACTER(LEN=256)                         :: cf_ncout = 'cdfmean.nc'  ! NCDF output file
  CHARACTER(LEN=256)                         :: cf_zerom = 'zeromean.nc' ! NCDF output file with zeromean field
  CHARACTER(LEN=256)                         :: ctype              ! type of C-grid point to work with
  CHARACTER(LEN=256)                         :: clunits            ! attribute of output file : units
  CHARACTER(LEN=256)                         :: cllong_name        !     "      long name
  CHARACTER(LEN=256)                         :: clshort_name       !     "      short name
  CHARACTER(LEN=256)                         :: cglobal            !     "      global 
  CHARACTER(LEN=256)                         :: cldum              ! dummy char variable
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_names        ! list of file names

  TYPE(variable), DIMENSION(:),  ALLOCATABLE :: stypvar            ! structure of output
  TYPE(variable), DIMENSION(:),  ALLOCATABLE :: stypvarin          ! structure of input data
  TYPE(variable), DIMENSION(:),  ALLOCATABLE :: stypvarzero        ! structure of zeromean output

  LOGICAL                                    :: lfull     = .false.! full step  flag
  LOGICAL                                    :: lvar      = .false.! variance  flag
  LOGICAL                                    :: lzeromean = .false.! zero mean  flag
  LOGICAL                                    :: lnodep    = .false.! no depth flag
  LOGICAL                                    :: lchk               ! flag for missing files
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfmean  IN-file IN-var T|U|V|F|W [imin imax jmin jmax kmin kmax]'
     PRINT *,'       ... [-full] [-var] [-zeromean] '
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'        Computes the mean value of the field (3D, weighted). For 3D fields,'
     PRINT *,'        a horizontal mean for each level is also given. If a spatial window'
     PRINT *,'        is specified, the mean value is computed only in this window.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       IN-file : input netcdf file.'
     PRINT *,'       IN-var  : name of netcdf variable to work with.'
     PRINT *,'       T|U|V|F|W : position of cdfvar on the C-grid' 
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [imin imax jmin jmax kmin kmax] : spatial windows where mean value '
     PRINT *,'                  is computed:' 
     PRINT *,'                  if imin = 0 then ALL i are taken'
     PRINT *,'                  if jmin = 0 then ALL j are taken'
     PRINT *,'                  if kmin = 0 then ALL k are taken'
     PRINT *,'       [ -full ] : compute the mean for full steps, instead of default '
     PRINT *,'                   partial steps.'
     PRINT *,'       [ -var ]  : also compute the spatial variance of cdfvar '
     PRINT *,'       [ -zeromean ] : create a file with cdfvar having a zero spatial mean.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       Files ', TRIM(cn_fhgr),', ', TRIM(cn_fzgr),', ', TRIM(cn_fmsk)
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       - netcdf file : ', TRIM(cf_ncout)
     PRINT *,'           variables : mean_cdfvar, mean_3D_cdfvar '
     PRINT *,'                    [var_cdfvar, var_3D_cdfvar, in case of -var]'
     PRINT *,'       - netcdf file : ', TRIM(cf_zerom),' [ in case of -zeromean option]'
     PRINT *,'           variables : cdfvar'
     PRINT *,'       - ASCII files : ', TRIM(cf_out) 
     PRINT *,'                       [ ',TRIM(cf_var),', in case of -var ]'
     PRINT *,'       - all output on ASCII files are also sent to standard output.'
     STOP
  ENDIF

  ! Open standard output with recl=256 to avoid wrapping of long lines (ifort)
  OPEN(6,FORM='FORMATTED',RECL=256)  ! ifort
  !  OPEN(6,FORM='FORMATTED')          ! gfortran

  cglobal = 'Partial step computation'
  ijarg = 1 ; ii = 0
  DO WHILE ( ijarg <= narg )
     CALL getarg(ijarg, cldum ) ; ijarg = ijarg + 1 
     SELECT CASE (cldum) 
     CASE ('-full' )
        lfull = .true. 
        cglobal = 'full step computation'
     CASE ('-var' )
        lvar = .true. 
     CASE ('-zeromean' )
        lzeromean = .true. 
     CASE DEFAULT 
        ii=ii+1
        SELECT CASE (ii) 
        CASE ( 1 ) ; cf_in  = cldum 
        CASE ( 2 ) ; cv_nam = cldum 
        CASE ( 3 ) ; ctype  = cldum 
        CASE ( 4 ) ; READ(cldum,*) iimin
        CASE ( 5 ) ; READ(cldum,*) iimax
        CASE ( 6 ) ; READ(cldum,*) ijmin
        CASE ( 7 ) ; READ(cldum,*) ijmax
        CASE ( 8 ) ; READ(cldum,*) ikmin
        CASE ( 9 ) ; READ(cldum,*) ikmax
        CASE DEFAULT 
          PRINT *, '  ERROR : Too many arguments ...'
          STOP
        END SELECT
     END SELECT
  END DO

  lchk = chkfile(cn_fhgr)
  lchk = chkfile(cn_fzgr) .OR. lchk
  lchk = chkfile(cn_fmsk) .OR. lchk
  lchk = chkfile(cf_in  ) .OR. lchk
  IF ( lchk ) STOP ! missing file

  cv_dep   = 'none'
  npiglo = getdim (cf_in, cn_x)
  npjglo = getdim (cf_in, cn_y)
  npk    = getdim (cf_in, cn_z, cdtrue=cv_dep, kstatus=ierr)

  IF (ierr /= 0 ) THEN
     npk   = getdim (cf_in, 'z', cdtrue=cv_dep, kstatus=ierr)
     IF (ierr /= 0 ) THEN
        npk   = getdim (cf_in, 'sigma', cdtrue=cv_dep, kstatus=ierr)
        IF ( ierr /= 0 ) THEN
           npk = getdim (cf_in, 'nav_lev', cdtrue=cv_dep, kstatus=ierr)
           IF ( ierr /= 0 ) THEN
              PRINT *,' assume file with no depth'
              npk=0
           ENDIF
        ENDIF
     ENDIF
  ENDIF

  npt   = getdim (cf_in, cn_t)
  nvpk  = getvdim(cf_in, cv_nam)
  ! save original npiglo, npiglo
  npiglo_fi = npiglo
  npjglo_fi = npjglo
  npk_fi    = npk

  IF (npk   == 0 ) THEN ; lnodep = .true.;  npk = 1                  ;  ENDIF ! no depth dimension ==> 1 level
  IF (iimin /= 0 ) THEN ; npiglo = iimax -iimin + 1;  ELSE ; iimin=1 ;  ENDIF
  IF (ijmin /= 0 ) THEN ; npjglo = ijmax -ijmin + 1;  ELSE ; ijmin=1 ;  ENDIF
  IF (ikmin /= 0 ) THEN ; npk    = ikmax -ikmin + 1;  ELSE ; ikmin=1 ;  ENDIF

  IF (nvpk == 2 ) nvpk = 1
  IF (nvpk == 3 ) nvpk = npk

  WRITE(6, *) 'npiglo = ', npiglo
  WRITE(6, *) 'npjglo = ', npjglo
  WRITE(6, *) 'npk    = ', npk
  WRITE(6, *) 'npt    = ', npt
  WRITE(6, *) 'nvpk   = ', nvpk
  WRITE(6, *) 'depth dim name is ', TRIM(cv_dep)

  ! Allocate arrays
  ALLOCATE ( zmask(npiglo,npjglo) )
  ALLOCATE ( zv   (npiglo,npjglo) )
  ALLOCATE ( e1   (npiglo,npjglo), e2(npiglo,npjglo), e3(npiglo,npjglo) )
  ALLOCATE ( gdep (npk), e31d(npk), tim(npt) , dvariance3d(npt), dvmeanout3d(npt) )
  ALLOCATE ( zdep(npk_fi) )

  SELECT CASE (TRIM(ctype))
  CASE ( 'T' )
     cv_e1    = cn_ve1t
     cv_e2    = cn_ve2t
     cv_e3    = 'e3t_ps'
     cv_e31d  = cn_ve3t
     cv_msk = 'tmask'
     cv_dep   = cn_gdept
  CASE ( 'U' )
     cv_e1    = cn_ve1u
     cv_e2    = cn_ve2u
     cv_e3    = 'e3t_ps'
     cv_e31d  = cn_ve3t
     cv_msk = 'umask'
     cv_dep   = cn_gdept
  CASE ( 'V' )
     cv_e1    = cn_ve1v
     cv_e2    = cn_ve2v
     cv_e3    = 'e3t_ps'
     cv_e31d  = cn_ve3t
     cv_msk = 'vmask'
     cv_dep   = cn_gdept
  CASE ( 'F' )
     cv_e1    = cn_ve1f
     cv_e2    = cn_ve2f
     cv_e3    = 'e3t_ps'
     cv_e31d  = cn_ve3t
     cv_msk = 'fmask'
     cv_dep   = cn_gdept
  CASE ( 'W' )
     cv_e1    = cn_ve1t
     cv_e2    = cn_ve2t
     cv_e3    = 'e3w_ps'
     cv_e31d  = cn_ve3w
     cv_msk = 'tmask'
     cv_dep   = cn_gdepw
  CASE DEFAULT
     PRINT *, 'this type of variable is not known :', TRIM(ctype)
     STOP
  END SELECT

  e1(:,:) = getvar  (cn_fhgr, cv_e1,  1,  npiglo, npjglo, kimin=iimin, kjmin=ijmin)
  e2(:,:) = getvar  (cn_fhgr, cv_e2,  1,  npiglo, npjglo, kimin=iimin, kjmin=ijmin)
  IF ( lfull )  e31d(:) = getvare3(cn_fzgr, cv_e31d, npk)
  zdep(:) = getvare3(cn_fzgr, cv_dep, npk_fi)
  gdep(:) = zdep(ikmin:npk - ikmin + 1)

  IF ( lvar ) THEN
    nvars = 4  ! space for variance too
  ELSE
    nvars = 2  ! default value
  ENDIF

  ALLOCATE ( stypvar(nvars), ipk(nvars), id_varout(nvars) )
  ALLOCATE ( rdumlon(ikx,iky), rdumlat(ikx,iky), rdummymean(ikx,iky) )
  ALLOCATE ( dvmeanout(npk) )
  IF ( lvar ) ALLOCATE ( dvariance(npk) )

  rdumlon(:,:) = 0.
  rdumlat(:,:) = 0.

  ipk(1) = nvpk ! mean for each level
  ipk(2) = 1   ! 3D mean
  IF ( lvar ) THEN
    ipk(3) = nvpk ! variance for each level
    ipk(4) = 1   ! 3D variance
  ENDIF

  ierr=getvaratt (cf_in, cv_nam, clunits, zspval, cllong_name, clshort_name)

  ! define new variables for output 
  stypvar%cunits            = TRIM(clunits)
  stypvar%rmissing_value    = 99999.
  stypvar%valid_min         = -1000.
  stypvar%valid_max         = 1000.
  stypvar%scale_factor      = 1.
  stypvar%add_offset        = 0.
  stypvar%savelog10         = 0.
  stypvar%conline_operation = 'N/A'

  stypvar(1)%cname          = 'mean_'//TRIM(cv_nam)
  stypvar(1)%clong_name     = 'mean_'//TRIM(cllong_name)
  stypvar(1)%cshort_name    = 'mean_'//TRIM(clshort_name)
  stypvar(1)%caxis          = 'ZT'

  stypvar(2)%cname          = 'mean_3D'//TRIM(cv_nam)
  stypvar(2)%clong_name     = 'mean_3D'//TRIM(cllong_name)
  stypvar(2)%cshort_name    = 'mean_3D'//TRIM(clshort_name)
  stypvar(2)%caxis          = 'T'

  IF ( lvar) THEN
    stypvar(3)%cunits         = TRIM(clunits)//'^2'
    stypvar(3)%cname          = 'var_'//TRIM(cv_nam)
    stypvar(3)%clong_name     = 'var_'//TRIM(cllong_name)
    stypvar(3)%cshort_name    = 'var_'//TRIM(clshort_name)
    stypvar(3)%caxis          = 'ZT'

    stypvar(4)%cunits         = TRIM(clunits)//'^2'
    stypvar(4)%cname          = 'var_3D'//TRIM(cv_nam)
    stypvar(4)%clong_name     = 'var_3D'//TRIM(cllong_name)
    stypvar(4)%cshort_name    = 'var_3D'//TRIM(clshort_name)
    stypvar(4)%caxis          = 'T'
  ENDIF

  OPEN(numout,FILE=cf_out)
  IF ( lvar ) OPEN(numvar,FILE=cf_var)
  ! create output fileset
  ncout = create      (cf_ncout,   'none',  ikx,   iky,   nvpk, cdep=cv_dep)
  ierr  = createvar   (ncout,      stypvar, nvars, ipk,   id_varout, cdglobal=TRIM(cglobal) )
  ierr  = putheadervar(ncout,      cf_in,  ikx, iky, npk, pnavlon=rdumlon, pnavlat=rdumlat, pdep=gdep(1:nvpk), cdep=cv_dep)
  tim   = getvar1d(cf_in, cn_vtimec, npt)
  ierr  = putvar1d(ncout,  tim,       npt, 'T')

  DO jt=1,npt
     dvol = 0.d0
     dsum = 0.d0
     dvar = 0.d0
     DO jk = 1, nvpk
        ik = jk+ikmin-1
        ! Get velocities v at ik
        zv   (:,:) = getvar(cf_in,  cv_nam,   ik, npiglo, npjglo, kimin=iimin, kjmin=ijmin, ktime=jt)
        zmask(:,:) = getvar(cn_fmsk, cv_msk, ik, npiglo, npjglo, kimin=iimin, kjmin=ijmin          )
        IF ( lfull ) THEN
          e3(:,:) = e31d(jk)
        ELSE
          e3(:,:) = getvar(cn_fzgr, cv_e3,    ik, npiglo, npjglo, kimin=iimin, kjmin=ijmin, ldiom=.TRUE.)
        ENDIF
        ! 
        dsurf  = SUM(DBLE(          e1 * e2      * zmask))
        dvol2d = SUM(DBLE(          e1 * e2 * e3 * zmask))
        dvol   = dvol + dvol2d
        dsum2d = SUM(DBLE(zv      * e1 * e2 * e3 * zmask))
        dvar2d = SUM(DBLE(zv * zv * e1 * e2 * e3 * zmask))
        dsum   = dsum + dsum2d
        dvar   = dvar + dvar2d

        IF (dvol2d /= 0 )THEN
           dvmeanout(jk) = dsum2d/dvol2d
           WRITE(6,*)' Mean value at level ',ik,'(',gdep(jk),' m) ',dvmeanout(jk), 'surface = ',dsurf/1.e6,' km^2'
           WRITE(numout,9004) gdep(jk), ik, dvmeanout(jk)
           IF ( lvar ) THEN
             dvariance(jk) = dvar2d/dvol2d - dvmeanout(jk) * dvmeanout(jk)
             WRITE(6,*)' Variance value at level ',ik,'(',gdep(jk),' m) ',dvariance(jk), 'surface = ',dsurf/1.e6,' km^2'
             WRITE(numvar,9004) gdep(jk), ik, dvariance(jk)
           ENDIF
        ELSE
           WRITE(6,*) ' No points in the water at level ',ik,'(',gdep(jk),' m) '
           dvmeanout(jk) = 99999.
           IF( lvar ) dvariance(jk) = 99999.
        ENDIF

        rdummymean(1,1) = dvmeanout(jk)
        ierr            = putvar(ncout, id_varout(1), rdummymean, jk, ikx, iky, ktime=jt )
        IF ( lvar ) THEN
          rdummymean(1,1) = dvariance(jk)
          ierr            = putvar(ncout, id_varout(3), rdummymean, jk, ikx, iky, ktime=jt )
        ENDIF
     END DO

     dvmeanout3d(jt) = dsum / dvol
     WRITE(6,*) ' Mean value over the ocean: ', dvmeanout3d(jt), jt
     rdummy(:,:) = dvmeanout3d(jt)
     ierr = putvar0d(ncout, id_varout(2), rdummy, ktime=jt )

     IF ( lvar ) THEN
       dvariance3d(jt) = dvar/dvol - dsum / dvol * dsum / dvol
       WRITE(6,*) ' Variance over the ocean: ', dvariance3d(jt), jt
       rdummy(:,:) = dvariance3d(jt)
       ierr = putvar0d(ncout, id_varout(4), rdummy, ktime=jt )
     ENDIF

  END DO  ! time loop

              CLOSE(numout)
  IF ( lvar ) CLOSE(numvar)

  ierr = closeout(ncout)
9004 FORMAT(f9.2,' ',i2,' ',f9.2)

  ! -zeromean option activated : rest the spatial mean computed above for each timeframe
  !           from the original variable, and output the result to zeromean.nc
  !           This replaces exactly the cdfzeromean tool
  !           The mean value which is used here is eventually computed on a reduced region
  IF ( lzeromean )  THEN
    DEALLOCATE ( zv, zmask, id_varout, ipk )
    npiglo = npiglo_fi ; npjglo = npjglo_fi
    ALLOCATE (zv(npiglo,npjglo), zmask(npiglo,npjglo) )

    ! re-read file and rest mean value from the variable and store on file
    nvars = getnvar(cf_in)
    ALLOCATE ( stypvarin(nvars), cv_names(nvars)    )
    ALLOCATE ( id_varout(1), ipk(1), stypvarzero(1) )
    cv_names(:) = getvarname(cf_in, nvars, stypvarin)

    ! look for the working variable
    DO jvar = 1, nvars
       IF ( TRIM(cv_names(jvar)) == TRIM(cv_nam) ) EXIT
    END DO
    ivar = jvar

    ipk(1)                        = nvpk
    stypvarzero(1)%cname          = cv_nam
    stypvarzero%cunits            = stypvarin(ivar)%cunits
    stypvarzero%rmissing_value    = stypvarin(ivar)%rmissing_value
    stypvarzero%valid_min         = stypvarin(ivar)%valid_min - MAXVAL(dvmeanout3d)
    stypvarzero%valid_max         = stypvarin(ivar)%valid_max - MINVAL(dvmeanout3d)
    stypvarzero(1)%clong_name     = stypvarin(ivar)%clong_name//' zero mean '
    stypvarzero(1)%cshort_name    = cv_nam
    stypvarzero%conline_operation = 'N/A'
    stypvarzero%caxis             = stypvarin(ivar)%caxis

  ik=nvpk
  IF ( lnodep ) ik = 0  ! no depth variable in input file : the same in output file
  ncout = create      (cf_zerom, cf_in,        npiglo, npjglo, ik            )
  ierr  = createvar   (ncout ,   stypvarzero , 1,      ipk,    id_varout     )
  ierr  = putheadervar(ncout,    cf_in,        npiglo, npjglo, ik , pdep=zdep)
  tim   = getvar1d(cf_in, cn_vtimec, npt)

  DO jt=1,npt
     DO jk = 1, nvpk
        ik = jk+ikmin-1
        zv   (:,:) = getvar(cf_in,   cv_nam,   ik, npiglo, npjglo, ktime=jt)
        zmask(:,:) = getvar(cn_fmsk, cv_msk, ik, npiglo, npjglo)

        WHERE (zmask /= 0 ) zv(:,:) = zv(:,:) - dvmeanout3d(jt)
        ierr = putvar(ncout, id_varout(1), zv, ik, npiglo, npjglo, ktime=jt )
     END DO
  END DO

  ierr=putvar1d(ncout, tim, npt,'T')
  ierr=closeout(ncout              )
 
  ENDIF

END PROGRAM cdfmean

PROGRAM cdfspice
  !!======================================================================
  !!                     ***  PROGRAM  cdfspice  ***
  !!=====================================================================
  !!  ** Purpose : Compute spiciness 3D field from gridT file
  !!               Store the results on a 'similar' cdf file.
  !!
  !!  ** Method  :  spiciness = sum(i=0,5)[sum(j=0,4)[b(i,j)*theta^i*(s-35)^j]]
  !!                   with:  b     -> coefficients
  !!                          theta -> potential temperature
  !!                          s     -> salinity
  !!
  !!  **  Example:
  !!       spice(15,33)=   0.5445863      0.544586321373410  calcul en double
  !!       spice(15,33)=   0.5445864      (calcul en simple precision)
  !!
  !!  ** References : Flament (2002) "A state variable for characterizing 
  !!              water masses and their diffusive stability: spiciness."
  !!              Progress in Oceanography Volume 54, 2002, Pages 493-501.
  !!
  !! History : 2.1  : 03/2010  : C.O. Dufour  : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: ji, jj, jk, jt     ! dummy loop index
  INTEGER(KIND=4)                           :: ierr               ! error status
  INTEGER(KIND=4)                           :: narg, iargc        ! browse command line
  INTEGER(KIND=4)                           :: npiglo, npjglo     ! size of the domain
  INTEGER(KIND=4)                           :: npk, npt           ! size of the domain
  INTEGER(KIND=4)                           :: ncout              ! ncid of output file
  INTEGER(KIND=4), DIMENSION(1)             :: ipk, id_varout     ! level and  varid's

  REAL(KIND=4)                              :: zspval             ! missing value
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: tim                ! time counter

  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dtemp              ! temperature
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dtempt             ! temperature
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dsal               ! salinity
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dsalt              ! salinity
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dsalref            ! reference salinity
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dspi               ! spiceness
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dmask              ! 2D mask at current level
  REAL(KIND=8), DIMENSION(6,5)              :: dbet               ! coefficients of spiciness formula

  CHARACTER(LEN=256)                        :: cf_tfil            ! input filename
  CHARACTER(LEN=256)                        :: cf_out='spice.nc'  ! output file name

  TYPE (variable), DIMENSION(1)             :: stypvar            ! structure for attributes
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfspice T-file '
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the spiceness corresponding to temperatures and salinities'
     PRINT *,'       given in the input file.' 
     PRINT *,'      '
     PRINT *,'       spiciness = sum(i=0,5)[sum(j=0,4)[b(i,j)*theta^i*(s-35)^j]]'
     PRINT *,'                 with:  b     -> coefficients'
     PRINT *,'                        theta -> potential temperature'
     PRINT *,'                        s     -> salinity'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       T-file : netcdf file with temperature and salinity (gridT)' 
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       none'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : vospice'
     PRINT *,'      '
     PRINT *,'     REFERENCE :'
     PRINT *,'       Flament (2002) "A state variable for characterizing '
     PRINT *,'             water masses and their diffusive stability: spiciness."'
     PRINT *,'             Progress in Oceanography Volume 54, 2002, Pages 493-501.'
     STOP
  ENDIF
  IF ( narg == 0 ) THEN
     PRINT *,'usage : cdfspice  gridT '
     PRINT *,'    Output on spice.nc, variable vospice'
     STOP
  ENDIF

  CALL getarg (1, cf_tfil)

  IF ( chkfile(cf_tfil) ) STOP ! missing files

  npiglo = getdim (cf_tfil,cn_x)
  npjglo = getdim (cf_tfil,cn_y)
  npk    = getdim (cf_tfil,cn_z)
  npt    = getdim (cf_tfil,cn_t)

  ipk(:)                       = npk 
  stypvar(1)%cname             = 'vospice'
  stypvar(1)%cunits            = 'kg/m3'
  stypvar(1)%rmissing_value    = 0.
  stypvar(1)%valid_min         = -300.
  stypvar(1)%valid_max         = 300.
  stypvar(1)%clong_name        = 'spiciness'
  stypvar(1)%cshort_name       = 'vospice'
  stypvar(1)%conline_operation = 'N/A'
  stypvar(1)%caxis             = 'TZYX'

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  ALLOCATE (dtemp(npiglo,npjglo), dsal (npiglo,npjglo) )
  ALLOCATE (dspi( npiglo,npjglo), dmask(npiglo,npjglo) )
  ALLOCATE (dtempt(npiglo,npjglo), dsalt(npiglo,npjglo))
  ALLOCATE (dsalref(npiglo,npjglo))
  ALLOCATE (tim(npt))

  ! create output fileset
  ncout = create      (cf_out, cf_tfil, npiglo, npjglo, npk       )
  ierr  = createvar   (ncout,  stypvar, 1,      ipk,    id_varout )
  ierr  = putheadervar(ncout,  cf_tfil, npiglo, npjglo, npk       )

  tim  = getvar1d(cf_tfil, cn_vtimec, npt     )
  ierr = putvar1d(ncout,   tim,       npt, 'T')

  zspval = getatt(cf_tfil, cn_vosaline, 'missing_value')

  ! Define coefficients to compute spiciness (R*8)
  dbet(1,1) = 0           ; dbet(1,2) = 7.7442d-01  ; dbet(1,3) = -5.85d-03   ; dbet(1,4) = -9.84d-04   ; dbet(1,5) = -2.06d-04
  dbet(2,1) = 5.1655d-02  ; dbet(2,2) = 2.034d-03   ; dbet(2,3) = -2.742d-04  ; dbet(2,4) = -8.5d-06    ; dbet(2,5) = 1.36d-05
  dbet(3,1) = 6.64783d-03 ; dbet(3,2) = -2.4681d-04 ; dbet(3,3) = -1.428d-05  ; dbet(3,4) = 3.337d-05   ; dbet(3,5) = 7.894d-06
  dbet(4,1) = -5.4023d-05 ; dbet(4,2) = 7.326d-06   ; dbet(4,3) = 7.0036d-06  ; dbet(4,4) = -3.0412d-06 ; dbet(4,5) = -1.0853d-06
  dbet(5,1) = 3.949d-07   ; dbet(5,2) = -3.029d-08  ; dbet(5,3) = -3.8209d-07 ; dbet(5,4) = 1.0012d-07  ; dbet(5,5) = 4.7133d-08
  dbet(6,1) = -6.36d-10   ; dbet(6,2) = -1.309d-09  ; dbet(6,3) = 6.048d-09   ; dbet(6,4) = -1.1409d-09 ; dbet(6,5) = -6.676d-10

  ! Compute spiciness
  DO jt=1,npt
     PRINT *,' TIME = ', jt, tim(jt)/86400.,' days'
     DO jk = 1, npk
        dmask(:,:) = 1.

        dtemp(:,:) = getvar(cf_tfil, cn_votemper, jk, npiglo, npjglo, ktime=jt)
        dsal( :,:) = getvar(cf_tfil, cn_vosaline, jk, npiglo, npjglo, ktime=jt)

        WHERE(dsal == zspval ) dmask = 0

        ! spiciness at time jt, at level jk  
        dspi(:,:)    = 0.d0
        dsalref(:,:) = dsal(:,:) - 35.d0
        dtempt(:,:)  = 1.d0
        DO ji=1,6
           dsalt(:,:) = 1.d0
           DO jj=1,5
              dspi( :,:) = dspi (:,:) + dbet   (ji,jj) * dtempt(:,:) * dsalt(:,:)
              dsalt(:,:) = dsalt(:,:) * dsalref( :,: )
           END DO
           dtempt(:,:) = dtempt(:,:) * dtemp(:,:)     
        END DO

        ierr = putvar(ncout, id_varout(1), REAL(dspi*dmask), jk, npiglo, npjglo, ktime=jt)

     END DO  ! loop to next level
  END DO  ! next time frame

  ierr = closeout(ncout)

END PROGRAM cdfspice

PROGRAM cdfkempemekeepe
  !!======================================================================
  !!                     ***  PROGRAM  cdfkempemekeepe  ***
  !!=====================================================================
  !!  ** Purpose : Compute the term of energetic transfert from mean kinetic
  !!               energy to mean potential energy (T1) and from eddy 
  !!               potential energy to eddy kinetic energy (T3)
  !!
  !! History : 2.1  : 03/2008  : A. Melet     : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                             :: jj, jk         ! dummy loop index
  INTEGER(KIND=4)                             :: npiglo, npjglo ! size of the domain
  INTEGER(KIND=4)                             :: npk, npt       ! size of the domain
  INTEGER(KIND=4)                             :: narg, iargc    ! browse line
  INTEGER(KIND=4)                             :: ncout, ierr    ! ncid of outputfile, error status
  INTEGER(KIND=4), DIMENSION(2)               :: ipk, id_varout ! levels and varid's of output vars

  REAL(KIND=4), DIMENSION(:,:,:), ALLOCATABLE :: wbartbar
  REAL(KIND=4), DIMENSION(:,:,:), ALLOCATABLE :: anowt 
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: t1mask
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: w1mask
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: txz
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: wxz 
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: wtxz
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: wbartbarxz
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: anowtxz
  REAL(KIND=4), DIMENSION(:),     ALLOCATABLE :: tim            ! time counter (dummy)

  CHARACTER(LEN=256)                          :: cf_uvwtfil          ! input file
  CHARACTER(LEN=256)                          :: cf_out='transfertst1t3.nc'

  TYPE  (variable), DIMENSION(2)              :: stypvar        ! structure for attibutes
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg /= 1 ) THEN
     PRINT *,'usage : cdfkempemekeepe file'
     PRINT *,'     Produce a cdf file transfertst1t3.nc with wT and anowT variables'
     PRINT *,'     file is from cdfmoyuvwt'
     PRINT *,'     the mean must have been computed on a period long enough'
     PRINT *,'     for the statistics to be meaningful'
     PRINT *,'                         '
     STOP
  ENDIF

  CALL getarg(1, cf_uvwtfil)

  IF (chkfile(cf_uvwtfil) ) STOP ! missing file
  npiglo = getdim(cf_uvwtfil, cn_x)
  npjglo = getdim(cf_uvwtfil, cn_y)
  npk    = getdim(cf_uvwtfil, cn_z)
  npt    = getdim(cf_uvwtfil, cn_t)

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  ! define new variables for output ( must update att.txt)
  ipk(:)                    = npk  
  stypvar(1)%cname          = 'wT'
  stypvar(1)%clong_name     = 'temporal mean of w times temporal mean of T on T point (*1000)'
  stypvar(1)%cshort_name    = 'wT'

  stypvar(2)%cname          = 'anowT'
  stypvar(2)%clong_name     = 'temporal mean of anomaly of w times ano of T on T point (*1000)'
  stypvar(2)%cshort_name    = 'anowT'
 
  stypvar%cunits            = '1000 m.K'
  stypvar%rmissing_value    = 0.
  stypvar%valid_min         = -1000.
  stypvar%valid_max         = 1000.
  stypvar%conline_operation = 'N/A'
  stypvar%caxis             = 'TYX'
  
  ! create output fileset
  ncout = create      (cf_out, cf_uvwtfil,   npiglo, npjglo, npk       )
  ierr  = createvar   (ncout,    stypvar, 2,      ipk,    id_varout )
  ierr  = putheadervar(ncout,    cf_uvwtfil,   npiglo, npjglo, npk       )

  ! Allocate the memory
  ALLOCATE ( wbartbar(  npiglo, npjglo, npk) )  ! 3D can be huge !
  ALLOCATE ( anowt(     npiglo, npjglo, npk) )  ! 3D can be huge
  ALLOCATE ( t1mask(    npiglo,npk) )
  ALLOCATE ( w1mask(    npiglo,npk) )
  ALLOCATE ( txz(       npiglo,npk) )
  ALLOCATE ( wxz(       npiglo,npk) )
  ALLOCATE ( wtxz(      npiglo,npk) )
  ALLOCATE ( anowtxz(   npiglo,npk) )
  ALLOCATE ( wbartbarxz(npiglo,npk) )  
  ALLOCATE ( tim(npt)  )  
  
  tim  = getvar1d(cf_uvwtfil, cn_vtimec, npt     )
  ierr = putvar1d(ncout, tim,       npt, 'T')

  DO jj = 1, npjglo
       wbartbarxz(:,:) = 0.0
       anowtxz(:,:)    = 0.0
       wtxz(:,:)       = 0.0
       wxz(:,:)        = 0.0
       txz(:,:)        = 0.0

       txz( :,:) = getvarxz(cf_uvwtfil, 'tbar',  jj, npiglo, npk, kimin=1, kkmin=1, ktime=1)
       wxz( :,:) = getvarxz(cf_uvwtfil, 'wbar',  jj, npiglo, npk, kimin=1, kkmin=1, ktime=1)
       wtxz(:,:) = getvarxz(cf_uvwtfil, 'wtbar', jj, npiglo, npk, kimin=1, kkmin=1, ktime=1)

       DO jk=1, npk-1
          w1mask(:,jk) = wxz(:,jk) * wxz(:,jk+1)
          t1mask(:,jk) = txz(:,jk)
          WHERE ( w1mask(:,jk) /= 0.) w1mask(:,jk)=1.
          WHERE ( t1mask(:,jk) /= 0.) t1mask(:,jk)=1. 
          wbartbarxz(:,jk) = 1000. * t1mask(:,jk) * txz(:,jk) * 0.5 * w1mask(:,jk) * ( wxz(:,jk) + wxz(:,jk+1) )
          anowtxz(   :,jk) = 1000. * ( wtxz(:,jk) - wbartbarxz(:,jk)*0.001 )      
       END DO
       wbartbar(:,jj,:) = wbartbarxz(:,:)
       anowt(   :,jj,:) = anowtxz(   :,:)
  END DO
  DO jk=1,npk
     ierr = putvar(ncout, id_varout(1), wbartbar(:,:,jk), jk, npiglo, npjglo )
     ierr = putvar(ncout, id_varout(2), anowt(   :,:,jk), jk, npiglo, npjglo )
  END DO

  ierr = closeout(ncout)  

END PROGRAM cdfkempemekeepe

PROGRAM cdfmean
  !!======================================================================
  !!                     ***  PROGRAM  cdfmean  ***
  !!=====================================================================
  !!  ** Purpose : Compute the Mean Value over the ocean or part of the
  !!               ocean (spatial mean).
  !!
  !!  ** Method  : mean= sum( V * e1 *e2 * e3 *mask )/ sum( e1 * e2 * e3 *mask ))
  !!               Partial cell version
  !!
  !! History : 2.1  : 10/2005  : J.M. Molines : Original code
  !!         : 2.1  : 07/2009  : R. Dussin    : Netcdf output
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class integration
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                            :: jk, jt, jvar       ! dummy loop index
  INTEGER(KIND=4)                            :: it                 ! time index for vvl
  INTEGER(KIND=4)                            :: ik, ivar           !
  INTEGER(KIND=4)                            :: jbasin, ivarb, ib  ! basin related variables
  INTEGER(KIND=4)                            :: iimin=0, iimax=0   ! domain limitation for computation
  INTEGER(KIND=4)                            :: ijmin=0, ijmax=0   ! domain limitation for computation
  INTEGER(KIND=4)                            :: ikmin=0, ikmax=0   ! domain limitation for computation
  INTEGER(KIND=4)                            :: narg, iargc, ijarg ! command line 
  INTEGER(KIND=4)                            :: npiglo, npjglo     ! size of the domain
  INTEGER(KIND=4)                            :: npiglo_fi          ! size of the domain from input file
  INTEGER(KIND=4)                            :: npjglo_fi          ! size of the domain from input file
  INTEGER(KIND=4)                            :: npk_fi             ! size of the domain from input file
  INTEGER(KIND=4)                            :: npk, npt           ! size of the domain
  INTEGER(KIND=4)                            :: nvpk               ! vertical levels in working variable
  INTEGER(KIND=4)                            :: nbasin=1           ! number of basins
  INTEGER(KIND=4)                            :: numout=10          ! logical unit for mean output file
  INTEGER(KIND=4)                            :: numvar=11          ! logical unit for variance output file
  INTEGER(KIND=4)                            :: numsum=12          ! logical unit for sum output file
  INTEGER(KIND=4)                            :: ikx=1, iky=1       ! dims of netcdf output file
  INTEGER(KIND=4)                            :: nvars, nvars_bas   ! number of values to write in cdf output
  INTEGER(KIND=4)                            :: ncout, ierr        ! for netcdf output
  INTEGER(KIND=4)                            :: idep, idep_max     ! possible depth index, maximum
  INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE :: n_sum,n_sum3d      ! index of sum, sum3d in id_varout
  INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE :: n_mean,n_mean3d    ! index of mean, mean3d in id_varout
  INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE :: n_var,n_var3d      ! index of var, var3d in id_varout
  INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE :: ipk, id_varout
  INTEGER(KIND=4), DIMENSION(:,:,:), ALLOCATABLE :: ibmask         ! nbasin x npiglo x npjglo

  REAL(KIND=4)                               :: zspval             ! missing value
  REAL(KIND=4), DIMENSION(:),    ALLOCATABLE :: gdep               ! depth 
  REAL(KIND=4), DIMENSION(:),    ALLOCATABLE :: zdep               ! depth of the whole vertical levels
  REAL(KIND=4), DIMENSION(:),    ALLOCATABLE :: e31d               ! 1d vertical spacing
  REAL(KIND=4), DIMENSION(1,1)               :: rdummy             ! dummy variable
  REAL(KIND=4), DIMENSION(:,:),  ALLOCATABLE :: e1, e2, e3, zv     ! metrics, velocity
  REAL(KIND=4), DIMENSION(:,:),  ALLOCATABLE :: zmask, zvzm        ! npiglo x npjglo
  REAL(KIND=4), DIMENSION(:,:),  ALLOCATABLE :: rdumlon, rdumlat   ! dummy lon/lat for output file
  REAL(KIND=4), DIMENSION(:,:),  ALLOCATABLE :: rdummymean         ! array for mean value on output file

  REAL(KIND=8)                               :: dsurf              ! cumulated values
  REAL(KIND=8)                               :: dvol2d,  dsum2d    !
  REAL(KIND=8)                               :: dvar2d             ! for variance computing
  REAL(KIND=8), DIMENSION(:),    ALLOCATABLE :: dtim               ! time counter
  REAL(KIND=8), DIMENSION(:),    ALLOCATABLE :: dvmeanout          ! spatial mean
  REAL(KIND=8), DIMENSION(:),    ALLOCATABLE :: dvariance          ! spatial variance
  REAL(KIND=8), DIMENSION(:),    ALLOCATABLE :: dvol, dsum, dvar   ! cumulated values
  REAL(KIND=8), DIMENSION(:,:),  ALLOCATABLE :: dvmeanout3d        ! global 3D mean value
  REAL(KIND=8), DIMENSION(:,:),  ALLOCATABLE :: dvariance3d        ! global 3D mean variance

  CHARACTER(LEN=256)                         :: cv_nam             ! current variable name
  CHARACTER(LEN=256)                         :: cv_dep             ! deptht name
  CHARACTER(LEN=20)                          :: cv_e1, cv_e2       ! horizontal metrics names
  CHARACTER(LEN=20)                          :: cv_e3, cv_e31d     ! vertical metrics names
  CHARACTER(LEN=20)                          :: cv_msk = ''        ! mask variable name
  CHARACTER(LEN=256)                         :: cf_e3              ! name of the file holding vertical metrics
  CHARACTER(LEN=256)                         :: cf_in              ! input file name
  CHARACTER(LEN=256)                         :: cf_out   = 'cdfmean.txt' ! ASCII output file for mean
  CHARACTER(LEN=256)                         :: cf_var   = 'cdfvar.txt'  ! ASCII output file for variance
  CHARACTER(LEN=256)                         :: cf_sum   = 'cdfsum.txt'  ! ASCII output file for variance
  CHARACTER(LEN=256)                         :: cf_ncout = 'cdfmean.nc'  ! NCDF output file
  CHARACTER(LEN=256)                         :: cf_zerom = 'zeromean.nc' ! NCDF output file with zeromean field
  CHARACTER(LEN=256)                         :: clbas    = ''      ! Basin name for printing
  CHARACTER(LEN=256)                         :: cl_prefix = ''     ! Prefix to prepend to output file names
  CHARACTER(LEN=256)                         :: ctype              ! type of C-grid point to work with
  CHARACTER(LEN=256)                         :: clunits            ! attribute of output file : units
  CHARACTER(LEN=256)                         :: cllong_name        !     "      long name
  CHARACTER(LEN=256)                         :: clshort_name       !     "      short name
  CHARACTER(LEN=256)                         :: cglobal            !     "      global 
  CHARACTER(LEN=256)                         :: cldum              ! dummy char variable
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: clv_dep         ! array of possible depth name (or 3rd dimension)
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_names        ! list of file names
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cbasins         ! list of basin names

  TYPE(variable), DIMENSION(:),  ALLOCATABLE :: stypvar            ! structure of output
  TYPE(variable), DIMENSION(:),  ALLOCATABLE :: stypvarin          ! structure of input data
  TYPE(variable), DIMENSION(:),  ALLOCATABLE :: stypvarzero        ! structure of zeromean output

  LOGICAL                                    :: lbas      = .FALSE.! basin flag
  LOGICAL                                    :: lfull     = .FALSE.! full step  flag
  LOGICAL                                    :: lvar      = .FALSE.! variance  flag
  LOGICAL                                    :: lsum      = .FALSE.! sum  flag
  LOGICAL                                    :: lzeromean = .FALSE.! zero mean  flag
  LOGICAL                                    :: lnodep    = .FALSE.! no depth flag
  LOGICAL                                    :: lchk               ! flag for missing files
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfmean -f IN-file -v IN-var -p C-point  ...'
     PRINT *,'       ... [-w imin imax jmin jmax kmin kmax] [-full] [-var] [-zeromean]...'
     PRINT *,'       ... [-M MSK-file VAR-mask ] [-B BASIN-mask LST-basins] [-P OUT-prefix]'
     PRINT *,'       ... [-o OUT-file] [ -ot OUTASCII-file] [-oz ZEROMEAN-file] ' 
     PRINT *,'       ... [-ov VAR-file] [-os SUM-file][ -vvl ] [-S]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'        Compute the mean value of the field (3D, weighted). For 3D fields,'
     PRINT *,'        a horizontal mean for each level is also given. If a spatial window'
     PRINT *,'        is specified, the mean value is computed only in this window.'
     PRINT *,'      '
     PRINT *,'        If -S option is used, the weighted sum of the fields at each level '
     PRINT *,'        is also saved, as well as the global weighted sum.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -f IN-file : input netcdf file.'
     PRINT *,'       -v IN-var  : name of netcdf variable to work with.'
     PRINT *,'       -p C-point : one of T|U|V|F|W indicating the position of IN-var on the'
     PRINT *,'                C-grid.' 
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-w imin imax jmin jmax kmin kmax] : spatial window where mean value'
     PRINT *,'                is computed:' 
     PRINT *,'                  if imin = 0 then ALL i are taken'
     PRINT *,'                  if jmin = 0 then ALL j are taken'
     PRINT *,'                  if kmin = 0 then ALL k are taken'
     PRINT *,'       [-full ] : compute the mean for full steps, instead of default '
     PRINT *,'              partial steps.'
     PRINT *,'       [-var ]: also compute the spatial variance of IN-var.'
     PRINT *,'       [-zeromean ] : create a file with cdfvar having a zero spatial mean.'
     PRINT *,'       [-M MSK-file VAR-mask] : Allow the use of a non standard mask file '
     PRINT *,'              with VAR-mask, instead of ',TRIM(cn_fmsk),' and the variable'
     PRINT *,'              associated with the grid point set by -p argument.'
     PRINT *,'              This option is a usefull alternative to the -w option, when the '
     PRINT *,'              area of interest is not ''box-like''. However, for vertical '
     PRINT *,'              selection, both -w and -M can be used together. '
     PRINT *,'          CAUTION : MSK file must have the same vertical dimension than the '
     PRINT *,'              working variable, otherwise, the resulting mean will be wrong.'
     PRINT *,'       [-B BASIN-mask LST-basins] : will compute the means for sub-basins,'
     PRINT *,'              specified by LST-basins from BASIN-mask file. LST-basin is a '
     PRINT *,'              blank separated list of mask variable names in BASIN-mask file.'
     PRINT *,'       [-P OUT-prefix] : OUT-prefix will be prepend to output filenames. '
     PRINT *,'              OUT-prefix can include a directory name.'
     PRINT *,'       [-o OUT-file]: specify the name of the output file instead of the '
     PRINT *,'              default name : ',TRIM(cf_ncout)
     PRINT *,'       [-ot OUTASCII-file] : specify the name of the output ASCII file instead '
     PRINT *,'                   of ',TRIM(cf_out)
     PRINT *,'       [-oz ZEROMEAN-file] : specify the name of the output netcdf file for '
     PRINT *,'                   option -zeromean, instead of ', TRIM(cf_zerom)
     PRINT *,'       [-ov VAR-file] : specify the name of the output text file for option '
     PRINT *,'                   -var, instead of ', TRIM(cf_var)
     PRINT *,'       [-os SUM-file] : specify the name of the output text file for option '
     PRINT *,'                   -S, instead of ', TRIM(cf_sum)
     PRINT *,'       [-vvl ] : use time-varying vertical metrics.'
     PRINT *,'       [-S ] : save the weighted sum of the fields in addition to the mean '
     PRINT *,'               values. (Replace somehow cdfsum)'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       Files ', TRIM(cn_fhgr),', ', TRIM(cn_fzgr),', ', TRIM(cn_fmsk)
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       - netcdf file : ', TRIM(cf_ncout)
     PRINT *,'           variables : mean_<IN-var>, mean_3D_<IN-var> '
     PRINT *,'                    [var_<IN-VAR>, var_3D_<IN-var>, in case of -var]'
     PRINT *,'                    [sum_<IN-VAR>, sum_3D_<IN-var>, in case of -S]'
     PRINT *,'       - netcdf file : ', TRIM(cf_zerom),' [ in case of -zeromean option]'
     PRINT *,'           variables : <IN-var>'
     PRINT *,'       - ASCII files : ', TRIM(cf_out) 
     PRINT *,'                       [ ',TRIM(cf_var),', in case of -var ]'
     PRINT *,'                       [ ',TRIM(cf_sum),', in case of -S ]'
     PRINT *,'       - all output on ASCII files are also sent to standard output.'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'         cdfsum  (obsolete, better use -S option in cdfmean)'
     PRINT *,'      '
     STOP 
  ENDIF

  ! Open standard output with recl=256 to avoid wrapping of long lines (ifort)
  OPEN(6,FORM='FORMATTED',RECL=256)  ! ifort
  ! OPEN(6,FORM='FORMATTED')          ! gfortran

  cglobal = 'Partial step computation'
  ijarg = 1 
  DO WHILE ( ijarg <= narg )
     CALL getarg(ijarg, cldum ) ; ijarg = ijarg + 1 
     SELECT CASE (cldum) 
     CASE ('-f'        ) ; CALL getarg(ijarg, cf_in    ) ; ijarg = ijarg + 1
     CASE ('-v'        ) ; CALL getarg(ijarg, cv_nam   ) ; ijarg = ijarg + 1
     CASE ('-p'        ) ; CALL getarg(ijarg, ctype    ) ; ijarg = ijarg + 1
        ! options
     CASE ('-full'     ) ; lfull     = .TRUE.  ; cglobal = 'full step computation'
     CASE ('-var'      ) ; lvar      = .TRUE. 
     CASE ('-zeromean' ) ; lzeromean = .TRUE. 
     CASE ('-vvl'      ) ; lg_vvl    = .TRUE. 
     CASE ('-w'        ) ; CALL getarg(ijarg, cldum    ) ; ijarg = ijarg + 1 ;  READ(cldum,*) iimin
        ;                  CALL getarg(ijarg, cldum    ) ; ijarg = ijarg + 1 ;  READ(cldum,*) iimax
        ;                  CALL getarg(ijarg, cldum    ) ; ijarg = ijarg + 1 ;  READ(cldum,*) ijmin
        ;                  CALL getarg(ijarg, cldum    ) ; ijarg = ijarg + 1 ;  READ(cldum,*) ijmax
        ;                  CALL getarg(ijarg, cldum    ) ; ijarg = ijarg + 1 ;  READ(cldum,*) ikmin
        ;                  CALL getarg(ijarg, cldum    ) ; ijarg = ijarg + 1 ;  READ(cldum,*) ikmax
     CASE ('-o'        ) ; CALL getarg(ijarg, cf_ncout ) ; ijarg = ijarg + 1
     CASE ('-oz'       ) ; CALL getarg(ijarg, cf_zerom ) ; ijarg = ijarg + 1
     CASE ('-ov'       ) ; CALL getarg(ijarg, cf_var   ) ; ijarg = ijarg + 1
     CASE ('-os'       ) ; CALL getarg(ijarg, cf_sum   ) ; ijarg = ijarg + 1
     CASE ('-ot'       ) ; CALL getarg(ijarg, cf_out   ) ; ijarg = ijarg + 1
     CASE ('-M'        ) ; CALL getarg ( ijarg, cn_fmsk) ; ijarg = ijarg + 1
        ;                  CALL getarg ( ijarg, cv_msk ) ; ijarg = ijarg + 1
     CASE ('-S'        ) ; lsum = .TRUE.
     CASE ('-B'        ) ; lbas = .TRUE.
        ;                ; CALL getarg ( ijarg, cn_fbasins) ; ijarg = ijarg + 1
        ;                ; CALL GetLstMask  ! set up nbasin and cbasins(:)
     CASE ( '-P' )
        ;                ; CALL getarg ( ijarg, cl_prefix) ; ijarg = ijarg + 1

     CASE DEFAULT        ; PRINT *,' ERROR : ',TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  END DO

  ! prepend prefix to output file name :
  cf_ncout=TRIM(cl_prefix)//TRIM(cf_ncout)
  cf_zerom=TRIM(cl_prefix)//TRIM(cf_zerom)
  cf_out  =TRIM(cl_prefix)//TRIM(cf_out  )
  cf_var  =TRIM(cl_prefix)//TRIM(cf_var  )
  cf_sum  =TRIM(cl_prefix)//TRIM(cf_sum  )

  lchk = chkfile(cn_fhgr)
  lchk = chkfile(cn_fzgr) .OR. lchk
  lchk = chkfile(cn_fmsk) .OR. lchk
  lchk = chkfile(cf_in  ) .OR. lchk
  IF ( lbas ) lchk =  chkfile(cn_fbasins ) .OR. lchk
  IF ( lchk ) STOP 99 ! missing file

  cv_dep   = 'none'
  npiglo = getdim (cf_in, cn_x)
  npjglo = getdim (cf_in, cn_y)

  ! looking for npk among various possible name
  idep_max=8
  ALLOCATE ( clv_dep(idep_max) )
  clv_dep(:) = (/cn_z,'z','sigma','nav_lev','levels','ncatice','icbcla','icbsect'/)
  idep=1  ; ierr=1000
  DO WHILE ( ierr /= 0 .AND. idep <= idep_max )
     npk  = getdim (cf_in, clv_dep(idep), cdtrue=cv_dep, kstatus=ierr)
     idep = idep + 1
  END DO

  IF ( ierr /= 0 ) THEN  ! none of the dim name was found
     PRINT *,' assume file with no depth'
     npk=0
  ENDIF

  npt   = getdim (cf_in, cn_t)
  nvpk  = getvdim(cf_in, cv_nam)
  ! save original npiglo, npiglo
  npiglo_fi = npiglo
  npjglo_fi = npjglo
  npk_fi    = npk

  IF (npk   == 0 ) THEN ; lnodep = .TRUE.;  npk = 1; npk_fi = 1      ;
  ENDIF ! no depth dimension ==> 1 level
  IF (iimin /= 0 ) THEN ; npiglo = iimax -iimin + 1;  ELSE ; iimin=1 ;
  ENDIF
  IF (ijmin /= 0 ) THEN ; npjglo = ijmax -ijmin + 1;  ELSE ; ijmin=1 ;
  ENDIF
  IF (ikmin /= 0 ) THEN ; npk    = ikmax -ikmin + 1;  ELSE ; ikmin=1 ;
  ENDIF

  IF (nvpk == 2 ) nvpk = 1
  IF (nvpk == 3 ) nvpk = npk

  WRITE(6, *) 'npiglo = ', npiglo
  WRITE(6, *) 'npjglo = ', npjglo
  WRITE(6, *) 'npk    = ', npk
  WRITE(6, *) 'npt    = ', npt
  WRITE(6, *) 'nvpk   = ', nvpk
  WRITE(6, *) 'depth dim name is ', TRIM(cv_dep)

  ! Allocate arrays
  ALLOCATE ( ibmask(nbasin,npiglo,npjglo) )
  ALLOCATE ( zmask(npiglo,npjglo), zvzm(npiglo,npjglo) )
  ALLOCATE ( zv   (npiglo,npjglo) )
  ALLOCATE ( e1   (npiglo,npjglo), e2(npiglo,npjglo), e3(npiglo,npjglo) )
  ALLOCATE ( dvariance3d(nbasin,npt), dvmeanout3d(nbasin,npt) )
  ALLOCATE ( gdep (npk), e31d(npk), dtim(npt)  )
  ALLOCATE ( dvol(nbasin), dsum(nbasin), dvar(nbasin) )
  ALLOCATE ( zdep(npk_fi) )
  ALLOCATE ( n_mean(nbasin), n_mean3d(nbasin), n_var(nbasin), n_var3d(nbasin) )
  ALLOCATE ( n_sum(nbasin), n_sum3d(nbasin) )

  SELECT CASE (TRIM(ctype))
  CASE ( 'T' )
     cv_e1    = cn_ve1t
     cv_e2    = cn_ve2t
     cf_e3    = cn_fe3t
     cv_e3    = cn_ve3t
     cv_e31d  = cn_ve3t1d
     IF (lg_vvl) cv_e3 = cn_ve3tvvl
     IF (cv_msk   == '' ) THEN ; cv_msk = cn_tmask ;
     ENDIF
     cv_dep   = cn_gdept
  CASE ( 'U' )
     cv_e1    = cn_ve1u
     cv_e2    = cn_ve2u
     cf_e3    = cn_fe3u
     cv_e3    = cn_ve3u
     cv_e31d  = cn_ve3t1d
     IF (lg_vvl) cv_e3 = cn_ve3uvvl
     IF (cv_msk   == '' ) THEN ; cv_msk = cn_umask ;
     ENDIF
     cv_dep   = cn_gdept
  CASE ( 'V' )
     cv_e1    = cn_ve1v
     cv_e2    = cn_ve2v
     cf_e3    = cn_fe3v
     cv_e3    = cn_ve3v
     cv_e31d  = cn_ve3t1d
     IF (lg_vvl) cv_e3 = cn_ve3vvvl
     IF (cv_msk   == '' ) THEN ; cv_msk = cn_vmask ;
     ENDIF
     cv_dep   = cn_gdept
  CASE ( 'F' )   ! JMM : WARNING : e3f metrics is not written any where we take e3t for the time being 111
     cv_e1    = cn_ve1f
     cv_e2    = cn_ve2f
     cf_e3    = cn_fe3t
     cv_e3    = cn_ve3t
     cv_e31d  = cn_ve3t1d
     IF (lg_vvl) cv_e3 = cn_ve3tvvl
     IF (cv_msk   == '' ) THEN ; cv_msk = cn_fmask ;
     ENDIF
     cv_dep   = cn_gdept
  CASE ( 'W' )
     cv_e1    = cn_ve1t
     cv_e2    = cn_ve2t
     cf_e3    = cn_fe3t
     cv_e3    = cn_ve3w
     cv_e31d  = cn_ve3w1d
     IF (lg_vvl) cv_e3 = cn_ve3wvvl
     IF (cv_msk   == '' ) THEN ; cv_msk = cn_tmask ;
     ENDIF
     cv_dep   = cn_gdepw
  CASE DEFAULT
     PRINT *, 'this type of variable is not known :', TRIM(ctype)
     STOP 99
  END SELECT

  e1(:,:) = getvar  (cn_fhgr, cv_e1,  1,  npiglo, npjglo, kimin=iimin, kjmin=ijmin)
  e2(:,:) = getvar  (cn_fhgr, cv_e2,  1,  npiglo, npjglo, kimin=iimin, kjmin=ijmin)
  IF ( lfull )  e31d(:) = getvare3(cn_fzgr, cv_e31d, npk)

  zdep(:) = getvare3(cn_fzgr, cv_dep, npk_fi)
  gdep(:) = zdep(ikmin:npk - ikmin + 1)

  IF ( lvar ) THEN ; nvars_bas = 4  ! space for variance too
  ELSE             ; nvars_bas = 2  ! default value
  ENDIF
  IF ( lsum ) THEN ; nvars_bas = nvars_bas + 2  ! add sum and sum3d
  ENDIF
  nvars = nvars_bas * nbasin

  ALLOCATE ( stypvar(nvars), ipk(nvars), id_varout(nvars) )
  ALLOCATE ( rdumlon(ikx,iky), rdumlat(ikx,iky), rdummymean(ikx,iky) )
  ALLOCATE ( dvmeanout(npk) )
  IF ( lvar ) ALLOCATE ( dvariance(npk) )

  CALL CreateOutput

  ! Get the basin masks
  IF ( lbas ) THEN
     DO jbasin = 1, nbasin
        ibmask(jbasin,:,:) = getvar(cn_fbasins, cbasins(jbasin), 1, npiglo, npjglo, kimin=iimin, kjmin=ijmin)
     END DO
  ELSE
     ibmask(1,:,:) = 1
  ENDIF

  OPEN(numout,FILE=cf_out)
  IF ( lvar ) OPEN(numvar,FILE=cf_var)
  IF ( lsum ) OPEN(numsum,FILE=cf_sum)
  IF ( lg_vvl ) cf_e3 = cf_in

  DO jt=1,npt
     IF ( lg_vvl ) THEN ; it = jt
     ELSE               ; it = 1
     ENDIF
     dvol(:) = 0.d0
     dsum(:) = 0.d0
     dvar(:) = 0.d0
     DO jk = 1, nvpk
        ik = jk+ikmin-1
        ! Get velocities v at ik
        zv   (:,:) = getvar(cf_in,   cv_nam, ik, npiglo, npjglo, kimin=iimin, kjmin=ijmin, ktime=jt)
        zmask(:,:) = getvar(cn_fmsk, cv_msk, ik, npiglo, npjglo, kimin=iimin, kjmin=ijmin          )
        zv = zv * zmask  ! do the masking now in case you have funny-like FillValues ( Thx Mercator :) )
        IF ( lfull ) THEN
           e3(:,:) = e31d(jk)
        ELSE
           e3(:,:) = getvar(cf_e3, cv_e3, ik, npiglo, npjglo, kimin=iimin, kjmin=ijmin, ktime=it, ldiom=.NOT.lg_vvl )
        ENDIF
        DO jbasin = 1, nbasin
           ivarb = nvars_bas * (jbasin - 1)
           !
           dsurf        = SUM(DBLE(          e1 * e2      * zmask * ibmask(jbasin,:,:)))
           dvol2d       = SUM(DBLE(          e1 * e2 * e3 * zmask * ibmask(jbasin,:,:)))
           dvol(jbasin) = dvol(jbasin) + dvol2d
           dsum2d       = SUM(DBLE(zv      * e1 * e2 * e3         * ibmask(jbasin,:,:)))  ! zv is already x by zmask
           dvar2d       = SUM(DBLE(zv * zv * e1 * e2 * e3         * ibmask(jbasin,:,:)))
           dsum(jbasin) = dsum(jbasin) + dsum2d
           dvar(jbasin) = dvar(jbasin) + dvar2d

           IF ( lbas ) clbas = ' for basin '//cbasins(jbasin)

           IF (dvol2d /= 0 )THEN
              dvmeanout(jk) = dsum2d/dvol2d
              WRITE(6,*)' Mean value', TRIM(clbas), ' at level ',ik,'(',gdep(jk),' m) ',dvmeanout(jk), 'surface = ',dsurf/1.e6,' km^2'
              WRITE(numout,9004) gdep(jk), ik, dvmeanout(jk)
              IF ( lvar ) THEN
                 dvariance(jk) = dvar2d/dvol2d - dvmeanout(jk) * dvmeanout(jk)
                 WRITE(6,*)' Variance value', TRIM(clbas), ' at level ',ik,'(',gdep(jk),' m) ',dvariance(jk), 'surface = ',dsurf/1.e6,' km^2'
                 WRITE(numvar,9004) gdep(jk), ik, dvariance(jk)
              ENDIF
              IF ( lsum ) THEN
                 WRITE(numsum,9004) gdep(jk), ik, dvol2d
              ENDIF
           ELSE
              WRITE(6,*) ' No points in the water at level ',ik,'(',gdep(jk),' m) '
              dvmeanout(jk) = 99999.
              IF( lvar ) dvariance(jk) = 99999.
           ENDIF

           rdummymean(1,1) = dvmeanout(jk)
           ierr            = putvar(ncout, id_varout(n_mean(jbasin)), rdummymean, jk, ikx, iky, ktime=jt )
           IF ( lvar ) THEN
              rdummymean(1,1) = dvariance(jk)
              ierr            = putvar(ncout, id_varout(n_var(jbasin)), rdummymean, jk, ikx, iky, ktime=jt )
           ENDIF
           IF ( lsum ) THEN
              rdummymean(1,1) = dsum2d
              ierr            = putvar(ncout, id_varout(n_sum(jbasin)), rdummymean, jk, ikx, iky, ktime=jt )
           ENDIF
        END DO ! basin loop
     END DO  ! depth loop

     DO jbasin = 1, nbasin
        ivarb = nvars_bas * (jbasin - 1)

        dvmeanout3d(jbasin,jt) = dsum(jbasin) / dvol(jbasin)
        WRITE(6,*) ' Mean value over the ocean: ', dvmeanout3d(jbasin,jt), jt
        WRITE(numout,*) ' Mean value over the ocean ',TRIM(clbas),': ', dvmeanout3d(jbasin,jt), jt
        rdummy(:,:) = dvmeanout3d(jbasin,jt)
        ierr = putvar0d(ncout, id_varout(n_mean3d(jbasin)), rdummy, ktime=jt )

        IF ( lvar ) THEN
           dvariance3d(jbasin,jt) = dvar(jbasin)/dvol(jbasin) - dsum(jbasin) / dvol(jbasin) * dsum(jbasin) / dvol(jbasin)
           WRITE(6,*) ' Variance over the ocean: ', dvariance3d(jbasin,jt), jt
           WRITE(numvar,*) ' Variance over the ocean ',TRIM(clbas),': ', dvariance3d(jbasin,jt), jt
           rdummy(:,:) = dvariance3d(jbasin,jt)
           ierr = putvar0d(ncout, id_varout(n_var3d(jbasin)), rdummy, ktime=jt )
        ENDIF

        IF ( lsum ) THEN
           WRITE(6,*) ' Sum over the ocean: ', dsum, jt
           WRITE(numsum,*) ' Sum over the ocean:  ',TRIM(clbas),'', dsum, jt
           rdummy(:,:) = dsum(jbasin)
           ierr = putvar0d(ncout, id_varout(n_sum3d(jbasin)), rdummy, ktime=jt )
        ENDIF
     END DO ! basin loop
  END DO  ! time loop

  CLOSE(numout)
  IF ( lvar ) CLOSE(numvar)

  ierr = closeout(ncout)
9004 FORMAT(f9.2,' ',i2,' ',f9.2)

  ! -zeromean option activated : rest the spatial mean computed above for each timeframe
  !           from the original variable, and output the result to zeromean.nc
  !           This replaces exactly the cdfzeromean tool
  !           The mean value which is used here is eventually computed on a reduced region
  IF ( lzeromean )  THEN
     DEALLOCATE ( zv, zmask, id_varout, ipk )
     npiglo = npiglo_fi ; npjglo = npjglo_fi
     ALLOCATE (zv(npiglo,npjglo), zmask(npiglo,npjglo) )

     ! re-read file and rest mean value from the variable and store on file
     nvars = getnvar(cf_in)
     ALLOCATE ( stypvarin(nvars), cv_names(nvars)    )
     ALLOCATE ( id_varout(nbasin), ipk(nbasin), stypvarzero(nbasin) )

     CALL CreateOutputZeromean

     ! Get the basin masks
     IF ( lbas ) THEN
        DO jbasin = 1, nbasin
           ibmask(jbasin,:,:) = getvar(cn_fbasins, cbasins(jbasin), 1, npiglo, npjglo)
        END DO
     ELSE
        ibmask(1,:,:) = 1
     ENDIF

     DO jt=1,npt
        DO jk = 1, nvpk
           ik = jk+ikmin-1
           zv   (:,:) = getvar(cf_in,   cv_nam,   ik, npiglo, npjglo, ktime=jt)
           zmask(:,:) = getvar(cn_fmsk, cv_msk, ik, npiglo, npjglo)
           DO jbasin = 1, nbasin
              zvzm(:,:) = (zv(:,:) - dvmeanout3d(jbasin,jt)) * zmask(:,:) * ibmask(jbasin,:,:)
              ierr = putvar(ncout, id_varout(jbasin), zvzm, ik, npiglo, npjglo, ktime=jt )
           END DO
        END DO
     END DO
     ierr=closeout(ncout              )
  ENDIF

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    INTEGER(KIND=4)   :: ivar   ! variable counter in id_varout
    CHARACTER(LEN=80) :: cl_suffix
    !!----------------------------------------------------------------------
    rdumlon(:,:) = 0.
    rdumlat(:,:) = 0.
    ivar = 0

    ierr=getvaratt (cf_in, cv_nam, clunits, zspval, cllong_name, clshort_name)

    ! define new variables for output 
    stypvar%cunits            = TRIM(clunits)
    stypvar%rmissing_value    = 99999.
    stypvar%valid_min         = -1000.
    stypvar%valid_max         = 1000.
    stypvar%scale_factor      = 1.
    stypvar%add_offset        = 0.
    stypvar%savelog10         = 0.
    stypvar%conline_operation = 'N/A'


    DO jbasin = 1,nbasin
       IF ( lbas )  THEN ; cl_suffix='_'//TRIM(cbasins(jbasin))
       ELSE              ; cl_suffix=''
       ENDIF
       ivar=ivar+1 ; n_mean(jbasin)=ivar
       ipk(n_mean(jbasin))            =  nvpk
       stypvar(n_mean(jbasin))%cname          = 'mean_'//TRIM(cv_nam)//TRIM(cl_suffix)
       stypvar(n_mean(jbasin))%clong_name     = 'mean_'//TRIM(cllong_name)//TRIM(cl_suffix)
       stypvar(n_mean(jbasin))%cshort_name    = 'mean_'//TRIM(clshort_name)//TRIM(cl_suffix)
       stypvar(n_mean(jbasin))%caxis          = 'ZT'

       ivar=ivar+1 ; n_mean3d(jbasin)=ivar
       ipk(n_mean3d(jbasin))            =  1
       stypvar(n_mean3d(jbasin))%cname          = 'mean_3D'//TRIM(cv_nam)//TRIM(cl_suffix)
       stypvar(n_mean3d(jbasin))%clong_name     = 'mean_3D'//TRIM(cllong_name)//TRIM(cl_suffix)
       stypvar(n_mean3d(jbasin))%cshort_name    = 'mean_3D'//TRIM(clshort_name)//TRIM(cl_suffix)
       stypvar(n_mean3d(jbasin))%caxis          = 'T'

       IF ( lvar) THEN
          ivar=ivar+1 ; n_var(jbasin)=ivar
          ipk(n_var(jbasin))            =  nvpk
          stypvar(n_var(jbasin))%cunits         = TRIM(clunits)//'^2'
          stypvar(n_var(jbasin))%cname          = 'var_'//TRIM(cv_nam)//TRIM(cl_suffix)
          stypvar(n_var(jbasin))%clong_name     = 'var_'//TRIM(cllong_name)//TRIM(cl_suffix)
          stypvar(n_var(jbasin))%cshort_name    = 'var_'//TRIM(clshort_name)//TRIM(cl_suffix)
          stypvar(n_var(jbasin))%caxis          = 'ZT'

          ivar=ivar+1 ; n_var3d(jbasin)=ivar
          ipk(n_var3d(jbasin))            =  1
          stypvar(n_var3d(jbasin))%cunits         = TRIM(clunits)//'^2'
          stypvar(n_var3d(jbasin))%cname          = 'var_3D'//TRIM(cv_nam)//TRIM(cl_suffix)
          stypvar(n_var3d(jbasin))%clong_name     = 'var_3D'//TRIM(cllong_name)//TRIM(cl_suffix)
          stypvar(n_var3d(jbasin))%cshort_name    = 'var_3D'//TRIM(clshort_name)//TRIM(cl_suffix)
          stypvar(n_var3d(jbasin))%caxis          = 'T'
       ENDIF
       IF ( lsum ) THEN
          ivar=ivar+1 ; n_sum(jbasin)=ivar
          ipk(n_sum(jbasin))            =  nvpk
          stypvar(n_sum(jbasin))%cunits         = TRIM(clunits)//'.m^3'
          stypvar(n_sum(jbasin))%cname          = 'sum_'//TRIM(cv_nam)//TRIM(cl_suffix)
          stypvar(n_sum(jbasin))%clong_name     = 'sum_'//TRIM(cllong_name)//TRIM(cl_suffix)
          stypvar(n_sum(jbasin))%cshort_name    = 'sum_'//TRIM(clshort_name)//TRIM(cl_suffix)
          stypvar(n_sum(jbasin))%caxis          = 'ZT'

          ivar=ivar+1 ; n_sum3d(jbasin)=ivar
          ipk(n_sum3d(jbasin))            =  1
          stypvar(n_sum3d(jbasin))%cunits         = TRIM(clunits)//'.m^3'
          stypvar(n_sum3d(jbasin))%cname          = 'sum_3D'//TRIM(cv_nam)//TRIM(cl_suffix)
          stypvar(n_sum3d(jbasin))%clong_name     = 'sum_3D'//TRIM(cllong_name)//TRIM(cl_suffix)
          stypvar(n_sum3d(jbasin))%cshort_name    = 'sum_3D'//TRIM(clshort_name)//TRIM(cl_suffix)
          stypvar(n_sum3d(jbasin))%caxis          = 'T'
       ENDIF
    ENDDO  ! basin loop

    ! create output fileset
    ncout = create      (cf_ncout,   'none',  ikx,   iky,   nvpk, cdep=cv_dep)
    ierr  = createvar   (ncout,      stypvar, nvars, ipk,   id_varout, cdglobal=TRIM(cglobal) )
    ierr  = putheadervar(ncout,      cf_in,  ikx, iky, npk, pnavlon=rdumlon, pnavlat=rdumlat, pdep=gdep(1:nvpk), cdep=cv_dep)
    dtim  = getvar1d(cf_in, cn_vtimec, npt  )
    ierr  = putvar1d(ncout,  dtim,  npt, 'T')


  END SUBROUTINE CreateOutput

  SUBROUTINE CreateOutputZeromean
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutputZeromean  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) for zeromean option
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    CHARACTER(LEN=80) :: cl_suffix
    cv_names(:) = getvarname(cf_in, nvars, stypvarin)

    ! look for the working variable
    DO jvar = 1, nvars
       IF ( TRIM(cv_names(jvar)) == TRIM(cv_nam) ) EXIT
    END DO
    ivar = jvar
    DO jbasin = 1, nbasin
       IF ( lbas ) THEN ; cl_suffix='_'//TRIM(cbasins(jbasin))
       ELSE             ; cl_suffix=''
       ENDIF

       ipk(jbasin)                           = nvpk
       stypvarzero(jbasin)%cname             = cv_nam//TRIM(cl_suffix)
       stypvarzero(jbasin)%cunits            = stypvarin(ivar)%cunits
       stypvarzero(jbasin)%rmissing_value    = stypvarin(ivar)%rmissing_value
       stypvarzero(jbasin)%valid_min         = stypvarin(ivar)%valid_min - MAXVAL(dvmeanout3d)
       stypvarzero(jbasin)%valid_max         = stypvarin(ivar)%valid_max - MINVAL(dvmeanout3d)
       stypvarzero(jbasin)%clong_name        = stypvarin(ivar)%clong_name//TRIM(cl_suffix)//' zero mean '
       stypvarzero(jbasin)%cshort_name       = cv_nam//TRIM(cl_suffix)
       stypvarzero(jbasin)%conline_operation = 'N/A'
       stypvarzero(jbasin)%caxis             = stypvarin(ivar)%caxis
    ENDDO

    ik=nvpk
    IF ( lnodep ) ik = 0  ! no depth variable in input file : the same in output file
    ncout = create      (cf_zerom, cf_in,        npiglo, npjglo, ik            )
    ierr  = createvar   (ncout ,   stypvarzero , nbasin, ipk,    id_varout     )
    ierr  = putheadervar(ncout,    cf_in,        npiglo, npjglo, ik , pdep=zdep)
    dtim  = getvar1d(cf_in, cn_vtimec, npt)
    ierr  = putvar1d(ncout, dtim,  npt,'T')

  END SUBROUTINE CreateOutputZeromean

  SUBROUTINE GetLstMask
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE GetLstMask  ***
    !!
    !! ** Purpose :  Fill in cbasins array from command line 
    !!
    !! ** Method  :  Blank separated list of names, check for '-' or last arg.
    !!----------------------------------------------------------------------
    INTEGER(KIND=4) :: iiarg
    LOGICAL         :: lchkv = .FALSE.
    !!----------------------------------------------------------------------
    iiarg=ijarg
    cldum='xxxx'
    DO WHILE ( cldum(1:1) /= '-' .AND. iiarg <= narg )
       CALL getarg( iiarg, cldum) ; iiarg=iiarg+1
    END DO
    nbasin=iiarg-ijarg-1
    ALLOCATE(cbasins(nbasin) )
    DO jbasin=1,nbasin
       CALL getarg( ijarg, cbasins(jbasin)) ; ijarg=ijarg+1
    END DO
    PRINT *, 'Basin File : ', TRIM(cn_fbasins)
    PRINT *, '  nbasin : ', nbasin
    DO jbasin = 1, nbasin
       PRINT *,'  basin ',jbasin,' : ',TRIM(cbasins(jbasin))
    END DO
    ! check if all cbasins are in cn_fbasins
    DO jbasin = 1, nbasin
       lchkv=lchkv .OR. chkvar(cn_fbasins,cbasins(jbasin))
    END DO
    IF ( lchkv ) STOP 99 ! missing variables.

  END SUBROUTINE GetLstMask


END PROGRAM cdfmean

PROGRAM cdf2levitusgrid3d
   !!======================================================================
   !!                     ***  PROGRAM  cdf2levitusgrid3d  ***
   !!=====================================================================
   !!  ** Purpose : remaps (bin) 2D high resolution (finer than 1x1 deg)
   !!               fields on Levitus 2D 1x1 deg grid
   !!
   !!  ** Method  : data surface averaging
   !!               It assumes that Levitus grid SW grid cell center 
   !!               is 0.5W,89.5S 
   !!
   !! History : 3.0  : 06/2012  : N. Ferry  : Original code
   !!----------------------------------------------------------------------
   USE cdfio
   USE modcdfnames
   USE cdftools
   USE modutils
   !!----------------------------------------------------------------------
   !! CDFTOOLS_3.0 , MEOM 2012
   !! $Id: cdf2levitusgrid3d.f90 652 2013-04-17 16:27:00Z molines $
   !! Copyright (c) 2012, J.-M. Molines
   !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
   !!----------------------------------------------------------------------
   IMPLICIT NONE

   INTEGER(KIND=4)                              :: ji, jj, jk, jt     ! dummy loop index
   INTEGER(KIND=4)                              :: jilev,jjlev        ! dummy loop index
   INTEGER(KIND=4)                              :: jvar               ! dummy loop index
   INTEGER(KIND=4)                              :: ii, ij             ! array index (not loop)
   INTEGER(KIND=4)                              :: iilev, ijlev       ! array index (not loop)
   INTEGER(KIND=4)                              :: icount             ! array index (not loop)
   INTEGER(KIND=4)                              :: npiglo, npjglo     ! size of the domain
   INTEGER(KIND=4)                              :: npk, npt           ! size of the domain
   INTEGER(KIND=4)                              :: npilev, npjlev     ! size of the Levitus domain
   INTEGER(KIND=4)                              :: narg, iargc, ijarg ! browse line
   INTEGER(KIND=4)                              :: ncout              ! ncid of output file
   INTEGER(KIND=4)                              :: ierr               ! error status
   INTEGER(KIND=4)                              :: nvars              ! number of variables in the input file
   INTEGER(KIND=4)                              :: iimin, iimax       ! IJ coordinates of the closest points
   INTEGER(KIND=4)                              :: ijmin, ijmax       ! "      "            "
   INTEGER(KIND=4)                              :: imethod=1          ! interpolation method
   INTEGER(KIND=4)                              :: iter_shap=3        ! number of Shapiro iteration
   INTEGER(KIND=4), DIMENSION(:),   ALLOCATABLE :: ipk, id_var        ! levels and varid's of input vars
   INTEGER(KIND=4), DIMENSION(:),   ALLOCATABLE :: ipkout, id_varout  ! levels and varid's of output vars

   REAL(KIND=4)                                 :: zradius=120.       ! Distance (km) for the search bubble (FHZ)
   REAL(KIND=4)                                 :: rlon1, rlon2, rlat1, rlat2, rpos
   REAL(KIND=4)                                 :: gphitmin
   REAL(KIND=4)                                 :: rlev_resol=0.33333333     ! degree
   REAL(KIND=4)                                 :: rlon0=-180         ! degree
   REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: e1t, e2t           ! horizontal T metrics
   REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: z_in               ! input field
   REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: z_fill             ! output 
   REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: glamt, gphit       ! T longitude latitude
   REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: rlonlev, rlatlev   ! Levitus grid longitude latitude
   REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: zbt
   REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: tmask              ! input mask
   REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: tmasklev           ! output mask
   REAL(KIND=4), DIMENSION(:),      ALLOCATABLE :: tim                ! time counter
   REAL(KIND=4), DIMENSION(:),      ALLOCATABLE :: gdept              ! depth axis

   REAL(KIND=8), DIMENSION(:,:),    ALLOCATABLE :: d_out, d_n         ! output field and weighting field

   CHARACTER(LEN=256)                           :: cdum               ! dummy char variable
   CHARACTER(LEN=256)                           :: cf_in              ! input file name
   CHARACTER(LEN=256)                           :: cf_out             ! output file name ( output)
   CHARACTER(LEN=256)                           :: cf_levitus_mask='levitus_mask.nc'   ! Levitus mask filename
   CHARACTER(LEN=256)                           :: cv_nam             ! variable name
   CHARACTER(LEN=256)                           :: cldum              ! dummy string
   CHARACTER(LEN=256)                           :: ctcalendar         ! time attributes
   CHARACTER(LEN=256)                           :: cttitle            ! time attributes
   CHARACTER(LEN=256)                           :: ctlong_name        ! time attributes
   CHARACTER(LEN=256)                           :: ctaxis             ! time attributes
   CHARACTER(LEN=256)                           :: ctunits            ! time attributes
   CHARACTER(LEN=256)                           :: cttime_origin      ! time attributes

   CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_names          ! array of var name
   CHARACTER(LEN=6)                              :: ctyp              ! 'fill' or 'smooth' for shapiro

   TYPE(variable), DIMENSION(:),   ALLOCATABLE  :: stypvar            ! input attributes
   TYPE(variable), DIMENSION(:),   ALLOCATABLE  :: stypvarout         ! output attributes

   LOGICAL                                      :: lchk               ! missing files flag
   LOGICAL                                      :: ltest
   LOGICAL                                      :: l360=.FALSE.       ! flag for 0-360 layout
   !!----------------------------------------------------------------------
   CALL ReadCdfNames()

   narg = iargc()
   IF ( narg == 0 ) THEN
      PRINT *,' usage : cdf2levitusgrid3d -f IN-file -o OUT-file  -v VAR-name3D [-360]'
      PRINT *,'        [-r resolution] '
      PRINT *,'      '
      PRINT *,'     PURPOSE :'
      PRINT *,'       remaps (bin) 3D high resolution (finer than 1x1 deg) '
      PRINT *,'       fields on a regular grid. (vertical grid as input grid)  '
      PRINT *,'       (does not work for vector fields)  '
      PRINT *,'       Resolution can be given as argument, default is ', rlev_resol,' deg.'
      PRINT *,'      '
      PRINT *,'     ARGUMENTS :'
      PRINT *,'       -f IN-file  : netcdf input file ' 
      PRINT *,'       -o OUT-file : netcdf output file ' 
      PRINT *,'       -v VAR-name2D : input variable name for interpolation '
      PRINT *,'      '
      PRINT *,'     OPTIONS :'
      PRINT *,'       -360 : outfile is defined from 0 to 360 deg'
      PRINT *,'              Default is from -180 to 180 '
      PRINT *,'       -r  : resolution.'
      PRINT *,'     '
      PRINT *,'     REQUIRED FILES :'
      PRINT *,'       ',TRIM(cn_fhgr)
      PRINT *,'       ',TRIM(cn_fmsk)
      PRINT *,'      '
      PRINT *,'     OUTPUT : '
      PRINT *,'       netcdf file : name given as second argument'
      PRINT *,'         variables : 3d_var_name'
      STOP
   ENDIF

   ijarg = 1
   DO WHILE ( ijarg <= narg ) 
     CALL getarg( ijarg, cdum)  ; ijarg = ijarg + 1
     SELECT CASE (cdum)
     CASE ( '-f' )
       CALL getarg(ijarg, cf_in)  ; ijarg = ijarg + 1
     CASE ( '-o' )
       CALL getarg(ijarg, cf_out) ; ijarg = ijarg + 1
     CASE ( '-v' )
       CALL getarg(ijarg, cv_nam) ; ijarg = ijarg + 1
     CASE ( '-360' )
       l360=.TRUE.
       rlon0 = 0.
     CASE ( '-r' )
       CALL getarg( ijarg, cdum)  ; ijarg = ijarg + 1
       READ(cdum,*) rlev_resol
     END SELECT
   ENDDO


   lchk = chkfile (cn_fhgr)
   lchk = chkfile (cn_fmsk)         .OR. lchk
   lchk = chkfile (cf_in)           .OR. lchk
   IF ( lchk ) STOP 99 ! missing files

   npiglo = getdim(cf_in,cn_x)
   npjglo = getdim(cf_in,cn_y)
   npk    = getdim(cf_in,cn_z)
   npt    = getdim(cf_in,cn_t)

   npilev = NINT(360./rlev_resol)
   npjlev = NINT(180./rlev_resol)

   nvars = getnvar(cf_in)
   ALLOCATE (cv_names(nvars) )
   ALLOCATE (stypvar(nvars)  , stypvarout(1))
   ALLOCATE (id_var(nvars), ipk(nvars), id_varout(1), ipkout(1))
   ALLOCATE (zbt(npiglo,npjglo) , z_in(npiglo,npjglo) )

   ! get list of variable names and collect attributes in stypvar (optional)
   cv_names(:) = getvarname(cf_in, nvars, stypvar)

   id_var(:)   = (/(jvar, jvar=1,nvars)/)

   ! ipk gives the number of level or 0 if not a T[Z]YX  variable
   ipk(:)     = getipk(cf_in, nvars)
   WHERE( ipk == 0 ) cv_names='none'
   stypvar(:)%cname = cv_names

   ! select variables to output:
   ii=1
   DO jk=1,nvars
      IF ( TRIM(cv_names(jk)) == TRIM(cv_nam) ) THEN
         ipkout(ii) = ipk(jk)
         stypvarout(ii) = stypvar(jk)
      ENDIF
   ENDDO

   ! Allocate the memory
   ALLOCATE ( e1t(npiglo,npjglo), e2t(npiglo,npjglo) )
   ALLOCATE ( glamt(npiglo,npjglo), gphit(npiglo,npjglo)  )

   ALLOCATE ( d_out(npilev,npjlev) , d_n(npilev,npjlev) )
   ALLOCATE ( tmask(npiglo,npjglo) , tmasklev(npilev,npjlev))
   ALLOCATE ( rlonlev(npilev,npjlev), rlatlev(npilev,npjlev) )
   ALLOCATE ( gdept(1), tim(npt) )

   ! Read the metrics from the mesh_hgr file
   e1t = getvar(cn_fhgr, cn_ve1t, 1, npiglo, npjglo)
   e2t = getvar(cn_fhgr, cn_ve2t, 1, npiglo, npjglo)

   ! and the coordinates   from the mesh_hgr file
   glamt = getvar(cn_fhgr, cn_glamt, 1, npiglo, npjglo)
   gphit = getvar(cn_fhgr, cn_gphit, 1, npiglo, npjglo)
   gphitmin = MINVAL(gphit(:,1))
   IF ( l360 ) THEN
     WHERE ( glamt < 0. )
       glamt = glamt + 360. 
     END WHERE
   ENDIF

   ! get the longitude,latitude,mask from the input Levitus mask file
   rlonlev(:,1) = (/ (rlon0+rlev_resol*ji , ji=1,npilev ) /)
   DO jj=2, npjlev
      rlonlev(:,jj) = rlonlev(:,1)
   ENDDO
   rlatlev(1,:) = (/ (rlev_resol*jj - 90.  , jj=1,npjlev ) /)
   DO ji=2, npilev
      rlatlev(ji,:) = rlatlev(1,:)
   ENDDO
!  rlonlev(:,:)  = getvar(cf_levitus_mask, 'nav_lon',  1, npilev, npjlev)
!  rlatlev(:,:)  = getvar(cf_levitus_mask, 'nav_lat' , 1, npilev, npjlev)
!  tmasklev(:,:) = getvar(cf_levitus_mask, 'mask',     1, npilev, npjlev)
   tmasklev(:,:) = 1.


   ! create output fileset
   ncout = create      (cf_out,  cf_in, npilev, npjlev, npk ,cdlonvar='lon', cdlatvar='lat'  )
   ierr  = createvar   (ncout ,  stypvarout, 1,      ipkout,    id_varout    )
   ierr  = putheadervar(ncout ,  cf_in, npilev, npjlev, npk , pnavlon=rlonlev, pnavlat=rlatlev )

   tim  = getvar1d(cf_in, cn_vtimec, npt     )
   ierr = putvar1d(ncout, tim,       npt, 'T')
   ierr = gettimeatt(cf_in, cn_vtimec, ctcalendar, cttitle, ctlong_name, ctaxis, ctunits, cttime_origin )
   ierr = puttimeatt(ncout, cn_vtimec, ctcalendar, cttitle, ctlong_name, ctaxis, ctunits, cttime_origin )
   ierr = putvar1d( ncout, rlonlev(:,1), npilev, 'X')
   ierr = putvar1d( ncout, rlatlev(1,:), npjlev, 'Y')

   zbt(:,:) = e1t(:,:) * e2t(:,:)    ! for surface weighting

   DO jt = 1, npt
      DO jk = 1, npk
      PRINT *,'jt = ', jt,' jk = ', jk
      ! get the tmask from the byte_mask file
      tmask(:,:) = getvar(cn_fmsk, 'tmask', jk, npiglo, npjglo)
      z_in (:,:) = getvar(cf_in, cv_nam, jk, npiglo, npjglo, ktime=jt)
      ! Compute spatial mean by bin
      !-----------------------------
      ! Perform bining of the input file on the Levitus grid.
      ! Input area weighted values are summed up into a Levitus 1x1 bin
      d_out(:,:) = 0.d0
      d_n  (:,:) = 0.d0
      DO jj=1,npjglo
         DO ji=1,npiglo
            iilev = MIN( npilev,  INT( (glamt(ji,jj)-rlon0)/rlev_resol ) + 1)
            ijlev = MIN (npjlev , INT( (gphit(ji,jj)+ 90.)/rlev_resol ) + 1)
            !IF ( iilev < 1 .OR. iilev .GT. 360 ) print*, 'iilev, glamt = ',iilev,glamt(ji,jj)
            !IF ( ijlev < 1 .OR. ijlev .GT. 180 ) print*, 'ijlev, gphit = ',ijlev,gphit(ji,jj)
            IF ( z_in(ji,jj) /=  stypvarout(1)%rmissing_value ) THEN
               d_out(iilev,ijlev) = d_out(iilev,ijlev) + (z_in(ji,jj)*tmask(ji,jj))*zbt(ji,jj)*tmasklev(iilev,ijlev)*1.d0
               d_n  (iilev,ijlev) = d_n (iilev,ijlev)  +              tmask(ji,jj) *zbt(ji,jj)*tmasklev(iilev,ijlev)*1.d0
            ENDIF
         ENDDO
      ENDDO

      WHERE ( d_n > 0. )
         d_out = d_out / d_n 
      ELSEWHERE
         d_out = stypvarout(1)%rmissing_value 
      END WHERE

      ! Check if there are points with missing values on Levitus grid
      icount= COUNT( d_out == stypvarout(1)%rmissing_value .AND. tmasklev == 1. )
      IF ( icount /=  0. ) THEN
         ALLOCATE ( z_fill(npilev,npjlev) )
         z_fill(:,:) = 0.
         !
         imethod = 0
         SELECT CASE (imethod)
         CASE ( 0 ) 
              PRINT *, 'no filling, even if required for ',icount
         CASE ( 1 ) ! Method 1: fill missing data with shapiro
            ctyp='fill'
            iter_shap = 3  ! number of shapiro iteration
            CALL shapiro_fill_smooth ( REAL(d_out), npilev, npjlev, iter_shap, ctyp,         &
                                       stypvarout(1)%rmissing_value, INT(tmasklev), z_fill )

            DO jjlev = 1 , npjlev
               DO jilev = 1 , npilev
                  IF ( z_fill(jilev,jjlev) .NE. stypvarout(1)%rmissing_value  &
                       &                  .AND. tmasklev(jilev,jjlev) == 1    &
                       &                  .AND. d_out(jilev,jjlev) == stypvarout(1)%rmissing_value ) &
                       &  d_out(jilev,jjlev) = z_fill(jilev,jjlev)
               ENDDO
            ENDDO

         CASE ( 2 ) ! Method 2: compute with influence bubble
            ! For each point of Levitus grid, a data screening is performed 
            ! in a influence bubble of radius zradius, centered on Levitus point
            ! and the weighted average of the data in the bubble is computed
            z_fill(:,:) = 0.
            DO jjlev = 1 , npjlev-1
               DO jilev = 1 , npilev
                  ierr = 0
                  IF (  tmasklev(jilev,jjlev) == 1 .AND. d_out(jilev,jjlev) == stypvarout(1)%rmissing_value ) THEN 
                     ! for the South pole, no treatment performed if data too far from southern most orca points
                     CALL btoe(rlonlev(jilev,jjlev),rlatlev(jilev,jjlev),rlon1,rlat1,-1.2*zradius,-1.2*zradius)
                     IF ( rlat1 > gphitmin ) THEN
                        ! Search the closest point of ORCA grid for this Levitus point
                        CALL cdf_findij (rlonlev(jilev,jjlev), rlonlev(jilev,jjlev), rlatlev(jilev,jjlev), rlatlev(jilev,jjlev), &
                             &         iimin, iimax, ijmin, ijmax,cd_coord=cn_fhgr,cd_point='T',  cd_verbose='N')

                        ! Next valid grid point going northward on ORCA grid
                        ltest = .TRUE. ; ij = ijmin ; ii =  iimin
                        DO WHILE ( ij <= npjglo .AND. ltest .AND. &
                             & etobd(rlonlev(jilev,jjlev),rlatlev(jilev,jjlev),glamt(ii,ij), gphit(ii,ij)) <= zradius )
                           IF ( tmask(ii,ij) == 1 ) THEN
                              ltest = .FALSE.
                              z_fill(jilev,jjlev) = z_fill(jilev,jjlev) + &
                                   &(z_in(ii,ij)*tmask(ii,ij))*zbt(ii,ij)*tmasklev(jilev,jjlev)
                              d_n  (jilev,jjlev) = d_n (jilev,jjlev)  + &
                                   & tmask(ii,ij) *zbt(ii,ij)*tmasklev(jilev,jjlev)
                              ierr = ierr + 1
                           ENDIF
                           ij = ij + 1
                        END DO
                        ! Next valid grid point going southward on ORCA grid
                        ltest = .TRUE. ; ij = ijmin-1 ; ii =  iimin
                        DO WHILE ( ij >= 1 .AND. ltest .AND. &
                             & etobd(rlonlev(jilev,jjlev),rlatlev(jilev,jjlev),glamt(ii,ij), gphit(ii,ij)) <= zradius ) 
                           IF ( tmask(ii,ij) == 1 ) THEN
                              ltest = .FALSE.
                              z_fill(jilev,jjlev) = z_fill(jilev,jjlev) + &
                                   & (z_in(ii,ij)*tmask(ii,ij))*zbt(ii,ij)*tmasklev(jilev,jjlev)
                              d_n  (jilev,jjlev) = d_n (jilev,jjlev)  +  &
                                   & tmask(ii,ij) *zbt(ii,ij)*tmasklev(jilev,jjlev)
                              ierr = ierr + 1
                           ENDIF
                           ij = ij - 1
                        END DO
                        ! Next valid grid point going westward on ORCA grid
                        ltest = .TRUE. ; ij = ijmin ; ii =  iimin+1 ; IF ( ii > npiglo ) ii = ii - npiglo
                        DO WHILE ( ltest .AND. &
                             & etobd(rlonlev(jilev,jjlev),rlatlev(jilev,jjlev),glamt(ii,ij), gphit(ii,ij)) <= zradius ) 
                           IF ( tmask(ii,ij) == 1 ) THEN
                              ltest = .FALSE.
                              z_fill(jilev,jjlev) = z_fill(jilev,jjlev) + &
                                   & (z_in(ii,ij)*tmask(ii,ij))*zbt(ii,ij)*tmasklev(jilev,jjlev) 
                              d_n  (jilev,jjlev) = d_n (jilev,jjlev)  + &
                                   & tmask(ii,ij) *zbt(ii,ij)*tmasklev(jilev,jjlev)
                              ierr = ierr + 1
                           ENDIF
                           ii = ii + 1
                           IF ( ii > npiglo ) ii = ii - npiglo
                        END DO
                        ! Next valid grid point going eastward on ORCA grid
                        ltest = .TRUE. ; ij = ijmin ; ii =  iimin-1 ; IF ( ii < 1) ii = ii + npiglo
                        DO WHILE ( ltest .AND. &
                             & etobd(rlonlev(jilev,jjlev),rlatlev(jilev,jjlev),glamt(ii,ij), gphit(ii,ij)) <= zradius ) 
                           IF ( tmask(ii,ij) == 1 ) THEN
                              ltest = .FALSE.
                              z_fill(jilev,jjlev) = z_fill(jilev,jjlev) + &
                                   & (z_in(ii,ij)*tmask(ii,ij))*zbt(ii,ij)*tmasklev(jilev,jjlev) 
                              d_n  (jilev,jjlev) = d_n (jilev,jjlev)  + &
                                   & tmask(ii,ij) *zbt(ii,ij)*tmasklev(jilev,jjlev)
                              ierr = ierr + 1
                           ENDIF
                           ii = ii - 1
                           IF ( ii < 1 ) ii = ii + npiglo
                        END DO

                        ! computing d_out value
                        IF ( z_fill(jilev,jjlev) .NE. stypvarout(1)%rmissing_value &
                             & .AND. d_n(jilev,jjlev) > 0 &
                             & .AND. d_out(jilev,jjlev) == stypvarout(1)%rmissing_value ) &
                             &  d_out(jilev,jjlev) = z_fill(jilev,jjlev) / d_n(jilev,jjlev)

                     ENDIF ! rlat1 > gphitmin

                  ENDIF ! tmasklev(jilev,jjlev) == 1 .AND. d_out(jilev,jjlev) == stypvarout(1)%rmissing_value

               ENDDO
            ENDDO

            ! Case of the North Pole
            ijlev = npjlev
            DO jilev = 1 , npilev
               ierr = 0

               IF (  tmasklev(jilev,ijlev) == 1 .AND. d_out(jilev,ijlev) == stypvarout(1)%rmissing_value ) THEN

                  ! Search the closest point of ORCA grid for this Levitus point
                  CALL cdf_findij (rlonlev(jilev,ijlev), rlonlev(jilev,ijlev), rlatlev(jilev,ijlev), rlatlev(jilev,ijlev), &
                       & iimin, iimax, ijmin, ijmax,cd_coord=cn_fhgr,cd_point='T', cd_verbose='N')

                  ! Next valid grid point going southward on ORCA grid
                  ltest = .TRUE. ; ij = ijmin ; ii =  iimin
                  DO WHILE ( ij >= 1 .AND. ltest .AND. &
                       & etobd(rlonlev(jilev,ijlev),rlatlev(jilev,ijlev),glamt(ii,ij), gphit(ii,ij)) <= zradius ) 
                     IF ( tmask(ii,ij) == 1 ) THEN
                        ltest = .FALSE.
                        z_fill(jilev,ijlev) = z_fill(jilev,ijlev) + &
                             & (z_in(ii,ij)*tmask(ii,ij))*zbt(ii,ij)*tmasklev(jilev,ijlev) 
                        d_n  (jilev,ijlev) = d_n (jilev,ijlev)  +  &
                             & tmask(ii,ij) *zbt(ii,ij)*tmasklev(jilev,ijlev)
                        ierr = ierr + 1
                     ENDIF
                     ij = ij - 1
                  END DO
                  ! Next valid grid point going westward on ORCA grid
                  ltest = .TRUE. ; ij = ijmin ; ii =  iimin+1 ; IF ( ii > npiglo) ii = ii - npiglo
                  DO WHILE ( ltest .AND. &
                       & etobd(rlonlev(jilev,ijlev),rlatlev(jilev,ijlev),glamt(ii,ij), gphit(ii,ij)) <= zradius ) 
                     IF ( tmask(ii,ij) == 1 ) THEN
                        ltest = .FALSE.
                        z_fill(jilev,ijlev) = z_fill(jilev,ijlev) + &
                             & (z_in(ii,ij)*tmask(ii,ij))*zbt(ii,ij)*tmasklev(jilev,ijlev) 
                        d_n  (jilev,ijlev) = d_n (jilev,ijlev)  + &
                             & tmask(ii,ij) *zbt(ii,ij)*tmasklev(jilev,ijlev)
                        ierr = ierr + 1
                     ENDIF
                     ii = ii + 1
                     IF ( ii > npiglo ) ii = ii - npiglo
                  END DO
                  ! Next valid grid point going eastward on ORCA grid
                  ltest = .TRUE. ; ij = ijmin ; ii =  iimin-1 ; IF ( ii < 1 ) ii = ii + npiglo
                  DO WHILE ( ltest .AND. &
                       & etobd(rlonlev(jilev,ijlev),rlatlev(jilev,ijlev),glamt(ii,ij), gphit(ii,ij)) <= zradius ) 
                     IF ( tmask(ii,ij) == 1 ) THEN
                        ltest = .FALSE.
                        z_fill(jilev,ijlev) = z_fill(jilev,ijlev) + &
                             & (z_in(ii,ij)*tmask(ji,ij))*zbt(ii,ij)*tmasklev(jilev,ijlev) 
                        d_n  (jilev,ijlev) = d_n (jilev,ijlev)  + &
                             & tmask(ii,ij) *zbt(ii,ij)*tmasklev(jilev,ijlev)
                        ierr = ierr + 1
                     ENDIF
                     ii = ii - 1 ;  IF ( ii < 1 ) ii = ii + npiglo
                  END DO
                  ! Going "northward" and crossing the pole
                  ltest = .TRUE.
                  rpos = 1.
                  ij = ijmin + 1 * rpos ; ii =  iimin
                  IF ( ij > npjglo ) THEN
                     ii = ii + npiglo/2 ; IF ( ii > npiglo ) ii = ii - npiglo
                     rpos = -1.
                     ij = ij + 1 * rpos
                  ENDIF
                  DO WHILE ( ij >= 1 .AND. ltest .AND. &
                       & etobd(rlonlev(jilev,ijlev),rlatlev(jilev,ijlev),glamt(ii,ij), gphit(ii,ij)) <= zradius )
                     IF ( tmask(ii,ij) == 1 ) THEN
                        ltest = .FALSE.
                        z_fill(jilev,ijlev) = z_fill(jilev,ijlev) + &
                             &(z_in(ii,ij)*tmask(ii,ij))*zbt(ii,ij)*tmasklev(jilev,ijlev) 
                        d_n  (jilev,ijlev) = d_n (jilev,ijlev)  + &
                             & tmask(ii,ij) *zbt(ii,ij)*tmasklev(jilev,ijlev)
                        ierr = ierr + 1
                     ENDIF
                     ij = ij + 1 * rpos
                     IF ( ij > npjglo ) THEN
                        ii = ii + npiglo/2 ; IF ( ii > npiglo ) ii = ii - npiglo
                        rpos = -1.
                        ij = ij + 1 * rpos
                     ENDIF
                  END DO

                  ! computing d_out value
                  IF ( z_fill(jilev,ijlev) .NE. stypvarout(1)%rmissing_value  &
                       & .AND. d_n(jilev,ijlev) > 0  ) &
                       &  d_out(jilev,ijlev) = z_fill(jilev,ijlev) / d_n(jilev,ijlev)

               ENDIF

            ENDDO


         CASE DEFAULT 
            PRINT *, ' METHOD ', imethod ,'is not recognized in this program'
            STOP 99

         END SELECT  ! imethod
         IF ( ALLOCATED(z_fill) ) DEALLOCATE( z_fill )

      ENDIF !  filling points
      ! ----------------------------------------------------------------------------------------
      ! write 
      ierr = putvar(ncout, id_varout(1), REAL(d_out(:,:)), jk, npilev, npjlev, ktime=jt)
     ENDDO ! jk

   END DO ! loop on time

   ierr = closeout(ncout)

CONTAINS

   REAL(KIND=4) FUNCTION etobd(plonr, platr, plon, plat)
      !!---------------------------------------------------------------------
      !!                  ***  FUNCTION etobd  ***
      !!
      !! ** Purpose :
      !!           Compute the beta plane distance between two lon/lat values 
      !!
      !! ** Method  : 
      !!           Return the distance (km) between 2 points given in the
      !!           arguments with their latitudes and longitudes
      !!----------------------------------------------------------------------
      REAL(KIND=4), INTENT(in) :: plonr, platr, plon, plat  ! lon/lat of the 2 input points

      REAL(KIND=8), PARAMETER  :: dp_p1 = 1.745329D-02  ! radians per degree
      REAL(KIND=8), PARAMETER  :: dp_p2 = 111.1940D0    ! dp_p1 * earth radius in km (6370.949)

      REAL(KIND=8)             :: dl_rx, dl_ry          ! working double prec variables
      REAL(KIND=8)             :: dl_r0
      REAL(KIND=8)             :: dl_r1, dl_r2
      !!----------------------------------------------------------------------
      dl_r0 = DBLE(plonr) ; IF ( dl_r0 < 0.d0 ) dl_r0 = dl_r0 + 360.d0
      dl_r1 = DBLE(plon ) ; IF ( dl_r1 < 0.d0 ) dl_r1 = dl_r1 + 360.d0

      dl_rx = dl_r1 - dl_r0
      IF ( dl_rx > 180. ) THEN
         dl_rx = dl_rx - 360.d0
      ELSE IF ( dl_rx < -180.d0 ) THEN
         dl_rx = dl_rx + 360.d0
      ELSE IF ( ABS(dl_rx) == 180.d0 ) THEN
         dl_rx = 180.d0
      ENDIF
      dl_r2 = DBLE(plat) - DBLE(platr)

      dl_rx = dp_p2 * dl_rx * COS(dp_p1*platr)
      dl_ry = dp_p2 * dl_r2

      etobd = REAL(SQRT(dl_rx*dl_rx + dl_ry*dl_ry))

   END FUNCTION etobd


   SUBROUTINE btoe(plonr, platr, plon, plat, plx, ply)
     !!---------------------------------------------------------------------
     !!                  ***  ROUTINE btoe  ***
     !!
     !! ** Purpose :  Return position (lon/lat) of a point located at
     !!               a given distance from the original point
     !!
     !! ** Method  :  Trigo ... 
     !!
     !!----------------------------------------------------------------------
     REAL(KIND=4), INTENT(in)  :: plonr, platr, plx, ply
     REAL(KIND=4), INTENT(out) :: plon, plat

     REAL(KIND=8), PARAMETER   :: dp_p1= 1.745329D-02  ! radians per degree
     REAL(KIND=8), PARAMETER   :: dp_p2= 111.1940D0    ! dp_p1 * earth radius in km (6370.949)
     REAL(KIND=8)              :: dl_rx, dl_ry
     REAL(KIND=8)              :: dl_r0
     REAL(KIND=8)              :: dl_r1, dl_r2, dl_r3
     !!----------------------------------------------------------------------
      dl_r0 = DBLE(plonr) ; IF ( dl_r0 < 0.d0 ) dl_r0 = dl_r0 + 360.d0
      dl_rx = DBLE(plx  )
      dl_r2 = DBLE(platr)
      dl_r1 = dl_r0 + dl_rx / ( dp_p2 * COS(dp_p1*dl_r2) )
      dl_r3 = dl_r2 + ply   / dp_p2
      plon  = REAL(dl_r1)
      IF ( plon <    0. ) plon = plon + 360.
      IF ( plon >= 360. ) plon = plon - 360.
      plat = REAL(dl_r3)
      IF ( plat >  90. ) plat =  90.
      IF ( plat < -90. ) plat = -90.

   END SUBROUTINE btoe

END PROGRAM cdf2levitusgrid3d

PROGRAM cdfvertmean
  !!======================================================================
  !!                     ***  PROGRAM  cdfvertmean  ***
  !!=====================================================================
  !!  ** Purpose : Compute the vertical average of a scalar quantity
  !!               between 2 z layers. Can handle full step configuration
  !!               using the -full option.
  !!
  !!  ** Method  : compute the sum ( V  * e1 *e2 * e3 *mask )
  !!
  !! History : 2.1  : 11/2008  : J.M. Molines : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  USE modutils
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                               :: jk, jvar, jt        ! dummy loop index
  INTEGER(KIND=4)                               :: ik1, ik2            ! vertical limit of integration
  INTEGER(KIND=4)                               :: narg, iargc         ! command line 
  INTEGER(KIND=4)                               :: ijarg, ireq         ! command line 
  INTEGER(KIND=4)                               :: npiglo, npjglo      ! size of the domain
  INTEGER(KIND=4)                               :: npk, npt            ! size of the domain,
  INTEGER(KIND=4)                               :: nvars, ivar         ! variables in input
  INTEGER(KIND=4)                               :: ncout, ierr         ! ncid and error status
  INTEGER(KIND=4), DIMENSION(1)                 :: ipk, id_varout      ! levels and varid's of output vars

  REAL(KIND=4)                                  :: rdep_up             ! upper level of integration
  REAL(KIND=4)                                  :: rdep_down           ! lower level of integration
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: e3                  ! metrics
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: zv                  ! working variable
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: hdep                ! depth of the levels
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: zmask               ! mask
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: gdep                ! vertical levels
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: e31d                ! vertical metric full
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: tim                 ! time counter
  REAL(KIND=4), DIMENSION(1)                    :: rdep                ! dummy depth output

  REAL(KIND=8)                                  :: dvol                ! total volume
  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: dvol2d              ! layer volume
  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: dvertmean           ! value of integral

  CHARACTER(LEN=256)                            :: cf_in               ! input file name
  CHARACTER(LEN=256)                            :: cf_out='vertmean.nc'! output file
  CHARACTER(LEN=256)                            :: cv_in               ! variable name
  CHARACTER(LEN=256)                            :: cv_out='sovertmean' ! variable name
  CHARACTER(LEN=256)                            :: cv_dep              ! depth name
  CHARACTER(LEN=256)                            :: cv_e3               ! vertical metric name (partial)
  CHARACTER(LEN=256)                            :: cv_e31d             ! vertical metric name (full)
  CHARACTER(LEN=256)                            :: cv_msk              ! mask variable name
  CHARACTER(LEN=256)                            :: ctype='T'           ! position of the variable
  CHARACTER(LEN=256)                            :: cglobal             ! global attribute
  CHARACTER(LEN=256)                            :: cldum               ! dummy string
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_names            ! name of input variables
 
  TYPE(variable), DIMENSION(:), ALLOCATABLE     :: stypvarin           ! stucture for attributes (input)
  TYPE(variable), DIMENSION(1)                  :: stypvar             ! stucture for attributes (output)

  LOGICAL                                       :: lfull=.FALSE.       ! full step flag
  LOGICAL                                       :: lchk                ! file existence flag (true if missing)
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage :  cdfvertmean IN-file IN-var v-type dep1 dep2 [-full]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the vertical mean between dep1 and dep2 given in m,'
     PRINT *,'       for variable IN-var in the input file.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       IN-file  : netcdf input file.' 
     PRINT *,'       IN-var   : netcdf input variable.'
     PRINT *,'       v-type   : one of T U V W indicating position of variable on C-grid'
     PRINT *,'       dep1 dep2 : depths limit for vertical integration (meters). '
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-full ] : for full step configurations. Default is partial step.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ', TRIM(cn_fzgr),' and ',TRIM(cn_fmsk)
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : ', TRIM(cv_out),' (same units as input variable)'
     PRINT *,'      '
     STOP
  ENDIF

  ijarg = 1 ; ireq=0
  DO WHILE ( ijarg <= narg ) 
    CALL getarg (ijarg, cldum ) ; ijarg = ijarg + 1
    SELECT CASE ( cldum )
    CASE ( '-full' ) ; lfull = .TRUE.
    CASE DEFAULT
       ireq=ireq+1
       SELECT CASE ( ireq )
       CASE ( 1 ) ; cf_in=cldum
       CASE ( 2 ) ; cv_in=cldum
       CASE ( 3 ) ; ctype=cldum
       CASE ( 4 ) ; READ(cldum,*) rdep_up
       CASE ( 5 ) ; READ(cldum,*) rdep_down
       CASE DEFAULT
          PRINT *,' Too many arguments ...' ; STOP
       END SELECT
    END SELECT
  ENDDO

  lchk = chkfile (cn_fzgr)
  lchk = chkfile (cn_fmsk) .OR. lchk
  lchk = chkfile (cf_in  ) .OR. lchk
  IF ( lchk ) STOP ! missing files

  CALL SetGlobalAtt (cglobal)

  IF (rdep_down < rdep_up ) THEN
     PRINT *,'Give depth limits in increasing order !'
     STOP
  ENDIF

  npiglo = getdim (cf_in,cn_x)
  npjglo = getdim (cf_in,cn_y)
  npk    = getdim (cf_in,cn_z)
  npt    = getdim (cf_in,cn_t)

  nvars       = getnvar(cf_in)
  ALLOCATE( cv_names(nvars), stypvarin(nvars) )
  cv_names(:) = getvarname(cf_in, nvars, stypvarin)
  ivar=1
  DO jvar=1,nvars
     IF ( TRIM(cv_names(jvar)) == TRIM(cv_in) ) THEN
        EXIT
     ENDIF
     ivar=ivar+1
  ENDDO

  IF ( ivar == nvars+1 ) THEN
     PRINT *,' Variable ',TRIM(cv_in),' not found in ', TRIM(cf_in)
     STOP
  ENDIF

  rdep(1)                      = 0.
  ipk(:)                       = 1
  stypvar(1)%cname             = cv_out
  stypvar(1)%cunits            = stypvarin(ivar)%cunits
  stypvar(1)%rmissing_value    = stypvarin(ivar)%rmissing_value
  stypvar(1)%valid_min         = stypvarin(ivar)%valid_min
  stypvar(1)%valid_max         = stypvarin(ivar)%valid_max
  stypvar(1)%clong_name        = 'vertical average of '//TRIM(stypvarin(ivar)%clong_name)
  stypvar(1)%cshort_name       = cv_out
  stypvar(1)%conline_operation = 'N/A'
  stypvar(1)%caxis             = 'TYX'

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  ! Allocate arrays
  ALLOCATE ( zmask(npiglo,npjglo), dvertmean(npiglo, npjglo) )
  ALLOCATE ( zv(npiglo,npjglo), hdep(npiglo,npjglo)          )
  ALLOCATE ( e3(npiglo,npjglo), dvol2d(npiglo,npjglo)        )
  ALLOCATE ( gdep(npk), tim(npt)                             )

  IF ( lfull ) ALLOCATE ( e31d(npk) )

  ! Initialize output file
  ncout = create      (cf_out, cf_in,   npiglo, npjglo, 1)
  ierr  = createvar   (ncout,  stypvar, 1,      ipk,    id_varout, cdglobal=cglobal  )
  ierr  = putheadervar(ncout,  cf_in,   npiglo, npjglo, 1, pdep=rdep)

  tim  = getvar1d(cf_in, cn_vtimec, npt     )
  ierr = putvar1d(ncout, tim,       npt, 'T')

  SELECT CASE ( ctype)
  CASE( 'T','U','V','t','u','v');  cv_dep=cn_gdepw ; cv_e3='e3t_ps' ; cv_e31d=cn_ve3t 
  CASE( 'W' ,'w')               ;  cv_dep=cn_gdept ; cv_e3='e3w_ps' ; cv_e31d=cn_ve3w
  CASE DEFAULT ; PRINT *,'Point type ', TRIM(ctype),' not known! ' ; STOP
  END SELECT

               gdep(:) = getvare3(cn_fzgr, cv_dep,  npk)
  IF ( lfull ) e31d(:) = getvare3(cn_fzgr, cv_e31d, npk)

  ! set mask variable name
  SELECT CASE (ctype )
  CASE ('T','t','W','w') ; cv_msk='tmask'
  CASE ('U','u')         ; cv_msk='umask'
  CASE ('V','v')         ; cv_msk='vmask'
  END SELECT

  ! Look for ik1 and ik2 as nearest level of rdep_up and rdep_down
  ik1 = 1; ik2 = npk
  DO jk=1,npk
     IF ( gdep(jk) <= rdep_up   ) ik1 = jk
     IF ( gdep(jk) <= rdep_down ) ik2 = jk
  ENDDO

  PRINT '(a,2f8.3)', 'depth limit of integration : ', rdep_up, rdep_down
  PRINT '(a,2i8  )', 'nearest level found        : ', ik1,     ik2
  PRINT '(a,2f8.3)', 'corresponding depth        : ', gdep(ik1), gdep(ik2+1)

  DO jt=1,npt
     dvol           = 0.d0
     dvol2d(:,:)    = 0.d0
     dvertmean(:,:) = 0.d0

     DO jk = ik1, ik2
        ! Get values at jk
        zv(   :,:) = getvar(cf_in,   cv_in,  jk, npiglo, npjglo, ktime=jt)
        zmask(:,:) = getvar(cn_fmsk, cv_msk, jk, npiglo, npjglo          )

        ! get e3 at level jk ( ps...)
        IF ( lfull ) THEN ; e3(:,:) = e31d(jk)
        ELSE              ; e3(:,:) = getvar(cn_fzgr, cv_e3, jk, npiglo, npjglo, ldiom=.TRUE.)
        ENDIF

        IF ( jk == ik1 ) THEN
           hdep(:,:) = gdep(jk) + e3(:,:)
           e3(  :,:) = MIN(e3, hdep -rdep_up          )
        ENDIF

        IF ( jk == ik2 ) THEN
           e3(  :,:) = MIN(e3, (rdep_down) - gdep(jk) )
        ENDIF

        dvol       = SUM( DBLE(e3 * zmask) )
        dvol2d     =      e3 * zmask * 1.d0  + dvol2d
        dvertmean  = zv * e3 * zmask * 1.d0  + dvertmean

        IF (dvol == 0 )THEN
                  ! no more layer below !    
           EXIT   ! get out of the jk loop
        ENDIF
     END DO

     ! Output to netcdf file 
     WHERE ( dvol2d /= 0 )  dvertmean = dvertmean/dvol2d
     ierr = putvar(ncout, id_varout(1), REAL(dvertmean), 1, npiglo, npjglo, ktime=jt)
  END DO  ! loop on time

  ierr = closeout(ncout)

END PROGRAM cdfvertmean

PROGRAM cdfpendep
  !!======================================================================
  !!                     ***  PROGRAM  cdfpendep  ***
  !!=====================================================================
  !!  ** Purpose : Compute penetration depth for passive tracer output. 
  !!               This is the ratio between inventory and surface 
  !!               concentration.
  !!
  !!  ** Method  : takes TRC files as input
  !!
  !! History : 2.1  : 02/2008  : J.M. Molines : Original code
  !!         : 2.1  : 09/2010  : C. Dufour    : Adapation to TOP evolution
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio 
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class passive_tracer
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: jt                   ! dummy loop index
  INTEGER(KIND=4)                           :: narg, iargc, ijarg   ! browse command line
  INTEGER(KIND=4)                           :: npiglo, npjglo       ! size of the domain
  INTEGER(KIND=4)                           :: npk, npt             ! size of the domain
  INTEGER(KIND=4)                           :: ncout                ! ncid of output file
  INTEGER(KIND=4)                           :: ierr                 ! error status
  INTEGER(KIND=4), DIMENSION(1)             :: ipk, id_varout       ! levels and varid's of output vats

  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: trcinv, trcsurf      ! inventory, surface concentration
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: rpendep              ! penetration depth

  REAL(KIND=8), DIMENSION(:),   ALLOCATABLE :: dtim                 ! time counter

  CHARACTER(LEN=256)                        :: cf_trcfil            ! tracer file name
  CHARACTER(LEN=256)                        :: cf_inv               ! inventory file name
  CHARACTER(LEN=256)                        :: cf_out='pendep.nc'   ! output file
  CHARACTER(LEN=256)                        :: cv_inv               ! inventory variable name
  CHARACTER(LEN=256)                        :: cv_trc               ! tracer variable name
  CHARACTER(LEN=256)                        :: cglobal              ! global attribute
  CHARACTER(LEN=256)                        :: cldum                ! dummy string

  TYPE(variable), DIMENSION(1)              :: stypvar              ! structure for attributes

  LOGICAL                                   :: lnc4 = .FALSE.       ! Use nc4 with chunking and deflation
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  cv_inv = cn_invcfc
  cv_trc = cn_cfc11
  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage :  cdfpendep -trc TRC-file -i INV-file [-o OUT-file] [-nc4] ...'
     PRINT *,'              ... [-vinv inventory_name -vtrc trc_name ]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'        Compute the penetration depth for passive tracers. It is the ratio'
     PRINT *,'        between the inventory and the surface concentration of the tracer.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -trc TRC-file : netcdf file with tracer concentration.' 
     PRINT *,'       -i INV-file   : netcdf file with inventory of the tracer.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-vinv inventory_name ] : specify netcdf variable name for inventory.' 
     PRINT *,'                                Default is ', TRIM(cv_inv)
     PRINT *,'       [-vtrc trc_name   ]    : specify netcdf variable name for tracer.' 
     PRINT *,'                                Default is ', TRIM(cv_trc)
     PRINT *,'       [-o OUT-file ] : specify output file name instead of ', TRIM(cf_out)
     PRINT *,'       [ -nc4 ]     : Use netcdf4 output with chunking and deflation level 1.'
     PRINT *,'                 This option is effective only if cdftools are compiled with'
     PRINT *,'                 a netcdf library supporting chunking and deflation.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        none'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : pendep (m)'
     PRINT *,'      '
     STOP 
  ENDIF

  ijarg = 1
  DO WHILE ( ijarg <= narg)
     CALL getarg(ijarg, cldum ) ; ijarg = ijarg + 1 
     SELECT CASE ( cldum )
     CASE ('-trc' ) ;  CALL getarg(ijarg, cf_trcfil) ; ijarg=ijarg+1
     CASE ('-i'   ) ;  CALL getarg(ijarg, cf_inv   ) ; ijarg=ijarg+1
        ! options
     CASE ('-o'   ) ;  CALL getarg(ijarg, cf_out   ) ; ijarg=ijarg+1
     CASE ('-vinv') ;  CALL getarg(ijarg, cv_inv   ) ; ijarg=ijarg+1
     CASE ('-vtrc') ;  CALL getarg(ijarg, cv_trc   ) ; ijarg=ijarg+1
     CASE ('-nc4' ) ;  lnc4 = .TRUE.
     CASE DEFAULT  ; PRINT *, ' ERROR : ', TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  END DO

  IF ( chkfile(cf_trcfil) .OR. chkfile(cf_inv) ) STOP 99 ! missing file

  npiglo = getdim (cf_trcfil,cn_x)
  npjglo = getdim (cf_trcfil,cn_y)
  npk    = getdim (cf_trcfil,cn_z)
  npt    = getdim (cf_trcfil,cn_t)

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  ALLOCATE( trcinv(npiglo,npjglo), trcsurf(npiglo,npjglo), rpendep(npiglo,npjglo) )
  ALLOCATE( dtim(npt) )

  WRITE(cglobal,9000) TRIM(cf_trcfil), TRIM(cf_inv), TRIM(cv_inv), TRIM(cv_trc)
9000 FORMAT('cdfpendep ',a,' ',a,' -inv ',a,' -trc ',a )

  CALL CreateOutput

  DO jt = 1,npt
     rpendep(:,:) = 0.
     trcinv( :,:) = getvar(cf_inv,    cv_inv, 1, npiglo, npjglo, ktime=jt)
     trcsurf(:,:) = getvar(cf_trcfil, cv_trc, 1, npiglo, npjglo, ktime=jt)

     WHERE( trcsurf /= 0 ) rpendep = trcinv/trcsurf
     ierr=putvar(ncout, id_varout(1), rpendep, 1, npiglo, npjglo, ktime=jt)
  END DO

  ierr = closeout(ncout)

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    ipk(1)                       = 1
    stypvar(1)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(1)%cname             = cn_pendep
    stypvar(1)%cunits            = 'm'
    stypvar(1)%rmissing_value    = 0.
    stypvar(1)%valid_min         = 0.
    stypvar(1)%valid_max         = 10000.
    stypvar(1)%clong_name        = 'Penetration depth'
    stypvar(1)%cshort_name       = cn_pendep
    stypvar(1)%conline_operation = 'N/A'
    stypvar(1)%caxis             = 'TYX'

    ncout = create      (cf_out, cf_trcfil, npiglo, npjglo, 1                          , ld_nc4=lnc4 )
    ierr  = createvar   (ncout,  stypvar,   1,      ipk,    id_varout, cdglobal=cglobal, ld_nc4=lnc4 )
    ierr  = putheadervar(ncout,  cf_trcfil, npiglo, npjglo, 1                                        )

    dtim = getvar1d(cf_trcfil, cn_vtimec, npt     )
    ierr = putvar1d(ncout,    dtim,       npt, 'T')

  END SUBROUTINE CreateOutput

END PROGRAM cdfpendep

PROGRAM cdffracinv
  !!======================================================================
  !!                     ***  PROGRAM  cdffracinv  ***
  !!=====================================================================
  !!  ** Purpose : Compute fraction of inventory for passive tracers
  !!               output. This is the ratio between inventory at a
  !!               grid point and total inventory
  !!
  !! History : 2.1  : 07/2010  : C.O. Dufour  : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio 
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class passive_tracer
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: jt                    ! dummy loop index
  INTEGER(KIND=4)                           :: narg, iargc, ijarg    ! browse line
  INTEGER(KIND=4)                           :: npiglo, npjglo        ! size of the domain
  INTEGER(KIND=4)                           :: npk, npt              ! size of the domain
  INTEGER(KIND=4)                           :: ncout                 ! ncid of output file
  INTEGER(KIND=4)                           :: ierr                  ! error status
  INTEGER(KIND=4), DIMENSION(1)             :: ipk, id_varout        ! level and varid's of output vars

  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: trcinvij              ! tracer inventory
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: fracinv               ! fraction of inventory

  REAL(KIND=8), DIMENSION(:),   ALLOCATABLE :: dtim                  ! time counter

  CHARACTER(LEN=256)                        :: cf_trc                ! tracer file (for inventory)
  CHARACTER(LEN=256)                        :: cf_out='fracinv.nc'   ! output file name
  CHARACTER(LEN=256)                        :: cv_inv='invcfc'       ! inventory name
  CHARACTER(LEN=256)                        :: cv_out='fracinv'      ! output variable name
  CHARACTER(LEN=256)                        :: cglobal               ! global attribute
  CHARACTER(LEN=256)                        :: cldum                 ! dummy string

  TYPE(variable), DIMENSION(1)              :: stypvar               ! structure for attributes

  LOGICAL                                   :: lnc4 = .FALSE.        ! Use nc4 with chunking and deflation
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdffracinv -trc TRC-file [-inv INV-name] [-o OUT-file] [-nc4]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the fraction of inventory for passive tracers, which is '
     PRINT *,'       the ratio between inventory at a grid point and the total inventory.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -trc TRC-file : netcdf file with tracer inventory.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-inv INV-name ]: netcdf variable name for inventory [ ',TRIM(cv_inv),' ]'
     PRINT *,'       [-o OUT-file ]: specify output file name instead of ', TRIM(cf_out)
     PRINT *,'       [-nc4 ] : Use netcdf4 output with chunking and deflation level 1.'
     PRINT *,'            This option is effective only if cdftools are compiled with'
     PRINT *,'            a netcdf library supporting chunking and deflation.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       none '
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : ', TRIM(cv_out)
     PRINT *,'      '
     STOP 
  ENDIF

  ijarg = 1 
  DO WHILE (ijarg <= narg )
     CALL getarg(ijarg,cldum  ) ; ijarg = ijarg + 1
     SELECT CASE ( cldum )
     CASE ( '-trc' ) ; CALL getarg(ijarg, cf_trc) ; ijarg =ijarg + 1
        ! options
     CASE ( '-inv' ) ; CALL getarg(ijarg, cv_inv) ; ijarg =ijarg + 1
     CASE ( '-o'   ) ; CALL getarg(ijarg, cf_out) ; ijarg =ijarg + 1
     CASE ( '-nc4' ) ; lnc4 = .TRUE.
     CASE DEFAULT    ; PRINT *, ' ERROR : ', TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  END DO

  IF ( chkfile(cf_trc) ) STOP 99 ! missing file

  npiglo = getdim (cf_trc,cn_x)
  npjglo = getdim (cf_trc,cn_y)
  npk    = getdim (cf_trc,cn_z)
  npt    = getdim (cf_trc,cn_t)

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk

  ALLOCATE( trcinvij(npiglo,npjglo), fracinv(npiglo,npjglo) )
  ALLOCATE( dtim(npt) )

  WRITE(cglobal,9000) TRIM(cf_trc), TRIM(cv_inv)
9000 FORMAT('cdffracinv ',a,' -inv ',a )

  CALL CreateOutput

  DO jt=1,npt
     fracinv( :,:) = 0.
     trcinvij(:,:) = getvar(cf_trc, cv_inv, 1, npiglo, npjglo, ktime=jt)
     ! JMM bug ?? : SUM(trcinij) is not the 'total inventory', should be weighted by model metrics ???
     !              also assume spval is 0
     fracinv( :,:) = trcinvij(:,:) / SUM(trcinvij(:,:))
     ierr = putvar(ncout, id_varout(1), fracinv, 1, npiglo, npjglo, ktime=jt)
  END DO

  ierr = closeout(ncout)

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    ipk(1)                       = 1
    stypvar(1)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(1)%cname             = cv_out
    stypvar(1)%cunits            = ''
    stypvar(1)%rmissing_value    = 0.
    stypvar(1)%valid_min         = 0.
    stypvar(1)%valid_max         = 10000.
    stypvar(1)%clong_name        = 'Fraction of inventory'
    stypvar(1)%cshort_name       = cv_out
    stypvar(1)%conline_operation = 'N/A'
    stypvar(1)%caxis             = 'TYX'

    ncout = create      (cf_out, cf_trc,  npiglo, npjglo, 1                          , ld_nc4=lnc4  )
    ierr  = createvar   (ncout,  stypvar, 1,      ipk,    id_varout, cdglobal=cglobal, ld_nc4=lnc4  )
    ierr  = putheadervar(ncout,  cf_trc,  npiglo, npjglo, 1                                         )

    dtim = getvar1d(cf_trc, cn_vtimec, npt     )
    ierr = putvar1d(ncout, dtim,       npt, 'T')

  END SUBROUTINE CreateOutput

END PROGRAM cdffracinv

PROGRAM cdfcheckic
  !!======================================================================
  !!                     ***  PROGRAM  cdfcheckic  ***
  !!=====================================================================
  !!  ** Purpose : apply a non penetrative convection scheme
  !!               using same algoritm than NEMO
  !!
  !!  ** Method  : when static instability detected, mix the cell above with the cell down
  !!               the process is repeated until no more static unstability
  !!
  !!  ** Comments: 3d array are used as the NEMO algo works column-wise and most of the 
  !!               netcdf used in NEMO are chunk 2d along x,y (map access)
  !!
  !! History : 4.0  : 09/2020 : P. Mathiot : initial code
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames   ! for cdf variable names
  USE eos
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class Equation_of_state
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                              :: jk, jt                   ! dummy loop index
  INTEGER(KIND=4)                              :: jpi, jpj, jpk
  INTEGER(KIND=4)                              :: ierr                     ! working integer
  INTEGER(KIND=4)                              :: narg, iargc, ijarg       ! 
  INTEGER(KIND=4)                              :: npiglo, npjglo, npk, npt ! size of the domain
  INTEGER(KIND=4)                              :: ncout                    ! ncid of output file
  INTEGER(KIND=4), DIMENSION(2)                :: ipk, id_varout           ! level and id of output variables
  INTEGER(KIND=4), DIMENSION(:,:), ALLOCATABLE :: mbkt, mikt               ! top and bottom level

  REAL(KIND=4), DIMENSION (:,:,:), ALLOCATABLE :: ztem, zsal, e3w,e3t, wmask, tmask   ! 3d array
  REAL(KIND=4), DIMENSION (:,:),   ALLOCATABLE :: tmskutil
  REAL(KIND=4), DIMENSION (:,:,:), ALLOCATABLE :: gdept, gdepw             ! depth
  REAL(KIND=4), DIMENSION (:),     ALLOCATABLE :: gdept_1d                 ! depth

  REAL(KIND=8), DIMENSION (:),     ALLOCATABLE :: dtim                     ! time

  CHARACTER(LEN=256)                           :: cf_tfil, cldum, cv_dep   ! input file name, ...
  CHARACTER(LEN=256)                           :: cf_sfil                  ! salinity file if different from temperature file
  CHARACTER(LEN=256)                           :: cf_out = 'cdfic.nc'      ! output file name
  CHARACTER(LEN=256)                           :: cglobal                  ! global attribute
  CHARACTER(LEN=80)                            :: cf_e3w                   ! file with e3w in case of vvl

  TYPE(variable), DIMENSION(2)                 :: stypvar                  ! variable attribute

  LOGICAL                                      :: lchk                     ! check missing files
  LOGICAL                                      :: lnc4  =.FALSE.           ! full step flag
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfcheckic -t T-file [-s S-file] [-o OUT-file] [-nc4]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Apply the non penetrative convection scheme to the initial condition to' 
     PRINT *,'       avoid static instability'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -t T-file : netcdf input gridT file for temperature and salinity.' 
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-s S-file] : netcdf input for salinity if not in T-file.'
     PRINT *,'       [-o OUT-file ] : specify output file name instead of ',TRIM(cf_out),'.'
     PRINT *,'       [-nc4 ]  : Use netcdf4 output with chunking and deflation level 1.'
     PRINT *,'                 This option is effective only if cdftools are compiled with'
     PRINT *,'                 a netcdf library supporting chunking and deflation.'
     PRINT *,'      '
     PRINT *,'     OPENMP SUPPORT : yes'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ',TRIM(cn_fzgr),' is needed for this program.' 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) ,' unless -o option specified'
     PRINT *,'      '
     PRINT *,'    SEE ALSO :'
     PRINT *,'       cdfbn2'
     STOP 
  ENDIF

  cglobal = 'Partial step computation'
  cf_sfil = 'none'

  ijarg = 1
  DO WHILE ( ijarg <= narg ) 
     CALL getarg(ijarg, cldum) ; ijarg = ijarg + 1
     SELECT CASE (cldum)
     CASE ( '-t'    ) ; CALL getarg(ijarg, cf_tfil) ; ijarg = ijarg + 1
        ! options
     CASE ( '-s'    ) ; CALL getarg(ijarg, cf_sfil) ; ijarg = ijarg + 1
     CASE ( '-o'    ) ; CALL getarg(ijarg, cf_out ) ; ijarg = ijarg + 1
     CASE ( '-nc4'  ) ; lnc4    = .TRUE.
     CASE DEFAULT     ; PRINT *,' ERROR : ', TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  END DO
  IF ( cf_sfil == 'none') cf_sfil = cf_tfil


  lchk = chkfile (cn_fzgr )
  lchk = lchk .OR. chkfile (cn_fhgr  )
  lchk = lchk .OR. chkfile (cf_tfil  )
  lchk = lchk .OR. chkfile (cf_sfil  )
  IF ( lchk  ) STOP 99  ! missing files 

  npiglo = getdim (cf_tfil, cn_x); jpi=npiglo
  npjglo = getdim (cf_tfil, cn_y); jpj=npjglo
  npk    = getdim (cf_tfil, cn_z); jpk=npk
  npt    = getdim (cf_tfil, cn_t)

  PRINT *, 'npiglo =', npiglo
  PRINT *, 'npjglo =', npjglo
  PRINT *, 'npk    =', npk
  PRINT *, 'npt    =', npt

  ALLOCATE (ztem (npiglo,npjglo,npk), zsal(npiglo,npjglo,npk) )
  ALLOCATE (wmask(npiglo,npjglo,npk), tmask(npiglo,npjglo,npk))
  ALLOCATE (e3w(npiglo,npjglo,npk),e3t(npiglo,npjglo,npk))
  ALLOCATE (tmskutil(npiglo,npjglo) )
  ALLOCATE (gdepw(npiglo,npjglo,npk), gdept(npiglo,npjglo,npk), gdept_1d(npk), dtim(npt)        )
  ALLOCATE (mikt(npiglo,npjglo), mbkt(npiglo,npjglo) )

  gdept_1d = getvare3(cn_fzgr, cn_gdept, npk)
  CALL CreateOutput

  tmskutil(:,:) = getvar(cn_fmsk, cn_tmaskutil, 1, npiglo, npjglo)
  mbkt(:,:) = getvar(cn_fzgr, 'mbathy', 1, npiglo, npjglo)
  mikt(:,:) = getvar(cn_fzgr, 'misf'  , 1, npiglo, npjglo)

  ! load needed static data (wmask used as temporary array here)
  PRINT *, 'load scale factor, depth ...'
  PRINT *, cg_zgr_ver
  IF ( cg_zgr_ver == 'v3.6') cn_ve3w = 'e3w_0'
  IF ( cg_zgr_ver == 'v3.6') cn_ve3t = 'e3t_0'
  e3w(:,:,:)   = getvar3d(cn_fzgr, cn_ve3w  , npiglo, npjglo, npk)
  e3t(:,:,:)   = getvar3d(cn_fzgr, cn_ve3t  , npiglo, npjglo, npk)
  tmask(:,:,:) = getvar3d(cn_fmsk, cn_tmask , npiglo, npjglo, npk)
  gdepw(:,:,1) = 0.
  gdept(:,:,1) = e3t(:,:,1)/2.
  DO jk = 2, npk
    gdepw(:,:,jk) = gdepw(:,:,jk-1) + e3t(:,:,jk-1)
    gdept(:,:,jk) = gdept(:,:,jk-1) + e3w(:,:,jk)
  ENDDO
!  gdepw(:,:,:) = getvar3d(cn_fzgr, cn_depw3d, npiglo, npjglo, npk)
! gdept(:,:,:) = getvar3d(cn_fzgr, cn_dept3d, npiglo, npjglo, npk)

  ! wmask is computed from tmask
  DO jk = 2,npk 
     wmask(:,:,jk) = tmask(:,:,jk) * tmask(:,:,jk-1)
  END DO

  ! start temporal loop
  DO jt=1,npt
     PRINT *,jt,'/',npt

     !  2  compute 3d t/s/wmask
     ztem (:,:,:) = getvar3d(cf_tfil, cn_votemper, npiglo, npjglo, npk, ktime=jt)
     zsal (:,:,:) = getvar3d(cf_sfil, cn_vosaline, npiglo, npjglo, npk, ktime=jt)

     ! 3 compute alpha, beta and bn2
     CALL tra_npc( ztem, zsal )

     ! 4 write data
     DO jk = 1,npk 
        ierr = putvar(ncout, id_varout(1), ztem(:,:,jk)*tmask(:,:,jk), jk, npiglo, npjglo, ktime=jt )
        ierr = putvar(ncout, id_varout(2), zsal(:,:,jk)*tmask(:,:,jk), jk, npiglo, npjglo, ktime=jt )
     END DO

   END DO

   ierr = closeout(ncout)

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    ipk(1)                       = npk  !  3D
    stypvar(1)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(1)%cname             = 'votemper'
    stypvar(1)%cunits            = 'C'
    stypvar(1)%rmissing_value    = -9999.
    stypvar(1)%valid_min         = -10.
    stypvar(1)%valid_max         = 50.
    stypvar(1)%clong_name        = 'ocean temperature'
    stypvar(1)%cshort_name       = 'ocean temperature'
    stypvar(1)%conline_operation = 'N/A'
    stypvar(1)%caxis             = 'TZYX'

    ipk(2)                       = npk  !  3D
    stypvar(2)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(2)%cname             = 'vosaline'
    stypvar(2)%cunits            = 'C'
    stypvar(2)%rmissing_value    = -9999.
    stypvar(2)%valid_min         = 0.
    stypvar(2)%valid_max         = 60.
    stypvar(2)%clong_name        = 'ocean salinity'
    stypvar(2)%cshort_name       = 'ocean salinity'
    stypvar(2)%conline_operation = 'N/A'
    stypvar(2)%caxis             = 'TZYX'


    ! create output fileset
    ncout = create      (cf_out,   cf_tfil,  npiglo, npjglo, npk,                               ld_nc4=lnc4 )
    ierr  = createvar   (ncout ,   stypvar,  2,      ipk,    id_varout, cdglobal=TRIM(cglobal), ld_nc4=lnc4 )
    ierr  = putheadervar(ncout,    cf_tfil,  npiglo, npjglo, npk, pdep=gdept_1d)

    dtim = getvar1d(cf_tfil, cn_vtimec, npt    )
    ierr = putvar1d(ncout,  dtim,       npt,'T')

  END SUBROUTINE CreateOutput

   SUBROUTINE tra_npc( pt, ps )
      !!----------------------------------------------------------------------
      !!  FROM NEMO NEMO/OCE 4.0
      !!                  ***  ROUTINE tranpc  ***
      !!
      !! ** Purpose : Non-penetrative convective adjustment scheme. solve
      !!      the static instability of the water column on after fields
      !!      while conserving heat and salt contents.
      !!
      !! ** Method  : updated algorithm able to deal with non-linear equation of state
      !!              (i.e. static stability computed locally)
      !!
      !! ** Action  : - tsa: after tracers with the application of the npc scheme
      !!              - send the associated trends for on-line diagnostics (l_trdtra=T)
      !!
      !! References :     Madec, et al., 1991, JPO, 21, 9, 1349-1371.
      !!----------------------------------------------------------------------
      !
      REAL(4 ), DIMENSION(jpi,jpj,jpk), INTENT(inout) :: pt, ps          ! active tracers and RHS of tracer equation
      REAL(4 ), DIMENSION(jpk) :: zgdept, zgdepw
      !
      INTEGER  ::   ji, jj, jk                                               ! dummy loop indices
      INTEGER  ::   jiter, iktop, ikbot, ikp, ikup, ikdown, ilayer, ik_low   ! local integers
      INTEGER  ::   jp_tem=1, jp_sal=2                                       ! temp and salinity index
      LOGICAL  ::   l_bottom_reached, l_column_treated                       ! flag to detect if the work is done
      REAL(4 ) ::   zta, zalfa, zsum_temp, zsum_alfa, zaw, zdz, zsum_z
      REAL(4 ) ::   zsa, zbeta, zsum_sali, zsum_beta, zbw, zrw, z1_rDt
      REAL(4 ), PARAMETER ::   zn2_zero = 1.e-14                ! acceptance criteria for neutrality (N2==0)
      REAL(4 ), PARAMETER ::   grav = 9.80665                   ! physics cst
      REAL(4 ), DIMENSION(        jpk     )   ::   zvn2         ! vertical profile of N2 at 1 given point...
      REAL(4 ), DIMENSION(        jpk, 2  )   ::   zvts, zvab   ! vertical profile of T & S , and  alpha & betaat 1 given point
      !!----------------------------------------------------------------------
      !
      DO jj = 1,jpj
         DO ji = 1,jpi
            !
            ! 1 compute alpha/beta
            !
            IF( tmskutil(ji,jj) == 1 ) THEN      ! At least 2 ocean points
               !                                     ! consider one ocean column 
               !
               ! load T/S
               zvts(:,jp_tem) = pt(ji,jj,:)      ! temperature
               zvts(:,jp_sal) = ps(ji,jj,:)      ! salinity
               !
               ! load depth
               zgdept(:) = gdept(ji,jj,:)
               zgdepw(:) = gdepw(ji,jj,:)
               !
               ! compute beta and alpha at T point
               zvab(:,jp_sal)= beta ( zvts(:,jp_tem), zvts(:,jp_sal), zgdept(:), jpk )
               zvab(:,jp_tem)= albet( zvts(:,jp_tem), zvts(:,jp_sal), zgdept(:), jpk ) * zvab(:,jp_sal)
               !
               ! compute N2 at W point, doing exactly as in eosbn2.F90:
               DO jk = 2,jpk
                  ! 
                  ! Interpolating alfa and beta at W point:
                  zrw =  (zgdepw(jk  ) - zgdept(jk)) &
                     & / (zgdept(jk-1) - zgdept(jk))
                  zaw = zvab(jk,jp_tem) * (1.    - zrw) + zvab(jk-1,jp_tem) * zrw * wmask(ji,jj,jk)
                  zbw = zvab(jk,jp_sal) * (1.    - zrw) + zvab(jk-1,jp_sal) * zrw * wmask(ji,jj,jk)
                  !
                  ! compute N2
                  zvn2(jk) = grav*( zaw * ( zvts(jk-1,jp_tem) - zvts(jk,jp_tem) )     &
                              &   - zbw * ( zvts(jk-1,jp_sal) - zvts(jk,jp_sal) )  )  &
                              &   / e3w(ji,jj,jk) * wmask(ji,jj,jk)
               END DO
               !
               ikbot = mbkt(ji,jj)   ! ikbot: ocean bottom T-level
               iktop = mikt(ji,jj)   ! iktop: ocean top    T-level
               ikp = iktop           ! because N2 is irrelevant at the surface level (will start at ikp=2)
               ilayer = 0
               jiter  = 0
               l_column_treated = .FALSE.
               !
               ! Iteration until no more static instability
               DO WHILE ( .NOT. l_column_treated )
                  !
                  jiter = jiter + 1
                  ! 
                  IF( jiter >= 400 ) STOP 'tra_npc :  PROBLEM #0 (tto much iteration)'
                  !
                  l_bottom_reached = .FALSE.
                  !
                  DO WHILE ( .NOT. l_bottom_reached )
                     !
                     ikp = ikp + 1
                     !
                     !! Testing level ikp for instability
                     !! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                     IF( zvn2(ikp) <  -zn2_zero ) THEN ! Instability found!
                        !
                        ilayer = ilayer + 1    ! yet another instable portion of the water column found....
                        !
                        !! ikup is the uppermost point where mixing will start:
                        ikup = ikp - 1 ! ikup is always "at most at ikp-1", less if neutral levels overlying
                        !
                        !! If the points above ikp-1 have N2 == 0 they must also be mixed:
                        IF( ikp > iktop+1 ) THEN
                           DO jk = ikp-1, iktop+1, -1
                              IF( ABS(zvn2(jk)) < zn2_zero ) THEN
                                 ikup = ikup - 1  ! 1 more upper level has N2=0 and must be added for the mixing
                              ELSE
                                 EXIT
                              ENDIF
                           END DO
                        ENDIF
                        
                        IF( iktop < iktop )  STOP 'tra_npc :  PROBLEM #1'
                        !
                        zsum_temp = 0.   
                        zsum_sali = 0.   
                        zsum_alfa = 0.   
                        zsum_beta = 0.   
                        zsum_z    = 0.   
                        DO jk = ikup, ikbot     ! Inside the instable (and overlying neutral) portion of the column
                           !
                           zdz       = e3t(ji,jj,jk)
                           zsum_temp = zsum_temp + zvts(jk,jp_tem)*zdz
                           zsum_sali = zsum_sali + zvts(jk,jp_sal)*zdz
                           zsum_alfa = zsum_alfa + zvab(jk,jp_tem)*zdz
                           zsum_beta = zsum_beta + zvab(jk,jp_sal)*zdz
                           zsum_z    = zsum_z    + zdz
                           !                              
                           IF( jk == ikbot ) EXIT ! avoid array-index overshoot in case ikbot = jpk, cause we're calling jk+1 next line
                           !! EXIT when we have reached the last layer that is instable (N2<0) or neutral (N2=0):
                           IF( zvn2(jk+1) > zn2_zero ) EXIT
                        END DO
                       
                        ikdown = jk ! for the current unstable layer, ikdown is the deepest point with a negative or neutral N2
                        IF( ikup == ikdown )   STOP 'tra_npc :  PROBLEM #2'
                        !
                        ! Mixing Temperature, salinity, alpha and beta from ikup to ikdown included:
                        zta   = zsum_temp/zsum_z
                        zsa   = zsum_sali/zsum_z
                        zalfa = zsum_alfa/zsum_z
                        zbeta = zsum_beta/zsum_z
   
                        !! Homogenaizing the temperature, salinity, alpha and beta in this portion of the column
                        DO jk = ikup, ikdown
                           zvts(jk,jp_tem) = zta
                           zvts(jk,jp_sal) = zsa
                           zvab(jk,jp_tem) = zalfa
                           zvab(jk,jp_sal) = zbeta
                        END DO

                        !! Updating N2 in the relvant portion of the water column
                        !! Temperature, Salinity, Alpha and Beta have been homogenized in the unstable portion
                        !! => Need to re-compute N2! will use Alpha and Beta!
                        
                        ikup   = MAX(iktop+1,ikup)         ! ikup can never be 1 !
                        ik_low = MIN(ikdown+1,ikbot) ! we must go 1 point deeper than ikdown!
                        
                        DO jk = ikup, ik_low              ! we must go 1 point deeper than ikdown!
   
                           !! Interpolating alfa and beta at W point:
                           zrw =  (zgdepw(jk  ) - zgdept(jk)) &
                              & / (zgdept(jk-1) - zgdept(jk))
                           zaw = zvab(jk,jp_tem) * (1.    - zrw) + zvab(jk-1,jp_tem) * zrw * wmask(ji,jj,jk)
                           zbw = zvab(jk,jp_sal) * (1.    - zrw) + zvab(jk-1,jp_sal) * zrw * wmask(ji,jj,jk)
   
                           !! N2 at W point, doing exactly as in eosbn2.F90:
                           zvn2(jk) = grav*( zaw * ( zvts(jk-1,jp_tem) - zvts(jk,jp_tem) )     &
                              &            - zbw * ( zvts(jk-1,jp_sal) - zvts(jk,jp_sal) )  )  &
                              &       / e3w(ji,jj,jk) * wmask(ji,jj,jk)
   
                        END DO
                     
                        ikp = MIN(ikdown+1,ikbot)
                        
   
                     ENDIF  !IF( zvn2(ikp) < 0. )
   
                     IF( ikp == ikbot ) l_bottom_reached = .TRUE.
                     !
                  END DO ! DO WHILE ( .NOT. l_bottom_reached )
   
                  IF( ikp /= ikbot )   STOP 'tra_npc :  PROBLEM #3'
                 
                  ! ******* At this stage ikp == ikbot ! *******
                 
                  IF( ilayer > 0 ) THEN      !! least an unstable layer has been found
                     !
                     ikp    = 1     ! starting again at the surface for the next iteration
                     ilayer = 0
                     !
                  ENDIF
                  !
                  IF( ikp >= ikbot )   l_column_treated = .TRUE.
                  !
               END DO ! DO WHILE ( .NOT. l_column_treated )
   
               !! Updating pts:
               pt(ji,jj,:) = zvts(:,jp_tem)
               ps(ji,jj,:) = zvts(:,jp_sal)
   
            ENDIF ! IF( tmskutil == 1 ) THEN
   
         END DO
      END DO
      !
   END SUBROUTINE tra_npc

END PROGRAM

PROGRAM cdfmltmask
  !!======================================================================
  !!                     ***  PROGRAM  cdfmltmask  ***
  !!=====================================================================
  !!  ** Purpose : multiplication of file by a mask (0,1)
  !!
  !! History : 2.1  : 06/2007  : M. Juza      : Original code
  !!         : 2.1  : 06/2007  : P. Mathiot   : add forcing capabilities
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!           3.0  : 06/2013  : J.M. Molines : add multi variable capability
  !!           3.0  : 11/2016  : J.M. Molines : use keys for arguments
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                             :: jk, jt, jvar       ! dummy loop index
  INTEGER(KIND=4)                             :: ierr               ! error status
  INTEGER(KIND=4)                             :: narg, iargc, ijarg ! command line 
  INTEGER(KIND=4)                             :: npiglo, npjglo     ! size of the domain
  INTEGER(KIND=4)                             :: npk, npt           ! size of the domain
  INTEGER(KIND=4)                             :: npkmask            ! vertical levels in mask file
  INTEGER(KIND=4)                             :: nvar=1             ! number of variable to process(default 1)
  INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE  :: nvpk               ! vertical levels in working variable

  REAL(KIND=4)                                :: zspval             ! missing value attribute
  REAL(KIND=4)                                :: zspv0              ! missing value in the output file (default 0)
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: zv                 ! cv_in at jk level 
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: zmask              ! mask at jk level 
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: zvmask             ! masked cv_in at jk level

  CHARACTER(LEN=256)                          :: cunits             ! units attribute
  CHARACTER(LEN=256)                          :: clname             ! long_name attribute
  CHARACTER(LEN=256)                          :: csname             ! short_name attribute
  CHARACTER(LEN=256)                          :: cf_in              ! input file name
  CHARACTER(LEN=256)                          :: cf_out             ! output file name
  CHARACTER(LEN=256)                          :: cf_msk             ! input mask file name
  CHARACTER(LEN=256)                          :: cvartype           ! variable position on Cgrid
  CHARACTER(LEN=256)                          :: cv_dep             ! depth dim name
  CHARACTER(LEN=256)                          :: cldum              ! dummy string
  CHARACTER(LEN=20)                           :: cv_msk             ! mask variable name
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_in            ! cdf variable names to process

  LOGICAL                                     :: lnc4=.false.       ! use Netcdf4 chunking and deflation
  LOGICAL                                     :: lout=.false.       ! specified output file name
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfmltmask -f IN-file -m MSK-file -v IN-var1,var2,...  '
     PRINT *,'              -p  T| U | V | F | W | P  [-s _Fillvalue] [-nc4] [-o OUT-file]'
     PRINT *,'              [ -M MSK-var ]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Multiply IN-var(s) of IN-file by the mask corresponding to the' 
     PRINT *,'       C-grid point position given by the -p argument.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -f IN-file  : input netcdf file.' 
     PRINT *,'       -m MSK-file : input netcdf mask file.' 
     PRINT *,'       -v IN-var1,var2,...   : Comma separated list of variable names to mask.'
     PRINT *,'       -p T| U | V | F | W | P : C-grid position of IN-var'
     PRINT *,'                P indicate a polygon mask created by cdfpoly.'
     PRINT *,'      OPTIONS : '
     PRINT *,'        -s _FillValue : specify values for masked areas [0 by default ]'
     PRINT *,'        -nc4 : output file will be chunked and deflated'
     PRINT *,'        -o OUT-file : name of output file, instead of <IN-file>_masked'
     PRINT *,'        -M MSK-var : use MSK-var in the MSK-file, instead of the one defined'
     PRINT *,'               by default according to the -p option. Overrid -p option.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        none, all are given as arguments.'
     PRINT *,'      '
     PRINT *,'     OUTPUT : (jvar)'
     PRINT *,'       The output file is a copy of the input file with only'
     PRINT *,'       the requested variable masked.'
     PRINT *,'       netcdf file : IN-file_masked unless specified with -o '
     PRINT *,'         variables : IN-var (same as input).'
     STOP
  ENDIF

  zspv0 = 0.
  ijarg = 1
  cv_msk ='none'
  DO WHILE (ijarg <= narg)
    CALL getarg (ijarg, cldum ) ; ijarg = ijarg + 1
    SELECT CASE ( cldum)
    CASE ( '-f' )
        CALL getarg(ijarg, cf_in )   ; ijarg = ijarg + 1
    CASE ( '-m' )
        CALL getarg(ijarg, cf_msk)   ; ijarg = ijarg + 1
    CASE ( '-M' )
        CALL getarg(ijarg, cv_msk)   ; ijarg = ijarg + 1
    CASE ( '-v' )
        CALL getarg(ijarg, cldum)    ; ijarg = ijarg + 1
        CALL ParseVars ( cldum )
    CASE ( '-p' )
        CALL getarg(ijarg, cvartype) ; ijarg = ijarg + 1
    CASE ( '-s' )
        CALL getarg(ijarg, cldum)    ; ijarg = ijarg + 1 
        READ(cldum,*) zspv0
    CASE ( '-nc4' )
         lnc4 = .false.
         PRINT *,' Option -nc4 actually ignored, sorry !, proceed ...'
    CASE ( '-o' )
        CALL getarg(ijarg, cf_out )  ; ijarg = ijarg + 1 ; lout=.TRUE.
    CASE DEFAULT
        PRINT *, TRIM(cldum), ' : unknown option'
    END SELECT
  ENDDO

  IF ( chkfile (cf_in) .OR. chkfile(cf_msk) ) STOP 99 ! missing files

  ! append _masked to input file name and copy initial file to new file, which will be modified
  !  using dd more efficient than cp for big files
  IF ( .NOT. lout ) THEN
     cf_out   = TRIM(cf_in)//'_masked'
  ENDIF
  CALL system(' dd bs=10000000 if='//TRIM(cf_in)//' of='//TRIM(cf_out) )
  cf_in = cf_out

  PRINT *,' Working on copy : ', TRIM(cf_out)

  npiglo = getdim (cf_in,cn_x)
  npjglo = getdim (cf_in,cn_y)
  npk    = getdim (cf_in,cn_z, cdtrue=cv_dep, kstatus=ierr)

  IF (ierr /= 0 ) THEN
     npk   = getdim (cf_in, 'z', cdtrue=cv_dep, kstatus=ierr)
     IF (ierr /= 0 ) THEN
       npk   = getdim (cf_in, 'sigma', cdtrue=cv_dep, kstatus=ierr)
        IF ( ierr /= 0 ) THEN
          npk = getdim (cf_in, 'nav_lev', cdtrue=cv_dep, kstatus=ierr)
            IF ( ierr /= 0 ) THEN
              PRINT *,' assume file with no depth'
              npk=0
            ENDIF
        ENDIF
     ENDIF
  ENDIF

  npkmask = getdim (cf_msk, cn_z, cdtrue=cv_dep, kstatus=ierr)
  IF (ierr /= 0 ) THEN
     npkmask  = getdim (cf_msk, 'z', cdtrue=cv_dep, kstatus=ierr)
       IF ( ierr /= 0 ) THEN
            npkmask = getdim (cf_msk, 'nav_lev', cdtrue=cv_dep, kstatus=ierr)
            IF ( ierr /= 0 ) THEN
              PRINT *,' assume file with no depth'
              npkmask=0
            ENDIF
       ENDIF
  ENDIF

  npt   = getdim (cf_in, cn_t    )
  ALLOCATE( nvpk(nvar) )

  DO jvar = 1, nvar
     nvpk(jvar)  = getvdim(cf_in, cv_in(jvar))
     IF (nvpk(jvar) == 2 ) nvpk(jvar) = 1
     IF (nvpk(jvar) == 3 ) nvpk(jvar) = npk
  END DO

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt
  PRINT *, 'npkmask= ', npkmask

  DO jvar = 1, nvar
    PRINT *, 'nvpk(',TRIM(cv_in(jvar)),')   = ', nvpk(jvar)
  END DO

  IF (npk==0) npk=1

  ! Allocate arrays
  ALLOCATE( zmask(npiglo,npjglo) )
  ALLOCATE( zv   (npiglo,npjglo) )
  ALLOCATE(zvmask(npiglo,npjglo) )

  IF ( cv_msk == 'none' ) THEN  ! means cv_msk was not defined by -M option
  SELECT CASE (TRIM(cvartype))
  CASE ( 'T' )
     cv_msk='tmask'
  CASE ( 'U' )
     cv_msk='umask'
  CASE ( 'V' )
     cv_msk='vmask'
  CASE ( 'F' )
     cv_msk='fmask'
  CASE ( 'W' )
     cv_msk='tmask'
  CASE ( 'P' )   ! for polymask 
     cv_msk='polymask'
  CASE DEFAULT
     PRINT *, 'this type of variable is not known :', TRIM(cvartype)
     STOP 99
  END SELECT
  ENDIF

  IF ( npkmask <= 1 ) THEN 
        zmask(:,:) = getvar(cf_msk, cv_msk, 1, npiglo, npjglo)
  ENDIF

  DO jt = 1, npt
     IF (MOD(jt,100)==0) PRINT *, jt,'/', npt
     DO jvar = 1, nvar  ! loop on variables
        DO jk = 1, nvpk(jvar)
        PRINT *,' Processing level ', jk,' variable ',TRIM(cv_in(jvar))
        IF ( npkmask > 1 ) THEN
        ! Read mask
          zmask(:,:) = getvar(cf_msk, cv_msk, jk, npiglo, npjglo)
        ENDIF
          ! Read cv_in
          zv(:,:) = getvar(cf_in, cv_in(jvar), jk, npiglo, npjglo, ktime=jt)
          ! Multiplication of cv_in by mask at level jk
!         zvmask = zv * zmask
          WHERE ( zmask == 0 ) 
           zvmask = zspv0
          ELSEWHERE
           zvmask = zv
          ENDWHERE
          ! Writing  on the copy of original file                 
          ierr = putvar(cf_out, cv_in(jvar), jk, npiglo, npjglo, 1, 1, ktime=jt, ptab=zvmask)
        END DO
     END DO
  END DO

  ! set missing value attribute for cv_in as 0.
  DO jvar = 1, nvar 
     ierr = getvaratt (cf_in, cv_in(jvar), cunits, zspval, clname, csname)
     IF ( csname == "" ) csname=TRIM( cv_in(jvar) )
     ierr = cvaratt   (cf_out, cv_in(jvar), cunits, zspv0,  clname, csname)
  END DO

CONTAINS
   SUBROUTINE ParseVars (cdum)
      !!---------------------------------------------------------------------
      !!                  ***  ROUTINE ParseVars  ***
      !!
      !! ** Purpose :  Decode variables names to be used
      !!
      !! ** Method  :  look for , in the argument string and set the number of
      !!         variable (nvaro), allocate cv_fix array and fill it with the
      !!         decoded  names.
      !!
      !!----------------------------------------------------------------------
      CHARACTER(LEN=*), INTENT(in) :: cdum

      CHARACTER(LEN=80), DIMENSION(100) :: cl_dum  ! 100 is arbitrary
      INTEGER  :: ji
      INTEGER  :: inchar,  i1=1
      !!----------------------------------------------------------------------

      inchar= LEN(TRIM(cdum))
      ! scan the input string and look for ',' as separator
      DO ji=1,inchar
         IF ( cdum(ji:ji) == ',' ) THEN
            cl_dum(nvar) = cdum(i1:ji-1)
            i1=ji+1
            nvar=nvar+1
         ENDIF
      ENDDO

      ! last name of the list does not have a ','
      cl_dum(nvar) = cdum(i1:inchar)

      ALLOCATE ( cv_in(nvar) )
      DO ji=1, nvar
         cv_in(ji) = cl_dum(ji)
      ENDDO
   END SUBROUTINE ParseVars

END PROGRAM cdfmltmask 

PROGRAM cdfbuoyflx
  !!======================================================================
  !!                     ***  PROGRAM  cdfbuoyflx  ***
  !!=====================================================================
  !!  ** Purpose :  Produce a file with the water flux separated into 4 components:
  !!                E (evap), P (precip), R (runoff), dmp (sssdmp).
  !!                The total water flux is E -P -R + dmp. Units in this program
  !!                are mm/days.  (Up to that it is the same than cdfwflx)
  !!
  !!                It also produces un the same file the component of the heat flux
  !!                Latent Heat FLux, Sensible Heat flux, Long Wave HF, Short Wave HF,
  !!                Net HF
  !!
  !!                Buoyancy fluxes are also computed, as a net value but also with the
  !!                contribution of each term.
  !!
  !!  ** Method  : Evap is computed from the latent heat flux : evap=-qla/Lv
  !!               Runoff is read from the climatological input file
  !!               dmp is read from the file (sowafldp)
  !!               Precip is then computed as the difference between the
  !!               total water flux (sowaflup) and the E-R+dmp. In the high latitudes
  !!               this precip includes the effect of snow (storage/melting). Therefore
  !!               it may differ slightly from the input precip file.
  !!
  !!               Heat fluxes are directly copied from the gridT files, same name, same units
  !!               We also add sst and SSS for convenience.
  !!
  !!               Buoyancy fluxes are also computed as :
  !!                  BF = -1/rho (alpha x TF  - beta SF )
  !!                       (TF = thermal part, SF = haline part )
  !!                  TF = 1/(rho x Cp)* Q
  !!                  SF = 1/(1-SSS) x (E-P) x SSS
  !!
  !! History : 2.1  : 01/2008  : J.M. Molines : Original code
  !!           3.0  : 12/2010  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE eos
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2010, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4), PARAMETER                :: jp_varout=25
  INTEGER(KIND=4)                           :: ncout, ierr
  INTEGER(KIND=4)                           :: jt                                ! dummy loop index
  INTEGER(KIND=4)                           :: narg, iargc                       ! command line 
  INTEGER(KIND=4)                           :: npiglo, npjglo, npt               ! size of the domain
  INTEGER(KIND=4), DIMENSION(jp_varout)     :: ipk, id_varout  

  ! Physical constants
  REAL(KIND=4)                              :: Lv = 2.5e6                        ! latent HF <--> evap conversion
  REAL(KIND=4)                              :: Cp = 4000.                        ! specific heat of water 

  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: tim, zdep                         ! time counter, deptht
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zmask, zcoefq, zcoefw             ! work array
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zalbet, zbeta                     ! work array
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: evap, precip, runoff, wdmp, wnet  ! water flux components
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: wice, precip_runoff               ! water flux components
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: qlat, qsb, qlw, qsw, qnet         ! heat flux components
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: b_evap, b_precip, b_runoff        ! BF water flux components
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: b_wdmp, bw_net                    ! BF water flux components
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: b_qlat, b_qsb, b_qlw              ! BF heat flux components
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: b_qsw , bh_net                    ! BF heat flux components
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zsst, zsss, buoyancy_fl             ! Total buoyancy flux

  CHARACTER(LEN=256)                        :: cf_tfil , cf_rnfil                ! input file gridT and runoff
  CHARACTER(LEN=256)                        :: cf_out='buoyflx.nc'               ! output file

  TYPE(variable), DIMENSION(jp_varout)      :: stypvar                           ! structure for attributes

  LOGICAL                                   :: lchk
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  !!  Read command line and output usage message if not compliant.
  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfbuoyflx  T-file RNF-file'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute (or read) the heat and water fluxes components.'
     PRINT *,'       Compute (or read) the net heat and water fluxes.'
     PRINT *,'       Compute the buoyancy heat and water fluxes components.'
     PRINT *,'       Compute the net buoyancy fluxes.'
     PRINT *,'       Save sss and sst.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       T-file   : netcdf file with ' 
     PRINT *,'       RNF-file : netcdf file with runoff ' 
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        none'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables :  25 variables (2D)'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'      '
     PRINT *,'      '
     STOP
  ENDIF

  CALL getarg (1, cf_tfil)
  CALL getarg (2, cf_rnfil)

  lchk =           chkfile (cf_tfil )
  lchk = lchk .OR. chkfile (cf_rnfil)
  IF (lchk ) STOP ! missing files

  npiglo = getdim (cf_tfil,cn_x)
  npjglo = getdim (cf_tfil,cn_y)
  npt    = getdim (cf_tfil,cn_t)

  ! prepare output variables
  ALLOCATE (zdep(1), tim(npt) )
  zdep(1) = 0.
  ipk(:)  = 1  ! all variables ( output are 2D)
  stypvar%conline_operation = 'N/A'
  stypvar%caxis             = 'TYX'

  ! 1--> 7 water fluxes                     ;   ! 8 --> 12    heat fluxes
  stypvar(1)%cname= 'evap'                  ;  stypvar(8)%cname= 'latent'      
  stypvar(2)%cname= 'precip'                ;  stypvar(9)%cname= 'sensible'      
  stypvar(3)%cname= 'runoff'                ;  stypvar(10)%cname= 'longwave'      
  stypvar(4)%cname= 'sssdmp'                ;  stypvar(11)%cname= 'solar'      
  stypvar(5)%cname= 'watnet'                ;  stypvar(12)%cname= 'heatnet'      
  stypvar(6)%cname= 'wice'            
  stypvar(7)%cname= 'precip_runoff'  

  stypvar(1:7)%cunits='mm/day'              ;  stypvar(8:12)%cunits='W/m2'      
  stypvar(1:7)%rmissing_value=0.            ;  stypvar(8:12)%rmissing_value=0.      
  stypvar(1:7)%valid_min= -100.             ;  stypvar(8:12)%valid_min= -500.      
  stypvar(1:7)%valid_max= 100.              ;  stypvar(8:12)%valid_max= 500.      
  stypvar(1)%clong_name='Evaporation'       ;  stypvar(8)%clong_name='Latent Heat flux'      
  stypvar(2)%clong_name='Precipitation'     ;  stypvar(9)%clong_name='Sensible Heat flux'       
  stypvar(3)%clong_name='Runoff'            ;  stypvar(10)%clong_name='Long Wave Heat flux'      
  stypvar(4)%clong_name='SSS damping'       ;  stypvar(11)%clong_name='Short Wave Heat flux'
  stypvar(5)%clong_name='Total water flux'  ;  stypvar(12)%clong_name='Net Heat Flux'      
  stypvar(6)%clong_name='Ice congelation and melting'  
  stypvar(7)%clong_name='Precip and runoff together' 

  stypvar(1)%cshort_name='evap'             ;  stypvar(8)%cshort_name='latent'      
  stypvar(2)%cshort_name='precip'           ;  stypvar(9)%cshort_name='sensible'      
  stypvar(3)%cshort_name='runoff'           ;  stypvar(10)%cshort_name='longwave'      
  stypvar(4)%cshort_name='sssdmp'           ;  stypvar(11)%cshort_name='solar'      
  stypvar(5)%cshort_name='watnet'           ;  stypvar(12)%cshort_name='heatnet'       
  stypvar(6)%cshort_name='wice'  
  stypvar(7)%cshort_name='precip_runoff' 

  ! 13--> 17  buoy water fluxes             ;   ! 18 --> 22    buoy heat fluxes
  stypvar(13)%cname= 'evap_b'               ;  stypvar(18)%cname= 'latent_b'
  stypvar(14)%cname= 'precip_b'             ;  stypvar(19)%cname= 'sensible_b'
  stypvar(15)%cname= 'runoff_b'             ;  stypvar(20)%cname= 'longwave_b'
  stypvar(16)%cname= 'sssdmp_b'             ;  stypvar(21)%cname= 'solar_b'
  stypvar(17)%cname= 'watnet_b'             ;  stypvar(22)%cname= 'heatnet_b'

  stypvar(13:17)%cunits='1e-6 kg/m2/s'      ;  stypvar(18:22)%cunits='1e-6 kg/m2/s'
  stypvar(13:17)%rmissing_value=0.          ;  stypvar(18:22)%rmissing_value=0.
  stypvar(13:17)%valid_min= -100.           ;  stypvar(18:22)%valid_min= -500.
  stypvar(13:17)%valid_max= 100.            ;  stypvar(18:22)%valid_max= 500.

  stypvar(13)%clong_name='buoy flx evap'    ;  stypvar(18)%clong_name='buoy Latent Heat flux'
  stypvar(14)%clong_name='buoy flx precip'  ;  stypvar(19)%clong_name='buoy Sensible Heat flux'
  stypvar(15)%clong_name='buoy flx runoff'  ;  stypvar(20)%clong_name='buoy Long Wave Heat flux'
  stypvar(16)%clong_name='buoy flx damping' ;  stypvar(21)%clong_name='buoy Short Wave Heat flux'
  stypvar(17)%clong_name='buoy haline flx'  ;  stypvar(22)%clong_name='buoy thermo Flux'

  stypvar(13)%cshort_name='evap_b'          ;  stypvar(18)%cshort_name='latent_b'
  stypvar(14)%cshort_name='precip_b'        ;  stypvar(19)%cshort_name='sensible_b'
  stypvar(15)%cshort_name='runoff_b'        ;  stypvar(20)%cshort_name='longwave_b'
  stypvar(16)%cshort_name='sssdmp_b'        ;  stypvar(21)%cshort_name='solar_b'
  stypvar(17)%cshort_name='watnet_b'        ;  stypvar(22)%cshort_name='heatnet_b'

  ! total buoyancy flux
  stypvar(23)%cname= 'buoyancy_fl'
  stypvar(23)%cunits='1e-6 kg/m2/s'
  stypvar(23)%rmissing_value=0.
  stypvar(23)%valid_min= -100.
  stypvar(23)%valid_max= 100.
  stypvar(23)%clong_name='buoyancy flux'
  stypvar(23)%cshort_name='buoyancy_fl'

  ! SSS                                         ; SST
  stypvar(24)%cname= 'sss'                      ;   stypvar(25)%cname= 'sst'
  stypvar(24)%cunits='PSU'                      ;   stypvar(25)%cunits='Celsius'
  stypvar(24)%rmissing_value=0.                 ;   stypvar(25)%rmissing_value=0.
  stypvar(24)%valid_min= 0.                     ;   stypvar(25)%valid_min= -2.
  stypvar(24)%valid_max= 45                     ;   stypvar(25)%valid_max= 45
  stypvar(24)%clong_name='Sea Surface Salinity' ;   stypvar(25)%clong_name='Sea Surface Temperature'
  stypvar(24)%cshort_name='sss  '               ;   stypvar(25)%cshort_name='sst'

  PRINT *, 'npiglo =', npiglo
  PRINT *, 'npjglo =', npjglo
  PRINT *, 'npt    =', npt


  ALLOCATE ( zmask(npiglo,npjglo), wnet(npiglo,npjglo), zalbet(npiglo,npjglo), zbeta(npiglo, npjglo) )
  ALLOCATE ( zcoefq(npiglo,npjglo), zcoefw(npiglo,npjglo) )
  ALLOCATE ( evap(npiglo,npjglo), precip(npiglo,npjglo), runoff(npiglo,npjglo), wdmp(npiglo,npjglo) )
  ALLOCATE ( wice(npiglo,npjglo), precip_runoff(npiglo,npjglo) )
  ALLOCATE ( qlat(npiglo,npjglo), qsb(npiglo,npjglo), qlw(npiglo,npjglo), qsw(npiglo,npjglo), qnet(npiglo,npjglo) )
  ALLOCATE ( b_evap(npiglo,npjglo), b_precip(npiglo,npjglo), b_runoff(npiglo,npjglo), b_wdmp(npiglo,npjglo),bw_net(npiglo,npjglo) ) 
  ALLOCATE ( b_qlat(npiglo,npjglo), b_qsb(npiglo,npjglo),    b_qlw(npiglo,npjglo),    b_qsw(npiglo,npjglo), bh_net(npiglo,npjglo))
  ALLOCATE ( buoyancy_fl(npiglo,npjglo), zsst(npiglo,npjglo), zsss(npiglo,npjglo) )

  ncout = create      (cf_out, cf_tfil, npiglo,    npjglo, 1             )
  ierr  = createvar   (ncout,  stypvar, jp_varout, ipk,    id_varout     )
  ierr  = putheadervar(ncout,  cf_tfil, npiglo,    npjglo, 1,   pdep=zdep)

  DO jt = 1, npt
     ! read sss for masking purpose and sst
     zsss(:,:) = getvar(cf_tfil, cn_vosaline, 1, npiglo, npjglo, ktime=jt)
     zmask=1. ; WHERE ( zsss == 0 ) zmask=0.
     zsst(:,:) = getvar(cf_tfil, cn_votemper, 1, npiglo, npjglo, ktime=jt)

     ! Evap : 
     qlat(:,:)= getvar(cf_tfil, cn_solhflup, 1, npiglo, npjglo, ktime=jt) *zmask(:,:)    ! W/m2 
     evap(:,:)= -1.* qlat(:,:) /Lv*86400. *zmask(:,:)                                    ! mm/days

     ! Wdmp
     wdmp(:,:)= getvar(cf_tfil, cn_sowafldp, 1, npiglo, npjglo, ktime=jt)*86400.*zmask(:,:) ! mm/days

     ! Runoff  ! take care : not a model output (time_counter may disagree ... jmm
     runoff(:,:)= getvar(cf_rnfil, 'sorunoff', 1, npiglo, npjglo)*86400.*zmask(:,:)         ! mm/days

     ! total water flux (emps)
     wnet(:,:) = getvar(cf_tfil, cn_sowaflcd, 1, npiglo, npjglo, ktime=jt )*86400.*zmask(:,:)          ! mm/days

     ! fsalt = contribution of ice freezing and melting to salinity ( + = freezing, - = melting )Q
     wice(:,:) = getvar(cf_tfil, cn_iowaflup, 1, npiglo, npjglo, ktime=jt )*86400.*zmask(:,:)          ! mm/days

     ! Precip:
     precip(:,:)= evap(:,:)-runoff(:,:)+wdmp(:,:)-wnet(:,:)+wice(:,:)                     ! mm/day

     ! Precip+runoff : (as a whole ) (interpolated on line)
     precip_runoff(:,:)= evap(:,:)+wdmp(:,:)-wnet(:,:)+wice(:,:)                          ! mm/day

     ! other heat fluxes
     qsb(:,:)= getvar(cf_tfil, cn_sosbhfup,  1, npiglo, npjglo, ktime = jt )*zmask(:,:)    ! W/m2 
     qlw(:,:)= getvar(cf_tfil, cn_solwfldo,  1, npiglo, npjglo, ktime = jt )*zmask(:,:)    ! W/m2 
     qsw(:,:)= getvar(cf_tfil, cn_soshfldo,  1, npiglo, npjglo, ktime = jt )*zmask(:,:)    ! W/m2 
     qnet(:,:)=getvar(cf_tfil, cn_sohefldo,  1, npiglo, npjglo, ktime = jt )*zmask(:,:)    ! W/m2 

     ! buoyancy flux
     zalbet(:,:)= albet ( zsst, zsss, 0., npiglo, npjglo)
     zbeta (:,:)= beta  ( zsst, zsss, 0., npiglo, npjglo)
     zcoefq(:,:)= -zbeta * zalbet /Cp * 1.e6
     zcoefw(:,:)=  zbeta * zsss/(1-zsss/1000.)/86400. *1.e6   ! division by 86400 to get back water fluxes in kg/m2/s

     buoyancy_fl=0. ; bh_net=0. ; b_qlat=0.  ; b_qlw=0.  ; b_qsw=0.   ; b_qsb=0.
     bw_net=0.      ; b_evap=0. ; b_precip=0.; b_wdmp=0. ; b_runoff=0.

     WHERE (zsss /= 0 ) 
        bh_net(:,:)= zcoefq * qnet
        b_qlat(:,:)= zcoefq * qlat
        b_qlw (:,:)= zcoefq * qlw
        b_qsw (:,:)= zcoefq * qsw
        b_qsb (:,:)= zcoefq * qsb

        bw_net(:,:)= zcoefw * wnet
        b_evap(:,:)= zcoefw * evap
        b_precip(:,:)= -zcoefw * precip
        b_runoff(:,:)= -zcoefw * runoff
        b_wdmp(:,:)= zcoefw * wdmp

        !    buoyancy_fl(:,:) = zcoefq * qnet +zcoefw * wnet
        buoyancy_fl(:,:) = bh_net + bw_net
     END WHERE

     ! Write output file

     ierr = putvar(ncout, id_varout(1), evap,   1, npiglo, npjglo, ktime=jt )
     ierr = putvar(ncout, id_varout(2), precip, 1, npiglo, npjglo, ktime=jt )
     ierr = putvar(ncout, id_varout(3), runoff, 1, npiglo, npjglo, ktime=jt )
     ierr = putvar(ncout, id_varout(4), wdmp,   1, npiglo, npjglo, ktime=jt )
     ierr = putvar(ncout, id_varout(5), wnet,   1, npiglo, npjglo, ktime=jt )
     ierr = putvar(ncout, id_varout(6), wice,   1, npiglo, npjglo, ktime=jt )
     ierr = putvar(ncout, id_varout(7), precip_runoff,   1,npiglo, npjglo, ktime=jt )

     ierr = putvar(ncout, id_varout(8), qlat,   1, npiglo, npjglo, ktime=jt )
     ierr = putvar(ncout, id_varout(9), qsb,    1, npiglo, npjglo, ktime=jt )
     ierr = putvar(ncout, id_varout(10),qlw,    1, npiglo, npjglo, ktime=jt )
     ierr = putvar(ncout, id_varout(11),qsw,    1, npiglo, npjglo, ktime=jt )
     ierr = putvar(ncout, id_varout(12),qnet,   1, npiglo, npjglo, ktime=jt )

     ierr = putvar(ncout, id_varout(13),b_evap,  1, npiglo, npjglo, ktime=jt )
     ierr = putvar(ncout, id_varout(14),b_precip,1, npiglo, npjglo, ktime=jt )
     ierr = putvar(ncout, id_varout(15),b_runoff,1, npiglo, npjglo, ktime=jt )
     ierr = putvar(ncout, id_varout(16),b_wdmp,  1, npiglo, npjglo, ktime=jt )
     ierr = putvar(ncout, id_varout(17),bw_net,  1, npiglo, npjglo, ktime=jt )

     ierr = putvar(ncout, id_varout(18),b_qlat,  1, npiglo, npjglo, ktime=jt )
     ierr = putvar(ncout, id_varout(19),b_qsb,   1, npiglo, npjglo, ktime=jt )
     ierr = putvar(ncout, id_varout(20),b_qlw,   1, npiglo, npjglo, ktime=jt )
     ierr = putvar(ncout, id_varout(21),b_qsw,   1, npiglo, npjglo, ktime=jt )
     ierr = putvar(ncout, id_varout(22),bh_net,  1, npiglo, npjglo, ktime=jt )

     ierr = putvar(ncout, id_varout(23),buoyancy_fl, 1,npiglo, npjglo, ktime=jt )

     ierr = putvar(ncout, id_varout(24), zsss,  1, npiglo, npjglo, ktime=jt )
     ierr = putvar(ncout, id_varout(25), zsst,  1, npiglo, npjglo, ktime=jt )
  END DO  ! time loop

  tim  = getvar1d(cf_tfil, cn_vtimec, npt     )
  ierr = putvar1d(ncout,   tim,       npt, 'T')

  ierr=closeout(ncout)

END PROGRAM cdfbuoyflx

PROGRAM cdfhflx
  !!======================================================================
  !!                     ***  PROGRAM  cdfhflx  ***
  !!=====================================================================
  !!  ** Purpose : Compute the Meridional Heat Transport from the 
  !!               forcing fluxes.
  !!
  !!  ** Method  : Compute the zonaly integrated heat flux.
  !!               The program looks for the file "new_maskglo.nc". 
  !!               If it does not exist, only the calculation over all 
  !!               the whole domain is performed (this is adequate for 
  !!               a basin configuration like NATL4).
  !!               In new_maskglo.nc the masking corresponds to the global
  !!               configuration. (Global, Atlantic, Indo-Pacific, 
  !!               Indian,Pacific ocean)
  !!
  !! History : 2.1  : 07/2005  : J.M. Molines  : Original code
  !!           2.1  : 04/2006  : A.M. Treguier : adaptation to NATL4 case
  !!           2.1  : 07/2009  : R. Dussin     : Netcdf output
  !!           3.0  : 01/2011  : J.M. Molines  : Doctor norm + Lic. + generalization
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class forcing
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                             :: jbasin, ji, jj, jk, jt ! dummy loop index
  INTEGER(KIND=4)                             :: npbasins               ! number of subbasins
  INTEGER(KIND=4)                             :: ierr                   ! error status
  INTEGER(KIND=4)                             :: narg, iargc,ijarg      ! command line 
  INTEGER(KIND=4)                             :: npiglo, npjglo         ! size of the domain
  INTEGER(KIND=4)                             :: npk, npt               ! size of the domain
  INTEGER(KIND=4)                             :: ncout                  ! ncid of output file
  INTEGER(KIND=4)                             :: numout=10              ! logical unit of txt output file
  INTEGER(KIND=4)                             :: ikx=1                  ! dims of netcdf output file
  INTEGER(KIND=4), DIMENSION(:),  ALLOCATABLE :: ipk, id_varout         ! levels and varid's of output vars
  INTEGER(KIND=4), DIMENSION(2)               :: iloc                   ! used for maxloc

  REAL(KIND=4), DIMENSION(:,:,:), ALLOCATABLE :: zmask                  ! npbasins x npiglo x npjglo
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: e1t, e2t               ! horizontal metrics
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: gphit                  ! Latitide
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: zflx                   ! fluxes read on file
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: rdumlon                ! dummy longitude = 0.
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: rdumlat                ! latitude for i = north pole

  REAL(KIND=8), DIMENSION(:),     ALLOCATABLE :: dtim                   ! time counter
  REAL(KIND=8), DIMENSION(:,:),   ALLOCATABLE :: dmht                   ! cumulated heat trp
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: dhtrp                  ! MHT from fluxes

  TYPE(variable), DIMENSION(:),   ALLOCATABLE :: stypvar                ! attributes output

  CHARACTER(LEN=256)                          :: cf_tfil                ! input file
  CHARACTER(LEN=256)                          :: cf_out  ='hflx.out'    ! output txt file
  CHARACTER(LEN=256)                          :: cf_outnc='cdfhflx.nc'  ! output nc file
  CHARACTER(LEN=256)                          :: cldum                  ! working variable

  LOGICAL                                     :: lglo = .FALSE.         ! global or subbasin computation
  LOGICAL                                     :: lchk = .FALSE.         ! missing file flag
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()

  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfhflx  -f T-file [-o OUTNC-file ] [-ot OUTTXT-file] '
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the Meridional Heat Transport (MHT) from surface heat fluxes,' 
     PRINT *,'       in function of the latitude.'
     PRINT *,'       If a sub-basin file is available, MHT is computed for each sub-basin.'
     PRINT *,'       Note that the latitude is in fact a line of constant J coordinate, not'
     PRINT *,'       a true parallel, if the model grid is distorted as in the northern most'
     PRINT *,'       part of ORCA configurations.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -f T-file : a file with heat fluxes (gridT). '
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-o OUTNC-file ]: specify the name of the netcdf output file, instead of'
     PRINT *,'                    ', TRIM(cf_outnc) 
     PRINT *,'       [-ot OUTTXT-file ]: specify the name of the text output file, instead of'
     PRINT *,'                    ', TRIM(cf_out) 
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       Files ', TRIM(cn_fhgr),', ',TRIM(cn_fbasins),' and ',TRIM(cn_fmsk),'.' 
     PRINT *,'       If ',TRIM(cn_fbasins),' is not available, only global MHT is computed.'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       ASCII file  : ', TRIM(cf_out  )
     PRINT *,'       netcdf file : ', TRIM(cf_outnc) 
     PRINT *,'         variables : hflx_glo, [hflx_atl, hflx_inp, hflx_pac, hflx_ind]'
     STOP 
  ENDIF

  ijarg = 1
  DO WHILE ( ijarg <= narg )
     CALL getarg (ijarg, cldum ) ; ijarg=ijarg+1
     SELECT CASE ( cldum)
     CASE ( '-f' ) ; CALL getarg (ijarg, cf_tfil ) ; ijarg=ijarg+1
        ! options
     CASE ( '-o' ) ; CALL getarg (ijarg, cf_outnc) ; ijarg=ijarg+1
     CASE ( '-ot') ; CALL getarg (ijarg, cf_out  ) ; ijarg=ijarg+1
     CASE DEFAULT  ; PRINT *,'ERROR : ',TRIM(cldum), ': unknown option.' ; STOP 99
     END SELECT
  ENDDO

  lchk = chkfile(cn_fhgr)
  lchk = chkfile(cn_fmsk) .OR. lchk
  lchk = chkfile(cf_tfil) .OR. lchk
  IF ( lchk ) STOP 99 ! missing file

  npiglo = getdim (cf_tfil,cn_x)
  npjglo = getdim (cf_tfil,cn_y)
  npk    = getdim (cf_tfil,cn_z)
  npt    = getdim (cf_tfil,cn_t)

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  !  Detects newmaskglo file 
  lglo = .NOT. ( chkfile(cn_fbasins, ld_verbose=.FALSE.) )
  

  IF (lglo) THEN ; npbasins = 5
  ELSE           ; npbasins = 1
                 ; PRINT *,' No ',TRIM(cn_fbasins),' found : only global MHT is computed.'
  ENDIF

  ! Allocate arrays
  ALLOCATE ( zmask(npbasins,npiglo,npjglo) )
  ALLOCATE ( zflx(npiglo,npjglo) )
  ALLOCATE ( e1t(npiglo,npjglo), e2t(npiglo,npjglo), gphit(npiglo,npjglo) )
  ALLOCATE ( dhtrp (npbasins,npjglo) )
  ALLOCATE ( dmht(npbasins, npjglo) )
  ALLOCATE ( rdumlon(1,npjglo), rdumlat(1,npjglo) )
  ALLOCATE ( dtim(npt) )

  ALLOCATE (stypvar(npbasins), ipk(npbasins), id_varout(npbasins))

  e1t(  :,:) = getvar(cn_fhgr, cn_ve1t,  1, npiglo, npjglo) 
  e2t(  :,:) = getvar(cn_fhgr, cn_ve2t,  1, npiglo, npjglo) 
  gphit(:,:) = getvar(cn_fhgr, cn_gphit, 1, npiglo, npjglo)

  iloc         = MAXLOC(gphit)
  rdumlat(1,:) = gphit(iloc(1),:)
  rdumlon(:,:) = 0.   ! set the dummy longitude to 0

  CALL CreateOutput

  OPEN(numout, FILE=cf_out, FORM='FORMATTED', RECL=256)  ! to avoid wrapped line with ifort
  WRITE(numout,*)'! Zonal heat transport (integrated from surface fluxes) (in Pw)'

  ! reading the masks
  ! 1 : global ; 2 : Atlantic ; 3 : Indo-Pacif ; 4 : Indian ; 5 : Pacif
  zmask(1,:,:)= getvar(cn_fmsk, cn_vmask, 1, npiglo, npjglo)

  IF (lglo) THEN
     zmask(2,:,:) = getvar(cn_fbasins, cn_tmaskatl, 1, npiglo, npjglo)
     zmask(4,:,:) = getvar(cn_fbasins, cn_tmaskind, 1, npiglo, npjglo)
     zmask(5,:,:) = getvar(cn_fbasins, cn_tmaskpac, 1, npiglo, npjglo)
     zmask(3,:,:) = zmask(5,:,:) + zmask(4,:,:)
     ! ensure that there are no overlapping on the masks
     WHERE(zmask(3,:,:) > 0 ) zmask(3,:,:) = 1
     ! change global mask for GLOBAL periodic condition
     zmask(1,1,:) = 0.
     zmask(1,npiglo,:) = 0.
  ENDIF

  DO jt = 1, npt
     ! initialize dmht
     dmht(:,:)  = 0.d0
     dhtrp(:,:) = 0.d0
     WRITE(numout,*)' TIME =', jt, dtim(jt)/86400.,' days'

     ! Get fluxes
     zflx(:,:)= getvar(cf_tfil, cn_sohefldo, 1, npiglo, npjglo, ktime=jt)

     ! integrates 'zonally' (along i-coordinate)
     DO ji=1,npiglo
        ! For all basins 
        DO jbasin = 1, npbasins
           dmht(jbasin,:) = dmht(jbasin,:) + e1t(ji,:)*e2t(ji,:)* zmask(jbasin,ji,:)*zflx(ji,:)*1.d0
        END DO
     END DO

     ! cumulates transport from north to south
     DO jj=npjglo-1,1,-1
        dhtrp(:,jj) = dhtrp(:,jj+1) - dmht(:,jj)
     END DO

     ! transform to peta watt
     dhtrp(:,:) = dhtrp(:,:) / 1.d15    

     IF (lglo) THEN
        WRITE(numout,*)'! J        Global          Atlantic         INDO-PACIF    INDIAN  PACIF '
        DO jj=npjglo, 1, -1
           WRITE(numout,9000) jj, &
                rdumlat(1,jj), dhtrp(1,jj),      dhtrp(2,jj),        dhtrp(3,jj), dhtrp(4,jj), dhtrp(5,jj)
        ENDDO
     ELSE
        WRITE(numout,*)'! J        Global   '
        DO jj=npjglo, 1, -1
           WRITE(numout,9000) jj, rdumlat(1,jj), dhtrp(1,jj)  
        ENDDO
     ENDIF

9000 FORMAT(I4,5(1x,f9.3,1x,f8.4))

     DO jj=1, npbasins
        ierr = putvar(ncout, id_varout(jj), REAL(dhtrp(jj,:)), ipk(jj), ikx, npjglo, ktime=jt )
     END DO
  END DO   ! time loop

  ierr = closeout(ncout)
  CLOSE(numout)
CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    ! define new variables for output 
    ipk(:)                    = 1
    stypvar%cunits            = 'PW'
    stypvar%rmissing_value    = 99999.
    stypvar%valid_min         = -1000.
    stypvar%valid_max         = 1000.
    stypvar%scale_factor      = 1.
    stypvar%add_offset        = 0.
    stypvar%savelog10         = 0.
    stypvar%cunits            = 'PW' 
    stypvar%conline_operation = 'N/A'
    stypvar%caxis             = 'T'

    stypvar(1)%cname          = 'hflx_glo'
    stypvar(1)%clong_name     = 'Heat_Fluxes_Global'
    stypvar(1)%cshort_name    = 'hflx_glo'

    IF (lglo) THEN
       stypvar(2)%cname       = 'hflx_atl'             ; stypvar(3)%cname       = 'hflx_inp'
       stypvar(2)%clong_name  = 'Heat_Fluxes_Atlantic' ; stypvar(3)%clong_name  = 'Heat_Fluxes_Indo-Pacific'
       stypvar(2)%cshort_name = 'hflx_atl'             ; stypvar(3)%cshort_name = 'hflx_inp'

       stypvar(4)%cname       = 'hflx_ind'             ; stypvar(5)%cname       = 'hflx_pac'
       stypvar(4)%clong_name  = 'Heat_Fluxes_Indian'   ; stypvar(5)%clong_name  = 'Heat_Fluxes_Pacific'
       stypvar(4)%cshort_name = 'hflx_ind'             ; stypvar(5)%cshort_name = 'hflx_pac'
    ENDIF
    ! create output fileset
    ncout = create      (cf_outnc, 'none',  ikx,      npjglo, npk                                  )
    ierr  = createvar   (ncout,    stypvar, npbasins, ipk,    id_varout                            )
    ierr  = putheadervar(ncout,    cf_tfil, ikx,      npjglo, npk, pnavlon=rdumlon, pnavlat=rdumlat)

    dtim  = getvar1d(cf_tfil, cn_vtimec, npt     )
    ierr  = putvar1d(ncout,   dtim,      npt, 'T')

  END SUBROUTINE CreateOutput

END PROGRAM cdfhflx

PROGRAM cdfisf_poolchk
  !!======================================================================
  !!                     ***  PROGRAM  cdfisf_poolchk  ***
  !!=====================================================================
  !!  ** Purpose : Build a mask-like file that marks the un-connected point
  !!              in a 3D mask files. Un-connected points are points which
  !!              do not communicate with the open ocean. This case is
  !!              frequent for the ocean cavity below the ice shelves.
  !!
  !!  ** Method  : Use a fillpool3D algorithm. This program use 3D arrays
  !!               and may be very memory consuming for big domains.
  !!
  !! History :   3.0  : 11/2016  : J.M. Molines. P. Mathiot (original code)
  !!         :   4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  !!   routines                                         : description
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  USE modutils
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class ice_shelf_processing
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                               :: ji, jj, jk        ! dummy loop index
  INTEGER(KIND=4)                               :: narg, ijarg       ! command line
  INTEGER(KIND=4)                               :: npiglo, npjglo    ! domain dimension
  INTEGER(KIND=4)                               :: npk               ! domain dimension
  INTEGER(KIND=4)                               :: iiseed, ijseed    ! working seeds
  INTEGER(KIND=4)                               :: ikseed, ijmax     ! working seeds
  INTEGER(KIND=4)                               :: ifill = 2
  INTEGER(KIND=4)                               :: ncid, id          ! netcdf stuff
  INTEGER(KIND=4)                               :: ierr, ncout       ! netcdf stuff
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: ipk               ! arrays of vertical level for each var
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: id_varout         ! varid's of average vars

  INTEGER(KIND=2), DIMENSION(:,:),   ALLOCATABLE :: itab             ! 2D working array
  INTEGER(KIND=2), DIMENSION(:,:,:), ALLOCATABLE :: itab3d, itmask   ! 3D working array

  REAL(KIND=4), DIMENSION(:),        ALLOCATABLE :: rsum             ! iceshelf draft
  REAL(KIND=4), DIMENSION(:,:),      ALLOCATABLE :: rdraft           ! iceshelf draft

  CHARACTER(LEN=255)                             :: cf_in            ! input filename
  CHARACTER(LEN=255)                             :: cf_out='poolmask.nc' !default output filename
  CHARACTER(LEN=255)                             :: cf_isfdr='isf_draft.nc' ! filename for isf_draft
  CHARACTER(LEN=255)                             :: cv_isfdr='isf_draft' ! name of isf_draft variable
  CHARACTER(LEN=255)                             :: cldum            ! working char variable

  TYPE (variable), DIMENSION(:),    ALLOCATABLE  :: stypvar          ! attributes for average values

  LOGICAL                                        :: lchk=.FALSE.     ! missing files flag
  LOGICAL                                        :: lnc4=.FALSE.     ! netcdf4 flag
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()
  ! input file is a mask file, then :
  cn_t='t'
  cn_z='z'
  cn_vdeptht='nav_lev'

  narg = iargc()

  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfisf_poolchk -m MASK-file -d ISFDRAFT-file [-v ISFDRAFT-variable]'
     PRINT *,'            [-nc4] [-o OUT-file]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Produces a netcdf mask file with 1 everywhere, except for points not '
     PRINT *,'       connected to the open ocean (frequent for cavities below ice-shelves),'
     PRINT *,'       which have 0 value. Both 3D and 2D variables are created, the 2D '
     PRINT *,'       variables being used for cdfisf_forcing.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -m MASK-file : name of the input NEMO mask file, with tmask variable.'
     PRINT *,'       -d ISFDRAFT-file : name of the file with ice shelf draft.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       -v ISFDRAFT-variable: name of the variable for ice shelf draft.'
     PRINT *,'       -nc4 : use netcdf4 with chunking and deflation for the output.'
     PRINT *,'       -o OUT-file : name of the output file. [Default : ',TRIM(cf_out),' ]' 
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       Only the mask file given as argument' 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out),' unless -o option is used.'
     PRINT *,'         variables : tmask_pool3d, tmask_pool2d'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'      cdfisf_fill, cdfisf_forcing, cdfisf_rnf' 
     PRINT *,'      '
     STOP 
  ENDIF

  ijarg=1
  DO WHILE ( ijarg <= narg )
     CALL getarg(ijarg, cldum) ; ijarg = ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-m'  ) ; CALL getarg(ijarg, cf_in   ) ; ijarg = ijarg+1
     CASE ( '-o'  ) ; CALL getarg(ijarg, cf_out  ) ; ijarg = ijarg+1
     CASE ( '-d'  ) ; CALL getarg(ijarg, cf_isfdr) ; ijarg = ijarg+1
     CASE ( '-v'  ) ; CALL getarg(ijarg, cv_isfdr) ; ijarg = ijarg+1
     CASE ( '-nc4') ; lnc4 = .TRUE.
     CASE DEFAULT   ; PRINT *,' ERROR : ', TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  ENDDO

  lchk = lchk .OR. chkfile(cf_in    )
  lchk = lchk .OR. chkfile(cf_isfdr)
  IF ( lchk ) STOP 99 ! missing files

  npiglo = getdim (cf_in,cn_x )
  npjglo = getdim (cf_in,cn_y )
  npk    = getdim (cf_in,cn_z )

  PRINT *, ' NPIGLO = ', npiglo
  PRINT *, ' NPJGLO = ', npjglo
  PRINT *, ' NPK    = ', npk

  ALLOCATE ( itab(npiglo, npjglo), itab3d( npiglo, npjglo, npk), itmask(npiglo, npjglo,npk) )
  ALLOCATE ( rdraft(npiglo, npjglo), rsum(npjglo) )
  ALLOCATE ( ipk(2), id_varout(2), stypvar(2))

  CALL CreateOutput

  ! Read ice shelf draft in order to find the northern limit of the cavities
  rdraft(:,:) = getvar(cf_isfdr, cv_isfdr, 1, npiglo, npjglo )
  rsum(:)     = SUM(rdraft, DIM=1 )
  ijmax=2
  DO jj=1, npjglo-1
     IF ( rsum(jj) /= 0. ) THEN
        ijmax=jj
     ENDIF
  ENDDO
  ijmax = MIN ( npjglo, ijmax+10 )

  ! JMM :note the use of 3D array ( very unusual in CDFTOOLS )
  itmask(:,:,:) = getvar3d (cf_in, cn_tmask, npiglo, npjglo, npk)
  itab3d(:,:,:) = itmask(:,:,:)

  ! set limits  for fillpool algo
  itab3d(:,ijmax  ,1:npk-1) = 0
  itab3d(:,ijmax-1,:) = 1  ! open a connection for sure at ijmax -1 (out of iceshelf cavities)
  itab3d(:,:,    1)   = 0  ! to set an upper limit !, assuming to cavities at this level
  iiseed= npiglo/2  ; ijseed = ijmax -1 ; ikseed = 2
  PRINT *,' SEED position',iiseed, ijseed, ikseed, itab3d(iiseed, ijseed, ikseed)

  CALL FillPool3D( iiseed, ijseed,ikseed, itab3d, -ifill )
  PRINT *, '  Number of disconected points : ', COUNT(  (itab3d(:,1:ijmax-2,:) == 1) )
  ! at this point itab3d (:,1:ijmax,:) can have 3 different values :
  !              0 where there where already 0
  !              -ifill where the ocean points are connected
  !              1 where ocean points in tmask are not connected
  itab(:,:) = itmask(:,:,1)  ! restore original tmask at surface
  itab(:,1:ijmax-2) = SUM(itab3d(:,1:ijmax-2,:), dim=3) 
  WHERE (itab(:,1:ijmax-2) > 0 ) itab(:,1:ijmax-2)=0
  WHERE (itab(:,1:ijmax-2) < 0 ) itab(:,1:ijmax-2)=1

  ierr = putvar( ncout, id_varout(1), itab(:,:), 1, npiglo, npjglo)

  DO jk = 1, npk 
     ierr = putvar( ncout, id_varout(2), itab3d(:,:,jk), jk, npiglo, npjglo)
  ENDDO

  ierr = closeout(ncout)

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create the output file. This is done outside the main
    !!               in order to increase readability of the code. 
    !!
    !! ** Method  :  Use global variables, defined in main 
    !!----------------------------------------------------------------------
    REAL(KIND=8), DIMENSION(1) :: dl_tim
    !!----------------------------------------------------------------------
    ! define new variables for output
    ipk(1) = 1  !  2D
    stypvar(1)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(1)%cname             = 'tmask_pool2d'
    stypvar(1)%rmissing_value    =  -99.
    stypvar(1)%valid_min         =  0.
    stypvar(1)%valid_max         =  1.
    stypvar(1)%clong_name        = '2d isf pool mask'
    stypvar(1)%cshort_name       = 'tmask_pool2d'
    stypvar(1)%conline_operation = 'N/A'
    stypvar(1)%caxis             = 'TYX'
    stypvar(1)%cprecision        = 'by'
    ! define new variables for output
    ipk(2) = npk  !  3D
    stypvar(2)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(2)%cname             = 'tmask_pool3d'
    stypvar(2)%rmissing_value    =  -99.
    stypvar(2)%valid_min         =  0.
    stypvar(2)%valid_max         =  1
    stypvar(2)%clong_name        = '3d isf pool mask'
    stypvar(2)%cshort_name       = 'tmask_pool3d'
    stypvar(2)%conline_operation = 'N/A'
    stypvar(2)%caxis             = 'TZYX'
    stypvar(2)%cprecision        = 'by'

    ! create output file taking the sizes in cf_fill
    ncout  = create      (cf_out, cf_in,   npiglo, npjglo, npk, cdepvar=cn_vdeptht, ld_nc4=lnc4 )
    ierr   = createvar   (ncout,  stypvar, 2,   ipk, id_varout,                     ld_nc4=lnc4 )
    ierr   = putheadervar(ncout,  cf_in,   npiglo, npjglo, npk                                  )

    dl_tim(1) = 0.d0
    ierr = putvar1d(ncout, dl_tim, 1, 'T')

  END SUBROUTINE CreateOutput

END PROGRAM cdfisf_poolchk

PROGRAM cdfbuoyflx
  !!======================================================================
  !!                     ***  PROGRAM  cdfbuoyflx  ***
  !!=====================================================================
  !!  ** Purpose :  Produce a file with the water flux separated into 4 components:
  !!                E (evap), P (precip), R (runoff), dmp (sssdmp).
  !!                The total water flux is E -P -R + dmp. Units in this program
  !!                are mm/days.  (Up to that it is the same than cdfwflx)
  !!
  !!                It also produces un the same file the component of the heat flux
  !!                Latent Heat FLux, Sensible Heat flux, Long Wave HF, Short Wave HF,
  !!                Net HF
  !!
  !!                Buoyancy fluxes are also computed, as a net value but also with the
  !!                contribution of each term.
  !!
  !!  ** Method  : Evap is computed from the latent heat flux : evap=-qla/Lv
  !!               Runoff is read from the climatological input file
  !!               dmp is read from the file (sowafldp)
  !!               Precip is then computed as the difference between the
  !!               total water flux (sowaflup) and the E-R+dmp. In the high latitudes
  !!               this precip includes the effect of snow (storage/melting). Therefore
  !!               it may differ slightly from the input precip file.
  !!
  !!               Heat fluxes are directly copied from the gridT files, same name, same units
  !!               We also add sst and SSS for convenience.
  !!
  !!               Buoyancy fluxes are also computed as :
  !!                  BF = g/rho ( alpha x TF  - beta x SF ) 
  !!                       (TF = thermal part, SF = haline part )
  !!                  TF = Qnet/cp
  !!                  SF = rho x (E-P) x SSS
  !!  ** Reference :
  !!              Atmosphere, Ocean and Climate Dynamics: An Introductory Text. By John Marshall,
  !!              R. Alan Plumb ( Academic Press, 2008 ) Eq. 11.4 p 225. 
  !!
  !! History : 2.1  : 01/2008  : J.M. Molines : Original code
  !!           3.0  : 12/2010  : J.M. Molines : Doctor norm + Lic.
  !!           3.0  : 09/2015  : J.M. Molines : add nc4 capabilities, optional output file
  !!                                            short output,
  !!                                            different management of read fluxes (XIOS ...)
  !!----------------------------------------------------------------------
  USE cdfio
  USE eos
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2010, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: np_varout=25
  INTEGER(KIND=4)                           :: ncout, ierr
  INTEGER(KIND=4)                           :: jt                                ! dummy loop index
  INTEGER(KIND=4)                           :: narg, iargc, ijarg                ! command line 
  INTEGER(KIND=4)                           :: npiglo, npjglo, npt               ! size of the domain
  INTEGER(KIND=4), ALLOCATABLE, DIMENSION(:):: ipk, id_varout  

  ! Physical constants
  REAL(KIND=4)                              :: Lv = 2.5e6                        ! latent HF <--> evap conversion
  REAL(KIND=4)                              :: Cp = 4000.                        ! specific heat of water 
  REAL(KIND=4)                              :: Rho = 1026.                       ! reference density
  REAL(KIND=4)                              :: Grav = 9.81                       ! Gravity

  REAL(KIND=4)                              :: zsps                              ! Missing value for salinity
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: tim, zdep                         ! time counter, deptht
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zmask, zcoefq, zcoefw             ! work array
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zalbet, zbeta                     ! work array
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: evap, precip, runoff, wdmp, wnet  ! water flux components
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: wice, precip_runoff               ! water flux components
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: qlat, qsb, qlw, qsw, qnet         ! heat flux components
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: b_evap, b_precip, b_runoff        ! BF water flux components
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: b_wdmp, bw_net                    ! BF water flux components
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: b_qlat, b_qsb, b_qlw              ! BF heat flux components
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: b_qsw , bh_net                    ! BF heat flux components
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zsst, zsss, buoyancy_fl           ! Total buoyancy flux

  CHARACTER(LEN=256)                        :: cf_tfil ,cf_flxfil, cf_rnfil      ! input file gridT, flx and runoff
  CHARACTER(LEN=256)                        :: cf_out='buoyflx.nc'               ! output file
  CHARACTER(LEN=256)                        :: cldum                             ! dummy character variable
  CHARACTER(LEN=256)                        :: cv_sss                            ! Actual name for SSS
  CHARACTER(LEN=256)                        :: cv_sst                            ! Actual name for SST

  TYPE(variable), ALLOCATABLE, DIMENSION(:) :: stypvar                           ! structure for attributes

  LOGICAL                                   :: lchk =.false.                     ! flag for missing files
  LOGICAL                                   :: lnc4 =.false.                     ! flag for netcdf4 output
  LOGICAL                                   :: lsho =.false.                     ! flag for short output
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  !!  Read command line and output usage message if not compliant.
  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfbuoyflx  -t T-file [-r RNF-file] [-f FLX-file ] [-sss SSS-name]'
     PRINT *,'     ... [-sst SST-name] [-nc4] [-o output_file]  [-short ]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute (or read) the heat and water fluxes components.'
     PRINT *,'       Compute (or read) the net heat and water fluxes.'
     PRINT *,'       Compute the buoyancy heat and water fluxes components.'
     PRINT *,'       Compute the net buoyancy fluxes.'
     PRINT *,'       Save sss and sst. '
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -t T-file   : netcdf file with temperature and salinity '
     PRINT *,'      '
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [ -r RNF-file ] : Specify a run-off file if runoff not in T-file '
     PRINT *,'                         nor in FLX-file'
     PRINT *,'       [ -f FLX-file ] : Use this option if fluxes are not saved in gridT files'
     PRINT *,'       [ -sss SSS-name ] : Use this option if SSS variable name in T-file '
     PRINT *,'                          differ from ',TRIM(cn_vosaline)
     PRINT *,'       [ -sst SST-name ] : Use this option if SST variable name in T-file '
     PRINT *,'                          differ from ',TRIM(cn_votemper)
     PRINT *,'       [ -nc4 ] Use netcdf4 output with chunking and deflation level 1'
     PRINT *,'               This option is effective only if cdftools are compiled with'
     PRINT *,'               a netcdf library supporting chunking and deflation.'
     PRINT *,'       [ -o output_file ] Default is ', TRIM(cf_out)
     PRINT *,'       [ -short ] With this option only save the buoyancy flux without '
     PRINT *,'                  all the components of the flux.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        none'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : 25 variables (2D) or 1 variable in case of -short option'
     PRINT *,'      '
     PRINT *,'     WARNING : '
     PRINT *,'         cdfbuoyflx is not working yet with CMIP6 output' 
     PRINT *,'     SEE ALSO :'
     PRINT *,'      '
     PRINT *,'      '
     STOP
  ENDIF

  IF (TRIM(cn_output) == 'CMIP6') THEN
      PRINT *, 'cdfbuoyflx is not working yet with CMIP6 output'
      STOP 99
  END IF


  ijarg   = 1
  cf_flxfil='none'
  cf_rnfil='none'
  cv_sss=cn_vosaline
  cv_sst=cn_votemper

  DO   WHILE ( ijarg <= narg ) 
     CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1
     SELECT CASE ( cldum )
     CASE ( '-f' )     ! specify  flx files
        CALL getarg (ijarg, cf_flxfil) ; ijarg = ijarg + 1
        lchk = lchk .OR. chkfile (cf_flxfil)
     CASE ( '-t' )     ! specify  T files
        CALL getarg (ijarg, cf_tfil) ; ijarg = ijarg + 1
        lchk = lchk .OR. chkfile (cf_tfil  )
     CASE ( '-r' )     ! specify  runoff files
        CALL getarg (ijarg, cf_rnfil) ; ijarg = ijarg + 1
        lchk = lchk .OR. chkfile (cf_rnfil )
     CASE ( '-sss' )     ! specify  runoff files
        CALL getarg (ijarg, cv_sss) ; ijarg = ijarg + 1
     CASE ( '-sst' )     ! specify  runoff files
        CALL getarg (ijarg, cv_sst) ; ijarg = ijarg + 1
     CASE ( '-nc4' )   !  allow chunking and deflation on output
        lnc4 = .true.
     CASE ( '-o' )     ! specify  output files
        CALL getarg (ijarg, cf_out) ; ijarg = ijarg + 1
     CASE ( '-short' ) ! use short output ( only buoyancy fluxes )
        lsho = .true. ; np_varout = 1
     CASE DEFAULT
        PRINT *, " Option ", TRIM(cldum)," not supported "
        STOP 99
     END SELECT
  ENDDO
  IF (lchk ) STOP 99 ! missing files

  IF ( cf_flxfil == 'none' ) THEN
    cf_flxfil = cf_tfil
  ENDIF
  ! If no runoff file specified, assume that run off are in flx file [ which must be read by the way ... ]
  IF ( cf_rnfil == 'none' ) THEN
    cf_rnfil = cf_flxfil
  ENDIF

  ! Look for Missing value for salinity
  zsps = getspval(cf_tfil, cn_vosaline)

  npiglo = getdim (cf_tfil,cn_x)
  npjglo = getdim (cf_tfil,cn_y)
  npt    = getdim (cf_tfil,cn_t)

  PRINT *, 'npiglo =', npiglo
  PRINT *, 'npjglo =', npjglo
  PRINT *, 'npt    =', npt

  CALL CreateOutput

  ! always allocated
  ALLOCATE ( zmask(npiglo,npjglo), wnet(npiglo,npjglo), zalbet(npiglo,npjglo), zbeta(npiglo, npjglo) )
  ALLOCATE ( zcoefq(npiglo,npjglo), zcoefw(npiglo,npjglo), qnet(npiglo,npjglo) )
  ALLOCATE ( bw_net(npiglo,npjglo) ,bh_net(npiglo,npjglo)) 
  ALLOCATE ( buoyancy_fl(npiglo,npjglo), zsst(npiglo,npjglo), zsss(npiglo,npjglo) )

  ! allocated only for full output
  IF ( .NOT. lsho ) THEN
  ALLOCATE ( evap(npiglo,npjglo), precip(npiglo,npjglo), runoff(npiglo,npjglo), wdmp(npiglo,npjglo) )
  ALLOCATE ( wice(npiglo,npjglo), precip_runoff(npiglo,npjglo) )
  ALLOCATE ( qlat(npiglo,npjglo), qsb(npiglo,npjglo), qlw(npiglo,npjglo), qsw(npiglo,npjglo) )
  ALLOCATE ( b_evap(npiglo,npjglo), b_precip(npiglo,npjglo), b_runoff(npiglo,npjglo), b_wdmp(npiglo,npjglo) ) 
  ALLOCATE ( b_qlat(npiglo,npjglo), b_qsb(npiglo,npjglo),    b_qlw(npiglo,npjglo),    b_qsw(npiglo,npjglo)  )
  ENDIF

  DO jt = 1, npt
     ! read sss for masking purpose and sst
     zsss(:,:) = getvar(cf_tfil, cv_sss, 1, npiglo, npjglo, ktime=jt)
     zmask=1. ; WHERE ( zsss == zsps ) zmask=0.
     zsst(:,:) = getvar(cf_tfil, cv_sst, 1, npiglo, npjglo, ktime=jt)

     ! total water flux (emps)
     wnet(:,:) = getvar(cf_flxfil, cn_sowaflup, 1, npiglo, npjglo, ktime=jt )*86400.*zmask(:,:)          ! mm/days
     qnet(:,:)=  getvar(cf_flxfil, cn_sohefldo, 1, npiglo, npjglo, ktime=jt )*zmask(:,:)    ! W/m2 

     ! buoyancy flux
     zalbet(:,:)= albet ( zsst, zsss, 0., npiglo, npjglo)
     zbeta (:,:)= beta  ( zsst, zsss, 0., npiglo, npjglo)
     zcoefq(:,:)= Grav/Rho *( zbeta * zalbet /Cp ) * 1.e6
     zcoefw(:,:)= Grav* zbeta * zsss / 86400. /1000 * 1.e6   ! division by 86400 and 1000 to get back water fluxes in m/s

     buoyancy_fl=0. ; bh_net=0. ; bw_net=0.
     WHERE ( zmask == 1 ) 
        bh_net(:,:)= zcoefq * qnet
        bw_net(:,:)= zcoefw * wnet
        buoyancy_fl(:,:) = ( bh_net - bw_net ) 
     END WHERE

     IF ( .NOT. lsho ) THEN
     ! Evap : 
     qlat(:,:)= getvar(cf_flxfil, cn_solhflup, 1, npiglo, npjglo, ktime=jt) *zmask(:,:)    ! W/m2 
     evap(:,:)= -1.* qlat(:,:) /Lv*86400. *zmask(:,:)                                    ! mm/days

     ! Wdmp
     wdmp(:,:)= getvar(cf_flxfil, cn_sowafldp, 1, npiglo, npjglo, ktime=jt)*86400.*zmask(:,:) ! mm/days

     ! Runoff  ! take care : not a model output (time_counter may disagree ... jmm
     runoff(:,:)= getvar(cf_rnfil, 'sorunoff', 1, npiglo, npjglo)*86400.*zmask(:,:)         ! mm/days

     ! fsalt = contribution of ice freezing and melting to salinity ( + = freezing, - = melting )Q
     wice(:,:) = getvar(cf_flxfil, cn_iowaflup, 1, npiglo, npjglo, ktime=jt )*86400.*zmask(:,:)          ! mm/days

     ! Precip:
     precip(:,:)= evap(:,:)-runoff(:,:)+wdmp(:,:)-wnet(:,:)+wice(:,:)                     ! mm/day

     ! Precip+runoff : (as a whole ) (interpolated on line)
     precip_runoff(:,:)= evap(:,:)+wdmp(:,:)-wnet(:,:)+wice(:,:)                          ! mm/day

     ! other heat fluxes
     qsb(:,:)= getvar(cf_flxfil, cn_sosbhfup,  1, npiglo, npjglo, ktime = jt )*zmask(:,:)    ! W/m2 
     qlw(:,:)= getvar(cf_flxfil, cn_solwfldo,  1, npiglo, npjglo, ktime = jt )*zmask(:,:)    ! W/m2 
     qsw(:,:)= getvar(cf_flxfil, cn_soshfldo,  1, npiglo, npjglo, ktime = jt )*zmask(:,:)    ! W/m2 


     b_qlat=0.  ; b_qlw=0.    ; b_qsw=0.   ; b_qsb=0.
     b_evap=0.  ; b_precip=0. ; b_wdmp=0.  ; b_runoff=0.

     WHERE (zsss /= 0 ) 
        b_qlat(:,:)= zcoefq * qlat
        b_qlw (:,:)= zcoefq * qlw
        b_qsw (:,:)= zcoefq * qsw
        b_qsb (:,:)= zcoefq * qsb

        b_evap(:,:)= zcoefw * evap
        b_precip(:,:)= -zcoefw * precip
        b_runoff(:,:)= -zcoefw * runoff
        b_wdmp(:,:)= zcoefw * wdmp

        !    buoyancy_fl(:,:) = zcoefq * qnet +zcoefw * wnet
     END WHERE
     ENDIF

     ! Write output file
     IF ( lsho ) THEN
        ierr = putvar(ncout, id_varout(1),buoyancy_fl, 1,npiglo, npjglo, ktime=jt )
     ELSE
        ierr = putvar(ncout, id_varout(1), evap,   1, npiglo, npjglo, ktime=jt )
        ierr = putvar(ncout, id_varout(2), precip, 1, npiglo, npjglo, ktime=jt )
        ierr = putvar(ncout, id_varout(3), runoff, 1, npiglo, npjglo, ktime=jt )
        ierr = putvar(ncout, id_varout(4), wdmp,   1, npiglo, npjglo, ktime=jt )
        ierr = putvar(ncout, id_varout(5), wnet,   1, npiglo, npjglo, ktime=jt )
        ierr = putvar(ncout, id_varout(6), wice,   1, npiglo, npjglo, ktime=jt )
        ierr = putvar(ncout, id_varout(7), precip_runoff,   1,npiglo, npjglo, ktime=jt )

        ierr = putvar(ncout, id_varout(8), qlat,   1, npiglo, npjglo, ktime=jt )
        ierr = putvar(ncout, id_varout(9), qsb,    1, npiglo, npjglo, ktime=jt )
        ierr = putvar(ncout, id_varout(10),qlw,    1, npiglo, npjglo, ktime=jt )
        ierr = putvar(ncout, id_varout(11),qsw,    1, npiglo, npjglo, ktime=jt )
        ierr = putvar(ncout, id_varout(12),qnet,   1, npiglo, npjglo, ktime=jt )

        ierr = putvar(ncout, id_varout(13),b_evap,  1, npiglo, npjglo, ktime=jt )
        ierr = putvar(ncout, id_varout(14),b_precip,1, npiglo, npjglo, ktime=jt )
        ierr = putvar(ncout, id_varout(15),b_runoff,1, npiglo, npjglo, ktime=jt )
        ierr = putvar(ncout, id_varout(16),b_wdmp,  1, npiglo, npjglo, ktime=jt )
        ierr = putvar(ncout, id_varout(17),bw_net,  1, npiglo, npjglo, ktime=jt )

        ierr = putvar(ncout, id_varout(18),b_qlat,  1, npiglo, npjglo, ktime=jt )
        ierr = putvar(ncout, id_varout(19),b_qsb,   1, npiglo, npjglo, ktime=jt )
        ierr = putvar(ncout, id_varout(20),b_qlw,   1, npiglo, npjglo, ktime=jt )
        ierr = putvar(ncout, id_varout(21),b_qsw,   1, npiglo, npjglo, ktime=jt )
        ierr = putvar(ncout, id_varout(22),bh_net,  1, npiglo, npjglo, ktime=jt )

        ierr = putvar(ncout, id_varout(23),buoyancy_fl, 1,npiglo, npjglo, ktime=jt )

        ierr = putvar(ncout, id_varout(24), zsss,  1, npiglo, npjglo, ktime=jt )
        ierr = putvar(ncout, id_varout(25), zsst,  1, npiglo, npjglo, ktime=jt )
     ENDIF
  END DO  ! time loop

  tim  = getvar1d(cf_tfil, cn_vtimec, npt     )
  ierr = putvar1d(ncout,   tim,       npt, 'T')

  ierr=closeout(ncout)

CONTAINS
  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Set up all things required for the output file, create
    !!               the file and write the header part.
    !!
    !! ** Method  :  Use global module variables
    !!
    !!----------------------------------------------------------------------
    INTEGER(KIND=4) :: jv   ! dummy loop index
    !!----------------------------------------------------------------------
    ! prepare output variables
    ALLOCATE (zdep(1), tim(npt) )
    zdep(1) = 0.
    ALLOCATE (ipk(np_varout), id_varout(np_varout), stypvar(np_varout) )
    ipk(:)  = 1  ! all variables ( output are 2D)
    stypvar%conline_operation = 'N/A'
    stypvar%caxis             = 'TYX'
    DO jv = 1, np_varout
       stypvar(jv)%ichunk = (/npiglo,MAX(1,npjglo/30), 1, 1 /)
    ENDDO

    IF ( lsho ) THEN
       ! total buoyancy flux
       stypvar(1)%cname= 'buoyancy_fl'
       stypvar(1)%cunits='1e-6 m2/s3'
       stypvar(1)%rmissing_value=0.
       stypvar(1)%valid_min= -100.
       stypvar(1)%valid_max= 100.
       stypvar(1)%clong_name='buoyancy flux'
       stypvar(1)%cshort_name='buoyancy_fl'
    ELSE
       ! 1--> 7 water fluxes                     ;   ! 8 --> 12    heat fluxes
       stypvar(1)%cname= 'evap'                  ;  stypvar(8)%cname= 'latent'      
       stypvar(2)%cname= 'precip'                ;  stypvar(9)%cname= 'sensible'      
       stypvar(3)%cname= 'runoff'                ;  stypvar(10)%cname= 'longwave'      
       stypvar(4)%cname= 'sssdmp'                ;  stypvar(11)%cname= 'solar'      
       stypvar(5)%cname= 'watnet'                ;  stypvar(12)%cname= 'heatnet'      
       stypvar(6)%cname= 'wice'            
       stypvar(7)%cname= 'precip_runoff'  

       stypvar(1:7)%cunits='mm/day'              ;  stypvar(8:12)%cunits='W/m2'      
       stypvar(1:7)%rmissing_value=0.            ;  stypvar(8:12)%rmissing_value=0.      
       stypvar(1:7)%valid_min= -100.             ;  stypvar(8:12)%valid_min= -500.      
       stypvar(1:7)%valid_max= 100.              ;  stypvar(8:12)%valid_max= 500.      
       stypvar(1)%clong_name='Evaporation'       ;  stypvar(8)%clong_name='Latent Heat flux'      
       stypvar(2)%clong_name='Precipitation'     ;  stypvar(9)%clong_name='Sensible Heat flux'       
       stypvar(3)%clong_name='Runoff'            ;  stypvar(10)%clong_name='Long Wave Heat flux'      
       stypvar(4)%clong_name='SSS damping'       ;  stypvar(11)%clong_name='Short Wave Heat flux'
       stypvar(5)%clong_name='Total water flux'  ;  stypvar(12)%clong_name='Net Heat Flux'      
       stypvar(6)%clong_name='Ice congelation and melting'  
       stypvar(7)%clong_name='Precip and runoff together' 

       stypvar(1)%cshort_name='evap'             ;  stypvar(8)%cshort_name='latent'      
       stypvar(2)%cshort_name='precip'           ;  stypvar(9)%cshort_name='sensible'      
       stypvar(3)%cshort_name='runoff'           ;  stypvar(10)%cshort_name='longwave'      
       stypvar(4)%cshort_name='sssdmp'           ;  stypvar(11)%cshort_name='solar'      
       stypvar(5)%cshort_name='watnet'           ;  stypvar(12)%cshort_name='heatnet'       
       stypvar(6)%cshort_name='wice'  
       stypvar(7)%cshort_name='precip_runoff' 

       ! 13--> 17  buoy water fluxes             ;   ! 18 --> 22    buoy heat fluxes
       stypvar(13)%cname= 'evap_b'               ;  stypvar(18)%cname= 'latent_b'
       stypvar(14)%cname= 'precip_b'             ;  stypvar(19)%cname= 'sensible_b'
       stypvar(15)%cname= 'runoff_b'             ;  stypvar(20)%cname= 'longwave_b'
       stypvar(16)%cname= 'sssdmp_b'             ;  stypvar(21)%cname= 'solar_b'
       stypvar(17)%cname= 'watnet_b'             ;  stypvar(22)%cname= 'heatnet_b'

       stypvar(13:17)%cunits='1e-6 m2/s3'      ;  stypvar(18:22)%cunits='1e-6 m2/s3'
       stypvar(13:17)%rmissing_value=0.          ;  stypvar(18:22)%rmissing_value=0.
       stypvar(13:17)%valid_min= -100.           ;  stypvar(18:22)%valid_min= -500.
       stypvar(13:17)%valid_max= 100.            ;  stypvar(18:22)%valid_max= 500.

       stypvar(13)%clong_name='buoy flx evap'    ;  stypvar(18)%clong_name='buoy Latent Heat flux'
       stypvar(14)%clong_name='buoy flx precip'  ;  stypvar(19)%clong_name='buoy Sensible Heat flux'
       stypvar(15)%clong_name='buoy flx runoff'  ;  stypvar(20)%clong_name='buoy Long Wave Heat flux'
       stypvar(16)%clong_name='buoy flx damping' ;  stypvar(21)%clong_name='buoy Short Wave Heat flux'
       stypvar(17)%clong_name='buoy haline flx'  ;  stypvar(22)%clong_name='buoy thermo Flux'

       stypvar(13)%cshort_name='evap_b'          ;  stypvar(18)%cshort_name='latent_b'
       stypvar(14)%cshort_name='precip_b'        ;  stypvar(19)%cshort_name='sensible_b'
       stypvar(15)%cshort_name='runoff_b'        ;  stypvar(20)%cshort_name='longwave_b'
       stypvar(16)%cshort_name='sssdmp_b'        ;  stypvar(21)%cshort_name='solar_b'
       stypvar(17)%cshort_name='watnet_b'        ;  stypvar(22)%cshort_name='heatnet_b'

       ! total buoyancy flux
       stypvar(23)%cname= 'buoyancy_fl'
       stypvar(23)%cunits='1e-6 m2/s3'
       stypvar(23)%rmissing_value=0.
       stypvar(23)%valid_min= -100.
       stypvar(23)%valid_max= 100.
       stypvar(23)%clong_name='buoyancy flux'
       stypvar(23)%cshort_name='buoyancy_fl'

       ! SSS                                         ; SST
       stypvar(24)%cname= 'sss'                      ;   stypvar(25)%cname= 'sst'
       stypvar(24)%cunits='PSU'                      ;   stypvar(25)%cunits='Celsius'
       stypvar(24)%rmissing_value=0.                 ;   stypvar(25)%rmissing_value=0.
       stypvar(24)%valid_min= 0.                     ;   stypvar(25)%valid_min= -2.
       stypvar(24)%valid_max= 45                     ;   stypvar(25)%valid_max= 45
       stypvar(24)%clong_name='Sea Surface Salinity' ;   stypvar(25)%clong_name='Sea Surface Temperature'
       stypvar(24)%cshort_name='sss  '               ;   stypvar(25)%cshort_name='sst'
    ENDIF

    ncout = create      (cf_out, cf_tfil, npiglo,    npjglo, 1,          ld_nc4=lnc4 )
    ierr  = createvar   (ncout,  stypvar, np_varout, ipk,    id_varout , ld_nc4=lnc4 )
    ierr  = putheadervar(ncout,  cf_tfil, npiglo,    npjglo, 1,   pdep=zdep )
  END SUBROUTINE CreateOutput


END PROGRAM cdfbuoyflx

PROGRAM cdfstats
   !!======================================================================
   !!                     ***  PROGRAM  cdfstats  ***
   !!=====================================================================
   !!  ** Purpose : Compute RMS/CORREL between 2 files. 
   !!               Seasonal cycle removed
   !!
   !!  ** Method  :
   !!
   !! History : 2.1  : 2009     : M.A. Balmaseda : original code  from cdfrmsssh.f90
   !!           3.0  : 10/2012  : M.A. Balmaseda : Merged into CDFTOOLS_3.0
   !!           3.0  : 11/2012  : J.M. Molines   : Dr norm + licence
   !!----------------------------------------------------------------------
   USE cdfio
   USE modcdfnames
   USE modutils,  ONLY : SetGlobalAtt
   !!----------------------------------------------------------------------
   !! CDFTOOLS_3.0 , MEOM 2012
   !! $Id$
   !! Copyright (c) 2012, J.-M. Molines
   !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
   !!----------------------------------------------------------------------
   IMPLICIT NONE

   INTEGER(KIND=4)                           :: jt, jm                 ! dummy loop index
   INTEGER(KIND=4)                           :: narg, iargc, ijarg, ij ! browse command line
   INTEGER(KIND=4)                           :: npiglo, npjglo         ! size of the domain
   INTEGER(KIND=4)                           :: npk, nt                ! size of the domain
   INTEGER(KIND=4), PARAMETER                :: jpvar=4                ! number of output variables
   INTEGER(KIND=4), DIMENSION(jpvar)         :: ipk, id_varout

   TYPE(variable), DIMENSION(jpvar)          :: stypvar                ! structure for attribute

   REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: u, v                   ! input variables from file 1 and 2
   REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: tmask, e1t, e2t        ! mask and metrics
   REAL(KIND=4), DIMENSION(1)                :: timean                 ! time for output (dummy)

   REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dl_er, dl_uv           ! rms, correlation
   REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dl_sn, dl_sg           ! signal/noise signal ratios
   REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dl_du, dl_dv           !  variable anomaly
   REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dl_u2, dl_v2           ! quadratic sum
   REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dl_um, dl_vm           ! linear sum
   REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dl_area                ! cell areas
   REAL(KIND=8)                              :: dl_spma                ! total area of the ocean ( info only)
   REAL(KIND=8)                              :: dl_spmu, dl_spmv       ! global mean (info only)
   REAL(KIND=8)                              :: dl_fct, dl_fcts        ! scaling coefficients

   CHARACTER(LEN=256)                        :: cf_in, cf_ref          ! input and reference file names
   CHARACTER(LEN=256)                        :: cf_msk, cf_hgr         ! current mask and hgr file
   CHARACTER(LEN=256)                        :: cf_out = 'stats.nc'    ! output file
   CHARACTER(LEN=256)                        :: cglobal                ! Global attribute
   CHARACTER(LEN=256)                        :: cldum                  ! dummy string for arguments
   CHARACTER(LEN=20)                         :: cv_name1, cv_name2     ! variable name
   CHARACTER(LEN=2)                          :: cy                     ! (1 or 12 ) 

   INTEGER(KIND=4)                           :: ncy                    ! 1/12 for annual/seasonal statistics
   INTEGER(KIND=4)                           :: ncout                  ! ID of netcdf output file
   INTEGER(KIND=4)                           :: ierr                   ! error status for ncdf

   LOGICAL                                   :: lchk                   ! flag for checking missing files
   !!--------------------------------------------------------------------------------------------------------
   CALL ReadCdfNames()

   narg= iargc()
   IF ( narg < 3 ) THEN
      PRINT *,' usage : cdfstats IN-file REF-file ncy [VAR-name1 [VAR-name2]] ...'
      PRINT *,'                [-m mesh_mask file ]'
      PRINT *,'      '
      PRINT *,'     PURPOSE :'
      PRINT *,'            This tool computes some statistics (rms, correlation, '
      PRINT *,'         signal/noise ratio and signal ratio [ratio of std '
      PRINT *,'         deviation]) between to files. In this tool, the files'
      PRINT *,'         are supposed to hold monthly averages values, for many '
      PRINT *,'         years. Specifying ncy=12, allows to remove the seasonal'
      PRINT *,'         cycle of the data.'
      PRINT *,'            This program was initially written for SSH statistics'
      PRINT *,'         between model output and AVISO files (default variable'
      PRINT *,'         names are ',TRIM(cn_sossheig),' for this reason ). It can'
      PRINT *,'         now be used with any variables.'
      PRINT *,'      '
      PRINT *,'     ARGUMENTS :'
      PRINT *,'        IN-file  : First data file ( usually model output) '
      PRINT *,'        REF-file : Second data file ( usually observation file) '
      PRINT *,'        ncy      : 1 or 12. If set to 12, annual cycle is removed '
      PRINT *,'                   from the data '
      PRINT *,'        [VAR-name1 [VAR-name2]] : If variable names of input files'
      PRINT *,'                 are not ', TRIM(cn_sossheig),' they can be specified'
      PRINT *,'                 on the command line. If only one name is given, it is'
      PRINT *,'                 assumed that both file use same variable name.'
      PRINT *,'      '
      PRINT *,'     OPTIONS :'
      PRINT *,'        -m mesh_mask file : specify a mesh_mask file holding the tmaskutil'
      PRINT *,'                 and the horizontal metrics. If this option is not used,'
      PRINT *,'                 mask are taken in ',TRIM(cn_fmsk), ' and horizontal metric'
      PRINT *,'                 is taken in ',TRIM(cn_fhgr)
      PRINT *,'      '
      PRINT *,'     REQUIRED FILES :'
      PRINT *,'       ' , TRIM(cn_fmsk),' and ', TRIM(cn_fhgr)
      PRINT *,'           or mesh_mask file specified in -m option'
      PRINT *,'      '
      PRINT *,'     OUTPUT : '
      PRINT *,'        netcdf file : ', TRIM(cf_out) 
      PRINT *,'         variables are : ' 
      PRINT *,'               rms    : RMS between the input files'
      PRINT *,'               correl : CORREL between the input files'
      PRINT *,'               rrat   : Signal to noise ratio '
      PRINT *,'               srat   : Signal ratio (stdev ratio) '
      PRINT *,'      '
      STOP
   ENDIF

   ! default values
   cf_msk   = cn_fmsk
   cf_hgr   = cn_fhgr
   cv_name1 = cn_sossheig  
   cv_name2 = cn_sossheig  
   CALL SetGlobalAtt( cglobal )  ! global attribute for history : command line

   ! Browse command line
   ijarg = 1 ; ij    = 0
   DO WHILE (ijarg <= narg )
      CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1
      SELECT CASE ( cldum )
      CASE ( '-m ' )     ! non default mesh-mask file
         CALL getarg (ijarg, cldum ) ; ijarg = ijarg + 1
         cf_msk = cldum
         cf_hgr = cldum
      CASE DEFAULT       ! the order of arguments does matter !
         ij = ij + 1
         SELECT CASE (ij)
         CASE ( 1 ) ; cf_in    = cldum 
         CASE ( 2 ) ; cf_ref   = cldum
         CASE ( 3 ) ; cy       = cldum ; READ(cy, * ) ncy
         CASE ( 4 ) ; cv_name1 = cldum
         CASE ( 5 ) ; cv_name2 = cldum
         CASE DEFAULT
            PRINT *, ' Too many arguments ...'
            STOP
         END SELECT
      END SELECT
    END DO

    IF (ij == 4 ) cv_name2 = cv_name1   ! if only one variable name given, take the same for both

   ! Security check for files
   lchk = chkfile ( cf_in  )
   lchk = chkfile ( cf_ref ) .OR. lchk
   lchk = chkfile ( cf_msk ) .OR. lchk
   lchk = chkfile ( cf_hgr ) .OR. lchk
   IF (lchk ) STOP ! missing files

   ! log arguments do far
   PRINT *,'IN-file   : ', TRIM(cf_in )
   PRINT *,'REF-file  : ', TRIM(cf_ref)
   PRINT *,'NCY       : ', ncy
   PRINT *,'VAR-name1 : ', TRIM(cv_name1)
   PRINT *,'VAR_name2 : ', TRIM(cv_name2)
   PRINT *,'MASK file : ', TRIM(cf_msk  )
   PRINT *,'HGR file  : ', TRIM(cf_hgr  )

   ! define domain size from IN-file
   npiglo = getdim (cf_in, cn_x )
   npjglo = getdim (cf_in, cn_y )
   nt     = getdim (cf_in, cn_t )  ! read time dimension
   npk    = 1

   PRINT *, 'NPIGLO =', npiglo
   PRINT *, 'NPJGLO =', npjglo
   PRINT *, 'NPK    =', npk

   ! Allocate arrays from domain size
   ALLOCATE(     u(npiglo,npjglo),   v(npiglo,npjglo)                     )
   ALLOCATE( tmask(npiglo,npjglo), e1t(npiglo,npjglo), e2t(npiglo,npjglo) )

   ALLOCATE( dl_er(npiglo,npjglo), dl_uv(npiglo,npjglo) )
   ALLOCATE( dl_sn(npiglo,npjglo), dl_sg(npiglo,npjglo) )
   ALLOCATE( dl_u2(npiglo,npjglo), dl_v2(npiglo,npjglo) )
   ALLOCATE( dl_du(npiglo,npjglo), dl_dv(npiglo,npjglo) )
   ALLOCATE( dl_um(npiglo,npjglo), dl_vm(npiglo,npjglo) )
   ALLOCATE( dl_area(npiglo,npjglo)                     )

   ! prepare output file 
   !   common features to all variables
   ipk    (:)                   = 1
   stypvar(:)%conline_operation = 'N/A'
   stypvar(:)%caxis             = 'TYX'

   !   specific features
   stypvar(1)%cname             = 'rms'
   stypvar(1)%cunits            = 'm'
   stypvar(1)%rmissing_value    = 0.
   stypvar(1)%valid_min         = 0.
   stypvar(1)%valid_max         = 100.
   stypvar(1)%clong_name        = 'RMS_'//TRIM(cv_name1)//'_'//TRIM(cv_name2)//'_'//cy
   stypvar(1)%cshort_name       = 'rms'

   stypvar(2)%cname             = 'correl'
   stypvar(2)%cunits            = 'ndim'
   stypvar(2)%rmissing_value    = 0.
   stypvar(2)%valid_min         = -1.
   stypvar(2)%valid_max         = 1.
   stypvar(2)%clong_name        = 'CORREL_'//TRIM(cv_name1)//'_'//TRIM(cv_name2)//'_'//cy
   stypvar(2)%cshort_name       = 'correl'

   stypvar(3)%cname             = 'rrat'
   stypvar(3)%cunits            = 'N/A'
   stypvar(3)%rmissing_value    = 0.
   stypvar(3)%valid_min         = 0.
   stypvar(3)%valid_max         = 100.
   stypvar(3)%clong_name        = 'RMS/signal_'//TRIM(cv_name1)//'_'//TRIM(cv_name2)//'_'//cy
   stypvar(3)%cshort_name       = 'rrat'

   stypvar(4)%cname             = 'srat'
   stypvar(4)%cunits            = 'N/A'
   stypvar(4)%rmissing_value    = 0.
   stypvar(4)%valid_min         = 0.
   stypvar(4)%valid_max         = 100.
   stypvar(4)%clong_name        = 'sdvm/sdvo_'//TRIM(cv_name1)//'_'//TRIM(cv_name2)//'_'//cy
   stypvar(4)%cshort_name       = 'srat'

   ! Read mask and metrics  
   tmask= getvar(cf_msk, 'tmaskutil', 1, npiglo, npjglo)
   e1t  = getvar(cf_hgr, cn_ve1t,     1, npiglo, npjglo)
   e2t  = getvar(cf_hgr, cn_ve2t,     1, npiglo, npjglo)

   dl_area(:,:) = tmask(:,:)*e1t(:,:)*e2t(:,:)*1.d0   ! masked cell area
   dl_spma      = SUM(dl_area)                        ! model ocean area
   dl_fct       = 1.d0/float(nt)
   dl_fcts      = 1.d0*float(ncy)*dl_fct

   PRINT *, 'dl_spma = ',dl_spma, SUM(tmask)

   PRINT *,' creating output file'
   ncout = create   (cf_out, cf_in,   npiglo, npjglo, npk                              )
   ierr  = createvar(ncout,  stypvar, jpvar,  ipk,    id_varout, cdglobal=TRIM(cglobal))

   PRINT *,' output file created'
   dl_er(:,:) = 0.d0   ! rms
   dl_uv(:,:) = 0.d0   ! correlation
   dl_u2(:,:) = 0.d0   ! variance var1
   dl_v2(:,:) = 0.d0   ! variance var2
   dl_sn(:,:) = 0.d0   ! signal to noise ratio (rms/sdv)
   dl_sg(:,:) = 0.d0   ! signal ratio  (sdv(1)/sdv(2))

   DO jm = 1, ncy      ! loop on month (ncy=12)  or no loop if annual file (ncy=1)
      dl_um(:,:) = 0.d0
      dl_vm(:,:) = 0.d0
      PRINT *,' computing mean for month ',jm
      DO jt = jm, nt, ncy
         u(:,:) = getvar(cf_in , cv_name1, 1, npiglo, npjglo, ktime=jt)
         v(:,:) = getvar(cf_ref, cv_name2, 1, npiglo, npjglo, ktime=jt)

         dl_um(:,:) = dl_um(:,:) + u(:,:)*tmask(:,:)*1.d0
         dl_vm(:,:) = dl_vm(:,:) + v(:,:)*tmask(:,:)*1.d0
      ENDDO

      dl_um(:,:) = dl_um(:,:)*dl_fcts
      dl_vm(:,:) = dl_vm(:,:)*dl_fcts

      PRINT *,'MIN MAX UM ',MINVAL(dl_um), MAXVAL(dl_um)
      PRINT *,'MIN MAX VM ',MINVAL(dl_vm), MAXVAL(dl_vm)
      PRINT *,'computing 2nd order statistics'
      DO jt = jm, nt, ncy
         u(:,:) = getvar(cf_in , cv_name1, 1, npiglo, npjglo, ktime = jt)
         v(:,:) = getvar(cf_ref, cv_name2, 1, npiglo, npjglo, ktime = jt)

         ! anomaly
         dl_du(:,:) = (u(:,:) - dl_um(:,:))*tmask(:,:)
         dl_dv(:,:) = (v(:,:) - dl_vm(:,:))*tmask(:,:)

         ! REM no used if print below commented out (jmm ?)
         !         dl_spmu = SUM(u(:,:)*dl_area(:,:))/dl_spma
         !         dl_spmv = SUM(v(:,:)*dl_area(:,:))/dl_spma
         !         PRINT *,' jt, dl_spmu, dl_spmv ', jt, dl_spmu,dl_spmv

         dl_u2(:,:)=dl_u2(:,:) +  dl_du(:,:)             *  dl_du(:,:)
         dl_v2(:,:)=dl_v2(:,:) +  dl_dv(:,:)             *  dl_dv(:,:)
         dl_er(:,:)=dl_er(:,:) + (dl_du(:,:)-dl_dv(:,:)) * (dl_du(:,:)-dl_dv(:,:))
         dl_uv(:,:)=dl_uv(:,:) +  dl_du(:,:)             *  dl_dv(:,:)
      ENDDO
   ENDDO    ! loop on month

   dl_u2(:,:) = dl_u2(:,:)*dl_fct
   dl_v2(:,:) = dl_v2(:,:)*dl_fct 
   dl_uv(:,:) = dl_uv(:,:)*dl_fct
   dl_er(:,:) = SQRT(dl_er(:,:)*dl_fct)

   WHERE (tmask(:,:) > 0 )  dl_uv(:,:) = dl_uv(:,:)/SQRT(dl_u2(:,:)*dl_v2(:,:))
   WHERE (tmask(:,:) > 0 )  dl_sn(:,:) = dl_er(:,:)/SQRT(dl_v2(:,:))
   WHERE (tmask(:,:) > 0 )  dl_sg(:,:) = SQRT(dl_u2(:,:)/dl_v2(:,:))

   ! some print on standard output
   PRINT *,'MIN MAX RMS          ', MINVAL(dl_er), MAXVAL(dl_er)
   PRINT *,'MIN MAX CORREL       ', MINVAL(dl_uv), MAXVAL(dl_uv)
   PRINT *,'MIN MAX SIGNAL/NOISE ', MINVAL(dl_sn), MAXVAL(dl_sn)
   PRINT *,'MIN MAX SIGNAL RATIO ', MINVAL(dl_sg), MAXVAL(dl_sg)

   ! output on NC file
   ierr = putvar(ncout, id_varout(1), REAL(dl_er), 1, npiglo, npjglo)
   ierr = putvar(ncout, id_varout(2), REAL(dl_uv), 1, npiglo, npjglo)
   ierr = putvar(ncout, id_varout(3), REAL(dl_sn), 1, npiglo, npjglo)
   ierr = putvar(ncout, id_varout(4), REAL(dl_sg), 1, npiglo, npjglo)

   timean(1) = 1.e0
   ierr      = putvar1d(ncout,timean,1,'T')
   ierr      = closeout(ncout             )

END PROGRAM cdfstats

PROGRAM cdfmxlhcsc
  !!======================================================================
  !!                     ***  PROGRAM  cdfmxlhcsc  ***
  !!=====================================================================
  !!  ** Purpose : Compute mixed layer depth and the heat and salt contents
  !!               in the mixed layer. There is an option to limit this 
  !!               computation between hmin and ml depth. For that, hmin is
  !!               given as last argument (>0) with no arguments, hmin is 
  !!               supposed to be 0.
  !!
  !!  ** Method  : This program is a merge of  cdfmxl, cdfmxlheatc and
  !!               cdfmxlsaltc.
  !!               MXL computation:
  !!                - compute surface properties
  !!                - initialize depths and model levels number
  !!                - from bottom to top compute rho and
  !!                check if rho > rho_surf +rho_c, where rho_c is a 
  !!                density criteria given as argument
  !!               Heat Content and Salt Content:
  !!                 HC = sum ( rho cp T * e1 * e2 * e3 * tmask )
  !!                 SC = sum ( rho    S * e1 * e2 * e3 * tmask )
  !!                 where the sum is limited to the MXL, between hmin and
  !!                 MLD
  !!
  !! History : 2.1  : 04/2007  : M. Juza      : Merging of the programs
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE eos
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class mixed_layer
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                              :: ji, jj, jk, jt  ! dummy loop index
  INTEGER(KIND=4)                              :: it              ! time index for vvl
  INTEGER(KIND=4)                              :: ik              ! level indirect index
  INTEGER(KIND=4)                              :: narg, iargc     ! browse line
  INTEGER(KIND=4)                              :: ijarg           ! argument counter
  INTEGER(KIND=4)                              :: npiglo, npjglo  ! domain size
  INTEGER(KIND=4)                              :: npk, npt        ! domaine size
  INTEGER(KIND=4)                              :: ncout, ierr     ! ncid of output file an error status
  INTEGER(KIND=4), DIMENSION(3)                :: ipk, id_varout  ! levels and varid's of output vars
  INTEGER(KIND=4), DIMENSION(:,:), ALLOCATABLE :: mbathy          ! number of w levels in water <= npk
  INTEGER(KIND=4), DIMENSION(:,:), ALLOCATABLE :: nmln            ! last level where rho > rho + val_crit
  !              or rtem > rtem + val_crit
  REAL(KIND=4), PARAMETER                      :: rprho0=1020.    ! reference density
  REAL(KIND=4), PARAMETER                      :: rpcp=4000.      ! specific heat of water
  REAL(KIND=4)                                 :: val             ! criteria value
  REAL(KIND=4)                                 :: hmin = 0.       ! minimum depth for vertical integration
  REAL(KIND=4), DIMENSION(1)                   :: rdep            ! dummy depth output
  REAL(KIND=4), DIMENSION(:),      ALLOCATABLE :: gdepw           ! depth of w points
  REAL(KIND=4), DIMENSION(:),      ALLOCATABLE :: e31d            ! vertical metrics (full step)
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: rtem            ! temperature
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: rsal            ! salinity
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: rho             ! density (sigma-0)
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: rho_surf        ! surface density
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: tem_surf        ! surface temperature
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: hmld            ! mixed layer depth
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: tmask_surf      ! surface tmask
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: tmask           ! land sea mask of temperature
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: e3              ! vertical metrics

  REAL(KIND=8), DIMENSION(:),      ALLOCATABLE :: dtim            ! time counter
  REAL(KIND=8), DIMENSION(:,:),    ALLOCATABLE :: dmxlheatc       ! mxl heat content
  REAL(KIND=8), DIMENSION(:,:),    ALLOCATABLE :: dmxlsaltc       ! mxl salt content

  TYPE(variable), DIMENSION(3)                 :: stypvar         ! output attributes

  CHARACTER(LEN=256)                           :: cf_tfil         ! input file
  CHARACTER(LEN=256)                           :: cf_sfil         ! salinity file (option)
  CHARACTER(LEN=256)                           :: cf_mld          ! mld input file (option)
  CHARACTER(LEN=256)                           :: cf_out='mxlhcsc.nc' ! output file
  CHARACTER(LEN=256)                           :: cv_mld          ! mld imput variable (option)
  CHARACTER(LEN=256)                           :: criteria        ! type of criteria used for mld
  CHARACTER(LEN=256)                           :: cldum           ! dummy string

  LOGICAL                                      :: lchk            ! flag for missing files
  LOGICAL                                      :: lfull=.FALSE.   ! flag for full step
  LOGICAL                                      :: lnc4 =.FALSE.   ! Use nc4 with chunking and deflation
  LOGICAL                                      :: lmld =.TRUE.    ! Flag to compute mld
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfmxlhcsc -t T-file -C criteria -th THRESH-value [-hmin hmin] ...'
     PRINT *,'            ... [-s S-file] [-o OUT-file] [-nc4] [-vvl] [-mld MLD-file MLD-var]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the MiXed Layer depth, the Heat Content and Salt Content in the'
     PRINT *,'       mixed layer. Various criteria can be used and (-C argument) with any '
     PRINT *,'       threshold values (-th argument).' 
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -t T-file : netcdf input file for temperature and salinity (gridT).' 
     PRINT *,'           If salinity is not in T-file, use -s option.'
     PRINT *,'       -C criteria : Specify the type of criteria to use for MXL computation'
     PRINT *,'                can be one of temperature, t,  T for temperature criteria.'
     PRINT *,'                    or one of density, d,  D  for density criteria.'
     PRINT *,'       -th THRESH-value : threshold value for the criteria.'
     PRINT *,'                (eg: 0.2 for temp, 0.01 or 0.03 for dens)'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-s S-file  ] : specify salinity file if not T-file.'
     PRINT *,'       [-hmin hmin ] : limit the vertical integral from hmin to mld. By default,' 
     PRINT *,'                 hmin is set to 0 so that the integral is performed on the'
     PRINT *,'                 whole mixed layer.'
     PRINT *,'       [-o OUT-file ] : specify output file name instead of ',TRIM(cf_out)
     PRINT *,'       [ -nc4 ]     : Use netcdf4 output with chunking and deflation level 1.'
     PRINT *,'                 This option is effective only if cdftools are compiled with'
     PRINT *,'                 a netcdf library supporting chunking and deflation.'
     PRINT *,'       [-vvl ] : use time-varying vertical metrics'
     PRINT *,'       [-mld MLD-file MLD-var]: This option replaces both ''-C'' and ''-t'' '
     PRINT *,'                 arguments, indicating that the mixed layer depth is to be read'
     PRINT *,'                 as the variable MLD-var in the MLD-file. With this option, the'
     PRINT *,'                 heat and salt content can be computed from the MLD estimates'
     PRINT *,'                 provided by ''cdfmxl''.' 
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ',TRIM(cn_fhgr),' ',TRIM(cn_fzgr),' and ',TRIM(cn_fmsk) 
     PRINT *,'        In case of full step configuration, ',TRIM(cn_fbathylev),' is also required.'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) ,' unless -o option is used'
     PRINT *,'         variables : -  somxl010 (mld based on density criterion 0.01)'
     PRINT *,'          (2D)          or somxl030 (mld on density criterion 0.03)'
     PRINT *,'                        or somxlt02 (mld on temperature criterion -0.2)'
     PRINT *,'                        -  somxlheatc (heat content computed in the MLD)'
     PRINT *,'                        -  somxlsaltc (salt content computed in the MLD)'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'       cdfmxl, cdfmxlheatc and  cdfmxlsaltc.'
     PRINT *,'      '
     STOP 
  ENDIF


  ijarg = 1 
  cf_sfil = 'none'
  DO WHILE ( ijarg <= narg )
     CALL getarg (ijarg, cldum ) ; ijarg = ijarg + 1
     SELECT CASE ( cldum )
     CASE ( '-t '    ) ; CALL getarg (ijarg, cf_tfil  ) ; ijarg = ijarg + 1 
     CASE ( '-C '    ) ; CALL getarg (ijarg, criteria ) ; ijarg = ijarg + 1 
     CASE ( '-th'    ) ; CALL getarg (ijarg, cldum    ) ; ijarg = ijarg + 1  ; READ(cldum,*) val
        ! options
     CASE ( '-s '    ) ; CALL getarg (ijarg, cf_sfil  ) ; ijarg = ijarg + 1 
     CASE ( '-hmin ' ) ; CALL getarg (ijarg, cldum    ) ; ijarg = ijarg + 1  ; READ(cldum,*) hmin
     CASE ( '-o'     ) ; CALL getarg (ijarg, cf_out   ) ; ijarg = ijarg + 1  
     CASE ( '-nc4'   ) ; lnc4   = .TRUE.
     CASE ( '-vvl'   ) ; lg_vvl = .TRUE.
     CASE ( '-mld'   ) ; CALL getarg (ijarg, cf_mld   ) ; ijarg = ijarg + 1
        ;                CALL getarg (ijarg, cv_mld   ) ; ijarg = ijarg + 1 
        ;                lmld = .FALSE.
     CASE DEFAULT  ; PRINT *, ' ERROR : Option ',TRIM(cldum),' unknown !' ; STOP 99
     END SELECT
  ENDDO

 IF ( cf_sfil == 'none' ) cf_sfil=cf_tfil

  lchk = chkfile (cn_fhgr)
  lchk = chkfile (cn_fzgr) .OR. lchk
  lchk = chkfile (cn_fmsk) .OR. lchk
  lchk = chkfile (cf_tfil) .OR. lchk
  lchk = chkfile (cf_sfil) .OR. lchk
  IF ( .NOT. lmld ) lchk = chkfile (cf_mld) .OR. lchk
  IF ( lchk ) STOP 99 ! missing files
  IF ( lg_vvl ) THEN
     cn_fe3t = cf_tfil 
     cn_ve3t = cn_ve3tvvl
  ENDIF

  ! read dimensions 
  npiglo = getdim (cf_tfil, cn_x)
  npjglo = getdim (cf_tfil, cn_y)
  npk    = getdim (cf_tfil, cn_z)
  npt    = getdim (cf_tfil, cn_t)

  IF ( lmld ) THEN
     ! Variable Mixed Layer Depth
     SELECT CASE ( criteria)
     CASE ( 'Temperature', 'temperature', 't', 'T' ) ; WRITE(cv_mld,'(a,i2.2)' ) 'somxlt', INT(ABS(val)*10)
     CASE ( 'Density',     'density',     'd', 'D' ) ; WRITE(cv_mld,'(a,i3.3)' ) 'somxl' , INT((val)*1000)
     CASE DEFAULT  ; PRINT *,'ERROR: ',TRIM(criteria),' : criteria not understood' ; STOP 99
     END SELECT
  ENDIF

  ! Allocate arrays
  ALLOCATE (rtem(npiglo,npjglo),rsal(npiglo,npjglo)          )
  ALLOCATE (tmask(npiglo,npjglo),tmask_surf(npiglo,npjglo)   )
  ALLOCATE (mbathy(npiglo,npjglo)                            )
  ALLOCATE (nmln(npiglo,npjglo),hmld(npiglo,npjglo)          )
  ALLOCATE (dmxlheatc(npiglo,npjglo),dmxlsaltc(npiglo,npjglo))
  ALLOCATE (e3(npiglo,npjglo)                                )
  ALLOCATE (gdepw(0:npk), dtim(npt)                          )

  CALL CreateOutput

  ! read mbathy and gdepw use real rtem(:,:) as template (getvar is used for real only)
  INQUIRE (FILE=cn_fbathylev, EXIST=lfull)
  IF ( lfull ) THEN ; rtem(:,:) = getvar(cn_fbathylev, cn_bathylev, 1, npiglo, npjglo) ; ALLOCATE ( e31d(npk) )
  ELSE              ; rtem(:,:) = getvar(cn_fzgr,      cn_mbathy,   1, npiglo, npjglo)
  ENDIF

  mbathy(:,:)  = rtem(:,:)
  gdepw(0)     = 999999.  ! dummy values normaly always masked
  gdepw(1:npk) = getvare3(cn_fzgr, cn_gdepw, npk) 
  IF ( lfull ) e31d = getvare3(cn_fzgr, cn_ve3t1d, npk )

  ! read surface tmask
  tmask_surf(:,:) = getvar(cn_fmsk, cn_tmask, 1, npiglo, npjglo)

  DO jt = 1, npt   ! major time loop
     IF (lg_vvl ) THEN ; it=jt
     ELSE              ; it=1
     ENDIF
     IF ( lmld ) THEN
        ! MXL computation
        !---------------
        ! Initialization to the number of w ocean point mbathy
        nmln(:,:) = mbathy(:,:)


        SELECT CASE ( criteria )
        CASE ( 'temperature', 'Temperature', 'T', 't' ) ! Temperature criteria
           ! temp_surf
           IF (.NOT. ALLOCATED ( tem_surf) ) ALLOCATE (tem_surf(npiglo,npjglo))
           tem_surf(:,:) = getvar(cf_tfil, cn_votemper, 1, npiglo, npjglo, ktime=jt )

           ! Last w-level at which ABS(rtem-tem_surf)>=ABS(val) (starting from jpk-1)
           ! (rtem defined at t-point, thus jk-1 for w-level just above)
           DO jk = npk-1, 2, -1
              rtem(:,:) = getvar(cf_tfil, cn_votemper, jk, npiglo, npjglo, ktime=jt)
              WHERE ( ABS(rtem - tem_surf) > ABS(val) ) nmln = jk
           ENDDO
        CASE ( 'density', 'Density', 'D', 'd' ) ! Density criteria
           ! compute rho_surf
           IF ( .NOT. ALLOCATED( rho_surf ) ) ALLOCATE (rho_surf(npiglo,npjglo) )
           IF ( .NOT. ALLOCATED( rho      ) ) ALLOCATE (rho     (npiglo,npjglo) )
           rtem(:,:) = getvar(cf_tfil, cn_votemper, 1, npiglo, npjglo, ktime=jt)
           rsal(:,:) = getvar(cf_sfil, cn_vosaline, 1, npiglo, npjglo, ktime=jt)
           rho_surf(:,:) = sigma0 (rtem, rsal, npiglo, npjglo )* tmask_surf(:,:)

           ! Last w-level at which rhop>=rho surf+rho_c (starting from jpk-1)
           ! (rhop defined at t-point, thus jk-1 for w-level just above)
           DO jk = npk-1, 2, -1
              rtem( :,:) = getvar(cf_tfil, cn_votemper,  jk ,npiglo, npjglo, ktime=jt)
              rsal( :,:) = getvar(cf_sfil, cn_vosaline,  jk ,npiglo, npjglo, ktime=jt)
              tmask(:,:) = getvar(cn_fmsk, cn_tmask,     jk, npiglo, npjglo          )
              rho(  :,:) = sigma0 (rtem, rsal, npiglo, npjglo ) * tmask(:,:)
              WHERE ( rho > rho_surf + val ) nmln = jk
           ENDDO
        END SELECT

        !! Determine mixed layer depth
        DO jj = 1, npjglo
           DO ji = 1, npiglo
              ik = nmln(ji,jj)
              hmld (ji,jj) = gdepw(ik) * tmask_surf(ji,jj)
           ENDDO
        ENDDO
     ELSE  ! read MLD in file
        hmld(:,:) = getvar(cf_mld, cv_mld, jk, npiglo,npjglo, ktime=jt) * tmask_surf(:,:)
     ENDIF

     !!Compute heat and salt contents in the mixed layer depth
     !!-------------------------------------------------------
     !!
     dmxlheatc(:,:) = 0.d0
     dmxlsaltc(:,:) = 0.d0

     DO jk = 1,npk
        ! Get temperature and salinity at jk
        rtem(:,:)  = getvar(cf_tfil,  cn_votemper, jk, npiglo, npjglo, ktime=jt)
        rsal(:,:)  = getvar(cf_sfil,  cn_vosaline, jk, npiglo, npjglo, ktime=jt)
        tmask(:,:) = getvar(cn_fmsk,  cn_tmask ,   jk, npiglo, npjglo          )

        IF ( lfull ) THEN
           e3(:,:) = e31d(jk)
        ELSE
           ! Get e3 at level jk (ps...)
           e3(:,:) = getvar(cn_fe3t, cn_ve3t, jk ,npiglo, npjglo, ktime=it, ldiom=.NOT.lg_vvl )
        ENDIF

        ! e3 is used as a flag for the mixed layer; it is 0 outside the mixed layer
        e3(:,:) = MAX(0., MIN(e3, hmld-gdepw(jk) ) + MIN(e3, gdepw(jk)+ e3-hmin) - e3)

        ! Heat and salt contents
        dmxlheatc(:,:) = dmxlheatc(:,:) + rtem(:,:) * e3(:,:) * tmask(:,:) *1.d0
        dmxlsaltc(:,:) = dmxlsaltc(:,:) + rsal(:,:) * e3(:,:) * tmask(:,:) *1.d0

     END DO

     !! Heat and salt contents (10^9.J/m2 and 10^6.kg/m2)
     dmxlheatc(:,:) = dmxlheatc(:,:) *rprho0 *rpcp * 1.d-9
     dmxlsaltc(:,:) = dmxlsaltc(:,:) *rprho0       * 1.d-6

     ierr = putvar(ncout, id_varout(1), hmld,            1, npiglo, npjglo, ktime=jt)
     ierr = putvar(ncout, id_varout(2), REAL(dmxlheatc), 1, npiglo, npjglo, ktime=jt)
     ierr = putvar(ncout, id_varout(3), REAL(dmxlsaltc), 1, npiglo, npjglo, ktime=jt)

  END DO ! time loop

  ierr = closeout(ncout)
CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------

    rdep(1) = 0.
    ipk(:)  = 1 
    stypvar(1)%ichunk      = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(1)%cname       = TRIM(cv_mld)
    stypvar(1)%cshort_name = TRIM(cv_mld)
    stypvar(1)%cunits      = 'm'
    stypvar(1)%clong_name  = 'Mixed Layer Depth'

    ! Variable Heat Content
    stypvar(2)%ichunk      = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(2)%cname       = 'somxlheatc'
    stypvar(2)%cunits      = '10^9 J/m2'
    stypvar(2)%clong_name  = 'Mixed_Layer_Heat_Content'
    stypvar(2)%cshort_name = 'somxlheatc'

    ! Variable Salt Content
    stypvar(3)%ichunk      = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(3)%cname       = 'somxlsaltc'
    stypvar(3)%cunits      = '10^6 kg/m2'
    stypvar(3)%clong_name  = 'Mixed_Layer_Salt_Content'
    stypvar(3)%cshort_name = 'somxlsaltc'

    ncout = create      (cf_out, cf_tfil, npiglo, npjglo, 1        , ld_nc4=lnc4 )
    ierr  = createvar   (ncout,  stypvar, 3,      ipk,    id_varout, ld_nc4=lnc4 )
    ierr  = putheadervar(ncout,  cf_tfil, npiglo, npjglo, 1, pdep=rdep           )
    dtim  = getvar1d(cf_tfil, cn_vtimec, npt     )
    ierr  = putvar1d(ncout, dtim,       npt, 'T')

  END SUBROUTINE CreateOutput


END PROGRAM cdfmxlhcsc

PROGRAM cdfvint
   !!======================================================================
   !!                     ***  PROGRAM  cdfvint  ***
   !!=====================================================================
   !!  ** Purpose : Compute vertically integrated temperature or salinity.
   !!
   !!  ** Method  : Compute the integral from top to bottom and save 
   !!               cumulated values. For temperature, cumulated values are
   !!               transformed to heat content (J.K.m^-2). For salinity
   !!               they are saved as PSU.m
   !!
   !! History : 2.1  : 10/2012  : M.A. Balmaseda : Original code from cdfmxlhc
   !!           3.0  : 11/2012  : J.M. Molines   : Doctor norm + Lic + ...
   !!----------------------------------------------------------------------
   USE cdfio
   USE modcdfnames
   !!----------------------------------------------------------------------
   !! CDFTOOLS_3.0 , MEOM 2012
   !! $Id$
   !! Copyright (c) 2012, J.-M. Molines
   !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
   !!----------------------------------------------------------------------
   IMPLICIT NONE

   INTEGER(KIND=4)                           :: jk, jt              ! dummy loop index
   INTEGER(KIND=4)                           :: ierr, ij, iko       ! working integer
   INTEGER(KIND=4)                           :: narg, iargc, ijarg  ! command line 
   INTEGER(KIND=4)                           :: npiglo, npjglo      ! size of the domain
   INTEGER(KIND=4)                           :: npk, npt            ! size of the domain
   INTEGER(KIND=4)                           :: npko                ! size of the domain
   INTEGER(KIND=4),             DIMENSION(1) :: ipk, id_varout      ! only one output variable
   INTEGER(KIND=4)                           :: ncout 

   REAL(KIND=4), PARAMETER                   :: pprho0 = 1020.     ! water density (kg/m3)
   REAL(KIND=4), PARAMETER                   :: ppcp   = 4000.     ! calorific capacity (J/kg/m3)
   REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e3t                 ! vertical metric
   REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zt                  ! working input variable
   REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: tmask               ! npiglo x npjglo
   REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: gdepw               ! depth
   REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: gdepo               ! output depth 
   REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: tim                 ! time counter
   REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: e31d                ! vertical metrics in case of full step
   REAL(KIND=4)                              :: rdep1, rdep2        ! depth counters
   REAL(KIND=4)                              :: tol  = 1.0             ! tolerance 
   REAL(KIND=4)                              :: sclf = 1.0            ! scale factor

   REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dl_vint1, dl_vint2  ! verticall int quantity         

   CHARACTER(LEN=256)                        :: cf_in, cf_out       ! input/output file
   CHARACTER(LEN=256)                        :: cv_in, cv_out       ! variable name in and out
   CHARACTER(LEN=256)                        :: cunits, clongname   ! variable attributes
   CHARACTER(LEN=256)                        :: cldum               ! dummy string for command line browsing

   LOGICAL                                   :: lfull =.FALSE.      ! flag for full step computation
   LOGICAL                                   :: lgsop =.FALSE.      ! selected depths gsop intercomparison
   LOGICAL                                   :: lchk  =.FALSE.      ! flag for missing files
   LOGICAL                                   :: lout                ! check for output

   TYPE(variable), DIMENSION(1)              :: stypvar             ! extension for attributes
   !!----------------------------------------------------------------------
   CALL ReadCdfNames()

   narg= iargc()
   IF ( narg == 0 ) THEN
      PRINT *,' usage : cdfvint T-file [IN-var] [-GSOP] [-full] '
      PRINT *,'      '
      PRINT *,'     PURPOSE :'
      PRINT *,'          Compute the vertical integral of the variable from top '
      PRINT *,'       to bottom, and save the cumulated valued, level by level.'
      PRINT *,'       For temperature (default var), the integral is transformed'
      PRINT *,'       to Heat Content ( J.K. m^-2) hence for salinity, the integral'
      PRINT *,'       represents PSU.m '
      PRINT *,'      '
      PRINT *,'     ARGUMENTS :'
      PRINT *,'         T-file : gridT file holding either Temperature or salinity '
      PRINT *,'        [IN-var ] : name of input variable to process. Default is '
      PRINT *,'               ', TRIM(cn_votemper),'. Can also be ',TRIM(cn_vosaline)
      PRINT *,'      '
      PRINT *,'     OPTIONS :'
      PRINT *,'        -GSOP : Use 7 GSOP standard level for the output '
      PRINT *,'                Default is to take the model levels for the output'
      PRINT *,'        -full : for full step computation ' 
      PRINT *,'      '
      PRINT *,'     REQUIRED FILES :'
      PRINT *,'       ', TRIM(cn_fmsk),', ',TRIM(cn_fhgr),' and ', TRIM(cn_fzgr) 
      PRINT *,'      '
      PRINT *,'     OUTPUT : '
      PRINT *,'       netcdf file :  VAR-name.nc'
      PRINT *,'         variables :  either voheatc or vohsalt'
      PRINT *,'      '
      PRINT *,'     SEE ALSO :'
      PRINT *,'        cdfvertmean, cdfheatc, cdfmxlhcsc and  cdfmxlheatc'
      PRINT *,'      '
      STOP
   ENDIF

   ! default values
   cv_in = cn_votemper

   ! browse command line
   ijarg = 1   ; ij = 0
   DO WHILE ( ijarg <= narg ) 
      CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1
      SELECT CASE ( cldum)
      CASE ( '-GSOP' ) ; lgsop = .TRUE. 
      CASE ( '-full' ) ; lfull = .TRUE. 
      CASE DEFAULT     
         ij = ij + 1
         SELECT CASE ( ij)
         CASE ( 1 ) ; cf_in = cldum
         CASE ( 2 ) ; cv_in = cldum
         CASE DEFAULT ; PRINT *, ' ERROR: Too many arguments ! ' ; STOP
         END SELECT
      END SELECT
   END DO

   ! Security check
   lchk = chkfile ( cf_in   )
   lchk = chkfile ( cn_fmsk ) .OR. lchk
   lchk = chkfile ( cn_fhgr ) .OR. lchk
   lchk = chkfile ( cn_fzgr ) .OR. lchk
   IF ( lchk ) STOP ! missing files

   ! Set output information according to variable name
   IF ( cv_in == cn_votemper ) THEN
      cv_out    = 'voheatc'
      clongname = 'Heat Content per unit area'
      cunits    = 'J Km^-2'
      sclf      = pprho0*ppcp/1.e6
   ELSEIF ( cv_in == cn_vosaline ) THEN
      cv_out    = 'vohsalt'
      clongname = 'Vertically Integrated Salinity'
      cunits    = 'psu*m'
      sclf      =1.
   ELSE
      PRINT *,'  ERROR: Variable ', TRIM(cv_in), ' not pre-defined ...'
      PRINT *,'     Accepted variables are ', TRIM(cn_votemper),' and ',TRIM(cn_vosaline)
      STOP
   ENDIF

   ! log information so far
   cf_out = TRIM(cv_out)//'.nc'
   PRINT *,' INPUT VARIABLE  : ' , TRIM(cv_in)
   PRINT *,' OUTPUT VARIABLE : ' , TRIM(cv_out)
   PRINT *,' OUTPUT FILE     : ' , TRIM(cf_out)

   npiglo = getdim (cf_in, cn_x )
   npjglo = getdim (cf_in, cn_y )
   npk    = getdim (cf_in, cn_z )
   npt    = getdim (cf_in, cn_t )

   IF ( lgsop ) THEN ; PRINT *,' using GSOP depths' ; npko = 7
                ELSE ; PRINT *,' using model depths'; npko = npk
   ENDIF

   PRINT *, ' NPIGLO = ', npiglo
   PRINT *, ' NPJGLO = ', npjglo
   PRINT *, ' NPK    = ', npk
   PRINT *, ' NPKO   = ', npko
   PRINT *, ' NPT    = ', npt

   ! Allocate arrays
   ALLOCATE ( tim(npt) )
   ALLOCATE ( tmask(npiglo,npjglo) )
   ALLOCATE ( zt(npiglo,npjglo)  )
   ALLOCATE ( e3t(npiglo,npjglo) )
   ALLOCATE ( e31d(npk)   )
   ALLOCATE ( gdepw(npk), gdepo(npko) ) 

   ALLOCATE ( dl_vint1(npiglo, npjglo), dl_vint2(npiglo,npjglo) )

   ! prepare output variable
   ipk(:)                       = npko
   stypvar(1)%cname             = TRIM(cv_out)
   stypvar(1)%cunits            = TRIM(cunits)
   stypvar(1)%rmissing_value    = 0.
   stypvar(1)%valid_min         = -1.e15
   stypvar(1)%valid_max         =  1.e15
   stypvar(1)%clong_name        = TRIM(clongname)
   stypvar(1)%cshort_name       = TRIM(cv_out)
   stypvar(1)%conline_operation = 'N/A'
   stypvar(1)%caxis             = 'TZYX'

   ! Initialize output file
   gdepw(:) = getvare3(cn_fzgr, cn_gdepw, npk )
   e31d(:)  = getvare3(cn_fzgr, cn_ve3t,  npk )

   IF ( lgsop ) THEN
      gdepo(:) = (/100.,300.,700.,1500.,3000.,4000.,6000./)
   ELSE  
      gdepo(1:npk-1) = gdepw(2:npk)
      gdepo(npk)     = 6000.
   ENDIF

   PRINT*,'OUTPUT DEPTHS ARE : ',gdepo
   ncout = create      (cf_out, 'none', npiglo, npjglo, npko, cdep=cn_vdepthw, ld_xycoo=.FALSE.)
   ierr  = createvar   (ncout, stypvar, 1, ipk, id_varout )
   ierr  = putheadervar(ncout, cf_in,   npiglo, npjglo, npko, pdep=gdepo,     ld_xycoo=.FALSE.)

   tim   = getvar1d    (cf_in, cn_vtimec, npt     )
   ierr  = putvar1d    (ncout, tim,       npt, 'T')

   PRINT *, 'Output files initialised ...'

   DO jt = 1, npt
      dl_vint1(:,:) = 0.d0
      iko  = 1
      rdep1 = 0.0 ; rdep2 = 0.0
      lout = .TRUE.
      DO jk = 1, npk
         IF ( lgsop ) lout = .FALSE.
         rdep1          = rdep2
         dl_vint2(:,:) = dl_vint1 (:,:)

         tmask(:,:)= getvar(cn_fmsk, 'tmask', jk, npiglo, npjglo           )
         zt(:,:)   = getvar(cf_in,   cv_in,   jk, npiglo, npjglo, ktime=jt )
         IF ( lfull ) THEN ; e3t(:,:) = e31d(jk)
                      ELSE ; e3t(:,:) = getvar(cn_fzgr, 'e3t_ps', jk, npiglo, npjglo, ldiom=.TRUE.)
         ENDIF

         rdep2 = rdep1 + e31d(jk)
         dl_vint1(:,:) = dl_vint1(:,:)+ zt(:,:)*e3t(:,:)*tmask(:,:)*1.d0

         IF ( rdep2 >= (gdepo(iko) - tol ) ) THEN
            lout=.TRUE.
            !modify vertical thickness for output
            WHERE (e3t(:,:) >  gdepo(iko) - rdep1 ) e3t(:,:) = gdepo(iko)-rdep1
            dl_vint2(:,:) = dl_vint2(:,:)+ zt(:,:)*e3t(:,:)*tmask(:,:)*1.d0
         ENDIF

         IF ( lout ) THEN
            dl_vint2(:,:) = dl_vint2(:,:) * sclf
            IF (jt == 1 ) THEN
               PRINT *,'Output for level ',iko
               PRINT *,'rdep1, rdep2, depo ',rdep1,rdep2,gdepo(iko) 
            ENDIF
            ierr = putvar(ncout, id_varout(1) ,REAL(dl_vint2), iko, npiglo, npjglo, ktime=jt)
            iko = iko + 1
         ENDIF
      END DO  ! loop to next level
   END DO  ! next time frame

   ierr = closeout(ncout)

END PROGRAM cdfvint

PROGRAM cdfzonalmeanvT
  !!======================================================================
  !!                     ***  PROGRAM  cdfzonalmeanvT  ***
  !!=====================================================================
  !!  ** Purpose : Compute the mean product of zonal mean V by zonal mean
  !!               of tracer (T and S )
  !!
  !!  ** Method  : In this program the 'zonal' meanvT is in fact a meanvT 
  !!               along the I coordinate. 
  !! History : 3.0  : 06/2013  : J.M. Molines : from cdfzonalmean and cdfvT
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  USE modutils
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class integration
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                              :: ji, jj, jk ,jt      ! dummy loop index
  INTEGER(KIND=4)                              :: jbasin, jtag        ! dummy loop index
  INTEGER(KIND=4)                              :: npbasins=1          ! number of subbasin
  INTEGER(KIND=4)                              :: ivar = 0            ! output variable counter
  INTEGER(KIND=4)                              :: narg, iargc         ! command line 
  INTEGER(KIND=4)                              :: ijarg               ! command line 
  INTEGER(KIND=4)                              :: itag, ntags         ! arg index of 1rst tag, number of tags
  INTEGER(KIND=4)                              :: ntframe             ! time frame counter
  INTEGER(KIND=4)                              :: npiglo, npjglo      ! size of the domain
  INTEGER(KIND=4)                              :: npk, npt            ! size of the domain
  INTEGER(KIND=4)                              :: ncout               ! ncid of output file
  INTEGER(KIND=4)                              :: ierr                ! working integers
  INTEGER(KIND=4), DIMENSION(:),   ALLOCATABLE :: ipk, id_varout      ! jpbasin x nvar
  INTEGER(KIND=4), DIMENSION(2)                :: ijloc               ! for maxloc

  REAL(KIND=4)                                 :: zspval=99999.       ! missing value 
  REAL(KIND=4), DIMENSION (:),     ALLOCATABLE :: gdep                ! gdept or gdepw
  REAL(KIND=4), DIMENSION (:,:),   ALLOCATABLE :: e1, e2, gphi        ! metrics, latitude
  REAL(KIND=4), DIMENSION (:,:),   ALLOCATABLE :: ztem, zsal, zvel    ! temp, sal and velocity
  REAL(KIND=4), DIMENSION (:,:),   ALLOCATABLE :: zdumlon             ! dummy longitude = 0.
  REAL(KIND=4), DIMENSION (:,:),   ALLOCATABLE :: zdumlat             ! latitude for i = north pole
  REAL(KIND=4), DIMENSION (:,:),   ALLOCATABLE :: zvmask              ! vmask
  REAL(KIND=4), DIMENSION (:,:,:), ALLOCATABLE :: zmask               ! basin mask jpbasins x npiglo x npjglo

  REAL(KIND=8)                                 :: dtotal_time         ! cumul of time in seconds
  REAL(KIND=8), DIMENSION (:),     ALLOCATABLE :: dtim                ! time counter
  REAL(KIND=8), DIMENSION (:),     ALLOCATABLE :: dzovel, dzotem, dzosal  ! npjglo
  REAL(KIND=8), DIMENSION (:),     ALLOCATABLE :: darea, dl_tmp       ! npjglo
  REAL(KIND=8), DIMENSION (:,:,:,:), ALLOCATABLE :: dzovt, dzovs       ! 1xnpjglo x npk x npbasins

  CHARACTER(LEN=256)                           :: cf_tfil, cf_sfil    ! input files names for T S
  CHARACTER(LEN=256)                           :: cf_vfil             ! input files names for V
  CHARACTER(LEN=256)                           :: cf_out='zonalmeanvt.nc' ! output file name
  CHARACTER(LEN=256)                           :: cf_basins='none'    ! sub basin file name
  CHARACTER(LEN=256)                           :: cldum               ! dummy character variable
  CHARACTER(LEN=256)                           :: confcase            ! confcase name
  CHARACTER(LEN=4  ), DIMENSION(5)             :: cbasin=(/'_glo','_atl','_inp','_ind','_pac'/) ! sub basin suffixes
  CHARACTER(LEN=80 ),DIMENSION(:), ALLOCATABLE :: ctag_lst


  TYPE(variable), DIMENSION(:),    ALLOCATABLE :: stypvar             ! structure for input variables

  LOGICAL            :: lpdep    =.FALSE.   ! flag for depth sign (default dep < 0)
  LOGICAL            :: lndep_in =.FALSE.   ! flag for depth sign (default dep < 0) in input file
  LOGICAL            :: ldebug   =.FALSE.   ! flag for activated debug print 
  LOGICAL            :: lchk     =.FALSE.   ! flag for missing files
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfzonalmeanvT -c CONFIG-CASE -l LST-tags [-b BASIN-file] [-pdep] ...'
     PRINT *,'                 ...  [-ndep_in] [-o OUT-file]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the time average of zonal-mean(V) x zonal-mean(T/S) for the'
     PRINT *,'       set of files corresponding to the list of tags, passed as arguments.'
     PRINT *,'       This quantity is the mean-flow contribution to the heat/salt transport'
     PRINT *,'       overturning component. < > being the zonal average, we have: '
     PRINT *,'              Total       =        mean-flow             +     eddy.'
     PRINT *,'        time_mean(<V><T>) = time_mean(<V>)*time_mean(<T>)+time_mean(<V>''<T>'')'
     PRINT *,'      '
     PRINT *,'       Zonal mean is in fact the mean value computed along the I coordinate.'
     PRINT *,'       The result is a vertical slice, in the meridional direction.'
     PRINT *,'      '
     PRINT *,'       REMARKS:  Partial steps are not handled properly (but probably minor'
     PRINT *,'           impact on results) nor vvl case !.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -c CONFIG-CASE is the config name of a given experiment (eg ORCA025-G70)'
     PRINT *,'            The program will look for gridT, gridU and gridV files for this'
     PRINT *,'            config (grid_T, grid_U and grid_V are also accepted). In addition,'
     PRINT *,'            if gridS or grid_S file is found, it will be taken in place of '
     PRINT *,'            gridT for the salinity variable.'
     PRINT *,'       -l LST-tags : a blank-separated list of time tags that will be used'
     PRINT *,'            for time averaging. e.g. y2000m01d05 y2000m01d10 ...'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-b BASIN-file] : netcdf file describing sub basins, similar to '
     PRINT *,'            ', TRIM(cn_fbasins),'. If this name is not given as option, only'
     PRINT *,'            the global zonal mean is computed.'
     PRINT *,'       [-pdep  ] : use positive depths in the output file.'
     PRINT *,'            Default behaviour is to have negative depths.'
     PRINT *,'       [-ndep_in ] : negative depths are used in the input file.'
     PRINT *,'            Default behaviour is to have positive depths.'
     PRINT *,'       [-o OUT-file] : specify output file name instead of ',TRIM(cf_out)
     PRINT *,'       [-debug] : add some print for debug'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ',TRIM(cn_fhgr),', ', TRIM(cn_fzgr),' and ', TRIM(cn_fmsk)
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : zovzot : mean product of zonal_mean(V) x zonal_mean(T)'
     PRINT *,'                     zovzot : mean product of zonal_mean(V) x zonal_mean(S)'
     PRINT *,'                       A suffix _bas is append to variable name oin order to'
     PRINT *,'                     indicate the basin (atl, inp, ind, pac) or glo for global'
     PRINT *,'         '
     STOP 
  ENDIF

  ! decode command line
  ijarg = 1  
  DO WHILE ( ijarg <= narg ) 
     CALL getarg( ijarg, cldum ) ; ijarg=ijarg+1
     SELECT CASE (cldum)
     CASE ( '-c'      ) ; CALL getarg( ijarg, confcase ) ; ijarg=ijarg+1  
     CASE ( '-l'      ) ; CALL GetTagList
     CASE ( '-pdep'   ) ; lpdep    =.TRUE.
     CASE ( '-ndep_in') ; lndep_in =.TRUE.
     CASE ( '-debug'  ) ; ldebug   =.TRUE.
     CASE ( '-b'      ) ; CALL getarg( ijarg, cf_basins) ; ijarg=ijarg+1 ; npbasins = 5
     CASE ( '-o'      ) ; CALL getarg( ijarg, cf_out   ) ; ijarg=ijarg+1 
     CASE DEFAULT       ; PRINT *,' ERROR : ', TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  END DO

  IF ( ldebug ) THEN
     PRINT *, ' CONFIG-CASE = ', TRIM(confcase)
     PRINT *, ' NTAGS       = ', ntags
     PRINT *, '  arg pos    = ', itag
     PRINT *, '  -o         = ', TRIM(cf_out)
  ENDIF

  ! check  files existence
  lchk = lchk .OR. chkfile (cn_fhgr)
  lchk = lchk .OR. chkfile (cn_fzgr)
  lchk = lchk .OR. chkfile (cn_fmsk)
  IF ( npbasins /=1 ) THEN
     lchk = lchk .OR. chkfile (cf_basins  )
  ENDIF
  IF ( lchk ) STOP 99 ! missing files

  cf_tfil = SetFileName( confcase, cldum, 'T')  ! look in first T file for dimensions
  IF ( chkfile (cf_tfil) ) STOP 99 

  npiglo = getdim (cf_tfil,cn_x)
  npjglo = getdim (cf_tfil,cn_y)
  npk    = getdim (cf_tfil,cn_z)

  ! Allocation ...
  ALLOCATE ( ipk(2*npbasins), id_varout(2*npbasins) )
  ALLOCATE ( stypvar(2*npbasins) )

  ALLOCATE ( gdep (npk) )
  ALLOCATE ( e1(npiglo,npjglo), e2(npiglo,npjglo), gphi(npiglo,npjglo) )
  ALLOCATE ( zvmask(npiglo, npjglo))
  ALLOCATE ( zvel(npiglo,npjglo), ztem(npiglo,npjglo), zsal(npiglo,npjglo) )
  ALLOCATE ( zdumlon(1,npjglo), zdumlat(1,npjglo) )
  ALLOCATE ( zmask(npbasins,npiglo, npjglo))

  ALLOCATE ( dzovel(npjglo), dzotem(npjglo), dzosal(npjglo), darea(npjglo), dl_tmp(npjglo) )
  ALLOCATE ( dzovt(1,npjglo, npk, npbasins), dzovs(1,npjglo, npk, npbasins) )

  ! read config information previous to file creation
  gdep(:)   = getvare3(cn_fzgr, cn_gdept, npk)
  gphi(:,:) = getvar(cn_fhgr, cn_gphit, 1, npiglo, npjglo)

  ! Look for the i-index that go through the North Pole
  ijloc        = MAXLOC(gphi)
  zdumlat(1,:) = gphi(ijloc(1),:)  ! 
  zdumlon(:,:) = 0.                ! set the dummy longitude to 0
  IF ( .NOT. lpdep ) gdep(:)   = -1.*  gdep(:)     ! helps for plotting the results

  IF ( ldebug ) PRINT *, 'Create Output files ...'
  CALL CreateOutput
  IF ( ldebug ) PRINT *, 'done.'

  ! initialization of 2D time independant fields
  zmask(1,:,:) = getvar(cn_fmsk, cn_tmask, 1, npiglo, npjglo)
  IF ( cf_basins /= 'none' ) THEN
     zmask(2,:,:) = getvar(cf_basins, cn_tmaskatl, 1, npiglo, npjglo )
     zmask(4,:,:) = getvar(cf_basins, cn_tmaskind, 1, npiglo, npjglo )
     zmask(5,:,:) = getvar(cf_basins, cn_tmaskpac, 1, npiglo, npjglo )
     zmask(3,:,:) = zmask(5,:,:) + zmask(4,:,:)
     ! ensure that there are no overlapping on the masks
     WHERE(zmask(3,:,:) > 0 ) zmask(3,:,:) = 1
  ENDIF
  e1(:,:)   = getvar(cn_fhgr, cn_ve1v,  1, npiglo, npjglo) 
  e2(:,:)   = getvar(cn_fhgr, cn_ve2v,  1, npiglo, npjglo) 

  ! tag loop
  ijarg = itag
  ntframe  = 0  ! reset count index for time mean

  DO jtag = 1, ntags 
     cldum = ctag_lst(jtag)
     cf_tfil = SetFileName( confcase, cldum, 'T', ld_stop=.TRUE.  )
     cf_sfil = SetFileName( confcase, cldum, 'S', ld_stop=.FALSE. )
     cf_vfil = SetFileName( confcase, cldum, 'V'                  )
     IF ( chkfile (cf_sfil, ld_verbose=.FALSE.) ) cf_sfil = cf_tfil  ! do not complain if not found
     IF ( ldebug ) THEN
        PRINT *, ' T-FILE = ', TRIM(cf_tfil)
        PRINT *, ' S-FILE = ', TRIM(cf_sfil)
        PRINT *, ' V-FILE = ', TRIM(cf_vfil)
     ENDIF

     npt = getdim (cf_tfil,cn_t)   ! case of multiple time frames in a single file, assume identical of V file
     ALLOCATE( dtim(npt) ) 
     dtim = getvar1d(cf_tfil, cn_vtimec, npt)
     IF ( ldebug ) PRINT *, 'TIME : ', dtim(:)
     dtotal_time = dtotal_time + SUM(dtim(1:npt) )
     DEALLOCATE( dtim )
     dzovt = 0.d0
     dzovs = 0.d0

     DO jt = 1, npt  
        ntframe = ntframe + 1
        DO jk = 1, npk 
           IF ( ldebug) PRINT *,' JTAG JT JK', jtag, jt, jk
           ! read variables 
           zsal(:,:) = getvar(cf_sfil,  cn_vosaline, jk, npiglo, npjglo, ktime=jt )
           ztem(:,:) = getvar(cf_tfil,  cn_votemper, jk, npiglo, npjglo, ktime=jt )
           zvel(:,:) = getvar(cf_vfil,  cn_vomecrty, jk, npiglo, npjglo, ktime=jt )
           ! do not read e3 metrics at level jk (to do as in cdfzonal mean ... JMM : to be improved !
           zvmask(:,:) = getvar(cn_fmsk, cn_vmask,    jk ,npiglo, npjglo          )

           ! put T and S at V points
           ztem(:,1:npjglo-1) = 0.5 * ( ztem(:,1:npjglo-1) + ztem(:,2:npjglo) ) * zvmask(:,1:npjglo-1)
           zsal(:,1:npjglo-1) = 0.5 * ( zsal(:,1:npjglo-1) + zsal(:,2:npjglo) ) * zvmask(:,1:npjglo-1)

           ! For all basins 
           DO jbasin = 1, npbasins
              IF ( ldebug) PRINT *,'    JBASIN ', jbasin
              dzovel(:) = 0.d0
              dzotem(:) = 0.d0
              dzosal(:) = 0.d0
              darea (:) = 0.d0
              IF ( ldebug) PRINT *,'      reset done.'

              ! integrates V 'zonally' (along i-coordinate)
              DO ji=1,npiglo
                 dl_tmp(:) = 1.d0*e1(ji,:)*e2(ji,:)* zmask(jbasin,ji,:) 
                 dzovel(:) = dzovel(:) + dl_tmp(:)*zvel  (ji,:)
                 dzotem(:) = dzotem(:) + dl_tmp(:)*ztem  (ji,:)
                 dzosal(:) = dzosal(:) + dl_tmp(:)*zsal  (ji,:)
                 darea (:) = darea (:) + dl_tmp(:)*zvmask(ji,:)
              END DO
              IF ( ldebug) PRINT *,'      Zonal integral done.'

              ! compute the mean value if the darea is not 0, else assign spval
              WHERE (darea /= 0 )
                 dzovel=dzovel/darea
                 dzotem=dzotem/darea
                 dzosal=dzosal/darea
                 ! cumulate in time
                 dzovt(1,:,jk,jbasin) = dzovt(1,:,jk,jbasin) + dzovel(:)*dzotem(:)
                 dzovs(1,:,jk,jbasin) = dzovs(1,:,jk,jbasin) + dzovel(:)*dzosal(:)
              ELSEWHERE
                 dzovel=zspval
                 dzotem=zspval
                 dzosal=zspval
                 ! cumulate in time
                 dzovt(1,:,jk,jbasin) = zspval
                 dzovs(1,:,jk,jbasin) = zspval
              ENDWHERE
              IF ( ldebug) PRINT *,'      mean and masking done.'

           END DO  !next basin
        END DO ! next level
     ENDDO   ! next time in file
  ENDDO  ! next file

  ! normalize before output
  WHERE ( dzovt /= zspval ) 
     dzovt(:,:,:,:) = dzovt(:,:,:,:) / ntframe
     dzovs(:,:,:,:) = dzovs(:,:,:,:) / ntframe
  ELSEWHERE
     dzovt(:,:,:,:) = zspval
     dzovs(:,:,:,:) = zspval
  ENDWHERE

  ALLOCATE ( dtim(1) )
  dtim(1) = dtotal_time/ntframe
  IF ( ldebug ) PRINT *, ' mean time ', dtim(1), ntframe

  ! output file 
  ierr   = putvar1d(ncout, dtim, 1, 'T')
  ivar = 0
  DO jbasin = 1, npbasins
     ivar = ivar + 1
     DO jk = 1, npk
        ierr = putvar (ncout, id_varout(ivar  ), REAL(dzovt(:,:,jk,jbasin) ), jk, 1, npjglo, kwght=ntframe )
        ierr = putvar (ncout, id_varout(ivar+1), REAL(dzovs(:,:,jk,jbasin) ), jk, 1, npjglo, kwght=ntframe )
     ENDDO
     ivar = ivar + 1
  ENDDO

  ierr = closeout(ncout)

CONTAINS 

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Set up all things required for the output file, create
    !!               the file and write the header part.
    !!
    !! ** Method  :  Use global module variables
    !!
    !!----------------------------------------------------------------------
    ipk(:) = npk
    ivar = 0
    DO jbasin = 1, npbasins
       ivar = ivar + 1
       stypvar(ivar)%cname             = 'zovzot'//TRIM(cbasin(jbasin) )
       stypvar(ivar)%cunits            = 'm.DegC.s-1'
       stypvar(ivar)%rmissing_value    = zspval
       stypvar(ivar)%valid_min         = -50.
       stypvar(ivar)%valid_max         =  50.
       stypvar(ivar)%clong_name        = 'product of zonalmean V x zonalmean T for'//TRIM(cbasin(jbasin) )
       stypvar(ivar)%cshort_name       = 'zovzot'//TRIM(cbasin(jbasin) )
       stypvar(ivar)%conline_operation = 'N/A'
       stypvar(ivar)%caxis             = 'TZY'

       ivar = ivar + 1
       stypvar(ivar)%cname             = 'zovzos'//TRIM(cbasin(jbasin) )
       stypvar(ivar)%cunits            = 'm.PSU.s-1'
       stypvar(ivar)%rmissing_value    = zspval
       stypvar(ivar)%valid_min         = -50.
       stypvar(ivar)%valid_max         = 50.
       stypvar(ivar)%clong_name        = 'product of zonalmean V x zonalmean S for'//TRIM(cbasin(jbasin) )
       stypvar(ivar)%cshort_name       = 'zovzos'//TRIM(cbasin(jbasin) )
       stypvar(ivar)%conline_operation = 'N/A'
       stypvar(ivar)%caxis             = 'TZY'
    END DO

    ! create output fileset
    ncout = create      (cf_out, cf_tfil,          1, npjglo, npk    )
    ierr  = createvar   (ncout,  stypvar, 2*npbasins, ipk, id_varout )
    ierr  = putheadervar(ncout,  cf_tfil,          1, npjglo, npk, pnavlon=zdumlon, pnavlat=zdumlat, pdep=gdep )

  END SUBROUTINE CreateOutput

  SUBROUTINE GetTagList
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE GetTagList  ***
    !!
    !! ** Purpose :  Set up a tag list given on the command line as 
    !!               blank separated list
    !!
    !! ** Method  :  Scan the command line until a '-' is found
    !!----------------------------------------------------------------------
    INTEGER (KIND=4)  :: ji
    INTEGER (KIND=4)  :: icur
    !!----------------------------------------------------------------------
    !!
    ntags=0
    ! need to read a list of file ( number unknow ) 
    ! loop on argument till a '-' is found as first char
    icur=ijarg                          ! save current position of argument number
    DO ji = icur, narg                  ! scan arguments till - found
       CALL getarg ( ji, cldum )
       IF ( cldum(1:1) /= '-' ) THEN ; ntags = ntags+1
       ELSE                          ; EXIT
       ENDIF
    ENDDO
    ALLOCATE (ctag_lst(ntags) )
    DO ji = icur, icur + ntags -1
       CALL getarg(ji, ctag_lst( ji -icur +1 ) ) ; ijarg=ijarg+1
    END DO
  END SUBROUTINE GetTagList

END PROGRAM cdfzonalmeanvT

PROGRAM cdfsigtrp
   !!======================================================================
   !!                     ***  PROGRAM  cdfsigtrp  ***
   !!======================================================================
   !!  ** Purpose : Compute density class Mass transport across a section.
   !!
   !!  ** Method  :- The begining and end point of the section are given in 
   !!                term of f-points index.
   !!              - The program works for zonal or meridional sections.
   !!              - The section definitions are given in an ASCII FILE 
   !!                dens_section.dat:
   !!                 foreach sections, 2 lines :
   !!                       (i) : section name (String, no blank)
   !!                      (ii) : imin imax jmin jmax for the section
   !!              - Only vertical slices corrsponding to the sections are
   !!                read in the files.
   !!              - read metrics, depth, etc
   !!              - read normal velocity (either vozocrtx oy vomecrty )
   !!              - read 2 rows of T and S ( i i+1  or j j+1 )
   !!              - compute the mean value at velocity point
   !!              - compute sigma0 (can be easily modified for sigmai )
   !!              - compute the depths of isopyncal surfaces
   !!              - compute the transport from surface to the isopycn
   !!              - compute the transport in each class of density
   !!              - compute the total transport (for information)
   !!
   !! History : 2.1  : 03/2006  : J.M. Molines : Original code
   !!                : 07/2009  : R. Dussin    : add cdf output
   !!           3.0  : 06/2011  : J.M. Molines : Doctor norm + Lic.
   !!----------------------------------------------------------------------
   !!----------------------------------------------------------------------
   !!   routines      : description
   !!  section_init   : initialize section names and positions
   !!  print_out      : routine which performs standard output if required
   !!  bimg_writ      : routine which performs bimg output if required
   !!----------------------------------------------------------------------
   USE cdfio
   USE eos          ! for sigma0, sigmai
   USE modcdfnames  ! for ReadCdfNames
   USE modutils     ! for SetGlobalAtt
   !!----------------------------------------------------------------------
   !! CDFTOOLS_3.0 , MEOM 2011
   !! $Id$
   !! Copyright (c) 2011, J.-M. Molines
   !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
   !!----------------------------------------------------------------------
   IMPLICIT NONE

   INTEGER(KIND=4)                               :: ji, jk, jclass, jsec ! dummy loop index
   INTEGER(KIND=4)                               :: jiso, jbin, jarg     ! dummy loop index
   INTEGER(KIND=4)                               :: nbins                ! number of density classes
   INTEGER(KIND=4)                               :: ipos                 ! working variable
   INTEGER(KIND=4)                               :: narg, iargc          ! command line 
   INTEGER(KIND=4)                               :: ijarg, ireq          ! command line
   INTEGER(KIND=4)                               :: npk, nk              ! vertical size, number of wet layers
   INTEGER(KIND=4)                               :: numbimg=10           ! optional bimg logical unit
   INTEGER(KIND=4)                               :: numout=11            ! ascii output
   INTEGER(KIND=4)                               :: nsection             ! number of sections (overall)
   INTEGER(KIND=4)                               :: iimin, iimax         ! working section limits
   INTEGER(KIND=4)                               :: ijmin, ijmax         ! working section limits
   INTEGER(KIND=4)                               :: npts                 ! number of points in section
   INTEGER(KIND=4)                               :: ikx=1, iky=1         ! dims of netcdf output file
   INTEGER(KIND=4)                               :: nboutput=2           ! number of values to write in cdf output
   INTEGER(KIND=4)                               :: ncout, ierr          ! for netcdf output
   INTEGER(KIND=4)                               :: iweight              ! weight of input file for further averaging
   INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: iimina, iimaxa       ! sections limits
   INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: ijmina, ijmaxa       ! sections limits
   INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: ipk, id_varout       ! variable levels and id

   REAL(KIND=4)                                  :: refdep =0.e0         ! reference depth (m)
   REAL(KIND=4), DIMENSION(1)                    :: tim                  ! time counter
   REAL(KIND=4), DIMENSION(1)                    :: rdummy1, rdummy2     ! working variable
   REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: gdept, gdepw         ! depth of T and W points 
   REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: eu                   ! either e1v or e2u
   REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: e3t1d, e3w1d         ! vertical metrics in case of full step
   REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: rlonlat              ! longitudes/latitudes if the section
   REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: zs, zt               ! salinity and temperature from file 
   REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: rdumlon, rdumlat     ! dummy longitude and latitude for output
   REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: zu                   ! velocity
   REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: zmask                ! mask
   REAL(KIND=4), DIMENSION(:,:,:),   ALLOCATABLE :: tmpm, tmpz           ! temporary arrays

   ! double precision for cumulative variables and densities
   REAL(KIND=8)                                  :: dsigma_min           ! minimum density for bining
   REAL(KIND=8)                                  :: dsigma_max, dltsig   ! maximum density for bining, step
   REAL(KIND=8)                                  :: dsigma, dalfa        ! working sigma, interpolation coeff.
   REAL(KIND=8), DIMENSION(:),       ALLOCATABLE :: dsigma_lev           ! built array with sigma levels
   REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: de3                  ! vertical metrics
   REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: ddepu                ! depth of vel points
   REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: dsig                 ! density
   REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: dhiso                ! depth of isopycns
   REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: dwtrp, dwtrpbin      ! transport arrays
   REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: dtrpbin              ! transport arrays

   TYPE(variable), DIMENSION(:),     ALLOCATABLE :: stypvar              ! structure of output

   CHARACTER(LEN=256)                            :: cf_tfil              ! temperature salinity file
   CHARACTER(LEN=256)                            :: cf_ufil              ! zonal velocity file
   CHARACTER(LEN=256)                            :: cf_vfil              ! meridional velocity file
   CHARACTER(LEN=256)                            :: cf_section='dens_section.dat'  ! input section file
   CHARACTER(LEN=256)                            :: cf_out='trpsig.txt'  ! output  ascii file
   CHARACTER(LEN=256)                            :: cf_bimg              ! output bimg file (2d)
   CHARACTER(LEN=256)                            :: cf_nc                ! output netcdf file (2d)
   CHARACTER(LEN=256)                            :: cf_outnc             ! output netcdf file (1d, 0d))
   CHARACTER(LEN=256)                            :: cv_dep               ! depth variable
   CHARACTER(LEN=256)                            :: cldum                ! dummy string
   CHARACTER(LEN=256)                            :: cglobal              ! global attribute
   CHARACTER(LEN=80 )                            :: cfmt_9000            ! format string 
   CHARACTER(LEN=80 )                            :: cfmt_9001            ! format string
   CHARACTER(LEN=80 )                            :: cfmt_9002            ! format string
   CHARACTER(LEN=80 )                            :: cfmt_9003            ! format string
   CHARACTER(LEN=256)                            :: cl_vnam, cl_lname    ! working variables
   CHARACTER(LEN=256)                            :: csuffixvarname       !
   CHARACTER(LEN=256)                            :: cprefixlongname      !
   CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_names             ! names of input variables
   CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: csection             ! section name
   CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cvarname             ! output variable name (root)
   CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: clongname            ! output long name (root)

   LOGICAL                                       :: l_merid              ! flag for meridional section
   LOGICAL                                       :: ltemp  =.FALSE.      ! flag for extra print
   LOGICAL                                       :: lprint =.FALSE.      ! flag for extra print
   LOGICAL                                       :: lbimg  =.FALSE.      ! flag for bimg output
   LOGICAL                                       :: lncdf  =.FALSE.      ! flag for bimg output
   LOGICAL                                       :: lfull  =.FALSE.      ! flag for bimg output
   LOGICAL                                       :: lchk   =.FALSE.      ! flag for missing files
   !!----------------------------------------------------------------------
   CALL ReadCdfNames()

   narg= iargc()
   IF ( narg < 6 ) THEN
      PRINT *,' usage :  cdfsigtrp T-file U-file V-file sigma_min sigma_max nbins ...'
      PRINT *,'              ... [-print ] [-bimg ] [-full ] [ -refdep ref_depth] ...'
      PRINT *,'              ... [-section file ] [-temp ]'
      PRINT *,'      '
      PRINT *,'     PURPOSE :'
      PRINT *,'       Compute density class transports, according to the density class' 
      PRINT *,'       definition ( minimum, maximum and number of bins) given in arguments.'
      PRINT *,'       Section position are given in ',TRIM(cf_section),', an ASCII file '
      PRINT *,'       with pairs of lines giving section name and section location as'
      PRINT *,'       imin imax jmin jmax. Only zonal or meridional section are allowed.'
      PRINT *,'       The name of this file can be specified with the -section option, if'
      PRINT *,'       it differs from the standard name. Optionaly, a netcdf root variable '
      PRINT *,'       name and a netcdf root long-name can be provided on the line giving '
      PRINT *,'       the section name.'
      PRINT *,'      '
      PRINT *,'       This program can also be used to compute transport by class of '
      PRINT *,'       temperatures, provided the temperatures decreases monotonically '
      PRINT *,'       downward. In this case, use -temp option and of course specify'
      PRINT *,'       sigma_min, sigma_max as temperatures.'
      PRINT *,'      '
      PRINT *,'     ARGUMENTS :'
      PRINT *,'       T-file : netcdf file with temperature and salinity' 
      PRINT *,'       U-file : netcdf file with zonal velocity component'
      PRINT *,'       V-file : netcdf file with meridional velocity component'
      PRINT *,'       sigma_min : minimum density for binning'
      PRINT *,'       sigma_max : maximum density for binning'
      PRINT *,'       nbins : number of bins. This will fix the bin ''width'' '
      PRINT *,'      '
      PRINT *,'     OPTIONS :'
      PRINT *,'       [ -full ] : for full step configuration' 
      PRINT *,'       [ -bimg ] : produce extra bimg output file which shows the details'
      PRINT *,'               of the sections (normal velocity, density, temperature, '
      PRINT *,'               salinity, transports, isopycnal depths. (to be change to '
      PRINT *,'               netcdf files for more common use.'
      PRINT *,'       [ -ncdf ] : produce extra netcdf output file which shows the details'
      PRINT *,'               of the sections (normal velocity, density, temperature, '
      PRINT *,'               salinity, transports, isopycnal depths. '
      PRINT *,'       [ -print ]: write the binned transports on standard output, for each'
      PRINT *,'               sections.'
      PRINT *,'       [ -refdep ref_depth ]: give a reference depths for the computation of'
      PRINT *,'               potential density. Sigma_min, sigma_max must be adapted '
      PRINT *,'               accordingly.'
      PRINT *,'       [ -section file] : give the name of section file.'
      PRINT *,'               Default is ', TRIM(cf_section)
      PRINT *,'       [ -temp ] : use temperature instead of density for binning'
      PRINT *,'      '
      PRINT *,'     REQUIRED FILES :'
      PRINT *,'       ', TRIM(cn_fhgr),', ', TRIM(cn_fzgr),' and ', TRIM(cf_section)
      PRINT *,'      '
      PRINT *,'     OUTPUT : '
      PRINT *,'       Netcdf file : There is 1 netcdf file per section. File name is build'
      PRINT *,'         from section name : Section_name_trpsig.nc'
      PRINT *,'         variables : sigma_class (upper limit of the bin)'
      PRINT *,'                     sigtrp : transport (Sv per bin)'
      PRINT *,'      '
      PRINT *,'       ascii file  : ', TRIM(cf_out) 
      PRINT *,'      '
      PRINT *,'       bimg  file  :  There are 2 bimg files whose name is build from section'
      PRINT *,'         name : section_name_trpdep.bimg and section_name_trpsig.bimg.'
      PRINT *,'         This file is written only if -bimg option is used.'
      PRINT *,'      '
      PRINT *,'      Standard output : the results are written on standard output only if '
      PRINT *,'         the -print option is used.'
      PRINT *,'      '
      PRINT *,'     SEE ALSO :'
      PRINT *,'      cdfrhoproj, cdftransport, cdfsigintegr '
      PRINT *,'      '
      STOP
   ENDIF

   ! browse command line
   ijarg = 1 ; ireq = 0
   DO WHILE ( ijarg <= narg )
      CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1
      SELECT CASE ( cldum )
      CASE ( '-full' ) ; lfull  = .TRUE.
      CASE ( '-bimg' ) ; lbimg  = .TRUE.
      CASE ( '-ncdf' ) ; lncdf  = .TRUE.
      CASE ( '-print') ; lprint = .TRUE.
      CASE ( '-temp')  ; ltemp  = .TRUE. 
      CASE ( '-refdep' ) ; CALL getarg(ijarg, cldum      ) ; ijarg=ijarg+1 ; READ(cldum,*) refdep
      CASE ( '-section') ; CALL getarg(ijarg, cf_section ) ; ijarg=ijarg+1 
      CASE DEFAULT
         ireq=ireq+1
         SELECT CASE ( ireq)
         CASE ( 1 ) ; cf_tfil = cldum
         CASE ( 2 ) ; cf_ufil = cldum
         CASE ( 3 ) ; cf_vfil = cldum
         CASE ( 4 ) ; READ(cldum,*) dsigma_min
         CASE ( 5 ) ; READ(cldum,*) dsigma_max
         CASE ( 6 ) ; READ(cldum,*) nbins
         CASE DEFAULT 
            PRINT *,' Too many arguments ' ; STOP
         END SELECT
      END SELECT
   END DO

   ! check for file existence
   lchk = lchk .OR. chkfile( cn_fzgr    )
   lchk = lchk .OR. chkfile( cn_fhgr    )
   lchk = lchk .OR. chkfile( cf_section )
   lchk = lchk .OR. chkfile( cf_tfil    )
   lchk = lchk .OR. chkfile( cf_ufil    )
   lchk = lchk .OR. chkfile( cf_vfil    )
   IF ( lchk ) STOP ! missing file
   IF ( ltemp)  THEN  ! temperature decrease downward. Change sign and swap min/max
      refdep = -10. ! flag value
      dltsig     = dsigma_max  ! use dltsig as dummy variable for swapping
      dsigma_max = -dsigma_min
      dsigma_min = -dltsig
   ENDIF

   ! define global attribute with command line
   CALL SetGlobalAtt( cglobal)

   ! get the attribute iweight from vozocrtx
   iweight = getatt(cf_ufil, cn_vozocrtx, 'iweight')
   IF ( iweight == 0 ) iweight = 1  ! if 0 means that it is not defined.

   ALLOCATE ( stypvar(nboutput), ipk(nboutput), id_varout(nboutput) )
   ALLOCATE ( rdumlon(ikx,iky),  rdumlat(ikx,iky)                   )

   rdumlon(:,:)=0.
   rdumlat(:,:)=0.

   ipk(1)=nbins ! sigma for each level
   ipk(2)=nbins ! transport for each level
   ! initialisation of variable names etc... is done according to section name

   ! Initialise sections from file 
   ! first call to get nsection and allocate arrays 
   nsection = 0 ; CALL section_init(cf_section, csection,cvarname,clongname,iimina, iimaxa, ijmina, ijmaxa, nsection)
   ALLOCATE ( csection(nsection), cvarname(nsection), clongname(nsection) )
   ALLOCATE ( iimina(nsection), iimaxa(nsection), ijmina(nsection),ijmaxa(nsection) )
   CALL section_init(cf_section, csection,cvarname,clongname, iimina,iimaxa,ijmina,ijmaxa, nsection)

   ! Allocate and build sigma levels and section array
   ALLOCATE ( dsigma_lev (nbins+1) , dtrpbin(nsection,nbins)  )

   dsigma_lev(1)=dsigma_min
   dltsig=( dsigma_max - dsigma_min) / nbins
   DO jclass =2, nbins+1
      dsigma_lev(jclass)= dsigma_lev(1) + (jclass-1) * dltsig
   END DO

   ! Look for vertical size of the domain
   npk = getdim (cf_tfil,cn_z)
   ALLOCATE ( gdept(npk), gdepw(npk) )
   IF ( lfull ) ALLOCATE ( e3t1d(npk), e3w1d(npk))

   ! read gdept, gdepw : it is OK even in partial cells, as we never use the bottom gdep
   gdept(:) = getvare3(cn_fzgr, cn_gdept, npk)
   gdepw(:) = getvare3(cn_fzgr, cn_gdepw, npk)

   IF ( lfull )  THEN 
      e3t1d(:) = getvare3(cn_fzgr, cn_ve3t, npk)
      e3w1d(:) = getvare3(cn_fzgr, cn_ve3w, npk)
   ENDIF

   !! *  Main loop on sections
   DO jsec=1,nsection
      iimin=iimina(jsec) ; iimax=iimaxa(jsec)
      ijmin=ijmina(jsec) ; ijmax=ijmaxa(jsec)

      IF (iimin == iimax ) THEN        ! meridional section
         npts    = ijmax - ijmin       ! number of segments
         l_merid = .TRUE.

      ELSE IF ( ijmin == ijmax ) THEN  ! zonal section
         npts    = iimax - iimin       ! number of segments
         l_merid = .FALSE.

      ELSE
         PRINT *,' Section ',TRIM(csection(jsec)),' is neither zonal nor meridional :('
         PRINT *,' We skip this section .'
         CYCLE
      ENDIF

      ALLOCATE ( zu(npts,npk), zt(npts,npk), zs(npts,npk), dsig(npts,0:npk)  )
      ALLOCATE ( eu(npts), de3(npts,npk), ddepu(npts, 0:npk), zmask(npts,npk) )
      ALLOCATE ( tmpm(1,npts,2), tmpz(npts,1,2)                              )
      ALLOCATE ( dwtrp(npts, nbins+1), dhiso(npts,nbins+1), dwtrpbin(npts,nbins) )
      ALLOCATE ( rlonlat(npts,1) )

      zt = 0. ; zs = 0. ; zu = 0. ; ddepu= 0. ; zmask = 0.  ; dsig=0.d0

      IF (l_merid ) THEN   ! meridional section at i=iimin=iimax
         tmpm(:,:,1)   = getvar(cn_fhgr, cn_ve2u,   1, 1, npts, kimin=iimin, kjmin=ijmin+1)
         eu(:)         = tmpm(1,:,1)  ! metrics varies only horizontally
         tmpm(:,:,1)   = getvar(cn_fhgr, cn_vlat2d, 1, 1, npts, kimin=iimin, kjmin=ijmin+1)
         rlonlat(:,1)  = tmpm(1,:,1)  ! latitude in this case
         DO jk = 1,npk
            ! initiliaze ddepu to gdept()
            ddepu(:,jk) = gdept(jk)

            IF ( lfull ) THEN
               de3(:,jk)   = e3t1d(jk)
               tmpm(1,:,1) = e3w1d(jk)
               tmpm(1,:,2) = e3w1d(jk)
            ELSE
               ! vertical metrics (PS case)
               tmpm(:,:,1) = getvar(cn_fzgr, 'e3u_ps', jk, 1, npts, kimin=iimin,   kjmin=ijmin+1, ldiom=.TRUE.)
               de3(:,jk)   = tmpm(1,:,1)
               tmpm(:,:,1) = getvar(cn_fzgr, 'e3w_ps', jk, 1, npts, kimin=iimin,   kjmin=ijmin+1, ldiom=.TRUE.)
               tmpm(:,:,2) = getvar(cn_fzgr, 'e3w_ps', jk, 1, npts, kimin=iimin+1, kjmin=ijmin+1, ldiom=.TRUE.)
            ENDIF

            IF (jk >= 2 ) THEN
               DO ji=1,npts
                  ddepu(ji,jk)= ddepu(ji,jk-1) + MIN(tmpm(1,ji,1), tmpm(1,ji,2))
               END DO
            ENDIF

            ! Normal velocity
            tmpm(:,:,1) = getvar(cf_ufil,cn_vozocrtx,jk,1,npts, kimin=iimin, kjmin=ijmin+1)
            zu(:,jk)    = tmpm(1,:,1)

            ! salinity and deduce umask for the section
            tmpm(:,:,1) = getvar(cf_tfil,cn_vosaline,jk,1,npts, kimin=iimin  , kjmin=ijmin+1)
            tmpm(:,:,2) = getvar(cf_tfil,cn_vosaline,jk,1,npts, kimin=iimin+1, kjmin=ijmin+1)
            zmask(:,jk) = tmpm(1,:,1)*tmpm(1,:,2)
            WHERE ( zmask(:,jk) /= 0 ) zmask(:,jk)=1
            ! do not take special care for land value, as the corresponding velocity point is masked
            zs(:,jk) = 0.5 * ( tmpm(1,:,1) + tmpm(1,:,2) )

            ! limitation to 'wet' points
            IF ( SUM(zs(:,jk))  == 0 ) THEN
               nk=jk ! first vertical point of the section full on land
               EXIT  ! as soon as all the points are on land
            ENDIF

            ! temperature
            tmpm(:,:,1) = getvar(cf_tfil, cn_votemper, jk, 1, npts, kimin=iimin,   kjmin=ijmin+1)
            tmpm(:,:,2) = getvar(cf_tfil, cn_votemper, jk, 1, npts, kimin=iimin+1, kjmin=ijmin+1)
            zt(:,jk) = 0.5 * ( tmpm(1,:,1) + tmpm(1,:,2) )
         END DO

      ELSE                   ! zonal section at j=ijmin=ijmax
         tmpz(:,:,1)  = getvar(cn_fhgr, cn_ve1v,   1, npts, 1, kimin=iimin, kjmin=ijmin)
         eu(:)        = tmpz(:,1,1)
         tmpz(:,:,1)  = getvar(cn_fhgr, cn_vlon2d, 1, npts, 1, kimin=iimin, kjmin=ijmin)
         rlonlat(:,1) = tmpz(:,1,1)  ! longitude in this case
         DO jk=1,npk
            ! initiliaze ddepu to gdept()
            ddepu(:,jk) = gdept(jk)

            IF ( lfull ) THEN
               de3(:,jk)   = e3t1d(jk)
               tmpm(:,1,1) = e3w1d(jk)
               tmpm(:,1,2) = e3w1d(jk)
            ELSE
               ! vertical metrics (PS case)
               tmpz(:,:,1)=getvar(cn_fzgr,'e3v_ps',jk, npts, 1, kimin=iimin+1, kjmin=ijmin, ldiom=.TRUE.)
               de3(:,jk) = tmpz(:,1,1)
               tmpz(:,:,1)=getvar(cn_fzgr,'e3w_ps',jk,npts,1, kimin=iimin+1, kjmin=ijmin,   ldiom=.TRUE.)
               tmpz(:,:,2)=getvar(cn_fzgr,'e3w_ps',jk,npts,1, kimin=iimin+1, kjmin=ijmin+1, ldiom=.TRUE.)
            ENDIF

            IF (jk >= 2 ) THEN
               DO ji=1,npts
                  ddepu(ji,jk)= ddepu(ji,jk-1) + MIN(tmpz(ji,1,1), tmpz(ji,1,2))
               END DO
            ENDIF

            ! Normal velocity
            tmpz(:,:,1)=getvar(cf_vfil,cn_vomecrty,jk,npts,1, kimin=iimin+1, kjmin=ijmin)
            zu(:,jk)=tmpz(:,1,1)

            ! salinity and mask
            tmpz(:,:,1)=getvar(cf_tfil,cn_vosaline,jk, npts, 1, kimin=iimin+1, kjmin=ijmin)
            tmpz(:,:,2)=getvar(cf_tfil,cn_vosaline,jk, npts, 1, kimin=iimin+1, kjmin=ijmin+1)
            zmask(:,jk)=tmpz(:,1,1)*tmpz(:,1,2)
            WHERE ( zmask(:,jk) /= 0 ) zmask(:,jk)=1
            ! do not take special care for land value, as the corresponding velocity point is masked
            zs(:,jk) = 0.5 * ( tmpz(:,1,1) + tmpz(:,1,2) )

            ! limitation to 'wet' points
            IF ( SUM(zs(:,jk))  == 0 ) THEN
               nk=jk ! first vertical point of the section full on land
               EXIT  ! as soon as all the points are on land
            ENDIF

            ! temperature
            tmpz(:,:,1)=getvar(cf_tfil,cn_votemper,jk, npts, 1, kimin=iimin+1, kjmin=ijmin)
            tmpz(:,:,2)=getvar(cf_tfil,cn_votemper,jk, npts, 1, kimin=iimin+1, kjmin=ijmin+1)
            zt(:,jk) = 0.5 * ( tmpz(:,1,1) + tmpz(:,1,2) )
         END DO

      ENDIF

      ! compute density only for wet points
      IF ( refdep == -10. ) THEN
         dsig(:,1:nk)= -zt(:,:)  ! change sign 
      ELSEIF ( refdep == 0. ) THEN
         dsig(:,1:nk)=sigma0( zt, zs,         npts, nk)*zmask(:,:)
      ELSE
         dsig(:,1:nk)=sigmai( zt, zs, refdep, npts, nk)*zmask(:,:)
      ENDIF

      dsig(:,0)=dsig(:,1)-1.e-4   ! dummy layer for easy interpolation

      ! compute depth of isopynals (nbins+1 )
      DO  jiso =1, nbins+1
         dsigma=dsigma_lev(jiso)
!!!  REM : I and K loop can be inverted if necessary
         DO ji=1,npts
            dhiso(ji,jiso) = gdept(npk)
            DO jk=1,nk 
               IF ( dsig(ji,jk) < dsigma ) THEN
               ELSE
                  ! interpolate between jk-1 and jk
                  dalfa=(dsigma - dsig(ji,jk-1)) / ( dsig(ji,jk) -dsig(ji,jk-1) )
                  IF (ABS(dalfa) > 1.1 .OR. dalfa < 0 ) THEN   ! case dsig(0) = dsig(1)-1.e-4
                     dhiso(ji,jiso)= 0.d0
                  ELSE
                     dhiso(ji,jiso)= ddepu(ji,jk)*dalfa + (1.d0-dalfa)* ddepu(ji,jk-1)
                  ENDIF
                  EXIT
               ENDIF
            END DO
         END DO
      END DO

      ! compute transport between surface and isopycn 
      DO jiso = 1, nbins + 1
         dsigma=dsigma_lev(jiso)
         DO ji=1,npts
            dwtrp(ji,jiso) = 0.d0
            DO jk=1, nk-1
               IF ( gdepw(jk+1) < dhiso(ji,jiso) ) THEN
                  dwtrp(ji,jiso)= dwtrp(ji,jiso) + eu(ji)*de3(ji,jk)*zu(ji,jk)*1.d0
               ELSE  ! last box ( fraction)
                  dwtrp(ji,jiso)= dwtrp(ji,jiso) + eu(ji)*(dhiso(ji,jiso)-gdepw(jk))*zu(ji,jk)*1.d0
                  EXIT  ! jk loop
               ENDIF
            END DO
         END DO
      END DO

      ! binned transport : difference between 2 isopycns
      DO jbin=1, nbins
         dsigma=dsigma_lev(jbin)
         DO ji=1, npts
            dwtrpbin(ji,jbin) = dwtrp(ji,jbin+1) -  dwtrp(ji,jbin) 
         END DO
         dtrpbin(jsec,jbin)=SUM(dwtrpbin(:,jbin) )
      END DO

      ! output of the code for 1 section
      IF (lprint) CALL print_out(jsec)
      IF (lbimg ) CALL bimg_writ(jsec)
      IF (lncdf ) CALL cdf_writ(jsec)
      PRINT *,' Total transport in all bins :',TRIM(csection(jsec)),' ',SUM(dtrpbin(jsec,:) )/1.d6

      ! free memory for the next section
      DEALLOCATE ( zu, zt, zs, dsig, ddepu, dhiso, dwtrp, dwtrpbin )
      DEALLOCATE ( eu, de3, tmpm, tmpz, zmask, rlonlat             )

   END DO   ! next section

   !! Global Output
   OPEN( numout, FILE=cf_out)
   ipos=INDEX(cf_tfil,'_gridT.nc')
   WRITE(numout,9006)  TRIM(cf_tfil(1:ipos-1))
   WRITE(numout,9005) ' sigma  ', (csection(jsec),jsec=1,nsection)
   DO jiso=1,nbins
      WRITE(numout,9004) dsigma_lev(jiso), (dtrpbin(jsec,jiso),jsec=1,nsection)
   ENDDO
   CLOSE(numout)

   cv_dep='levels'
   ! need to call section_init again in order to reset cvarname, clongname if they where modified 
   ! previously in cdf_writ(  case lncdf=true )
   IF (lncdf) THEN
      CALL section_init(cf_section, csection,cvarname,clongname, iimina,iimaxa,ijmina,ijmaxa, nsection)
   ENDIF

   DO jsec=1,nsection
      ! setup output variables (section dependant for adaptative variable name (if possible)
      ! define new variables for output 
      IF ( cvarname(jsec) /= 'none' ) THEN
         csuffixvarname='_'//TRIM(cvarname(jsec))
      ELSE
         csuffixvarname=''
      ENDIF
      IF ( clongname(jsec) /= 'none' ) THEN
         cprefixlongname=TRIM(clongname(jsec))//'_'
      ELSE
         cprefixlongname=''
      ENDIF

      stypvar%rmissing_value    = 99999.
      stypvar%scale_factor      = 1.
      stypvar%add_offset        = 0.
      stypvar%savelog10         = 0.
      stypvar%iwght             = iweight
      stypvar%conline_operation = 'N/A'
      stypvar%caxis             = 'ZT'

      IF ( ltemp ) THEN
         stypvar(1)%cname          = 'temp_class'
         stypvar(1)%cunits         = '[]'
         stypvar(1)%valid_min      = 0.
         stypvar(1)%valid_max      = 100.
         stypvar(1)%clong_name     = 'class of potential temperature'
         stypvar(1)%cshort_name    = 'temp_class'

         stypvar(2)%cname          = 'temptrp'//TRIM(csuffixvarname)
         stypvar(2)%cunits         = 'Sv'
         stypvar(2)%valid_min      = -1000.
         stypvar(2)%valid_max      = 1000.
         stypvar(2)%clong_name     = TRIM(cprefixlongname)//'transport in temperature class'
         stypvar(2)%cshort_name    = 'temptrp'
      ELSE
         stypvar(1)%cname          = 'sigma_class'
         stypvar(1)%cunits         = '[]'
         stypvar(1)%valid_min      = 0.
         stypvar(1)%valid_max      = 100.
         stypvar(1)%clong_name     = 'class of potential density'
         stypvar(1)%cshort_name    = 'sigma_class'

         stypvar(2)%cname          = 'sigtrp'//TRIM(csuffixvarname)
         stypvar(2)%cunits         = 'Sv'
         stypvar(2)%valid_min      = -1000.
         stypvar(2)%valid_max      = 1000.
         stypvar(2)%clong_name     = TRIM(cprefixlongname)//'transport in sigma class'
         stypvar(2)%cshort_name    = 'sigtrp'
      ENDIF


      ! create output fileset
      IF (ltemp) THEN
         cf_outnc = TRIM(csection(jsec))//'_trptemp.nc'
      ELSE
         cf_outnc = TRIM(csection(jsec))//'_trpsig.nc'
      ENDIF

      ncout = create      (cf_outnc, 'none',  ikx,      iky, nbins, cdep=cv_dep               )
      ierr  = createvar   (ncout,    stypvar, nboutput, ipk, id_varout, cdglobal=TRIM(cglobal))
      ierr  = putheadervar(ncout,    cf_tfil, ikx,      iky, nbins, &
           &   pnavlon=rdumlon, pnavlat=rdumlat, pdep=REAL(dsigma_lev), cdep=cv_dep           )

      tim  = getvar1d(cf_tfil, cn_vtimec, 1     )
      ierr = putvar1d(ncout,   tim,       1, 'T')

      DO jiso=1,nbins
         rdummy1 = dsigma_lev(jiso)
         rdummy2 = dtrpbin(jsec,jiso)/1.d6  ! Sv
         ierr    = putvar(ncout, id_varout(1), rdummy1, jiso, ikx, iky )
         ierr    = putvar(ncout, id_varout(2), rdummy2, jiso, ikx, iky )
      END DO

      ierr = closeout(ncout)

   END DO

9004 FORMAT(f9.4, 20e16.7)
9005 FORMAT('#',a9, 20(2x,a12,2x) )
9006 FORMAT('# ',a)

CONTAINS
   SUBROUTINE section_init(cdfile, cdsection, cdvarname, cdlongname, kimin, kimax, kjmin, kjmax, knumber)
      !!---------------------------------------------------------------------
      !!                  ***  ROUTINE section_init  ***
      !!
      !! ** Purpose : Read input ASCII file that defines section names and limit of
      !!              sections.
      !!
      !! ** Method  : At fisrt call only return the number of sections for further
      !!              allocation.  
      !!
      !!----------------------------------------------------------------------
      CHARACTER(LEN=*),                       INTENT(in   ) :: cdfile
      CHARACTER(LEN=256), DIMENSION(knumber), INTENT(out  ) :: cdsection
      CHARACTER(LEN=256), DIMENSION(knumber), INTENT(out  ) :: cdvarname
      CHARACTER(LEN=256), DIMENSION(knumber), INTENT(out  ) :: cdlongname
      INTEGER(KIND=4),                        INTENT(inout) :: knumber
      INTEGER(KIND=4), DIMENSION(knumber),    INTENT(out  ) :: kimin, kimax, kjmin, kjmax

      ! Local variables
      INTEGER(KIND=4)                                       :: jsec
      INTEGER(KIND=4)                                       :: ii, inum=10
      INTEGER(KIND=4)                                       :: ipos  
      CHARACTER(LEN=256)                                    :: cline
      CHARACTER(LEN=80), DIMENSION(3)                       :: cldum
      LOGICAL                                               :: llfirst
      !!----------------------------------------------------------------------
      llfirst=.FALSE.
      IF ( knumber == 0 ) llfirst=.TRUE.

      OPEN(inum, FILE=cdfile)
      REWIND(inum)
      ii = 0

      ! read the file just to count the number of sections
      DO
         READ(inum,'(a)') cline
         IF (INDEX(cline,'EOF') == 0 ) THEN
            READ(inum,*)    ! skip one line
            ii = ii + 1
         ELSE
            EXIT
         ENDIF
      END DO

      knumber=ii
      IF ( llfirst ) RETURN

      REWIND(inum)
      DO jsec=1,knumber
         READ(inum,'(a)') cline
         ii = 0
         cldum(:) = 'none'
         ipos = index(cline,' ')
         DO WHILE ( ipos > 1 ) 
            ii = ii + 1
            cldum(ii) = cline(1:ipos - 1 )
            cline = TRIM ( cline(ipos+1:) )
            ipos  = index( cline,' ' ) 
            IF ( ii >= 3 ) EXIT
         END DO
         cdsection(jsec) = TRIM(cldum(1) )
         cdvarname(jsec) = TRIM(cldum(2) )
         cdlongname(jsec) = TRIM(cldum(3) )
         READ(inum,*    ) kimin(jsec), kimax(jsec), kjmin(jsec), kjmax(jsec)
      END DO

      CLOSE(inum)

   END SUBROUTINE section_init

   SUBROUTINE bimg_writ( ksec)
      !!---------------------------------------------------------------------
      !!                  ***  ROUTINE bimg_writ  ***
      !!
      !! ** Purpose :  Write output bimg files if required 
      !!
      !! ** Method  :  Most of the variables are global 
      !!
      !!----------------------------------------------------------------------
      INTEGER(KIND=4), INTENT(in) :: ksec  ! number of the section

      INTEGER(KIND=4)             :: ji, jk
      !!----------------------------------------------------------------------
      ! (along section, depth ) 2D variables
      cf_bimg=TRIM(csection(ksec))//'_trpdep.bimg'
      OPEN(numbimg,FILE=cf_bimg,FORM='UNFORMATTED')
      cldum=' 4 dimensions in this isopycnal file '
      WRITE(numbimg) cldum

      cldum=' 1: T ;  2: S ; 3: sigma ; 4: Velocity '
      WRITE(numbimg) cldum

      WRITE(cldum,'(a,4i5.4)') ' from '//TRIM(csection(ksec)), iimin,iimax,ijmin,ijmax
      WRITE(numbimg) cldum

      cldum=' file '//TRIM(cf_tfil)
      WRITE(numbimg) cldum

      WRITE(numbimg) npts,nk,1,1,4,0
      WRITE(numbimg) 1.,-float(nk),1.,1., 0.
      WRITE(numbimg) 0.
      WRITE(numbimg) 0.

      WRITE(numbimg) (( REAL(zt(ji,jk)  ), ji=1,npts), jk=nk,1,-1 ) ! temperature 
      WRITE(numbimg) (( REAL(zs(ji,jk)  ), ji=1,npts), jk=nk,1,-1 ) ! salinity
      WRITE(numbimg) (( REAL(dsig(ji,jk)), ji=1,npts), jk=nk,1,-1 ) ! density
      WRITE(numbimg) (( REAL(zu(ji,jk)  ), ji=1,npts), jk=nk,1,-1 ) ! normal velocity
      CLOSE(numbimg)

      ! (along section, sigma ) 2D variables
      cf_bimg=TRIM(csection(ksec))//'_trpsig.bimg'
      OPEN(numbimg,FILE=cf_bimg,FORM='UNFORMATTED')
      cldum=' 3 dimensions in this isopycnal file '
      WRITE(numbimg) cldum
      cldum=' 1: hiso ;  2: bin trp ; 3: cumulated  trp '
      WRITE(numbimg) cldum
      WRITE(cldum,'(a,4i5.4)') ' from '//TRIM(csection(ksec)), iimin,iimax,ijmin,ijmax
      WRITE(numbimg) cldum
      cldum=' file '//TRIM(cf_tfil)
      WRITE(numbimg) cldum
      WRITE(numbimg) npts,nbins,1,1,3,0
      WRITE(numbimg) 1.,-REAL(dsigma_lev(nbins)),1.,REAL(dltsig), 0.
      WRITE(numbimg) 0.
      WRITE(numbimg) 0.
      WRITE(numbimg) (( REAL(dhiso(ji,jiso)   ),      ji=1,npts), jiso=nbins,1,-1) ! isopyc depth
      WRITE(numbimg) (( REAL(dwtrpbin(ji,jiso))/1.e6, ji=1,npts), jiso=nbins,1,-1) ! binned transport
      WRITE(numbimg) (( REAL(dwtrp(ji,jiso)   )/1.e6, ji=1,npts), jiso=nbins,1,-1) ! cumulated transport
      CLOSE(numbimg)

   END SUBROUTINE bimg_writ

   SUBROUTINE cdf_writ( ksec)
      !!---------------------------------------------------------------------
      !!                  ***  ROUTINE cdf_writ  ***
      !!
      !! ** Purpose :  Write output cdf files if required 
      !!
      !! ** Method  :  Most of the variables are global 
      !!
      !!----------------------------------------------------------------------
      INTEGER(KIND=4),   INTENT(in) :: ksec  ! number of the section

      INTEGER(KIND=4)               :: ji, jk
      INTEGER(KIND=4)               :: ivar
      INTEGER(KIND=4)               :: icout
      INTEGER(KIND=4), DIMENSION(4) :: ipk, id_varout

      REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zdum
      TYPE(variable),  DIMENSION(4) :: sl_typvar
      CHARACTER(LEN=255)            :: csuffixvarnam
      CHARACTER(LEN=255)            :: cprefixlongnam
      !!----------------------------------------------------------------------
      IF ( cvarname(ksec) /= 'none' ) THEN
         csuffixvarnam = '_'//TRIM(cvarname(ksec))
      ELSE
         csuffixvarnam = ''
      ENDIF
      IF ( clongname(ksec) /= 'none' ) THEN
         cprefixlongnam = TRIM(clongname(ksec))//'_'
      ELSE
         cprefixlongnam = ''
      ENDIF

      ALLOCATE ( zdum(npts,1))
      ! (along section, depth ) 2D variables
      cf_nc=TRIM(csection(ksec))//'_secdep.nc'
      ! define variables
      ipk(:)=nk
      sl_typvar%rmissing_value    = 0.
      sl_typvar%rmissing_value    = 0.
      sl_typvar%scale_factor      = 1.
      sl_typvar%add_offset        = 0.
      sl_typvar%savelog10         = 0.
      sl_typvar%iwght             = iweight
      sl_typvar%conline_operation = 'N/A'
      sl_typvar%caxis             = 'XZT'

      ivar=1
      sl_typvar(ivar)%cname          = 'temperature'//TRIM(csuffixvarnam)
      sl_typvar(ivar)%cunits         = 'Celsius'
      sl_typvar(ivar)%valid_min      = -2.
      sl_typvar(ivar)%valid_max      = 45.
      sl_typvar(ivar)%clong_name     = TRIM(cprefixlongnam)//'Potential_temperature'
      sl_typvar(ivar)%cshort_name    = 'temperature'

      ivar=ivar+1
      sl_typvar(ivar)%cname          = 'salinity'//TRIM(csuffixvarnam)
      sl_typvar(ivar)%cunits         = 'PSU'
      sl_typvar(ivar)%valid_min      = 0.
      sl_typvar(ivar)%valid_max      = 45.
      sl_typvar(ivar)%clong_name     = TRIM(cprefixlongnam)//'Salinity'
      sl_typvar(ivar)%cshort_name    = 'salinity'

      ivar=ivar+1
      sl_typvar(ivar)%cname          = 'density'//TRIM(csuffixvarnam)
      sl_typvar(ivar)%cunits         = 'kg/m3 -1000'
      sl_typvar(ivar)%valid_min      = 0.
      sl_typvar(ivar)%valid_max      = 45.
      sl_typvar(ivar)%clong_name     = TRIM(cprefixlongnam)//'potential_density'
      sl_typvar(ivar)%cshort_name    = 'density'

      ivar=ivar+1
      sl_typvar(ivar)%cname          = 'velocity'//TRIM(csuffixvarnam)
      sl_typvar(ivar)%cunits         = 'm/s'
      sl_typvar(ivar)%valid_min      = -3.
      sl_typvar(ivar)%valid_max      = 3.
      sl_typvar(ivar)%clong_name     = TRIM(cprefixlongnam)//'Normal_velocity'
      sl_typvar(ivar)%cshort_name    = 'velocity'

      icout = create      (cf_nc, 'none',    npts, 1, nk, cdep=cn_vdeptht                     )
      ierr  = createvar   (icout, sl_typvar, ivar, ipk, id_varout, cdglobal=TRIM(cglobal)     )
      ierr  = putheadervar(icout, cf_tfil,   npts, 1, nk, &
           &   pnavlon=rlonlat, pnavlat=rlonlat, cdep=cn_vdeptht                              )

      !    tim  = getvar1d(cf_tfil, cn_vtimec, 1     )
      !    ierr = putvar1d(icout,   tim,       1, 'T')

      DO jk = 1, nk
         zdum(:,1)=zt(:,jk)   ; ierr = putvar ( icout, id_varout(1), zdum, jk, npts, 1 )
         zdum(:,1)=zs(:,jk)   ; ierr = putvar ( icout, id_varout(2), zdum, jk, npts, 1 )
         zdum(:,1)=dsig(:,jk) ; ierr = putvar ( icout, id_varout(3), zdum, jk, npts, 1 )
         zdum(:,1)=zu(:,jk)   ; ierr = putvar ( icout, id_varout(4), zdum, jk, npts, 1 )
      END DO

      ierr = closeout(icout)

      ! (along section, sigma ) 2D variables
      cf_nc=TRIM(csection(ksec))//'_secsig.nc'
      ! define variables
      ipk(:)=nbins
      sl_typvar%rmissing_value    = 99999.
      sl_typvar%rmissing_value    = 99999.
      sl_typvar%scale_factor      = 1.
      sl_typvar%add_offset        = 0.
      sl_typvar%savelog10         = 0.
      sl_typvar%iwght             = iweight
      sl_typvar%conline_operation = 'N/A'
      sl_typvar%caxis             = 'XST'

      ivar=1
      ipk(ivar)=nbins-1
      sl_typvar(ivar)%cname          = 'isodep'//TRIM(csuffixvarnam)
      sl_typvar(ivar)%cunits         = 'm'
      sl_typvar(ivar)%valid_min      = 0.
      sl_typvar(ivar)%valid_max      = 6000.
      sl_typvar(ivar)%clong_name     = TRIM(cprefixlongnam)//'isopycnal_depth'
      sl_typvar(ivar)%cshort_name    = 'isodep'

      ivar=ivar+1
      sl_typvar(ivar)%cname          = 'bintrp'//TRIM(csuffixvarnam)
      sl_typvar(ivar)%cunits         = 'SV'
      sl_typvar(ivar)%valid_min      = -5.
      sl_typvar(ivar)%valid_max      = 5.
      sl_typvar(ivar)%clong_name     = TRIM(cprefixlongnam)//'Binned_transport'
      sl_typvar(ivar)%cshort_name    = 'bintrp'

      ivar=ivar+1
      sl_typvar(ivar)%cname          = 'sumtrp'//TRIM(csuffixvarnam)
      sl_typvar(ivar)%cunits         = 'SV'
      sl_typvar(ivar)%valid_min      = -20.
      sl_typvar(ivar)%valid_max      = 20.
      sl_typvar(ivar)%clong_name     = TRIM(cprefixlongnam)//'cumulated_transport'
      sl_typvar(ivar)%cshort_name    = 'sumtrp'

      icout = create      (cf_nc, 'none',    npts, 1, nbins, cdep='levels'                 )
      ierr  = createvar   (icout, sl_typvar, ivar, ipk, id_varout, cdglobal=TRIM(cglobal)  )
      ierr  = putheadervar(icout, cf_tfil,   npts, 1, nbins, &
           &   pnavlon=rlonlat, pnavlat=rlonlat, pdep=REAL(dsigma_lev), cdep='levels'      )

      PRINT *, 'NBINS', nbins, npts
      DO jk = 1, nbins-1
         zdum(:,1)=dhiso   (:,jk)      ; ierr = putvar ( icout, id_varout(1), zdum, jk, npts, 1 )
      END DO
      DO jk = 1, nbins
         zdum(:,1)=dwtrpbin(:,jk)/1.e6 ; ierr = putvar ( icout, id_varout(2), zdum, jk, npts, 1 )
         zdum(:,1)=dwtrp   (:,jk)/1.e6 ; ierr = putvar ( icout, id_varout(3), zdum, jk, npts, 1 )
      END DO
      ierr = closeout(icout)

      DEALLOCATE ( zdum )

   END SUBROUTINE cdf_writ

   SUBROUTINE print_out(ksec)
      !!---------------------------------------------------------------------
      !!                  ***  ROUTINE print_out  ***
      !!
      !! ** Purpose :  Print results on standard output 
      !!
      !! ** Method  :  Most of the variables are global and already known 
      !!
      !!----------------------------------------------------------------------
      INTEGER(KIND=4), INTENT(in) :: ksec  ! number of the section

      INTEGER(KIND=4)             :: ji, jk, jiso, jbin
      !!----------------------------------------------------------------------
      WRITE(cfmt_9000,'(a,i4,a)') '(i7,  ',npts,'f8.3)'
      WRITE(cfmt_9001,'(a,i4,a)') '(i7,  ',npts,'f8.0)'
      WRITE(cfmt_9002,'(a,i4,a)') '(f7.3,',npts,'f8.0)'
      WRITE(cfmt_9003,'(a,i4,a)') '(f7.3,',npts,'f8.3)'
      PRINT *,' T (deg C)' 
      DO jk=1,nk
         PRINT cfmt_9000, jk,  (zt(ji,jk),ji=1,npts)
      END DO

      PRINT *,' S (PSU)'
      DO jk=1,nk
         PRINT cfmt_9000,  jk,  (zs(ji,jk),ji=1,npts)
      END DO

      PRINT *,' SIG (kg/m3 - 1000 )'
      DO jk=1,nk
         PRINT cfmt_9000, jk,  (dsig(ji,jk),ji=1,npts)
      END DO

      PRINT *,' VELOCITY (cm/s ) '
      DO jk=1,nk
         PRINT cfmt_9000, jk,  (zu(ji,jk)*100,ji=1,npts)
      END DO

      PRINT *,' GDEPU (m) '
      DO jk=1,nk
         PRINT cfmt_9001,jk,  (ddepu(ji,jk)*zmask(ji,jk),ji=1,npts)
      END DO

      PRINT *, 'E3 (m)'
      DO jk=1,nk
         PRINT cfmt_9001,jk,  (de3(ji,jk)*zmask(ji,jk),ji=1,npts)
      END DO

      PRINT *,' DEP ISO ( m )'
      DO  jiso =1, nbins+1
         PRINT cfmt_9002, dsigma_lev(jiso),(dhiso(ji,jiso),ji=1,npts)
      END DO

      PRINT *,' TRP SURF -->  ISO (SV)'
      DO  jiso =1, nbins+1
         PRINT  cfmt_9003, dsigma_lev(jiso),(dwtrp(ji,jiso)/1.d6,ji=1,npts)
      END DO

      PRINT *,' TRP bins (SV)'
      DO  jbin =1, nbins
         PRINT  cfmt_9003, dsigma_lev(jbin),(dwtrpbin(ji,jbin)/1.d6,ji=1,npts), dtrpbin(ksec,jbin)/1.d6
      END DO



   END SUBROUTINE print_out

END PROGRAM cdfsigtrp

PROGRAM cdfzisot
  !!======================================================================
  !!                     ***  PROGRAM  cdfzisot  ***
  !!=====================================================================
  !!  ** Purpose : Compute isothermal depth
  !!
  !!  ** Method  : - compute surface properties
  !!               - initialize depths and model levels number
  !!
  !! History : 3.0  : 07/2012  : F.Hernandez: Original code
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!           
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class derived_fields
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4),PARAMETER                    :: pnvarout = 2   ! number of output variables
  INTEGER(KIND=4)                              :: ji, jj, jk, jt ! dummy loop index
  INTEGER(KIND=4)                              :: jref           ! dummy loop index
  INTEGER(KIND=4)                              :: narg, iargc, ii ! browse line
  INTEGER(KIND=4)                              :: ijarg          ! line parser
  INTEGER(KIND=4)                              :: npiglo, npjglo ! domain size
  INTEGER(KIND=4)                              :: npk, npt       ! domain size
  INTEGER(KIND=4)                              :: ncout, ierr    ! ncid of output file, error status
  INTEGER(KIND=4), DIMENSION(pnvarout)         :: ipk, id_varout ! levels and varid's of output vars
  INTEGER(KIND=4), DIMENSION(:,:), ALLOCATABLE :: mbathy         ! mbathy metric

  REAL(KIND=4)                                 :: rtref          ! reference temperature
  REAL(KIND=4)                                 :: rmisval        ! Missing value of temperature
  REAL(KIND=4), DIMENSION(:),      ALLOCATABLE :: gdept          ! depth of T levels
  REAL(KIND=4), DIMENSION(:),      ALLOCATABLE :: gdepw          ! depth of W levels
  REAL(KIND=4), DIMENSION(1)                   :: rdep           ! dummy depth for output
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: rtem, rtemxz   ! temperature
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: tmask          ! temperature mask
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: glam,gphi      ! lon/lat
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: rzisot         ! depth of the isotherm
  REAL(KIND=4), DIMENSION(:,:),    ALLOCATABLE :: rzisotup       ! depth of the isotherm above
  !                                                              ! in case of inversion
  REAL(KIND=4), DIMENSION(:,:,:),  ALLOCATABLE :: rtem3d        ! 3d temperature

  REAL(KIND=8), DIMENSION(:),      ALLOCATABLE :: dtim           ! time counter

  CHARACTER(LEN=256)                           :: cf_tfil        ! input T file
  CHARACTER(LEN=256)                           :: cf_out='zisot.nc'! defaults output file name
  CHARACTER(LEN=256)                           :: cldum           ! dummy value

  TYPE(variable), DIMENSION(pnvarout)          :: stypvar        ! structure for output var. attributes

  LOGICAL                                      :: lnc4 = .FALSE.  ! Use nc4 with chunking and deflation
  LOGICAL                                      :: l3d  = .FALSE.  ! load full 3d variable in memory
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfzisot -t T-file -iso ISO-temp [-o OUT-file] [-nc4] [-3d]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the depth of an isotherm surface from the temperature file'
     PRINT *,'       and value of the isotherm given on the command line.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -t T-file  : input netcdf file with the ocean temperature.' 
     PRINT *,'       -iso ISO-temp : Indicates the temperature (Celsius) of the chosen'
     PRINT *,'            isotherm.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'        [-o OUT-file] : specify the output file name instead of ',TRIM(cf_out)
     PRINT *,'        [-nc4]  : Use netcdf4 output with chunking and deflation level 1.'
     PRINT *,'             This option is effective only if cdftools are compiled with'
     PRINT *,'             a netcdf library supporting chunking and deflation.'
     PRINT *,'        [-l3d]  : Read temperature variable as 3d ionstead of xz slice '
     PRINT *,'                  ( depending of the chunking pattern of the file '
     PRINT *,'                  it could speed up a lot the tool if your machine memory is big enough)'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        ',TRIM(cn_fzgr)
     PRINT *,'         In case of FULL STEP configuration, ',TRIM(cn_fbathylev),' is also required.'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) ,' unless option -o is used.'
     PRINT *,'      '
     STOP 
  ENDIF

  ijarg=1
  DO WHILE ( ijarg <= narg ) 
     CALL getarg (ijarg, cldum ) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-t'  ) ; CALL getarg (ijarg, cf_tfil) ; ijarg=ijarg+1
     CASE ( '-iso') ; CALL getarg (ijarg, cldum  ) ; ijarg=ijarg+1 ; READ(cldum,*) rtref
        ! options
     CASE ( '-o'  ) ; CALL getarg (ijarg, cf_out ) ; ijarg=ijarg+1
     CASE ( '-nc4') ; lnc4 = .TRUE. 
     CASE ( '-l3d') ; l3d  = .TRUE. 
     CASE DEFAULT   ; PRINT *,' ERROR : ',TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  ENDDO

  IF ( chkfile(cf_tfil) .OR. chkfile(cn_fzgr) ) STOP 99 ! missing file

  ! read dimensions 
  npiglo = getdim (cf_tfil,cn_x)
  npjglo = getdim (cf_tfil,cn_y)
  npk    = getdim (cf_tfil,cn_z)
  npt    = getdim (cf_tfil,cn_t)

  ALLOCATE (gdept(npk), gdepw(npk), dtim(npt) )
  ALLOCATE (rtem(npiglo,npjglo), rtemxz(npiglo,npk) )
  ALLOCATE (tmask(npiglo,npjglo), glam(npiglo,npjglo), gphi(npiglo,npjglo) )
  ALLOCATE (rzisot(npiglo,npjglo) , rzisotup(npiglo,npjglo) )
  ALLOCATE (mbathy(npiglo,npjglo) )
  IF ( l3d ) ALLOCATE (rtem3d(npiglo,npjglo,npk))

  ! read metrics gdept and gdepw
  gdept(:)    = getvare3(cn_fzgr, cn_gdept, npk )
  gdepw(:)    = getvare3(cn_fzgr, cn_gdepw, npk)

  ! read "mbathy"
  mbathy(:,:) = getvar(cn_fzgr, cn_mbathy,    1, npiglo, npjglo)

  ! get missing value of votemper
  rmisval = getatt(cf_tfil, cn_votemper, cn_missing_value )

  ! get longitude and latitude
  glam(:,:) = getvar(cf_tfil, cn_vlon2d, 1, npiglo, npjglo)
  gphi(:,:) = getvar(cf_tfil, cn_vlat2d, 1, npiglo, npjglo)

  ! initialize tmask: 1=valid / 0= no valid of SST
  tmask(:,:) = 1.
  rtem( :,:) = getvar(cf_tfil, cn_votemper, 1, npiglo, npjglo, ktime=1 )  
  WHERE ( rtem == rmisval ) tmask = 0.
  ! initialise matrix of results
  rzisot   = 0. ; WHERE ( rtem == rmisval ) rzisot   = rmisval
  rzisotup = 0. ; WHERE ( rtem == rmisval ) rzisotup = rmisval

  CALL CreateOutput
  
  IF (l3d) THEN  ! read 3d array at once in case of -l3d option
     rtem3d=getvar3d(cf_tfil, cn_votemper, npiglo, npjglo, npk)
  END IF

  DO jt=1,npt
     DO jj = 1 , npjglo
        IF (MOD(jj,100) == 0) PRINT *, jj,'/',npjglo

        ! read temperature on x-z slab
        IF (l3d) THEN ! just get vertical slab from the 3D array
           rtemxz(:,:) = rtem3d(:,jj,:) !getvarxz(cf_tfil, cn_votemper, jj, npiglo, npk, kimin=1, kkmin=1, ktime=jt )
        ELSE ! read the vertical slab
           rtemxz(:,:) = getvarxz(cf_tfil, cn_votemper, jj, npiglo, npk, kimin=1, kkmin=1, ktime=jt )
        END IF

        DO ji = 1, npiglo
           IF ( tmask(ji,jj) == 1 ) THEN
              IF ( COUNT( rtemxz(ji,:)>=rtref .AND. rtemxz(ji,:) .NE.rmisval ) > 0 ) THEN

                 jk = 1 ! count level down

                 ! take into account temperature inversion from the surface
                 IF ( rtemxz(ji,1)<rtref .AND. rtemxz(ji,1) /= rmisval ) THEN

                    ! search first level with T >= rtref
                    DO WHILE ( jk < npk .AND. rtemxz(ji,jk) < rtref .AND. rtemxz(ji,jk) /=  rmisval )
                       jref = jk
                       jk = jk + 1
                    ENDDO

                    ! compute depth of the above isotherm
                    rzisotup(ji,jj) = ( gdept(jk-1)*( rtemxz(ji,jk)-rtref ) + &
                         & gdept(jk)*( rtref-rtemxz(ji,jk-1) ) ) / &
                         & ( rtemxz(ji,jk)-rtemxz(ji,jk-1) )

                    !write(12,*)ji,jj,glam(ji,jj),gphi(ji,jj),rzisotup(ji,jj)

                 ENDIF

                 ! then start from the first level with T >= rtref
                 ! and search first value below rtref
                 jref = 0
                 DO WHILE ( jk < npk .AND. rtemxz(ji,jk) >= rtref .AND. rtemxz(ji,jk) /=  rmisval )
                    jref = jk
                    jk = jk + 1
                 ENDDO

                 ! test if the level is the last "wet level" in model metrics
                 ! OR if next temperature value is missing
                 ! Or at the bottom
                 ! --> give value of the bottom of the layer: gdepw(k+1)
                 IF ( jref == mbathy(ji,jj) .OR. rtemxz(ji,jref+1) == rmisval .OR. jref == npk-1 ) THEN
                    rzisot(ji,jj) = gdepw(jref+1)
                 ELSE
                    rzisot(ji,jj) = ( gdept(jref)*( rtemxz(ji,jref+1)-rtref ) + &
                         & gdept(jref+1)*( rtref-rtemxz(ji,jref) ) ) / &
                         & ( rtemxz(ji,jref+1)-rtemxz(ji,jref) )
                 ENDIF

              ENDIF  ! COUNT( rtemxz(ji,:)>=rtref
           ENDIF  ! tmask(ji,jj) == 1

        ENDDO ! ji = 1, npiglo
     ENDDO ! jj = 1 , npjglo

     ! Store the zisot variable in output file
     ierr = putvar(ncout, id_varout(1), rzisot, 1, npiglo, npjglo, ktime=jt)
     ierr = putvar(ncout, id_varout(2), rzisotup, 1, npiglo, npjglo, ktime=jt)

  END DO ! time loop

  ierr = closeout(ncout)

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    WRITE(cldum,'(f6.2)') rtref
    ! define structure to write the computed isotherm depth
    rdep(1) = 0.
    ipk(:)                    = 1
    stypvar(1)%ichunk         = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(1)%cname          = 'zisot'//TRIM(cldum)
    stypvar(2)%ichunk         = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(2)%cname          = 'zisotup'//TRIM(cldum)
    stypvar%cunits            = 'm'
    stypvar%rmissing_value    = 32767.
    stypvar%valid_min         = 0.
    stypvar%valid_max         = 7000.
    stypvar(1)%clong_name     = 'Depth_of_'//TRIM(cldum)//'C_isotherm' 
    stypvar(2)%clong_name     = 'Depth_of_'//TRIM(cldum)//'C_upper_isotherm' 
    stypvar(1)%cshort_name    = 'D'//TRIM(cldum)
    stypvar(2)%cshort_name    = 'D'//TRIM(cldum)//'up'
    stypvar%conline_operation = 'N/A'
    stypvar%caxis             = 'TYX'

    ! Create output file, based on existing input gridT file
    ncout = create      (cf_out, cf_tfil, npiglo, npjglo, 1               , ld_nc4=lnc4)
    ierr  = createvar   (ncout,  stypvar, pnvarout,      ipk,    id_varout, ld_nc4=lnc4)
    ierr  = putheadervar(ncout,  cf_tfil, npiglo, npjglo, 1, pdep=rdep)

    dtim = getvar1d(cf_tfil, cn_vtimec, npt     )
    ierr = putvar1d(ncout,   dtim,      npt, 'T')

  END SUBROUTINE CreateOutput

END PROGRAM cdfzisot

PROGRAM cdfmkmask
  !!======================================================================
  !!                     ***  PROGRAM  cdfmkmask  ***
  !!=====================================================================
  !!  ** Purpose : Build mask file from a salinity output
  !!
  !!  ** Method  : Read vosaline and set tmask to 1 where sal is not 0
  !!               then umask, vmask and fmask are deduced from tmask
  !!               REM: the result may be locally different for fmask than
  !!                   fmask produced online as there are computed on line
  !!               merged with cdfmkmask-zone by adding a zoom option. When
  !!               used with -zoom option, the mask is 0 outside the zoom
  !!               area.
  !!
  !! History : 2.1  : 11/2005  : J.M. Molines : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !! Modified  3.0  : 08/2011  : P.   Mathiot : Add zoomij, zoombat, zoomvar and time option
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!         : 4.0  : 08/2017  : P.   Mathiot : Add flood filling option
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  USE modutils
  USE cdftools
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class mask
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: ji, jj, jk, jt           ! dummy loop index
  INTEGER(KIND=4)                           :: ierr                     ! working integer
  INTEGER(KIND=4)                           :: narg, iargc, ijarg       ! 
  INTEGER(KIND=4)                           :: npiglo, npjglo, npk, npt ! size of the domain
  INTEGER(KIND=4)                           :: npkk                     ! handle case without vertical dim
  INTEGER(KIND=4)                           :: iimin, iimax, iipts      ! limit in i
  INTEGER(KIND=4)                           :: ijmin, ijmax, ijpts      ! limit in j
  INTEGER(KIND=4)                           :: ncout                    ! ncid of output file
  INTEGER(KIND=4), DIMENSION(4)             :: ipk, id_varout           ! outptut variables : number of levels,
  INTEGER(KIND=4), DIMENSION(:,:), ALLOCATABLE :: mbathy                ! bathymetry  in levels

  REAL(KIND=4)                              :: rlonmin, rlonmax         ! limit in longitude
  REAL(KIND=4)                              :: rlatmin, rlatmax         ! limit in latitude
  REAL(KIND=4)                              :: rbatmin, rbatmax         ! limit in latitude
  REAL(KIND=4)                              :: rlonpts, rlatpts         ! seed point for lfilllonlat
  REAL(KIND=4)                              :: rvarmin, rvarmax         ! limit in variable
  REAL(KIND=4), DIMENSION(:)  , ALLOCATABLE :: rdep                     ! depth 
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: tmask, rmask, ssmask     ! 2D masks at current level and non depth and time dependent mask
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: rlon, rlat               ! latitude and longitude
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: rbat                     ! bathymetry 

  REAL(KIND=8), DIMENSION(:)  , ALLOCATABLE :: dtim                     ! time counter

  CHARACTER(LEN=256)                        :: cf_sfil                  ! file name
  CHARACTER(LEN=256)                        :: cf_out = 'mask_sal.nc'   ! output file
  CHARACTER(LEN=256)                        :: cf_boundary = 'boundary.txt' ! default boundary input file
  CHARACTER(LEN=256)                        :: cv_mask                  ! variable name
  CHARACTER(LEN=256)                        :: cv_nam                   ! variable name
  CHARACTER(LEN=256)                        :: cv_dep                   ! variable name
  CHARACTER(LEN=256)                        :: cldum                    ! dummy string

  TYPE (variable), DIMENSION(4)             :: stypvar                  ! output attribute

  LOGICAL                                   :: lzoom    = .FALSE.       ! zoom flag lat/lon
  LOGICAL                                   :: lzoomij  = .FALSE.       ! zoom flag i/j
  LOGICAL                                   :: lzoombat = .FALSE.       ! zoom flag bat
  LOGICAL                                   :: lzoomvar = .FALSE.       ! zoom flag var
  LOGICAL                                   :: lfill    = .FALSE.       ! flood fill algo flag    
  LOGICAL                                   :: lfilllonlat = .FALSE.    ! flood fill algo flag    
  LOGICAL                                   :: lboundf  = .FALSE.       ! section flag var
  LOGICAL                                   :: lboundflonlat = .FALSE.  ! section flag var
  LOGICAL                                   :: ltime    = .FALSE.       ! time flag    
  LOGICAL                                   :: lmbathy  = .FALSE.       ! mbathy flag    
  LOGICAL                                   :: l2dmask  = .FALSE.       ! 2d mask flag
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfmkmask -s S-file [-zoom lonmin lonmax latmin latmax] ...'
     PRINT *,'                   ... [-var  VAR-name ] ...'
     PRINT *,'                   ... [-zoomij iimin iimax ijmin ijmax] ...'
     PRINT *,'                   ... [-zoombat bathymin bathymax]  ...'
     PRINT *,'                   ... [-zoomvar varname varmin varmax]  ...'
     PRINT *,'                   ... [-fill iiseed jjseed] ...'
     PRINT *,'                   ... [-bfij BOUND_IJ-file.txt] ...'
     PRINT *,'                   ... [-bflonlat BOUND_LONLAT-file.txt] ...'
     PRINT *,'                   ... [-time ] [-o OUT-file]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       In its simplest use, this tool builds a mask file from the salinity '
     PRINT *,'       field read from the input file, assuming that land points are set to'
     PRINT *,'       _Fill_Value.'
     PRINT *,'       '
     PRINT *,'       A growing set of options, extend this tool to a much more sophisticated'
     PRINT *,'       mask builder: use of other variables than salinity, range criteria on'
     PRINT *,'       the variables, geographical or model limits, and the possibility of'
     PRINT *,'       using any combination of the criteria.'
     PRINT *,'       '
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -s S-file : netcdf file with salinity.' 
     PRINT *,'               * if S-file = -maskfile, we assume a reference file named ',TRIM(cn_fmsk)
     PRINT *,'                   with tmask variable.' 
     PRINT *,'               * if S-file = -2dmaskfile, we assume a reference file named '
     PRINT *,'                  ',TRIM(cn_fmsk),' with tmaskutil variable.' 
     PRINT *,'               * if S-file = -mbathy, we assume a reference file named '
     PRINT *,'                   bathylevel.nc with mbathy variable, giving the number of '
     PRINT *,'                   levels in the ocean.' 
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-var  VAR-name ] : give the name of the variable to work with, instead'
     PRINT *,'                         ', TRIM(cn_vosaline),'.'
     PRINT *,'       [-zoom lonmin lonmax latmin latmax] : geographical windows used to'
     PRINT *,'                        limit the area where the mask is builded. Outside'
     PRINT *,'                        this area, the mask is set to 0.'
     PRINT *,'       [-zoomij iimin iimax ijmin ijmax] : model grid windows used to'
     PRINT *,'                        limit the area where the mask is builded. Outside'
     PRINT *,'                        this area, the mask is set to 0.'
     PRINT *,'       [-zoombat bathymin bathymax] : depth windows used to'
     PRINT *,'                        limit the area where the mask is builded. Outside'
     PRINT *,'                        this area, the mask is set to 0.' 
     PRINT *,'                        Need mesh_zgr.nc'
     PRINT *,'       [-zoomvar varname varmin varmax] : range of varname variable used to'
     PRINT *,'                        limit the area where the mask is builded. Outside'
     PRINT *,'                        this area, the mask is set to 0.'
     PRINT *,'       [-fill iiseed jjseed] : mask everything except the cells into the'
     PRINT *,'                        non mask area where the point (iiseed,jjseed) is.'
     PRINT *,'       [-filllonlat lon lat] : mask everything except the cells into the'
     PRINT *,'                        non mask area where the point (lon,lat) is.'
     PRINT *,'       [-bfij BOUND_IJ-file.txt] : Specify a boundary file expressed in'
     PRINT *,'                        model grid point. It is used in conjunction with'
     PRINT *,'                        -fill series of options, to define an arbitrary'
     PRINT *,'                        closed area where mask values will be 1.'
     PRINT *,'                        See format of boundary files in dedicated paragraph.'
     PRINT *,'       [-bflonlat BOUND_LONLAT-file.txt] :  Specify a boundary file expressed '
     PRINT *,'                        in geographical coordinates. It is used in conjunction'
     PRINT *,'                        with the -fill series of options, to define an '
     PRINT *,'                        arbitrary closed area, where mask values will be 1.'
     PRINT *,'                        See format of boundary files in dedicated paragraph.'
     PRINT *,'       [-time ] : Build a mask corresponding to each time step of the '
     PRINT *,'                       input file'
     PRINT *,'       [-o OUT-file ] : output file name to be used in place of standard'
     PRINT *,'                        name [ ',TRIM(cf_out),' ]'
     PRINT *,'      '
     PRINT *,'     FORMAT OF BOUNDARY FILES :'
     PRINT *,'       Boundary files describes a set of model sections forming a closed line.'
     PRINT *,'       Each section (segment of the boundary) is defined by the position '
     PRINT *,'       (either in model I-J, or in geographical LON-LAT) of the ending points'
     PRINT *,'       of the respective section. Therefore, each section in the boundary file'
     PRINT *,'       corresponds to 2 lines :'
     PRINT *,'       NAME'
     PRINT *,'       xmin xmax ymin ymax logical_flag'
     PRINT *,'       NAME2 '
     PRINT *,'       .......'
     PRINT *,'       EOF'
     PRINT *,'         where xmin xmax ymin ymax specify the ending points of the section,'
     PRINT *,'         and   logical_flag (either T ior F), indicates if the corresponding'
     PRINT *,'         section is to be taken into account (T). '
     PRINT *,'       Note that last line of the file should be just ''EOF'' '
     PRINT *,'      '
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       If option -zoombat is used, file ', TRIM(cn_fzgr),' is required.'
     PRINT *,'       If option T-file is -maskfile then ', TRIM(cn_fmsk), ' is required.'
     PRINT *,'       If option T-file is -mbathy then bathylevel.nc and ', TRIM(cn_fzgr) 
     PRINT *,'        are required.'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out), ' or OUT-file.'
     PRINT *,'         variables : tmask, umask, vmask, fmask'
     PRINT *,'                fmask can differ from standard fmask because it does not'
     PRINT *,'                reflect the slip/noslip lateral condition.'
     STOP 
  ENDIF

  ijarg = 1
  cv_nam = 'none'
  DO WHILE ( ijarg <= narg ) 
     CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1
     SELECT CASE ( cldum )
     CASE ('-s','-f') ; CALL getarg (ijarg, cf_sfil) ; ijarg = ijarg + 1
     CASE ('-var'   ) ; CALL getarg (ijarg, cv_nam ) ; ijarg = ijarg + 1
     CASE ( '-zoom' )  ! read a zoom lat/lon area
        lzoom = .TRUE.
        CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) rlonmin
        CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) rlonmax
        CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) rlatmin
        CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) rlatmax
        !
     CASE ( '-zoomij' )  ! read a zoom i/j area
        lzoomij = .TRUE.
        CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) iimin
        CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) iimax
        CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) ijmin
        CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) ijmax
        !
     CASE ( '-zoombat' )  ! read a zoom bathy area 
        lzoombat = .TRUE.
        CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) rbatmin
        CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) rbatmax
        !
     CASE ( '-zoomvar' ) ! read a zoom variable area
        lzoomvar = .TRUE.
        CALL getarg (ijarg, cv_mask) ; ijarg = ijarg + 1 ;
        CALL getarg (ijarg, cldum)   ; ijarg = ijarg + 1 ; READ(cldum,*) rvarmin 
        CALL getarg (ijarg, cldum)   ; ijarg = ijarg + 1 ; READ(cldum,*) rvarmax 
     CASE ( '-fill' )  ! read a seed point and a boundary file
        lfill = .TRUE.
        CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) iipts
        CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) ijpts
     CASE ( '-filllonlat' )  ! read a seed point and a boundary file
        lfilllonlat = .TRUE.
        CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) rlonpts
        CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) rlatpts
     CASE ( '-bf' )    ! read boundary file name
        lboundf=.TRUE.
        CALL getarg (ijarg, cf_boundary) ; ijarg = ijarg + 1
     CASE ( '-bflonlat' )    ! read boundary file name
        lboundflonlat=.TRUE.
        CALL getarg (ijarg, cf_boundary) ; ijarg = ijarg + 1
     CASE ( '-time' )  ! create a mask for each time step of the file
        ltime=.TRUE.
     CASE ( '-o'    )  ! change output file name
        CALL getarg (ijarg, cf_out) ; ijarg = ijarg + 1
        !
     CASE DEFAULT  ; PRINT *, ' ERROR : ',TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  ENDDO

  IF ( lfill .AND. lfilllonlat ) THEN
     PRINT *, 'E R R O R: 2 seeds for the filling specified (-fill and -filllonlat), STOP'; STOP 99
  END IF
  IF ( lboundf .AND. lboundflonlat ) THEN
     PRINT *, 'E R R O R: 2 boundary files for the filling specified (-bf and -bflonlat), STOP'; STOP 99
  END IF

  IF ( lzoom .AND. lzoomij ) PRINT *, 'WARNING 2 spatial condition for mask'

  IF (.NOT. lzoomvar) cv_mask = cn_vosaline
  IF ( cv_nam /= 'none' ) cv_mask = cv_nam
  IF (TRIM(cf_sfil)=='-maskfile') THEN
     cv_mask = cn_tmask
     cf_sfil = cn_fmsk
     cn_z    = 'z'
  END IF

  IF (TRIM(cf_sfil)=='-2dmaskfile') THEN
     cv_mask = 'tmaskutil'
     cf_sfil = cn_fmsk
     cn_z    = 'z'
     l2dmask=.TRUE.
  END IF

  IF (TRIM(cf_sfil)=='-mbathy') THEN
     cv_mask = cn_mbathy
     cv_dep  = 'nav_lev'
     cf_sfil = 'bathylevel.nc'
     cn_z    = 'z'
     lmbathy = .TRUE.
     IF ( chkfile(cn_fzgr) ) STOP 99 ! missing file
  END IF

  IF ( chkfile(cf_sfil) ) STOP 99 ! missing file

  npiglo = getdim (cf_sfil,cn_x)
  npjglo = getdim (cf_sfil,cn_y)
  IF ( lmbathy ) THEN
     npk  = getdim (cn_fzgr,cn_z)
     ALLOCATE ( rdep(npk) )
  ELSE IF ( l2dmask ) THEN
     PRINT *,' npk is forced to 1'
     npk  = 0
  ELSE
     npk  = getdim (cf_sfil,cn_z)
  ENDIF
  npt    = getdim (cf_sfil,cn_t)

  PRINT *,' npiglo = ', npiglo
  PRINT *,' npjglo = ', npjglo
  PRINT *,' npk    = ', npk
  PRINT *,' npt    = ', npt

  IF ( npt == 0 ) THEN
     PRINT *,' npt is forced to 1'
     npt = 1
  ENDIF

  IF ((npt > 1) .AND. (.NOT. ltime)) THEN 
     PRINT *, "WARNING npt > 1"
     PRINT *, "we used only the first time step"
     npt=1
  END IF

  IF ( npk == 0 ) THEN ; npkk = 1
  ELSE                 ; npkk = npk
  ENDIF

  ALLOCATE (dtim(npt))
  CALL CreateOutput

  !! Allocate only usefull variable and read only usefull variable
  ALLOCATE (tmask(npiglo,npjglo), rmask(npiglo,npjglo), ssmask(npiglo,npjglo))
  ssmask(:,:) = 1.

  !! apply constraint constant over time and depth
  !! mbathy constrain
  IF ( lmbathy ) THEN
     ALLOCATE (mbathy(npiglo,npjglo))
     mbathy(:,:) = getvar(cf_sfil, cv_mask, 1, npiglo, npjglo)
     WHERE (mbathy < jk ) ssmask = 0.
  ENDIF

  !! bathy constraint
  IF ( lzoombat ) THEN
     IF ( chkfile(cn_fzgr) ) STOP 99 ! missing file
     ALLOCATE ( rbat  (npiglo,npjglo) )
     rbat(:,:)= getvar(cn_fbathymet, cn_bathymet,  1 ,npiglo, npjglo)
     WHERE (rbat < rbatmin .OR. rbat > rbatmax) ssmask = 0
  ENDIF

  !! lat/lon constrain
  IF ( lzoom ) THEN
     ALLOCATE (rlon(npiglo,npjglo), rlat(npiglo,npjglo))
     rlon(:,:) = getvar(cf_sfil, cn_vlon2d, 1, npiglo, npjglo)
     rlat(:,:) = getvar(cf_sfil, cn_vlat2d, 1, npiglo, npjglo)
     IF (rlonmax > rlonmin) THEN
        WHERE (rlon > rlonmax ) ssmask = 0
        WHERE (rlon < rlonmin ) ssmask = 0
     ELSE
        WHERE (rlon < rlonmin .AND. rlon > rlonmax ) ssmask = 0
     END IF

     WHERE (rlat > rlatmax ) ssmask = 0
     WHERE (rlat < rlatmin ) ssmask = 0
  ENDIF

  !! i/j constrain
  IF ( lzoomij ) THEN
     ssmask(1:iimin-1,:     ) = 0   ! West
     ssmask(iimax+1:npiglo,:) = 0   ! East
     ssmask(:,ijmax+1:npjglo) = 0   ! North
     ssmask(:,1:ijmin-1     ) = 0   ! South
  ENDIF

  !! Now compute the mask 
  DO jt=1, npt
     IF (MOD(jt,10)==0) PRINT *,jt,'/',npt,' ...'
     DO jk=1, npkk
        PRINT *, jk,'/',npkk

        tmask(:,:) = getvar(cf_sfil, cv_mask,  jk, npiglo, npjglo, ktime=jt)
        tmask(:,:) = tmask(:,:) * ssmask(:,:)

        !! variable constrain
        IF ( lzoomvar ) THEN
           rmask=tmask
           WHERE ((tmask >= rvarmin) .AND. (tmask <= rvarmax)) rmask = 1
           WHERE ((tmask <  rvarmin) .OR.  (tmask >  rvarmax)) rmask = 0
           tmask=rmask
        ELSE
           WHERE (tmask > 0 ) tmask = 1
           WHERE (tmask <=0 ) tmask = 0
        ENDIF

        !! fill constrain
        IF ( lfill .OR. lfilllonlat ) THEN
           CALL FillMask(tmask,iipts,ijpts,rlonpts,rlatpts)
        ENDIF

        !! write t- u- v- mask
        ierr       = putvar(ncout, id_varout(1), tmask, jk ,npiglo, npjglo, ktime=jt)
        ! umask
        rmask = 0.
        DO ji=1,npiglo-1
           DO jj=1,npjglo
              rmask(ji,jj) = tmask(ji,jj)*tmask(ji+1,jj)
           END DO
        END DO
        ierr       = putvar(ncout, id_varout(2), rmask, jk ,npiglo, npjglo, ktime=jt)
        ! vmask
        rmask=0.
        DO ji=1,npiglo
           DO jj=1,npjglo-1
              rmask(ji,jj) = tmask(ji,jj)*tmask(ji,jj+1)
           END DO
        END DO
        ierr       = putvar(ncout, id_varout(3), rmask, jk, npiglo, npjglo, ktime=jt)
        !fmask
        rmask=0.
        DO ji=1,npiglo-1
           DO jj=1,npjglo-1
              rmask(ji,jj) = tmask(ji,jj)*tmask(ji,jj+1)*tmask(ji+1,jj)*tmask(ji+1,jj+1)
           END DO
        END DO
        ierr       = putvar(ncout, id_varout(4), rmask, jk, npiglo, npjglo, ktime=jt)
     END DO  ! loop to next level
  END DO ! loop to next time

  ierr   = closeout(ncout)

  PRINT *,''
  PRINT *,'Mask file ',TRIM(cf_out),' has been created' 

CONTAINS

  SUBROUTINE FillMask(pmask, kipts, kjpts, plonpts, platpts)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE FillMask  ***
    !!
    !! ** Purpose :  build mask when using flood filling option
    !!
    !! ** Method  : Use FillPool2D routine after eventually setting up the
    !!              boundary of the domain to fill.
    !!
    !!----------------------------------------------------------------------
    REAL(KIND=4), DIMENSION(:,:),  INTENT(inout) :: pmask
    REAL(KIND=4),                  INTENT(in   ) :: plonpts, platpts
    INTEGER(KIND=4),               INTENT(inout) :: kipts, kjpts ! seeding point coordinates

    INTEGER(KIND=4)                              :: js           ! dummy loop index
    INTEGER(KIND=4)                              :: ii, ij       ! working integer
    INTEGER(KIND=4)                              :: iunit=10
    INTEGER(KIND=4)                              :: ipts         ! local integer with number of points per section
    INTEGER(KIND=2), DIMENSION(:,:), ALLOCATABLE :: imask

    REAL(KIND=4)                                 :: zlonmin, zlonmax, zlatmin, zlatmax
    REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE    :: zmskline
    REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE    :: zmsk_bck
    REAL(KIND=4), DIMENSION(:)  , ALLOCATABLE    :: zxx, zyy       ! working variables

    CHARACTER(LEN=256)                           :: cldum          ! dummy char variable
    CHARACTER(LEN=256)                           :: cline          ! dummy char variable
    CHARACTER(LEN=256)                           :: cl_section     ! section names

    LOGICAL :: ll_inc, ll_section
    !!----------------------------------------------------------------------
    ALLOCATE(zmskline(npiglo, npjglo), zmsk_bck(npiglo, npjglo))
    ALLOCATE(imask(npiglo, npjglo))

    zmskline(:,:) = 0.0
    zmsk_bck(:,:) = pmask(:,:)

    IF (lboundf .OR. lboundflonlat) THEN
       PRINT *,''
       PRINT *,'Boundary file: ',TRIM(cf_boundary),' is used to close the basin'
       PRINT *,''

       IF ( chkfile(cf_boundary) ) STOP 99 ! missing file
       ! allocate arrays which are only used in this case ( lboundf OR lboundflonlat )
       ALLOCATE(zxx(npiglo+npjglo), zyy(npiglo+npjglo)) ! dimension specified in broken_line
       ! optimal dimension could be ABS(imax-imin +1) + ABS(jmax-jmin+1) - 1

       OPEN(iunit, FILE=cf_boundary)
       ll_section = .TRUE.
       DO WHILE (ll_section)
          zxx(:)=1; zyy(:)=1

          ! read section name
          READ(iunit,'(a)') cl_section
          IF (TRIM(cl_section) == 'EOF' ) THEN
             ll_section = .FALSE.
          ELSE
             ! read section coordinates
             IF (lboundflonlat) THEN
                READ(iunit,*) zlonmin, zlonmax, zlatmin, zlatmax, ll_inc
                CALL cdf_findij ( zlonmin, zlonmax, zlatmin, zlatmax, iimin, iimax, ijmin, ijmax, &
                     &            cd_coord=cn_fhgr, cd_point='T', cd_verbose='T')
             ELSE
                READ(iunit,*) iimin, iimax, ijmin, ijmax, ll_inc
             ENDIF

             ! get index of cell included into the section
             CALL broken_line(iimin, iimax, ijmin, ijmax, zxx, zyy, ipts, npiglo, npjglo)

             ! mask boundary and keep location in zmskline
             DO js=1,ipts
                ii=zxx(js)
                ij=zyy(js)
                IF (ll_inc)  zmskline(ii,ij)=1.0 * zmsk_bck(ii,ij)
                pmask(ii,ij)=0.0
             END DO
          ENDIF
       END DO
       CLOSE(iunit)
    ELSE
       PRINT *,''
       PRINT *, 'NO BOUNDARIES ARE ADDED TO THE INPUT FILE TO CLOSE THE BASIN'
       PRINT *,''
    END IF

    ! fill area
    ! find ij if lon/lat given
    IF (lfilllonlat) THEN
       CALL cdf_findij ( plonpts, plonpts, platpts, platpts, kipts, kipts, kjpts, kjpts, &
            &            cd_coord=cn_fhgr, cd_point='T', cd_verbose='F')   
    ENDIF
    imask = NINT(pmask,2)
    CALL FillPool2D(kipts, kjpts, imask, -1) ! fill pool (use -1 to flag the
    ! area and avoid infinit loop in the algo

    ! keep only the point selected by the flood filling algo
    WHERE ( imask == -1 )
       pmask = 1.0
    ELSE WHERE
       pmask = 0.0
    END WHERE

    ! apply mskline condition (ll_inc)
    WHERE (zmskline == 1.0)
       pmask = zmsk_bck
    END WHERE

  END SUBROUTINE FillMask

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    ipk(1:4)                       = npkk

    stypvar(1)%cname               = cn_tmask
    stypvar(2)%cname               = cn_umask
    stypvar(3)%cname               = cn_vmask
    stypvar(4)%cname               = cn_fmask

    stypvar(1:4)%cunits            = '1/0'
    stypvar(1:4)%rmissing_value    = 9999.
    stypvar(1:4)%valid_min         = 0.
    stypvar(1:4)%valid_max         = 1.

    stypvar(1)%clong_name          = cn_tmask
    stypvar(2)%clong_name          = cn_umask
    stypvar(3)%clong_name          = cn_vmask
    stypvar(4)%clong_name          = cn_fmask

    stypvar(1)%cshort_name         = cn_tmask
    stypvar(2)%cshort_name         = cn_umask
    stypvar(3)%cshort_name         = cn_vmask
    stypvar(4)%cshort_name         = cn_fmask

    stypvar(1:4)%conline_operation = 'N/A'
    stypvar(1:4)%caxis             = 'TZYX'
    stypvar(1:4)%cprecision        = 'i2'

    ncout = create      (cf_out, cf_sfil,  npiglo, npjglo, npk)
    ierr  = createvar   (ncout,    stypvar, 4,      ipk,    id_varout )

    IF ( lmbathy ) THEN ; rdep(:) = getvare3(cn_fzgr, cv_dep ,npk)
       ; ierr  = putheadervar(ncout,    cf_sfil,  npiglo, npjglo, npk, pdep=rdep, cdep='nav_lev')
    ELSE                ; ierr  = putheadervar(ncout,    cf_sfil,  npiglo, npjglo, npk)
    ENDIF
    dtim = 0.d0
    ierr = putvar1d(ncout, dtim, npt,'T')

  END SUBROUTINE CreateOutput

END PROGRAM cdfmkmask

PROGRAM cdfbn2
  !!======================================================================
  !!                     ***  PROGRAM  cdfbn2  ***
  !!=====================================================================
  !!  ** Purpose : Compute the Brunt Vaissala frequency
  !!               using same algoritm than NEMO
  !!
  !!  ** Method  : Try to avoid 3 d arrays : work with 2 levels a a time
  !!              The brunt-vaisala frequency is computed using the
  !!              polynomial expression of McDougall (1987):
  !!              N^2 = grav * beta * ( alpha/beta*dk[ t ] - dk[ s ] )/e3w
  !!              N2 is then insterpolated at T levels
  !!
  !! History : 2.0  : 11/2004  : J.M. Molines : Original code
  !!           2.1  : 04/2005  : J.M. Molines : use cdfio
  !!           3.0  : 12/2010  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames   ! for cdf variable names
  USE eos
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class Equation_of_state
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                              :: jk, jt                   ! dummy loop index
  INTEGER(KIND=4)                              :: it                       ! time index for vvl
  INTEGER(KIND=4)                              :: ierr                     ! working integer
  INTEGER(KIND=4)                              :: narg, iargc, ijarg       ! 
  INTEGER(KIND=4)                              :: npiglo, npjglo, npk, npt ! size of the domain
  INTEGER(KIND=4)                              :: iup = 1, idown = 2, itmp ! for swapping the levels
  INTEGER(KIND=4)                              :: ncout                    ! ncid of output file
  INTEGER(KIND=4), DIMENSION(1)                :: ipk, id_varout           ! level and id of output variables

  REAL(KIND=4)                                 :: zsps                     ! Missing value for salinity
  REAL(KIND=4), DIMENSION (:,:,:), ALLOCATABLE :: ztemp, zsal, zwk         ! Array to read 2 layer of data
  REAL(KIND=4), DIMENSION (:,:),   ALLOCATABLE :: zn2                      ! Brunt Vaissala Frequency (N2)
  REAL(KIND=4), DIMENSION (:,:),   ALLOCATABLE :: zmask, e3w               ! mask and metric
  REAL(KIND=4), DIMENSION (:),     ALLOCATABLE :: gdep,  e3w1d             ! depth and time

  REAL(KIND=8), DIMENSION (:),     ALLOCATABLE :: dtim                     ! depth and time

  CHARACTER(LEN=256)                           :: cf_tfil, cldum, cv_dep   ! input file name, ...
  CHARACTER(LEN=256)                           :: cf_sfil                  !
  CHARACTER(LEN=256)                           :: cf_out = 'bn2.nc'        ! output file name
  CHARACTER(LEN=256)                           :: cglobal                  ! global attribute
  CHARACTER(LEN=80)                            :: cf_e3w                   ! file with e3w in case of vvl
  CHARACTER(LEN=80)                            :: cv_bn2  = 'vobn2'        ! cdf variable name for N2

  TYPE(variable), DIMENSION(1)                 :: stypvar                  ! variable attribute

  LOGICAL                                      :: l_w   =.FALSE.           ! flag for vertical location of bn2
  LOGICAL                                      :: lchk                     ! check missing files
  LOGICAL                                      :: lfull =.FALSE.           ! full step flag
  LOGICAL                                      :: lnc4  =.FALSE.           ! full step flag
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  cf_sfil='none'
  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfbn2  -t T-file [-s S-file] [-W] [-full] [-o OUT-file]...'
     PRINT *,'               ... [-nc4] [-vvl W-file]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the Brunt-Vaissala frequency (N2) according to temperature and' 
     PRINT *,'       salinity given in the input file.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -t T-file : netcdf input gridT file for temperature and salinity.' 
     PRINT *,'             If salinity is not in T-file, use -s option...' 
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-s S-file ] : specify salinity file name if not T-file' 
     PRINT *,'       [-W ] : keep N2 at W points. Default is to interpolate N2 at T point on' 
     PRINT *,'             the vertical.'
     PRINT *,'       [-full ] : indicate a full step configuration instead of the default'
     PRINT *,'             partial steps.'
     PRINT *,'       [-o OUT-file ] : specify output file name instead of ',TRIM(cf_out),'.'
     PRINT *,'       [-nc4 ]  : Use netcdf4 output with chunking and deflation level 1.'
     PRINT *,'                 This option is effective only if cdftools are compiled with'
     PRINT *,'                 a netcdf library supporting chunking and deflation.'
     PRINT *,'       [-vvl W-file ] : use time-varying vertical metrics, W-file is a file'
     PRINT *,'                 holding e3w(t) for vvl.'
     PRINT *,'      '
     PRINT *,'     OPENMP SUPPORT : yes'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ',TRIM(cn_fzgr),' is needed for this program.' 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) ,' unless -o option specified'
     PRINT *,'         variables : ', TRIM(cv_bn2)
     PRINT *,'      '
     PRINT *,'    SEE ALSO :'
     PRINT *,'       cdfsig0, cdfsigi, cdfsiginsitu, cdfsigntr '
     STOP 
  ENDIF

  cglobal = 'Partial step computation'

  ijarg = 1
  DO WHILE ( ijarg <= narg ) 
     CALL getarg(ijarg, cldum) ; ijarg = ijarg + 1
     SELECT CASE (cldum)
     CASE ( '-t'    ) ; CALL getarg(ijarg, cf_tfil) ; ijarg = ijarg + 1
        ! options
     CASE ( '-s'    ) ; CALL getarg(ijarg, cf_sfil) ; ijarg = ijarg + 1
     CASE ( '-W'    ) ; l_w     = .TRUE.
     CASE ( '-full' ) ; lfull   = .TRUE. ; cglobal = 'full step computation'
     CASE ( '-o'    ) ; CALL getarg(ijarg, cf_out ) ; ijarg = ijarg + 1
     CASE ( '-nc4'  ) ; lnc4    = .TRUE.
     CASE ( '-vvl'  ) ; lg_vvl  = .TRUE. 
        ; CALL getarg(ijarg, cf_e3w ) ; ijarg = ijarg + 1
     CASE DEFAULT     ; PRINT *,' ERROR : ', TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  END DO
  IF ( cf_sfil == 'none' ) cf_sfil=cf_tfil

  lchk = chkfile (cn_fzgr )
  lchk = lchk .OR. chkfile (cf_tfil  )
  lchk = lchk .OR. chkfile (cf_sfil  )
  IF (lg_vvl ) lchk = lchk .OR. chkfile (cf_e3w) 
  IF ( lchk  ) STOP 99  ! missing files 
  ! Look for missing value for salinity
  zsps = getspval(cf_sfil, cn_vosaline)

  IF ( lg_vvl ) THEN
    cn_fe3w = cf_e3w
    cn_ve3w = cn_ve3wvvl
  ENDIF

  npiglo = getdim (cf_tfil, cn_x)
  npjglo = getdim (cf_tfil, cn_y)
  npk    = getdim (cf_tfil, cn_z)
  npt    = getdim (cf_tfil, cn_t)


  PRINT *, 'npiglo =', npiglo
  PRINT *, 'npjglo =', npjglo
  PRINT *, 'npk    =', npk
  PRINT *, 'npt    =', npt

  ALLOCATE (ztemp(npiglo,npjglo,2), zsal(npiglo,npjglo,2) )
  ALLOCATE (zwk(npiglo,npjglo,2), zmask(npiglo,npjglo)    )
  ALLOCATE (zn2(npiglo,npjglo), e3w(npiglo,npjglo)        )
  ALLOCATE (gdep(npk), dtim(npt)                          )
  IF ( lfull ) ALLOCATE (e3w1d(npk) )

  cv_dep=cn_gdept
  IF (l_w) cv_dep=cn_gdepw

  gdep(:) = getvare3(cn_fzgr, cv_dep, npk)

  CALL CreateOutput

  IF ( lfull )  e3w1d(:) = getvare3(cn_fzgr, cn_ve3w1d, npk)

  gdep(:) = getvare3(cn_fzgr, cn_gdepw, npk)
  DO jt=1,npt
     IF ( lg_vvl ) THEN ; it=jt
     ELSE               ; it=1
     ENDIF
     !  2 levels of T and S are required : iup,idown (with respect to W level)
     !  Compute from bottom to top (for vertical integration)
     ztemp(:,:,idown) = getvar(cf_tfil, cn_votemper,  npk-1, npiglo, npjglo, ktime=jt)
     zsal( :,:,idown) = getvar(cf_sfil, cn_vosaline,  npk-1, npiglo, npjglo, ktime=jt)
     zwk(:,:,idown)   = 0.0

     DO jk = npk-1, 2, -1 
        PRINT *,'level ',jk
        zmask(:,:)=1.
        ztemp(:,:,iup)= getvar(cf_tfil, cn_votemper, jk-1, npiglo, npjglo, ktime=jt)
        zsal(:,:,iup) = getvar(cf_sfil, cn_vosaline, jk-1, npiglo, npjglo, ktime=jt)
        WHERE(zsal(:,:,idown) == zsps ) zmask = 0

        IF ( lfull ) THEN ; e3w(:,:) = e3w1d(jk)
        ELSE              ; e3w(:,:) = getvar(cn_fe3w, cn_ve3w , jk, npiglo, npjglo, ktime=it, ldiom=.NOT.lg_vvl )
        ENDIF

        zwk(:,:,iup) = eosbn2(ztemp, zsal, gdep(jk), e3w, npiglo, npjglo ,iup, idown)* zmask(:,:)

        IF ( .NOT. l_w ) THEN
           ! now put zn2 at T level (k )
           WHERE ( zwk(:,:,idown) == 0 ) ; zn2(:,:) =  zwk(:,:,iup)
           ELSEWHERE                     ; zn2(:,:) = 0.5 * ( zwk(:,:,iup) + zwk(:,:,idown) ) * zmask(:,:)
           END WHERE
        ELSE
          zn2(:,:) = zwk(:,:,iup)
        ENDIF

        WHERE ( zn2 == 0 ) zn2 = -1000.
        ierr = putvar(ncout, id_varout(1), zn2, jk, npiglo, npjglo, ktime=jt )
        itmp = idown ; idown = iup ; iup = itmp

     END DO  ! loop to next level
   END DO

   ierr = closeout(ncout)

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    ipk(1)                       = npk  !  3D
    stypvar(1)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(1)%cname             = cv_bn2
    stypvar(1)%cunits            = 's-1'
    stypvar(1)%rmissing_value    = -1000.
    stypvar(1)%valid_min         = 0.
    stypvar(1)%valid_max         = 50000.
    stypvar(1)%clong_name        = 'Brunt_Vaissala_Frequency'
    stypvar(1)%cshort_name       = cv_bn2
    stypvar(1)%conline_operation = 'N/A'
    stypvar(1)%caxis             = 'TZYX'

    ! create output fileset
    ncout = create      (cf_out,   cf_tfil,  npiglo, npjglo, npk,                               ld_nc4=lnc4 )
    ierr  = createvar   (ncout ,   stypvar,  1,      ipk,    id_varout, cdglobal=TRIM(cglobal), ld_nc4=lnc4 )
    ierr  = putheadervar(ncout,    cf_tfil,  npiglo, npjglo, npk, pdep=gdep)

    dtim = getvar1d(cf_tfil, cn_vtimec, npt    )
    ierr = putvar1d(ncout,  dtim,       npt,'T')

  END SUBROUTINE CreateOutput

END PROGRAM

PROGRAM cdfdiv
  !!======================================================================
  !!                     ***  PROGRAM  cdfdiv  ***
  !!=====================================================================
  !!  ** Purpose : Compute the divergence for given gridU gridV files
  !!               and variables
  !!
  !!  ** Method  : Use the same stencil than in NEMO code for computing
  !!               vertical velocities
  !!
  !! History :  3.0  : 10/2011  : P. Mathiot : first version, based on cdfw.f90
  !!                 : 05/2015  : J.M. Molines : revised version similar to cdfcurl
  !!         :  4.0  : 03/2017  : J.M. Molines  
  !!
  !!----------------------------------------------------------------------

  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class derived_fields
  !!----------------------------------------------------------------------

  IMPLICIT NONE

  INTEGER(KIND=4)                           :: ji, jj, jk, jt     ! dummy loop index
  INTEGER(KIND=4)                           :: it                 ! time index for vvl
  INTEGER(KIND=4)                           :: npiglo, npjglo     ! size of the domain
  INTEGER(KIND=4)                           :: npk, npt           ! size of the domain
  INTEGER(KIND=4)                           :: nlev               ! number of output levels
  INTEGER(KIND=4)                           :: narg, iargc        ! browse command line
  INTEGER(KIND=4)                           :: ijarg              !
  INTEGER(KIND=4)                           :: ncout, ierr        ! browse command line
  INTEGER(KIND=4), DIMENSION(1)             :: ipk, id_varout     ! output variable properties
  INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE :: nilev             ! level to be processed

  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e1v, e2u, e1t, e2t ! horizontql metrics
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e3u, e3v, e3t      ! vertical metrics
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: un, vn             ! velocity field
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zun, zvn           ! working arrays
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: zdep, gdep         ! depth
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: e31d               !  vertical metrics (full step)
  REAL(KIND=4)                              :: zmask              ! mask at T point for -T option

  REAL(KIND=8)                              :: dl_pi, dl_omega    ! 3.14159... and earth rotation rad/sec
  REAL(KIND=8), DIMENSION(:),   ALLOCATABLE :: dtim               ! time counter
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dhdivn             ! divergence
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dl_ff              ! Coriolis parameter at T point

  CHARACTER(LEN=256)                        :: cf_ufil, cf_vfil   ! file names
  CHARACTER(LEN=256)                        :: cf_tfil            ! T-file for vvl e3t metrics
  CHARACTER(LEN=256)                        :: cf_out = 'div.nc' ! output file name
  CHARACTER(LEN=256)                        :: cv_u, cv_v         ! variable names
  CHARACTER(LEN=256)                        :: cldum              ! dummy string

  TYPE (variable), DIMENSION(1)             :: stypvar            ! structure for attibutes

  LOGICAL                                   :: lforcing = .FALSE. ! forcing flag
  LOGICAL                                   :: lchk     = .FALSE. ! flag for missing files
  LOGICAL                                   :: lperio   = .FALSE. ! flag for E-W periodicity
  LOGICAL                                   :: ldblpr   = .FALSE. ! flag for dble precision output
  LOGICAL                                   :: lsurf    = .FALSE. ! flag for 1 lev on C grid.
  LOGICAL                                   :: loverf   = .FALSE. ! flag for 1 lev on C grid.
  LOGICAL                                   :: lfull    = .FALSE. ! full step flag
  LOGICAL                                   :: lnc4     = .FALSE. ! Use nc4 with chunking and deflation

  !!----------------------------------------------------------------------
  CALL ReadCdfNames() 
  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfdiv -u U-file U-var -v V-file V-var -l LST-level [-8]...'
     PRINT *,'          ... [-surf] [-overf] [-full] [-o OUT-file ] [-nc4] '
     PRINT *,'          ... [-vvl T-file]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the divergence of the flow from the U and V velocity components.'
     PRINT *,'       Divergence is computed at T point on the C-grid.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -u U-file U-var : file and variable name for zonal component'
     PRINT *,'       -v V-file V-var : file and variable name for meridional component'
     PRINT *,'       -l LST-level : levels to be processed. If set to 0, assume forcing file.'
     PRINT *,'              in input. Example of recognized syntax :'
     PRINT *,'               -l "1,10,30"  or -l "1-20" or even -l "1-3,10-20,30-"'
     PRINT *,'               -l  1 . Note that -l "3-" set a level list from 3 to the bottom'
     PRINT * 
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-8]: save in double precision instead of standard simple precision.'
     PRINT *,'       [-surf] : work with single level C-grid (not forcing)'
     PRINT *,'       [-overf]: store the ratio div/f where f is the coriolis parameter'
     PRINT *,'       [-full] : in case of full step configuration. Default is partial step.'
     PRINT *,'       [-o OUT-file] : specify output file name instead of ',TRIM(cf_out) 
     PRINT *,'       [-nc4]  : Use netcdf4 output with chunking and deflation level 1.'
     PRINT *,'                This option is effective only if cdftools are compiled with'
     PRINT *,'                a netcdf library supporting chunking and deflation.'
     PRINT *,'       [-vvl T-file] : use time-varying e3t, specify T-file for e3t.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        ', TRIM(cn_fhgr),' ',TRIM(cn_fzgr)
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) ,' unless -o option is used.'
     PRINT *,'         variables : div units : s^-1'
     PRINT *,'               or divoverf, no units (if -overf option)'
     PRINT *,'      '
     STOP 
  ENDIF

  ijarg=1
  DO WHILE ( ijarg <= narg ) 
     CALL getarg(ijarg, cldum) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ('-u'    ) ; CALL getarg(ijarg, cf_ufil) ; ijarg=ijarg+1
        ;              CALL getarg(ijarg, cv_u   ) ; ijarg=ijarg+1
     CASE ('-v'    ) ; CALL getarg(ijarg, cf_vfil) ; ijarg=ijarg+1
        ;              CALL getarg(ijarg, cv_v   ) ; ijarg=ijarg+1
     CASE ('-l'    ) ; CALL getarg(ijarg, cldum  ) ; ijarg=ijarg+1 
        ;              CALL ParseLevel(cldum)  ! fills in array nilev(nlev)
     CASE ('-8'    ) ; ldblpr = .TRUE.
     CASE ('-surf' ) ; lsurf  = .TRUE.
     CASE ('-overf') ; loverf = .TRUE.
     CASE ('-full' ) ; lfull  = .TRUE.
     CASE ('-nc4'  ) ; lnc4   = .TRUE.
     CASE ('-o'    ) ; CALL getarg(ijarg, cf_out ) ; ijarg=ijarg+1
     CASE ('-vvl'  ) ; lg_vvl = .TRUE.
        ;              CALL getarg(ijarg, cf_tfil) ; ijarg=ijarg+1 
     CASE DEFAULT    ; PRINT *,' ERROR : ', TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  ENDDO

  lchk = chkfile(cn_fhgr ) .OR. lchk
  lchk = chkfile(cn_fzgr ) .OR. lchk
  lchk = chkfile(cf_ufil ) .OR. lchk
  lchk = chkfile(cf_vfil ) .OR. lchk
  IF ( lchk ) STOP 99 ! missing files

  IF ( lg_vvl ) THEN
     cn_fe3u = cf_ufil
     cn_fe3v = cf_vfil
     cn_fe3t = cf_tfil

     cn_ve3u = cn_ve3uvvl
     cn_ve3v = cn_ve3vvvl
     cn_ve3t = cn_ve3tvvl
  ENDIF

  npiglo = getdim(cf_ufil,cn_x)
  npjglo = getdim(cf_ufil,cn_y)
  npk    = getdim(cf_ufil,cn_z)
  npt    = getdim(cf_ufil,cn_t) 

  PRINT *, 'NPIGLO = ', npiglo
  PRINT *, 'NPJGLO = ', npjglo
  PRINT *, 'NPK    = ', npk
  PRINT *, 'NPT    = ', npt
  PRINT *, 'NLEV   = ', nlev

  !test if lev exists
  IF ( (npk==0) .AND. (nlev > 0) .AND. .NOT. lsurf ) THEN
     PRINT *, 'Problem : npk = 0 and lev > 0 STOP 99'
     PRINT *, '  Use -surf option is dealing with single level file on C grid '
     STOP 99
  END IF

  ! case of 1 level on C-grid
  IF ( lsurf ) THEN
     nlev=1
     IF (ALLOCATED (nilev) ) DEALLOCATE(nilev) 
     ALLOCATE(nilev(nlev) )
     npk = 1 ; nilev(1) =1 
  ENDIF

  ! if forcing field 
  IF ( nilev(1) == 0 .AND. npk==0 ) THEN
     lforcing=.TRUE.
     npk = 1 ; nilev(1)=1
     PRINT *, 'npk =0, assume 1'
  END IF

  IF ( npt==0 ) THEN
     PRINT *, 'npt=0, assume 1'
     npt=1
  END IF
  ! 
  DO jk = 1, nlev
     IF (nilev(jk) >= npk ) THEN
        nlev=jk
        EXIT
     ENDIF
  ENDDO
  PRINT *, 'NLEV', nlev

  ! Allocate the memory
  ALLOCATE ( e1v(npiglo,npjglo), e2u(npiglo,npjglo) )
  ALLOCATE ( e1t(npiglo,npjglo), e2t(npiglo,npjglo) )
  ALLOCATE ( e3u(npiglo,npjglo), e3v(npiglo,npjglo), e3t(npiglo,npjglo) )

  ALLOCATE ( un(npiglo,npjglo)  , vn(npiglo,npjglo)  )
  ALLOCATE ( zun(npiglo,npjglo) , zvn(npiglo,npjglo) )
  ALLOCATE ( dhdivn(npiglo,npjglo) )
  ALLOCATE ( dtim(npt) )
  ALLOCATE ( gdep(nlev) , zdep(npk))
  IF ( lfull ) ALLOCATE ( e31d (npk) )

  e1v =  getvar(cn_fhgr, cn_ve1v, 1, npiglo, npjglo)
  e1t =  getvar(cn_fhgr, cn_ve1t, 1, npiglo, npjglo)
  e2u =  getvar(cn_fhgr, cn_ve2u, 1, npiglo, npjglo)
  e2t =  getvar(cn_fhgr, cn_ve2t, 1, npiglo, npjglo)

  ! use zun and zvn to store f latitude and longitude for output
  zun = getvar(cn_fhgr, cn_glamt, 1, npiglo, npjglo)
  zvn = getvar(cn_fhgr, cn_gphit, 1, npiglo, npjglo)

  IF ( loverf ) THEN
     ALLOCATE (dl_ff(npiglo,npjglo) )
     dl_pi = ACOS(-1.d0)
     dl_omega = 2* dl_pi/86400.d0
     dl_ff = 2* dl_omega* SIN ( zvn*dl_pi/180.d0 ) 
  ENDIF

  ! fills in gdep
  IF ( lforcing .OR. lsurf ) THEN
     gdep(1)=0.
  ELSE
     zdep(:) = getvar1d(cf_ufil, cn_vdepthu, npk )
     DO jk=1,nlev
        gdep(jk) = zdep( nilev(jk) )
     ENDDO
  ENDIF
  IF ( lfull ) e31d(:) = getvare3(cn_fzgr, cn_ve3t1d, npk)

  ! look for  E-W periodicity
  IF ( zun(1,1) == zun(npiglo-1,1) ) lperio = .TRUE.

  CALL CreateOutput

  DO jt=1,npt
     IF (MOD(jt,100)==0 ) PRINT *, jt,'/',npt

     IF ( lg_vvl ) THEN  ; it=jt
     ELSE                ; it=1
     ENDIF
     DO jk = 1, nlev

        zun(:,:) =  getvar(cf_ufil, cv_u, nilev(jk) ,npiglo,npjglo, ktime=jt)
        zvn(:,:) =  getvar(cf_vfil, cv_v, nilev(jk) ,npiglo,npjglo, ktime=jt)

        IF ( lfull ) THEN
           e3u(:,:) = e31d(jk)
           e3v(:,:) = e31d(jk)
           e3t(:,:) = e31d(jk)
        ELSE
           ! e3 metrics at level jk ( Partial steps)
           e3u(:,:) = getvar(cn_fe3u, cn_ve3u, jk, npiglo, npjglo, ktime=it, ldiom=.NOT.lg_vvl )
           e3v(:,:) = getvar(cn_fe3v, cn_ve3v, jk, npiglo, npjglo, ktime=it, ldiom=.NOT.lg_vvl )
           e3t(:,:) = getvar(cn_fe3t, cn_ve3t, jk, npiglo, npjglo, ktime=it, ldiom=.NOT.lg_vvl )
        ENDIF

        IF ( lforcing ) THEN ! for forcing file u and v are on the A grid
           DO ji=1, npiglo-1
              un(ji,:) = 0.5*(zun(ji,:) + zun(ji+1,:))
           END DO
           !
           DO jj=1, npjglo-1
              vn(:,jj) = 0.5*(zvn(:,jj) + zvn(:,jj+1))
           END DO
           ! end compute u and v on U and V point
        ELSE
           un(:,:) = zun(:,:)
           vn(:,:) = zvn(:,:)
        END IF

        dhdivn(:,:) = 0.d0
        DO jj = 2, npjglo -1
           DO ji = 2, npiglo -1
              dhdivn(ji,jj) =   &
                   &  (  e2u(ji,  jj  )*e3u(ji  ,jj  ) * un(ji  ,jj  )*1.d0 - &
                   &     e2u(ji-1,jj  )*e3u(ji-1,jj  ) * un(ji-1,jj  )*1.d0   &
                   &   + e1v(ji  ,jj  )*e3v(ji  ,jj  ) * vn(ji  ,jj  )*1.d0 - &
                   &     e1v(ji  ,jj-1)*e3v(ji  ,jj-1) * vn(ji  ,jj-1)*1.d0  )&
                   & / ( e1t(ji,jj)*e2t(ji,jj) * e3t(ji,jj) )
           END DO
        END DO

        IF ( lperio ) dhdivn(npiglo,:) = dhdivn(2, :)

        ! write dhdivn on file at level k and at time jt
        IF ( loverf ) THEN
           WHERE (dl_ff /= 0.d0) dhdivn=dhdivn/dl_ff
        ENDIF

        ierr = putvar(ncout, id_varout(1), dhdivn, jk, npiglo, npjglo, ktime=jt)
     ENDDO
  END DO
  ierr = closeout(ncout)

CONTAINS

  SUBROUTINE ParseLevel( cdum )
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE ParsLevel  ***
    !!
    !! ** Purpose :  Parse a string representing a level list with no separator
    !!               or , or - as separator 
    !!
    !! ** Method  :   1,3,5 => list = (1,3,5)
    !!                1-4   => liste = ( 1,2,3,4) 
    !!                1-4,6-8   => liste = ( 1,2,3,4,6,7,8) 
    !!                10-      => liste = (10,11,12,...bottom)
    !!                Allocate and fill nilev array with respective levels
    !!
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*), INTENT (in ) :: cdum

    INTEGER(KIND=4)                 :: jc, jk
    INTEGER(KIND=4)                 :: ilength, ik1, ik2
    INTEGER(KIND=4)                 :: icomma, idash, ipos, ipos1
    INTEGER(KIND=4), DIMENSION(350) :: ilev
    CHARACTER(LEN=256) :: cldum
    CHARACTER(LEN=80), DIMENSION(:), ALLOCATABLE :: clblk
    !!----------------------------------------------------------------------
    ilength=LEN(TRIM(cdum) )

    ! look for , and -
    icomma = 0 ; idash = 0
    DO jc=1,ilength
       IF ( cdum(jc:jc) == ',' ) THEN
          icomma = icomma + 1
       ELSE IF ( cdum(jc:jc) == '-' ) THEN
          idash = idash + 1
       ENDIF
    END DO

    ! no dash nor comma
    IF (icomma == 0 .AND. idash == 0 ) THEN
       nlev=1
       ALLOCATE ( nilev(nlev) )
       READ(cdum,*) nilev(1)
       RETURN
    ENDIF
    ! look for the number of blocks (between commas)
    cldum=cdum
    ALLOCATE (clblk(icomma+1))

    ipos1=1
    DO jc=1,icomma
       ipos=INDEX(cldum ,",")
       clblk(jc)=cldum(1:ipos-1)
       ipos1=ipos+1
       cldum=cldum(ipos1:)
    ENDDO
    clblk(icomma+1)=cldum

    ! now parse block
    nlev=0
    DO jc=1,icomma+1
       ipos=INDEX(clblk(jc),"-")
       IF ( ipos == 0 ) THEN
          nlev=nlev+1
          READ(clblk(jc),* ) ilev(nlev) 
       ELSE IF ( ipos == LEN(TRIM((clblk(jc)))) ) THEN
          READ(clblk(jc)(1:ipos-1),*) ik1
          ik2=300  ! use 300 as a maximum mean while we wait for npk
          PRINT *,' BINGO !', ik1, ik2
          DO jk=ik1,ik2
             nlev=nlev+1
             ilev(nlev)=jk
          ENDDO
       ELSE
          READ(clblk(jc)(1:ipos-1),*) ik1
          READ(clblk(jc)(ipos+1: ),*) ik2
          DO jk=ik1,ik2
             nlev=nlev+1
             ilev(nlev)=jk
          ENDDO
       ENDIF
    ENDDO
    ALLOCATE (nilev(nlev) )
    nilev(:)=ilev(1:nlev)

    DEALLOCATE( clblk)


  END SUBROUTINE ParseLevel

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    ! define new variables for output
    stypvar(1)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    IF (loverf)  THEN ; stypvar(1)%cname       = 'divoverf'
      ;                 stypvar(1)%cunits      = '-'
      ;                 stypvar(1)%clong_name  = 'Divergence normalized by f'
      ;                 stypvar(1)%cshort_name = 'divoverf'
    !-----------------------------------------------------------------------
    ELSE              ; stypvar(1)%cname       = 'div'
      ;                 stypvar(1)%cunits      = 's-1'
      ;                 stypvar(1)%clong_name  = 'Divergence '
      ;                 stypvar(1)%cshort_name = 'div'
    ENDIF

    IF ( ldblpr ) THEN ; stypvar(1)%cprecision = 'r8'
    ELSE               ; stypvar(1)%cprecision = 'r4'
    ENDIF

    stypvar(1)%rmissing_value    = 0.
    stypvar(1)%valid_min         = -1000.
    stypvar(1)%valid_max         =  1000.
    stypvar(1)%conline_operation = 'N/A'
    stypvar(1)%caxis             = 'TYX'

    ipk(1) = nlev  !  nlevel so far

    ! create output fileset
    ncout = create      (cf_out, cf_ufil, npiglo, npjglo, nlev, cdep=cn_vdepthu, ld_nc4=lnc4 )
    ierr  = createvar   (ncout ,   stypvar, 1 ,   ipk,    id_varout,             ld_nc4=lnc4 )
    ierr  = putheadervar(ncout,  'dummy', npiglo, npjglo, nlev, pnavlon=zun, pnavlat=zvn, pdep=gdep)

    dtim = getvar1d(cf_ufil, cn_vtimec, npt      )
    ierr = putvar1d(ncout,   dtim,      npt,  'T')

  END SUBROUTINE CreateOutput

END PROGRAM cdfdiv

PROGRAM cdfpolymask
  !!======================================================================
  !!                     ***  PROGRAM  cdfpolymask  ***
  !!=====================================================================
  !!  ** Purpose : Create a nc file with 1 into subareas defined as a 
  !!               polygone.
  !!
  !!  ** Method  : Use polylib routine (from finite element mesh generator
  !!               Trigrid)
  !!               Read vertices of polygone in an ascii file an produce a
  !!               resulting file the same shape as file givent in argumment
  !!               (used only for size and header )
  !!
  !! History : 2.1  : 07/2007  : J.M. Molines : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  !!   routines      : description
  !!   polymask 
  !!----------------------------------------------------------------------
  USE cdfio 
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: narg, iargc, ijarg     ! browse line
  INTEGER(KIND=4)                           :: npiglo, npjglo, npk    ! size of the domain
  INTEGER(KIND=4)                           :: ncout                  ! ncid of output file
  INTEGER(KIND=4)                           :: ierr                   ! error status
  INTEGER(KIND=4), DIMENSION(1)             :: ipk, id_varout         ! output var levels and varid 

  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: rpmask                 ! mask array
  REAL(KIND=4), DIMENSION(1)                :: tim                    ! dummy time counter

  CHARACTER(LEN=256)                        :: cf_ref                 ! name of reference file
  CHARACTER(LEN=256)                        :: cf_poly                ! name of ascii poly file
  CHARACTER(LEN=256)                        :: cf_out='polymask.nc'   ! output file name
  CHARACTER(LEN=256)                        :: cldum                  ! dummy arguments

  TYPE(variable), DIMENSION(1)              :: stypvar                ! output attribute

  LOGICAL                                   :: lreverse=.FALSE.       ! reverse flag
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg < 2 ) THEN
     PRINT *,' usage : cdfpolymask -p POLY-file -ref REF-file [ -r] [-o OUT_file]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Create a maskfile with polymask variable having 1'
     PRINT *,'       inside the polygon, and 0 outside. Option -r revert'
     PRINT *,'       the behaviour (0 inside, 1 outside).'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -p POLY-file : input ASCII file describing a polyline in I J grid.'
     PRINT *,'            This file is structured by block, one block corresponding '
     PRINT *,'            to a polygon:'
     PRINT *,'              1rst line of the block gives a polygon name'
     PRINT *,'              2nd line gives the number of vertices (nvert) and a dummy 0'
     PRINT *,'              the block finishes  with nvert pairs of (I,J) describing '
     PRINT *,'              the polygon vertices.'
     PRINT *,'       -ref REF-file  : reference netcdf file for header of polymask file.'
     PRINT *,'             This file will be used to look for domain dimensions, and '
     PRINT *,'             in order to build the output file (nav_lon, nav_lat etc ...)'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'        [ -r ] : revert option. When used, 0 is inside the polygon,'
     PRINT *,'                 1 outside.'
     PRINT *,'        [ -o OUT-file ] : spefify the name of the output mask file instead'
     PRINT *,'                 of ',TRIM(cf_out)
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       none' 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : polymask'
     STOP
  ENDIF

  ijarg = 1 

  DO WHILE ( ijarg <= narg ) 
     CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1
     SELECT CASE ( cldum ) 
     CASE ( '-p'   ) ; CALL getarg (ijarg, cf_poly ) ; ijarg = ijarg + 1
     CASE ( '-ref' ) ; CALL getarg (ijarg, cf_ref  ) ; ijarg = ijarg + 1
     CASE ( '-o'   ) ; CALL getarg (ijarg, cf_out  ) ; ijarg = ijarg + 1
     CASE ( '-r'   ) ; lreverse = .TRUE.
     CASE DEFAULT
        PRINT *,' unknown optional argument (', TRIM(cldum),' )'
        STOP 99
     END SELECT
  END DO

  IF ( chkfile(cf_poly) .OR. chkfile(cf_ref) ) STOP 99 ! missing files

  npiglo = getdim (cf_ref, cn_x)
  npjglo = getdim (cf_ref, cn_y)
  npk    = 1

  ipk(1)                       = 1
  stypvar(1)%cname             = 'polymask'
  stypvar(1)%cunits            = '1/0'
  stypvar(1)%rmissing_value    = 999.
  stypvar(1)%valid_min         = 0.
  stypvar(1)%valid_max         = 1.
  stypvar(1)%clong_name        = 'Polymask'
  stypvar(1)%cshort_name       = 'polymask'
  stypvar(1)%conline_operation = 'N/A'
  stypvar(1)%caxis             = 'TYX'

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo

  ALLOCATE( rpmask(npiglo,npjglo) )

  ncout = create      (cf_out, cf_ref,  npiglo, npjglo, npk       )
  ierr  = createvar   (ncout,  stypvar, 1,      ipk,    id_varout )
  ierr  = putheadervar(ncout,  cf_ref,  npiglo, npjglo, npk       )

  CALL polymask(cf_poly, rpmask) 

  ierr   = putvar(ncout, id_varout(1), rpmask, 1, npiglo, npjglo)
  tim(:) = 0.
  ierr   = putvar1d(ncout, tim, 1, 'T')

  ierr   = closeout(ncout)

CONTAINS


  SUBROUTINE polymask( cdpoly, pmask)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE polymask  ***
    !!
    !! ** Purpose : Build polymask from asci polygon file
    !!
    !! ** Method  : Use Poly routines and functions from modpoly module  
    !!
    !!----------------------------------------------------------------------
    USE modpoly

    CHARACTER(LEN=*),             INTENT(in ) :: cdpoly         ! polygon file name
    REAL(KIND=4), DIMENSION(:,:), INTENT(out) :: pmask          ! mask array

    INTEGER(KIND=4)                           :: ji, jj, jjpoly ! dummy loop index
    INTEGER(KIND=4)                           :: infront        ! number of
    REAL(KIND=4)                              :: zin, zout      ! 
    CHARACTER(LEN=256), DIMENSION(jpolys)     :: cl_area        ! name of the areas 
    LOGICAL                                   :: ll_in          ! flag for in/out poly
    !!----------------------------------------------------------------------
    IF ( lreverse ) THEN
       zin = 0. ; zout = 1.
    ELSE
       zin = 1. ; zout = 0.
    ENDIF

    pmask(:,:) = zout
    CALL ReadPoly(cdpoly, infront, cl_area)
    DO jjpoly=1, infront
       CALL PrepPoly(jjpoly)
       DO jj=npjglo, 1, -1
          DO ji=1,npiglo
             CALL InPoly(jjpoly,float(ji), float(jj), ll_in)
             IF (ll_in ) pmask(ji,jj) = zin
          ENDDO
       ENDDO
    ENDDO

  END SUBROUTINE polymask

END PROGRAM cdfpolymask

PROGRAM cdfmppini 
  !!======================================================================
  !!                     ***  PROGRAM  cdfmppini  ***
  !!=====================================================================
  !!  ** Purpose : off line domain decomposition using mesh_hgr
  !!
  !!  ** Method  : just an incapsulation of mpp_ini from NEMO
  !!
  !! History : 2.1  : 05/2010  : J.M. Molines : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  !!   routines      : description
  !!   mpp_init2     Nemo routine for mpp initialisation
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class preprocessing
  !!----------------------------------------------------------------------
  IMPLICIT NONE
  ! REM : some of the doctor rules are not followed because we want to use
  !       the mpp_init2 routine almost out of the box, thus we need to define
  !       variables which are parameters in NEMO, with the same name (jp..)

  INTEGER(KIND=4), PARAMETER                   :: wp=8   ! working precision
  INTEGER(KIND=4)                              :: jpni, jpnj, jpnij
  INTEGER(KIND=4)                              :: jpreci=1 , jprecj=1
  INTEGER(KIND=4)                              :: jpi, jpj, jpiglo, jpjglo
  INTEGER(KIND=4)                              :: jperio=6, jv
  INTEGER(KIND=4)                              :: narg, iargc, numout=6
  INTEGER(KIND=4)                              :: ijarg
  INTEGER(KIND=4), DIMENSION(:,:), ALLOCATABLE :: imask
  INTEGER(KIND=4), DIMENSION(:),   ALLOCATABLE :: nimppt, njmppt, nlcit, nlcjt
  INTEGER(KIND=4), DIMENSION(:),   ALLOCATABLE :: nldit, nldjt, nleit, nlejt
  INTEGER(KIND=4), DIMENSION(:),   ALLOCATABLE :: nbondi, nbondj, icount


  CHARACTER(LEN=80)                            :: cf_msk='m'
  CHARACTER(LEN=80)                            :: cf_out='mppini.txt'
  CHARACTER(LEN=80)                            :: cv_in
  CHARACTER(LEN=80)                            :: cldum

  LOGICAL                                      :: lwp=.TRUE.
  !----------------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfmppini -i jpni -j jpnj [-m/-b/-z] [-jperio jperio]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Performs the mpp initialisation with NEMO routine mpp_init2 and gives' 
     PRINT *,'       some statistics about the domains. Save the layout on a text file.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -i jpni : number of domains in the i direction.' 
     PRINT *,'       -j jpnj : number of domains in the j direction.' 
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-m/-b/-z] : use one of these option to choose the land/sea mask.'
     PRINT *,'               m  : take mask from ',TRIM(cn_fmsk),' (tmask) [ default ]'
     PRINT *,'               b  : take mask from ',TRIM(cn_fbathymet),' (Bathymetry)'
     PRINT *,'               z  : take mask from ',TRIM(cn_fzgr),' (mbathy)'
     PRINT *,'                   Default is ',TRIM(cf_msk)
     PRINT *,'       [-jperio jperio ] : specify jperio. '
     PRINT '(a,i2)','                          default value is ', jperio
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       one of ',TRIM(cn_fmsk),', ',TRIM(cn_fbathymet),' or ',TRIM(cn_fzgr),' according to option' 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       - Standard output'
     PRINT *,'       - ASCII file ', TRIM(cf_out)
     STOP 
  ENDIF

  cf_msk = cn_fmsk ; cv_in=cn_tmask
  ijarg=1 
  DO WHILE ( ijarg <= narg )
     CALL getarg( ijarg, cldum ) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-i'     ) ; CALL getarg( ijarg, cldum ) ; ijarg=ijarg+1 ; READ(cldum,*) jpni
     CASE ( '-j'     ) ; CALL getarg( ijarg, cldum ) ; ijarg=ijarg+1 ; READ(cldum,*) jpnj
        ! options
     CASE( '-m'      ) ; cf_msk = cn_fmsk       ; cv_in = cn_tmask
     CASE( '-b'      ) ; cf_msk = cn_fbathymet  ; cv_in = cn_bathymet
     CASE( '-z'      ) ; cf_msk = cn_fzgr       ; cv_in = cn_mbathy
     CASE( '-jperio' ) ; CALL getarg( ijarg, cldum ) ; ijarg=ijarg+1 ; READ(cldum,*) jperio
     CASE DEFAULT      ; PRINT *,' ERROR : ',TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  END DO

  IF ( chkfile (cf_msk ))  STOP 99 ! missing file

  jpiglo = getdim (cf_msk,cn_x)
  jpjglo = getdim (cf_msk,cn_y)

  jpi = ( jpiglo-2*jpreci + (jpni-1) ) / jpni + 2*jpreci 
  jpj = ( jpjglo-2*jprecj + (jpnj-1) ) / jpnj + 2*jprecj 

  ALLOCATE ( imask(jpiglo,jpjglo) )
  imask(:,:) = getvar(cf_msk, cv_in, 1, jpiglo, jpjglo)
  WHERE (imask <= 0 ) imask = 0
  WHERE (imask > 0  ) imask = 1
  CALL mpp_init2
  PRINT *, 'JPIGLO= ', jpiglo
  PRINT *, 'JPJGLO= ', jpjglo
  PRINT *, 'JPI   = ', jpi
  PRINT *, 'JPJ   = ', jpj
  PRINT *, 'JPNI  = ', jpni
  PRINT *, 'JPNJ  = ', jpnj
  PRINT *, 'JPNIJ = ', jpnij

  PRINT *, 'NBONDI between : ',MINVAL(nbondi),' AND ', MAXVAL(nbondi)
  PRINT *, 'NBONDJ between : ',MINVAL(nbondj),' AND ', MAXVAL(nbondj)
  PRINT *,' Accounting ...'
  ALLOCATE (icount(jpnij))
  DO jv=-1,2
     icount=0
     WHERE(nbondi == jv ) icount=1
     PRINT *,' NBONDI = ', jv,' : ', SUM(icount)
  ENDDO

  DO jv=-1,2
     icount=0
     WHERE(nbondj == jv ) icount=1
     PRINT *,' NBONDJ = ', jv,' : ', SUM(icount)
  ENDDO


CONTAINS

  SUBROUTINE mpp_init2
    !!----------------------------------------------------------------------
    !!                  ***  ROUTINE mpp_init2  ***
    !!
    !! * Purpose :   Lay out the global domain over processors.
    !!     FOR USING THIS VERSION, A PREPROCESSING TRAITMENT IS RECOMMENDED
    !!     FOR DEFINING BETTER CUTTING OUT.
    !!       This routine is used with a the bathymetry file.
    !!       In this version, the land processors are avoided and the adress
    !!     processor (nproc, narea,noea, ...) are calculated again.
    !!     The jpnij parameter can be lesser than jpni x jpnj
    !!     and this jpnij parameter must be calculated before with an
    !!     algoritmic preprocessing program.
    !!
    !! ** Method  :   Global domain is distributed in smaller local domains.
    !!      Periodic condition is a function of the local domain position
    !!      (global boundary or neighbouring domain) and of the global
    !!      periodic
    !!      Type :         jperio global periodic condition
    !!                     nperio local  periodic condition
    !!
    !! ** Action :        nimpp     : longitudinal index 
    !!                    njmpp     : latitudinal  index
    !!                    nperio    : lateral condition type 
    !!                    narea     : number for local area
    !!                    nlci      : first dimension
    !!                    nlcj      : second dimension
    !!                    nproc     : number for local processor
    !!                    noea      : number for local neighboring processor
    !!                    nowe      : number for local neighboring processor
    !!                    noso      : number for local neighboring processor
    !!                    nono      : number for local neighboring processor
    !!
    !! History :
    !!         :  4.0  : 03/2017  : J.M. Molines  
    !!        !  94-11  (M. Guyon)  Original code
    !!        !  95-04  (J. Escobar, M. Imbard)
    !!        !  98-02  (M. Guyon)  FETI method
    !!        !  98-05  (M. Imbard, J. Escobar, L. Colombet )  SHMEM and MPI versions
    !!   9.0  !  04-01  (G. Madec, J.M Molines)  F90 : free form , north fold jpni > 1
    !!----------------------------------------------------------------------
    !! 
    INTEGER(KIND=4) :: ji, jj, jn, jproc, jarea     ! dummy loop indices
    INTEGER(KIND=4) ::  inum = 99                   ! temporary logical unit
    INTEGER(KIND=4) ::   &
         ii, ij, ifreq, il1, il2,          &  ! temporary integers
         icont, ili, ilj,                  &  !    "          "
         isurf, ijm1, imil,                &  !    "          "
         iino, ijno, iiso, ijso,           &  !    "          " 
         iiea, ijea, iiwe, ijwe,           &  !    "          "
         iresti, irestj, iproc                !    "          "
    INTEGER(KIND=4) :: nreci, nrecj,  nperio
    INTEGER(KIND=4), DIMENSION(10000)          ::    iint, ijnt          
    INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE ::    iin, ijn          
    INTEGER(KIND=4), DIMENSION(jpni,jpnj) ::   &
         iimppt, ijmppt, ilci  , ilcj  ,   &  ! temporary workspace
         ipproc, ibondj, ibondi,           &  !    "           "
         ilei  , ilej  , ildi  , ildj  ,   &  !    "           "
         ioea  , iowe  , ioso  , iono         !    "           "
    REAL(wp) ::   zidom , zjdom          ! temporary scalars

    INTEGER(KIND=4) :: nono, noso, noea, nowe
    INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE :: ii_nono, ii_noso, ii_noea, ii_nowe

    ! 0. initialisation
    ! -----------------

    !  1. Dimension arrays for subdomains
    ! -----------------------------------

    !  Computation of local domain sizes ilci() ilcj()
    !  These dimensions depend on global sizes jpni,jpnj and jpiglo,jpjglo
    !  The subdomains are squares leeser than or equal to the global
    !  dimensions divided by the number of processors minus the overlap
    !  array.

    nreci=2*jpreci
    nrecj=2*jprecj
    iresti = 1 + MOD( jpiglo - nreci -1 , jpni )
    irestj = 1 + MOD( jpjglo - nrecj -1 , jpnj )

    ilci(1:iresti      ,:) = jpi
    ilci(iresti+1:jpni ,:) = jpi-1

    ilcj(:,      1:irestj) = jpj
    ilcj(:, irestj+1:jpnj) = jpj-1

    IF(lwp) WRITE(numout,*)
    IF(lwp) WRITE(numout,*) ' mpp_init2: defines mpp subdomains'
    IF(lwp) WRITE(numout,*) ' ~~~~~~  ----------------------'
    IF(lwp) WRITE(numout,*)
    IF(lwp) WRITE(numout,*) 'iresti=',iresti,' irestj=',irestj
    IF(lwp) WRITE(numout,*)
    IF(lwp) WRITE(numout,*) 'jpni=',jpni,' jpnj=',jpnj

    zidom = nreci + SUM(ilci(:,1) - nreci ) 
    IF(lwp) WRITE(numout,*)
    IF(lwp) WRITE(numout,*)' sum ilci(i,1)=',zidom,' jpiglo=',jpiglo

    zjdom = nrecj + SUM(ilcj(1,:) - nrecj ) 
    IF(lwp) WRITE(numout,*) ' sum ilcj(1,j)=',zjdom,' jpjglo=',jpjglo
    IF(lwp) WRITE(numout,*)


    !  2. Index arrays for subdomains
    ! -------------------------------

    iimppt(:,:) = 1
    ijmppt(:,:) = 1
    ipproc(:,:) = -1

    IF( jpni > 1 )THEN
       DO jj = 1, jpnj
          DO ji = 2, jpni
             iimppt(ji,jj) = iimppt(ji-1,jj) + ilci(ji-1,jj) - nreci
          END DO
       END DO
    ENDIF

    IF( jpnj > 1 )THEN
       DO jj = 2, jpnj
          DO ji = 1, jpni
             ijmppt(ji,jj) = ijmppt(ji,jj-1) + ilcj(ji,jj-1) - nrecj
          END DO
       END DO
    ENDIF


    ! 3. Subdomain description in the Regular Case
    ! --------------------------------------------

    nperio = 0
    icont = -1
    DO jarea = 1, jpni*jpnj
       ii = 1 + MOD(jarea-1,jpni)
       ij = 1 +    (jarea-1)/jpni
       ili = ilci(ii,ij)
       ilj = ilcj(ii,ij)

       ibondj(ii,ij) = -1
       IF( jarea >  jpni          )   ibondj(ii,ij) = 0
       IF( jarea >  (jpnj-1)*jpni )   ibondj(ii,ij) = 1
       IF( jpnj  == 1             )   ibondj(ii,ij) = 2

       ibondi(ii,ij) = 0
       IF( MOD(jarea,jpni) == 1 )   ibondi(ii,ij) = -1
       IF( MOD(jarea,jpni) == 0 )   ibondi(ii,ij) =  1
       IF( jpni            == 1 )   ibondi(ii,ij) =  2

       ! 2.4 Subdomain neighbors

       iproc = jarea - 1
       ioso(ii,ij) = iproc - jpni
       iowe(ii,ij) = iproc - 1
       ioea(ii,ij) = iproc + 1
       iono(ii,ij) = iproc + jpni

       ildi(ii,ij) = 1 + jpreci
       ilei(ii,ij) = ili -jpreci

       IF( ibondi(ii,ij) == -1 .OR. ibondi(ii,ij) == 2 ) ildi(ii,ij) = 1
       IF( ibondi(ii,ij) ==  1 .OR. ibondi(ii,ij) == 2 ) ilei(ii,ij) = ili

       ildj(ii,ij) =  1  + jprecj
       ilej(ii,ij) = ilj - jprecj
       IF( ibondj(ii,ij) == -1 .OR. ibondj(ii,ij) == 2 ) ildj(ii,ij) = 1
       IF( ibondj(ii,ij) ==  1 .OR. ibondj(ii,ij) == 2 ) ilej(ii,ij) = ilj

       ! warning ii*ij (zone) /= nproc (processors)!

       IF( jperio == 1 .OR. jperio == 4 .OR. jperio == 6 ) THEN
          IF( jpni == 1 )THEN
             ibondi(ii,ij) = 2
             nperio = 1
          ELSE
             ibondi(ii,ij) = 0
          ENDIF
          IF( MOD(jarea,jpni) == 0 ) THEN
             ioea(ii,ij) = iproc - (jpni-1)
          ENDIF
          IF( MOD(jarea,jpni) == 1 ) THEN
             iowe(ii,ij) = iproc + jpni - 1
          ENDIF
       ENDIF

       isurf = 0
       DO jj = 1+jprecj, ilj-jprecj
          DO  ji = 1+jpreci, ili-jpreci
             IF( imask(ji+iimppt(ii,ij)-1, jj+ijmppt(ii,ij)-1) == 1) isurf = isurf+1
          END DO
       END DO
       IF(isurf /= 0) THEN
          icont = icont + 1
          ipproc(ii,ij) = icont
          iint(icont+1) = ii
          ijnt(icont+1) = ij
       ENDIF
    END DO
    jpnij=icont+1
    ALLOCATE(iin(jpnij),ijn(jpnij),nimppt(jpnij), njmppt(jpnij), nlcit(jpnij), nlcjt(jpnij)  )
    ALLOCATE(nldit(jpnij), nldjt(jpnij)  )
    ALLOCATE(nleit(jpnij), nlejt(jpnij)  )
    ALLOCATE(nbondi(jpnij), nbondj(jpnij)  )
    ALLOCATE(ii_nono(jpnij), ii_noso(jpnij), ii_noea(jpnij) , ii_nowe(jpnij) )

    iin(:)=iint(1:jpnij)
    ijn(:)=ijnt(1:jpnij)

    ! Control
    ! 4. Subdomain print
    ! ------------------

    IF(lwp) THEN
       ifreq = 4
       il1 = 1
       DO jn = 1,(jpni-1)/ifreq+1
          il2 = MIN(jpni,il1+ifreq-1)
          WRITE(numout,*)
          WRITE(numout,9400) ('***',ji=il1,il2-1)
          DO jj = jpnj, 1, -1
             WRITE(numout,9403) ('   ',ji=il1,il2-1)
             WRITE(numout,9402) jj, (ilci(ji,jj),ilcj(ji,jj),ji=il1,il2)
             WRITE(numout,9404) (ipproc(ji,jj),ji=il1,il2)
             WRITE(numout,9403) ('   ',ji=il1,il2-1)
             WRITE(numout,9400) ('***',ji=il1,il2-1)
          END DO
          WRITE(numout,9401) (ji,ji=il1,il2)
          il1 = il1+ifreq
       END DO
9400   FORMAT('     ***',20('*************',a3))
9403   FORMAT('     *     ',20('         *   ',a3))
9401   FORMAT('        ',20('   ',i3,'          '))
9402   FORMAT(' ',i3,' *  ',20(i3,'  x',i3,'   *   '))
9404   FORMAT('     *  ',20('     ',i4,'   *   '))
    ENDIF


    ! 5. neighbour treatment
    ! ----------------------

    DO jarea = 1, jpni*jpnj
       iproc = jarea-1
       ii = 1 + MOD(jarea-1,jpni)
       ij = 1 +    (jarea-1)/jpni
       IF( ipproc(ii,ij) == -1 .AND. iono(ii,ij) >= 0   &
            .AND. iono(ii,ij) <= jpni*jpnj-1 ) THEN
          iino = 1 + MOD(iono(ii,ij),jpni)
          ijno = 1 +    (iono(ii,ij))/jpni
          IF( ibondj(iino,ijno) == 1 ) ibondj(iino,ijno)=2
          IF( ibondj(iino,ijno) == 0 ) ibondj(iino,ijno) = -1
       ENDIF
       IF( ipproc(ii,ij) == -1 .AND. ioso(ii,ij) >= 0   &
            .AND. ioso(ii,ij) <= jpni*jpnj-1 ) THEN
          iiso = 1 + MOD(ioso(ii,ij),jpni)
          ijso = 1 +    (ioso(ii,ij))/jpni
          IF( ibondj(iiso,ijso) == -1 ) ibondj(iiso,ijso) = 2
          IF( ibondj(iiso,ijso) ==  0 ) ibondj(iiso,ijso) = 1
       ENDIF
       IF( ipproc(ii,ij) == -1 .AND. ioea(ii,ij) >= 0   &
            .AND. ioea(ii,ij) <= jpni*jpnj-1) THEN
          iiea = 1 + MOD(ioea(ii,ij),jpni)
          ijea = 1 +    (ioea(ii,ij))/jpni
          IF( ibondi(iiea,ijea) == 1 ) ibondi(iiea,ijea) = 2
          IF( ibondi(iiea,ijea) == 0 ) ibondi(iiea,ijea) = -1
       ENDIF
       IF( ipproc(ii,ij) == -1 .AND. iowe(ii,ij) >= 0   &
            .AND. iowe(ii,ij) <= jpni*jpnj-1) THEN
          iiwe = 1 + MOD(iowe(ii,ij),jpni)
          ijwe = 1 +    (iowe(ii,ij))/jpni
          IF( ibondi(iiwe,ijwe) == -1 ) ibondi(iiwe,ijwe) = 2
          IF( ibondi(iiwe,ijwe) ==  0 ) ibondi(iiwe,ijwe) = 1
       ENDIF
    END DO


    ! just to save nono etc for all proc
    DO jarea = 1, jpnij
       ii = iin(jarea)
       ij = ijn(jarea)
       IF( ioso(ii,ij) >= 0 .AND. ioso(ii,ij) <= (jpni*jpnj-1) ) THEN
          iiso = 1 + MOD(ioso(ii,ij),jpni)
          ijso = 1 +    (ioso(ii,ij))/jpni
          noso = ipproc(iiso,ijso)
          ii_noso(jarea)= noso
       ENDIF
       IF( iowe(ii,ij) >= 0 .AND. iowe(ii,ij) <= (jpni*jpnj-1) ) THEN
          iiwe = 1 + MOD(iowe(ii,ij),jpni)
          ijwe = 1 +    (iowe(ii,ij))/jpni
          nowe = ipproc(iiwe,ijwe)
          ii_nowe(jarea)= nowe
       ENDIF
       IF( ioea(ii,ij) >= 0 .AND. ioea(ii,ij) <= (jpni*jpnj-1) ) THEN
          iiea = 1 + MOD(ioea(ii,ij),jpni)
          ijea = 1 +    (ioea(ii,ij))/jpni
          noea = ipproc(iiea,ijea)
          ii_noea(jarea)= noea
       ENDIF
       IF( iono(ii,ij) >= 0 .AND. iono(ii,ij) <= (jpni*jpnj-1) ) THEN
          iino = 1 + MOD(iono(ii,ij),jpni)
          ijno = 1 +    (iono(ii,ij))/jpni
          nono = ipproc(iino,ijno)
          ii_nono(jarea)= nono
       ENDIF
    END DO
    ! 6. Change processor name
    ! ------------------------

    DO jproc = 1, jpnij
       ii = iin(jproc)
       ij = ijn(jproc)

       nimppt(jproc) = iimppt(ii,ij)  
       njmppt(jproc) = ijmppt(ii,ij)  

       nlcit(jproc) = ilci(ii,ij)
       nlcjt(jproc) = ilcj(ii,ij)

       nldit(jproc) = ildi(ii,ij)
       nldjt(jproc) = ildj(ii,ij)

       nleit(jproc) = ilei(ii,ij)
       nlejt(jproc) = ilej(ii,ij)
    END DO

    ! Save processor layout in ascii file
    IF (lwp) THEN
       OPEN (inum, FILE=cf_out, FORM='FORMATTED', RECL=255)
       WRITE(inum,'(6i8)') jpnij,jpi,jpj,jpiglo,jpjglo
       WRITE(inum,'(a)') 'NAREA   nlci nlcj nldi nldj nlei nlej nimpp njmpp nono noso nowe noea nbondi nbondj '

       DO  jproc = 1, jpnij
          ii = iin(jproc)
          ij = ijn(jproc)
          nbondi(jproc) = ibondi(ii,ij)
          nbondj(jproc) = ibondj(ii,ij)


          WRITE(inum,'(15i5)') jproc  , nlcit(jproc), nlcjt(jproc), &
               nldit(jproc), nldjt(jproc), &
               nleit(jproc), nlejt(jproc), &
               nimppt(jproc), njmppt(jproc),& 
               ii_nono(jproc), ii_noso(jproc), ii_nowe(jproc), ii_noea(jproc) ,&
               nbondi(jproc),  nbondj(jproc) 
       END DO
       CLOSE(inum)   
    END IF


  END SUBROUTINE mpp_init2

END PROGRAM cdfmppini

PROGRAM cdffwc
  !!======================================================================
  !!                      ***  PROGRAM  cdffwc   ***
  !!=====================================================================
  !!  ** Purpose : Compute the freshwater content in a given basin from top
  !!               to bottom for each layer. Can handle full step configuration
  !!               using the -full option.'
  !!
  !!  ** Method  : compute fwc = sum(e1*e2*e3) - sum(S*e1*e2*e3)/Sref * btmask
  !!                 with reference salinity Sref (=34.7) and 
  !!                 the sub-basin mask btmask
  !!
  !!               based on cdfvertmean routine
  !!
  !! History : 0.1  : 09/2016  : M. Scheinert : First adaption
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  USE modutils
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class integration
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                            :: jk, jvar, jvarin, jt ! dummy loop index
  INTEGER(KIND=4)                            :: it                   ! time index for vvl
  INTEGER(KIND=4)                            :: ierr, iko            ! working integer
  INTEGER(KIND=4)                            :: narg, iargc, ijarg   ! command line 
  INTEGER(KIND=4)                            :: npiglo, npjglo       ! size of the domain
  INTEGER(KIND=4)                            :: npk, npt             ! size of the domain
  INTEGER(KIND=4)                            :: nvars, ivar          ! variables in input
  INTEGER(KIND=4)                            :: nvaro=1              ! variables for output
  INTEGER(KIND=4)                            :: ncout 
  INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE :: ipk, id_varout       ! levels and varid's of output vars

  REAL(KIND=4), PARAMETER                    :: ppspval= 9999.99     ! missing value
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE  :: e31d                 ! vertical metrics in case of full step
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE  :: e3t, area, ssh       ! vertical metric
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE  :: zt                   ! working input variable
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE  :: tmask                ! npiglo x npjglo
  REAL(KIND=4), DIMENSION(:,:,:), ALLOCATABLE:: zmask                ! npiglo x npjglo

  REAL(KIND=8)                               :: ds0=34.7d0           ! reference salinity
  REAL(KIND=8), DIMENSION(:),   ALLOCATABLE  :: dtim                 ! time counter
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE  :: dl_vint1, dl_vol2d   ! verticall int quantity         
  REAL(KIND=8), DIMENSION(:,:,:), ALLOCATABLE:: dfwc                 ! fwc. as 2dim to be consistent with putvar()

  CHARACTER(LEN=256)                         :: cf_sfil              ! input salinity file 
  CHARACTER(LEN=255)                         :: cf_sshfil            ! input SSH file (option)
  CHARACTER(LEN=256)                         :: cf_out='fwc.nc'      ! output file 
  CHARACTER(LEN=256)                         :: cldum                ! dummy string for command line browsing
  CHARACTER(LEN=256)                         :: cdefault             ! dummy string for default salinity value
  CHARACTER(LEN=256)                         :: cf_subbas='subbasins.nc'     ! subbasins file
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_names           ! name of input variables
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_in              ! name of output variables

  LOGICAL                                    :: lfull  =.FALSE.      ! flag for full step computation
  LOGICAL                                    :: lchk   =.FALSE.      ! flag for missing files
  LOGICAL                                    :: laccum =.FALSE.      ! flag for accumulated fwc
  LOGICAL                                    :: lssh   =.FALSE.      ! flag for using ssh for top layer thickness

  TYPE(variable), DIMENSION(:), ALLOCATABLE  :: stypvarin            ! stucture for attributes (input)
  TYPE(variable), DIMENSION(:), ALLOCATABLE  :: stypvar              ! extension for attributes
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()
  WRITE(cdefault,'(f5.1)') ds0

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdffwc -s S-file -bv BASIN-var1,var2,.. [-o OUT-file] [-sref REFSAL]'
     PRINT *,'                 [--ssh-file SSH-file] [-full] [-accum] [-ssh] [-vvl]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the freshwater content in a given basin from top to bottom'
     PRINT *,'       for each layer, using a reference salinity (',TRIM(cdefault),') that'
     PRINT *,'       can be changed with -sref option.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'        -s S-file   : netcdf input file holding salinity (in general a gridT).' 
     PRINT *,'        -bv BASIN-var1,var2,.. : Comma separated list of sub-basin variables'
     PRINT *,'                to process. E.g.: -bv tmaskatl,tmaskind '
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'        --ssh-file SSH-file : specify the ssh file if not in S-file.'
     PRINT *,'        -full  : for full step computation ' 
     PRINT *,'        -accum : compute accumulated content from top to bottom' 
     PRINT *,'        -ssh   : take ssh into account for surface layer' 
     PRINT *,'            If ssh is not in S-file, use --ssh-file option to specify the file'
     PRINT *,'            with ssh.'
     PRINT *,'        -sref REFSAL : reference salinity (',TRIM(cdefault),' by default)'
     PRINT *,'        -vvl   : use time-varying vertical metrics'
     PRINT *,'        -o OUT-file :  use specified output file instead of ', TRIM(cf_out)
     PRINT *,'        -b SUBAS-file :  use specified subbasin file instead of ', TRIM(cf_subbas)
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ', TRIM(cn_fzgr),', ',TRIM(cn_fhgr),' and ',TRIM(cf_subbas) ,' and ',TRIM(cn_fmsk)
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file :  fwc.nc (or specified with -o option)'
     PRINT *,'         variables :  fwc_BASIN, where BASIN was set by argument BASIN-var*'
     PRINT *,'                      (cAsE sensitive !)'
     PRINT *,'      '
     STOP 
  ENDIF

  ! browse command line
  ijarg = 1   
  cf_sshfil = 'none'
  DO WHILE ( ijarg <= narg ) 
     CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1
     SELECT CASE ( cldum)
     CASE ( '-s'       ) ; CALL getarg (ijarg, cf_sfil  ) ; ijarg = ijarg + 1
     CASE ( '-bv'      ) ; CALL getarg (ijarg, cldum    ) ; ijarg = ijarg + 1 ; CALL ParseVars(cldum)
        ! options
     CASE ('--ssh-file') ; CALL getarg(ijarg, cf_sshfil); ijarg=ijarg+1
     CASE ( '-full'    ) ; lfull  = .TRUE. 
     CASE ( '-o'       ) ; CALL getarg (ijarg, cf_out   ) ; ijarg = ijarg + 1
     CASE ( '-sref'    ) ; CALL getarg (ijarg, cldum    ) ; ijarg = ijarg + 1 ; READ(cldum,*) ds0
     CASE ( '-accum'   ) ; laccum = .TRUE. 
     CASE ( '-ssh'     ) ; lssh   = .TRUE. 
     CASE ( '-vvl'     ) ; lg_vvl = .TRUE. 
     CASE ( '-b'       ) ; CALL getarg (ijarg, cf_subbas) ; ijarg = ijarg + 1
     CASE DEFAULT        ; PRINT *,' ERROR : ',TRIM(cldum),' : unknown options.' ; STOP 99
     END SELECT
  END DO

  IF ( cf_sshfil == 'none') cf_sshfil = cf_sfil

  ! Security check
  lchk = chkfile ( cf_sfil   )
  lchk = chkfile ( cf_sshfil ) .OR. lchk
  lchk = chkfile ( cn_fmsk   ) .OR. lchk
  lchk = chkfile ( cn_fhgr   ) .OR. lchk
  lchk = chkfile ( cn_fzgr   ) .OR. lchk
  lchk = chkfile ( cf_subbas ) .OR. lchk
  IF ( lchk ) STOP 99 ! missing files

  IF ( lg_vvl ) THEN
    cn_fe3t = cf_sfil
    cn_ve3t = cn_ve3tvvl
  ENDIF

  ! log information so far
  PRINT *,' OUTPUT FILE     : ' , TRIM(cf_out)

  npiglo = getdim (cf_sfil, cn_x )
  npjglo = getdim (cf_sfil, cn_y )
  npk    = getdim (cf_sfil, cn_z )
  npt    = getdim (cf_sfil, cn_t )

  PRINT *, ' NPIGLO = ', npiglo
  PRINT *, ' NPJGLO = ', npjglo
  PRINT *, ' NPK    = ', npk
  PRINT *, ' NPT    = ', npt

  nvars       = getnvar(cf_subbas)

  ALLOCATE(  cv_names( nvars       ) )
  ALLOCATE( stypvarin( nvars       ) )
  ALLOCATE(   stypvar( nvaro       ) )
  ALLOCATE(       ipk( nvaro       ) )
  ALLOCATE( id_varout( nvaro       ) )
  ALLOCATE(      dfwc( nvaro, 1, 1 ) )

  cv_names(:) = getvarname(cf_subbas, nvars, stypvarin)

  ! just chck if var exist in file 
  DO jvar = 1, nvaro
     IF ( chkvar( cf_subbas, cv_in(jvar)) ) STOP 99  ! message is written in cdfio.chkvar
  ENDDO

  ! Allocate arrays
  ALLOCATE (      dtim( npt                   ) )
  ALLOCATE (    zmask( nvaro,   npiglo,npjglo ) )
  ALLOCATE (    tmask(          npiglo,npjglo ) )
  ALLOCATE (       zt(          npiglo,npjglo ) )
  ALLOCATE (      e3t(          npiglo,npjglo ) )
  ALLOCATE (     area(          npiglo,npjglo ) )
  ALLOCATE ( dl_vint1(          npiglo,npjglo ) )
  ALLOCATE ( dl_vol2d(          npiglo,npjglo ) )
  IF ( lssh  ) ALLOCATE ( ssh(  npiglo,npjglo ) )
  IF ( lfull ) ALLOCATE ( e31d( npk ) )

  ! Read area field
  area(:,:)   = getvar(cn_fhgr  , cn_ve1t,  1, npiglo, npjglo)  ! Save memory: e1t is first read into area
  zt(  :,:)   = getvar(cn_fhgr  , cn_ve2t,  1, npiglo, npjglo)  ! ..and zv is used to read e2t
  area(:,:)   = area(:,:) * zt(:,:)                             ! ..

  ! Read vertical axis in full-step-case
  IF ( lfull ) e31d(:) = getvare3(cn_fzgr, cn_ve3t1d, npk)

  ! Read sub-basin masks (2D) and keep them for all layers
  DO jvar = 1,nvaro          ! Loop through sub-basins
     zmask(jvar,:,:) = getvar(cf_subbas, cv_in(jvar) ,  1, npiglo, npjglo )
  END DO

  CALL CreateOutput

  PRINT *, 'Output files initialised ...'

  DO jt=1,npt
     IF ( lg_vvl ) THEN ; it=jt
     ELSE               ; it=1
     ENDIF

     dl_vol2d(  :,:) = 0.d0 ; dl_vint1(  :,:) = 0.d0 ; dfwc(:,:,:) = 0.d0
     IF ( lssh ) ssh(:,:) = 0.e0

     DO jk = 1, npk
        ! Get values at jk
        zt(   :,:) = getvar(cf_sfil, cn_vosaline, jk, npiglo, npjglo, ktime=jt)     ! Read Salinity(2D) at level jk and time step jt
        tmask(:,:) = getvar(cn_fmsk, cn_tmask,    jk, npiglo, npjglo          )

        ! get e3t at level jk ( ps...)
        IF ( lfull ) THEN ; e3t(:,:) = e31d(jk)
        ELSE              ; e3t(:,:) = getvar(cn_fe3t, cn_ve3t, jk, npiglo, npjglo, ktime=it,  ldiom=.NOT.lg_vvl)
        ENDIF

        IF ( jk == 1 .AND. lssh ) THEN
           ssh(:,:) = getvar(cf_sshfil,     cn_sossheig, 1, npiglo, npjglo, ktime=jt)
           e3t(:,:) = e3t(:,:) + ssh(:,:)
        ENDIF

        DO jvar = 1,nvaro          ! Loop through sub-basins
           dl_vol2d   = area * e3t * tmask * zmask(jvar,:,:) * 1.d0
           dl_vint1   = ( ds0 - zt ) / ds0 * dl_vol2d
           IF ( laccum ) THEN ; dfwc(jvar,1,1)   = SUM( dl_vint1 ) + dfwc(jvar,1,1)
           ELSE               ; dfwc(jvar,1,1)   = SUM( dl_vint1 )
           ENDIF
           ! Output to netcdf file 
           ierr = putvar(ncout, id_varout(jvar), REAL(dfwc(jvar,:,:)), jk, 1, 1, ktime=jt)
        END DO   ! jvar
     END DO
  END DO  ! loop on time

  ierr = closeout(ncout)

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------

    ! prepare output variable
    ipk(:)                       = npk
    WRITE(cldum, *) ds0

    DO jvar=1, nvaro     !Go through sub-basins
       DO jvarin=1,nvars
          IF ( cv_in(jvar) == stypvarin(jvarin)%cname ) EXIT  ! cv_in match cv_varin.
       END DO
       stypvar(jvar)%cname             = 'fwc_'//TRIM(cv_in(jvar))
       stypvar(jvar)%cunits            = 'm3'
       stypvar(jvar)%rmissing_value    = ppspval
       stypvar(jvar)%valid_min         = 0.0
       stypvar(jvar)%valid_max         = 0.0
       IF ( laccum ) THEN 
          stypvar(jvar)%clong_name     = 'freshwater content accumulated from top to bottom for '//TRIM(cv_in(jvar))//' based on S0='//TRIM(cldum)
       ELSE
          stypvar(jvar)%clong_name       = 'freshwater content per layer for '//TRIM(cv_in(jvar))//' based on S0='//TRIM(cldum)
       ENDIF
       stypvar(jvar)%clong_name        = 'freshwater content for '//TRIM(cv_in(jvar))//' based on S0='//TRIM(cldum)
       stypvar(jvar)%cshort_name       = 'fwc_'//TRIM(cv_in(jvar))
       stypvar(jvar)%conline_operation = 'N/A'
       stypvar(jvar)%caxis             = 'T'
    END DO

    ! Initialize output file
    ncout = create      (cf_out, 'none', 1, 1, npk, cdep=cn_vdepthw, ld_xycoo=.FALSE. )
    ierr  = createvar   (ncout, stypvar, nvaro, ipk, id_varout                        )
    ierr  = putheadervar(ncout, cf_sfil, 1, 1, npk,                  ld_xycoo=.FALSE. )

    dtim  = getvar1d    (cf_sfil, cn_vtimec, npt     )
    ierr  = putvar1d    (ncout  , dtim,      npt, 'T')

  END SUBROUTINE CreateOutput

  SUBROUTINE ParseVars (cdum)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE ParseVars  ***
    !!
    !! ** Purpose :  Decode variable name  option from command line
    !!
    !! ** Method  :  look for , in the argument string and set the number of
    !!         variable (nvaro), allocate cv_in array and fill it with the
    !!         decoded  names.
    !!
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*), INTENT(in) :: cdum

    CHARACTER(LEN=80), DIMENSION(100) :: cl_dum  ! 100 is arbitrary
    INTEGER  :: ji
    INTEGER  :: inchar,  i1=1
    !!----------------------------------------------------------------------
    inchar= LEN(TRIM(cdum))
    ! scan the input string and look for ',' as separator
    DO ji=1,inchar
       IF ( cdum(ji:ji) == ',' ) THEN
          cl_dum(nvaro) = cdum(i1:ji-1)
          i1=ji+1
          nvaro=nvaro+1
       ENDIF
    ENDDO

    ! last name of the list does not have a ','
    cl_dum(nvaro) = cdum(i1:inchar)

    ALLOCATE ( cv_in(nvaro) )
    DO ji=1, nvaro
       cv_in(ji) = cl_dum(ji)
    ENDDO
  END SUBROUTINE ParseVars

END PROGRAM cdffwc

PROGRAM cdfspeed
  !!======================================================================
  !!                     ***  PROGRAM  cdfspeed  ***
  !!=====================================================================
  !!  ** Purpose : combine u and v to obtains the wind speed
  !!
  !!  ** Method  : speed=sqrt(u**2 + v**2)
  !!
  !! History : 2.1  : 11/2007  : P. Mathiot   : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class derived_fields
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                            :: ji, jj, jk, jt, jlev ! dummy loop index
  INTEGER(KIND=4)                            :: narg, iargc, ijarg   ! command line 
  INTEGER(KIND=4)                            :: ncout, ierr          ! output file stuff
  INTEGER(KIND=4)                            :: npiglo, npjglo       ! size of the domain
  INTEGER(KIND=4)                            :: npk, npt, nlev       ! size of the domain
  INTEGER(KIND=4)                            :: nvpk                 ! vertical levels in working variable
  INTEGER(KIND=4)                            :: ik                   ! level counter
  INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE :: nklevel              ! requested levels
  INTEGER(KIND=4), DIMENSION(1)              :: ipk, id_varout       ! output variable vertical level, varid

  REAL(KIND=4), DIMENSION(:),    ALLOCATABLE :: gdept, gdeptall      ! deptht values for requested/all levels
  REAL(KIND=4), DIMENSION(:,:),  ALLOCATABLE :: zu, zv, zspeed       ! working arrays, speed

  REAL(KIND=8), DIMENSION(:),    ALLOCATABLE :: dtim                 ! time counter array

  CHARACTER(LEN=256)                         :: cf_vfil, cf_ufil     ! file for u and v components
  CHARACTER(LEN=256)                         :: cf_tfil='none'       ! file for T point position
  CHARACTER(LEN=256)                         :: cv_u, cv_v           ! name of u and v variable
  CHARACTER(LEN=256)                         :: cf_out='speed.nc'    ! output file name
  CHARACTER(LEN=256)                         :: cldum                ! dummy char variable

  TYPE (variable), DIMENSION(1)              :: stypvar              ! structure for attibutes

  LOGICAL                                    :: lforcing             ! forcing flag
  LOGICAL                                    :: lchk   = .FALSE.     ! flag for missing files
  LOGICAL                                    :: lnc4   = .FALSE.     ! flag for netcdf4 chunking and deflation
  LOGICAL                                    :: lcgrid = .FALSE.     ! flag for C-grid 2D data
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfspeed  -u U-file U-var -v V-file V-var [-t T-file] ...'
     PRINT *,'            ... [-o OUT-file] [-nc4] [-lev LST-level] [-C]' 
     PRINT *,'       '
     PRINT *,'    PURPOSE :'
     PRINT *,'       Compute the speed of ocean currents or wind speed.'
     PRINT *,'       '
     PRINT *,'       If the input files are 3D, the input is assumed to be a model'
     PRINT *,'       output on native C-grid. Speed is computed on the A-grid.'
     PRINT *,'       '
     PRINT *,'       If the input file is 2D then we assume that this is a forcing'
     PRINT *,'       file already on the A-grid, unless -C option is used.'
     PRINT *,'    '
     PRINT *,'    ARGUMENTS :'
     PRINT *,'       -u U-file U-var : netcdf file for U component and variable name.'
     PRINT *,'       -v V-file V-var : netcdf file for V componentt and variable name.'
     PRINT *,'    '
     PRINT *,'    OPTIONS :'
     PRINT *,'       [-t T-file] : indicate any file on gridT for correct header of the'
     PRINT *,'             output file (needed for 3D files or if -C option is used).'
     PRINT *,'       [-lev LST-level] : indicate a list of levels to be processed.'
     PRINT *,'             If not used, all levels are processed.'
     PRINT *,'       [-C] : indicates that data are on a C-grid even if input files are 2D.'
     PRINT *,'       [-o OUT-file] : use specified output file instead of ',TRIM(cf_out)
     PRINT *,'       [-nc4] : use netcdf4 output with chunking and deflation.'
     PRINT *,'    '
     PRINT *,'    OUTPUT :'
     PRINT *,'       Output on ',TRIM(cf_out),' unless -o option is used.'
     PRINT *,'         netcdf variable : U '
     PRINT *,'    '
     PRINT *,'    SEE ALSO :'
     PRINT *,'       cdfvita also computes the speed.'
     PRINT *,'    '
     STOP 
  ENDIF

  nlev =0
  ijarg=1
  DO WHILE ( ijarg <= narg ) 
     CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-u'   ) ; CALL getarg(ijarg, cf_ufil ) ; ijarg=ijarg+1
        ;              CALL getarg(ijarg, cv_u    ) ; ijarg=ijarg+1
     CASE ( '-v'   ) ; CALL getarg(ijarg, cf_vfil ) ; ijarg=ijarg+1
        ;              CALL getarg(ijarg, cv_v    ) ; ijarg=ijarg+1
        ! options
     CASE ( '-lev' ) ; CALL GetLevList
     CASE ( '-t'   ) ; CALL getarg(ijarg, cf_tfil ) ; ijarg=ijarg+1
     CASE ( '-o'   ) ; CALL getarg(ijarg, cf_out  ) ; ijarg=ijarg+1
     CASE ( '-nc4' ) ; lnc4   = .TRUE.
     CASE ( '-C'   ) ; lcgrid = .TRUE.
     CASE DEFAULT    ; PRINT *,' ERROR : ',TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  ENDDO

  IF ( cf_tfil /= 'none' ) lchk = lchk .OR. chkfile (cf_tfil)
  lchk = lchk .OR. chkfile (cf_ufil)
  lchk = lchk .OR. chkfile (cf_vfil)
  IF ( lchk ) STOP 99 ! missing file

  npiglo = getdim (cf_vfil,cn_x)
  npjglo = getdim (cf_vfil,cn_y)
  npk    = getdim (cf_vfil,cn_z)
  nvpk   = getvdim(cf_vfil,cv_v)
  npt    = getdim (cf_vfil,cn_t)

  IF ( (npk == 0) ) THEN
     IF ( lcgrid ) THEN ; lforcing = .FALSE.
     ELSE               ; lforcing = .TRUE.
     ENDIF
     npk=1
     PRINT *, 'W A R N I N G : you used a forcing field'
  ELSE
     lforcing=.FALSE.
     IF ( TRIM(cf_tfil) == 'none' ) THEN
        PRINT *,'  ERROR: you must specify a griT file as fifth argument '
        PRINT *,'     This is for the proper header of output file '
        STOP 99
     ENDIF
  END IF

  IF ( nlev == 0 ) THEN 
     nlev = npk 
     ALLOCATE ( nklevel(nlev) )
     DO jlev =1, nlev
        nklevel(jlev) = jlev
     ENDDO
  ENDIF

  IF (nvpk == 2 ) nvpk = 1
  IF (nvpk == 3 ) nvpk = nlev

  PRINT *, 'npiglo =', npiglo
  PRINT *, 'npjglo =', npjglo
  PRINT *, 'npk    =', npk
  PRINT *, 'nvpk   =', nvpk
  PRINT *, 'nlev   =', nlev
  PRINT *, 'npt    =', npt

  IF ( nlev >  nvpk ) THEN
     PRINT *, 'W A R N I N G : nlev larger than nvpk, we assume nlev=nvpk'
     nlev = nvpk
  END IF

  ! Allocate arrays
  ALLOCATE ( zv(npiglo,npjglo), zu(npiglo,npjglo), zspeed(npiglo,npjglo), dtim(npt))

  CALL CreateOutput

  DO jt = 1,npt
     DO jlev = 1, nlev
        ik = nklevel(jlev)
        ! Get velocities v at jk
        zu(:,:) = getvar(cf_ufil, cv_u, ik, npiglo, npjglo, ktime=jt)
        zv(:,:) = getvar(cf_vfil, cv_v, ik, npiglo, npjglo, ktime=jt)
        IF ( lforcing ) THEN
           ! u and v are already on the T grid points
        ELSE
           ! in this case we are on the C-grid and the speed must be computed 
           ! on the A-grid. We use reverse loop in order to use only one array
           DO ji=npiglo,2,-1
              DO jj=1,npjglo
                 zu(ji,jj) = 0.5*(zu(ji-1,jj)+zu(ji,jj))
              ENDDO
           ENDDO

           DO ji=1,npiglo 
              DO jj=npjglo,2,-1
                 zv(ji,jj) = 0.5*(zv(ji,jj-1)+zv(ji,jj))
              ENDDO
           ENDDO
        END IF
        zspeed    = SQRT(zv*zv+zu*zu)
        ierr = putvar(ncout, id_varout(1), zspeed, jlev ,npiglo, npjglo, ktime=jt)
     END DO
  END DO
  ierr = closeout(ncout)

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    ! define new variables for output
    stypvar(1)%ichunk=(/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(1)%cname             = 'U'
    stypvar(1)%cunits            = 'm.s-1'
    stypvar(1)%rmissing_value    = 0.
    stypvar(1)%valid_min         = -1000.
    stypvar(1)%valid_max         = 1000.
    stypvar(1)%clong_name        = 'Current or wind speed'
    stypvar(1)%cshort_name       = 'U'
    stypvar(1)%conline_operation = 'N/A'
    stypvar(1)%caxis             = 'TZYX'

    ! create output fileset
    IF (lforcing ) THEN
       ipk(1) = 1 !  2D  no dep variable
       ncout  = create      (cf_out, cf_vfil, npiglo, npjglo, 0         , ld_nc4=lnc4 )
       ierr   = createvar   (ncout,  stypvar, 1,      ipk,    id_varout , ld_nc4=lnc4 )
       ierr   = putheadervar(ncout,  cf_vfil, npiglo, npjglo, 0                       )
       nlev=1 ; nklevel(nlev) = 1
    ELSE
       ALLOCATE ( gdept(nlev), gdeptall(npk) )
       gdeptall = getvar1d ( cf_tfil, cn_vdeptht, npk )
       DO jlev = 1, nlev
          gdept(jlev) = gdeptall( nklevel(jlev) )
       END DO
       ipk(1) = nlev
       ncout  = create      (cf_out, cf_tfil, npiglo, npjglo, nlev      , ld_nc4=lnc4   )
       ierr   = createvar   (ncout,  stypvar, 1,      ipk,    id_varout , ld_nc4=lnc4   )
       ierr   = putheadervar(ncout,  cf_tfil, npiglo, npjglo, nlev,  pdep=gdept         )
    END IF

    dtim = getvar1d(cf_vfil, cn_vtimec, npt     )
    ierr = putvar1d(ncout, dtim,        npt, 'T')

  END SUBROUTINE CreateOutput

  SUBROUTINE GetLevList
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE GetLevList  ***
    !!
    !! ** Purpose :  Set up a level list given on the command line as 
    !!               blank separated list
    !!
    !! ** Method  :  Scan the command line until a '-' is found
    !!----------------------------------------------------------------------
    INTEGER (KIND=4)  :: ji
    INTEGER (KIND=4)  :: icur
    !!----------------------------------------------------------------------
    !!
    nlev=0
    ! need to read a list of level ( number unknow ) 
    ! loop on argument till a '-' is found as first char
    icur=ijarg                          ! save current position of argument number
    DO ji = icur, narg                  ! scan arguments till - found
       CALL getarg ( ji, cldum )
       IF ( cldum(1:1) /= '-' ) THEN ; nlev = nlev+1
       ELSE                          ; EXIT
       ENDIF
    ENDDO
    ALLOCATE (nklevel(nlev) )
    DO ji = icur, icur + nlev -1
       CALL getarg(ji, cldum ) ; ijarg=ijarg+1 ; READ(cldum, * ) nklevel( ji -icur +1 )
    END DO
  END SUBROUTINE GetLevList

END PROGRAM cdfspeed

PROGRAM cdfmaskdmp
  !!======================================================================
  !!                     ***  PROGRAM  cdfmaskdmp  ***
  !!=====================================================================
  !!  ** Purpose : Compute 3D mask for AABW relaxation from T and S 
  !!               climatology.
  !!               Store the results on a cdf file.
  !!
  !!  **  Method: read temp and salinity, compute sigma-2
  !!              compute coefs, create mask
  !!
  !! History : 2.1  : 09/2010  : R. Dussin    : Original code from JLS Py version
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE eos
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class preprocessing
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: ji, jj, jk, jt     ! dummy loop index
  INTEGER(KIND=4)                           :: ierr               ! error status
  INTEGER(KIND=4)                           :: narg, iargc,ijarg  ! browse command line
  INTEGER(KIND=4)                           :: npiglo, npjglo     ! size of the domain
  INTEGER(KIND=4)                           :: npk, npt           ! size of the domain
  INTEGER(KIND=4)                           :: ncout              ! ncid of output file
  INTEGER(KIND=4), DIMENSION(1)             :: ipk, id_varout     ! level and varid's

  REAL(KIND=4)                              :: ref_dep=2000.      ! reference depth in meters
  REAL(KIND=4)                              :: zsnmin=37.16       ! minimum density
  REAL(KIND=4)                              :: zswidth=0.025      ! tapering width
  REAL(KIND=4)                              :: hmin=1000.         ! depth limit
  REAL(KIND=4)                              :: hwidth=100.        ! depth tapering height
  REAL(KIND=4)                              :: rlatmax=-20.       ! max latitude
  REAL(KIND=4)                              :: rlatwidth=2.       ! latitude tapering width
  REAL(KIND=4)                              :: wdep, wsig, wlat   ! tapering function dep, sigma and lat
  REAL(KIND=4)                              :: tau=-1.            ! restoring time scale (days) (negative mean not used)
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: ztemp              ! temperature
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zsal               ! salinity
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zsigi              ! sigma-i
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zmask              ! 2D mask at current level
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zwdmp              ! 2D build mask at current level
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zlat               ! latitudes
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: zdep               ! deptht

  REAL(KIND=8), DIMENSION(:),   ALLOCATABLE :: dtim               ! time counter

  CHARACTER(LEN=256)                        :: cf_tfil            ! input filename for temperature
  CHARACTER(LEN=256)                        :: cf_sfil ='none'    ! input filename for salinity
  CHARACTER(LEN=256)                        :: cf_out='mask_dmp.nc' ! output file name
  CHARACTER(LEN=256)                        :: cldum              ! dummy string
  CHARACTER(LEN=256)                        :: cglobal            ! Global attribute with command name
  CHARACTER(LEN=256)                        :: cl_z               !  name of z dimension

  TYPE (variable), DIMENSION(1)             :: stypvar            ! structure for attributes

  LOGICAL                                   :: lnc4 = .FALSE.     ! Use nc4 with chunking and deflation
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()
  cl_z=cn_z

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfmaskdmp -t T-file [-s S-file] [-refdep REF-depth] [-tau TIME-scale]'
     PRINT *,'             ... [-dens smin width] [-dep hmin width] [-lat latmax width] ...'
     PRINT *,'             ... [-o OUT-file] [-nc4] [-zdim zdimnm]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute a damping mask with smooth transition according to density,'
     PRINT *,'       depth and latitude criteria. For each kind of criterion, a minimum  '
     PRINT *,'       value and a width of transition is used. Both minimum and width can'
     PRINT *,'       be adjusted with corresponding options. Reasonable default values are'
     PRINT *,'       provided.'
     PRINT *,'      '
     PRINT *,'       This tool was designed for building a mask in the deep Southern Ocean,'
     PRINT *,'       for dense waters. This explains that we consider the limit as a minimum'
     PRINT *,'       depth and density, but a maximum latitude. It needs some adjustments for'
     PRINT *,'       other situations.'
     PRINT *,'       '
     PRINT *,'       With -tau option, a time scale can be specified and the resulting file '
     PRINT *,'       can be used directly as a restoring file in NEMO (tradmp).'
     PRINT *,'       '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -t T-file : temperature/salinity file used to compute the potential ' 
     PRINT *,'             density relative to the reference depth.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-s S-file] : salinity file in case it differs from the temperature file.' 
     PRINT *,'       [-refdep REF-depth] : reference depth for potential density.'
     PRINT *,'       [-dens smin width] : set minimum density and width for density tapering'
     PRINT *,'       [-dep  hmin width] : set minimum depth and width for depth tapering'
     PRINT *,'       [-lat  latmax width]: set max latitude and width for latitude tapering'
     PRINT *,'       [-zdim zdimnm ] : give the name of the z dimension if not ',TRIM(cn_z)
     PRINT *,'       [-tau TIME-scale] : indicate a time scale for restoring (days). In this'
     PRINT *,'             case, the resulting file can be used as a ''resto'' file in '
     PRINT *,'             NEMO (tradmp).'
     PRINT *,'       [-o OUT-file] : specify output file name instead of ',TRIM(cf_out)
     PRINT *,'       [-nc4 ]  : Use netcdf4 output with chunking and deflation level 1.'
     PRINT *,'             This option is effective only if cdftools are compiled with'
     PRINT *,'             a netcdf library supporting chunking and deflation.'
     PRINT *,'      '
     PRINT *,'       Actual default values are :'
     PRINT '("             -refdep ", f6.0)', ref_dep
     PRINT '("             -dens   ", 2f8.3)', zsnmin, zswidth
     PRINT '("             -dep    ", 2f5.0)', hmin, hwidth
     PRINT '("             -lat    ", 2f5.0)', rlatmax, rlatwidth
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ', TRIM(cn_fmsk) 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) ,' unless -o option is used.'
     PRINT *,'         variables : wdmp'
     STOP 
  ENDIF

  ijarg=1
  DO WHILE (ijarg <= narg )
     CALL getarg(ijarg, cldum) ; ijarg=ijarg+1
     SELECT CASE ( cldum)
     CASE ( '-t'     ) ; CALL getarg(ijarg, cf_tfil ) ; ijarg=ijarg+1
        ! options
     CASE ( '-s'     ) ; CALL getarg(ijarg, cf_sfil ) ; ijarg=ijarg+1
     CASE ( '-refdep') ; CALL getarg(ijarg, cldum   ) ; ijarg=ijarg+1 ; READ(cldum,*) ref_dep
     CASE ( '-dens'  ) ; CALL getarg(ijarg, cldum   ) ; ijarg=ijarg+1 ; READ(cldum,*) zsnmin
        ;                CALL getarg(ijarg, cldum   ) ; ijarg=ijarg+1 ; READ(cldum,*) zswidth
     CASE ( '-dep'   ) ; CALL getarg(ijarg, cldum   ) ; ijarg=ijarg+1 ; READ(cldum,*) hmin
        ;                CALL getarg(ijarg, cldum   ) ; ijarg=ijarg+1 ; READ(cldum,*) hwidth
     CASE ( '-lat'   ) ; CALL getarg(ijarg, cldum   ) ; ijarg=ijarg+1 ; READ(cldum,*) rlatmax
        ;                CALL getarg(ijarg, cldum   ) ; ijarg=ijarg+1 ; READ(cldum,*) rlatwidth
     CASE ( '-zdim'  ) ; CALL getarg(ijarg, cl_z    ) ; ijarg=ijarg+1
     CASE ( '-tau'   ) ; CALL getarg(ijarg, cldum   ) ; ijarg=ijarg+1 ; READ(cldum,*) tau
     CASE ( '-o'     ) ; CALL getarg(ijarg, cf_out  ) ; ijarg=ijarg+1
     CASE ( '-nc4'   ) ; lnc4 = .TRUE. 
     CASE DEFAULT      ; PRINT *,' ERROR : ', TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  ENDDO
  IF ( cf_sfil == 'none' ) cf_sfil =cf_tfil

  WRITE(cglobal,'(" cdfmaskdmp -t ",a," -s ",a," -refdep ",f6.0," -dens ",2f8.3," -dep ",2f5.0," -lat ",2f5.0," -o ",a," -tau ",f5.0)')  &
       & TRIM(cf_tfil), TRIM(cf_sfil), ref_dep, zsnmin,zswidth, hmin, hwidth, rlatmax, rlatwidth,TRIM(cf_out), tau

  IF ( chkfile(cf_tfil) .OR. chkfile(cf_sfil) .OR. chkfile(cn_fmsk) ) STOP 99 ! missing files

  npiglo = getdim (cf_tfil,cn_x)
  npjglo = getdim (cf_tfil,cn_y)
  npk    = getdim (cf_tfil,cl_z)
  npt    = getdim (cf_tfil,cn_t)

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  ALLOCATE (ztemp(npiglo,npjglo), zsal( npiglo,npjglo)                      )
  ALLOCATE (zsigi(npiglo,npjglo), zmask(npiglo,npjglo), zlat(npiglo,npjglo) )
  ALLOCATE (zwdmp(npiglo,npjglo) )
  ALLOCATE (dtim(npt) , zdep(npk) )

  CALL CreateOutput

  zdep(:)   = getvar1d(cf_tfil, cn_vdeptht, npk              )
  zlat(:,:) = getvar  (cf_tfil, cn_vlat2d,  1, npiglo, npjglo)

  DO jt = 1, npt
     PRINT *,'time: ',jt
     DO jk = 1, npk
        PRINT *, 'jk = ', jk
        ztemp(:,:) = getvar(cf_tfil, cn_votemper, jk, npiglo, npjglo, ktime=jt)
        zsal( :,:) = getvar(cf_sfil, cn_vosaline, jk, npiglo, npjglo, ktime=jt)
        zmask(:,:) = getvar(cn_fmsk, cn_tmask,    jk, npiglo, npjglo          )

        zsigi(:,:) = sigmai( ztemp, zsal, ref_dep, npiglo, npjglo)* zmask(:,:)

        DO jj=1,npjglo
           DO ji=1,npiglo

              wdep = TANH( (zdep(jk    ) - hmin   ) / hwidth   ) / 2. + 0.5
              wsig = TANH( (zsigi(ji,jj) - zsnmin ) / zswidth  ) / 2. + 0.5
              wlat = TANH(-(zlat( ji,jj) - rlatmax) / rlatwidth) / 2. + 0.5

              zwdmp(ji,jj) = wdep * wsig * wlat

           ENDDO
        ENDDO

        zwdmp(:,:) = zwdmp(:,:) * zmask(:,:)
        IF ( tau > 0 ) THEN
          zwdmp(:,:) = zwdmp(:,:)/tau/86400.
        ENDIF

        ierr = putvar(ncout, id_varout(1), zwdmp, jk,npiglo, npjglo, ktime=jt)

     END DO  ! loop to next level
  END DO  ! loop on time

  ierr = closeout(ncout)

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------

    ipk(:)                    = npk  
    stypvar(1)%ichunk         = (/npiglo,MAX(1,npjglo/30),1,1 /)
    IF ( tau > 0 ) THEN
      stypvar(1)%cname          = 'resto'
      stypvar(1)%cunits         = '[s^-1]'
    ELSE
      stypvar(1)%cname          = 'wdmp'
      stypvar(1)%cunits         = '[0-1]'
    ENDIF
    stypvar(1)%rmissing_value = 1.e+20
    stypvar(1)%caxis          = 'TZYX'
    stypvar(1)%valid_min      = 0.
    stypvar(1)%valid_max      = 1.
    IF ( tau > 0 ) THEN
      stypvar(1)%clong_name     = 'restoring time scale  build on density criteria'
      stypvar(1)%cshort_name    = 'resto'
    ELSE
      stypvar(1)%clong_name     = 'Damping mask build on density criteria'
      stypvar(1)%cshort_name    = 'wdmp'
    ENDIF

    ! create output fileset
    ncout = create      (cf_out, cf_tfil,  npiglo, npjglo, npk      , ld_nc4=lnc4                  )
    ierr  = createvar   (ncout,  stypvar,  1,     ipk,     id_varout, ld_nc4=lnc4, cdglobal=cglobal)
    ierr  = putheadervar(ncout,  cf_tfil,  npiglo, npjglo, npk                        )

    dtim = getvar1d(cf_tfil, cn_vtimec,  npt )
    ierr = putvar1d(ncout,dtim, npt   , 'T'  )

  END SUBROUTINE CreateOutput

END PROGRAM cdfmaskdmp

PROGRAM cdfpvor
  !!======================================================================
  !!                     ***  PROGRAM  cdfpvor  ***
  !!=====================================================================
  !!  ** Purpose : Compute the Ertel Potential vorticity
  !!
  !!  ** Method  : Formula :
  !!      Qpot = drho/dz * ( f + xsi ) = Qstr + Qrel
  !!      * f is the Coriolis factor, computed from the latitudes of the T-grid :
  !!        f(i,j) = 2 * omega * sin ( phit(i,j) * pi / 180 )
  !!
  !!      * xsi is the relative vorticity (vertical component of the velocity curl),
  !!        computed from the relative vorticity of the F-points interpolated at
  !!        the T-points :
  !!        xsif(i,j) = ( ue(i,j) - ue(i,j+1) - ve(i,j) + ve(i+1,j) ) / areaf(i,j)
  !!         with : ue(i,j) = U(i,j) * e1u(i,j)
  !!                ve(i,j) = V(i,j) * e2v(i,j)
  !!             areaf(i,j) = e1f(i,j) * e2f(i,j)
  !!        xsi(i,j) = ( xsif(i-1,j-1) + xsif(i-1,j) + xsif(i,j-1) + xsif(i,j) ) / 4
  !!                 = (  ue(i-1,j-1) + ue(i,j-1) - ue(i-1,j+1) - ue(i,j+1)
  !!                    - ve(i-1,j-1) - ve(i-1,j) + ve(i+1,j-1) + ve(i+1,j) )
  !!                    / 4 / areat(i,j)
  !!        with : areat(i,j) = e1t(i,j) * e2t(i,j)
  !!        units : U, V in m.s-1
  !!           e1u, e2v, e1f, e2f in m
  !!           f, xsi in s-1
  !!           Qpot, Qrel, Qstr in 1.e-7 kg.m-4.s-1
  !!
  !! History : 2.1  : 12/2005  : A.M. Treguier : Original code
  !!           3.0  : 05/2011  : J.M. Molines  : Doctor norm + Lic., merge with cdfpv
  !!-------------------------------------------------------------------
  USE cdfio
  USE eos
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                             :: jk, jj, ji, jt       ! dummy loop index
  INTEGER(KIND=4)                             :: ierr                 ! working integer
  INTEGER(KIND=4)                             :: narg, iargc          ! command line
  INTEGER(KIND=4)                             :: ijarg, ireq          ! command line
  INTEGER(KIND=4)                             :: npiglo, npjglo       ! size of the domain
  INTEGER(KIND=4)                             :: npk, npt             ! size of the domain
  INTEGER(KIND=4)                             :: iup=1, idown=2, itmp ! working interger
  INTEGER(KIND=4)                             :: ncout                ! ncid for output file
  INTEGER(KIND=4)                             :: nvar=3               ! number of output variable
  INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE  :: ipk, id_varout       ! output variable id's

  REAL(KIND=4), DIMENSION(:,:,:), ALLOCATABLE :: ztemp, zsal, zwk     ! array to ead 2 layer of data
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: zn2                  ! Brunt Vaissala frequency
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: tmask                ! tmask from salinity
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: e3w                  ! vertical metric
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: e1u, e2v             ! horizontal metric
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: e1t, e2t             ! horizontal metric at T point
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: gphit                ! latitude of t point
  REAL(KIND=4), DIMENSION(:),     ALLOCATABLE :: gdepw                ! deptht
  REAL(KIND=4), DIMENSION(:),     ALLOCATABLE :: tim                  ! time counter
  REAL(KIND=4), DIMENSION(:),     ALLOCATABLE :: e31d                 ! metric for full step
  REAL(KIND=4)                                :: zpi, zomega, rau0sg  ! physical constant
  REAL(KIND=4)                                :: zsps                 ! Missing value for salinity

  REAL(KIND=8), DIMENSION(:,:),   ALLOCATABLE :: dun, dvn             ! velocity component and flx
  REAL(KIND=8), DIMENSION(:,:),   ALLOCATABLE :: drotn                ! curl of the velocity
  REAL(KIND=8), DIMENSION(:,:),   ALLOCATABLE :: d2fcor               ! coriolis term at T point
  REAL(KIND=8), DIMENSION(:,:),   ALLOCATABLE :: dstretch             ! stretching vorticity
  REAL(KIND=8), DIMENSION(:,:),   ALLOCATABLE :: dareat               ! area of T cells

  CHARACTER(LEN=256)                          :: cf_tfil              ! input T file
  CHARACTER(LEN=256)                          :: cf_ufil              ! input U file
  CHARACTER(LEN=256)                          :: cf_vfil              ! input V file
  CHARACTER(LEN=256)                          :: cf_out='pvor.nc'     ! output file
  CHARACTER(LEN=256)                          :: cldum                ! dummy character variable

  TYPE(variable), DIMENSION(:), ALLOCATABLE   :: stypvar              ! structure for attribute

  LOGICAL                                     :: lfull  = .FALSE.     ! flag for full step
  LOGICAL                                     :: lertel = .TRUE.      ! flag for large scale pv
  LOGICAL                                     :: lchk   = .FALSE.     ! flag for missing files
  LOGICAL                                     :: lnc4   = .FALSE.     ! flag for netcdf4 chunking and deflation
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg < 2 ) THEN
     PRINT *,' usage : cdfpvor T-file  U-file V-file [-full] [-lspv ] [-nc4] [-o output file]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the Ertel potential vorticity and save the relative  ' 
     PRINT *,'       vorticity, the stretching and the total potential vorticity. '
     PRINT *,'       Qtot = ( f + xsi ) . D(rho)/D(z)  = Qstrech + Qrel           '
     PRINT *,'       With -lspv option, compute only Qstretch or Large Scale P V '
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       T-file : netcdf file for temperature and salinity.           ' 
     PRINT *,'       U-file : netcdf file for zonal component of the velocity.    '
     PRINT *,'       V-file : netcdf file for meridional component of the velocity.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-full ] : indicate a full step configuration.                ' 
     PRINT *,'       [-lspv ] : calculate only the large scale potential vorticity.'
     PRINT *,'                  ( replace the old cdflspv tool).'
     PRINT *,'                  If used only T-file is required, no need for velocities.'
     PRINT *,'       [-nc4 ] :  use netcdf4 with chunking and deflation '
     PRINT *,'       [-o output file ] : use output file instead of default ',TRIM(cf_out)
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ', TRIM(cn_fhgr),' and ',TRIM(cn_fzgr)
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : vorelvor (1.e-7 kg.m-4.s-1 ) relative vorticity'
     PRINT *,'                     vostrvor (1.e-7 kg.m-4.s-1 ) stretching vorticity'
     PRINT *,'                     vototvor (1.e-7 kg.m-4.s-1 ) total potential vorticity'
     PRINT *,'                  Ertel PV are located at T points.'
     PRINT *,'           '
     PRINT *,'       With option -lspv :'
     PRINT *,'       netcdf file : lspv.nc'
     PRINT *,'         variables :  volspv  (1.e-7 kg.m-4.s-1 ) large scale potential vorticity'
     PRINT *,'                  LSPV is  located at W points.'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'       cdfcurl ( compute only the curl on 1 level)'
     PRINT *,'      '
     STOP
  ENDIF

  ijarg = 1  ; ireq = 0
  DO WHILE ( ijarg <= narg )
     CALL getarg( ijarg, cldum ) ; ijarg = ijarg + 1

     SELECT CASE ( cldum )
     CASE ( '-full' ) ; lfull  = .TRUE.
     CASE ( '-lspv' ) ; lertel = .FALSE. ; nvar = 1 ; cf_out = 'lspv.nc'
     CASE ( '-nc4'  ) ; lnc4 = .TRUE.
     CASE ( '-o'    ) ; CALL getarg( ijarg, cf_out ) ; ijarg = ijarg + 1
     CASE DEFAULT
        ireq=ireq+1
        SELECT CASE ( ireq )
        CASE ( 1 ) ; cf_tfil = cldum
        CASE ( 2 ) ; cf_ufil = cldum
        CASE ( 3 ) ; cf_vfil = cldum
        CASE DEFAULT
           PRINT *,' Too many arguments '; STOP 99
        END SELECT
     END SELECT
  END DO

  lchk = lchk .OR. chkfile( cn_fzgr)
  lchk = lchk .OR. chkfile( cn_fhgr)
  lchk = lchk .OR. chkfile( cf_tfil)
  IF ( lertel ) THEN
     lchk = lchk .OR. chkfile( cf_ufil)
     lchk = lchk .OR. chkfile( cf_vfil)
  ENDIF
  IF ( lchk ) STOP 99 ! missing file

  ! Look for MissingValue for salinity
  zsps = getspval(cf_tfil, cn_vosaline)

  npiglo = getdim (cf_tfil, cn_x)
  npjglo = getdim (cf_tfil, cn_y)
  npk    = getdim (cf_tfil, cn_z)
  npt    = getdim (cf_tfil, cn_t)

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  ALLOCATE ( e1u(npiglo,npjglo),   e1t(npiglo,npjglo)     )
  ALLOCATE ( e2v(npiglo,npjglo),   e2t(npiglo,npjglo)     )
  ALLOCATE ( gphit(npiglo,npjglo), d2fcor(npiglo,npjglo)  )
  ALLOCATE ( tmask(npiglo,npjglo)                         )
  ALLOCATE ( gdepw(npk), tim(npt)                         )

  ALLOCATE ( dstretch(npiglo,npjglo)                      )
  IF ( lertel ) THEN
     ALLOCATE ( dareat(npiglo,npjglo)                     )
     ALLOCATE ( dun(npiglo,npjglo),    dvn(npiglo,npjglo) )
     ALLOCATE ( drotn(npiglo,npjglo)                      )
  ENDIF
  IF ( lfull ) ALLOCATE ( e31d(npk)                       )

  e1u   = getvar(cn_fhgr, cn_ve1u,  1, npiglo, npjglo)
  e1t   = getvar(cn_fhgr, cn_ve1t,  1, npiglo, npjglo)
  e2v   = getvar(cn_fhgr, cn_ve2v,  1, npiglo, npjglo)
  e2t   = getvar(cn_fhgr, cn_ve2t,  1, npiglo, npjglo)
  gphit = getvar(cn_fhgr, cn_gphit, 1, npiglo, npjglo)

  rau0sg      = 1020./9.81
  zpi         = ACOS(-1.)
  zomega      = 2.0  * zpi /(3600*24)
  d2fcor(:,:) = 2.d0 * zomega * SIN(gphit(:,:)*zpi/180.0)

  IF ( lertel ) THEN
    dareat(:,:) = 4.d0 * e1t(:,:) * e2t(:,:)  ! factor of 4 to normalize relative vorticity
  ENDIF

  gdepw(:) = getvare3(cn_fzgr, cn_gdepw, npk)

  ALLOCATE (ztemp(npiglo,npjglo,2), zsal(npiglo,npjglo,2)) 
  ALLOCATE (zwk(npiglo,npjglo,2)                         )
  ALLOCATE (zn2(npiglo,npjglo) ,    e3w(npiglo,npjglo)   )
  ALLOCATE ( stypvar(nvar), ipk(nvar), id_varout(nvar)   )

  ! create output fileset

  ipk(:)= npk                   ! Those three variables are  3D
  stypvar%cunits            = '1.e-7 kg.m-4.s-1'
  stypvar%rmissing_value    = 0.
  stypvar%valid_min         = -10000.
  stypvar%valid_max         = 10000.
  stypvar%conline_operation = 'N/A'
  stypvar%caxis             = 'TZYX'

  DO ji = 1, nvar
   stypvar(ji)%ichunk = (/npiglo,MAX(1,npjglo/30), 1, 1 /)
  ENDDO

  IF (lertel ) THEN
     ! define variable name and attribute
     stypvar(1)%cname = 'vorelvor' ; stypvar(1)%clong_name = 'Relative_component_of_Ertel_PV'
     stypvar(2)%cname = 'vostrvor' ; stypvar(2)%clong_name = 'Stretching_component_of_Ertel_PV'
     stypvar(3)%cname = 'vototvor' ; stypvar(3)%clong_name = 'Ertel_potential_vorticity'

     stypvar(1)%cshort_name = 'vorelvor'
     stypvar(2)%cshort_name = 'vostrvor'
     stypvar(3)%cshort_name = 'vototvor'

     ncout = create      (cf_out, cf_tfil, npiglo, npjglo, npk       )
     ierr  = createvar   (ncout,  stypvar, nvar,   ipk,    id_varout )
     ierr  = putheadervar(ncout,  cf_tfil, npiglo, npjglo, npk       )
  ELSE
     stypvar(1)%cname = 'volspv' ; stypvar(1)%clong_name = 'Large Scale Potential_vorticity'
     stypvar(1)%cshort_name = 'volspv'
     ncout = create      (cf_out, cf_tfil, npiglo, npjglo, npk, cdep=TRIM(cn_vdepthw) )
     ierr  = createvar   (ncout,  stypvar, nvar,   ipk,    id_varout                  )
     ierr  = putheadervar(ncout,  cf_tfil, npiglo, npjglo, npk, pdep=gdepw            )
  ENDIF

  IF ( lfull ) e31d = getvare3( cn_fzgr, cn_ve3w1d, npk )

  tim  = getvar1d(cf_ufil, cn_vtimec, npt      )
  ierr = putvar1d(ncout,   tim,       npt, 'T' )

  DO jt=1,npt
     !  2 levels of T and S are required : iup,idown (with respect to W level)
     !  Compute from bottom to top (for vertical integration)
     PRINT *,'time=',jt,'(days:',tim(jt)/86400.,')'
     ztemp(:,:,idown) = getvar(cf_tfil, cn_votemper, npk-1, npiglo, npjglo, ktime=jt)
     zsal( :,:,idown) = getvar(cf_tfil, cn_vosaline, npk-1, npiglo, npjglo, ktime=jt)

     ! -------------------------------- LOOP OVER LEVELS
     DO jk = npk-1, 1, -1 
        PRINT *,'            level ',jk
        IF ( lertel ) THEN 
           ! ------------------------------------RELATIVE VORTICITY FIRST
           dun(:,:) = getvar(cf_ufil, cn_vozocrtx, jk ,npiglo, npjglo, ktime=jt)
           dvn(:,:) = getvar(cf_vfil, cn_vomecrty, jk ,npiglo, npjglo, ktime=jt)
           dun(:,:) = dun(:,:)*e1u(:,:)
           dvn(:,:) = dvn(:,:)*e2v(:,:)
           !     relative vorticity at T point
           drotn(:,:) = 0.d0
           DO jj = 2, npjglo -1 
              DO ji = 2, npiglo -1    
                 drotn(ji,jj) = ( dun(ji-1,jj-1)  + dun(ji,jj-1)  &
                      &        -dun(ji-1,jj+1)  - dun(ji,jj+1)  &
                      &        -dvn(ji-1,jj-1)  - dvn(ji-1,jj)  &
                      &        +dvn(ji+1,jj-1)  + dvn(ji+1,jj)) &
                      / dareat(ji,jj) 
              END DO
           END DO
        ENDIF

        !  now  tmask and Vaisala Frequency bn2
        IF ( jk > 1) THEN 
           tmask(:,:)=1.
           ztemp(:,:,iup) = getvar(cf_tfil, cn_votemper, jk-1 ,npiglo, npjglo, ktime=jt)
           zsal(:,:,iup)  = getvar(cf_tfil, cn_vosaline, jk-1 ,npiglo, npjglo, ktime=jt)
           WHERE(zsal(:,:,idown) == zsps ) tmask = 0.
           IF ( lfull ) THEN
              e3w(:,:) = e31d(jk)
           ELSE
              e3w(:,:) = getvar(cn_fzgr, 'e3w_ps', jk, npiglo, npjglo ,ldiom=.TRUE.)
           ENDIF

           WHERE (e3w == 0 ) e3w = 1.

           zwk(:,:,iup) = eosbn2 ( ztemp, zsal, gdepw(jk), e3w, npiglo, npjglo ,iup, idown)* tmask(:,:)
           !
           IF ( lertel ) THEN ! put zn2 at T level (k )
              WHERE ( zwk(:,:,idown) == 0 ) 
                 zn2(:,:) =  zwk(:,:,iup)
              ELSEWHERE
                 zn2(:,:) = 0.5 * ( zwk(:,:,iup) + zwk(:,:,idown) ) * tmask(:,:)
              END WHERE
           ELSE               ! keep bn2 at w points
              zn2(:,:) = zwk(:,:,iup) * tmask(:,:)
           ENDIF
        ENDIF
        !
        !   now rotn will be converted to relative vorticity and zn2 to stretching
        dstretch(:,:) = d2fcor(:,:)* rau0sg * zn2(:,:)

        IF ( lertel ) THEN
           drotn(:,:)    = drotn(:,:) * rau0sg * zn2(:,:)
           ! write the three variables on file at level k
           ierr = putvar(ncout, id_varout(1), REAL( drotn          )*1.e7, jk, npiglo, npjglo, ktime=jt)
           ierr = putvar(ncout, id_varout(2), REAL( dstretch       )*1.e7, jk, npiglo, npjglo, ktime=jt)
           ierr = putvar(ncout, id_varout(3), REAL((drotn+dstretch))*1.e7, jk, npiglo, npjglo, ktime=jt)
        ELSE
           ! save absolute value of dstretch, as in olf cdflspv
           ierr = putvar(ncout, id_varout(1), REAL( ABS(dstretch)  )*1.e7, jk, npiglo, npjglo, ktime=jt)
        ENDIF

        itmp = idown ; idown = iup ; iup = itmp

     END DO  ! loop to next level

     !  set zero at bottom and surface
     zwk(:,:,1) = 0.e0
     ierr = putvar(ncout, id_varout(1), zwk(:,:,1), 1,   npiglo, npjglo, ktime=jt)
     ierr = putvar(ncout, id_varout(1), zwk(:,:,1), npk, npiglo, npjglo, ktime=jt)

     IF (lertel ) THEN
        ierr = putvar(ncout, id_varout(2), zwk(:,:,1), 1,   npiglo, npjglo, ktime=jt)
        ierr = putvar(ncout, id_varout(3), zwk(:,:,1), 1,   npiglo, npjglo, ktime=jt)

        ierr = putvar(ncout, id_varout(2), zwk(:,:,1), npk, npiglo, npjglo, ktime=jt)
        ierr = putvar(ncout, id_varout(3), zwk(:,:,1), npk, npiglo, npjglo, ktime=jt)
     ENDIF
  END DO   ! loop on time

  ierr = closeout(ncout)

END PROGRAM cdfpvor

PROGRAM cdfvint
  !!======================================================================
  !!                     ***  PROGRAM  cdfvint  ***
  !!=====================================================================
  !!  ** Purpose : Compute vertically integrated temperature or salinity.
  !!
  !!  ** Method  : Compute the integral from top to bottom and save 
  !!               cumulated values. For temperature, cumulated values are
  !!               transformed to heat content (J.K.m^-2). For salinity
  !!               they are saved as PSU.m
  !!
  !! History : 2.1  : 10/2012  : M.A. Balmaseda : Original code from cdfmxlhc
  !!           3.0  : 11/2012  : J.M. Molines   : Doctor norm + Lic + ...
  !!                  02/2016  : S. Leroux      : Add -OCCI option
  !!         : 4.0  : 03/2017  : J.M. Molines
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class integration
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: jk, jt              ! dummy loop index
  INTEGER(KIND=4)                           :: ierr,  iko, it   ! working integer
  INTEGER(KIND=4)                           :: narg, iargc, ijarg  ! command line 
  INTEGER(KIND=4)                           :: npiglo, npjglo      ! size of the domain
  INTEGER(KIND=4)                           :: iimin=0, iimax=0    !
  INTEGER(KIND=4)                           :: ijmin=0, ijmax=0    !
  INTEGER(KIND=4)                           :: npk, npt            ! size of the domain
  INTEGER(KIND=4)                           :: npko                ! size of the domain
  INTEGER(KIND=4),             DIMENSION(1) :: ipk, id_varout      ! only one output variable
  INTEGER(KIND=4)                           :: ncout 

  REAL(KIND=4), PARAMETER                   :: pprho0 = 1020.     ! water density (kg/m3)
  REAL(KIND=4), PARAMETER                   :: ppcp   = 4000.     ! calorific capacity (J/kg/m3)
  REAL(KIND=4)                              :: rdep1, rdep2        ! depth counters
  REAL(KIND=4)                              :: tol  = 1.0          ! tolerance 
  REAL(KIND=4)                              :: sclf = 1.0          ! scale factor
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: gdepw               ! depth
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: gdepo               ! output depth 
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: e31d                ! vertical metrics in case of full step
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e3t                 ! vertical metric
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zt                  ! working input variable
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: rlon, rlat          ! output longitude, latitude
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: tmask               ! npiglo x npjglo

  REAL(KIND=8), DIMENSION(:),   ALLOCATABLE :: dtim                ! time counter
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dl_vint1, dl_vint2  ! verticall int quantity         

  CHARACTER(LEN=256)                        :: cf_in, cf_out       ! input/output file
  CHARACTER(LEN=256)                        :: cv_in, cv_out       ! variable name in and out
  CHARACTER(LEN=256)                        :: cunits, clongname   ! variable attributes
  CHARACTER(LEN=256)                        :: cldum               ! dummy string for command line browsing

  LOGICAL                                   :: lfull =.FALSE.      ! flag for full step computation
  LOGICAL                                   :: lgsop =.FALSE.      ! selected depths gsop intercomparison
  LOGICAL                                   :: locci =.FALSE.      ! selected 3 depths for occiput 
  LOGICAL                                   :: lchk  =.FALSE.      ! flag for missing files
  LOGICAL                                   :: lout                ! check for output
  LOGICAL                                   :: lnc4  =.FALSE.      ! flag for netcdf4 chunking and deflation
  LOGICAL                                   :: ltmean=.FALSE.      ! flag for mean temperature output
  LOGICAL                                   :: lsmean=.FALSE.      ! flag for mean salinity output
  LOGICAL                                   :: lfout =.FALSE.      ! flag for output filename

  TYPE(variable), DIMENSION(1)              :: stypvar             ! extension for attributes
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfvint -f T-file [-v IN-var] [-GSOP] [-OCCI] [-full] [-vvl] ...'
     PRINT *,'              ... [-w imin imax jmin jmax ] ...'
     PRINT *,'              ... [-tmean] [-smean] [-o OUT-file] [-nc4]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the vertical integral of the variable from top to bottom,'
     PRINT *,'       and save the cumulated valued, level by level. For temperature '
     PRINT *,'       (default variable), the integral is transformed to heat content, '
     PRINT *,'       (unit in 10^6 J/m2) hence for salinity, the units are PSU.m '
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'         -f T-file : gridT file holding either temperature or salinity '
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'        [-v IN-var ] : name of input variable to process. Default is ',TRIM(cn_votemper)
     PRINT *,'                Possible other choice is ', TRIM(cn_vosaline)
     PRINT *,'        [-GSOP] : Use 7 GSOP standard level for the output '
     PRINT *,'                Default is to take the model levels for the output'
     PRINT *,'        [-OCCI] : Use 3 levels for the output: 700m, 2000m and bottom'
     PRINT *,'                Default is to take the model levels for the output'
     PRINT *,'        [-full] : for full step computation ' 
     PRINT *,'        [-vvl]   : use time-varying metrics for vertical integration'
     PRINT *,'               (still some details to fix for the last cell including the'
     PRINT *,'                target deptht).'
     PRINT *,'        [-w imin imax jmin jmax ] : limit the vertical integral to a subdomain'
     PRINT *,'               specified by imin, imax, jmin, jmax.'
     PRINT *,'        [-tmean] : output mean temperature instead of heat content'
     PRINT *,'        [-smean] : output mean salinity instead of PSU.m'
     PRINT *,'        [-o OUT-file] : use specified output file instead of <IN-var>.nc'
     PRINT *,'        [-nc4]  : use netcdf4 output with chunking and deflation'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ', TRIM(cn_fmsk),', ',TRIM(cn_fhgr),' and ', TRIM(cn_fzgr) 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file :  VAR-name.nc (or specified with -o option)'
     PRINT *,'         variables :  either voheatc or vohsalt, unless -tmean or -smean used'
     PRINT *,'               In this latter case, variables are ',TRIM(cn_votemper),' and '
     PRINT *,'              ',TRIM(cn_vosaline)
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'        cdfvertmean, cdfheatc, cdfmxlhcsc and  cdfmxlheatc'
     PRINT *,'      '
     STOP 
  ENDIF

  ! default values
  cv_in = cn_votemper

  ! browse command line
  ijarg = 1   
  DO WHILE ( ijarg <= narg ) 
     CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1
     SELECT CASE ( cldum)
     CASE ( '-f'    ) ; CALL getarg (ijarg, cf_in  ) ; ijarg = ijarg + 1
        ! options
     CASE ( '-v'    ) ; CALL getarg (ijarg, cv_in  ) ; ijarg = ijarg + 1
     CASE ( '-GSOP' ) ; lgsop = .TRUE.
     CASE ( '-OCCI' ) ; locci = .TRUE.
     CASE ( '-full' ) ; lfull = .TRUE. 
     CASE ( '-tmean') ; ltmean= .TRUE. 
     CASE ( '-smean') ; lsmean= .TRUE. 
     CASE ( '-vvl'  ) ; lg_vvl= .TRUE. 
     CASE ('-w'     ) ; CALL getarg(ijarg, cldum   ) ; ijarg = ijarg + 1 ;  READ(cldum,*) iimin
        ;               CALL getarg(ijarg, cldum   ) ; ijarg = ijarg + 1 ;  READ(cldum,*) iimax
        ;               CALL getarg(ijarg, cldum   ) ; ijarg = ijarg + 1 ;  READ(cldum,*) ijmin
        ;               CALL getarg(ijarg, cldum   ) ; ijarg = ijarg + 1 ;  READ(cldum,*) ijmax
     
     CASE ( '-nc4'  ) ; lnc4  = .TRUE. 
     CASE ( '-o'    ) ; lfout = .TRUE. ; CALL getarg (ijarg, cf_out) ; ijarg = ijarg + 1
     CASE DEFAULT     ; PRINT *,' ERROR : ', TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  END DO

  ! Security check
  lchk = chkfile ( cf_in   )
  lchk = chkfile ( cn_fmsk ) .OR. lchk
  lchk = chkfile ( cn_fhgr ) .OR. lchk
  lchk = chkfile ( cn_fzgr ) .OR. lchk
  IF ( lchk ) STOP 99 ! missing files

  IF (lg_vvl ) THEN
     cn_fe3t = cf_in
     cn_ve3t = cn_ve3tvvl
  ENDIF

  IF ( ltmean .AND. cv_in == cn_vosaline ) THEN
     PRINT *,' WARNING : flag -tmean is useless with variable', TRIM(cv_in)
     ltmean = .FALSE.
  ENDIF
  IF ( lsmean .AND. cv_in == cn_votemper ) THEN
     PRINT *,' WARNING : flag -smean is useless with variable', TRIM(cv_in)
     lsmean = .FALSE.
  ENDIF

  ! Set output information according to variable name
  IF ( cv_in == cn_votemper ) THEN
     IF ( ltmean ) THEN
        cv_out    = cn_votemper
        clongname = 'Mean temperature '
        cunits    = 'Deg Celsius'
        sclf      = 1.
     ELSE
        cv_out    = 'voheatc'
        clongname = 'Heat Content per unit area'
        cunits    = '10^6 J/m2'
        sclf      = pprho0*ppcp/1.e6
     ENDIF
  ELSEIF ( cv_in == cn_vosaline ) THEN
     IF ( lsmean ) THEN
        cv_out    = cn_vosaline
        clongname = 'Mean salinity'
        cunits    = 'psu'
     ELSE
        cv_out    = 'vohsalt'
        clongname = 'Vertically Integrated Salinity'
        cunits    = 'psu.m'
     ENDIF
     sclf      = 1.
  ELSE
     PRINT *,'  ERROR: Variable ', TRIM(cv_in), ' not pre-defined ...'
     PRINT *,'     Accepted variables are ', TRIM(cn_votemper),' and ',TRIM(cn_vosaline)
     STOP 99
  ENDIF

  ! log information so far
  IF ( .NOT. lfout ) cf_out = TRIM(cv_out)//'.nc'
  PRINT *,' INPUT VARIABLE  : ' , TRIM(cv_in)
  PRINT *,' OUTPUT VARIABLE : ' , TRIM(cv_out)
  PRINT *,' OUTPUT FILE     : ' , TRIM(cf_out)

  npiglo = getdim (cf_in, cn_x )
  npjglo = getdim (cf_in, cn_y )
  npk    = getdim (cf_in, cn_z )
  npt    = getdim (cf_in, cn_t )

  IF ( iimin /= 0 ) THEN ; npiglo = iimax -iimin + 1;  ELSE ; iimin=1 ;
  ENDIF

  IF ( ijmin /= 0 ) THEN ; npjglo = ijmax -ijmin + 1;  ELSE ; ijmin=1 ;
  ENDIF

  IF ( lgsop ) THEN ; PRINT *,' using GSOP depths' ; npko = 7 ! SL: commented out
  ENDIF

  IF ( locci ) THEN ; PRINT *,' using OCCIPUT depths' ; npko = 3
  ENDIF

  IF ((.not.lgsop).and.(.not.locci)) THEN ; PRINT *,' using model depths'; npko = npk
  ENDIF

  PRINT *, ' NPIGLO = ', npiglo
  PRINT *, ' NPJGLO = ', npjglo
  PRINT *, ' NPK    = ', npk
  PRINT *, ' NPKO   = ', npko
  PRINT *, ' NPT    = ', npt

  ! Allocate arrays
  ALLOCATE ( dtim(npt) )
  ALLOCATE ( tmask(npiglo,npjglo) )
  ALLOCATE ( rlon(npiglo,npjglo), rlat(npiglo,npjglo)  )
  ALLOCATE ( zt(npiglo,npjglo)  )
  ALLOCATE ( e3t(npiglo,npjglo) )
  ALLOCATE ( e31d(npk)   )
  ALLOCATE ( gdepw(npk), gdepo(npko) ) 

  ALLOCATE ( dl_vint1(npiglo, npjglo), dl_vint2(npiglo,npjglo) )

  ! Initialize output file
  gdepw(:) = getvare3(cn_fzgr, cn_gdepw, npk )
  e31d(:)  = getvare3(cn_fzgr, cn_ve3t1d,  npk )

  IF ( lgsop ) THEN
     gdepo(:) = (/100.,300.,500.,700.,800.,2000.,6000./) ! GEOP standard levs
  ENDIF

  IF ( locci ) THEN 
     gdepo(:) = (/700.,2000.,6000./) ! SL: occiput levels
  ENDIF

  IF ((.not.lgsop).AND.(.not.locci)) THEN 
     gdepo(1:npk-1) = gdepw(2:npk)
     gdepo(npk)     = 6000.
  ENDIF

  rlon =getvar(cf_in, cn_vlon2d, 1, npiglo, npjglo, kimin=iimin, kjmin=ijmin)  ! nav_lon
  rlat =getvar(cf_in, cn_vlat2d, 1, npiglo, npjglo, kimin=iimin, kjmin=ijmin)  ! nav_lat

  CALL CreateOutput

  PRINT*,'OUTPUT DEPTHS ARE : ',gdepo

  DO jt = 1, npt
     IF ( lg_vvl ) THEN ; it=jt
     ELSE               ; it=1
     ENDIF
     dl_vint1(:,:) = 0.d0
     iko  = 1
     rdep1 = 0.0 ; rdep2 = 0.0
     lout = .TRUE.
     DO jk = 1, npk
        IF ( lgsop .OR. locci ) lout = .FALSE.
        rdep1          = rdep2
        dl_vint2(:,:) = dl_vint1 (:,:)

        tmask(:,:)= getvar(cn_fmsk, cn_tmask, jk, npiglo, npjglo, kimin=iimin, kjmin=ijmin           )
        zt(:,:)   = getvar(cf_in,   cv_in,    jk, npiglo, npjglo, kimin=iimin, kjmin=ijmin, ktime=jt )
        IF ( lfull ) THEN ; e3t(:,:) = e31d(jk)
        ELSE ; e3t(:,:) = getvar(cn_fe3t, cn_ve3t, jk, npiglo, npjglo, kimin=iimin, kjmin=ijmin,     &
                             &                                        ktime=it, ldiom=.NOT.lg_vvl    )

        ENDIF

        rdep2 = rdep1 + e31d(jk)
        dl_vint1(:,:) = dl_vint1(:,:)+ zt(:,:)*e3t(:,:)*tmask(:,:)*1.d0

        IF ( rdep2 >= (gdepo(iko) - tol ) ) THEN
           lout=.TRUE.
           !modify vertical thickness for output
           WHERE (e3t(:,:) >  gdepo(iko) - rdep1 ) e3t(:,:) = gdepo(iko)-rdep1
           dl_vint2(:,:) = dl_vint2(:,:)+ zt(:,:)*e3t(:,:)*tmask(:,:)*1.d0
        ENDIF

        IF ( lout ) THEN
           dl_vint2(:,:) = dl_vint2(:,:) * sclf
           IF (jt == 1 ) THEN
              PRINT *,'Output for level ',iko
              PRINT *,'rdep1, rdep2, depo ',rdep1,rdep2,gdepo(iko) 
           ENDIF
           IF ( ltmean .OR. lsmean ) THEN
              ierr = putvar(ncout, id_varout(1) ,REAL(dl_vint2)/rdep2, iko, npiglo, npjglo, ktime=jt)
           ELSE
              ierr = putvar(ncout, id_varout(1) ,REAL(dl_vint2), iko, npiglo, npjglo, ktime=jt)
           ENDIF
           iko = iko + 1
        ENDIF
     END DO  ! loop to next level
  END DO  ! next time frame

  ierr = closeout(ncout)

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    ! prepare output variable
    ipk(:)                       = npko
    ! choose chunk size for output ... not easy not used if lnc4=.false. but
    ! anyway ..
    stypvar(1)%ichunk=(/npiglo,MAX(1,npjglo/30),1,1 /)

    stypvar(1)%cname             = TRIM(cv_out)
    stypvar(1)%cunits            = TRIM(cunits)
    stypvar(1)%rmissing_value    = 0.
    stypvar(1)%valid_min         = -1.e15
    stypvar(1)%valid_max         =  1.e15
    stypvar(1)%clong_name        = TRIM(clongname)
    stypvar(1)%cshort_name       = TRIM(cv_out)
    stypvar(1)%conline_operation = 'N/A'
    stypvar(1)%caxis             = 'TZYX'

    ncout = create      (cf_out, 'none', npiglo, npjglo, npko, cdep=cn_vdepthw, ld_xycoo=.FALSE. &
         , ld_nc4=lnc4)
    ierr  = createvar   (ncout, stypvar, 1, ipk, id_varout , ld_nc4=lnc4)
    ierr  = putheadervar(ncout, cf_in,   npiglo, npjglo, npko,  pnavlon=rlon, pnavlat=rlat,  &
          &                             pdep=gdepo,     ld_xycoo=.FALSE.)

    dtim  = getvar1d    (cf_in, cn_vtimec, npt     )
    ierr  = putvar1d    (ncout, dtim,      npt, 'T')

  END SUBROUTINE CreateOutput

END PROGRAM cdfvint

 MODULE cdfio
  !!======================================================================
  !!                     ***  MODULE  cdfio  ***
  !! Implement all I/O related to netcdf in CDFTOOLS
  !!=====================================================================
  !! History : 2.1 : 2005  : J.M. Molines   : Original code
  !!               : 2009  : R. Dussin      : add putvar_0d function
  !!           3.0 : 12/2010 : J.M. Molines : Doctor + Licence     
  !! Modified: 3.0 : 08/2011 : P.   Mathiot : Add chkvar function           
  !!----------------------------------------------------------------------

  !!----------------------------------------------------------------------
  !!   routines      : description
  !! .............................
  !!   ERR_HDL       : Error Handler routine to catch netcdf errors
  !!   gettimeseries : print a 2 column array (time, variable) for a given
  !!                   file, variable and depth
  !!
  !!   functions     : description
  !! .............................
  !!   chkfile       : check the existence of a file
  !!   chkvar        : check the existence of a variable in a file
  !!   closeout      : close output file
  !!   copyatt       : copy attributes from a file taken as model
  !!   create        : create a netcdf data set
  !!   createvar     : create netcdf variables in a new data set
  !!   cvaratt       : change some var attributes
  !!   edatt_char    : edit attributes of char type
  !!   edatt_r4      : edit attributes of float type
  !!   getatt        : get attributes of a variable
  !!   getdim        : return the value of the dimension passed as argument
  !!   getipk        : get the vertical dimension of the variable
  !!   getnvar       : get the number of variable in a file
  !!   getspval      : get spval of a given variable
  !!   getvar1d      : read 1D real*4 variable (eg depth, time_counter) from a file
  !!   getvar1d8     : read 1D real*8 variable (eg depth, time_counter) from a file
  !!   getvar3d      : read 3D variable  at once
  !!   getvaratt     : read variable attributes
  !!   gettimeatt    : get time attributes
  !!   getvar        : read the variable
  !!   getvare3      : read e3 type variable
  !!   getvarid      : get the varid of a variable in a file
  !!   getvarname    : get the name of a variable, according to its varid
  !!   getvarxz      : get a x-z slice of 3D data
  !!   getvaryz      : get a y-z slice of 3D data
  !!   getvdim       : get the number of dim of a variable
  !!   getvardim     : get the values of the vertical coordinates variable
  !!   ncopen        : open a netcdf file and return its ncid
  !!   putatt        : write variable attribute
  !!   puttimeatt    : write time variable attribute
  !!   putheadervar  : write header variables such as nav_lon, nav_lat etc ... from a file taken
  !!                 : as template
  !!   putvar0d      : write a 0d variable (constant)
  !!   putvar1d4     : write a 1d real*4 variable
  !!   putvar1d8     : write a 1d real*8 variable
  !!   putvari2      : write a 2d Integer*2 variable
  !!   putvarr4      : write a 2d Real*4 variable
  !!   putvarr8      : write a 2d Real*8 variable
  !!   putvarzo      : write a zonally integrated/mean field
  !!   reputvarr4    : re-write a real*4 variable
  !!   reputvar1d4   : re-write a real*4 1d variable
  !!   reputvar1d8   : re-write a real*8 1d variable
  !!------------------------------------------------------------------------------------------------------
  USE netcdf        
  USE modcdfnames

  IMPLICIT NONE

  PRIVATE 
  INTEGER(KIND=4) :: nid_x, nid_y, nid_z, nid_t, nid_lat, nid_lon, nid_dep, nid_tim, nid_timb, nid_b
  INTEGER(KIND=4) :: nid_lon1d, nid_lat1d
  LOGICAL         :: l_mbathy=.false.
  INTEGER(KIND=4), DIMENSION(:,:), ALLOCATABLE :: mbathy         !: for reading e3._ps in nemo3.x
  REAL(KIND=4),    DIMENSION(:,:), ALLOCATABLE :: e3t_ps, e3w_ps !: for reading e3._ps in nemo3.x
  REAL(KIND=4),    DIMENSION(:),   ALLOCATABLE :: e3t_0, e3w_0   !: for readinf e3._ps in nemo3.x

  
  INTEGER(KIND=4)    :: nstart_date  = -1                      !# from global file attribute
  CHARACTER(LEN=256) :: ctime_units  = 'seconds since 0000-01-01 00:00:00'
  CHARACTER(LEN=256) :: ctime_origin = 'N/A'                   !# 
  CHARACTER(LEN=256) :: calendar     = 'N/A'                   !# gregorian noleap xxxd
  CHARACTER(LEN=256) :: config                                 !# config name associated with file
  CHARACTER(LEN=256) :: ccase                                  !# case name associated with  file
  CHARACTER(LEN=10 ) :: cfreq                                  !# raw model output frequency (5d, 30d 1h ..)

  TYPE, PUBLIC ::   variable 
     CHARACTER(LEN=256) :: cname             !# variable name
     CHARACTER(LEN=256) :: cunits            !# variable unit
     REAL(KIND=4)       :: rmissing_value    !# variable missing value or spval
     REAL(KIND=4)       :: valid_min         !# valid minimum
     REAL(KIND=4)       :: valid_max         !# valid maximum
     REAL(KIND=4)       :: scale_factor=1.   !# scale factor
     REAL(KIND=4)       :: add_offset=0.     !# add offset
     REAL(KIND=4)       :: savelog10=0.      !# flag for log10 transform
     INTEGER(KIND=4)    :: iwght=1           !# weight of the variable for cdfmoy_weighted
     INTEGER(KIND=4), DIMENSION(4) :: ichunk !# chunksize
     CHARACTER(LEN=256) :: clong_name        !# Long Name of the variable
     CHARACTER(LEN=256) :: cshort_name       !# short name of the variable
     CHARACTER(LEN=256) :: conline_operation !# ???
     CHARACTER(LEN=256) :: caxis             !# string defining the dim of the variable
     CHARACTER(LEN=256) :: cprecision='r4'   !# possible values are i2, r4, r8
  END TYPE variable

  TYPE, PUBLIC  :: ncfile                         ! logical structure reflecting file structure
     INTEGER(KIND=4)                              :: ncid    ! file ncid
     INTEGER(KIND=4)                              :: ndims   ! number of dims
     INTEGER(KIND=4)                              :: nvars   ! number of vars
     INTEGER(KIND=4)                              :: natts   ! number of global attributes
     INTEGER(KIND=4)                              :: iunlim  ! ID of unlimited dimension
     INTEGER(KIND=4)                              :: npi     ! i-size of file
     INTEGER(KIND=4)                              :: npj     ! j-size of file
     INTEGER(KIND=4)                              :: npk     ! k-size of file
     INTEGER(KIND=4)                              :: npt     ! t-size of file
     INTEGER(KIND=4)                              :: npb     ! time_bound size
     INTEGER(KIND=4)                              :: idx     ! x dimid
     INTEGER(KIND=4)                              :: idy     ! y dimid
     INTEGER(KIND=4)                              :: idz     ! z dimid
     INTEGER(KIND=4)                              :: idt     ! t dimid
     INTEGER(KIND=4)                              :: idb     ! time-bound  dimid
     INTEGER(KIND=4), DIMENSION(:),   ALLOCATABLE :: ideflat ! deflate level (nvar)
     INTEGER(KIND=4), DIMENSION(:),   ALLOCATABLE :: nvatt   ! number of att of each variable (var)
     INTEGER(KIND=4), DIMENSION(:),   ALLOCATABLE :: nvid    ! varid of each variable (var)
     INTEGER(KIND=4), DIMENSION(:),   ALLOCATABLE :: nvdim   ! dimension of each variable (var)
     INTEGER(KIND=4), DIMENSION(:),   ALLOCATABLE :: itype   ! type of each variable (var)
     INTEGER(KIND=4), DIMENSION(:),   ALLOCATABLE :: nlen    ! len of each dimension ( ndims)
     INTEGER(KIND=4), DIMENSION(:,:), ALLOCATABLE :: ichunk  ! size of chunk (nvar, ndims)
     INTEGER(KIND=4), DIMENSION(:,:), ALLOCATABLE :: idimids ! dimids of each variable (nvar, ndims) 
     CHARACTER(LEN=255)                            :: c_fnam ! name of working file
     CHARACTER(LEN=80 ), DIMENSION(:), ALLOCATABLE :: c_vnam ! name of each variable (var)
     CHARACTER(LEN=80 ), DIMENSION(:), ALLOCATABLE :: c_dnam ! name of each dimension (ndims)
     LOGICAL,           DIMENSION(:), ALLOCATABLE :: lconti  ! contiguous flag (nvar)
     !   extra information for global attribute 
     INTEGER(KIND=4)                :: number_total          ! DOMAIN_number_total
     INTEGER(KIND=4)                :: number                ! DOMAIN_number
     INTEGER(KIND=4), DIMENSION(2)  :: idimensions_ids       ! DOMAIN_dimensions_ids
     INTEGER(KIND=4), DIMENSION(2)  :: isize_global          ! DOMAIN_size_global
     INTEGER(KIND=4), DIMENSION(2)  :: isize_local           ! DOMAIN_size_local
     INTEGER(KIND=4), DIMENSION(2)  :: iposition_first       ! DOMAIN_position_first
     INTEGER(KIND=4), DIMENSION(2)  :: iposition_last        ! DOMAIN_position_last 
     INTEGER(KIND=4), DIMENSION(2)  :: ihalo_size_start      ! DOMAIN_halo_size_start
     INTEGER(KIND=4), DIMENSION(2)  :: ihalo_size_end        ! DOMAIN_halo_size_end
     CHARACTER(LEN=80)              :: c_type                ! DOMAIN_type
  END TYPE ncfile


  INTEGER(KIND=4), PARAMETER :: jp_missing_nm = 3
  
  CHARACTER(LEN=256), DIMENSION(jp_missing_nm) :: & ! take care of same length for each element
        & cl_missing_nm = (/'missing_value','Fillvalue    ','_Fillvalue   '/)
  CHARACTER(LEN=256 ) :: cl_dum              !# dummy char argument

  INTERFACE putvar
     MODULE PROCEDURE putvarr8, putvarr4, putvari2, putvarzo, reputvarr4, putvare3
  END INTERFACE

  INTERFACE putvar1d   
     MODULE PROCEDURE putvar1d4, reputvar1d4, putvar1d8, reputvar1d8
  END INTERFACE

  INTERFACE putvar0d   
     MODULE PROCEDURE putvar0dt, putvar0ds
  END INTERFACE

  INTERFACE atted
     MODULE PROCEDURE atted_char, atted_r4
  END INTERFACE

  PUBLIC :: chkfile, chkvar
  PUBLIC :: copyatt, create, createvar, getvaratt, cvaratt, gettimeatt
  PUBLIC :: putatt, putheadervar, putvar, putvar1d, putvar0d, atted, puttimeatt
  PUBLIC :: getatt, getdim, getvdim, getdimvar,getipk, getnvar, getvarname, getvarid
  PUBLIC :: getvar, getvarxz, getvaryz, getvar1d, getvar1d8, getvare3, getvar3d, getvar3dt, getvar4d, getspval
  PUBLIC :: getvar1d_bounds, putvar1d_bounds
  PUBLIC :: gettimeseries
  PUBLIC :: closeout, ncopen
  PUBLIC :: ERR_HDL


  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2010, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------

CONTAINS

  INTEGER(KIND=4) FUNCTION copyatt (cdvar, kidvar, kcin, kcout)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION copyatt  ***
    !!
    !! ** Purpose :   Copy attributes for variable cdvar, which have id 
    !!                kidvar in kcout, from file id kcin
    !!
    !! ** Method  :   Use NF90_COPY_ATT
    !!
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*), INTENT(in) :: cdvar
    INTEGER(KIND=4),  INTENT(in) :: kidvar, kcin, kcout

    INTEGER(KIND=4)    :: ja
    INTEGER(KIND=4)    :: istatus, idvar, iatt
    CHARACTER(LEN=256) :: clatt
    !!----------------------------------------------------------------------
    IF ( kcin /= -9999) THEN    ! there is a reference file open
       istatus = NF90_INQ_VARID(kcin, cdvar, idvar)
       istatus = NF90_INQUIRE_VARIABLE(kcin, idvar, natts=iatt)
       DO ja = 1, iatt
          istatus = NF90_INQ_ATTNAME(kcin,idvar,ja,clatt)
          istatus = NF90_COPY_ATT(kcin,idvar,clatt,kcout,kidvar)
       END DO
    ELSE                        ! no reference file
       SELECT CASE (TRIM(cdvar) )
       CASE ('nav_lon', 'lon', 'x', 'longitude' )
          istatus=NF90_PUT_ATT(kcout, kidvar, 'units',     'degrees_east')
          istatus=NF90_PUT_ATT(kcout, kidvar, 'valid_min', -180.         )
          istatus=NF90_PUT_ATT(kcout, kidvar, 'valid_max',  180.         )
          istatus=NF90_PUT_ATT(kcout, kidvar, 'long_name', 'Longitude'   )
          istatus=NF90_PUT_ATT(kcout, kidvar, 'nav_model', 'Default grid')
       CASE ('nav_lat' ,'lat', 'y', 'latitude' )
          istatus=NF90_PUT_ATT(kcout, kidvar, 'units',    'degrees_north')
          istatus=NF90_PUT_ATT(kcout, kidvar, 'valid_min', -90.          )
          istatus=NF90_PUT_ATT(kcout, kidvar, 'valid_max',  90.          )
          istatus=NF90_PUT_ATT(kcout, kidvar, 'long_name','Latitude'     )
          istatus=NF90_PUT_ATT(kcout, kidvar, 'nav_model', 'Default grid')
       CASE ('time_counter', 'time', 't', 'time_centered', 'time_instant')
          istatus=NF90_PUT_ATT(kcout, kidvar, 'calendar',   calendar     )
          istatus=NF90_PUT_ATT(kcout, kidvar, 'units',      ctime_units  )
          istatus=NF90_PUT_ATT(kcout, kidvar, 'time_origin',ctime_origin )
          istatus=NF90_PUT_ATT(kcout, kidvar, 'title',      'Time'       )
          istatus=NF90_PUT_ATT(kcout, kidvar, 'long_name',  'Time axis'  )
       CASE ('deptht', 'depthu' ,'depthv' , 'depthw', 'dep', 'gdept'     )
          istatus=NF90_PUT_ATT(kcout, kidvar, 'units',      'm'          )
          istatus=NF90_PUT_ATT(kcout, kidvar, 'positive',  'unknown'     )
          istatus=NF90_PUT_ATT(kcout, kidvar, 'valid_min',  0.           )
          istatus=NF90_PUT_ATT(kcout, kidvar, 'valid_max',  5875.        )
          istatus=NF90_PUT_ATT(kcout, kidvar, 'title',     TRIM(cdvar)   )
          istatus=NF90_PUT_ATT(kcout, kidvar, 'long_name', 'Vertical Levels')
       CASE ('sigma', 'levels')
          istatus=NF90_PUT_ATT(kcout, kidvar, 'units', 'kg/m3'           )
          istatus=NF90_PUT_ATT(kcout, kidvar, 'positive', 'unknown'      )
          istatus=NF90_PUT_ATT(kcout, kidvar, 'valid_min', 0.            )
          istatus=NF90_PUT_ATT(kcout, kidvar, 'valid_max', 40.           )
          istatus=NF90_PUT_ATT(kcout, kidvar, 'title', TRIM(cdvar)       )
          istatus=NF90_PUT_ATT(kcout, kidvar, 'long_name', 'Sigma bin limits')
       END SELECT
    ENDIF

    copyatt = istatus
  END FUNCTION copyatt


  INTEGER(KIND=4) FUNCTION create( cdfile, cdfilref ,kx,ky,kz ,cdep, cdepvar, &
       &                           cdlonvar, cdlatvar,  ld_xycoo, ld_nc4 )
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION create  ***
    !!
    !! ** Purpose : Create the file, and creates dimensions, and copy attributes 
    !!              from a cdilref reference file (for the nav_lon, nav_lat etc ...)
    !!              If optional cdep given : take as depth variable name instead of 
    !!              cdfilref. Return the ncid of the created file, and leave it open
    !!
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*),           INTENT(in) :: cdfile, cdfilref ! input file and reference file
    INTEGER(KIND=4),            INTENT(in) :: kx, ky, kz       ! dimension of the variable
    CHARACTER(LEN=*), OPTIONAL, INTENT(in) :: cdep     ! name of vertical dim name if not standard
    CHARACTER(LEN=*), OPTIONAL, INTENT(in) :: cdepvar  ! name of vertical var name if it differs
                                                       ! from vertical dimension name
    CHARACTER(LEN=*), OPTIONAL, INTENT(in) :: cdlonvar ! name of 1D longitude
    CHARACTER(LEN=*), OPTIONAL, INTENT(in) :: cdlatvar ! name of 1D latitude
    LOGICAL,          OPTIONAL, INTENT(in) :: ld_xycoo ! if false then DO NOT read nav_lat nav_lat from input file
    LOGICAL,          OPTIONAL, INTENT(in) :: ld_nc4   ! create NETCDF4 file with chunking and deflation

    INTEGER(KIND=4)               :: istatus, icout, incid, idum
    INTEGER(KIND=4) ,DIMENSION(4) :: invdim
    CHARACTER(LEN=256)            :: cldep, cldepref, cldepvar, clonvar, clatvar
    LOGICAL                       :: ll_xycoo, ll_nc4
    !!----------------------------------------------------------------------
    IF ( PRESENT (ld_nc4 ) ) THEN 
       ll_nc4 = ld_nc4
    ELSE
       ll_nc4 = .false. 
    ENDIF
#if defined key_netcdf4
    IF ( ll_nc4 ) THEN
      istatus = NF90_CREATE(cdfile,cmode=or(NF90_CLOBBER,NF90_NETCDF4     ), ncid=icout)
    ELSE
      istatus = NF90_CREATE(cdfile,cmode=or(NF90_CLOBBER,NF90_64BIT_OFFSET), ncid=icout)
    ENDIF
#else
    istatus = NF90_CREATE(cdfile,cmode=or(NF90_CLOBBER,NF90_64BIT_OFFSET), ncid=icout)
#endif
    istatus = NF90_DEF_DIM(icout, cn_x, kx, nid_x)
    istatus = NF90_DEF_DIM(icout, cn_y, ky, nid_y)

    IF ( kz /= 0 ) THEN
       ! try to find out the name I will use for depth dimension in the new file ...
       IF (PRESENT (cdep) ) THEN
          cldep = cdep
          idum=getdim(cdfilref,cldep,cldepref)   ! look for depth dimension name in ref file
         IF (cldepref =='unknown' ) cldepref=cdep
       ELSE 
          idum=getdim(cdfilref,cn_z,cldep   )   ! look for depth dimension name in ref file
          cldepref=cldep
       ENDIF
       cldepvar=cldep
       istatus = NF90_DEF_DIM(icout,TRIM(cldep),kz, nid_z)
       IF (PRESENT (cdepvar) ) THEN
         cldepvar=cdepvar
       ENDIF
    ENDIF


    istatus = NF90_DEF_DIM(icout,cn_t,NF90_UNLIMITED, nid_t)

    invdim(1) = nid_x ; invdim(2) = nid_y ; invdim(3) = nid_z ; invdim(4) = nid_t

    ! Open reference file if any,  otherwise set ncid to flag value (for copy att)
    IF ( TRIM(cdfilref) /= 'none' ) THEN
       istatus = NF90_OPEN(cdfilref,NF90_NOWRITE,incid)
    ELSE
       incid = -9999
    ENDIF

    IF (PRESENT (ld_xycoo) ) THEN
      ll_xycoo = ld_xycoo
    ELSE
      ll_xycoo = .true.
    ENDIF 
    ! define variables and copy attributes
    IF ( ll_xycoo ) THEN
       istatus = NF90_DEF_VAR(icout,cn_vlon2d,NF90_FLOAT,(/nid_x, nid_y/), nid_lon)
       istatus = copyatt(cn_vlon2d, nid_lon,incid,icout)
       istatus = NF90_DEF_VAR(icout,cn_vlat2d,NF90_FLOAT,(/nid_x, nid_y/), nid_lat)
       istatus = copyatt(cn_vlat2d, nid_lat,incid,icout)
    ENDIF
    IF ( PRESENT(cdlonvar) ) THEN
       istatus = NF90_DEF_VAR(icout,cdlonvar,NF90_FLOAT,(/nid_x/), nid_lon1d)
    ENDIF
    IF ( PRESENT(cdlatvar) ) THEN
       istatus = NF90_DEF_VAR(icout,cdlatvar,NF90_FLOAT,(/nid_y/), nid_lat1d)
    ENDIF
    IF ( kz /= 0 ) THEN
       istatus = NF90_DEF_VAR(icout,TRIM(cldepvar),NF90_FLOAT,(/nid_z/), nid_dep)
       ! JMM bug fix : if cdep present, then chose attribute from cldepref
       istatus = copyatt(TRIM(cldepvar), nid_dep,incid,icout)
    ENDIF

    istatus = NF90_DEF_VAR(icout,cn_vtimec,NF90_FLOAT,(/nid_t/), nid_tim)
    istatus = copyatt(cn_vtimec, nid_tim,incid,icout)

    ! Add Global General attribute at first call
    istatus=NF90_PUT_ATT(icout,NF90_GLOBAL,'start_date', nstart_date )
    istatus=NF90_PUT_ATT(icout,NF90_GLOBAL,'output_frequency', cfreq )
    istatus=NF90_PUT_ATT(icout,NF90_GLOBAL,'CONFIG',          config )
    istatus=NF90_PUT_ATT(icout,NF90_GLOBAL,'CASE',             ccase )

    istatus = NF90_CLOSE(incid)

    create=icout
  END FUNCTION create


  INTEGER(KIND=4) FUNCTION createvar(kout, sdtyvar, kvar, kpk, kidvo, cdglobal, ld_nc4)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION createvar  ***
    !!
    !! ** Purpose :  Create kvar  variables cdvar(:), in file id kout,
    !!
    !! ** Method  : INPUT:
    !!                 kout  = ncid of output file
    !!                 cdvar = array of name of variables
    !!                 kvar  = number of variables to create
    !!                 kpk   = number of vertical dimensions foreach variable
    !!             OUTPUT:
    !!                 kidvo = arrays with the varid of the variables just created.
    !!----------------------------------------------------------------------
    INTEGER(KIND=4),                  INTENT(in) :: kout    ! ncid of output file
    TYPE (variable), DIMENSION(kvar) ,INTENT(in) :: sdtyvar ! variable structure
    INTEGER(KIND=4),                  INTENT(in) :: kvar    ! number of variable
    INTEGER(KIND=4), DIMENSION(kvar), INTENT(in) :: kpk     ! number of level/var
    INTEGER(KIND=4), DIMENSION(kvar), INTENT(out):: kidvo   ! varid's of output var
    CHARACTER(LEN=*), OPTIONAL,       INTENT(in) :: cdglobal! Global Attribute
    LOGICAL         , OPTIONAL,       INTENT(in) :: ld_nc4  ! user chunking and deflation

    INTEGER(KIND=4)               :: jv             ! dummy loop index
    INTEGER(KIND=4)               :: idims, istatus 
    INTEGER(KIND=4), DIMENSION(4) :: iidims, ichunk
    INTEGER(KIND=4)               :: iprecision
    LOGICAL                       :: ll_nc4
    !!----------------------------------------------------------------------
    IF ( PRESENT (ld_nc4 ) ) THEN 
       ll_nc4 = ld_nc4
    ELSE
       ll_nc4 = .false. 
    ENDIF

    DO jv = 1, kvar
       ! Create variables whose name is not 'none'
       IF ( sdtyvar(jv)%cname /= 'none' ) THEN
          IF (kpk(jv) == 1 ) THEN
             idims=3
             iidims(1) = nid_x ; iidims(2) = nid_y ; iidims(3) = nid_t
          ELSE IF (kpk(jv) > 1 ) THEN
             idims=4
             iidims(1) = nid_x ; iidims(2) = nid_y ; iidims(3) = nid_z ; iidims(4) = nid_t
          ELSE IF (kpk(jv) < 0 ) THEN
             idims=1
             iidims(1) = nid_t 
          ELSE
             PRINT *,' ERROR: ipk = ',kpk(jv), jv , sdtyvar(jv)%cname
             STOP 98
          ENDIF
    
          SELECT CASE ( sdtyvar(jv)%cprecision ) ! check the precision of the variable to create
          !
          CASE ( 'r8' ) ; iprecision = NF90_DOUBLE
          !
          CASE ( 'i2' ) ; iprecision = NF90_SHORT
          !
          CASE ( 'by' ) ; iprecision = NF90_BYTE
          !
          CASE DEFAULT  ! r4
                          iprecision = NF90_FLOAT
             IF ( sdtyvar(jv)%scale_factor /= 1. .OR. sdtyvar(jv)%add_offset /= 0. ) THEN
                          iprecision = NF90_SHORT
             ENDIF
          END SELECT

#if defined key_netcdf4
         IF ( ll_nc4 ) THEN
          istatus = NF90_DEF_VAR(kout, sdtyvar(jv)%cname, iprecision, iidims(1:idims) ,kidvo(jv), & 
                  &               chunksizes=sdtyvar(jv)%ichunk(1:idims), deflate_level=1 )
         ELSE
          istatus = NF90_DEF_VAR(kout, sdtyvar(jv)%cname, iprecision, iidims(1:idims) ,kidvo(jv) )
         ENDIF
#else
          istatus = NF90_DEF_VAR(kout, sdtyvar(jv)%cname, iprecision, iidims(1:idims) ,kidvo(jv) )
#endif
          ! add attributes
          istatus = putatt(sdtyvar(jv), kout, kidvo(jv), cdglobal=cdglobal)
          createvar=istatus
       ENDIF
    END DO
    istatus = NF90_ENDDEF(kout)

  END FUNCTION createvar


  FUNCTION getvarid( cdfile, knvars )
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION getvarid  ***
    !!
    !! ** Purpose :  return a real array with the nvar variable id 
    !!
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*),       INTENT(in) :: cdfile
    INTEGER(KIND=4),        INTENT(in) :: knvars    ! Number of variables in cdfile
    INTEGER(KIND=4), DIMENSION(knvars) :: getvarid  ! return function

    INTEGER(KIND=4)                       :: jv     ! dummy loop index
    CHARACTER(LEN=256), DIMENSION(knvars) :: cdvar
    INTEGER(KIND=4)                       :: incid
    INTEGER(KIND=4)                       :: istatus
    !!----------------------------------------------------------------------
    istatus = NF90_OPEN(cdfile, NF90_NOWRITE, incid)
    DO jv = 1, knvars
       istatus = NF90_INQUIRE_VARIABLE(incid, jv, cdvar(jv) )
       istatus = NF90_INQ_VARID(incid, cdvar(jv), getvarid(jv))
    ENDDO
    istatus=NF90_CLOSE(incid)

  END FUNCTION getvarid


  INTEGER(KIND=4) FUNCTION getvaratt (cdfile, cdvar, cdunits, pmissing_value, cdlong_name, cdshort_name)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION getvaratt  ***
    !!
    !! ** Purpose : Get specific attributes for a variable (units, missing_value, 
    !!              long_name, short_name
    !!
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*), INTENT(in)  :: cdfile, cdvar
    REAL(KIND=4), INTENT(out)       :: pmissing_value
    CHARACTER(LEN=*), INTENT(out) :: cdunits, cdlong_name, cdshort_name

    INTEGER(KIND=4) :: istatus
    INTEGER(KIND=4) :: incid, ivarid
    !!----------------------------------------------------------------------
    istatus = NF90_OPEN(cdfile, NF90_NOWRITE, incid)
    istatus = NF90_INQ_VARID(incid, cdvar, ivarid)

    istatus = NF90_GET_ATT(incid, ivarid, 'units',           cdunits        )
    pmissing_value = getspval ( cdfile, cdvar )
    istatus = NF90_GET_ATT(incid, ivarid, 'long_name',       cdlong_name    )
    istatus = NF90_GET_ATT(incid, ivarid, 'short_name',      cdshort_name   )

    getvaratt = istatus
    istatus   = NF90_CLOSE(incid)

  END FUNCTION getvaratt


  INTEGER(KIND=4) FUNCTION gettimeatt (cdfile, cdvartime, ctcalendar, cttitle, &
        &                            ctlong_name, ctaxis, ctunits, cttime_origin )
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION gettimeatt  ***
    !!
    !! ** Purpose : Get specific attributes for time variable
    !!
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*), INTENT(in)  :: cdfile
    CHARACTER(LEN=*), INTENT(in)  :: cdvartime
    CHARACTER(LEN=*), INTENT(out) :: ctcalendar, cttitle, ctlong_name, ctaxis, ctunits, cttime_origin

    INTEGER(KIND=4) :: istatus
    INTEGER(KIND=4) :: incid, ivarid
    !!----------------------------------------------------------------------
    ctcalendar    = 'unknown'
    cttitle       = 'unknown'
    ctlong_name   = 'unknown'
    ctaxis        = 'unknown'
    ctunits       = 'unknown'
    cttime_origin = 'unknown'

    istatus = NF90_OPEN(cdfile, NF90_NOWRITE, incid)
    istatus = NF90_INQ_VARID(incid, cdvartime, ivarid)

    istatus = NF90_GET_ATT(incid, ivarid, 'calendar',         ctcalendar    )
    istatus = NF90_GET_ATT(incid, ivarid, 'title',            cttitle       )
    istatus = NF90_GET_ATT(incid, ivarid, 'long_name',        ctlong_name   )
    istatus = NF90_GET_ATT(incid, ivarid, 'axis',             ctaxis        )
    istatus = NF90_GET_ATT(incid, ivarid, 'units',            ctunits       )
    istatus = NF90_GET_ATT(incid, ivarid, 'time_origin',      cttime_origin )

    gettimeatt = istatus
    istatus   = NF90_CLOSE(incid)

  END FUNCTION gettimeatt

  INTEGER(KIND=4) FUNCTION puttimeatt (kout, cdvartime, ctcalendar, cttitle, &
        &                          ctlong_name, ctaxis, ctunits, cttime_origin )
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION puttimeatt  ***
    !!
    !! ** Purpose : Put specific attributes for time variable
    !!
    !!----------------------------------------------------------------------
    INTEGER(KIND=4),     INTENT(in) :: kout
    CHARACTER(LEN=20),  INTENT(in)  :: cdvartime
    CHARACTER(LEN=256), INTENT(in) :: ctcalendar, cttitle, ctlong_name, ctaxis, ctunits, cttime_origin

    INTEGER(KIND=4) :: ivarid
    !!----------------------------------------------------------------------

    puttimeatt=NF90_INQ_VARID(kout, cdvartime, ivarid)
    IF (puttimeatt /= 0 ) THEN 
      PRINT *, NF90_STRERROR(puttimeatt)  ; PRINT *, 'puttimeatt var does not exist' ; STOP 98
    ENDIF
   
    puttimeatt = NF90_REDEF(kout)
    puttimeatt=NF90_PUT_ATT(kout,ivarid,'calendar',ctcalendar)
    IF (puttimeatt /= 0 ) THEN ;PRINT *, NF90_STRERROR(puttimeatt)  ; PRINT *, 'puttimeatt calendar'  ; STOP 98 ; ENDIF
    puttimeatt=NF90_PUT_ATT(kout,ivarid,'title',cttitle)
    IF (puttimeatt /= 0 ) THEN ;PRINT *, NF90_STRERROR(puttimeatt)  ; PRINT *, 'puttimeatt title'     ; STOP 98 ; ENDIF
    puttimeatt=NF90_PUT_ATT(kout,ivarid,'long_name',ctlong_name)
    IF (puttimeatt /= 0 ) THEN ;PRINT *, NF90_STRERROR(puttimeatt)  ; PRINT *, 'puttimeatt long_name' ; STOP 98 ; ENDIF
    puttimeatt=NF90_PUT_ATT(kout,ivarid,'axis',ctaxis)
    IF (puttimeatt /= 0 ) THEN ;PRINT *, NF90_STRERROR(puttimeatt)  ; PRINT *, 'puttimeatt axis'      ; STOP 98 ; ENDIF
    puttimeatt=NF90_PUT_ATT(kout,ivarid,'units',ctunits)
    IF (puttimeatt /= 0 ) THEN ;PRINT *, NF90_STRERROR(puttimeatt)  ; PRINT *, 'puttimeatt units'     ; STOP 98 ; ENDIF
    puttimeatt=NF90_PUT_ATT(kout,ivarid,'time_origin',cttime_origin)
    IF (puttimeatt /= 0 ) THEN ;PRINT *, NF90_STRERROR(puttimeatt)  ; PRINT *,'puttimeatt time_origin'; STOP 98 ; ENDIF

    puttimeatt=NF90_ENDDEF(kout)

  END FUNCTION puttimeatt


  INTEGER(KIND=4) FUNCTION cvaratt (cdfile, cdvar, cdunits, pmissing_value, cdlong_name, cdshort_name)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION cvaratt  ***
    !!
    !! ** Purpose : Change variable attributs in an existing variable
    !!
    !!----------------------------------------------------------------------
    CHARACTER(LEN=256), INTENT(in) :: cdfile, cdvar
    CHARACTER(LEN=256), INTENT(in) :: cdunits, cdlong_name, cdshort_name
    REAL(KIND=4),       INTENT(in) :: pmissing_value

    INTEGER(KIND=4) :: istatus
    INTEGER(KIND=4) :: incid, ivarid
    REAL(KIND=4)    :: zspval
    CHARACTER(LEN=256) :: clmissing   ! get the actual missing_value attribute name
    !!----------------------------------------------------------------------
    istatus = NF90_OPEN (cdfile, NF90_WRITE, incid)
    istatus = NF90_REDEF(incid)
    istatus = NF90_INQ_VARID(incid, cdvar, ivarid)

!   istatus=NF90_RENAME_ATT(incid, ivarid, 'units',         cdunits        )
    istatus=NF90_PUT_ATT(incid, ivarid, 'units',         cdunits        )
    zspval = getspval   ( cdfile, cdvar, clmissing                       )
    istatus=NF90_PUT_ATT(incid, ivarid, clmissing, pmissing_value        )
    istatus=NF90_PUT_ATT(incid, ivarid, 'long_name',     cdlong_name    )
    istatus=NF90_PUT_ATT(incid, ivarid, 'short_name',    cdshort_name   )

    istatus=NF90_ENDDEF(incid)
    cvaratt=istatus
    istatus=NF90_CLOSE(incid)

  END FUNCTION cvaratt


  INTEGER(KIND=4) FUNCTION putatt (sdtyvar, kout, kid, cdglobal)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION putatt  ***
    !!
    !! ** Purpose : Put attribute for variable defined in the data structure 
    !!
    !!----------------------------------------------------------------------
    TYPE (variable),            INTENT(in) :: sdtyvar
    INTEGER(KIND=4),            INTENT(in) :: kout, kid
    CHARACTER(LEN=*), OPTIONAL, INTENT(in) :: cdglobal   !: global attribute
    !!----------------------------------------------------------------------
    putatt=NF90_PUT_ATT(kout,kid,'units',sdtyvar%cunits) 
    IF (putatt /= NF90_NOERR ) THEN ;PRINT *, NF90_STRERROR(putatt)  ; PRINT *, 'putatt units'; STOP 98; ENDIF

    ! With netcdf4, missing value must have the same precision than the variable. Need to convert
    ! to sdtyvar%cprecision previous PUT_ATT
    SELECT CASE (sdtyvar%cprecision )
    CASE ( 'r8' ) ; putatt=NF90_PUT_ATT(kout,kid,cn_missing_value,REAL(sdtyvar%rmissing_value,8) )  
    CASE ( 'i2' ) ; putatt=NF90_PUT_ATT(kout,kid,cn_missing_value, INT(sdtyvar%rmissing_value,2) )  
    CASE ( 'by' ) ; putatt=NF90_PUT_ATT(kout,kid,cn_missing_value, INT(sdtyvar%rmissing_value,1) )  
    CASE DEFAULT  ; putatt=NF90_PUT_ATT(kout,kid,cn_missing_value,REAL(sdtyvar%rmissing_value,4) )
    END SELECT
    IF (putatt /= NF90_NOERR ) THEN ;PRINT *, NF90_STRERROR(putatt)  ; PRINT *, 'putatt missing value'; STOP 98; ENDIF

    putatt=NF90_PUT_ATT(kout,kid,'valid_min',sdtyvar%valid_min) 
    IF (putatt /= NF90_NOERR ) THEN ;PRINT *, NF90_STRERROR(putatt)  ; PRINT *, 'putatt valid_min'    ; STOP 98; ENDIF
    putatt=NF90_PUT_ATT(kout,kid,'valid_max',sdtyvar%valid_max)
    IF (putatt /= NF90_NOERR ) THEN ;PRINT *, NF90_STRERROR(putatt)  ; PRINT *, 'putatt valid_max'    ; STOP 98; ENDIF
    putatt=NF90_PUT_ATT(kout,kid,'long_name',sdtyvar%clong_name)
    IF (putatt /= NF90_NOERR ) THEN ;PRINT *, NF90_STRERROR(putatt)  ; PRINT *, 'putatt longname'     ; STOP 98; ENDIF
    putatt=NF90_PUT_ATT(kout,kid,'short_name',sdtyvar%cshort_name) 
    IF (putatt /= NF90_NOERR ) THEN ;PRINT *, NF90_STRERROR(putatt)  ; PRINT *, 'putatt short name'   ; STOP 98; ENDIF
    putatt=NF90_PUT_ATT(kout,kid,'iweight',sdtyvar%iwght) 
    IF (putatt /= NF90_NOERR ) THEN ;PRINT *, NF90_STRERROR(putatt)  ; PRINT *, 'putatt iweight'      ; STOP 98; ENDIF
    putatt=NF90_PUT_ATT(kout,kid,'online_operation',sdtyvar%conline_operation) 
    IF (putatt /= NF90_NOERR ) THEN ;PRINT *, NF90_STRERROR(putatt)  ; PRINT *, 'putatt online oper'  ; STOP 98; ENDIF
    putatt=NF90_PUT_ATT(kout,kid,'axis',sdtyvar%caxis) 
    IF (putatt /= NF90_NOERR ) THEN ;PRINT *, NF90_STRERROR(putatt)  ; PRINT *, 'putatt axis'         ; STOP 98; ENDIF

    ! Optional attributes (scale_factor, add_offset )
    putatt=NF90_PUT_ATT(kout,kid,'scale_factor',sdtyvar%scale_factor) 
    IF (putatt /= NF90_NOERR ) THEN ;PRINT *, NF90_STRERROR(putatt)  ; PRINT *, 'putatt scale fact'; STOP 98; ENDIF
    putatt=NF90_PUT_ATT(kout,kid,'add_offset',sdtyvar%add_offset) 
    IF (putatt /= NF90_NOERR ) THEN ;PRINT *, NF90_STRERROR(putatt)  ; PRINT *, 'putatt add offset'; STOP 98; ENDIF
    putatt=NF90_PUT_ATT(kout,kid,'savelog10',sdtyvar%savelog10) 
    IF (putatt /= NF90_NOERR ) THEN ;PRINT *, NF90_STRERROR(putatt)  ; PRINT *, 'putatt savelog0'  ; STOP 98; ENDIF

    ! Global attribute
    IF ( PRESENT(cdglobal) ) THEN
      putatt=NF90_PUT_ATT(kout,NF90_GLOBAL,'history',cdglobal)
      IF (putatt /= NF90_NOERR ) THEN ;PRINT *, NF90_STRERROR(putatt)  ; PRINT *, 'putatt global'  ; STOP 98; ENDIF
    ENDIF

  END FUNCTION putatt


  REAL(KIND=4) FUNCTION getatt (cdfile, cdvar, cdatt)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION getatt  ***
    !!
    !! ** Purpose : return a REAL value with the values of the
    !!              attribute cdatt for all the variable cdvar in cdfile  
    !!
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*), INTENT(in) :: cdfile  ! file name
    CHARACTER(LEN=*), INTENT(in) :: cdvar   ! var name
    CHARACTER(LEN=*), INTENT(in) :: cdatt   ! attribute name to look for

    INTEGER(KIND=4) :: istatus, jv, incid, idum
    !!----------------------------------------------------------------------
    istatus = NF90_OPEN  (cdfile, NF90_NOWRITE, incid)
    istatus = NF90_INQ_VARID(incid, cdvar, idum)

    IF ( istatus /= NF90_NOERR) PRINT *, TRIM(NF90_STRERROR(istatus)),' when looking for ',TRIM(cdvar),' in getatt.'

    istatus = NF90_GET_ATT(incid, idum, cdatt, getatt)
    IF ( istatus /= NF90_NOERR ) THEN
       PRINT *,' getatt problem :',NF90_STRERROR(istatus)
       PRINT *,' attribute :', TRIM(cdatt)
       PRINT *,' variable  :', TRIM(cdvar)
       PRINT *,' file      :', TRIM(cdfile)
       PRINT *,' return default 0 '
       getatt=0.
    ENDIF

    istatus=NF90_CLOSE(incid)

  END FUNCTION getatt


  INTEGER(KIND=4) FUNCTION atted_char ( cdfile, cdvar, cdatt, cdvalue )
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION atted_char  ***
    !!
    !! ** Purpose : attribute editor : modify existing attribute or create
    !!              new attribute for variable cdvar in cdfile 
    !!
    !! ** Method  : just put_att after some check.
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*),  INTENT(in) :: cdfile  ! input file
    CHARACTER(LEN=*),  INTENT(in) :: cdvar   ! variable name
    CHARACTER(LEN=*),  INTENT(in) :: cdatt   ! attribute  name
    CHARACTER(LEN=*),  INTENT(in) :: cdvalue ! attribute value

    INTEGER(KIND=4)               :: incid,  istatus, idvar, ityp
    !!-------------------------------------------------------------------------
    istatus = NF90_OPEN(cdfile, NF90_WRITE, incid)
    istatus = NF90_INQ_VARID(incid, cdvar, idvar)
    IF ( istatus /= NF90_NOERR ) THEN
       PRINT *, NF90_STRERROR(istatus),' in atted ( inq_varid)'
       STOP 98
    ENDIF
    istatus = NF90_INQUIRE_ATTRIBUTE(incid, idvar, cdatt, xtype=ityp )
    IF ( istatus /= NF90_NOERR ) THEN
       PRINT *, ' Attribute does not exist. Create it'
       istatus = NF90_REDEF(incid)
       istatus = NF90_PUT_ATT(incid, idvar, cdatt, cdvalue)
       atted_char = istatus
    ELSE
       IF ( ityp == NF90_CHAR ) THEN
         istatus = NF90_REDEF(incid)
         istatus = NF90_PUT_ATT(incid, idvar, cdatt, cdvalue)
         atted_char = istatus
       ELSE
         PRINT *, ' Mismatch in attribute type in atted_char'
         STOP 98
       ENDIF
    ENDIF
    istatus=NF90_CLOSE(incid)

  END FUNCTION atted_char


  INTEGER(KIND=4) FUNCTION atted_r4 ( cdfile, cdvar, cdatt, pvalue )
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION atted_r4  ***
    !!
    !! ** Purpose : attribute editor : modify existing attribute or create
    !!              new attribute for variable cdvar in cdfile
    !!
    !! ** Method  : just put_att after some check.
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*),  INTENT(in) :: cdfile  ! input file
    CHARACTER(LEN=*),  INTENT(in) :: cdvar   ! variable name
    CHARACTER(LEN=*),  INTENT(in) :: cdatt   ! attribute  name
    REAL(KIND=4),      INTENT(in) :: pvalue  ! attribute value

    INTEGER(KIND=4)               :: incid,  istatus, idvar, ityp
    !!-------------------------------------------------------------------------
    istatus = NF90_OPEN(cdfile, NF90_WRITE, incid)
    istatus = NF90_INQ_VARID(incid, cdvar, idvar)
    IF ( istatus /= NF90_NOERR ) THEN
       PRINT *, NF90_STRERROR(istatus),' in atted ( inq_varid)'
       STOP 98
    ENDIF
    istatus = NF90_INQUIRE_ATTRIBUTE(incid, idvar, cdatt, xtype=ityp )
    IF ( istatus /= NF90_NOERR ) THEN
       PRINT *, ' Attribute does not exist. Create it'
       istatus = NF90_REDEF(incid)
       istatus = NF90_PUT_ATT(incid, idvar, cdatt, pvalue)
       atted_r4 = istatus
    ELSE
       IF ( ityp == NF90_FLOAT ) THEN
         istatus = NF90_REDEF(incid)
         istatus = NF90_PUT_ATT(incid, idvar, cdatt, pvalue)
         atted_r4 = istatus
       ELSE
         PRINT *, ' Mismatch in attribute type in atted_r4'
         STOP 98
       ENDIF
    ENDIF
    istatus=NF90_CLOSE(incid)

  END FUNCTION atted_r4


  INTEGER(KIND=4)  FUNCTION  getdim (cdfile, cdim_name, cdtrue, kstatus, ldexact)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION getdim  ***
    !!
    !! ** Purpose : Return the INTEGER value of the dimension
    !!              identified with cdim_name in cdfile 
    !!
    !! ** Method  : This function look for a dimension name that contains 
    !!              cdim_name, in cdfile. In option it returns the error 
    !!              status which can be used to make another intent, changing 
    !!              the dim name. Finally, with the last optional argument 
    !!              ldexact, exact match to cdim_name can be required.
    !!              
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*),             INTENT(in ) :: cdfile     ! File name to look at
    CHARACTER(LEN=*),             INTENT(in ) :: cdim_name  ! File name to look at
    CHARACTER(LEN=256), OPTIONAL, INTENT(out) :: cdtrue     ! full name of the read dimension
    INTEGER(KIND=4),    OPTIONAL, INTENT(out) :: kstatus    ! status of the nf inquire
    LOGICAL,            OPTIONAL, INTENT(in ) :: ldexact    ! when true look for exact cdim_name

    INTEGER(KIND=4)    :: jdim
    INTEGER(KIND=4)    :: incid, id_dim, idv
    INTEGER(KIND=4)    :: istatus
    INTEGER(KIND=4)    :: idims
    CHARACTER(LEN=256) :: clnam
    LOGICAL            :: lexact   = .false.
    LOGICAL, SAVE      :: ll_first = .true.
    !!-----------------------------------------------------------
    clnam = '-------------'

    IF ( PRESENT(kstatus)  ) kstatus=0
    IF ( PRESENT(ldexact)  ) lexact=ldexact
    IF ( cdim_name == cn_x ) lexact=.true.  ! fix for XIOS files having now a new dimension xaxis_bound which match getdim ('x') ....
                                            ! more clever fix must be found for identification of the dimensions in the input files
    istatus=NF90_OPEN(cdfile, NF90_NOWRITE, incid)
    IF ( istatus == NF90_NOERR ) THEN
       istatus=NF90_INQUIRE(incid, ndimensions=idims)

       IF ( lexact ) THEN
          istatus=NF90_INQ_DIMID(incid, cdim_name, id_dim)
          IF (istatus /= NF90_NOERR ) THEN
            PRINT *,NF90_STRERROR(istatus)
            PRINT *,' Exact dimension name ', TRIM(cdim_name),' not found in ',TRIM(cdfile) ; STOP
          ENDIF
          istatus=NF90_INQUIRE_DIMENSION(incid, id_dim, len=getdim)
          IF ( PRESENT(cdtrue) ) cdtrue=cdim_name
          jdim = 0
       ELSE  ! scann all dims to look for a partial match
         DO jdim = 1, idims
            istatus=NF90_INQUIRE_DIMENSION(incid, jdim, name=clnam, len=getdim)
            IF ( INDEX(clnam, TRIM(cdim_name)) /= 0 ) THEN
               IF ( PRESENT(cdtrue) ) cdtrue=clnam
               EXIT
            ENDIF
         ENDDO
       ENDIF

       IF ( jdim > idims ) THEN   ! dimension not found
          IF ( PRESENT(kstatus) ) kstatus=1    ! error send optionally to the calling program
          getdim=0
          IF ( PRESENT(cdtrue) ) cdtrue='unknown'
       ENDIF
       ! first call 
       IF ( ll_first ) THEN
          ll_first = .false. 
          ! take the opportunity to initialize time_counter attributes :
          istatus = NF90_INQ_VARID(incid, cn_vtimec, idv )
          IF ( istatus == NF90_NOERR ) THEN 
             istatus = NF90_GET_ATT(incid, idv, 'units',  ctime_units  )
             istatus = NF90_GET_ATT(incid, idv, 'time_origin', ctime_origin )
             istatus = NF90_GET_ATT(incid, idv, 'calendar',    calendar     )
          ENDIF
 
          ! read global attributes 

          ! start_date
          cl_dum = Get_Env ( 'start_date' )  ! look for environment variable
          istatus = NF90_INQUIRE_ATTRIBUTE(incid, NF90_GLOBAL, 'start_date')
          IF ( istatus == NF90_NOERR ) THEN
             istatus = NF90_GET_ATT(incid, NF90_GLOBAL, 'start_date', nstart_date )
          ELSE IF ( cl_dum /= '' ) THEN 
             READ(cl_dum, * ) nstart_date
          ELSE
             nstart_date = -1
          ENDIF

          ! output_frequency 
          cl_dum = Get_Env ( 'output_frequency' )  ! look for environment variable
          istatus = NF90_INQUIRE_ATTRIBUTE(incid, NF90_GLOBAL, 'output_frequency')
          IF ( istatus == NF90_NOERR ) THEN
             istatus = NF90_GET_ATT(incid, NF90_GLOBAL, 'output_frequency', cfreq )
          ELSE IF ( cl_dum /= '' ) THEN
             cfreq = TRIM(cl_dum)
          ELSE
             cfreq = 'N/A'
          ENDIF

          ! CONFIG
          cl_dum = Get_Env ( 'CONFIG' )  ! look for environment variable
          istatus = NF90_INQUIRE_ATTRIBUTE(incid, NF90_GLOBAL, 'CONFIG')
          IF ( istatus == NF90_NOERR ) THEN
             istatus = NF90_GET_ATT(incid, NF90_GLOBAL, 'CONFIG', config )
          ELSE IF ( cl_dum /= '' ) THEN
             config = TRIM(cl_dum)
          ELSE
             config = 'N/A'
          ENDIF

          ! CASE
          cl_dum = Get_Env ( 'CASE' )  ! look for environment variable
          istatus = NF90_INQUIRE_ATTRIBUTE(incid, NF90_GLOBAL, 'CASE')
          IF ( istatus == NF90_NOERR ) THEN
             istatus = NF90_GET_ATT(incid, NF90_GLOBAL, 'CASE', ccase )
          ELSE IF ( cl_dum /= '' ) THEN
             ccase = TRIM(cl_dum)
          ELSE
             ccase = 'N/A'
          ENDIF
       ENDIF
       istatus=NF90_CLOSE(incid)
    ELSE              ! problem with the file
       IF ( PRESENT(cdtrue) ) cdtrue='unknown'
       IF ( PRESENT(kstatus) ) kstatus=1 
    ENDIF
    ! reset lexact to false for next call 
    lexact=.false.

  END FUNCTION getdim


  REAL(KIND=4) FUNCTION  getspval (cdfile, cdvar, cdmissing )
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION getspval  ***
    !!
    !! ** Purpose : return the SPVAL value of the variable cdvar in cdfile
    !!
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*),           INTENT(in ) :: cdfile    ! File name to look at
    CHARACTER(LEN=*),           INTENT(in ) :: cdvar     ! variable name
    CHARACTER(LEN=*), OPTIONAL, INTENT(out) :: cdmissing ! missing att. name

    INTEGER(KIND=4) :: incid, id_var
    INTEGER(KIND=4) :: istatus
    INTEGER(KIND=4) :: jtry
    !!----------------------------------------------------------------------

    IF ( PRESENT (cdmissing) ) cdmissing = cn_missing_value

    istatus=NF90_OPEN      (cdfile, NF90_NOWRITE, incid               )
    istatus=NF90_INQ_VARID (incid, cdvar, id_var                      )
    istatus=NF90_GET_ATT   (incid, id_var, cn_missing_value, getspval )

    IF ( istatus /= NF90_NOERR ) THEN 
      DO jtry = 1, jp_missing_nm
         IF ( PRESENT (cdmissing) ) cdmissing = TRIM(cl_missing_nm(jtry))
         istatus = NF90_GET_ATT (incid, id_var, cl_missing_nm(jtry) , getspval )
         IF ( istatus == NF90_NOERR ) EXIT
         IF ( PRESENT (cdmissing) ) cdmissing = cn_missing_value
         getspval = 0.
      ENDDO
    ENDIF
    istatus=NF90_CLOSE     (incid )

  END FUNCTION getspval


  INTEGER(KIND=4) FUNCTION getvdim (cdfile, cdvar)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION getvdim  ***
    !!
    !! ** Purpose : Return the number of dimensions for variable cdvar in cdfile 
    !!
    !! ** Method  : Inquire for variable cdvar in cdfile. If found,
    !!              determines the number of dimensions , assuming that variables
    !!              are either (x,y,dep,time) or (x,y,time)
    !!              If cdvar is not found, give an interactive choice for an existing
    !!              variable, cdvar is then updated to this correct name.  
    !!
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*), INTENT(in)    :: cdfile   ! File name to look at
    CHARACTER(LEN=*), INTENT(inout) :: cdvar    ! variable name to look at.

    INTEGER(KIND=4)    :: jvar
    INTEGER(KIND=4)    :: istatus, incid, id_var, ivar, idi, istatus0
    CHARACTER(LEN=256) :: clongname='long_name', clongn
    !!----------------------------------------------------------------------
    CALL ERR_HDL(NF90_OPEN(cdfile,NF90_NOWRITE,incid))

    istatus0 = NF90_INQ_VARID ( incid,cdvar,id_var)
    DO WHILE  ( istatus0 == NF90_ENOTVAR ) 
       ivar=getnvar(cdfile)
       PRINT *, 'Give the number corresponding to the variable you want to work with '
       DO jvar = 1, ivar
          clongn=''
          istatus=NF90_INQUIRE_VARIABLE (incid, jvar, cdvar, ndims=idi)
          istatus=NF90_GET_ATT (incid, jvar, clongname, clongn)
          IF (istatus /= NF90_NOERR ) clongn='unknown'
          PRINT *, jvar, ' ',TRIM(cdvar),' ',TRIM(clongn)
       ENDDO
       READ *,id_var
       istatus0=NF90_INQUIRE_VARIABLE (incid, id_var, cdvar, ndims=idi)
    ENDDO
    ! 
    CALL ERR_HDL(NF90_INQUIRE_VARIABLE (incid, id_var, cdvar, ndims=idi))
    getvdim = idi - 1
    CALL ERR_HDL (NF90_CLOSE(incid))

  END FUNCTION getvdim

  FUNCTION getdimvar (cdfile, kpk, cd_depnam)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION getdimvar  ***
    !!
    !! ** Purpose :  Try to infer the name of the depth variable associated
    !!               with z dimension, and return the values as a 1d array 
    !!
    !! ** Method  :  Trial and error method ... 
    !!
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*), INTENT(in) :: cdfile
    INTEGER(KIND=4),  INTENT(in) :: kpk
    REAL(KIND=4), DIMENSION(kpk) :: getdimvar
    CHARACTER(LEN=*), OPTIONAL, INTENT(out) :: cd_depnam

    INTEGER(KIND=4) :: ji
    INTEGER(KIND=4) :: incid, idims, iuldid, idimv, ivars, istatus
    INTEGER(KIND=4), DIMENSION(4) :: idimt
    CHARACTER(LEN=80) :: clvar ='none'
    
    !!----------------------------------------------------------------------
    istatus = NF90_OPEN   (cdfile,NF90_NOWRITE,incid)
    istatus = NF90_INQUIRE(incid, ndimensions=idims, unlimiteddimid=iuldid,&
                  &              nvariables=ivars)
    ! look for variables with only one dim, not unlimited dim ...
    DO ji = 1, ivars
       istatus = NF90_INQUIRE_VARIABLE(incid, ji, name=clvar, ndims=idimv, &
                  & dimids=idimt )
       IF ( idimv == 1 ) THEN ! candidate
          IF ( idimt(1) /= iuldid) THEN ! this is The Variable
             PRINT *, ' Found vertical variable :', TRIM(clvar)
             istatus = NF90_GET_VAR(incid, ji, getdimvar(:) )
             EXIT
          ENDIF
       ENDIF
    ENDDO
    IF ( present(cd_depnam) ) cd_depnam=TRIM(clvar)
    IF ( ji == ivars +1 ) THEN
       PRINT *,'Sorry, no vertical dim variables inferred ...'
       getdimvar=0.
    ENDIF

  END FUNCTION

  INTEGER(KIND=4) FUNCTION  getnvar (cdfile)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION getnvar  ***
    !!
    !! ** Purpose :  return the number of variables in cdfile 
    !!
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*), INTENT(in) ::  cdfile   ! file to look at

    INTEGER(KIND=4) :: incid
    INTEGER(KIND=4) :: istatus
    !!----------------------------------------------------------------------
    istatus = NF90_OPEN    (cdfile, NF90_NOWRITE, incid )
    istatus = NF90_INQUIRE (incid, nvariables = getnvar )
    istatus = NF90_CLOSE   (incid )

  END FUNCTION getnvar


  FUNCTION  getipk (cdfile,knvars,cdep)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION getipk  ***
    !!
    !! ** Purpose : Return the number of levels for all the variables
    !!              in cdfile. Return 0 if the variable in 1d.
    !!
    !! ** Method  : returns npk when 4D variables ( x,y,z,t )
    !!              returns  1  when 3D variables ( x,y,  t )
    !!              returns  0  when other ( vectors )
    !!
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*),           INTENT(in) :: cdfile   ! File to look at
    INTEGER(KIND=4),            INTENT(in) ::  knvars  ! Number of variables in cdfile
    CHARACTER(LEN=*), OPTIONAL, INTENT(in) :: cdep     ! optional depth dim name
    INTEGER(KIND=4), DIMENSION(knvars)     :: getipk   ! array (variables ) of levels

    INTEGER(KIND=4)    :: incid, ipk, jv, iipk
    INTEGER(KIND=4)    :: istatus
    CHARACTER(LEN=256) :: cldep='dep'
    !!----------------------------------------------------------------------
    istatus=NF90_OPEN(cdfile,NF90_NOWRITE,incid)

    IF (  PRESENT (cdep) ) cldep = cdep

    ! Note the very important TRIM below : if not, getdim crashes as it never find the correct dim !
    iipk = getdim(cdfile, TRIM(cldep), kstatus=istatus)

    IF ( istatus /= 0 ) THEN
       PRINT *,' getipk : vertical dim not found ...assume 1'
       iipk=1
    ENDIF

    DO jv = 1, knvars
       istatus=NF90_INQUIRE_VARIABLE(incid, jv, ndims=ipk)
       IF (ipk == 4 ) THEN
          getipk(jv) = iipk
       ELSE IF (ipk == 3 ) THEN
          getipk(jv) = 1
       ELSE
          getipk(jv) = 0
       ENDIF
    END DO

    istatus=NF90_CLOSE(incid)

  END FUNCTION getipk


  FUNCTION  getvarname (cdfile, knvars, sdtypvar)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION getvarname  ***
    !!
    !! ** Purpose : return a character array with the knvars variable
    !!              name corresponding to cdfile 
    !!
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*),          INTENT(in) :: cdfile
    INTEGER(KIND=4),           INTENT(in) :: knvars    ! Number of variables in cdfile
    TYPE (variable),   DIMENSION (knvars) :: sdtypvar  ! Retrieve variables attribute
    CHARACTER(LEN=256), DIMENSION(knvars) :: getvarname

    INTEGER(KIND=4)    :: incid,  jv, ilen
    INTEGER(KIND=4)    :: istatus
    INTEGER(KIND=4)    :: iatt
    REAL(KIND=4)       :: zatt
    CHARACTER(LEN=256) :: cldum=''
    !!----------------------------------------------------------------------
    istatus=NF90_OPEN(cdfile,NF90_NOWRITE,incid)

    DO jv = 1, knvars
       istatus=NF90_INQUIRE_VARIABLE(incid, jv, name=getvarname(jv) )
       sdtypvar(jv)%cname=getvarname(jv)


       ! look for standard attibutes
       IF ( NF90_INQUIRE_ATTRIBUTE(incid, jv, 'units', len=ilen) == NF90_NOERR ) THEN
          istatus=NF90_GET_ATT(incid, jv, 'units', cldum(1:ilen))
          sdtypvar(jv)%cunits = TRIM(cldum)
          cldum = ''
       ELSE 
          sdtypvar(jv)%cunits = 'N/A'
       ENDIF

       sdtypvar(jv)%rmissing_value = getspval ( cdfile, sdtypvar(jv)%cname )

       IF ( NF90_INQUIRE_ATTRIBUTE(incid, jv, 'valid_min') == NF90_NOERR ) THEN
          istatus=NF90_GET_ATT(incid, jv, 'valid_min', zatt)
          sdtypvar(jv)%valid_min = zatt
       ELSE
          sdtypvar(jv)%valid_min = 0.
       ENDIF

       IF ( NF90_INQUIRE_ATTRIBUTE(incid, jv, 'valid_max') == NF90_NOERR ) THEN
          istatus=NF90_GET_ATT(incid, jv, 'valid_max', zatt)
          sdtypvar(jv)%valid_max = zatt
       ELSE
          sdtypvar(jv)%valid_max = 0.
       ENDIF

       IF ( NF90_INQUIRE_ATTRIBUTE(incid, jv, 'iweight') == NF90_NOERR ) THEN
          istatus=NF90_GET_ATT(incid, jv, 'iweight', iatt)
          sdtypvar(jv)%iwght = iatt
       ELSE
          sdtypvar(jv)%iwght = 1
       ENDIF

       IF ( NF90_INQUIRE_ATTRIBUTE(incid, jv, 'long_name', len=ilen) == NF90_NOERR ) THEN
          istatus=NF90_GET_ATT(incid, jv, 'long_name', cldum(1:ilen))
          sdtypvar(jv)%clong_name = TRIM(cldum)
          cldum = ''
       ELSE
          sdtypvar(jv)%clong_name = 'N/A'
       ENDIF

       IF ( NF90_INQUIRE_ATTRIBUTE(incid, jv, 'short_name', len=ilen) == NF90_NOERR ) THEN
          istatus=NF90_GET_ATT(incid, jv, 'short_name', cldum(1:ilen))
          sdtypvar(jv)%cshort_name = TRIM(cldum)
          cldum = ''
       ELSE
          sdtypvar(jv)%cshort_name = 'N/A'
       ENDIF

       IF ( NF90_INQUIRE_ATTRIBUTE(incid, jv, 'online_operation', len=ilen) == NF90_NOERR ) THEN
          istatus=NF90_GET_ATT(incid, jv, 'online_operation', cldum(1:ilen))
          sdtypvar(jv)%conline_operation = TRIM(cldum)
          cldum = ''
       ELSE
          sdtypvar(jv)%conline_operation = 'N/A'
       ENDIF

       IF ( NF90_INQUIRE_ATTRIBUTE(incid, jv, 'axis', len=ilen) == NF90_NOERR ) THEN
          istatus=NF90_GET_ATT(incid, jv, 'axis', cldum(1:ilen))
          sdtypvar(jv)%caxis = TRIM(cldum)
          cldum = ''
       ELSE
          sdtypvar(jv)%caxis = 'N/A'
       ENDIF

    END DO
    istatus=NF90_CLOSE(incid)

  END FUNCTION getvarname


  FUNCTION  getvar (cdfile,cdvar,klev,kpi,kpj,kimin,kjmin, ktime, ldiom)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION  getvar  ***
    !!
    !! ** Purpose : Return the 2D REAL variable cvar, from cdfile at level klev.
    !!              kpi,kpj are the horizontal size of the 2D variable
    !!
    !! ** Method  : Initially a quite straigth forward function. But with the
    !!              NEMO variation about the e3t in partial steps, I try to adapt
    !!              the code to all existing mesh_zgr format, which reduces the
    !!              readibility of the code. One my think of specific routine for
    !!              getvar (e3._ps ...)
    !!
    !!---------------------------------------------------------------------
    CHARACTER(LEN=*),          INTENT(in) :: cdfile       ! file name to work with
    CHARACTER(LEN=*),          INTENT(in) :: cdvar        ! variable name to work with
    INTEGER(KIND=4), OPTIONAL, INTENT(in) :: klev         ! Optional variable. If missing 1 is assumed
    INTEGER(KIND=4),           INTENT(in) :: kpi, kpj     ! horizontal size of the 2D variable
    INTEGER(KIND=4), OPTIONAL, INTENT(in) :: kimin, kjmin ! Optional variable. If missing 1 is assumed
    INTEGER(KIND=4), OPTIONAL, INTENT(in) :: ktime        ! Optional variable. If missing 1 is assumed
    LOGICAL,         OPTIONAL, INTENT(in) :: ldiom        ! Optional variable. If missing false is assumed
    REAL(KIND=4), DIMENSION(kpi,kpj) :: getvar            ! 2D REAL 4 holding variable field at klev

    INTEGER(KIND=4), DIMENSION(4)               :: istart, icount, inldim
    INTEGER(KIND=4)                             :: incid, id_var, id_dimunlim, inbdim, inbdim2
    INTEGER(KIND=4)                             :: istatus, ilev, imin, jmin
    INTEGER(KIND=4)                             :: itime, ilog, ipiglo, imax
    INTEGER(KIND=4), SAVE                       :: ii, ij, ik0, ji, jj, ik1, ik
    REAL(KIND=4)                                :: sf=1., ao=0.        !: Scale factor and add_offset
    REAL(KIND=4)                                :: spval  !: missing value
    REAL(KIND=4) , DIMENSION (:,:), ALLOCATABLE :: zend, zstart
    CHARACTER(LEN=256)                          :: clvar
    LOGICAL                                     :: lliom=.false., llperio=.false.
    LOGICAL                                     :: llog=.FALSE. , lsf=.FALSE. , lao=.FALSE.
    !!
    INTEGER(KIND=4)                :: ityp
    !INTEGER(KIND=4), DIMENSION(:)  :: dimids
    !INTEGER(KIND=4)                :: nAtts
    !!---------------------------------------------------------------------
    llperio=.false.
    IF (PRESENT(klev) ) THEN
       ilev=klev
    ELSE
       ilev=1
    ENDIF

    IF (PRESENT(kimin) ) THEN
       imin=kimin

       ipiglo=getdim(cdfile, cn_x, ldexact=.true.)
       IF (imin+kpi-1 > ipiglo ) THEN 
         llperio=.true.
         imax=kpi+1 +imin -ipiglo
       ENDIF
    ELSE
       imin=1
    ENDIF

    IF (PRESENT(kjmin) ) THEN
       jmin=kjmin
    ELSE
       jmin=1
    ENDIF

    IF (PRESENT(ktime) ) THEN
       itime=ktime
    ELSE
       itime=1
    ENDIF

    IF (PRESENT(ldiom) ) THEN
       lliom=ldiom
    ELSE
       lliom=.false.
    ENDIF

    clvar=cdvar

    ! Must reset the flags to false for every call to getvar
    llog = .FALSE.
    lsf  = .FALSE.
    lao  = .FALSE.

    CALL ERR_HDL(NF90_OPEN(cdfile,NF90_NOWRITE,incid) )

    IF ( lliom) THEN  ! try to detect if input file is a zgr IOM file, looking for e3t_0
      istatus=NF90_INQ_VARID( incid,'e3t_0', id_var)
      istatus=NF90_INQUIRE_VARIABLE( incid, id_var, xtype=ityp, ndims=inbdim) !, dimids, nAtts)
      IF ( istatus == NF90_NOERR ) THEN
        ! iom file , change names
        ! now try to detect if it is v2 or v3, in v3, e3t_ps exist and is a 2d variable
         istatus=          NF90_INQ_VARID( incid,'e3t_ps', id_var)
         istatus=istatus + NF90_INQUIRE_VARIABLE( incid, id_var, xtype=ityp, ndims=inbdim2) !, dimids, nAtts)
         !istatus2=NF90_INQUIRE_VAR( incid, id_var, 'e3t_0', xtype, ndims, dimids, nAtts)
         PRINT *, 'e3t_0 has' , inbdim, 'dimensions'
         IF ( istatus == NF90_NOERR ) THEN  
           ! case of NEMO_v3 zfr files
           ! look for mbathy and out it in memory, once for all
           IF ( .NOT. l_mbathy ) THEN
             PRINT *,'MESH_ZGR V3 detected'
             l_mbathy=.true.
             istatus=NF90_INQ_DIMID(incid,'x',id_var) ; istatus=NF90_INQUIRE_DIMENSION(incid,id_var, len=ii )
             istatus=NF90_INQ_DIMID(incid,'y',id_var) ; istatus=NF90_INQUIRE_DIMENSION(incid,id_var, len=ij )
             istatus=NF90_INQ_DIMID(incid,'z',id_var) ; istatus=NF90_INQUIRE_DIMENSION(incid,id_var, len=ik0)

             ALLOCATE( mbathy(ii,ij))               ! mbathy is allocated on the whole domain
             ALLOCATE( e3t_ps(ii,ij),e3w_ps(ii,ij)) ! e3._ps  are  allocated on the whole domain
             ALLOCATE( e3t_0(ik0), e3w_0(ik0) )     ! whole depth

             istatus=NF90_INQ_VARID (incid,'mbathy', id_var)
             IF ( istatus /=  NF90_NOERR ) THEN
               PRINT *, 'Problem reading mesh_zgr.nc v3 : no mbathy found !' ; STOP 98
             ENDIF
             istatus=NF90_GET_VAR(incid,id_var, mbathy, start=(/1,1,1/), count=(/ii,ij,1/) )
             !
             istatus=NF90_INQ_VARID (incid,'e3t_ps', id_var)
             IF ( istatus /=  NF90_NOERR ) THEN
               PRINT *, 'Problem reading mesh_zgr.nc v3 : no e3t_ps found !' ; STOP 98
             ENDIF
             istatus=NF90_GET_VAR(incid,id_var,e3t_ps, start=(/1,1,1/), count=(/ii,ij,1/) )
             !
             istatus=NF90_INQ_VARID (incid,'e3w_ps', id_var)
             IF ( istatus /=  NF90_NOERR ) THEN
               PRINT *, 'Problem reading mesh_zgr.nc v3 : no e3w_ps found !' ; STOP 98
             ENDIF
             istatus=NF90_GET_VAR(incid,id_var,e3w_ps, start=(/1,1,1/), count=(/ii,ij,1/) )
             !
             istatus=NF90_INQ_VARID (incid,'e3t_0', id_var)
             IF ( istatus /=  NF90_NOERR ) THEN
               PRINT *, 'Problem reading mesh_zgr.nc v3 : no e3t_0 found !' ; STOP 98
             ENDIF
             istatus=NF90_GET_VAR(incid,id_var,e3t_0, start=(/1,1/), count=(/ik0,1/) )
             !
             istatus=NF90_INQ_VARID (incid,'e3w_0', id_var)
             IF ( istatus /=  NF90_NOERR ) THEN
               PRINT *, 'Problem reading mesh_zgr.nc v3 : no e3w_0 found !' ; STOP 98
             ENDIF
             istatus=NF90_GET_VAR(incid,id_var,e3w_0, start=(/1,1/), count=(/ik0,1/) )
             DO ji=1,ii
                DO jj=1,ij
                   IF ( e3t_ps (ji,jj) == 0 .AND. mbathy(ji,jj) /= 0 ) e3t_ps(ji,jj)=e3t_0(mbathy(ji,jj))
                END DO
             END DO
           ENDIF
          ! zgr v3
          SELECT CASE ( clvar )
           CASE ('e3u_ps')  ; clvar='e3u_ps'
           CASE ('e3v_ps')  ; clvar='e3v_ps'
           CASE ('e3w_ps')  ; clvar='e3w_ps'
          END SELECT

         ELSEIF ( inbdim>2 ) THEN
          !  case of NEMO_V3.6 STABLE zgr file
          SELECT CASE ( clvar )
           CASE ('e3t_ps')  ; clvar='e3t_0'
           CASE ('e3u_ps')  ; clvar='e3u_0'
           CASE ('e3v_ps')  ; clvar='e3v_0'
           CASE ('e3w_ps')  ; clvar='e3w_0'
          END SELECT
          
         ELSE
          ! zgr v2
          SELECT CASE ( clvar )
           CASE ('e3t_ps')  ; clvar='e3t'
           CASE ('e3u_ps')  ; clvar='e3u'
           CASE ('e3v_ps')  ; clvar='e3v'
           CASE ('e3w_ps')  ; clvar='e3w'
          END SELECT
         ENDIF
      ENDIF
    ENDIF

    istatus=NF90_INQUIRE(incid, unlimitedDimId=id_dimunlim)
    CALL ERR_HDL(NF90_INQ_VARID ( incid,clvar,id_var))
    ! look for time dim in variable
    inldim=0
    istatus=NF90_INQUIRE_VARIABLE(incid, id_var, ndims=inbdim,dimids=inldim(:) )

    istart(1) = imin
    istart(2) = jmin
    ! JMM ! it workd for X Y Z T file,   not for X Y T .... try to found a fix !
    IF ( inldim(3) == id_dimunlim ) THEN
    istart(3) = itime
    istart(4) = 1
    ELSE
    istart(3) = ilev
    istart(4) = itime
    ENDIF

    icount(1)=kpi
    icount(2)=kpj
    icount(3)=1
    icount(4)=1

    spval = getspval ( cdfile, cdvar)  ! try many kind of missing_value (eg _FillValue _Fillvalue Fillvalue ...)

    istatus=NF90_INQUIRE_ATTRIBUTE(incid,id_var,'savelog10')
    IF (istatus == NF90_NOERR ) THEN
       ! there is a scale factor for this variable
       istatus=NF90_GET_ATT(incid,id_var,'savelog10',ilog)
       IF ( ilog /= 0 ) llog=.TRUE.
    ENDIF

    istatus=NF90_INQUIRE_ATTRIBUTE(incid,id_var,'scale_factor')
    IF (istatus == NF90_NOERR ) THEN
       ! there is a scale factor for this variable
       istatus=NF90_GET_ATT(incid,id_var,'scale_factor',sf)
       IF ( sf /= 1. ) lsf=.TRUE.
    ENDIF

    istatus=NF90_INQUIRE_ATTRIBUTE(incid,id_var,'add_offset')
    IF (istatus == NF90_NOERR ) THEN
       ! there is a scale factor for this variable
       istatus=NF90_GET_ATT(incid,id_var,'add_offset', ao)
       IF ( ao /= 0.) lao=.TRUE.
    ENDIF


    IF (llperio ) THEN
      ALLOCATE (zend (ipiglo-imin,kpj), zstart(imax-1,kpj) )
      IF (l_mbathy .AND. &
        &  ( cdvar == 'e3t_ps' .OR. cdvar == 'e3w_ps' .OR. cdvar == 'e3u_ps' .OR. cdvar == 'e3v_ps'))  THEN
       istatus=0
       clvar=cdvar
       SELECT CASE ( clvar )
         CASE ( 'e3t_ps', 'e3u_ps', 'e3v_ps' ) 
           DO ji=1,ipiglo-imin
            DO jj=1,kpj
             ik=mbathy(imin+ji-1, jmin+jj-1)
             IF (ilev == ik ) THEN
               zend(ji,jj)=e3t_ps(imin+ji-1, jmin+jj-1)
             ELSE
               zend(ji,jj)=e3t_0(ilev)
             ENDIF
            END DO
           END DO
           DO ji=1,imax-1
            DO jj=1,kpj
             ik=mbathy(ji+1, jmin+jj-1)
             IF (ilev == ik ) THEN
               zstart(ji,jj)=e3t_ps(ji+1, jmin+jj-1)
             ELSE
               zstart(ji,jj)=e3t_0(ilev)
             ENDIF
            END DO
           END DO
          getvar(1:ipiglo-imin,:)=zend
          getvar(ipiglo-imin+1:kpi,:)=zstart
         IF (clvar == 'e3u_ps') THEN
         DO ji=1,kpi-1
          DO jj=1,kpj
            getvar(ji,jj)=MIN(getvar(ji,jj),getvar(ji+1,jj))
          END DO
         END DO
           ! not very satisfactory but still....
           getvar(kpi,:)=getvar(kpi-1,:)
         ENDIF

         IF (clvar == 'e3v_ps') THEN
         DO ji=1,kpi
          DO jj=1,kpj-1
            getvar(ji,jj)=MIN(getvar(ji,jj),getvar(ji,jj+1))
          END DO
         END DO
           ! not very satisfactory but still....
           getvar(:,kpj)=getvar(:,kpj-1)
         ENDIF
         
         CASE ( 'e3w_ps')
           DO ji=1,ipiglo-imin
            DO jj=1,kpj
             ik=mbathy(imin+ji-1, jmin+jj-1)
             IF (ilev == ik ) THEN
               zend(ji,jj)=e3w_ps(imin+ji-1, jmin+jj-1)
             ELSE
               zend(ji,jj)=e3w_0(ilev)
             ENDIF
            END DO
           END DO
           DO ji=1,imax-1
            DO jj=1,kpj
             ik=mbathy(ji+1, jmin+jj-1)
             IF (ilev == ik ) THEN
               zstart(ji,jj)=e3w_ps(ji+1, jmin+jj-1)
             ELSE
               zstart(ji,jj)=e3w_0(ilev)
             ENDIF
            END DO
           END DO
       getvar(1:ipiglo-imin,:)=zend
       getvar(ipiglo-imin+1:kpi,:)=zstart

       END SELECT
      ELSE
       istatus=NF90_GET_VAR(incid,id_var,zend, start=(/imin,jmin,ilev,itime/),count=(/ipiglo-imin,kpj,1,1/))
       istatus=NF90_GET_VAR(incid,id_var,zstart, start=(/2,jmin,ilev,itime/),count=(/imax-1,kpj,1,1/))
       getvar(1:ipiglo-imin,:)=zend
       getvar(ipiglo-imin+1:kpi,:)=zstart
      ENDIF
      DEALLOCATE(zstart, zend )
    ELSE
      IF (l_mbathy .AND. &
        &  ( cdvar == 'e3t_ps' .OR. cdvar == 'e3w_ps' .OR. cdvar == 'e3u_ps' .OR. cdvar == 'e3v_ps'))  THEN
       istatus=0
       clvar=cdvar
       SELECT CASE ( clvar )
         CASE ( 'e3t_ps', 'e3u_ps', 'e3v_ps' ) 
         DO ji=1,kpi
          DO jj=1,kpj
           ik=mbathy(imin+ji-1, jmin+jj-1)
           IF (ilev == ik ) THEN
             getvar(ji,jj)=e3t_ps(imin+ji-1, jmin+jj-1)
           ELSE
             getvar(ji,jj)=e3t_0(ilev)
           ENDIF
          END DO
         END DO
         IF (clvar == 'e3u_ps') THEN
         DO ji=1,kpi-1
          DO jj=1,kpj
            getvar(ji,jj)=MIN(getvar(ji,jj),getvar(ji+1,jj))
          END DO
         END DO
           ! not very satisfactory but still....
           getvar(kpi,:)=getvar(2,:) 
         ENDIF
         IF (clvar == 'e3v_ps') THEN
         DO ji=1,kpi
          DO jj=1,kpj-1
            getvar(ji,jj)=MIN(getvar(ji,jj),getvar(ji,jj+1))
          END DO
         END DO
           ! not very satisfactory but still....
           IF ( kpj /= 1 ) getvar(:,kpj)=getvar(:,kpj-1)
         ENDIF

         CASE ( 'e3w_ps')
         DO ji=1,kpi
          DO jj=1,kpj
           ik=mbathy(imin+ji-1, jmin+jj-1)
           IF (ilev == ik ) THEN
             getvar(ji,jj)=e3w_ps(imin+ji-1, jmin+jj-1)
           ELSE
             getvar(ji,jj)=e3w_0(ilev)
           ENDIF
          END DO
         END DO

       END SELECT
      ELSE
        istatus=NF90_GET_VAR(incid,id_var,getvar, start=istart,count=icount)
      ENDIF
    ENDIF
    IF ( istatus /= 0 ) THEN
       PRINT *,' Problem in getvar for ', TRIM(clvar)
       CALL ERR_HDL(istatus)
       STOP 98
    ENDIF

    ! Caution : order does matter !
    IF (lsf )  WHERE (getvar /= spval )  getvar=getvar*sf
    IF (lao )  WHERE (getvar /= spval )  getvar=getvar + ao
    IF (llog)  WHERE (getvar /= spval )  getvar=10**getvar

    istatus=NF90_CLOSE(incid)

  END FUNCTION getvar

  FUNCTION  getvar3d (cdfile,cdvar,kpi,kpj,kpz, kimin, kjmin, kkmin, ktime )
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION  getvar3d  ***
    !!
    !! ** Purpose : Return the 3D REAL variable cdvar(x,y,z), from cdfile 
    !!              kpi,kpj,kpz are the horizontal size of the 3D variable
    !!              Sub domain can be optionaly specified with its starting
    !!              point, kimin, kjmin, kkmin
    !!
    !! ** Method  : Use NF90 primitive to read the block of 3D data
    !!
    !!---------------------------------------------------------------------
    CHARACTER(LEN=*),          INTENT(in) :: cdfile
    CHARACTER(LEN=*),          INTENT(in) :: cdvar
    INTEGER(KIND=4),           INTENT(in) :: kpi,   kpj,   kpz
    INTEGER(KIND=4), OPTIONAL, INTENT(in) :: kimin, kjmin, kkmin
    INTEGER(KIND=4), OPTIONAL, INTENT(in) :: ktime         ! Optional variable. If missing 1 is assumed 
    REAL(KIND=4), DIMENSION(kpi,kpj,kpz)  :: getvar3d      ! 3D REAL 

    INTEGER(KIND=4), DIMENSION(4) :: istart, icount
    INTEGER(KIND=4)               :: incid, id_var
    INTEGER(KIND=4)               :: istatus
    INTEGER(KIND=4)               :: iimin, ijmin, ikmin
    INTEGER(KIND=4)               :: itime, ilog
    INTEGER(KIND=4)               :: idum
    REAL(KIND=4)                  :: sf=1., ao=0.       !  Scale factor and add_offset
    REAL(KIND=4)                  :: spval              !  Missing values
    LOGICAL                       :: llog=.FALSE. , lsf=.FALSE. , lao=.FALSE.
    !!---------------------------------------------------------------------
    IF (PRESENT(kimin) ) THEN
       iimin=kimin
    ELSE
       iimin=1
    ENDIF

    IF (PRESENT(kjmin) ) THEN
       ijmin=kjmin
    ELSE
       ijmin=1
    ENDIF

    IF (PRESENT(kkmin) ) THEN
       ikmin=kkmin
    ELSE
       ikmin=1
    ENDIF

    IF (PRESENT(ktime) ) THEN
       itime=ktime
    ELSE
       itime=1
    ENDIF
   
    ! Must reset the flags to false for every call to getvar
    llog=.FALSE.
    lsf=.FALSE.
    lao=.FALSE.
    PRINT *,' GETVAR3D '
    PRINT *,'  ', TRIM(cdfile)
    PRINT *,'  ', TRIM(cdvar )
    PRINT *,'    KPI KPJ KPZ ',kpi, kpj, kpz

    CALL ERR_HDL(NF90_OPEN(cdfile,NF90_NOWRITE,incid) )
    CALL ERR_HDL(NF90_INQ_VARID ( incid, cdvar, id_var) )
    istart=(/iimin, ijmin, ikmin, itime/)
    icount=(/kpi,   kpj,   kpz,   1    /)

    spval = getspval ( cdfile, cdvar )

    istatus=NF90_INQUIRE_ATTRIBUTE(incid,id_var,'savelog10')
    IF (istatus == NF90_NOERR ) THEN
       ! there is a scale factor for this variable
       istatus=NF90_GET_ATT(incid,id_var,'savelog10',ilog)
       IF ( ilog /= 0 ) llog=.TRUE.
    ENDIF

    istatus=NF90_INQUIRE_ATTRIBUTE(incid,id_var,'scale_factor')
    IF (istatus == NF90_NOERR ) THEN
       ! there is a scale factor for this variable
       istatus=NF90_GET_ATT(incid,id_var,'scale_factor',sf)
       IF ( sf /= 1. ) lsf=.TRUE.
    ENDIF

    istatus=NF90_INQUIRE_ATTRIBUTE(incid,id_var,'add_offset')
    IF (istatus == NF90_NOERR ) THEN
       ! there is a scale factor for this variable
       istatus=NF90_GET_ATT(incid,id_var,'add_offset',ao)
       IF ( ao /= 0.) lao=.TRUE.
    ENDIF

    istatus=NF90_GET_VAR(incid,id_var,getvar3d, start=istart,count=icount)
    IF ( istatus /= 0 ) THEN
       PRINT *,' Problem in getvar3d for ', TRIM(cdvar)
       CALL ERR_HDL(istatus)
       STOP 98
    ENDIF

    ! Caution : order does matter !
    IF (lsf )  WHERE (getvar3d /= spval )  getvar3d=getvar3d*sf
    IF (lao )  WHERE (getvar3d /= spval )  getvar3d=getvar3d + ao
    IF (llog)  WHERE (getvar3d /= spval )  getvar3d=10**getvar3d

    istatus=NF90_CLOSE(incid)

  END FUNCTION getvar3d

  FUNCTION  getvar3dt (cdfile,cdvar,kk, kpi,kpj,kpt, kimin, kjmin, ktmin )
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION  getvar3d  ***
    !!
    !! ** Purpose : Return the 3D REAL variable cdvar(x,y,t), at level kk
    !!              from cdfile.  kpi,kpj,kpt are the size of the variable
    !!              subdomain starting point can be specified by kimin, kjmin, ktmin
    !!
    !! ** Method  : Use NF90 primitive to read the block of 3D data
    !!
    !!---------------------------------------------------------------------
    CHARACTER(LEN=*),          INTENT(in) :: cdfile
    CHARACTER(LEN=*),          INTENT(in) :: cdvar
    INTEGER(KIND=4),           INTENT(in) :: kpi,   kpj,   kk, kpt
    INTEGER(KIND=4), OPTIONAL, INTENT(in) :: kimin, kjmin, ktmin
    REAL(KIND=4), DIMENSION(kpi,kpj,kpt)  :: getvar3dt      ! 3D REAL 

    INTEGER(KIND=4), DIMENSION(4) :: istart, icount
    INTEGER(KIND=4)               :: jt
    INTEGER(KIND=4)               :: incid, id_var, iid
    INTEGER(KIND=4)               :: istatus
    INTEGER(KIND=4)               :: iimin, ijmin, itmin
    INTEGER(KIND=4)               :: itime, ilog
    INTEGER(KIND=4)               :: idum
    REAL(KIND=4)                  :: sf=1., ao=0.       !  Scale factor and add_offset
    REAL(KIND=4)                  :: spval              !  Missing values
    LOGICAL                       :: llog=.FALSE. , lsf=.FALSE. , lao=.FALSE.
    !!---------------------------------------------------------------------
    IF (PRESENT(kimin) ) THEN
       iimin=kimin
    ELSE
       iimin=1
    ENDIF

    IF (PRESENT(kjmin) ) THEN
       ijmin=kjmin
    ELSE
       ijmin=1
    ENDIF

    IF (PRESENT(ktmin) ) THEN
       itmin=ktmin
    ELSE
       itmin=1
    ENDIF

    ! Must reset the flags to false for every call to getvar
    llog=.FALSE.
    lsf=.FALSE.
    lao=.FALSE.
    PRINT *,' GETVAR3DT '
    PRINT *,'  ', TRIM(cdfile)
    PRINT *,'  ', TRIM(cdvar )
    PRINT *,'    KPI KPJ KPT, KK ',kpi, kpj, kpt, kk

    CALL ERR_HDL(NF90_OPEN(cdfile,NF90_NOWRITE,incid) )
    CALL ERR_HDL(NF90_INQ_VARID ( incid, cdvar, id_var) )
    istatus= NF90_INQUIRE_VARIABLE(incid, id_var, ndims=iid)
    IF ( iid == 4 ) THEN
      istart=(/iimin, ijmin, kk, itmin/)
      icount=(/kpi,   kpj,    1, kpt  /)
    ELSEIF  ( iid == 3 ) THEN ! assume X Y T ( cannot be X, Z, T nor Y Z T )
      istart=(/iimin, ijmin, itmin, 1/)
      icount=(/kpi,   kpj,   kpt  , 1/)
    ENDIF

    spval = getspval ( cdfile, cdvar )

    istatus=NF90_INQUIRE_ATTRIBUTE(incid,id_var,'savelog10')
    IF (istatus == NF90_NOERR ) THEN
       ! there is a scale factor for this variable
       istatus=NF90_GET_ATT(incid,id_var,'savelog10',ilog)
       IF ( ilog /= 0 ) llog=.TRUE.
    ENDIF

    istatus=NF90_INQUIRE_ATTRIBUTE(incid,id_var,'scale_factor')
    IF (istatus == NF90_NOERR ) THEN
       ! there is a scale factor for this variable
       istatus=NF90_GET_ATT(incid,id_var,'scale_factor',sf)
       IF ( sf /= 1. ) lsf=.TRUE.
    ENDIF

    istatus=NF90_INQUIRE_ATTRIBUTE(incid,id_var,'add_offset')
    IF (istatus == NF90_NOERR ) THEN
       ! there is a scale factor for this variable
       istatus=NF90_GET_ATT(incid,id_var,'add_offset',ao)
       IF ( ao /= 0.) lao=.TRUE.
    ENDIF

    istatus=NF90_GET_VAR(incid,id_var, getvar3dt(:,:,:), start=istart,count=icount)
    IF ( istatus /= 0 ) THEN
       PRINT *,' Problem in getvar3dt for ', TRIM(cdvar)
       CALL ERR_HDL(istatus)
       STOP 98
    ENDIF

    ! Caution : order does matter !
    IF (lsf )  WHERE (getvar3dt /= spval )  getvar3dt=getvar3dt*sf
    IF (lao )  WHERE (getvar3dt /= spval )  getvar3dt=getvar3dt + ao
    IF (llog)  WHERE (getvar3dt /= spval )  getvar3dt=10**getvar3dt

    istatus=NF90_CLOSE(incid)

  END FUNCTION getvar3dt

  FUNCTION  getvar4d (cdfile,cdvar,kpi,kpj,kpz,kpt, kimin, kjmin, kkmin, ktmin )
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION  getvar4d  ***
    !!
    !! ** Purpose : Return the 4D REAL variable cdvar(x,y,z,t).
    !!              kpi,kpj,kpz,kpt are the dimensions of the 4D variable.
    !!              A subdomain can be specified using kimin, kjmin, kkmin, ktmin
    !!
    !! ** Method  : Use NF90 primitive to read the block of 3D data
    !!
    !!---------------------------------------------------------------------
    CHARACTER(LEN=*),          INTENT(in) :: cdfile
    CHARACTER(LEN=*),          INTENT(in) :: cdvar
    INTEGER(KIND=4),           INTENT(in) :: kpi,   kpj,   kpz, kpt
    INTEGER(KIND=4), OPTIONAL, INTENT(in) :: kimin, kjmin, kkmin, ktmin
    REAL(KIND=4), DIMENSION(kpi,kpj,kpz,kpt) :: getvar4d      ! 3D REAL 

    INTEGER(KIND=4), DIMENSION(4) :: istart, icount
    INTEGER(KIND=4)               :: incid, id_var, iid
    INTEGER(KIND=4)               :: istatus
    INTEGER(KIND=4)               :: iimin, ijmin, ikmin, itmin
    INTEGER(KIND=4)               :: ilog
    INTEGER(KIND=4)               :: idum
    REAL(KIND=4)                  :: sf=1., ao=0.       !  Scale factor and add_offset
    REAL(KIND=4)                  :: spval              !  Missing values
    LOGICAL                       :: llog=.FALSE. , lsf=.FALSE. , lao=.FALSE.
    !!---------------------------------------------------------------------
    IF (PRESENT(kimin) ) THEN
       iimin=kimin
    ELSE
       iimin=1
    ENDIF

    IF (PRESENT(kjmin) ) THEN
       ijmin=kjmin
    ELSE
       ijmin=1
    ENDIF

    IF (PRESENT(kkmin) ) THEN
       ikmin=kkmin
    ELSE
       ikmin=1
    ENDIF

    IF (PRESENT(ktmin) ) THEN
       itmin=ktmin
    ELSE
       itmin=1
    ENDIF
   
    ! Must reset the flags to false for every call to getvar
    llog=.FALSE.
    lsf=.FALSE.
    lao=.FALSE.
    PRINT *,' GETVAR4D '
    PRINT *,'  ', TRIM(cdfile)
    PRINT *,'  ', TRIM(cdvar )
    PRINT *,'    KPI KPJ KPZ, KPT ',kpi, kpj, kpz, kpt

    CALL ERR_HDL(NF90_OPEN(cdfile,NF90_NOWRITE,incid) )
    CALL ERR_HDL(NF90_INQ_VARID ( incid, cdvar, id_var) )
    istatus= NF90_INQUIRE_VARIABLE(incid, id_var, ndims=iid)
    IF ( iid == 4 ) THEN
      istart=(/iimin, ijmin, ikmin, itmin/)
      icount=(/kpi,   kpj,   kpz,   kpt  /)
    ELSEIF  ( iid == 3 ) THEN ! assume X Y T ( cannot be X, Z, T nor Y Z T )
      istart=(/iimin, ijmin, itmin, 1/)
      icount=(/kpi,   kpj,   kpt,   1/)
    ENDIF

    spval = getspval ( cdfile, cdvar )

    istatus=NF90_INQUIRE_ATTRIBUTE(incid,id_var,'savelog10')
    IF (istatus == NF90_NOERR ) THEN
       ! there is a scale factor for this variable
       istatus=NF90_GET_ATT(incid,id_var,'savelog10',ilog)
       IF ( ilog /= 0 ) llog=.TRUE.
    ENDIF

    istatus=NF90_INQUIRE_ATTRIBUTE(incid,id_var,'scale_factor')
    IF (istatus == NF90_NOERR ) THEN
       ! there is a scale factor for this variable
       istatus=NF90_GET_ATT(incid,id_var,'scale_factor',sf)
       IF ( sf /= 1. ) lsf=.TRUE.
    ENDIF

    istatus=NF90_INQUIRE_ATTRIBUTE(incid,id_var,'add_offset')
    IF (istatus == NF90_NOERR ) THEN
       ! there is a scale factor for this variable
       istatus=NF90_GET_ATT(incid,id_var,'add_offset',ao)
       IF ( ao /= 0.) lao=.TRUE.
    ENDIF

    istatus=NF90_GET_VAR(incid,id_var,getvar4d, start=istart,count=icount)
    IF ( istatus /= 0 ) THEN
       PRINT *,' Problem in getvar4d for ', TRIM(cdvar)
       CALL ERR_HDL(istatus)
       STOP 98
    ENDIF

    ! Caution : order does matter !
    IF (lsf )  WHERE (getvar4d /= spval )  getvar4d=getvar4d*sf
    IF (lao )  WHERE (getvar4d /= spval )  getvar4d=getvar4d + ao
    IF (llog)  WHERE (getvar4d /= spval )  getvar4d=10**getvar4d

    istatus=NF90_CLOSE(incid)

  END FUNCTION getvar4d


  FUNCTION  getvarxz (cdfile, cdvar, kj, kpi, kpz, kimin, kkmin, ktime)
    !!-------------------------------------------------------------------------
    !!                  ***  FUNCTION  getvarxz  ***
    !!
    !! ** Purpose : Return the 2D REAL variable x-z slab cvar, from cdfile at j=kj
    !!              kpi,kpz are the  size of the 2D variable
    !!
    !!-------------------------------------------------------------------------
    CHARACTER(LEN=*),          INTENT(in) :: cdfile        ! file name to work with
    CHARACTER(LEN=*),          INTENT(in) :: cdvar         ! variable name to work with
    INTEGER(KIND=4),           INTENT(in) :: kj            ! Optional variable. If missing 1 is assumed
    INTEGER(KIND=4),           INTENT(in) :: kpi, kpz      ! size of the 2D variable
    INTEGER(KIND=4), OPTIONAL, INTENT(in) :: kimin, kkmin  ! Optional variable. If missing 1 is assumed
    INTEGER(KIND=4), OPTIONAL, INTENT(in) :: ktime         ! Optional variable. If missing 1 is assumed 
    REAL(KIND=4), DIMENSION(kpi,kpz)      :: getvarxz      ! 2D REAL 4 holding variable x-z slab at kj

    INTEGER(KIND=4), DIMENSION(4) :: istart, icount
    INTEGER(KIND=4)               :: incid, id_var
    INTEGER(KIND=4)               :: istatus, ilev, imin, kmin
    INTEGER(KIND=4)               :: itime, ilog
    INTEGER(KIND=4)               :: idum
    REAL(KIND=4)                  :: sf=1., ao=0.       !  Scale factor and add_offset
    REAL(KIND=4)                  :: spval              !  Missing values
    LOGICAL                       :: llog=.FALSE. , lsf=.FALSE. , lao=.FALSE.
    !!-------------------------------------------------------------------------

    IF (PRESENT(kimin) ) THEN
       imin=kimin
    ELSE
       imin=1
    ENDIF

    IF (PRESENT(kkmin) ) THEN
       kmin=kkmin
    ELSE
       kmin=1
    ENDIF

    IF (PRESENT(ktime) ) THEN
       itime=ktime
    ELSE
       itime=1
    ENDIF

    ! Must reset the flags to false for every call to getvar
    llog=.FALSE.
    lsf=.FALSE.
    lao=.FALSE.


    CALL ERR_HDL(NF90_OPEN(cdfile,NF90_NOWRITE,incid) )
    CALL ERR_HDL(NF90_INQ_VARID ( incid,cdvar,id_var))

    spval = getspval ( cdfile, cdvar )

    istatus=NF90_INQUIRE_ATTRIBUTE(incid,id_var,'savelog10')
    IF (istatus == NF90_NOERR ) THEN
       ! there is a scale factor for this variable
       istatus=NF90_GET_ATT(incid,id_var,'savelog10',ilog)
       IF ( ilog /= 0 ) llog=.TRUE.
    ENDIF

    istatus=NF90_INQUIRE_ATTRIBUTE(incid,id_var,'scale_factor')
    IF (istatus == NF90_NOERR ) THEN
       ! there is a scale factor for this variable
       istatus=NF90_GET_ATT(incid,id_var,'scale_factor',sf)
       IF ( sf /= 1. ) lsf=.TRUE.
    ENDIF

    istatus=NF90_INQUIRE_ATTRIBUTE(incid,id_var,'add_offset')
    IF (istatus == NF90_NOERR ) THEN
       ! there is a scale factor for this variable
       istatus=NF90_GET_ATT(incid,id_var,'add_offset',ao)
       IF ( ao /= 0.) lao=.TRUE.
    ENDIF

    ! detect if there is a y dimension in cdfile
    istatus=NF90_INQ_DIMID(incid,'y',idum)
    IF ( istatus == NF90_NOERR ) THEN  ! the file has a 'y' dimension
      istart=(/imin,kj,kmin,itime/)
      ! JMM ! it workd for X Y Z T file,   not for X Y T .... try to found a fix !
      icount=(/kpi,1,kpz,1/)
    ELSE    ! no y dimension
      istart=(/imin,kmin,itime,1/)
      icount=(/kpi,kpz,1,1/)
    ENDIF

    istatus=NF90_GET_VAR(incid,id_var,getvarxz, start=istart,count=icount)
    IF ( istatus /= 0 ) THEN
       PRINT *,' Problem in getvarxz for ', TRIM(cdvar)
       CALL ERR_HDL(istatus)
       STOP 98
    ENDIF

    ! Caution : order does matter !
    IF (lsf )  WHERE (getvarxz /= spval )  getvarxz=getvarxz*sf
    IF (lao )  WHERE (getvarxz /= spval )  getvarxz=getvarxz + ao
    IF (llog)  WHERE (getvarxz /= spval )  getvarxz=10**getvarxz

    istatus=NF90_CLOSE(incid)

  END FUNCTION getvarxz


  FUNCTION  getvaryz (cdfile, cdvar, ki, kpj, kpz, kjmin, kkmin, ktime)
    !!-------------------------------------------------------------------------
    !!                  ***  FUNCTION  getvar  ***
    !!
    !! ** Purpose : Return the 2D REAL variable y-z slab cvar, from cdfile at i=ki
    !!              kpj,kpz are the  size of the 2D variable
    !!
    !!-------------------------------------------------------------------------
    CHARACTER(LEN=*),          INTENT(in) :: cdfile       ! file name to work with
    CHARACTER(LEN=*),          INTENT(in) :: cdvar        ! variable name to work with
    INTEGER(KIND=4),           INTENT(in) :: ki           ! 
    INTEGER(KIND=4),           INTENT(in) :: kpj,kpz      ! size of the 2D variable
    INTEGER(KIND=4), OPTIONAL, INTENT(in) :: kjmin, kkmin ! Optional variable. If missing 1 is assumed
    INTEGER(KIND=4), OPTIONAL, INTENT(in) :: ktime        ! Optional variable. If missing 1 is assumed
    REAL(KIND=4), DIMENSION(kpj,kpz)      :: getvaryz     ! 2D REAL 4 holding variable x-z slab at kj

    INTEGER(KIND=4), DIMENSION(4)       :: istart, icount
    INTEGER(KIND=4)                     :: incid, id_var
    INTEGER(KIND=4)                     :: istatus, ilev, jmin, kmin
    INTEGER(KIND=4)                     :: itime, ilog
    INTEGER(KIND=4)                     :: idum

    REAL(KIND=4)                        :: sf=1., ao=0.   !  Scale factor and add_offset
    REAL(KIND=4)                        :: spval          !  Missing values
    LOGICAL                             :: llog=.FALSE. , lsf=.FALSE. , lao=.FALSE.
    !!-------------------------------------------------------------------------

    IF (PRESENT(kjmin) ) THEN
       jmin=kjmin
    ELSE
       jmin=1
    ENDIF

    IF (PRESENT(kkmin) ) THEN
       kmin=kkmin
    ELSE
       kmin=1
    ENDIF

    IF (PRESENT(ktime) ) THEN
       itime=ktime
    ELSE
       itime=1
    ENDIF

    ! Must reset the flags to false for every call to getvar
    llog=.FALSE.
    lsf=.FALSE.
    lao=.FALSE.


    CALL ERR_HDL(NF90_OPEN(cdfile,NF90_NOWRITE,incid) )
    CALL ERR_HDL(NF90_INQ_VARID ( incid,cdvar,id_var))

    spval = getspval ( cdfile, cdvar )

    istatus=NF90_INQUIRE_ATTRIBUTE(incid,id_var,'savelog10')
    IF (istatus == NF90_NOERR ) THEN
       ! there is a scale factor for this variable
       istatus=NF90_GET_ATT(incid,id_var,'savelog10',ilog)
       IF ( ilog /= 0 ) llog=.TRUE.
    ENDIF

    istatus=NF90_INQUIRE_ATTRIBUTE(incid,id_var,'scale_factor')
    IF (istatus == NF90_NOERR ) THEN
       ! there is a scale factor for this variable
       istatus=NF90_GET_ATT(incid,id_var,'scale_factor',sf)
       IF ( sf /= 1. ) lsf=.TRUE.
    ENDIF

    istatus=NF90_INQUIRE_ATTRIBUTE(incid,id_var,'add_offset')
    IF (istatus == NF90_NOERR ) THEN
       ! there is a scale factor for this variable
       istatus=NF90_GET_ATT(incid,id_var,'add_offset', ao)
       IF ( ao /= 0.) lao=.TRUE.
    ENDIF

    ! detect if there is a x dimension in cdfile
    istatus=NF90_INQ_DIMID(incid,'x',idum)
    IF ( istatus == NF90_NOERR ) THEN  ! the file has a 'x' dimension
      istart=(/ki,jmin,kmin,itime/)
      ! JMM ! it workd for X Y Z T file,   not for X Y T .... try to found a fix !
      icount=(/1,kpj,kpz,1/)
    ELSE    ! no x dimension
      istart=(/jmin,kmin,itime,1/)
      icount=(/kpj,kpz,1,1/)
    ENDIF

    istatus=NF90_GET_VAR(incid,id_var,getvaryz, start=istart,count=icount)
    IF ( istatus /= 0 ) THEN
       PRINT *,' Problem in getvaryz for ', TRIM(cdvar)
       CALL ERR_HDL(istatus)
       STOP 98
    ENDIF

    ! Caution : order does matter !
    IF (lsf )  WHERE (getvaryz /= spval )  getvaryz=getvaryz*sf
    IF (lao )  WHERE (getvaryz /= spval )  getvaryz=getvaryz + ao
    IF (llog)  WHERE (getvaryz /= spval )  getvaryz=10**getvaryz

    istatus=NF90_CLOSE(incid)

  END FUNCTION getvaryz


  FUNCTION  getvar1d (cdfile, cdvar, kk, kstatus)
    !!-------------------------------------------------------------------------
    !!                  ***  FUNCTION  getvar1d  ***
    !!
    !! ** Purpose :  return 1D variable cdvar from cdfile, of size kk
    !!
    !!-------------------------------------------------------------------------
    CHARACTER(LEN=*),           INTENT(in) :: cdfile   ! file name to work with
    CHARACTER(LEN=*),           INTENT(in) :: cdvar    ! variable name to work with
    INTEGER(KIND=4),            INTENT(in) :: kk       ! size of 1D vector to be returned
    INTEGER(KIND=4), OPTIONAL, INTENT(out) :: kstatus  ! return status concerning the variable existence
    REAL(KIND=4), DIMENSION(kk)            :: getvar1d ! real returned vector

    INTEGER(KIND=4), DIMENSION(1) :: istart, icount
    INTEGER(KIND=4) :: incid, id_var
    INTEGER(KIND=4) :: istatus
    !!-------------------------------------------------------------------------
    istart(:) = 1
    icount(1)=kk
    IF ( PRESENT(kstatus) ) kstatus = 0

    istatus=NF90_OPEN(cdfile,NF90_NOWRITE,incid)
    istatus=NF90_INQ_VARID ( incid,cdvar,id_var)
    IF ( istatus == NF90_NOERR ) THEN
       istatus=NF90_GET_VAR(incid,id_var,getvar1d,start=istart,count=icount)
    ELSE
       IF ( PRESENT(kstatus) ) kstatus= istatus
       getvar1d=99999999999.
    ENDIF

    istatus=NF90_CLOSE(incid)

  END FUNCTION getvar1d

  FUNCTION  getvar1d8 (cdfile, cdvar, kk, kstatus)
    !!-------------------------------------------------------------------------
    !!                  ***  FUNCTION  getvar1d8  ***
    !!
    !! ** Purpose :  return 1D variable cdvar from cdfile, of size kk
    !!
    !!-------------------------------------------------------------------------
    CHARACTER(LEN=*),           INTENT(in) :: cdfile   ! file name to work with
    CHARACTER(LEN=*),           INTENT(in) :: cdvar    ! variable name to work with
    INTEGER(KIND=4),            INTENT(in) :: kk       ! size of 1D vector to be returned
    INTEGER(KIND=4), OPTIONAL, INTENT(out) :: kstatus  ! return status concerning the variable existence
    REAL(KIND=8), DIMENSION(kk)            :: getvar1d8 ! real returned vector

    INTEGER(KIND=4), DIMENSION(1) :: istart, icount
    INTEGER(KIND=4) :: incid, id_var
    INTEGER(KIND=4) :: istatus
    !!-------------------------------------------------------------------------
    istart(:) = 1
    icount(1)=kk
    IF ( PRESENT(kstatus) ) kstatus = 0

    istatus=NF90_OPEN(cdfile,NF90_NOWRITE,incid)
    istatus=NF90_INQ_VARID ( incid,cdvar,id_var)
    IF ( istatus == NF90_NOERR ) THEN
       istatus=NF90_GET_VAR(incid,id_var,getvar1d8,start=istart,count=icount)
    ELSE
       IF ( PRESENT(kstatus) ) kstatus= istatus
       getvar1d8=99999999999.
    ENDIF

    istatus=NF90_CLOSE(incid)

  END FUNCTION getvar1d8

  FUNCTION  getvar1d_bounds (cdfile, cdvar, kk, kstatus)
    !!-------------------------------------------------------------------------
    !!                  ***  FUNCTION  getvar1d  ***
    !!
    !! ** Purpose :  return 1D variable cdvar from cdfile, of size kk
    !!
    !!-------------------------------------------------------------------------
    CHARACTER(LEN=*),           INTENT(in) :: cdfile   ! file name to work with
    CHARACTER(LEN=*),           INTENT(in) :: cdvar    ! variable name to work with
    INTEGER(KIND=4),            INTENT(in) :: kk       ! size of 1D vector to be returned
    INTEGER(KIND=4), OPTIONAL, INTENT(out) :: kstatus  ! return status concerning the variable existence
    REAL(KIND=4), DIMENSION(kk,2)          :: getvar1d_bounds ! real returned vector

    INTEGER(KIND=4), DIMENSION(2) :: istart, icount
    INTEGER(KIND=4) :: incid, id_var
    INTEGER(KIND=4) :: istatus
    !!-------------------------------------------------------------------------
    istart(:) = 1
    icount(1)=2; icount(2)=kk

    IF ( PRESENT(kstatus) ) kstatus = 0

    istatus=NF90_OPEN(cdfile,NF90_NOWRITE,incid)
    istatus=NF90_INQ_VARID ( incid,cdvar,id_var)
    IF ( istatus == NF90_NOERR ) THEN
       istatus=NF90_GET_VAR(incid,id_var,getvar1d_bounds,start=istart,count=icount)
    ELSE
       IF ( PRESENT(kstatus) ) kstatus= istatus
       getvar1d_bounds(:,:)=99999999999.
    ENDIF

    istatus=NF90_CLOSE(incid)

  END FUNCTION getvar1d_bounds

  FUNCTION  getvare3 (cdfile,cdvar,kk)
    !!-------------------------------------------------------------------------
    !!                  ***  FUNCTION  getvare3  ***
    !!
    !! ** Purpose :  Special routine for e3, which in fact is a 1D variable
    !!               but defined as e3 (1,1,npk,1) in coordinates.nc (!!)
    !!
    !!-------------------------------------------------------------------------
    CHARACTER(LEN=*), INTENT(in) :: cdfile   ! file name to work with
    CHARACTER(LEN=*), INTENT(in) :: cdvar    ! variable name to work with
    INTEGER(KIND=4),  INTENT(in) :: kk       ! size of 1D vector to be returned
    REAL(KIND=4),  DIMENSION(kk) :: getvare3 ! return e3 variable form the coordinate file

    INTEGER(KIND=4), DIMENSION(4) :: istart, icount
    INTEGER(KIND=4)               :: incid, id_var
    INTEGER(KIND=4)               :: istatus
    CHARACTER(LEN=256)            :: clvar   ! local name for cdf var (modified)
    !!-------------------------------------------------------------------------
    istart(:) = 1
    icount(:) = 1
    icount(3)=kk
    clvar=cdvar

    istatus=NF90_OPEN(cdfile,NF90_NOWRITE,incid)
    ! check for IOM style mesh_zgr or coordinates :
    ! IOIPSL (x_a=y_a=1)               IOM 
    ! gdept(time,z,y_a,x_a)            gdept_0(t,z)
    ! gdepw(time,z,y_a,x_a)            gdepw_0(t,z)
    !   e3t(time,z,y_a,x_a)            e3t_0(t,z)
    !   e3w(time,z,y_a,x_a)            e3w_0(t,z)
    istatus=NF90_INQ_VARID ( incid,'gdept_0',id_var)
    IF ( istatus == NF90_NOERR) THEN
     icount(1)=kk ; icount(3)=1
     SELECT CASE (clvar)
        CASE ('gdepw') 
           clvar='gdepw_0'
        CASE ('gdept')
           clvar='gdept_0'
        CASE ('e3t')
           clvar='e3t_0'
        CASE ('e3w')
           clvar='e3w_0'
      END SELECT
    ENDIF
    istatus=NF90_INQ_VARID ( incid,'gdept_1d',id_var)
    IF ( istatus == NF90_NOERR) THEN
     icount(1)=kk ; icount(3)=1
     SELECT CASE (clvar)
        CASE ('gdepw') 
           clvar='gdepw_1d'
        CASE ('gdept')
           clvar='gdept_1d'
        CASE ('e3t')
           clvar='e3t_1d'
        CASE ('e3w')
           clvar='e3w_1d'
      END SELECT
    ENDIF

    istatus=NF90_INQ_VARID ( incid,clvar,id_var)
    istatus=NF90_GET_VAR(incid,id_var,getvare3,start=istart,count=icount)
    IF ( istatus /= 0 ) THEN
       PRINT *,' Problem in getvare3 for ', TRIM(cdvar)
       PRINT *,TRIM(cdfile), kk
       CALL ERR_HDL(istatus)
       STOP 98
    ENDIF

    istatus=NF90_CLOSE(incid)

  END FUNCTION getvare3


  INTEGER(KIND=4) FUNCTION putheadervar(kout, cdfile, kpi, kpj, kpk, pnavlon, pnavlat , pdep, cdep, ld_xycoo)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION  putheadervar  ***
    !!
    !! ** Purpose :  copy header variables from cdfile to the already open ncfile (ncid=kout)
    !!
    !! ** Method  :  header variables are nav_lat, nav_lon and either (deptht, depthu, or depthv )
    !!               Even if the use of different variable name for deptht, depthu depthv is
    !!               one of the many non sense of IOIPSL, we are forced to stick with !
    !!               (Note that these 3 depth are identical in OPA. On the other hand, nav_lon, nav_lat
    !!               differ for U and V and T points but have the same variable name).
    !!               If pnavlon and pnavlat are provided as arguments, they are used for nav_lon, nav_lat
    !!               instead of the nav_lon,nav_lat read on the file cdfile.
    !!
    !! ** Action  : header variables for file kout is copied from cdfile
    !!
    !!----------------------------------------------------------------------
    INTEGER(KIND=4),                            INTENT(in) :: kout     ! ncid of the outputfile (already open )
    CHARACTER(LEN=*),                           INTENT(in) :: cdfile   ! file from where the headers will be copied
    INTEGER(KIND=4),                            INTENT(in) :: kpi, kpj ! dimension of nav_lon (kpi,kpj)
    INTEGER(KIND=4),                            INTENT(in) :: kpk      ! dimension of depht(kpk)
    LOGICAL,      OPTIONAL,                     INTENT(in) :: ld_xycoo ! option to put yx info
    REAL(KIND=4), OPTIONAL, DIMENSION(kpi,kpj), INTENT(in) :: pnavlon  ! array provided optionaly to overrid the
    REAL(KIND=4), OPTIONAL, DIMENSION(kpi,kpj), INTENT(in) :: pnavlat  ! corresponding arrays in cdfile 
    REAL(KIND=4), OPTIONAL, DIMENSION(kpk),     INTENT(in) :: pdep     ! dep array if not on cdfile
    CHARACTER(LEN=*), OPTIONAL,                 INTENT(in) :: cdep     ! optional name of vertical variable

    INTEGER(KIND=4), PARAMETER                :: jpdep=6
    INTEGER(KIND=4)                           :: istatus, idep, jj
    REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: z2d
    REAL(KIND=4), DIMENSION(kpk)              :: z1d
    CHARACTER(LEN=256), DIMENSION(jpdep )     :: cldept= (/'deptht ','depthu ','depthv ','depthw ','nav_lev','z      '/)
    CHARACTER(LEN=256)                        :: cldep
    LOGICAL                                   :: ll_xycoo
    !!----------------------------------------------------------------------
    IF (PRESENT(ld_xycoo) ) THEN 
      ll_xycoo = ld_xycoo
    ELSE
      ll_xycoo = .true.
    ENDIF

    cldept = (/cn_vdeptht, cn_vdepthu, cn_vdepthv, cn_vdepthw,'nav_lev','z      '/)

    IF ( ll_xycoo  ) THEN   
       ALLOCATE ( z2d (kpi,kpj) )
   
       IF (PRESENT(pnavlon) ) THEN 
          z2d = pnavlon
       ELSE
          IF ( chkvar ( cdfile, cn_vlon2d )) THEN
              IF (chkvar (cdfile, cn_vlon1d) ) THEN
                PRINT *, '... dummy value used!'
                z2d = 0.
              ELSE
                z2d(:,1) = getvar1d(cdfile, cn_vlon1d, kpi, istatus ) 
                DO jj=2,kpj
                  z2d(:,jj) = z2d(:,1)
                ENDDO
              ENDIF
          ELSE
            z2d=getvar(cdfile,cn_vlon2d, 1,kpi,kpj)
          ENDIF
       ENDIF
       istatus = putvar(kout, nid_lon,z2d,1,kpi,kpj)
   
       IF (PRESENT(pnavlat) ) THEN
          z2d = pnavlat
       ELSE
          IF ( chkvar ( cdfile, cn_vlat2d )) THEN
              IF (chkvar (cdfile, cn_vlat1d) ) THEN
                PRINT *, '... dummy value used!'
                z2d = 0.
              ELSE
                z2d(1,:) = getvar1d(cdfile, cn_vlat1d, kpj, istatus ) 
                DO jj=2,kpi
                  z2d(jj,:) = z2d(1,:)
                ENDDO
              ENDIF
          ELSE
            z2d=getvar(cdfile,cn_vlat2d, 1,kpi,kpj)
          ENDIF
       ENDIF
   
       istatus = putvar(kout, nid_lat,z2d,1,kpi,kpj)
       DEALLOCATE (z2d)
    ENDIF

    IF (kpk /= 0 ) THEN
       IF (PRESENT(pdep) ) THEN
          z1d = pdep
       ELSE
          idep = NF90_NOERR

          IF ( PRESENT (cdep)) THEN
             z1d=getvar1d(cdfile,cdep,kpk,idep)
          ENDIF

          IF ( .NOT. PRESENT(cdep) .OR. idep /= NF90_NOERR ) THEN  ! look for standard dep name
             DO jj = 1,jpdep
                cldep=cldept(jj)
                z1d=getvar1d(cdfile,cldep,kpk,idep)
                IF ( idep == NF90_NOERR )  EXIT
             END DO
             IF (jj == jpdep +1 ) THEN
                PRINT *,' No depth variable found in ', TRIM(cdfile)
                STOP 98
             ENDIF
          ENDIF
       ENDIF

       istatus = putvar1d(kout,z1d,kpk,'D')
    ENDIF

    putheadervar=istatus

  END FUNCTION putheadervar


  INTEGER(KIND=4) FUNCTION putvarr8(kout, kid, ptab, klev, kpi, kpj, ktime, kwght)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION putvarr8  ***
    !!            
    !! ** Purpose : copy a 2D level of ptab in already open file kout, 
    !!              using variable kid
    !!
    !! ** Method  : this corresponds to the generic function putvar with r8 arg.
    !!----------------------------------------------------------------------
    INTEGER(KIND=4),                  INTENT(in) :: kout     ! ncid of output file
    INTEGER(KIND=4),                  INTENT(in) :: kid      ! varid of output variable
    REAL(KIND=8), DIMENSION(kpi,kpj), INTENT(in) :: ptab     ! 2D array to write in file
    INTEGER(KIND=4),                  INTENT(in) :: klev     ! level at which ptab will be written
    INTEGER(KIND=4),                  INTENT(in) :: kpi, kpj ! dimension of ptab
    INTEGER(KIND=4), OPTIONAL,        INTENT(in) :: ktime    ! dimension of ptab
    INTEGER(KIND=4), OPTIONAL,        INTENT(in) :: kwght    ! weight of this variable

    INTEGER(KIND=4)               :: istatus, itime, id_dimunlim, inbdim
    INTEGER(KIND=4), DIMENSION(4) :: istart, icount, inldim
    !!----------------------------------------------------------------------
    IF (PRESENT(ktime) ) THEN
       itime=ktime
    ELSE
       itime=1
    ENDIF

     ! look for unlimited dim (time_counter)
    istatus=NF90_INQUIRE         (kout, unlimitedDimId=id_dimunlim       )
    istatus=NF90_INQUIRE_VARIABLE(kout,kid,ndims=inbdim,dimids=inldim(:) )

    !  if the last dim of id_var is time, then adjust the starting point
    istart(:) = 1    ; icount(:) = 1    ! default
    icount(1) = kpi  ; icount(2) = kpj  ! in any case
    IF ( inldim(inbdim) == id_dimunlim ) istart(inbdim) = itime ! assume than last dim is UNLIM
    IF ( inbdim == 4                   ) istart(3     ) = klev

    istatus=NF90_PUT_VAR(kout,kid, ptab, start=istart,count=icount)

    IF (PRESENT(kwght) ) THEN
      istatus=NF90_PUT_ATT(kout, kid, 'iweight', kwght)
    ENDIF
    putvarr8=istatus

  END FUNCTION putvarr8

  INTEGER(KIND=4) FUNCTION putvarr4(kout, kid, ptab, klev, kpi, kpj, ktime, kwght)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION putvarr4  ***
    !!            
    !! ** Purpose : copy a 2D level of ptab in already open file kout, 
    !!              using variable kid
    !!
    !! ** Method  : this corresponds to the generic function putvar with r4 arg.
    !!----------------------------------------------------------------------
    INTEGER(KIND=4),                  INTENT(in) :: kout     ! ncid of output file
    INTEGER(KIND=4),                  INTENT(in) :: kid      ! varid of output variable
    REAL(KIND=4), DIMENSION(kpi,kpj), INTENT(in) :: ptab     ! 2D array to write in file
    INTEGER(KIND=4),                  INTENT(in) :: klev     ! level at which ptab will be written
    INTEGER(KIND=4),                  INTENT(in) :: kpi, kpj ! dimension of ptab
    INTEGER(KIND=4), OPTIONAL,        INTENT(in) :: ktime    ! dimension of ptab
    INTEGER(KIND=4), OPTIONAL,        INTENT(in) :: kwght    ! weight of this variable

    INTEGER(KIND=4)               :: istatus, itime, id_dimunlim, inbdim
    INTEGER(KIND=4), DIMENSION(4) :: istart, icount, inldim
    !!----------------------------------------------------------------------
    IF (PRESENT(ktime) ) THEN
       itime=ktime
    ELSE
       itime=1
    ENDIF

     ! look for unlimited dim (time_counter)
    istatus=NF90_INQUIRE         (kout, unlimitedDimId=id_dimunlim       )
    istatus=NF90_INQUIRE_VARIABLE(kout,kid,ndims=inbdim,dimids=inldim(:) )

    !  if the last dim of id_var is time, then adjust the starting point
    istart(:) = 1    ; icount(:) = 1    ! default
    icount(1) = kpi  ; icount(2) = kpj  ! in any case
    IF ( inldim(inbdim) == id_dimunlim ) istart(inbdim) = itime ! assume than last dim is UNLIM
    IF ( inbdim == 4                   ) istart(3     ) = klev

    istatus=NF90_PUT_VAR(kout,kid, ptab, start=istart,count=icount)

    IF (PRESENT(kwght) ) THEN
      istatus=NF90_PUT_ATT(kout, kid, 'iweight', kwght)
    ENDIF
    putvarr4=istatus

  END FUNCTION putvarr4


  INTEGER(KIND=4) FUNCTION putvare3(kout, kid, ptab, kmax, cd_vert, ktime, kwght)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION putvarr4  ***
    !!            
    !! ** Purpose : copy a 2D level of ptab in already open file kout, 
    !!              using variable kid
    !!
    !! ** Method  : this corresponds to the generic function putvar with r4 arg.
    !!----------------------------------------------------------------------
    INTEGER(KIND=4),                  INTENT(in) :: kout     ! ncid of output file
    INTEGER(KIND=4),                  INTENT(in) :: kid      ! varid of output variable
    REAL(KIND=4), DIMENSION(kmax),    INTENT(in) :: ptab     ! 1D array to write in file 
    INTEGER(KIND=4),                  INTENT(in) :: kmax     ! number of level in file
    CHARACTER(LEN=*),                 INTENT(in) :: cd_vert  ! dummy var to indicate vertical profile
    INTEGER(KIND=4), OPTIONAL,        INTENT(in) :: ktime    ! 
    INTEGER(KIND=4), OPTIONAL,        INTENT(in) :: kwght    ! weight of this variable

    INTEGER(KIND=4)               :: istatus, itime, id_dimunlim, inbdim
    INTEGER(KIND=4), DIMENSION(4) :: istart, icount, inldim
    !!----------------------------------------------------------------------
    IF (PRESENT(ktime) ) THEN
       itime=ktime
    ELSE
       itime=1
    ENDIF

     ! look for unlimited dim (time_counter)
    istatus=NF90_INQUIRE         (kout, unlimitedDimId=id_dimunlim       )
    istatus=NF90_INQUIRE_VARIABLE(kout,kid,ndims=inbdim,dimids=inldim(:) )

    !  if the last dim of id_var is time, then adjust the starting point
    istart(:) = 1    ; icount(:) = 1    ! default
    icount(1) = 1  ; icount(2) = 1  ; icount(3) = kmax ! in any case
    IF ( inldim(inbdim) == id_dimunlim ) istart(inbdim) = itime ! assume than last dim is UNLIM

    istatus=NF90_PUT_VAR(kout,kid, ptab, start=istart,count=icount)

    IF (PRESENT(kwght) ) THEN
      istatus=NF90_PUT_ATT(kout, kid, 'iweight', kwght)
    ENDIF
    putvare3=istatus

  END FUNCTION putvare3

  INTEGER(KIND=4) FUNCTION putvari2(kout, kid, ktab, klev, kpi, kpj, ktime, kwght)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION putvari2  ***
    !!            
    !! ** Purpose : copy a 2D level of ptab in already open file kout, 
    !!              using variable kid
    !!
    !! ** Method  : this corresponds to the generic function putvar with i2 arg.
    !!----------------------------------------------------------------------
    INTEGER(KIND=4),                     INTENT(in) :: kout     ! ncid of output file
    INTEGER(KIND=4),                     INTENT(in) :: kid      ! varid of output variable
    INTEGER(KIND=2), DIMENSION(kpi,kpj), INTENT(in) :: ktab     ! 2D array to write in file
    INTEGER(KIND=4),                     INTENT(in) :: klev     ! level at which ktab will be written
    INTEGER(KIND=4),                     INTENT(in) :: kpi, kpj ! dimension of ktab
    INTEGER(KIND=4), OPTIONAL,           INTENT(in) :: ktime    ! dimension of ktab
    INTEGER(KIND=4), OPTIONAL,           INTENT(in) :: kwght    ! weight of this variable

    INTEGER(KIND=4)               :: istatus, itime, id_dimunlim, inbdim
    INTEGER(KIND=4), DIMENSION(4) :: istart, icount, inldim
    !!----------------------------------------------------------------------
    IF (PRESENT(ktime) ) THEN
       itime=ktime
    ELSE
       itime=1
    ENDIF

     ! look for unlimited dim (time_counter)
    istatus=NF90_INQUIRE         (kout, unlimitedDimId=id_dimunlim       )
    istatus=NF90_INQUIRE_VARIABLE(kout,kid,ndims=inbdim,dimids=inldim(:) )

    !  if the last dim of id_var is time, then adjust the starting point
    istart(:) = 1    ; icount(:) = 1    ! default
    icount(1) = kpi  ; icount(2) = kpj  ! in any case
    IF ( inldim(inbdim) == id_dimunlim ) istart(inbdim) = itime ! assume than last dim is UNLIM
    IF ( inbdim == 4                   ) istart(3     ) = klev

    istatus=NF90_PUT_VAR(kout,kid, ktab, start=istart,count=icount)

    IF (PRESENT(kwght) ) THEN
      istatus=NF90_PUT_ATT(kout, kid, 'iweight', kwght)
    ENDIF
    putvari2=istatus

  END FUNCTION putvari2


  INTEGER(KIND=4) FUNCTION reputvarr4 (cdfile, cdvar, klev, kpi, kpj, kimin, kjmin, ktime, ptab, kwght)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION reputvarr4  ***
    !!
    !! ** Purpose :  Change an existing variable in inputfile 
    !!
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*),                 INTENT(in) :: cdfile       ! file name to work with
    CHARACTER(LEN=*),                 INTENT(in) :: cdvar        ! variable name to work with
    INTEGER(KIND=4), OPTIONAL,        INTENT(in) :: klev         ! Optional variable. If missing 1 is assumed
    INTEGER(KIND=4),                  INTENT(in) :: kpi, kpj     ! horizontal size of the 2D variable
    INTEGER(KIND=4), OPTIONAL,        INTENT(in) :: kimin, kjmin ! Optional variable. If missing 1 is assumed
    INTEGER(KIND=4), OPTIONAL,        INTENT(in) :: ktime        ! Optional variable. If missing 1 is assumed
    REAL(KIND=4), DIMENSION(kpi,kpj), INTENT(in) :: ptab        ! 2D REAL 4 holding variable field at klev
    INTEGER(KIND=4), OPTIONAL,        INTENT(in) :: kwght        ! weight of this variable

    INTEGER(KIND=4) :: incid, id_var, id_dimunlim, inbdim
    INTEGER(KIND=4) :: istatus, ilev, iimin, ijmin, itime
    INTEGER(KIND=4), DIMENSION(4) :: istart, icount, inldim
    !!----------------------------------------------------------------------
    ilev  = 1 ; IF (PRESENT(klev ) ) ilev  = klev
    iimin = 1 ; IF (PRESENT(kimin) ) iimin = kimin
    ijmin = 1 ; IF (PRESENT(kjmin) ) ijmin = kjmin
    itime = 1 ; IF (PRESENT(ktime) ) itime = ktime

    istatus=NF90_OPEN(cdfile,NF90_WRITE,incid)
    istatus=NF90_INQ_VARID(incid,cdvar,id_var)
     ! look for unlimited dim (time_counter)
    istatus=NF90_INQUIRE         (incid,    unlimitedDimId=id_dimunlim       )
    istatus=NF90_INQUIRE_VARIABLE(incid,id_var,ndims=inbdim,dimids=inldim(:) )

    !  if the last dim of id_var is time, then adjust the starting point
    istart(:) = 1     ; icount(:) = 1    ! default
    istart(1) = iimin ; istart(2) = ijmin
    icount(1) = kpi   ; icount(2) = kpj  ! in any case
    IF ( inldim(inbdim) == id_dimunlim ) istart(inbdim) = itime ! assume than last dim is UNLIM
    IF ( inbdim == 4                   ) istart(3     ) = ilev

    istatus=NF90_PUT_VAR(incid,id_var, ptab,start=istart, count=icount )

    IF (PRESENT(kwght)) THEN
      istatus=NF90_PUT_ATT(incid,id_var,'iweight',kwght)
    ENDIF

    reputvarr4=istatus

    istatus=NF90_CLOSE(incid)

  END FUNCTION reputvarr4


  INTEGER(KIND=4) FUNCTION putvarzo(kout, kid, ptab, klev, kpi, kpj, ktime)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION putvarzo  ***
    !!
    !! ** Purpose : Copy a 2D level of ptab in already open file kout, using variable kid
    !!              This variant deals with degenerated 2D (1 x jpj) zonal files
    !!
    !!----------------------------------------------------------------------
    INTEGER(KIND=4),              INTENT(in) :: kout             ! ncid of output file
    INTEGER(KIND=4),              INTENT(in) :: kid              ! varid of output variable
    REAL(KIND=4), DIMENSION(:),   INTENT(in) :: ptab             ! 1D array to write in file (x-z or y-z )
    INTEGER(KIND=4),              INTENT(in) :: klev             ! level at which ptab will be written
    INTEGER(KIND=4),              INTENT(in) :: kpi, kpj         ! dimension of ptab
    INTEGER(KIND=4), OPTIONAL,    INTENT(in) :: ktime            ! time to write

    INTEGER(KIND=4)               :: istatus, itime, ilev, id_dimunlim, inbdim
    INTEGER(KIND=4), DIMENSION(4) :: istart, icount, inldim
    !!----------------------------------------------------------------------
    ilev=klev
    IF (PRESENT(ktime) ) THEN
       itime=ktime
    ELSE
       itime=1
    ENDIF

     ! look for unlimited dim (time_counter)
    istatus=NF90_INQUIRE         (kout, unlimitedDimId=id_dimunlim       )
    istatus=NF90_INQUIRE_VARIABLE(kout,kid,ndims=inbdim,dimids=inldim(:) )

    !  if the third dim of id_var is time, then adjust the starting point 
    !  to take ktime into account (case XYT file)
    istart(:) = 1    ; icount(:) = 1    ! default 
    icount(1) = kpi  ; icount(2) = kpj  ! in any case
    IF ( inldim(inbdim) == id_dimunlim ) istart(inbdim) = itime ! assume than last dim is UNLIM
    IF ( inbdim == 4                   ) istart(3) = klev

    istatus=NF90_PUT_VAR(kout,kid, ptab, start=istart,count=icount)
    putvarzo=istatus

  END FUNCTION putvarzo


  INTEGER(KIND=4) FUNCTION putvar1d4(kout, ptab, kk, cdtype)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION putvar1d4  ***
    !!
    !! ** Purpose :  Copy 1D variable (size kk) hold in ptab,  with id 
    !!               kid, into file id kout 
    !!
    !! ** Method  : cdtype is either T (time_counter) or D (depth.)
    !!                         LON (1D longitude) or LAT (1D latitude)
    !!
    !!----------------------------------------------------------------------
    INTEGER(KIND=4),            INTENT(in) :: kout   ! ncid of output file
    REAL(KIND=4), DIMENSION(kk),INTENT(in) :: ptab   ! 1D array to write in file
    INTEGER(KIND=4),            INTENT(in) :: kk     ! number of elements in ptab
    CHARACTER(LEN=1),           INTENT(in) :: cdtype ! either T or D LON or LAT

    INTEGER(KIND=4)               :: istatus, iid
    INTEGER(KIND=4), DIMENSION(1) :: istart, icount
    !!----------------------------------------------------------------------
    SELECT CASE ( cdtype )
    CASE ('T', 't' ) 
       iid = nid_tim
    CASE ('D', 'd' )
       iid = nid_dep
    CASE ('X', 'x' )
       iid = nid_lon1d
    CASE ('Y', 'y' )
       iid = nid_lat1d
    END SELECT

    istart(:) = 1
    icount(:) = kk
    istatus=NF90_PUT_VAR(kout,iid, ptab, start=istart,count=icount)
    putvar1d4=istatus

  END FUNCTION putvar1d4

  INTEGER(KIND=4) FUNCTION putvar1d8(kout, dtab, kk, cdtype)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION putvar1d8  ***
    !!
    !! ** Purpose :  Copy 1D variable (size kk) hold in ptab,  with id 
    !!               kid, into file id kout 
    !!
    !! ** Method  : cdtype is either T (time_counter) or D (depth.)
    !!                         LON (1D longitude) or LAT (1D latitude)
    !!
    !!----------------------------------------------------------------------
    INTEGER(KIND=4),            INTENT(in) :: kout   ! ncid of output file
    REAL(KIND=8), DIMENSION(kk),INTENT(in) :: dtab   ! 1D array to write in file
    INTEGER(KIND=4),            INTENT(in) :: kk     ! number of elements in ptab
    CHARACTER(LEN=1),           INTENT(in) :: cdtype ! either T or D LON or LAT

    INTEGER(KIND=4)               :: istatus, iid
    INTEGER(KIND=4), DIMENSION(1) :: istart, icount
    !!----------------------------------------------------------------------
    SELECT CASE ( cdtype )
    CASE ('T', 't' ) 
       iid = nid_tim
    CASE ('D', 'd' )
       iid = nid_dep
    CASE ('X', 'x' )
       iid = nid_lon1d
    CASE ('Y', 'y' )
       iid = nid_lat1d
    END SELECT

    istart(:) = 1
    icount(:) = kk
    istatus=NF90_PUT_VAR(kout,iid, dtab, start=istart,count=icount)
    putvar1d8=istatus

  END FUNCTION putvar1d8

  INTEGER(KIND=4) FUNCTION putvar1d_bounds(kout, ptab, kk, cdtype)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION putvar1d4  ***
    !!
    !! ** Purpose :  Copy 1D variable (size kk) hold in ptab,  with id 
    !!               kid, into file id kout 
    !!
    !! ** Method  : cdtype is either T (time_counter) or D (depth.)
    !!                         LON (1D longitude) or LAT (1D latitude)
    !!
    !!----------------------------------------------------------------------
    INTEGER(KIND=4),            INTENT(in) :: kout   ! ncid of output file
    REAL(KIND=4), DIMENSION(kk,2),INTENT(in) :: ptab   ! 1D array to write in file
    INTEGER(KIND=4),            INTENT(in) :: kk     ! number of elements in ptab
    CHARACTER(LEN=1),           INTENT(in) :: cdtype ! either T or D LON or LAT

    INTEGER(KIND=4)               :: istatus, iid
    INTEGER(KIND=4), DIMENSION(2) :: istart, icount
    !!----------------------------------------------------------------------
    SELECT CASE ( cdtype )
    CASE ('T', 't' )
       iid = nid_timb
    CASE DEFAULT
       PRINT *, 'E R R O R: CASE ',cdtype,' do not coded'
       STOP 98
    END SELECT

    istart(:) = 1
    icount(1) = 2; icount(2)=kk
    istatus=NF90_PUT_VAR(kout,iid, ptab, start=istart,count=icount)
    putvar1d_bounds=istatus
  END FUNCTION putvar1d_bounds


  INTEGER(KIND=4) FUNCTION reputvar1d4(cdfile, cdvar, ptab, kk )
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION reputvar1d4  ***
    !!
    !! ** Purpose : Copy 1d variable cdfvar in cdfile, an already existing file
    !!              ptab is the 1d array to write and kk the size of ptab
    !!
    !! ** Method  :   
    !!
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*),            INTENT(in) :: cdfile      ! filename
    CHARACTER(LEN=*),            INTENT(in) :: cdvar       ! variable name
    REAL(KIND=4), DIMENSION(kk), INTENT(in) :: ptab        ! 1D array to write in file
    INTEGER(KIND=4),             INTENT(in) :: kk          ! number of elements in ptab

    INTEGER                                 :: istatus, incid, id
    !!-----------------------------------------------------------
    istatus = NF90_OPEN(cdfile, NF90_WRITE, incid)
    istatus = NF90_INQ_VARID(incid, cdvar, id )
    istatus = NF90_PUT_VAR(incid, id, ptab, start=(/1/), count=(/kk/) )
    reputvar1d4 = istatus
    istatus = NF90_CLOSE(incid)

  END FUNCTION reputvar1d4

  INTEGER(KIND=4) FUNCTION reputvar1d8(cdfile, cdvar, dtab, kk )
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION reputvar1d8  ***
    !!
    !! ** Purpose : Copy 1d variable cdfvar in cdfile, an already existing file
    !!              ptab is the 1d array to write and kk the size of ptab
    !!
    !! ** Method  :   
    !!
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*),            INTENT(in) :: cdfile      ! filename
    CHARACTER(LEN=*),            INTENT(in) :: cdvar       ! variable name
    REAL(KIND=8), DIMENSION(kk), INTENT(in) :: dtab        ! 1D array to write in file
    INTEGER(KIND=4),             INTENT(in) :: kk          ! number of elements in ptab

    INTEGER                                 :: istatus, incid, id
    !!-----------------------------------------------------------
    istatus = NF90_OPEN(cdfile, NF90_WRITE, incid)
    istatus = NF90_INQ_VARID(incid, cdvar, id )
    istatus = NF90_PUT_VAR(incid, id, dtab, start=(/1/), count=(/kk/) )
    reputvar1d8 = istatus
    istatus = NF90_CLOSE(incid)

  END FUNCTION reputvar1d8


  INTEGER(KIND=4) FUNCTION putvar0dt(kout, kid, pvalue, ktime)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION putvar0dt  ***
    !!
    !! ** Purpose : Copy single value, with id varid, into file id kout
    !!
    !! ** Method  :  use argument as dummy array(1,1) 
    !!
    !!----------------------------------------------------------------------
    INTEGER(KIND=4),              INTENT(in) :: kout   ! ncid of output file
    INTEGER(KIND=4),              INTENT(in) :: kid    ! id of the variable
    REAL(KIND=4), DIMENSION(1,1), INTENT(in) :: pvalue ! single value to write in file
    INTEGER(KIND=4), OPTIONAL,    INTENT(in) :: ktime  ! time frame to write

    INTEGER(KIND=4) :: istatus
    INTEGER(KIND=4) :: itime
    INTEGER(KIND=4) :: id_dimunlim, inbdim
    INTEGER(KIND=4), DIMENSION(4) :: inldim, istart, icount
    !!----------------------------------------------------------------------
    IF (PRESENT(ktime) ) THEN
      itime = ktime
    ELSE
      itime = 1
    ENDIF 
    
     ! look for unlimited dim (time_counter)
    istatus=NF90_INQUIRE(kout, unlimitedDimId=id_dimunlim)
    istatus=NF90_INQUIRE_VARIABLE(kout,kid,ndims=inbdim,dimids=inldim(:) )

    istart(:) = 1
    icount(:) = 1
    IF ( inldim(inbdim) == id_dimunlim ) THEN ! var has an unlimited dim
       istart(inbdim) = itime ! assume than last dim is UNLIM 
    ENDIF

    istatus=NF90_PUT_VAR(kout, kid, pvalue, start=istart, count=icount )

    putvar0dt=istatus

  END FUNCTION putvar0dt

  INTEGER(KIND=4) FUNCTION putvar0ds(kout, kid, pvalue, ktime)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION putvar0ds  ***
    !!
    !! ** Purpose : Copy single value, with id varid, into file id kout
    !!
    !! ** Method  : use argument as scalar
    !!
    !!----------------------------------------------------------------------
    INTEGER(KIND=4),              INTENT(in) :: kout   ! ncid of output file
    INTEGER(KIND=4),              INTENT(in) :: kid    ! id of the variable
    REAL(KIND=4),                 INTENT(in) :: pvalue ! single value to write in file
    INTEGER(KIND=4), OPTIONAL,    INTENT(in) :: ktime  ! time frame to write

    INTEGER(KIND=4) :: istatus
    INTEGER(KIND=4) :: itime
    INTEGER(KIND=4) :: id_dimunlim, inbdim
    INTEGER(KIND=4), DIMENSION(4) :: inldim, istart, icount

    REAL(KIND=4), DIMENSION(1,1)             :: ztab   ! dummy array for PUT_VAR
    !!----------------------------------------------------------------------
    IF (PRESENT(ktime) ) THEN
      itime = ktime
    ELSE
      itime = 1
    ENDIF

     ! look for unlimited dim (time_counter)
    istatus=NF90_INQUIRE(kout, unlimitedDimId=id_dimunlim)
    istatus=NF90_INQUIRE_VARIABLE(kout,kid,ndims=inbdim,dimids=inldim(:) )

    istart(:) = 1
    icount(:) = 1
    IF ( inldim(inbdim) == id_dimunlim ) THEN ! var has an unlimited dim
       istart(inbdim) = itime ! assume than last dim is UNLIM 
    ENDIF
    ztab = pvalue

    istatus=NF90_PUT_VAR(kout, kid, ztab, start=istart, count=icount )

    putvar0ds=istatus

  END FUNCTION putvar0ds

  INTEGER(KIND=4) FUNCTION closeout(kout)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION closeout  ***
    !!
    !! ** Purpose :  close opened output files 
    !!
    !!----------------------------------------------------------------------
    INTEGER(KIND=4), INTENT(in) :: kout   ! ncid of file to be closed
    !!----------------------------------------------------------------------
    closeout=NF90_CLOSE(kout)

  END FUNCTION closeout

  INTEGER(KIND=4) FUNCTION ncopen(cdfile)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION  ncopen  ***
    !!
    !! ** Purpose : open file cdfile and return file ID
    !!
    !!---------------------------------------------------------------------
      CHARACTER(LEN=*), INTENT(in) :: cdfile ! file name

      INTEGER(KIND=4) :: istatus, incid
    !!---------------------------------------------------------------------
      istatus = NF90_OPEN(cdfile,NF90_WRITE,incid)

      ncopen=incid

  END FUNCTION ncopen

  SUBROUTINE ERR_HDL(kstatus)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE ERR_HDL  ***
    !!
    !! ** Purpose : Error handle for NetCDF routine.
    !!              Stop if kstatus indicates error conditions.  
    !!
    !!----------------------------------------------------------------------
    INTEGER(KIND=4), INTENT(in) ::  kstatus
    !!----------------------------------------------------------------------
    IF (kstatus /=  NF90_NOERR ) THEN
       PRINT *, 'ERROR in NETCDF routine, status=',kstatus
       PRINT *,NF90_STRERROR(kstatus)
       STOP 98
    END IF

  END SUBROUTINE ERR_HDL


  SUBROUTINE gettimeseries (cdfile, cdvar, kilook, kjlook, klev, ldncdf)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE gettimeseries  ***
    !!
    !! ** Purpose : Display a 2 columns output ( time, variable) for
    !!              a given variable of a given file at a given point 
    !!
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*),          INTENT(in) :: cdfile, cdvar
    INTEGER(KIND=4),           INTENT(in) :: kilook,kjlook
    INTEGER(KIND=4), OPTIONAL, INTENT(in) :: klev
    LOGICAL,         OPTIONAL, INTENT(in) :: ldncdf

    INTEGER(KIND=4)                         :: jt, jk
    INTEGER(KIND=4)                         :: iint
    INTEGER(KIND=4)                         :: istatus
    INTEGER(KIND=4)                         :: incid, id_t, id_var
    INTEGER(KIND=4)                         :: indim
    REAL(KIND=4), DIMENSION(:), ALLOCATABLE :: ztime, zval
    REAL(KIND=4)                            :: ztmp  
    REAL(KIND=4)                            :: zao=0., zsf=1.0   !: add_offset, scale_factor
    CHARACTER(LEN=256)                      :: clname
    LOGICAL                                 :: ll_netcdf=.false.
    !!----------------------------------------------------------------------
    ! Klev can be used to give the model level we want to look at
    IF ( PRESENT(klev) ) THEN
       jk=klev
    ELSE
       jk=1
    ENDIF

    IF ( PRESENT(ldncdf) ) THEN
       ll_netcdf=ldncdf
    ELSE
       ll_netcdf=.false.
    ENDIF


    ! Open cdf dataset
    istatus=NF90_OPEN(cdfile,NF90_NOWRITE,incid)

    ! read time dimension
    istatus=NF90_INQ_DIMID(incid, cn_t, id_t)
    istatus=NF90_INQUIRE_DIMENSION(incid,id_t, len=iint)

    ! Allocate space
    ALLOCATE (ztime(iint), zval(iint) )

    ! gettime
    istatus=NF90_INQ_VARID(incid,cn_vtimec,id_var)
    istatus=NF90_GET_VAR(incid,id_var,ztime,(/1/),(/iint/) )

    ! read variable
    istatus=NF90_INQ_VARID(incid,cdvar,id_var)

    ! look for scale_factor and add_offset attribute:
    istatus=NF90_GET_ATT(incid,id_var,'add_offset',ztmp)
    IF ( istatus == NF90_NOERR ) zao = ztmp
    istatus=NF90_GET_ATT(incid,id_var,'scale_factor',ztmp)
    IF ( istatus == NF90_NOERR ) zsf = ztmp

    ! get number of dimension of the variable ( either x,y,t or x,y,z,t )
    istatus=NF90_INQUIRE_VARIABLE(incid,id_var, ndims=indim)
    IF ( indim == 3 ) THEN
       istatus=NF90_GET_VAR(incid,id_var,zval,(/kilook,kjlook,1/),(/1,1,iint/) )
    ELSE IF ( indim == 4 ) THEN
       istatus=NF90_GET_VAR(incid,id_var,zval,(/kilook,kjlook,jk,1/),(/1,1,1,iint/) )
    ELSE 
       PRINT *,'  ERROR : variable ',TRIM(cdvar),' has ', indim, &
            &       ' dimensions !. Only 3 or 4 supported'
       STOP 98
    ENDIF

    ! convert to physical values
    zval=zval*zsf + zao

    ! display results :
    DO jt=1,iint
       PRINT *,ztime(jt)/86400., zval(jt)
    ENDDO

    istatus=NF90_CLOSE(incid)
    IF ( ll_netcdf )  THEN
      WRITE (clname,'("probe_",i4.4,"_",i4.4,"_",a,".nc")') kilook, kjlook, TRIM(cdvar)
    ENDIF
    ! not finished ...

  END SUBROUTINE gettimeseries

  LOGICAL FUNCTION chkfile (cd_file, ld_verbose ) 
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION chkfile  ***
    !!
    !! ** Purpose :  Check if cd_file exists.
    !!               Return false if it exists, true if it does not
    !!               Do nothing is filename is 'none'
    !!
    !! ** Method  : Doing it this way allow statements such as
    !!              IF ( chkfile( cf_toto) ) STOP 99 ! missing file
    !!
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*),  INTENT(in) :: cd_file
    LOGICAL, OPTIONAL, INTENT(in) :: ld_verbose

    LOGICAL                      :: ll_exist, ll_verbose
    !!----------------------------------------------------------------------
    IF ( PRESENT(ld_verbose) ) THEN
       ll_verbose = ld_verbose
    ELSE
       ll_verbose = .TRUE.
    ENDIF

    IF ( TRIM(cd_file) /= 'none')  THEN 
       INQUIRE (file = TRIM(cd_file), EXIST=ll_exist)

       IF (ll_exist) THEN
          chkfile = .false.
       ELSE
          IF ( ll_verbose ) PRINT *, ' File ',TRIM(cd_file),' is missing '
          chkfile = .true.
       ENDIF
    ELSE  
       chkfile = .false.  ! 'none' file is not checked
    ENDIF

  END FUNCTION chkfile

  LOGICAL FUNCTION chkvar (cd_file, cd_var)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION chkvar  ***
    !!
    !! ** Purpose :  Check if cd_var exists in file cd_file.
    !!               Return false if it exists, true if it does not
    !!               Do nothing is varname is 'none'
    !!
    !! ** Method  : Doing it this way allow statements such as
    !!              IF ( chkvar( cf_toto, cv_toto) ) STOP 99 ! missing var
    !!
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*), INTENT(in) :: cd_file
    CHARACTER(LEN=*), INTENT(in) :: cd_var

    INTEGER(KIND=4)              :: istatus
    INTEGER(KIND=4)              :: incid, id_t, id_var

    !!----------------------------------------------------------------------
    IF ( TRIM(cd_var) /= 'none')  THEN
    
       ! Open cdf dataset
       istatus = NF90_OPEN(cd_file, NF90_NOWRITE,incid)
       ! Read variable
       istatus = NF90_INQ_VARID(incid, cd_var, id_var)

       IF ( istatus == NF90_NOERR ) THEN
          chkvar = .false.
       ELSE
          PRINT *, ' '
          PRINT *, ' Var ',TRIM(cd_var),' is missing in file ',TRIM(cd_file)
          chkvar = .true.
       ENDIF
       
       ! Close file
       istatus = NF90_CLOSE(incid) 
    ELSE
       chkvar = .false.  ! 'none' file is not checked
    ENDIF

  END FUNCTION chkvar

  CHARACTER(LEN=256) FUNCTION Get_Env ( cd_env )
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION Get_Env  ***
    !!
    !! ** Purpose :  A wrapper for system routine getenv
    !!
    !! ** Method  :  Call getenv
    !!
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*), INTENT(in) :: cd_env
    !!----------------------------------------------------------------------
    CALL getenv( TRIM(cd_env), Get_Env )
    IF ( TRIM(Get_Env) /= '' ) THEN
      PRINT *,'Environment found : ',TRIM(cd_env),' = ', TRIM(Get_Env)
    ENDIF

  END FUNCTION Get_Env

  FUNCTION GetNcFile (cd_file)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION GetNcFile  ***
    !!
    !! ** Purpose :  fills in the ncfile  structure corresponding to the file
    !!               given in argument 
    !!
    !! ** Method  :  Use NF90 function to get the ad-hoc information 
    !!
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*), INTENT(in) :: cd_file
    TYPE(ncfile)                 :: GetNcFile

    INTEGER(KIND=4) :: jvar, jdim                      ! loop index
    INTEGER(KIND=4) :: ierr, idx, idy, idz, idt, idb   ! error status and dimids
    !!----------------------------------------------------------------------
    GetNcFile%c_fnam = cd_file
    ierr = NF90_OPEN(cd_file, NF90_NOWRITE, GetNcFile%ncid )
    ierr = NF90_INQUIRE(GetNcFile%ncid, nDimensions    = GetNcFile%ndims,  &
         &                              nVariables     = GetNcFile%nvars,  &
         &                              nAttributes    = GetNcFile%natts,  &
         &                              unlimitedDimId = GetNcFile%iunlim  )
    ALLOCATE (GetNcFile%nvdim   (GetNcFile%nvars) )
    ALLOCATE (GetNcFile%nvid    (GetNcFile%nvars) )
    ALLOCATE (GetNcFile%c_vnam  (GetNcFile%nvars) )
    ALLOCATE (GetNcFile%nvatt   (GetNcFile%nvars) )
    ALLOCATE (GetNcFile%itype   (GetNcFile%nvars) )
    ALLOCATE (GetNcFile%c_dnam  (GetNcFile%ndims) )
    ALLOCATE (GetNcFile%nlen    (GetNcFile%ndims) )
    ALLOCATE (GetNcFile%idimids (GetNcFile%nvars,GetNcFile%ndims) )

    ! Look for dimensions
    DO jdim = 1, GetNcFile%ndims
       ierr = NF90_INQUIRE_DIMENSION(GetNcFile%ncid,jdim,                 &
            &                         name   = GetNcFile%c_dnam(jdim),    &
            &                         len    = GetNcFile%nlen  (jdim) )
    ENDDO
    ! Look for variables
    DO jvar = 1, GetNcFile%nvars
       ierr = NF90_INQUIRE_VARIABLE (GetNcFile%ncid, jvar,                &
            &                         name   = GetNcFile%c_vnam(jvar),    &
            &                         xtype  = GetNcFile%itype(jvar),     &
            &                         ndims  = GetNcFile%nvdim(jvar),     &
            &                         dimids = GetNcFile%idimids(jvar,:), &
            &                         nAtts  = GetNcFile%nvatt(jvar),     &
            &                         contiguous = GetNcFile%lconti(jvar),   &
            &                         chunksizes = GetNcFile%ichunk(jvar,:), &
            &                         deflate_level = GetNcFile%ideflat(jvar)      )
    END DO
    ! Look for attributes
    ierr = NF90_GET_ATT (GetNcFile%ncid, NF90_GLOBAL, 'DOMAIN_number_total'   , GetNcFile%number_total       )
    ierr = NF90_GET_ATT (GetNcFile%ncid, NF90_GLOBAL, 'DOMAIN_number      '   , GetNcFile%number             )
    ierr = NF90_GET_ATT (GetNcFile%ncid, NF90_GLOBAL, 'DOMAIN_dimensions_ids' , GetNcFile%idimensions_ids(:) )
    ierr = NF90_GET_ATT (GetNcFile%ncid, NF90_GLOBAL, 'DOMAIN_size_global'    , GetNcFile%isize_global(:)    )
    ierr = NF90_GET_ATT (GetNcFile%ncid, NF90_GLOBAL, 'DOMAIN_size_local'     , GetNcFile%isize_local(:)     )
    ierr = NF90_GET_ATT (GetNcFile%ncid, NF90_GLOBAL, 'DOMAIN_position_first' , GetNcFile%iposition_first(:) )
    ierr = NF90_GET_ATT (GetNcFile%ncid, NF90_GLOBAL, 'DOMAIN_position_last'  , GetNcFile%iposition_last(:)  )
    ierr = NF90_GET_ATT (GetNcFile%ncid, NF90_GLOBAL, 'DOMAIN_halo_size_start', GetNcFile%ihalo_size_start(:))
    ierr = NF90_GET_ATT (GetNcFile%ncid, NF90_GLOBAL, 'DOMAIN_halo_size_end'  , GetNcFile%ihalo_size_end(:)  )
    ierr = NF90_GET_ATT (GetNcFile%ncid, NF90_GLOBAL, 'DOMAIN_type'           , GetNcFile%c_type             )

    ! NOTE : for recombined files, no more DOMAIN attributes !!!
    ! DOMAIN_dimensions_ids gives ids for x, y 
    idx = GetNcFile%idimensions_ids(1)
    idy = GetNcFile%idimensions_ids(2)
    ! time is unlimited dim
    idt = GetNcFile%iunlim

    ! try to infer size of the domain assuming some basis:
    ! (1) 2D var are (x,y)
    ! (2) time dim is unlimited
    ! (3) allowed shape of var : x,y ; x,y,t ; x,y,z,t  ; x,y,z   ; t   ; z 

    ! Look for x y z t tbound dim id
    idx=-1 ; idy=-1 ; idz=-1 ; idt=-1 ; idb=-1

    DO jvar = 1, GetNcFile%nvars
       GetNcFile%nvid(jvar) = jvar
       IF ( GetNcFile%nvdim(jvar) == 2 ) THEN  
          IF ( GetNcFile%idimids(jvar,2) == GetNcFile%iunlim ) THEN  ! catch a time_bounds, time_counter var
            idb = GetNcFile%idimids(jvar,1)
          ELSE
          idx = GetNcFile%idimids(jvar,1) 
          idy = GetNcFile%idimids(jvar,2) 
          ENDIF
       ELSE IF ( GetNcFile%nvdim(jvar) == 3 ) THEN 
          idx = GetNcFile%idimids(jvar,1) 
          idy = GetNcFile%idimids(jvar,2) 
          IF ( GetNcFile%idimids(jvar,3) == GetNcFile%iunlim ) THEN
             idt = GetNcFile%idimids(jvar,3) 
          ELSE
             idz = GetNcFile%idimids(jvar,3) 
          ENDIF
       ELSE IF ( GetNcFile%nvdim(jvar) == 4 ) THEN
          idx = GetNcFile%idimids(jvar,1)  
          idy = GetNcFile%idimids(jvar,2)  
          idz = GetNcFile%idimids(jvar,3)  
          IF ( GetNcFile%idimids(jvar,4) /= GetNcFile%iunlim ) THEN
             PRINT *, ' 4D variables must have an unlimited time dimension ...'
             PRINT *, ' Cannot process this file :', TRIM(cd_file)
             STOP 98
          ENDIF
          idt = GetNcFile%idimids(jvar,4) 
       ENDIF
    END DO

    GetNcFile%idx=idx
    GetNcFile%idy=idy
    GetNcFile%idz=idz
    GetNcFile%idt=idt
    GetNcFile%idb=idb

    IF ( idx == -1 .OR. idy == -1 ) THEN 
       PRINT *, ' ERROR : no x, y dimensions found'
       STOP 98
    ENDIF

    ! get dimensions
    GetNcFile%npi=0 ; GetNcFile%npj=0 ; GetNcFile%npk=0 ; GetNcFile%npt=0 ; GetNcFile%npb=0

    ierr = NF90_INQUIRE_DIMENSION( GetNcFile%ncid, idx,         &
         &                        name = GetNcFile%c_dnam(idx), &
         &                        len  = GetNcFile%npi          )
    GetNcFile%nlen(idx) = GetNcFile%npi
    ierr = NF90_INQUIRE_DIMENSION( GetNcFile%ncid, idy,         &
         &                        name = GetNcFile%c_dnam(idy), &
         &                        len  = GetNcFile%npj          )
    GetNcFile%nlen(idy) = GetNcFile%npj

    IF ( idz /= -1 ) THEN
       ierr = NF90_INQUIRE_DIMENSION( GetNcFile%ncid, idz,         &
            &                        name = GetNcFile%c_dnam(idz), &
            &                        len  = GetNcFile%npk          )
       GetNcFile%nlen(idz) = GetNcFile%npk
    ENDIF

    IF ( idt /= -1 ) THEN
       ierr = NF90_INQUIRE_DIMENSION( GetNcFile%ncid, idt,         &
            &                        name = GetNcFile%c_dnam(idt), &
            &                        len  = GetNcFile%npt          )
       GetNcFile%nlen(idt) = GetNcFile%npt
    ENDIF

    IF ( idb /= -1 ) THEN
       ierr = NF90_INQUIRE_DIMENSION( GetNcFile%ncid, idb,         &
            &                        name = GetNcFile%c_dnam(idb), &
            &                        len  = GetNcFile%npb          )
       GetNcFile%nlen(idb) = GetNcFile%npb
    ENDIF
    ! fill in DOMAIN attributes 
    ierr = NF90_GET_ATT (GetNcFile%ncid, NF90_GLOBAL, 'DOMAIN_number_total'   , GetNcFile%number_total       )
    ierr = NF90_GET_ATT (GetNcFile%ncid, NF90_GLOBAL, 'DOMAIN_number      '   , GetNcFile%number             )
    ierr = NF90_GET_ATT (GetNcFile%ncid, NF90_GLOBAL, 'DOMAIN_dimensions_ids' , GetNcFile%idimensions_ids(:) )
    ierr = NF90_GET_ATT (GetNcFile%ncid, NF90_GLOBAL, 'DOMAIN_size_global'    , GetNcFile%isize_global(:)    )
    ierr = NF90_GET_ATT (GetNcFile%ncid, NF90_GLOBAL, 'DOMAIN_size_local'     , GetNcFile%isize_local(:)     )
    ierr = NF90_GET_ATT (GetNcFile%ncid, NF90_GLOBAL, 'DOMAIN_position_first' , GetNcFile%iposition_first(:) )
    ierr = NF90_GET_ATT (GetNcFile%ncid, NF90_GLOBAL, 'DOMAIN_position_last'  , GetNcFile%iposition_last(:)  )
    ierr = NF90_GET_ATT (GetNcFile%ncid, NF90_GLOBAL, 'DOMAIN_halo_size_start', GetNcFile%ihalo_size_start(:))
    ierr = NF90_GET_ATT (GetNcFile%ncid, NF90_GLOBAL, 'DOMAIN_halo_size_end'  , GetNcFile%ihalo_size_end(:)  )
    ierr = NF90_GET_ATT (GetNcFile%ncid, NF90_GLOBAL, 'DOMAIN_type'           , GetNcFile%c_type             )

    ! CORRECT for Halo :
    GetNcfile%isize_local(:)     = GetNcfile%isize_local(:)     - GetNcFile%ihalo_size_start(:) - GetNcFile%ihalo_size_end(:)
    GetNcFile%iposition_first(:) = GetNcFile%iposition_first(:) + GetNcFile%ihalo_size_start(:)
    GetNcFile%iposition_last(:)  = GetNcFile%iposition_last(:)  - GetNcFile%ihalo_size_end(:)

    GetNcFile%npi       = GetNcfile%isize_local(1)
    GetNcFile%npj       = GetNcfile%isize_local(2)
    GetNcFile%nlen(idx) = GetNcFile%npi
    GetNcFile%nlen(idy) = GetNcFile%npj

  END FUNCTION GetNcFile

END MODULE cdfio

PROGRAM cdfstdevts
  !!======================================================================
  !!                     ***  PROGRAM  cdfstdevts  ***
  !!=====================================================================
  !!  ** Purpose : Compute the RMS of T and S, from the mean squared value.
  !!
  !!  ** Method  : Read gridT and gridT2 and compute rms
  !!
  !! History : 2.1  : 11/2004  : J.M. Molines : Original code
  !!           3.0  : 05/2011  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class statistics
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                            :: jk, jt, jvar      ! dummy loop index
  INTEGER(KIND=4)                            :: narg, iargc       ! command line
  INTEGER(KIND=4)                            :: ijarg             ! command line
  INTEGER(KIND=4)                            :: npiglo, npjglo    ! size of the domain
  INTEGER(KIND=4)                            :: npk, npt          ! size of the domain
  INTEGER(KIND=4)                            :: ncout             ! ncid of output variable
  INTEGER(KIND=4)                            :: ierr              ! error status
  INTEGER(KIND=4), DIMENSION(2)              :: ipko, id_varout   ! output variable

  REAL(KIND=4), DIMENSION(:,:),  ALLOCATABLE :: zvbar, zvba2      ! mean and mean2 variable

  REAL(KIND=8), DIMENSION(:),    ALLOCATABLE :: dtim              ! time counter
  REAL(KIND=8), DIMENSION(:,:),  ALLOCATABLE :: dsdev             ! standard deviation

  CHARACTER(LEN=256)                         :: cf_tfil           ! input mean file name
  CHARACTER(LEN=256)                         :: cf_tfil2          ! input mean2 file name
  CHARACTER(LEN=256)                         :: cf_sfil           ! input mean file name
  CHARACTER(LEN=256)                         :: cf_sfil2          ! input mean2 file name
  CHARACTER(LEN=256)                         :: cf_out = 'stdevts.nc'! output file name
  CHARACTER(LEN=256)                         :: cv_in, cv_in2     ! input variable names
  CHARACTER(LEN=256)                         :: cldum             ! dummy character variable
  CHARACTER(LEN=256)                         :: cl_votemper       ! local name for T
  CHARACTER(LEN=256)                         :: cl_vosaline       ! local name for S
  CHARACTER(LEN=256)                         :: cl_votemper2      ! local name for T2
  CHARACTER(LEN=256)                         :: cl_vosaline2      ! local name for S2
  CHARACTER(LEN=256), DIMENSION(4)           :: cv_namesi         ! input variable names
  CHARACTER(LEN=256), DIMENSION(4)           :: cl_fil            ! input variable names

  TYPE(variable), DIMENSION(2)               :: stypvaro          ! output data structure

  LOGICAL                                    :: lchk = .FALSE.    ! flag for missing files
  LOGICAL                                    :: lnc4 = .FALSE.    ! Use nc4 with chunking and deflation
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfstdevts -t T-file -t2 T2-file [-o OUT-file] [-nc4] ...'
     PRINT *,'                   [-s S-file] [-s2 S2-file ] ...'
     PRINT *,'           [-var VAR-temp VAR-sal VAR-temp2 VAR-sal2 ]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the standard deviation of the temperature and salinity from'
     PRINT *,'       their mean and  mean squared values.  The mean squared values for T'
     PRINT *,'       and S are not automatically computed with cdfmoy (need some namelist'
     PRINT *,'       modification). Consider using the more generic program ''cdfstd'' if'
     PRINT *,'       you do not already have the mean T2 and mean S2.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -t T-file  : netcdf file with mean values for T, S' 
     PRINT *,'       -t T2-file : netcdf file with mean squared values for T,S' 
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-t S-file ]  : salinity file if not in T-file.'
     PRINT *,'       [-t S2-file]  : salinity sqd file if not in T2-file.'
     PRINT *,'       [-o OUT-file] : specify output file name instead of ',TRIM(cf_out)
     PRINT *,'       [-nc4 ] : Use netcdf4 output with chunking and deflation level 1.'
     PRINT *,'            This option is effective only if cdftools are compiled with'
     PRINT *,'            a netcdf library supporting chunking and deflation.'
     PRINT *,'       [-var VAR-temp VAR-sal VAR-temp2 VAR-sal2 ] : Specify variable names'
     PRINT *,'            for mean and mean-squared temperature and salinity.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       none' 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : ', TRIM(cn_votemper)//'_stdev, same unit than the input.'
     PRINT *,'                     ', TRIM(cn_vosaline)//'_stdev, same unit than the input.'
     PRINT *,'      '
     PRINT *,'     SEA ALSO :'
     PRINT *,'       cdfstd, cdfrmsssh, cdfstdevw, cdfstats.'
     PRINT *,'      '
     STOP 
  ENDIF

  cl_votemper  = cn_votemper
  cl_vosaline  = cn_vosaline
  cl_votemper2 = TRIM(cn_votemper)//'_sqd'
  cl_vosaline2 = TRIM(cn_vosaline)//'_sqd'

  cf_sfil ='none'
  cf_sfil2='none'

  ijarg = 1  
  DO WHILE ( ijarg <= narg) 
     CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-t' ) ; CALL getarg(ijarg, cf_tfil ) ; ijarg=ijarg+1
     CASE ( '-t2') ; CALL getarg(ijarg, cf_tfil2) ; ijarg=ijarg+1
        ! option
     CASE ( '-s' ) ; CALL getarg(ijarg, cf_sfil ) ; ijarg=ijarg+1
     CASE ( '-s2') ; CALL getarg(ijarg, cf_sfil2) ; ijarg=ijarg+1
     CASE ( '-o' ) ; CALL getarg(ijarg, cf_out  ) ; ijarg=ijarg+1
     CASE ('-nc4') ; lnc4 = .TRUE.
     CASE ('-var') ; CALL getarg(ijarg, cl_votemper ) ; ijarg=ijarg+1
       ;           ; CALL getarg(ijarg, cl_vosaline ) ; ijarg=ijarg+1
       ;           ; CALL getarg(ijarg, cl_votemper2) ; ijarg=ijarg+1
       ;           ; CALL getarg(ijarg, cl_vosaline2) ; ijarg=ijarg+1
     CASE DEFAULT  ; PRINT *,' ERROR : ', TRIM(cldum),' : unknown option.'
     END SELECT
  ENDDO

  IF ( cf_sfil  == 'none' ) cf_sfil  = cf_tfil
  IF ( cf_sfil2 == 'none' ) cf_sfil2 = cf_tfil2

  cv_namesi(1) = cl_votemper  ; cl_fil(1)=cf_tfil
  cv_namesi(2) = cl_vosaline  ; cl_fil(2)=cf_sfil
  cv_namesi(3) = cl_votemper2 ; cl_fil(3)=cf_tfil2
  cv_namesi(4) = cl_vosaline2 ; cl_fil(4)=cf_sfil2

  ! check existence of files
  lchk = lchk .OR. chkfile(cf_tfil )
  lchk = lchk .OR. chkfile(cf_tfil2)
  lchk = lchk .OR. chkfile(cf_sfil )
  lchk = lchk .OR. chkfile(cf_sfil2)
  IF (lchk ) STOP 99 ! missing file

  npiglo = getdim (cf_tfil, cn_x)
  npjglo = getdim (cf_tfil, cn_y)
  npk    = getdim (cf_tfil, cn_z)
  npt    = getdim (cf_tfil, cn_t)

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  ALLOCATE( zvbar(npiglo,npjglo), zvba2(npiglo,npjglo) )
  ALLOCATE( dsdev(npiglo,npjglo), dtim(npt)            )

  CALL CreateOutput

  DO jvar = 1, 2   ! temperature and salinity
     cv_in  = cv_namesi(jvar  )
     cv_in2 = cv_namesi(jvar+2)
     DO jt = 1, npt
        DO jk = 1, npk
           zvbar(:,:) = getvar(cl_fil(jvar)  , cv_in,  jk, npiglo, npjglo, ktime=jt)
           zvba2(:,:) = getvar(cl_fil(jvar+2), cv_in2, jk, npiglo, npjglo, ktime=jt)

           dsdev(:,:) = SQRT ( DBLE(zvba2(:,:) - zvbar(:,:)*zvbar(:,:)) )

           ierr = putvar(ncout, id_varout(jvar), REAL(dsdev), jk, npiglo, npjglo, ktime=jt)
        END DO
     END DO
  END DO

  ierr = closeout(ncout)

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    ipko(1) = npk
    stypvaro(1)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvaro(1)%cname             = TRIM(cl_votemper)//'_stdev'
    stypvaro(1)%cunits            = 'DegC'
    stypvaro(1)%rmissing_value    = 0.
    stypvaro(1)%valid_min         = 0.
    stypvaro(1)%valid_max         = 20
    stypvaro(1)%clong_name        = 'STDEV_Temperature'
    stypvaro(1)%cshort_name       = TRIM(cl_votemper)//'_stdev'
    stypvaro(1)%conline_operation = 'N/A'
    stypvaro(1)%caxis             = 'TZYX'

    ipko(2) = npk
    stypvaro(2)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvaro(2)%cname             = TRIM(cl_vosaline)//'_stdev'
    stypvaro(2)%cunits            = 'PSU'
    stypvaro(2)%rmissing_value    = 0.
    stypvaro(2)%valid_min         = 0.
    stypvaro(2)%valid_max         = 10
    stypvaro(2)%clong_name        = 'STDEV_Salinity'
    stypvaro(2)%cshort_name       = TRIM(cl_vosaline)//'_stdev'
    stypvaro(2)%conline_operation = 'N/A'
    stypvaro(2)%caxis             = 'TZYX'

    ncout = create      (cf_out, cf_tfil,    npiglo, npjglo, npk       , ld_nc4=lnc4)
    ierr  = createvar   (ncout,  stypvaro, 2,      ipko,   id_varout , ld_nc4=lnc4)
    ierr  = putheadervar(ncout,  cf_tfil,    npiglo, npjglo, npk       )

    dtim = getvar1d(cf_tfil, cn_vtimec, npt     )
    ierr = putvar1d(ncout, dtim,      npt, 'T')

  END SUBROUTINE CreateOutput

END PROGRAM cdfstdevts

PROGRAM cdficb_clim
  !!======================================================================
  !!                     ***  PROGRAM  cdficb_clim  ***
  !!=====================================================================
  !!  ** Purpose : Concatenate ceberg mass and melt from 12 monthly files
  !!               into a single 12 time frame file.
  !!  ** Method  : read and write ...
  !!
  !! History :  3.0  : 06/2016  : N. Merino         : Original code
  !!         :  4.0  : 03/2017  : J.-M. Molines
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017
  !! $Id$
  !! Copyright (c) 2012, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class iceberg_processing
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                            :: jf, jt               ! dummy loop index
  INTEGER(KIND=4)                            :: ierr                 ! working integer
  INTEGER(KIND=4)                            :: nfiles               ! number of files
  INTEGER(KIND=4)                            :: narg, iargc, ijarg   ! command line 
  INTEGER(KIND=4)                            :: npiglo, npjglo, npt  ! size of the domain
  INTEGER(KIND=4)                            :: nvpk                 ! vertical levels in working variable
  INTEGER(KIND=4)                            :: nboutput=2           ! number of values to write in cdf output
  INTEGER(KIND=4)                            :: ncout                ! for netcdf output
  INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE :: ipk, id_varout

  REAL(KIND=4), DIMENSION(:,:),  ALLOCATABLE :: ricbmass, ricbmelt   ! icbmass icbmelt

  REAL(KIND=8), DIMENSION(:),    ALLOCATABLE :: dtim                 ! time counter

  TYPE(variable), DIMENSION(:),  ALLOCATABLE :: stypvar              ! structure of output
  !
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cf_lst            ! input icb file
  CHARACTER(LEN=256)                         :: cf_out='icbdiags.nc' ! output file
  CHARACTER(LEN=256)                         :: cldum                ! dummy string
  !
  LOGICAL                                    :: lchk  = .FALSE.      ! missing file flag
  LOGICAL                                    :: lnc4  = .FALSE.      ! Use nc4 with chunking and deflation
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdficb_clim -l LST-ICB-monthly-files [-o OUT-file] [-nc4]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'        Concatenates 12 monthly input files, into a 12 frames output file.'
     PRINT *,'        This is done for the 2 variables corresponding to mass and melt.'
     PRINT *,'        No process done in this tool.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -l  LST-ICB-monthly-files : A list of 12 monthly-mean ICB files.'
     PRINT *,'            These files are likely produced by cdfmoy.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-o OUT-file] : specify output file name instead of ',TRIM(cf_out)
     PRINT *,'       [-nc4 ] : Use netcdf4 output with chunking and deflation level 1.'
     PRINT *,'            This option is effective only if cdftools are compiled with'
     PRINT *,'            a netcdf library supporting chunking and deflation.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'         none '
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : Mass  (Kg/m2 )'
     PRINT *,'                     Melt  (Kg/m2/s )'
     STOP 
  ENDIF

  ijarg = 1
  DO WHILE (ijarg <= narg )
     CALL getarg(ijarg, cldum) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-l'  ) ; CALL GetFileList
        ! options
     CASE ( '-o'  ) ; CALL getarg(ijarg, cf_out) ; ijarg=ijarg+1
     CASE ( '-nc4') ; lnc4 = .TRUE.
     CASE DEFAULT   ; PRINT *,' ERROR : ', TRIM(cldum),' unknown option.' ; STOP 99
     END SELECT
  ENDDO

  IF ( nfiles /= 12 ) THEN 
     PRINT *,' +++ ERROR : This program needs 12 monthly files in input.' ; STOP 99
  ENDIF

  DO jf=1, nfiles
     lchk = lchk .OR. chkfile(cf_lst(jf))
  ENDDO

  IF ( lchk ) STOP 99 ! missing file

  npiglo = getdim (cf_lst(1),cn_x)
  npjglo = getdim (cf_lst(1),cn_y)
  npt    = 12

  ALLOCATE ( ricbmass(npiglo,npjglo) )
  ALLOCATE ( ricbmelt(npiglo,npjglo) )
  ALLOCATE ( dtim(npt) )
  ALLOCATE ( stypvar(nboutput), ipk(nboutput), id_varout(nboutput) )

  CALL CreateOutput

  ! Check variable on first file ?
  IF (chkvar(cf_lst(1), cn_iicbmass)) THEN
     cn_iicbmass='missing'
     PRINT *,'' 
     PRINT *,' WARNING, ICEBERG MASS IS SET TO 0. '
     PRINT *,' '
  END IF
  !
  DO jt = 1, npt
     IF (TRIM(cn_iicbmass) /= 'missing') THEN ; ricbmass(:,:) = getvar(cf_lst(jt), cn_iicbmass, 1, npiglo, npjglo, ktime=1)
     ELSE                                     ; ricbmass(:,:) = 0.
     ENDIF
     ricbmelt(:,:) = getvar(cf_lst(jt), cn_iicbmelt, 1, npiglo, npjglo, ktime=1)

     ! netcdf output
     ierr = putvar(ncout,id_varout(1),REAL(ricbmass(:,:)),1,npiglo,npjglo, ktime=jt)
     ierr = putvar(ncout,id_varout(2),REAL(ricbmelt(:,:)),1,npiglo,npjglo, ktime=jt)
  END DO ! time loop
  ierr = closeout(ncout)

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------

    ipk(:) = 1
    ! define new variables for output 
    stypvar%scale_factor      = 1.
    stypvar%add_offset        = 0.
    stypvar%savelog10         = 0.
    stypvar%conline_operation = 'N/A'
    stypvar%caxis             = 'T'

    stypvar(1)%ichunk         = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(1)%cname          = 'Mass'
    stypvar(1)%cunits         = 'Kg/m2'
    stypvar(1)%clong_name     = 'Icb mass per unit of area'
    stypvar(1)%cshort_name    = 'Mass'

    stypvar(2)%ichunk         = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(2)%cname          = 'Melt'
    stypvar(2)%cunits         = 'Kg/m2/s'
    stypvar(2)%clong_name     = 'Icb melt flux'
    stypvar(2)%cshort_name    = 'Melt'


    ! create output fileset
    ncout = create      (cf_out, 'none',  npiglo,      npjglo, 1,  cdep='depthw', ld_nc4=lnc4 )
    ierr  = createvar   (ncout,  stypvar, nboutput, ipk, id_varout              , ld_nc4=lnc4 )
    ierr  = putheadervar(ncout,  cf_lst(1), npiglo,      npjglo, 1)

    dtim = (/(jt,jt=1,12)/)
    ierr = putvar1d(ncout, dtim, npt, 'T')


  END SUBROUTINE CreateOutput

  SUBROUTINE GetFileList
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE GetFileList  ***
    !!
    !! ** Purpose :  Set up a file list given on the command line as 
    !!               blank separated list
    !!
    !! ** Method  :  Scan the command line until a '-' is found
    !!----------------------------------------------------------------------
    INTEGER (KIND=4)  :: ji
    INTEGER (KIND=4)  :: icur
    !!----------------------------------------------------------------------
    !!
    nfiles=0
    ! need to read a list of file ( number unknow ) 
    ! loop on argument till a '-' is found as first char
    icur=ijarg                          ! save current position of argument number
    DO ji = icur, narg                  ! scan arguments till - found
       CALL getarg ( ji, cldum )
       IF ( cldum(1:1) /= '-' ) THEN ; nfiles = nfiles+1
       ELSE                          ; EXIT
       ENDIF
    ENDDO
    ALLOCATE (cf_lst(nfiles) )
    DO ji = icur, icur + nfiles -1
       CALL getarg(ji, cf_lst( ji -icur +1 ) ) ; ijarg=ijarg+1
    END DO
  END SUBROUTINE GetFileList

END PROGRAM cdficb_clim

PROGRAM cdffixanom
  !!======================================================================
  !!                     ***  PROGRAM  cdffixanom  ***
  !!=====================================================================
  !!  ** Purpose : Tool dedicated to the local correction of initial 
  !!               conditions files, where deepest part are some time 
  !!               Spurious. Below a given level, the values of the variable
  !!               are replaced by the upper level.
  !!
  !! History : 4.0  : 04/2020  : J.M. Molines (from cdfmax/cdfmltmask)
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2020
  !! $Id$
  !! Copyright (c) 2020, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class file_informations
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                               :: jk,  jt
  INTEGER(KIND=4)                               :: narg, iargc, ijarg
  INTEGER(KIND=4)                               :: ni, nj, nk, nt       ! size of the global domain
  INTEGER(KIND=4)                               :: niz, njz             ! size of the domain
  INTEGER(KIND=4)                               :: ikref                ! revel of reference
  INTEGER(KIND=4)                               :: iimin=1, iimax=0     ! i-limit of the domain
  INTEGER(KIND=4)                               :: ijmin=1, ijmax=0     ! j-limit of the domain
  INTEGER(KIND=4)                               :: itmin=1, itmax=0     ! t-limit of the domain
  INTEGER(KIND=4)                               :: istatus,ierr         ! working integer

  REAL(KIND=4)                                  :: zspval               ! missing value or spval
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE     :: v2d, vref            ! running 2d var, and reference var.

  CHARACTER(LEN=256)                            :: cf_in                ! input file name
  CHARACTER(LEN=256)                            :: cf_out               ! input file name
  CHARACTER(LEN=256)                            :: cv_in='none'         ! current variable name
  CHARACTER(LEN=256)                            :: cldum                ! dummy char variable

  LOGICAL                                       :: lout = .FALSE.       ! Flag set when name of output file given

  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdffixanom -f IN-file -v IN-var -reflev kref  ...'
     PRINT *,'      ... [-w imin imax jmin jmax] [-time tmin tmax ] ...'
     PRINT *,'      ... [-o OUT-file ]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'        In the subdomain, replace the variable value by values at kref,'
     PRINT *,'        from kref+1 to the last wet point. Action is performed on a copy'
     PRINT *,'        of the input file.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -f IN-file : input file '
     PRINT *,'       -v IN-var  : input variable'
     PRINT *,'       -reflev kref : Give reference level'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-w imin imax jmin jmax] : restrict to sub area specified by the '
     PRINT *,'                  given limits. '
     PRINT *,'       [-time tmin tmax ] : restrict to the indicated time windows.'
     PRINT *,'       [-o OUT-file] : specify the output file name instead of default.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       none' 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       output is done on <IN-file>_fixanom, or OUT-file if -o option used.'
     STOP 
  ENDIF

  ijarg=1
  ikref=0
  cv_in = 'none'
  DO  WHILE (ijarg <=  narg)
     CALL getarg(ijarg, cldum) ; ijarg = ijarg + 1
     SELECT CASE (cldum )
     CASE ( '-f'      ) ; CALL getarg(ijarg, cf_in) ; ijarg = ijarg + 1
     CASE ( '-v'      ) ; CALL getarg(ijarg, cv_in) ; ijarg = ijarg + 1 
     CASE ( '-reflev' ) ; CALL getarg(ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) ikref
     CASE ( '-w'      ) ; CALL getarg(ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) iimin
        ;                 CALL getarg(ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) iimax
        ;                 CALL getarg(ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) ijmin
        ;                 CALL getarg(ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) ijmax
     CASE ( '-time'   ) ; CALL getarg(ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) itmin
        ;                 CALL getarg(ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) itmax
     CASE ( '-o'      ) ; CALL getarg(ijarg, cf_out); ijarg = ijarg + 1 ; lout=.TRUE.

     CASE DEFAULT     ; PRINT *, ' ERROR : ', TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  END DO

  ! Check if reference level given
  IF ( ikref == 0 ) THEN
    PRINT *,' *** ERROR : You must specify a reference level with -reflev '
    STOP 99
  ENDIF
  
  ! Check for variable name
  IF ( TRIM(cv_in) == 'none' ) THEN
    PRINT *,' *** ERROR : You must specify a variable name with -v option.'
    STOP 99
  ENDIF

  ! Check for missing files
  IF ( chkfile(cf_in) ) STOP 99 ! missing file

  IF ( .NOT. lout ) THEN
     cf_out   = TRIM(cf_in)//'_fixanom'
  ENDIF
  CALL system(' dd bs=10000000 if='//TRIM(cf_in)//' of='//TRIM(cf_out) )
  cf_in = cf_out

  PRINT *,' Working on copy : ', TRIM(cf_out)

  ni=0 ; nj=0; nk=0; nt=0 

  ni = getdim(cf_in, cn_x, cldum, istatus)
  IF ( istatus == 1 ) THEN 
     ni = getdim(cf_in, 'lon', cldum, istatus)
     IF ( istatus == 1 ) THEN
        PRINT *,' No X or lon dim found ' ; STOP 99
     ENDIF
  ENDIF
  IF ( iimax == 0 ) iimax = ni

  nj = getdim(cf_in, cn_y, cldum, istatus)
  IF ( istatus == 1 ) THEN 
     nj = getdim(cf_in, 'lat', cldum, istatus)
     IF ( istatus == 1 ) THEN
        PRINT *,' No y or lat dim found ' ; STOP 99
     ENDIF
  ENDIF
  IF ( ijmax == 0 ) ijmax = nj

  nk=getdim(cf_in, cn_z, cldum, istatus)
  IF ( istatus == 1 ) THEN 
     nk = getdim(cf_in, 'z', cldum, istatus)
     IF ( istatus == 1 ) THEN 
        nk = getdim(cf_in, 'lev', cldum, istatus)
        IF ( istatus == 1 ) THEN
           PRINT *,' No dep or z or lev  dim found ' 
           nk = 1
        ENDIF
     ENDIF
  ENDIF
  IF ( nk <= ikref ) THEN
    PRINT *,' *** ERROR : reference level >= total levels in files'
    STOP 99
  ENDIF

  nt = getdim(cf_in, cn_t, cldum, istatus)

  IF ( istatus == 1 ) THEN 
     nt = getdim(cf_in, 'step', cldum, istatus)
     IF ( istatus == 1 ) THEN
        PRINT *,' No time or step dim found ' 
     ENDIF
  ENDIF

  ! fix the size of the zoomed area, or the whole domain if no zoom
  niz = iimax - iimin + 1
  njz = ijmax - ijmin + 1

  IF (nt == 0 ) nt = 1  ! assume a 1 time frame file
  IF ( itmax == 0 ) itmax = nt

  zspval = getatt(cf_in, cv_in, cn_missing_value)

  ALLOCATE (vref(niz,njz), v2d(niz,njz) )

  ! Loop on time
  DO jt=itmin, itmax
   ! read ref value 
   vref(:,:) = getvar(cf_in, cv_in, ikref, niz, njz, kimin=iimin, kjmin=ijmin, ktime=jt)
   ! Loop on level
   DO jk=ikref+1, nk
     v2d(:,:)  = getvar(cf_in, cv_in, jk, niz, njz, kimin=iimin, kjmin=ijmin, ktime=jt)
     WHERE (v2d /= zspval ) v2d=vref
     ierr = putvar(cf_out, cv_in, jk, niz, njz, kimin=iimin, kjmin=ijmin, ptab=v2d,ktime=jt)
   ENDDO
  ENDDO

END PROGRAM cdffixanom

PROGRAM cdfsum
  !!======================================================================
  !!                     ***  PROGRAM  cdfsum  ***
  !!=====================================================================
  !!  ** Purpose : Compute the sum of a variable over the ocean, or
  !!               part of the ocean
  !!
  !!  ** Method  : this code is for partial steps configuration
  !!              sum = sum ( V * e1 *e2 * e3 *mask )
  !!              CAUTION : this version is still tricky, as it does not
  !!              compute the same thing in case of forcing field or
  !!              model field. Need clarification ( JMM)
  !!
  !! History : 2.1  : 11/2008  : P. Mathiot   : Original code (from cdfmean)
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: jk, jt              ! dummy loop index
  INTEGER(KIND=4)                           :: ik                  ! dummy loop index
  INTEGER(KIND=4)                           :: iimin=0, iimax=0    ! domain limitation for computation
  INTEGER(KIND=4)                           :: ijmin=0, ijmax=0    ! domain limitation for computation
  INTEGER(KIND=4)                           :: ikmin=0, ikmax=0    ! domain limitation for computation
  INTEGER(KIND=4)                           :: ierr                ! working integer
  INTEGER(KIND=4)                           :: narg, iargc,ijarg   ! command line 
  INTEGER(KIND=4)                           :: npiglo, npjglo      ! size of the domain
  INTEGER(KIND=4)                           :: npk, npkk, npt      ! size of the domain
  INTEGER(KIND=4)                           :: nvpk                ! vertical levels in working variable
  INTEGER(KIND=4)                           :: numout=10           ! logical unit
  INTEGER(KIND=4)                           :: ncout               ! for netcdf output
  INTEGER(KIND=4), DIMENSION(2)             :: ipk, id_varout

  REAL(KIND=4)                              :: zspval             ! missing value
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e1, e2, e3,  zv     ! metrics, velocity
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zmask               ! npiglo x npjglo
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: gdep                ! depth 
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: tim                 ! time
  REAL(KIND=4), DIMENSION(1,1)              :: rdummy              ! dummy 2d variable for result

  REAL(KIND=8)                              :: dvol, dvol2d        ! volume of the ocean/ layer
  REAL(KIND=8)                              :: dsurf               ! surface of the ocean
  REAL(KIND=8)                              :: dsum, dsum2d        ! global sum /layer sum
  REAL(KIND=8)                              :: dsumt               ! global sum over time

  CHARACTER(LEN=256)                        :: cldum               ! dummy string
  CHARACTER(LEN=256)                        :: cf_in               ! file name 
  CHARACTER(LEN=256)                        :: cf_out='cdfsum.nc'  ! output file name 
  CHARACTER(LEN=256)                        :: cv_dep              ! depth name in mesh_zgr
  CHARACTER(LEN=256)                        :: cdep                ! depth name in output file
  CHARACTER(LEN=256)                        :: cv_in               ! variable name
  CHARACTER(LEN=20)                         :: cv_e1, cv_e2, cv_e3 ! name of the horiz/vert metrics
  CHARACTER(LEN=20)                         :: cv_msk              ! name of mask variable
  CHARACTER(LEN=20)                         :: cl_vmsk             ! name of external mask variable (-M option)
  CHARACTER(LEN=20)                         :: cvartype            ! variable type
  CHARACTER(LEN=256)                        :: clunits            ! attribute of output file : units
  CHARACTER(LEN=256)                        :: cllong_name        !     "      long name
  CHARACTER(LEN=256)                        :: clshort_name       !     "      short name
  CHARACTER(LEN=256)                        :: cglobal            !     "      global 

  TYPE(variable), DIMENSION(2)              :: stypvar             ! structure of output

  LOGICAL                                   :: lforcing            ! forcing flag
  LOGICAL                                   :: lchk                ! flag for missing files
  LOGICAL                                   :: lerror=.FALSE.      ! flag for missing arguments
  LOGICAL                                   :: lfmsk=.FALSE.       ! flag for using non standard mask file
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfsum -f IN-file -v IN-var -p T| U | V | F | W  ... '
     PRINT *,'          ... [-zoom imin imax jmin jmax kmin kmax] [-full ] [-o OUT-file] '
     PRINT *,'          ... [-M MSK-file VAR-mask ]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Computes the sum value of the field (3D, weighted)' 
     PRINT *,'       This sum can be optionally limited to a 3D sub-area.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -f IN-file : netcdf input file.' 
     PRINT *,'       -v IN-var  : netcdf variable to work with.'
     PRINT *,'       -p T| U | V | F | W : C-grid point where IN-var is located.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-zoom imin imax jmin jmax kmin kmax] : limit of the 3D sub area. '
     PRINT *,'              if imin=0 all i are taken'
     PRINT *,'              if jmin=0 all j are taken'
     PRINT *,'              if kmin=0 all k are taken'
     PRINT *,'       [ -full : ] Use full steps instead of default partial steps'
     PRINT *,'       [-o OUT-file ] : name of the output file instead of', TRIM(cf_out)
     PRINT *,'       [-M MSK-file VAR-mask] : Allow the use of a non standard mask file '
     PRINT *,'              with VAR-mask, instead of ',TRIM(cn_fmsk),' and the variable'
     PRINT *,'              associated with the grid point set by -p argument.'
     PRINT *,'              This option is a usefull alternative to -zoom option, when the '
     PRINT *,'              area of interest is not ''box-like'' '
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'      ', TRIM(cn_fhgr),', ',TRIM(cn_fzgr),' and ',TRIM(cn_fmsk),'. If'
     PRINT *,'         -M option is used, the specified mask file is required instead '
     PRINT *,'         ', TRIM(cn_fmsk)
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       Standard output.'
     PRINT *,'       netcdf file : ',TRIM(cf_out),' unless modified with -o option. '
     PRINT *,'           - 2 variables : vertical profile of sum and 3D sum.'
     PRINT *,'                         names are sum_<varname> and sum3D_<varname>.'
     PRINT *,'      '
     PRINT *,'     SEE ALSO: '
     PRINT *,'       cdfmean '
     STOP
  ENDIF

  ijarg=1
  ! mandatory arguments are set to none by default for further check
  cf_in='none' ; cv_in='none'; cvartype='none'
  DO WHILE ( ijarg <= narg )
     CALL getarg( ijarg, cldum) ; ijarg=ijarg+1
     SELECT CASE (cldum)
     CASE ( '-f '   ) ; CALL getarg(ijarg, cf_in   ) ; ijarg=ijarg+1
     CASE ( '-v '   ) ; CALL getarg(ijarg, cv_in   ) ; ijarg=ijarg+1
     CASE ( '-p '   ) ; CALL getarg(ijarg, cvartype) ; ijarg=ijarg+1
     CASE ( '-o '   ) ; CALL getarg(ijarg, cf_out  ) ; ijarg=ijarg+1
     CASE ( '-zoom' ) ; 
                        CALL getarg(ijarg, cldum   ) ; ijarg=ijarg+1 ; READ(cldum,*)  iimin
                        CALL getarg(ijarg, cldum   ) ; ijarg=ijarg+1 ; READ(cldum,*)  iimax
                        CALL getarg(ijarg, cldum   ) ; ijarg=ijarg+1 ; READ(cldum,*)  ijmin
                        CALL getarg(ijarg, cldum   ) ; ijarg=ijarg+1 ; READ(cldum,*)  ijmax
                        CALL getarg(ijarg, cldum   ) ; ijarg=ijarg+1 ; READ(cldum,*)  ikmin
                        CALL getarg(ijarg, cldum   ) ; ijarg=ijarg+1 ; READ(cldum,*)  ikmax
     CASE ( '-M' ) ;    lfmsk =.TRUE.
                        CALL getarg(ijarg, cn_fmsk ) ; ijarg=ijarg+1 
                        CALL getarg(ijarg, cl_vmsk ) ; ijarg=ijarg+1 
     CASE DEFAULT 
         PRINT *,' Option ', TRIM(cldum),' not understood ...'
         STOP 99
     END SELECT
  ENDDO
  
  IF ( cf_in == 'none' )  THEN
     PRINT *,' You must specify an input file with -f option'
     lerror= lerror .OR. .TRUE. 
  ENDIF
  IF ( cv_in == 'none' )  THEN
     PRINT *,' You must specify an input variable with -v option'
     lerror= lerror .OR. .TRUE. 
  ENDIF
  IF ( cvartype == 'none' )  THEN
     PRINT *,' You must specify a point type with -p option'
     lerror= lerror .OR. .TRUE. 
  ENDIF
  IF (lerror ) STOP 99

  lchk = chkfile(cn_fhgr)
  lchk = chkfile(cn_fzgr) .OR. lchk
  lchk = chkfile(cn_fmsk) .OR. lchk
  lchk = chkfile(cf_in  ) .OR. lchk
  IF ( lchk ) STOP 99 ! missing file

  npiglo = getdim (cf_in,cn_x)
  npjglo = getdim (cf_in,cn_y)
  npk    = getdim (cf_in,cn_z)
  nvpk   = getvdim(cf_in,cv_in)
  npt    = getdim (cf_in,cn_t)
  npkk = npk

  IF (iimin /= 0 ) THEN ; npiglo = iimax - iimin + 1;  ELSE ; iimin = 1 ;  ENDIF
  IF (ijmin /= 0 ) THEN ; npjglo = ijmax - ijmin + 1;  ELSE ; ijmin = 1 ;  ENDIF
  IF (ikmin /= 0 ) THEN ; npkk   = ikmax - ikmin + 1;  ELSE ; ikmin = 1 ; ikmax = npk ;  ENDIF

  IF (nvpk == 2 ) nvpk = 1
  IF (nvpk == 3 ) nvpk = npkk

  PRINT *, 'Size of the extracted area :'
  PRINT *, '  npiglo = ', npiglo
  PRINT *, '  npjglo = ', npjglo
  PRINT *, '  npk    = ', npk
  PRINT *, '  nvpk   = ', nvpk
  PRINT *, '  npt    = ', npt

  lforcing=.FALSE.
  IF ( (npk == 0) ) THEN
     lforcing = .TRUE.
     npk      = 1
     PRINT *, 'W A R N I N G : you used a forcing field'
  END IF

  IF (lforcing)  OPEN(unit=numout, file='cdfsum.txt' , form='formatted', status='new', iostat=ierr)

  ! Allocate arrays
  ALLOCATE ( zmask(npiglo,npjglo) )
  ALLOCATE ( zv   (npiglo,npjglo) )
  ALLOCATE ( e1   (npiglo,npjglo), e2(npiglo,npjglo), e3(npiglo,npjglo) )
  ALLOCATE ( gdep (npk), tim(npt) )

  SELECT CASE (TRIM(cvartype))
  CASE ( 'T' )
     cv_e1  = cn_ve1t
     cv_e2  = cn_ve2t
     cv_e3  = 'e3t_ps'
     cv_msk = 'tmask'
     cv_dep = cn_gdept
     cdep   = cn_vdeptht
  CASE ( 'U' )
     cv_e1  = cn_ve1u
     cv_e2  = cn_ve2u
     cv_e3  = 'e3t_ps'
     cv_msk = 'umask'
     cv_dep = cn_gdept
     cdep   = cn_vdepthu
  CASE ( 'V' )
     cv_e1  = cn_ve1v
     cv_e2  = cn_ve2v
     cv_e3  = 'e3t_ps'
     cv_msk = 'vmask'
     cv_dep = cn_gdept
     cdep   = cn_vdepthv
  CASE ( 'F' )
     cv_e1  = cn_ve1f
     cv_e2  = cn_ve2f
     cv_e3  = 'e3t_ps'
     cv_msk = 'fmask'
     cv_dep = cn_gdept
     cdep   = cn_vdeptht
  CASE ( 'W' )
     cv_e1  = cn_ve1t
     cv_e2  = cn_ve2t
     cv_e3  = 'e3w_ps'
     cv_msk = 'tmask'
     cv_dep = cn_gdepw
     cdep   = cn_vdepthw
  CASE DEFAULT
     PRINT *, 'this type of variable is not known :', TRIM(cvartype)
     STOP 99
  END SELECT

  ! set cv_mask to on-line specified name if -M option used
  IF ( lfmsk ) cv_msk = cl_vmsk

  e1(:,:) = getvar  (cn_fhgr, cv_e1, 1, npiglo, npjglo, kimin=iimin, kjmin=ijmin)
  e2(:,:) = getvar  (cn_fhgr, cv_e2, 1, npiglo, npjglo, kimin=iimin, kjmin=ijmin)
  gdep(:) = getvare3(cn_fzgr, cv_dep,   npk                                   )

  CALL CreateOutput

  dsumt = 0.d0
  DO jt = 1,npt
     dvol = 0.d0
     dsum = 0.d0
     zv   = 0.
     DO jk = 1,nvpk
        ik = jk + ikmin -1
        ! Get field  at ik
        zv   (:,:) = getvar(cf_in,   cv_in,  ik, npiglo, npjglo, ktime=jt,   kimin=iimin, kjmin=ijmin)
        zmask(:,:) = getvar(cn_fmsk, cv_msk, ik, npiglo, npjglo,             kimin=iimin, kjmin=ijmin)
        !    zmask(:,npjglo)=0.

        ! get e3 at level ik ( ps...)
        e3(:,:) = getvar(cn_fzgr, cv_e3, ik, npiglo, npjglo, kimin=iimin, kjmin=ijmin, ldiom=.TRUE.)      
        ! 
        IF (.NOT. lforcing) THEN
           dsurf  = SUM(DBLE(e1 * e2      * zmask))
           dvol2d = SUM(DBLE(e1 * e2 * e3 * zmask))
           dvol   = dvol + dvol2d
           dsum2d = SUM(DBLE(zv * e1 * e2 * zmask))
           dsum   = dsum + dsum2d
           IF (dvol2d /= 0 )THEN
              PRINT *, ' Sum value at level ', ik, '(',gdep(ik),' m) ', dsum2d
              rdummy(1,1)= REAL(dsum2d)
           ELSE
              PRINT *, ' No points in the water at level ', ik, '(',gdep(ik),' m) '
              rdummy(1,1)= 99999.
           ENDIF
        ELSE
           dsurf  = SUM(DBLE(     e1 * e2 * zmask))
           dsum2d = SUM(DBLE(zv * e1 * e2 * zmask))
           dsum   = dsum + dsum2d
           PRINT *, ' Sum value at time ',jt,' = ', dsum2d
           PRINT *, '          Surface  = ', dsurf/1.d6,' km^2'
           PRINT *, '       mean value  = ', dsum2d/dsurf
           WRITE (numout,'(i4," ",1e13.6)') jt, dsum2d
           rdummy(1,1) = REAL(dsum2d)
        END IF
        ierr = putvar( ncout, id_varout(1), rdummy, jk, 1,1, ktime=jt)
     END DO
     dsumt = dsumt + dsum
     IF (.NOT. lforcing) PRINT * ,' Sum value over the ocean: ', dsumt
     rdummy(1,1) = REAL(dsumt)
     ierr = putvar( ncout, id_varout(2), rdummy, 1, 1, 1, ktime=jt)
  END DO  ! time loop
  
  PRINT *, ' mean Sum over time ', dsumt/npt

  CLOSE(numout)
  ierr=closeout(ncout)

  CONTAINS
  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose : Create netcdf output file  
    !!----------------------------------------------------------------------
    REAL(KIND=4), DIMENSION(1,1)              :: zdumlon, zdumlat    ! dummy latitude and longitude
    !!
    ! define new variables for output 
    zdumlon = 0. ; zdumlat = 0.
    ierr=getvaratt (cf_in, cv_in, clunits, zspval, cllong_name, clshort_name)
    stypvar%rmissing_value    = 99999.
    stypvar%valid_min         = -1000.
    stypvar%valid_max         = 1000.
    stypvar%scale_factor      = 1.
    stypvar%add_offset        = 0.
    stypvar%savelog10         = 0.
    stypvar%conline_operation = 'N/A'

    ipk(1) = nvpk  ! vertical profile
    stypvar(1)%cname          = 'sum_'//TRIM(cv_in)
    stypvar(1)%cunits         = TRIM(clunits)//'.m2'
    stypvar(1)%clong_name     = 'sum'//TRIM(cllong_name)
    stypvar(1)%cshort_name    = 'sum'//TRIM(clshort_name)
    stypvar(1)%caxis          = 'ZT'

    ipk(2) = 1     ! 3D sum
    stypvar(2)%cname          = 'sum_3D'//TRIM(cv_in)
    stypvar(2)%cunits         = TRIM(clunits)//'.m3'
    stypvar(2)%clong_name     = 'sum_3D'//TRIM(cllong_name)
    stypvar(2)%cshort_name    = 'sum_3D'//TRIM(clshort_name)
    stypvar(2)%caxis          = 'T'

    ncout = create      (cf_out,     'none',  1,     1  ,   nvpk, cdep=cdep)
    ierr  = createvar   (ncout,      stypvar, 2    , ipk,   id_varout      )
    ierr  = putheadervar(ncout,      cf_in,   1,     1, npkk,              &
                    &  pnavlon=zdumlon, pnavlat=zdumlat,                   &
                    &  pdep=gdep(ikmin:ikmax),                             &
                    &  cdep=cdep                                           )
    tim   = getvar1d(cf_in, cn_vtimec, npt)
    ierr  = putvar1d(ncout,  tim,      npt, 'T')
  
  END SUBROUTINE CreateOutput

END PROGRAM cdfsum

PROGRAM cdfvsig
  !!======================================================================
  !!                     ***  PROGRAM  cdfvsig  ***
  !!=====================================================================
  !!  ** Purpose : Compute the average values for the products 
  !!               U.sig, V.sig, W.sig where sig is the potential density.
  !!
  !!  ** Method  : pass the CONFIG name and a series of tags as arguments.
  !!               Tracers are interpolated on velocity points. The product
  !!               is evaluated at velocity points.
  !!
  !! History : 2.1  : 11/2004  : J.M. Molines : Original code
  !!           2.1  : 02/2010  : J.M. Molines : handle multiframes input files.
  !!           3.0  : 04/2011  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE eos
  USE modcdfnames
  USE modutils
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class second_order_moments
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: ji, jj, jk, jt, jtt  ! dummy loop index
  INTEGER(KIND=4)                           :: jsig                 ! dummy loop index
  INTEGER(KIND=4)                           :: ierr                 ! working integer
  INTEGER(KIND=4)                           :: narg, iargc          ! command line
  INTEGER(KIND=4)                           :: ijarg, iiarg         ! argument counter
  INTEGER(KIND=4)                           :: ntags                ! number of tags to process
  INTEGER(KIND=4)                           :: ndep                 ! number of reference depth to deal with
  INTEGER(KIND=4)                           :: npiglo,npjglo        ! size of the domain
  INTEGER(KIND=4)                           :: npk, npt             ! size of the domain
  INTEGER(KIND=4)                           :: ntframe              ! Cumul of time frame
  INTEGER(KIND=4)                           :: nopt                 ! number of options
  INTEGER(KIND=4)                           :: ncoutu               ! ncid of output file
  INTEGER(KIND=4)                           :: ncoutv               ! ncid of output file
  INTEGER(KIND=4)                           :: ncoutw               ! ncid of output file
  INTEGER(KIND=4)                           :: nfieldu, nfieldv, nfieldw  ! ncid of output file
  INTEGER(KIND=4)                           :: ivaru, ivarv, ivarw  ! variable counter
  INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE :: ipku, id_varoutu     ! level and varid's of output vars
  INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE :: ipkv, id_varoutv     ! level and varid's of output vars
  INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE :: ipkw, id_varoutw     ! level and varid's of output vars

  REAL(KIND=4)                              :: zdepref              ! reference level for potential density
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: refdep               ! Reference depth table
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: ztemp,  zsal         ! Array to read a layer of data
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zu, zv, zw           ! Velocity component
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: ztempu, zsalu        ! Array to read a layer of data
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: ztempv, zsalv        ! Array to read a layer of data
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: ztempw, zsalw        ! Array to read a layer of data
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: umask,  vmask, wmask ! masks

  REAL(KIND=8)                                :: dtotal_time          ! cumulated time
  REAL(KIND=8), DIMENSION(1)                  :: dtimean              ! mean time
  REAL(KIND=8), DIMENSION(:),     ALLOCATABLE :: dtim                 ! time counter of individual files
  REAL(KIND=8), DIMENSION(:,:),   ALLOCATABLE :: dcumulu, dcumulu2    ! Arrays for cumulated values
  REAL(KIND=8), DIMENSION(:,:),   ALLOCATABLE :: dcumulv, dcumulv2    ! Arrays for cumulated values
  REAL(KIND=8), DIMENSION(:,:),   ALLOCATABLE :: dcumulw, dcumulw2    ! Arrays for cumulated values
  REAL(KIND=8), DIMENSION(:,:,:), ALLOCATABLE :: dcumulus             ! Arrays for cumulated values
  REAL(KIND=8), DIMENSION(:,:,:), ALLOCATABLE :: dcumulvs             ! Arrays for cumulated values
  REAL(KIND=8), DIMENSION(:,:,:), ALLOCATABLE :: dcumulws             ! Arrays for cumulated values
  REAL(KIND=8), DIMENSION(:,:,:), ALLOCATABLE :: dcumulsu             ! Arrays for cumulated values
  REAL(KIND=8), DIMENSION(:,:,:), ALLOCATABLE :: dcumulsv             ! Arrays for cumulated values
  REAL(KIND=8), DIMENSION(:,:,:), ALLOCATABLE :: dcumulsw             ! Arrays for cumulated values
  REAL(KIND=8), DIMENSION(:,:,:), ALLOCATABLE :: dsigu                ! Array for sigmai at u point
  REAL(KIND=8), DIMENSION(:,:,:), ALLOCATABLE :: dsigv                ! Array for sigmai at v point
  REAL(KIND=8), DIMENSION(:,:,:), ALLOCATABLE :: dsigw                ! Array for sigmai at w point

  CHARACTER(LEN=256)                        :: cf_tfil              ! TS file name
  CHARACTER(LEN=256)                        :: cf_sfil              ! salinity file (option)
  CHARACTER(LEN=256)                        :: cf_ufil              ! zonal velocity file
  CHARACTER(LEN=256)                        :: cf_vfil              ! meridional velocity file
  CHARACTER(LEN=256)                        :: cf_wfil              ! vertical velocity file
  CHARACTER(LEN=256)                        :: cf_root=''           ! file name root for output
  CHARACTER(LEN=256)                        :: cf_outu='usig.nc'    ! output file
  CHARACTER(LEN=256)                        :: cf_outv='vsig.nc'    ! output file
  CHARACTER(LEN=256)                        :: cf_outw='wsig.nc'    ! output file
  CHARACTER(LEN=256)                        :: config               ! configuration name
  CHARACTER(LEN=256)                        :: ctag                 ! current tag to work with               
  CHARACTER(LEN=256)                        :: cldum                ! dummy character var for browsing
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE:: ctag_lst          ! tag list to process

  TYPE (variable), DIMENSION(:), ALLOCATABLE :: stypvaru             ! structure for attributes
  TYPE (variable), DIMENSION(:), ALLOCATABLE :: stypvarv             ! structure for attributes
  TYPE (variable), DIMENSION(:), ALLOCATABLE :: stypvarw             ! structure for attributes

  LOGICAL                                   :: lcaltmean             ! flag for mean time computation
  LOGICAL                                   :: lwo   = .TRUE.        ! flag for -no-w option
  LOGICAL                                   :: lsigo = .TRUE.        ! flag for -no-sig option
  LOGICAL                                   :: luvo  = .TRUE.        ! flag for -no-uv option
  LOGICAL                                   :: lTpt  = .FALSE.       ! flag for -no-uv option
  LOGICAL                                   :: lpref = .FALSE.       ! flag for -pref option
  LOGICAL                                   :: lperio= .FALSE.       ! checking E-W periodicity
  LOGICAL                                   :: lnc4  = .FALSE.       ! Use nc4 with chunking and deflation
  LOGICAL                                   :: lsal  = .FALSE.       ! flag for gridS file

  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  !!  Read command line
  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfvsig -c CONFIG-CASE -l LST-tags [-o OUT-root] [-nc4] [-no-w] ...'
     PRINT *,'              ... [-S] [-no-sig]  [-no-uv] [-T ] [-depref LST-depht] '
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the time average values for second order moments U.sig, V.sig' 
     PRINT *,'       and W.sig. By default sig is sigma-0, the potential density refered to'
     PRINT *,'       the surface. The user can provide a list of reference depths, to force'
     PRINT *,'       the computation of the respective second order moments, e.g U.sig-2 ...'
     PRINT *,'      '
     PRINT *,'       In order to ease the post processing, time-mean densities interpolated'
     PRINT *,'       at velocity points, as well as mean velocity components are also saved.'
     PRINT *,'       Various options allows the modulation of the output.'
     PRINT *,'      '
     PRINT *,'       If salinity is not in gridT file use -S option.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -c CONFIG-CASE is the config name of a given experiment (eg ORCA025-G70)'
     PRINT *,'            The program will look for gridT, gridU, gridV  and gridW files for' 
     PRINT *,'            this config ( grid_T, grid_U, grid_V and grid_W are also accepted).'
     PRINT *,'       -l LST-tags : a blank-separated list of time tags that will be used for '
     PRINT *,'            time averaging, e.g. y2000m01d05 y2000m01d10.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'        [-S ] : indicate that salinity is in gridS file.'
     PRINT *,'        [-o OUT-root]: specify the file name root used for the output.'
     PRINT *,'            Output file names will be <ROOT>usig.nc, <ROOT>vsig and <ROOT>wsig.'
     PRINT *,'            Default <ROOT> is empty. Consider then to add an ''_'' in the root'
     PRINT *,'            name.'
     PRINT *,'        [-nc4 ] : Use netcdf4 output with chunking and deflation level 1.'
     PRINT *,'            This option is effective only if cdftools are compiled with'
     PRINT *,'            a netcdf library supporting chunking and deflation.'
     PRINT *,'        [-no-w] : do not compute the  mean vertical products.'
     PRINT *,'        [-no-sig] : do not output the mean density on U V points.'
     PRINT *,'        [-no-uv ] : do not  output the mean velocity components.'
     PRINT *,'        [-T ] : computes U and V at T points, so that  U.sig, V.sig will be at'
     PRINT *,'              at  T point.'
     PRINT *,'        [-depref LST-depht] : give a comma-separated list of reference depths '
     PRINT *,'              for potential density computation. eg : ''-depref  0,2000,3000'' '
     PRINT *,'              If not specified the unique reference depth is  0m (surface).'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        ',TRIM(cn_fmsk)
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_outu),', ',TRIM(cf_outv),' and ', TRIM(cf_outw)
     PRINT *,'       variables : vousig, vovsig, vowsig : mean product v x sigma-0 '
     PRINT *,'                                            at velocity point.'
     PRINT *,'                   vosigu, vosigv, vosigw : mean sigma-0 at velocity point.'
     PRINT *,'                   ',TRIM(cn_vozocrtx),', ',TRIM(cn_vomecrty),', ',TRIM(cn_vovecrtz),' : mean velocity components.'
     PRINT *,'      '
     STOP 
  ENDIF

  !! Initialisation from 1st file (all file are assume to have the same geometry)
  ijarg = 1 
  DO WHILE ( ijarg <= narg )
     CALL getarg(ijarg, cldum) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-c'     ) ; CALL getarg(ijarg, config ) ; ijarg=ijarg+1 
     CASE ( '-l'     ) ; CALL GetTagList
        ! options
     CASE ( '-S'     ) ; lsal = .TRUE.
     CASE ( '-o'     ) ; CALL getarg(ijarg, cf_root) ; ijarg=ijarg+1 
     CASE ( '-nc4'   ) ; lnc4 = .TRUE.
     CASE ( '-no-w'  ) ; lwo   =.FALSE. 
     CASE ( '-no-sig') ; lsigo =.FALSE.
     CASE ( '-no-uv' ) ; luvo  =.FALSE. 
     CASE ( '-T'     ) ; lTpt  =.TRUE.  
     CASE ( '-pref'  ) ; CALL getarg(ijarg, cldum  ) ; ijarg=ijarg+1 ; CALL ParseRefDep(cldum)
        ;                 lpref =.TRUE.  
     CASE DEFAULT      ; PRINT *,' ERROR : ',TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  END DO
  
  ! initialize refdep if not done on command line
  IF ( .NOT. lpref ) THEN
     ndep = 1
     ALLOCATE(refdep(ndep) )
     refdep(1) =0.0
  ENDIF

  ! |  always            |   if lsigo        |   if luvo    |
  ! | ndep [ u x sigma ] +   ndep [ sigma ]  +  2 [ u, u2 ] |
  nfieldu = ndep + ndep * COUNT ( (/lsigo /)  ) + 2 * COUNT ( (/luvo/) )
  nfieldv = nfieldu
  nfieldw = COUNT ( (/lwo /)) * nfieldu

  ctag = ctag_lst(1)
  cf_tfil = SetFileName ( config, ctag, 'T')
  IF ( lsal ) THEN
     cf_sfil = SetFileName(config, ctag, 'S')
  ELSE
     cf_sfil = cf_tfil
  ENDIF

  cf_ufil = SetFileName ( config, ctag, 'U')
  cf_vfil = SetFileName ( config, ctag, 'V')
  IF ( lwo ) cf_wfil = SetFileName ( config, ctag, 'W')

  npiglo = getdim (cf_tfil,cn_x)
  npjglo = getdim (cf_tfil,cn_y)
  npk    = getdim (cf_tfil,cn_z)

  PRINT *, 'npiglo =', npiglo
  PRINT *, 'npjglo =', npjglo
  PRINT *, 'npk    =', npk

  ALLOCATE( dcumulus(npiglo,npjglo,ndep), dcumulvs(npiglo,npjglo,ndep) )
  ALLOCATE( ztemp(npiglo,npjglo),    zsal(npiglo,npjglo)               )
  ALLOCATE( ztempu(npiglo,npjglo),  zsalu(npiglo,npjglo)               )
  ALLOCATE( ztempv(npiglo,npjglo),  zsalv(npiglo,npjglo)               )
  ALLOCATE( zu(npiglo,npjglo),       zv(npiglo,npjglo)                 )
  ALLOCATE( dsigu(npiglo,npjglo,ndep),    dsigv(npiglo,npjglo,ndep)    )
  ALLOCATE( umask(npiglo,npjglo),    vmask(npiglo,npjglo),    wmask(npiglo,npjglo)    )

  IF ( lwo   )           ALLOCATE( dcumulws(npiglo,npjglo,ndep) )
  IF ( lsigo )           ALLOCATE( dcumulsu(npiglo,npjglo,ndep), dcumulsv(npiglo,npjglo,ndep) )
  IF ( lwo .AND. lsigo ) ALLOCATE( dcumulsw(npiglo,npjglo,ndep) )
  IF ( luvo  )           ALLOCATE( dcumulu(npiglo,npjglo),  dcumulv(npiglo,npjglo)  )
  IF ( luvo  )           ALLOCATE( dcumulu2(npiglo,npjglo), dcumulv2(npiglo,npjglo) )
  IF ( lwo .AND. luvo  ) ALLOCATE( dcumulw(npiglo,npjglo), dcumulw2(npiglo,npjglo)  )

  IF ( lwo  )  ALLOCATE( zw(npiglo,npjglo)                             )
  IF ( lwo  )  ALLOCATE( ztempw(npiglo,npjglo),  zsalw(npiglo,npjglo)  )
  IF ( lwo  )  ALLOCATE( dsigw(npiglo,npjglo,ndep)                     )

  ! check periodicity (use ztemp as dummy array )
  ztemp(:,:) = getvar(cf_tfil, cn_vlon2d, 1, npiglo, npjglo )
  IF ( ztemp(1,1) == ztemp(npiglo-1,1) )  THEN
     lperio = .TRUE.
     PRINT *,' E-W periodicity detected '
  ENDIF

  CALL CreateOutputFile

  lcaltmean=.TRUE.
  DO jk = 1, npk
     PRINT *,'level ',jk
        ! Reset of cumulation arrays
        ;                   dcumulus(:,:,:) = 0.d0 
        ;                   dcumulvs(:,:,:) = 0.d0 

     IF ( lwo   )           dcumulws(:,:,:) = 0.d0

     IF ( lsigo ) THEN  ;   dcumulsu(:,:,:) = 0.d0 
        ;                   dcumulsv(:,:,:) = 0.d0  
     ENDIF
     IF ( lsigo .AND. lwo ) dcumulsw(:,:,:) = 0.d0

     IF ( luvo  ) THEN   ;  dcumulu(:,:)    = 0.d0  
        ;                   dcumulv(:,:)    = 0.d0 
     ENDIF
     IF ( luvo  ) THEN   ;  dcumulu2(:,:)   = 0.d0  
        ;                   dcumulv2(:,:)   = 0.d0 
     ENDIF
     IF (luvo .AND. lwo ) THEN ; dcumulw( :,:) = 0.d0 
        ;                        dcumulw2(:,:) = 0.d0 
     ENDIF
     dtotal_time   = 0.d0 ;  ntframe     = 0

     umask(:,:) = getvar(cn_fmsk, cn_umask , jk, npiglo, npjglo )
     vmask(:,:) = getvar(cn_fmsk, cn_vmask , jk, npiglo, npjglo )
     IF ( lwo .OR. lTpt ) wmask(:,:) = getvar(cn_fmsk, cn_tmask , jk, npiglo, npjglo )

     DO jt = 1, ntags            ! loop on tags
        ctag = ctag_lst(jt)
        cf_tfil = SetFileName ( config, ctag, 'T' )
        cf_ufil = SetFileName ( config, ctag, 'U' )
        cf_vfil = SetFileName ( config, ctag, 'V' )
        IF ( lwo ) cf_wfil = SetFileName ( config, ctag, 'W' )

        npt = getdim (cf_tfil, cn_t)
        IF ( lcaltmean ) THEN
           ALLOCATE ( dtim(npt) )
           dtim        = getvar1d(cf_tfil, cn_vtimec, npt)
           dtotal_time = dtotal_time + SUM(dtim(1:npt) )
           DEALLOCATE( dtim )
        END IF

        DO jtt = 1, npt  ! loop on time frame in a single file
           ntframe    = ntframe+1
           zu(:,:)    = getvar(cf_ufil, cn_vozocrtx, jk, npiglo, npjglo, ktime=jtt )
           zv(:,:)    = getvar(cf_vfil, cn_vomecrty, jk, npiglo, npjglo, ktime=jtt )
           ztemp(:,:) = getvar(cf_tfil, cn_votemper, jk, npiglo, npjglo, ktime=jtt )
           zsal(:,:)  = getvar(cf_sfil, cn_vosaline, jk, npiglo, npjglo, ktime=jtt )
           IF ( lwo ) zw(:,:)    = getvar(cf_wfil, cn_vovecrtz, jk, npiglo, npjglo, ktime=jtt )

           dsigu(:,:,:) = 0.d0  ; dsigv(:,:,:) = 0.d0
           IF ( lTpt )  THEN
              ! u,v at T point
              DO ji=npiglo,2,-1
                 zu(ji,:) = 0.5 * ( zu(ji-1,:) + zu(ji,:) )
              END DO
              DO jj=npjglo,2,-1
                 zv(:,jj) = 0.5 * ( zv(:,jj-1) + zv(:,jj) )
              END DO
              IF ( lperio ) THEN
                 zu(1,:) = zu(npiglo-1,:)
              ENDIF
              IF ( luvo ) THEN
                 dcumulu(:,:)   = dcumulu(:,:)  + zu(:,:)    * 1.d0
                 dcumulv(:,:)   = dcumulv(:,:)  + zv(:,:)    * 1.d0
                 dcumulu2(:,:)  = dcumulu2(:,:)  + zu(:,:)*zu(:,:) * 1.d0
                 dcumulv2(:,:)  = dcumulv2(:,:)  + zv(:,:)*zv(:,:) * 1.d0
              ENDIF
              DO jsig=1,ndep
                 zdepref=refdep(jsig)
                 ! rem : use dsigu for sig at T point, for the sake of simplicity ...
                 dsigu(:,:,jsig) = sigmai(ztemp, zsal, zdepref, npiglo, npjglo) * wmask(:,:)

                 dcumulus(:,:,jsig) = dcumulus(:,:,jsig) + dsigu(:,:,jsig) * zu(:,:) * 1.d0
                 dcumulvs(:,:,jsig) = dcumulvs(:,:,jsig) + dsigu(:,:,jsig) * zv(:,:) * 1.d0
                 IF ( lsigo ) THEN
                    dcumulsu(:,:,jsig) = dcumulsu(:,:,jsig) + dsigu(:,:,jsig) * 1.d0
                 ENDIF
              ENDDO
           ELSE
              ! temperature at u point, v points
              DO ji=1, npiglo-1
                 DO jj = 1, npjglo -1
                    ztempu(ji,jj) = 0.5 * ( ztemp(ji,jj) + ztemp(ji+1,jj) )  ! temper at Upoint
                    ztempv(ji,jj) = 0.5 * ( ztemp(ji,jj) + ztemp(ji,jj+1) )  ! temper at Vpoint
                    zsalu(ji,jj)  = 0.5 * ( zsal(ji,jj)  +  zsal(ji+1,jj) )  ! sal at U point
                    zsalv(ji,jj)  = 0.5 * ( zsal(ji,jj)  +  zsal(ji,jj+1) )  ! sal at v point
                 END DO
              END DO

              IF ( luvo ) THEN
                 dcumulu(:,:)   = dcumulu(:,:)  + zu(:,:)    * 1.d0
                 dcumulv(:,:)   = dcumulv(:,:)  + zv(:,:)    * 1.d0
                 dcumulu2(:,:)  = dcumulu2(:,:)  + zu(:,:)*zu(:,:) * 1.d0
                 dcumulv2(:,:)  = dcumulv2(:,:)  + zv(:,:)*zv(:,:) * 1.d0
              ENDIF
              DO jsig=1,ndep
                 zdepref=refdep(jsig)
                 dsigu(:,:,jsig) = sigmai(ztempu, zsalu, zdepref, npiglo, npjglo) * umask(:,:)
                 dsigv(:,:,jsig) = sigmai(ztempv, zsalv, zdepref, npiglo, npjglo) * vmask(:,:)

                 dcumulus(:,:,jsig) = dcumulus(:,:,jsig) + dsigu(:,:,jsig) * zu(:,:) * 1.d0
                 dcumulvs(:,:,jsig) = dcumulvs(:,:,jsig) + dsigv(:,:,jsig) * zv(:,:) * 1.d0
                 IF ( lsigo ) THEN
                    dcumulsu(:,:,jsig) = dcumulsu(:,:,jsig) + dsigu(:,:,jsig) * 1.d0
                    dcumulsv(:,:,jsig) = dcumulsv(:,:,jsig) + dsigv(:,:,jsig) * 1.d0
                 ENDIF

                 IF ( lwo ) THEN
                    IF ( jk > 1 ) THEN ! now wsig
                       ztempw(:,:)   = 0.5 * ( ztemp(:,:) + getvar(cf_tfil, cn_votemper, jk-1, npiglo, npjglo, ktime=jtt ))
                       zsalw(:,:)    = 0.5 * ( zsal(:,:)  + getvar(cf_sfil, cn_vosaline, jk-1, npiglo, npjglo, ktime=jtt ))
                       dsigw(:,:,jsig)    = sigmai(ztempw, zsalw, zdepref, npiglo, npjglo) * wmask(:,:)
                       dcumulws(:,:,jsig) = dcumulws(:,:,jsig) + dsigw(:,:,jsig) * zw(:,:) * 1.d0
                       IF ( lsigo ) dcumulsw(:,:,jsig) = dcumulsw(:,:,jsig) + dsigw(:,:,jsig) * 1.d0
                       IF ( luvo  ) dcumulw(:,:)   = dcumulw(:,:)   + zw(:,:)         * 1.d0
                       IF ( luvo  ) dcumulw2(:,:)  = dcumulw2(:,:)  + zw(:,:)*zw(:,:) * 1.d0
                    ENDIF
                 ENDIF
              ENDDO
           ENDIF  ! Tpoint

        END DO  !jtt
     END DO  ! jt
     ! finish with level jk ; compute mean (assume spval is 0 )
     ivaru=0 ; ivarv=0 ; ivarw=0
     !    U
     DO jsig=1,ndep
        ivaru=ivaru + 1
        ierr = putvar(ncoutu, id_varoutu(ivaru), SNGL(dcumulus(:,:,jsig)/ntframe), jk, npiglo, npjglo, kwght=ntframe )
        IF ( lsigo) THEN 
           ivaru=ivaru + 1
           ierr = putvar(ncoutu, id_varoutu(ivaru), SNGL(dcumulsu(:,:,jsig)/ntframe), jk, npiglo, npjglo, kwght=ntframe )
        ENDIF
     END DO

     IF ( luvo ) THEN 
        ivaru=ivaru + 1
        ierr = putvar(ncoutu, id_varoutu(ivaru), SNGL(dcumulu(:,:)      /ntframe), jk, npiglo, npjglo, kwght=ntframe )
        ivaru=ivaru + 1
        ierr = putvar(ncoutu, id_varoutu(ivaru), SNGL(dcumulu2(:,:)     /ntframe), jk, npiglo, npjglo, kwght=ntframe )
     ENDIF

     !    V
     DO jsig=1,ndep
        ivarv=ivarv + 1
        ierr = putvar(ncoutv, id_varoutv(ivarv), SNGL(dcumulvs(:,:,jsig)/ntframe), jk, npiglo, npjglo, kwght=ntframe )
        IF ( lsigo) THEN 
           ivarv=ivarv + 1
           ierr = putvar(ncoutv, id_varoutv(ivarv), SNGL(dcumulsv(:,:,jsig)/ntframe), jk, npiglo, npjglo, kwght=ntframe )
        ENDIF
     ENDDO
     IF ( luvo ) THEN 
        ivarv=ivarv + 1
        ierr = putvar(ncoutv, id_varoutv(ivarv), SNGL(dcumulv(:,:)      /ntframe), jk, npiglo, npjglo, kwght=ntframe )
        ivarv=ivarv + 1
        ierr = putvar(ncoutv, id_varoutv(ivarv), SNGL(dcumulv2(:,:)     /ntframe), jk, npiglo, npjglo, kwght=ntframe )
     ENDIF

     !    W
     IF ( lwo ) THEN
        DO jsig=1,ndep
           ivarw=ivarw + 1
           ierr = putvar(ncoutw, id_varoutw(ivarw), SNGL(dcumulws(:,:,jsig)/ntframe), jk, npiglo, npjglo, kwght=ntframe )
           IF (lsigo) THEN 
              ivarw=ivarw + 1
              ierr = putvar(ncoutw, id_varoutw(ivarw), SNGL(dcumulsw(:,:,jsig)/ntframe), jk, npiglo, npjglo, kwght=ntframe )
           ENDIF
        ENDDO
        IF ( luvo ) THEN 
           ivarw=ivarw + 1
           ierr = putvar(ncoutw, id_varoutw(ivarw), SNGL(dcumulw(:,:)      /ntframe), jk, npiglo, npjglo, kwght=ntframe )
           ivarw=ivarw + 1
           ierr = putvar(ncoutw, id_varoutw(ivarw), SNGL(dcumulw2(:,:)     /ntframe), jk, npiglo, npjglo, kwght=ntframe )
        ENDIF
     ENDIF

     IF ( lcaltmean )  THEN
        dtimean(1)= dtotal_time/ntframe
        ierr      = putvar1d(ncoutu, dtimean, 1, 'T')
        ierr      = putvar1d(ncoutv, dtimean, 1, 'T')
        IF ( lwo ) ierr = putvar1d(ncoutw, dtimean, 1, 'T')
     END IF

     lcaltmean = .FALSE. ! tmean already computed

  END DO  ! loop to next level

  ierr = closeout(ncoutu)
  ierr = closeout(ncoutv)
  IF ( lwo ) ierr = closeout(ncoutw)

CONTAINS

  SUBROUTINE CreateOutputFile
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutputFile  ***
    !!
    !! ** Purpose :  Create netcdf file according to flags
    !!
    !! ** Method  :  Flags are global variables and there dore known in
    !!               in this routine.
    !!
    !!----------------------------------------------------------------------
    INTEGER(KIND=4)    :: jsig, ivaru, ivarv, ivarw, jf
    CHARACTER(LEN=1)   :: cldep
    CHARACTER(LEN=256) :: cl_global, cl_refu, cl_refv, cl_refw
    !!----------------------------------------------------------------------
    ALLOCATE ( stypvaru(nfieldu), ipku(nfieldu), id_varoutu(nfieldu)    )
    ALLOCATE ( stypvarv(nfieldv), ipkv(nfieldv), id_varoutv(nfieldv)     )
    IF ( lwo ) ALLOCATE ( stypvarw(nfieldw), ipkw(nfieldw), id_varoutw(nfieldw)  )

    ! initialize chunking used in case of lnc4
    DO jf=1, nfieldu
       stypvaru(jf)%ichunk = (/npiglo,MAX(1,npjglo/30),1,1 /)
    ENDDO
    DO jf=1, nfieldv
       stypvarv(jf)%ichunk = (/npiglo,MAX(1,npjglo/30),1,1 /)
    ENDDO
    IF ( lwo ) THEN
      DO jf=1, nfieldw
         stypvarw(jf)%ichunk = (/npiglo,MAX(1,npjglo/30),1,1 /)
      ENDDO
    ENDIF

    IF ( lTpt ) THEN
       cl_global = ' All variables computed on T points'
       cl_refu= cf_tfil
       cl_refv= cf_tfil
       cl_refw= cf_tfil
    ELSE
       cl_global = ' All variables on native U or V points'
       cl_refu= cf_ufil
       cl_refv= cf_vfil
       cl_refw= cf_wfil
    ENDIF


    ! define output variables  U points
    stypvaru%rmissing_value    = 0.
    stypvaru%valid_min         = -100.
    stypvaru%valid_max         = 100.
    stypvaru%conline_operation = 'N/A'
    stypvaru%caxis             = 'TZYX'
    ipku(:)= npk  ! all variables (input and output are 3D)

    ivaru=0
    DO jsig = 1, ndep
       WRITE(cldep,'(I1)') INT(refdep(jsig)/1000)
       ivaru = ivaru + 1
       stypvaru(ivaru)%cname      = 'vousig'//cldep          ; stypvaru(ivaru)%cunits    = 'kg.m-2.s-1'
       stypvaru(ivaru)%clong_name = 'Mean U x sigma'//cldep  ; stypvaru(ivaru)%cshort_name   = 'vousig'//cldep

       IF ( lsigo ) THEN
          ivaru = ivaru + 1 
          stypvaru(ivaru)%cname      = 'vosigu'//cldep              ; stypvaru(ivaru)%cunits  = 'kg.m-3'
          stypvaru(ivaru)%clong_name = 'Mean sigma'//cldep//' at U' ; stypvaru(ivaru)%cshort_name = 'vosigu'//cldep
       ENDIF
    ENDDO

    IF ( luvo ) THEN
       ivaru = ivaru + 1 
       stypvaru(ivaru)%cname      = cn_vozocrtx      ; stypvaru(ivaru)%cunits        = 'm/s'
       stypvaru(ivaru)%clong_name = 'Mean zonal vel' ; stypvaru(ivaru)%cshort_name   = cn_vozocrtx
       ivaru = ivaru + 1 
       stypvaru(ivaru)%cname      = TRIM(cn_vozocrtx)//'_sqd'      ; stypvaru(ivaru)%cunits        = '(m/s)^2'
       stypvaru(ivaru)%clong_name = 'Mean zonal vel squared' ; stypvaru(ivaru)%cshort_name   = TRIM(cn_vozocrtx)//'_sqd' 
    ENDIF

    ! create output fileset
    ncoutu = create      (cf_outu, cl_refu,  npiglo, npjglo, npk                                  , ld_nc4=lnc4)
    ierr   = createvar   (ncoutu,  stypvaru, nfieldu,      ipku,   id_varoutu , cdglobal=cl_global, ld_nc4=lnc4)
    ierr   = putheadervar(ncoutu,  cl_refu,  npiglo, npjglo, npk        )


    ! define output variables  V points
    stypvarv%rmissing_value    = 0.
    stypvarv%valid_min         = -100.
    stypvarv%valid_max         = 100.
    stypvarv%conline_operation = 'N/A'
    stypvarv%caxis             = 'TZYX'
    ipkv(:)= npk  !   "                     "

    ivarv=0
    DO jsig = 1, ndep 
       WRITE(cldep,'(I1)') INT(refdep(jsig)/1000)
       ivarv = ivarv + 1
       stypvarv(ivarv)%cname      = 'vovsig'//cldep          ; stypvarv(ivarv)%cunits      = 'kg.m-2.s-1'
       stypvarv(ivarv)%clong_name = 'Mean V x sigma'//cldep  ; stypvarv(ivarv)%cshort_name = 'vovsig'//cldep

       IF ( lsigo ) THEN
          ivarv = ivarv + 1
          stypvarv(ivarv)%cname      = 'vosigv'//cldep              ; stypvarv(ivarv)%cunits      = 'kg.m-3'
          stypvarv(ivarv)%clong_name = 'Mean sigma'//cldep//' at V' ; stypvarv(ivarv)%cshort_name = 'vosigv'//cldep
       ENDIF
    ENDDO

    IF ( luvo ) THEN
       ivarv = ivarv + 1 
       stypvarv(ivarv)%cname      = cn_vomecrty      ; stypvarv(ivarv)%cunits        = 'm/s'
       stypvarv(ivarv)%clong_name = 'Mean merid vel' ; stypvarv(ivarv)%cshort_name   = cn_vomecrty
       ivarv = ivarv + 1 
       stypvarv(ivarv)%cname      = TRIM(cn_vomecrty)//'_sqd'      ; stypvarv(ivarv)%cunits  = '(m/s)^2'
       stypvarv(ivarv)%clong_name = 'Mean merid vel squared' ; stypvarv(ivarv)%cshort_name   = TRIM(cn_vomecrty)//'_sqd'
    ENDIF

    ncoutv = create      (cf_outv, cl_refv,  npiglo, npjglo, npk                                  , ld_nc4=lnc4)
    ierr   = createvar   (ncoutv,  stypvarv, nfieldv,      ipkv,   id_varoutv, cdglobal=cl_global , ld_nc4=lnc4)
    ierr   = putheadervar(ncoutv,  cl_refv,  npiglo, npjglo, npk        )

    IF ( lwo ) THEN
       ! define output variables  W points
       stypvarw%rmissing_value    = 0.
       stypvarw%valid_min         = -100.
       stypvarw%valid_max         = 100.
       stypvarw%conline_operation = 'N/A'
       stypvarw%caxis             = 'TZYX'
       ipkw(:)= npk  !   "                     "

       ivarw=0
       DO jsig = 1, ndep
          WRITE(cldep,'(I1)') INT(refdep(jsig)/1000)
          ivarw = ivarw + 1
          stypvarw(ivarw)%cname      = 'vowsig'//cldep          ; stypvarw(ivarw)%cunits      = 'kg.m-2.s-1'
          stypvarw(ivarw)%clong_name = 'Mean W x sigma'//cldep  ; stypvarw(ivarw)%cshort_name = 'vowsig'//cldep

          IF ( lsigo ) THEN
             ivarw = ivarw + 1
             stypvarw(ivarw)%cname      = 'vosigw'//cldep              ; stypvarw(ivarw)%cunits      = 'kg.m-3'
             stypvarw(ivarw)%clong_name = 'Mean sigma'//cldep//' at W' ; stypvarw(ivarw)%cshort_name = 'vosigw'//cldep
          ENDIF
       ENDDO

       IF ( luvo ) THEN
          ivarw = ivarw + 1
          stypvarw(ivarw)%cname      = cn_vovecrtz      ; stypvarw(ivarw)%cunits        = 'm/s'
          stypvarw(ivarw)%clong_name = 'Mean vert. vel' ; stypvarw(ivarw)%cshort_name   = cn_vovecrtz
          ivarw = ivarw + 1
          stypvarw(ivarw)%cname      = TRIM(cn_vovecrtz)//'_sqd' ; stypvarw(ivarw)%cunits       = '(m/s)^2'
          stypvarw(ivarw)%clong_name = 'Mean vert. vel squared' ; stypvarw(ivarw)%cshort_name   = TRIM(cn_vovecrtz)//'_sqd'
       ENDIF

       ncoutw = create      (cf_outw, cl_refw,  npiglo, npjglo, npk                                 , ld_nc4=lnc4)
       ierr   = createvar   (ncoutw,  stypvarw, nfieldw,      ipkw,   id_varoutw, cdglobal=cl_global, ld_nc4=lnc4)
       ierr   = putheadervar(ncoutw,  cl_refw,  npiglo, npjglo, npk        )
    ENDIF

  END SUBROUTINE  CreateOutputFile

  SUBROUTINE ParseRefDep (cdum)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE ParseRefDep  ***
    !!
    !! ** Purpose :  Decode variable name  option from command line
    !!
    !! ** Method  :  look for , in the argument string and set the number of
    !!         ref_dep (ndep), allocate  array and fill it with the
    !!         decoded  names.
    !!
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*), INTENT(in) :: cdum

    CHARACTER(LEN=80), DIMENSION(100) :: cl_dum  ! 100 is arbitrary
    INTEGER  :: ji
    INTEGER  :: inchar,  i1=1
    !!----------------------------------------------------------------------
    inchar= LEN(TRIM(cdum))
    ndep = 1
    ! scan the input string and look for ',' as separator
    DO ji=1,inchar
       IF ( cdum(ji:ji) == ',' ) THEN
          cl_dum(ndep) = cdum(i1:ji-1)
          i1=ji+1
          ndep=ndep+1
       ENDIF
    ENDDO

    ! last name of the list does not have a ','
    cl_dum(ndep) = cdum(i1:inchar)

    ALLOCATE ( refdep(ndep) )
    DO ji=1, ndep
       READ(cl_dum(ji),*) refdep(ji)
    ENDDO
    PRINT *, refdep
  END SUBROUTINE ParseRefDep

  SUBROUTINE GetTagList
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE GetTagList  ***
    !!
    !! ** Purpose :  Set up a tag list given on the command line as 
    !!               blank separated list
    !!
    !! ** Method  :  Scan the command line until a '-' is found
    !!----------------------------------------------------------------------
    INTEGER (KIND=4)  :: ji
    INTEGER (KIND=4)  :: icur
    !!----------------------------------------------------------------------
    !!
    ntags=0
    ! need to read a list of file ( number unknow ) 
    ! loop on argument till a '-' is found as first char
    icur=ijarg                          ! save current position of argument number
    DO ji = icur, narg                  ! scan arguments till - found
       CALL getarg ( ji, cldum )
       IF ( cldum(1:1) /= '-' ) THEN ; ntags = ntags+1
       ELSE                          ; EXIT
       ENDIF
    ENDDO
    ALLOCATE (ctag_lst(ntags) )
    DO ji = icur, icur + ntags -1
       CALL getarg(ji, ctag_lst( ji -icur +1 ) ) ; ijarg=ijarg+1
    END DO
  END SUBROUTINE GetTagList

END PROGRAM cdfvsig

MODULE icediag
  !!======================================================================
  !!                     ***  MODULE  icediag  ***
  !! Container for the icediags routine
  !!=====================================================================
  !! History : 3.0  !  date     J. Regidor      Create module
  !!----------------------------------------------------------------------

  !!----------------------------------------------------------------------
  !!   routines      : description
  !!   icediags      : compute ice diagnostics
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class ice_diagnostics
  !!----------------------------------------------------------------------
CONTAINS

  SUBROUTINE icediags(e1, e2, tmask, ff, ricethick, riceldfra, dvoln, darean, dextendn, &
       dextendn2, dvols, dareas, dextends, dextends2)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE icediags  ***
    !!
    !! ** Purpose :  Compute ice diagnostics ice volume, ice area and ice extend
    !!               for both hemisphere.
    !!
    !! ** Method  :  surface integration 
    !!
    !! ** Comment :  The use of a routine instead of having the computation in the
    !!               core of the program is experimental. Doing so, the routine can
    !!               be called from a python script, but having a routine with 14
    !!               arguments is a real problem for readibility.
    !!----------------------------------------------------------------------
    REAL(KIND=4), DIMENSION(:,:), INTENT(IN) :: e1, e2               ! metrics
    REAL(KIND=4), DIMENSION(:,:), INTENT(IN) :: tmask, ff            ! npiglo x npjglo
    REAL(KIND=4), DIMENSION(:,:), INTENT(IN) :: ricethick, riceldfra ! thickness, leadfrac (concentration)
    REAL(KIND=8), INTENT(OUT)        :: dvols, dareas        ! volume, area extend South hemisphere
    REAL(KIND=8), INTENT(OUT)        :: dextends, dextends2  ! volume, area extend South hemisphere
    REAL(KIND=8), INTENT(OUT)        :: dvoln, darean        ! volume, area extend North hemisphere
    REAL(KIND=8), INTENT(OUT)        :: dextendn, dextendn2
    !!----------------------------------------------------------------------

    ! North : ff > 0
    dvoln     = SUM( ricethick (:,:)* e1(:,:) * e2(:,:) * riceldfra (:,:) * tmask (:,:), (ff > 0 ) )
    darean    = SUM(                  e1(:,:) * e2(:,:) * riceldfra (:,:) * tmask (:,:), (ff > 0 ) )
    dextendn  = SUM(                  e1(:,:) * e2(:,:) * riceldfra (:,:) * tmask (:,:), (riceldfra > 0.15 .AND. ff > 0 ) )
    ! JMM added 22/01/2007 : to compute same extent than the NSIDC
    dextendn2 = SUM(                  e1(:,:) * e2(:,:)                   * tmask (:,:), (riceldfra > 0.15 .AND. ff > 0 ) )

    ! South : ff < 0
    dvols     = SUM( ricethick (:,:)* e1(:,:) * e2(:,:) * riceldfra (:,:) * tmask (:,:), (ff < 0 ) )
    dareas    = SUM(                  e1(:,:) * e2(:,:) * riceldfra (:,:) * tmask (:,:), (ff < 0 ) )
    dextends  = SUM(                  e1(:,:) * e2(:,:) * riceldfra (:,:) * tmask (:,:), (riceldfra > 0.15 .AND. ff < 0  ) )
    dextends2 = SUM(                  e1(:,:) * e2(:,:)                   * tmask (:,:), (riceldfra > 0.15 .AND. ff < 0  ) )

    dvoln = dvoln / 1d9
    darean = darean / 1d9
    dextendn = dextendn / 1d9
    dextendn2 = dextendn2 / 1d9

    dvols = dvols / 1d9
    dareas = dareas / 1d9
    dextends = dextends / 1d9
    dextends2 = dextends2 / 1d9
  END SUBROUTINE icediags

END MODULE icediag


PROGRAM cdficediag
  !!======================================================================
  !!                     ***  PROGRAM  cdficediag  ***
  !!=====================================================================
  !!  ** Purpose : Compute the Ice volume, area and extend for each 
  !!               hemisphere
  !!
  !!  ** Method  : Use the icemod files for input and determine the
  !!               hemisphere with sign of the coriolis parameter.
  !!
  !! History : 2.1  : 01/2006  : J.M. Molines : Original code
  !!         : 2.1  : 07/2009  : R. Dussin    : Add Ncdf output
  !!           3.0  : 12/2010  : J.M. Molines : Doctor norm + Lic.
  !! Modified: 3.0  : 08/2011  : P.   Mathiot : Add LIM3 option
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  USE icediag
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                            :: jt           ! dummy loop index
  INTEGER(KIND=4)                            :: ierr                 ! working integer
  INTEGER(KIND=4)                            :: narg, iargc          ! command line
  INTEGER(KIND=4)                            :: ijarg                ! command line
  INTEGER(KIND=4)                            :: npiglo, npjglo, npt  ! size of the domain
  INTEGER(KIND=4)                            :: nperio = 4           ! boundary condition ( periodic, north fold)
  INTEGER(KIND=4)                            :: ikx=1, iky=1, ikz=0  ! dims of netcdf output file
  INTEGER(KIND=4)                            :: nboutput=8           ! number of values to write in cdf output
  INTEGER(KIND=4)                            :: ncout                ! for netcdf output
  INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE :: ipk, id_varout

  REAL(KIND=4), DIMENSION(:,:),  ALLOCATABLE :: e1, e2               ! metrics
  REAL(KIND=4), DIMENSION(:,:),  ALLOCATABLE :: tmask, ff            ! npiglo x npjglo
  REAL(KIND=4), DIMENSION(:,:),  ALLOCATABLE :: ricethick, riceldfra ! thickness, leadfrac (concentration)
  REAL(KIND=4), DIMENSION(:,:),  ALLOCATABLE :: rdumlon, rdumlat     ! dummy lon lat for output

  REAL(KIND=8)                               :: dvols, dareas        ! volume, area extend South hemisphere
  REAL(KIND=8)                               :: dextends, dextends2  ! volume, area extend South hemisphere
  REAL(KIND=8)                               :: dvoln, darean        ! volume, area extend North hemisphere
  REAL(KIND=8)                               :: dextendn, dextendn2  ! volume, area extend North hemisphere
  REAL(KIND=8), DIMENSION(:),    ALLOCATABLE :: dtim                 ! time counter

  TYPE(variable), DIMENSION(:),  ALLOCATABLE :: stypvar              ! structure of output
  !
  CHARACTER(LEN=256)                         :: cf_ifil              ! input ice file
  CHARACTER(LEN=256)                         :: cf_out='icediags.nc' ! output file
  CHARACTER(LEN=256)                         :: cldum                ! dummy string
  CHARACTER(LEN=256)                         :: cv_mask              ! mask variable name
  !
  LOGICAL                                    :: lchk  = .FALSE.      ! missing file flag
  LOGICAL                                    :: llim3 = .FALSE.      ! LIM3 flag
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()
  cv_mask=cn_tmask

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdficediag -i ICE-file [-lim3] [-o OUT-file] [-maskfile MSK-file] ...'
     PRINT *,'                   ... [-maskvar MSK-var]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'        Compute the ice volume, area and extent for each hemisphere.'
     PRINT *,'        The extent is computed in a similar way to NSIDC for easy '
     PRINT *,'        comparison : the extent is the surface of the grid cells covered'
     PRINT *,'        by ice when the ice concentration is above 0.15'
     PRINT *,'      '
     PRINT *,'        For compatibility with previous version, another estimate of '
     PRINT *,'        the extend is computed using grid cell surfaces weighted by the'
     PRINT *,'        ice concentration, but it will be deprecated soon.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -i ICE-file : netcdf icemod file (LIM2 by default)' 
     PRINT *,'      '
     PRINT *,'     OPTION :'
     PRINT *,'       [-lim3 ] : LIM3 variable name convention is used. Default is LIM2.'
     PRINT *,'       [-maskfile MSK-file] : specify name of mask file instead of ',TRIM(cn_fmsk)
     PRINT *,'       [-maskvar MSK-var ] : specify name of mask variable instead of ',TRIM(cn_tmask)
     PRINT *,'       [-o OUT-file ] : specify output file instead of ',TRIM(cf_out)
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        ',TRIM(cn_fhgr),' and ',TRIM(cn_fmsk)
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : [NS]Volume  (10^9 m3 )'
     PRINT *,'                     [NS]Area    (10^9 m2 )'
     PRINT *,'                     [NS]Extent  (10^9 m2 ) -- obsolete --'
     PRINT *,'                     [NS]Exnsidc (10^9 m2 )'
     PRINT *,'               N = northern hemisphere'
     PRINT *,'               S = southern hemisphere'
     PRINT *,'       standard output'
     STOP 
  ENDIF

  ijarg = 1 
  DO WHILE ( ijarg <= narg )
     CALL getarg (ijarg, cldum   ) ; ijarg = ijarg + 1 
     SELECT CASE ( cldum )
     CASE ( '-i'       ) ; CALL getarg (ijarg, cf_ifil) ; ijarg=ijarg+1
     CASE ( '-lim3'    ) ; llim3 = .TRUE.
     CASE ( '-maskvar' ) ; CALL getarg (ijarg, cv_mask) ; ijarg=ijarg+1
     CASE ( '-maskfile') ; CALL getarg (ijarg, cn_fmsk) ; ijarg=ijarg+1
     CASE ('-o'        ) ; CALL getarg (ijarg, cf_out ) ; ijarg=ijarg+1
     CASE DEFAULT        ; PRINT *,' ERROR : ',TRIM(cldum), ' : unknown option.' ; STOP 99
     END SELECT
  END DO

  lchk = lchk .OR. chkfile(cn_fhgr)
  lchk = lchk .OR. chkfile(cn_fmsk)
  lchk = lchk .OR. chkfile(cf_ifil)

  IF ( lchk ) STOP 99 ! missing file

  npiglo = getdim (cf_ifil,cn_x)
  npjglo = getdim (cf_ifil,cn_y)
  npt    = getdim (cf_ifil,cn_t)

  ALLOCATE ( tmask(npiglo,npjglo) ,ff(npiglo,npjglo) )
  ALLOCATE ( ricethick(npiglo,npjglo) )
  ALLOCATE ( riceldfra(npiglo,npjglo) )
  ALLOCATE ( e1(npiglo,npjglo),e2(npiglo,npjglo) )
  ALLOCATE ( dtim(npt) )

  ALLOCATE ( stypvar(nboutput), ipk(nboutput), id_varout(nboutput) )
  ALLOCATE ( rdumlon(1,1), rdumlat(1,1) )

  CALL CreateOutput

  e1(:,:) = getvar(cn_fhgr, cn_ve1t,  1, npiglo, npjglo)
  e2(:,:) = getvar(cn_fhgr, cn_ve2t,  1, npiglo, npjglo)
  ff(:,:) = getvar(cn_fhgr, cn_gphit, 1, npiglo, npjglo) ! only the sign of ff is important

  ! modify the mask for periodic and north fold condition (T pivot, F Pivot ...)
  ! in fact should be nice to use jperio as in the code ...
  tmask(:,:)=getvar(cn_fmsk,cv_mask,1,npiglo,npjglo)
  SELECT CASE (nperio)
  CASE (0) ! closed boundaries
     ! nothing to do
  CASE (4) ! ORCA025 type boundary
     tmask(1:2,:)=0.
     tmask(:,npjglo)=0.
     tmask(npiglo/2+1:npiglo,npjglo-1)= 0.
  CASE (6)
     tmask(1:2,:)=0.
     tmask(:,npjglo)=0.
  CASE DEFAULT
     PRINT *,' Nperio=', nperio,' not yet coded'
     STOP 99
  END SELECT

  ricethick(:,:)=0.
  riceldfra(:,:)=0.

  IF (llim3) THEN
     cn_iicethic = cn_iicethic3
     cn_ileadfra = cn_ileadfra3
  END IF

  ! Check variable
  IF (chkvar(cf_ifil, cn_iicethic)) THEN
     cn_iicethic='missing'
     PRINT *,'' 
     PRINT *,' WARNING, ICE THICKNESS IS SET TO 0. '
     PRINT *,' '
  END IF

  IF (chkvar(cf_ifil, cn_ileadfra)) STOP 99
  !
  DO jt = 1, npt
     IF (TRIM(cn_iicethic) .NE. 'missing') ricethick(:,:) = getvar(cf_ifil, cn_iicethic, 1, npiglo, npjglo, ktime=jt)
     riceldfra(:,:) = getvar(cf_ifil, cn_ileadfra, 1, npiglo, npjglo, ktime=jt)

     CALL icediags(e1, e2, tmask, ff, ricethick, riceldfra, dvoln, darean, dextendn, dextendn2, dvols, dareas, dextends, dextends2)

     PRINT *,' TIME = ', jt,' ( ',dtim(jt),' )'
     PRINT *,' Northern Hemisphere ' 
     PRINT *,'          NVolume (10^9 m3)  ', dvoln
     PRINT *,'          NArea (10^9 m2)    ', darean
     PRINT *,'          NExtend (10^9 m2)  ', dextendn
     PRINT *,'          NExnsidc (10^9 m2) ', dextendn2
     PRINT *
     PRINT *,' Southern Hemisphere ' 
     PRINT *,'          SVolume (10^9 m3)  ', dvols
     PRINT *,'          SArea (10^9 m2)    ', dareas
     PRINT *,'          SExtend (10^9 m2)  ', dextends
     PRINT *,'          SExnsidc (10^9 m2) ', dextends2


     ! netcdf output 
     ierr = putvar0d(ncout,id_varout(1), REAL(dvoln     ), ktime=jt)
     ierr = putvar0d(ncout,id_varout(2), REAL(darean    ), ktime=jt)
     ierr = putvar0d(ncout,id_varout(3), REAL(dextendn  ), ktime=jt)
     ierr = putvar0d(ncout,id_varout(4), REAL(dextendn2 ), ktime=jt)
     ierr = putvar0d(ncout,id_varout(5), REAL(dvols     ), ktime=jt)
     ierr = putvar0d(ncout,id_varout(6), REAL(dareas    ), ktime=jt)
     ierr = putvar0d(ncout,id_varout(7), REAL(dextends  ), ktime=jt)
     ierr = putvar0d(ncout,id_varout(8), REAL(dextends2 ), ktime=jt)
  END DO ! time loop
  ierr = closeout(ncout)

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------

    rdumlon(:,:) = 0.
    rdumlat(:,:) = 0.
    ipk(:) = 1
    ! define new variables for output 
    stypvar%scale_factor      = 1.
    stypvar%add_offset        = 0.
    stypvar%savelog10         = 0.
    stypvar%conline_operation = 'N/A'
    stypvar%caxis             = 'T'

    stypvar(1)%cname          = 'NVolume'
    stypvar(1)%cunits         = '10^9 m3'
    stypvar(1)%clong_name     = 'Ice_volume_in_Northern_Hemisphere'
    stypvar(1)%cshort_name    = 'NVolume'

    stypvar(2)%cname          = 'NArea'
    stypvar(2)%cunits         = '10^9 m2'
    stypvar(2)%clong_name     = 'Ice_area_in_Northern_Hemisphere'
    stypvar(2)%cshort_name    = 'NArea'

    stypvar(3)%cname          = 'NExtent'
    stypvar(3)%cunits         = '10^9 m2'
    stypvar(3)%clong_name     = 'Ice_extent_in_Northern_Hemisphere'
    stypvar(3)%cshort_name    = 'NExtent'

    stypvar(4)%cname          = 'NExnsidc'
    stypvar(4)%cunits         = '10^9 m2'
    stypvar(4)%clong_name     = 'Ice_extent_similar_to_NSIDC_in_Northern_Hemisphere'
    stypvar(4)%cshort_name    = 'NExnsidc'

    stypvar(5)%cname          = 'SVolume'
    stypvar(5)%cunits         = '10^9 m3'
    stypvar(5)%clong_name     = 'Ice_volume_in_Southern_Hemisphere'
    stypvar(5)%cshort_name    = 'SVolume'

    stypvar(6)%cname          = 'SArea'
    stypvar(6)%cunits         = '10^9 m2'
    stypvar(6)%clong_name     = 'Ice_area_in_Southern_Hemisphere'
    stypvar(6)%cshort_name    = 'SArea'

    stypvar(7)%cname          = 'SExtent'
    stypvar(7)%cunits         = '10^9 m2'
    stypvar(7)%clong_name     = 'Ice_extent_in_Southern_Hemisphere'
    stypvar(7)%cshort_name    = ''

    stypvar(8)%cname          = 'SExnsidc'
    stypvar(8)%cunits         = '10^9 m2'
    stypvar(8)%clong_name     = 'Ice_extent_similar_to_NSIDC_in_Southern_Hemisphere'
    stypvar(8)%cshort_name    = 'SExnsidc'

    ! create output fileset
    ncout = create      (cf_out, 'none',  ikx,      iky, ikz,     cdep='depthw'                   )
    ierr  = createvar   (ncout,  stypvar, nboutput, ipk, id_varout                                )
    ierr  = putheadervar(ncout,  cf_ifil, ikx,      iky, ikz,     pnavlon=rdumlon, pnavlat=rdumlat)

    dtim  = getvar1d(cf_ifil, cn_vtimec, npt     )
    ierr  = putvar1d(ncout,  dtim,       npt, 'T')

  END SUBROUTINE CreateOutput

END PROGRAM cdficediag

PROGRAM cdfwflx
  !!======================================================================
  !!                     ***  PROGRAM  cdfwflx  ***
  !!=====================================================================
  !!  ** Purpose : Produce a file with the water flux separated into 
  !!               4 components: E (soevap), P (soprecip), R (sorunoff),
  !!               dmp (sowafldp).
  !!               The total water flux is E -P -R + dmp. Units in this 
  !!               program are mm/days.
  !!
  !!  ** Method  : Evap is computed from the latent heat flux : evap=-qla/Lv
  !!               Runoff is read from the climatological input file
  !!               dmp is read from the file (sowafldp)
  !!               Precip is then computed as the difference between the
  !!               total water flux (sowaflup) and the E-R+dmp. In the high 
  !!               latitudes this precip includes the effect of snow 
  !!               (storage/melting). Therefore it may differ slightly from
  !!               the input precip file.
  !!
  !! History : 2.1  : 01/2008  : J.M. Molines : Original code
  !!           3.0  : 04/2011  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class forcing
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4), PARAMETER                 :: jpvarout = 5     ! number of output variables
  INTEGER(KIND=4)                            :: jj, jk, ji, jt   ! dummy loop index
  INTEGER(KIND=4)                            :: npiglo, npjglo   ! size of the domain
  INTEGER(KIND=4)                            :: npt              ! size of the domain
  INTEGER(KIND=4)                            :: narg, iargc      ! command line 
  INTEGER(KIND=4)                            :: ijarg            !
  INTEGER(KIND=4)                            :: ncout, ierr      ! netcdf i/o
  INTEGER(KIND=4), DIMENSION(jpvarout)       :: ipk, id_varout   ! levels and varid of output vars

  REAL(KIND=4)                               :: Lv=2.5e6         ! latent HF <--> evap conversion
  REAL(KIND=4), DIMENSION(1)                 :: dep              ! dummy depth
  REAL(KIND=4), DIMENSION (:,:), ALLOCATABLE :: zmask, zwk       !  work array
  REAL(KIND=4), DIMENSION (:,:), ALLOCATABLE :: evap, precip     ! water flux components
  REAL(KIND=4), DIMENSION (:,:), ALLOCATABLE :: runoff, wdmp     ! water flux components

  REAL(KIND=8), DIMENSION(1)                 :: dtim             ! time_counter

  CHARACTER(LEN=256)                         :: cf_tfil          ! input gridT file name
  CHARACTER(LEN=256)                         :: cf_sfil          ! salinity file (option)
  CHARACTER(LEN=256)                         :: cf_ffil          ! input flxT file name
  CHARACTER(LEN=256)                         :: cf_rnf           ! input runoff file name
  CHARACTER(LEN=256)                         :: cf_out='wflx.nc' ! output file
  CHARACTER(LEN=256)                         :: cldum            ! working char variable

  TYPE(variable), DIMENSION(jpvarout)        :: stypvar          ! structure for attributes

  LOGICAL                                    :: lchk             ! flag for missing files
  LOGICAL                                    :: lnc4 = .FALSE.   ! Use nc4 with chunking and deflation
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfwflx -t T-file -r RNF-file [-s S-file][-f FLX-file]...'
     PRINT *,'                 ...  [-o OUT-file] [-nc4]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the water fluxes components. Suitable for annual means files.'
     PRINT *,'       All output variables are in mm/days.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -t T-file   : model output file with water fluxes (gridT). '
     PRINT *,'             If salinity not in T-file use -s option.'
     PRINT *,'       -r RNF-file : file with the climatological runoff on the model grid.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-s S-file  ]: salinity file if not T-file.'
     PRINT *,'       [-f FLX-file]: model output file with water fluxes if not in T-file.'
     PRINT *,'       [-o OUT-file]: specify output file name instead of ',TRIM(cf_out)
     PRINT *,'       [-nc4 ] : Use netcdf4 output with chunking and deflation level 1.'
     PRINT *,'            This option is effective only if cdftools are compiled with'
     PRINT *,'            a netcdf library supporting chunking and deflation.'
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        none'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) ,' unless -o option is used.'
     PRINT *,'       variables : soevap, soprecip, sorunoff, sowadmp, sowaflux'
     PRINT *,'      '
     STOP 
  ENDIF

  cf_ffil='none'
  cf_sfil='none'
  ijarg=1
  DO WHILE ( ijarg <= narg) 
     CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1
     SELECT CASE ( cldum)
     CASE( '-t'  ) ; CALL getarg(ijarg, cf_tfil) ; ijarg=ijarg+1
     CASE( '-r'  ) ; CALL getarg(ijarg, cf_rnf ) ; ijarg=ijarg+1
        ! options
     CASE( '-s'  ) ; CALL getarg(ijarg, cf_sfil) ; ijarg=ijarg+1
     CASE( '-f'  ) ; CALL getarg(ijarg, cf_ffil) ; ijarg=ijarg+1
     CASE( '-o'  ) ; CALL getarg(ijarg, cf_out ) ; ijarg=ijarg+1
     CASE( '-nc4') ; lnc4 = .TRUE.
     CASE DEFAULT  ; PRINT *,' ERROR : ',TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  END DO

  IF (cf_ffil =='none' ) cf_ffil=cf_tfil
  IF (cf_sfil =='none' ) cf_sfil=cf_tfil

  lchk = lchk .OR. chkfile ( cf_tfil)
  lchk = lchk .OR. chkfile ( cf_sfil)
  lchk = lchk .OR. chkfile ( cf_rnf )
  IF ( lchk ) STOP 99 ! missing file

  npiglo= getdim (cf_tfil, cn_x)
  npjglo= getdim (cf_tfil, cn_y)
  npt   = getdim (cf_tfil, cn_t)

  PRINT *, 'npiglo=', npiglo
  PRINT *, 'npjglo=', npjglo
  PRINT *, 'npt   =', npt

  ALLOCATE ( zmask(npiglo,npjglo), zwk(npiglo,npjglo))
  ALLOCATE ( evap(npiglo,npjglo), precip(npiglo,npjglo), runoff(npiglo,npjglo), wdmp(npiglo,npjglo) )

  CALL CreateOutput

  DO jt =1, npt
     ! read vosaline for masking purpose
     zwk(:,:)    =  getvar(cf_sfil, cn_vosaline,  1 ,npiglo,npjglo, ktime=jt )
     zmask       =  1. ; WHERE ( zwk == 0 ) zmask = 0.
     evap(:,:)   = -1.* getvar(cf_ffil, cn_solhflup, 1 ,npiglo, npjglo, ktime=jt )/Lv*86400. *zmask(:,:)  ! mm/days
     wdmp(:,:)   =      getvar(cf_ffil, cn_sowafldp, 1 ,npiglo, npjglo, ktime=jt )   *86400. *zmask(:,:)  ! mm/days
     runoff(:,:) =      getvar(cf_rnf,  cn_sorunoff, 1 ,npiglo, npjglo, ktime=jt )   *86400. *zmask(:,:)  ! mm/days
     zwk(:,:)    =      getvar(cf_ffil, cn_sowaflup, 1 ,npiglo, npjglo, ktime=jt )   *86400. *zmask(:,:)  ! mm/days
     precip(:,:)= evap(:,:) - runoff(:,:) + wdmp(:,:) - zwk(:,:)                                          ! mm/day

     ierr = putvar(ncout, id_varout(1), evap,   1, npiglo, npjglo, ktime=jt )
     ierr = putvar(ncout, id_varout(2), precip, 1, npiglo, npjglo, ktime=jt )
     ierr = putvar(ncout, id_varout(3), runoff, 1, npiglo, npjglo, ktime=jt )
     ierr = putvar(ncout, id_varout(4), wdmp,   1, npiglo, npjglo, ktime=jt )
     ierr = putvar(ncout, id_varout(5), zwk,    1, npiglo, npjglo, ktime=jt )
  ENDDO

  ierr=closeout(ncout)

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    INTEGER(KIND=4) :: jv
    !!----------------------------------------------------------------------
    ! prepare output variables
    dep(1) = 0.
    ipk(:) = 1  ! all variables ( output are 2D)
    DO jv=1, jpvarout
       stypvar(jv)%ichunk     = (/npiglo,MAX(1,npjglo/30),1,1 /)
    ENDDO

    stypvar%rmissing_value    = 0.
    stypvar%valid_min         = -100.
    stypvar%valid_max         =  100.
    stypvar%cunits            = 'mm/day'
    stypvar%conline_operation = 'N/A'
    stypvar%caxis             = 'TYX'

    stypvar(1)%cname = 'soevap'   ; stypvar(1)%clong_name = 'Evaporation'      ; stypvar(1)%cshort_name = 'soevap'
    stypvar(2)%cname = 'soprecip' ; stypvar(2)%clong_name = 'Precipitation'    ; stypvar(2)%cshort_name = 'soprecip'
    stypvar(3)%cname = 'sorunoff' ; stypvar(3)%clong_name = 'Runoff'           ; stypvar(3)%cshort_name = 'sorunoff'
    stypvar(4)%cname = 'sowadmp'  ; stypvar(4)%clong_name = 'SSS damping'      ; stypvar(4)%cshort_name = 'sowadmp'
    stypvar(5)%cname = 'sowaflux' ; stypvar(5)%clong_name = 'Total water flux' ; stypvar(5)%cshort_name = 'sowaflux'

    ! Write output file
    ncout = create      (cf_out, cf_tfil, npiglo,   npjglo, 1          , ld_nc4=lnc4 )
    ierr  = createvar   (ncout,  stypvar, jpvarout, ipk,    id_varout  , ld_nc4=lnc4 )
    ierr  = putheadervar(ncout,  cf_tfil, npiglo,   npjglo, 1, pdep=dep)


    dtim  = getvar1d(cf_tfil, cn_vtimec, npt     )
    ierr  = putvar1d(ncout,   dtim,      npt, 'T')

  END SUBROUTINE CreateOutput

END PROGRAM cdfwflx

PROGRAM cdfsigintegr_pedro
  !!======================================================================
  !!                     ***  PROGRAM  cdfsigintegr  ***
  !!=====================================================================
  !!  ** Purpose : This program is used to integrate quantities between 
  !!               isopycnals
  !!
  !!  ** Method  : Linear interpolation is used on the vertical to define
  !!               the depth of the given isopycn.
  !!               Then, the integral is performed from the top of the ocean
  !!               down to the given isopycnal. Finaly, by making the 
  !!               difference between 2 isopycnals we obtain the required 
  !!               quantity.
  !!
  !! History : 2.1  : 12/2007  : J.M. Molines : Original code
  !!           3.0  : 06/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  USE modutils
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id: cdfsigintegr.f90 657 2013-05-21 16:36:14Z molines $
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                               :: ji, jj, jk, jt   ! dummy loop index
  INTEGER(KIND=4)                               :: jiso, jfich      ! dummy loop index
  INTEGER(KIND=4)                               :: jvar             ! dummy loop index
  INTEGER(KIND=4)                               :: npiglo, npjglo   ! domain size
  INTEGER(KIND=4)                               :: npk, npt         ! domain size
  INTEGER(KIND=4)                               :: npiso, nvars     ! number of isopycnals, variables
  INTEGER(KIND=4)                               :: narg, iargc      ! command line
  INTEGER(KIND=4)                               :: ijarg, ireq      ! command line
  INTEGER(KIND=4)                               :: nfiles           ! number of input files
  INTEGER(KIND=4)                               :: istrt_arg        ! argument number of first input file
  INTEGER(KIND=4)                               :: ik0              ! layer index
  INTEGER(KIND=4)                               :: ijk              ! layer index
  INTEGER(KIND=4)                               :: numin=10         ! logical unit for ascii input file
  INTEGER(KIND=4)                               :: ncout, ierr      ! ncid and status variable
  INTEGER(KIND=4), DIMENSION(9)                 :: ipk, id_varout   ! levels and id's of output variables
  !
  REAL(KIND=4), DIMENSION(:,:,:),   ALLOCATABLE :: v3d              ! 3D v working array (npk)
  REAL(KIND=4), DIMENSION(:,:,:),   ALLOCATABLE :: u3d              ! 3D u working array (npk)
  REAL(KIND=4), DIMENSION(:,:,:),   ALLOCATABLE :: m3d              ! 3D modulus working array (npk)
  REAL(KIND=4), DIMENSION(:,:,:),   ALLOCATABLE :: zint             ! pseudo 3D working array (2)
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: v2d              ! 2D v working array
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: u2d              ! 2D u working array
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: e3               ! vertical metrics
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: e1t              ! U/V Horizontal metric !!Pedro
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: e2t              ! U/V Horizontal metric !!Pedro
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: tmask            ! mask of t points from rho
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: zdum             ! dummy array for I/O
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: zdum_u           ! dummy array for I/O for u
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: zdum_v           ! dummy array for I/O for v
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: zdum_m           ! dummy array for I/O for m
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: zdum_a           ! dummy array for I/O for angle
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: rho_lev          ! value of isopycnals
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: tim              ! time counter
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: h1d              ! depth of rho points
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: gdepw            ! depth of W points
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: e31d             ! vertical metrics in full step
  REAL(KIND=4)                                  :: zspval=999999.   ! output missing value
  REAL(KIND=4)                                  :: zspvalz          ! missing value from rho file      
  REAL(KIND=4)                                  :: maskvalue=0.     ! masked values for ocean velocity output
  INTEGER(KIND=4)                               :: nboutput=9       ! number of values to write in cdf output
  REAL(KIND=4)                                  :: pi               !pi 

  REAL(KIND=8), DIMENSION(:,:,:),   ALLOCATABLE :: dv2dint          ! interpolated value / int of v 
  REAL(KIND=8), DIMENSION(:,:,:),   ALLOCATABLE :: du2dint          ! int of u
  REAL(KIND=8), DIMENSION(:,:,:),   ALLOCATABLE :: dm2dint          ! int of the modulus
  REAL(KIND=8), DIMENSION(:,:,:),   ALLOCATABLE :: dalpha           ! 3D coefficient (npiso)

  CHARACTER(LEN=256)                            :: cf_rholev = 'rho_lev' ! input file for rho surfaces
  CHARACTER(LEN=256)                            :: cf_ufil          ! input file for u data
  CHARACTER(LEN=256)                            :: cf_vfil          ! input file for v data
  CHARACTER(LEN=256)                            :: cf_rho           ! input file for density
  CHARACTER(LEN=256)                            :: cf_out           ! output file
  CHARACTER(LEN=256)                            :: cv_in            ! name of input variable
  CHARACTER(LEN=256)                            :: cldum            ! dummy string variable
  CHARACTER(LEN=256)                            :: cluni            ! dummy string variable for variable units
  CHARACTER(LEN=256)                            :: cglobal          ! global attribute
  CHARACTER(LEN=256)                            :: ctype='T'        ! position of variable on C grid
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_names         ! temporary arry for variable name in file

  TYPE(variable), DIMENSION(:),     ALLOCATABLE :: stypvar          ! structure for attributes
  TYPE(variable), DIMENSION(:),     ALLOCATABLE :: stypzvar         ! structure for attributes

  LOGICAL                                       :: lfull = .FALSE.  ! flag for full step
  LOGICAL                                       :: lchk  = .FALSE.  ! flag for missing files
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg=iargc()
  IF ( narg < 3 ) THEN
     PRINT *,' usage : cdfsigintegr IN-var RHO-file list_of_files [ VAR-type ] ...'
     PRINT *,'              ... [ -sig sigma_name] [ -full ] '
     PRINT *,'      '
     PRINT *,'     PURPOSE :' 
     PRINT *,'       Take a list of input files with specific IN-var variable, associated'
     PRINT *,'       with a reference density file. A set of isopycnal surfaces is defined'
     PRINT *,'       in an ASCII file (rho_lev by default), using same depth reference than'
     PRINT *,'       the input reference density file. This program computes the integral of'
     PRINT *,'       IN-var between the isopycnals defined in rho_lev. It also gives the '
     PRINT *,'       isopycnal depth and thickness of density layers.'
     PRINT *,'      '
     PRINT *,'       Rho_lev file first line indicates the number of following isopycnals.'
     PRINT *,'       Then a list of the densities is given, one per line.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       IN-var : input variable to be integrated' 
     PRINT *,'       RHO-file : netcdf file with already computed density' 
     PRINT *,'       list_of_files : a list of model netcdf files containing IN-var.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [ VAR-type ] : one of T U V F W which defined the position on' 
     PRINT *,'               IN-var in the model C-grid. Default is ', TRIM(ctype)
     PRINT *,'       [ -sig sigma_name ] : give the name of sigma variable in RHO-file.'
     PRINT *,'               Default is ',TRIM(cn_vosigma0)
     PRINT *,'       [ -full ] : indicate a full step configuration.'
     PRINT *,'       [ -rholev  file] : indicates name of file defining the limits for '
     PRINT *,'               integration. Default is ', TRIM(cf_rholev)
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ', TRIM(cn_fzgr),',',TRIM(cn_fhgr),' and ',TRIM(cf_rholev)
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : IN-file.integr'
     PRINT *,'         variables : inv_IN-var  : inventory of IN-var from input file.'
     PRINT *,'                     ', TRIM(cn_vodepiso),' (m) : depth of isopycnal.'
     PRINT *,'                     ', TRIM(cn_isothick),' (m) : thickness of isopycnal layer.'
     PRINT *,'                     mean_IN-var (same unit as IN-var) : mean IN-var in the isopycnal'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'      cdfrhoproj, cdfsigtrp, cdfisopycdep'
     PRINT *,'      '
     STOP
  ENDIF
  pi=ACOS(-1.)
  !ijarg = 1 ; ireq = 0 ; nfiles = 0
  ijarg = 1 ; ireq = 0
  DO WHILE ( ijarg <= narg ) 
     CALL getarg( ijarg, cldum ) ; ijarg = ijarg+1
     SELECT CASE ( cldum )
     !CASE ( 'T','t','U','u','V','v','F','f','W','w' )
        !ctype=cldum
     CASE ( '-sig '   ) ; CALL getarg( ijarg, cn_vosigma0) ; ijarg = ijarg+1
     CASE ( '-rholev ') ; CALL getarg( ijarg, cf_rholev  ) ; ijarg = ijarg+1
     CASE ( '-full '  ) ; lfull = .TRUE.
     CASE DEFAULT
        ireq=ireq+1
        SELECT CASE ( ireq )
        CASE ( 1 ) ; cf_rho = cldum
        CASE ( 2 ) ; cf_ufil  = cldum
        CASE ( 3 ) ; cf_vfil = cldum
        CASE DEFAULT 
           !nfiles=nfiles+1
           !IF ( nfiles == 1 ) istrt_arg = ijarg - 1
           PRINT *,' Too many arguments ' ; STOP 99
        END SELECT
     END SELECT
  END DO

  CALL SetGlobalAtt( cglobal )

  ! check for files existence
  lchk = lchk .OR. chkfile (cn_fzgr   )
  lchk = lchk .OR. chkfile (cn_fhgr   ) !!Modified Pedro (Added)
  lchk = lchk .OR. chkfile (cf_rholev )
  lchk = lchk .OR. chkfile (cf_rho    )
  lchk = lchk .OR. chkfile (cf_ufil   )
  lchk = lchk .OR. chkfile (cf_vfil   )
  IF ( lchk ) STOP 99 ! missing file

  ! Read rho level between which the integral is being performed
  OPEN(numin,file=cf_rholev)
  READ(numin,*) npiso
  ALLOCATE (rho_lev(npiso) )
  PRINT *,' Density limits read in ',TRIM(cf_rholev)
  DO jiso=1,npiso
     READ(numin,*) rho_lev(jiso)
     PRINT *,rho_lev(jiso)
  END DO
  CLOSE(numin)

  npiglo = getdim(cf_rho, cn_x)
  npjglo = getdim(cf_rho, cn_y)
  npk    = getdim(cf_rho, cn_z)
  
  zspvalz=getspval(cf_rho, cn_vosigma0)

  !CALL getarg(istrt_arg, cf_ufil)
  !IF ( chkfile ( cf_ufil ) ) STOP 99 ! missing file

  nvars=getnvar(cf_vfil)
  ALLOCATE(cv_names(nvars), stypzvar(nvars))

  cv_names(:)=getvarname(cf_vfil,nvars,stypzvar)
  ALLOCATE( e1t(npiglo,npjglo), e2t(npiglo,npjglo) ) !!Modified Pedro (added)
  ALLOCATE( v3d(npiglo,npjglo,npk), u3d(npiglo,npjglo,npk), m3d(npiglo,npjglo,npk), u2d(npiglo,npjglo))
  ALLOCATE(dalpha(npiglo,npjglo,npiso), e3(npiglo,npjglo) )
  ALLOCATE( dv2dint(npiglo,npjglo,2), v2d(npiglo,npjglo), zint(npiglo,npjglo,2)  )
  ALLOCATE( du2dint(npiglo,npjglo,2), dm2dint(npiglo,npjglo,2))
  ALLOCATE( h1d(npk) ,gdepw(npk) ,tmask(npiglo,npjglo), zdum_u(npiglo,npjglo) )
  ALLOCATE( zdum_v(npiglo,npjglo), zdum_m(npiglo,npjglo), zdum(npiglo,npjglo) )
  ALLOCATE( stypvar(nboutput) , zdum_a(npiglo,npjglo) )
  IF ( lfull ) ALLOCATE ( e31d(npk) )

  gdepw(:) = getvare3(cn_fzgr, cn_gdepw, npk)

  IF (lfull ) e31d(:) = getvare3(cn_fzgr, cn_ve3t1d, npk)

  h1d(:) = getvar1d(cf_rho, cn_vdeptht, npk)

  ! Note, if working with vertical slabs, one may avoid 3D array, but may be slow ...
  tmask=1.
  DO jk=1,npk
     v3d(:,:,jk) = getvar(cf_rho, cn_vosigma0, jk, npiglo, npjglo)
     IF ( jk == 1 ) THEN
        WHERE (v3d(:,:,jk) == zspvalz ) tmask=0.
     ENDIF
  END DO

  !! Modified Pedro
  !! Get horizontal grid
  !! Obtain dx on t point
  !IF (ctype == 'U') THEN
  e2t(:,:)   = getvar(cn_fhgr, cn_ve2t, 1, npiglo, npjglo)
  !! Obtain dy on t point
  !ELSE IF (ctype == 'V') THEN
  e1t(:,:)   = getvar(cn_fhgr, cn_ve1t, 1, npiglo, npjglo)
  !! end modifying
  !END IF

  !! ** Compute interpolation coefficients as well as the level used
  !!    to interpolate between
  !! Comented Pedro
  DO ji=1,npiglo
     DO jj = 1, npjglo
        ijk = 1
        !!DO jiso=1,npiso 
        jiso=1 !! La primera definicion de isopyc la dejamos como esta
           !  Assume that rho (z) is increasing downward (no inversion)
           !     Caution with sigma0 at great depth !
           DO WHILE (rho_lev(jiso) >=  v3d(ji,jj,ijk) .AND. ijk <= npk &
                &                .AND. v3d(ji,jj,ijk) /=  zspvalz )
              ijk = ijk+1
           END DO
           ijk = ijk-1
           ik0 = ijk
           IF (ijk == 0) THEN
              ijk = 1
              dalpha(ji,jj,jiso) = 0.d0
           ELSE IF (v3d(ji,jj,ijk+1) == zspvalz ) THEN !!Masked values
              ik0 = 0
              dalpha(ji,jj,jiso) = 0.d0
           ELSE 
              ! ... dalpha is always in [0,1]. Adding ik0 ( >=1 ) for saving space for ik0
              dalpha(ji,jj,jiso)= (rho_lev(jiso)-v3d(ji,jj,ijk))/(v3d(ji,jj,ijk+1)-v3d(ji,jj,ijk)) + ik0
           ENDIF
        !!END DO
     END DO
  END DO

      !! Commented Pedro
   DO ji=1,npiglo
      DO jj = 1, npjglo
         ijk = 1
         !!DO jiso=1,npiso
         jiso=2  !La segunda definicion de isopyc la modificamos para extraer la superficie inferior
            !  Assume that rho (z) is increasing downward (no inversion)
            !     Caution with sigma0 at great depth ! 
            maskvalue=v3d(ji,jj,npk) !We pick a value that we know is masked (last value)
            DO WHILE (maskvalue /=  v3d(ji,jj,ijk) .AND. ijk <= npk ) !While the value is not masked, +1
               ijk = ijk+1
            END DO
            ijk = ijk-1
            dalpha(ji,jj,jiso) = ijk !Equal the first value before the mask appears
         !!END DO
      END DO
  END DO

  ! define header of all files
  ipk(1)=npiso-1 ; ipk(2)=npiso-1 ; ipk(3)=npiso ; ipk(4)=npiso-1
  ipk(5)=npiso-1 ; ipk(6)=npiso-1 ; ipk(7)=npiso-1 ; ipk(8)=npiso-1 
  ipk(9)=npiso-1
  !DO jvar=1,nvars
  !   IF ( cv_in == stypzvar(jvar)%cname ) THEN 
  !      stypvar(1)=stypzvar(jvar)
  !      EXIT
  !   ENDIF
  !END DO
  ! save original long name for further process
  !cldum = TRIM(stypvar(1)%clong_name)
  !cluni = TRIM(cv_vomecrty%cunits)

  stypvar(1)%cname             = 'int_vomecrty'
  stypvar(1)%clong_name        = 'vomecrty integrated on sigma bin'
  stypvar(1)%cshort_name       = stypvar(1)%cname
  stypvar(1)%cunits            = 'Sv'
  stypvar(1)%rmissing_value    = zspval
  stypvar(1)%caxis             = 'TRYX'

  stypvar(2)%cname             = TRIM(cn_isothick)
  stypvar(2)%cunits            = 'm'
  stypvar(2)%rmissing_value    = zspval
  stypvar(2)%valid_min         = 0.
  stypvar(2)%valid_max         = 7000.
  stypvar(2)%clong_name        = 'Thickness_of_Isopycnals'
  stypvar(2)%cshort_name       = TRIM(cn_isothick)
  stypvar(2)%conline_operation = 'N/A'
  stypvar(2)%caxis             = 'TRYX'

  stypvar(3)%cname             = TRIM(cn_vodepiso)
  stypvar(3)%cunits            = 'm'
  stypvar(3)%rmissing_value    = zspval
  stypvar(3)%valid_min         = 0.
  stypvar(3)%valid_max         = 7000.
  stypvar(3)%clong_name        = 'Depth_of_Isopycnals'
  stypvar(3)%cshort_name       = TRIM(cn_vodepiso)
  stypvar(3)%conline_operation = 'N/A'
  stypvar(3)%caxis             = 'TRYX'

  stypvar(4)%cname             = 'mean_vomecrty'
  stypvar(4)%cunits            = 'm/s'
  stypvar(4)%rmissing_value    = zspval
  stypvar(4)%valid_min         = stypvar(1)%valid_min
  stypvar(4)%valid_max         = stypvar(1)%valid_min
  stypvar(4)%clong_name        = ' mean value in sigma layer'
  stypvar(4)%cshort_name       = stypvar(4)%cname
  stypvar(4)%conline_operation = 'N/A'
  stypvar(4)%caxis             = 'TRYX'

  stypvar(5)%cname             = 'int_vozocrtx'
  stypvar(5)%clong_name        = ' vozocrtx integrated on sigma bin'
  stypvar(5)%cshort_name       = stypvar(5)%cname
  stypvar(5)%cunits            = 'Sv'
  stypvar(5)%rmissing_value    = zspval
  stypvar(5)%caxis             = 'TRYX'

  stypvar(6)%cname             = 'mean_vozocrtx'
  stypvar(6)%cunits            = 'm/s'
  stypvar(6)%rmissing_value    = zspval
  stypvar(6)%valid_min         = stypvar(5)%valid_min
  stypvar(6)%valid_max         = stypvar(5)%valid_min
  stypvar(6)%clong_name        = 'mean value in sigma layer'
  stypvar(6)%cshort_name       = stypvar(6)%cname
  stypvar(6)%conline_operation = 'N/A'
  stypvar(6)%caxis             = 'TRYX'
  
  stypvar(7)%cname             = 'int_modulus'
  stypvar(7)%clong_name        = 'integration of the modulus'
  stypvar(7)%cshort_name       = stypvar(7)%cname
  stypvar(7)%cunits            = 'Sv'
  stypvar(7)%rmissing_value    = zspval
  stypvar(7)%caxis             = 'TRYX'

  stypvar(8)%cname             = 'modulus_mean' 
  stypvar(8)%cunits            = 'm/s'
  stypvar(8)%rmissing_value    = zspval
  stypvar(8)%valid_min         = stypvar(7)%valid_min
  stypvar(8)%valid_max         = stypvar(7)%valid_min
  stypvar(8)%clong_name        = 'mean value of the modulus in sigma layer'
  stypvar(8)%cshort_name       = stypvar(8)%cname
  stypvar(8)%conline_operation = 'N/A'
  stypvar(8)%caxis             = 'TRYX'
  
  stypvar(9)%cname             = 'angle_modulus'
  stypvar(9)%clong_name        = 'Modulus angle'
  stypvar(9)%cshort_name       = stypvar(9)%cname
  stypvar(9)%cunits            = '°'
  stypvar(9)%rmissing_value    = zspval
  stypvar(9)%caxis             = 'TRYX'

!! ** Loop on the scalar files to project on choosen isopycnics surfaces
  !DO jfich=1, nfiles

     !CALL getarg(jfich+istrt_arg-1, cf_ufil)
     !IF ( chkfile (cf_ufil) ) STOP 99 ! missing file
     !IF ( chkfile (cf_vfil) ) STOP 99 ! missing file
     PRINT *,'working with ', TRIM(cf_ufil)
     PRINT *,'working with ', TRIM(cf_vfil)

     ! create output file
     !! Modified Pedro
     !cf_out=TRIM(cf_in)//'.integr'
     cf_out='cdfsigintegr_file'
     ncout = create      (cf_out, cf_rho,  npiglo, npjglo, npiso                       )
     ierr  = createvar   (ncout,  stypvar, 9,      ipk,    id_varout, cdglobal=cglobal )
     ierr  = putheadervar(ncout,  cf_rho,  npiglo, npjglo, npiso, pdep=rho_lev         )
     ! copy time arrays in output file
     npt = getdim ( cf_ufil, cn_t)
     ALLOCATE ( tim(npt) )
     tim(:) = getvar1d(cf_ufil, cn_vtimec, npt     )
     ierr   = putvar1d(ncout, tim,       npt, 'T')
     DEALLOCATE ( tim )
     DO jt =1, npt
        DO jk=1,npk
           v2d(:,:) = getvar(cf_vfil, cn_vomecrty, jk, npiglo, npjglo, ktime = jt )
           u2d(:,:) = getvar(cf_ufil, cn_vozocrtx, jk, npiglo, npjglo, ktime = jt )
           !SELECT CASE ( ctype )
           !CASE ('T', 't' )
           !   v3d(:,:,jk) = v2d(:,:)
           !CASE ('U','u' )
              DO jj=1,npjglo
                 DO ji=2, npiglo
                    u3d(ji,jj,jk)=0.5*( u2d(ji,jj) + u2d(ji-1,jj) )  ! put variable on T point
                    u3d(1,jj,jk)=0.5*( u2d(2,jj) + u2d(1,jj) )  ! put variable on T point
                 END DO
              END DO
           !CASE ('V','v' )
              DO jj=2,npjglo
                 DO ji=1, npiglo
                    v3d(ji,jj,jk)=0.5*( v2d(ji,jj) + v2d(ji,jj-1) )  ! put variable on T point
                    v3d(ji,1,jk)=0.5*( v2d(ji,2) + v2d(ji,1) )  ! put variable on T point
                 END DO
              END DO              
           !CASE('W','w' )
              !v3d(:,:,jk) = v2d(:,:)
              !v2d(:,:) = getvar(cf_ufil, cv_in, jk+1, npiglo, npjglo, ktime = jt )
              !v3d(:,:,jk) = 0.5 * ( v3d(:,:,jk) + v2d(:,:) )
           !CASE('F','f' )
              !DO jj = 2, npjglo
                 !DO ji = 2, npiglo
                    !v3d(:,:,jk) = 0.25*( v2d(ji,jj) + v2d( ji, jj-1) + v2d (ji-1,jj-1) + v2d(ji-1, jj) )
                 !END DO
              !END DO
           !END SELECT
        END DO

        ! Compute integral from surface to isopycnal
        !!DO jiso=1,npiso
        jiso=1 !! La primera integral la dejamos como esta
           ! determine isopycnal surface
           DO ji=1,npiglo
              DO jj=1,npjglo
                 ! ik0 is retrieved from dalpha, taking the integer part.
                 ik0=INT(dalpha(ji,jj,jiso)) ; dalpha(ji,jj,jiso) =  dalpha(ji,jj,jiso) - ik0
                 IF (ik0 /= 0) THEN
                    zint (ji,jj,1)=dalpha(ji,jj,jiso)*h1d(ik0+1) + (1.d0-dalpha(ji,jj,jiso))*h1d(ik0)
                 ELSE 
                    zint  (ji,jj,1)=0. !zspval
                 ENDIF
              END DO
           END DO

        ! Compute integral from surface to isopycnal
        jiso=2 !! En la segunda utilizamos la batimetria
           ! determine isopycnal surface
           DO ji=1,npiglo
              DO jj=1,npjglo
                 ! ik0 is retrieved from dalpha, taking the integer part.
                 ik0=INT(dalpha(ji,jj,jiso)) ; dalpha(ji,jj,jiso) =  dalpha(ji,jj,jiso) - ik0
                 IF (zint(ji,jj,1) /= 0) THEN
                    zint (ji,jj,2)=dalpha(ji,jj,jiso)*h1d(ik0+1) + (1.d0-dalpha(ji,jj,jiso))*h1d(ik0)
                 ELSE
                    zint  (ji,jj,2)=0. !zspval
                 ENDIF
              END DO
           END DO
           ! integrate from jk=1 to zint
           du2dint(:,:,1) = 0.d0
           du2dint(:,:,2) = 0.d0
           dv2dint(:,:,1) = 0.d0
           dv2dint(:,:,2) = 0.d0
           dm2dint(:,:,1) = 0.d0
           dm2dint(:,:,2) = 0.d0

           DO jk=1,npk-1
              ! get metrixs at level jk
              IF ( lfull ) THEN 
                 e3(:,:) = e31d(jk)
              ELSE
                 e3(:,:)=getvar(cn_fzgr,'e3t_ps',jk,npiglo,npjglo,ldiom=.TRUE.)
              ENDIF

              DO ji=1,npiglo
                 DO jj=1,npjglo
                    IF ( gdepw(jk)+e3(ji,jj) < zint(ji,jj,1) ) THEN  ! full cell
                       !!dv2dint(ji,jj,1)=dv2dint(ji,jj,1) + e3(ji,jj)* v3d(ji,jj,jk)
                       du2dint(ji,jj,1)=du2dint(ji,jj,1) + e3(ji,jj)* u3d(ji,jj,jk) * e2t(ji,jj) / 1000000 !!Modified Pedro
                       dv2dint(ji,jj,1)=dv2dint(ji,jj,1) + e3(ji,jj)* v3d(ji,jj,jk) * e1t(ji,jj) / 1000000!!Modified Pedro
                       !dm2dint(ji,jj,1)=dm2dint(ji,jj,1) + SQRT(du2dint(ji,jj,1)*du2dint(ji,jj,1) + &
                       !                                   & dv2dint(ji,jj,1)*dv2dint(ji,jj,1))
                    ELSE IF (( zint(ji,jj,1) <= gdepw(jk)+e3(ji,jj) ) .AND. (zint(ji,jj,1) > gdepw(jk)) ) THEN
                       !!dv2dint(ji,jj,1)=dv2dint(ji,jj,1)+ (zint(ji,jj,1) - gdepw(jk) )* v3d(ji,jj,jk)
                       du2dint(ji,jj,1)=du2dint(ji,jj,1)+ (zint(ji,jj,1) - gdepw(jk) )* u3d(ji,jj,jk) * e2t(ji,jj) / 1000000!! Modified Pedro
                       dv2dint(ji,jj,1)=dv2dint(ji,jj,1)+ (zint(ji,jj,1) - gdepw(jk) )* v3d(ji,jj,jk) * e1t(ji,jj) / 1000000!! Modified Pedro
                       !dm2dint(ji,jj,1)=dm2dint(ji,jj,1)+ (zint(ji,jj,1) - gdepw(jk) )* SQRT(du2dint(ji,jj,1)* &
                       !                 & du2dint(ji,jj,1) + dv2dint(ji,jj,1)*dv2dint(ji,jj,1)) !! Modified Pedro
                    ELSE   ! below the isopycnal 
                       ! do nothing for this i j point
                    ENDIF
                 END DO
              END DO
              
              DO ji=1,npiglo
                 DO jj=1,npjglo
                    IF ( gdepw(jk)+e3(ji,jj) < zint(ji,jj,2) ) THEN  ! full cell
                       !!dv2dint(ji,jj,1)=dv2dint(ji,jj,1) + e3(ji,jj)* v3d(ji,jj,jk)
                       du2dint(ji,jj,2)=du2dint(ji,jj,2) + e3(ji,jj)* u3d(ji,jj,jk) * e2t(ji,jj) / 1000000
                       dv2dint(ji,jj,2)=dv2dint(ji,jj,2) + e3(ji,jj)* v3d(ji,jj,jk) * e1t(ji,jj) / 1000000!!Modified Pedro
                       !dm2dint(ji,jj,2)=dm2dint(ji,jj,2) + SQRT(du2dint(ji,jj,2)*du2dint(ji,jj,2) + &
                       !                                    & dv2dint(ji,jj,2)*dv2dint(ji,jj,2))
                    ELSE IF (( zint(ji,jj,2) <= gdepw(jk)+e3(ji,jj) ) .AND. (zint(ji,jj,2) > gdepw(jk)) ) THEN
                       !!dv2dint(ji,jj,1)=dv2dint(ji,jj,1)+ (zint(ji,jj,1) - gdepw(jk) )* v3d(ji,jj,jk)
                       du2dint(ji,jj,2)=du2dint(ji,jj,2)+ (zint(ji,jj,2) - gdepw(jk) )* u3d(ji,jj,jk) * e2t(ji,jj) / 1000000!! Modified Pedro
                       dv2dint(ji,jj,2)=dv2dint(ji,jj,2)+ (zint(ji,jj,2) - gdepw(jk) )* v3d(ji,jj,jk) * e1t(ji,jj) / 1000000!! Modified Pedro
                       !dm2dint(ji,jj,2)=dm2dint(ji,jj,2)+ (zint(ji,jj,2) - gdepw(jk) )* SQRT(du2dint(ji,jj,2)* &
                       !                 & du2dint(ji,jj,2) + dv2dint(ji,jj,2)*dv2dint(ji,jj,2))!! Modified Pedro
                    ELSE   ! below the isopycnal 
                       ! do nothing for this i j point
                    ENDIF
                 END DO
              END DO
           END DO   ! end on vertical integral for isopynal jiso

           zdum=zint(:,:,1)

           WHERE (tmask == 0. ) zint(:,:,1)=zspval
           WHERE (tmask == 0. ) zint(:,:,2)=zspval
           !ierr = putvar(ncout,id_varout(3), zdum, jiso, npiglo, npjglo, ktime=jt ) !Saves depth of isopycnals
           ierr = putvar(ncout,id_varout(3), zint(:,:,1), 1, npiglo, npjglo, ktime=jt )
           ierr = putvar(ncout,id_varout(3), zint(:,:,2), 2, npiglo, npjglo, ktime=jt )

           !IF (jiso > 1  ) THEN  ! compute the difference ie the inventory in the layer between 2 isopycnals
              !zdum=dv2dint(:,:,1) - dv2dint(:,:,2) ; WHERE ((tmask == 0.)  .OR. (zdum < 0 ) ) zdum = zspval
           zdum_u=du2dint(:,:,2) - du2dint(:,:,1) ; WHERE (tmask == 0. ) zdum_u = zspval !! Modified Pedro
           zdum_v=dv2dint(:,:,2) - dv2dint(:,:,1) ; WHERE (tmask == 0. ) zdum_v = zspval !! Modified Pedro
           zdum_m=dm2dint(:,:,2) - dm2dint(:,:,1) ; WHERE (tmask == 0. ) zdum_m = zspval !! Modified Pedro
              !ierr = putvar(ncout, id_varout(1), zdum, jiso-1, npiglo, npjglo, ktime=jt) !Saves integral
           ierr = putvar(ncout, id_varout(5), zdum_u, 1, npiglo, npjglo, ktime=jt)
           ierr = putvar(ncout, id_varout(1), zdum_v, 1, npiglo, npjglo, ktime=jt)
           !ierr = putvar(ncout, id_varout(7), zdum_m, 1, npiglo, npjglo, ktime=jt)
     
           DO ji=1,npiglo
              DO jj=1,npjglo
                 zdum_m(ji,jj) = SQRT(zdum_v(ji,jj) * zdum_v(ji,jj) + zdum_u(ji,jj) * zdum_u(ji,jj))
                 zdum_a(ji,jj)= atan2(zdum_v(ji,jj), zdum_u(ji,jj)) * 180./pi 
                 IF ( zdum_v(ji,jj) < 0. ) zdum_a(ji,jj) = 360.+zdum_a(ji,jj)
              END DO
           END DO
           WHERE (tmask == 0. ) zdum_m=zspval
           WHERE (tmask == 0. ) zdum_a = zspval
           ierr = putvar(ncout, id_varout(7), zdum_m, 1, npiglo, npjglo, ktime=jt)
           ierr = putvar(ncout, id_varout(9), zdum_a , 1, npiglo, npjglo, ktime=jt)

              !zdum=zint  (:,:,1) - zint  (:,:,2) ; WHERE ((tmask == 0.)  .OR. (zdum < 0 ) ) zdum = zspval
           zdum=zint  (:,:,2) - zint  (:,:,1) ; WHERE (tmask == 0.) zdum = zspval
           !ierr = putvar(ncout, id_varout(2), zdum, jiso-1, npiglo, npjglo, ktime=jt) !Saves thickness
           ierr = putvar(ncout, id_varout(2), zdum, 1, npiglo, npjglo, ktime=jt)

              WHERE ( zdum /= zspval .AND. zdum /= 0.) 
                 zdum_u=(du2dint(:,:,2) - du2dint(:,:,1))/ zdum
                 zdum_v=(dv2dint(:,:,2) - dv2dint(:,:,1))/ zdum
                 zdum_m = zdum_m / zdum
              !ELSEWHERE
                 !zdum_u=zspval
                 !zdum_v=zspval
                 !zdum_m=zspval
              ENDWHERE
              !ierr = putvar(ncout, id_varout(4), zdum, jiso-1, npiglo, npjglo, ktime=jt) !Saves average
              ierr = putvar(ncout, id_varout(6), zdum_u, 1, npiglo, npjglo, ktime=jt)
              ierr = putvar(ncout, id_varout(4), zdum_v, 1, npiglo, npjglo, ktime=jt)
              ierr = putvar(ncout, id_varout(8), zdum_m, 1, npiglo, npjglo, ktime=jt)

           !ENDIF
           !dv2dint(:,:,2) = dv2dint(:,:,1)
           !zint   (:,:,2) = zint   (:,:,1)

        END DO
     !END DO
     ierr = closeout(ncout)
  !END DO  ! loop on scalar files
  PRINT *,' integral between isopycnals completed successfully'
END  PROGRAM cdfsigintegr_pedro

PROGRAM cdf_domain2bathy
  !!======================================================================
  !!                     ***  PROGRAM  cdf_domain2bathy  ***
  !!=====================================================================
  !!  ** Purpose : Create a bathy file from domain_cfg file
  !!
  !!  ** Method  : integrate e3t_0 on the wet points
  !!
  !! History :  4.0  : 10/2020  : J.M. Molines : 
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  !!   routines      : description
  !!----------------------------------------------------------------------

  USE cdfio
  USE modcdfnames

  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2020
  !! $Id$
  !! Copyright (c) 2012, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class domain_file
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: jk, jt              ! dummy loop index
  INTEGER(KIND=4)                           :: ierr,  iko, it   ! working integer
  INTEGER(KIND=4)                           :: narg, iargc, ijarg  ! command line 
  INTEGER(KIND=4)                           :: npiglo, npjglo      ! size of the domain
  INTEGER(KIND=4)                           :: npk, npt            ! size of the domain
  INTEGER(KIND=4)                           :: ncout 
  INTEGER(KIND=4), DIMENSION(1)                :: ipk, id_varout      ! only one output variable
  INTEGER(KIND=4), DIMENSION(:,:), ALLOCATABLE :: mbathy           ! working input variable

  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e3t                 ! vertical metric
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: rlon, rlat          ! output longitude, latitude

  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dbati               ! bathymetry
  REAL(KIND=8), DIMENSION(:),   ALLOCATABLE :: dtim                ! time

  CHARACTER(LEN=256)                        :: cf_in, cf_out       ! input/output file
  CHARACTER(LEN=256)                        :: cv_out              ! output variable name
  CHARACTER(LEN=256)                        :: cldum               ! working variables

  LOGICAL                                   :: lnc4=.FALSE.        ! nc4 flag
  LOGICAL                                   :: lchk                ! file flag
  TYPE(variable), DIMENSION(1)              :: stypvar             ! extension for attributes
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdf_domain2bathy -d DOMAINCFG-file [-nc4] [-o BATI-file]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the bathymetry of a configuration, consistent with the'
     PRINT *,'       domain_cfg file given in argument. This program compute the bathymetry'
     PRINT *,'       from the e3t_0 variable and bottom_level variable.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'         -d DOMAINCFG-file: pass the name of the domain file to work with.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'        [-nc4]  : use netcdf4 output with chunking and deflation'
     PRINT *,'        [-o BATI-file] : use specified output file instead of <IN-var>.nc'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        none'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file :  bati.nc of BATI-file if specified'
     PRINT *,'         variables :  bathy_meter'
     PRINT *,'      '
     STOP 
  ENDIF

  ! browse command line
  ijarg = 1   
  cf_out='none'
  DO WHILE ( ijarg <= narg ) 
     CALL getarg (ijarg, cldum) ; ijarg = ijarg + 1
     SELECT CASE ( cldum)
     CASE ( '-d'    ) ; CALL getarg (ijarg, cf_in  ) ; ijarg = ijarg + 1
        ! options

     CASE ( '-nc4'  ) ; lnc4  = .TRUE. 
     CASE ( '-o'    ) ; CALL getarg (ijarg, cf_out) ; ijarg = ijarg + 1
     CASE DEFAULT     ; PRINT *,' ERROR : ', TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  END DO

  ! Security check
  lchk = chkfile ( cf_in   )
  IF ( lchk ) STOP 99 ! missing files

  IF ( cf_out ==  'none' ) cf_out='bati.nc'

  npiglo = getdim (cf_in, cn_x )
  npjglo = getdim (cf_in, cn_y )
  npk    = getdim (cf_in, 'z' )
  npt    = getdim (cf_in, 't' )

  PRINT *, ' NPIGLO = ', npiglo
  PRINT *, ' NPJGLO = ', npjglo
  PRINT *, ' NPK    = ', npk
  PRINT *, ' NPT    = ', npt

  ! Allocate arrays
  ALLOCATE ( rlon(npiglo,npjglo), rlat(npiglo,npjglo)  )
  ALLOCATE ( mbathy(npiglo,npjglo) )
  ALLOCATE ( dbati(npiglo,npjglo)  )
  ALLOCATE ( e3t(npiglo,npjglo)    )
  ALLOCATE ( dtim(npt)             )

  CALL CreateOutput

  mbathy(:,:) = getvar(cf_in,'bottom_level',1,npiglo, npjglo)
  dbati=0.d0

  DO jk = 1, npk
     e3t(:,:) = getvar(cf_in,'e3t_0',jk, npiglo,npjglo)
     WHERE( mbathy >= jk ) dbati(:,:)=dbati(:,:) + e3t(:,:)
  ENDDO
  ierr = putvar(ncout, id_varout(1) ,REAL(dbati), 1, npiglo, npjglo)
  ierr = closeout(ncout)

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    ! prepare output variable
    ipk(:)                       = 1
    ! choose chunk size for output ... not easy not used if lnc4=.false. but
    ! anyway ..
    stypvar(1)%ichunk=(/npiglo,MAX(1,npjglo/30),1,1 /)
    cv_out = cn_bathymet

    stypvar(1)%cname             = cv_out
    stypvar(1)%cunits            = 'm'
    stypvar(1)%rmissing_value    = 0.
    stypvar(1)%valid_min         = 0.
    stypvar(1)%valid_max         = 10000.
    stypvar(1)%clong_name        = 'Bathymetry'
    stypvar(1)%cshort_name       =  cv_out
    stypvar(1)%conline_operation = 'N/A'
    stypvar(1)%caxis             = 'TYX'

   rlon =getvar(cf_in, cn_glamt, 1, npiglo, npjglo)  ! nav_lon
   rlat =getvar(cf_in, cn_gphit, 1, npiglo, npjglo)  ! nav_lat

    ncout = create      (cf_out, 'none', npiglo, npjglo, 1 , ld_nc4=lnc4)
    ierr  = createvar   (ncout, stypvar, 1, ipk, id_varout , ld_nc4=lnc4)
    ierr  = putheadervar(ncout, cf_in,   npiglo, npjglo, 1,  pnavlon=rlon, pnavlat=rlat )

    dtim  = getvar1d    (cf_in, cn_vtimec, npt     )
    ierr  = putvar1d    (ncout, dtim,      npt, 'T')

  END SUBROUTINE CreateOutput

END PROGRAM cdf_domain2bathy

PROGRAM cdfsigi
  !!======================================================================
  !!                     ***  PROGRAM  cdfsigi  ***
  !!=====================================================================
  !!  ** Purpose : Compute sigmai 3D field from gridT file
  !!                Store the results on a 'similar' cdf file.
  !!
  !!  **  Method: read temp and salinity, compute sigma-i
  !!              using depth given in argument (meters or dbar)
  !!
  !! History : 2.0  : 11/2004  : J.M. Molines : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE eos
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class Equation_of_state
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: jk, jt             ! dummy loop index
  INTEGER(KIND=4)                           :: ierr               ! error status
  INTEGER(KIND=4)                           :: narg, iargc, ijarg ! browse command line
  INTEGER(KIND=4)                           :: npiglo, npjglo     ! size of the domain
  INTEGER(KIND=4)                           :: npk, npt           ! size of the domain
  INTEGER(KIND=4)                           :: ncout              ! ncid of output file
  INTEGER(KIND=4), DIMENSION(1)             :: ipk, id_varout     ! level and  varid's

  REAL(KIND=4)                              :: ref_dep            ! reference depth in meters
  REAL(KIND=4)                              :: zspval             ! missing value
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: ztemp              ! temperature
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zsal               ! salinity
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zsigi              ! sigma-i
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zmask              ! 2D mask at current level

  REAL(KIND=8), DIMENSION(:),   ALLOCATABLE :: dtim               ! time counter

  CHARACTER(LEN=256)                        :: cf_tfil            ! input filename
  CHARACTER(LEN=256)                        :: cf_sfil            ! salinity file (option)
  CHARACTER(LEN=256)                        :: cf_out='sigi.nc'   ! output file name
  CHARACTER(LEN=256)                        :: cldum              ! dummy string

  TYPE (variable), DIMENSION(1)             :: stypvar            ! structure for attributes

  LOGICAL                                   :: lnc4 = .FALSE.     ! Use nc4 with chunking and deflation
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfsigi -t T-file -r REF-dep(m) [-s S-file] [-o OUT-file] [-nc4] '
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute potential density referred to the depth given in arguments.' 
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -t T-file  : netcdf file with temperature and salinity.' 
     PRINT *,'          If salinity not in T-file, use -s option.'
     PRINT *,'       -r REF-dep : reference depth in meter.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'      [-s S-file   ] : Specify salinity file if not T-file.'
     PRINT *,'      [-o OUT-file ] : Specify output file name instead of ',TRIM(cf_out)
     PRINT *,'      [-nc4 ] : Use netcdf4 output with chunking and deflation level 1.'
     PRINT *,'           This option is effective only if cdftools are compiled with'
     PRINT *,'           a netcdf library supporting chunking and deflation.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        none'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : ', TRIM(cn_vosigmai),' (kg/m3 -1000 )'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'      cdfsig0, cdfsiginintu' 
     PRINT *,'      '
     STOP 
  ENDIF

  ijarg=1
  cf_sfil='none'
  DO WHILE ( ijarg <= narg ) 
     CALL getarg (ijarg, cldum ) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-t'   ) ; CALL getarg (ijarg, cf_tfil) ; ijarg=ijarg+1
     CASE ( '-r'   ) ; CALL getarg (ijarg, cldum  ) ; ijarg=ijarg+1 ; READ(cldum,*) ref_dep
        ! options
     CASE ( '-s'   ) ; CALL getarg (ijarg, cf_sfil) ; ijarg=ijarg+1
     CASE ( '-o'   ) ; CALL getarg (ijarg, cf_out ) ; ijarg=ijarg+1
     CASE ( '-nc4' ) ; lnc4 = .TRUE.
     CASE DEFAULT    ; PRINT *,' ERROR : ', TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  ENDDO

  IF ( cf_sfil == 'none' ) cf_sfil=cf_tfil

  IF ( chkfile(cf_tfil) .OR. chkfile(cf_sfil) ) STOP 99 ! missing file

  npiglo = getdim (cf_tfil, cn_x)
  npjglo = getdim (cf_tfil, cn_y)
  npk    = getdim (cf_tfil, cn_z)
  npt    = getdim (cf_tfil, cn_t)

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  ALLOCATE (ztemp(npiglo,npjglo), zsal (npiglo,npjglo) )
  ALLOCATE (zsigi(npiglo,npjglo), zmask(npiglo,npjglo) )
  ALLOCATE (dtim(npt) )

  CALL CreateOutput
  zspval= getatt(cf_sfil, cn_vosaline, cn_missing_value)
  DO jt = 1, npt
     PRINT *,'time: ',jt
     DO jk = 1, npk
        zmask(:,:) = 1.

        ztemp(:,:) = getvar(cf_tfil, cn_votemper,  jk, npiglo, npjglo, ktime=jt)
        zsal( :,:) = getvar(cf_sfil, cn_vosaline,  jk, npiglo, npjglo, ktime=jt)

        WHERE( zsal == zspval ) zmask = 0

        zsigi(:,:) = sigmai(ztemp, zsal, ref_dep, npiglo, npjglo )* zmask(:,:)

        ierr = putvar(ncout, id_varout(1), zsigi, jk, npiglo, npjglo, ktime=jt)

     END DO  ! loop to next level
  END DO  ! loop on time

  ierr = closeout(ncout)
CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    ipk(:)= npk  ! all variables (input and output are 3D)
    stypvar(1)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(1)%cname             = cn_vosigmai
    stypvar(1)%cunits            = 'kg/m3'
    stypvar(1)%rmissing_value    = 0.
    stypvar(1)%valid_min         = 0.001
    stypvar(1)%valid_max         = 45.
    stypvar(1)%clong_name        = 'Potential_density:refered to '//TRIM(cldum)//' m'
    stypvar(1)%cshort_name       = cn_vosigmai
    stypvar(1)%conline_operation = 'N/A'
    stypvar(1)%caxis             = 'TZYX'

    ! create output fileset
    ncout = create      (cf_out, cf_tfil, npiglo, npjglo, npk       , ld_nc4=lnc4 )
    ierr  = createvar   (ncout,  stypvar, 1,      ipk,    id_varout , ld_nc4=lnc4 )
    ierr  = putheadervar(ncout,  cf_tfil, npiglo, npjglo, npk                     )

    dtim  = getvar1d(cf_tfil, cn_vtimec, npt     )
    ierr  = putvar1d(ncout,   dtim,      npt, 'T')

  END SUBROUTINE CreateOutput

END PROGRAM cdfsigi

PROGRAM cdfvertmean
  !!======================================================================
  !!                     ***  PROGRAM  cdfvertmean  ***
  !!=====================================================================
  !!  ** Purpose : Compute the vertical average of a scalar quantity
  !!               between 2 z layers. Can handle full step configuration
  !!               using the -full option.
  !!
  !!  ** Method  : compute the sum ( V  * e1 *e2 * e3 *mask )
  !!
  !! History : 2.1  : 11/2008  : J.M. Molines : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!           3.0  : 06/2013  : J.M. Molines : multi variables capability
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  USE modutils
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                               :: jk, jvar, jvarin, jt! dummy loop index
  INTEGER(KIND=4)                               :: ik1, ik2            ! vertical limit of integration
  INTEGER(KIND=4)                               :: narg, iargc         ! command line 
  INTEGER(KIND=4)                               :: ijarg, ireq         ! command line 
  INTEGER(KIND=4)                               :: npiglo, npjglo      ! size of the domain
  INTEGER(KIND=4)                               :: npk, npt            ! size of the domain,
  INTEGER(KIND=4)                               :: nvars, ivar         ! variables in input
  INTEGER(KIND=4)                               :: nvaro=1             ! variables for output
  INTEGER(KIND=4)                               :: ncout, ierr         ! ncid and error status
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: ipk, id_varout      ! levels and varid's of output vars

  REAL(KIND=4)                                  :: rdep_up             ! upper level of integration
  REAL(KIND=4)                                  :: rdep_down           ! lower level of integration
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: e3                  ! metrics
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: zv                  ! working variable
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: hdep                ! depth of the levels
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: zmask               ! mask
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: gdep                ! vertical levels
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: e31d                ! vertical metric full
  REAL(KIND=4), DIMENSION(:),       ALLOCATABLE :: tim                 ! time counter
  REAL(KIND=4), DIMENSION(1)                    :: rdep                ! dummy depth output

  REAL(KIND=8)                                  :: dvol                ! total volume
  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: dvol2d              ! layer volume
  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: dvertmean           ! value of integral

  CHARACTER(LEN=256)                            :: cf_in               ! input file name
  CHARACTER(LEN=256)                            :: cf_out='vertmean.nc'! output file
  CHARACTER(LEN=256)                            :: cv_cur              ! variable name
  CHARACTER(LEN=256)                            :: cv_dep              ! depth name
  CHARACTER(LEN=256)                            :: cv_e3               ! vertical metric name (partial)
  CHARACTER(LEN=256)                            :: cv_e31d             ! vertical metric name (full)
  CHARACTER(LEN=256)                            :: cv_msk              ! mask variable name
  CHARACTER(LEN=256)                            :: ctype='T'           ! position of the variable
  CHARACTER(LEN=256)                            :: cglobal             ! global attribute
  CHARACTER(LEN=256)                            :: cldum               ! dummy string
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_names            ! name of input variables
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_in               ! name of output variables

  TYPE(variable), DIMENSION(:), ALLOCATABLE     :: stypvarin           ! stucture for attributes (input)
  TYPE(variable), DIMENSION(:), ALLOCATABLE     :: stypvar             ! stucture for attributes (output)

  LOGICAL                                       :: lfull =.FALSE.      ! full step flag
  LOGICAL                                       :: ldebug=.FALSE.      ! full step flag
  LOGICAL                                       :: lchk                ! file existence flag (true if missing)
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage :  cdfvertmean [-debug] IN-file IN-var1,var2,.. v-type dep1 dep2 [-full]'
     PRINT *,'              ... [-o OUT-file ]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the vertical mean between dep1 and dep2 given in m,'
     PRINT *,'       for variable IN-var in the input file.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       IN-file  : netcdf input file.' 
     PRINT *,'       IN-var1,var2,.. : Comma separated list of input variables to process.'
     PRINT *,'       v-type   : one of T U V W indicating position of variable on C-grid'
     PRINT *,'       dep1 dep2 : depths limit for vertical integration (meters), from top '
     PRINT *,'                to bottom, positive depths.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-full  ] : for full step configurations. Default is partial step.'
     PRINT *,'       [-debug ] : print some extra informations.'
     PRINT *,'       [-o OUT-file ] : specify output file instead of ',TRIM(cf_out)
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ', TRIM(cn_fzgr),' and ',TRIM(cn_fmsk)
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : varin_vertmean (same units as input variable)'
     PRINT *,'      '
     STOP
  ENDIF

  ijarg = 1 ; ireq=0
  DO WHILE ( ijarg <= narg ) 
     CALL getarg (ijarg, cldum ) ; ijarg = ijarg + 1
     SELECT CASE ( cldum )
     CASE ( '-full'  ) ; lfull  = .TRUE.
     CASE ( '-debug' ) ; ldebug = .TRUE.
     CASE ( '-o' )     ; CALL getarg (ijarg, cf_out ) ; ijarg = ijarg + 1
     CASE DEFAULT
        ireq=ireq+1
        SELECT CASE ( ireq )
        CASE ( 1 ) ; cf_in=cldum
        CASE ( 2 ) ; CALL ParseVars(cldum)
        CASE ( 3 ) ; ctype=cldum
        CASE ( 4 ) ; READ(cldum,*) rdep_up
        CASE ( 5 ) ; READ(cldum,*) rdep_down
        CASE DEFAULT
           PRINT *,' Too many arguments ...' ; STOP 99
        END SELECT
     END SELECT
  ENDDO

  lchk = chkfile (cn_fzgr)
  lchk = chkfile (cn_fmsk) .OR. lchk
  lchk = chkfile (cf_in  ) .OR. lchk
  IF ( lchk ) STOP 99 ! missing files

  CALL SetGlobalAtt (cglobal)

  IF (rdep_down < rdep_up ) THEN
     PRINT *,'Give depth limits in increasing order !'
     STOP 99
  ENDIF

  npiglo = getdim (cf_in,cn_x)
  npjglo = getdim (cf_in,cn_y)
  npk    = getdim (cf_in,cn_z)
  npt    = getdim (cf_in,cn_t)

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  nvars       = getnvar(cf_in)
  ALLOCATE( cv_names(nvars), stypvarin(nvars) )
  ALLOCATE( stypvar(nvaro), ipk(nvaro), id_varout(nvaro) )
  cv_names(:) = getvarname(cf_in, nvars, stypvarin)

  ! just chck if var exist in file 
  DO jvar = 1, nvaro
     IF ( chkvar( cf_in, cv_in(jvar)) ) STOP 99 ! message is written in cdfio.chkvar
  ENDDO

  ! Allocate arrays
  ALLOCATE ( zmask(npiglo,npjglo), dvertmean(npiglo, npjglo) )
  ALLOCATE ( zv(npiglo,npjglo), hdep(npiglo,npjglo)          )
  ALLOCATE ( e3(npiglo,npjglo), dvol2d(npiglo,npjglo)        )
  ALLOCATE ( gdep(npk), tim(npt)                             )
  IF ( lfull ) ALLOCATE ( e31d(npk) )

  rdep(1)                      = 0.
  ipk(:)                       = 1
  DO jvar=1, nvaro
     DO jvarin=1,nvars
        IF ( cv_in(jvar) == stypvarin(jvarin)%cname ) EXIT  ! cv_in match cv_varin.
     END DO
     stypvar(jvar)%cname             = TRIM(cv_in(jvar))//'_vert_mean'
     stypvar(jvar)%cunits            = stypvarin(jvarin)%cunits
     stypvar(jvar)%rmissing_value    = stypvarin(jvarin)%rmissing_value
     stypvar(jvar)%valid_min         = stypvarin(jvarin)%valid_min
     stypvar(jvar)%valid_max         = stypvarin(jvarin)%valid_max
     stypvar(jvar)%clong_name        = 'vertical average of '//TRIM(stypvarin(jvarin)%clong_name)
     stypvar(jvar)%cshort_name       = TRIM(cv_in(jvar))//'_vert_mean'
     stypvar(jvar)%conline_operation = 'N/A'
     stypvar(jvar)%caxis             = 'TYX'
  END DO

  ! Initialize output file
  ncout = create      (cf_out, cf_in,   npiglo, npjglo, 1)
  ierr  = createvar   (ncout,  stypvar, nvaro,  ipk,    id_varout, cdglobal=cglobal  )
  ierr  = putheadervar(ncout,  cf_in,   npiglo, npjglo, 1, pdep=rdep)

  tim  = getvar1d(cf_in, cn_vtimec, npt     )
  ierr = putvar1d(ncout, tim,       npt, 'T')

  SELECT CASE ( ctype)
  CASE( 'T','t');  cv_dep=cn_gdepw ; cv_e3='e3t_ps' ; cv_e31d=cn_ve3t1d 
  CASE( 'U','u');  cv_dep=cn_gdepw ; cv_e3='e3u_ps' ; cv_e31d=cn_ve3t1d 
  CASE( 'V','v');  cv_dep=cn_gdepw ; cv_e3='e3v_ps' ; cv_e31d=cn_ve3t1d 
  CASE( 'W','w');  cv_dep=cn_gdept ; cv_e3='e3w_ps' ; cv_e31d=cn_ve3w1d
  CASE DEFAULT ; PRINT *,'Point type ', TRIM(ctype),' not known! ' ; STOP 99
  END SELECT

               gdep(:) = getvare3(cn_fzgr, cv_dep,  npk)
  IF ( lfull ) e31d(:) = getvare3(cn_fzgr, cv_e31d, npk)

  ! set mask variable name
  SELECT CASE (ctype )
  CASE ('T','t','W','w') ; cv_msk='tmask'
  CASE ('U','u')         ; cv_msk='umask'
  CASE ('V','v')         ; cv_msk='vmask'
  END SELECT

  ! Look for ik1 and ik2 as nearest level of rdep_up and rdep_down
  ik1 = 1; ik2 = npk
  DO jk=1,npk
     IF ( gdep(jk) <= rdep_up   ) ik1 = jk
     IF ( gdep(jk) <= rdep_down ) ik2 = jk
  ENDDO

  PRINT '(a,2f10.3)', 'depth limit of integration : ', rdep_up, rdep_down
  PRINT '(a,2i10  )', 'nearest level found        : ', ik1,     ik2
  PRINT '(a,2f10.3)', 'corresponding depth        : ', gdep(ik1), gdep(MIN(ik2+1,npk))

  DO jt=1,npt
     DO jvar = 1,nvaro
        cv_cur = cv_in(jvar)
        dvol           = 0.d0
        dvol2d(:,:)    = 0.d0
        dvertmean(:,:) = 0.d0

        DO jk = ik1, ik2
           ! Get values at jk
           zv(   :,:) = getvar(cf_in,   cv_cur, jk, npiglo, npjglo, ktime=jt)
           zmask(:,:) = getvar(cn_fmsk, cv_msk, jk, npiglo, npjglo          )

           ! get e3 at level jk ( ps...)
           IF ( lfull ) THEN ; e3(:,:) = e31d(jk)
           ELSE              ; e3(:,:) = getvar(cn_fzgr, cv_e3, jk, npiglo, npjglo, ldiom=.TRUE.)
           ENDIF

           IF ( jk == ik1 ) THEN
              hdep(:,:) = gdep(jk) + e3(:,:)
              e3(  :,:) = MIN(e3, hdep -rdep_up          )
           ENDIF

           IF ( jk == ik2 ) THEN
              e3(  :,:) = MIN(e3, (rdep_down) - gdep(jk) )
           ENDIF

           dvol       = SUM( DBLE(e3 * zmask) )
           dvol2d     =      e3 * zmask * 1.d0  + dvol2d
           dvertmean  = zv * e3 * zmask * 1.d0  + dvertmean

           IF (dvol == 0 )THEN
              ! no more layer below !    
              EXIT   ! get out of the jk loop
           ENDIF
        END DO

        ! Output to netcdf file 
        WHERE ( dvol2d /= 0 )  dvertmean = dvertmean/dvol2d
        ierr = putvar(ncout, id_varout(jvar), REAL(dvertmean), 1, npiglo, npjglo, ktime=jt)
     END DO
  END DO  ! loop on time

  ierr = closeout(ncout)
CONTAINS
  SUBROUTINE ParseVars (cdum)
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE ParseVars  ***
    !!
    !! ** Purpose :  Decode variable name  option from command line
    !!
    !! ** Method  :  look for , in the argument string and set the number of
    !!         variable (nvaro), allocate cv_in array and fill it with the
    !!         decoded  names.
    !!
    !!----------------------------------------------------------------------
    CHARACTER(LEN=*), INTENT(in) :: cdum

    CHARACTER(LEN=80), DIMENSION(100) :: cl_dum  ! 100 is arbitrary
    INTEGER  :: ji
    INTEGER  :: inchar,  i1=1
    !!----------------------------------------------------------------------
    inchar= LEN(TRIM(cdum))
    ! scan the input string and look for ',' as separator
    DO ji=1,inchar
       IF ( cdum(ji:ji) == ',' ) THEN
          cl_dum(nvaro) = cdum(i1:ji-1)
          i1=ji+1
          nvaro=nvaro+1
       ENDIF
    ENDDO

    ! last name of the list does not have a ','
    cl_dum(nvaro) = cdum(i1:inchar)

    ALLOCATE ( cv_in(nvaro) )
    IF ( ldebug) PRINT *,' SELECTED VARIABLES :'
    DO ji=1, nvaro
       cv_in(ji) = cl_dum(ji)
       IF ( ldebug) PRINT *, "    ",TRIM(cv_in(ji))
    ENDDO
  END SUBROUTINE ParseVars


END PROGRAM cdfvertmean

PROGRAM cdfcofdis
  !!======================================================================
  !!                     ***  PROGRAM  cdfcofdis  ***
  !!=====================================================================
  !!  ** Purpose : A wrapper for NEMO routine cofdis: create a file 
  !!               with the distance to coast variable
  !!
  !!  ** Method  : Mimic some NEMO global variables to be able to use
  !!               NEMO cofdis with minimum changes. Use cdfio instead
  !!               of IOIPSL for the output file. Due to this constaint
  !!               DOCTOR norm is not fully respected (eg jpi not PARAMETER) 
  !!               pdct is not a routine argument ...
  !!
  !! History : 2.1  : 11/2009  : J.M. Molines : Original code
  !!           3.0  : 12/2010  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  !!   cofdis       : compute distance to coast (NEMO routine )
  !!----------------------------------------------------------------------

  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class preprocessing
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: jpi, jpj, jpk, npk
  INTEGER(KIND=4)                           :: jpim1, jpjm1, nperio=4
  INTEGER(KIND=4)                           :: narg, iargc, ijarg
  INTEGER(KIND=4)                           :: ncout, ierr
  INTEGER(KIND=4), DIMENSION(1)             :: ipk, id_varout

  ! from phycst
  REAL(KIND=4)            :: rpi = 3.141592653589793          !: pi
  REAL(KIND=4)            :: rad = 3.141592653589793 / 180.   !: conv. from degre into radian
  REAL(KIND=4)            :: ra  = 6371229.                   !: earth radius (meter)

  ! to be read in mesh_hgr
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: glamt, glamu,glamv, glamf
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: gphit, gphiu,gphiv, gphif
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: tmask, umask, vmask, fmask
  ! 
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: pdct                       ! 2D only in this version
  ! It is a 3D arg in original cofdis
  REAL(KIND=8) ,DIMENSION(1)                :: dtim

  CHARACTER(LEN=256)                        :: cf_out='dist.coast'
  CHARACTER(LEN=256)                        :: cf_tfil
  CHARACTER(LEN=256)                        :: cv_out='Tcoast'
  CHARACTER(LEN=256)                        :: cldum

  TYPE(variable), DIMENSION(1)              :: stypvar

  LOGICAL                                   :: lchk
  LOGICAL                                   :: lsurf = .FALSE.
  LOGICAL                                   :: lrnf  = .FALSE.
  LOGICAL                                   :: lnc4  = .FALSE.     ! Use nc4 with chunking and deflation
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()
  !
  narg=iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage :  cdfcofdis -H HGR-file -M MSK-file -T gridT.nc [-jperio jperio ]...'
     PRINT *,'               ... [-rnf] [-surf] [-o OUT-file[ [-nc4] '
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'        Compute the distance to the coast and create a file with the ',TRIM(cv_out)
     PRINT *,'        variable, indicating the distance to the coast. This computation is '
     PRINT *,'        done for every model level, unless -surf option is used.'
     PRINT *,'        This file is used in NEMO tradmp routine for fading out restoring'
     PRINT *,'        in vicinity of the coast line.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -H HGR-file : name of the mesh_hgr file '
     PRINT *,'       -M MSK-file : name of the mask file '
     PRINT *,'       -T T-file   : netcdf file at T point ( used for looking at jpk)'
     PRINT *,'             (This argument is not used with -surf option).'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-jperio jperio ] : define the NEMO jperio variable for north fold '
     PRINT *,'           condition. Default is  4.'
     PRINT *,'       [-rnf ]  : use a runoff file instead of mask file. In this case the'
     PRINT *,'             computed distance is the distance to runoff points defined in the'
     PRINT *,'             file by the variable socoefr. Force -surf option.'
     PRINT *,'       [-surf ] : only compute  distance at the surface.'
     PRINT *,'       [-o OUT-file ] : specify name of the output file instead of ', TRIM(cf_out)
     PRINT *,'       [-nc4 ]     : Use netcdf4 output with chunking and deflation level 1.'
     PRINT *,'                 This option is effective only if cdftools are compiled with'
     PRINT *,'                 a netcdf library supporting chunking and deflation.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       none' 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) ,' unless -o option is used.'
     PRINT *,'         variables : ', TRIM(cv_out),' (m)'
     PRINT *,'      '
     STOP 
  ENDIF

  ijarg = 1
  DO WHILE ( ijarg <= narg )
     CALL getarg(ijarg, cldum) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-H'     ) ; CALL getarg(ijarg,cn_fhgr) ; ijarg=ijarg+1
     CASE ( '-M'     ) ; CALL getarg(ijarg,cn_fmsk) ; ijarg=ijarg+1
     CASE ( '-T'     ) ; CALL getarg(ijarg,cf_tfil) ; ijarg=ijarg+1
        ! options
     CASE ( '-jperio') ; CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1 ;  READ(cldum, * ) nperio
     CASE ( '-surf'  ) ; lsurf = .TRUE.
     CASE ( '-rnf'   ) ; lrnf  = .TRUE. ; lsurf =.TRUE. ; cn_tmask='socoefr'
     CASE ( '-o'     ) ; CALL getarg(ijarg, cf_out) ; ijarg=ijarg+1 
     CASE ( '-nc4'   ) ; lnc4  = .TRUE.
     CASE DEFAULT      ; PRINT *,' ERROR : ', TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  ENDDO

  IF ( lrnf ) THEN
     PRINT *, ' WORKING WITH RUNOFF FILE :'
     PRINT *, '      RUNOFF FILE : ', TRIM(cn_fmsk)
     PRINT *, '      VARIABLE    : ', TRIM(cn_tmask)
     PRINT *, '  '
     PRINT *, ' -surf OPTION forced !'
  ENDIF

  lchk =           chkfile ( cn_fhgr )
  lchk = lchk .OR. chkfile ( cn_fmsk )
  IF ( .NOT. lsurf) lchk = lchk .OR. chkfile ( cf_tfil )
  IF ( lchk ) STOP 99 ! missing files

  ! read domain dimensions in the mask file
  jpi = getdim(cn_fhgr,cn_x)
  jpj = getdim(cn_fhgr,cn_y)

  IF ( .NOT. lsurf ) THEN
    jpk = getdim(cf_tfil,cn_z)

    IF (jpk == 0 ) THEN
       jpk = getdim(cf_tfil,'z')
       IF ( jpk == 0 ) THEN
          PRINT *,' ERROR in determining jpk form gridT file ....'
          STOP 99
       ENDIF
    ENDIF
  ELSE
    jpk=1
  ENDIF

  PRINT *, ' JPI = ', jpi
  PRINT *, ' JPJ = ', jpj
  PRINT *, ' JPK = ', jpk

  jpim1=jpi-1 ; jpjm1=jpj-1

  ! ALLOCATION of the arrays
  ALLOCATE ( glamt(jpi,jpj), glamu(jpi,jpj), glamv(jpi,jpj), glamf(jpi,jpj) )
  ALLOCATE ( gphit(jpi,jpj), gphiu(jpi,jpj), gphiv(jpi,jpj), gphif(jpi,jpj) )
  ALLOCATE ( tmask(jpi,jpj), umask(jpi,jpj), vmask(jpi,jpj), fmask(jpi,jpj) )
  ALLOCATE ( pdct(jpi,jpj) )

  PRINT *, 'ALLOCATION DONE.'

  ! read latitude an longitude
  glamt(:,:) = getvar(cn_fhgr,cn_glamt,1,jpi,jpj)
  glamu(:,:) = getvar(cn_fhgr,cn_glamu,1,jpi,jpj)
  glamv(:,:) = getvar(cn_fhgr,cn_glamv,1,jpi,jpj)
  glamf(:,:) = getvar(cn_fhgr,cn_glamf,1,jpi,jpj)

  gphit(:,:) = getvar(cn_fhgr,cn_gphit,1,jpi,jpj)
  gphiu(:,:) = getvar(cn_fhgr,cn_gphiu,1,jpi,jpj)
  gphiv(:,:) = getvar(cn_fhgr,cn_gphiv,1,jpi,jpj)
  gphif(:,:) = getvar(cn_fhgr,cn_gphif,1,jpi,jpj)

  ! prepare file output
  npk = jpk

  CALL CreateOutput

  CALL cofdis (npk)

CONTAINS

  SUBROUTINE cofdis(kpk)
    !!----------------------------------------------------------------------
    !!                 ***  ROUTINE cofdis  ***
    !!
    !! ** Purpose :   Compute the distance between ocean T-points and the
    !!      ocean model coastlines. Save the distance in a NetCDF file.
    !!
    !! ** Method  :   For each model level, the distance-to-coast is 
    !!      computed as follows : 
    !!       - The coastline is defined as the serie of U-,V-,F-points
    !!      that are at the ocean-land bound.
    !!       - For each ocean T-point, the distance-to-coast is then 
    !!      computed as the smallest distance (on the sphere) between the 
    !!      T-point and all the coastline points.
    !!       - For land T-points, the distance-to-coast is set to zero.
    !!      C A U T I O N : Computation not yet implemented in mpp case.
    !!
    !! ** Action  : - pdct, distance to the coastline (argument)
    !!              - NetCDF file 'dist.coast' 
    !!----------------------------------------------------------------------
    INTEGER(KIND=4), INTENT(in) ::   kpk                 ! number of level to deal with

    INTEGER(KIND=4) ::   ji, jj, jk, jl      ! dummy loop indices
    INTEGER(KIND=4) ::   iju, ijt            ! temporary integers
    INTEGER(KIND=4) ::   icoast, itime
    INTEGER(KIND=4) ::   icot         ! logical unit for file distance to the coast
    LOGICAL, DIMENSION(jpi,jpj) ::   llcotu, llcotv, llcotf   ! ???
    CHARACTER (len=32) ::   clname
    REAL(KIND=4) ::   zdate0
    REAL(KIND=4), DIMENSION(jpi,jpj)   ::   zxt, zyt, zzt, zmask   ! cartesian coordinates for T-points
    REAL(KIND=4), DIMENSION(3*jpi*jpj) ::   zxc, zyc, zzc, zdis    ! temporary workspace
    !!----------------------------------------------------------------------

    ! 0. Initialization
    ! -----------------
    PRINT *, 'COFDIS init'
    zxt(:,:) = COS( rad * gphit(:,:) ) * COS( rad * glamt(:,:) )
    zyt(:,:) = COS( rad * gphit(:,:) ) * SIN( rad * glamt(:,:) )
    zzt(:,:) = SIN( rad * gphit(:,:) )


    ! 1. Loop on vertical levels
    ! --------------------------
    !                                             ! ===============
    DO jk = 1, kpk                                ! Horizontal slab
       !                                          ! ===============
       PRINT *,'WORKING for level ', jk, nperio
       pdct(:,:) = 0.e0
       tmask(:,:)=getvar(cn_fmsk,cn_tmask,jk,jpi,jpj)
       WHERE (tmask /= 0 ) tmask=1
       DO jj = 1, jpjm1
          DO ji = 1, jpim1   ! vector loop
             umask(ji,jj) = tmask(ji,jj ) * tmask(ji+1,jj  )
             vmask(ji,jj) = tmask(ji,jj ) * tmask(ji  ,jj+1)
          END DO
          DO ji = 1, jpim1      ! NO vector opt.
             fmask(ji,jj) = tmask(ji,jj  ) * tmask(ji+1,jj  )   &
                  &         * tmask(ji,jj+1) * tmask(ji+1,jj+1)
          END DO
       END DO
       umask(jpi,:)=umask(2,:)
       vmask(jpi,:)=vmask(2,:)
       fmask(jpi,:)=fmask(2,:)


       PRINT *, '    READ masks done.'
       ! Define the coastline points (U, V and F)
       DO jj = 2, jpjm1
          DO ji = 2, jpim1
             zmask(ji,jj) =  ( tmask(ji,jj+1) + tmask(ji+1,jj+1) &
                  &           + tmask(ji,jj  ) + tmask(ji+1,jj  ) )
             llcotu(ji,jj) = ( tmask(ji,jj  ) + tmask(ji+1,jj  ) == 1. ) 
             llcotv(ji,jj) = ( tmask(ji,jj  ) + tmask(ji  ,jj+1) == 1. ) 
             llcotf(ji,jj) = ( zmask(ji,jj) > 0. ) .AND. ( zmask(ji,jj) < 4. )
          END DO
       END DO
       PRINT *,'  llcot? set now.'

       ! Lateral boundaries conditions
       llcotu(:, 1 ) = umask(:,  2  ) == 1
       llcotu(:,jpj) = umask(:,jpjm1) == 1
       llcotv(:, 1 ) = vmask(:,  2  ) == 1
       llcotv(:,jpj) = vmask(:,jpjm1) == 1
       llcotf(:, 1 ) = fmask(:,  2  ) == 1
       llcotf(:,jpj) = fmask(:,jpjm1) == 1

       IF( nperio == 1 .OR. nperio == 4 .OR. nperio == 6 ) THEN
          llcotu( 1 ,:) = llcotu(jpim1,:)
          llcotu(jpi,:) = llcotu(  2  ,:)
          llcotv( 1 ,:) = llcotv(jpim1,:)
          llcotv(jpi,:) = llcotv(  2  ,:)
          llcotf( 1 ,:) = llcotf(jpim1,:)
          llcotf(jpi,:) = llcotf(  2  ,:)
       ELSE
          llcotu( 1 ,:) = umask(  2  ,:) == 1
          llcotu(jpi,:) = umask(jpim1,:) == 1
          llcotv( 1 ,:) = vmask(  2  ,:) == 1
          llcotv(jpi,:) = vmask(jpim1,:) == 1
          llcotf( 1 ,:) = fmask(  2  ,:) == 1
          llcotf(jpi,:) = fmask(jpim1,:) == 1
       ENDIF
       IF( nperio == 3 .OR. nperio == 4 ) THEN
          DO ji = 1, jpim1
             iju = jpi - ji + 1
             llcotu(ji,jpj  ) = llcotu(iju,jpj-2)
             llcotf(ji,jpjm1) = llcotf(iju,jpj-2)
             llcotf(ji,jpj  ) = llcotf(iju,jpj-3)
          END DO
          DO ji = jpi/2, jpim1
             iju = jpi - ji + 1
             llcotu(ji,jpjm1) = llcotu(iju,jpjm1)
          END DO
          DO ji = 2, jpi
             ijt = jpi - ji + 2
             llcotv(ji,jpjm1) = llcotv(ijt,jpj-2)
             llcotv(ji,jpj  ) = llcotv(ijt,jpj-3)
          END DO
       ENDIF
       IF( nperio == 5 .OR. nperio == 6 ) THEN
          DO ji = 1, jpim1
             iju = jpi - ji
             llcotu(ji,jpj  ) = llcotu(iju,jpjm1)
             llcotf(ji,jpj  ) = llcotf(iju,jpj-2)
          END DO
          DO ji = jpi/2, jpim1
             iju = jpi - ji
             llcotf(ji,jpjm1) = llcotf(iju,jpjm1)
          END DO
          DO ji = 1, jpi
             ijt = jpi - ji + 1
             llcotv(ji,jpj  ) = llcotv(ijt,jpjm1)
          END DO
          DO ji = jpi/2+1, jpi
             ijt = jpi - ji + 1
             llcotv(ji,jpjm1) = llcotv(ijt,jpjm1)
          END DO
       ENDIF

       ! Compute cartesian coordinates of coastline points
       ! and the number of coastline points

       icoast = 0
       PRINT *,' START computing cartesian coord of coastlines '
       DO jj = 1, jpj
          DO ji = 1, jpi
             IF( llcotf(ji,jj) ) THEN
                icoast = icoast + 1
                zxc(icoast) = COS( rad*gphif(ji,jj) ) * COS( rad*glamf(ji,jj) )
                zyc(icoast) = COS( rad*gphif(ji,jj) ) * SIN( rad*glamf(ji,jj) )
                zzc(icoast) = SIN( rad*gphif(ji,jj) )
             ENDIF
             IF( llcotu(ji,jj) ) THEN
                icoast = icoast+1
                zxc(icoast) = COS( rad*gphiu(ji,jj) ) * COS( rad*glamu(ji,jj) )
                zyc(icoast) = COS( rad*gphiu(ji,jj) ) * SIN( rad*glamu(ji,jj) )
                zzc(icoast) = SIN( rad*gphiu(ji,jj) )
             ENDIF
             IF( llcotv(ji,jj) ) THEN
                icoast = icoast+1
                zxc(icoast) = COS( rad*gphiv(ji,jj) ) * COS( rad*glamv(ji,jj) )
                zyc(icoast) = COS( rad*gphiv(ji,jj) ) * SIN( rad*glamv(ji,jj) )
                zzc(icoast) = SIN( rad*gphiv(ji,jj) )
             ENDIF
          END DO
       END DO
       PRINT *,' END computing cartesian coord of coastlines '

       ! Distance for the T-points

       PRINT *,' START computing distance for T points', icoast
       DO jj = 1, jpj
          PRINT *, jj
          DO ji = 1, jpi
             IF ( lrnf ) THEN  ! we compute distance even where socoefr =0
                DO jl = 1, icoast
                   zdis(jl) = ( zxt(ji,jj) - zxc(jl) )**2   &
                        &     + ( zyt(ji,jj) - zyc(jl) )**2 &
                        &     + ( zzt(ji,jj) - zzc(jl) )**2
                END DO
                pdct(ji,jj) = ra * SQRT( MINVAL( zdis(1:icoast) ) )
             ELSE              ! Distance is computed only for non masked cells.
              IF( tmask(ji,jj) == 0. ) THEN
                pdct(ji,jj) = 0.
              ELSE
                DO jl = 1, icoast
                   zdis(jl) = ( zxt(ji,jj) - zxc(jl) )**2   &
                        &     + ( zyt(ji,jj) - zyc(jl) )**2 &
                        &     + ( zzt(ji,jj) - zzc(jl) )**2
                END DO
                pdct(ji,jj) = ra * SQRT( MINVAL( zdis(1:icoast) ) )
              ENDIF
             ENDIF
          END DO
       END DO
       PRINT *,' END computing distance for T points'

       ierr=putvar(ncout,id_varout(1),pdct,jk,jpi,jpj)
       !                                                ! ===============
    END DO                                              !   End of slab
    !                                                   ! ===============
    dtim(:)=0.d0
    ierr=putvar1d(ncout,dtim,1,'T')
    ierr = closeout(ncout)

  END SUBROUTINE cofdis

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    INTEGER(KIND=4) :: iipk
    ipk(1)                       = npk
    stypvar(1)%ichunk            = (/jpi,MAX(1,jpj/30),1,1 /)
    stypvar(1)%cname             = cv_out
    stypvar(1)%cunits            = 'm'
    stypvar(1)%rmissing_value    = 0
    stypvar(1)%valid_min         = 0.
    stypvar(1)%valid_max         = 10000000.
    stypvar(1)%clong_name        = cv_out
    stypvar(1)%cshort_name       = cv_out
    stypvar(1)%conline_operation = 'N/A'
    stypvar(1)%caxis             = 'TZYX'
    stypvar(1)%cprecision        = 'r4'

    IF ( lsurf ) THEN
      iipk = 0
    ELSE
      iipk = npk
    ENDIF

    ncout = create      (cf_out, cf_tfil, jpi, jpj, iipk       , ld_nc4=lnc4 )
    ierr  = createvar   (ncout,  stypvar, 1,   ipk, id_varout , ld_nc4=lnc4 )
    ierr  = putheadervar(ncout,  cf_tfil, jpi, jpj, iipk       )

  END SUBROUTINE CreateOutput

END PROGRAM cdfcofdis

PROGRAM cdfisf_diags
  !!======================================================================
  !!                     ***  PROGRAM  cdfisf_diags  ***
  !!=====================================================================
  !!  ** Purpose : Compute the integrated ice shelf melt for each ice shelves 
  !!             specified in a list 
  !!
  !!  ** Method  : total_melt = sum ( melt_rate * e1 * e2 * mask )
  !!
  !! History : 3.0  : 08/2015  : P. Mathiot   : Original code (from cdfsum)
  !!           4.0  : 08/2017  : J.M. Molines : port to CDFTOOLS 4.0
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  USE modutils
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class ice_shelf_processing
  !!-----------------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: jt, jisf            ! dummy loop index
  INTEGER(KIND=4)                           :: iimin=0, iimax=0    ! domain limitation for computation
  INTEGER(KIND=4)                           :: ijmin=0, ijmax=0    ! domain limitation for computation
  INTEGER(KIND=4)                           :: ikx=1, iky=1        ! dims of netcdf output file
  INTEGER(KIND=4)                           :: idum                ! dummy integer for txt file reading
  INTEGER(KIND=4)                           :: id_isf              ! ice shelf id
  INTEGER(KIND=4)                           :: iunit=10            ! ice shelf text input file id
  INTEGER(KIND=4)                           :: ierr                ! working integer
  INTEGER(KIND=4)                           :: narg, iargc, ijarg  ! command line 
  INTEGER(KIND=4)                           :: npiglo, npjglo      ! size of the domain
  INTEGER(KIND=4)                           :: npk, npt, nisf      ! size of the domain
  INTEGER(KIND=4)                           :: nvpk                ! vertical levels in working variable
  INTEGER(KIND=4)                           :: ncout               ! for netcdf output
  INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE :: ipk, id_varout

  REAL(KIND=4)                              :: rdummy              ! dummy 2d variable for result
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: gdep                ! depth 
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e1, e2, zmlt        ! metrics and ice shelf melt
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zmask, zmaskisf, mask ! npiglo x npjglo
  REAL(KIND=4), DIMENSION(1,1)              :: rdumlon, rdumlat    ! dummy latitude and longitude
  REAL(KIND=4), DIMENSION(1,1)              :: rdum                ! dummy variable for txt file reading

  REAL(KIND=8)                              :: dfwfobs             ! ice shelf melt observation
  REAL(KIND=8), DIMENSION(:),   ALLOCATABLE :: dtim                ! time

  CHARACTER(LEN=256)                        :: cldum, cdum         ! dummy string
  CHARACTER(LEN=3)                          :: cid_isf             ! isf id print in netcdf output long name
  CHARACTER(LEN=256)                        :: cf_isfmsk           ! input file names
  CHARACTER(LEN=256)                        :: cf_isflst           ! input file names
  CHARACTER(LEN=256)                        :: cf_in               ! file name 
  CHARACTER(LEN=256)                        :: cf_out='cdfisf.nc'  ! output file name 
  CHARACTER(LEN=256)                        :: cv_in               ! variable name
  CHARACTER(LEN=20)                         :: cv_msk              ! name of mask variable
  CHARACTER(LEN=20)                         :: cv_isfmsk           ! name of mask variable
  CHARACTER(LEN=256)                        :: cglobal             ! netcdf global attribute


  TYPE(variable), DIMENSION(:), ALLOCATABLE :: stypvar             ! structure of output
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfisf_diags -f IN-file -v IN-var -ff ISF-fill_file -fv ISF-fill_var '
     PRINT *,'                -l ISF-list [-w imin imax jmin jmax kmin kmax] [-o OUT-file] '
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Computes the integrated ice shelf melting for all ice shelves'
     PRINT *,'       defined in the input list.' 
     PRINT *,'       This diags can be optionally limited to a sub-area.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -f IN-file : netcdf input file for ice shelf melting.' 
     PRINT *,'       -v IN-var  : netcdf ice shelf melt variable to work with (kg/m2/y).'
     PRINT *,'                 convertion from kg/m2/s to Gt/y is made with 365d.'
     PRINT *,'       -ff ISF-fill_file : file built by cdfisf_fill (all the ice shelves are'
     PRINT *,'                       tagged with an id)'
     PRINT *,'       -fv ISF-fill_var  : name of fill variable to use in ISF-fill_file'
     PRINT *,'       -l ISF-list : ice shelf list outputed by cdfisf_fill'
     PRINT *,'                  (id in the list must match the list in ISF-fill_file)'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       -w imin imax jmin jmax  : limit of the sub area to work with.' 
     PRINT *,'              if imin=0 all i are taken'
     PRINT *,'              if jmin=0 all j are taken'
     PRINT *,'       -o OUT-file : specify the name of the output file instead of ',TRIM(cf_out)
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'      ', TRIM(cn_fhgr),' and ',TRIM(cn_fmsk)
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       Standard output.'
     PRINT *,'       netcdf file : ',TRIM(cf_out),' with 1 variable for each ice shelves'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'       cdfisf_fill, cdfisf_forcing, cdfisf_poolchk, cdfisf_rnf'
     PRINT *,'      '

     STOP
  ENDIF

  ! global attribute
  ! setting up the building command in global attribute
  CALL SetGlobalAtt (cglobal)  ! append command name to global attribute

  ijarg = 1  
  DO WHILE ( ijarg <= narg )
     CALL getarg(ijarg, cldum ) ; ijarg = ijarg + 1
     SELECT CASE (cldum )
     CASE ( '-f'  ) ; CALL getarg (ijarg,cf_in    )  ; ijarg=ijarg+1
     CASE ( '-v'  ) ; CALL getarg (ijarg,cv_in    )  ; ijarg=ijarg+1
     CASE ( '-ff' ) ; CALL getarg (ijarg,cf_isfmsk)  ; ijarg=ijarg+1
     CASE ( '-fv' ) ; CALL getarg (ijarg,cv_isfmsk)  ; ijarg=ijarg+1
     CASE ( '-l'  ) ; CALL getarg (ijarg,cf_isflst)  ; ijarg=ijarg+1
        !
     CASE ( '-w'  ) ; CALL getarg (ijarg,cldum    )  ; ijarg=ijarg+1 ; READ(*,cldum) iimin 
        ;           ; CALL getarg (ijarg,cldum    )  ; ijarg=ijarg+1 ; READ(*,cldum) iimax 
        ;           ; CALL getarg (ijarg,cldum    )  ; ijarg=ijarg+1 ; READ(*,cldum) ijmin 
        ;           ; CALL getarg (ijarg,cldum    )  ; ijarg=ijarg+1 ; READ(*,cldum) ijmax
     CASE ( '-o'  ) ; CALL getarg (ijarg,cf_out   )  ; ijarg=ijarg+1
     CASE DEFAULT ; PRINT *,' ERROR : ', TRIM(cldum) ,' : unknown option.'; STOP 99
     END SELECT
  ENDDO

  ! check input files and variables
  CALL CheckInput

  ! get dimension
  npiglo = getdim (cf_in,cn_x)
  npjglo = getdim (cf_in,cn_y)
  npk    = getdim (cf_in,cn_z)
  npt    = getdim (cf_in,cn_t)
  nvpk   = 1

  IF (iimin /= 0 ) THEN ; npiglo = iimax - iimin + 1;
  ELSE ; iimin = 1 ;
  ENDIF
  IF (ijmin /= 0 ) THEN ; npjglo = ijmax - ijmin + 1;
  ELSE ; ijmin = 1 ;
  ENDIF

  PRINT *, 'Size of the extracted area :'
  PRINT *, '  npiglo = ', npiglo
  PRINT *, '  npjglo = ', npjglo
  PRINT *, '  npk    = ', npk
  PRINT *, '  npt    = ', npt

  IF ( (npk == 0) ) THEN
     npk      = 1
  END IF

  ! Allocate arrays
  ALLOCATE ( zmask(npiglo,npjglo), zmaskisf(npiglo,npjglo), mask(npiglo,npjglo) )
  ALLOCATE ( zmlt(npiglo,npjglo) )
  ALLOCATE ( e1   (npiglo,npjglo), e2(npiglo,npjglo) )
  ALLOCATE ( gdep (npk), dtim(npt) )

  e1(:,:) = getvar  (cn_fhgr, cn_ve1t, 1, npiglo, npjglo, kimin=iimin, kjmin=ijmin)
  e2(:,:) = getvar  (cn_fhgr, cn_ve2t, 1, npiglo, npjglo, kimin=iimin, kjmin=ijmin)

  ! open text file for isf
  OPEN(unit=iunit, file=cf_isflst, form='FORMATTED', status='OLD')

  ! get number of isf
  nisf = 0
  cdum='XXX'
  DO WHILE ( TRIM(cdum) /= 'EOF')
     READ(iunit,*) cdum
     nisf=nisf+1
  END DO
  REWIND(iunit)
  nisf = nisf - 1
  PRINT *, nisf,' ice shelf detected in the input text file'

  ! define new variables for output 
  ALLOCATE( stypvar(nisf), ipk(nisf), id_varout(nisf) )

  ! create netcdf output
  CALL CreateOutput

  ! compute number of isf
  DO jt = 1,npt
     PRINT *, jt,'/',npt

     ! Get velocities v at ik
     zmlt(:,:) = getvar(cf_in, cv_in, 1, npiglo, npjglo, ktime=jt, kimin=iimin, kjmin=ijmin)

     ! get isf mask
     zmask   (:,:) = getvar(cn_fmsk  , cn_tmaskutil, 1, npiglo, npjglo, kimin=iimin, kjmin=ijmin)
     zmaskisf(:,:) = getvar(cf_isfmsk, cv_isfmsk   , 1, npiglo, npjglo, kimin=iimin, kjmin=ijmin)

     ! compute melt for each ice shelf
     REWIND(iunit)
     DO jisf=1,nisf

        ! read text file
        READ(iunit,*) id_isf, cdum, rdum, rdum, idum, idum, idum, idum, dfwfobs 

        ! set mask
        mask(:,:) = 0.0
        WHERE (zmaskisf == -id_isf)
           mask(:,:) = zmask
        END WHERE

        ! compute total melt for each ice shelf
        rdummy = SUM(DBLE(zmlt * e1 * e2 * mask)) *86400.d0 * 365.d0 / 1.e12

        ! sanity check
        IF (ABS(rdummy) > stypvar(jisf)%valid_max) THEN
           PRINT *, 'total melt of ',TRIM(cdum),' is unexpected'
           PRINT *, 'please check that input file is kg/m2/s'
           STOP
        END IF

        ! standard output
        WRITE (6,'(i3,a5,f6.1,f12.1)') jt, TRIM(cdum), dfwfobs, rdummy

        ! netcdf output
        ierr = putvar0d(ncout, id_varout(jisf), rdummy, ktime=jt )

     END DO
  END DO

  ierr=closeout(ncout)

CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create the output file. This is done outside the main
    !!               in order to increase readability of the code. 
    !!
    !! ** Method  :  Use global variables, defined in main 
    !!----------------------------------------------------------------------

    REWIND(iunit)
    ! loop on all isf
    DO jisf=1,nisf
       ! read text file
       READ(iunit,*) cid_isf, cdum, rdum, rdum, idum, idum, idum, idum, dfwfobs

       stypvar(jisf)%cunits            = 'Gt/y'
       stypvar(jisf)%rmissing_value    = -1.e4
       stypvar(jisf)%valid_min         = -1.e4
       stypvar(jisf)%valid_max         = 1.e4
       stypvar(jisf)%scale_factor      = 1.
       stypvar(jisf)%add_offset        = 0.
       stypvar(jisf)%savelog10         = 0.
       stypvar(jisf)%conline_operation = 'N/A'

       stypvar(jisf)%cname             = 'isfmelt_'//TRIM(cdum)
       stypvar(jisf)%clong_name        = 'isf melt for '//TRIM(cdum)//' with id: '//TRIM(cid_isf)
       stypvar(jisf)%cshort_name       = 'isfmelt_'//TRIM(cdum)
       stypvar(jisf)%caxis             = 'ZT'
       stypvar(jisf)%cprecision        = 'r8'

       ipk(jisf) = 1
    END DO

    ! create output fileset
    ncout = create      (cf_out, 'none',  ikx,   iky,   nvpk, cdep=cn_gdept)
    ierr  = createvar   (ncout, stypvar, nisf, ipk,   id_varout, cdglobal=TRIM(cglobal) )
    ierr  = putheadervar(ncout, cf_in,  ikx, iky, npk, pnavlon=rdumlon, pnavlat=rdumlat, pdep=gdep(1:nvpk), cdep=cn_gdept)

    ! read/write time variable
    dtim  = getvar1d(cf_in, cn_vtimec, npt     )
    ierr  = putvar1d(ncout, dtim,      npt, 'T')

  END SUBROUTINE CreateOutput

  SUBROUTINE CheckInput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CheckInput  ***
    !!
    !! ** Purpose :  Check the presence of input file and variable needed
    !!               by the tool. This is done outside the main in order 
    !!               to increase readability of the code. 
    !!
    !! ** Method  :  Use global variables, defined in main 
    !!----------------------------------------------------------------------
    LOGICAL :: lchk                ! flag for missing files and variables

    ! check file
    lchk = chkfile(cn_fhgr  )
    lchk = chkfile(cn_fmsk  ) .OR. lchk
    lchk = chkfile(cf_in    ) .OR. lchk
    lchk = chkfile(cf_isfmsk) .OR. lchk
    lchk = chkfile(cf_isflst) .OR. lchk
    lchk = chkfile(cf_in    ) .OR. lchk
    IF ( lchk ) STOP 96 ! missing file

    ! check var
    lchk = chkvar(cf_isfmsk, cv_isfmsk   )
    lchk = chkvar(cf_in    , cv_in       ) .OR. lchk
    lchk = chkvar(cn_fhgr  , cn_ve1t     ) .OR. lchk
    lchk = chkvar(cn_fhgr  , cn_ve2t     ) .OR. lchk
    lchk = chkvar(cn_fmsk  , cn_tmaskutil) .OR. lchk
    IF ( lchk ) STOP 96 ! missing variable

  END SUBROUTINE CheckInput

END PROGRAM cdfisf_diags

PROGRAM cdfmkresto
  !!======================================================================
  !!                     ***  PROGRAM  cdfmkresto  ***
  !!=====================================================================
  !!  ** Purpose : implement DRAKKAR restoring strategy off-line
  !!
  !!  ** Method  : port DRAKKAR resto_patch routine off-line
  !!
  !! History :  4.0  : 05/2017  : J.M. Molines :  Original code
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  !!   routines      : description
  !!   PrintCfgInfo  : Give details on the format for input cfg file
  !!   resto_patch   : Drakkar/Nemo routine used for building a local patch
  !!   ReadCfg       : Read Config file to feed the patch structure
  !!   GetCoord      : Read Config file to feed the patch structure
  !!   CreateOutput  : Create output file
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  USE cdftools
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017
  !! $Id$
  !! Copyright (c) 2012, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class preprocessing
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4), PARAMETER                 :: wp=4
  INTEGER(KIND=4)                            :: jjpat, jk
  INTEGER(KIND=4)                            :: npiglo, npjglo, npk
  INTEGER(KIND=4)                            :: nvar=1
  INTEGER(KIND=4)                            :: ijarg, narg, iargc
  INTEGER(KIND=4)                            :: npatch
  INTEGER(KIND=4)                            :: ncout, ierr
  INTEGER(KIND=4), DIMENSION(1)              :: id_varout, ipk

  REAL(KIND=4)                               :: ra    = 6371229.   !: earth radius
  REAL(KIND=4)                               :: rad = 3.141592653589793 / 180.
  REAL(KIND=4)                               :: rvalue
  REAL(KIND=4), DIMENSION(:),     ALLOCATABLE:: gdept_1d
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE:: gphi, glam
  REAL(KIND=4), DIMENSION(:,:,:), ALLOCATABLE:: resto

  REAL(KIND=8)                               :: dlon1, dlon2, dlat1, dlat2
  REAL(KIND=8), DIMENSION(:),     ALLOCATABLE:: dtim

  CHARACTER(LEN=255)                         :: cf_coord  ! coordinate file
  CHARACTER(LEN=255)                         :: cf_cfg    ! config file (txt)
  CHARACTER(LEN=255)                         :: cf_out = 'damping_coef.nc' ! default output name
  CHARACTER(LEN=255)                         :: cf_dep    ! depth file (txt)
  CHARACTER(LEN=255)                         :: cf_resto  ! Previous resto file for appending new zones
  CHARACTER(LEN=255)                         :: cv_resto  ! Previous resto variable in cf_resto
  CHARACTER(LEN=255)                         :: cv_out = 'resto' ! output variable name
  CHARACTER(LEN=255)                         :: ctype='T' ! C-point type for the output file
  CHARACTER(LEN=255)                         :: cldum     ! dummy character variable

  TYPE                                       :: patch     ! Structure handling a patch
     CHARACTER(1) :: ctyp         ! type ( R or C)
     REAL(KIND=4) :: rlon1 
     REAL(KIND=4) :: rlon2 
     REAL(KIND=4) :: rlat1 
     REAL(KIND=4) :: rlat2 
     REAL(KIND=4) :: rim
     REAL(KIND=4) :: radius
     REAL(KIND=4) :: tresto
     REAL(KIND=4) :: rdep1
     REAL(KIND=4) :: rdep2
  END TYPE patch

  TYPE (patch )  , DIMENSION(:), ALLOCATABLE :: spatch
  TYPE (variable), DIMENSION(1)              :: stypvar            ! structure for attributes

  LOGICAL                                    :: lnc4      = .FALSE.     ! Use nc4 with chunking and deflation
  LOGICAL                                    :: lfdep     = .TRUE.      ! flag for ascii depth file
  LOGICAL                                    :: lprev     = .FALSE.     ! flag for previous restoring file
  LOGICAL                                    :: ltime     = .TRUE.      ! flag for specific value (not time)
  LOGICAL                                    :: l2d       = .FALSE.     ! flag for 2d fields
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg=iargc()

  IF ( narg == 0 ) THEN
     PRINT *,' usage :  cdfmkresto -c COORD-file -i CFG-file [-d DEP-file] [-o DMP-file]...'
     PRINT *,'                     ...[-ov VAR-out] [-2d] [-prev RESTO-file RESTO-var ] ...'
     PRINT *,'                     ...[-p C-TYPE] [-val VALUE] [-nc4] [-h]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Create a file with a 3D damping coefficient suitable for the NEMO'
     PRINT *,'       TS restoring performed by tradmp. Units for the damping_coefficient '
     PRINT *,'       are s^-1.' 
     PRINT *,'      '
     PRINT *,'       The restoring zone is defined by a series of patches defined in the'
     PRINT *,'       configuration file, and that can have either a rectangular or a circular'
     PRINT *,'       shape. Overlapping patches are not added.'
     PRINT *,'       '
     PRINT *,'       This tool has been improved with new options (-val, -2d) so that it can'
     PRINT *,'       be used for building ''bfr2d_coef'' as well as ''shlat2d''.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -c COORD-file : pass the name of the file with horizontal coordinates.'
     PRINT *,'       -i CFG-file : pass the name of an ascii configuration file used to '
     PRINT *,'               to define the restoring properties. (use cdfmkresto -h for '
     PRINT *,'               a detailed description of this CFG-file, with some examples.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-h ]: print a detailed description of the configuration file.'
     PRINT *,'       [-d DEP-file]: name on an ASCII file with gdept_1d, if ',TRIM(cn_fzgr)
     PRINT *,'                is not available. This file is just a list of the deptht, in'
     PRINT *,'                one column.'
     PRINT *,'       [-prev RESTO-file RESTO-var] : Use RESTO-file and RESTO-var for the'
     PRINT *,'                initialization of the restoring coefficient. Units MUST be'
     PRINT *,'                s^-1 !!! '
     PRINT *,'       [-p C-type] : indicate on which grid point (T or F -so far-) the '
     PRINT *,'               variable is computed in the output file.'
     PRINT *,'       [-val VALUE ] : with this option, the ''restoring'' coefficient is'
     PRINT *,'                  set to VALUE , instead of a time scale.'
     PRINT *,'       [-2d ] : Create a 2D file instead of a default 3D file.'
     PRINT *,'       [-o DMP-file]: name of the output file instead of ',TRIM(cf_out),'.'
     PRINT *,'       [-ov VAR-out]: name of the output variable instead of ',TRIM(cv_out),'.'
     PRINT *,'       [-nc4]  : Use netcdf4 output with chunking and deflation level 1'
     PRINT *,'            This option is effective only if cdftools are compiled with'
     PRINT *,'            a netcdf library supporting chunking and deflation.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'         ', TRIM(cn_fzgr),'. If not available, use the -d option.'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) ,' unless -o option is used.'
     PRINT *,'         variables : ', TRIM(cv_out),' (s^-1 ) (unless -ov option used)'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'         cdfmkdmp'
     PRINT *,'      '
     STOP 
  ENDIF

  ijarg = 1 
  DO WHILE ( ijarg <= narg )
     CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-c'   ) ; CALL getarg(ijarg, cf_coord ) ; ijarg=ijarg+1
     CASE ( '-i'   ) ; CALL getarg(ijarg, cf_cfg   ) ; ijarg=ijarg+1
        ! option
     CASE ( '-h'   ) ; CALL PrintCfgInfo             ; STOP 0
     CASE ( '-d'   ) ; CALL getarg(ijarg, cf_dep   ) ; ijarg=ijarg+1
     CASE ( '-o'   ) ; CALL getarg(ijarg, cf_out   ) ; ijarg=ijarg+1
     CASE ( '-ov'  ) ; CALL getarg(ijarg, cv_out   ) ; ijarg=ijarg+1
     CASE ( '-prev') ; CALL getarg(ijarg, cf_resto ) ; ijarg=ijarg+1
        ;            ; CALL getarg(ijarg, cv_resto ) ; ijarg=ijarg+1
        ;            ; lprev = .TRUE.
     CASE ( '-p'   ) ; CALL getarg(ijarg, ctype    ) ; ijarg=ijarg+1 
     CASE ( '-val' ) ; CALL getarg(ijarg, cldum    ) ; ijarg=ijarg+1 ; READ(cldum,*) rvalue
        ;            ; ltime = .FALSE.
     CASE ( '-2d'  ) ; l2d  = .TRUE.
     CASE ( '-nc4' ) ; lnc4 = .TRUE.
     CASE DEFAULT    ; PRINT *, ' ERROR : ', TRIM(cldum),' : unknown option.'; STOP 99 
     END SELECT
  ENDDO

  ! Sanity check
  IF ( lprev ) THEN
        IF ( chkfile(cf_resto) ) STOP 99
  ENDIF
  IF ( chkfile(cf_dep, ld_verbose=.FALSE.) ) THEN
     ! look for cn_fzgr file
     lfdep=.FALSE.
     IF ( chkfile(cn_fzgr) ) STOP 99
  ENDIF
  IF ( chkfile(cf_coord) .OR. chkfile(cf_cfg) ) STOP 99 ! missing file
  IF ( ctype /= 'T' .AND. ctype /='F' ) THEN
     PRINT *,' ERROR : C-TYPE can be only T or F (so far...)'
     STOP 99
  ENDIF

  CALL ReadCfg  ! read configuration file and set variables

  CALL GetCoord ! read model horizontal coordinates and vertical levels
  ALLOCATE ( resto(npiglo, npjglo, npk) )

  IF ( lprev ) THEN 
    DO jk=1,npk
      resto(:,:,jk) = getvar(cf_resto,cv_resto, jk, npiglo, npjglo) 
    ENDDO
  ELSE
    resto(:,:,:) = 0.
  ENDIF

  CALL CreateOutput ! prepare netcdf output file 

  DO jjpat =1, npatch
     CALL resto_patch ( spatch(jjpat), resto  )
  ENDDO
  DO jk = 1, npk
     ierr = putvar( ncout, id_varout(1), resto(:,:,jk), jk, npiglo, npjglo)
  ENDDO
  ierr = closeout(ncout)

CONTAINS

  SUBROUTINE PrintCfgInfo
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE PrintCfgInfo  ***
    !!
    !! ** Purpose :  Display detailed information about the configuration
    !!               file.
    !!
    !! ** Method  :  Just print text.
    !!
    !!----------------------------------------------------------------------
    PRINT *,'       '
    PRINT *,'#   FORMAT OF THE CONFIGURATION FILE FOR cdfmkresto TOOL.'
    PRINT *,'       '
    PRINT *,'## CONTEXT:      '
    PRINT *,'      The restoring zone is defined by a series of patches described in the'
    PRINT *,'    configuration file, and that can have either a rectangular, a circular'
    PRINT *,'    or a disk shape. Overlapping patches uses the maximum between the patches.'
    PRINT *,'       '
    PRINT *,'    The configuration file is used to describe the series of patches.'
    PRINT *,'       '
    PRINT *,'## FILE FORMAT:   '
    PRINT *,'      There are as many lines as patches in the configuration files. No blank'
    PRINT *,'    lines are allowed but lines starting with a # are skipped.'
    PRINT *,'      Each line starts with either R, C, D or I to indicate either a Rectangular'
    PRINT *,'    patch, a Circular patch a Disk patch or IJ patch. Remaining fields on the '
    PRINT *,'    line  depend on the type of patch:'
    PRINT *,'###   Case of rectangular patches: the line looks like:'
    PRINT *,'       R lon1 lon2 lat1 lat2 band_width tresto z1 z2'
    PRINT *,'     In the rectangular case, the rectangle is defined by its geographical '
    PRINT *,'     limits (lon1, lon2, lat1, lat2 in degrees).'
    PRINT *,'     tresto represents the restoring time scale for the maximum restoring.'
    PRINT *,'     The restoring coefficient decay to zero outside the patch. The decay is'
    PRINT *,'     applied across a rim which width is given by the rim_width parameter'
    PRINT *,'     given in degrees.'
    PRINT *,'     Additionaly, z1 and z2 indicates a depth range (m) limiting the restoring.'
    PRINT *,'     If z1=z2, the restoring will be applied on the full water column.'
    PRINT *,'       '
    PRINT *,'###   Case of circulat patches: the line looks like:'
    PRINT *,'       C lon1 lat1 radius tresto z1 z2'
    PRINT *,'     In the circular case, the circle is defined by its center (lon1, lat1) in '
    PRINT *,'     degrees  and its radius in km. ''tresto'' represents the restoring time'
    PRINT *,'     scale at the center of the circle. The damping coefficient decays to zero'
    PRINT *,'     outside the defined circle. As in the rectangular case, z1 and z2 define a'
    PRINT *,'     depth range for  limiting the restoring. If z1=z2, the restoring is '
    PRINT *,'     applied to the full water column.'
    PRINT *,'       '
    PRINT *,'###   Case of disk patches: the line looks like:'
    PRINT *,'       D lon1 lat1 radius rim tresto z1 z2'
    PRINT *,'      In the disk case, a circle is defined with its center (lon1, lat1) in '
    PRINT *,'      degrees, and its radius in km.  In the disk case, the damping coefficient'
    PRINT *,'      is constant over the disk, and a there is a linear decay in a ring '
    PRINT *,'      around the disk, which width is the rim value (in km).'
    PRINT *,'      '
    PRINT *,'###   Case of a IJ patch : In this case, a rectangular patch is constructed '
    PRINT *,'      using directly the I,J coordinates (config dependent) passed on the line.'
    PRINT *,'      line looks like:'
    PRINT *,'      I  imin  imax  jmin  jmax  tresto  z1 z2 '
    PRINT *,'      In this case, if -val option is used, the value is exactly tresto'
    PRINT *,'       '
    PRINT *,'##  EXAMPLE:  '
    PRINT *,'       The standard DRAKKAR restoring procedure corresponds to the following '
    PRINT *,'     configuration file:  '
    PRINT *,'    '
    PRINT *,'# DRAKKAR restoring configuration file'
    PRINT *,'# Black Sea'
    PRINT *,'# type lon1  lon2 lat1 lat2 rim_width tresto   z1   z2'
    PRINT *,'    R   27.4 42.0 41.0 47.5   0.       180.     0    0'
    PRINT *,'# Red Sea'
    PRINT *,'    R   20.4 43.6 12.9 30.3   0.       180.     0    0'
    PRINT *,'# Persian Gulf'
    PRINT *,'    R   46.5 57.0 23.0 31.5   1.       180.     0    0'
    PRINT *,'# Restoring in the overflow regions'
    PRINT *,'# Gulf of Cadix (Gibraltar overflow)'
    PRINT *,'# type lon1  lat1 radius tresto  z1    z2'
    PRINT *,'    C  -7.0  36.0  80.      6.  600. 1300.'
    PRINT *,'# Gulf of Aden (Bab-el-Mandeb overflow)'
    PRINT *,'    C  44.75 11.5 100.      6.  0.   0.'
    PRINT *,'# Arabian Gulf  (Ormuz Strait  overflow)'
    PRINT *,'    C  57.75 25.0 100.      6.  0.   0.'
    PRINT *,'# Disk example ( not used in drakkar so far)'
    PRINT *,'# type lon1  lat1 radius  rim tresto  z1    z2'
    PRINT *,'   D    -30  -50   200    10   720    0     500'
    PRINT *,'# IJ example ( dummy , just an example)'
    PRINT *,'   I    250  252   300 301  10.  0 500 '
    PRINT *,'    '
    PRINT *,'       This file defines 8 patches, (3 rectangular, 3 circular,1 disk and 1 IJ).'
    PRINT *,'     Lines starting by # are helpfull comment for documenting the'
    PRINT *,'     restoring strategy. Note that as far as the position of the patches are '
    PRINT *,'     given in geographical coordinates, the same file can be used for different'
    PRINT *,'     model configuration (and resolution) !'
    PRINT *,'       Note that the time scale is not used if a value is passed with the '
    PRINT *,'     -val option. This latter option, combined with -2d option can be used'
    PRINT *,'     for producing 2D bottom friction enhancement, of 2D shlat coefficient.'
    PRINT *,'    '


  END SUBROUTINE PrintCfgInfo

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    ipk(1)                    = npk
    stypvar(1)%ichunk         = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(1)%cname          = cv_out
    IF ( ltime ) THEN
      stypvar(1)%cunits         = '[s^1]'
    ELSE
      stypvar(1)%cunits         = '[ ]'
    ENDIF
    stypvar(1)%rmissing_value = 1.e+20
    IF ( l2d ) THEN
      stypvar(1)%caxis          = 'TYX'
    ELSE
      stypvar(1)%caxis          = 'TZYX'
    ENDIF
    stypvar(1)%valid_min      = 0.
    stypvar(1)%valid_max      = 500.
    IF ( ltime )  THEN
      stypvar(1)%clong_name     = 'Restoring coefficent'
    ELSE
      stypvar(1)%clong_name     = 'Mask coefficent'
    ENDIF
    stypvar(1)%cshort_name    = cv_out

    IF ( l2d ) THEN
      ncout = create      (cf_out, 'none',  npiglo, npjglo, 0, ld_nc4=lnc4 )
      ierr  = createvar   (ncout,  stypvar,  1,     ipk,        id_varout,       ld_nc4=lnc4 )
      ierr  = putheadervar(ncout,  cf_coord,  npiglo, npjglo, 0 ,  &
           pnavlon=glam, pnavlat=gphi)
    ELSE
      ncout = create      (cf_out, 'none',  npiglo, npjglo, npk  ,cdep='deptht', ld_nc4=lnc4 )
      ierr  = createvar   (ncout,  stypvar,  1,     ipk,        id_varout,       ld_nc4=lnc4 )
      ierr  = putheadervar(ncout,  cf_coord,  npiglo, npjglo, npk ,  &
           pnavlon=glam, pnavlat=gphi, pdep=gdept_1d, cdep=cn_vdeptht )
    ENDIF

    ALLOCATE (dtim(1) )
    dtim = 0.d0
    ierr = putvar1d(ncout, dtim, 1   , 'T'  )

  END SUBROUTINE CreateOutput

  SUBROUTINE ReadCfg
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE ReadCfg  ***
    !!
    !! ** Purpose :  Read config file and set patch parameters
    !!
    !! ** Method  :  read and fill in corresponding variables
    !!
    !!----------------------------------------------------------------------
    INTEGER(KIND=4)    :: inum = 10! logical unit for configuration file
    INTEGER(KIND=4)    :: ierr ! error flag
    CHARACTER(LEN=255) :: cline, cltyp

    OPEN(inum, FILE=cf_cfg)
    ! count the number of patches and allocate spatch
    ierr=0
    npatch=0
    DO WHILE ( ierr == 0 )
       READ(inum,'(a)', iostat=ierr) cline
       IF ( ierr == 0 ) THEN
          IF ( cline(1:1) /= '#' ) THEN
             npatch=npatch+1
          ENDIF
       ENDIF
    ENDDO
    PRINT *,' NPATCH = ', npatch
    ALLOCATE ( spatch(npatch) )

    ! read again to fill the patch structure
    REWIND(inum)
    ierr = 0
    npatch = 0
    DO WHILE ( ierr == 0 )
       READ(inum,'(a)', iostat=ierr) cline
       IF ( ierr == 0 ) THEN
          IF ( cline(1:1) /= '#' ) THEN
             npatch=npatch+1
             PRINT *,'   Patch ',npatch,' :  ',TRIM(cline)
             READ(cline,*) cltyp
             SELECT CASE (cltyp)
             CASE ( 'R', 'r' ) ; READ(cline,*) spatch(npatch)%ctyp, &  ! Rectangle
                  & spatch(npatch)%rlon1, spatch(npatch)%rlon2,     &
                  & spatch(npatch)%rlat1, spatch(npatch)%rlat2,     &
                  & spatch(npatch)%rim, spatch(npatch)%tresto,      &
                  & spatch(npatch)%rdep1, spatch(npatch)%rdep2 
             CASE ( 'C', 'c' ) ; READ(cline,*) spatch(npatch)%ctyp, &   ! Circle
                  & spatch(npatch)%rlon1, spatch(npatch)%rlat1,     &
                  & spatch(npatch)%radius, spatch(npatch)%tresto,   &
                  & spatch(npatch)%rdep1, spatch(npatch)%rdep2 
             CASE ( 'D', 'd' ) ; READ(cline,*) spatch(npatch)%ctyp, &   ! Disque
                  & spatch(npatch)%rlon1, spatch(npatch)%rlat1,     &
                  & spatch(npatch)%radius,     &
                  & spatch(npatch)%rim, spatch(npatch)%tresto,   &
                  & spatch(npatch)%rdep1, spatch(npatch)%rdep2 
             CASE ( 'I', 'i' ) ; READ(cline,*) spatch(npatch)%ctyp, &   ! I
                  & spatch(npatch)%rlon1, spatch(npatch)%rlon2,     &
                  & spatch(npatch)%rlat1, spatch(npatch)%rlat2,     &
                  & spatch(npatch)%tresto,                          &
                  & spatch(npatch)%rdep1, spatch(npatch)%rdep2 
                  PRINT *, ' W A R N I N G : You are using a patch defined with I,J index'
                  PRINT *, ' =============   It depends on your configuration !'
             END SELECT
          ENDIF
       ENDIF
    ENDDO


  END SUBROUTINE ReadCfg

  SUBROUTINE GetCoord
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE GetCoord  ***
    !!
    !! ** Purpose :  Read glam, gphi from horizontal grid information
    !!               Read vertical grid information  
    !!
    !! ** Method  :  Open cf_coord file for horizontal grid.
    !!               Read vertical information from eiher mesh_zgr.nc
    !!               or cf_gdep ascii file
    !!
    !!----------------------------------------------------------------------
    INTEGER(KIND=4) :: inum=11, ieof=0, ilev=0
    !!----------------------------------------------------------------------
    npiglo = getdim(cf_coord,cn_x)
    npjglo = getdim(cf_coord,cn_y)
    ALLOCATE (glam(npiglo,npjglo), gphi(npiglo,npjglo) )
    IF ( ctype == 'T' ) THEN
      glam(:,:)=getvar(cf_coord,cn_glamt, 1,npiglo,npjglo)
      gphi(:,:)=getvar(cf_coord,cn_gphit, 1,npiglo,npjglo)
    ELSE IF  ( ctype == 'F' ) THEN
      glam(:,:)=getvar(cf_coord,cn_glamf, 1,npiglo,npjglo)
      gphi(:,:)=getvar(cf_coord,cn_gphif, 1,npiglo,npjglo)
    ELSE
      PRINT *, "ERROR : C-Type can be only T or F" ; STOP 99
    ENDIF
    ! now deal with vertical levels ( suppose z or zps ! )
    IF ( l2d ) THEN
       npk=1
       ALLOCATE(gdept_1d(npk))
       gdept_1d(1) = 0.
    ELSE
      IF ( lfdep ) THEN
         OPEN(inum, FILE=cf_dep)
         ! first read to look for number of levels
         DO WHILE ( ieof == 0 )
            READ(inum,*,iostat=ieof)
            ilev=ilev+1
         ENDDO
         npk=ilev - 1
         ALLOCATE(gdept_1d(npk))
         REWIND(inum)
         DO jk=1,npk
            READ(inum,*) gdept_1d(jk)
         ENDDO
         CLOSE(inum)
      ELSE
         npk = getdim(cn_fzgr,'z', kstatus=ierr)   ! depth dimension in mesh_zgr is 'z' 
         IF ( ierr /= 0 ) THEN
            npk   = getdim (cn_fzgr,'nav_lev', kstatus=ierr)
         ENDIF
  
         ALLOCATE( gdept_1d(npk) )
         gdept_1d(:) =  getvare3(cn_fzgr, cn_gdept, npk)
      ENDIF
    ENDIF

  END SUBROUTINE GetCoord


  SUBROUTINE resto_patch ( sd_patch, presto )
    !!------------------------------------------------------------------------
    !!                 ***  Routine resto_patch  ***
    !!
    !! ** Purpose :   modify resto array on a geographically defined zone.
    !!                The restoring can be limited on the vertical.
    !!
    !! ** Method  :  Use glam, gphi arrays. If the defined zone is outside 
    !!              the domain, resto is unchanged. Reactangular and Circulat
    !!              patches can be used.
    !!
    !!------------------------------------------------------------------------
    TYPE (patch),               INTENT(in )   :: sd_patch
    REAL(wp), DIMENSION(:,:,:), INTENT(inout) :: presto 
    !
    REAL(wp)          :: zlon1, zlon2, zlat1, zlat2, zbw, ztmax
    REAL(wp)          :: zz1, zz2
    !!
    INTEGER :: ji,jj, jk            ! dummy loop index
    INTEGER :: ii1, ii2, ij1, ij2   ! limiting horizontal index corresponding (I case)
    INTEGER :: ik1, ik2             ! limiting vertical index corresponding to zz1,zz2
    INTEGER, DIMENSION(1)  :: iloc 

    REAL(wp) :: zv1, zv2, zv3, zv4, zcoef, ztmp, zdist, zradius, zradius2, zcoef2
    REAL(wp), DIMENSION(:,:), ALLOCATABLE :: zpatch
    REAL(wp), DIMENSION(:)  , ALLOCATABLE :: zmask

    CHARACTER(LEN=1) :: cl_typ
    !!------------------------------------------------------------------------
    ALLOCATE ( zpatch(npiglo,npjglo), zmask(npk) )

    cl_typ   = sd_patch%ctyp
    zlon1    = sd_patch%rlon1
    zlon2    = sd_patch%rlon2
    zlat1    = sd_patch%rlat1
    zlat2    = sd_patch%rlat2
    zbw      = sd_patch%rim
    zradius  = sd_patch%radius
    zradius2 = zradius * zradius
    ztmax    = sd_patch%tresto
    zz1      = sd_patch%rdep1
    zz2      = sd_patch%rdep2

    zpatch = 0._wp
    IF ( ltime ) THEN
       zcoef  = 1._wp/ztmax/86400._wp
    ELSE
       zcoef  = rvalue
    ENDIF

    SELECT CASE ( cl_typ )
    CASE ( 'C', 'c' )   ! Circular patch 
       !  mask for horizontal extent
       DO jj = 1, npjglo
          DO ji = 1 , npiglo
             zpatch(ji,jj) =  SIN(gphi(ji,jj)*rad)* SIN(zlat1*rad)  &
                  &         + COS(gphi(ji,jj)*rad)* COS(zlat1*rad)  &
                  &         * COS(rad*(zlon1-glam(ji,jj)))
          ENDDO
       ENDDO

       WHERE ( ABS (zpatch ) > 1 ) zpatch = 1.
       ! applying spatial horizontal variation
       DO jj = 1, npjglo
          DO ji= 1, npiglo 
             ztmp = zpatch(ji,jj)
             zdist = ATAN(SQRT( (1.-ztmp)/(1+ztmp)) )*2.*ra/1000.
             zpatch(ji,jj) = EXP( - zdist*zdist/zradius2 )
          ENDDO
       ENDDO
       ! clean cut off
       WHERE (ABS(zpatch) < 0.01 ) zpatch = 0.

    CASE ( 'D', 'd' )   ! Circular patch 
       !  mask for horizontal extent
       DO jj = 1, npjglo
          DO ji = 1 , npiglo
            dlon1=zlon1*1.d0         ; dlat1=zlat1*1.d0
            dlon2=glam(ji,jj)*1.d0  ; dlat2=gphi(ji,jj)*1.d0
            zpatch(ji,jj) =  dist( dlon1, dlon2, dlat1, dlat2 )
          ENDDO
       ENDDO

       WHERE ( ABS (zpatch ) < zradius     ) zpatch = 1.
       WHERE ( ABS (zpatch ) > zradius+zbw ) zpatch = 0.
       ! applying spatial horizontal variation
       DO jj = 1, npjglo
          DO ji= 1, npiglo
           IF (zpatch(ji,jj) >= zradius ) THEN
              zpatch(ji,jj) = (zradius+zbw - zpatch(ji,jj) )/ zbw
           ENDIF
          ENDDO
       ENDDO
       ! clean cut off
       WHERE (ABS(zpatch) < 0.01 ) zpatch = 0.

       ! JMM : eventually add some checking to avoid locally large resto.


    CASE ( 'R','r' )
       ! horizontal extent
       zcoef2=1./(zbw +1.e-20 ) ! to avoid division by 0
       DO jj=1,npjglo
          DO ji=1,npiglo
             zv1=MAX(0., zcoef2*( glam(ji,jj) - zlon1)  )
             zv2=MAX(0., zcoef2*( zlon2 - glam(ji,jj))  )
             zv3=MAX(0., zcoef2*( gphi(ji,jj) - zlat1)  )
             zv4=MAX(0., zcoef2*( zlat2 - gphi(ji,jj))  )
             zpatch(ji,jj)= MIN( 1., MIN( 1., zv1,zv2,zv3,zv4 ) )
          ENDDO
       ENDDO
     CASE ( 'I','i')
       ii1=NINT(zlon1)  ; ii2 = NINT(zlon2)
       ij1=NINT(zlat1)  ; ij2 = NINT(zlat2)
       DO jj= ij1, ij2
          DO ji=ii1, ii2
             PRINT *, ' I-Patch at ',ji,jj, ztmax
             zpatch(ji,jj) = 1.
          ENDDO
       ENDDO
       ! Alter zcoef 
       IF ( .NOT. ltime  ) zcoef = ztmax
    END SELECT

    ! Vertical limitation same treatment for both types
    zmask(:) = 1.
    IF ( zz1 /= zz2 ) THEN
       WHERE ( gdept_1d < zz1 .OR. gdept_1d > zz2 ) zmask = 0.
       ! look for first 1
       iloc=MAXLOC(zmask) ; ik1 = iloc(1)
       ! now look for first 0
       zmask(1:ik1) = 1.
       iloc=MINLOC(zmask) ; ik2 = iloc(1) - 1

       zmask = 0._wp
       IF (ik2-ik1 > 4 ) THEN ! vertical ramp
          zmask(ik1        ) = 0.25_wp
          zmask(ik1+1      ) = 0.75_wp
          zmask(ik1+2:ik2-2) = 1.0_wp
          zmask(ik2-1      ) = 0.75_wp
          zmask(ik2        ) = 0.25_wp
       ELSE
          zmask(ik1:ik2) = 1. ! all the water column in zz1-zz2 is restored the same
       ENDIF
    ENDIF

    DO jk=1, npk
       presto(:,:,jk)= MAX(presto(:,:,jk),zpatch * zcoef * zmask(jk) )
    ENDDO
    !
    DEALLOCATE ( zmask, zpatch )
    !
  END SUBROUTINE resto_patch
END PROGRAM cdfmkresto

PROGRAM cdfmsk
  !!======================================================================
  !!                     ***  PROGRAM  cdfmsk  ***
  !!=====================================================================
  !!  ** Purpose : Compute the number of land points from the mask
  !!
  !! History : 2.1  : 05/2005  : J.M. Molines : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class file_informations
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: jk                   ! dummy loop index
  INTEGER(KIND=4)                           :: npoint               ! number of points
  INTEGER(KIND=4)                           :: narg, iargc          ! browse line
  INTEGER(KIND=4)                           :: npiglo, npjglo, npk  ! size of the domain

  REAL(KIND=4)                              :: zss                  !
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zmask                ! 2D mask at current level

  CHARACTER(LEN=256)                        :: cf_msk               ! file name
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfmsk MSK-file'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the number of ocean points, land points and displaysome ' 
     PRINT *,'       statistics: number and percentage of land points, number and '
     PRINT *,'       percentage of sea points.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       MSK-file : input mask file (which contains ',TRIM(cn_tmask),').'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        none apart the mask file passed as argument.'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       Standard output'
     STOP 
  ENDIF

  CALL getarg (1, cf_msk)

  IF ( chkfile(cf_msk) ) STOP 99 ! missing file

  ! in mask file cn_z is 'z'
  cn_z='z'  ! ugly fix

  npiglo = getdim (cf_msk, cn_x)
  npjglo = getdim (cf_msk, cn_y)
  npk    = getdim (cf_msk, cn_z)

  PRINT *,' NPIGLO = ', npiglo
  PRINT *,' NPJGLO = ', npjglo
  PRINT *,' NPK    = ', npk

  ALLOCATE (zmask(npiglo,npjglo))

  npoint = 0
  DO jk=1, npk
     zmask(:,:) = getvar(cf_msk, cn_tmask, jk ,npiglo, npjglo)
     zss        = SUM(zmask)
     npoint     = npoint + zss
  END DO

  PRINT *, ' Number of Ocean points :', npoint ,'  ',(1.*npoint )/npiglo/npjglo/npk*100,' %'
  PRINT *, ' Number of Land points :', npiglo*npjglo*npk - npoint ,'  ',(npiglo*npjglo*npk -1.*npoint )/npiglo/npjglo/npk*100,' %'

END PROGRAM cdfmsk

PROGRAM cdfmax
  !!======================================================================
  !!                     ***  PROGRAM  cdfmax  ***
  !!=====================================================================
  !!  ** Purpose : Find the min/max of a variable of an nc file. Give its 
  !!               location. A sub-area can be specified either horizontally
  !!               and/or vertically.
  !!
  !! History : 2.1  : 11/2006  : J.M. Molines : Original code
  !!           3.0  : 01/2011  : J.M. Molines : Doctor norm + Lic.
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_3.0 , MEOM 2011
  !! $Id$
  !! Copyright (c) 2011, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                               :: ji, jk, jvar, jt
  INTEGER(KIND=4)                               :: idep
  INTEGER(KIND=4)                               :: narg, iargc, ijarg
  INTEGER(KIND=4)                               :: ni, nj, nk, nt       ! size of the global domain
  INTEGER(KIND=4)                               :: ndim                 ! dimension of the variables
  INTEGER(KIND=4)                               :: ntype                ! type of slab (xy, xz, yz ...)
  INTEGER(KIND=4)                               :: ii1, ii2, ij1, ij2   ! index of min max  
  INTEGER(KIND=4)                               :: niz, njz, nkz, nvars ! size of the domain
  INTEGER(KIND=4)                               :: iimin=1, iimax=0     ! i-limit of the domain
  INTEGER(KIND=4)                               :: ijmin=1, ijmax=0     ! j-limit of the domain
  INTEGER(KIND=4)                               :: ikmin=1, ikmax=0     ! k-limit of the domain
  INTEGER(KIND=4)                               :: itmin=1, itmax=0     ! t-limit of the domain
  INTEGER(KIND=4)                               :: istatus              ! working integer
  INTEGER(KIND=4), DIMENSION(2)                 :: ilmin, ilmax         ! working array for minloc, maxloc

  REAL(KIND=4)                                  :: rfact=1.0            ! multiplying factor
  REAL(KIND=4)                                  :: zspval               ! missing value or spval
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE     :: h                    ! depth 
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE     :: v2d, rlon, rlat      ! data array, longitude, latitude

  CHARACTER(LEN=256)                            :: cf_in                ! input file name
  CHARACTER(LEN=256)                            :: cv_in='none'         ! current variable name
  CHARACTER(LEN=256)                            :: cldum                ! dummy char variable
  CHARACTER(LEN=256), DIMENSION(:), ALLOCATABLE :: cv_names             ! list of variables in file

  TYPE(variable), DIMENSION(:),     ALLOCATABLE :: stypvar              ! dummy dtructure to read var names

  LOGICAL                                       :: lforcexy=.FALSE.     ! flag for forced horizontal slab
  LOGICAL                                       :: lflag=.FALSE.        ! flag set when all data are missing
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfmax -f file -var cdfvar ...'
     PRINT *,'      ... [-lev kmin kmax ] [-zoom imin imax jmin jmax] ...'
     PRINT *,'      ... [-time tmin tmax ] [-fact multfact]  [-xy ]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'        Find minimum and maximum of a file as well as their '
     PRINT *,'        respective location. Options allow to restrict the '
     PRINT *,'        finding to a sub area in time and space. This program'
     PRINT *,'        also deal with vertical slabs in a domain.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -f file  : input file '
     PRINT *,'       -var cdfvar : input variable'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-lev kmin kmax ] : restrict to level between kmin and kmax. '
     PRINT *,'       [-zoom imin imax jmin jmax] : restrict to sub area specified'
     PRINT *,'                       by the given limits. If the zoomed area is '
     PRINT *,'                       degenerated to a single line, then the vertical'
     PRINT *,'                       slab is considered as domain.'
     PRINT *,'       [-time tmin tmax ] : restrict to the indicated time windows.'
     PRINT *,'       [-fact multfact] : use a multiplicative factor for the output'
     PRINT *,'       [-xy ] : force horizontal slab even in the case of a degenerated'
     PRINT *,'                       zoomed area.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       none' 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       output is done on standard output.'
     STOP
  ENDIF

  ijarg=1
  DO  WHILE (ijarg <=  narg)
     CALL getarg(ijarg, cldum) ; ijarg = ijarg + 1
     SELECT CASE (cldum )
     CASE ( '-f'    )
        CALL getarg(ijarg, cf_in) ; ijarg = ijarg + 1
     CASE ( '-lev'  )
        CALL getarg(ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) ikmin
        CALL getarg(ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) ikmax
     CASE ( '-fact'   )
        CALL getarg(ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) rfact
     CASE ( '-zoom' )
        CALL getarg(ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) iimin
        CALL getarg(ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) iimax
        CALL getarg(ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) ijmin
        CALL getarg(ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) ijmax
     CASE ( '-time' )
        CALL getarg(ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) itmin
        CALL getarg(ijarg, cldum) ; ijarg = ijarg + 1 ; READ(cldum,*) itmax
     CASE ( '-var'  )
        CALL getarg(ijarg, cv_in) ; ijarg = ijarg + 1 
     CASE ( '-xy'   )
        lforcexy = .TRUE.
     CASE DEFAULT
        PRINT *, cldum,' : unknown option '
        STOP 99
     END SELECT
  END DO

  IF ( chkfile(cf_in) ) STOP 99 ! missing file

  ni=0 ; nj=0; nk=0; nt=0 

  ni = getdim(cf_in, cn_x, cldum, istatus)
  IF ( istatus == 1 ) THEN 
     ni = getdim(cf_in, 'lon', cldum, istatus)
     IF ( istatus == 1 ) THEN
        PRINT *,' No X or lon dim found ' ; STOP 99
     ENDIF
  ENDIF
  IF ( iimax == 0 ) iimax = ni

  nj = getdim(cf_in, cn_y, cldum, istatus)
  IF ( istatus == 1 ) THEN 
     nj = getdim(cf_in, 'lat', cldum, istatus)
     IF ( istatus == 1 ) THEN
        PRINT *,' No y or lat dim found ' ; STOP 99
     ENDIF
  ENDIF
  IF ( ijmax == 0 ) ijmax = nj

  nk=getdim(cf_in, cn_z, cldum, istatus)
  IF ( istatus == 1 ) THEN 
     nk = getdim(cf_in, 'z', cldum, istatus)
     IF ( istatus == 1 ) THEN 
        nk = getdim(cf_in, 'lev', cldum, istatus)
        IF ( istatus == 1 ) THEN
           PRINT *,' No dep or z or lev  dim found ' 
           nk = 1
        ENDIF
     ENDIF
  ENDIF
  IF ( ikmax == 0 ) ikmax = nk

  nt = getdim(cf_in, cn_t, cldum, istatus)

  IF ( istatus == 1 ) THEN 
     nt = getdim(cf_in, 'step', cldum, istatus)
     IF ( istatus == 1 ) THEN
        PRINT *,' No time or step dim found ' 
     ENDIF
  ENDIF


  ! fix the size of the zoomed area, or the whole domain if no zoom
  niz = iimax - iimin + 1
  njz = ijmax - ijmin + 1
  nkz = ikmax - ikmin + 1

  IF (nt == 0 ) nt = 1  ! assume a 1 time frame file
  IF ( itmax == 0 ) itmax = nt
  ! allocate arrays
  ALLOCATE (h(nk), rlon(niz,njz), rlat(niz,njz))

  ! Look for variable name starting with dep
  nvars     = getnvar(cf_in)
  ALLOCATE (cv_names(nvars), stypvar(nvars))
  cv_names = getvarname(cf_in,nvars,stypvar)
  DO jvar=1,nvars
     idep = INDEX(cv_names(jvar),'dep') + INDEX(cv_names(jvar),'lev')
     IF (idep /= 0 ) EXIT
  END DO

  IF ( jvar == nvars +1 ) THEN
     ! no depth variable found ... we initialize it to levels
     h = (/(ji,ji=1,nk)/)
  ELSE
     h = getvar1d(cf_in, cv_names(jvar), nk)
  ENDIF
  zspval = getatt(cf_in, cv_in, cn_missing_value)

  ! Allocate memory and define ntype : (1) = horizontal i-j slab eventually many layers.
  !                                    (2) = vertical j-k slab, at a given i
  !                                    (3) = vertical i-k slab, at a given j
  IF ( (niz /= 1 .AND. njz /= 1 ) .OR. lforcexy  ) THEN 
     ALLOCATE (v2d(niz,njz) )
     ntype = 1    ! horizontal x-y slabs
  ELSE  
     IF ( niz == 1 ) THEN
        ALLOCATE (v2d(njz,nkz))
        ntype = 2 ! vertical y-z slab
     ELSE
        ALLOCATE(v2d(niz,nkz))
        ntype = 3 ! vertical x-z slab
     ENDIF
  ENDIF

  ! read latitude, longitude from the header
  rlon = getvar(cf_in, cn_vlon2d, 1, niz, njz, iimin, ijmin)
  rlat = getvar(cf_in, cn_vlat2d, 1, niz, njz, iimin, ijmin)

  DO
     ndim = getvdim(cf_in, cv_in) + 1   ! getvdim gives ndim-1 !
     PRINT *,TRIM(cv_in),' with multiplying factor of ', rfact
     ! ndim <=3 corresponds to purely 2D variables (x,y) or (x,y,t)
     IF ( ndim <= 3 ) THEN
        ikmin = 1 ; ikmax = 1 ; nkz = 1
     ENDIF

     SELECT CASE (ntype)
     CASE (1)
        SELECT CASE (ndim)
        CASE( 2,3,4 )  ! assume x,y,z,t variable
           PRINT 9000,'time  level     dep  MAX:   i    long    j    lat   MaxValue   MIN:     i    long    j   lat    MinValue'
           DO jt=itmin, itmax
              DO jk=ikmin,ikmax
                 v2d(:,:) = getvar(cf_in, cv_in, jk, niz, njz, kimin=iimin, kjmin=ijmin, ktime=jt)
                 ilmax = MAXLOC(v2d,(v2d /= zspval) )
                 ilmin = MINLOC(v2d,(v2d /= zspval) )
                 ii1=ilmax(1) ; ij1=ilmax(2)
                 ii2=ilmin(1) ; ij2=ilmin(2)
                 lflag = lchkflag()
                 PRINT 9003, jt, jk, h(jk),ii1+iimin -1, rlon(ii1,ij1),ij1+ijmin -1,rlat(ii1,ij1),v2d(ii1,ij1)*rfact, &
                      &             ii2+iimin -1, rlon(ii2,ij2),ij2+ijmin -1,rlat(ii2,ij2),v2d(ii2,ij2)*rfact
              END DO
           END DO
           EXIT

        CASE DEFAULT
           PRINT *,' Non mapable variables x-y :('
           cv_in='none'
        END SELECT

     CASE (2)
        SELECT CASE (ndim)
        CASE( 4 )  ! assume x,y,z,t variable
           PRINT 9000,' time i-slab  MAX:   i    long   j    lat   k     dep    MaxValue    MIN:  i    &
                & long   j     lat   k     dep    MinValue'
           DO jt=itmin, itmax
              v2d(:,:) = getvaryz(cf_in, cv_in, iimin, njz, nkz, ijmin, ikmin, ktime=jt)
              ilmax = MAXLOC(v2d,(v2d/= zspval) )
              ilmin = MINLOC(v2d,(v2d/= zspval) )
              ii1=ilmax(1) ; ij1=ilmax(2)
              ii2=ilmin(1) ; ij2=ilmin(2)
              lflag = lchkflag()
              PRINT 9002, jt, iimin, iimin, rlon(1,ii1),ii1+ijmin -1,rlat(1,ii1),ij1+ikmin-1, h(ij1+ikmin-1), v2d(ii1,ij1)*rfact, &
                   &             iimin, rlon(1,ii2),ii2+ijmin -1,rlat(1,ii2),ij2+ikmin-1, h(ij2+ikmin-1), v2d(ii2,ij2)*rfact
           END DO
           EXIT
        CASE DEFAULT
           PRINT *,' Non mapable variables x-z or y-z :('
           cv_in='none'
        END SELECT

     CASE (3)
        SELECT CASE (ndim)
        CASE( 4 )  ! assume x,y,z,t variable
           PRINT 9000,' time j-slab  MAX:   i    long   j    lat   k     dep    MaxValue    MIN:  i    &
                & long   j     lat   k     dep    MinValue'
           DO jt=itmin, itmax
              v2d(:,:) = getvarxz(cf_in, cv_in, ijmin, niz, nkz, iimin, ikmin, ktime=jt)
              ilmax = MAXLOC(v2d,(v2d /= zspval) )
              ilmin = MINLOC(v2d,(v2d /= zspval) )
              ii1=ilmax(1) ; ij1=ilmax(2)
              ii2=ilmin(1) ; ij2=ilmin(2)
              lflag = lchkflag()
              PRINT 9002, jt, ijmin, ii1, rlon(ii1,1),ijmin,rlat(ii1,1),ij1+ikmin-1, h(ij1+ikmin-1), v2d(ii1,ij1)*rfact, &
                   &             ii2, rlon(ii2,1),ijmin,rlat(ii2,1),ij2+ikmin-1, h(ij2+ikmin-1), v2d(ii2,ij2)*rfact
           END DO
           EXIT
        CASE DEFAULT
           PRINT *,' Non mapable variables x-z or y-z :('
           cv_in='none'
        END SELECT

     CASE DEFAULT
        PRINT *,' ntype = ',ntype, '  is not defined ' ; STOP 99
     END SELECT ! ntype
  ENDDO

9000 FORMAT(a)
9002 FORMAT(I5, x,i4,9x, i5,f8.2, i5, f7.2, i5, f8.2, e14.5, 6x, i5,f8.2, i5, f7.2, i5, f8.2, e14.5 )
9003 FORMAT(I5, x,i5,1x,f7.2,5x,i5,f8.2, i5, f7.2, e14.5, 5x,i5,f8.2, i5, f7.2, e14.5)

CONTAINS
   LOGICAL FUNCTION lchkflag()
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION lchkflag  ***
    !!
    !! ** Purpose :  Set flag to true when all data are missing. 
    !!
    !! ** Method  :  When all data are missing, MAXLOC or MINLOC return 0 index
    !!               which cannot be used in v2d, or any other array.
    !!               In this case, faulty indices are set to 1,1 and 1,2 and
    !!               corresponding v2d is set to a flag value 999999999.999
    !!               REM: the return value is T or F, btw not used in the code.
    !!----------------------------------------------------------------------

    lflag=.false.
    IF ( ii1 == 0 ) THEN ; ii1=1 ; lflag=.true. ; ENDIF
    IF ( ii2 == 0 ) THEN ; ii2=1 ; lflag=.true. ; ENDIF
    IF ( ij1 == 0 ) THEN ; ij1=1 ; lflag=.true. ; ENDIF
    IF ( ij2 == 0 ) THEN ; ij2=2 ; lflag=.true. ; ENDIF
    IF ( lflag ) v2d(ii1,ij1)=-999999999.999
    IF ( lflag ) v2d(ii2,ij2)=+999999999.999
    lchkflag = lflag
   END FUNCTION lchkflag

END PROGRAM cdfmax

PROGRAM cdf_conv_zgr
  !!======================================================================
  !!                     ***  PROGRAM  cdf_conv_zgr  ***
  !!=====================================================================
  !!  ** Purpose : Convert mesh_zgr file from 3.0 Mercator style to 
  !!               3.6 Drakkar style.
  !!
  !!  ** Method  : Mercator style use 2D e3t_ps and e3w_ps + 1d e3t_0, e3w_0
  !!               Drakkar style use 3D e3t_0, e3u_0 e3v_0 e3w_0 + all
  !!               standard features of standard 3.6 ( It corresponds to
  !!               mesh creation with nn_msh=6 in NEMO namelist).
  !!
  !!  ** Remark  : This code is not using cdfio module and has netcdf 
  !!               primitive directly on it...
  !!
  !! History :  4.0  : 10/2018  : J.M. Molines : 
  !!----------------------------------------------------------------------

  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2018
  !! $Id$
  !! Copyright (c) 2012, J.-M. Molines
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class file_operations
  !!----------------------------------------------------------------------
  USE netcdf
  IMPLICIT NONE

  INTEGER(KIND=4) ::  ji,jj,jk
  INTEGER(KIND=4) :: narg, ijarg, icky
  INTEGER(KIND=4) :: ncid, id, ierr, ik
  INTEGER(KIND=4) :: ncido
  INTEGER(KIND=4) :: id_lon, id_lat, id_lev, id_tim
  INTEGER(KIND=4) :: id_mbt, id_hdt, id_hdw, id_gdt, id_gdw
  INTEGER(KIND=4) :: id_e3t1d, id_e3w1d
  INTEGER(KIND=4) :: idx, idy, idz, idt
  INTEGER(KIND=4) :: id_e3t, id_e3u, id_e3v, id_e3w
  INTEGER(KIND=4) :: npiglo, npjglo, npk, npt
  INTEGER(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: mbathy

  REAL(KIND=8), DIMENSION(:,:,:), ALLOCATABLE :: e3t, e3x,e3w
  REAL(KIND=8), DIMENSION(:,:),   ALLOCATABLE :: e3t_ps, e3w_ps, v2d
  REAL(KIND=8), DIMENSION(:),     ALLOCATABLE :: e3t_1d, e3w_1d, v1d, v1dt

  CHARACTER(LEN=80) :: cf_zgr_in
  CHARACTER(LEN=80) :: cf_zgr_out
  CHARACTER(LEN=80) :: cldum

  LOGICAL           :: lnc4=.FALSE.
  !!----------------------------------------------------------------------

  narg=iargc() 
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdf_conv_zgr -i <IN-file> -o <OUT-file> [-nc4] '
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Convert mesh_zgr files whith 2D +1D variables, into a full 3D '
     PRINT *,'       mesh_zgr file compliant with NEMO_3.6 format (names)' 
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'        -i IN-file : name of the input mesh_zgr file to convert.'
     PRINT *,'        -o OUT-file : name of the resulting converted mesh_zgr.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'        -nc4 : use netcdf4 with chunking and compression'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'         none'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'         Output file name is specified on the command line.'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'      ' 
     STOP
  ENDIF

  ijarg = 1 
  DO WHILE ( ijarg <= narg )
     CALL getarg(ijarg, cldum ) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-i'   ) ; CALL getarg(ijarg, cf_zgr_in  ) ; ijarg=ijarg+1
     CASE ( '-o'   ) ; CALL getarg(ijarg, cf_zgr_out ) ; ijarg=ijarg+1
        ! option
     CASE ( '-nc4' ) ; lnc4 = .TRUE.
     CASE DEFAULT    ; PRINT *, ' ERROR : ', TRIM(cldum),' : unknown option.'; STOP 1
     END SELECT
  ENDDO

  ! open file
  ierr=NF90_OPEN(cf_zgr_in, NF90_NOWRITE, ncid)
  ! read dimensions
  ierr=NF90_INQ_DIMID(ncid,"x",id) ; ierr=NF90_INQUIRE_DIMENSION(ncid,id,len=npiglo)
  ierr=NF90_INQ_DIMID(ncid,"y",id) ; ierr=NF90_INQUIRE_DIMENSION(ncid,id,len=npjglo)
  ierr=NF90_INQ_DIMID(ncid,"z",id) ; ierr=NF90_INQUIRE_DIMENSION(ncid,id,len=npk)
  ierr=NF90_INQ_DIMID(ncid,"t",id) ; ierr=NF90_INQUIRE_DIMENSION(ncid,id,len=npt)

  ! allocate space
  ALLOCATE( e3t(npiglo, npjglo, npk), e3x(npiglo, npjglo, npk) )
  ALLOCATE( e3w(npiglo, npjglo, npk) )
  ALLOCATE( e3t_ps(npiglo, npjglo) , mbathy(npiglo, npjglo),e3w_ps(npiglo, npjglo), v2d(npiglo, npjglo))
  ALLOCATE( e3t_1d(npk), e3w_1d(npk), v1d(npk), v1dt(npt) )

  ! read e3t_ps
  ierr=NF90_INQ_VARID(ncid,"e3t_ps",id) ; ierr=NF90_GET_VAR(ncid, id, e3t_ps,start=(/1,1,1/), count=(/npiglo,npjglo,1/) )
  PRINT * ,NF90_STRERROR(ierr)
  ! read e3w_ps
  ierr=NF90_INQ_VARID(ncid,"e3w_ps",id) ; ierr=NF90_GET_VAR(ncid, id, e3w_ps,start=(/1,1,1/), count=(/npiglo,npjglo,1/) )
  PRINT * ,NF90_STRERROR(ierr)
  ! read e3t_1d
  ierr=NF90_INQ_VARID(ncid,"e3t_0",id) ; ierr=NF90_GET_VAR(ncid, id, e3t_1d,start=(/1,1/), count=(/npk,1/) )
  PRINT * ,NF90_STRERROR(ierr), e3t_1d
  ! read e3w_1d
  ierr=NF90_INQ_VARID(ncid,"e3w_0",id) ; ierr=NF90_GET_VAR(ncid, id, e3w_1d,start=(/1,1/), count=(/npk,1/) )
  PRINT * ,NF90_STRERROR(ierr), e3w_1d
  ! read mbathy : give the k-index for the last point in the sea
  ierr=NF90_INQ_VARID(ncid,"mbathy",id) ; ierr=NF90_GET_VAR(ncid, id, mbathy,start=(/1,1,1/), count=(/npiglo,npjglo,1/) )
  PRINT * ,NF90_STRERROR(ierr), MAXVAL(mbathy)

  ! open the output file
#if defined key_netcdf4
  IF ( lnc4 ) THEN
     ierr=NF90_CREATE(cf_zgr_out,cmode=or(NF90_CLOBBER,NF90_NETCDF4     ), ncid=ncido)
  ELSE
     ierr=NF90_CREATE(cf_zgr_out,cmode=or(NF90_CLOBBER,NF90_64BIT_OFFSET), ncid=ncido)
  ENDIF
#else
  ierr=NF90_CREATE(cf_zgr_out,cmode=or(NF90_CLOBBER,NF90_64BIT_OFFSET), ncid=ncido)
#endif
  ierr=NF90_DEF_DIM(ncido,"x",npiglo, idx)
  ierr=NF90_DEF_DIM(ncido,"y",npjglo, idy)
  ierr=NF90_DEF_DIM(ncido,"z",npk, idz)
  ierr=NF90_DEF_DIM(ncido,"t",NF90_UNLIMITED, idt)

#if defined key_netcdf4
  IF ( lnc4 ) THEN
     ierr=NF90_DEF_VAR(ncido,"nav_lon",NF90_FLOAT,(/idx,idy/), id_lon,chunksizes=(/npiglo,1/),deflate_level=1 )
     ierr=NF90_DEF_VAR(ncido,"nav_lat",NF90_FLOAT,(/idx,idy/), id_lat,chunksizes=(/npiglo,1/),deflate_level=1 )
     ierr=NF90_DEF_VAR(ncido,"nav_lev",NF90_FLOAT,(/idz/)    , id_lev)
     ierr=NF90_DEF_VAR(ncido,"time_counter",NF90_DOUBLE,(/idt/), id_tim)
     !
     icky=MAX(npiglo/30,10)
     ierr=NF90_DEF_VAR(ncido,"e3t_0",NF90_DOUBLE,(/idx,idy,idz,idt/), id_e3t,chunksizes=(/npiglo,icky,1,1/),deflate_level=1 )
     ierr=NF90_DEF_VAR(ncido,"e3u_0",NF90_DOUBLE,(/idx,idy,idz,idt/), id_e3u,chunksizes=(/npiglo,icky,1,1/),deflate_level=1 )
     ierr=NF90_DEF_VAR(ncido,"e3v_0",NF90_DOUBLE,(/idx,idy,idz,idt/), id_e3v,chunksizes=(/npiglo,icky,1,1/),deflate_level=1 )
     ierr=NF90_DEF_VAR(ncido,"e3w_0",NF90_DOUBLE,(/idx,idy,idz,idt/), id_e3w,chunksizes=(/npiglo,icky,1,1/),deflate_level=1 )
     ierr=NF90_DEF_VAR(ncido,"mbathy",NF90_SHORT,(/idx,idy,idt/)    , id_mbt,chunksizes=(/npiglo,icky,1/)  ,deflate_level=1 )
     ierr=NF90_DEF_VAR(ncido,"hdept",NF90_FLOAT,(/idx,idy,idt/)     , id_hdt,chunksizes=(/npiglo,icky,1/)  ,deflate_level=1 )
     ierr=NF90_DEF_VAR(ncido,"hdepw",NF90_FLOAT,(/idx,idy,idt/)     , id_hdw,chunksizes=(/npiglo,icky,1/)  ,deflate_level=1 )
     ierr=NF90_DEF_VAR(ncido,"gdept_1d",NF90_DOUBLE,(/idz,idt/)     , id_gdt)
     ierr=NF90_DEF_VAR(ncido,"gdepw_1d",NF90_DOUBLE,(/idz,idt/)     , id_gdw)
     ierr=NF90_DEF_VAR(ncido,"e3t_1d",NF90_DOUBLE,(/idz,idt/)       , id_e3t1d)
     ierr=NF90_DEF_VAR(ncido,"e3w_1d",NF90_DOUBLE,(/idz,idt/)       , id_e3w1d)
  ELSE
     ierr=NF90_DEF_VAR(ncido,"nav_lon",NF90_FLOAT,(/idx,idy/), id_lon)
     ierr=NF90_DEF_VAR(ncido,"nav_lat",NF90_FLOAT,(/idx,idy/), id_lat)
     ierr=NF90_DEF_VAR(ncido,"nav_lev",NF90_FLOAT,(/idz/)    , id_lev)
     ierr=NF90_DEF_VAR(ncido,"time_counter",NF90_DOUBLE,(/idt/), id_tim)
     !
     ierr=NF90_DEF_VAR(ncido,"e3t_0",NF90_DOUBLE,(/idx,idy,idz,idt/), id_e3t)
     ierr=NF90_DEF_VAR(ncido,"e3u_0",NF90_DOUBLE,(/idx,idy,idz,idt/), id_e3u)
     ierr=NF90_DEF_VAR(ncido,"e3v_0",NF90_DOUBLE,(/idx,idy,idz,idt/), id_e3v)
     ierr=NF90_DEF_VAR(ncido,"e3w_0",NF90_DOUBLE,(/idx,idy,idz,idt/), id_e3w)
     ierr=NF90_DEF_VAR(ncido,"mbathy",NF90_SHORT,(/idx,idy,idt/), id_mbt)
     ierr=NF90_DEF_VAR(ncido,"hdept",NF90_FLOAT,(/idx,idy,idt/), id_hdt)
     ierr=NF90_DEF_VAR(ncido,"hdepw",NF90_FLOAT,(/idx,idy,idt/), id_hdw)
     ierr=NF90_DEF_VAR(ncido,"gdept_1d",NF90_DOUBLE,(/idz,idt/), id_gdt)
     ierr=NF90_DEF_VAR(ncido,"gdepw_1d",NF90_DOUBLE,(/idz,idt/), id_gdw)
     ierr=NF90_DEF_VAR(ncido,"e3t_1d",NF90_DOUBLE,(/idz,idt/), id_e3t1d)
     ierr=NF90_DEF_VAR(ncido,"e3w_1d",NF90_DOUBLE,(/idz,idt/), id_e3w1d)
  ENDIF
#else
  ierr=NF90_DEF_VAR(ncido,"nav_lon",NF90_FLOAT,(/idx,idy/), id_lon)
  ierr=NF90_DEF_VAR(ncido,"nav_lat",NF90_FLOAT,(/idx,idy/), id_lat)
  ierr=NF90_DEF_VAR(ncido,"nav_lev",NF90_FLOAT,(/idz/)    , id_lev)
  ierr=NF90_DEF_VAR(ncido,"time_counter",NF90_DOUBLE,(/idt/), id_tim)
  !
  ierr=NF90_DEF_VAR(ncido,"e3t_0",NF90_DOUBLE,(/idx,idy,idz,idt/), id_e3t)
  ierr=NF90_DEF_VAR(ncido,"e3u_0",NF90_DOUBLE,(/idx,idy,idz,idt/), id_e3u)
  ierr=NF90_DEF_VAR(ncido,"e3v_0",NF90_DOUBLE,(/idx,idy,idz,idt/), id_e3v)
  ierr=NF90_DEF_VAR(ncido,"e3w_0",NF90_DOUBLE,(/idx,idy,idz,idt/), id_e3w)
  ierr=NF90_DEF_VAR(ncido,"mbathy",NF90_SHORT,(/idx,idy,idt/), id_mbt)
  ierr=NF90_DEF_VAR(ncido,"hdept",NF90_FLOAT,(/idx,idy,idt/), id_hdt)
  ierr=NF90_DEF_VAR(ncido,"hdepw",NF90_FLOAT,(/idx,idy,idt/), id_hdw)
  ierr=NF90_DEF_VAR(ncido,"gdept_1d",NF90_DOUBLE,(/idz,idt/), id_gdt)
  ierr=NF90_DEF_VAR(ncido,"gdepw_1d",NF90_DOUBLE,(/idz,idt/), id_gdw)
  ierr=NF90_DEF_VAR(ncido,"e3t_1d",NF90_DOUBLE,(/idz,idt/), id_e3t1d)
  ierr=NF90_DEF_VAR(ncido,"e3w_1d",NF90_DOUBLE,(/idz,idt/), id_e3w1d)
#endif
  ierr=NF90_ENDDEF(ncido)

  ! fill the dimension variables :

  ierr=NF90_INQ_VARID(ncid,"nav_lon",id) ; ierr=NF90_GET_VAR(ncid,id,v2d) ; ierr=NF90_PUT_VAR(ncido,id_lon,v2d)
  ierr=NF90_INQ_VARID(ncid,"nav_lat",id) ; ierr=NF90_GET_VAR(ncid,id,v2d) ; ierr=NF90_PUT_VAR(ncido,id_lat,v2d)
  ierr=NF90_INQ_VARID(ncid,"nav_lev",id) ; ierr=NF90_GET_VAR(ncid,id,v1d) ; ierr=NF90_PUT_VAR(ncido,id_lev,v1d)
  ierr=NF90_INQ_VARID(ncid,"time_counter",id) ; ierr=NF90_GET_VAR(ncid,id,v1dt) ; ierr=NF90_PUT_VAR(ncido,id_tim,v1dt)

  ! now depth and metrics
  ierr=NF90_INQ_VARID(ncid,"hdept",id) ; ierr=NF90_GET_VAR(ncid,id,     v2d,start=(/1,1,1/), count=(/npiglo,npjglo,1/) ) 
  ;                                    ; ierr=NF90_PUT_VAR(ncido,id_hdt,v2d,start=(/1,1,1/), count=(/npiglo,npjglo,1/) )
  ierr=NF90_INQ_VARID(ncid,"hdepw",id) ; ierr=NF90_GET_VAR(ncid,id,     v2d,start=(/1,1,1/), count=(/npiglo,npjglo,1/) ) 
  ;                                    ; ierr=NF90_PUT_VAR(ncido,id_hdw,v2d,start=(/1,1,1/), count=(/npiglo,npjglo,1/) )

  ierr=NF90_INQ_VARID(ncid,"gdept_0",id) ; ierr=NF90_GET_VAR(ncid,id,     v1d,start=(/1,1/), count=(/npk,1/) ) 
  ;                                      ; ierr=NF90_PUT_VAR(ncido,id_gdt,v1d,start=(/1,1/), count=(/npk,1/) )
  ierr=NF90_INQ_VARID(ncid,"gdepw_0",id) ; ierr=NF90_GET_VAR(ncid,id,     v1d,start=(/1,1/), count=(/npk,1/) ) 
  ;                                      ; ierr=NF90_PUT_VAR(ncido,id_gdw,v1d,start=(/1,1/), count=(/npk,1/) )

  ierr=NF90_INQ_VARID(ncid,"e3t_0",id) ; ierr=NF90_GET_VAR(ncid,id,       v1d,start=(/1,1/), count=(/npk,1/) ) 
  ;                                    ; ierr=NF90_PUT_VAR(ncido,id_e3t1d,v1d,start=(/1,1/), count=(/npk,1/) )
  ierr=NF90_INQ_VARID(ncid,"e3w_0",id) ; ierr=NF90_GET_VAR(ncid,id,       v1d,start=(/1,1/), count=(/npk,1/) ) 
  ;                                    ; ierr=NF90_PUT_VAR(ncido,id_e3w1d,v1d,start=(/1,1/), count=(/npk,1/) )

  ierr=NF90_PUT_VAR(ncido,id_mbt, mbathy, start=(/1,1,1/), count=(/npiglo,npjglo,1/) )

  ! build the 3d e3t
  ! 1 init
  DO jk=1,npk
     e3t(:,:,jk) = e3t_1d(jk)
  ENDDO
  ! 2 ps
  DO jj=1,npjglo
     DO ji=1,npiglo
        ik=MAX(mbathy(ji,jj),1)
        e3t(ji,jj,ik)=MAX(e3t_ps(ji,jj),e3t_1d(1))
     ENDDO
  ENDDO
  ierr=NF90_PUT_VAR(ncido,id_e3t,e3t,start=(/1,1,1,1/), count=(/npiglo,npjglo, npk,1/) )
  ! Now build e3u 
  e3x=100.d0
  DO jk=1, npk
     DO jj=1,npjglo
        DO ji=1, npiglo-1
           e3x(ji,jj,jk) = MIN(e3t(ji,jj,jk), e3t(ji+1,jj,jk))
        ENDDO
     ENDDO
  ENDDO
  ! putvar ...
  ierr=NF90_PUT_VAR(ncido,id_e3u,e3x,start=(/1,1,1,1/), count=(/npiglo,npjglo, npk,1/) )

  ! Now build e3v 
  e3x=100.d0
  DO jk=1, npk
     DO jj=1,npjglo-1
        DO ji=1, npiglo
           e3x(ji,jj,jk) = MIN(e3t(ji,jj,jk), e3t(ji,jj+1,jk))
        ENDDO
     ENDDO
  ENDDO

  ! putvar ...
  ierr=NF90_PUT_VAR(ncido,id_e3v,e3x,start=(/1,1,1,1/), count=(/npiglo,npjglo, npk,1/) )

  ! build the 3d e3w
  ! 1 init
  DO jk=1,npk
     e3w(:,:,jk) = e3w_1d(jk)
  ENDDO
  ! 2 ps
  DO jj=1,npjglo
     DO ji=1,npiglo
        ik=MAX(mbathy(ji,jj),1)
        e3w(ji,jj,ik)=MAX(e3w_ps(ji,jj),e3w_1d(1))
     ENDDO
  ENDDO
  ierr=NF90_PUT_VAR(ncido,id_e3w,e3w,start=(/1,1,1,1/), count=(/npiglo,npjglo, npk,1/) )

  ierr=NF90_CLOSE(ncido)
  ierr=NF90_CLOSE(ncid)


END PROGRAM cdf_conv_zgr

PROGRAM cdficb_clv
  !!======================================================================
  !!                     ***  PROGRAM  cdficb_clv  ***
  !!=====================================================================
  !!  ** Purpose : Prepare netcdf iceberg calving file
  !!
  !!  ** Method  : generate random disctribution along ice shelf front 
  !!               then scale it
  !!
  !! History : 4.0  : 04/2020  : P.Mathiot 
  !!----------------------------------------------------------------------
  !!----------------------------------------------------------------------
  USE cdfio 
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id: cdficb_rnf.f90 668 2013-05-30 12:54:00Z molines $
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class ice_shelf_processing
  !!-----------------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                               :: jicb, ji, jj       ! dummy loop index
  INTEGER(KIND=4)                               :: ierr               ! working integer
  INTEGER(KIND=4)                               :: narg, iargc, ijarg ! browsing command line
  INTEGER(KIND=4)                               :: npiglo, npjglo, npk! size of the domain
  INTEGER(KIND=4)                               :: nicb               ! number of ice shelves
  INTEGER(KIND=4)                               :: iunit=10           ! id file
  INTEGER(KIND=4)                               :: ncout              ! ncid of output files
  INTEGER(KIND=4)                               :: ifill
  INTEGER(KIND=4)                               :: iiseed, ijseed     ! position of a point within ice shelf (not used here)
  INTEGER(KIND=4)                               :: ijmin, ijmax       ! j-limits of a particular ice shelf
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: ipk                ! arrays of vertical level for each var
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: id_varout          ! varid's of average vars
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: isum               ! zonal sum of icb index for optim
  INTEGER(KIND=2), DIMENSION(:,:),  ALLOCATABLE :: icbindex, icbmask  ! 
  INTEGER(KIND=2), DIMENSION(:,:),  ALLOCATABLE :: icbindex_wk        !
  INTEGER(KIND=4), DIMENSION(:),    ALLOCATABLE :: iseed
  INTEGER(KIND=4)                               :: nseed              ! size of seed array
  INTEGER(KIND=4)                               :: irdsf              ! seed scale factor

  REAL(KIND=4)                                  :: rdraftmax, rdraftmin ! dummy information in input file
  REAL(KIND=4)                                  :: rlon, rlat         ! dummy information in input file
  REAL(KIND=4), DIMENSION(:,:),     ALLOCATABLE :: bathy, zdrft       ! bathymetry and ice shelf draft

  REAL(KIND=8)                                  :: dfwf, dclv, dclv_tot
  REAL(KIND=8)                                  :: dsumcoef
  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: dl_icbclv2d
  REAL(KIND=8), DIMENSION(:,:),     ALLOCATABLE :: dicbclv2d

  !                                                FILES
  CHARACTER(LEN=256)                            :: cf_fill            ! input file names
  CHARACTER(LEN=256)                            :: cf_icblist         ! input file names
  CHARACTER(LEN=256)                            :: cf_bathy='bathy.nc'! bathymetry file name
  CHARACTER(LEN=256)                            :: cf_isfdr='isf_draft.nc'! ice_draft file name
  CHARACTER(LEN=256)                            :: cf_out='icbcalv.nc'! output file for average
  !                                                VARIABLES
  CHARACTER(LEN=256)                            :: cv_fill            ! fill var name
  CHARACTER(LEN=256)                            :: cv_bathy='Bathymetry' ! bathymetry name
  CHARACTER(LEN=256)                            :: cv_isfdr='isf_draft'  ! ice shelf draft name
  CHARACTER(LEN=256)                            :: cldum              ! dummy string argument

  TYPE (variable), DIMENSION(:),    ALLOCATABLE :: stypvar            ! attributes for average values

  LOGICAL                                       :: lchk    = .FALSE.  ! flag for missing files
  LOGICAL                                       :: lnc4    = .FALSE.  ! flag for netcdf4 chunking and deflation
  LOGICAL                                       :: lperio  = .FALSE.  !
  LOGICAL                                       :: ltot    = .FALSE.  !
  !!----------------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()

  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdficb_clv -f ISF-fill-file -v ISF-fill-var -l ISF-listfile '
     PRINT *,'    [-b BATHY-file] [-vb BATHY-var] [-i ISFDRAFT-file] [-vi ISFDRAFT-variable]'
     PRINT *,'    [-s irdsf] [-st] [-nc4] [-o OUT-file ]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'        Build a netcdf calving file, for use in NEMO ICB module.'
     PRINT *,'      '
     PRINT *,'        This file hold the 2D  calving rate field (km3/year) at points located'
     PRINT *,'        along the ice shelves edge. In this program, all points along a given'
     PRINT *,'        iceshelf contribute to the calving.  The total calving rate for a given' 
     PRINT *,'        iceshelf is randomly spread over the calving points.'
     PRINT *,'      '
     PRINT *,'        Optionally, [-st], the overall calving rate can be scaled to match'
     PRINT *,'        observational estimates.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'        -f ISF-fill-file : file built by cdffill (all the ice shelves are'
     PRINT *,'                           tagged with an id)'
     PRINT *,'        -v ISF-fill_var  : name of fill variable to use in ISF-fill_file'
     PRINT *,'        -l ISF-list : Text file with the calving rate (GT/y) given for'
     PRINT *,'                      each ice shelf.' 
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'        -s irdsf : seed random scale factor (seed = irdsf * ifill) '
     PRINT *,'               This is a way to change the seed for the random number generator'
     PRINT *,'               [ default : 1 ]'
     PRINT *,'        -b BATHY-file : give name of bathy file.'
     PRINT *,'                    [ default : ',TRIM(cf_bathy),' ]'
     PRINT *,'        -vb BATHY-var : give name of bathy variable.'
     PRINT *,'                    [ default : ',TRIM(cv_bathy),' ]'
     PRINT *,'        -i ISFDRAFT-file : give name of isf_draft file.'
     PRINT *,'                      [ default : ',TRIM(cf_isfdr),' ]'
     PRINT *,'        -vi ISFDRAFT-var : give name of isf_draft variable.'
     PRINT *,'                      [ default : ',TRIM(cv_isfdr),' ]'
     PRINT *,'        -st : scale to total iceberg calving all at the end'
     PRINT *,'                to include calving from front unresolved ice shelves'
     PRINT *,'        -nc4 : Use this option to have netcdf4 output file, with chunking'
     PRINT *,'               and deflation.'
     PRINT *,'        -o OUT-file : Specify the name of the output file instead of '
     PRINT *,'               the default name ',TRIM(cf_out)
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ',TRIM(cn_fhgr),' and all files specified on the command line' 
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) ,' unless -o option used'
     PRINT *,'         variables : soicbclv (km3/y)'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'       cdfisb_fill'
     PRINT *,'      '
     STOP 
  ENDIF

  ijarg=1
  DO WHILE ( ijarg <= narg )
     CALL getarg(ijarg,cldum) ; ijarg=ijarg+1
     SELECT CASE (cldum)
     CASE ('-f' ) ; CALL getarg(ijarg,cf_fill   ) ; ijarg=ijarg+1
     CASE ('-v' ) ; CALL getarg(ijarg,cv_fill   ) ; ijarg=ijarg+1
     CASE ('-l' ) ; CALL getarg(ijarg,cf_icblist) ; ijarg=ijarg+1
     CASE ('-s' ) ; CALL getarg(ijarg,cldum     ) ; ijarg=ijarg+1 ; READ(cldum,*) irdsf
     CASE ('-b' ) ; CALL getarg(ijarg,cf_bathy  ) ; ijarg=ijarg+1
     CASE ('-vb') ; CALL getarg(ijarg,cv_bathy  ) ; ijarg=ijarg+1
     CASE ('-i' ) ; CALL getarg(ijarg,cf_isfdr  ) ; ijarg=ijarg+1
     CASE ('-vi') ; CALL getarg(ijarg,cv_isfdr  ) ; ijarg=ijarg+1
     CASE ('-nc4'); lnc4   = .TRUE.
     CASE ('-ew' ); lperio = .TRUE.
     CASE ('-st' ); ltot   = .TRUE.
     CASE ('-o' ) ; CALL getarg(ijarg,cf_out    ) ; ijarg=ijarg+1
     CASE DEFAULT ; PRINT *,' ERROR : ',TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  ENDDO

  lchk = lchk .OR. chkfile (cf_fill   )
  lchk = lchk .OR. chkfile (cf_icblist)
  lchk = lchk .OR. chkfile (cf_bathy  )
  lchk = lchk .OR. chkfile (cf_isfdr  )
  lchk = lchk .OR. chkfile (cn_fhgr   )

  IF ( lchk ) STOP 99 ! missing file

  npiglo = getdim (cf_fill, cn_x)
  npjglo = getdim (cf_fill, cn_y)
  npk    = 0                  ! bathy file has no dep dimension

  PRINT *, 'NPIGLO = ', npiglo
  PRINT *, 'NPJGLO = ', npjglo
  PRINT *, 'NPK    = ', npk

  ALLOCATE(icbindex (npiglo, npjglo), icbmask    (npiglo, npjglo))
  ALLOCATE(icbindex_wk(npiglo, npjglo), isum(npjglo))

  ALLOCATE(bathy    (npiglo, npjglo), zdrft      (npiglo, npjglo))

  ALLOCATE(dicbclv2d(npiglo, npjglo), dl_icbclv2d(npiglo, npjglo))

  ALLOCATE (stypvar(1))
  ALLOCATE (ipk(1),id_varout(1))

  CALL CreateOutput

  ! define variable
  ! read ice shelf draft data
  icbindex(:,:) = getvar(cf_fill,  cv_fill,  1 ,npiglo, npjglo )  ! fill index
  bathy(:,:)    = getvar(cf_bathy, cv_bathy, 1, npiglo, npjglo )  ! ocean bathy
  zdrft(:,:)    = getvar(cf_isfdr, cv_isfdr, 1, npiglo, npjglo )  ! ice shelf draft

!  ! sanity check
!  zdrft = MIN(zdrft,bathy)

  ! open icb file
  OPEN(unit=iunit, file=cf_icblist, form='formatted', status='old')
  ! get number of icb
  nicb = 0
  cldum='XXX'
  DO WHILE ( TRIM(cldum) /= 'EOF')
     READ(iunit,*) cldum
     nicb=nicb+1
  END DO
  REWIND(iunit)
  nicb = nicb - 1

  PRINT *, '   Number of ISF found in file list : ', nicb

  CALL RANDOM_SEED(SIZE=nseed)
  ALLOCATE(iseed(nseed))
  dicbclv2d = 0.0
  DO jicb=1,nicb-1
     ! reset working icb index to its initial value
     icbindex_wk(:,:) = icbindex(:,:)

     ! read ice shelf data for jsf
     READ(iunit,*) ifill,cldum,rlon, rlat, iiseed, ijseed ,rdraftmin, rdraftmax, dfwf, dclv

     icbmask  (:,:) = 0
     dl_icbclv2d(:,:) = 0.0d0
     dsumcoef       = 0.0d0

     ! only deal with current ice shelf
     WHERE (icbindex_wk /=  -ifill ) icbindex_wk = 0

     ! find the j-limits for the current ice shelf 
     isum(:)=SUM(icbindex_wk,dim=1)
     ijmin = npjglo ; ijmax=2
     DO jj=npjglo, 3, -1
        IF ( isum(jj) /= 0 ) THEN
           ijmin=jj
        ENDIF
     ENDDO
     DO jj=1, npjglo-2
        IF ( isum(jj) /= 0 ) THEN
           ijmax=jj
        ENDIF
     ENDDO

     iseed = ifill * irdsf
     CALL RANDOM_SEED(PUT=iseed)
     DO ji=2,npiglo-1
        DO jj = ijmin-1, ijmax+1
           IF ( zdrft(ji,jj) == 0 .AND.  &                                          ! not under ice_shelf
                &    bathy(ji,jj) /= 0 .AND.  &                                     ! but in the ocean
                &    MINVAL(icbindex_wk(ji-1:ji+1 , jj-1:jj+1)) == -ifill  .AND. &  ! adjacent to the correct icb
                &    icbindex_wk(ji,jj) == 0                               .AND. &  ! 
                &    icbmask(ji,jj)     == 0       ) THEN                           ! not filled yet
                ! case ice shelf in pultiple part in txt list
                ! WHY, should not be needed dicbclv2d(ji,jj) = 0.0
                CALL RANDOM_NUMBER(dl_icbclv2d(ji,jj))
                dsumcoef = dsumcoef + dl_icbclv2d(ji,jj)
                icbmask(ji,jj) = 1
           END IF
        END DO
     END DO

     IF ( SUM(icbmask) == 0 .AND. ifill < 99) THEN
        PRINT *, 'E R R O R : this ice shelf ',ifill, ' do not have sea access and so cannot calve'
        STOP
     END IF

     WHERE (icbmask == 1)
        dl_icbclv2d = dl_icbclv2d / dsumcoef * dclv
     END WHERE

     PRINT *, TRIM(cldum),' calving is : ',SUM(dl_icbclv2d)

     dicbclv2d = dicbclv2d + dl_icbclv2d

  END DO

  ! scale to the total ice berg calving
  IF ( ltot ) THEN
     READ(iunit,*) ifill,cldum,rlon, rlat, iiseed, ijseed ,rdraftmin, rdraftmax, dfwf, dclv_tot
     IF (ifill /= 99) THEN
        PRINT *, 'last iceberg line must be -99 TOTA ....'
        STOP 42
     END IF
     dicbclv2d = dicbclv2d * dclv_tot / SUM(dicbclv2d)     
  END IF

  ! Diagnose total amount of fwf
  PRINT *, 'diag : '
  PRINT *, 'total sum of icb (Gt/y) = ', SUM(dicbclv2d(2:npiglo-1,2:npjglo-1))

  ! convertion of Gt/y in km3/y (icb density 850 (NEMO default))
  dicbclv2d = dicbclv2d*1.d+3/850.d0
  IF ( lperio ) THEN 
     dicbclv2d(npiglo,:) = dicbclv2d(2       ,:)
     dicbclv2d(1     ,:) = dicbclv2d(npiglo-1,:)
  ENDIF

  ierr = putvar(ncout, id_varout(1), dicbclv2d, 1, npiglo, npjglo)

  ierr = closeout(ncout)

CONTAINS

  SUBROUTINE CreateOutput 
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create output netcdf output file using cdfio 
    !!              We use a routine just to increase readability
    !! ** Method  :  Use global variables to know about the file to be created
    !!           
    !!----------------------------------------------------------------------
    REAL(KIND=8), DIMENSION(1) :: dl_tim
    !!----------------------------------------------------------------------

    ! define new variables for output
    stypvar(1)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(1)%cname             = 'soicbclv'
    stypvar(1)%rmissing_value    =  -99.d0
    stypvar(1)%valid_min         =  0.
    stypvar(1)%valid_max         =  2000.
    stypvar(1)%clong_name        = 'icberg calving'
    stypvar(1)%cshort_name       = 'soicbclv'
    stypvar(1)%conline_operation = 'N/A'
    stypvar(1)%caxis             = 'TYX'
    stypvar(1)%cprecision        = 'r8'
    stypvar(1)%cunits             = 'km3/y'
    ipk(1) = 1  !  2D

    ! create output file taking the sizes in cf_fill
    ncout  = create      (cf_out, cf_fill,   npiglo, npjglo, npk,  ld_nc4=lnc4)
    ierr   = createvar   (ncout,  stypvar, 1,   ipk, id_varout  ,  ld_nc4=lnc4)
    ierr   = putheadervar(ncout,  cf_fill,   npiglo, npjglo, npk              )

    dl_tim(1) = 0.d0
    ierr = putvar1d(ncout, dl_tim, 1, 'T') 

  END SUBROUTINE CreateOutput

END PROGRAM cdficb_clv

PROGRAM cdfsigntr
  !!======================================================================
  !!                     ***  PROGRAM  cdfsigntr  ***
  !!=====================================================================
  !!  ** Purpose : Compute ntr volumic mass 3D field from gridT file
  !!               Store the results on a 'similar' cdf file.
  !!
  !!  ** Method  : Use Mc Dougall Jackett EOS (2005)
  !!
  !! History : 3.0  : 06/2013  : J.M. Molines from G. Madec idl code
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE eos
  USE modcdfnames
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class Equation_of_state
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: jk, jt             ! dummy loop index
  INTEGER(KIND=4)                           :: ierr               ! error status
  INTEGER(KIND=4)                           :: narg, iargc, ijarg ! browse command line
  INTEGER(KIND=4)                           :: npiglo, npjglo     ! size of the domain
  INTEGER(KIND=4)                           :: npk, npt           ! size of the domain
  INTEGER(KIND=4)                           :: ncout              ! ncid of output file
  INTEGER(KIND=4), DIMENSION(1)             :: ipk, id_varout     ! level and  varid's

  REAL(KIND=4)                              :: zsps               ! missing value for salinity
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: ztemp              ! temperature
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zsal               ! salinity
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zsigntr            ! sigma-0
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zmask              ! 2D mask at current level

  REAL(KIND=8), DIMENSION(:),   ALLOCATABLE :: dtim               ! time counter

  CHARACTER(LEN=256)                        :: cf_tfil            ! input filename
  CHARACTER(LEN=256)                        :: cf_sfil            ! salinity file (option)
  CHARACTER(LEN=256)                        :: cldum              ! working variable
  CHARACTER(LEN=256)                        :: cf_out='signtr.nc' ! output file name

  TYPE (variable), DIMENSION(1)             :: stypvar            ! structure for attributes

  LOGICAL                                   :: lnc4 = .FALSE.     ! Use nc4 with chunking and deflation
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg = iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfsigntr -t T-file [-s S-file] [-o OUT-file] [-nc4]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute neutral volumic mass (kg/m3) from temperature and salinity.'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -t T-file  : netcdf file with temperature and salinity.' 
     PRINT *,'           If salinity not in T-file, use -s option.'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-s S-file   ] : Specify salinity file if not T-file.'
     PRINT *,'       [-o OUT-file ] : Specify output file name instead of ', TRIM(cf_out)
     PRINT *,'       [-nc4 ]      : Use netcdf4 output with chunking and deflation level 1.'
     PRINT *,'                 This option is effective only if cdftools are compiled with'
     PRINT *,'                 a netcdf library supporting chunking and deflation.'
     PRINT *,'      '
     PRINT *,'     OPENMP SUPPORT : yes'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'        none'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) ,' unless option -o is used.'
     PRINT *,'         variables : ', TRIM(cn_vosigntr), ' ( kg/m3 )'
     PRINT *,'      '
     PRINT *,'     SEE ALSO :'
     PRINT *,'       cdfsig0, cdfsigi, cdfsiginsitu, cdfspice'
     STOP 
  ENDIF

  ijarg=1
  cf_sfil='none'
  DO WHILE ( ijarg <= narg ) 
     CALL getarg(ijarg, cldum  ) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ( '-t'   ) ; CALL getarg (ijarg, cf_tfil ) ; ijarg=ijarg+1
        ! options
     CASE ( '-s'   ) ; CALL getarg (ijarg, cf_sfil ) ; ijarg=ijarg+1
     CASE ( '-o'   ) ; CALL getarg (ijarg, cf_out  ) ; ijarg=ijarg+1
     CASE ( '-nc4' ) ; lnc4 = .TRUE.
     CASE DEFAULT    ; PRINT *,' ERROR : ', TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  ENDDO

  IF ( cf_sfil == 'none' ) cf_sfil=cf_tfil

  IF (chkfile(cf_tfil) .OR. chkfile(cf_sfil) ) STOP 99 ! missing file

  npiglo = getdim (cf_tfil, cn_x)
  npjglo = getdim (cf_tfil, cn_y)
  npk    = getdim (cf_tfil, cn_z)
  npt    = getdim (cf_tfil, cn_t)

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt

  ALLOCATE (ztemp(npiglo,npjglo), zsal (npiglo,npjglo) )
  ALLOCATE (zsigntr(npiglo,npjglo), zmask(npiglo,npjglo) )
  ALLOCATE (dtim(npt) )

  CALL CreateOutput
  zsps = getspval( cf_sfil, cn_vosaline )

  DO jt=1,npt
     PRINT *,' TIME = ', jt, dtim(jt)/86400.,' days'
     DO jk = 1, npk
        PRINT *, 'level : ', jk
        zmask(:,:)=1.

        ztemp(:,:)= getvar(cf_tfil, cn_votemper, jk, npiglo, npjglo, ktime=jt)
        zsal(:,:) = getvar(cf_sfil, cn_vosaline, jk, npiglo, npjglo, ktime=jt)

        WHERE( zsal == zsps ) zmask = 0.0

        zsigntr(:,:) = sigmantr (ztemp, zsal, npiglo, npjglo )* zmask(:,:)

        ierr = putvar(ncout, id_varout(1), zsigntr, jk, npiglo, npjglo, ktime=jt)

     END DO  ! loop to next level
  END DO  ! next time frame

  ierr = closeout(ncout)
CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    ipk(:)                       = npk  ! all variables (input and output are 3D)
    stypvar(1)%ichunk            = (/npiglo,MAX(1,npjglo/30),1,1 /)
    stypvar(1)%cname             = cn_vosigntr
    stypvar(1)%cunits            = 'kg/m3'
    stypvar(1)%rmissing_value    = 0.
    stypvar(1)%valid_min         = 0.001
    stypvar(1)%valid_max         = 1040.
    stypvar(1)%clong_name        = 'Neutral volumic mass'
    stypvar(1)%cshort_name       = cn_vosigntr
    stypvar(1)%conline_operation = 'N/A'
    stypvar(1)%caxis             = 'TZYX'

    ! create output fileset
    ncout = create      (cf_out, cf_tfil, npiglo, npjglo, npk       , ld_nc4=lnc4 )
    ierr  = createvar   (ncout,  stypvar, 1,      ipk,    id_varout , ld_nc4=lnc4 )
    ierr  = putheadervar(ncout,  cf_tfil, npiglo, npjglo, npk                     )

    dtim=getvar1d(cf_tfil, cn_vtimec, npt     )
    ierr=putvar1d(ncout,  dtim,       npt, 'T')

  END SUBROUTINE CreateOutput

END PROGRAM cdfsigntr

PROGRAM cdfpsi
  !!======================================================================
  !!                     ***  PROGRAM  cdfpsi  ***
  !!=====================================================================
  !!  ** Purpose : Compute Barotropic Stream Function
  !!
  !!  ** Method  : Compute the 2D fields dtrpu, dtrpv as the integral on 
  !!               the vertical of u, v on their respective points.
  !!               Then integrate from south to north : ==> dpsiu
  !!               Then integrate from West to East   : ==> dpsiv
  !!                  (should be almost the same (if no error ))
  !!               Default (appropriate for global model): output dpsiu;
  !!               normalizes the values setting psi (jpi,jpj) = 0
  !!               If option "V" is given as last argument, output dpsiv,
  !!               normalizes values setting psi(jpi,1) = 0.
  !!               This is appropriate for North Atlantic
  !!
  !! History : 2.1  : 05/2005  : J.M. Molines : Original code
  !!           3.0  : 05/2011  : J.M. Molines : Doctor norm + Lic.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  USE modutils
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class transport
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=4)                           :: ji, jj, jk, jt  ! dummy loop index
  INTEGER(KIND=4)                           :: it              ! time idex for vvl
  INTEGER(KIND=4)                           :: ierr            ! working integer
  INTEGER(KIND=4)                           :: narg, iargc     ! command line 
  INTEGER(KIND=4)                           :: ijarg           ! command line
  INTEGER(KIND=4)                           :: npiglo, npjglo  ! size of the domain
  INTEGER(KIND=4)                           :: npk, npt        ! size of the domain
  INTEGER(KIND=4)                           :: ncout           ! ncid of output file
  INTEGER(KIND=4)                           :: iiref, ijref    ! reference i j point
  INTEGER(KIND=4)                           :: nvout=1         ! number of output variables
  INTEGER(KIND=4), DIMENSION(:),ALLOCATABLE :: ipk, id_varout  ! levels and id's of output vars

  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zmask           ! mask
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e1v, e3v        ! v metrics
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: e2u, e3u        ! u metrics
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zu, zv          ! velocity components
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: glamf, gphif    ! longitude/latitude
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zsshu, zsshv    ! ssh at u and v point
  REAL(KIND=4), DIMENSION(:,:), ALLOCATABLE :: zssh            ! temporary array for ssh
  REAL(KIND=4), DIMENSION(:),   ALLOCATABLE :: e31d            ! 1d vertical metrics, full step case

  REAL(KIND=8), DIMENSION(:),   ALLOCATABLE :: dtim            ! time counter
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dztrpu, dztrpv  ! transport working arrays
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dtrpu, dtrpv    ! transport working arrays
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dtrpsshu        ! transport working arrays
  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: dtrpsshv        ! transport working arrays
  REAL(KIND=8), TARGET, DIMENSION(:,:), ALLOCATABLE :: dpsiu   ! BSF ( U computation
  REAL(KIND=8), TARGET, DIMENSION(:,:), ALLOCATABLE :: dpsiv   ! BSF (V computation )
  REAL(KIND=8), TARGET, DIMENSION(:,:), ALLOCATABLE :: dpsisshu ! BSF ( SSHU computation
  REAL(KIND=8), TARGET, DIMENSION(:,:), ALLOCATABLE :: dpsisshv ! BSF ( SSHV computation )
  REAL(KIND=8), POINTER, DIMENSION(:,:)     :: dpsi            ! point to dpsiu or dpsiv
  REAL(KIND=8), POINTER, DIMENSION(:,:)     :: dpsissh         ! point to dpsisshu or dpsisshv

  CHARACTER(LEN=256)                        :: cf_ufil         ! gridU netcdf file name
  CHARACTER(LEN=256)                        :: cf_vfil         ! gridV netcdf file name
  CHARACTER(LEN=255)                        :: cf_sshfil       ! input SSH file (option)
  CHARACTER(LEN=256)                        :: cf_out='psi.nc' ! output file name
  CHARACTER(LEN=256)                        :: cv_out='sobarstf' ! output variable name
  CHARACTER(LEN=256)                        :: cv_outssh='sobarstfssh'    ! output variable name
  CHARACTER(LEN=256)                        :: cv_outotal='sobarstftotal' ! output variable name
  CHARACTER(LEN=256)                        :: cldum           ! dummy character variable
  CHARACTER(LEN=256)                        :: cglobal         ! global attribute

  TYPE(variable), DIMENSION(:), ALLOCATABLE :: stypvar         ! structure for attributes

  LOGICAL                                   :: lchk  = .FALSE. ! flag for missing files
  LOGICAL                                   :: ll_u  = .TRUE.  ! flag for U integration
  LOGICAL                                   :: ll_v  = .FALSE. ! flag for V integration
  LOGICAL                                   :: lfull = .FALSE. ! flag for full step config
  LOGICAL                                   :: lmask = .FALSE. ! flag for masking output
  LOGICAL                                   :: lmean = .FALSE. ! flag for mean U,V calculation
  LOGICAL                                   :: lopen = .FALSE. ! flag for open calculation
  LOGICAL                                   :: lssh  = .FALSE. ! flag for ssh computation
  LOGICAL                                   :: lnc4  = .FALSE. ! flag for netcdf4 chunking and deflation
  LOGICAL                                   :: llev  = .FALSE. ! flag for level computation (cdfpsi_level like)
  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfpsi -u U-file -v V-file [-V] [-full] [-mask] [-mean] [-nc4]    ...'
     PRINT *,'          ... [--ssh-file SSH-file] [-open] [-ref iref jref] [-o OUT-file] ...'
     PRINT *,'          ... [-vvl] [-lev]'
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       Compute the barotropic stream function (a proxy) as the integral of '
     PRINT *,'       the transport. It is a proxy, as far as the flow in not strictly non-'
     PRINT *,'       divergent. '
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -u U-file  : netcdf file of zonal velocity.' 
     PRINT *,'       -v V-file  : netcdf file of meridional velocity.' 
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-V ] : use V field instead of U field for integration.' 
     PRINT *,'       [-full ] : indicates a full step case. Default is partial steps.'
     PRINT *,'       [-mask ] : mask output fields. Note that the land value is significant.'
     PRINT *,'              It correspond to the potential on this continent.'
     PRINT *,'       [-mean ] : save the average of the computations done with U and V.'
     PRINT *,'       [--ssh-file SSH-file] : compute the transport in the ''ssh'' layer, using '
     PRINT *,'              surface velocities. Take the ssh from T-file specified in this'
     PRINT *,'              option. This is an experimental option, not certified ...'
     PRINT *,'       [-open ] : for open domain configuration. See also -ref to set  '
     PRINT *,'              reference point.'
     PRINT *,'       [-ref iref jref ] : Set the reference point in i,j coordinates. BSF at'
     PRINT *,'              reference point is arbitrarly set to zero.'
     PRINT *,'       [-o  OUT-file ] : specify output file name instead of default ',TRIM(cf_out)
     PRINT *,'       [-nc4  ] : use netcdf4 output files with chunking and deflation'
     PRINT *,'       [-vvl  ] : use time-varying vertical metrics'
     PRINT *,'       [-lev] : This option is still experimental. It has been added to cdfpsi'
     PRINT *,'            in order to mimic former ''cdfpsi_level'', now removed. '
     PRINT *,'            With this option, integral of transports is saved at every level,'
     PRINT *,'            giving a ''pseudo'' stream-function. It works only for global'
     PRINT *,'            configurations, so far.'
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       ', TRIM(cn_fhgr),' and ', TRIM(cn_fzgr),'.'
     PRINT *,'       ', TRIM(cn_fmsk),' is required only if -mask option used.'
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_out) 
     PRINT *,'         variables : ', TRIM(cv_out),' (m3/s )'
     PRINT *,'       If option -ssh is used, 2 additional variables are added to the file :'
     PRINT *,'                     ', TRIM(cv_outssh),' (m3/s ) : contribution of SSH'
     PRINT *,'                     ', TRIM(cv_outotal),' (m3/s ) : total BSF'
     PRINT *,'      '
     STOP 
  ENDIF

  CALL SetGlobalAtt (cglobal)
  iiref = -1 ; ijref= -1

  ijarg = 1
  DO WHILE ( ijarg <= narg )
     CALL getarg( ijarg, cldum ) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ('-u'        ) ; CALL getarg( ijarg, cf_ufil ) ; ijarg=ijarg+1 
     CASE ('-v'        ) ; CALL getarg( ijarg, cf_vfil ) ; ijarg=ijarg+1 
        ! options 
     CASE ('-V'        ) ; ll_v  = .TRUE. ;  ll_u = .FALSE.
     CASE ('-full'     ) ; lfull = .TRUE.
     CASE ('-mask'     ) ; lmask = .TRUE.
     CASE ('-mean'     ) ; lmean = .TRUE.  ; ll_v = .TRUE. ; ll_u = .TRUE.
     CASE ('--ssh-file') ; lssh  = .TRUE.  ; nvout=3
        ;                  CALL getarg( ijarg, cf_sshfil ) ; ijarg=ijarg+1 
     CASE ('-open'     ) ; lopen = .TRUE.  ; ll_v = .TRUE. ; ll_u = .TRUE.
     CASE ('-o'        ) ; CALL getarg( ijarg, cf_out ) ; ijarg=ijarg + 1 
     CASE ('-nc4'      ) ; lnc4  = .TRUE. 
     CASE ('-ref'      ) ; CALL getarg( ijarg, cldum  ) ; ijarg=ijarg+1 ; READ(cldum,*) iiref
        ;                  CALL getarg( ijarg, cldum  ) ; ijarg=ijarg+1 ; READ(cldum,*) ijref
     CASE ('-vvl'      ) ; lg_vvl = .TRUE.
     CASE ('-lev'      ) ; llev   = .TRUE. ; cv_out='vobarstf'
     CASE DEFAULT        ; PRINT *,' ERROR : ',TRIM(cldum), ' : unknown option.' ; STOP 99
     END SELECT
  ENDDO

  lchk = lchk .OR. chkfile( cn_fhgr )
  lchk = lchk .OR. chkfile( cn_fzgr )
  IF ( lmask) lchk = lchk .OR. chkfile( cn_fmsk )
  IF ( lssh ) lchk = lchk .OR. chkfile( cf_sshfil )
  lchk = lchk .OR. chkfile( cf_ufil )
  lchk = lchk .OR. chkfile( cf_vfil )

  IF ( lchk ) STOP 99 ! missing file
  IF ( lg_vvl ) THEN 
     cn_fe3u = cf_ufil
     cn_fe3v = cf_vfil
     cn_ve3u = cn_ve3uvvl
     cn_ve3v = cn_ve3vvvl
  ENDIF
  ! check option compatibility
  IF ( llev .AND. lopen) THEN
     PRINT *,' +++ error : cannot use both -lev and -open options.' ; STOP 99 
  ENDIF
  IF ( llev .AND. lssh) THEN
     PRINT *,' +++ error : cannot use both -lev and -ssh options.' ; STOP 99 
  ENDIF
  IF ( llev .AND. lmean) THEN
     PRINT *,' +++ error : cannot use both -lev and -mean options.' ; STOP 99 
  ENDIF
  IF ( llev .AND. lmask) THEN
     PRINT *,' +++ error : cannot use both -lev and -mask options.' ; STOP 99 
  ENDIF

  npiglo = getdim (cf_ufil, cn_x)
  npjglo = getdim (cf_ufil, cn_y)
  npk    = getdim (cf_ufil, cn_z)
  npt    = getdim (cf_ufil, cn_t)

  IF ( iiref == -1 .OR. ijref == -1 ) THEN
     iiref=npiglo
     ijref=npjglo
  ENDIF

  ALLOCATE (stypvar(nvout), ipk(nvout), id_varout(nvout))

  PRINT *, 'npiglo = ', npiglo
  PRINT *, 'npjglo = ', npjglo
  PRINT *, 'npk    = ', npk
  PRINT *, 'npt    = ', npt
  PRINT *, ' Option is use :'
  PRINT *, '    -full : ', lfull
  PRINT *, '    -mask : ', lmask
  PRINT *, '    -mean : ', lmean
  PRINT *, '    -ssh  : ', lssh
  PRINT *, '    -open : ', lopen
  PRINT *, '    -ref  : ', iiref, ijref
  PRINT *, '  U-comp  : ', ll_u
  PRINT *, '  V-comp  : ', ll_v
  PRINT *, '      -o  : ', TRIM(cf_out)
  PRINT *, '    -lnc4 : ', lnc4
  PRINT *, '    -vvl  : ', lg_vvl

  ! Allocate arrays
  ALLOCATE ( zmask(npiglo,npjglo)                 )
  ALLOCATE ( e1v(npiglo,npjglo),e3v(npiglo,npjglo))
  ALLOCATE ( e2u(npiglo,npjglo),e3u(npiglo,npjglo))
  ALLOCATE ( zu(npiglo,npjglo),dtrpu(npiglo,npjglo), dpsiu(npiglo,npjglo), dztrpu(npiglo,npjglo) )
  ALLOCATE ( zv(npiglo,npjglo),dtrpv(npiglo,npjglo), dpsiv(npiglo,npjglo), dztrpv(npiglo,npjglo) )
  ALLOCATE ( glamf(npiglo,npjglo), gphif(npiglo,npjglo))
  ALLOCATE ( dtim(npt))

  IF ( lfull ) ALLOCATE ( e31d(npk))
  IF ( lssh  ) ALLOCATE ( zssh(npiglo,npjglo), zsshu(npiglo,npjglo), zsshv(npiglo,npjglo))
  IF ( lssh  ) ALLOCATE ( dpsisshu(npiglo,npjglo), dpsisshv(npiglo,npjglo) )
  IF ( lssh  ) ALLOCATE ( dtrpsshu(npiglo,npjglo), dtrpsshv(npiglo,npjglo) )

  glamf(:,:) = getvar(cn_fhgr, cn_glamf, 1, npiglo, npjglo)
  gphif(:,:) = getvar(cn_fhgr, cn_gphif, 1, npiglo, npjglo)

  CALL CreateOutput

  e1v(:,:)   = getvar(cn_fhgr, cn_ve1v, 1, npiglo, npjglo)
  e2u(:,:)   = getvar(cn_fhgr, cn_ve2u, 1, npiglo, npjglo)
  IF ( lmask) THEN
     zmask(:,:) = getvar(cn_fmsk, cn_fmask, 1, npiglo, npjglo)
     WHERE ( zmask >= 2 ) zmask = 1
  ENDIF

  IF ( lfull) e31d(:)    = getvare3(cn_fzgr, cn_ve3t1d, npk )
  ! get rid of the free-slip/no-slip condition

  DO jt = 1, npt
     IF ( lg_vvl ) THEN ; it=jt
     ELSE               ; it=1
     ENDIF
     dtrpu(:,:)= 0.d0 ; dtrpv(:,:)= 0.d0 ; dpsiu(:,:)= 0.d0 ; dpsiv(:,:)= 0.d0
     IF ( lssh ) THEN
        zsshu(:,:) = 0.0 ; zsshv(:,:) = 0.0
        dpsisshu(:,:) = 0.d0 ; dpsisshv(:,:) = 0.d0 ; dtrpsshu(:,:) = 0.d0 ; dtrpsshv(:,:) = 0.d0

        zssh(:          ,    :     ) = getvar(cf_sshfil, cn_sossheig, 1, npiglo, npjglo, ktime=jt )
        zsshu(1:npiglo-1,    :     ) = 0.5*( zssh(2:npiglo,:       ) + zssh(1:npiglo-1,:         ))
        zsshv(   :      ,1:npjglo-1) = 0.5*( zssh(:       ,2:npjglo) + zssh(:         ,1:npjglo-1))
     ENDIF


     DO jk = 1,npk
        IF ( ll_v ) THEN
           zv(:,:) = getvar(cf_vfil, cn_vomecrty, jk, npiglo, npjglo, ktime=jt )
           IF ( lfull ) THEN ; e3v(:,:) = e31d(jk)
           ELSE              ; e3v(:,:) = getvar(cn_fe3v, cn_ve3v, jk, npiglo, npjglo, ktime=it, ldiom=.NOT.lg_vvl)
           ENDIF
           dztrpv(:,:) = zv(:,:)*e1v(:,:)*e3v(:,:)*1.d0 ! meridional transport of each grid cell
           dtrpv(:,:) = dtrpv(:,:) + dztrpv(:,:)        ! cumul over the depth
           IF ( lssh .AND. (jk == 1 ) ) THEN
              dtrpsshv(:,:) = dtrpsshv(:,:) + zv(:,:)*e1v(:,:)*zsshv(:,:)*1.d0  ! meridional transport of each grid cell
           ENDIF
           IF ( llev ) THEN  ! compute zonal integral
              dpsiv(npiglo,:)= 0.d0
              DO ji=npiglo-1,1,-1
                 dpsiv(ji,:) = dpsiv(ji+1,:) - dztrpv(ji,:)  ! psi at f point
              END DO
              ierr = putvar(ncout, id_varout(1), SNGL(dpsiv), jk, npiglo, npjglo, ktime=jt)
           ENDIF
        ENDIF

        IF ( ll_u) THEN
           zu(:,:) = getvar(cf_ufil, cn_vozocrtx, jk, npiglo, npjglo, ktime=jt )
           IF ( lfull ) THEN ; e3u(:,:) = e31d(jk)
           ELSE              ; e3u(:,:) = getvar(cn_fe3u, cn_ve3u, jk, npiglo, npjglo, ktime=it, ldiom=.NOT.lg_vvl)
           ENDIF
           dztrpu(:,:)=  zu(:,:)*e2u(:,:)*e3u(:,:)*1.d0  !  zonal transport of each grid cell
           dtrpu(:,:) = dtrpu(:,:) + dztrpu(:,:)         ! cumul over the depth
           IF ( lssh .AND. (jk == 1 ) ) THEN
              dtrpsshu(:,:) = dtrpsshu(:,:) + zv(:,:)*e2u(:,:)*zsshu(:,:)*1.d0  ! meridional transport of each grid cell
           ENDIF
           IF ( llev ) THEN
              dpsiu(:,:)= 0.d0
              DO jj = 2, npjglo
                 dpsiu(:,jj) = dpsiu(:,jj-1) - dztrpu(:,jj)   ! psi at f point
              END DO
              ierr = putvar(ncout, id_varout(1), SNGL(dpsiu), jk, npiglo, npjglo, ktime=jt)
           ENDIF
        ENDIF
     END DO  ! loop to next level

     IF ( llev ) THEN  ! stop here !
        ierr = closeout (ncout)
        PRINT *,' cdfpsi_level completed.'
        STOP 0
     ENDIF

     IF ( lopen ) THEN
        ! This case corresponds to arbitrary configuration: we chose to compute the transport
        ! across a first line ( eg, ji= 2 or jj= npjglo-1 ), assuming that this starting line is
        ! in the true ocean. If it is on true land, it is not a problem. But it cannot be on
        ! arbitrary masked points....
        IF ( lssh ) THEN
           dpsisshu(1,npjglo-2) = dtrpsshv(1, npjglo-2)
           DO ji = 2, npiglo
              dpsisshu(ji,npjglo-2) = dpsisshu(ji-1,npjglo-2) + dtrpsshv(ji,npjglo-2)
           END DO
           ! Then compute the transport with along U starting from this line
           DO jj= npjglo-3,1,-1
              DO ji = 1, npiglo
                 dpsisshu(ji,jj) = dpsisshu(ji,jj+1) + dtrpsshu(ji,jj+1)
              END DO
           END DO
        ENDIF

        dpsiu(1,npjglo-2) = dtrpv(1, npjglo-2)
        DO ji = 2, npiglo
           dpsiu(ji,npjglo-2) = dpsiu(ji-1,npjglo-2) + dtrpv(ji,npjglo-2)
        END DO
        ! Then compute the transport with along U starting from this line
        DO jj= npjglo-3,1,-1
           DO ji = 1, npiglo
              dpsiu(ji,jj) = dpsiu(ji,jj+1) + dtrpu(ji,jj+1)
           END DO
        END DO

        IF ( lmean ) THEN  ! we need also the other estimate
           dpsiv(npiglo-2, npjglo) = dtrpu(npiglo-2, npjglo)
           DO jj= npjglo - 1, 1, -1
              dpsiv(npiglo-2,jj) = dpsiv(npiglo-2, jj+1) + dtrpu(npiglo-2, jj+1)
           END DO
           DO jj=npjglo,1,-1
              DO ji = npiglo -3,1,-1
                 dpsiv(ji,jj) = dpsiv(ji+1,jj) - dtrpv(ji+1,jj)
              END DO
           END DO
           dpsiu(:,:) = 0.5*(dpsiu(:,:) + dpsiv(:,:))

           IF ( lssh ) THEN
              dpsisshv(npiglo-2, npjglo) = dtrpsshu(npiglo-2, npjglo)
              DO jj= npjglo - 1, 1, -1
                 dpsisshv(npiglo-2,jj) = dpsisshv(npiglo-2, jj+1) + dtrpsshu(npiglo-2, jj+1)
              END DO
              DO jj=npjglo,1,-1
                 DO ji = npiglo -3,1,-1
                    dpsisshv(ji,jj) = dpsisshv(ji+1,jj) - dtrpsshv(ji+1,jj)
                 END DO
              END DO
              dpsisshu(:,:) = 0.5*(dpsisshu(:,:) + dpsisshv(:,:))
           ENDIF
        ENDIF

        dpsi => dpsiu
        IF ( lssh ) dpsissh => dpsisshu

     ELSE
        ! now perform zonal integration if requested
        IF ( ll_v ) THEN
           ! integrate zonally from east to west 
           ! This comfortable with NATL configurations as the eastern most points are land points.
           dpsiv(npiglo,:)= 0.d0
           DO ji=npiglo-1,1,-1
              dpsiv(ji,:) = dpsiv(ji+1,:) - dtrpv(ji,:)  ! psi at f point
           END DO
           dpsi => dpsiv
           IF ( lssh ) THEN
              dpsisshv(npiglo,:)= 0.d0
              DO ji=npiglo-1,1,-1
                 dpsisshv(ji,:) = dpsisshv(ji+1,:) - dtrpsshv(ji,:)  ! psissh at f point
              END DO
              dpsissh => dpsisshv
           ENDIF
        ENDIF

        ! now perform meridional integration if requested
        IF ( ll_u ) THEN
           ! integrate from the south to the north with zonal transport
           ! This is because on global configuration, line jj=1 is always land (Antarctic)
           dpsiu(:,:) = 0.d0
           DO jj = 2, npjglo
              dpsiu(:,jj) = dpsiu(:,jj-1) - dtrpu(:,jj)   ! psi at f point
           END DO
           dpsi => dpsiu
           IF ( lssh ) THEN
              dpsisshu(:,:) = 0.d0
              DO jj = 2, npjglo
                 dpsisshu(:,jj) = dpsisshu(:,jj-1) - dtrpsshu(:,jj)   ! psissh at f point
              END DO
              dpsissh => dpsisshu
           ENDIF
        ENDIF

        IF ( lmean) THEN 
           dpsiu(:,:) = 0.5 * ( dpsiu(:,:) + dpsiv(:,:) )
           dpsi => dpsiu
           IF ( lssh ) THEN
              dpsisshu(:,:) = 0.5 * ( dpsisshu(:,:) + dpsisshv(:,:) )
              dpsissh => dpsisshu
           ENDIF
        ENDIF
     ENDIF

     ! output results after normalization
     dpsi = dpsi - dpsi(iiref,ijref)
     IF ( lmask ) THEN
        PRINT *,' Write masked BSF'
        ierr = putvar(ncout, id_varout(1), SNGL(dpsi)*zmask(:,:), 1, npiglo, npjglo, ktime=jt)
        IF ( lssh ) THEN
           ierr = putvar(ncout, id_varout(2), SNGL(dpsissh     )*zmask(:,:), 1, npiglo, npjglo, ktime=jt)
           ierr = putvar(ncout, id_varout(3), SNGL(dpsissh+dpsi)*zmask(:,:), 1, npiglo, npjglo, ktime=jt)
        ENDIF
     ELSE
        PRINT *,' Write BSF'
        ierr = putvar(ncout, id_varout(1), SNGL(dpsi)           , 1, npiglo, npjglo, ktime=jt)
        IF ( lssh ) THEN
           ierr = putvar(ncout, id_varout(2), SNGL(dpsissh     ), 1, npiglo, npjglo, ktime=jt)
           ierr = putvar(ncout, id_varout(3), SNGL(dpsissh+dpsi), 1, npiglo, npjglo, ktime=jt)
        ENDIF
     ENDIF
  ENDDO

  ierr = closeout (ncout)
CONTAINS

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    IF ( llev ) THEN
       ! define new variables for output ( must update att.txt)
       ipk(1) = npk  !  2D ( X, Y , T )
       stypvar(1)%cname             = cv_out
       stypvar(1)%rmissing_value    = 0.
       stypvar(1)%clong_name        = 'Barotropic_Stream_Function_per_level'
       stypvar(1)%cshort_name       = cv_out
       stypvar(1)%cunits            = 'm3/s'
       stypvar(1)%valid_min         = -300.e6
       stypvar(1)%valid_max         = 300.e6
       stypvar(1)%conline_operation = 'N/A'
       stypvar(1)%caxis             = 'TYX'
       stypvar(1)%ichunk = (/npiglo,MAX(1,npjglo/30),1,1 /)


    ELSE
       ! define new variables for output ( must update att.txt)
       ipk(:) = 1  !  2D ( X, Y , T )
       stypvar(:)%cunits            = 'm3/s'
       stypvar(:)%valid_min         = -300.e6
       stypvar(:)%valid_max         = 300.e6
       stypvar(:)%conline_operation = 'N/A'
       stypvar(:)%caxis             = 'TYX'
       DO ji=1,nvout
          stypvar(ji)%ichunk = (/npiglo,MAX(1,npjglo/30),1,1 /)
       ENDDO

       stypvar(1)%cname             = cv_out
       stypvar(1)%rmissing_value    = 0.
       stypvar(1)%clong_name        = 'Barotropic_Stream_Function'
       stypvar(1)%cshort_name       = cv_out

       IF ( lssh ) THEN
          stypvar(2)%cname             = cv_outssh
          stypvar(2)%rmissing_value    = 0.
          stypvar(2)%clong_name        = 'Barotropic_Stream_Function SSH contribution'
          stypvar(2)%cshort_name       = cv_outssh

          stypvar(3)%cname             = cv_outotal
          stypvar(3)%rmissing_value    = 0.
          stypvar(3)%clong_name        = 'Barotropic_Stream_Function SSH total'
          stypvar(3)%cshort_name       = cv_outotal
       ENDIF
    ENDIF
    ! create output fileset
    ncout = create      (cf_out, cf_ufil, npiglo, npjglo, 1                                , ld_nc4=lnc4 )
    ierr  = createvar   (ncout,  stypvar, nvout,  ipk,    id_varout, cdglobal=TRIM(cglobal), ld_nc4=lnc4 )
    ierr  = putheadervar(ncout,  cf_ufil, npiglo, npjglo, 1, glamf, gphif)

    dtim = getvar1d(cf_ufil, cn_vtimec, npt     )
    ierr = putvar1d(ncout,   dtim,      npt, 'T')

  END SUBROUTINE CreateOutput

END PROGRAM cdfpsi

PROGRAM cdfmoc
  !!======================================================================
  !!                     ***  PROGRAM  cdfmoc  ***
  !!=====================================================================
  !!  ** Purpose : Compute the Meridional Overturning Cell (MOC)
  !!
  !!  ** Method  : The MOC is computed from the V velocity field, integrated
  !!               from the bottom to the surface, then zonally averaged with
  !!               eventual masking for oceanic basins.
  !!               The program looks for the file "new_maskglo.nc". If it 
  !!               does not exist, only the calculation over all the domain
  !!               is performed (this is adequate for a basin configuration).
  !!               In new_maskglo.nc the masking corresponds to the global
  !!               configuration. MOC for Global, Atlantic, Indo-Pacific, 
  !!               Indian, Pacific ocean, inp0=Global-Atlantic
  !!               Results are saved on moc.nc file with variables name 
  !!               respectively zomsfglo, zomsfatl, zomsfinp, zomsfind, zomsfpac, zomsinp0
  !!
  !! History : 2.1  : 07/2005  : J.M. Molines  : Original code
  !!                : 04/2006  : A.M. Treguier : Adaptation to NATL4 case
  !!                : 09/2007  : G. Smith      : MOC decomposition
  !!                : 01/2008  : A. Lecointre  : MOC decomposition adaptation 
  !!           3.0  : 03/2011  : J.M. Molines  : Merge all MOC prog, Doctor norm + Lic.
  !!                : 10/2012  : M.A. Balmaseda: it adds basin INP0=GLOBAL-ATL, different from INP.
  !!         : 4.0  : 03/2017  : J.M. Molines  
  !!         
  !!
  !! References :  For MOC decomposition : Lee & Marotzke (1998), 
  !!               Baehr, Hirschi, Beismann &  Marotzke (2004),
  !!               Cabanes, Lee, & Fu (2007),  Koehl & Stammer (2007).
  !!               See also the powerpoint presentation by Tony Lee at the third 
  !!               CLIVAR-GSOP intercomparison  available at : 
  !!    http://www.clivar.org/organization/gsop/synthesis/mit/talks/lee_MOC_comparison.ppt
  !!               See :   AMOC Metrics guidelines availablke on:
  !!    https://www.godae-oceanview.org/documents/q/action-edit/ref-264/parent-261/
  !!----------------------------------------------------------------------
  USE cdfio
  USE modcdfnames
  USE eos
  !!----------------------------------------------------------------------
  !! CDFTOOLS_4.0 , MEOM 2017 
  !! $Id$
  !! Copyright (c) 2017, J.-M. Molines 
  !! Software governed by the CeCILL licence (Licence/CDFTOOLSCeCILL.txt)
  !! @class transport
  !!----------------------------------------------------------------------
  IMPLICIT NONE

  INTEGER(KIND=2), DIMENSION(:,:,:), ALLOCATABLE :: ibmask       !  nbasins x npiglo x npjglo
  INTEGER(KIND=2), DIMENSION(:,:), ALLOCATABLE :: ivmask         ! ivmask (used to mask e3v)
  INTEGER(KIND=4)                             :: npglo, npatl, npinp, npinp0
  INTEGER(KIND=4)                             :: npind, nppac
  INTEGER(KIND=4)                             :: jbasin, jj, jk  ! dummy loop index
  INTEGER(KIND=4)                             :: ji, jt          ! dummy loop index
  INTEGER(KIND=4)                             :: it              ! time index for vvl
  INTEGER(KIND=4)                             :: nbasins, ibasin ! number of sub basins
  INTEGER(KIND=4)                             :: nbasinso        ! number of sub output basins nbasins+1 to include INDP0
  INTEGER(KIND=4)                             :: ierr            ! working integer
  INTEGER(KIND=4)                             :: narg, iargc     ! command line browser
  INTEGER(KIND=4)                             :: ijarg           !  "             "
  INTEGER(KIND=4)                             :: npiglo,npjglo   ! size of the domain
  INTEGER(KIND=4)                             :: npk, npt        ! size of the domain
  INTEGER(KIND=4)                             :: ncout           ! out put file id
  INTEGER(KIND=4)                             :: nvarout         ! number of output variables
  INTEGER(KIND=4)                             :: ijvar           ! index for output variable
  INTEGER(KIND=4), DIMENSION(:),  ALLOCATABLE :: ipk, id_varout  ! output variables info
  INTEGER(KIND=4), DIMENSION(2)               :: iloc            ! working integer array

  REAL(KIND=4), DIMENSION(:,:,:), ALLOCATABLE :: e3v             ! Vertical e3v masked by vmask
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: e1v,      gphiv ! metrics, velocity
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: zv              ! meridional velocity
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: rdumlon         ! dummy longitude = 0.
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: rdumlat         ! latitude for i = north pole
  REAL(KIND=4), DIMENSION(:),     ALLOCATABLE :: gdepw           ! depthw
  REAL(KIND=4), DIMENSION(:),     ALLOCATABLE :: gdept           ! deptht
  REAL(KIND=4), DIMENSION(:),     ALLOCATABLE :: e31d            ! e3 1D : used if full step

  REAL(KIND=8), DIMENSION(:),     ALLOCATABLE :: dtim            ! time counter array
  REAL(KIND=8), DIMENSION(:,:,:), ALLOCATABLE :: dmoc            ! nbasins x npjglo x npk

  CHARACTER(LEN=256)                          :: cf_vfil         ! meridional velocity file
  CHARACTER(LEN=256)                          :: cf_moc = 'moc.nc'  ! output file name
  CHARACTER(LEN=256)                          :: cglobal         ! Global attribute for output file
  CHARACTER(LEN=256)                          :: cldum           ! dummy char variable

  TYPE(variable) ,DIMENSION(:),   ALLOCATABLE :: stypvar         ! structure for attribute

  LOGICAL                                     :: lbas  = .FALSE. ! new_maskglo.nc file  flag
  LOGICAL                                     :: lfull = .FALSE. ! full step flag
  LOGICAL                                     :: lchk  = .FALSE. ! check for missing files
  LOGICAL                                     :: ldec  = .FALSE. ! flag for decomposition option
  LOGICAL                                     :: lrap  = .FALSE. ! flag for rapid option

  ! Variables used only when MOC decomposition is requested
  INTEGER(KIND=2), DIMENSION(:,:), ALLOCATABLE :: iumask         ! iumask (used if decomposition)
  INTEGER(KIND=2), DIMENSION(:,:), ALLOCATABLE :: itmask         ! itmask (used if decomposition)

  INTEGER(KIND=4)                             :: itmp, iup, ido  ! up and down index for work

  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: e1u             ! used if ldec
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: hdep            ! total depth at v point
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: zcoef           ! coefficient for geostrophic calc
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: ztemp           ! temperature
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: zsal            ! salinity
  REAL(KIND=4), DIMENSION(:,:),   ALLOCATABLE :: zsig0           ! density
  REAL(KIND=4)                                :: zmsv
  REAL(KIND=4)                                :: rpi             ! pi 
  REAL(KIND=4)                                :: grav = 9.81     ! gravity
  REAL(KIND=4)                                :: rau0 = 1025.    ! mean density

  REAL(KIND=8), DIMENSION(:,:,:), ALLOCATABLE :: dmoc_sh         ! nbasins x npjglo x npk
  REAL(KIND=8), DIMENSION(:,:,:), ALLOCATABLE :: dmoc_bt         ! nbasins x npjglo x npk
  REAL(KIND=8), DIMENSION(:,:,:), ALLOCATABLE :: dmoc_btw        ! nbasins x npjglo x npk
  REAL(KIND=8), DIMENSION(:,:,:), ALLOCATABLE :: dmoc_ag         ! nbasins x npjglo x npk
  REAL(KIND=8), DIMENSION(:,:,:), ALLOCATABLE :: dvgeo           !  npiglo x npjglo x 2
  REAL(KIND=8), DIMENSION(:,:),   ALLOCATABLE :: dvbt            ! Barotropic velocity
  REAL(KIND=8)                                :: dgeo            ! Barotropic velocity

  CHARACTER(LEN=256)                          :: cf_tfil         ! Grid T file (case of decomposition)
  CHARACTER(LEN=256)                          :: cf_ufil         ! Grid U file (case Rapid)
  CHARACTER(LEN=256)                          :: cf_sfil         ! Grid S file (case Rapid)

  !!----------------------------------------------------------------------
  CALL ReadCdfNames()

  narg= iargc()
  IF ( narg == 0 ) THEN
     PRINT *,' usage : cdfmoc  -v V-file  [-decomp] [-rapid] [-t T-file] [-s S-file] ...'
     PRINT *,'                  ... [-u U-file] [-full] [-vvl ] [-o OUT-file] '
     PRINT *,'      '
     PRINT *,'     PURPOSE :'
     PRINT *,'       The primary purpose of this tool is to compute the MOC for oceanic '
     PRINT *,'       sub-basins as described in ',TRIM(cn_fbasins),'. If this sub-basins'
     PRINT *,'       file is not found, then only computes the global MOC.'
     PRINT *,'      '
     PRINT *,'       The option ''-decomp'' was developped in order to decompose the MOC'
     PRINT *,'       into its 3 components : Geostrophic, Barotropic and Ageostrophic.'
     PRINT *,'      '
     PRINT *,'       With the option ''-rapid'', the model MOC at the latitude of the RAPID'
     PRINT *,'       section (26.5 N) is evaluated in the same manner as it is done with'
     PRINT *,'       observations of the RAPID MOCHA array, (see details below).'
     PRINT *,'      '
     PRINT *,'     REFERENCES :'
     PRINT *,'        - MOC decomposition:'
     PRINT *,'          Lee & Marotzke (1998), Baehr, Hirschi, Beismann &  Marotzke (2004),'
     PRINT *,'          Cabanes, Lee, & Fu (2007), Koehl & Stammer (2007).'
     PRINT *,'        - RAPID MOCHA array evaluation:'
     PRINT *,'          See :   http://www.rapid.ac.uk'
     PRINT *,'      '
     PRINT *,'     ARGUMENTS :'
     PRINT *,'       -v V-file : file with meridional velocity component (mandatory).'
     PRINT *,'      '
     PRINT *,'     OPTIONS :'
     PRINT *,'       [-decomp ] : decompose MOC in 3 components: Geostrophic, Barotropic and'
     PRINT *,'                 Ageostrophic. For this option temperatures and salinity are'
     PRINT *,'                 needed (for density calculation), hence T-file/S-file.'
     PRINT *,'       [-rapid ] : Compute the AMOC at 26.5 N in the same manner than the'
     PRINT *,'                 RAPID MOCHA array, separating the Gulfstream transport and the'
     PRINT *,'                 contribution of different water masses :'
     PRINT *,'                   - 0-800m      : Thermocline recirculation'
     PRINT *,'                   - 800-1100m   : AIW recirculation'
     PRINT *,'                   - 1100-3000m  : upper-NADW recirculation'
     PRINT *,'                   - 3000-5000m  : lower-NADW recirculation'
     PRINT *,'                   - 5000-bottom : AABW recirculation'
     PRINT *,'       [-t T-file] : file with temperature and salinity. Required for '
     PRINT *,'               ''-decomp'' and ''-rapid'' options.'
     PRINT *,'       [-s S-file]:  Specify a salinity only file if the salinity is not '
     PRINT *,'                available in T-file.  Required for  ''-decomp'' and '
     PRINT *,'               ''-rapid'' options.'
     PRINT *,'       [-u U-file]:  Specify the U-file (zonal wind-stress), required only for '
     PRINT *,'                ''-rapid'' option, for the evaluation of Ekman transport. '
     PRINT *,'       [-full ] : use full step instead of default partial step' 
     PRINT *,'       [-vvl  ] : Use time-varying vertical metrics'
     PRINT *,'       [-o OUT-file] : specify output file instead of ',TRIM(cf_moc)
     PRINT *,'      '
     PRINT *,'     REQUIRED FILES :'
     PRINT *,'       Files ',TRIM(cn_fhgr),' ', TRIM(cn_fhgr),' and ', TRIM(cn_fmsk)
     PRINT *,'       File ',TRIM(cn_fbasins),'. If this latter file is not available '
     PRINT *,'             only the MOC for the global domain is computed'
     PRINT *,'      '
     PRINT *,'     OPENMP SUPPORT : yes '
     PRINT *,'      '
     PRINT *,'     OUTPUT : '
     PRINT *,'       netcdf file : ', TRIM(cf_moc)
     PRINT *,'       variables ',TRIM( cn_zomsfglo),' : Global ocean '
     PRINT *,'       variables ',TRIM( cn_zomsfatl),' : Atlantic Ocean '
     PRINT *,'       variables ',TRIM( cn_zomsfinp),' : Indo Pacific '
     PRINT *,'       variables ',TRIM( cn_zomsfind),' : Indian Ocean alone'
     PRINT *,'       variables ',TRIM( cn_zomsfpac),' : Pacific Ocean alone'
     PRINT *,'       variables ',TRIM( cn_zomsfinp0),' : Indo Pacific Net'
     PRINT *,'      '
     PRINT *,'       If decomposition is required , ( option -decomp ) add 3 additional'
     PRINT *,'       variables per basin with suffixes _sh, _bt, _ag.'
     PRINT *,'      '
     PRINT *,'       If option -rapid is used the output file (rapid_moc.nc) is degenerated'
     PRINT *,'       into 6 scalar values : tr_gs, tr_THERM, tr_AIW, tr_UNADW, tr_LNADW, '
     PRINT *,'       tr_BW and a vertical profile of the AMOC at 26.5N, as computed'
     PRINT *,'       traditionally.'
     PRINT *,'       Additional variables are also computed following CLIVAR-GODAE '
     PRINT *,'       reanalysis intercomparison project recommendations. '
     PRINT *,'      '
     STOP 
  ENDIF

  cglobal = 'Partial step computation'
  ! optional files set to none
  cf_sfil='none'
  cf_tfil='none'
  cf_ufil='none'

  ijarg = 1 
  DO WHILE ( ijarg <= narg )
     CALL getarg (ijarg, cldum) ; ijarg=ijarg+1
     SELECT CASE ( cldum )
     CASE ('-v'     ) ; CALL getarg (ijarg, cf_vfil) ; ijarg=ijarg+1
        ! options
     CASE ('-t'     ) ; CALL getarg (ijarg, cf_tfil) ; ijarg=ijarg+1
     CASE ('-s'     ) ; CALL getarg (ijarg, cf_sfil) ; ijarg=ijarg+1
     CASE ('-u'     ) ; CALL getarg (ijarg, cf_ufil) ; ijarg=ijarg+1
     CASE ('-o'     ) ; CALL getarg (ijarg, cf_moc ) ; ijarg=ijarg+1
     CASE ('-full'  ) ; lfull  = .TRUE. ; cglobal = 'Full step computation'
     CASE ('-decomp') ; ldec   = .TRUE.
     CASE ('-rapid' ) ; lrap   = .TRUE.
     CASE ('-vvl'   ) ; lg_vvl = .TRUE.
     CASE DEFAULT     ; PRINT *,' ERROR : ',TRIM(cldum),' : unknown option.' ; STOP 99
     END SELECT
  END DO
  IF ( cf_sfil == 'none' ) cf_sfil = cf_tfil

  lchk = lchk .OR. chkfile ( cn_fhgr )
  lchk = lchk .OR. chkfile ( cn_fzgr )
  lchk = lchk .OR. chkfile ( cn_fmsk )
  lchk = lchk .OR. chkfile ( cf_vfil )
  IF ( ldec  ) lchk = lchk .OR. chkfile (TRIM(cf_tfil)) .OR. chkfile (TRIM(cf_sfil)) 
  IF ( lrap  ) lchk = lchk .OR. chkfile (TRIM(cf_tfil)) .OR. chkfile (TRIM(cf_sfil)) .OR. chkfile(TRIM(cf_ufil)) 
  IF ( lchk  ) STOP 99  ! missing file(s)
  IF ( lg_vvl) THEN
     cn_fe3v = cf_vfil
     cn_ve3v = cn_ve3vvvl
  ENDIF

  IF ( lrap ) THEN 
     ! all the work will be done in a separated routine for RAPID-MOCHA section
     CALL rapid_amoc 
     STOP 99  ! program stops here in this case
  ENDIF

  npiglo = getdim (cf_vfil,cn_x)
  npjglo = getdim (cf_vfil,cn_y)
  npk    = getdim (cf_vfil,cn_z)
  npt    = getdim (cf_vfil,cn_t)

  PRINT *, 'Working with cdfmoc ...'
  PRINT *, '  npiglo =', npiglo
  PRINT *, '  npjglo =', npjglo
  PRINT *, '  npk    =', npk
  PRINT *, '  npt    =', npt

  !  Detects newmaskglo file 
  lbas = .NOT. chkfile (cn_fbasins )

  IF (lbas) THEN ; nbasins = 5 ; nbasinso= 6
  ELSE           ; nbasins = 1 ; nbasinso= 1
  ENDIF

  IF ( ldec ) THEN ; nvarout=nbasinso * 4   ! total, _sh, _bt, _ag
  ELSE             ; nvarout=nbasinso       ! total
  ENDIF

  ! Allocate arrays
  ALLOCATE ( ibmask(nbasins, npiglo, npjglo) )
  ALLOCATE ( zv(npiglo, npjglo), e1v(npiglo,npjglo), e3v(npiglo,npjglo,npk) )
  ALLOCATE ( gphiv(npiglo,npjglo) )
  ALLOCATE ( rdumlon(1,npjglo), rdumlat(1,npjglo))
  ALLOCATE ( gdepw(npk), gdept(npk), e31d(npk) )
  ALLOCATE ( dtim(npt) )
  ALLOCATE ( dmoc( nbasins, npjglo, npk   ) )
  ALLOCATE ( ivmask(npiglo, npjglo) )

  IF ( ldec ) THEN 
     ALLOCATE ( iumask(npiglo, npjglo) )
     ALLOCATE ( itmask(npiglo, npjglo) )
     ALLOCATE ( ztemp(npiglo, npjglo) )
     ALLOCATE ( zsal(npiglo, npjglo) )
     ALLOCATE ( zsig0(npiglo, npjglo) )
     ALLOCATE ( e1u(npiglo, npjglo) )
     ALLOCATE ( zcoef(npiglo, npjglo) )
     ALLOCATE ( dvbt(npiglo, npjglo), hdep(npiglo,npjglo) )
     ALLOCATE ( dmoc_sh(nbasins, npjglo, npk) )
     ALLOCATE ( dmoc_bt(nbasins, npjglo, npk) )
     ALLOCATE ( dmoc_btw(nbasins, npjglo, npk) )
     ALLOCATE ( dmoc_ag(nbasins, npjglo, npk)  )
     ALLOCATE ( dvgeo(npiglo, npjglo, 2 ) )
  ENDIF

  e1v(:,:)   = getvar  (cn_fhgr, cn_ve1v,  1, npiglo,npjglo) 
  gphiv(:,:) = getvar  (cn_fhgr, cn_gphiv, 1, npiglo,npjglo)
  gdepw(:)   = getvare3(cn_fzgr, cn_gdepw, npk             )
  gdepw(:)   = -1.* gdepw(:)


  IF ( ldec  ) gdept(:) = getvare3(cn_fzgr, cn_gdept, npk             )
  IF ( ldec  ) e1u(:,:) = getvar  (cn_fhgr, cn_ve1u,  1, npiglo,npjglo)
  IF ( lfull ) e31d(:)  = getvare3(cn_fzgr, cn_ve3t1d, npk)

  iloc=MAXLOC(gphiv)
  rdumlat(1,:) = gphiv(iloc(1),:)
  rdumlon(:,:) = 0.   ! set the dummy longitude to 0

  ALLOCATE ( stypvar(nvarout), ipk(nvarout), id_varout(nvarout) )

  CALL CreateOutput

  ! 1 : global ; 2 : Atlantic ; 3 : Indo-Pacif ; 4 : Indian ; 5 : Pacif
  ibmask(npglo,:,:) = getvar(cn_fmsk,   cn_vmask, 1, npiglo, npjglo)
  IF ( lbas ) THEN
     ibmask(npatl,:,:) = getvar(cn_fbasins, cn_tmaskatl, 1, npiglo, npjglo)
     ibmask(npind,:,:) = getvar(cn_fbasins, cn_tmaskind, 1, npiglo, npjglo)
     ibmask(nppac,:,:) = getvar(cn_fbasins, cn_tmaskpac, 1, npiglo, npjglo)
     ibmask(npinp,:,:) = ibmask(nppac,:,:) + ibmask(npind,:,:)  ! indo pacific mask
     ! ensure that there are no overlapping on the masks
     WHERE(ibmask(npinp,:,:) > 0 ) ibmask(npinp,:,:) = 1
  ENDIF
  ! change global mask for GLOBAL periodic condition
  ibmask(1,1,     :) = 0.
  ibmask(1,npiglo,:) = 0.
     
  DO jt = 1, npt
     IF ( lg_vvl ) THEN  ; it=jt
     ELSE                ; it=1
     ENDIF

     IF ( it == jt ) THEN
        DO jk= 1, npk
           ! save e3v masked with vmask as 3d array
           e3v(:,:,jk) = get_e3v(jk,it)
        END DO
     ENDIF
     ! --------------------------
     ! 1) Compute total MOC: dmoc
     ! --------------------------
     dmoc(:,:,:) = 0.d0        ! initialize moc to 0
     IF ( ldec) THEN ; dvbt=0.d0 ; hdep=0.0 ; dmoc_bt=0.d0 ;
     ENDIF
     DO jk = 1, npk-1
        ! Get velocities v at jk, time = jt
        zv(:,:)= getvar(cf_vfil, cn_vomecrty,  jk, npiglo, npjglo, ktime=jt)
        !          print *, jk, MAXVAL(zv)

        IF ( ldec ) THEN
           ! compute barotropic component when requested
           ! this contribution is computed here in order to use zv(jk)
           dvbt(:,:)    = dvbt(:,:) + e3v(:,:,jk)*zv(:,:)*1.d0
           hdep(:,:)    = hdep(:,:) + e3v(:,:,jk)
        ENDIF

        ! integrates 'zonally' (along i-coordinate)
        DO jbasin = 1, nbasins
           !$OMP PARALLEL DO SCHEDULE(RUNTIME)
           DO jj=1,npjglo
              DO ji=1,npiglo
                 ! For all basins 
                 dmoc(jbasin,jj,jk)=dmoc(jbasin,jj,jk) -  &
                      &             e1v(ji,jj)*e3v(ji,jj,jk)* ibmask(jbasin,ji,jj)*zv(ji,jj)*1.d0
              ENDDO
           END DO
           !$OMP END PARALLEL DO
        END DO
     END DO

     ! integrates vertically from bottom to surface
     !$OMP PARALLEL DO SCHEDULE(RUNTIME)
     DO jj = 1, npjglo
        DO jk = npk-1, 1, -1
           dmoc(:,jj,jk)    = dmoc(:,jj,jk+1)    + dmoc(:,jj,jk)/1.d6
        END DO
     ENDDO
     !$OMP END PARALLEL DO

     IF ( ldec ) THEN
        !--------------------------------------------------
        ! 2) compute extra term if decomposition requested
        !--------------------------------------------------
        !  2.1 : Barotropic MOC : dmoc_bt
        !  """"""""""""""""""""
        ! compute vertical mean of the meridional velocity
        WHERE ( hdep /= 0 )
           dvbt(:,:) = dvbt(:,:) / hdep(:,:)
        ELSEWHERE
           dvbt(:,:) = 0.d0
        ENDWHERE

        DO jk=1, npk-1

           ! integrates 'zonally' (along i-coordinate)
           DO ji=1,npiglo
              ! For all basins
              DO jbasin = 1, nbasins
                 DO jj=1,npjglo
                    dmoc_bt(jbasin,jj,jk)=dmoc_bt(jbasin,jj,jk) -  &
                         &    e1v(ji,jj)*e3v(ji,jj,jk)* ibmask(jbasin,ji,jj)*dvbt(ji,jj)
                 ENDDO
              END DO
           END DO
        END DO
        ! integrates vertically   from bottom to surface
        DO jk = npk-1, 1, -1
           dmoc_bt(:,:,jk) = dmoc_bt(:,:,jk+1) + dmoc_bt(:,:,jk)/1.d6
        END DO

        !  2.2 : Geostrophic Shear MOC : dmoc_sh
        !  """""""""""""""""""""""""""""
        ! using equation 2.7 of Lecointre (2008 
        ! f. Dv/Dz = -g/rau0. Drho/Dx 
        rau0 = 1025.0
        grav = 9.81
        rpi  = ACOS( -1.)
        zcoef(:,:) =  2*2*rpi/( 24.0 * 3600. )* SIN ( rpi * gphiv(:,:) /180.0) ! f at v point
        WHERE ( zcoef /= 0 ) 
           zcoef(:,:) = -grav/ rau0 / zcoef(:,:)
        ELSEWHERE
           zcoef(:,:) = 0.
        END WHERE

        dvgeo(:,:,:) = 0.0
        dvbt(:,:)    = 0.d0
        iup = 1 ; ido = 2
        DO jk=npk-1, 1, -1
           iumask(:,:) = getvar(cn_fmsk, cn_umask, jk, npiglo, npjglo)
           itmask(:,:) = getvar(cn_fmsk, cn_tmask, jk, npiglo, npjglo)
           ztemp(:,:)  = getvar(cf_tfil, cn_votemper, jk, npiglo, npjglo, ktime=jt )
           zsal(:,:)   = getvar(cf_sfil, cn_vosaline, jk, npiglo, npjglo, ktime=jt )
           zsig0(:,:)  = sigmai (ztemp, zsal, gdept(jk), npiglo, npjglo )* itmask(:,:)

           ! dgeo is Drho/dx at V point ( average on the 4 neighbours U points)
           ! thus, dgeo is -f.rau0/g. Dv/Dz 
           DO jj = 2, npjglo -1
              DO ji = 2, npiglo -1
                 zmsv =  1. / MAX (1_2, iumask(ji-1,jj+1)+iumask(ji,jj+1)+iumask(ji-1,jj)+iumask(ji,jj) )
                 dgeo = ( ( zsig0(ji,  jj+1) - zsig0(ji-1,jj+1) ) * iumask(ji-1, jj+1) / e1u(ji-1, jj+1) &
                      &  +( zsig0(ji+1,jj+1) - zsig0(ji  ,jj+1) ) * iumask(ji,   jj+1) / e1u(ji,   jj+1) &
                      &  +( zsig0(ji,  jj  ) - zsig0(ji-1,jj  ) ) * iumask(ji-1, jj  ) / e1u(ji-1, jj  ) &
                      &  +( zsig0(ji+1,jj  ) - zsig0(ji,  jj  ) ) * iumask(ji,   jj  ) / e1u(ji,   jj  )  )*1.d0
                 ! 
                 ! dvgeo is the geostrophic velocity at w point(jk) obtained by vertical integration of Dv/Dz
                 ! between bottom and jk
                 dvgeo(ji,jj,iup) = dvgeo(ji,jj,ido) + zcoef(ji,jj) * dgeo * zmsv * ibmask(npglo,ji,jj) *e3v(ji,jj,jk)
                 ! zv is the geostrophic velocity located at v-level (jk)
                 zv(ji,jj) = 0.5 *( dvgeo(ji,jj,iup) + dvgeo(ji,jj,ido) )
              ENDDO
           ENDDO
           ! compute the vertical mean of geostrophic velocity
           ! for memory management purpose we re-use dvbt which is not used any longer.
           dvbt(:,:) = dvbt(:,:) + e3v(:,:,jk)*zv(:,:)*1.d0

           ! integrates 'zonally' (along i-coordinate)
           DO ji=1,npiglo
              ! For all basins
              DO jbasin = 1, nbasins
                 DO jj=1,npjglo
                    dmoc_sh(jbasin,jj,jk)=dmoc_sh(jbasin,jj,jk) -  &
                         &             e1v(ji,jj)*e3v(ji,jj,jk)* ibmask(jbasin,ji,jj)*zv(ji,jj)*1.d0
                 ENDDO
              END DO
           END DO
           ! swap up and down for next level computation
           itmp=iup ;  iup = ido ; ido = itmp
        ENDDO   ! end of level loop

        WHERE ( hdep /=0 )
           dvbt(:,:) = dvbt(:,:) / hdep(:,:)
        ELSEWHERE
           dvbt(:,:) = 0.d0
        END WHERE

        !  2.2.1 : Barotropic Geostrophic Shear MOC : dmoc_btw
        !  """"""""""""""""""""""""""""""""""""""""""
        ! compute corresponding MOC for this unwanted pseudo barotropic contribution
        dmoc_btw(:,:,:) = 0.d0
        DO jk=1, npk-1

           ! integrates 'zonally' (along i-coordinate)
           DO ji=1,npiglo
              ! For all basins
              DO jbasin = 1, nbasins
                 DO jj=1,npjglo
                    dmoc_btw(jbasin,jj,jk)=dmoc_btw(jbasin,jj,jk) -  &
                         &         e1v(ji,jj)*e3v(ji,jj,jk)* ibmask(jbasin,ji,jj)*dvbt(ji,jj)
                 ENDDO
              END DO
           END DO
        END DO

        ! apply correction to dmoc_sh
        dmoc_sh(:,:,:) = dmoc_sh(:,:,:) - dmoc_btw(:,:,:)

        ! integrates vertically   from bottom to surface
        DO jk = npk-1, 1, -1
           dmoc_sh(:,:,jk) = dmoc_sh(:,:,jk+1) + dmoc_sh(:,:,jk)/1.e6
        END DO  ! 

        !  2.3 : Barotropic Geostrophic Shear MOC : dmoc_ag
        ! ----------------------------------------
        ! compute ageostrophic component 
        !  AGEO        =   MOC total    Geo-Shear        Barotropic
        dmoc_ag(:,:,:) = dmoc(:,:,:) - dmoc_sh(:,:,:) - dmoc_bt(:,:,:)
     ENDIF

     ! netcdf output
     ijvar=1
     DO jbasin = 1, nbasins
        DO jk = 1, npk
           ierr = putvar (ncout, id_varout(ijvar), REAL(dmoc(jbasin,:,jk)), jk, 1, npjglo, ktime=jt)
        END DO
        ijvar = ijvar + 1

        IF ( ldec ) THEN
           !           print *, dmoc_sh(jbasin,60,10)
           DO jk = 1, npk 
              ierr = putvar (ncout, id_varout(ijvar), REAL(dmoc_sh(jbasin,:,jk)), jk, 1, npjglo, ktime=jt)
           END DO
           !           print *, dmoc_bt(jbasin,60,10)
           ijvar = ijvar + 1 
           DO jk = 1, npk 
              ierr = putvar (ncout, id_varout(ijvar), REAL(dmoc_bt(jbasin,:,jk)), jk, 1, npjglo, ktime=jt)
           END DO
           !           print *, dmoc_ag(jbasin,60,10)
           ijvar = ijvar + 1 
           DO jk = 1, npk 
              ierr = putvar (ncout, id_varout(ijvar), REAL(dmoc_ag(jbasin,:,jk)), jk, 1, npjglo, ktime=jt)
           END DO
           ijvar = ijvar + 1 
        ENDIF
     END DO

     IF ( lbas ) THEN
        jbasin=nbasinso
        DO jk = 1, npk
           ierr = putvar (ncout, id_varout(ijvar), REAL(dmoc(npglo,:,jk)-dmoc(npatl,:,jk)), jk, 1, npjglo, ktime=jt)
        END DO
        ijvar = ijvar + 1
        IF ( ldec ) THEN

           DO jk = 1, npk 
              ierr = putvar (ncout, id_varout(ijvar), REAL(dmoc_sh(npglo,:,jk)-dmoc_sh(npatl,:,jk)), jk, 1, npjglo, ktime=jt)
           END DO

           ijvar = ijvar + 1 
           DO jk = 1, npk 
              ierr = putvar (ncout, id_varout(ijvar), REAL(dmoc_bt(npglo,:,jk)-dmoc_bt(npatl,:,jk)), jk, 1, npjglo, ktime=jt)
           END DO

           ijvar = ijvar + 1 
           DO jk = 1, npk 
              ierr = putvar (ncout, id_varout(ijvar), REAL(dmoc_ag(npglo,:,jk)-dmoc_ag(npatl,:,jk)), jk, 1, npjglo, ktime=jt)
           END DO
           ijvar = ijvar + 1 
        ENDIF
     ENDIF
  ENDDO  ! time loop

  ierr = closeout(ncout)

CONTAINS

  FUNCTION get_e3v(kk,kt)
    !!---------------------------------------------------------------------
    !!                  ***  FUNCTION get_e3  ***
    !!
    !! ** Purpose : Send back e3v at level kk selecting
    !!              full step or partial step case
    !!
    !! ** Method  :  check for global flag lfull  
    !!
    !!----------------------------------------------------------------------
    INTEGER(KIND=4), INTENT(in)  :: kk  ! level to work with
    INTEGER(KIND=4), INTENT(in)  :: kt  ! time for reading e3v (vvl case)
    REAL(KIND=4), DIMENSION(npiglo,npjglo) :: get_e3v

    ivmask(:,:) = getvar(cn_fmsk, cn_vmask, jk, npiglo, npjglo)
    IF ( lfull ) THEN ; get_e3v(:,:) = e31d(jk)
    ELSE              ; get_e3v(:,:) = getvar(cn_fe3v, cn_ve3v, jk, npiglo, npjglo, ktime=kt, ldiom=.NOT.lg_vvl )
    ENDIF
    get_e3v(:,:) = get_e3v(:,:) * ivmask(:,:)

  END FUNCTION get_e3v

  SUBROUTINE rapid_amoc
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE rapid_amoc  ***
    !!
    !! ** Purpose :  Decompose AMOC at 26.5N (Rapid-Mocha array) the same way 
    !!               it is done with observations.
    !!
    !! ** Method  :  Use code provided by N. Ferry (Mercator-ocean) for the
    !!               choice of the components. 
    !!
    !! References : RAPID-MOCHA paper ... 
    !! 
    !! Upadted    :  2012-08 : N. Ferry  additional quantities are calculated
    !!                         See Keith Haines and Vladimir Stepanov document :   
    !!                         (CLIVAR-GODAE reanalysis intercomparison) 
    !!               See :   AMOC Metrics guidelines availablke on:
    !!    https://www.godae-oceanview.org/documents/q/action-edit/ref-264/parent-261/
    !! 
    !!----------------------------------------------------------------------
    USE cdftools  ! for cdf_findij
    ! Geographical settings for Rapid/Mocha Array
    REAL(KIND=4), PARAMETER :: rp_lat_rapid  = 26.5  ! latitude of Rapid array
    REAL(KIND=4), PARAMETER :: rp_lonw_rapid = -80.1 ! longitude of the western most point
    REAL(KIND=4), PARAMETER :: rp_lone_rapid = 12.7  ! longitude of the eastern most point
    REAL(KIND=4), PARAMETER :: rp_lon_gs = -77.4     !  Gulf Stream limit (eastward from the US coast).

    INTEGER(KIND=4), PARAMETER :: jp_class = 5      ! number of depth range classes
    REAL(KIND=4), PARAMETER, DIMENSION(jp_class+1) :: rp_zlim = (/0.,800.,1100.,3000.,5000., 10000./) ! limit of depth classes
    !
    INTEGER(KIND=4) :: ijrapid ! J-index of the rapid section
    INTEGER(KIND=4) :: iiw     ! I-index of the western limit of the section
    INTEGER(KIND=4) :: iie     ! I-index of the eastern limit of the section
    INTEGER(KIND=4) :: iigs    ! I-index of the eastern limit of the gulfstream
    INTEGER(KIND=4), DIMENSION(jp_class+1) :: iklim ! K-index of the vertical limits for the depth classes
    INTEGER(KIND=4) :: idum    ! dummy integer value
    INTEGER(KIND=4) :: npigs   ! number of point in the Gulf-stream band
    INTEGER(KIND=4) :: ndiag   ! number of diagnostics
    INTEGER(KIND=4) :: jclass , jv , jk100   ! dummy loop index
    INTEGER(KIND=4) :: idvar   ! id of the netcdf variable
    INTEGER(KIND=4), DIMENSION (:,:),   ALLOCATABLE :: itmaskrapid ! tmask rapid section
    !
    REAL(KIND=8), DIMENSION (:,:,:), ALLOCATABLE :: damocrapid              ! (1,1,npk)
    REAL(KIND=8), DIMENSION (:,:,:), ALLOCATABLE :: dtrp                    ! (1,1,1)
    REAL(KIND=8), DIMENSION (:,:),   ALLOCATABLE :: dtaux                   ! zonal wind stress
    REAL(KIND=8), DIMENSION (:),     ALLOCATABLE :: de1rapid                ! e1 metrics alonf rapid
    REAL(KIND=8), DIMENSION (:),     ALLOCATABLE :: dmv, dmt                ! mean velocity and tracer (T/S) on verticak
    REAL(KIND=8)            :: ds, ds0, dtrek, dmv0, dmt0, dms0

    REAL(KIND=4), DIMENSION (:,:),   ALLOCATABLE :: vrapid, trapid, srapid  ! (i,k) vertical slab
    REAL(KIND=4), DIMENSION (:,:),   ALLOCATABLE :: e3vrapid, var2d         ! (i,k) vertical slab
    REAL(KIND=4), DIMENSION (:,:),   ALLOCATABLE :: zwk                     !
    REAL(KIND=4), DIMENSION (:),     ALLOCATABLE :: gdept                   ! deptht
    REAL(KIND=4)            :: zmin, zmax, zbot, zalpha, rho
    REAL(KIND=4)            :: zpi, f, zval

    CHARACTER(LEN=1), DIMENSION (3)  :: cvarname
    !!----------------------------------------------------------------------
    npk    = getdim (cf_vfil,cn_z)
    PRINT*, 'cf_vfil = ', TRIM(cf_vfil)
    PRINT*, 'cf_tfil = ', TRIM(cf_tfil)
    PRINT*, 'cf_sfil = ', TRIM(cf_sfil)
    PRINT*, 'cf_ufil = ', TRIM(cf_ufil)
    npt    = getdim (cf_vfil,cn_t)
    ! 1) look for integer indices corresponding to the section characteristics
    CALL cdf_findij ( rp_lonw_rapid,  rp_lone_rapid, rp_lat_rapid, rp_lat_rapid, &
         &              iiw          ,  iie          , ijrapid,      idum   ,      &
         &              cd_coord=cn_fhgr, cd_point='F')
    CALL cdf_findij ( rp_lonw_rapid,  rp_lon_gs,     rp_lat_rapid, rp_lat_rapid, &
         &              idum         ,  iigs         , idum,         idum,         &
         &              cd_coord=cn_fhgr, cd_point='F')

  IF ( lg_vvl) THEN
     cn_fe3v = cf_vfil
     cn_ve3v = cn_ve3vvvl
  ENDIF

    ! ORCA2 fails to cdf_findij ( Med sea ... )
    !   iiw     = 99
    !   iie     = 138
    !   iigs    = 103
    !   ijrapid = 98

    npiglo =  iie -iiw+1 ! size of the rapid section
    npigs  =  iigs-iiw+1 ! size of the rapid section
    !  1.1 ) read vertical slabs corresponding to ijrapid
    ALLOCATE ( vrapid(npiglo , npk), e3vrapid(npiglo, npk) , var2d(npiglo , npk))
    ALLOCATE ( trapid(npiglo , npk), srapid(npiglo, npk) )
    ALLOCATE ( itmaskrapid(npiglo , npk) )
    ALLOCATE ( gdept(npk) )
    ALLOCATE ( zwk(npiglo, 1), de1rapid(npiglo), dmv(npiglo), dmt(npiglo), dtaux(npiglo,1) )
    ALLOCATE ( damocrapid(1,1,npk), gdepw(npk), e31d(npk)  )
    ALLOCATE ( dtrp(1,1,1) )
    ALLOCATE ( rdumlon(1,1), rdumlat(1,1), dtim(npt) )

    zwk(:,:)     = getvar (cn_fhgr, cn_gphiv, 1, npiglo, 1, kimin=iiw,kjmin=ijrapid )
    rdumlon(:,:) = 0.0
    rdumlat(:,:) = zwk(1,1)

    IF ( lfull ) e31d(:)  = getvare3(cn_fzgr, cn_ve3t1d, npk )

    zwk(:,:)   = getvar (cn_fhgr, cn_ve1v, 1, npiglo, 1, kimin=iiw,kjmin=ijrapid )
    de1rapid(:) = zwk(:,1)
    gdepw(:)   = getvare3(cn_fzgr, cn_gdepw, npk             )
    DO jk = 1, npk
       zwk(:,:) = getvar(cn_fmsk, cn_tmask, jk, npiglo, 1, kimin=iiw,kjmin=ijrapid )
       itmaskrapid(:,jk) = zwk(:,1)
    ENDDO
    gdept(:) = getvare3(cn_fzgr, cn_gdept, npk             )

    CALL CreateOutputRapid

    DO jt = 1, npt
       IF ( lg_vvl ) THEN ; it=jt
       ELSE               ; it=1
       ENDIF

       IF ( it == jt ) THEN ! read each time only for vvl
          DO jk = 1, npk
             IF ( lfull ) THEN
                e3vrapid(:,jk) = e31d(jk)
             ELSE
                zwk(:,:) = getvar(cn_fe3v, cn_ve3v,jk,npiglo,1,kimin=iiw,kjmin=ijrapid, ktime=it, ldiom=.NOT.lg_vvl )
                WHERE (zwk(:,1) == 0.d0 ) zwk(:,1)=0.1 ! arbitrary to avoid /O
                e3vrapid(:,jk) = zwk(:,1)
             ENDIF
          ENDDO
       ENDIF
       ! Get variables V,dtaux,T,S
       DO jk = 1 , npk
          zwk(:,:) = getvar(cf_vfil,cn_vomecrty,jk,npiglo,1,kimin=iiw,kjmin=ijrapid, ktime = jt )
          vrapid(:,jk) = zwk(:,1)
       ENDDO
       dtaux(:,:) =  getvar(cf_ufil,cn_sozotaux,1, npiglo,1,kimin=iiw,kjmin=ijrapid, ktime = jt )
       DO jk = 1 , npk
          zwk(:,:) = getvar(cf_tfil,cn_votemper,jk,npiglo,1,kimin=iiw,kjmin=ijrapid, ktime = jt )
          trapid(:,jk) = zwk(:,1)
       ENDDO
       DO jk = 1 , npk
          zwk(:,:) = getvar(cf_sfil,cn_vosaline,jk,npiglo,1,kimin=iiw,kjmin=ijrapid, ktime = jt )
          srapid(:,jk) = zwk(:,1)
       ENDDO
       ! mask missing values:
       vrapid(:,:) = vrapid(:,:) * itmaskrapid(:,:)    ! vmask = tmask here
       dtaux(:,1)  = dtaux (:,1) * itmaskrapid(:,1)    !    APPROXIMATIF !!
       trapid(:,:) = trapid(:,:) * itmaskrapid(:,:)    ! 
       srapid(:,:) = srapid(:,:) * itmaskrapid(:,:)    ! 
       PRINT*, 'max vrapid  ',MAXVAL(vrapid)
       PRINT*, 'max trapid  ',MAXVAL(trapid)
       PRINT*, 'max srapid  ',MAXVAL(srapid)
       PRINT*, 'max dtaux   ',MAXVAL(ABS(dtaux))

       ! 2) compute the amoc at 26.5 N, traditional way ( from top to bottom as in MOCHA)
       damocrapid(:,:,1) = 0.d0
       dtrp(:,:,1) = 0.d0
       ierr = putvar (ncout, id_varout(1), REAL(dtrp(:,:,1)/1.d6), 1, 1, 1, ktime=jt)
       DO jk = 2, npk
          damocrapid(1,1,jk) = damocrapid(1,1,jk-1)
          DO ji = 1, npiglo   ! remember : this is a local index
             damocrapid(1,1,jk) = damocrapid(1,1,jk) + vrapid(ji,jk-1) * de1rapid(ji) * e3vrapid(ji,jk-1)*1.d0
          ENDDO
          dtrp(:,:,1) = damocrapid(:,:,jk)
          ierr = putvar (ncout, id_varout(1), REAL(dtrp(:,:,1)/1.d6), jk, 1, 1, ktime=jt)
       ENDDO
       ! 2.1) Total maximum AMOC (Q1)
       dtrp(1,1,1) = MAXVAL(damocrapid(:,:,:))
       ierr = putvar (ncout, id_varout(8), REAL(dtrp(:,:,1)/1.d6) , 1, 1, 1, ktime=jt)
       PRINT *, 'JT = ', jt ,' Total maximum AMOC = ', REAL(dtrp(:,:,1)/1.d6)

       ! 3) compute the Gulf-stream transport (western most part of the section)
       dtrp(:,:,:) = 0.d0
       DO ji = 1, npigs
          DO jk = 1, npk
             dtrp(1,1,1) = dtrp(1,1,1) + vrapid(ji,jk) * de1rapid(ji) * e3vrapid(ji,jk)*1.d0
          ENDDO
       ENDDO
       ierr = putvar (ncout, id_varout(2), REAL(dtrp(:,:,1)/1.d6), 1, 1, 1, ktime=jt)
       PRINT *, 'JT = ', jt ,' GS = ', dtrp(:,:,1)/1.d6,' Sv'

       ! 4) compute the contributions of the eastern part of the section, sorted by depth range
       DO jclass = 1, jp_class
          zmin = rp_zlim(jclass   )
          zmax = rp_zlim(jclass+1 )
          dtrp(:,:,:) = 0.d0
          DO ji = npigs+1 , npiglo
             DO jk = 1, npk
                ! use Nicolas Ferry code ( can be improved )
                zbot =  gdepw(jk) + e3vrapid(ji,jk) 
                IF ( gdepw(jk) >= zmin .AND.  zbot <= zmax ) zalpha=1.0
                IF ( gdepw(jk) >= zmax .OR.  zbot <= zmin ) zalpha=0.0
                IF ( gdepw(jk) <= zmin .AND.  zbot >= zmin ) &
                     &  zalpha = ( zbot - zmin     ) / e3vrapid ( ji,jk) 
                IF ( gdepw(jk) <= zmax .AND.  zbot >= zmax ) &
                     &  zalpha = ( zmax - gdepw(jk)) / e3vrapid ( ji,jk) 
                dtrp(1,1,1) = dtrp(1,1,1) + vrapid(ji,jk) * de1rapid(ji) * e3vrapid(ji,jk)*1.d0 * zalpha
             ENDDO
          ENDDO

          ierr = putvar (ncout, id_varout(jclass+2), REAL(dtrp(:,:,1)/1.d6), 1, 1, 1, ktime=jt)
          PRINT *, 'JT = ', jt ,' trp_class:', zmin, zmax, dtrp(:,:,1)/1.d6,' Sv'
       END DO

       ! 5) compute the Total Ekman transport (#3)
       dtrp(:,:,:) = 0.d0
       rho = 1020
       zpi = 4.*ATAN(1.)
       f = 2.* 2.*zpi/86400.*SIN(rp_lat_rapid*zpi/180.)
       DO ji = 1, npiglo
          dtrp(1,1,1) = dtrp(1,1,1) - dtaux(ji,1) * de1rapid(ji) / (rho*f) *1.d0
       ENDDO
       dtrek = dtrp(1,1,1)/1.d6  ! for future use
       ierr = putvar (ncout, id_varout(9), REAL(dtrp(:,:,1)/1.d6), 1, 1, 1, ktime=jt)
       PRINT *, 'JT = ', jt ,' Total Ekman transport = ', dtrp(:,:,1)/1.d6,' Sv'

       ! 6) compute the Total transport (Florida to Africa)  (#4)
       dtrp(:,:,:) = 0.d0
       DO ji = 1, npiglo
          DO jk = 1, npk
             dtrp(1,1,1) = dtrp(1,1,1) + vrapid(ji,jk) * de1rapid(ji) * e3vrapid(ji,jk)*1.d0
          ENDDO
       ENDDO
       ierr = putvar (ncout, id_varout(10), REAL(dtrp(:,:,1)/1.d6), 1, 1, 1, ktime=jt)
       PRINT *, 'JT = ', jt ,' Total Transport = ', dtrp(:,:,1)/1.d6,' Sv'

       ! 7) Florida, MidOcean and Total  section , area mean V, T, S (#5)
       cvarname = (/ 'V', 'T', 'S' /)
       DO jv = 1,3
          IF ( jv == 1 ) var2d(:,:) = vrapid(:,:)  ! V
          IF ( jv == 2 ) var2d(:,:) = trapid(:,:)  ! T
          IF ( jv == 3 ) var2d(:,:) = srapid(:,:)  ! S
          ! Total
          idvar=11+(jv-1)*3
          ds = 0. ; dtrp(1,1,1) = 0.d0
          DO ji = 1, npiglo
             DO jk = 1, npk
                ds0 = de1rapid(ji) * e3vrapid(ji,jk)*itmaskrapid(ji,jk)*1.d0
                ds = ds + ds0
                dtrp(1,1,1) = dtrp(1,1,1) + var2d(ji,jk) * ds0 *1.d0
             ENDDO
          ENDDO
          ierr = putvar (ncout, id_varout(idvar), REAL(dtrp(:,:,1)/ds*1.d0), 1, 1, 1, ktime=jt)
          PRINT *, TRIM(stypvar(idvar)%cname),' :'
          PRINT *, 'JT = ', jt ,' Mean '//cvarname(jv)//' Total section = ', dtrp(:,:,1)/ds,' u.S.I'
          ! Florida Straight
          idvar=11+(jv-1)*3+1
          ds = 0. ; dtrp(1,1,1) = 0.d0
          DO ji = 1, npigs
             DO jk = 1, npk
                ds0 = de1rapid(ji) * e3vrapid(ji,jk)*itmaskrapid(ji,jk)*1.d0
                ds = ds + ds0
                dtrp(1,1,1) = dtrp(1,1,1) + var2d(ji,jk) * ds0 *1.d0
             ENDDO
          ENDDO
          ierr = putvar (ncout, id_varout(idvar), REAL(dtrp(:,:,1)/ds*1.d0), 1, 1, 1, ktime=jt)
          PRINT *, TRIM(stypvar(idvar)%cname),' :'
          PRINT *, 'JT = ', jt ,' Mean '//cvarname(jv)//' Florida section = ', dtrp(:,:,1)/ds,' u.S.I'
          ! MidOcean
          idvar=11+(jv-1)*3+2
          ds = 0. ; dtrp(1,1,1) = 0.d0
          DO ji = npigs+1, npiglo
             DO jk = 1, npk
                ds0 = de1rapid(ji) * e3vrapid(ji,jk)*itmaskrapid(ji,jk)*1.d0
                ds = ds + ds0
                dtrp(1,1,1) = dtrp(1,1,1) + var2d(ji,jk) * ds0 *1.d0
             ENDDO
          ENDDO
          ierr = putvar (ncout, id_varout(idvar), REAL(dtrp(:,:,1)/ds*1.d0), 1, 1, 1, ktime=jt)
          PRINT *, TRIM(stypvar(idvar)%cname),' :'
          PRINT *, 'JT = ', jt ,' Mean '//cvarname(jv)//' MidOcean section = ', dtrp(:,:,1)/ds,' u.S.I'
       ENDDO ! jv 

       ! 8) compute MidOcean mean V x mean T  (#6)
       ! Compute zonal mean v(z) profile (East of Bahamas)
       ! Compute zonal mean T(z) profile (East of Bahamas)
       ! Compute vertical integral of v(z)*T(z) to get Sv x deg C
       cvarname = (/ 'T', 'S', ' ' /)
       DO jv = 1,2
          IF ( jv == 1 ) var2d(:,:) = trapid(:,:)  ! T
          IF ( jv == 2 ) var2d(:,:) = srapid(:,:)  ! S
          dmv(:) = 0.d0
          dmt(:) = 0.d0
          DO jk = 1, npk
             ds = 0.
             DO ji = npigs+1, npiglo
                dmv(jk) = dmv(jk) + vrapid(ji,jk) * de1rapid(ji) *1.d0
                dmt(jk) = dmt(jk) + var2d (ji,jk) * de1rapid(ji) *1.d0
                ds = ds + de1rapid(ji) * itmaskrapid(ji,jk) *1.d0
             ENDDO
             IF ( ds /= 0. ) dmv(jk) = dmv(jk) / ds  
             IF ( ds /= 0. ) dmt(jk) = dmt(jk) / ds
          ENDDO
          ! vertical integral of dmv(jk)*dmt(jk) 
          dtrp(1,1,1) = 0.d0
          DO jk = 1, npk
             DO ji = npigs+1, npiglo
                dtrp(1,1,1) = dtrp(1,1,1) + dmv(jk) * dmt(jk) * de1rapid(ji) * e3vrapid(ji,jk)*1.d0
             ENDDO
          ENDDO
          ierr = putvar (ncout, id_varout(20-1+jv), REAL(dtrp(:,:,1)/1.d6), 1, 1, 1, ktime=jt)
          PRINT *, TRIM(stypvar(idvar)%cname),' :'
          PRINT *, 'JT = ', jt ,' Total  Transport of mean V x mean '//cvarname(jv)//'= ', & 
               dtrp(:,:,1)/1.d6,' Sv.uSI'
       ENDDO

       ! 8) T / S Transports      
       cvarname = (/ 'T', 'S', ' ' /)
       ndiag = 5
       DO jv = 1,2
          ! compute Total/Florida/MidOcean transport based on V and T/S at each grid point
          IF ( jv == 1 ) var2d(:,:) = trapid(:,:)  ! T
          IF ( jv == 2 ) var2d(:,:) = srapid(:,:)  ! S
          ! # 7.1 Total
          dtrp(:,:,:) = 0.d0
          idvar=22+(jv-1)*ndiag
          DO ji = 1, npiglo
             DO jk = 1, npk
                !computation done at T points, fields already masked:
                dtrp(1,1,1) = dtrp(1,1,1) + vrapid(ji,jk) * var2d(ji,jk) * de1rapid(ji) * e3vrapid(ji,jk)*1.d0
             ENDDO
          ENDDO
          ierr = putvar (ncout, id_varout(idvar), REAL(dtrp(:,:,1)/1.d6), 1, 1, 1, ktime=jt)
          PRINT *, TRIM(stypvar(idvar)%cname),' :'
          PRINT *, 'JT = ', jt ,' Total '//cvarname(jv)//' Transport = ', dtrp(:,:,1)/1.d6,' u.S.I'
          ! # 7.2 Florida
          dtrp(:,:,:) = 0.d0
          idvar=23+(jv-1)*ndiag
          DO ji = 1, npigs
             DO jk = 1, npk
                dtrp(1,1,1) = dtrp(1,1,1) + vrapid(ji,jk) * var2d(ji,jk) * de1rapid(ji) * e3vrapid(ji,jk)*1.d0
             ENDDO
          ENDDO
          ierr = putvar (ncout, id_varout(idvar), REAL(dtrp(:,:,1)/1.d6), 1, 1, 1, ktime=jt)
          PRINT *, TRIM(stypvar(idvar)%cname),' :'
          PRINT *, 'JT = ', jt ,' Florida '//cvarname(jv)//' Transport = ', dtrp(:,:,1)/1.d6,' u.S.I'
          ! # 7.3 MidOcean
          dtrp(:,:,:) = 0.d0
          idvar=24+(jv-1)*ndiag 
          DO ji = npigs+1, npiglo
             DO jk = 1, npk
                dtrp(1,1,1) = dtrp(1,1,1) + vrapid(ji,jk) * var2d(ji,jk) * de1rapid(ji) * e3vrapid(ji,jk)*1.d0
             ENDDO
          ENDDO
          ierr = putvar (ncout, id_varout(idvar), REAL(dtrp(:,:,1)/1.d6), 1, 1, 1, ktime=jt)
          PRINT *, TRIM(stypvar(idvar)%cname),' :'
          PRINT *, 'JT = ', jt ,' MidOcean '//cvarname(jv)//' Transport = ', dtrp(:,:,1)/1.d6,' u.S.I'
          ! # 8.1 Ekman T/S transport based on SST/SSS
          dtrp(:,:,:) = 0.d0
          idvar=25+(jv-1)*ndiag
          ds = 0.d0
          jk = 1
          DO ji = 1, npiglo
             dtrp(1,1,1) = dtrp(1,1,1) + var2d(ji,jk) * de1rapid(ji) * e3vrapid(ji,jk)*1.d0
             ds = ds + de1rapid(ji) * e3vrapid(ji,jk)*itmaskrapid(ji,jk)*1.d0
          ENDDO
          ierr = putvar (ncout, id_varout(idvar), REAL(dtrek*dtrp(:,:,1)/ds), 1, 1, 1, ktime=jt)
          PRINT *, TRIM(stypvar(idvar)%cname),' :'
          PRINT *, 'JT = ', jt ,' Ekman '//cvarname(jv)//' Transport based on SST/S = ', dtrek*dtrp(:,:,1)/ds,' u.S.I'
          ! # 8.2 Ekman T/S transport based on T100/Syy100
          dtrp(:,:,:) = 0.d0
          idvar=26+(jv-1)*ndiag
          ds = 0.d0 ; jk100 = 0
          DO jk = npk,1,-1
             IF ( gdept(jk) >= 100. ) jk100 = jk  ! to determine 100m depth index
          ENDDO
          PRINT *, gdept(jk100) ,' ~= 100 m for index jk = ',jk100
          DO ji = 1, npiglo
             DO jk = 1, jk100
                dtrp(1,1,1) = dtrp(1,1,1) + var2d(ji,jk) * de1rapid(ji) * e3vrapid(ji,jk)*1.d0
                ds = ds + de1rapid(ji) * e3vrapid(ji,jk)*itmaskrapid(ji,jk)* 1.d0
             ENDDO
          ENDDO
          ierr = putvar (ncout, id_varout(idvar), REAL(dtrek*dtrp(:,:,1)/ds), 1, 1, 1, ktime=jt)
          PRINT *, TRIM(stypvar(idvar)%cname),' :'
          PRINT *, 'JT = ', jt ,' Total Ekman '//cvarname(jv)//' Transport based on T/S100= ', dtrek*dtrp(:,:,1)/ds,' u.S.I'

       ENDDO ! jv

       ! # 9 meanV x meanT Transport
       dtrp(:,:,:) = 0.d0
       idvar=32
       ds = 0.d0 ; dmv0 = 0.d0 ; dmt0 = 0.d0 ; dms0 = 0.d0
       DO ji = 1, npiglo
          DO jk = 1, jk100
             ds0 = de1rapid(ji) * e3vrapid(ji,jk)*itmaskrapid(ji,jk)*1.d0
             ds = ds + ds0
             dmv0 = dmv0 + vrapid(ji,jk)*ds0*1.d0
             dmt0 = dmt0 + trapid(ji,jk)*ds0*1.d0
             dms0 = dms0 + srapid(ji,jk)*ds0*1.d0
          ENDDO
       ENDDO
       dtrp(1,1,1) = dmv0 * dmt0 / ds *1.d0
       ierr = putvar (ncout, id_varout(idvar), REAL(dtrp(:,:,1)/1.d6), 1, 1, 1, ktime=jt)
       PRINT *, TRIM(stypvar(idvar)%cname),' :'
       PRINT *, 'JT = ', jt ,' Total throughflow temperature transport = ', REAL(dtrp(1,1,1)/1.d6),' Sv.deg C.'
       dtrp(1,1,1) = dmv0 * dms0 / ds *1.d0
       idvar=33
       ierr = putvar (ncout, id_varout(idvar), REAL(dtrp(:,:,1)/1.d6), 1, 1, 1, ktime=jt)
       PRINT *, TRIM(stypvar(idvar)%cname),' :'
       PRINT *, 'JT = ', jt ,' Total throughflow salinity transport = ', REAL(dtrp(1,1,1)/1.d6),' Sv.PSU'


    END DO   ! time loop

    dtim = getvar1d( cf_vfil, cn_vtimec, npt     )
    ierr = putvar1d( ncout,   dtim,      npt, 'T')
    ierr = closeout( ncout                       )

  END SUBROUTINE rapid_amoc

  SUBROUTINE CreateOutput
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Prepare netcdf files for output 
    !!
    !! ** Method  :  use global module variables 
    !!
    !!----------------------------------------------------------------------
    INTEGER(KIND=4) :: ii   ! variable counter
    !!----------------------------------------------------------------------
    ! define new variables for output 
    !    all variables
    stypvar%cunits            = 'Sverdrup'
    stypvar%rmissing_value    = 99999.
    stypvar%valid_min         = -1000.
    stypvar%valid_max         =  1000.
    stypvar%scale_factor      = 1.
    stypvar%add_offset        = 0.
    stypvar%savelog10         = 0.
    stypvar%conline_operation = 'N/A'
    stypvar%caxis             = 'TZY'
    ipk(:) = npk  ! All variables are vertical slices 1 x npjglo x npk

    ii=1 ; ibasin=1
    PRINT *, 'Variable ',ii,' is zomsfglo'
    npglo=ibasin  ; ibasin = ibasin + 1 
    stypvar(ii)%cname          = TRIM(cn_zomsfglo)
    stypvar(ii)%clong_name     = 'Meridional_Overt.Cell_Global'
    stypvar(ii)%cshort_name    = TRIM(cn_zomsfglo)
    ii=ii+1

    IF ( ldec ) THEN
       PRINT *, 'Variable ',ii,' is zomsfglo_sh'
       stypvar(ii)%cname       = TRIM(cn_zomsfglo)//'_sh'
       stypvar(ii)%clong_name  = 'GeoShear_Merid_StreamFunction'
       stypvar(ii)%cshort_name = TRIM(cn_zomsfglo)//'_sh'
       ii= ii+1
       PRINT *, 'Variable ',ii,' is zomsfglo_bt'
       stypvar(ii)%cname       = TRIM(cn_zomsfglo)//'_bt'
       stypvar(ii)%clong_name  = 'Barotropic_Merid_StreamFunction'
       stypvar(ii)%cshort_name = TRIM(cn_zomsfglo)//'_bt'
       ii= ii+1
       PRINT *, 'Variable ',ii,' is zomsfglo_ag'
       stypvar(ii)%cname       = TRIM(cn_zomsfglo)//'_ag'
       stypvar(ii)%clong_name  = 'Ageostoph_Merid_StreamFunction'
       stypvar(ii)%cshort_name = TRIM(cn_zomsfglo)//'_ag'
       ii= ii+1
    ENDIF

    IF (lbas) THEN
       npatl=ibasin  ; ibasin = ibasin + 1
       PRINT *, 'Variable ',ii,' is zomsfatl'
       stypvar(ii)%cname       = TRIM(cn_zomsfatl)
       stypvar(ii)%clong_name  = 'Meridional_Overt.Cell_Atlantic'
       stypvar(ii)%cshort_name = TRIM(cn_zomsfatl)
       ii= ii+1
       IF ( ldec ) THEN 
          PRINT *, 'Variable ',ii,' is zomsfatl_sh'
          stypvar(ii)%cname       = TRIM(cn_zomsfatl)//'_sh'
          stypvar(ii)%clong_name  = 'GeoShear_Merid_StreamFunction_Atlantic'
          stypvar(ii)%cshort_name = TRIM(cn_zomsfatl)//'_sh'
          ii= ii+1
          PRINT *, 'Variable ',ii,' is zomsfatl_bt'
          stypvar(ii)%cname       = TRIM(cn_zomsfatl)//'_bt'
          stypvar(ii)%clong_name  = 'Barotropic_Merid_StreamFunction_Atlantic'
          stypvar(ii)%cshort_name = TRIM(cn_zomsfatl)//'_bt'
          ii= ii+1
          PRINT *, 'Variable ',ii,' is zomsfatl_ag'
          stypvar(ii)%cname       = TRIM(cn_zomsfatl)//'_ag'
          stypvar(ii)%clong_name  = 'Ageostroph_Merid_StreamFunction_Atlantic'
          stypvar(ii)%cshort_name = TRIM(cn_zomsfatl)//'_ag'
          ii= ii+1
       ENDIF

       npinp=ibasin  ; ibasin = ibasin + 1
       PRINT *, 'Variable ',ii,' is zomsfinp'
       stypvar(ii)%cname       = TRIM(cn_zomsfinp)
       stypvar(ii)%clong_name  = 'Meridional_Overt.Cell_IndoPacif'
       stypvar(ii)%cshort_name = TRIM(cn_zomsfinp)
       ii= ii+1

       IF ( ldec ) THEN
          PRINT *, 'Variable ',ii,' is zomsfinp_sh'
          stypvar(ii)%cname       = TRIM(cn_zomsfinp)//'_sh'
          stypvar(ii)%clong_name  = 'GeoShear_Merid_StreamFunction_IndoPacif'
          stypvar(ii)%cshort_name = TRIM(cn_zomsfinp)//'_sh'
          ii= ii+1
          PRINT *, 'Variable ',ii,' is zomsfinp_bt'
          stypvar(ii)%cname       = TRIM(cn_zomsfinp)//'_bt'
          stypvar(ii)%clong_name  = 'Barotropic_Merid_StreamFunction_IndoPacif'
          stypvar(ii)%cshort_name = TRIM(cn_zomsfinp)//'_bt'
          ii= ii+1
          PRINT *, 'Variable ',ii,' is zomsfinp_ag'
          stypvar(ii)%cname       = TRIM(cn_zomsfinp)//'_ag'
          stypvar(ii)%clong_name  = 'Ageostroph_Merid_StreamFunction_IndoPacif'
          stypvar(ii)%cshort_name = TRIM(cn_zomsfinp)//'_ag'
          ii= ii+1
       ENDIF

       npind=ibasin  ; ibasin = ibasin + 1
       PRINT *, 'Variable ',ii,' is zomsfind'
       stypvar(ii)%cname       = TRIM(cn_zomsfind)
       stypvar(ii)%clong_name  = 'Meridional_Overt.Cell_Indian'
       stypvar(ii)%cshort_name = TRIM(cn_zomsfind)
       ii= ii+1

       IF ( ldec ) THEN
          PRINT *, 'Variable ',ii,' is zomsfind_sh'
          stypvar(ii)%cname       = TRIM(cn_zomsfind)//'_sh'
          stypvar(ii)%clong_name  = 'GeoShear_Merid_StreamFunction_Indian'
          stypvar(ii)%cshort_name = TRIM(cn_zomsfind)//'_sh'
          ii= ii+1
          PRINT *, 'Variable ',ii,' is zomsfind_bt'
          stypvar(ii)%cname       = TRIM(cn_zomsfind)//'_bt'
          stypvar(ii)%clong_name  = 'Barotropic_Merid_StreamFunction_Indian'
          stypvar(ii)%cshort_name = TRIM(cn_zomsfind)//'_bt'
          ii= ii+1
          PRINT *, 'Variable ',ii,' is zomsfind_ag'
          stypvar(ii)%cname       = TRIM(cn_zomsfind)//'_ag'
          stypvar(ii)%clong_name  = 'Ageostroph_Merid_StreamFunction_Indian'
          stypvar(ii)%cshort_name = TRIM(cn_zomsfind)//'_ag'
          ii= ii+1
       ENDIF

       nppac=ibasin  ; ibasin = ibasin + 1
       PRINT *, 'Variable ',ii,' is zomsfpac'
       stypvar(ii)%cname       = TRIM(cn_zomsfpac)
       stypvar(ii)%clong_name  = 'Meridional_Overt.Cell_pacif'
       stypvar(ii)%cshort_name = TRIM(cn_zomsfpac)
       ii= ii+1

       IF ( ldec ) THEN
          PRINT *, 'Variable ',ii,' is zomsfpac_sh'
          stypvar(ii)%cname       = TRIM(cn_zomsfpac)//'_sh'
          stypvar(ii)%clong_name  = 'GeoShear_Merid_StreamFunction_Pacif'
          stypvar(ii)%cshort_name = TRIM(cn_zomsfpac)//'_sh'
          ii= ii+1
          PRINT *, 'Variable ',ii,' is zomsfpac_bt'
          stypvar(ii)%cname       = TRIM(cn_zomsfpac)//'_bt'
          stypvar(ii)%clong_name  = 'Barotropic_Merid_StreamFunction_Pacif'
          stypvar(ii)%cshort_name = TRIM(cn_zomsfpac)//'_bt'
          ii= ii+1
          PRINT *, 'Variable ',ii,' is zomsfpac_ag'
          stypvar(ii)%cname       = TRIM(cn_zomsfpac)//'_ag'
          stypvar(ii)%clong_name  = 'Ageostroph_Merid_StreamFunction_Pacif'
          stypvar(ii)%cshort_name = TRIM(cn_zomsfpac)//'_ag'
          ii=ii+1
       ENDIF

       npinp0=ibasin  ; ibasin = ibasin + 1
       PRINT *, 'Variable ',ii,' is zomsfinp0'
       stypvar(ii)%cname       = TRIM(cn_zomsfinp0)
       stypvar(ii)%clong_name  = 'Meridional_Overt.Cell_IndPac0'
       stypvar(ii)%cshort_name = TRIM(cn_zomsfinp0)
       ii= ii+1

       IF ( ldec ) THEN
          PRINT *, 'Variable ',ii,' is zomsfinp0_sh'
          stypvar(ii)%cname       = TRIM(cn_zomsfinp0)//'_sh'
          stypvar(ii)%clong_name  = 'GeoShear_Merid_StreamFunction_IndPac0'
          stypvar(ii)%cshort_name = TRIM(cn_zomsfinp0)//'_sh'
          ii= ii+1
          PRINT *, 'Variable ',ii,' is zomsfinp0_bt'
          stypvar(ii)%cname       = TRIM(cn_zomsfinp0)//'_bt'
          stypvar(ii)%clong_name  = 'Barotropic_Merid_StreamFunction_IndPac0'
          stypvar(ii)%cshort_name = TRIM(cn_zomsfinp0)//'_bt'
          ii= ii+1
          PRINT *, 'Variable ',ii,' is zomsfinp0_ag'
          stypvar(ii)%cname       = TRIM(cn_zomsfinp0)//'_ag'
          stypvar(ii)%clong_name  = 'Ageostroph_Merid_StreamFunction_IndPac0'
          stypvar(ii)%cshort_name = TRIM(cn_zomsfinp0)//'_ag'
       ENDIF
    ENDIF

    ! create output fileset
    ncout = create      ( cf_moc,  'none',    1, npjglo, npk, cdep=cn_vdepthw )
    ierr  = createvar   ( ncout,   stypvar,   nvarout,   ipk, id_varout, cdglobal=TRIM(cglobal)           )
    ierr  = putheadervar( ncout,   cf_vfil,   1, npjglo, npk, pnavlon=rdumlon, pnavlat=rdumlat, pdep=gdepw)
    dtim  = getvar1d    ( cf_vfil, cn_vtimec, npt                    )
    ierr  = putvar1d    ( ncout,  dtim,       npt, 'T')

  END SUBROUTINE CreateOutput

  SUBROUTINE CreateOutputRapid
    !!---------------------------------------------------------------------
    !!                  ***  ROUTINE CreateOutput  ***
    !!
    !! ** Purpose :  Create netcdf output file(s) 
    !!
    !! ** Method  :  Use stypvar global description of variables
    !!
    !!----------------------------------------------------------------------
    INTEGER(KIND=4) :: idvar   ! working integer for ncdf variables
    ! prepare output dataset: 7 variables
    ! add 12 new variables for CLIVAR GSOP-GODAE intercomparison
    cf_moc = 'rapid_'//TRIM(cf_moc)
    nvarout =  33
    ALLOCATE ( stypvar(nvarout), ipk(nvarout), id_varout(nvarout) )
    stypvar%cunits            = 'Sverdrup'
    stypvar%rmissing_value    = 99999.
    stypvar%valid_min         = -1000.
    stypvar%valid_max         =  1000.
    stypvar%scale_factor      = 1.
    stypvar%add_offset        = 0.
    stypvar%savelog10         = 0.
    stypvar%conline_operation = 'N/A'

    stypvar%caxis             = 'T'
    ipk(:) = 1  ! only amoc_rapid has ipk=npk
    ! overturning classical way
    stypvar(1)%cname          = 'amoc_rapid'
    stypvar(1)%clong_name     = 'Rapid Overturning '
    stypvar(1)%cshort_name    = 'amoc_rapid'
    ipk(1)                    = npk

    stypvar(2)%cname          = 'tr_GS'
    stypvar(2)%clong_name     = 'Gulf Stream Contribution (Q2)'
    stypvar(2)%cshort_name    = 'tr_GS'

    stypvar(3)%cname          = 'tr_THERM'
    stypvar(3)%clong_name     = 'Overturning contrib of Thermocline waters'
    stypvar(3)%cshort_name    = 'tr_THERM'

    stypvar(4)%cname          = 'tr_AIW'
    stypvar(4)%clong_name     = 'Overturning contrib of intermediate waters'
    stypvar(4)%cshort_name    = 'tr_AIW'

    stypvar(5)%cname          = 'tr_UNADW'
    stypvar(5)%clong_name     = 'Overturning contrib of Upper NADW '
    stypvar(5)%cshort_name    = 'tr_UNADW'

    stypvar(6)%cname          = 'tr_LNADW'
    stypvar(6)%clong_name     = 'Overturning contrib of Lower NADW '
    stypvar(6)%cshort_name    = 'tr_LNADW'

    stypvar(7)%cname          = 'tr_BW'
    stypvar(7)%clong_name     = 'Overturning contrib of Bottom Waters'
    stypvar(7)%cshort_name    = 'tr_BW'

    ! additional new variables:
    !   # 1 in Keith Haines document
    stypvar(8)%cname          = 'Total_max_amoc_rapid'
    stypvar(8)%clong_name     = 'Total Max Rapid Overturning (Q1)'
    stypvar(8)%cshort_name    = 'Total_max_amoc_rapid'
    !   # 2 is tr_GS: see stypvar(2)  (Q2)

    !   # 3 in Keith Haines document
    stypvar(9)%cname          = 'tr_EKMAN'
    stypvar(9)%clong_name     = 'Total Ekman transport (Q3)'
    stypvar(9)%cshort_name    = 'tr_EKMAN'
    !   # 4 in Keith Haines document
    stypvar(10)%cname          = 'tr_TOTAL'
    stypvar(10)%clong_name     = 'Total transport at 26.5N (Q4)'
    stypvar(10)%cshort_name    = 'tr_TOTAL'
    !   # 5.1 in Keith Haines document
    !  Total section  V
    idvar = 11
    stypvar(idvar)%cunits         = 'm.s**-1'
    stypvar(idvar)%cname          = 'mean_v_total_section'
    stypvar(idvar)%clong_name     = 'Total section mean meridional velocity at 26.5N (Q5)'
    stypvar(idvar)%cshort_name    = 'mean_V_total_section'
    !  Florida section V
    idvar = 12
    stypvar(idvar)%cunits         = 'm.s**-1'
    stypvar(idvar)%cname          = 'mean_v_Florida_section'
    stypvar(idvar)%clong_name     = 'Florida section mean meridional velocity at 26.5N (Q5)'
    stypvar(idvar)%cshort_name    = 'mean_V_Florida_section'
    !  MidOcean section V
    idvar = 13
    stypvar(idvar)%cunits         = 'm.s**-1'
    stypvar(idvar)%cname          = 'mean_v_MidOcean_section'
    stypvar(idvar)%clong_name     = 'MidOcean section mean meridional velocity at 26.5N (Q5)'
    stypvar(idvar)%cshort_name    = 'mean_V_MidOcean_section'
    !  Total section  T
    idvar = 14
    stypvar(idvar)%cunits         = 'deg. Celsius'
    stypvar(idvar)%cname          = 'mean_T_total_section'
    stypvar(idvar)%clong_name     = 'Total section mean Temperature at 26.5N (Q5)'
    stypvar(idvar)%cshort_name    = 'mean_T_total_section'
    !  Florida section T
    idvar = 15
    stypvar(idvar)%cunits         = 'deg. Celsius'
    stypvar(idvar)%cname          = 'mean_T_Florida_section'
    stypvar(idvar)%clong_name     = 'Florida section mean Temperature at 26.5N (Q5)'
    stypvar(idvar)%cshort_name    = 'mean_T_Florida_section'
    !  MidOcean section T
    idvar = 16
    stypvar(idvar)%cunits         = 'deg. Celsius'
    stypvar(idvar)%cname          = 'mean_T_MidOcean_section'
    stypvar(idvar)%clong_name     = 'MidOcean section mean Temperature at 26.5N (Q5)'
    stypvar(idvar)%cshort_name    = 'mean_T_MidOcean_section'
    !  Total section  S
    idvar = 17
    stypvar(idvar)%cunits         = 'PSU'
    stypvar(idvar)%cname          = 'mean_S_total_section'
    stypvar(idvar)%clong_name     = 'Total section mean Salinity at 26.5N (Q5)'
    stypvar(idvar)%cshort_name    = 'mean_S_total_section'
    !  Florida section S
    idvar = 18
    stypvar(idvar)%cunits         = 'PSU'
    stypvar(idvar)%cname          = 'mean_S_Florida_section'
    stypvar(idvar)%clong_name     = 'Florida section mean Salinity at 26.5N (Q5)'
    stypvar(idvar)%cshort_name    = 'mean_S_Florida_section'
    !  MidOcean section S
    idvar = 19
    stypvar(idvar)%cunits         = 'PSU'
    stypvar(idvar)%cname          = 'mean_S_MidOcean_section'
    stypvar(idvar)%clong_name     = 'MidOcean  section mean Salinity at 26.5N (Q5)'
    stypvar(idvar)%cshort_name    = 'mean_S_MidOcean_section'
    !   # 6 in Keith Haines document
    idvar = 20
    stypvar(idvar)%cunits         = 'Sv*deg. Celsius'
    stypvar(idvar)%cname          = 'MO_meanVtimesmeanT'
    stypvar(idvar)%clong_name     = 'Mid Ocean mean V x mean T at 26.5N (Q6)'
    stypvar(idvar)%cshort_name    = 'MO_meanVtimesmeanT'
    !   # 6 in Keith Haines document
    idvar = 21
    stypvar(idvar)%cunits         = 'Sv*deg. Celsius'
    stypvar(idvar)%cname          = 'MO_meanVtimesmeanS'
    stypvar(idvar)%clong_name     = 'Mid Ocean mean V x mean S at 26.5N (Q6)'
    stypvar(idvar)%cshort_name    = 'MO_meanVtimesmeanS'
    !   # 7.1 in Keith Haines document
    idvar = idvar + 1
    stypvar(idvar)%cunits         = 'Sv*deg. Celsius'
    stypvar(idvar)%cname          = 'Total_temp_transport'
    stypvar(idvar)%clong_name     = 'Total temperature transport V x T at 26.5N (Q7)'
    stypvar(idvar)%cshort_name    = 'Total_temp_transport'
    !   # 7.2 in Keith Haines document
    idvar = idvar + 1
    stypvar(idvar)%cunits         = 'Sv*deg. Celsius'
    stypvar(idvar)%cname          = 'Florida_temp_transport'
    stypvar(idvar)%clong_name     = 'Florida section temperature transport V x T at 26.5N (Q7)'
    stypvar(idvar)%cshort_name    = 'Florida_temp_transport'
    !   # 7.3 in Keith Haines document
    idvar = idvar + 1
    stypvar(idvar)%cunits         = 'Sv*deg. Celsius'
    stypvar(idvar)%cname          = 'MidOcean_temp_transport'
    stypvar(idvar)%clong_name     = 'MidOcean section temperature transport V x T at 26.5N (Q7)'
    stypvar(idvar)%cshort_name    = 'MidOcean_temp_transport'
    !   # 8.1 in Keith Haines document
    idvar = idvar + 1
    stypvar(idvar)%cunits         = 'Sv*deg. Celsius'
    stypvar(idvar)%cname          = 'Ekman_temp_transport_SST'
    stypvar(idvar)%clong_name     = 'Ekman temperature transport based on SST at 26.5N (Q8.1)'
    stypvar(idvar)%cshort_name    = 'Total_temp_transport_SST'
    !   # 8.2 in Keith Haines document
    idvar = idvar + 1
    stypvar(idvar)%cunits         = 'Sv*deg. Celsius'
    stypvar(idvar)%cname          = 'Ekman_temp_transport_T100'
    stypvar(idvar)%clong_name     = 'Ekman temperature transport based on T100m at 26.5N (Q8.2)'
    stypvar(idvar)%cshort_name    = 'Total_temp_transport_T100'
    !   # 7.1 in Keith Haines document
    idvar = idvar + 1
    stypvar(idvar)%cunits         = 'Sv*PSU'
    stypvar(idvar)%cname          = 'Total_salt_transport'
    stypvar(idvar)%clong_name     = 'Total salinity transport V x S at 26.5N (Q7)'
    stypvar(idvar)%cshort_name    = 'Total_salt_transport'
    !   # 7.2 in Keith Haines document
    idvar = idvar + 1
    stypvar(idvar)%cunits         = 'Sv*PSU'
    stypvar(idvar)%cname          = 'Florida_salt_transport'
    stypvar(idvar)%clong_name     = 'Florida section salinity transport V x S at 26.5N (Q7)'
    stypvar(idvar)%cshort_name    = 'Florida_salt_transport'
    !   # 7.3 in Keith Haines document
    idvar = idvar + 1
    stypvar(idvar)%cunits         = 'Sv*PSU'
    stypvar(idvar)%cname          = 'MidOcean_salt_transport'
    stypvar(idvar)%clong_name     = 'MidOcean section salinity transport V x S at 26.5N (Q7)'
    stypvar(idvar)%cshort_name    = 'MidOcean_salt_transport'
    !   # 8.1 in Keith Haines document
    idvar = idvar + 1
    stypvar(idvar)%cunits         = 'Sv*PSU'
    stypvar(idvar)%cname          = 'Ekman_salt_transport_SSS'
    stypvar(idvar)%clong_name     = 'Ekman salinity transport based on SSS at 26.5N (Q8.1)'
    stypvar(idvar)%cshort_name    = 'Total_salt_transport_SSS'
    !   # 8.2 in Keith Haines document
    idvar = idvar + 1
    stypvar(idvar)%cunits         = 'Sv*PSU'
    stypvar(idvar)%cname          = 'Ekman_salt_transport_S100'
    stypvar(idvar)%clong_name     = 'Ekman salinity transport based on S100m at 26.5N (Q8.2)'
    stypvar(idvar)%cshort_name    = 'Total_salt_transport_S100'
    !   # 9 in Keith Haines document
    idvar = idvar + 1
    stypvar(idvar)%cunits         = 'Sv*deg. Celsius'
    stypvar(idvar)%cname          = 'Total_meanVtimesmeanT'
    stypvar(idvar)%clong_name     = 'Throughflow temperature transport = mean V x mean T 26.5N (Q9)'
    stypvar(idvar)%cshort_name    = 'Total_meanVtimesmeanT'
    !   # 9 in Keith Haines document
    idvar = idvar + 1
    stypvar(idvar)%cunits         = 'Sv*PSU'
    stypvar(idvar)%cname          = 'Total_meanVtimesmeanS'
    stypvar(idvar)%clong_name     = 'Throughflow salinity transport = mean V x mean S 26.5N (Q9)'
    stypvar(idvar)%cshort_name    = 'Total_meanVtimesmeanS'

    PRINT*, 'idvar = ', idvar

    ncout = create      ( cf_moc, 'none',  1, 1, npk, cdep=cn_vdepthw )
    ierr  = createvar   ( ncout,  stypvar, nvarout,   ipk, id_varout                              )
    ierr  = putheadervar( ncout,  cf_vfil, 1, 1, npk, pnavlon=rdumlon, pnavlat=rdumlat, pdep=gdepw)

  END SUBROUTINE CreateOutputRapid

END PROGRAM cdfmoc

#!/bin/ksh

#   $Rev$
#   $Date$
# suppose that we run this script in $CDFTOOLS/DOC
CDFTOOLS=../

grep subsection cdftools_user.tex | grep -v addcontent | grep underline | sed -e 's@\\subsection\*{\\underline{@@'  -e 's/:}}//' \
        -e 's/\\//g' | sort > list_man
here=$(pwd)
cd $CDFTOOLS
ls -1 *90 | sed -e 's/.f90//' | sort > $here/list_prog
cd $here

n=01
for f in $( cat list_prog ); do
  grep -q $f list_man
  if [ $? == 1 ] ; then
    printf "\n %02d  %s \t %s \n " $n $f 'missing in manual'
    n=$(( n + 1 ))
  fi
done
    printf "\n"

for f in $( cat list_man ); do
  grep -q $f list_prog
  if [ $? == 1 ] ; then
    printf "%s \t %s \n \n" $f 'missing in CDFTOOLS ??'
  fi
done

\rm -f list_prog list_man

#!/bin/ksh


mkdir -p MODIFIED

for file in *.?90 ; do 
cat $file | sed -e '/History/ a\
\ \ !!         :  4.0  : 03/2017  : J.M. Molines  ' -e '/CDFTOOLS_3.0/ c\
\ \ !! CDFTOOLS_4.0 , MEOM 2017 ' -e '/Copyright/ c\
\ \ !! Copyright (c) 2017, J.-M. Molines ' > MODIFIED/$file

done

#!/bin/ksh

#   $Rev$
#   $Date$
CDFTOOLS=../

grep subsection cdftools_prog.tex | grep -v addcontent | grep underline | sed -e 's@\\subsection\*{\\underline{@@'  -e 's/}}//' \
        -e 's/\\//g' | sed -e 's/^ //' |  sed -e 's/^.*F/F/' |  sed -e 's/^.*S/S/' | sort > list_man

here=$(pwd)
cd $CDFTOOLS
grep FUNCTION cdfio.f90 | grep -v END | grep -v -e '!' | sed -e 's/^.*F/F/' | sort > tttmp
grep FUNCTION eos.f90 | grep -v END | grep -v -e '!' | sed -e 's/^.*F/F/' | sort >> tttmp
grep SUBROUTINE cdfio.f90 | grep -v END | grep -v -e '!' | sed -e 's/^.*S/S/' | sort >> tttmp
grep SUBROUTINE eos.f90 | grep -v END | grep -v -e '!' | sed -e 's/^.*S/S/' | sort >> tttmp
cat tttmp | sort > $here/list_prog  ; \rm tttmp
cd $here

 cat list_prog
n=01
for f in $( cat list_prog | awk '{ print $0 }' ); do
echo $f
#  g=$( echo $f | awk '{print $2}' )
#echo $g
#  grep -q $g list_man
#  if [ $? == 1 ] ; then
#    printf "\n %02d  %s \t %s \n " $n $f 'missing in manual'
#    n=$(( n + 1 ))
#  fi
done
    printf "\n"
exit

for f in $( cat list_man ); do
  grep -q $f list_prog
  if [ $? == 1 ] ; then
    printf "%s \t %s \n \n" $f 'missing in CDFTOOLS ??'
  fi
done

\rm -f list_prog list_man

=head1  NAME

cdftools - diagnostics in Fortran 90 for NEMO model outputs

=head1 SYNOPSIS

 cdf* option...

=head1 DESCRIPTION

C<CDFTOOLS> is a diagnostic package written in fortran 90
for the analysis of NEMO model output in the frame of the DRAKKAR project.

This software is a computer program for analysis of NEMO model output 
produced in the frame of the DRAKKAR project. It is designed  for the
treatment of the NetCdf files produced by NEMO-DRAKKAR. 

C<NEMO> web site : http://www.nemo-ocean.eu/

=head1 COMMAND

=head1  NAME

CDFTOOLS - diagnostics in Fortran 90 for NEMO model outputs

=head1 PACKAGE DESCRIPTION

C<CDFTOOLS> is a diagnostic package written in fortran 90 for the analysis of NEMO model output, initialized in  the frame of the DRAKKAR project (https://www.drakkar-ocean.eu/). It is now available on GitHub under the CeCILL license (http://www.cecill.info/licences/Licence_CeCILL_V2-en.html).

C<NEMO> web site : http://www.nemo-ocean.eu/

=head1 SYNOPSIS

C<CDFTOOLS> is a collection of fortran program. Each program belonging to this collection is
designed to perform some specific actions on NEMO output files, and generally provides another netcdf file as output. Output files follow the same CDF format as NEMO file, thus allowing for the building of a secondary data base (assuming that the primary data base is just the raw model output).

This documentation is automatically produced by the concatenation of the C<USAGE> messages produced by each particular program when invoked without any argument. (Standard behaviour of all cdftools). In the documentation, we use a rather classical formalism, where mandatory arguments are just indicated on the command line and options are indicated between squared brackets [..].

Each program name starts with the 3 letters 'cdf' followed by a word related to the action performed by the tools. Example:  C<cdfw  Ufile.nc Vfile.nc > is used to compute the vertical velocity using the horizontal velocity field represented by its two components Ufile.nc and Vfile.nc.

Better than a long speech, the following paragraphs  describes each of the existing cdftools. C<CDFTOOLS>  have been sorted out by classes in order to have a consistent documentation.
